#pylint: skip-file
#pylint: disable-all
# causes too many errors and crashes

import numpy,string,sys
from numpy import random
import numpy.linalg
import exceptions
import os
import time
#import check_updates
import scipy
from scipy import array,sqrt,mean

#pylint: skip-file

#check_updates.main() # check for updates

def get_version():
    import check_updates
    version=check_updates.get_version()
    return version


def sort_diclist(undecorated,sort_on):
    decorated=[(dict_[sort_on],dict_) for dict_ in undecorated]
    decorated.sort()
    return[dict_ for (key, dict_) in decorated]


def get_dictitem(In,k,v,flag):
    """ returns a list of dictionaries from list In with key,k  = value, v . CASE INSENSITIVE # allowed keywords:"""
    try:
        if flag=="T":return [dictionary for dictionary in In if dictionary[k].lower()==v.lower()] # return that which is
        if flag=="F":
            return [dictionary for dictionary in In if dictionary[k].lower()!=v.lower()] # return that which is not
        if flag=="has":return [dictionary for dictionary in In if v.lower() in dictionary[k].lower()] # return that which is contained
        if flag=="not":return [dictionary for dictionary in In if v.lower() not in dictionary[k].lower()] # return that which is not contained
        if flag=="eval":
            A=[dictionary for dictionary in In if dictionary[k]!=''] # find records with no blank values for key
            return [dictionary for dictionary in A if float(dictionary[k])==float(v)] # return that which is
        if flag=="min":
            A=[dictionary for dictionary in In if dictionary[k]!=''] # find records with no blank values for key
            return [dictionary for dictionary in A if float(dictionary[k])>=float(v)] # return that which is greater than
        if flag=="max":
            A=[dictionary for dictionary in In if dictionary[k]!=''] # find records with no blank values for key
            return [dictionary for dictionary in A if float(dictionary[k])<=float(v)] # return that which is less than
    except Exception, err:
        return []

def get_dictkey(In,k,dtype):
    """
        returns list of given key (k)  from input list of dictionaries (In) in data type dtype.  uses command:
        get_dictkey(In,k,dtype).  If dtype =="", data are strings; if "int", data are integers; if "f", data are floats.
    """

    Out=[]
    for d in In:
        if dtype=='': Out.append(d[k])
        if dtype=='f':
            if d[k]=="":
                Out.append(0)
            else:
                Out.append(float(d[k]))
        if dtype=='int':
            if d[k]=="":
                Out.append(0)
            else:
                Out.append(int(d[k]))
    return Out

def find(f,seq):
    for item in seq:
       if f in item: return item
    return ""

def get_orient(samp_data,er_sample_name):
    # set orientation priorities
    EX=["SO-ASC","SO-POM"]
    orient={'er_sample_name':er_sample_name,'sample_azimuth':"",'sample_dip':"",'sample_description':""}
    orients=get_dictitem(samp_data,'er_sample_name',er_sample_name,'T') # get all the orientation data for this sample
    if 'sample_orientation_flag' in orients[0].keys(): orients=get_dictitem(orients,'sample_orientation_flag','b','F') # exclude all samples with bad orientation flag
    if len(orients)>0:orient=orients[0] # re-initialize to first one
    methods=get_dictitem(orients,'magic_method_codes','SO-','has')
    methods=get_dictkey(methods,'magic_method_codes','') # get a list of all orientation methods for this sample
    SO_methods=[]
    for methcode in methods:
        meths=methcode.split(":")
        for meth in meths:
           if meth.strip() not in EX:SO_methods.append(meth)
   # find top priority orientation method
    if len(SO_methods)==0:
        print "no orientation data for ",er_sample_name
        az_type="SO-NO"
    else:
        SO_priorities=set_priorities(SO_methods,0)
        az_type=SO_methods[SO_methods.index(SO_priorities[0])]
        orient=get_dictitem(orients,'magic_method_codes',az_type,'has')[0] # re-initialize to best one
    return orient,az_type


def EI(inc):
    poly_tk03= [  3.15976125e-06,  -3.52459817e-04,  -1.46641090e-02,   2.89538539e+00]
    return poly_tk03[0]*inc**3 + poly_tk03[1]*inc**2+poly_tk03[2]*inc+poly_tk03[3]


def find_f(data):
    rad=numpy.pi/180.
    Es,Is,Fs,V2s=[],[],[],[]
    ppars=doprinc(data)
    D=ppars['dec']
    Decs,Incs=data.transpose()[0],data.transpose()[1]
    Tan_Incs=numpy.tan(Incs*rad)
    for f in numpy.arange(1.,.2 ,-.01):
        U=numpy.arctan((1./f)*Tan_Incs)/rad
        fdata=numpy.array([Decs,U]).transpose()
        ppars=doprinc(fdata)
        Fs.append(f)
        Es.append(ppars["tau2"]/ppars["tau3"])
        ang = angle([D,0],[ppars["V2dec"],0])
        if 180.-ang<ang:ang=180.-ang
        V2s.append(ang)
        Is.append(abs(ppars["inc"]))
        if EI(abs(ppars["inc"]))<=Es[-1]:
            del Es[-1]
            del Is[-1]
            del Fs[-1]
            del V2s[-1]
            if len(Fs)>0:
                for f in numpy.arange(Fs[-1],.2 ,-.005):
                    U=numpy.arctan((1./f)*Tan_Incs)/rad
                    fdata=numpy.array([Decs,U]).transpose()
                    ppars=doprinc(fdata)
                    Fs.append(f)
                    Es.append(ppars["tau2"]/ppars["tau3"])
                    Is.append(abs(ppars["inc"]))
                    ang=angle([D,0],[ppars["V2dec"],0])
                    if 180.-ang<ang:ang=180.-ang
                    V2s.append(ang)
                    if EI(abs(ppars["inc"]))<=Es[-1]:
                        return Es,Is,Fs,V2s
    return [0],[0],[0],[0]


def cooling_rate(SpecRec,SampRecs,crfrac,crtype):
    CrSpecRec,frac,crmcd={},0,'DA-CR'
    for key in SpecRec.keys():CrSpecRec[key]=SpecRec[key]
    if len(SampRecs)>0:
        frac=.01*float(SampRecs[0]['cooling_rate_corr'])
        if 'DA-CR' in SampRecs[0]['cooling_rate_mcd']:
            crmcd=SampRecs[0]['cooling_rate_mcd']
        else:
            crmcd='DA-CR'
    elif crfrac!=0:
        frac=crfrac
        crmcd=crtype
    if frac!=0:
        inten=frac*float(CrSpecRec['specimen_int'])
        CrSpecRec["specimen_int"]='%9.4e '%(inten) # adjust specimen intensity by cooling rate correction
        CrSpecRec['magic_method_codes'] = CrSpecRec['magic_method_codes']+':crmcd'
        CrSpecRec["specimen_correction"]='c'
        return CrSpecRec
    else:
        return []


def convert_lat(Recs):
    """
    uses lat, for age<5Ma, model_lat if present, else tries to use average_inc to estimate plat.
    """
    New=[]
    for rec in Recs:
        if 'model_lat' in rec.keys() and rec['model_lat']!="":
             New.append(rec)
        elif 'average_age'  in rec.keys() and rec['average_age']!="" and  float(rec['average_age'])<=5.:
            if 'site_lat' in rec.keys() and rec['site_lat']!="":
                 rec['model_lat']=rec['site_lat']
                 New.append(rec)
        elif 'average_inc' in rec.keys() and rec['average_inc']!="":
            rec['model_lat']='%7.1f'%(plat(float(rec['average_inc'])))
            New.append(rec)
    return New

def convert_ages(Recs):
    """
    converts ages to Ma
    """
    New=[]
    for rec in Recs:
        age=''
        agekey=find('age',rec.keys())
        if agekey!="":
            keybase=agekey.split('_')[0]+'_'
            if rec[keybase+'age']!="":
                age=float(rec[keybase+"age"])
            elif rec[keybase+'age_low']!="" and rec[keybase+'age_high']!='':
                age=float(rec[keybase+'age_low'])  +(float(rec[keybase+'age_high'])-float(rec[keybase+'age_low']))/2.
            if age!='':
                rec[keybase+'age_unit']
                if rec[keybase+'age_unit']=='Ma':
                    rec[keybase+'age']='%10.4e'%(age)
                elif rec[keybase+'age_unit']=='ka' or rec[keybase+'age_unit']=='Ka':
                    rec[keybase+'age']='%10.4e'%(age*.001)
                elif rec[keybase+'age_unit']=='Years AD (+/-)':
                    rec[keybase+'age']='%10.4e'%((2011-age)*1e-6)
                elif rec[keybase+'age_unit']=='Years BP':
                    rec[keybase+'age']='%10.4e'%((age)*1e-6)
                rec[keybase+'age_unit']='Ma'
                New.append(rec)
            else:
                if 'er_site_names' in rec.keys():
                    print 'problem in convert_ages:', rec['er_site_names']
                elif 'er_site_name' in rec.keys():
                    print 'problem in convert_ages:', rec['er_site_name']
                else:
                    print 'problem in convert_ages:', rec
        else:
            print 'no age key:', rec
    return New

def getsampVGP(SampRec,SiteNFO):
    site=get_dictitem(SiteNFO,'er_site_name',SampRec['er_site_name'],'T')
    try:
        lat=float(site['site_lat'])
        lon=float(site['site_lon'])
        dec = float(SampRec['sample_dec'])
        inc = float(SampRec['sample_inc'])
        if SampRec['sample_alpha95']!="":
            a95=float(SampRec['sample_alpha95'])
        else:
            a95=0
        plong,plat,dp,dm=dia_vgp(dec,inc,a95,lat,lon)
        ResRec={}
        ResRec['pmag_result_name']='VGP Sample: '+SampRec['er_sample_name']
        ResRec['er_location_names']=SampRec['er_location_name']
        ResRec['er_citation_names']="This study"
        ResRec['er_site_name']=SampRec['er_site_name']
        ResRec['average_dec']=SampRec['sample_dec']
        ResRec['average_inc']=SampRec['sample_inc']
        ResRec['average_alpha95']=SampRec['sample_alpha95']
        ResRec['tilt_correction']=SampRec['sample_tilt_correction']
        ResRec['pole_comp_name']=SampleRec['sample_comp_name']
        ResRec['vgp_lat']='%7.1f'%(plat)
        ResRec['vgp_lon']='%7.1f'%(plon)
        ResRec['vgp_dp']='%7.1f'%(dp)
        ResRec['vgp_dm']='%7.1f'%(dm)
        ResRec['magic_method_codes']=SampRec['magic_method_codes']+":DE-DI"
        return ResRec
    except:
        return ""

def getsampVDM(SampRec,SampNFO):
    samps=get_dictitem(SampNFO,'er_sample_name',SampRec['er_sample_name'],'T')
    if len(samps)>0:
        samp=samps[0]
        lat=float(samp['sample_lat'])
        int = float(SampRec['sample_int'])
        vdm=b_vdm(int,lat)
        if 'sample_int_sigma' in SampRec.keys() and  SampRec['sample_int_sigma']!="":
            sig=b_vdm(float(SampRec['sample_int_sigma']),lat)
            sig='%8.3e'%(sig)
        else:
            sig=""
    else:
        print 'could not find sample info for: ', SampRec['er_sample_name']
        return {}
    ResRec={}
    ResRec['pmag_result_name']='V[A]DM Sample: '+SampRec['er_sample_name']
    ResRec['er_location_names']=SampRec['er_location_name']
    ResRec['er_citation_names']="This study"
    ResRec['er_site_names']=SampRec['er_site_name']
    ResRec['er_sample_names']=SampRec['er_sample_name']
    if 'sample_dec' in SampRec.keys():
        ResRec['average_dec']=SampRec['sample_dec']
    else:
        ResRec['average_dec']=""
    if 'sample_inc' in SampRec.keys():
        ResRec['average_inc']=SampRec['sample_inc']
    else:
        ResRec['average_inc']=""
    ResRec['average_int']=SampRec['sample_int']
    ResRec['vadm']='%8.3e'%(vdm)
    ResRec['vadm_sigma']=sig
    ResRec['magic_method_codes']=SampRec['magic_method_codes']
    ResRec['model_lat']=samp['sample_lat']
    return ResRec

def getfield(irmunits,coil,treat):
# calibration of ASC Impulse magnetizer
    if coil=="3": m,b=0.0071,-0.004 # B=mh+b where B is in T, treat is in Volts
    if coil=="2": m,b=0.00329,-0.002455 # B=mh+b where B is in T, treat is in Volts
    if coil=="1": m,b=0.0002,-0.0002 # B=mh+b where B is in T, treat is in Volts
    return float(treat)*m+b

def sortbykeys(input,sort_list):
    Output = []
    List=[] # get a list of what to be sorted by second key
    for rec in input:
        if rec[sort_list[0]] not in List:List.append(rec[sort_list[0]])
    for current in List: # step through input finding all records of current
        Currents=[]
        for rec in input:
            if rec[sort_list[0]]==current:Currents.append(rec)
        Current_sorted=sort_diclist(Currents,sort_list[1])
        for rec in Current_sorted:
            Output.append(rec)
    return Output

def get_list(data,key): # return a colon delimited list of unique key values
    keylist=[]
    for rec in data:
        keys=rec[key].split(':')
        for k in keys:
            if k not in keylist:keylist.append(k)
    keystring=""
    if len(keylist)==0:return keystring
    for k in keylist:keystring=keystring+':'+k
    return keystring[1:]

def ParseSiteFile(site_file):
    Sites,file_type=magic_read(site_file)
    LocNames,Locations=[],[]
    for site in Sites:
        if site['er_location_name'] not in LocNames: # new location name
            LocNames.append(site['er_location_name'])
            sites_locs=get_dictitem(Sites,'er_location_name',site['er_location_name'],'T') # get all sites for this loc
            lats=get_dictkey(sites_locs,'site_lat','f') # get all the latitudes as floats
            lons=get_dictkey(sites_locs,'site_lon','f') # get all the longitudes as floats
            LocRec={'er_citation_names':'This study','er_location_name':site['er_location_name'],'location_type':''}
            LocRec['location_begin_lat']=str(min(lats))
            LocRec['location_end_lat']=str(max(lats))
            LocRec['location_begin_lon']=str(min(lons))
            LocRec['location_end_lon']=str(max(lons))
            Locations.append(LocRec)
    return Locations

def ParseMeasFile(measfile,sitefile,instout,specout): # fix up some stuff for uploading
    #
    # read in magic_measurements file to get specimen, and instrument names
    #
    master_instlist=[]
    InstRecs=[]
    meas_data,file_type=magic_read(measfile)
    if file_type != 'magic_measurements':
        print file_type,"This is not a valid magic_measurements file "
        sys.exit()
    # read in site data
    if sitefile!="":
        SiteNFO,file_type=magic_read(sitefile)
        if file_type=="bad_file":
            print "Bad  or no er_sites file - lithology, etc will not be imported"
    else:
        SiteNFO=[]
    # define the Er_specimen records to create a new er_specimens.txt file
    #
    suniq,ErSpecs=[],[]
    for rec in meas_data:
# fill in some potentially missing fields
        if "magic_instrument_codes" in rec.keys():
            list=(rec["magic_instrument_codes"])
            list.strip()
            tmplist=list.split(":")
            for inst in tmplist:
                if inst not in master_instlist:
                    master_instlist.append(inst)
                    InstRec={}
                    InstRec["magic_instrument_code"]=inst
                    InstRecs.append(InstRec)
        if "measurement_standard" not in rec.keys():rec['measurement_standard']='u' # make this an unknown if not specified
        if rec["er_specimen_name"] not in suniq and rec["measurement_standard"]!='s': # exclude standards
            suniq.append(rec["er_specimen_name"])
            ErSpecRec={}
            ErSpecRec["er_citation_names"]="This study"
            ErSpecRec["er_specimen_name"]=rec["er_specimen_name"]
            ErSpecRec["er_sample_name"]=rec["er_sample_name"]
            ErSpecRec["er_site_name"]=rec["er_site_name"]
            ErSpecRec["er_location_name"]=rec["er_location_name"]
    #
    # attach site litho, etc. to specimen if not already there
            sites=get_dictitem(SiteNFO,'er_site_name',rec['er_site_name'],'T')
            if len(sites)==0:
                site={}
                print 'site record in er_sites table not found for: ',rec['er_site_name']
            else:
                site=sites[0]
            if 'site_class' not in site.keys() or 'site_lithology' not in site.keys() or 'site_type' not in site.keys():
                site['site_class']='Not Specified'
                site['site_lithology']='Not Specified'
                site['site_type']='Not Specified'
            if 'specimen_class' not in ErSpecRec.keys():ErSpecRec["specimen_class"]=site['site_class']
            if 'specimen_lithology' not in ErSpecRec.keys():ErSpecRec["specimen_lithology"]=site['site_lithology']
            if 'specimen_type' not in ErSpecRec.keys():ErSpecRec["specimen_type"]=site['site_type']
            if 'specimen_volume' not in ErSpecRec.keys():ErSpecRec["specimen_volume"]=""
            if 'specimen_weight' not in ErSpecRec.keys():ErSpecRec["specimen_weight"]=""
            ErSpecs.append(ErSpecRec)
    #
    #
    # save the data
    #
    magic_write(specout,ErSpecs,"er_specimens")
    print " Er_Specimen data (with updated info from site if necessary)  saved in ",specout
    #
    # write out the instrument list
    if len(InstRecs) >0:
        magic_write(instout,InstRecs,"magic_instruments")
        print " Instruments data saved in ",instout
    else:
        print "No instruments found"

def ReorderSamples(specfile,sampfile,outfile): # take care of re-ordering sample table, putting used orientations first
    UsedSamps,RestSamps=[],[]
    Specs,filetype=magic_read(specfile) # read in specimen file
    Samps,filetype=magic_read(sampfile) # read in sample file
    for rec in Specs: # hunt through specimen by specimen
        meths=rec['magic_method_codes'].strip().strip('\n').split(':')
        for meth in meths:
            methtype=meth.strip().strip('\n').split('-')
            if 'SO' in methtype:
                SO_meth=meth # find the orientation method code
        samprecs=get_dictitem(Samps,'er_sample_name',rec['er_sample_name'],'T')
        used=get_dictitem(samprecs,'magic_method_codes',SO_meth,'has')
        if len(used)>0:
            UsedSamps.append(used[0])
        else:
            print 'orientation not found for: ',rec['er_specimen_name']
        rest=get_dictitem(samprecs,'magic_method_codes',SO_meth,'not')
        for rec in rest:
            RestSamps.append(rec)
    for rec in RestSamps:
        UsedSamps.append(rec) # append the unused ones to the end of the file
    magic_write(outfile,UsedSamps,'er_samples')

def orient(mag_azimuth,field_dip,or_con):
    """
    uses specified orientation convention to convert user supplied orientations
    to laboratory azimuth and plunge
    """
    or_con = str(or_con)
    if mag_azimuth==-999:return "",""
    if or_con=="1": # lab_mag_az=mag_az;  sample_dip = -dip
        return mag_azimuth, -field_dip
    if or_con=="2":
        return mag_azimuth-90.,-field_dip
    if or_con=="3": # lab_mag_az=mag_az;  sample_dip = 90.-dip
        return mag_azimuth, 90.-field_dip
    if or_con=="4": # lab_mag_az=mag_az;  sample_dip = dip
        return mag_azimuth, field_dip
    if or_con=="5": # lab_mag_az=mag_az;  sample_dip = dip-90.
        return mag_azimuth, field_dip-90.
    if or_con=="6": # lab_mag_az=mag_az-90.;  sample_dip = 90.-dip
        return mag_azimuth-90., 90.-field_dip
    if or_con=="7": # lab_mag_az=mag_az;  sample_dip = 90.-dip
        return mag_azimuth-90., 90.-field_dip
    print "Error in orientation convention"

def get_Sb(data):
    """
    returns vgp scatter for data set
    """
    Sb,N=0.,0.
    for  rec in data:
                delta=90.-abs(float(rec['vgp_lat']))
                if rec['average_k']!="0":
                    k=float(rec['average_k'])
                    L=float(rec['average_lat'])*numpy.pi/180. # latitude in radians
                    Nsi=float(rec['average_nn'])
                    K=k/(2.*(1.+3.*numpy.sin(L)**2)/(5.-3.*numpy.sin(L)**2))
                    Sw=81./numpy.sqrt(K)
                else:
                    Sw,Nsi=0,1.
                Sb+=delta**2.-(Sw**2)/Nsi
                N+=1.
    return numpy.sqrt( Sb/float(N-1.) )

def default_criteria(nocrit):
    Crits={}
    critkeys=['magic_experiment_names', 'measurement_step_min', 'measurement_step_max', 'measurement_step_unit', 'specimen_polarity', 'specimen_nrm', 'specimen_direction_type', 'specimen_comp_nmb', 'specimen_mad', 'specimen_alpha95', 'specimen_n', 'specimen_int_sigma', 'specimen_int_sigma_perc', 'specimen_int_rel_sigma', 'specimen_int_rel_sigma_perc', 'specimen_int_mad', 'specimen_int_n', 'specimen_w', 'specimen_q', 'specimen_f', 'specimen_fvds', 'specimen_b_sigma', 'specimen_b_beta', 'specimen_g', 'specimen_dang', 'specimen_md', 'specimen_ptrm', 'specimen_drat', 'specimen_drats', 'specimen_rsc', 'specimen_viscosity_index', 'specimen_magn_moment', 'specimen_magn_volume', 'specimen_magn_mass', 'specimen_int_dang','specimen_int_ptrm_n', 'specimen_delta', 'specimen_theta', 'specimen_gamma', 'specimen_frac','specimen_gmax','specimen_scat','sample_polarity', 'sample_nrm', 'sample_direction_type', 'sample_comp_nmb', 'sample_sigma', 'sample_alpha95', 'sample_n', 'sample_n_lines', 'sample_n_planes', 'sample_k', 'sample_r', 'sample_tilt_correction', 'sample_int_sigma', 'sample_int_sigma_perc', 'sample_int_rel_sigma', 'sample_int_rel_sigma_perc', 'sample_int_n', 'sample_magn_moment', 'sample_magn_volume', 'sample_magn_mass', 'site_polarity', 'site_nrm', 'site_direction_type', 'site_comp_nmb', 'site_sigma', 'site_alpha95', 'site_n', 'site_n_lines', 'site_n_planes', 'site_k', 'site_r', 'site_tilt_correction', 'site_int_sigma', 'site_int_sigma_perc', 'site_int_rel_sigma', 'site_int_rel_sigma_perc', 'site_int_n', 'site_magn_moment', 'site_magn_volume', 'site_magn_mass', 'average_age_min', 'average_age_max', 'average_age_sigma', 'average_age_unit', 'average_sigma', 'average_alpha95', 'average_n', 'average_nn', 'average_k', 'average_r', 'average_int_sigma', 'average_int_rel_sigma', 'average_int_rel_sigma_perc', 'average_int_n', 'average_int_nn', 'vgp_dp', 'vgp_dm', 'vgp_sigma', 'vgp_alpha95', 'vgp_n', 'vdm_sigma', 'vdm_n', 'vadm_sigma', 'vadm_n', 'criteria_description', 'er_citation_names']
    for key in critkeys:Crits[key]='' # set up dictionary with all possible
    Crits['pmag_criteria_code']='ACCEPT'
    Crits['criteria_definition']='acceptance criteria for study'
    Crits['er_citation_names']='This study'
    if nocrit==0: # use default criteria
#
# set some sort of quasi-reasonable default criteria
#
        Crits['specimen_mad']='5'
        Crits['specimen_dang']='10'
        Crits['specimen_int_n']='4'
        Crits['specimen_int_ptrm_n']='2'
        Crits['specimen_drats']='20'
        Crits['specimen_b_beta']='0.1'
        Crits['specimen_md']='15'
        Crits['specimen_fvds']='0.7'
        Crits['specimen_q']='1.0'
        Crits['specimen_int_dang']='10'
        Crits['specimen_int_mad']='10'
        Crits['sample_alpha95']='5'
        Crits['site_int_n']='2'
        Crits['site_int_sigma']='5e-6'
        Crits['site_int_sigma_perc']='15'
        Crits['site_n']='5'
        Crits['site_n_lines']='4'
        Crits['site_k']='50'
    return [Crits]

def grade(PmagRec,ACCEPT,type):
    """
    Finds the 'grade' (pass/fail; A/F) of a record (specimen,sample,site) given the acceptance criteria
    """
    GREATERTHAN=['specimen_q','site_k','site_n','site_n_lines','site_int_n','measurement_step_min','specimen_int_ptrm_n','specimen_fvds','specimen_frac','specimen_f','specimen_n','specimen_int_n','sample_int_n','average_age_min','average_k','average_r','specimen_magn_moment','specimen_magn_volumn','specimen_rsc','sample_n','sample_n_lines','sample_n_planes','sample_k','sample_r','site_magn_moment','site_magn_volumn','site_magn_mass','site_r'] # these statistics must be exceede to pass, all others must be less than (except specimen_scat, which must be true)
    ISTRUE=['specimen_scat']
    kill=[] # criteria that kill the record
    sigma_types=['sample_int_sigma','sample_int_sigma_perc','site_int_sigma','site_int_sigma_perc','average_int_sigma','average_int_sigma_perc']
    sigmas=[]
    accept={}
    if type=='specimen_int':
        USEKEYS=['specimen_q','measurement_step_min','measurement_step_max','specimen_int_ptrm_n','specimen_fvds','specimen_frac','specimen_f','specimen_int_n','specimen_magn_moment','specimen_magn_volumn','specimen_rsc','specimen_scat','specimen_drats','specimen_int_mad','specimen_int_dang','specimen_md','specimen_b_beta','specimen_w','specimen_gmax']
    elif type=='specimen_dir':
        USEKEYS=['measurement_step_min','measurement_step_max','specimen_mad','specimen_n','specimen_magn_moment','specimen_magn_volumn']
    elif type=='sample_int':
        USEKEYS=['sample_int_n','sample_int_sigma','sample_int_sigma_perc']
    elif type=='sample_dir':
        USEKEYS=['sample_alpha95','sample_n','sample_n_lines','sample_n_planes','sample_k','sample_r']
    elif type=='site_int':
        USEKEYS=['site_int_sigma','site_int_sigma_perc','site_int_n']
    elif type=='site_dir':
        USEKEYS=['site_alpha95','site_k','site_n','site_n_lines','site_n_planes','site_r']

    for key in ACCEPT.keys():
        if ACCEPT[key]!="" and key in USEKEYS:
            if key in ISTRUE and ACCEPT[key]=='TRUE' or ACCEPT[key]=='True':
                ACCEPT[key]='1' # this is because Excel always capitalizes True to TRUE and python doesn't recognize that as a boolean.  never mind
            elif ACCEPT[key]=='FALSE' or ACCEPT[key]=='False':
                ACCEPT[key]='0'
            elif eval(ACCEPT[key])==0:
                ACCEPT[key]=""
            accept[key]=ACCEPT[key]
    for key in sigma_types:
        if key in USEKEYS and key in accept.keys() and key in PmagRec.keys(): sigmas.append(key)
    if len(sigmas)>1:
        if PmagRec[sigmas[0]]=="" or PmagRec[sigmas[1]]=="":
           kill.append(sigmas[0])
           kill.append(sigmas[1])
        elif eval(PmagRec[sigmas[0]])>eval(accept[sigmas[0]]) and eval(PmagRec[sigmas[1]])>eval(accept[sigmas[1]]):
           kill.append(sigmas[0])
           kill.append(sigmas[1])
    elif len(sigmas)==1 and sigmas[0] in accept.keys():
        if PmagRec[sigmas[0]]>accept[sigmas[0]]:
           kill.append(sigmas[0])
    for key in accept.keys():
     if accept[key]!="":
        if key not in PmagRec.keys() or PmagRec[key]=='':
            kill.append(key)
        elif key not in sigma_types:
            if key in ISTRUE: # boolean must be true
                if PmagRec[key]!='1':
                    kill.append(key)
            if key in GREATERTHAN:
                if eval(PmagRec[key])<eval(accept[key]):
                    kill.append(key)
            else:
                if eval(PmagRec[key])>eval(accept[key]):
                    kill.append(key)
    return kill

#
def flip(D):
    """
    determines principle direction and calculates the antipode of
    the reverse mode

    input: a nested list of directions
    returns a normal mode and flipped reverse mode as two DI blocks
    """
    ppars=doprinc(D) #get principle direction
    D1,D2=[],[]
    for rec in D:
        ang=angle([rec[0],rec[1]],[ppars['dec'],ppars['inc']])
        if ang>90.:
            d,i=(rec[0]-180.)%360.,-rec[1]
            D2.append([d,i,1.])
        else:
            D1.append([rec[0],rec[1],1.])
    return D1,D2
#
def dia_vgp(*args): # new function interface by J.Holmes, SIO, 6/1/2011
    """
    converts declination, inclination, alpha95 to VGP, dp, dm
    takes input as (Decs, Incs, a95, Site latitudes, Site Longitudes).
    These can be lists or individual values.
    Returns longitude, latitude, dp, dm
    """
    # test whether arguments are one 2-D list or 5 floats
    if len(args) == 1: # args comes in as a tuple of multi-dim lists.
        largs=list(args).pop() # scrap the tuple.
        (decs, dips, a95s, slats, slongs) = zip(*largs) # reorganize the lists so that we get columns of data in each var.
    else:
        # When args > 1, we are receiving five floats. This usually happens when the invoking script is
        # executed in interactive mode.
        (decs, dips, a95s, slats, slongs) = (args)

    # We send all incoming data to numpy in an array form. Even if it means a 1x1 matrix. That's OKAY. Really.
    (dec, dip, a95, slat, slong) = (numpy.array(decs), numpy.array(dips), numpy.array(a95s), \
                                    numpy.array(slats), numpy.array(slongs)) # package columns into arrays
    rad=numpy.pi/180. # convert to radians
    dec,dip,a95,slat,slong=dec*rad,dip*rad,a95*rad,slat*rad,slong*rad
    p=numpy.arctan2(2.0,numpy.tan(dip))
    plat=numpy.arcsin(numpy.sin(slat)*numpy.cos(p)+numpy.cos(slat)*numpy.sin(p)*numpy.cos(dec))
    beta=(numpy.sin(p)*numpy.sin(dec))/numpy.cos(plat)

    #------------------------------------------------------------------------------------------------------------
    # The deal with "boolmask":
    # We needed a quick way to assign matrix values based on a logic decision, in this case setting boundaries
    # on out-of-bounds conditions. Creating a matrix of boolean values the size of the original matrix and using
    # it to "mask" the assignment solves this problem nicely. The downside to this is that Numpy complains if you
    # attempt to mask a non-matrix, so we have to check for array type and do a normal assignment if the type is
    # scalar. These checks are made before calculating for the rest of the function.
    #------------------------------------------------------------------------------------------------------------

    boolmask = beta > 1. # create a mask of boolean values
    if isinstance(beta,numpy.ndarray):
        beta[boolmask] = 1. # assigns 1 only to elements that mask TRUE.
    else: # Numpy gets upset if you try our masking trick with a scalar or a 0-D matrix.
        if boolmask:
            beta = 1.
    boolmask = beta < -1.
    if isinstance(beta,numpy.ndarray):
        beta[boolmask] = -1. # assigns -1 only to elements that mask TRUE.
    else:
        if boolmask:
            beta = -1.

    beta=numpy.arcsin(beta)
    plong = slong+numpy.pi-beta
    if (numpy.cos(p) > numpy.sin(slat)*numpy.sin(plat)).any():
        boolmask = (numpy.cos(p) > (numpy.sin(slat)*numpy.sin(plat)))
        if isinstance(plong,numpy.ndarray):
            plong[boolmask] = (slong+beta)[boolmask]
        else:
            if boolmask:
                plong = slong+beta

    boolmask = (plong < 0)
    if isinstance(plong,numpy.ndarray):
        plong[boolmask] = plong[boolmask]+2*numpy.pi
    else:
        if boolmask:
            plong = plong+2*numpy.pi

    boolmask = (plong > 2*numpy.pi)
    if isinstance(plong,numpy.ndarray):
        plong[boolmask] = plong[boolmask]-2*numpy.pi
    else:
        if boolmask:
            plong = plong-2*numpy.pi

    dm=a95* (numpy.cos(slat)/numpy.cos(dip))/rad
    dp=a95*(1+3*(numpy.sin(slat)**2))/(2*rad)
    plat,plong=plat/rad,plong/rad
    return plong.tolist(),plat.tolist(),dp.tolist(),dm.tolist()

def int_pars(x,y,vds):
    """
     calculates York regression and Coe parameters (with Tauxe Fvds)
    """
# first do linear regression a la York
    xx,yer,xer,xyer,yy,xsum,ysum,xy=0.,0.,0.,0.,0.,0.,0.,0.
    xprime,yprime=[],[]
    pars={}
    pars["specimen_int_n"]=len(x)
    n=float(len(x))
    if n<=2:
        print "shouldn't be here at all!"
        return pars,1
    for i in range(len(x)):
        xx+=x[i]**2.
        yy+=y[i]**2.
        xy+=x[i]*y[i]
        xsum+=x[i]
        ysum+=y[i]
    xsig=numpy.sqrt((xx-(xsum**2./n))/(n-1.))
    ysig=numpy.sqrt((yy-(ysum**2./n))/(n-1.))
    sum=0
    for i in range(int(n)):
        yer+= (y[i]-ysum/n)**2.
        xer+= (x[i]-xsum/n)**2.
        xyer+= (y[i]-ysum/n)*(x[i]-xsum/n)
    slop=-numpy.sqrt(yer/xer)
    pars["specimen_b"]=slop
    s1=2.*yer-2.*slop*xyer
    s2=(n-2.)*xer
    sigma=numpy.sqrt(s1/s2)
    pars["specimen_b_sigma"]=sigma
    s=(xy-(xsum*ysum/n))/(xx-(xsum**2.)/n)
    r=(s*xsig)/ysig
    pars["specimen_rsc"]=r**2.
    ytot=abs(ysum/n-slop*xsum/n)
    for i in range(int(n)):
        xprime.append((slop*x[i]+y[i]-ytot)/(2.*slop))
        yprime.append(((slop*x[i]+y[i]-ytot)/2.)+ytot)
    sumdy,dy=0,[]
    dyt = abs(yprime[0]-yprime[int(n)-1])
    for i in range((int(n)-1)):
        dy.append(abs(yprime[i+1]-yprime[i]))
        sumdy+= dy[i]**2.
    f=dyt/ytot
    pars["specimen_f"]=f
    pars["specimen_ytot"]=ytot
    ff=dyt/vds
    pars["specimen_fvds"]=ff
    ddy=(1./dyt)*sumdy
    g=1.-ddy/dyt
    pars["specimen_g"]=g
    q=abs(slop)*f*g/sigma
    pars["specimen_q"]=q
    pars["specimen_b_beta"]=-sigma/slop
    return pars,0

def dovds(data):
    """
     calculates vector difference sum for demagnetization data
    """
    vds,X=0,[]
    for rec in data:
        X.append(dir2cart(rec))
    for k  in range(len(X)-1):
        xdif=X[k+1][0]-X[k][0]
        ydif=X[k+1][1]-X[k][1]
        zdif=X[k+1][2]-X[k][2]
        vds+=numpy.sqrt(xdif**2+ydif**2+zdif**2)
    vds+=numpy.sqrt(X[-1][0]**2+X[-1][1]**2+X[-1][2]**2)
    return vds

def vspec_magic(data):
    """
   takes average vector of replicate measurements
    """
    vdata,Dirdata,step_meth=[],[],""
    if len(data)==0:return vdata
    treat_init=["treatment_temp", "treatment_temp_decay_rate", "treatment_temp_dc_on", "treatment_temp_dc_off", "treatment_ac_field", "treatment_ac_field_decay_rate", "treatment_ac_field_dc_on", "treatment_ac_field_dc_off", "treatment_dc_field", "treatment_dc_field_decay_rate", "treatment_dc_field_ac_on", "treatment_dc_field_ac_off", "treatment_dc_field_phi", "treatment_dc_field_theta"]
    treats=[]
#
# find keys that are used
#
    for key in treat_init:
        if key in data[0].keys():treats.append(key)  # get a list of keys
    stop={}
    stop["er_specimen_name"]="stop"
    for key in treats:
        stop[key]="" # tells program when to quit and go home
    data.append(stop)
#
# set initial states
#
    DataState0,newstate={},0
    for key in treats:
        DataState0[key]=data[0][key] # set beginning treatment
    k,R=1,0
    for i in range(k,len(data)):
        FDirdata,Dirdata,DataStateCurr,newstate=[],[],{},0
        for key in treats:  # check if anything changed
	    DataStateCurr[key]=data[i][key]
            if DataStateCurr[key].strip() !=  DataState0[key].strip(): newstate=1 # something changed
        if newstate==1:
            if i==k: # sample is unique
                vdata.append(data[i-1])
            else: # measurement is not unique
                #print "averaging: records " ,k,i
                for l in range(k-1,i):
                    if 'orientation' in data[l]['measurement_description']:
                        data[l]['measurement_description']=""
                    Dirdata.append([float(data[l]['measurement_dec']),float(data[l]['measurement_inc']),float(data[l]['measurement_magn_moment'])])
                    FDirdata.append([float(data[l]['measurement_dec']),float(data[l]['measurement_inc'])])
                dir,R=vector_mean(Dirdata)
                Fpars=fisher_mean(FDirdata)
                vrec=data[i-1]
                vrec['measurement_dec']='%7.1f'%(dir[0])
                vrec['measurement_inc']='%7.1f'%(dir[1])
                vrec['measurement_magn_moment']='%8.3e'%(R/(i-k+1))
                vrec['measurement_csd']='%7.1f'%(Fpars['csd'])
                vrec['measurement_positions']='%7.1f'%(Fpars['n'])
                vrec['measurement_description']='average of multiple measurements'
                if "magic_method_codes" in vrec.keys():
                    meths=vrec["magic_method_codes"].strip().split(":")
                    if "DE-VM" not in meths:meths.append("DE-VM")
                    methods=""
                    for meth in meths:
                        methods=methods+meth+":"
                    vrec["magic_method_codes"]=methods[:-1]
                else: vrec["magic_method_codes"]="DE-VM"
                vdata.append(vrec)
# reset state to new one
            for key in treats:
                DataState0[key]=data[i][key] # set beginning treatment
            k=i+1
            if data[i]["er_specimen_name"] =="stop":
                del data[-1]  # get rid of dummy stop sign
                return vdata,treats # bye-bye

def get_specs(data):
    """
     takes a magic format file and returns a list of unique specimen names
    """
# sort the specimen names
#
    speclist=[]
    for rec in data:
      spec=rec["er_specimen_name"]
      if spec not in speclist:
          speclist.append(spec)
    speclist.sort()
    return speclist

def vector_mean(data):
    """
    calculates the vector mean of a given set of vectors
    """
    R,Xbar,X=0,[0,0,0],[]
    for rec in data:
        X.append(dir2cart(rec))
    for i in range(len(X)):
        for c in range(3):
           Xbar[c]+=X[i][c]
    for c in range(3):
        R+=Xbar[c]**2
    R=numpy.sqrt(R)
    for c in range(3):
        Xbar[c]=Xbar[c]/R
    dir=cart2dir(Xbar)
    return dir, R

def mark_dmag_rec(s,ind,data):
    """
    edits demagnetization data to mark "bad" points with measurement_flag
    """
    datablock=[]
    for rec in  data:
        if rec['er_specimen_name']==s:
            meths=rec['magic_method_codes'].split(':')
            if 'LT-NO' in meths or 'LT-AF-Z' in meths or 'LT-T-Z' in meths:
                datablock.append(rec)
    dmagrec=datablock[ind]
    for k in  range(len(data)):
        meths=data[k]['magic_method_codes'].split(':')
        if 'LT-NO' in meths or 'LT-AF-Z' in meths or 'LT-T-Z' in meths:
            if data[k]['er_specimen_name']==s:
                if data[k]['treatment_temp']==dmagrec['treatment_temp'] and data[k]['treatment_ac_field']==dmagrec['treatment_ac_field']:
                    if data[k]['measurement_dec']==dmagrec['measurement_dec'] and data[k]['measurement_inc']==dmagrec['measurement_inc'] and data[k]['measurement_magn_moment']==dmagrec['measurement_magn_moment']:
                        if data[k]['measurement_flag']=='g':
                            flag='b'
                        else:
                            flag='g'
                        data[k]['measurement_flag']=flag
                        break
    return data

def mark_samp(Samps,data,crd):




    return Samps

def find_dmag_rec(s,data):
    """
    returns demagnetization data for specimen s from the data - excludes other kinds of experiments and "bad" measurements
    """
    EX=["LP-AN-ARM","LP-AN-TRM","LP-ARM-AFD","LP-ARM2-AFD","LP-TRM-AFD","LP-TRM","LP-TRM-TD","LP-X"] # list of excluded lab protocols
    INC=["LT-NO","LT-AF-Z","LT-T-Z", "LT-M-Z", "LP-PI-TRM-IZ", "LP-PI-M-IZ"]
    datablock,tr=[],""
    therm_flag,af_flag,mw_flag=0,0,0
    units=[]
    spec_meas=get_dictitem(data,'er_specimen_name',s,'T')
    for rec in spec_meas:
           if 'measurement_flag' not in rec.keys():rec['measurement_flag']='g'
           skip=1
           tr=""
           methods=rec["magic_method_codes"].split(":")
           for meth in methods:
               if meth.strip() in INC:
                   skip=0
           for meth in EX:
               if meth in methods:skip=1
           if skip==0:
               if "LT-NO" in methods:
                   tr = float(rec["treatment_temp"])
               if "LT-AF-Z" in methods:
                   af_flag=1
                   tr = float(rec["treatment_ac_field"])
                   if "T" not in units:units.append("T")
               if "LT-T-Z" in methods:
                   therm_flag=1
                   tr = float(rec["treatment_temp"])
                   if "K" not in units:units.append("K")
               if "LT-M-Z" in methods:
                   mw_flag=1
                   tr = float(rec["treatment_mw_power"])*float(rec["treatment_mw_time"])
                   if "J" not in units:units.append("J")
               if "LP-PI-TRM-IZ" in methods or "LP-PI-M-IZ" in methods:  # looking for in-field first thellier or microwave data - otherwise, just ignore this
                   ZI=0
               else:
                   ZI=1
               Mkeys=['measurement_magnitude','measurement_magn_moment','measurement_magn_volume','measurement_magn_mass']
               if tr !="":
                   dec,inc,int = "","",""
                   if "measurement_dec" in rec.keys() and rec["measurement_dec"] != "":
                       dec=float(rec["measurement_dec"])
                   if "measurement_inc" in rec.keys() and rec["measurement_inc"] != "":
                       inc=float(rec["measurement_inc"])
                   for key in Mkeys:
                       if key in rec.keys() and rec[key]!="":int=float(rec[key])
                   if 'magic_instrument_codes' not in rec.keys():rec['magic_instrument_codes']=''
                   datablock.append([tr,dec,inc,int,ZI,rec['measurement_flag'],rec['magic_instrument_codes']])
    if therm_flag==1:
        for k in range(len(datablock)):
            if datablock[k][0]==0.: datablock[k][0]=273.
    if af_flag==1:
        for k in range(len(datablock)):
            if datablock[k][0]>=273 and datablock[k][0]<=323: datablock[k][0]=0.
    meas_units=""
    if len(units)>0:
        for u in units:meas_units=meas_units+u+":"
        meas_units=meas_units[:-1]
    return datablock,meas_units

def magic_read(infile, data=None):
    """
    reads  a Magic template file, puts data in a list of dictionaries.
    """
    hold,magic_data,magic_record,magic_keys=[],[],{},[]
    if data: #
        f = data
    else:
        try:
            f=open(infile,"rU")
        except:
            return [],'bad_file'

    d = f.readline()[:-1].strip('\n')
    if not d:
        return [], 'empty_file'
    if d[0]=="s" or d[1]=="s":
        delim='space'
    elif d[0]=="t" or d[1]=="t":
        delim='tab'
    else:
        print 'error reading ', infile
        #sys.exit()
        return [], 'bad_file'
    if delim=='space':
        file_type=d.split()[1]
    if delim=='tab':
        file_type=d.split('\t')[1]
    if file_type=='delimited':
        if delim=='space':
            file_type=d.split()[2]
        if delim=='tab':
            file_type=d.split('\t')[2]
    if delim=='space':
        line =f.readline()[:-1].split()
    if delim=='tab':
        line =f.readline()[:-1].split('\t')
    for key in line:
        magic_keys.append(key)
    lines=f.readlines()
    if len(lines)<1:
       return [],'empty_file'
    for line in lines[:-1]:
        line.replace('\n','')
        if delim=='space':rec=line[:-1].split()
        if delim=='tab':rec=line[:-1].split('\t')
        hold.append(rec)
    line = lines[-1].replace('\n','')
    if delim=='space':rec=line[:-1].split()
    if delim=='tab':rec=line.split('\t')
    hold.append(rec)
    for rec in hold:
        magic_record={}
        if len(magic_keys) != len(rec):
            if rec != ['>>>>>>>>>>'] and 'delimited' not in rec[0]: # ignores this warning when reading the dividers in an upload.txt composite file
                print "Warning: Uneven record lengths detected: "
                print magic_keys
                print rec
        # modified by Ron Shaar:
        # add a health check:
        # if len(magic_keys) > len(rec): take rec
        # if len(magic_keys) < len(rec): take magic_keys
        # original code: for k in range(len(rec)):
        # channged to: for k in range(min(len(magic_keys),len(rec))):
        for k in range(min(len(magic_keys),len(rec))):
           magic_record[magic_keys[k]]=rec[k].strip('\n')
        magic_data.append(magic_record)
    magictype=file_type.lower().split("_")
    Types=['er','magic','pmag','rmag']
    if magictype in Types:file_type=file_type.lower()
    return magic_data,file_type

def upload_read(infile,table):
    """
    reads  a table from a MagIC upload (or downloaded) txt file,
     puts data in a list of dictionaries
    """
    delim='tab'
    hold,magic_data,magic_record,magic_keys=[],[],{},[]
    f=open(infile,"rU")
#
# look for right table
#
    line =f.readline()[:-1]
    file_type=line.split('\t')[1]
    if file_type=='delimited': file_type=line.split('\t')[2]
    if delim=='tab':
        line =f.readline()[:-1].split('\t')
    else:
        print "only tab delimitted files are supported now"
        sys.exit()
    while file_type!=table:
        while line[0][0:5] in f.readlines() !=">>>>>":
            pass
        line =f.readline()[:-1]
        file_type=line.split('\t')[1]
        if file_type=='delimited': file_type=line.split('\t')[2]
        ine =f.readline()[:-1].split('\t')
    while line[0][0:5] in f.readlines() !=">>>>>":
        for key in line:
            magic_keys.append(key)
        for line in f.readlines():
            rec=line[:-1].split('\t')
            hold.append(rec)
        for rec in hold:
            magic_record={}
            if len(magic_keys) != len(rec):
                print "Uneven record lengths detected: ",rec
                raw_input("Return to continue.... ")
            for k in range(len(magic_keys)):
                magic_record[magic_keys[k]]=rec[k]
            magic_data.append(magic_record)
    return magic_data

def putout(ofile,keylist,Rec):
    """
    writes out a magic format record to ofile
    """
    pmag_out=open(ofile,'a')
    outstring=""
    for key in keylist:
        try:
           outstring=outstring + '\t' + str(Rec[key]).strip()
        except:
           print key,Rec[key]
           #raw_input()
    outstring=outstring+'\n'
    pmag_out.write(outstring[1:])
    pmag_out.close()

def first_rec(ofile,Rec,file_type):
    """
    opens the file ofile as a magic template file with headers as the keys to Rec
    """
    keylist=[]
    opened = False
    # sometimes Windows needs a little extra time to open a file
    # or else it throws an error
    while not opened:
        try:
            pmag_out = open(ofile,'w')
            opened = True
        except IOError:
            time.sleep(1)
    outstring="tab \t"+file_type+"\n"
    pmag_out.write(outstring)
    keystring=""
    for key in Rec.keys():
        keystring=keystring+'\t'+key.strip()
        keylist.append(key)
    keystring=keystring + '\n'
    pmag_out.write(keystring[1:])
    pmag_out.close()
    return keylist

def magic_write_old(ofile,Recs,file_type):
    """
    writes out a magic format list of dictionaries to ofile
    """

    if len(Recs)<1:
        return
    pmag_out=open(ofile,'w')
    outstring="tab \t"+file_type+"\n"
    pmag_out.write(outstring)
    keystring=""
    keylist=[]
    for key in Recs[0].keys():
        keylist.append(key)
    keylist.sort()
    for key in keylist:
        keystring=keystring+'\t'+key.strip()
    keystring=keystring + '\n'
    pmag_out.write(keystring[1:])
    for Rec in Recs:
        outstring=""
        for key in keylist:
           try:
              outstring=outstring+'\t'+str(Rec[key].strip())
           except:
              if 'er_specimen_name' in Rec.keys():
                  print Rec['er_specimen_name']
              elif 'er_specimen_names' in Rec.keys():
                  print Rec['er_specimen_names']
              print key,Rec[key]
              #raw_input()
        outstring=outstring+'\n'
        pmag_out.write(outstring[1:])
    pmag_out.close()

def magic_write(ofile,Recs,file_type):
    """
    called by magic_write(outputfile,records_list,magic_file_type)
    writes out a magic format list of dictionaries to ofile

    """
    if len(Recs)<1:
        return False, 'No records to write to file {}'.format(ofile)
    else:
        print len(Recs),' records written to file ',ofile
    pmag_out=open(ofile,'w')
    outstring="tab \t"+file_type+"\n"
    pmag_out.write(outstring)
    keystring=""
    keylist=[]
    for key in Recs[0].keys():
        keylist.append(key)
    keylist.sort()
    for key in keylist:
        keystring=keystring+'\t'+key.strip()
    keystring=keystring + '\n'
    pmag_out.write(keystring[1:])
    for Rec in Recs:
        outstring=""
        for key in keylist:
           try:
              outstring=outstring+'\t'+str(Rec[key].strip())
           except:
              if 'er_specimen_name' in Rec.keys():
                  print Rec['er_specimen_name']
              elif 'er_specimen_names' in Rec.keys():
                  print Rec['er_specimen_names']
              print key,Rec[key]
              #raw_input()
        outstring=outstring+'\n'
        pmag_out.write(outstring[1:])
    pmag_out.close()
    return True, ofile

def dotilt(dec,inc,bed_az,bed_dip):
    """
    does a tilt correction on dec,inc using bedding dip direction bed_az and dip bed_dip.  called with syntax:  dotilt(dec,inc,bed_az,bed_dip).
    """
    rad=numpy.pi/180. # converts from degrees to radians
    X=dir2cart([dec,inc,1.]) # get cartesian coordinates of dec,inc
# get some sines and cosines of new coordinate system
    sa,ca= -numpy.sin(bed_az*rad),numpy.cos(bed_az*rad)
    cdp,sdp= numpy.cos(bed_dip*rad),numpy.sin(bed_dip*rad)
# do the rotation
    xc=X[0]*(sa*sa+ca*ca*cdp)+X[1]*(ca*sa*(1.-cdp))+X[2]*sdp*ca
    yc=X[0]*ca*sa*(1.-cdp)+X[1]*(ca*ca+sa*sa*cdp)-X[2]*sa*sdp
    zc=X[0]*ca*sdp-X[1]*sdp*sa-X[2]*cdp
# convert back to direction:
    Dir=cart2dir([xc,yc,-zc])
    return Dir[0],Dir[1] # return declination, inclination of rotated direction

def dotilt_V(input):
    """
    does a tilt correction on dec,inc using bedding dip direction bed_az and dip bed_dip
    """
    input=input.transpose()
    dec, inc, bed_az, bed_dip =input[0],input[1],input[2],input[3]  # unpack input array into separate arrays
    rad=numpy.pi/180. # convert to radians
    Dir=numpy.array([dec,inc]).transpose()
    X=dir2cart(Dir).transpose() # get cartesian coordinates
    N=numpy.size(dec)

# get some sines and cosines of new coordinate system
    sa,ca= -numpy.sin(bed_az*rad),numpy.cos(bed_az*rad)
    cdp,sdp= numpy.cos(bed_dip*rad),numpy.sin(bed_dip*rad)
# do the rotation
    xc=X[0]*(sa*sa+ca*ca*cdp)+X[1]*(ca*sa*(1.-cdp))+X[2]*sdp*ca
    yc=X[0]*ca*sa*(1.-cdp)+X[1]*(ca*ca+sa*sa*cdp)-X[2]*sa*sdp
    zc=X[0]*ca*sdp-X[1]*sdp*sa-X[2]*cdp
# convert back to direction:
    cart=numpy.array([xc,yc,-zc]).transpose()
    Dir=cart2dir(cart).transpose()
    return Dir[0],Dir[1] # return declination, inclination arrays of rotated direction

def dogeo(dec,inc,az,pl):
    """
    called as:  dogeo(dec,inc,az,pl)
    rotates dec,inc into geographic coordinates using az,pl as azimuth and plunge of X direction
    """
    A1,A2,A3=[],[],[] # set up lists for rotation vector
    Dir=[dec,inc,1.] # put dec inc in direction list and set  length to unity
    X=dir2cart(Dir) # get cartesian coordinates
#
#   set up rotation matrix
#
    A1=dir2cart([az,pl,1.])
    A2=dir2cart([az+90.,0,1.])
    A3=dir2cart([az-180.,90.-pl,1.])
#
# do rotation
#
    xp=A1[0]*X[0]+A2[0]*X[1]+A3[0]*X[2]
    yp=A1[1]*X[0]+A2[1]*X[1]+A3[1]*X[2]
    zp=A1[2]*X[0]+A2[2]*X[1]+A3[2]*X[2]
#
# transform back to dec,inc
#
    Dir_geo=cart2dir([xp,yp,zp])
    return Dir_geo[0],Dir_geo[1]    # send back declination and inclination

def dogeo_V(input):
    """
    rotates dec,in into geographic coordinates using az,pl as azimuth and plunge of X direction
    handles  array for  input
    """
    input=input.transpose()
    dec, inc, az, pl =input[0],input[1],input[2],input[3]  # unpack input array into separate arrays
    Dir=numpy.array([dec,inc]).transpose()
    X=dir2cart(Dir).transpose() # get cartesian coordinates
    N=numpy.size(dec)
    A1=dir2cart(numpy.array([az,pl,numpy.ones(N)]).transpose()).transpose()
    A2=dir2cart(numpy.array([az+90.,numpy.zeros(N),numpy.ones(N)]).transpose()).transpose()
    A3=dir2cart(numpy.array([az-180.,90.-pl,numpy.ones(N)]).transpose()).transpose()

# do rotation
#
    xp=A1[0]*X[0]+A2[0]*X[1]+A3[0]*X[2]
    yp=A1[1]*X[0]+A2[1]*X[1]+A3[1]*X[2]
    zp=A1[2]*X[0]+A2[2]*X[1]+A3[2]*X[2]
    cart=numpy.array([xp,yp,zp]).transpose()
#
# transform back to dec,inc
#
    Dir_geo=cart2dir(cart).transpose()
    return Dir_geo[0],Dir_geo[1]    # send back declination and inclination arrays

def dodirot(D,I,Dbar,Ibar):
    """
    This function is called by dodirot(D,I,Dbar,Ibar) where D=declination, I = inclination and Dbar/Ibar are the desired mean direction.  It returns the rotated Dec/Inc pair.
    """
    d,irot=dogeo(D,I,Dbar,90.-Ibar)
    drot=d-180.
#    drot,irot=dogeo(D,I,Dbar,Ibar)
    if drot<360.:drot=drot+360.
    if drot>360.:drot=drot-360.
    return drot,irot

def find_samp_rec(s,data,az_type):
    """
    find the orientation info for samp s
    """
    datablock,or_error,bed_error=[],0,0
    orient={}
    orient["sample_dip"]=""
    orient["sample_azimuth"]=""
    orient['sample_description']=""
    for rec in data:
        if rec["er_sample_name"].lower()==s.lower():
           if 'sample_orientation_flag' in  rec.keys() and rec['sample_orientation_flag']=='b':
               orient['sample_orientation_flag']='b'
               return orient
           if "magic_method_codes" in rec.keys() and az_type != "0":
               methods=rec["magic_method_codes"].replace(" ","").split(":")
               if az_type in methods and "sample_azimuth" in rec.keys() and rec["sample_azimuth"]!="": orient["sample_azimuth"]= float(rec["sample_azimuth"])
               if "sample_dip" in rec.keys() and rec["sample_dip"]!="": orient["sample_dip"]=float(rec["sample_dip"])
               if "sample_bed_dip_direction" in rec.keys() and rec["sample_bed_dip_direction"]!="":orient["sample_bed_dip_direction"]=float(rec["sample_bed_dip_direction"])
               if "sample_bed_dip" in rec.keys() and rec["sample_bed_dip"]!="":orient["sample_bed_dip"]=float(rec["sample_bed_dip"])
           else:
               if "sample_azimuth" in rec.keys():orient["sample_azimuth"]=float(rec["sample_azimuth"])
               if "sample_dip" in rec.keys(): orient["sample_dip"]=float(rec["sample_dip"])
               if "sample_bed_dip_direction" in rec.keys(): orient["sample_bed_dip_direction"]=float(rec["sample_bed_dip_direction"])
               if "sample_bed_dip" in rec.keys(): orient["sample_bed_dip"]=float(rec["sample_bed_dip"])
               if 'sample_description' in rec.keys(): orient['sample_description']=rec['sample_description']
        if orient["sample_azimuth"]!="": break
    return orient

def vspec(data):
    """
    takes the vector mean of replicate measurements at a give step
    """
    vdata,Dirdata,step_meth=[],[],[]
    tr0=data[0][0] # set beginning treatment
    data.append("Stop")
    k,R=1,0
    for i in range(k,len(data)):
        Dirdata=[]
        if data[i][0] != tr0:
            if i==k: # sample is unique
                vdata.append(data[i-1])
                step_meth.append(" ")
            else: # sample is not unique
                for l in range(k-1,i):
                    Dirdata.append([data[l][1],data[l][2],data[l][3]])
                dir,R=vector_mean(Dirdata)
                vdata.append([data[i-1][0],dir[0],dir[1],R/(i-k+1),'1','g'])
                step_meth.append("DE-VM")
            tr0=data[i][0]
            k=i+1
            if tr0=="stop":break
    del data[-1]
    return step_meth,vdata

def Vdiff(D1,D2):
    """
    finds the vector difference between two directions D1,D2
    """
    A=dir2cart([D1[0],D1[1],1.])
    B=dir2cart([D2[0],D2[1],1.])
    C=[]
    for i in range(3):
        C.append(A[i]-B[i])
    return cart2dir(C)

def angle(D1,D2):
    """
    call to angle(D1,D2) returns array of angles between lists of two directions D1,D2 where D1 is for example, [[Dec1,Inc1],[Dec2,Inc2],etc.]
    """
    D1=numpy.array(D1)
    if len(D1.shape)>1:
        D1=D1[:,0:2] # strip off intensity
    else: D1=D1[:2]
    D2=numpy.array(D2)
    if len(D2.shape)>1:
        D2=D2[:,0:2] # strip off intensity
    else: D2=D2[:2]
    X1=dir2cart(D1) # convert to cartesian from polar
    X2=dir2cart(D2)
    angles=[] # set up a list for angles
    for k in range(X1.shape[0]): # single vector
        angle= numpy.arccos(numpy.dot(X1[k],X2[k]))*180./numpy.pi # take the dot product
        angle=angle%360.
        angles.append(angle)
    return numpy.array(angles)

def cart2dir(cart):
    """
    converts a direction to cartesian coordinates.  takes an array of [x,y,z])
    """
    cart=numpy.array(cart)
    rad=numpy.pi/180. # constant to convert degrees to radians
    if len(cart.shape)>1:
        Xs,Ys,Zs=cart[:,0],cart[:,1],cart[:,2]
    else: #single vector
        Xs,Ys,Zs=cart[0],cart[1],cart[2]
    Rs=numpy.sqrt(Xs**2+Ys**2+Zs**2) # calculate resultant vector length
    Decs=(numpy.arctan2(Ys,Xs)/rad)%360. # calculate declination taking care of correct quadrants (arctan2) and making modulo 360.
    try:
        Incs=numpy.arcsin(Zs/Rs)/rad # calculate inclination (converting to degrees) #
    except:
        print 'trouble in cart2dir' # most likely division by zero somewhere
        return numpy.zeros(3)

    return numpy.array([Decs,Incs,Rs]).transpose() # return the directions list

#def cart2dir(cart): # OLD ONE
#    """
#    converts a direction to cartesian coordinates
#    """
#    Dir=[] # establish a list to put directions in
#    rad=numpy.pi/180. # constant to convert degrees to radians
#    R=numpy.sqrt(cart[0]**2+cart[1]**2+cart[2]**2) # calculate resultant vector length
#    if R==0:
#       print 'trouble in cart2dir'
#       print cart
#       return [0.0,0.0,0.0]
#    D=numpy.arctan2(cart[1],cart[0])/rad  # calculate declination taking care of correct quadrants (arctan2)
#    if D<0:D=D+360. # put declination between 0 and 360.
#    if D>360.:D=D-360.
#    Dir.append(D)  # append declination to Dir list
#    I=numpy.arcsin(cart[2]/R)/rad # calculate inclination (converting to degrees)
#    Dir.append(I) # append inclination to Dir list
#    Dir.append(R) # append vector length to Dir list
#    return Dir # return the directions list

def tauV(T):
    """
    gets the eigenvalues (tau) and eigenvectors (V) from matrix T
    """
    t,V,tr=[],[],0.
    ind1,ind2,ind3=0,1,2
    evalues,evectmps=numpy.linalg.eig(T)
    evectors=numpy.transpose(evectmps)  # to make compatible with Numeric convention
    for tau in evalues:
        tr+=tau
    if tr!=0:
        for i in range(3):
            evalues[i]=evalues[i]/tr
    else:
        return t,V
# sort evalues,evectors
    t1,t2,t3=0.,0.,1.
    for k in range(3):
        if evalues[k] > t1:
            t1,ind1=evalues[k],k
        if evalues[k] < t3:
            t3,ind3=evalues[k],k
    for k in range(3):
        if evalues[k] != t1 and evalues[k] != t3:
            t2,ind2=evalues[k],k
    V.append(evectors[ind1])
    V.append(evectors[ind2])
    V.append(evectors[ind3])
    t.append(t1)
    t.append(t2)
    t.append(t3)
    return t,V

def Tmatrix(X):
    """
    gets the orientation matrix (T) from data in X
    """
    T=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
    for row in X:
        for k in range(3):
            for l in range(3):
                T[k][l] += row[k]*row[l]
    return T

def dir2cart(d):
   # converts list or array of vector directions, in degrees, to array of cartesian coordinates, in x,y,z
    ints=numpy.ones(len(d)).transpose() # get an array of ones to plug into dec,inc pairs
    d=numpy.array(d)
    rad=numpy.pi/180.
    if len(d.shape)>1: # array of vectors
        decs,incs=d[:,0]*rad,d[:,1]*rad
        if d.shape[1]==3: ints=d[:,2] # take the given lengths
    else: # single vector
        decs,incs=numpy.array(d[0])*rad,numpy.array(d[1])*rad
        if len(d)==3:
            ints=numpy.array(d[2])
        else:
            ints=numpy.array([1.])
    cart= numpy.array([ints*numpy.cos(decs)*numpy.cos(incs),ints*numpy.sin(decs)*numpy.cos(incs),ints*numpy.sin(incs)]).transpose()
    return cart

def dms2dd(d):
   # converts list or array of degree, minute, second locations to array of decimal degrees
    d=numpy.array(d)
    if len(d.shape)>1: # array of angles
        degs,mins,secs=d[:,0],d[:,1],d[:,2]
        print degs,mins,secs
    else: # single vector
        degs,mins,secs=numpy.array(d[0]),numpy.array(d[1]),numpy.array(d[2])
        print degs,mins,secs
    dd= numpy.array(degs+mins/60.+secs/3600.).transpose()
    return dd

def findrec(s,data):
    """
    finds all the records belonging to s in data
    """
    datablock=[]
    for rec in data:
       if s==rec[0]:
           datablock.append([rec[1],rec[2],rec[3],rec[4]])
    return datablock

def domean(indata,start,end,calculation_type):
    """
     gets average direction using fisher or pca (line or plane) methods
    """
    mpars={}
    datablock=[]
    start0,end0=start,end
    for ind,rec in enumerate(indata):
        if len(rec)<6:rec.append('g')
        if rec[5]=='b' and ind==start0:
            mpars["specimen_direction_type"]="Error"
            print "Can't select 'bad' point as start for PCA"
            return mpars
        if rec[5]=='b' and ind<start:
            start-=1
            end-=1
        if rec[5]=='b' and ind>start and ind<=end+1:
            end-=1
        if rec[5]=='g':
            datablock.append(rec) # use only good data
    mpars["calculation_type"]=calculation_type
    rad=numpy.pi/180.
    if end>len(datablock)-1 or end<start : end=len(datablock)-1
    control,data,X,Nrec=[],[],[],float(end-start+1)
    cm=[0.,0.,0.]
#
#  get cartesian coordinates
#
    fdata=[]
    for k in range(start,end+1):
        if calculation_type == 'DE-BFL' or calculation_type=='DE-BFL-A' or calculation_type=='DE-BFL-O' :  # best-fit line
            data=[datablock[k][1],datablock[k][2],datablock[k][3]]
        else:
            data=[datablock[k][1],datablock[k][2],1.0] # unit weight
        fdata.append(data)
        cart= dir2cart(data)
        X.append(cart)
    if calculation_type=='DE-BFL-O': # include origin as point
        X.append([0.,0.,0.])
        #pass
    if calculation_type=='DE-FM': # for fisher means
        fpars=fisher_mean(fdata)
        mpars["specimen_direction_type"]='l'
        mpars["specimen_dec"]=fpars["dec"]
        mpars["specimen_inc"]=fpars["inc"]
        mpars["specimen_alpha95"]=fpars["alpha95"]
        mpars["specimen_n"]=fpars["n"]
        mpars["specimen_r"]=fpars["r"]
        mpars["measurement_step_min"]=indata[start0][0]
        mpars["measurement_step_max"]=indata[end0][0]
        mpars["center_of_mass"]=cm
        mpars["specimen_dang"]=-1
        return mpars
#
#	get center of mass for principal components (DE-BFL or DE-BFP)
#
    for cart in X:
        for l in range(3):
            cm[l]+=cart[l]/Nrec
    mpars["center_of_mass"]=cm

#
#   transform to center of mass (if best-fit line)
#
    if calculation_type!='DE-BFP': mpars["specimen_direction_type"]='l'
    if calculation_type=='DE-BFL' or calculation_type=='DE-BFL-O': # not for planes or anchored lines
        for k in range(len(X)):
            for l in range(3):
               X[k][l]=X[k][l]-cm[l]
    else:
        mpars["specimen_direction_type"]='p'
#
#   put in T matrix
#
    T=numpy.array(Tmatrix(X))
#
#   get sorted evals/evects
#
    t,V=tauV(T)
    if t[2]<0:t[2]=0 # make positive
    if t==[]:
        mpars["specimen_direction_type"]="Error"
        print "Error in calculation"
        return mpars
    v1,v3=V[0],V[2]
    if calculation_type=='DE-BFL-A':
        Dir,R=vector_mean(fdata)
        mpars["specimen_direction_type"]='l'
        mpars["specimen_dec"]=Dir[0]
        mpars["specimen_inc"]=Dir[1]
        mpars["specimen_n"]=len(fdata)
        mpars["measurement_step_min"]=indata[start0][0]
        mpars["measurement_step_max"]=indata[end0][0]
        mpars["center_of_mass"]=cm
        s1=numpy.sqrt(t[0])
        MAD=numpy.arctan(numpy.sqrt(t[1]+t[2])/s1)/rad
        mpars["specimen_mad"]=MAD # I think this is how it is done - i never anchor the "PCA" - check
        return mpars
    if calculation_type!='DE-BFP':
#
#   get control vector for principal component direction
#
        rec=[datablock[start][1],datablock[start][2],datablock[start][3]]
        P1=dir2cart(rec)
        rec=[datablock[end][1],datablock[end][2],datablock[end][3]]
        P2=dir2cart(rec)
#
#   get right direction along principal component
##
        for k in range(3):
            control.append(P1[k]-P2[k])
        # changed by rshaar
        # control is taken as the center of mass
        #control=cm


        dot = 0
        for k in range(3):
            dot += v1[k]*control[k]
        if dot<-1:dot=-1
        if dot>1:dot=1
        if numpy.arccos(dot) > numpy.pi/2.:
            for k in range(3):
                v1[k]=-v1[k]
#   get right direction along principal component
#
        s1=numpy.sqrt(t[0])
        Dir=cart2dir(v1)
        MAD=numpy.arctan(numpy.sqrt(t[1]+t[2])/s1)/rad
    if calculation_type=="DE-BFP":
        Dir=cart2dir(v3)
        MAD=numpy.arctan(numpy.sqrt(t[2]/t[1]+t[2]/t[0]))/rad
#
#  	get angle with  center of mass
#
    CMdir=cart2dir(cm)
    Dirp=[Dir[0],Dir[1],1.]
    dang=angle(CMdir,Dirp)
    mpars["specimen_dec"]=Dir[0]
    mpars["specimen_inc"]=Dir[1]
    mpars["specimen_mad"]=MAD
    #mpars["specimen_n"]=int(Nrec)
    mpars["specimen_n"]=len(X)
    mpars["specimen_dang"]=dang[0]
    mpars["measurement_step_min"]=indata[start0][0]
    mpars["measurement_step_max"]=indata[end0][0]
    return mpars

def circ(dec,dip,alpha):
    """
    function to calculate points on an circle about dec,dip with angle alpha
    """
    rad=numpy.pi/180.
    D_out,I_out=[],[]
    dec,dip,alpha=dec*rad ,dip*rad,alpha*rad
    dec1=dec+numpy.pi/2.
    isign=1
    if dip!=0: isign=(abs(dip)/dip)
    dip1=(dip-isign*(numpy.pi/2.))
    t=[[0,0,0],[0,0,0],[0,0,0]]
    v=[0,0,0]
    t[0][2]=numpy.cos(dec)*numpy.cos(dip)
    t[1][2]=numpy.sin(dec)*numpy.cos(dip)
    t[2][2]=numpy.sin(dip)
    t[0][1]=numpy.cos(dec)*numpy.cos(dip1)
    t[1][1]=numpy.sin(dec)*numpy.cos(dip1)
    t[2][1]=numpy.sin(dip1)
    t[0][0]=numpy.cos(dec1)
    t[1][0]=numpy.sin(dec1)
    t[2][0]=0
    for i in range(101):
        psi=float(i)*numpy.pi/50.
        v[0]=numpy.sin(alpha)*numpy.cos(psi)
        v[1]=numpy.sin(alpha)*numpy.sin(psi)
        v[2]=numpy.sqrt(abs(1.-v[0]**2 - v[1]**2))
        elli=[0,0,0]
        for j in range(3):
            for k in range(3):
                elli[j]=elli[j] + t[j][k]*v[k]
        Dir=cart2dir(elli)
        D_out.append(Dir[0])
        I_out.append(Dir[1])
    return D_out,I_out

def PintPars(datablock,araiblock,zijdblock,start,end,accept):
    """
     calculate the paleointensity magic parameters  make some definitions
    """
    methcode,ThetaChecks,DeltaChecks,GammaChecks="","","",""
    zptrm_check=[]
    first_Z,first_I,ptrm_check,ptrm_tail,zptrm_check,GammaChecks=araiblock[0],araiblock[1],araiblock[2],araiblock[3],araiblock[4],araiblock[5]
    if len(araiblock)>6:
        ThetaChecks=araiblock[6] # used only for perpendicular method of paleointensity
        DeltaChecks=araiblock[7] # used only for perpendicular  method of paleointensity
    xi,yi,diffcum=[],[],0
    xiz,xzi,yiz,yzi=[],[],[],[]
    Nptrm,dmax=0,-1e-22
# check if even zero and infield steps
    if len(first_Z)>len(first_I):
        maxe=len(first_I)-1
    else: maxe=len(first_Z)-1
    if end==0 or end > maxe:
        end=maxe
# get the MAD, DANG, etc. for directional data
    bstep=araiblock[0][start][0]
    estep=araiblock[0][end][0]
    zstart,zend=0,len(zijdblock)
    for k in range(len(zijdblock)):
        zrec=zijdblock[k]
        if zrec[0]==bstep:zstart=k
        if zrec[0]==estep:zend=k
    PCA=domean(zijdblock,zstart,zend,'DE-BFL')
    D,Diz,Dzi,Du=[],[],[],[]  # list of NRM vectors, and separated by zi and iz
    for rec in zijdblock:
        D.append((rec[1],rec[2],rec[3]))
        Du.append((rec[1],rec[2]))
        if rec[4]==1:
            Dzi.append((rec[1],rec[2]))  # if this is ZI step
        else:
            Diz.append((rec[1],rec[2]))  # if this is IZ step
# calculate the vector difference sum
    vds=dovds(D)
    b_zi,b_iz=[],[]
# collect data included in ZigZag calculation
    if end+1>=len(first_Z):
        stop=end-1
    else:
        stop=end
    for k in range(start,end+1):
       for l in range(len(first_I)):
           irec=first_I[l]
           if irec[0]==first_Z[k][0]:
               xi.append(irec[3])
               yi.append(first_Z[k][3])
    pars,errcode=int_pars(xi,yi,vds)
    if errcode==1:return pars,errcode
#    for k in range(start,end+1):
    for k in range(len(first_Z)-1):
        for l in range(k):
            if first_Z[k][3]/vds>0.1:   # only go down to 10% of NRM.....
               irec=first_I[l]
               if irec[4]==1 and first_I[l+1][4]==0: # a ZI step
                   xzi=irec[3]
                   yzi=first_Z[k][3]
                   xiz=first_I[l+1][3]
                   yiz=first_Z[k+1][3]
                   slope=numpy.arctan2((yzi-yiz),(xiz-xzi))
                   r=numpy.sqrt( (yzi-yiz)**2+(xiz-xzi)**2)
                   if r>.1*vds:b_zi.append(slope) # suppress noise
               elif irec[4]==0 and first_I[l+1][4]==1: # an IZ step
                   xiz=irec[3]
                   yiz=first_Z[k][3]
                   xzi=first_I[l+1][3]
                   yzi=first_Z[k+1][3]
                   slope=numpy.arctan2((yiz-yzi),(xzi-xiz))
                   r=numpy.sqrt( (yiz-yzi)**2+(xzi-xiz)**2)
                   if r>.1*vds:b_iz.append(slope) # suppress noise
#
    ZigZag,Frat,Trat=-1,0,0
    if len(Diz)>2 and len(Dzi)>2:
        ZigZag=0
        dizp=fisher_mean(Diz) # get Fisher stats on IZ steps
        dzip=fisher_mean(Dzi) # get Fisher stats on ZI steps
        dup=fisher_mean(Du) # get Fisher stats on all steps
#
# if directions are TOO well grouped, can get false positive for ftest, so
# angles must be > 3 degrees apart.
#
        if angle([dizp['dec'],dizp['inc']],[dzip['dec'],dzip['inc']])>3.:
            F=(dup['n']-2.)* (dzip['r']+dizp['r']-dup['r'])/(dup['n']-dzip['r']-dizp['r']) # Watson test for common mean
            nf=2.*(dup['n']-2.) # number of degees of freedom
            ftest=fcalc(2,nf)
            Frat=F/ftest
            if Frat>1.:
                ZigZag=Frat # fails zigzag on directions
                methcode="SM-FTEST"
# now do slopes
    if len(b_zi)>2 and len(b_iz)>2:
        bzi_m,bzi_sig=gausspars(b_zi)  # mean, std dev
        biz_m,biz_sig=gausspars(b_iz)
        n_zi=float(len(b_zi))
        n_iz=float(len(b_iz))
        b_diff=abs(bzi_m-biz_m) # difference in means
#
# avoid false positives - set 3 degree slope difference here too
        if b_diff>3*numpy.pi/180.:
            nf=n_zi+n_iz-2.  # degrees of freedom
            svar= ((n_zi-1.)*bzi_sig**2 + (n_iz-1.)*biz_sig**2)/nf
            T=(b_diff)/numpy.sqrt(svar*(1.0/n_zi + 1.0/n_iz)) # student's t
            ttest=tcalc(nf,.05) # t-test at 95% conf.
            Trat=T/ttest
            if Trat>1  and Trat>Frat:
                ZigZag=Trat # fails zigzag on directions
                methcode="SM-TTEST"
    pars["specimen_Z"]=ZigZag
    pars["method_codes"]=methcode
# do drats
    if len(ptrm_check) != 0:
        diffcum,drat_max=0,0
        for prec in ptrm_check:
            step=prec[0]
            endbak=end
            zend=end
            while zend>len(zijdblock)-1:
               zend=zend-2  # don't count alteration that happens after this step
            if step <zijdblock[zend][0]:
                Nptrm+=1
                for irec in first_I:
                    if irec[0]==step:break
                diffcum+=prec[3]-irec[3]
                if abs(prec[3]-irec[3])>drat_max:drat_max=abs(prec[3]-irec[3])
        pars["specimen_drats"]=(100*abs(diffcum)/first_I[zend][3])
        pars["specimen_drat"]=(100*abs(drat_max)/first_I[zend][3])
    elif len(zptrm_check) != 0:
        diffcum=0
        for prec in zptrm_check:
            step=prec[0]
            endbak=end
            zend=end
            while zend>len(zijdblock)-1:
               zend=zend-1
            if step <zijdblock[zend][0]:
                Nptrm+=1
                for irec in first_I:
                    if irec[0]==step:break
                diffcum+=prec[3]-irec[3]
        pars["specimen_drats"]=(100*abs(diffcum)/first_I[zend][3])
    else:
        pars["specimen_drats"]=-1
        pars["specimen_drat"]=-1
# and the pTRM tails
    if len(ptrm_tail) != 0:
        for trec in ptrm_tail:
            step=trec[0]
            for irec in first_I:
                if irec[0]==step:break
            if abs(trec[3]) >dmax:dmax=abs(trec[3])
        pars["specimen_md"]=(100*dmax/vds)
    else: pars["specimen_md"]=-1
    pars["measurement_step_min"]=bstep
    pars["measurement_step_max"]=estep
    pars["specimen_dec"]=PCA["specimen_dec"]
    pars["specimen_inc"]=PCA["specimen_inc"]
    pars["specimen_int_mad"]=PCA["specimen_mad"]
    pars["specimen_int_dang"]=PCA["specimen_dang"]
    #pars["specimen_int_ptrm_n"]=len(ptrm_check) # this is WRONG!
    pars["specimen_int_ptrm_n"]=Nptrm
# and the ThetaChecks
    if ThetaChecks!="":
        t=0
        for theta in ThetaChecks:
            if theta[0]>=bstep and theta[0]<=estep and theta[1]>t:t=theta[1]
        pars['specimen_theta']=t
    else:
        pars['specimen_theta']=-1
# and the DeltaChecks
    if DeltaChecks!="":
        d=0
        for delta in DeltaChecks:
            if delta[0]>=bstep and delta[0]<=estep and delta[1]>d:d=delta[1]
        pars['specimen_delta']=d
    else:
        pars['specimen_delta']=-1
    pars['specimen_gamma']=-1
    if GammaChecks!="":
        for gamma in GammaChecks:
            if gamma[0]<=estep: pars['specimen_gamma']=gamma[1]


    #--------------------------------------------------------------
    # From here added By Ron Shaar 11-Dec 2012
    # New parameters defined in Shaar and Tauxe (2012):
    # FRAC (specimen_frac) - ranges from 0. to 1.
    # SCAT (specimen_scat) - takes 1/0
    # gap_max (specimen_gmax) - ranges from 0. to 1.
    #--------------------------------------------------------------

    #--------------------------------------------------------------
    # FRAC is similar to Fvds, but the numerator is the vds fraction:
    # FRAC= [ vds (start,end)] / total vds ]
    # gap_max= max [ (vector difference) /  vds (start,end)]
    #--------------------------------------------------------------

    # collect all zijderveld data to arrays and calculate VDS

    z_temperatures=[row[0] for row in zijdblock]
    zdata=[]                # array of zero-fields measurements in Cartezian coordinates
    vector_diffs=[]         # array of vector differences (for vds calculation)
    NRM=zijdblock[0][3]     # NRM

    for k in range(len(zijdblock)):
        DIR=[zijdblock[k][1],zijdblock[k][2],zijdblock[k][3]/NRM]
        cart=dir2cart(DIR)
        zdata.append(array([cart[0],cart[1],cart[2]]))
        if k>0:
            vector_diffs.append(sqrt(sum((array(zdata[-2])-array(zdata[-1]))**2)))
    vector_diffs.append(sqrt(sum(array(zdata[-1])**2))) # last vector differnce: from the last point to the origin.
    vds=sum(vector_diffs)  # vds calculation
    zdata=array(zdata)
    vector_diffs=array(vector_diffs)

    # calculate the vds within the chosen segment
    vector_diffs_segment=vector_diffs[zstart:zend]
    # FRAC calculation
    FRAC=sum(vector_diffs_segment)/vds
    pars['specimen_frac']=FRAC

    # gap_max calculation
    max_FRAC_gap=max(vector_diffs_segment/sum(vector_diffs_segment))
    pars['specimen_gmax']=max_FRAC_gap


    #---------------------------------------------------------------------
    # Calculate the "scat box"
    # all data-points, pTRM checks, and tail-checks, should be inside a "scat box"
    #---------------------------------------------------------------------

    # intialization
    pars["fail_arai_beta_box_scatter"]=False # fail scat due to arai plot data points
    pars["fail_ptrm_beta_box_scatter"]=False # fail scat due to pTRM checks
    pars["fail_tail_beta_box_scatter"]=False # fail scat due to tail checks
    pars["specimen_scat"]="1" # Pass by default

    #--------------------------------------------------------------
    # collect all Arai plot data points in arrays

    x_Arai,y_Arai,t_Arai,steps_Arai=[],[],[],[]
    NRMs=araiblock[0]
    PTRMs=araiblock[1]
    ptrm_checks = araiblock[2]
    ptrm_tail = araiblock[3]

    PTRMs_temperatures=[row[0] for row in PTRMs]
    NRMs_temperatures=[row[0] for row in NRMs]
    NRM=NRMs[0][3]

    for k in range(len(NRMs)):
      index_pTRMs=PTRMs_temperatures.index(NRMs[k][0])
      x_Arai.append(PTRMs[index_pTRMs][3]/NRM)
      y_Arai.append(NRMs[k][3]/NRM)
      t_Arai.append(NRMs[k][0])
      if NRMs[k][4]==1:
        steps_Arai.append('ZI')
      else:
        steps_Arai.append('IZ')
    x_Arai=array(x_Arai)
    y_Arai=array(y_Arai)

    #--------------------------------------------------------------
    # collect all pTRM check to arrays

    x_ptrm_check,y_ptrm_check,ptrm_checks_temperatures,=[],[],[]
    x_ptrm_check_starting_point,y_ptrm_check_starting_point,ptrm_checks_starting_temperatures=[],[],[]

    for k in range(len(ptrm_checks)):
      if ptrm_checks[k][0] in NRMs_temperatures:
        # find the starting point of the pTRM check:
        for i in range(len(datablock)):
            rec=datablock[i]
            if "LT-PTRM-I" in rec['magic_method_codes'] and float(rec['treatment_temp'])==ptrm_checks[k][0]:
                starting_temperature=(float(datablock[i-1]['treatment_temp']))
                try:
                    index=t_Arai.index(starting_temperature)
                    x_ptrm_check_starting_point.append(x_Arai[index])
                    y_ptrm_check_starting_point.append(y_Arai[index])
                    ptrm_checks_starting_temperatures.append(starting_temperature)

                    index_zerofield=zerofield_temperatures.index(ptrm_checks[k][0])
                    x_ptrm_check.append(ptrm_checks[k][3]/NRM)
                    y_ptrm_check.append(zerofields[index_zerofield][3]/NRM)
                    ptrm_checks_temperatures.append(ptrm_checks[k][0])

                    break
                except:
                    pass

    x_ptrm_check_starting_point=array(x_ptrm_check_starting_point)
    y_ptrm_check_starting_point=array(y_ptrm_check_starting_point)
    ptrm_checks_starting_temperatures=array(ptrm_checks_starting_temperatures)
    x_ptrm_check=array(x_ptrm_check)
    y_ptrm_check=array(y_ptrm_check)
    ptrm_checks_temperatures=array(ptrm_checks_temperatures)

    #--------------------------------------------------------------
    # collect tail checks to arrays

    x_tail_check,y_tail_check,tail_check_temperatures=[],[],[]
    x_tail_check_starting_point,y_tail_check_starting_point,tail_checks_starting_temperatures=[],[],[]

    for k in range(len(ptrm_tail)):
      if ptrm_tail[k][0] in NRMs_temperatures:

        # find the starting point of the pTRM check:
        for i in range(len(datablock)):
            rec=datablock[i]
            if "LT-PTRM-MD" in rec['magic_method_codes'] and float(rec['treatment_temp'])==ptrm_tail[k][0]:
                starting_temperature=(float(datablock[i-1]['treatment_temp']))
                try:

                    index=t_Arai.index(starting_temperature)
                    x_tail_check_starting_point.append(x_Arai[index])
                    y_tail_check_starting_point.append(y_Arai[index])
                    tail_checks_starting_temperatures.append(starting_temperature)

                    index_infield=infield_temperatures.index(ptrm_tail[k][0])
                    x_tail_check.append(infields[index_infield][3]/NRM)
                    y_tail_check.append(ptrm_tail[k][3]/NRM + zerofields[index_infield][3]/NRM)
                    tail_check_temperatures.append(ptrm_tail[k][0])

                    break
                except:
                    pass

    x_tail_check=array(x_tail_check)
    y_tail_check=array(y_tail_check)
    tail_check_temperatures=array(tail_check_temperatures)
    x_tail_check_starting_point=array(x_tail_check_starting_point)
    y_tail_check_starting_point=array(y_tail_check_starting_point)
    tail_checks_starting_temperatures=array(tail_checks_starting_temperatures)


    #--------------------------------------------------------------
    # collect the chosen segment in the Arai plot to arraya

    x_Arai_segment= x_Arai[start:end+1] # chosen segent in the Arai plot
    y_Arai_segment= y_Arai[start:end+1] # chosen segent in the Arai plot

    #--------------------------------------------------------------
    # collect pTRM checks in segment to arrays
    # notice, this is different than the conventional DRATS.
    # for scat calculation we take only the pTRM checks which were carried out
    # before reaching the highest temperature in the chosen segment

    x_ptrm_check_for_SCAT,y_ptrm_check_for_SCAT=[],[]
    for k in range(len(ptrm_checks_temperatures)):
      if ptrm_checks_temperatures[k] >= pars["measurement_step_min"] and ptrm_checks_starting_temperatures <= pars["measurement_step_max"] :
            x_ptrm_check_for_SCAT.append(x_ptrm_check[k])
            y_ptrm_check_for_SCAT.append(y_ptrm_check[k])

    x_ptrm_check_for_SCAT=array(x_ptrm_check_for_SCAT)
    y_ptrm_check_for_SCAT=array(y_ptrm_check_for_SCAT)

    #--------------------------------------------------------------
    # collect Tail checks in segment to arrays
    # for scat calculation we take only the tail checks which were carried out
    # before reaching the highest temperature in the chosen segment

    x_tail_check_for_SCAT,y_tail_check_for_SCAT=[],[]

    for k in range(len(tail_check_temperatures)):
      if tail_check_temperatures[k] >= pars["measurement_step_min"] and tail_checks_starting_temperatures[k] <= pars["measurement_step_max"] :
            x_tail_check_for_SCAT.append(x_tail_check[k])
            y_tail_check_for_SCAT.append(y_tail_check[k])


    x_tail_check_for_SCAT=array(x_tail_check_for_SCAT)
    y_tail_check_for_SCAT=array(y_tail_check_for_SCAT)

    #--------------------------------------------------------------
    # calculate the lines that define the scat box:

    # if threshold value for beta is not defined, then scat cannot be calculated (pass)
    # in this case, scat pass
    if 'specimen_b_beta' in accept.keys() and accept['specimen_b_beta']!="":
        b_beta_threshold=float(accept['specimen_b_beta'])
        b=pars['specimen_b']             # best fit line
        cm_x=mean(array(x_Arai_segment)) # x center of mass
        cm_y=mean(array(y_Arai_segment)) # y center of mass
        a=cm_y-b*cm_x

        # lines with slope = slope +/- 2*(specimen_b_beta)

        two_sigma_beta_threshold=2*b_beta_threshold
        two_sigma_slope_threshold=abs(two_sigma_beta_threshold*b)

        # a line with a  shallower  slope  (b + 2*beta*b) passing through the center of mass
        # y=a1+b1x
        b1=b+two_sigma_slope_threshold
        a1=cm_y-b1*cm_x

        # bounding line with steeper  slope (b - 2*beta*b) passing through the center of mass
        # y=a2+b2x
        b2=b-two_sigma_slope_threshold
        a2=cm_y-b2*cm_x

        # lower bounding line of the 'beta box'
        # y=intercept1+slop1x
        slop1=a1/((a2/b2))
        intercept1=a1

        # higher bounding line of the 'beta box'
        # y=intercept2+slop2x

        slop2=a2/((a1/b1))
        intercept2=a2

        pars['specimen_scat_bounding_line_high']=[intercept2,slop2]
        pars['specimen_scat_bounding_line_low']=[intercept1,slop1]

        #--------------------------------------------------------------
        # check if the Arai data points are in the 'box'

        # the two bounding lines
        ymin=intercept1+x_Arai_segment*slop1
        ymax=intercept2+x_Arai_segment*slop2

        # arrays of "True" or "False"
        check_1=y_Arai_segment>ymax
        check_2=y_Arai_segment<ymin

        # check if at least one "True"
        if (sum(check_1)+sum(check_2))>0:
         pars["fail_arai_beta_box_scatter"]=True

        #--------------------------------------------------------------
        # check if the pTRM checks data points are in the 'box'

        if len(x_ptrm_check_for_SCAT) > 0:

          # the two bounding lines
          ymin=intercept1+x_ptrm_check_for_SCAT*slop1
          ymax=intercept2+x_ptrm_check_for_SCAT*slop2

          # arrays of "True" or "False"
          check_1=y_ptrm_check_for_SCAT>ymax
          check_2=y_ptrm_check_for_SCAT<ymin


          # check if at least one "True"
          if (sum(check_1)+sum(check_2))>0:
            pars["fail_ptrm_beta_box_scatter"]=True

        #--------------------------------------------------------------
        # check if the tail checks data points are in the 'box'


        if len(x_tail_check_for_SCAT) > 0:

          # the two bounding lines
          ymin=intercept1+x_tail_check_for_SCAT*slop1
          ymax=intercept2+x_tail_check_for_SCAT*slop2

          # arrays of "True" or "False"
          check_1=y_tail_check_for_SCAT>ymax
          check_2=y_tail_check_for_SCAT<ymin


          # check if at least one "True"
          if (sum(check_1)+sum(check_2))>0:
            pars["fail_tail_beta_box_scatter"]=True

        #--------------------------------------------------------------
        # check if specimen_scat is PASS or FAIL:

        if pars["fail_tail_beta_box_scatter"] or pars["fail_ptrm_beta_box_scatter"] or pars["fail_arai_beta_box_scatter"]:
              pars["specimen_scat"]='0'
        else:
              pars["specimen_scat"]='1'

    return pars,0

def getkeys(table):
    """
    customize by commenting out unwanted keys
    """
    keys=[]
    if table=="ER_expedition":
        pass
    if table=="ER_citations":
        keys.append("er_citation_name")
        keys.append("long_authors")
        keys.append("year")
        keys.append("title")
        keys.append("citation_type")
        keys.append("doi")
        keys.append("journal")
        keys.append("volume")
        keys.append("pages")
        keys.append("book_title")
        keys.append("book_editors")
        keys.append("publisher")
        keys.append("city")
    if table=="ER_locations":
        keys.append("er_location_name")
        keys.append("er_scientist_mail_names" )
#        keys.append("er_location_alternatives" )
        keys.append("location_type" )
        keys.append("location_begin_lat")
        keys.append("location_begin_lon" )
#        keys.append("location_begin_elevation" )
        keys.append("location_end_lat" )
        keys.append("location_end_lon" )
#        keys.append("location_end_elevation" )
        keys.append("continent_ocean" )
        keys.append("country" )
        keys.append("region" )
        keys.append("plate_block" )
        keys.append("terrane" )
        keys.append("tectonic_setting" )
#        keys.append("er_citation_names")
    if table=="ER_Formations":
        keys.append("er_formation_name")
        keys.append("formation_class")
        keys.append("formation_lithology")
        keys.append("formation_paleo_environment")
        keys.append("formation_thickness")
        keys.append("formation_description")
    if table=="ER_sections":
        keys.append("er_section_name")
        keys.append("er_section_alternatives")
        keys.append("er_expedition_name")
        keys.append("er_location_name")
        keys.append("er_formation_name")
        keys.append("er_member_name")
        keys.append("section_definition")
        keys.append("section_class")
        keys.append("section_lithology")
        keys.append("section_type")
        keys.append("section_n")
        keys.append("section_begin_lat")
        keys.append("section_begin_lon")
        keys.append("section_begin_elevation")
        keys.append("section_begin_height")
        keys.append("section_begin_drill_depth")
        keys.append("section_begin_composite_depth")
        keys.append("section_end_lat")
        keys.append("section_end_lon")
        keys.append("section_end_elevation")
        keys.append("section_end_height")
        keys.append("section_end_drill_depth")
        keys.append("section_end_composite_depth")
        keys.append("section_azimuth")
        keys.append("section_dip")
        keys.append("section_description")
        keys.append("er_scientist_mail_names")
        keys.append("er_citation_names")
    if table=="ER_sites":
        keys.append("er_location_name")
        keys.append("er_site_name")
#        keys.append("er_site_alternatives")
#        keys.append("er_formation_name")
#        keys.append("er_member_name")
#        keys.append("er_section_name")
        keys.append("er_scientist_mail_names")
        keys.append("site_class")
#        keys.append("site_type")
#        keys.append("site_lithology")
#        keys.append("site_height")
#        keys.append("site_drill_depth")
#        keys.append("site_composite_depth")
#        keys.append("site_lithology")
#        keys.append("site_description")
        keys.append("site_lat")
        keys.append("site_lon")
#        keys.append("site_location_precision")
#        keys.append("site_elevation")
    if table == "ER_samples" :
        keys.append("er_location_name")
        keys.append("er_site_name")
#       keys.append("er_sample_alternatives")
        keys.append("sample_azimuth")
        keys.append("sample_dip")
        keys.append("sample_bed_dip")
        keys.append("sample_bed_dip_direction")
#       keys.append("sample_cooling_rate")
#       keys.append("sample_type")
#       keys.append("sample_lat")
#       keys.append("sample_lon")
        keys.append("magic_method_codes")
    if table == "ER_ages" :
#       keys.append("er_location_name")
#       keys.append("er_site_name")
#       keys.append("er_section_name")
#       keys.append("er_formation_name")
#       keys.append("er_member_name")
#       keys.append("er_site_name")
#       keys.append("er_sample_name")
#       keys.append("er_specimen_name")
#       keys.append("er_fossil_name")
#       keys.append("er_mineral_name")
#       keys.append("tiepoint_name")
        keys.append("age")
        keys.append("age_sigma")
        keys.append("age_unit")
        keys.append("age_range_low")
        keys.append("age_range_hi")
        keys.append("timescale_eon")
        keys.append("timescale_era")
        keys.append("timescale_period")
        keys.append("timescale_epoch")
        keys.append("timescale_stage")
        keys.append("biostrat_zone")
        keys.append("conodont_zone")
        keys.append("magnetic_reversal_chron")
        keys.append("astronomical_stage")
#       keys.append("age_description")
#       keys.append("magic_method_codes")
#       keys.append("er_timescale_citation_names")
#       keys.append("er_citation_names")
    if table == "MAGIC_measurements" :
        keys.append("er_location_name")
        keys.append("er_site_name")
        keys.append("er_sample_name")
        keys.append("er_specimen_name")
        keys.append("measurement_positions")
        keys.append("treatment_temp")
        keys.append("treatment_ac_field")
        keys.append("treatment_dc_field")
        keys.append("treatment_dc_field_phi")
        keys.append("treatment_dc_field_theta")
        keys.append("magic_experiment_name")
        keys.append("magic_instrument_codes")
        keys.append("measurement_temp")
        keys.append("magic_method_codes")
        keys.append("measurement_inc")
        keys.append("measurement_dec")
        keys.append("measurement_magn_moment")
        keys.append("measurement_csd")
    return  keys

def getnames():
    """
    get mail names
    """
    namestring=""
    addmore=1
    while addmore:
        scientist=raw_input("Enter  name  - <Return> when done ")
        if scientist != "":
            namestring=namestring+":"+scientist
        else:
            namestring=namestring[1:]
            addmore=0
    return namestring

def magic_help(keyhelp):
    """
    returns a help message for a give magic key
    """
    helpme={}
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_location_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["location_type"]=	"Location type"
    helpme["location_begin_lat"]=	"Begin of section or core or outcrop -- latitude"
    helpme["location_begin_lon"]=	"Begin of section or core or outcrop -- longitude"
    helpme["location_begin_elevation"]=	"Begin of section or core or outcrop -- elevation relative to sealevel"
    helpme["location_end_lat"]=	"Ending of section or core -- latitude "
    helpme["location_end_lon"]=	"Ending of section or core -- longitude "
    helpme["location_end_elevation"]=	"Ending of section or core -- elevation relative to sealevel"
    helpme["location_geoid"]=	"Geoid used in determination of latitude and longitude:  WGS84, GEOID03, USGG2003, GEOID99, G99SSS , G99BM, DEFLEC99 "
    helpme["continent_ocean"]=	"Name for continent or ocean island region"
    helpme["ocean_sea"]=	"Name for location in an ocean or sea"
    helpme["country"]=	"Country name"
    helpme["region"]=	"Region name"
    helpme["plate_block"]=	"Plate or tectonic block name"
    helpme["terrane"]=	"Terrane name"
    helpme["tectonic_setting"]=	"Tectonic setting"
    helpme["location_description"]=	"Detailed description"
    helpme["location_url"]=	"Website URL for the location explicitly"
    helpme["er_scientist_mail_names"]=	"Colon-delimited list of names for scientists who described location"
    helpme["er_citation_names"]=	"Colon-delimited list of citations"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_formation_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["formation_class"]=	"General lithology class: igneous, metamorphic or sedimentary"
    helpme["formation_lithology"]=	"Lithology: e.g., basalt, sandstone, etc."
    helpme["formation_paleo_enviroment"]=	"Depositional environment"
    helpme["formation_thickness"]=	"Formation thickness"
    helpme["er_member_name"]=	"Name for member"
    helpme["er_member_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["member_class"]=	"General lithology type"
    helpme["member_lithology"]=	"Lithology"
    helpme["member_paleo_environment"]=	"Depositional environment"
    helpme["member_thickness"]=	"Member thickness"
    helpme["member_description"]=	"Detailed description"
    helpme["er_section_name"]=	"Name for section or core"
    helpme["er_section_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["er_expedition_name"]=	"Name for seagoing or land expedition"
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_member_name"]=	"Name for member"
    helpme["section_definition"]=	"General definition of section"
    helpme["section_class"]=	"General lithology type"
    helpme["section_lithology"]=	"Section lithology or archeological classification"
    helpme["section_type"]=	"Section type"
    helpme["section_n"]=	"Number of subsections included composite (stacked) section"
    helpme["section_begin_lat"]=	"Begin of section or core -- latitude"
    helpme["section_begin_lon"]=	"Begin of section or core -- longitude"
    helpme["section_begin_elevation"]=	"Begin of section or core -- elevation relative to sealevel"
    helpme["section_begin_height"]=	"Begin of section or core -- stratigraphic height"
    helpme["section_begin_drill_depth"]=	"Begin of section or core -- depth in MBSF as used by ODP"
    helpme["section_begin_composite_depth"]=	"Begin of section or core -- composite depth in MBSF as used by ODP"
    helpme["section_end_lat"]=	"End of section or core -- latitude "
    helpme["section_end_lon"]=	"End of section or core -- longitude "
    helpme["section_end_elevation"]=	"End of section or core -- elevation relative to sealevel"
    helpme["section_end_height"]=	"End of section or core -- stratigraphic height"
    helpme["section_end_drill_depth"]=	"End of section or core -- depth in MBSF as used by ODP"
    helpme["section_end_composite_depth"]=	"End of section or core -- composite depth in MBSF as used by ODP"
    helpme["section_azimuth"]=	"Section azimuth as measured clockwise from the north"
    helpme["section_dip"]=	"Section dip as measured into the outcrop"
    helpme["section_description"]=	"Detailed description"
    helpme["er_site_name"]=	"Name for site"
    helpme["er_site_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["er_expedition_name"]=	"Name for seagoing or land expedition"
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_section_name"]=	"Name for section or core"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_member_name"]=	"Name for member"
    helpme["site_definition"]=	"General definition of site"
    helpme["site_class"]=	"[A]rchaeologic,[E]xtrusive,[I]ntrusive,[M]etamorphic,[S]edimentary"
    helpme["site_lithology"]=	"Site lithology or archeological classification"
    helpme["site_type"]=	"Site type: slag, lava flow, sediment layer, etc."
    helpme["site_lat"]=	"Site location -- latitude"
    helpme["site_lon"]=	"Site location -- longitude"
    helpme["site_location_precision"]=	"Site location -- precision in latitude and longitude"
    helpme["site_elevation"]=	"Site location -- elevation relative to sealevel"
    helpme["site_height"]=	"Site location -- stratigraphic height"
    helpme["site_drill_depth"]=	"Site location -- depth in MBSF as used by ODP"
    helpme["site_composite_depth"]=	"Site location -- composite depth in MBSF as used by ODP"
    helpme["site_description"]=	"Detailed description"
    helpme["magic_method_codes"]=	"Colon-delimited list of method codes"
    helpme["er_sample_name"]=	"Name for sample"
    helpme["er_sample_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["er_expedition_name"]=	"Name for seagoing or land expedition"
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_section_name"]=	"Name for section or core"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_member_name"]=	"Name for member"
    helpme["er_site_name"]=	"Name for site"
    helpme["sample_class"]=	"General lithology type"
    helpme["sample_lithology"]=	"Sample lithology or archeological classification"
    helpme["sample_type"]=	"Sample type"
    helpme["sample_texture"]=	"Sample texture"
    helpme["sample_alteration"]=	"Sample alteration grade"
    helpme["sample_alteration_type"]=	"Sample alteration type"
    helpme["sample_lat"]=	"Sample location -- latitude"
    helpme["sample_lon"]=	"Sample location -- longitude"
    helpme["sample_location_precision"]=	"Sample location -- precision in latitude and longitude"
    helpme["sample_elevation"]=	"Sample location -- elevation relative to sealevel"
    helpme["sample_height"]=	"Sample location -- stratigraphic height"
    helpme["sample_drill_depth"]=	"Sample location -- depth in MBSF as used by ODP"
    helpme["sample_composite_depth"]=	"Sample location -- composite depth in MBSF as used by ODP"
    helpme["sample_date"]=	"Sampling date"
    helpme["sample_time_zone"]=	"Sampling time zone"
    helpme["sample_azimuth"]=	"Sample azimuth as measured clockwise from the north"
    helpme["sample_dip"]=	"Sample dip as measured into the outcrop"
    helpme["sample_bed_dip_direction"]=	"Direction of the dip of a paleo-horizontal plane in the bedding"
    helpme["sample_bed_dip"]=	"Dip of the bedding as measured to the right of strike direction"
    helpme["sample_cooling_rate"]=	"Estimated ancient in-situ cooling rate per Ma"
    helpme["er_specimen_name"]=	"Name for specimen"
    helpme["er_specimen_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["er_expedition_name"]=	"Name for seagoing or land expedition"
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_section_name"]=	"Name for section or core"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_member_name"]=	"Name for member"
    helpme["er_site_name"]=	"Name for site"
    helpme["er_sample_name"]=	"Name for sample"
    helpme["specimen_class"]=	"General lithology type"
    helpme["specimen_lithology"]=	"Specimen lithology or archeological classification"
    helpme["specimen_type"]=	"Specimen type"
    helpme["specimen_texture"]=	"Specimen texture"
    helpme["specimen_alteration"]=	"Specimen alteration grade"
    helpme["specimen_alteration_type"]=	"Specimen alteration type"
    helpme["specimen_elevation"]=	"Specimen location -- elevation relative to sealevel"
    helpme["specimen_height"]=	"Specimen location -- stratigraphic height"
    helpme["specimen_drill_depth"]=	"Specimen location -- depth in MBSF as used by ODP"
    helpme["specimen_composite_depth"]=	"Specimen location -- composite depth in MBSF as used by ODP"
    helpme["specimen_azimuth"]=	"Specimen azimuth as measured clockwise from the north"
    helpme["specimen_dip"]=	"Specimen dip as measured into the outcrop"
    helpme["specimen_volume"]=	"Specimen volume"
    helpme["specimen_weight"]=	"Specimen weight"
    helpme["specimen_density"]=	"Specimen density"
    helpme["specimen_size"]=	"Specimen grain size fraction"
    helpme["er_expedition_name"]=	"Name for seagoing or land expedition"
    helpme["er_location_name"]=	"Name for location or drill site"
    helpme["er_formation_name"]=	"Name for formation"
    helpme["er_member_name"]=	"Name for member"
    helpme["er_site_name"]=	"Name for site"
    helpme["er_sample_name"]=	"Name for sample"
    helpme["er_specimen_name"]=	"Name for specimen"
    helpme["er_fossil_name"]=	"Name for fossil"
    helpme["er_mineral_name"]=	"Name for mineral"
    helpme["GM-ALPHA"]=	"Age determination by using alpha counting"
    helpme["GM-ARAR"]=	"40Ar/39Ar age determination"
    helpme["GM-ARAR-AP"]=	"40Ar/39Ar age determination: Age plateau"
    helpme["GM-ARAR-II"]=	"40Ar/39Ar age determination: Inverse isochron"
    helpme["GM-ARAR-NI"]=	"40Ar/39Ar age determination: Normal isochron"
    helpme["GM-ARAR-TF"]=	"40Ar/39Ar age determination: Total fusion or recombined age"
    helpme["GM-C14"]=	"Radiocarbon age determination"
    helpme["GM-C14-AMS"]=	"Radiocarbon age determination: AMS"
    helpme["GM-C14-BETA"]=	"Radiocarbon age determination: Beta decay counting"
    helpme["GM-C14-CAL"]=	"Radiocarbon age determination: Calibrated"
    helpme["GM-CC"]=	"Correlation chronology"
    helpme["GM-CC-ARCH"]=	"Correlation chronology: Archeology"
    helpme["GM-CC-ARM"]=	"Correlation chronology: ARM"
    helpme["GM-CC-ASTRO"]=	"Correlation chronology: Astronomical"
    helpme["GM-CC-CACO3"]=	"Correlation chronology: Calcium carbonate"
    helpme["GM-CC-COLOR"]=	"Correlation chronology: Color or reflectance"
    helpme["GM-CC-GRAPE"]=	"Correlation chronology: Gamma Ray Polarimeter Experiment"
    helpme["GM-CC-IRM"]=	"Correlation chronology: IRM"
    helpme["GM-CC-ISO"]=	"Correlation chronology: Stable isotopes"
    helpme["GM-CC-REL"]=	"Correlation chronology: Relative chronology other than stratigraphic successions"
    helpme["GM-CC-STRAT"]=	"Correlation chronology: Stratigraphic succession"
    helpme["GM-CC-TECT"]=	"Correlation chronology: Tectites and microtectites"
    helpme["GM-CC-TEPH"]=	"Correlation chronology: Tephrochronology"
    helpme["GM-CC-X"]=	"Correlation chronology: Susceptibility"
    helpme["GM-CHEM"]=	"Chemical chronology"
    helpme["GM-CHEM-AAR"]=	"Chemical chronology: Amino acid racemization"
    helpme["GM-CHEM-OH"]=	"Chemical chronology: Obsidian hydration"
    helpme["GM-CHEM-SC"]=	"Chemical chronology: Stoan coatings CaCO3"
    helpme["GM-CHEM-TH"]=	"Chemical chronology: Tephra hydration"
    helpme["GM-COSMO"]=	"Cosmogenic age determination"
    helpme["GM-COSMO-AL26"]=	"Cosmogenic age determination: 26Al"
    helpme["GM-COSMO-AR39"]=	"Cosmogenic age determination: 39Ar"
    helpme["GM-COSMO-BE10"]=	"Cosmogenic age determination: 10Be"
    helpme["GM-COSMO-C14"]=	"Cosmogenic age determination: 14C"
    helpme["GM-COSMO-CL36"]=	"Cosmogenic age determination: 36Cl"
    helpme["GM-COSMO-HE3"]=	"Cosmogenic age determination: 3He"
    helpme["GM-COSMO-KR81"]=	"Cosmogenic age determination: 81Kr"
    helpme["GM-COSMO-NE21"]=	"Cosmogenic age determination: 21Ne"
    helpme["GM-COSMO-NI59"]=	"Cosmogenic age determination: 59Ni"
    helpme["GM-COSMO-SI32"]=	"Cosmogenic age determination: 32Si"
    helpme["GM-DENDRO"]=	"Dendrochronology"
    helpme["GM-ESR"]=	"Electron Spin Resonance"
    helpme["GM-FOSSIL"]=	"Age determined from fossil record"
    helpme["GM-FT"]=	"Fission track age determination"
    helpme["GM-HIST"]=	"Historically recorded geological event"
    helpme["GM-INT"]=	"Age determination through interpolation between at least two geological units of known age"
    helpme["GM-INT-L"]=	"Age determination through interpolation between at least two geological units of known age: Linear"
    helpme["GM-INT-S"]=	"Age determination through interpolation between at least two geological units of known age: Cubic spline"
    helpme["GM-ISO"]=	"Age determined by isotopic dating, but no further details available"
    helpme["GM-KAR"]=	"40K-40Ar age determination"
    helpme["GM-KAR-I"]=	"40K-40Ar age determination: Isochron"
    helpme["GM-KAR-MA"]=	"40K-40Ar age determination: Model age"
    helpme["GM-KCA"]=	"40K-40Ca age determination"
    helpme["GM-KCA-I"]=	"40K-40Ca age determination: Isochron"
    helpme["GM-KCA-MA"]=	"40K-40Ca age determination: Model age"
    helpme["GM-LABA"]=	"138La-138Ba age determination"
    helpme["GM-LABA-I"]=	"138La-138Ba age determination: Isochron"
    helpme["GM-LABA-MA"]=	"138La-138Ba age determination: Model age"
    helpme["GM-LACE"]=	"138La-138Ce age determination"
    helpme["GM-LACE-I"]=	"138La-138Ce age determination: Isochron"
    helpme["GM-LACE-MA"]=	"138La-138Ce age determination: Model age"
    helpme["GM-LICHE"]=	"Lichenometry"
    helpme["GM-LUHF"]=	"176Lu-176Hf age determination"
    helpme["GM-LUHF-I"]=	"176Lu-176Hf age determination: Isochron"
    helpme["GM-LUHF-MA"]=	"176Lu-176Hf age determination: Model age"
    helpme["GM-LUM"]=	"Luminescence"
    helpme["GM-LUM-IRS"]=	"Luminescence: Infrared stimulated luminescence"
    helpme["GM-LUM-OS"]=	"Luminescence: Optically stimulated luminescence"
    helpme["GM-LUM-TH"]=	"Luminescence: Thermoluminescence"
    helpme["GM-MOD"]=	"Model curve fit to available age dates"
    helpme["GM-MOD-L"]=	"Model curve fit to available age dates: Linear"
    helpme["GM-MOD-S"]=	"Model curve fit to available age dates: Cubic spline"
    helpme["GM-MORPH"]=	"Geomorphic chronology"
    helpme["GM-MORPH-DEF"]=	"Geomorphic chronology: Rate of deformation"
    helpme["GM-MORPH-DEP"]=	"Geomorphic chronology: Rate of deposition"
    helpme["GM-MORPH-POS"]=	"Geomorphic chronology: Geomorphology position"
    helpme["GM-MORPH-WEATH"]=	"Geomorphic chronology: Rock and mineral weathering"
    helpme["GM-NO"]=	"Unknown geochronology method"
    helpme["GM-O18"]=	"Oxygen isotope dating"
    helpme["GM-PBPB"]=	"207Pb-206Pb age determination"
    helpme["GM-PBPB-C"]=	"207Pb-206Pb age determination: Common Pb"
    helpme["GM-PBPB-I"]=	"207Pb-206Pb age determination: Isochron"
    helpme["GM-PLEO"]=	"Pleochroic haloes"
    helpme["GM-PMAG-ANOM"]=	"Paleomagnetic age determination: Magnetic anomaly identification"
    helpme["GM-PMAG-APWP"]=	"Paleomagnetic age determination: Comparing paleomagnetic data to APWP"
    helpme["GM-PMAG-ARCH"]=	"Paleomagnetic age determination: Archeomagnetism"
    helpme["GM-PMAG-DIR"]=	"Paleomagnetic age determination: Directions"
    helpme["GM-PMAG-POL"]=	"Paleomagnetic age determination: Polarities"
    helpme["GM-PMAG-REGSV"]=	"Paleomagnetic age determination: Correlation to a regional secular variation curve"
    helpme["GM-PMAG-RPI"]=	"Paleomagnetic age determination: Relative paleointensity"
    helpme["GM-PMAG-VEC"]=	"Paleomagnetic age determination: Full vector"
    helpme["GM-RATH"]=	"226Ra-230Th age determination"
    helpme["GM-RBSR"]=	"87Rb-87Sr age determination"
    helpme["GM-RBSR-I"]=	"87Rb-87Sr age determination: Isochron"
    helpme["GM-RBSR-MA"]=	"87Rb-87Sr age determination: Model age"
    helpme["GM-REOS"]=	"187Re-187Os age determination"
    helpme["GM-REOS-I"]=	"187Re-187Os age determination: Isochron"
    helpme["GM-REOS-MA"]=	"187Re-187Os age determination: Model age"
    helpme["GM-REOS-PT"]=	"187Re-187Os age determination: Pt normalization of 186Os"
    helpme["GM-SCLERO"]=	"Screlochronology"
    helpme["GM-SHRIMP"]=	"SHRIMP age dating"
    helpme["GM-SMND"]=	"147Sm-143Nd age determination"
    helpme["GM-SMND-I"]=	"147Sm-143Nd age determination: Isochron"
    helpme["GM-SMND-MA"]=	"147Sm-143Nd age determination: Model age"
    helpme["GM-THPB"]=	"232Th-208Pb age determination"
    helpme["GM-THPB-I"]=	"232Th-208Pb age determination: Isochron"
    helpme["GM-THPB-MA"]=	"232Th-208Pb age determination: Model age"
    helpme["GM-UPA"]=	"235U-231Pa age determination"
    helpme["GM-UPB"]=	"U-Pb age determination"
    helpme["GM-UPB-CC-T0"]=	"U-Pb age determination: Concordia diagram age, upper intersection"
    helpme["GM-UPB-CC-T1"]=	"U-Pb age determination: Concordia diagram age, lower intersection"
    helpme["GM-UPB-I-206"]=	"U-Pb age determination: 238U-206Pb isochron"
    helpme["GM-UPB-I-207"]=	"U-Pb age determination: 235U-207Pb isochron"
    helpme["GM-UPB-MA-206"]=	"U-Pb age determination: 238U-206Pb model age"
    helpme["GM-UPB-MA-207"]=	"U-Pb age determination: 235U-207Pb model age"
    helpme["GM-USD"]=	"Uranium series disequilibrium age determination"
    helpme["GM-USD-PA231-TH230"]=	"Uranium series disequilibrium age determination: 231Pa-230Th"
    helpme["GM-USD-PA231-U235"]=	"Uranium series disequilibrium age determination: 231Pa-235U"
    helpme["GM-USD-PB210"]=	"Uranium series disequilibrium age determination: 210Pb"
    helpme["GM-USD-RA226-TH230"]=	"Uranium series disequilibrium age determination: 226Ra-230Th"
    helpme["GM-USD-RA228-TH232"]=	"Uranium series disequilibrium age determination: 228Ra-232Th"
    helpme["GM-USD-TH228-TH232"]=	"Uranium series disequilibrium age determination: 228Th-232Th"
    helpme["GM-USD-TH230"]=	"Uranium series disequilibrium age determination: 230Th"
    helpme["GM-USD-TH230-TH232"]=	"Uranium series disequilibrium age determination: 230Th-232Th"
    helpme["GM-USD-TH230-U234"]=	"Uranium series disequilibrium age determination: 230Th-234U"
    helpme["GM-USD-TH230-U238"]=	"Uranium series disequilibrium age determination: 230Th-238U"
    helpme["GM-USD-U234-U238"]=	"Uranium series disequilibrium age determination: 234U-238U"
    helpme["GM-UTH"]=	"238U-230Th age determination"
    helpme["GM-UTHHE"]=	"U-Th-He age determination"
    helpme["GM-UTHPB"]=	"U-Th-Pb age determination"
    helpme["GM-UTHPB-CC-T0"]=	"U-Th-Pb age determination: Concordia diagram intersection age, upper intercept"
    helpme["GM-UTHPB-CC-T1"]=	"U-Th-Pb age determination: Concordia diagram intersection age, lower intercept"
    helpme["GM-VARVE"]=	"Age determined by varve counting"
    helpme["tiepoint_name"]=	"Name for tiepoint horizon"
    helpme["tiepoint_alternatives"]=	"Colon-delimited list of alternative names and abbreviations"
    helpme["tiepoint_height"]=	"Tiepoint stratigraphic height relative to reference tiepoint"
    helpme["tiepoint_height_sigma"]=	"Tiepoint stratigraphic height uncertainty"
    helpme["tiepoint_elevation"]=	"Tiepoint elevation relative to sealevel"
    helpme["tiepoint_type"]=	"Tiepoint type"
    helpme["age"]=	"Age"
    helpme["age_sigma"]=	"Age -- uncertainty"
    helpme["age_range_low"]=	"Age -- low range"
    helpme["age_range_high"]=	"Age -- high range"
    helpme["age_unit"]=	"Age -- unit"
    helpme["timescale_eon"]=	"Timescale eon"
    helpme["timescale_era"]=	"Timescale era"
    helpme["timescale_period"]=	"Timescale period"
    helpme["timescale_epoch"]=	"Timescale epoch"
    helpme["timescale_stage"]=	"Timescale stage"
    helpme["biostrat_zone"]=	"Biostratigraphic zone"
    helpme["conodont_zone"]=	"Conodont zone"
    helpme["magnetic_reversal_chron"]=	"Magnetic reversal chron"
    helpme["astronomical_stage"]=	"Astronomical stage name"
    helpme["oxygen_stage"]=	"Oxygen stage name"
    helpme["age_culture_name"]=	"Age culture name"
    return helpme[keyhelp]

def dosundec(sundata):
    """
    returns the declination for a given set of suncompass data
    INPUT:
      sundata={'date':'yyyy:mm:dd:hr:min','delta_u':DU,'lat':LAT,'lon':LON,'shadow_angle':SHADAZ}
      where:
         DU is the hours to subtract from local time to get Greenwich Mean Time
         LAT,LON are the site latitude,longitude (negative for south and west respectively)
         SHADAZ is the shadow angle of the desired direction with respect to the sun.
    OUTPUT:
      the declination of the desired direction wrt true north.
    """
    rad=numpy.pi/180.
    iday=0
    timedate=sundata["date"]
    timedate=timedate.split(":")
    year=int(timedate[0])
    mon=int(timedate[1])
    day=int(timedate[2])
    hours=float(timedate[3])
    min=float(timedate[4])
    du=int(sundata["delta_u"])
    hrs=hours-du
    if hrs > 24:
        day+=1
        hrs=hrs-24
    if hrs < 0:
        day=day-1
        hrs=hrs+24
    julian_day=julian(mon,day,year)
    utd=(hrs+min/60.)/24.
    greenwich_hour_angle,delta=gha(julian_day,utd)
    H=greenwich_hour_angle+float(sundata["lon"])
    if H > 360: H=H-360
    lat=float(sundata["lat"])
    if H > 90 and H < 270:lat=-lat
# now do spherical trig to get azimuth to sun
    lat=(lat)*rad
    delta=(delta)*rad
    H=H*rad
    ctheta=numpy.sin(lat)*numpy.sin(delta)+numpy.cos(lat)*numpy.cos(delta)*numpy.cos(H)
    theta=numpy.arccos(ctheta)
    beta=numpy.cos(delta)*numpy.sin(H)/numpy.sin(theta)
#
#       check which beta
#
    beta=numpy.arcsin(beta)/rad
    if delta < lat: beta=180-beta
    sunaz=180-beta
    suncor=(sunaz+float(sundata["shadow_angle"]))%360. #  mod 360
    return suncor

def gha(julian_day,f):
    """
    returns greenwich hour angle
    """
    rad=numpy.pi/180.
    d=julian_day-2451545.0+f
    L= 280.460 + 0.9856474*d
    g=  357.528 + 0.9856003*d
    L=L%360.
    g=g%360.
# ecliptic longitude
    lamb=L+1.915*numpy.sin(g*rad)+.02*numpy.sin(2*g*rad)
# obliquity of ecliptic
    epsilon= 23.439 - 0.0000004*d
# right ascension (in same quadrant as lambda)
    t=(numpy.tan((epsilon*rad)/2))**2
    r=1/rad
    rl=lamb*rad
    alpha=lamb-r*t*numpy.sin(2*rl)+(r/2)*t*t*numpy.sin(4*rl)
#       alpha=mod(alpha,360.0)
# declination
    delta=numpy.sin(epsilon*rad)*numpy.sin(lamb*rad)
    delta=numpy.arcsin(delta)/rad
# equation of time
    eqt=(L-alpha)
#
    utm=f*24*60
    H=utm/4+eqt+180
    H=H%360.0
    return H,delta

def julian(mon,day,year):
    """
    returns julian day
    """
    ig=15+31*(10+12*1582)
    if year == 0:
        print "Julian no can do"
        return
    if year < 0: year=year+1
    if mon > 2:
        julian_year=year
        julian_month=mon+1
    else:
        julian_year=year-1
        julian_month=mon+13
    j1=int(365.25*julian_year)
    j2=int(30.6001*julian_month)
    j3=day+1720995
    julian_day=j1+j2+j3
    if day+31*(mon+12*year) >= ig:
        jadj=int(0.01*julian_year)
        julian_day=julian_day+2-jadj+int(0.25*jadj)
    return julian_day

def fillkeys(Recs):
    """
    reconciles keys of dictionaries within Recs.
    """
    keylist,OutRecs=[],[]
    for rec in Recs:
        for key in rec.keys():
            if key not in keylist:keylist.append(key)
    for rec in  Recs:
        for key in keylist:
            if key not in rec.keys(): rec[key]=""
        OutRecs.append(rec)
    return OutRecs,keylist

def fisher_mean(data):
    """
    call to fisher_mean(data) calculates fisher statistics for data, which is a list of [dec,inc] pairs.
    """
    R,Xbar,X,fpars=0,[0,0,0],[],{}
    N=len(data)
    if N <2:
       return fpars
    X=dir2cart(data)
    for i in range(len(X)):
        for c in range(3):
           Xbar[c]+=X[i][c]
    for c in range(3):
        R+=Xbar[c]**2
    R=numpy.sqrt(R)
    for c in range(3):
        Xbar[c]=Xbar[c]/R
    dir=cart2dir(Xbar)
    fpars["dec"]=dir[0]
    fpars["inc"]=dir[1]
    fpars["n"]=N
    fpars["r"]=R
    if N!=R:
        k=(N-1.)/(N-R)
        fpars["k"]=k
        csd=81./numpy.sqrt(k)
    else:
        fpars['k']='inf'
        csd=0.
    b=20.**(1./(N-1.)) -1
    a=1-b*(N-R)/R
    if a<-1:a=-1
    a95=numpy.arccos(a)*180./numpy.pi
    fpars["alpha95"]=a95
    fpars["csd"]=csd
    if a<0: fpars["alpha95"] = 180.0
    return fpars

def gausspars(data):
    """
    calculates gaussian statistics for data
    """
    N,mean,d=len(data),0.,0.
    if N<1: return "",""
    if N==1: return data[0],0
    for j in range(N):
       mean+=data[j]/float(N)
    for j in range(N):
       d+=(data[j]-mean)**2
    stdev=numpy.sqrt(d*(1./(float(N-1))))
    return mean,stdev

def weighted_mean(data):
    """
    calculates weighted mean of data
    """
    W,N,mean,d=0,len(data),0,0
    if N<1: return "",""
    if N==1: return data[0][0],0
    for x in data:
       W+=x[1] # sum of the weights
    for x in data:
       mean+=(float(x[1])*float(x[0]))/float(W)
    for x in data:
       d+=(float(x[1])/float(W))*(float(x[0])-mean)**2
    stdev=numpy.sqrt(d*(1./(float(N-1))))
    return mean,stdev

def lnpbykey(data,key0,key1): # calculate a fisher mean of key1 data for a group of key0
    PmagRec={}
    if len(data)>1:
        for rec in data:
            rec['dec']=float(rec[key1+'_dec'])
            rec['inc']=float(rec[key1+'_inc'])
        fpars=dolnp(data,key1+'_direction_type')
        PmagRec[key0+"_dec"]=fpars["dec"]
        PmagRec[key0+"_inc"]=fpars["inc"]
        PmagRec[key0+"_n"]=(fpars["n_total"])
        PmagRec[key0+"_n_lines"]=fpars["n_lines"]
        PmagRec[key0+"_n_planes"]=fpars["n_planes"]
        PmagRec[key0+"_r"]=fpars["R"]
        PmagRec[key0+"_k"]=fpars["K"]
        PmagRec[key0+"_alpha95"]=fpars["alpha95"]
        if int(PmagRec[key0+"_n_planes"])>0:
            PmagRec["magic_method_codes"]="DE-FM-LP"
        elif int(PmagRec[key0+"_n_lines"])>2:
            PmagRec["magic_method_codes"]="DE-FM"
    elif len(data)==1:
        PmagRec[key0+"_dec"]=data[0][key1+'_dec']
        PmagRec[key0+"_inc"]=data[0][key1+'_inc']
        PmagRec[key0+"_n"]='1'
        if data[0][key1+'_direction_type']=='l':
            PmagRec[key0+"_n_lines"]='1'
            PmagRec[key0+"_n_planes"]='0'
        if data[0][key1+'_direction_type']=='p':
            PmagRec[key0+"_n_planes"]='1'
            PmagRec[key0+"_n_lines"]='0'
        PmagRec[key0+"_alpha95"]=""
        PmagRec[key0+"_r"]=""
        PmagRec[key0+"_k"]=""
        PmagRec[key0+"_direction_type"]="l"
    return PmagRec

def fisher_by_pol(data):
    """
    input:    as in dolnp (list of dictionaries with 'dec' and 'inc')
    description: do fisher mean after splitting data into two polarity domains.
    output: three dictionaries:
        'A'= polarity 'A'
        'B = polarity 'B'
        'ALL'= switching polarity of 'B' directions, and calculate fisher mean of all data
    code modified from eqarea_ell.py b rshaar 1/23/2014
    """
    FisherByPoles={}
    DIblock,nameblock,locblock=[],[],[]
    for rec in data:
        if 'dec' in rec.keys() and 'inc' in rec.keys():
            DIblock.append([float(rec["dec"]),float(rec["inc"])]) # collect data for fisher calculation
        else:
            continue
        if 'name' in rec.keys():
            nameblock.append(rec['name'])
        else:
            nameblock.append("")
        if 'loc' in rec.keys():
            locblock.append(rec['loc'])
        else:
            locblock.append("")

    ppars=doprinc(array(DIblock)) # get principal directions
    reference_DI=[ppars['dec'],ppars['inc']] # choose the northerly declination principe component ("normal")
    if reference_DI[0]>90 and reference_DI[0]<270: # make reference direction in northern hemisphere
        reference_DI[0]=(reference_DI[0]+180.)%360
        reference_DI[1]=reference_DI[1]*-1.
    nDIs,rDIs,all_DI,npars,rpars=[],[],[],[],[]
    nlist,rlist,alllist="","",""
    nloclist,rloclist,allloclist="","",""
    for k in range(len(DIblock)):
        if angle([DIblock[k][0],DIblock[k][1]],reference_DI) > 90.:
            rDIs.append(DIblock[k])
            rlist=rlist+":"+nameblock[k]
            if locblock[k] not in rloclist:rloclist=rloclist+":"+locblock[k]
            all_DI.append( [(DIblock[k][0]+180.)%360.,-1.*DIblock[k][1]])
            alllist=alllist+":"+nameblock[k]
            if locblock[k] not in allloclist:allloclist=allloclist+":"+locblock[k]
        else:
            nDIs.append(DIblock[k])
            nlist=nlist+":"+nameblock[k]
            if locblock[k] not in nloclist:nloclist=nloclist+":"+locblock[k]
            all_DI.append(DIblock[k])
            alllist=alllist+":"+nameblock[k]
            if locblock[k] not in allloclist:allloclist=allloclist+":"+locblock[k]

    for mode in ['A','B','All']:
        if mode=='A' and len(nDIs)>2:
            fpars=fisher_mean(nDIs)
            fpars['sites']=nlist.strip(':')
            fpars['locs']=nloclist.strip(':')
            FisherByPoles[mode]=fpars
        elif mode=='B' and len(rDIs)>2:
            fpars=fisher_mean(rDIs)
            fpars['sites']=rlist.strip(':')
            fpars['locs']=rloclist.strip(':')
            FisherByPoles[mode]=fpars
        elif mode=='All' and len(all_DI)>2:
            fpars=fisher_mean(all_DI)
            fpars['sites']=alllist.strip(':')
            fpars['locs']=allloclist.strip(':')
            FisherByPoles[mode]=fpars
    return FisherByPoles

def dolnp(data,direction_type_key):
    """
    returns fisher mean, a95 for data  using method of mcfadden and mcelhinny '88 for lines and planes
    """
    if "tilt_correction" in data[0].keys():
        tc=data[0]["tilt_correction"]
    else:
        tc='-1'
    n_lines,n_planes=0,0
    X,L,fdata,dirV=[],[],[],[0,0,0]
    E=[0,0,0]
    fpars={}
#
# sort data  into lines and planes and collect cartesian coordinates
    for rec in data:
        cart=dir2cart([rec["dec"],rec["inc"]])[0]
        if direction_type_key in rec.keys() and rec[direction_type_key]=='p': # this is a pole to a plane
            n_planes+=1
            L.append(cart) # this is the "EL, EM, EN" array of MM88
        else: # this is a line
            n_lines+=1
            fdata.append([rec["dec"],rec["inc"],1.]) # collect data for fisher calculation
            X.append(cart)
            E[0]+=cart[0]
            E[1]+=cart[1]
            E[2]+=cart[2]
# set up initial points on the great circles
    V,XV=[],[]
    if n_planes !=0:
        if n_lines==0:
            V=dir2cart([180.,-45.,1.]) # set the initial direction arbitrarily
        else:
           R=numpy.sqrt(E[0]**2+E[1]**2+E[2]**2)
           for c in E:
               V.append(c/R) # set initial direction as mean of lines
        U=E[:]   # make a copy of E
        for pole in L:
            XV.append(vclose(pole,V)) # get some points on the great circle
            for c in range(3):
               U[c]=U[c]+XV[-1][c]
# iterate to find best agreement
        angle_tol=1.
        while angle_tol > 0.1:
            angles=[]
            for k in range(n_planes):
               for c in range(3): U[c]=U[c]-XV[k][c]
               R=numpy.sqrt(U[0]**2+U[1]**2+U[2]**2)
               for c in range(3):V[c]=U[c]/R
               XX=vclose(L[k],V)
               ang=XX[0]*XV[k][0]+XX[1]*XV[k][1]+XX[2]*XV[k][2]
               angles.append(numpy.arccos(ang)*180./numpy.pi)
               for c in range(3):
                   XV[k][c]=XX[c]
                   U[c]=U[c]+XX[c]
               amax =-1
               for ang in angles:
                   if ang > amax:amax=ang
               angle_tol=amax
# calculating overall mean direction and R
        U=E[:]
        for dir in XV:
            for c in range(3):U[c]=U[c]+dir[c]
        R=numpy.sqrt(U[0]**2+U[1]**2+U[2]**2)
        for c in range(3):U[c]=U[c]/R
# get dec and inc of solution points on gt circles
        dirV=cart2dir(U)
# calculate modified Fisher stats fo fit
        n_total=n_lines+n_planes
        NP=n_lines+0.5*n_planes
        if NP<1.1:NP=1.1
        if n_total-R !=0:
            K=(NP-1.)/(n_total-R)
            fac=(20.**(1./(NP-1.))-1.)
            fac=fac*(NP-1.)/K
            a=1.-fac/R
            a95=a
            if abs(a) > 1.0: a95=1.
            if a<0:a95=-a95
            a95=numpy.arccos(a95)*180./numpy.pi
        else:
            a95=0.
            K='inf'
    else:
        dir=fisher_mean(fdata)
        n_total,R,K,a95=dir["n"],dir["r"],dir["k"],dir["alpha95"]
        dirV[0],dirV[1]=dir["dec"],dir["inc"]
    fpars["tilt_correction"]=tc
    fpars["n_total"]='%i '% (n_total)
    fpars["n_lines"]='%i '% (n_lines)
    fpars["n_planes"]='%i '% (n_planes)
    fpars["R"]='%5.4f '% (R)
    if K!='inf':
        fpars["K"]='%6.0f '% (K)
    else:
        fpars["K"]=K
    fpars["alpha95"]='%7.1f '% (a95)
    fpars["dec"]='%7.1f '% (dirV[0])
    fpars["inc"]='%7.1f '% (dirV[1])
    return fpars

def vclose(L,V):
    """
    gets the closest vector
    """
    lam,X=0,[]
    for k in range(3):
        lam=lam+V[k]*L[k]
    beta=numpy.sqrt(1.-lam**2)
    for k in range(3):
        X.append( ((V[k]-lam*L[k])/beta))
    return X

def scoreit(pars,PmagSpecRec,accept,text,verbose):
    """
    gets a grade for a given set of data, spits out stuff
    """
    s=PmagSpecRec["er_specimen_name"]
    PmagSpecRec["measurement_step_min"]='%8.3e' % (pars["measurement_step_min"])
    PmagSpecRec["measurement_step_max"]='%8.3e' % (pars["measurement_step_max"])
    PmagSpecRec["measurement_step_unit"]=pars["measurement_step_unit"]
    PmagSpecRec["specimen_int_n"]='%i'%(pars["specimen_int_n"])
    PmagSpecRec["specimen_lab_field_dc"]='%8.3e'%(pars["specimen_lab_field_dc"])
    PmagSpecRec["specimen_int"]='%8.3e '%(pars["specimen_int"])
    PmagSpecRec["specimen_b"]='%5.3f '%(pars["specimen_b"])
    PmagSpecRec["specimen_q"]='%5.1f '%(pars["specimen_q"])
    PmagSpecRec["specimen_f"]='%5.3f '%(pars["specimen_f"])
    PmagSpecRec["specimen_fvds"]='%5.3f'%(pars["specimen_fvds"])
    PmagSpecRec["specimen_b_beta"]='%5.3f'%(pars["specimen_b_beta"])
    PmagSpecRec["specimen_int_mad"]='%7.1f'%(pars["specimen_int_mad"])
    PmagSpecRec["specimen_dec"]='%7.1f'%(pars["specimen_dec"])
    PmagSpecRec["specimen_inc"]='%7.1f'%(pars["specimen_inc"])
    PmagSpecRec["specimen_int_dang"]='%7.1f '%(pars["specimen_int_dang"])
    PmagSpecRec["specimen_drats"]='%7.1f '%(pars["specimen_drats"])
    PmagSpecRec["specimen_int_ptrm_n"]='%i '%(pars["specimen_int_ptrm_n"])
    PmagSpecRec["specimen_rsc"]='%6.4f '%(pars["specimen_rsc"])
    PmagSpecRec["specimen_md"]='%i '%(int(pars["specimen_md"]))
    PmagSpecRec["specimen_b_sigma"]='%5.3f '%(pars["specimen_b_sigma"])
    if 'specimen_scat' in pars.keys():PmagSpecRec['specimen_scat']=pars['specimen_scat']
    if 'specimen_gmax' in pars.keys():PmagSpecRec['specimen_gmax']='%5.3f'%(pars['specimen_gmax'])
    if 'specimen_frac' in pars.keys():PmagSpecRec['specimen_frac']='%5.3f'%(pars['specimen_frac'])
    #PmagSpecRec["specimen_Z"]='%7.1f'%(pars["specimen_Z"])
  # check score
   #
    kill=grade(PmagSpecRec,accept,'specimen_int')
    Grade=""
    if len(kill)==0:
        Grade='A'
    else:
        Grade='F'
    pars["specimen_grade"]=Grade
    if verbose==0:
        return pars,kill
    diffcum=0
    if pars['measurement_step_unit']=='K':
        outstr= "specimen     Tmin  Tmax  N  lab_field  B_anc  b  q  f(coe)  Fvds  beta  MAD  Dang  Drats  Nptrm  Grade  R  MD%  sigma  Gamma_max \n"
        pars_out= (s,(pars["measurement_step_min"]-273),(pars["measurement_step_max"]-273),(pars["specimen_int_n"]),1e6*(pars["specimen_lab_field_dc"]),1e6*(pars["specimen_int"]),pars["specimen_b"],pars["specimen_q"],pars["specimen_f"],pars["specimen_fvds"],pars["specimen_b_beta"],pars["specimen_int_mad"],pars["specimen_int_dang"],pars["specimen_drats"],pars["specimen_int_ptrm_n"],pars["specimen_grade"],numpy.sqrt(pars["specimen_rsc"]),int(pars["specimen_md"]), pars["specimen_b_sigma"],pars['specimen_gamma'])
        outstring= '%s %4.0f %4.0f %i %4.1f %4.1f %5.3f %5.1f %5.3f %5.3f %5.3f  %7.1f %7.1f %7.1f %s %s %6.3f %i %5.3f %7.1f' % pars_out +'\n'
    elif pars['measurement_step_unit']=='J':
        outstr= "specimen     Wmin  Wmax  N  lab_field  B_anc  b  q  f(coe)  Fvds  beta  MAD  Dang  Drats  Nptrm  Grade  R  MD%  sigma  ThetaMax DeltaMax GammaMax\n"
        pars_out= (s,(pars["measurement_step_min"]),(pars["measurement_step_max"]),(pars["specimen_int_n"]),1e6*(pars["specimen_lab_field_dc"]),1e6*(pars["specimen_int"]),pars["specimen_b"],pars["specimen_q"],pars["specimen_f"],pars["specimen_fvds"],pars["specimen_b_beta"],pars["specimen_int_mad"],pars["specimen_int_dang"],pars["specimen_drats"],pars["specimen_int_ptrm_n"],pars["specimen_grade"],numpy.sqrt(pars["specimen_rsc"]),int(pars["specimen_md"]), pars["specimen_b_sigma"],pars["specimen_theta"],pars["specimen_delta"],pars["specimen_gamma"])
        outstring= '%s %4.0f %4.0f %i %4.1f %4.1f %5.3f %5.1f %5.3f %5.3f %5.3f  %7.1f %7.1f %7.1f %s %s %6.3f %i %5.3f %7.1f %7.1f %7.1f' % pars_out +'\n'
    if pars["specimen_grade"]!="A":
        print '\n killed by:'
        for k in kill:
            print k,':, criterion set to: ',accept[k],', specimen value: ',pars[k]
        print '\n'
    print outstr
    print outstring
    return pars,kill

def b_vdm(B,lat):
    """
    Converts field values in tesla to v(a)dm in Am^2
    """
    rad=numpy.pi/180.
    fact=((6.371e6)**3)*1e7 # changed radius of the earth from 3.367e6 3/12/2010
    colat=(90.-lat) * rad
    return fact*B/(numpy.sqrt(1+3*(numpy.cos(colat)**2)))

def vdm_b(vdm,lat):
    """
    Converts v(a)dm to  field values in tesla
    """
    rad=numpy.pi/180.
    fact=((6.371e6)**3)*1e7 # changed radius of the earth from 3.367e6 3/12/2010
    colat=(90.-lat) * rad
    return vdm*(numpy.sqrt(1+3*(numpy.cos(colat)**2)))/fact

def binglookup(w1i,w2i):
    """
    Bingham statistics lookup table.
    """
    K={'0.06': {'0.02': ['-25.58', '-8.996'], '0.06': ['-9.043', '-9.043'], '0.04': ['-13.14', '-9.019']}, '0.22': {'0.08': ['-6.944', '-2.644'], '0.02': ['-25.63', '-2.712'], '0.20': ['-2.649', '-2.354'], '0.06': [ '-9.027', '-2.673'], '0.04': ['-13.17', '-2.695'], '0.14': ['-4.071', '-2.521'], '0.16': ['-3.518', '-2.470'], '0.10': ['-5.658', '-2.609'], '0.12': ['-4.757', '-2.568'], '0.18': ['-3.053', '-2.414'], '0.22': ['-2.289', '-2.289']}, '0.46': {'0.02': ['-25.12', '-0.250'], '0.08': ['-6.215', '0.000'], '0.06': ['-8.371', '-0.090'], '0.04': ['-12.58', '-0.173']}, '0.44': {'0.08': ['-6.305', '-0.186'], '0.02': ['-25.19', '-0.418'], '0.06': ['-8.454', '-0.270'], '0.04': ['-12.66', '-0.347'], '0.10': ['-4.955', '-0.097'], '0.12': ['-3.992', '0.000']}, '0.42': {'0.08': ['-6.388', '-0.374'], '0.02': ['-25.5', '-0.589'], '0.06': [ '-8.532', '-0.452'], '0.04': ['-12.73', '-0.523'], '0.14': ['-3.349', '-0.104'], '0.16': ['-2.741', '0.000'], '0.10': ['-5.045', '-0.290'], '0.12': ['-4.089', '-0.200']}, '0.40': {'0.08': ['-6.466', '-0.564'], '0.02': ['-25.31', '-0.762'], '0.20': ['-1.874', '-0.000'], '0.06': ['-8.604', '-0.636'], '0.04': ['-12.80', '-0.702'], '0.14': ['-3.446', '-0.312'], '0.16': ['-2.845', '-0.215'], '0.10': ['-5.126', '-0.486'] , '0.12': ['-4.179', '-0.402'], '0.18': ['-2.330', '-0.111']}, '0.08': {'0.02': ['-25.6', '-6.977'], '0.08': ['-7.035', '-7.035'], '0.06': ['-9.065', '-7.020'], '0.04': ['-13.16', '-6.999']}, '0.28': {'0.08': ['-6.827', '-1.828'], '0.28': ['-1.106', '-1.106'], '0.02': ['-25.57', '-1.939'], '0.20': ['-2.441', '-1.458'], '0.26': ['-1.406', '-1.203'], '0.24': ['-1.724', '-1.294'], '0.06': ['-8.928', '-1.871'], '0.04': ['-13.09', '-1.908'], '0.14': ['-3.906', '-1.665'], '0.16': ['-3.338', '-1.601'], '0.10': ['-5.523', '-1.779'], '0.12': ['-4.606', '-1.725'], '0.18': ['-2.859', '-1.532'], '0.22': ['-2.066', '-1.378']}, '0.02': {'0.02': ['-25.55','-25.55']}, '0.26': {'0.08': ['-6.870', '-2.078'], '0.02': ['-25.59', '-2.175'], '0.20': ['-2.515', '-1.735'], '0.26': ['-1.497', '-1.497'], '0.24': ['-1.809', '-1.582'], '0.06': ['-8.96 6', '-2.117'], '0.04': ['-13.12', '-2.149'], '0.14': ['-3.965', '-1.929'], '0.16': ['-3.403', '-1.869'], '0.10': ['-5.573', '-2.034'], '0.12': ['-4.661', '-1.984'], '0.18': ['-2.928', '-1.805'], '0.22': ['-2.1 46', '-1.661']}, '0.20': {'0.08': ['-6.974', '-2.973'], '0.02': ['-25.64', '-3.025'], '0.20': ['-2.709', '-2.709'], '0.06': ['-9.05', '-2.997'], '0.04': ['-13.18', '-3.014'], '0.14': ['-4.118', '-2.863'], '0.1 6': ['-3.570', '-2.816'], '0.10': ['-5.694', '-2.942'], '0.12': ['-4.799', '-2.905'], '0.18': ['-3.109', '-2.765']}, '0.04': {'0.02': ['-25.56', '-13.09'], '0.04': ['-13.11', '-13.11']}, '0.14': {'0.08': ['-7.  033', '-4.294'], '0.02': ['-25.64', '-4.295'], '0.06': ['-9.087', '-4.301'], '0.04': ['-13.20', '-4.301'], '0.14': ['-4.231', '-4.231'], '0.10': ['-5.773', '-4.279'], '0.12': ['-4.896', '-4.258']}, '0.16': {'0 .08': ['-7.019', '-3.777'], '0.02': ['-25.65', '-3.796'], '0.06': ['-9.081', '-3.790'], '0.04': ['-13.20', '-3.796'], '0.14': ['-4.198', '-3.697'], '0.16': ['-3.659', '-3.659'], '0.10': ['-5.752', '-3.756'], ' 0.12': ['-4.868', '-3.729']}, '0.10': {'0.02': ['-25.62', '-5.760'], '0.08': ['-7.042', '-5.798'], '0.06': ['-9.080', '-5.791'], '0.10': ['-5.797', '-5.797'], '0.04': ['-13.18', '-5.777']}, '0.12': {'0.08': [' -7.041', '-4.941'], '0.02': ['-25.63', '-4.923'], '0.06': ['-9.087', '-4.941'], '0.04': ['-13.19', '-4.934'], '0.10': ['-5.789', '-4.933'], '0.12': ['-4.917', '-4.917']}, '0.18': {'0.08': ['-6.999', '-3.345'], '0.02': ['-25.65', '-3.381'], '0.06': ['-9.068', '-3.363'], '0.04': ['-13.19', '-3.375'], '0.14': ['-4.160', '-3.249'], '0.16': ['-3.616', '-3.207'], '0.10': ['-5.726', '-3.319'], '0.12': ['-4.836', '-3.287'] , '0.18': ['-3.160', '-3.160']}, '0.38': {'0.08': ['-6.539', '-0.757'], '0.02': ['-25.37', '-0.940'], '0.20': ['-1.986', '-0.231'], '0.24': ['-1.202', '0.000'], '0.06': ['-8.670', '-0.824'], '0.04': ['-12.86', '-0.885'], '0.14': ['-3.536', '-0.522'], '0.16': ['-2.941', '-0.432'], '0.10': ['-5.207', '-0.684'], '0.12': ['-4.263', '-0.606'], '0.18': ['-2.434', '-0.335'], '0.22': ['-1.579', '-0.120']}, '0.36': {'0.08': ['-6.606', '-9.555'], '0.28': ['-0.642', '0.000'], '0.02': ['-25.42', '-1.123'], '0.20': ['-2.089', '-0.464'], '0.26': ['-0.974', '-0.129'], '0.24': ['-1.322', '-0.249'], '0.06': ['-8.731', '-1.017'], '0.04': ['-12.91', '-1.073'], '0.14': ['-3.620', '-0.736'], '0.16': ['-3.032', '-0.651'], '0.10': ['-5.280', '-0.887'], '0.12': ['-4.342', '-0.814'], '0.18': ['-2.531', '-0.561'], '0.22': ['-1.690', '-0.360']}, '0.34 ': {'0.08': ['-6.668', '-1.159'], '0.28': ['-0.771', '-0.269'], '0.02': ['-25.46', '-1.312'], '0.20': ['-2.186', '-0.701'], '0.26': ['-1.094', '-0.389'], '0.24': ['-1.433', '-0.500'], '0.06': ['-8.788', '-1.21 6'], '0.32': ['-0.152', '0.000'], '0.04': ['-12.96', '-1.267'], '0.30': ['-0.459', '-0.140'], '0.14': ['-3.699', '-0.955'], '0.16': ['-3.116', '-0.876'], '0.10': ['-5.348', '-1.096'], '0.12': ['-4.415', '-1.02 8'], '0.18': ['-2.621', '-0.791'], '0.22': ['-1.794', '-0.604']}, '0.32': {'0.08': ['-6.725', '-1.371'], '0.28': ['-0.891', '-0.541'], '0.02': ['-25.50', '-1.510'], '0.20': ['-2.277', '-0.944'], '0.26': ['-1.2 06', '-0.653'], '0.24': ['-1.537', '-0.756'], '0.06': ['-8.839', '-1.423'], '0.32': ['-0.292', '-0.292'], '0.04': ['-13.01', '-1.470'], '0.30': ['-0.588', '-0.421'], '0.14': ['-3.773', '-1.181'], '0.16': ['-3.  195', '-1.108'], '0.10': ['-5.411', '-1.313'], '0.12': ['-4.484', '-1.250'], '0.18': ['-2.706', '-1.028'], '0.22': ['-1.891', '-0.853']}, '0.30': {'0.08': ['-6.778', '-1.596'], '0.28': ['-1.002', '-0.819'], '0 .02': ['-25.54', '-1.718'], '0.20': ['-2.361', '-1.195'], '0.26': ['-1.309', '-0.923'], '0.24': ['-1.634', '-1.020'], '0.06': ['-8.886', '-1.641'], '0.04': ['-13.05', '-1.682'], '0.30': ['-0.708', '-0.708'], ' 0.14': ['-3.842', '-1.417'], '0.16': ['-3.269', '-1.348'], '0.10': ['-5.469', '-1.540'], '0.12': ['-4.547', '-1.481'], '0.18': ['-2.785', '-1.274'], '0.22': ['-1.981', '-1.110']}, '0.24': {'0.08': ['-6.910', ' -2.349'], '0.02': ['-25.61', '-2.431'], '0.20': ['-2.584', '-2.032'], '0.24': ['-1.888', '-1.888'], '0.06': ['-8.999', '-2.382'], '0.04': ['-23.14', '-2.410'], '0.14': ['-4.021', '-2.212'], '0.16': ['-3.463', '-2.157'], '0.10': ['-5.618', '-2.309'], '0.12': ['-4.711', '-2.263'], '0.18': ['-2.993', '-2.097'], '0.22': ['-2.220', '-1.963']}}
    w1,w2=0.,0.
    wstart,incr=0.01,0.02
    if w1i < wstart: w1='%4.2f'%(wstart+incr/2.)
    if w2i < wstart: w2='%4.2f'%(wstart+incr/2.)
    wnext=wstart+incr
    while wstart <0.5:
        if w1i >=wstart and w1i <wnext :
            w1='%4.2f'%(wstart+incr/2.)
        if w2i >=wstart and w2i <wnext :
            w2='%4.2f'%(wstart+incr/2.)
        wstart+=incr
        wnext+=incr
    k1,k2=float(K[w2][w1][0]),float(K[w2][w1][1])
    return  k1,k2

def cdfout(data,file):
    """
    spits out the cdf for data to file
    """
    f=open(file,"w")
    data.sort()
    for j in range(len(data)):
        y=float(j)/float(len(data))
        out=str(data[j])+' '+str(y)+ '\n'
        f.write(out)

def dobingham(data):
    """
    gets bingham parameters for data
    """
    control,X,bpars=[],[],{}
    N=len(data)
    if N <2:
       return bpars
#
#  get cartesian coordinates
#
    for rec in data:
        X.append(dir2cart([rec[0],rec[1],1.]))
#
#   put in T matrix
#
    T=numpy.array(Tmatrix(X))
    t,V=tauV(T)
    w1,w2,w3=t[2],t[1],t[0]
    k1,k2=binglookup(w1,w2)
    PDir=cart2dir(V[0])
    EDir=cart2dir(V[1])
    ZDir=cart2dir(V[2])
    if PDir[1] < 0:
        PDir[0]+=180.
        PDir[1]=-PDir[1]
    PDir[0]=PDir[0]%360.
    bpars["dec"]=PDir[0]
    bpars["inc"]=PDir[1]
    bpars["Edec"]=EDir[0]
    bpars["Einc"]=EDir[1]
    bpars["Zdec"]=ZDir[0]
    bpars["Zinc"]=ZDir[1]
    bpars["n"]=N
#
#  now for Bingham ellipses.
#
    fac1,fac2=-2*N*(k1)*(w3-w1),-2*N*(k2)*(w3-w2)
    sig31,sig32=numpy.sqrt(1./fac1), numpy.sqrt(1./fac2)
    bpars["Zeta"],bpars["Eta"]=2.45*sig31*180./numpy.pi,2.45*sig32*180./numpy.pi
    return  bpars

def doflip(dec,inc):
   """
   flips lower hemisphere data to upper hemisphere
   """
   if inc <0:
       inc=-inc
       dec=(dec+180.)%360.
   return dec,inc

def doincfish(inc):
    """
    gets fisher mean inc from inc only data
    """
    rad,SCOi,SSOi=numpy.pi/180.,0.,0. # some definitions
    abinc=[]
    for i in inc:abinc.append(abs(i))
    MI,std=gausspars(abinc) # get mean inc and standard deviation
    fpars={}
    N=len(inc)  # number of data
    fpars['n']=N
    fpars['ginc']=MI
    if MI<30:
        fpars['inc']=MI
        fpars['k']=0
        fpars['alpha95']=0
        fpars['csd']=0
        fpars['r']=0
        print 'WARNING: mean inc < 30, returning gaussian mean'
        return fpars
    for i in inc:  # sum over all incs (but take only positive inc)
        coinc=(90.-abs(i))*rad
        SCOi+= numpy.cos(coinc)
        SSOi+= numpy.sin(coinc)
    Oo=(90.0-MI)*rad # first guess at mean
    SCFlag = -1  # sign change flag
    epsilon = float(N)*numpy.cos(Oo) # RHS of zero equations
    epsilon+= (numpy.sin(Oo)**2-numpy.cos(Oo)**2)*SCOi
    epsilon-= 2.*numpy.sin(Oo)*numpy.cos(Oo)*SSOi
    while SCFlag < 0: # loop until cross zero
        if MI > 0 : Oo-=(.01*rad)  # get steeper
        if MI < 0 : Oo+=(.01*rad)  # get shallower
        prev=epsilon
        epsilon = float(N)*numpy.cos(Oo) # RHS of zero equations
        epsilon+= (numpy.sin(Oo)**2.-numpy.cos(Oo)**2.)*SCOi
        epsilon-= 2.*numpy.sin(Oo)*numpy.cos(Oo)*SSOi
        if abs(epsilon) > abs(prev): MI=-1*MI  # reverse direction
        if epsilon*prev < 0: SCFlag = 1 # changed sign
    S,C=0.,0.  # initialize for summation
    for i in inc:
        coinc=(90.-abs(i))*rad
        S+= numpy.sin(Oo-coinc)
        C+= numpy.cos(Oo-coinc)
    k=(N-1.)/(2.*(N-C))
    Imle=90.-(Oo/rad)
    fpars["inc"]=Imle
    fpars["r"],R=2.*C-N,2*C-N
    fpars["k"]=k
    f=fcalc(2,N-1)
    a95= 1. - (0.5)*(S/C)**2 - (f/(2.*C*k))
#    b=20.**(1./(N-1.)) -1.
#    a=1.-b*(N-R)/R
#    a95=numpy.arccos(a)*180./numpy.pi
    csd=81./numpy.sqrt(k)
    fpars["alpha95"]=a95
    fpars["csd"]=csd
    return fpars

def dokent(data,NN):
    """
    gets Kent  parameters for data ([D,I],N)
    """
    X,kpars=[],{}
    N=len(data)
    if N <2:
       return kpars
#
#  get fisher mean and convert to co-inclination (theta)/dec (phi) in radians
#
    fpars=fisher_mean(data)
    pbar=fpars["dec"]*numpy.pi/180.
    tbar=(90.-fpars["inc"])*numpy.pi/180.
#
#   initialize matrices
#
    H=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
    w=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
    b=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
    gam=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
    xg=[]
#
#  set up rotation matrix H
#
    H=[ [numpy.cos(tbar)*numpy.cos(pbar),-numpy.sin(pbar),numpy.sin(tbar)*numpy.cos(pbar)],[numpy.cos(tbar)*numpy.sin(pbar),numpy.cos(pbar),numpy.sin(pbar)*numpy.sin(tbar)],[-numpy.sin(tbar),0.,numpy.cos(tbar)]]
#
#  get cartesian coordinates of data
#
    for rec in data:
        X.append(dir2cart([rec[0],rec[1],1.]))
#
#   put in T matrix
#
    T=Tmatrix(X)
    for i in range(3):
        for j in range(3):
            T[i][j]=T[i][j]/float(NN)
#
# compute B=H'TH
#
    for i in range(3):
        for j in range(3):
            for k in range(3):
                w[i][j]+=T[i][k]*H[k][j]
    for i in range(3):
        for j in range(3):
            for k in range(3):
                b[i][j]+=H[k][i]*w[k][j]
#
# choose a rotation w about North pole to diagonalize upper part of B
#
    psi = 0.5*numpy.arctan(2.*b[0][1]/(b[0][0]-b[1][1]))
    w=[[numpy.cos(psi),-numpy.sin(psi),0],[numpy.sin(psi),numpy.cos(psi),0],[0.,0.,1.]]
    for i in range(3):
        for j in range(3):
            gamtmp=0.
            for k in range(3):
                gamtmp+=H[i][k]*w[k][j]
            gam[i][j]=gamtmp
    for i in range(N):
        xg.append([0.,0.,0.])
        for k in range(3):
            xgtmp=0.
            for j in range(3):
                xgtmp+=gam[j][k]*X[i][j]
            xg[i][k]=xgtmp
# compute asymptotic ellipse parameters
#
    xmu,sigma1,sigma2=0.,0.,0.
    for  i in range(N):
        xmu+= xg[i][2]
        sigma1=sigma1+xg[i][1]**2
        sigma2=sigma2+xg[i][0]**2
    xmu=xmu/float(N)
    sigma1=sigma1/float(N)
    sigma2=sigma2/float(N)
    g=-2.0*numpy.log(0.05)/(float(NN)*xmu**2)
    if numpy.sqrt(sigma1*g)<1:eta=numpy.arcsin(numpy.sqrt(sigma1*g))
    if numpy.sqrt(sigma2*g)<1:zeta=numpy.arcsin(numpy.sqrt(sigma2*g))
    if numpy.sqrt(sigma1*g)>=1.:eta=numpy.pi/2.
    if numpy.sqrt(sigma2*g)>=1.:zeta=numpy.pi/2.
#
#  convert Kent parameters to directions,angles
#
    kpars["dec"]=fpars["dec"]
    kpars["inc"]=fpars["inc"]
    kpars["n"]=NN
    ZDir=cart2dir([gam[0][1],gam[1][1],gam[2][1]])
    EDir=cart2dir([gam[0][0],gam[1][0],gam[2][0]])
    kpars["Zdec"]=ZDir[0]
    kpars["Zinc"]=ZDir[1]
    kpars["Edec"]=EDir[0]
    kpars["Einc"]=EDir[1]
    if kpars["Zinc"]<0:
        kpars["Zinc"]=-kpars["Zinc"]
        kpars["Zdec"]=(kpars["Zdec"]+180.)%360.
    if kpars["Einc"]<0:
        kpars["Einc"]=-kpars["Einc"]
        kpars["Edec"]=(kpars["Edec"]+180.)%360.
    kpars["Zeta"]=zeta*180./numpy.pi
    kpars["Eta"]=eta*180./numpy.pi
    return kpars

def doprinc(data):
    """
    gets principal components from data in form of an array of [dec,inc] data.
    """
    ppars={}
    rad=numpy.pi/180.
    X=dir2cart(data)
    #for rec in data:
    #    dir=[]
    #    for c in rec: dir.append(c)
    #    cart= (dir2cart(dir))
    #    X.append(cart)
#   put in T matrix
#
    T=numpy.array(Tmatrix(X))
#
#   get sorted evals/evects
#
    t,V=tauV(T)
    Pdir=cart2dir(V[0])
    ppars['Edir']=cart2dir(V[1]) # elongation direction
    dec,inc=doflip(Pdir[0],Pdir[1])
    ppars['dec']=dec
    ppars['inc']=inc
    ppars['N']=len(data)
    ppars['tau1']=t[0]
    ppars['tau2']=t[1]
    ppars['tau3']=t[2]
    Pdir=cart2dir(V[1])
    dec,inc=doflip(Pdir[0],Pdir[1])
    ppars['V2dec']=dec
    ppars['V2inc']=inc
    Pdir=cart2dir(V[2])
    dec,inc=doflip(Pdir[0],Pdir[1])
    ppars['V3dec']=dec
    ppars['V3inc']=inc
    return ppars

def PTrot(EP,Lats,Lons):
    """ Does rotation of points on a globe  by finite rotations, using method of Cox and Hart 1986, box 7-3. """
# gets user input of Rotation pole lat,long, omega for plate and converts to radians
    E=dir2cart([EP[1],EP[0],1.]) # EP is pole lat,lon omega
    omega=EP[2]*numpy.pi/180. # convert to radians
    RLats,RLons=[],[]
    for k in range(len(Lats)):
      if Lats[k]<=90.: # peel off delimiters
# converts to rotation pole to cartesian coordinates
        A=dir2cart([Lons[k],Lats[k],1.])
# defines cartesian coordinates of the pole A
        R=[[0.,0.,0.],[0.,0.,0.],[0.,0.,0.]]
        R[0][0]=E[0]*E[0]*(1-numpy.cos(omega)) + numpy.cos(omega)
        R[0][1]=E[0]*E[1]*(1-numpy.cos(omega)) - E[2]*numpy.sin(omega)
        R[0][2]=E[0]*E[2]*(1-numpy.cos(omega)) + E[1]*numpy.sin(omega)
        R[1][0]=E[1]*E[0]*(1-numpy.cos(omega)) + E[2]*numpy.sin(omega)
        R[1][1]=E[1]*E[1]*(1-numpy.cos(omega)) + numpy.cos(omega)
        R[1][2]=E[1]*E[2]*(1-numpy.cos(omega)) - E[0]*numpy.sin(omega)
        R[2][0]=E[2]*E[0]*(1-numpy.cos(omega)) - E[1]*numpy.sin(omega)
        R[2][1]=E[2]*E[1]*(1-numpy.cos(omega)) + E[0]*numpy.sin(omega)
        R[2][2]=E[2]*E[2]*(1-numpy.cos(omega)) + numpy.cos(omega)
# sets up rotation matrix
        Ap=[0,0,0]
        for i in range(3):
            for j in range(3):
                Ap[i]+=R[i][j]*A[j]
# does the rotation
        Prot=cart2dir(Ap)
        RLats.append(Prot[1])
        RLons.append(Prot[0])
      else:  # preserve delimiters
        RLats.append(Lats[k])
        RLons.append(Lons[k])
    return RLats,RLons

def dread(infile,cols):
    """
     reads in specimen, tr, dec, inc int into data[].  position of
     tr, dec, inc, int determined by cols[]
    """
    data=[]
    f=open(infile,"rU")
    for line in f.readlines():
        tmp=line.split()
        rec=(tmp[0],float(tmp[cols[0]]),float(tmp[cols[1]]),float(tmp[cols[2]]),
          float(tmp[cols[3]]) )
        data.append(rec)
    return data

def fshdev(k):
    """
    a call to fshdev(k), where k is kappa, returns a direction from distribution with mean declination of 0, inclination of 90 and kappa of k
    """
    R1=random.random()
    R2=random.random()
    L=numpy.exp(-2*k)
    a=R1*(1-L)+L
    fac=numpy.sqrt((-numpy.log(a))/(2*k))
    inc=90.-2*numpy.arcsin(fac)*180./numpy.pi
    dec=2*numpy.pi*R2*180./numpy.pi
    return dec,inc

def lowes(data):
    """
    gets Lowe's power spectrum from infile - writes to ofile
    """
    Ls=range(1,9)
    Rs=[]
    recno=0
    for l in Ls:
        pow=0
        for m in range(0,l+1):
            pow+=(l+1)*((1e-3*data[recno][2])**2+(1e-3*data[recno][3])**2)
            recno+=1
        Rs.append(pow)
    return Ls,Rs

def magnetic_lat(inc):
    """
    returns magnetic latitude from inclination
    """
    rad=numpy.pi/180.
    paleo_lat=numpy.arctan( 0.5*numpy.tan(inc*rad))/rad
    return paleo_lat

def check_F(AniSpec):
    s=numpy.zeros((6),'f')
    s[0]=float(AniSpec["anisotropy_s1"])
    s[1]=float(AniSpec["anisotropy_s2"])
    s[2]=float(AniSpec["anisotropy_s3"])
    s[3]=float(AniSpec["anisotropy_s4"])
    s[4]=float(AniSpec["anisotropy_s5"])
    s[5]=float(AniSpec["anisotropy_s6"])
    chibar=(s[0]+s[1]+s[2])/3.
    tau,Vdir=doseigs(s)
    t2sum=0
    for i in range(3): t2sum+=tau[i]**2
    if 'anisotropy_sigma' in AniSpec.keys() and 'anisotropy_n' in AniSpec.keys():
        if AniSpec['anisotropy_type']=='AMS':
            nf=int(AniSpec["anisotropy_n"])-6
        else:
            nf=3*int(AniSpec["anisotropy_n"])-6
        sigma=float(AniSpec["anisotropy_sigma"])
        F=0.4*(t2sum-3*chibar**2)/(sigma**2)
        Fcrit=fcalc(5,nf)
        if F>Fcrit: # anisotropic
            chi=numpy.array([[s[0],s[3],s[5]],[s[3],s[1],s[4]],[s[5],s[4],s[2]]])
            chi_inv=numpy.linalg.inv(chi)
            #trace=chi_inv[0][0]+chi_inv[1][1]+chi_inv[2][2] # don't normalize twice
            #chi_inv=3.*chi_inv/trace
        else: # isotropic
            chi_inv=numpy.array([[1.,0,0],[0,1.,0],[0,0,1.]]) # make anisotropy tensor identity tensor
            chi=chi_inv
    else: # no sigma key available - just do the correction
        print 'WARNING: NO FTEST ON ANISOTROPY PERFORMED BECAUSE OF MISSING SIGMA - DOING CORRECTION ANYWAY'
        chi=numpy.array([[s[0],s[3],s[5]],[s[3],s[1],s[4]],[s[5],s[4],s[2]]])
        chi_inv=numpy.linalg.inv(chi)
    return chi,chi_inv

def Dir_anis_corr(InDir,AniSpec):
    """
    takes the 6 element 's' vector and the Dec,Inc 'InDir' data,
    performs simple anisotropy correction. returns corrected Dec, Inc
    """
    Dir=numpy.zeros((3),'f')
    Dir[0]=InDir[0]
    Dir[1]=InDir[1]
    Dir[2]=1.
    chi,chi_inv=check_F(AniSpec)
    if chi[0][0]==1.:return Dir # isotropic
    X=dir2cart(Dir)
    M=numpy.array(X)
    H=numpy.dot(M,chi_inv)
    return cart2dir(H)

def doaniscorr(PmagSpecRec,AniSpec):
    """
    takes the 6 element 's' vector and the Dec,Inc, Int 'Dir' data,
    performs simple anisotropy correction. returns corrected Dec, Inc, Int
    """
    AniSpecRec={}
    for key in PmagSpecRec.keys():
        AniSpecRec[key]=PmagSpecRec[key]
    Dir=numpy.zeros((3),'f')
    Dir[0]=float(PmagSpecRec["specimen_dec"])
    Dir[1]=float(PmagSpecRec["specimen_inc"])
    Dir[2]=float(PmagSpecRec["specimen_int"])
# check if F test passes!  if anisotropy_sigma available
    chi,chi_inv=check_F(AniSpec)
    if chi[0][0]==1.: # isotropic
        cDir=[Dir[0],Dir[1]] # no change
        newint=Dir[2]
    else:
        X=dir2cart(Dir)
        M=numpy.array(X)
        H=numpy.dot(M,chi_inv)
        cDir= cart2dir(H)
        Hunit=[H[0]/cDir[2],H[1]/cDir[2],H[2]/cDir[2]] # unit vector parallel to Banc
        Zunit=[0,0,-1.] # unit vector parallel to lab field
        Hpar=numpy.dot(chi,Hunit) # unit vector applied along ancient field
        Zpar=numpy.dot(chi,Zunit) # unit vector applied along lab field
        HparInt=cart2dir(Hpar)[2] # intensity of resultant vector from ancient field
        ZparInt=cart2dir(Zpar)[2] # intensity of resultant vector from lab field
        newint=Dir[2]*ZparInt/HparInt
        if cDir[0]-Dir[0]>90:
            cDir[1]=-cDir[1]
            cDir[0]=(cDir[0]-180.)%360.
    AniSpecRec["specimen_dec"]='%7.1f'%(cDir[0])
    AniSpecRec["specimen_inc"]='%7.1f'%(cDir[1])
    AniSpecRec["specimen_int"]='%9.4e'%(newint)
    AniSpecRec["specimen_correction"]='c'
    if 'magic_method_codes' in AniSpecRec.keys():
        methcodes=AniSpecRec["magic_method_codes"]
    else:
        methcodes=""
    if methcodes=="": methcodes="DA-AC-"+AniSpec['anisotropy_type']
    if methcodes!="": methcodes=methcodes+":DA-AC-"+AniSpec['anisotropy_type']
    if chi[0][0]==1.: # isotropic
        methcodes= methcodes+':DA-AC-ISO' # indicates anisotropy was checked and no change necessary
    AniSpecRec["magic_method_codes"]=methcodes.strip(":")
    return AniSpecRec

def vfunc(pars_1,pars_2):
    """
    returns 2*(Sw-Rw) for Watson's V
    """
    cart_1=dir2cart([pars_1["dec"],pars_1["inc"],pars_1["r"]])
    cart_2=dir2cart([pars_2['dec'],pars_2['inc'],pars_2["r"]])
    Sw=pars_1['k']*pars_1['r']+pars_2['k']*pars_2['r'] # k1*r1+k2*r2
    xhat_1=pars_1['k']*cart_1[0]+pars_2['k']*cart_2[0] # k1*x1+k2*x2
    xhat_2=pars_1['k']*cart_1[1]+pars_2['k']*cart_2[1] # k1*y1+k2*y2
    xhat_3=pars_1['k']*cart_1[2]+pars_2['k']*cart_2[2] # k1*z1+k2*z2
    Rw=numpy.sqrt(xhat_1**2+xhat_2**2+xhat_3**2)
    return 2*(Sw-Rw)

def vgp_di(plat,plong,slat,slong):
    """
    returns direction for a given observation site from a Virtual geomagnetic pole
    """
    rad,signdec=numpy.pi/180.,1.
    delphi=abs(plong-slong)
    if delphi!=0:signdec=(plong-slong)/delphi
    if slat==90.:slat=89.99
    thetaS=(90.-slat)*rad
    thetaP=(90.-plat)*rad
    delphi=delphi*rad
    cosp=numpy.cos(thetaS)*numpy.cos(thetaP)+numpy.sin(thetaS)*numpy.sin(thetaP)*numpy.cos(delphi)
    thetaM=numpy.arccos(cosp)
    cosd=(numpy.cos(thetaP)-numpy.cos(thetaM)*numpy.cos(thetaS))/(numpy.sin(thetaM)*numpy.sin(thetaS))
    C=abs(1.-cosd**2)
    if C!=0:
         dec=-numpy.arctan(cosd/numpy.sqrt(abs(C)))+numpy.pi/2.
    else:
        dec=numpy.arccos(cosd)
    if -numpy.pi<signdec*delphi and signdec<0: dec=2.*numpy.pi-dec  # checking quadrant
    if signdec*delphi> numpy.pi: dec=2.*numpy.pi-dec
    dec=(dec/rad)%360.
    inc=(numpy.arctan2(2.*numpy.cos(thetaM),numpy.sin(thetaM)))/rad
    return  dec,inc

def watsonsV(Dir1,Dir2):
    """
    calculates Watson's V statistic for two sets of directions
    """
    counter,NumSims=0,500
#
# first calculate the fisher means and cartesian coordinates of each set of Directions
#
    pars_1=fisher_mean(Dir1)
    pars_2=fisher_mean(Dir2)
#
# get V statistic for these
#
    V=vfunc(pars_1,pars_2)
#
# do monte carlo simulation of datasets with same kappas, but common mean
#
    Vp=[] # set of Vs from simulations
    print "Doing ",NumSims," simulations"
    for k in range(NumSims):
        counter+=1
        if counter==50:
            print k+1
            counter=0
        Dirp=[]
# get a set of N1 fisher distributed vectors with k1, calculate fisher stats
        for i in range(pars_1["n"]):
            Dirp.append(fshdev(pars_1["k"]))
        pars_p1=fisher_mean(Dirp)
# get a set of N2 fisher distributed vectors with k2, calculate fisher stats
        Dirp=[]
        for i in range(pars_2["n"]):
            Dirp.append(fshdev(pars_2["k"]))
        pars_p2=fisher_mean(Dirp)
# get the V for these
        Vk=vfunc(pars_p1,pars_p2)
        Vp.append(Vk)
#
# sort the Vs, get Vcrit (95th one)
#
    Vp.sort()
    k=int(.95*NumSims)
    return V,Vp[k]


def dimap(D,I):
    """
    FUNCTION TO MAP DECLINATION, INCLINATIONS INTO EQUAL AREA PROJECTION, X,Y

    Usage:     dimap(D, I)
    Argin:     Declination (float) and Inclination (float)

    """
### DEFINE FUNCTION VARIABLES
    XY=[0.,0.]                                     # initialize equal area projection x,y

### GET CARTESIAN COMPONENTS OF INPUT DIRECTION
    X=dir2cart([D,I,1.])

### CHECK IF Z = 1 AND ABORT
    if X[2] ==1.0: return XY                       # return [0,0]

### TAKE THE ABSOLUTE VALUE OF Z
    if X[2]<0:X[2]=-X[2]                           # this only works on lower hemisphere projections

### CALCULATE THE X,Y COORDINATES FOR THE EQUAL AREA PROJECTION
    R=numpy.sqrt( 1.-X[2])/(numpy.sqrt(X[0]**2+X[1]**2)) # from Collinson 1983
    XY[1],XY[0]=X[0]*R,X[1]*R

### RETURN XY[X,Y]
    return XY

def dimap_V(D,I):
    """
    FUNCTION TO MAP DECLINATION, INCLINATIONS INTO EQUAL AREA PROJECTION, X,Y

    Usage:     dimap_V(D, I)
        D and I are both numpy arrays

    """
### GET CARTESIAN COMPONENTS OF INPUT DIRECTION
    DI=numpy.array([D,I]).transpose() #
    X=dir2cart(DI).transpose()
### CALCULATE THE X,Y COORDINATES FOR THE EQUAL AREA PROJECTION
    R=numpy.sqrt( 1.-abs(X[2]))/(numpy.sqrt(X[0]**2+X[1]**2)) # from Collinson 1983
    XY=numpy.array([X[1]*R,X[0]*R]).transpose()

### RETURN XY[X,Y]
    return XY

def getmeths(method_type):
    """
    returns MagIC  method codes available for a given type
    """
    meths=[]
    if method_type=='GM':
        meths.append('GM-PMAG-APWP')
        meths.append('GM-ARAR')
        meths.append('GM-ARAR-AP')
        meths.append('GM-ARAR-II')
        meths.append('GM-ARAR-NI')
        meths.append('GM-ARAR-TF')
        meths.append('GM-CC-ARCH')
        meths.append('GM-CC-ARCHMAG')
        meths.append('GM-C14')
        meths.append('GM-FOSSIL')
        meths.append('GM-FT')
        meths.append('GM-INT-L')
        meths.append('GM-INT-S')
        meths.append('GM-ISO')
        meths.append('GM-KAR')
        meths.append('GM-PMAG-ANOM')
        meths.append('GM-PMAG-POL')
        meths.append('GM-PBPB')
        meths.append('GM-RATH')
        meths.append('GM-RBSR')
        meths.append('GM-RBSR-I')
        meths.append('GM-RBSR-MA')
        meths.append('GM-SMND')
        meths.append('GM-SMND-I')
        meths.append('GM-SMND-MA')
        meths.append('GM-CC-STRAT')
        meths.append('GM-LUM-TH')
        meths.append('GM-UPA')
        meths.append('GM-UPB')
        meths.append('GM-UTH')
        meths.append('GM-UTHHE')
    else: pass
    return meths

def first_up(ofile,Rec,file_type):
    """
    writes the header for a MagIC template file
    """
    keylist=[]
    pmag_out=open(ofile,'a')
    outstring="tab \t"+file_type+"\n"
    pmag_out.write(outstring)
    keystring=""
    for key in Rec.keys():
        keystring=keystring+'\t'+key
        keylist.append(key)
    keystring=keystring + '\n'
    pmag_out.write(keystring[1:])
    pmag_out.close()
    return keylist

def average_int(data,keybase,outkey): # returns dictionary with average intensities from list of arbitrary dictinaries.
    Ints,DataRec=[],{}
    for r in data:Ints.append(float(r[keybase+'_int']))
    if len(Ints)>1:
        b,sig=gausspars(Ints)
        sigperc=100.*sig/b
        DataRec[outkey+"_int_sigma"]='%8.3e '% (sig)
        DataRec[outkey+"_int_sigma_perc"]='%5.1f '%(sigperc)
    else: # if only one, just copy over specimen data
        b=Ints[0]
        DataRec[outkey+"_int_sigma"]=''
        DataRec[outkey+"_int_sigma_perc"]=''
    DataRec[outkey+"_int"]='%8.3e '%(b)
    DataRec[outkey+"_int_n"]='%i '% (len(data))
    return DataRec

def get_age(Rec,sitekey,keybase,Ages,DefaultAge):
    """
    finds the age record for a given site
    """
    site=Rec[sitekey]
    gotone=0
    if len(Ages)>0:
        for agerec in Ages:
            if agerec["er_site_name"]==site:
                if "age" in agerec.keys() and agerec["age"]!="":
                    Rec[keybase+"age"]=agerec["age"]
                    gotone=1
                if "age_unit" in agerec.keys(): Rec[keybase+"age_unit"]=agerec["age_unit"]
                if "age_sigma" in agerec.keys(): Rec[keybase+"age_sigma"]=agerec["age_sigma"]
    if gotone==0 and len(DefaultAge)>1:
        sigma=0.5*(float(DefaultAge[1])-float(DefaultAge[0]))
        age=float(DefaultAge[0])+sigma
        Rec[keybase+"age"]= '%10.4e'%(age)
        Rec[keybase+"age_sigma"]= '%10.4e'%(sigma)
        Rec[keybase+"age_unit"]=DefaultAge[2]
    return Rec
#
def adjust_ages(AgesIn):
    """
    Function to adjust ages to a common age_unit
    """
# get a list of age_units first
    age_units,AgesOut,factors,factor,maxunit,age_unit=[],[],[],1,1,"Ma"
    for agerec in AgesIn:
        if agerec[1] not in age_units:
            age_units.append(agerec[1])
            if agerec[1]=="Ga":
                factors.append(1e9)
                maxunit,age_unit,factor=1e9,"Ga",1e9
            if agerec[1]=="Ma":
                if maxunit==1:maxunit,age_unt,factor=1e6,"Ma",1e6
                factors.append(1e6)
            if agerec[1]=="Ka":
                factors.append(1e3)
                if maxunit==1:maxunit,age_unit,factor=1e3,"Ka",1e3
            if "Years" in agerec[1].split():factors.append(1)
    if len(age_units)==1: # all ages are of same type
        for agerec in AgesIn:
            AgesOut.append(agerec[0])
    elif len(age_units)>1:
        for agerec in AgesIn:  # normalize all to largest age unit
            if agerec[1]=="Ga":AgesOut.append(agerec[0]*1e9/factor)
            if agerec[1]=="Ma":AgesOut.append(agerec[0]*1e6/factor)
            if agerec[1]=="Ka":AgesOut.append(agerec[0]*1e3/factor)
            if "Years" in agerec[1].split():
                if agerec[1]=="Years BP":AgesOut.append(agerec[0]/factor)
                if agerec[1]=="Years Cal BP":AgesOut.append(agerec[0]/factor)
                if agerec[1]=="Years AD (+/-)":AgesOut.append((1950-agerec[0])/factor) # convert to years BP first
                if agerec[1]=="Years Cal AD (+/-)":AgesOut.append((1950-agerec[0])/factor)
    return AgesOut,age_unit
#
def gaussdev(mean,sigma):
    """
    returns a number randomly drawn from a gaussian distribution with the given mean, sigma
    """
    return random.normal(mean,sigma) # return gaussian deviate
#
def get_unf(N):
    """
    Called with get_unf(N).
 subroutine to retrieve N uniformly distributed directions
 using the way described in Fisher et al. (1987).
    """
#
# get uniform directions  [dec,inc]
    z=random.uniform(-1.,1.,size=N)
    t=random.uniform(0.,360.,size=N) # decs
    i=numpy.arcsin(z)*180./numpy.pi # incs
    return numpy.array([t,i]).transpose()

#def get_unf(N): #Jeff's way
    """
     subroutine to retrieve N uniformly distributed directions
    """
#    nmax,k=5550,66   # initialize stuff for uniform distribution
#    di,xn,yn,zn=[],[],[],[]
##
## get uniform direcctions (x,y,z)
#    for  i in range(1,k):
#        m = int(2*float(k)*numpy.sin(numpy.pi*float(i)/float(k)))
#        for j in range(m):
#            x=numpy.sin(numpy.pi*float(i)/float(k))*numpy.cos(2.*numpy.pi*float(j)/float(m))
#            y=numpy.sin(numpy.pi*float(i)/float(k))*numpy.sin(2.*numpy.pi*float(j)/float(m))
#            z=numpy.cos(numpy.pi*float(i)/float(k))
#            r=numpy.sqrt(x**2+y**2+z**2)
#            xn.append(x/r)
#            yn.append(y/r)
#            zn.append(z/r)
##
## select N random phi/theta from unf dist.
#
#    while len(di)<N:
#        ind=random.randint(0,len(xn)-1)
#        dir=cart2dir((xn[ind],yn[ind],zn[ind]))
#        di.append([dir[0],dir[1]])
#    return di
##
def s2a(s):
    """
     convert 6 element "s" list to 3,3 a matrix (see Tauxe 1998)
    """
    a=numpy.zeros((3,3,),'f') # make the a matrix
    for i in range(3):
        a[i][i]=s[i]
    a[0][1],a[1][0]=s[3],s[3]
    a[1][2],a[2][1]=s[4],s[4]
    a[0][2],a[2][0]=s[5],s[5]
    return a
#
def a2s(a):
    """
     convert 3,3 a matrix to 6 element "s" list  (see Tauxe 1998)
    """
    s=numpy.zeros((6,),'f') # make the a matrix
    for i in range(3):
        s[i]=a[i][i]
    s[3]=a[0][1]
    s[4]=a[1][2]
    s[5]=a[0][2]
    return s

def doseigs(s):
    """
    convert s format for eigenvalues and eigenvectors
    """
#
    A=s2a(s) # convert s to a (see Tauxe 1998)
    tau,V=tauV(A) # convert to eigenvalues (t), eigenvectors (V)
    Vdirs=[]
    for v in V: # convert from cartesian to direction
        Vdir= cart2dir(v)
        if Vdir[1]<0:
            Vdir[1]=-Vdir[1]
            Vdir[0]=(Vdir[0]+180.)%360.
        Vdirs.append([Vdir[0],Vdir[1]])
    return tau,Vdirs
#
#
def doeigs_s(tau,Vdirs):
    """
     get elements of s from eigenvaulues - note that this is very unstable
    """
#
    V=[]
    t=numpy.zeros((3,3,),'f') # initialize the tau diagonal matrix
    for j in range(3): t[j][j]=tau[j] # diagonalize tau
    for k in range(3):
        V.append(dir2cart([Vdirs[k][0],Vdirs[k][1],1.0]))
    V=numpy.transpose(V)
    tmp=numpy.dot(V,t)
    chi=numpy.dot(tmp,numpy.transpose(V))
    return a2s(chi)
#
#
def fcalc(col,row):
    """
  looks up f from ftables F(row,col), where row is number of degrees of freedom - this is 95% confidence (p=0.05)
    """
#
    if row>200:row=200
    if col>20:col=20
    ftest=numpy.array([[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20],
[1, 161.469, 199.493, 215.737, 224.5, 230.066, 234.001, 236.772, 238.949, 240.496, 241.838, 242.968, 243.88, 244.798, 245.26, 245.956, 246.422, 246.89, 247.36, 247.596, 248.068],
[2, 18.5128, 18.9995, 19.1642, 19.2467, 19.2969, 19.3299, 19.3536, 19.371, 19.3852, 19.3963, 19.4043, 19.4122, 19.4186, 19.425, 19.4297, 19.4329, 19.4377, 19.4409, 19.4425, 19.4457],
[3, 10.1278, 9.5522, 9.2767, 9.1173, 9.0133, 8.9408, 8.8868, 8.8452, 8.8124, 8.7857, 8.7635, 8.7446, 8.7287, 8.715, 8.7028, 8.6923, 8.683, 8.6745, 8.667, 8.6602],
[4, 7.7087, 6.9444, 6.5915, 6.3882, 6.2561, 6.1631, 6.0943, 6.0411, 5.9988, 5.9644, 5.9359, 5.9117, 5.8912, 5.8733, 5.8578, 5.844, 5.8319, 5.8211, 5.8113, 5.8025],
[5, 6.608, 5.7861, 5.4095, 5.1922, 5.0503, 4.9503, 4.8759, 4.8184, 4.7725, 4.735, 4.7039, 4.6777, 4.6552, 4.6358, 4.6187, 4.6038, 4.5904, 4.5785, 4.5679, 4.5581],
[6, 5.9874, 5.1433, 4.757, 4.5337, 4.3874, 4.2838, 4.2067, 4.1468, 4.099, 4.06, 4.0275, 3.9999, 3.9764, 3.956, 3.9381, 3.9223, 3.9083, 3.8957, 3.8844, 3.8742],
[7, 5.5914, 4.7374, 4.3469, 4.1204, 3.9715, 3.866, 3.787, 3.7257, 3.6767, 3.6366, 3.603, 3.5747, 3.5504, 3.5292, 3.5107, 3.4944, 3.4799, 3.4669, 3.4552, 3.4445],
[8, 5.3177, 4.459, 4.0662, 3.8378, 3.6875, 3.5806, 3.5004, 3.4381, 3.3881, 3.3472, 3.313, 3.2839, 3.259, 3.2374, 3.2184, 3.2017, 3.1867, 3.1733, 3.1613, 3.1503],
[9, 5.1174, 4.2565, 3.8626, 3.6331, 3.4817, 3.3738, 3.2928, 3.2296, 3.1789, 3.1373, 3.1025, 3.0729, 3.0475, 3.0255, 3.0061, 2.989, 2.9737, 2.96, 2.9476, 2.9365],
[10, 4.9647, 4.1028, 3.7083, 3.4781, 3.3258, 3.2171, 3.1355, 3.0717, 3.0204, 2.9782, 2.9429, 2.913, 2.8872, 2.8648, 2.845, 2.8276, 2.812, 2.7981, 2.7855, 2.774],
[11, 4.8443, 3.9823, 3.5875, 3.3567, 3.2039, 3.0946, 3.0123, 2.948, 2.8962, 2.8536, 2.8179, 2.7876, 2.7614, 2.7386, 2.7186, 2.7009, 2.6851, 2.6709, 2.6581, 2.6464],
[12, 4.7472, 3.8853, 3.4903, 3.2592, 3.1059, 2.9961, 2.9134, 2.8486, 2.7964, 2.7534, 2.7173, 2.6866, 2.6602, 2.6371, 2.6169, 2.5989, 2.5828, 2.5684, 2.5554, 2.5436],
[13, 4.6672, 3.8055, 3.4106, 3.1791, 3.0255, 2.9153, 2.8321, 2.7669, 2.7144, 2.6711, 2.6347, 2.6037, 2.5769, 2.5536, 2.5331, 2.5149, 2.4987, 2.4841, 2.4709, 2.4589],
[14, 4.6001, 3.7389, 3.3439, 3.1122, 2.9582, 2.8477, 2.7642, 2.6987, 2.6458, 2.6021, 2.5655, 2.5343, 2.5073, 2.4837, 2.463, 2.4446, 2.4282, 2.4134, 2.4, 2.3879],
[15, 4.543, 3.6824, 3.2874, 3.0555, 2.9013, 2.7905, 2.7066, 2.6408, 2.5877, 2.5437, 2.5068, 2.4753, 2.4481, 2.4244, 2.4034, 2.3849, 2.3683, 2.3533, 2.3398, 2.3275],
[16, 4.494, 3.6337, 3.2389, 3.0069, 2.8524, 2.7413, 2.6572, 2.5911, 2.5377, 2.4935, 2.4564, 2.4247, 2.3973, 2.3733, 2.3522, 2.3335, 2.3167, 2.3016, 2.288, 2.2756],
[17, 4.4513, 3.5916, 3.1968, 2.9647, 2.81, 2.6987, 2.6143, 2.548, 2.4943, 2.4499, 2.4126, 2.3807, 2.3531, 2.329, 2.3077, 2.2888, 2.2719, 2.2567, 2.2429, 2.2303],
[18, 4.4139, 3.5546, 3.1599, 2.9278, 2.7729, 2.6613, 2.5767, 2.5102, 2.4563, 2.4117, 2.3742, 2.3421, 2.3143, 2.29, 2.2686, 2.2496, 2.2325, 2.2172, 2.2033, 2.1906],
[19, 4.3808, 3.5219, 3.1274, 2.8951, 2.7401, 2.6283, 2.5435, 2.4768, 2.4227, 2.378, 2.3402, 2.308, 2.28, 2.2556, 2.2341, 2.2149, 2.1977, 2.1823, 2.1683, 2.1555],
[20, 4.3512, 3.4928, 3.0984, 2.8661, 2.7109, 2.599, 2.514, 2.4471, 2.3928, 2.3479, 2.31, 2.2776, 2.2495, 2.2249, 2.2033, 2.184, 2.1667, 2.1511, 2.137, 2.1242],
[21, 4.3248, 3.4668, 3.0725, 2.8401, 2.6848, 2.5727, 2.4876, 2.4205, 2.3661, 2.3209, 2.2829, 2.2504, 2.2222, 2.1975, 2.1757, 2.1563, 2.1389, 2.1232, 2.109, 2.096],
[22, 4.3009, 3.4434, 3.0492, 2.8167, 2.6613, 2.5491, 2.4638, 2.3965, 2.3419, 2.2967, 2.2585, 2.2258, 2.1975, 2.1727, 2.1508, 2.1313, 2.1138, 2.098, 2.0837, 2.0707],
[23, 4.2794, 3.4221, 3.028, 2.7955, 2.64, 2.5276, 2.4422, 2.3748, 2.3201, 2.2747, 2.2364, 2.2036, 2.1752, 2.1503, 2.1282, 2.1086, 2.091, 2.0751, 2.0608, 2.0476],
[24, 4.2597, 3.4029, 3.0088, 2.7763, 2.6206, 2.5082, 2.4226, 2.3551, 2.3003, 2.2547, 2.2163, 2.1834, 2.1548, 2.1298, 2.1077, 2.088, 2.0703, 2.0543, 2.0399, 2.0267],
[25, 4.2417, 3.3852, 2.9913, 2.7587, 2.603, 2.4904, 2.4047, 2.3371, 2.2821, 2.2365, 2.1979, 2.1649, 2.1362, 2.1111, 2.0889, 2.0691, 2.0513, 2.0353, 2.0207, 2.0075],
[26, 4.2252, 3.369, 2.9752, 2.7426, 2.5868, 2.4741, 2.3883, 2.3205, 2.2655, 2.2197, 2.1811, 2.1479, 2.1192, 2.094, 2.0716, 2.0518, 2.0339, 2.0178, 2.0032, 1.9898],
[27, 4.21, 3.3542, 2.9603, 2.7277, 2.5719, 2.4591, 2.3732, 2.3053, 2.2501, 2.2043, 2.1656, 2.1323, 2.1035, 2.0782, 2.0558, 2.0358, 2.0179, 2.0017, 1.987, 1.9736],
[28, 4.196, 3.3404, 2.9467, 2.7141, 2.5581, 2.4453, 2.3592, 2.2913, 2.236, 2.1901, 2.1512, 2.1179, 2.0889, 2.0636, 2.0411, 2.021, 2.0031, 1.9868, 1.972, 1.9586],
[29, 4.1829, 3.3276, 2.9341, 2.7014, 2.5454, 2.4324, 2.3463, 2.2783, 2.2229, 2.1768, 2.1379, 2.1045, 2.0755, 2.05, 2.0275, 2.0074, 1.9893, 1.973, 1.9582, 1.9446],
[30, 4.1709, 3.3158, 2.9223, 2.6896, 2.5335, 2.4205, 2.3343, 2.2662, 2.2107, 2.1646, 2.1255, 2.0921, 2.0629, 2.0374, 2.0148, 1.9946, 1.9765, 1.9601, 1.9452, 1.9317],
[31, 4.1597, 3.3048, 2.9113, 2.6787, 2.5225, 2.4094, 2.3232, 2.2549, 2.1994, 2.1531, 2.1141, 2.0805, 2.0513, 2.0257, 2.003, 1.9828, 1.9646, 1.9481, 1.9332, 1.9196],
[32, 4.1491, 3.2945, 2.9011, 2.6684, 2.5123, 2.3991, 2.3127, 2.2444, 2.1888, 2.1425, 2.1033, 2.0697, 2.0404, 2.0147, 1.992, 1.9717, 1.9534, 1.9369, 1.9219, 1.9083],
[33, 4.1392, 3.2849, 2.8915, 2.6589, 2.5027, 2.3894, 2.303, 2.2346, 2.1789, 2.1325, 2.0933, 2.0596, 2.0302, 2.0045, 1.9817, 1.9613, 1.943, 1.9264, 1.9114, 1.8977],
[34, 4.13, 3.2759, 2.8826, 2.6499, 2.4936, 2.3803, 2.2938, 2.2253, 2.1696, 2.1231, 2.0838, 2.05, 2.0207, 1.9949, 1.972, 1.9516, 1.9332, 1.9166, 1.9015, 1.8877],
[35, 4.1214, 3.2674, 2.8742, 2.6415, 2.4851, 2.3718, 2.2852, 2.2167, 2.1608, 2.1143, 2.0749, 2.0411, 2.0117, 1.9858, 1.9629, 1.9424, 1.924, 1.9073, 1.8922, 1.8784],
[36, 4.1132, 3.2594, 2.8663, 2.6335, 2.4771, 2.3637, 2.2771, 2.2085, 2.1526, 2.1061, 2.0666, 2.0327, 2.0032, 1.9773, 1.9543, 1.9338, 1.9153, 1.8986, 1.8834, 1.8696],
[37, 4.1055, 3.2519, 2.8588, 2.6261, 2.4696, 2.3562, 2.2695, 2.2008, 2.1449, 2.0982, 2.0587, 2.0248, 1.9952, 1.9692, 1.9462, 1.9256, 1.9071, 1.8904, 1.8752, 1.8613],
[38, 4.0981, 3.2448, 2.8517, 2.619, 2.4625, 2.349, 2.2623, 2.1935, 2.1375, 2.0909, 2.0513, 2.0173, 1.9877, 1.9617, 1.9386, 1.9179, 1.8994, 1.8826, 1.8673, 1.8534],
[39, 4.0913, 3.2381, 2.8451, 2.6123, 2.4558, 2.3422, 2.2555, 2.1867, 2.1306, 2.0839, 2.0442, 2.0102, 1.9805, 1.9545, 1.9313, 1.9107, 1.8921, 1.8752, 1.8599, 1.8459],
[40, 4.0848, 3.2317, 2.8388, 2.606, 2.4495, 2.3359, 2.249, 2.1802, 2.124, 2.0773, 2.0376, 2.0035, 1.9738, 1.9476, 1.9245, 1.9038, 1.8851, 1.8682, 1.8529, 1.8389],
[41, 4.0786, 3.2257, 2.8328, 2.6, 2.4434, 2.3298, 2.2429, 2.174, 2.1178, 2.071, 2.0312, 1.9971, 1.9673, 1.9412, 1.9179, 1.8972, 1.8785, 1.8616, 1.8462, 1.8321],
[42, 4.0727, 3.2199, 2.8271, 2.5943, 2.4377, 2.324, 2.2371, 2.1681, 2.1119, 2.065, 2.0252, 1.991, 1.9612, 1.935, 1.9118, 1.8909, 1.8722, 1.8553, 1.8399, 1.8258],
[43, 4.067, 3.2145, 2.8216, 2.5888, 2.4322, 2.3185, 2.2315, 2.1625, 2.1062, 2.0593, 2.0195, 1.9852, 1.9554, 1.9292, 1.9059, 1.885, 1.8663, 1.8493, 1.8338, 1.8197],
[44, 4.0617, 3.2093, 2.8165, 2.5837, 2.4271, 2.3133, 2.2262, 2.1572, 2.1009, 2.0539, 2.014, 1.9797, 1.9499, 1.9236, 1.9002, 1.8794, 1.8606, 1.8436, 1.8281, 1.8139],
[45, 4.0566, 3.2043, 2.8115, 2.5787, 2.4221, 2.3083, 2.2212, 2.1521, 2.0958, 2.0487, 2.0088, 1.9745, 1.9446, 1.9182, 1.8949, 1.874, 1.8551, 1.8381, 1.8226, 1.8084],
[46, 4.0518, 3.1996, 2.8068, 2.574, 2.4174, 2.3035, 2.2164, 2.1473, 2.0909, 2.0438, 2.0039, 1.9695, 1.9395, 1.9132, 1.8898, 1.8688, 1.85, 1.8329, 1.8173, 1.8031],
[47, 4.0471, 3.1951, 2.8024, 2.5695, 2.4128, 2.299, 2.2118, 2.1427, 2.0862, 2.0391, 1.9991, 1.9647, 1.9347, 1.9083, 1.8849, 1.8639, 1.845, 1.8279, 1.8123, 1.798],
[48, 4.0426, 3.1907, 2.7981, 2.5653, 2.4085, 2.2946, 2.2074, 2.1382, 2.0817, 2.0346, 1.9946, 1.9601, 1.9301, 1.9037, 1.8802, 1.8592, 1.8402, 1.8231, 1.8075, 1.7932],
[49, 4.0384, 3.1866, 2.7939, 2.5611, 2.4044, 2.2904, 2.2032, 2.134, 2.0774, 2.0303, 1.9902, 1.9558, 1.9257, 1.8992, 1.8757, 1.8547, 1.8357, 1.8185, 1.8029, 1.7886],
[50, 4.0343, 3.1826, 2.79, 2.5572, 2.4004, 2.2864, 2.1992, 2.1299, 2.0734, 2.0261, 1.9861, 1.9515, 1.9214, 1.8949, 1.8714, 1.8503, 1.8313, 1.8141, 1.7985, 1.7841],
[51, 4.0303, 3.1788, 2.7862, 2.5534, 2.3966, 2.2826, 2.1953, 2.126, 2.0694, 2.0222, 1.982, 1.9475, 1.9174, 1.8908, 1.8673, 1.8462, 1.8272, 1.8099, 1.7942, 1.7798],
[52, 4.0266, 3.1752, 2.7826, 2.5498, 2.3929, 2.2789, 2.1916, 2.1223, 2.0656, 2.0184, 1.9782, 1.9436, 1.9134, 1.8869, 1.8633, 1.8422, 1.8231, 1.8059, 1.7901, 1.7758],
[53, 4.023, 3.1716, 2.7791, 2.5463, 2.3894, 2.2754, 2.1881, 2.1187, 2.062, 2.0147, 1.9745, 1.9399, 1.9097, 1.8831, 1.8595, 1.8383, 1.8193, 1.802, 1.7862, 1.7718],
[54, 4.0196, 3.1683, 2.7757, 2.5429, 2.3861, 2.272, 2.1846, 2.1152, 2.0585, 2.0112, 1.971, 1.9363, 1.9061, 1.8795, 1.8558, 1.8346, 1.8155, 1.7982, 1.7825, 1.768],
[55, 4.0162, 3.165, 2.7725, 2.5397, 2.3828, 2.2687, 2.1813, 2.1119, 2.0552, 2.0078, 1.9676, 1.9329, 1.9026, 1.876, 1.8523, 1.8311, 1.812, 1.7946, 1.7788, 1.7644],
[56, 4.0129, 3.1618, 2.7694, 2.5366, 2.3797, 2.2656, 2.1781, 2.1087, 2.0519, 2.0045, 1.9642, 1.9296, 1.8993, 1.8726, 1.8489, 1.8276, 1.8085, 1.7912, 1.7753, 1.7608],
[57, 4.0099, 3.1589, 2.7665, 2.5336, 2.3767, 2.2625, 2.1751, 2.1056, 2.0488, 2.0014, 1.9611, 1.9264, 1.896, 1.8693, 1.8456, 1.8244, 1.8052, 1.7878, 1.772, 1.7575],
[58, 4.0069, 3.1559, 2.7635, 2.5307, 2.3738, 2.2596, 2.1721, 2.1026, 2.0458, 1.9983, 1.958, 1.9233, 1.8929, 1.8662, 1.8424, 1.8212, 1.802, 1.7846, 1.7687, 1.7542],
[59, 4.0039, 3.1531, 2.7608, 2.5279, 2.371, 2.2568, 2.1693, 2.0997, 2.0429, 1.9954, 1.9551, 1.9203, 1.8899, 1.8632, 1.8394, 1.8181, 1.7989, 1.7815, 1.7656, 1.751],
[60, 4.0012, 3.1504, 2.7581, 2.5252, 2.3683, 2.254, 2.1665, 2.097, 2.0401, 1.9926, 1.9522, 1.9174, 1.887, 1.8603, 1.8364, 1.8151, 1.7959, 1.7784, 1.7625, 1.748],
[61, 3.9985, 3.1478, 2.7555, 2.5226, 2.3657, 2.2514, 2.1639, 2.0943, 2.0374, 1.9899, 1.9495, 1.9146, 1.8842, 1.8574, 1.8336, 1.8122, 1.793, 1.7755, 1.7596, 1.745],
[62, 3.9959, 3.1453, 2.753, 2.5201, 2.3631, 2.2489, 2.1613, 2.0917, 2.0348, 1.9872, 1.9468, 1.9119, 1.8815, 1.8547, 1.8308, 1.8095, 1.7902, 1.7727, 1.7568, 1.7422],
[63, 3.9934, 3.1428, 2.7506, 2.5176, 2.3607, 2.2464, 2.1588, 2.0892, 2.0322, 1.9847, 1.9442, 1.9093, 1.8789, 1.852, 1.8282, 1.8068, 1.7875, 1.77, 1.754, 1.7394],
[64, 3.9909, 3.1404, 2.7482, 2.5153, 2.3583, 2.244, 2.1564, 2.0868, 2.0298, 1.9822, 1.9417, 1.9068, 1.8763, 1.8495, 1.8256, 1.8042, 1.7849, 1.7673, 1.7514, 1.7368],
[65, 3.9885, 3.1381, 2.7459, 2.513, 2.356, 2.2417, 2.1541, 2.0844, 2.0274, 1.9798, 1.9393, 1.9044, 1.8739, 1.847, 1.8231, 1.8017, 1.7823, 1.7648, 1.7488, 1.7342],
[66, 3.9862, 3.1359, 2.7437, 2.5108, 2.3538, 2.2395, 2.1518, 2.0821, 2.0251, 1.9775, 1.937, 1.902, 1.8715, 1.8446, 1.8207, 1.7992, 1.7799, 1.7623, 1.7463, 1.7316],
[67, 3.9841, 3.1338, 2.7416, 2.5087, 2.3516, 2.2373, 2.1497, 2.0799, 2.0229, 1.9752, 1.9347, 1.8997, 1.8692, 1.8423, 1.8183, 1.7968, 1.7775, 1.7599, 1.7439, 1.7292],
[68, 3.9819, 3.1317, 2.7395, 2.5066, 2.3496, 2.2352, 2.1475, 2.0778, 2.0207, 1.973, 1.9325, 1.8975, 1.867, 1.84, 1.816, 1.7945, 1.7752, 1.7576, 1.7415, 1.7268],
[69, 3.9798, 3.1297, 2.7375, 2.5046, 2.3475, 2.2332, 2.1455, 2.0757, 2.0186, 1.9709, 1.9303, 1.8954, 1.8648, 1.8378, 1.8138, 1.7923, 1.7729, 1.7553, 1.7393, 1.7246],
[70, 3.9778, 3.1277, 2.7355, 2.5027, 2.3456, 2.2312, 2.1435, 2.0737, 2.0166, 1.9689, 1.9283, 1.8932, 1.8627, 1.8357, 1.8117, 1.7902, 1.7707, 1.7531, 1.7371, 1.7223],
[71, 3.9758, 3.1258, 2.7336, 2.5007, 2.3437, 2.2293, 2.1415, 2.0717, 2.0146, 1.9669, 1.9263, 1.8912, 1.8606, 1.8336, 1.8096, 1.7881, 1.7686, 1.751, 1.7349, 1.7202],
[72, 3.9739, 3.1239, 2.7318, 2.4989, 2.3418, 2.2274, 2.1397, 2.0698, 2.0127, 1.9649, 1.9243, 1.8892, 1.8586, 1.8316, 1.8076, 1.786, 1.7666, 1.7489, 1.7328, 1.7181],
[73, 3.9721, 3.1221, 2.73, 2.4971, 2.34, 2.2256, 2.1378, 2.068, 2.0108, 1.9631, 1.9224, 1.8873, 1.8567, 1.8297, 1.8056, 1.784, 1.7646, 1.7469, 1.7308, 1.716],
[74, 3.9703, 3.1204, 2.7283, 2.4954, 2.3383, 2.2238, 2.1361, 2.0662, 2.009, 1.9612, 1.9205, 1.8854, 1.8548, 1.8278, 1.8037, 1.7821, 1.7626, 1.7449, 1.7288, 1.714],
[75, 3.9685, 3.1186, 2.7266, 2.4937, 2.3366, 2.2221, 2.1343, 2.0645, 2.0073, 1.9595, 1.9188, 1.8836, 1.853, 1.8259, 1.8018, 1.7802, 1.7607, 1.7431, 1.7269, 1.7121],
[76, 3.9668, 3.117, 2.7249, 2.4921, 2.3349, 2.2204, 2.1326, 2.0627, 2.0055, 1.9577, 1.917, 1.8819, 1.8512, 1.8241, 1.8, 1.7784, 1.7589, 1.7412, 1.725, 1.7102],
[77, 3.9651, 3.1154, 2.7233, 2.4904, 2.3333, 2.2188, 2.131, 2.0611, 2.0039, 1.956, 1.9153, 1.8801, 1.8494, 1.8223, 1.7982, 1.7766, 1.7571, 1.7394, 1.7232, 1.7084],
[78, 3.9635, 3.1138, 2.7218, 2.4889, 2.3318, 2.2172, 2.1294, 2.0595, 2.0022, 1.9544, 1.9136, 1.8785, 1.8478, 1.8206, 1.7965, 1.7749, 1.7554, 1.7376, 1.7214, 1.7066],
[79, 3.9619, 3.1123, 2.7203, 2.4874, 2.3302, 2.2157, 2.1279, 2.0579, 2.0006, 1.9528, 1.912, 1.8769, 1.8461, 1.819, 1.7948, 1.7732, 1.7537, 1.7359, 1.7197, 1.7048],
[80, 3.9604, 3.1107, 2.7188, 2.4859, 2.3287, 2.2142, 2.1263, 2.0564, 1.9991, 1.9512, 1.9105, 1.8753, 1.8445, 1.8174, 1.7932, 1.7716, 1.752, 1.7342, 1.718, 1.7032],
[81, 3.9589, 3.1093, 2.7173, 2.4845, 2.3273, 2.2127, 2.1248, 2.0549, 1.9976, 1.9497, 1.9089, 1.8737, 1.8429, 1.8158, 1.7916, 1.77, 1.7504, 1.7326, 1.7164, 1.7015],
[82, 3.9574, 3.1079, 2.716, 2.483, 2.3258, 2.2113, 2.1234, 2.0534, 1.9962, 1.9482, 1.9074, 1.8722, 1.8414, 1.8143, 1.7901, 1.7684, 1.7488, 1.731, 1.7148, 1.6999],
[83, 3.956, 3.1065, 2.7146, 2.4817, 2.3245, 2.2099, 2.122, 2.052, 1.9947, 1.9468, 1.906, 1.8707, 1.8399, 1.8127, 1.7886, 1.7669, 1.7473, 1.7295, 1.7132, 1.6983],
[84, 3.9546, 3.1051, 2.7132, 2.4803, 2.3231, 2.2086, 2.1206, 2.0506, 1.9933, 1.9454, 1.9045, 1.8693, 1.8385, 1.8113, 1.7871, 1.7654, 1.7458, 1.728, 1.7117, 1.6968],
[85, 3.9532, 3.1039, 2.7119, 2.479, 2.3218, 2.2072, 2.1193, 2.0493, 1.9919, 1.944, 1.9031, 1.8679, 1.8371, 1.8099, 1.7856, 1.7639, 1.7443, 1.7265, 1.7102, 1.6953],
[86, 3.9519, 3.1026, 2.7106, 2.4777, 2.3205, 2.2059, 2.118, 2.048, 1.9906, 1.9426, 1.9018, 1.8665, 1.8357, 1.8085, 1.7842, 1.7625, 1.7429, 1.725, 1.7088, 1.6938],
[87, 3.9506, 3.1013, 2.7094, 2.4765, 2.3193, 2.2047, 2.1167, 2.0467, 1.9893, 1.9413, 1.9005, 1.8652, 1.8343, 1.8071, 1.7829, 1.7611, 1.7415, 1.7236, 1.7073, 1.6924],
[88, 3.9493, 3.1001, 2.7082, 2.4753, 2.318, 2.2034, 2.1155, 2.0454, 1.9881, 1.94, 1.8992, 1.8639, 1.833, 1.8058, 1.7815, 1.7598, 1.7401, 1.7223, 1.706, 1.691],
[89, 3.9481, 3.0988, 2.707, 2.4741, 2.3169, 2.2022, 2.1143, 2.0442, 1.9868, 1.9388, 1.8979, 1.8626, 1.8317, 1.8045, 1.7802, 1.7584, 1.7388, 1.7209, 1.7046, 1.6896],
[90, 3.9469, 3.0977, 2.7058, 2.4729, 2.3157, 2.2011, 2.1131, 2.043, 1.9856, 1.9376, 1.8967, 1.8613, 1.8305, 1.8032, 1.7789, 1.7571, 1.7375, 1.7196, 1.7033, 1.6883],
[91, 3.9457, 3.0965, 2.7047, 2.4718, 2.3146, 2.1999, 2.1119, 2.0418, 1.9844, 1.9364, 1.8955, 1.8601, 1.8292, 1.802, 1.7777, 1.7559, 1.7362, 1.7183, 1.702, 1.687],
[92, 3.9446, 3.0955, 2.7036, 2.4707, 2.3134, 2.1988, 2.1108, 2.0407, 1.9833, 1.9352, 1.8943, 1.8589, 1.828, 1.8008, 1.7764, 1.7546, 1.735, 1.717, 1.7007, 1.6857],
[93, 3.9435, 3.0944, 2.7025, 2.4696, 2.3123, 2.1977, 2.1097, 2.0395, 1.9821, 1.934, 1.8931, 1.8578, 1.8269, 1.7996, 1.7753, 1.7534, 1.7337, 1.7158, 1.6995, 1.6845],
[94, 3.9423, 3.0933, 2.7014, 2.4685, 2.3113, 2.1966, 2.1086, 2.0385, 1.981, 1.9329, 1.892, 1.8566, 1.8257, 1.7984, 1.7741, 1.7522, 1.7325, 1.7146, 1.6982, 1.6832],
[95, 3.9412, 3.0922, 2.7004, 2.4675, 2.3102, 2.1955, 2.1075, 2.0374, 1.9799, 1.9318, 1.8909, 1.8555, 1.8246, 1.7973, 1.7729, 1.7511, 1.7314, 1.7134, 1.6971, 1.682],
[96, 3.9402, 3.0912, 2.6994, 2.4665, 2.3092, 2.1945, 2.1065, 2.0363, 1.9789, 1.9308, 1.8898, 1.8544, 1.8235, 1.7961, 1.7718, 1.75, 1.7302, 1.7123, 1.6959, 1.6809],
[97, 3.9392, 3.0902, 2.6984, 2.4655, 2.3082, 2.1935, 2.1054, 2.0353, 1.9778, 1.9297, 1.8888, 1.8533, 1.8224, 1.7951, 1.7707, 1.7488, 1.7291, 1.7112, 1.6948, 1.6797],
[98, 3.9381, 3.0892, 2.6974, 2.4645, 2.3072, 2.1925, 2.1044, 2.0343, 1.9768, 1.9287, 1.8877, 1.8523, 1.8213, 1.794, 1.7696, 1.7478, 1.728, 1.71, 1.6936, 1.6786],
[99, 3.9371, 3.0882, 2.6965, 2.4636, 2.3062, 2.1916, 2.1035, 2.0333, 1.9758, 1.9277, 1.8867, 1.8513, 1.8203, 1.7929, 1.7686, 1.7467, 1.7269, 1.709, 1.6926, 1.6775],
[100, 3.9361, 3.0873, 2.6955, 2.4626, 2.3053, 2.1906, 2.1025, 2.0323, 1.9748, 1.9267, 1.8857, 1.8502, 1.8193, 1.7919, 1.7675, 1.7456, 1.7259, 1.7079, 1.6915, 1.6764],
[101, 3.9352, 3.0864, 2.6946, 2.4617, 2.3044, 2.1897, 2.1016, 2.0314, 1.9739, 1.9257, 1.8847, 1.8493, 1.8183, 1.7909, 1.7665, 1.7446, 1.7248, 1.7069, 1.6904, 1.6754],
[102, 3.9342, 3.0854, 2.6937, 2.4608, 2.3035, 2.1888, 2.1007, 2.0304, 1.9729, 1.9248, 1.8838, 1.8483, 1.8173, 1.7899, 1.7655, 1.7436, 1.7238, 1.7058, 1.6894, 1.6744],
[103, 3.9333, 3.0846, 2.6928, 2.4599, 2.3026, 2.1879, 2.0997, 2.0295, 1.972, 1.9238, 1.8828, 1.8474, 1.8163, 1.789, 1.7645, 1.7427, 1.7229, 1.7048, 1.6884, 1.6733],
[104, 3.9325, 3.0837, 2.692, 2.4591, 2.3017, 2.187, 2.0989, 2.0287, 1.9711, 1.9229, 1.8819, 1.8464, 1.8154, 1.788, 1.7636, 1.7417, 1.7219, 1.7039, 1.6874, 1.6723],
[105, 3.9316, 3.0828, 2.6912, 2.4582, 2.3009, 2.1861, 2.098, 2.0278, 1.9702, 1.922, 1.881, 1.8455, 1.8145, 1.7871, 1.7627, 1.7407, 1.7209, 1.7029, 1.6865, 1.6714],
[106, 3.9307, 3.082, 2.6903, 2.4574, 2.3, 2.1853, 2.0971, 2.0269, 1.9694, 1.9212, 1.8801, 1.8446, 1.8136, 1.7862, 1.7618, 1.7398, 1.72, 1.702, 1.6855, 1.6704],
[107, 3.9299, 3.0812, 2.6895, 2.4566, 2.2992, 2.1845, 2.0963, 2.0261, 1.9685, 1.9203, 1.8792, 1.8438, 1.8127, 1.7853, 1.7608, 1.7389, 1.7191, 1.7011, 1.6846, 1.6695],
[108, 3.929, 3.0804, 2.6887, 2.4558, 2.2984, 2.1837, 2.0955, 2.0252, 1.9677, 1.9195, 1.8784, 1.8429, 1.8118, 1.7844, 1.7599, 1.738, 1.7182, 1.7001, 1.6837, 1.6685],
[109, 3.9282, 3.0796, 2.6879, 2.455, 2.2976, 2.1828, 2.0947, 2.0244, 1.9669, 1.9186, 1.8776, 1.8421, 1.811, 1.7835, 1.7591, 1.7371, 1.7173, 1.6992, 1.6828, 1.6676],
[110, 3.9274, 3.0788, 2.6872, 2.4542, 2.2968, 2.1821, 2.0939, 2.0236, 1.9661, 1.9178, 1.8767, 1.8412, 1.8102, 1.7827, 1.7582, 1.7363, 1.7164, 1.6984, 1.6819, 1.6667],
[111, 3.9266, 3.0781, 2.6864, 2.4535, 2.2961, 2.1813, 2.0931, 2.0229, 1.9653, 1.917, 1.8759, 1.8404, 1.8093, 1.7819, 1.7574, 1.7354, 1.7156, 1.6975, 1.681, 1.6659],
[112, 3.9258, 3.0773, 2.6857, 2.4527, 2.2954, 2.1806, 2.0924, 2.0221, 1.9645, 1.9163, 1.8751, 1.8396, 1.8085, 1.7811, 1.7566, 1.7346, 1.7147, 1.6967, 1.6802, 1.665],
[113, 3.9251, 3.0766, 2.6849, 2.452, 2.2946, 2.1798, 2.0916, 2.0213, 1.9637, 1.9155, 1.8744, 1.8388, 1.8077, 1.7803, 1.7558, 1.7338, 1.7139, 1.6958, 1.6793, 1.6642],
[114, 3.9243, 3.0758, 2.6842, 2.4513, 2.2939, 2.1791, 2.0909, 2.0206, 1.963, 1.9147, 1.8736, 1.8381, 1.8069, 1.7795, 1.755, 1.733, 1.7131, 1.695, 1.6785, 1.6633],
[115, 3.9236, 3.0751, 2.6835, 2.4506, 2.2932, 2.1784, 2.0902, 2.0199, 1.9623, 1.914, 1.8729, 1.8373, 1.8062, 1.7787, 1.7542, 1.7322, 1.7123, 1.6942, 1.6777, 1.6625],
[116, 3.9228, 3.0744, 2.6828, 2.4499, 2.2925, 2.1777, 2.0895, 2.0192, 1.9615, 1.9132, 1.8721, 1.8365, 1.8054, 1.7779, 1.7534, 1.7314, 1.7115, 1.6934, 1.6769, 1.6617],
[117, 3.9222, 3.0738, 2.6821, 2.4492, 2.2918, 2.177, 2.0888, 2.0185, 1.9608, 1.9125, 1.8714, 1.8358, 1.8047, 1.7772, 1.7527, 1.7307, 1.7108, 1.6927, 1.6761, 1.6609],
[118, 3.9215, 3.0731, 2.6815, 2.4485, 2.2912, 2.1763, 2.0881, 2.0178, 1.9601, 1.9118, 1.8707, 1.8351, 1.804, 1.7765, 1.752, 1.7299, 1.71, 1.6919, 1.6754, 1.6602],
[119, 3.9208, 3.0724, 2.6808, 2.4479, 2.2905, 2.1757, 2.0874, 2.0171, 1.9594, 1.9111, 1.87, 1.8344, 1.8032, 1.7757, 1.7512, 1.7292, 1.7093, 1.6912, 1.6746, 1.6594],
[120, 3.9202, 3.0718, 2.6802, 2.4472, 2.2899, 2.175, 2.0868, 2.0164, 1.9588, 1.9105, 1.8693, 1.8337, 1.8026, 1.775, 1.7505, 1.7285, 1.7085, 1.6904, 1.6739, 1.6587],
[121, 3.9194, 3.0712, 2.6795, 2.4466, 2.2892, 2.1744, 2.0861, 2.0158, 1.9581, 1.9098, 1.8686, 1.833, 1.8019, 1.7743, 1.7498, 1.7278, 1.7078, 1.6897, 1.6732, 1.6579],
[122, 3.9188, 3.0705, 2.6789, 2.446, 2.2886, 2.1737, 2.0855, 2.0151, 1.9575, 1.9091, 1.868, 1.8324, 1.8012, 1.7736, 1.7491, 1.727, 1.7071, 1.689, 1.6724, 1.6572],
[123, 3.9181, 3.0699, 2.6783, 2.4454, 2.288, 2.1731, 2.0849, 2.0145, 1.9568, 1.9085, 1.8673, 1.8317, 1.8005, 1.773, 1.7484, 1.7264, 1.7064, 1.6883, 1.6717, 1.6565],
[124, 3.9176, 3.0693, 2.6777, 2.4448, 2.2874, 2.1725, 2.0842, 2.0139, 1.9562, 1.9078, 1.8667, 1.831, 1.7999, 1.7723, 1.7478, 1.7257, 1.7058, 1.6876, 1.6711, 1.6558],
[125, 3.9169, 3.0687, 2.6771, 2.4442, 2.2868, 2.1719, 2.0836, 2.0133, 1.9556, 1.9072, 1.866, 1.8304, 1.7992, 1.7717, 1.7471, 1.725, 1.7051, 1.6869, 1.6704, 1.6551],
[126, 3.9163, 3.0681, 2.6765, 2.4436, 2.2862, 2.1713, 2.083, 2.0126, 1.955, 1.9066, 1.8654, 1.8298, 1.7986, 1.771, 1.7464, 1.7244, 1.7044, 1.6863, 1.6697, 1.6544],
[127, 3.9157, 3.0675, 2.6759, 2.443, 2.2856, 2.1707, 2.0824, 2.0121, 1.9544, 1.906, 1.8648, 1.8291, 1.7979, 1.7704, 1.7458, 1.7237, 1.7038, 1.6856, 1.669, 1.6538],
[128, 3.9151, 3.0669, 2.6754, 2.4424, 2.285, 2.1701, 2.0819, 2.0115, 1.9538, 1.9054, 1.8642, 1.8285, 1.7974, 1.7698, 1.7452, 1.7231, 1.7031, 1.685, 1.6684, 1.6531],
[129, 3.9145, 3.0664, 2.6749, 2.4419, 2.2845, 2.1696, 2.0813, 2.0109, 1.9532, 1.9048, 1.8636, 1.828, 1.7967, 1.7692, 1.7446, 1.7225, 1.7025, 1.6843, 1.6677, 1.6525],
[130, 3.914, 3.0659, 2.6743, 2.4414, 2.2839, 2.169, 2.0807, 2.0103, 1.9526, 1.9042, 1.863, 1.8273, 1.7962, 1.7685, 1.744, 1.7219, 1.7019, 1.6837, 1.6671, 1.6519],
[131, 3.9134, 3.0653, 2.6737, 2.4408, 2.2834, 2.1685, 2.0802, 2.0098, 1.9521, 1.9037, 1.8624, 1.8268, 1.7956, 1.768, 1.7434, 1.7213, 1.7013, 1.6831, 1.6665, 1.6513],
[132, 3.9129, 3.0648, 2.6732, 2.4403, 2.2829, 2.168, 2.0796, 2.0092, 1.9515, 1.9031, 1.8619, 1.8262, 1.795, 1.7674, 1.7428, 1.7207, 1.7007, 1.6825, 1.6659, 1.6506],
[133, 3.9123, 3.0642, 2.6727, 2.4398, 2.2823, 2.1674, 2.0791, 2.0087, 1.951, 1.9026, 1.8613, 1.8256, 1.7944, 1.7668, 1.7422, 1.7201, 1.7001, 1.6819, 1.6653, 1.65],
[134, 3.9118, 3.0637, 2.6722, 2.4392, 2.2818, 2.1669, 2.0786, 2.0082, 1.9504, 1.902, 1.8608, 1.8251, 1.7939, 1.7662, 1.7416, 1.7195, 1.6995, 1.6813, 1.6647, 1.6494],
[135, 3.9112, 3.0632, 2.6717, 2.4387, 2.2813, 2.1664, 2.0781, 2.0076, 1.9499, 1.9015, 1.8602, 1.8245, 1.7933, 1.7657, 1.7411, 1.719, 1.6989, 1.6808, 1.6641, 1.6488],
[136, 3.9108, 3.0627, 2.6712, 2.4382, 2.2808, 2.1659, 2.0775, 2.0071, 1.9494, 1.901, 1.8597, 1.824, 1.7928, 1.7651, 1.7405, 1.7184, 1.6984, 1.6802, 1.6635, 1.6483],
[137, 3.9102, 3.0622, 2.6707, 2.4378, 2.2803, 2.1654, 2.077, 2.0066, 1.9488, 1.9004, 1.8592, 1.8235, 1.7922, 1.7646, 1.74, 1.7178, 1.6978, 1.6796, 1.663, 1.6477],
[138, 3.9098, 3.0617, 2.6702, 2.4373, 2.2798, 2.1649, 2.0766, 2.0061, 1.9483, 1.8999, 1.8586, 1.823, 1.7917, 1.7641, 1.7394, 1.7173, 1.6973, 1.6791, 1.6624, 1.6471],
[139, 3.9092, 3.0613, 2.6697, 2.4368, 2.2794, 2.1644, 2.0761, 2.0056, 1.9478, 1.8994, 1.8581, 1.8224, 1.7912, 1.7635, 1.7389, 1.7168, 1.6967, 1.6785, 1.6619, 1.6466],
[140, 3.9087, 3.0608, 2.6692, 2.4363, 2.2789, 2.1639, 2.0756, 2.0051, 1.9473, 1.8989, 1.8576, 1.8219, 1.7907, 1.763, 1.7384, 1.7162, 1.6962, 1.678, 1.6613, 1.646],
[141, 3.9083, 3.0603, 2.6688, 2.4359, 2.2784, 2.1634, 2.0751, 2.0046, 1.9469, 1.8984, 1.8571, 1.8214, 1.7901, 1.7625, 1.7379, 1.7157, 1.6957, 1.6775, 1.6608, 1.6455],
[142, 3.9078, 3.0598, 2.6683, 2.4354, 2.2779, 2.163, 2.0747, 2.0042, 1.9464, 1.8979, 1.8566, 1.8209, 1.7897, 1.762, 1.7374, 1.7152, 1.6952, 1.6769, 1.6603, 1.645],
[143, 3.9073, 3.0594, 2.6679, 2.435, 2.2775, 2.1625, 2.0742, 2.0037, 1.9459, 1.8975, 1.8562, 1.8204, 1.7892, 1.7615, 1.7368, 1.7147, 1.6946, 1.6764, 1.6598, 1.6444],
[144, 3.9068, 3.0589, 2.6675, 2.4345, 2.277, 2.1621, 2.0737, 2.0033, 1.9455, 1.897, 1.8557, 1.82, 1.7887, 1.761, 1.7364, 1.7142, 1.6941, 1.6759, 1.6592, 1.6439],
[145, 3.9064, 3.0585, 2.667, 2.4341, 2.2766, 2.1617, 2.0733, 2.0028, 1.945, 1.8965, 1.8552, 1.8195, 1.7882, 1.7605, 1.7359, 1.7137, 1.6936, 1.6754, 1.6587, 1.6434],
[146, 3.906, 3.0581, 2.6666, 2.4337, 2.2762, 2.1612, 2.0728, 2.0024, 1.9445, 1.8961, 1.8548, 1.819, 1.7877, 1.7601, 1.7354, 1.7132, 1.6932, 1.6749, 1.6582, 1.6429],
[147, 3.9055, 3.0576, 2.6662, 2.4332, 2.2758, 2.1608, 2.0724, 2.0019, 1.9441, 1.8956, 1.8543, 1.8186, 1.7873, 1.7596, 1.7349, 1.7127, 1.6927, 1.6744, 1.6578, 1.6424],
[148, 3.9051, 3.0572, 2.6657, 2.4328, 2.2753, 2.1604, 2.072, 2.0015, 1.9437, 1.8952, 1.8539, 1.8181, 1.7868, 1.7591, 1.7344, 1.7123, 1.6922, 1.6739, 1.6573, 1.6419],
[149, 3.9046, 3.0568, 2.6653, 2.4324, 2.2749, 2.1599, 2.0716, 2.0011, 1.9432, 1.8947, 1.8534, 1.8177, 1.7864, 1.7587, 1.734, 1.7118, 1.6917, 1.6735, 1.6568, 1.6414],
[150, 3.9042, 3.0564, 2.6649, 2.4319, 2.2745, 2.1595, 2.0711, 2.0006, 1.9428, 1.8943, 1.853, 1.8172, 1.7859, 1.7582, 1.7335, 1.7113, 1.6913, 1.673, 1.6563, 1.641],
[151, 3.9038, 3.056, 2.6645, 2.4315, 2.2741, 2.1591, 2.0707, 2.0002, 1.9424, 1.8939, 1.8526, 1.8168, 1.7855, 1.7578, 1.7331, 1.7109, 1.6908, 1.6726, 1.6558, 1.6405],
[152, 3.9033, 3.0555, 2.6641, 2.4312, 2.2737, 2.1587, 2.0703, 1.9998, 1.942, 1.8935, 1.8521, 1.8163, 1.785, 1.7573, 1.7326, 1.7104, 1.6904, 1.6721, 1.6554, 1.64],
[153, 3.903, 3.0552, 2.6637, 2.4308, 2.2733, 2.1583, 2.0699, 1.9994, 1.9416, 1.8931, 1.8517, 1.8159, 1.7846, 1.7569, 1.7322, 1.71, 1.6899, 1.6717, 1.6549, 1.6396],
[154, 3.9026, 3.0548, 2.6634, 2.4304, 2.2729, 2.1579, 2.0695, 1.999, 1.9412, 1.8926, 1.8513, 1.8155, 1.7842, 1.7565, 1.7318, 1.7096, 1.6895, 1.6712, 1.6545, 1.6391],
[155, 3.9021, 3.0544, 2.6629, 2.43, 2.2725, 2.1575, 2.0691, 1.9986, 1.9407, 1.8923, 1.8509, 1.8151, 1.7838, 1.7561, 1.7314, 1.7091, 1.6891, 1.6708, 1.654, 1.6387],
[156, 3.9018, 3.054, 2.6626, 2.4296, 2.2722, 2.1571, 2.0687, 1.9982, 1.9403, 1.8918, 1.8505, 1.8147, 1.7834, 1.7557, 1.7309, 1.7087, 1.6886, 1.6703, 1.6536, 1.6383],
[157, 3.9014, 3.0537, 2.6622, 2.4293, 2.2717, 2.1568, 2.0684, 1.9978, 1.94, 1.8915, 1.8501, 1.8143, 1.7829, 1.7552, 1.7305, 1.7083, 1.6882, 1.6699, 1.6532, 1.6378],
[158, 3.901, 3.0533, 2.6618, 2.4289, 2.2714, 2.1564, 2.068, 1.9974, 1.9396, 1.8911, 1.8497, 1.8139, 1.7826, 1.7548, 1.7301, 1.7079, 1.6878, 1.6695, 1.6528, 1.6374],
[159, 3.9006, 3.0529, 2.6615, 2.4285, 2.271, 2.156, 2.0676, 1.997, 1.9392, 1.8907, 1.8493, 1.8135, 1.7822, 1.7544, 1.7297, 1.7075, 1.6874, 1.6691, 1.6524, 1.637],
[160, 3.9002, 3.0525, 2.6611, 2.4282, 2.2706, 2.1556, 2.0672, 1.9967, 1.9388, 1.8903, 1.8489, 1.8131, 1.7818, 1.754, 1.7293, 1.7071, 1.687, 1.6687, 1.6519, 1.6366],
[161, 3.8998, 3.0522, 2.6607, 2.4278, 2.2703, 2.1553, 2.0669, 1.9963, 1.9385, 1.8899, 1.8485, 1.8127, 1.7814, 1.7537, 1.7289, 1.7067, 1.6866, 1.6683, 1.6515, 1.6361],
[162, 3.8995, 3.0518, 2.6604, 2.4275, 2.27, 2.155, 2.0665, 1.9959, 1.9381, 1.8895, 1.8482, 1.8124, 1.781, 1.7533, 1.7285, 1.7063, 1.6862, 1.6679, 1.6511, 1.6357],
[163, 3.8991, 3.0515, 2.6601, 2.4271, 2.2696, 2.1546, 2.0662, 1.9956, 1.9377, 1.8892, 1.8478, 1.812, 1.7806, 1.7529, 1.7282, 1.7059, 1.6858, 1.6675, 1.6507, 1.6353],
[164, 3.8987, 3.0512, 2.6597, 2.4268, 2.2693, 2.1542, 2.0658, 1.9953, 1.9374, 1.8888, 1.8474, 1.8116, 1.7803, 1.7525, 1.7278, 1.7055, 1.6854, 1.6671, 1.6503, 1.6349],
[165, 3.8985, 3.0508, 2.6594, 2.4264, 2.2689, 2.1539, 2.0655, 1.9949, 1.937, 1.8885, 1.8471, 1.8112, 1.7799, 1.7522, 1.7274, 1.7052, 1.685, 1.6667, 1.6499, 1.6345],
[166, 3.8981, 3.0505, 2.6591, 2.4261, 2.2686, 2.1536, 2.0651, 1.9945, 1.9367, 1.8881, 1.8467, 1.8109, 1.7795, 1.7518, 1.727, 1.7048, 1.6846, 1.6663, 1.6496, 1.6341],
[167, 3.8977, 3.0502, 2.6587, 2.4258, 2.2683, 2.1533, 2.0648, 1.9942, 1.9363, 1.8878, 1.8464, 1.8105, 1.7792, 1.7514, 1.7266, 1.7044, 1.6843, 1.6659, 1.6492, 1.6338],
[168, 3.8974, 3.0498, 2.6584, 2.4254, 2.268, 2.1529, 2.0645, 1.9939, 1.936, 1.8874, 1.846, 1.8102, 1.7788, 1.7511, 1.7263, 1.704, 1.6839, 1.6656, 1.6488, 1.6334],
[169, 3.8971, 3.0495, 2.6581, 2.4251, 2.2676, 2.1526, 2.0641, 1.9936, 1.9357, 1.8871, 1.8457, 1.8099, 1.7785, 1.7507, 1.7259, 1.7037, 1.6835, 1.6652, 1.6484, 1.633],
[170, 3.8967, 3.0492, 2.6578, 2.4248, 2.2673, 2.1523, 2.0638, 1.9932, 1.9353, 1.8868, 1.8454, 1.8095, 1.7781, 1.7504, 1.7256, 1.7033, 1.6832, 1.6648, 1.6481, 1.6326],
[171, 3.8965, 3.0488, 2.6575, 2.4245, 2.267, 2.152, 2.0635, 1.9929, 1.935, 1.8864, 1.845, 1.8092, 1.7778, 1.75, 1.7252, 1.703, 1.6828, 1.6645, 1.6477, 1.6323],
[172, 3.8961, 3.0485, 2.6571, 2.4242, 2.2667, 2.1516, 2.0632, 1.9926, 1.9347, 1.8861, 1.8447, 1.8088, 1.7774, 1.7497, 1.7249, 1.7026, 1.6825, 1.6641, 1.6473, 1.6319],
[173, 3.8958, 3.0482, 2.6568, 2.4239, 2.2664, 2.1513, 2.0628, 1.9923, 1.9343, 1.8858, 1.8443, 1.8085, 1.7771, 1.7493, 1.7246, 1.7023, 1.6821, 1.6638, 1.647, 1.6316],
[174, 3.8954, 3.0479, 2.6566, 2.4236, 2.266, 2.151, 2.0626, 1.9919, 1.934, 1.8855, 1.844, 1.8082, 1.7768, 1.749, 1.7242, 1.7019, 1.6818, 1.6634, 1.6466, 1.6312],
[175, 3.8952, 3.0476, 2.6563, 2.4233, 2.2658, 2.1507, 2.0622, 1.9916, 1.9337, 1.8852, 1.8437, 1.8078, 1.7764, 1.7487, 1.7239, 1.7016, 1.6814, 1.6631, 1.6463, 1.6309],
[176, 3.8948, 3.0473, 2.6559, 2.423, 2.2655, 2.1504, 2.0619, 1.9913, 1.9334, 1.8848, 1.8434, 1.8075, 1.7761, 1.7483, 1.7236, 1.7013, 1.6811, 1.6628, 1.646, 1.6305],
[177, 3.8945, 3.047, 2.6556, 2.4227, 2.2652, 2.1501, 2.0616, 1.991, 1.9331, 1.8845, 1.8431, 1.8072, 1.7758, 1.748, 1.7232, 1.7009, 1.6808, 1.6624, 1.6456, 1.6302],
[178, 3.8943, 3.0467, 2.6554, 2.4224, 2.2649, 2.1498, 2.0613, 1.9907, 1.9328, 1.8842, 1.8428, 1.8069, 1.7755, 1.7477, 1.7229, 1.7006, 1.6805, 1.6621, 1.6453, 1.6298],
[179, 3.8939, 3.0465, 2.6551, 2.4221, 2.2646, 2.1495, 2.0611, 1.9904, 1.9325, 1.8839, 1.8425, 1.8066, 1.7752, 1.7474, 1.7226, 1.7003, 1.6801, 1.6618, 1.645, 1.6295],
[180, 3.8936, 3.0462, 2.6548, 2.4218, 2.2643, 2.1492, 2.0608, 1.9901, 1.9322, 1.8836, 1.8422, 1.8063, 1.7749, 1.7471, 1.7223, 1.7, 1.6798, 1.6614, 1.6446, 1.6292],
[181, 3.8933, 3.0458, 2.6545, 2.4216, 2.264, 2.149, 2.0605, 1.9899, 1.9319, 1.8833, 1.8419, 1.806, 1.7746, 1.7468, 1.7219, 1.6997, 1.6795, 1.6611, 1.6443, 1.6289],
[182, 3.8931, 3.0456, 2.6543, 2.4213, 2.2638, 2.1487, 2.0602, 1.9896, 1.9316, 1.883, 1.8416, 1.8057, 1.7743, 1.7465, 1.7217, 1.6994, 1.6792, 1.6608, 1.644, 1.6286],
[183, 3.8928, 3.0453, 2.654, 2.421, 2.2635, 2.1484, 2.0599, 1.9893, 1.9313, 1.8827, 1.8413, 1.8054, 1.774, 1.7462, 1.7214, 1.6991, 1.6789, 1.6605, 1.6437, 1.6282],
[184, 3.8925, 3.045, 2.6537, 2.4207, 2.2632, 2.1481, 2.0596, 1.989, 1.9311, 1.8825, 1.841, 1.8051, 1.7737, 1.7459, 1.721, 1.6987, 1.6786, 1.6602, 1.6434, 1.6279],
[185, 3.8923, 3.0448, 2.6534, 2.4205, 2.263, 2.1479, 2.0594, 1.9887, 1.9308, 1.8822, 1.8407, 1.8048, 1.7734, 1.7456, 1.7208, 1.6984, 1.6783, 1.6599, 1.643, 1.6276],
[186, 3.892, 3.0445, 2.6531, 2.4202, 2.2627, 2.1476, 2.0591, 1.9885, 1.9305, 1.8819, 1.8404, 1.8045, 1.7731, 1.7453, 1.7205, 1.6981, 1.678, 1.6596, 1.6428, 1.6273],
[187, 3.8917, 3.0442, 2.6529, 2.4199, 2.2624, 2.1473, 2.0588, 1.9882, 1.9302, 1.8816, 1.8401, 1.8042, 1.7728, 1.745, 1.7202, 1.6979, 1.6777, 1.6593, 1.6424, 1.627],
[188, 3.8914, 3.044, 2.6526, 2.4197, 2.2621, 2.1471, 2.0586, 1.9879, 1.9299, 1.8814, 1.8399, 1.804, 1.7725, 1.7447, 1.7199, 1.6976, 1.6774, 1.659, 1.6421, 1.6267],
[189, 3.8912, 3.0437, 2.6524, 2.4195, 2.2619, 2.1468, 2.0583, 1.9877, 1.9297, 1.8811, 1.8396, 1.8037, 1.7722, 1.7444, 1.7196, 1.6973, 1.6771, 1.6587, 1.6418, 1.6264],
[190, 3.8909, 3.0435, 2.6521, 2.4192, 2.2617, 2.1466, 2.0581, 1.9874, 1.9294, 1.8808, 1.8393, 1.8034, 1.772, 1.7441, 1.7193, 1.697, 1.6768, 1.6584, 1.6416, 1.6261],
[191, 3.8906, 3.0432, 2.6519, 2.4189, 2.2614, 2.1463, 2.0578, 1.9871, 1.9292, 1.8805, 1.8391, 1.8032, 1.7717, 1.7439, 1.719, 1.6967, 1.6765, 1.6581, 1.6413, 1.6258],
[192, 3.8903, 3.043, 2.6516, 2.4187, 2.2611, 2.1461, 2.0575, 1.9869, 1.9289, 1.8803, 1.8388, 1.8029, 1.7714, 1.7436, 1.7188, 1.6964, 1.6762, 1.6578, 1.641, 1.6255],
[193, 3.8901, 3.0427, 2.6514, 2.4184, 2.2609, 2.1458, 2.0573, 1.9866, 1.9286, 1.88, 1.8385, 1.8026, 1.7712, 1.7433, 1.7185, 1.6961, 1.6759, 1.6575, 1.6407, 1.6252],
[194, 3.8899, 3.0425, 2.6512, 2.4182, 2.2606, 2.1456, 2.057, 1.9864, 1.9284, 1.8798, 1.8383, 1.8023, 1.7709, 1.7431, 1.7182, 1.6959, 1.6757, 1.6572, 1.6404, 1.6249],
[195, 3.8896, 3.0422, 2.6509, 2.418, 2.2604, 2.1453, 2.0568, 1.9861, 1.9281, 1.8795, 1.838, 1.8021, 1.7706, 1.7428, 1.7179, 1.6956, 1.6754, 1.657, 1.6401, 1.6247],
[196, 3.8893, 3.042, 2.6507, 2.4177, 2.2602, 2.1451, 2.0566, 1.9859, 1.9279, 1.8793, 1.8377, 1.8018, 1.7704, 1.7425, 1.7177, 1.6953, 1.6751, 1.6567, 1.6399, 1.6244],
[197, 3.8891, 3.0418, 2.6504, 2.4175, 2.26, 2.1448, 2.0563, 1.9856, 1.9277, 1.879, 1.8375, 1.8016, 1.7701, 1.7423, 1.7174, 1.6951, 1.6748, 1.6564, 1.6396, 1.6241],
[198, 3.8889, 3.0415, 2.6502, 2.4173, 2.2597, 2.1446, 2.0561, 1.9854, 1.9274, 1.8788, 1.8373, 1.8013, 1.7699, 1.742, 1.7172, 1.6948, 1.6746, 1.6562, 1.6393, 1.6238],
[199, 3.8886, 3.0413, 2.65, 2.417, 2.2595, 2.1444, 2.0558, 1.9852, 1.9272, 1.8785, 1.837, 1.8011, 1.7696, 1.7418, 1.7169, 1.6946, 1.6743, 1.6559, 1.6391, 1.6236],
[200, 3.8883, 3.041, 2.6497, 2.4168, 2.2592, 2.1441, 2.0556, 1.9849, 1.9269, 1.8783, 1.8368, 1.8008, 1.7694, 1.7415, 1.7166, 1.6943, 1.6741, 1.6557, 1.6388, 1.62]])
    return ftest[row][col]

def tcalc(nf,p):
    """
     t-table for nf degrees of freedom (95% confidence)
    """
#
    if p==.05:
        if nf> 2: t= 4.3027
        if nf> 3: t= 3.1824
        if nf> 4: t= 2.7765
        if nf> 5: t= 2.5706
        if nf> 6: t= 2.4469
        if nf> 7: t= 2.3646
        if nf> 8: t= 2.3060
        if nf> 9: t= 2.2622
        if nf> 10: t= 2.2281
        if nf> 11: t= 2.2010
        if nf> 12: t= 2.1788
        if nf> 13: t= 2.1604
        if nf> 14: t= 2.1448
        if nf> 15: t= 2.1315
        if nf> 16: t= 2.1199
        if nf> 17: t= 2.1098
        if nf> 18: t= 2.1009
        if nf> 19: t= 2.0930
        if nf> 20: t= 2.0860
        if nf> 21: t= 2.0796
        if nf> 22: t= 2.0739
        if nf> 23: t= 2.0687
        if nf> 24: t= 2.0639
        if nf> 25: t= 2.0595
        if nf> 26: t= 2.0555
        if nf> 27: t= 2.0518
        if nf> 28: t= 2.0484
        if nf> 29: t= 2.0452
        if nf> 30: t= 2.0423
        if nf> 31: t= 2.0395
        if nf> 32: t= 2.0369
        if nf> 33: t= 2.0345
        if nf> 34: t= 2.0322
        if nf> 35: t= 2.0301
        if nf> 36: t= 2.0281
        if nf> 37: t= 2.0262
        if nf> 38: t= 2.0244
        if nf> 39: t= 2.0227
        if nf> 40: t= 2.0211
        if nf> 41: t= 2.0195
        if nf> 42: t= 2.0181
        if nf> 43: t= 2.0167
        if nf> 44: t= 2.0154
        if nf> 45: t= 2.0141
        if nf> 46: t= 2.0129
        if nf> 47: t= 2.0117
        if nf> 48: t= 2.0106
        if nf> 49: t= 2.0096
        if nf> 50: t= 2.0086
        if nf> 51: t= 2.0076
        if nf> 52: t= 2.0066
        if nf> 53: t= 2.0057
        if nf> 54: t= 2.0049
        if nf> 55: t= 2.0040
        if nf> 56: t= 2.0032
        if nf> 57: t= 2.0025
        if nf> 58: t= 2.0017
        if nf> 59: t= 2.0010
        if nf> 60: t= 2.0003
        if nf> 61: t= 1.9996
        if nf> 62: t= 1.9990
        if nf> 63: t= 1.9983
        if nf> 64: t= 1.9977
        if nf> 65: t= 1.9971
        if nf> 66: t= 1.9966
        if nf> 67: t= 1.9960
        if nf> 68: t= 1.9955
        if nf> 69: t= 1.9949
        if nf> 70: t= 1.9944
        if nf> 71: t= 1.9939
        if nf> 72: t= 1.9935
        if nf> 73: t= 1.9930
        if nf> 74: t= 1.9925
        if nf> 75: t= 1.9921
        if nf> 76: t= 1.9917
        if nf> 77: t= 1.9913
        if nf> 78: t= 1.9908
        if nf> 79: t= 1.9905
        if nf> 80: t= 1.9901
        if nf> 81: t= 1.9897
        if nf> 82: t= 1.9893
        if nf> 83: t= 1.9890
        if nf> 84: t= 1.9886
        if nf> 85: t= 1.9883
        if nf> 86: t= 1.9879
        if nf> 87: t= 1.9876
        if nf> 88: t= 1.9873
        if nf> 89: t= 1.9870
        if nf> 90: t= 1.9867
        if nf> 91: t= 1.9864
        if nf> 92: t= 1.9861
        if nf> 93: t= 1.9858
        if nf> 94: t= 1.9855
        if nf> 95: t= 1.9852
        if nf> 96: t= 1.9850
        if nf> 97: t= 1.9847
        if nf> 98: t= 1.9845
        if nf> 99: t= 1.9842
        if nf> 100: t= 1.9840
        return t
#
    elif p==.01:
        if nf> 2: t= 9.9250
        if nf> 3: t= 5.8408
        if nf> 4: t= 4.6041
        if nf> 5: t= 4.0321
        if nf> 6: t= 3.7074
        if nf> 7: t= 3.4995
        if nf> 8: t= 3.3554
        if nf> 9: t= 3.2498
        if nf> 10: t= 3.1693
        if nf> 11: t= 3.1058
        if nf> 12: t= 3.0545
        if nf> 13: t= 3.0123
        if nf> 14: t= 2.9768
        if nf> 15: t= 2.9467
        if nf> 16: t= 2.9208
        if nf> 17: t= 2.8982
        if nf> 18: t= 2.8784
        if nf> 19: t= 2.8609
        if nf> 20: t= 2.8453
        if nf> 21: t= 2.8314
        if nf> 22: t= 2.8188
        if nf> 23: t= 2.8073
        if nf> 24: t= 2.7970
        if nf> 25: t= 2.7874
        if nf> 26: t= 2.7787
        if nf> 27: t= 2.7707
        if nf> 28: t= 2.7633
        if nf> 29: t= 2.7564
        if nf> 30: t= 2.7500
        if nf> 31: t= 2.7440
        if nf> 32: t= 2.7385
        if nf> 33: t= 2.7333
        if nf> 34: t= 2.7284
        if nf> 35: t= 2.7238
        if nf> 36: t= 2.7195
        if nf> 37: t= 2.7154
        if nf> 38: t= 2.7116
        if nf> 39: t= 2.7079
        if nf> 40: t= 2.7045
        if nf> 41: t= 2.7012
        if nf> 42: t= 2.6981
        if nf> 43: t= 2.6951
        if nf> 44: t= 2.6923
        if nf> 45: t= 2.6896
        if nf> 46: t= 2.6870
        if nf> 47: t= 2.6846
        if nf> 48: t= 2.6822
        if nf> 49: t= 2.6800
        if nf> 50: t= 2.6778
        if nf> 51: t= 2.6757
        if nf> 52: t= 2.6737
        if nf> 53: t= 2.6718
        if nf> 54: t= 2.6700
        if nf> 55: t= 2.6682
        if nf> 56: t= 2.6665
        if nf> 57: t= 2.6649
        if nf> 58: t= 2.6633
        if nf> 59: t= 2.6618
        if nf> 60: t= 2.6603
        if nf> 61: t= 2.6589
        if nf> 62: t= 2.6575
        if nf> 63: t= 2.6561
        if nf> 64: t= 2.6549
        if nf> 65: t= 2.6536
        if nf> 66: t= 2.6524
        if nf> 67: t= 2.6512
        if nf> 68: t= 2.6501
        if nf> 69: t= 2.6490
        if nf> 70: t= 2.6479
        if nf> 71: t= 2.6469
        if nf> 72: t= 2.6458
        if nf> 73: t= 2.6449
        if nf> 74: t= 2.6439
        if nf> 75: t= 2.6430
        if nf> 76: t= 2.6421
        if nf> 77: t= 2.6412
        if nf> 78: t= 2.6403
        if nf> 79: t= 2.6395
        if nf> 80: t= 2.6387
        if nf> 81: t= 2.6379
        if nf> 82: t= 2.6371
        if nf> 83: t= 2.6364
        if nf> 84: t= 2.6356
        if nf> 85: t= 2.6349
        if nf> 86: t= 2.6342
        if nf> 87: t= 2.6335
        if nf> 88: t= 2.6329
        if nf> 89: t= 2.6322
        if nf> 90: t= 2.6316
        if nf> 91: t= 2.6309
        if nf> 92: t= 2.6303
        if nf> 93: t= 2.6297
        if nf> 94: t= 2.6291
        if nf> 95: t= 2.6286
        if nf> 96: t= 2.6280
        if nf> 97: t= 2.6275
        if nf> 98: t= 2.6269
        if nf> 99: t= 2.6264
        if nf> 100: t= 2.6259
        return t
        return t
    else:
        return 0
#
def sbar(Ss):
    """
    calculate average s,sigma from list of "s"s.
    """
    npts=len(Ss)
    Ss=numpy.array(Ss).transpose()
    avd,avs=[],[]
    #D=numpy.array([Ss[0],Ss[1],Ss[2],Ss[3]+0.5*(Ss[0]+Ss[1]),Ss[4]+0.5*(Ss[1]+Ss[2]),Ss[5]+0.5*(Ss[0]+Ss[2])]).transpose()
    D=numpy.array([Ss[0],Ss[1],Ss[2],Ss[3]+0.5*(Ss[0]+Ss[1]),Ss[4]+0.5*(Ss[1]+Ss[2]),Ss[5]+0.5*(Ss[0]+Ss[2])])
    for j in range(6):
        avd.append(numpy.average(D[j]))
        avs.append(numpy.average(Ss[j]))
    D=D.transpose()
    #for s in Ss:
    #    print 'from sbar: ',s
    #    D.append(s[:]) # append a copy of s
    #    D[-1][3]=D[-1][3]+0.5*(s[0]+s[1])
    #    D[-1][4]=D[-1][4]+0.5*(s[1]+s[2])
    #    D[-1][5]=D[-1][5]+0.5*(s[0]+s[2])
    #    for j in range(6):
    #        avd[j]+=(D[-1][j])/float(npts)
    #        avs[j]+=(s[j])/float(npts)
#   calculate sigma
    nf=(npts-1)*6 # number of degrees of freedom
    s0=0
    Dels=(D-avd)**2
    s0=numpy.sum(Dels)
    sigma=numpy.sqrt(s0/float(nf))
    return nf,sigma,avs

def dohext(nf,sigma,s):
    """
    calculates hext parameters for nf, sigma and s
    """
#
    hpars={}
    hpars['F_crit']='0'
    hpars['F12_crit']='0'
    hpars["F"]=0
    hpars["F12"]=0
    hpars["F23"]=0
    hpars["v1_dec"]=-1
    hpars["v1_inc"]=-1
    hpars["v2_dec"]=-1
    hpars["v2_inc"]=-1
    hpars["v3_dec"]=-1
    hpars["v3_inc"]=-1
    hpars["t1"]=-1
    hpars["t2"]=-1
    hpars["t3"]=-1
    hpars["e12"]=-1
    hpars["e23"]=-1
    hpars["e13"]=-1
    if nf<0 or sigma==0:return hpars
    f=numpy.sqrt(2.*fcalc(2,nf))
    t2sum=0
    tau,Vdir=doseigs(s)
    for i in range(3): t2sum+=tau[i]**2
    chibar=(s[0]+s[1]+s[2])/3.
    hpars['F_crit']='%s'%(fcalc(5,nf))
    hpars['F12_crit']='%s'%(fcalc(2,nf))
    hpars["F"]=0.4*(t2sum-3*chibar**2)/(sigma**2)
    hpars["F12"]=0.5*((tau[0]-tau[1])/sigma)**2
    hpars["F23"]=0.5*((tau[1]-tau[2])/sigma)**2
    hpars["v1_dec"]=Vdir[0][0]
    hpars["v1_inc"]=Vdir[0][1]
    hpars["v2_dec"]=Vdir[1][0]
    hpars["v2_inc"]=Vdir[1][1]
    hpars["v3_dec"]=Vdir[2][0]
    hpars["v3_inc"]=Vdir[2][1]
    hpars["t1"]=tau[0]
    hpars["t2"]=tau[1]
    hpars["t3"]=tau[2]
    hpars["e12"]=numpy.arctan((f*sigma)/(2*abs(tau[0]-tau[1])))*180./numpy.pi
    hpars["e23"]=numpy.arctan((f*sigma)/(2*abs(tau[1]-tau[2])))*180./numpy.pi
    hpars["e13"]=numpy.arctan((f*sigma)/(2*abs(tau[0]-tau[2])))*180./numpy.pi
    return hpars
#
#
def design(npos):
    """
     make a design matrix for an anisotropy experiment
    """
    if npos==15:
#
# rotatable design of Jelinek for kappabridge (see Tauxe, 1998)
#
        A=numpy.array([[.5,.5,0,-1.,0,0],[.5,.5,0,1.,0,0],[1,.0,0,0,0,0],[.5,.5,0,-1.,0,0],[.5,.5,0,1.,0,0],[0,.5,.5,0,-1.,0],[0,.5,.5,0,1.,0],[0,1.,0,0,0,0],[0,.5,.5,0,-1.,0],[0,.5,.5,0,1.,0],[.5,0,.5,0,0,-1.],[.5,0,.5,0,0,1.],[0,0,1.,0,0,0],[.5,0,.5,0,0,-1.],[.5,0,.5,0,0,1.]]) #  design matrix for 15 measurment positions
    elif npos==6:
        A=numpy.array([[1.,0,0,0,0,0],[0,1.,0,0,0,0],[0,0,1.,0,0,0],[.5,.5,0,1.,0,0],[0,.5,.5,0,1.,0],[.5,0,.5,0,0,1.]]) #  design matrix for 6 measurment positions

    else:
        print "measurement protocol not supported yet "
        sys.exit()
    B=numpy.dot(numpy.transpose(A),A)
    B=numpy.linalg.inv(B)
    B=numpy.dot(B,numpy.transpose(A))
    return A,B
#
#
def dok15_s(k15):
    """
    calculates least-squares matrix for 15 measurements from Jelinek [1976]
    """
#
    A,B=design(15) #  get design matrix for 15 measurements
    sbar=numpy.dot(B,k15) # get mean s
    t=(sbar[0]+sbar[1]+sbar[2]) # trace
    bulk=t/3. # bulk susceptibility
    Kbar=numpy.dot(A,sbar)  # get best fit values for K
    dels=k15-Kbar  # get deltas
    dels,sbar=dels/t,sbar/t# normalize by trace
    So= sum(dels**2)
    sigma=numpy.sqrt(So/9.) # standard deviation
    return sbar,sigma,bulk
#
def cross(v, w):
    """
     cross product of two vectors
    """
    x = v[1]*w[2] - v[2]*w[1]
    y = v[2]*w[0] - v[0]*w[2]
    z = v[0]*w[1] - v[1]*w[0]
    return [x, y, z]
#
def dosgeo(s,az,pl):
    """
     rotates  matrix a to az,pl returns  s
    """
#
    a=s2a(s) # convert to 3,3 matrix
#  first get three orthogonal axes
    X1=dir2cart((az,pl,1.))
    X2=dir2cart((az+90,0.,1.))
    X3=cross(X1,X2)
    A=numpy.transpose([X1,X2,X3])
    b=numpy.zeros((3,3,),'f') # initiale the b matrix
    for i in range(3):
        for j in range(3):
            dum=0
            for k in range(3):
                for l in range(3):
                    dum+=A[i][k]*A[j][l]*a[k][l]
            b[i][j]=dum
    return a2s(b)
#
#
def dostilt(s,bed_az,bed_dip):
    """
     rotate "s" data to stratigraphic coordinates
    """
    tau,Vdirs=doseigs(s)
    Vrot=[]
    for evec in Vdirs:
        d,i=dotilt(evec[0],evec[1],bed_az,bed_dip)
        Vrot.append([d,i])
    return doeigs_s(tau,Vrot)
#
#
def apseudo(Ss,ipar,sigma):
    """
     draw a bootstrap sample of Ss
    """
#
    Is=random.randint(0,len(Ss)-1,size=len(Ss)) # draw N random integers
    Ss=numpy.array(Ss)
    if ipar==0:
        BSs=Ss[Is]
    else: # need to recreate measurement - then do the parametric stuffr
        A,B=design(6) # get the design matrix for 6 measurements
        K,BSs=[],[]
        for k in range(len(Ss)):
            K.append(numpy.dot(A,Ss[k]))
        Pars=numpy.random.normal(K,sigma)
        for k in range(len(Ss)):
            BSs.append(numpy.dot(B,Pars[k]))
    return numpy.array(BSs)
#
def sbootpars(Taus,Vs):
    """
     get bootstrap parameters for s data
    """
#
    Tau1s,Tau2s,Tau3s=[],[],[]
    V1s,V2s,V3s=[],[],[]
    nb=len(Taus)
    bpars={}
    for k in range(nb):
        Tau1s.append(Taus[k][0])
        Tau2s.append(Taus[k][1])
        Tau3s.append(Taus[k][2])
        V1s.append(Vs[k][0])
        V2s.append(Vs[k][1])
        V3s.append(Vs[k][2])
    x,sig=gausspars(Tau1s)
    bpars["t1_sigma"]=sig
    x,sig=gausspars(Tau2s)
    bpars["t2_sigma"]=sig
    x,sig=gausspars(Tau3s)
    bpars["t3_sigma"]=sig
    kpars=dokent(V1s,len(V1s))
    bpars["v1_dec"]=kpars["dec"]
    bpars["v1_inc"]=kpars["inc"]
    bpars["v1_zeta"]=kpars["Zeta"]*numpy.sqrt(nb)
    bpars["v1_eta"]=kpars["Eta"]*numpy.sqrt(nb)
    bpars["v1_zeta_dec"]=kpars["Zdec"]
    bpars["v1_zeta_inc"]=kpars["Zinc"]
    bpars["v1_eta_dec"]=kpars["Edec"]
    bpars["v1_eta_inc"]=kpars["Einc"]
    kpars=dokent(V2s,len(V2s))
    bpars["v2_dec"]=kpars["dec"]
    bpars["v2_inc"]=kpars["inc"]
    bpars["v2_zeta"]=kpars["Zeta"]*numpy.sqrt(nb)
    bpars["v2_eta"]=kpars["Eta"]*numpy.sqrt(nb)
    bpars["v2_zeta_dec"]=kpars["Zdec"]
    bpars["v2_zeta_inc"]=kpars["Zinc"]
    bpars["v2_eta_dec"]=kpars["Edec"]
    bpars["v2_eta_inc"]=kpars["Einc"]
    kpars=dokent(V3s,len(V3s))
    bpars["v3_dec"]=kpars["dec"]
    bpars["v3_inc"]=kpars["inc"]
    bpars["v3_zeta"]=kpars["Zeta"]*numpy.sqrt(nb)
    bpars["v3_eta"]=kpars["Eta"]*numpy.sqrt(nb)
    bpars["v3_zeta_dec"]=kpars["Zdec"]
    bpars["v3_zeta_inc"]=kpars["Zinc"]
    bpars["v3_eta_dec"]=kpars["Edec"]
    bpars["v3_eta_inc"]=kpars["Einc"]
    return bpars
#
#
def s_boot(Ss,ipar,nb):
    """
     returns bootstrap parameters for S data
    """
    npts=len(Ss)
# get average s for whole dataset
    nf,Sigma,avs=sbar(Ss)
    Tmean,Vmean=doseigs(avs) # get eigenvectors of mean tensor
#
# now do bootstrap to collect Vs and taus of bootstrap means
#
    Taus,Vs=[],[]  # number of bootstraps, list of bootstrap taus and eigenvectors
#

    for k in range(nb): # repeat nb times
#        if k%50==0:print k,' out of ',nb
        BSs=apseudo(Ss,ipar,Sigma) # get a pseudosample - if ipar=1, do a parametric bootstrap
        nf,sigma,avbs=sbar(BSs) # get bootstrap mean s
        tau,Vdirs=doseigs(avbs) # get bootstrap eigenparameters
        Taus.append(tau)
        Vs.append(Vdirs)
    return Tmean,Vmean,Taus,Vs

#
def designAARM(npos):
#
    """
    calculates B matrix for AARM calculations.
    """
    if npos!=9:
        print 'Sorry - only 9 positions available'
        sys.exit()
    Dec=[315.,225.,180.,135.,45.,90.,270.,270.,270.,90.,180.,180.,0.,0.,0.]
    Dip=[0.,0.,0.,0.,0.,-45.,-45.,0.,45.,45.,45.,-45.,-90.,-45.,45.]
    index9=[0,1, 2,5,6,7,10,11,12]
    H=[]
    for ind in range(15):
        Dir=[Dec[ind],Dip[ind],1.]
        H.append(dir2cart(Dir))  # 15 field directionss
#
# make design matrix A
#
    A=numpy.zeros((npos*3,6),'f')
    tmpH=numpy.zeros((npos,3),'f') # define tmpH
    if npos == 9:
        for i in range(9):
            k=index9[i]
            ind=i*3
            A[ind][0]=H[k][0]
            A[ind][3]=H[k][1]
            A[ind][5]=H[k][2]
            ind=i*3+1
            A[ind][3]=H[k][0]
            A[ind][1]=H[k][1]
            A[ind][4]=H[k][2]
            ind=i*3+2
            A[ind][5]=H[k][0]
            A[ind][4]=H[k][1]
            A[ind][2]=H[k][2]
            for j in range(3):
                tmpH[i][j]=H[k][j]
        At=numpy.transpose(A)
        ATA=numpy.dot(At,A)
        ATAI=numpy.linalg.inv(ATA)
        B=numpy.dot(ATAI,At)
    else:
        print "B matrix not yet supported"
        sys.exit()
    return B,H,tmpH
#
def designATRM(npos):
#
    """
    calculates B matrix for ATRM calculations.
    """
    #if npos!=6:
    #    print 'Sorry - only 6 positions available'
    #    sys.exit()
    Dec=[0,0,  0,90,180,270,0] # for shuhui only
    Dip=[90,-90,0,0,0,0,90]
    Dec=[0,90,0,180,270,0,0,90,0]
    Dip=[0,0,90,0,0,-90,0,0,90]
    H=[]
    for ind in range(6):
        Dir=[Dec[ind],Dip[ind],1.]
        H.append(dir2cart(Dir))  # 6 field directionss
#
# make design matrix A
#
    A=numpy.zeros((npos*3,6),'f')
    tmpH=numpy.zeros((npos,3),'f') # define tmpH
    #if npos == 6:
    #    for i in range(6):
    for i in range(6):
            ind=i*3
            A[ind][0]=H[i][0]
            A[ind][3]=H[i][1]
            A[ind][5]=H[i][2]
            ind=i*3+1
            A[ind][3]=H[i][0]
            A[ind][1]=H[i][1]
            A[ind][4]=H[i][2]
            ind=i*3+2
            A[ind][5]=H[i][0]
            A[ind][4]=H[i][1]
            A[ind][2]=H[i][2]
            for j in range(3):
                tmpH[i][j]=H[i][j]
    At=numpy.transpose(A)
    ATA=numpy.dot(At,A)
    ATAI=numpy.linalg.inv(ATA)
    B=numpy.dot(ATAI,At)
    #else:
    #    print "B matrix not yet supported"
    #    sys.exit()
    return B,H,tmpH

#
def domagicmag(file,Recs):
    """
    converts a magic record back into the SIO mag format
    """
    for rec in Recs:
        type=".0"
        meths=[]
        tmp=rec["magic_method_codes"].split(':')
        for meth in tmp:
            meths.append(meth.strip())
        if 'LT-T-I' in meths: type=".1"
        if 'LT-PTRM-I' in meths: type=".2"
        if 'LT-PTRM-MD' in meths: type=".3"
        treatment=float(rec["treatment_temp"])-273
        tr='%i'%(treatment)+type
        inten='%8.7e '%(float(rec["measurement_magn_moment"])*1e3)
        outstring=rec["er_specimen_name"]+" "+tr+" "+rec["measurement_csd"]+" "+inten+" "+rec["measurement_dec"]+" "+rec["measurement_inc"]+"\n"
        file.write(outstring)
#
#
def cleanup(first_I,first_Z):
    """
     cleans up unbalanced steps
     failure can be from unbalanced final step, or from missing steps,
     this takes care of  missing steps
    """
    cont=0
    Nmin=len(first_I)
    if len(first_Z)<Nmin:Nmin=len(first_Z)
    for kk in range(Nmin):
        if first_I[kk][0]!=first_Z[kk][0]:
            print "\n WARNING: "
            if first_I[kk]<first_Z[kk]:
                del first_I[kk]
            else:
                del first_Z[kk]
            print "Unmatched step number: ",kk+1,'  ignored'
            cont=1
        if cont==1: return first_I,first_Z,cont
    return first_I,first_Z,cont
#
#
def sortarai(datablock,s,Zdiff):
    """
     sorts data block in to first_Z, first_I, etc.
    """
    first_Z,first_I,zptrm_check,ptrm_check,ptrm_tail=[],[],[],[],[]
    field,phi,theta="","",""
    starthere=0
    Treat_I,Treat_Z,Treat_PZ,Treat_PI,Treat_M=[],[],[],[],[]
    ISteps,ZSteps,PISteps,PZSteps,MSteps=[],[],[],[],[]
    GammaChecks=[] # comparison of pTRM direction acquired and lab field
    Mkeys=['measurement_magn_moment','measurement_magn_volume','measurement_magn_mass','measurement_magnitude']
    rec=datablock[0]
    for key in Mkeys:
        if key in rec.keys() and rec[key]!="":
            momkey=key
            break
# first find all the steps
    for k in range(len(datablock)):
	rec=datablock[k]
        temp=float(rec["treatment_temp"])
        methcodes=[]
        tmp=rec["magic_method_codes"].split(":")
        for meth in tmp:
            methcodes.append(meth.strip())
        if 'LT-T-I' in methcodes and 'LP-TRM' not in methcodes and 'LP-PI-TRM' in methcodes:
            Treat_I.append(temp)
            ISteps.append(k)
            if field=="":field=float(rec["treatment_dc_field"])
            if phi=="":
                phi=float(rec['treatment_dc_field_phi'])
                theta=float(rec['treatment_dc_field_theta'])
# stick  first zero field stuff into first_Z
        if 'LT-NO' in methcodes:
            Treat_Z.append(temp)
            ZSteps.append(k)
        if 'LT-T-Z' in methcodes:
            Treat_Z.append(temp)
            ZSteps.append(k)
        if 'LT-PTRM-Z' in methcodes:
            Treat_PZ.append(temp)
            PZSteps.append(k)
        if 'LT-PTRM-I' in methcodes:
            Treat_PI.append(temp)
            PISteps.append(k)
        if 'LT-PTRM-MD' in methcodes:
            Treat_M.append(temp)
            MSteps.append(k)
        if 'LT-NO' in methcodes:
            dec=float(rec["measurement_dec"])
            inc=float(rec["measurement_inc"])
            str=float(rec[momkey])
            first_I.append([273,0.,0.,0.,1])
            first_Z.append([273,dec,inc,str,1])  # NRM step
    for temp in Treat_I: # look through infield steps and find matching Z step
        if temp in Treat_Z: # found a match
            istep=ISteps[Treat_I.index(temp)]
            irec=datablock[istep]
            methcodes=[]
            tmp=irec["magic_method_codes"].split(":")
            for meth in tmp: methcodes.append(meth.strip())
            brec=datablock[istep-1] # take last record as baseline to subtract
            zstep=ZSteps[Treat_Z.index(temp)]
            zrec=datablock[zstep]
    # sort out first_Z records
            if "LP-PI-TRM-IZ" in methcodes:
                ZI=0
            else:
                ZI=1
            dec=float(zrec["measurement_dec"])
            inc=float(zrec["measurement_inc"])
            str=float(zrec[momkey])
            first_Z.append([temp,dec,inc,str,ZI])
    # sort out first_I records
            idec=float(irec["measurement_dec"])
            iinc=float(irec["measurement_inc"])
            istr=float(irec[momkey])
            X=dir2cart([idec,iinc,istr])
            BL=dir2cart([dec,inc,str])
            I=[]
            for c in range(3): I.append((X[c]-BL[c]))
            if I[2]!=0:
                iDir=cart2dir(I)
                if Zdiff==0:
                    first_I.append([temp,iDir[0],iDir[1],iDir[2],ZI])
                else:
                    first_I.append([temp,0.,0.,I[2],ZI])
                gamma=angle([iDir[0],iDir[1]],[phi,theta])
            else:
                first_I.append([temp,0.,0.,0.,ZI])
                gamma=0.0
# put in Gamma check (infield trm versus lab field)
            if 180.-gamma<gamma:  gamma=180.-gamma
            GammaChecks.append([temp-273.,gamma])
    for temp in Treat_PI: # look through infield steps and find matching Z step
        step=PISteps[Treat_PI.index(temp)]
        rec=datablock[step]
        dec=float(rec["measurement_dec"])
        inc=float(rec["measurement_inc"])
        str=float(rec[momkey])
        brec=datablock[step-1] # take last record as baseline to subtract
        pdec=float(brec["measurement_dec"])
        pinc=float(brec["measurement_inc"])
        pint=float(brec[momkey])
        X=dir2cart([dec,inc,str])
        prevX=dir2cart([pdec,pinc,pint])
        I=[]
        for c in range(3): I.append(X[c]-prevX[c])
        dir1=cart2dir(I)
        if Zdiff==0:
            ptrm_check.append([temp,dir1[0],dir1[1],dir1[2]])
        else:
            ptrm_check.append([temp,0.,0.,I[2]])
# in case there are zero-field pTRM checks (not the SIO way)
    for temp in Treat_PZ:
        step=PZSteps[Treat_PZ.index(temp)]
        rec=datablock[step]
        dec=float(rec["measurement_dec"])
        inc=float(rec["measurement_inc"])
        str=float(rec[momkey])
        brec=datablock[step-1]
        pdec=float(brec["measurement_dec"])
        pinc=float(brec["measurement_inc"])
        pint=float(brec[momkey])
        X=dir2cart([dec,inc,str])
        prevX=dir2cart([pdec,pinc,pint])
        I=[]
        for c in range(3): I.append(X[c]-prevX[c])
        dir2=cart2dir(I)
        zptrm_check.append([temp,dir2[0],dir2[1],dir2[2]])
    ## get pTRM tail checks together -
    for temp in Treat_M:
        step=MSteps[Treat_M.index(temp)] # tail check step - just do a difference in magnitude!
        rec=datablock[step]
#        dec=float(rec["measurement_dec"])
#        inc=float(rec["measurement_inc"])
        str=float(rec[momkey])
        if temp in Treat_Z:
            step=ZSteps[Treat_Z.index(temp)]
            brec=datablock[step]
#        pdec=float(brec["measurement_dec"])
#        pinc=float(brec["measurement_inc"])
            pint=float(brec[momkey])
#        X=dir2cart([dec,inc,str])
#        prevX=dir2cart([pdec,pinc,pint])
#        I=[]
#        for c in range(3):I.append(X[c]-prevX[c])
#        d=cart2dir(I)
#        ptrm_tail.append([temp,d[0],d[1],d[2]])
            ptrm_tail.append([temp,0,0,str-pint])  # difference - if negative, negative tail!
        else:
            print s, '  has a tail check with no first zero field step - check input file! for step',temp-273.
#
# final check
#
    if len(first_Z)!=len(first_I):
               print len(first_Z),len(first_I)
               print " Something wrong with this specimen! Better fix it or delete it "
               raw_input(" press return to acknowledge message")
    araiblock=(first_Z,first_I,ptrm_check,ptrm_tail,zptrm_check,GammaChecks)
    return araiblock,field

def sortmwarai(datablock,exp_type):
    """
     sorts microwave double heating data block in to first_Z, first_I, etc.
    """
    first_Z,first_I,ptrm_check,ptrm_tail,zptrm_check=[],[],[],[],[]
    field,phi,theta="","",""
    POWT_I,POWT_Z,POWT_PZ,POWT_PI,POWT_M=[],[],[],[],[]
    ISteps,ZSteps,PZSteps,PISteps,MSteps=[],[],[],[],[]
    rad=numpy.pi/180.
    ThetaChecks=[] #
    DeltaChecks=[]
    GammaChecks=[]
# first find all the steps
    for k in range(len(datablock)):
        rec=datablock[k]
        powt=int(float(rec["treatment_mw_energy"]))
        methcodes=[]
        tmp=rec["magic_method_codes"].split(":")
        for meth in tmp: methcodes.append(meth.strip())
        if 'LT-M-I' in methcodes and 'LP-MRM' not in methcodes:
            POWT_I.append(powt)
            ISteps.append(k)
            if field=="":field=float(rec['treatment_dc_field'])
            if phi=="":
                phi=float(rec['treatment_dc_field_phi'])
                theta=float(rec['treatment_dc_field_theta'])
        if 'LT-M-Z' in methcodes:
            POWT_Z.append(powt)
            ZSteps.append(k)
        if 'LT-PMRM-Z' in methcodes:
            POWT_PZ.append(powt)
            PZSteps.append(k)
        if 'LT-PMRM-I' in methcodes:
            POWT_PI.append(powt)
            PISteps.append(k)
        if 'LT-PMRM-MD' in methcodes:
            POWT_M.append(powt)
            MSteps.append(k)
        if 'LT-NO' in methcodes:
            dec=float(rec["measurement_dec"])
            inc=float(rec["measurement_inc"])
            str=float(rec["measurement_magn_moment"])
            first_I.append([0,0.,0.,0.,1])
            first_Z.append([0,dec,inc,str,1])  # NRM step
    if exp_type=="LP-PI-M-D":
# now look trough infield steps and  find matching Z step
        for powt in POWT_I:
            if powt in POWT_Z:
                istep=ISteps[POWT_I.index(powt)]
                irec=datablock[istep]
                methcodes=[]
                tmp=irec["magic_method_codes"].split(":")
                for meth in tmp: methcodes.append(meth.strip())
                brec=datablock[istep-1] # take last record as baseline to subtract
                zstep=ZSteps[POWT_Z.index(powt)]
                zrec=datablock[zstep]
    # sort out first_Z records
                if "LP-PI-M-IZ" in methcodes:
                    ZI=0
                else:
                    ZI=1
                dec=float(zrec["measurement_dec"])
                inc=float(zrec["measurement_inc"])
                str=float(zrec["measurement_magn_moment"])
                first_Z.append([powt,dec,inc,str,ZI])
    # sort out first_I records
                idec=float(irec["measurement_dec"])
                iinc=float(irec["measurement_inc"])
                istr=float(irec["measurement_magn_moment"])
                X=dir2cart([idec,iinc,istr])
                BL=dir2cart([dec,inc,str])
                I=[]
                for c in range(3): I.append((X[c]-BL[c]))
                iDir=cart2dir(I)
                first_I.append([powt,iDir[0],iDir[1],iDir[2],ZI])
# put in Gamma check (infield trm versus lab field)
                gamma=angle([iDir[0],iDir[1]],[phi,theta])
                GammaChecks.append([powt,gamma])
    elif exp_type=="LP-PI-M-S":
# find last zero field step before first infield step
        lzrec=datablock[ISteps[0]-1]
        irec=datablock[ISteps[0]]
        ndec=float(lzrec["measurement_dec"])
        ninc=float(lzrec["measurement_inc"])
        nstr=float(lzrec["measurement_magn_moment"])
        NRM=dir2cart([ndec,ninc,nstr])
        fdec=float(irec["treatment_dc_field_phi"])
        finc=float(irec["treatment_dc_field_theta"])
        Flab=dir2cart([fdec,finc,1.])
        for step in ISteps:
            irec=datablock[step]
            rdec=float(irec["measurement_dec"])
            rinc=float(irec["measurement_inc"])
            rstr=float(irec["measurement_magn_moment"])
            theta1=angle([ndec,ninc],[rdec,rinc])
            theta2=angle([rdec,rinc],[fdec,finc])
            powt=int(float(irec["treatment_mw_energy"]))
            ThetaChecks.append([powt,theta1+theta2])
            p=(180.-(theta1+theta2))
            nstr=rstr*(numpy.sin(theta2*rad)/numpy.sin(p*rad))
            tmstr=rstr*(numpy.sin(theta1*rad)/numpy.sin(p*rad))
            first_Z.append([powt,ndec,ninc,nstr,1])
            first_I.append([powt,dec,inc,tmstr,1])
# check if zero field steps are parallel to assumed NRM
        for step in ZSteps:
            zrec=datablock[step]
            powt=int(float(zrec["treatment_mw_energy"]))
            zdec=float(zrec["measurement_dec"])
            zinc=float(zrec["measurement_inc"])
            delta=angle([ndec,ninc],[zdec,zinc])
            DeltaChecks.append([powt,delta])
    # get pTRMs together - take previous record and subtract
    for powt in POWT_PI:
        step=PISteps[POWT_PI.index(powt)]
        rec=datablock[step]
        dec=float(rec["measurement_dec"])
        inc=float(rec["measurement_inc"])
        str=float(rec["measurement_magn_moment"])
        brec=datablock[step-1] # take last record as baseline to subtract
        pdec=float(brec["measurement_dec"])
        pinc=float(brec["measurement_inc"])
        pint=float(brec["measurement_magn_moment"])
        X=dir2cart([dec,inc,str])
        prevX=dir2cart([pdec,pinc,pint])
        I=[]
        for c in range(3): I.append(X[c]-prevX[c])
        dir1=cart2dir(I)
        ptrm_check.append([powt,dir1[0],dir1[1],dir1[2]])
    ## get zero field pTRM  checks together
    for powt in POWT_PZ:
        step=PZSteps[POWT_PZ.index(powt)]
        rec=datablock[step]
        dec=float(rec["measurement_dec"])
        inc=float(rec["measurement_inc"])
        str=float(rec["measurement_magn_moment"])
        brec=datablock[step-1]
        pdec=float(brec["measurement_dec"])
        pinc=float(brec["measurement_inc"])
        pint=float(brec["measurement_magn_moment"])
        X=dir2cart([dec,inc,str])
        prevX=dir2cart([pdec,pinc,pint])
        I=[]
        for c in range(3): I.append(X[c]-prevX[c])
        dir2=cart2dir(I)
        zptrm_check.append([powt,dir2[0],dir2[1],dir2[2]])
    ## get pTRM tail checks together -
    for powt in POWT_M:
        step=MSteps[POWT_M.index(powt)] # tail check step
        rec=datablock[step]
#        dec=float(rec["measurement_dec"])
#        inc=float(rec["measurement_inc"])
        str=float(rec["measurement_magn_moment"])
        step=ZSteps[POWT_Z.index(powt)]
        brec=datablock[step]
#        pdec=float(brec["measurement_dec"])
#        pinc=float(brec["measurement_inc"])
        pint=float(brec["measurement_magn_moment"])
#        X=dir2cart([dec,inc,str])
#        prevX=dir2cart([pdec,pinc,pint])
#        I=[]
#        for c in range(3):I.append(X[c]-prevX[c])
#        d=cart2dir(I)
 #       ptrm_tail.append([powt,d[0],d[1],d[2]])
        ptrm_tail.append([powt,0,0,str-pint])  # just do absolute magnitude difference # not vector diff
    #  check
    #
        if len(first_Z)!=len(first_I):
                   print len(first_Z),len(first_I)
                   print " Something wrong with this specimen! Better fix it or delete it "
                   raw_input(" press return to acknowledge message")
                   print MaxRec
    araiblock=(first_Z,first_I,ptrm_check,ptrm_tail,zptrm_check,GammaChecks,ThetaChecks,DeltaChecks)
    return araiblock,field

    #
def doigrf(long,lat,alt,date,**kwargs):
    """
    called with doigrf(long,lat,alt,date,**kwargs)
#       calculates the interpolated (<2010) or extrapolated (>2010) main field and
#       secular variation coefficients and passes these to the Malin and Barraclough
#       routine to calculate the IGRF field. dgrf coefficients for 1945 to 2005, igrf for pre 1945 and post 2010
#       from http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html
#
#      for dates prior to between 1900 and 1600, this program uses coefficients from the GUFM1 model of Jackson et al. 2000
#      prior to that, it uses either arch3k or one of the cals models
#
#
#       input:
#       long  = east longitude in degrees (0 to 360 or -180 to 180)
#       lat   = latitude in degrees (-90 to 90)
#       alt   = height above mean sea level in km (itype = 1 assumed)
#       date  = Required date in years and decimals of a year (A.D.)
# Output:
#       x     = north component of the magnetic force in nT
#       y     = east component of the magnetic force in nT
#       z     = downward component of the magnetic force in nT
#       f     = total magnetic force in nT
#
#       To check the results you can run the interactive program at the NGDC
#        http://www.ngdc.noaa.gov/geomagmodels/IGRFWMM.jsp
    """

#
#
    gh,sv=[],[]
    colat = 90.-lat
#! convert to colatitude for MB routine
    if long>0: long=long+360.
# ensure all positive east longitudes
    itype = 1
    models,igrf12coeffs=get_igrf12()
    if 'mod' in kwargs.keys():
        if kwargs['mod']=='arch3k':
            psvmodels,psvcoeffs=get_arch3k() # use ARCH3k coefficients
        elif kwargs['mod']=='cals3k':
            psvmodels,psvcoeffs=get_cals3k() # default: use CALS3K_4b coefficients between -1000,1940
        elif kwargs['mod']=='pfm9k':
            psvmodels,psvcoeffs=get_pfm9k() #  use PFM9k (Nilsson et al., 2014), coefficients from -7000 to 1900
        else:
            psvmodels,psvcoeffs=get_cals10k() # use prior to -1000, back to -8000
# use geodetic coordinates
    if 'models' in kwargs:
        if 'mod' in kwargs.keys():
            return psvmodels,psvcoeffs
        else:
            return models,igrf12coeffs
    if date<-8000:
        print 'too old'
        sys.exit()
    if date<-1000:
        if kwargs['mod']=='pfm9k':
            incr=10
        else:
            incr=50
        model=date-date%incr
        gh=psvcoeffs[psvmodels.index(int(model))]
        sv=(psvcoeffs[psvmodels.index(int(model+incr))]-gh)/float(incr)
        x,y,z,f=magsyn(gh,sv,model,date,itype,alt,colat,long)
    elif date<1900:
        if kwargs['mod']=='cals10k':
            incr=50
        else:
            incr=10
        model=date-date%incr
        gh=psvcoeffs[psvmodels.index(model)]
        if model+incr<1900:
            sv=(psvcoeffs[psvmodels.index(model+incr)]-gh)/float(incr)
        else:
            field2=igrf12coeffs[models.index(1940)][0:120]
            sv=(field2-gh)/float(1940-model)
        x,y,z,f=magsyn(gh,sv,model,date,itype,alt,colat,long)
    else:
        model=date-date%5
        if date<2015:
            gh=igrf12coeffs[models.index(model)]
            sv=(igrf12coeffs[models.index(model+5)]-gh)/5.
            x,y,z,f=magsyn(gh,sv,model,date,itype,alt,colat,long)
        else:
            gh=igrf12coeffs[models.index(2015)]
            sv=igrf12coeffs[models.index(2015.20)]
            x,y,z,f=magsyn(gh,sv,model,date,itype,alt,colat,long)
    if 'coeffs' in kwargs.keys():
        return gh
    else:
        return x,y,z,f
#
def get_igrf12():
    models= [1900, 1905, 1910, 1915, 1920, 1925, 1930, 1935, 1940, 1945, 1950, 1955, 1960, 1965, 1970, 1975, 1980, 1985, 1990, 1995, 2000, 2005, 2010, 2015, 2015.20]
    coeffs=numpy.array([[-31543, -2298, 5922, -677, 2905, -1061, 924, 1121, 1022, -1469, -330, 1256, 3, 572, 523, 876, 628, 195, 660, -69, -361, -210, 134, -75, -184, 328, -210, 264, 53, 5, -33, -86, -124, -16, 3, 63, 61, -9, -11, 83, -217, 2, -58, -35, 59, 36, -90, -69, 70, -55, -45, 0, -13, 34, -10, -41, -1, -21, 28, 18, -12, 6, -22, 11, 8, 8, -4, -14, -9, 7, 1, -13, 2, 5, -9, 16, 5, -5, 8, -18, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 8, 2, 10, -1, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 2, 4, 2, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-31464, -2298, 5909, -728, 2928, -1086, 1041, 1065, 1037, -1494, -357, 1239, 34, 635, 480, 880, 643, 203, 653, -77, -380, -201, 146, -65, -192, 328, -193, 259, 56, -1, -32, -93, -125, -26, 11, 62, 60, -7, -11, 86, -221, 4, -57, -32, 57, 32, -92, -67, 70, -54, -46, 0, -14, 33, -11, -41, 0, -20, 28, 18, -12, 6, -22, 11, 8, 8, -4, -15, -9, 7, 1, -13, 2, 5, -8, 16, 5, -5, 8, -18, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 8, 2, 10, 0, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 2, 4, 2, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-31354, -2297, 5898, -769, 2948, -1128, 1176, 1000, 1058, -1524, -389, 1223, 62, 705, 425, 884, 660, 211, 644, -90, -400, -189, 160, -55, -201, 327, -172, 253, 57, -9, -33, -102, -126, -38, 21, 62, 58, -5, -11, 89, -224, 5, -54, -29, 54, 28, -95, -65, 71, -54, -47, 1, -14, 32, -12, -40, 1, -19, 28, 18, -13, 6, -22, 11, 8, 8, -4, -15, -9, 6, 1, -13, 2, 5, -8, 16, 5, -5, 8, -18, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 8, 2, 10, 0, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 2, 4, 2, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-31212, -2306, 5875, -802, 2956, -1191, 1309, 917, 1084, -1559, -421, 1212, 84, 778, 360, 887, 678, 218, 631, -109, -416, -173, 178, -51, -211, 327, -148, 245, 58, -16, -34, -111, -126, -51, 32, 61, 57, -2, -10, 93, -228, 8, -51, -26, 49, 23, -98, -62, 72, -54, -48, 2, -14, 31, -12, -38, 2, -18, 28, 19, -15, 6, -22, 11, 8, 8, -4, -15, -9, 6, 2, -13, 3, 5, -8, 16, 6, -5, 8, -18, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 8, 2, 10, 0, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 1, 4, 2, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-31060, -2317, 5845, -839, 2959, -1259, 1407, 823, 1111, -1600, -445, 1205, 103, 839, 293, 889, 695, 220, 616, -134, -424, -153, 199, -57, -221, 326, -122, 236, 58, -23, -38, -119, -125, -62, 43, 61, 55, 0, -10, 96, -233, 11, -46, -22, 44, 18, -101, -57, 73, -54, -49, 2, -14, 29, -13, -37, 4, -16, 28, 19, -16, 6, -22, 11, 7, 8, -3, -15, -9, 6, 2, -14, 4, 5, -7, 17, 6, -5, 8, -19, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 9, 2, 10, 0, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 1, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30926, -2318, 5817, -893, 2969, -1334, 1471, 728, 1140, -1645, -462, 1202, 119, 881, 229, 891, 711, 216, 601, -163, -426, -130, 217, -70, -230, 326, -96, 226, 58, -28, -44, -125, -122, -69, 51, 61, 54, 3, -9, 99, -238, 14, -40, -18, 39, 13, -103, -52, 73, -54, -50, 3, -14, 27, -14, -35, 5, -14, 29, 19, -17, 6, -21, 11, 7, 8, -3, -15, -9, 6, 2, -14, 4, 5, -7, 17, 7, -5, 8, -19, 8, 10, -20, 1, 14, -11, 5, 12, -3, 1, -2, -2, 9, 2, 10, 0, -2, -1, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 1, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30805, -2316, 5808, -951, 2980, -1424, 1517, 644, 1172, -1692, -480, 1205, 133, 907, 166, 896, 727, 205, 584, -195, -422, -109, 234, -90, -237, 327, -72, 218, 60, -32, -53, -131, -118, -74, 58, 60, 53, 4, -9, 102, -242, 19, -32, -16, 32, 8, -104, -46, 74, -54, -51, 4, -15, 25, -14, -34, 6, -12, 29, 18, -18, 6, -20, 11, 7, 8, -3, -15, -9, 5, 2, -14, 5, 5, -6, 18, 8, -5, 8, -19, 8, 10, -20, 1, 14, -12, 5, 12, -3, 1, -2, -2, 9, 3, 10, 0, -2, -2, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -2, 1, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30715, -2306, 5812, -1018, 2984, -1520, 1550, 586, 1206, -1740, -494, 1215, 146, 918, 101, 903, 744, 188, 565, -226, -415, -90, 249, -114, -241, 329, -51, 211, 64, -33, -64, -136, -115, -76, 64, 59, 53, 4, -8, 104, -246, 25, -25, -15, 25, 4, -106, -40, 74, -53, -52, 4, -17, 23, -14, -33, 7, -11, 29, 18, -19, 6, -19, 11, 7, 8, -3, -15, -9, 5, 1, -15, 6, 5, -6, 18, 8, -5, 7, -19, 8, 10, -20, 1, 15, -12, 5, 11, -3, 1, -3, -2, 9, 3, 11, 0, -2, -2, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -1, 2, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30654, -2292, 5821, -1106, 2981, -1614, 1566, 528, 1240, -1790, -499, 1232, 163, 916, 43, 914, 762, 169, 550, -252, -405, -72, 265, -141, -241, 334, -33, 208, 71, -33, -75, -141, -113, -76, 69, 57, 54, 4, -7, 105, -249, 33, -18, -15, 18, 0, -107, -33, 74, -53, -52, 4, -18, 20, -14, -31, 7, -9, 29, 17, -20, 5, -19, 11, 7, 8, -3, -14, -10, 5, 1, -15, 6, 5, -5, 19, 9, -5, 7, -19, 8, 10, -21, 1, 15, -12, 5, 11, -3, 1, -3, -2, 9, 3, 11, 1, -2, -2, 2, -3, -4, 2, 2, 1, -5, 2, -2, 6, 6, -4, 4, 0, 0, -1, 2, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30594, -2285, 5810, -1244, 2990, -1702, 1578, 477, 1282, -1834, -499, 1255, 186, 913, -11, 944, 776, 144, 544, -276, -421, -55, 304, -178, -253, 346, -12, 194, 95, -20, -67, -142, -119, -82, 82, 59, 57, 6, 6, 100, -246, 16, -25, -9, 21, -16, -104, -39, 70, -40, -45, 0, -18, 0, 2, -29, 6, -10, 28, 15, -17, 29, -22, 13, 7, 12, -8, -21, -5, -12, 9, -7, 7, 2, -10, 18, 7, 3, 2, -11, 5, -21, -27, 1, 17, -11, 29, 3, -9, 16, 4, -3, 9, -4, 6, -3, 1, -4, 8, -3, 11, 5, 1, 1, 2, -20, -5, -1, -1, -6, 8, 6, -1, -4, -3, -2, 5, 0, -2, -2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30554, -2250, 5815, -1341, 2998, -1810, 1576, 381, 1297, -1889, -476, 1274, 206, 896, -46, 954, 792, 136, 528, -278, -408, -37, 303, -210, -240, 349, 3, 211, 103, -20, -87, -147, -122, -76, 80, 54, 57, -1, 4, 99, -247, 33, -16, -12, 12, -12, -105, -30, 65, -55, -35, 2, -17, 1, 0, -40, 10, -7, 36, 5, -18, 19, -16, 22, 15, 5, -4, -22, -1, 0, 11, -21, 15, -8, -13, 17, 5, -4, -1, -17, 3, -7, -24, -1, 19, -25, 12, 10, 2, 5, 2, -5, 8, -2, 8, 3, -11, 8, -7, -8, 4, 13, -1, -2, 13, -10, -4, 2, 4, -3, 12, 6, 3, -3, 2, 6, 10, 11, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30500, -2215, 5820, -1440, 3003, -1898, 1581, 291, 1302, -1944, -462, 1288, 216, 882, -83, 958, 796, 133, 510, -274, -397, -23, 290, -230, -229, 360, 15, 230, 110, -23, -98, -152, -121, -69, 78, 47, 57, -9, 3, 96, -247, 48, -8, -16, 7, -12, -107, -24, 65, -56, -50, 2, -24, 10, -4, -32, 8, -11, 28, 9, -20, 18, -18, 11, 9, 10, -6, -15, -14, 5, 6, -23, 10, 3, -7, 23, 6, -4, 9, -13, 4, 9, -11, -4, 12, -5, 7, 2, 6, 4, -2, 1, 10, 2, 7, 2, -6, 5, 5, -3, -5, -4, -1, 0, 2, -8, -3, -2, 7, -4, 4, 1, -2, -3, 6, 7, -2, -1, 0, -3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30421, -2169, 5791, -1555, 3002, -1967, 1590, 206, 1302, -1992, -414, 1289, 224, 878, -130, 957, 800, 135, 504, -278, -394, 3, 269, -255, -222, 362, 16, 242, 125, -26, -117, -156, -114, -63, 81, 46, 58, -10, 1, 99, -237, 60, -1, -20, -2, -11, -113, -17, 67, -56, -55, 5, -28, 15, -6, -32, 7, -7, 23, 17, -18, 8, -17, 15, 6, 11, -4, -14, -11, 7, 2, -18, 10, 4, -5, 23, 10, 1, 8, -20, 4, 6, -18, 0, 12, -9, 2, 1, 0, 4, -3, -1, 9, -2, 8, 3, 0, -1, 5, 1, -3, 4, 4, 1, 0, 0, -1, 2, 4, -5, 6, 1, 1, -1, -1, 6, 2, 0, 0, -7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30334, -2119, 5776, -1662, 2997, -2016, 1594, 114, 1297, -2038, -404, 1292, 240, 856, -165, 957, 804, 148, 479, -269, -390, 13, 252, -269, -219, 358, 19, 254, 128, -31, -126, -157, -97, -62, 81, 45, 61, -11, 8, 100, -228, 68, 4, -32, 1, -8, -111, -7, 75, -57, -61, 4, -27, 13, -2, -26, 6, -6, 26, 13, -23, 1, -12, 13, 5, 7, -4, -12, -14, 9, 0, -16, 8, 4, -1, 24, 11, -3, 4, -17, 8, 10, -22, 2, 15, -13, 7, 10, -4, -1, -5, -1, 10, 5, 10, 1, -4, -2, 1, -2, -3, 2, 2, 1, -5, 2, -2, 6, 4, -4, 4, 0, 0, -2, 2, 3, 2, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30220, -2068, 5737, -1781, 3000, -2047, 1611, 25, 1287, -2091, -366, 1278, 251, 838, -196, 952, 800, 167, 461, -266, -395, 26, 234, -279, -216, 359, 26, 262, 139, -42, -139, -160, -91, -56, 83, 43, 64, -12, 15, 100, -212, 72, 2, -37, 3, -6, -112, 1, 72, -57, -70, 1, -27, 14, -4, -22, 8, -2, 23, 13, -23, -2, -11, 14, 6, 7, -2, -15, -13, 6, -3, -17, 5, 6, 0, 21, 11, -6, 3, -16, 8, 10, -21, 2, 16, -12, 6, 10, -4, -1, -5, 0, 10, 3, 11, 1, -2, -1, 1, -3, -3, 1, 2, 1, -5, 3, -1, 4, 6, -4, 4, 0, 1, -1, 0, 3, 3, 1, -1, -4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-30100, -2013, 5675, -1902, 3010, -2067, 1632, -68, 1276, -2144, -333, 1260, 262, 830, -223, 946, 791, 191, 438, -265, -405, 39, 216, -288, -218, 356, 31, 264, 148, -59, -152, -159, -83, -49, 88, 45, 66, -13, 28, 99, -198, 75, 1, -41, 6, -4, -111, 11, 71, -56, -77, 1, -26, 16, -5, -14, 10, 0, 22, 12, -23, -5, -12, 14, 6, 6, -1, -16, -12, 4, -8, -19, 4, 6, 0, 18, 10, -10, 1, -17, 7, 10, -21, 2, 16, -12, 7, 10, -4, -1, -5, -1, 10, 4, 11, 1, -3, -2, 1, -3, -3, 1, 2, 1, -5, 3, -2, 4, 5, -4, 4, -1, 1, -1, 0, 3, 3, 1, -1, -5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-29992, -1956, 5604, -1997, 3027, -2129, 1663, -200, 1281, -2180, -336, 1251, 271, 833, -252, 938, 782, 212, 398, -257, -419, 53, 199, -297, -218, 357, 46, 261, 150, -74, -151, -162, -78, -48, 92, 48, 66, -15, 42, 93, -192, 71, 4, -43, 14, -2, -108, 17, 72, -59, -82, 2, -27, 21, -5, -12, 16, 1, 18, 11, -23, -2, -10, 18, 6, 7, 0, -18, -11, 4, -7, -22, 4, 9, 3, 16, 6, -13, -1, -15, 5, 10, -21, 1, 16, -12, 9, 9, -5, -3, -6, -1, 9, 7, 10, 2, -6, -5, 2, -4, -4, 1, 2, 0, -5, 3, -2, 6, 5, -4, 3, 0, 1, -1, 2, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-29873, -1905, 5500, -2072, 3044, -2197, 1687, -306, 1296, -2208, -310, 1247, 284, 829, -297, 936, 780, 232, 361, -249, -424, 69, 170, -297, -214, 355, 47, 253, 150, -93, -154, -164, -75, -46, 95, 53, 65, -16, 51, 88, -185, 69, 4, -48, 16, -1, -102, 21, 74, -62, -83, 3, -27, 24, -2, -6, 20, 4, 17, 10, -23, 0, -7, 21, 6, 8, 0, -19, -11, 5, -9, -23, 4, 11, 4, 14, 4, -15, -4, -11, 5, 10, -21, 1, 15, -12, 9, 9, -6, -3, -6, -1, 9, 7, 9, 1, -7, -5, 2, -4, -4, 1, 3, 0, -5, 3, -2, 6, 5, -4, 3, 0, 1, -1, 2, 4, 3, 0, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-29775, -1848, 5406, -2131, 3059, -2279, 1686, -373, 1314, -2239, -284, 1248, 293, 802, -352, 939, 780, 247, 325, -240, -423, 84, 141, -299, -214, 353, 46, 245, 154, -109, -153, -165, -69, -36, 97, 61, 65, -16, 59, 82, -178, 69, 3, -52, 18, 1, -96, 24, 77, -64, -80, 2, -26, 26, 0, -1, 21, 5, 17, 9, -23, 0, -4, 23, 5, 10, -1, -19, -10, 6, -12, -22, 3, 12, 4, 12, 2, -16, -6, -10, 4, 9, -20, 1, 15, -12, 11, 9, -7, -4, -7, -2, 9, 7, 8, 1, -7, -6, 2, -3, -4, 2, 2, 1, -5, 3, -2, 6, 4, -4, 3, 0, 1, -2, 3, 3, 3, -1, 0, -6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-29692, -1784, 5306, -2200, 3070, -2366, 1681, -413, 1335, -2267, -262, 1249, 302, 759, -427, 940, 780, 262, 290, -236, -418, 97, 122, -306, -214, 352, 46, 235, 165, -118, -143, -166, -55, -17, 107, 68, 67, -17, 68, 72, -170, 67, -1, -58, 19, 1, -93, 36, 77, -72, -69, 1, -25, 28, 4, 5, 24, 4, 17, 8, -24, -2, -6, 25, 6, 11, -6, -21, -9, 8, -14, -23, 9, 15, 6, 11, -5, -16, -7, -4, 4, 9, -20, 3, 15, -10, 12, 8, -6, -8, -8, -1, 8, 10, 5, -2, -8, -8, 3, -3, -6, 1, 2, 0, -4, 4, -1, 5, 4, -5, 2, -1, 2, -2, 5, 1, 1, -2, 0, -7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [-29619.400000000001, -1728.2, 5186.1000000000004, -2267.6999999999998, 3068.4000000000001, -2481.5999999999999, 1670.9000000000001, -458.0, 1339.5999999999999, -2288.0, -227.59999999999999, 1252.0999999999999, 293.39999999999998, 714.5, -491.10000000000002, 932.29999999999995, 786.79999999999995, 272.60000000000002, 250.0, -231.90000000000001, -403.0, 119.8, 111.3, -303.80000000000001, -218.80000000000001, 351.39999999999998, 43.799999999999997, 222.30000000000001, 171.90000000000001, -130.40000000000001, -133.09999999999999, -168.59999999999999, -39.299999999999997, -12.9, 106.3, 72.299999999999997, 68.200000000000003, -17.399999999999999, 74.200000000000003, 63.700000000000003, -160.90000000000001, 65.099999999999994, -5.9000000000000004, -61.200000000000003, 16.899999999999999, 0.69999999999999996, -90.400000000000006, 43.799999999999997, 79.0, -74.0, -64.599999999999994, 0.0, -24.199999999999999, 33.299999999999997, 6.2000000000000002, 9.0999999999999996, 24.0, 6.9000000000000004, 14.800000000000001, 7.2999999999999998, -25.399999999999999, -1.2, -5.7999999999999998, 24.399999999999999, 6.5999999999999996, 11.9, -9.1999999999999993, -21.5, -7.9000000000000004, 8.5, -16.600000000000001, -21.5, 9.0999999999999996, 15.5, 7.0, 8.9000000000000004, -7.9000000000000004, -14.9, -7.0, -2.1000000000000001, 5.0, 9.4000000000000004, -19.699999999999999, 3.0, 13.4, -8.4000000000000004, 12.5, 6.2999999999999998, -6.2000000000000002, -8.9000000000000004, -8.4000000000000004, -1.5, 8.4000000000000004, 9.3000000000000007, 3.7999999999999998, -4.2999999999999998, -8.1999999999999993, -8.1999999999999993, 4.7999999999999998, -2.6000000000000001, -6.0, 1.7, 1.7, 0.0, -3.1000000000000001, 4.0, -0.5, 4.9000000000000004, 3.7000000000000002, -5.9000000000000004, 1.0, -1.2, 2.0, -2.8999999999999999, 4.2000000000000002, 0.20000000000000001, 0.29999999999999999, -2.2000000000000002, -1.1000000000000001, -7.4000000000000004, 2.7000000000000002, -1.7, 0.10000000000000001, -1.8999999999999999, 1.3, 1.5, -0.90000000000000002, -0.10000000000000001, -2.6000000000000001, 0.10000000000000001, 0.90000000000000002, -0.69999999999999996, -0.69999999999999996, 0.69999999999999996, -2.7999999999999998, 1.7, -0.90000000000000002, 0.10000000000000001, -1.2, 1.2, -1.8999999999999999, 4.0, -0.90000000000000002, -2.2000000000000002, -0.29999999999999999, -0.40000000000000002, 0.20000000000000001, 0.29999999999999999, 0.90000000000000002, 2.5, -0.20000000000000001, -2.6000000000000001, 0.90000000000000002, 0.69999999999999996, -0.5, 0.29999999999999999, 0.29999999999999999, 0.0, -0.29999999999999999, 0.0, -0.40000000000000002, 0.29999999999999999, -0.10000000000000001, -0.90000000000000002, -0.20000000000000001, -0.40000000000000002, -0.40000000000000002, 0.80000000000000004, -0.20000000000000001, -0.90000000000000002, -0.90000000000000002, 0.29999999999999999, 0.20000000000000001, 0.10000000000000001, 1.8, -0.40000000000000002, -0.40000000000000002, 1.3, -1.0, -0.40000000000000002, -0.10000000000000001, 0.69999999999999996, 0.69999999999999996, -0.40000000000000002, 0.29999999999999999, 0.29999999999999999, 0.59999999999999998, -0.10000000000000001, 0.29999999999999999, 0.40000000000000002, -0.20000000000000001, 0.0, -0.5, 0.10000000000000001, -0.90000000000000002], [-29554.630000000001, -1669.05, 5077.9899999999998, -2337.2399999999998, 3047.6900000000001, -2594.5, 1657.76, -515.42999999999995, 1336.3, -2305.8299999999999, -198.86000000000001, 1246.3900000000001, 269.72000000000003, 672.50999999999999, -524.72000000000003, 920.54999999999995, 797.96000000000004, 282.06999999999999, 210.65000000000001, -225.22999999999999, -379.86000000000001, 145.15000000000001, 100.0, -305.36000000000001, -227.0, 354.41000000000003, 42.719999999999999, 208.94999999999999, 180.25, -136.53999999999999, -123.45, -168.05000000000001, -19.57, -13.550000000000001, 103.84999999999999, 73.599999999999994, 69.560000000000002, -20.329999999999998, 76.739999999999995, 54.75, -151.34, 63.630000000000003, -14.58, -63.530000000000001, 14.58, 0.23999999999999999, -86.359999999999999, 50.939999999999998, 79.879999999999995, -74.459999999999994, -61.140000000000001, -1.6499999999999999, -22.57, 38.729999999999997, 6.8200000000000003, 12.300000000000001, 25.350000000000001, 9.3699999999999992, 10.93, 5.4199999999999999, -26.32, 1.9399999999999999, -4.6399999999999997, 24.800000000000001, 7.6200000000000001, 11.199999999999999, -11.73, -20.879999999999999, -6.8799999999999999, 9.8300000000000001, -18.109999999999999, -19.710000000000001, 10.17, 16.219999999999999, 9.3599999999999994, 7.6100000000000003, -11.25, -12.76, -4.8700000000000001, -0.059999999999999998, 5.5800000000000001, 9.7599999999999998, -20.109999999999999, 3.5800000000000001, 12.69, -6.9400000000000004, 12.67, 5.0099999999999998, -6.7199999999999998, -10.76, -8.1600000000000001, -1.25, 8.0999999999999996, 8.7599999999999998, 2.9199999999999999, -6.6600000000000001, -7.7300000000000004, -9.2200000000000006, 6.0099999999999998, -2.1699999999999999, -6.1200000000000001, 2.1899999999999999, 1.4199999999999999, 0.10000000000000001, -2.3500000000000001, 4.46, -0.14999999999999999, 4.7599999999999998, 3.0600000000000001, -6.5800000000000001, 0.28999999999999998, -1.01, 2.0600000000000001, -3.4700000000000002, 3.77, -0.85999999999999999, -0.20999999999999999, -2.3100000000000001, -2.0899999999999999, -7.9299999999999997, 2.9500000000000002, -1.6000000000000001, 0.26000000000000001, -1.8799999999999999, 1.4399999999999999, 1.4399999999999999, -0.77000000000000002, -0.31, -2.27, 0.28999999999999998, 0.90000000000000002, -0.79000000000000004, -0.57999999999999996, 0.53000000000000003, -2.6899999999999999, 1.8, -1.0800000000000001, 0.16, -1.5800000000000001, 0.95999999999999996, -1.8999999999999999, 3.9900000000000002, -1.3899999999999999, -2.1499999999999999, -0.28999999999999998, -0.55000000000000004, 0.20999999999999999, 0.23000000000000001, 0.89000000000000001, 2.3799999999999999, -0.38, -2.6299999999999999, 0.95999999999999996, 0.60999999999999999, -0.29999999999999999, 0.40000000000000002, 0.46000000000000002, 0.01, -0.34999999999999998, 0.02, -0.35999999999999999, 0.28000000000000003, 0.080000000000000002, -0.87, -0.48999999999999999, -0.34000000000000002, -0.080000000000000002, 0.88, -0.16, -0.88, -0.76000000000000001, 0.29999999999999999, 0.33000000000000002, 0.28000000000000003, 1.72, -0.42999999999999999, -0.54000000000000004, 1.1799999999999999, -1.0700000000000001, -0.37, -0.040000000000000001, 0.75, 0.63, -0.26000000000000001, 0.20999999999999999, 0.34999999999999998, 0.53000000000000003, -0.050000000000000003, 0.38, 0.40999999999999998, -0.22, -0.10000000000000001, -0.56999999999999995, -0.17999999999999999, -0.81999999999999995], [-29496.57, -1586.4200000000001, 4944.2600000000002, -2396.0599999999999, 3026.3400000000001, -2708.54, 1668.1700000000001, -575.73000000000002, 1339.8499999999999, -2326.54, -160.40000000000001, 1232.0999999999999, 251.75, 633.73000000000002, -537.02999999999997, 912.65999999999997, 808.97000000000003, 286.48000000000002, 166.58000000000001, -211.03, -356.82999999999998, 164.46000000000001, 89.400000000000006, -309.72000000000003, -230.87, 357.29000000000002, 44.579999999999998, 200.25999999999999, 189.00999999999999, -141.05000000000001, -118.06, -163.16999999999999, -0.01, -8.0299999999999994, 101.04000000000001, 72.780000000000001, 68.689999999999998, -20.899999999999999, 75.920000000000002, 44.18, -141.40000000000001, 61.539999999999999, -22.829999999999998, -66.260000000000005, 13.1, 3.02, -78.090000000000003, 55.399999999999999, 80.439999999999998, -75.0, -57.799999999999997, -4.5499999999999998, -21.199999999999999, 45.240000000000002, 6.54, 14.0, 24.960000000000001, 10.460000000000001, 7.0300000000000002, 1.6399999999999999, -27.609999999999999, 4.9199999999999999, -3.2799999999999998, 24.41, 8.2100000000000009, 10.84, -14.5, -20.030000000000001, -5.5899999999999999, 11.83, -19.34, -17.41, 11.609999999999999, 16.710000000000001, 10.85, 6.96, -14.050000000000001, -10.74, -3.54, 1.6399999999999999, 5.5, 9.4499999999999993, -20.539999999999999, 3.4500000000000002, 11.51, -5.2699999999999996, 12.75, 3.1299999999999999, -7.1399999999999997, -12.380000000000001, -7.4199999999999999, -0.76000000000000001, 7.9699999999999998, 8.4299999999999997, 2.1400000000000001, -8.4199999999999999, -6.0800000000000001, -10.08, 7.0099999999999998, -1.9399999999999999, -6.2400000000000002, 2.73, 0.89000000000000001, -0.10000000000000001, -1.0700000000000001, 4.71, -0.16, 4.4400000000000004, 2.4500000000000002, -7.2199999999999998, -0.33000000000000002, -0.95999999999999996, 2.1299999999999999, -3.9500000000000002, 3.0899999999999999, -1.99, -1.03, -1.97, -2.7999999999999998, -8.3100000000000005, 3.0499999999999998, -1.48, 0.13, -2.0299999999999998, 1.6699999999999999, 1.6499999999999999, -0.66000000000000003, -0.51000000000000001, -1.76, 0.54000000000000004, 0.84999999999999998, -0.79000000000000004, -0.39000000000000001, 0.37, -2.5099999999999998, 1.79, -1.27, 0.12, -2.1099999999999999, 0.75, -1.9399999999999999, 3.75, -1.8600000000000001, -2.1200000000000001, -0.20999999999999999, -0.87, 0.29999999999999999, 0.27000000000000002, 1.04, 2.1299999999999999, -0.63, -2.4900000000000002, 0.94999999999999996, 0.48999999999999999, -0.11, 0.58999999999999997, 0.52000000000000002, 0.0, -0.39000000000000001, 0.13, -0.37, 0.27000000000000002, 0.20999999999999999, -0.85999999999999999, -0.77000000000000002, -0.23000000000000001, 0.040000000000000001, 0.87, -0.089999999999999997, -0.89000000000000001, -0.87, 0.31, 0.29999999999999999, 0.41999999999999998, 1.6599999999999999, -0.45000000000000001, -0.58999999999999997, 1.0800000000000001, -1.1399999999999999, -0.31, -0.070000000000000007, 0.78000000000000003, 0.54000000000000004, -0.17999999999999999, 0.10000000000000001, 0.38, 0.48999999999999999, 0.02, 0.44, 0.41999999999999998, -0.25, -0.26000000000000001, -0.53000000000000003, -0.26000000000000001, -0.79000000000000004], [-29442.0, -1501.0, 4797.1000000000004, -2445.0999999999999, 3012.9000000000001, -2845.5999999999999, 1676.7, -641.89999999999998, 1350.7, -2352.3000000000002, -115.3, 1225.5999999999999, 244.90000000000001, 582.0, -538.39999999999998, 907.60000000000002, 813.70000000000005, 283.30000000000001, 120.40000000000001, -188.69999999999999, -334.89999999999998, 180.90000000000001, 70.400000000000006, -329.5, -232.59999999999999, 360.10000000000002, 47.299999999999997, 192.40000000000001, 197.0, -140.90000000000001, -119.3, -157.5, 16.0, 4.0999999999999996, 100.2, 70.0, 67.700000000000003, -20.800000000000001, 72.700000000000003, 33.200000000000003, -129.90000000000001, 58.899999999999999, -28.899999999999999, -66.700000000000003, 13.199999999999999, 7.2999999999999998, -70.900000000000006, 62.600000000000001, 81.599999999999994, -76.099999999999994, -54.100000000000001, -6.7999999999999998, -19.5, 51.799999999999997, 5.7000000000000002, 15.0, 24.399999999999999, 9.4000000000000004, 3.3999999999999999, -2.7999999999999998, -27.399999999999999, 6.7999999999999998, -2.2000000000000002, 24.199999999999999, 8.8000000000000007, 10.1, -16.899999999999999, -18.300000000000001, -3.2000000000000002, 13.300000000000001, -20.600000000000001, -14.6, 13.4, 16.199999999999999, 11.699999999999999, 5.7000000000000002, -15.9, -9.0999999999999996, -2.0, 2.1000000000000001, 5.4000000000000004, 8.8000000000000007, -21.600000000000001, 3.1000000000000001, 10.800000000000001, -3.2999999999999998, 11.800000000000001, 0.69999999999999996, -6.7999999999999998, -13.300000000000001, -6.9000000000000004, -0.10000000000000001, 7.7999999999999998, 8.6999999999999993, 1.0, -9.0999999999999996, -4.0, -10.5, 8.4000000000000004, -1.8999999999999999, -6.2999999999999998, 3.2000000000000002, 0.10000000000000001, -0.40000000000000002, 0.5, 4.5999999999999996, -0.5, 4.4000000000000004, 1.8, -7.9000000000000004, -0.69999999999999996, -0.59999999999999998, 2.1000000000000001, -4.2000000000000002, 2.3999999999999999, -2.7999999999999998, -1.8, -1.2, -3.6000000000000001, -8.6999999999999993, 3.1000000000000001, -1.5, -0.10000000000000001, -2.2999999999999998, 2.0, 2.0, -0.69999999999999996, -0.80000000000000004, -1.1000000000000001, 0.59999999999999998, 0.80000000000000004, -0.69999999999999996, -0.20000000000000001, 0.20000000000000001, -2.2000000000000002, 1.7, -1.3999999999999999, -0.20000000000000001, -2.5, 0.40000000000000002, -2.0, 3.5, -2.3999999999999999, -1.8999999999999999, -0.20000000000000001, -1.1000000000000001, 0.40000000000000002, 0.40000000000000002, 1.2, 1.8999999999999999, -0.80000000000000004, -2.2000000000000002, 0.90000000000000002, 0.29999999999999999, 0.10000000000000001, 0.69999999999999996, 0.5, -0.10000000000000001, -0.29999999999999999, 0.29999999999999999, -0.40000000000000002, 0.20000000000000001, 0.20000000000000001, -0.90000000000000002, -0.90000000000000002, -0.10000000000000001, 0.0, 0.69999999999999996, 0.0, -0.90000000000000002, -0.90000000000000002, 0.40000000000000002, 0.40000000000000002, 0.5, 1.6000000000000001, -0.5, -0.5, 1.0, -1.2, -0.20000000000000001, -0.10000000000000001, 0.80000000000000004, 0.40000000000000002, -0.10000000000000001, -0.10000000000000001, 0.29999999999999999, 0.40000000000000002, 0.10000000000000001, 0.5, 0.5, -0.29999999999999999, -0.40000000000000002, -0.40000000000000002, -0.29999999999999999, -0.80000000000000004], [10.300000000000001, 18.100000000000001, -26.600000000000001, -8.6999999999999993, -3.2999999999999998, -27.399999999999999, 2.1000000000000001, -14.1, 3.3999999999999999, -5.5, 8.1999999999999993, -0.69999999999999996, -0.40000000000000002, -10.1, 1.8, -0.69999999999999996, 0.20000000000000001, -1.3, -9.0999999999999996, 5.2999999999999998, 4.0999999999999996, 2.8999999999999999, -4.2999999999999998, -5.2000000000000002, -0.20000000000000001, 0.5, 0.59999999999999998, -1.3, 1.7, -0.10000000000000001, -1.2, 1.3999999999999999, 3.3999999999999999, 3.8999999999999999, 0.0, -0.29999999999999999, -0.10000000000000001, 0.0, -0.69999999999999996, -2.1000000000000001, 2.1000000000000001, -0.69999999999999996, -1.2, 0.20000000000000001, 0.29999999999999999, 0.90000000000000002, 1.6000000000000001, 1.0, 0.29999999999999999, -0.20000000000000001, 0.80000000000000004, -0.5, 0.40000000000000002, 1.3, -0.20000000000000001, 0.10000000000000001, -0.29999999999999999, -0.59999999999999998, -0.59999999999999998, -0.80000000000000004, 0.10000000000000001, 0.20000000000000001, -0.20000000000000001, 0.20000000000000001, 0.0, -0.29999999999999999, -0.59999999999999998, 0.29999999999999999, 0.5, 0.10000000000000001, -0.20000000000000001, 0.5, 0.40000000000000002, -0.20000000000000001, 0.10000000000000001, -0.29999999999999999, -0.40000000000000002, 0.29999999999999999, 0.29999999999999999, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]])
    return models,coeffs

def get_cals3k():
    models=[-1000,-990,-980,-970,-960,-950,-940,-930,-920,-910,-900,-890,-880,-870,-860,-850,-840,-830,-820,-810,-800,-790,-780,-770,-760,-750,-740,-730,-720,-710,-700,-690,-680,-670,-660,-650,-640,-630,-620,-610,-600,-590,-580,-570,-560,-550,-540,-530,-520,-510,-500,-490,-480,-470,-460,-450,-440,-430,-420,-410,-400,-390,-380,-370,-360,-350,-340,-330,-320,-310,-300,-290,-280,-270,-260,-250,-240,-230,-220,-210,-200,-190,-180,-170,-160,-150,-140,-130,-120,-110,-100,-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,470,480,490,500,510,520,530,540,550,560,570,580,590,600,610,620,630,640,650,660,670,680,690,700,710,720,730,740,750,760,770,780,790,800,810,820,830,840,850,860,870,880,890,900,910,920,930,940,950,960,970,980,990,1000,1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,1110,1120,1130,1140,1150,1160,1170,1180,1190,1200,1210,1220,1230,1240,1250,1260,1270,1280,1290,1300,1310,1320,1330,1340,1350,1360,1370,1380,1390,1400,1410,1420,1430,1440,1450,1460,1470,1480,1490,1500,1510,1520,1530,1540,1550,1560,1570,1580,1590,1600,1610,1620,1630,1640,1650,1660,1670,1680,1690,1700,1710,1720,1730,1740,1750,1760,1770,1780,1790,1800,1810,1820,1830,1840,1850,1860,1870,1880,1890,1900,1910,1920,1930,1940]
    coeffs=numpy.array([[-33719.7383551,-263.748312707,-3182.51718048,-1429.82706058,-3025.5410826,213.155259437,2266.51141514,-360.234747256,-671.705672116,886.732039779,282.550399141,-672.340989688,-42.6562230009,-247.983163026,422.2624706,-352.989728466,-331.563134383,277.189968788,-930.510984722,-283.079111451,-124.458379384,-25.1987098669,243.399219266,-469.960044888,83.9046787025,94.6715625921,-62.8508455388,144.441607761,109.019363939,123.352707625,-180.138957665,-166.700991413,-13.4952584064,-209.212926401,268.465603334,-9.36433934422,27.4859163563,22.4897582198,12.7530025413,-15.3127311921,-45.8468405068,-75.3470129602,-91.9902117593,-3.90610128725,-68.9993902167,45.2482498001,-28.9350241055,-13.1915386411,2.15443667308,2.96670887781,1.33708714223,5.25984505842,-6.45194299119,-3.65250488186,-18.518252081,-1.50357286527,-29.6880521677,-30.8677610054,-2.22560178608,-12.0304104859,16.4293362981,3.959353332,9.81307259746,0.508496867888,0.892754815706,-5.04951318522,2.99223608283,1.18984898779,5.16126810248,-2.72424959905,-2.93166650903,-4.6895192021,-8.61616974617,6.11196767069,-3.40147084135,8.10463399849,-3.3960587882,-2.34016514915,-3.43653173898,-1.47884778825,-0.180750062376,-0.889317945872,0.257315221392,-0.218618402042,-0.080963047642,-0.541180388083,-0.455133175674,-0.640012340672,-1.60805464047,-0.809998928739,-0.270099275862,-0.951157574199,0.586727659478,-0.598526256261,-0.355648720842,-0.0982498984115,-1.04050581859,0.281614504234,-0.739380507402,-0.0753312870462,0.00901542800022,-0.13583818432,-0.057921066754,-0.13648361368,0.0257340571037,0.0475545012495,0.256384164088,-0.152571742257,-0.140122389204,0.0264797936968,0.210413134183,0.836796357888,0.611626383014,0.0881276528425,-0.0940766001223,-0.714844630893,-0.468516903706,-0.258791646165,-0.0968510440335,0.180331918475],[-33756.7513162,-311.420517835,-3168.86618334,-1398.81092723,-2996.25760606,217.986142726,2248.77402862,-349.046118036,-708.717080295,864.716570088,266.816460025,-659.647470949,-35.3490663284,-258.069134251,433.96159791,-348.830237479,-335.934908548,278.552553628,-928.25548469,-281.198178007,-118.834149016,-28.7068983192,244.612282973,-479.55021698,80.5766226198,94.832415576,-65.4204448668,144.876403323,107.526656022,126.36750355,-183.97524265,-167.160489281,-17.8233688152,-211.410995491,270.496961013,-8.84103785339,27.1972685776,23.8293348731,12.0244373335,-15.4492759722,-45.5440450629,-76.9257006352,-92.8360445566,-4.82403386593,-69.9045222465,45.5909688344,-28.5648018715,-13.4340272034,2.09010060562,3.14450652311,1.15517498125,5.24512682358,-6.71122714653,-3.42608985004,-18.8257610212,-1.46254527216,-29.9276529522,-31.1191437024,-2.04398363683,-12.0839719283,16.5113589645,3.8981908616,9.7610349045,0.52501213189,0.929334441485,-4.99223864906,2.92601397671,1.18069071665,5.20054491556,-2.7791771296,-2.90650586508,-4.80950113379,-8.72822692063,6.16092295255,-3.41852148473,8.16409299511,-3.42462934817,-2.39720312491,-3.44926630865,-1.47954187682,-0.168306431463,-0.884189242024,0.263210454257,-0.192409853939,-0.0519482970408,-0.550675054444,-0.462953104104,-0.634780380518,-1.64758667521,-0.825840174108,-0.269874333587,-0.966038503783,0.593363342008,-0.607336671734,-0.386188948994,-0.101765376474,-1.03771681031,0.283515470714,-0.73765951108,-0.0821921560254,0.00947750698842,-0.135602751928,-0.0540077085324,-0.137775899909,0.0269569791912,0.0447475552833,0.267383673518,-0.160680420479,-0.139573911834,0.0224770497515,0.20561007453,0.842796278027,0.608509410013,0.0839125121203,-0.101107058238,-0.720369893332,-0.471588868236,-0.260040331141,-0.0969735539762,0.182813841209],[-33793.0523859,-360.562883659,-3153.20103421,-1363.869828,-2965.17082847,222.114904916,2231.49552355,-336.25415117,-744.932164099,840.826857343,252.400644375,-646.961325772,-28.057742808,-268.37542123,447.591140188,-344.017742483,-340.821874012,279.984937128,-925.76819666,-278.770345194,-113.042633124,-31.8402342273,246.069128075,-489.957061855,77.3936595337,94.9868473946,-68.2905889353,145.57045991,106.148220499,129.626926908,-187.815725738,-167.710565869,-22.2795418317,-213.863656728,272.775402155,-8.24179673401,26.8888564019,25.1430441712,11.2833296269,-15.5820549198,-45.2905310853,-78.5226499154,-93.7500299576,-5.78045711036,-70.8702645247,45.9495906276,-28.1983364903,-13.7167550425,2.03689585678,3.31789827079,0.951921910372,5.22002039487,-6.99993099512,-3.20459332979,-19.128771058,-1.42219095115,-30.1796441771,-31.3872191653,-1.87263288767,-12.1339387178,16.5964682254,3.84345471906,9.71743963838,0.546137981842,0.966911392869,-4.93894904149,2.85673130741,1.16537472522,5.24332367622,-2.82871856203,-2.88250892183,-4.93001639247,-8.84572735942,6.21145884395,-3.43624660987,8.22515283762,-3.45577959481,-2.45823762157,-3.46394133044,-1.48280346513,-0.154599203981,-0.878800516559,0.269796909563,-0.165897593076,-0.0234457247429,-0.560129366262,-0.469626664186,-0.630303822353,-1.68771596918,-0.84196378321,-0.271730319286,-0.980940542738,0.597851544964,-0.61621887913,-0.418318972156,-0.104423922618,-1.03563695428,0.285759101182,-0.737061816188,-0.0891102329962,0.010271839232,-0.134983829204,-0.049855085683,-0.139625332511,0.0286219688263,0.0418713255582,0.279160162664,-0.168738241147,-0.138775268205,0.0180005973893,0.200965679858,0.84883320881,0.605809498429,0.0793704332232,-0.108240994648,-0.72626829338,-0.475179030718,-0.261450715116,-0.0972719789519,0.185629788885],[-33827.8260149,-411.041889541,-3134.5784429,-1325.4443414,-2931.96828094,225.680990752,2214.28450645,-322.16247157,-780.143058822,815.060050115,239.576597944,-634.382817728,-20.8030233217,-279.012097951,462.985017169,-338.595559814,-346.112013657,281.415229144,-923.11183766,-275.783662772,-107.1523454,-34.6158097957,247.743452655,-501.129105178,74.35724799,95.1484380914,-71.4750256563,146.522123184,104.892176532,133.126298704,-191.635095096,-168.351552343,-26.8616872428,-216.566408243,275.285499279,-7.56952483173,26.5640741673,26.4206929568,10.5373092338,-15.702493793,-45.0925828899,-80.1303527703,-94.7343621895,-6.77652120778,-71.8940577099,46.3159889128,-27.8340791916,-14.0369775496,1.99290967238,3.4849795542,0.727748394206,5.18644836023,-7.3196567653,-2.98842308918,-19.4261678751,-1.38316389815,-30.445622318,-31.6705553583,-1.71577581357,-12.1792362724,16.6855220374,3.79634810577,9.68300185941,0.57173269784,1.00504425509,-4.88940980956,2.78524522694,1.1434894787,5.28959020587,-2.87291484859,-2.85994751925,-5.05130669969,-8.96882238158,6.26287702592,-3.45416396313,8.28799186547,-3.48887801616,-2.52279041821,-3.48061304831,-1.48884772068,-0.139625549083,-0.87328409807,0.277313057853,-0.139113553989,0.00430602738694,-0.569340708968,-0.475253366397,-0.626727136272,-1.72844248658,-0.858511713064,-0.275856439105,-0.995745734084,0.600074734371,-0.625026175213,-0.451886140145,-0.106161627437,-1.03424454006,0.288362847461,-0.737574352726,-0.0960511057336,0.011344818048,-0.133899988811,-0.0455053235623,-0.142036324959,0.0307565716806,0.0388642334457,0.291742636179,-0.176778812295,-0.137733010911,0.0130589750389,0.196506735221,0.85488202306,0.603584056693,0.074556225877,-0.115418231676,-0.732497085193,-0.479278325551,-0.262994487971,-0.0977764223595,0.188774116897],[-33859.7291554,-462.844483371,-3111.63976126,-1284.4479122,-2896.36177555,228.463716987,2196.75299475,-307.280166839,-814.078078638,787.391640287,228.598839492,-621.997537164,-13.6252424963,-289.991553046,479.956246396,-332.631988269,-351.666948485,282.767074677,-920.364621619,-272.251583533,-101.226035176,-37.0703400308,249.596414954,-512.972057664,71.4660282882,95.3323032807,-74.9720974345,147.717065203,103.757387541,136.860705278,-195.408228516,-169.069912206,-31.5610582114,-219.5078486,278.009119192,-6.82809684623,26.2279878561,27.6529940096,9.7934762176,-15.797851856,-44.9568239686,-81.7397908141,-95.7883452869,-7.81128995524,-72.9718120621,46.6847494229,-27.4703536846,-14.3893044596,1.95566841483,3.64347175267,0.484083375252,5.14631186388,-7.67138447826,-2.7785946729,-19.7165099608,-1.34581492589,-30.7264223701,-31.9663078919,-1.57670784878,-12.218687992,16.7793272528,3.75747313998,9.65786808439,0.601641948261,1.043302905,-4.84341468489,2.712548439,1.11495988455,5.33887241221,-2.91174949324,-2.83902681272,-5.17349200143,-9.09733658231,6.31457487461,-3.47166713003,8.3529046838,-3.5233066519,-2.59018594931,-3.49936800238,-1.49783425573,-0.123406129966,-0.867778812274,0.285953017553,-0.112094978299,0.0310783042354,-0.578113429163,-0.479927657978,-0.624247458184,-1.76971739911,-0.875596864911,-0.282393465593,-1.01032191468,0.599937914144,-0.633671637985,-0.486719976258,-0.107022587697,-1.03347960049,0.291317047743,-0.73916149587,-0.102974142838,0.0126313268842,-0.132285538972,-0.0409955329335,-0.145001762839,0.033368576396,0.0356622459267,0.305143159462,-0.184839198376,-0.136445858864,0.00766257817911,0.19225378654,0.860896594579,0.601850780996,0.0695394863854,-0.122596387493,-0.738984994799,-0.483859950754,-0.264642577362,-0.098509206966,0.192222788776],[-33887.8547111,-515.961968415,-3082.75692975,-1242.12438839,-2858.24389721,230.337929569,2178.8474946,-292.189791404,-846.448773695,757.876584794,219.685444994,-609.819358726,-6.53585102718,-301.337521027,498.26884986,-326.209704545,-357.336154067,283.976628419,-917.622695998,-268.234395404,-95.315369363,-39.2652389345,251.592823157,-525.362778234,68.7203422312,95.5579277219,-78.7725630968,149.133907819,102.739800571,140.823945061,-199.111295732,-169.840978672,-36.3634272468,-222.672200469,280.927188883,-6.02261394544,25.8853068969,28.8322111734,9.05792494142,-15.8536174786,-44.8892851178,-83.3402708476,-96.9092405597,-8.88150095025,-74.0975918734,47.0506321748,-27.1053697008,-14.766995171,1.92217532122,3.79073568521,0.222860651128,5.1014793073,-8.05514989148,-2.57686037003,-19.9981590517,-1.30962438897,-31.0226491173,-32.2701279453,-1.45809897282,-12.2507854566,16.8791210414,3.72752511861,9.64180327012,0.635563566542,1.08132804937,-4.80085169743,2.63965803462,1.08001744639,5.39052579277,-2.9451083395,-2.81995230931,-5.29645655247,-9.23084588151,6.36616245804,-3.48791196072,8.42030576376,-3.55838458994,-2.65971108538,-3.52045663257,-1.50983771856,-0.105974895176,-0.862438265885,0.295909294799,-0.08490295532,0.0567148055929,-0.586330615362,-0.483765715816,-0.623098357162,-1.81145668339,-0.89327057601,-0.291417707284,-1.02451089265,0.597325549185,-0.642084631594,-0.522644395809,-0.107105053201,-1.03321161783,0.294647310074,-0.741774270799,-0.109847038034,0.0140602675086,-0.130090524932,-0.036366812914,-0.148511453563,0.0364561907228,0.0322056090058,0.319361338607,-0.192949966158,-0.134902722441,0.00181621188893,0.188229630813,0.866822586222,0.600609076757,0.0644189717351,-0.129745368834,-0.74562681492,-0.488882188967,-0.266354443749,-0.0994945678597,0.195944138333],[-33912.0518388,-569.486738071,-3047.95458352,-1199.50682107,-2817.73193939,231.315276385,2160.59541747,-277.438189801,-877.025527532,726.697363539,212.974364176,-597.811454469,0.414379658706,-313.057409133,517.539974011,-319.410558873,-362.932980687,285.00983167,-914.970606383,-263.822056492,-89.4392783129,-41.2793302095,253.700872608,-538.154218291,66.1217080803,95.8512457314,-82.8530947906,150.749033226,101.842719488,145.003500538,-202.726878448,-170.635900896,-41.2547991691,-226.039666207,284.01817708,-5.16246867192,25.5411956081,29.9534060226,8.33741972002,-15.8566742828,-44.8920819485,-84.9210881138,-98.0896318984,-9.98353116248,-75.2622309535,47.4089032146,-26.7364902309,-15.1624332026,1.88922179894,3.92439017665,-0.0535299965301,5.05448354979,-8.46894651901,-2.38536324328,-20.2688976043,-1.27338036017,-31.3346530047,-32.576939165,-1.36153248899,-12.2740970684,16.9861568564,3.70702208705,9.63424768188,0.672925148712,1.11859385232,-4.76158856808,2.56760944709,1.03919391806,5.44381956,-2.97282884383,-2.80290169545,-5.41998522029,-9.36861349215,6.41713318512,-3.50191531817,8.49037035749,-3.5933539239,-2.73067950783,-3.54413500617,-1.52492452301,-0.0873994797811,-0.8574618344,0.307317090974,-0.0576021290836,0.0811184982873,-0.593921881637,-0.486852330941,-0.623450487205,-1.85355353759,-0.911492525632,-0.302929400174,-1.03812487958,0.592154076335,-0.65018876039,-0.559442023009,-0.10655294816,-1.03326564099,0.298368925722,-0.745336028661,-0.116631906763,0.0155508427255,-0.127297369522,-0.0316685365081,-0.152535383616,0.0400171307672,0.0284605866805,0.334364615923,-0.201117958695,-0.133094658322,-0.00447702016474,0.184459198052,0.872583209123,0.599827634824,0.0592919616612,-0.136851867652,-0.752301833838,-0.494294375624,-0.2680913195,-0.100754095005,0.199892094918],[-33932.6818852,-620.656608221,-3008.12878384,-1157.51087967,-2774.88707437,231.144172485,2141.90954521,-263.726635353,-905.666459454,694.03450958,208.466357438,-585.845862577,7.16686140043,-325.024655824,537.328761088,-312.338148434,-368.269955771,285.841815463,-912.446008508,-259.110577283,-83.5870907007,-43.1918194918,255.873934982,-551.184424821,63.6646410476,96.2345688712,-87.1743214919,152.534321613,101.066653692,149.383810203,-206.247205276,-171.416932124,-46.2289537456,-229.585563159,287.253597256,-4.25934013569,25.2021678249,31.0151993958,7.63813272897,-15.7963866256,-44.961394376,-86.4743083834,-99.3174926679,-11.1150960161,-76.4552326144,47.7575500233,-26.3588119277,-15.5660520135,1.85413594274,4.04261098618,-0.341795854566,5.00798405075,-8.90931274817,-2.20619168545,-20.5268315974,-1.23577276381,-31.6621761087,-32.8809334178,-1.28728218538,-12.2871643108,17.100562742,3.69528049362,9.63369399563,0.712995546954,1.15440170525,-4.72540116761,2.49729635233,0.993229383668,5.49770078529,-2.99480795642,-2.7878532912,-5.5439227934,-9.50928387155,6.46660268828,-3.51261421064,8.56292224378,-3.6274855991,-2.80239591043,-3.57032330795,-1.54304815053,-0.067784540922,-0.853076359407,0.320175872282,-0.0302485195919,0.104267385801,-0.600865099708,-0.489163116681,-0.625392272776,-1.89589827918,-0.93010820449,-0.316867679649,-1.05093949692,0.584420147661,-0.657915719732,-0.596912697069,-0.105549910666,-1.03343925371,0.302425120196,-0.749742631584,-0.123283028129,0.0170068472543,-0.12392603552,-0.0269513875937,-0.157006100827,0.0440261577058,0.0244226829387,0.350071559109,-0.209331969257,-0.131009564058,-0.0112115486138,0.180978968716,0.87806783709,0.599440608726,0.0542312023892,-0.143901083641,-0.758881272641,-0.500015935258,-0.269837041122,-0.102294160371,0.20400131272],[-33950.5802981,-666.934141657,-2964.57052965,-1116.84161314,-2729.9532162,229.515441031,2122.43501273,-251.653969348,-932.283096637,659.932544154,206.099110194,-573.862743417,13.5593993913,-337.079972318,557.144975604,-305.081865021,-373.160506542,286.420084355,-910.065733858,-254.173528601,-77.7171715377,-45.0679606363,258.070480922,-564.327106695,61.339793742,96.7151109586,-91.6839698901,154.45750949,100.403931354,153.94677479,-209.675022073,-172.14817295,-51.2931395645,-233.283162926,290.602619503,-3.32539803276,24.877083335,32.0185066098,6.96529211239,-15.6653483279,-45.0908085835,-87.9946671076,-100.576571672,-12.2762452544,-77.6655193547,48.0931866041,-25.9654988358,-15.9697738068,1.81496724935,4.14444284499,-0.638240600577,4.96416559087,-9.37205465017,-2.0405258676,-20.769678175,-1.19537702499,-32.004706592,-33.1769618711,-1.23514644904,-12.288358895,17.2215445025,3.69128836147,9.63826991619,0.754987053227,1.18777361314,-4.69180879115,2.4293471441,0.94312701551,5.55073740972,-3.01107052261,-2.77451902408,-5.66821559262,-9.65106285386,6.51331767596,-3.51882093911,8.63730999022,-3.66013246176,-2.87430923651,-3.59871530531,-1.56399317938,-0.047317883025,-0.8494936423,0.334349513043,-0.0028929192775,0.126143062888,-0.607159959637,-0.490495620443,-0.628929948158,-1.93829104104,-0.948871575476,-0.333176532503,-1.06273783561,0.574195018613,-0.665136985107,-0.634869628473,-0.104212389109,-1.0335148708,0.306726920406,-0.754878027017,-0.129742042764,0.0183247472079,-0.120016561888,-0.0222736664491,-0.161824825261,0.0484245560629,0.0201179486029,0.366364806469,-0.217565112396,-0.128641248609,-0.0183681184348,0.177835834412,0.883159707106,0.599389738199,0.0492758838158,-0.150874566665,-0.765253277231,-0.505953013824,-0.271583470965,-0.104106994946,0.20821095883],[-33965.860536,-707.600617511,-2918.8261235,-1078.04449159,-2683.38772738,226.069141609,2101.56364625,-241.417060796,-956.894265113,624.33860541,205.743902773,-561.957510807,19.378002495,-349.035909859,576.543289175,-297.695380866,-377.432787402,286.672372758,-907.863154386,-249.032863759,-71.7671908028,-46.932512114,260.249859826,-577.49916957,59.1357654651,97.2777826721,-96.3203114263,156.482003983,99.8370846832,158.672241647,-213.014162253,-172.798174707,-56.4615828022,-237.09943314,294.031783466,-2.37207988641,24.5761146555,32.9660512796,6.32312419092,-15.46035144,-45.2730466566,-89.4761047848,-101.845546737,-13.4689948497,-78.8809632357,48.4083786069,-25.5511412792,-16.3671169145,1.77092537206,4.23000767401,-0.938917563559,4.92488431369,-9.85234076338,-1.88836601386,-20.9943589571,-1.1504121136,-32.362152417,-33.461136067,-1.20547525629,-12.2762694028,17.347838085,3.69453865121,9.6461658538,0.7981758473,1.21760008832,-4.65989999151,2.36426458727,0.890103149673,5.6013165594,-3.02206148586,-2.76227640964,-5.79300404438,-9.79185997895,6.55568490649,-3.51930656887,8.71256277842,-3.69066075156,-2.94586819456,-3.62889404627,-1.58743887076,-0.0262768009628,-0.846833118464,0.34960627828,0.0244735889612,0.146680679952,-0.612787495258,-0.49054616661,-0.633982987315,-1.98044181201,-0.967474223715,-0.351861427871,-1.07334232306,0.561643271675,-0.671642140777,-0.673074855958,-0.102571453282,-1.0333304242,0.311167294081,-0.760628269468,-0.135939401915,0.0194058090033,-0.115627655058,-0.0176949745128,-0.166874077336,0.0531347438935,0.0155989759707,0.383096309489,-0.225780872799,-0.125997691951,-0.0259205674855,0.175086458317,0.887757070255,0.599643956603,0.044438632262,-0.157745725838,-0.771342194878,-0.51200700956,-0.273311054984,-0.106166697146,0.212469782963],[-33978.6616949,-743.569685045,-2871.54654091,-1041.55067955,-2635.60318276,220.831984323,2078.81063146,-233.152868547,-979.60562487,587.240010237,207.212523159,-550.29801908,24.4536959454,-360.701053864,595.183988398,-290.212153429,-380.974022166,286.542893075,-905.880665919,-243.678630774,-65.6658388225,-48.8051180711,262.36749071,-590.666695048,57.0347141778,97.8934725221,-101.025711911,158.569698813,99.3421982255,163.535337287,-216.270664397,-173.338919791,-61.7482355584,-240.990130274,297.508456304,-1.41009662739,24.3086108757,33.8623867638,5.71211194387,-15.1817884422,-45.5004232063,-90.9131815784,-103.10124475,-14.696979523,-80.0888934688,48.6931704387,-25.1127134378,-16.7530791092,1.72178677716,4.30035232974,-1.23982134445,4.89131331391,-10.344550354,-1.74941942569,-21.1983452203,-1.09894494319,-32.7351842319,-33.7297720659,-1.19888811858,-12.2492064845,17.4779923912,3.70498877065,9.65573892941,0.84169858934,1.24287683793,-4.62851890965,2.30236347689,0.835476046038,5.64792804328,-3.02843801729,-2.75026891899,-5.9185981082,-9.92933975373,6.59198276883,-3.51289636779,8.78764361606,-3.71860529807,-3.01643235339,-3.6604043813,-1.61292062596,-0.00497797708595,-0.845171469835,0.365668599391,0.0519211828699,0.165884382556,-0.617770214362,-0.488937290752,-0.640420742736,-2.02206823476,-0.985543014807,-0.372981200403,-1.0825525917,0.54700589544,-0.677183592359,-0.711267650985,-0.100589598928,-1.03279896769,0.31563255311,-0.766895163125,-0.14181131002,0.0201519096548,-0.110837870523,-0.0132682340927,-0.172037894019,0.0580741435089,0.0109514863146,0.400095757032,-0.233925130873,-0.12308776663,-0.0338508818572,0.172810523857,0.891777737621,0.600197856346,0.0397229150463,-0.16447960272,-0.777092836759,-0.518079408578,-0.274982867654,-0.108432481725,0.216738128774],[-33989.6948797,-775.806536572,-2823.39454148,-1007.54442102,-2586.91498124,214.36931473,2054.05133312,-227.129188639,-1000.54607621,548.727620895,210.195315149,-539.072467714,28.6646791259,-371.903937875,612.851555798,-282.644189532,-383.737511829,286.000091554,-904.163943768,-238.104247478,-59.3189751902,-50.7086882635,264.380697802,-603.838739866,55.0183039774,98.5336368523,-105.755016867,160.687956853,98.8980663558,168.50477845,-219.452799094,-173.74720656,-67.1636765088,-244.903334733,301.00878629,-0.450647334554,24.0837580324,34.7132574187,5.12967748723,-14.8333591617,-45.7638254227,-92.30207041,-104.320145587,-15.96465181,-81.2766040586,48.9365543952,-24.6491804847,-17.1245647077,1.66754836606,4.35745279125,-1.53690584681,4.86431001299,-10.8421509269,-1.62353354068,-21.379813661,-1.03857604634,-33.1250990394,-33.9790600711,-1.2159458311,-12.2051812814,17.6106912866,3.72310949124,9.66576192094,0.884511055559,1.26279752483,-4.59642244043,2.243805262,0.780626655465,5.68944393384,-3.03076483598,-2.73748501932,-6.04527212256,-10.0611093761,6.62042967894,-3.49857566962,8.86149867786,-3.74372025561,-3.08532232629,-3.69280206081,-1.63992640286,0.0162653884782,-0.844605424604,0.38228533814,0.0795610985425,0.18387433975,-0.622205204149,-0.485243449973,-0.648063032677,-2.06293876487,-1.00262506658,-0.396611418332,-1.09014572996,0.530572326325,-0.681491294626,-0.749187386137,-0.0981485444789,-1.03191139656,0.320007780453,-0.773604852365,-0.14731110994,0.0204687266938,-0.105743787187,-0.00903647618741,-0.177212446521,0.0631612893789,0.00629326628606,0.417180833596,-0.241917767012,-0.119915132729,-0.0421467125637,0.171107221236,0.895164889342,0.601068559067,0.0351349039197,-0.171035800749,-0.782465667532,-0.524088308645,-0.276550147623,-0.110853906735,0.220994381874],[-34000.5431711,-805.335048952,-2775.40960098,-976.200432707,-2537.88585304,207.560858233,2027.11742357,-223.36271368,-1019.85373506,508.898276986,214.339940585,-528.523624545,31.9393949898,-382.569192256,629.377141045,-274.985933974,-385.714170982,285.021121432,-902.793853869,-232.332760024,-52.6500187779,-52.6516136051,266.251474193,-617.020938889,53.0784936573,99.1726489572,-110.472634577,162.800761672,98.4847220624,173.542106447,-222.562918412,-174.006036813,-72.7166333229,-248.786971422,304.509021105,0.495787611933,23.9101253148,35.5249469758,4.57141228855,-14.4205956942,-46.0545721628,-93.6401039939,-105.479769235,-17.2769875281,-82.4308529603,49.1259306366,-24.1612207048,-17.4799806703,1.6078368149,4.40419285954,-1.82617139128,4.84486726758,-11.3384296223,-1.51056964117,-21.53757601,-0.966188605983,-33.5339025475,-34.2051447706,-1.25777499195,-12.1429371078,17.7450315614,3.74974224359,9.67552718129,0.92546255567,1.27694602031,-4.56241882039,2.18882131424,0.727097967007,5.72513094861,-3.02956227461,-2.72285091113,-6.1733422904,-10.1850348753,6.63926761837,-3.47553734827,8.9332040712,-3.7657085562,-3.15191767251,-3.72573848509,-1.66808446318,0.0371544998672,-0.845238817202,0.399251839895,0.107532170673,0.200855908841,-0.626218369054,-0.47908807132,-0.656722047493,-2.10286035572,-1.01823860184,-0.422833730247,-1.09589042934,0.512641436029,-0.684290099711,-0.786577543404,-0.0950997335274,-1.03069142341,0.324215166108,-0.780665433191,-0.152405514207,0.0202642334946,-0.100453262594,-0.00503393778638,-0.182317663128,0.0683173576924,0.00175398669402,0.434175383981,-0.249655951211,-0.116475077297,-0.0507954461316,0.170079148534,0.89789017672,0.602288039703,0.0306983257646,-0.177365849782,-0.787433364141,-0.529965164358,-0.277957025489,-0.113384189364,0.225222120941],[-34013.4041525,-834.455949882,-2728.48453425,-947.711770248,-2489.48823081,201.037982682,1997.64731045,-221.631771775,-1037.55138796,467.743554164,219.377767665,-518.868793412,34.2141123729,-392.587590908,644.528685476,-267.210309111,-386.898131316,283.587570624,-901.864407396,-226.415323006,-45.6176097244,-54.6608052867,267.943980568,-630.186327383,51.214877251,99.7930350886,-115.145693325,164.86602567,98.0778843961,178.615385434,-225.601069362,-174.096940424,-78.4168692389,-252.588813327,307.978226485,1.41966967558,23.7958437017,36.303368592,4.03344000916,-13.9470874624,-46.3642029559,-94.9256153871,-106.558872347,-18.6401705953,-83.537287406,49.2508396808,-23.6501376545,-17.8171315946,1.54105402921,4.44367634967,-2.10380509131,4.8341560464,-11.8270915382,-1.40986968779,-21.6708669015,-0.878422333106,-33.9636054233,-34.4038786258,-1.32582621408,-12.0620756,17.8801695589,3.78548336749,9.68452578757,0.963340949514,1.28518348537,-4.52546254183,2.13778605784,0.676491321789,5.75447846683,-3.02515190215,-2.7052928051,-6.30311897466,-10.2992717188,6.64705212631,-3.44316967699,9.00214897712,-3.78400105856,-3.21560647752,-3.75886548156,-1.69718880204,0.0574183810774,-0.847191490401,0.416386707977,0.135955379837,0.217049373841,-0.629905325209,-0.470148047064,-0.666259134865,-2.14161179327,-1.03195907173,-0.451683951026,-1.09952939185,0.49352637299,-0.685316109521,-0.823189123619,-0.0913419436584,-1.02916419454,0.328200044214,-0.787934755756,-0.157060643178,0.0194365670645,-0.0950654624763,-0.00129110206667,-0.18730428158,0.0734625512929,-0.00254157466281,0.450914440773,-0.257024085333,-0.112753833016,-0.0597685565489,0.169818812252,0.899949309927,0.603896617854,0.0264545772414,-0.183401733575,-0.791967634088,-0.535639105607,-0.279150498198,-0.115979973527,0.229392251145],[-34029.4906866,-866.667228284,-2683.2283733,-922.649868514,-2442.62158832,195.193297908,1965.66396711,-221.405510807,-1053.58889148,425.253966352,225.164841646,-510.277542147,35.4099782743,-401.88557972,658.069005219,-259.275919139,-387.281521089,281.664412096,-901.448265894,-220.40749061,-38.1969741785,-56.7779117348,269.415436932,-643.289618754,49.4299733827,100.373776127,-119.738783142,166.838785303,97.6400684866,183.70026304,-228.566984383,-174.007217041,-84.2609354884,-256.253450886,311.386929925,2.31287943021,23.7476090582,37.0519124366,3.51303217668,-13.4163346543,-46.6851777781,-96.1558805633,-107.536915883,-20.0585381723,-84.5806299122,49.3027694983,-23.1197071656,-18.1339811141,1.4649793969,4.47883036691,-2.36629095749,4.83270246012,-12.3026310248,-1.31987833072,-21.7794354542,-0.77197893727,-34.4153348091,-34.5712766786,-1.4206124676,-11.9626577912,18.015820683,3.83139361696,9.69230140096,0.997046111777,1.28757517773,-4.48453343464,2.09111565672,0.630423395346,5.77696948962,-3.01797076322,-2.68378212511,-6.43480862629,-10.40211062,6.64301488152,-3.40104914874,9.06799201315,-3.79794597524,-3.27580647446,-3.79195166624,-1.72710751828,0.0767854296358,-0.850516745177,0.433532252358,0.164915265191,0.232635114503,-0.633319037477,-0.458216653254,-0.676552745456,-2.1789015089,-1.04342754785,-0.483084446036,-1.10081515981,0.473589461693,-0.684324080102,-0.858745927076,-0.0867916059603,-1.0273863221,0.331942619578,-0.795258345535,-0.161238408646,0.0178955555944,-0.0896646076305,0.00217025442064,-0.192131815991,0.078509481755,-0.00647915252077,0.467243837719,-0.263927139188,-0.108730598499,-0.0690152451451,0.170404153036,0.901371696432,0.605924988522,0.0224556426177,-0.189076028531,-0.796038874666,-0.541041912953,-0.280063367353,-0.118596977875,0.233474519209],[-34047.2775795,-903.545328073,-2640.26031224,-901.544874437,-2397.26476666,190.467447245,1931.81704227,-221.791373776,-1067.95886564,381.653163241,231.662723008,-502.742014823,35.512898769,-410.454102654,669.897404916,-251.177210079,-386.856418662,279.193406276,-901.557302185,-214.338659119,-30.3567557246,-58.9800848442,270.626294001,-656.263473958,47.7188430127,100.879267977,-124.218421673,168.684175851,97.1343354662,188.779323198,-231.441363134,-173.737472824,-90.2183858387,-259.728195744,314.718939513,3.16789816658,23.7661094743,37.7716601082,3.0082935111,-12.8342756982,-47.0120727321,-97.3236861316,-108.396275344,-21.5259920742,-85.5464808092,49.2776010933,-22.5765503481,-18.4305381666,1.37782599684,4.5117383511,-2.61059809036,4.83946948758,-12.7612949524,-1.23851167735,-21.863307132,-0.643740533513,-34.8876266618,-34.7045429561,-1.54068690724,-11.845858864,18.1527163876,3.88876791716,9.69899598771,1.02595070789,1.2843302938,-4.43859509588,2.04902930363,0.590258830461,5.79214279227,-3.00878939309,-2.65753830001,-6.56822750316,-10.4923055166,6.6274072914,-3.34924628273,9.13074014799,-3.80721860611,-3.33199008509,-3.82498006743,-1.75779048424,0.0950304225759,-0.855154259812,0.450600246287,0.194448059477,0.247738388883,-0.636511439627,-0.443332716214,-0.687499662284,-2.21443493373,-1.05237855532,-0.516816274852,-1.09968367048,0.453258737407,-0.681237927121,-0.892921357641,-0.0813669516105,-1.02544719405,0.335462256678,-0.802505105015,-0.164908884876,0.015595517714,-0.0843124701067,0.00534591888852,-0.196756491323,0.0833682083228,-0.00997996941456,0.483025934076,-0.27033503225,-0.104389922188,-0.0784714240044,0.171862896048,0.902238525312,0.608362638277,0.0187736031283,-0.194351359959,-0.799632220664,-0.546134628796,-0.280626246778,-0.121194178273,0.237450339101],[-34064.6854547,-945.195927725,-2600.3240404,-884.724628402,-2352.84958228,187.275084005,1896.85415329,-221.846401056,-1080.72896262,337.356453579,238.829710622,-496.159530832,34.5429543739,-418.3295192,679.987944204,-242.948917573,-385.624585735,276.114316943,-902.148564249,-208.247836069,-22.0783665116,-61.1984490522,271.537412925,-669.01772291,46.0717822116,101.270619483,-128.558282969,170.382019463,96.5284241274,193.836187274,-234.185968891,-173.298058395,-96.2370629534,-262.964334062,317.960144141,3.97817845556,23.8461902798,38.4635542966,2.51929678857,-12.208939727,-47.338821484,-98.4190299366,-109.122955115,-23.0275024375,-86.4220820069,49.174030867,-22.0284640216,-18.7081270208,1.27837409395,4.5436796864,-2.83377100441,4.85311723502,-13.2001552212,-1.16323155546,-21.9230895441,-0.490896845425,-35.3763604118,-34.801844667,-1.68326927928,-11.7138021061,18.2917716261,3.95873943346,9.7053020396,1.04975534951,1.27578187242,-4.38664136174,2.01161113509,0.557082538052,5.79990434024,-2.99856186983,-2.62592153176,-6.70272705027,-10.5691018881,6.6011936733,-3.28832793512,9.19059041537,-3.81164872768,-3.38362403582,-3.85799163885,-1.78924936426,0.112016819373,-0.860985835313,0.46756305896,0.224517707817,0.262475687283,-0.639512424411,-0.425758433329,-0.698977251609,-2.24796248481,-1.05863128821,-0.552488050357,-1.09620077483,0.433014661997,-0.676094097008,-0.925365762398,-0.0750095251209,-1.02345318792,0.338787668826,-0.809536544955,-0.168049941434,0.0125301800756,-0.0790546862231,0.00823181280825,-0.201141528688,0.0879571149246,-0.0130083527559,0.498136676347,-0.276261623313,-0.0997202735884,-0.0880436904057,0.174174573116,0.90266800971,0.61116252599,0.0154969259674,-0.199207324078,-0.802741732096,-0.550894722815,-0.280773781797,-0.123737367311,0.241301927236],[-34080.8409304,-991.363516836,-2563.45798678,-872.230892154,-2308.880038,185.861774398,1861.00478868,-220.720958037,-1091.91942564,292.858599628,246.621726477,-490.45036332,32.5724584623,-425.531282027,688.325534563,-234.628459471,-383.593434645,272.40029881,-903.1483176,-202.212221075,-13.3899373816,-63.3446229121,272.086027047,-681.420871153,44.4836480074,101.521982441,-132.735705395,171.920779889,95.7946291826,198.849439844,-236.750119342,-172.700610227,-102.253117847,-265.917626706,321.086994345,4.7386686683,23.9804486843,39.1288265228,2.04878408554,-11.5483739739,-47.6571654268,-99.4298170956,-109.706787768,-24.5433480987,-87.1968363732,48.9945803221,-21.4838806653,-18.9670308315,1.16570661027,4.57560934298,-3.03271187926,4.87295819672,-13.6161722511,-1.09149670642,-21.9599235566,-0.311377847332,-35.8753570377,-34.8619275041,-1.84447354679,-11.5697129029,18.4331611245,4.04139989598,9.71185421156,1.06821586282,1.26250320596,-4.3278474927,1.97899759604,0.531672765393,5.80056781346,-2.98817831048,-2.58837672825,-6.83724635228,-10.6321542561,6.5656987457,-3.21931840081,9.24789859613,-3.81110989465,-3.43004802816,-3.89091301561,-1.8215761561,0.127665022142,-0.867850191005,0.484407831525,0.255033219763,0.276976297481,-0.642278736635,-0.405892286322,-0.710811694742,-2.27928652152,-1.06211741064,-0.589558085232,-1.09051855373,0.413387024988,-0.669040974776,-0.955739978101,-0.0677871689684,-1.02151125872,0.34190789001,-0.816178739064,-0.170650558781,0.00871254766364,-0.0739275149973,0.0108312445094,-0.205252643354,0.0922175854536,-0.0155578091382,0.5124621554,-0.281738229731,-0.0947124826183,-0.0976227893189,0.177278703449,0.902783200694,0.614227633141,0.0127128578395,-0.203640036047,-0.805357538434,-0.555298702352,-0.280456858848,-0.126193363553,0.244988537359],[-34094.7710907,-1041.95469155,-2528.35421451,-863.863884369,-2264.89474721,186.483485522,1824.40082898,-217.655496012,-1101.49284999,248.781550606,255.058758142,-485.457148753,29.845142212,-432.010394933,694.97241107,-226.253185045,-380.783717396,268.068207328,-904.465934578,-196.289922214,-4.34683796659,-65.305581804,272.19414392,-693.315072632,42.9513179598,101.614859608,-136.728854964,173.295536595,94.9153545327,203.800824094,-239.072419152,-171.956183814,-108.190126107,-268.542780972,324.07619034,5.44543446721,24.1608358518,39.767774933,1.60056706904,-10.8612323189,-47.9573308138,-100.339821311,-110.141830743,-26.0478267014,-87.8629522522,48.7478656909,-20.9520618366,-19.2047143888,1.03969271797,4.6084248544,-3.20448003581,4.89816616079,-14.0063262116,-1.02089469161,-21.9750137256,-0.104168258823,-36.3772266838,-34.8847584765,-2.01906477729,-11.417507174,18.5772100309,4.13625439875,9.71920528087,1.08123147886,1.24529637365,-4.26157079443,1.951440254,0.514459824498,5.79470211568,-2.97853828303,-2.54455367589,-6.97039163672,-10.6815269704,6.52287310599,-3.14361013359,9.3034116419,-3.80564150145,-3.47045793142,-3.92369073647,-1.85474615825,0.141937384985,-0.875491999789,0.501130467654,0.285909523425,0.29133345876,-0.644744803218,-0.384231016392,-0.72277766254,-2.30822828662,-1.06290249821,-0.62737120402,-1.0829362846,0.394970232266,-0.660396712337,-0.983707211911,-0.0599133285924,-1.01973731219,0.344758426107,-0.822250051319,-0.172705010368,0.00418947262128,-0.0689632125608,0.0131700395656,-0.209048440578,0.0961163786501,-0.0176386285151,0.525901428856,-0.286818754608,-0.0893778501195,-0.107101386985,0.18108566596,0.902720656851,0.61742502023,0.0105030630164,-0.207675481739,-0.807475244486,-0.559332157632,-0.279636223594,-0.128532986602,0.24846202605],[-34105.8803794,-1097.0161099,-2493.47946629,-859.309247779,-2220.44293144,189.384127065,1787.23622379,-212.04998763,-1109.436543,205.850069639,264.1364224,-480.936442304,26.6993307591,-437.713031744,700.011305121,-217.86401538,-377.238294286,263.16124312,-905.991921925,-190.529946719,4.97517190447,-66.9644259387,271.778253968,-704.527984931,41.474358604,101.533843516,-140.522907202,174.509407709,93.8808960725,208.672834116,-241.082883736,-171.078408054,-113.958776742,-270.793380146,326.906781281,6.09622153059,24.3770509417,40.380416674,1.17871114434,-10.1582068571,-48.2283785082,-101.129970972,-110.425358639,-27.5100199225,-88.4140530575,48.4467852472,-20.4421259588,-19.4170716017,0.901208666331,4.64288368623,-3.34637855996,4.92788234585,-14.3678935907,-0.949266654242,-21.9695936873,0.131040583542,-36.8733081654,-34.8708646994,-2.20056227929,-11.2611388441,18.7244678095,4.2428123934,9.7280571439,1.08888109652,1.22516377521,-4.18729211631,1.9291734512,0.505483173506,5.78315637322,-2.97057260116,-2.49425277314,-7.10042381554,-10.7175275353,6.47524907534,-3.06282615793,9.35807569545,-3.79532344578,-3.50396796445,-3.95628961779,-1.88861300763,0.154869643193,-0.883575373098,0.517751770795,0.317060235953,0.305613527158,-0.646844509412,-0.361385778621,-0.734612826969,-2.33463033497,-1.06111640065,-0.665145638605,-1.07383419382,0.37838563555,-0.650573823326,-1.00891519616,-0.051671358679,-1.01822660641,0.347253330087,-0.827562948353,-0.174214645988,-0.000953310792612,-0.0641948642351,0.0152849661265,-0.212491562831,0.0996500669805,-0.0192887488679,0.538370151988,-0.291570185003,-0.0837376729544,-0.116364993891,0.185477833092,0.902628294984,0.620592564056,0.00895304387735,-0.211356749153,-0.809079645938,-0.562987376307,-0.278273427564,-0.130737271508,0.251675500584],[-34115.0107931,-1154.47854385,-2457.97228053,-858.251513235,-2175.06878967,194.43832227,1749.79142517,-203.523593778,-1115.83686098,164.685011309,273.739017916,-476.56863785,23.4421253578,-442.516141079,703.596115558,-209.510325331,-373.056881532,257.72344961,-907.575097169,-185.004604802,14.513951598,-68.191821698,270.755544314,-714.893672122,40.054166634,101.266217702,-144.11173946,175.575307592,92.6841154881,213.455103651,-242.715076917,-170.081973175,-119.46855907,-272.63083966,329.567651137,6.69151860988,24.6174620624,40.9687571073,0.787183615112,-9.45347362369,-48.4579642978,-101.783898629,-110.556878675,-28.8982700346,-88.8448152584,48.1086777125,-19.9614929545,-19.6002222373,0.752405044344,4.67984676065,-3.45583108744,4.96107027089,-14.6991281425,-0.874674599053,-21.9457003577,0.39444937634,-37.3540977164,-34.8207459593,-2.38164743481,-11.1042183892,18.8755091385,4.36000409841,9.7393854318,1.09146431341,1.20319506848,-4.10457161158,1.91224434813,0.504370265747,5.76704035094,-2.96516227402,-2.43735338595,-7.22546607643,-10.7404837671,6.42550435581,-2.97868095655,9.41303068604,-3.7804032838,-3.52966333271,-3.98855775258,-1.92306696694,0.166564059102,-0.891749957517,0.534320218459,0.348394184187,0.319926269794,-0.648529429941,-0.338020038185,-0.746034152432,-2.35841051583,-1.05689434024,-0.702055843925,-1.06360991959,0.36428297722,-0.640017190157,-1.03099747714,-0.0433324813354,-1.01704747229,0.349279103456,-0.831954719491,-0.175198981967,-0.00660776378602,-0.0596531932917,0.0172199570962,-0.215539239377,0.102835226985,-0.0205669617111,0.54980045998,-0.296068766845,-0.0778089748077,-0.125295214675,0.190323604784,0.902668931758,0.623559845973,0.00815286112544,-0.21472820924,-0.810146563416,-0.566274875583,-0.276344611404,-0.132792169056,0.254589637969],[-34124.2857811,-1212.18550056,-2422.33771453,-860.203980347,-2128.90408172,201.48889197,1712.28826813,-191.730451379,-1120.81410934,125.727945207,283.702037346,-472.137184977,20.2558415514,-446.32449492,705.784066428,-201.231784024,-368.357982495,251.797593612,-909.049892163,-179.81815061,24.2303023211,-68.9030230523,269.059683621,-724.279594959,38.6967954158,100.811302449,-147.49029334,176.508322102,91.3236066965,218.133538916,-243.921873902,-168.989838403,-124.64254983,-274.024247642,332.051754419,7.23238851969,24.8711564947,41.5360893285,0.431452645855,-8.76271244518,-48.632952593,-102.290870883,-110.537506564,-30.1875797734,-89.1490326877,47.748780185,-19.5154368954,-19.7523456619,0.595704234802,4.72038810744,-3.53060526456,4.99726186744,-14.998562149,-0.795136086925,-21.9058024702,0.685939501005,-37.8106634465,-34.7346279183,-2.55535142687,-10.9496518067,19.0308352148,4.48668996931,9.75467762506,1.08933256966,1.18038904277,-4.01310357359,1.9006731915,0.510510295919,5.74767479059,-2.96283225279,-2.37388170033,-7.34378143288,-10.750766552,6.37587854673,-2.89277956071,9.4691407144,-3.76109738194,-3.54672167306,-4.02024124164,-1.95807180067,0.177158421608,-0.899724150676,0.550877185965,0.379809988823,0.334387579025,-0.649723615334,-0.314765739738,-0.756742014553,-2.3795228865,-1.05038223001,-0.737309034947,-1.05256000254,0.353270702838,-0.629048285534,-1.04958164748,-0.0350733457076,-1.01624020348,0.350736565425,-0.835268361464,-0.175684530254,-0.0126666844942,-0.0553668987808,0.0190174248899,-0.218159637643,0.105705510771,-0.0215286744576,0.560131026449,-0.300366890968,-0.071614673888,-0.13377583403,0.195492868083,0.902990880364,0.626178046132,0.00818738219573,-0.217821652043,-0.810648252134,-0.56921900659,-0.273833847006,-0.134690378911,0.257174659502],[-34136.0578531,-1269.57543573,-2387.52727447,-864.792588325,-2082.61060164,210.652166328,1675.30391342,-176.200425505,-1124.50593222,89.3537907722,293.836492807,-467.603988905,17.263956981,-449.176292864,706.599795446,-193.056630105,-363.266688397,245.426288514,-910.256791392,-175.093828654,34.1054675341,-69.0591945728,266.63467363,-732.60304565,37.4138567667,100.17692318,-150.652125151,177.323169394,89.8001683215,222.684279217,-244.674401981,-167.836230308,-129.410445601,-274.950506958,334.352547391,7.7193362518,25.1282109008,42.0848464869,0.118266189223,-8.102793563,-48.7399305487,-102.643127103,-110.370403445,-31.3609945302,-89.3216238623,47.3745244322,-19.1102349593,-19.8740250866,0.433716730713,4.76547528538,-3.56868074521,5.0367879343,-15.2644602185,-0.708556376384,-21.8524843946,1.00466351927,-38.2354917575,-34.6133005857,-2.71548530464,-10.7995225312,19.1911102737,4.62246514085,9.7753829714,1.08276188486,1.15767421773,-3.91274206085,1.89460342724,0.523197286609,5.72656349812,-2.96391100582,-2.3040756348,-7.45384240966,-10.7488652654,6.3280766035,-2.80656805836,9.52686947927,-3.73761833997,-3.55456681647,-4.05116873546,-1.99359250226,0.186762596264,-0.907250458588,0.567477593981,0.411183946074,0.34906611297,-0.650302294083,-0.292217980907,-0.766399442175,-2.39792582656,-1.04176224116,-0.770153017863,-1.04087788521,0.345881989204,-0.617789381528,-1.06432346044,-0.0269663007908,-1.01586071175,0.351590571638,-0.83738922783,-0.175694706074,-0.0190273783403,-0.0513685215646,0.0207162955227,-0.220326664381,0.108307990144,-0.0222096746169,0.569307722952,-0.304479574577,-0.0651907743106,-0.141696493449,0.200867707868,0.903718486808,0.628329265942,0.0091167252252,-0.220661258787,-0.810567542253,-0.571841284846,-0.270714764878,-0.136424701386,0.259412229694],[-34152.8375807,-1326.91005489,-2353.28027322,-872.089737693,-2036.98384279,221.972525015,1639.44805793,-156.715698732,-1127.0058183,55.8417385891,303.93298242,-463.053077408,14.565695463,-451.141011126,706.124111849,-185.010702744,-357.917804756,238.651360635,-911.049096084,-170.956544349,44.0928944202,-68.658112377,263.391810176,-739.829210883,36.2187120761,99.3740800755,-153.588298792,178.037131541,88.1088027554,227.072586476,-244.960649154,-166.662492927,-133.715412144,-275.391676173,336.458901248,8.15374106479,25.3810069603,42.6154653441,-0.144286533209,-7.48884067593,-48.7674038191,-102.835452263,-110.062989293,-32.4083567373,-89.3607432161,46.9878238916,-18.7527429944,-19.9671697015,0.269481735083,4.81545083906,-3.56800769237,5.08039414299,-15.4953118421,-0.612793767724,-21.7883088053,1.34854244574,-38.6224715448,-34.4580995364,-2.85749503618,-10.6551606995,19.3556408039,4.76708809449,9.802207922,1.07215362165,1.13585699776,-3.80352778694,1.89423302241,0.541725351996,5.70524556579,-2.96861720792,-2.22824103748,-7.55432266559,-10.7352969594,6.28320393546,-2.72127600244,9.58623634531,-3.71012572666,-3.5528112625,-4.08101220607,-2.02958914577,0.195459429713,-0.914102720228,0.584186718118,0.442343672663,0.363961387391,-0.650062537789,-0.270895316054,-0.774656037168,-2.41358963088,-1.03125179672,-0.799912026948,-1.02870330369,0.342524996184,-0.606228342122,-1.07501129431,-0.0190131928917,-1.01602827112,0.351821491123,-0.838245155757,-0.175243630921,-0.0255856818696,-0.0476798484651,0.022354238247,-0.222010961893,0.110683472661,-0.0226355625473,0.577294345596,-0.308413187183,-0.0585828486236,-0.148946163617,0.206346809338,0.904944220642,0.629929881328,0.010951008516,-0.223244156969,-0.80991334389,-0.574137722219,-0.266961144984,-0.137972328869,0.261288809693],[-34177.4586026,-1384.2127661,-2318.1831378,-882.460912523,-1992.75227835,235.262393413,1604.99634667,-133.299566467,-1128.37357458,25.290932736,313.809776494,-458.568633004,12.2585827383,-452.159881805,704.482558896,-177.118857797,-352.461602091,231.530596619,-911.303249967,-167.508992509,54.1077781862,-67.7208922199,259.207710814,-745.954612559,35.123142347,98.4140622913,-156.290993825,178.66889712,86.2403624248,231.261777927,-244.779510472,-165.513407104,-137.522040222,-275.332268327,338.356768124,8.53787633813,25.6239981416,43.1270932719,-0.349097586122,-6.93321772549,-48.707219084,-102.866415702,-109.626986944,-33.3252238376,-89.2672071117,46.5906776492,-18.4485285575,-20.033433167,0.106039563139,4.87016193732,-3.52699771132,5.1286093738,-15.6904714208,-0.506089222454,-21.7157854216,1.71444073373,-38.966836631,-34.2708674074,-2.97883636999,-10.5176414075,19.5221758262,4.91989796774,9.83547330846,1.05805787025,1.11563698349,-3.68578091076,1.89962365791,0.565371233614,5.68514067478,-2.97710071338,-2.14666293558,-7.64410456699,-10.7107171634,6.24187153114,-2.63805727332,9.64706496139,-3.67865838821,-3.54116102073,-4.10916811363,-2.06610487802,0.203336053885,-0.920074527832,0.601045828846,0.473092617175,0.379028552294,-0.648783436311,-0.251229877731,-0.78123125171,-2.42650769361,-1.01910450457,-0.826041606253,-1.01616726071,0.343506154627,-0.594333124812,-1.08158052552,-0.0111995035497,-1.0169434305,0.351372707932,-0.837766383127,-0.174339007765,-0.0322353101458,-0.0443106009902,0.0239757431948,-0.223188158473,0.112860299608,-0.0228366138524,0.584068212938,-0.312171684472,-0.0518446110086,-0.15541802938,0.21183720974,0.906738883768,0.630924011602,0.0136550075165,-0.225536602499,-0.808732760071,-0.576089091912,-0.262562119824,-0.139297266214,0.262789740398],[-34211.8150425,-1442.49075456,-2281.11370766,-896.286575944,-1950.49510219,250.101076251,1571.99558312,-106.053164032,-1128.65235895,-2.24333232887,323.362231462,-454.195845112,10.4100249749,-452.069708784,701.758276644,-169.405513757,-347.017557322,224.142078191,-910.916496081,-164.830364132,64.0486027718,-66.3037074553,253.952592889,-750.997138,34.135012183,97.3108465802,-158.754205521,179.239442793,84.183357238,235.221770428,-244.135580534,-164.436255089,-140.812522423,-274.757394127,340.02810926,8.87418518802,25.8517334804,43.6173967248,-0.489112096455,-6.44526868941,-48.554159963,-102.736639169,-109.077315038,-34.1128388468,-89.0434096028,46.1844493516,-18.2023627067,-20.0740823491,-0.0539755038635,4.92868820966,-3.44500817914,5.18186801447,-15.8501108906,-0.387083288036,-21.6371508949,2.09841740961,-39.2654915154,-34.0539452657,-3.07873571494,-10.3878047452,19.6878430566,5.08025171347,9.87536446079,1.0411265697,1.09756919773,-3.56006857192,1.9107267926,0.593339113996,5.66748057896,-2.98948637471,-2.05962574069,-7.72235225499,-10.6760306538,6.20445115372,-2.55798502825,9.70908801577,-3.64314327645,-3.51948867399,-4.13500907452,-2.10323617594,0.210502406129,-0.924965884791,0.618073683183,0.503219149401,0.394165232218,-0.646264441362,-0.233609970186,-0.785925521248,-2.4366779374,-1.00561320697,-0.848134235526,-1.00335175727,0.349019924364,-0.582084298852,-1.08409757633,-0.00353958579227,-1.01886135865,0.350193558208,-0.835868851223,-0.172984885801,-0.0388713354615,-0.0412570162358,0.0256216222791,-0.223852241982,0.114863366406,-0.0228510339631,0.589626713343,-0.315752878137,-0.0450264718092,-0.161024280157,0.217259318564,0.90914842474,0.631271056523,0.0171542582268,-0.227498267205,-0.807100949813,-0.577668353161,-0.257513397621,-0.14036177372,0.263898222149],[-34255.6873112,-1501.49081802,-2241.66843624,-913.620840091,-1910.34271752,266.001198093,1540.18243483,-75.2985008349,-1127.83071236,-26.7105145196,332.557220633,-449.990777347,8.9700400705,-450.68337232,697.999322826,-161.912217477,-341.661167536,216.547170435,-909.784841562,-162.966592378,73.8145071928,-64.4821403219,247.522547903,-755.017853824,33.2529094935,96.0799878245,-160.968427194,179.773887992,81.9317190048,238.921496033,-243.046985836,-163.481639523,-143.589917176,-273.658139805,341.461543266,9.1645390021,26.0597488107,44.0833618598,-0.555681305643,-6.03141686664,-48.3079669786,-102.451009337,-108.431311519,-34.7767213933,-88.6931693929,45.7701477344,-18.0163909681,-20.0923539053,-0.208003548939,4.98957261484,-3.32226592891,5.24019047912,-15.9753834217,-0.254758414581,-21.5546784452,2.49590603967,-39.5163816051,-33.8101937181,-3.15772617075,-10.2660470447,19.8493437853,5.24723031268,9.92241487305,1.02223554007,1.08191112459,-3.42716967534,1.92734897773,0.624814652612,5.65327651428,-3.00576576093,-1.96754582669,-7.78859678267,-10.6322800927,6.17094892586,-2.4820772432,9.7717698131,-3.60364242471,-3.48785650544,-4.15789268351,-2.14103002553,0.217081036205,-0.928618125644,0.635256274148,0.53250665193,0.409242368156,-0.642314597063,-0.218358357434,-0.788612978766,-2.44414737388,-0.991076990831,-0.865947567638,-0.990345734998,0.359129307922,-0.569473718753,-1.08273033536,0.0039984651048,-1.02202480604,0.348230722501,-0.832479101709,-0.171187688284,-0.045388163857,-0.0385011071707,0.0273295856415,-0.223999988704,0.116710435531,-0.0227192163479,0.593983405002,-0.319174319701,-0.0381731419417,-0.165702109825,0.222534366587,0.912191522192,0.630950547159,0.0213406456808,-0.229094836443,-0.805113965742,-0.578868622452,-0.251826761383,-0.141130508586,0.26461231065],[-34307.5683529,-1559.29167474,-2199.99212722,-934.498051522,-1871.88556713,282.443073577,1509.4869316,-41.5971728344,-1125.85874571,-48.1313214091,341.437387194,-445.940064863,7.76080664358,-447.784086938,693.250857996,-154.696565666,-336.458548746,208.774634792,-907.780539437,-161.933909836,83.3412391561,-62.3511747824,239.856703074,-758.116017716,32.4706029062,94.7325261071,-162.924250856,180.301733317,79.4819714657,242.337758665,-241.547656525,-162.699984029,-145.866152356,-272.031473916,342.663616542,9.41179752977,26.2448976666,44.5209099882,-0.540802293445,-5.69592586843,-47.9733345466,-102.019495863,-107.707949013,-35.3241119987,-88.2212246035,45.3508168482,-17.8904215073,-20.0934762188,-0.353438967865,5.05113335296,-3.1596894764,5.30251424452,-16.0686959944,-0.10867007916,-21.4711255073,2.90186936787,-39.7182256141,-33.5427714032,-3.21653590494,-10.1519739261,20.0037477138,5.41981258579,9.97776845004,1.00240886719,1.06872613637,-3.2880487118,1.94911929229,0.658978465315,5.64320118659,-3.02581820191,-1.87109572517,-7.84273660336,-10.5805742961,6.14128537804,-2.4112699799,9.8345382868,-3.56051635114,-3.44643339121,-4.17731010112,-2.17943603693,0.223181838946,-0.930917860523,0.652568550377,0.560743766119,0.424114377066,-0.636780620516,-0.205702094677,-0.789290199218,-2.44903742669,-0.97580481778,-0.879399807404,-0.977249043292,0.373790684585,-0.556511197863,-1.07769857154,0.0114985421789,-1.02664194365,0.345421454398,-0.827563953168,-0.168956505904,-0.0516844879733,-0.0360090623638,0.0291404851078,-0.223628498072,0.118412169573,-0.022476873223,0.597162697787,-0.322482839881,-0.0313258973189,-0.169421149287,0.227590695476,0.915869544473,0.629961394073,0.0260895049155,-0.23030964677,-0.802873746727,-0.579719342779,-0.245521395684,-0.141576349155,0.264952395101],[-34365.7859964,-1615.26254615,-2156.81319708,-958.973355794,-1834.76382099,299.061621198,1479.97087507,-5.51940086996,-1122.57923893,-66.5976598399,350.155672089,-442.050418461,6.48199186836,-443.262567663,687.482090816,-147.792746355,-331.441158564,200.839191575,-904.798899362,-161.743581486,92.5629713011,-60.0479665868,230.935597932,-760.403345747,31.7845533332,93.2825576398,-164.613992496,180.848369488,76.8326406426,245.445753863,-239.682935627,-162.144483044,-147.657856523,-269.880757707,343.649564322,9.61874680973,26.4046039428,44.9245372989,-0.437804434217,-5.43857019315,-47.5613290814,-101.455391775,-106.928679301,-35.7652370055,-87.6327142948,44.9283214161,-17.8241832858,-20.0844194937,-0.488937832534,5.1113308886,-2.9593297753,5.36728971076,-16.1330590026,0.0507719483473,-21.3890125038,3.31060712462,-39.8710225524,-33.2547940788,-3.25631861786,-10.0450181858,20.1488406541,5.59719986412,10.042944728,0.982616468804,1.05793902608,-3.1439463668,1.97558040679,0.695097012762,5.63760120434,-3.0492341141,-1.77131907969,-7.88499336537,-10.5222111781,6.11539032836,-2.34640528532,9.89677323657,-3.5143149178,-3.39561848212,-4.19307767498,-2.21841049901,0.228926727553,-0.931818624904,0.669962920997,0.587710455776,0.438581147798,-0.629548398533,-0.195783890089,-0.788128932729,-2.45148071557,-0.960117184114,-0.888543610452,-0.964097431094,0.392823849566,-0.543222683919,-1.06929123431,0.0190424572366,-1.03289439671,0.34175251689,-0.821119877623,-0.166292588501,-0.057675022477,-0.0337352760496,0.0310852704994,-0.222775644685,0.119975064274,-0.0221561701183,0.599197666328,-0.325722420223,-0.0245220550983,-0.172183205878,0.232375035019,0.920159761621,0.628312658792,0.0312692691485,-0.231152959188,-0.800485198014,-0.580272825402,-0.238622212651,-0.141685486721,0.264947797543],[-34428.4655084,-1669.27997749,-2112.59369262,-987.04675388,-1798.81375517,315.836000988,1451.62341605,32.494104826,-1117.77209592,-82.2672959551,358.978677364,-438.35978712,4.83227199857,-437.108499686,680.654542689,-141.221524094,-326.624643667,192.751283439,-900.776995532,-162.397034365,101.412924856,-57.7046265943,220.781994001,-761.997664987,31.1939303928,91.74588676,-166.037034603,181.435356924,73.9907606651,248.222866645,-237.501344062,-161.864588665,-148.990107389,-267.221191161,344.441277842,9.78832617648,26.535958065,45.2881315302,-0.242251734754,-5.25522746274,-47.0885671834,-100.773596455,-106.117292597,-36.1117461509,-86.9342421796,44.502856936,-17.8171837489,-20.0737149568,-0.614230878547,5.16781195323,-2.72438884719,5.4325174707,-16.172409573,0.222192612715,-21.310455246,3.71658792111,-39.9761501936,-32.9495414357,-3.27919268292,-9.94497753229,20.2832188417,5.7786548535,10.1198666154,0.963789329124,1.04942101125,-2.99636659294,2.00618370632,0.732455548016,5.63663145272,-3.07531611584,-1.66958539397,-7.91580045364,-10.4587904439,6.09314887963,-2.28821153604,9.95804704014,-3.46573618841,-3.33598117721,-4.20532463063,-2.25800247099,0.234458974133,-0.931342820613,0.687407526265,0.613194622106,0.452415437474,-0.620575834736,-0.188682334785,-0.785481099028,-2.45161910395,-0.944343957554,-0.893577181399,-0.950916973615,0.415922129937,-0.529657314788,-1.05784350202,0.0267052261135,-1.04092114903,0.337262493348,-0.813185798413,-0.163203697989,-0.0632885885504,-0.031622945003,0.0331861013391,-0.221523677591,0.121404454461,-0.0217916159398,0.600131390519,-0.328924242793,-0.0177956824953,-0.174021355973,0.236850313592,0.925033173679,0.626039191565,0.0367691309797,-0.23165724336,-0.798059380112,-0.580607720856,-0.231169782547,-0.141459819539,0.264635983555],[-34493.8559143,-1720.36193214,-2067.67033944,-1018.52817794,-1764.02665986,332.82649374,1424.44814864,71.9961565368,-1111.24622586,-95.3606423516,368.182278131,-434.801608331,2.42448989099,-429.307792245,672.679369666,-134.984816146,-322.000438881,184.508085748,-895.694935693,-163.90319486,109.821109012,-55.43723158,209.468503613,-762.993353361,30.7005061395,90.1355300625,-167.201983024,182.077984228,70.9721604306,250.650838212,-235.056660699,-161.897128558,-149.897188962,-264.075892895,345.061281709,9.92216353415,26.6348974898,45.6053363085,0.0470134983791,-5.13974408126,-46.5759082241,-99.9904915517,-105.296763275,-36.375242583,-86.1306612682,44.0741752342,-17.867290473,-20.0687496585,-0.729404892731,5.21787148468,-2.45912324557,5.49556118214,-16.1909285532,0.403051532282,-21.2366512165,4.11469112441,-40.0362095923,-32.6299042954,-3.28850613458,-9.8519598018,20.4062952915,5.96325007234,10.2108787285,0.946863302653,1.04291099069,-2.84686170113,2.04013889386,0.770318585329,5.64014907751,-3.10333385618,-1.56750159584,-7.93580900882,-10.3918446393,6.07434314038,-2.23710845866,10.0181300071,-3.41545663488,-3.26810204812,-4.21434261753,-2.2982465071,0.239944160436,-0.929511282117,0.704911766884,0.636995417864,0.465347836461,-0.609944883611,-0.184425710177,-0.781822307623,-2.44962249757,-0.928765137251,-0.894830946832,-0.937731895241,0.442676187777,-0.515908694256,-1.04364683277,0.0345227363929,-1.05074740497,0.33202439922,-0.803811839878,-0.159697561775,-0.0684516114572,-0.0296045473869,0.0354583076826,-0.21997353112,0.122701444785,-0.0214223743389,0.600002702596,-0.332120453147,-0.0111859306328,-0.175001031279,0.240994196505,0.930445004226,0.623195330778,0.0425041483082,-0.231866133416,-0.795700191361,-0.580814830765,-0.2232196094,-0.140918185631,0.264057681268],[-34560.3947781,-1766.52007343,-2023.52667059,-1053.23341915,-1730.48156167,349.848255333,1398.42081094,112.658247439,-1102.94126788,-106.217160165,377.961971578,-431.257620322,-1.20459559645,-419.815327651,663.515872226,-129.071531966,-317.547509863,176.088471333,-889.58400091,-166.266276733,117.720066747,-53.3236506691,197.112385908,-763.461837193,30.3070599543,88.4574793912,-168.120883538,182.782775063,67.7934780426,252.712680057,-232.403424371,-162.267759575,-150.420160136,-260.471601716,345.532686808,10.0213657703,26.697635069,45.8701202365,0.428952047362,-5.08691629507,-46.0472735632,-99.1235386058,-104.48726886,-36.5676814282,-85.2251707021,43.6415764841,-17.9711556421,-20.075450078,-0.834218611768,5.2589581022,-2.16876501585,5.5537526369,-16.1930135061,0.590150075792,-21.1679453499,4.50000322186,-40.0549080202,-32.29855484,-3.28876054167,-9.76621187099,20.518073345,6.14985482463,10.3184336106,0.932826859306,1.03794834625,-2.69695498148,2.07654866683,0.807897455764,5.64773319723,-3.13276533133,-1.46677289115,-7.94592880923,-10.3226810778,6.05849136347,-2.19324266602,10.0768032768,-3.36414365542,-3.1925806644,-4.2204943355,-2.33908721264,0.245545541478,-0.926326444053,0.722462593751,0.658954716583,0.477053280779,-0.597812669548,-0.183009110435,-0.777685731225,-2.44566070049,-0.913589582451,-0.89276780317,-0.924552065561,0.472617384412,-0.502094431166,-1.02694491339,0.0425108372323,-1.06230997603,0.326127130906,-0.793052015583,-0.155779434498,-0.0730890186413,-0.0276128237435,0.0379017639889,-0.218229870806,0.123865325801,-0.0210956837058,0.598840128442,-0.335341320446,-0.00473945909831,-0.17521071269,0.244805158192,0.936331709683,0.619855292979,0.0483994888153,-0.23182727038,-0.793502130035,-0.580985805525,-0.214835014366,-0.140085842316,0.263258039115],[-34627.3057986,-1805.60849279,-1981.08627684,-1091.0334504,-1698.26907191,366.680521681,1373.55657929,154.215844907,-1092.86149474,-115.247603693,388.405620542,-427.629926878,-6.43332096358,-408.602300575,653.2830253,-123.447741389,-313.269138051,167.478198911,-882.515693494,-169.465532865,125.026227276,-51.4060455257,183.83956803,-763.469419158,30.016885648,86.7191646123,-168.812762468,183.548825778,64.4723403006,254.387628922,-229.589375327,-162.992957443,-150.600202058,-256.438987739,345.878685722,10.088637264,26.721612514,46.0779688372,0.899703380478,-5.09204378592,-45.5287801884,-98.1892742499,-103.707534646,-36.7017222436,-84.2221455926,43.204107093,-18.1254019664,-20.0987241171,-0.928298284576,5.28907754933,-1.85915293374,5.60491573865,-16.1831769953,0.779378335812,-21.1042851848,4.86754852574,-40.0365601319,-31.957768799,-3.28514664741,-9.68766980099,20.6186111408,6.33707760274,10.4444718175,0.922520876812,1.03404202546,-2.54816373173,2.11455634046,0.844270662107,5.65886752916,-3.16306241661,-1.36916075109,-7.94718263015,-10.2524120521,6.04481444468,-2.15662686954,10.1338826398,-3.31249800367,-3.10998923245,-4.22411769611,-2.38038912208,0.251413152186,-0.921827417334,0.740030422899,0.678984480059,0.487234734076,-0.584367863352,-0.184371766471,-0.773649831828,-2.43991241795,-0.898989075602,-0.887949822025,-0.911357959483,0.505234573766,-0.48831819075,-1.00796095277,0.0506811423901,-1.07549773479,0.319663784592,-0.780996569831,-0.151466946614,-0.0771399998102,-0.0255817442514,0.0405060836688,-0.216405418938,0.12490864859,-0.0208571594906,0.596668259023,-0.33859364163,0.00149672378783,-0.174754361847,0.248294146046,0.942611235707,0.616108524065,0.0543940826752,-0.231580057717,-0.791531852439,-0.581200992228,-0.206083281779,-0.138985452651,0.262281613094],[-34695.0850215,-1837.04956628,-1940.63192624,-1131.72912758,-1668.05585891,383.330881716,1349.96380742,196.512610299,-1081.06788792,-122.863202,399.53105285,-423.876324317,-13.4960924738,-395.716383463,642.152527031,-118.050951216,-309.187805945,158.689006974,-874.626474867,-173.474051174,131.648918581,-49.7112010159,169.780652474,-763.082610298,29.8354587848,84.9316000204,-169.3022338,184.363664719,61.0309088676,255.652140012,-226.661488298,-164.080783407,-150.481809203,-252.011644492,346.118950784,10.1257707811,26.7057788382,46.2262583991,1.45172574246,-5.15237582575,-45.0472097243,-97.2023839101,-102.975483338,-36.7912208186,-83.1267231544,42.7582659942,-18.3277069236,-20.1427360725,-1.01165125083,5.30699395317,-1.53658884318,5.64739765113,-16.1652446821,0.965625478824,-21.0451297715,5.21258490447,-39.9870574568,-31.609570887,-3.28351893188,-9.61608872994,20.7081483932,6.52373869015,10.5901927102,0.916350538521,1.03062130613,-2.40198127041,2.15345551071,0.878459455611,5.67303977213,-3.19364853902,-1.27656072184,-7.9407008771,-10.1819797467,6.03233058885,-2.12696070296,10.1891896289,-3.26118313695,-3.02096992926,-4.22566220087,-2.42194605117,0.257654113341,-0.916134346924,0.75756618155,0.697068982291,0.495614810021,-0.569856640735,-0.188371255107,-0.770288877184,-2.43252412891,-0.885100866612,-0.881017353431,-0.898104359709,0.539941154258,-0.474651881325,-0.986913622749,0.059044503161,-1.09015296505,0.312762188997,-0.767784801639,-0.146779104763,-0.0805735451124,-0.0234641910485,0.0432417508233,-0.214625650984,0.125864551777,-0.020732599132,0.593507511413,-0.341840073659,0.00746484479741,-0.173759302323,0.251495527179,0.949183649685,0.612066020967,0.0604395375929,-0.231150830154,-0.789831747073,-0.581519473691,-0.197028692984,-0.137639679263,0.261168277039],[-34765.3887432,-1861.53130332,-1902.62235932,-1175.03522115,-1641.08440058,400.046813507,1327.64525493,239.515996382,-1067.65474054,-129.546036184,411.347484655,-420.017158552,-22.5784706495,-381.255814237,630.245816584,-112.803503053,-305.330149992,149.73000706,-866.095817019,-178.269871834,137.516240247,-48.2613510097,155.075191129,-762.368725802,29.7733936374,83.1039956295,-169.618136449,185.205720656,57.4950345781,256.48339645,-223.668772414,-165.534799625,-150.115905662,-247.224876435,346.268584762,10.1338957075,26.6506887062,46.3122448747,2.0750598966,-5.26612568064,-44.6289497811,-96.1774400279,-102.306872798,-36.8512268468,-81.942717104,42.2971319693,-18.575822372,-20.2125782756,-1.08457826296,5.31220749618,-1.20757923893,5.67979763933,-16.142412648,1.14347899053,-20.9894721617,5.53110428546,-39.9134184896,-31.2555008134,-3.29042051321,-9.55113566552,20.7868359377,6.70885349887,10.7565414101,0.91438491946,1.02705798868,-2.25979336113,2.19263405075,0.909596207203,5.68969681646,-3.22392032143,-1.19082503259,-7.92773799983,-10.1120967939,6.01974125869,-2.10356638057,10.2423772154,-3.21076395151,-2.92619310536,-4.22563389525,-2.46361012875,0.264314507635,-0.909425705209,0.775018348167,0.713222279585,0.501911271313,-0.554539498622,-0.194761906576,-0.768137984873,-2.42360011915,-0.871997203176,-0.872680126536,-0.884684130494,0.576096056741,-0.461107863275,-0.963986715859,0.0676453744357,-1.10609123963,0.30557649994,-0.753578123001,-0.141728089551,-0.0833848714722,-0.0212240685684,0.0460606434756,-0.213022133546,0.126770500411,-0.0207252661645,0.58937392541,-0.345009205507,0.0131058309745,-0.172360286154,0.254474206607,0.955935546717,0.607863512939,0.0665002393551,-0.230551365195,-0.788432737402,-0.581987244928,-0.187732881349,-0.136070314875,0.259951388446],[-34839.3883403,-1880.15793242,-1867.34165091,-1220.61296059,-1618.77985102,416.952627716,1306.13062937,283.173820235,-1052.65034516,-135.800885193,423.903594457,-416.110855027,-33.7836838755,-365.236063287,617.618715959,-107.631491567,-301.697844037,140.598864505,-857.108813147,-183.812647876,142.579789589,-47.0656988099,139.84930334,-761.389183905,29.8437115608,81.2521995413,-169.793078197,186.051505286,53.8936953461,256.872587956,-220.657586638,-167.349796817,-149.56630851,-242.118625529,346.336519354,10.1150052992,26.5596286364,46.332429002,2.76027225609,-5.42915715519,-44.2982112048,-95.1285883334,-101.715728862,-36.8991350309,-80.6741179104,41.8141370152,-18.865908791,-20.3131209912,-1.14813344622,5.3046399224,-0.878436021296,5.70125468669,-16.1183466612,1.30767877541,-20.9361329542,5.8202654554,-39.8234131673,-30.8968448911,-3.31285118269,-9.49263689121,20.8543643463,6.89103768423,10.944256655,0.916485885419,1.02274869314,-2.1229838057,2.23161388148,0.936938111462,5.70819343029,-3.2530790929,-1.11355014849,-7.90974345604,-10.043453637,6.00549604947,-2.08547743438,10.2932816097,-3.16159764044,-2.82619456549,-4.2244270598,-2.50542489151,0.271383415399,-0.901986693817,0.792354354303,0.727451937566,0.505863887042,-0.53865655389,-0.203212506119,-0.767717138163,-2.41323081727,-0.859737593567,-0.863685263626,-0.870927249905,0.613080532203,-0.447663967267,-0.939331832118,0.0765102237823,-1.12310780835,0.298240652319,-0.738534003832,-0.136330659849,-0.0856063597986,-0.0188236292027,0.0489056245863,-0.211731093881,0.127652173259,-0.0208256533363,0.584299819878,-0.348001272151,0.0183744455454,-0.170684773364,0.257315832115,0.962769161621,0.603655649558,0.0725700013685,-0.229777250044,-0.787353550652,-0.582642443015,-0.178270326207,-0.134298948328,0.258648522069],[-34916.4730897,-1893.28043465,-1834.92033669,-1267.84042661,-1601.99442102,434.204709738,1284.87981303,327.271462427,-1036.0437273,-141.914324241,437.334582136,-412.113268123,-47.0878235862,-347.598440065,604.277171107,-102.486662087,-298.240934858,131.296034314,-847.796019784,-190.025704193,146.826939872,-46.1186695032,124.228110898,-760.189762528,30.0529666268,79.395108361,-169.862167636,186.883218113,50.2624838683,256.826166323,-217.665351,-169.506870636,-148.899583644,-236.733854961,346.326562936,10.0711788353,26.4350126702,46.2815678733,3.49914307162,-5.63538627108,-44.0745605275,-94.067500362,-101.213515214,-36.9523041328,-79.3257080268,41.3047731513,-19.1927831866,-20.4465971774,-1.20374397969,5.28395086714,-0.555458827747,5.7109068648,-16.0971695181,1.45324197315,-20.88393788,6.07801924502,-39.7245627221,-30.5346765268,-3.35663746575,-9.4404445388,20.9109176469,7.06854661707,11.1538359464,0.92245097442,1.01711832592,-1.99284575018,2.26982678047,0.959717017406,5.72764660712,-3.28030783599,-1.04615552657,-7.88829038321,-9.97673176709,5.98816671464,-2.07157994018,10.3421719085,-3.11389946442,-2.72125083784,-4.22237406257,-2.54745490472,0.278823740689,-0.894122118636,0.809575450162,0.739731948624,0.507240731174,-0.522474270478,-0.213395633274,-0.769526925869,-2.40153215321,-0.848396105434,-0.854698792415,-0.856627471289,0.650431095154,-0.434288872936,-0.913023171399,0.0855969770945,-1.14094945192,0.290849541165,-0.722800103955,-0.130612542218,-0.0872845967111,-0.0162118720225,0.0517182780759,-0.210873606793,0.128514412304,-0.0210218903945,0.578321820179,-0.350717610454,0.0232342558598,-0.168853612403,0.260113038298,0.969620203505,0.599585395624,0.0786849954699,-0.228835832579,-0.78658588077,-0.58351920929,-0.168723351632,-0.132353555458,0.257261127115],[-34994.4904008,-1900.07432137,-1804.52975579,-1315.91198727,-1590.77340884,452.286195737,1263.6936721,371.671818377,-1017.90910502,-147.914199401,451.852417012,-407.827509499,-62.3211384319,-328.295313038,590.200820234,-97.3586143565,-294.874605815,121.832940478,-838.24163819,-196.805345744,150.263038562,-45.4011847008,108.334262594,-758.769950687,30.3990181059,77.5460778314,-169.865269874,187.684078904,46.6416502082,256.360459573,-214.715646023,-171.975791064,-148.168642622,-231.110487051,346.236509132,10.0038507742,26.2747769126,46.1517181798,4.28271319888,-5.87868967505,-43.9722359756,-93.0016700018,-100.807728334,-37.0248576326,-77.9025716083,40.766598123,-19.5514634929,-20.6115836332,-1.25267607062,5.24903178455,-0.245037813624,5.70755770036,-16.0829705707,1.5753820473,-20.8316930638,6.30296521612,-39.6235552343,-30.169728302,-3.42583316742,-9.39441610728,20.9576530988,7.23959176601,11.3852039483,0.932095406546,1.00968047064,-1.87047537265,2.30657437198,0.977017307082,5.74694123918,-3.30507250928,-0.989857157215,-7.86489973038,-9.91251572792,5.96673635032,-2.06071078678,10.3897321493,-3.06773942458,-2.61143815198,-4.21985231487,-2.58973294529,0.286598432151,-0.886040078255,0.826718268529,0.750008855569,0.505817593159,-0.506289698344,-0.22507948236,-0.774002784035,-2.38864712156,-0.838052350197,-0.846235988052,-0.841561613464,0.687860113786,-0.420954134617,-0.885036939157,0.0947581347753,-1.15932914819,0.283482060442,-0.706517575219,-0.124604227706,-0.088455640899,-0.0133279328675,0.054444128053,-0.210546628727,0.12935410175,-0.0213097101426,0.571471694517,-0.353078658239,0.0276555677895,-0.166977790911,0.262957734598,0.976447403852,0.595767300813,0.0849195199643,-0.227759089205,-0.786087682129,-0.584639641519,-0.159170191469,-0.130269067303,0.255773024868],[-35070.9044395,-1900.645267,-1774.85907555,-1364.32427752,-1584.60367513,471.81025154,1242.55589828,416.129921075,-998.390016856,-153.639213026,467.66302968,-403.132599659,-79.1994280521,-307.360869717,575.38239191,-92.2626535936,-291.498437796,112.246878366,-828.534681695,-204.033361604,152.893868023,-44.9310011879,92.2718846424,-757.124704827,30.871098558,75.7178343364,-169.840960688,188.435206906,43.0658576577,255.488970457,-211.825091682,-174.719691639,-147.413082285,-225.278800902,346.060853463,9.91430875941,26.0752254733,45.933574222,5.10127469465,-6.15200207059,-44.0027800745,-91.9344402134,-100.502613507,-37.1307044521,-76.41049374,40.1959715268,-19.9383425556,-20.805041393,-1.29602938813,5.19791304008,0.0467919492029,5.69019837103,-16.0790867657,1.66905828504,-20.7779908451,6.49392213104,-39.5268605049,-29.8019599851,-3.52326445114,-9.35331087657,20.9958487979,7.40318877173,11.6374344134,0.945221519299,0.999889687612,-1.75682302581,2.34118071697,0.987916773807,5.76469009347,-3.32696715259,-0.945565321263,-7.84091325775,-9.85113621159,5.94041633286,-2.05153937137,10.4366238793,-3.02304344154,-2.49670325924,-4.21728496708,-2.63214122538,0.294697192581,-0.877890161429,0.843796138385,0.758211771741,0.501385928991,-0.490423314099,-0.238060734041,-0.781515168858,-2.37467407309,-0.828770129349,-0.838691396842,-0.825419336114,0.725170844834,-0.40754522602,-0.855331951783,0.103819447517,-1.17797848138,0.276211380328,-0.689830532743,-0.118327698051,-0.0891483507524,-0.010116141501,0.0570193829214,-0.21083121205,0.130158378824,-0.021693130654,0.563772417518,-0.355004827673,0.0316188338429,-0.165151356833,0.265959156713,0.983211854367,0.59230580936,0.0913573549498,-0.226587457922,-0.785777322245,-0.586001326711,-0.149659536013,-0.128074813722,0.254163241879],[-35143.8260036,-1896.60793768,-1744.6769907,-1412.65785157,-1582.69215929,493.157362987,1221.25777176,460.023129243,-977.57088864,-158.95418015,484.882837739,-398.037420463,-97.425425061,-284.836076987,559.806007634,-87.2236796028,-288.026129528,102.598369521,-818.765779084,-211.609605843,154.717321214,-44.7830696372,76.1227298414,-755.250050138,31.4533680531,73.9263872811,-169.825493305,189.114165756,39.556512553,254.216334277,-209.004771471,-177.693260015,-146.665872424,-219.256900935,345.786600109,9.80566472146,25.8323415051,45.6187537561,5.94368584943,-6.44622123303,-44.1751499825,-90.8684662436,-100.299086344,-37.2856240831,-74.8546747991,39.5886763936,-20.3494458709,-21.0226247969,-1.33493470219,5.1281573346,0.31488913286,5.65858473882,-16.0882822459,1.72923235334,-20.7215941725,6.64965770797,-39.4401083447,-29.4297117678,-3.65088654588,-9.3148471031,21.0259394123,7.55840421004,11.9090227238,0.961615394589,0.987268009237,-1.65266694571,2.3729965919,0.991524708884,5.77936540871,-3.34551437731,-0.913791022606,-7.81750278015,-9.79257914975,5.9082025594,-2.04268540662,10.4832646017,-2.97955540663,-2.37669926246,-4.21489097206,-2.67444552582,0.303162878867,-0.869802223754,0.860794220131,0.764266484541,0.493791177415,-0.475131942575,-0.252112071182,-0.792397474786,-2.35971441538,-0.820583129547,-0.832401519294,-0.80777068732,0.76223497119,-0.393853856026,-0.8238586583,0.112588509315,-1.19663996385,0.269059769271,-0.672840438205,-0.111800994953,-0.0893950767414,-0.00651906743194,0.0593783769223,-0.21180091139,0.130909846058,-0.0221904624508,0.555233090101,-0.356410742521,0.0351185180717,-0.163453775803,0.269233690495,0.989850286047,0.589286562562,0.0980868792234,-0.225355403836,-0.785529852283,-0.587575433828,-0.14021992212,-0.125788577499,0.252397524985],[-35211.5499693,-1889.21080633,-1713.12257019,-1460.18154709,-1584.10700742,516.452835661,1199.34509002,502.458591226,-955.458733237,-163.814553523,503.549902765,-392.552003192,-116.736646458,-260.762032561,543.442709147,-82.2748854509,-284.390041155,92.9521162193,-809.027549149,-219.456498839,155.733154747,-45.0529792267,59.9667086216,-753.137798205,32.1247471035,72.1884139437,-169.849971027,189.698329322,36.130062776,252.548792825,-206.265011643,-180.844285436,-145.962273171,-213.059089401,345.4007218,9.68143281404,25.5425924674,45.2025087888,6.79754201461,-6.75114198781,-44.4963571075,-89.8078841195,-100.19477848,-37.5041391926,-73.2385491923,38.9430374733,-20.7787224257,-21.2603656613,-1.37067153275,5.03744548732,0.554899026819,5.61271642378,-16.1131820972,1.75127988477,-20.661295,6.76967008011,-39.3680258232,-29.0498894978,-3.81007627146,-9.2763104383,21.0477062723,7.70391305432,12.1983027207,0.981092334205,0.971377583551,-1.55861519631,2.40136315791,0.98701835359,5.78942329087,-3.3601305799,-0.894789694973,-7.79565014176,-9.73648790677,5.86907843997,-2.03263305628,10.5299507951,-2.93690747907,-2.25095574469,-4.2126695455,-2.71637595278,0.312077274563,-0.861910000032,0.877673895988,0.768138946449,0.482937909631,-0.460642901506,-0.266963679331,-0.806973387933,-2.34387429083,-0.813465941455,-0.827693170707,-0.788160277577,0.798950204958,-0.379667257704,-0.790551509375,0.120903416868,-1.21501815344,0.262020172614,-0.655620479343,-0.105047946936,-0.0892318585548,-0.00248359688675,0.0614661186768,-0.213522177225,0.131594028776,-0.0228316884864,0.545852008328,-0.357221148294,0.0381531170907,-0.161959415338,0.272895145868,0.996293982886,0.586797932049,0.105210631466,-0.22407964983,-0.785192762836,-0.589325939297,-0.130879511996,-0.123423081474,0.250440428758],[-35272.4871351,-1878.77731363,-1679.31289617,-1505.82933293,-1587.81218053,541.743225522,1176.28075253,542.27481336,-932.083304854,-168.21608349,523.608275188,-386.669186018,-136.898894554,-235.224589761,526.292515812,-77.4714824634,-280.570914758,83.3866609595,-799.426919333,-227.525127495,155.936538214,-45.8311699994,43.8930929051,-750.770937913,32.8601016113,70.5220928682,-169.945709854,190.167751406,32.8051086252,250.497609084,-203.611289007,-184.118034618,-145.329536841,-206.700239709,344.895179319,9.54583129995,25.202206063,44.6859248997,7.64832870163,-7.0570998867,-44.9714000966,-88.7576631054,-100.185480916,-37.79571938,-71.5643069833,38.2605843104,-21.2182337531,-21.5154860386,-1.40411809532,4.92397958724,0.763569524718,5.55284817737,-16.1557148209,1.73082401193,-20.5962459808,6.85453381082,-39.3141927073,-28.6585543349,-4.00181797603,-9.23471953778,21.0604638388,7.83817002129,12.503684552,1.0034470761,0.951980499126,-1.47512952395,2.42567610742,0.973712410848,5.79356270702,-3.37016819159,-0.888604412554,-7.77605229334,-9.6822215591,5.82226318517,-2.01986659772,10.5769000024,-2.89476501608,-2.11907796413,-4.21051535397,-2.75762262239,0.321559095465,-0.85435552064,0.894393891719,0.769862233338,0.468861292236,-0.447220175094,-0.282331155393,-0.825535718952,-2.32731684623,-0.807308780159,-0.824873687431,-0.766162325755,0.835183187996,-0.364834440121,-0.755343334819,0.128641372053,-1.23278393737,0.255086420937,-0.638241348275,-0.0981139872606,-0.0886930924169,0.00201834745388,0.0632442808616,-0.216055937955,0.132214682535,-0.0236518636114,0.535618079392,-0.357375962282,0.0407276172541,-0.160740812128,0.277053406877,1.0024818052,0.584933406128,0.112845071027,-0.222755601465,-0.784600620387,-0.591216288388,-0.121670787923,-0.120994114664,0.248265886892],[-35324.9681767,-1864.62372473,-1643.28141321,-1548.51925175,-1592.51255912,569.10107248,1151.75604715,578.362654711,-907.577080525,-172.144505414,544.895812882,-380.424281569,-157.699565767,-208.41566915,508.461503247,-72.8944128365,-276.596808183,73.9975265094,-790.082412406,-235.787244596,155.346090632,-47.1803738523,28.0222425424,-748.128901807,33.6342151084,68.9471769761,-170.138371461,190.505041454,29.6025386505,248.076872503,-201.038336575,-187.461154311,-144.775947877,-200.196499818,344.272907988,9.40400905519,24.8081238405,44.0766530539,8.47943038559,-7.35580206169,-45.6031326308,-87.7230625657,-100.264283224,-38.1646152415,-69.8331099813,37.5444405984,-21.6599348899,-21.787159655,-1.43571807502,4.78700133694,0.939136682608,5.479714199,-16.2167903044,1.66368972159,-20.5261227139,6.90581940663,-39.2809483622,-28.2515333444,-4.22598181102,-9.18699656951,21.0638559329,7.95978924695,12.8239162146,1.0283760273,0.929164593387,-1.4025400129,2.44552654133,0.951240301202,5.79066907695,-3.3750194291,-0.895106409509,-7.75917976248,-9.62904176418,5.76728874456,-2.00309222434,10.624214734,-2.85302112204,-1.98085845574,-4.20838703717,-2.79781153634,0.331710872709,-0.847305292796,0.910891381929,0.769563122959,0.451753456491,-0.435176522451,-0.297953503126,-0.848334628184,-2.3102910283,-0.801941250267,-0.824210343923,-0.741409755983,0.870801734122,-0.349260460005,-0.718161208846,0.135746474927,-1.2495863092,0.248279502328,-0.620787887752,-0.0910741191038,-0.0878245651453,0.00697431598145,0.064698119558,-0.219451892307,0.132789550614,-0.0246831397201,0.524510148198,-0.356831874233,0.0428466734632,-0.159872551022,0.28179839522,1.00836584904,0.583773878389,0.121111381747,-0.221371553604,-0.783582607156,-0.59321843996,-0.112621080795,-0.118524225971,0.245863109221],[-35367.7391042,-1846.40355848,-1606.04189104,-1587.54714894,-1596.90247555,598.584756078,1126.05363486,610.163133618,-882.238707833,-175.694565728,567.171717901,-373.953176705,-178.991443713,-180.677510727,490.154960607,-68.6365942354,-272.530834334,64.8712063305,-781.117445716,-244.222309482,154.019431805,-49.1406036146,12.5217697746,-745.193985152,34.42477959,67.4756151177,-170.436953433,190.688454202,26.5392982941,245.303605607,-198.533436317,-190.822987021,-144.285256738,-193.566008479,343.546263426,9.26169082553,24.3581964551,43.3868769756,9.27371085618,-7.64097321294,-46.3911691286,-86.7084065275,-100.41926135,-38.6115780848,-68.0454100396,36.7962149887,-22.0978337065,-22.0759428345,-1.46501535938,4.62661836977,1.08128329517,5.39411091229,-16.2961032129,1.5465810626,-20.450852248,6.92546187569,-39.2691472267,-27.8249684844,-4.48075359396,-9.12980151895,21.0586013088,8.06809271917,13.1578637996,1.05556106366,0.903229803299,-1.34097601867,2.46068073691,0.919472412902,5.77956921423,-3.3743810793,-0.914075499888,-7.74529097709,-9.576080404,5.70412693137,-1.98137786378,10.6717725987,-2.81185881079,-1.83635293595,-4.20637664555,-2.83640943624,0.342569750057,-0.840847563231,0.92703826826,0.767420302912,0.431853410994,-0.424866484741,-0.313624081971,-0.875565829534,-2.29307020427,-0.797198181126,-0.8258566575,-0.713621379637,0.905739821279,-0.332842521513,-0.678890976341,0.142268469954,-1.26506903847,0.241688181135,-0.603387193298,-0.0840114114428,-0.0866768082207,0.0123393250823,0.0658316294689,-0.223728598089,0.133324437189,-0.0259517968863,0.512476564554,-0.355579902819,0.0444987268002,-0.159415983643,0.287183670295,1.01391342922,0.583367590931,0.130118861083,-0.219920673798,-0.781965008517,-0.595305121246,-0.103741399393,-0.11604006842,0.243238808485],[-35400.3776577,-1825.69520354,-1568.65957173,-1622.86805226,-1600.23132683,629.955463225,1099.57126513,637.539164858,-856.468557927,-179.085190617,590.213337893,-367.472906527,-200.61592809,-152.380133715,471.571691199,-64.8074539865,-268.455943361,56.0878759803,-772.651815446,-252.820871332,152.033134595,-51.7460792627,-2.42484927038,-741.935825658,35.2135296082,66.1166315664,-170.831597352,190.688779987,23.6239670225,242.208171612,-196.075254612,-194.151522521,-143.824692625,-186.824698984,342.726601934,9.1265224739,23.8509737914,42.6323801747,10.0168709224,-7.90674114977,-47.330164793,-85.7159147055,-100.636501019,-39.1340951995,-66.2026367673,36.0181434492,-22.5273970421,-22.3817538803,-1.49142057711,4.44365494307,1.19118759463,5.29679563967,-16.3928431345,1.37749170532,-20.3712579525,6.91592241893,-39.278053757,-27.3755655214,-4.76286618518,-9.0601401973,21.0459803592,8.16285157477,13.5044380998,1.08469329001,0.87472277347,-1.29046761998,2.47114249979,0.878526716178,5.75906941827,-3.36812987593,-0.945120388502,-7.73448273227,-9.52268415863,5.6333899979,-1.95431869601,10.7195004587,-2.7715128739,-1.68573711631,-4.20463232797,-2.87279545974,0.354114903238,-0.83502706365,0.942640703798,0.763602070524,0.409452196163,-0.416685401946,-0.329264506413,-0.907386705592,-2.27591588825,-0.792979090389,-0.829776828136,-0.682611975235,0.940018006435,-0.31551611697,-0.637437348552,0.148280613705,-1.27890641236,0.235441403905,-0.586152916433,-0.0770184380888,-0.0853146072755,0.0180461291741,0.0666570354533,-0.228892879822,0.133796974063,-0.027479409398,0.499449130066,-0.353644306995,0.0456816069177,-0.159403875923,0.293218678552,1.01912794353,0.583716158891,0.139972177676,-0.218397260698,-0.779585886493,-0.597440418308,-0.0950368103658,-0.113574349541,0.240400159583],[-35422.7977012,-1804.856001,-1531.5332856,-1654.57220656,-1602.21215076,662.933818166,1072.57549307,660.690871058,-830.663694968,-182.548962938,613.881971865,-361.282260673,-222.397068748,-123.960858678,452.875205785,-61.5165460696,-264.448573088,47.7056440088,-764.775316673,-261.5673486,149.474572295,-54.9973960323,-16.6254319028,-738.3297117,35.9833276439,64.8796285931,-171.300399003,190.476200864,20.8667795302,238.833127,-193.635166084,-197.398489221,-143.355000481,-179.993206604,341.826621066,9.00629699524,23.2852710049,41.8314398113,10.6986532224,-8.14763351319,-48.4106868115,-84.7451397446,-100.902817482,-39.7256415326,-64.3087788642,35.21286726,-22.9440797601,-22.7056011629,-1.51470635478,4.2394971341,1.27106373382,5.18795548907,-16.5063784259,1.15597564952,-20.2887115023,6.88047403736,-39.3050147933,-26.901499568,-5.06793349252,-8.97569443657,21.027475716,8.24424416995,13.8627701146,1.11553984382,0.844290785543,-1.25092149018,2.4769867428,0.828674164852,5.72813221138,-3.35612426966,-0.987698486938,-7.72658274245,-9.46867428363,5.55625968357,-1.92203550689,10.7673501828,-2.73226188349,-1.5294053714,-4.20333308079,-2.90636988015,0.366296182541,-0.829867260644,0.957477293552,0.758245682045,0.384890241017,-0.411045438905,-0.344919720626,-0.943881300815,-2.25904484713,-0.789265089769,-0.835752980321,-0.648357531294,0.973689991035,-0.297243744693,-0.593769929909,0.153920546886,-1.29080171816,0.229695434887,-0.569183559795,-0.070195445506,-0.0838028301938,0.0240185396648,0.0671970030279,-0.234943742338,0.134158407839,-0.0292873265547,0.485370913878,-0.351084050088,0.0464093580955,-0.159833308001,0.299859347801,1.02405660964,0.584792191923,0.150766529666,-0.216791862127,-0.776313662366,-0.599596339305,-0.0865146415725,-0.111168732508,0.237366128357],[-35434.1198255,-1786.11882538,-1494.19790552,-1682.5306293,-1602.47612305,697.641175467,1045.73576333,680.294025152,-805.25482749,-186.162309514,638.157307785,-355.553081123,-244.063539732,-95.9302070176,434.26590507,-58.8723327444,-260.55178021,39.7760844343,-757.529407614,-270.401144109,146.46201071,-58.8384266008,-29.8758551697,-734.356960278,36.7101952363,63.7691416498,-171.813907359,190.03083641,18.2858746921,235.23892705,-191.17344745,-200.523542615,-142.827374745,-173.099921743,340.865268548,8.9068501789,22.6594604339,41.0037735067,11.3119149191,-8.35945387105,-49.6184734635,-83.7905121242,-101.207075,-40.3723001263,-62.3721466454,34.3843240194,-23.3443088553,-23.0487562345,-1.53460643109,4.01581392127,1.32326521448,5.06696359553,-16.6360381901,0.883406967756,-20.2040337767,6.82241623244,-39.3454841125,-26.4031699312,-5.38998692217,-8.87470349212,21.005518031,8.31313183096,14.2318375864,1.14795225682,0.812500490474,-1.22202535039,2.47817397194,0.770211885712,5.68592287494,-3.33834949399,-1.04124615761,-7.72094007873,-9.41435598781,5.47480240661,-1.88495607002,10.8153861545,-2.69451792988,-1.36811032349,-4.20280632856,-2.93647060652,0.37905624736,-0.825321439161,0.971302131421,0.751484530562,0.358525095907,-0.408406028107,-0.360693677776,-0.985019207036,-2.24255759041,-0.786124428628,-0.843372923068,-0.611020760417,1.00683199864,-0.278043602625,-0.547955111062,0.159387519082,-1.30048866166,0.2246501063,-0.552607635206,-0.0636441998002,-0.0821922009369,0.0301672068191,0.0674743267547,-0.241860401389,0.134341557558,-0.0313968383022,0.470219040433,-0.34798396602,0.0466966425315,-0.160662982336,0.307024815358,1.0287885506,0.586552655601,0.1625684768,-0.215102898345,-0.772053855767,-0.60175320987,-0.078180719471,-0.108874280927,0.234176492254],[-35434.5125591,-1770.76946987,-1455.86115864,-1706.67033714,-1600.49726566,734.462189916,1020.28310118,697.501758752,-780.778142904,-189.915395874,663.077988642,-350.180083716,-265.317442346,-68.7914392869,415.965708307,-56.9579129912,-256.790463422,32.3503432591,-750.897282748,-279.234252019,143.144949052,-63.1617869899,-41.9645199171,-729.990562837,37.371954078,62.7823422162,-172.342305316,189.346044159,15.9014808601,231.508259751,-188.641930037,-203.493182302,-142.186300693,-166.180334834,339.863668993,8.83314424148,21.9715435399,40.1696559586,11.8508266183,-8.5410469018,-50.9337381406,-82.8431636688,-101.538793194,-41.0537631295,-60.404150568,33.5394299521,-23.7248883883,-23.410974571,-1.55057732713,3.77472564899,1.34995500885,4.93237695197,-16.7808482097,0.56256852662,-20.1174746506,6.74477655766,-39.3935125769,-25.8830909162,-5.72161553942,-8.75588737126,20.9837203314,8.37103285139,14.6102933197,1.18171350301,0.779860894877,-1.20320328109,2.47442081272,0.70342535374,5.63170577352,-3.31504789675,-1.10521150587,-7.71643626086,-9.36041302276,5.39203584894,-1.84370237868,10.8639803842,-2.65862634899,-1.20294854202,-4.20343439426,-2.96243115752,0.392314141909,-0.821262511388,0.983873854998,0.743447317603,0.3307369986,-0.409312860182,-0.376694702801,-1.03068381233,-2.22643278717,-0.783712964004,-0.852016741941,-0.570917097029,1.03960983548,-0.257978900789,-0.500124721499,0.164910079421,-1.30774403386,0.220535581503,-0.536570480498,-0.0574671350716,-0.0805243525194,0.0364012332948,0.0675087730898,-0.249594155592,0.134263969317,-0.0338222802254,0.453992043605,-0.344439155881,0.0465445062062,-0.161804774948,0.314608344533,1.03346130908,0.588948830305,0.17541302933,-0.21332675946,-0.766750110613,-0.603893361386,-0.0700401591797,-0.10675029592,0.230885403916],[-35426.1665947,-1758.71954404,-1415.31413986,-1727.0068822,-1595.82653457,773.591903512,997.768346956,713.346421888,-757.729686371,-193.76664391,688.673702133,-344.783922437,-285.973383815,-42.9695895731,398.160059041,-55.8064660223,-253.160168218,25.4673999815,-744.813048476,-287.984166231,139.682110309,-67.824905948,-52.6764386284,-725.191313211,37.9538898537,61.9151852387,-172.852629102,188.424668711,13.7353676462,227.742055425,-185.994261864,-206.267339654,-141.380065292,-159.273914982,338.838827593,8.78765388406,21.2221549728,39.3489313422,12.3112892474,-8.69161489651,-52.3317920626,-81.8926048609,-101.885506061,-41.7450744774,-58.4171407368,32.6887231406,-24.0812441084,-23.7887854123,-1.56245297525,3.51890843105,1.35320443694,4.78209868289,-16.9387995221,0.197293901996,-20.0284669703,6.65085092184,-39.4421368819,-25.3449302898,-6.0545693089,-8.61834617757,20.9663860512,8.41959469031,14.9962182246,1.2163960412,0.746736610282,-1.1938019562,2.46529167704,0.628772155031,5.56475969199,-3.2865323972,-1.1790071393,-7.71155175908,-9.30755612611,5.31163346617,-1.79888409768,10.9139039097,-2.62475855169,-1.03522873661,-4.20547980462,-2.98357477414,0.405932467318,-0.817533349228,0.994933432308,0.734244437003,0.301879871305,-0.414356474387,-0.392973897002,-1.08069410013,-2.21051392926,-0.782221624152,-0.86088872371,-0.528492052804,1.0722960014,-0.237160324777,-0.450457116302,0.170701632419,-1.31236460021,0.217578137375,-0.521217093753,-0.0517521577582,-0.0788361146216,0.0426304281805,0.067321662026,-0.258077465603,0.133829468124,-0.0365676543349,0.436694580604,-0.340548147567,0.0459340531812,-0.163124638215,0.322484385487,1.03825170685,0.591934356199,0.189308550953,-0.211451108579,-0.760383120006,-0.605988564315,-0.0621091150095,-0.104859095701,0.227552066586],[-35411.9894487,-1748.32815856,-1371.6825905,-1743.55343431,-1588.19866613,814.99210498,979.313738975,728.420613776,-736.459885596,-197.653475324,714.931051272,-338.917873077,-306.048392473,-18.8590601002,381.01521848,-55.4182148794,-249.612304265,19.1401874077,-739.189061792,-296.583948354,136.205629251,-72.6677802429,-61.8272448272,-719.936899098,38.4443849983,61.1621070846,-173.296671423,187.278582515,11.8057716325,224.03571155,-183.197875822,-208.810164415,-140.373865569,-152.419951584,337.801714798,8.76835896856,20.4167051909,38.5598643859,12.6943516654,-8.81125151299,-53.786454643,-80.9289843957,-102.233988888,-42.4187910522,-56.4237384394,31.8433390192,-24.407950221,-24.1785973295,-1.57019290292,3.25136785161,1.33541774132,4.61377341324,-17.1068646989,-0.207394459581,-19.9356384947,6.54361549869,-39.483590049,-24.7932104327,-6.38124935244,-8.46151002052,20.95683827,8.46026061104,15.3871426601,1.25152151744,0.713122399141,-1.19310486434,2.45035354375,0.547047342323,5.4845429179,-3.25316582808,-1.26200873396,-7.70444241492,-9.25637122205,5.23721543763,-1.75098767455,10.9656847122,-2.59290146246,-0.86638741259,-4.2088966317,-2.99923687946,0.419687657125,-0.81399371528,1.00419315534,0.723948445961,0.272264366785,-0.424032822111,-0.409522999896,-1.13474922712,-2.19449081976,-0.781832992336,-0.869125430763,-0.484296992138,1.10517058536,-0.215694018045,-0.399198833362,0.177030642075,-1.31419571722,0.215960593679,-0.506679120851,-0.0465634171792,-0.0771560941489,0.0487588657462,0.0669268784973,-0.26720401172,0.132930427483,-0.0396184270516,0.418338847923,-0.336414429991,0.0448316938007,-0.164447420497,0.330514631762,1.04333550321,0.595483439666,0.204208735702,-0.209438173928,-0.752974553251,-0.60800023346,-0.0544067872116,-0.103246823622,0.224240747644],[-35395.3061106,-1737.27379467,-1323.92395014,-1756.24863048,-1577.51839282,858.085665719,965.188836355,742.784779532,-717.09998353,-201.536285316,741.731869292,-332.226175737,-325.639456972,3.24203496662,364.69135658,-55.7745289408,-246.073529312,13.3664580197,-733.925546621,-304.996325731,132.795801403,-77.538483132,-69.2977902982,-714.236378351,38.8343665646,60.5271048153,-173.618907213,185.926433686,10.119508082,220.471408995,-180.232659527,-211.08790825,-139.15563833,-145.656522902,336.751418333,8.77039594983,19.5660041702,37.819626873,13.005387952,-8.90033956204,-55.2699978638,-79.9448557967,-102.572469571,-43.0503728887,-54.4384726888,31.0138698291,-24.6984914522,-24.5766120649,-1.57423439602,2.97518582958,1.29998726861,4.4256875802,-17.2815976458,-0.645564424536,-19.8375356336,6.42589695455,-39.50974926,-24.2327125353,-6.69543461213,-8.28516022867,20.9560278779,8.4938484559,15.7798359449,1.28650223226,0.678782359859,-1.20045504517,2.4292852242,0.459378909362,5.3908476176,-3.21511099274,-1.35323611517,-7.6930630244,-9.2072773965,5.17174455541,-1.70055117248,11.019406425,-2.56280995508,-0.69788399736,-4.21315838168,-3.00883985215,0.433303849711,-0.810599276687,1.01135579518,0.712578254582,0.242230353816,-0.43869154565,-0.426235933487,-1.19241147143,-2.17796741407,-0.782681792354,-0.875879110924,-0.438914795235,1.13844426409,-0.193638125193,-0.346732619777,0.184194017854,-1.31316046452,0.215778490042,-0.493041448055,-0.0419427933694,-0.0755236068302,0.0546850123371,0.0663344528056,-0.276835761896,0.13144595536,-0.0429432000951,0.398957695984,-0.332117310306,0.0432193413035,-0.165571251525,0.338559901117,1.04885544871,0.599579626419,0.220010536387,-0.207209544161,-0.744577479839,-0.609867004567,-0.0469596858503,-0.10193519785,0.221009432318],[-35379.5349159,-1725.36548375,-1271.8486726,-1765.13085376,-1564.19089768,902.092540286,955.408000007,756.482386867,-699.683343852,-205.347675188,768.879900517,-324.464077427,-344.922421579,22.9632245518,349.248166733,-56.8132130178,-242.419788151,8.13685582314,-728.922128038,-313.197404517,129.498560495,-82.3150108473,-75.0171594251,-708.123078413,39.1235235461,60.025226797,-173.762412245,184.395675627,8.67333555889,217.120029706,-177.092281384,-213.081765611,-137.72633734,-139.025691697,335.677367465,8.78644445819,18.6848366944,37.1442884367,13.2538263236,-8.96102926478,-56.7527743046,-78.9353222039,-102.891212611,-43.6210587283,-52.4775297132,30.2062253281,-24.9471273132,-24.9791086466,-1.57573832084,2.69344232724,1.25080955369,4.2177246034,-17.4590153475,-1.11019128563,-19.7323241207,6.30010378528,-39.5136041844,-23.6691271545,-6.9921328292,-8.08954585661,20.9638825529,8.52136631063,16.1702944588,1.32054013837,0.643192336573,-1.21514602253,2.40192085479,0.367239411043,5.28379032566,-3.17244404581,-1.45143480155,-7.67547501357,-9.16060545835,5.11758378582,-1.64815855173,11.0745949442,-2.53416676934,-0.531500272609,-4.21771085049,-3.01193642686,0.446484333152,-0.807432753673,1.01613910304,0.700092025889,0.212129619315,-0.458561191964,-0.442886876305,-1.25308570378,-2.16046757488,-0.784803334155,-0.880362365586,-0.392913816148,1.17218046629,-0.171026993611,-0.293546837698,0.192469460712,-1.30924170803,0.217111852075,-0.48038301865,-0.0378988139717,-0.0739965277088,0.0602969122541,0.0655248602402,-0.286822128767,0.129255183849,-0.0464779216056,0.378626651533,-0.327683502359,0.0411083733428,-0.166291044601,0.34649055156,1.05490052196,0.604189877524,0.236559728659,-0.204679741668,-0.735273449829,-0.611512839788,-0.0397981943093,-0.100941451073,0.217910586847],[-35368.0195505,-1714.51318097,-1216.65896971,-1770.38481006,-1548.89568944,946.247546732,949.952947597,769.624403523,-684.226189858,-208.897787503,796.096799904,-315.451300233,-364.124324542,39.7975881831,334.615193641,-58.4358604745,-238.483224677,3.44900530396,-724.096490456,-321.186041086,126.316909854,-86.9381495877,-78.9640642942,-701.646463292,39.3180813879,59.6782623473,-173.671563733,182.721239117,7.44862882828,214.035575516,-173.788924658,-214.793208134,-136.096685928,-132.568893476,334.561352158,8.80644991543,17.790089516,36.5483630254,13.4523713228,-9.00028474201,-58.2040721573,-77.8996106692,-103.182323319,-44.1187666245,-50.5580160121,29.4217918599,-25.1502698899,-25.3820754477,-1.57643760851,2.40912237974,1.19190302835,3.99159121033,-17.634341995,-1.59339336201,-19.6184454415,6.16791744345,-39.4902904563,-23.1088520762,-7.26745224113,-7.87526691774,20.9798042249,8.54425650295,16.5536840805,1.35252910145,0.605526262755,-1.23633662312,2.36828450631,0.272400616071,5.16388810552,-3.12541395227,-1.5551134082,-7.65000230223,-9.11647793036,5.07656801122,-1.59434085793,11.1301416472,-2.50660691404,-0.369365177021,-4.22215869379,-3.00813306697,0.458924902604,-0.804684684181,1.01827461317,0.686402106498,0.182354141499,-0.483745392711,-0.459145295103,-1.31598355782,-2.14144269593,-0.788090757448,-0.881885509601,-0.346800708193,1.20627556994,-0.147904668465,-0.240218950428,0.202065923082,-1.30247591144,0.220032289488,-0.468779639498,-0.0344052288641,-0.0726495348894,0.0654649234054,0.0644337520512,-0.296993698507,0.126257458506,-0.0501153572817,0.357462005124,-0.323080104566,0.0385458779954,-0.16641992704,0.35420724411,1.06148573796,0.609263393664,0.253644599226,-0.201775114827,-0.725158968755,-0.612850930874,-0.0329462064537,-0.100282181005,0.214986311083],[-35363.6890905,-1707.16080175,-1160.00983831,-1772.21538941,-1532.6169889,989.705863202,948.198055439,782.093648022,-670.696291265,-211.9452369,822.996343458,-305.094510247,-383.434016778,53.2826196084,320.664054708,-60.5403978904,-234.085604162,-0.685664074961,-719.400446689,-328.981811693,123.211863238,-91.3954501542,-81.1741289934,-694.880104876,39.4258583891,59.5133215523,-173.291531815,180.940515796,6.41635628032,211.254971449,-170.353524143,-216.231609848,-134.29951923,-126.325785212,333.376412285,8.81827876307,16.9008505442,36.0457950308,13.6156988181,-9.02871088054,-59.5930957898,-76.84161285,-103.440490367,-44.5376549699,-48.6985332995,28.660653067,-25.3043683138,-25.7805255176,-1.57801652787,2.12515442113,1.12759422586,3.75035757102,-17.8025877019,-2.08717952405,-19.4946966492,6.03047970219,-39.4367435642,-22.5583479253,-7.51883433261,-7.64293590305,21.0018382581,8.56363460222,16.9244942216,1.38124630623,0.564766771574,-1.2632035706,2.32853493028,0.176758324519,5.03206379507,-3.07425161422,-1.66258057116,-7.61520609303,-9.07479530979,5.0498525473,-1.53937127148,11.1844901077,-2.47959498638,-0.213676073517,-4.22599167089,-2.99705437544,0.470335479179,-0.802649654857,1.01751491467,0.6714038278,0.153327204081,-0.514247424777,-0.474583003225,-1.38017906861,-2.12033523442,-0.792324138203,-0.879872059837,-0.300985768122,1.24049113128,-0.124300944703,-0.187421967227,0.213121959667,-1.29292387711,0.224550830719,-0.458278528102,-0.0314171043332,-0.0715635059879,0.0700392717866,0.062972821414,-0.307165697363,0.122367371836,-0.0537227429739,0.335611482504,-0.318224514346,0.0356009618415,-0.165794267613,0.361646377156,1.06856601367,0.614756240621,0.271010259614,-0.198420931847,-0.714334489493,-0.613782438892,-0.0264295871393,-0.0999623363522,0.212265320698],[-35368.2008336,-1704.3661508,-1104.15722382,-1771.03922967,-1516.07170418,1031.77655407,949.454044835,793.560576547,-659.103725702,-214.213740285,849.070297625,-293.385908814,-403.107894475,62.8986698657,307.29945479,-63.0630819338,-229.06576887,-4.28926730129,-714.789061861,-336.628252203,120.141560138,-95.6827058748,-81.6858358423,-687.932980925,39.4558960124,59.5515203696,-172.574791525,179.094758305,5.54429102119,208.798735817,-166.826126434,-217.411536102,-132.3791781,-120.343024142,332.092588825,8.81000340267,16.0344924425,35.6495741356,13.7583943945,-9.05830115331,-60.890944594,-75.7699655387,-103.660866698,-44.8765745155,-46.9179601278,27.917563945,-25.404595134,-26.1712338549,-1.58158739237,1.84397800806,1.06283030753,3.49763983159,-17.9592512372,-2.58375318242,-19.3603254297,5.88904047225,-39.3508389069,-22.0234958672,-7.74515864597,-7.39248316365,21.0276733541,8.58064029391,17.2772333589,1.40570247132,0.519925619397,-1.29489609162,2.28281122757,0.0823625367885,4.8894576626,-3.01906780544,-1.77208074098,-7.56990971788,-9.0352107251,5.03781035005,-1.48320232443,11.2357166363,-2.45254369878,-0.0667246219863,-4.22869789009,-2.97838206063,0.480476765538,-0.801685424773,1.01370528017,0.654956006154,0.125509341714,-0.550004713272,-0.488745767241,-1.4447056897,-2.09667348566,-0.797145470641,-0.873888478891,-0.255749085149,1.27446747703,-0.100139860065,-0.135829518271,0.225811177916,-1.28061446666,0.230682970461,-0.44893741984,-0.028885819325,-0.0708055328153,0.0738667459168,0.0610470948929,-0.317147457267,0.117500746807,-0.0571621460751,0.313243486054,-0.313014669882,0.0323636867852,-0.16427403061,0.368765643663,1.07605450337,0.620651246777,0.288406451843,-0.194542467184,-0.702891153785,-0.614215402522,-0.0202759714042,-0.0999869390077,0.209785280678],[-35381.6716239,-1705.19960648,-1051.10898721,-1767.2376943,-1499.45741658,1071.83003137,953.09649593,803.355893279,-649.480221299,-215.328328832,873.825285357,-280.187795409,-423.470239223,68.2435855387,294.38597939,-65.965853742,-223.275991839,-7.39958536704,-710.187287152,-344.1813123,117.054732054,-99.8060088202,-80.547868157,-680.911890669,39.4153366155,59.8007470719,-171.481519297,177.227882554,4.7978334574,206.679195538,-163.252271171,-218.344254521,-130.386772679,-114.660799956,330.672171599,8.77000430202,15.2045170078,35.3697325016,13.8944497154,-9.10102768461,-62.0715987982,-74.6951309955,-103.837878623,-45.1360136683,-45.2313647105,27.1862475144,-25.4453438025,-26.5502678874,-1.58795008211,1.56727455957,1.00269046734,3.23662051108,-18.0998535541,-3.07587627433,-19.2148604647,5.74466639343,-39.2312609846,-21.5087533901,-7.94661931637,-7.12362103051,21.0547332972,8.5961415756,17.6067367854,1.42509107452,0.470002272933,-1.33042306758,2.23121670623,-0.00868997118722,4.73727900966,-2.95995686484,-1.88193624189,-7.51324312608,-8.99694926316,5.04026084891,-1.42545927098,11.281892913,-2.42470413961,0.0694855218177,-4.22968872223,-2.95185847945,0.489152795751,-0.802128630385,1.00677037912,0.636894591933,0.099348459613,-0.590850098563,-0.501183341902,-1.50861223636,-2.07004199629,-0.802107788012,-0.863665131567,-0.211255889936,1.30780378952,-0.0753274846295,-0.0860282716186,0.240257697545,-1.26555981437,0.238404179406,-0.44078534831,-0.0267492384526,-0.0704235414324,0.0768157409672,0.058560231815,-0.326746551074,0.111594522237,-0.0602942981284,0.290521902239,-0.307350546759,0.0289307612735,-0.161756065094,0.375548467149,1.08382391732,0.626950447851,0.305596271827,-0.190063563701,-0.690906744649,-0.614062412686,-0.014511419873,-0.100358567623,0.207575896449],[-35401.9032693,-1708.32314052,-1002.14747777,-1761.09938955,-1482.44903518,1109.18238112,958.876799862,810.7251435,-641.877370659,-214.673023241,896.892599456,-265.24996958,-444.747905298,69.0174168453,281.609574595,-69.2315056744,-216.566003078,-10.0358502553,-705.507507088,-351.700253361,113.858367254,-103.802439235,-77.8290461433,-673.872813843,39.3084657145,60.2607018227,-169.979685232,175.368809929,4.13763185002,204.895583603,-159.672243809,-219.03398283,-128.363063166,-109.300430303,329.06312109,8.68801956634,14.4183851073,35.2134990181,14.035188611,-9.1678670881,-63.1134212893,-73.6237204278,-103.967306063,-45.3168992782,-43.6480110954,26.4602966462,-25.4223051962,-26.9102721349,-1.59839272787,1.29602747336,0.952217837822,2.97048881903,-18.2197104657,-3.55752111255,-19.0581578804,5.5979405464,-39.0775519692,-21.0169262585,-8.12375429845,-6.83657003322,21.0804115174,8.61120330222,17.908225697,1.43861880145,0.414288299025,-1.36871192494,2.17415422195,-0.0943440945919,4.57669593032,-2.89704156282,-1.99067934708,-7.44472432959,-8.95901180237,5.05680284703,-1.36561828404,11.3212750936,-2.39500106478,0.193385601245,-4.22843666566,-2.91723014128,0.496227090616,-0.804233955285,0.99668421354,0.617097757349,0.075270172221,-0.636498544878,-0.511547803554,-1.57101867774,-2.04006666861,-0.806783918398,-0.849034106748,-0.167527167136,1.34003753254,-0.0497724733211,-0.0385426478141,0.256427659004,-1.24775564395,0.247669397659,-0.433772267857,-0.0249314725434,-0.070457266943,0.0787756158433,0.0554285827207,-0.335792748772,0.104628442551,-0.0629895480149,0.267597491825,-0.301124074892,0.0253984961466,-0.158189040703,0.38200794623,1.09169873556,0.633641628557,0.322361855623,-0.184917401513,-0.6784315011,-0.613218114305,-0.009148144947,-0.10108797762,0.205636193867],[-35426.1106314,-1712.64327725,-957.477196589,-1753.03412707,-1464.55747631,1143.44729172,966.766334408,814.963844235,-636.333593339,-211.616495899,918.060104202,-248.425367125,-467.115372632,64.9628911777,268.587724021,-72.8447923468,-208.817198883,-12.2066665803,-700.678203683,-359.253947536,110.432509817,-107.725030078,-73.6079530664,-666.840897688,39.1436998511,60.9285638792,-168.047901179,173.528177465,3.52187158463,203.424681899,-156.119949695,-219.485063756,-126.332040085,-104.268769302,327.212956773,8.55681945676,13.6808830271,35.1845650231,14.1883887681,-9.26792786431,-64.0026602935,-72.560717978,-104.047047154,-45.4200184892,-42.1716646012,25.7329329867,-25.3318437362,-27.2424067889,-1.61463461378,1.03138067048,0.915915408183,2.70253912548,-18.3142650106,-4.02438937547,-18.8909782878,5.44881298863,-38.889160985,-20.5490576022,-8.27692978657,-6.53142870095,21.1025763903,8.62720940913,18.1779768477,1.4454117769,0.352537404411,-1.40879211652,2.11233197346,-0.172681313546,4.40881463413,-2.83051225336,-2.09715988025,-7.36410183417,-8.92019337065,5.08679110107,-1.30308707141,11.3522933573,-2.36228136495,0.303915323496,-4.22452513468,-2.87428478313,0.50157007873,-0.808181982159,0.983453717708,0.595522535881,0.0536677273281,-0.686525483171,-0.51961068425,-1.6311640413,-2.00646156587,-0.81076513412,-0.829906401131,-0.124454188266,1.37068326336,-0.0233676224194,0.00622111369957,0.274209776237,-1.22718088214,0.258412353068,-0.427785206513,-0.0233645204562,-0.0709460647037,0.0796558492169,0.0515986966957,-0.344145366488,0.0966358293963,-0.0651417932007,0.24460914556,-0.294238766202,0.0218633810991,-0.153555538164,0.388172411593,1.09947395506,0.640687667991,0.338522618975,-0.17905529523,-0.66548006768,-0.611583549424,-0.0041749481063,-0.102191735725,0.20395172021],[-35452.9732454,-1717.46740374,-915.118105373,-1743.57963098,-1445.75148038,1174.64161284,976.491589616,815.652490089,-632.816620968,-205.83195978,937.186182723,-229.709780736,-490.679142441,55.9012496,254.946203606,-76.7377960013,-199.961393251,-13.9277208663,-695.671212868,-366.910888847,106.606770462,-111.62378774,-67.9934893481,-659.789918121,38.9493846823,61.8049032879,-165.679584557,171.694498661,2.90383394933,202.21591494,-152.624648246,-219.706748543,-124.304785218,-99.5646945132,325.07017996,8.3745100973,13.0003651465,35.2832241621,14.3584521612,-9.40894412633,-64.7330561657,-71.5133560676,-104.078702747,-45.4470910471,-40.8035759654,25.0001342157,-25.1703525687,-27.5355444936,-1.63873491901,0.776233046405,0.897803426422,2.43704344837,-18.3792694387,-4.47380099216,-18.714993446,5.29572054619,-38.6654956222,-20.1053083201,-8.4060367331,-6.20861223369,21.1193540326,8.64492401577,18.4131167219,1.44427390468,0.285082958645,-1.449732507,2.04692996155,-0.241868844731,4.23477918019,-2.76063663554,-2.20049785075,-7.27147320107,-8.87933462867,5.12924065858,-1.23738247217,11.3736720784,-2.32537528233,0.400523906932,-4.21748931722,-2.82289551832,0.504965946187,-0.814100795628,0.967113024396,0.572293779819,0.0349255439669,-0.740296474038,-0.525175875446,-1.68840719622,-1.96906662848,-0.813691081917,-0.80624656908,-0.0818234967771,1.39935004251,0.00401144880911,0.0479573482156,0.293387889094,-1.20380971213,0.270511351575,-0.422647324961,-0.0220023632096,-0.0719546704384,0.0793914133932,0.0470552954696,-0.351685751206,0.0877152294863,-0.0666614042294,0.221696392377,-0.286605859718,0.0184200094483,-0.147854053972,0.394075795878,1.10693093237,0.648026770278,0.353927238117,-0.172455094869,-0.652047183429,-0.609065701366,0.000423374419835,-0.103686206641,0.202485525846],[-35482.8801555,-1723.75807803,-872.504237227,-1733.50307879,-1426.73716204,1202.96876088,987.946371513,812.865249599,-631.190509496,-197.325895365,954.138039495,-209.304207969,-515.505844053,41.6439299165,240.410712959,-80.7504424227,-190.002512264,-15.2431940246,-690.535703942,-374.725429895,102.195882752,-115.526659305,-61.07987574,-652.67569248,38.7791626838,62.8886444176,-162.882547653,169.834394258,2.23315831153,201.2012316,-149.211636833,-219.710568413,-122.274954244,-95.1813546609,322.597454427,8.14456680604,12.3910903876,35.5073352489,14.5455589922,-9.59876073461,-65.3069186246,-70.4895608896,-104.064923963,-45.3999551249,-39.5429220764,24.2587964222,-24.9373174103,-27.7788367788,-1.67299145312,0.53620661577,0.901400846346,2.17887131829,-18.4108309068,-4.90421555631,-18.5323531944,5.13638464881,-38.4069421159,-19.685875847,-8.51065103461,-5.86908615384,21.1302272278,8.6654944831,18.6119930953,1.43366706227,0.212915177268,-1.49053196431,1.97976822956,-0.300138267089,4.05588542333,-2.68783469306,-2.30015583611,-7.16735933567,-8.83546635407,5.1830600264,-1.16824346827,11.384528242,-2.28330891769,0.483016599706,-4.20711610975,-2.76294813517,0.506078903232,-0.822049815518,0.947733292606,0.547777821282,0.0193759588415,-0.79699779452,-0.528068302979,-1.74222226895,-1.92780978709,-0.815277006452,-0.778157695809,-0.0394297973036,1.42571326233,0.0325207777326,0.0864963202421,0.313731742664,-1.17761707117,0.2838367341,-0.41818919912,-0.0208227108248,-0.0735731798567,0.0779327656203,0.0418265509472,-0.358324669466,0.078034466842,-0.0674673209562,0.199008944979,-0.278147019536,0.0151447743125,-0.141115903904,0.39974830326,1.11386144578,0.655611269967,0.368456501901,-0.165119127199,-0.638120018889,-0.605606664386,0.00467894164806,-0.105591548615,0.201202527485],[-35518.0777736,-1733.79187514,-827.651920036,-1723.71949423,-1408.97917159,1228.43161696,1000.73418996,806.671066858,-631.168291847,-186.383954381,968.77823965,-187.640396375,-541.674546797,22.137658782,224.712306539,-84.6557353209,-179.012928558,-16.2030416331,-685.383330047,-382.759112806,97.0207135689,-119.462349089,-52.960712272,-645.460206406,38.7072759057,64.1808725216,-159.674407313,167.896869853,1.45876815781,200.301773483,-145.906981871,-219.504254136,-120.236388754,-91.1022385874,319.766851212,7.87525232183,11.8718788644,35.8529660939,14.7462851144,-9.84424487882,-65.7333053426,-69.4985643205,-104.009375818,-45.2833993634,-38.3858466219,23.5078131516,-24.6327102804,-27.9618263284,-1.71964532244,0.31899169988,0.929901667952,1.93315858564,-18.4055690339,-5.31565422067,-18.3457721753,4.96827182992,-38.114894578,-19.2905769419,-8.59047596762,-5.51385092242,21.1348635544,8.69013281272,18.7741362107,1.41196565886,0.13763439192,-1.5303355434,1.91308149941,-0.345819933936,3.87344441774,-2.6124736916,-2.39586388392,-7.05262549189,-8.78784262941,5.24680114898,-1.0954090405,11.3842574022,-2.23511306281,0.551633348678,-4.19320925292,-2.69439039321,0.504519797169,-0.832048909551,0.925414528635,0.522493444269,0.00731178035839,-0.855705970505,-0.528138074241,-1.79220013565,-1.88270651845,-0.815318829454,-0.745896658652,0.00298335232281,1.44946876711,0.0623713274404,0.121745858063,0.33500699111,-1.14857273691,0.298210668343,-0.414205023092,-0.0198261611531,-0.0758981309551,0.0752440858813,0.0359847211971,-0.363997795273,0.0678073267048,-0.0674889550223,0.176702437848,-0.268782784087,0.0120988986519,-0.133407691558,0.405220760317,1.12005811903,0.663415934594,0.382008134951,-0.15704905267,-0.623674164683,-0.601174653335,0.00863900243819,-0.107925954145,0.200064856991],[-35561.0250741,-1748.64729065,-778.677612552,-1715.4170107,-1393.85269742,1250.94898746,1014.27110129,797.271300658,-632.504636192,-173.383777974,980.994183983,-165.126246987,-569.046925475,-2.42261804689,207.623523499,-88.2576369595,-167.139859248,-16.8676663289,-680.322217632,-391.045019077,90.9493095978,-123.424625851,-43.7479658705,-638.087720954,38.8146675708,65.6639254415,-156.087086746,165.828211409,0.532941066131,199.447075889,-142.720972404,-219.089212557,-118.178802801,-87.3025438597,316.556897249,7.58052770339,11.4579180733,36.3121667371,14.9536396957,-10.1535606836,-66.0221912705,-68.5480616791,-103.916265625,-45.1003523836,-37.3284338955,22.7496844584,-24.2569629191,-28.0745388649,-1.77939220673,0.132409382282,0.986081410339,1.70369236213,-18.3621733174,-5.70896664592,-18.1589848711,4.78952035389,-37.7908392524,-18.9195189865,-8.64492660772,-5.14482044424,21.1324814277,8.71979952291,18.8999834641,1.37796198265,0.0614435421015,-1.56844980357,1.84887629907,-0.377684269964,3.68865522438,-2.53528287975,-2.48732356416,-6.92832301875,-8.73613581743,5.31894808888,-1.01893654928,11.3725271045,-2.17983172893,0.607036001696,-4.17553764561,-2.61731543055,0.499930814947,-0.843942537668,0.900316567595,0.496942674326,-0.0010415628587,-0.915513303794,-0.525396099245,-1.83800440241,-1.83390199547,-0.81368522028,-0.709763773227,0.0455876678424,1.47037318609,0.0937321850667,0.153642929882,0.356941081887,-1.11669930316,0.313391134511,-0.410442638475,-0.0190384549203,-0.0789781249191,0.0713128752591,0.0296368265318,-0.368643812967,0.0572454214932,-0.066689013177,0.154930110967,-0.258464501174,0.00934617293698,-0.124813798463,0.410510070137,1.12533441466,0.671409841666,0.394496270526,-0.1482480133,-0.608698609966,-0.595753121513,0.012348172199,-0.110700254666,0.199025433007],[-35612.7265178,-1766.66577565,-723.260233525,-1709.81833433,-1381.8403693,1270.39329202,1028.00183004,785.111483392,-635.103451059,-158.63385233,990.669646808,-142.000225864,-597.239509791,-31.6065909077,189.102552445,-91.4337407857,-154.587927056,-17.3203545742,-675.408561951,-399.555700506,83.9088783304,-127.317922952,-33.5665864691,-630.474420743,39.1743831904,67.2932531124,-152.173342126,163.590084392,-0.579580683286,198.590336312,-139.629910936,-218.459668187,-116.076336008,-83.7592494978,312.951102528,7.27850076206,11.1551596986,36.8727582472,15.1580590445,-10.535678702,-66.1811517675,-67.6398361307,-103.788304896,-44.8474096989,-36.3693103436,21.9893015204,-23.812896671,-28.1091040384,-1.85066918267,-0.0172469674615,1.0722785838,1.49206764163,-18.2821437428,-6.08496098414,-17.9759171018,4.5996487691,-37.4351533367,-18.5739689704,-8.67342860059,-4.76562340563,21.121883071,8.75497070176,18.9907432031,1.3312360047,-0.0130131291398,-1.60418875806,1.78849838389,-0.395246123539,3.5026829864,-2.45757379513,-2.57399756913,-6.79544006763,-8.68062069362,5.39818222542,-0.939647177103,11.3494049021,-2.11675310612,0.650194506822,-4.15385354598,-2.53208278395,0.492054703095,-0.85731002257,0.872717619309,0.471519012309,-0.00555919730372,-0.97560097894,-0.520132511546,-1.87934159439,-1.78170713597,-0.810333992136,-0.670050425479,0.0882829476944,1.48830112598,0.126634950674,0.182178762496,0.379229741567,-1.08212782088,0.329111007641,-0.406666739192,-0.0185126658118,-0.0827780044519,0.0661622595011,0.0229175269731,-0.372191196295,0.0465285977184,-0.0650937146375,0.133845453678,-0.247211358533,0.00696063439879,-0.115420609064,0.415573921261,1.12955385354,0.679530112145,0.405856624246,-0.138731000152,-0.593228544727,-0.589342687656,0.0158272578572,-0.113914160808,0.198033459673],[-35673.994318,-1785.09319448,-660.85460631,-1708.37195595,-1372.82214288,1286.45082716,1041.79491918,771.001134114,-639.094503315,-142.404060267,997.617478298,-118.471601718,-625.74810485,-64.9026177425,169.348357127,-94.1048888654,-141.627097865,-17.6573442149,-670.658011686,-408.218159079,75.9015965214,-130.965656084,-22.5411386684,-622.56739023,39.8496191194,68.9984031148,-148.00476694,161.163927297,-1.90941315236,197.707481361,-136.586823554,-217.611647471,-113.890974162,-80.4516482913,308.944336171,6.98995631431,10.9618013298,37.5196587319,15.3484767992,-11.0035913512,-66.2146214414,-66.7702327771,-103.627350336,-44.5190639973,-35.5103350447,21.2283466371,-23.3080473264,-28.0622606336,-1.92929163134,-0.125049974649,1.19011340123,1.29823415373,-18.1693188592,-6.44383793875,-17.8005462291,4.39924725165,-37.0482435067,-18.2570888677,-8.67598092759,-4.38091326086,21.1017968755,8.79672544173,19.0482007181,1.27216496487,-0.0829239500888,-1.63677790767,1.73268809123,-0.398813722733,3.31684432762,-2.38130918407,-2.65517622244,-6.65490094458,-8.62221061347,5.48325606604,-0.859095162226,11.3151430731,-2.0456304575,0.68206672944,-4.12804250001,-2.43923023742,0.480770275492,-0.8714902146,0.843013097335,0.446530799049,-0.0062256242291,-1.03527600827,-0.512863541255,-1.91593958344,-1.72654038785,-0.805347535464,-0.627090613754,0.130708365841,1.50318756367,0.161060973086,0.207331722494,0.401667315475,-1.04514954091,0.34513854384,-0.40271702499,-0.0183163813132,-0.0871792831391,0.0598483984698,0.0159664252493,-0.374557077876,0.0358011421503,-0.0627850442315,0.113604713226,-0.235094541591,0.0050104324286,-0.105319992512,0.420322418861,1.13263490879,0.687697862101,0.416018619638,-0.128519590737,-0.577361964971,-0.581963829576,0.0190963833784,-0.117555155258,0.197056395484],[-35745.0228853,-1798.86335314,-591.427082897,-1712.45974585,-1365.99772115,1299.10652401,1056.05634644,756.538148816,-644.909974741,-124.887083876,1001.6273579,-94.513420933,-653.843884549,-101.704705452,148.744023306,-96.2630200491,-128.580591268,-18.0014393235,-666.030323072,-416.911357926,66.9944213935,-134.088650068,-10.8061305873,-614.299878292,40.8907891131,70.6782695503,-143.681982544,158.548794684,-3.47797442651,196.79798351,-133.513772031,-216.553107833,-111.569489493,-77.367011628,304.538690617,6.73702464498,10.8644019471,38.233069724,15.5106804084,-11.5767966456,-66.1230706274,-65.9301746743,-103.437446868,-44.1038685561,-34.7568046794,20.4683000033,-22.7535076826,-27.9340875615,-2.0084390043,-0.187854277983,1.33990519864,1.11994667523,-18.0304730006,-6.78528795693,-17.636824877,4.18946353866,-36.6296771582,-17.9742127271,-8.65245822385,-3.99709030267,21.071169287,8.84617127031,19.0747171275,1.20196042575,-0.145305124686,-1.66529926263,1.68135034719,-0.389698758704,3.13257271888,-2.30918874466,-2.73007174932,-6.50747148146,-8.56257729565,5.57336390963,-0.779571977022,11.2702974137,-1.96661516049,0.703502692088,-4.09811868051,-2.33955938407,0.466128330332,-0.885561756445,0.811769247175,0.422178625151,-0.00315502174251,-1.09403015573,-0.504388388622,-1.94752195826,-1.66894435486,-0.798915168736,-0.581163622629,0.172256900124,1.51508037768,0.196845128759,0.229078709897,0.424079977773,-1.00618496918,0.361287918542,-0.398473572362,-0.0185327919859,-0.0919710618422,0.052470981249,0.00893047666923,-0.375652018219,0.0251737355803,-0.0599113802897,0.094368646678,-0.222241799554,0.00356047224894,-0.0946024568578,0.424619233653,1.13456591749,0.695793862126,0.424917417754,-0.117652722325,-0.561262659399,-0.573651761739,0.0221590150274,-0.121605850411,0.19606816467],[-35824.8061842,-1800.02900544,-514.687163487,-1723.1706237,-1359.86340442,1308.86728217,1071.37296683,743.831962994,-653.165284905,-106.25306714,1002.60040457,-69.9134253379,-680.636099413,-141.195416162,127.798977581,-97.9792113237,-115.831614668,-18.4725956935,-661.436412073,-425.463016833,57.3387869416,-136.334607579,1.48564546693,-605.599277746,42.3297606298,72.2050493063,-139.320002642,155.759278831,-5.28986926112,195.886086936,-130.311604947,-215.302562078,-109.050003801,-74.4906628518,299.753227694,6.54153985072,10.8393861595,38.9906348751,15.6272634766,-12.2771657602,-65.9052204868,-65.106442545,-103.222790839,-43.584240979,-34.1119480417,19.7155578053,-22.1621340916,-27.7290811035,-2.07925904734,-0.204339249947,1.52079962436,0.952395510341,-17.8745858919,-7.10895614981,-17.4882343511,3.97262866963,-36.177652051,-17.7311476778,-8.60185021093,-3.62151031322,21.0289594313,8.90397790221,19.074134487,1.12262093578,-0.197156667875,-1.68892441462,1.63354276615,-0.369977669966,2.95125299326,-2.24420657303,-2.79785861107,-6.35360032633,-8.50376188419,5.66832149819,-0.703653819603,11.215951859,-1.88023515829,0.715672003094,-4.0640651871,-2.23415962197,0.448319335325,-0.898449078428,0.779638527523,0.398550391361,0.00341570300205,-1.15153479919,-0.495672546738,-1.97388357209,-1.60952553652,-0.791288206624,-0.532462500337,0.212206307223,1.52424972057,0.233668479331,0.247526358338,0.446346750972,-0.965739436894,0.3773684392,-0.393826375984,-0.0192595590019,-0.0968718185276,0.0441522050102,0.00197244555004,-0.375396063699,0.0147247808922,-0.0566612827627,0.0762703350656,-0.208821593751,0.00266224537931,-0.0833449368697,0.42831186428,1.13543519365,0.703677237743,0.432526398506,-0.106182429381,-0.545128893004,-0.564476930439,0.0250120754833,-0.126036258309,0.195047642264],[-35911.1926155,-1783.81433676,-432.300763487,-1740.89732213,-1353.22341057,1315.96654996,1087.96821425,734.048882651,-664.09268642,-86.715690243,1000.5267826,-44.7146081049,-705.500926547,-182.365254238,107.059633163,-99.2746196415,-103.74566108,-19.1388540232,-656.797467626,-433.71079836,47.1794618252,-137.444105378,14.1837195039,-596.493522282,44.1862523743,73.47341059,-135.010589247,152.823799369,-7.34061819688,195.010620037,-126.916141774,-213.870725497,-106.29180097,-71.7933555645,294.630997494,6.42014073564,10.8697741981,39.7726202541,15.6836079275,-13.1185485154,-65.561556663,-64.2894667101,-102.981158534,-42.9510580085,-33.5733860704,18.9776057747,-21.5486727569,-27.4556491519,-2.13402065575,-0.17379289499,1.73180132646,0.790233121633,-17.7088763506,-7.41477909693,-17.3574089908,3.75279027938,-35.6924471279,-17.5313698749,-8.52340179368,-3.25966487249,20.9745476329,8.97089646745,19.0516058713,1.0360584761,-0.236172593429,-1.70714956212,1.58824357761,-0.341505717651,2.77397912191,-2.18855679933,-2.8576503627,-6.19391428509,-8.44707627327,5.76783728262,-0.633323124633,11.1536902031,-1.78743546534,0.720418378196,-4.02583425997,-2.12415761535,0.427515063567,-0.909284869839,0.747159944344,0.375708067259,0.0131744476918,-1.20756426338,-0.487387505962,-1.99496346082,-1.54884987801,-0.782649601098,-0.481287671685,0.250012864858,1.53120233324,0.271252731468,0.2630143278,0.468455715107,-0.924387292827,0.393131035853,-0.388740273866,-0.0205663713385,-0.101635914096,0.0349926911702,-0.00474659772523,-0.373747130548,0.00449790744633,-0.053165032534,0.0593643351476,-0.19498223783,0.00233925563412,-0.0716373093209,0.431315085895,1.13540931933,0.711259167727,0.438877083951,-0.0941754210009,-0.529137829343,-0.554563216974,0.0276754800432,-0.130788756694,0.193994219084],[-36001.6613587,-1752.38222081,-349.647358797,-1764.82420939,-1346.22552533,1320.01819604,1105.50996541,726.88925633,-677.252862559,-66.5696740413,995.527047475,-19.3969812478,-728.472492944,-224.253596408,86.7948586447,-100.029532606,-92.5723482455,-19.9941711147,-652.095088122,-441.586581246,36.7936840073,-137.383161832,27.1820289263,-587.135522035,46.4784510596,74.4412327448,-130.806046768,149.780933199,-9.6120136941,194.212814518,-123.338006248,-212.25848952,-103.299141493,-69.2333661986,289.231793827,6.37920678986,10.9524725113,40.5652143562,15.6732821004,-14.0992814679,-65.0976200568,-63.4804912788,-102.702597452,-42.214422649,-33.1264785096,18.2580318966,-20.9272712133,-27.1265459809,-2.16916053019,-0.095642478527,1.97156512712,0.629706476742,-17.5362045322,-7.70299369476,-17.245426366,3.53565468897,-35.1787401231,-17.3734566171,-8.41817323067,-2.91361801863,20.9084048428,9.04820573862,19.0133498756,0.943577570401,-0.26117024111,-1.72005105635,1.54488024945,-0.305263906118,2.60160612446,-2.14275241357,-2.90881821401,-6.02945613714,-8.392484741,5.87122832582,-0.569124221892,11.0854230227,-1.68924816797,0.719946312474,-3.98347860329,-2.01071167949,0.403851052607,-0.917663910978,0.714681656159,0.35368558144,0.0257690795216,-1.26197307107,-0.479692140428,-2.01092700539,-1.48732843911,-0.77299485801,-0.428119338989,0.285612797198,1.53655094547,0.309499714715,0.276155460773,0.490534093201,-0.882636846276,0.408354969317,-0.383255592189,-0.0224625519275,-0.106120187042,0.025059015012,-0.01110080022,-0.370747434669,-0.00549629358601,-0.0494407027401,0.04361351575,-0.180794940513,0.00258532676854,-0.0595848733449,0.433666306762,1.13470347663,0.718555821919,0.444082783261,-0.0816953499856,-0.513400179455,-0.544087562557,0.0302002895105,-0.135793390813,0.192932808812],[-36092.6166469,-1711.06794153,-271.278670029,-1793.36192698,-1339.31265292,1320.66897816,1123.18852519,721.401478287,-691.893478446,-46.0242101538,987.900318824,5.30365497636,-749.736596675,-266.02014046,67.1075507519,-100.094584388,-82.4817232996,-20.9696873349,-647.354503453,-449.056594902,26.3969703494,-136.256539217,40.367306912,-577.729912559,49.207472793,75.1071808983,-126.748713411,146.672349379,-12.0721833681,193.524266948,-119.623759502,-210.461498206,-100.102691549,-66.7658027432,283.618892335,6.41807400414,11.0875674968,41.3561665312,15.594931112,-15.206631997,-64.5239475276,-62.6850537105,-102.378030311,-41.3960067721,-32.7517171799,17.5593167605,-20.311012468,-26.7551948044,-2.1838697023,0.0291918351925,2.23770363043,0.468339999566,-17.3577984834,-7.97465719822,-17.152556348,3.32699318235,-34.6433282565,-17.252598506,-8.28821928133,-2.58334082863,20.8313261787,9.13713135169,18.965443428,0.846313548058,-0.271688346334,-1.72815157585,1.50305645303,-0.262088186187,2.43492155214,-2.10619601602,-2.95106170215,-5.86136470938,-8.33927680763,5.9777334814,-0.510779599744,11.0134442939,-1.58667517302,0.716626864374,-3.9371069838,-1.89504003741,0.377565482951,-0.923458161554,0.682501481673,0.332461447908,0.0408371081807,-1.31468715138,-0.472519632199,-2.02213939701,-1.42529867144,-0.76225269493,-0.373479741529,0.319255502771,1.54094215265,0.348376167595,0.287666213788,0.512701018384,-0.840936867191,0.422840863162,-0.377450256821,-0.0249217231768,-0.110238389674,0.014422022518,-0.0169978420598,-0.366502999835,-0.0152674293355,-0.0454694119638,0.0289406428806,-0.166287385688,0.00338733243018,-0.0472988798511,0.435472680346,1.13356113473,0.725616135985,0.448325617091,-0.0688138702201,-0.497970187511,-0.533245053054,0.0326426874634,-0.140973874233,0.191891329524],[-36180.7417029,-1665.20485193,-198.650370506,-1825.02791458,-1332.50428966,1317.91071781,1139.94871556,716.163537488,-707.244803548,-25.1492229931,978.024061328,28.590634298,-769.438308707,-306.936904533,48.055568839,-99.3567302513,-73.6247113568,-21.9705682705,-642.631304616,-456.095632558,16.0983116063,-134.258010738,53.5671663222,-568.485463039,52.3492741151,75.4819403411,-122.892684911,143.539137983,-14.6928261835,192.955907451,-115.8397554,-208.481593097,-96.739897463,-64.3399732287,277.856533146,6.5322337794,11.2725732247,42.1310349388,15.4482743876,-16.4247477353,-63.8570482155,-61.9114068973,-102.004618898,-40.5212586699,-32.4294061816,16.8860942757,-19.7131299235,-26.3544849315,-2.17847627642,0.197698935764,2.52663052313,0.304224400181,-17.1752426767,-8.23199826644,-17.079483556,3.1312096308,-34.0939702832,-17.1622940959,-8.13590730509,-2.26789306335,20.7433444432,9.23823867437,18.9132344731,0.745426155446,-0.267851312395,-1.73214925685,1.46228446178,-0.213162143924,2.27476198168,-2.07794632893,-2.98436969492,-5.69084684908,-8.28644936876,6.08667826052,-0.457710600455,10.9402146353,-1.48084611347,0.712956415758,-3.88686466691,-1.77836011304,0.349045394595,-0.926696597935,0.650971848236,0.311944834723,0.0579817946893,-1.36564540354,-0.465741217672,-2.02909446339,-1.36310325438,-0.750361047421,-0.31786879475,0.351328700566,1.54499615897,0.38778628707,0.298246389179,0.534983573349,-0.799753117467,0.436368063879,-0.371427711629,-0.027889624518,-0.113919521758,0.0031845956246,-0.0223851381522,-0.361157552221,-0.0248229425076,-0.0412454957289,0.0152676225208,-0.151476004216,0.0047275204704,-0.0348848170617,0.436879065547,1.13222524734,0.732477733616,0.451811764758,-0.0556136807986,-0.48287898428,-0.522223679968,0.0350507812671,-0.146241921722,0.190882908486],[-36263.9881626,-1619.30961683,-131.735201239,-1858.61761176,-1325.63848033,1312.30548901,1154.6787377,709.791616371,-722.648975339,-4.00744297104,966.316819035,49.6685073387,-787.755762196,-346.424880552,29.622017469,-97.7254570737,-66.1452220206,-22.8985870272,-638.009708996,-462.674884139,5.93946786224,-131.645237816,66.5977876664,-559.601512415,55.8687472312,75.5781240176,-119.300870481,140.424645266,-17.4444227036,192.501100431,-112.070337061,-206.332617124,-93.2505373682,-61.9023622024,272.011876527,6.71478483986,11.5028315367,42.8740939073,15.2342798041,-17.7376812637,-63.1182408818,-61.1722204009,-101.582473353,-39.6175680292,-32.1372670811,16.2437512757,-19.1465305065,-25.9389829464,-2.15373826982,0.405699760966,2.83377788535,0.136246663553,-16.9903379009,-8.47779283434,-17.0268379126,2.9516498622,-33.5392106561,-17.0949571104,-7.96389574493,-1.96574052406,20.6440656573,9.3517821705,18.8621571854,0.642108624467,-0.250264642711,-1.73278119676,1.42202216053,-0.159873395219,2.12210275296,-2.05687158463,-3.00899107481,-5.51915203302,-8.23276321766,6.1975286324,-0.409045251395,10.8680215979,-1.37294460019,0.711408669016,-3.83295634384,-1.66185232049,0.318774382959,-0.927526407945,0.620496904746,0.291989079951,0.0767652812471,-1.41476484232,-0.45917402836,-2.03235670784,-1.30104992005,-0.737215113993,-0.26176096308,0.382336977294,1.54928576338,0.427613193749,0.308628258475,0.557405636206,-0.759512089602,0.448737577924,-0.365316976674,-0.0312901209034,-0.117094497529,-0.00852594549329,-0.0272541860184,-0.35487718675,-0.0341526139197,-0.036773085341,0.00251868902317,-0.136354333778,0.00658083239374,-0.0224306207363,0.43804943377,1.13093264606,0.739183433914,0.454757469862,-0.0421778585284,-0.468139497647,-0.511208579756,0.037463995799,-0.151510821882,0.189915838639],[-36340.6010406,-1574.39506348,-70.3300294405,-1893.10371658,-1318.16275191,1305.14194663,1166.65056179,701.62219015,-737.679736283,17.3296705095,953.248434183,67.8874774271,-804.851980649,-384.148561722,11.7286382909,-95.1522379338,-60.1714954629,-23.6803505102,-633.581741457,-468.771483114,-4.06163353042,-128.674060077,79.2949753549,-551.232152884,59.7275675211,75.3994876115,-116.03938618,137.37296155,-20.2923796371,192.140491114,-108.409366282,-204.046488942,-89.6730105467,-59.4079141343,266.157951714,6.95733130527,11.7698354094,43.5689381876,14.9540797536,-19.1324678715,-62.3318435328,-60.4841955195,-101.114405739,-38.7112429144,-31.8500905963,15.6374771379,-18.6231839956,-25.5259701035,-2.10999064472,0.648125857001,3.15381889058,-0.0364825838822,-16.8057133616,-8.71495642613,-16.9951062767,2.79094638638,-32.9881457713,-17.0425745192,-7.77433272839,-1.67552345574,20.5336409794,9.47772640138,18.8178778806,0.537797754999,-0.219793522519,-1.73067608182,1.38163862977,-0.103784539952,1.9778916581,-2.0419791938,-3.02549154549,-5.34755331218,-8.17689250596,6.31006960282,-0.363551544741,10.7989464362,-1.26426404632,0.714154556546,-3.77574455712,-1.54673263863,0.287312785922,-0.926091099399,0.591540656946,0.272424932751,0.0967304818411,-1.4619723651,-0.452650019362,-2.03249966547,-1.23942566536,-0.722651905702,-0.205581439812,0.412836509507,1.55434415648,0.467693691731,0.319560395783,0.580033538449,-0.720540891562,0.459841966865,-0.359274093016,-0.0350396992015,-0.11968143714,-0.0205608223858,-0.0316218103459,-0.347813764517,-0.0432322163888,-0.0320672794333,-0.00937408490195,-0.120918678352,0.00891679446771,-0.0100192543583,0.439161390767,1.12991557869,0.74577240389,0.457383154667,-0.0286015095443,-0.453755495521,-0.500384783544,0.0399078930834,-0.156708214929,0.189001600968],[-36408.2112474,-1528.54510734,-15.0476872752,-1927.48815277,-1308.96613623,1298.50934475,1176.02367813,691.996735502,-752.175666799,38.8275391973,939.339934889,82.8135663733,-820.701497771,-420.047356816,-5.64381334492,-91.6619395769,-55.8050985196,-24.264806668,-629.424811315,-474.341309572,-13.8612132994,-125.553084086,91.5358997625,-543.478747878,63.8812890961,74.9395473623,-113.173111315,134.427962174,-23.1948651252,191.847584257,-104.938064109,-201.672869029,-86.0302029515,-56.8268506616,260.378141887,7.25105089234,12.0605641718,44.1987284542,14.607868429,-20.6001772892,-61.5219048475,-59.8644215856,-100.606533775,-37.8237330141,-31.5442879158,15.0717384705,-18.1543911287,-25.1338022391,-2.04692765203,0.918983845268,3.48066983011,-0.214748498125,-16.625610356,-8.94604075663,-16.9846654747,2.65068889551,-32.4492240927,-16.9976160428,-7.56738548765,-1.39628740954,20.4140666255,9.61595193198,18.7858564673,0.434162929684,-0.177469807763,-1.7263698795,1.34036828294,-0.0467866861156,1.84292453614,-2.03263028064,-3.03475632513,-5.17718509264,-8.11774111133,6.42462620033,-0.319990234111,10.7349267817,-1.15640249146,0.722876838204,-3.71591345881,-1.43416196943,0.255273336077,-0.922495849646,0.564599184883,0.253058655333,0.117385017632,-1.50723541176,-0.446088996051,-2.0300722584,-1.17850872739,-0.706506880796,-0.149614327592,0.443335114607,1.56071445319,0.507784286079,0.331757443012,0.602968768578,-0.683065894468,0.469686977344,-0.353491236248,-0.0390564057045,-0.1215898321,-0.0327536116337,-0.0355272139279,-0.340099077481,-0.0520387274371,-0.0271721084568,-0.0204570953595,-0.105178087357,0.0116931808894,0.00228167605248,0.44038419195,1.12940438982,0.752241686348,0.459915302544,-0.0150165411793,-0.439717800038,-0.489934550337,0.0423971828137,-0.161783370013,0.188163801733],[-36463.7810465,-1479.55508428,34.0960203766,-1960.68508698,-1296.61476252,1294.97793422,1183.03130232,681.341815176,-766.113491989,60.5449530588,925.149566703,94.2124185039,-835.116603409,-454.160761639,-22.4270833692,-87.33480583,-53.1003416676,-24.579120744,-625.586723378,-479.283289832,-23.442243213,-122.468471791,103.181862182,-536.407434253,68.2720319155,74.1907274121,-110.757373985,131.642564127,-26.1052651614,191.585966505,-101.725594408,-199.274044877,-82.33776765,-54.1332207566,254.750125249,7.58611012502,12.3614746133,44.7463358265,14.1990550188,-22.1331502739,-60.7100585578,-59.3286543609,-100.069144888,-36.9709472139,-31.2005066129,14.5523468558,-17.749563127,-24.7782433627,-1.96375778723,1.21158590062,3.80769033423,-0.398323157584,-16.4544629521,-9.1728986119,-16.9954485844,2.53001709614,-31.9293910608,-16.9532793989,-7.34221514285,-1.12688186627,20.2873179813,9.76571682213,18.7703235909,0.332897054529,-0.124778939806,-1.72035765891,1.29742029109,0.00905591431068,1.71793820322,-2.0284326641,-3.03788048938,-5.00887262943,-8.05423082498,6.54177640566,-0.277110290288,10.6775563234,-1.05098379486,0.739002586245,-3.65405622779,-1.3250806726,0.223272701424,-0.916888461671,0.540096937792,0.233661026997,0.138196938042,-1.55047298812,-0.439404999549,-2.02555938744,-1.11848508633,-0.688618031645,-0.0939780326769,0.474296757331,1.56895946863,0.547564902426,0.345844016053,0.626282136888,-0.647290691121,0.47827161861,-0.348167083967,-0.0432491829803,-0.122735809002,-0.0449373055976,-0.039051758315,-0.331846681645,-0.0605425738944,-0.0221434677846,-0.0307658977907,-0.0891328043656,0.014854691995,0.0144516268686,0.441878330074,1.12960374622,0.758555039129,0.462549891726,-0.00155776723102,-0.426015605529,-0.480002261435,0.0449320317392,-0.166688080214,0.187422361759],[-36504.1792069,-1427.3920392,77.7360492698,-1991.52773649,-1280.1643809,1296.91327506,1186.93591378,670.205892181,-779.4569023,82.5109424835,911.24722548,101.744369991,-847.837359179,-486.6381385,-38.5298427704,-82.2632740627,-52.0370545277,-24.5372550607,-622.140629357,-483.448438524,-32.8756170186,-119.596623422,114.053407568,-530.082580554,72.8314366915,73.162571861,-108.828551786,129.072635607,-28.974116915,191.303927394,-98.8372438361,-196.931334961,-78.6239279936,-51.31126733,249.340305936,7.95085689364,12.6633428175,45.1978006219,13.7383709467,-23.7221993573,-59.9192145693,-58.892087633,-99.5192483383,-36.1679637488,-30.8052908097,14.0855642096,-17.4158611689,-24.4746018569,-1.86035888762,1.5193265469,4.12808116371,-0.584975572614,-16.2966178064,-9.39650267615,-17.0265519637,2.42574961029,-31.4345761672,-16.9042028893,-7.09893160629,-0.866228528886,20.1535401567,9.92542643533,18.7741034715,0.235651006996,-0.0637760467337,-1.71323163312,1.25233012221,0.0617553563937,1.60379880872,-2.0287714254,-3.03610388274,-4.84324849675,-7.98549231334,6.6619484999,-0.233706879313,10.6276326432,-0.949525241392,0.763420325941,-3.59056245867,-1.22035652818,0.191917668547,-0.909591845566,0.51831901544,0.214003562497,0.158617558879,-1.59149372673,-0.432445208873,-2.01937749912,-1.05939873221,-0.668848037178,-0.0387574953577,0.506147228957,1.57944459469,0.586654346259,0.362210406941,0.650034195475,-0.613431370551,0.485579371719,-0.343498477321,-0.0475161841827,-0.12307276935,-0.0569607600612,-0.0423210515549,-0.323175833693,-0.0687034193121,-0.0170330306539,-0.0403072917545,-0.0727587748924,0.0183453228254,0.0265045088013,0.443784178349,1.13066215194,0.764668235713,0.465405535032,0.0116692465361,-0.412658949647,-0.470694397437,0.0474866261148,-0.171369463364,0.186788709531],[-36526.0134604,-1370.70085293,116.344096993,-2018.84726815,-1258.60487584,1305.91611182,1186.90644448,659.177242943,-792.15544371,104.689658951,898.12883364,105.17078301,-858.567863824,-517.558201339,-53.7371240944,-76.5570062931,-52.5825611581,-24.0702038209,-619.135394123,-486.674227743,-42.2254114558,-117.054472549,123.978670342,-524.540361961,77.4871237319,71.8722996803,-107.402068714,126.770748535,-31.7545964653,190.961877888,-96.325142141,-194.723708779,-74.9104117832,-48.3570564316,244.220242677,8.33554371355,12.9603228031,45.5452616316,13.2391438775,-25.3578167606,-59.1709949527,-58.5684316487,-98.9749988742,-35.4231804833,-30.350762241,13.6839546676,-17.1582746097,-24.2374799313,-1.73687284454,1.83657137803,4.43568885301,-0.772411248784,-16.1567764076,-9.61734350699,-17.0772179971,2.33450028876,-30.9683652449,-16.8463286383,-6.83671651977,-0.613705359024,20.0121587217,10.0923775837,18.7992788936,0.144056531997,0.00343466885509,-1.70571506319,1.20480909064,0.109561892758,1.5011511458,-2.03285353075,-3.03070022022,-4.68070574507,-7.91092804383,6.78584068963,-0.188899038775,10.5857308075,-0.853661776141,0.796691878142,-3.52572019877,-1.12073074446,0.161737499059,-0.901011908014,0.499392855723,0.193899704946,0.178192715675,-1.63013112188,-0.425046131925,-2.01193991549,-1.00124577061,-0.647097377738,0.0160070576268,0.539186652669,1.59244353182,0.624575412577,0.381098628069,0.67426225045,-0.58165991418,0.491568927682,-0.339684912249,-0.0517781856594,-0.122585680659,-0.0686986195345,-0.045454382509,-0.314197482188,-0.0764926676494,-0.0118778445701,-0.0490884130928,-0.056046428874,0.0221154970023,0.0384635426899,0.446207898867,1.1327077864,0.770527151126,0.468566532461,0.0245681764348,-0.399658206607,-0.462109913097,0.0500117506623,-0.17577656088,0.186272860158],[-36527.4548535,-1307.71226677,150.930016365,-2041.78546246,-1231.57799359,1322.41471332,1182.08873729,648.8621547,-804.180189878,126.853468019,886.152016116,104.499281658,-866.983945433,-546.840285309,-67.7880841221,-70.2996768452,-54.7075004512,-23.1075254921,-616.598078993,-488.831688266,-51.5733768255,-114.894554055,132.784346065,-519.743611292,82.1790378689,70.3442603277,-106.469723422,124.773627435,-34.410458899,190.540011818,-94.2234741913,-192.71399564,-71.2104256528,-45.2775653343,239.448021381,8.73416891898,13.2501050296,45.7890982392,12.7148679864,-27.0293515441,-58.4822050452,-58.3684522517,-98.4555032835,-34.7377773309,-29.8353422914,13.3652168886,-16.9789518667,-24.07627639,-1.59396300378,2.15927116386,4.7255727818,-0.95862382953,-16.0387000257,-9.8358528747,-17.1470307058,2.25263221827,-30.5317901797,-16.7769729923,-6.55452879643,-0.369695726254,19.8617191918,10.262888251,18.8464448267,0.0594250062679,0.0750267465449,-1.69868581465,1.1547182441,0.151225321859,1.41029390768,-2.03983629397,-3.02297268018,-4.521391185,-7.83036275887,6.91426588782,-0.142301741677,10.5522727271,-0.764708015011,0.839021581999,-3.45959669104,-1.02683042128,0.133150268226,-0.891554720009,0.483251653573,0.173224765684,0.19662985654,-1.66632210581,-0.417066928388,-2.00370257549,-0.943998476411,-0.623374114516,0.070339242294,0.573561010281,1.60807674571,0.660812978968,0.402562851918,0.698915596951,-0.552089515381,0.496188075993,-0.336853912398,-0.0559769836578,-0.12129900479,-0.0800671753297,-0.0485504123549,-0.305017591157,-0.0839034123633,-0.00669430366729,-0.0571339247936,-0.0390013274701,0.0261182851822,0.0503515417899,0.449207744609,1.13581171242,0.776062145357,0.4720811734,0.0370806524425,-0.387023518136,-0.454305113314,0.0524406242317,-0.179865961028,0.185869864618],[-36510.2956367,-1238.56601927,182.38038463,-2059.86876817,-1199.79436652,1345.74536927,1172.05273898,639.514871537,-815.399401423,148.606598438,875.526913446,99.9687856204,-872.842226457,-574.397366815,-80.4635481274,-63.4959757096,-58.3710739845,-21.5663604553,-614.523541223,-489.871298698,-61.0022425185,-113.142883701,140.312723099,-515.60561501,86.8694869782,68.6184796684,-105.998297779,123.107369188,-36.9200695594,190.037466613,-92.5571099276,-190.947602416,-67.5239579253,-42.0889216663,235.068532816,9.14320822167,13.537148298,45.9391494947,12.1780332728,-28.7232929329,-57.863272325,-58.2992856855,-97.9816145698,-34.1055911356,-29.2641794828,13.1465871786,-16.87921661,-23.995972918,-1.43406630538,2.485307996,4.99443545679,-1.14181074858,-15.9437509187,-10.0520192888,-17.2356779332,2.17635418264,-30.1240636962,-16.6952062705,-6.25112334756,-0.135805796213,19.7003904114,10.4333812125,18.9146129039,-0.0177779184076,0.149423782157,-1.6931278188,1.10213556055,0.186358782166,1.33125457774,-2.04880405314,-3.01428165495,-4.3651826438,-7.74417551409,7.04814465607,-0.0940883565746,10.5274285292,-0.683694859419,0.890124412297,-3.39221865299,-0.939168832574,0.106405260544,-0.881670551268,0.469619049559,0.151949726091,0.213828202798,-1.70011542413,-0.408307676819,-1.99515001436,-0.887599143987,-0.597839413168,0.124326684712,0.609193787807,1.62624005161,0.694892791065,0.426401713057,0.72392771756,-0.524823599779,0.499418830785,-0.335100917757,-0.0600586118888,-0.11930295605,-0.0910378206244,-0.0516848408863,-0.29574641082,-0.0909475491565,-0.00146705163667,-0.0644744628803,-0.0216404815652,0.0303009245983,0.0621883722106,0.452802882508,1.13998184796,0.781202711092,0.475949652314,0.0491920603571,-0.374784325311,-0.447289596755,0.0547033693948,-0.18360740962,0.185571829033],[-36478.8662548,-1164.54791647,209.890588428,-2072.81436617,-1164.72988602,1374.56000924,1157.05021183,631.056824141,-825.571165017,169.484629277,866.283390247,91.9441836393,-876.052689519,-600.259501916,-91.5282165002,-56.0788016083,-63.5131159247,-19.3857391933,-612.8955338,-489.811435962,-70.5538145414,-111.797302836,146.455388921,-512.020880891,91.5375470939,66.7437060164,-105.931729276,121.790323569,-39.2726609331,189.465000144,-91.346295244,-189.455007213,-63.8364856843,-38.8164833939,231.128115328,9.55928422818,13.8324592329,46.0116544988,11.6409419935,-30.4253382708,-57.3197050686,-58.3639833063,-97.5711081178,-33.5136687839,-28.6483324938,13.0419152107,-16.8616299594,-24.00025363,-1.26100713273,2.8141214042,5.24015742565,-1.32064592101,-15.8710670705,-10.265047562,-17.3426206475,2.10268675108,-29.7436351056,-16.6018875654,-5.92510578237,0.0852073948574,19.5270808707,10.6009033255,19.0016329023,-0.0878386296369,0.225061115508,-1.6899806656,1.04734754673,0.215261864075,1.26388600672,-2.05891710018,-3.0059465843,-4.2118374815,-7.6531189627,7.18837386262,-0.0450466338291,10.5110714959,-0.611751443781,0.949216445059,-3.32387798153,-0.858109100042,0.0815782708588,-0.871826003191,0.458048044944,0.130143698215,0.229796197719,-1.73162469409,-0.398520344433,-1.98672885023,-0.831966867546,-0.57074900287,0.178047713848,0.645701551204,1.64667815401,0.726357566268,0.452249186316,0.749264316372,-0.499991303808,0.501303712932,-0.334549806111,-0.0639663232972,-0.116736203235,-0.101625138821,-0.0549195122067,-0.286491224231,-0.0976471637856,0.00384756309079,-0.071148123844,-0.00401080044561,0.034602621968,0.073979130935,0.456970655189,1.14518434367,0.785879626075,0.480137850107,0.0608919127315,-0.363000975813,-0.441058722393,0.0567347244407,-0.186976251953,0.185384708205],[-36437.6821226,-1086.4423206,231.028794866,-2080.45874832,-1127.94316788,1407.17675606,1138.05203085,623.356570429,-834.517205327,189.041801989,858.339606581,80.9015369814,-876.704823506,-624.499718828,-100.756430455,-47.967549126,-70.0477801943,-16.5423869971,-611.69550045,-488.705527723,-80.2176023097,-110.800209004,151.182582528,-508.848775251,96.1722759924,64.7673606586,-106.200848694,120.827348598,-41.4601634068,188.840438962,-90.592903242,-188.250610712,-60.1181596274,-35.4964057584,227.670534683,9.98097071735,14.147240878,46.0267853437,11.1149476846,-32.119970705,-56.8551490403,-58.5603120144,-97.2343786543,-32.9434125934,-28.0012022124,13.0615786275,-16.9276955202,-24.0904480665,-1.07908738363,3.14583583513,5.46126057714,-1.49389108084,-15.8181684006,-10.4738805443,-17.4665607998,2.03007461754,-29.3877802189,-16.4990798926,-5.57531133484,0.2895588854,19.3422860723,10.762985917,19.1048722477,-0.1513955343,0.300484079965,-1.69003655288,0.990740385924,0.238729034718,1.20770783539,-2.06933731698,-2.9991996342,-4.06113295932,-7.55812297948,7.33573293999,0.00350250703925,10.5029931405,-0.549938194444,1.01512469156,-3.25516271463,-0.783938970477,0.0586319177982,-0.862461400277,0.448019461162,0.107921575456,0.244602097874,-1.76102008467,-0.387465590931,-1.97888841882,-0.777033475101,-0.542385361244,0.231576555886,0.682485912511,1.6690993403,0.754752240172,0.479720099819,0.774851560023,-0.477709543043,0.501944936831,-0.335295205872,-0.0676559617847,-0.113757321715,-0.111862929639,-0.0583062529465,-0.277369456511,-0.104027906864,0.00930862880582,-0.0772233337276,0.0138204196699,0.0389563562557,0.0857259136832,0.461638243008,1.15137160387,0.790010534436,0.484618503849,0.0721523031302,-0.351759535132,-0.435603199577,0.0584689739188,-0.189958387041,0.18532365571],[-36390.4235034,-1005.59236886,241.559518024,-2082.77607916,-1090.76641462,1441.74201314,1116.10182873,616.067425219,-842.217782788,206.925452192,851.530717626,67.292486415,-875.130502454,-647.168626815,-108.080839199,-39.1199897809,-77.8183918845,-13.0664319977,-610.914698663,-486.623817091,-89.9181969917,-110.07834114,154.563487502,-505.905351483,100.769525296,62.7430369309,-106.73603356,120.216451904,-43.4676803962,188.188178065,-90.2710270547,-187.332135672,-56.3240015216,-32.1747262588,224.729846398,10.4123007766,14.4901534992,46.0080374011,10.6129873212,-33.7861360596,-56.4741188707,-58.8810968354,-96.9724757356,-32.3726740296,-27.3369617201,13.2102986521,-17.0756393038,-24.2674397031,-0.892730929083,3.48052407595,5.65714956616,-1.65886089547,-15.7816325123,-10.6779345137,-17.6049770427,1.95896418648,-29.0525869671,-16.3896260513,-5.20181986173,0.47275928549,19.1474257993,10.9176572607,19.2221254914,-0.209192933874,0.374411148273,-1.69381119556,0.932857604265,0.257958634687,1.16172870414,-2.07900496962,-2.99499831652,-3.91307668766,-7.46045760599,7.49062496165,0.0497444940635,10.5026308642,-0.498943235431,1.08645013033,-3.18699676026,-0.716959117003,0.0374416876905,-0.854026335174,0.43900883015,0.0853756893201,0.25834644798,-1.7885043262,-0.374953168896,-1.97214261196,-0.722818840618,-0.512998708388,0.284958047584,0.718838684063,1.69313362787,0.779696725951,0.508480401613,0.800537835419,-0.45804295578,0.501502277237,-0.337364186234,-0.0711317942625,-0.110537803551,-0.121794482723,-0.0619129916205,-0.268541164926,-0.110104722294,0.0149623831884,-0.082793520005,0.0317771150795,0.0433258762482,0.0974459358997,0.466671323718,1.1584783007,0.79351091664,0.489399872712,0.0829229670608,-0.341157974182,-0.430915567516,0.0598266604425,-0.192557763166,0.185399481618],[-36339.551398,-924.999848961,238.420007991,-2080.09663127,-1054.08609924,1476.99217971,1092.38937164,608.814488723,-848.857781442,222.932481389,845.669103149,51.581319504,-871.694755378,-668.273972272,-113.468394602,-29.5596528468,-86.6173217007,-9.0431828877,-610.558381589,-483.600516845,-99.5003088644,-109.544435135,156.71484957,-502.993945106,105.325590553,60.7203516414,-107.475360432,119.958659543,-45.2707309293,187.548817595,-90.3231399025,-186.691678956,-52.3927586978,-28.9070793399,222.336584563,10.8639009146,14.8669869368,45.979154438,10.1500036127,-35.3977054113,-56.1807867092,-59.3122146226,-96.7799146341,-31.773867674,-26.6749860524,13.4881026485,-17.3010251944,-24.5326548074,-0.70508999655,3.81785645831,5.82790327545,-1.8121603005,-15.7576364559,-10.8770323022,-17.7542676054,1.89139340522,-28.7332523658,-16.2777800024,-4.80575567132,0.631044530659,18.9447173757,11.0639495015,19.3510110753,-0.261846399983,0.445721962335,-1.70146058299,0.874194019589,0.274313118509,1.12445878809,-2.08696740661,-2.99394066687,-3.76774845269,-7.36178250215,7.65346726672,0.0916593537586,10.5092277108,-0.459175092338,1.16161551519,-3.12074780899,-0.657401181257,0.0177889336718,-0.846886743614,0.430529858184,0.062525684129,0.271116781816,-1.81435392912,-0.360860790389,-1.96702773535,-0.669415555256,-0.482808441403,0.33826818858,0.753946905431,1.71839751152,0.800886658964,0.538250062533,0.82609767537,-0.441063492995,0.500193786801,-0.340763270857,-0.0744532283786,-0.107231952209,-0.131464178141,-0.0658359842421,-0.260186402256,-0.115892428208,0.0208371408813,-0.0879539019589,0.049751726329,0.0477132289965,0.109193261768,0.471891791522,1.16645532172,0.796311767903,0.494531344064,0.0931212439675,-0.331299882748,-0.426990160916,0.0607338825025,-0.194779402193,0.185630280605],[-36287.0933101,-845.935335362,220.973212321,-2073.25605651,-1018.09433262,1511.85071124,1068.17251418,601.134066284,-854.917558734,236.980481316,840.499176024,34.4773418949,-866.658420157,-687.568742625,-116.966724289,-19.4187002145,-96.2458116,-4.57371845976,-610.630319485,-479.65161457,-108.757782095,-109.109561135,157.748071198,-499.923036729,109.821156086,58.7211330077,-108.357212219,120.050571885,-46.8466893445,186.990969252,-90.6697472032,-186.296879703,-48.2760428292,-25.7466770973,220.507359499,11.348695999,15.2751339973,45.965273611,9.73999000199,-36.9265680566,-55.9725688699,-59.8331162156,-96.6423584186,-31.1191264865,-26.0371981893,13.8940406625,-17.5946842692,-24.8839957672,-0.517591977171,4.15565986387,5.97431295399,-1.95123041697,-15.7419350758,-11.0705422056,-17.9101350005,1.83238057595,-28.4251940136,-16.1671459362,-4.39018067135,0.762303559491,18.7361352383,11.201382813,19.4879571495,-0.309575631661,0.513201451899,-1.71304768045,0.814802393992,0.289267900122,1.09429318182,-2.09246840246,-2.99573356063,-3.62520228381,-7.26351704811,7.82436684792,0.127573909832,10.522179094,-0.430389388149,1.23903436071,-3.05788896405,-0.605421017086,-0.000472019216645,-0.841275925454,0.422074944907,0.0392395234885,0.28302629627,-1.83894729169,-0.345100184859,-1.9640159115,-0.616887101531,-0.451930338017,0.391577441632,0.78706217267,1.74453816355,0.81817210301,0.568726912749,0.85118334815,-0.426866581045,0.498217344674,-0.345417674394,-0.0776743670656,-0.103943963699,-0.140922879819,-0.0702138112962,-0.252482281106,-0.121445451415,0.0269494200226,-0.0928045436424,0.0676423805274,0.052162868869,0.121052991699,0.47714007534,1.17526534338,0.798398955568,0.500088290553,0.102672409711,-0.322283306994,-0.423797048188,0.0611372339465,-0.196613452711,0.186023230433],[-36236.4628926,-768.900787796,189.924839097,-2063.26782568,-983.455469238,1545.11047435,1043.98475286,592.528392237,-860.912296687,248.840502388,835.608683707,16.6497875695,-860.303279776,-704.682575279,-118.880399705,-8.86288378506,-106.516039399,0.202292638778,-611.208664307,-474.843081418,-117.508353789,-108.720482352,157.738269202,-496.529254838,114.241455022,56.7573452198,-109.315872288,120.468821495,-48.1865254401,186.579884569,-91.2328817598,-186.106324666,-43.9692687582,-22.7424063356,219.241635468,11.8812302241,15.7121921377,45.9924794446,9.39791036558,-38.3461434205,-55.8441215906,-60.4234198518,-96.5407209605,-30.3896019136,-25.4445102398,14.4242133836,-17.9401030022,-25.3162703804,-0.330804664318,4.49196483757,6.09800403018,-2.07243346913,-15.7297619898,-11.2572943452,-18.0684266279,1.7888771467,-28.1260545379,-16.0603945207,-3.96163770946,0.866180975158,18.5225752,11.3295133715,19.628303606,-0.352580422783,0.575740279308,-1.72866271555,0.754986548089,0.304592039048,1.06988907626,-2.09489065251,-2.99944106411,-3.48575632499,-7.16679731517,8.00227970337,0.156556702826,10.5406839044,-0.41144967352,1.31701719039,-2.9998377716,-0.561164043256,-0.0175050935515,-0.837379851887,0.413115212286,0.0153634971646,0.294235839217,-1.8625577769,-0.327542102882,-1.96349081739,-0.565242291951,-0.420394999953,0.444821828772,0.817612575135,1.77116485513,0.831650598346,0.599535876633,0.875363238692,-0.41552247604,0.495720352079,-0.351090195845,-0.0808417462738,-0.100770136426,-0.150216050995,-0.0752042202619,-0.245590997598,-0.12681602623,0.0333279208103,-0.0974486119182,0.0853831917129,0.0567388137685,0.133129227962,0.482306048893,1.18484891318,0.799845369051,0.506143194115,0.11154226112,-0.314197676919,-0.421278192589,0.0610182343394,-0.198032128348,0.186564313655],[-36191.6393731,-694.45452373,146.528789533,-2050.89952404,-951.464263533,1575.58799597,1019.8124338,582.514561238,-867.300076032,258.211950611,830.470330594,-1.33022848812,-853.08124721,-719.36555691,-119.898348741,1.91490547482,-117.210925478,5.09500463725,-612.456896269,-469.330351876,-125.615617787,-108.353470423,156.748387318,-492.694588595,118.581695894,54.8363847248,-110.27726518,121.172027976,-49.2936317059,186.368861758,-91.9334401649,-186.081477435,-39.5134362008,-19.946761235,218.524308283,12.4761750414,16.1758671949,46.089029587,9.14044566473,-39.6324174248,-55.7893970907,-61.0631523791,-96.4524555832,-29.5754290697,-24.9144771351,15.0680468802,-18.3116949067,-25.8233102784,-0.145036513038,4.82511268817,6.2012738727,-2.17056793761,-15.7158945441,-11.4352050786,-18.2249905211,1.7699621486,-27.8355174153,-15.9594012164,-3.53048883442,0.943977013697,18.3047381397,11.4484794038,19.7664541354,-0.39113726849,0.632417581639,-1.74861580527,0.695348776154,0.322598860712,1.05025507784,-2.09382192188,-3.00376958388,-3.34989842911,-7.07251249271,8.18497940232,0.178499482214,10.5636747481,-0.400350363734,1.39333471162,-2.94818292681,-0.524802849371,-0.033530884646,-0.835374406667,0.403123673626,-0.00931351946353,0.304960455245,-1.88536301126,-0.308065751513,-1.96579901035,-0.514416833542,-0.388125355255,0.497788389818,0.845193114207,1.79779819795,0.841668394557,0.630240301379,0.898168256049,-0.407000201948,0.492876663034,-0.357358039754,-0.0840007418567,-0.0978007395249,-0.159381384025,-0.080980345345,-0.239662462148,-0.132056034016,0.0400087767744,-0.101994379479,0.102946484348,0.0615038645955,0.145546073344,0.487325695684,1.1951337307,0.800813032554,0.512781708902,0.119740861373,-0.307126363957,-0.419358580585,0.060400383607,-0.199002869398,0.187230743591],[-36156.1240421,-625.2389504,92.9931785096,-2036.57564396,-923.619431058,1602.67509781,995.980021284,570.755622369,-874.404558295,264.887060234,824.480363556,-18.9506179508,-845.567614336,-731.513615022,-120.968078112,12.7175029571,-128.106382324,9.87821963087,-614.574281003,-463.296114204,-132.936034177,-108.023757836,154.837827906,-488.407951784,122.841247026,52.9557637331,-111.164036625,122.113920903,-50.1781959049,186.400124762,-92.6919780921,-186.198505015,-34.9761376119,-17.4130350418,218.3473488,13.1476104028,16.6625135538,46.2832723618,8.982781947,-40.7645732531,-55.8039110728,-61.7310431734,-96.3521373939,-28.6715139301,-24.4617721207,15.8100798902,-18.6776214076,-26.4000398357,0.0399701568826,5.15345492596,6.28649849974,-2.24053219562,-15.6948655801,-11.6017491734,-18.3755734648,1.78620227592,-27.5540840137,-15.8655457942,-3.10893245923,0.99940415186,18.0841418201,11.5599958738,19.8962891572,-0.425475115912,0.682503228262,-1.77346954446,0.636374504956,0.345950257496,1.03462215598,-2.089125506,-3.00724452069,-3.21800287944,-6.98117309665,8.36965068097,0.193882587479,10.5898892147,-0.394743362287,1.46521102842,-2.90488786095,-0.496417690343,-0.0488190335029,-0.835382288137,0.391614757498,-0.0350938069962,0.315425159098,-1.90751630589,-0.286606368812,-1.97127449718,-0.46429612806,-0.354917680807,0.550155521609,0.869483492811,1.82390757896,0.848741718799,0.660398895598,0.919159428934,-0.401219769193,0.489892061961,-0.363684157273,-0.0872024064456,-0.0950852412715,-0.168438420646,-0.0877138799566,-0.234834517321,-0.137224417255,0.0470266441833,-0.106553545615,0.120313359989,0.0665098610573,0.158442360173,0.49215705764,1.20605585405,0.80152320295,0.520109774521,0.127295206305,-0.301140634266,-0.417979929886,0.0593704509195,-0.199481060683,0.188020729549],[-36130.5070424,-564.508038095,35.2031227455,-2020.19586292,-900.486030808,1626.96491071,974.073814173,557.61970515,-882.544651948,269.00141221,816.975812511,-35.5624809849,-838.078253913,-741.121977618,-123.084580509,23.3064995896,-138.996473693,14.304971447,-617.730856936,-456.869016058,-139.29619432,-107.744861245,152.02418267,-483.709437825,127.007914762,51.0913672501,-111.909772244,123.244510114,-50.8528407288,186.707550139,-93.4060453347,-186.449232153,-30.4142256756,-15.1948744526,218.714751509,13.9098523115,17.1607094556,46.5996851915,8.93460915673,-41.727389472,-55.8810514812,-62.3971037328,-96.2121474799,-27.6699236672,-24.1031938823,16.634814878,-19.004592318,-27.0398113961,0.226292777536,5.47424468832,6.35561678096,-2.27858781676,-15.6617536452,-11.7545611353,-18.5157118349,1.84844184832,-27.2808551739,-15.7807420735,-2.70779107544,1.03783806704,17.8635076529,11.6669081507,20.010262779,-0.45553185751,0.725600799987,-1.80382345342,0.578058226223,0.376915740172,1.02211627942,-2.08131374286,-3.00823613731,-3.08997933834,-6.89314428217,8.55361057615,0.203185854822,10.6181096177,-0.392304631467,1.52948462251,-2.87233778044,-0.475944163432,-0.0636139806104,-0.837284121654,0.378165385176,-0.0623730016873,0.325812050803,-1.92921793918,-0.263311995833,-1.98019372528,-0.414756241605,-0.320547097966,0.601702134345,0.890107031049,1.8490735416,0.853452720656,0.689573808462,0.937818303272,-0.398132578951,0.48698890165,-0.369479221598,-0.09051036246,-0.0925945391064,-0.177374855619,-0.0955583341577,-0.231217788477,-0.142387743835,0.0543839449116,-0.111251988089,0.137441578781,0.0718024977106,0.171978000262,0.4967442174,1.21756546789,0.802183382959,0.528248608966,0.134205679997,-0.296294607748,-0.417079157611,0.0580710052769,-0.19939749319,0.188935171639],[-36111.8131271,-514.226801809,-15.3610798762,-2000.71971237,-881.234686362,1649.98511008,956.921857685,544.126593248,-892.01274306,271.082322705,807.227104417,-50.2077365299,-830.569240189,-748.136335601,-127.294978768,33.3937285825,-149.685302067,18.13438478,-622.046349439,-450.130983355,-144.533453674,-107.526060876,148.233972049,-478.646237629,131.053852059,49.2053776185,-112.458276154,124.508502835,-51.3333596165,187.323426509,-93.9442525039,-186.834021807,-25.8740038405,-13.3516657643,219.632704581,14.7782795638,17.6507541344,47.0611326562,9.00077918656,-42.5096483649,-56.0093780388,-63.0220836765,-96.0031070469,-26.5593269919,-23.8605098393,17.5313550588,-19.2569360112,-27.7315093297,0.417920511105,5.78362252685,6.41033565944,-2.28187403066,-15.6117991548,-11.8915034959,-18.6409517305,1.96783366092,-27.0128132897,-15.707275357,-2.3367401543,1.06575398825,17.6454494167,11.7720230939,20.0980187492,-0.481005387565,0.761761909031,-1.8403677816,0.519900818932,0.417342136762,1.0118015616,-2.07146449969,-3.00481463995,-2.9652274241,-6.80860309569,8.73422732055,0.206626683476,10.6471849785,-0.390602433036,1.58247590543,-2.85313409341,-0.463306691174,-0.0781329081513,-0.840697761365,0.362390311137,-0.0916419575208,0.33632852588,-1.95072342336,-0.238508611406,-1.99276956521,-0.36569596922,-0.284777788648,0.652336376275,0.906591901631,1.87294517106,0.85637113509,0.71723085692,0.953420797034,-0.397771876038,0.484372328303,-0.374067991216,-0.0940100348544,-0.0902294706886,-0.186148167739,-0.104641607386,-0.228887707033,-0.147620640209,0.0620667023739,-0.116231397402,0.154271014355,0.0774334849519,0.186337274305,0.501006207747,1.22960029209,0.802958660712,0.537316051271,0.140463165802,-0.292637544798,-0.41655400783,0.056674533683,-0.198640825479,0.189952953879],[-36095.6628395,-475.054820708,-42.6763963033,-1976.21540748,-864.411559759,1673.80553357,948.494372908,531.656923449,-902.962038717,271.764507142,794.411116802,-61.7446353063,-822.85167821,-752.474505097,-134.847297702,42.685750749,-159.996212241,21.1008112825,-627.598789867,-443.147496915,-148.482252915,-107.412625282,143.310441465,-473.297524587,134.94379205,47.2544327698,-112.759139098,125.84122534,-51.63817318,188.278890661,-94.1729643496,-187.368750362,-21.4034006774,-11.9445603657,221.119135409,15.7674730109,18.1111372591,47.691307503,9.18149355878,-43.1033458176,-56.1748426523,-63.5641826708,-95.6971639666,-25.3299718585,-23.7562371457,18.4929720871,-19.3949200153,-28.4643947943,0.619633560482,6.07776860538,6.45269836753,-2.24832230073,-15.5406448543,-12.0107352107,-18.7468439394,2.15576735428,-26.7457627811,-15.6474102963,-2.00428854074,1.09114158261,17.4313295812,11.8779812042,20.1473979004,-0.501533793493,0.791257503316,-1.88394222138,0.461030097815,0.468920734731,1.00261869566,-2.06077439837,-2.99489024851,-2.84278489293,-6.72752849749,8.90868034736,0.204475002309,10.6756878572,-0.387271679385,1.61995809979,-2.84992228199,-0.45842063574,-0.0926115502925,-0.845158944211,0.343911213981,-0.123471802102,0.347206459438,-1.97233969276,-0.212526539098,-2.00919463259,-0.316969571965,-0.247340526679,0.702028625382,0.918463643776,1.89513701414,0.85812259709,0.742695399668,0.965206113297,-0.400195223135,0.482253352744,-0.376708389608,-0.0977915096853,-0.0878636046135,-0.194695180844,-0.115069308722,-0.227893152112,-0.153018180137,0.0700686994992,-0.121635546269,0.170755347004,0.0834590405938,0.201727961972,0.504853939721,1.2420821084,0.803998190679,0.547405420472,0.146079159385,-0.290223265638,-0.416271233816,0.0553735949781,-0.197065786028,0.191041975395],[-36077.3730613,-444.894469276,-44.4999128836,-1947.1335274,-848.064560129,1699.28560704,949.310979718,520.340452602,-915.779214161,271.587330886,778.516042793,-69.5187862835,-814.961312217,-754.262511059,-145.809091843,51.0550062082,-169.819150701,23.1216808876,-634.203308817,-435.963845449,-150.993736249,-107.324512308,137.411132514,-467.740613661,138.684759146,45.1904276117,-112.796802507,127.24118224,-51.7868644016,189.60852184,-94.0311438864,-188.013612594,-17.0334451724,-11.0057020848,223.104245476,16.8866812483,18.524283183,48.4922355946,9.46679282251,-43.5023495973,-56.3592179413,-64.0046870948,-95.2778535194,-23.9754488211,-23.8051384631,19.4923723821,-19.4069490953,-29.2340349905,0.832084253867,6.35356630391,6.48492638148,-2.18350246936,-15.4440371151,-12.1097896004,-18.8285848101,2.4166607918,-26.4759999642,-15.6024330075,-1.71569193549,1.11688043579,17.2196563307,11.9869867759,20.1537606051,-0.517162913173,0.814250768854,-1.93373730955,0.399848976816,0.533143903244,0.993214346581,-2.04854409462,-2.97654746483,-2.7217486614,-6.64946426703,9.07587295478,0.19765452544,10.7014335999,-0.380515193444,1.63967950063,-2.8628698481,-0.460931629698,-0.107024451916,-0.850219857144,0.322600969037,-0.15803763681,0.358594853642,-1.99444263058,-0.185324689401,-2.02912457312,-0.26834969163,-0.207990193833,0.750905907007,0.92589285697,1.91520498266,0.859350928862,0.765181423264,0.973204523612,-0.405455335526,0.480835372944,-0.377329893874,-0.101835961837,-0.0853644079599,-0.203033452658,-0.126810929835,-0.228260309769,-0.158713383972,0.0783019769081,-0.127518695935,0.186877242144,0.0899078099058,0.218241094402,0.508293877164,1.25492429425,0.805455303648,0.558394760581,0.151118750142,-0.289093192795,-0.416064439745,0.054176254172,-0.194681518787,0.192184237572],[-36052.8151029,-419.737800556,-31.7478343182,-1916.35764309,-830.431605232,1726.12187108,955.980429567,509.601736742,-931.101583461,270.896046353,760.42840982,-73.5377291183,-807.146803986,-753.910321494,-159.087028946,58.5457251168,-179.112081044,24.2917389596,-641.465841916,-428.614841323,-151.971770709,-107.04614464,130.997906148,-462.057356929,142.323826395,42.9699625194,-112.585534273,128.76249283,-51.7927326597,191.346942951,-93.5344683844,-188.686733565,-12.7901561768,-10.5507297747,225.429650775,18.1388084309,18.8767280511,49.4462574507,9.83957723303,-43.7005420297,-56.5437723367,-64.3486444791,-94.7422444305,-22.495019175,-24.0149394937,20.4807135052,-19.3102236458,-30.0444742588,1.05110626344,6.60875622208,6.50896694157,-2.10016952695,-15.3173182012,-12.1853141196,-18.8811354863,2.74812371415,-26.2009119677,-15.5733041598,-1.47444324023,1.13997878122,17.0060222613,12.1008172389,20.1200677823,-0.528268707034,0.830651484967,-1.98735907361,0.334211926696,0.611377205658,0.982146731101,-2.03195536599,-2.94825654795,-2.60143783223,-6.57373234879,9.23631412483,0.187706782294,10.7213776366,-0.368964083115,1.64107309988,-2.88971001454,-0.470494001632,-0.121040594961,-0.855527995042,0.298569970911,-0.195143598749,0.370565154611,-2.01746478375,-0.156524598945,-2.05166901495,-0.219520543933,-0.166547802432,0.799168467151,0.929665214001,1.93254366868,0.86068885299,0.783769749,0.978269714926,-0.413633821767,0.480354482656,-0.376529054087,-0.106008461567,-0.082603703641,-0.21126262921,-0.139715466025,-0.230018531275,-0.164872121914,0.0866074045298,-0.133836065082,0.20264320921,0.0967818960655,0.235843119562,0.511416106399,1.26803090826,0.807507140336,0.569934154624,0.1557193403,-0.289302250632,-0.41574658577,0.0528977068398,-0.191647060949,0.193380840779],[-36020.0343103,-396.274175958,-11.9787829797,-1886.3281792,-810.616829256,1753.4107681,965.194765423,499.151993958,-949.382374029,269.866663971,740.885061777,-73.9989060676,-799.624857172,-751.695751084,-173.826261351,65.2392330205,-187.868258903,24.6830793317,-649.044963744,-421.175810231,-151.366451418,-106.437932178,124.406635345,-456.375997187,145.898733771,40.5709927083,-112.129898783,130.440899271,-51.6749194813,193.523860621,-92.723413043,-189.329728027,-8.72460460845,-10.5939354064,227.944151017,19.5234798816,19.1602430933,50.5410576863,10.2864400769,-43.6927930414,-56.7109162166,-64.6026742408,-94.0912950686,-20.8976641573,-24.3925732935,21.4122099596,-19.1205122594,-30.9028949192,1.27190727143,6.84178724744,6.5272270786,-2.00995590114,-15.1548389082,-12.2337161467,-18.9002055923,3.1482740495,-25.9193717214,-15.5610310961,-1.28583310367,1.15805371329,16.7829394878,12.2207927878,20.0481693017,-0.535329312057,0.840007676942,-2.04266793857,0.26226251211,0.704922999082,0.968316649944,-2.00786030031,-2.90838359324,-2.48132719082,-6.49948001822,9.38966980298,0.176289393573,10.7318308402,-0.35116685483,1.62321790253,-2.92792350482,-0.487020017625,-0.134328304686,-0.860879186319,0.271822695086,-0.234675655352,0.383189888269,-2.04177527532,-0.12566831679,-2.07586094606,-0.170075157391,-0.122866466685,0.846863723976,0.930592757522,1.94634447494,0.862809207421,0.797390167955,0.98130330434,-0.424936054935,0.481031628178,-0.374836182276,-0.110149458012,-0.0794784562337,-0.219477088686,-0.153653554516,-0.233206347529,-0.171659631166,0.094871126241,-0.140546112803,0.218093722,0.104088257355,0.254497721815,0.51432334302,1.28126221362,0.810364564702,0.581606240059,0.160091841165,-0.290946341651,-0.415102558866,0.0513610002819,-0.188071664277,0.194621830847],[-35979.5152944,-375.033352456,9.3128126621,-1858.48761764,-788.770432246,1779.94483311,973.712573543,488.661669314,-970.732724484,268.580436843,720.34659649,-71.511390307,-792.652154908,-748.028204184,-189.374871821,71.2626095919,-196.081392754,24.3549993866,-656.7052473,-413.75865529,-149.194722955,-105.455057564,117.841428905,-450.920474506,149.431787671,38.0067476502,-111.423495768,132.302805303,-51.4537087659,196.143658142,-91.6542288274,-189.9225692,-4.90838745098,-11.1427831646,230.518001466,21.0348143319,19.3753686468,51.7717338543,10.8001405897,-43.4752756421,-56.8471002278,-64.7730020628,-93.3315389307,-19.2027371986,-24.9440459737,22.2404130049,-18.8524100549,-31.8220482738,1.48942514638,7.05185938407,6.54251037338,-1.92122558301,-14.9499819501,-12.2513078035,-18.8821627351,3.61516694727,-25.6321740548,-15.5666826132,-1.1572596083,1.1703830781,16.5408813523,12.3483319078,19.9390603901,-0.539020321316,0.841356494339,-2.09794120194,0.182758559269,0.814907888758,0.951336097703,-1.9731693305,-2.85534573,-2.3609329832,-6.42586240019,9.53451165595,0.164962924899,10.7284766977,-0.326044342298,1.58486478492,-2.9750592084,-0.510466704042,-0.146567516404,-0.866286736996,0.242258251782,-0.276554622974,0.396550142139,-2.06761053724,-0.0922589467844,-2.10070785708,-0.11956470209,-0.0768673534654,0.893808520548,0.929396614864,1.95561852799,0.866410721806,0.804889535956,0.983314411455,-0.439671746804,0.483103274273,-0.372735277319,-0.114087440009,-0.0759245510452,-0.227768244999,-0.168540910222,-0.237860160669,-0.179209199301,0.103012093528,-0.14759955488,0.233295264603,0.111824511855,0.274158100769,0.517106572126,1.2944337256,0.814255950194,0.592950503854,0.16450052298,-0.294146817174,-0.413914089704,0.0494357109315,-0.184017482089,0.19590484029],[-35933.5294854,-362.940214034,27.3699667425,-1832.90106787,-766.348742841,1804.42263416,978.243489586,477.430102281,-994.78724491,267.11305683,698.993850506,-67.1474582471,-786.600838418,-743.581076677,-205.281428244,76.8075775382,-203.70642172,23.377978018,-664.322766257,-406.509279466,-145.552022658,-104.147304908,111.398803007,-446.020686601,152.932171405,35.3301557893,-110.452115916,134.372358768,-51.1465156449,199.177334524,-90.3978369582,-190.477930447,-1.42973284272,-12.1993751718,233.043696876,22.6590704795,19.5316097788,53.1389033614,11.3784806683,-43.0449520546,-56.9430922637,-64.8657250124,-92.4743559707,-17.4382610142,-25.6736993462,22.9173317361,-18.5196809098,-32.8182442254,1.69804994811,7.2385036359,6.55775532736,-1.83870857342,-14.6953766567,-12.2346181021,-18.8236790602,4.14641228561,-25.3417495029,-15.5910004616,-1.0972663317,1.17787003314,16.2698839651,12.4853343851,19.7930102941,-0.540222307992,0.833212739726,-2.15194504128,0.0950348943056,0.942299708087,0.931560798088,-1.92502632684,-2.7877805698,-2.23970328746,-6.35201622876,9.66855330269,0.155140660758,10.7068365191,-0.292973203988,1.52460150463,-3.02884211223,-0.540754294572,-0.157427992906,-0.872005830922,0.20974155972,-0.320738034905,0.410709823254,-2.09507250513,-0.0558043039467,-2.12524395037,-0.0675516394101,-0.0285182983486,0.939640200654,0.926663842865,1.95930691823,0.872198980407,0.805147572677,0.985403272963,-0.458181095949,0.486816748008,-0.370676487239,-0.117633311612,-0.0719106212821,-0.236221911953,-0.184340757753,-0.244012657873,-0.187619996047,0.110962897067,-0.154926188034,0.248334122907,0.119968256609,0.294766220665,0.51982842952,1.3073346494,0.81939432218,0.603510280025,0.169235544236,-0.299023244178,-0.411976673628,0.0470481188753,-0.17951254475,0.197246624414],[-35884.8781675,-368.368379834,38.1496919617,-1808.73191242,-745.100380015,1825.46350663,975.834839274,464.570569991,-1020.93237566,265.585041331,676.841600477,-61.9968620528,-781.847414727,-739.058944351,-221.332033048,82.0677025589,-210.702035017,21.8328976034,-671.826311295,-399.598093779,-140.603049542,-102.609667731,105.101394222,-442.009803262,156.403877732,32.6024747892,-109.202609948,136.660669507,-50.779021999,202.576558142,-89.0279697958,-191.018830152,1.61929611719,-13.7549734773,235.426789075,24.3799014631,19.6405116783,54.6452408115,12.0188978087,-42.4045293375,-56.9914680256,-64.8902783098,-91.5328272912,-15.6357328323,-26.5817554524,23.4022682728,-18.1339956403,-33.9044770409,1.89249943698,7.40199879917,6.5761136051,-1.76487721202,-14.3846337801,-12.180858709,-18.7238267718,4.73957036616,-25.0517236471,-15.6337877252,-1.11383528748,1.18149290144,15.9605958642,12.6330284249,19.6100868914,-0.53993126479,0.814294333922,-2.20385397435,-0.00111546411605,1.08792766123,0.909824948865,-1.86131892794,-2.70444164957,-2.11744103741,-6.27699172275,9.7890900787,0.147917695546,10.6629621382,-0.251580872637,1.44127587743,-3.08712319318,-0.577738857181,-0.166613872429,-0.878390756046,0.174168687895,-0.367184499281,0.425799362187,-2.12414064095,-0.0159028468453,-2.14856250841,-0.0137514676826,0.0222331331677,0.98385786891,0.922921949003,1.95641192657,0.880764684824,0.797174825966,0.988541867947,-0.480746778187,0.492339617498,-0.369002744445,-0.120608727776,-0.0674298467973,-0.244910582586,-0.201031498015,-0.251668108809,-0.196952039713,0.118682583666,-0.162443356917,0.263305070815,0.128503816681,0.316225979846,0.522549213503,1.31973013065,0.825950900785,0.612873447144,0.174584607649,-0.305671122906,-0.409108028859,0.0441514208029,-0.174578874565,0.198648515248],[-35834.9118711,-387.784449209,41.5435842995,-1786.16305008,-724.175750925,1842.52243699,966.61140805,450.61334168,-1048.99112824,264.024251241,653.791401943,-56.3118315931,-778.2511695,-734.718919829,-236.945156175,87.1195535825,-217.264415033,19.7361167676,-679.07610673,-393.153070722,-134.387950265,-100.795933726,98.9626045573,-439.064914868,159.86242866,29.8182922093,-107.683872425,139.142370866,-50.4114125287,206.312376825,-87.5870869843,-191.552950424,4.21608663463,-15.7872014035,237.626073799,26.1936354027,19.7095003192,56.2903850148,12.7022506709,-41.5744515834,-56.9839202947,-64.8635515811,-90.5132092788,-13.8131304052,-27.6653045145,23.6821770755,-17.7095099561,-35.0833510376,2.0715961532,7.54648117734,6.60199256474,-1.70421232248,-14.0149378512,-12.0896421857,-18.5880339624,5.39301546356,-24.7651785579,-15.6937831889,-1.20761372669,1.18049578806,15.6085446743,12.7903454833,19.3915745517,-0.539132162343,0.785153531662,-2.25260640838,-0.105529338559,1.25269356848,0.886423111978,-1.78170738091,-2.60409910783,-1.99511265995,-6.19949508573,9.89412720987,0.143487080541,10.5948554567,-0.202671978678,1.33488221631,-3.14824813608,-0.621030641344,-0.174145798465,-0.885559979833,0.135567982112,-0.415571243011,0.442284596587,-2.15479577252,0.0277517633502,-2.16986526603,0.041593259374,0.0755825609602,1.02581429916,0.918641176394,1.94642621079,0.892274234801,0.780442638839,0.993288478524,-0.507521589873,0.499622743146,-0.367992713304,-0.122943207068,-0.062524971652,-0.253899106333,-0.218497821428,-0.260710111804,-0.207221473621,0.126247173322,-0.170096011284,0.278234753892,0.137466254478,0.338312902752,0.52538330334,1.33139352737,0.833987203792,0.620750060251,0.180694599746,-0.314113262145,-0.405229927415,0.0407057204519,-0.169251739861,0.200077998008],[-35783.8469556,-414.912713376,40.9045109229,-1765.64324453,-701.609318331,1856.02714538,952.002533477,436.692226121,-1078.85430465,262.582717886,629.94306614,-49.9554719263,-775.280992857,-730.670733298,-251.443866679,91.9571692377,-223.681808102,17.1404496149,-685.900536252,-387.193495458,-126.914412502,-98.6360442175,92.9900554166,-437.360925771,163.308389435,26.9317978475,-105.908464788,141.786398291,-50.096967969,210.371010557,-86.1005782208,-192.0732494,6.3560644755,-18.2505834709,239.622566585,28.0981652315,19.7388268957,58.0676950847,13.4018227512,-40.5793516511,-56.9110348917,-64.7980438133,-89.4161470722,-11.9816026954,-28.9133175503,23.7560987072,-17.2605638312,-36.3536317326,2.23709454006,7.67566047648,6.6387490981,-1.66371668657,-13.5854751118,-11.9613875912,-18.4224274133,6.10558316129,-24.4838794297,-15.7672708191,-1.37584832316,1.17537326127,15.2115643941,12.9564656797,19.1390574614,-0.538132874239,0.746999411384,-2.29743663232,-0.218349746397,1.4370473323,0.861326602308,-1.68648173526,-2.48574325737,-1.87335404264,-6.11766500006,9.98268481536,0.142325999015,10.5016874463,-0.147161995349,1.20602245692,-3.21061607851,-0.670038718061,-0.180027899461,-0.893384817477,0.0940670912058,-0.465593127598,0.46060556264,-2.18715488093,0.0753753076088,-2.18848467637,0.0982244550331,0.131757882446,1.06497484146,0.914374410679,1.92914960169,0.906839496592,0.754700191314,1.00015922322,-0.538584782908,0.508544192585,-0.367903092311,-0.124592188919,-0.0571875364086,-0.26321935759,-0.23658904062,-0.270971119131,-0.218476811878,0.13375570105,-0.177863957527,0.293123820628,0.146878833098,0.360798658199,0.528499774815,1.34215107956,0.843575273911,0.626921009124,0.187707552539,-0.324317455351,-0.400298841268,0.036708085468,-0.163557745035,0.201503962577],[-35732.7651073,-445.049424505,41.3256432387,-1747.50039551,-675.83930285,1866.93491135,933.708015996,424.164021164,-1110.33660436,261.432906809,605.586609739,-42.6633936558,-772.236429487,-726.994997513,-264.283658255,96.5373811466,-230.267449361,14.1526151388,-692.159413953,-381.662891632,-118.215384034,-96.0654177335,87.2150659005,-437.086690422,166.730012443,23.8791098996,-103.881192793,144.551783639,-49.875117727,214.746650966,-84.5809361421,-192.554508084,8.030372108,-21.0723354821,241.40269538,30.0891326996,19.7239620598,59.9677582891,14.0883105202,-39.4454835694,-56.7616130054,-64.7009209768,-88.2351629731,-10.1491013431,-30.302262308,23.630301781,-16.7986559538,-37.7100555066,2.3920444879,7.79276917512,6.68836574047,-1.65126852552,-13.0962940502,-11.7962132033,-18.2324625854,6.87741075036,-24.2082142572,-15.8474715173,-1.614111927,1.16788685103,14.7696339387,13.1310820428,18.8547409607,-0.53673546052,0.701261460326,-2.33808120495,-0.339883834212,1.64119911486,0.834488484841,-1.57610777525,-2.34847744498,-1.75218788384,-6.02898470911,10.0547595374,0.145419522395,10.3837338131,-0.085585110675,1.05574570042,-3.27255279367,-0.723939944994,-0.184180360656,-0.901641683123,0.0498238008683,-0.517029638118,0.481126417099,-2.22148517371,0.127106693403,-2.20387221283,0.156054799932,0.191047143744,1.10103612274,0.910816291525,1.90470748001,0.924604920885,0.719972714129,1.00970089047,-0.573881486182,0.518957016601,-0.368904398446,-0.125504777603,-0.0513638631834,-0.27288256479,-0.255157633899,-0.282280258038,-0.230816403624,0.141312376155,-0.185773945177,0.307995236769,0.156738813743,0.383505608316,0.532112411644,1.35192181512,0.854820557106,0.631256608667,0.195808514075,-0.336203810942,-0.394278770641,0.0321913049493,-0.157526936572,0.202892058494],[-35682.349927,-478.744600099,46.0440796843,-1730.86328386,-646.503484239,1876.28303817,912.826761776,414.262049097,-1142.83915156,260.873920367,581.154403732,-34.5705125088,-768.441476753,-724.248122131,-275.070666207,100.8577342,-237.247697667,10.9347572553,-697.818883621,-376.473901767,-108.467792384,-93.049716141,81.6536014684,-438.499013598,170.102033835,20.6219944553,-101.59003142,147.400439096,-49.7720311214,219.403062055,-83.0456615512,-192.994770581,9.21132041416,-24.1691781272,242.957841146,32.1527916472,19.6647464354,61.980497568,14.7414867966,-38.2011837799,-56.5275618051,-64.5768764223,-86.9692162096,-8.32856840864,-31.8048114975,23.3065607096,-16.3387069219,-39.1498793492,2.53842413035,7.9005388424,6.751077688,-1.6719121833,-12.5477698192,-11.5922243067,-18.0232203803,7.70794378095,-23.9398500998,-15.9284428493,-1.91941848763,1.15857782542,14.2834815782,13.3144389531,18.5413764767,-0.534692958308,0.64873247278,-2.37492969713,-0.469877330034,1.86524235453,0.806861774806,-1.45115558347,-2.19173778749,-1.63131965436,-5.93128418883,10.1103891926,0.153298341787,10.2413411687,-0.0188444848791,0.884880598506,-3.33256880471,-0.781808582508,-0.186435372681,-0.910298304177,0.00298018123657,-0.569756262396,0.504131039098,-2.2579494666,0.183054769059,-2.21543726687,0.215222481769,0.25366503934,1.13369345254,0.908497023772,1.87319795887,0.945586138661,0.676292758052,1.02256203296,-0.613349566321,0.530740445211,-0.371185297899,-0.125585314759,-0.0450030204698,-0.282885458614,-0.274129292555,-0.294474258683,-0.244338911646,0.149039716794,-0.193823182201,0.322920020557,0.167030937587,0.40627644935,0.536434227651,1.3606515994,0.867811412547,0.633621138026,0.205187263988,-0.349717395742,-0.387169190451,0.0272044414888,-0.151207164261,0.204220283028],[-35632.8691871,-515.567745623,55.0269710615,-1714.93194233,-613.396862786,1884.92882088,890.865287222,408.165551256,-1175.75922911,261.195191191,557.113348796,-25.9073963176,-763.306677963,-723.275887912,-283.510354479,104.888215211,-244.875850361,7.66888981791,-702.918278032,-371.542578578,-97.9159502304,-89.5897575166,76.3447167532,-441.913084256,173.390528628,17.1068459536,-99.0112442156,150.281214566,-49.8126317812,224.284238972,-81.5304377994,-193.395204686,9.8472519135,-27.4448269444,244.283185606,34.271377935,19.5591921569,64.0932346533,15.34113319,-36.8790638384,-56.2047715259,-64.4333760529,-85.6172207231,-6.54164027369,-33.3865822329,22.7807581731,-15.8975799103,-40.6730430105,2.67927018889,8.00150659709,6.82571602452,-1.73055803244,-11.941155753,-11.3474200356,-17.8005931143,8.59628277024,-23.6832171982,-16.003390595,-2.29094614096,1.14792314202,13.7543522633,13.5077414982,18.2017795706,-0.531264524283,0.590262456561,-2.40884240341,-0.607805745118,2.10918567445,0.779649553115,-1.31258352962,-2.01554672376,-1.51067457194,-5.82238884442,10.149109977,0.166557483675,10.0747053698,0.0521296337887,0.693960296691,-3.38925995705,-0.842707889559,-0.186549600328,-0.91926536244,-0.0462824900081,-0.623639883778,0.529864609691,-2.29672335122,0.243264757882,-2.22270545853,0.275932089222,0.319776812963,1.16246225074,0.907942929108,1.83458030195,0.96985316328,0.623666112806,1.03955252072,-0.656915715048,0.543814539063,-0.374952316131,-0.124726338155,-0.0380242749945,-0.293204022969,-0.293438447922,-0.307371239093,-0.259147381227,0.157087399693,-0.202023406735,0.337983228217,0.177708812598,0.428918657792,0.541703451211,1.36825449713,0.882670501755,0.633856699218,0.216066190412,-0.364813727916,-0.378993560755,0.0218210066953,-0.144653060828,0.20548721737],[-35584.7838848,-553.119618562,64.4217157964,-1699.44311722,-576.393092462,1892.76482331,870.079119103,406.910159672,-1208.50899187,262.540129717,533.881329814,-16.7157368767,-756.294512667,-724.956903508,-289.430746693,108.565543831,-253.462386172,4.54313102176,-707.547682507,-366.823607636,-86.8499305214,-85.7359230519,71.3441646316,-447.653262948,176.558995176,13.2563523192,-96.1151927458,153.11871137,-50.0355248061,229.333985865,-80.0862695603,-193.740189183,9.86223910056,-30.7844123935,245.370252183,36.4256756533,19.4018646033,66.2896815638,15.8628617312,-35.5153823357,-55.7894478449,-64.2820976585,-84.1752105167,-4.81951927836,-35.0050648244,22.0473580129,-15.4935182267,-42.2773927814,2.81851031341,8.09817108632,6.9102306592,-1.83279797172,-11.2793250402,-11.0597500806,-17.5717441665,9.54206364636,-23.4455865659,-16.0634927648,-2.7295955401,1.13584427445,13.1842720505,13.7125619515,17.8385068246,-0.525113369709,0.527218928895,-2.44102860222,-0.752878748524,2.37302204145,0.754066347491,-1.16176327303,-1.82022180482,-1.39060213418,-5.70006723404,10.1700297207,0.185813476712,9.884356717,0.126684384616,0.483467596752,-3.44118213984,-0.905777969077,-0.184182392224,-0.928306889983,-0.0976809224313,-0.678478463837,0.55856133714,-2.33802813389,0.307684967143,-2.22536461237,0.338379756763,0.38949844772,1.18669326981,0.909734176365,1.78877591065,0.99752082763,0.562097185998,1.06152578104,-0.704486252855,0.558093382923,-0.380361810541,-0.12281244839,-0.0303211609836,-0.303780906496,-0.312989793357,-0.320773618598,-0.275364412678,0.165626654624,-0.210404022423,0.353271880388,0.188704640502,0.451189780101,0.548187852162,1.37461772533,0.899541803076,0.63181338487,0.228705079771,-0.381445671022,-0.369786809875,0.0161350561565,-0.137925567782,0.206689997308],[-35536.5346539,-587.218790069,66.7824847666,-1684.02008144,-535.173157521,1898.88184675,853.921240415,411.560968054,-1240.4409242,265.047911414,511.909910349,-6.72157737065,-746.900651405,-730.142477657,-292.709970536,111.81686443,-263.323816807,1.76756496591,-711.800979429,-362.268222002,-75.5651340845,-81.5311754868,66.7244577233,-456.035223214,179.564065679,8.97673504427,-92.863172359,155.823925257,-50.4811325808,234.508554251,-78.764510505,-193.999647107,9.17313116296,-34.0583148085,246.217211816,38.593342303,19.1850379133,68.5501108917,16.2797603043,-34.147465182,-55.2770814057,-64.1330499143,-82.6369789546,-3.19595576656,-36.6102191824,21.1033837761,-15.1473576579,-43.9575170241,2.96067941394,8.19296201847,7.00123411702,-1.98499861491,-10.5667604228,-10.7269406063,-17.3437946496,10.5452553187,-23.2351372428,-16.0985369452,-3.23603446975,1.12120977597,12.5774456719,13.930705968,17.4542429895,-0.514309267014,0.461393454917,-2.47306781479,-0.904044581939,2.65654501587,0.731308566108,-1.00048040963,-1.606496049,-1.27145242919,-5.56221186472,10.1725142412,0.211453107875,9.67174205789,0.204038034575,0.25400317326,-3.48696324844,-0.97022588851,-0.178927290787,-0.937010682982,-0.150844335991,-0.733959813245,0.590365050058,-2.38211779675,0.376121192322,-2.22328694721,0.402802783383,0.462823249399,1.20570551843,0.914365982468,1.73582419101,1.02859549755,0.491689849734,1.08933485782,-0.755935112216,0.573498810629,-0.387540559835,-0.119731519752,-0.021762318796,-0.314519769232,-0.332642387407,-0.334477678486,-0.293119003188,0.174830627421,-0.218996455009,0.368855510572,0.199913477067,0.472818281158,0.556147267684,1.37964977835,0.91853183298,0.627381963083,0.243356424232,-0.399561294868,-0.359615454628,0.0102643813273,-0.131097496954,0.207830935628],[-35486.8622763,-613.223963717,54.4497247814,-1668.62297693,-490.322648907,1901.92154521,845.761443745,423.454817943,-1270.92152345,268.529524648,491.6902477,4.42784331749,-734.621472987,-739.371732342,-293.344377641,114.618252536,-274.77214738,-0.451785156766,-715.826256811,-357.825877747,-64.343181646,-76.9984637827,62.5663135534,-467.254844527,182.385893395,4.1878124241,-89.2203576594,158.282551375,-51.1789610619,239.774704105,-77.6117735989,-194.127386461,7.69906461899,-37.1368158595,246.817623695,40.7572100812,18.9051005907,70.8537397452,16.563519697,-32.8082726874,-54.6674353166,-63.9944803633,-80.9964382606,-1.70586302863,-38.1477834737,19.9522798758,-14.8775636343,-45.7032422019,3.1105002401,8.29020824645,7.0947924663,-2.19264817951,-9.8091849624,-10.3491098732,-17.1230548146,11.6052097938,-23.0604519248,-16.0976959897,-3.81069469153,1.10213008245,11.9391554462,14.1630527769,17.0523315696,-0.496908117248,0.395462538908,-2.50669248674,-1.05970567479,2.95913919112,0.712023063423,-0.830425602259,-1.3757244448,-1.15378451242,-5.40711658515,10.1561416307,0.243950097184,9.43926202743,0.283764074317,0.00674038891001,-3.52520778545,-1.03547161373,-0.17050188397,-0.94480002583,-0.205366191394,-0.789556737826,0.625333513129,-2.42923649965,0.448287258301,-2.21661346528,0.46941435576,0.539592046682,1.2188774874,0.922347822357,1.67593471929,1.06302116275,0.412773898962,1.12365170636,-0.811021407605,0.589940233945,-0.396520241379,-0.115446215362,-0.0122345951324,-0.325310945308,-0.352176492963,-0.348301685012,-0.312486351656,0.184860544078,-0.227850985301,0.384815318922,0.21120910063,0.493535312979,0.565814227611,1.38329720486,0.939712406109,0.620538613538,0.260255105307,-0.419074649335,-0.348552558297,0.0043168915984,-0.124248506292,0.208896703303],[-35436.5232013,-628.374911103,25.8338830441,-1654.76598498,-443.606212367,1900.6102337,846.757646634,442.311439447,-1299.82501105,272.605401124,473.311222666,16.8947459268,-719.396488065,-752.300408599,-291.810887912,116.928038464,-288.003820789,-2.070556606,-719.769556438,-353.51691397,-53.3179416377,-72.2464086789,58.9113503757,-481.213095436,185.041130067,-1.14791959331,-85.2009036942,160.400031561,-52.1325050885,245.127150681,-76.6772978895,-194.062531948,5.40298533849,-39.9222914337,247.134608164,42.9135311167,18.5566767891,73.1836818514,16.696554235,-31.5176087995,-53.9651613549,-63.8750738834,-79.2494939557,-0.378725579995,-39.5740272657,18.6017989822,-14.6915063445,-47.502497567,3.2728395621,8.39256983629,7.19008768684,-2.45791809016,-9.01325759648,-9.93180479352,-16.9145534777,12.7205978095,-22.9306028837,-16.0525901507,-4.45456760388,1.07781604892,11.2718076845,14.4087847106,16.6379041002,-0.471550925798,0.332075032516,-2.54279896509,-1.21876267327,3.27915530194,0.695787628529,-0.653018396689,-1.12947244303,-1.0395222768,-5.23388248601,10.1203707695,0.284405786784,9.18944242384,0.366456645751,-0.255576942798,-3.55469723881,-1.10128523204,-0.158857429936,-0.951150665656,-0.26075309205,-0.844964340656,0.663304816884,-2.47954646747,0.523718538597,-2.20568995942,0.537938496768,0.619700130582,1.22580598708,0.934325190454,1.60941765592,1.10078149266,0.326129267296,1.16454994881,-0.869358155926,0.607293842332,-0.407213252507,-0.11001821546,-0.00164124653763,-0.33609470006,-0.37139277698,-0.362129438293,-0.333424413948,0.195794932722,-0.237012201853,0.401220608442,0.222564520518,0.51311694908,0.577348837714,1.38554567702,0.963099908994,0.611391232424,0.279519082312,-0.439856457944,-0.336626568723,-0.00168660588488,-0.117445070974,0.209842660572],[-35386.8031405,-633.992279626,-11.9731048911,-1644.7597865,-397.700008258,1895.14079945,855.373153102,466.37764015,-1327.44943073,276.933602014,456.383438147,30.3022593362,-701.547605687,-768.046437319,-288.774161776,118.699364717,-303.017998249,-3.26361787097,-723.773580426,-349.348735071,-42.4609469013,-67.3958717968,55.7462699433,-497.51858211,187.572448658,-7.00668235042,-80.880980788,162.13529312,-53.2948388202,250.569949201,-75.9902442131,-193.764205145,2.33621395567,-42.3713265875,247.125782781,45.0669539576,18.1371855703,75.5259968184,16.6795075833,-30.2815409827,-53.181620755,-63.7779887823,-77.398634946,0.774906912964,-40.866940288,17.0626942185,-14.5883940668,-49.3477106537,3.45229770993,8.50032298672,7.28982780521,-2.777944169,-8.18656035156,-9.48518787312,-16.7204733097,13.8879627736,-22.8523096233,-15.9611899166,-5.16666562671,1.04845510769,10.5756332425,14.665697188,16.2183038667,-0.437797188178,0.27297793022,-2.5809640573,-1.38058353683,3.61352673964,0.68161122626,-0.469653902167,-0.869520342634,-0.931494411972,-5.04308101562,10.0651395774,0.333824913093,8.92463443848,0.45273581922,-0.528589639897,-3.57482475785,-1.16759216162,-0.144245112222,-0.955767704117,-0.316374874676,-0.900133042336,0.703795591764,-2.53293832645,0.601725200841,-2.19085109198,0.607539648502,0.703063531192,1.22644561752,0.950693926376,1.53678873521,1.14173047537,0.233150823125,1.2115270619,-0.930401541122,0.625434936538,-0.419543265933,-0.103594024276,0.0100776122672,-0.346870627133,-0.390163698702,-0.375887705027,-0.355723637562,0.207591765217,-0.246446724597,0.418067300698,0.234067106251,0.531415541906,0.590746342691,1.3864575683,0.988583003941,0.600204226915,0.301049412478,-0.461723614473,-0.323865508323,-0.00780663790236,-0.110735516945,0.210639425835],[-35337.953247,-633.34092178,-53.2818476296,-1639.89782441,-355.378039614,1885.89180893,869.325005342,493.798586267,-1353.93798179,281.213430443,440.287220412,44.0539742113,-681.596752114,-785.857843886,-284.891489578,119.931392914,-319.659180013,-4.27331321105,-727.978067172,-345.323960778,-31.7095511323,-62.5325799774,53.0564696581,-515.66179779,190.028514833,-13.3173085332,-76.3522407509,163.47648561,-54.5973507376,256.099286484,-75.5543097812,-193.216705124,-1.40036761374,-44.4681141802,246.771996167,47.2194215378,17.6512471738,77.8682591858,16.5220735421,-29.1023048636,-52.3310222733,-63.7027402095,-75.451227044,1.75744137669,-42.0129932331,15.3523018251,-14.5663813995,-51.2341017429,3.65184243227,8.61380522338,7.39708133642,-3.14616622807,-7.33810491857,-9.02011540268,-16.5414471234,15.1016906268,-22.8288269821,-15.8250214116,-5.94209512641,1.01307633139,9.85253173256,14.9306421703,15.8017590212,-0.395830285371,0.219590247409,-2.62044010898,-1.54414041776,3.95849598245,0.668707042427,-0.282054778078,-0.598093349215,-0.832184750337,-4.83664445135,9.99132650695,0.392148242369,8.6476096221,0.542464893944,-0.807554373402,-3.58552994474,-1.23436067449,-0.12707380839,-0.958525743398,-0.371536859229,-0.954903228764,0.746244081125,-2.58905134257,0.681427410652,-2.17245076298,0.677184461912,0.789383868392,1.2209841842,0.971388863808,1.4588020793,1.18542527073,0.135544348159,1.26386222505,-0.99345407278,0.644255905515,-0.433418347814,-0.0963702556189,0.0229035518061,-0.357643315051,-0.40836491937,-0.389490160248,-0.3790657542,0.220132567248,-0.256042938988,0.435276725087,0.245810196994,0.548310978975,0.605841446972,1.38614340836,1.01589225555,0.587330133328,0.324601094594,-0.484438660264,-0.310360551322,-0.0141032166367,-0.10417433159,0.211286036383],[-35289.4714052,-634.127314527,-92.6422199921,-1639.48845344,-320.140316274,1873.42363237,884.738251076,523.627828757,-1378.73808052,285.102594947,424.592270443,57.1909776629,-659.763190505,-805.331851327,-280.689689792,120.747054899,-337.583722125,-5.2784260364,-732.553456539,-341.361043188,-21.1651329191,-57.6499556709,50.7352610079,-535.045009906,192.460364072,-19.9427539603,-71.696535325,164.4244912,-55.9482580488,261.66755022,-75.3265768737,-192.442876799,-5.67930430129,-46.2191400845,246.07015909,49.3645604286,17.1170219401,80.1952427729,16.2442491274,-27.9761972371,-51.4307231009,-63.6381224113,-73.4292357662,2.58373683815,-43.0094390951,13.5014183032,-14.6258172239,-53.1527450328,3.87086180355,8.73425281842,7.5135536705,-3.55157451795,-6.47825905193,-8.54644848619,-16.375404855,16.3511216066,-22.8568867623,-15.6501366772,-6.7704509478,0.966937804583,9.10601936246,15.1982802887,15.3958039271,-0.346614287394,0.173138695631,-2.66077044199,-1.70745234644,4.30972924505,0.656958884346,-0.0919694028544,-0.318138845463,-0.742531939616,-4.61850235881,9.90109678655,0.457323720718,8.36195240902,0.634695584557,-1.08756533248,-3.58685884845,-1.30164466879,-0.107898781386,-0.959491677266,-0.425567064773,-1.00889893825,0.790033090778,-2.6471010206,0.76179112349,-2.15084317024,0.745974797154,0.877820066991,1.21004042769,0.995625677038,1.37657208839,1.23094509804,0.0351169911339,1.32056074884,-1.05770503908,0.663538733301,-0.448630609953,-0.0885708077811,0.0366935965258,-0.368389273248,-0.425849131225,-0.402821590738,-0.403039298065,0.233229233495,-0.265600064195,0.452725165246,0.257826679944,0.563756150787,0.622252823457,1.38475962134,1.04451712456,0.573161869102,0.349806950112,-0.507711863077,-0.296261012516,-0.0206164879974,-0.0978169229975,0.211776693742],[-35239.6640901,-639.602061273,-126.00099694,-1643.00162959,-293.618549801,1858.2137535,899.004418851,555.441896577,-1401.39185252,288.449065335,409.015267644,69.2414291476,-636.100301554,-826.046328953,-276.519843767,121.199536113,-356.437014982,-6.41928147321,-737.509716025,-337.305385124,-10.8645445006,-52.6854926691,48.6866134866,-555.040296746,194.890234545,-26.7737987639,-66.9835440087,165.004049615,-57.2520707822,267.253263072,-75.2325445166,-191.457816927,-10.3461618992,-47.6295550299,245.036741002,51.4931760993,16.5421911733,82.4878489149,15.864555984,-26.8979712321,-50.4887176438,-63.5639301581,-71.3495864038,3.28029362192,-43.8541930575,11.5506397204,-14.7689506551,-55.0920361115,4.1095699537,8.8601625306,7.6396517571,-3.98608409773,-5.61908355756,-8.07191279155,-16.218929459,17.6257360692,-22.9277379172,-15.44274341,-7.63615863555,0.904464072522,8.34161799609,15.4627744238,15.0072591028,-0.29037586234,0.134857185032,-2.70155845756,-1.86948816114,4.66240971065,0.645874502223,0.0984032312311,-0.0324059252852,-0.662228107271,-4.39284548376,9.79808999064,0.526528092736,8.07191182299,0.728055800972,-1.36368385575,-3.57897069975,-1.36936154021,-0.0871591494281,-0.958467901592,-0.477805860323,-1.06185687618,0.834502248214,-2.70641704383,0.841557939465,-2.1263608486,0.813122653724,0.967399575895,1.19461709776,1.02233853939,1.29154684895,1.27719829424,-0.0662598749368,1.3805555214,-1.12227657022,0.683019529845,-0.464929680493,-0.0804306172751,0.0513555854916,-0.37905235238,-0.44244147467,-0.415721710407,-0.427304437934,0.246638889272,-0.274921695587,0.470205687745,0.270146892607,0.577760786216,0.639530261349,1.38252260797,1.07384971438,0.558113887513,0.376243996454,-0.531210672147,-0.281751743946,-0.0273472306426,-0.0917172488299,0.212110306499],[-35186.7900783,-649.606881596,-151.774287627,-1650.73473364,-275.801694087,1840.27107112,911.514856147,588.858063101,-1421.74431746,291.231148493,393.32101445,80.240789869,-610.75402769,-847.55300223,-272.671241576,121.260963169,-375.911318276,-7.81938872422,-742.712491436,-332.962787788,-0.730367320096,-47.5812989421,46.8663112911,-575.062971901,197.308816642,-33.7455386544,-62.2673658778,165.255436372,-58.4200600991,272.872579986,-75.1871803833,-190.266138278,-15.2327965847,-48.6933304739,243.703185769,53.5964708825,15.9219355928,84.7263901108,15.3966677473,-25.8618538633,-49.5054241086,-63.4538113819,-69.2212697502,3.87964869254,-44.5413637082,9.54164395436,-14.9991619603,-57.041365886,4.36989346941,8.98773850117,7.77461965334,-4.44551687355,-4.77338429711,-7.60216745768,-16.067778143,18.9159687188,-23.0294968826,-15.2083788185,-8.52119495857,0.820923915747,7.56624532738,15.7191889804,14.6424955472,-0.226402757264,0.106035309916,-2.74232182957,-2.03025227804,5.01158615153,0.634353550381,0.286415267286,0.256533777958,-0.590234439122,-4.1637137461,9.68690978562,0.596815851772,7.78179032709,0.820953541595,-1.6312498847,-3.56217596529,-1.437162307,-0.0651645553056,-0.954949565222,-0.527632474268,-1.11362220084,0.878986884738,-2.76656432675,0.919308772067,-2.09933815503,0.877944525132,1.05709165889,1.17589121883,1.0503458474,1.20525475713,1.32307469094,-0.166754837967,1.44287683478,-1.18625907445,0.702480487635,-0.482070027809,-0.0721943285757,0.0668698608226,-0.389553327064,-0.457945883357,-0.427998510098,-0.451614074304,0.260095591821,-0.283832676518,0.487436232951,0.282792444919,0.590359333646,0.657198260754,1.37966825073,1.1032586518,0.542572388037,0.403478371118,-0.554590851664,-0.26703395575,-0.0342473226486,-0.085933206652,0.212304488817],[-35130.4734148,-661.806546462,-169.376933203,-1664.03872549,-265.696236475,1819.31935719,922.967066216,623.620569286,-1440.02681925,293.442946463,377.375598949,90.4785159655,-583.926877531,-869.414917974,-269.411877249,120.824058343,-395.758731443,-9.55359835907,-747.949588193,-328.085519626,9.37909233689,-42.286418687,45.2669088664,-594.585579133,199.672254433,-40.8310217673,-57.5849526853,165.222353261,-59.3592189664,278.562205997,-75.0973355663,-188.868216913,-20.1737074471,-49.3966149769,242.105803527,55.6658204017,15.2379729949,86.8922982553,14.8486450369,-24.8583801123,-48.4790844663,-63.2743218871,-67.0499238971,4.41607872689,-45.0626562122,7.51328294017,-15.3190995985,-58.9923209307,4.65515188666,9.11046710451,7.91598053918,-4.92916767174,-3.95419817746,-7.14218492455,-15.9160419561,20.2119583397,-23.1478474048,-14.9528021418,-9.40714652447,0.712491903967,6.78671700496,15.9633278034,14.3069309856,-0.152939049566,0.0877917724288,-2.78261476078,-2.19084023284,5.35210640232,0.620525313965,0.469351966235,0.54590652815,-0.52476587227,-3.93539749932,9.57260519504,0.665180377571,7.49549336468,0.911750904654,-1.88616016834,-3.5368874255,-1.50456348802,-0.042011059005,-0.948183918302,-0.574507282926,-1.16417907891,0.922800738923,-2.82737449712,0.993489750553,-2.07019708752,0.939917529088,1.14569777495,1.15514285368,1.07832049576,1.11912856154,1.36746870172,-0.26472344718,1.50663874401,-1.24876362132,0.721751094944,-0.499806730765,-0.0641105999207,0.0832983754498,-0.399795732852,-0.472164152649,-0.439459589098,-0.475811739044,0.273299265568,-0.292190488336,0.504087447464,0.295750609763,0.601614482095,0.674729112089,1.37642061653,1.13209717227,0.5268560652,0.431081731484,-0.57753415554,-0.252312847349,-0.0412442297603,-0.0805222185246,0.212387957323],[-35072.2758093,-672.663060091,-179.234716503,-1684.73097971,-262.154701353,1794.84308324,934.260074835,659.033561568,-1456.73949162,294.923141392,361.196832733,100.128555059,-556.093136064,-891.298035203,-267.188183542,119.740692541,-415.776108512,-11.6168562052,-753.014438326,-322.398587092,19.5973411078,-36.8136583525,43.9119184517,-613.227549822,201.909966092,-48.0218053571,-52.9476700049,164.940886196,-59.9571491689,284.348981983,-74.883292442,-187.266011038,-25.0543515646,-49.7238264896,240.264800718,57.6911919914,14.4650053931,88.9691628426,14.2256583783,-23.8710928074,-47.4133390904,-62.9883661997,-64.842042698,4.9131368935,-45.4066571826,5.49067411042,-15.7268943364,-60.9442811948,4.96942756909,9.22014814115,8.05872420773,-5.4379051818,-3.17417657016,-6.69762945482,-15.7551867545,21.5017953343,-23.2675495187,-14.6821337787,-10.2793787161,0.577162285286,6.00654288527,16.1916644508,14.0038876503,-0.0674488228164,0.0807844107511,-2.82242511563,-2.35298685845,5.67844994603,0.601994706199,0.644930508123,0.832122605588,-0.463161669793,-3.71265862827,9.45952148735,0.728830261809,7.21543731322,0.999032925946,-2.12566288843,-3.50330789892,-1.57132869549,-0.0176186378123,-0.937346491062,-0.618028128751,-1.21361609123,0.965131187043,-2.88877869909,1.0624798023,-2.03952829573,0.998811264908,1.23174013034,1.13367302447,1.10479612568,1.0342459159,1.40940080844,-0.359000329453,1.57116454057,-1.30908481942,0.740730163035,-0.517966690216,-0.0564185415536,0.100750806616,-0.40965512612,-0.484921468214,-0.449937179039,-0.499786118461,0.285891877387,-0.299873055027,0.519828342735,0.308930554802,0.611655882787,0.691512641685,1.37295394612,1.15972482384,0.511124816013,0.458676008517,-0.599837055214,-0.23777794003,-0.048306239997,-0.0755287537545,0.212385142692],[-35012.2687343,-675.107358446,-183.461846738,-1714.49322167,-262.970197988,1766.16090383,946.992139394,693.938502025,-1472.56384431,295.569301771,344.912399193,109.466311779,-527.894600861,-912.825914932,-266.414045554,117.823095999,-435.790922599,-13.9364486646,-757.673200249,-315.606545735,30.1075170333,-31.2175922843,42.8844869689,-630.735966251,203.926295041,-55.3265403164,-48.34786695,164.448173596,-60.0894525414,290.260936294,-74.4778802708,-185.44275302,-29.7984147866,-49.6466493784,238.198602924,59.6630009027,13.5729627482,90.9405401378,13.5311992555,-22.8797374753,-46.3163834038,-62.5566306478,-62.6004495214,5.38700747177,-45.5552624739,3.49047696502,-16.2162640892,-62.9009754212,5.31852520363,9.30773909624,8.19532427928,-5.97414723564,-2.44650602265,-6.2751536416,-15.5754912232,22.7722976777,-23.3730438352,-14.4003554489,-11.1255001344,0.416397350157,5.22831854708,16.4018458491,13.735604306,0.0333558872562,0.0855618115267,-2.86198498367,-2.51873794355,5.98449189686,0.575985288866,0.81080639044,1.11077284908,-0.402238727739,-3.50020109104,9.35163091653,0.785757748046,6.94345110406,1.08170403834,-2.34752314458,-3.46142485039,-1.63720056287,0.00817685994204,-0.921434239745,-0.65784220304,-1.2619654503,1.00508528316,-2.95074349513,1.12451578649,-2.00811983688,1.05451325919,1.313515244,1.11276117203,1.12831780647,0.951545369115,1.44809922139,-0.448618556924,1.63602435212,-1.3665704245,0.759377027697,-0.536438746815,-0.0493875573927,0.119373083142,-0.418964810516,-0.496034302175,-0.459246647975,-0.52342588625,0.297467628276,-0.306773087581,0.534278819524,0.322162883092,0.62063400755,0.706896538522,1.36942097141,1.18553955793,0.495463236124,0.485926932491,-0.621322442111,-0.223616237613,-0.055392937158,-0.0709817221712,0.212335692416],[-34948.1675884,-664.167655775,-184.218559537,-1753.56535169,-265.771878912,1733.28566246,962.57386452,727.65836365,-1488.0362482,295.526856043,328.826966797,118.612620796,-499.866951469,-933.790415626,-267.406914949,114.892967521,-455.531433344,-16.3828663794,-761.711092432,-307.358843436,41.0775867354,-25.5237556917,42.309613146,-646.8992536,205.602388592,-62.73967285,-43.777297933,163.792034375,-59.6149160998,296.31307759,-73.7988341669,-183.378037702,-34.3353927871,-49.1304618934,235.936699845,61.5672891677,12.5283094727,92.7867343264,12.7721503368,-21.8637760819,-45.200078913,-61.9338850986,-60.3275419738,5.85446502381,-45.485543842,1.5287362216,-16.7768901407,-64.8641906142,5.7089452918,9.36264594881,8.3156961548,-6.53970782427,-1.78575974292,-5.88166202633,-15.3662231161,24.0088543881,-23.4477272277,-14.1104856835,-11.9324923921,0.234330972248,4.45742637242,16.5929676454,13.5048528396,0.153368316776,0.102488111752,-2.90155751663,-2.6902300158,6.26335949478,0.539777991023,0.964070008261,1.37676352329,-0.338490125337,-3.30306740411,9.25310080093,0.834520521673,6.68196111564,1.15907157638,-2.54917927398,-3.41123519213,-1.70155098691,0.0356579213236,-0.899257424058,-0.693500762457,-1.30920569026,1.04172740414,-3.01321456002,1.17756201743,-1.97687942542,1.10684034019,1.38907517783,1.09365945003,1.14740504422,0.872076891861,1.4829689995,-0.53242183907,1.70092379501,-1.4203465987,0.777731213719,-0.555033633302,-0.043319788831,0.13935752596,-0.427503112365,-0.505306904659,-0.467160575791,-0.5465969863,0.307567679235,-0.312771797798,0.546978941749,0.335209629344,0.628664931137,0.720176111667,1.36597114074,1.20895367932,0.479991142695,0.512508520161,-0.641735158362,-0.210023205607,-0.0623835429758,-0.066911718412,0.212310878697],[-34876.2739701,-638.781280949,-185.280327573,-1800.10650838,-268.413366321,1696.72461603,981.401632841,759.433537211,-1503.37885882,295.251103201,313.422208599,127.499599952,-472.581454981,-954.116537506,-270.601569707,110.790695855,-474.571641051,-18.7835893232,-764.918889378,-297.295894064,52.6337146404,-19.751426145,42.3554382099,-661.542462147,206.801668316,-70.2283379898,-39.2345779629,163.037034963,-58.3835327568,302.502333363,-72.7499199486,-181.053125968,-38.6061467803,-48.1344706198,233.509728785,63.3837568798,11.2964845607,94.484353909,11.9614120599,-20.8051168272,-44.0778134951,-61.0731701644,-58.0279213376,6.3332891771,-45.1709866048,-0.377416458407,-17.3913764464,-66.8313702318,6.14657229166,9.37302739529,8.40807395068,-7.13461329381,-1.2074980218,-5.52355772739,-15.1168058925,25.1952299032,-23.4740220987,-13.8153455024,-12.6865758836,0.0373526752899,3.70189671056,16.765286914,13.3155376861,0.296534505982,0.131567182118,-2.94133086465,-2.86948923801,6.50770666248,0.491085443164,1.10126401632,1.62460673275,-0.268345768616,-3.12670219915,9.16815474201,0.874153588977,6.43394782972,1.23107078053,-2.7276506532,-3.35261407247,-1.76332618379,0.0651808897671,-0.869598237684,-0.724445738075,-1.35529067266,1.07413744545,-3.07601893803,1.21940935663,-1.94672257669,1.15546719869,1.45627915559,1.07757741682,1.16060644553,0.797009455529,1.51358350659,-0.609075931228,1.76565122102,-1.46928759586,0.795865286957,-0.573404374031,-0.0385275289252,0.16090577069,-0.434999831155,-0.512549325782,-0.473407414151,-0.56912856246,0.31569932178,-0.317726651245,0.557407539845,0.347779747529,0.635824970188,0.73061333099,1.36273281869,1.22939084712,0.464853460315,0.538107445537,-0.660744344253,-0.197192248565,-0.0690831703809,-0.0633629855318,0.212402425776],[-34793.4085404,-604.572242368,-191.59264692,-1850.49418803,-269.832606619,1657.3686546,1002.81639887,787.552257869,-1518.34441503,295.409435189,299.32378332,135.761285134,-446.741088712,-973.927107686,-276.604738427,105.422962336,-492.357042761,-20.9242876319,-767.140912097,-285.061736076,64.8227108262,-13.957597286,43.2342859468,-674.579103272,207.384567099,-77.7229029066,-34.7200467357,162.260710525,-56.2414443613,308.800437,-71.237800196,-178.450864017,-42.5730211692,-46.607473963,230.948644284,65.0861741995,9.85111958512,96.0082378105,11.1199075224,-19.687631244,-42.964477864,-59.9288703468,-55.7108147473,6.83946476648,-44.5842927691,-2.21264487033,-18.0345704733,-68.7948794732,6.63549546682,9.32758588803,8.46001094542,-7.75581214583,-0.726508769187,-5.20590545503,-14.8170611413,26.3137003414,-23.4350266323,-13.5180933857,-13.3745854793,-0.165380452277,2.97176481403,16.9204471748,13.1722991576,0.466151150571,0.172220861993,-2.98155917623,-3.05788640382,6.71039519907,0.428479933092,1.21891819724,1.84865975886,-0.188238447845,-2.9766195462,9.10081469763,0.904297095965,6.20264198492,1.29814461058,-2.87981281516,-3.28542524512,-1.82080208172,0.0970431345024,-0.831465508463,-0.750095281302,-1.40013417908,1.10143686093,-3.13878304781,1.24797384042,-1.9184764388,1.20009411081,1.51294007657,1.065666589,1.16655627101,0.727528601144,1.53971591758,-0.677203551323,1.83008950228,-1.51206275125,0.813848309622,-0.591100595774,-0.0353021852963,0.184171550759,-0.441166444045,-0.517614207672,-0.477703197036,-0.590803164269,0.321398587904,-0.321456554862,0.565065543588,0.359543049381,0.642187957851,0.737491523659,1.35981987485,1.24634128883,0.450202311867,0.562443801237,-0.677970775049,-0.185305844753,-0.0752368793944,-0.0604034285231,0.212724904163],[-34700.2247622,-575.377118109,-207.145683085,-1900.04678634,-270.896279493,1615.80179593,1024.31426511,808.734632675,-1531.99618656,296.516405936,287.119876843,142.639640018,-423.203270758,-993.41613883,-286.086437617,98.8549289001,-508.267472292,-22.565378281,-768.331098986,-270.374349341,77.5347217553,-8.27778251034,45.1144645056,-685.990530612,207.238488447,-85.0987264401,-30.2297515969,161.540433287,-53.0620776996,315.148619801,-69.1933971044,-175.554483716,-46.2270174677,-44.4927912102,228.270988716,66.6464473526,8.18879932678,97.3362154335,10.2777719949,-18.4951387663,-41.8744820937,-58.4644513641,-53.3921547271,7.38380181591,-43.7059557503,-3.96090773723,-18.6771586356,-70.7403432915,7.17594918978,9.21856467952,8.46077397884,-8.39549267082,-0.3542500955,-4.93173182142,-14.4583511934,27.3455321287,-23.3162300442,-13.2224311138,-13.9854143663,-0.363381595924,2.27605351431,17.0597376823,13.078958527,0.663751029843,0.223247342278,-3.02258783465,-3.25541502109,6.86547399163,0.351714270764,1.31426140959,2.04392703103,-0.0948943591272,-2.85786407288,9.05437055046,0.924972047102,5.99110262064,1.36105870675,-3.00250615905,-3.20925911098,-1.87172810326,0.131284129607,-0.784399188895,-0.770039351004,-1.44353175614,1.12290457333,-3.20079566062,1.26171002035,-1.89274634793,1.24056449635,1.55702399279,1.05896072399,1.16408842767,0.664754652415,1.56126770098,-0.735602658492,1.89408203896,-1.54734037366,0.831633939641,-0.607640407666,-0.0338788860652,0.209154759663,-0.445753190207,-0.520425310578,-0.479790541974,-0.611353147205,0.324302289656,-0.323742862665,0.569564415495,0.370181275705,0.647853904638,0.740192407073,1.35731355731,1.2593973449,0.436164902176,0.585290208869,-0.693023504954,-0.174497213393,-0.080588819314,-0.0581040899942,0.213376710764],[-34601.7466581,-567.737465289,-234.44702543,-1944.23298748,-274.312201677,1572.15791134,1042.02787265,819.625803548,-1542.96346311,298.545760755,277.142648097,147.232720935,-402.857687651,-1012.83821013,-299.563983584,91.3459256885,-521.734349034,-23.5342575376,-768.561807442,-253.125311991,90.5093945902,-2.83960629448,48.0558348954,-695.725078128,206.322158536,-92.1874869777,-25.760070562,160.931607154,-48.7838729655,321.465766746,-66.5812941048,-172.372942503,-49.5771958683,-41.762467532,225.478111291,68.0416522012,6.33595240202,98.4550552876,9.46963026598,-17.2167511456,-40.8192919013,-56.6650206424,-51.0964415365,7.97068681089,-42.5337619653,-5.6043761619,-19.2930749254,-72.6500593982,7.76269698126,9.04525414045,8.40383066751,-9.04090719937,-0.0973745990071,-4.70145520537,-14.0360272568,28.273174128,-23.1081242356,-12.9342860476,-14.5111372832,-0.549564810121,1.62109985894,17.1821991029,13.0372695798,0.888199395402,0.283291483585,-3.06468915678,-3.46023038608,6.96944525994,0.261818397758,1.38561199475,2.20679066567,0.0138077444306,-2.77487617202,9.03085108138,0.935852238862,5.8017217458,1.42041774303,-3.09350782835,-3.12360149318,-1.9142080674,0.167506135678,-0.728693474599,-0.784141213526,-1.48506732243,1.13817525892,-3.26101263534,1.25990360465,-1.86983544418,1.27683115996,1.58692676235,1.05821385966,1.15231505885,0.609603538209,1.57810081696,-0.783531679226,1.95731958023,-1.57411557729,0.849097228903,-0.622611604975,-0.0344192806137,0.235612129758,-0.448609578944,-0.520979180165,-0.479493495026,-0.63046808692,0.324228677694,-0.324345679961,0.570706162585,0.379453761775,0.652936286111,0.738268956302,1.3552568233,1.26826515759,0.422811528436,0.606461456602,-0.705619749455,-0.164839485969,-0.084986562036,-0.0565246198727,0.214396217936],[-34504.5463331,-590.604908159,-272.011423521,-1980.57165007,-282.428843974,1526.59364511,1053.21963339,819.068454918,-1550.16144797,300.894068667,269.227568806,148.957017175,-386.218427873,-1032.61155527,-316.825788927,83.2573716462,-532.453230707,-23.8597797709,-767.986156465,-233.421410321,103.41418727,2.4045897941,51.9593712507,-703.617767945,204.684883179,-98.8305180598,-21.3222619156,160.451152293,-43.4587505212,327.670540805,-63.3919721824,-168.974134683,-52.600000872,-38.4507058612,222.583241117,69.2640699754,4.34642579012,99.366070558,8.72576729712,-15.8598278159,-39.8051324668,-54.547333457,-48.8563387082,8.60324230933,-41.0947134953,-7.12281189785,-19.872443058,-74.5095641831,8.3859875802,8.8162314849,8.28945031542,-9.67641131391,0.0428919129586,-4.51220283427,-13.5540143904,29.0840752785,-22.8094197658,-12.663787593,-14.9470955935,-0.724659180312,1.01023094303,17.2838039335,13.0456829517,1.13539536133,0.351248192098,-3.10773837857,-3.66859858958,7.0224741005,0.160954515301,1.43204042365,2.33597057388,0.137654024186,-2.73084776136,9.03083500979,0.935320798941,5.63570443303,1.47532526737,-3.15279896963,-3.02859148429,-1.94739672768,0.204791100425,-0.665504021433,-0.792614907501,-1.52412842212,1.14747458587,-3.31828395029,1.2428818875,-1.84964682406,1.30881763601,1.60192864562,1.06363218412,1.13068410798,0.562579297962,1.58977925233,-0.821013405402,2.01929909011,-1.59213616933,0.866139941372,-0.635899786392,-0.0369823780698,0.263025919145,-0.449735458516,-0.51937362786,-0.476759045741,-0.647853865573,0.321275298199,-0.323055413522,0.568515099949,0.387291983362,0.657507702857,0.731570349239,1.3536577483,1.27278458238,0.41012561108,0.625778980894,-0.715716946896,-0.156351587026,-0.0884624781678,-0.0556930024961,0.215745388731],[-34413.6333505,-640.295031312,-314.11113434,-2009.2394856,-295.588653175,1479.2056477,1057.34750658,808.395125719,-1553.21827051,302.580966916,262.670438224,147.89931096,-373.290765146,-1053.1091401,-336.795474102,74.9340126927,-540.45147065,-23.7802266869,-766.744623908,-211.601895289,115.92038917,7.70671646923,56.5574841645,-709.363314461,202.450739592,-104.909366978,-16.9448777132,160.077202671,-37.2695684633,333.704075997,-59.6387843757,-165.476853275,-55.2255707206,-34.6551213132,219.608884202,70.323039573,2.29143118514,100.086917293,8.06695307722,-14.4528070241,-38.8265289943,-52.1636406316,-46.707487027,9.28270157812,-39.4462070495,-8.49316581251,-20.4235042053,-76.3062295892,9.03248751323,8.54756072836,8.12537385094,-10.2856234405,0.0715664855358,-4.3579164806,-13.0264850413,29.772883602,-22.4274782908,-12.4239756686,-15.291666793,-0.897702756427,0.44340178551,17.357005595,13.0987628253,1.39867489237,0.426053160215,-3.15128551653,-3.87567540684,7.02875128669,0.0517504761749,1.45342165282,2.43306300496,0.273701239572,-2.72689586157,9.05319510808,0.92051271982,5.49300363261,1.5232936647,-3.18273069611,-2.92499701584,-1.97167444658,0.241889859865,-0.596843798084,-0.796114646029,-1.56012058961,1.15166252329,-3.37167686848,1.21206086619,-1.8317435394,1.33635639924,1.60244052544,1.07485369787,1.09923735321,0.523821299436,1.59560068602,-0.848881195728,2.07928954163,-1.6020397516,0.882682497687,-0.64770413639,-0.0414755735315,0.290654829029,-0.449295964562,-0.515837133613,-0.471697794056,-0.663332415444,0.315826101412,-0.319795819035,0.563254691649,0.393817829089,0.661587356416,0.720320391832,1.35249406386,1.2729492175,0.398024764116,0.643087232908,-0.72353440447,-0.148964754732,-0.0912590437954,-0.0555926983449,0.217293228287],[-34332.374995,-702.947981412,-353.996863693,-2032.73838753,-311.981799736,1429.95871312,1056.37593959,790.347755788,-1552.56923615,302.550085956,256.463755738,144.808235804,-363.772733205,-1074.53768831,-357.882953308,66.5967867138,-546.032761919,-23.6620964559,-764.901450835,-188.150678776,127.809305269,13.4464650013,61.5485175124,-712.634749474,199.774407728,-110.370473139,-12.66743834,159.763366628,-30.4853346566,339.543788991,-55.3441401839,-162.009339244,-57.3600121524,-30.5013384166,216.582825776,71.240790591,0.241809264816,100.643978842,7.50222819252,-13.0406051346,-37.8659892498,-49.5873235611,-44.678784088,10.0074867299,-37.6592221313,-9.6958318065,-20.9624049776,-78.0271061191,9.68871081896,8.25838080907,7.92387222811,-10.8544642141,-0.00267497214454,-4.23042295595,-12.4747873608,30.341000228,-21.9751512237,-12.2275468479,-15.5456014726,-1.08075128261,-0.080302965305,17.3935096721,13.1890304651,1.67041783835,0.506793308698,-3.19468156894,-4.07661755786,6.99495042921,-0.0633604625977,1.44990507259,2.50176021665,0.417292721207,-2.76197802047,9.09557960499,0.888415101045,5.37282685553,1.56118590895,-3.18714746493,-2.81405028342,-1.98795248741,0.277485588757,-0.525073823434,-0.795550176427,-1.59259767576,1.15197281267,-3.42063924484,1.16945111581,-1.81551224174,1.35922647501,1.58975864851,1.09117451151,1.05861528783,0.493296585477,1.59492291859,-0.868408274987,2.13654489287,-1.6049778291,0.898676716316,-0.658388829109,-0.0477006512113,0.317697594874,-0.447544173553,-0.510676526879,-0.464521932378,-0.676868673607,0.308422813822,-0.314641392069,0.555328543279,0.399268902926,0.665168801279,0.705037698554,1.35174722884,1.26891657794,0.386421264084,0.658291914902,-0.729437598612,-0.142542476229,-0.09371723711,-0.0561906105176,0.218869001319],[-34263.4356024,-763.223883044,-386.535886273,-2054.08057055,-329.137831253,1379.04948889,1053.27735567,767.513541617,-1549.00692889,299.89543146,249.766602269,140.660217553,-357.354089384,-1096.94530446,-378.560525377,58.3591368167,-549.60664002,-23.8457041802,-762.48408899,-163.557064475,138.979118983,19.9885067792,66.7127783803,-713.23109862,196.799871805,-115.209200948,-8.52729832304,159.455696689,-23.3778050899,345.191938298,-50.5304035208,-158.672743001,-58.9287036794,-26.1004935563,213.53300791,72.0432901346,-1.74206943867,101.063123327,7.03201015623,-11.6700806816,-36.9042280217,-46.8909161851,-42.7880191688,10.7740043119,-35.7970043527,-10.7187003973,-21.5000653938,-79.6593380462,10.3430674527,7.9670856513,7.69672328258,-11.3725393199,-0.169985173831,-4.12214119857,-11.9205249693,30.7934615993,-21.4659510401,-12.0832651053,-15.711573661,-1.28213876399,-0.560552581485,17.3873502507,13.309311112,1.9434459184,0.592691945751,-3.23748106137,-4.26723996311,6.92803899193,-0.182533029276,1.42193599238,2.54600516346,0.563990192424,-2.8335373585,9.15542957745,0.837401087365,5.2744422663,1.58655612027,-3.17005666434,-2.6971680927,-1.99694509215,0.310388629387,-0.452391448013,-0.79187785906,-1.62122657198,1.14956506529,-3.46496616882,1.11713314511,-1.80053397847,1.37739176996,1.56547221495,1.11189195878,1.00992880505,0.471009654917,1.58752840757,-0.880791183109,2.19054593182,-1.6020927986,0.914116980854,-0.668284906953,-0.0554369773923,0.343443197557,-0.444721468741,-0.504199860687,-0.45550556008,-0.688507047787,0.29958872545,-0.307803615828,0.545182782439,0.403843952335,0.668292680727,0.68636997909,1.35145856105,1.26102237118,0.375304433287,0.671400335294,-0.733765399937,-0.136924351824,-0.0961218786652,-0.0574563870355,0.220327693828],[-34207.5455922,-811.86879091,-410.741955271,-2075.42582893,-345.338527912,1327.20347151,1050.76440772,741.928886564,-1543.2745123,294.004806585,242.065768178,136.111128555,-353.822588339,-1120.49111835,-397.605497307,50.3157475881,-551.529606753,-24.5892796245,-759.569090547,-138.240654652,149.384739535,27.6167378723,71.9254090246,-711.136221267,193.655225278,-119.430120075,-4.55148356934,159.1008105,-16.1876917778,350.641012767,-45.226817483,-155.55814334,-59.8893851191,-21.5433548499,210.489188138,72.7536090799,-3.60353637022,101.366241975,6.65563322855,-10.3857476107,-35.9278332465,-44.1392689444,-41.0480878871,11.5758872546,-33.9133246868,-11.5615142784,-22.0416580629,-81.1923473796,10.9850918463,7.69166278024,7.45351520879,-11.8304439076,-0.419952521766,-4.02633178969,-11.382598993,31.1358641207,-20.9133207533,-11.997862066,-15.7939226413,-1.50604840029,-0.995191820057,17.3359023216,13.4536396468,2.21102575707,0.682957198534,-3.27941799162,-4.44334723879,6.83465720831,-0.30409307984,1.37020885115,2.56919456595,0.709986950149,-2.93852711197,9.23017508792,0.767011142809,5.19701331656,1.59755955245,-3.1353619326,-2.57609276065,-1.99890351948,0.339464375242,-0.380796189604,-0.786032222588,-1.64559490289,1.14537356151,-3.50452593677,1.05710795105,-1.78655530377,1.39105466555,1.53114972206,1.13634048812,0.95442121848,0.456964802633,1.57353053398,-0.887033735052,2.24101221736,-1.59437669706,0.929053425494,-0.677665625438,-0.0644812268005,0.367260617819,-0.441041303759,-0.496692274638,-0.444953650342,-0.698279909816,0.289792459418,-0.299551625721,0.533273161195,0.407650623791,0.671037547083,0.664967914213,1.35171195796,1.24969009902,0.36473108861,0.682458637134,-0.736806206312,-0.131965228212,-0.0986605509432,-0.0593754000796,0.221574215893],[-34164.06552,-846.231229195,-427.588632701,-2098.1069107,-360.134601269,1275.56217387,1050.74773243,714.955308643,-1535.89538321,284.478655918,233.138410544,131.428428107,-353.030140002,-1145.39908942,-414.126507292,42.571589218,-552.091789579,-26.0721055672,-756.318374236,-112.570933898,158.982795071,36.4943618902,77.1001416404,-706.507112451,190.453190601,-123.033279808,-0.756419122205,158.642492745,-9.12060172184,355.86534953,-39.4869545936,-152.75066289,-60.2443279144,-16.9033273808,207.478156818,73.3886967229,-5.28716837938,101.571678083,6.37245361553,-9.22592812948,-34.9323536746,-41.3905753052,-39.4722521151,12.4017003526,-32.0539782671,-12.2343278725,-22.5871290566,-82.6183352083,11.6046724684,7.44924289631,7.20232807225,-12.2196469745,-0.741420456627,-3.93770095814,-10.8766312609,31.3735185382,-20.3314046147,-11.9761206939,-15.7995232554,-1.75264426481,-1.38175451305,17.2393126281,13.6168451349,2.46683879193,0.776690776614,-3.32031846382,-4.60060512741,6.72110122581,-0.426301996651,1.29593730297,2.5740912305,0.85202359719,-3.07365149689,9.31706051942,0.678047001882,5.13949289934,1.5930256875,-3.08674469153,-2.45271559154,-1.99373140559,0.363632939864,-0.312130814777,-0.778867169115,-1.66518681584,1.14013272003,-3.53916906243,0.991329500368,-1.77343873582,1.4006059284,1.48826071732,1.16381183326,0.893397458711,0.451025492348,1.5533131351,-0.88801744983,2.28785040348,-1.58268087689,0.943582838558,-0.686742153193,-0.074645443609,0.388582247051,-0.436703271055,-0.488408332555,-0.433180336616,-0.706189142806,0.279461836498,-0.290166658241,0.520054646222,0.410717973359,0.67349087253,0.641460088243,1.35259671711,1.23541410293,0.35479242602,0.691549049512,-0.738805802293,-0.127530189726,-0.101428617781,-0.0619334107964,0.222557151116],[-34131.8501921,-869.047499063,-438.405324592,-2122.8170413,-374.374506057,1225.33879805,1054.03312427,687.27223069,-1527.13306086,271.052037183,223.049454001,126.509536989,-354.896589472,-1171.90100823,-427.592850235,35.2480091749,-551.50934103,-28.3865408474,-752.962718839,-86.8952252017,167.6729197,46.6334084014,82.1589669863,-699.629408341,187.286300871,-126.006597869,2.85335125929,158.018689022,-2.3482100371,360.817963447,-33.401980335,-150.322001816,-60.0473900927,-12.2428574352,204.515268003,73.9574354804,-6.7422064894,101.695101762,6.18339992532,-8.21899025798,-33.9219288571,-38.6991217228,-38.0756490895,13.2305062266,-30.2576598292,-12.7544605037,-23.1308486485,-83.9305015737,12.1912247947,7.25441457935,6.94996766359,-12.5326268544,-1.12265636611,-3.85238371474,-10.4151688707,31.5113167818,-19.7352337837,-12.0200921704,-15.7379898753,-2.01842293949,-1.71857834917,17.0993403665,13.793804516,2.70517942437,0.872669525466,-3.36013504068,-4.73480979335,6.59323710475,-0.547226199564,1.20119099648,2.56296840369,0.987224145449,-3.23532321088,9.41292360474,0.572511762553,5.10060969143,1.57255706257,-3.02766430233,-2.32888322135,-1.98113289389,0.381993172169,-0.24810267537,-0.771139328057,-1.67949959168,1.13443998558,-3.56868975114,0.921706927397,-1.76112761352,1.4065666954,1.43818270507,1.19352434343,0.828271217853,0.452822038045,1.52749573685,-0.884585048076,2.33103605079,-1.56769604802,0.95783246733,-0.69564063558,-0.0857340723654,0.40690911385,-0.431889938429,-0.479589833924,-0.42050230456,-0.712224594445,0.268988824946,-0.279917638816,0.505982354602,0.413038517424,0.675727305567,0.616447389486,1.35416478784,1.21873058964,0.345590326732,0.698779612925,-0.739957751611,-0.12348308489,-0.104451964026,-0.0651086923173,0.223251293417],[-34109.2263426,-883.861744641,-443.742649738,-2149.82991154,-388.776036461,1177.28675948,1060.66065851,658.991816402,-1517.14690042,253.706666288,212.068375595,121.28632448,-359.260133842,-1199.94649977,-437.871083588,28.4032169952,-549.947442907,-31.5491789329,-749.691142245,-61.5389188903,175.324881781,57.9074240508,86.999709077,-690.844770342,184.213763774,-128.340577514,6.27452841209,157.173126907,3.98567740598,365.45255054,-27.0809663819,-148.319290977,-59.3965090364,-7.61047526524,201.598008122,74.4634391255,-7.93277178553,101.749271589,6.08930100664,-7.38306774113,-32.9024031279,-36.1144416389,-36.8723557691,14.0331628498,-28.5558965595,-13.1388799516,-23.6597968434,-85.1202329707,12.7344382255,7.11699348573,6.7022129521,-12.7639382917,-1.55243057993,-3.76734839399,-10.0083618424,31.5547943113,-19.139493181,-12.1285699368,-15.6206774603,-2.29721433343,-2.00608357068,16.9178712844,13.9790328411,2.92144506006,0.969437125157,-3.39890803325,-4.84262353342,6.45627888078,-0.664948534879,1.08882160901,2.5381690679,1.11302563948,-3.41964879131,9.51415082486,0.453309478149,5.07891624796,1.5367355795,-2.96124889615,-2.20612369104,-1.96076189825,0.39399560226,-0.190186079619,-0.763500227341,-1.68823400816,1.12882347661,-3.59289658838,0.850036759534,-1.74959492336,1.4094688094,1.38225075068,1.22464079638,0.760602775815,0.461788918412,1.49686826668,-0.877627555857,2.3704519442,-1.54997971519,0.971889921199,-0.704307481828,-0.0975381551326,0.421852113925,-0.426752620135,-0.470472902626,-0.407232138431,-0.716407287499,0.258714858198,-0.269070077785,0.491493195861,0.414617162417,0.677796817246,0.590510245663,1.35639938422,1.20019420355,0.337206202637,0.704288444744,-0.740414995223,-0.119664857021,-0.107713585036,-0.0688616439285,0.223618194259],[-34093.4809869,-892.848447327,-443.317981996,-2178.76460785,-403.813582977,1131.96962126,1070.43289595,630.526342976,-1506.07974137,232.674671002,200.614979443,115.903744393,-365.864064533,-1229.27585179,-445.097607037,22.0635573463,-547.518544621,-35.5401971848,-746.617791735,-36.789394419,181.813431499,70.1518070053,91.5082326718,-680.49555233,181.270446903,-130.037236231,9.50630949174,156.058767574,9.76954932089,369.732259577,-20.6372470581,-146.776264941,-58.4111459442,-3.05210626097,198.719749963,74.9052445765,-8.83795799351,101.745566569,6.09040497267,-6.73020728519,-31.880000146,-33.6793135257,-35.8730796491,14.7803897876,-26.9722033156,-13.3996362121,-24.1557709463,-86.1781500325,13.2248930136,7.04295554975,6.46388507873,-12.9108693154,-2.01985372749,-3.67996526941,-9.66367452238,31.5105507369,-18.557356268,-12.2981147837,-15.4587709687,-2.58165421993,-2.24529457767,16.6966787558,14.1668563618,3.11212489048,1.06535419246,-3.43652421257,-4.92167074845,6.31484493704,-0.777605506794,0.962063548454,2.50202667074,1.22715566653,-3.62245246733,9.61718384201,0.323969498748,5.07301490584,1.48679372626,-2.89050672938,-2.08579782684,-1.93239909942,0.399385167615,-0.139566402324,-0.756505113552,-1.69125787786,1.12374576815,-3.61163760123,0.77794589105,-1.73876831413,1.40980800438,1.32178943363,1.25629367169,0.691955237938,0.47724773921,1.46225223098,-0.868000400577,2.40589776409,-1.52994732709,0.985845108245,-0.712551737655,-0.109839117939,0.433138941525,-0.421425985734,-0.461278976595,-0.393662608833,-0.718780435883,0.248944908093,-0.257879553891,0.476972802297,0.415473994084,0.679708899823,0.564187666619,1.35922986989,1.18034623582,0.32969572284,0.708219753592,-0.740305506946,-0.115915564147,-0.111164992464,-0.0731358134348,0.223608962931],[-34081.0734812,-896.868257353,-436.439689925,-2208.70700338,-419.401275785,1089.82073302,1082.82471158,602.159155134,-1493.94657285,208.44190904,189.20047112,110.688672947,-374.367566477,-1259.36202752,-449.513555835,16.2439275457,-544.292956129,-40.2919338475,-743.755035491,-12.9107639399,187.039091532,83.1530003361,95.5482155535,-668.929359464,178.470196758,-131.099799137,12.5413728658,154.648691204,14.9179443663,373.626641387,-14.1936587871,-145.709512595,-57.2279139027,1.38708784401,195.871503213,75.2765705116,-9.44867199064,101.69236739,6.18519488411,-6.26541627487,-30.8602635947,-31.4324431116,-35.086093301,15.4422748001,-25.5255414638,-13.5424798198,-24.5982613106,-87.0934271431,13.6536741241,7.03462666851,6.2390534936,-12.9732357574,-2.51431786981,-3.58842581909,-9.38630732144,31.385502275,-18.000248504,-12.5231727326,-15.2621426566,-2.8636232938,-2.43800944942,16.4368958994,14.3512663799,3.27455642839,1.15864885422,-3.47268411837,-4.97064821247,6.17292147811,-0.883431495957,0.824601230133,2.45691140595,1.32768309025,-3.83932054294,9.71858908072,0.188377953217,5.08172092974,1.42433558337,-2.81810887589,-1.96894026359,-1.89603694911,0.398175972891,-0.0972089546975,-0.750571751543,-1.68857510686,1.1196324122,-3.62478608407,0.706960941579,-1.72851436242,1.40796828457,1.25809861342,1.28763110014,0.623849968562,0.498503770184,1.42443784785,-0.856551197577,2.43707861814,-1.50795902679,0.999727322452,-0.720117743505,-0.122416755723,0.440597238364,-0.416029597505,-0.452198372458,-0.380062416731,-0.719402444059,0.239947794668,-0.246577780597,0.462755965779,0.415647149868,0.681431302522,0.537964759938,1.3625437175,1.15967546469,0.323083373136,0.71070293503,-0.739736232394,-0.112080811909,-0.114746464781,-0.0778495072871,0.223160795157],[-34067.6154468,-898.565629114,-424.971091686,-2238.20715817,-435.259374791,1051.04990419,1096.55705562,573.792632741,-1480.54812065,181.692977964,178.328095521,105.844861793,-384.456261615,-1289.58417668,-451.467325683,10.9534727385,-540.274105011,-45.7028371028,-741.071696762,9.8408226471,190.923049372,96.6078329469,98.9726490328,-656.529059176,175.809302301,-131.523099279,15.3638100948,152.938030621,19.3638209962,377.095486126,-7.88473070004,-145.12930476,-55.9986337998,5.66615269681,193.046034726,75.5656696163,-9.76333217602,101.593978226,6.37200375487,-5.98724689741,-29.8494953649,-29.4105947303,-34.5182148758,15.9845180027,-24.2318921447,-13.5723993645,-24.9671709038,-87.8564154835,14.0120642286,7.09095101253,6.03145050291,-12.9518450392,-3.02577192212,-3.49133263491,-9.17939878455,31.1865759092,-17.4792006479,-12.7965530492,-15.0399161871,-3.13458103676,-2.58669950866,16.1395569054,14.5265114487,3.4068050084,1.24734910111,-3.50688080001,-4.98897534332,6.03392164641,-0.980516185002,0.680421477783,2.40543101634,1.41280021711,-4.06577243918,9.81473178522,0.0504083272439,5.10371639006,1.3510137664,-2.74640291088,-1.85645708241,-1.85179816818,0.390636394918,-0.0639320993672,-0.745969133953,-1.68028555995,1.11683451895,-3.63213526285,0.638504892532,-1.71859247656,1.4041899023,1.19248499919,1.31775499174,0.557733280007,0.524838044425,1.38417454534,-0.844138756467,2.46364641161,-1.48436548088,1.01350733161,-0.726707174655,-0.135042633231,0.444135824322,-0.410675075221,-0.44340550163,-0.366681769244,-0.718331280109,0.231938557463,-0.235345751795,0.449138500571,0.415204204049,0.682891254152,0.512269678186,1.36618625613,1.13859556539,0.317358081135,0.711824233783,-0.738799279793,-0.108031400345,-0.118377547896,-0.082903661316,0.222207673339],[-34048.3906797,-902.212811104,-413.583902944,-2265.8315476,-451.279978319,1015.55950338,1109.99237691,545.13638922,-1465.56227582,153.165157359,168.395257241,101.420142632,-395.942027405,-1319.41602322,-451.321453901,6.21997296409,-535.435850279,-51.6865192625,-738.530112196,31.213956845,193.407671646,110.163390827,101.663452076,-643.692451722,173.280525107,-131.300741044,17.9498256631,150.936932179,23.0535836705,380.092540037,-1.85943082835,-145.040638944,-54.8738896661,9.74557666813,190.243902424,75.7582304813,-9.78397040519,101.450647819,6.64827341983,-5.89111318477,-28.8566878532,-27.6490655717,-34.1734897607,16.3727129282,-23.10325005,-13.4948915583,-25.2451515512,-88.4607238384,14.2922452924,7.2091761807,5.8446703139,-12.8485850381,-3.5450392873,-3.38775469873,-9.04452227968,30.9206080098,-17.0053921579,-13.110114557,-14.8002787888,-3.38597324241,-2.69349027213,15.8062111179,14.6875351226,3.50758945579,1.3295866871,-3.53826871052,-4.97642545045,5.90078907837,-1.06690930816,0.533433445478,2.35011782472,1.48065920257,-4.29731009121,9.90218633504,-0.0861289773209,5.13770986472,1.26832301098,-2.67741518444,-1.74927285597,-1.79978903121,0.377153699379,-0.0403587682003,-0.742793981336,-1.66647935054,1.11563440919,-3.63340671194,0.573851032733,-1.70867914619,1.39855749976,1.12623896363,1.34569986366,0.49487246037,0.555504573418,1.34212731164,-0.831521077048,2.48527402516,-1.45942729906,1.0271685714,-0.732055417092,-0.147505504768,0.443732463869,-0.405472727734,-0.43504123422,-0.353730011488,-0.715604128146,0.22509055428,-0.224305981246,0.436352573592,0.414228966528,0.683964088716,0.487459316236,1.36998096468,1.11745251909,0.312496906094,0.711618727081,-0.737551115927,-0.103680068008,-0.121953057565,-0.088197812313,0.220703202835],[-34019.0247608,-910.633175964,-408.14090808,-2290.85408866,-467.007890859,982.858527747,1121.73845559,515.828284245,-1448.73977163,123.565519489,159.720103245,97.5229919206,-408.648843877,-1348.19031536,-449.284638034,2.05137605646,-529.789486935,-58.1583936976,-736.048842331,50.999951615,194.521677406,123.486643433,103.561999185,-630.768594108,170.872066503,-130.443638429,20.2742338415,148.661957716,25.9491733592,382.591997764,3.74123808638,-145.416307074,-53.978550965,13.599883061,187.475714089,75.841106423,-9.51891076384,101.259391347,7.00654347006,-5.96928757899,-27.8892527514,-26.1770713103,-34.045731794,16.5783477764,-22.143693644,-13.3096847124,-25.4184829656,-88.9008618795,14.4885856876,7.38521270246,5.68215947997,-12.6678199782,-4.06417299414,-3.27779091857,-8.98164301149,30.5953281089,-16.5884138421,-13.4538373355,-14.5484882056,-3.60935464851,-2.75947787285,15.4382237156,14.8305507891,3.57651287461,1.40394009113,-3.56584161213,-4.93332813295,5.77585709374,-1.141211161,0.387292492072,2.29340580945,1.5295571223,-4.52931332543,9.97827024661,-0.217492962526,5.18310886288,1.17758886029,-2.61227994204,-1.64812851187,-1.73993980294,0.358216424443,-0.0268061107382,-0.741035372856,-1.6472343111,1.11623137273,-3.62840661451,0.514030103897,-1.69847870238,1.39101744622,1.0605696302,1.37056073249,0.436409158535,0.589982696575,1.29889443515,-0.819159059072,2.50164488494,-1.43323351364,1.04069127195,-0.735941697924,-0.15962784067,0.439452413816,-0.400533876593,-0.427184992763,-0.341369173526,-0.71126588568,0.219523042362,-0.213574316495,0.424557715122,0.412799944904,0.684486291307,0.463822926268,1.37377933726,1.09653886462,0.308515739712,0.710085485683,-0.735970665417,-0.0989673346986,-0.125349314547,-0.0936326394134,0.218602866736],[-33975.8496999,-925.799507413,-415.320583828,-2313.81126071,-481.967703147,952.452395038,1130.6456218,485.991895361,-1429.99486868,93.5062416547,152.602527329,94.1379088834,-422.291501445,-1375.30119761,-445.330605429,-1.55408865206,-523.412082245,-65.0396354639,-733.508002831,69.074513661,194.384305565,136.305620003,104.678636053,-618.058062558,168.575225556,-128.989922356,22.3156988665,146.133516712,28.0308066882,384.581565516,8.79270011905,-146.205993022,-53.3992686565,17.2217675171,184.762225587,75.8043047343,-8.98294821699,101.012901061,7.43415537458,-6.21315536863,-26.9530828146,-25.0142370935,-34.1189646505,16.5794991587,-21.3482061411,-13.0160620569,-25.4810326416,-89.1761655845,14.5983729743,7.61409772447,5.54697177412,-12.4167171702,-4.57688319374,-3.16230855595,-8.98876378124,30.2190962119,-16.2358124402,-13.816712974,-14.2863215528,-3.79724415346,-2.78480773062,15.0374863315,14.9538092251,3.6141928097,1.46962801171,-3.58848840401,-4.86059632445,5.66081055886,-1.20273944038,0.245286339826,2.23741731763,1.55810916969,-4.75726533285,10.0411592312,-0.340170041197,5.23975968445,1.07989288607,-2.55118382246,-1.55358548072,-1.6720162382,0.334401220437,-0.0232214315845,-0.740572906145,-1.62262491901,1.11870839238,-3.61708055581,0.459780900288,-1.68774932271,1.38147017444,0.996551729923,1.39157643606,0.383362521559,0.628000510699,1.25511096441,-0.80716699576,2.5125913236,-1.40571182898,1.05409248357,-0.738239102858,-0.171263774564,0.431461152105,-0.395966741528,-0.419844928582,-0.329707112118,-0.705392825763,0.21530152161,-0.203278133997,0.413854490049,0.410984082874,0.684270868505,0.441593566975,1.37748219481,1.07610821187,0.305465962074,0.707198942997,-0.733963294653,-0.0938702977929,-0.128422322562,-0.0991187761644,0.215869398941],[-33917.4482255,-947.627643048,-438.294457367,-2336.20924856,-495.932080669,924.320317751,1136.05551722,456.902719479,-1409.44834407,63.3369615271,147.285851511,91.1824459604,-436.39451742,-1400.22666111,-439.463879363,-4.64957295755,-516.459683198,-72.2886706696,-730.800016632,85.380138298,193.160048744,148.422367183,105.036582767,-605.801278712,166.385017406,-127.00434503,24.0663118309,143.35730202,29.2999541127,386.05184727,13.2054365434,-147.354857601,-53.1965485555,20.606159072,182.135824172,75.6434386823,-8.19774192594,100.704488193,7.91450062656,-6.61314255776,-26.0544011575,-24.1682429064,-34.3696776788,16.3614146417,-20.7038268323,-12.6106760956,-25.426343444,-89.2889487744,14.6221160826,7.89047751658,5.44176183188,-12.1038000441,-5.07849665757,-3.04304539595,-9.06219808592,29.8009185954,-15.9519583692,-14.1870914641,-14.0131684509,-3.94257508133,-2.76901935579,14.606573546,15.0562333841,3.62218017889,1.52662977494,-3.60540612962,-4.75959018543,5.55681101612,-1.25156415982,0.110200437921,2.18367527227,1.56549348472,-4.97687811061,10.089568433,-0.45078001077,5.30770146911,0.976659450075,-2.49397519833,-1.46612101052,-1.59597281308,0.306307997182,-0.0292415046258,-0.741268221046,-1.59280923436,1.12306036433,-3.59950901809,0.411538863705,-1.67642024705,1.36982382536,0.935110322115,1.40821429141,0.336631775107,0.669454963528,1.21152283048,-0.795392907265,2.51804661976,-1.37665214506,1.0674026968,-0.738771568926,-0.182310024137,0.419993042634,-0.391859711786,-0.412972929858,-0.318807849896,-0.698099958372,0.212457110678,-0.193581398974,0.404301929904,0.408825851568,0.683170108269,0.420961518698,1.38103405554,1.05640118012,0.303439416552,0.702960313111,-0.731377380159,-0.0883911677922,-0.131005559848,-0.104558558405,0.212480136327],[-33844.6082483,-973.848232167,-468.884213807,-2359.13292893,-508.369251589,899.145819857,1140.72661579,430.953941506,-1387.31746844,33.3166741143,143.523071633,89.0032318183,-450.269154089,-1422.21158055,-432.305953041,-7.44730889681,-509.146209162,-79.9536570056,-727.887418348,99.9242454841,191.147290742,159.639006896,104.539308257,-594.233383403,164.262519356,-124.580448133,25.5603771441,140.308302234,29.7855680885,387.027898016,16.9651683448,-148.807036989,-53.4081120534,23.7438963565,179.686358839,75.3605085623,-7.19486039174,100.341813335,8.43245792778,-7.1521545759,-25.195040577,-23.6196824675,-34.7561184865,15.9210699863,-20.1916080291,-12.0794935869,-25.234272416,-89.2387953089,14.5654779958,8.20735100697,5.36834675236,-11.7364508509,-5.56432501016,-2.92177901075,-9.19606806987,29.3550718492,-15.7364128121,-14.5514710744,-13.7280687113,-4.03499847214,-2.70988488024,14.1505466112,15.1338663856,3.60308773578,1.57534096169,-3.61721223629,-4.63238189881,5.46463607698,-1.28838911685,-0.0162707095978,2.13338366074,1.5519784388,-5.18371785705,10.1222223646,-0.546194797451,5.38735894261,0.870109334074,-2.44090626035,-1.38716812189,-1.51228820061,0.274482121884,-0.0442339249742,-0.743148460887,-1.5583723336,1.12914644868,-3.57604818543,0.369425304676,-1.66486275885,1.35608448498,0.877059331996,1.42025429967,0.296810159466,0.714326551546,1.16907290282,-0.783372737698,2.51785317268,-1.3458442428,1.08054845561,-0.737056897173,-0.192711520517,0.405358981482,-0.388238447618,-0.406541831165,-0.308738506418,-0.689584084774,0.211032031778,-0.184716770034,0.395929615307,0.406344403537,0.681190733606,0.402085689911,1.38444455934,1.03767405247,0.30265883917,0.697453212016,-0.728007317307,-0.0825807847268,-0.132826037327,-0.10977115441,0.2084741862],[-33760.3303873,-1003.38299522,-498.571465812,-2383.40648654,-519.500177495,876.654434043,1146.64890808,409.894438991,-1363.71876069,3.5606243501,140.925505886,87.8068875555,-463.364074352,-1440.49853289,-424.621963547,-10.1216295139,-501.644229451,-88.0516264342,-724.777852591,112.736166008,188.595800831,169.798092481,103.08049359,-583.530106418,162.172918211,-121.794735369,26.8536318103,136.963932942,29.5376073669,387.542197464,20.0898958882,-150.494845535,-54.0582364228,26.6384177581,177.488549506,74.9590018372,-6.00011055011,99.9382354935,8.97827065171,-7.80679544811,-24.3764822508,-23.3357093589,-35.2380977629,15.2633157918,-19.7902776394,-11.408795074,-24.8866750424,-89.0259679611,14.4352478625,8.55880079164,5.32809778786,-11.320063816,-6.02929004368,-2.80087458511,-9.38214489623,28.8936668954,-15.5859805524,-14.8984823606,-13.4305219187,-4.06602660177,-2.60691417084,13.6745363956,15.1835650729,3.55954999326,1.61631678039,-3.62504753985,-4.48074220677,5.38461512456,-1.31413496503,-0.132949244346,2.08680896814,1.51856123267,-5.37467710182,10.1382542333,-0.624003209829,5.47912236896,0.76277467833,-2.39160937314,-1.31772632474,-1.42151673227,0.239384942027,-0.0675138107564,-0.746379951519,-1.51984638057,1.13667491896,-3.54706185032,0.333337653201,-1.65366121265,1.34035053661,0.822710046525,1.4276784471,0.264126002897,0.762576438167,1.12867678022,-0.770536890224,2.51193671669,-1.31303886711,1.09339276577,-0.732610170806,-0.202435762577,0.387852361939,-0.385139100967,-0.400509723441,-0.299562946008,-0.680006964421,0.211004028943,-0.176901737352,0.388735196387,0.403478352192,0.678396086926,0.385015604925,1.38773126327,1.02014853723,0.303321374002,0.69081841152,-0.723640073972,-0.0764901836057,-0.133625581003,-0.11458579722,0.203895226726],[-33668.5332016,-1032.4418815,-521.679867192,-2410.0791465,-529.702615901,856.573476866,1155.14581583,395.693383046,-1339.01514184,-25.9468960417,139.213705283,87.7364845772,-475.263128361,-1454.55319505,-417.046398932,-12.813325998,-494.106824349,-96.572092469,-721.474722756,123.91972644,185.738323552,178.880703526,100.657171443,-573.773632989,160.093607345,-118.731593514,28.0107654953,133.31105467,28.6364156869,387.630005908,22.6259334986,-152.34998511,-55.1414693394,29.3038111369,175.596860452,74.4428332326,-4.63759394063,99.506760636,9.5430104085,-8.5541642488,-23.6007239584,-23.2752023887,-35.7785166833,14.404686927,-19.4729755706,-10.5895997687,-24.3727458365,-88.6554338479,14.2397554796,8.94037569862,5.32103582886,-10.8601964166,-6.46891442285,-2.68305335139,-9.60974843186,28.425127355,-15.4946375532,-15.2202352641,-13.1189310069,-4.03086794222,-2.45991285325,13.1836561372,15.205326648,3.49441394256,1.65029948172,-3.63007672456,-4.3064743461,5.3164636896,-1.33015691533,-0.239366562185,2.04299864313,1.4668433006,-5.54818308648,10.1378632139,-0.682536183814,5.58323864546,0.657035722846,-2.3450339004,-1.25824395571,-1.32411861133,0.201423215924,-0.0982512782323,-0.75117781595,-1.47763867108,1.14515774613,-3.51299864888,0.30288958912,-1.64350241997,1.32280266406,0.771888745334,1.43071966596,0.238461811971,0.81424174942,1.09112323762,-0.756111294549,2.50046673451,-1.27785193646,1.10583783917,-0.725072806267,-0.211472243606,0.367779169133,-0.38261130115,-0.394804450455,-0.29131904162,-0.66949954678,0.212265170912,-0.170334178618,0.382664156376,0.40006480843,0.674882415383,0.369681429166,1.39094513846,1.00399178382,0.305582704455,0.683209330669,-0.718065402031,-0.070195678069,-0.13319392978,-0.118893180452,0.198800506644],[-33573.6275966,-1057.32231932,-534.382005072,-2439.77136812,-539.907071728,838.716307737,1166.65504074,389.680256016,-1313.52190766,-55.2785998302,138.271384609,88.7655440558,-485.840233196,-1464.20554964,-410.208781681,-15.5908661743,-486.609468546,-105.450435629,-717.992199394,133.620168611,182.711521093,186.902288466,97.3480962314,-564.996747636,158.006952144,-115.457773009,29.1042654301,129.351556886,27.1962717712,387.315165774,24.6203803422,-154.305189458,-56.6461306151,31.7641074929,174.034801353,73.8109623653,-3.12724285036,99.0588811445,10.122425274,-9.36703504821,-22.8705823408,-23.3919646438,-36.3470443943,13.3643535694,-19.2078098184,-9.62290202339,-23.6883045016,-88.1369411502,13.9871366833,9.34795746449,5.34568322604,-10.3615445042,-6.87833052657,-2.57074678378,-9.86505193762,27.9535554096,-15.4551611302,-15.5111640263,-12.7927383373,-3.9272432764,-2.2701443678,12.6827994866,15.2012149569,3.41054563608,1.67771189515,-3.63354078435,-4.11132531902,5.25941981913,-1.33780045216,-0.335009420762,1.99987456439,1.39909990368,-5.70385846726,10.1218095517,-0.720518920317,5.69942040015,0.555177045937,-2.29975848768,-1.2085902998,-1.2204439698,0.161001072925,-0.135625537044,-0.757767799209,-1.43211375307,1.15393022015,-3.47430698724,0.277607447598,-1.63510250146,1.30383101458,0.724022844525,1.42981975777,0.219487281408,0.869269467295,1.0571427656,-0.739275383574,2.48385583885,-1.23979773555,1.11783497381,-0.714261236255,-0.219802274087,0.345437163589,-0.380705600345,-0.389362932359,-0.28403384823,-0.658166028746,0.214654837091,-0.165162593813,0.377671405503,0.395860889261,0.670795023202,0.355930103877,1.39413390741,0.989341130818,0.30952155085,0.6748122065,-0.711088214242,-0.0637796017692,-0.131383262218,-0.122641392649,0.193257084802],[-33479.9778114,-1077.59330294,-536.417208009,-2472.12104615,-551.660281507,822.400508116,1180.12945148,391.285382856,-1287.15222016,-84.4944573133,138.147092123,90.5403434038,-495.419217121,-1469.63399739,-404.82222638,-18.4398008395,-479.101428638,-114.512252218,-714.334561572,141.975789883,179.548531382,193.797649699,93.3100519539,-557.224189453,155.889230986,-111.992792999,30.2198561717,125.116696189,25.3642180912,386.613765472,26.1048217021,-156.27599514,-58.5748492,34.0634581772,172.782151249,73.0536781017,-1.48355241412,98.6056225789,10.720689195,-10.2058771548,-22.1847209736,-23.6376045934,-36.9169567346,12.1538460346,-18.9561945904,-8.52366924372,-22.8353020451,-87.4852541535,13.6833596795,9.77599174499,5.39938019859,-9.82651461534,-7.25162660768,-2.46491540462,-10.1307410504,27.4800094802,-15.4603464315,-15.7653660328,-12.4537579196,-3.75416709981,-2.04155522222,12.1763129299,15.1751426433,3.31078654,1.69825281574,-3.63704444134,-3.89696657045,5.21229591134,-1.33804821025,-0.418473099661,1.95484362708,1.31834467698,-5.84203730915,10.0908073045,-0.736722005982,5.82673382527,0.459580465301,-2.25376115409,-1.16778695228,-1.11073151733,0.118669931291,-0.179001298624,-0.766423150699,-1.38369902509,1.16216391089,-3.43135577862,0.25707157912,-1.62915527122,1.28411794087,0.678251717989,1.42558484928,0.206917075549,0.927500244539,1.02755467179,-0.719228129637,2.46277404707,-1.19832229044,1.12936164391,-0.70017571579,-0.227368531723,0.321102674174,-0.379476544717,-0.384163515773,-0.277762337673,-0.646100470298,0.217954390579,-0.161474574711,0.373790816895,0.39058440663,0.666344386214,0.343577749476,1.39732805932,0.976345869925,0.315143825161,0.665871076121,-0.702510931192,-0.0573088343436,-0.128117010093,-0.125831349832,0.187330082678],[-33390.876551,-1095.98667974,-533.136607975,-2505.78281,-566.504809426,806.029987203,1193.86528471,397.715580753,-1259.49585202,-113.499656739,138.9541313,92.5103703919,-504.906682258,-1471.2595619,-401.846931866,-21.3118123212,-471.432959853,-123.490976297,-710.4652747,149.097072963,176.2656793,199.370292107,88.7904555608,-550.53147572,153.699726544,-108.327917573,31.4560749278,120.671675388,23.3110967225,385.55614266,27.0899874326,-158.156183901,-60.9497524016,36.2803635822,171.783324986,72.1528112825,0.27902098988,98.1587750739,11.3472314352,-11.0202214297,-21.5344017793,-23.9619598888,-37.4586198791,10.7746551247,-18.6674783445,-7.32307442812,-21.8199815261,-86.7224675617,13.3328446852,10.2164309627,5.47877994393,-9.25683980163,-7.5817416231,-2.36451613,-10.3866146163,27.0053392381,-15.5040264881,-15.9749404847,-12.1067682982,-3.51026596825,-1.7807353185,11.6693369552,15.133353867,3.19820914435,1.71089349552,-3.64254149439,-3.6654729042,5.17363915873,-1.33167771053,-0.487587140448,1.90540006275,1.22823770959,-5.96312854872,10.0454844327,-0.729467555822,5.96354679983,0.372864671889,-2.20442579161,-1.1341895222,-0.995062718719,0.0751962234035,-0.22785954522,-0.777454713547,-1.33301082649,1.16887650525,-3.38458737144,0.240927423489,-1.62631080061,1.26463785895,0.633616481906,1.41873523291,0.20070216654,0.988665089329,1.00339530958,-0.695153912255,2.43822830929,-1.15284006982,1.14043827709,-0.682952490758,-0.2340623865,0.2950722144,-0.378980136962,-0.379231419273,-0.27259231978,-0.633438412023,0.22189176176,-0.159323169491,0.371130078872,0.383944748591,0.661805393657,0.332478876224,1.40056881665,0.965224705071,0.322408696324,0.65671123806,-0.692129586418,-0.0508406400368,-0.123346567557,-0.12851190465,0.181098520693],[-33308.0183172,-1119.07716423,-533.417334101,-2538.44581604,-586.00181152,787.457098491,1205.65481915,404.448502283,-1229.82054322,-142.022243177,140.872041558,93.8960828134,-515.627597994,-1469.79062992,-402.541201665,-24.1249631101,-463.365109205,-132.060997545,-706.341151685,155.080988545,172.829108503,203.287161234,84.0721012524,-545.060861064,151.384713902,-104.431134444,32.9206492662,116.102730551,21.2208940724,384.174690934,27.5628245218,-159.838493905,-63.8135754491,38.5166208748,170.953652303,71.0829099901,2.14797710616,97.7309629083,12.0153529038,-11.7516034763,-20.9063443958,-24.3148934945,-37.9447485633,9.21775879173,-18.2862986157,-6.06867616083,-20.6528156896,-85.8773085105,12.9379696589,10.6595341474,5.58065768691,-8.65382802935,-7.86034719165,-2.26667672883,-10.6108819088,26.5299435459,-15.5822048064,-16.131909911,-11.7602062211,-3.19431272468,-1.49745198268,11.1681675015,15.0834011533,3.07572547857,1.71397406505,-3.65216072629,-3.41914380281,5.14207301156,-1.3192411039,-0.539532851205,1.84926177531,1.13269595494,-6.06783124686,9.98609797342,-0.697032458666,6.1070962556,0.297727177167,-2.1490582217,-1.10578822716,-0.873517572335,0.0314538951477,-0.281819855308,-0.791220979879,-1.28082354614,1.1730118635,-3.33450462887,0.228989711065,-1.62715294578,1.24659666836,0.589073793224,1.41001305593,0.200918978947,1.05221832652,0.985837084749,-0.666409659202,2.41148891954,-1.10289366106,1.15110346927,-0.662850668909,-0.239720231332,0.267633399029,-0.379281364182,-0.374636547899,-0.268637128456,-0.620361612863,0.226186800075,-0.15873346958,0.369865739631,0.375650014333,0.657499543934,0.322527781088,1.40387738342,0.956241204436,0.331196792645,0.647721067783,-0.679787477438,-0.0444200403047,-0.117058137846,-0.13076900856,0.174659125138],[-33232.5669685,-1150.06970082,-543.323946552,-2569.16692998,-610.519534444,764.775005396,1214.27793317,407.589755829,-1197.74493298,-169.886346531,143.912634076,94.154758854,-528.534302769,-1466.09483125,-407.737659557,-26.8490090066,-454.82699433,-139.980542172,-701.912335195,160.054480811,169.151070326,205.304804421,79.3747755908,-540.897182616,148.903187845,-100.318425752,34.6889875012,111.482294297,19.2388294856,382.499645403,27.526430482,-161.241811993,-67.1675753102,40.8602152488,170.203270625,69.8289136862,4.10716249741,97.3312306841,12.7272219624,-12.3548568798,-20.2853833287,-24.6510076376,-38.3579510985,7.48194197403,-17.773128865,-4.80990737887,-19.3555898581,-84.979922609,12.5032202562,11.0972226672,5.70368374584,-8.02162427335,-8.08205423734,-2.16784850294,-10.785998224,26.0530911342,-15.6915610627,-16.2329540846,-11.4222624724,-2.8095489374,-1.20339993492,10.6785850282,15.0320626015,2.9462148983,1.70694535624,-3.66726178207,-3.16049643424,5.11627448998,-1.30129962381,-0.572667387685,1.78478701865,1.03497533932,-6.15765155236,9.91321250885,-0.639426104382,6.25390691472,0.235855518461,-2.0854781856,-1.08065705033,-0.746439614476,-0.0118177390822,-0.340248010431,-0.8079256348,-1.22781245902,1.17374372932,-3.28170485453,0.220992876038,-1.63202840497,1.23091049914,0.543608929929,1.40012417514,0.207299564329,1.11740786621,0.97564696805,-0.632708400091,2.38375624371,-1.04841032706,1.16136482373,-0.640310389909,-0.244222993621,0.239078285915,-0.380449925354,-0.370397836195,-0.265926653699,-0.607090461115,0.230592201287,-0.15967466616,0.37010317783,0.365489785141,0.653705315046,0.313614202763,1.40724888496,0.949548190988,0.341293961834,0.639237114042,-0.665465909401,-0.0380826753211,-0.109328512923,-0.132699707501,0.168106665734],[-33164.4314424,-1182.09689822,-563.178113968,-2599.33761546,-638.636763997,737.358627154,1220.27471684,406.026466019,-1163.71639901,-197.131245849,147.928107169,93.2628887934,-543.70805997,-1461.1101762,-417.354750994,-29.5255515696,-446.03970335,-147.17487431,-697.123831622,164.218763498,165.10265137,205.454373157,74.8292137985,-537.969405573,146.242083062,-96.0956308388,36.7758540386,106.844910613,17.4530080027,380.550854225,27.0117673595,-162.331512027,-70.9393125642,43.3550009305,169.452601542,68.3915599169,6.13385660645,96.9598763044,13.4659986681,-12.8130072134,-19.6577823706,-24.9339192479,-38.6948795928,5.5852479924,-17.1143478195,-3.58783359172,-17.9674250869,-84.0590897855,12.0372027682,11.5256390005,5.84856472086,-7.36913491814,-8.24625928176,-2.06436440017,-10.9010017245,25.57251912,-15.8290218997,-16.2820447146,-11.0978452312,-2.36698279253,-0.910609905946,10.2046969,14.9847012997,2.81261747433,1.69110444778,-3.68759850291,-2.8920922573,5.09486312237,-1.27830113871,-0.587332798037,1.71113758705,0.936963541463,-6.23483711695,9.82830104962,-0.559074839633,6.40018663396,0.187247345211,-2.01235907739,-1.05720144417,-0.614757209088,-0.0541120091484,-0.402059856025,-0.827446839964,-1.1743008072,1.17059006962,-3.22683142493,0.216492223044,-1.64080818606,1.21794409897,0.496416947041,1.38969223659,0.219054514175,1.18339449958,0.972824482402,-0.594139817133,2.35597403452,-0.989840675423,1.17118768377,-0.616035155334,-0.247530335401,0.209709551756,-0.382558948382,-0.366427474656,-0.264346469144,-0.593849220452,0.234925199646,-0.162027430612,0.371810288452,0.353385100647,0.650585050353,0.305620078622,1.41068362879,0.945094305887,0.352392926188,0.631452354193,-0.649342041113,-0.0318721387047,-0.100378243295,-0.134397422465,0.161524969338],[-33101.7485486,-1210.25628694,-590.637773053,-2629.90965662,-669.006845182,705.247753373,1224.06696634,398.780535684,-1128.05438305,-223.708481154,152.781283309,91.0641917259,-560.922877856,-1455.86750514,-431.076467206,-32.1308182622,-437.268126163,-153.582688087,-691.996129755,167.791881401,160.440586375,203.738476484,70.4850944093,-536.197953378,143.389874823,-91.8679252323,39.1687519909,102.202543108,15.9210023456,378.311359399,26.0163337496,-163.093875938,-75.0506241342,46.0314834559,168.613679866,66.7701143136,8.21128421127,96.612438842,14.2105880118,-13.1187053526,-19.0130715547,-25.1381424759,-38.9598296422,3.54244075382,-16.3106435295,-2.44314154818,-16.5362968875,-83.1404504091,11.5472608423,11.9428324706,6.01672492621,-6.7046911471,-8.35143586682,-1.95216632329,-10.9478824602,25.0849278665,-15.9955195444,-16.2852002595,-10.7920598449,-1.88014911211,-0.632541478212,9.75002029052,14.9448985784,2.67709663788,1.66760506117,-3.71214724723,-2.61587953216,5.07677576203,-1.25012542726,-0.583833244015,1.62823954109,0.839302651772,-6.30089271144,9.7324723372,-0.458995846454,6.54162041584,0.151218455408,-1.92875389664,-1.03384198138,-0.479585396822,-0.094974126276,-0.466308008367,-0.849607592732,-1.1204295041,1.16320555151,-3.17037877332,0.215396873111,-1.6530040887,1.20791812361,0.44703083213,1.37915309504,0.235409447465,1.24926484408,0.977049413365,-0.551039017269,2.32890036305,-0.928020001485,1.18046414298,-0.590890955928,-0.249551914907,0.179770796084,-0.385698955567,-0.362659989094,-0.263768927014,-0.580835484194,0.239103053266,-0.165655887769,0.374996362277,0.339333120212,0.64822971463,0.298515877567,1.41416550014,0.942756679529,0.364134685367,0.624491275918,-0.631700045484,-0.0257885001735,-0.0905103895746,-0.13592988629,0.154987686608],[-33042.172759,-1234.76343727,-620.22506473,-2660.59800147,-701.127044806,669.67862463,1225.91931403,386.286837682,-1090.71362928,-249.518205542,158.457718509,87.1489370234,-579.476534594,-1451.45790765,-448.306294961,-34.5425970711,-428.759089828,-159.167966588,-686.617611041,171.031393692,154.876587492,200.209317618,66.3792048051,-535.468014647,140.338528944,-87.7193242777,41.8257008669,97.5539331817,14.6778406177,375.735900347,24.5322595118,-163.52974218,-79.3906561314,48.9050560325,167.622457664,64.9600453564,10.3298057184,96.2793299229,14.9395371473,-13.2757069765,-18.3441688571,-25.2450669844,-39.1599062571,1.37434714666,-15.3702864422,-1.40627546837,-15.1125796194,-82.2427969434,11.0387180412,12.3485154625,6.20957646862,-6.03497917278,-8.39608615729,-1.82636249893,-10.9212017916,24.5872672907,-16.1930587977,-16.2487369049,-10.5065166494,-1.36282975793,-0.379814635732,9.31864546669,14.9165488038,2.54115569034,1.63729577753,-3.73930844295,-2.33316614432,5.06118757843,-1.21595659293,-0.562518820119,1.53661388192,0.741718446065,-6.35627651499,9.62716162515,-0.342164581231,6.67445327451,0.126760322096,-1.83345323953,-1.00923182321,-0.342004100276,-0.133927752925,-0.532255457858,-0.874137518783,-1.06623272225,1.15137410997,-3.11268863929,0.217847862196,-1.66785836481,1.20083248407,0.395379618873,1.36879995636,0.255752517551,1.31426381918,0.987852110897,-0.503570333412,2.30318276931,-0.863873049578,1.18905457572,-0.565777192796,-0.250139060872,0.149451614309,-0.389953425237,-0.359065268072,-0.264061309145,-0.568224754632,0.243120514992,-0.170413299021,0.379673911695,0.323398037858,0.646642402893,0.292367700039,1.41769903311,0.942378110581,0.376233266826,0.618425023666,-0.612817380011,-0.019815357255,-0.0800347283709,-0.137349659236,0.148586654631],[-32984.5570903,-1255.29524146,-647.041583088,-2690.85026001,-734.630273366,632.105328171,1226.71006165,370.485660321,-1051.57748335,-274.620674691,164.953486039,81.2734864527,-598.397779367,-1448.70659937,-468.243345462,-36.6065599371,-420.815891864,-163.936789304,-681.055775553,174.140243587,148.191601814,194.990173789,62.6033626918,-535.596767948,137.093597848,-83.737111499,44.6781529324,92.882653198,13.7183111204,372.779463871,22.5565603286,-163.630372476,-83.8152609725,51.9833654778,166.446279335,62.9596279673,12.4810851691,95.9470376404,15.625781078,-13.3014872137,-17.6455260987,-25.2455719941,-39.3004877878,-0.889903245205,-14.3013867109,-0.490435550129,-13.7442605964,-81.3751900902,10.5164924483,12.7445433978,6.42872019611,-5.36688916012,-8.38047229841,-1.6825963036,-10.8193851869,24.0769704301,-16.4228186167,-16.1774280245,-10.2376087521,-0.828442487851,-0.158497726109,8.91481349564,14.9051481163,2.40607496108,1.60161117726,-3.76704421956,-2.04494343472,5.04750776895,-1.17487748292,-0.524234884902,1.43693130948,0.643145672272,-6.40070394353,9.51437565232,-0.211390949632,6.79617715464,0.112815126406,-1.72458459851,-0.982215522755,-0.203092026719,-0.170502857319,-0.599182987756,-0.900616007311,-1.01158623701,1.13512193258,-3.05406232585,0.223972208699,-1.68458333694,1.1963136052,0.341642935404,1.35879889719,0.279678525968,1.37790300484,1.0046632544,-0.451614957658,2.27931647713,-0.79825346876,1.19675897871,-0.541506056026,-0.249155068296,0.118900278362,-0.395379665621,-0.355581627461,-0.265055449541,-0.556175142634,0.247009421478,-0.176159532744,0.385801501103,0.305686014321,0.645719933895,0.287296105965,1.42130463736,0.94375662893,0.38850002163,0.613267679458,-0.592919744903,-0.0139592372466,-0.0692441579669,-0.138713783329,0.142419625808],[-32929.6587054,-1269.96746296,-670.150189743,-2720.34438089,-769.03925798,593.077863766,1228.05422128,352.911116958,-1010.52766029,-299.222347147,172.143681771,73.5434536008,-616.923862166,-1448.14626489,-490.26598571,-38.1676546192,-413.816013298,-167.915165539,-675.332406482,177.188832335,140.22098353,188.144515556,59.284937702,-536.413094774,133.673164113,-80.0247552331,47.644214685,88.1610410304,12.9911807683,369.402982834,20.0718960501,-163.374246146,-88.1836097967,55.2700966406,165.065866638,60.7721747498,14.6557428647,95.6005707188,16.2354071356,-13.22334075,-16.9129147981,-25.140309387,-39.3879221301,-3.21899195647,-13.1132761885,0.300847051479,-12.4734230233,-80.5391354475,9.98550147786,13.1345929674,6.67602301608,-4.70858300696,-8.30640007931,-1.51751153712,-10.6440131774,23.5509913356,-16.685495477,-16.0749314707,-9.97970740777,-0.289263760448,0.0274755331739,8.54281740036,14.9163725707,2.27298440414,1.56273929082,-3.79311767342,-1.75219752897,5.03551783508,-1.12608384902,-0.470221527807,1.32968890529,0.542043649308,-6.43358384501,9.39620490185,-0.0693271491673,6.90482207136,0.108425487397,-1.60017192512,-0.951925440372,-0.0639528732152,-0.204283983229,-0.666336162013,-0.928496912575,-0.956248636602,1.11469618502,-2.99480142599,0.233828136839,-1.70248512207,1.1937243117,0.286131657622,1.34921042878,0.306887303059,1.43972517613,1.02681697319,-0.395045436425,2.25757839495,-0.731998429447,1.2032699038,-0.518788869714,-0.246498305824,0.0882384945433,-0.402005012495,-0.352103003062,-0.266560369948,-0.544830004214,0.250806176,-0.182746182471,0.393288718418,0.286326291453,0.645298252238,0.28343910983,1.42498426609,0.946646373274,0.400777370645,0.608978856254,-0.572218743677,-0.00825699225151,-0.0584195974324,-0.140095239128,0.136581716445],[-32878.7486574,-1278.63125276,-691.240112971,-2748.7903102,-803.834922409,552.42443642,1231.5500226,334.368892102,-967.278167055,-323.5025728,179.847016654,64.1368572014,-634.451852589,-1450.08681305,-513.906723371,-39.0677774121,-408.15212752,-171.113343984,-669.46208732,180.1799666,130.812863309,179.655166,56.5584819919,-537.808385114,130.091964392,-76.688380172,50.6442203877,83.3579717508,12.4091292075,365.56176185,17.0517265883,-162.729556128,-92.3666346982,58.7634305825,163.468951102,58.4031326396,16.8464769885,95.2234484784,16.7339365051,-13.0728168794,-16.1450387515,-24.9324505921,-39.4304132805,-5.57912527511,-11.8229452029,0.969273802688,-11.3366274686,-79.7293879329,9.45037403595,13.5234210601,6.95329071839,-4.06830017346,-8.17630040849,-1.32850824217,-10.3981218976,23.0048247469,-16.9806506218,-15.9454765804,-9.72697671849,0.244107248581,0.174847705959,8.20725861588,14.9550533034,2.14296178585,1.52318040353,-3.81528305181,-1.4557188302,5.02531918788,-1.06891492146,-0.401934598285,1.2151275966,0.436835855706,-6.45428911045,9.27449521499,0.0813230810321,6.99842644631,0.112693315421,-1.4582414164,-0.917800004161,0.0744482335571,-0.234899258549,-0.732969965954,-0.95721147051,-0.899899871112,1.09046985493,-2.935151259,0.247384687503,-1.72097431506,1.19231721904,0.229199858867,1.33997649303,0.337010035334,1.49918980775,1.05354550879,-0.333815217146,2.23801465902,-0.666007024269,1.20814588723,-0.498270031902,-0.24209569461,0.0575670089665,-0.409830080844,-0.348507524168,-0.268374773132,-0.534314696442,0.254525084072,-0.190022271202,0.401994146266,0.265461827385,0.645184507814,0.280906051222,1.42869949944,0.950760686784,0.412915494445,0.605465424853,-0.550927749873,-0.00276093502185,-0.04782624679,-0.141570140045,0.131174551262],[-32832.357834,-1283.85232457,-710.814397734,-2775.3329888,-838.571305138,509.881709931,1237.75335676,315.941729354,-921.306035653,-347.565663406,188.053175112,53.0684407343,-650.237574025,-1454.73324462,-538.904334624,-39.1601761108,-404.156303012,-173.520920006,-663.453096054,183.099752058,119.752994032,169.44590354,54.513317584,-539.735303036,126.353435858,-73.8159727213,53.5906053493,78.4442350188,11.8661212017,361.19694474,13.4733320948,-161.67248743,-96.2592733061,62.4407896566,161.634391764,55.8570013252,19.0465081395,94.7953577269,17.0913703134,-12.8818635395,-15.3441018018,-24.6246838228,-39.4451766981,-7.93847664359,-10.4587158171,1.518387869,-10.3648579344,-78.9355065269,8.91418634737,13.915563977,7.26149279725,-3.45300526042,-7.99399255448,-1.1130839052,-10.0851502367,22.4317502705,-17.3060248408,-15.7951702127,-9.47432214851,0.76188718969,0.279967794529,7.91285669794,15.0249658627,2.01707876317,1.48548182672,-3.83144867862,-1.15606289323,5.01699782596,-1.00251016267,-0.320637009484,1.09322223929,0.326173132071,-6.46278242333,9.15066176829,0.237626531405,7.07492796913,0.125122632938,-1.2970664474,-0.879344842209,0.210957546553,-0.261917836114,-0.798414889737,-0.98613700053,-0.842218154307,1.06287482457,-2.87521337815,0.264483192426,-1.73953300701,1.19132116616,0.171102019418,1.33098139706,0.369620013249,1.5556208364,1.08407873664,-0.268069297908,2.22047713031,-0.601283312936,1.2108515943,-0.480486447546,-0.235881703514,0.026962965256,-0.418808075779,-0.344673106226,-0.270309934219,-0.524737490216,0.258124208165,-0.197803303255,0.411752396031,0.243251118937,0.645186503144,0.279751296103,1.43237019189,0.955777911942,0.424745151224,0.602613213029,-0.529288866735,0.00248051730185,-0.0377230120708,-0.143214714251,0.12629540938],[-32789.9542888,-1284.50527681,-729.441596623,-2799.55255296,-871.743500321,465.237537646,1247.78308725,299.372264682,-872.352192304,-371.438478169,196.873182342,40.7292642668,-663.412846791,-1461.9841091,-564.879334098,-38.3781022381,-402.172101534,-175.140796725,-657.219257781,185.908172444,106.920089251,157.492964626,53.2816971984,-542.144312599,122.453062133,-71.5160175887,56.378863835,73.400237123,11.2423866813,356.277922233,9.33340959608,-160.165242627,-99.7553238587,66.2666287192,159.545993937,53.1419151144,21.2385107867,94.2920543437,17.2747112993,-12.6863598691,-14.5107545033,-24.22014618,-39.4487711222,-10.2597022024,-9.05114002469,1.95716147181,-9.58452981488,-78.141365594,8.38107498348,14.3141265419,7.6005849354,-2.87221919368,-7.76599570655,-0.869231422431,-9.70970074249,21.8256591435,-17.6564967031,-15.6292731022,-9.21499556086,1.25552326799,0.341881618015,7.66469530744,15.1300558048,1.8970752929,1.45260408095,-3.83938876515,-0.854542463548,5.01026868344,-0.926405804726,-0.228088631987,0.963988739118,0.209072940164,-6.45895514185,9.02671840929,0.396951697163,7.13316767798,0.145604662658,-1.11488869229,-0.836140673635,0.34440486235,-0.284787280504,-0.861749623857,-1.0145104398,-0.782934601359,1.0323758807,-2.81524808381,0.284636375502,-1.75771534395,1.18984771708,0.112163710866,1.32219000614,0.404368214595,1.60850553956,1.11769836494,-0.197900840233,2.20477339698,-0.538742514365,1.21085286309,-0.46588619347,-0.227833217742,-0.00341935706674,-0.428843793276,-0.340437847049,-0.272162787206,-0.516236789705,0.261478966274,-0.205905123994,0.422308297522,0.219877868643,0.645099157388,0.280012825519,1.43595622162,0.961378736046,0.436162417388,0.600302586383,-0.507505883474,0.00740576187657,-0.028332839563,-0.145114551112,0.122051323247],[-32750.7826631,-1275.11325562,-749.45325997,-2821.66881148,-901.07596507,418.309033369,1262.70617644,286.665019501,-820.545525567,-395.091730411,206.470276084,27.890343052,-673.174267518,-1471.36919864,-591.315991851,-36.7382466778,-402.510600088,-175.990961931,-650.583420263,188.503961305,92.3123139883,143.836244648,53.0405432128,-544.9712216,118.386772703,-69.9043655065,58.8889865027,68.2229066398,10.4161706593,350.802762528,4.64289955432,-158.158157097,-102.763886854,70.193585134,157.184510017,50.2705034441,23.3950064074,93.6863569557,17.2502708482,-12.522815577,-13.6447379126,-23.7257556046,-39.4556951147,-12.5019508853,-7.62912691023,2.29906775753,-9.015864263,-77.3263128294,7.85627026538,14.720220914,7.96923980199,-2.33746267181,-7.50085014739,-0.596231695527,-9.27730316552,21.181458414,-18.0243348324,-15.4509415167,-8.9412892936,1.71772715181,0.362252784994,7.46759243358,15.2742935115,1.78523381563,1.42762267372,-3.83678756397,-0.553296153156,5.0043623735,-0.840617746581,-0.126347014293,0.827560151384,0.0850332435118,-6.44254461454,8.90518663693,0.557280921507,7.17286880364,0.174586363562,-0.910039882459,-0.787645596232,0.473513801585,-0.302861873767,-0.921857580411,-1.04145238448,-0.721844800296,0.999432355134,-2.75567079479,0.307088599015,-1.77512355606,1.18692908918,0.0527818849859,1.31367533503,0.441062100333,1.65749622226,1.1537580198,-0.123383361085,2.19070866132,-0.479147348081,1.20763699278,-0.454802527015,-0.217984739853,-0.0333481313593,-0.439805578819,-0.33561184924,-0.27373289134,-0.508958673187,0.264389865874,-0.214147024189,0.433334450539,0.195538198753,0.64472001033,0.281716393113,1.43944088758,0.967262163292,0.447117225038,0.598419371677,-0.485723426074,0.0119385339899,-0.0198475037902,-0.147357007521,0.118549755918],[-32715.0044325,-1253.06545714,-774.277412127,-2841.61716978,-925.56506753,369.030051011,1281.51408464,279.502183825,-766.024916237,-418.555982384,217.096988932,15.1267861178,-679.006729137,-1482.39074187,-617.748572664,-34.2304008792,-405.310227899,-176.082921765,-643.400792185,190.720007258,75.8826183203,128.551866341,53.9372518329,-548.171009592,114.169757665,-69.0470619422,60.9998421329,62.9229533219,9.29010405506,344.757979177,-0.581133253224,-155.626189047,-105.245136759,74.1533037921,154.503508685,47.2558469108,25.4901576937,92.9529041005,16.9943442516,-12.4187581519,-12.7518222831,-23.1533149451,-39.4888676618,-14.6311509705,-6.22183679985,2.55224065738,-8.67160770089,-76.4684003931,7.34299015806,15.1334918265,8.36514411567,-1.85775567425,-7.20666737099,-0.294591421825,-8.79275841281,20.49321384,-18.4008275891,-15.2628157589,-8.64882209793,2.1415042742,0.343268333039,7.3254419621,15.4605624206,1.68342515452,1.41288009981,-3.82154927301,-0.254342075559,4.99838046606,-0.744867819128,-0.0167917348336,0.684035066562,-0.0458071528044,-6.41382695475,8.78807491476,0.716892511147,7.19380327885,0.213142553651,-0.681770667803,-0.73301264694,0.596697332116,-0.315520167068,-0.977840466607,-1.0661020527,-0.658783170081,0.964442537909,-2.69674251625,0.331114558704,-1.79133138458,1.1817766802,-0.00673779439003,1.30551966217,0.479557444743,1.70209818961,1.19167409582,-0.0448692223464,2.17814949876,-0.423157246684,1.20075087005,-0.447429135796,-0.206395308423,-0.0626108226278,-0.45156237481,-0.330045152723,-0.274886047077,-0.502982919375,0.266637968526,-0.222303121346,0.444547229187,0.170411963473,0.643889968794,0.284829884969,1.44274792404,0.973146618145,0.457515035287,0.596899558406,-0.46408443544,0.0160012802405,-0.0124521723425,-0.15002930046,0.115883246105],[-32684.17838,-1219.08943527,-806.442996869,-2859.41965676,-945.280393341,317.583077596,1302.0302917,278.615773381,-708.930460059,-441.935956349,228.915978546,2.78965902028,-680.768571982,-1494.55248039,-643.629631762,-30.8004344793,-410.566958357,-175.46019463,-635.557430082,192.34838866,57.5781203892,111.749279985,56.0596610068,-551.722290521,109.837518331,-68.963292024,62.5888903567,57.5188604144,7.78842045603,338.1179254,-6.32135993143,-152.573390536,-107.195642574,78.069249841,151.442230396,44.1131339522,27.5020983731,92.0682996693,16.4905206493,-12.3930290797,-11.8425644836,-22.520655297,-39.576943794,-16.6214792521,-4.8576109658,2.71913463417,-8.55765772919,-75.5442247241,6.84295080586,15.5521665826,8.78582900701,-1.440064369,-6.89090962653,0.0336184680808,-8.26120999143,19.7544217737,-18.7767931269,-15.066819215,-8.33561419335,2.52126243146,0.288196865539,7.24077107862,15.6897587679,1.5928818393,1.40992520332,-3.7916183329,0.0403525365479,4.99117852725,-0.638916250343,0.0996022141841,0.533767956194,-0.182763312983,-6.37329213297,8.67676096373,0.874315495937,7.19590659166,0.262384560866,-0.430354839622,-0.67116677105,0.712387434461,-0.322268607514,-1.02898358249,-1.08762991655,-0.593605985478,0.927719684813,-2.6385640471,0.356110004829,-1.80581610923,1.17376885119,-0.0661564969593,1.29782848236,0.519737878854,1.74178844102,1.23091071105,0.0370063635775,2.16705095239,-0.37132851454,1.1897999125,-0.443845610954,-0.193145282909,-0.0910102686693,-0.463981801107,-0.323608273936,-0.275531936256,-0.498320329264,0.26801886628,-0.230118058881,0.455697055651,0.144660860437,0.6424905667,0.289277099631,1.44573308417,0.978756318051,0.46721080448,0.59572078569,-0.44272057384,0.0195215137746,-0.00629819672751,-0.153201471669,0.114126946924],[-32659.4452552,-1174.71055392,-847.412138396,-2875.21526314,-960.56138486,264.88037458,1322.0987186,284.012849722,-649.517325444,-465.257193578,241.976132407,-8.87430009161,-678.722987431,-1507.40335536,-668.364266691,-26.386175648,-418.130357305,-174.225518055,-626.930990215,193.159584313,37.4215144691,93.5991503849,59.437856672,-555.604446696,105.446443379,-69.6333978309,63.5366203582,52.0356206931,5.86192250603,330.84831236,-12.5503402473,-149.046232508,-108.624833272,81.8578769709,147.948972009,40.8622793446,29.4103367847,91.0120367579,15.7278069969,-12.4564922766,-10.9328515725,-21.8516349551,-39.7522844458,-18.4517248488,-3.56119558907,2.79867564173,-8.67244155084,-74.5306557138,6.3568583129,15.9730133426,9.22860161412,-1.08978759204,-6.56091190034,0.384188003119,-7.68913725868,18.958912931,-19.1416003183,-14.8642530858,-7.99984462149,2.85274889183,0.203118327904,7.21464786198,15.9610971905,1.51422199185,1.41972014463,-3.74512646365,0.328654270773,4.98150146982,-0.522986699824,0.221928839516,0.37728840125,-0.324640540166,-6.32175675145,8.57230970688,1.02812341939,7.17957090831,0.322985928954,-0.157266710789,-0.60121882836,0.819002051876,-0.322828925369,-1.074724151,-1.10523765676,-0.526252595826,0.889526605534,-2.58114006689,0.381530607308,-1.81803768367,1.16238890058,-0.125268784693,1.29083870245,0.561489634346,1.77616545413,1.27092055512,0.121397376726,2.15743740362,-0.324085297863,1.1744816168,-0.44399185139,-0.178361717923,-0.118354475827,-0.476919953252,-0.316178962766,-0.275620530435,-0.494922974531,0.268368727343,-0.23732486681,0.466552033441,0.118437194141,0.640457328006,0.294935514821,1.44821604969,0.983777261509,0.476043079476,0.594856473245,-0.421752329868,0.0224015592317,-0.00148374207703,-0.156927174005,0.113335781578],[-32637.202542,-1120.16523553,-896.528706054,-2888.65640108,-970.775405402,212.904996766,1340.335196,295.432206087,-588.281022744,-488.075965507,256.393297744,-19.4225435603,-673.242204459,-1520.37195313,-691.29137682,-20.998163687,-427.662989938,-172.519857375,-617.314452937,193.001159633,15.5934108949,74.4162625067,64.0602911693,-559.756069166,101.053314774,-71.0107450916,63.7275105174,46.5208156501,3.50792282534,322.934872524,-19.19478403,-145.125571045,-109.533293511,85.4343771704,143.993072801,37.5280845631,31.1887242509,89.7657575488,14.7020887236,-12.6110084126,-10.0409645429,-21.1658548512,-40.0479143912,-20.0961022193,-2.35253715092,2.79199606365,-9.0068673846,-73.4039232214,5.88528556481,16.3898113181,9.68943239478,-0.811402532862,-6.22470653733,0.750971251706,-7.08333200482,18.1019945335,-19.4811994174,-14.6567389019,-7.63778558791,3.13216311679,0.0983037506577,7.24655258262,16.2728338266,1.44781143102,1.4424899326,-3.68058478955,0.607868673939,4.96768382508,-0.398109969154,0.349046691772,0.215213833901,-0.469323812459,-6.26061795486,8.47632944345,1.17671181594,7.14643287324,0.395047043254,0.135121655338,-0.522720079773,0.915046304986,-0.317093453886,-1.1145931195,-1.1181694019,-0.456872000614,0.849978795714,-2.52449901788,0.406749719446,-1.82752118606,1.14730321996,-0.183953951915,1.28508792581,0.604539771075,1.80519467815,1.31102776133,0.207408182828,2.14930465014,-0.281674165981,1.15458934216,-0.447635030983,-0.162222704781,-0.144422251808,-0.490201997687,-0.307656047276,-0.275156936016,-0.492698396813,0.267535350666,-0.243670532431,0.476881193276,0.0918755085411,0.637806586726,0.301607043571,1.45006209823,0.98783307992,0.483894259338,0.59424152616,-0.401293061619,0.0245061369707,0.00195157089419,-0.161247725943,0.113535724021],[-32613.440677,-1055.73669227,-953.22324949,-2899.66386604,-975.63268238,163.852860216,1355.71926845,312.382171429,-526.038590823,-509.944990867,272.200000296,-28.529144807,-665.131465416,-1532.86422101,-711.850109608,-14.6703146724,-438.705576038,-170.545780796,-606.529461353,191.691267127,-7.60033392869,54.5784954566,69.9019944086,-564.11938874,96.7363206347,-73.0188719828,63.0645195065,41.0284078429,0.746270361094,314.377525023,-26.1764291627,-140.925239128,-109.938498133,88.7089599535,139.563539572,34.1425949598,32.8134826888,88.3181634687,13.4184322788,-12.8533434316,-9.191977195,-20.4887285163,-40.4945401896,-21.5347565694,-1.24376913846,2.69633646237,-9.54312536231,-72.1431848957,5.42865391204,16.7957065402,10.163639722,-0.607032731164,-5.88961929545,1.12586564396,-6.45210606166,17.1812338033,-19.7819841276,-14.4452545498,-7.24748293278,3.35762515184,-0.0126890814622,7.33520915962,16.6226016077,1.39336728895,1.47774654688,-3.59693035425,0.875410896302,4.9483688004,-0.265899826592,0.479711565786,0.0481848634733,-0.614453945667,-6.19122071444,8.3901012683,1.31903566341,7.09881919969,0.478411742223,0.443396194104,-0.435745897295,0.999044192585,-0.305278996227,-1.14834277898,-1.12578198286,-0.385735541188,0.809175168204,-2.4686262149,0.431285324327,-1.83385963404,1.12838471164,-0.241987653196,1.28111312577,0.648695702859,1.8289671281,1.35062540197,0.294118031897,2.14273593922,-0.244177259742,1.13006762386,-0.454397606382,-0.144952889646,-0.169028065271,-0.503642270178,-0.297978357944,-0.274190791708,-0.491481105602,0.26545627927,-0.248919544202,0.486496798839,0.0651212058135,0.634602643272,0.309098479975,1.45114454294,0.990588411382,0.490678307861,0.593823440653,-0.381456291007,0.025668825664,0.00403755612143,-0.166191528757,0.11474565342],[-32584.5634775,-982.917887132,-1015.1806327,-2909.03506926,-975.105213291,119.885847327,1367.72867774,333.376940899,-463.827124091,-530.394649731,289.252930512,-36.0520189573,-655.540865594,-1544.21104841,-729.446253767,-7.45053335285,-450.720967528,-168.531259701,-594.488525869,189.028533968,-31.7485157696,34.4707019763,76.8842648397,-568.635791847,92.5903935878,-75.5527554496,61.4820080723,35.6105952171,-2.39127189301,305.190744322,-33.4185013098,-136.574465101,-109.863483922,91.601869266,134.673205,30.7458482887,34.2670352624,86.6660906375,11.8904258087,-13.1723617672,-8.41753139376,-19.8486293846,-41.1173135515,-22.7529213653,-0.242886126935,2.50710935298,-10.2579757095,-70.7289468865,4.98747281205,17.1832593626,10.6464056507,-0.476508318712,-5.56087570203,1.49815450019,-5.80542504714,16.1964608024,-20.0320628762,-14.2297888557,-6.82892011893,3.53008363931,-0.113797062547,7.47881207606,17.0062963441,1.34976194275,1.5242485183,-3.49363424819,1.12898513553,4.92268055448,-0.128756706843,0.612561916288,-0.123092125231,-0.7575011534,-6.11461019683,8.31457601374,1.4546857101,7.03981396169,0.572613759587,0.763456132028,-0.340977284948,1.06979018448,-0.287976832131,-1.17592111748,-1.12762809742,-0.313210430018,0.767206264748,-2.41348507124,0.45490689128,-1.83677372906,1.10574585136,-0.299054947474,1.27940980887,0.693856584788,1.84771993572,1.38920446414,0.380586629819,2.13781270074,-0.211607688894,1.10096892207,-0.463816286108,-0.126813639355,-0.192023297155,-0.517062013947,-0.287126976491,-0.272814382229,-0.491029169042,0.262186662096,-0.252882394789,0.495257745256,0.0383276314457,0.630944693517,0.317262240121,1.45133492094,0.991784524391,0.496341682674,0.593556083252,-0.362342963667,0.0257172923366,0.004885162558,-0.171747392745,0.116974434569],[-32547.8547117,-904.802694503,-1077.62914044,-2918.1223092,-969.659908684,82.977462336,1375.51766583,355.977436895,-402.793160662,-549.010551908,307.221295694,-42.1326946737,-645.899467507,-1553.5432654,-743.667349669,0.579799684881,-463.075758849,-166.691523237,-581.2377652,184.800360395,-56.3589277581,14.4382004586,84.8401305206,-573.228886902,88.7230899499,-78.4676084818,58.9598033112,30.3118216585,-5.8587697668,295.407043472,-40.841418195,-132.210201271,-109.353147228,94.0468002267,129.356114323,27.3852687974,35.5396499274,84.817242335,10.1431895269,-13.5469108286,-7.75344966025,-19.2760517826,-41.9323626545,-23.7468170571,0.645797418414,2.22361987235,-11.1186875095,-69.1429411885,4.56254577677,17.5443039327,11.1326640591,-0.415677929871,-5.24144556984,1.8540384014,-5.15448506779,15.1504819719,-20.2218476939,-14.0096683069,-6.38405130225,3.6538008942,-0.187851427094,7.67417543423,17.4178425668,1.31516112735,1.57997649476,-3.37125616708,1.36666878173,4.89030750558,0.00998137430947,0.746232071143,-0.297717008238,-0.895788071036,-6.0317591829,8.2500374748,1.58399741839,6.97337920164,0.677272799282,1.09069120653,-0.239582541096,1.12640597448,-0.266123699317,-1.19753601019,-1.12354255509,-0.23985582275,0.724180043024,-2.35903303729,0.477623924935,-1.8362173073,1.07977462864,-0.354766501022,1.28041603894,0.740097571716,1.86196235186,1.42645411179,0.465885807655,2.13444785883,-0.183859035466,1.06743687985,-0.475233953995,-0.108108116692,-0.213299415901,-0.530284540685,-0.275144749941,-0.271161885493,-0.491031732769,0.257893230377,-0.255443960894,0.503107950818,0.0116709379275,0.626978679318,0.325994622063,1.45051772781,0.991274596371,0.500874823618,0.593385849267,-0.3440314297,0.0244959145524,0.00468078365348,-0.177853529186,0.120194319404],[-32501.7055093,-825.3967601,-1132.44736945,-2928.37148362,-959.949906886,55.1979593779,1377.97819017,377.129945991,-344.110687427,-565.432433854,325.599249619,-47.1631611648,-637.833052749,-1559.96935514,-754.461862434,9.28281578902,-475.056153349,-165.204218455,-566.948766268,178.800331495,-80.9247534051,-5.25620226399,93.4914222166,-577.815043938,85.2449963972,-81.5832844568,55.5245133723,25.1723130608,-9.59905200067,285.068176443,-48.3630476929,-127.981673196,-108.478577947,95.9889560903,123.668359346,24.113304955,36.6281423831,82.7898135018,8.21324369198,-13.948291514,-7.2388596535,-18.802235712,-42.9472558948,-24.5252155565,1.42091155708,1.85094923743,-12.0815326048,-67.3717449215,4.15525845812,17.8696768157,11.6165044278,-0.415986760769,-4.93262798319,2.17675951694,-4.51115196602,14.0486834763,-20.3439440747,-13.7838491212,-5.91664775141,3.73693574031,-0.218363915521,7.91663010085,17.8487691601,1.28716048093,1.64217784394,-3.23186394501,1.58675822039,4.85151208177,0.146166523724,0.879360827771,-0.474750091286,-1.02629747374,-5.94363534043,8.1961257926,1.70808084554,6.90409522369,0.79224398044,1.41986869879,-0.13321426492,1.1683549502,-0.240954939681,-1.21368048876,-1.11363385777,-0.166528964984,0.680278031251,-2.3052384254,0.49966813549,-1.83245933608,1.05115992928,-0.408619568752,1.2845396775,0.78770158879,1.87245144207,1.46235514201,0.549066270448,2.13234490269,-0.160701109263,1.02975046894,-0.487801058416,-0.0891717748156,-0.232784423296,-0.543110645638,-0.262154275458,-0.269392837232,-0.491121436082,0.252839593035,-0.256562872212,0.510092896088,-0.0146237295493,0.622915131242,0.335232357095,1.44860107488,0.989042206815,0.504308577128,0.593245821198,-0.326576697262,0.0218927246907,0.00368212837829,-0.184392437121,0.124334095563],[-32445.7670772,-749.79721721,-1170.12811981,-2940.96754669,-946.882686168,38.2300812593,1373.57207901,393.506692351,-288.870330228,-579.33601043,343.872095169,-51.698407236,-632.93718086,-1562.57815756,-762.094928281,18.4910945617,-485.883565542,-164.147047447,-551.85866164,170.833790935,-104.960151476,-24.4299533373,102.488116029,-582.313282149,82.2660182607,-84.6887026542,51.2499894848,20.2365204263,-13.5485243539,274.223787014,-55.9046541581,-124.027676828,-107.34354791,97.3772724315,117.678069748,20.9834564994,37.5342911855,80.6095124826,6.14713792892,-14.3436952044,-6.91389293749,-18.4575470243,-44.1613481363,-25.1098590806,2.08014505364,1.40087293085,-13.0950304401,-65.4055065521,3.76664988235,18.1489800324,12.0904973235,-0.465734336906,-4.63439343276,2.4472590146,-3.88711658056,12.8983576239,-20.3929215884,-13.5514713316,-5.43134402277,3.79042738673,-0.190544087253,8.20011843451,18.2883099639,1.26267345032,1.70740598889,-3.07902561717,1.78753571731,4.80702646561,0.275098443856,1.0108612312,-0.653331190194,-1.14548015592,-5.85106033894,8.15203169233,1.82869293631,6.83694326523,0.917812188375,1.74534879137,-0.0238914061054,1.19541633266,-0.213933630033,-1.22506809111,-1.09827377429,-0.094395706112,0.635804261587,-2.25203903926,0.521519161096,-1.82602653094,1.02094090722,-0.459952620885,1.29216342964,0.837095567503,1.88009132222,1.49720666995,0.629120795909,2.13091472951,-0.141799926376,0.988296633047,-0.500561984014,-0.0703425327812,-0.250439112943,-0.555309365561,-0.248351216445,-0.267663854119,-0.490878548937,0.247364611323,-0.256263954288,0.516362849346,-0.0402568577609,0.618999195833,0.344944966916,1.44549154546,0.985192965473,0.506690921166,0.593028879649,-0.310014685624,0.0178575927817,0.00218207362461,-0.19119985344,0.129274147205],[-32380.3692874,-681.756317826,-1187.50713047,-2955.88082562,-931.359837017,32.7137354494,1362.34061251,403.637689774,-237.794079226,-590.547824144,361.825253357,-56.1614597525,-632.278731597,-1560.98297577,-766.936346399,28.0495449794,-494.824335218,-163.321058806,-536.27840424,160.769803771,-128.09216055,-42.9276759238,111.472691436,-586.766670888,79.8712789367,-87.5705767685,46.2959364647,15.5310149279,-17.6660416719,262.925050268,-63.3858164409,-120.465153581,-106.110737349,98.1875269883,111.496264079,18.0406802586,38.2656431089,78.3064418283,3.99379847445,-14.7109483014,-6.81205871863,-18.2702878198,-45.559811999,-25.5420533937,2.62871896198,0.897385407164,-14.1084383036,-63.237789216,3.3970750521,18.3728442583,12.5412427898,-0.551185371457,-4.34685486432,2.64809607836,-3.29423323609,11.7092337145,-20.3654146212,-13.3112427667,-4.93072490136,3.82534137189,-0.0887156857249,8.51785368673,18.7229154227,1.2385289036,1.77201813998,-2.91876360645,1.96759270912,4.75849120349,0.392080393778,1.1394888332,-0.833049691069,-1.24856351975,-5.75485882467,8.11700458298,1.94738283424,6.77772333558,1.0542018371,2.06048846666,0.0859289708734,1.207885073,-0.186551015924,-1.23254981158,-1.07812391016,-0.0247361948944,0.591405668267,-2.1994947609,0.543847236621,-1.81779856457,0.990780086257,-0.508093192293,1.30358047099,0.888666613367,1.88604932898,1.53157119009,0.704914325064,2.12945646148,-0.126691835981,0.943627082739,-0.512468216773,-0.051934260182,-0.266272841034,-0.566547457828,-0.23398184156,-0.266075134052,-0.489915924674,0.241914209422,-0.25465742364,0.522185520091,-0.06491438563,0.615455810091,0.355144351735,1.44111147622,0.979951569102,0.508072644548,0.592596445116,-0.294366720294,0.0123716230565,0.000549692547447,-0.198084238988,0.134849894836],[-32307.2333366,-622.895851571,-1185.56622942,-2972.21505209,-914.113212151,37.9982486704,1345.15375092,407.876325158,-191.297845728,-599.096655716,379.471982656,-60.7653234549,-636.191368576,-1554.99122925,-769.400489956,37.8072362896,-501.245872318,-162.2853395,-520.523774159,148.543742028,-150.062857357,-60.6024328844,120.064191901,-591.31227062,78.1289931815,-90.0199195219,40.8829598466,11.0771018756,-21.9413807678,251.227754976,-70.7172896473,-117.371634972,-104.994894093,98.4062758968,105.268394535,15.326637734,38.8353078795,75.9140283277,1.80387964376,-15.0402558266,-6.96053077545,-18.2663930691,-47.1163840043,-25.8794881909,3.06929841243,0.382701595263,-15.07147733,-60.8639185689,3.0468549639,18.5338685276,12.9508973197,-0.657469442095,-4.07133675368,2.76248414718,-2.74505717237,10.4928137907,-20.2600154238,-13.0629302129,-4.41438190067,3.85197363735,0.101301072265,8.86211184168,19.1370165863,1.21149202832,1.83265235351,-2.75913411776,2.1255266794,4.7082836604,0.492396277744,1.26387403994,-1.01391578902,-1.33014905492,-5.65596733226,8.09043208262,2.06512715364,6.73291586313,1.20196641703,2.35843093403,0.193524684248,1.20640161696,-0.16033741178,-1.23706538845,-1.05408298428,0.0410308359189,0.548132117208,-2.14777752328,0.567441083845,-1.80903433367,0.962690218174,-0.552278957341,1.31901570599,0.942669562425,1.89175223456,1.5662737302,0.775261881747,2.12695605965,-0.114856826379,0.896327599345,-0.522404297854,-0.0342606645395,-0.280345721993,-0.576404211372,-0.219326136912,-0.264656328782,-0.487883112048,0.237003907227,-0.251934158561,0.527914419667,-0.0882134706998,0.612476505249,0.365853079006,1.43542360271,0.973643896086,0.508526671431,0.59174200048,-0.279647069656,0.00545660593128,-0.00083226593534,-0.204817361656,0.14085217956],[-32228.5964729,-576.512246385,-1167.01473129,-2989.49371772,-896.104532719,52.7156081688,1323.00972632,407.451765304,-149.752005089,-605.072281319,396.851646323,-65.786042881,-644.450567748,-1544.43413125,-769.774607397,47.6241317261,-504.636256467,-160.486862436,-504.891023858,134.195948743,-170.612687583,-77.3108962145,127.921003101,-596.151608045,77.1002376403,-91.8442640445,35.2627378258,6.91852379449,-26.3814815028,239.200528285,-77.8067358512,-114.775488581,-104.214261269,98.0176850919,99.170470585,12.8837793751,39.2627124908,73.4678310256,-0.368234656393,-15.3317247238,-7.38430286561,-18.4631768836,-48.7916663146,-26.1849063289,3.39381638747,-0.0908362600693,-15.9391481413,-58.2864359402,2.71768097319,18.6267465844,13.3003141849,-0.769965032597,-3.80979546105,2.77323763187,-2.25110993312,9.26199706422,-20.0784689309,-12.8094416265,-3.87911168465,3.88042127902,0.390879428478,9.22616259912,19.5153869707,1.17827453316,1.88620012568,-2.6090056637,2.25972222153,4.65905794851,0.5711244067,1.38242987247,-1.19645165639,-1.38522886141,-5.55516880527,8.07215838053,2.18252605804,6.70894033654,1.36184446654,2.63318282618,0.295613709988,1.19207279622,-0.136935150444,-1.23954323157,-1.02721532692,0.101363112738,0.507187248,-2.09714292961,0.593080774983,-1.80125986798,0.938722915426,-0.591536966404,1.33860861784,0.999083818619,1.89878311327,1.60238459679,0.839252076408,2.12208957168,-0.105772417057,0.84700696873,-0.529427812786,-0.0176419720725,-0.292726341204,-0.584451872445,-0.204688260717,-0.263374021306,-0.48443375171,0.233152554351,-0.248355820956,0.533925320554,-0.109687874477,0.610200894655,0.377060647281,1.42847487333,0.966689511909,0.508177060396,0.590128940139,-0.265856425345,-0.00283791747746,-0.00161390859044,-0.21113631858,0.147078758546],[-32147.5362773,-544.190028955,-1136.70019773,-3007.39671398,-878.133598136,74.6484529339,1296.56203372,403.925473383,-113.444639548,-608.717368416,414.092174379,-71.3273219122,-656.419166852,-1529.10479934,-768.281076577,57.3508829846,-504.627576161,-157.298837685,-489.616475268,117.823008816,-189.533089931,-92.913113263,134.763987123,-601.462529283,76.833304226,-92.8766561283,29.6898477253,3.10668674111,-31.005120986,226.930497144,-84.5585619544,-112.650135631,-103.983721198,97.0202926557,93.3760408039,10.7508250841,39.5690458255,71.0030115846,-2.47230078293,-15.5917695275,-8.10009984388,-18.8729633476,-50.5373959315,-26.5229726558,3.59283228972,-0.46127233486,-16.6715403696,-55.5133061211,2.41127037499,18.6481384343,13.5708212493,-0.875553948049,-3.5651221372,2.66449522973,-1.82287026337,8.03073958381,-19.8248146837,-12.5541330109,-3.31936038853,3.9191081777,0.787250669458,9.60270781998,19.8442944847,1.13578963826,1.93015323687,-2.47740816317,2.3685248792,4.61347188478,0.623553058031,1.4936478019,-1.38117737884,-1.40950785918,-5.45308360092,8.06246838354,2.2997914845,6.71202017483,1.5347516535,2.87994027364,0.389158032825,1.16641512431,-0.117873594539,-1.24087617199,-0.998649993716,0.154769085699,0.469867447182,-2.04794159277,0.621460093569,-1.79610309312,0.920774927065,-0.624826584585,1.36242790871,1.05777015405,1.90883479923,1.64101232688,0.896209149076,2.11334964868,-0.0988148294031,0.796269844242,-0.53270983847,-0.00237878906917,-0.303501875051,-0.590288674421,-0.190350147699,-0.262152997804,-0.479269053455,0.230825454221,-0.24423000417,0.540592681826,-0.128839867746,0.608705769427,0.388735749818,1.42038671797,0.959540800575,0.507186839395,0.587369598745,-0.252950945861,-0.0124127736139,-0.00151389597433,-0.216781192015,0.153307234182],[-32067.5837075,-523.841825709,-1105.09343641,-3026.30550423,-860.499600105,101.234377042,1265.79284008,398.42617794,-82.6251985376,-610.446120964,431.630960918,-77.2056762805,-671.451285099,-1509.09702212,-764.733538262,66.8902396552,-501.001829906,-152.092255154,-474.748839274,99.5414219442,-206.690350873,-107.256063278,140.492034433,-607.316331572,77.3728652881,-92.9806349974,24.3717107031,-0.289640013248,-35.8259362176,214.526814588,-90.9076489262,-110.928041937,-104.480804964,95.4447374623,88.0134203379,8.95578240318,39.7738134444,68.5456753849,-4.47188285239,-15.8289730791,-9.11092268735,-19.5121385714,-52.3083858686,-26.9561321098,3.66747190269,-0.670906147533,-17.2455039656,-52.5639800545,2.12716329837,18.5962852421,13.7468290886,-0.965891765817,-3.34128674789,2.42406722388,-1.46898217478,6.81150582024,-19.5055650339,-12.2984362706,-2.7270574866,3.97276596245,1.29287631235,9.98257738465,20.1147731277,1.08142782344,1.96269098198,-2.37195149897,2.45047031908,4.57372900342,0.645647791817,1.59679652471,-1.56820996664,-1.3998285508,-5.35027106961,8.0627258134,2.41707484112,6.74772360184,1.72086422683,3.09545324031,0.472280136508,1.13152818424,-0.104305640732,-1.2418832325,-0.96936379605,0.200127302136,0.437408683551,-2.00064169242,0.65311423638,-1.7949161458,0.910415266765,-0.651213675847,1.39049401313,1.11874843008,1.9236100578,1.68309655955,0.945613194032,2.09950940998,-0.0931216047154,0.744872789348,-0.53181025396,0.0112823655521,-0.312774160133,-0.59360526659,-0.176520475128,-0.260905625845,-0.472173424166,0.230357588429,-0.239848844775,0.548252942859,-0.145200142984,0.607970932394,0.400844550892,1.41136195486,0.952633494457,0.505701403397,0.583086880613,-0.240810104771,-0.0231032296285,-0.000378924220817,-0.221587623852,0.159278563834],[-31992.5656256,-512.858891635,-1082.37957362,-3046.62992461,-843.377743048,129.757631445,1231.08173242,391.407698946,-57.5090137725,-610.783399664,449.791668307,-83.0626676905,-688.968192278,-1484.70175463,-758.828853892,76.1457592522,-493.706518399,-144.361566877,-460.23819878,79.4795030123,-222.010361967,-120.207974822,145.074223695,-613.738818978,78.7417020054,-92.0588681004,19.4648745599,-3.20909936875,-40.8546605704,202.109803369,-96.8112888673,-109.526903212,-105.841753488,93.3436595443,83.1817385142,7.51888658575,39.8934339614,66.1182243514,-6.34309031223,-16.0541105785,-10.4068817057,-20.3963620697,-54.0633344214,-27.5410811078,3.625574481,-0.670223955517,-17.6487457689,-49.4643668445,1.8648925233,18.4709715175,13.8171843257,-1.03615764287,-3.14261218653,2.04432671303,-1.19761768008,5.61634721361,-19.1293897866,-12.0420728645,-2.09430462136,4.04387684492,1.90585324269,10.356165042,20.3207024633,1.01329519011,1.9826384013,-2.29857024295,2.50445514656,4.54136643693,0.634319688889,1.69125340146,-1.75701464145,-1.35453181728,-5.24687037463,8.07446140427,2.53417882329,6.82038804724,1.91951034414,3.27755103586,0.543862663701,1.08986626251,-0.0970483198267,-1.24323104766,-0.940189936948,0.23664359463,0.410878281278,-1.95580864661,0.688392048648,-1.79871639756,0.908723373255,-0.669891785601,1.42274109699,1.18204092557,1.94460427572,1.72931048636,0.987062862694,2.07966304555,-0.0877520804596,0.693570230394,-0.526574014329,0.0231475232727,-0.320641169032,-0.594176512241,-0.163345180372,-0.259542165645,-0.463035623831,0.231985331166,-0.235488550624,0.55716039819,-0.158365598313,0.607918228124,0.413371976062,1.40165189931,0.946339811623,0.503855220349,0.576976604257,-0.229258034816,-0.0347065442255,0.00185085679891,-0.225457980669,0.164744160713],[-31925.4065029,-509.133091813,-1075.01174153,-3068.78542164,-826.92255718,157.971636722,1193.36694801,382.975720047,-38.4399723865,-610.261493913,468.582710111,-88.6546093769,-708.361097048,-1456.32610715,-750.153525866,84.9710853571,-482.88072094,-133.770184946,-446.05489068,57.8503471878,-235.421569649,-131.634647188,148.470705047,-620.785715882,80.9226478399,-90.0664904729,15.0868922927,-5.60910411524,-46.0880727147,189.803649462,-102.241546557,-108.379917496,-108.160668107,90.7875920855,78.9773717729,6.45312929044,39.9415092615,63.7436726594,-8.07317473852,-16.282259689,-11.9703120946,-21.5353053768,-55.7641304771,-28.3242100072,3.47884678794,-0.419265390794,-17.8764811998,-46.2482635381,1.6262837872,18.2735441086,13.7751768084,-1.08461442919,-2.97326003657,1.52166235912,-1.01623872334,4.4574527477,-18.7068231377,-11.7850095552,-1.41497558666,4.13420638595,2.6202036968,10.7148078183,20.4579435746,0.930551445448,1.98912676054,-2.26152903298,2.52968964204,4.51710659539,0.587316601118,1.77597519581,-1.94651430683,-1.2733598617,-5.14264858245,8.09888573435,2.65064932736,6.93264398925,2.12893191308,3.42478707411,0.60322882933,1.04415714755,-0.0966280159906,-1.24540780252,-0.911885898292,0.263801179511,0.391054743363,-1.91414464487,0.727441691586,-1.80815562617,0.91631244272,-0.680220833192,1.45893429025,1.24748337194,1.97297669658,1.77998093764,1.02030734644,2.05332231852,-0.0818111077624,0.643048975793,-0.517060104712,0.0330732666361,-0.32715633951,-0.591878795112,-0.150924916564,-0.257965668693,-0.451852148411,0.235870917252,-0.23141696345,0.567461863411,-0.168046403757,0.608435227811,0.426313487811,1.3915356744,0.940969118554,0.501750866922,0.568837417488,-0.218101137569,-0.0470190010885,0.00519736492541,-0.228318029942,0.169513823647],[-31867.4125367,-508.524170411,-1086.73151381,-3093.26085898,-810.772331525,184.252033889,1153.96601071,372.972793049,-25.9104378278,-609.360985361,487.738550414,-93.7137421175,-728.992753876,-1424.35306908,-738.339574258,93.1425643215,-468.817871118,-120.162648204,-432.147730149,34.9277345518,-246.822667005,-141.446102939,150.635405346,-628.497008988,83.8611612678,-87.0093437771,11.3077837681,-7.45822195657,-51.5066137499,177.735264723,-107.191220915,-107.441315924,-111.486414189,87.8648078641,75.4869457369,5.76312191712,39.9261163741,61.4430879128,-9.65929753522,-16.5307273814,-13.7755630061,-22.9358339832,-57.3795920045,-29.3404635633,3.24392143118,0.112129172168,-17.9288468977,-42.9574050681,1.41466479426,18.0060162577,13.6187453305,-1.11240360481,-2.83772836207,0.856321671518,-0.931303189176,3.34650559912,-18.2495853395,-11.5268076928,-0.684575956419,4.24513817829,3.42524728903,11.0505699775,20.5250904152,0.833420225521,1.98162474618,-2.26333738972,2.52560489791,4.50083425253,0.503349070547,1.84982379634,-2.13502171632,-1.15745039291,-5.03716296725,8.13679833666,2.76609622061,7.08504507885,2.34649993834,3.53654810672,0.650258575834,0.997168922851,-0.10321464443,-1.24873927131,-0.885068451962,0.281343706643,0.378420149693,-1.87640429223,0.77021071333,-1.82349820518,0.933275901627,-0.681703759929,1.49871093664,1.3148942188,2.00944853928,1.83509754875,1.04518690772,2.02041305928,-0.0744751612799,0.59393118694,-0.503472366342,0.0409720876498,-0.332329700989,-0.586690691691,-0.139311695771,-0.256086889972,-0.438711973196,0.24207766215,-0.227866101277,0.579199009843,-0.174047936383,0.609381323832,0.439687048651,1.38128483522,0.936748769397,0.499441852324,0.55857390675,-0.207141573353,-0.0598269454667,0.00963912959421,-0.230123082019,0.17344783746],[-31819.2691385,-507.448278571,-1116.41191066,-3119.67654767,-794.67022857,207.647569254,1114.29344961,360.984292831,-20.100337811,-608.65499903,506.797857695,-97.8835741122,-750.308745923,-1389.17639492,-723.480246274,100.422153605,-451.88703795,-103.575604904,-418.461720171,10.9959417551,-256.172457963,-149.72494254,151.464547522,-636.840118942,87.465596611,-82.9146463306,8.14538518541,-8.74872359803,-57.0682083876,166.022027756,-111.684133606,-106.696376863,-115.829606783,84.6810616063,72.7681586206,5.43944433018,39.8528467108,59.2347857661,-11.1086202272,-16.8082690361,-15.7903624871,-24.6002560801,-58.8896370947,-30.6163141975,2.94721372086,0.943733637285,-17.8084033044,-39.6417286186,1.23190562879,17.6707897876,13.3506976753,-1.12218420909,-2.73955526848,0.052990623944,-0.945661850148,2.29350155609,-17.77033219,-11.2644760715,0.0983384906131,4.37799991178,4.3036319916,11.3556236789,20.5231875129,0.722934326378,1.95995881195,-2.30473506996,2.49223377511,4.49170787094,0.382324980707,1.91246579628,-2.32040472425,-1.009359069,-4.92980484088,8.18822831223,2.88062839088,7.27558139731,2.56929713392,3.61317673907,0.68563443705,0.951321037893,-0.116530715568,-1.25348959914,-0.860176364126,0.289321159793,0.373087554474,-1.84325844809,0.81653800573,-1.84469599647,0.959197158641,-0.674133117101,1.54156751243,1.38426508853,2.05413867092,1.89437816893,1.06164480068,1.98124034506,-0.0649770031154,0.546793515659,-0.486092457423,0.0468486128359,-0.336180326563,-0.578682399881,-0.128501082177,-0.253874615855,-0.423793040738,0.250546489489,-0.225017184809,0.592335731054,-0.176306069337,0.610609870047,0.453537756648,1.3711210971,0.933828987196,0.496935021969,0.546250103386,-0.196151301537,-0.0728683230412,0.0151002714749,-0.230856861576,0.17642883234],[-31781.2397549,-504.099428243,-1158.91389557,-3146.8000666,-778.690969718,228.198648104,1075.8499615,346.57433285,-20.7767215756,-608.831763556,525.278597224,-100.800795154,-771.916692035,-1351.36570675,-706.039418464,106.603595622,-432.493707095,-84.2141752938,-404.929662367,-13.6520442169,-263.491662768,-156.723063654,150.8482296,-645.724720734,91.612489822,-77.8253125862,5.5739817231,-9.49131587106,-62.7082573053,154.765633101,-115.782641266,-106.160407634,-121.158999981,81.3456273784,70.8512892421,5.45648267207,39.7266366064,57.1311108795,-12.436908396,-17.1140355483,-17.9771818355,-26.5279023944,-60.2846214446,-32.1685327954,2.62259734248,2.08281272959,-17.5218416452,-36.3581380702,1.07749266493,17.2705607255,12.9774011145,-1.11846242768,-2.6810546398,-0.878747493933,-1.05787386869,1.30553125909,-17.2816351683,-10.9929737059,0.933204837684,4.53392624864,5.23337649896,11.6226607807,20.45572949,0.600808723541,1.9241267244,-2.38480906101,2.43008826751,4.48825604555,0.225249613159,1.96453873788,-2.50050743256,-0.832818797897,-4.81978230835,8.25279329996,2.99485001278,7.49984649649,2.79399123925,3.65583716442,0.710713951194,0.908659213948,-0.135885575988,-1.25987465866,-0.837461001615,0.28806171996,0.374756022059,-1.81526782447,0.866201719131,-1.87140549268,0.993230694719,-0.657608222286,1.58694146714,1.45574583027,2.1066169082,1.95725466929,1.0697929989,1.9364951272,-0.0525893735502,0.502195173404,-0.465348560375,0.0508121932045,-0.338740645083,-0.567997729578,-0.118434873909,-0.251355378614,-0.40736643213,0.261103560919,-0.222986712159,0.606753451475,-0.174905034523,0.611979925489,0.467927586652,1.36121334582,0.932264630238,0.494193133525,0.53204782885,-0.184870516901,-0.0858568280653,0.021443029391,-0.230544201008,0.178380423268],[-31752.789804,-497.801414562,-1208.79656195,-3173.48883997,-762.925484488,246.415854227,1039.97680287,329.402528159,-27.5483601445,-610.517787077,542.807109527,-102.210429362,-793.434085418,-1311.45049406,-686.528537726,111.502082343,-411.087252367,-62.364667841,-391.457687593,-38.7179009569,-268.778926444,-162.755255215,148.722180948,-655.03044114,96.1613101697,-71.8058680502,3.53989966802,-9.69862283335,-68.3575382697,144.059564743,-119.569570614,-105.852475172,-127.39889114,77.9636547463,69.74514894,5.78007397797,39.5513529188,55.1360801699,-13.6633031027,-17.4444676859,-20.2959570821,-28.7128521963,-61.5610041916,-34.0005174788,2.3035273356,3.52488503585,-17.0817924214,-33.1643854667,0.950162721906,16.8083772157,12.5069351587,-1.10728504127,-2.66387778057,-1.92627030787,-1.26391045459,0.387060827894,-16.7948574936,-10.707352284,1.81845868368,4.71347719603,6.19093551158,11.8458717965,20.3285940053,0.469284400916,1.87433736181,-2.50141534796,2.3400145702,4.48854310236,0.0338070190707,2.00700011526,-2.67342407205,-0.63219629575,-4.7062137677,8.33001084047,3.10957401057,7.75205962191,3.01696424096,3.66668590335,0.727205922941,0.870878804041,-0.160353331867,-1.26799851124,-0.816999896592,0.278082088584,0.382827859147,-1.79287734428,0.918849932112,-1.90304999497,1.03423361432,-0.632425739794,1.6342708677,1.52946771828,2.16612059447,2.02291259607,1.06995919696,1.88710778347,-0.0367394286869,0.460622694669,-0.441814647247,0.053032160614,-0.34003970147,-0.554817530599,-0.109019917893,-0.248576766692,-0.389746436749,0.273492141321,-0.221839501485,0.622243399889,-0.170019822311,0.613349018318,0.48291139927,1.35169949489,0.932007019436,0.491162837037,0.516194979166,-0.173051935476,-0.0985103429265,0.0284952289978,-0.229242701875,0.17927455277],[-31732.6834521,-487.844576227,-1262.86176419,-3198.9860093,-747.47851024,262.967204307,1007.8944897,309.685241887,-40.0590669402,-614.182423393,559.126551675,-101.942935198,-814.370003979,-1269.89266948,-665.414003242,114.941828765,-388.138130044,-38.3539746955,-377.932204681,-63.9147605815,-271.983197411,-168.11739502,145.081233873,-664.606810913,100.970250563,-64.938141281,1.97106847927,-9.37804999664,-73.947823503,133.996150962,-123.129249372,-105.79035512,-134.436680019,74.6257687737,69.4417330655,6.37267720502,39.3296751845,53.2471974414,-14.8054582008,-17.7984653815,-22.7048886664,-31.1433003171,-62.7206793714,-36.1037890885,2.01885272928,5.25375378246,-16.5065863758,-30.1169913831,0.848712906663,16.2880623627,11.9479752033,-1.09490972264,-2.68976178795,-3.07504189758,-1.55854606682,-0.459129946557,-16.3206265706,-10.4044089386,2.75123412473,4.91582453164,7.1529959086,12.0212771308,20.1495741365,0.330889338837,1.81111030841,-2.651622009,2.22326340698,4.4903421665,-0.189673459963,2.04066438299,-2.83762773236,-0.412329062263,-4.58859868712,8.41924650472,3.22551647314,8.02566914666,3.23447230463,3.64847658167,0.736791995669,0.839233584414,-0.188912098527,-1.27788211459,-0.7986935461,0.260029588639,0.396536676916,-1.77643890914,0.973934326127,-1.9388948001,1.08083309926,-0.599045877955,1.68296308711,1.60542655762,2.23159649719,2.09035722516,1.06259779094,1.83414811147,-0.0170311689154,0.422528073878,-0.416152038473,0.0536946217767,-0.340116403642,-0.53933762406,-0.100154405889,-0.24559522793,-0.371254035524,0.287403765405,-0.221582472865,0.638528012328,-0.161873490786,0.614557529157,0.498515014962,1.34268545763,0.932922019646,0.487780672171,0.498933647255,-0.160495401504,-0.110565026171,0.0360733493246,-0.227041559969,0.179123877355],[-31719.9310433,-472.756423003,-1318.70840305,-3222.88095159,-732.469856678,278.374661781,980.303260143,287.911736907,-57.9788888925,-620.154365481,574.043728015,-99.6873418877,-834.071594776,-1226.77289656,-643.045593801,116.74881122,-364.111374514,-12.5159023429,-364.199456652,-88.9836871198,-273.029019182,-173.044105795,139.941252932,-674.248067849,105.899107889,-57.3127942715,0.7778905707,-8.53091176035,-79.4169499105,124.67157786,-126.531565086,-105.970574962,-142.139695351,71.4099651138,69.9067219301,7.19463282593,39.0631811725,51.4557847176,-15.8778259745,-18.1759719211,-25.1570686776,-33.8028158663,-63.7674477946,-38.458178367,1.79135316856,7.25033055842,-15.8172976961,-27.2620035789,0.771983387752,15.7139074292,11.3094834736,-1.08705193843,-2.76031167267,-4.30892806318,-1.93619621397,-1.23118742044,-15.8674685059,-10.0816463186,3.72773324651,5.13801640792,8.09712622895,12.1455530005,19.9273432473,0.188229047179,1.73521840502,-2.83200701306,2.08134742418,4.49110437049,-0.442132197341,2.06611723919,-2.99154319328,-0.178210243145,-4.46659388493,8.51967731279,3.34290799844,8.31413092881,3.44311039513,3.60479640928,0.741424373897,0.814529916452,-0.220481521262,-1.28950104986,-0.782305144458,0.234637117234,0.4149839792,-1.76616644476,1.03074640844,-1.97804335796,1.13147237951,-0.558041081591,1.73249910749,1.68345306521,2.30189859395,2.15840694441,1.04832058788,1.77863269719,0.00677576563995,0.388172813131,-0.388976136955,0.0529913316617,-0.339026092836,-0.521763481803,-0.0917318328615,-0.242479863667,-0.352204055725,0.302491187055,-0.222169625536,0.655289380068,-0.150719492802,0.615457665869,0.514724819636,1.33424600585,0.934784798048,0.484009698237,0.480531527332,-0.147026789702,-0.121781859802,0.0439763244466,-0.224046778898,0.177956941225],[-31713.9676524,-452.091661869,-1376.27203319,-3245.43398104,-717.93998938,292.892058073,956.823462156,263.986976061,-80.994944187,-628.550762178,587.435804926,-95.2968535575,-851.943982649,-1181.99109386,-619.413077574,116.756753879,-339.444538739,14.8375777414,-350.109806191,-113.703893505,-271.847340712,-177.636645501,133.390727032,-683.725365605,110.815942516,-49.0259517112,-0.137353069585,-7.14573078511,-84.7097760969,116.17143186,-129.810599956,-106.354931175,-150.352186087,68.3828953021,71.0731745924,8.20649413236,38.7540437854,49.7485502342,-16.8896139061,-18.575669323,-27.6044329411,-36.6676896742,-64.7033619052,-41.0314226287,1.63611359664,9.48518237636,-15.0393638388,-24.6335977162,0.719015225797,15.0905576418,10.601027882,-1.08773943486,-2.87675931235,-5.61059832336,-2.39106612148,-1.92784437807,-15.4414496492,-9.73794179672,4.74188644475,5.37474033153,9.00357665857,12.2166988877,19.6718320877,0.0438466547519,1.64766728597,-3.03883657032,1.91623254331,4.48817027414,-0.719800221738,2.08342938976,-3.13356648787,0.0653056388666,-4.34018189568,8.63011859029,3.46111323333,8.61141054567,3.63984481071,3.54022759588,0.743194931872,0.797267950563,-0.254010638346,-1.30282800616,-0.767505079923,0.202704778961,0.437148785486,-1.76206946663,1.08839578124,-2.01950492502,1.18449176502,-0.510101839773,1.78243208943,1.76306674569,2.375910336,2.22581231129,1.02798432379,1.72156907834,0.0347395580138,0.357623126016,-0.360891802166,0.0511059694032,-0.336846717211,-0.502322100027,-0.0836575433555,-0.239308496265,-0.332881350507,0.318367134882,-0.223506230085,0.672186325996,-0.136840398123,0.615939255502,0.531450934821,1.32644796032,0.937310579367,0.479877548177,0.46127608517,-0.132521634966,-0.131972030254,0.0520027961048,-0.220390809183,0.175829678511],[-31714.4864432,-429.812700854,-1434.93801377,-3266.70515238,-704.75495247,307.340781528,936.143834652,237.817544593,-108.441863121,-639.515804118,599.220498744,-88.9931659107,-867.461769545,-1135.70677904,-594.274294185,114.904604698,-314.509552121,43.3648974032,-335.637503699,-137.855063325,-268.485248309,-181.9029586,125.545983008,-692.725347042,115.608308474,-40.1560282707,-0.880716751182,-5.22194749218,-89.7607808378,108.541584634,-132.962040473,-106.908511925,-158.874895081,65.6013655105,72.8531657966,9.36600384433,38.4131123672,48.1104548662,-17.8459618575,-18.9887565516,-30.00495996,-39.7029092882,-65.5356151329,-43.7774901697,1.56371419883,11.9183803877,-14.2055969584,-22.259503123,0.687070431034,14.4246632132,9.83349337856,-1.09756424674,-3.03931895944,-6.96145788097,-2.91478016928,-2.55024907412,-15.0466372665,-9.37395494352,5.78560232115,5.61749596153,9.85527885803,12.2335874359,19.3943643789,-0.100173894837,1.54984159296,-3.26786704958,1.73113383468,4.47885125793,-1.01794402393,2.09255630566,-3.26255284399,0.313526163658,-4.21034411506,8.74941654953,3.57832938632,8.91184436443,3.82153752074,3.4601949582,0.744042431268,0.787604028853,-0.288537006144,-1.31790289953,-0.753882050739,0.165302963053,0.461832645489,-1.76382185623,1.14588102897,-2.06228636711,1.23819868221,-0.456264694476,1.83242422052,1.84336076761,2.45253426104,2.29112654811,1.00275852173,1.6640013021,0.0667845498905,0.330871588595,-0.332530381016,0.0482217407664,-0.333736595027,-0.481282498785,-0.0758357096566,-0.236186877346,-0.313506015928,0.334606958688,-0.225426043941,0.688878019745,-0.120601718972,0.61595099689,0.548488767778,1.31937498605,0.940117354706,0.475496492854,0.441462465805,-0.116888067349,-0.141005857574,0.0599561315504,-0.216233963758,0.172816677116],[-31719.7559306,-409.282309996,-1494.48893859,-3286.52615256,-693.43642534,322.412584835,917.390761627,209.421368733,-139.492804483,-653.191698675,609.162722142,-80.9441394419,-880.279151837,-1088.20401126,-567.364364705,111.166241962,-289.659301333,72.6452997769,-320.787616224,-161.259510075,-263.036374112,-185.826626213,116.55847594,-700.867092638,120.165501834,-30.7913079074,-1.56699164787,-2.77357645962,-94.5059655674,101.81512391,-135.963595145,-107.587761475,-167.475216396,63.1195725543,75.1438978102,10.6270132672,38.0515873307,46.5288473286,-18.7538806124,-19.4000647368,-32.3157083356,-42.8682830057,-66.2686152843,-46.6429030212,1.58798532224,14.5015164013,-13.3541099377,-20.1634558394,0.672387518096,13.7239681924,9.02019007816,-1.11598158525,-3.24742241357,-8.34039605138,-3.49728307708,-3.09902165186,-14.6865348151,-8.98888977114,6.84921768744,5.85560297678,10.6368217485,12.196316823,19.107617701,-0.241550783084,1.4436891998,-3.51417003237,1.52988507342,4.46061558203,-1.33102500575,2.09336036259,-3.37720536333,0.561234106221,-4.07813005622,8.87620303655,3.69215764298,9.20974590063,3.98519486702,3.37082561502,0.745845945551,0.785175734112,-0.322994348045,-1.33469494202,-0.740964247513,0.12370042197,0.487737054112,-1.77094985135,1.20209114187,-2.10538506357,1.2907114763,-0.397695382403,1.88214929059,1.92333916118,2.53058671857,2.35285793953,0.974100280415,1.60707286494,0.102715274889,0.307841343102,-0.304520633333,0.0445436685109,-0.329881567002,-0.458978071287,-0.0681527365734,-0.233239422304,-0.294322743377,0.350753137591,-0.227719614955,0.705011536197,-0.102415569469,0.615462853631,0.565617106747,1.31310600916,0.942777409586,0.471047052599,0.421425313891,-0.10005020832,-0.148811085828,0.0676364623732,-0.211756391985,0.169016208682],[-31727.175881,-391.624471768,-1555.10828138,-3304.32430449,-683.973299869,338.694817583,900.285828875,178.322757668,-173.165007788,-669.659835971,616.987141654,-71.08845346,-890.398093104,-1039.87895322,-538.573350705,105.563802366,-265.231410238,102.19908764,-305.525957637,-183.788282675,-255.643660797,-189.417361211,106.638543711,-707.702029118,124.376218439,-21.038462774,-2.31588220124,0.175124695825,-98.8804733042,96.0134865554,-138.801867426,-108.335583852,-175.894390674,60.9925375212,77.8253067306,11.9383176586,37.67836398,44.9925317975,-19.6235168034,-19.787929781,-34.4918587689,-46.124354248,-66.9038026027,-49.5668366565,1.72840128565,17.1807871633,-12.5249246335,-18.3648028957,0.669738867707,12.9970572302,8.17636420299,-1.14290305714,-3.49883479005,-9.72361355658,-4.12737773999,-3.57485739339,-14.364111954,-8.57976705635,7.92237892635,6.07701814538,11.3339259009,12.1057955334,18.8254967057,-0.377808738463,1.33153732155,-3.77209771489,1.31655958499,4.4312715004,-1.65285425698,2.08594059276,-3.47623273556,0.802463461566,-3.94415133342,9.0090254087,3.80009648081,9.49917763034,4.12802964972,3.27882614048,0.750539772148,0.78923256806,-0.356156486477,-1.35308758628,-0.728262546646,0.0793173730019,0.51349614852,-1.78285771174,1.25592948988,-2.1477692746,1.33994200588,-0.335573812318,1.93129675693,2.00210093336,2.60874833156,2.40947395177,0.943698690503,1.55198990447,0.142261152943,0.288373278464,-0.277479595938,0.0403287921767,-0.325475360231,-0.435803878105,-0.0604721374545,-0.230613975475,-0.275612164597,0.366337743784,-0.230150222666,0.720213695825,-0.0827317443887,0.614449949896,0.582652446806,1.30769226165,0.944837127944,0.466745762407,0.401532416181,-0.0819479181715,-0.155358036357,0.074822333252,-0.20716278858,0.164549740603],[-31734.4827085,-377.179789806,-1617.02492216,-3319.37860891,-676.279361252,356.730540692,884.916972981,144.081922088,-208.3664034,-688.944543069,622.457440474,-59.2167295132,-897.972602617,-991.142992722,-508.004830947,98.2090964876,-241.545746525,131.533068616,-289.782558134,-205.336347535,-246.484215361,-192.756054188,96.0073532908,-712.73733527,128.136638662,-11.018638921,-3.2452567985,3.59498652814,-102.822853457,91.1444511143,-141.489927929,-109.095396871,-183.85843452,59.2740980238,80.7657740532,13.2450935269,37.3006014353,43.4910564658,-20.4657851667,-20.1279731037,-36.4892400049,-49.4332640461,-67.4437509592,-52.4841219926,2.00648763499,19.8992850169,-11.7591538855,-16.8792513562,0.672702325977,12.2530915513,7.31828174211,-1.17884183787,-3.78957137336,-11.08585463,-4.79236023748,-3.9795256483,-14.0821052946,-8.1426504146,8.99459606538,6.26979195474,11.9328430597,11.963676424,18.5625108923,-0.506441073967,1.215825386,-4.03537345822,1.09530125971,4.38896792812,-1.97681127307,2.07083913541,-3.55849343556,1.03081279373,-3.8086376013,9.14643932394,3.90010235626,9.77381634817,4.24745537741,3.19124673903,0.760027784726,0.798678603062,-0.386686040253,-1.37286393563,-0.715296405328,0.0336640520277,0.537732010504,-1.79882902809,1.30640764887,-2.18835248788,1.38375723579,-0.271049509611,1.97957663866,2.07895365173,2.68554634833,2.45944302207,0.913361823512,1.49995269311,0.18502854209,0.272257840355,-0.252010903988,0.035888650145,-0.320709220047,-0.412199539388,-0.0526550936343,-0.228464208418,-0.257666062184,0.380908762708,-0.232463150284,0.73411397562,-0.0620092495025,0.612884203909,0.599469418823,1.30314199279,0.945833447498,0.462803886794,0.382158278153,-0.0625547844141,-0.160630509977,0.081292107107,-0.202667228095,0.159549530649],[-31740.1918211,-364.028468707,-1679.31751805,-3330.28377997,-669.938627612,377.337684894,871.215006466,106.914057652,-243.859995276,-710.998618685,625.389886302,-45.1519612698,-903.239542878,-942.464105394,-476.135696232,89.303199996,-218.883246607,160.14014132,-273.483815556,-225.836149969,-235.780223604,-196.016920787,84.8668130806,-715.453225904,131.354211036,-0.856063270672,-4.47266025548,7.45237121221,-106.278458648,87.1966019997,-144.071410046,-109.830205284,-191.086127787,57.9965946179,83.8293531721,14.4890649284,36.9241050634,42.0160892376,-21.2905574955,-20.397706246,-38.2677911441,-52.7618801688,-67.8955770767,-55.3270714366,2.44098815161,22.5982887196,-11.093714838,-15.7209802333,0.673231426987,11.5017327377,6.46257313016,-1.22392949571,-4.11464169767,-12.4017526144,-5.47846106269,-4.31592624389,-13.8422071423,-7.67445296791,10.0550579504,6.42338790897,12.4202325511,11.7718997816,18.3330855407,-0.625256324802,1.09900655929,-4.29740316603,0.870242150584,4.33232063113,-2.29595574838,2.0491493082,-3.62308873596,1.23983600908,-3.67173833738,9.28677670227,3.9908695523,10.0269790378,4.34104212851,3.11488206662,0.776011132829,0.811925532138,-0.413214459104,-1.39379534521,-0.701574418161,-0.0117469825375,0.559197090531,-1.81803725695,1.35270336546,-2.22602551293,1.42002034933,-0.205174227634,2.02668109824,2.15345359992,2.75934409365,2.50126588473,0.884907037619,1.45209872139,0.230491296149,0.259296349409,-0.228641934677,0.0315732066171,-0.315788726018,-0.388617565574,-0.0445775579466,-0.22692616891,-0.240767461406,0.394042564182,-0.234384542648,0.746352391004,-0.0406756993722,0.610739400109,0.615988427731,1.29941594854,0.945295170086,0.459417410418,0.363663209988,-0.0419078437933,-0.164616672887,0.0868443307686,-0.198484971478,0.154151839493],[-31743.9283447,-350.153139961,-1741.19630157,-3335.01566478,-664.257520909,401.358547957,858.594733306,67.80263837,-278.096403116,-735.610780339,625.698341997,-28.8316218499,-906.361449859,-894.369669403,-443.773759581,79.1648795437,-197.473298021,187.552656146,-256.604123029,-245.249166475,-223.821224052,-199.490212507,73.3951359606,-715.360198864,133.951046095,9.32647206236,-6.10947134391,11.71031158,-109.209239916,84.1354128175,-146.619759899,-110.51684924,-197.308231774,57.1713694087,86.8751308161,15.6081962626,36.5547439687,40.5606731637,-22.1071275394,-20.5772490937,-39.7947237412,-56.0817188198,-68.270042902,-58.0279705791,3.04413712995,25.2174403189,-10.5628625862,-14.9010024047,0.660885724164,10.7531950898,5.625313506,-1.27777545899,-4.46823749225,-13.6462213209,-6.17114165277,-4.58777181459,-13.6457436591,-7.17349276036,11.0919305947,6.52854266906,12.7837003069,11.5337361606,18.1510033712,-0.732630913473,0.983670899652,-4.55161507203,0.645505395948,4.26054707975,-2.60295021719,2.02243575747,-3.66937055927,1.42328815671,-3.53362722264,9.42826530824,4.07174789084,10.2518393128,4.40691915275,3.05613202936,0.799877165911,0.826795216581,-0.434367648286,-1.41564271199,-0.686579187384,-0.0554097049131,0.576807395244,-1.83955043818,1.39419758748,-2.2597138635,1.44667626748,-0.138892881979,2.07224232182,2.22535262951,2.82831247698,2.53353633109,0.860088492357,1.40947041837,0.277874873364,0.249277088108,-0.207806525193,0.0277741980983,-0.310930541824,-0.365510728839,-0.0361253845957,-0.226117539277,-0.225182736243,0.405350414748,-0.235614718943,0.756591644159,-0.0191203537622,0.607984467521,0.632176198033,1.29643098908,0.942775101728,0.456763278514,0.346401111438,-0.0201333258188,-0.167315258185,0.0913158980466,-0.19481599738,0.148504174284],[-31747.3824467,-334.576162725,-1800.19376558,-3331.06269147,-658.455533158,429.956873644,846.458582419,28.5579677981,-309.151483344,-762.543162221,623.297853872,-10.3754156677,-907.387153943,-847.657294227,-411.946560158,68.2476861488,-177.52259677,213.32571178,-239.182792413,-263.54834277,-211.003849556,-203.569752073,61.731726055,-712.039755484,135.866628913,19.4041364449,-8.26029999207,16.3257405859,-111.595554255,81.8868685965,-149.235271377,-111.143782539,-202.273605977,56.7885707624,89.7677675222,16.5370771767,36.2007095048,39.1180098532,-22.9261774813,-20.6497394875,-41.0449428508,-59.3670494212,-68.5790290684,-60.5226385549,3.82107686342,27.6940528373,-10.1995758983,-14.4286912844,0.623365958275,10.0184171259,4.82207685881,-1.33966510954,-4.84395404189,-14.794123558,-6.85451433081,-4.79965092883,-13.4939519238,-6.6394403447,12.0929661448,6.57737957551,13.0115031509,11.254384751,18.0286295645,-0.827533158121,0.872611057812,-4.79147448126,0.42509480369,4.17342342075,-2.89000945279,1.99260449989,-3.6969792483,1.57535993772,-3.3943731978,9.56895126566,4.14254072135,10.4413453538,4.44390802544,3.02103434762,0.832636098678,0.840684571881,-0.44884282435,-1.43811044665,-0.669760411377,-0.0958365861622,0.589613000891,-1.86226443844,1.43052194598,-2.28838938858,1.46182494287,-0.0730413713202,2.11587286446,2.2944816405,2.89048896374,2.5551413936,0.840659719182,1.37304966841,0.326193846736,0.241976690681,-0.189903933806,0.0249222472897,-0.306361333235,-0.343325016946,-0.0271823407298,-0.226115189878,-0.211166158114,0.41448856778,-0.235825771518,0.764529863338,0.00229349564369,0.604605258494,0.648033563928,1.29407262684,0.937890803559,0.455020614415,0.330720118606,0.00257508006764,-0.168738392942,0.0945820256021,-0.191823260039,0.142777746224],[-31754.5701834,-316.787844415,-1848.82446592,-3315.09068656,-651.789326113,465.233697541,835.191552934,-9.13573439748,-334.727977256,-791.586100416,618.095187947,10.2324303933,-906.474365986,-803.463086705,-381.991732687,57.1165837141,-159.233766339,236.999264932,-221.282516988,-280.725266095,-197.857652408,-208.747824824,49.9691788195,-705.152034098,137.057892997,29.2500774598,-11.0307182042,21.2391871757,-113.419602229,80.3356041448,-152.043225866,-111.714601518,-205.761748027,56.8271014837,92.3855626064,17.2095810452,35.8712062871,37.6830950161,-23.7643747806,-20.5969132347,-42.0008289169,-62.5967905028,-68.8356319774,-62.7532841829,4.77558330707,29.968224541,-10.0328523436,-14.3123868124,0.547066607199,9.30905690965,4.06848419349,-1.40962054599,-5.23408966319,-15.8207912744,-7.51210970142,-4.95665326995,-13.3882177288,-6.07185297759,13.0459917547,6.56287100714,13.0920753028,10.9401249494,17.9761636306,-0.909520851277,0.768829827119,-5.01052478266,0.212707880538,4.0713202917,-3.14914392229,1.96210581147,-3.70587973911,1.69062624971,-3.2537854709,9.70664490768,4.20309532304,10.5882102026,4.45153208569,3.01480315617,0.874973308892,0.850851368314,-0.455453566691,-1.46087666997,-0.650547078728,-0.13158478051,0.596801108506,-1.88498031633,1.46165158851,-2.31114544616,1.46373253803,-0.00837160631438,2.15717004032,2.36066930399,2.94378551091,2.56529606294,0.828262739641,1.34375099417,0.374401714974,0.237139722211,-0.175301038521,0.023466108187,-0.302310383213,-0.322490243959,-0.0176148748876,-0.226980564143,-0.19896727334,0.421199710409,-0.234696995715,0.769920252433,0.0232015325891,0.600609783866,0.66358809484,1.29218990398,0.930355652479,0.45436208828,0.316981975607,0.0259813191643,-0.168922610063,0.0965167289848,-0.189631646532,0.137155728629],[-31770.3885711,-297.765604315,-1877.21878347,-3284.0252209,-643.713548536,509.280595973,826.72590893,-44.9260115764,-352.727832515,-822.400410634,609.849257163,33.3044579658,-904.015404327,-762.912858788,-355.26369815,46.331880754,-142.786951249,258.131645814,-202.951620265,-296.787408785,-184.930227799,-215.506617408,38.140890277,-694.540368891,137.499545054,38.7400023912,-14.5116311858,26.3785847088,-114.657916966,79.3486849369,-155.172282134,-112.238650548,-207.631818134,57.2752284877,94.62190525,17.5702112226,35.572604144,36.2560843214,-24.6427351044,-20.4003088969,-42.6524041281,-65.7535139043,-69.0509325392,-64.6822796091,5.91390487328,31.9843497381,-10.0860006899,-14.5537898535,0.42101993105,8.6356671204,3.37966938264,-1.48879589768,-5.62999601614,-16.7052883875,-8.12966703907,-5.06305997889,-13.3318531655,-5.46949343815,13.9386567877,6.4794837538,13.0161070388,10.5981152474,17.9998022877,-0.978537893961,0.675133542897,-5.20288025566,0.0114132980393,3.95470026313,-3.37320155373,1.93316193631,-3.69609426288,1.76442448882,-3.11130518032,9.8387034649,4.2531862905,10.6857953009,4.43015220556,3.04100220392,0.927275331981,0.854844322961,-0.453325055937,-1.48352839925,-0.628472543724,-0.161380486618,0.597669981808,-1.90657388049,1.48782023737,-2.32718747703,1.4510822333,0.0544020736382,2.19570575868,2.42365432154,2.98616401749,2.56365674414,0.824072478919,1.32235035769,0.421467937315,0.234420489079,-0.164292521827,0.0237834505185,-0.298951929826,-0.303404533854,-0.00728534924889,-0.22873840255,-0.188783654625,0.425356366927,-0.231966821729,0.772622989204,0.0432319636324,0.596017454246,0.678869849792,1.29056932691,0.920021536862,0.454863628793,0.305541172323,0.0498172888089,-0.167942854665,0.0970131117195,-0.188308082727,0.131808903819],[-31798.416098,-279.86376821,-1881.39685116,-3237.47536897,-633.983600471,562.480329622,823.000379781,-79.0644987096,-362.341122648,-854.485130885,598.160028222,59.1011210317,-900.528198202,-726.387578199,-332.554682367,36.2827825275,-128.289134951,276.428088598,-184.239796868,-311.789042118,-172.524289989,-224.081763324,26.244915475,-680.337637758,137.216292539,47.7619274579,-18.7374868276,31.6750312411,-115.296806273,78.8230026712,-158.707982636,-112.715553839,-207.886067409,58.1088093602,96.3660444529,17.5966538458,35.304053457,34.8472459955,-25.577468499,-20.0481951433,-42.9991845009,-68.8276969488,-69.2269608528,-66.3098814009,7.23587220748,33.6861740091,-10.3751448175,-15.137265369,0.242520545755,8.00600053271,2.76861822762,-1.57769685202,-6.02341227017,-17.4363564288,-8.69996190145,-5.12081401461,-13.3310521065,-4.83293251304,14.7567348074,6.32326690539,12.7821227151,10.2373085197,18.0999141536,-1.03475048629,0.593983390094,-5.3642925425,-0.176700409697,3.82405443626,-3.55775830651,1.90638646722,-3.66753063775,1.79363151113,-2.96649923645,9.96151643152,4.29255006886,10.7301201187,4.38205170382,3.10048039535,0.989622069735,0.850145175157,-0.442256911437,-1.50547781039,-0.603382940294,-0.184385899014,0.591800261876,-1.92623322246,1.50934701385,-2.3359282556,1.42334031585,0.114685281054,2.23103646577,2.48317412169,3.01608965779,2.5507123274,0.828414386668,1.30934608282,0.466216641203,0.233321182461,-0.156955231767,0.0260282214747,-0.296355597972,-0.286420902547,0.00389324688389,-0.23131712485,-0.180697720649,0.427026991835,-0.22749657814,0.772697277704,0.0620915498556,0.590874222448,0.693898906538,1.2889233633,0.906956578725,0.456411065626,0.296703232406,0.0737082889529,-0.165960300257,0.0960428183638,-0.187829339557,0.12686515018],[-31840.100807,-264.404701182,-1866.3443271,-3177.52736949,-622.019274418,622.986600476,824.588947927,-112.205941311,-364.044928399,-887.214774641,582.68499259,87.4876085483,-896.684948065,-693.497904883,-313.900957794,27.1212644616,-115.741194148,291.800286337,-165.243648895,-325.849500484,-160.686162479,-234.349522135,14.3324686683,-662.957492441,136.277108211,56.2290907167,-23.6674621646,37.073801193,-115.335010586,78.6970472662,-162.646646594,-113.111131582,-206.666190315,59.2750897673,97.506183356,17.3022045891,35.0584687654,33.478023348,-26.5719614989,-19.5334670367,-43.0515605334,-71.8129988221,-69.3506415657,-67.6710454775,8.72974265752,35.0173869976,-10.9076867102,-16.0286130656,0.0171142735267,7.4245205688,2.2447875278,-1.67411399922,-6.40735117519,-18.0123975291,-9.22300287211,-5.12818853957,-13.3926817173,-4.16613259528,15.4834230566,6.09094006808,12.3987738771,9.86882099825,18.272299567,-1.0782873477,0.527375151808,-5.49294247236,-0.350299477453,3.6802109577,-3.70129837717,1.88062541504,-3.62005212502,1.77729906409,-2.81960384515,10.0705490213,4.32035743673,10.7209214829,4.31188274444,3.19158542568,1.0616166319,0.833987462703,-0.422710057224,-1.52608205704,-0.575540070133,-0.200342056174,0.579146716805,-1.94348090244,1.52648773459,-2.33716946429,1.38088629108,0.172033569633,2.26271555572,2.53885683294,3.03284373,2.52792619794,0.840890250615,1.30490299116,0.507295878407,0.233187734092,-0.153075101943,0.0301059583242,-0.294505931526,-0.271818660978,0.0159056489898,-0.23455960704,-0.174687512763,0.426444805215,-0.221288512404,0.77040861406,0.0796217025906,0.585295728041,0.708652030948,1.2869728591,0.89149589181,0.458767497374,0.29070264021,0.097141713082,-0.163261552243,0.093671624133,-0.188085518102,0.122420097435],[-31894.7163492,-250.886725697,-1841.61570888,-3107.85859573,-606.746707124,687.691105278,830.148655792,-145.276121247,-359.064277716,-919.866557098,563.367065494,117.819061739,-893.195977389,-663.468041321,-298.572978946,18.8295845757,-105.03619128,304.338954693,-146.107126292,-339.116066778,-149.349188173,-245.837772849,2.51557683787,-642.97377298,134.778979204,64.0832911396,-29.2019385327,42.5430646603,-114.787347313,78.9369315444,-166.893331367,-113.353558766,-204.196036453,60.6911440123,97.9370247552,16.7252806135,34.82697432,32.1734920066,-27.6126692642,-18.8521521358,-42.827312193,-74.7001596227,-69.3969255234,-68.8179057965,10.3692723791,35.9268828309,-11.6865433364,-17.1785021275,-0.24450946095,6.89268050904,1.81361603975,-1.77276422875,-6.77654927003,-18.4377231928,-9.70371944082,-5.08076100655,-13.5213693839,-3.47712060466,16.1014379175,5.77819665518,11.8832909023,9.50468011127,18.5097220735,-1.10926421201,0.476609847345,-5.58920220159,-0.508541355787,3.524426934,-3.80427102548,1.85345585318,-3.55352058776,1.71673590775,-2.6715811957,10.1611335466,4.33475397505,10.6615596836,4.22588779366,3.3111807237,1.1423849997,0.803540691861,-0.39562704845,-1.54478231382,-0.545515386424,-0.209551804038,0.559960028346,-1.95801220427,1.53940457533,-2.33103384036,1.32490449259,0.226165046515,2.29041299501,2.5900808829,3.03660365515,2.49742927074,0.86071331999,1.30882152033,0.543254722327,0.233241020047,-0.152245479174,0.0357574839246,-0.293341781479,-0.259783654372,0.0286172522865,-0.238257777501,-0.17066238592,0.423944178495,-0.213433695731,0.766158879511,0.09581608022,0.57948065604,0.723050874995,1.2845263848,0.874164942928,0.461678877682,0.287674872125,0.119504578179,-0.160236577797,0.0900249782815,-0.188904580923,0.118542263044],[-31960.4692526,-242.353966593,-1816.2692176,-3032.73205958,-588.142368468,753.883177093,836.92338759,-178.343496326,-348.844554225,-951.779494789,540.549290054,148.914121626,-890.477439013,-635.549606726,-285.285417051,11.3615439497,-95.9619281763,314.28266954,-127.03094272,-351.670828612,-138.42468263,-257.821951696,-9.10286123841,-621.044518026,132.846622789,71.311379065,-35.2008724209,48.0704533162,-113.670525203,79.5104241699,-171.28824527,-113.380048951,-200.730835331,62.2467142196,97.5837474275,15.9196675158,34.6077155364,30.9575563368,-28.6699569032,-18.0038160133,-42.3511758498,-77.4738033354,-69.3440752914,-69.8050866684,12.1146422192,36.3764937728,-12.7119796071,-18.5285758818,-0.529267130729,6.41104161574,1.47631117924,-1.86491205758,-7.12733060059,-18.7202569655,-10.1491295073,-4.97534955139,-13.7174769814,-2.77826456955,16.5975452754,5.38021391028,11.2597955939,9.15675000728,18.8025393729,-1.12806944946,0.44226381199,-5.65508843292,-0.650584095959,3.35821105166,-3.86817389831,1.82183592521,-3.46840963698,1.61552647255,-2.52425199545,10.2297358807,4.33311719886,10.5583051728,4.13055126182,3.45496048778,1.23043581449,0.75624051732,-0.362327935494,-1.56122229355,-0.514044309737,-0.212660918183,0.534671627931,-1.96952660059,1.54818493606,-2.31783329421,1.25726655486,0.276860486714,2.31413729708,2.63597450651,3.02834449386,2.46154037901,0.886844891791,1.32055939616,0.572715150558,0.232693818689,-0.153979742636,0.0426183942549,-0.292803586677,-0.250407367058,0.0417978350871,-0.242185518566,-0.168452369715,0.419916643374,-0.204026878497,0.760434297285,0.11077271221,0.573717518108,0.736958228936,1.28151869771,0.855523911605,0.464902383067,0.287606820761,0.140166639401,-0.157337170348,0.0852743337744,-0.190079629056,0.115282412166],[-32035.0967411,-242.281615756,-1797.96529608,-2956.09583159,-566.378108837,819.270269379,842.184485979,-211.393400036,-334.849406396,-982.299906115,514.683001682,179.337593035,-888.908644814,-609.25977102,-272.673830479,4.65087242385,-88.3120654625,321.935533079,-108.253154033,-363.594175152,-127.850952441,-269.525592469,-20.3915887735,-597.880631575,130.601256261,77.913720941,-41.505738625,53.6484710409,-112.014401207,80.3814469667,-175.645517243,-113.116943918,-196.532869223,63.8284454372,96.4046143937,14.9452693078,34.3997394455,29.8536636192,-29.7059810125,-16.9931966493,-41.6493270404,-80.1127643422,-69.1647723411,-70.6871424379,13.9213651535,36.336787422,-13.9808024436,-20.0190938095,-0.82262004713,5.97975458998,1.2309073878,-1.94021409886,-7.45626637523,-18.8691326407,-10.567375833,-4.80810342809,-13.9788591487,-2.08324165302,16.960686276,4.89320402375,10.5556107942,8.83704985748,19.1396266771,-1.13505567292,0.424556579835,-5.69357592213,-0.775799775646,3.18339676494,-3.89500435371,1.7823610704,-3.36571868953,1.47857253444,-2.37948909892,10.2732473444,4.31237574902,10.4188874621,4.03237527876,3.61803480565,1.32357294514,0.690029211366,-0.324264071634,-1.57510764295,-0.481922640504,-0.210581900755,0.503898487625,-1.97781800247,1.55279806434,-2.29814427617,1.1802115863,0.324057946597,2.33401048355,2.67549153428,3.00950209477,2.42273761795,0.918207495019,1.33929988294,0.594389259858,0.230834494491,-0.157752185717,0.0502702732179,-0.292814178265,-0.24368931817,0.0551468662834,-0.246128443198,-0.167866020171,0.414776121789,-0.193222578561,0.753739334413,0.124671123725,0.568330416565,0.750203256282,1.27796672814,0.83616890068,0.468250177898,0.290363676112,0.158499710481,-0.155028172447,0.0796332128365,-0.191375731908,0.112684024852],[-32117.8218397,-248.602690075,-1792.25818339,-2880.79859946,-540.65211515,881.799975901,843.624224964,-244.963187085,-318.257387347,-1010.80203473,486.175061332,207.698604389,-888.973314418,-584.842777485,-259.482787016,-1.34801742222,-81.9831958162,327.609176552,-90.0526367392,-375.026943353,-117.810265647,-280.179364505,-31.1110183189,-574.113747115,128.142953562,83.8734190904,-47.9717165428,59.254341416,-109.863450417,81.4783329234,-179.754379305,-112.433107271,-191.839365134,65.3380234854,94.3623321643,13.8567187682,34.1973761391,28.8823462397,-30.6854611458,-15.8264421664,-40.7465876314,-82.5860974445,-68.8161302474,-71.5116814209,15.7479933632,35.7816748217,-15.4919714089,-21.5945087604,-1.11139554705,5.59941255567,1.07347882889,-1.98838645468,-7.75901708736,-18.8918222881,-10.9653005084,-4.57290084104,-14.3018062676,-1.40453601432,17.1796501257,4.31117822057,9.79666154502,8.55769871518,19.5105413408,-1.1304762649,0.424100703744,-5.70785674365,-0.883734148568,3.00213586416,-3.88628799101,1.73175948234,-3.24691138476,1.31124036419,-2.2389952781,10.2885570018,4.26827924366,10.251214407,3.93834947324,3.79628762316,1.41927551503,0.603231087581,-0.282700566061,-1.58606316944,-0.449862372107,-0.204311173662,0.468392297311,-1.98272921577,1.55305625303,-2.27291705893,1.09602571297,0.367790446213,2.3501541388,2.70726094886,2.98167397975,2.38369524479,0.954087348391,1.36400411002,0.607056817351,0.227062890032,-0.163058377691,0.0583221610805,-0.293295430404,-0.239551747462,0.0683437853461,-0.249923981399,-0.168742969039,0.408886027298,-0.1812705918,0.746551904916,0.137729059077,0.563649554018,0.762555792797,1.27394683734,0.816752908079,0.471684982663,0.295751221437,0.173870582765,-0.153740740515,0.0732860026526,-0.192557553204,0.110782923005],[-32208.7301777,-254.925257768,-1802.55011429,-2808.43985339,-509.27457103,939.960896355,839.387895126,-280.343642498,-299.899131683,-1036.69897498,455.379629634,232.77148568,-891.360255054,-563.131182962,-244.691335308,-6.63332014395,-76.9398431964,331.587596221,-72.7269779696,-386.163165618,-108.654392404,-289.09128548,-40.9206253443,-550.244309086,125.555883696,89.1572104973,-54.4824619485,64.8552404365,-107.269266457,82.7124876507,-183.398560949,-111.157235801,-186.842062487,66.7020807996,91.4113784077,12.6995316891,33.9920965658,28.0586461235,-31.5793281761,-14.508744051,-39.662376906,-84.8568785477,-68.2442024532,-72.3155570768,17.5615928149,34.6845307276,-17.2472009231,-23.2052781828,-1.38488801355,5.27122845953,0.999154052161,-1.99995489799,-8.02995033659,-18.7933175897,-11.3471499265,-4.26239494532,-14.681649659,-0.752158035208,17.2431177103,3.62668001404,9.00656132901,8.33016988049,19.9063057692,-1.11471817019,0.441852276624,-5.70080193433,-0.97406582438,2.81676656654,-3.84303866617,1.66722347627,-3.11361004138,1.11886068275,-2.10413463621,10.2727972142,4.1960016104,10.062724892,3.85531508519,3.98650689323,1.51505027689,0.494589016938,-0.238680486228,-1.59365213016,-0.418414242384,-0.194792337398,0.428885456596,-1.98416040356,1.54875178472,-2.24328015347,1.00688558632,0.408121010587,2.36271225504,2.72978906956,2.94647680799,2.34701330853,0.994147737009,1.39362010393,0.609624955861,0.220924633034,-0.169470215003,0.0664528942084,-0.294180794719,-0.23787081338,0.0810834624361,-0.253474470482,-0.170964299832,0.402544787943,-0.168471781172,0.73930857891,0.150141724739,0.559999298136,0.773761885847,1.26957420701,0.797914909391,0.475289446732,0.303576345542,0.185677413678,-0.153844418065,0.0663730611881,-0.19342269018,0.109600990729],[-32307.9692184,-254.896025693,-1825.76937619,-2739.35414981,-470.756244106,993.917360116,829.006121419,-319.83588148,-280.24878792,-1059.59431847,422.561083535,253.853704472,-897.085305605,-545.377178259,-227.581825192,-11.167492227,-73.151328392,333.988247158,-56.5402815074,-397.174138129,-100.859524913,-295.655723234,-49.4722000158,-526.654800395,122.908957613,93.7217248491,-60.9759673576,70.3952778904,-104.254230131,83.9753015078,-186.36780459,-109.134623862,-181.692604578,67.8948900554,87.5144474967,11.508375331,33.7737726223,27.3900134609,-32.3727758909,-13.0349717511,-38.4130139311,-86.8861659675,-67.3978312521,-73.1235547111,19.3514830724,33.0249951365,-19.2491622683,-24.8095421401,-1.63526486677,4.99630677078,1.00450172502,-1.96874344081,-8.26218380783,-18.5756514035,-11.7138061865,-3.86967532443,-15.1123532877,-0.130248261211,17.1419782672,2.83078641913,8.2054832055,8.16414743266,20.3198455237,-1.08821747312,0.47873283799,-5.6740144568,-1.04670369718,2.62937338182,-3.76567426224,1.58677822022,-2.96710596047,0.906363460834,-1.97556522494,10.223837537,4.09030726188,9.85960157187,3.78920417497,4.18608059383,1.60871489135,0.363471747369,-0.193017026172,-1.59741696112,-0.387846490753,-0.182724082414,0.385788658524,-1.98199910916,1.5397674513,-2.21026917775,0.91471533364,0.445003063143,2.37192239769,2.74154593919,2.90535027281,2.3148869663,1.03826336573,1.42726961227,0.601367218928,0.212034350972,-0.176651478957,0.0744301520638,-0.295396616402,-0.238516665652,0.0931490003295,-0.256788094897,-0.174469000564,0.395979365507,-0.155113869634,0.732368366046,0.161969235319,0.557693536368,0.78356149955,1.26497571116,0.780179862911,0.479203591457,0.313689521228,0.193455386435,-0.155672873554,0.0589545629238,-0.193809987392,0.109148594464],[-32415.466107,-241.667352817,-1850.53333152,-2672.96685124,-423.602521698,1045.61825357,813.783301073,-366.548560011,-259.428487976,-1079.35664671,387.858200037,270.925303836,-907.368171907,-533.179646693,-207.78681572,-14.899921701,-70.6209878888,334.736449408,-41.6722289807,-408.1848606,-95.0347728698,-299.423485154,-56.4837893184,-503.593612519,120.250830443,97.5097990872,-67.4484264417,75.7935692501,-100.818005818,85.1320605,-188.479171326,-106.252032318,-176.492858147,68.9459027111,82.6518397531,10.3073157822,33.5310330906,26.8757379255,-33.0688684458,-11.3898617647,-37.0129372989,-88.6375997828,-66.237462159,-73.9464863371,21.131220716,30.7963148916,-21.499527627,-26.3756482485,-1.85765596672,4.77560306384,1.0887416907,-1.89332466416,-8.44848356088,-18.2383467227,-12.0632231406,-3.39025405324,-15.5859098745,0.464482553847,16.8718626715,1.91483775689,7.40789662472,8.06627425363,20.7458067028,-1.05129495138,0.535776039884,-5.62759703223,-1.10187714655,2.44177539263,-3.65416331084,1.48952582111,-2.80834108288,0.67809326626,-1.85295147553,10.1407451864,3.94613924876,9.64612935197,3.74448742423,4.39303783339,1.69862641977,0.210031308716,-0.146266626311,-1.59684738203,-0.358137467942,-0.168499770288,0.339244978833,-1.97608994567,1.5260851834,-2.17477711856,0.82105751731,0.478284057071,2.37818403506,2.7411896487,2.85942174508,2.28891218313,1.08640369898,1.46425292131,0.582018586147,0.20007411109,-0.184376355168,0.0821110809514,-0.296858342423,-0.24136691149,0.104450192412,-0.259953128882,-0.179268650273,0.389326187961,-0.141451295238,0.725973738177,0.173127485946,0.557020678531,0.791721482583,1.26025658028,0.763895853802,0.483580086954,0.325976119224,0.196946023954,-0.159487014236,0.0510019613442,-0.193601191215,0.109415858494],[-32530.8094001,-209.068428007,-1862.89087856,-2608.21038566,-367.060183332,1097.59092941,795.50417404,-421.779395874,-237.484157135,-1096.22618754,351.462988449,284.455708405,-922.76278629,-527.836211344,-185.422006444,-17.8148364349,-69.4017067454,333.751699224,-28.1911450041,-419.189346354,-91.7211647861,-300.155291915,-61.789183026,-481.225045265,117.607956701,100.459875961,-73.9140956083,80.9709264737,-96.9598611502,86.0665947395,-189.602460142,-102.44871843,-171.329400843,69.899133653,76.8342439756,9.11243212097,33.2533387843,26.5084678901,-33.6802807529,-9.56408642505,-35.4707309799,-90.0813197381,-64.7429793302,-74.7870807661,22.919573067,28.0177573869,-23.9899701306,-27.8797303875,-2.0486916359,4.61011191624,1.25065806352,-1.7760031589,-8.58415220705,-17.7810036011,-12.3903710508,-2.82443263537,-16.0923642834,1.03774103623,16.4365411285,0.87500516582,6.6224089714,8.03910278627,21.1791883449,-1.00397011875,0.613914437444,-5.56132608011,-1.14047770372,2.25550074554,-3.50894895169,1.37587244361,-2.63836049682,0.438329252114,-1.73547082336,10.0243611066,3.76050765055,9.4250242522,3.72411238298,4.60548035417,1.78358111142,0.0350200294045,-0.0987499985749,-1.59144985356,-0.329166239469,-0.152385983992,0.289421113367,-1.96639946806,1.50781581092,-2.13753560616,0.727270874571,0.50788270192,2.38211464213,2.72798646163,2.80959664467,2.27001420151,1.13832396075,1.50375229763,0.551703223045,0.184837106327,-0.192454998181,0.0894130817626,-0.298475311792,-0.246278441151,0.114980456992,-0.26305037626,-0.185421500724,0.382624254065,-0.127686978044,0.720296137913,0.18350375471,0.558210601677,0.79808319369,1.25550075611,0.749215049729,0.488488552284,0.340251115174,0.196069779821,-0.165397478882,0.0424435905128,-0.19271395896,0.110348985876],[-32652.1726268,-156.321931317,-1852.79715308,-2544.79182702,-301.9397207,1151.73459073,776.18033799,-483.484352253,-214.928126376,-1110.60497944,313.686349398,295.387370734,-942.565792893,-529.655775351,-161.044256237,-20.0076004398,-69.5290357967,331.12848903,-16.0156791942,-429.993596982,-91.1278559799,-297.842486428,-65.3869473436,-459.748368348,114.992616317,102.53198445,-80.3612561821,85.8898278696,-92.6954185515,86.7379132674,-189.672124052,-97.7290497225,-166.325629895,70.7935587865,70.1214214263,7.94208216164,32.9312038,26.2774070643,-34.2166253612,-7.5673102372,-33.7860298877,-91.1973255965,-62.9171688274,-75.653566273,24.7278656986,24.7440339378,-26.6952130254,-29.3000917133,-2.20330573496,4.4990528797,1.48521726548,-1.62085828694,-8.6686321799,-17.2069530357,-12.6891388979,-2.178100082,-16.6214202902,1.59397759729,15.8507618133,-0.283160651056,5.85445009228,8.08157602649,21.6130940241,-0.945993296387,0.713246468978,-5.47590947132,-1.16452796082,2.07166780178,-3.33212157489,1.24714453309,-2.45847638391,0.192155014895,-1.62204873123,9.877975077,3.53418534013,9.1983887893,3.72979636606,4.82055359238,1.86235800292,-0.160033760063,-0.0507309268823,-1.58083404668,-0.300898531057,-0.134838867291,0.236728829966,-1.95322319773,1.4852507316,-2.09904858015,0.634958903284,0.53399193345,2.38462485354,2.70219236654,2.75672884908,2.25855553324,1.19316218302,1.5445179479,0.510938894696,0.166282694382,-0.200639966308,0.0962381682881,-0.300117997987,-0.253053612172,0.12473121098,-0.266081301206,-0.192962245859,0.375882194996,-0.113964120807,0.715538448303,0.193068927756,0.561410978845,0.80262956697,1.25074977101,0.736140708564,0.493798067396,0.356142552503,0.190927410989,-0.173321081196,0.0332402958599,-0.191077299742,0.111834057903],[-32777.2527675,-88.0310391216,-1820.86440869,-2483.28516688,-230.323118591,1207.96070885,757.480507203,-547.672865993,-192.622092459,-1122.86394359,274.765950161,304.824131811,-965.371745559,-537.988273106,-135.583947744,-21.6253239447,-70.9881305125,327.167614098,-4.96322612783,-440.387287221,-93.0891113253,-292.755200858,-67.3747244752,-439.467690993,112.414972773,103.722819296,-86.7395258366,90.5745778525,-88.0794660264,87.1826930736,-188.706417399,-92.1352939452,-161.653654087,71.6637309846,62.6178790917,6.81661534424,32.5578037795,26.1727114576,-34.6780102294,-5.42811119883,-31.952846036,-91.9802675302,-60.7750059904,-76.56476833,26.5606338529,21.0527973453,-29.5770820727,-30.6185318749,-2.31537567365,4.43913070622,1.78352785153,-1.43217443882,-8.70406083112,-16.5237138004,-12.9536891305,-1.45982794701,-17.1645757665,2.13723695521,15.1362312873,-1.54461454542,5.10843315901,8.19107207147,22.0395692585,-0.877210863263,0.832671556345,-5.37325829444,-1.177033163,1.8912959768,-3.12712357444,1.10537034411,-2.27024786987,-0.0545973130047,-1.51121743989,9.70655200997,3.27160940623,8.9682123233,3.76241984874,5.03475602794,1.93351610527,-0.373084297683,-0.00246731973935,-1.56482675597,-0.273416591257,-0.116592251669,0.181862139122,-1.93717761047,1.45888807358,-2.05973929499,0.545985146159,0.5571032041,2.38670477115,2.66497945006,2.70163337621,2.2545889276,1.2496378429,1.58501745174,0.460480246384,0.144548696622,-0.208622998827,0.102476977299,-0.301632889998,-0.261451366596,0.133636141888,-0.268989178205,-0.201877779183,0.369108606436,-0.100408797744,0.711944689747,0.20187927029,0.566670590298,0.805484748967,1.24600246483,0.724621120874,0.499238941132,0.373119527947,0.181761106875,-0.183046403398,0.0234491513749,-0.188617453744,0.113730427642],[-32904.2104292,-13.1108948576,-1774.26557629,-2424.14731953,-154.743283423,1264.52854531,740.803168145,-611.239378914,-171.105529094,-1133.2184316,234.733502503,313.791365266,-989.928054345,-551.731241126,-110.281504836,-22.7420204598,-73.702306192,322.263259558,5.14900443773,-450.25331904,-97.269985659,-285.441922156,-67.8914488371,-420.671129451,109.877236293,104.063246127,-92.9790302877,95.0754457245,-83.197117819,87.4733876201,-186.790899204,-85.7071163804,-157.469972203,72.5603305854,54.4414360204,5.74829620874,32.1307808783,26.1842338837,-35.0593918027,-3.17721489975,-29.9621355564,-92.4312308581,-58.3299994275,-77.538557905,28.4227482599,17.0269254069,-32.5957484781,-31.8197645884,-2.38137768728,4.42508206598,2.13518695657,-1.2139532866,-8.69157002694,-15.740368568,-13.1770766229,-0.678365096279,-17.7146413011,2.6734519112,14.3163074702,-2.88931322936,4.38752907898,8.3643116988,22.4507717963,-0.797939886843,0.970077680128,-5.2557394646,-1.18117923312,1.71541697412,-2.89787192329,0.953354224659,-2.0751947327,-0.296149597977,-1.40093853343,9.5156460976,2.9789785844,8.73626443018,3.82211441035,5.2451656374,1.99562492907,-0.601781123151,0.0458903525825,-1.5434693952,-0.246862245538,-0.0984577394086,0.125488183075,-1.91899021421,1.42938243627,-2.02004377667,0.46219536468,0.577793237493,2.38932920621,2.61797578217,2.64510874451,2.25791468965,1.30658254045,1.62368940811,0.401133719967,0.119861899786,-0.216103483994,0.108092799222,-0.302880158092,-0.271218921891,0.141592800393,-0.271753887654,-0.212133062565,0.362295355561,-0.0871711642028,0.709738486745,0.209993780689,0.573980157031,0.806844012968,1.24124844495,0.714550642773,0.504560979824,0.390618627108,0.168912392368,-0.194291701349,0.0132041988037,-0.185261724985,0.115887755754],[-33031.0543234,59.6319042135,-1720.06226532,-2367.50610544,-77.1578650443,1319.2176361,727.336037403,-672.300747477,-150.486825008,-1141.76018346,193.50630821,323.064122022,-1015.27756428,-569.711153321,-86.2675968643,-23.3639777178,-77.5868546524,316.805494754,14.45852702,-459.52368994,-103.315548943,-276.541246189,-67.1044267756,-403.540565883,107.367023906,103.59987625,-99.0097843383,99.4444106208,-78.142124631,87.6850736452,-184.035608977,-78.486854273,-153.860889325,73.5341742119,45.7120376208,4.73967790953,31.6507769426,26.2987644326,-35.3557626875,-0.841371037595,-27.8078181029,-92.5508380603,-55.5960980911,-78.5784200823,30.31573024,12.7454122997,-35.7159191891,-32.8926960998,-2.40056193093,4.45023799726,2.52953204918,-0.970699996896,-8.63150418004,-14.8666173304,-13.3513040481,0.156919874297,-18.2634414044,3.20813473349,13.4132152976,-4.2963205678,3.69337230063,8.59699579904,22.839784059,-0.708663689457,1.122796142,-5.12577010254,-1.17994678108,1.54485741857,-2.64838830137,0.794294411293,-1.87491733916,-0.527134520601,-1.28920856458,9.3107721337,2.66259394499,8.5039527347,3.90787194494,5.44974330248,2.04747784505,-0.843735775842,0.0943326061866,-1.51691979462,-0.221357475335,-0.0811963479347,0.0680924762037,-1.89937216112,1.39737684058,-1.98039584142,0.385149058431,0.596546951243,2.39337510668,2.56278590171,2.58787984426,2.26798452856,1.36312281031,1.65913558216,0.333627410656,0.0924857994498,-0.222872785155,0.113132385526,-0.303729507437,-0.282096770355,0.148511139341,-0.274398433051,-0.223689294974,0.355393696196,-0.074406805751,0.709044097888,0.217443547736,0.583295498031,0.806886991081,1.23648108163,0.705741838788,0.509577897898,0.408110638057,0.152744494051,-0.20675691493,0.0026698648073,-0.18094854497,0.118170260675],[-33156.6423178,123.356545822,-1663.25524017,-2313.95423316,1.33873440809,1370.02075168,717.387542976,-729.539034094,-130.704874054,-1148.53692013,151.096434395,333.036356987,-1040.51804814,-590.755101289,-64.3917638131,-23.4654138622,-82.6026775579,311.192202299,23.0394489581,-468.148271025,-110.897140137,-266.677687611,-65.2022148614,-388.128535231,104.874427201,102.379003453,-104.773868244,103.73351301,-73.0143641708,87.886006827,-180.548052298,-70.5249685023,-150.837746695,74.6260630531,36.5331426498,3.7919611179,31.1181834198,26.4983617353,-35.5625406123,1.55487963926,-25.4891782742,-92.3398515014,-52.5933513074,-79.6719638368,32.2325718797,8.27686100766,-38.907878824,-33.8298439684,-2.37365656809,4.50737246449,2.95553968738,-0.707148242828,-8.52482832279,-13.9129823448,-13.469027345,1.03530139611,-18.8016830839,3.74433215561,12.4461016376,-5.74565606207,3.0259458177,8.88430667058,23.2012608487,-0.609903919448,1.28827139666,-4.98579877658,-1.17612280106,1.38024849913,-2.38266793819,0.631425226646,-1.67119919612,-0.742737478953,-1.17477573098,9.09709107399,2.32831724833,8.27227424872,4.01785752911,5.64728450315,2.08826423364,-1.09682539595,0.142939815212,-1.48535041072,-0.196937987149,-0.0655307050789,0.010075442228,-1.87899828398,1.36344645116,-1.94124162551,0.316051856707,0.613712666408,2.39960934756,2.50093352876,2.53050355152,2.28395409262,1.41857433186,1.69020160552,0.258470862487,0.0627086519184,-0.228783903612,0.117676610999,-0.304054199359,-0.293808046067,0.154317381166,-0.276971277683,-0.236498777478,0.348330385327,-0.0622441593983,0.709893165359,0.224265328165,0.594551407196,0.805779999472,1.23168537829,0.697940954122,0.514144104067,0.425141107687,0.133565194234,-0.220131135415,-0.00798187971448,-0.175641161101,0.12046542929],[-33281.5834133,174.585169372,-1606.66306949,-2264.04943742,80.3440778752,1415.55847389,710.856314328,-782.288286504,-111.659636752,-1153.60958108,107.533530251,343.849096328,-1064.9772225,-613.813151057,-45.4213323966,-22.9947263809,-88.7542625813,305.80244542,30.9060253001,-476.108025838,-119.692088734,-256.461060522,-62.3670806612,-374.328409634,102.394973071,100.440278782,-110.228099941,107.985705175,-67.9088187974,88.1406778308,-176.438600472,-61.8862436714,-148.34039792,75.8575751484,26.9869543827,2.90544057353,30.5312730543,26.7635702337,-35.6784933343,3.98622382813,-23.0084857341,-91.8031040568,-49.3464636628,-80.7931003062,34.1586222255,3.67610957733,-42.1444307942,-34.6295546031,-2.3018854319,4.58950923411,3.40184333374,-0.427953187893,-8.37330833486,-12.8910377286,-13.5242205267,1.94493274354,-19.3200633075,4.28179494887,11.4302149053,-7.21844165352,2.3835870748,9.22024063593,23.5310047002,-0.502168994495,1.46421978403,-4.83825882483,-1.17232557405,1.22189150175,-2.10486404416,0.46762529232,-1.46613699184,-0.939160249962,-1.05734138664,8.87898665821,1.98158241619,8.04153117518,4.14931826857,5.83687773193,2.11750778581,-1.35918557273,0.191854876939,-1.44889823732,-0.173578282414,-0.0521027371336,-0.0482237871428,-1.85858392541,1.32806593146,-1.90303650352,0.255645882044,0.629517226007,2.40862409231,2.4338351904,2.47332386843,2.30469233163,1.47237625719,1.71601507075,0.176017760867,0.0309246688495,-0.233760440394,0.121818330475,-0.303725020566,-0.306062124873,0.158957473498,-0.27952825946,-0.250494069193,0.341020349459,-0.0507897180316,0.71222664205,0.230504316594,0.607647957323,0.803665212715,1.22681689164,0.690829070363,0.518131413822,0.441339496287,0.111598648291,-0.234077469969,-0.0185984153753,-0.169341890989,0.122674044262],[-33408.1647021,213.28291514,-1555.48643561,-2217.96694355,160.188058753,1454.21138809,707.616118718,-831.379960047,-93.2254614449,-1156.96051436,62.652686758,355.510406801,-1088.66388066,-637.989418168,-30.3867571032,-21.8645588735,-96.0502647734,300.981211548,38.0452329751,-483.53767674,-129.356380779,-246.622386242,-58.7549916252,-361.94180834,99.9324283019,97.8206550153,-115.343668472,112.24201024,-62.936219867,88.5140774326,-171.870324948,-52.6506255114,-146.272365996,77.2234269896,17.1274735144,2.07819543345,29.885851192,27.0753762031,-35.7062406569,6.42246537316,-20.3691964496,-90.9629741449,-45.8842225745,-81.9152151487,36.0722445833,-1.02201128619,-45.3992215213,-35.2967122512,-2.18703798244,4.68982645213,3.85691122132,-0.137541825247,-8.1789654479,-11.8134432244,-13.5141326517,2.87279391997,-19.8127645142,4.81692638993,10.3749439109,-8.69635080059,1.76284548833,9.59772009734,23.8252939146,-0.386117948052,1.64856437329,-4.68557072677,-1.17116092656,1.07012045514,-1.8193034621,0.305206827182,-1.26218469109,-1.1143476657,-0.937449174536,8.65917132469,1.62767860226,7.81083006446,4.29859506348,6.01731355716,2.13494479316,-1.62924744913,0.241253632514,-1.40768199811,-0.151182841886,-0.0415101755997,-0.106404012867,-1.83892867562,1.29172318072,-1.86622877618,0.204091464071,0.644122631203,2.42058430567,2.36287631607,2.41621654419,2.32883594238,1.52391116383,1.73597194115,0.0864831054058,-0.00234701941452,-0.23780710003,0.125660665305,-0.302611328275,-0.318561148465,0.162389443898,-0.282104282042,-0.26559245003,0.333416378409,-0.0401155045455,0.715911566433,0.236218664045,0.622393649309,0.800676641699,1.2217026891,0.684028082784,0.521349849521,0.456407470899,0.0869598455728,-0.248243473333,-0.0290526174484,-0.162103313428,0.124706982602],[-33540.1930555,241.746954398,-1510.4897735,-2175.89318106,241.594926204,1485.54907146,706.849319419,-878.179782668,-75.2436273071,-1158.5501993,16.3830144559,367.695392831,-1111.71262275,-662.523136632,-20.1386892908,-19.962115812,-104.517710235,297.078893858,44.3901876742,-490.562390204,-139.547179131,-237.869762581,-54.5007263156,-350.66854777,97.4957255988,94.5573298985,-120.098550225,116.543351277,-58.1940341893,89.0692193581,-167.022775255,-42.9009005748,-144.483305788,78.689417968,6.98854422194,1.30606736924,29.1790820932,27.4122258211,-35.6490827688,8.83228044862,-17.574827762,-89.8478626814,-42.2368511208,-83.0002758321,37.9419534229,-5.79535460967,-48.6464986817,-35.8380743485,-2.03060454093,4.8016988059,4.30853938172,0.1601304234,-7.94382774505,-10.6935677492,-13.4371315504,3.80475245748,-20.2734433496,5.34280113503,9.28665202854,-10.1607667835,1.16003878886,10.0084017287,24.080506127,-0.262520315461,1.83923273796,-4.5303755709,-1.17514486936,0.92500382216,-1.53046568457,0.146177899637,-1.06206264991,-1.26679809347,-0.816030182636,8.43971840408,1.27195841909,7.5789910469,4.46114794158,6.18752848069,2.14072069748,-1.90543763341,0.291285591085,-1.36181203142,-0.129643239915,-0.0343436958515,-0.164125207224,-1.82089491054,1.25494796802,-1.83118260574,0.16123649788,0.65767793291,2.43558768379,2.28938907886,2.3589540312,2.35482014114,1.57271052038,1.74973443327,-0.00996217772202,-0.0365261191968,-0.241039234352,0.129318297107,-0.300570344546,-0.33100694559,0.16457421643,-0.284704964076,-0.281706051144,0.325494323138,-0.0302711002374,0.720760490721,0.241476450633,0.638603030305,0.796946144084,1.21614433815,0.677125435118,0.523624772415,0.470123806244,0.0597177449101,-0.262256413549,-0.0392297752892,-0.154014422443,0.126499695187],[-33681.0066773,263.886884369,-1468.07758277,-2137.58288104,325.627575479,1510.37831723,707.068383013,-924.236529771,-57.4763592978,-1158.21655783,-31.0528193755,379.895994214,-1134.10297615,-686.629920236,-15.3006947422,-17.2056582503,-114.161194852,294.484846092,49.8580756607,-497.217564867,-149.900030179,-230.80924111,-49.6994970122,-340.137679035,95.0872495623,90.6863459957,-124.460562562,120.930654417,-53.7483757642,89.8727795423,-162.060484957,-32.7100969383,-142.780647422,80.1937710187,-3.40298981484,0.581828460635,28.4080739539,27.7505270729,-35.5095861761,11.1854494017,-14.6288422069,-88.4831253961,-38.434836886,-83.9948937545,39.7263922177,-10.6253602837,-51.8566540008,-36.2583350893,-1.83324210099,4.91794036278,4.74371558633,0.461044195154,-7.67027055201,-9.5456932544,-13.2912085696,4.72613457066,-20.692553608,5.84932091883,8.17128786193,-11.5922433645,0.572269262751,10.4427150372,24.2928472932,-0.131920361693,2.0339662225,-4.37581113563,-1.18674577128,0.786369328697,-1.2431981909,-0.00762377828459,-0.868762482005,-1.39480595676,-0.694295811941,8.22262653377,0.919894114318,7.34506429811,4.63184748404,6.34656177862,2.13531259249,-2.18593616998,0.342111143251,-1.3113953065,-0.108909788617,-0.0312315512616,-0.221155534346,-1.80542159225,1.21822711162,-1.7982287418,0.126774091698,0.670338798142,2.45380569148,2.21455638039,2.3013831478,2.38092232126,1.61844649331,1.75713235784,-0.113052708623,-0.071027673368,-0.243621930355,0.13292544287,-0.297429654286,-0.343098523378,0.165474577622,-0.287309142208,-0.298756616307,0.317218111235,-0.0213148371189,0.726521153521,0.246344239439,0.656118662351,0.792568038954,1.20996732477,0.669679355798,0.524833609908,0.482319565694,0.0299406135843,-0.275725847739,-0.0490214206328,-0.145197532175,0.128009616996],[-33827.836691,285.780300309,-1421.12664455,-2101.63785516,414.550960448,1531.09789557,706.297790127,-969.579934018,-39.7666882854,-1155.38535965,-78.8562510456,391.72712667,-1155.08643042,-709.531417529,-16.1601895747,-13.6482608508,-124.900749076,293.67498313,54.4540168272,-503.34103635,-160.074472408,-225.817066695,-44.4547543602,-329.906871978,92.681558131,86.2360204562,-128.393509592,125.459613979,-49.6264983601,90.9867324804,-157.08071884,-22.1618272411,-140.933272732,81.6428206743,-14.0111507237,-0.104779574521,27.5610841242,28.0606718659,-35.2890878257,13.449922345,-11.5361781299,-86.8820084342,-34.5173248665,-84.8262171659,41.3722475501,-15.4834165894,-54.998370494,-36.559648928,-1.59441337043,5.02903904046,5.1470950992,0.760352399323,-7.36417254781,-8.38483526153,-13.0734988467,5.62022737211,-21.0542189086,6.32201532049,7.03904965506,-12.9735111589,-0.00246583156853,10.8897753725,24.4586429458,0.00590208180437,2.23039316398,-4.22568495964,-1.20879307069,0.653247858776,-0.962542432346,-0.154886146771,-0.685803223985,-1.49578458236,-0.574613539201,8.01099969313,0.575930466818,7.10871140786,4.80510841741,6.49349659981,2.11933815826,-2.46881758313,0.394039635265,-1.25646373366,-0.0889074374831,-0.0328908443366,-0.277378561681,-1.79346544766,1.18169017268,-1.76775140842,0.100295987857,0.68207989377,2.47569564524,2.13912878152,2.2435528401,2.40513568899,1.66085387583,1.75793367584,-0.22236537019,-0.105303241562,-0.245712253219,0.136618171557,-0.292960628156,-0.35448702178,0.165071543883,-0.289868893688,-0.316671142849,0.308455198035,-0.0132842342473,0.7328508395,0.250874290615,0.674807740951,0.787500015865,1.20306369189,0.661126296285,0.524907293475,0.492786914771,-0.0022743061019,-0.288271544765,-0.058355796205,-0.135803828647,0.129199924951],[-33977.574287,310.382603134,-1361.98051302,-2066.49054741,509.482062317,1550.62663442,701.423836007,-1013.01989405,-22.0205131119,-1149.71059569,-125.908450394,402.580905143,-1173.59210969,-730.630361845,-22.7349188994,-9.40280214964,-136.594613251,295.14454962,58.178351287,-508.70528364,-169.813094437,-223.10201348,-38.8849215031,-319.578454825,90.2569394469,81.2601781977,-131.853333951,130.19059276,-45.8420069608,92.4468522518,-152.150493494,-11.3647836531,-138.73112641,82.9124392456,-24.7799121435,-0.760934963274,26.6317612357,28.3133847545,-34.9840590185,15.5920517444,-8.31076352011,-85.0600061225,-30.5340605808,-85.4210020592,42.8198019104,-20.3324885963,-58.0363274676,-36.7463178457,-1.31363043007,5.12602333502,5.50240250607,1.05468648845,-7.03411850423,-7.22650243907,-12.7825842252,6.46925669622,-21.3406515465,6.74454709198,5.90213933612,-14.2886477085,-0.566040183642,11.3379540205,24.5745301296,0.151199658005,2.42595672058,-4.08436051328,-1.24370800118,0.52470182183,-0.693201621808,-0.294505040853,-0.516893595694,-1.56686703032,-0.459892414855,7.80820647709,0.243875872467,6.86980840583,4.975295614,6.62706300529,2.0934507901,-2.752009169,0.447288973825,-1.19725967731,-0.0695952153417,-0.0400058801504,-0.332580157199,-1.78578441889,1.14536170376,-1.74013826762,0.0813668145739,0.692882462423,2.50171943259,2.06360304234,2.18552999584,2.42544750222,1.69959575676,1.75191879127,-0.337199996802,-0.138814902105,-0.24746372239,0.140496331968,-0.286978642054,-0.364801704223,0.163342794687,-0.292318436324,-0.335338561662,0.299047815403,-0.00616076877803,0.73938314926,0.255142130597,0.694543985622,0.781618775516,1.1953639874,0.65090378472,0.523809986938,0.501296115063,-0.0367581636859,-0.299546448253,-0.0671995055283,-0.126000645656,0.130052767632],[-34127.7299445,339.634648161,-1286.04492118,-2031.49390735,610.729490743,1571.18371155,689.795539086,-1053.6014188,-4.4116069562,-1141.07652562,-171.090320477,411.992961148,-1188.7231985,-749.143965561,-34.9132221461,-4.63898920967,-149.072449435,299.333491358,61.0840621142,-513.117582603,-178.782484624,-222.785875528,-33.0756964982,-308.842807031,87.8089904983,75.8257245632,-134.785315842,135.183879376,-42.4063438705,94.2939123065,-147.338918004,-0.423119763943,-136.005850914,83.8817994375,-35.6295646208,-1.38581670673,25.6196777733,28.4836896738,-34.5897423761,17.5797052705,-4.97269652037,-83.0410635262,-26.5336828816,-85.7147445635,44.018425024,-25.1286959647,-60.9285483134,-36.8224863686,-0.989759982405,5.20094712593,5.79464871788,1.34064265099,-6.68950687167,-6.08732363632,-12.4197871986,7.25745074022,-21.5350419917,7.10397550146,4.7745835078,-15.5202306005,-1.11868542987,11.776141356,24.637640957,0.304005209221,2.61803344867,-3.95625398359,-1.29360085458,0.400195004405,-0.440040422141,-0.425616726951,-0.36541301798,-1.60536763663,-0.352115260545,7.61772534189,-0.0717951681618,6.6288726832,5.13727685618,6.74588397811,2.05842537274,-3.03306414698,0.501821400596,-1.13417498603,-0.0510034558797,-0.0531919197796,-0.386456512916,-1.78299795653,1.10932257786,-1.71574966361,0.0695740689817,0.702941354431,2.53231318391,1.98861431899,2.12751836517,2.44015315637,1.7343579708,1.73903845844,-0.456476977555,-0.17103534798,-0.248986427377,0.14460319169,-0.279345966173,-0.373694816552,0.160284309249,-0.294573488272,-0.354611209552,0.288879765416,8.76361422893e-05,0.745760057845,0.259238967434,0.715207761693,0.774830815199,1.18685085928,0.638564711226,0.521562612143,0.507666584311,-0.073208097869,-0.309229932911,-0.075506268951,-0.115953402687,0.130574994421],[-34277.5917881,378.247953966,-1195.76986753,-1997.16009474,718.721163966,1593.34158313,671.129148098,-1090.63855518,12.6644549751,-1129.53514154,-213.482199988,420.066505719,-1199.68613419,-764.109246605,-52.3621532984,0.463869156194,-162.241168532,306.627557563,63.3436606374,-516.424094314,-186.5300259,-224.911823248,-27.0444100335,-297.533014187,85.3580791603,69.9808974815,-137.109892664,140.484245017,-39.3326464358,96.5733802733,-142.720653906,10.5785150293,-132.647108849,84.4698237157,-46.4514578594,-1.9695021169,24.5228178042,28.5595874523,-34.1124119819,19.3791672372,-1.54773860169,-80.8590295707,-22.5564503521,-85.661483618,44.9427776599,-29.8229254444,-63.6286028108,-36.788600291,-0.621892597144,5.24684892088,6.01240726751,1.611000643,-6.34130479987,-4.98468551065,-11.9906884356,7.97354814766,-21.6244759724,7.39654099612,3.67317742592,-16.6487831794,-1.65586092538,12.1942060262,24.6461794363,0.463712795843,2.8043906986,-3.84547226607,-1.3608341365,0.279209131777,-0.207918379949,-0.547862830078,-0.233874553993,-1.60925438028,-0.250970009086,7.44333241628,-0.365687675041,6.38797800714,5.28622956979,6.84867929238,2.01522342061,-3.30904476655,0.557270778534,-1.06756520013,-0.0333811311347,-0.0729451822402,-0.438624923123,-1.7855512301,1.0736531895,-1.6948302709,0.0645634095695,0.712830138293,2.5679142266,1.91505853135,2.07015648763,2.44783984355,1.76489864606,1.71959346949,-0.578714491483,-0.201469896532,-0.250326877465,0.148915346229,-0.269934598831,-0.380928891738,0.155961106431,-0.296521529705,-0.374287093242,0.277894289652,0.0054729579467,0.751690382865,0.263247065186,0.736670547208,0.767110785266,1.17761722443,0.623772399776,0.518248220813,0.511824709264,-0.111154785141,-0.317052236025,-0.0831675754325,-0.10583259042,0.130798811265],[-34427.9858395,429.725178174,-1094.21901059,-1964.60339316,833.082254607,1617.4976167,646.513390182,-1122.28770805,28.6191200993,-1115.27907937,-252.297564166,427.133354176,-1205.25639445,-774.552729971,-74.3771679946,5.72548251134,-176.070737157,317.334037866,65.1506274811,-518.40689621,-192.579587289,-229.353637001,-20.8361960579,-285.552451863,82.9340732926,63.7673529812,-138.753745703,146.110710446,-36.619636965,99.3162422931,-138.33765085,21.5417197112,-128.570914509,84.6172100697,-57.1078044708,-2.49736239512,23.3391314469,28.5374321104,-33.5670656205,20.954783652,1.93344211928,-78.5449496194,-18.6447357608,-85.2235095846,45.5781876079,-34.3588499399,-66.09398594,-36.6422127003,-0.209461891693,5.2582162176,6.14719021028,1.8568582286,-6.00168698091,-3.93582360833,-11.502974327,8.60887603045,-21.5984514776,7.62183978555,2.6175622188,-17.6570935871,-2.16992067857,12.5824816751,24.5994577012,0.629267666289,2.98303868936,-3.75544009985,-1.44754328858,0.160899046572,-0.0011881658099,-0.661362326418,-0.123999550044,-1.57703060795,-0.155530046093,7.28909121307,-0.633071503399,6.15022071348,5.41717770826,6.93441708718,1.96469733531,-3.57675007241,0.613112809381,-0.997803277207,-0.0170915160612,-0.0995589923787,-0.488678113528,-1.79373302364,1.03833013156,-1.67740635609,0.0659844035456,0.723178737708,2.60892245935,1.8436495597,2.01437311258,2.4470977417,1.79102632558,1.69400567697,-0.702209638,-0.22972664459,-0.251515476499,0.153365927687,-0.258639170312,-0.386360777074,0.150476045093,-0.298048091919,-0.394119966247,0.266058353662,0.0100179913979,0.756933561835,0.26723193471,0.758770618608,0.75842270139,1.16784753435,0.606204393587,0.513996833607,0.513720501976,-0.150026921598,-0.322816072101,-0.0900589438574,-0.0958137598415,0.130762130632],[-34579.18473,492.183146605,-983.468486397,-1933.95074537,951.943016856,1644.18814966,615.998943456,-1146.43808105,43.0030196183,-1098.48427228,-286.980398877,433.16212683,-1204.13688097,-779.870519736,-100.358028823,10.9561823807,-190.433809784,331.629874421,66.6405042322,-518.842026409,-196.576491714,-235.964907179,-14.5975279405,-272.878543208,80.5426241936,57.2572794373,-139.666077143,152.081555757,-34.2479343993,102.522732505,-134.224447094,32.3340462386,-123.736658879,84.2669599858,-67.4605117127,-2.96372337122,22.0710341164,28.4166711208,-32.9605358007,22.2745887796,5.44319477066,-76.1252429803,-14.8457547059,-84.3759170742,45.909921755,-38.6861154577,-68.2888216789,-36.3893164127,0.246539518664,5.2290871045,6.19271525325,2.0723178005,-5.68205658017,-2.95392355849,-10.9631620092,9.15725237446,-21.4498159146,7.7786840485,1.62492935438,-18.5320500298,-2.65713929469,12.9317629465,24.4969296188,0.799749152335,3.15108540638,-3.68877770072,-1.55528350981,0.0443068602021,0.17724412592,-0.766034912197,-0.0362810496275,-1.50778306655,-0.0652298078841,7.1578869859,-0.87033165684,5.91727026246,5.52531918966,7.00184929876,1.90768821725,-3.83321950481,0.669009782288,-0.925519984771,-0.00249907219412,-0.133323316064,-0.536281674345,-1.80762466905,1.00330991724,-1.66309889041,0.0735166152385,0.734610020907,2.65551964169,1.77483065785,1.96081399014,2.43663965614,1.81236162799,1.66278830015,-0.825329586007,-0.255465311423,-0.25264489376,0.157936578477,-0.245387479121,-0.389896058042,0.143853574797,-0.299066337437,-0.413895712643,0.253320959319,0.0138088543688,0.761297287609,0.271300575573,0.78133408442,0.7487243827,1.15771564373,0.585588212454,0.508882917323,0.513326703283,-0.189286972506,-0.326345336335,-0.0961261198836,-0.0860497397995,0.1304918028],[-34729.8437067,559.90315634,-872.00455804,-1904.00681386,1072.82786289,1671.22977336,578.968711009,-1163.23892987,55.7893247111,-1079.2233837,-317.976428235,438.049731299,-1195.97395189,-779.973481169,-130.114381515,15.9917446748,-205.090838966,349.408539821,67.9428181577,-517.800172945,-198.364781217,-244.793809663,-8.55218138505,-259.618100744,78.1602602298,50.551025801,-139.839594044,158.43090059,-32.2569714293,106.17200607,-130.480904426,42.8241909048,-118.193109103,83.383938581,-77.4002132107,-3.37590960419,20.7264482011,28.2006854348,-32.2891043304,23.3027665086,8.9687137565,-73.6434947192,-11.1970865647,-83.1272068862,45.9328758223,-42.7713387999,-70.1874985882,-36.0462535813,0.742653195126,5.15283498309,6.14784481722,2.25537435467,-5.3934597091,-2.04318046358,-10.3814401665,9.61904118911,-21.1821706645,7.86995686989,0.704410974643,-19.2652599572,-3.12071954198,13.2339428475,24.3376227812,0.97447640379,3.30490629867,-3.64641651923,-1.68484420758,-0.0712832647695,0.327070729429,-0.86266023219,0.0314478271465,-1.40326821218,0.0217088413164,7.04959237755,-1.07469720133,5.68824992755,5.60678742159,7.04960646658,1.84530334306,-4.07592023486,0.724904911553,-0.851575289392,0.0101943097788,-0.174504744181,-0.581055066297,-1.82692647764,0.968456037401,-1.65084186142,0.0863801583896,0.748127271763,2.70710032632,1.70905788387,1.90943089915,2.41557124041,1.82826843603,1.62659411047,-0.946632363376,-0.278441352386,-0.253908746522,0.162684145004,-0.230155907918,-0.391498524457,0.13603190677,-0.299460572036,-0.433473540178,0.239625424551,0.0170512167569,0.76456006199,0.275699082199,0.804033748672,0.738110480311,1.1472380605,0.561819783805,0.502863571398,0.510706313704,-0.228463141536,-0.327477385321,-0.101420958277,-0.0766510736458,0.129999469898],[-34877.6674877,631.429180366,-767.687894973,-1873.66089737,1194.35233065,1695.79045549,536.469379024,-1173.42203955,66.9422214523,-1057.72196087,-346.334637023,442.219993906,-1180.84910628,-775.301486642,-163.280409215,20.6263754149,-219.881918166,370.294331066,69.1883411925,-515.481880528,-198.000068777,-255.819281805,-2.90521766984,-245.867750254,75.745925648,43.7112364264,-139.321135942,165.161603556,-30.7090266905,110.213012703,-127.187696736,52.9100977523,-112.011713687,81.9651417078,-86.8232138383,-3.7445003413,19.3094032188,27.8936537435,-31.5602475158,24.0088089766,12.5013160534,-71.1442884709,-7.72230765188,-81.4990301161,45.6588180674,-46.5845173807,-71.7789216495,-35.6327759762,1.27545356685,5.02386432571,6.01635908916,2.40327518103,-5.14647059946,-1.20257610769,-9.76966745843,9.99929220719,-20.8049481932,7.90401897925,-0.137770489276,-19.8554266122,-3.56611681629,13.4824659441,24.1216230194,1.15340830643,3.44178609633,-3.6275413263,-1.83649811571,-0.186500791795,0.449412604921,-0.953044524407,0.0825578610391,-1.26716384445,0.107855671005,6.96279196214,-1.24526187362,5.46143723897,5.6587866819,7.07708472758,1.7786344764,-4.30258821952,0.780951808039,-0.776630511242,0.021015397216,-0.223084172658,-0.622670664395,-1.85117125162,0.933461734941,-1.63950222893,0.103343732324,0.764714290275,2.7625745805,1.64650726019,1.85988388078,2.38337638878,1.83830756516,1.58611888721,-1.06468809656,-0.298542041812,-0.255575961864,0.167679659076,-0.212944294954,-0.391187649695,0.12699520966,-0.299109929788,-0.452796214896,0.224898573599,0.0199533258789,0.766449614448,0.280646608349,0.826432715805,0.726720589238,1.13636289148,0.534930310827,0.495926013646,0.505976648832,-0.267064003748,-0.326134528707,-0.106082870077,-0.0676977535374,0.129293826353],[-35020.5412455,707.10682251,-674.729364296,-1842.40248035,1315.51661645,1716.01118224,490.423021803,-1176.70003344,76.3003666237,-1034.51934375,-373.092631255,446.270646366,-1158.80402525,-766.851514565,-199.086904826,24.6332322229,-234.724292276,393.778114409,70.4613977854,-512.057153241,-195.74398643,-268.836925704,2.1648719077,-231.766493982,73.2597551687,36.7700876713,-138.188533123,172.245447895,-29.6473714247,114.549064392,-124.376934631,62.5009200296,-105.291458811,80.0262154455,-95.6179101861,-4.07819492175,17.822860605,27.4994016533,-30.7918326707,24.3749697465,16.0244286242,-68.6657819123,-4.43814701755,-79.5224101107,45.113103978,-50.0966524312,-73.066131891,-35.171918077,1.84195370288,4.83836038758,5.80455972347,2.51234026297,-4.95060732026,-0.428938098957,-9.13900073239,10.3049676663,-20.3299443841,7.89261009322,-0.896487491633,-20.3080365827,-3.99878177441,13.6732254596,23.8502663106,1.33693139348,3.56001167853,-3.63034863398,-2.01001461626,-0.301840302708,0.546186184527,-1.03935057188,0.120403452077,-1.10354389097,0.195788791865,6.89583350359,-1.38305767653,5.2350680581,5.67971873089,7.08410738248,1.70858734169,-4.51138879436,0.837340934826,-0.701152397135,0.0301303368199,-0.278750122236,-0.660912378611,-1.87976421339,0.898008895587,-1.62821939031,0.123178711322,0.785102140303,2.82069197859,1.5869635577,1.81174000266,2.33999867455,1.84221295251,1.54213709724,-1.17810566781,-0.315766211087,-0.257965946425,0.172966298791,-0.193781584686,-0.389020633707,0.116790794629,-0.297921166931,-0.471852990178,0.209083880994,0.0226779447149,0.766719789609,0.286260934138,0.848096449938,0.714673003513,1.12504056985,0.505086347035,0.488099170419,0.499289418421,-0.304592142191,-0.322361304728,-0.11029464825,-0.0592292977742,0.12839450216],[-35155.3296231,784.272225004,-597.170521543,-1809.1276012,1434.99913363,1730.58633026,442.724020821,-1173.05586796,84.02050739,-1010.22689081,-399.162941837,450.740305174,-1130.16842993,-755.868271025,-236.631149988,27.891731579,-249.462206679,419.333411303,71.7980130234,-507.720953881,-191.946694384,-283.594801848,6.51550490242,-217.54042719,70.6850243625,29.7855765093,-136.518206486,179.642596756,-29.0891736712,119.05635149,-122.072369939,71.5207607783,-98.1745555957,77.5965989792,-103.673450813,-4.38538138481,16.281089588,27.0275674153,-30.0038367149,24.4031173615,19.5142705944,-66.2475301974,-1.35422865836,-77.2427753295,44.3314653991,-53.2846533071,-74.0610941299,-34.6869688344,2.43694846269,4.59562831843,5.52137466527,2.58048186454,-4.81073898082,0.281392378325,-8.49989677562,10.5447176293,-19.7722580443,7.85049865902,-1.56901841389,-20.6322854366,-4.42297924551,13.8045953993,23.5256460327,1.52460820334,3.6584456148,-3.65242720966,-2.20418469639,-0.416794849738,0.619674593905,-1.12326736166,0.148209630933,-0.916862725716,0.288278450759,6.84645311029,-1.48997981731,5.00759304885,5.66920151644,7.07068999235,1.63587730797,-4.70092612136,0.894020331811,-0.625696492088,0.0376901330165,-0.34084581754,-0.695531228227,-1.91201728225,0.862145771415,-1.61645814978,0.144751028133,0.809877844747,2.8800190524,1.53015603782,1.76450834454,2.28591369742,1.83982348929,1.49549789128,-1.28559500153,-0.33022403111,-0.261391031861,0.178538743861,-0.172813211195,-0.385129375909,0.105516305758,-0.295846548028,-0.490635445478,0.192247443396,0.0253067292541,0.765211584156,0.292574402844,0.868600648295,0.702135508644,1.11319904148,0.472623625097,0.47944610471,0.490834780767,-0.340566908924,-0.316312487467,-0.114237044453,-0.0512503028278,0.127327653392],[-35278.8155184,855.494608935,-539.364145607,-1772.11386134,1550.66171682,1739.06861566,394.15743,-1162.73704568,90.5164842355,-985.428071508,-425.236874233,455.869590489,-1095.58206622,-743.647230728,-275.016787559,30.4049165053,-263.835127236,446.470534555,73.1465435658,-502.69977207,-186.995379583,-299.825150484,10.0382789129,-203.475637137,68.0382334457,22.8559016825,-134.382083186,187.300738544,-29.0128403385,123.59243315,-120.291008699,79.8961941054,-90.8388799848,74.7054650082,-110.901238318,-4.67288990944,14.7078862756,26.4954398321,-29.2154937957,24.1158684235,22.9405120385,-63.9311434755,1.52274319571,-74.717131662,43.354388822,-56.136545767,-74.7806678462,-34.1981993242,3.05283048596,4.29795957249,5.17816239637,2.60832180268,-4.72599981741,0.93116883965,-7.86213849945,10.7280370679,-19.1491453357,7.79362512572,-2.15649746346,-20.8397324538,-4.84094823971,13.8772334879,23.1503337142,1.71502728934,3.7365151585,-3.69089473617,-2.41672543174,-0.529944504172,0.672374373587,-1.20568792031,0.169041901379,-0.711732348705,0.387808521566,6.81166167931,-1.56840901697,4.77770405326,5.62806643915,7.03665979444,1.56106174825,-4.87045121849,0.950744627738,-0.55093297595,0.0437844021501,-0.408400078196,-0.726239756588,-1.9472306224,0.82626989834,-1.60394413886,0.167027625272,0.839458250569,2.93901366871,1.47590402591,1.71759992264,2.22201275719,1.83096907165,1.44709565891,-1.38607157629,-0.342109788372,-0.266054431424,0.184337805802,-0.150289783135,-0.379739143221,0.0932985347573,-0.292913584663,-0.509118257965,0.174576927361,0.027839546093,0.761874047959,0.299550713287,0.887558620276,0.689317618829,1.10072240695,0.438002119551,0.470039727044,0.480848721921,-0.374571024268,-0.308235209479,-0.118057763155,-0.043748239239,0.126118120864],[-35389.2760595,915.598829704,-502.243137014,-1730.30511072,1660.71566089,1742.14099005,344.926722508,-1146.3596897,95.9688400969,-960.693905735,-451.96052937,461.711832374,-1056.00486984,-731.39947011,-313.179189167,32.1977073223,-277.612681838,474.637292942,74.391568567,-497.230204386,-181.250071913,-317.154389735,12.6732947912,-189.825397819,65.3534166313,16.0684772916,-131.870213061,195.143440192,-29.3567894266,128.019981162,-119.024434102,87.565338298,-83.4592536324,71.3737143902,-117.251886009,-4.94360769826,13.1234674551,25.9233662013,-28.4487465069,23.5503428179,26.2740056612,-61.755705612,4.19355217808,-72.0035072622,42.2225363731,-58.6559833752,-75.2468293556,-33.7200902645,3.68255319652,3.94919866146,4.78857531195,2.59748103771,-4.69193856563,1.52322215572,-7.23561710568,10.8657350813,-18.4780591702,7.73655784009,-2.6648248683,-20.9446951337,-5.25192291401,13.8936149635,22.7270289522,1.90680881744,3.79441075123,-3.7420971433,-2.64473604493,-0.640006581258,0.706820981444,-1.28748995179,0.185847448118,-0.492989107728,0.496039248614,6.7877583322,-1.62141152548,4.54470884567,5.55827994343,6.98171562958,1.48470070719,-5.01999739467,1.00725058753,-0.477385065899,0.0485080601587,-0.480249208348,-0.752945690324,-1.9847744829,0.790776848759,-1.59052742526,0.188968132574,0.873953112245,2.99619405131,1.42400255881,1.67048961437,2.14951903687,1.81554187716,1.39786362168,-1.47879882581,-0.351707983026,-0.272015454269,0.190256481712,-0.126469535874,-0.373144316451,0.080284163221,-0.289218462059,-0.527282970095,0.156313594492,0.0302069991248,0.756704770016,0.30708089482,0.904673973535,0.67643566211,1.08747696079,0.401772060326,0.459956828572,0.469617303815,-0.406324107706,-0.29846548667,-0.121854226064,-0.0366892289482,0.124786126488],[-35487.3606318,960.114990395,-485.114478293,-1683.87389891,1763.54808436,1741.0270817,294.984756613,-1124.57426483,100.273509948,-936.614884072,-479.879484687,468.217179538,-1012.59548954,-719.952171069,-350.051120733,33.315002087,-290.600759256,503.260803061,75.3848430753,-491.54231611,-174.956117788,-335.178467058,14.3691109576,-176.817345265,62.6806426361,9.49540360812,-129.079412939,203.070955778,-30.0335307765,132.224649209,-118.253054392,94.4693157069,-76.2052867793,67.6211131046,-122.709041686,-5.19530602517,11.5428561381,25.3329845054,-27.7284915971,22.7550004758,29.4862698234,-59.7569136821,6.66330939771,-69.15976004,40.9768745165,-60.8577411223,-75.4835855243,-33.2614847229,4.31979467252,3.55388097981,4.36736060669,2.54997635972,-4.70165586725,2.05943700989,-6.62990552318,10.9689175466,-17.7755693294,7.69234942859,-3.10316519214,-20.9621010255,-5.65266655227,13.857542499,22.2579508652,2.09867453625,3.83290220433,-3.80195710407,-2.88488919489,-0.746061035047,0.725162751506,-1.36953044971,0.201375736756,-0.265387566844,0.613765460581,6.77065516348,-1.65216441748,4.30852191025,5.462594703,6.90534407589,1.40740704823,-5.1502045691,1.06325573917,-0.405415779755,0.051932306372,-0.555097111137,-0.775790387616,-2.02408055898,0.756006294057,-1.57617268426,0.209605978367,0.913087517267,3.05016800606,1.37428991591,1.62272247316,2.06982691317,1.79343034728,1.34874642389,-1.56332844271,-0.359352818618,-0.279151741832,0.196153045934,-0.101602975299,-0.365679259622,0.0666364619461,-0.284913556222,-0.545101788761,0.13772058834,0.0322852167343,0.749736524868,0.314974288534,0.919732537314,0.663685212249,1.07331245562,0.364508733774,0.449260201112,0.457467346918,-0.435642924919,-0.28738841714,-0.125642847299,-0.030015711013,0.123330921079],[-35574.8519699,985.115822444,-484.445215435,-1634.26269823,1858.04967673,1737.47959671,244.674246304,-1098.16202738,103.030904113,-913.664896284,-509.310855579,475.570540162,-966.518754939,-709.376094996,-384.606959084,33.781991793,-302.631764985,531.783739878,76.0177161185,-485.783877745,-168.161897601,-353.461631413,15.0582217833,-164.611808772,60.0723536799,3.17903835713,-126.107050563,210.96233892,-30.9268731981,136.138315154,-117.936768158,100.556321276,-69.2196942158,63.4685561693,-127.282233289,-5.42186867352,9.9719641006,24.7434994639,-27.0855912803,21.7881926383,32.5515143466,-57.9610351999,8.94010476248,-66.2340943514,39.6554386632,-62.7579483851,-75.5124531654,-32.8232917897,4.95978556739,3.11571847145,3.92938373552,2.46631488859,-4.74688405447,2.5395940898,-6.05294204201,11.0483090229,-17.0546762328,7.67160872322,-3.48084382691,-20.9058119313,-6.03831424912,13.7732213655,21.7441035198,2.28980402084,3.85307345733,-3.86629050637,-3.13389165472,-0.847914366716,0.728487114081,-1.45267079489,0.218318339583,-0.0332263408638,0.741113564824,6.75666012104,-1.66358015322,4.06975589554,5.34428630172,6.80684750347,1.32995232639,-5.26194692475,1.11854510637,-0.335165139397,0.0540812479528,-0.631593616612,-0.795285873852,-2.06472267858,0.722176190709,-1.56088831368,0.228072757478,0.956276697608,3.09982025753,1.32664177023,1.57404453941,1.98433081601,1.76451398021,1.30058998368,-1.63939787998,-0.36542514117,-0.287133140192,0.201889222158,-0.0758819609198,-0.357690268063,0.0525519512742,-0.280203608153,-0.562545099209,0.119036743321,0.0339007122228,0.74100582402,0.32297705924,0.932621292509,0.651216891725,1.05810883748,0.326752450806,0.43800376318,0.444752956558,-0.462408473369,-0.275380563175,-0.129358145747,-0.0236512095197,0.121721165299],[-35652.7614712,990.183613961,-493.963401713,-1582.96134563,1944.299712,1733.94571927,195.951191183,-1068.7456939,103.848932325,-892.090700004,-540.230924999,484.512201502,-919.071357953,-699.034640693,-415.727492824,33.5970111923,-313.547394408,559.670336481,76.2850378456,-479.967876295,-160.679661028,-371.438827712,14.7157192859,-153.176242134,57.5603884949,-2.87522715646,-123.042161697,218.667134436,-31.8604788582,139.753320143,-117.985798651,105.793415812,-62.556427618,58.9288904453,-131.000103598,-5.62234181469,8.40500491088,24.1716218753,-26.5625469824,20.7258831245,35.449931205,-56.3773479995,11.0365072606,-63.2479132189,38.2903554033,-64.3721445644,-75.3552484331,-32.4024983597,5.59777640102,2.63681583123,3.48909911374,2.34363611442,-4.8179272269,2.9619524686,-5.5094858118,11.1146301856,-16.3219038053,7.68105127492,-3.80520638444,-20.7908578723,-6.40347352789,13.6449933266,21.1859574883,2.48017918946,3.85610187333,-3.93113334383,-3.38858908562,-0.94638118,0.716546910794,-1.5376383613,0.239258422857,0.199457849149,0.877209675814,6.74313129487,-1.65912246459,3.82939626687,5.20683204454,6.68540103455,1.25352057678,-5.35626934279,1.17317988919,-0.266590955616,0.0548710259615,-0.70826782712,-0.812518732394,-2.1065188272,0.689265879482,-1.54473059182,0.243394238365,1.00262436628,3.14446477885,1.28077791679,1.52441427288,1.89436447618,1.7287141975,1.25435685399,-1.70687691983,-0.370293908905,-0.295469624551,0.207391211984,-0.0494246931757,-0.349534610909,0.0382966436856,-0.275393478993,-0.579608134999,0.100423566856,0.034844257257,0.730491860917,0.330793044414,0.943344223181,0.639109941497,1.0418394874,0.288982858501,0.426256242798,0.431910494853,-0.48656622658,-0.262797085478,-0.132872021605,-0.0175308889195,0.119925869046],[-35720.7797039,979.090439206,-500.176970254,-1531.57404199,2023.87598675,1734.31466627,151.385559256,-1037.66324498,102.267780066,-871.864440239,-572.258670496,496.00704271,-871.265513762,-688.072270429,-442.354549392,32.720515789,-323.22390428,586.372936708,76.2694187708,-473.934243725,-152.266308862,-388.486139085,13.3461626641,-142.367964479,55.1546307359,-8.69788521989,-119.992867244,226.030592998,-32.6205018851,143.094879778,-118.273431703,110.158805089,-56.2071741606,54.0205380429,-133.916595251,-5.80023028693,6.82668446688,23.6271964988,-26.2049065223,19.6498664006,38.1706566479,-54.9969302491,12.9640064002,-60.2038198228,36.9121059223,-65.7186337022,-75.0319620686,-31.9918431062,6.22917078632,2.1182357225,3.06101049742,2.17789793137,-4.90564334507,3.32646881351,-4.99991037486,11.17752952,-15.5781127708,7.72449364871,-4.08217643764,-20.6316345669,-6.74217915072,13.4770798388,20.5844349987,2.6703932598,3.8433403243,-3.99225271555,-3.6458439109,-1.04311152069,0.688983929335,-1.62463170565,0.266744173933,0.429508411884,1.02043805261,6.72847817291,-1.64223562627,3.58902594752,5.05356607014,6.54051840129,1.17957311071,-5.43416177343,1.22743582089,-0.199514662781,0.0542864536422,-0.783661429415,-0.828908401916,-2.14934370511,0.657076215623,-1.52766867617,0.254760623122,1.05095517955,3.18387014757,1.23637191399,1.47405746144,1.80111194763,1.68611791936,1.21099680835,-1.76572167423,-0.374319577473,-0.303594939598,0.212635342589,-0.0223057887184,-0.341555983778,0.0241453235224,-0.27081803391,-0.5963201967,0.0819401328386,0.0349276408964,0.718175464738,0.338074352864,0.952035078339,0.627378848491,1.02458062734,0.251595734288,0.414124887177,0.419393826089,-0.508121282218,-0.249970495317,-0.136025019523,-0.0116193915089,0.117908605404],[-35776.7940543,954.373746471,-490.835742779,-1481.23269181,2098.64049455,1741.98364775,111.705491996,-1006.8314218,97.9994653193,-852.572425285,-604.847170505,510.552497952,-824.164211553,-675.760594835,-463.840679439,31.1323201007,-331.452824548,611.39747992,76.0969558021,-467.514803978,-142.745379739,-404.124939255,10.9618632201,-132.104422945,52.8483068441,-14.3063128234,-117.067550272,232.938199033,-33.0067999822,146.191605589,-118.703839088,113.627707654,-50.1796254036,48.7512651704,-136.131072996,-5.96783762643,5.22068809126,23.1137970642,-26.0421979848,18.6348797435,40.7107649444,-53.8062277971,14.7263171095,-57.1094530623,35.5401535547,-66.8316136082,-74.5587324674,-31.5861689509,6.84788787052,1.55900852331,2.658716424,1.96761884037,-5.00164495354,3.63600229486,-4.52157511905,11.2443019136,-14.8231894791,7.80092847296,-4.32127599626,-20.4398913627,-7.05152201247,13.2735999744,19.9398227881,2.86102638823,3.81529925737,-4.04550965426,-3.90255730927,-1.13985139395,0.646290421086,-1.71299668615,0.303383812713,0.65455236384,1.16854284572,6.71055023312,-1.61571813968,3.34929076817,4.88772580618,6.37126473466,1.10975060996,-5.49661807073,1.28172701236,-0.133924838284,0.0524241032497,-0.856623413573,-0.845880002753,-2.19289008507,0.625391638407,-1.50935539503,0.261689465545,1.10006828118,3.2178775328,1.19314865163,1.4229707005,1.70569355902,1.63657067471,1.1713783398,-1.8161145046,-0.37776725831,-0.310990348322,0.217677108555,0.00541274027657,-0.33404661961,0.0102782699882,-0.266777212388,-0.612707574575,0.0635703194891,0.0340585884398,0.704086492907,0.344520914855,0.9588787914,0.615974427331,1.00637438572,0.214928002059,0.401609529034,0.407628598888,-0.527213847956,-0.237152007019,-0.138672230602,-0.00590864883122,0.115620620855],[-35817.296334,919.540195019,-463.497106692,-1432.94824851,2170.47180836,1757.63315063,76.3586334026,-979.899958932,90.921169281,-833.741020685,-637.713895842,528.259726349,-779.378013837,-661.555224132,-480.154897242,28.874875182,-338.051055707,634.261038637,75.9095810137,-460.754944558,-132.013409844,-418.169853748,7.63066491024,-122.371107309,50.6457361529,-19.7096944843,-114.370652311,239.291250961,-32.8974632595,149.062616708,-119.274854514,116.189677048,-44.5218775161,43.1283420693,-137.784121499,-6.13849565775,3.57710958276,22.6314021525,-26.094547797,17.7348074725,43.0697920574,-52.80749393,16.320662106,-53.9925300282,34.1858643665,-67.7609491041,-73.9490549349,-31.1863981285,7.44675281315,0.960235913639,2.29587600069,1.71311053695,-5.09906559632,3.89386054489,-4.07421407576,11.3189086472,-14.0622809926,7.90572999381,-4.53655511021,-20.2245455689,-7.33346474508,13.0380883116,19.2524756505,3.05208780082,3.77276090079,-4.08651830751,-4.15519884367,-1.23761863211,0.589336887843,-1.80195464982,0.351194705768,0.871115030846,1.31876346445,6.6855397888,-1.5814962528,3.10916227773,4.71239455198,6.17653751065,1.04587037099,-5.544447774,1.33632959639,-0.0698896369007,0.0495777438565,-0.926004963889,-0.864416788044,-2.23662977351,0.593986503498,-1.48928784398,0.263567016092,1.14877020118,3.24583827583,1.15095903103,1.370627184,1.60919647941,1.57963654711,1.13624832775,-1.85835780402,-0.380752039825,-0.317269856281,0.222573306137,0.0336148380722,-0.327236628118,-0.00313077229525,-0.263439259528,-0.628723780611,0.045294041525,0.0322205583825,0.688226937727,0.349889668426,0.963891629163,0.60478716993,0.987096231216,0.17926635796,0.388555857084,0.396967970705,-0.544073981017,-0.224485183148,-0.140712443426,-0.000432340402557,0.112996875002],[-35840.1297606,873.789629776,-420.981824333,-1387.47528783,2239.54197421,1780.63863322,42.317256649,-960.855063616,81.3321021991,-815.185140271,-670.298169333,548.546106252,-738.318867164,-645.228226864,-491.538391546,26.1581149418,-342.875230684,654.679449156,75.7642586353,-453.718599106,-120.163299107,-430.609342447,3.48907835532,-113.173021798,48.5791197256,-24.8772077458,-111.986733921,245.00069693,-32.2090704083,151.694000062,-120.031223632,117.865344373,-39.3028479083,37.1698254992,-139.045545416,-6.32496833685,1.90477670079,22.1749469486,-26.3723898077,16.9913359798,45.2427289565,-52.0032839953,17.7346235957,-50.890039023,32.8545674962,-68.5583100115,-73.2164955486,-30.797614965,8.0161447008,0.327856442285,1.98340797985,1.41806605386,-5.19177117225,4.10209581435,-3.65528097668,11.3998382221,-13.3013944529,8.03171140323,-4.74127314052,-19.992066155,-7.5943699899,12.7732123539,18.5239063347,3.24232099424,3.71711241312,-4.11145834621,-4.39929488761,-1.33682292198,0.519386371388,-1.88954479105,0.410940324964,1.07640411398,1.4679627714,6.65011594519,-1.54042599343,2.86705245459,4.53072335577,5.9559512137,0.990148214897,-5.57806598016,1.39123618495,-0.00765973546763,0.0461234299345,-0.99044257458,-0.885107034345,-2.27974256461,0.562788165506,-1.46701418416,0.26011619594,1.19585688537,3.26717212481,1.1098508829,1.31641914579,1.51271825551,1.51484712991,1.10618938348,-1.89270663895,-0.383251790488,-0.322252167237,0.227346830228,0.0620563991522,-0.321293059417,-0.0158766314233,-0.260894025117,-0.644187628991,0.0270520666172,0.0294701639518,0.670668326028,0.353980274966,0.967047597909,0.593656392523,0.96662627,0.144866263358,0.374759832193,0.387680876711,-0.55891980365,-0.211983297239,-0.14210712799,0.0047278832297,0.109954557316],[-35844.6665469,816.967958538,-372.843967401,-1346.34745157,2305.32826853,1808.83911524,5.29804535337,-953.88320378,69.5207148743,-797.129128522,-701.668104541,570.432671073,-702.130281961,-626.894682528,-498.163354772,23.2637878461,-345.932701848,672.604061988,75.7190798117,-446.422366193,-107.414247799,-441.49301941,-1.16661701015,-104.518112978,46.6951846337,-29.7789277995,-109.964913717,249.993375452,-30.8907099747,154.065546823,-121.040234708,118.732460025,-34.5927255622,30.9119832596,-140.106423704,-6.53439903048,0.222305694816,21.7353674113,-26.8824437826,16.4338275486,47.2236393772,-51.3923642095,18.9546573858,-47.843902257,31.5494319231,-69.2755967009,-72.3769397398,-30.4330302274,8.54633840952,-0.328644025906,1.7285124769,1.08571680277,-5.27500095456,4.26154099668,-3.25959652295,11.4815139293,-12.5461378169,8.17026271787,-4.94574172889,-19.7463338134,-7.84492222455,12.4810503996,17.7578999683,3.42995925689,3.65037718421,-4.11731136753,-4.63054334591,-1.4372229072,0.437266957516,-1.97265068231,0.482239363175,1.26864389414,1.61326365623,6.60233743123,-1.49207596916,2.62102805101,4.34590590872,5.71009625892,0.945338013002,-5.59728984389,1.44625521874,0.052522417133,0.0424341616078,-1.04855083562,-0.908090085521,-2.32141540198,0.53187255914,-1.44218687317,0.251514215518,1.24033713335,3.28155265112,1.07021842388,1.25984351921,1.41750811539,1.44181515281,1.08174286188,-1.91929298552,-0.385033136098,-0.326095547471,0.231983153608,0.0904413584529,-0.316312090338,-0.0277213051946,-0.259141326656,-0.658866885864,0.00874466729447,0.0258990966904,0.651552600334,0.356692997133,0.968314661541,0.582433597907,0.944927757809,0.112017361253,0.359987960737,0.379950116494,-0.571929960278,-0.199517302265,-0.142910749556,0.0094259094088,0.106414346275],[-35832.158468,752.011666134,-330.118866388,-1311.14183281,2366.94735014,1839.73489272,-37.6519474945,-961.209626309,55.7540797765,-780.307246818,-730.41556802,593.105226982,-671.180174523,-606.683017774,-500.14806864,20.4729089529,-347.438825829,688.292841898,75.8462213832,-438.69942441,-93.9797332649,-450.812606965,-5.92688126446,-96.4261840987,45.0313968194,-34.4194795587,-108.264200205,254.190575513,-28.8962254722,156.169027425,-122.334213998,118.928756291,-30.4487057654,24.3890713939,-141.121602056,-6.76881241182,-1.44830239268,21.3092310954,-27.6325617273,16.0842545043,49.0077264999,-50.955137276,19.9814210745,-44.8893883817,30.2701075031,-69.9481882715,-71.4411416225,-30.1102900262,9.02974909368,-0.996855381375,1.53294407802,0.716832426969,-5.34355170338,4.37194847241,-2.87743683372,11.5584003194,-11.7979354739,8.31258644048,-5.15416692149,-19.4874118475,-8.09829506773,12.1649070005,16.9589018657,3.61335290805,3.57513292942,-4.10296716218,-4.84581473154,-1.53748600129,0.342884299402,-2.04715750559,0.563766447867,1.44775039192,1.75310938907,6.54216156382,-1.43480496598,2.36893808464,4.16186724472,5.44030177919,0.913948993588,-5.60170952078,1.50107278976,0.110530278536,0.038638370151,-1.09918749571,-0.933079872586,-2.36108854322,0.501566419777,-1.41469699224,0.238539196756,1.28179356302,3.28918355962,1.03278269662,1.20064401717,1.3251704306,1.36048578211,1.06325369547,-1.93812951155,-0.385831068484,-0.329114073858,0.236464179151,0.118476994964,-0.312305013574,-0.0384062446327,-0.258107657583,-0.672585369591,-0.00969298028748,0.0215802080441,0.631127806641,0.358089985183,0.967772584457,0.571063460258,0.922126695208,0.08110800464,0.344069495215,0.37387358448,-0.583190494291,-0.186895102182,-0.143224233984,0.0135121710694,0.102348475553],[-35806.4588309,679.132960652,-290.42678973,-1280.20370639,2422.73642359,1871.55930612,-83.8809324654,-981.657618266,40.7923704303,-765.710505941,-755.795777188,616.38466823,-644.938180443,-584.388794581,-498.971170713,17.905294597,-347.707603027,702.066257538,75.9595621355,-430.306867064,-80.0455816417,-458.708662407,-10.6885243394,-89.0936228655,43.5708148604,-38.8252404733,-106.72606536,257.452647544,-26.2088973225,157.976659651,-123.856026748,118.564117284,-26.9557965027,17.5854519678,-142.102023282,-7.02313029152,-3.08299195672,20.918171865,-28.6205083911,15.954574165,50.5829903468,-50.6401137555,20.8356550226,-42.0557519131,29.001550853,-70.5764361157,-70.3865153372,-29.8366669098,9.46432677763,-1.66263518151,1.39250626367,0.317493038144,-5.39172426165,4.43215904948,-2.49837548693,11.6304896906,-11.0542118618,8.44949932607,-5.36906868971,-19.2072012326,-8.3663969213,11.8331931412,16.1237649771,3.79074720195,3.49434301898,-4.07098995354,-5.04288629651,-1.63525372424,0.236195032884,-2.1103953981,0.653091488763,1.61497155305,1.88727626473,6.46911168863,-1.36725575354,2.10822013255,3.98405087255,5.14652421051,0.895606456884,-5.59190365781,1.55496669957,0.166246547484,0.034544760334,-1.14194445658,-0.959460906721,-2.39830831396,0.472326069889,-1.38518389775,0.22226534715,1.32030309311,3.29057696393,0.997814343355,1.13844336488,1.23750526522,1.27119778383,1.05022829409,-1.94940084648,-0.385741198799,-0.331030972893,0.240750209065,0.145848684133,-0.309084069712,-0.047742129083,-0.257666117345,-0.685215657363,-0.0281560434545,0.0165406757375,0.609711486258,0.358322229377,0.965702873895,0.559524985317,0.898421857228,0.0525145993454,0.327039397492,0.369479265585,-0.592693928625,-0.174005756461,-0.142996296696,0.0170175948327,0.0978743935474],[-35772.6035277,601.946494374,-249.330293904,-1252.78410499,2471.87616253,1903.36107992,-129.912095362,-1011.86144609,25.0766762178,-754.317427655,-777.034832419,640.403930674,-621.996450055,-559.817792908,-495.781250336,15.5373779788,-347.131031179,714.34082945,75.8952178591,-420.881777403,-65.8197266387,-465.192456474,-15.3820646559,-82.726605001,42.2771319669,-43.058120012,-105.178505883,259.670228129,-22.8315160598,159.447148603,-125.491769169,117.746890126,-24.1820722172,10.4767222933,-143.018536943,-7.29223608068,-4.66455669048,20.5773472639,-29.8400373322,16.0429083864,51.9381531957,-50.3842114223,21.5359022254,-39.3591724491,27.7196093178,-71.1443697142,-69.1888164675,-29.6126223549,9.85018891506,-2.31463236834,1.29903317848,-0.106588458022,-5.41667707182,4.44132629263,-2.11092289492,11.6961775974,-10.3084226711,8.57024210516,-5.58792082085,-18.8971881479,-8.65897152833,11.4943173514,15.2489610634,3.96046187678,3.41039364443,-4.02524159235,-5.22077927377,-1.7283142069,0.11765769093,-2.16017814172,0.747436075522,1.77309116689,2.01569660309,6.38409863613,-1.28857250547,1.83711731324,3.81751373685,4.82910573253,0.889310236731,-5.5684384422,1.60727500174,0.219475317561,0.0299917618039,-1.17683449885,-0.986576711576,-2.43257480453,0.444629667717,-1.35429435023,0.204038284425,1.35612741389,3.28656644831,0.965318871297,1.07311138268,1.15606594514,1.17448963869,1.04184569637,-1.95328872581,-0.384968516048,-0.331584211664,0.24487601184,0.172275641678,-0.306396242649,-0.0556103803346,-0.2576590816,-0.696643154307,-0.0465735047155,0.010870837027,0.587654351214,0.357574440747,0.96243964674,0.547773707169,0.874068724999,0.0265164610103,0.308983653841,0.366676721849,-0.600378374297,-0.160765182785,-0.142172885012,0.0199819930749,0.0931487635603],[-35734.6750816,528.176151752,-200.375293583,-1229.40109732,2514.83518446,1935.44215536,-172.946119254,-1047.5260786,8.66411646298,-746.854880232,-793.318065615,665.345443968,-600.480116365,-532.94196029,-490.909142951,13.247256549,-346.077037367,725.539713287,75.5667480436,-409.980483025,-51.5412390514,-470.071545639,-19.9502743628,-77.4474905591,41.1026232856,-47.1908846301,-103.482101276,260.786659862,-18.7696018777,160.523469583,-127.089956781,116.563938216,-22.1410444182,3.0379884781,-143.833627817,-7.57686920947,-6.18213944327,20.2883048024,-31.280219575,16.3380851287,53.0635601569,-50.1215897719,22.088594801,-36.7955360221,26.3946719283,-71.6299721611,-67.8312825166,-29.4350512682,10.1877799772,-2.94596410153,1.2424036416,-0.550260979483,-5.41875268133,4.39921768345,-1.70305787257,11.750669592,-9.54933851608,8.66255067515,-5.80354520203,-18.5503872911,-8.9831771452,11.1544749243,14.3321743749,4.12090967577,3.32440669788,-3.96981854242,-5.37939003625,-1.81528133509,-0.0115225827228,-2.19478643224,0.844188209131,1.92619507444,2.13800256461,6.28960075024,-1.19852244044,1.55498743018,3.6658977608,4.48899468125,0.894211149377,-5.53162946004,1.6575060809,0.269817648091,0.0249551171934,-1.20412645082,-1.01398435905,-2.46324217892,0.418814771353,-1.32235410174,0.18528535501,1.38954406094,3.27830381307,0.935044145111,1.004848606,1.08194026208,1.07106373234,1.03726491682,-1.94989334325,-0.383692111112,-0.330693708952,0.248970424845,0.197519997321,-0.303983243888,-0.0619720821271,-0.257937824168,-0.70673813365,-0.0649771408307,0.00477530444934,0.565274118231,0.356030266257,0.958351047282,0.535702776494,0.849367508473,0.00324290814243,0.290009738914,0.36529164095,-0.606136320701,-0.147110604579,-0.14071637811,0.0224134960121,0.0883315556032],[-35693.553627,463.902222604,-141.706659516,-1210.73041103,2552.72417913,1967.13713613,-211.032166863,-1086.1723382,-8.32825740474,-743.583045923,-804.309623155,691.28250797,-579.191067963,-503.828531626,-484.514059596,10.9324299134,-344.750749041,735.984141439,74.9411395969,-397.369291369,-37.4378404616,-473.24660837,-24.4197353995,-73.3818790723,40.0057958296,-51.2628255587,-101.530317794,260.805180482,-14.0771865452,161.143892564,-128.555127328,115.056918945,-20.8380819524,-4.75198712594,-144.517278466,-7.88166085892,-7.62265006346,20.046576264,-32.9187641044,16.8209334241,53.9500606384,-49.8064155926,22.4865046907,-34.3628069424,24.9953305724,-72.0209757481,-66.3046113981,-29.3024645583,10.4766189201,-3.55312617784,1.21348112665,-1.00685628325,-5.39951402209,4.3065319807,-1.26715753051,11.7876008353,-8.76921048217,8.71377928996,-6.01109119118,-18.160516709,-9.34572585996,10.8177970842,13.3711808182,4.27013322294,3.23635066195,-3.90831543419,-5.51885330465,-1.89478598526,-0.149310371907,-2.21350602511,0.941358796809,2.07749745318,2.25370198977,6.1874512418,-1.09705369834,1.26115362289,3.53125085296,4.12694155516,0.909373277474,-5.48196630831,1.70514488583,0.316655293958,0.0196090421237,-1.22426397515,-1.04125210991,-2.48946888894,0.395170840438,-1.28931003432,0.167101874525,1.42089676314,3.26659253351,0.906660517168,0.933628460881,1.01575255393,0.96146724062,1.03566342416,-1.93944845464,-0.382013478734,-0.32844595378,0.253194041787,0.221355423485,-0.30159531609,-0.06686656475,-0.258327337218,-0.715337881017,-0.0833903721645,-0.00141875225168,0.542804840257,0.353902069337,0.953705008648,0.523221183859,0.824488688081,-0.0172844860579,0.270125995591,0.365102848807,-0.60990785982,-0.13301004358,-0.138597384879,0.0243092276004,0.0835666775766],[-35647.5678254,409.720699479,-75.0251191219,-1197.15271493,2586.10242507,1997.44069863,-243.64363817,-1125.99854322,-25.5985794014,-744.372866051,-809.813250748,718.023851844,-557.493226916,-472.490649813,-476.727182217,8.6029122379,-343.120639569,745.942324736,74.0435037518,-383.015680153,-23.6666393144,-474.729186025,-28.9273207871,-70.6699702444,38.9746563021,-55.2486602033,-99.2335929876,259.791697342,-8.84480226761,161.255971722,-129.8625757,113.204935895,-20.2869407096,-12.9229307024,-145.038775433,-8.2111162886,-8.96529231946,19.845162838,-34.7154182802,17.4680196904,54.5880716064,-49.4169684665,22.7075670006,-32.0667100347,23.4888236531,-72.3123072546,-64.605767159,-29.2148689676,10.714538088,-4.13431614457,1.20370277647,-1.46704199301,-5.36006941903,4.16483754871,-0.80063135425,11.7999665147,-7.96453702427,8.71079789229,-6.20769369553,-17.7218404129,-9.75175441247,10.4863060153,12.3637503213,4.40537551819,3.14512937615,-3.84377929266,-5.63928058944,-1.96499324457,-0.292928931616,-2.21624623081,1.03766290123,2.2290940542,2.36227680958,6.07887661821,-0.983914242039,0.955186531727,3.41418077244,3.74312160534,0.93357189446,-5.42046235617,1.74947700422,0.359113130898,0.0142900685949,-1.2378345979,-1.06780883298,-2.51022602626,0.374096860927,-1.25469753361,0.150296882245,1.45067526895,3.25185866888,0.879959034974,0.859235197694,0.957717932077,0.846063479006,1.03620897508,-1.92234094299,-0.379935343563,-0.325031714528,0.257690598153,0.243529451257,-0.298988567294,-0.0704099939702,-0.258618807713,-0.722232354245,-0.101733175619,-0.0072708573304,0.520421267533,0.351475312807,0.94866347218,0.510313128258,0.799485729082,-0.0351254921831,0.249234845502,0.36583918424,-0.611687514938,-0.118486378132,-0.135776911528,0.0256656247576,0.0789676819985],[-35593.8733331,363.75511845,-1.16658679977,-1188.7304688,2615.19367298,2026.46599958,-270.895389707,-1164.61183592,-42.9398922834,-748.775057697,-809.515874339,745.343427034,-534.857719905,-438.781950941,-467.48833357,6.33411613783,-340.996782852,755.663428613,73.0021988391,-366.954948717,-10.2387201966,-474.523021321,-33.653829916,-69.4356009793,38.0179929175,-59.0823149854,-96.5177253447,257.861841977,-3.16214713416,160.831884073,-131.026306546,110.941073863,-20.4896593742,-21.5092366278,-145.349914777,-8.56800850793,-10.1881847481,19.6767650224,-36.6197568768,18.2523491653,54.9712990505,-48.9486727322,22.7207949911,-29.9113322971,21.8463092117,-72.4977292867,-62.7329594477,-29.1699353199,10.8991021221,-4.68916950408,1.20464517527,-1.92150356422,-5.30069247516,3.97619608455,-0.30464292849,11.7813939383,-7.13321521512,8.64156596769,-6.38891964201,-17.2279207368,-10.2023734846,10.1602052175,11.3084216306,4.52345195753,3.04874547951,-3.77866279926,-5.74135341678,-2.02378991174,-0.439390640518,-2.20322304857,1.13245842161,2.38243351718,2.46367767498,5.96536668968,-0.858287603346,0.637641561263,3.31405275723,3.33743546277,0.965371108005,-5.34834553302,1.78967683602,0.396202201617,0.00939431823286,-1.24558354507,-1.0929225002,-2.52457574973,0.356128027992,-1.21768863586,0.135462049844,1.47958778659,3.23438256163,0.854945632702,0.781557348381,0.907724065288,0.725270728488,1.0381352537,-1.89888707659,-0.377370162192,-0.320688275248,0.262577239722,0.263810962541,-0.295945603823,-0.0727781076788,-0.258571741973,-0.727223223008,-0.119811688748,-0.0122972146699,0.498249523583,0.349078664155,0.943314773341,0.497061852354,0.774370518723,-0.0503983160301,0.227224016704,0.367198531785,-0.611435339139,-0.103624572869,-0.132179179203,0.0264678448657,0.0746411485019],[-35529.2908281,322.278421413,77.0412021452,-1185.17283124,2639.9323326,2054.48381492,-292.915402741,-1200.01723042,-60.2703205795,-756.060252324,-803.30295663,773.204159591,-511.09939535,-402.340296717,-456.818022554,4.24717284795,-338.089628337,765.356749828,72.0331210331,-349.384683143,2.98582020704,-472.732960205,-38.8376559765,-69.7781355894,37.1590601898,-62.6752517514,-93.3253441941,255.166387721,2.86433090812,159.871513259,-132.119520015,108.163418806,-21.4485604362,-30.5294271258,-145.393816223,-8.95329934197,-11.2719403786,19.5375784044,-38.5774966737,19.1409355873,55.1004553103,-48.4188546562,22.4898083289,-27.9053098783,20.0480783743,-72.5729507851,-60.6854729006,-29.1641357856,11.0286452367,-5.21846991889,1.20911219574,-2.36184609168,-5.220369827,3.74297147508,0.214490877524,11.7268448996,-6.27757630177,8.496718354,-6.55059575171,-16.6716381549,-10.6967006429,9.83788310868,10.2042537834,4.62104086603,2.94470793768,-3.71461826745,-5.82656260779,-2.06873625285,-0.585748523615,-2.17546682971,1.22577561853,2.53754422477,2.55846502017,5.84787954446,-0.718698876915,0.309365619263,3.22925654914,2.90964523162,1.00321458714,-5.26700923883,1.82489262945,0.42697104687,0.00534507373742,-1.24839591435,-1.11566131742,-2.53183254257,0.341867744517,-1.17717934245,0.122798735505,1.50854281113,3.21411297648,0.8318630658,0.700422072161,0.865385480607,0.599532464001,1.04076451559,-1.86933754976,-0.374143715648,-0.315671721777,0.267934589493,0.282020079022,-0.292301143226,-0.0741969494722,-0.25790429141,-0.73016001939,-0.137315784138,-0.0160197240099,0.476357144179,0.347063841306,0.937623319372,0.483669289178,0.749054081605,-0.063262635165,0.203943192819,0.368890761386,-0.609078635778,-0.0885411909749,-0.127698656456,0.0266980522032,0.0706701837401],[-35451.7049208,274.972223409,155.069954595,-1185.88982173,2658.99456812,2082.00062477,-310.656263307,-1230.77087578,-77.359891351,-765.423793364,-791.218051039,801.367356116,-486.336590968,-362.920238273,-444.936158111,2.55014654124,-334.029442019,775.196343274,71.3213771197,-330.645607053,16.1514032082,-469.614431916,-44.8093715499,-71.7952267054,36.4421887161,-65.9104259725,-89.6147181511,251.867091792,9.11109340094,158.361687173,-133.266189268,104.721230519,-23.1755261015,-39.9776074068,-145.120452095,-9.36594965377,-12.1940227589,19.425765428,-40.5310572972,20.099226478,54.9765127582,-47.8629672051,21.9660948945,-26.0679022595,18.0808637472,-72.5432531069,-58.4668033312,-29.1942769356,11.101424343,-5.72258065826,1.21148910191,-2.77884511769,-5.11655043621,3.46744371809,0.745824953923,11.6298057466,-5.40575445106,8.26809174566,-6.69113701942,-16.0466346173,-11.233443688,9.51666170795,9.05072505639,4.69448778632,2.83049356099,-3.65266639696,-5.89643750273,-2.0971282412,-0.728955766368,-2.13468458987,1.31763904102,2.69289848938,2.64694481212,5.72626322464,-0.563834617909,-0.0291193500751,3.15745729707,2.45937143704,1.04544523501,-5.17815605333,1.85422883361,0.450471275748,0.00256589889298,-1.24715272319,-1.13500295076,-2.531428341,0.33198823183,-1.13200491085,0.112185505042,1.53834282815,3.19062104002,0.81100468747,0.615454795748,0.830090919389,0.469229387697,1.04353938717,-1.83404250158,-0.370015513652,-0.310247342335,0.273810248442,0.297979017602,-0.287944808929,-0.0749234453388,-0.256330013821,-0.730910826128,-0.153838514773,-0.0179803485886,0.454792922863,0.345741901215,0.931452785843,0.470397599262,0.723320516512,-0.0739411814102,0.179169460554,0.370665552939,-0.60456486174,-0.0733821615688,-0.122214067949,0.0263389213143,0.0671104494003],[-35359.1537781,212.716444287,227.038995279,-1190.79345929,2671.65717771,2109.12248232,-325.115569272,-1257.01542368,-94.0740870589,-776.046089449,-773.489904354,829.739178853,-461.187975531,-320.362007336,-432.244876757,1.41291248909,-328.4889869,785.28352069,71.0996128222,-311.216053245,29.3914796501,-465.564267032,-51.8808038374,-75.6005808422,35.9115696936,-68.6909085464,-85.3624287221,248.129217193,15.4398307798,156.29446099,-134.632183415,100.470044969,-25.7051046801,-49.8135017304,-144.511534464,-9.80094201843,-12.9397766224,19.3409432758,-42.42639562,21.0959723106,54.605469637,-47.3331906577,21.1009370392,-24.4329459401,15.9435813391,-72.430266989,-56.0827555627,-29.25678116,11.1167308035,-6.20272740607,1.2085067058,-3.16517551214,-4.98644304951,3.15310094273,1.27415538142,11.4841384656,-4.53167828907,7.95144875711,-6.81438731191,-15.3473662,-11.8122070545,9.19339707552,7.84780016771,4.74065454666,2.70402750067,-3.59332151019,-5.95298190508,-2.10624803866,-0.866089138049,-2.08293963338,1.40810310656,2.84533139347,2.72973874531,5.59877248079,-0.392621827893,-0.37778305597,3.09643695056,1.98618582828,1.09076913773,-5.08398009664,1.87692928558,0.465914892079,0.00145059912947,-1.24279124522,-1.14995345291,-2.52300909481,0.327172551608,-1.08115141838,0.103213486925,1.56972451515,3.16310287475,0.79280464739,0.525995859199,0.801292948339,0.33464078832,1.04615507616,-1.79356923919,-0.364722829185,-0.304742312808,0.280235530755,0.311553217745,-0.282820593668,-0.0752116807453,-0.253594146649,-0.729427647288,-0.168928041348,-0.0177888191046,0.433605453688,0.345368617582,0.924609167199,0.457590936227,0.696825939549,-0.0826305673629,0.152606044546,0.372401818623,-0.597916021914,-0.0583181541611,-0.115649014306,0.0253702787913,0.0640006043078],[-35250.2586405,130.119045283,288.574579225,-1199.97456985,2677.86034333,2135.65477653,-336.617228762,-1280.57862875,-110.248803972,-787.288630253,-750.588523082,858.371597445,-436.807546538,-274.707569572,-419.371997084,1.00612175485,-321.272152841,795.586135442,71.5690235575,-291.688147749,42.7516011469,-461.072450812,-60.2976215219,-81.239133413,35.6110870885,-70.9509842583,-80.5761558474,244.075723472,21.7153112942,153.654387096,-136.398242877,95.2953587004,-29.0628452211,-59.948694143,-143.587644635,-10.2511073304,-13.4997518356,19.2850951688,-44.2210182742,22.109435382,53.9954914364,-46.8861301653,19.8493996882,-23.0417570472,13.6530245807,-72.2713930931,-53.545957672,-29.3462152862,11.0737950701,-6.65818950039,1.20045309583,-3.51515710005,-4.82631921008,2.80461824097,1.78269474241,11.2840303692,-3.67377245697,7.54658711343,-6.92880076649,-14.5715216812,-12.433072802,8.8650395407,6.59739411617,4.75679980543,2.56446512052,-3.5362742792,-5.99769586426,-2.09373304091,-0.994220804792,-2.02226016614,1.4967386415,2.99019720241,2.80720964813,5.46270860302,-0.204982407716,-0.736505812053,3.0443556541,1.49044182598,1.13830741639,-4.98739464983,1.89237220142,0.472694820563,0.00234105400865,-1.23598792951,-1.15974006789,-2.50635995698,0.328004049238,-1.02393587185,0.095275639392,1.60301771057,3.13061183699,0.777625588207,0.431323643221,0.77851000497,0.19624234539,1.04854661746,-1.74877441553,-0.358010435322,-0.299553430359,0.287224771414,0.322577718973,-0.276957184202,-0.0752618062602,-0.249525944853,-0.725717471611,-0.182143483222,-0.0151419469697,0.412874832448,0.346062754688,0.91690702361,0.445607340044,0.669205627719,-0.0895324732849,0.123968716518,0.374108256202,-0.589243990991,-0.0435687466716,-0.107990976929,0.0237647960314,0.0613672699089],[-35124.7866892,29.2951645051,338.203857722,-1213.2987289,2678.33118544,2161.04384688,-344.967456255,-1304.98191517,-125.660791391,-798.8292059,-723.432512811,887.283525845,-414.8808007,-226.425693945,-406.913864383,1.50243147727,-312.385974102,805.901838112,72.8160425279,-272.754984577,56.1064333631,-456.596569878,-70.2054921395,-88.6000381251,35.5745240776,-72.6581863964,-75.2985262392,239.765119228,27.8184159313,150.399793167,-138.725676181,89.131478062,-33.2330317301,-70.2534491802,-142.401807211,-10.7087081704,-13.8678275654,19.265050256,-45.885529574,23.1280863156,53.1563250472,-46.5731683678,18.1766165325,-21.9320761937,11.2423075933,-72.1151208376,-50.8788707948,-29.4537750685,10.972467532,-7.08464794236,1.19148526391,-3.82360204293,-4.63133959537,2.42808271197,2.25457909064,11.0244275641,-2.85271633181,7.05644916135,-7.04639373851,-13.7223303605,-13.0956865572,8.5277933661,5.30410641074,4.74088961203,2.4126086684,-3.48030659379,-6.03099939923,-2.05798630233,-1.11023403436,-1.95464711449,1.58226102455,3.12164932018,2.87905419712,5.31466679123,-0.00269178623181,-1.10455614075,2.99956105652,0.973973850933,1.18757405085,-4.89208304356,1.90012865001,0.470455044917,0.00548387007995,-1.22697789014,-1.16386983746,-2.48139338435,0.334794354862,-0.96011644342,0.0875409124509,1.63796889659,3.09215463526,0.765441875883,0.330860751542,0.761215207793,0.0550270884094,1.05079716836,-1.7007735213,-0.349667976841,-0.295175044515,0.294744646525,0.330852533487,-0.270483942168,-0.0751939261156,-0.244051987689,-0.71982303061,-0.193110175142,-0.00986236149124,0.392697482229,0.347763475788,0.908196515942,0.434739758135,0.640130899231,-0.0948841988975,0.0930779180538,0.375885818527,-0.578734922574,-0.0294269830961,-0.099312143099,0.02149227415,0.0592361702024],[-34982.9829368,-81.8434194623,379.4623235,-1230.55633048,2674.48781094,2185.82605278,-350.360422576,-1332.71607032,-140.193798602,-810.637578409,-693.042535062,916.195559187,-396.583451355,-176.437691873,-394.81801628,3.0976193102,-302.060895186,815.915710755,74.758611165,-255.002516638,69.1353828194,-452.274479077,-81.6693788826,-97.3333734631,35.8559829785,-73.818958465,-69.6227687445,235.186473832,33.6443155564,146.43149125,-141.667163168,81.9399381394,-38.0978139558,-80.577377727,-140.993394481,-11.1510616613,-14.0371165267,19.2825180154,-47.4046337835,24.1339833749,52.0866802323,-46.426674114,16.0484242242,-21.1126626017,8.74425654845,-71.9958400445,-48.1142307452,-29.5577115004,10.8164627031,-7.47042443426,1.18640966928,-4.08533729071,-4.40008892108,2.02665147102,2.6721183772,10.6967588843,-2.08453752225,6.48099772452,-7.17338655448,-12.8101144281,-13.7935823684,8.1763658535,3.97614926865,4.6913240393,2.25228551254,-3.423489701,-6.05184245678,-1.99892757865,-1.21161183917,-1.88339261027,1.66131483553,3.23379857699,2.94280566724,5.1526977817,0.209392300707,-1.47853384264,2.95983871486,0.440808039711,1.237883695,-4.801910641,1.89957731055,0.459478270224,0.0111398425588,-1.21522223995,-1.16206087067,-2.44805788089,0.34721532645,-0.890160292421,0.0789189489626,1.67346885113,3.04699172299,0.755308241566,0.224836027726,0.748454892203,-0.0871317061497,1.05274663056,-1.65069391148,-0.339592937056,-0.292103510669,0.302556800736,0.336175085662,-0.263551129719,-0.0749171631139,-0.237133295288,-0.71167573274,-0.201583558347,-0.00194055929531,0.373078748654,0.350175853147,0.898327083559,0.425045273236,0.609413365494,-0.0991104959102,0.0600007702389,0.377741258587,-0.566537629397,-0.0162905482778,-0.0897118020568,0.0185092670717,0.0576405142808],[-34827.0413696,-193.265057428,417.048901262,-1251.93246524,2668.29539578,2211.10784075,-353.495862903,-1364.66459693,-153.967052785,-822.598450408,-660.433154376,944.822689835,-382.450110766,-125.875625607,-382.666510063,5.90849498408,-290.582419025,825.285165232,77.3185189895,-238.92628237,81.4430531139,-448.065820327,-94.7116873543,-106.977758035,36.4928575958,-74.4706249522,-63.6659141396,230.33374141,39.0786586215,141.640763106,-145.207485343,73.7057141817,-43.4952863351,-90.7552029267,-139.372268045,-11.552682537,-14.011625865,19.3333663753,-48.7607075255,25.0969240935,50.7911163619,-46.4676256132,13.4370747666,-20.5762700968,6.18794915305,-71.9278953473,-45.2903963218,-29.6237154812,10.612120979,-7.80451155984,1.18955610015,-4.2958325476,-4.13433253888,1.60508380861,3.01677403516,10.2934248482,-1.3827470399,5.81863280202,-7.30951082251,-11.8492792873,-14.5150885756,7.80350112371,2.6235520217,4.6072898289,2.08782912656,-3.36362365718,-6.05955362177,-1.9172556421,-1.29572661922,-1.81277051382,1.73062655518,3.3209670228,2.99537993832,4.97613760634,0.424521127595,-1.85286867586,2.9222198067,-0.103809338388,1.28795797797,-4.72072896199,1.89022565569,0.440370420757,0.0195807204296,-1.20023212776,-1.15403882046,-2.40641491478,0.36454649059,-0.814652518451,0.0682653937954,1.70829505453,2.99446161075,0.745748008123,0.114124172327,0.738853955519,-0.227888025779,1.05380729087,-1.59967062111,-0.327748218929,-0.290873444334,0.31037426617,0.338425263918,-0.256296689721,-0.0743381527034,-0.228711224647,-0.701223499254,-0.207394459796,0.00854610274039,0.353967723151,0.352999226146,0.887087842021,0.416489341624,0.576954844837,-0.102779228047,0.0249556429796,0.379523849449,-0.552767739339,-0.00460783695407,-0.0793268107595,0.0147731759078,0.0565938669497],[-34660.8069035,-300.826653022,453.560380769,-1277.49840144,2660.52232508,2237.47055787,-356.294643136,-1400.781451,-166.904709409,-834.557042462,-626.685202264,972.689130252,-372.658340129,-76.0187932748,-370.177060579,10.0449258436,-278.158750823,833.625382404,80.4182502543,-224.990591768,92.5745732673,-443.961533034,-109.33673874,-117.097945085,37.5112262778,-74.6411054403,-57.553214708,225.217184868,43.9882511276,135.91890307,-149.322918865,64.4361473404,-49.2829401697,-100.594101663,-137.519562296,-11.8905577049,-13.7990072344,19.4084416602,-49.9268375208,25.9787635784,49.2822058525,-46.7130744458,10.3243034136,-20.3164488036,3.6075426481,-71.906749163,-42.4436624546,-29.608237671,10.3661194814,-8.07792782202,1.20558606616,-4.45047598452,-3.83765247814,1.1712175247,3.27057485165,9.81007064224,-0.761045311159,5.07000517979,-7.4492563913,-10.8542563688,-15.2453443963,7.40090370822,1.2570342354,4.48855786578,1.92323181855,-3.29821963155,-6.05380997763,-1.81376731813,-1.35963281659,-1.7469364817,1.78786630978,3.37770093493,3.03431385306,4.78505001194,0.63573743604,-2.22055194224,2.88360939493,-0.653997405861,1.33614654404,-4.6522116262,1.87174188972,0.413857296644,0.0311223331664,-1.18171783165,-1.13949141592,-2.35657939675,0.38597159509,-0.734089183427,0.0545944191951,1.74138304739,2.93380396492,0.735204693545,2.38797505414e-06,0.73088183769,-0.364637571213,1.05308893564,-1.54869924751,-0.314083475763,-0.292013752347,0.317920727835,0.337565677775,-0.248838781933,-0.0733993299241,-0.218699375929,-0.688474494071,-0.210409870029,0.0214613146463,0.335310086459,0.355967417274,0.87417860934,0.409036253298,0.54270019274,-0.106502367418,-0.0117317548087,0.380986762657,-0.53744284704,0.00518834439397,-0.0683114564609,0.0102686211986,0.05609884942],[-34488.5037243,-409.337716184,486.83291731,-1306.63845616,2650.48662776,2263.89754159,-361.674575005,-1441.63476775,-178.56353594,-846.189389152,-593.072866083,999.066842593,-367.421145521,-28.1838383002,-357.557722993,15.6089424882,-264.851816615,840.515940733,84.0112635689,-213.660887418,102.080437406,-440.140878686,-125.456768397,-127.419088778,38.9097225047,-74.3243051162,-51.4094270467,219.87883112,48.2323991009,129.17822353,-154.015602047,54.1950269643,-55.3828860379,-109.854473137,-135.394742469,-12.1482540403,-13.4094028459,19.4956528154,-50.8622291753,26.7409704462,47.5836885245,-47.1760115108,6.71029334129,-20.3402222425,1.05312385958,-71.9163618045,-39.5991440525,-29.461326941,10.0844511242,-8.28564590749,1.23915977438,-4.54379176682,-3.51448156652,0.736688951767,3.41852630849,9.24763417512,-0.234364421274,4.2420941009,-7.58415982672,-9.83422315777,-15.9676682865,6.96090841575,-0.112249958846,4.33559437841,1.76137706689,-3.22493143818,-6.03461209837,-1.68947523798,-1.40000275985,-1.68881128978,1.83187765983,3.39938523655,3.05865530429,4.57973565381,0.837507407733,-2.57366279676,2.84164291265,-1.20344087939,1.38073464875,-4.59949436036,1.84406361523,0.380625779495,0.0460053909265,-1.15970338057,-1.1182054519,-2.29870906726,0.410732247694,-0.648919673376,0.0374041613487,1.7718644418,2.86414825873,0.722389770602,-0.116042606049,0.723300770566,-0.494617297994,1.04965180667,-1.49846701706,-0.298441535382,-0.296051815159,0.324965918534,0.333650313778,-0.241278154603,-0.0721226952427,-0.207048459692,-0.673502860754,-0.210568765314,0.0365948059253,0.317129865992,0.358808223849,0.859262476088,0.402671406382,0.506616632048,-0.110803349364,-0.0496454404516,0.381887527461,-0.520424743398,0.0127462161447,-0.0568117189643,0.00501992398219,0.0561765253082],[-34314.832885,-524.06752538,512.197616572,-1339.43284555,2637.86125482,2288.20748298,-372.24264833,-1487.6363685,-188.805942243,-856.897269711,-561.11813568,1023.52602202,-366.743649987,16.4853917382,-345.334384616,22.5207857951,-250.691210639,845.47216522,88.2260148679,-205.399672155,109.626788189,-436.919250568,-142.878992077,-137.807747462,40.6387902571,-73.5339850323,-45.3680325653,214.411495534,51.6464150924,121.38760365,-159.315819291,43.1080288779,-61.7724003837,-118.270122448,-132.92795145,-12.313445584,-12.8713147557,19.5808802705,-51.5168727983,27.3359462327,45.7396654178,-47.8710571066,2.61567981274,-20.665208017,-1.41703089451,-71.9261368336,-36.769979545,-29.1250992047,9.77504975954,-8.42959883111,1.29559636321,-4.57296082496,-3.17141246544,0.317815733856,3.44660160912,8.61400033544,0.180782615192,3.34731887914,-7.70207781975,-8.79332857167,-16.663162586,6.47569165951,-1.47291701187,4.15036932333,1.60380801148,-3.14145290135,-6.00365873778,-1.54544620213,-1.41336991258,-1.64037711088,1.86330895498,3.38184065479,3.06936893569,4.3606539307,1.02571081498,-2.90343546265,2.79423704149,-1.74568932421,1.4197149132,-4.565189591,1.80759924155,0.34143426683,0.0644206596435,-1.13485134939,-1.08989984714,-2.23328825543,0.43815918854,-0.559406573516,0.0165077634345,1.79935652156,2.78444251509,0.706338762186,-0.232420894684,0.715030108539,-0.615088153343,1.04236794919,-1.44941903615,-0.28060859585,-0.303563386718,0.331358581129,0.326910157778,-0.233712071748,-0.0706497683488,-0.193711338652,-0.656552218635,-0.207858769707,0.0536624064897,0.299516543747,0.361332649993,0.841925373599,0.397451166858,0.468653268481,-0.116141639977,-0.0883326013039,0.381921238333,-0.501471339532,0.0177728172887,-0.0450048621736,-0.000924719465102,0.0568648551681],[-34142.2862691,-640.735076069,533.421422551,-1377.08176396,2625.27174278,2310.37477583,-389.8777524,-1536.22049118,-198.352735905,-865.42706167,-531.978382092,1046.34429572,-369.524875462,57.0380542506,-333.88415772,30.3227427403,-235.654587078,847.998622537,93.5286162592,-200.405396669,115.07918648,-434.477154308,-161.30041859,-148.129292925,42.5552634451,-72.3496030444,-39.5754782498,209.006704764,54.1075731902,112.623734489,-165.185969434,31.371910874,-68.4181073947,-125.567852551,-130.013168271,-12.3850892642,-12.2546266099,19.6442328265,-51.8259847836,27.7172118714,43.8320953786,-48.7892793209,-1.90728011816,-21.2939837992,-3.73775907225,-71.8845906783,-33.9599026994,-28.5336186073,9.44928348181,-8.52535928775,1.37949908569,-4.5405063901,-2.81751063301,-0.0601329811566,3.34805339246,7.92894720195,0.474912259497,2.40441399097,-7.78270239887,-7.73212580029,-17.3081552221,5.93677262258,-2.81239174011,3.9377450623,1.44966174782,-3.04567811791,-5.96643095094,-1.38324388696,-1.39586182252,-1.60197765551,1.88603398729,3.32360329037,3.0700142261,4.13059665072,1.1976428669,-3.19887236971,2.7393751536,-2.27370556441,1.450624986,-4.55187896863,1.76368204407,0.297210535561,0.0865599195336,-1.10916614618,-1.05437704277,-2.16146784391,0.46759589744,-0.465374024872,-0.00750946558378,1.8243883677,2.6942728714,0.686600199273,-0.346805313927,0.705111168037,-0.722988904462,1.02986644966,-1.40184379256,-0.260303086596,-0.315199035219,0.337113524361,0.317886455495,-0.226226099305,-0.06937918852,-0.178663488635,-0.63823407192,-0.202378603476,0.0723255779114,0.282682997768,0.363585525904,0.821912794601,0.393595841662,0.428979537366,-0.122907710262,-0.127151859001,0.380684199566,-0.480258711972,0.0199943843086,-0.0331265189066,-0.0074927648706,0.058207177696],[-33971.8015778,-753.124854905,565.10679464,-1420.54479603,2615.76418758,2332.48821515,-418.796283319,-1581.69129447,-208.155927605,-870.485305916,-506.741073594,1067.28982566,-373.745047139,91.9511929838,-323.303069015,38.4254255616,-219.629282949,847.468794242,100.397769936,-198.664538885,118.159520742,-432.843724454,-180.382225584,-158.267791646,44.4789049788,-70.852806662,-34.212898124,203.915257326,55.5080187422,102.969396434,-171.531969765,19.2011579428,-75.2882026713,-131.482166354,-126.525062904,-12.3663650473,-11.6386736115,19.6600369923,-51.7032988164,27.8299974091,41.956827094,-49.9076292384,-6.79498303566,-22.220268881,-5.8436766026,-71.7308292479,-31.1654654588,-27.6184737359,9.12063752436,-8.59301482008,1.49550019899,-4.44728698754,-2.4672246846,-0.364615145762,3.12109207504,7.21658841322,0.643443272147,1.43428989867,-7.8017384081,-6.64909404253,-17.8756211511,5.33471121716,-4.11645578246,3.70407698181,1.29702375031,-2.9351282391,-5.92948547753,-1.2052393847,-1.34230977825,-1.57339028032,1.90531616841,3.22519510373,3.06481931665,3.89375808473,1.3510790919,-3.44729071135,2.6748819742,-2.77978747367,1.47076444748,-4.56216273341,1.71393983979,0.248973814138,0.11273514529,-1.08524712951,-1.01144506309,-2.08445680648,0.498215887156,-0.366469299103,-0.033505257941,1.84775414784,2.59367305588,0.662768820531,-0.456251985938,0.692631851963,-0.814876495939,1.01069430122,-1.35588107722,-0.237133868893,-0.331745554531,0.342261412394,0.30725185568,-0.218873675629,-0.0688616563882,-0.161826855482,-0.619318368138,-0.19435185682,0.0922603384867,0.266899441815,0.365682553365,0.799112572518,0.391302804941,0.387947757113,-0.131481891878,-0.16528830265,0.377695818573,-0.456414231032,0.0191530130267,-0.0214931261376,-0.0145764838558,0.0602576006667],[-33803.9199988,-851.829046489,620.527703482,-1469.40941646,2612.84070333,2356.34936713,-460.297068509,-1617.5613481,-218.81409659,-871.040102319,-486.159922244,1086.96733911,-377.164183687,120.562361038,-312.750712988,46.2539650029,-202.520887893,843.430988753,109.370526714,-199.983952935,118.949365899,-431.65707552,-199.590467563,-167.872122097,46.2071449696,-69.1363955359,-29.4051768877,199.346495984,55.7956742099,92.5894749203,-178.159654902,6.88561867806,-82.2353380474,-135.770514563,-122.301628,-12.2690325706,-11.1046535502,19.6071806353,-51.086912065,27.6314588572,40.2069923637,-51.1920977764,-11.9608652716,-23.4002131357,-7.67615540004,-71.3850489911,-28.3740852217,-26.3155648939,8.80190309701,-8.65320778216,1.64465241182,-4.30047681614,-2.13619945398,-0.568938658434,2.76457862065,6.50402634519,0.68831252731,0.457241768351,-7.72861911939,-5.54034137866,-18.339408888,4.66263697395,-5.37109939957,3.45658949282,1.14400712002,-2.80910258051,-5.89971832303,-1.01461356138,-1.250281648,-1.55543646946,1.9262919841,3.08718279073,3.05803968061,3.65586260659,1.48436596358,-3.63604384399,2.60057534049,-3.25683426024,1.47842699225,-4.59842870402,1.66027319405,0.197920721771,0.142898411352,-1.06531517011,-0.961271963086,-2.00395921265,0.528798509498,-0.262713262347,-0.0607792128382,1.87042531239,2.48288465884,0.634489305269,-0.55767941955,0.677578141189,-0.887467307797,0.984117156286,-1.31142831913,-0.210452819798,-0.353972474402,0.346883908443,0.295763368478,-0.211673016698,-0.0694738587017,-0.143191593437,-0.600571256407,-0.184094777243,0.113060113209,0.252251044697,0.367815316816,0.773426071475,0.390743253324,0.346018520581,-0.141977479594,-0.201911108916,0.372768947023,-0.429490262955,0.0151328283899,-0.0104002025017,-0.0220317441965,0.063118481661],[-33641.74518,-937.904373382,700.096633939,-1520.46418084,2617.19307326,2380.89348445,-514.818108723,-1640.15414239,-229.677062002,-866.478412458,-470.92208828,1106.03992636,-378.569939344,142.865398785,-301.220471685,53.4938123002,-184.06802615,835.673541233,120.87473281,-204.280483118,117.780006523,-430.518751921,-218.24402813,-176.496216292,47.5503294098,-67.2064072837,-25.1894882307,195.465953555,54.955399654,81.6871461591,-184.871348904,-5.23389578839,-89.0693615664,-138.216907829,-117.166909153,-12.1180548379,-10.7127228814,19.478186801,-49.9293630919,27.1021135931,38.6612297128,-52.615980741,-17.3031944889,-24.7781109224,-9.18201702068,-70.7622623583,-25.5637117401,-24.5682969324,8.50021087672,-8.72458660113,1.82529792904,-4.10829684483,-1.83623125749,-0.653556294195,2.27727042449,5.81965753113,0.611602294721,-0.505885130095,-7.53190847261,-4.39890253874,-18.6756487021,3.91650287441,-6.56173535933,3.20178605173,0.988409678257,-2.66893264061,-5.8829172084,-0.814205954119,-1.11954505836,-1.54894322927,1.95362553665,2.90925866288,3.05404742539,3.42244352208,1.59708747787,-3.75340067021,2.51855684171,-3.69803882295,1.47281265964,-4.66250605755,1.60459066639,0.145021784334,0.176532834091,-1.05097782238,-0.904256107646,-1.92185705913,0.558162478282,-0.154521135497,-0.0891000330856,1.89354867709,2.36194514254,0.601698235962,-0.648245615578,0.660973594777,-0.937607429781,0.950121319848,-1.26785128896,-0.179388382859,-0.382460065201,0.351097961159,0.284119490618,-0.204646589683,-0.071411383656,-0.122866765131,-0.582638442597,-0.171907147474,0.134261415567,0.238722541777,0.370234017117,0.744701628578,0.392103645623,0.303644201072,-0.154176450261,-0.236180333592,0.366029104752,-0.398849510893,0.00793879847893,-1.96794605075e-05,-0.0296925675265,0.0669678451843],[-33490.7632917,-1025.01195442,800.678464622,-1569.76870951,2626.04456971,2403.93471644,-585.53110452,-1647.13789553,-239.41278736,-856.828667419,-461.885805535,1124.06371939,-377.375763556,158.595546518,-288.134582402,60.1183095593,-163.914044755,823.987080294,135.036571796,-211.61057143,114.852607215,-429.231158335,-235.627500286,-183.831737212,48.3970984879,-64.9761117371,-21.590219597,192.413367347,52.955656004,70.4101605988,-191.520799012,-16.8138882561,-95.6672876816,-138.607230307,-110.970350975,-11.9268663291,-10.4872617583,19.2733714005,-48.1766914901,26.2285546915,37.3762644359,-54.1664005488,-22.7194222643,-26.3174775491,-10.3046644245,-69.7910057878,-22.7036786216,-22.325593103,8.2200727996,-8.81713579632,2.03745196875,-3.87217493253,-1.57711116884,-0.601528764775,1.65862852626,5.18992006171,0.410506232397,-1.43167458633,-7.18490507733,-3.21510764842,-18.8621093572,3.09347856585,-7.67253473449,2.94435360217,0.829296022909,-2.51557564054,-5.88226201685,-0.605798939312,-0.949780420402,-1.55405708631,1.99127141986,2.69072733322,3.05738663517,3.19767254315,1.69027077532,-3.78844410203,2.43199482566,-4.09642506081,1.4531225845,-4.75601446944,1.54810178773,0.0910863165144,0.213108563067,-1.0431854957,-0.840513947497,-1.83959339351,0.585484948367,-0.0425786568502,-0.11815763835,1.9182244479,2.23063678495,0.564637267251,-0.725308594209,0.644293057181,-0.962170383476,0.908812667633,-1.22428257887,-0.143014810762,-0.417731616033,0.354852894567,0.272821627402,-0.197845128907,-0.0747761029227,-0.10092759542,-0.565981128652,-0.157994709506,0.15540259911,0.226364395512,0.373129673847,0.712781252225,0.395564620122,0.261245639465,-0.167702250903,-0.267216566531,0.357670549827,-0.363795366708,-0.00237724111679,0.00946545668621,-0.0373638780724,0.0719952165825],[-33354.9422407,-1127.62634912,906.331037619,-1612.90955765,2635.97931081,2421.1219386,-671.654325929,-1639.70577009,-246.18939117,-842.837634629,-459.559677713,1141.25722504,-374.047773942,168.541243881,-273.089263882,66.409200454,-141.871883338,808.491945176,151.786601599,-222.098952715,110.722501012,-427.652628258,-250.918066233,-189.555659131,48.7401936415,-62.3304593453,-18.5341078126,190.190303412,49.8191456356,58.90626509,-197.959223784,-27.4928332983,-101.889478285,-136.752278145,-103.606572795,-11.6889536995,-10.4140536393,19.0068196419,-45.8187408396,25.0288993285,36.3651412359,-55.8309683042,-28.1090219112,-27.9749216444,-11.001464871,-68.42087547,-19.7621687952,-19.5606261534,7.96297715437,-8.92541517843,2.27835638061,-3.59481000859,-1.36159557277,-0.4123642366,0.909591842181,4.63336859921,0.0818589540294,-2.30219157422,-6.66621762388,-1.98141529693,-18.8883427195,2.19313569536,-8.6917756563,2.68613432556,0.66903599636,-2.35151713038,-5.89701027189,-0.390472228422,-0.744314228413,-1.57097187984,2.04000170165,2.43047138674,3.07027713317,2.98473034948,1.76437152388,-3.73479817958,2.34537564409,-4.44810114085,1.41893473989,-4.88111750765,1.49098704559,0.0369067796811,0.251653992694,-1.04109146449,-0.77033551893,-1.75830037555,0.610062313238,0.0716324383136,-0.147947762742,1.94491604711,2.08870316431,0.523119392741,-0.787197158795,0.629439853563,-0.959397293683,0.860682502713,-1.18026708925,-0.100330936001,-0.460373468694,0.357899466037,0.262029707379,-0.191330344185,-0.0792721594411,-0.0775464503317,-0.550602494554,-0.142488078711,0.176006070545,0.215132399471,0.376576360687,0.677545421215,0.401105860925,0.219160922391,-0.182074642203,-0.294466151618,0.348069256251,-0.323856385604,-0.0156725857192,0.0177645225666,-0.0448368678177,0.0783507715982],[-33234.7079091,-1247.69409937,998.480011985,-1647.9170107,2645.55477307,2428.21480577,-767.738863541,-1621.64634088,-248.833783504,-826.03396626,-463.973292109,1158.60713253,-369.62121498,174.548079666,-256.112795953,72.7408970349,-118.204602749,789.565110032,170.836081106,-235.808029154,106.252363788,-425.757247424,-263.183392776,-193.446201781,48.6747372696,-59.2083638933,-15.893398021,188.627339217,45.6426534527,47.2884211716,-204.031292907,-36.8864268087,-107.634554286,-132.461801028,-95.0608647136,-11.3656548934,-10.4536086037,18.6953979888,-42.8990731056,23.5503831441,35.5886550595,-57.5846697265,-33.3760707816,-29.7108902275,-11.2331998098,-66.638838331,-16.7023251535,-16.2723733764,7.73115440544,-9.02829385153,2.54211940047,-3.28124102353,-1.18680063461,-0.104314194021,0.0373878884433,4.15673329341,-0.377121036085,-3.1028268573,-5.96478670898,-0.690777972069,-18.7583577699,1.21715694634,-9.61293894177,2.42648740332,0.513898930264,-2.18019126276,-5.92238556359,-0.169607127639,-0.510206337657,-1.59886681469,2.09602686292,2.12836745324,3.09241740347,2.78480780303,1.82001158232,-3.59163197212,2.26457743463,-4.75253786821,1.37028805637,-5.04071052247,1.43236270781,-0.0166618590403,0.290930698657,-1.0420720029,-0.694419618983,-1.67858439651,0.631301602773,0.185606179007,-0.178220377403,1.97297248934,1.93597568625,0.476592811472,-0.833434767732,0.61867475712,-0.929168570673,0.806477633484,-1.13602209422,-0.0503742208396,-0.511079211418,0.359785454643,0.251547331418,-0.18515134596,-0.0842461681651,-0.0530236328964,-0.535980218847,-0.125534084157,0.195546568837,0.205007627878,0.380320916468,0.63900505812,0.408425131885,0.177577624118,-0.196741711184,-0.317797133903,0.337771731209,-0.278908891387,-0.0316965931953,0.0244025618774,-0.0518790789748,0.0861064743393],[-33127.0960757,-1375.79039121,1070.49506417,-1675.55280234,2656.28273189,2424.20957809,-867.271226106,-1595.64886587,-247.353685769,-807.894445545,-474.724206596,1177.19321336,-364.522863598,178.523448636,-237.261342795,79.2747901604,-93.4288902649,767.591223115,191.812126832,-252.563427412,102.289105274,-423.450523233,-271.572379642,-195.347264429,48.2982372522,-55.6292707743,-13.5848946532,187.512666492,40.5835126535,35.6242237353,-209.52036642,-44.6568709969,-112.814158769,-125.56139707,-85.3870674108,-10.9053958336,-10.5808958503,18.3427161183,-39.4813848603,21.8482443145,34.9850461469,-59.3801151029,-38.4386931283,-31.4796899575,-10.9699112393,-64.4566509333,-13.4908779674,-12.4707436242,7.53025545359,-9.10484180703,2.82101517663,-2.93895191844,-1.05116695183,0.298948275521,-0.944047533787,3.75922472127,-0.965624807951,-3.82199347539,-5.07558156373,0.659799648407,-18.4818006769,0.166627126082,-10.4301864496,2.16524547126,0.37097719273,-2.00460234218,-5.95325553889,0.0537336143061,-0.255361814746,-1.63649131908,2.15390759722,1.78628247882,3.12169444417,2.59834952174,1.85717770705,-3.3605272743,2.19496364386,-5.01010980143,1.30688703487,-5.23775147679,1.37135425163,-0.0685310979477,0.329894818145,-1.04334244851,-0.613918095998,-1.60082454055,0.648394996445,0.296576669095,-0.208359000006,2.00102584742,1.77260465654,0.424211311049,-0.863994277444,0.613965057142,-0.87215594314,0.74677051588,-1.09208300403,0.00758836096493,-0.570507649977,0.360043820259,0.241188419211,-0.179308502338,-0.0890216237694,-0.027723480876,-0.521461765278,-0.10741051313,0.213500198048,0.195990621956,0.383896055907,0.597301353521,0.417027370592,0.136633083203,-0.211218043572,-0.337253944196,0.327309863317,-0.229044247815,-0.0501976611012,0.028794645743,-0.0582473272458,0.09527044267],[-33029.9204025,-1506.91186157,1125.91057725,-1697.14917116,2668.87824982,2410.74972435,-965.869331924,-1563.35534753,-241.901689545,-789.761791702,-491.094017725,1197.15490247,-358.591233906,181.713847214,-216.551089134,86.1447578172,-68.0459894721,742.933881492,214.15047729,-272.012438074,99.4042402847,-420.522397573,-275.485343942,-195.137408252,47.7097424325,-51.5980033038,-11.5744452188,186.630681199,34.8436329558,23.8919206059,-214.144837206,-50.5860360645,-117.332319714,-115.919532024,-74.6934527869,-10.2582079556,-10.7718577834,17.9392811741,-35.6254578856,19.9807496759,34.4748222989,-61.1488542278,-43.2484943632,-33.2222926902,-10.2053458242,-61.9046464145,-10.1055974988,-8.1724161219,7.36526511947,-9.13629967069,3.10587596906,-2.57222625093,-0.954963651473,0.773708072059,-2.0158334518,3.431905628,-1.67812602256,-4.45507173625,-3.9973162772,2.065093837,-18.0706570377,-0.959468300044,-11.136839984,1.90244128346,0.246692113103,-1.82744295233,-5.98369020316,0.274901399053,0.0133110405231,-1.68252552438,2.20756152748,1.40817923476,3.15345729178,2.42562119709,1.87395293811,-3.04425353597,2.14004292722,-5.2213689801,1.22776595603,-5.47473276087,1.3072875515,-0.117720244452,0.367721675998,-1.04226335979,-0.530391955108,-1.52499258345,0.660251245038,0.401939370741,-0.237464781487,2.02702780547,1.59917900791,0.364615387492,-0.878993967047,0.616540002622,-0.789620203643,0.68183652112,-1.04908661938,0.0739811271356,-0.639124208836,0.358267112792,0.230789434533,-0.173749357007,-0.0930093734571,-0.00208037467847,-0.506327164536,-0.0885191903045,0.229424161615,0.188071710982,0.3866958651,0.552699156159,0.42622939948,0.0964949855577,-0.225183289088,-0.352940836484,0.317132575065,-0.17449674073,-0.0709614913227,0.0303323496775,-0.0637085478512,0.105799035143],[-32943.3270903,-1640.43304076,1171.37282654,-1713.7005026,2682.95229952,2390.17983929,-1061.423275,-1526.23741408,-232.406404468,-772.782621181,-512.226939925,1217.77765056,-351.469559235,184.585459706,-194.139606929,93.5077654703,-42.4821304168,715.957719522,237.166986316,-293.766236052,97.8367555537,-416.73467762,-274.596899075,-192.803873105,47.0019685119,-47.0884788037,-9.85888554594,185.78067524,28.6347194017,11.9894485691,-217.598567936,-54.568719648,-121.120377354,-103.434592984,-63.143107361,-9.38204396318,-11.0022352327,17.4651120844,-31.3809362675,18.0042270204,33.9696174695,-62.8124108081,-47.7861813856,-34.8755311026,-8.94859571241,-59.0309727988,-6.53493225192,-3.40098604516,7.23952058242,-9.10689643734,3.38576988719,-2.1819616434,-0.900063294742,1.29950422864,-3.15623886889,3.16056767558,-2.50539237686,-5.00012803585,-2.73322432359,3.51227855941,-17.5390825782,-2.16438207299,-11.7251793172,1.63863427678,0.146352103635,-1.65137668449,-6.00715558627,0.488228716189,0.290646297422,-1.73553769582,2.25128443347,1.00011844826,3.18171632554,2.2663659038,1.86708465918,-2.64660863535,2.10134530322,-5.38694704226,1.13158371113,-5.75351269494,1.23983027466,-0.16341065811,0.403795713096,-1.03648620437,-0.445592105121,-1.45067172685,0.66559010774,0.499435737892,-0.264312145328,2.04853253338,1.41670372541,0.296286477143,-0.878672595562,0.626946107566,-0.683484866424,0.611792720253,-1.00772612182,0.14888237035,-0.717101429562,0.35413782685,0.220227581816,-0.1683499826,-0.095746974089,0.0234315849738,-0.489878556052,-0.0693359891413,0.242971282208,0.181244290498,0.388051331222,0.505583640577,0.435269703201,0.0573723941211,-0.238437468035,-0.365003380701,0.307648141138,-0.115632533105,-0.0938005751624,0.0284256595391,-0.0680404073639,0.117589429762],[-32869.548906,-1775.74053872,1211.9635581,-1725.95353988,2697.96934619,2364.35604715,-1152.77093402,-1486.39887021,-218.659816548,-757.850503627,-537.235350925,1238.1317572,-342.998944949,187.203654016,-170.455478391,101.514674144,-17.0747555475,687.035616315,260.200182521,-317.481657874,97.6311276317,-411.901064042,-268.791554285,-188.422425719,46.2532258184,-42.0682281315,-8.44369800013,184.7852359,22.159268642,-0.220715894953,-219.582772533,-56.5726258733,-124.137695347,-88.0305907189,-50.9462390067,-8.24515860068,-11.2536888806,16.8933311321,-26.790961387,15.9733987756,33.3791349463,-64.2920023143,-52.0468843744,-36.3743334188,-7.21977841333,-55.8955647946,-2.776035067,1.81109139826,7.15503886344,-9.00513117622,3.64815206185,-1.76885185788,-0.889241035195,1.859025038,-4.34172909632,2.9285955809,-3.43569065033,-5.45427053886,-1.29008553834,4.98267351052,-16.9038201053,-3.45280165128,-12.1860955958,1.37535810836,0.0738894734034,-1.47912783193,-6.0173631101,0.687549628637,0.572581507695,-1.79406816646,2.28029282937,0.569505230697,3.20035091005,2.11971248223,1.83290784891,-2.17279709516,2.07887292263,-5.50725201777,1.01669003159,-6.07497017424,1.16904929406,-0.204848423376,0.437631056647,-1.0240616535,-0.361377589485,-1.37721708691,0.663039708033,0.587117142625,-0.287512598704,2.06303245943,1.22652496659,0.217961241215,-0.863434724924,0.645303878284,-0.556331538767,0.536628732487,-0.968642405489,0.232020816862,-0.8042657613,0.347454751823,0.20946100217,-0.162923408267,-0.0969009423628,0.0483182112611,-0.471508245094,-0.0503683546256,0.253865449806,0.175482063502,0.387313229694,0.456413670439,0.443405587516,0.0194976079667,-0.250805883012,-0.37362120827,0.299219830638,-0.0529226196126,-0.11852378675,0.0225104838671,-0.0710214563222,0.130478019399],[-32809.5187686,-1908.04443987,1249.20098025,-1734.33760164,2714.85945865,2334.88804685,-1238.58586797,-1446.13773447,-200.478901084,-745.291797668,-565.079401172,1257.51897674,-333.18575702,189.604533613,-146.21128901,110.258591448,7.98027224469,656.544597158,282.737425358,-342.843709686,98.8536964235,-405.894387755,-258.055124818,-182.090445319,45.5270119279,-36.5119111672,-7.3320360144,183.519113487,15.6174582262,-12.8616218527,-219.804887927,-56.6055214991,-126.334724523,-69.6768138934,-38.3378119203,-6.82681207641,-11.5172968831,16.1919234137,-21.8904388845,13.9435982062,32.6149960685,-65.508071244,-56.0256361976,-37.641881849,-5.05455695685,-52.562384885,1.1650695423,7.41810371744,7.11224988223,-8.82437472129,3.87906015659,-1.33484524082,-0.925393086978,2.43780299338,-5.54584195829,2.71966584802,-4.45385057611,-5.81374144384,0.324914630809,6.45255161515,-16.1831838268,-4.82877415573,-12.5071546061,1.11499548644,0.0317260395942,-1.31343645865,-6.00868369052,0.866532599695,0.855642734006,-1.85649977463,2.29084749773,0.124883686928,3.20348569946,1.98511205057,1.7679063938,-1.62958354059,2.0715034648,-5.58178432964,0.880643776551,-6.43868311883,1.09532315107,-0.241329620475,0.468824265719,-1.00349620886,-0.279723708714,-1.30382754446,0.65121625938,0.663271963164,-0.305630732786,2.06818329888,1.03042923241,0.128808508507,-0.833795997394,0.67149588933,-0.41114602402,0.456114315631,-0.932320766655,0.322804004582,-0.900073639819,0.338139734019,0.198517713517,-0.15724771302,-0.0962596917283,0.072063161118,-0.45069444784,-0.0321375427009,0.261885104942,0.170710277481,0.383916581512,0.405710321146,0.449939320494,-0.016815979094,-0.262065728568,-0.378929286904,0.292083785349,0.0130828728674,-0.144939323763,0.0120617689147,-0.0724307529717,0.144264411089],[-32762.887756,-2030.66533638,1282.27583147,-1738.28955906,2735.28923605,2303.45987577,-1317.47134969,-1407.21136387,-177.50375719,-734.952579011,-594.57023377,1275.31845771,-321.999650216,191.668513696,-122.338147285,119.831380053,32.6314725902,624.844201049,304.362995181,-369.554988645,101.592219085,-398.640525711,-242.431817235,-173.873828943,44.8843513846,-30.3822199923,-6.52221789976,181.901557948,9.20402783175,-26.0374164307,-217.983213354,-54.7130035897,-127.630021265,-48.4140950855,-25.5585714934,-5.11585563508,-11.786067488,15.3292316717,-16.7062840963,11.9683420095,31.5900568322,-66.383142848,-59.7154130172,-38.586017805,-2.5123085752,-49.0924604065,5.27254303168,13.360360815,7.10893901307,-8.56030596373,4.06415824115,-0.882287000416,-1.01109229005,3.02437139175,-6.73983808648,2.51819664222,-5.54162927031,-6.07559856087,2.10599779675,7.89247672909,-15.3951713095,-6.29517658282,-12.671612135,0.860212423438,0.0212868071394,-1.15682799466,-5.97564039268,1.01920619464,1.13697091372,-1.92087149747,2.28008961609,-0.324426048772,3.18517538764,1.86275725441,1.66859149846,-1.02515386936,2.07682189806,-5.60888799055,0.719831519151,-6.84260124366,1.01915826908,-0.272214209796,0.497047059175,-0.973604019053,-0.202464865822,-1.22956286872,0.628855642728,0.726398089808,-0.317309513054,2.06180392728,0.830646381347,0.0283973398297,-0.790370894389,0.705096642482,-0.251246822321,0.369676809082,-0.899028988262,0.42033950765,-1.00361892532,0.326185857932,0.187429104906,-0.151093053485,-0.0937006639157,0.0941627686749,-0.426985936055,-0.0151271100287,0.26687163423,0.166808012036,0.377407733091,0.354027078331,0.454195646795,-0.0511429164441,-0.271943812785,-0.380966675754,0.286264009365,0.0817365796553,-0.172848294199,-0.00342650729516,-0.0720585818155,0.158714266157],[-32731.1573686,-2141.30906065,1306.93392802,-1735.96043458,2759.29745141,2271.05179549,-1388.30726339,-1371.9686064,-148.887387401,-726.547414122,-624.627220029,1290.72616551,-309.724024185,193.07097959,-100.095663202,130.438394635,56.9269036397,592.236389664,324.690764124,-397.460331888,105.931867582,-390.189014322,-222.032096686,-163.83874171,44.4137649013,-23.6048239247,-5.99900860018,179.875386796,3.07601781105,-39.8380189719,-213.893173366,-50.9784820508,-127.929845672,-24.3511922501,-12.8461016057,-3.1042768066,-12.0420137052,14.283538643,-11.2602442536,10.0932681544,30.2190203038,-66.8553853045,-63.1071326307,-39.1070013512,0.325771300095,-45.5397359,9.52225505878,19.5666098981,7.14026804846,-8.20682989217,4.19207725907,-0.413759465427,-1.1470554889,3.61011015433,-7.89666740637,2.30972085781,-6.6807149576,-6.23665703743,4.04859285935,9.26748109166,-14.5563232748,-7.8536511901,-12.658378899,0.613268639548,0.0436943203059,-1.0108852947,-5.91252323188,1.14096407127,1.41418856512,-1.98519436743,2.24616660775,-0.769304241854,3.1398168039,1.75316611215,1.5317011624,-0.368931125423,2.09091852169,-5.5856804244,0.529564855368,-7.28254888683,0.940854075143,-0.296929361635,0.522074774295,-0.933393288534,-0.130873920989,-1.15341151947,0.594959566417,0.775284304766,-0.3215123195,2.04193126017,0.629755371644,-0.0832707172989,-0.733837912503,0.745248936896,-0.0804179369496,0.276391300758,-0.868772524378,0.523353066558,-1.11360033828,0.311564078631,0.176173271746,-0.144261949926,-0.089158936103,0.114212873234,-0.400020983794,0.000316360928572,0.268724647628,0.163583361205,0.367458991026,0.301897258422,0.45552883351,-0.0829393187271,-0.280144998716,-0.379684335144,0.281545512759,0.152260649791,-0.202021415997,-0.0244516312213,-0.069695784291,0.173539147136],[-32719.2957585,-2240.0849482,1320.61300259,-1725.65381936,2785.20975711,2238.74267641,-1450.31380375,-1342.26661799,-113.890639392,-719.779013068,-654.272320855,1302.70349762,-296.457712917,193.178307319,-80.7095058362,142.215133219,80.9148595339,558.876080797,343.355809461,-426.425014778,111.897477173,-380.562073886,-197.078951228,-152.061399914,44.2013515629,-16.1078507888,-5.76171319872,177.399357642,-2.63435374429,-54.3503626779,-207.338445189,-45.5483954554,-127.130178697,2.32828428169,-0.429992602205,-0.78661055871,-12.2683148301,13.036937303,-5.57195260908,8.35147867427,28.4146022088,-66.873748767,-66.1992789299,-39.0962000149,3.35316243105,-41.9501031329,13.881156291,25.9542724334,7.20123672477,-7.75938634772,4.25340393473,0.0661609813302,-1.33526246383,4.18851130088,-8.99141353615,2.07866040486,-7.85230592499,-6.29482450568,6.14784012242,10.5361979252,-13.6811376828,-9.50443013158,-12.4419622976,0.377054965814,0.0991692442299,-0.876522140572,-5.81383041209,1.22746384469,1.68529441941,-2.04773982162,2.18769781283,-1.20076529568,3.06150860585,1.65673928576,1.35387265411,0.328212474559,2.10814685717,-5.50824271227,0.304272804686,-7.75180707035,0.860742536611,-0.314943837216,0.543768326023,-0.882241785995,-0.0659749211988,-1.07429981188,0.548636892173,0.808928714434,-0.317531636896,2.0065278984,0.430623337596,-0.205925962862,-0.665106015361,0.79055267862,0.0968405643821,0.175097817317,-0.841286164108,0.630118370754,-1.2282876481,0.29427726606,0.164745309642,-0.136572597491,-0.082659989265,0.131840846775,-0.369530175802,0.0139052018361,0.267406133747,0.160763271138,0.353796513057,0.249822731547,0.453258839772,-0.11158667404,-0.286366170895,-0.375003586982,0.277491460654,0.223690443826,-0.232184225647,-0.0515079555335,-0.0651267020613,0.188384113849],[-32731.461217,-2324.88088601,1325.60863391,-1705.85143297,2811.19229094,2208.54232698,-1503.02735504,-1318.27950599,-72.1817116643,-714.158279529,-682.505907447,1310.11886967,-281.666639279,191.05901841,-64.8781889123,155.116057064,104.633309479,524.809344713,360.035786268,-456.1842558,119.437777121,-369.60132468,-167.933467084,-138.613806101,44.3023027388,-7.84937002262,-5.8184657099,174.45344884,-7.7943471995,-69.6551855589,-198.114438758,-38.6368783015,-125.107833277,31.3522964629,11.465144242,1.8358307071,-12.4565385448,11.5754042007,0.335549718338,6.76844845427,26.0862109989,-66.3913244491,-68.9968280495,-38.4323303509,6.43405667968,-38.3609806652,18.3025949036,32.4285438396,7.28772468934,-7.21710919733,4.23988281283,0.548927722935,-1.57860272574,4.7537865547,-9.9991845457,1.80705668811,-9.03539739648,-6.24955405813,8.39755937915,11.6493869248,-12.7818943027,-11.2460081884,-11.9928535134,0.155603915943,0.186752359616,-0.754305411589,-5.67491118882,1.27442990517,1.94801714552,-2.10692594685,2.10330555006,-1.60947162776,2.94389395438,1.57360360154,1.1313549321,1.05365846307,2.12107431775,-5.37162654839,0.037839609926,-8.24090946799,0.779284249624,-0.325672732309,0.561982170955,-0.819951858873,-0.00869687887369,-0.991260487585,0.489220782866,0.82631226308,-0.304928438999,1.95333159531,0.236441424546,-0.339097792229,-0.58538819659,0.839021491489,0.275186721318,0.0645174491312,-0.816096265366,0.738366866716,-1.34549901121,0.274382123803,0.153195599103,-0.127885424733,-0.0742999005775,0.146677269799,-0.335381958353,0.0254065460719,0.262883906049,0.15801508779,0.336124739408,0.198293271885,0.446627207127,-0.136425720751,-0.290299075069,-0.366863367012,0.273461281509,0.294819936985,-0.263009724073,-0.0850881005958,-0.0581141230388,0.202818685601],[-32767.1885534,-2388.44534311,1330.94576147,-1674.73227697,2836.57061111,2184.06245949,-1546.17145502,-1298.04246475,-23.8323592845,-708.915053961,-708.126459982,1311.81575695,-264.071908881,185.467073957,-52.5677028417,168.868231405,128.11368756,490.034842122,374.463374588,-486.254823311,128.418182059,-356.92010245,-135.111985782,-123.576965284,44.7249066877,1.17270796678,-6.17439460554,171.044781158,-12.2552382235,-85.8267308697,-186.001475322,-30.5361441103,-121.718510159,62.34592567,22.6225002246,4.75106473001,-12.6076852956,9.89042291954,6.42859617036,5.36844438495,23.136236853,-65.3656756021,-71.5118543939,-36.9798579192,9.40115270399,-34.8004622546,22.7241011097,38.8789823842,7.39608144127,-6.58385831877,4.14426977464,1.02030911971,-1.88011288821,5.29930044005,-10.8936385696,1.47275747916,-10.2059234236,-6.10218630788,10.7891174518,12.5490625938,-11.8689157887,-13.0749130154,-11.2778698111,-0.0457754250522,0.30420259777,-0.644729082148,-5.49237412726,1.2779515887,2.19917847212,-2.16101973191,1.99112163101,-1.98542915576,2.77995449573,1.50346045904,0.859868913958,1.79270046174,2.12013911262,-5.16997888951,-0.276104814054,-8.73745701267,0.697063210154,-0.328453855526,0.576478518541,-0.746761851585,0.0401320596171,-0.903519248136,0.416476919037,0.826186432696,-0.283539916614,1.87973840273,0.0506867738503,-0.482157550566,-0.496302828883,0.887941847282,0.448262824808,-0.056648936666,-0.792589186934,0.845225432454,-1.46256796258,0.25198706383,0.141634332008,-0.118118689001,-0.0642178245679,0.158355923772,-0.297616473361,0.0346620107411,0.255106417527,0.154948319956,0.314069676195,0.147795558586,0.434763583578,-0.156794363295,-0.291647663891,-0.355270198702,0.268605970542,0.364131532218,-0.294108300557,-0.125678868284,-0.0483866437212,0.216336411545],[-32826.053789,-2424.07814862,1354.7594578,-1630.93855437,2859.62070704,2170.10642498,-1580.58020218,-1277.92223488,30.782742322,-703.569748444,-729.870644482,1306.33874616,-241.98899306,174.939504767,-43.0125836951,183.094731283,151.31682127,454.496759563,386.341362626,-516.034253827,138.592557638,-341.978725456,-99.3036003552,-107.057053021,45.4650118292,10.9299003672,-6.83142101093,167.197929862,-15.8822007242,-102.91610614,-170.811438632,-21.6039723747,-116.810346293,94.8202367629,32.8220000545,7.94166637242,-12.7229491423,7.98389844582,12.6591900819,4.17294609415,19.4640923776,-63.7725596046,-73.7576950246,-34.593748424,12.058489173,-31.2881936009,27.0685638558,45.1809804268,7.52321865759,-5.86579284773,3.96264124826,1.45997901336,-2.24213126231,5.81820052987,-11.6483863202,1.05113791709,-11.3371608537,-5.85272782132,13.3097750759,13.1701187639,-10.9500285251,-14.9851842163,-10.2610614717,-0.220724666627,0.448596695239,-0.547556239734,-5.26405347377,1.23518568912,2.43487339303,-2.208065259,1.84968971631,-2.31787999083,2.5632545794,1.44577510339,0.535612292803,2.52877678085,2.093765179,-4.89652024938,-0.643757615934,-9.2259671015,0.614605173383,-0.322415997544,0.587028554417,-0.663300698663,0.0800338713919,-0.810466096493,0.330779692991,0.807306155927,-0.253469906796,1.78315915313,-0.122656929518,-0.63395774198,-0.399764462353,0.93387030815,0.608667401925,-0.189602225311,-0.770026931785,0.947178978625,-1.57629881112,0.227190274008,0.130228651766,-0.107248852875,-0.0525799968223,0.166578362022,-0.256479293496,0.041635578693,0.244074922848,0.151127911021,0.287264330313,0.0989053897054,0.416755092974,-0.171973444637,-0.290112627151,-0.340262638422,0.261906994238,0.429757266627,-0.324974414236,-0.173747526668,-0.0356230880331,0.228349035896],[-32911.9509611,-2427.10015602,1395.99764287,-1573.24897319,2876.44642548,2165.09375407,-1605.92506261,-1261.94215761,91.4652669942,-698.356361189,-747.646211993,1292.70280398,-216.597646314,159.376118469,-36.5236943424,197.565216878,174.073568977,418.073562059,395.471392593,-545.521782311,150.179196571,-324.922000408,-60.949983962,-89.5182496847,46.5770725093,21.3878239221,-7.74553209419,162.96529969,-18.6518296808,-120.789011218,-152.643902015,-12.0474700947,-110.380845341,128.282203948,41.7888100476,11.3960736575,-12.7843368107,5.88984543077,18.9550963312,3.20476576638,14.9931147321,-61.6587887081,-75.6783985877,-31.1710182774,14.2489792023,-27.8594288822,31.2752037859,51.1964724607,7.66691793459,-5.0647502572,3.70007762762,1.83989928312,-2.65854505726,6.3035582283,-12.2410465256,0.530229294285,-12.4106992819,-5.47467745865,15.9331908541,13.4593387729,-10.0299936987,-16.9618582273,-8.90254339672,-0.362975722373,0.617904100582,-0.460827144606,-4.98891644409,1.1469318273,2.64945594986,-2.24477165885,1.68022228859,-2.59676957264,2.29478670721,1.39779509713,0.162934717461,3.24379668046,2.03221788099,-4.54228206677,-1.06929418478,-9.68698876821,0.531816094028,-0.306297163442,0.593462391518,-0.570316986765,0.111477067063,-0.711998603374,0.233864102491,0.768406214187,-0.215151557728,1.66221597144,-0.279269506532,-0.790600919871,-0.297779881968,0.974265336939,0.748505594224,-0.334414926606,-0.747091577242,1.040235847,-1.68266573473,0.199919072744,0.119140152778,-0.0953714677576,-0.0394835642239,0.171216189807,-0.212478161731,0.0466020289602,0.229728491454,0.14616516024,0.255395301254,0.052342349829,0.39207253409,-0.181130923281,-0.284864616861,-0.321715747767,0.252613582493,0.489655321501,-0.354772740948,-0.229539100644,-0.0193987387645,0.238251685931],[-33026.3623712,-2394.34550863,1433.26959368,-1498.6292887,2882.66944782,2161.05054819,-1621.96722839,-1262.53861478,158.528572956,-693.281445222,-762.510903997,1270.3675514,-191.913614857,139.653098273,-34.9895051405,212.178355391,196.389460211,380.603809368,401.852138948,-575.260008639,163.618347327,-306.804960808,-20.299174112,-71.9877009668,48.1345041032,32.5748914195,-8.85559632215,158.515187885,-20.6289268144,-139.160802339,-131.937955447,-1.92306833185,-102.680026597,162.260231381,49.157580765,15.086876365,-12.7471419409,3.66258065793,25.2476988755,2.49441665815,9.67523352422,-59.1422805806,-77.1515199497,-26.6795197077,15.8692873861,-24.5779567709,35.3055783347,56.7709135007,7.82067528557,-4.18221567404,3.36761736465,2.13215435725,-3.1135879369,6.75236496675,-12.6475485446,-0.0912971087,-13.420475926,-4.9093543221,18.6127160097,13.3804460563,-9.11364616596,-18.9781301681,-7.15900835891,-0.467296409572,0.808649732175,-0.381729475099,-4.66602971743,1.01711323233,2.83779960614,-2.26435712318,1.48629641847,-2.8116808973,1.98419696042,1.35333610026,-0.243256066635,3.91711553502,1.92914608518,-4.09566729471,-1.55419777677,-10.0965410872,0.448049180005,-0.279196558491,0.595536563903,-0.468837914362,0.135466195972,-0.607897795814,0.12940986306,0.708161396623,-0.168640962319,1.51677400919,-0.414510291323,-0.944702939576,-0.192731333175,1.00808577869,0.859419914341,-0.489837412782,-0.721725060842,1.11987657775,-1.77672548253,0.170053711746,0.108366885237,-0.0827148412614,-0.0251184429916,0.172154151083,-0.166270222499,0.0501552460709,0.211977470181,0.139979646641,0.218099659213,0.00906435975504,0.360703908753,-0.183397835822,-0.274320531614,-0.299332629694,0.240342777051,0.541665570879,-0.382254156328,-0.293032063549,0.00084311271568,0.245425654884],[-33169.5774874,-2327.65716524,1463.07744315,-1404.03057307,2873.08394808,2152.99809088,-1631.88972707,-1289.86215802,232.116381847,-688.177578635,-775.198311803,1238.33396064,-171.079885272,116.219183439,-39.4432049641,226.79130843,218.408157059,341.992962709,405.481470607,-605.49507032,178.923158475,-288.591757702,22.0342869313,-55.6088134395,50.1895424455,44.5459238947,-10.1451448379,154.121246818,-21.8681561473,-157.755576872,-109.201580617,8.6080460249,-93.9903006766,196.134653701,54.5171183564,18.9602392055,-12.5535614074,1.35058964084,31.4688169252,2.07288467891,3.4635864234,-56.3656032187,-78.0715608507,-21.0869765691,16.7808218883,-21.5037495607,39.1028884258,61.7352310706,7.97340060543,-3.2250016838,2.97626097037,2.30909377679,-3.5898777486,7.16247911626,-12.8392478262,-0.82424535925,-14.3564590157,-4.09744369941,21.2924756493,12.8909591675,-8.20632191983,-21.0015767898,-4.98735718886,-0.528809250074,1.01456199201,-0.307477707315,-4.29500990814,0.85004838636,2.99589039783,-2.25870692158,1.27139041995,-2.94974555193,1.64189946799,1.30624292456,-0.66643148899,4.52526890177,1.77693302158,-3.54404476067,-2.09840549942,-10.4266890444,0.362551194816,-0.240699827415,0.592981624209,-0.360361648397,0.152871242373,-0.497499723401,0.0222896056332,0.625359846986,-0.113917376637,1.34670669821,-0.522726273985,-1.08795402162,-0.0874220553017,1.03361144317,0.931843945142,-0.654315791974,-0.691755107832,1.18067288895,-1.85280662413,0.137591646288,0.0977978201571,-0.0695713563921,-0.00982531263979,0.169212690389,-0.118603942701,0.0530062107068,0.190921564179,0.132589259836,0.174951341176,-0.0296869130683,0.322632281694,-0.177882670942,-0.256862521762,-0.272880057614,0.224607592168,0.583191697982,-0.405929899602,-0.364098621525,0.0257287009099,0.249162155324],[-33341.7754895,-2227.76626072,1503.28260569,-1289.05096687,2843.64615825,2140.49594,-1639.83977691,-1349.37707184,311.147478845,-682.793286009,-785.751599238,1195.81045576,-155.671840275,89.5669709957,-49.6545217542,241.016977816,240.21080088,302.312055868,406.395088411,-636.001699905,195.842933665,-270.99196294,65.093739026,-41.5435212158,52.7558836225,57.2991264519,-11.6591265875,150.135935043,-22.4003209178,-176.277202526,-84.9629946814,19.2826023026,-84.5794962142,229.124442825,57.424512432,22.941534142,-12.1515744158,-1.01138685809,37.526663663,1.97191080348,-3.69441962918,-53.4928832309,-78.3502411324,-14.3542559319,16.8068740752,-18.6868445294,42.5879623437,65.9077881362,8.11206205513,-2.20740697656,2.53342360887,2.33902661873,-4.07017624184,7.52615618584,-12.7844115522,-1.69167507691,-15.2046439425,-2.98069415463,23.9080994192,11.9416039667,-7.31228852284,-22.9917457731,-2.3451926665,-0.542166634913,1.22717068535,-0.23620670662,-3.87663395315,0.649693022529,3.11889061273,-2.21952191077,1.03773021494,-2.99633775815,1.27846081574,1.25051514156,-1.08851569484,5.04194934184,1.56725603333,-2.87387315534,-2.70016571253,-10.6452331467,0.274709732454,-0.190617455374,0.585370696432,-0.246690771633,0.164142775015,-0.37997899604,-0.0815819529098,0.518420006667,-0.051316337371,1.15179953859,-0.597506436022,-1.21102387113,0.0147676886061,1.04859544836,0.954949782295,-0.825855697185,-0.654836199122,1.21628306758,-1.9043436781,0.102681581418,0.0872584679381,-0.0562799591508,0.00598916328933,0.16204859255,-0.0702786919425,0.055953207483,0.166784082797,0.124030188875,0.125447090866,-0.0625089679333,0.277866270263,-0.163771735314,-0.230796996227,-0.242207518668,0.204871631773,0.611210425602,-0.424043858313,-0.442392511231,0.0559355676088,0.248668870262],[-33541.6160185,-2110.1238756,1584.79116666,-1154.06060189,2788.45950556,2125.92277017,-1653.59334555,-1442.80452183,394.068746769,-676.973319911,-793.63954406,1141.25658818,-146.330998282,59.8424725224,-64.6658494174,254.509681248,261.997356644,261.939419144,404.447182224,-666.262384094,213.642841969,-254.767928081,107.440788985,-31.1213081961,55.8599719632,70.8671852704,-13.4693847591,146.991583595,-22.275004767,-194.457105031,-59.8808596979,29.6858203928,-74.7913510428,260.268376807,57.3839289778,26.9358653027,-11.4662208059,-3.38650814505,43.3127956626,2.22741419122,-11.8664552435,-50.7390194849,-77.9269005663,-6.47764954433,15.7318777803,-16.1819829759,45.655072641,69.0949315758,8.21802929568,-1.14524772047,2.04609703454,2.1929559661,-4.53202349997,7.82877253952,-12.4518167392,-2.73098562888,-15.9589839675,-1.50124777401,26.3778830237,10.477422072,-6.435243566,-24.897971597,0.808469841203,-0.503531198884,1.43657435123,-0.166587916773,-3.41117025916,0.421806121619,3.20177645049,-2.13809465194,0.78630521477,-2.93730807646,0.905359264977,1.17759949345,-1.488925407,5.4371137119,1.29172158972,-2.07081847008,-3.3557761165,-10.7155981292,0.183483561173,-0.129203672814,0.572011508958,-0.129506962257,0.169861272797,-0.254050577639,-0.174547571486,0.385392730947,0.0182977731618,0.93204062446,-0.632500107941,-1.30310507653,0.109295249771,1.05045326284,0.916541967131,-1.0019152438,-0.608486096049,1.21947785515,-1.92374074584,0.0655083685953,0.076308623269,-0.0433328462036,0.021888298333,0.150225958279,-0.0220456700564,0.0601122967695,0.139956584849,0.114515115108,0.0690598711522,-0.0879786982003,0.226572337558,-0.140557603146,-0.194297067891,-0.20735117538,0.180596776643,0.622241877115,-0.434528990212,-0.527247040866,0.0922145642971,0.243075648207],[-33764.3065351,-2025.61214699,1736.4478671,-995.374281786,2697.9872901,2111.84143256,-1688.45233504,-1566.31941129,480.241986371,-669.722556786,-797.767373075,1071.71542711,-142.610621582,25.027060473,-82.433351573,267.173990499,284.571963524,221.840258032,399.38855913,-695.498178113,230.480725503,-240.643787697,146.637838664,-25.7158289952,59.5000378872,85.3771347548,-15.5883811424,145.307281422,-21.5920710788,-212.127731419,-34.7533210249,39.0585453559,-65.0473612446,288.336699156,53.8913446561,30.7980273663,-10.4149009604,-5.70865312258,48.7168559255,2.87726916245,-21.1215401898,-48.386508334,-76.8011682602,2.48383602819,13.2775250608,-14.0333567296,48.1501931623,71.114349794,8.26105085772,-0.0647993017763,1.52404089387,1.84357561685,-4.94500164132,8.05717484466,-11.814413931,-3.99368045047,-16.6329335736,0.394693435943,28.6015571221,8.43057493434,-5.56763321776,-26.6601147142,4.51752048011,-0.411118960053,1.63012338529,-0.098436114916,-2.90126271084,0.175147648962,3.24137101315,-2.00616636777,0.519381143154,-2.761423448,0.536490561891,1.0748902107,-1.84577534095,5.67946238114,0.940790749851,-1.11755091425,-4.05945725488,-10.5956532537,0.0875416205216,-0.0569937627634,0.551439263368,-0.0110731405626,0.170914628628,-0.11797395364,-0.246841021097,0.224650106497,0.0935538898258,0.688635028166,-0.622143815546,-1.35174570634,0.190589839965,1.03566224016,0.803713225584,-1.1793992562,-0.549494642718,1.1823928617,-1.90188491659,0.0263295463552,0.0643327487508,-0.0315749295646,0.0373660799626,0.133211977748,0.02528757332,0.0670269049189,0.111099526352,0.104737517991,0.00548619580558,-0.104732068242,0.169239325815,-0.108141467682,-0.145617369593,-0.16853856761,0.151244354416,0.612484502351,-0.434866050405,-0.617375646738,0.135458985697,0.231495397996],[-34002.1168778,-2034.1920569,1946.79035183,-809.476384448,2565.35478283,2092.36899512,-1754.24684229,-1717.93125041,568.632685024,-659.230347831,-797.739995095,987.00120032,-146.025959088,-15.2036959223,-101.083281253,279.105637225,308.997170993,183.750796635,391.461588842,-723.386215937,244.950197114,-229.888028015,180.051188641,-26.6562699223,63.7113361323,100.920692677,-17.8836228894,145.887796323,-20.6028796995,-228.829071118,-10.6767883189,46.7023129932,-55.83178611,311.997844946,46.4651318593,34.3529086391,-8.91947334677,-7.85621597024,53.5762553883,3.9742323056,-31.4776348044,-46.8214355747,-74.9025010049,12.4021102928,9.20103652694,-12.2509790385,49.9010823488,71.8122879967,8.20339999575,1.00159738281,0.983174526587,1.25431303424,-5.25979055144,8.19168781468,-10.8519110514,-5.52114352672,-17.2619531,2.79005498151,30.4689640688,5.74302338855,-4.68099203238,-28.1981201312,8.83141151553,-0.265966028148,1.79519648281,-0.0330056734487,-2.35379206869,-0.0753548470159,3.23096383049,-1.81626607942,0.242246849399,-2.46088777983,0.196375812257,0.928622563355,-2.12651530989,5.74010191222,0.509889596107,0.00933237314595,-4.80164128314,-10.2362464903,-0.0152113116329,0.0256110603571,0.521207736604,0.106085823124,0.16890633937,0.0290221386629,-0.285968620495,0.0339190781727,0.17232300036,0.425337969687,-0.561224988842,-1.34015910106,0.253059278909,1.0021268102,0.604457947455,-1.35360180518,-0.472732036809,1.09689484484,-1.82754467332,-0.0146443865156,0.0504319488242,-0.0223209704838,0.0520077367916,0.110381016932,0.0707223827293,0.0788541920123,0.0807727916226,0.0958901978165,-0.0653631552508,-0.111448388742,0.107185743805,-0.0666817124386,-0.0824336527452,-0.125732822392,0.11679461926,0.578420780535,-0.421848725414,-0.710375328424,0.186730324822,0.213130816347],[-34242.5542771,-2181.15150045,2178.05940433,-599.041799861,2392.09804522,2057.88324516,-1849.91824421,-1892.29313496,655.69348931,-643.087535947,-793.43201508,891.45744121,-158.604171929,-58.0487971684,-118.930378448,290.327134536,336.181880304,150.209616066,381.484313075,-749.784849567,256.534160472,-224.262625257,205.137555632,-35.3313128253,68.6211448793,117.412492173,-20.1489976776,149.705554539,-19.7000722801,-243.729014,11.0399513287,52.0902893833,-47.7182899418,329.887319344,34.5653743236,37.4249541331,-6.92132577491,-9.67094802951,57.6519101754,5.57547484541,-42.9012882665,-46.5080050023,-72.0672256716,23.0885183131,3.32740890756,-10.835076564,50.7250196758,71.0414633055,8.00764916677,2.01830357943,0.443124480347,0.378453595232,-5.41417459138,8.19950452534,-9.54561537,-7.34603022689,-17.893970404,5.80208419521,31.8587951282,2.37306976359,-3.73545768331,-29.4075104709,13.7960641268,-0.0714502029394,1.92164201753,0.0277328052278,-1.78043902892,-0.309950898942,3.15895324588,-1.56350132107,-0.0384223852551,-2.02770336171,-0.0802577948468,0.726881187932,-2.28582312146,5.59054673511,0.00141205695464,1.33567514511,-5.56905603781,-9.58359875305,-0.12768198479,0.118876661249,0.47846138336,0.219216274256,0.166072302925,0.186468590713,-0.27734343562,-0.190340954902,0.251978381861,0.148107096604,-0.443789432555,-1.2469286142,0.291144347645,0.949612851008,0.306949261189,-1.51826594599,-0.372247967308,0.954521534501,-1.68777028239,-0.057328033219,0.0334952601566,-0.0172782695657,0.0654850579461,0.0811538302238,0.113043003394,0.0981661684598,0.0493946913038,0.0895173041259,-0.143495733485,-0.106658310481,0.0425442234502,-0.0164516788214,-0.001803371215,-0.0786997879234,0.0777551854215,0.516555228075,-0.391651365456,-0.802900826943,0.247190758904,0.187143103595],[-34472.1329739,-2491.83335255,2405.67438376,-376.554944961,2191.14799975,2005.78092545,-1967.29489791,-2063.48944275,734.029554648,-618.034647113,-783.70682446,793.283683838,-177.554907413,-100.227407698,-131.522524935,300.394708657,366.830305509,124.619991659,370.706671304,-773.651549675,264.539767072,-224.839471533,218.550303045,-52.8490680311,74.3565048177,134.460480882,-22.200488458,157.963112382,-19.3404034457,-255.858228453,29.2366712249,54.4744519896,-41.2275476899,340.407416705,17.5953280745,39.8206543518,-4.43637197914,-10.9911316666,60.6323692636,7.71090363322,-55.3287718798,-47.9246360251,-68.1465051939,34.3404816085,-4.54507604094,-9.76790298094,50.3727746728,68.6467095972,7.64030787131,2.92957867011,-0.0802572006164,-0.841767414924,-5.35347239804,8.03970535557,-7.87373751289,-9.51297782519,-18.5757738247,9.54904070599,32.643445664,-1.73209801549,-2.68566375288,-30.1681600945,19.4434858791,0.169574077735,2.00012414061,0.0803218155251,-1.20138991005,-0.509665556971,3.01232257346,-1.25034188599,-0.315133558838,-1.45050504337,-0.256233443502,0.462803123158,-2.27574004434,5.20170102195,-0.581246132696,2.88502173397,-6.34638824281,-8.58268778011,-0.252446112144,0.224315164575,0.420249921238,0.324249192363,0.164266754276,0.353243811932,-0.206017742941,-0.452100869422,0.329458250631,-0.135592735465,-0.262387249021,-1.0487904023,0.299410874769,0.876931870534,-0.101844862277,-1.66686039617,-0.243057687346,0.746345514372,-1.46857298601,-0.101547347048,0.0126046015448,-0.0184650202536,0.0773936451674,0.0450522811027,0.150763649201,0.12743768981,0.0176522438149,0.0873662160949,-0.228653579956,-0.0885928725115,-0.0221879074993,0.0422815064834,0.0988920389062,-0.0274123389564,0.0345850324981,0.422768167391,-0.340048434024,-0.891035762334,0.318079637988,0.152457556722],[-34679.3784784,-2917.50459331,2621.38526939,-175.852628379,1998.09096431,1941.58656286,-2080.05905553,-2177.68526503,788.254281593,-580.672979526,-766.966730561,707.986933766,-193.849834218,-135.887160847,-130.103918654,307.663190882,400.534172693,111.050873436,361.135237802,-792.993027344,268.909922886,-231.527809234,216.379112642,-79.5429051866,81.0433873735,151.010158519,-23.9717542683,172.029830352,-20.1555032249,-263.930768875,42.9894416249,53.0208788644,-36.6554998266,341.743409079,-4.99594151708,41.3690106996,-1.61403705714,-11.6696969241,62.066892922,10.3440961482,-68.6530599444,-51.5777137508,-62.956061742,45.9776803786,-14.6196314972,-8.96146336827,48.5192329815,64.4816979683,7.0893567035,3.66038776876,-0.575173304391,-2.48891070582,-5.04116072979,7.65409484121,-5.82044397089,-12.0707239167,-19.3505097161,14.1579544166,32.7041405515,-6.63507047966,-1.47006712782,-30.3441489372,25.792342554,0.457884794241,2.02698266626,0.121022319283,-0.647533470717,-0.656844815019,2.77264476751,-0.891638461792,-0.579394580076,-0.716733815298,-0.289862265011,0.137587205274,-2.04441604973,4.54783999623,-1.23345514775,4.68039226215,-7.11663946896,-7.17788579582,-0.391733645258,0.346114832719,0.344099073003,0.416347619907,0.165292712313,0.526670784892,-0.0572830862371,-0.756449999256,0.399982092649,-0.416179391658,-0.00846947103645,-0.720075599298,0.273400313012,0.781917600635,-0.634838849032,-1.79297245907,-0.0808699442707,0.463023365828,-1.15492778596,-0.147238148442,-0.0128288159321,-0.0281592737924,0.0875342904568,0.00192883755535,0.182076992696,0.169056875933,-0.0136707091859,0.0910982476497,-0.32024098185,-0.0555124578688,-0.0839143444971,0.109236471032,0.221917417721,0.0282188886886,-0.0124384447183,0.292585575183,-0.262532520719,-0.970146258799,0.400704929826,0.107746426275],[-34858.7740954,-3265.80798403,2823.85454579,-65.8573121594,1885.6469411,1876.10971146,-2128.95266754,-2150.74475612,789.845855361,-528.043403107,-742.516942697,663.145314134,-192.533443418,-153.007695455,-100.709610962,308.271782282,434.696121886,113.883753886,356.175155257,-805.203792009,271.721664232,-242.887755826,194.803243808,-114.497345236,88.770053912,164.92490274,-25.6155270299,193.399387375,-23.1123141804,-265.971685831,51.6065993518,47.1371470868,-33.892226894,331.934936413,-33.5799133029,41.9693153321,1.19011834792,-11.5890567299,61.289299372,13.333652931,-82.6784723682,-58.033757734,-56.1653011206,57.8836136485,-27.0439895479,-8.19479052342,44.7716746632,58.430139246,6.38667087769,4.11641997213,-1.03316674816,-4.68954250676,-4.46570116075,6.95764679056,-3.38724452141,-15.0500669498,-20.2536464278,19.7839245945,31.9491350991,-12.3969865382,0.0025160188135,-29.7811888849,32.8513808402,0.802195080855,2.00942975252,0.147025749216,-0.163628917373,-0.734189810724,2.40961414902,-0.518836460761,-0.820200514658,0.184866337449,-0.129625200109,-0.236126264614,-1.53139062446,3.61147846369,-1.94708235046,6.7476047377,-7.86091398934,-5.31282042815,-0.547306584007,0.492653878956,0.248580613958,0.490459639831,0.171504175701,0.700641847931,0.183044024738,-1.11061756032,0.455495395702,-0.680764407019,0.327107868639,-0.231150745775,0.210609638068,0.662464362943,-1.30276690797,-1.89022840622,0.118743704581,0.0949415795486,-0.730708446564,-0.19466506078,-0.0429228610381,-0.0488263509133,0.0962566074819,-0.04782179126,0.204615736774,0.225402273154,-0.0441084215562,0.101888311987,-0.41723170644,-0.00611501079006,-0.138455784887,0.184083602555,0.369531835717,0.0888281660358,-0.0631614567957,0.121721652551,-0.154400304841,-1.0346325432,0.496434178797,0.0514862760349],[-35011.2358435,-3342.47982974,3017.21825367,-81.1714597498,1910.685897,1821.13366221,-2073.7155609,-1940.20102595,728.533291158,-461.726596907,-712.052202926,676.499848718,-161.519403485,-145.609472147,-36.5440114722,300.320129366,466.558408091,131.616734542,357.764618842,-809.000223912,274.294484336,-255.005804443,153.60555243,-153.938745811,96.730151701,175.130490817,-27.4984849113,222.313243449,-28.7242125016,-260.721390809,55.0879799012,37.241358777,-32.2370359789,310.887679629,-66.4193597572,41.8032009394,3.6329893922,-10.8207360148,58.193415926,16.5789875125,-96.8327681864,-66.963615359,-47.834044642,69.6626462213,-40.9837677098,-6.87073880881,38.9198407711,50.8846766068,5.70738062511,4.21888587336,-1.49294923135,-7.4413834648,-3.65831375685,5.95997040958,-0.520373803039,-18.3975621207,-21.1826701477,26.1977252627,30.3332855046,-18.7640717523,1.945152935,-28.4170914123,40.3057845424,1.23849706742,1.93870483373,0.169611259222,0.240161200357,-0.778631118492,1.90005649287,-0.140178652852,-1.03496315674,1.22667572822,0.198725488844,-0.600762835804,-0.789351655344,2.42840958849,-2.67413295361,9.07869030759,-8.50559415521,-3.12230554024,-0.718863486751,0.673710117469,0.131276097059,0.5361004927,0.17600933351,0.879961859071,0.518359587012,-1.52107161256,0.487155479196,-0.92269746919,0.736993000404,0.411120524418,0.126706594404,0.527459501254,-2.09783435467,-1.95820769883,0.344073038301,-0.341788938928,-0.197511748923,-0.244242840335,-0.0763794710151,-0.0812299239188,0.102874711555,-0.104103765462,0.212593804112,0.292710620328,-0.0709397975253,0.121107419114,-0.522327518698,0.0589050881306,-0.181649389282,0.267036312628,0.541840836187,0.157101685033,-0.112516142878,-0.0872092758328,-0.0161652818599,-1.08568844237,0.603334205387,-0.0137505111089],[-35139.0481845,-3432.42874875,3176.22175587,-44.7308398611,1961.14642211,1759.68431828,-2032.22475145,-1717.60508579,689.630630876,-395.404323664,-682.996148114,700.20681702,-120.731718301,-145.412815261,32.776339339,295.482273606,500.060299327,145.645830707,359.316306849,-809.811169884,269.554661747,-263.234709373,103.475557577,-190.000536316,101.834579671,187.312032105,-29.7962249712,254.812962864,-35.0095864556,-251.166899886,54.5561666285,26.2583810599,-31.3215628518,284.829947024,-96.2815678981,41.6176667469,6.11855212672,-9.81102089376,54.9769661735,20.4626771801,-109.744601578,-75.2787196944,-39.5746171776,79.7949043359,-52.8064540871,-4.00350164286,31.6483254853,43.6376838209,5.48530398214,3.99814826969,-2.10312647812,-10.2247611603,-2.67187505406,5.04026756791,3.03830178942,-21.8368863021,-21.6782906736,32.0159080405,27.8567918726,-24.5272792854,4.74303460378,-26.4788882697,46.9241340544,1.84895622882,1.72806982042,0.233728367293,0.692482068302,-0.974615486187,1.27938792704,0.360209833029,-1.24254525785,2.27273204095,0.432398968762,-0.801864854182,-0.212887513986,1.16129732765,-3.24575857221,11.5348829546,-8.82196440829,-1.30094943582,-0.90186661823,0.888921934627,-0.0164867877979,0.528291505313,0.143414111311,1.1092121103,0.924501401862,-1.98400801007,0.495688116661,-1.15905577509,1.16677521298,1.08683874931,0.0836931781114,0.421677452316,-2.96537682549,-2.01193453368,0.53460177478,-0.754166292086,0.386488608202,-0.296025633409,-0.109240245308,-0.12052200519,0.101428155584,-0.169350598813,0.191777262733,0.349569855679,-0.0841435422393,0.152585281758,-0.649649545845,0.135224639637,-0.21143532662,0.360032575974,0.734392431088,0.239903886524,-0.140136853001,-0.312105762749,0.135343432659,-1.14665732068,0.709814650174,-0.0730738080707],[-35245.5613977,-3547.53250992,3342.87444189,42.6906844758,2039.81498207,1672.91580025,-2008.58558591,-1450.39987372,673.042421688,-329.875941199,-660.401028376,737.384464444,-71.5448064685,-161.905434781,123.743233955,294.155522524,533.926803791,155.941206849,362.081292336,-808.318789159,256.757606565,-269.21201781,45.7844910299,-218.201907945,103.335302834,202.061086234,-32.7621273371,289.493895739,-41.115083301,-237.491095518,50.3963345154,14.4183006781,-32.6178829829,255.14650669,-120.7632743,41.3198451291,8.62010357452,-8.44527981937,51.7116373934,24.9922680511,-121.354829955,-82.5654971916,-31.7084438332,88.0224618711,-61.9621654288,-0.0948085040434,23.526127814,37.2574790717,5.78025093838,3.38398954321,-2.86384885194,-13.002195553,-1.49639972917,4.26180989477,7.2780462592,-25.2688829595,-21.6585855412,37.0781870446,24.6220774867,-29.418141651,8.18105607401,-23.8097501729,52.507759868,2.63723531532,1.36457885744,0.321191711723,1.17532309645,-1.33721993011,0.543163746604,1.00171129241,-1.40789784644,3.30083682031,0.573791275773,-0.781245248664,0.15071100268,-0.1401714573,-3.59921622292,14.009813827,-8.75458209658,0.0522613749312,-1.09352566999,1.13556058323,-0.197919583545,0.464730148933,0.0628618892607,1.38302883818,1.4062906291,-2.4938772414,0.478080296561,-1.37506355175,1.61943150474,1.79005365294,0.0935269748142,0.355365080932,-3.89158318761,-2.05343249717,0.678443881351,-1.12701994996,1.01057456133,-0.350275384806,-0.140695991143,-0.165313068058,0.0886975238512,-0.244747477927,0.138179170168,0.391549237334,-0.0821017918058,0.196461547546,-0.798403192614,0.223798989303,-0.223374666466,0.462432616943,0.949779056562,0.338604864646,-0.143579653823,-0.54861410359,0.293636484423,-1.21651848192,0.81447789483,-0.12501365662],[-35330.2474562,-3630.20163313,3455.06578858,168.515489966,2145.6630869,1572.03473871,-1983.69383773,-1158.30472302,675.23129724,-268.075546289,-649.940356183,790.604643845,-6.76481142153,-196.132929764,243.524728369,297.36385592,564.762310246,160.962064099,367.202678653,-806.06411963,235.204019215,-271.44772706,-16.3858391788,-233.256471011,100.953914862,219.754357196,-36.6675841493,323.848684476,-46.3316517463,-219.320985376,42.7889165278,1.34540153568,-36.7508956932,223.325385857,-137.103710811,40.9714680141,11.1800407936,-6.53543251263,48.4183890542,30.0865278658,-131.887920482,-88.4328699552,-24.2260356781,94.2548010802,-68.2390815953,4.26782346171,15.442739334,32.3471814956,6.67661765784,2.36055464023,-3.76634883143,-15.7047335562,-0.146945000437,3.66716484984,12.1518103972,-28.632429258,-21.0905843283,41.3089836277,20.8368648601,-33.2365487787,11.9119240523,-20.1005834256,56.9168131337,3.59538983948,0.859291114611,0.410625109534,1.66873069352,-1.8775120163,-0.302965374486,1.78730163078,-1.50157401142,4.2859020423,0.631535077027,-0.498288447344,0.284258824731,-1.38609890227,-3.68605822528,16.3430638801,-8.24501943628,0.88302915218,-1.29452313523,1.41114660868,-0.415408685704,0.348887350303,-0.0742696359983,1.689298677,1.96548763884,-3.04032029536,0.426948497759,-1.55519595903,2.09954627577,2.5143660205,0.163342404912,0.339944537318,-4.84883478577,-2.08742630654,0.755847324429,-1.45293610004,1.66062938659,-0.408342507091,-0.170903859959,-0.213807471168,0.0622006031392,-0.330729971284,0.0489490395146,0.414903328009,-0.0651375014277,0.251137074861,-0.965897212861,0.324462931089,-0.213335188774,0.573458770451,1.18883625365,0.451833109519,-0.121214390832,-0.790446439575,0.450807578644,-1.29328120427,0.917015718864,-0.171196583127],[-35390.0552288,-3583.90914403,3582.59068487,304.483607416,2265.15480118,1463.49723813,-1929.07791847,-871.406815645,689.484591543,-220.721611805,-656.300372614,862.396907442,60.3342142141,-241.846828193,377.530222113,305.240580692,588.776950897,157.331926988,371.517906761,-803.179768771,208.527389855,-273.167617425,-76.3704512217,-234.075910642,95.0244934253,239.996578917,-42.2534764539,355.149591043,-49.9485501001,-197.551869073,32.6673663958,-12.3008612561,-43.1929231648,190.680483536,-142.792881897,40.9882808917,13.8048790295,-3.7010925065,45.0562003339,35.3623009358,-141.800386528,-92.4299727778,-17.4039113991,98.5059427725,-71.576752757,8.98615798457,8.12798341074,29.6849644102,8.28048605155,1.03173478085,-4.75046950108,-18.2972660375,1.35443945226,3.30628165832,17.52399998,-31.9431039492,-20.0017720593,44.6380034693,16.7041661759,-35.8525750316,15.627697899,-15.1259243817,60.0652179755,4.70081784443,0.255464071579,0.472017709398,2.16622964628,-2.58811360196,-1.25782508943,2.69846152693,-1.50026894691,5.19643377256,0.626764202927,0.0728300919114,0.205407832245,-2.46801095154,-3.47654634512,18.3347054613,-7.26357255412,1.17028332243,-1.50935114867,1.71469501945,-0.67057157904,0.191870484277,-0.273527241944,2.01592282017,2.60138401647,-3.612918584,0.331075244951,-1.69053552648,2.61328956845,3.25709686303,0.298689000938,0.387615464002,-5.79486200161,-2.11282333094,0.737231127567,-1.73247901063,2.32044101367,-0.473358441113,-0.200605914979,-0.2636603591,0.0206396265898,-0.426664744942,-0.0773949990644,0.416705552843,-0.0329484864692,0.312897275424,-1.15006294662,0.436547820516,-0.180322601577,0.691259509943,1.45229170585,0.577134354844,-0.073390923672,-1.02922469781,0.600163355881,-1.374319692,1.01896767809,-0.214676962394],[-35418.5156937,-3492.96870961,3775.91223527,426.779288653,2378.51899999,1345.52795672,-1858.10522227,-641.398153915,709.595645413,-193.403166129,-684.320283934,945.820772759,103.816976663,-288.501073657,508.149737723,316.814806599,604.093724316,141.095780441,370.861409603,-799.132278868,177.920080811,-279.907482404,-125.43370375,-219.954044955,85.8662332847,261.890537829,-50.1824346069,381.344592331,-51.7008518993,-173.980400934,21.0058436898,-26.2779779981,-50.484168369,158.358130434,-136.994897049,41.7796699741,16.4242751222,0.416090429683,41.5377824239,40.3547360978,-151.497644802,-94.2852912825,-11.7414867415,100.619923513,-72.0666733102,14.2615910114,2.17951998719,29.6215634964,10.6716997813,-0.497271376595,-5.74690455168,-20.7458584422,2.98279056411,3.21437143521,23.225416503,-35.3150371466,-18.4782116932,46.9797117315,12.3611844185,-37.163815786,19.0876470518,-8.81980426005,61.7756477991,5.92752143042,-0.405350132477,0.47899757423,2.66367170404,-3.45060452685,-2.31565025942,3.70974436011,-1.39851439169,6.0114824114,0.560415963839,0.960263364612,-0.0498604303267,-3.28867971744,-2.96759729756,19.7914081604,-5.82094157148,0.909448270509,-1.74119620728,2.04434770493,-0.964217839868,0.00354077399365,-0.536592670014,2.35352975794,3.31147434171,-4.19703971295,0.179347558592,-1.77831951832,3.17506437251,4.01163569355,0.507968867558,0.50957109507,-6.68122014177,-2.12602751645,0.600076690679,-1.97434681586,2.97843845,-0.547927632772,-0.230611298279,-0.312281243874,-0.0371299577672,-0.531380464849,-0.241816982452,0.394914437049,0.0169316573228,0.376353009773,-1.34850754188,0.560185629298,-0.124212558346,0.81533287534,1.73961586351,0.711318340397,-0.00106646873189,-1.25482776071,0.737956981527,-1.45341203052,1.12077967095,-0.256560159308],[-35410.3085264,-3441.26019604,4143.30147665,529.352674191,2457.57474781,1239.79613058,-1753.33290386,-429.306917585,733.538440483,-184.887748535,-732.781284836,1024.75565,121.519009596,-309.62846464,637.305637898,330.22480186,612.477220459,110.890170958,363.735296314,-791.404109535,143.648865944,-288.218007287,-152.821060474,-198.960023414,73.8004904408,284.116917739,-61.0789971003,402.532455555,-51.7292337829,-149.782194814,8.85026845579,-39.6840245211,-54.2857115114,129.73629511,-125.361426833,43.6666917275,18.9389481429,5.88923467788,37.5543041595,44.5465288358,-160.740269924,-94.0423018879,-7.35756650811,100.170447976,-69.8361458413,20.9565253144,-1.31975883786,30.7893353272,13.8626276919,-2.12236105769,-6.70528427085,-23.0551165377,4.70504228495,3.36299695697,29.0386084914,-38.8084238945,-16.6875252861,48.3117991771,7.76886833387,-37.0954418132,22.1403791215,-1.35114037875,61.6431298894,7.24707225769,-1.10154944155,0.410398916925,3.16898908323,-4.44342111033,-3.48662711478,4.80141399961,-1.21518612257,6.72536747157,0.405595131495,2.16917879745,-0.433900877753,-3.82304588647,-2.16778821603,20.5984943062,-4.04547370315,0.10237179818,-1.98916695273,2.39549338944,-1.29447945313,-0.211671374108,-0.865014136237,2.69739727359,4.09317117503,-4.77927254223,-0.0389056130914,-1.82152809505,3.81490806058,4.7489737995,0.798502972225,0.711844033096,-7.4687349318,-2.11762674507,0.347423502793,-2.21720075836,3.62795439424,-0.63418320231,-0.261101997391,-0.35626545359,-0.113105110268,-0.642970411837,-0.444705182124,0.347297270888,0.0879303010768,0.435245327523,-1.55673397973,0.696193868698,-0.045024052779,0.950941173335,2.04480202892,0.849043435642,0.0928781663178,-1.45720955898,0.868497504376,-1.51996487876,1.21727708146,-0.295608805562],[-35361.5005612,-3341.57886842,4419.49259513,609.415955393,2464.4464176,1148.85752598,-1614.31993819,-233.208141506,760.643074469,-196.466467934,-789.864677172,1083.80556741,132.318287295,-312.912079363,761.880277853,344.316589743,616.066189279,69.4301223181,350.562914649,-776.945101956,108.625514594,-291.82171565,-162.731077354,-182.81410982,59.5180047387,305.233181482,-75.4094290321,419.876695636,-51.0839950018,-127.020773534,-2.3582760272,-50.4887029819,-52.3410073165,107.185117228,-114.78332748,46.732064005,21.3463720123,12.5398084524,32.6717095115,47.6868853128,-169.151440152,-92.248005518,-4.5060718906,97.3036043405,-64.6836755563,29.6303580339,-1.27996359696,30.9665485015,17.8280485568,-3.7358207831,-7.56250459695,-25.2753609356,6.55433376319,3.74402113542,34.7300264629,-42.4213687895,-14.8938852733,48.5212004882,2.99532487915,-35.5402668241,24.6791472132,7.04338821994,59.365511176,8.63930696756,-1.81328878228,0.245715121007,3.69506338105,-5.5447007926,-4.78689000017,5.98717939669,-0.960137446189,7.29075997572,0.110038953561,3.67364419499,-0.91786376806,-4.09522976869,-1.06797924354,20.7299720369,-2.15237438842,-1.20135392356,-2.25267191416,2.76165849608,-1.65692827531,-0.450811348185,-1.261118751,3.04830293404,4.94057566158,-5.34923406433,-0.324402042176,-1.82567329588,4.55411010694,5.42268877385,1.18347780261,0.995160477798,-8.1342688671,-2.0834677155,-0.0109307953729,-2.50249289303,4.26306368366,-0.734103360398,-0.292828443224,-0.391434744638,-0.208459666992,-0.758952354996,-0.685672393324,0.272405399383,0.183672356232,0.482036996292,-1.76742618865,0.848104080942,0.0542677780819,1.10325162334,2.35995344961,0.986415421191,0.20218471436,-1.62903337243,0.998442515475,-1.56222600886,1.30121610837,-0.330167956766],[-35266.6478156,-3255.49528604,4537.82134865,640.132088497,2410.82368526,1043.03311037,-1497.05878114,-29.1817157643,791.429436457,-236.275479696,-843.621008437,1119.12663687,145.079465242,-317.642620754,880.008049207,359.983536409,617.046161502,23.4224417819,329.84606587,-752.808680232,78.3369546925,-289.701256418,-164.808724329,-176.069986735,43.4653872678,324.344287776,-93.3875422678,434.221040536,-49.9821697228,-107.710054578,-11.6532840296,-56.8897030796,-45.8117438044,91.7538338967,-107.770161312,50.9209507794,23.5640088277,19.9254201472,26.6315244109,49.7688929757,-176.395717938,-89.3645804582,-3.18812360908,92.1881153394,-56.6717359515,39.9650762603,2.02843969409,29.4381841833,22.5355840346,-5.24066018856,-8.22957695995,-27.433735647,8.53114627446,4.31460295784,40.1480200357,-46.0973649652,-13.4139469912,47.4882618706,-1.81880447009,-32.5696763588,26.5495586177,15.7826245102,54.8966197931,10.0723475376,-2.50873688288,-0.0244917767546,4.24249107172,-6.72704746744,-6.21928253079,7.28290351479,-0.682111393298,7.6474284347,-0.341114029397,5.40307135257,-1.48215283281,-4.17093301494,0.34710860164,20.1704317686,-0.435869686429,-2.90351077374,-2.52950076028,3.13338822443,-2.04694782887,-0.710380392762,-1.71944876383,3.40595019814,5.83762182287,-5.89092598849,-0.667356323572,-1.80589311656,5.39672344082,6.00034590852,1.67063443626,1.3549650431,-8.67775425092,-2.01460964454,-0.454832581722,-2.85662748208,4.87876625231,-0.848236951239,-0.326698177497,-0.413216468338,-0.322597696078,-0.875864237247,-0.9639369729,0.171426207256,0.308905340649,0.507918099329,-1.97108878286,1.02276070632,0.169603158904,1.27294025861,2.67772661146,1.1221603867,0.319922540562,-1.77018511841,1.13228677796,-1.56406646196,1.37125138718,-0.349229902502],[-35119.5687622,-3171.94560942,4670.91151162,617.069036989,2341.01966679,939.383042667,-1381.00658006,215.468365184,826.218779653,-304.555438143,-884.117566228,1143.02472229,165.019179548,-314.091165596,981.13155164,378.798492651,616.411467591,-20.3315259683,304.580321073,-718.833857895,58.8236473377,-284.573547999,-164.362292782,-177.876554594,26.4765554456,340.877633511,-114.633734703,445.6890867,-48.2196795674,-91.847321199,-18.8648073177,-59.1585112943,-38.8966086797,81.8900627755,-101.448025468,55.9540324086,25.6838838089,27.4016449175,19.1775655064,51.1929957282,-182.01328462,-85.5229967783,-2.97363924879,84.7972079471,-46.6903745062,50.5266744433,6.52972443172,27.3263165138,27.8890974051,-6.58995347712,-8.63670844945,-29.4714059432,10.5764903141,4.94534160118,45.3284618818,-49.6839030487,-12.4891616308,45.1091389243,-6.55403042523,-28.4249984961,27.4817014616,23.8632085095,48.5175364169,11.506872366,-3.15124778308,-0.384196957129,4.79202778695,-7.9719724179,-7.76086463047,8.7125381082,-0.478025039876,7.7672039182,-0.886719311325,7.26732653206,-2.12402841516,-4.13814873835,2.05276010573,18.915219457,0.768090444201,-4.82694288324,-2.81561036805,3.50250531017,-2.45535226519,-0.985272545999,-2.22138061065,3.76771958592,6.75635742938,-6.38112891712,-1.04521421971,-1.77349763332,6.33425110126,6.46663644948,2.259423808,1.77520521435,-9.11141010574,-1.90621884543,-0.956644281527,-3.29582341623,5.48220282054,-0.976295370118,-0.363561890109,-0.417161425132,-0.451947020915,-0.987894719128,-1.27670305831,0.0478368110701,0.46902566682,0.504312237204,-2.15453192789,1.22796232962,0.299305313497,1.45679705293,2.99166248888,1.2515032254,0.439290947259,-1.88660895347,1.26922254052,-1.50710910237,1.42965059434,-0.330621789246],[-34918.9720709,-3194.00243027,4797.24552972,556.472841404,2294.76048438,879.917414471,-1253.3569331,416.857294512,862.791104766,-391.964686392,-905.790343666,1163.4531494,203.104542652,-282.919856874,1033.42684375,403.171001895,612.892921801,-55.7559158722,282.640067966,-679.055472007,47.5654697559,-274.948686076,-159.86475133,-186.405867229,10.0567061676,354.631768808,-138.087577648,453.900234703,-45.8946862555,-78.3027415309,-24.3073347758,-60.3407138317,-36.1938400626,76.3529049985,-91.4189245686,61.3142040694,28.0961546821,34.0727752182,10.1447936177,52.7314076686,-185.169286632,-80.7377495437,-3.25908249343,75.3151924701,-36.0294285887,59.1403661546,9.60455142934,26.2733767074,33.7327861057,-7.79336229738,-8.78041802977,-31.2206225208,12.5572830495,5.47230942416,50.4036582984,-52.8963399992,-12.3125592154,41.2785277856,-10.958774248,-23.4157525295,27.0971703577,30.2912624318,40.6375878163,12.9047120866,-3.69901597261,-0.79632425451,5.30687917064,-9.28120799284,-9.37183178283,10.300240992,-0.45913557451,7.6197894747,-1.41019409772,9.17511985998,-2.85759017448,-4.05094998247,3.98452936875,16.9632681447,1.17348782403,-6.74913216359,-3.10588279662,3.862774322,-2.86728096447,-1.26789973319,-2.73703125617,4.12590434532,7.65780430916,-6.78664595097,-1.43092989978,-1.7314141705,7.34544153008,6.81929054244,2.9472533657,2.22741243666,-9.43777789756,-1.76644943727,-1.49612814769,-3.82643817698,6.08063223458,-1.11768157578,-0.405047543995,-0.399237473211,-0.591039616675,-1.08654138901,-1.61875996238,-0.0938472245195,0.669902481392,0.46368883752,-2.30047365641,1.46899453428,0.443975195017,1.64904598117,3.29736343329,1.36570428442,0.552054829712,-1.98458331402,1.40160484818,-1.37725917342,1.4764390253,-0.249143215585],[-34666.4984551,-3292.80008453,4995.90218119,464.922116077,2295.61307791,863.989436423,-1092.7048121,575.745177304,900.419654593,-494.988845468,-899.477685336,1179.60045967,248.744350257,-225.62175974,1029.71369754,436.115429648,607.067781027,-74.8706455722,269.16590747,-636.360707405,38.9345248666,-261.942166416,-151.954793593,-199.861193107,-4.34479418482,365.402052263,-162.738669974,459.125063388,-42.1740304683,-67.3810653895,-27.8852499527,-62.6163747565,-40.5553512832,75.9323382474,-75.3227093915,66.4513175954,31.1750607095,38.906487565,-0.483854168283,55.1129146032,-184.498351997,-74.6182155723,-3.80716522177,64.2498705237,-25.5303644195,64.4190532636,9.4829603392,27.3466244989,39.860248457,-8.81674170919,-8.67500623398,-32.468673569,14.324479071,5.80805269582,55.4515086863,-55.3436110207,-12.9399397152,35.8478507048,-14.6272676863,-17.8625666138,25.14407577,34.2947707345,31.5495959125,14.2030217133,-4.11117954534,-1.22864536213,5.7542569513,-10.6554388727,-10.9971766637,12.0632657976,-0.709353591942,7.158847564,-1.76519169755,11.0619057393,-3.67211438523,-3.93171240666,6.0319548763,14.2741703932,0.544572357186,-8.43278246054,-3.39024144878,4.19997084708,-3.26375671996,-1.55026206693,-3.23673282099,4.47077606025,8.49104140042,-7.06041672909,-1.79538989995,-1.67318357407,8.39988429534,7.06633803839,3.73476799103,2.68386066179,-9.64404774995,-1.61132578517,-2.07920559292,-4.45215777043,6.68096855981,-1.27040255104,-0.452220435959,-0.354510154523,-0.733927636374,-1.16147115349,-1.98260159536,-0.250246590855,0.918608940828,0.378358941362,-2.38814213326,1.74939457337,0.605980559628,1.84180343788,3.59328659312,1.45368943578,0.64791884512,-2.06844949875,1.51905755715,-1.16522136219,1.5050532707,-0.0770525312176],[-34363.9035643,-3312.18435967,5167.42707503,349.881268343,2348.50661378,838.397479441,-950.875285503,721.213656946,941.554935208,-618.359833382,-853.576319872,1198.03728637,263.457276637,-187.917037073,1002.76581383,477.378945086,602.752978338,-71.6330716682,262.059612602,-591.719745425,27.5810181001,-258.816137061,-153.167189551,-214.586351421,-15.5728108725,372.053265296,-187.528773248,463.260007894,-36.8009468245,-60.3903942282,-29.0178117655,-65.3931316638,-51.6468776405,78.0198002756,-51.8510429973,70.8547761889,35.0927711918,41.0074254737,-12.6690023039,58.8686154603,-178.51152406,-66.2587833732,-5.14692126462,51.3100911248,-15.5058075462,66.1651080582,6.16563570449,30.6617498428,45.9609280715,-9.59317069563,-8.33412969053,-33.0986211726,15.7879734222,5.95901197618,60.3545180602,-56.7117090662,-14.2649139385,28.7949294537,-17.2717113884,-12.4290120194,21.6255524348,35.5884224506,21.5228299637,15.3270873923,-4.36507995871,-1.65463341053,6.11497978114,-12.0800200588,-12.5973297676,13.9731130081,-1.22037373069,6.32580147888,-1.88187767778,12.9004927272,-4.48227540748,-3.77621476745,7.95081273295,10.8036716983,-1.20447460137,-9.57124809169,-3.65082263904,4.49535145648,-3.62255383163,-1.82458143963,-3.69207358353,4.7895761379,9.20085435654,-7.15645481846,-2.11702807269,-1.57058123945,9.45848545014,7.20859674594,4.61258114823,3.12374628048,-9.71174223795,-1.4803334685,-2.73803963663,-5.15206448841,7.31289172643,-1.43180170423,-0.50399643669,-0.277578497147,-0.874653173716,-1.19957358139,-2.3575054037,-0.417595450281,1.21877657176,0.241535854711,-2.39471897662,2.06881346863,0.787895790892,2.02638604661,3.87703302579,1.50004577592,0.712527411477,-2.13466976842,1.60786259309,-0.868664847319,1.5078366871,0.21086588963],[-34013.6151115,-3234.9471634,5459.92991997,260.401285582,2432.76977855,745.971138945,-828.055231824,891.344747028,964.695877603,-739.61291212,-792.613134437,1233.80940091,253.548533767,-135.029083699,995.27751755,520.160253079,600.051336626,-52.485534424,256.13651254,-546.818836365,12.4997848078,-264.497456649,-155.172756502,-217.874044302,-23.3011244968,374.979960249,-210.769384474,468.533522352,-31.8183206991,-56.0744555103,-25.8784918508,-62.4473348279,-65.6409733146,78.7551801718,-24.8006423334,73.450014317,39.8348847921,40.5807293914,-25.9946206854,64.1571581708,-167.787911333,-55.5302396818,-7.48120917223,35.3066332726,-5.63790888438,65.0313268836,2.09209404759,34.3376758554,51.7356685982,-10.3953301871,-7.93819016825,-33.233386566,16.8221998042,6.30056814325,64.9530046094,-56.9177972459,-16.429918162,20.523107079,-18.8628790948,-7.66758641753,16.4973732717,34.6796964201,11.0462575822,16.2695361868,-4.44415523023,-2.00245974805,6.30646689402,-13.5557094691,-14.1360733821,15.8825629671,-1.85176770485,5.15470121109,-1.79579811112,14.6277859479,-5.23527646312,-3.57290910727,9.47188416708,6.64821397957,-3.92117374325,-9.90852788348,-3.8733049073,4.74989973913,-3.92815033532,-2.08044016377,-4.05761563517,5.04605079815,9.74985268112,-7.06491372539,-2.4079891971,-1.36122692206,10.5220809682,7.2251221832,5.5359971579,3.50214344392,-9.64206550778,-1.41186837699,-3.487843336,-5.87637538399,7.99430951271,-1.59896265031,-0.5566010487,-0.169112807787,-1.00677009526,-1.18834486442,-2.72774315026,-0.587604186592,1.5612322235,0.0527768150918,-2.3042881111,2.4186524708,0.991273069698,2.1945244492,4.13545622315,1.48827236914,0.730778738554,-2.1742493639,1.66632557706,-0.507509376143,1.49869352651,0.618912679886],[-33623.9248901,-3144.08832423,5650.94723727,236.102637222,2509.91596789,583.35043714,-676.338828917,1087.62929911,962.93506361,-842.701320023,-741.110271766,1280.8157483,250.147964198,-55.8368164236,987.527287626,560.107909409,598.711863445,-21.8777642964,258.687327251,-502.374591225,-16.8651886001,-260.485230058,-143.493218055,-209.471479228,-28.9117805306,377.10106236,-230.801793513,474.803442772,-27.2922666109,-53.0187440897,-19.8178251002,-54.9761156648,-79.358406016,78.1947179893,2.16889666357,73.2437114338,45.3225409002,37.9446424983,-39.608303615,70.6506924081,-154.533728627,-43.7219798498,-9.97683624146,16.4439998313,3.48520410912,63.4416205897,-0.595274784337,36.0928418628,56.9961603305,-11.6538673266,-7.72587902822,-33.0166095178,17.145589291,7.38603289643,69.1030015194,-56.1022159298,-19.4721272242,11.5339759837,-19.3387058223,-3.88517257708,10.2373745024,32.3340894909,0.965991337082,17.0294624266,-4.33159046158,-2.17981846812,6.17161049295,-15.0580217837,-15.5839969149,17.5960367775,-2.44378217298,3.7500266776,-1.55992143689,16.2238981607,-5.92892665845,-3.34638507634,10.4066310693,2.10002753255,-7.21225784075,-9.36622891109,-4.04314509146,4.98798952659,-4.17639674139,-2.30244065585,-4.28317417452,5.18275000149,10.1179669781,-6.78719974519,-2.68915398933,-1.00103448324,11.6104795097,7.10385975096,6.43666829606,3.75597207293,-9.40377657436,-1.42725034359,-4.27734194563,-6.54501602755,8.73177585107,-1.76901393086,-0.600785901198,-0.0330244108084,-1.12321524407,-1.12110347361,-3.06949398315,-0.748465195138,1.92451250555,-0.178295680687,-2.10713982908,2.77755740594,1.21844742062,2.33571095633,4.35394763233,1.40928903485,0.701427557782,-2.17780086631,1.69871537366,-0.110358847657,1.51102718938,1.129945906],[-33212.3982773,-3120.27872783,5737.82702334,241.004097881,2595.88659703,425.307724011,-544.899518425,1215.92100422,955.242348872,-930.946147881,-686.911243803,1316.06702636,256.852710509,25.5851512483,963.128996844,597.545838272,598.627300293,20.5401541606,271.991705416,-456.842000035,-57.7387075222,-247.978112707,-122.105169015,-195.178032148,-34.6562190801,378.723354509,-247.442657728,480.787590245,-21.4400120943,-51.7192188004,-12.8821042687,-50.0158466405,-90.0525241559,77.4296145092,27.7576006347,69.8669422261,50.9056130887,33.5073555936,-52.3897009475,77.7481876032,-141.350761764,-32.3156274724,-13.5994582483,-3.06969188173,10.8082784594,62.3883104191,-2.60996492844,34.7814352297,61.4866374937,-13.6345587044,-7.94071327476,-32.5558558993,16.7904145294,9.36776400155,72.2439264359,-54.5023072937,-22.9993065371,2.30705798952,-18.7731050515,-1.62250595851,4.01707830834,29.2887058238,-8.11646090736,17.5695355221,-4.01256431137,-2.1375720866,5.58908645637,-16.4895843866,-16.9749346227,18.9771168092,-2.83740094919,2.24626066493,-1.24244904859,17.7084113389,-6.64210129327,-3.10159181334,10.6824456468,-2.37852587811,-10.6143599525,-7.95654510252,-4.13145791436,5.24895177736,-4.35814183619,-2.46908774407,-4.31280301436,5.14579364409,10.2762445922,-6.33414253235,-2.92118406906,-0.49120037547,12.6809514827,6.84190823579,7.26813595358,3.79073222425,-8.95572435024,-1.5522921985,-5.02440989011,-7.04917487427,9.54474659056,-1.94247872498,-0.617917136978,0.125993224201,-1.21597428845,-0.987233205803,-3.35276855881,-0.886165719343,2.27793083317,-0.434618289049,-1.7992455502,3.11658036557,1.46220383807,2.43571451581,4.50766655128,1.26549929073,0.630013645971,-2.13139747222,1.70556929391,0.308017713305,1.56959800281,1.70363356481],[-32806.5898837,-3069.69673157,5757.45331112,223.368923529,2687.1773451,286.213589756,-385.13221561,1285.69303685,950.238269204,-1011.83940709,-624.455072401,1330.22807699,251.115110782,92.3288219987,943.943871331,630.836231527,595.028490312,68.7483707902,293.787618599,-410.225201822,-103.637442275,-235.575420247,-95.135372282,-179.187494157,-42.501450826,378.425318897,-260.605347589,484.089174741,-13.4523613131,-53.9486069362,-7.65131786984,-50.6620196423,-97.1322310608,79.3174645166,50.2336631348,63.1270802843,56.0840540636,28.2630387944,-63.589476765,84.7653801487,-130.911592037,-22.7702411881,-19.6177416384,-21.140332067,15.3421130375,62.2762018152,-5.98994271594,29.6842377674,64.9034330459,-16.4901917638,-8.80639748185,-31.9263938377,15.9634813155,12.1617051989,73.6573573501,-52.2948129471,-26.6722919803,-6.82354576044,-17.2626938535,-1.14766712554,-1.02618672381,26.2814063948,-16.0468763534,17.8440985106,-3.48526226078,-1.84269587761,4.49168304289,-17.7293737537,-18.3105597904,19.8967714228,-2.88815303862,0.798970060793,-0.921235443959,19.0215490493,-7.50429260522,-2.84376301937,10.2552584,-6.24700603085,-13.5972574943,-5.76111442595,-4.09490832099,5.56632783251,-4.46060777813,-2.55855372535,-4.08225389007,4.8924336557,10.1807041692,-5.71709482711,-3.04215373307,0.146628095393,13.6662725687,6.42337101117,7.96296169885,3.51153650083,-8.26485808269,-1.83169753677,-5.65775698629,-7.29153880566,10.4231668725,-2.11893398718,-0.584605304118,0.301406192339,-1.27766645351,-0.772475316598,-3.54207376516,-0.984469724211,2.58534015979,-0.698793952518,-1.37958045976,3.40802748369,1.71116016468,2.47499196724,4.55984866094,1.05760121981,0.525482703385,-2.01062047419,1.69001003617,0.730093366324,1.68527578936,2.28222906672],[-32450.9568391,-2944.03124675,5750.23266107,161.379237393,2743.29928391,142.767356377,-217.040129912,1291.25989896,965.598642177,-1078.5666122,-557.599651496,1333.56874316,223.004303672,147.054947521,935.839028425,659.784413395,588.235083222,113.675708069,328.463647636,-367.31490319,-146.075827009,-230.463375736,-70.5218225242,-164.202866839,-53.9829168812,375.202758464,-270.705905066,482.060277365,-5.98410298382,-58.7832251122,-7.97914305823,-55.0580065676,-101.067737189,86.2547868152,66.3923515307,53.2439872056,60.4964611151,23.3760517865,-72.9342775617,90.2883116351,-125.417012534,-17.2673617552,-27.9063482282,-36.6004857631,17.1563356681,63.3948380465,-12.6675297108,20.559659344,66.9884331594,-20.3125135286,-10.5445674476,-31.1725966331,14.7286466518,15.5713722226,72.4219709246,-49.4888069764,-30.386957229,-15.3654837318,-15.1266346929,-2.3942909515,-3.91420804132,23.8482881532,-22.5991521278,17.8027410684,-2.74353944298,-1.29348003181,2.83823097303,-18.6711151492,-19.5477860359,20.1953238593,-2.50205926991,-0.440412216752,-0.627801195604,19.9720580654,-8.66558788214,-2.5922420808,9.08216197658,-8.97890883528,-15.5490375506,-2.91153125534,-3.87820834426,5.96539684926,-4.47343425134,-2.54969925175,-3.52815897486,4.36800606734,9.77343361224,-4.94491735971,-2.98799570359,0.885111440135,14.4723702215,5.82035077264,8.42434922781,2.82929213531,-7.29997565242,-2.31504485718,-6.11966215955,-7.1710935656,11.3392209894,-2.29530384903,-0.476154625303,0.485586219423,-1.30282627094,-0.462103499321,-3.59851561211,-1.02517896065,2.80453214675,-0.95508320181,-0.844214485802,3.6199102674,1.95426199399,2.43069733285,4.46416365945,0.781433510317,0.400967818482,-1.78477227053,1.65561946438,1.13096658772,1.86257559864,2.80048943727],[-32215.2530019,-2804.32480827,5797.30149227,54.3298230394,2748.94243587,46.3500038333,-45.7333335597,1356.9048262,1032.60169644,-1127.20435948,-483.575809274,1353.21495289,185.007088482,261.574568373,936.482039037,689.99359947,587.822190213,144.35669248,375.013278411,-330.88055881,-168.592584214,-233.57806964,-44.5108868338,-145.181278785,-68.0479003316,370.776389398,-278.318044009,469.124940503,-7.50244085508,-54.1296964682,-10.834036374,-56.0457677711,-104.154233376,93.9979972163,69.190444393,42.7717134241,64.5952229599,20.4812104796,-80.6610520275,91.7867047857,-126.120049895,-17.4286868645,-35.2354638114,-50.4503585031,19.1599832288,65.8523904968,-21.2476633786,8.71251319351,67.841687677,-24.7005600311,-13.2243337613,-30.0646976755,12.6542145803,19.2822688459,68.1462462893,-46.3060625454,-34.2184822672,-22.7576878651,-12.9579702623,-4.21764244228,-4.32284160525,22.4595733699,-27.0227812891,17.4050576534,-1.73978404962,-0.548979099609,0.776722269631,-19.3929979104,-20.4958857881,19.8517150231,-1.77544526246,-1.38079247985,-0.36892355868,20.1882406727,-10.1971917197,-2.28295739953,7.19893971156,-10.2997301151,-15.7924963033,0.19815143929,-3.42830476959,6.45254954284,-4.41082291128,-2.39377309137,-2.63775248062,3.51757050623,9.00433444679,-4.02853828566,-2.75549765708,1.65970249705,15.0029801816,4.99479465077,8.56150398652,1.73605672796,-6.07462764794,-3.04811463095,-6.40603953991,-6.58956350944,12.2235719193,-2.4711457357,-0.279367691236,0.674839958248,-1.2824013487,-0.0508362800958,-3.48888753798,-0.987679304888,2.89074335839,-1.20242445527,-0.200565893098,3.71527752302,2.17716528198,2.29490166017,4.17143320021,0.433319835308,0.268817531794,-1.43944230708,1.59659968353,1.4695368995,2.10128264744,3.20427849716],[-32148.3062751,-2699.58147005,5826.44731825,-62.6308615531,2791.68532997,-88.8853415391,48.5793679126,1379.04591559,1105.33517554,-1170.36498691,-419.082403273,1402.77452667,132.946177147,362.766826528,886.564809532,729.316222365,594.92899785,160.936092856,419.671115315,-301.202578688,-179.945402549,-231.522534662,-13.6954565493,-116.632652962,-83.3466795863,368.462401197,-283.050146003,441.854459222,-15.6487135979,-37.2774019848,-8.83103945289,-53.3296682969,-108.19657071,101.75588065,61.0465348134,35.2429678986,68.6190262804,20.6748700941,-84.4653969937,89.5010512386,-133.296879211,-21.0651740575,-41.6721319203,-62.1168950389,23.1886231544,68.1982255784,-26.1355957264,-4.40265565133,68.0131914079,-28.7201698512,-16.7896551364,-27.9651380084,9.80542291087,22.8851187414,61.3902595329,-43.4375966193,-37.9609924811,-29.2346169563,-10.5070481479,-5.69749693211,-3.46021933194,22.8764669141,-29.5905453444,16.6949666527,-0.409438746725,0.300778926777,-1.44923446554,-20.0149707312,-20.8154063857,19.0336597893,-0.971503326441,-1.89432619201,-0.135291275782,19.3651853329,-12.0288089848,-1.75969462347,4.89293549573,-10.3811932202,-14.0973021581,2.86744402595,-2.69502187845,7.00023940338,-4.35533421062,-2.03959500779,-1.4393007205,2.28632069492,7.86200266893,-2.97243586379,-2.39680839459,2.37122787183,15.2316238351,3.94296527379,8.35583435268,0.297990111101,-4.68459926527,-3.9919824345,-6.5232213115,-5.52116842084,12.9447843589,-2.64678389673,-0.0048311099482,0.868387240431,-1.21170479433,0.444669654336,-3.21456548643,-0.866038421868,2.82616424478,-1.43814152812,0.509218119058,3.67608547026,2.36437716021,2.08245178116,3.65222402472,0.0157409245832,0.126326830131,-0.988440591477,1.51285072429,1.70265027505,2.41067017044,3.45042254184],[-32117.9365425,-2644.44928829,5905.61728547,-179.469746901,2861.40777728,-303.973038259,222.387242471,1430.91711709,1131.24582237,-1223.6335578,-354.167658101,1437.02344511,86.5360254684,422.190769883,804.058704491,767.20653588,607.132379324,175.697695704,463.375926186,-262.811538233,-207.534344448,-220.787675743,27.3139149414,-102.122900456,-102.174615142,368.367826918,-285.583008655,406.909716815,-18.3931353,-15.429321825,-5.10571473135,-50.3842152227,-112.02675777,115.833302222,47.9211802623,32.3421492916,70.4518240795,23.0295194007,-81.5644007485,84.6535521932,-144.644632151,-24.9975941747,-48.9161371347,-69.5150937292,30.0081075487,69.6183662333,-26.5389533374,-19.5260687832,68.0992018045,-32.28748446,-21.2926157115,-24.6887558715,6.59698112256,26.6613623975,52.9129802607,-41.2074313024,-40.8226425675,-35.4725136842,-7.21384325304,-6.43420603362,-2.69654793736,24.5746461822,-31.9532541141,15.7750789468,1.11555668619,1.12135409715,-3.71788716796,-20.616864374,-20.3316827494,17.9807802589,-0.20703426669,-1.92996939655,0.173685497466,17.6107966072,-14.0348594208,-1.04236118971,2.53855117558,-9.80970159686,-10.9302920663,4.58932378957,-1.66381063604,7.54750521653,-4.4188194843,-1.53941124874,-0.0153615984052,0.745142100142,6.4502550001,-1.78336648904,-1.93592867391,2.98216520875,15.1789981078,2.78057613542,7.90972060615,-1.42652332425,-3.21296554245,-5.04351808347,-6.49995730692,-4.07976566161,13.4181718832,-2.81228444874,0.3094028291,1.06933123453,-1.11818458122,0.984291211537,-2.82384020303,-0.687973737028,2.63255265172,-1.63949495242,1.24003930186,3.51296683265,2.53299763507,1.8303182602,2.93645286671,-0.446569014246,-0.0324302221557,-0.458047426337,1.41806312627,1.83046308465,2.78243831548,3.53057881529],[-31995.6590298,-2532.39676313,5946.45416133,-290.128441265,2888.03719749,-547.591647185,445.212360415,1494.50197025,1102.76302517,-1286.3220865,-317.704902412,1420.02377361,37.0614816072,431.770277063,710.452484533,797.742689521,616.576581619,195.006474262,505.623177781,-218.312966031,-249.885104312,-209.02322216,73.5652496503,-107.380182295,-121.076400459,367.331565258,-286.855057098,372.149454184,-13.1015801119,1.05136543227,-4.58949076894,-48.6692768714,-115.100956189,128.610284993,32.7075642048,33.2979642664,69.5933048961,25.5075607507,-72.2480395645,78.6424326678,-158.522207249,-28.9427086669,-57.1423046637,-71.6586017654,38.3403113688,69.4371082821,-25.2927434836,-36.6555783377,68.1472783397,-35.8461350073,-26.8104355833,-20.5193285778,3.35628454328,30.8262753871,43.3939045393,-39.9602074123,-42.2606404263,-40.9219330674,-2.9949263466,-5.8057399858,-2.49749049541,26.6656105577,-34.3585000073,14.6975233864,2.58120816581,1.75493432525,-5.85357111319,-21.1763081021,-19.1506733266,16.8309717374,0.509664337791,-1.57594759841,0.541460240357,15.2956459544,-16.0137965954,-0.0959257558928,0.375497858192,-8.85834468684,-6.97383832963,5.22992520317,-0.411986382546,8.00680557431,-4.70652887482,-1.00627643503,1.52497547784,-0.954317107374,4.92614741094,-0.538975087223,-1.40834443024,3.53846585141,14.8782187106,1.59068082374,7.378285165,-3.28461307154,-1.68316705496,-6.08606828337,-6.34092863752,-2.43450127658,13.5534269997,-2.95552474243,0.600966854858,1.27591467199,-1.03341039483,1.52141433776,-2.38266029143,-0.486539154916,2.32919253948,-1.7799411928,1.96815838462,3.24455862251,2.69556455553,1.57804181755,2.08538361405,-0.904618459247,-0.199441305848,0.114334240062,1.31957820684,1.87243811642,3.17351694594,3.46058072093],[-31809.1065246,-2400.32638817,5973.98191236,-427.959913559,2912.47378637,-749.016443319,603.560983129,1439.21612492,1074.56604632,-1373.27670044,-313.703594665,1381.92756057,-10.121267778,434.547034889,635.919976052,827.102525308,619.962298454,218.498389065,544.489968101,-174.101077489,-286.299587019,-196.06217039,108.637092747,-116.743646959,-139.76570296,363.248779856,-286.274360408,336.665145661,-1.99722338827,8.55807727676,-7.53124065005,-49.4123694575,-117.967979688,123.460993173,17.2087837517,36.355483237,65.9393845124,27.6007504449,-58.8356943976,73.2286669514,-174.365648544,-32.4641459356,-64.7881962176,-67.2101610547,45.819154861,67.2505701685,-26.4056897389,-53.812979066,67.9216599148,-39.6830500064,-33.0700596951,-16.0073441255,0.589692421357,35.0251642525,33.574558791,-39.4150933295,-41.4695158909,-44.5263934264,2.31235616263,-3.06445552902,-2.51382681498,28.3406646097,-36.3758612572,13.4425682853,3.79256252907,2.12858202768,-7.73088129301,-21.5324845014,-17.5129825007,15.6879683378,1.32168623127,-0.93292088289,1.08421645622,12.8708548388,-17.8480464767,1.22288003576,-1.2848318162,-7.5168377308,-2.84872809317,4.80813786587,0.988677286143,8.31659771329,-5.30377691164,-0.509899106687,3.11479727236,-2.69645520338,3.46286469869,0.695677089158,-0.834342796406,4.1146125554,14.3583794461,0.454161364453,6.90177098964,-5.05946223585,-0.0827877027358,-6.97951183611,-6.04681101392,-0.756150838523,13.2508274334,-3.05960858502,0.815338623851,1.472087996,-0.967578999109,2.01090174164,-1.94966779763,-0.285423458023,1.92919947626,-1.82433681965,2.68147976803,2.89026455517,2.85480841711,1.35702844276,1.16600549933,-1.31013762169,-0.357088081181,0.688123859143,1.22156676855,1.84004747318,3.5345100392,3.25985645401],[-31624.8851361,-2358.25510702,5944.05364707,-572.321111199,2948.15938215,-892.068685603,737.565657797,1301.45182186,1061.21863675,-1445.707583,-333.473727184,1319.42479749,-22.0298817864,481.399623974,588.6742326,855.070101762,623.773103419,240.750213158,584.384798188,-133.849054183,-319.241126498,-180.084605794,133.411754779,-107.748400134,-157.350721738,356.419591916,-281.467881887,303.614146688,13.9165874506,7.88424622967,-9.25269690286,-51.9936144997,-118.780032873,96.0199236218,5.26983890616,40.8134510895,60.7178471355,28.267600593,-44.003491734,71.5880185278,-190.732401565,-34.8579695093,-70.6257418524,-57.6469840277,52.9942997649,61.4489668497,-33.026659386,-68.7419240596,67.7894633578,-43.6899814,-39.6040329438,-11.2887276212,-1.15135743457,38.6886178491,23.6904839093,-38.9585535082,-38.5266609602,-45.1313381408,7.91037723305,2.43645492765,-2.78407541743,28.7116251148,-37.7251515003,12.1084275868,4.66479242576,2.21486175935,-9.15853250584,-21.5044692703,-15.6713640497,14.3910137512,2.402012687,-0.408400957556,1.99103227846,10.4290871879,-19.2748545885,2.95621671897,-2.17063346169,-5.89211226245,1.03284198531,3.2566540114,2.48815865615,8.45534252119,-6.29061653199,-0.037334268,4.71309788559,-4.38309362704,2.17190054193,1.90309736819,-0.297378351518,4.75679464408,13.5491608891,-0.518384096285,6.53132704016,-6.55738917624,1.58217579427,-7.57096435372,-5.63265199271,0.828989178444,12.4406790205,-3.11137285735,0.91931248567,1.63740279718,-0.901486149904,2.41623253984,-1.56887230205,-0.0951722376727,1.45355116135,-1.73630251661,3.35136118157,2.46316959019,3.01494013231,1.17245355053,0.257187764869,-1.63833933802,-0.477689776006,1.23465238409,1.14360755233,1.75926191835,3.81974035113,2.93410821365],[-31492.4881943,-2302.95779043,5930.3900264,-702.013759742,2942.36270645,-1011.02889015,935.12622787,1142.80221407,1044.19478484,-1486.05407887,-377.538983701,1260.04222349,14.5716016192,587.735566733,525.44758348,873.666544319,636.168572399,252.733782416,624.690146854,-107.189682706,-363.931184519,-174.185353318,154.753364084,-66.4649918706,-175.111834754,347.817968469,-265.133226405,275.455630623,32.6033439562,-1.17165170458,-7.91594131047,-62.506693683,-121.169513031,52.5333522657,8.31662246183,46.6862228646,55.2649487703,26.9728882489,-29.8230720758,76.1943283194,-208.055958785,-34.8851586167,-74.3709213381,-46.7678048327,58.9621377316,51.5646338008,-45.3727428579,-78.6725692328,68.3991308365,-47.5155248417,-45.731535797,-5.94213334839,-2.14668446756,41.2806444188,13.896172369,-38.4570702374,-33.8011754575,-42.3871049871,13.2735146483,9.91166557306,-3.64070585804,28.051450163,-38.3164754638,10.8061402574,5.08235865992,1.97311543782,-9.89912800554,-21.102380331,-13.7506650175,12.6734942476,3.782979777,-0.489458836486,3.36017368708,8.07319325643,-19.9073925868,5.0628621078,-1.97807797266,-4.21913522856,4.46478941038,0.441404277109,4.05634507202,8.36829422063,-7.78474433564,0.461653262353,6.28361132731,-5.8952508373,1.11247161167,3.10732553954,0.117826199428,5.47686973145,12.3641868832,-1.192371339,6.30695364774,-7.61335346616,3.26395283117,-7.75079720313,-5.12113834913,2.17337127462,11.1178940154,-3.09282182803,0.886783530888,1.73877669575,-0.81095849967,2.71369197452,-1.27221569164,0.0724914860338,0.938925239496,-1.48168419453,3.95374345068,1.97775007698,3.17750857357,1.02170652014,-0.548196904425,-1.89516106124,-0.558040026512,1.73894967297,1.10135052401,1.66138650975,3.98482706166,2.46390251287],[-31295.0818033,-2311.76842044,5883.91055175,-783.408464547,2962.16996595,-1093.47208858,1171.53588938,1015.35051502,1062.32268788,-1531.78384852,-435.82063584,1232.00370657,86.2441424421,708.850662124,418.058167566,885.213142327,658.94221163,265.334057398,640.89187602,-111.738087932,-404.44572231,-171.06489498,174.174208963,-42.4715917334,-196.969873172,338.030515785,-223.760180638,247.684405788,47.7620712011,-9.84976617485,-4.08795438918,-86.015749274,-128.729345047,0.566214536045,24.2657187022,53.655437653,50.5268177793,26.051601224,-18.8484177994,86.7993486378,-224.971122858,-31.6962300361,-71.0726477177,-34.7302095375,59.5665906592,35.8063871633,-61.2897775625,-79.7750528336,70.112101112,-50.3373227053,-49.5655442128,0.0220481014083,-3.26525406051,42.4235314386,4.61475312138,-36.7034876979,-26.6836583329,-36.2735933344,18.6288343002,18.195140999,-5.58723532364,27.8549454265,-37.7067840001,9.60397414554,5.18333458172,1.60122661412,-9.84682218225,-20.3409995162,-11.9511658735,10.5086327004,5.71595583857,-1.29309844568,5.34980314929,6.23850412889,-19.2157198788,7.44076671912,-0.245035107432,-2.5223426232,7.28244854943,-3.3176873799,5.68146281958,8.10582054129,-9.86365635173,1.02388996647,7.807353958,-7.15612296169,0.389589178156,4.36280891982,0.413472622436,6.34819948985,10.8465781835,-1.45788502053,6.33197481025,-7.99058113705,4.96567959632,-7.44603329898,-4.45599005196,3.00412299701,9.34781120249,-2.98343858136,0.732966725511,1.74673000344,-0.663931822563,2.88514057305,-1.10289034598,0.208889353421,0.412064456907,-1.01545156616,4.49601074601,1.47606614988,3.33735832004,0.926268594228,-1.15258863851,-2.06692292277,-0.628022917441,2.19975253888,1.08842806278,1.56432246702,3.97297234311,1.81073946622],[-31029.2518816,-2336.35849454,5818.49782661,-843.358614885,2962.10398161,-1215.37971353,1396.93251292,842.803248027,1111.80607433,-1595.62663149,-498.034770868,1210.47700764,120.045180645,834.029105211,280.088461539,892.204548723,692.847314726,272.793507175,618.858353394,-149.886974885,-428.332498472,-143.005005547,219.410742862,-52.9405485771,-223.853922973,330.100992778,-165.164326115,216.140291712,54.6034511291,-19.4475181328,-6.86245083331,-112.947841998,-131.077875411,-46.3081457771,46.6579391804,61.0940232031,47.3764676805,24.4778925809,-11.7610550034,97.5788542558,-240.088797207,-22.2952550031,-59.7296484731,-19.502493396,50.9693624067,16.8323079238,-79.5669810849,-69.65212764,73.09048034,-51.4479255882,-49.3979685405,5.55114902313,-5.64010846047,40.970868341,-3.89950229288,-33.8706007874,-17.4332736728,-28.4933355429,24.170978795,23.4221849608,-9.30486626511,27.8311835388,-35.5747554173,8.58114726783,5.28928168646,1.74570333937,-9.10159715308,-19.138046757,-10.7100160421,8.12322681454,7.5985443211,-2.99803738808,7.57639685414,5.11879039254,-17.3760595922,9.9904582152,2.5101157756,-1.07657336629,9.35035948879,-7.46156698548,7.30653341843,7.80222978356,-12.4343484485,1.6631983598,9.30872884351,-8.18889669411,0.0816134114697,5.62566090481,0.478548290724,7.20083654679,8.91597397011,-1.38904293792,6.5945426442,-7.64150058662,6.59047201292,-6.587529401,-3.6299087023,3.16989590898,7.29448858307,-2.77744143423,0.497074995608,1.66800777591,-0.425394417215,2.93511565447,-1.10250066901,0.298857083503,-0.120499787512,-0.339889064427,4.97139134265,0.910513526069,3.49720204905,0.884593017178,-1.49709824771,-2.15430037768,-0.697198886696,2.60068129468,1.14346901802,1.48879725196,3.72839596299,0.971518993019],[-30788.2800342,-2312.67508552,5786.30187143,-962.803335925,2979.60643828,-1388.49892262,1525.98616789,663.126294952,1176.87421625,-1693.40136508,-527.684836451,1199.27376099,144.906376765,912.534365462,162.060402325,906.210870526,732.73206859,256.508495568,593.862283527,-214.024105865,-431.262353313,-105.887843889,254.684439221,-93.134606754,-247.515155951,330.44579701,-106.223209434,192.318682161,63.6309543624,-25.6280539946,-28.523315549,-132.1498015,-128.09867233,-69.1410481769,65.3199380651,63.9531879943,45.5300354379,17.7129462251,-8.06447746225,104.476810499,-251.892544222,-6.12798624452,-42.0631157292,-10.5429518634,37.740345742,1.94265139151,-95.3383122407,-54.7597593499,75.2393351774,-51.8553335984,-46.6938227282,8.01944314639,-10.289436839,36.062539967,-10.1512972805,-31.2079505034,-9.22221401553,-20.3295888062,29.3504646057,23.8691592927,-13.921316338,26.7165014535,-32.1422443671,7.67241524858,5.32562487055,2.9615297901,-8.24686875347,-17.5353093941,-10.4486089905,6.33288824626,8.28866439291,-5.53145143316,9.29127863779,4.34566331029,-14.8964859243,12.8494832137,5.48753308099,-0.0363374679185,10.4132230985,-11.3088910852,8.72946409878,7.50535800866,-15.2422446729,2.24611302215,10.8006717201,-9.10971996062,0.263708371128,6.80290621141,0.340579011733,7.63915039029,6.49060335374,-1.14342214879,7.09184676469,-6.64365565982,8.13943122405,-5.19480606412,-2.72664963501,2.74683138186,5.28220369573,-2.5006276262,0.165553920224,1.52271469462,-0.0982023532088,2.87831473898,-1.28673598147,0.361998941586,-0.646224171485,0.505113058533,5.34871117168,0.211169265142,3.67421415543,0.86433583229,-1.5497163352,-2.17384600942,-0.717388399051,2.9564758575,1.28765653544,1.43561669975,3.28562274943,-0.012700092837],[-30649.13763,-2287.66289005,5805.21623251,-1122.77938472,2972.72527823,-1588.14472762,1578.64396953,549.600685896,1239.41029019,-1792.58120223,-538.262308483,1229.97130185,171.995720456,916.612166119,30.4855102851,929.803623213,774.595352376,207.045719326,555.333644873,-272.772391397,-417.817839957,-67.0434012898,290.95500099,-133.362699374,-256.353867615,339.077999652,-54.5639939936,185.611092545,78.4976400296,-24.4185621924,-57.3091986581,-146.322478114,-124.178898972,-78.4818974758,71.3991339096,60.5097613408,46.7801477355,8.90547924804,-5.23730823573,107.75594449,-259.117986136,17.5767304101,-24.0758526376,-9.68447999856,21.1138823958,-8.32900145769,-104.137834119,-38.8400918966,75.3955487834,-51.9911367746,-44.4162463391,7.44915539898,-16.0546465209,28.1619309747,-12.0770183744,-30.5717316531,-3.19385515501,-14.0362015853,30.9770248703,21.5287703576,-17.0221592641,23.7261135755,-27.8384986269,7.12987787083,5.2703407553,5.00380183787,-7.41783610171,-15.8438201827,-11.2626742501,5.76969570914,6.66267125303,-8.31099133652,9.81727797047,3.22702063663,-11.9173083353,15.805047495,8.55010789756,0.403338989864,10.3092754032,-14.2134019876,9.68917007976,7.2833348178,-17.9711377171,2.63577278346,12.1853036139,-10.0474023389,1.05314950965,7.68297847614,0.115763503354,7.2664156673,3.52519056025,-0.905330888141,7.71369752438,-5.06305838964,9.61320680915,-3.35961811984,-2.03888169975,1.87796902959,3.60646084863,-2.22036796588,-0.309165602664,1.35757086899,0.291744899285,2.72759502848,-1.64637545556,0.474273481829,-1.16420256711,1.48348503734,5.55514328086,-0.625908291773,3.84530065475,0.793970422169,-1.33941511531,-2.12692825318,-0.636091045894,3.27194249223,1.50466821901,1.35167607446,2.71833780734,-1.09562441488]])
    return models,coeffs

def get_arch3k():
    models=[-1000,-990,-980,-970,-960,-950,-940,-930,-920,-910,-900,-890,-880,-870,-860,-850,-840,-830,-820,-810,-800,-790,-780,-770,-760,-750,-740,-730,-720,-710,-700,-690,-680,-670,-660,-650,-640,-630,-620,-610,-600,-590,-580,-570,-560,-550,-540,-530,-520,-510,-500,-490,-480,-470,-460,-450,-440,-430,-420,-410,-400,-390,-380,-370,-360,-350,-340,-330,-320,-310,-300,-290,-280,-270,-260,-250,-240,-230,-220,-210,-200,-190,-180,-170,-160,-150,-140,-130,-120,-110,-100,-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,470,480,490,500,510,520,530,540,550,560,570,580,590,600,610,620,630,640,650,660,670,680,690,700,710,720,730,740,750,760,770,780,790,800,810,820,830,840,850,860,870,880,890,900,910,920,930,940,950,960,970,980,990,1000,1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,1110,1120,1130,1140,1150,1160,1170,1180,1190,1200,1210,1220,1230,1240,1250,1260,1270,1280,1290,1300,1310,1320,1330,1340,1350,1360,1370,1380,1390,1400,1410,1420,1430,1440,1450,1460,1470,1480,1490,1500,1510,1520,1530,1540,1550,1560,1570,1580,1590,1600,1610,1620,1630,1640,1650,1660,1670,1680,1690,1700,1710,1720,1730,1740,1750,1760,1770,1780,1790,1800,1810,1820,1830,1840,1850,1860,1870,1880,1890,1900,1910,1920,1930,1940]
    coeffs=numpy.array([[-35442.00185,-5581.93725,-2788.952135,-722.957971667,2384.25115167,-101.519988767,995.450500667,641.048914333,-744.9152325,-309.171524833,-699.663918,120.585123433,-473.928992333,-1072.994595,148.2877391,-404.370941333,-259.9676955,-276.835615667,296.054265667,-317.516778,168.8133075,121.297345,-76.5088868667,-680.843634833,-107.558298333,1.25702119,-38.8363388333,163.252904,-99.9489627167,140.5617345,-12.1732746,-122.214406167,-295.6268535,-8.83372448333,-34.16152625,-5.71226826333,32.6825645,8.20257266333,48.6089771167,-25.6492067833,47.2122755333,-23.7736568333,-54.078435,-66.4343332833,3.50893533667,-4.53771406483,31.24981385,-15.8208231333,7.01743350333,9.580563075,3.950929465,8.676137505,-6.976487835,10.5543420667,-6.413725175,-12.3141324167,-7.22647108167,8.64280564,-3.07368870167,16.4415188333,-9.89298240167,-2.95657417833,-3.936359395,2.86189283,-0.482910932333,0.139363821833,0.317727031333,-1.24698948167,1.180571905,0.06902060355,-0.448326519833,0.8903172585,3.92547785667,-2.03229955,5.08494030167,-4.12248995333,-0.693284893167,-1.99377857833,1.661652535,2.44255471833,0.432025898333,-1.04666304667,-0.202699857167,-0.4108860095,0.0400315327,-0.08716767415,0.433315240333,0.848772993833,0.798408043333,1.038761275,-0.624943841833,1.27984523333,-1.038802965,0.2421321085,-0.590293182,1.00735977183,1.15692575667,0.0683605878833,-0.227478181833,-0.0387326936333,-0.26990283,-0.0236197467833,-0.182476422833,0.0727217695833,-0.0565102939167,0.0727430715667,0.384737398167,0.254232192833,0.174623523,-0.0400560311167,0.267405362667,-0.1471133155,0.265869048667,-0.156947054667,0.447935138167,0.390135888,0.00143985193183,-0.03867022145,-0.07613102665,0.0468598583],[-35489.7856667,-5705.19769,-2973.12161167,-644.631576333,2389.179175,-186.660027167,1054.42426783,627.698023167,-780.554755167,-359.537901333,-735.4462295,169.712252333,-447.8563955,-1080.206295,201.37109,-431.501336333,-284.670885333,-284.980622667,324.683971167,-312.257783,202.0763605,141.397636833,-74.1190228167,-694.4898145,-115.052439833,-3.10426157833,-39.4541007,171.548959667,-103.521182733,156.960394833,-12.31258865,-125.8169885,-293.928888833,-19.9691173167,-27.7453858333,-5.66766976,33.2599684333,8.87754499833,49.3710700833,-28.7942642333,52.0252603,-25.56673815,-56.33090255,-62.1472817333,-1.41715976333,-0.452965437667,32.07160935,-16.7827305667,7.85462493667,10.041168825,4.211393995,8.41500247,-8.26246755,11.4413884333,-7.04941451,-12.8768106,-5.46200494667,7.40875026,-1.65048889933,16.5648282333,-10.54837262,-3.48871051667,-4.40000752167,3.14309023833,-0.387622049,0.144635814,0.198477135867,-1.50401523667,1.19401244167,-0.0715325668833,-0.436660176667,1.24811480867,3.71891543333,-1.65719136833,4.94477074333,-4.39446833833,-0.958055156667,-2.22456321833,1.748103975,2.56729456167,0.447922513,-1.03771877833,-0.216702818833,-0.430896963167,0.0574253927667,-0.134927439933,0.4085011725,0.914069352167,0.8099381425,1.02756916,-0.549956834,1.19653272833,-1.10287131167,0.15346496325,-0.645168150833,1.03351013333,1.20667054833,0.0659357542,-0.273931099833,-0.0556266908,-0.269125127167,-0.0257700813167,-0.179313518333,0.1003515682,-0.0715126790833,0.0691575267167,0.411270677167,0.235158851333,0.184569637833,-0.0309029442833,0.244705558833,-0.152141532333,0.242460051833,-0.165678284833,0.452104317,0.397077476333,0.000478544102333,-0.0613963062333,-0.0789632882667,0.05215680125],[-35583.6940333,-5806.150265,-3174.32576833,-576.0145085,2405.06938,-271.900787,1105.25801,624.526778167,-814.042917667,-406.4627795,-766.233414333,214.0442435,-421.9727755,-1082.57621333,253.330277833,-457.797096167,-309.687227,-290.879279,351.9044045,-307.102331833,237.307492,161.069428833,-71.9488595,-709.068710667,-122.684403167,-7.95022852833,-39.5263873,179.5812695,-107.0859655,173.683791167,-12.7781773833,-129.361550333,-292.7135445,-31.4914643167,-20.9896741667,-5.715497055,33.7107443667,9.62020640167,50.0563197833,-32.0113524167,56.8098365,-27.5450642333,-58.5557191333,-57.9284621167,-6.52533735667,3.81286325517,32.9580629667,-17.7063608833,8.693768305,10.5048152167,4.46361512167,8.11977768667,-9.61730726,12.30472905,-7.76050466333,-13.4414801167,-3.67311296333,6.11366977333,-0.173116437333,16.7266823333,-11.2165715333,-4.01090243,-4.86873576667,3.43534061333,-0.278650078167,0.1415682885,0.07036144945,-1.786478645,1.205576395,-0.232221610683,-0.42633419,1.619641305,3.49503852333,-1.275275429,4.81392957333,-4.68422931333,-1.22259835767,-2.45665793333,1.83279790833,2.69321274,0.466131703167,-1.02337536667,-0.233223960833,-0.450366127167,0.0730125403167,-0.180462101167,0.380864734,0.980451899,0.8236675065,1.01213959067,-0.4766547295,1.11278115833,-1.17508242,0.0640206148,-0.700628715,1.05978524167,1.25832593667,0.06232807605,-0.3197891045,-0.073261589,-0.267235379,-0.0281905027833,-0.174734133333,0.13031225505,-0.0854539043167,0.0659040936167,0.438809045667,0.215722355833,0.193964399667,-0.0228875718333,0.221001118667,-0.159598617333,0.219115791667,-0.175037358,0.456642284667,0.405036515167,-0.00117623470983,-0.0838758919667,-0.0820038736167,0.0577081305667],[-35713.3376833,-5886.34435833,-3385.1458,-517.086784,2433.56713833,-352.0980025,1146.26196167,629.186187167,-845.5770165,-448.850682333,-791.265895,253.586877667,-397.488647,-1080.31805167,303.306474333,-483.149496,-334.699463667,-294.741203667,377.658153833,-302.4495545,274.094730833,180.201855667,-70.2297263833,-724.331396833,-130.369359833,-13.2214337283,-39.2008968833,187.3165335,-110.7219005,190.535793,-13.5269462333,-132.920262833,-291.906611167,-43.34022515,-13.94430793,-5.83678123833,34.0417988,10.3893899633,50.6689259333,-35.2818833833,61.50690315,-29.6902352833,-60.7560654333,-53.7954316333,-11.78811662,8.22076827,33.8828014333,-18.5774408167,9.531413255,10.97096965,4.70511511167,7.79818054667,-11.0212073367,13.1323874333,-8.54604831667,-14.0046891333,-1.8798286105,4.76572949,1.34054717233,16.91313,-11.88867995,-4.51986355167,-5.339161355,3.73571137333,-0.156950957,0.132988193167,-0.0635820655333,-2.08806180333,1.21448389167,-0.413269399,-0.416427183333,1.99727096667,3.25686634167,-0.892977187667,4.6890333,-4.988225285,-1.48644982833,-2.68873716833,1.91391828833,2.81758651333,0.486137653333,-1.0042642055,-0.251042664667,-0.468843301333,0.0873280593333,-0.223301315667,0.350740553333,1.04773568133,0.837977268667,0.993495380333,-0.406901154167,1.02838202083,-1.25443894333,-0.0265198882167,-0.756448955167,1.085341845,1.31053788833,0.0573583310167,-0.364752572,-0.0915632098333,-0.264469530667,-0.0306665724167,-0.168884904333,0.162234004167,-0.0981099669833,0.0631881316167,0.4671578535,0.195829921,0.203053127,-0.0164187405333,0.196478735167,-0.1693110015,0.195695150833,-0.185005785,0.461300969667,0.413628449667,-0.00365054895667,-0.106035171883,-0.0851965823833,0.063368622],[-35870.7480833,-5943.48737333,-3594.62535833,-467.546035667,2476.63326,-421.140420833,1176.176555,637.8537635,-875.067105333,-485.4839875,-809.470894167,288.530638,-375.935891833,-1073.83301833,350.391336333,-507.400948333,-359.314621333,-296.669045667,401.911652333,-298.6415315,311.990488833,198.6456125,-69.1029871167,-739.852284667,-138.035261167,-18.8523912,-38.6037268667,194.713608833,-114.451331167,207.325397167,-14.5014906333,-136.5095945,-291.3677215,-55.4050176167,-6.66309564,-6.02044863667,34.2489867667,11.1414501167,51.20712175,-38.5711066833,66.0588328333,-31.96667575,-62.9156116667,-49.7497368833,-17.1577917833,12.7322097333,34.81574525,-19.3846027667,10.3629803583,11.4338180667,4.93027089667,7.455388995,-12.4530568333,13.9111834,-9.39911048167,-14.5592842167,-0.0983409153333,3.37619511833,2.87460618667,17.1092017667,-12.5546729,-5.01330340167,-5.80490580167,4.04163142667,-0.0241082056667,0.120860971167,-0.201110906017,-2.40322323,1.219240525,-0.614332948,-0.406110828667,2.3744757,3.00683094667,-0.5155130015,4.56652106667,-5.30146624,-1.74935277,-2.91786726167,1.98978660167,2.93815618333,0.507620888667,-0.9806656575,-0.268955151833,-0.486006322,0.10058004905,-0.263131932833,0.318131159,1.11542271333,0.8514499095,0.972202724333,-0.342166942167,0.942981154,-1.33934165833,-0.118477556533,-0.811878376833,1.10928684167,1.36217986833,0.0509298407,-0.408546942833,-0.110439269783,-0.260879788667,-0.03292286095,-0.161880059,0.1957189175,-0.10925531325,0.06106758735,0.496018696833,0.175358679333,0.211969775667,-0.01184693233,0.1712289945,-0.180972614,0.172043285667,-0.1954450355,0.465748777333,0.422516631167,-0.00705161036833,-0.127793544333,-0.0885347456333,0.0689593108333],[-36049.5548,-5974.30948333,-3790.37198667,-426.932349833,2536.05741,-472.696477667,1193.999145,646.350493,-902.209659833,-515.0211295,-819.5918405,319.197738667,-358.910852667,-1063.38552833,393.618092667,-530.350889833,-383.046232167,-296.669232,424.658692,-295.940881333,350.5891125,216.218559833,-68.6411001333,-755.114845833,-145.619507667,-24.7688213667,-37.8403157333,201.729597333,-118.241344833,223.870272667,-15.6276564333,-140.095672333,-290.915586,-67.5460485333,0.803513746667,-6.26258882667,34.3169065167,11.83009565,51.6646627333,-41.8272718,70.4067760333,-34.3211305167,-64.9996532167,-45.7801202167,-22.5723093333,17.3109813333,35.7255718667,-20.1134314667,11.1826006167,11.8822285,5.13064835833,7.094058205,-13.8897534333,14.6261738,-10.30655691,-15.0948387167,1.6590718895,1.9590783075,4.415395125,17.29971745,-13.2013823333,-5.488243085,-6.257427245,4.35083108,0.117712804,0.106548540683,-0.340824652667,-2.72709806833,1.21770309667,-0.834378814,-0.3948261145,2.74579571333,2.74706831167,-0.146851367333,4.442819075,-5.61726919167,-2.01065767,-3.139783905,2.05852503667,3.05266803333,0.530478992667,-0.952499588667,-0.285701446167,-0.501654704833,0.112597238167,-0.299767899667,0.282747191333,1.18265417833,0.862791300833,0.948463588333,-0.283506255833,0.856112165833,-1.42764363833,-0.2120996195,-0.865686077833,1.13055605,1.41217881833,0.04292478975,-0.450802120167,-0.129764575667,-0.256340524833,-0.0346226291667,-0.153795507333,0.230311316667,-0.118671664,0.0594563090667,0.524982996667,0.154128415667,0.220739101,-0.00945448497667,0.145258272333,-0.194170208167,0.147970290333,-0.206097644833,0.469552682667,0.431387752667,-0.0115093428317,-0.1490154075,-0.09202620365,0.0742893632],[-36247.5594167,-5977.77682667,-3962.23209167,-394.976575667,2612.92780833,-501.462581667,1198.26345667,649.6495225,-926.465093333,-536.126961333,-820.588897333,345.790271167,-348.196947,-1049.2587,431.805891,-551.688110167,-405.3512735,-294.752203,445.869634833,-294.607768833,389.425031,232.633359,-68.8637633167,-769.588827667,-153.0358275,-30.8834616333,-37.0031166333,208.3182695,-122.044499333,239.963542833,-16.84954915,-143.612832667,-290.358986667,-79.6174087333,8.39923317333,-6.56038911,34.22739555,12.4128266667,52.0348555,-44.9926485167,74.4861323167,-36.6960977667,-66.9629838333,-41.8730197667,-27.96701725,21.9152342167,36.5807144167,-20.7477825833,11.9815864833,12.30288275,5.29805379,6.71646446667,-15.3064352833,15.2617918667,-11.2520431333,-15.59927305,3.380554715,0.527855641,5.94710612333,17.4691738833,-13.8148464833,-5.94065626667,-6.68751050667,4.66007846667,0.265971247667,0.0912494332333,-0.481547775,-3.05456733167,1.20790538333,-1.071651374,-0.382276307667,3.10590038333,2.47900596667,0.208587855833,4.31433118667,-5.92878516667,-2.26904997333,-3.34977414333,2.118053025,3.15858929833,0.554531938833,-0.919604630333,-0.300104551833,-0.515649478833,0.123131783167,-0.332925817167,0.2442801665,1.24831830167,0.870720593167,0.9221731325,-0.232007953333,0.767311772667,-1.51726365833,-0.307361316667,-0.916487028,1.147972585,1.45931674167,0.0332450222,-0.4910865685,-0.149354390667,-0.250673404167,-0.0354516041167,-0.144707487667,0.2655004895,-0.126123586833,0.0582078760167,0.5535648705,0.131947487333,0.229307808167,-0.00951280687333,0.1185655931,-0.208545557667,0.123363849383,-0.2166672645,0.472233771333,0.439881508667,-0.0171311504833,-0.169532129833,-0.09566989925,0.0791720431667],[-36474.5991667,-5954.47642833,-4094.28508833,-369.495537833,2707.18263333,-503.318101667,1185.60329,635.735725167,-946.20434,-547.887187333,-812.280218167,367.8397755,-346.779519333,-1032.78749,464.0370485,-570.959103333,-425.680618167,-291.058905333,465.437325667,-294.753224667,427.660163333,247.421761667,-69.3254939,-783.114562667,-160.224521833,-37.0579788667,-36.1511161,214.455011833,-125.7062625,255.322551333,-18.2362394167,-146.849589667,-289.630705,-91.5641538333,16.0533230567,-6.92580550333,33.9747985167,12.86377815,52.3222095167,-47.9959329333,78.2255564833,-39.0604948333,-68.7415589333,-38.0348754167,-33.2987883,26.48671895,37.3891704333,-21.2641029833,12.7481611,12.6798268833,5.42485633833,6.32699197667,-16.6821811,15.80449565,-12.2157488167,-16.0629841167,5.05446063667,-0.903739335167,7.44515757167,17.6170414333,-14.38053645,-6.37022377333,-7.09074125,4.96583289833,0.415857167,0.0747233159167,-0.621997875667,-3.38238899667,1.18928193333,-1.320880145,-0.369727292833,3.45025394667,2.205409265,0.5436090325,4.18054530333,-6.23026398333,-2.523408255,-3.54435677333,2.16719045667,3.25567405333,0.579714388333,-0.8822747665,-0.311446449,-0.527925004667,0.131650429667,-0.3618519135,0.203152822833,1.311063995,0.874112148,0.893361448667,-0.189168974833,0.67638894,-1.60683535333,-0.403496078667,-0.962844547833,1.16072661667,1.503249155,0.0218989694933,-0.5295565495,-0.1689150465,-0.243625727333,-0.03509498865,-0.134745520167,0.300775967333,-0.131284444833,0.0570739387833,0.581310663,0.108664811267,0.237496433333,-0.0122170554733,0.0911400651167,-0.2239755305,0.0985391685833,-0.226720679833,0.473383314333,0.447789043,-0.0239387344167,-0.189371699,-0.0995511809667,0.0836155784833],[-36740.4017833,-5912.34587,-4178.92681,-347.605562,2814.6869,-478.952039333,1150.53458333,592.630460667,-960.037500833,-550.700915667,-795.677928167,384.513671167,-356.680574667,-1014.32192417,489.9543495,-587.968359833,-443.587404833,-285.708192,483.349539167,-295.958687833,464.898224833,260.075563,-69.58609835,-795.9126095,-167.195869833,-43.0610612667,-35.2135995167,220.173504333,-128.956032667,269.7881665,-19.95992615,-149.642159833,-288.778755,-103.402643133,23.7974896,-7.36838684,33.5932516333,13.2038256167,52.5408188,-50.7732432167,81.5719689667,-41.41716905,-70.30309965,-34.2846664,-38.54479455,31.0095872,38.1933512333,-21.64994985,13.47764385,13.0015093667,5.50906867833,5.92908810833,-18.0084063833,16.2387249333,-13.1796850167,-16.4876056833,6.67175343333,-2.323601244,8.89603764,17.7564354833,-14.8899129667,-6.78482724167,-7.46462210667,5.26656431333,0.560702106167,0.0548914612833,-0.7613929655,-3.710751325,1.15899112833,-1.57460679833,-0.360636956,3.77529945667,1.929746915,0.853242306,4.04407136667,-6.51807513833,-2.77592208833,-3.72084884833,2.20629612667,3.34517483,0.606051865667,-0.841668442,-0.320097683667,-0.538380277833,0.137431621167,-0.3866312245,0.160511216,1.36951543833,0.871854554833,0.862223550833,-0.156032864167,0.583580744833,-1.69566478833,-0.500452604333,-1.00358948967,1.16859962,1.544351575,0.00871803687667,-0.5668845195,-0.1882539515,-0.235057815167,-0.03347845785,-0.124008015167,0.335799377,-0.134011914,0.0558289912333,0.6079077325,0.0841234713,0.245083490167,-0.0176785723167,0.0630318945167,-0.240544038833,0.0737177482,-0.2359030615,0.472673963833,0.455129185167,-0.0319801804,-0.208786775333,-0.10376161345,0.0877845969333],[-37045.5639,-5867.868215,-4223.502395,-328.115879,2928.96513833,-433.617065833,1088.60058667,514.576705167,-967.936185167,-545.3408055,-772.297829,395.643472667,-377.4442565,-992.675421833,508.974971667,-602.89921,-458.62486,-278.629016333,499.794812667,-297.216035833,501.368530167,270.008263667,-69.4323546333,-808.213957667,-173.998381667,-48.6409635667,-33.9978129167,225.532599667,-131.4640765,283.368006833,-22.2094033833,-151.921157667,-287.845820667,-115.130989,31.7430940667,-7.88430209333,33.1229995,13.4875719167,52.6993188333,-53.2777086833,84.49728535,-43.7709740333,-71.6407482,-30.63968175,-43.6764880667,35.5124270667,39.03606255,-21.9008283833,14.17280165,13.2570425,5.55231243167,5.52255212,-19.2859423167,16.5464315833,-14.1257545833,-16.8796585333,8.22361637667,-3.71923805167,10.3037250467,17.9011821833,-15.3378136,-7.19465520833,-7.80609695333,5.562574425,0.6936895605,0.0283935112567,-0.899806354167,-4.04194717833,1.11102740833,-1.825124525,-0.3591308715,4.077627995,1.65544023167,1.13767945917,3.90837124333,-6.78949042333,-3.030568865,-3.87678293333,2.23577721667,3.42791211333,0.633775887,-0.799056285667,-0.3272623055,-0.546966145667,0.13962225,-0.408567533333,0.117659051967,1.42224151,0.862971538,0.829019837,-0.132608758167,0.489603192,-1.78330871833,-0.599098276667,-1.03788543333,1.17136804167,1.58290449333,-0.00648443512667,-0.603735199667,-0.2072240235,-0.224871832333,-0.0307661761333,-0.1125658935,0.3703260395,-0.134440562,0.0543123309333,0.6330498345,0.05824857345,0.251894024,-0.0259573133,0.0344656864767,-0.258421776,0.04876481425,-0.244011554,0.469756128833,0.461967888833,-0.0412711300667,-0.228076134,-0.108360597,0.0918146173333],[-37384.3491,-5823.80573833,-4234.0812,-310.266868833,3049.20752833,-372.075804167,998.2498745,399.143892167,-970.501715833,-531.645897167,-743.547153833,402.437948167,-406.838837,-966.580568167,521.168540167,-616.0735265,-470.474513,-269.7311905,515.2467475,-297.071178,537.238613833,276.996811333,-68.6764043667,-820.112812833,-180.671319667,-53.6628212167,-32.3030328,230.57991,-132.871072,296.038328333,-25.06396575,-153.615588333,-286.800841667,-126.746993667,40.0281738167,-8.45863132833,32.5748746667,13.7729389667,52.7798094833,-55.4792595,86.9670235833,-46.1114884,-72.7394876333,-27.0992886833,-48.6679559167,40.0409936333,39.9448893167,-22.0085583667,14.8378174167,13.4345428833,5.55690695167,5.09880383833,-20.5202187333,16.7093693833,-15.0377780833,-17.2412259167,9.70228447833,-5.07956133167,11.6794146167,18.0552404833,-15.7162400167,-7.61060756833,-8.113303985,5.853647575,0.809771735333,-0.00823365217333,-1.03827885167,-4.37789605167,1.03955582783,-2.06600781667,-0.368264456333,4.353120985,1.38593590667,1.39903956,3.773493955,-7.04036434333,-3.292029325,-4.01068650833,2.255710095,3.50378066667,0.662957835667,-0.755118892167,-0.3343007375,-0.5534087605,0.137803101667,-0.4290349415,0.0757909109333,1.46774020167,0.846277960667,0.794222604167,-0.118680201833,0.394541433,-1.868871175,-0.700638252167,-1.06536153,1.16861148167,1.61865108667,-0.02391263453,-0.640796276333,-0.225647259333,-0.212916894667,-0.0271807952667,-0.100368441683,0.404177598667,-0.132788445667,0.05244954705,0.656270819,0.0309794084017,0.257813815667,-0.0371707873667,0.00568989445667,-0.277686625,0.0234521596867,-0.250950775667,0.464199592667,0.468187907167,-0.0518394237333,-0.247592710667,-0.113364554167,0.09578048425],[-37749.2457,-5778.49174333,-4216.12141,-293.517024667,3174.200275,-298.523716667,878.096659167,245.766716683,-968.5523435,-510.000662833,-710.773643,406.058660167,-442.412296667,-935.232018167,526.794269167,-627.825609333,-478.985789167,-258.985305833,530.099154333,-294.213661667,572.4911405,280.869427667,-67.21726945,-831.7109515,-187.226690167,-58.0128536167,-29.9606830833,235.329599833,-132.9015965,307.747742667,-28.5982257333,-154.681642833,-285.610707333,-138.2444385,48.77282,-9.065483625,31.9646529833,14.1112489333,52.7589475,-57.3663466833,88.9527025667,-48.4315792667,-73.58573605,-23.6652633667,-53.4925772167,44.62824385,40.9387566167,-21.96908,15.4775536667,13.5259351,5.526021465,4.6501804,-21.7153864833,16.71414245,-15.90171845,-17.5719121167,11.098235375,-6.39397067167,13.0296366167,18.2181737167,-16.0190590167,-8.04110131,-8.38568976167,6.13868399,0.905064107,-0.0573978752767,-1.17709032833,-4.718332645,0.940228754667,-2.29139023167,-0.389842160167,4.59725781667,1.124661175,1.63844983,3.63844237,-7.26692260167,-3.56355607833,-4.12197617167,2.26641585167,3.57225254667,0.693310007,-0.710426859333,-0.3422763075,-0.557254248,0.132221974167,-0.449233843,0.0361320117493,1.5048041,0.820633265,0.758426093167,-0.114067044167,0.2984235205,-1.95144359,-0.8057603085,-1.08605257167,1.16010083333,1.65113267333,-0.0437550116833,-0.678607149,-0.243392990667,-0.199116581167,-0.0229446751833,-0.08736918345,0.437233471667,-0.129337431167,0.0502516671333,0.677111925333,0.00232560275667,0.2627801265,-0.0513672608167,-0.02299235924,-0.298362432,-0.00232811735333,-0.256728744667,0.455662149833,0.473619237,-0.0636928464833,-0.267617379,-0.118751812833,0.0997358391],[-38130.7557667,-5724.81029833,-4171.63465667,-278.3908435,3297.45965,-214.706508667,726.509912333,59.7094039,-963.606800667,-483.502007167,-675.179410833,406.6580625,-482.301314333,-899.583873167,526.235664333,-638.605481333,-484.642278333,-246.657804833,544.302468667,-288.372913,606.665897833,281.4184805,-65.2507007167,-843.3859,-193.631852833,-61.6057313167,-26.9432182667,239.725396,-131.667414833,318.467481,-32.936935,-155.202446167,-284.352594333,-149.624608667,57.99152555,-9.64789598333,31.3488180833,14.5278699167,52.6293167,-58.9938782667,90.4849486167,-50.7519907667,-74.1928291833,-20.3679393333,-58.1284746333,49.2501374833,42.0212755333,-21.8006200333,16.1039853833,13.5415194667,5.466936265,4.18079749167,-22.87057575,16.5719396,-16.7135266,-17.8693795167,12.3985321,-7.65309961667,14.34181625,18.3859432167,-16.2538636167,-8.48538494833,-8.62852270833,6.41612687,0.979413568833,-0.117285286517,-1.31372721,-5.05622187833,0.814288918333,-2.49738137167,-0.421590776333,4.80657516333,0.8756688845,1.85294907333,3.50298307667,-7.47034762333,-3.84295661667,-4.21379551,2.27010413167,3.63325845667,0.723673045667,-0.66570345,-0.351050556833,-0.557991243833,0.125225251,-0.470032191833,6.45690473333e-05,1.533985245,0.785699434333,0.722882343,-0.118767713833,0.202019945,-2.03112595,-0.913068125833,-1.10154659,1.14694793333,1.68020250333,-0.0659747077833,-0.717290512167,-0.260626909333,-0.183783366333,-0.0182367330333,-0.0737058396,0.4696600255,-0.124674518667,0.0480116525833,0.695523253167,-0.027420035665,0.267001290333,-0.06827996945,-0.05104684095,-0.320425340167,-0.0281402154467,-0.261768636167,0.4444177735,0.4782329565,-0.0767195504167,-0.288183574333,-0.124440091667,0.103704310917],[-38523.9544667,-5662.57676167,-4102.79620667,-267.550258,3412.01585333,-121.078347633,543.783388667,-150.361968483,-957.261841667,-455.040165,-637.6197275,404.08178,-524.863519,-861.127970833,519.254026167,-648.695495667,-487.974837333,-233.062226333,557.485253333,-279.715631,639.148668167,278.4027945,-63.0241501,-855.373095333,-199.801677167,-64.4117129833,-23.2746604667,243.6436605,-129.397830167,328.161177667,-38.1580208,-155.273019833,-283.100595333,-160.8649475,67.6121548167,-10.1473593667,30.7749887333,15.0358179667,52.3906288833,-60.4180856833,91.6036818333,-53.0833146,-74.5725141,-17.25606355,-62.54970665,53.8564470833,43.1749558333,-21.5147303667,16.7257427,13.4960581833,5.38792712,3.70118026333,-23.9768798333,16.2980177,-17.47214145,-18.1289534667,13.5843330333,-8.84891532833,15.6003933333,18.5496329333,-16.4281165167,-8.93604908,-8.84813990333,6.68345827,1.03503914983,-0.184542022667,-1.44475243667,-5.38222806833,0.663978318,-2.68180473,-0.460264033333,4.97760826333,0.642528292333,2.03971752333,3.36743896333,-7.652628415,-4.12559809,-4.28987763833,2.26824185,3.68648921,0.752836776833,-0.621434126,-0.360088262833,-0.555327425167,0.119309711,-0.492190530833,-0.031113497984,1.55605525333,0.741621798167,0.688932454833,-0.132791180333,0.10663324575,-2.10827373833,-1.02070900933,-1.11368188667,1.13023535833,1.705618505,-0.0901415282667,-0.756637207333,-0.27749328,-0.167391671333,-0.0132515463667,-0.0596141622167,0.501560929167,-0.1194274265,0.0461863875833,0.711460668333,-0.057832725,0.270765441167,-0.0876665625833,-0.0778574351333,-0.3438184845,-0.05351809905,-0.266549406167,0.430862731667,0.481983055167,-0.0906781844167,-0.309193366333,-0.130359731667,0.1076013],[-38924.20805,-5594.00291833,-4011.85853333,-263.907565833,3510.70964,-17.7196821167,330.596894533,-375.499616333,-950.977527,-427.3253095,-598.69679,398.069425333,-568.5313795,-821.334370333,505.390575833,-658.266192833,-489.463521167,-218.441868167,569.157332333,-268.465321667,669.289867167,271.5448795,-60.7749091667,-867.774772667,-205.624658167,-66.4088371333,-18.9727890833,246.918003,-126.325059833,336.771827833,-44.32632515,-154.968650167,-281.891485833,-171.922348,77.5430121,-10.5086403,30.28345845,15.6458381667,52.0348781667,-61.68687065,92.3418767833,-55.42876085,-74.7259548833,-14.37721155,-66.72411995,58.3894439667,44.3738808833,-21.11798685,17.3473387,13.40305945,5.29642935833,3.221546185,-25.0211636167,15.9061162167,-18.1754238333,-18.3430317833,14.63487695,-9.973344355,16.7886700167,18.6973241667,-16.54670385,-9.383455545,-9.049950605,6.93696756333,1.07446042,-0.2558997615,-1.56655293667,-5.68616829833,0.491465211333,-2.842676135,-0.502451742833,5.10648757333,0.428273736167,2.19600963667,3.23173669833,-7.814842895,-4.40600592,-4.35342401167,2.26167850167,3.73104796333,0.779538442,-0.5779378725,-0.3688777475,-0.548922932167,0.116892451333,-0.516387921333,-0.05617430485,1.57154559,0.6886004805,0.657705610833,-0.1561055475,0.0136093405167,-2.18302155833,-1.12669366333,-1.12411454833,1.11078446667,1.72685398167,-0.115740123317,-0.796274452833,-0.294056587333,-0.150404446333,-0.00820993565333,-0.0453141956167,0.532941701667,-0.114194199167,0.0452484106167,0.724756628833,-0.0884467471667,0.2743000195,-0.109295382367,-0.102793675083,-0.368451477,-0.07800756275,-0.271498522833,0.415324786167,0.484739557833,-0.1052905353,-0.330481403667,-0.136431256,0.111304508167],[-39323.0308167,-5519.30115667,-3899.237465,-269.9657825,3586.09551667,94.0120063667,88.5263193,-607.320905667,-946.295390167,-402.944391833,-558.9476305,388.420936667,-611.506605167,-781.662267667,484.228028333,-667.396590333,-489.516519,-202.921153667,578.885613333,-254.8586925,696.552100333,260.6498775,-58.7328919833,-880.5204105,-210.9587285,-67.5828142333,-14.0518459367,249.378739833,-122.689883833,344.234390167,-51.4771790333,-154.353602833,-280.722525667,-182.733343333,87.6824455667,-10.6812816333,29.90636975,16.367784,51.53957115,-62.83896895,92.7263355167,-57.7805722833,-74.6461212667,-11.7585501983,-70.6242864,62.7918445333,45.5820979167,-20.6169772167,17.9698885833,13.2745154167,5.20109625833,2.74844178167,-25.9867695667,15.4106553833,-18.81833325,-18.50150465,15.5331980667,-11.0191652883,17.8891624333,18.8147918667,-16.6114568167,-9.81696504167,-9.23728678833,7.17211373333,1.100172845,-0.328326685167,-1.67564347333,-5.95738602167,0.298778674817,-2.97816099,-0.544647143667,5.18892385833,0.235009784333,2.319246845,3.09437858833,-7.95734541667,-4.67797199,-4.40765847167,2.25119592833,3.76539039333,0.8023449955,-0.535402137667,-0.377126649,-0.5384113975,0.120424167667,-0.543496749667,-0.07417139845,1.580759925,0.62672772,0.62981815,-0.188453892333,-0.0760047680167,-2.25527610833,-1.22891693,-1.13428366167,1.08906649167,1.74310926167,-0.14229416,-0.8357607075,-0.310344437167,-0.133224134667,-0.00334905753167,-0.0309957145333,0.563753235,-0.109571517667,0.0456233937333,0.7351291735,-0.118795314833,0.277752466333,-0.132911743833,-0.1252329195,-0.3941740545,-0.101154764217,-0.277009264833,0.398085629333,0.486278398833,-0.120243859167,-0.351781367333,-0.142565532333,0.114689581667],[-39705.1176667,-5439.63857167,-3766.29561,-286.2234835,3630.42518,211.327159083,-180.090695967,-838.590758833,-944.452937,-384.050618667,-518.710026833,374.985344667,-651.780123,-743.452802333,455.343900833,-676.0419735,-488.337677667,-186.465322167,586.3181315,-239.086909333,720.5391435,245.623715333,-57.0737668333,-893.338917833,-215.6447735,-67.8977957833,-8.52495509667,250.870250667,-118.71702,350.479295333,-59.5941402833,-153.463608,-279.532662833,-193.2034425,97.93471185,-10.6261823667,29.6695617167,17.20496355,50.87503005,-63.9006428833,92.7781039,-60.1099054333,-74.3146944,-9.397990185,-74.2229329333,67.0165515167,46.7535412167,-20.0127218333,18.5898276,13.1197088333,5.10965851333,2.286929335,-26.8549669167,14.8274383,-19.3903185333,-18.5919328,16.2693922167,-11.9790236333,18.8877424333,18.8852702833,-16.6175048667,-10.22553185,-9.410132515,7.383545485,1.11415290167,-0.399363196333,-1.76821928667,-6.18581159833,0.0883948431,-3.08640094,-0.583488484333,5.22115027333,0.0638783472833,2.40838645333,2.95222454667,-8.07814968833,-4.93500915,-4.45495695167,2.23724432333,3.78748834833,0.819742722333,-0.493960563,-0.384695399667,-0.523365627667,0.132046015833,-0.574295188,-0.0846309354,1.58375775,0.556177885833,0.605266385833,-0.228994802333,-0.161589217483,-2.32416796,-1.325399115,-1.145003595,1.06500326333,1.75343499167,-0.169427530667,-0.874576393667,-0.326323370833,-0.116183978883,0.001137390135,-0.0168365940767,0.593841533,-0.106059232667,0.0475828055167,0.742226637,-0.148400526333,0.2811524805,-0.158165699333,-0.144615942167,-0.420629536,-0.122607314833,-0.283291717667,0.379277685833,0.486346031167,-0.135240830833,-0.372719322,-0.1486739035,0.117622714833],[-40038.0647167,-5366.84027833,-3625.41598833,-305.266173167,3636.17255167,330.925134,-472.592052167,-1064.8224095,-944.770945167,-371.403682,-477.451743,358.048072,-687.6469195,-707.208218,418.284675667,-683.9621375,-485.5598195,-168.685357,591.281800333,-221.174414667,741.163606833,226.545088,-55.7686509333,-905.662989667,-219.582998333,-67.2100930333,-2.35808284,251.278947167,-114.540586,355.51372,-68.5257198167,-152.2380735,-278.077629167,-203.195642833,108.277133133,-10.34193453,29.59563625,18.1444462667,50.0183174167,-64.88125885,92.53349965,-62.3344018,-73.6871241167,-7.22003581167,-77.4800523,71.0618910167,47.8333,-19.2812666833,19.1932386833,12.93995955,5.01909125333,1.84334256167,-27.6104114833,14.1762977667,-19.8695039,-18.5985549833,16.8558770333,-12.8466227833,19.7906716167,18.8858733,-16.5430512833,-10.5996899833,-9.56225960333,7.564790895,1.11639379167,-0.4692516085,-1.83993486333,-6.36507721833,-0.135218216683,-3.165895645,-0.616133265833,5.2046,-0.0864612348667,2.46946226833,2.79929027333,-8.167700845,-5.17216055,-4.49366486333,2.21878764833,3.795436485,0.830580341167,-0.453733684667,-0.391569142667,-0.503118282667,0.152479453667,-0.608587417667,-0.08837035015,1.58035591833,0.477893941667,0.582874684333,-0.275036401167,-0.243605400833,-2.38635953,-1.41513821,-1.15531384333,1.0374359,1.75711699333,-0.197046280833,-0.9120495395,-0.341753743333,-0.0994706950833,0.00522705383,-0.00294099035667,0.622789561667,-0.103805988667,0.0508614494,0.745769926833,-0.176820210333,0.284211198167,-0.184390207667,-0.1607311105,-0.446866407833,-0.1424724615,-0.2899351965,0.3584935255,0.484869523,-0.150207996667,-0.3928415335,-0.154697646833,0.119913767333],[-40292.4345167,-5317.63175833,-3496.89308167,-318.3962635,3594.64765,446.888944833,-785.424909,-1283.03409833,-945.7520405,-365.600566667,-434.885895667,338.43657,-717.924192667,-672.945812333,372.642863333,-690.692264667,-480.630476333,-149.073048167,593.7275485,-201.2160655,758.5069095,203.567729333,-54.73024025,-916.743147333,-222.653854833,-65.3262175667,4.53458870333,250.490885667,-110.2725935,359.381764167,-78.0666115333,-150.577366667,-276.0134825,-212.553735833,118.6999095,-9.83963369833,29.7080197167,19.1776879,48.9384788667,-65.774282,92.0313978667,-64.3505279333,-72.7039507333,-5.118630175,-80.3503642,74.9331873333,48.7596605667,-18.3916886333,19.7593234167,12.7332465167,4.92330801,1.42198568333,-28.2332747333,13.4758504,-20.2293414667,-18.5022971833,17.3113796167,-13.61662015,20.6083470167,18.7899647,-16.3611222167,-10.9289007,-9.684800055,7.707858675,1.10596353167,-0.539476482,-1.88639522333,-6.48865745333,-0.367812847667,-3.21503451667,-0.639720802333,5.141545825,-0.21846898105,2.51037844,2.62838186833,-8.21388924833,-5.38399600167,-4.52051865833,2.19413916333,3.78707114167,0.8337457595,-0.414861024167,-0.397891484167,-0.476827139833,0.182003189833,-0.646037112333,-0.08655006645,1.57007747833,0.392834810833,0.561029866667,-0.323305754833,-0.322847700333,-2.43765403,-1.49709928167,-1.16364332833,1.00478951717,1.75339028833,-0.225153697333,-0.947336607,-0.3562598275,-0.0832215909167,0.00893070640167,0.01063677529,0.649985243333,-0.102866474667,0.0550508276333,0.745372818,-0.203643737167,0.286521796667,-0.210812733833,-0.173465947,-0.471729678,-0.160934750667,-0.296337387333,0.335133484167,0.481802832833,-0.165147970333,-0.411606776333,-0.160574945833,0.121330683833],[-40456.6514167,-5320.87441833,-3408.507665,-320.235155,3495.47900667,550.228523333,-1111.95915517,-1491.39145667,-945.359283167,-366.993395833,-391.301395833,317.496618333,-742.670459333,-640.769943333,317.517680167,-695.318146167,-472.895383,-127.129147333,593.561846,-179.7256435,772.749222167,176.830452167,-53.7221503833,-925.5295885,-224.646542667,-62.0547820833,12.27292868,248.362361,-106.057384833,362.1909295,-87.9574406833,-148.302279,-272.919410667,-221.104868,129.1417565,-9.140087355,30.0251226,20.3093073167,47.6025875833,-66.5454023667,91.32352785,-66.0365093667,-71.2804322,-2.98407700917,-82.7862956667,78.6282204333,49.4587351333,-17.2955254833,20.2569701167,12.4979297833,4.81876445,1.02754113967,-28.6910914333,12.7429287833,-20.4417211333,-18.2796136833,17.65312455,-14.2854659667,21.3549722333,18.5674412,-16.0383187,-11.1984483167,-9.77029804167,7.80246019333,1.08245921,-0.6116085795,-1.90362959167,-6.54808709667,-0.606856291333,-3.23266425167,-0.6516871625,5.03452506833,-0.3355348765,2.54103043667,2.43207170333,-8.20320220167,-5.563989385,-4.53241041333,2.16013605167,3.76011835167,0.828221828167,-0.377515521167,-0.404108056167,-0.443897053167,0.220518863167,-0.686740179667,-0.0803788324333,1.55192380333,0.302205514333,0.53790694,-0.370246788333,-0.400099524833,-2.47367231333,-1.57027000833,-1.16831640167,0.965016861833,1.74143810667,-0.253440965667,-0.979408444833,-0.369278387,-0.0676684083667,0.0121398197183,0.0238217662833,0.674553426167,-0.103315981167,0.0597925619333,0.740454626667,-0.2284593525,0.2876318115,-0.236729407333,-0.182773608833,-0.494040901667,-0.178272585833,-0.301833551667,0.3085456,0.477079178833,-0.179968168,-0.4284104995,-0.166302810167,0.121570209667],[-40547.7604667,-5427.48578667,-3384.040635,-311.902821333,3331.64784167,634.712965333,-1438.58975833,-1689.03978833,-940.626954833,-373.734859333,-346.362496333,296.434083333,-764.030728833,-612.443560833,251.003610333,-696.1798835,-461.595910333,-102.424413083,590.129705333,-157.885884833,783.841892833,146.678086167,-52.0555584667,-930.460985,-225.252255167,-57.3564038167,20.9126572333,244.655666,-102.04378595,364.101043,-97.76545585,-145.065649167,-268.3686265,-228.697462167,139.378476,-8.30064724333,30.53095075,21.5376579833,46.0014017333,-67.1018804833,90.4799320167,-67.2458707,-69.2999838333,-0.758996318333,-84.7582567167,82.1241500167,49.84680415,-15.8930263667,20.63897195,12.2386122667,4.70650375333,0.675343588,-28.9346498667,11.9916875333,-20.4866337,-17.9065053,17.88558365,-14.8554064667,22.0544617833,18.1922642333,-15.5271829167,-11.38573535,-9.82073966,7.83739078667,1.04934466833,-0.685681767167,-1.88782128667,-6.535008995,-0.852168235667,-3.22081124833,-0.651234437,4.88769184,-0.441127756167,2.575181205,2.20648390667,-8.12111131,-5.70500838,-4.52875184833,2.110133615,3.713925455,0.8139426955,-0.341754511667,-0.410796113167,-0.404641893667,0.266660490333,-0.73113229,-0.0708383991333,1.52429692833,0.208589681667,0.512215395,-0.412284493,-0.475350618,-2.49038560167,-1.63446022167,-1.16761902833,0.915266327333,1.72119324,-0.280585355167,-1.00726414933,-0.379989004333,-0.0533740691167,0.0145591279667,0.03638176235,0.6953275705,-0.105130596333,0.06508366265,0.730329898167,-0.250709268167,0.2872079765,-0.261746969667,-0.188717518667,-0.5126407185,-0.195080896167,-0.305514706,0.2781437405,0.4708057885,-0.1942927245,-0.442758995167,-0.172134607667,0.120228093],[-40593.5258333,-5649.06307833,-3423.07018167,-293.179155333,3103.77702833,698.821994167,-1755.40114167,-1878.442715,-928.4811505,-385.126082333,-300.096845333,275.987131667,-784.1085725,-588.833948667,174.232094583,-692.0641585,-446.759049167,-74.858243,583.161555333,-136.305906667,791.9917295,114.218532983,-49.0686662167,-930.744255833,-224.3358785,-51.2802461,30.4814142833,239.316355667,-98.1954178833,365.283139667,-107.088246383,-140.585786667,-262.157373833,-235.324116333,149.374561333,-7.38297011833,31.2400827667,22.8778308167,44.1464927667,-67.3581597,89.55404365,-67.8996844667,-66.6878662833,1.61022118083,-86.28002015,85.4633577333,49.90188815,-14.1216490167,20.8747151667,11.9688018833,4.59124692167,0.371365954333,-28.93677505,11.2306604167,-20.35829875,-17.37285875,18.0305690833,-15.3299454167,22.7382552,17.6612017167,-14.79708895,-11.48626595,-9.83922866167,7.80698948333,1.0086686055,-0.76280512,-1.839205925,-6.44752956,-1.10402460017,-3.18007578667,-0.6396102715,4.71007102833,-0.535266084167,2.62448702167,1.950930935,-7.957300055,-5.80703320667,-4.50943690833,2.04221820333,3.65005022667,0.791107064333,-0.3086190915,-0.419123906167,-0.359708608,0.318896766833,-0.779516067833,-0.05778728865,1.48597924833,0.11447585915,0.4838223455,-0.4466528505,-0.549222087167,-2.48442028333,-1.69060268667,-1.16005926167,0.8548444035,1.69348937833,-0.305936287333,-1.03094751,-0.3879101625,-0.0409183784667,0.0158636099,0.04826122995,0.711578784,-0.1082806965,0.0709603263,0.714608163667,-0.2701894075,0.284988282833,-0.285429885833,-0.191713646167,-0.526469611333,-0.211818955167,-0.3065470675,0.243847167667,0.463252727,-0.207989474333,-0.454621751,-0.178236528,0.117278754667],[-40613.3834,-5916.86278667,-3488.536045,-269.531361667,2830.665295,748.718989333,-2050.581195,-2053.63134833,-909.796037667,-400.344541167,-252.9668815,258.683190667,-801.188611833,-570.230944167,92.1405239683,-683.186832667,-429.538501167,-45.0594826,573.275248167,-114.506076767,797.500435,81.7897955333,-44.605527,-926.104647167,-222.015556667,-44.2461966667,40.77647265,232.513088167,-94.3873371,365.889551833,-115.365675,-134.851499,-254.193656667,-241.118846333,159.2072845,-6.41558407833,32.10165475,24.3046530333,42.0538417,-67.3152007833,88.5906550667,-67.94456005,-63.4656179333,4.19934815667,-87.4233824833,88.7138657333,49.6454135,-11.9775115567,20.9703163167,11.6957144333,4.475193025,0.103536142833,-28.7183878333,10.4706213217,-20.0675240333,-16.6905294833,18.1296481,-15.7257829,23.4332122833,16.9864421167,-13.84708275,-11.5064158333,-9.83133863333,7.71673201667,0.963429833667,-0.842550366667,-1.76464096167,-6.29556186333,-1.36012707833,-3.11566701833,-0.619304709,4.51509835833,-0.619291469167,2.69627168,1.66650376833,-7.711286795,-5.87329197667,-4.47684723333,1.959497575,3.570885185,0.7610291505,-0.277885473667,-0.4292269815,-0.310621742167,0.375189238833,-0.831374618833,-0.0424605832167,1.43726585333,0.0219930660833,0.452820413,-0.471521023,-0.622977813667,-2.454990745,-1.73946513833,-1.14570950167,0.785678732667,1.65939477,-0.3292387925,-1.05108224333,-0.393000091833,-0.0302246726,0.0161240007167,0.0595468846,0.723325141,-0.112686782667,0.0769897097333,0.693693712833,-0.287173976833,0.280878189667,-0.307226261167,-0.1924805045,-0.535047225333,-0.228500833667,-0.304757881333,0.206453669833,0.454641042833,-0.220944096833,-0.464198649667,-0.184636666833,0.1130117955],[-40620.9623667,-6154.57963,-3538.35355333,-248.998501833,2533.02496833,792.063063167,-2311.42674667,-2203.05635833,-887.031506833,-418.531208167,-205.2112235,247.557393833,-811.438235333,-556.5619765,10.0146496567,-670.207009667,-411.205817333,-13.66671985,561.282174167,-91.5421154333,800.718075333,51.8160371833,-38.8023399,-916.320854667,-218.454979333,-36.7229702667,51.57695615,224.459982667,-90.4723795667,366.05549,-122.035089667,-127.9926415,-244.3987615,-246.221281,168.977191,-5.40911892,33.05069785,25.7850571833,39.7428013,-67.00426195,87.6228806833,-67.3333886167,-59.7005673333,7.08325578333,-88.2628653167,91.9499883833,49.1034435,-9.47371022833,20.9421902,11.4235442,4.35826013333,-0.142410409167,-28.3144188167,9.71909962667,-19.6277181667,-15.8813823333,18.2255351,-16.0605965,24.1668386667,16.1823019,-12.6850792167,-11.4543993333,-9.80281957333,7.574616135,0.916445022833,-0.924765560333,-1.67204871333,-6.09210954167,-1.61853902167,-3.03358683333,-0.593777166,4.31678318833,-0.694679128667,2.797760755,1.35495468167,-7.38570464833,-5.90781562,-4.43383086333,1.86583968833,3.47861618667,0.725209643167,-0.2491086505,-0.44115845,-0.259149949167,0.433352557667,-0.886144308,-0.026359543,1.37878446,-0.06659478975,0.419379855833,-0.4850708255,-0.697764358833,-2.40223894,-1.78203933,-1.12504234333,0.7101630595,1.61986622333,-0.350206978167,-1.068313365,-0.395326131167,-0.0210960729667,0.0154649491167,0.0702957132,0.7307560585,-0.118250699333,0.0826619651833,0.668202356,-0.3019204615,0.274831629333,-0.326569138833,-0.191747824167,-0.538128781167,-0.245210531667,-0.300147849,0.166951652,0.445152739667,-0.232971194,-0.471719745,-0.191321532,0.107748248],[-40613.8948,-6311.74226167,-3554.18145,-237.282745167,2228.07002667,831.453449167,-2527.25241,-2314.76889667,-862.831122667,-438.026287667,-157.275967,245.396284167,-810.799667833,-547.753118167,-68.8230392317,-653.948001833,-392.467786333,18.92267575,548.115607167,-66.4991758167,801.942118167,25.888338855,-32.2338945333,-901.437987167,-213.847429,-29.0312073167,62.7561872833,215.456819333,-86.3575987667,365.891400667,-126.760961167,-120.344242,-232.8374715,-250.7723615,178.744013,-4.37435031667,34.0358009333,27.3023888,37.2636396167,-66.47929745,86.6765966667,-66.0620879833,-55.52182375,10.2799867383,-88.8774549667,95.2209294333,48.2938747167,-6.64929610167,20.80729995,11.1514980833,4.23994342,-0.373656497667,-27.7640341667,8.98225287833,-19.05648955,-14.9788057667,18.3447768833,-16.3549183167,24.9566233,15.2590944667,-11.3348857017,-11.34101405,-9.76280215167,7.38855587167,0.867830223333,-1.010508053,-1.56879431333,-5.84987202333,-1.87736063,-2.93908199167,-0.566876143667,4.126283625,-0.763594666667,2.93288201167,1.01698964483,-6.98999793833,-5.91669112833,-4.38593141,1.76477615167,3.37429088333,0.685089701333,-0.2225685835,-0.4554325935,-0.207421471833,0.491620826667,-0.943189447,-0.0104003383167,1.31181093333,-0.14902235585,0.383802325833,-0.486484477167,-0.774870497833,-2.328693525,-1.820410265,-1.099998975,0.630529391167,1.57509854667,-0.368456687,-1.08344893667,-0.394950913333,-0.013457090255,0.0138987550833,0.0803583655667,0.734189879167,-0.124846953,0.08768387835,0.6390312925,-0.314478626667,0.266953546167,-0.343168858167,-0.190250654333,-0.536149542,-0.262464259333,-0.293295306,0.1262854327,0.434612606833,-0.243811971833,-0.477614238,-0.1982639015,0.10173286255],[-40572.21125,-6341.32637167,-3538.43668333,-235.575208,1935.44257,864.734272667,-2688.25584167,-2381.27651,-839.2818465,-455.631881167,-110.2193089,255.1608355,-796.617891833,-543.955078333,-142.326757467,-635.2843135,-373.576500667,52.3012578833,534.907326833,-38.7901361883,801.355160667,5.07800665333,-25.6101325333,-881.690025667,-208.4324095,-21.4322524667,74.2022732667,205.882349,-82.0036033167,365.488797333,-129.340186333,-112.289359,-219.6792055,-254.912499833,188.494459833,-3.338213525,34.99417885,28.8435675167,34.6872524833,-65.7955198167,85.7833586333,-64.1504663167,-51.0664008,13.7625731167,-89.3498195167,98.5334913833,47.22286385,-3.558027756,20.57825505,10.8709182167,4.12055431667,-0.594286801333,-27.1028073333,8.27129971833,-18.3741441,-14.0147136333,18.49957475,-16.6319690333,25.8041889667,14.2210941667,-9.82872663167,-11.1772169833,-9.722652535,7.16580559167,0.815755299167,-1.10048035,-1.46253111833,-5.5799745,-2.13281317167,-2.83734903333,-0.541081173333,3.95156854167,-0.828956304167,3.10105683167,0.651532786,-6.537017975,-5.90635817167,-4.340577685,1.65930796667,3.257615645,0.642236206,-0.198762518,-0.472490049333,-0.157947822333,0.5485072025,-1.0015005595,0.00469430366667,1.23808504,-0.223374172833,0.3464529,-0.475963683,-0.8558815245,-2.23807960167,-1.856947575,-1.07360131667,0.5486974855,1.52437992,-0.383571399833,-1.097330315,-0.391810182167,-0.00721298384167,0.0114138649967,0.0894403072833,0.7339176625,-0.132356816333,0.0918721741667,0.607163005,-0.324827723167,0.257465354,-0.356909235,-0.188724580333,-0.529903058,-0.280921352833,-0.285215996,0.0852730128833,0.422421317333,-0.253187676333,-0.4824049125,-0.2054060025,0.0951426728833],[-40466.3601333,-6201.544025,-3490.65139833,-242.9483945,1675.10574,891.769420833,-2785.88778667,-2396.13443833,-818.447501167,-467.762019167,-64.5306416,279.625102,-766.4346085,-545.183086833,-208.88306,-615.189172,-354.747865333,86.0814985,522.7503505,-7.85621915333,799.168851333,-9.66020056167,-19.5447046667,-857.255515833,-202.464519167,-14.2261316717,85.7592938667,196.085520167,-77.3761986,364.946846833,-129.5728665,-104.152134833,-205.0468335,-258.735546833,198.210729833,-2.32271833167,35.8456060833,30.3793028167,32.0705640667,-65.0097567667,84.9757958,-61.6146375667,-46.4493976167,17.5178113167,-89.7439230833,101.8957602,45.8925332833,-0.246140082333,20.2704249,10.5719959833,3.99920865167,-0.8117504085,-26.3660146333,7.59680327333,-17.60170695,-13.0151948833,18.7031413667,-16.9112638,26.7137516167,13.0704953,-8.19329625167,-10.9729987167,-9.69031483,6.91407667667,0.760057093,-1.19419634,-1.36098406167,-5.29298966167,-2.381647985,-2.73484372833,-0.518093104167,3.79951470833,-0.893472588,3.302851585,0.257025821333,-6.03690318167,-5.88304431667,-4.30315391667,1.55161564333,3.12816343333,0.598087154333,-0.1774413185,-0.492253298667,-0.112953445833,0.602759472,-1.06027284167,0.0177488100333,1.15918580833,-0.288393455167,0.307706651667,-0.453549385167,-0.942380531667,-2.13324358833,-1.89408829333,-1.04809368667,0.4660550185,1.46701275667,-0.3952606135,-1.11060921667,-0.385943991667,-0.00216849465,0.00806656602167,0.09737432595,0.730289190167,-0.140702610667,0.0950302212333,0.573444207833,-0.333157786667,0.246629975333,-0.3677524995,-0.187859589,-0.520000338,-0.301317090333,-0.276682848833,0.044490070835,0.4080242025,-0.260916705667,-0.486536864667,-0.212690914167,0.0881090087667],[-40314.9110667,-5931.80604,-3425.51015833,-260.376471333,1440.91925667,908.964423,-2825.541995,-2367.78172333,-799.910734167,-475.7214485,-21.0682717667,316.268657667,-724.410055833,-551.7326745,-271.388616833,-593.635266333,-336.4469455,119.8506149,511.3029285,25.0653661783,795.402865833,-19.55651045,-14.1581556133,-828.962623333,-195.997446667,-7.508892125,97.2753823333,186.132683167,-72.7110072667,364.307772667,-127.927832833,-96.00618795,-189.363683167,-262.145067833,207.7941915,-1.33887771833,36.6032835333,31.8927288,29.4500488333,-64.1658687667,84.2771688833,-58.6073004167,-41.7007794667,21.4223156667,-90.0203888333,105.268432333,44.3376126,3.24927858733,19.8917809167,10.2689661033,3.883142725,-1.0201773665,-25.5666713833,6.96812485167,-16.7736552167,-11.9846598,18.9345638333,-17.17747785,27.6703803,11.83079035,-6.45360541667,-10.7307755833,-9.665096275,6.63771144833,0.7040723805,-1.28853185833,-1.26472557333,-4.99176176167,-2.62109407333,-2.63552829833,-0.496153677667,3.66853834167,-0.951559849667,3.532363365,-0.158454743833,-5.49991281833,-5.84835110167,-4.27376339833,1.44333676667,2.98726142833,0.553042674,-0.1586682465,-0.5143302125,-0.0728983081667,0.654690744667,-1.11891465,0.0293056850333,1.07655312867,-0.344204258333,0.269479642833,-0.421184425333,-1.03260052417,-2.017255615,-1.93208936667,-1.02365323,0.383831829333,1.40378550833,-0.403595927667,-1.12341756,-0.377660533667,0.00144168698167,0.00379730633667,0.104121335267,0.723778877833,-0.149835493833,0.0975563240667,0.538404166833,-0.3396468285,0.234962222667,-0.376113948667,-0.1874309985,-0.507155623,-0.323543920833,-0.267853768333,0.00452214949,0.391608746333,-0.267031906667,-0.4901515015,-0.220134515,0.0807329517],[-40146.8661667,-5586.29285833,-3361.197875,-288.9079,1222.987055,912.263258833,-2814.11018333,-2307.658255,-782.475834167,-481.3292705,19.4101741833,362.454566667,-676.040837167,-563.632314333,-333.398543833,-570.336410333,-319.144659167,153.219298667,500.152447,58.3997103833,790.111407333,-26.1300157,-9.47341783667,-797.605094667,-189.054332167,-1.36501693667,108.590159633,176.018741333,-68.2723065833,363.608167667,-124.945311333,-87.8827480333,-173.014838167,-264.9997815,217.126011667,-0.4045357315,37.283763,33.3630924833,26.8359098,-63.2954436167,83.706197,-55.2936146,-36.8349763667,25.3580582667,-90.1179537833,108.6016095,42.5928086167,6.89213153667,19.44706765,9.97830426333,3.77968967833,-1.21631525,-24.7118421833,6.39292593667,-15.9263600167,-10.9217222983,19.1687440833,-17.4090572333,28.6561775667,10.5270629467,-4.63493668833,-10.449923,-9.64335006833,6.34072411833,0.6523126125,-1.37979787667,-1.17279327,-4.67783813167,-2.84887922333,-2.543809415,-0.472076588833,3.55432671,-0.996465319333,3.7831046,-0.5854863645,-4.93600216667,-5.80230997167,-4.25064432333,1.33573405,2.83649332833,0.507522948333,-0.142207413833,-0.538121985167,-0.037518127955,0.704705733833,-1.17693467,0.0398701502,0.9916510385,-0.391690620667,0.233936786,-0.380944675167,-1.12416909333,-1.892824255,-1.97063795333,-0.9997188635,0.303093612667,1.33587489167,-0.408773041,-1.13557702667,-0.367295188833,0.00337144018,-0.00142912078,0.109749549667,0.714832240167,-0.1597033095,0.0999331062,0.502425136667,-0.3445472185,0.223045935,-0.382460299167,-0.18704795,-0.491907944,-0.347344793833,-0.258647467833,-0.0341044951983,0.373583740833,-0.271645373833,-0.493237517667,-0.227763435,0.0730787984],[-39983.4442833,-5211.86972,-3314.81431333,-328.488047667,1014.791864,897.898237,-2756.43707,-2226.343795,-765.037734833,-485.527250167,56.2832736333,416.592099667,-626.383299833,-580.461809167,-398.067193833,-545.094991167,-303.2219185,185.828416167,489.155569333,90.706688,783.521238333,-30.6622811167,-5.461753715,-763.764519,-181.6803475,4.078990445,119.536282667,165.7593585,-64.2849310667,362.928224333,-121.065603333,-79.7709115667,-156.274333333,-267.133902,226.100083667,0.458263622333,37.8785139667,34.7622559667,24.22595985,-62.4202689667,83.2862331667,-51.81223095,-31.8490924167,29.2403921667,-89.96656565,111.857111667,40.6830840333,10.653185515,18.9404116167,9.710940975,3.69381455167,-1.4028863,-23.8071247167,5.87731377833,-15.0926511833,-9.820465005,19.3871016167,-17.5830701667,29.6603312667,9.17961287167,-2.75615496383,-10.129955035,-9.618783825,6.02731476667,0.609368819167,-1.46445275833,-1.08550143,-4.35303088833,-3.06368376,-2.46471037833,-0.442429984167,3.45304215,-1.02164307017,4.05135606667,-1.01614588983,-4.3515684,-5.74538286833,-4.23030462333,1.22930208667,2.67711156333,0.462116279333,-0.1273783435,-0.562885522,-0.00658622472,0.752874098167,-1.23408827667,0.04945271115,0.905580821667,-0.431962515833,0.203096126167,-0.334237618167,-1.21508096167,-1.76137562667,-2.00980513833,-0.975008250833,0.224376937333,1.26432855833,-0.411064659667,-1.14675137833,-0.355125071,0.00351266153167,-0.00759335264333,0.114402729667,0.703768361167,-0.170274072,0.102520242017,0.465705678,-0.3482377415,0.211399443833,-0.3872049475,-0.186422426833,-0.474487766333,-0.372680470333,-0.248736510167,-0.0711204371667,0.354337938333,-0.274945808833,-0.4957270635,-0.235589132833,0.0651662953],[-39841.64305,-4851.39902333,-3303.68731833,-378.367051333,811.708586,861.855354333,-2655.94953,-2134.16363833,-746.483025167,-488.7028665,88.9277420833,477.7807245,-580.368196833,-601.412503333,-468.3542525,-517.736241833,-288.976675167,217.331286,478.347642333,120.586534967,776.000206,-34.3197116833,-2.02536032667,-727.862554,-173.926119167,8.676013625,129.9438695,155.386292833,-60.9477187833,362.382848667,-116.668353667,-71.6064624833,-139.3377385,-268.3474535,234.616326167,1.22386546017,38.36181015,36.0581601167,21.6106277,-61.5502765833,83.0443188,-48.2817302667,-26.71963655,33.00675195,-89.4816738,115.004376,38.6257176333,14.50988045,18.3741188833,9.47332486833,3.62903732,-1.58673097833,-22.8549317333,5.42620466667,-14.3012649,-8.67013668667,19.575427,-17.6731999,30.6773357,7.80531473333,-0.829865430333,-9.77038758667,-9.58233555667,5.70138957333,0.579645004667,-1.53908599333,-1.00423584867,-4.01897418667,-3.26494399167,-2.4032245,-0.403694231833,3.36132773333,-1.020377455,4.33558993833,-1.4434477,-3.74962948167,-5.67830378833,-4.20749575167,1.12382207333,2.51005384833,0.417511099333,-0.113234383883,-0.587814703333,0.020020744495,0.798946143667,-1.29033687667,0.05773627425,0.8190151175,-0.466206393167,0.178824481333,-0.281925571,-1.30353275833,-1.62317719833,-2.049931715,-0.947538339333,0.147749143983,1.19006405667,-0.410799098333,-1.156441755,-0.341350858667,0.00185637233167,-0.0146516850983,0.118267510167,0.690749306833,-0.181535564167,0.105561378167,0.428256606167,-0.351175025,0.200447853,-0.390711813833,-0.185340305667,-0.454868180333,-0.3996736885,-0.2375666445,-0.1064723223,0.334238342,-0.277178757667,-0.497489327333,-0.2436023935,0.05697777115],[-39730.5066333,-4538.61930833,-3336.13851667,-437.6092275,612.004434167,802.962818833,-2515.44976667,-2038.35094,-726.144119833,-490.728005,117.2254484,545.2963365,-541.673325333,-625.922244667,-546.554530333,-488.237927333,-276.712854667,247.358026,467.7678465,146.935907167,767.710010333,-37.9449297333,0.793660615,-690.164191667,-165.861728167,12.22789418,139.589670333,144.914756,-58.4148998167,362.005116167,-112.016280167,-63.3975337333,-122.330834167,-268.449001833,242.547404,1.867741575,38.6858425,37.19886565,18.9734242667,-60.69563335,82.9874707333,-44.79321435,-21.4504029,36.6114141,-88.5922225,117.9971725,36.4271648167,18.4332260167,17.7516263,9.26784128333,3.58549199167,-1.776212125,-21.8605938333,5.04259572333,-13.5781231,-7.46719820667,19.7220145833,-17.6615012167,31.69655145,6.41569333833,1.1279898895,-9.36960337833,-9.52489622833,5.36732508333,0.567868567167,-1.599870335,-0.930554052833,-3.678492555,-3.45132763167,-2.36538352,-0.353685938333,3.27587974167,-0.989249944,4.63317861333,-1.86213852333,-3.13440013833,-5.60108807167,-4.17730064833,1.01893286617,2.335666655,0.374545075333,-0.0984011072667,-0.611678803667,0.0424447899,0.8423206115,-1.345212275,0.0637576295333,0.732553175667,-0.495722841333,0.1622180515,-0.2249927035,-1.38815272833,-1.47891806333,-2.091070825,-0.915682785833,0.0732861982152,1.11364880333,-0.408232619833,-1.16396391333,-0.326141839167,-0.00148246147,-0.0224452957167,0.121546363667,0.675878030667,-0.193375569667,0.109145459833,0.390151733833,-0.353877786667,0.190533274667,-0.393321676,-0.183702473833,-0.433144959833,-0.428380905833,-0.224750530833,-0.140058232333,0.3135153665,-0.278536451,-0.4983088995,-0.251754937833,0.04847892245],[-39644.6707667,-4288.35920167,-3388.86855333,-506.487435833,417.721452,730.284525167,-2339.89590167,-1936.51941833,-704.743631667,-491.257376667,142.929192333,616.8734745,-510.3375075,-655.134197667,-633.499414167,-457.020556833,-266.875271667,275.5268225,456.894465167,169.510817667,757.817781,-41.7763673167,2.406671915,-650.841421833,-157.630711833,14.4524437333,148.096035,134.245212167,-56.7260210167,361.472104833,-107.1878935,-55.4578849,-105.367232383,-267.325457,249.676592167,2.36719783333,38.77260405,38.0702237,16.2957117333,-59.88000485,83.0399741667,-41.3986444667,-16.1628218833,39.9988486,-87.2840997,120.7301175,34.0794888167,22.3676706667,17.0831340667,9.090739235,3.55116639833,-1.97222306333,-20.8441331167,4.72206277,-12.94567525,-6.24043185167,19.8099494333,-17.5570748333,32.6821323,5.015054655,3.083499675,-8.923492985,-9.440883395,5.03252717333,0.578925314667,-1.64239724333,-0.8633605045,-3.33959712,-3.618089755,-2.35901134,-0.295793830167,3.19222013667,-0.934225143,4.93365629167,-2.26943270333,-2.51854794667,-5.51180423833,-4.13785169833,0.914636832667,2.15338170833,0.334776316833,-0.0808461505667,-0.631956088333,0.0611526387833,0.881392417667,-1.39632062,0.06542459235,0.646911227,-0.521860603333,0.152207372833,-0.166109884333,-1.468239095,-1.33243475667,-2.13224676833,-0.879615388,0.00150885231067,1.035040637,-0.403463500833,-1.16846827833,-0.309648587,-0.00612080771,-0.03036313125,0.1243465675,0.6592954385,-0.205206525333,0.113044734333,0.3519628605,-0.3568244445,0.181786784833,-0.395508450333,-0.181587091167,-0.410299634833,-0.458456882,-0.2106615525,-0.171461843833,0.292118687333,-0.279077781667,-0.497900321167,-0.2599497265,0.0396185058167],[-39578.5951167,-4123.58081,-3450.73203667,-588.5742955,228.168590617,649.786323667,-2136.94205,-1821.08220833,-684.266282667,-490.1320995,167.724944833,689.060895,-484.686853833,-689.5111745,-729.8854755,-424.753717833,-259.7182705,301.673776667,444.910994667,188.380560667,745.663814167,-46.0327133667,2.0334777805,-610.190367167,-149.383009833,15.14607655,155.164602667,123.253698167,-55.9001272333,360.464018833,-102.2401955,-48.19565645,-88.6493811,-264.863793667,255.789439833,2.71266055667,38.5537725333,38.56828995,13.5738445333,-59.1396967167,83.10911965,-38.1368909,-11.0132697083,43.0741723333,-85.5496160833,123.098204833,31.5788821833,26.25136145,16.3845700667,8.93540986833,3.51132865,-2.167755595,-19.8329394333,4.45212788,-12.4212080333,-5.02798410333,19.81206625,-17.3741842833,33.5984667167,3.61242033167,4.999635465,-8.42776282667,-9.32514298667,4.70609103833,0.615893752,-1.66394201333,-0.799815063667,-3.01265239333,-3.76259027167,-2.39089658833,-0.235116626167,3.104902285,-0.863745628333,5.22653836667,-2.65991365333,-1.91587560667,-5.408389065,-4.08794345167,0.810598994333,1.96267368667,0.300058526833,-0.05898412615,-0.646515507333,0.0766052737667,0.914075178,-1.44153389167,0.06056722315,0.562799211,-0.5454972555,0.1470443985,-0.108052658067,-1.54217529833,-1.18801413667,-2.17243209833,-0.840063564167,-0.0671929627515,0.954308615167,-0.396471933167,-1.168932585,-0.292046364,-0.011698877755,-0.0378122754,0.126622712667,0.641149431333,-0.216396330167,0.116918134,0.314410679167,-0.360241337833,0.174239361,-0.397808204333,-0.178921957833,-0.387463495167,-0.489560861333,-0.195937105667,-0.2002803415,0.2700849975,-0.278765249667,-0.495906693833,-0.268065636,0.0303118353667],[-39522.56355,-4063.77074,-3523.63299333,-686.871011667,41.7885894667,562.648055167,-1917.62748833,-1683.60104667,-667.105506,-487.700235667,192.5237975,757.892023167,-462.186600333,-728.046104,-835.2413595,-392.307135333,-255.403098333,325.793545833,431.109419167,203.910399667,731.111482,-50.6793190833,-1.16298537133,-568.8103965,-141.278774,14.2338978167,160.643625333,111.8798015,-55.9176800333,358.770519667,-97.22456495,-42.0572845667,-72.4605941333,-261.000779667,260.759132167,2.91168473333,38.0038335,38.63428505,10.816369885,-58.5218876667,83.10978675,-35.0535349167,-6.17417766833,45.73476415,-83.4016119,125.028295833,28.93996855,30.0082534333,15.6777680333,8.79965493333,3.455894075,-2.354413005,-18.85959355,4.215787925,-12.0191949,-3.87106476667,19.7026866,-17.1318921333,34.4169081667,2.223702974,6.83510674833,-7.88463069333,-9.173279965,4.39726434,0.679869554667,-1.66370496667,-0.7365208385,-2.70805831333,-3.88472875333,-2.465308695,-0.176727720167,3.00894144833,-0.7871818365,5.50251268667,-3.02667122667,-1.34030046,-5.29102694667,-4.02733951167,0.707673711167,1.763434715,0.271722749833,-0.032211441595,-0.654290462,0.0895271983333,0.938763290333,-1.47951795667,0.04769260255,0.481119708667,-0.567370205,0.14481575,-0.05332460648,-1.60806796,-1.04967777033,-2.21088841167,-0.798407423833,-0.132024273633,0.871675729167,-0.387354678833,-1.16451615167,-0.273685675667,-0.0180245233,-0.0444392724333,0.1283542865,0.621733665667,-0.226453091333,0.120473340167,0.278254522,-0.364226666,0.1678602405,-0.400683017,-0.175585511333,-0.365682173833,-0.521332078667,-0.181461449167,-0.22607257,0.247494596667,-0.277523622833,-0.492032976667,-0.275901335,0.0205638156833],[-39440.8059333,-4064.17805667,-3577.66081,-790.975462167,-132.617618383,475.156349,-1699.31910833,-1523.28160167,-653.799141167,-485.3920765,217.738515333,819.6843635,-439.987978667,-768.468908667,-944.041391167,-360.9007285,-254.523395,347.693883667,415.5713645,217.421979833,714.246776,-54.4714200167,-7.89025745283,-528.091928333,-133.613555667,11.780363725,164.469596167,100.271731267,-56.4781751833,356.157574833,-92.15874995,-37.4890598,-57.1516364167,-255.882357667,264.712586,2.981122295,37.1909458167,38.26449565,8.029787765,-58.0539875667,82.9378466,-32.2359941833,-1.83636576,47.9487082167,-80.9187268167,126.513455333,26.2327305167,33.5193019167,14.9944556333,8.697219795,3.38487798,-2.53642403667,-17.9611381,3.99405204167,-11.7521915167,-2.81665007333,19.486348,-16.8560148167,35.1095296833,0.874990355667,8.53668519333,-7.320969925,-8.98085965833,4.11449707833,0.769576024167,-1.64179894,-0.671113172167,-2.43419128,-3.983598255,-2.57918810667,-0.126282133033,2.90267667833,-0.712294100333,5.74847503333,-3.36590783,-0.805400436,-5.16789399833,-3.95632910333,0.612207066667,1.55686967667,0.249320645167,-0.00137849446333,-0.655069970667,0.101896004333,0.955744038833,-1.50882709833,0.0276689972483,0.4027416815,-0.58927382,0.144007871,-0.00489458990333,-1.66611191,-0.9203607805,-2.24744455667,-0.756488790167,-0.190360159333,0.787483980333,-0.377269504167,-1.15566045667,-0.255428035833,-0.0250195327333,-0.0500421159167,0.1299788625,0.601779774167,-0.2349943995,0.123640226,0.244111513167,-0.3691529955,0.162397739833,-0.404240939833,-0.1718589835,-0.3457114225,-0.553005231833,-0.168244832667,-0.2482691175,0.224242931833,-0.275609571167,-0.486486200167,-0.2830228295,0.010800645375],[-39303.1303667,-4054.95800167,-3565.93516167,-891.169481833,-281.045310167,397.9947915,-1498.60483667,-1339.52273667,-645.353406333,-484.6686065,244.40028,871.813386167,-414.695810167,-807.810882833,-1048.89493433,-331.975954833,-257.9450395,367.2356115,398.7985105,230.537817333,695.299128833,-55.5831621833,-18.7424812817,-489.413371667,-126.707554833,7.76960865833,166.589329,88.6368683833,-57.2050134,352.389221667,-86.9483020333,-34.8795774667,-42.9728894667,-249.6830135,267.857167167,2.95100162667,36.1642197167,37.4557255667,5.20086510667,-57.7575458333,82.4755524333,-29.7554725,1.827844935,49.74292645,-78.1850991167,127.5758725,23.5350012,36.6604804167,14.3722982833,8.63692753667,3.29626241,-2.731739495,-17.1753397667,3.762289565,-11.6279362667,-1.90644558667,19.1868522,-16.5709306333,35.6553027333,-0.408085902333,10.0535255467,-6.77019208,-8.74075151,3.86704117333,0.882871758167,-1.59923793333,-0.604862682667,-2.198877905,-4.05991473667,-2.72779330333,-0.0886233678833,2.78775594,-0.645817497167,5.95284029833,-3.67559601667,-0.321456124667,-5.04944308167,-3.87338507667,0.531391643333,1.34451083167,0.2322263845,0.0329033128883,-0.648786945,0.1153494775,0.965664282833,-1.52851817333,0.00152300149333,0.328311555833,-0.613029451833,0.143344438,0.0347806286533,-1.71734312833,-0.801470885,-2.28220098667,-0.715391095167,-0.2394373345,0.702155673333,-0.367702771,-1.14296644333,-0.238212859167,-0.0323511198,-0.0543864401333,0.132027341833,0.582069712333,-0.2417936595,0.126244453833,0.2123576095,-0.3755510795,0.1575394665,-0.408406489333,-0.168255913833,-0.3278673535,-0.583785161833,-0.156978651667,-0.266425798333,0.2002339545,-0.273425868833,-0.479523960333,-0.288920182167,0.00154290686167],[-39136.84575,-4012.78163333,-3483.46368,-980.601058667,-404.312928333,327.034612833,-1334.167015,-1144.61762033,-639.655931667,-488.946091333,270.9883485,911.145685333,-388.774333333,-842.066099,-1144.685985,-305.661403167,-266.125496167,384.403728,381.335044,243.286785333,675.022088833,-53.3848075667,-33.8628796333,-454.304310167,-120.640887333,2.47649006167,167.1780585,77.2624323333,-57.91701555,347.410128333,-81.8674493167,-34.3201381167,-30.2678443333,-242.466272833,270.391065167,2.83658241833,35.0455752667,36.2778109833,2.35030455383,-57.6101704833,81.6497536,-27.75061645,4.76729092,51.1060859167,-75.2177070333,128.235537833,20.93074125,39.3163229167,13.8251999333,8.63252923833,3.19759085,-2.950271905,-16.5084975333,3.50346209667,-11.6534426,-1.1463979635,18.8181632,-16.27272345,36.0332455833,-1.59285895367,11.3424626333,-6.26471423667,-8.44040026333,3.65690400667,1.01391376883,-1.538728905,-0.538520646667,-2.00105862167,-4.11385079333,-2.90098999,-0.0614589329833,2.66471090167,-0.585404581833,6.10398221167,-3.94939421833,0.1052682425,-4.94503224,-3.77314745833,0.471611574833,1.12838803583,0.219004707,0.0682518007667,-0.636630355667,0.131051692,0.970249985333,-1.5378346,-0.0276192628183,0.259097618667,-0.640057216,0.144003948667,0.0631268909,-1.760904085,-0.69305842,-2.31448617667,-0.6744670765,-0.276960947667,0.616580528,-0.360331052333,-1.12677416833,-0.222730220667,-0.0400704020333,-0.0575701581,0.134772175167,0.563176907333,-0.246735769333,0.128596532667,0.183179868833,-0.383660756833,0.153490236833,-0.41313582,-0.164678065333,-0.312137322167,-0.612485701667,-0.147729466333,-0.280256938167,0.175657828,-0.271526186833,-0.471247767,-0.293094885,-0.006708669545],[-38982.9538667,-3928.702115,-3338.64481333,-1052.70163967,-507.493781333,253.245693667,-1224.73606333,-954.453471833,-633.613693333,-502.057048667,295.105601167,934.5220985,-366.332796833,-866.830441667,-1226.95113167,-281.699008167,-279.3456595,399.188905167,363.741932833,255.241309333,654.342005167,-47.58447075,-53.2407336833,-424.265559333,-115.4259515,-3.73709732833,166.468211667,66.4536105,-58.4725984333,341.219708333,-77.2777376333,-35.8040727333,-19.38673675,-234.2433215,272.4891975,2.64458220833,33.9729619667,34.8195232,-0.492605153,-57.5673103333,80.3998468667,-26.3715209,6.96695291167,52.0157439333,-72.00739375,128.503937167,18.5021477667,41.3738154333,13.35821955,8.697697775,3.09890186833,-3.19963682167,-15.9557031833,3.20273911,-11.8333683667,-0.532585753983,18.3902024,-15.94826805,36.2211841667,-2.64524291,12.36315635,-5.83595554,-8.06486364667,3.48376856667,1.15569175167,-1.46331527333,-0.4726711675,-1.83722384833,-4.1453023,-3.08690500333,-0.0409085764333,2.53345933,-0.526455509667,6.190434825,-4.17951533833,0.470178649667,-4.86332149833,-3.64865073333,0.4386812945,0.910576720833,0.208084128,0.101827924067,-0.620069878667,0.150030889167,0.9712243415,-1.53600243,-0.05616262005,0.196359729333,-0.671638086333,0.1476754605,0.0776837711,-1.79524474833,-0.594611941,-2.34328142167,-0.632436751167,-0.300897559167,0.5317245445,-0.356830263167,-1.10721294333,-0.2095423105,-0.0483166540167,-0.0597744203,0.138410726833,0.545497567333,-0.249711877,0.131088180667,0.156669278833,-0.393618878667,0.150537757,-0.418345999167,-0.160850882,-0.298379651,-0.637799816167,-0.140356112667,-0.2895438245,0.150769012667,-0.2704792095,-0.4616592385,-0.295026059333,-0.0134747697383],[-38864.61085,-3805.85041667,-3139.461885,-1102.59311167,-592.498347,169.245311467,-1179.90239833,-779.067252667,-625.243852667,-525.331253667,315.253343833,941.106743167,-350.0809065,-878.727437333,-1292.31226333,-259.929112167,-297.427559,411.715173833,346.754555833,265.968529833,634.128417167,-37.8574904,-76.5965788667,-399.992273167,-111.042774,-10.6059780967,164.643517,56.4626740833,-58.7814411167,333.922304167,-73.3474258167,-39.2302776333,-10.396679635,-225.001770667,274.197071167,2.38327435167,33.0165185333,33.14229625,-3.3123113145,-57.58350645,78.706135,-25.6995934,8.42851381333,52.5001651167,-68.5497994667,128.373612833,16.2915294333,42.75906465,12.9729615833,8.835679915,3.00617377,-3.48810571333,-15.5070412667,2.84950364,-12.16591165,-0.0598682532667,17.9173624,-15.5925121667,36.2084474167,-3.54684953833,13.0894672167,-5.50585900167,-7.60564184167,3.34710605833,1.303569195,-1.37495310667,-0.408414768,-1.70322559667,-4.15614157,-3.27712285333,-0.0236007619683,2.39439941,-0.468183434333,6.20756804167,-4.36154371333,0.771293417167,-4.81035499,-3.49490841667,0.434550973333,0.693594260333,0.198349548667,0.1321169715,-0.599985101667,0.172887439667,0.9697874855,-1.52313891333,-0.0820025521167,0.141103587833,-0.708833588833,0.1552825305,0.07744007375,-1.819213815,-0.505496756,-2.36776216667,-0.588170713333,-0.310733839333,0.4486876085,-0.3580348285,-1.08401197333,-0.199064749167,-0.0570687513667,-0.0611139927667,0.143062585,0.5292098565,-0.250717037833,0.133961195667,0.132847388667,-0.405622741,0.148975651167,-0.424002231167,-0.156606733833,-0.2864512195,-0.658813051333,-0.134580155667,-0.294355006167,0.1258346945,-0.270565631333,-0.450627951667,-0.294359185667,-0.01848612445],[-38793.4447833,-3651.12487833,-2896.07672333,-1126.91823833,-657.595111667,68.9608553667,-1202.13813667,-619.084150833,-613.213398833,-557.999035,331.015911167,931.375023667,-340.386012,-876.545939,-1339.249465,-240.160346,-319.8727635,422.343528333,330.966568,275.108936333,614.706876,-24.217034475,-103.202650867,-381.6256475,-107.429449167,-17.9699564167,161.861484667,47.4307754333,-58.8396051,325.605885,-70.1659423667,-44.3291515833,-3.21366155167,-214.678448833,275.469548167,2.056393425,32.1876862833,31.27980225,-6.1065892,-57.6279534333,76.5772064833,-25.7701112667,9.18898079833,52.59592245,-64.8302383833,127.832603833,14.2900548,43.43401125,12.6649056333,9.0431042,2.91937076833,-3.82007135333,-15.1496521667,2.44108403833,-12.6437543667,0.28075932385,17.410386,-15.2031819667,35.9982415167,-4.30030403333,13.5069615333,-5.284699425,-7.06446582,3.24574499,1.45579828167,-1.27513834333,-0.345712073667,-1.59367343833,-4.148101785,-3.46541112167,-0.00678433207333,2.248277215,-0.4124700195,6.15727894167,-4.49585615667,1.00802382067,-4.78803071333,-3.31119238833,0.458256775667,0.481029086167,0.189194559833,0.158775497167,-0.576720993,0.200045189167,0.966981726,-1.499818035,-0.10396975175,0.0938988686833,-0.751946419833,0.1670538245,0.0625314017833,-1.83219622,-0.425380109333,-2.38659439667,-0.541563138667,-0.306828620167,0.3691004255,-0.364066622333,-1.05635649667,-0.191517140833,-0.0662428857,-0.0616062814167,0.148726517833,0.5143421645,-0.249860497833,0.137419301333,0.111611810667,-0.41972284,0.149045116,-0.4301969605,-0.151821475,-0.276308191167,-0.6747673635,-0.1302070355,-0.294760824833,0.101301841033,-0.271855393333,-0.437790577,-0.290907539833,-0.0217189978333],[-38775.5879,-3471.231955,-2613.58864167,-1122.715965,-699.52364,-50.1814960333,-1292.35062333,-471.588964833,-596.444749333,-598.605144,342.749219333,905.961842,-336.471171167,-859.898892833,-1366.53741167,-222.253577667,-346.110753,431.418634333,316.797429167,282.40226,596.138197167,-6.78666818333,-132.156315667,-369.097342,-104.5204905,-25.7243798667,158.233624,39.4327683667,-58.6616252167,316.304392667,-67.7911099667,-50.7748542167,2.27724524167,-203.171746333,276.215276333,1.670665875,31.472142,29.2527034167,-8.87490202667,-57.6733826167,74.0177366167,-26.5982699167,9.29832743833,52.3355888,-60.8246996833,126.864654167,12.4721995167,43.3719301333,12.4289366833,9.31425714833,2.836345965,-4.19674659833,-14.8701894833,1.97754472333,-13.2564976,0.500187708,16.8785942167,-14.7756478667,35.5974216167,-4.913949315,13.60803455,-5.18058800333,-6.44512723,3.17802035167,1.61193029333,-1.16491905667,-0.284428418833,-1.503171135,-4.121841915,-3.645996155,0.011657272315,2.09625540333,-0.361385297,6.04345784333,-4.58415167,1.18155525333,-4.79719290833,-3.097489405,0.507682542167,0.27688302725,0.179983877167,0.181933637667,-0.550261907333,0.231660904333,0.963665283833,-1.46650044667,-0.121172819667,0.0549564523667,-0.800808766667,0.1828661155,0.033573604745,-1.83374350333,-0.353656972,-2.39845462,-0.4925871115,-0.289917468,0.294569009667,-0.374712740167,-1.02319673,-0.187065346667,-0.0757166466667,-0.0612340762667,0.1553550275,0.500861626667,-0.247264437667,0.141615620667,0.0927934435833,-0.435829297667,0.150844917833,-0.437006628667,-0.146421423667,-0.267834037833,-0.685025228,-0.126984953833,-0.290863411167,0.0776184723,-0.274328584667,-0.422697151333,-0.2844982305,-0.02321988315],[-38817.3736,-3294.33632667,-2297.80713667,-1091.13652333,-717.565361833,-185.527654167,-1444.14795833,-333.0883325,-574.116279167,-644.647933333,351.9554225,866.925286667,-337.454195,-830.398524333,-1374.88082833,-205.867167333,-375.251794167,439.216984167,304.240968333,287.295744833,578.180616667,13.7135021083,-162.347545833,-361.681618167,-102.182945333,-33.8150448333,153.835479,32.3314702333,-58.3747043,306.065292667,-66.2434418667,-58.2026681833,6.27831984333,-190.363188167,276.181266,1.2387065615,30.8176168333,27.0793802333,-11.62097634,-57.6932801167,71.0512008167,-28.1553691667,8.82944277667,51.7361778167,-56.5177893167,125.420479833,10.7924831133,42.5986260667,12.2537434,9.64117879833,2.75313585333,-4.60706276833,-14.64706955,1.46550894683,-13.9935498833,0.616782377,16.32232615,-14.3034748333,35.0118594,-5.39903259,13.4074460333,-5.18989580667,-5.758326995,3.13914201167,1.77422538667,-1.045148163,-0.223379821833,-1.42485046833,-4.07724732667,-3.81658546833,0.0336890738833,1.93831116333,-0.31568379,5.87202173167,-4.62779501167,1.29514366333,-4.833652105,-2.856277855,0.5775425955,0.0855541728333,0.1698518255,0.2023926345,-0.520139224,0.267185910667,0.960421320833,-1.42387713833,-0.133134352667,0.0240647499593,-0.8544735805,0.2025025805,-0.00804558578667,-1.82295762667,-0.290458581167,-2.40198298167,-0.4412996865,-0.2619050875,0.226290486833,-0.3886381,-0.983558214,-0.1856376575,-0.08544514155,-0.0600141626,0.162771682,0.488600961667,-0.243068781667,0.146873991,0.0762117765333,-0.453420880833,0.154350715167,-0.444483527833,-0.140200047167,-0.260999910333,-0.689337669667,-0.124455385667,-0.282908619833,0.0552179158167,-0.277660885,-0.404962586333,-0.2752283665,-0.0232396645833],[-38921.7097667,-3133.25525667,-1962.76238833,-1035.48357317,-711.755214167,-333.7195605,-1644.46778333,-207.143184767,-545.475331167,-693.458209667,360.277759,817.628249667,-344.284525167,-790.709856667,-1368.11290667,-190.352505333,-406.343383333,446.105872833,293.1312495,289.41181,560.5133325,36.07495425,-193.159361167,-358.524083167,-100.253469767,-42.1743084667,148.759738333,25.9216657833,-58.0342511833,294.96129,-65.53812035,-66.3452705167,8.98379588667,-176.232588167,275.235313333,0.762135603833,30.1818645,24.7651319833,-14.3475236333,-57.6451822667,67.71406045,-30.3626856667,7.892446395,50.8141577,-51.9007427,123.477836333,9.22519246667,41.2086426,12.1223224,10.0120248667,2.66369307667,-5.03652521667,-14.45404505,0.9097236435,-14.8380161333,0.658420957,15.73657985,-13.7781337,34.2450545833,-5.76284222333,12.9423714333,-5.28982484,-5.01225664667,3.12252188667,1.94322463167,-0.916394054167,-0.160765484367,-1.35265565167,-4.016071085,-3.97640739,0.0612231056,1.77397488167,-0.272915255333,5.64683086333,-4.62704865667,1.35331490833,-4.88745977167,-2.5894904,0.664015936167,-0.09255812575,0.1582599995,0.220965986833,-0.485836695667,0.3058523955,0.957540595833,-1.37277475833,-0.139427791833,0.000115838604,-0.911637077833,0.225738082833,-0.0610831658883,-1.79927268667,-0.236327489,-2.39580555667,-0.387104911,-0.224431506333,0.164355738167,-0.404862848,-0.937639926667,-0.186921405333,-0.0953563199,-0.0579389291667,0.170713005667,0.477316128833,-0.237285020833,0.153523517167,0.0614119521,-0.471875313167,0.159359986833,-0.452556862333,-0.132919242833,-0.255892353333,-0.687761010333,-0.1220818905,-0.271245853333,0.03444695965,-0.281695821667,-0.384597349333,-0.263637287667,-0.0221235842667],[-39093.2053167,-2997.057885,-1629.84252167,-960.282261667,-685.262587,-492.238208833,-1879.37531667,-99.7921737,-509.650367,-742.507344833,368.788831667,761.612499167,-359.432069833,-743.470017833,-1351.11724833,-174.7899365,-438.389743,452.4344225,283.2152995,288.319663333,542.916030667,58.91979175,-223.9943315,-358.745768167,-98.5470093667,-50.7092461667,143.127836833,20.00298755,-57.69276115,283.078312667,-65.76494005,-74.9213186667,10.5588308617,-160.762822667,273.277782667,0.2356761945,29.539996,22.3136224833,-17.0496164167,-57.4722320167,64.0488294167,-33.1283924,6.63275267667,49.5867048167,-46.9436174833,121.021727167,7.751962115,39.3110011167,12.0142779167,10.4127963,2.56287439667,-5.47000327167,-14.2563374833,0.314261305833,-15.7673084833,0.657499527667,15.1134684667,-13.1874916167,33.3004275,-6.01213331833,12.25744115,-5.45356850167,-4.21217136167,3.11994159333,2.117692795,-0.779075911667,-0.0947612166667,-1.28033314167,-3.94087888833,-4.12376421,0.0962288235333,1.603134245,-0.228401590667,5.37160992167,-4.58096469333,1.36181846,-4.9473375,-2.29823031,0.763592097667,-0.258260016333,0.144736387333,0.238316287333,-0.447080521,0.346700242167,0.95502148,-1.31405062333,-0.139248671167,-0.0184560714907,-0.970632773,0.252177594667,-0.124206974983,-1.76227796167,-0.191293453833,-2.378565925,-0.3287933515,-0.1790682035,0.108633906367,-0.422524020667,-0.8858093535,-0.190456103833,-0.10539646595,-0.0550139352667,0.178835530667,0.466634119833,-0.229899744,0.161811279333,0.0477049321833,-0.490538849167,0.165507012667,-0.4610828345,-0.1243333395,-0.252556761667,-0.680376103667,-0.1193075655,-0.2562776545,0.0155683181967,-0.286332878833,-0.361674889167,-0.250333889167,-0.0202262124333],[-39334.0532833,-2895.84906333,-1317.548495,-869.306868167,-641.018898833,-657.674312,-2135.13537333,-16.2433529833,-465.636036167,-788.97022,378.637604167,702.405029833,-385.0815375,-691.276517667,-1328.47056667,-158.2449295,-470.286801167,458.503601,274.279963833,283.6363595,525.1561615,80.97888295,-254.235641833,-361.356426833,-96.8755410167,-59.3134660667,137.039553667,14.4017073967,-57.38524585,270.496482833,-66.967984,-83.63432635,11.2172664667,-143.925769,270.204606,-0.348110731833,28.8623645667,19.7246827333,-19.7143048333,-57.1096982,60.0990768,-36.3446605333,5.20029823167,48.0868259167,-41.61412005,118.040130333,6.34827864167,37.0149881333,11.9072046333,10.82684965,2.44560021833,-5.89184529167,-14.0172836,-0.315212660833,-16.7544098667,0.6475203995,14.4495656167,-12.5196879333,32.1848345167,-6.15675085167,11.3995637167,-5.65523522,-3.362108485,3.12260819333,2.29572830833,-0.6333347485,-0.0240991176,-1.20160708,-3.85371289,-4.25634999333,0.140724063567,1.42673422833,-0.178179585167,5.0517643,-4.4896875,1.32804488167,-5.002523375,-1.98287537833,0.872347208833,-0.412425587333,0.128783967,0.255036609167,-0.403538768333,0.3885164965,0.9526391985,-1.24849623333,-0.131959107,-0.0332923263,-1.02960255017,0.281148870833,-0.195571425333,-1.71190245833,-0.154735299167,-2.34914123833,-0.264920727667,-0.1275902151,0.0589017783,-0.440722489333,-0.828293686167,-0.195733664833,-0.115484885,-0.05125390195,0.186742755667,0.456080774167,-0.220909154333,0.171871064,0.0343612510167,-0.508766042167,0.172357506167,-0.469815222,-0.114323037,-0.250864422333,-0.667363261667,-0.115500383,-0.238484019167,-0.00120000046333,-0.2914484405,-0.336215693167,-0.2358841625,-0.0178988411667],[-39612.8446167,-2823.954575,-1028.86254817,-763.412595333,-573.11107,-820.775619333,-2395.63173167,45.62929585,-413.903925833,-827.8583005,392.340488833,644.8973105,-420.109353,-636.290483833,-1303.35227833,-140.493042167,-500.814780833,464.705415833,266.577741167,275.825255833,507.192854,101.773635933,-283.409429667,-365.042117167,-95.1804844333,-68.01121545,130.5231495,9.02160989333,-57.03959795,257.358412333,-68.9141446333,-92.2608390167,11.3734169333,-125.723526833,265.959662667,-0.990643933667,28.0622546,16.967723,-22.3386015833,-56.5153464333,55.9199966,-39.84632475,3.71283169833,46.4218066833,-35.9042115833,114.557097,4.977371845,34.4344117833,11.7908102667,11.2283795333,2.30191539167,-6.29614983167,-13.7175141333,-0.973509736333,-17.76954585,0.653524418333,13.7602390333,-11.77466275,30.92318695,-6.21485803667,10.4203222783,-5.87240970167,-2.46464583333,3.12591849333,2.47681646167,-0.478712817167,0.0499334137333,-1.11487525,-3.75785232333,-4.37545746333,0.195614071,1.24807270333,-0.1224256114,4.69868610333,-4.35694908333,1.26246016833,-5.04513127167,-1.64264077,0.985346491833,-0.555917217167,0.110430753583,0.272937517667,-0.354340961833,0.429960082333,0.949720417,-1.17735038667,-0.118644512833,-0.0458603985333,-1.08717091167,0.311236632167,-0.272153816,-1.64922055333,-0.124870561467,-2.30782625333,-0.193605126667,-0.0724758619667,0.01495513425,-0.4586542185,-0.765259500667,-0.2024041815,-0.125221181,-0.04653309975,0.1941852675,0.4453815605,-0.210377327,0.1834995315,0.0207963532117,-0.526297685667,0.1794926625,-0.4784841885,-0.10307291185,-0.250407334167,-0.649461744,-0.109866224167,-0.218707524333,-0.0156523485033,-0.296987904833,-0.308258573,-0.220841889833,-0.0155142142833],[-39893.0562333,-2789.40157333,-757.096128667,-650.356219667,-481.614003667,-971.656051333,-2646.276055,98.5646146833,-358.262282833,-856.255547167,412.776724667,592.681673,-460.133846,-579.669077,-1278.452705,-121.999046167,-529.237975833,471.613536667,259.974991833,265.823986,489.317069833,121.008753667,-311.396204167,-368.432360333,-93.4078812167,-76.87506275,123.632026,3.67458038,-56.64274685,243.882268,-71.38811855,-100.743598467,11.4805896167,-106.18791785,260.554975,-1.64959841133,27.0682504833,14.0136781667,-24.9435493,-55.7145730833,51.56661375,-43.5007408833,2.21392601267,44.6973949,-29.81854595,110.625787167,3.60748277167,31.6797291833,11.6729383833,11.6018573667,2.12314344,-6.67890341333,-13.3614627833,-1.664625431,-18.7945083667,0.6789067305,13.0549057833,-10.95938355,29.55156475,-6.20208425333,9.367082315,-6.08622173167,-1.52179939367,3.12975059333,2.66347698833,-0.314791994,0.1282277899,-1.0226059015,-3.660708,-4.48564776167,0.258476938333,1.06777398567,-0.063794121195,4.32599811833,-4.18439504,1.17443531833,-5.07044157833,-1.27611532633,1.0971209245,-0.689283658833,0.0899420778667,0.294238925833,-0.298965313667,0.4706716065,0.945732608667,-1.102770485,-0.101222919717,-0.0574251925167,-1.14278415,0.340895385667,-0.351239424333,-1.57431754167,-0.10040740535,-2.256082875,-0.112986589017,-0.0164497303333,-0.0229696461333,-0.475556554333,-0.6968202775,-0.210422723833,-0.1342946665,-0.0408242246667,0.201068519333,0.4346241185,-0.198424049,0.196464177333,0.00675095621833,-0.543052796167,0.186666888167,-0.487169807833,-0.0904907178167,-0.251065744333,-0.627798164833,-0.101670647917,-0.197902937,-0.0274607292167,-0.302810754167,-0.277852790833,-0.205757226833,-0.01342157895],[-40140.3692,-2794.50576333,-489.248631167,-538.036322,-367.666232667,-1100.23314267,-2875.08946333,155.311657717,-302.885619,-872.412085,442.522847,548.563442333,-500.391543333,-522.089896833,-1255.47592,-103.415473417,-555.089870167,479.726992333,254.2720975,254.735075,471.888893333,138.550552167,-338.106752167,-370.371109,-91.5270966667,-85.9668873833,116.426014833,-1.818290005,-56.1543251167,230.2702415,-74.21285625,-109.050402,11.9364575833,-85.3868976333,254.050264167,-2.273129115,25.8289142,10.8421765867,-27.5526242167,-54.7438472333,47.0829567167,-47.2002514167,0.7278598965,43.0144834667,-23.3721687167,106.308625,2.22345329733,28.8470512,11.5668475,11.9359665833,1.902174225,-7.03806179333,-12.9608940167,-2.39500408333,-19.81394495,0.720953243,12.3437881167,-10.0813221333,28.1045524833,-6.128027025,8.28152237,-6.28290108167,-0.534928964833,3.135110135,2.85786380667,-0.141528981567,0.211804775667,-0.928619677333,-3.56985870333,-4.59057992,0.325988681667,0.886187183167,-0.00475504763,3.94593902167,-3.97241702,1.07244750533,-5.07541777167,-0.881550209333,1.203302975,-0.812501165,0.06747306315,0.320835111,-0.237138880833,0.510612154333,0.9402408065,-1.0268654135,-0.0813825273667,-0.06914049045,-1.19617040333,0.3686874515,-0.430439213833,-1.48708681833,-0.0801050958667,-2.19539969667,-0.0212546987,0.0382140101,-0.054390561,-0.490873708167,-0.6232480545,-0.219859488167,-0.1424196835,-0.0341332897,0.207370569667,0.4240049635,-0.185156869167,0.2105033235,-0.00793937895167,-0.559002053833,0.19363324,-0.495933006667,-0.0764659045667,-0.252734533167,-0.603378968667,-0.0902139868667,-0.1769505585,-0.036259411,-0.3088010355,-0.245109162,-0.19110784,-0.0118617381167],[-40336.3049167,-2842.13420833,-216.08547945,-434.3562855,-233.6172555,-1200.13401833,-3072.16311333,225.971599333,-251.1149055,-875.304934,482.822688167,515.253921833,-536.699069,-464.221518167,-1235.39879333,-85.1298667667,-578.034485167,489.339875833,249.436020833,243.5526015,455.240745167,154.400978,-363.427029667,-369.826245,-89.4506617833,-95.3178212,109.007725167,-7.58251678,-55.5517265167,216.720167667,-77.2236331667,-117.1376515,13.1284278333,-63.4432715167,246.531099167,-2.80627068,24.31568275,7.46487581167,-30.1873765,-53.64243855,42.5186909833,-50.8526529167,-0.717387522333,41.48654265,-16.6071667133,101.678486917,0.8097164465,26.0164186167,11.4811309167,12.2246540667,1.63847612833,-7.374822145,-12.5260399667,-3.166963235,-20.814592,0.780077005667,11.6426184167,-9.15449044667,26.61905535,-6.00681731667,7.19871554667,-6.45334665667,0.491887847333,3.14059278,3.06172123,0.0406989215667,0.300877050667,-0.834956918333,-3.49182798833,-4.69286802,0.3961207415,0.704221969167,0.0512354621717,3.57122275,-3.72456165667,0.963485579833,-5.05868955167,-0.459235910683,1.30039004333,-0.925823414667,0.0426210674,0.353995079667,-0.16925675795,0.549821150333,0.933394066667,-0.951771037333,-0.0602885218,-0.0818881232833,-1.24722690667,0.3932699545,-0.507161444833,-1.38847030333,-0.0628659528333,-2.12748295167,0.0823727652833,0.0896452071667,-0.0792759346833,-0.504080576667,-0.5450866605,-0.230751874333,-0.149478230667,-0.0266634699333,0.213125774333,0.413728375333,-0.170785195167,0.2254542035,-0.0234753062117,-0.574155776333,0.200220313333,-0.5047381105,-0.06107294865,-0.255248347333,-0.577164512167,-0.07510558365,-0.1566194955,-0.0419466123667,-0.314785958333,-0.210300594,-0.177266464333,-0.01101945695],[-40479.2454333,-2945.83397333,63.4934733667,-348.8962,-84.9429599333,-1269.34222167,-3228.32235833,319.394717833,-205.7212865,-864.503290833,533.70444,495.490211167,-565.458331,-406.858582833,-1219.18572333,-67.1836224667,-597.751976833,500.593271,245.504460167,232.996865333,439.665796333,168.528518167,-387.250478833,-365.726486333,-86.9941804333,-104.920308733,101.522227433,-13.724274605,-54.8794377667,203.43749,-80.2666279,-124.956391667,15.4638906167,-40.5020324833,238.066595333,-3.18826752167,22.5179036167,3.92207742183,-32.8676315833,-52.4519713333,37.93393385,-54.37221055,-2.0885655925,40.23226705,-9.58166887667,96.8063128833,-0.660838127333,23.2590899,11.4171903667,12.4666029333,1.33782037167,-7.69091865,-12.0614595667,-3.97837538333,-21.7844548333,0.860903943667,10.96766345,-8.197835515,25.13355685,-5.86008611667,6.14958995167,-6.58923246,1.5515508065,3.14162746833,3.27685684167,0.2313903426,0.395495718667,-0.740850803833,-3.432405285,-4.794704475,0.468349973,0.522582657,0.09969741965,3.215576125,-3.447346995,0.853312436,-5.01923416667,-0.0115992242333,1.38480248167,-1.03011559667,0.01445223435,0.394477429333,-0.09630197435,0.588359413667,0.925871128167,-0.879758007667,-0.0387393133333,-0.0962923487833,-1.29582333333,0.413378859667,-0.578497748333,-1.28010509,-0.0478097818667,-2.05412945,0.197649060367,0.1360617802,-0.0981432974833,-0.514489562667,-0.4629414125,-0.243045822833,-0.155556360667,-0.0188303697167,0.218365482833,0.4039206535,-0.155621230667,0.241290570333,-0.0401093514833,-0.588456598167,0.2063548925,-0.513482654,-0.0444743554333,-0.258404971667,-0.5501211495,-0.0562526147833,-0.137586378667,-0.0446768917,-0.320465083833,-0.173776655333,-0.164528735333,-0.0110992831667],[-40572.4806667,-3115.305165,350.328039217,-289.20066,72.0146891,-1307.44194833,-3337.03534,439.9500665,-168.7628905,-840.2828385,594.4836735,491.412530667,-584.287057167,-350.642703,-1207.21640333,-49.584304,-613.986478,513.496763667,242.559458,223.628516667,425.459393833,180.883994667,-409.3832755,-357.2723915,-83.9996963667,-114.7109385,94.1306807167,-20.2957156333,-54.1649409833,190.621376167,-83.25928685,-132.420872333,19.2637075833,-16.745708115,228.741500167,-3.36718417,20.4445593333,0.269068754,-35.60202035,-51.2039305167,33.3904922,-57.6955379333,-3.34573793167,39.3579496833,-2.36134718167,91.7589283333,-2.20030165617,20.6336849167,11.3748537167,12.66031845,1.00825004983,-7.98837069333,-11.5699143333,-4.824098815,-22.7107304333,0.9700004825,10.33567961,-7.22772828833,23.6807333667,-5.70451677,5.160703485,-6.68691113167,2.6364085,3.13348998667,3.50289710667,0.4294670275,0.495096698667,-0.645022874667,-3.39613169333,-4.89595304,0.542904708,0.342239748333,0.137698703833,2.89049214167,-3.14673977167,0.747221664167,-4.95736853333,0.458659254983,1.45390819167,-1.12571172333,-0.0179631278333,0.4423604765,-0.0195645165833,0.626144397167,0.918466247167,-0.812882503333,-0.0169533898017,-0.112715246733,-1.341819295,0.428175454667,-0.641845335333,-1.16368134333,-0.0339551002833,-1.97706509,0.324160737167,0.176013601167,-0.111407224817,-0.521602416333,-0.377671689333,-0.256640180833,-0.160744276167,-0.0110839283417,0.2230741195,0.394683566,-0.140004669833,0.257978894,-0.05805252725,-0.601808728667,0.211990037833,-0.521964708667,-0.026853813585,-0.2619393425,-0.523061409833,-0.0335992515583,-0.120495884167,-0.0446410551,-0.3255864755,-0.135996639617,-0.1531312595,-0.01221252835],[-40623.1875333,-3332.718495,650.85115,-252.7811855,232.871977233,-1317.25969,-3401.895195,576.9420465,-139.925740333,-804.718637333,662.566003333,503.326624,-594.157635167,-295.989367667,-1197.34740667,-32.51712755,-626.848027,527.725172667,241.044084,215.932324833,412.845196167,191.673293167,-429.454496167,-344.842156,-80.5132531833,-124.506015667,87.0519065,-27.1198587,-53.3163965667,178.4420165,-86.3258606333,-139.3897815,24.50952295,7.46247934,218.780213167,-3.32930503667,18.1635600667,-3.39557261983,-38.3678373167,-49.9212043667,28.9596504333,-60.8445003167,-4.445334935,38.9380763,4.94529696,86.6218752333,-3.76108034333,18.1568627,11.3573089333,12.8043396333,0.663931410833,-8.27541731667,-11.0617493667,-5.68729823,-23.5848018667,1.11589921417,9.77210192167,-6.257142615,22.2800847833,-5.54033961667,4.24317424833,-6.76373929833,3.73628251,3.114189645,3.73287921667,0.631824455,0.5962296075,-0.5469305585,-3.382866065,-4.99063907167,0.622466648833,0.166363442622,0.167381361,2.60000698333,-2.82878221333,0.648574841,-4.88087873667,0.947126299167,1.50962157,-1.21111309167,-0.0552385742667,0.495772440333,0.0587459433833,0.662749275,0.912830218667,-0.752472387333,0.00655652071,-0.130319144333,-1.38549466,0.438408515167,-0.696034567833,-1.04206727833,-0.0201038941283,-1.89876349,0.460681583667,0.209534858333,-0.119014574667,-0.5259584805,-0.2913980755,-0.2714316685,-0.1650844775,-0.00390633966167,0.227193035333,0.386410235333,-0.124466452333,0.275468445167,-0.0772319901333,-0.614294242833,0.217251538,-0.529826711167,-0.00859598553,-0.265501480167,-0.496516520333,-0.00734212286667,-0.105909921317,-0.0421609443167,-0.330289974333,-0.09794518755,-0.143188626167,-0.0141019570333],[-40638.2555333,-3573.62199833,971.839151333,-234.491744833,394.1998125,-1302.24717333,-3429.314915,716.863793,-118.272902833,-760.094046,735.017649833,530.746776333,-596.428039667,-243.520714333,-1186.97268833,-16.1993326592,-636.473106333,542.8749205,241.365419,210.450394667,401.794470167,201.059945833,-447.0642945,-329.147858667,-76.62657635,-134.089658167,80.5070876333,-33.9831547167,-52.2068391667,166.973569667,-89.6624733667,-145.713401333,31.0397886,31.734660235,208.409186333,-3.07239728333,15.7526682833,-6.967563505,-41.1308529333,-48.6264406833,24.6976193833,-63.8632293167,-5.34635127167,39.0082999,12.2311067417,81.4681274667,-5.28129852333,15.8325688667,11.3668617167,12.8959805667,0.319092493817,-8.55871665333,-10.5502825,-6.54752389667,-24.3978815667,1.30700697833,9.29579647333,-5.29301737333,20.94157755,-5.36222286167,3.40359980333,-6.84047092167,4.84051702333,3.082122915,3.958121125,0.834749389,0.6955365785,-0.446425824333,-3.38967702,-5.070802915,0.710288235,-0.00233195384667,0.193372509167,2.34470940333,-2.498299415,0.560181732167,-4.798265005,1.449108259,1.554756805,-1.28424968,-0.0978390071,0.552372892667,0.136303021567,0.697708673333,0.910783469,-0.699144368,0.0338104162483,-0.147906030333,-1.42686483667,0.445391739167,-0.740481882167,-0.917845737833,-0.00500523446333,-1.821418725,0.605845735833,0.236996479167,-0.1207057255,-0.5283169265,-0.2064328705,-0.287268199667,-0.168600012,0.002260865285,0.230597026167,0.379563019,-0.109512189283,0.29372235,-0.0974739109,-0.625815950667,0.222277471,-0.536641099833,0.00999847792167,-0.268694031333,-0.47081044,0.0223100728917,-0.0943409080833,-0.0375178753667,-0.334799625333,-0.0606774148333,-0.134765815,-0.0164404177333],[-40630.2562833,-3825.31771667,1308.50539917,-230.8878295,549.657523333,-1270.79044333,-3425.50493,845.839012167,-102.820294483,-709.017239333,808.295198333,572.662804833,-593.498263833,-193.551380167,-1174.42621,-0.55804867,-642.886533,558.538416333,243.838398833,207.3186565,392.2449585,208.8780225,-461.8554925,-310.867697333,-72.3463223167,-143.180181333,74.71614685,-40.6711923667,-50.7881845167,156.305632333,-93.5436260667,-151.225585833,38.6943019333,55.7159411,197.8096745,-2.59701024833,13.301273,-10.3337761817,-43.8512180167,-47.3423165,20.6655354167,-66.8049582833,-5.99772133667,39.57633615,19.4090040667,76.3530810833,-6.71012472167,13.66307625,11.3990231667,12.9329058,-0.00785817206667,-8.84035747667,-10.041283535,-7.384171425,-25.1395603167,1.55591404167,8.91609594667,-4.340198195,19.66990225,-5.166123575,2.64552917333,-6.9337187,5.93970358667,3.03375326667,4.16955887167,1.03455414533,0.790852021167,-0.340866486333,-3.41299992667,-5.12789955333,0.810494928167,-0.162137152212,0.220286355667,2.12432898333,-2.159894355,0.484602888833,-4.71666539,1.95972982,1.59159150833,-1.34367811,-0.146475824317,0.609522762667,0.210512893167,0.730436825333,0.914158883,-0.653272393333,0.06695700195,-0.1642521865,-1.46578236,0.450551681,-0.7746628815,-0.793156602833,0.0124313179717,-1.74674667167,0.758274567167,0.258458525667,-0.116447755333,-0.5293013875,-0.12486090085,-0.303905013667,-0.171436751,0.00692457701333,0.2330490335,0.374444352833,-0.0956441852667,0.3127838675,-0.11864517635,-0.6361306595,0.227190988667,-0.541982083167,0.02873798351,-0.271168614333,-0.4462034425,0.0550890911667,-0.0862435226833,-0.0310491606667,-0.339257761167,-0.025103681955,-0.1278990005,-0.0189632703667],[-40608.9276167,-4071.92147333,1648.25887,-239.656854333,694.589676833,-1234.94882667,-3393.35312333,949.3304115,-93.0637715333,-653.845813667,878.4430075,628.814403333,-588.4363255,-145.552487417,-1158.39905167,14.5214356408,-646.111993333,574.302457167,248.992612,206.486396833,384.371109833,214.9082375,-473.325516,-290.594067333,-67.6393524667,-151.5081575,69.8878511667,-46.9435014333,-49.0394091,146.623343167,-98.2383237,-155.673890333,47.3740583667,79.07785985,187.148356167,-1.901519875,10.8896970983,-13.3758013,-46.49795625,-46.0914597,16.9416483167,-69.7144397833,-6.324032085,40.6534046833,26.4116344333,71.3335706167,-7.99862679667,11.655953155,11.4480030167,12.91099405,-0.295248223017,-9.12537217,-9.53703564833,-8.17786484833,-25.7961065333,1.880266915,8.64257589333,-3.40084388667,18.4721688167,-4.94675086,1.97357839833,-7.05688765833,7.02541825667,2.96511197667,4.35851991333,1.22746799833,0.879577400667,-0.226426112833,-3.45011324333,-5.15339931333,0.927577800167,-0.310809138667,0.252794026833,1.94003706667,-1.81806459167,0.425808025333,-4.64224097667,2.47411216667,1.62217226167,-1.38792431333,-0.202019923667,0.6647785995,0.278568001167,0.760229166833,0.924689540167,-0.615440492333,0.107870084467,-0.1783237285,-1.50208865667,0.455314277,-0.797626199167,-0.670029968167,0.0336427518167,-1.67609797,0.9167701695,0.273770025333,-0.106152959167,-0.529380475333,-0.0486452880667,-0.321087616,-0.173727993833,0.0095755841,0.234325451,0.371255159167,-0.0834175960167,0.332659457333,-0.140699492333,-0.645012235833,0.232038419167,-0.545384459167,0.0474171328167,-0.272510937833,-0.422931776833,0.09075405955,-0.08201528675,-0.0230820537667,-0.3437124295,0.00797857048,-0.122608695667,-0.0214205075667],[-40580.0898833,-4308.23566333,1967.14108833,-262.293834833,824.706955167,-1207.95836167,-3331.16433333,1015.16827983,-89.5846320333,-595.838431833,941.767926167,699.547628167,-584.211459,-99.17150895,-1139.39512833,29.1419143,-645.972462667,589.765064333,257.165092333,207.603650333,378.287128667,218.4499385,-480.860507167,-268.6386365,-62.4129761667,-158.873336,66.1806514833,-52.64698065,-47.0339579333,138.104886167,-104.028165383,-158.750953667,56.9860227333,101.586824783,176.451394333,-0.976091318333,8.55714957667,-15.99503335,-49.04636105,-44.9017604333,13.6024641667,-72.6194085333,-6.236604875,42.2078034,33.2075902833,66.4158013667,-9.108422315,9.832309885,11.5054045,12.8209886167,-0.5239214265,-9.41487546167,-9.03673128333,-8.91030140167,-26.3533626833,2.29960719333,8.46602662667,-2.46876123833,17.3451060167,-4.69686624333,1.3950955585,-7.21121247,8.08806445167,2.871781035,4.51824578,1.41063059,0.960035929333,-0.0990732694167,-3.49855106333,-5.14113439167,1.06582628767,-0.449614893333,0.296424628167,1.79147130833,-1.47364399333,0.386692957833,-4.57568818833,2.98721659333,1.64670787333,-1.41534216667,-0.265026935,0.716581715833,0.338166264167,0.786267008833,0.943664688,-0.5860831625,0.157592708,-0.189146878333,-1.53549789167,0.461205848167,-0.808878294,-0.548740647167,0.0591719321,-1.60932085167,1.08018251183,0.282413483,-0.0895369127167,-0.528392015667,0.020812709,-0.338438963333,-0.1755035745,0.00979169205667,0.234124317833,0.370073226,-0.0732486512333,0.353317114,-0.163539426333,-0.652029424333,0.236936698333,-0.5465843605,0.0662406348333,-0.272557146,-0.400906009167,0.129107157283,-0.08187816385,-0.0137850812133,-0.347923023667,0.0380450704117,-0.1189711825,-0.0236720624167],[-40539.5465333,-4536.64353833,2268.99612,-302.948599833,938.1603975,-1191.82898,-3239.44229833,1037.81595167,-93.9568972,-534.996073167,996.928243833,782.941037,-582.020403167,-56.6690255833,-1119.388475,43.3167160667,-642.335033,604.469353333,267.679010333,210.4973895,372.83795,218.590382333,-484.065334833,-245.148977833,-56.5609572833,-165.274139,63.53424575,-57.8748305333,-44.8374372167,130.518996833,-111.108923,-160.275443833,67.3393134333,123.086263333,165.502828,0.187273161667,6.27157036167,-18.1691391333,-51.49307295,-43.7978372667,10.63082793,-75.5154076833,-5.70348138667,44.1170403833,39.7806348333,61.4917878167,-10.0170756767,8.21242909333,11.561593,12.6479923,-0.685345118167,-9.703707215,-8.54214294167,-9.57428526833,-26.7999711,2.81426017833,8.34318266833,-1.540525794,16.2468500667,-4.407788415,0.9093742205,-7.38128706333,9.11698309333,2.75062170667,4.64627217667,1.58345084,1.03307815867,0.0421691256667,-3.55364806333,-5.08999116833,1.22463546167,-0.587031881667,0.353619191833,1.66695917833,-1.12311142617,0.363616106833,-4.50932031167,3.49336995333,1.66391193833,-1.42458361333,-0.335212774667,0.765275115667,0.388669656667,0.808172478333,0.971148759333,-0.563795725333,0.215497824833,-0.196301320333,-1.56632347833,0.468915365167,-0.810943886167,-0.427403203,0.0865922672333,-1.54331764167,1.24689514333,0.283992398333,-0.0663053120833,-0.5255844875,0.0829238749,-0.355446998667,-0.176460484167,0.00757975560833,0.2322218055,0.3708539525,-0.06493961715,0.374553863,-0.1868611295,-0.656663800333,0.241967304,-0.545934175333,0.0859652051833,-0.272012787167,-0.379097873167,0.169704117667,-0.0855554190333,-0.00320647140167,-0.351381739167,0.0650033224167,-0.117108806333,-0.02568857275],[-40490.7458333,-4761.59236833,2566.46895833,-367.507195,1037.53154633,-1182.61647167,-3121.14343167,1018.154518,-106.855505483,-469.912835,1043.8405295,875.232274833,-582.418805833,-21.0083335033,-1100.72657833,57.5797770667,-635.116991833,617.7767425,279.228934833,214.746202833,366.421327833,214.771487333,-482.932052333,-219.849410333,-49.8832069,-170.844061,61.7098776,-62.8100483833,-42.5604558333,123.458857,-119.443747,-160.1789635,78.3006434833,143.499433667,154.017496833,1.58264440833,3.97601028167,-19.92041285,-53.8218622833,-42.78588915,7.96468674,-78.3502711,-4.71278909167,46.2426046,46.1162003833,56.4390347333,-10.7451777167,6.81169043,11.5962135,12.3854841333,-0.772227279667,-9.97854155167,-8.048208165,-10.1668174617,-27.1286114667,3.42171324667,8.22440603333,-0.623325644333,15.1343518,-4.083791765,0.512648212833,-7.54255834833,10.10681925,2.59677221167,4.74516820333,1.74821473667,1.10098967833,0.197750017917,-3.60850584167,-5.00364578167,1.40227743167,-0.731728062333,0.4216653305,1.55407138667,-0.764637810333,0.351988739667,-4.43298360833,3.989133475,1.67076427833,-1.41665478,-0.412135697,0.812000763167,0.430436211167,0.8257833885,1.0063385995,-0.545786057,0.2798599215,-0.199719800833,-1.59463706833,0.478081833667,-0.806988712833,-0.3041963935,0.113456708233,-1.47492426667,1.41570071167,0.277756687167,-0.0371165199183,-0.520147452667,0.137896514683,-0.3715419695,-0.176443772667,0.003068895165,0.228516520667,0.373378037,-0.0578726204333,0.396170196667,-0.210359626167,-0.65847272,0.247189259667,-0.543985494,0.107221451217,-0.271446152167,-0.356571001167,0.212109536,-0.09270728125,0.00843766711,-0.353634714167,0.08904387305,-0.117053548333,-0.0276320050667],[-40449.6446167,-5001.31188333,2857.96584667,-460.909521667,1121.683105,-1179.47306167,-2979.662295,958.805724333,-127.451959333,-399.694124167,1082.20567,971.986529167,-586.269214667,4.28498353667,-1085.7604,72.9619712,-624.14772,629.094143167,290.229879,219.547035667,357.255507667,206.4397225,-477.537748167,-192.483506833,-42.1013330167,-175.626046167,60.4875321833,-67.6759960667,-40.40960435,116.501115,-128.978,-158.405353167,89.7044222333,162.794585167,141.708840333,3.195052465,1.65070157417,-21.26798375,-56.0030507833,-41.8722278833,5.55137925667,-81.0698124167,-3.250742675,48.4378180167,52.21085065,51.1435879167,-11.3287097333,5.65392541167,11.5796417667,12.0368367833,-0.777790035,-10.2168718067,-7.54318193,-10.6796729167,-27.33273735,4.12158407,8.06213213167,0.276005907667,13.9699054667,-3.73488389667,0.20599761405,-7.66977157,11.0509832167,2.40284251833,4.81828849167,1.90691839833,1.16870841667,0.37015238,-3.65501548333,-4.88587428333,1.59746293833,-0.890466879833,0.4963992025,1.44226899333,-0.397675709017,0.34896084,-4.33680823833,4.470559735,1.66410881667,-1.393085095,-0.4956533275,0.857276777,0.463779253,0.8393889735,1.04850160833,-0.529107606833,0.3490645485,-0.1992842365,-1.61990755667,0.487759447167,-0.799710439667,-0.177491328183,0.1378239505,-1.40133793333,1.58525928,0.2630466275,-0.00289919215667,-0.511199507667,0.186263692333,-0.386130199167,-0.175606298667,-0.00361899194833,0.222906620167,0.377288547667,-0.05138320195,0.418020186667,-0.233714562333,-0.656964149333,0.252549085167,-0.541192243,0.130554174833,-0.271246842833,-0.332537537833,0.255932851167,-0.102935631367,0.020890577235,-0.354198297167,0.110493429333,-0.118834182167,-0.02972259675],[-40430.0088333,-5273.52740167,3133.733965,-586.029665333,1187.50475667,-1181.81492167,-2818.28822,862.7042755,-154.5435715,-324.240650167,1112.18890667,1068.504068,-594.932528667,15.8655692633,-1076.61329333,90.4354172333,-609.3226875,637.9422415,298.951694167,223.754785167,343.705144,192.992882333,-467.997754167,-162.900096333,-32.9706419333,-179.616109167,59.64421105,-72.7267803833,-38.6699871333,109.299102167,-139.6844145,-154.891916833,101.371634467,180.968464833,128.3066325,5.0040049,-0.704953911667,-22.2412924333,-58.0041271667,-41.06131815,3.36436929167,-83.6249925333,-1.29656288167,50.56913405,58.0664178167,45.49503095,-11.80829085,4.76149526333,11.4823955167,11.60780445,-0.699048019833,-10.3925552167,-7.00836476167,-11.0996074167,-27.4041200167,4.91671896167,7.816872795,1.14959606,12.7150703833,-3.372588005,-0.00923526546667,-7.73854817167,11.9423013167,2.16191286833,4.86803177333,2.061264345,1.24221494,0.564168877333,-3.68549937,-4.739185035,1.809510275,-1.067994057,0.5718756815,1.32066193833,-0.0217565239,0.3517856645,-4.211063235,4.93340096333,1.641319075,-1.35590260333,-0.585477450333,0.9010969815,0.489273433167,0.849357754167,1.09704357833,-0.511420118167,0.421783460333,-0.194845998333,-1.64143608667,0.496355963,-0.791712327333,-0.0454666921833,0.157691456833,-1.31968453333,1.75411093167,0.239434957,0.0350995471817,-0.497910230167,0.228737512333,-0.398606534667,-0.174173836333,-0.0122620429933,0.2152104115,0.382064924833,-0.04496188495,0.4399552355,-0.256628952,-0.651720795,0.257895425167,-0.537891689167,0.156560622667,-0.2718060085,-0.306149006833,0.300807818333,-0.115808925333,0.0338101978,-0.352562692667,0.129750055833,-0.122437631,-0.03218640185],[-40438.6179667,-5568.976625,3389.50469167,-740.330398833,1235.21294333,-1186.54155,-2647.73476167,730.656017667,-186.287041,-244.650594,1134.381735,1158.98025667,-610.066948333,12.8734737483,-1073.72927,110.5460571,-590.950695667,643.866351833,303.898977,226.422002,324.912664667,174.219372667,-454.691636,-131.458486767,-22.4266437,-182.787403833,58.9590217667,-78.0905080333,-37.5190571,101.6162064,-151.559407667,-149.667170833,113.043736667,197.987074,113.751876633,6.97696970833,-3.0543007875,-22.8702170833,-59.7784574833,-40.3461122833,1.372423545,-86.0035332667,1.15227801333,52.5377793667,63.6636220667,39.4484634333,-12.1999837667,4.10660955,11.2868120667,11.1097662833,-0.534802645333,-10.4841659167,-6.43170495833,-11.4178393,-27.3392454833,5.80892309333,7.46939214167,1.98529926333,11.3384062917,-2.99902073667,-0.149543633117,-7.73626666167,12.78210965,1.87123890667,4.89465313167,2.21236509333,1.32570802167,0.782156578333,-3.69310047833,-4.563707345,2.03777525667,-1.265596765,0.641879182,1.17717088333,0.364598227983,0.355306519833,-4.05003590833,5.37681581667,1.603296475,-1.30786513,-0.681146408167,0.942481316167,0.507485055,0.856042353,1.15125884333,-0.490617939,0.4975524435,-0.186303724833,-1.65896351,0.5023684695,-0.785823158333,0.0932978065167,0.171458309167,-1.22765446333,1.92139178667,0.207701697833,0.0754436734,-0.480497621833,0.265755902167,-0.4086148505,-0.1723932175,-0.0226052218167,0.205342428333,0.387306538667,-0.03820610835,0.461794244,-0.278811195333,-0.642648475167,0.263072547,-0.534244843333,0.185653347333,-0.273287864333,-0.276502914667,0.346384752,-0.130819328667,0.0468646646667,-0.348643464833,0.147047361333,-0.127586915167,-0.0350628219667],[-40483.5154,-5872.41915333,3626.178265,-918.9234045,1264.57957667,-1192.43858167,-2480.74251667,564.814640333,-220.508721167,-163.372332533,1149.34545667,1238.86831833,-631.875223,-3.19390415667,-1076.44027167,133.335187167,-569.6706515,646.8741445,304.216292167,227.3980555,300.997084333,150.253827833,-438.111824333,-98.9400767833,-10.639096035,-185.072213833,58.3938695,-83.79557705,-36.9093708833,93.3992192,-164.675232667,-142.905672,124.413402333,213.7503995,98.2277306333,9.06209650167,-5.319934865,-23.16207575,-61.2861489667,-39.7150508833,-0.459873298333,-88.27370045,4.03918855667,54.2734954667,68.95338245,33.0498058333,-12.4869625667,3.63111981833,10.9928223333,10.5624940567,-0.28853815395,-10.47527185,-5.82111292167,-11.6367325167,-27.1531786333,6.78802686167,7.01403972667,2.77355961833,9.83142946833,-2.60125948667,-0.246881735167,-7.66534819,13.573359,1.53503672833,4.89749151,2.35924565,1.42279923167,1.01999925633,-3.67421863,-4.35813578333,2.279943795,-1.48244235,0.7054795345,1.00484915933,0.7651873885,0.3512435905,-3.85357474333,5.80152821167,1.55395608,-1.25041070167,-0.781712659167,0.979588599333,0.518558631,0.8598802105,1.21010088333,-0.465376829167,0.577514251167,-0.173824003333,-1.6723505,0.506135992667,-0.783796416333,0.23977719955,0.177571612333,-1.12449938667,2.08675273667,0.169632469667,0.11779309275,-0.459910486167,0.297152630333,-0.416171515667,-0.170660155833,-0.0345427152,0.193255988,0.392975159,-0.0309352484833,0.483603958,-0.299981228833,-0.629742390667,0.268119699833,-0.530288725167,0.217997244833,-0.2757773835,-0.243153105167,0.392424216167,-0.147377353167,0.0601295566,-0.342790959,0.1622867495,-0.133932178833,-0.0381736645833],[-40563.9828333,-6167.85075333,3845.23016167,-1116.65589067,1276.43552833,-1199.11085333,-2328.742195,369.982238667,-255.663410833,-82.491529155,1157.61163833,1304.396805,-659.157433667,-30.3929909517,-1083.78290167,158.555799167,-546.036731,647.079728167,299.283611333,226.896464167,272.3229905,121.416938017,-418.765364833,-66.0599395,2.17449329333,-186.401752,57.9430920167,-89.8269000333,-36.7405975,84.6519784333,-179.040260833,-134.820995667,135.207057167,228.121674333,81.94753995,11.2136538583,-7.432838485,-23.1256758333,-62.4825662667,-39.1617743667,-2.167218165,-90.4970083333,7.28742625833,55.7186409333,73.86542505,26.36347375,-12.6534196667,3.27715735167,10.6058333333,9.983250415,0.0331542228667,-10.3501371667,-5.19033134333,-11.7617089667,-26.8618697667,7.83934794833,6.448803855,3.50150163,8.19356811,-2.16663417167,-0.3332631525,-7.52929402333,14.31682115,1.159055895,4.87568634667,2.50057839333,1.53639687667,1.27207414333,-3.62627698333,-4.12139118333,2.533066985,-1.71709590667,0.7621872825,0.7994217895,1.1832186065,0.331404782167,-3.62206694667,6.20728509,1.496859865,-1.18482290833,-0.886067741667,1.0106752215,0.522812541,0.8611092545,1.27236295833,-0.4346078585,0.6627794185,-0.157571852167,-1.681394555,0.508429885833,-0.7867455595,0.394604666833,0.174563631167,-1.00989036317,2.24951728333,0.126757547967,0.161892953833,-0.437080233333,0.322660660333,-0.421330964667,-0.169318513,-0.0479365342667,0.178886258667,0.399060498167,-0.02301831765,0.505432342833,-0.319818912167,-0.612999827833,0.273167711167,-0.525983777167,0.253632608833,-0.279299227833,-0.2058808695,0.438654141667,-0.164990014833,0.0737153894167,-0.3353563575,0.175296242333,-0.141102754333,-0.0413390494167],[-40664.9238667,-6424.77106333,4059.101395,-1327.947825,1277.725425,-1202.71188167,-2200.99124,154.951657067,-291.269581333,-2.95734753667,1160.13286833,1352.91422333,-688.8219305,-66.7204385333,-1093.59319167,185.545111667,-520.653307167,644.492409333,288.818953333,225.557018333,239.333840667,88.6340432,-397.2287015,-33.2775787477,15.743627715,-186.817189167,57.54663925,-96.1167510667,-36.8760900333,75.41894485,-194.450756833,-125.667247,145.292176333,240.885710167,65.1565826667,13.3966850833,-9.36233453833,-22.7786343167,-63.3301338167,-38.693934,-3.77207618333,-92.6918605333,10.8038277233,56.8674690167,78.2857572333,19.4801606333,-12.6986054167,2.989930285,10.1375566267,9.38380810167,0.42367643305,-10.1011134883,-4.56009171833,-11.79630935,-26.47928855,8.94529026,5.78468332333,4.14265947,6.43602047167,-1.69347921333,-0.4378773565,-7.334314995,15.0101166667,0.750568669833,4.82903372,2.63552956667,1.66666646167,1.531585505,-3.54726257333,-3.85448223167,2.79422910833,-1.96663614333,0.808356629167,0.560269465167,1.616870065,0.288943789667,-3.35809468333,6.59200026167,1.43463081667,-1.11285834,-0.992903510833,1.03457852,0.520734391833,0.859601875667,1.33685902167,-0.397702759,0.753596454833,-0.137482714333,-1.68615457333,0.5096785945,-0.795000282333,0.5569218545,0.161451616667,-0.884621556833,2.408267595,0.0800442598,0.206964535833,-0.412928673,0.341772397833,-0.424152158333,-0.168527564833,-0.06263279685,0.162234165667,0.405607898833,-0.014472251195,0.527184184833,-0.337951545333,-0.592585974,0.278400791833,-0.521206180667,0.292299699833,-0.2836848105,-0.164860021,0.484639602833,-0.183397226,0.0874842342833,-0.326676361833,0.185724007833,-0.148694445333,-0.0444171198833],[-40750.3283833,-6593.17952167,4293.448965,-1545.53717167,1283.80912,-1194.719875,-2103.73972167,-66.9429702333,-327.879293333,76.067613145,1158.65885833,1383.32928833,-715.593267167,-109.99323995,-1102.38920167,213.114897667,-494.080191667,639.081518167,273.021848667,224.5855065,202.612463667,53.51972295,-374.126264,-0.764603340667,29.69316615,-186.486401333,57.0866399833,-102.517372,-37.0956967667,65.80650835,-210.443485333,-115.726116167,154.703831833,251.755149167,48.1425005,15.5767256,-11.1320580867,-22.1544490167,-63.7988164,-38.32607705,-5.279711315,-94.8153815833,14.4814574333,57.7800668833,82.06061425,12.52374593,-12.6353977833,2.72024346,9.607108245,8.76544065333,0.8737166715,-9.73128795167,-3.96024541167,-11.7419409,-26.0134653,10.0846225367,5.05096528,4.65750912,4.585169775,-1.19064220333,-0.5851965945,-7.08928469333,15.6486528167,0.319792891333,4.757509925,2.76329971167,1.80995930667,1.78892354167,-3.43607261,-3.56063169333,3.05986685333,-2.22532019833,0.836637459,0.291714726492,2.05916877333,0.219289679,-3.06648795833,6.95250867333,1.368914985,-1.03644978983,-1.1002943715,1.05101721833,0.513062139167,0.8546737205,1.40199052167,-0.3546822125,0.848884715667,-0.113467530583,-1.68683336,0.509588327167,-0.807773197833,0.724173056667,0.1380525295,-0.750703948667,2.56117406167,0.0298510903833,0.2519200395,-0.388423897333,0.353794040667,-0.424681273167,-0.168097542,-0.0783836699,0.143392876167,0.412713284,-0.00548103489333,0.548442257,-0.3539626395,-0.568911932333,0.283941876833,-0.515715255833,0.333325466333,-0.288508307,-0.12072817145,0.529868428333,-0.202615044333,0.10114343835,-0.317124761,0.1930789925,-0.156292323833,-0.0472930815],[-40774.2044667,-6620.85082167,4570.20960167,-1759.53232167,1313.32376333,-1167.69459833,-2039.496655,-283.7664051,-365.803685,156.48282575,1154.87253833,1396.057675,-734.279382333,-157.703161167,-1106.26509833,239.985674167,-466.712518333,630.818976833,252.535510667,225.262209667,162.922232667,17.9244130833,-350.0462955,31.3371159857,43.6050453167,-185.595289667,56.4389366333,-108.805913333,-37.1340726667,56.0034537,-226.456530333,-105.240672617,163.513459,260.464338167,31.1918115667,17.70908595,-12.7859423,-21.2874843333,-63.86340385,-38.0627162167,-6.67097736,-96.7983669167,18.22422145,58.5362731833,85.0511497833,5.62563169167,-12.4714222833,2.43311331333,9.033400305,8.12422308167,1.37406417283,-9.250810555,-3.42093924167,-11.5962439667,-25.46834165,11.23904135,4.28497046167,5.01216670667,2.67384484583,-0.666126644333,-0.791207293333,-6.80428560667,16.22726895,-0.121990065333,4.66096817167,2.88308439333,1.96063644667,2.03382694667,-3.29201358833,-3.2437444,3.32703431167,-2.485505105,0.840474393,0.0008437528,2.50273859167,0.121511008488,-2.75321548333,7.2859729,1.30109346167,-0.9574028905,-1.20597951167,1.06010320833,0.5005567535,0.845486588833,1.46592635667,-0.305985237333,0.946877574833,-0.08536151405,-1.683566395,0.507861680833,-0.823527802333,0.893535366333,0.105219120217,-0.610610571667,2.70669019667,-0.0235730462667,0.295741343,-0.364531296333,0.358168135,-0.422964383167,-0.167674825833,-0.0949081382167,0.1225432505,0.420440813833,0.003663919585,0.568630404167,-0.367453678833,-0.542526361167,0.289864392,-0.509144403167,0.3759237535,-0.293117928167,-0.0742694445,0.574006007333,-0.222712376333,0.114439163,-0.307070492667,0.196957437167,-0.163516815,-0.0498353648833],[-40735.7516833,-6512.62017,4869.9493,-1960.66378,1368.61866,-1131.67927833,-2005.62297667,-498.792185,-402.1563345,237.767261,1147.3804,1392.65425,-745.862119,-207.178160167,-1102.82446,266.1430035,-438.7311335,619.6837305,228.269664167,227.406769333,121.211018367,-17.1214062333,-325.503230833,62.4043516167,57.2634287667,-184.081311,55.6349049667,-114.728308,-36.8546257333,46.3565779167,-242.237018,-94.3009863,171.563932833,266.979811,14.473818585,19.7190266667,-14.2948491167,-20.1528545667,-63.50966455,-37.8558803,-7.86727615,-98.6413005167,22.0041504167,59.13755175,87.2570625667,-1.13664202,-12.1772980667,2.13497158833,8.41209097333,7.466094305,1.92891945,-8.672150285,-2.94255246833,-11.34638525,-24.8504969,12.4129129167,3.50976507333,5.22006404167,0.723860846667,-0.107666561,-1.05179558433,-6.48997594,16.7425306333,-0.568617022333,4.53814910333,2.99427640833,2.11427137333,2.26394400667,-3.11466424,-2.90441459167,3.59815744333,-2.73937433,0.8243156195,-0.305824705175,2.94848492,0.00249422795333,-2.424824035,7.59233823333,1.23337902,-0.877415572667,-1.308144695,1.06088213167,0.4829505075,0.831647147833,1.527518515,-0.252806650167,1.047070935,-0.0526625850333,-1.67583796167,0.506014276833,-0.840316634833,1.06469609033,0.0656614818333,-0.466336001833,2.84489537667,-0.0791943783833,0.337930564167,-0.342055275667,0.355254260167,-0.418960382,-0.167251002,-0.1122448553,0.09986066425,0.4285086035,0.0124084598533,0.587565722667,-0.378370721333,-0.513864404333,0.2962814985,-0.500886470833,0.419814954833,-0.2966420055,-0.0259145348667,0.617446377,-0.243372926,0.127409904,-0.296756249167,0.197567961667,-0.170176189667,-0.0518276081833],[-40637.6548833,-6325.21654667,5166.97077333,-2147.947085,1443.53992167,-1098.14429167,-1990.36409833,-705.453157167,-435.5073755,320.313604333,1135.27100833,1375.935225,-749.655348167,-257.667718,-1091.96845333,291.954660833,-409.795795,605.8046675,200.7415385,230.482798333,77.90344415,-50.97680655,-301.2001275,92.7898559167,70.6674657167,-181.895793667,54.67225765,-120.2256685,-36.30817935,37.1836186333,-257.410644667,-83.0629980833,178.9418275,271.349473667,-2.07623787667,21.5504820833,-15.6726944,-18.7451934333,-62.74308335,-37.6694616667,-8.77214461167,-100.283271883,25.7735719333,59.5776116833,88.6998763,-7.74851080833,-11.7792190333,1.88923285667,7.72718559,6.79369818333,2.542111685,-7.99902290667,-2.51400803833,-10.9764106833,-24.16295625,13.6074022667,2.72996860667,5.293300175,-1.24207380417,0.477299357667,-1.34298185,-6.14153024,17.1833496833,-1.0173815215,4.39190255167,3.098183125,2.269514745,2.48032983333,-2.90460944167,-2.548134265,3.87554825667,-2.98257993,0.7897715535,-0.616824279833,3.39468483667,-0.127992573678,-2.08380839167,7.86900426333,1.16220667,-0.799017023667,-1.40487153,1.05371069833,0.460513525167,0.812803589833,1.58544468167,-0.196735141667,1.14737686167,-0.0147418370667,-1.66260551833,0.504975218333,-0.855159259167,1.23777347833,0.02169322235,-0.320175076667,2.975505125,-0.138118093933,0.377591937333,-0.320579271333,0.34621201,-0.412412499167,-0.166875878333,-0.130460870833,0.0753581040833,0.436367490833,0.02023573115,0.605133695833,-0.386605087833,-0.483059551833,0.303384853167,-0.490489809167,0.464869675833,-0.298405274167,0.0233603757,0.660672172167,-0.264586356333,0.139995842833,-0.285958369833,0.1954320145,-0.176348640333,-0.0533868293],[-40491.0218833,-6119.64336667,5439.60632667,-2328.01254,1529.75343,-1076.33451,-1979.58688167,-891.8772935,-466.232649333,403.6418905,1118.26761833,1348.56570833,-744.126614833,-307.96091,-1074.72476667,317.761024,-379.931187833,589.327498667,170.0213275,233.7163605,33.4657801,-83.3348659333,-277.786587833,123.133707167,83.9347639167,-179.110494833,53.5045692833,-125.419666833,-35.6659541167,28.7473257167,-271.626653667,-71.6400451,185.762131667,273.723616,-18.5469014983,23.1818563,-16.9500942333,-17.0725513333,-61.60371205,-37.4825497167,-9.32448568333,-101.665249167,29.4947609,59.8180413833,89.4408876833,-14.1993168367,-11.3155077667,1.77787755167,6.96483642667,6.11663097833,3.216546015,-7.236033725,-2.12106083833,-10.4821841617,-23.4142026167,14.8229451,1.93276616167,5.25435488833,-3.20189349,1.08034718467,-1.63278382167,-5.74641673167,17.5425106667,-1.46658083333,4.22923167,3.19687425333,2.426599155,2.68571667,-2.664720525,-2.18297053333,4.15973141667,-3.21527799,0.739811418667,-0.922008577167,3.84138342,-0.258764870833,-1.72993913167,8.11549829,1.08189346917,-0.724684143333,-1.49454487167,1.03968084667,0.433797152833,0.789245235,1.63857002,-0.139320164183,1.245399325,0.0283866420167,-1.64323639,0.505781923167,-0.866106167667,1.41398004833,-0.02459961215,-0.173999846167,3.098850005,-0.202197823333,0.413997836333,-0.299605459333,0.332716551167,-0.403113158167,-0.166702028167,-0.149617880167,0.0491976061167,0.443434282333,0.0268507197667,0.621419694833,-0.392126969167,-0.450105951,0.311374339333,-0.477906713,0.51124143,-0.297925453667,0.07260541685,0.7042795965,-0.286420362667,0.152309310833,-0.274465763167,0.191283256167,-0.182152804,-0.0547560381333],[-40321.9879167,-5960.73515667,5668.27198167,-2508.00442333,1616.25331167,-1072.17947333,-1962.47717833,-1051.88019383,-494.2644145,486.768012333,1097.04832167,1312.370645,-729.6508005,-356.1713455,-1053.30726167,343.988695333,-349.2471595,570.597240167,136.085532017,236.1707335,-11.5688785167,-114.379044433,-255.550035833,153.661551833,97.16762895,-175.801693333,52.0994973667,-130.419054167,-35.0658921,21.2189395333,-284.678910667,-60.0165812667,191.971289333,274.350293333,-34.9859521167,24.5922336833,-18.1531712833,-15.15785755,-60.1334938667,-37.2572066833,-9.507516395,-102.7420025,33.1572870167,59.7922077833,89.5983485167,-20.471295,-10.7876956,1.88631010333,6.11418113833,5.44350701833,3.94857830833,-6.39262700167,-1.746897675,-9.87067737833,-22.61058985,16.0571297167,1.103713136,5.14410914667,-5.13776511667,1.70837590167,-1.88508602833,-5.290895915,17.82059205,-1.91405444167,4.056583345,3.29100023333,2.584465605,2.88225868833,-2.398963545,-1.81576262,4.44867926333,-3.4370792,0.681929018,-1.2145135715,4.29268819,-0.377614704833,-1.36188053567,8.33507278167,0.987353554667,-0.654901616167,-1.57561877,1.01995449867,0.403362343167,0.7613399445,1.68571831833,-0.0816929047,1.33908190333,0.0760871449833,-1.61707666833,0.509828079167,-0.8722840345,1.59492782667,-0.0710459011333,-0.0291521913333,3.216471455,-0.272980138167,0.447540309,-0.279170565167,0.316709470333,-0.390931956333,-0.166814716833,-0.169621977833,0.02167802169,0.449184175667,0.0321766783167,0.636512246333,-0.394945325667,-0.415035247667,0.3203520885,-0.463266913667,0.559071237333,-0.294869554333,0.1210874882,0.749045086167,-0.308872957,0.164835091,-0.2623457705,0.186004151667,-0.187741268,-0.0560749325],[-40145.4342667,-5893.69298,5832.22818167,-2693.05227167,1693.11271833,-1087.298205,-1931.68598667,-1179.12339333,-519.5568705,569.215425333,1072.51829167,1268.89915333,-707.280455,-399.505063167,-1029.85039167,370.966696667,-317.976957833,549.960757167,98.9806289,237.277141167,-56.3695104,-144.037286833,-234.72213,184.323079167,110.3532903,-172.101104167,50.4205013333,-135.252663667,-34.6015565333,14.738098715,-296.4145525,-48.2125135,197.396885,273.472682,-51.33675875,25.7539425,-19.2947447833,-13.0439048667,-58.3608550833,-36.9593682,-9.31701482333,-103.459404833,36.7673830667,59.4391834167,89.3093772833,-26.5118933167,-10.1802722933,2.28273419167,5.17364568667,4.78162721167,4.73293083167,-5.48210299833,-1.37587653167,-9.15071633167,-21.7560384833,17.3041897,0.232020744833,5.00346314833,-7.02615955167,2.37078605,-2.06483901333,-4.76542844833,18.0227607167,-2.35617385333,3.87905273167,3.381586625,2.740640355,3.069484595,-2.11100956667,-1.45312225833,4.73996848167,-3.64547016,0.6263183555,-1.48765234667,4.753785915,-0.4723513595,-0.9797480785,8.53158454833,0.874699779833,-0.590556183167,-1.64642075333,0.995788391833,0.369729369667,0.7291833505,1.72556570333,-0.0246394525833,1.42676731667,0.1276769905,-1.583170265,0.5183905145,-0.872988676833,1.781428245,-0.114565604683,0.112521517667,3.33029181667,-0.351460024833,0.478695839333,-0.259731413833,0.300161181167,-0.375802244833,-0.167272554,-0.190292179333,-0.00689153404,0.4532568275,0.0361250939667,0.6503198795,-0.395155314833,-0.377994619,0.3302862565,-0.446672114,0.6083908875,-0.288777269833,0.168051330167,0.795522776667,-0.331910996167,0.1779609815,-0.249885969667,0.180433572667,-0.193153489,-0.0573981583333],[-39958.1119667,-5901.72567667,5915.88131,-2876.25737167,1764.27681167,-1119.03776167,-1893.704585,-1272.46405333,-540.165971333,651.049286333,1046.36839333,1218.53768333,-678.389837667,-431.598659667,-1004.34695483,398.4044005,-286.830341,527.886132333,59.4806009,237.2339905,-99.1678029333,-171.383662667,-215.855348,213.963235833,123.109005833,-168.217023167,48.4295661833,-139.683786667,-34.0885986167,9.46808805833,-306.598074667,-36.3742680833,201.603853167,271.368655333,-67.1899417,26.5951063167,-20.3745836667,-10.793170035,-56.2999954333,-36.5321322,-8.79041496167,-103.779616333,40.3235589833,58.71604395,88.7187709833,-32.1663195,-9.44319181667,2.953317025,4.16015373667,4.13687298167,5.55727758,-4.53302808833,-1.00764760433,-8.33879543667,-20.8560436833,18.56324115,-0.669380459,4.87668011833,-8.83542531,3.08994961667,-2.16339735833,-4.17766617333,18.1696271833,-2.78155254,3.698136275,3.46876888,2.88766575333,3.24073638167,-1.80294430167,-1.09836865267,5.03287881333,-3.83259723833,0.585905202667,-1.73818012833,5.23118346667,-0.532516791667,-0.589047939667,8.71432125,0.746727212,-0.5351217325,-1.70460187,0.967653127667,0.333616559167,0.692454275333,1.756431575,0.0317912987,1.50775934667,0.182322963333,-1.54079040833,0.533180924333,-0.868412354,1.97332520833,-0.150120029,0.2486269435,3.44293973167,-0.436138018833,0.507217994,-0.243478012333,0.285002729167,-0.357989829667,-0.167922584667,-0.2113039095,-0.03602572666,0.4555880915,0.0385340808,0.662473563167,-0.393042808167,-0.339525423167,0.341024174667,-0.4280813325,0.658933578833,-0.278512442,0.212970039667,0.8440256165,-0.355165267833,0.191963724333,-0.238133401833,0.175343053,-0.1979366095,-0.0585094988667],[-39758.0447333,-5949.22269167,5906.68578167,-3047.21895667,1835.77182333,-1162.06115333,-1859.63431833,-1339.06013333,-553.433581167,731.5937125,1020.7671665,1160.73381833,-646.4558895,-446.629406167,-976.454562,425.891292833,-256.737421833,504.798234167,18.3660179,235.995755,-138.258305267,-195.515697,-199.431625833,241.473311667,134.996027333,-164.328525833,46.0512535167,-143.425147667,-33.3232068333,5.57515419667,-315.0527225,-24.6380512833,204.186884667,268.395872,-82.1114251333,27.0484383667,-21.36560925,-8.47738778167,-53.9510198833,-35.9107431833,-7.96791621333,-103.692584167,43.8216390333,57.5909478333,87.9832343833,-37.2779775833,-8.538200005,3.83362357833,3.09703764833,3.51996250833,6.40756964167,-3.572895325,-0.642373137833,-7.45439196333,-19.92046265,19.83251195,-1.5853606975,4.80670103833,-10.538063945,3.88400644167,-2.19152684167,-3.544361665,18.2894024833,-3.17780460333,3.51430426167,3.552719725,3.0175467,3.38951771667,-1.47785790333,-0.753865051333,5.326346545,-3.99117849,0.572612040333,-1.96531514167,5.73005014333,-0.551583730167,-0.197770714,8.89475937,0.6100009015,-0.4914005475,-1.74825356333,0.935363501167,0.2959239735,0.650670079167,1.776935655,0.0874988088333,1.58188181,0.2391081495,-1.48962251167,0.556004105667,-0.85940887,2.17018247667,-0.1729809155,0.3768639525,3.55690948833,-0.524011449667,0.5330416535,-0.232704678333,0.2724730145,-0.337978417167,-0.168674605167,-0.232279199167,-0.0652479570667,0.456179326167,0.0393432881,0.672659178167,-0.388885527167,-0.300249636833,0.35256407,-0.407522044833,0.710390355333,-0.262909014,0.255599273833,0.894606709833,-0.377966982667,0.207125012,-0.228172568333,0.171187294833,-0.201658429167,-0.0591757773],[-39559.4079833,-5983.80119833,5807.97786333,-3200.521985,1913.06845167,-1207.19066,-1839.955105,-1388.16094167,-557.9517795,808.366850667,997.727777333,1095.047165,-616.194460167,-440.628859833,-944.919403333,452.986654333,-229.126265167,480.747326333,-23.5961310833,232.987829667,-172.324281167,-215.342964333,-185.950537,266.371464833,145.7014105,-160.676337833,43.1106478333,-146.234928833,-32.2709561333,3.17400961667,-321.6096885,-13.2030391467,204.998575667,264.9085425,-95.6834297,27.09789115,-22.2271469333,-6.18029401833,-51.3302350167,-35.0747824,-6.896480655,-103.217076333,47.2276506,56.0913225833,87.2343147333,-41.6927633833,-7.46694841,4.82878370667,2.01701998533,2.95184041,7.27096711833,-2.63344939667,-0.284070856167,-6.523065355,-18.9717292,21.0993871833,-2.49482527167,4.81933249167,-12.1046962167,4.74916573667,-2.17137849333,-2.89094185167,18.4131060833,-3.53366483167,3.330538775,3.63515193,3.12162684167,3.51135446333,-1.14191455483,-0.426275080167,5.61669290333,-4.11676957167,0.592503925833,-2.16870900833,6.24749673333,-0.5269362935,0.182241709333,9.08398693,0.472512129833,-0.461413130667,-1.776739625,0.899129979833,0.258030903167,0.603630636333,1.78665505167,0.141925909467,1.64810740833,0.296976531,-1.430921395,0.587781878667,-0.84744185,2.36935808667,-0.179493063667,0.493881940833,3.67388766833,-0.611603264333,0.5560871855,-0.22945364,0.263002489,-0.31659228,-0.169443290667,-0.252759648667,-0.0938842814,0.455261075667,0.03866879405,0.680588758833,-0.382857399833,-0.2612612505,0.365001344667,-0.385388761167,0.761951989833,-0.241158533167,0.295411592,0.946850850667,-0.39966329,0.223515804667,-0.221016240333,0.168017654333,-0.204043755333,-0.0592382511167],[-39373.45165,-5937.60049167,5642.187445,-3333.11379333,2005.27527,-1240.28972,-1843.45223167,-1422.906955,-553.679106,878.684712,979.561806167,1021.6616515,-590.5217075,-410.024881833,-907.024104667,478.981944833,-205.7363425,455.539950167,-65.4862950333,227.8742065,-200.115522833,-229.118842667,-176.049172833,288.496145833,154.937030667,-157.623657167,39.35198535,-147.891756667,-30.9305444,2.34298492,-325.911885167,-2.36503531833,204.0576025,261.167765333,-107.426783717,26.7552339,-22.9367794333,-3.999493685,-48.4753362167,-34.0400458,-5.63307175833,-102.348996333,50.4742312667,54.2983746833,86.5580171833,-45.22309665,-6.249461205,5.84612236,0.962203117567,2.45820252667,8.13420119833,-1.7544155925,0.0531892561667,-5.573607955,-18.0370306333,22.3412136,-3.36445257,4.92441732333,-13.4921834167,5.667504965,-2.121139015,-2.24678530667,18.5695714,-3.836629985,3.15278505833,3.71890704333,3.18993372833,3.60065387833,-0.802499072,-0.1267102455,5.89815854167,-4.204847465,0.647364044,-2.34506969167,6.77386636,-0.454846704333,0.535964584,9.29142343667,0.341377715667,-0.447498825667,-1.789769175,0.8600408995,0.221754015667,0.551548001333,1.78540447,0.194344676833,1.704062985,0.3548946865,-1.36682175667,0.628669993,-0.833655613333,2.565950625,-0.165641597,0.594776831167,3.794886185,-0.6959259445,0.57590458,-0.235841512833,0.256809724167,-0.294871209833,-0.1700293825,-0.272194705,-0.1209762937,0.453282136333,0.0366869724,0.6858356775,-0.374997669,-0.2240378765,0.378364102833,-0.362206543167,0.812238965333,-0.212423546667,0.331269744167,1.00008292783,-0.4198784345,0.240975877333,-0.217758716667,0.165719096167,-0.204809306167,-0.0585665169833],[-39208.5852,-5751.24712,5432.970035,-3440.03209833,2119.75662333,-1247.07952,-1881.32371167,-1446.90945833,-539.832691667,939.767134333,968.478521667,939.902937333,-572.537205833,-351.6805465,-860.375000833,503.341160167,-188.145947,428.960840833,-106.535080933,220.221905,-220.5537585,-235.248781,-170.391298,307.550004167,162.440027833,-155.437673833,34.5375608167,-148.165510833,-29.3097553167,3.110541265,-327.630699833,7.55867036,201.300925167,257.406547833,-116.873397167,26.0279331,-23.4419435333,-2.0219118945,-45.4051560667,-32.8137119,-4.24024962167,-101.0884572,53.4841541833,52.2619864167,86.0308725333,-47.6911784,-4.90339132667,6.78889167167,-0.0301178534,2.07013548167,8.98578718167,-0.968007364167,0.359996226833,-4.63238658833,-17.1421504833,23.53321285,-4.16789470667,5.13307872667,-14.6621072167,6.62248416667,-2.06133853167,-1.640493785,18.78458895,-4.07577916667,2.98646923,3.80660428333,3.214139895,3.65327228167,-0.465566342333,0.135209955833,6.164791055,-4.25144367333,0.740138464667,-2.49274366,7.29992480833,-0.332647187333,0.848967964667,9.52494523333,0.223701069833,-0.4519886515,-1.78730324667,0.818453634,0.188696375,0.494815456333,1.77316765,0.244409923167,1.74793643,0.411950044333,-1.29900769333,0.679163411667,-0.819441355667,2.75528934,-0.127695420583,0.674977297167,3.92032593333,-0.773822655333,0.5920164225,-0.253940282167,0.254058384333,-0.2738339825,-0.170463504333,-0.290108946167,-0.145611379333,0.4506191475,0.0336312641167,0.6880926375,-0.365270047667,-0.189787475,0.392683851833,-0.338436236833,0.859936653667,-0.175880045667,0.362170277167,1.053497735,-0.438118114,0.2593756775,-0.219467019667,0.164156015167,-0.203636500833,-0.0570248703],[-39065.6343167,-5410.16673,5200.537965,-3511.58327,2251.50978,-1216.51863,-1973.14550833,-1466.54217667,-513.409597333,987.751133,965.957720667,846.31648,-566.417609667,-264.456947167,-805.035019167,526.3147065,-177.225651833,400.917411,-146.620758667,209.130259667,-233.3877095,-233.3208505,-169.737181833,322.797761333,168.127991333,-153.979800833,28.5625910333,-146.884997333,-27.5191466833,5.29190291667,-326.781012,16.182780835,196.4045695,253.865046,-123.692578167,24.92253225,-23.5771840167,-0.289593726333,-42.0913963,-31.3862866167,-2.80310294833,-99.4961104667,56.1629877,49.9126494333,85.7453924333,-49.0105020333,-3.44025226,7.54930940833,-0.943713611767,1.83415363833,9.82189423,-0.276052299833,0.649184781833,-3.717058005,-16.3093122833,24.6522121333,-4.91666072833,5.47118974,-15.6120999667,7.60579515833,-2.02286168833,-1.09413881033,19.0778093667,-4.24933777667,2.83422662,3.90060814333,3.1947422,3.67395294667,-0.131658007667,0.357422232,6.41279468167,-4.25879092667,0.8801412275,-2.619766685,7.82237149833,-0.1632160179,1.11250013483,9.789641665,0.126490704983,-0.4773131205,-1.77111223667,0.772105467333,0.159631359333,0.434697213,1.7514933,0.293255692667,1.78103827167,0.467860319167,-1.227973975,0.741476340333,-0.807667381,2.93570628167,-0.0638635616333,0.732792590833,4.04984179,-0.841785362333,0.604144133167,-0.285464188833,0.2549925325,-0.254390592333,-0.171681035333,-0.306431712167,-0.167300343167,0.447423152333,0.0299122668667,0.687795833833,-0.353579656167,-0.158552656833,0.408178051667,-0.314416008667,0.904722330167,-0.131120536133,0.38816701,1.10623005667,-0.453508496833,0.278859335167,-0.227021575833,0.163339911,-0.200206756167,-0.0545129238],[-38918.28845,-4963.43881833,4957.66575667,-3541.82004,2380.72963,-1145.72493667,-2125.63474833,-1482.36079667,-473.690373667,1019.927571,972.076144667,740.980415333,-572.827769833,-151.057963433,-744.650123167,548.2216515,-172.387952,371.581089667,-185.584488833,194.205545667,-239.461733833,-224.458666833,-174.284511333,334.539858167,172.187035333,-152.8393475,21.4823020167,-144.1078595,-25.7788469667,8.59773764667,-323.5878965,23.2538725333,189.445416333,250.7241635,-127.903934667,23.5031454,-23.2165073167,1.17699889217,-38.5467021833,-29.7933778333,-1.37449725005,-97.5848863667,58.4239386,47.2253725667,85.7843228333,-49.2282310833,-1.9046430015,8.10063242833,-1.774743102,1.77205877167,10.6349500533,0.332532546667,0.936556275,-2.83317229,-15.5359205667,25.6730228667,-5.64039262,5.96276136167,-16.3580827,8.590135375,-2.00945497333,-0.610553378833,19.4475412667,-4.36419574,2.69719253833,4.00184544667,3.13923311167,3.67218269333,0.199161703333,0.540141473,6.63820878333,-4.23671598167,1.07396700983,-2.73001546333,8.33351200833,0.0520476834,1.32736993667,10.08267646,0.04995748025,-0.523597334667,-1.74420689,0.720189971167,0.1352654335,0.373191823333,1.72258145333,0.3415117055,1.80367841333,0.522445067167,-1.15427456667,0.816574938,-0.798889937667,3.10591146167,0.0255379278833,0.768779459,4.18169968667,-0.899329539333,0.61248044,-0.330036229167,0.259961157167,-0.237075375667,-0.174306511667,-0.321126964667,-0.185919370833,0.443551552167,0.0259108411,0.6851881575,-0.339845157,-0.129685193333,0.424860281833,-0.290259447667,0.946727926,-0.07856147535,0.409349082333,1.15750078833,-0.465766844833,0.2995159565,-0.240313491,0.163455007833,-0.194662104167,-0.0511864191],[-38780.2370667,-4464.50819333,4716.68083333,-3539.34479167,2497.09560833,-1043.15008167,-2330.11342,-1493.98342167,-421.8203845,1038.63582333,983.171980833,626.868794,-588.964054667,-18.6792262333,-684.800915667,569.883930833,-172.1357775,340.776825833,-223.462488333,176.315769333,-240.871695833,-210.94973,-182.876747667,343.913018833,175.070229667,-151.797435167,13.5097811267,-140.095102333,-24.1135143667,12.5906699417,-318.588965,29.03278455,180.7774125,247.926153167,-129.8522425,21.8554713167,-22.3907351333,2.43208807333,-34.8085201167,-28.0880776,0.00725308646667,-95.41101395,60.3090151833,44.20528005,86.1334991667,-48.4850838,-0.331964604333,8.50855422333,-2.53791791,1.868862375,11.4302159,0.876236961667,1.21817211183,-1.97852119833,-14.8183707833,26.5958911833,-6.37561478667,6.60462973167,-16.91855065,9.55056539833,-2.00180807333,-0.181041159833,19.8652355,-4.433823145,2.57654564333,4.11026070833,3.05687560833,3.651524915,0.527667089167,0.686135892,6.84079757333,-4.19769129333,1.32111241167,-2.82131572667,8.82664511,0.308720526267,1.499482745,10.3930816,-0.0116306004167,-0.586216206833,-1.70964197833,0.664369642833,0.1150400407,0.311543435667,1.68788124,0.389874850833,1.81723082,0.5754481765,-1.07840347,0.904003591667,-0.792012633833,3.265310025,0.136385372867,0.784673544667,4.31382733167,-0.9484296115,0.6183602885,-0.385106381833,0.268609753167,-0.221819924,-0.1782725385,-0.334539947,-0.201812741167,0.439092617833,0.0220688699333,0.680857297833,-0.324363800833,-0.102387180233,0.442708312167,-0.266180017667,0.9863065615,-0.0197937235167,0.425921542833,1.20718420167,-0.475148775833,0.321258821,-0.258259797,0.164421944667,-0.187719655,-0.0472466286667],[-38669.7283167,-3935.61697167,4472.33949667,-3511.93872167,2599.07759,-920.425942333,-2572.52153167,-1498.42323667,-358.8122555,1047.188455,995.845312667,507.891103,-610.9787815,123.779849067,-631.016787667,591.9028195,-175.251659,308.665180167,-260.3333755,156.418757833,-240.142696,-195.251163667,-193.781183167,351.781810667,177.102237667,-150.823832167,4.95837788167,-135.175674333,-22.6090405833,16.8235091,-312.391180333,34.0362716667,170.652627833,245.3709765,-129.840219167,20.0282904833,-21.1884697833,3.53802373,-30.9328211833,-26.35495495,1.34056555162,-93.0476726833,61.93034105,40.8412500667,86.7576755333,-46.8976936,1.2248855285,8.846105945,-3.251873295,2.09972943833,12.2071792833,1.3698891535,1.482771415,-1.13587881667,-14.1540266,27.4332264333,-7.15495666167,7.387413605,-17.3048449833,10.4512070517,-1.981203975,0.207607818667,20.29119125,-4.46952668167,2.47311285667,4.223297135,2.95577496167,3.615574895,0.857106444833,0.799212024167,7.02083516833,-4.15157752333,1.61886203167,-2.89152355667,9.29086921,0.599947802667,1.63748972167,10.7047564333,-0.0637795501833,-0.658433848167,-1.66913792167,0.606665634167,0.0980936015667,0.25056412,1.64947065833,0.438709409167,1.82344971667,0.626183557,-1.000267251,1.00268842383,-0.7867774035,3.41249990833,0.263338949,0.783355839667,4.44266265667,-0.990738513,0.623958087667,-0.448293201333,0.280353361,-0.2081972435,-0.183339026833,-0.346910847167,-0.215467547,0.4343658605,0.0184833308667,0.675443359833,-0.307584287333,-0.0758740021167,0.461616958167,-0.242766337333,1.02382963883,0.0432745882167,0.438414497,1.25492134,-0.481767684833,0.344174415667,-0.279935568667,0.166038409333,-0.180082104167,-0.0429637376167],[-38588.9340667,-3410.02767667,4208.79048333,-3463.275245,2682.23767167,-788.057701167,-2831.900445,-1495.30138,-285.447864833,1048.17527333,1007.8994425,389.566412667,-636.086093333,267.961282167,-587.045535,614.600833667,-180.636306667,275.7266585,-296.1220575,135.133779167,-239.459116167,-179.202164,-205.571234333,359.0392015,178.492226667,-149.889938333,-3.83652589,-129.713313667,-21.4122352833,20.9700158,-305.441480333,38.6461797833,159.359805667,242.935831833,-128.213916333,18.0507795833,-19.6949044333,4.53961295167,-26.99260015,-24.6793244,2.65607827,-90.54206915,63.3575470667,37.14474165,87.6087757167,-44.6042886667,2.72208448667,9.18861968167,-3.93349514333,2.44057516333,12.9566106667,1.82468902333,1.72139582667,-0.2830839765,-13.5391856333,28.1871290333,-8.00077956833,8.29832046667,-17.5347654667,11.26032985,-1.927331965,0.56705955,20.6850176167,-4.48018939667,2.38752950667,4.33669654333,2.84356031667,3.56851304667,1.19014388517,0.882045865,7.176774015,-4.10553658667,1.96307074667,-2.94014739833,9.716107505,0.919279139333,1.74900052333,11.0015332833,-0.112782044833,-0.733842491667,-1.62362875167,0.548978634833,0.0836901070333,0.191140962167,1.609380065,0.487770929333,1.823430585,0.6739229055,-0.919439592667,1.111021615,-0.783148722167,3.54616524333,0.401206074167,0.767238340667,4.56463453833,-1.02831206767,0.631132328,-0.517084965,0.2942858505,-0.195691069167,-0.189243517333,-0.358301824667,-0.227303872333,0.429615831333,0.01507935345,0.669380135333,-0.289817705833,-0.0494380570667,0.4813339075,-0.220584996,1.059618095,0.108796714217,0.4471478915,1.30037318167,-0.485915044333,0.368201700167,-0.304336799333,0.167879036167,-0.172355140333,-0.0385857537667],[-38539.9671667,-2929.52101667,3923.17266667,-3401.95283333,2739.04747667,-654.117051167,-3080.565215,-1489.312,-204.083569333,1043.36515167,1017.040235,279.377813667,-663.220593333,407.474806333,-554.323518833,638.009954333,-187.284344,242.304887,-330.4372385,112.8228146,-240.250836,-163.82851,-217.370647833,366.9504875,179.429348,-148.960865667,-12.5658404417,-124.074497667,-20.60946455,24.8404154833,-297.98688,43.0036506833,147.338558,240.426854333,-125.447371833,15.9590556,-17.9998918833,5.479836905,-23.07700035,-23.10429135,3.98293158333,-87.9099325667,64.59434015,33.1613140167,88.6120442167,-41.8088408667,4.14320535833,9.61088112167,-4.59617576,2.86148332667,13.66868745,2.24606446833,1.93280624667,0.592396187333,-12.9675171333,28.8483005,-8.93043882167,9.321096205,-17.6447618,11.96159835,-1.819308125,0.902687947167,21.0084984,-4.473345965,2.31796279833,4.44590900833,2.726028465,3.51332001833,1.52611880833,0.9368949985,7.30629582833,-4.06651235333,2.34942482833,-2.96941612167,10.0969452883,1.26082124617,1.83815252833,11.2691178167,-0.166344666333,-0.8084846425,-1.573619375,0.492779615833,0.07104754765,0.13367146925,1.56848304667,0.536296655167,1.81774137167,0.718205892,-0.835481113167,1.22725071833,-0.780640534833,3.66568774333,0.5452034135,0.7374445675,4.67689159333,-1.06394166667,0.640262918167,-0.588300391333,0.3090164285,-0.183691266,-0.195603325,-0.368764061667,-0.2378216385,0.4247603185,0.0118149272917,0.662850407333,-0.271241575833,-0.0223535421233,0.50146834,-0.199824928833,1.09382190333,0.175075692167,0.4520405025,1.34335923,-0.4881686815,0.392707315333,-0.330051094833,0.169221331667,-0.1650826085,-0.0342612553],[-38527.4658667,-2527.26304167,3620.44801833,-3338.24027167,2763.42114333,-524.803941333,-3289.712175,-1484.34850667,-117.559062217,1034.39296,1021.11837167,185.082146667,-691.1393345,535.918921,-533.806099333,662.021033,-194.307928667,208.705822167,-362.833285833,89.8538107333,-243.930723667,-149.970064667,-228.305039333,376.804870833,180.073500167,-148.0381765,-20.9380552,-118.6288545,-20.2756493,28.2347533833,-290.198119667,47.2395832833,135.038496833,237.6148785,-122.011152833,13.7866064833,-16.2053537333,6.39406668333,-19.2813108833,-21.6657986333,5.34573659167,-85.1471779167,65.6365602,28.9401922167,89.6785602667,-38.7161232167,5.470791035,10.1857561317,-5.25213383,3.32902539333,14.33007155,2.63623390167,2.11620853833,1.50186422017,-12.4293018333,29.4039475167,-9.95813979,10.437687785,-17.6708546333,12.5372303167,-1.63635771833,1.21953448283,21.2202045167,-4.45538330167,2.26178183167,4.54555112667,2.60772264333,3.45219314333,1.86394688333,0.966021442,7.40600418833,-4.040293925,2.77317222,-2.98136280667,10.4265769167,1.61859357667,1.90883259833,11.49149785,-0.2321845565,-0.878571595167,-1.51914279,0.439517691333,0.05943805545,0.0782959581167,1.52719384667,0.583400066,1.80654142167,0.758381722667,-0.747667516333,1.34934438667,-0.778546382,3.76983875833,0.6906053775,0.695017989333,4.77586094167,-1.10025891833,0.651506108,-0.6586250725,0.323059329,-0.171492553667,-0.2019189055,-0.378241597333,-0.2475254875,0.4195785235,0.00862595925,0.655836938,-0.252022892667,0.00612441707333,0.521488213667,-0.180571458333,1.12635978667,0.24045804,0.452946651667,1.383490455,-0.489024983833,0.416957261667,-0.355590871333,0.169291418,-0.158770880333,-0.0301327683],[-38552.16365,-2212.49156,3336.978165,-3282.56339667,2754.327605,-398.038142167,-3441.73014833,-1479.213025,-29.3388662,1022.46056,1018.541025,111.234202933,-716.995524833,645.877160333,-525.526425667,686.191201333,-201.327703,174.846216667,-393.297327333,66.8660862833,-252.532447167,-138.080895,-238.011820667,389.316089167,180.517648667,-147.256437333,-28.8333494667,-113.748787667,-20.4891259167,30.7127173667,-282.146675,51.2888913833,122.6794185,234.270095167,-118.380856833,11.575666985,-14.42593585,7.28250444667,-15.6940506833,-20.4248951833,6.72085042,-82.2438955,66.43353035,24.4768874333,90.70698065,-35.5597304167,6.698174355,10.9418478667,-5.90412175333,3.81325802167,14.9256241,2.996351975,2.259340175,2.457449045,-11.9197041833,29.83470485,-11.1043117517,11.6243333333,-17.6679698833,12.9754528833,-1.37549827167,1.52497284667,21.2825511667,-4.42990435667,2.21816234667,4.632098595,2.49258559667,3.384942065,2.20650452333,0.969433590667,7.47275301,-4.03318726667,3.22758815667,-2.98527558833,10.6997998667,1.98209280167,1.96723230667,11.6529995667,-0.315539812,-0.941212195,-1.46005830667,0.391165601833,0.0490840771333,0.0253899483667,1.48598746833,0.629538946667,1.78927852667,0.7943929935,-0.6555182985,1.47488367,-0.7775719245,3.85772738833,0.832046166167,0.642499063,4.85726290833,-1.13847593167,0.664735674167,-0.725212542333,0.335356075333,-0.158569029,-0.207531232833,-0.3864275345,-0.256736768667,0.4140557325,0.00563101713667,0.648163831167,-0.232068528167,0.03664222426,0.540852198833,-0.1628766895,1.15719026667,0.303271478667,0.450327588,1.41997796167,-0.488504204667,0.4402607595,-0.379632876833,0.167578873167,-0.153744515167,-0.0262728120833],[-38618.2175667,-1934.15538833,3125.56501,-3242.12174667,2722.32134167,-264.0318625,-3542.88212167,-1465.183205,57.49670595,1007.46803633,1008.575214,56.8786666,-735.954542,732.905440167,-527.549744667,709.606184333,-209.042136833,140.305112167,-421.980250833,44.93934825,-267.747399167,-127.911167167,-247.560437667,403.901002,180.664860333,-146.9196605,-36.2920144167,-109.5962115,-21.2664241833,31.6241077833,-273.8224375,54.6412088333,110.0511214,230.303950333,-114.734999333,9.36260556333,-12.7519855167,8.11733666833,-12.3682068933,-19.4648718333,7.99298858667,-79.2201445833,66.8665225167,19.71259715,91.62074555,-32.5030259167,7.82762193,11.7731318,-6.537601695,4.29773437333,15.4399032,3.31817346167,2.33147456167,3.461919855,-11.4466029333,30.1203510167,-12.37974625,12.8546668,-17.6986174667,13.2717440667,-1.082120528,1.818278075,21.1846300667,-4.39452207,2.18711590167,4.70337979667,2.38031830167,3.30646545167,2.56110977167,0.945869471833,7.5052835,-4.04787889167,3.703313,-3.00048038,10.91329785,2.33252605333,2.01734869167,11.7463527167,-0.414115223333,-0.998980363667,-1.39592467,0.349232257667,0.04081113005,-0.0245586754,1.44531423833,0.677114261667,1.76548595333,0.826647497167,-0.558971433833,1.60094021,-0.780960837,3.92860831333,0.964338410833,0.5830399605,4.91721936833,-1.17636274167,0.677911943333,-0.787482191833,0.345849965833,-0.1447996395,-0.2117398135,-0.392819885333,-0.265358504167,0.408573862333,0.003161656855,0.639575626833,-0.211142747167,0.0694169172,0.559061002167,-0.1467554135,1.18620137833,0.362193218333,0.445257741833,1.451444695,-0.4858208105,0.461748806,-0.401764681667,0.164024069333,-0.149627686667,-0.0226313212167],[-38701.6117333,-1630.94735,3027.08059333,-3216.71387667,2683.18549167,-111.39380535,-3599.251805,-1433.60493667,140.228656167,990.539185,991.8906295,21.252959335,-743.642709167,794.967937333,-537.872483667,730.996276667,-217.9541685,104.906378383,-448.6940035,25.1351975883,-290.210164667,-119.043216,-258.0337995,419.979511333,180.295601667,-147.310523167,-43.37556845,-106.206152333,-22.5505227667,30.6083310667,-265.123736,56.8539199167,97.0761148667,225.690003833,-111.097942,7.172445525,-11.2802413,8.86273622333,-9.34117901833,-18.8368719667,9.08679702667,-76.066859,66.8577872,14.6555133983,92.3561403667,-29.6346686667,8.85219892833,12.5715316333,-7.13253361,4.76176963667,15.8591641667,3.58898941333,2.30789189167,4.51250047167,-11.01120305,30.2528805333,-13.7735241,14.09968115,-17.8004081833,13.42007,-0.798607436833,2.095319195,20.9234466667,-4.34468054667,2.16762863667,4.757694605,2.26768397833,3.211428955,2.93085993667,0.894556183333,7.50385423167,-4.08379434833,4.189677115,-3.04037776833,11.0627855833,2.65493350167,2.06048287667,11.7680298667,-0.525308357333,-1.05554982233,-1.32623992167,0.315169581,0.0352951777333,-0.0716856184833,1.405135095,0.7274467795,1.73435113,0.855141896167,-0.458515933333,1.724662225,-0.790851127333,3.98133362167,1.084180698,0.518839046667,4.953199315,-1.21208466333,0.688711022167,-0.845355809,0.354743851833,-0.130200722167,-0.213776115167,-0.397004461,-0.2732247535,0.403418786167,0.00140956944775,0.629696211333,-0.189270482833,0.104290519467,0.575730882333,-0.132143106667,1.21309344333,0.416447841333,0.438465776167,1.476847475,-0.4805398925,0.480599557667,-0.421837136167,0.158657424333,-0.1459333615,-0.0192052506833],[-38776.4126333,-1307.76866033,3021.92093667,-3199.39950167,2640.79105167,55.4121931,-3607.11124167,-1385.66280333,219.249255833,973.4210845,968.975639833,4.64866431667,-740.825793167,833.72719,-558.36445,750.223574833,-227.465417667,69.4122911333,-473.174945333,7.39780669167,-318.776111167,-112.285955333,-269.459183833,437.562074833,179.364662833,-148.3311435,-49.83381175,-103.600809167,-24.2831457333,27.9673082,-256.176853,58.0624279333,83.9936111333,220.570325833,-107.387700833,4.98600322333,-10.0429108633,9.572527365,-6.63749151333,-18.4900470667,10.0570652367,-72.7737572333,66.5290667833,9.35426728667,92.95018355,-26.9421800667,9.74824664,13.3203538833,-7.69795784833,5.18611591167,16.18830925,3.80741796167,2.21212541833,5.60230864167,-10.5970280333,30.27308825,-15.2733147,15.3560343167,-17.9604748667,13.4199983,-0.527151928833,2.35701695833,20.5042279333,-4.283440115,2.15562177833,4.79121358833,2.15377881167,3.10601749333,3.30945034333,0.821281175667,7.47535646667,-4.13943417333,4.68351944333,-3.10231799,11.1484624,2.95044856167,2.09666893,11.7202896333,-0.651115883167,-1.11314324167,-1.25156186667,0.288566405,0.0305820935167,-0.116904353783,1.36588505,0.778832470333,1.697041785,0.878827297,-0.3542712165,1.84573582167,-0.806341019667,4.01709861667,1.19296538167,0.451193730833,4.96670833667,-1.24701195167,0.696227367667,-0.898493551,0.362608448167,-0.114564517833,-0.213603442,-0.399345382167,-0.280578652833,0.398306989333,-6.97064733333e-06,0.618808305333,-0.167451117333,0.141333641833,0.590928856667,-0.118974540167,1.23822147333,0.466349665667,0.430180243833,1.49669784167,-0.47327901,0.4967087575,-0.4397747495,0.151840977333,-0.142439028,-0.0162195869833],[-38826.63395,-991.369381333,3075.05125,-3183.05988833,2593.43037,226.94241115,-3561.48490333,-1324.72521167,295.958865667,957.3542685,939.9225285,7.040240125,-729.4865905,851.464663333,-591.8165235,767.577214,-236.734635667,34.803592515,-495.26608,-8.62797730833,-352.0321775,-108.775983,-281.625317667,456.752952667,177.897613,-149.748100833,-55.3165840833,-101.816348,-26.4151843333,24.0925075,-247.165436333,58.50961425,71.0819318167,215.096853,-103.495732183,2.77081622033,-9.04087213167,10.327913805,-4.276484025,-18.3486954167,10.9759161,-69.3306102667,66.0319739833,3.85068267667,93.4509785667,-24.3908622333,10.4842090783,14.0229566667,-8.25292955333,5.554198715,16.4355757667,3.977214245,2.07989396167,6.72319422833,-10.1830427517,30.2271828333,-16.8690507333,16.6237117833,-18.1540773167,13.2692346,-0.261045367115,2.60522764833,19.9318650167,-4.216195865,2.14582970333,4.79872087167,2.03902990667,2.99931551333,3.68899856667,0.733650603833,7.42707525167,-4.21295848,5.18259996167,-3.180202865,11.1696098667,3.22323223333,2.12518735833,11.60496355,-0.7946190145,-1.17362719167,-1.172580095,0.2682067995,0.0239516031167,-0.161160562167,1.32804076,0.829070024333,1.65519232333,0.896408826333,-0.246038018,1.96413034,-0.82588777,4.03697192,1.29283497833,0.3810009515,4.95928624833,-1.28312738333,0.699716442167,-0.946404525,0.370015381667,-0.0975557413,-0.21142887,-0.400354567333,-0.287764055833,0.392752539333,-0.00157706378058,0.607317085833,-0.146827478667,0.180744284333,0.604733817333,-0.10718163715,1.26190250167,0.512342816667,0.420409302667,1.511556155,-0.4648294785,0.510026788333,-0.455471952667,0.1439784695,-0.138971993167,-0.0139530267833],[-38834.7236667,-708.245418833,3147.58113333,-3163.98174,2538.780415,394.989653667,-3461.777195,-1249.30720333,370.786586167,943.100017,905.646680667,27.3575929767,-710.107868333,850.2681845,-639.396529667,783.288134667,-245.079387333,2.13211219333,-514.813944833,-23.0782053617,-388.737620667,-109.238890667,-294.202324833,477.495153833,175.960497333,-151.355710333,-59.5457126667,-100.870107,-28.9031567333,19.2770042167,-238.225509833,58.3895663,58.5835740333,209.322626667,-99.3926185167,0.507264424667,-8.274309785,11.1809840667,-2.28565948433,-18.3505322667,11.8918118667,-65.73025115,65.468616,-1.81455394333,93.8659366167,-21.9693846833,11.0057002,14.68751835,-8.81463046667,5.85305261333,16.6069311167,4.09820996667,1.94152501833,7.86548210833,-9.74850621667,30.1439841667,-18.5476516333,17.8933284,-18.3563125833,12.9575411,0.00576205237333,2.84617226333,19.2123707833,-4.14769959167,2.13453888,4.77671580667,1.92420224833,2.89912930167,4.06250825667,0.639567045333,7.36393478167,-4.30199185167,5.68245216833,-3.26690568167,11.1235226167,3.47529568333,2.14658783667,11.4225664667,-0.957035452667,-1.239962615,-1.08977678833,0.253188641333,0.0133094728817,-0.204672374,1.29194938833,0.8763407655,1.61017750167,0.907015404333,-0.133665495333,2.07915662333,-0.847739197833,4.04157212167,1.38502975667,0.309307844833,4.93115466167,-1.32154915833,0.697887808667,-0.9887212865,0.377123474167,-0.0788788944167,-0.207445539833,-0.400498238167,-0.294915319,0.386313543667,-0.00371294435667,0.595445812667,-0.128278868333,0.222703522333,0.617045943167,-0.0967110357,1.28422571833,0.554667719667,0.409066762167,1.52143503333,-0.455783875333,0.520359286167,-0.468796645167,0.1353519645,-0.135428824,-0.01255872915],[-38781.0358167,-484.360683333,3196.82315167,-3141.77771,2474.045335,552.6473965,-3311.74281,-1153.06224667,443.174188333,930.975718833,867.913106833,63.49849515,-681.656330667,832.034746833,-700.6489565,797.518248333,-251.973072667,-27.473219885,-531.663923833,-35.8612758667,-427.820019667,-113.990047333,-306.7388595,499.566996333,173.657675,-152.977656833,-62.3153432833,-100.760703333,-31.7075249333,13.715808305,-229.446449,57.8485735833,46.70549955,203.203186667,-95.1288401,-1.81122509967,-7.74361352667,12.1540712167,-0.701138535,-18.4467365,12.8293013333,-61.9689881833,64.89203965,-7.60167258833,94.1623174667,-19.6903133667,11.23565985,15.3269598833,-9.39813235667,6.07314401,16.7059223667,4.16622870667,1.82184478333,9.01776611333,-9.27303176333,30.0350185667,-20.2929342,19.1462298833,-18.54217475,12.4669484667,0.278657062885,3.09045251833,18.3529887333,-4.08201075833,2.11960776333,4.72341604667,1.810408935,2.81196000167,4.42380303333,0.547239918833,7.288512785,-4.40363533833,6.17639382,-3.35428546167,11.0055990333,3.70648205667,2.16272220333,11.1723447,-1.137689736,-1.31618576167,-1.003432778,0.242943547667,-0.00280041685667,-0.2469203665,1.25783019833,0.919201812667,1.563118695,0.910192500167,-0.01706932,2.18946395167,-0.869936001167,4.03109734167,1.46988107833,0.237342069667,4.88123665,-1.36252034167,0.6889135645,-1.025190838,0.383679340667,-0.05828373515,-0.2018289195,-0.4001932695,-0.301954489,0.378595059833,-0.00674836954333,0.583238004667,-0.112427080533,0.267370164667,0.627584334833,-0.0875268411333,1.30505586833,0.593355294833,0.3959804105,1.525804325,-0.446536016667,0.527370003167,-0.479587005,0.126124995667,-0.131775870167,-0.0120644398],[-38651.2984667,-337.086892833,3184.78999,-3116.339635,2397.99110667,693.9243555,-3117.58865333,-1029.8041885,512.619846667,921.118255833,828.055603167,112.731517033,-642.980684167,798.262335333,-774.669672667,810.335989,-256.9970645,-53.0920045667,-545.650959667,-46.8489380667,-468.296168833,-123.357866833,-318.7659475,522.478626667,171.0608845,-154.444918333,-63.44267575,-101.439212833,-34.7894581167,7.56795015167,-220.947090833,57.0205547167,35.5513900167,196.655813333,-90.7519980667,-4.189659065,-7.44605194667,13.2725375167,0.45717775,-18.59538995,13.8115626333,-58.05627675,64.3513357667,-13.4883216233,94.2903078167,-17.56980075,11.1101188833,15.9415461167,-10.0155865867,6.20530754167,16.7364237,4.178222335,1.741076055,10.17207373,-8.73832718333,29.9107188667,-22.08665375,20.36288255,-18.6887639667,11.78542935,0.558699798833,3.34723239333,17.3594147833,-4.02227111333,2.09838359833,4.63699538167,1.69779172,2.74311434333,4.76789245833,0.465439501333,7.20342359833,-4.51393645667,6.658129175,-3.43527328667,10.8118668167,3.91456162833,2.175531655,10.8523598833,-1.33476898833,-1.40562282333,-0.913665042667,0.236727841167,-0.0257423935517,-0.287596715667,1.22589662333,0.9563491725,1.51530472333,0.905705611667,0.103970090167,2.293704315,-0.890521965,4.00556705833,1.547202155,0.166692933783,4.80785838833,-1.40561345833,0.671049313167,-1.05552309167,0.3892879955,-0.0355292793667,-0.194707270667,-0.3998108295,-0.308789629167,0.369279688667,-0.0110571968733,0.57067559,-0.09980014105,0.314891784833,0.636027322333,-0.07948698825,1.32410288333,0.628346931333,0.381122753667,1.52392947833,-0.437295009333,0.530734719,-0.487663011167,0.116421614,-0.127943908333,-0.01243594735],[-38454.5082,-258.512865,3102.70387167,-3091.13469333,2314.61071333,817.306057833,-2894.88453167,-878.422507167,578.308705167,913.172672333,785.327797667,170.392275667,-593.7740195,750.236371667,-858.761134,821.557612833,-260.1235375,-74.86775455,-556.478210167,-55.9144229167,-509.1403645,-137.626720833,-329.9448625,545.0683895,168.189793167,-155.642611167,-62.87796315,-102.636720833,-38.0795361167,0.984013348333,-212.966770667,55.9798850167,24.9599292333,189.496087667,-86.3487224667,-6.613712095,-7.37486185167,14.59103385,1.241733374,-18.7654003833,14.8733914,-54.05799705,63.9021155833,-19.4865441833,94.1559387833,-15.6549896833,10.6371630317,16.4842886,-10.6690217667,6.240324055,16.7158916667,4.13485400833,1.70643289833,11.3332659167,-8.13519427,29.7921416667,-23.9038016667,21.5251682333,-18.7910161833,10.9373706667,0.829586321833,3.619515825,16.2419219833,-3.97016516,2.06605834167,4.51836327,1.58141097333,2.69449356,5.094118205,0.405370338333,7.11559052833,-4.62676800667,7.125349135,-3.50820005833,10.5478077833,4.09136426833,2.18745759,10.4631755,-1.54333001333,-1.50950844667,-0.820763516833,0.2331460995,-0.0566927274667,-0.327975176667,1.19662853667,0.986969804833,1.46924262833,0.894740490167,0.229770347833,2.39190810167,-0.907556041167,3.96660340833,1.61584244333,0.100238524383,4.71024273333,-1.44893937,0.6430293095,-1.07959305833,0.393122686,-0.0104948824,-0.1860528385,-0.399893601833,-0.315493217,0.358446961833,-0.0171927476833,0.557759121833,-0.0906427265667,0.3653881655,0.6423734235,-0.0719254885333,1.34113966833,0.659691271833,0.3651704915,1.51532273833,-0.427965462333,0.530357122667,-0.492917412667,0.1062280693,-0.1237665725,-0.0133760924167],[-38204.72355,-280.179276667,2978.27272,-3075.29198,2220.938485,926.019235333,-2665.31273333,-715.255318,637.725942667,906.378805,737.037708,230.192281667,-538.385907667,692.200874167,-949.050719167,830.744787833,-260.919808667,-94.1025932333,-563.710127833,-63.5340386833,-548.236060833,-156.818287,-340.518872333,566.6793275,165.149960667,-156.286563,-60.7907653833,-103.876495,-41.3794585667,-5.71369741833,-205.657613667,54.5463407167,14.9720842583,181.382841333,-82.1865966833,-9.019108795,-7.50379692667,16.1836882333,1.77581741,-18.8593409833,16.02850695,-50.0368032333,63.5238207833,-25.5719203833,93.5823924,-14.0845443333,9.88834171333,16.87715315,-11.3517556,6.164423485,16.6815339333,4.04458222,1.73102448667,12.4884584833,-7.45606243667,29.6896033333,-25.7193290667,22.5978247167,-18.8728747833,9.98086669333,1.06141357383,3.90468409167,15.0225159167,-3.92828887833,2.01429411667,4.37356272667,1.45292925167,2.665252505,5.39784782667,0.377890328667,7.03219274333,-4.74073712167,7.57409301,-3.57747404833,10.2278656483,4.22491547,2.198555875,10.01198183,-1.75981321333,-1.62946621,-0.726177116667,0.229899034667,-0.0965220295167,-0.370822160667,1.169112325,1.0103975225,1.42700726667,0.879428348,0.358771461667,2.48506650667,-0.9192709025,3.91722938667,1.67407365833,0.0402948992167,4.58956356667,-1.49157435167,0.6027650635,-1.096651935,0.393640768333,0.01664021025,-0.175751310667,-0.401318969,-0.322336283333,0.345953135,-0.0252881651833,0.544317076667,-0.08482002255,0.4187055605,0.6470709895,-0.0638248604667,1.35569903833,0.687536429833,0.348646681667,1.49986914167,-0.418912239,0.525752549167,-0.494843956333,0.0951344651167,-0.118997481,-0.0143726291833],[-37929.00745,-418.893215167,2857.323015,-3081.29276333,2117.77938667,1026.0771925,-2447.477195,-561.1537945,687.9614425,899.530976833,679.594943,285.912330167,-482.6471975,629.037793667,-1040.135309,837.418686833,-259.388561,-112.645881367,-567.007265667,-70.41224215,-583.038958667,-180.243482167,-350.781785333,587.1992465,162.066324833,-156.177146167,-57.4555298167,-104.6976605,-44.4641097,-12.1044554833,-198.979577667,52.5087502833,5.80890461833,171.9683965,-78.4728547833,-11.3229032983,-7.79524367,18.12989995,2.18764604167,-18.7691413833,17.2875880333,-46.0497206667,63.1790479833,-31.6887726167,92.3679434167,-12.9611062,8.93747169,17.0342098833,-12.0495989,5.97582313167,16.677387,3.91750089333,1.82372855,13.6140449,-6.706067045,29.6069011333,-27.5037730333,23.5341957167,-18.9450772,8.97635981,1.22453160667,4.18968869667,13.7296935833,-3.89794105333,1.93752304167,4.21008416,1.303772085,2.65196151167,5.670904065,0.389270050833,6.95850342167,-4.85527135667,7.99697731833,-3.64577046,9.865772405,4.30476287333,2.20318157167,9.50926330667,-1.98063017333,-1.76540583833,-0.631787889333,0.224598201167,-0.146020328317,-0.418817943,1.14197547667,1.025784405,1.38990635167,0.861665926167,0.488461055167,2.57378874333,-0.924149907167,3.8596509,1.721005515,-0.01252672735,4.44784876333,-1.53265610833,0.548692708667,-1.10575677667,0.388815154,0.0453792793333,-0.163868639,-0.404992488,-0.329424700667,0.3317391555,-0.0351977599833,0.530211432667,-0.0820914023333,0.474297167333,0.650645039,-0.0543726872,1.366867765,0.712200562167,0.331680159333,1.47755494667,-0.4106698595,0.516483635833,-0.4929430025,0.0824916194,-0.113481521333,-0.0149137348],[-37658.91835,-601.835062167,2771.25583167,-3126.832625,2021.21551333,1119.71679833,-2236.63954667,-419.185041667,724.083803333,890.131273333,609.514072333,338.0998245,-427.649553833,565.286053833,-1121.89439,840.683039167,-257.19249,-132.119259167,-565.595315333,-76.9803776167,-610.952109,-205.278222333,-360.471944,607.047840333,159.047275,-155.575951167,-53.1271708,-104.915455333,-47.3973694,-17.5984699833,-192.551017167,49.8821044833,-2.09540167667,160.965937,-75.07719735,-13.4041567333,-8.22812672667,20.4820478333,2.484893745,-18.5058712833,18.7144076667,-42.1609294667,62.8724362167,-37.68320825,90.3383023167,-12.2003520167,7.79317551667,16.9494302833,-12.72951485,5.70110563833,16.7365142,3.74220303167,1.97662629833,14.6919816667,-5.91962128167,29.5488349833,-29.2055896,24.2907603167,-18.9650439,7.946096235,1.32973347167,4.447192515,12.3852856167,-3.87691950833,1.84076951,4.03487482667,1.12792086,2.65422714667,5.90208364833,0.435944814,6.8976589,-4.96771586,8.38602327833,-3.705829635,9.46418317,4.334396485,2.18841378,8.96322462667,-2.20230106167,-1.91407887167,-0.539830685833,0.216333666333,-0.205035044,-0.472148760167,1.11611333,1.03051326167,1.35829299,0.842767032,0.615104888167,2.65798485,-0.921067971333,3.793790745,1.75843805167,-0.0607840922333,4.28702542667,-1.57179861333,0.480880667,-1.10690615833,0.376670076833,0.0747614668667,-0.1508264525,-0.411436590167,-0.336223591333,0.316244029667,-0.0470828478667,0.515646976833,-0.0822308807,0.5308235285,0.653467087167,-0.0435609991,1.373788865,0.734174308,0.313679939667,1.44863537667,-0.404038368,0.502529504667,-0.487412906167,0.0676514750833,-0.107309422333,-0.0147601946333],[-37411.4861167,-727.8531905,2724.858295,-3221.53625667,1947.25753,1202.744885,-2023.80427667,-282.564760667,742.351594167,876.357733833,524.916412667,390.361890333,-371.981221667,504.136943167,-1184.25842167,839.638618,-256.100472333,-153.112424167,-559.085322833,-83.3236961667,-630.4587685,-228.612484167,-368.953147333,626.115372833,156.035298,-154.873260667,-47.8623874333,-104.476852,-50.33866895,-21.6236533333,-186.006652333,46.9021482667,-8.74434999833,148.169644,-71.8185942833,-15.1877384833,-8.77278081,23.2584141,2.65846923667,-18.1254054667,20.3907411667,-38.4379400667,62.6386144,-43.4159394833,87.3925611667,-11.6388094667,6.45449149167,16.6793785333,-13.3561979333,5.37153668667,16.8663537667,3.50186859667,2.18392987833,15.7164143667,-5.13558668333,29.5196637333,-30.77498275,24.8407208833,-18.89145105,6.89065061,1.40547386167,4.648278845,10.99722386,-3.860432415,1.72910837833,3.8505906,0.921725216167,2.67445749833,6.08277149333,0.512590831833,6.85018125667,-5.07110531667,8.73857783833,-3.7478734,9.02552828333,4.32458321,2.14514221833,8.37655124167,-2.41891542167,-2.070697695,-0.451474346667,0.204354127667,-0.2727857095,-0.530141418833,1.09322889833,1.0209541455,1.333624865,0.823530872667,0.736539913667,2.737541405,-0.909663191333,3.719207105,1.78815262333,-0.107683678,4.10795211,-1.60793571167,0.400881403167,-1.10078344667,0.355896076667,0.10404909055,-0.137211532333,-0.420630062,-0.342223276167,0.299966166333,-0.0615567545167,0.501118254333,-0.0849882326833,0.586802308,0.655583348833,-0.0317470662167,1.37625140667,0.753814654667,0.2944322645,1.41337876833,-0.3991214275,0.484091399,-0.478791472833,0.0500429141333,-0.100655974817,-0.01385051015],[-37192.6415,-780.894854,2709.96729667,-3356.74722667,1894.11556,1273.49189667,-1817.97341833,-153.465304183,744.558529167,857.213051,426.7399805,439.701200667,-316.718220333,448.952072333,-1223.41145167,834.033495667,-256.351200333,-175.167336167,-548.709129167,-89.5769022667,-640.9377005,-249.294470333,-375.526940667,642.393428333,152.7973345,-153.978259333,-41.5075359167,-103.408095833,-53.2235162833,-24.0439985667,-179.594944,43.9044116167,-15.046090975,133.485756333,-68.6037010167,-16.7008499833,-9.33110093833,26.4712793333,2.79024423833,-17.5784896,22.2841362333,-35.0196013667,62.5562943167,-48.9952688167,83.5443469667,-11.2028604667,5.02284427333,16.29772875,-13.9173614667,5.00416033333,17.0556616667,3.21500095333,2.46654896,16.6761951167,-4.37664029333,29.5354376333,-32.21463565,25.2141145167,-18.73782265,5.86123378333,1.47821288667,4.78379689833,9.57019454167,-3.845093755,1.59665333333,3.65408229167,0.6871937035,2.71718255333,6.21094585833,0.62657996,6.81767184833,-5.16280495667,9.07123053667,-3.77856569667,8.57256886,4.28292182,2.07632872833,7.75301854167,-2.62457046,-2.23102191833,-0.366505527167,0.1850476705,-0.349113299333,-0.593090333333,1.07394620167,0.9955443755,1.32173852,0.804365111833,0.852840384333,2.81609086333,-0.892516216,3.64149835333,1.81026427333,-0.152042311,3.91300548,-1.63931126333,0.311050785333,-1.08872338167,0.326539319333,0.1332079855,-0.1238402455,-0.4323904125,-0.347787913333,0.282848147333,-0.0791903432167,0.487818230167,-0.0903628128667,0.642071881,0.657158043,-0.0191631532617,1.37569223167,0.771165015167,0.2753225415,1.37277616333,-0.3953282115,0.462052218333,-0.467793551167,0.0296840011433,-0.0933931151833,-0.0119204855917],[-37006.1000667,-751.913309,2704.37408333,-3516.36219333,1856.387575,1330.076495,-1640.084985,-40.0677360167,734.813935333,831.173268,316.8146665,480.071425,-264.2176905,403.004223167,-1236.19063,823.843427333,-257.872316,-197.521868667,-535.910592667,-95.8433244667,-642.051832333,-266.923142333,-379.566490333,653.394534667,149.028222667,-152.604847667,-33.8736132833,-101.650800717,-55.87626545,-24.8949755167,-173.7613775,41.1922963167,-22.0920436833,116.9577961,-65.35540165,-18.0078646333,-9.76289946,30.1215592,2.99570776333,-16.7766655,24.3225852667,-32.07848985,62.6974001167,-54.5777810167,78.8633689167,-10.8468356333,3.58692291667,15.8351642667,-14.4091001167,4.61365295667,17.2865762,2.906890745,2.85210518333,17.56023615,-3.65999106833,29.6109498333,-33.53468215,25.4563486833,-18.53098655,4.90845228,1.55952439833,4.84484827667,8.12428852,-3.828059435,1.43306017,3.440870055,0.427117637,2.78699653333,6.28760985333,0.790376120333,6.80164185167,-5.24090366667,9.40298435667,-3.80901877167,8.12963812333,4.21400152167,1.985905805,7.10168679333,-2.80944774167,-2.39261597,-0.284314320833,0.153464334,-0.433795361167,-0.661322030333,1.05846213667,0.9536696245,1.32973765667,0.785668204,0.964291521333,2.89731675,-0.8728196135,3.56731369167,1.82473259167,-0.191763524167,3.70518435167,-1.662493555,0.213120713167,-1.07278813,0.288639991,0.162417447833,-0.1116064515,-0.446427165667,-0.353399487167,0.264626591167,-0.10050959105,0.4769802455,-0.0983710642167,0.696695398167,0.658258953333,-0.00592480338333,1.373829185,0.786278216667,0.258080448,1.32765167,-0.391727104667,0.437277910167,-0.455394635833,0.00664330142333,-0.0852757915333,-0.00862865924],[-36843.0371167,-683.637118667,2688.09083833,-3683.75233333,1819.44586,1369.86143167,-1496.075275,54.5206206833,717.342794167,798.2084185,196.662382617,507.477223333,-216.0876005,366.190060167,-1225.62263167,809.366576,-259.676717167,-219.421293,-522.774455,-102.568939183,-634.330810833,-282.475508167,-380.976324333,658.272767,144.557081667,-150.395229167,-24.7860761333,-99.4253866167,-58.24478255,-24.2808511833,-168.845434333,38.9595375667,-30.5247547,98.98666165,-62.23039555,-19.1684227333,-9.97582600667,34.18815035,3.39037602,-15.6119220667,26.46148565,-29.67349245,63.1452131333,-60.3085864333,73.51918785,-10.6137302667,2.15640160067,15.32098325,-14.8420752,4.20444949167,17.5330115167,2.62644940667,3.38914571333,18.36564345,-2.98827089667,29.7675917167,-34.7671457,25.6159690667,-18.3081812333,4.05176359,1.66295206667,4.83900004667,6.67773382667,-3.81164786,1.23091083617,3.20638805167,0.149284592833,2.89273118167,6.31421913167,1.011022076,6.80232902,-5.30746637833,9.74617764333,-3.84728189167,7.71473103333,4.12236834333,1.88440649167,6.43135020833,-2.969698935,-2.553422235,-0.2045206345,0.106153912467,-0.5256262575,-0.735782763833,1.04611375167,0.8948259135,1.36260434667,0.766486322167,1.07224892433,2.98296766,-0.852039900667,3.50311637167,1.83109862167,-0.223641884667,3.48759263667,-1.67592067333,0.108177174572,-1.05292861667,0.243737887667,0.192221978333,-0.101363071267,-0.4621113175,-0.359943582667,0.244372697167,-0.125857913217,0.469847811,-0.109305955333,0.751216656667,0.658912231333,0.00810161064167,1.37247743667,0.798964355667,0.244175499333,1.27885116833,-0.387448267,0.410312559167,-0.441784073,-0.01843418734,-0.0761696548,-0.004344506845],[-36685.7166667,-644.837574667,2661.47761333,-3836.0854,1764.63862667,1391.16711167,-1382.49463,128.889777383,697.485261333,759.059058333,66.64444635,518.7235505,-173.437381,336.825154333,-1198.37038833,790.850392167,-260.256715,-240.2878905,-511.914039,-110.157963667,-618.662513833,-297.540265333,-380.346943667,656.700512333,139.170712,-146.892685,-14.0051336883,-97.1111348833,-60.2754699667,-22.3359036333,-165.034467333,37.2335209167,-40.8392123833,80.0841985833,-59.3266799667,-20.2428028667,-9.88034700667,38.6679956167,4.10880963833,-13.9682435167,28.6627340333,-27.7832992167,63.9783828333,-66.3258488833,67.6950348667,-10.5420552333,0.748867999,14.7704370333,-15.2264834333,3.77758501333,17.7633088,2.44232309167,4.12982386,19.0896679667,-2.35728149167,30.0297779333,-35.9466139833,25.7313358,-18.10803095,3.30654601333,1.80065570833,4.771972545,5.23660072,-3.79915133833,0.983044285833,2.94289466167,-0.135182876667,3.043395475,6.29169133833,1.291351715,6.81846899833,-5.36405387667,10.107047135,-3.901496,7.34103260167,4.01304656667,1.78180432333,5.74677618333,-3.10593677833,-2.70939580167,-0.1272228604,0.0399466693167,-0.623484932167,-0.817900624667,1.03576937667,0.818738863333,1.423929645,0.744819767167,1.17867781,3.07336276667,-0.831047437833,3.45350223333,1.82904710167,-0.244626209167,3.26277033667,-1.67950694833,-0.00244778554667,-1.02775198583,0.1943581035,0.223125133,-0.09397836505,-0.478502667667,-0.368529321667,0.2209467865,-0.155333840667,0.467666818333,-0.123559782333,0.806253753333,0.659075464667,0.02328024008,1.37298679667,0.8089123965,0.2348394725,1.227213255,-0.381805182,0.381493199167,-0.4267203055,-0.04457191345,-0.0658345698833,0.000144291365],[-36502.0758833,-682.413640167,2620.43718333,-3948.86961833,1680.98308667,1395.01317667,-1291.048175,185.1564225,680.167751667,715.386677667,-71.4554086833,512.560229833,-136.3275675,313.171719167,-1159.96858,768.233734167,-258.3956795,-259.347302667,-505.437059167,-118.857657333,-596.031566667,-313.2705065,-378.244147,648.296984833,132.5513775,-141.830244,-1.35891597,-95.0967085333,-61.9584348667,-19.2153461167,-162.423340167,36.0025787,-53.4512958,60.7331823167,-56.7294898667,-21.3070937833,-9.43975758333,43.5244856833,5.23098249667,-11.7749673383,30.8992562333,-26.3815957,65.2473878333,-72.7291345333,61.5700770833,-10.65336655,-0.640135169,14.2088819667,-15.5670263833,3.32966647333,17.9404681167,2.40579184167,5.10770140333,19.7361992667,-1.76867401,30.4150807167,-37.0959498667,25.8385152,-17.9566918333,2.67697319667,1.98784026,4.646725735,3.808165525,-3.7898503,0.685266125667,2.64256386667,-0.416754277833,3.24386767833,6.22285533833,1.62971231833,6.84931509667,-5.41082492333,10.4900822667,-3.97648794667,7.01720531667,3.89218193833,1.68472746833,5.052215345,-3.21773369,-2.85670788833,-0.0516616710833,-0.0467564192333,-0.72601158,-0.9084219815,1.02617706833,0.725439510167,1.51543007833,0.719364743,1.28504815833,3.168142585,-0.810440103833,3.421671885,1.81868972667,-0.2530376765,3.03265275333,-1.67290905667,-0.117457839095,-0.995979056,0.14267660295,0.2555579825,-0.0899397346,-0.494510771333,-0.379916538833,0.193531931667,-0.189061814833,0.471315119,-0.1413248705,0.8621231205,0.658543412167,0.0397998732833,1.37634209833,0.815853220333,0.230809782167,1.17333987667,-0.374190005833,0.351068496667,-0.4099948085,-0.0709007747667,-0.0541488637667,0.00406816957667],[-36286.0927667,-761.717511333,2569.41494333,-4019.36402,1577.32011167,1388.545685,-1202.18748,236.530344333,665.4300485,668.274038667,-214.379109783,493.598077167,-102.312655133,295.631038,-1111.96552667,741.325710667,-254.970731333,-276.334521667,-503.789778,-128.766851,-567.3326505,-329.582443833,-374.685586833,633.406033167,124.540061833,-135.729989,12.9210264283,-93.82640415,-63.5349192833,-15.1277272833,-160.985409,35.33424795,-68.2835419833,41.3144746833,-54.46943905,-22.3981588,-8.76221049833,48.6567146333,6.62567994333,-9.13384653167,33.1481599333,-25.4707049167,66.9615685167,-79.49181555,55.33615865,-10.9042278167,-2.06390598033,13.6888807667,-15.85381445,2.86435496,18.0453081,2.50034452833,6.29611655833,20.3182163833,-1.24492020417,30.9274239667,-38.2250753167,25.9808583167,-17.8433389,2.14615645667,2.24143780833,4.46950491333,2.41390203833,-3.77659371167,0.348516836367,2.30532715,-0.691826183,3.48820277667,6.11500193833,2.01177374333,6.89572823667,-5.45167225167,10.9007205667,-4.06898770167,6.74612174,3.76800327167,1.5951632,4.356786265,-3.302255955,-2.99298831333,0.0237496725,-0.150031993717,-0.831519379667,-1.00562561033,1.01672371833,0.616206868833,1.633451955,0.690315454167,1.390304315,3.26688380333,-0.791374481333,3.40965310667,1.80160674333,-0.249401573333,2.80002738167,-1.65534040833,-0.234817656167,-0.957359410667,0.0895299202167,0.2894649035,-0.0887600389833,-0.509356744,-0.393719217667,0.162533034167,-0.227060782167,0.480581100833,-0.1624700785,0.918436424,0.6570051335,0.0569034491,1.38339884833,0.819968796333,0.232098127833,1.11797611833,-0.3641762725,0.319678201667,-0.391599406833,-0.0969966906667,-0.0413798236,0.006962675285],[-36059.43575,-827.9503975,2506.144405,-4061.74628667,1467.87236,1375.12968833,-1104.69466217,290.209917333,650.644723,618.909285833,-360.156426167,466.884104667,-69.4375635333,284.291165833,-1055.30377383,710.354464667,-251.1774805,-291.5751235,-506.237916,-139.565513333,-533.4501225,-346.213251667,-369.533171833,613.369750667,115.225992,-129.234459167,28.4163913833,-93.4404006167,-65.1545873667,-10.23460702,-160.645252667,35.3109001667,-84.9636746833,22.2036105517,-52.49994015,-23.5244718333,-7.98874029667,53.9636297,8.15178091167,-6.184963465,35.3930981333,-25.03060345,69.11080795,-86.5743233167,49.1682149667,-11.2330442833,-3.53941102833,13.2229333333,-16.0822255,2.37967247667,18.0800896333,2.68535140167,7.64426494667,20.8431213667,-0.8011554005,31.5600611,-39.3565156833,26.19088595,-17.7554710833,1.7036535,2.56173899167,4.25030012333,1.0694623145,-3.753586085,-0.0152664912,1.93748736667,-0.962898417167,3.76594991,5.97399682667,2.42228918,6.95588904833,-5.49427417,11.34216935,-4.177278095,6.52820971,3.64555713333,1.51541166667,3.668688435,-3.36019945167,-3.11737592333,0.100659466017,-0.264786828833,-0.938441915333,-1.10817866,1.00720513667,0.492901561833,1.77260741667,0.657546803667,1.49287545333,3.36967360833,-0.775814407333,3.41810490667,1.77935804833,-0.234303410167,2.56795064833,-1.62727323167,-0.352569491,-0.912612895667,0.03556533575,0.324779159667,-0.0895419378,-0.522791616167,-0.409364234167,0.12878655735,-0.269015314667,0.494635528167,-0.1867619075,0.974731106333,0.6545345405,0.0735328973833,1.394807795,0.821553231667,0.238565091333,1.061951625,-0.351567140167,0.2880894405,-0.3717653825,-0.12261093455,-0.0277964755167,0.00875260699167],[-35840.4881667,-855.171713333,2430.928515,-4088.17836333,1360.89802667,1358.59928333,-997.449664167,348.058211,634.265439167,568.612289833,-506.9916215,434.689333667,-37.0027908183,278.352785167,-991.517501333,675.93964,-247.590562333,-305.55683,-512.2380205,-150.967676333,-495.529102667,-363.159903667,-362.840545833,589.737654333,104.7799089,-122.731418667,44.6534917833,-93.9606270167,-66.9048971333,-4.77564354383,-161.380157,35.897519,-103.0577632,3.70944112333,-50.7843889833,-24.6965478,-7.20800036667,59.3409198667,9.72540924833,-3.05075705983,37.5962560333,-25.0436273167,71.6395414333,-93.9373931833,43.1920698,-11.5939996667,-5.07352517,12.8009742667,-16.2559339833,1.87557326833,18.0518334667,2.93559065,9.10245086667,21.3140136833,-0.449342797,32.2936100667,-40.5166954833,26.4812449333,-17.6867591333,1.33924021,2.93897228,3.99826334167,-0.211535510333,-3.718214975,-0.396888980633,1.54722924667,-1.22982922117,4.066179205,5.80652173333,2.84711385,7.02617657833,-5.54812106333,11.81246035,-4.30158519167,6.36120452167,3.52635684333,1.44706363667,2.99530956,-3.39368155833,-3.22916093333,0.180037785167,-0.387053436333,-1.04503867083,-1.21460993667,0.997253878333,0.358535848833,1.92752136667,0.621251343,1.59064546667,3.47599174,-0.766002816167,3.44622533333,1.75255433333,-0.208653676833,2.339101665,-1.58983287333,-0.468974252333,-0.862538057333,-0.0186741877,0.3613932425,-0.09163309555,-0.5346652635,-0.426403023667,0.0931021149167,-0.314148296667,0.512584297167,-0.213646929833,1.03044763867,0.651337968333,0.08861549045,1.41073514,0.820653085833,0.249844399667,1.00586135417,-0.336396397833,0.256927379,-0.350737642,-0.1475940855,-0.0136333063303,0.00945371694833],[-35637.2071,-817.232470833,2351.19069833,-4108.29336667,1266.160755,1345.432215,-879.878477667,413.849517833,614.886701,519.274693833,-652.473777,399.165407667,-3.32300535667,276.822609333,-921.577452,638.589861,-244.644741167,-318.704559,-521.189082667,-162.376477,-454.752077833,-380.116327667,-354.691039833,564.127386667,93.34545905,-116.588894167,61.1294681167,-95.3919771167,-68.8158478,0.978679589667,-163.055485,37.0175738833,-122.049433,-13.8824870817,-49.2556135667,-25.9207413333,-6.50915405,64.6664824,11.2634505067,0.144991107333,39.7062686167,-25.4682059,74.468245,-101.503463917,37.5139265,-11.9231630167,-6.67765600333,12.41624155,-16.3747426167,1.352528801,17.9632651833,3.22629806167,10.615548095,21.7293612667,-0.199914997817,33.0995332,-41.7195667,26.8549926,-17.6211156667,1.03864683267,3.36666734167,3.720556825,-1.41449988217,-3.66703678667,-0.786309521833,1.1427031615,-1.49173777167,4.37602457333,5.61838831167,3.2707384,7.100850475,-5.62098335667,12.3059008833,-4.43926425667,6.23987647,3.41310774,1.39032034833,2.344278285,-3.40469101,-3.326986935,0.262683367333,-0.512546187,-1.14917155333,-1.32295614333,0.9862101075,0.216263441917,2.09205029833,0.581416872833,1.68106243667,3.58426092,-0.763625458667,3.49187891833,1.72211021167,-0.173953156,2.11610784667,-1.54419744167,-0.58212026,-0.8078566125,-0.0726438733,0.399031633833,-0.0943538530167,-0.544668399167,-0.444210373167,0.0563371644167,-0.361516292333,0.5333543165,-0.242488753333,1.08470979333,0.647430024667,0.1010686487,1.43086879,0.817304622,0.265264709667,0.950238109667,-0.318819631833,0.226815485167,-0.328763013833,-0.171770591667,0.000864455328667,0.00908111569333],[-35456.6736833,-707.532996333,2278.58315,-4127.67374833,1188.811075,1343.709335,-754.968818333,491.903234333,592.787181167,472.518497833,-793.595090833,361.160374333,33.630107865,278.030482333,-846.2068555,599.231144,-242.445361667,-331.245553,-532.715904667,-173.010534167,-412.550834167,-396.629738167,-345.271006333,538.1783065,81.1294785,-110.994079333,77.3831624,-97.7449792333,-70.8377201833,6.67081629617,-165.462037333,38.5205736167,-141.360891167,-30.3200968167,-47.8194237,-27.20614605,-5.92792670833,69.8205256333,12.69962095,3.30397893183,41.6495928167,-26.2356759333,77.4838174167,-109.160408167,32.2159856667,-12.1397033333,-8.37228549,12.0646054833,-16.4448461833,0.820783065333,17.8150849333,3.54282632,12.1338206833,22.0834242,-0.0548290646283,33.9379847833,-42.9649606833,27.3039577,-17.5323209333,0.781380201667,3.841529295,3.420986885,-2.52403158167,-3.59941970833,-1.1732905335,0.731126964667,-1.74403063833,4.68310763333,5.41537274167,3.67961683,7.171582965,-5.71708269833,12.8124679,-4.58401272167,6.15538158833,3.31005925167,1.343258165,1.72356097,-3.39534393,-3.40888512167,0.348560228333,-0.637695818167,-1.24888792167,-1.430289615,0.973210684,0.0697279819,2.260242005,0.537695982167,1.762043575,3.69160394333,-0.769275473833,3.55141959,1.68957641667,-0.132550416867,1.90171920333,-1.49176541167,-0.6898679045,-0.749285689833,-0.12580890115,0.437271505167,-0.0973705376167,-0.552490241167,-0.462029284833,0.01922322785,-0.409908721333,0.555838379167,-0.272602970833,1.13661853833,0.642535574,0.110048386,1.45435516,0.811720452833,0.283778672833,0.8956803445,-0.299189599833,0.198438620667,-0.306144115667,-0.194930982667,0.015420287403,0.00764003628333],[-35314.7024667,-574.7051375,2197.88447667,-4141.96274,1120.615455,1354.43937,-632.386729667,578.048189167,573.364782833,429.271557,-928.103521833,319.327650667,72.6795846167,279.766346,-767.557645167,560.1967595,-240.141269167,-343.133126667,-546.743891667,-182.75333,-370.4848115,-412.897001667,-334.7479375,513.358402833,68.5404082167,-105.624977,93.13475085,-100.970162117,-72.9216799833,11.9315287983,-168.5573335,40.26696005,-160.456766667,-45.35109535,-46.3706181167,-28.58667025,-5.352901875,74.7382052333,14.0288883833,6.38879887333,43.3623706333,-27.29245545,80.58048825,-116.7999475,27.38226125,-12.1552197833,-10.1838023633,11.74219545,-16.4990596667,0.3136639855,17.6159090833,3.89728538167,13.6347682167,22.3758429,-0.00544759881333,34.772512,-44.2482406833,27.8213898167,-17.3876328333,0.544396488333,4.36239877833,3.09951015833,-3.52415637333,-3.52417046167,-1.54948140833,0.318289612367,-1.97437444333,4.98184296833,5.20518922667,4.06685766333,7.231179745,-5.83785347667,13.3224437,-4.726647895,6.09775183833,3.22311447833,1.301889455,1.1416482165,-3.36796313,-3.47240826167,0.435654672833,-0.7616173485,-1.34347298667,-1.53232494167,0.958023989167,-0.07673105715,2.42827305833,0.489892729833,1.83265261167,3.79511865833,-0.782390536667,3.62084247167,1.65744860833,-0.0873661360667,1.69908610833,-1.434171415,-0.789818374667,-0.68752995,-0.177745320833,0.475594571333,-0.10134720875,-0.558190912333,-0.479132523833,-0.01780777555,-0.457871723,0.5793577305,-0.303337730667,1.18566893167,0.636313170833,0.115102567833,1.48018857833,0.804478834333,0.304167305833,0.843039164,-0.2780393495,0.172615142333,-0.2832401555,-0.2168797835,0.0297281351167,0.00509227348833],[-35224.8988,-455.663982,2101.31971,-4147.91920333,1056.06083533,1380.63454833,-518.9014495,670.490263167,561.3629345,390.464957833,-1053.384548,273.3264515,113.46753385,280.232393833,-686.99493,523.6688895,-237.0550345,-354.276457167,-562.9613085,-191.315975,-329.865448,-428.773748,-323.242278167,491.278524667,55.9927049,-100.2154755,108.101443283,-105.013233333,-74.99808535,16.4579437,-172.204145833,42.1306705833,-178.689274167,-58.7365631,-44.7613679167,-30.0806002833,-4.67972748833,79.3528491167,15.2290311833,9.36233832667,44.7892587833,-28.5709074,83.6543523,-124.270137,23.0865671,-11.85810465,-12.14587295,11.4476652167,-16.5650464,-0.133192811833,17.37469885,4.29612529333,15.0960958,22.6036159,-0.0429220127283,35.5667795,-45.55284405,28.3961846667,-17.1437138,0.30017698915,4.93044065,2.75309721167,-4.39881175167,-3.44959343667,-1.905034535,-0.0897215555333,-2.170930015,5.267227495,4.993713515,4.42504399833,7.27264924833,-5.98330494667,13.8247715333,-4.85509280833,6.05477066833,3.15907725167,1.26050599,0.606752058833,-3.324822985,-3.5149131,0.521634697167,-0.883096713,-1.43214705,-1.624471865,0.940684114667,-0.219268347433,2.59219409833,0.437849629667,1.89162568833,3.89169550833,-0.801864771333,3.69539484,1.62847549333,-0.0418477819683,1.5111233,-1.37311914833,-0.879644519667,-0.6232227035,-0.228154088,0.5133201915,-0.106964661333,-0.561836537833,-0.494645440333,-0.0542785732167,-0.504003972333,0.603285468833,-0.334068831833,1.231169755,0.628436979167,0.115810817167,1.50716419,0.796170602667,0.325039389333,0.793074413333,-0.255988907167,0.1500630455,-0.260400589333,-0.237482966,0.04347837025,0.00135733777667],[-35205.79555,-327.221867333,1988.88667,-4149.75646667,1001.2101015,1425.66795,-414.789117167,766.222186167,557.9208375,356.442368333,-1167.39225167,225.4997885,155.420595,279.379824833,-604.568140167,490.7253135,-233.569864667,-364.8023015,-580.3347975,-198.396537833,-291.243026833,-443.807454333,-310.667577,473.280079167,43.7249642167,-94.8797929333,121.958472333,-109.7778235,-77.0101023167,20.13264425,-176.282023667,44.0860623,-195.449862,-70.2496597167,-42.7747754167,-31.6854339167,-3.89382676,83.5951427833,16.2174583833,12.1669311,45.8964189333,-30.0375275,86.6339985167,-131.407010667,19.4033563,-11.1200644633,-14.2763345333,11.1600398667,-16.647272,-0.498172717333,17.1015957667,4.71399887667,16.48661715,22.75755465,-0.168935825383,36.2921876667,-46.8554910667,29.0208096667,-16.7572897833,0.0269042967667,5.53863246,2.37282337333,-5.13177286833,-3.37641662167,-2.22996172333,-0.4862698123,-2.33056351833,5.53287283667,4.781858505,4.74500023167,7.29017609667,-6.15382963833,14.3102289667,-4.95940453333,6.01476157667,3.12236343833,1.21148679,0.126129867667,-3.26616129833,-3.53372815667,0.6053591885,-0.999617081333,-1.51390874,-1.703312235,0.921528690667,-0.355996382167,2.74779337667,0.381174114167,1.93645035833,3.97875209667,-0.827433631667,3.77015406167,1.60474832167,0.000620604476667,1.339887515,-1.30943115,-0.957284885,-0.557196024167,-0.277075862167,0.5497165525,-0.114256196,-0.563406231333,-0.507560976167,-0.0894971991167,-0.547470513833,0.626952077167,-0.364462550167,1.27193329,0.618631862833,0.1115533895,1.53401535333,0.7871181865,0.345204361,0.746138785667,-0.233459148833,0.131262919,-0.2380265855,-0.256770156833,0.0564457056167,-0.00359697980667],[-35277.5641167,-144.799029,1864.12445,-4150.23172833,963.331575167,1492.46731,-325.173556167,855.935057667,563.566974,326.369068667,-1268.08211333,177.774178667,196.894546,277.800383333,-520.3816085,461.860223167,-230.4217105,-374.659675167,-597.483967333,-203.495743,-255.020663667,-457.8124455,-297.037280833,459.834918667,31.8022052167,-89.7762101833,134.453475667,-115.0631135,-78.7568224167,22.8170998667,-180.7802155,46.06398185,-210.368526667,-79.6686731667,-40.1948778167,-33.4123602167,-2.99746432167,87.4035673167,16.9006253,14.7757104167,46.6315799833,-31.6669345667,89.4348661167,-138.061883833,16.40428765,-9.84369483833,-16.5741621,10.7982618167,-16.7412652833,-0.772266368167,16.8024203167,5.109951195,17.77541665,22.8229038833,-0.374322500833,36.9169811167,-48.1199085167,29.6852408333,-16.2024288167,-0.292369810183,6.15323027167,1.94403237167,-5.70773425833,-3.30111791667,-2.51899180167,-0.867033304,-2.45547148667,5.77074936,4.569135945,5.02229737333,7.27727948667,-6.34500850667,14.76790145,-5.034610215,5.96527213667,3.11006281167,1.145799515,-0.295615862,-3.18893638333,-3.528176075,0.686621484833,-1.10919434167,-1.58815368833,-1.76639283,0.900346529333,-0.4856170295,2.89134713833,0.319199857167,1.9651298,4.05301749167,-0.859097325667,3.83925312667,1.58705709833,0.036915076415,1.18554497333,-1.24255833,-1.02201639917,-0.490737564667,-0.324920524333,0.5841657945,-0.1229204975,-0.562796374833,-0.516927566,-0.12288513335,-0.587737248667,0.649405282667,-0.3943291645,1.30661685333,0.606427172333,0.102056191583,1.55909858667,0.7774951895,0.3636565125,0.701834504167,-0.2105850355,0.116106780833,-0.216649319667,-0.274999136333,0.0686080755,-0.00981523233833],[-35435.2805167,113.9426875,1706.55078667,-4152.00264167,948.340890167,1577.77918333,-250.414429667,931.757503167,577.2688005,301.323550833,-1353.30407833,132.979230933,236.166173833,276.2663885,-438.405897833,437.159016833,-227.667758,-383.3098915,-613.063448333,-206.3951535,-221.501638333,-471.742028833,-282.421264,451.284838667,20.254541265,-85.0494743,145.449893333,-120.719947333,-80.11980865,24.407746,-185.789491,48.0307251,-223.154729167,-86.6738145167,-36.9947153667,-35.2726364167,-2.05361507333,90.7135526667,17.18261395,17.1661514167,46.94961485,-33.3969319667,92.0006332167,-144.131232,14.20042235,-8.01782276667,-19.05747995,10.283881415,-16.8433299167,-0.967035754167,16.4750338833,5.44708910667,18.9407050833,22.7830536333,-0.636069805,37.4187131,-49.32206795,30.38515645,-15.4723785833,-0.6803462775,6.73591851333,1.4676923485,-6.11693657167,-3.21973385,-2.76886149833,-1.22958404083,-2.54766023667,5.97488110167,4.35338974167,5.25310317667,7.22894305,-6.55264836,15.18589885,-5.07741813,5.89394665167,3.11539838667,1.060481132,-0.657064896,-3.09273696333,-3.50019028833,0.765831235333,-1.20921739333,-1.65431161,-1.81207657667,0.876624694333,-0.607350294833,3.01841039833,0.2510763165,1.97672929667,4.11076563,-0.896543700333,3.89742639833,1.574600395,0.0651165366167,1.04698020567,-1.17291262333,-1.07434565,-0.424695149667,-0.371388612667,0.616303877833,-0.132398016833,-0.559801073833,-0.5221538905,-0.154109465,-0.624366670833,0.669548759833,-0.423643436333,1.334222025,0.591357433833,0.0871082449167,1.58087281333,0.767076660833,0.379348455333,0.659376226833,-0.187615887833,0.104098659767,-0.196562125167,-0.292177010833,0.0799423460833,-0.0175695878667],[-35650.03375,437.3791155,1502.78562667,-4152.57244333,958.571146167,1674.82838167,-191.491223833,993.166461167,597.0387815,283.645982833,-1421.61469667,91.5804711,274.093968333,275.951327167,-364.931954833,415.886830667,-224.873418667,-389.8476695,-626.535564,-206.228216667,-190.953282,-486.961745833,-267.153968,447.198427667,8.89943390833,-80.8528367667,155.003725833,-126.664952,-80.86315565,24.8009085833,-191.3545635,49.9596308167,-233.799025833,-91.11903135,-33.1518141833,-37.2915740833,-1.186312081,93.4872113333,17.0051067333,19.3206062833,46.8088317333,-35.1275047667,94.3067322333,-149.5813715,12.8503412,-5.64675567333,-21.7166241667,9.583985265,-16.9386602667,-1.11740344133,16.1088161167,5.70047561167,19.95406625,22.6207503,-0.923123080833,37.785266,-50.44528215,31.1062413833,-14.5627930167,-1.15204301,7.26087450667,0.959034858667,-6.36214266833,-3.12297901167,-2.97991894167,-1.576567205,-2.61070965,6.13635317333,4.130910195,5.43370160333,7.14112384833,-6.76992722167,15.55125005,-5.082992995,5.78913558,3.133212065,0.956624467333,-0.9609677375,-2.98081615333,-3.45385649333,0.844584935,-1.29650403833,-1.71265563167,-1.84076959833,0.849241154333,-0.721289260833,3.12421839333,0.175438763667,1.97190378667,4.148407455,-0.938365638167,3.93927429833,1.56660000667,0.08375413815,0.9223936435,-1.10247215833,-1.11534132167,-0.360402859667,-0.41541205,0.6458562855,-0.1416063665,-0.554028416167,-0.523205183,-0.1828047565,-0.657232113,0.68624179,-0.452642859,1.354132935,0.573043300667,0.0667839598167,1.597701645,0.755652686833,0.391035828,0.617944419833,-0.165271577833,0.0946443482167,-0.178164064167,-0.308043998667,0.0905147308833,-0.0269344241],[-35883.7026,781.097399333,1255.41520067,-4151.09820833,993.410173,1780.89794833,-144.034623,1051.42244633,619.981796667,277.525663667,-1471.66371333,55.0085512,315.395827167,275.103005667,-305.163783167,397.069234333,-221.0006055,-393.5087,-637.647704,-201.753618167,-164.212416667,-504.177772333,-251.538789167,447.9978775,-2.443190275,-77.3686794333,163.186907167,-132.891653333,-80.8502342667,23.8650022333,-197.202702333,51.7549530333,-242.024541,-93.0374316833,-28.7329777333,-39.4767706667,-0.577728976667,95.68362725,16.3397013333,21.1848017167,46.1950973,-36.7000075667,96.3058550667,-154.321878,12.3193958667,-2.73317235733,-24.5793085833,8.74015573,-17.0115786333,-1.27085850833,15.6863847667,5.85550773333,20.7814725833,22.3288375833,-1.21401678533,37.9983479833,-51.4684923,31.8135902667,-13.4546549,-1.74019433167,7.734950495,0.4377531282,-6.45720109167,-3.00245784833,-3.15182041,-1.91075106,-2.65014792167,6.24548628167,3.89791886333,5.55367501,7.00846566333,-6.99195951,15.8481991167,-5.03950574667,5.63355814667,3.16338169167,0.836553577167,-1.21295333417,-2.860865895,-3.39141363167,0.924837898,-1.36688071,-1.76262014167,-1.854234665,0.817055230833,-0.828471505333,3.20288155333,0.0912250283285,1.95081209333,4.16215878667,-0.981733142333,3.95849288667,1.562243485,0.0902533293167,0.810185113667,-1.03501282367,-1.145678665,-0.298229943333,-0.455985444667,0.67280293,-0.1492116865,-0.544956978,-0.5202089175,-0.208511686667,-0.686420883667,0.698381285,-0.481329762,1.36567871333,0.551262868333,0.0409353513833,1.60793593333,0.742902246,0.396856607333,0.577042235333,-0.144720787833,0.0873577035,-0.161621651833,-0.3224048395,0.100136670467,-0.0380404103],[-36105.35955,1093.24284117,959.174440667,-4149.482155,1049.569572,1892.73195333,-101.36345525,1119.01398,642.983239167,286.823374833,-1502.75582167,25.8129929883,365.329878833,271.746879333,-262.283652333,379.8336025,-214.9486755,-393.655296167,-646.111670667,-191.8068585,-141.912091,-523.331707833,-235.915772833,454.309526833,-13.8412276517,-74.74280965,170.147006167,-139.4120825,-79.9899881333,21.4982296167,-202.778561333,53.2259066167,-247.512569667,-92.4879464667,-23.9018513,-41.79356935,-0.393978274333,97.2878513333,15.1748867,22.71069845,45.0886004667,-37.89538075,97.9173972833,-158.240314833,12.53983815,0.683208367333,-27.6765776,7.80787554667,-17.0462450167,-1.46838775167,15.1906076167,5.90181464,21.3941660333,21.89834555,-1.48416645667,38.02822265,-52.3649010667,32.4662811833,-12.1403121167,-2.47469700333,8.17598579,-0.0782794825333,-6.41745594333,-2.85427479333,-3.28310680833,-2.23493051667,-2.67250010667,6.29324542167,3.65010845333,5.60193804667,6.82214490833,-7.21388423667,16.0598534,-4.93696054667,5.41191631,3.207149855,0.703293634667,-1.418744095,-2.74094270167,-3.31539642667,1.00733175633,-1.416431285,-1.80344372333,-1.85436755667,0.778808559667,-0.929943880667,3.24849056333,-0.00281838285267,1.913721045,4.14759155667,-1.02369226033,3.949798055,1.56079752667,0.08188864085,0.709059478667,-0.974438668333,-1.16677361167,-0.237941654667,-0.492374239333,0.697117727167,-0.1540750625,-0.5322054585,-0.513143909,-0.230828553167,-0.711849164667,0.704755254,-0.509441049833,1.36836749,0.525636021333,0.00945521688333,1.61023081,0.7286271855,0.3949037055,0.536340544333,-0.127216378667,0.08172697535,-0.146930456333,-0.335229228333,0.10857037,-0.0510705645167],[-36293.5652333,1327.84030667,620.326508667,-4146.07811167,1120.338125,2011.30755167,-65.4228861,1199.41851833,664.168452333,313.202274333,-1513.38116333,3.86016377,426.839470333,265.577961667,-237.349240333,363.391638667,-205.965642833,-389.5582955,-652.0017285,-175.223349167,-124.255616333,-543.710433,-220.6991965,466.1145865,-25.3795844333,-73.0136164167,176.033578,-146.238875833,-78.0084653333,17.5831024667,-207.414350833,54.1396398667,-250.101020667,-89.5256252667,-18.7839290833,-44.2022759833,-0.73565575,98.2821150333,13.5038440667,23.9085181,43.4257294167,-38.4722074167,99.0378426333,-161.219049333,13.4416581167,4.54831735767,-30.9884998167,6.81563936833,-17.0231709833,-1.739405455,14.6025262,5.82997587,21.7702635833,21.3064052833,-1.69634300667,37.8357400333,-53.0929148333,33.0203989167,-10.62691914,-3.36225863667,8.59491696667,-0.578359292633,-6.25046815,-2.67502476833,-3.37372905667,-2.55270547333,-2.68280336667,6.26973804333,3.38212355667,5.57246013,6.57069865667,-7.42687104833,16.1671363333,-4.770499325,5.11460479167,3.26678724833,0.558104660667,-1.58076695333,-2.62578941833,-3.22886714,1.09188911167,-1.44239154667,-1.83453179167,-1.84214407,0.732713926333,-1.025934021,3.25587096333,-0.108366334005,1.86111592333,4.09919737167,-1.061670395,3.90842921833,1.56287834333,0.0563065322167,0.618446812333,-0.9234514595,-1.18040258667,-0.179711704333,-0.523961727667,0.7184895455,-0.155276661833,-0.5153640815,-0.501759865333,-0.249485456667,-0.733048035667,0.703935420833,-0.536666942167,1.36162463167,0.495394200167,-0.0273661545833,1.603048265,0.713121628333,0.383579951167,0.495580779167,-0.113894333667,0.0770645313333,-0.134163562833,-0.346474777167,0.115731493833,-0.0660164883],[-36455.3282,1488.82309667,282.303503217,-4137.33518,1205.91139833,2142.66802833,-41.7567567167,1286.128035,683.207459167,356.064117,-1503.016725,-11.8765388283,500.7993885,256.4447285,-227.027118333,347.064776,-194.295140667,-380.942972,-655.195251833,-150.613673833,-111.294631333,-563.467080333,-205.724533667,482.554623,-37.1973055,-72.26004355,180.991849167,-153.258129167,-74.41933135,12.0449825267,-210.431137333,54.4667217333,-249.844185167,-84.4155744667,-13.3401478,-46.6677306833,-1.63687977767,98.6891797333,11.3317712817,24.82854275,41.1508384333,-38.25130135,99.60562025,-163.134562167,14.8977914833,8.85863087167,-34.4216171333,5.77740058833,-16.9181063167,-2.09640188667,13.9149075167,5.62431798167,21.8875956,20.5330779167,-1.81953524667,37.3899045167,-53.5903054167,33.4332189,-8.91759066,-4.38296008,8.99769030667,-1.07012205467,-5.96814874333,-2.461012055,-3.42544643333,-2.86771275167,-2.68771903333,6.16494455167,3.09039323167,5.46537798333,6.24544823333,-7.61652581667,16.1567848667,-4.53721507167,4.73595011667,3.34515179833,0.3966059145,-1.70270121333,-2.51519947167,-3.13151447167,1.177416465,-1.44385327833,-1.856155645,-1.81828424167,0.6777017215,-1.11605624833,3.222479985,-0.2261963145,1.79372371167,4.0133692,-1.093186365,3.82925707167,1.57014020667,0.0114473014167,0.537743555167,-0.882652818833,-1.18701761833,-0.12432817205,-0.551460866,0.736288283333,-0.152229232167,-0.494227365667,-0.485666572,-0.263987547667,-0.7495022465,0.694818850833,-0.562580974167,1.34476468667,0.459934476167,-0.0687622757167,1.584648245,0.697104183333,0.3620629345,0.454655642333,-0.105469701167,0.0729114723667,-0.123630701,-0.356572751167,0.1215808655,-0.0824513516833],[-36634.9712833,1567.529825,-48.1582504667,-4123.19514167,1296.876815,2277.10189667,-35.3928357667,1361.03419,701.6694625,411.721484333,-1475.55895333,-22.7588858167,582.137958333,244.681130667,-229.1520175,331.319741667,-180.323079667,-368.144132667,-655.5346515,-118.5701345,-102.59428965,-581.935276333,-190.475950333,502.097749167,-49.1181896667,-72.2458940667,185.286735167,-160.232101167,-69.14832785,5.07693691167,-211.761661333,54.4133315,-247.171550667,-77.4452298333,-7.60207960333,-49.1305552833,-2.97979437667,98.63442905,8.736863385,25.51022015,38.31362575,-37.2400064833,99.6758639333,-164.008757167,16.817992,13.552487655,-37.8476356333,4.69773054333,-16.7266582167,-2.52040362167,13.15173615,5.29581807667,21.7571752333,19.5895904833,-1.84560311333,36.70738335,-53.8336198167,33.6983324167,-7.04234183833,-5.491639275,9.38265111333,-1.559452915,-5.587134915,-2.21921591167,-3.44184369,-3.18017083,-2.68797205167,5.98454792833,2.77806968333,5.28883142833,5.85285528167,-7.77366235333,16.0336388833,-4.24242243333,4.28330599667,3.44218770833,0.2186797902,-1.78967062,-2.40685290167,-3.02199371667,1.26017057667,-1.42352372333,-1.86991754333,-1.78343235,0.616361390667,-1.19927456,3.15121964833,-0.353913709167,1.71358166,3.89243347333,-1.11682572333,3.71241579,1.583648675,-0.0512191572333,0.466442365333,-0.851090367833,-1.18638815333,-0.0723944836667,-0.575889734833,0.749790055167,-0.145610341833,-0.469372206333,-0.465047385167,-0.273730481167,-0.760976737333,0.677875593333,-0.586611400333,1.31828272667,0.419841438,-0.113525378017,1.55493353667,0.681363876667,0.331220554333,0.413799639833,-0.101854433333,0.0691606853167,-0.115472366333,-0.3659206675,0.1260861785,-0.0998226162667],[-36881.5866667,1584.29128167,-356.21738145,-4110.72905667,1386.05771333,2401.98594333,-48.1275696667,1414.31306333,719.558537667,474.879655333,-1437.381305,-29.5416372667,666.246354333,229.712335667,-238.727104667,316.7568155,-164.9125865,-352.192062833,-652.785213667,-80.5912571667,-97.8793189833,-597.954702167,-175.123268667,523.784296167,-60.8214012333,-72.6998979667,189.143423833,-166.888364167,-62.52202755,-3.05954627,-211.520499333,53.9778456333,-242.352938667,-69.1533231,-1.51381941667,-51.5143506667,-4.59646601667,98.2889108167,5.82218893,25.9297234,35.0200803833,-35.5749033333,99.2967035333,-163.876604667,19.02110065,18.5896637333,-41.2030087833,3.576473375,-16.4549258167,-2.98429328333,12.3560587,4.86535341667,21.40308,18.5066674833,-1.79716160333,35.8264026333,-53.8231938167,33.7986058333,-5.03332211167,-6.66918179333,9.74474414833,-2.06617540333,-5.131278835,-1.9614253,-3.430171885,-3.48788759667,-2.68312708333,5.74404633667,2.45184034167,5.05128637333,5.409612485,-7.89735185,15.8079358333,-3.89546862833,3.760046985,3.55652628333,0.0181204533,-1.8499924,-2.29998820833,-2.90171181333,1.33596772,-1.38642385667,-1.87822331333,-1.73917817,0.553382542667,-1.27476926333,3.04763950833,-0.486951424333,1.62177922333,3.74213351833,-1.13273337,3.55918374833,1.603959595,-0.131223677833,0.403305054167,-0.828574091833,-1.17956135833,-0.0244591720167,-0.599025718833,0.758643112833,-0.136557354333,-0.441805781167,-0.440688145833,-0.278235053667,-0.7676634175,0.654452148333,-0.608214158833,1.28305425167,0.376560057,-0.1606784485,1.51468688333,0.66649606,0.2921526015,0.373259941667,-0.1031281655,0.0653927676333,-0.109788919667,-0.375257476167,0.129338492167,-0.117717823917],[-37208.8985167,1567.94834667,-636.7813625,-4100.26441667,1469.68897833,2501.46458833,-80.4756135667,1436.55908167,737.021750333,541.135783667,-1395.54919333,-32.61323055,749.1016575,211.4790575,-250.867784667,303.599696667,-148.7279925,-334.2271485,-646.561836833,-37.8865482517,-96.5284379167,-610.456240667,-159.820698667,546.572784333,-72.1300581833,-73.3274467333,192.763443167,-172.909152667,-54.7735401,-11.9584315117,-209.867082,53.1730546,-235.691045167,-60.07997715,4.99477126667,-53.77075575,-6.32991402833,97.8174447667,2.6963192745,26.079047,31.41619065,-33.4015885833,98.5185764333,-162.788184833,21.3298811333,23.9351386167,-44.4221750667,2.41173340833,-16.1080623667,-3.46883099,11.5696104167,4.351821655,20.8469439667,17.3204514667,-1.69434750167,34.7848347333,-53.5637866833,33.7190660667,-2.91924150033,-7.89352824667,10.0773703383,-2.61140325333,-4.62498286667,-1.69622770333,-3.39994313167,-3.78918014,-2.67442170667,5.45576659167,2.11736050333,4.762732335,4.93176977,-7.98742546167,15.4904252333,-3.50419375667,3.17158976667,3.686270695,-0.211811378133,-1.89223368167,-2.19356494667,-2.77194905167,1.40194122167,-1.33761144333,-1.88373019333,-1.68784753333,0.491964540667,-1.34268697667,2.91732522167,-0.621228628167,1.51935629833,3.568160805,-1.140526785,3.37164024833,1.631333355,-0.2280701425,0.346915468833,-0.814764959,-1.16743696667,0.0190274580167,-0.622658646333,0.762782069167,-0.125931202333,-0.412588371833,-0.413561422,-0.277448302833,-0.7701353565,0.6256778755,-0.627059465,1.23994831,0.331382601167,-0.209096946,1.464859045,0.652925259,0.245975173167,0.333197214167,-0.109316778833,0.0612422151167,-0.1065917795,-0.385290956333,0.131440542833,-0.135720911667],[-37589.2225,1564.25293667,-884.783079667,-4085.70664167,1550.19158833,2560.84930667,-128.117269667,1420.94895667,753.723688,607.213164333,-1356.46117,-30.8487644833,828.751349833,191.557384667,-260.676875167,291.517204667,-132.474807333,-315.270109,-636.2227865,9.24074064333,-97.1769709667,-618.149233333,-144.352751833,569.406466833,-82.9978351333,-73.9427728667,196.307383,-178.007201167,-45.88253435,-21.01473785,-206.807937167,52.1605433667,-227.441079167,-50.6589130167,12.0193711133,-55.8480114,-8.05982752333,97.3542383167,-0.571706832,25.9817725,27.66966045,-30.8059564833,97.4162982667,-160.759259333,23.6147672333,29.57653405,-47.41324525,1.21015433196,-15.6771707333,-3.95677105667,10.82574965,3.76008065167,20.10114865,16.0585294667,-1.54230124833,33.6159619333,-53.0452526667,33.4553462833,-0.713802241333,-9.12814333833,10.37893575,-3.211344505,-4.08965551167,-1.42672289333,-3.35695970167,-4.08328721167,-2.66522941833,5.12516123333,1.77477274,4.434121095,4.43057403333,-8.03961711,15.0916342,-3.0699567,2.52831457667,3.831891225,-0.4752644075,-1.92314787333,-2.08550368667,-2.63279107833,1.45607952,-1.280129865,-1.88893385,-1.63132984667,0.4330779055,-1.40475944333,2.76476386667,-0.754601513167,1.40782505,3.37500637667,-1.137833095,3.15279878667,1.66678387333,-0.3403616195,0.2964715265,-0.808674429,-1.15016694333,0.0578267926667,-0.648261730667,0.761964832167,-0.1140474365,-0.38267518,-0.384217308167,-0.271698793167,-0.769173484833,0.592121849333,-0.643296630833,1.189663265,0.285012096333,-0.2572472575,1.40633427667,0.641229506333,0.193923888333,0.293924496333,-0.120187944167,0.05661484415,-0.105720639167,-0.396517435167,0.13248729,-0.153364289],[-37995.6131833,1598.15472667,-1106.18097183,-4067.56320833,1628.62377,2569.68743667,-181.416900667,1367.51724667,767.655698,671.259169833,-1324.375435,-22.4709286333,904.509136667,170.997060167,-266.066550167,280.0682785,-116.5843695,-296.055734,-621.573395833,60.3014881817,-98.6178403333,-620.507961,-128.5435435,591.752854833,-93.3281589,-74.4906955667,199.86036,-182.086078667,-35.9245861167,-29.6907310667,-202.349676667,51.08680235,-217.789885167,-41.1446448667,19.4755225167,-57.6811696167,-9.73735283333,96.9827709833,-3.93035304717,25.66465065,23.9233071333,-27.836301,96.0689443167,-157.833432667,25.8001383167,35.4463227167,-50.11610495,-0.00543362215333,-15.1536278167,-4.43969968,10.1471352733,3.10040422833,19.18505915,14.7417932167,-1.34388197333,32.3543082333,-52.2728886333,33.01237245,1.56230669967,-10.3414473283,10.65309785,-3.86600003667,-3.54602601167,-1.15575025133,-3.303645315,-4.36817688167,-2.65774660333,4.75778131167,1.42285640833,4.07335209167,3.91636615,-8.05249418667,14.6219444333,-2.59346923167,1.84286841,3.99241063,-0.7697234535,-1.94894489667,-1.97640297,-2.484910365,1.49699302833,-1.21543832667,-1.89506006833,-1.571650105,0.376850940333,-1.46272723333,2.59362347333,-0.8853746575,1.28902528167,3.16672584833,-1.12204853833,2.90706939,1.71015562,-0.465741751,0.251408397167,-0.809949704333,-1.12827075833,0.09261825115,-0.676317162,0.756126079333,-0.10103501685,-0.352788754333,-0.353264188667,-0.261533417333,-0.765397734333,0.554418711167,-0.657139562667,1.13312882333,0.238125496167,-0.303709377333,1.34024084667,0.631720939,0.1371319326,0.255827705167,-0.135380395833,0.0514144066667,-0.106669026833,-0.409037229333,0.132473838167,-0.170426610667],[-38427.1665833,1646.85246,-1323.92416833,-4058.12922167,1701.490055,2524.06510833,-226.994042333,1281.11354333,775.6530205,733.487422333,-1300.58947167,-6.59475193333,974.125436167,148.752149333,-270.3883345,269.272202667,-100.969343833,-277.085569167,-603.300156833,113.425647983,-100.418323983,-618.758039667,-112.534039717,613.565482,-102.872389883,-75.0290944667,203.360866167,-185.2277245,-25.2950573833,-37.6303797667,-196.754554,50.0195490167,-207.036703167,-31.5589027167,26.9162567167,-59.22042125,-11.3871699617,96.7314900667,-7.29972162167,25.17549725,20.3028375,-24.5604484167,94.5642621667,-154.184937167,27.8894981667,41.3411065333,-52.5231486667,-1.21287642137,-14.5484377,-4.918468605,9.55320822167,2.40191890167,18.1486408667,13.3975674,-1.1094815755,31.0447394833,-51.2972134833,32.41404025,3.85442360167,-11.5089347833,10.8931309833,-4.54999307,-3.01815059667,-0.889530685667,-3.24043522,-4.637833355,-2.65275982333,4.36586116833,1.06378348667,3.686201835,3.40274501833,-8.03124245167,14.09563095,-2.08295018167,1.133109111,4.156904455,-1.0827674005,-1.97790448833,-1.86992012833,-2.33092050167,1.52445274,-1.14457423333,-1.90195789833,-1.51210539167,0.323129048167,-1.51750546333,2.40851312333,-1.0110813645,1.16579237333,2.94854195167,-1.09238293167,2.64206299,1.75703916,-0.599967207667,0.2102127615,-0.818163227333,-1.10333515667,0.125513649733,-0.705944984,0.745870934167,-0.0872352231333,-0.323633663667,-0.321830460667,-0.247939289667,-0.7593617365,0.514006138167,-0.668677114333,1.07199654167,0.191821644333,-0.3474216725,1.26850909833,0.623724889667,0.077029762,0.2189346285,-0.153726406,0.04532208535,-0.108300946,-0.422455023667,0.1312844235,-0.187033964],[-38869.1154333,1691.69505833,-1548.08240333,-4074.86141167,1768.07922,2428.47771833,-246.336140333,1172.83992,772.249798333,794.490733667,-1284.20133667,17.96335655,1035.82441267,123.270043133,-277.3209725,258.823467667,-85.8034402167,-258.780551833,-582.450296333,166.2607515,-102.309863833,-614.033456667,-96.8141057167,635.236228333,-111.3554915,-75.76877605,206.603651333,-187.648691667,-14.5735265183,-44.50344915,-190.2455715,48.8853218167,-195.394521333,-21.91398345,33.7958370833,-60.40228185,-13.06526585,96.5823607667,-10.6158001833,24.5442939667,16.9318479333,-21.0629778833,92.95417115,-150.009822667,29.88218275,47.0160596,-54.6658368833,-2.38625014333,-13.87206725,-5.39211051,9.061650295,1.697290725,17.0495840833,12.0531754,-0.863789001333,29.7291814,-50.1846799333,31.6813572167,6.09640556,-12.61881795,11.0891986333,-5.23391986167,-2.53499366,-0.634269457667,-3.16563929,-4.88336153333,-2.64956056167,3.96477866667,0.7002323675,3.27450220167,2.90515378167,-7.984731105,13.5271609667,-1.550112605,0.416078129167,4.31168252333,-1.40193656333,-2.02099017833,-1.771366355,-2.175507125,1.53846389,-1.068459702,-1.90864688,-1.45606690333,0.271994439833,-1.56961771167,2.21406368833,-1.12830166167,1.04087650567,2.72646262167,-1.0491898075,2.36615839,1.80178313333,-0.739290006167,0.170313097667,-0.833185305167,-1.07800153833,0.159095742333,-0.736086610667,0.731909822,-0.07316870275,-0.2958972255,-0.291236733,-0.232034405833,-0.751506509167,0.472732373333,-0.677775056667,1.0081242315,0.147509105333,-0.3875504935,1.19337384333,0.616218903833,0.01487514275,0.182999894667,-0.173897892667,0.0376448948,-0.1092623935,-0.436382259167,0.1288075405,-0.203518815],[-39293.1251167,1692.53104833,-1773.90653167,-4125.66959333,1819.168505,2292.76554,-232.521237167,1051.6062565,754.394434333,852.7012635,-1273.285365,48.4136137167,1087.48757333,91.9314384333,-289.113712833,248.751066833,-71.2767237333,-241.563730333,-560.860207167,216.5237725,-104.726694,-607.033786,-82.29427095,656.751633833,-118.461391667,-76.6772110833,209.291683,-189.648955833,-4.32328603,-50.26397315,-183.02138,47.3625094667,-183.157778667,-12.29940048,39.6348315833,-61.1501895333,-14.7170033167,96.4798491,-13.8030424167,23.7830961167,13.8569506833,-17.4522356833,91.1859646333,-145.497957833,31.7387874167,52.2298709333,-56.56454045,-3.51871718167,-13.1322930167,-5.83334411,8.68325398333,1.03375250067,15.9352591333,10.7255007483,-0.639360709167,28.4193710667,-48.9948742333,30.8203974,8.21399877667,-13.6601366167,11.2243677333,-5.896098245,-2.12455824833,-0.397773466333,-3.07507505,-5.09544778667,-2.63968608667,3.56790979,0.337192003233,2.838551565,2.433801605,-7.92127843833,12.92605235,-1.0108673605,-0.2941299075,4.442432965,-1.71814787833,-2.08926824667,-1.68388599833,-2.02328665833,1.537482955,-0.988740538833,-1.91342195,-1.404316155,0.223645134167,-1.61757085333,2.014418195,-1.233582955,0.916303521167,2.50512065333,-0.993769305,2.08608610333,1.83892976833,-0.880716448167,0.128723124517,-0.854078847667,-1.05487736167,0.195424527,-0.765875380167,0.7143781775,-0.0598054843167,-0.269999069,-0.262342026667,-0.2147750325,-0.7415522545,0.432285240333,-0.683881241,0.943041659667,0.106266365183,-0.423269459167,1.11654008167,0.608199112833,-0.0482552809,0.147612962833,-0.1944784005,0.0276209339167,-0.108388098333,-0.450476628,0.125024976167,-0.2200929105],[-39655.2176833,1641.34228667,-1960.79648667,-4198.35895,1846.56505667,2134.89041667,-199.633343667,919.612376667,723.680636667,903.52635,-1265.19125333,77.3681344,1127.3143,53.0612707717,-302.605836833,239.120210167,-58.1565476833,-225.8931665,-540.3808665,262.924401167,-108.2949075,-596.967398833,-70.2548760833,676.863118833,-124.069966,-77.4792626333,211.100831667,-191.342882333,5.15420882167,-55.0870054833,-175.178509,44.9435776333,-170.794344167,-2.97412388,44.3582584833,-61.4070284333,-16.13804815,96.34942495,-16.7656222,22.87924415,11.0589692983,-13.8735519333,89.1271908833,-140.7484575,33.3582059333,56.8640938667,-58.1741233833,-4.66755259833,-12.3245118333,-6.184070045,8.41775172,0.45580314365,14.8222367667,9.42878449167,-0.4711589795,27.1023549333,-47.73530925,29.82261005,10.1461643283,-14.6085109333,11.2654374833,-6.542151135,-1.802544975,-0.18503897078,-2.96463501333,-5.26805890167,-2.61115072667,3.18255017,-0.0152132054,2.38185427,1.99410171667,-7.83929313667,12.2983358667,-0.483706216783,-0.987041953167,4.53742717167,-2.03228718167,-2.18883754833,-1.60285397,-1.87768699167,1.51871647167,-0.9084484465,-1.91453204667,-1.35463180333,0.179101485833,-1.65776595167,1.81387163833,-1.32361604833,0.793208692167,2.28791575333,-0.928036389667,1.80551726667,1.86577535833,-1.02262381283,0.0835102735667,-0.8773398345,-1.03583083167,0.234410472167,-0.795275873667,0.692623957333,-0.0483924748333,-0.245904351833,-0.235131266167,-0.196479557667,-0.728810031833,0.393832555333,-0.686097178833,0.877353982833,0.0687162927667,-0.453457958,1.03891018,0.599439007,-0.111237420417,0.1125826642,-0.213952343,0.0146717153317,-0.105360823333,-0.464641035,0.120266920833,-0.236458663],[-39907.2162333,1562.723995,-2066.01949833,-4275.850905,1852.14775167,1974.23720167,-162.341399667,776.774503667,682.385777833,943.7777225,-1256.818715,99.0696716833,1154.12253833,5.96337033667,-313.5566865,229.4945135,-47.3169140833,-212.030681167,-522.116814667,304.6906445,-113.318984667,-582.820941,-61.7455984333,694.063295667,-128.328978,-78.0383809,211.777310667,-192.723774833,13.6865926933,-59.0804379667,-166.789312667,41.2330716,-158.799018167,5.80097448,48.0629826,-61.1639358333,-17.1810591167,96.1172036667,-19.4309971333,21.8168752333,8.53625982833,-10.4693024233,86.6832606667,-135.824774833,34.6448077333,60.8752936,-59.4375848,-5.89894767667,-11.4377763667,-6.40213818333,8.25510455833,-0.0123508182333,13.71531905,8.18248784,-0.3917378325,25.7734022667,-46.39529245,28.6853573333,11.85035485,-15.4398397667,11.1814866833,-7.18676077,-1.58013671833,0.00536214888,-2.83250725333,-5.39862635667,-2.557740305,2.8130484,-0.347087999267,1.90852978833,1.59156869,-7.73397579,11.65143555,0.0151023660333,-1.6548621825,4.58776979167,-2.348578005,-2.32369762333,-1.522243015,-1.74081532,1.48122377833,-0.829996270833,-1.91040843167,-1.30533825,0.139540600833,-1.68771056167,1.61638361167,-1.39573554833,0.672331279333,2.07807219167,-0.854164083,1.52687549167,1.88079190167,-1.16422542833,0.0332300344833,-0.899189733667,-1.02210120667,0.275265176833,-0.824472958167,0.6661727345,-0.0396476918667,-0.223309519333,-0.2094206725,-0.177196948167,-0.713115458833,0.358283831333,-0.683797334167,0.811261212667,0.0353028348667,-0.4772427535,0.961175536333,0.589931021833,-0.1731108415,0.0778189777833,-0.2310035925,-0.00158466314,-0.100251668583,-0.478896288333,0.114948524167,-0.2522266215],[-40049.67265,1462.43395667,-2064.78207167,-4344.88804333,1834.56314333,1827.06874333,-132.728752167,617.531678667,634.946830167,971.450578167,-1245.66538833,110.704630833,1165.06609167,-48.695051495,-319.365116667,219.763894167,-39.0006729,-200.036986667,-506.602554,340.776227833,-119.399487,-564.750548333,-57.1700151833,707.493392,-131.5805595,-78.1925042667,211.333951667,-193.810544833,21.1991754,-62.1787531333,-158.156544167,36.1403406333,-147.530827,13.8789688733,51.01322915,-60.5092349833,-17.7728696833,95.7873880167,-21.7580631167,20.6642117833,6.31593792667,-7.37407597333,83.8892005167,-130.7790285,35.5585584333,64.3309432333,-60.3245821167,-7.24491111667,-10.47865455,-6.48124067333,8.18334995667,-0.362401635517,12.6432352333,7.00517717833,-0.419122611,24.4618575667,-44.9725291167,27.4343884333,13.3199800833,-16.1397585833,10.9685035,-7.85236465333,-1.46055027,0.177739902387,-2.68574678333,-5.49134145833,-2.481087015,2.46538306667,-0.6547879895,1.427318888,1.23323604583,-7.60542410667,10.9999202167,0.475795076883,-2.29250606667,4.59293565,-2.67407975167,-2.492897445,-1.43950582667,-1.61252999667,1.42726315167,-0.756338036667,-1.90143248167,-1.25710274167,0.10502345505,-1.70855039333,1.42674089667,-1.44972157333,0.553687929833,1.87906582667,-0.7745041715,1.2522074215,1.88441719833,-1.306601985,-0.0217218658,-0.917766192333,-1.014104525,0.317205160833,-0.853664466167,0.635566477667,-0.0336649973333,-0.2021254545,-0.185359423,-0.1574685965,-0.695310206167,0.326476128,-0.6775123865,0.745092979333,0.00615316731667,-0.494469221667,0.884104525833,0.579978865333,-0.233525291667,0.04367445655,-0.2451373345,-0.021091619685,-0.0934274195167,-0.493439484333,0.109477920667,-0.267206945667],[-40096.5776833,1319.74159,-1958.54581167,-4401.652705,1790.7701,1700.55272167,-112.745104,440.243704333,584.020584667,986.922264833,-1230.78459667,113.6001745,1158.40990333,-109.769547217,-319.783064833,209.917442167,-32.6684718167,-189.9647935,-493.560913833,370.123564167,-125.924805,-543.479331,-56.9579039167,717.110839,-134.049938833,-77.8164419833,209.8786765,-194.573468167,27.5725609167,-64.2556002,-149.499045,29.5754495,-137.126424667,21.24359165,53.3233131333,-59.5225103167,-17.93392305,95.3936256,-23.7234497,19.4952037833,4.43535300667,-4.64609506333,80.7904089,-125.6627365,36.1107543833,67.2524194333,-60.837833,-8.70377751333,-9.46286534,-6.44255843667,8.19518773167,-0.5958252135,11.6413557167,5.91425861333,-0.557054452,23.2023425833,-43.48350565,26.1080102333,14.54592625,-16.7039011667,10.6374743333,-8.549246715,-1.44424689667,0.3340235995,-2.53297347667,-5.550148275,-2.38720851833,2.14624648,-0.9365348455,0.944685291667,0.9268101695,-7.45940305167,10.3598286983,0.890977231667,-2.89483925667,4.55549265667,-3.01145313833,-2.69358229167,-1.35680155833,-1.493408055,1.35963389833,-0.689062767833,-1.88833558,-1.21209967833,0.0750116658333,-1.72217804,1.24799464333,-1.48564615,0.437182629667,1.69444178667,-0.6909378615,0.984501319833,1.87719691667,-1.45061372333,-0.0803456413667,-0.933227942667,-1.01256658833,0.360235264833,-0.882327704667,0.6017792595,-0.0300577647833,-0.1824946395,-0.163367997833,-0.138061129667,-0.676383542667,0.298969959667,-0.667945174333,0.679524388833,-0.0185418129,-0.505202559167,0.808745652833,0.569763336667,-0.292475273667,0.0106243584,-0.256314923833,-0.0438271360833,-0.08495543235,-0.508195784333,0.104152045333,-0.2814699105],[-40062.3087167,1156.20247333,-1771.54876167,-4449.03026667,1731.39140167,1590.012975,-92.8177169833,250.929277167,529.555723167,992.842263,-1213.778045,113.807011,1135.92629833,-174.603277,-314.2772955,199.326178333,-27.9974305167,-181.921626833,-481.516184833,392.471966833,-131.642940667,-519.327447333,-61.2644778833,722.969314833,-136.031781333,-77.0874871667,207.6516615,-194.831155833,32.7180131667,-64.9695247667,-140.827394833,21.6180097167,-127.711834,27.9472175333,55.1506650833,-58.2747990333,-17.7954563833,95.0096576,-25.33001955,18.3332185333,2.98913369333,-2.28595516633,77.4918304833,-120.536729,36.3440068667,69.6961523833,-60.9831561,-10.25933651,-8.39732221333,-6.32718090167,8.28689329833,-0.7358634195,10.7251599317,4.93696346,-0.803214599833,22.0449315333,-41.9463025,24.7526063333,15.5372738167,-17.1290559,10.207137615,-9.28113348667,-1.53141481333,0.4800780515,-2.38204168833,-5.58042290833,-2.289220935,1.85954180333,-1.19091616033,0.464270915267,0.6826323265,-7.300080045,9.748674345,1.258636514,-3.456051955,4.48138970667,-3.36010486667,-2.92321427167,-1.27733448167,-1.383528135,1.28220610333,-0.628059164167,-1.87252799,-1.174001925,0.0495209298167,-1.731570085,1.08154854433,-1.50351738,0.3236664465,1.52824846667,-0.604686845333,0.727327531167,1.860655585,-1.59595488333,-0.142087093,-0.9462290665,-1.01760861333,0.404315320333,-0.909542744333,0.565893826833,-0.02787605525,-0.164640655833,-0.144008327333,-0.119330767833,-0.657814689,0.275998243333,-0.655922515333,0.615398556667,-0.0383736614667,-0.509656872667,0.7363989935,0.559638062667,-0.349676198333,-0.02097281665,-0.2646581305,-0.0694842933167,-0.0749451591667,-0.522869716833,0.0992760992333,-0.295153004333],[-39956.0211167,1015.58922167,-1534.144765,-4489.09522167,1675.03224833,1487.948695,-61.2581692667,60.7334191667,471.192758,993.234272167,-1196.749145,118.4033435,1102.43145167,-240.2386185,-302.409060333,187.042621667,-24.7295361833,-175.946312833,-468.753285833,408.4641155,-135.317970833,-492.657032667,-70.0313014667,724.916541,-137.933986833,-76.3100696333,204.961918,-194.387854667,36.6619219833,-63.99477125,-132.129294333,12.4687189,-119.533577667,34.0882184167,56.7356658,-56.8534591833,-17.5325127667,94.7255728333,-26.5882122167,17.1728333333,2.07792268167,-0.274787463667,74.1399703167,-115.503174833,36.3257226833,71.76917885,-60.7595701833,-11.8926771167,-7.28456422333,-6.18329975833,8.45377992167,-0.808004535333,9.89169217833,4.106692815,-1.14836269817,21.0503263667,-40.3855378167,23.4222038667,16.32235215,-17.4098907667,9.699459155,-10.04958067,-1.72258225333,0.625122471833,-2.240543535,-5.58936837667,-2.20049669833,1.605668285,-1.41461680333,-0.0096091471,0.512490102333,-7.13035294667,9.18504423833,1.58102299,-3.96988110833,4.37908534167,-3.718102615,-3.17999350667,-1.20434154167,-1.28181970833,1.19966835833,-0.572693402333,-1.855982615,-1.14666838833,0.0289066583,-1.73959843167,0.9283458315,-1.50351784833,0.215154369167,1.38457759667,-0.51668265,0.484244221167,1.83740026833,-1.74165527667,-0.206985088833,-0.957523701167,-1.02845956333,0.449240040333,-0.9341263615,0.528994584167,-0.0259971871667,-0.148785628667,-0.1279986675,-0.101252381717,-0.641224584333,0.257612560167,-0.6423980015,0.553887414667,-0.0529168950333,-0.508173847,0.668355582167,0.550244642667,-0.404623526333,-0.05089210355,-0.270405616167,-0.0973884620667,-0.0635812298667,-0.536996564,0.0951933278,-0.308399174167],[-39795.8449167,913.010004,-1265.07159517,-4521.86591,1632.00056167,1391.069965,-14.1988889167,-119.195729333,410.339123833,990.701821167,-1180.90138333,131.318226833,1063.26715333,-304.685932667,-284.305831833,172.741949833,-22.531848,-171.966063167,-454.436277667,419.011732667,-136.364113167,-464.094692333,-83.18063975,722.594613833,-140.013307167,-75.6176822167,202.124412833,-193.1919245,39.5154315667,-61.2919853333,-123.428437833,2.28361198167,-112.931744,39.77896365,58.2904836667,-55.3312228333,-17.2433359667,94.6266933833,-27.4982826167,16.0232145167,1.71821662,1.41352209533,70.8376996833,-110.682742833,36.1182811333,73.5654749667,-60.1502654333,-13.59436085,-6.13573176167,-6.038067505,8.68865920667,-0.8211538035,9.13757652333,3.44393693167,-1.57754424333,20.2585260167,-38.8256635333,22.1641251833,16.9252328,-17.5358679833,9.13169059333,-10.85254075,-2.01788850667,0.773117437667,-2.11365195333,-5.58442912,-2.127418335,1.38427612833,-1.60267476833,-0.4709003109,0.421958717333,-6.95213822,8.68311855167,1.85923394167,-4.42988218667,4.25499045333,-4.08135545833,-3.46180740833,-1.140543185,-1.18645809667,1.11518182,-0.5232241955,-1.84060858,-1.13206809333,0.0134148686217,-1.74724820333,0.789561840833,-1.48666538,0.113975312683,1.26584070333,-0.428052983833,0.258088328033,1.809388875,-1.88608919333,-0.275101184333,-0.967543280667,-1.04396983333,0.494785977333,-0.954810871167,0.491953002,-0.0239115205833,-0.135155463667,-0.1158529045,-0.0837717109167,-0.627526035333,0.243851612833,-0.628106160333,0.496226098667,-0.0621209334333,-0.501082485167,0.605500339,0.542114683167,-0.456717428333,-0.0788992790333,-0.273722338,-0.1266857962,-0.0510662459167,-0.550068454,0.0922550628333,-0.321311503333],[-39604.49775,830.025761333,-981.037601667,-4544.18323,1602.10531833,1297.36479667,46.5012229333,-281.3475795,349.989021167,985.387273167,-1166.14646333,152.675932833,1022.79002217,-365.636863667,-260.988568667,156.8144825,-21.3166678,-169.422208667,-438.7739625,425.088329667,-134.492786333,-434.439861333,-100.261158883,715.214989667,-142.287761667,-75.00355235,199.523031667,-191.353185667,41.5086992,-57.0196793,-114.753946333,-8.62643249,-108.382408667,45.2291984,60.01815645,-53.7462064667,-16.9313807833,94.7940836,-28.0770610667,14.9293161,1.846854975,2.81906104,67.6809957833,-106.215324333,35.8386063,75.1724358667,-59.1025988333,-15.34411065,-4.96938825833,-5.88681723333,8.98139022333,-0.780740973167,8.46507582167,2.945893945,-2.066488145,19.6850279833,-37.2837892,21.0334527167,17.3702294333,-17.4823107,8.52465895,-11.68052165,-2.412825925,0.922241986333,-2.00053898333,-5.57398185,-2.07081857333,1.19559218667,-1.75327156,-0.910997137167,0.406596836333,-6.76246249333,8.25377504667,2.09500820333,-4.82644413833,4.117514345,-4.44323342167,-3.76383098833,-1.08692279833,-1.09428321833,1.0299001145,-0.480050219,-1.82873018333,-1.129338575,0.00322564727167,-1.75451487833,0.666594332,-1.45601942167,0.0234523857833,1.17230587167,-0.339702373833,0.0516257734667,1.77900762167,-2.02653824667,-0.345594118833,-0.975779561333,-1.06196248167,0.540489161667,-0.970100181167,0.455183014667,-0.0217250369833,-0.124059465333,-0.107346510667,-0.0668946702,-0.616903159667,0.234776700167,-0.61383851,0.443630157667,-0.0666692194333,-0.488615624,0.548323114833,0.535763597833,-0.505079477,-0.1045024502,-0.274450518167,-0.1561432875,-0.0376320327,-0.561373574667,0.0907453050333,-0.3338616845],[-39412.9381667,728.908334667,-696.115674333,-4549.51307833,1579.35475833,1205.68929167,112.594200233,-420.454228,294.904182667,976.133856667,-1152.10665667,179.731464333,984.568648667,-421.317846167,-233.0449355,140.1397045,-21.0427533833,-167.725637833,-422.589217167,427.6113665,-129.8029905,-404.259593,-120.872917517,701.749394167,-144.679340333,-74.3327871333,197.5158205,-189.022029,42.9151963667,-51.4939166333,-106.09582925,-20.000626035,-106.4083795,50.6127369833,62.1545300833,-52.1307302,-16.5336036667,95.2980989833,-28.3254156167,13.9460275333,2.35245535833,3.97673477333,64.72103725,-102.232557517,35.5826637833,76.6852112,-57.54812915,-17.1190844167,-3.80884415,-5.70666063833,9.32149880667,-0.683503275167,7.87458681333,2.60008335333,-2.59276793,19.3261652333,-35.7676862667,20.0735472333,17.68280975,-17.2205732167,7.89867793167,-12.5253808333,-2.90054173333,1.06809899833,-1.89828273667,-5.56569616,-2.02759975333,1.03871203783,-1.86426168833,-1.32127366483,0.4572864605,-6.55561985,7.90294743833,2.289727455,-5.15045591333,3.97526298333,-4.79852685167,-4.07959569667,-1.04351755667,-1.001298504,0.943959972,-0.444140072167,-1.82255130667,-1.13619141333,-0.00164496597167,-1.76017167333,0.560790324,-1.415041725,-0.0530644752833,1.10285045333,-0.252721441667,-0.133460358967,1.74866667833,-2.16066767333,-0.4171759185,-0.981291988667,-1.07967486,0.585556288333,-0.978420679167,0.418804437,-0.0199343535667,-0.1158124135,-0.10196242075,-0.0505830469167,-0.609006718667,0.230409479167,-0.600180085167,0.397079242833,-0.0675480359667,-0.470976804167,0.496762152833,0.531653428,-0.548944829167,-0.127099689667,-0.272385609,-0.184371000833,-0.0236258109567,-0.570115996,0.09092092575,-0.345878522167],[-39248.8431,567.6497315,-420.661907167,-4525.78387333,1557.25610833,1116.78859667,170.479091,-533.093882833,251.7012015,961.817026667,-1138.06655167,208.069174333,951.953689833,-471.030566667,-199.548530667,123.892039,-21.50609355,-166.357802667,-406.917815667,427.6473595,-122.804297167,-373.488245,-144.653129667,681.317449333,-147.107379,-73.3567879333,196.396607167,-186.318768,44.0842371667,-45.1383885333,-97.2940883333,-31.6522751167,-107.417467,56.06805765,64.9715115667,-50.52950215,-15.9441065667,96.1906744333,-28.22251285,13.13397375,3.09950057,4.93888760333,61.9576998333,-98.8139277333,35.41511445,78.2205325833,-55.4263678333,-18.89667395,-2.68099986167,-5.465184955,9.69749181667,-0.518816417333,7.35981784,2.39049483667,-3.13400552,19.1606632667,-34.26846755,19.3111734667,17.8980444667,-16.7282848333,7.27455300333,-13.38481405,-3.46822953,1.20562579667,-1.80348352333,-5.56617550167,-1.991863675,0.909865890167,-1.93266841333,-1.69405762167,0.561610564167,-6.3228715,7.630296265,2.44728148833,-5.39625632333,3.83814759,-5.14563510833,-4.39963707333,-1.00902487417,-0.902454916833,0.857124887333,-0.416947471667,-1.82394866833,-1.14937266167,-0.00166046708167,-1.7620448,0.472820188333,-1.36720669667,-0.112403865783,1.05475368667,-0.1678360238,-0.297278824,1.72138159667,-2.28743791333,-0.487884483667,-0.982742633,-1.09370260667,0.628885365333,-0.978445053833,0.382736846167,-0.0192451419833,-0.1106876145,-0.0989981014333,-0.0347493487333,-0.603074281167,0.230509456333,-0.587469580833,0.357210777167,-0.0660159920333,-0.448336875833,0.450041563,0.530372926167,-0.587963589,-0.145969471333,-0.267421027333,-0.209818264167,-0.00953156377667,-0.5755655555,0.0929383641167,-0.357069053667],[-39133.5810667,335.484720117,-183.730134278,-4460.37512333,1535.05436833,1028.72646,206.802481333,-627.9118525,226.700722167,941.570117,-1123.68001833,234.3798415,924.829731,-515.513328833,-158.869825,109.039806483,-22.6253715,-165.013978167,-392.312482167,425.697031833,-114.164441333,-342.071616167,-170.770135667,653.502441833,-149.557101333,-71.8605692667,196.362753333,-183.2759745,45.317028,-38.2777380833,-88.2883364667,-43.2982367667,-111.676915833,61.8705965667,68.5923804167,-48.9975467167,-15.06453735,97.5059628167,-27.7529252,12.5483808167,3.99869563333,5.71740728,59.3820093667,-96.0310464833,35.4442628167,79.8470785333,-52.7179741167,-20.6820875333,-1.61086325967,-5.13321653667,10.1014333033,-0.282600179333,6.91133101333,2.307928775,-3.676400035,19.1607781833,-32.7864098667,18.7766621333,18.0443950833,-15.9958031,6.66169817333,-14.2632626,-4.08878422333,1.331631395,-1.71398624333,-5.57918118,-1.95886679667,0.804640501833,-1.95656525833,-2.02330021667,0.70727149,-6.05961178833,7.43345152833,2.570854745,-5.55914945833,3.71401117,-5.48617920667,-4.709695225,-0.9780033515,-0.791349667333,0.7696195245,-0.400125354167,-1.83424525167,-1.16565035167,0.0028777375,-1.758577695,0.402799927833,-1.31525990667,-0.152438431333,1.024625685,-0.08634144241,-0.439712482167,1.69998215667,-2.40653124667,-0.5555216365,-0.977306152167,-1.09995105833,0.6693578895,-0.969940222,0.346876415167,-0.0203085012167,-0.108978797667,-0.0977894619167,-0.0191723835583,-0.598414520833,0.234706911333,-0.575825509667,0.324449386667,-0.0633360722,-0.421170252,0.407362241833,0.532405653,-0.6218596675,-0.160699779667,-0.259293708667,-0.230841491,0.00420219696,-0.577392836833,0.0965884106833,-0.367082776167],[-39075.3906833,72.3186814667,-6.79832228,-4351.04129833,1523.08593833,940.972696667,217.811814333,-718.856535333,221.238586833,916.284632,-1109.86222,258.973827167,900.595703167,-554.061409833,-110.170598033,95.4338713667,-24.6805170667,-163.959731667,-378.5597535,421.867313,-103.5717626,-310.1024855,-197.911634667,618.437734333,-152.1557725,-69.9481530167,197.458851333,-179.812980333,46.8183403833,-30.89667145,-79.1374406167,-54.4767167833,-119.273899,68.281942,73.06204645,-47.5635402333,-13.8978694833,99.2509972667,-26.9128995167,12.2318662333,5.03460285,6.29732192,57.0493447167,-93.9221113167,35.7817838667,81.5994745167,-49.3995979333,-22.4825624667,-0.603733963667,-4.70650341333,10.5325676333,0.0119983371667,6.52206718833,2.3441622,-4.21685800667,19.3116288833,-31.3308990167,18.49733005,18.1419066167,-15.0115852833,6.06501015667,-15.1636315,-4.73336209333,1.44801742667,-1.630246295,-5.60342300333,-1.93077262,0.7185223385,-1.93927685833,-2.30644077,0.885988836333,-5.76714694,7.31215567833,2.661448695,-5.630913675,3.60683297667,-5.82074443333,-4.99479041,-0.9457396415,-0.660808567667,0.682727009667,-0.394375560333,-1.85371477167,-1.18388751833,0.01177332925,-1.75013052667,0.350508847,-1.26104911,-0.173085001833,1.01025359,-0.0104980678233,-0.559621260167,1.68587355333,-2.51713864333,-0.617591976833,-0.962489065667,-1.09392774333,0.706178170667,-0.953086977333,0.311207193167,-0.0233005268167,-0.110936782167,-0.0981112429167,-0.00354407836667,-0.594772481833,0.242656262833,-0.565390191,0.298693966,-0.0602076435167,-0.390321822,0.368316245667,0.537684326333,-0.6500637455,-0.171028654167,-0.2478892045,-0.245923229833,0.01727699625,-0.575521852167,0.10150648865,-0.375567974],[-39079.14535,-205.36966205,135.304755388,-4205.394975,1522.57847833,862.0192245,207.300849,-815.4762725,233.594420667,886.039470333,-1097.75719667,282.010163667,877.628607,-588.659537667,-53.6273660117,82.9342940167,-28.03241735,-163.8576055,-366.551447667,416.542095167,-91.4412405667,-277.428776,-224.817227,577.585643333,-154.805255167,-67.76469945,199.6041495,-176.198133,48.75485145,-23.1521035,-69.7535694,-64.8661880167,-129.834143167,75.35118935,78.3323238,-46.1745129333,-12.4364439167,101.398270033,-25.7317244167,12.2130999167,6.135222905,6.71101324667,54.9396614167,-92.4409039667,36.4297231,83.47977165,-45.4676049333,-24.2560797333,0.344121208667,-4.16979890333,10.9910628167,0.364740735667,6.187671865,2.46531315333,-4.757611175,19.5616891167,-29.9184922667,18.4511456833,18.2077066833,-13.7847377833,5.50214407667,-16.0872557167,-5.38822335167,1.552590935,-1.54715860167,-5.634097445,-1.90279461,0.646969336833,-1.89121152833,-2.547397515,1.0799669215,-5.45384276167,7.25296263667,2.72040979,-5.61145048,3.51821219333,-6.15117380167,-5.24541237833,-0.913993707333,-0.501933185333,0.595956771333,-0.3991602985,-1.88161116333,-1.20147671333,0.0246216600333,-1.73711633333,0.314499747333,-1.20780003,-0.176472110667,1.00651219667,0.0567575865567,-0.659041599167,1.67794849333,-2.62008763667,-0.672527316833,-0.938698171167,-1.07089160167,0.739830299833,-0.9285000705,0.275346676667,-0.0286729219333,-0.116700001833,-0.0996010537667,0.0123576365083,-0.591167372167,0.2540699015,-0.556200688333,0.2793336445,-0.0575806925667,-0.357227318333,0.331719092,0.545042486,-0.672787674333,-0.177020690333,-0.233935610333,-0.254018599833,0.0298400197833,-0.570277742833,0.107041878167,-0.382405492667],[-39123.5005,-487.090300333,258.864872167,-4036.48372333,1536.248635,800.463973167,189.278868333,-913.775023667,258.786962,852.837675667,-1087.14001333,306.812330833,858.340268333,-620.7353915,8.26768503667,70.9165952167,-32.6593840833,-164.924493167,-356.883729333,410.539148667,-77.9763469833,-244.189549667,-250.517737833,533.350972333,-157.327663167,-65.5921394833,202.714193333,-172.809552667,51.21904995,-15.137247845,-59.8558920333,-74.2013694833,-142.612355,83.2928773,84.256,-44.7346604333,-10.7658766417,103.876640833,-24.2870407,12.4937659667,7.23625629667,7.08895145167,53.03331595,-91.4731641,37.4357132333,85.4594781,-40.9747093667,-25.9375294833,1.24118923833,-3.52452022667,11.4659167667,0.767023998333,5.90408016833,2.63272604667,-5.28562984333,19.86156715,-28.5641243167,18.6141452333,18.2632364,-12.3474498667,4.999662075,-17.0181250167,-6.037270545,1.64293273,-1.45610826167,-5.66562815667,-1.87050818667,0.586428419333,-1.82590797167,-2.75338036667,1.27099436333,-5.12949775167,7.23723118167,2.75435724333,-5.50443952833,3.451234495,-6.47290091667,-5.45087536167,-0.8888434725,-0.308334296733,0.508967858,-0.411396267333,-1.91620552167,-1.215694945,0.04074434625,-1.72073597833,0.291232972,-1.15935153333,-0.164637921,1.00676568,0.11390597265,-0.739878916833,1.67479957,-2.71532045833,-0.718686782,-0.9080991465,-1.02704042083,0.771421918333,-0.895621840667,0.238983865,-0.03640007305,-0.126231418167,-0.101839200917,0.0285486163667,-0.5866343825,0.2683725725,-0.548495351167,0.2658602245,-0.0564937385833,-0.323306757,0.296517384333,0.553084720333,-0.69049432,-0.178783674333,-0.218503380167,-0.254294918667,0.0423360605833,-0.561513988,0.1124903025,-0.387825598833],[-39194.7905667,-783.4170155,332.409245667,-3862.07537333,1565.03182167,755.114649167,182.930294333,-1005.7487745,291.420019,820.186268667,-1078.26795833,338.9183945,845.363981833,-650.121130833,69.553780455,59.0567613833,-38.0847253833,-167.058343667,-349.817776333,404.124509667,-62.7035544,-211.525132167,-274.0410805,488.581922,-159.414958333,-63.7546473833,206.812562167,-170.040108167,54.1095425833,-6.77801381333,-49.2322610667,-82.0918023,-156.778311333,92.5841633167,90.6279813667,-43.1389526,-9.02091447333,106.623835833,-22.6694384167,13.0681642833,8.30556697,7.58854312667,51.3928962833,-90.9124502833,38.9404955167,87.50844195,-36.0162715,-27.44842765,2.08602908167,-2.77914995,11.9440437167,1.20625979567,5.68013132667,2.81200091167,-5.782922745,20.1896852833,-27.2915746333,18.98478515,18.3427341667,-10.743959685,4.59409380667,-17.9233041167,-6.655722965,1.71346535,-1.34613720833,-5.69221609167,-1.83101606167,0.537666329333,-1.757986185,-2.93269780667,1.44541357833,-4.805225435,7.249619495,2.77635425167,-5.31261851333,3.41236611167,-6.77424407667,-5.59592463833,-0.8793370565,-0.0756756532667,0.421543329333,-0.426918192,-1.95562427333,-1.22419123333,0.0598495309,-1.703079875,0.276805515333,-1.11985799167,-0.138913949667,1.00484754017,0.160859184667,-0.802483349667,1.676083065,-2.8015062,-0.753118350833,-0.873870818333,-0.958945757,0.80217933,-0.852545749333,0.2020681245,-0.0463960664833,-0.1396115505,-0.1044298245,0.0448855892167,-0.5804744075,0.285109696667,-0.542934157167,0.258060917333,-0.0578128738833,-0.289968369833,0.2621163005,0.560774139833,-0.703654151,-0.176022235,-0.2028529055,-0.2456383335,0.0551707515667,-0.548521433167,0.1171670035,-0.392331734667],[-39283.91655,-1093.4796195,320.186158667,-3704.82426167,1606.67282,720.0384235,211.6331025,-1083.30584,325.1939415,789.596329667,-1072.66009167,384.5384925,840.639352167,-676.366837333,125.144420583,47.3632949,-44.3247549167,-170.462517833,-345.577524,396.590888333,-44.6495024833,-180.488872167,-294.5036175,446.456398167,-160.569216333,-62.5886117167,211.884575167,-168.348923667,57.0093322667,2.09270082167,-37.80898535,-88.14352685,-171.4788135,103.659538867,97.2658431,-41.2445774,-7.2815473,109.608141833,-20.9925825833,13.9031411167,9.33819204833,8.28926599,50.1112120833,-90.645281,41.0572960333,89.610647,-30.7122406833,-28.7143813167,2.87566739833,-1.91943592783,12.4268943,1.67212541,5.53662483833,2.97742482,-6.25176322167,20.5428261167,-26.1346777833,19.5713269667,18.4819299667,-9.02532193167,4.32680069833,-18.7726044833,-7.222050005,1.75389321333,-1.20368382667,-5.706058425,-1.778835555,0.508951062667,-1.70274579667,-3.09481645,1.59547195167,-4.49789542333,7.28114074333,2.79967812833,-5.03985602333,3.40926631,-7.04404972,-5.667229665,-0.894449157167,0.1988043336,0.331736762667,-0.442557287333,-1.99825787167,-1.22398481667,0.0837820675667,-1.6869669,0.268840760167,-1.09249575,-0.1012804192,0.996837423,0.197515125,-0.846249346333,1.68248692333,-2.87766841333,-0.772768478833,-0.839366501667,-0.863929261167,0.8334060585,-0.797589324833,0.164417620167,-0.0591388786,-0.157213121,-0.1069137675,0.0612667367667,-0.572087119333,0.30453368,-0.540297378833,0.255896514833,-0.0618065208167,-0.258671888,0.228479343667,0.567536647333,-0.712723005,-0.1682064205,-0.188214420667,-0.227048649333,0.0688246323,-0.530657512833,0.120480426333,-0.396416342167],[-39365.79075,-1401.21616167,217.144448433,-3583.45074833,1660.22667167,693.457102,291.846959333,-1136.11995167,353.919711333,761.9018075,-1071.03894667,446.918686833,847.127495333,-700.915782667,171.972870167,35.8474211,-51.5294011,-175.470246833,-344.564782667,387.364290833,-23.6280459583,-151.6373625,-311.687992333,409.765014333,-160.344423333,-62.3595244333,217.7568455,-168.107702,59.4806807667,11.42784245,-25.5911716833,-92.2640441,-186.005779667,116.717014167,103.952958883,-38.9315509667,-5.58909170333,112.783528833,-19.3412341333,14.9460062833,10.315183805,9.21325214167,49.2131212,-90.5801521167,43.7997931333,91.7249574167,-25.2027360167,-29.7146028,3.608954095,-0.927686022167,12.9212923667,2.165864835,5.48869576167,3.11641443667,-6.70294287167,20.9162664167,-25.1293199333,20.3651931333,18.6952536833,-7.24724182667,4.21471696333,-19.5458622667,-7.72435945833,1.75494496167,-1.018365275,-5.69940336833,-1.70655359167,0.508882755833,-1.66952583833,-3.247593085,1.71818199,-4.22458939167,7.324101365,2.83186068833,-4.69432842,3.44248787,-7.27464899667,-5.659545565,-0.940041115333,0.5147792755,0.237302768667,-0.4564573955,-2.04243241,-1.21270008667,0.114889168933,-1.67397501833,0.266269432833,-1.07844044167,-0.0535636597883,0.980675857833,0.223613123167,-0.870990615667,1.69377166167,-2.94345378833,-0.7764297055,-0.807295804,-0.7414404395,0.866480541,-0.7302376155,0.125892652983,-0.07521851205,-0.179233674167,-0.109090398167,0.07763243285,-0.560911479667,0.327170065833,-0.540987643833,0.259486101167,-0.0681762212667,-0.230507969667,0.195860023,0.573011050333,-0.718104624833,-0.155219003333,-0.175465556333,-0.1983259885,0.0838983608333,-0.507755047833,0.122064723833,-0.400505597833],[-39428.7508167,-1745.84644167,44.2636442333,-3489.42215667,1713.56352333,675.655812167,400.1282635,-1176.136865,379.716293333,737.243061167,-1072.841495,518.216336167,861.449674167,-729.260062333,206.6793395,25.0973877667,-58.5889358167,-182.066567,-347.4160035,376.3537375,-1.8488641,-126.367056667,-326.304699667,378.1594065,-158.832986333,-62.6581314833,224.2497525,-169.073540167,61.6159479333,20.7805200833,-13.0167037343,-94.8746134,-200.5740145,131.5571065,110.2842725,-36.2877687,-3.89727002167,116.116592167,-17.6093734,16.2303122333,11.21725805,10.3336571267,48.6012859,-90.7995268833,47.06938685,93.6930619333,-19.5686541167,-30.5936021,4.27166243833,0.172120678833,13.4281235667,2.715212845,5.54915818167,3.24774117833,-7.11672263667,21.2980877833,-24.2899399667,21.3282482,18.9246961833,-5.43086782833,4.19045508833,-20.2443046,-8.166791255,1.71618842333,-0.8018543015,-5.67342717,-1.61356834,0.5390229535,-1.64955023333,-3.38391749667,1.81636358667,-3.983180125,7.37309610667,2.86280592167,-4.285157865,3.49121854167,-7.46298510333,-5.58486082833,-1.010129419,0.868757385833,0.138889729583,-0.470694799167,-2.08757499333,-1.19303953167,0.152377165167,-1.66262554167,0.270509446667,-1.07553433,0.00549882989667,0.956741806167,0.2397859255,-0.878162734,1.70574157,-2.99742380833,-0.767648983,-0.776543381,-0.594662254833,0.902520021,-0.652820869167,0.0871325546333,-0.0945222184,-0.205134804167,-0.111711296333,0.0935660673833,-0.547289666833,0.352832637667,-0.5444646865,0.269091333667,-0.0764942737667,-0.204792794333,0.164387302167,0.577005599167,-0.719449793333,-0.138351623833,-0.164004994833,-0.160773925833,0.10078014255,-0.480802003833,0.122059994667,-0.4048154755],[-39462.6588167,-2145.87386667,-171.9727044,-3412.19463167,1758.43883833,666.6992075,512.343887,-1218.536325,404.881559167,715.228847167,-1077.54276167,590.671397167,879.097279667,-765.753070667,227.0008865,15.555407225,-64.6935878,-190.28628,-354.402679167,363.515589333,18.712248275,-105.83734655,-338.904405833,350.8620975,-156.210051167,-63.0971362333,231.135675667,-170.897567833,63.56153295,29.7959694167,-0.549885370667,-96.34473995,-215.432278667,147.91668,115.904691167,-33.4146571333,-2.1604133455,119.5672065,-15.6927046167,17.7824177,12.0419426167,11.6055767833,48.1940591833,-91.3696942667,50.7603729333,95.3743737833,-13.8710116033,-31.5094997,4.85505816833,1.35227387583,13.9480899667,3.34043436,5.72475909833,3.39137494167,-7.47379228,21.6815938667,-23.6155656833,22.42174375,19.1107404,-3.58630503,4.17930399333,-20.8733850333,-8.55212061333,1.639770855,-0.5671463755,-5.62991431333,-1.50191209833,0.599375190667,-1.63272929167,-3.49564802,1.89434005833,-3.767232625,7.42468551667,2.88160293333,-3.82038791667,3.53420650667,-7.606951605,-5.45583988167,-1.09631978667,1.2570274545,0.0373548526,-0.4873363445,-2.13300124167,-1.16818577667,0.195132399667,-1.65122010833,0.28305631,-1.08114818333,0.076988758545,0.926235894333,0.247090228667,-0.869226445667,1.71437085333,-3.03774559333,-0.749783559333,-0.74536307,-0.4271303735,0.942257438,-0.568219874167,0.0487413786833,-0.11673068885,-0.2342049275,-0.115445081833,0.108711075567,-0.531737286333,0.3811581675,-0.550073191333,0.284686944167,-0.08630530125,-0.1805704295,0.13422883,0.579495538333,-0.716176854667,-0.118818178567,-0.153022556167,-0.1157963505,0.119648955667,-0.450951017167,0.120676910167,-0.409463814],[-39461.8076667,-2582.237065,-410.366553833,-3351.51877333,1794.00376333,665.1712585,615.298799167,-1270.88289,428.48145,694.905945333,-1085.04037667,660.2144775,896.994110333,-811.637506833,232.920487333,7.33216339933,-69.8892988,-200.417258667,-365.126131333,348.628705667,37.1559314833,-90.43622265,-349.626410333,327.412796,-152.527147167,-63.5783486,238.064576167,-173.265519333,65.2792323667,38.3327994667,11.4567179823,-96.8748679667,-230.582623167,165.437797,120.5831415,-30.3515538167,-0.373936472,123.067734,-13.5572740833,19.5708153833,12.8002771167,12.9646830667,47.9467017833,-92.266503,54.7446455167,96.6934541167,-8.17359173833,-32.5594439667,5.36282338,2.59387629333,14.4853680333,4.03905666,6.01332259167,3.55971013833,-7.76993689833,22.0658523833,-23.0884059167,23.60732095,19.2184246333,-1.72634946267,4.13126356333,-21.4335573667,-8.88031555,1.52844437167,-0.320457517483,-5.56652205167,-1.375527695,0.690657653167,-1.61224069,-3.57929894,1.95749707167,-3.57155908167,7.47734481833,2.88281304333,-3.30858156833,3.55663179833,-7.70392051833,-5.28227587833,-1.192496645,1.675020395,-0.0670610045167,-0.506659311333,-2.177042485,-1.140120145,0.242888349333,-1.63866841667,0.304470240833,-1.09243831167,0.16003624155,0.891118754,0.246802604,-0.845644904667,1.71666398333,-3.06296518,-0.724871510333,-0.713179845833,-0.242256174267,0.9856322375,-0.4789296195,0.0109950733833,-0.141418984667,-0.265760674667,-0.120435750333,0.122982554333,-0.514766302667,0.411768883,-0.5571616215,0.3056086675,-0.0969937213,-0.157216110833,0.105602514267,0.580504562,-0.707925859167,-0.0973456195,-0.142128524833,-0.0645674065767,0.140323472667,-0.419144606,0.118107860833,-0.414428273833],[-39424.4767333,-3017.001145,-646.129458,-3315.31148,1823.404505,670.8829445,703.071218333,-1331.67669167,447.076964,674.914741167,-1094.90247,724.976237667,914.132278833,-867.1084225,225.856308,0.298181844,-74.8456919333,-212.849010833,-378.863989833,331.466919667,52.9340752833,-80.0384227167,-358.229317,307.570410667,-147.741179333,-64.2432840167,244.566271333,-175.9197775,66.57594085,46.3196039667,22.7395531,-96.5489273,-245.845297,183.601158,124.109081,-27.0939957,1.4242013545,126.511272333,-11.2221475233,21.5079806667,13.5073633,14.3413475333,47.8220586,-93.3999064667,58.8428474667,97.59627605,-2.541447615,-33.7859713,5.80735519833,3.88342582667,15.0431008333,4.79304842167,6.40267818667,3.76170788667,-8.009234435,22.4461512667,-22.6784562667,24.8386413167,19.2264059667,0.133943971,4.01414229167,-21.91676475,-9.15466799167,1.38597849833,-0.0620317192667,-5.47744027,-1.23936703833,0.813650039833,-1.58281537,-3.63480453,2.01057127,-3.39178992833,7.52971134167,2.864939705,-2.75891492333,3.54652283667,-7.74911592667,-5.074022355,-1.29513949333,2.11733674333,-0.1742524704,-0.527161714167,-2.21690396167,-1.10989913167,0.296016198833,-1.62418260833,0.334279292,-1.10632116333,0.252366919167,0.853860851333,0.240448647833,-0.809036779833,1.70955674833,-3.071598205,-0.694516924667,-0.6805963725,-0.0435363920667,1.03231899367,-0.3872509585,-0.02603622745,-0.168008225167,-0.299040840833,-0.1264485905,0.136540391333,-0.496885977167,0.444142421,-0.564958294667,0.330698965167,-0.107790890417,-0.134356948667,0.0786841629333,0.57994373,-0.694532644667,-0.0743786554167,-0.131276137667,-0.00821135075667,0.1625458045,-0.386222838833,0.114488322667,-0.419532227167],[-39347.6085,-3397.46493333,-858.121776167,-3307.439625,1851.996,683.047583333,770.359613667,-1392.593995,458.445362667,653.135680667,-1105.92457667,782.787767167,931.229219167,-933.0090575,206.978977,-5.507199544,-80.6466295833,-227.583255667,-395.073733833,311.938771667,65.2398880167,-74.5666288833,-364.089016667,291.2145285,-141.824717333,-65.2892550667,250.223639167,-178.672554667,67.18575105,53.6505173667,33.0187688833,-95.3035051167,-260.934966333,201.810020833,126.353095333,-23.6554801667,3.21609147333,129.778742333,-8.726454755,23.4721080667,14.1800920167,15.6650076667,47.7972564833,-94.65240305,62.8462872333,98.0624282667,2.96202869167,-35.2211392833,6.196764595,5.220404355,15.6185267833,5.58413059167,6.87624102167,4.00569877,-8.19225696667,22.8103941333,-22.35351225,26.0585047167,19.1239092,1.97879082733,3.79685323333,-22.31411195,-9.3739832,1.21631694,0.211098411017,-5.35782003667,-1.0957283465,0.971077911333,-1.5400198,-3.66089793167,2.0544776,-3.224758525,7.57753865667,2.82738722833,-2.18070318667,3.492353325,-7.73846176833,-4.83790460667,-1.401999195,2.57831021667,-0.283956469167,-0.547275463,-2.249814375,-1.07750969167,0.355939107667,-1.60710844667,0.3719838245,-1.12068019333,0.350988661,0.8166764925,0.228751837833,-0.761142618333,1.69005911667,-3.06231999167,-0.659338227667,-0.649108695667,0.165603333067,1.08194721167,-0.2956465145,-0.0623400304833,-0.196192821667,-0.333205782333,-0.133103583667,0.149725091333,-0.478542884333,0.477699277167,-0.572775316,0.358606715167,-0.117845455833,-0.1120358135,0.0535624667,0.577653430167,-0.675889172667,-0.0501514196167,-0.120850348,0.05209127329,0.186114786167,-0.3530924495,0.109851602,-0.424503814333],[-39223.4750333,-3708.40733833,-1034.43379033,-3318.31661,1876.867425,696.597486333,808.2625955,-1450.79631167,465.033068667,626.666267333,-1116.19870167,829.409393667,947.1636005,-1009.62617967,176.577671833,-9.18949488167,-87.9094955,-243.764814,-413.678630833,290.000615,73.2822086333,-74.2711587833,-366.041348667,277.785050667,-134.775171667,-66.5813394,254.888082,-181.410807333,67.0574055333,60.22265375,41.87334665,-92.8103762667,-275.680074167,219.5895165,127.330016167,-20.1271467167,5.087308415,132.7997345,-6.11999586667,25.421523,14.8231164667,16.8464288333,47.8977167167,-95.9543114,66.6344637167,98.1252536667,8.30441239167,-36.8538316167,6.51467427833,6.61657157167,16.2098865167,6.40202058167,7.436023055,4.28547951667,-8.30562131333,23.1443170333,-22.0960079833,27.2322522167,18.9152795167,3.80656724167,3.46643401,-22.6204876,-9.528936015,1.020354571,0.497942193833,-5.2080612,-0.9403719505,1.16881649317,-1.48505704333,-3.64876669,2.08547295667,-3.06888227667,7.61858132,2.770314895,-1.578026002,3.39155215,-7.67174548833,-4.575742755,-1.51005957833,3.05345908333,-0.395866204667,-0.567959963833,-2.27555368,-1.04124504167,0.424029874,-1.58756058667,0.418786426167,-1.13568836667,0.453385714833,0.781124135333,0.2110872375,-0.7025149945,1.65782634333,-3.03434391667,-0.6182813755,-0.620254268333,0.383092623833,1.13372092,-0.206724533833,-0.09779753185,-0.2263409955,-0.367811964833,-0.140028123333,0.162530646333,-0.4599688895,0.512077241667,-0.580617390333,0.388305973167,-0.126808166,-0.0908881921167,0.03039553543,0.573670357833,-0.651803701167,-0.0245083668983,-0.111497989333,0.11551190405,0.210757241333,-0.320620449,0.104129542883,-0.429020091333],[-39049.4544833,-3927.01551333,-1177.77177167,-3339.750345,1897.45650167,702.1878925,816.665796667,-1498.66024167,468.963562833,592.51309,-1124.26814667,863.6067415,962.219051667,-1097.12160667,137.314765967,-9.92271774333,-97.5370209,-260.449224667,-434.025747,265.801711167,76.2001721333,-78.3943432667,-363.299791,266.529095,-126.600948333,-68.0949465333,258.4335275,-184.0239875,66.1031400167,65.9072994833,49.1265064833,-88.8842854833,-289.957186833,236.590444833,127.088338,-16.6014651,7.10101973,135.4976545,-3.497136525,27.2805819167,15.4417071,17.82058625,48.1102157,-97.2472290667,70.1471876167,97.8298396167,13.43547118,-38.6427628167,6.7462801,8.08371077667,16.8122130833,7.22196573,8.07271780333,4.59726972,-8.34310156167,23.42790195,-21.8889265333,28.3395386167,18.60958645,5.60685784667,3.02612428,-22.8333755667,-9.61020447,0.800509502667,0.799450801667,-5.02906069,-0.770230026167,1.41105347167,-1.41813652,-3.594267315,2.100432705,-2.92175205,7.65187471667,2.69465883833,-0.957223414167,3.24824645667,-7.55155490167,-4.29023612667,-1.61449312,3.53671874667,-0.509215335667,-0.589381996,-2.29384934167,-0.998727006167,0.501875708167,-1.565417475,0.4744880585,-1.15090345167,0.557279465,0.748476350833,0.186686920833,-0.634091905333,1.61432749,-2.988014115,-0.571113865333,-0.5944859355,0.606292396,1.18649194167,-0.122509985,-0.1322973715,-0.2586643565,-0.402311633,-0.1465678945,0.175163519833,-0.441392858333,0.546743752333,-0.588288921167,0.418724163667,-0.134468253167,-0.0716692093,0.00930605542,0.568245248667,-0.622426869833,0.00239849102333,-0.1034695104,0.181022267167,0.2360900835,-0.289292499333,0.0972216048167,-0.432800243333],[-38837.5206167,-4040.83056,-1294.19171,-3365.53785167,1911.86271,694.002278,798.201880167,-1527.699175,472.936926833,547.950042667,-1128.41613833,885.725716833,976.713614667,-1195.552285,92.6612664833,-6.70765639617,-110.3040421,-277.007145667,-455.267733667,239.407468167,73.11518865,-85.9122460333,-355.617950667,256.5503125,-117.300062333,-69.7939813,260.6437545,-186.447042667,64.22543895,70.5074862,54.718777,-83.5830847667,-303.726877333,252.572434833,125.7027335,-13.1699533,9.31837165833,137.790039167,-0.964176141667,28.9813127167,16.0159297167,18.5476961833,48.37384495,-98.4888092667,73.3513867833,97.2382278167,18.2833479333,-40.5471157833,6.87725685833,9.634248615,17.42303425,8.020492555,8.777780675,4.93563374833,-8.30164396667,23.64029665,-21.7140244833,29.3634453,18.2185034667,7.36258783667,2.481805395,-22.9479279333,-9.60912913,0.559131917333,1.117129242,-4.82039572,-0.581178725667,1.70067810667,-1.337801735,-3.49634678667,2.09818318833,-2.779678415,7.67544300833,2.60034534333,-0.326417053833,3.06695052,-7.37943327167,-3.98572525667,-1.70998338333,4.02082023833,-0.623338631833,-0.611612342667,-2.30409781333,-0.947219405333,0.590540142,-1.539757235,0.538213003667,-1.16524613667,0.660778552,0.719304730667,0.154391295667,-0.557398663,1.56099314333,-2.92372211167,-0.518562121333,-0.571830732833,0.832038848167,1.23867941667,-0.0444040891,-0.165794900167,-0.293377442333,-0.436145845667,-0.151992206167,0.187797711833,-0.4228309015,0.581169039333,-0.5954334605,0.448826602833,-0.140739832167,-0.0551302850667,-0.00975530887,0.561602288833,-0.5879959845,0.030150134685,-0.09680669735,0.2475810335,0.261462112167,-0.259302699333,0.0891690267333,-0.435617608833],[-38621.71265,-4059.35230333,-1389.71647,-3395.09426,1919.08557333,671.417454,756.5338325,-1527.580915,480.128387,492.076808,-1125.93433833,896.066487167,990.198678333,-1304.138825,45.1356732883,1.97841481533,-126.635608833,-293.061038167,-476.7523655,210.5265625,63.3298450667,-95.8085172667,-343.401121833,247.127176333,-106.774456433,-71.6718522333,261.147977833,-188.663728833,61.33440555,73.7983592667,58.6984702833,-77.1948894,-316.961079667,267.440771167,123.215799667,-9.93506249833,11.78038465,139.572992,1.38205695333,30.4962199167,16.4968903667,19.0130884667,48.59251785,-99.66332185,76.2490385,96.4178789333,22.7435592167,-42.5219039167,6.88523274333,11.2814079733,18.0464062167,8.782175005,9.55234376,5.28696295833,-8.18262890667,23.7638668833,-21.557625,30.2853206833,17.7596865167,9.05127415,1.838214045,-22.9512321,-9.51441654167,0.297725457283,1.454316385,-4.57837517333,-0.367428178,2.03916030333,-1.24258716,-3.3572704,2.08022036667,-2.63727201,7.684094635,2.48787654167,0.307360649667,2.85093950333,-7.1555912,-3.66640818333,-1.79191699,4.49603529,-0.737349528833,-0.634524422667,-2.30537569333,-0.884039962,0.6897454175,-1.50877184833,0.608718029833,-1.177192535,0.7628735135,0.6933973895,0.11264899285,-0.473534576,1.498769885,-2.842194495,-0.461674723,-0.552207525167,1.05649007417,1.288373705,0.0271570020667,-0.198226437833,-0.330827487333,-0.4688894395,-0.155648221167,0.200358945667,-0.403960423,0.615039110167,-0.601686339,0.477641342167,-0.145563842833,-0.0421307084667,-0.0269278407833,0.553845325833,-0.548960816667,0.0582222909,-0.0913227824833,0.314140616833,0.286003013667,-0.230447887167,0.0801430561167,-0.437405018],[-38428.6404333,-4005.40979667,-1498.408305,-3432.29414667,1917.302445,627.9782615,693.730289667,-1483.81600333,491.867487,425.1310305,-1114.812795,894.4298895,1003.6600265,-1420.57889333,-3.87327624667,17.2403395405,-146.624434833,-308.161193333,-498.043659333,179.026410833,46.9174115333,-107.337433917,-327.271820333,237.618232333,-94.9686314333,-73.7512527833,259.646272,-190.696703833,57.3189699833,75.7533945833,61.1319377,-70.0887510833,-329.689753833,281.134369667,119.5996355,-6.99300525167,14.4878933167,140.757358667,3.45102288167,31.7853195,16.86883245,19.21837185,48.6543720833,-100.7948323,78.8341972167,95.41716435,26.7039391,-44.51115525,6.75175540333,13.0280240667,18.6878626,9.49362399333,10.3902586367,5.638723875,-7.98744197333,23.78069685,-21.41936365,31.0789663167,17.2548435167,10.651906105,1.10394885533,-22.82405605,-9.31593017833,0.0201112449667,1.81374013167,-4.29887432333,-0.124010362333,2.42445462333,-1.13335854667,-3.18083551,2.04921151167,-2.49129542667,7.66924242667,2.36098253833,0.941059825833,2.60282407667,-6.87839422833,-3.33724290333,-1.85685336167,4.95111852,-0.849261928333,-0.657566883667,-2.29685631167,-0.8070168405,0.7982918175,-1.47170448833,0.684229048,-1.18467141833,0.862913977667,0.669717534333,0.0606941550273,-0.3817959145,1.42800024833,-2.74427812333,-0.402388529333,-0.535684396,1.27530584167,1.33379130667,0.0923101344333,-0.229306527833,-0.371178075833,-0.5002935025,-0.1570158645,0.212741132167,-0.384696652167,0.6479424125,-0.606526327833,0.504438207167,-0.148884704667,-0.0335207469833,-0.0419475663333,0.544908825333,-0.506004622,0.0857190788,-0.0868461141667,0.3796383175,0.308939589,-0.2023164385,0.0702876832833,-0.438186634],[-38263.7218833,-3883.57679333,-1673.07859833,-3481.59485833,1909.22207167,557.299108,606.201553333,-1391.72433667,506.924755833,348.672566667,-1094.150115,881.240085333,1017.40954833,-1540.02994167,-53.4393182783,38.6288633667,-170.232592667,-322.2462755,-518.356318333,144.938266333,25.4938980033,-120.384244667,-307.761166,227.041431833,-82.2092216333,-76.2248767333,255.911949167,-192.483914,52.1322678167,76.6733198833,61.9271796833,-62.6091956833,-342.204757333,293.542966833,114.7939445,-4.44278195167,17.3350696167,141.285053833,5.16271448667,32.8119500333,17.1614119333,19.14022775,48.4720994333,-101.947382667,81.0478678,94.2542962,30.1035399167,-46.4905108833,6.481175555,14.84170985,19.3502416,10.12446299,11.2693548333,5.9844158,-7.72158159833,23.6848908,-21.30499105,31.7174245,16.7184048667,12.1617881167,0.283071295333,-22.55240745,-9.00585888833,-0.26131236105,2.19130403,-3.97877106333,0.1431691135,2.84615006333,-1.01385129017,-2.97071637667,2.011510655,-2.34244662667,7.62488145,2.22280497167,1.57844911117,2.32127489,-6.54587686833,-3.002613275,-1.90147807,5.374328705,-0.954572260667,-0.679671654,-2.27762026667,-0.716647314167,0.9134865105,-1.43001345833,0.762786794833,-1.18474996833,0.959546867333,0.6476048415,-0.00174966285756,-0.279964334,1.34797790833,-2.630972435,-0.3436499505,-0.521790002167,1.48333129167,1.37317005,0.151004325967,-0.258309191833,-0.413573673,-0.530213526,-0.155810419833,0.224936991333,-0.365588237,0.679059353333,-0.609365039,0.528586703,-0.150503008333,-0.0299369994333,-0.0543568329833,0.534668477167,-0.459846082167,0.1112584652,-0.0834117499667,0.442764491167,0.329615931167,-0.1748545575,0.0598551614,-0.437781154333],[-38118.3086333,-3701.667895,-1906.39150333,-3537.86220333,1898.87623333,461.5118555,496.3975145,-1258.42000333,525.14844,265.3605215,-1065.052855,858.125831667,1030.80987833,-1658.53815833,-104.28985045,65.0669634167,-196.9985165,-336.033052,-536.997173167,108.958838083,0.57021038,-135.374261833,-285.4521325,214.381410667,-69.0555198333,-79.22125775,249.740973667,-193.987825,46.00077075,76.8399910167,60.9742464167,-55.0717950167,-354.834993167,304.449736333,108.818452167,-2.39228225683,20.1917727,141.142717833,6.466031705,33.5760083333,17.4023500333,18.7891160333,47.9918869,-103.186743333,82.7937305,92.9477419333,32.9778313167,-48.4435543,6.088469495,16.67101415,20.0377329667,10.6531672,12.1586394167,6.31864285833,-7.37907963833,23.4813804167,-21.2185212833,32.17341075,16.1555286,13.6060208667,-0.618401217,-22.1356534,-8.59343931167,-0.531851184333,2.577306105,-3.618254465,0.426434134333,3.28882740167,-0.887449449667,-2.728611,1.97431715667,-2.190871135,7.54736670333,2.07367002667,2.22508145667,2.00603456,-6.15886146833,-2.67166774667,-1.92439933,5.758671465,-1.04870887,-0.700017086333,-2.247411005,-0.615042175333,1.03178321183,-1.38495122333,0.842361715333,-1.17497841,1.051888047,0.626951656833,-0.0745083887394,-0.1673427198,1.25841401833,-2.50289979333,-0.288842805667,-0.510589981333,1.67667608833,1.40580623333,0.2028376275,-0.284479634833,-0.456680805167,-0.5583633005,-0.152147688167,0.236919915,-0.3470709095,0.707329194333,-0.609768929167,0.549663596667,-0.150189616333,-0.0315050542667,-0.0642391828667,0.523078927,-0.41080894,0.133673637333,-0.0811809379,0.5021856515,0.347824719333,-0.148182529167,0.0490936579667,-0.4358893935],[-37975.1737667,-3489.322975,-2121.04471333,-3583.15040667,1887.62823833,350.888121,378.271735333,-1091.75834017,548.7412835,178.412782517,-1030.62231867,828.312829333,1044.34685667,-1772.90408333,-158.712166667,95.1912878833,-225.979392333,-350.764114833,-553.605209167,72.5529668,-26.6914970133,-152.796902667,-261.337609333,198.101563833,-56.23848865,-82.7044172833,241.047741333,-195.2764985,39.38000385,76.4556958167,58.3690012333,-47.86867915,-368.008706167,313.4712715,101.886945167,-0.9576708705,22.9508429167,140.378832667,7.33782359,34.1078257667,17.6200502333,18.2648324167,47.1713084667,-104.5656875,83.9414500833,91.55165705,35.4619161,-50.3165035333,5.59548669833,18.4587158167,20.7544727,11.0766296,13.0241543833,6.64238523667,-6.93641740833,23.1802376,-21.1477767667,32.4211260667,15.56620485,15.0363269333,-1.58087318767,-21.5741098833,-8.11359739667,-0.776704968667,2.95818137667,-3.22315235833,0.720278981167,3.73498284,-0.755050176333,-2.45510732,1.94388593333,-2.03021790333,7.4348502,1.91100996833,2.88660984333,1.65993022333,-5.71729155667,-2.36167837667,-1.92682827667,6.100610285,-1.12793067333,-0.7186013605,-2.20722875,-0.5052354885,1.14919521667,-1.337162745,0.9206395645,-1.15367245833,1.14089025167,0.607512132167,-0.156767631883,-0.0450297239667,1.15953646167,-2.35953867833,-0.241996190833,-0.502652311667,1.853010745,1.43114027,0.247805111333,-0.307205305667,-0.4991362865,-0.584285403833,-0.146506510667,0.2485509985,-0.3294925825,0.731569708667,-0.607324165833,0.567629213,-0.148026362167,-0.0376394676333,-0.0720876855667,0.5101734525,-0.358729521,0.1521843755,-0.0801255207833,0.556949811,0.363443508333,-0.1221965908,0.0383505478667,-0.431961042333],[-37814.4538167,-3302.19724,-2225.15803833,-3597.16254333,1872.38904333,237.638634333,268.821855333,-896.859203167,580.178869333,91.30437,-994.304335833,794.886898333,1058.40736833,-1878.68020167,-220.565971833,127.592258533,-255.898739167,-367.776456,-568.124086,36.96518267,-54.9644751667,-173.465248167,-236.723816333,176.209770667,-44.4873577333,-86.5514211333,229.746936167,-196.473006833,32.68752765,75.6913230833,54.21341155,-41.45233105,-382.2462775,320.144534833,94.2286411333,-0.2476252745,25.5119270333,139.0397665,7.76970157,34.4490504667,17.8317068667,17.6826187167,45.97147865,-106.145207333,84.3575563667,90.0998865667,37.7135791667,-52.0145987167,5.02448792,20.14497135,21.5024552,11.4012934,13.8388494333,6.95747007333,-6.36771625333,22.7951715,-21.0784081,32.4408077333,14.9390603333,16.5117808167,-2.5752647,-20.8522341,-7.60732576,-0.982041528833,3.31932932333,-2.799628605,1.02080135283,4.16810409833,-0.6158961385,-2.15088946833,1.92712420167,-1.852742625,7.287739485,1.72940915833,3.57028983667,1.28595464733,-5.21562841333,-2.09132678,-1.91140218667,6.39375529167,-1.18886388167,-0.735642818833,-2.15785158333,-0.3905082205,1.26137152167,-1.286711985,0.995355874667,-1.119075975,1.22801959667,0.589246416167,-0.247655756667,0.0863660068,1.05102093733,-2.19907851833,-0.206977517833,-0.4986742135,2.0094033,1.44781637167,0.286649184,-0.325883199167,-0.539612106167,-0.607398361667,-0.139516674,0.2594811395,-0.313131179333,0.750662873167,-0.601525833,0.582622357,-0.144224210833,-0.0474946695667,-0.0782114026167,0.495839286667,-0.3032606905,0.166175275167,-0.0799904588167,0.606178598833,0.376138320167,-0.09645340845,0.0281024797333,-0.425173071833],[-37622.86615,-3199.85017167,-2162.78616333,-3567.38950833,1847.93701,131.06222935,178.779394917,-681.298114333,620.735813167,7.56001206667,-957.972451,759.354377333,1072.663995,-1973.20278667,-293.458082167,161.193334833,-285.3365255,-387.733809167,-580.7948685,3.09612994667,-83.34883535,-198.389789667,-212.314906833,147.455054333,-34.3081244,-90.62363165,215.858748833,-197.711831833,26.2564422833,74.6176483667,48.5031045833,-36.0572020833,-397.899908,324.182994167,85.8686439333,-0.327801574833,27.7752121,137.155592833,7.773537695,34.6534893833,18.0356644167,17.1214716,44.3979651667,-107.983199,83.9611887667,88.5551298167,39.8290017,-53.4486752167,4.39064016333,21.6743515167,22.2743647333,11.6399832833,14.5890177833,7.263013535,-5.65489819667,22.3402412833,-21.00791265,32.2245455,14.25407595,18.0694191667,-3.57168253333,-19.9517929167,-7.10428892333,-1.13957486267,3.64852279667,-2.354085375,1.32478275667,4.57564901833,-0.470000404167,-1.81593570167,1.92794931333,-1.65482103833,7.10774926167,1.52445387833,4.28124499167,0.885788945333,-4.64671831667,-1.87353502,-1.880569355,6.63195894167,-1.22915162167,-0.751058489667,-2.09964898167,-0.2741124985,1.36447581833,-1.23375085833,1.06540268067,-1.07055661833,1.31455703,0.5719570145,-0.34598138,0.2273001154,0.931736150833,-2.01963032333,-0.186262898167,-0.4989756115,2.14289643167,1.45499730167,0.319958908833,-0.339878394333,-0.5769731535,-0.627156276167,-0.131840040833,0.269247716333,-0.298159346833,0.7639193205,-0.5921192805,0.595039141833,-0.139024269833,-0.0603753881167,-0.0824427070167,0.479680344167,-0.244138199,0.1752142665,-0.0804346828333,0.649080228833,0.385764321167,-0.0706694615333,0.018618503355,-0.414864020167],[-37398.7963,-3142.151285,-1969.50325833,-3505.49516667,1822.86807167,38.61989325,93.5353626683,-470.050115333,666.7434965,-70.1061021333,-917.982667333,720.380333667,1084.57067,-2059.33634667,-371.082730167,195.014213167,-313.756866667,-409.2941,-591.479196667,-28.3311783633,-111.7037883,-226.391851333,-186.3038225,113.090680333,-25.7589051,-95.0121671833,199.820777833,-198.8979725,20.44881875,73.1601806833,41.3563112,-31.1418838,-414.648186,325.7829805,76.4219300167,-1.109754675,29.6420979333,134.746048833,7.40168136167,34.8328500833,18.1850272,16.5465322,42.5799526167,-109.981892833,82.7766248667,86.7679707833,41.7398623667,-54.6113525,3.71568822,23.0146591667,23.0308598167,11.7896628167,15.2850157833,7.54553105833,-4.82538714833,21.8170964667,-20.9192806667,31.7947024167,13.4886214167,19.6771443667,-4.54471459667,-18.8896637667,-6.59056079667,-1.25182727167,3.94128999667,-1.89809887167,1.62038614,4.95172427667,-0.324023507333,-1.45265511,1.93641669667,-1.44001964,6.90131213,1.29887326667,5.01095287333,0.459850010833,-4.01404919,-1.69900236833,-1.83032667667,6.81656232833,-1.2498743,-0.763989795833,-2.03263710167,-0.15950889685,1.45657869667,-1.18059179167,1.13299445,-1.011621222,1.39932772667,0.5546809645,-0.448687342333,0.377665935333,0.8004914555,-1.82339009,-0.177037229,-0.500603951167,2.25257687,1.45301642333,0.3459808885,-0.349029146333,-0.610428417833,-0.6431017015,-0.123530750333,0.2775970565,-0.284763272333,0.771967748833,-0.579668347,0.605091174,-0.132978154,-0.0757623840667,-0.0841475066333,0.461287122167,-0.182070176667,0.179597361167,-0.0809311536333,0.685646624167,0.392276390167,-0.04606473755,0.00947969459483,-0.400818326167],[-37146.7151,-3076.97861167,-1711.71732333,-3430.00693167,1806.80848833,-34.3641999833,-8.28711157667,-289.1300135,713.381218833,-139.15932985,-869.349722,676.082671333,1091.61448833,-2140.583035,-445.3250665,228.2063025,-340.627979333,-430.584199167,-599.829610833,-56.7776788167,-139.977116167,-255.7789285,-156.6882655,75.09503405,-18.7345763333,-99.8059745,182.170538,-199.859028167,15.5851973333,71.17048275,33.0345661667,-26.1239290333,-431.972069167,325.331148333,65.4010539667,-2.46235058167,31.0139872167,131.822371,6.71937884833,35.1133129167,18.2006269833,15.93017415,40.6416968333,-112.014851667,80.8750008333,84.5538110833,43.3132370167,-55.51639195,3.01904763667,24.1377267833,23.72237625,11.8437286167,15.9458805,7.78512828833,-3.91515170333,21.2202917167,-20.7962066333,31.18483075,12.6172667,21.2764302333,-5.46781020333,-17.6867733333,-6.03814014833,-1.32521580833,4.19487617,-1.44443953167,1.89337696833,5.29254812167,-0.1854833047,-1.066032795,1.93903948333,-1.21446814217,6.67557624833,1.05672739883,5.74484134167,0.0101369983333,-3.322702205,-1.55235187833,-1.75553426,6.94835533167,-1.253003705,-0.773415395333,-1.95646889333,-0.0502219155,1.535857355,-1.12951474167,1.20021913167,-0.946560096333,1.480703025,0.536105306667,-0.552168778833,0.536871979667,0.656728821,-1.61371876333,-0.175620923333,-0.499782504833,2.336990885,1.44224699,0.363023834167,-0.353205008167,-0.639264746167,-0.654748320333,-0.114437148833,0.284162359667,-0.272974464167,0.775627436833,-0.564756555167,0.6130756715,-0.126737294667,-0.0931397040833,-0.0826530595333,0.440392826167,-0.118273023083,0.179528588167,-0.0807681089667,0.7158722975,0.395519616333,-0.0239243326767,0.000202497192667,-0.383032282167],[-36870.8768167,-2994.77827833,-1427.73106333,-3351.82223667,1802.65506667,-83.28716425,-130.816675165,-148.662944617,757.203733667,-197.176172833,-809.5481895,627.375872833,1094.28565167,-2217.51014167,-513.572898,259.680742167,-365.159614833,-450.186740167,-605.814284333,-81.82885775,-167.543464,-285.739592833,-123.188072667,34.922445175,-13.241853865,-105.036152383,163.533638667,-200.623900167,11.8109421417,68.4957650667,24.0293062,-20.8330686667,-449.500643833,323.1786965,52.7847863167,-4.25833603667,31.7883417,128.4454685,5.78615380333,35.5837372833,17.9725270833,15.3612089667,38.6962362167,-113.996290333,78.3157900667,81.8532207333,44.5044081333,-56.1703324833,2.32681288167,25.01344105,24.300303,11.8103934167,16.5904272833,7.95501209167,-2.948987895,20.5635127167,-20.6270834833,30.4255368333,11.6220796,22.8316445833,-6.30918869167,-16.3583795833,-5.447863145,-1.36451382167,4.40687579333,-1.01007872817,2.132331865,5.59641081167,-0.0611657323167,-0.667368834,1.92522049167,-0.983386955,6.437347005,0.796381669333,6.46700600167,-0.457693709167,-2.57568289667,-1.42822921,-1.66106681,7.02756056667,-1.2407831,-0.778099281667,-1.871698965,0.0495348534167,1.60075772667,-1.08194158333,1.26663777167,-0.880639941833,1.55762953333,0.5154804675,-0.654285488667,0.702072527833,0.501086760667,-1.39322582667,-0.179794430833,-0.496388663667,2.39434754333,1.42362378667,0.372330827167,-0.3524369485,-0.662732222167,-0.661402700167,-0.10472908085,0.288478835833,-0.262602437,0.775578846667,-0.548276426,0.619393529667,-0.120724807667,-0.111891565567,-0.0779050008833,0.416908920333,-0.0539314075833,0.175385078,-0.0796971829167,0.739596970333,0.395500707167,-0.00433404014,-0.00895455025517,-0.361910249167],[-36575.53285,-2900.09630167,-1147.7698995,-3268.79421333,1809.866625,-107.8594009,-257.506021833,-43.4356125833,797.425423667,-243.083523833,-738.7448055,579.266204667,1095.86500833,-2288.40823,-577.636431833,288.003980333,-386.953674833,-466.9510205,-609.382835333,-103.187784483,-193.352909833,-316.1779105,-86.6815443167,-7.07478846667,-9.54271830667,-110.770841333,144.704909167,-201.375647833,9.04107453167,64.9885639,14.97968247,-15.2724118033,-467.179688333,319.5845355,39.2222390667,-6.40196088833,31.8770156333,124.733508167,4.64373645833,36.2620503833,17.3844962333,15.0164796667,36.9108722,-115.887433167,75.1340012333,78.8159054167,45.3698958167,-56.6005724667,1.67539497167,25.6180201333,24.7127749167,11.7042210333,17.22968185,8.03100554333,-1.94085248767,19.8874034167,-20.39728185,29.5447520333,10.5113402083,24.3315098167,-7.04445237333,-14.9159393167,-4.84721976167,-1.37011200833,4.576019845,-0.618379126667,2.32702556667,5.864112285,0.0443917702333,-0.271720714,1.88630023,-0.748981296667,6.19541497,0.512139902333,7.15924408833,-0.937625479667,-1.772767992,-1.32977378833,-1.561117205,7.055853715,-1.2151471,-0.7767529485,-1.78010861167,0.134944851567,1.65107025,-1.0387602315,1.33005242333,-0.82094669,1.62943174167,0.4933804195,-0.754782071833,0.867516554833,0.3351539815,-1.1624830285,-0.187955783,-0.494126694,2.423659335,1.39822946833,0.377266334,-0.346921459667,-0.680098185167,-0.662036327167,-0.0947856913,0.290305569667,-0.253531572833,0.772289593667,-0.531675707167,0.624321147167,-0.114987103833,-0.131489699667,-0.07050640795,0.391048429167,0.0103803144167,0.167969967833,-0.0782658196667,0.7568833055,0.392216820667,0.0133723638567,-0.0168910358783,-0.3380379495],[-36269.4798,-2791.90473667,-891.125544667,-3181.81644833,1829.343015,-107.762590383,-376.455965333,25.2187163,832.564065833,-275.774031,-657.985328,535.578360667,1097.489065,-2349.69187833,-637.410059667,311.907421667,-405.5625405,-480.1956825,-610.283904333,-120.686256333,-216.002223167,-346.554007667,-48.3557746917,-50.8336165083,-7.78144915667,-117.0041285,126.305826833,-202.191780333,7.28530475333,60.5311326167,6.425876315,-9.53410593667,-484.935219667,314.865914333,25.3556200333,-8.77902446833,31.2143632333,120.789080333,3.32512839833,37.1906537,16.3206005667,15.0067184167,35.4303895167,-117.627342833,71.414264,75.5747773333,45.9502556333,-56.82943795,1.09949589483,25.9267073333,24.92282125,11.5324187667,17.8736496333,7.98779035,-0.913834497167,19.2353420667,-20.0844474333,28.5799568833,9.29094515333,25.7591193167,-7.648957465,-13.3734390667,-4.25471890167,-1.34358384333,4.69896145333,-0.287283826233,2.46842090833,6.09459603667,0.127302949317,0.107024368167,1.81891163,-0.511932823667,5.95851166,0.197755939833,7.803312825,-1.420782526,-0.916951442967,-1.25740079333,-1.465446665,7.03380267333,-1.17856064333,-0.768493,-1.68332214167,0.202252239833,1.68600806667,-1.0001988435,1.38868989667,-0.772867930833,1.69508573167,0.469968372167,-0.853447985333,1.02779251167,0.1617652389,-0.9223634795,-0.198231518333,-0.495069784333,2.42422213,1.36590302667,0.3808509155,-0.337043589167,-0.6905723555,-0.6559054555,-0.0848580860667,0.289305552833,-0.245514417333,0.766267168,-0.5162714555,0.627854312167,-0.109747639333,-0.151268274,-0.0609686993,0.363138660333,0.07414822625,0.158113492167,-0.0767375049667,0.767894507833,0.385200941667,0.0298871616333,-0.0225106451,-0.311903843833],[-35954.5659167,-2684.49164333,-682.408731667,-3095.84404667,1859.11069833,-85.4664724667,-493.134673667,54.5634080167,860.843046833,-294.855991833,-567.265709167,495.026126833,1098.27165333,-2398.887255,-689.999494,331.223623833,-420.450464667,-489.238936833,-607.948004667,-134.590439833,-235.114965,-375.936964167,-8.99983666667,-96.8042365167,-7.72547814,-123.498106667,108.6131361,-202.792880333,6.51320993833,54.8426695,-1.475972955,-3.629926965,-502.683886167,309.2592365,11.5157554017,-11.287906835,29.83586185,116.643652833,1.881675385,38.39725925,14.7050149833,15.30751805,34.3262788,-119.168447,67.2872357833,72.1506176,46.2311962333,-56.869876,0.603854451833,25.9324498167,24.9232601833,11.2976081,18.53098445,7.82019031333,0.114837464667,18.6304794167,-19.6736163667,27.5737651,7.96417693,27.0860804333,-8.11368842833,-11.7378985333,-3.66296956833,-1.29185146833,4.77110559333,-0.0222123712667,2.554774875,6.290159435,0.189516353833,0.464786360167,1.72644819833,-0.271171414733,5.73334028,-0.149287107333,8.38604922833,-1.89873263333,-0.0148023367,-1.20347995833,-1.37519020333,6.96126361833,-1.133861155,-0.7541732355,-1.583252115,0.250511184167,1.70604083833,-0.964647162,1.44183444667,-0.738014135167,1.754509165,0.4455617825,-0.949843825667,1.17965549667,-0.0151612832333,-0.6732590925,-0.208054062333,-0.499048983167,2.39715947,1.32532061667,0.384141849333,-0.323365707333,-0.694040763833,-0.6431466995,-0.0753589282333,0.285151585667,-0.2381012615,0.757836439167,-0.5029543925,0.630035699833,-0.105116401333,-0.1704781515,-0.0497754682333,0.333605207167,0.137235306333,0.1467024535,-0.0753782835833,0.773121390333,0.3739457165,0.0456429470167,-0.0254257923333,-0.283747759333],[-35640.8401167,-2602.524285,-534.400616,-3017.49067,1893.35038667,-43.7796243833,-610.899158,44.98820534,880.672018,-301.340219333,-467.3566155,456.470540667,1097.84135833,-2433.74872333,-732.884477667,346.156526667,-431.401147333,-493.779600833,-601.671185333,-145.1069055,-250.523190667,-403.758301333,30.4974708917,-145.46144065,-9.03476978167,-130.007265833,91.7452057167,-202.898569,6.65977751667,47.6336099333,-8.803431275,2.35379835833,-520.279484,302.9493175,-1.95850974333,-13.8319097333,27.8061319833,112.309993333,0.33069088,39.8795230833,12.4856194467,15.8340633167,33.6219685,-120.4616365,62.88841745,68.5771226167,46.196388,-56.7362257,0.184781863833,25.6377614833,24.7201705667,10.9942168333,19.2011826,7.53071604,1.12796145183,18.0856171667,-19.1560472833,26.5680355,6.54867886667,28.2871299167,-8.43929238,-10.01771593,-3.06142054833,-1.22290285,4.78951905667,0.176756460933,2.586736735,6.45254199667,0.234652791667,0.800704665167,1.61461264667,-0.0279084642667,5.52584584167,-0.527492480833,8.897840315,-2.365733215,0.9237435657,-1.160044565,-1.28988,6.83860183,-1.083739865,-0.734656893333,-1.48154864333,0.280237424333,1.712091575,-0.930079866667,1.48914892167,-0.7163830045,1.80690510333,0.420561771833,-1.04335952167,1.321166315,-0.192159422267,-0.416218779833,-0.2152419385,-0.505730882833,2.34459861333,1.27504695833,0.387477506667,-0.306447015667,-0.690541299833,-0.624151144167,-0.0665045290167,0.2776770365,-0.230840991167,0.747207039667,-0.492294647,0.630748834167,-0.101142045217,-0.188569993333,-0.0371941511,0.302777676833,0.1994003065,0.134469743167,-0.0746470601333,0.773352393833,0.358103343833,0.0609152219667,-0.0254804193333,-0.253738630667],[-35323.1062167,-2574.33131833,-443.189177167,-2953.44346167,1924.33986,12.2020061,-724.893562167,3.43631076,889.193929333,-297.143037667,-361.423165167,419.904891333,1098.12292667,-2452.3797,-763.434992167,356.461029667,-438.548260667,-494.1991915,-590.975457667,-151.979584,-261.887333333,-429.210583833,69.04409185,-197.024723,-11.4332862067,-136.374669167,75.73522485,-202.366734,7.65320025167,38.7724982,-15.5407735317,8.203504085,-537.490196667,295.993191833,-14.7124043317,-16.30325655,25.1806683167,107.815068833,-1.33872826167,41.5903742333,9.6624188,16.5163714,33.29273835,-121.4574065,58.29805905,64.9085101833,45.8386417667,-56.42672575,-0.151553854333,25.0488234667,24.3313318,10.6169206833,19.8658061,7.12839777833,2.10542524,17.60479835,-18.5290626167,25.5854738667,5.07591915833,29.3409324167,-8.62499301667,-8.222662195,-2.450800395,-1.14141272667,4.75364993667,0.312681007333,2.56686331667,6.57990133167,0.265189479833,1.11104398483,1.490484615,0.2147063901,5.33765636167,-0.930965584167,9.33043525333,-2.81678131833,1.88673073683,-1.124742725,-1.21017506333,6.66719759833,-1.03040261833,-0.710152939333,-1.37963394833,0.292500529667,1.705119945,-0.895152664,1.52923413,-0.706589278333,1.85109769667,0.394943962833,-1.13272265,1.45073608667,-0.366141198833,-0.153072672833,-0.219474283333,-0.515347488,2.26915629833,1.21416570333,0.390880245667,-0.286965299333,-0.680038594667,-0.599432893833,-0.0584441850333,0.267031947167,-0.223417667,0.7343668555,-0.484426467,0.629833079667,-0.0977365529333,-0.205094732333,-0.0234322154467,0.2709502555,0.260148525167,0.121654481833,-0.0751976067667,0.769430504167,0.337641147,0.07588590275,-0.0226418862,-0.222026521],[-34982.7692833,-2635.02098667,-411.574911333,-2913.11438,1941.03859833,72.4836624667,-829.188888,-54.56100471,881.515943667,-284.263439333,-253.443697,385.893420333,1103.17525667,-2452.02234833,-779.6249115,361.506646333,-441.949043,-491.113147,-575.8163185,-154.959578,-268.631443833,-451.132201333,105.18600525,-251.232005333,-14.63033055,-142.510324,60.5880302833,-201.148276167,9.33256883167,28.3403867667,-21.49592895,13.5968202717,-554.074553833,288.412196667,-26.4905088833,-18.5735086,21.9946594667,103.189627317,-3.12243408833,43.4425407167,6.269205025,17.3221754833,33.2737864167,-122.112691333,53.5642547667,61.20017285,45.13009425,-55.9177637,-0.390283078333,24.1732950833,23.7757211667,10.167834855,20.4983749,6.62388321333,3.024141755,17.19140685,-17.8012572667,24.62949895,3.57635935333,30.2152567,-8.66694176833,-6.356551155,-1.83662755833,-1.04991676517,4.66454113667,0.390014338167,2.49908225167,6.66944776167,0.2823897665,1.386243765,1.36210480667,0.452009168667,5.16485219,-1.35011593567,9.67627181167,-3.24455642833,2.86559240833,-1.098114595,-1.13817014667,6.446457375,-0.975918813167,-0.680280699667,-1.2785381,0.288128722167,1.68583482167,-0.859292217,1.55921147167,-0.706443933667,1.88655795833,0.368206057833,-1.21605617667,1.56706953667,-0.534171967667,0.114009824,-0.221864362333,-0.528990590167,2.17272996667,1.14209819333,0.394935276833,-0.265679361333,-0.662437262833,-0.569533548667,-0.0515211005333,0.2534896405,-0.215562766167,0.719246165167,-0.479150477,0.6272735825,-0.09461676445,-0.21965326,-0.00856710558167,0.2385363245,0.3189053945,0.10808058845,-0.0776377095333,0.761899137333,0.312714020833,0.0908780059333,-0.0168944856733,-0.188915467167],[-34634.6103833,-2798.26988167,-437.245704667,-2903.84972333,1935.98879167,129.3240866,-923.918267,-121.312747067,855.325016333,-265.534923,-146.720019017,354.020177167,1114.649755,-2429.80356,-779.494044667,361.1863725,-442.191960833,-485.220980167,-556.437360833,-154.131336333,-270.092075833,-468.255127333,137.66958,-307.995259833,-18.3594338667,-148.401196167,46.31645375,-199.1282515,11.623535425,16.5650746633,-26.5853798,18.2942624833,-570.083605167,280.1892805,-36.9524863333,-20.5501823333,18.3310577,98.4824377167,-4.97574345,45.3713093167,2.33874704667,18.1528837667,33.4911190667,-122.440308833,48.7059681333,57.5820709333,44.10310625,-55.2242528667,-0.519706184833,23.0409448667,23.073074,9.64862539333,21.0717456833,6.01966552167,3.84818558167,16.8448200833,-16.9856283667,23.6960991167,2.08779758317,30.9035020833,-8.580898515,-4.44168546833,-1.2278588315,-0.949815393833,4.524490885,0.412435463667,2.38486081,6.71754785167,0.285665854667,1.61820188667,1.23481532333,0.681920174,5.00520316,-1.77569402833,9.93701645,-3.64431993333,3.84673588667,-1.08197703167,-1.07365387667,6.17936719833,-0.922329658833,-0.645872080667,-1.17961750333,0.2677201155,1.65500831667,-0.822156049,1.57823469,-0.714059291,1.91350831333,0.341341379833,-1.292900085,1.66989351167,-0.693991913833,0.3815861665,-0.2240583595,-0.546880063,2.05863783667,1.058769322,0.399690673167,-0.2434592135,-0.638036762333,-0.535064982333,-0.0458737908167,0.237567825,-0.206849200833,0.702240692333,-0.476111681667,0.622896871667,-0.0912455675,-0.232214207,0.00732204419,0.2060446125,0.3754278735,0.0934705668,-0.0821545861667,0.751484620333,0.283632131,0.105835406833,-0.00820490575667,-0.154714652833],[-34315.6878167,-3027.65455167,-548.617276167,-2925.462575,1908.53886833,173.270001,-1010.8912675,-206.764100667,813.52967,-244.935464,-43.66782255,323.167829,1129.69211667,-2388.40514667,-765.858107167,356.656851167,-440.543298167,-476.856108833,-533.5904325,-150.301164667,-266.608772667,-481.090293333,165.9930295,-365.664493833,-22.2839587667,-154.0907135,33.0576273,-196.3656565,14.40539835,3.696632665,-31.0710284167,22.3872289167,-585.353589167,271.825983667,-45.8474618,-22.1978421667,14.3367493333,93.7710898833,-6.87465502833,47.34786525,-2.05378776,18.8867712333,33.9686071333,-122.521480833,43.8739217833,54.1506213333,42.7902447,-54.5229451667,-0.5531129465,21.7157743667,22.2468124833,9.06498698833,21.5826321667,5.322265635,4.55196870167,16.5774517167,-16.1315746167,22.7959306667,0.634377436667,31.4108011333,-8.434704755,-2.52238177667,-0.620005649425,-0.847675323833,4.343475665,0.384044277833,2.228677125,6.72915512333,0.272178975333,1.805789255,1.11043283783,0.895582777,4.85760774167,-2.20476594667,10.12206089,-4.02060909167,4.81396172333,-1.07140497167,-1.01592907483,5.87654924667,-0.871863241667,-0.60802494,-1.08435312017,0.233334974667,1.61527047333,-0.784220175333,1.58819990833,-0.729959989667,1.932258465,0.316134579333,-1.36496381667,1.76176549,-0.8440166065,0.648013629,-0.225564939667,-0.568426302667,1.93187759167,0.967423148333,0.405149271667,-0.220990381,-0.607969992167,-0.496889527667,-0.0411383278167,0.219798127333,-0.196901687833,0.684371678167,-0.4755714715,0.616943078,-0.0867879175,-0.243246385167,0.024818622405,0.174070893833,0.430522685,0.0779559726333,-0.0884100966833,0.738869374833,0.2518106,0.120577028333,0.00342262820667,-0.120475045733],[-34064.25135,-3275.23391167,-759.697824333,-2971.56142,1859.34493,196.946333833,-1085.78114333,-325.3646,761.171135333,-226.781031167,52.58652055,293.343609333,1144.309635,-2332.32988,-744.2012255,349.330129833,-438.442931833,-466.646325667,-508.194080167,-144.379122,-258.959335167,-490.920349333,189.508187,-421.9297625,-26.1136469,-159.642397667,20.92015643,-193.052184333,17.5817530667,-10.0373790733,-35.2932172,25.9596167,-599.511010333,263.984792,-52.8920572,-23.5103721167,10.1683773733,89.1401191333,-8.822729685,49.3610875667,-6.81258855667,19.4194303167,34.7449155,-122.419692333,39.2738652833,51.0006688667,41.2271384833,-54.0334035333,-0.511583510833,20.2683978167,21.3246081833,8.42244886167,22.0336039667,4.54500140833,5.11807637167,16.40538465,-15.2957040833,21.9477388833,-0.7625858275,31.74199115,-8.313448995,-0.648549666667,-0.00765294253333,-0.750786260667,4.13359673,0.310404746833,2.03655668,6.71009869,0.240006059,1.94963552667,0.990265566833,1.080609208,4.72113511333,-2.63572421333,10.2405852333,-4.38187409167,5.74897108333,-1.05983787167,-0.9650510075,5.54983202,-0.8263567945,-0.567614858667,-0.993911477833,0.187691439167,1.56908836,-0.746045885333,1.59127955333,-0.755191496667,1.94228416667,0.294114456167,-1.43411990333,1.84546592333,-0.983172295167,0.911456151667,-0.225008649333,-0.592923489667,1.797772905,0.872043109667,0.411501316,-0.198767855333,-0.573493435,-0.455889429,-0.0367440263667,0.200571350333,-0.185450031667,0.666660975,-0.477868717333,0.609593766167,-0.0805171402333,-0.253225320167,0.0446983530167,0.143208699333,0.484991822667,0.0618839909167,-0.0958384764167,0.724740799167,0.218955805833,0.134901330167,0.0180208524033,-0.0874212086167],[-33914.4983,-3505.38741667,-1024.73274683,-3028.21984167,1785.947685,199.260973333,-1131.07632833,-486.6682095,704.281109167,-215.932499,136.94716635,265.8926655,1155.86815,-2266.18239,-722.554184667,340.305844667,-437.383566,-455.796743833,-481.760971333,-136.946985,-248.0850305,-499.196367,206.6560035,-474.272208333,-29.6663527167,-165.105777167,10.0291812295,-189.593183833,21.1086410833,-24.453550955,-39.3980762,28.8854878,-611.9847765,257.248808333,-57.5498656833,-24.4782230167,5.98934479833,84.7014330833,-10.8328406217,51.3985169333,-11.843254485,19.71493,35.8477959,-122.135837833,35.1015263333,48.2868960833,39.5046657,-53.9514726167,-0.408876158667,18.7711414167,20.33518775,7.73699211333,22.4230615,3.70221603,5.53407794333,16.3474159167,-14.5221879167,21.1683877,-2.07553338267,31.9103390833,-8.29879705833,1.13056395167,0.596666585575,-0.665477806333,3.90769912,0.19532410445,1.816858455,6.66446405333,0.187869246,2.04749734333,0.87495488,1.22557435333,4.594349035,-3.066636065,10.2987311167,-4.73623074,6.63076870333,-1.044839285,-0.925862344667,5.210212025,-0.787957876833,-0.525268231833,-0.909561925167,0.133385258967,1.51843032667,-0.707913571833,1.58878890167,-0.7913445615,1.94255314667,0.276568286667,-1.50143613167,1.92219844833,-1.11033872717,1.16877113433,-0.220612641833,-0.621006748667,1.661831235,0.776318225667,0.419940629833,-0.1773650125,-0.5358374595,-0.412710449833,-0.03214645945,0.180203534167,-0.172180892167,0.650098923167,-0.48326823,0.600810843333,-0.0718312594167,-0.262249962,0.0675793634167,0.114096470233,0.5391127215,0.0460346694333,-0.103919436867,0.709928714333,0.186776034333,0.148865061333,0.03588687145,-0.05665878805],[-33898.3504,-3690.28645333,-1263.16539,-3086.45321333,1682.68338333,185.047413833,-1122.223615,-692.594959167,646.5635575,-218.274407333,204.734967833,242.713452,1163.96991833,-2195.04040167,-707.5896045,330.277874833,-439.163052167,-445.4662865,-456.143098667,-128.261898,-234.994083333,-506.583167167,215.905369167,-519.783456,-32.6985456333,-170.602323833,0.499054778,-186.525830667,24.8794259833,-39.3379560167,-43.302371,31.02226095,-621.963698167,251.987858667,-59.2381578167,-25.0386190667,1.95397214167,80.5460858667,-12.9374545167,53.3957620667,-17.0451562,19.7646867333,37.2760857667,-121.6073435,31.4809649333,46.1807338667,37.7283439333,-54.4106102167,-0.245367808467,17.29988375,19.2993904833,7.02618899333,22.73530515,2.801837925,5.77986580333,16.4083446667,-13.8438320333,20.4556647333,-3.26592124833,31.9266467,-8.45030572167,2.765530925,1.16579502933,-0.597136417333,3.68179002,0.0414230109667,1.57928724,6.59508779,0.111387848303,2.09185753,0.762087203833,1.32019949,4.47288721833,-3.49163748,10.2992218,-5.08599383167,7.4358836,-1.02840059667,-0.906652196333,4.86963148667,-0.759453672833,-0.480550026667,-0.832268848,0.0732362413617,1.46575698667,-0.670475322667,1.58061130167,-0.840114476833,1.931640205,0.2648748415,-1.56714729,1.99192095167,-1.22346494333,1.41573120333,-0.210918009667,-0.654820625833,1.53001488667,0.684186057,0.431495970833,-0.157666666833,-0.496108863167,-0.3677147,-0.0267472006667,0.159262222833,-0.156635885,0.6355681675,-0.491805426167,0.590280318667,-0.05994830735,-0.270440130167,0.0938926174333,0.08738355025,0.592674939667,0.0314160176833,-0.112548808167,0.695210481167,0.157106212667,0.1624656445,0.0571917367833,-0.0292275575167],[-34035.6550833,-3818.00787,-1449.15401333,-3145.015215,1543.97947833,155.127195833,-1051.58445983,-937.727407333,588.951948,-238.142988833,254.501973833,222.734291833,1170.03239333,-2120.64419,-701.975277667,319.584398,-444.959171833,-435.520748,-432.832631833,-118.330646833,-219.757485,-512.7882855,216.660717833,-556.525691667,-34.9143818333,-176.137185,-7.3886142505,-184.082418333,28.75120415,-54.3799883667,-46.8547262,32.43426205,-628.879491,248.274335833,-57.5165895333,-25.0944139333,-1.795171555,76.7243065167,-15.1010275167,55.25815075,-22.3506596167,19.5421399667,39.0248542,-120.783236833,28.4275598333,44.8244433333,35.9835582167,-55.4734897,-0.0147583950333,15.9154801833,18.2145484167,6.31003552167,22.9472358333,1.83307538667,5.83249256667,16.5790017667,-13.27546925,19.7828170833,-4.29004174167,31.7995358833,-8.79878473833,4.21875215167,1.67905025667,-0.550632109,3.467295465,-0.153590476383,1.33085988833,6.50427482667,0.00218725804667,2.07598747,0.6463324495,1.36188724167,4.34981320833,-3.901697915,10.2459025333,-5.42663200167,8.14556442833,-1.01232574283,-0.913404828667,4.537473365,-0.743790433833,-0.433539340167,-0.763341579667,0.00904465684667,1.41389205333,-0.6345138055,1.56652560667,-0.9031793725,1.90968239,0.260665833667,-1.63100765,2.054614695,-1.31967881333,1.649193015,-0.1955540765,-0.696424352667,1.407080875,0.5986951105,0.446452625167,-0.140717990167,-0.455229952833,-0.321047130167,-0.0202788217,0.138487918,-0.138112412667,0.6237416285,-0.503438475167,0.5778057995,-0.04385894165,-0.2779757105,0.123740860617,0.0636018528833,0.645515849667,0.018628924165,-0.122109251833,0.681035882,0.131385060333,0.175630023667,0.0818859120667,-0.00591493736667],[-34298.1629833,-3902.26953167,-1644.22211167,-3201.77188167,1372.09343167,110.729195383,-948.799689333,-1212.71080017,532.412469167,-274.932602333,292.527048,201.560817333,1175.60544333,-2038.10771667,-700.798684,308.653359,-454.445579667,-424.232677833,-411.160984833,-106.531633933,-201.109908,-516.875924833,211.019772,-584.935595667,-36.2326300333,-181.445775,-13.5409122067,-181.733663167,32.9217025,-69.1894854667,-50.2049233833,33.5866595667,-632.655861833,245.7842315,-52.5108619333,-24.6780913667,-5.14217469,73.1556294167,-17.2334154667,56.9857733667,-27.7239103,18.9714366833,41.0310041167,-119.570874167,25.8542968,44.2797556833,34.2530577333,-57.11814135,0.265091720033,14.64355805,17.0635364,5.58367951,23.0500797,0.784251228167,5.70818393833,16.8100812667,-12.7764666667,19.1232714,-5.09016569333,31.5337016,-9.34807948667,5.47725690167,2.16901723167,-0.526838879167,3.263482565,-0.388487339833,1.0733735325,6.39118267,-0.143782094197,2.01376012333,0.518882965,1.36188345167,4.220878345,-4.27760666667,10.14965615,-5.75604257833,8.75176863,-0.985993529,-0.935091010333,4.21787016,-0.7404770975,-0.386770404667,-0.7033740765,-0.0567810885717,1.36344503667,-0.600429033,1.54872101833,-0.97980719,1.877932365,0.264000104833,-1.691144685,2.112157585,-1.39804705333,1.86654154667,-0.174903787333,-0.7428767485,1.29576061833,0.519851587167,0.461344960667,-0.126809534667,-0.414108814667,-0.273173542,-0.0125704836583,0.1182455674,-0.116307577217,0.6141974035,-0.5177008515,0.563175228833,-0.0235100906138,-0.285190013667,0.156608903667,0.04309608165,0.697219182833,0.007163355055,-0.13304564,0.668150273833,0.109815584883,0.187215470333,0.1089060673,0.0134769627833],[-34639.4959833,-3941.34401,-1888.86682667,-3250.06588167,1176.075701,57.7687735167,-846.622693333,-1511.44738333,478.714985333,-327.255017,325.804353,174.890525333,1180.54778833,-1943.84157167,-697.114998833,297.979099167,-467.380632,-410.2955995,-390.064505667,-92.1015640167,-178.64634,-517.638104667,201.811068333,-605.514511,-36.7054689333,-186.295811667,-18.15098735,-178.914674667,37.74687555,-83.5045602333,-53.4903515,35.01047355,-633.070323,244.155575167,-44.59916045,-23.8898125667,-7.98865665333,69.7164892,-19.2817436667,58.61263345,-33.11390995,17.9925469333,43.2161001,-117.822909,23.6841739833,44.5470915667,32.4650243333,-59.3185340333,0.568329079167,13.5044348667,15.8415971667,4.83175266333,23.0386381833,-0.340407979,5.43763230667,17.0415296333,-12.2946221167,18.45883115,-5.62056902667,31.1191517,-10.104297285,6.53150823,2.68490222333,-0.523254850333,3.06956972667,-0.655734698167,0.809968216667,6.25238895667,-0.3243805755,1.923923615,0.370612641667,1.330635235,4.0822998,-4.599804315,10.0170460733,-6.07668896833,9.24834342833,-0.933437267333,-0.954889274667,3.91432164167,-0.747256786333,-0.342716551,-0.6520379875,-0.120506153933,1.31346516,-0.568096830833,1.52918625667,-1.0679312505,1.83624818667,0.273642575667,-1.745090425,2.16566114667,-1.458631205,2.06476833833,-0.148489856833,-0.7887366425,1.198325765,0.446937702,0.471325657833,-0.115874149833,-0.373662396333,-0.224770120333,-0.00325986643,0.0986904755833,-0.0913246552,0.6059006105,-0.533838898833,0.545925107833,0.000560105428,-0.292367867667,0.191758017833,0.02627805105,0.7472742055,-0.00351086247167,-0.1453493305,0.657415803167,0.0922506663833,0.195467692167,0.136816674333,0.0294689903],[-35013.5021833,-3947.78358333,-2177.62363667,-3281.72459167,964.716952667,7.80597976667,-760.742075333,-1827.703255,430.632286333,-392.459219333,359.543893833,142.07429,1184.91439833,-1838.57757667,-685.753963333,288.385042667,-483.251636,-393.500067167,-368.614102667,-74.14141915,-153.416921833,-514.191988,191.564140167,-617.814289833,-36.3769082333,-190.520457833,-21.6943847333,-175.372778167,43.6409546167,-97.2948754,-56.7533296333,37.0802803667,-629.554761167,243.119026,-34.2743145167,-22.8695676167,-10.2823544083,66.2679946,-21.2818052,60.1924814667,-38.46151355,16.6158081667,45.4565643833,-115.353505667,21.8831368333,45.6017836333,30.49758825,-62.0237144667,0.854109619333,12.51235075,14.5646478333,4.03411913,22.9097285333,-1.52263438517,5.06860678167,17.2091866,-11.7883025833,17.7750228667,-5.82816609833,30.52217905,-11.0724218167,7.37963354667,3.267536045,-0.537509379167,2.88760288667,-0.939006173833,0.548967642167,6.08189454333,-0.533474513167,1.82507616667,0.195324899232,1.272950715,3.92723001667,-4.84443711333,9.84800285,-6.39387126833,9.62996531333,-0.8419656785,-0.958695031,3.63088459833,-0.760252549333,-0.302558399167,-0.607915902,-0.1763793555,1.261435775,-0.5369357125,1.508326975,-1.16410278167,1.78323176333,0.286574593667,-1.78992615167,2.21483756833,-1.50287297167,2.24022191167,-0.116573312967,-0.8295252875,1.11751153167,0.379767637333,0.471456657667,-0.107332386333,-0.3347001235,-0.176906848667,0.008287613605,0.0796490349833,-0.063393563,0.5972537705,-0.5508696375,0.5254781585,0.0272984203862,-0.300124365333,0.228142906,0.0133205573183,0.794683763833,-0.013983522155,-0.159150845,0.649823799333,0.0787320668667,0.198526028167,0.163985195333,0.0424701473],[-35365.89135,-3954.77608833,-2484.14174167,-3292.704405,745.307956333,-25.9074490833,-697.661457333,-2157.14851833,389.357659667,-466.006442,397.672771667,104.578828483,1187.85782667,-1722.25082333,-663.6052555,280.594835667,-500.8647565,-374.298517167,-345.8280195,-51.9999293667,-126.07303625,-506.146494333,182.113223333,-620.771299,-35.2244566,-193.932360833,-24.8302389,-170.9678285,51.0027839167,-110.423082167,-60.0444331833,39.90697295,-621.3418005,242.525484333,-22.1508046367,-21.7480230667,-12.0288267,62.6528008333,-23.3065290167,61.8014658,-43.7001806833,14.8758976667,47.5815877167,-111.964863,20.4635752833,47.3793421833,28.2070349167,-65.1436885333,1.0762110045,11.6614802,13.2611919667,3.16561756833,22.6689462833,-2.75010976333,4.653390125,17.2542018,-11.2238327,17.062818,-5.66110699333,29.7051109833,-12.2436797167,8.02487881167,3.95132596167,-0.568279933667,2.71802046667,-1.21511865667,0.299186161717,5.87333465833,-0.7667547685,1.73461481833,-0.00645340257333,1.190844475,3.747993625,-4.986174055,9.64416039667,-6.71041347833,9.89066046,-0.702866815333,-0.934439244,3.369196125,-0.774891031,-0.266574785167,-0.568477247,-0.218310860833,1.20351223333,-0.506396678667,1.48570841667,-1.26280730333,1.716906255,0.299266339333,-1.82266887333,2.26026937667,-1.53257831667,2.38808209167,-0.0809339231833,-0.861498798333,1.05512134167,0.318371823833,0.457743980667,-0.1002581201,-0.297671736833,-0.130923318883,0.02273842272,0.0605243451,-0.0326808499183,0.586471003333,-0.567610557,0.5011389435,0.0555273987833,-0.309311194667,0.264777604167,0.00403805635667,0.837851003333,-0.0251499811167,-0.174661679,0.646105828167,0.0694093017167,0.195030099667,0.1887414775,0.0526298676],[-35659.70775,-3951.24982667,-2802.68039333,-3282.51838667,533.187495,-35.7904588333,-649.402711,-2495.06422167,354.779820167,-543.4387665,442.154362333,68.7430496,1188.32993167,-1595.215295,-628.650524333,274.556957833,-519.666607333,-353.323380667,-320.214297833,-25.4874509633,-97.0259413667,-493.551431,174.9113295,-613.908570833,-33.43012805,-196.638551833,-28.0507739667,-165.6691835,59.9870039,-122.593096833,-63.4669801167,43.5263035,-608.009627667,242.396955667,-8.81724801667,-20.65188045,-13.3196768167,58.7656907833,-25.4745846167,63.4565704667,-48.70304235,12.7856464333,49.4651648667,-107.563638667,19.5163026,49.79210475,25.4906517833,-68.5764289667,1.20437849833,10.9307440833,11.95645265,2.18623704,22.3183673,-3.99414214167,4.22457723833,17.1447017,-10.5847222,16.3448585167,-5.089784175,28.6447727667,-13.59705515,8.46752862167,4.75177782667,-0.609421575,2.56118457833,-1.46468691167,0.0627784010333,5.62313631,-1.01865312833,1.66395615167,-0.227953578768,1.08535414017,3.54655949667,-5.00789528,9.40996654833,-7.02651987,10.0249639267,-0.515168898333,-0.8708827195,3.13052734167,-0.785533604333,-0.233968836333,-0.531406221,-0.242085136,1.13723330667,-0.477426563167,1.46093834333,-1.35793725833,1.63584087333,0.309768091333,-1.84144917333,2.30340845667,-1.54981060333,2.50382188,-0.0452361172167,-0.879968219833,1.01208130667,0.262998146667,0.427800743167,-0.09350137425,-0.262529607333,-0.0879389799333,0.0406244241667,0.0410632649667,-0.000208679573333,0.5722910125,-0.582959989667,0.472505811167,0.0840843795167,-0.320667087167,0.301237893667,-0.00206522506,0.8753194235,-0.0382284648333,-0.191271382,0.646719058,0.0643904566833,0.184293369167,0.209629424,0.05998775],[-35903.8461833,-3921.01145,-3105.12857667,-3244.69165833,338.713255833,-18.2654404833,-594.900810667,-2829.71740667,330.137300167,-622.525298833,489.124452333,42.4942826833,1186.68426667,-1462.652685,-584.612147167,270.3490155,-539.442231,-332.2304295,-291.432863667,4.93474136333,-68.10040495,-478.020851,169.3391155,-598.1261375,-31.2244228833,-198.674392333,-31.47541025,-159.771136333,70.25346885,-133.732304333,-67.1825560667,47.4609516333,-589.914848833,242.862072833,5.41130536667,-19.6593404333,-14.1818428167,54.6756622,-27.8299673,65.0381537833,-53.3143815,10.365573145,51.0175164167,-102.291498667,19.17152415,52.7444139667,22.4210801,-72.24035225,1.22485214667,10.3220142217,10.68378643,1.10551055118,21.85118245,-5.19019151667,3.78563787167,16.8948453333,-9.89277816,15.6670037833,-4.13945665167,27.3732201667,-15.1133187667,8.71610375667,5.63034416167,-0.659009251667,2.42135559667,-1.67756672833,-0.152905809783,5.336088585,-1.27113210833,1.61336903833,-0.453611425667,0.957762211333,3.33516073833,-4.91331102333,9.15621641833,-7.344789705,10.03638142,-0.29541622995,-0.7666581775,2.91720479167,-0.789923446167,-0.204584776167,-0.496051327167,-0.245632133667,1.06441910517,-0.449249266833,1.434417,-1.44309788,1.54140530667,0.318770663,-1.84613036667,2.34578733667,-1.558032245,2.586612025,-0.0150650315067,-0.881513102167,0.989070303667,0.2143437415,0.384160723167,-0.0865251970833,-0.229890314833,-0.0487779805667,0.061807047,0.0220408699467,0.0326638135483,0.555016579167,-0.595639889833,0.4403927475,0.1122479731,-0.333860073833,0.337679554167,-0.005757937175,0.9066885405,-0.054084288,-0.207287301667,0.652213025333,0.0638013899,0.1675052445,0.226277746833,0.0645962617333],[-36104.14835,-3871.70935167,-3380.30988167,-3181.18766833,166.614963267,27.33809405,-525.5419175,-3144.964595,315.544869,-700.982159833,534.382063333,29.7511060167,1183.539385,-1326.42766833,-536.318946833,267.672625333,-559.553285,-312.461659167,-259.685790167,38.4085253367,-40.0718064167,-461.226385,164.195484333,-574.465786667,-28.67506055,-199.942428333,-35.0853361,-153.396768,81.2669238167,-143.638137333,-71.2492620333,51.1237561667,-567.5102535,243.892282833,20.2176062633,-18.7555356833,-14.6277711,50.4763283667,-30.2987657333,66.3834937,-57.4105112167,7.657952115,52.1623859833,-96.3397953,19.4771614833,56.09750025,19.1129645333,-76.06237255,1.13994794833,9.83421819,9.47253503667,-0.0412654502667,21.2589489833,-6.29322312333,3.331708855,16.52738425,-9.18201101333,15.0502897,-2.85893253333,25.9406348667,-16.7744640667,8.79602728167,6.548415945,-0.717944804667,2.30141748833,-1.84641414167,-0.342063176167,5.01904659333,-1.50932137667,1.578305275,-0.6674896885,0.808839579167,3.12454670167,-4.71258555333,8.89915224167,-7.66630266333,9.936439415,-0.0582542758,-0.626270809,2.72784917,-0.788081346167,-0.178523385,-0.462221326667,-0.229411422833,0.987717858167,-0.4204746525,1.4059823,-1.51235424167,1.43577166667,0.328952199833,-1.83691596333,2.39020591167,-1.55987967,2.63807118833,0.00510841555667,-0.865104625667,0.985009448667,0.172869587833,0.330780582833,-0.0793210170333,-0.200402045333,-0.0142044112667,0.0855190744333,0.00444203457,0.06503938995,0.535229099167,-0.604343940833,0.406015600667,0.140245883,-0.348195207167,0.374496244167,-0.00757026380167,0.931889939833,-0.07327191975,-0.221573292833,0.662606553667,0.0676788555167,0.146345683333,0.2388590805,0.06651930305],[-36255.9151333,-3841.77500833,-3691.364295,-3111.55588667,17.4064112333,95.67863005,-455.860488167,-3409.80332333,306.000226667,-775.028055833,576.719793167,27.8318471833,1181.63372833,-1182.65937833,-490.635061667,266.037043,-578.818544667,-294.457221,-225.989383167,73.4885327,-11.8699128667,-445.250451,158.081774333,-543.071337,-25.5758705333,-200.375329333,-38.8258483,-146.5003895,92.1997087833,-151.883647333,-75.6594395,53.9514500333,-540.993489167,245.441053667,35.0727968167,-17.8426922333,-14.7213199833,46.2022794667,-32.6916545333,67.3023034667,-60.9186838,4.74741400833,52.8606542,-89.8770138167,20.3931003833,59.6398627667,15.59627405,-79.9970712333,0.956381875833,9.457913315,8.336693185,-1.19620415882,20.54379695,-7.289702155,2.86034437333,16.0722703833,-8.493035175,14.4686507667,-1.30641760167,24.37955425,-18.572571,8.765200565,7.50137725667,-0.790274839833,2.20640389833,-1.96295836333,-0.5013327465,4.68142551333,-1.72518489667,1.55173989,-0.8560144605,0.636822998167,2.914116325,-4.41489295667,8.65871847,-7.99523939333,9.749948125,0.196485963717,-0.459513490333,2.55100222,-0.780742784833,-0.154859452,-0.428566475833,-0.196381923667,0.909332337833,-0.3898482675,1.37487072333,-1.56136560667,1.32096253167,0.3429018695,-1.813530345,2.44246328,-1.55855371,2.66222471833,0.0144423324767,-0.832582956333,0.994272501333,0.138617210833,0.272966664667,-0.0718977890333,-0.174650500167,0.0151150594667,0.110424331583,-0.0109734641367,0.0964571457333,0.513517891333,-0.608050877833,0.370685440667,0.1692899725,-0.36307393,0.412650332667,-0.00794385622,0.950709738833,-0.09592444155,-0.234054709,0.676849477833,0.0758452783333,0.122844448233,0.247923341667,0.0655769542833],[-36367.5559333,-3842.062095,-4048.81150333,-3049.43286667,-106.512519567,183.0416951,-389.610753167,-3610.19235833,299.118895333,-841.922684333,613.004507667,35.6650393667,1181.63855333,-1032.16980183,-453.170509333,265.570048833,-596.628177,-279.664492,-191.138982333,108.851778017,16.4706493833,-431.964254167,150.198366667,-503.739406833,-21.7918351167,-200.038293167,-42.9187856833,-139.193488167,102.456295517,-158.37277,-80.5430882333,55.5503770167,-510.523942333,247.464842667,49.4326610833,-16.8885076833,-14.5085925333,41.9067704167,-34.9153296333,67.6775416333,-63.7807222667,1.68165846,53.0910070333,-83.0014417833,21.8586276333,63.1714578833,11.9071610517,-84.0301907333,0.674652225833,9.19857389,7.314984205,-2.31496501833,19.7040002833,-8.14421624,2.37436522167,15.5561746167,-7.85818995167,13.91052315,0.460144916667,22.72379285,-20.51110735,8.66657297833,8.486431515,-0.878632632333,2.14368999667,-2.01474482833,-0.625141302333,4.32692881167,-1.90566008167,1.53092200333,-1.00688372117,0.4346348155,2.70534746167,-4.028467535,8.44830605,-8.34513028333,9.497714485,0.469399595667,-0.27259638095,2.37917172,-0.768191213833,-0.132564266,-0.393346700167,-0.147817387983,0.8305845425,-0.355554555333,1.341328935,-1.58579213,1.19705841,0.361859679,-1.775194065,2.50618282,-1.55948869167,2.66203208167,0.0141888475717,-0.784961099167,1.012541399,0.11172700195,0.213964220167,-0.0640218019167,-0.153256939167,0.03841009245,0.135860841667,-0.0235057782833,0.1264255132,0.490344665167,-0.605644261833,0.335257633167,0.199981319333,-0.377883838667,0.4527198705,-0.00746938221333,0.962974552333,-0.121688345767,-0.244214345,0.694152395167,0.0881945860833,0.0981447078667,0.2537285815,0.06196952425],[-36445.0955333,-3843.98714833,-4420.28290333,-2999.66086,-201.329809833,286.406562333,-318.510198667,-3752.475845,294.163941333,-901.702160833,639.459550333,55.4467332833,1181.02371167,-876.526078667,-424.452869833,266.503305333,-613.412243333,-269.856685167,-154.743565167,143.269428833,44.918015,-421.733050667,140.033299833,-457.5052635,-17.3040050167,-199.136516667,-47.7474185,-131.514311833,111.742470833,-163.212462667,-86.02505455,55.6455304667,-476.720249,249.922399,62.95948725,-15.8893525,-14.0057777833,37.63796465,-36.9893148167,67.4876682167,-65.9863665167,-1.56398006667,52.84926085,-75.8079731,23.8209274667,66.55407055,8.12852721,-88.1734267667,0.305366173833,9.07117202167,6.45061785833,-3.39336583333,18.7416020667,-8.82162092333,1.866853855,15.00404395,-7.28890772833,13.39269545,2.37959469667,21.02194685,-22.5931639833,8.52255311833,9.49995702,-0.982962927167,2.119204335,-1.991332715,-0.7131786545,3.9571699,-2.03790918833,1.515604305,-1.10927878333,0.199042285617,2.50626308667,-3.56604480667,8.27665421,-8.729507435,9.19524413333,0.7579120445,-0.0655579853,2.20744924,-0.751718961833,-0.110811856683,-0.354891567667,-0.0839610411633,0.752935024,-0.315369941667,1.30687198,-1.58205281667,1.06422775817,0.386697745167,-1.72191628667,2.582500835,-1.56712485833,2.64045457667,0.00565151080667,-0.721749410833,1.03644305,0.0911992774,0.1551639947,-0.05583676305,-0.136457602167,0.0553218989167,0.162107970333,-0.0325400839333,0.154750154167,0.466236912833,-0.596349032667,0.300149072333,0.232269909167,-0.3918573515,0.4946834375,-0.00652992973333,0.969224125,-0.150360822667,-0.251137398333,0.713789501167,0.104246037967,0.0727480141667,0.256650865667,0.0563810612167],[-36489.1891833,-3834.173505,-4772.743855,-2954.20981667,-268.1190555,406.775951333,-240.939053167,-3846.19419167,294.324131,-955.264114333,655.146614667,87.1148205833,1176.549775,-720.505400333,-402.411151667,269.567396333,-629.466382167,-265.805433667,-116.773504817,175.721793167,72.1686215167,-413.920723833,127.7320335,-405.982715333,-12.169173605,-197.733107333,-53.5411742667,-123.529136333,119.975633667,-166.789564333,-91.9943269667,54.2217781667,-440.335752667,252.717594833,75.3682015,-14.8990585167,-13.1934239333,33.4169281167,-38.9434966667,66.8044047,-67.5576901333,-4.96900804833,52.166553,-68.3879246333,26.2187772833,69.6490134833,4.26684796633,-92.4172734667,-0.156252465167,9.08844412,5.76403072,-4.43297019167,17.68677745,-9.28830350333,1.3408140785,14.4287626167,-6.77934183333,12.9284353333,4.38273966,19.2759793167,-24.80737705,8.35894675333,10.5439406667,-1.1052593805,2.13480647,-1.88871036,-0.766262100333,3.57851700333,-2.10947193167,1.50779557,-1.16109877833,-0.0661150617,2.322561125,-3.04467578667,8.13518565167,-9.15410134,8.85972248333,1.06327099717,0.161989194717,2.03151143,-0.732561609,-0.0899211622667,-0.312019655667,-0.00493646187,0.677214130333,-0.2673703755,1.27330391833,-1.54951813833,0.923887300833,0.416798783,-1.65469353333,2.66832068833,-1.58334633167,2.60135621,-0.008216573765,-0.642423289167,1.06276326167,0.074600879,0.0966518500167,-0.0473560605,-0.1245123925,0.06587950915,0.189591637833,-0.0382281232167,0.181200013,0.441669538167,-0.579993789833,0.265734789167,0.265355944667,-0.404192269167,0.537972438167,-0.00504165735667,0.970112087333,-0.181230488,-0.253996043833,0.734860504,0.122600153167,0.04641220255,0.257151395,0.0497321895833],[-36497.2102167,-3791.511445,-5065.67009667,-2900.165285,-307.9201845,546.167444167,-155.192376167,-3906.009615,303.711376667,-1003.7123845,659.0090555,130.169666267,1163.91820333,-571.394258167,-384.264447333,275.3923595,-644.997349333,-268.1920075,-77.50983955,205.270427833,96.1151104,-407.491897667,113.65495845,-350.4513315,-6.52223596317,-195.819213833,-60.4493054667,-115.390339667,127.163822667,-169.5764885,-98.1784633,51.36980875,-401.9767785,255.833190667,86.3417852167,-13.98404105,-12.0374718667,29.2836222833,-40.8101421333,65.7221515333,-68.4978048833,-8.46851155333,51.1001936667,-60.8130431333,29.0246084833,72.2892753667,0.286337700333,-96.7565709667,-0.713576275667,9.261152405,5.27471913667,-5.42870926,16.57235355,-9.50389576833,0.8048942775,13.8449737333,-6.324971355,12.53228955,6.39129210333,17.4618586667,-27.1409209667,8.19852099833,11.6241261833,-1.246265365,2.19064565,-1.705094255,-0.782853532833,3.19678582833,-2.10792999667,1.50808807,-1.16176088833,-0.35750859655,2.15728306667,-2.483015525,8.00613294,-9.62113166333,8.50724581833,1.38947185,0.411292582,1.84822287167,-0.711720865667,-0.0706000685833,-0.264335782333,0.08921969107,0.603736843,-0.210255551833,1.24150868,-1.48843417833,0.777635258167,0.450367925667,-1.574320585,2.7584391,-1.60849572833,2.548812185,-0.02338171188,-0.545955688,1.088611575,0.05940354575,0.0379067690833,-0.0386287890667,-0.1176894845,0.0700533202667,0.218542727333,-0.0409004016833,0.20534821,0.416957561167,-0.556613744833,0.232545218,0.298157681333,-0.413862646167,0.581822176,-0.00259088941667,0.966383504833,-0.213269055,-0.251804011,0.756328277,0.141672425,0.0185689273667,0.2555907865,0.04290774815],[-36462.8665333,-3702.914865,-5287.66238333,-2835.607815,-323.327048167,700.130037667,-61.7689123167,-3939.20401167,321.600291333,-1047.79333,650.208158833,183.5299925,1141.46933167,-433.2534165,-365.5797665,283.590896333,-659.940784333,-276.927694167,-37.144923905,231.493350167,116.02693985,-400.697068833,98.1036967833,-292.592323833,-0.494597101,-193.3487505,-68.3396330833,-107.102934067,133.280911,-171.684761667,-104.1408428,47.1925091167,-362.431725333,259.187428,95.6337479167,-13.1314938167,-10.5326247583,25.30926125,-42.5603217167,64.2735097,-68.7754502833,-11.9957037967,49.7239738,-53.2125077667,32.17365655,74.3389893167,-3.82533140533,-101.14844175,-1.34318821633,9.58088570333,4.98825219667,-6.36623569167,15.4106852833,-9.44485000167,0.252892992167,13.2747708167,-5.925510365,12.2023482333,8.33974675167,15.5669058167,-29.5570481,8.06305209833,12.73709125,-1.40338284167,2.281543415,-1.44662185167,-0.764596044833,2.81520897333,-2.02949879333,1.51080123167,-1.10873161667,-0.666980807833,2.01044917167,-1.89574817167,7.87587132,-10.1220902833,8.15436753833,1.73566423,0.682320348167,1.65565335333,-0.69099434,-0.0539074433667,-0.213139775333,0.195915090367,0.5334489275,-0.144524239367,1.211181805,-1.39892195833,0.629477505833,0.4862430665,-1.48057016333,2.84872372333,-1.64003568833,2.48783846833,-0.0375377598,-0.432198576667,1.111492605,0.04337902465,-0.02118671395,-0.0301816817,-0.115901724,0.0679316442,0.248398345,-0.04047099495,0.226752795333,0.392507610167,-0.526323597,0.2016174235,0.330212063,-0.419665324,0.625675402333,0.00153348455333,0.959146752,-0.245792576,-0.244003322667,0.777109634,0.159964239833,-0.0109880471833,0.252347439,0.0366264285167],[-36378.8354,-3549.437015,-5451.89213833,-2767.68615,-314.484214833,858.498886167,41.2674780667,-3949.46488333,343.656762833,-1087.62702333,627.691250333,247.321197833,1108.55441167,-306.644644333,-341.215588833,293.093355833,-674.208491333,-291.561267833,4.58590564667,254.0810515,132.516962167,-391.544279333,81.5287943333,-234.409695667,5.79360494683,-190.349039,-76.9566905333,-98.5440381167,138.238422667,-172.902486667,-109.436376167,41.8846142333,-322.602318833,262.661752,103.036093967,-12.2801888,-8.71916291333,21.5716867,-44.1487072,62.4511734333,-68.3262746833,-15.5110071667,48.1446007,-45.74598455,35.5974174667,75.6805418333,-8.054568335,-105.5048765,-2.00682677,10.0239494833,4.90296272333,-7.23723984333,14.2032878333,-9.09758361833,-0.334980997833,12.7495895667,-5.58224050167,11.9383366667,10.1717570783,13.5914446833,-31.9964963,7.97687721,13.8736761167,-1.57198941,2.39978771,-1.12230454617,-0.7175982095,2.43581764333,-1.875670895,1.50666894833,-0.997225795833,-0.984230536,1.884446255,-1.29462835533,7.73569836167,-10.64040945,7.81886067667,2.09843274,0.974354733167,1.45203216667,-0.6723443165,-0.04063486365,-0.16021737,0.311004847,0.467590284167,-0.0718604685383,1.18156341167,-1.28081127667,0.484202933667,0.524451349,-1.37260697,2.93641369167,-1.673745675,2.42416258833,-0.0491733185333,-0.301300672,1.12905098333,0.024285611933,-0.0802328090833,-0.0226943975833,-0.118736630167,0.0596791123333,0.27827027,-0.0366554329167,0.2448541205,0.368817032667,-0.489278002,0.1740760755,0.361401213833,-0.4203740395,0.669276605167,0.00809798859167,0.949705590167,-0.278219718167,-0.230136315167,0.796146681833,0.1759509175,-0.0420917151167,0.247828274333,0.03156761815],[-36241.2423,-3322.34757167,-5584.67145,-2699.44137167,-280.721460833,1011.15639367,154.628755017,-3943.79623,367.677269833,-1122.061055,591.730926167,320.902805333,1062.97502,-192.717504617,-308.081247333,303.34064,-687.371795167,-311.148607833,47.6521865783,272.389483167,145.7742815,-378.5847115,64.79970385,-177.593768,12.23376161,-186.8269905,-85.9871155667,-89.6409569833,141.966833667,-173.164519,-113.651186833,35.8366162667,-283.261707167,266.138136667,108.290301667,-11.4119513333,-6.64801352333,18.12786,-45.5228687833,60.2934889,-67.1225998,-18.9492560667,46.5138388667,-38.5571881333,39.23458495,76.16882045,-12.3969625233,-109.7118165,-2.68333558,10.5651708833,5.00710138833,-8.0272907,12.9696113167,-8.454786995,-0.968610442,12.3009628667,-5.2984911,11.7409413333,11.8225931333,11.5295728667,-34.3927594833,7.97043470667,15.0234118333,-1.749529695,2.53853031,-0.742727028167,-0.646353153667,2.06329250667,-1.64758185667,1.48814297,-0.826988825667,-1.3003630325,1.78183144,-0.694201016667,7.574513445,-11.1586578333,7.52025660833,2.475118675,1.28372832917,1.23424558333,-0.656979290833,-0.0313605662167,-0.107235729783,0.430460144667,0.406718264667,0.00660866231333,1.15196755333,-1.13604460283,0.346082991,0.5649815855,-1.25054352833,3.01793483333,-1.70593606667,2.36386689333,-0.0560820158167,-0.154518010313,1.13819528167,0.000197132632,-0.1382791624,-0.0164478548833,-0.1258726135,0.04561192845,0.307212589833,-0.0296447923667,0.259243858167,0.346355496,-0.446110050667,0.150898449167,0.391494827,-0.415016751833,0.7121666965,0.0175202505567,0.939350328,-0.309669167833,-0.209916868667,0.81205244,0.188201338833,-0.0743418262333,0.242466400167,0.0282737102333],[-36067.1395333,-3078.505445,-5748.30975167,-2635.84704333,-227.172794667,1149.04673833,267.135655667,-3922.38596833,393.826224333,-1146.776925,546.9386955,397.806481333,1002.972982,-95.9612452667,-270.387738167,314.980176667,-697.809582333,-333.219421333,90.1979688833,285.264875833,154.293531833,-362.430867,48.8723307833,-123.0435217,18.92630195,-182.654281833,-94.9223547333,-80.5764422,144.265642833,-172.966385,-116.542880833,29.50980955,-245.0235545,269.549426667,111.023469667,-10.5479843433,-4.37982067833,14.9880821667,-46.56935415,57.8750100167,-65.2832846333,-22.1758919,44.9948770667,-31.8308486667,43.0180835333,75.6161067833,-16.8604923333,-113.6661485,-3.38189489667,11.1814728167,5.26051315167,-8.67924885667,11.7599571333,-7.53866272833,-1.62986768,11.9487009333,-5.10449373333,11.5942462833,13.2140393667,9.37775341,-36.7022832833,8.09020534,16.1658390833,-1.939349445,2.69435066333,-0.324584208,-0.545431557,1.71006283167,-1.34851832283,1.45262671667,-0.607906495167,-1.61128729,1.69866675,-0.1164793585,7.38500133,-11.67327415,7.282889275,2.85961945,1.597493495,0.999292619667,-0.6455662615,-0.02636766765,-0.0560019051767,0.5504873105,0.351394433167,0.0911349374617,1.12251526833,-0.970799158833,0.2196538375,0.606800480167,-1.11836355617,3.09084165833,-1.73834405167,2.31374171833,-0.0565880439667,0.00315509491333,1.13620856833,-0.028444313667,-0.192851959833,-0.01119342469,-0.137487301167,0.0264621680433,0.333760788167,-0.0202270541983,0.270252358167,0.325870133833,-0.398388138167,0.1332988895,0.420313077333,-0.4039407335,0.753857923167,0.0287722841667,0.929411265167,-0.339209292667,-0.183721389,0.823610948,0.196474153667,-0.10675472495,0.236678186167,0.0266335048833],[-35878.0924667,-2912.39881667,-5996.88591833,-2583.35498333,-165.631531167,1266.03931833,367.5768055,-3883.989185,422.491858167,-1157.00634167,498.741878167,470.571646,927.3298795,-22.6994440667,-234.346481667,328.951921167,-703.351164667,-355.0999125,129.854668367,291.697445333,155.990306333,-344.273680167,34.4523629833,-71.2282989333,26.0683200333,-177.554059,-103.231224117,-71.6170399667,144.958048333,-172.89482,-117.932532167,23.21219435,-208.410967167,272.863336333,110.809852833,-9.70090383833,-1.954838687,12.15300754,-47.1501460167,55.2738816333,-62.9417360667,-25.0471195167,43.6889332667,-25.7729555167,46.8861678167,73.8266028,-21.4515093833,-117.263462,-4.11677414833,11.8506418667,5.61816483,-9.11889695167,10.6258794033,-6.37774315167,-2.29648783333,11.6960165,-5.04340338667,11.4755423333,14.27243465,7.13593907667,-38.8863679333,8.37844877667,17.2714073167,-2.14702422,2.863454015,0.114455170333,-0.405284191667,1.38871397167,-0.983285757667,1.39816252333,-0.352471204917,-1.91445908333,1.62745431667,0.4182242685,7.162078865,-12.18357,7.12775904833,3.24161956833,1.90072358,0.7472154525,-0.6391806795,-0.0262982880667,-0.00834973145667,0.667401836333,0.302066364833,0.182162966467,1.09355251833,-0.791284504167,0.109968925217,0.648024794333,-0.980190671167,3.15325494667,-1.773963475,2.27931429667,-0.05035229585,0.16592970552,1.12184558,-0.0599239183333,-0.241576429167,-0.00670525684833,-0.1539662735,0.00304754410667,0.356213679833,-0.00923291048167,0.278490116167,0.308256956,-0.347516711333,0.122721466167,0.447596369667,-0.387772851167,0.793850363333,0.0404446113667,0.9208521745,-0.366185836667,-0.152103324833,0.829979105667,0.2011251765,-0.138372879667,0.230626641833,0.0262525360333],[-35693.6742833,-2887.47506333,-6339.42032,-2547.872685,-105.77136155,1363.10733833,451.225216333,-3828.47979167,452.931257833,-1150.46036833,451.772719667,534.3703135,835.998169667,22.4205618333,-202.562993833,345.582027833,-702.704101333,-374.6682115,164.926562333,291.450948333,149.397437167,-324.461399667,22.3330769,-23.2294823667,33.78287385,-171.320137167,-110.475357333,-62.9958056167,144.004547333,-173.4087105,-117.660544167,17.2038894333,-174.0193395,275.856319333,107.515629,-8.83831321333,0.616954497,9.624181295,-47.1820997667,52.5329467167,-60.2310562667,-27.4757103833,42.6512079333,-20.5455401333,50.7351058667,70.71894755,-26.0929213,-120.3873475,-4.879561285,12.5594511,6.03894438667,-9.295840825,9.59526983167,-5.00991419333,-2.95690772333,11.5315741833,-5.13549841167,11.3643546333,14.9509028667,4.831218985,-40.89871355,8.8555124,18.2982969167,-2.37499374667,3.042747045,0.557871620667,-0.21930926047,1.10770651833,-0.559476453933,1.32362558667,-0.07442875,-2.20440126667,1.564509995,0.893210022833,6.90345621833,-12.6847464833,7.06677494833,3.60566291167,2.18104422833,0.482762407,-0.639939932167,-0.0315642985167,0.0342298824233,0.778690296833,0.2598431605,0.279819150833,1.06580299667,-0.603059034,0.0207681207333,0.687321188667,-0.839923859167,3.20222031667,-1.81465209667,2.26427028333,-0.0383322679,0.328712891667,1.09593812167,-0.09275507565,-0.283157061167,-0.003348056365,-0.175486463667,-0.02368947404,0.373501729167,0.00299912604833,0.2846329665,0.294280383333,-0.294607795,0.119959440667,0.4727915175,-0.367171551667,0.831190894333,0.0512297865667,0.914428086,-0.390069998833,-0.1157158483,0.830800337833,0.202498743167,-0.168619248667,0.224467652667,0.0269944306833],[-35526.9204667,-2962.33227167,-6695.85832833,-2518.37464333,-44.61887985,1453.27461833,516.891747,-3769.751925,487.164786,-1129.96563667,407.394598,587.220888167,727.508837667,36.5088961833,-171.725648,364.3797925,-696.827867333,-391.5667105,194.783749667,285.29985,133.419046333,-302.179934,13.5753132183,18.5715219333,41.7838337333,-164.000159167,-116.517247833,-54.8809780833,141.7332285,-174.958085333,-115.710867,11.8033925517,-142.598945167,278.060650833,101.5542427,-7.95842425333,3.38286314633,7.42023299667,-46.6930475167,49.6995977833,-57.2933807667,-29.4783469,41.9267696667,-16.2099932667,54.4232658667,66.3902666833,-30.56902835,-122.974872167,-5.638094835,13.31482955,6.50353223333,-9.20917685,8.66917189333,-3.46997068667,-3.60595575167,11.4367493667,-5.35345401833,11.2557160167,15.2259786333,2.53340988283,-42.7076151667,9.49941996667,19.2021636667,-2.61806240333,3.22990418833,0.9949708365,0.0129107314533,0.869503252667,-0.0815625742333,1.23485242167,0.211448775083,-2.47160346,1.51546342,1.28937459617,6.60967857333,-13.17059955,7.09627394833,3.935054555,2.43444765833,0.215666826833,-0.649895750833,-0.0425815821167,0.0711649665333,0.8842755055,0.226550232167,0.3847602715,1.04143130333,-0.411537957833,-0.04770185705,0.724722246333,-0.702382947,3.23259144167,-1.860558135,2.27012388833,-0.0220295283383,0.489082667333,1.061377865,-0.127005027433,-0.318185852167,-0.00193809136,-0.201828632833,-0.0527373905,0.3858273785,0.0166821928117,0.289142428667,0.284213506833,-0.240732009167,0.124392366333,0.4948711865,-0.342580481833,0.864287892667,0.0601690600667,0.911123661,-0.4104759505,-0.0751667063,0.826133471833,0.2004741265,-0.197571857333,0.218637082,0.02937446195],[-35382.0205,-3089.22098833,-6970.625745,-2475.45057667,18.3203137167,1550.48683333,558.4776195,-3716.07745167,528.244528167,-1101.23858,365.4162385,627.557378667,603.258871667,22.4521801,-137.717439567,384.280957167,-687.397592167,-406.019117833,219.778723667,275.12228,108.830836467,-276.800501333,8.183673335,50.3649775333,49.5365408,-155.6091355,-121.2884385,-47.1200045333,138.6759475,-177.668204333,-112.336314667,6.89211121,-115.318914233,278.871147167,93.8543559833,-7.07816166167,6.43891124,5.57007444667,-45.69734545,46.7950488,-54.2611832833,-31.1606372167,41.4405393667,-12.8553916167,57.7536716833,61.1430220333,-34.55997575,-125.0339585,-6.34585840333,14.1250851167,6.997181695,-8.88181838833,7.82296614167,-1.80299676947,-4.24386330333,11.3732576333,-5.6488116,11.1342869,15.1214729167,0.360484604667,-44.3038732167,10.2593134317,19.9371329667,-2.86594064167,3.41748735833,1.41558085117,0.283833394197,0.671029932,0.4437636624,1.142811795,0.490850524833,-2.699798115,1.487028525,1.59368364,6.294564925,-13.63627135,7.20026618333,4.20827084,2.66088364833,-0.0429511991667,-0.670784278333,-0.0609473336667,0.1020541813,0.983558845167,0.204389968167,0.4975499445,1.02392216833,-0.2207337101,-0.0952088860667,0.761518510167,-0.572004895667,3.24138680667,-1.910775775,2.29565496833,-0.00645204312333,0.645050874333,1.0220756435,-0.163523335667,-0.347628461667,-0.00350398189,-0.232451801333,-0.0829123107167,0.393745979,0.03250062575,0.292497173667,0.278095064833,-0.18650685,0.134908474667,0.513203368167,-0.314372056167,0.891677219,0.06657576175,0.911563067,-0.428352065667,-0.0317844405167,0.816513113,0.1948744895,-0.2252646615,0.213916037667,0.0340036854167],[-35258.05185,-3191.32551833,-7099.86797667,-2414.511035,92.3043689833,1661.813335,579.833758,-3675.36433167,574.17175,-1068.06524667,323.6709175,657.610941833,464.400098333,-15.2314261333,-97.86104325,403.5179005,-676.293364,-419.007048167,241.1350655,262.401991167,77.53314035,-247.729179667,6.23432579833,70.4492712667,56.5590717833,-146.524983,-124.933583,-39.4497247333,135.239923667,-181.2440085,-107.595227833,2.44205307833,-92.6751337667,278.0564695,85.1546122833,-6.170439875,9.747161775,4.07393773,-44.2280509167,43.8250301667,-51.1715285333,-32.5580335667,41.1502645833,-10.4701855283,60.6393342,55.2576259167,-37.8647333333,-126.6076265,-6.94461323833,14.9780527833,7.51417389167,-8.35830780667,7.025416845,-0.0498931862,-4.87039855833,11.31527265,-5.97881226667,10.99496375,14.6868309167,-1.6062612755,-45.6894540167,11.08612605,20.4885563667,-3.10356641667,3.60082445333,1.81601086333,0.577360487833,0.504120051833,1.0033253135,1.05043677817,0.754048641167,-2.87937818,1.48378062167,1.80632105667,5.97066102667,-14.0766576333,7.360196085,4.41656146,2.86166853833,-0.2838293885,-0.702420523167,-0.0857239910667,0.127889057833,1.07414594733,0.193821925167,0.616054292667,1.01347191833,-0.0334876200667,-0.1232355334,0.799032486167,-0.450472844667,3.22790110167,-1.96277005667,2.33761300167,0.00593557403167,0.795091499667,0.981700691833,-0.202291091333,-0.373158928167,-0.008820660915,-0.266052559833,-0.11308146305,0.3977669515,0.0510239728,0.294723963,0.275333627,-0.132387904017,0.149985748667,0.5278157985,-0.282973540833,0.912555488,0.0706852660167,0.915507488667,-0.444442529833,0.0130455885833,0.802722141,0.185877666667,-0.252109525833,0.2106066015,0.0411085160833],[-35166.1474167,-3182.29206667,-7040.81607,-2331.89929333,185.723856033,1788.413075,584.700069833,-3662.67682333,623.4493135,-1034.80877833,278.3246365,679.9157715,309.4675365,-71.3194441333,-50.7453896535,420.517572833,-665.501435667,-431.870117,260.153219833,247.944976167,41.7126333383,-214.823044667,7.82287907833,77.61024335,62.3997876833,-137.140106333,-127.622592333,-31.6059550833,131.757090333,-185.314194167,-101.639457,-1.471581385,-75.0117963,275.591621167,76.1666956833,-5.21506293167,13.27214528,2.94570494333,-42.32445805,40.8166090167,-48.0403295,-33.7130936667,41.0608022167,-9.02717260833,63.07629655,48.9970255667,-40.3162913667,-127.757325833,-7.38135174833,15.86341965,8.05737417167,-7.68693952,6.25460222333,1.7531277422,-5.48399094167,11.2524599,-6.30713982,10.8511676333,13.9696652167,-3.296822005,-46.8719334,11.9307197167,20.8582298,-3.31618761667,3.775382575,2.195183975,0.876575658833,0.36138775,1.58407623083,0.960922769333,0.994491821833,-3.00428153667,1.51292335,1.92742751833,5.65021903333,-14.4854094,7.55629389,4.55893671333,3.03966793667,-0.499384650333,-0.744062427333,-0.116071981883,0.149758519167,1.15366590667,0.1948567055,0.737742406667,1.01024850667,0.1473670419,-0.134145300667,0.838822746667,-0.3394708055,3.19213931667,-2.01294620833,2.39238535333,0.01479831958,0.938467038167,0.943548212,-0.243549647,-0.3963197565,-0.018490584595,-0.301359498,-0.142318517833,0.398435937167,0.0726290265833,0.295664230333,0.275314279,-0.0789954028333,0.1679879435,0.538745791,-0.248793817167,0.926356730667,0.0731309570667,0.9225943085,-0.4590593995,0.05820552165,0.785581474333,0.173491847667,-0.278463223167,0.2089512505,0.0508115404667],[-35117.9190667,-3046.616525,-6822.73842667,-2233.45493167,295.977453333,1918.21738167,581.022447833,-3676.433395,673.300953167,-1003.37295933,226.069160667,697.139125167,139.12236935,-139.868864333,-1.68066153067,434.4549735,-655.712317167,-445.251378833,277.520230833,231.613416167,3.56867827,-179.658776833,12.1717542667,71.9367234667,66.9360326,-127.738622667,-129.449789167,-23.5285112833,128.15017,-189.534203167,-94.6604563333,-4.95720100833,-62.3655977,271.8433505,67.36921795,-4.17825283333,16.9229803667,2.172486795,-40.01788575,37.767523,-44.8922488667,-34.5946620333,41.1850207167,-8.538636515,65.1733451167,42.5509767,-41.8804566333,-128.5171695,-7.62860982,16.7597551333,8.62282903333,-6.89346093167,5.51139251,3.56817187,-6.07447213833,11.18964635,-6.635873765,10.72097175,13.0140070833,-4.68573284167,-47.8485826667,12.7754244333,21.0603581833,-3.49648132667,3.93994460167,2.553459855,1.17044502233,0.242445711,2.17337282167,0.871813165,1.2081648315,-3.076366335,1.57490846167,1.960800395,5.34038114333,-14.85428925,7.77891364667,4.63950453333,3.19016432833,-0.689352527333,-0.7948659525,-0.149818767667,0.169489021833,1.21959463167,0.207202664167,0.860469242667,1.01248265833,0.318363863333,-0.129742761667,0.880650315167,-0.240094352833,3.135528995,-2.05812901833,2.45702867833,0.02082699605,1.07149572267,0.908024939,-0.286819528667,-0.416034683833,-0.0325683954167,-0.3372768015,-0.169734004667,0.3958388215,0.0971402624833,0.295322118167,0.277578219167,-0.02723691215,0.1878724455,0.546089864,-0.2126226835,0.933051502,0.0742688201833,0.931731277667,-0.472417334667,0.102131129117,0.765406805167,0.157919209167,-0.303645349,0.209241754667,0.0624752026833],[-35131.5737,-2800.42809833,-6511.61909333,-2133.39621333,417.949250167,2031.576745,581.875889667,-3706.10505333,719.320109,-974.060348667,163.8054448,712.504202667,-44.8134782667,-214.9310915,40.6201023632,444.706661667,-647.017970833,-459.481319167,293.6548365,212.581699333,-34.725589595,-144.693456,18.1550025167,54.3209984667,70.2232319833,-118.621505333,-130.488575167,-15.26940801,124.081874,-193.5235095,-86.8308353333,-8.16628641167,-54.5797028,267.361931833,59.0617597167,-3.01345920833,20.5486302167,1.72917914167,-37.3339091,34.65157365,-41.7381011,-35.1385092833,41.5454762167,-9.04946172167,67.0856792667,36.0501838667,-42.59726425,-128.890682,-7.67101344167,17.6357922167,9.20410155333,-5.99131913833,4.807095035,5.35935941333,-6.63190680333,11.1425102,-6.99129506333,10.6243514333,11.858532,-5.77166160167,-48.6066129833,13.6201652,21.1117716,-3.640003575,4.09536059833,2.89250500667,1.449998385,0.151317599483,2.758673305,0.776255408667,1.39310776833,-3.10272762,1.66651289667,1.91164731667,5.044805085,-15.1732748,8.02363227667,4.66400636167,3.30366783,-0.8569445115,-0.8536930825,-0.183916958167,0.1895014355,1.26876382333,0.230643270333,0.982014389833,1.01709320833,0.475938406333,-0.111703305083,0.923706484,-0.15326613255,3.060246805,-2.095647315,2.52888174333,0.0249946910333,1.18871720833,0.8739121325,-0.331005821667,-0.4299131915,-0.0507949401333,-0.372732461333,-0.194458570667,0.389666938167,0.1241485405,0.293693356,0.281850417333,0.0219218988,0.208911302333,0.550106917667,-0.1755250325,0.932871463833,0.0741838763,0.9413503655,-0.484635935333,0.143029135167,0.742149743,0.139530618,-0.326442151,0.2117116675,0.07504524945],[-35219.1033833,-2466.72771833,-6171.80257333,-2039.21768833,543.247044667,2111.91740833,590.860045,-3743.82246167,759.549191167,-947.7344955,89.642964585,726.330963167,-240.532421317,-292.566092667,68.6637497167,451.145305333,-639.258146667,-474.615083833,308.342729167,190.210138667,-71.7186249667,-112.01699905,24.5280987833,26.2316653583,72.36277445,-109.893815333,-130.7647635,-6.95965290667,119.299816833,-197.055476333,-78.2306187,-11.3347939217,-51.2968009667,262.775022333,51.43983655,-1.69014385617,24.0683488333,1.59252838333,-34.27818235,31.46301565,-38.6035138167,-35.2677422,42.1251481833,-10.5661015067,68.9714550667,29.5875526667,-42.5605406,-128.912849833,-7.504316255,18.4761085667,9.791310635,-4.97792485333,4.15430655833,7.09527841167,-7.145771875,11.1168489,-7.39667372,10.5728863333,10.5359102217,-6.57575572333,-49.1440023667,14.46093855,21.0410709167,-3.74581931833,4.24322371167,3.21256055167,1.71218373167,0.0913369188333,3.33018146333,0.667534263833,1.54603538333,-3.09113493,1.77911723333,1.78585136167,4.76162880833,-15.4339880667,8.28427879,4.643115205,3.3740346,-1.00636727317,-0.920090697167,-0.2163670145,0.211804109833,1.29946470333,0.264661504833,1.10095358417,1.02106528833,0.616738887667,-0.0815856743167,0.9655401465,-0.0791631783,2.96779546167,-2.12261636833,2.604705755,0.0290543822333,1.286325385,0.839387515,-0.375196882167,-0.435965782333,-0.0729700715167,-0.407141161167,-0.215731146333,0.379726646833,0.15318607,0.291014384333,0.287886312,0.0677472167667,0.2306156405,0.550844848,-0.1383065115,0.926018638,0.07322808765,0.949754421,-0.4958191425,0.179501696833,0.7156424745,0.118593942567,-0.34584552,0.216441373,0.0874769587167],[-35372.7668667,-2102.835025,-5839.6878,-1947.90092833,655.103512333,2163.506105,592.622809333,-3775.79386833,796.532086333,-925.825930333,8.76635562333,734.1781095,-442.434689833,-370.968360667,80.8023436833,454.751745,-631.826920833,-489.379704333,320.330127,165.10243,-106.810236167,-82.0433263667,30.5139879,-10.1482412667,73.5475952167,-101.389938167,-130.197178333,1.03319476167,113.888708667,-200.196918667,-68.6316439167,-14.7172381833,-51.7890820833,258.481568833,44.4245788,-0.231787354667,27.5133479,1.70929427667,-30.88425035,28.2854256333,-35.5610876833,-34.86259495,42.8440105167,-12.9316542,70.8712335833,23.1822852333,-41.9481105,-128.614429333,-7.15685469,19.2981157833,10.3599047183,-3.83977459833,3.58009633833,8.75478967,-7.59485021333,11.098921,-7.83295652833,10.5545025333,9.078964145,-7.15426115833,-49.4621260167,15.3088390833,20.8848449,-3.82149380167,4.38906438667,3.510802765,1.96438367667,0.0647124964333,3.88461364333,0.544846153833,1.66318102833,-3.043888015,1.90024927167,1.59684378,4.48251908833,-15.6345510167,8.56207837833,4.59123499667,3.40066436,-1.146478405,-0.994129742667,-0.246680448333,0.237285291333,1.31440349333,0.307482177167,1.21714782,1.02320884667,0.7390918075,-0.0399438472833,1.00246701917,-0.01467563465,2.85995662667,-2.137845615,2.68259493667,0.0350946651167,1.36398799667,0.8005713655,-0.419563084167,-0.432751778167,-0.0986214475833,-0.440900820167,-0.23335892,0.366605489167,0.183388887167,0.2877230205,0.2955469285,0.110056677167,0.253192761833,0.548144647333,-0.1008217574,0.913207703333,0.0721736049833,0.955591926667,-0.505987775,0.2111899905,0.685637931833,0.0950111411,-0.361212722,0.223383238667,0.0992734258833],[-35583.5621833,-1713.72429333,-5546.82608667,-1865.799985,752.4465065,2194.92842167,584.016781167,-3782.72707833,828.881020333,-907.590662167,-71.8993596483,736.532456167,-642.705254667,-445.786493,76.1285389333,455.447474,-624.636989333,-502.080882667,329.438864833,138.394282,-138.216610833,-54.9978383833,35.9421567333,-52.4700123583,73.76878535,-93.4061026167,-128.644067167,8.39114310333,108.032788333,-202.640854,-57.7546079667,-18.2606069667,-55.2330999333,254.8857395,37.8790148167,1.32238818717,30.75137965,2.02494108667,-27.25321905,25.2229468,-32.5980648,-33.7830356833,43.73383915,-15.9458508833,72.8472840167,16.8456985667,-40.9341874667,-128.005308833,-6.647252515,20.0861462,10.8819377667,-2.59972806833,3.11458692333,10.3269512367,-7.949617125,11.1094533667,-8.26815025,10.5772892167,7.52606884667,-7.55617842667,-49.5570530167,16.1840042667,20.6769712,-3.867498945,4.53692674667,3.78325084667,2.20279339,0.0731833943,4.41556622333,0.410371108833,1.74887970333,-2.96062293333,2.02618303333,1.36181874333,4.204724935,-15.7737253833,8.86300223833,4.52236316,3.3832261,-1.28741538,-1.073123473,-0.272505426833,0.2663447995,1.31408540667,0.3569003405,1.32762807,1.02301162667,0.842123216833,0.01330165085,1.03319741667,0.0445261352667,2.74121587167,-2.140738485,2.76228362333,0.04527109555,1.421995115,0.752934856833,-0.4642669775,-0.418672785667,-0.126685365533,-0.473485394667,-0.247345748333,0.350703609,0.213767945,0.2831471795,0.304724567333,0.148265897833,0.2770924745,0.542286094333,-0.0626427038167,0.896080086,0.07182512985,0.958102977833,-0.514976076667,0.238127956833,0.6518076855,0.0687500251833,-0.3718519335,0.232470202833,0.110035429717],[-35834.54975,-1320.924151,-5321.08254667,-1795.56675667,832.843976667,2213.18611667,569.263712833,-3748.81591167,856.074888833,-891.321117167,-146.489420383,735.809389167,-834.465433667,-513.710095333,52.0385154333,453.228365333,-617.14865,-511.275428667,335.699948,111.03729975,-164.325012333,-31.77032635,40.74522615,-98.3400615833,72.98184245,-86.1547814667,-125.977233833,14.7898885217,101.8803898,-204.009097667,-45.4700505333,-21.8945535167,-60.8143371833,252.336955333,31.6345568,2.91192364333,33.6481241,2.49719518833,-23.4834027667,22.3724133167,-29.6602659833,-31.9047068667,44.8200262167,-19.4283006167,74.9504327667,10.58201161,-39.6652924333,-127.0723325,-5.99911299167,20.8188392833,11.3343949333,-1.27649304267,2.78644187,11.81001415,-8.17912699833,11.1687629,-8.67929427833,10.6504420833,5.91550279667,-7.81894593333,-49.41883635,17.1015349667,20.4392714,-3.88421619667,4.6891538,4.02657875,2.42480723167,0.118304967017,4.917421025,0.266914784667,1.80886749833,-2.84320631667,2.15434459167,1.09802442733,3.92798939,-15.84987705,9.19007488167,4.44583738,3.31995733,-1.43656494833,-1.15395363,-0.291727897333,0.299249121167,1.29894474167,0.4107213895,1.42914528333,1.01992187833,0.925625167833,0.0778768296667,1.056690125,0.1024930023,2.61623800333,-2.13125393,2.84252806333,0.0607500678,1.46003779167,0.6930105025,-0.508740600167,-0.392434539833,-0.155967266167,-0.5043670725,-0.257773289333,0.332263364667,0.243367049167,0.2764880265,0.315265302833,0.181968759333,0.302746571167,0.533537322333,-0.0235300680167,0.876200312833,0.07276674715,0.9562833095,-0.522660863333,0.260240485333,0.614006301167,0.0401006150683,-0.377188684833,0.24343885,0.119323747667],[-36094.35235,-929.8926405,-5171.19166667,-1729.86792,895.8862045,2225.67383,549.441255333,-3670.411505,879.273738,-876.016724667,-210.450620333,734.150697333,-1013.03644883,-573.2781555,8.17088453333,447.874059833,-608.902742833,-515.8660025,339.407973667,84.1328071833,-184.1154185,-12.9548483433,45.3550412833,-146.032758917,70.9880000333,-79.7318248833,-122.073570333,20.0132298,95.6795229833,-203.994831167,-31.7796299667,-25.4568470333,-67.8827101333,250.929850667,25.56664025,4.45662730167,36.1155250667,3.10211761167,-19.6602284667,19.8165403667,-26.6879118167,-29.1690843833,46.1049565,-23.2029425333,77.1462460667,4.39782022833,-38.2273327333,-125.797349833,-5.23002027833,21.4771114,11.6968565667,0.108697991,2.60896903667,13.2067780667,-8.26177981333,11.2807661167,-9.03670334333,10.7708394167,4.27588932333,-7.96325066,-49.0351677167,18.0571700833,20.18265635,-3.869802415,4.84473728667,4.23632425667,2.627450745,0.1984747555,5.38617315167,0.118728509567,1.84531086,-2.693731395,2.28223516833,0.818085435167,3.65098662,-15.86069055,9.538938425,4.36658239,3.21195587333,-1.59729220833,-1.23361327833,-0.303275680333,0.335961192,1.26980482833,0.467107907,1.51871269,1.01384640333,0.989478409667,0.152091751733,1.07197069,0.162164110167,2.487588115,-2.10959977667,2.92068627167,0.0815401776,1.478733145,0.618605691333,-0.552617288833,-0.354153222833,-0.185458382167,-0.533015546833,-0.2646316295,0.311665414333,0.2715740795,0.2669557875,0.326864903,0.211065411333,0.330069386333,0.521974355,0.01661140565,0.854449877,0.0753030347167,0.949042157,-0.529100861333,0.277458559167,0.5721511355,0.00927227889,-0.377234424167,0.255889993,0.127049518333],[-36337.8740667,-536.386325333,-5091.588615,-1664.54423667,942.264139667,2237.10148333,525.738991333,-3548.42239167,898.8728995,-861.953766833,-260.663729333,732.838512667,-1175.0789,-626.542594,-53.8600981667,439.224632667,-599.973232,-515.116563167,340.6716055,58.64074685,-197.880809167,1.17606302667,50.8830089167,-193.754858833,67.6679762833,-74.25857275,-116.916152833,23.8326338667,89.5924030667,-202.502818833,-16.760789405,-28.6736909,-75.72218695,250.540149167,19.4145533,5.897064925,38.08607125,3.80341270667,-15.8764372,17.5744705667,-23.6322342667,-25.5816895833,47.5662922667,-27.1040092333,79.3262365,-1.74943131667,-36.7029483167,-124.151206167,-4.35533346,22.0499247167,11.9528025333,1.536406394,2.57645346333,14.5234194167,-8.19377742333,11.4263554,-9.32349792333,10.9176814833,2.62141993217,-8.012774425,-48.3945354667,19.0400229,19.9134887333,-3.82284682333,5.00515880667,4.40951075,2.81010573167,0.310257475667,5.81999252833,-0.0324148945667,1.854484395,-2.519642045,2.40437205333,0.531497687,3.36866456667,-15.8069600667,9.90289021333,4.28772402833,3.061774145,-1.76973719833,-1.30959028667,-0.305922792833,0.376855787167,1.22821609667,0.524881394833,1.59428924,1.004211116,1.0336710465,0.232440659167,1.07786317,0.225525701167,2.356173625,-2.07745401667,2.99359868167,0.107258517133,1.47911809,0.528702712833,-0.595154260833,-0.3054284895,-0.214312406167,-0.559045857667,-0.267771841167,0.289401323833,0.298168150833,0.254023636,0.339092324833,0.235887664333,0.358591144167,0.507669116167,0.0574661166833,0.831270915,0.0791786088333,0.935296961167,-0.534473876,0.289712107667,0.526213381333,-0.0232930858983,-0.372657765833,0.269084001667,0.133405769667],[-36564.05235,-175.289051333,-5051.82250167,-1600.741035,968.895916,2247.38061667,495.595741167,-3386.87863667,916.5366775,-849.0974455,-297.482811667,729.897517167,-1319.11890667,-678.216896667,-132.150652117,428.2665335,-590.231188667,-509.4002445,339.215009,34.9752110333,-207.485667333,10.3130830233,57.9417568833,-239.523156833,63.27925115,-69.58958765,-110.783767,26.15417515,83.6283551,-199.891370333,-0.628160353333,-31.5414383167,-83.3646034833,250.802340667,12.8396400317,7.21615043833,39.5821597333,4.55449533667,-12.182732835,15.59886225,-20.50599745,-21.2241105833,49.0956338667,-30.952346,81.3293823833,-7.95127653167,-35.1823929833,-122.111018833,-3.40929261167,22.5442773333,12.1133601167,3.012077625,2.66174868667,15.7747620667,-7.99011781,11.5674847333,-9.54090392,11.0421557167,0.956772024667,-8.001744435,-47.5049093833,20.0415177,19.6425249333,-3.75039780667,5.17553807,4.55206576833,2.98238409333,0.4484298745,6.22509620833,-0.188196179767,1.83270058,-2.33577222,2.50707992667,0.245080566383,3.07094640333,-15.6966882333,10.2732034117,4.21337713167,2.87223629333,-1.95339161167,-1.38157143667,-0.299185800333,0.422824416,1.17740882,0.583879912833,1.657902475,0.989265865167,1.060299405,0.313088638833,1.072596105,0.293647707833,2.220436645,-2.03782346333,3.057514565,0.1386960215,1.4613293,0.423830762,-0.635664872,-0.248558474667,-0.242180684167,-0.582809210167,-0.2673701765,0.265886888833,0.323426287333,0.238220306667,0.3514112475,0.257456551,0.387362908333,0.490893150833,0.0984800622333,0.806350851667,0.08378537025,0.913874784,-0.538634268667,0.296696172333,0.47640475,-0.05695850125,-0.364290630833,0.2820850675,0.138743720667],[-36777.6227167,120.836705167,-5008.378605,-1546.53489667,974.453245667,2256.31682167,457.181899333,-3189.581785,932.2242995,-837.157907,-322.6096475,723.144476,-1444.09085167,-732.006839167,-224.201893833,415.979384,-579.6412225,-499.683018667,334.758630333,13.3016737133,-214.612788167,14.3653623,66.6835377667,-281.177024667,58.2235473,-65.5962499833,-104.115273117,26.9060812333,77.7109839667,-196.513415833,16.4081937117,-34.2140576,-89.7239156333,251.348968667,5.47973634667,8.44586053333,40.6256359667,5.29968572333,-8.63162169667,13.8156398,-17.33060035,-16.2054070333,50.5552853,-34.5500746,83.0040424,-14.3147880467,-33.7583644,-119.643969333,-2.42094155,22.9694866167,12.20122945,4.54251275333,2.830463255,16.9728428333,-7.67888245,11.6678913167,-9.69191383833,11.0934256333,-0.7171440455,-7.965624645,-46.3725358167,21.0532832667,19.3819785833,-3.66074224333,5.363036325,4.67431289833,3.15543159833,0.607026270167,6.60784595833,-0.3540418215,1.779439035,-2.15870330667,2.57488162333,-0.0351526468,2.74744796,-15.5366855167,10.6401021167,4.14824972833,2.64659114167,-2.14815207667,-1.45018952167,-0.2820625105,0.475293630333,1.12099482,0.644189741833,1.71223276667,0.966552570667,1.07252949167,0.387376129167,1.05405547167,0.367480430667,2.07856009667,-1.99340982167,3.10834618667,0.1770809925,1.425577755,0.304661043167,-0.673582535833,-0.185474573333,-0.269049720167,-0.604650444,-0.263707411,0.241580666,0.347787061167,0.220313651,0.363361460667,0.276937356833,0.415189393,0.471890217333,0.139115864467,0.7792545335,0.0884656872167,0.883514033667,-0.541250615167,0.2982308285,0.422970100667,-0.0911245833,-0.352682947667,0.293941926,0.1433713765],[-36975.8612167,353.787172667,-4918.62835,-1515.87480833,965.773992833,2263.21148,417.874514667,-2962.54696667,942.484426,-825.174453333,-337.675112667,714.132911167,-1549.02420333,-788.9200915,-325.8010045,402.4340155,-568.4927195,-486.865944167,328.007657167,-5.92007998,-219.922800333,13.9170260167,77.6557258167,-316.801012167,52.7996592667,-62.3633478,-97.34842135,26.1414718667,71.9133253833,-192.439273667,34.2781574667,-36.603289,-93.7574034667,251.925646833,-2.96677278833,9.64088040667,41.1596109333,5.97922460833,-5.31410385667,12.1865130333,-14.0850728,-10.61003193,51.8897927,-37.6827654,84.2768267333,-20.9158219833,-32.5121307,-116.701707167,-1.40206217767,23.3140909833,12.2387996,6.105864935,3.05092006667,18.1258604333,-7.281007785,11.71475605,-9.76697846833,11.0528439833,-2.38794777733,-7.93315118333,-44.9951062833,22.0697083167,19.1454598,-3.55647360833,5.57221547667,4.78665278,3.33192418833,0.7785977225,6.96990455333,-0.5334322595,1.69902513667,-2.00026453833,2.60147215833,-0.298704304117,2.39109292,-15.32863145,10.99600355,4.09823703333,2.38981748167,-2.35331393833,-1.51500178333,-0.252547035333,0.535619457,1.061238115,0.705022825167,1.75805336833,0.933726269833,1.07367445333,0.449663789167,1.02189093517,0.449410010333,1.93000182667,-1.94521449167,3.14343904833,0.224188975333,1.37292596333,0.172472352883,-0.7086568335,-0.118201947517,-0.2948731275,-0.624178171833,-0.257093819333,0.216961770833,0.371428800667,0.200542909667,0.3743370195,0.295114853,0.440948466667,0.450963108333,0.1792525245,0.7499486535,0.0930031460167,0.843548400833,-0.541676611833,0.294480378833,0.36647093,-0.125295581917,-0.3383609725,0.303772004333,0.147663065],[-37132.9521167,581.589354,-4755.78674333,-1520.022625,958.341686667,2262.58914833,383.750121667,-2713.671035,941.833876,-812.236959333,-344.636178167,705.874429667,-1633.56057667,-846.975590167,-429.503693667,386.997299667,-557.444850167,-471.634001,320.683859333,-21.6834839533,-223.322200667,10.8668697,91.7699523,-345.238182,47.1550506,-60.0976698667,-90.86454415,24.19346265,66.53761865,-187.613244,52.9814008333,-38.4326263333,-94.59227275,252.316467667,-12.6427266133,10.8381876033,41.1119372333,6.52415516,-2.33722266,10.6953251483,-10.7406786917,-4.53821868167,53.1035071667,-40.10323365,85.15556475,-27.7740916167,-31.5180958,-113.250802333,-0.354279588333,23.5550409333,12.2478427833,7.64709657,3.28947854167,19.2387206833,-6.80796247,11.70619475,-9.73598182167,10.9280180333,-4.03187930333,-7.93635752833,-43.3764371,23.0816256,18.96024785,-3.43525997667,5.80170761333,4.90033544833,3.50685695667,0.953340783167,7.311432215,-0.724505862833,1.59871126167,-1.865921565,2.58886778333,-0.532221117167,1.99578744167,-15.0723352333,11.3318312,4.07361487,2.11255722667,-2.5698067,-1.57444649333,-0.208985458167,0.6047696115,1.00020838867,0.764827959167,1.795638705,0.8895138975,1.06772755667,0.495156327667,0.977201348333,0.542414319667,1.77426688333,-1.89263943667,3.16053036333,0.282739202167,1.30667486167,0.0290230155333,-0.742115826833,-0.0493213624833,-0.3194536625,-0.640535513667,-0.247973395,0.192736936167,0.394421790167,0.178850727833,0.3834497025,0.312571791333,0.463306383667,0.428279711833,0.219030839833,0.718530921333,0.09754824745,0.7938195255,-0.5393260395,0.286092111667,0.307669079167,-0.159462327833,-0.322050758,0.310813619833,0.152279094667],[-37226.2237667,853.272147167,-4525.29505833,-1563.08394,966.679141167,2245.91440167,354.721477167,-2447.002835,927.396019167,-796.436820667,-345.370447167,699.8952645,-1698.51476,-902.580169833,-530.255058667,369.541461,-546.697258833,-454.476264333,314.399704167,-33.4553655667,-224.290318,6.651965,109.18874215,-366.025253667,41.36609525,-58.8968011833,-84.9449292,21.5297098333,61.7685890667,-181.968085,72.3533729333,-39.6714534,-91.7192749667,252.339602,-23.4697419333,12.01300585,40.4550775833,6.87049633667,0.257471556667,9.31152654333,-7.27639673833,1.87886443667,54.18591815,-41.6341352833,85.6648542833,-34.8332045167,-30.8344074667,-109.303242167,0.709581131667,23.6742671833,12.2447913,9.121227665,3.520217235,20.3184067667,-6.27423440667,11.6439283167,-9.57370865667,10.7226254833,-5.61884297,-8.00255642,-41.5374098667,24.0750128667,18.8513013167,-3.29546666,6.046102795,5.02476949167,3.67484402,1.123652746,7.63478744,-0.925110002667,1.48746814333,-1.75828500833,2.53950096,-0.727185300667,1.558446945,-14.7722980333,11.6360318,4.08175473167,1.82518605667,-2.79928154833,-1.62652771,-0.151400920317,0.683244212667,0.939368945667,0.822356062833,1.826082275,0.833687125,1.059121655,0.520046160833,0.921490601167,0.646963043333,1.611107245,-1.83561554167,3.15651951167,0.3544528115,1.23032674333,-0.12368299745,-0.7756640445,0.0193684565167,-0.342351684333,-0.653213526667,-0.2367089205,0.169401451167,0.416886158667,0.155255117833,0.390060391333,0.329912169667,0.4808173955,0.404159907333,0.258066777333,0.685165667333,0.102129295667,0.734136029833,-0.53404646,0.273769980667,0.247400254667,-0.193921109,-0.304274781333,0.314625608333,0.157636439667],[-37271.1458333,1182.83051817,-4236.81986833,-1638.139965,1000.33122283,2209.06799833,330.575959167,-2174.500925,902.284169667,-775.486277333,-342.810481667,696.748306,-1748.32856833,-951.52287,-628.854079667,350.541000833,-536.031200333,-436.267253333,309.755168333,-41.6634305833,-221.738951,0.938599768333,128.845863167,-379.382067333,35.2949162167,-58.7183985,-79.6135674167,18.4171312333,57.77244515,-175.3710185,92.0615407333,-40.5661331333,-85.2084473167,252.090601,-35.07372075,13.0709632333,39.2142254167,7.07547664333,2.49395054833,8.09292963333,-3.6724483794,8.520165475,55.1760295333,-42.2640488,85.8885413833,-41.9627499667,-30.4491188833,-104.953595,1.77047476067,23.66470545,12.2539708167,10.5128674233,3.74856530667,21.37364975,-5.69734624,11.5639400667,-9.28027159833,10.4590920333,-7.13003842167,-8.13066399,-39.5199636333,25.0255306167,18.8252756833,-3.13529437333,6.29668078667,5.163089175,3.83092931667,1.28651309,7.94087019,-1.13256842833,1.378276295,-1.68009757833,2.46036918667,-0.8878386385,1.08369363383,-14.4392110167,11.8965387833,4.12454478333,1.534571875,-3.04091833667,-1.669062465,-0.0823716157717,0.769323176333,0.8782311495,0.876616972833,1.849086995,0.768396828833,1.050800015,0.522648931,0.856905990333,0.76002687,1.4420392,-1.77471036333,3.12877489,0.439794711,1.14782797667,-0.2832598635,-0.810590342667,0.08807136405,-0.363056751167,-0.6622502415,-0.223984954667,0.146899332333,0.438852532167,0.129407987333,0.394531280167,0.347030072667,0.492833427333,0.379146557333,0.295769736167,0.6505335105,0.106935599667,0.664969999833,-0.525810781,0.258724247,0.186744880333,-0.229123212333,-0.285136304,0.315445802667,0.1636632445],[-37289.7797667,1554.62027167,-3900.14960167,-1735.07227667,1062.15758467,2151.31022,307.197559667,-1908.209225,870.840913167,-747.486744667,-339.247713833,695.628502,-1787.63178333,-989.579912667,-726.74943,330.553888167,-524.856687833,-417.7696245,307.0636805,-46.7519054667,-214.537015167,-6.82799791,149.158628667,-386.08375,28.7657654167,-59.3704668333,-74.8112695167,15.1465603333,54.7632142667,-167.7277865,111.742743167,-41.5424594833,-75.42634305,251.673032,-46.9784653667,13.90939325,37.4434183333,7.21630848,4.44146452833,7.12577931833,0.0723586790667,15.2592556633,56.0849284167,-42.0546983833,85.8995838167,-49.0034925333,-30.3356351,-100.3058007,2.809373125,23.5173915833,12.2959338333,11.8174444167,3.98789953667,22.4089800667,-5.096871915,11.5004019167,-8.86226017667,10.1572908317,-8.54595239667,-8.31558268667,-37.3639598333,25.9042009,18.8790495167,-2.95329249333,6.54075317667,5.31546921667,3.96906501,1.43973972,8.22970638667,-1.34402997833,1.28340304667,-1.63189692167,2.35806308333,-1.02061336967,0.576213420783,-14.0825729833,12.1000427833,4.19926996333,1.24613408017,-3.293705465,-1.70009860333,-0.00565817352,0.860648367333,0.815104759667,0.9264311705,1.864174275,0.696437838,1.04521695,0.502652,0.7855450715,0.878097378333,1.26835570667,-1.71018699,3.07452201333,0.537612297667,1.06273300367,-0.4476520565,-0.848095885833,0.1574958882,-0.381064740667,-0.6677126505,-0.210462754833,0.124856244333,0.460223470167,0.1009647288,0.397487889,0.363681986167,0.499031638333,0.3538143185,0.331634871833,0.615260985667,0.112113081167,0.586836517667,-0.514987461667,0.242016350167,0.126636295033,-0.265580324667,-0.264569828,0.313727675667,0.170147476],[-37282.4971333,1949.33847,-3528.80906667,-1835.99366,1149.77740333,2074.13209,275.947148,-1657.238455,838.40476,-712.510112667,-334.886670167,694.326216,-1819.38886333,-1015.276369,-822.538760167,310.006512333,-512.769148667,-398.959113333,306.4837975,-48.6417630667,-202.477633333,-16.1922247817,169.106618667,-387.442670833,21.5300098,-60.5396910833,-70.3431859167,12.0425119483,53.0578202333,-159.1056705,131.2434155,-42.8787891833,-62.9470282167,251.0556695,-58.68091075,14.4145411167,35.2552697333,7.35716751,6.182728505,6.50945786833,3.94556755893,22.00525555,56.90246165,-41.10553385,85.7162108167,-55.7840619167,-30.4867174,-95.466361,3.80763263833,23.23297435,12.3758608667,13.0312937333,4.25443209667,23.4287850667,-4.48388167167,11.4633986,-8.32454024,9.82427516167,-9.84404586167,-8.565639005,-35.1089632667,26.6844012667,19.00730635,-2.74764603333,6.76431980833,5.47772352,4.0833048,1.5828238,8.50129886,-1.554407005,1.20674550333,-1.61026971,2.23711507667,-1.13087161833,0.0348844231333,-13.7099748333,12.2360602,4.30155855667,0.965937042833,-3.55584798333,-1.71774128167,0.0739915174283,0.9546085455,0.748490292167,0.970966581167,1.87076861167,0.620805383333,1.043234915,0.461169107667,0.709257514667,0.998055147,1.08969438183,-1.64174786,2.99263252333,0.645741402833,0.978351073333,-0.614861265,-0.8894348605,0.227303965167,-0.395914473833,-0.6698659345,-0.1965481015,0.102966582867,0.480750572333,0.0695822759667,0.399444509167,0.37963243,0.49937961,0.328623930167,0.365321257167,0.5796765985,0.117890116333,0.500684511667,-0.502302744167,0.2244447105,0.0678081598667,-0.303831432333,-0.242926553167,0.309904369333,0.1770710535],[-37243.9154167,2326.19240167,-3164.69542167,-1926.67387667,1257.55551167,1977.01134833,233.533191667,-1417.257825,809.284397333,-670.376689833,-327.385054667,691.5701395,-1842.53470167,-1028.83372167,-915.245262833,289.4025075,-499.239164167,-378.638018833,308.146248333,-46.8384247833,-185.709642333,-26.66255965,188.362510833,-384.765036167,13.444111975,-61.9350812,-65.8058122833,9.40793231,52.8809532667,-149.571832333,150.4866625,-44.6277145333,-48.4443583333,250.101858333,-69.7126521833,14.4901218,32.7510203167,7.54301478667,7.80499231333,6.30704764,7.93789589833,28.7004966667,57.62562505,-39.5646757167,85.3074139333,-62.11166815,-30.90465305,-90.5120014333,4.74279820167,22.81424435,12.4772958833,14.1519144,4.56346739333,24.4298263,-3.86169375167,11.4465683667,-7.68031499833,9.455184675,-10.9819701383,-8.88909246667,-32.7866622667,27.35072965,19.1961653833,-2.51829783167,6.95555843167,5.64003094667,4.166930065,1.71823009333,8.75135458833,-1.75760303,1.14499257667,-1.60892711167,2.101062705,-1.21698463667,-0.53922801455,-13.3282231333,12.2994131,4.42355135333,0.6967303305,-3.8234411,-1.72015948667,0.152330370483,1.04829427,0.676425023167,1.01031707917,1.86735059,0.5446222445,1.044011525,0.401346721667,0.630479574333,1.1175967375,0.906660365833,-1.56979146667,2.88357985333,0.761035909667,0.896220936,-0.782073370833,-0.934661862833,0.29661215,-0.407062705667,-0.669038779,-0.182350134833,0.0808693979667,0.500185505333,0.0349801271283,0.4009816735,0.3945295835,0.494310372,0.304261189333,0.396229794667,0.54423383,0.124246638,0.407684515,-0.488601599667,0.206310351,0.0111765740667,-0.343840144667,-0.220741432333,0.304167938167,0.184402953833],[-37185.4257333,2635.3849,-2852.58344667,-1997.48909833,1376.18583667,1856.87268,178.229832,-1184.15447117,787.461717333,-621.750347167,-315.240377,686.008340333,-1856.178785,-1030.65420667,-1004.42275333,269.465736,-483.890606,-355.732658833,311.8308265,-41.0508647667,-164.4018835,-38.0127151,206.6365215,-379.118913333,4.47123783333,-63.2968614167,-60.7845414,7.40703193167,54.37991095,-139.200093667,169.298688,-46.8276817667,-32.5560977667,248.617221667,-79.64561865,14.0617115667,30.0321822167,7.82991892333,9.37303933667,6.56787720333,12.0245527567,35.2617524,58.24512945,-37.5901587167,84.61048905,-67.8030923667,-31.5884186667,-85.50382675,5.59278184833,22.2688736667,12.5866047833,15.1778079333,4.92928712667,25.4003106,-3.23863198833,11.4417981,-6.95221572833,9.03772257667,-11.91841225,-9.29113700833,-30.4242994333,27.88757435,19.4269145667,-2.26624899,7.10498786167,5.79283384833,4.21483498,1.84885035667,8.97319037,-1.94795488667,1.09419506667,-1.62441098833,1.95242264833,-1.27724563,-1.14352594583,-12.9432704,12.2849234833,4.555974925,0.439736129667,-4.091990545,-1.70587317833,0.225715566,1.13867846,0.5974021015,1.04478287833,1.85209738167,0.4711650865,1.04625043833,0.325983910667,0.5516511735,1.23412719667,0.720257277167,-1.49502535833,2.74777451833,0.8800790425,0.817085193667,-0.9464357115,-0.983407586333,0.3645265905,-0.414042341,-0.665512987333,-0.168057552,0.0582848849833,0.5183160435,-0.00301444517,0.4027731045,0.4078774695,0.4843023485,0.281425919333,0.4235853635,0.509392044,0.131021022833,0.308935414333,-0.474651677667,0.187692322667,-0.04240291645,-0.3854072845,-0.198497174833,0.2966338235,0.1920573045],[-37128.0917667,2851.30509,-2632.922045,-2039.94197167,1495.626585,1703.71830167,115.56659455,-970.744474667,777.350404,-569.288027833,-301.800799333,678.371869,-1864.76996333,-1021.17745,-1090.3478,250.986158167,-467.055477333,-330.6296755,317.015620333,-32.2713747333,-138.334086333,-50.3578622833,223.641161167,-370.685109,-5.401327275,-64.5059970833,-55.0351499667,5.86880601,57.51438525,-127.937214667,187.353499667,-49.49769965,-15.6527313983,246.373018167,-88.1701770667,13.0815500833,27.2116538667,8.31513227,10.8649840933,7.34005874333,16.1979611667,41.5522499,58.7624470167,-35.31360765,83.5256903667,-72.7410479333,-32.5461204833,-80.5220933667,6.34546672333,21.6243867167,12.7182777833,16.1036638667,5.368676405,26.3280802667,-2.63951422333,11.4527834333,-6.18468561667,8.549978205,-12.6335735667,-9.782238645,-28.0614106333,28.2784722667,19.6807129833,-1.99137717333,7.21046912167,5.93472757,4.22687131167,1.977657865,9.15878383667,-2.12384680667,1.05434795,-1.66603878333,1.79280744333,-1.31563573,-1.77687198333,-12.5647349,12.1881808,4.69012382333,0.195322920933,-4.35780034,-1.67403534333,0.2919379495,1.22343430167,0.512052055667,1.07487805167,1.82271676667,0.403131891,1.04896587,0.234615743833,0.475226171167,1.34359787167,0.531090634333,-1.41922763167,2.58594715333,0.999357255667,0.741265613,-1.106006426,-1.03512280883,0.429869167167,-0.416807275833,-0.659604735667,-0.154378906667,0.0354305934333,0.535100988833,-0.0445500550383,0.405521984333,0.419113183,0.469586286167,0.260834444167,0.446300945,0.475558693667,0.137943588333,0.205495685567,-0.461354050333,0.168591419,-0.0925982075667,-0.428362377667,-0.176843123333,0.287449651,0.199941159333],[-37086.2055833,2970.08718667,-2509.064865,-2049.15831333,1607.16735167,1515.26028333,56.611593945,-791.460884333,781.868060333,-516.853099667,-290.899370167,670.323452667,-1872.84978333,-1001.37382917,-1171.97216833,234.516567333,-449.706086,-304.4641245,322.795873667,-21.5808702367,-107.214227133,-63.2985492833,239.495608,-358.896533,-16.1277492667,-65.6182035333,-48.5311384333,4.36928447333,62.2339330667,-115.676334667,204.420167333,-52.4980620333,2.19426487333,243.150054167,-95.0513754667,11.543617275,24.3963024333,9.074275645,12.1933146833,8.67752134667,20.4571506167,47.4448970833,59.1908299167,-32.7877523,81.9590337833,-76.8295002667,-33.78406345,-75.6053502167,6.998423235,20.9230587667,12.8969647167,16.9190702833,5.896178185,27.1961918667,-2.09069723833,11.4798034333,-5.41473778833,7.971592345,-13.1054988667,-10.371442615,-25.7218482,28.5099519,19.94209385,-1.69277639667,7.27616384167,6.06995394667,4.2064938,2.105686105,9.29680733167,-2.285404835,1.02318194183,-1.74580352833,1.62252509167,-1.33354407833,-2.43681735,-12.1970902667,12.0059675167,4.82125734667,-0.0365033904333,-4.61596841167,-1.62422704333,0.3501207795,1.30119929167,0.422857483333,1.10055477,1.77610377333,0.342507837333,1.05010795833,0.125382939753,0.4023569715,1.442536285,0.3399991715,-1.343424245,2.399290645,1.11739497533,0.66879536,-1.25828893667,-1.08905433167,0.491175419333,-0.415622508833,-0.651645368167,-0.142195687,0.012947795265,0.550411119,-0.0897143342833,0.409752424667,0.427432830667,0.450065210667,0.242618377333,0.463307752333,0.443038941833,0.144837325667,0.09843777425,-0.448859156,0.148978095833,-0.138931137583,-0.472498943167,-0.156473788333,0.2766564745,0.208040402],[-37064.1944833,2976.51535167,-2440.61883167,-2036.519375,1703.0163,1301.44004833,11.5349662467,-645.140018833,798.813924667,-466.820950333,-284.616228167,663.354049333,-1879.74944667,-975.230815167,-1246.18445167,220.395671667,-432.626640167,-278.769919333,328.223801,-9.29173193833,-71.9336430833,-75.7454852167,254.771875167,-343.06145,-27.3650895667,-66.8447971833,-41.5830234,2.47251831178,68.4304400333,-102.575248267,220.427358,-55.6320584833,20.965174835,238.686171833,-100.346908967,9.531709415,21.6170849333,10.094685365,13.2667839833,10.5724858183,24.76986875,52.8472778,59.4962994333,-30.0437858667,79.8223672,-80.05343565,-35.3201512167,-70.6770221333,7.55401837667,20.1986474667,13.1464613,17.6133703167,6.50715731333,27.9922238,-1.61313800667,11.5017572833,-4.671312985,7.29029372,-13.3130108667,-11.0701837167,-23.38551145,28.5833751333,20.1904578667,-1.372906185,7.311118345,6.209791075,4.15811045667,2.22983445833,9.38018987667,-2.43374902667,0.994908498,-1.87164228667,1.442138385,-1.324764425,-3.12009894833,-11.8356796167,11.7402840667,4.9448073,-0.259169558067,-4.86040329167,-1.55691948833,0.401908091333,1.37282343667,0.332764831,1.121105115,1.71062783333,0.290119827,1.04783783333,-0.00208463615467,0.332661596833,1.52996588833,0.148059359767,-1.26849157,2.18944953833,1.233760665,0.597963330667,-1.40018065,-1.14412628667,0.5466432235,-0.410813009667,-0.641562614667,-0.132275752667,-0.00844186359,0.564161803833,-0.138275337033,0.415565373833,0.432289848833,0.425883645333,0.2260481955,0.473800079333,0.411888713333,0.151160182667,-0.01154418,-0.436674017,0.128355475667,-0.1806569605,-0.517535674,-0.138175293333,0.264065878333,0.216347441667],[-37052.3208,2874.44319667,-2384.118115,-2016.33493667,1780.97842333,1074.376619,-15.6501809383,-520.214586167,823.6728345,-420.661565167,-284.060131667,658.5858155,-1881.68250667,-945.559950833,-1308.92279667,208.457672333,-416.543707333,-255.079798667,332.8007015,4.85764704667,-33.4505656117,-86.3389047,269.420649667,-322.589771,-38.8022101833,-68.4612483,-34.6519818,-0.0927020612,75.9788602167,-88.8723495167,235.392217333,-58.9329698,40.6850257167,232.785776167,-104.073368833,7.14144157667,18.85084745,11.3086546667,14.0068369333,12.9685594667,29.07991225,57.6957277833,59.6017693833,-27.0685444167,77.0387892667,-82.37695915,-37.2037377167,-65.6799508,8.02100739667,19.4656621333,13.4819915,18.16709165,7.18130349833,28.7047214,-1.22133323017,11.4944478833,-3.96700933667,6.49167476833,-13.2335380833,-11.9036984833,-21.0345759833,28.4980681667,20.4145809,-1.03217573933,7.32188691667,6.36609061833,4.08253552,2.34331441667,9.40552824833,-2.570318185,0.9647904215,-2.04774399333,1.24862276833,-1.28145884333,-3.82780936,-11.47467135,11.3924650333,5.059580915,-0.475330357667,-5.088239025,-1.47196148333,0.4497321845,1.44010539167,0.2440178805,1.13491542,1.625680705,0.245499883167,1.04091538833,-0.147894484914,0.264423571,1.60573674167,-0.0446282702667,-1.19472769167,1.95731302833,1.348178465,0.527107645833,-1.53011313333,-1.19997085167,0.594956065833,-0.402504358833,-0.628734385667,-0.125069695833,-0.028086946835,0.5761608805,-0.189971142833,0.4224606545,0.433290918833,0.397004068833,0.2101719575,0.477202177167,0.381907580833,0.156462527833,-0.12406806385,-0.424401210833,0.10603209555,-0.217342590333,-0.563450838,-0.122563491333,0.249717671833,0.2247503425],[-37029.4773667,2691.38815333,-2299.17078333,-1995.624855,1842.98982333,845.31711,-30.4034743167,-406.744081167,852.938490167,-380.2273465,-290.062138167,655.546726833,-1875.00342333,-914.0135235,-1355.68535167,198.310232667,-402.212078667,-234.7631565,336.343607167,21.2792260917,7.32747018667,-94.0597025833,283.0654305,-297.769254333,-50.2622802333,-70.6147208333,-28.16490525,-3.37257560822,84.7609547333,-74.8417084667,249.139308333,-62.5636083833,61.11133635,225.174987667,-106.131889667,4.44385553833,16.1086180167,12.6545121,14.3820416833,15.7853524833,33.3194760667,61.8833683833,59.41061185,-23.8780647167,73.4972240833,-83.7416581833,-39.4550973833,-60.6179104833,8.40839675833,18.7329905333,13.91572425,18.5622105,7.89216875167,29.3270219333,-0.925956041667,11.4350543167,-3.30784218167,5.55789260167,-12.8573449,-12.8877441333,-18.67270155,28.2401559333,20.6022578,-0.6704270845,7.30920574333,6.54837944667,3.97883976667,2.44018636833,9.37396959833,-2.69127726167,0.930358635333,-2.27552673833,1.03973996733,-1.20233161167,-4.560608585,-11.11329665,10.96034265,5.16229882833,-0.684664397667,-5.298024745,-1.36921565333,0.4943682675,1.50454162833,0.158207741367,1.14112349167,1.521852365,0.209167431,1.02924656833,-0.311964964167,0.196592641833,1.668414795,-0.238451980733,-1.12312673333,1.70340806333,1.458745665,0.455600134667,-1.64767691167,-1.25672589833,0.634504812167,-0.390737423667,-0.612579075667,-0.120890780333,-0.04556802495,0.586361142833,-0.244509479667,0.4297655095,0.430346275,0.363341365833,0.194319316667,0.473023237167,0.352751681,0.160206051667,-0.23849438,-0.412178636333,0.08135434545,-0.2490261665,-0.610298005333,-0.110416178333,0.233890583833,0.233212805167],[-36964.6048167,2480.68882667,-2176.81979667,-1975.76577,1898.51416,622.6332155,-36.4174178333,-296.2618345,885.381420167,-346.046742667,-301.781035167,655.666590667,-1857.13599333,-880.647247833,-1385.81290333,189.9223825,-390.085660167,-218.288763667,339.463858833,39.4664219167,50.319289105,-99.9064015833,295.812279667,-269.987543333,-61.5731980667,-73.2842059833,-22.2663172833,-7.154076415,94.3988810667,-60.5427536,260.987696667,-66.4565310833,81.4981517833,215.531264833,-106.479132333,1.477181525,13.4590607667,14.1215122667,14.4312490667,18.94147225,37.4757003,65.2416935833,58.9135901,-20.6186776167,69.0865069667,-84.1443535,-42.0198503167,-55.5551933,8.70248154,18.0181843667,14.4584691,18.7965964167,8.64042594167,29.8737543,-0.722034825,11.3298358833,-2.71549470667,4.49430872667,-12.2016354667,-13.9983362667,-16.3326207333,27.8009364333,20.726477,-0.295070583583,7.27041778167,6.76342750333,3.84770980167,2.52813218,9.29307075,-2.78037304167,0.897587957167,-2.55480568167,0.82703377,-1.09642104883,-5.30409049667,-10.7633701,10.447566675,5.24135891,-0.887084586333,-5.48986789667,-1.24959173167,0.533455904333,1.566954705,0.0763342510958,1.14250434167,1.40118686833,0.18545038,1.01520337167,-0.492200431167,0.13307556035,1.71433859167,-0.429696856667,-1.05790595833,1.43088046167,1.56060692667,0.382980594333,-1.75372372333,-1.31365918167,0.663617132333,-0.375324779833,-0.593594938667,-0.120234319667,-0.0610126891167,0.594999234333,-0.301464840333,0.437477812667,0.423922975333,0.325686996167,0.179146545167,0.460764835333,0.324929665333,0.161470790667,-0.353180833667,-0.4008253985,0.0538394399667,-0.276273491,-0.657554026667,-0.102626840783,0.2170064195,0.241639246667],[-36834.5685833,2293.20073667,-2024.20156333,-1964.80591667,1956.27815,417.117353333,-36.5181278167,-176.383770017,919.047763833,-318.9727915,-316.2406495,661.710756833,-1824.485615,-842.835998167,-1397.31251,183.6468555,-380.724527167,-205.642862167,343.101671167,58.83187115,96.24767545,-104.775809667,308.2045415,-241.108127167,-72.3396076,-76.4381134833,-17.0747241167,-11.2387715033,104.45732505,-45.9896231833,270.198449167,-70.4075170667,100.934279217,203.513306,-105.0870445,-1.67148028667,11.0004840517,15.6810610833,14.1585624833,22.3605064667,41.4861884167,67.5838599167,58.1134318,-17.4409926167,63.7064389833,-83.5731141833,-44.8073048333,-50.5229448167,8.88648420667,17.3547660333,15.1150842167,18.85914165,9.43367495833,30.34003695,-0.602172835,11.1818073167,-2.20093876167,3.32275598833,-11.2774262167,-15.1902321167,-14.0334896167,27.1813957667,20.7548543667,0.0814826973333,7.207032905,7.01782485667,3.69167131833,2.61717492333,9.16699997,-2.81802307,0.8706317365,-2.88158241167,0.627556277167,-0.97087301,-6.03546494667,-10.4343393333,9.86324108833,5.28296278667,-1.08198445533,-5.66458569833,-1.1155976905,0.564780645833,1.62834056,0.00147859151667,1.14220715833,1.26613729167,0.179594927167,1.00068879767,-0.685734173,0.0783325467833,1.73997980667,-0.612788061333,-1.00331430283,1.14450111217,1.64822201333,0.309258327833,-1.84934325167,-1.369878315,0.680917983167,-0.356381042167,-0.572629315,-0.1236390565,-0.0739356977667,0.602238287,-0.359847855333,0.445639272667,0.414421058833,0.284904165333,0.165076300333,0.439912063,0.299002718667,0.159335410667,-0.466075477833,-0.391099299333,0.0232409004917,-0.299544606167,-0.70448169,-0.0998935666333,0.199628063667,0.250022801167],[-36641.3487333,2131.47167,-1880.917105,-1963.01897667,2012.32297833,235.713307183,-42.3777413333,-55.8450778667,955.9775425,-300.310689833,-329.749923,674.190982667,-1778.21204333,-800.718294,-1389.51713333,180.478557167,-373.893349,-196.3881815,347.859499667,78.6426832667,145.00278365,-110.122629667,320.9651605,-213.109810167,-82.2081431,-79.74436435,-12.61188006,-15.4176015,114.702758,-31.3048097167,275.955304167,-74.2729828833,118.359106333,189.085218,-102.188743333,-4.95500100833,8.882170695,17.3109229333,13.59643685,26.0076455667,45.2849874,68.7440491833,56.9366690167,-14.5513052667,57.3467771167,-82.1074506167,-47.7054951,-45.57880865,8.93671423,16.7756879667,15.8840908333,18.7508626167,10.272497065,30.7201011333,-0.550694541833,10.9690009167,-1.78629894667,2.06768627117,-10.11679179,-16.4043816,-11.8029355233,26.3729808667,20.6703888333,0.446494174417,7.11768756667,7.31462538,3.51701017167,2.71316166333,8.99940151,-2.78553213667,0.850255250833,-3.25072735167,0.450419933,-0.8356651175,-6.72752853,-10.1350167367,9.212639745,5.27798054833,-1.26388453833,-5.81775025,-0.970071058,0.585322504833,1.688856355,-0.0626306790042,1.14309903,1.119534017,0.1957668545,0.988079251833,-0.888375360667,0.034046529365,1.74147392333,-0.781955651333,-0.963054471667,0.8483502505,1.71585130833,0.236142993167,-1.93379436333,-1.42368734167,0.684460247833,-0.334241057333,-0.550667299833,-0.131600919333,-0.0839130182,0.608462087167,-0.418243822667,0.454138566667,0.4026413695,0.2421555645,0.152297458333,0.4099797975,0.275155203833,0.152929340167,-0.575097507333,-0.384203792333,-0.0104288980167,-0.319211761333,-0.749887048667,-0.10299402995,0.181756580667,0.258335650167],[-36391.4395833,1975.69706,-1786.97830667,-1962.85520667,2055.92190167,86.5596754167,-68.5886062833,47.6332902833,999.842954333,-291.431851667,-337.170526833,691.652848,-1720.51099333,-756.505165333,-1363.89242,181.1656,-368.953251833,-189.280399667,353.6415,98.6718091,195.9982075,-117.474736,334.921481,-187.552436667,-90.9806301,-82.7975967,-8.67077694333,-19.5505082333,125.169083167,-16.615096255,277.72486,-77.8536116167,132.791851667,172.550606833,-98.1501135167,-8.33910619333,7.23788750833,18.9977602,12.8080928833,29.89915265,48.8167588667,68.6744905333,55.3024924,-12.1408942667,50.0962398667,-79.87562245,-50.5910011667,-40.7936277667,8.837609325,16.3046396333,16.7446258333,18.4820066833,11.1549881667,31.0043651,-0.535438514167,10.6576033667,-1.486451575,0.758740924667,-8.76176205833,-17.5779743833,-9.66848468,25.3649390333,20.4715057667,0.789875334167,6.999762855,7.649518305,3.328918415,2.81868380667,8.790600655,-2.66696763833,0.831916059,-3.65168490167,0.298038179667,-0.6992148335,-7.35264688,-9.87029349167,8.49997635833,5.224352605,-1.42472432,-5.94074785667,-0.815825055833,0.59242658,1.74793332167,-0.1134284622,1.14750516,0.9633889015,0.236782745,0.978619502167,-1.09378194183,-0.000375924373333,1.71645363167,-0.931758277667,-0.939238921667,0.546101255167,1.75913434667,0.166635106,-2.004650465,-1.47300351167,0.672633895667,-0.309387280333,-0.528505982333,-0.144274634333,-0.0907217959667,0.614069244667,-0.475180225833,0.462851777,0.389447822333,0.198991726,0.1408556205,0.371015063,0.2533902705,0.141781120167,-0.678269328833,-0.381273202333,-0.0467365324417,-0.335350687667,-0.792379379167,-0.112482929167,0.162919063667,0.266508164167],[-36098.1280833,1807.37947667,-1733.29205833,-1960.43886667,2079.16522833,-20.8417475833,-112.068792317,127.0678332,1051.46324633,-293.170168833,-335.422201167,714.243446167,-1652.223185,-711.320504833,-1324.86942833,185.5807765,-365.618363667,-183.273573,359.2785395,118.678233417,248.479796,-127.9242995,349.831471333,-165.309679833,-98.5155670167,-85.4675275,-4.89877748333,-23.8695864333,135.860430333,-2.11522778667,275.560972167,-81.0653094667,143.6474035,154.320407333,-93.1708179,-11.724130835,6.10944909333,20.77572775,11.8412388833,34.05682215,51.9967191667,67.4754884833,53.21341965,-10.2944724683,42.1060776,-76.9744811,-53.3267122667,-36.1863988667,8.60316971833,15.9569628167,17.6681952833,18.0769385167,12.0854511,31.1730717833,-0.532334357833,10.2433021817,-1.29955009833,-0.558541223833,-7.26505906333,-18.6566761,-7.64547700833,24.1659042833,20.144599,1.105170306,6.85625471167,8.01108703,3.13200001167,2.93579269167,8.53926126667,-2.459762565,0.809923226,-4.07252421,0.174125586783,-0.5704947575,-7.89219893833,-9.64329445,7.73424622333,5.12047656167,-1.56370560333,-6.02901307167,-0.6567382555,0.585870943,1.80442502333,-0.150553996167,1.15637466167,0.799048883,0.302955730333,0.970657248167,-1.29597953167,-0.026084573035,1.66457419167,-1.05907596383,-0.933861734333,0.240730821117,1.77644322333,0.102118802233,-2.06028726667,-1.51645220833,0.646425574667,-0.282653910167,-0.5065663735,-0.161304467333,-0.094467461,0.6191382175,-0.529463077333,0.472015606,0.375045502,0.156817349,0.130491877333,0.323891885333,0.233755775,0.125667175667,-0.774243314667,-0.382307922,-0.0847740150667,-0.347689446,-0.830771551,-0.128132391167,0.1430810305,0.274494445333],[-35813.4947333,1638.24600667,-1678.89661,-1965.09181167,2078.89537833,-86.8469438167,-170.2717595,173.051417333,1107.943275,-308.747899667,-324.6503345,741.129407833,-1575.99281,-666.1443495,-1273.92786333,193.069409,-365.088559833,-177.828868,363.385827833,138.680889,301.148977167,-140.914652333,366.119248667,-147.297004167,-104.72463525,-88.0484701167,-1.08138271,-28.7794115833,146.865245833,12.0023400783,269.894491333,-83.63262015,150.578147667,134.635256333,-87.6136989167,-14.9821141,5.45082877667,22.6826825833,10.658311595,38.4401430333,54.7343463167,65.2600100833,50.7166111333,-9.05639694,33.4814953333,-73.5440820333,-55.7817948,-31.7197039,8.28089117833,15.7456095,18.6374660333,17.5459530833,13.03913745,31.1971912667,-0.543931184167,9.72813294167,-1.2205282,-1.85907040833,-5.69791504833,-19.5877983,-5.737093535,22.7982711,19.6848975833,1.395318365,6.69831382167,8.38861433167,2.92973460167,3.06008666,8.24548862333,-2.173554885,0.777366084,-4.50268675,0.0807161553333,-0.458101625333,-8.33652710167,-9.45149639,6.93090335833,4.96687722833,-1.67956455833,-6.07874945333,-0.496963284,0.568417462333,1.857485345,-0.174231250833,1.16994830833,0.628118805,0.392121944,0.961914591,-1.49131358333,-0.0434933620833,1.58725156833,-1.16375459833,-0.947895209167,-0.0633876930333,1.76803597667,0.0433880676617,-2.09983954167,-1.553758535,0.606941623333,-0.255415008333,-0.484902965,-0.1820880325,-0.0951351039833,0.624240152167,-0.5804187995,0.481800209833,0.359646539333,0.116397786233,0.120912332333,0.269774365167,0.216053466667,0.104579031283,-0.861804290333,-0.387064779,-0.12333222625,-0.356247721,-0.864732219833,-0.149475995333,0.122260116667,0.2825856235],[-35597.0784667,1489.39783,-1588.78596,-1990.82138167,2055.79887833,-117.507151833,-240.6283835,172.2656735,1165.21874833,-340.924040667,-306.386873833,772.3252315,-1495.923715,-620.797629833,-1212.37419833,202.892855167,-368.793152167,-172.664325333,365.087060167,158.5014155,352.919721,-155.873686333,384.559821333,-134.563291167,-109.529816833,-90.9968124,2.92587314167,-34.6123955333,158.245686,25.6059981333,261.066739333,-85.1539127,153.208293833,113.665173567,-81.9369537167,-17.9959730667,5.15806326167,24.7551685167,9.18510327833,42.9895132167,56.94538355,62.1019256,47.8818063,-8.491863,24.3228719833,-69.7503239,-57.81956875,-27.3404743167,7.91934819333,15.6723548333,19.64194975,16.8788805667,13.98337325,31.0466958833,-0.582074132167,9.11963643833,-1.25446300333,-3.11229344167,-4.13843418333,-20.3126956,-3.94566701167,21.2908474,19.0910929333,1.66592189,6.53762981667,8.773239785,2.720811045,3.18519006,7.90977106,-1.82012493833,0.7292557545,-4.934923225,0.0242061436167,-0.371366813667,-8.67440422833,-9.29173805667,6.10835265167,4.76474362167,-1.77060242667,-6.08639474,-0.339619242667,0.543966928833,1.90645405667,-0.185172817833,1.18817874667,0.451980508167,0.501509766,0.950520248,-1.67742120333,-0.05160747135,1.48552098,-1.24513956833,-0.982644226667,-0.360910459217,1.73427984,-0.00883145718667,-2.12258634333,-1.5848807,0.5550857585,-0.228809949667,-0.463156916,-0.206040342667,-0.09255515845,0.630043530833,-0.627717369333,0.492199177667,0.343456068333,0.0781538438833,0.111920706833,0.209553777,0.200287652333,0.0783610565833,-0.939543931333,-0.395359373333,-0.161038966333,-0.361076643667,-0.894082424333,-0.176014310167,0.1005030601,0.291186011667],[-35472.9691833,1399.709165,-1441.477485,-2041.81340167,2021.85661167,-120.0730785,-314.751802833,109.296976958,1220.25094667,-388.210287167,-284.003682667,809.4798275,-1418.01152167,-576.2158415,-1142.61950667,213.9965395,-377.132569667,-168.106307667,364.4366725,177.620233833,402.863243333,-172.597199833,405.6835805,-128.1938845,-113.135121,-94.6896345667,7.16146259,-41.4335872667,169.938772,38.5982380667,249.2967585,-85.3954382667,151.190699,91.5161667833,-76.54160425,-20.7468443333,5.07785068333,27.0117985833,7.401530995,47.6081721167,58.6141548667,58.0555466667,44.7806739667,-8.67933468667,14.7132203183,-65.7652239833,-59.3121986833,-23.0066710167,7.551007485,15.7066501833,20.6742727167,16.0702116833,14.8794454,30.71782345,-0.662129010833,8.43258602,-1.41065595333,-4.29638939167,-2.66000742333,-20.7772010167,-2.27181575367,19.6674996833,18.3584856667,1.92392730667,6.37531085167,9.15808721167,2.50073186833,3.30216339167,7.538188155,-1.41387523433,0.667579049,-5.36451447333,0.0108542579333,-0.322630482833,-8.89738905167,-9.16306263333,5.28008785167,4.51232838667,-1.83688859833,-6.04802409,-0.185586364867,0.514822312,1.95082629667,-0.185997397333,1.21032604333,0.2729734122,0.627102428,0.937187041833,-1.85313702,-0.0489431344833,1.35915852,-1.303449355,-1.03948325567,-0.6474824255,1.67502762167,-0.0544409597217,-2.12777270167,-1.60961765667,0.491659455333,-0.203127355333,-0.440792241,-0.232519167333,-0.08722319475,0.637147714,-0.671228449667,0.502734762333,0.327071136833,0.0420557663667,0.103647178433,0.1437192632,0.186197530333,0.0465694282533,-1.00649164383,-0.407226944333,-0.197067662,-0.3623396595,-0.9187297235,-0.207177181167,0.0778182386667,0.300634279],[-35433.4640667,1399.79105667,-1238.78482,-2119.16096333,1997.400115,-99.5091882667,-379.587301167,-16.0900101667,1269.90311,-443.7005365,-260.099466333,854.948404167,-1346.286325,-533.496384333,-1070.18467,225.275912,-389.1352345,-164.482446333,361.962463167,195.414960167,450.292839833,-191.284904833,428.946936167,-128.5452755,-115.8926155,-99.4727516,11.5582744017,-49.1465854667,181.7181295,50.8451415,234.949786333,-84.5263508167,144.432288833,68.4666657167,-71.80498725,-23.3083884,4.96935821167,29.4164752167,5.34261694667,52.1801656333,59.7565835,53.2630455,41.46024985,-9.682977505,4.77341706167,-61.7613215,-60.2164822333,-18.6974093167,7.18303432667,15.7826474167,21.7215377667,15.1264898667,15.6961746833,30.2234813167,-0.786787973667,7.69001266667,-1.700468225,-5.40324605,-1.31970717117,-20.9557524167,-0.716462308667,17.9627538833,17.4917637,2.17535497833,6.20457590667,9.53823033333,2.263251215,3.40129073333,7.141204335,-0.973198770167,0.600685524167,-5.78619349,0.0402348856,-0.321814516333,-9.0023858,-9.06609186833,4.45931998167,4.20969153,-1.88304665667,-5.96419497667,-0.0332643059667,0.482431027333,1.99054190333,-0.1814842445,1.23404019,0.09456022295,0.762815401333,0.924317150667,-2.01662933833,-0.0352647746667,1.208038845,-1.33927566333,-1.11920543833,-0.919718178833,1.590514885,-0.0949447576333,-2.11629881,-1.62752989667,0.418961965333,-0.177590262833,-0.417201621167,-0.260835264333,-0.0804428306333,0.645636652667,-0.710888416167,0.512475161333,0.311187269667,0.00808881281667,0.0964209405333,0.0725522010633,0.173314711333,0.00878162429667,-1.06255541167,-0.422853928667,-0.231243718667,-0.360491129333,-0.938668699833,-0.241704720167,0.0543362801167,0.31079677],[-35458.1226333,1495.230385,-1002.63662883,-2226.537305,2000.16081,-59.9180871217,-426.362702,-188.635268208,1310.53336333,-498.962634667,-234.875898833,909.702653,-1281.32113,-492.179335667,-1001.76699683,235.9936075,-403.204059167,-161.4121165,357.951249,211.414278,494.860170833,-212.056413,453.2184185,-135.263354333,-117.985634,-105.609135267,16.0923125167,-57.6197731,193.297194833,62.2387373167,218.578340667,-82.8350456,133.053424333,44.9959691833,-68.1300431667,-25.7446540667,4.59119838833,31.90473135,3.07933852567,56.6070543333,60.3800820333,47.9382269,37.9655482667,-11.5301192433,-5.32030206167,-57.8987683167,-60.5578557833,-14.39637575,6.80968967833,15.83622795,22.7629248333,14.0654412167,16.4190575333,29.5737247167,-0.9467469125,6.92222991,-2.13155929,-6.42210264833,-0.1617203565,-20.8438244167,0.719157062,16.2232287333,16.5091758833,2.421839245,6.02023746833,9.90843345,2.00404667,3.47678461167,6.72939599,-0.516313387667,0.538695593,-6.19184741333,0.1092980821,-0.372805073833,-8.986850945,-8.999266095,3.662634365,3.86257208,-1.915391905,-5.839383925,0.1185947413,0.448338944333,2.02568699,-0.176438561667,1.25675606833,-0.0794289477,0.902624748667,0.914125977167,-2.16445991333,-0.0107820475667,1.0334082015,-1.35183353333,-1.22172610167,-1.17416583967,1.48211987833,-0.13246789095,-2.09024910333,-1.63809674333,0.340621423333,-0.151286477833,-0.392037349833,-0.290316253667,-0.0736289421833,0.65520876,-0.7464685155,0.5207405855,0.29635194,-0.0233624222,0.0907278881667,-0.00345373546333,0.16156436,-0.0351044786133,-1.10787253667,-0.442185673,-0.263405948,-0.355961681333,-0.9538263125,-0.277755322667,0.0303145429967,0.3211656585],[-35528.0263,1646.17719667,-751.921254,-2368.91632,2030.56725,0.23178903,-464.6512605,-377.1486755,1339.33836333,-548.996540333,-204.821924,969.256019,-1217.62684167,-450.904684,-938.1680695,246.400332833,-417.643616667,-157.385342833,352.006727,226.611699167,536.3156685,-232.8093015,477.713936833,-147.087185833,-119.1720015,-112.977816,20.8669551833,-66.6055776333,204.649674167,72.6445457333,201.229865167,-80.52860965,117.71140975,21.433635075,-65.80245405,-28.0356424167,3.87661544333,34.38049495,0.763565577667,60.8344366333,60.4787205167,42.3781799667,34.3124460667,-14.0244457833,-15.4543899117,-54.2315985833,-60.41308195,-10.0432102,6.41847490667,15.8504958667,23.7614776333,12.93147075,17.0445072833,28.78023765,-1.11509956333,6.140834765,-2.64728997167,-7.35792313333,0.8269461815,-20.4633357667,2.05974457267,14.4923128667,15.4448204667,2.65453654833,5.823507165,10.26093827,1.72764189167,3.52644771,6.31666034333,-0.0550169363333,0.487616662833,-6.55916059667,0.2121503455,-0.455421200167,-8.85554253667,-8.94761725333,2.90282635667,3.48626027833,-1.93916705,-5.678017845,0.267400994333,0.412922138667,2.05652475333,-0.173000683833,1.27659136333,-0.243539774683,1.04281070483,0.9090124385,-2.290782455,0.02408849055,0.843933023,-1.34156404167,-1.34180976333,-1.40970299333,1.35493318333,-0.169208341333,-2.05075795333,-1.64149275,0.260216362167,-0.124062570983,-0.366070538667,-0.320146925,-0.0677164997167,0.665431890167,-0.777179306667,0.527447100833,0.283614598167,-0.05154129145,0.0871252258833,-0.0820094806033,0.1508412095,-0.0832999236333,-1.14353536167,-0.463749755833,-0.29370881,-0.348290585667,-0.964415357667,-0.313388278,0.00590548043667,0.331343475833],[-35623.0525333,1768.19831667,-526.177395,-2543.30231,2077.41046167,78.6574860117,-503.0127695,-554.6484415,1356.70688167,-590.079259833,-166.048145667,1028.7412005,-1150.85717167,-407.644648833,-881.252261333,257.527236,-430.411810667,-150.474325667,343.329469667,241.846514333,574.460366833,-251.994148833,501.394776667,-162.369513333,-119.107384333,-121.2108185,26.0993918333,-76.01012175,215.784910833,81.8759362833,183.732145333,-77.9331035,99.1878201833,-1.92470331667,-65.0296676,-30.17953425,2.84016407333,36.7595178667,-1.48749040933,64.8391461167,60.0057487,36.82747635,30.4599875667,-16.9521138,-25.5312219,-50.76829905,-59.8740493833,-5.59877646833,5.981575955,15.8253356167,24.6765183167,11.7701043167,17.5790169333,27.8395158667,-1.27014113,5.340994865,-3.20061445,-8.22164684667,1.6722430965,-19.8446466333,3.31654146,12.8066341833,14.3297134167,2.86023353333,5.61686278,10.5856114333,1.44400735333,3.54995622167,5.913937795,0.400434325167,0.450277168667,-6.87142188667,0.340581287167,-0.5469850035,-8.61513634167,-8.89964977333,2.18872089167,3.09416321833,-1.958227835,-5.48353402667,0.409925218333,0.375916050333,2.08271238667,-0.170820615833,1.29162397167,-0.392116157167,1.18065446333,0.910994477333,-2.39130326,0.0683382194833,0.647934005167,-1.30918698667,-1.47514992833,-1.62666506,1.212924585,-0.206804419167,-1.99829791333,-1.63752133333,0.181198468833,-0.0957677567667,-0.340457355833,-0.349522985833,-0.06307361545,0.675697143333,-0.801795815333,0.532851797333,0.274084640667,-0.0758611288833,0.0860589224333,-0.16113552405,0.141038591333,-0.13410235045,-1.17100321,-0.486346725833,-0.322127004833,-0.336721711667,-0.9703457115,-0.346667409167,-0.01881262872,0.340891229],[-35714.5659333,1808.21066167,-330.084954667,-2735.00467,2133.83814,173.09164735,-535.826106333,-712.383610167,1365.647225,-619.757424,-118.127981933,1086.78025333,-1080.96032833,-362.101791833,-834.874763833,270.2443715,-440.194546333,-140.0462455,331.156473833,257.519719833,608.649750167,-269.168532833,523.3621425,-179.273009,-117.683335833,-130.063766667,31.83845935,-86.01487275,226.819555167,89.7713170167,166.593707167,-75.31017225,78.3072775167,-24.6896069417,-66.0655556667,-32.23321805,1.50184639823,39.00493545,-3.66984561833,68.6396399667,58.9528294833,31.4730971667,26.3685678,-20.1360905833,-35.4009356,-47.56005035,-59.0246382667,-1.06591223833,5.470263045,15.7684211,25.4935253833,10.6083564683,18.0287492167,26.7565007167,-1.39002446667,4.51613333833,-3.77315217167,-9.00899978167,2.38096726333,-19.0172252167,4.47948755,11.1941234117,13.1940036667,3.03035382,5.40475513167,10.87643565,1.16592674733,3.544048865,5.53046080667,0.8421849345,0.428418250667,-7.12346679333,0.486503637833,-0.632021518167,-8.27242310667,-8.85061959667,1.52627637583,2.69880588667,-1.97278772333,-5.25820691,0.544519233,0.3372560595,2.10321593167,-0.1672382085,1.29899560167,-0.521044065,1.31345959833,0.921501488667,-2.46445492833,0.119510801283,0.4517910015,-1.25533564833,-1.618985425,-1.825244215,1.059460598,-0.245089046667,-1.933119685,-1.625930735,0.105994143883,-0.0661119611333,-0.316348250667,-0.378131569333,-0.05953744,0.685277568667,-0.819489932667,0.536991498,0.268624677167,-0.0958971366167,0.0872931300333,-0.239215691667,0.132133387333,-0.1861494935,-1.19135812,-0.509169212,-0.348070410833,-0.320766897167,-0.971469092667,-0.376160031333,-0.0438747647,0.3495052555],[-35770.1140833,1765.63748167,-152.371622067,-2924.15279333,2199.322725,276.5425795,-557.224628167,-856.3584715,1369.43728333,-637.743758,-63.0529256833,1143.13916667,-1009.9613055,-312.334776167,-801.409193167,284.749919833,-446.701362167,-126.196160167,315.191101,273.674684167,638.641304,-284.467663,542.7827415,-196.977815,-115.001992167,-139.399073167,38.0435993667,-96.7881120667,237.892253833,96.22640165,150.0645135,-72.8402934167,55.7091663833,-46.499149,-69.0249414833,-34.2570998667,-0.1136286104,41.1102152833,-5.855535525,72.25201935,57.3048620333,26.4112386667,22.0158873,-23.4503808167,-44.9054362167,-44.6768073833,-57.9114271667,3.501168645,4.86808574833,15.6853979,26.20904235,9.44572010667,18.3891076333,25.5337096,-1.457879455,3.66612541,-4.34951605167,-9.70280557,2.94499652667,-17.9980293,5.52732507833,9.67315058333,12.07232065,3.16088759,5.19012736167,11.1280361333,0.903225344,3.50419425333,5.17349165,1.26691313417,0.424197331667,-7.31394311667,0.644480402,-0.7054547505,-7.83336324,-8.79931969667,0.919450314667,2.31163430333,-1.97855460667,-5.00577037333,0.670181171833,0.296742804833,2.11663603667,-0.158660101333,1.296106985,-0.627099453333,1.43888610333,0.94159286,-2.51069057667,0.1752145995,0.2598674839,-1.18067588,-1.77029918833,-2.00422409333,0.897636677667,-0.282119890333,-1.85600206833,-1.60748948833,0.0364890751167,-0.03489150063,-0.294586379333,-0.405772706,-0.0564741373167,0.693466022,-0.829689626833,0.5395894825,0.267800997667,-0.11150905895,0.0902245025667,-0.314682640333,0.124035512167,-0.238277830833,-1.20495998333,-0.531889270167,-0.370733216833,-0.300522072333,-0.968052662667,-0.400707852167,-0.0690978595,0.3571060245],[-35766.38235,1671.03603833,16.9239137333,-3092.09354667,2275.86078,379.778348167,-563.064387,-999.337645,1370.89408833,-645.171813667,-4.38312011667,1198.67328667,-941.630466167,-255.779033333,-781.967564333,300.838559,-450.195545167,-109.6543033,295.739117167,289.861371333,664.3060375,-298.364639833,558.968112333,-215.259778167,-111.295806333,-149.159215167,44.5509000833,-108.384795383,249.056461333,101.136337283,134.117988833,-70.6597194167,31.8763873017,-67.0631416333,-73.96315915,-36.3246383333,-1.9934377501,43.0697253333,-8.13797418167,75.68360645,55.0562634667,21.6519468833,17.3840001333,-26.7839611167,-53.89229565,-42.1904498,-56.5732983,8.036628595,4.16236059667,15.5742918333,26.8266776167,8.26372660333,18.6531052,24.1853385667,-1.46424248333,2.79452957667,-4.91578592167,-10.2710511533,3.34725134833,-16.8048870667,6.43584612,8.254748305,11.0019174333,3.25072703,4.97274985833,11.3376143333,0.661382335333,3.42543033167,4.85347015667,1.67458762167,0.441744758833,-7.44530884333,0.815075060667,-0.766868525667,-7.30512999667,-8.746352555,0.370052849667,1.94523143667,-1.96899668167,-4.730656055,0.787069619667,0.253803446,2.121980985,-0.1417126235,1.280269195,-0.707325926333,1.555369755,0.972922112167,-2.53224744833,0.233888525833,0.07556446855,-1.08604674717,-1.92655204167,-2.162649665,0.730795016167,-0.3150058425,-1.76803980333,-1.583822405,-0.02583432795,-0.00163010040333,-0.275725758833,-0.432342280667,-0.05315798415,0.699478333833,-0.832290319333,0.540173215333,0.272180656333,-0.1228352595,0.0940531827167,-0.3859860555,0.116787414333,-0.289411034167,-1.212066775,-0.5541980415,-0.38915016,-0.276147280167,-0.9607131755,-0.419373954,-0.0941768133,0.363846102167],[-35696.9920833,1534.88521667,179.776170933,-3228.06344,2362.18074,483.369465167,-563.967926333,-1140.99382867,1371.73005333,-642.354104833,56.3214396833,1251.56819667,-876.009347667,-192.772688833,-773.551605167,318.231012333,-450.335428167,-91.23752235,273.339312833,305.857345167,685.007293333,-309.972952333,571.187071167,-233.550884167,-106.720217667,-159.1627295,51.1058049667,-120.528516333,260.1747325,104.172813,119.065471833,-69.1072980667,7.39469199,-86.23835175,-80.8146359333,-38.4458934667,-4.116587355,44.82503205,-10.46016372,78.8691516167,52.1801584167,17.2239886167,12.4080936883,-29.9622105667,-62.31540505,-40.1073153333,-55.1175636833,12.50483614,3.35734947667,15.4318337167,27.33130725,7.07366951167,18.79814655,22.7415952667,-1.42296524333,1.8922171075,-5.43320976167,-10.7068835667,3.60150727667,-15.4952814667,7.21653403833,6.93636652333,10.0260172183,3.29888019167,4.75164481833,11.50208575,0.443161657167,3.30018025333,4.58714056167,2.05583767833,0.482965166833,-7.51740731833,0.9969216425,-0.808412861167,-6.70967289833,-8.682642035,-0.126237388167,1.616804415,-1.94040867833,-4.43603668833,0.894346907833,0.207954396667,2.11998612333,-0.115559874817,1.249279285,-0.7574854125,1.66005360833,1.01752167683,-2.53160254667,0.294274455833,-0.0959568953,-0.976145221,-2.08206632667,-2.30300747667,0.564575535667,-0.341844853667,-1.67028178833,-1.55663431833,-0.0794906394167,0.03374051487,-0.260103806167,-0.4572278925,-0.04937075515,0.703014991,-0.827069306333,0.538341130833,0.282610792833,-0.130252388333,0.0983588483,-0.451428306,0.109805892333,-0.337771190667,-1.21423703333,-0.575116294167,-0.403051751333,-0.247605085167,-0.950523319833,-0.4314408465,-0.118821786217,0.369856441667],[-35568.10655,1374.06262333,330.607917,-3330.20446333,2457.33903333,587.9474445,-572.218194333,-1277.95369333,1371.32787167,-630.533345667,117.39009495,1298.98102667,-812.442474333,-123.59834255,-771.089309667,336.261025167,-447.183455333,-71.86269265,248.627996833,321.149343,700.510075833,-318.162829,578.867059833,-251.554447167,-101.3695576,-169.2706265,57.4265652667,-132.858813,270.891979167,104.974458167,105.15464275,-68.561667,-17.1911957483,-104.000258267,-89.39448905,-40.5610518167,-6.46683141667,46.2987907833,-12.7553629333,81.6719685167,48.6226997333,13.082698085,7.02741371,-32.8302505667,-70.1705935667,-38.4164113833,-53.643614,16.8749235333,2.47538307667,15.2536072667,27.6998074,5.88663858333,18.7896112333,21.2244532,-1.373062075,0.946231015383,-5.86266512167,-11.0143336333,3.72979857833,-14.1279171833,7.89489647333,5.70806894,9.18614659333,3.30538713667,4.52683756333,11.6176067333,0.248824030617,3.12159506,4.38736294167,2.39628451,0.547747917833,-7.532317135,1.1887334825,-0.8252799395,-6.07021535833,-8.59793497333,-0.576135930167,1.341491945,-1.88966409,-4.12397157833,0.990272396333,0.159272049667,2.112049155,-0.0803094561667,1.20210837667,-0.773653801,1.74961985333,1.07720921667,-2.51267065833,0.355859033667,-0.250861834883,-0.856156493,-2.23073822,-2.42792857667,0.404744025167,-0.361047804833,-1.56322684,-1.52747763667,-0.123064879833,0.0708426496,-0.247777132167,-0.479444590667,-0.0448743551833,0.704121671833,-0.8136153275,0.533835929833,0.2997903745,-0.134585785,0.102929612767,-0.509744355,0.102376449917,-0.381937122833,-1.21300564333,-0.593753016833,-0.4124979965,-0.214884595833,-0.938579209167,-0.436237995333,-0.1427251065,0.375241428667],[-35402.2879,1219.91231,476.2336595,-3401.90412833,2562.24367,694.217423833,-592.3613305,-1410.08985,1367.24932,-611.527404833,176.550458167,1340.38330667,-751.121958167,-46.3602604833,-769.931090833,353.6358505,-441.180019833,-52.61607265,222.6885765,335.046202333,711.576451833,-322.320383833,581.730672333,-269.113172,-95.4558945333,-179.449407667,63.2083904333,-144.978888833,280.847601,103.485030167,92.4076067333,-69.2165960667,-41.3534283667,-120.3189335,-99.3932040333,-42.5994397333,-9.06822088,47.4185606167,-14.98460135,83.97234295,44.379742,9.136643445,1.24517438667,-35.2279708667,-77.4406515667,-37.0586191,-52.2259132333,21.1240911,1.55316922267,15.0186249333,27.9129264833,4.69851301167,18.6018550333,19.6493885167,-1.35164786,-0.0410344193,-6.16498066833,-11.1925968167,3.76256844,-12.7509994167,8.49829214167,4.55286934833,8.51935542833,3.27563419,4.29434733833,11.6816763,0.0732238518,2.88569620833,4.25869381167,2.68544845167,0.637513270333,-7.49419490333,1.39098307667,-0.814217785333,-5.40543397,-8.48206442333,-0.987891747167,1.132570255,-1.81333734,-3.79585054667,1.07408185283,0.107776124583,2.09996780667,-0.0377843006733,1.137967565,-0.754837398167,1.82162176667,1.15316166167,-2.48089918333,0.419054777333,-0.386995241833,-0.729592613667,-2.36717581333,-2.53937568667,0.256731383667,-0.371400478833,-1.447124335,-1.497668285,-0.155431099,0.1092603791,-0.238319994333,-0.4979226825,-0.0397794835167,0.7026098085,-0.792036638167,0.5263696885,0.323983554333,-0.137198775667,0.107922612,-0.560254870667,0.0943589942667,-0.420918832167,-1.20931628,-0.6091563355,-0.417838227667,-0.178042306833,-0.925798625667,-0.4332548605,-0.165540383667,0.380074981667],[-35244.5160167,1045.50310133,607.227298,-3444.31405,2666.12327167,797.0817085,-626.319415,-1545.26775333,1359.80109333,-587.0160835,230.514012667,1374.9663,-695.649818,38.6923118167,-770.05813,369.8957495,-432.065594667,-34.5955542833,196.345251667,345.998488667,718.381841333,-323.568422,579.841415833,-286.409955833,-89.1230936833,-189.464581833,68.2103649,-156.483506333,289.621121167,99.6554291,80.4601504667,-71.1098819333,-64.8542839833,-135.104017,-110.65048325,-44.5358342833,-11.9238017733,48.1479136,-17.0737096833,85.7031458667,39.4945364333,5.26665121833,-4.90074047333,-37.1199439167,-84.06925565,-36.0306754833,-50.9436487,25.2362908333,0.608124495,14.70093365,27.96357155,3.51703668667,18.2339748667,18.04657525,-1.38105145833,-1.06092824795,-6.335057295,-11.2270811167,3.7136882,-11.4109417833,9.04553431167,3.46042882,8.05019757167,3.21333073833,4.04738842667,11.6936080833,-0.0881330982167,2.59359198167,4.206922105,2.91981239167,0.754663839667,-7.41068317667,1.60778559167,-0.776578888167,-4.73021661667,-8.33071852667,-1.367236028,0.997661616,-1.70983710833,-3.45362081,1.14607639667,0.05282699607,2.085167315,0.00909594412333,1.05609643383,-0.700699850833,1.87520745667,1.246526485,-2.44075846333,0.485237802833,-0.503985579167,-0.5980062525,-2.48858248333,-2.63851919333,0.124099357975,-0.372327601667,-1.32296104,-1.46746173667,-0.176133422833,0.148993220333,-0.231319759333,-0.511857049667,-0.0346589365,0.697986230167,-0.762769727333,0.515809947333,0.355367101667,-0.138977296833,0.113722984167,-0.602787783333,0.0862766998833,-0.454356798333,-1.203793855,-0.620766417667,-0.419400077,-0.13764446875,-0.912510856667,-0.4224440295,-0.186948113333,0.384321236167],[-35138.6394667,791.990088667,686.719729333,-3461.36101333,2752.981785,889.122651333,-680.847428833,-1687.72940333,1350.04832,-558.1899275,277.609064167,1400.519015,-649.318648667,129.654878883,-773.858867167,385.358369667,-419.135175167,-18.464282665,170.274913833,352.253591,720.521880333,-323.7440915,572.898289167,-303.659961667,-82.3380715167,-198.954562167,72.1346687333,-166.917546667,296.722366667,93.3533121667,68.8124387167,-74.3971318,-87.5740545167,-148.238144667,-123.039727333,-46.3651218167,-15.0108039167,48.41040335,-18.9245268667,86.7989119333,34.0124407667,1.34814344667,-11.403014745,-38.5356258,-89.98876685,-35.3463610167,-49.8756412833,29.2175676667,-0.363186166667,14.2798322167,27.8444763333,2.357649945,17.6919052,16.4514841667,-1.47614843667,-2.10925108167,-6.38645842,-11.1011246333,3.590536545,-10.1522267783,9.553472995,2.43741092667,7.79680858167,3.11833405333,3.78013143833,11.6563502,-0.237034633667,2.24875177167,4.24018037667,3.09942636667,0.901578116667,-7.28977108333,1.84330719167,-0.715064902167,-4.057139035,-8.14338733,-1.71495836833,0.942172869667,-1.57998938833,-3.10371274833,1.20697941,-0.00641397953667,2.06972165833,0.0580641922767,0.955980129667,-0.610016132167,1.91043975167,1.35863303,-2.39528666333,0.555719381,-0.601995298,-0.462093548833,-2.59404202167,-2.72635755,0.00965556258333,-0.364098273833,-1.19316907333,-1.43750472833,-0.184588362,0.190317408333,-0.226614225,-0.520649567167,-0.0300491516667,0.68963763,-0.726021681167,0.502118655333,0.394233083167,-0.1403454125,0.120641973,-0.637306206667,0.07880694235,-0.482288177167,-1.19733437167,-0.6282087885,-0.417550128333,-0.0944380048833,-0.899076242167,-0.403779195333,-0.206678261667,0.387953093333],[-35086.65425,485.697566833,705.9193935,-3457.293515,2827.52533333,970.683700833,-755.300916167,-1836.48204,1336.40664167,-524.1694115,317.805723167,1419.5094,-611.971661333,223.561093167,-783.488096167,399.096682,-402.184102167,-4.556359985,146.315411667,353.222964333,717.901294167,-324.3766635,561.098925333,-321.158558333,-75.3863574833,-207.878593333,74.7404097667,-175.717949333,301.885403667,84.7283489167,57.15221915,-78.9881622167,-109.456221267,-159.4970855,-136.312717333,-48.1008731333,-18.4047687,48.1301834833,-20.4660903333,87.20459255,28.0763986,-2.66515435833,-18.1532180167,-39.51204015,-95.08307405,-34.99551795,-49.0212749833,33.0797323167,-1.34603074567,13.71519425,27.5477561167,1.21902194047,16.9733929,14.9184060333,-1.62562508833,-3.15182974333,-6.33251852,-10.77137815,3.39610800833,-8.98371600333,10.041493645,1.49075796417,7.77114706167,2.99898783667,3.48583415833,11.5738492667,-0.380848507333,1.85381549833,4.36544855667,3.231797105,1.08477024617,-7.13628404333,2.11068098,-0.634170245167,-3.3883073,-7.91867267833,-2.028890095,0.971185475333,-1.42547837667,-2.75195133333,1.25940915667,-0.06954761153,2.05568617833,0.10539156455,0.8381710135,-0.483706236,1.92850519333,1.49003693833,-2.34507363833,0.633346374167,-0.6812670265,-0.320410537667,-2.682191985,-2.802698635,-0.0834985922917,-0.347473779667,-1.05956427383,-1.40864318167,-0.180849681833,0.23355443,-0.223401823167,-0.523995996667,-0.0267802303833,0.677322574833,-0.682752633333,0.4850601445,0.440271519833,-0.140863080333,0.128973467667,-0.663615061167,0.0730011412333,-0.504605935667,-1.19029409333,-0.6309550915,-0.412877392167,-0.048865145065,-0.885898084333,-0.377625610833,-0.224529704833,0.391035534],[-35074.7218667,183.74053815,688.8743475,-3439.20935333,2902.06908167,1049.77337783,-843.252009333,-1985.82858833,1314.79861333,-483.172963167,351.4614355,1436.74275333,-580.597596,316.114603167,-799.3040325,409.235719333,-381.248608,6.62510620167,126.639756,349.086029833,710.359614333,-326.3551485,545.256754667,-339.124772833,-68.72045915,-216.390077833,75.7713452667,-182.322088833,304.927706833,74.0284539167,45.3691893167,-84.59637045,-130.437558667,-168.715203167,-150.225038667,-49.73799275,-22.2520391,47.2298096,-21.6384024,86.84711205,21.8698697167,-6.76662272833,-25.0014167333,-40.0647787833,-99.2564509,-34.9593341667,-48.3328664833,36.8670593,-2.308172935,12.9513505833,27.0602730667,0.0925352385333,16.06338045,13.5084659,-1.80988472,-4.1493944,-6.17738009,-10.1905058583,3.13681537333,-7.89453734667,10.5473817,0.622888908833,7.97601769333,2.86839881667,3.15704304167,11.4482037667,-0.5308661525,1.40839982233,4.58768855333,3.324827405,1.30995026667,-6.95152416667,2.42601855167,-0.536028911333,-2.72077116167,-7.64953333333,-2.30613614,1.08744389733,-1.24883791333,-2.39995573667,1.30668083667,-0.135137073067,2.04494525667,0.146095738833,0.703166031833,-0.3241655045,1.93016092833,1.640647495,-2.28936999,0.721416682167,-0.741146127833,-0.170844236833,-2.75051347167,-2.86662958667,-0.152266015483,-0.323700807333,-0.922425999167,-1.38099907167,-0.165558906167,0.278980422833,-0.220359093833,-0.521525475,-0.0258735828333,0.660903678,-0.634277928167,0.464104232,0.4929390705,-0.1397823335,0.138930469167,-0.681281053,0.0699045913833,-0.52099855,-1.18262145167,-0.628146762167,-0.406139931333,-0.000982677443333,-0.873104294167,-0.344586796667,-0.240395521333,0.393661345667],[-35089.7869333,-66.8283282333,680.352725,-3410.08392167,2983.49452833,1135.58550167,-937.225834833,-2125.59961,1282.49277167,-435.028585167,377.947171,1456.40647667,-550.2666415,402.991022167,-818.711216833,414.102951167,-356.561720833,14.307191225,113.059892167,340.510791667,697.834549167,-329.428917833,526.259449833,-357.1730995,-62.7778415167,-224.561110667,74.9961740333,-186.255382333,305.711112,61.59094275,33.5826407833,-90.8936088333,-150.1877235,-175.779129667,-164.3644745,-51.2670980167,-26.6499764,45.6699029333,-22.3973627,85.6355247167,15.6029155,-10.934202125,-31.7894164833,-40.1351504667,-102.432962733,-35.1321673667,-47.7506967167,40.6513310333,-3.215452575,11.9449990667,26.3796391333,-1.03010091287,14.9383278667,12.2841264,-2.01782064,-5.05974560667,-5.91590605667,-9.31788134833,2.84626532667,-6.87142854833,11.1265102167,-0.168465918667,8.41909698,2.73987445333,2.78798306833,11.2815701,-0.696452476667,0.911510555667,4.90955085333,3.38236563667,1.58408374167,-6.73805022167,2.80392082667,-0.416680716333,-2.051303705,-7.31993150333,-2.54525787167,1.297781575,-1.05160183,-2.04606638333,1.35172582333,-0.201773169333,2.03853083667,0.176012362333,0.552150641667,-0.134785397917,1.91531495167,1.81056845667,-2.22857512333,0.8232080095,-0.7803563285,-0.0112948051667,-2.79359980833,-2.91701071667,-0.191631029167,-0.293715929667,-0.780207069167,-1.35462083,-0.139401064,0.326608205,-0.216245346667,-0.513101199,-0.0281375361167,0.640537622667,-0.582090377333,0.438759238333,0.5516124605,-0.136672245833,0.150848914833,-0.689959164167,0.0706468033167,-0.530509760333,-1.173929415,-0.618202643667,-0.398043682,0.0498054801517,-0.860784718167,-0.305105481667,-0.254220515833,0.396026754667],[-35123.4082833,-247.917470017,685.781192167,-3368.33244,3073.52863667,1226.41212,-1031.2719425,-2250.59657333,1239.73879333,-379.873243833,395.327266667,1481.06085167,-518.593971667,481.393429167,-838.5308185,412.9795185,-328.205715667,17.9104907,106.966122667,327.518415167,680.964570667,-332.961385,505.406220833,-374.788153333,-57.8487467333,-232.309851667,72.3352803833,-187.050392833,304.056129667,47.9618046,21.9459238833,-97.3465846167,-168.397059167,-180.556532,-178.309123167,-52.6937313833,-31.6165182,43.4650586333,-22.68239315,83.5137252833,9.51392801833,-15.17878015,-38.31075435,-39.68873805,-104.531772833,-35.38258045,-47.215219,44.5212413667,-4.04881754167,10.6774050067,25.5158322833,-2.151348285,13.5890820167,11.3029918333,-2.25385635167,-5.83528029333,-5.55215385333,-8.11427418167,2.57033617833,-5.89634465667,11.8402406667,-0.878634538833,9.11390225833,2.62275612,2.37647776333,11.0763567833,-0.884473701,0.365203814333,5.32997288,3.40605509833,1.91374284333,-6.50017724667,3.25855774833,-0.2695183599,-1.37263911383,-6.91100827667,-2.741983365,1.61244280833,-0.8333242495,-1.68793668,1.39681962667,-0.268806422,2.03637694667,0.192130324,0.386770553667,0.0802801565,1.884557225,1.99955448,-2.16355151,0.942174398333,-0.798025914333,0.161761715333,-2.80521625167,-2.95151725167,-0.1955613065,-0.257098719167,-0.630577874167,-1.32956901167,-0.102872443017,0.376299873833,-0.210419519167,-0.499012792667,-0.0339892664,0.616450766167,-0.527628627167,0.408999101667,0.615566422667,-0.131252758833,0.165170790833,-0.6896822755,0.0766468242167,-0.531989169667,-1.16331202333,-0.5993194535,-0.388714296167,0.104506317733,-0.849012064833,-0.259425992,-0.265982202333,0.398456475833],[-35175.0954667,-365.2565725,683.943778,-3311.107155,3169.09393,1312.01764333,-1124.65820167,-2362.74451333,1188.35818667,-318.269376833,400.225636333,1511.09457667,-486.669045333,549.179812833,-857.130353667,405.844153333,-296.130071,16.8368538833,109.420576,309.159527167,660.569616667,-336.892845,484.110169333,-391.819422333,-54.04411245,-239.414116333,67.7810071,-184.186009,299.630896167,33.7320706833,10.3912615217,-103.30841655,-184.9730825,-182.847850167,-191.682006667,-54.0052543167,-37.1068618833,40.6646274,-22.4039345167,80.4324834833,3.83856879,-19.5788843333,-44.3224383333,-38.7749504,-105.434571667,-35.6076788833,-46.6509335333,48.5522376333,-4.79596303833,9.14726796167,24.48830545,-3.267664095,12.0190106833,10.61629875,-2.53590142667,-6.4226013,-5.11224678167,-6.53033129167,2.34107311833,-4.94049578667,12.7411556167,-1.49813658317,10.0758739567,2.52231506667,1.92317353667,10.8354490833,-1.1005901725,-0.223930136167,5.84566323167,3.39726197833,2.30506331667,-6.245181265,3.80662557667,-0.0929484462667,-0.6721477773,-6.40606769833,-2.88947643,2.04249951833,-0.592426041,-1.32357788233,1.442879225,-0.335839856,2.03780635,0.191890178833,0.209632612383,0.316739309583,1.839489325,2.20666339,-2.09525123,1.08245068517,-0.794916229667,0.353541863,-2.77986470667,-2.96634849,-0.15806780265,-0.212582743667,-0.471194351,-1.30576163333,-0.05640035421,0.427591301167,-0.202580639167,-0.479754110833,-0.0436059423833,0.5889357825,-0.472173213667,0.375255885333,0.683820455667,-0.123207056,0.182407737,-0.680843902667,0.08967725325,-0.5246029445,-1.14921444833,-0.569813087,-0.377816415167,0.164126607,-0.837696948333,-0.207735771667,-0.275563593833,0.4012505985],[-35255.83965,-470.7411495,653.904467167,-3231.32754333,3258.73913833,1380.63758667,-1226.24207167,-2468.30039333,1133.49159,-252.276802167,389.8685595,1542.04323667,-458.782811333,605.950120833,-873.346845667,393.994882333,-260.358992333,10.8966376917,120.298393167,284.028761333,637.532878167,-341.143071667,463.407719833,-408.125267667,-51.2143753833,-245.437428333,61.44104035,-177.305910833,292.184679,19.3690418467,-1.18769933,-108.2612995,-199.8870455,-182.490309,-204.064328167,-55.1828721167,-42.9600667167,37.36794115,-21.4855188,76.4025335,-1.29162269833,-24.2578547833,-49.6082220167,-37.5081816167,-105.051068667,-35.6834514,-45.98312015,52.77251945,-5.45558575333,7.38808220333,23.3296432167,-4.36821455167,10.2517343,10.2333174667,-2.8988687,-6.78187369,-4.64707179167,-4.53455286333,2.18396411833,-3.97170997,13.8592999833,-2.01717205167,11.3231089667,2.43856538333,1.43471607533,10.5601592,-1.34493512,-0.84570636,6.445455145,3.35527673167,2.75802758833,-5.98558678333,4.45959223167,0.109264681267,0.0635778904667,-5.79379547,-2.98123112167,2.59889125,-0.326243702933,-0.952699418,1.488681565,-0.403085884667,2.04045074333,0.174817405833,0.0234083240333,0.570616083667,1.78255788667,2.42902161833,-2.02581422,1.24771494833,-0.774216827333,0.568969746333,-2.712709495,-2.957721555,-0.0740817745,-0.158096553183,-0.300364238167,-1.2832838,-0.000286829223333,0.4794477015,-0.193151392333,-0.456143513167,-0.0565416442,0.558251921,-0.416291436,0.338585289,0.754926798,-0.112444965,0.2031296295,-0.664507735,0.111212692883,-0.5076866925,-1.12983103833,-0.528471076,-0.364708143,0.229445194167,-0.826721243167,-0.150259370917,-0.28264624,0.404652126833],[-35370.3624167,-596.071769667,606.3611835,-3125.01501,3335.69422333,1427.78106167,-1338.14385833,-2565.02846833,1079.36057833,-185.201508833,363.358006167,1570.01637167,-437.027090833,652.831951833,-884.100379667,378.9468315,-221.736822333,0.321425866667,138.992789,251.518388833,612.8436555,-344.758042333,444.182278667,-423.036822167,-49.0524608333,-250.035328833,53.4640876,-166.347074,281.640750833,5.21958772667,-12.6633894283,-111.819980667,-212.873028667,-179.383862667,-214.980240833,-56.1697913833,-48.9739355667,33.6782383333,-19.94132135,71.4555291,-5.84743740333,-29.2981907,-54.0059985,-35.9451941167,-103.337598,-35.4474275667,-45.1521127833,57.17782215,-6.02532196667,5.458914425,22.0699992333,-5.44814628667,8.313639715,10.1239999,-3.376693425,-6.90190213333,-4.200762295,-2.124499101,2.12821011667,-2.96957004667,15.2082696833,-2.429448495,12.8675285,2.36781403833,0.924969191833,10.24837568,-1.61133190833,-1.49037264583,7.11128375333,3.27824989833,3.26231978833,-5.733695355,5.21749061333,0.333640317833,0.841356520033,-5.06837485333,-3.01224862167,3.288519085,-0.0320680965667,-0.576447812833,1.53113866167,-0.470606131833,2.04087181833,0.143394176,-0.169803287283,0.838653524,1.71595789167,2.66163470167,-1.95784766,1.43857091,-0.739519450167,0.810145509167,-2.60023996,-2.92295203333,0.0593303380833,-0.09150187085,-0.117592924133,-1.26214743167,0.06485726949,0.530446546333,-0.183168027833,-0.429009491667,-0.0716736835,0.524504375833,-0.359684107167,0.300091528833,0.8272914145,-0.0990441387667,0.227388433667,-0.6419131495,0.141828266333,-0.480846212667,-1.10367057167,-0.474787644,-0.348775530167,0.300676510333,-0.815863333667,-0.0875359862,-0.286859501833,0.408746620333],[-35505.5033333,-757.342212,575.7839815,-2992.691865,3401.79084,1454.55576667,-1453.66912333,-2635.56831333,1028.0833855,-118.46912275,320.889749667,1593.44978167,-418.0943065,691.122284167,-884.888217167,361.881332667,-181.3307355,-14.5498150417,165.048267167,212.155697333,587.372999167,-346.040096667,427.20528,-435.310645167,-47.2500599,-253.123974333,43.9551785667,-151.395377167,268.054337833,-8.49815586,-23.6737609667,-113.676505833,-223.375069167,-173.570322,-223.954669833,-56.9030794167,-55.0225701333,29.6793467,-17.8715469,65.62331265,-9.85755444667,-34.71529575,-57.4066656167,-34.04574,-100.31021555,-34.7132211,-44.1277871167,61.7766147333,-6.50324656833,3.41361387,20.7393910333,-6.523757385,6.22490592333,10.2408584167,-3.98947738,-6.79183384333,-3.797356075,0.679355812667,2.220968715,-1.93265151217,16.79537805,-2.725852665,14.7122444167,2.30769939333,0.41267098415,9.89960385,-1.894272965,-2.15042202333,7.82097241667,3.165102385,3.80245632833,-5.49984814833,6.07345581333,0.582385367833,1.66094466383,-4.22974256667,-2.97936293,4.11385065333,0.291043511067,-0.1977611135,1.56821384833,-0.536356890667,2.03590164833,0.101596419333,-0.3683891735,1.11720173933,1.641161965,2.89848759667,-1.89468122,1.65378606667,-0.694002378333,1.07673913567,-2.44170275167,-2.86120331333,0.243460078767,-0.0115941390167,0.0767792463,-1.24225400333,0.138036410867,0.579373459833,-0.173330208167,-0.399255908333,-0.0872430128167,0.487731284167,-0.30194268,0.260553285333,0.899174071167,-0.08353480245,0.254806208167,-0.6146304685,0.181391084333,-0.4443888955,-1.07016767667,-0.4087505425,-0.3296335535,0.377683412333,-0.80475885,-0.0204110349333,-0.287911452667,0.413579045833],[-35637.0842,-992.4753425,582.7187225,-2840.98993167,3452.26650667,1459.51474,-1567.62977667,-2667.58002833,979.903173833,-54.63242988,263.704740167,1608.89477833,-399.239085333,722.459381167,-873.906904167,344.246099167,-140.2372679,-32.7706172167,197.025849667,166.777364833,561.791962333,-344.072859,412.817655,-444.4922075,-45.2451670833,-254.558722,33.12312655,-132.818586167,251.695535,-21.7856348933,-33.9560048333,-113.730384833,-231.1412545,-165.290384667,-230.824123667,-57.2796019333,-60.9378078667,25.44538185,-15.4141762333,59.0145173667,-13.4546161533,-40.48878785,-59.7957718167,-31.8146258833,-96.0633511667,-33.4194968667,-42.9161304667,66.5667992333,-6.89932664833,1.31873239083,19.3626562333,-7.60492422,4.020643265,10.5083251667,-4.735227055,-6.48565765167,-3.45457672833,3.83767667067,2.482701095,-0.8755386915,18.6111484,-2.902446175,16.8395367667,2.24909176667,-0.0825110087333,9.51382625,-2.18187320333,-2.817943685,8.54997687167,3.02009939833,4.35979650333,-5.28911316333,7.01783750833,0.8552387015,2.51803946167,-3.28610168,-2.88452914,5.066824525,0.6402541775,0.178151242833,1.59698756,-0.598902288167,2.02272055667,0.0554547073,-0.571563357833,1.40388402333,1.56025361833,3.13356600667,-1.83867086,1.89182361333,-0.640753287833,1.36780027667,-2.23959243167,-2.77362573667,0.4761563295,0.0811644334167,0.2812451227,-1.22412742833,0.218210839333,0.625293174167,-0.164680898333,-0.367833723333,-0.101274524383,0.447638512167,-0.242087592167,0.220723155833,0.968973227667,-0.0665871569167,0.284873829333,-0.584236161833,0.229709236167,-0.399435327,-1.02934417333,-0.331043323167,-0.307161239,0.4598963,-0.793289821167,0.0502663902667,-0.285735181667,0.4192209295],[-35742.9782333,-1322.02188633,638.413337167,-2675.33200333,3480.04742833,1441.64905333,-1678.65246,-2662.44206667,934.6419865,2.25623764667,194.1743165,1612.377535,-380.490923667,747.6714985,-851.610450667,327.504771167,-99.4644911167,-52.8626582833,232.890723167,116.515115183,536.061309,-338.7481135,400.8025085,-451.2110425,-42.4613722833,-254.114978,21.32432235,-111.201666033,233.125817167,-34.8393617833,-43.3967674667,-112.102401,-236.383509667,-154.880463667,-235.690503833,-57.2120067,-66.5037282667,21.0497582333,-12.69634751,51.8093176833,-16.8202840167,-46.5778261167,-61.2504557833,-29.3271052333,-90.75752865,-31.62097735,-41.5474955,71.5054255,-7.228591055,-0.753555785,17.94964905,-8.68771713167,1.74076921167,10.8413907167,-5.59458741333,-6.03468047833,-3.18575082167,7.29826893667,2.89394937333,0.1772915615,20.6244298833,-2.97434717,19.2103437167,2.17970390333,-0.54704288035,9.08662122667,-2.45752869167,-3.487897625,9.27708607667,2.85130206667,4.91552667167,-5.10075123,8.03744587,1.14574115917,3.40207571,-2.25104131333,-2.738586305,6.12957131833,1.0108355005,0.546334710333,1.61380270333,-0.658868133167,1.99829172833,0.0117176544,-0.7795069175,1.69770744,1.47579849333,3.36117715167,-1.79035920333,2.15008659167,-0.5825280065,1.68104432167,-1.99787777333,-2.66324802667,0.751774803667,0.1855565578,0.493333533,-1.208901645,0.304043066833,0.667572956167,-0.158557504833,-0.335461967,-0.112253870167,0.403841012167,-0.178934181333,0.181321319667,1.03543324117,-0.0487225684333,0.317021035,-0.5519011685,0.286538388333,-0.347349253,-0.981493685667,-0.242964601167,-0.281520025,0.546286187833,-0.781801390833,0.12359937195,-0.280517458833,0.425727022333],[-35827.5014833,-1713.29401,732.463279333,-2505.92514167,3488.19748333,1399.11809333,-1780.17492167,-2627.19678667,890.050982167,49.60997172,114.15201365,1605.04200167,-363.493874,767.5609915,-819.6472385,311.718127667,-60.1817457333,-73.5870789333,271.4299455,62.231568155,510.388200333,-330.579943,391.047453167,-456.325469333,-38.86374655,-252.025620833,8.92660032833,-87.2073163,212.8738745,-47.7257585833,-51.9462065833,-108.931389,-239.579617333,-142.4992475,-238.718904833,-56.6899422167,-71.69767565,16.54744615,-9.87822930333,44.1770639333,-20.1037215333,-52.9262027,-61.8464188167,-26.7075748333,-84.5383671333,-29.3871735833,-40.0488229,76.521633,-7.482247415,-2.77927099917,16.4908067333,-9.79299234333,-0.587387401667,11.16065565,-6.55477902333,-5.481094905,-3.01038267,11.0177575783,3.41655149833,1.21159044717,22.7962279333,-2.96232814167,21.7795649,2.10103495167,-0.974600132833,8.61100738,-2.71774578167,-4.16162083667,9.98111180167,2.66110891,5.45270217167,-4.93610111333,9.11953511,1.44119857167,4.30173176333,-1.14252018712,-2.552041885,7.28126326333,1.39784098167,0.904568950667,1.61877656333,-0.715299130167,1.96102198667,-0.02646689525,-0.993363261167,1.99554618667,1.38894876667,3.57512483333,-1.75077331167,2.424710385,-0.523321196167,2.01299161667,-1.72251722,-2.53360918,1.062956927,0.300370378167,0.710351576167,-1.19729978833,0.394512887,0.706251157667,-0.155041692333,-0.302333167167,-0.119240515167,0.3562260335,-0.112357741033,0.142689211833,1.09722077167,-0.0307180642167,0.350451580833,-0.519156519,0.3512555535,-0.289894406667,-0.927372160167,-0.1464223334,-0.252992966333,0.635744762667,-0.7708913835,0.198757892333,-0.272557242,0.432943719833],[-35900.3820833,-2113.73021,846.672696167,-2345.31471333,3484.44582833,1332.62349,-1863.34642833,-2567.29317333,843.104612167,86.32771165,26.0428030667,1589.82029833,-348.666582,783.217940667,-779.686397667,296.465968833,-23.4550604667,-93.6544863167,311.782604667,4.89323882,485.3253245,-319.926135667,383.494097,-460.417076333,-34.5574084667,-248.680880333,-3.69037955333,-61.4732862833,191.469478,-60.4500526,-59.4681653833,-104.285647867,-241.142513,-128.261640333,-240.057108,-55.7155298333,-76.5630089667,11.9714411483,-7.12552341667,36.2947732167,-23.4418500833,-59.43811815,-61.65078385,-24.0496845667,-77.54462355,-26.78240325,-38.4501101833,81.5431275833,-7.64766018167,-4.75001779167,14.9650572167,-10.9499702117,-2.94063709833,11.3881696833,-7.597582505,-4.86349386,-2.939671145,14.9498193167,4.020492835,2.21078097167,25.0859997667,-2.88320557167,24.5015491667,2.01775990333,-1.36069529117,8.07874728,-2.963449215,-4.84286915167,10.63872028,2.45006053167,5.95442093,-4.79466512,10.2497389017,1.73135538333,5.20503170667,0.0227053948667,-2.33434266333,8.501184485,1.79567267333,1.2504954365,1.61329648833,-0.766455083,1.90961926,-0.0571295044167,-1.21466892967,2.293276995,1.29998977167,3.76837822167,-1.72051022167,2.71119671,-0.4664914155,2.35955272167,-1.41922432333,-2.38784490667,1.40249456333,0.423928354833,0.929523814333,-1.18979615333,0.488719769,0.741543921,-0.153759851667,-0.268473903833,-0.121414040333,0.304583701667,-0.04245506555,0.10495194465,1.152799555,-0.0134271697633,0.384258808833,-0.487370867167,0.423011855667,-0.228687848333,-0.867891985833,-0.04325373275,-0.221907113667,0.727083313167,-0.761110741667,0.2750184365,-0.262169290833,0.440602231833],[-35966.15975,-2485.12280833,967.321701833,-2199.79581167,3475.35556167,1248.561215,-1925.67134,-2482.457105,793.339096333,113.151014433,-65.9795853167,1568.2328,-333.612009833,794.974057167,-733.404838,281.775296167,10.3983181,-111.419174283,353.053715,-54.0361052783,461.164107667,-307.015539333,378.005653833,-463.855725333,-29.65459525,-244.317117,-16.1125008217,-34.5415324517,169.511611333,-73.1338989333,-65.7820496167,-98.2300452833,-241.3787895,-112.3724139,-239.8144715,-54.3327973333,-81.12270315,7.33939792167,-4.5735927,28.3624434667,-26.9804205667,-65.9792836167,-60.7523941,-21.4017493167,-69.9480677,-23.8534005667,-36.7860558833,86.5086842333,-7.732220185,-6.65975316,13.3475248833,-12.1821952333,-5.29120079833,11.4530819833,-8.68832291,-4.22442357167,-2.97323321,19.0344829667,4.69237471333,3.15320105167,27.4535632833,-2.74613068333,27.3324151167,1.931464545,-1.70315056333,7.48228939333,-3.194591955,-5.53361859333,11.2281541,2.22247609833,6.40438846833,-4.67353051167,11.4112017333,2.01025656,6.09951973167,1.22912082622,-2.09345046167,9.76962730667,2.19743118333,1.580060925,1.59935278,-0.811180024833,1.84275645167,-0.0781252211333,-1.44431933167,2.58702868667,1.20975554333,3.93402655167,-1.69968252833,3.00500689167,-0.414949689667,2.71641106333,-1.09361176117,-2.22855674833,1.7636285,0.553547562333,1.14771646,-1.18697184167,0.585871172167,0.773931343167,-0.154452422333,-0.234063254667,-0.117958264167,0.248629719833,0.0306568046333,0.0682619242,1.20063487167,0.00234462643,0.4176337805,-0.457934672833,0.500885621333,-0.165295345167,-0.804043546167,0.0648453663333,-0.188845535667,0.819001986333,-0.752974294833,0.351806216,-0.249654436167,0.448488929],[-36025.0657667,-2807.33201167,1101.249868,-2064.70906833,3462.50794,1157.387535,-1971.15640667,-2374.04690667,743.657070333,130.562691833,-157.559340033,1540.07536833,-315.6539645,802.234434667,-682.128512167,268.069091333,41.5039345167,-125.291654,394.224047833,-112.75612905,437.723432833,-292.101844167,374.129124333,-467.185272833,-24.33612995,-238.911357667,-27.9045251667,-6.89173552333,147.687802333,-86.0133339667,-70.7570676667,-90.9596383167,-240.585069833,-95.11710475,-237.95863,-52.6270546167,-85.3340275333,2.6918266,-2.33560469383,20.5924566167,-30.8715610167,-72.4130578167,-59.2739415,-18.7861779333,-61.94834905,-20.6001603333,-35.0690549167,91.3409345333,-7.75441534833,-8.50042084667,11.62040289,-13.5063268,-7.60899528,11.2907979167,-9.783835505,-3.60991076667,-3.10139513833,23.2013895833,5.42662118667,4.02020499167,29.85410305,-2.566912265,30.2259924833,1.841814215,-2.00370102667,6.81445051,-3.40918239167,-6.23363039,11.72975985,1.98610592833,6.78764324333,-4.56848760167,12.58476305,2.27174226667,6.970739575,2.46169772833,-1.84017988167,11.0658519433,2.59633720833,1.88967438833,1.57875362167,-0.849734421833,1.75859955833,-0.0870612709833,-1.68215171333,2.87318783833,1.11967114333,4.06577201833,-1.68863082,3.30137314667,-0.371981376333,3.07792290667,-0.750759660667,-2.05881360333,2.13936271333,0.6861711145,1.36197889667,-1.1896905,0.685025416,0.803896516167,-0.15707514,-0.199457083833,-0.10815939135,0.188229589333,0.10674799525,0.0327820880117,1.23924352333,0.0156744020033,0.449841917667,-0.432279676667,0.583639718333,-0.10118246105,-0.736834861,0.17618181935,-0.154670428,0.910163635333,-0.7470583795,0.428525054667,-0.2352161745,0.456465225667],[-36082.3349667,-3050.99378333,1253.65689833,-1926.69639833,3442.429125,1065.46557783,-2010.48039167,-2256.75694167,699.369916167,135.7950515,-246.495845833,1504.185585,-295.645545667,805.255031333,-625.436801167,255.896618167,69.4016295833,-134.081112667,434.483118333,-169.955384333,415.110068167,-275.549734333,371.475568667,-471.701597667,-18.8003923333,-232.306800167,-38.5563159333,21.0896542317,126.593080167,-99.2442599667,-74.5691576333,-82.6264028833,-239.233605833,-76.88640675,-234.268477667,-50.6525999333,-89.0695737333,-1.86882881,-0.530621094333,13.1615893083,-35.2402271667,-78.7145138833,-57.305603,-16.22630245,-53.7647894,-16.98238285,-33.2587457833,95.9141968833,-7.71785577167,-10.2504756567,9.78162158167,-14.9480012167,-9.87129441667,10.8462919667,-10.860963535,-3.05128007667,-3.30866617333,27.3830044333,6.21128562333,4.80708106667,32.2284611333,-2.37710726333,33.1333831,1.74989837,-2.26483516833,6.06992565667,-3.607368715,-6.93980732833,12.1252254333,1.74848733667,7.09438725167,-4.47679037333,13.75525425,2.50455762,7.80408867333,3.704362205,-1.58962512667,12.3675156167,2.989313845,2.17668997333,1.552241725,-0.882758298833,1.65544079333,-0.0815395778833,-1.92546431,3.14778534667,1.03175990383,4.15873394333,-1.68938977833,3.59708713167,-0.341587092667,3.437422375,-0.394991788533,-1.88160762833,2.52218905167,0.819917306167,1.56944523833,-1.19951829,0.784448982833,0.831374006667,-0.161389207333,-0.1649189645,-0.0912069367833,0.124018897217,0.185257821667,-0.00122901730333,1.26735290167,0.0251199010833,0.480618993833,-0.411583122167,0.669952350833,-0.0375401339667,-0.666835702,0.2889958545,-0.120170219217,0.999097686333,-0.744150579667,0.5042597055,-0.218864200667,0.464596571333],[-36132.4203833,-3218.98419333,1415.89229,-1783.91379667,3414.49657833,980.950578,-2036.07692167,-2135.20891833,662.482149167,130.0092385,-330.294016,1463.27781,-274.293554,803.476535833,-566.479766833,245.479849,94.1479060667,-137.086834667,472.8971465,-225.431047667,393.838136167,-258.387134167,369.142487667,-477.126382833,-13.1929019133,-224.609230833,-47.7942665167,48.8440818667,106.422498933,-112.680065733,-77.24334655,-73.57506835,-237.416871333,-57.9661985667,-228.839946333,-48.4366159,-92.3414542333,-6.28315041167,0.7184885385,6.21062038867,-40.1168026833,-84.7918247667,-54.9284524833,-13.7396613,-45.6236988,-13.0422694683,-31.3800423,100.115020967,-7.62183387167,-11.9095820333,7.83627235333,-16.5232005333,-12.0451855,10.07797486,-11.9104821667,-2.55917929333,-3.60377517833,31.4924122333,7.02807849167,5.49491723667,34.5155755,-2.184063495,35.9924377333,1.65947021333,-2.48427276,5.25108073167,-3.791274175,-7.64717684167,12.3930833833,1.50452274333,7.32264102333,-4.40234149833,14.90180965,2.70084168333,8.58700356333,4.93452630333,-1.34736364833,13.6462458833,3.366446195,2.43617905333,1.522205155,-0.9082644715,1.53370008167,-0.0615664642833,-2.172041045,3.40506641333,0.945041692833,4.21015214333,-1.70430945333,3.88927183667,-0.3268138795,3.79012476667,-0.0330028503,-1.69913256167,2.90310017833,0.950665320167,1.76582908167,-1.21602474333,0.883841740667,0.856546344,-0.166681020333,-0.130656425967,-0.0669128149667,0.0565509626333,0.265297037833,-0.033528518705,1.28398649167,0.0292716686167,0.510695169167,-0.397111289167,0.758942527,0.0242490776167,-0.594844205,0.401325822,-0.0862414902,1.0840233545,-0.744266318833,0.578556318167,-0.200783884167,0.472378119667],[-36138.5348,-3312.69345167,1586.87591167,-1638.271395,3384.78668833,915.804802833,-2033.925615,-2007.40612,631.7288445,117.805159333,-405.7518145,1421.81611333,-250.2479635,795.772439167,-507.721492667,236.077366,116.449539483,-133.870064333,508.881554167,-278.571043,374.6295325,-241.137353167,366.273671667,-482.428160167,-7.84904801667,-215.994840667,-55.54908805,75.9190335833,87.4325768833,-125.9738985,-78.5512092,-64.1803011833,-234.943251333,-38.7064520167,-221.9455085,-46.0306878,-95.2533346,-10.5499061583,1.324490921,-0.103756900333,-45.4658602,-90.4679346833,-52.2385927833,-11.2858673767,-37.7936778833,-8.87013613833,-29.4860202167,103.8562,-7.46551884833,-13.509003,5.78439577167,-18.2409423,-14.0986564333,8.95299766667,-12.9103822167,-2.14780644,-3.98929029333,35.4204048333,7.85963858167,6.05565640333,36.66069905,-1.98524804167,38.7340311,1.57739272833,-2.66500269167,4.36235543333,-3.965172285,-8.35486468667,12.5095434333,1.2477499895,7.47080174,-4.34865372833,15.99684515,2.85783602833,9.30578884333,6.12861974833,-1.115625368,14.8711352,3.715269995,2.662011675,1.49282088833,-0.9243228865,1.39437192667,-0.0290175557333,-2.42179117833,3.63805049333,0.857055670167,4.217830325,-1.73550998333,4.17389432,-0.3288850475,4.13120312333,0.327805566133,-1.51341842667,3.27263707,1.0732555945,1.94609716667,-1.238025465,0.982881562333,0.8800356975,-0.171955902,-0.09693735245,-0.035664103392,-0.0141982927833,0.345772368833,-0.06438862905,1.28829057,0.0267457302833,0.540872958667,-0.389851502167,0.849629946167,0.0827822773333,-0.521861395667,0.5111525595,-0.0539801665833,1.16288810667,-0.747059085,0.650874239667,-0.1813488115,0.479210725667],[-36073.5517333,-3365.61601167,1741.70826667,-1485.21716167,3350.25425667,873.597885667,-2009.33283333,-1876.22366167,608.771779833,102.982759783,-470.609835667,1379.262445,-223.151416167,780.213964833,-450.568626833,227.678970167,137.680198833,-123.8351345,541.4523845,-328.787141833,357.545788833,-224.272963167,361.850276333,-486.969402833,-3.01330065167,-206.274761667,-61.6144537833,102.030119633,69.9390463,-138.991479167,-78.3944886167,-54.8769254833,-231.772813833,-19.4906511923,-213.857483667,-43.5116365167,-97.81493175,-14.6270458833,1.27765542383,-5.610801048,-51.28541145,-95.6131005833,-49.3502735167,-8.86126924167,-30.5451786167,-4.572075821,-27.6375922,107.026730333,-7.265288385,-15.07215545,3.62994168333,-20.0911281833,-15.99524595,7.44610249333,-13.8398124333,-1.83294986,-4.47373142667,39.0556111833,8.67826519833,6.45337702,38.5999262,-1.78085856667,41.2937957667,1.50561830667,-2.81439059167,3.40703507,-4.13004490667,-9.059388435,12.4561886667,0.9753309435,7.53741553833,-4.32010543833,17.0119575,2.96979178667,9.94351885167,7.261339725,-0.897415721833,16.0123141833,4.02559877667,2.84624623,1.46747587,-0.930963125667,1.23759017167,0.0146062988667,-2.67387841667,3.84120616,0.766782726833,4.179955735,-1.78480597333,4.44681536167,-0.349424971,4.45498593667,0.679644502167,-1.32644461,3.62103823833,1.18347335667,2.10466618667,-1.265054895,1.08114537083,0.902508568333,-0.176588796667,-0.06426463235,0.00204306286533,-0.0881732415,0.425750528333,-0.0937579053667,1.27952526833,0.0164223525983,0.571892181833,-0.390707222,0.940971337333,0.136543015567,-0.448737457,0.616157186833,-0.0242248972883,1.23355749667,-0.752418523333,0.720638649167,-0.160823233667,0.484583053167],[-35938.6969833,-3419.386325,1834.11013333,-1320.57493333,3299.88031833,848.759202667,-1971.02588167,-1757.66141833,595.832352,85.3303694167,-524.784803333,1334.516005,-197.08723,756.842027167,-397.951132667,220.833763,158.6018745,-107.06229865,569.3222095,-376.839130333,343.242817667,-209.124251667,355.445311667,-490.120297167,1.417729785,-195.241031333,-65.7835538,126.754894333,54.0394766833,-151.450159167,-77.0150263,-45.808288,-227.927949833,-0.516437586,-204.806083167,-40.8604618667,-99.95905595,-18.4156326,0.55128717,-10.1921303133,-57.5734622,-100.215138033,-46.2917029167,-6.47722758833,-24.0354965,-0.238824420667,-25.8377290333,109.512703,-7.02044265,-16.5815156,1.39153193833,-22.0578926333,-17.70175415,5.530991355,-14.6975652167,-1.60587001167,-5.070926685,42.32406585,9.452609415,6.6751443,40.2734241,-1.57360947167,43.6135921333,1.44458617833,-2.93076538333,2.39262963667,-4.28244469,-9.75227500667,12.2146460167,0.681352677167,7.52243902,-4.32537851667,17.92638645,3.02977333333,10.4907615617,8.31094982667,-0.694637261333,17.0441532167,4.28891807,2.982832585,1.44668104833,-0.927130018333,1.06431486,0.0698257439667,-2.92566325333,4.00938966833,0.673307077667,4.094719735,-1.85483383833,4.7052521,-0.390221819167,4.75726154333,1.01554121283,-1.139670119,3.94042647333,1.27799923833,2.23730627,-1.29649559,1.178438115,0.9237207845,-0.180048475833,-0.03313202154,0.0461903325913,-0.1646944404,0.504715886833,-0.121085854967,1.25704544167,-0.00287641164,0.604383625833,-0.400447721,1.03199444317,0.18429078,-0.376027189167,0.714683350667,0.00256752106333,1.29438363,-0.760106155333,0.787369241833,-0.139435787,0.488007231833],[-35754.2341667,-3502.90411667,1812.92145,-1148.61603683,3222.09486667,829.682698167,-1925.82783,-1670.736285,592.694663,62.4221492,-571.589171333,1287.31498833,-177.775881833,726.832747833,-354.128725,215.915032,179.080206167,-84.9272917333,591.3949605,-424.3870555,332.891664333,-197.617566167,347.1024765,-491.363967,5.73924995167,-182.877189,-68.1079683333,149.709487167,39.4523100667,-162.848157667,-74.8646198333,-36.8376080333,-223.525521,18.2532267077,-194.979691833,-37.9589390333,-101.6166755,-21.8219874333,-0.860926104167,-13.85737615,-64.25546055,-104.325759167,-42.9835920833,-4.18565089333,-18.2941944167,4.05368278567,-24.0387347667,111.214826,-6.70476811333,-18.0011905833,-0.898298543333,-24.1148024833,-19.2129845,3.2058232715,-15.5014839667,-1.42418732333,-5.803740235,45.19111475,10.15640846,6.73344806833,41.6364900667,-1.36437658,45.6450541,1.396533615,-3.00540972167,1.33293884433,-4.41641888667,-10.4267677283,11.7735201833,0.353715922088,7.433569875,-4.37394909833,18.72867395,3.03342296167,10.94713505,9.26419559167,-0.507313099,17.9480400667,4.49611926333,3.067578375,1.429461585,-0.910245156333,0.8771337815,0.137349476283,-3.17325024333,4.13922396667,0.5742344925,3.96217847333,-1.94755767,4.94823920167,-0.4518064315,5.03597033833,1.33146641833,-0.953598404833,4.22605030833,1.35318188833,2.341060495,-1.33160538833,1.27465714667,0.942762169833,-0.181702935167,-0.00375506751,0.0966579123167,-0.242410031,0.582547167667,-0.145936747833,1.22076384833,-0.0320487622183,0.639258400833,-0.419296744333,1.12202774667,0.225567396167,-0.303977219667,0.8060902645,0.0258078939617,1.34421337333,-0.769821515167,0.850643175667,-0.1174120621,0.488977510167],[-35539.1961,-3572.66017833,1675.255755,-982.659228,3125.096075,814.228338833,-1878.51599667,-1618.00801,594.199081167,34.4769376283,-612.699766167,1239.28285667,-164.2868395,689.966186333,-319.019419667,211.731471833,198.6501845,-58.8515461167,607.934085,-471.165531833,327.036603333,-189.805660167,336.677622167,-490.0782755,9.84566658833,-169.500215333,-68.8658829667,170.9503135,26.1698292167,-172.689329833,-71.93783075,-27.88808475,-218.533344333,36.8332638,-184.5312225,-34.7654368167,-102.869650833,-24.84099015,-2.91562106033,-16.6583788333,-71.1840521167,-107.8922105,-39.3732372667,-1.98018443033,-13.3323,8.24633958833,-22.21391195,112.0312485,-6.29155984833,-19.3486422833,-3.224859285,-26.2477551,-20.5598997167,0.503380656,-16.2454553333,-1.24666964833,-6.66690431,47.6219114167,10.78054035,6.62816508833,42.6451078833,-1.158698785,47.3462895167,1.37184829,-3.04210494167,0.2390838925,-4.53541505667,-11.08693115,11.1314136333,-0.01686076048,7.28344063333,-4.46301676333,19.4076369333,2.985773165,11.30806955,10.11321254,-0.339637449,18.7083611667,4.63981265667,3.09504238,1.41849506833,-0.878665998333,0.6784473675,0.214114718667,-3.41488273167,4.22884587333,0.465881183667,3.78498079833,-2.06126364667,5.17547267833,-0.531001706167,5.28812550667,1.626314175,-0.769757545,4.474070585,1.40565677167,2.41286945,-1.37040830333,1.368766705,0.959664963167,-0.180232748833,0.0239417286933,0.152285684167,-0.320285593333,0.658760224,-0.1687457135,1.17128481667,-0.07133408935,0.6776534885,-0.446280319833,1.21029857,0.260882248,-0.2331548585,0.889942091667,0.0447687788833,1.38179702333,-0.781517742667,0.909665504,-0.0951401206667,0.487104729],[-35303.9570833,-3553.27073333,1462.47416,-835.720528667,3023.60935667,810.768012333,-1838.24576167,-1596.07325167,594.389435833,1.27943281333,-647.7322425,1191.39272667,-152.703580833,645.8065405,-288.982789333,206.724729667,216.481918833,-30.2277877585,619.559951667,-515.588081,325.764169167,-184.791268667,324.1216795,-485.946195833,13.4712041167,-155.418828,-68.4901429833,190.663813167,14.476266375,-180.615802167,-68.1429066167,-18.9632039667,-212.913208833,55.1324432333,-173.515482,-31.2860573,-103.780916833,-27.5144281167,-5.56694225833,-18.6270772333,-78.2407546167,-110.851975667,-35.4718202,0.176495323667,-9.17985833,12.319208935,-20.3214305833,111.851201667,-5.761087455,-20.6459673333,-5.57976260333,-28.4454322667,-21.7809612167,-2.54254732517,-16.9082142,-1.0584230365,-7.63806628333,49.5760826167,11.32342475,6.36365683,43.2506344,-0.969855229,48.6780952333,1.38150567167,-3.05008453667,-0.878390626667,-4.642059015,-11.7403218333,10.2907388433,-0.431088865078,7.07983466333,-4.58521187167,19.9499519333,2.89358600167,11.5678154667,10.8485263833,-0.199474202417,19.3102885833,4.715380055,3.060166325,1.41732009667,-0.832779239833,0.470516492833,0.297702069833,-3.649792765,4.27770287667,0.346312418667,3.56615497667,-2.193384365,5.38537312833,-0.624056003,5.50983412333,1.89885393833,-0.590752036833,4.68056880833,1.433015685,2.45001349167,-1.41376273,1.45874416167,0.97485145,-0.174613499167,0.05000971025,0.211899256333,-0.397559737,0.733025742833,-0.190122679167,1.10958847167,-0.120691014817,0.720166963,-0.4801589555,1.29572997167,0.290792722667,-0.16429002385,0.965592513667,0.05874330305,1.40604261667,-0.795407665,0.9631841455,-0.0730786497,0.482275217167],[-35062.7158833,-3409.78722667,1261.62015833,-720.0395355,2924.16977167,835.182769333,-1817.646465,-1600.45352167,588.629282,-39.019147655,-674.753328667,1142.2065,-140.0999605,592.681116833,-259.596268833,200.229775,231.952394,-0.589001817333,626.300748667,-555.842238167,328.108599,-181.685107333,309.2472765,-478.6400685,16.5167317,-140.623546833,-67.6068564333,208.952520667,4.68107311167,-186.468466667,-63.4412168333,-10.2834865417,-206.547140667,72.9823931333,-161.984647167,-27.5321071167,-104.3162605,-29.9041533333,-8.748723245,-19.8071103,-85.3567860833,-113.170638,-31.35247905,2.31721841133,-5.88144420667,16.2705036,-18.3117410667,110.588156333,-5.103457835,-21.8991595167,-7.94987662,-30.6713883667,-22.9068446667,-5.90489108833,-17.4745825333,-0.869094519167,-8.695964605,51.0074439,11.7769419167,5.949016815,43.4178434667,-0.8175066775,49.5959582167,1.430430245,-3.03821578,-2.0081111915,-4.730336645,-12.3916976333,9.258517385,-0.887705696833,6.82564112333,-4.73320735167,20.3392495667,2.76290129833,11.7175926833,11.4615632833,-0.0966339097833,19.7373616333,4.71734935167,2.96069172667,1.42744309667,-0.774707384833,0.256058201733,0.387066702833,-3.87717363667,4.28735244333,0.214651780217,3.309421015,-2.34141421833,5.575117325,-0.727259709667,5.69593621,2.147952175,-0.420706780667,4.84176759333,1.43266398167,2.45061884333,-1.46234851333,1.54226815833,0.988597211833,-0.164583266333,0.0746599152167,0.2742509585,-0.473469808333,0.805534453167,-0.210399859667,1.03708955483,-0.179945793,0.767078981667,-0.519786279333,1.376877435,0.315673124833,-0.0983647542833,1.03256850667,0.0668448237833,1.41619738167,-0.811730332333,1.0097098085,-0.0518078737333,0.474381354667],[-34826.9888333,-3221.193845,1160.955965,-627.1627915,2817.48236,900.5836295,-1824.071405,-1631.55647833,579.460347,-85.01480455,-692.055325833,1089.38113167,-127.450382,527.108527167,-229.448615667,192.847509167,246.456710833,29.0009542915,627.425016667,-591.192047833,331.862558667,-180.480312167,291.3208455,-467.965233,18.8646787833,-124.6428295,-66.5802395833,225.810987667,-2.95321404,-190.420107833,-57.93736625,-2.38717295333,-199.301961667,89.8946719167,-150.221410333,-23.6019389667,-104.3974595,-32.0093458333,-12.34288502,-20.14294345,-92.4947456667,-114.825561667,-27.18056685,4.45374383,-3.55565198,20.0413324167,-16.2278513333,108.235725667,-4.34135979667,-23.1187895833,-10.3239967167,-32.8589383167,-23.9263698833,-9.54225791,-17.9325935167,-0.7028045525,-9.83739984667,51.8643169333,12.1266280167,5.36791228,43.1336035333,-0.7191928615,50.0624911667,1.51562576833,-3.01826554167,-3.14415710167,-4.78916445667,-13.0406400667,8.04862814667,-1.38495341667,6.52546816167,-4.90693588833,20.5619381,2.59883297333,11.7462309833,11.94319225,-0.04091676595,19.9735348167,4.642121425,2.800828945,1.44953000333,-0.708011822,0.0365436579333,0.480845116667,-4.09768415167,4.2603851,0.0711564032667,3.02021539,-2.50373858833,5.74269613167,-0.838104392333,5.84197415333,2.37052917333,-0.264374108667,4.95300703167,1.402921095,2.41507399,-1.51427285333,1.61695551833,1.0014834535,-0.150454197333,0.0981100193833,0.3378776535,-0.5479133895,0.876521755,-0.2293302935,0.955576830167,-0.248448952167,0.8187283845,-0.564485409333,1.452496485,0.335296881333,-0.0366095272,1.089973635,0.06853901525,1.41181774167,-0.829780109167,1.04786502167,-0.0321101827833,0.462964874667],[-34598.0875167,-3074.23401,1208.16673,-536.517104333,2696.108375,1005.63705083,-1850.87184833,-1693.63810667,572.631682167,-133.636296433,-701.331718167,1033.61718417,-119.177200667,449.784964167,-198.826476833,185.579607667,261.746648833,57.3744375833,622.337059333,-622.278195667,335.773034333,-181.755033833,270.116965333,-454.083298167,20.419647,-106.9409202,-65.5154528167,241.161669833,-8.41524656833,-192.561419333,-51.9231684,4.440121395,-191.0636125,105.40860535,-138.449437167,-19.59609855,-103.904917,-33.7397182167,-16.23162805,-19.5487716667,-99.6091280833,-115.843237667,-23.0371132333,6.6012214,-2.23225319333,23.62809845,-14.1458926167,104.8779625,-3.507797625,-24.2950872,-12.6820056167,-34.9301566667,-24.8003636167,-13.4024754133,-18.2820596333,-0.562986805833,-11.06871575,52.1389394333,12.3800643667,4.61241006833,42.4244086,-0.682787952,50.0800734167,1.626637105,-2.997777475,-4.28314217333,-4.80338079333,-13.6801633333,6.67894380333,-1.92066406333,6.187064935,-5.113528685,20.6167064167,2.40884271167,11.653298,12.29442815,-0.0361548909833,20.0197022167,4.49173621,2.59312491,1.48176544,-0.637171372667,-0.187767319933,0.578752577,-4.311586245,4.19990389833,-0.0822999645167,2.7039733,-2.68001984167,5.88726256,-0.9553474145,5.947399125,2.56500867333,-0.124025254993,5.01398324,1.34451109,2.34814376833,-1.56606175,1.681602495,1.01377288333,-0.133506178,0.120308682067,0.4015028755,-0.6210040995,0.946285672833,-0.246007927833,0.8666837865,-0.3250745255,0.875048096833,-0.6140771325,1.52193867667,0.349469179667,0.0204648646667,1.137615975,0.0639796270167,1.39395380833,-0.848243561833,1.07726420167,-0.0147536809905,0.4475843395],[-34387.0721667,-2980.48296667,1400.41355833,-445.65498,2564.85057667,1142.09511333,-1890.68142,-1777.12969333,568.8571,-183.806031,-703.9142875,977.249094167,-116.510717167,367.048119833,-165.097514667,179.205088667,277.8069815,83.4095865167,610.9897065,-649.694427,340.071579333,-185.068063333,245.840534,-437.389235833,21.4012639167,-87.4374206667,-64.6382115833,254.904763333,-11.9284530617,-192.876729167,-45.5280215667,10.12616703,-181.7429735,119.386121167,-126.848770333,-15.49173735,-102.732546167,-35.0545710833,-20.3694011833,-18.0194974333,-106.709560033,-116.2483745,-18.9504629,8.79906601667,-1.79646681167,27.0493599333,-12.14147905,100.596402283,-2.6190535,-25.3866501167,-15.0058359833,-36.8306913833,-25.5028976333,-17.4526740333,-18.5323867,-0.452980931833,-12.3788788667,51.8563113667,12.55607065,3.68994215167,41.32375705,-0.6891486805,49.6819350667,1.74941220833,-2.971876815,-5.41684047333,-4.75945915,-14.30317195,5.16574639,-2.49495983333,5.81314358,-5.35492570167,20.5050665667,2.20506577333,11.4477879167,12.5210208333,-0.0724828943,19.89059315,4.27377237,2.346966165,1.51988639167,-0.564712754167,-0.415034769167,0.682428071667,-4.51840635167,4.10988441833,-0.2441519401,2.36442407667,-2.86868057,6.00629723667,-1.075939333,6.01435474333,2.73178764,0.00223405819333,5.02810997333,1.26128433,2.25439615667,-1.61515371,1.73672692667,1.02504461,-0.115321777767,0.141224027333,0.46466124,-0.692664395667,1.01557324383,-0.259663411333,0.771876092,-0.408492849167,0.935055617,-0.667765330667,1.58466786167,0.358646716833,0.07309803845,1.1759246,0.0544433309,1.36433186167,-0.866035872667,1.09855021167,-0.000232943195333,0.428102235833],[-34220.08885,-2979.55369167,1714.41021667,-354.6024185,2423.047145,1297.005685,-1938.91820667,-1852.25934833,569.619878333,-233.8001685,-700.891343667,922.067645,-114.6860785,280.917413,-124.2065547,175.128279833,295.030413833,106.298775933,593.333320333,-673.165857167,343.103789833,-189.074488,217.636565833,-418.157911167,22.1764445167,-66.0274827,-64.1059546167,266.982500167,-13.7933322,-191.8130335,-38.5034038333,14.1013385167,-171.280748667,131.683375667,-115.7775815,-11.2795717283,-100.80304635,-35.9118535667,-24.6826526,-15.6216589833,-113.850684,-115.9551695,-15.0994972,11.04045093,-2.144114385,30.2416296,-10.3532772,95.47169045,-1.71242995667,-26.3634589,-17.2786933,-38.4975538333,-26.0293813167,-21.6426638833,-18.6830621833,-0.4067631595,-13.7691052167,51.02605215,12.65495485,2.58144576167,39.8652474167,-0.712682918667,48.8947170667,1.863470835,-2.937083475,-6.536978305,-4.644624625,-14.9073060333,3.53575105333,-3.11329730333,5.403871635,-5.63221746667,20.2227196,1.99853901833,11.1315999167,12.6289064833,-0.1394874176,19.59734925,3.99287018167,2.06758514,1.55914353333,-0.492876678167,-0.643728816167,0.792330310333,-4.71858709,3.99734290333,-0.415806149,2.00665587167,-3.06594424333,6.09603494333,-1.195851815,6.04364078167,2.871717395,0.114978369007,4.99759943167,1.15581094667,2.13619323,-1.658634785,1.78302962,1.03512420667,-0.0973729329167,0.160571620167,0.526519785167,-0.7629037045,1.08569133667,-0.2702859255,0.673434137333,-0.496581473333,0.997760839667,-0.724268298333,1.63993333833,0.3636777385,0.120639390817,1.20505699833,0.04089862705,1.323921085,-0.8819126865,1.11232729,0.0109146758928,0.404092446833],[-34102.58995,-3047.92644833,2138.11321167,-268.819836,2287.072265,1458.293095,-1984.787245,-1889.38388333,571.8329495,-279.532950167,-694.161328167,872.650106833,-108.11928275,193.7343975,-71.6761569317,173.192279667,313.4544945,124.770913,570.183748167,-692.027677,343.516552667,-192.332700833,184.9613185,-396.932127,22.8138995,-42.9563826,-64.19872855,277.501650833,-14.2987522667,-189.620722833,-30.59183695,15.9393541167,-159.731450833,142.182747167,-105.683814917,-6.95403390667,-98.1735196167,-36.2897762167,-29.0896287,-12.461973805,-121.010072167,-114.862712167,-11.6123722617,13.2801978833,-3.12528513833,33.0821154,-8.88350934833,89.5960154833,-0.806019466367,-27.2313144333,-19.48408025,-39.87890665,-26.3936956333,-25.9036982667,-18.7311235167,-0.442764656,-15.2455654167,49.6753710667,12.65676555,1.28522477567,38.0897312833,-0.730711331,47.7365019167,1.95602950833,-2.89502353167,-7.63392565667,-4.45423203333,-15.4942493,1.81697978743,-3.78198283,4.96318009167,-5.94572818833,19.7707785167,1.79635259333,10.7113774,12.6267084333,-0.227458081167,19.1483371667,3.65326903333,1.760381045,1.59654248,-0.422929770167,-0.871872629833,0.905894795667,-4.91281751833,3.86815281833,-0.5996684235,1.63644799833,-3.26700144,6.15360874667,-1.31091301833,6.03702478833,2.98636531833,0.21490401,4.92445753667,1.0304958355,1.99550948,-1.69324159167,1.82062125167,1.04397770333,-0.080248512,0.178161719333,0.585555747333,-0.831600901,1.15734806833,-0.278284949,0.573603675667,-0.5869117845,1.06219866367,-0.781928794833,1.68720932667,0.365543903833,0.162570093333,1.22529699167,0.024293122445,1.27331491167,-0.894443842333,1.11889686167,0.0180930274167,0.37507306],[-34025.55115,-3145.88093167,2592.14433833,-187.195319667,2179.818615,1597.95915667,-2018.50004833,-1877.460855,573.686643167,-315.0865535,-687.074165333,834.7091975,-97.6302891833,111.553432033,-7.81562584333,173.222761167,333.406941333,137.930059667,543.1893185,-706.939874667,341.593643167,-195.565779667,148.498739333,-375.101441167,23.2862154333,-18.4649278733,-64.9704946167,286.819163,-13.8799538167,-186.018296833,-22.1595220833,15.8300482,-147.497771,150.8790705,-97.0983357833,-2.53990874667,-94.9176065167,-36.1054890333,-33.47310475,-8.61385305833,-128.036165667,-112.957102,-8.41116441667,15.3764203,-4.485560385,35.39064535,-7.76338988333,83.0629285667,0.0786377103667,-28.0049064667,-21.5941508667,-40.9291219667,-26.5825783167,-30.14905295,-18.6654102,-0.5303251045,-16.8291117,47.8764539333,12.5203885167,-0.159623342333,36.0385961667,-0.714196582833,46.2240097,2.01536199833,-2.84946776667,-8.69664326667,-4.19025947167,-16.0555465833,0.0347199097333,-4.49771053833,4.501601895,-6.296327245,19.1651784167,1.60049218833,10.20871635,12.5228751667,-0.3221115665,18.5525985167,3.25990594,1.42943117667,1.629666305,-0.3559208885,-1.09773730733,1.01838079067,-5.09934627667,3.72517841667,-0.795235476667,1.2590180345,-3.466154855,6.17927719333,-1.41742096,6.00046200167,3.077199365,0.3049279575,4.811502245,0.888350421333,1.83349021,-1.71534182167,1.84934464667,1.05158182833,-0.0642143649667,0.193582796167,0.639866889833,-0.898370799333,1.23013570333,-0.283628246667,0.4738513225,-0.676688061833,1.12766911833,-0.838919753167,1.72692032333,0.365238576167,0.199203167833,1.23725145333,0.00593826278,1.21276634,-0.9018435675,1.11843219167,0.0207976145833,0.340640954833],[-33991.4774167,-3270.69975333,2954.84626833,-106.725089633,2116.02796,1681.77468667,-2042.41140667,-1806.50185667,575.141286,-334.680079167,-681.560309833,811.537736,-84.3585465833,40.3541640667,66.6063124017,175.551628167,355.493875667,146.011335167,514.2484205,-718.923476667,337.76615,-199.835221833,109.433304717,-354.033423167,23.5817515167,7.20229392333,-66.2692899,295.448077333,-13.0650623167,-180.678246,-13.7620426733,14.1900430333,-134.939364167,157.5368645,-90.3228564167,1.89211293167,-91.1360166,-35.28371175,-37.7158482333,-4.13749440517,-134.757487833,-110.249596,-5.37255880667,17.2154441833,-6.042049745,37.0801804,-7.04229102167,76.0625943333,0.904276741967,-28.7056784,-23.5894257833,-41.6200049333,-26.5623631333,-34.2914982667,-18.4606308167,-0.635977155667,-18.5257478667,45.6907068833,12.2355383833,-1.722212106,33.7892017,-0.6238097505,44.38409015,2.029355175,-2.803714375,-9.715501025,-3.86017284167,-16.5752526333,-1.78794497923,-5.24767745,4.02695315667,-6.68112485667,18.4240413167,1.41825303833,9.64311996,12.3330639667,-0.4067440285,17.8250765667,2.81457643333,1.077953169,1.65731486167,-0.2921417065,-1.31983116833,1.12481254333,-5.27552049,3.56976948833,-0.9997419935,0.878113034333,-3.65718624667,6.17424269,-1.51176413667,5.93955459167,3.14557855333,0.387761332833,4.66362205667,0.730574661167,1.65142334833,-1.72203996667,1.86976034,1.05827821833,-0.0493819123333,0.206374375,0.687858940167,-0.963125457667,1.30312159333,-0.286249345667,0.375115159667,-0.763117972167,1.193364815,-0.893744336333,1.75945557833,0.363323148333,0.230406565667,1.24186888667,-0.0134830243217,1.14266366167,-0.9025666885,1.11146311833,0.0187585952333,0.3007783105],[-34014.5596667,-3359.50657333,3203.86826667,-36.2681208,2114.16035333,1700.87788667,-2043.16653167,-1666.39858,570.8042415,-335.322881333,-677.559610833,809.597241333,-63.4053990667,-18.1699712333,152.437591717,178.583234833,378.848936333,149.901480667,485.6417845,-727.245328833,331.9949685,-204.740577,69.33579035,-333.563615667,23.19967855,33.0529847933,-68.0719185167,303.669159,-12.0959303,-173.388489333,-5.51692058167,11.615283725,-122.032740833,162.158230167,-85.1196205,6.20392409167,-87.1840878333,-33.8824765167,-41.8574726667,0.860597769333,-141.022667667,-106.673477667,-2.37445118817,18.73376055,-7.562381335,38.2411108333,-6.75511307833,68.8454544833,1.6555908525,-29.4075192167,-25.4934643167,-41.9793606,-26.3337107833,-38.2693241833,-18.0758145667,-0.741297155,-20.3338007,43.1858505833,11.8422395333,-3.37067809167,31.4370235,-0.410528586617,42.2525772167,2.00398475333,-2.76434010167,-10.6926351217,-3.47989999,-17.0493042,-3.63623798333,-6.01707051833,3.53801275333,-7.094165255,17.5663381333,1.26162159167,9.03532601167,12.07913195,-0.459519525,16.9859957667,2.319196885,0.715906369667,1.68406364667,-0.229759752167,-1.53832934,1.220235065,-5.44284846667,3.40185402333,-1.211581631,0.494143207667,-3.83345731167,6.13955385667,-1.59216727,5.86086114833,3.19308967333,0.469049454333,4.48788007,0.5584068665,1.455533505,-1.71096663333,1.88344208333,1.06557032333,-0.03482409725,0.2167126575,0.7283004095,-1.02695551383,1.37536056167,-0.286856886167,0.2775337225,-0.843410414333,1.25793326833,-0.945758884333,1.785580145,0.359795346833,0.256957466167,1.24051106167,-0.0331150802333,1.0651044605,-0.895160307333,1.09925883833,0.01190394708,0.255802029333],[-34095.4899833,-3410.57523833,3358.13020833,29.6642688,2165.781575,1659.69197667,-2017.92906,-1466.671675,563.0031965,-318.869639,-675.547875167,828.648409833,-33.897997,-66.5300564,247.4862065,182.5975765,403.365126667,150.506565667,458.021893833,-731.590015833,323.3356865,-210.679025,29.6864240967,-312.9631995,21.8879721833,58.7000412333,-70.3067862833,311.535233333,-11.1778804167,-164.233706833,2.30468942667,8.54832172667,-108.826943283,164.995258167,-81.0577791,10.257067805,-83.2296818667,-31.9259081833,-45.8932493667,6.27447223317,-146.733176833,-102.230656467,0.655134207333,19.7955169667,-8.80810508,38.9959554,-6.88520580167,61.6192709667,2.30962437667,-30.1434943167,-27.3159922667,-42.0083068,-25.8880761,-42.0321695833,-17.4819938667,-0.840781404167,-22.2713296833,40.429597,11.3738314667,-5.05502126833,29.0620273,-0.0349319281333,39.8627001833,1.94026582333,-2.73325261,-11.6295182833,-3.05372261667,-17.4683971167,-5.49229305,-6.78757860333,3.03080616,-7.53330703667,16.61034105,1.13566162333,8.40910821333,11.7781541167,-0.459659682333,16.0534926667,1.77703362833,0.354366254665,1.71192927667,-0.168215216833,-1.753787245,1.30319225167,-5.60128908333,3.22345690667,-1.42697869,0.107894689,-3.989212165,6.076052565,-1.65936816167,5.77141390667,3.22046247,0.554396826,4.29057863,0.3738224585,1.25262556833,-1.68022231667,1.89193147333,1.07430916167,-0.0204857469517,0.224690909,0.760561707833,-1.09048364833,1.44659438,-0.285473883167,0.181441401933,-0.914724203833,1.31998058,-0.994930437167,1.806135525,0.354312852833,0.280052198167,1.23425445167,-0.0520700076167,0.982503919833,-0.878349985167,1.08303850667,0.000323044636667,0.206105070333],[-34198.9685,-3435.30057833,3479.62631667,101.512344067,2249.484585,1577.6602,-1966.32835333,-1227.02155783,558.346352,-289.587139667,-676.999842833,863.982324333,2.98130861667,-109.478587167,347.155755167,189.347665167,429.6247395,147.818483833,430.5858745,-731.741440167,310.3382325,-218.204151,-9.08213669667,-290.794993167,19.8334873,84.2879981333,-73.0245512833,318.8196305,-10.42828613,-153.6092175,9.54419884167,4.92628531933,-95.2094255833,166.3418075,-77.7058166167,14.0005216167,-79.2310365,-29.3994613167,-49.77782,12.0068518783,-151.853344333,-96.9163056167,3.65317380517,20.3191636667,-9.628457765,39.4424349333,-7.406405975,54.5533058167,2.84270182167,-30.8925028833,-29.0332591333,-41.6750525667,-25.21646745,-45.5364925333,-16.6555037833,-0.942973503,-24.34410755,37.4613913,10.8567153167,-6.73209971667,26.7346080167,0.517265729383,37.2423615,1.82948463667,-2.70551072167,-12.5174966167,-2.57160791,-17.8198759833,-7.33406048333,-7.54204731167,2.50458388833,-7.99663451333,15.56686095,1.04254769917,7.783622495,11.4459711,-0.396732621167,15.0421977667,1.18987476583,0.00287036749333,1.73833874667,-0.1081180337,-1.96557220667,1.37621292333,-5.74829666833,3.03912133,-1.64186333667,-0.277511843167,-4.120110975,5.98321805833,-1.71469216333,5.67640628667,3.228317715,0.6462749435,4.07679101,0.177873851233,1.04859356467,-1.62909606833,1.89712497667,1.08420979,-0.00730752228333,0.230003148667,0.784477101667,-1.15333696667,1.51734072333,-0.281665763333,0.087729683835,-0.974680103,1.37809545,-1.0414052875,1.82153969833,0.346281987,0.300419627667,1.22383612667,-0.0699309324333,0.896981747,-0.851465856,1.06425316,-0.0159575788867,0.15215270515],[-34291.7552333,-3426.43128167,3628.66460833,186.167621833,2338.59558333,1474.22746833,-1892.27209167,-963.797019333,564.0107675,-256.6280325,-685.143752,909.1892965,46.7904182667,-148.872368167,448.475077333,200.882753333,457.079080333,141.089495333,402.6044365,-727.2463645,292.62389,-226.809827333,-47.1179690533,-266.188957,17.4789125,109.96644605,-76.32652165,325.312444333,-9.98600218333,-141.848047667,16.2517678367,0.489618167333,-81.1175596,166.407954667,-74.4436036833,17.5077331667,-75.0353427,-26.2559117833,-53.48019745,17.8818715167,-156.336627167,-90.7499300833,6.52989403333,20.3301255,-9.98308849167,39.7327128333,-8.29875916833,47.7356174833,3.26624446167,-31.5948186833,-30.5941551667,-40.9683603833,-24.3411211167,-48.7314487667,-15.58857195,-1.042548924,-26.50931015,34.29661875,10.3305628167,-8.37988877167,24.5048579667,1.23084470117,34.4295754167,1.66545963667,-2.669468915,-13.3372691333,-2.02701986333,-18.09227185,-9.13629368,-8.26742197833,1.96696507833,-8.47391547667,14.44377035,0.987306358333,7.16646669167,11.0999520667,-0.271303030983,13.96981815,0.56301381285,-0.332609568502,1.75825816333,-0.0490043854667,-2.17062499167,1.442645925,-5.87777550167,2.85337161833,-1.85341023167,-0.656418419,-4.22307437,5.86083375333,-1.75752602,5.576884685,3.22017229833,0.7445728015,3.85214304,-0.0275560235667,0.8478737555,-1.55941725167,1.900515745,1.093749755,0.004077633025,0.232472989833,0.800298646833,-1.2134355,1.58755280667,-0.2753033085,-0.00237490086,-1.0219748235,1.43120285,-1.084549015,1.83143702667,0.3361654065,0.318419794667,1.21007800833,-0.0865321170667,0.810324802833,-0.814947723333,1.04413319,-0.0366191248833,0.09473963355],[-34358.0448667,-3401.462735,3833.64177,282.840179833,2410.45637167,1363.53523333,-1806.38746,-689.3946655,585.122761333,-228.553292,-702.873566,958.069957,95.2194894333,-184.4180595,549.403734167,218.567898,484.840787,129.575129833,374.516804,-718.337575833,270.828298333,-235.542383167,-83.9022475,-239.622941833,15.1123832667,135.642621,-80.3771688833,331.112793333,-10.0561709167,-129.1297145,22.3203423667,-4.81572178567,-66.89191295,165.264099333,-70.6976764333,20.84834125,-70.5529942833,-22.4991279,-56.9710934333,23.7156074667,-160.1132205,-83.9014872667,9.22454846333,19.8343359833,-9.89570517833,39.9961754,-9.49292883,41.2584664667,3.61243730833,-32.2033481333,-31.9511759,-39.9191759833,-23.2909938167,-51.5650707167,-14.3075272667,-1.12609569833,-28.7113591167,30.9675300833,9.82794592,-9.95857622667,22.4190830833,2.089361395,31.4577099167,1.45147792833,-2.61485182,-14.0648084333,-1.4273761555,-18.2749498,-10.875630665,-8.95018532167,1.42941419767,-8.95324198,13.2625562333,0.972358278333,6.56934818833,10.7541331,-0.0824016584333,12.85141925,-0.0941864539333,-0.649245654833,1.768422445,0.0106641961333,-2.36420882833,1.50430173167,-5.98282560333,2.668736155,-2.05692100167,-1.022078978,-4.29675739167,5.71258636833,-1.78745234833,5.47392996667,3.19869026167,0.849692069167,3.62150308333,-0.238721479933,0.653927217167,-1.47460455333,1.90285251667,1.10130953167,0.0138001984233,0.231923079833,0.808670219167,-1.26825353167,1.65613589833,-0.266013827833,-0.087759127865,-1.05622935,1.47858212333,-1.123687285,1.835407835,0.324419327667,0.334463947667,1.19365897833,-0.101304005783,0.724177237,-0.769950400333,1.02350180833,-0.0610600564167,0.0352179909333],[-34393.3022667,-3379.06316333,4059.73336833,382.6548695,2451.40825167,1250.50584333,-1707.150115,-422.0011495,622.068287,-212.626988833,-731.522998167,1008.57499533,142.154412867,-213.081783167,645.1517085,242.487897,511.720808833,113.410178517,347.340615,-705.718833167,246.853745,-244.131103833,-117.9989003,-212.189901,12.81221155,160.961979833,-85.1397767667,336.207378167,-10.5675882467,-115.435085167,27.5539468833,-10.6339299433,-53.1135543833,163.159991167,-66.1110098,24.0642831833,-65.7740282667,-18.1612339667,-60.2882166667,29.44340765,-163.137006,-76.54413745,11.7556197383,18.8118231333,-9.31831112667,40.2978196667,-10.9133153833,35.1930378,3.91779856167,-32.6947324667,-33.0821995,-38.5864495833,-22.0840215833,-54.0145983333,-12.8293373333,-1.18194935,-30.8937267167,27.54128575,9.37250629667,-11.429396635,20.5151678667,3.06484953833,28.3467576667,1.19637384867,-2.538980775,-14.6840372167,-0.786206491667,-18.3649295167,-12.5398609167,-9.57378195,0.896018300333,-9.42173570333,12.0522179,1.00011422667,6.00391976167,10.4199761667,0.16551646785,11.6946513833,-0.774142201817,-0.946319152833,1.768395365,0.0710697013333,-2.54305814333,1.56222092333,-6.06096710333,2.48509877,-2.24772654167,-1.37082030833,-4.34038285833,5.54231815833,-1.80370494167,5.36851929667,3.16624536667,0.960039834167,3.38761373667,-0.452826061,0.469109749667,-1.37896725833,1.903965185,1.106280025,0.0222568800167,0.228122785833,0.81018401,-1.31650488,1.72165784833,-0.253839037,-0.168126874367,-1.077569225,1.51892634667,-1.158335155,1.8331244,0.311471954333,0.348542252333,1.17489860167,-0.1140187575,0.6398029055,-0.7181270165,1.00262424333,-0.0887844810667,-0.0251241992667],[-34408.2839333,-3348.20524667,4263.33475333,471.135314667,2458.44550333,1141.39570833,-1582.29772833,-172.730993383,671.273254333,-217.022480667,-770.3397355,1061.73050667,183.822937833,-232.631354167,730.045805833,271.9287575,535.464660833,93.0672748167,321.836332833,-689.326848333,222.163045667,-252.188642,-148.155879833,-185.319873833,10.6196501833,185.270004333,-90.6680740167,340.245597333,-11.1922167167,-101.01978035,32.0565101667,-16.7108412333,-40.4367561167,160.28988,-60.62018985,27.2075051,-60.7270806167,-13.3736531033,-63.5435320333,35.0164686833,-165.479237833,-68.7388035167,14.0571209333,17.2793003833,-8.259400825,40.61538505,-12.5166757167,29.54186705,4.22151598167,-33.04982385,-33.9995589833,-37.0341497333,-20.7692707167,-56.0865631,-11.1527944333,-1.239872125,-32.9809990333,24.0678050333,8.97631734333,-12.7748342833,18.80178635,4.115900955,25.0980624667,0.910327667833,-2.44200912667,-15.1864876667,-0.113132449667,-18.37640795,-14.119074,-10.1260233583,0.359366428833,-9.86175992667,10.83324279,1.0748832825,5.47266112167,10.101469455,0.460998508833,10.496748595,-1.4724838495,-1.22614949767,1.759009605,0.130970225667,-2.70434932,1.6186878,-6.114790535,2.30389202667,-2.425327095,-1.70061981667,-4.35367170833,5.351132565,-1.8040823,5.258717805,3.12479932667,1.07141485683,3.14991723667,-0.6687101,0.2937930045,-1.27759570667,1.90280212333,1.108723555,0.0296735362167,0.221219696833,0.805433824667,-1.3577758,1.78358147333,-0.240303318833,-0.242914174333,-1.086881815,1.55044360667,-1.18788473167,1.82359258,0.298095944833,0.359969109333,1.153558465,-0.124986055833,0.557773155333,-0.661557106167,0.981260504167,-0.119571376383,-0.0850980362833],[-34398.0079333,-3314.63932667,4451.74937667,537.905401333,2437.64018167,1046.0829855,-1434.12354833,50.4855768,727.839313167,-247.464750333,-814.883325333,1114.71079167,217.700625333,-243.741477667,800.126278,305.853534833,554.342737667,69.9151383333,298.480896833,-668.8512595,196.7824195,-259.411020333,-173.011151667,-160.7223085,8.469578685,208.090391,-97.1607584333,343.012938833,-11.5842137667,-86.43860405,35.8057028333,-22.6844324167,-29.5462694667,156.763357833,-54.3659718333,30.2930005,-55.4373542333,-8.38725192667,-66.7956732167,40.4007065667,-167.2806445,-60.6174036667,16.0596264,15.2220344333,-6.75289291833,40.8537092667,-14.2821695833,24.3154216667,4.552828935,-33.2618572833,-34.74782065,-35.31294865,-19.3951903667,-57.7998687167,-9.29544115833,-1.34751905333,-34.9138370333,20.6074684,8.63167645,-13.9818552667,17.2836680667,5.20495309667,21.7162995833,0.602680837833,-2.32653896,-15.57243595,0.586308966667,-18.3253693167,-15.6021409333,-10.5942437667,-0.191639982333,-10.2603158083,9.62962394,1.19664259167,4.97588012333,9.79985681833,0.7927073305,9.25717617333,-2.184142115,-1.491598555,1.741647815,0.1880460185,-2.84613889333,1.67689643667,-6.14787105167,2.12740531167,-2.58835269667,-2.01009715833,-4.338637145,5.14137871667,-1.78733349333,5.14338654167,3.07531911833,1.17982188833,2.90824695333,-0.884723305333,0.1278806062,-1.17582709,1.89774840333,1.10901309667,0.0359216742,0.211623109333,0.795369744667,-1.392186415,1.84156764,-0.2266003205,-0.311509910333,-1.08551741333,1.57178763167,-1.21205029167,1.80643378833,0.2847337935,0.368057677333,1.129633135,-0.134376962333,0.478689771167,-0.602269122333,0.958886955833,-0.1532088775,-0.143408997317],[-34356.8550667,-3277.09654667,4673.53524,568.741460667,2407.72917167,973.945637,-1278.94864333,250.803646283,783.3317525,-305.100806167,-857.010192167,1163.250375,244.472495833,-245.205122667,857.248526333,342.483190667,567.2003225,46.3988237167,278.671386,-643.963688667,170.7808975,-264.675527167,-190.752040667,-140.260798167,6.11687089667,228.856643,-104.981084783,344.659919333,-11.5521094333,-72.3116602667,38.6589552667,-27.967026,-21.0384834833,152.417441167,-47.5156565833,33.2772528,-50.0501365167,-3.61577115917,-70.08993295,45.5442021333,-168.753560833,-52.4260826,17.7165727,12.655559465,-4.90980798,40.9241607167,-16.22735775,19.6121169333,4.92698766667,-33.3639214667,-35.4145118667,-33.4973143667,-18.0134534667,-59.1961821333,-7.304981075,-1.565187325,-36.6364044,17.22276295,8.33548546667,-15.04810965,15.9890779833,6.31908083167,18.2176944167,0.284905763333,-2.19919476333,-15.85053875,1.30104496783,-18.2311908833,-16.98070825,-10.9667053333,-0.771520758833,-10.6102247667,8.46979204667,1.36348448167,4.51155583667,9.51735317333,1.15642002967,7.980311905,-2.90271878167,-1.75040646667,1.72034318667,0.240426004333,-2.967045945,1.74059556167,-6.16608212167,1.95823011167,-2.73469612167,-2.29887280833,-4.30112551,4.91718372667,-1.75420712833,5.02230044333,3.016456805,1.282679915,2.66294259333,-1.09830938533,-0.0307304228667,-1.079897954,1.887744195,1.10840975167,0.0411191017,0.200008149833,0.781799602667,-1.420963525,1.89554409833,-0.213886354,-0.373319328167,-1.07582787,1.58205691667,-1.231458255,1.78188599333,0.270774381333,0.371928349167,1.10303126,-0.141973387833,0.402862050333,-0.5424140575,0.935246339833,-0.189161209667,-0.198382442833],[-34288.2267833,-3221.65386,4946.733185,551.4405135,2388.11658167,921.4448315,-1132.045259,434.8628735,830.549576,-388.159846333,-888.334010667,1205.36983333,264.4268175,-232.181284167,903.962723833,380.823251167,573.401961,25.6450153667,264.401945167,-615.376813333,145.2725365,-267.299059833,-199.912128333,-125.247953167,3.49061866067,247.029447667,-114.310263833,345.439849667,-11.1830061,-58.9729547333,40.4946401333,-31.9704765667,-15.314109,147.214422667,-40.28784085,36.1107171833,-44.7402387167,0.549676173333,-73.4681793667,50.4238822667,-170.084071833,-44.3821368833,19.0412819167,9.62969638167,-2.8079771785,40.7622829167,-18.4386994333,15.53685545,5.34026019167,-33.39096125,-36.0777716,-31.67115985,-16.6462795667,-60.31823815,-5.22853549333,-1.93276801833,-38.0933008833,13.9819310833,8.10100903,-15.9869957167,14.9468888833,7.472397335,14.6368712,-0.0357060443333,-2.06284951667,-16.0270073667,2.016254925,-18.1052351667,-18.2493385833,-11.2315946833,-1.39084249867,-10.90293355,7.378632305,1.578085885,4.07743875167,9.25503433167,1.556922985,6.677320945,-3.62308212667,-2.015998565,1.699325185,0.2868512245,-3.06565109667,1.81258468833,-6.17426820833,1.797410435,-2.86163575833,-2.56745489667,-4.24596878333,4.681398005,-1.70475569,4.896555785,2.94651391167,1.37902865833,2.41514213333,-1.30696943333,-0.186328306633,-0.9962862355,1.87348321,1.10828881167,0.0450696975333,0.186693509333,0.766430209667,-1.44555749167,1.94488136833,-0.2029678245,-0.428325391333,-1.05975207167,1.580292265,-1.24672044833,1.750380945,0.255621372167,0.370617696333,1.073590015,-0.147331947333,0.3304543515,-0.484200226667,0.910802861667,-0.226587615667,-0.248600073],[-34194.4655333,-3208.230555,5171.52444,491.405495,2381.1303,861.4308235,-1001.0252725,603.153826667,870.701210167,-487.626788,-898.522697167,1241.69493667,273.795348,-199.965338,939.9864285,422.231232,575.633744167,12.8697167067,257.464075167,-584.8132105,121.515341767,-267.919705667,-199.040728667,-115.450292167,0.661888149333,262.739882167,-124.598125167,345.536352667,-10.4535024867,-46.4989430833,41.1779658833,-34.0767826167,-12.3957097,141.131132333,-33.3132594,38.5645234167,-39.6488163,3.83194832917,-76.9072938833,55.2036082167,-171.401056667,-36.6175328833,20.11992425,6.194954925,-0.533871552333,40.2189526,-21.0868305833,12.2037271367,5.70689506333,-33.3925458,-36.8185736,-29.8847239833,-15.2426877,-61.20104855,-3.091173173,-2.46328224167,-39.25822825,10.9384206983,7.94183323333,-16.8356430667,14.1770002167,8.71911222667,11.0029383317,-0.366540006833,-1.92718856333,-16.1161251,2.72403630333,-17.9463776167,-19.4052969833,-11.3746469333,-2.05406531333,-11.1340572667,6.37467817667,1.85054144167,3.672575625,9.00543539333,2.01502768833,5.356070025,-4.34513317,-2.30331850167,1.68387894333,0.323364193667,-3.14374996167,1.895135215,-6.17813081,1.64460359667,-2.96490709167,-2.81622061667,-4.17582889833,4.43687699333,-1.63692423,4.76984295167,2.86134893167,1.47149781333,2.16522000833,-1.50930532667,-0.343418460833,-0.9295628585,1.85743242333,1.111327275,0.04652444375,0.171235322833,0.7502647665,-1.46841499,1.98869973333,-0.19370917,-0.476948110167,-1.03814096833,1.566269415,-1.25825657667,1.71309598333,0.238719131333,0.363652688167,1.041217725,-0.149688115167,0.2618529395,-0.429109091667,0.8867572535,-0.2649029965,-0.293185336],[-34053.5382333,-3238.99340833,5311.12434,409.9993405,2391.063885,774.379017,-875.833129667,757.382163833,905.907899833,-593.1769775,-882.801946,1275.11351333,270.902502833,-149.3343235,962.786800333,466.482514167,576.72755,11.3851179433,258.355766,-552.900443,99.42743205,-267.583490333,-188.276104667,-109.098573833,-2.83239531767,276.203435667,-135.168492667,344.7933285,-9.16031026167,-34.8703500333,40.8894460833,-34.1019260833,-11.9666323,134.493722,-26.9545640333,40.3787775667,-34.9078040667,6.08171698167,-80.3144909167,60.00378045,-172.76021,-29.1429963167,21.06173425,2.36623633667,1.90625775483,39.2361809333,-24.2945229167,9.59739651833,5.96346485167,-33.4232051667,-37.7108779167,-28.1383530333,-13.77488475,-61.8666464667,-0.920300920333,-3.140066535,-40.1445732167,8.13115360167,7.86737516167,-17.6217199667,13.6707217,10.073620585,7.34595544,-0.710470159833,-1.80618919167,-16.1417136167,3.42445647167,-17.7556780333,-20.4480888,-11.3937728,-2.759959495,-11.3058500333,5.46512185667,2.18398616667,3.29518221167,8.76454868,2.53938113833,4.02584195,-5.069704025,-2.61519723333,1.67814597,0.344912803333,-3.20572661667,1.988764105,-6.18185999,1.49884153833,-3.042622975,-3.04607979667,-4.092297955,4.18571684667,-1.55030269833,4.64496608167,2.76060819667,1.56222045,1.91473907833,-1.70489741333,-0.502458823,-0.881427672,1.84123220167,1.11971246333,0.0440979745833,0.153378362333,0.733431846333,-1.49138563333,2.02638598167,-0.185504705667,-0.519865129,-1.01141418717,1.54080442667,-1.26650620167,1.67121865333,0.220252309333,0.351338416333,1.00638086317,-0.1488474045,0.197818433167,-0.377860995167,0.863972420167,-0.3040072275,-0.332179046667],[-33833.3974833,-3228.46370333,5447.82985833,326.428794333,2432.93153,667.565603333,-736.636916167,907.106796667,933.499950833,-696.863340167,-842.722670667,1309.43064167,260.9193295,-84.16243094,973.469248667,510.459562667,577.690242333,21.08900169,266.6888525,-518.113958833,77.96471125,-265.632393167,-169.727554667,-103.527823767,-7.95679325,287.271762,-145.685777,342.8061105,-6.86868993167,-24.13879595,40.3727072833,-32.5805515667,-13.3185270167,127.714345667,-21.1017619667,41.4063714833,-30.6755223167,7.20474623333,-83.5869329833,64.8067347667,-174.214576167,-21.8556408,21.86109235,-1.74649599,4.48485202333,37.8990761667,-28.0927434667,7.57351118333,6.12221693833,-33.5337721833,-38.8167245833,-26.4162496667,-12.28576855,-62.3360372667,1.24785023867,-3.95489401333,-40.7536403167,5.55596118833,7.88667896333,-18.35776635,13.3908007167,11.4938230167,3.69769440792,-1.05609153267,-1.71287134,-16.1294860667,4.11907121,-17.5458962333,-21.379218,-11.30060405,-3.50839749167,-11.41843085,4.63739235667,2.57188045667,2.93750658833,8.53196929167,3.11933299833,2.69643266167,-5.79425030833,-2.943082455,1.68484111,0.347904208,-3.25591476833,2.09267402167,-6.187908945,1.35930058667,-3.096368645,-3.25895034167,-3.99635101333,3.925604545,-1.44665887167,4.52012027333,2.64656294167,1.65147974333,1.66518803,-1.892843685,-0.660274088667,-0.852226866167,1.82508096,1.13435382167,0.0371712426,0.1336432215,0.715653845333,-1.51509983667,2.05768788167,-0.177994736333,-0.557733302667,-0.980157501333,1.50436408,-1.27173338833,1.624692145,0.2003023865,0.334583543333,0.969316867,-0.1449636155,0.1392021174,-0.3309645295,0.842799220667,-0.344035049833,-0.3661073065],[-33545.09015,-3167.13736167,5579.784735,253.443792667,2502.44187333,546.468028167,-585.452368167,1045.5709825,954.659997667,-792.422668,-783.214683667,1343.73100333,245.657464167,-6.96440481,974.099125833,552.262103333,579.9768475,40.7475979,281.860377667,-480.330907333,56.5024702667,-261.988365167,-145.234745333,-97.1724396833,-15.2378916033,296.1668715,-155.743542833,339.42239,-3.35202616167,-14.4033787333,39.7578107667,-29.9821089333,-15.9851581,120.97924,-15.6781581667,41.60146195,-26.94459085,7.18432692167,-86.5432234333,69.5915346833,-175.800485167,-14.804895045,22.5123726667,-6.02766766167,7.13393971667,36.27071725,-32.45524565,6.00413927333,6.19149449333,-33.7328924333,-40.1659075667,-24.6908929167,-10.8109522117,-62.6083946667,3.36351470333,-4.88504635167,-41.0831277833,3.20831579667,8.00278342333,-19.03932355,13.2977993833,12.9377318167,0.09021495,-1.39941430667,-1.655709385,-16.0946363167,4.81256204333,-17.3199902,-22.1958228333,-11.10329795,-4.29178056167,-11.4731942667,3.88256576833,3.00330815833,2.59704210333,8.30611830667,3.7434504,1.378091995,-6.51449092167,-3.27890921333,1.70367497333,0.329091892,-3.29763219,2.207382625,-6.19385763,1.22588781833,-3.1247264,-3.455325495,-3.88955085667,3.65525327,-1.32853183333,4.394014425,2.51970141833,1.74066078667,1.41830983,-2.07200542667,-0.813468482667,-0.842908405667,1.80876037,1.15518053333,0.0248653159183,0.112208101233,0.696912007667,-1.53915270667,2.082185795,-0.169939885,-0.590862485167,-0.945092422167,1.45750984333,-1.27399785,1.57363023833,0.178521294,0.314576375667,0.930359645333,-0.138205989833,0.0868219391,-0.289105574667,0.823460380667,-0.3849765185,-0.395237348667],[-33215.3188,-3098.44778667,5670.96424,202.0988965,2578.75022,411.777429833,-441.4798015,1156.27315833,974.890083,-877.556815667,-711.2103825,1372.70001,224.1586455,78.5972986933,966.426073833,591.465395333,585.118872167,68.4050586833,302.800347333,-440.389476833,34.0538499333,-257.253218833,-116.382344033,-90.0977380833,-24.7523366,303.493041,-164.854259333,334.678426833,1.36523733667,-5.83944923333,38.6998939167,-26.7395159333,-19.96287285,114.261545,-10.6281649967,41.0299232,-23.5396375333,6.10412706833,-88.9361505667,74.2805606833,-177.5345155,-8.14812767333,23.0117185,-10.4394376,9.76160187167,34.3965827167,-37.2915481,4.78427431833,6.18953574167,-33.9848408167,-41.7510799833,-22.9196102333,-9.38655343,-62.66410675,5.37109601,-5.90351875,-41.1394238333,1.094538519,8.20481377333,-19.6357947,13.3575624833,14.35742105,-3.44892824208,-1.74166273167,-1.63624570333,-16.0424148333,5.51283947333,-17.0732675,-22.8892083,-10.8067342333,-5.098080305,-11.4718566667,3.19962549667,3.46241159167,2.27901819167,8.08746191833,4.397795335,0.0805520816667,-7.226668005,-3.61288796833,1.730746485,0.286132461167,-3.33257271833,2.33395639667,-6.19306244,1.09975449933,-3.12461513833,-3.63417739667,-3.77318974167,3.37591812667,-1.19961836667,4.26719454333,2.38089080667,1.83129688,1.17659364467,-2.242212935,-0.9577158905,-0.854599925333,1.79116021333,1.18085313833,0.00626060105667,0.0892416280333,0.6772202995,-1.56191788833,2.09954564833,-0.1597206675,-0.61916437,-0.9067966415,1.40125559667,-1.27342004333,1.51868512667,0.154662025333,0.292796477333,0.8904249455,-0.1293271515,0.041717046305,-0.253055815667,0.805784146167,-0.4268167045,-0.419697862333],[-32879.49,-3039.60862,5706.07281167,161.453938833,2646.22528667,264.638446167,-302.429608,1237.57093833,995.7043775,-952.3605695,-632.866638,1395.49700667,198.033980667,167.777760617,950.233748167,628.104070667,593.327663833,101.583585667,328.270945167,-399.1327625,9.53859341667,-251.7269865,-84.4115122333,-82.5973037333,-36.15516185,309.417299667,-172.732768167,328.400386167,7.08834883667,1.45540382,37.1941402333,-23.24560835,-25.23755595,107.407064,-6.17341887667,39.8815945667,-20.3645602,4.05950413833,-90.6237254,78.7283598667,-179.4027105,-1.88446640167,23.32879365,-14.9335442,12.2617054283,32.252211,-42.536479,3.885942215,6.15680737,-34.2426827833,-43.53586025,-21.0780012167,-8.06499992333,-62.4832720333,7.24454288,-7.00510152167,-40.9133819,-0.790322760667,8.48405993833,-20.1244826333,13.5572301,15.7161078667,-6.90649895167,-2.08054756,-1.64317064333,-15.9656776,6.22415658167,-16.80576715,-23.4528499667,-10.420956455,-5.92160630833,-11.4057639167,2.58291588333,3.94126865333,1.98902295667,7.87998038,5.07058384167,-1.19071249167,-7.93351981,-3.935004075,1.76215966,0.221106545833,-3.35924213167,2.47171375667,-6.17965314667,0.981663289833,-3.09746431,-3.79549685333,-3.645354025,3.08701445667,-1.06181603317,4.14033995167,2.23071649333,1.92441420667,0.942338681333,-2.40590559333,-1.08841903833,-0.887508367167,1.77101873833,1.20951778833,-0.0187289563483,0.0653235461667,0.656183303833,-1.58136847667,2.10946060167,-0.147144420167,-0.642475680833,-0.865615594833,1.33584131167,-1.270143485,1.46017388167,0.128133587217,0.270346011167,0.8506368805,-0.119478230167,0.00488455298667,-0.223293660667,0.789388231667,-0.469916970833,-0.439783359],[-32577.3067833,-2975.71557167,5703.28373833,110.469912367,2702.97638833,108.7960746,-158.07614654,1302.97165833,1014.36481383,-1018.2707085,-553.781949167,1413.46316167,172.500728167,254.683048833,925.7944535,661.5401995,603.4079165,137.294505333,357.155483167,-357.003283,-18.2410724333,-245.074706,-50.1846877,-75.3172431,-49.09402185,313.687139,-179.328648167,320.456369667,13.5159201983,7.34528914667,35.3602887833,-19.8443938333,-31.80480685,100.217929083,-2.4803798045,38.4238619833,-17.4219823667,1.12881209,-91.5617492167,82.7119143833,-181.373993167,4.01976711667,23.4604388333,-19.4495330833,14.5758453333,29.8384802167,-48.1112636667,3.32791803333,6.16100274333,-34.4666389167,-45.47284055,-19.1691003667,-6.92448881,-62.037665,8.95466960333,-8.182506215,-40.3926330167,-2.44063224433,8.84498890833,-20.48407475,13.9011048,16.9779079167,-10.269227545,-2.40656084333,-1.65713546,-15.8514667,6.94424628,-16.52358515,-23.88126095,-9.962650215,-6.75616817667,-11.2657023667,2.03125563167,4.43842505833,1.73357840833,7.693342095,5.750477075,-2.42945424667,-8.63841644667,-4.23445430667,1.79504938167,0.1395798759,-3.37436742667,2.618555365,-6.14800316333,0.871807172167,-3.04756202833,-3.93835376833,-3.50449484667,2.788921975,-0.915630063333,4.01362193167,2.0716788,2.01994643333,0.718685113167,-2.566125505,-1.200310365,-0.941635659,1.74713693667,1.23895503833,-0.0492477229667,0.0413234479833,0.633574205,-1.59498244333,2.11142202,-0.132784399167,-0.660502067167,-0.822156724167,1.26145416167,-1.264087465,1.39815005833,0.0989415102667,0.248019196667,0.812400256,-0.1098395865,-0.0225260120783,-0.200175548333,0.7738606505,-0.51468981,-0.455740941333],[-32339.31615,-2884.98721,5706.821405,32.42832115,2756.13043667,-49.7122461,-6.62814916,1367.69748833,1026.00388333,-1077.71538833,-479.456132167,1425.63535333,153.082085333,331.811244167,891.249814833,690.876270667,613.949624833,172.248296167,387.8050045,-314.656210167,-51.0991947667,-237.816193333,-14.1956027667,-70.0743638667,-63.22581795,316.119485833,-184.7442545,310.8361865,20.3118262,11.52916227,32.92143995,-16.7372403333,-40.0980645833,92.6009833167,0.289307680333,36.9387814833,-14.6621802667,-2.61040441667,-91.7002215167,86.01601485,-183.422595167,9.51968829,23.44599415,-24.056295,16.7487475,27.1108395833,-53.87636305,3.143515945,6.27251449167,-34.6013301167,-47.5091307333,-17.1858875333,-6.03361131833,-61.2953830833,10.47104928,-9.420003255,-39.5960334167,-3.81141813333,9.26624225,-20.6646029333,14.3939914333,18.10886705,-13.52112945,-2.71210414333,-1.65653543833,-15.6859849333,7.675647655,-16.2290710167,-24.1671034,-9.44375605167,-7.59373510167,-11.0485674833,1.55569857667,4.94565318167,1.529634355,7.53782485833,6.427996595,-3.62723825833,-9.34344582167,-4.49969238,1.825320875,0.0466282458,-3.37492163,2.77381491833,-6.09139207833,0.7709522175,-2.97691625667,-4.061437105,-3.34941048833,2.48455326667,-0.762860401,3.89013703833,1.90694559167,2.11852742333,0.509863494667,-2.72546532,-1.28766336333,-1.01700317133,1.71813327,1.26662209833,-0.0848715143833,0.0178479300283,0.609461795333,-1.60007281167,2.10502955,-0.1165891252,-0.673022041833,-0.776656480167,1.17851384167,-1.25519039167,1.33339145,0.0674340290667,0.227001162833,0.777548073667,-0.101505080133,-0.0391624285,-0.184077026667,0.7586867825,-0.561493589,-0.467757074667],[-32175.4103333,-2761.19996333,5752.02387,-76.0500462333,2811.72665333,-208.2015154,148.423779293,1430.99391667,1027.79625333,-1133.66181667,-415.451684667,1429.44792667,141.346938833,394.889418,843.619547167,716.017321,624.135143667,203.6518385,418.345861333,-273.515409667,-89.6286740167,-230.955022833,23.0658947,-68.3364993833,-78.0769042,316.829379667,-188.908609833,299.6676655,27.2466047667,13.92515415,29.354315,-14.05034945,-50.3097114333,84.3929279667,2.12336214383,35.6912585833,-11.959789375,-6.99430037,-91.01043395,88.5275744333,-185.508169167,14.5187300267,23.365067,-28.7651450667,18.8022671333,24.0563090167,-59.6919664833,3.35874595667,6.547400395,-34.5848443667,-49.5732407,-15.1288349167,-5.42949687667,-60.2419356667,11.7594979667,-10.6846961017,-38.5426829167,-4.86357100667,9.73133065167,-20.6209469167,15.0334984,19.0675734167,-16.6451648167,-2.99546379167,-1.62222807,-15.4552891833,8.41972468,-15.9205258833,-24.3086084333,-8.87564605333,-8.420592065,-10.7583375,1.168984529,5.457282665,1.39046713833,7.42320582667,7.08819226167,-4.776330705,-10.0497238567,-4.722852295,1.847503475,-0.0536219713,-3.35914952,2.9371521,-6.00348450167,0.679289262167,-2.88697624667,-4.16209651833,-3.18163174,2.17859350333,-0.604398754833,3.77162203167,1.74064024667,2.21815067,0.319064219333,-2.88609431,-1.34707493667,-1.1132864,1.68258982167,1.28992053,-0.125301099883,-0.00502072517,0.5841320905,-1.59417189833,2.090086535,-0.0982941164667,-0.679611457,-0.729795563167,1.08824708683,-1.24309752,1.266359155,0.034557655,0.207630534333,0.747410958,-0.0955108958833,-0.0445998077333,-0.1751123065,0.7432538855,-0.6105252685,-0.475946821333],[-32059.0997167,-2635.669355,5821.823375,-205.013297317,2863.80460667,-369.560124,306.180453167,1476.93311833,1021.72662167,-1188.94404167,-365.8742195,1422.5805,134.4191955,446.475103667,780.2742045,737.789311667,634.147383333,230.213161333,446.9725965,-235.782246167,-131.991901833,-225.197024667,60.6062573667,-69.7838019167,-93.2168763833,316.213167,-191.3663845,287.105281333,34.2817755,14.8254714,24.2937987833,-11.9868610333,-61.7352078833,75.3216276167,3.430946135,34.8343693833,-9.18156681167,-11.790373495,-89.55064895,90.2825996833,-187.5859915,18.9667356,23.3303444,-33.3575031167,20.657999,20.83038025,-65.5319718833,3.95617023333,7.012785415,-34.376198,-51.5995868833,-13.0253915333,-5.10850643667,-58.8987361667,12.7906457833,-11.9266513833,-37.21734055,-5.608546835,10.28076299,-20.36730205,15.80015725,19.8085537,-19.61937915,-3.25629621,-1.54296532833,-15.1528807333,9.17211974667,-15.5955478,-24.3172964333,-8.273975855,-9.21992031,-10.4038826167,0.8711808395,5.98067330833,1.307907635,7.35489115833,7.70922814667,-5.87108065167,-10.7580741167,-4.90383912167,1.85819427333,-0.157867730133,-3.327519025,3.10819452667,-5.88130865667,0.594903398333,-2.781202285,-4.23787725833,-3.00676142333,1.87486396167,-0.4394488325,3.65447005,1.57723609833,2.312955975,0.146921797717,-3.04970058167,-1.379249835,-1.22956804833,1.64001247333,1.30719393833,-0.169839857833,-0.0273849234717,0.558276772333,-1.57594921,2.066572415,-0.0781043094667,-0.680112648167,-0.683403556833,0.992592075833,-1.22766469833,1.19648304333,0.00163890026667,0.188679127333,0.722008134833,-0.0928514577667,-0.0397686152333,-0.172969561167,0.7272185495,-0.661566356667,-0.480460559833],[-31943.3090167,-2519.60314,5879.17185667,-339.261279167,2909.84634167,-532.673140667,472.637610833,1486.66298833,1012.46247,-1244.55690833,-332.577850167,1406.26857667,130.295436833,491.076339833,701.5643705,757.081981,644.494571167,251.8098355,472.4403415,-203.107189667,-175.7364115,-220.1904955,97.4928245333,-73.3319573333,-108.356658083,314.620848833,-191.4533585,273.356283,41.5959872333,14.5527607833,17.66155509,-10.7504331833,-73.2910647333,65.0119861,4.79263034833,34.4305698833,-6.25324064667,-16.7577692667,-87.4580285167,91.3771846167,-189.622239167,22.8635434667,23.4316682833,-37.5339617167,22.1706098833,17.6505290667,-71.4104778,4.92899154833,7.68014501333,-33.9572171667,-53.5425974667,-10.9253526667,-5.06064067167,-57.3073620833,13.5420634167,-13.1117209833,-35.5941781833,-6.08507070833,10.9771242167,-19.940679,16.67712835,20.2910655167,-22.4270885167,-3.49315477833,-1.41183346167,-14.7807915833,9.92453418,-15.2566179333,-24.2119565167,-7.65587170167,-9.98172897333,-9.99798389667,0.656526711333,6.52661119667,1.26541625333,7.335814085,8.2692274,-6.90921597333,-11.4684867833,-5.04321906833,1.85582979,-0.262668020667,-3.28209541333,3.28698179667,-5.72496657167,0.515075491333,-2.66390513333,-4.28838169667,-2.832436155,1.57643448333,-0.2679683031,3.533645825,1.42044733333,2.39672535,-0.00710279846667,-3.21714806,-1.385434915,-1.36420222667,1.59023127333,1.31746158333,-0.217458866833,-0.04925051355,0.533013497833,-1.54491102,2.03485307167,-0.0564696739667,-0.674829685,-0.639692779333,0.893460891833,-1.20953312167,1.123177455,-0.0302632727333,0.1686431915,0.7009738,-0.0943296379667,-0.0257642206833,-0.1770269675,0.710411301,-0.714341647167,-0.481309148333],[-31804.80665,-2414.25730333,5911.33731,-474.013687,2950.36783667,-687.9602325,649.113299167,1447.65331333,1002.67746967,-1301.43472333,-314.604831333,1383.250245,129.235541,534.925572833,611.666262,774.1383685,655.3394775,268.602429,493.850504,-176.522403167,-218.2079925,-214.511905667,133.226931667,-78.3641473333,-123.2602355,312.285192833,-188.692909167,258.763263833,49.3889204833,13.3593353333,9.47450365023,-10.4469088333,-84.0468742833,52.97670695,6.79124976833,34.5379380833,-3.13224572367,-21.73146815,-84.8962829833,91.8981774833,-191.6257825,26.1789657333,23.7108768167,-41.0250733333,23.1389572167,14.7324928333,-77.3302188833,6.33365014833,8.56533716667,-33.3190175833,-55.3798294333,-8.88984939,-5.28036731667,-55.5271266833,13.9860981667,-14.2330089,-33.6497037833,-6.34341935667,11.8762681333,-19.37797425,17.6713384167,20.48555555,-25.0518561,-3.70320863667,-1.22298006033,-14.3448807833,10.6672780567,-14.9087830667,-24.0149685833,-7.03713352833,-10.7049564333,-9.55525967167,0.518954225333,7.10291844833,1.24596794833,7.37184867833,8.75094371,-7.88756769833,-12.1793380667,-5.14116702833,1.839380175,-0.364395757167,-3.22481611667,3.47461917,-5.53575088833,0.437077223167,-2.538411545,-4.31516751833,-2.66714156167,1.285965825,-0.0916953765,3.40428673,1.27291274333,2.46449372,-0.143165884617,-3.38855296667,-1.36668889833,-1.515820615,1.53311205167,1.31995667167,-0.267076237,-0.0703795230667,0.509996270833,-1.50098372,1.99566211333,-0.0336665533833,-0.664335644667,-0.6009890955,0.792318475833,-1.19008738167,1.046055027,-0.0608749417333,0.146372765,0.684011336,-0.100519909967,-0.00348321208333,-0.186869931,0.692707845833,-0.7685176675,-0.478179784333],[-31645.1721167,-2328.03197333,5921.32554333,-610.181331333,2984.993735,-829.595012833,834.3140825,1365.298735,994.521525167,-1361.00622,-310.726417833,1357.19646167,133.799864167,581.911434833,515.2462715,789.359209333,666.3539425,280.292080667,510.783576,-156.812343167,-257.5710195,-206.273692,166.942203333,-85.0900507,-137.52085,309.256368,-182.806848,243.923779833,57.5626722333,11.3786153333,-0.100803699067,-11.3538215167,-93.4928858833,38.8827199,9.81607673333,35.2626638,0.179769413667,-26.5316619,-81.9813414333,91.8244947667,-193.5724115,28.90223835,24.1278898167,-43.6972592167,23.38824005,12.2085185,-83.27588505,8.25362666333,9.69368368667,-32.4576281667,-57.0683392333,-6.98155754333,-5.78155695333,-53.5904462,14.09685985,-15.2988672333,-31.3799123833,-6.432601405,13.0028054333,-18.7077905,18.8044623333,20.3764300333,-27.46639915,-3.88466751833,-0.968093613,-13.84280965,11.3831003833,-14.55793275,-23.7398553333,-6.434996785,-11.3898337333,-9.08711119833,0.452553914333,7.71108975167,1.23670748833,7.47189218667,9.14249095333,-8.796355835,-12.8890016167,-5.19736402167,1.80652507167,-0.458197641333,-3.15598663333,3.66902485833,-5.31398458,0.359564523167,-2.40875247167,-4.31930832333,-2.51629673833,1.00564619417,0.0869649088333,3.262904555,1.13735204,2.51255679,-0.259231600833,-3.56407542833,-1.32373247833,-1.68304978167,1.468900275,1.31342454,-0.317403287833,-0.09067240005,0.49014427,-1.44363198167,1.94956202833,-0.0102390451333,-0.648918633,-0.5686523415,0.6902758005,-1.17051378667,0.964879369,-0.0901344360667,0.120973208217,0.6712631575,-0.11195907335,0.0264455501333,-0.202301810833,0.674080831167,-0.823742662,-0.470774037667],[-31460.15665,-2263.43201667,5913.02073667,-742.313561,3013.30927,-963.071089,1028.2620595,1250.36857667,992.637249,-1425.15402833,-319.706096333,1334.02004667,144.755144333,633.819833667,417.835465167,803.755436833,676.96341,286.599420333,523.642914667,-144.607871,-292.220013833,-193.0508325,197.438179833,-93.7474817667,-150.659132333,305.5179785,-173.502735167,229.600803667,65.8832124333,8.79699745833,-10.7014183431,-13.85729785,-101.134046567,22.5868153483,14.2312099217,36.70630415,3.66286640133,-30.9084180833,-78.8161387333,91.0995710333,-195.390059167,31.0595188333,24.5923117667,-45.4285002833,22.7768154333,10.2215389467,-89.2186098333,10.7609361267,11.0872568167,-31.3736563167,-58.5435613667,-5.27375069833,-6.58018507333,-51.5081410167,13.8565408333,-16.3221673167,-28.7779200167,-6.40295612667,14.3792782167,-17.95734795,20.1007717167,19.95278965,-29.63594845,-4.037878405,-0.638575432,-13.2680001167,12.0469344167,-14.2092605333,-23.39532995,-5.86669714833,-12.0364431333,-8.60108117333,0.449812932667,8.35243696167,1.22498448167,7.64568042167,9.432746215,-9.62183898,-13.5948460333,-5.21093386,1.75404498167,-0.538808312,-3.07579688667,3.86557193667,-5.05961268167,0.281344203167,-2.27967738667,-4.30173412,-2.38347327833,0.736625557667,0.265813080233,3.105997555,1.01666048117,2.53712744833,-0.352388007,-3.74363365667,-1.25707151833,-1.864171755,1.39827181667,1.296345295,-0.367051049833,-0.110376239467,0.473869935667,-1.37219336667,1.896787715,0.0128829123333,-0.628811802333,-0.5435268695,0.588010193833,-1.15179668167,0.879257699833,-0.118002639817,0.0915306992333,0.662875643333,-0.129114429,0.06353635185,-0.22309815,0.654674536167,-0.879550431833,-0.458783261667],[-31252.1077167,-2256.45841333,5874.19712,-859.585704167,3024.736975,-1106.59345217,1218.37433833,1105.37414183,1005.2830265,-1497.615135,-340.789307,1317.23458333,157.911014167,688.990818833,324.688553333,819.439738833,686.775764333,287.420469667,532.932075667,-140.741564,-321.194132833,-173.073309333,223.3480205,-104.7451142,-162.125365,301.2900275,-160.461169333,216.623309,74.0117699,5.77522800167,-22.1604150167,-18.3387541833,-106.6595495,4.11365522667,20.3291672667,38.9237044667,7.35805800333,-34.54791705,-75.4423191333,89.6805120333,-196.974208333,32.6355854167,25.0057932333,-46.17824015,21.2041997167,8.89648064167,-95.0947703667,13.89139315,12.74684825,-30.0665193833,-59.72762025,-3.823079425,-7.672839215,-49.2702502333,13.2572906667,-17.3064942167,-25.8535254833,-6.30071009833,16.0130381333,-17.1429270167,21.5755310333,19.2100859333,-31.5264230333,-4.168413495,-0.229892532333,-12.6135105333,12.6344743333,-13.8618320167,-22.9851453167,-5.341508455,-12.6416745,-8.103104105,0.504538424167,9.02431934167,1.20147651667,7.899144405,9.61301637667,-10.3498456117,-14.2927857167,-5.180535,1.67819771833,-0.602722371333,-2.98549007167,4.05866044,-4.771767505,0.201524131167,-2.15335407,-4.26305533833,-2.26976377,0.4800344585,0.442536906167,2.93118987167,0.912618447,2.53543152,-0.419799533833,-3.92653550167,-1.16705050833,-2.05698396333,1.322162605,1.26736514333,-0.415041166833,-0.130226566667,0.461063052,-1.28620232667,1.83729831333,0.0351850544167,-0.6044241185,-0.5254877975,0.485969566333,-1.13452581167,0.789026145833,-0.144640588833,0.0576015537333,0.6588480195,-0.152167011833,0.107411722567,-0.248843171833,0.634720468667,-0.935332736667,-0.44182875],[-31036.1029667,-2295.62747667,5830.12046833,-968.618293333,3019.94747,-1263.31407667,1376.32789667,938.9571795,1032.74547833,-1579.45942167,-367.986734167,1304.90543,172.536959167,740.452421167,239.891778333,836.247439833,695.869209833,283.013375667,538.4225865,-144.003699,-345.258364167,-145.4901665,243.533470667,-118.930182667,-172.075590833,296.867688,-144.0246675,205.633792833,81.9425190667,2.15128653,-34.3466473667,-25.0940432,-110.235062,-16.1855558017,28.3072642333,41.81337615,11.2581690833,-37.4183564167,-71.8203402167,87.5864990833,-198.302131167,33.6597021833,25.23614205,-46.07642825,18.6634739833,8.30132812333,-100.8210738,17.6197741333,14.6602092333,-28.5775905667,-60.6264476167,-2.63287536,-9.04542623,-46.88690155,12.3239258,-18.2705315333,-22.6494386167,-6.16949064167,17.8783957667,-16.2749471167,23.2245833,18.1660079,-33.1342476833,-4.27333664333,0.246054936,-11.888381,13.137835,-13.5180685167,-22.51749985,-4.85783194,-13.2082621667,-7.59814672167,0.607578312833,9.71490301667,1.15986768333,8.23101618833,9.68360750833,-10.9780675167,-14.97749535,-5.10554310333,1.580567565,-0.650504302833,-2.88785827833,4.24559298,-4.453486965,0.119659703883,-2.02942441167,-4.20542247333,-2.17365979833,0.236094358857,0.613796154667,2.73789237833,0.825126916833,2.50724519333,-0.4615908655,-4.11113278333,-1.05430010583,-2.25948822833,1.24222792333,1.226882735,-0.460863568833,-0.150580451167,0.451628056167,-1.18700811167,1.77185483,0.056584054,-0.576431927833,-0.513552364833,0.3844789705,-1.11904721833,0.6944993895,-0.170472059,0.01941168845,0.658647183667,-0.180686109,0.157670218,-0.2790888235,0.614664562833,-0.990403143,-0.419746521],[-30838.64175,-2291.60301333,5809.55130333,-1085.016521,3015.2889,-1427.46105,1488.72063667,757.785624,1070.16926833,-1670.88586833,-392.933811167,1296.26021333,189.037370167,784.750448167,164.34048535,853.039099,703.598241167,274.434791,539.741469333,-151.992333333,-364.6481365,-111.07254645,258.401603667,-137.667047833,-180.902976,292.439125167,-124.827614,196.789827,89.9468812833,-2.19831523833,-47.2473896167,-33.7793442667,-112.391876167,-37.6288000667,38.1426711167,45.2200859,15.37822445,-39.6599725333,-67.9425273667,84.91707285,-199.435415833,34.2004235,25.2645146,-45.2946485667,15.2978999833,8.42626571833,-106.3085005,21.7973086,16.7988136,-26.9450634833,-61.3041798167,-1.6706474065,-10.6687401333,-44.3980965833,11.110191165,-19.2286730833,-19.1968644167,-6.02946053,19.9355320833,-15.3522900167,24.9972324167,16.8565902667,-34.4957826833,-4.35109817667,0.771758439,-11.1116004167,13.5660488667,-13.1821978333,-22.0054406167,-4.40662160167,-13.74484855,-7.08451600167,0.7494359195,10.4142302817,1.09983265,8.62749222,9.65454628833,-11.5207777667,-15.64251135,-4.98976080667,1.464744785,-0.686021678667,-2.78572304833,4.42714731,-4.11020957,0.0360966587167,-1.90635377,-4.132894595,-2.09289733667,0.00370015642667,0.778243871333,2.52756443,0.752570529333,2.45566403,-0.481596236833,-4.29484202333,-0.921725553,-2.47032122167,1.15939312833,1.17653407167,-0.5047686405,-0.171254154333,0.4454735175,-1.07686640933,1.70185881167,0.0772614667,-0.545754513333,-0.507082908833,0.283648461833,-1.10520994167,0.596295531667,-0.1955650905,-0.0219907883833,0.6616287175,-0.2137018265,0.213281529167,-0.3135586005,0.594499075333,-1.04427892283,-0.392953461833],[-30675.8173333,-2253.08329167,5805.12179333,-1224.413185,3016.05239,-1593.25077667,1561.50345,575.7057775,1111.55961833,-1767.709815,-408.767081333,1291.74032167,208.0445985,818.336837833,93.3201802667,869.330276167,710.252408667,263.314216833,536.4899255,-163.237007333,-379.971638167,-72.0910630833,267.781840333,-159.910680167,-188.758008167,288.013463,-103.542964017,189.788114,97.9881299167,-7.20644791833,-60.6886037333,-44.05316895,-113.271033333,-59.4198800167,49.3900087,49.00921615,19.64154165,-41.4450915667,-63.83820505,81.7984214333,-200.406149167,34.4278723833,25.1276773333,-44.0283072333,11.3598451867,9.13533293667,-111.621743667,26.29343025,19.1113812167,-25.20761035,-61.8281493667,-0.881093477,-12.4809330667,-41.8443931,9.68037901,-20.1795927167,-15.56326355,-5.883690185,22.14176775,-14.4024723,26.8494315,15.3404258333,-35.65689605,-4.40660630667,1.33709966533,-10.298614985,13.9360097667,-12.8525119833,-21.4637599167,-3.98505322667,-14.2599577167,-6.565858545,0.917888559667,11.1198993,1.02385597467,9.07266737167,9.546909455,-11.9950594333,-16.2931088167,-4.842661035,1.33512393167,-0.711696663,-2.68060737,4.604031745,-3.74842224,-0.0489182947167,-1.784549065,-4.049984745,-2.02365500833,-0.219770910977,0.936506672333,2.30432662333,0.691973663167,2.38546278667,-0.484158737667,-4.47788987167,-0.774134748333,-2.68699218667,1.075500761,1.11867048333,-0.547286370667,-0.192031441,0.441891795333,-0.958642743833,1.62873886667,0.0976390948167,-0.513299307167,-0.5047605375,0.183699969083,-1.09295509667,0.495415436,-0.220081787833,-0.0660379458167,0.667123659667,-0.250071581167,0.272937923167,-0.3512050535,0.574658427167,-1.097076825,-0.362849270333]])
    return models,coeffs

def get_pfm9k():
    models=[-7000,-6990,-6980,-6970,-6960,-6950,-6940,-6930,-6920,-6910,-6900,-6890,-6880,-6870,-6860,-6850,-6840,-6830,-6820,-6810,-6800,-6790,-6780,-6770,-6760,-6750,-6740,-6730,-6720,-6710,-6700,-6690,-6680,-6670,-6660,-6650,-6640,-6630,-6620,-6610,-6600,-6590,-6580,-6570,-6560,-6550,-6540,-6530,-6520,-6510,-6500,-6490,-6480,-6470,-6460,-6450,-6440,-6430,-6420,-6410,-6400,-6390,-6380,-6370,-6360,-6350,-6340,-6330,-6320,-6310,-6300,-6290,-6280,-6270,-6260,-6250,-6240,-6230,-6220,-6210,-6200,-6190,-6180,-6170,-6160,-6150,-6140,-6130,-6120,-6110,-6100,-6090,-6080,-6070,-6060,-6050,-6040,-6030,-6020,-6010,-6000,-5990,-5980,-5970,-5960,-5950,-5940,-5930,-5920,-5910,-5900,-5890,-5880,-5870,-5860,-5850,-5840,-5830,-5820,-5810,-5800,-5790,-5780,-5770,-5760,-5750,-5740,-5730,-5720,-5710,-5700,-5690,-5680,-5670,-5660,-5650,-5640,-5630,-5620,-5610,-5600,-5590,-5580,-5570,-5560,-5550,-5540,-5530,-5520,-5510,-5500,-5490,-5480,-5470,-5460,-5450,-5440,-5430,-5420,-5410,-5400,-5390,-5380,-5370,-5360,-5350,-5340,-5330,-5320,-5310,-5300,-5290,-5280,-5270,-5260,-5250,-5240,-5230,-5220,-5210,-5200,-5190,-5180,-5170,-5160,-5150,-5140,-5130,-5120,-5110,-5100,-5090,-5080,-5070,-5060,-5050,-5040,-5030,-5020,-5010,-5000,-4990,-4980,-4970,-4960,-4950,-4940,-4930,-4920,-4910,-4900,-4890,-4880,-4870,-4860,-4850,-4840,-4830,-4820,-4810,-4800,-4790,-4780,-4770,-4760,-4750,-4740,-4730,-4720,-4710,-4700,-4690,-4680,-4670,-4660,-4650,-4640,-4630,-4620,-4610,-4600,-4590,-4580,-4570,-4560,-4550,-4540,-4530,-4520,-4510,-4500,-4490,-4480,-4470,-4460,-4450,-4440,-4430,-4420,-4410,-4400,-4390,-4380,-4370,-4360,-4350,-4340,-4330,-4320,-4310,-4300,-4290,-4280,-4270,-4260,-4250,-4240,-4230,-4220,-4210,-4200,-4190,-4180,-4170,-4160,-4150,-4140,-4130,-4120,-4110,-4100,-4090,-4080,-4070,-4060,-4050,-4040,-4030,-4020,-4010,-4000,-3990,-3980,-3970,-3960,-3950,-3940,-3930,-3920,-3910,-3900,-3890,-3880,-3870,-3860,-3850,-3840,-3830,-3820,-3810,-3800,-3790,-3780,-3770,-3760,-3750,-3740,-3730,-3720,-3710,-3700,-3690,-3680,-3670,-3660,-3650,-3640,-3630,-3620,-3610,-3600,-3590,-3580,-3570,-3560,-3550,-3540,-3530,-3520,-3510,-3500,-3490,-3480,-3470,-3460,-3450,-3440,-3430,-3420,-3410,-3400,-3390,-3380,-3370,-3360,-3350,-3340,-3330,-3320,-3310,-3300,-3290,-3280,-3270,-3260,-3250,-3240,-3230,-3220,-3210,-3200,-3190,-3180,-3170,-3160,-3150,-3140,-3130,-3120,-3110,-3100,-3090,-3080,-3070,-3060,-3050,-3040,-3030,-3020,-3010,-3000,-2990,-2980,-2970,-2960,-2950,-2940,-2930,-2920,-2910,-2900,-2890,-2880,-2870,-2860,-2850,-2840,-2830,-2820,-2810,-2800,-2790,-2780,-2770,-2760,-2750,-2740,-2730,-2720,-2710,-2700,-2690,-2680,-2670,-2660,-2650,-2640,-2630,-2620,-2610,-2600,-2590,-2580,-2570,-2560,-2550,-2540,-2530,-2520,-2510,-2500,-2490,-2480,-2470,-2460,-2450,-2440,-2430,-2420,-2410,-2400,-2390,-2380,-2370,-2360,-2350,-2340,-2330,-2320,-2310,-2300,-2290,-2280,-2270,-2260,-2250,-2240,-2230,-2220,-2210,-2200,-2190,-2180,-2170,-2160,-2150,-2140,-2130,-2120,-2110,-2100,-2090,-2080,-2070,-2060,-2050,-2040,-2030,-2020,-2010,-2000,-1990,-1980,-1970,-1960,-1950,-1940,-1930,-1920,-1910,-1900,-1890,-1880,-1870,-1860,-1850,-1840,-1830,-1820,-1810,-1800,-1790,-1780,-1770,-1760,-1750,-1740,-1730,-1720,-1710,-1700,-1690,-1680,-1670,-1660,-1650,-1640,-1630,-1620,-1610,-1600,-1590,-1580,-1570,-1560,-1550,-1540,-1530,-1520,-1510,-1500,-1490,-1480,-1470,-1460,-1450,-1440,-1430,-1420,-1410,-1400,-1390,-1380,-1370,-1360,-1350,-1340,-1330,-1320,-1310,-1300,-1290,-1280,-1270,-1260,-1250,-1240,-1230,-1220,-1210,-1200,-1190,-1180,-1170,-1160,-1150,-1140,-1130,-1120,-1110,-1100,-1090,-1080,-1070,-1060,-1050,-1040,-1030,-1020,-1010,-1000,-990,-980,-970,-960,-950,-940,-930,-920,-910,-900,-890,-880,-870,-860,-850,-840,-830,-820,-810,-800,-790,-780,-770,-760,-750,-740,-730,-720,-710,-700,-690,-680,-670,-660,-650,-640,-630,-620,-610,-600,-590,-580,-570,-560,-550,-540,-530,-520,-510,-500,-490,-480,-470,-460,-450,-440,-430,-420,-410,-400,-390,-380,-370,-360,-350,-340,-330,-320,-310,-300,-290,-280,-270,-260,-250,-240,-230,-220,-210,-200,-190,-180,-170,-160,-150,-140,-130,-120,-110,-100,-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,470,480,490,500,510,520,530,540,550,560,570,580,590,600,610,620,630,640,650,660,670,680,690,700,710,720,730,740,750,760,770,780,790,800,810,820,830,840,850,860,870,880,890,900,910,920,930,940,950,960,970,980,990,1000,1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,1110,1120,1130,1140,1150,1160,1170,1180,1190,1200,1210,1220,1230,1240,1250,1260,1270,1280,1290,1300,1310,1320,1330,1340,1350,1360,1370,1380,1390,1400,1410,1420,1430,1440,1450,1460,1470,1480,1490,1500,1510,1520,1530,1540,1550,1560,1570,1580,1590,1600,1610,1620,1630,1640,1650,1660,1670,1680,1690,1700,1710,1720,1730,1740,1750,1760,1770,1780,1790,1800,1810,1820,1830,1840,1850,1860,1870,1880,1890,1900]
    coeffs=numpy.array([[-31741.8903131,1003.19529868,1489.86574709,-3779.77909138,707.507661342,778.986079542,-178.298186355,2599.99788883,574.048478458,1105.22785997,-425.089567956,-239.401705807,241.750924564,308.741812971,369.767754264,-373.286902283,607.858423106,-382.719830489,49.3627749162,203.694007332,76.9336962043,-160.755989868,175.793081862,-256.133165739,-8.35198288316,277.757622458,-4.80319725902,-25.3464481129,75.4538434062,66.8331215162,8.18916481065,-70.1564654705,-43.3900797751,-13.0509069829,-27.2629505306,-24.686819077,54.5536811186,-27.2087212982,25.1910633769,4.10443046083,34.7482717743,-3.01994889188,-7.1788315317,-33.8676752131,-8.02209563042,-5.92877632514,2.74197565223,1.25892256316,-5.39717294172,5.2579449991,1.55881037088,-0.00319408038842,-0.161286130434,10.3706845823,-2.49511071057,-5.79735829956,-2.50291217403,-4.04438987812,-9.08965114102,2.9374867091,1.57141866161,-1.74779236793,-0.964405230705,-1.32611947033,0.732760249754,-1.94299041107,0.572188572662,-0.821363013794,4.03260870877,2.33483099126,-0.76445067563,-1.34618841021,-1.22106719762,-2.12161451811,-2.0503065374,-0.638371474064,-0.0417801273568,-1.55150018101,0.922271614756,0.525207922486,-0.329838504229,-0.514671696871,0.0661321196784,-0.807597969145,-0.50826400882,1.17203491904,-0.208305031466,0.269526804211,-0.289363306102,-0.232922851836,-0.315926186483,0.157000209679,-0.0467554331662,0.042690146093,-0.0888237425671,0.127276698707,-0.0614005179836,0.0871348591265,0.0800321828977,0.0843589096567,-0.0340110386401,0.00332098633177,-0.141423509649,-0.0731592312511,0.288321908259,0.0974906145541,-0.0534068348854,0.0281969750078,0.0405307753062,-0.0476714089356,-0.103818727422,-0.0906022449848,0.0326812117057,-0.127846955686,0.0386430980141,-0.0173075675785,-0.0257224852616,0.00590779073765,-0.0253149604776,-0.0119677222249],[-31658.4574619,1004.33888909,1495.60755761,-3773.87576683,675.074765606,783.448188511,-190.31761836,2598.50774051,588.830909915,1102.96803819,-443.355764947,-242.514179936,250.697255376,295.729244702,381.120470448,-379.546396628,599.672241391,-383.785969551,42.6159848008,204.379849707,72.1780483315,-158.89767221,174.71095222,-258.228723756,-5.64903196388,276.047565538,-3.13479132636,-25.9698139588,78.2404888998,65.4573810814,9.1801679591,-70.6012229073,-43.2994816146,-11.6854536251,-26.745571255,-24.7092700458,53.9861360818,-27.2893896703,25.1002688438,3.96131246439,34.3933416513,-3.25105319874,-6.70616082639,-34.0021382548,-7.34185900771,-5.81040476,2.49534377471,0.871731743624,-5.2796246042,5.06804022611,1.70794435982,-0.0335276840069,-0.172444273545,10.1496151856,-2.6572226324,-5.66785536995,-2.61212215874,-3.92881524464,-9.17742549082,2.93182714976,1.5001498767,-1.79326557489,-0.961236154435,-1.34410664164,0.710655439424,-2.01867104085,0.616004342796,-0.849376221816,4.02382910481,2.29747098142,-0.759746936874,-1.33503664631,-1.22589646145,-2.13201108812,-2.07435299877,-0.661682153458,-0.0603571785285,-1.57465954753,0.921782332406,0.537237682495,-0.344340434919,-0.522222707036,0.0578016553121,-0.816353178345,-0.517898137917,1.16678785202,-0.218458645653,0.266801292453,-0.292426437689,-0.23768431876,-0.32711810434,0.155329339036,-0.0558276920942,0.0414405009983,-0.0904836758058,0.13140240533,-0.0560620276528,0.0886943321757,0.0776928320852,0.0842253787746,-0.0344337200814,8.28913399673e-05,-0.141619329086,-0.0714108286207,0.287962025325,0.0984092942712,-0.0577554172874,0.0284888435484,0.0384218701481,-0.0513601454493,-0.10340124896,-0.0951790047329,0.0345492548259,-0.130719760876,0.0400982142959,-0.0144426464445,-0.026755363546,0.00676376232475,-0.0253763117979,-0.0130385582529],[-31572.1557025,1003.58149724,1499.63291246,-3767.62215326,643.419519415,787.345402323,-202.641090119,2595.90468466,603.171884661,1100.72280848,-461.993920574,-244.937319683,259.734800752,283.534710672,392.656078497,-385.719704378,591.097123568,-384.369262844,35.7898570014,205.355834907,67.3483584658,-156.900760655,173.584501534,-260.281030626,-3.0176812058,274.223435349,-1.32121165498,-26.5033396668,81.0279624659,64.0358437455,10.1920811016,-70.9951742425,-43.2325363214,-10.3362033797,-26.2192584759,-24.7426144216,53.4052324487,-27.3261964709,25.0119852628,3.80920001015,34.0093367449,-3.47176812968,-6.205830458,-34.1259607462,-6.66147139546,-5.68167848267,2.26376756004,0.466786971351,-5.16369706369,4.87643918843,1.85703736466,-0.0621884809309,-0.183651574511,9.92654846549,-2.81818969458,-5.5348588885,-2.72762024331,-3.81205758564,-9.27332049266,2.92836951446,1.42090126997,-1.83739065304,-0.955888744458,-1.36237654006,0.687703776085,-2.09577815798,0.660250197639,-0.876837894776,4.01503375118,2.25825672035,-0.755562959622,-1.32496320269,-1.22894754484,-2.14322248776,-2.09857465394,-0.685459135332,-0.0784087154403,-1.59604035562,0.920515796348,0.549851325639,-0.358889558109,-0.530279469015,0.0489222719603,-0.824952294979,-0.527219076906,1.1610167724,-0.228918405009,0.263715319456,-0.29584820185,-0.242173483202,-0.339293242881,0.152870955437,-0.065120503917,0.0396457805094,-0.0915643344302,0.135105660949,-0.0506823148381,0.0903523788718,0.0750711168476,0.0840373409658,-0.0350330555895,-0.00325306107848,-0.141844057122,-0.0695815946276,0.287436818195,0.0992658142693,-0.0621984273507,0.0286307664804,0.0361623176045,-0.0552508960554,-0.103138323795,-0.0997287715683,0.0364342812759,-0.133484593556,0.0416246443505,-0.0115443093212,-0.0277344339966,0.00756047650669,-0.0252940639103,-0.0140463117457],[-31482.3203372,1002.49387917,1501.78151328,-3760.26253307,611.876792823,791.184593192,-215.426081665,2591.88699197,616.79255912,1098.45362966,-481.299827008,-246.747009667,268.693205771,272.108603921,404.070866769,-391.79267296,582.190058311,-384.498511686,28.8781899319,206.626653917,62.5074917197,-154.760630342,172.40262891,-262.267296774,-0.453592611475,272.283476439,0.632072484166,-26.9631963157,83.8316447439,62.5491597853,11.196535819,-71.347088973,-43.2062273785,-9.01521757646,-25.678886808,-24.7859840167,52.8076147476,-27.3120819617,24.9176464657,3.6446918099,33.5948233756,-3.6916582993,-5.67865817823,-34.2413743871,-5.977368053,-5.54408003726,2.05282682694,0.0425693656823,-5.04927461671,4.68294310614,2.0055872356,-0.0894563981757,-0.196289135444,9.69996379052,-2.97783389805,-5.39766668728,-2.84943575958,-3.69460216586,-9.37571743803,2.92600676936,1.33372520973,-1.88097425177,-0.948079025075,-1.38088245037,0.663862807852,-2.17431540707,0.70418914054,-0.903645654215,4.00588555229,2.2170593214,-0.752171131408,-1.31628621895,-1.23056956234,-2.15577359711,-2.12265312111,-0.709852804731,-0.0957733705385,-1.6158851221,0.918578351479,0.562810088884,-0.373464409484,-0.5388476705,0.0394655753825,-0.833384607867,-0.536173839383,1.15468096766,-0.239697284897,0.260123336482,-0.299743822666,-0.246365553927,-0.352340421534,0.149612093202,-0.0746298825474,0.0374670176225,-0.0921093377848,0.13841203754,-0.0451278457711,0.0921042559614,0.0722146630227,0.0837838966484,-0.0357725117554,-0.00670262480264,-0.142078620097,-0.0676677677336,0.28673771547,0.100049662869,-0.0667723905909,0.0286543886397,0.0337103125473,-0.0593276426895,-0.103050606203,-0.104272083172,0.038336870793,-0.136133298023,0.043203968344,-0.00864349164156,-0.0286641061202,0.0082692428398,-0.0250807680795,-0.0150024933134],[-31388.2866684,1002.64679094,1501.89306172,-3751.04118866,579.781455883,795.472633328,-228.830073032,2586.15293312,629.414089713,1096.12196054,-501.569276423,-248.019134504,277.402115509,261.401317487,415.061123622,-397.751149801,573.008034295,-384.202517394,21.8747820063,208.196997724,57.7183132057,-152.472656413,171.154233455,-264.164732625,2.04757181658,270.225933355,2.71959182016,-27.3655549842,86.6669163732,60.9779794773,12.1651636922,-71.6657365955,-43.2375382688,-7.73455754538,-25.1193308662,-24.8385106435,52.1899275066,-27.2399864047,24.808686284,3.46438657537,33.1483678639,-3.92028832223,-5.12546173879,-34.3506108776,-5.28598423966,-5.39909196786,1.86810139413,-0.402439954039,-4.9362415598,4.48735319933,2.15309182284,-0.115611362757,-0.211738058459,9.46834052928,-3.13597724375,-5.25557659836,-2.97759803943,-3.57693425004,-9.48299761842,2.92363188067,1.23867406425,-1.9248230205,-0.937523020585,-1.39957765736,0.63909008284,-2.2542864327,0.747084174848,-0.929697121676,3.99604741257,2.1737498979,-0.749843839771,-1.30932383467,-1.23111162851,-2.17018929623,-2.14627001847,-0.7350135467,-0.11228977627,-1.63443636377,0.916076342696,0.575875209191,-0.388043524729,-0.547932999184,0.0294031713384,-0.841639405827,-0.544709438946,1.14773972526,-0.25080826068,0.255879794795,-0.304228524222,-0.2502357397,-0.366148459726,0.14553978665,-0.084351841898,0.0350652453338,-0.0921623052142,0.141347107082,-0.0392650866837,0.0939452201911,0.0691710964485,0.0834541462403,-0.0366155551699,-0.0102815537116,-0.142303944354,-0.0656655864003,0.285856145754,0.10075032839,-0.0715138325236,0.0285913548622,0.0310240498487,-0.063574367287,-0.103158750461,-0.108829477225,0.0402576031152,-0.138657718579,0.0448177664422,-0.00577112883889,-0.0295487894238,0.00886137088038,-0.0247489755706,-0.0159186135658],[-31289.3899985,1005.61098857,1499.80725943,-3739.20240245,546.468378649,800.716394942,-243.010544251,2578.40077882,640.757632866,1093.68925994,-523.098060994,-248.829578813,285.691175045,251.363244409,425.323137414,-403.580982329,563.608040192,-383.510081286,14.7734316386,210.071557314,53.0436880365,-150.032214008,169.828214272,-265.950548603,4.49015007584,268.049050645,4.93587708205,-27.7265867511,89.5491579932,59.3029530983,13.0695963023,-71.9598866069,-43.3434524755,-6.50628461636,-24.5354652654,-24.8993261144,51.548815254,-27.1028500618,24.6765385495,3.26488301835,32.6685365303,-4.16722281308,-4.54705889139,-34.4559019173,-4.58375521478,-5.24819681857,1.71517108031,-0.869759868469,-4.82448218949,4.28947068809,2.29904897659,-0.140933301689,-0.23137944567,9.23015805034,-3.29244173262,-5.10788645384,-3.1121364147,-3.4595391029,-9.59354232533,2.92013781455,1.13580020186,-1.96974360863,-0.923936755287,-1.41841544582,0.613343149164,-2.33569487945,0.788198303911,-0.954889918702,3.98518223645,2.12819956319,-0.748853472246,-1.30439418945,-1.2309228579,-2.1869944652,-2.16910696421,-0.761091746282,-0.12779656508,-1.65193659745,0.913116114895,0.588807923527,-0.402605439529,-0.557541142761,0.0187066655877,-0.849705977677,-0.552772889193,1.14015233269,-0.26226430772,0.250839145656,-0.309417530598,-0.253759249286,-0.380606176883,0.140641070098,-0.0942823958816,0.0326014966396,-0.091766856063,0.143936441553,-0.0329605038077,0.0958705283076,0.0659880429629,0.0830371901597,-0.037525652424,-0.0140056016844,-0.142500956233,-0.0635712890894,0.284783537647,0.101357299154,-0.0764592786644,0.0284733099837,0.0280617243804,-0.0679750517834,-0.103483410848,-0.113421491409,0.04219705798,-0.141049699523,0.0464476188112,-0.00295815634631,-0.0303928934142,0.00930817018479,-0.0243112376484,-0.0168061831127],[-31185.5026557,1012.41902609,1495.38190481,-3724.18284567,511.524614512,807.299531214,-258.063157301,2568.48915582,650.595413939,1091.10372957,-546.118749607,-249.226902663,293.436056877,241.95707666,434.621776361,-409.257514876,554.038234977,-382.460794513,7.58041579987,212.263836753,48.5447142191,-147.438095243,168.406419275,-267.603769954,6.87549845289,265.747854985,7.27306781893,-28.0629049181,92.4883531657,57.5094655564,13.8874951455,-72.2380229114,-43.5390687449,-5.33882021652,-23.920924149,-24.9658714218,50.8802716818,-26.894726441,24.5138081299,3.04454269348,32.153697656,-4.44041556037,-3.94369744689,-34.5594726742,-3.86781579663,-5.09163761726,1.59880958105,-1.36030958464,-4.71389551366,4.08920777063,2.44268043107,-0.165876421468,-0.256655392103,8.98433750117,-3.44712194161,-4.95382921948,-3.25262040943,-3.34251343364,-9.7054799398,2.91479888585,1.02527241663,-2.01659245599,-0.907101357164,-1.43721505001,0.586616721637,-2.41841039216,0.826766994817,-0.979232258675,3.97291684234,2.08035688717,-0.74931035148,-1.30174139782,-1.23024394097,-2.20655200529,-2.19082921025,-0.78824831314,-0.142188518864,-1.66855615712,0.909774553759,0.601385409988,-0.417078581982,-0.567628600455,0.00732748274799,-0.85757050971,-0.56031505762,1.13189905236,-0.274076997596,0.244883626209,-0.31537709781,-0.256897632642,-0.395598153384,0.134941734656,-0.104405657708,0.0302106425179,-0.0909677491274,0.146206174709,-0.0261124865915,0.0978684755346,0.0627239634837,0.0825213597542,-0.038460269175,-0.0178851005898,-0.142657190095,-0.0613910569121,0.283514205291,0.101852737737,-0.0816351645756,0.0283225830362,0.0248085708252,-0.0725092052113,-0.104040946561,-0.118061433507,0.0441532960827,-0.143298414631,0.048075880365,-0.000226685358366,-0.0311990344721,0.00958889225334,-0.0237797810688,-0.0176762394818],[-31078.6450728,1021.95064928,1488.54718322,-3706.18874497,475.545950203,815.11281919,-273.836301937,2556.91811524,658.903934046,1088.2605428,-570.611018017,-249.150367923,300.696543186,233.194701941,442.996228106,-414.714079391,544.311458833,-381.137407555,0.351925689905,214.822592413,44.2754213387,-144.702760137,166.842491604,-269.110681206,9.19304639082,263.304501573,9.71373885991,-28.3928916787,95.4728971407,55.6018402855,14.6206413792,-72.5074870435,-43.8319468772,-4.22602616164,-23.2643797748,-25.0288242784,50.1776871369,-26.6141220341,24.3177840369,2.80877852698,31.6014273654,-4.74137704815,-3.3133454527,-34.6635221881,-3.13809903935,-4.9246993268,1.52056609928,-1.87260961505,-4.60443938559,3.88692055766,2.58210345661,-0.191592046506,-0.289251964432,8.73156714467,-3.60020275187,-4.79237839576,-3.39678031632,-3.22439972913,-9.81592720103,2.90841480397,0.907725205787,-2.06642516395,-0.887058368924,-1.45525950219,0.55905418187,-2.50176661659,0.861915569615,-1.00317472235,3.95873370462,2.03048026599,-0.750676540565,-1.30131347405,-1.22888187188,-2.22857690265,-2.21103654347,-0.816686255405,-0.155585017313,-1.68417664543,0.90601070811,0.6134486112,-0.431190949844,-0.577955117611,-0.00486367713158,-0.865206778113,-0.567302227308,1.12304404638,-0.286252286744,0.238006617116,-0.321977609599,-0.259557804492,-0.410992013409,0.128622598589,-0.114658137778,0.0279229058728,-0.0898143010106,0.148184687417,-0.0187471173514,0.0998995110047,0.0594806592478,0.0818919100899,-0.0393528673466,-0.0219086942553,-0.142786612383,-0.0591708415778,0.282054004986,0.102189503742,-0.0870275660061,0.0281242398361,0.0213579831084,-0.0771384449915,-0.104830536484,-0.122733691715,0.0461143019485,-0.145382355589,0.0496880050092,0.00243646988498,-0.0319626564726,0.00971455636241,-0.0231655345521,-0.0185379278717],[-30971.3747088,1032.54740194,1479.25137678,-3685.61871581,439.380355792,823.923816883,-290.116549862,2544.34806424,665.710763235,1085.04161591,-596.491318689,-248.511911915,307.578443576,225.100306888,450.554260147,-419.873504728,534.431722243,-379.633460725,-6.84336893432,217.805393748,40.2880718751,-141.842085684,165.083023206,-270.459381708,11.4292416218,260.697927732,12.2380738541,-28.7353714492,98.4857880909,53.5891353512,15.2768460763,-72.7753349451,-44.227761936,-3.15812436467,-22.5532639292,-25.0771715768,49.4338011302,-26.2606565791,24.0869263182,2.56476628796,31.0091037435,-5.07000693436,-2.65340101536,-34.770242967,-2.39523755605,-4.74142739384,1.4811837148,-2.40458079859,-4.49608636992,3.68307613801,2.71515920758,-0.219405780696,-0.330916222243,8.4729770226,-3.75194162058,-4.62244261688,-3.54188662027,-3.10335192072,-9.92174793779,2.90216662697,0.783909492326,-2.12034712433,-0.86391443696,-1.4716977841,0.530836078173,-2.58496319874,0.892741814094,-1.02727848231,3.94207921165,1.97890555238,-0.752252037702,-1.30298440732,-1.2265352207,-2.25262216463,-2.22931238445,-0.846619105826,-0.168161589564,-1.69860748219,0.901754167557,0.624854410925,-0.444620433285,-0.588231251107,-0.0180162951438,-0.872585456547,-0.573704535238,1.11367245179,-0.298794727818,0.23022928492,-0.329040481639,-0.261633020753,-0.42665114209,0.121903236953,-0.124964445787,0.0257423475901,-0.0883569677675,0.149900922326,-0.0109224016203,0.101917122328,0.056370766572,0.0811333271625,-0.040130907929,-0.0260596044981,-0.142909797563,-0.0569665374456,0.280411678572,0.102313131026,-0.0926124687517,0.0278540303962,0.0178303949658,-0.0818199156418,-0.105847064422,-0.127415424329,0.0480655410602,-0.14727734356,0.0512702213976,0.00505331938237,-0.0326774101644,0.00970412373239,-0.02247910231,-0.0193999203985],[-30866.2490225,1042.55082781,1467.44276761,-3662.87137368,403.875801347,833.500082308,-306.690472775,2531.43941003,671.04347156,1081.32886515,-623.676104093,-247.223471962,314.187567648,217.698078137,457.403639985,-424.658619739,524.403035692,-378.042494333,-13.9367983158,221.26981021,36.6349283079,-138.87194888,163.074606026,-271.637970809,13.5705318782,257.907070787,14.8262564507,-29.1091686461,101.510024189,51.4804088187,15.8639203096,-73.0486225582,-44.7321889849,-2.1253367386,-21.7750083984,-25.0999002099,48.6413531722,-25.8339498139,23.8196950215,2.31968174552,30.3741048755,-5.42620487693,-1.96126224145,-34.8818275187,-1.63986395983,-4.53586726503,1.4814055074,-2.95414397413,-4.38880903127,3.4781416005,2.83968883834,-0.250643227931,-0.383395225123,8.20969717675,-3.9025960049,-4.44293051699,-3.68520980615,-2.97752393975,-10.0198059788,2.89723541291,0.654576199253,-2.17946372892,-0.837776207661,-1.4856788775,0.502142958854,-2.66719978462,0.918343514045,-1.05210471116,3.92239975182,1.92596859905,-0.753336841091,-1.30662818684,-1.22290255749,-2.27824079856,-2.2452401538,-0.878260397149,-0.180093764756,-1.71165808724,0.896934521708,0.635459692921,-0.457044922477,-0.598167557818,-0.0322798523817,-0.879677218673,-0.579492118391,1.10386940564,-0.31170887347,0.221572796163,-0.336387129605,-0.263016537341,-0.442438924558,0.115003224802,-0.135249191435,0.0236730285556,-0.086646205453,0.151383822081,-0.00269634493113,0.103874797113,0.0535069217728,0.0802300969678,-0.0407218519125,-0.0303210531355,-0.143047320099,-0.0548340388744,0.278595967888,0.10216915345,-0.0983658586082,0.0274877047291,0.0143462401333,-0.0865107616802,-0.107085414179,-0.132083789648,0.0499924789005,-0.148959199705,0.0528087581838,0.00764587313248,-0.0333369462965,0.00957655558365,-0.0217310885539,-0.0202708891785],[-30765.8254726,1050.30247067,1453.0696378,-3638.34533404,369.880256938,843.609173477,-323.344642378,2518.85255979,674.929629069,1077.0042068,-652.081826696,-245.196985383,320.629725004,211.012202322,463.652135119,-428.99225328,514.229409664,-376.458048694,-20.8596926977,225.27341125,33.3682531168,-135.80822672,160.763832014,-272.634547859,15.603364892,254.910868065,17.4584702987,-29.5331076857,104.528603606,49.2847187536,16.389675152,-73.3344058246,-45.3509030873,-1.11788519636,-20.9170449688,-25.0859970702,47.7930827738,-25.3336214765,23.5145501947,2.08070066878,29.6938088464,-5.80987053381,-1.2343272375,-35.0004683511,-0.872610863769,-4.30206438702,1.52197455686,-3.51921998055,-4.28257993428,3.27258403395,2.95353350324,-0.286629992103,-0.448436032658,7.94285764888,-4.052423362,-4.25275073028,-3.82402035886,-2.84506971754,-10.1069651529,2.89480221985,0.520476249571,-2.24488036951,-0.80875032742,-1.49635176414,0.473155372225,-2.74767602022,0.937818455257,-1.07821458148,3.89914171348,1.87200525872,-0.753230948936,-1.3121188018,-1.21768245234,-2.30498581181,-2.2584032721,-0.911823662124,-0.191557072028,-1.72313788038,0.891481360172,0.645121340951,-0.468142307588,-0.607474594623,-0.0478038299379,-0.886452738152,-0.584635113746,1.09372004498,-0.324999276354,0.212058317387,-0.343838969171,-0.263601610173,-0.458218745944,0.108142137191,-0.145436984416,0.0217190096552,-0.0847324701218,0.152662329328,0.00587304718316,0.105726022971,0.0510017611671,0.0791667055014,-0.0410531602871,-0.0346762619847,-0.143219754454,-0.0528292402233,0.276615614773,0.101703104871,-0.104263721371,0.0270010128472,0.0110259523469,-0.0911681276244,-0.108540469561,-0.13671594597,0.0518805809521,-0.150403745189,0.0542898440215,0.010236141134,-0.0339349156176,0.00935081313658,-0.0209320974952,-0.0211595063281],[-30672.0928804,1054.38631982,1436.34375118,-3612.36866577,338.077605433,854.121285349,-339.897424725,2507.06735197,677.398619981,1071.95307555,-681.60722891,-242.378190296,326.985982217,205.03441836,469.363934653,-432.830270219,503.916360125,-374.964535884,-27.5706068227,229.845652987,30.5265161356,-132.672667874,158.105137496,-273.432978166,17.5135446384,251.692059101,20.1144897156,-30.0249283313,107.524586001,47.0124159103,16.8606223801,-73.636658781,-46.0839498019,-0.125421848239,-19.9687760356,-25.0274711869,46.8839064576,-24.7608685826,23.1701502692,1.85392767162,28.9667993512,-6.22035018365,-0.470909073774,-35.126549733,-0.0939291262603,-4.03522127617,1.60299806739,-4.09848336431,-4.17725963495,3.06671195008,3.05496200171,-0.328270142032,-0.527348329968,7.67335832724,-4.2016462525,-4.05085166643,-3.95595851342,-2.70442912327,-10.1805375105,2.89585570664,0.382064474851,-2.31740515016,-0.776994494792,-1.50300170032,0.443998742507,-2.82578449991,0.95053980668,-1.1060212185,3.87182409031,1.81720413747,-0.751291483932,-1.31922471169,-1.21063428736,-2.33240941391,-2.26845680429,-0.947472838869,-0.20275382974,-1.73287711818,0.885318134822,0.653761130614,-0.477650394076,-0.615923906164,-0.0647012423646,-0.892883935025,-0.589124773064,1.08327664723,-0.338668026505,0.201717872568,-0.351219246754,-0.263305193188,-0.473865873701,0.101488391186,-0.155476408282,0.0198788008782,-0.0826577552676,0.153764812848,0.0147495241274,0.107448346682,0.0489344606208,0.0779358328433,-0.0410687504312,-0.0391120563718,-0.143447358105,-0.0509968056567,0.274474217648,0.100867876826,-0.110277853466,0.0263788561447,0.00797077176943,-0.0957502325504,-0.110201921094,-0.141290876699,0.0537194478765,-0.151586858012,0.0557020476259,0.0128481892104,-0.034461941178,0.00904263660126,-0.0200913546621,-0.022073208663],[-30584.7655158,1054.35614663,1418.53079828,-3584.98725132,308.495380898,865.317160653,-356.294363279,2495.84135013,678.487085185,1066.07497971,-712.080212922,-238.848027991,333.238433739,199.626674291,474.428914109,-436.260679493,493.475424968,-373.609855045,-34.1369934325,234.903538198,28.093016614,-129.510507718,155.084336328,-274.000190885,19.2843000635,248.248592277,22.7724516914,-30.5980317334,110.481276967,44.6790217993,17.2780765861,-73.9470278425,-46.9088566676,0.86468040634,-18.927486429,-24.9284201345,45.9174487936,-24.1231972593,22.7859472118,1.64118274706,28.1964825241,-6.65477658794,0.327019324697,-35.2532229767,0.69645741321,-3.73516872778,1.72203974092,-4.69362350212,-4.07226065479,2.86019955216,3.14395371335,-0.374781606236,-0.619692304305,7.40117848592,-4.35034765074,-3.83634083719,-4.08014350546,-2.55518577744,-10.2396279896,2.90061493529,0.238611340934,-2.39665702394,-0.742870616991,-1.5054590406,0.414577997568,-2.90168961144,0.956982269912,-1.13534555791,3.84025629707,1.7611648548,-0.747104066763,-1.32729225712,-1.20176069293,-2.36006062322,-2.27534239259,-0.985173486978,-0.213993513143,-1.74078940418,0.878343746579,0.661560404874,-0.48554664854,-0.623530988154,-0.0829392380505,-0.898947714855,-0.593036807224,1.0724600513,-0.352707363493,0.190626915409,-0.358358531754,-0.262139032418,-0.489303104569,0.0950057718923,-0.165411941989,0.0181287086281,-0.0804302041383,0.154717345945,0.0239838550578,0.109115551714,0.047250354197,0.0765629354104,-0.0407783652748,-0.043629675659,-0.143749120571,-0.049336478561,0.272154801261,0.0996457915587,-0.116363293835,0.0256427415402,0.00520516427258,-0.100219593766,-0.112038686193,-0.145794865674,0.0555152210495,-0.152484643537,0.0570432979582,0.0155143064846,-0.0348965352333,0.00865488214659,-0.0192125708489,-0.0230144917982],[-30502.9890109,1050.00816801,1401.15995135,-3556.17642656,280.997030195,877.580179062,-372.512795856,2484.75154911,678.233479738,1059.27294604,-743.310970865,-234.721240556,339.344430989,194.618470434,478.693370614,-439.404526055,482.919647569,-372.432777084,-40.6535297684,240.33595633,26.0372611555,-126.372853306,151.695086747,-274.298881131,20.8982163565,244.582218183,25.4100838844,-31.2647343891,113.382043583,42.3013506202,17.6420530658,-74.2540775191,-47.7975217179,1.86561847063,-17.792431588,-24.7959636236,44.899511364,-23.4296909115,22.361591373,1.44321473292,27.387470109,-7.10972912888,1.15657006918,-35.3718311553,1.49900666987,-3.40289460687,1.87602740376,-5.3070834783,-3.96688350666,2.65256246638,3.22091566282,-0.424960778161,-0.724590768454,7.12606724547,-4.4985756345,-3.60836552981,-4.19606432075,-2.39720923839,-10.2837897496,2.90910656863,0.0890912222278,-2.48195765616,-0.706791653394,-1.50369041411,0.384742941191,-2.97574869091,0.957895929711,-1.16586048805,3.80432035383,1.7033397836,-0.740311442605,-1.33556224899,-1.19112511146,-2.38748766028,-2.27907332355,-1.02484157142,-0.22561238671,-1.74680917867,0.870450958633,0.668765398539,-0.491868452868,-0.630372324073,-0.102448498843,-0.904622229584,-0.596468041886,1.06115823649,-0.367107064271,0.178871757046,-0.365089224311,-0.260138571918,-0.504465117611,0.0886069064268,-0.175312038349,0.0164394884117,-0.0780494974206,0.155545428059,0.0336485640683,0.110825480708,0.045861315508,0.0750816637039,-0.0402082041362,-0.0482339627175,-0.144143714383,-0.0478367721283,0.269635246937,0.0980265289919,-0.122470892049,0.024823327334,0.00273440215494,-0.104539803139,-0.114014488997,-0.15021602184,0.0572781770258,-0.153073263968,0.0583138640414,0.0182688379047,-0.0352141823408,0.00818718493119,-0.0182980781665,-0.023984616048],[-30425.9089981,1041.13860088,1385.76038262,-3525.91152733,255.446000191,891.293720249,-388.53006027,2473.37494374,676.676258695,1051.45000126,-775.109694872,-230.112570076,345.261325388,189.83930711,482.003601295,-442.382854857,472.262071304,-371.472072908,-47.2148930719,246.031796825,24.3287563639,-123.310811689,147.931046988,-274.291744016,22.3378787065,240.694687413,28.0051139529,-32.0373527959,116.21025293,39.8962165726,17.9525671153,-74.5463723205,-48.7218429868,2.8905892479,-16.5628669518,-24.6372213651,43.8358957507,-22.6894329443,21.8967331035,1.26077246701,26.5443738501,-7.58178718867,2.01485527094,-35.4737173419,2.31417655896,-3.03938677848,2.06188888226,-5.94130637713,-3.86042870344,2.44331631888,3.2862548748,-0.477604051253,-0.841166535201,6.84777372645,-4.64637828157,-3.36607303152,-4.30320994506,-2.23036906446,-10.3125759502,2.92135726947,-0.0675215068597,-2.57262871215,-0.66917056338,-1.49766244997,0.354343377157,-3.04831907443,0.954030870836,-1.19723889725,3.76389828067,1.64318129671,-0.730556356637,-1.3432754982,-1.17879098538,-2.41423874562,-2.27966288373,-1.06639305715,-0.237946714915,-1.75087088192,0.861532534171,0.675622346412,-0.496653188944,-0.636524397401,-0.123159706591,-0.909885631156,-0.599515302708,1.04925918211,-0.381856905792,0.166538708614,-0.371243724569,-0.257339255743,-0.519286591887,0.0822044219056,-0.185245150171,0.0147818957362,-0.075515315801,0.156274558629,0.043816175253,0.112675976301,0.0446792181661,0.073525668225,-0.0393844663335,-0.0529297604185,-0.144649812073,-0.0464861995503,0.266893436007,0.0959997690474,-0.128551497682,0.0239512718261,0.000563757715182,-0.108674452534,-0.116093053644,-0.154542454143,0.0590185923597,-0.153328881506,0.0595140148981,0.0211461284183,-0.0353903670576,0.00763918011366,-0.0173502087258,-0.0249848417271],[-30352.6711095,1027.54366214,1373.86126433,-3494.1678895,231.705737749,906.841163887,-404.323494339,2461.28852885,673.853877113,1042.50917212,-807.286577073,-225.136758638,350.946468357,185.11868464,484.205903277,-445.316710853,461.515739549,-370.766513424,-53.9157605845,251.87994913,22.9370088429,-120.37548992,143.785875289,-273.941474656,23.5858723025,236.587750558,30.5352695552,-32.9282034508,118.949272086,37.480433856,18.2096340305,-74.8124767567,-49.653718508,3.95278964141,-15.2380479593,-24.4593130697,42.7324035358,-21.9115067624,21.3910227539,1.09460478712,25.6718054912,-8.06753014951,2.89898704126,-35.5502246097,3.1424249957,-2.64563310762,2.27655200275,-6.59873528292,-3.75219675799,2.23197673585,3.34037837395,-0.531507818957,-0.968542417331,6.56604704942,-4.79380366974,-3.1086106296,-4.40106936416,-2.054534814,-10.325539751,2.93739370061,-0.23225247192,-2.66799185723,-0.630420306326,-1.48734177732,0.323229109248,-3.1197580981,0.946137178046,-1.22915367384,3.71887209764,1.58014176701,-0.717481554036,-1.34967281565,-1.16482175711,-2.4398620998,-2.27712435969,-1.10974390914,-0.251332762229,-1.75290895422,0.851481236378,0.682377483301,-0.499938238656,-0.642063691616,-0.145003543142,-0.914716071512,-0.60227541535,1.03665086744,-0.396946665009,0.15371408125,-0.376654432669,-0.253776527949,-0.533702206461,0.0757109454448,-0.195279730265,0.0131266861083,-0.0728273399662,0.156930237093,0.0545592127057,0.114764881134,0.0436159357837,0.0719285994748,-0.0383333511848,-0.0577219116331,-0.145286086171,-0.0452732740189,0.263907249797,0.0935551916471,-0.134555960304,0.0230572333166,-0.00130149674806,-0.112587133818,-0.118238104271,-0.158762271529,0.060746743606,-0.153227658354,0.0606440195513,0.0241805229734,-0.0354005739408,0.0070105028526,-0.0163712946377,-0.0260164291497],[-30282.5213818,1009.19552205,1366.47606403,-3460.9544538,209.646537319,924.39133821,-419.895605057,2448.14650879,669.831709186,1032.39438198,-839.662715123,-219.885147619,356.365560284,180.301894803,485.180200725,-448.307287472,450.70174859,-370.349865607,-60.8310092732,257.772793823,21.8239297721,-117.614809317,139.256743398,-273.214967287,24.6300215168,232.269663629,32.9822922916,-33.9464978518,121.583353179,35.0674792693,18.4116568417,-75.0429167774,-50.5674900484,5.06387180599,-13.8182954742,-24.2693133605,41.5959707353,-21.1046413041,20.8442882092,0.944971462008,24.7734529299,-8.56323490839,3.80557837256,-35.5943870436,3.98452955291,-2.22279211389,2.51607857969,-7.28146663291,-3.64192645336,2.01821460894,3.38386706449,-0.585920056783,-1.10567105235,6.28073956483,-4.94070442863,-2.83561080805,-4.48964474048,-1.86958529884,-10.3225159849,2.95693654876,-0.406046475277,-2.76727521873,-0.590698838848,-1.47285311313,0.291251179762,-3.1903863181,0.934924487742,-1.26125850269,3.66921354853,1.51384323669,-0.700899487802,-1.35413080742,-1.14925319964,-2.463927566,-2.27155893071,-1.15481344824,-0.26599896264,-1.75282880742,0.840188394472,0.68925057187,-0.501793663606,-0.647072469223,-0.167905614582,-0.919114706439,-0.604832165323,1.02325160405,-0.412344149457,0.140462119046,-0.381163088931,-0.249507285939,-0.547658804319,0.0690269243234,-0.20547544911,0.0114588921605,-0.069985198915,0.157527037553,0.0659319885866,0.117163502144,0.0425865262901,0.0703262181301,-0.0370868438156,-0.0626097550779,-0.146071194148,-0.0441810562781,0.260657271331,0.0906962627253,-0.14045400924,0.0221730476509,-0.00286937800334,-0.11624994029,-0.120417435615,-0.162863598119,0.0624765492694,-0.152759718771,0.0617045558608,0.0274018812943,-0.0352279650714,0.0063011458457,-0.0153623736284,-0.0270781182274],[-30215.1074701,986.770164217,1362.55543053,-3426.41458054,189.166083681,943.254865685,-435.349576141,2433.91192601,664.78280566,1021.2131407,-872.102828763,-214.355475555,361.517697424,175.297395227,484.940925946,-451.376372051,439.873406359,-370.235880704,-67.9563150088,263.616676025,20.9210486356,-115.063948262,134.354877116,-272.095912631,25.4791074546,227.774704308,35.3439795297,-35.0890274982,124.100288536,32.6574800086,18.5505895164,-75.236064092,-51.4472743072,6.22930890277,-12.3081920587,-24.0741165092,40.4380711014,-20.2761476411,20.2570674934,0.810175984121,23.849308677,-9.06396842136,4.72924578197,-35.606002776,4.84254643379,-1.77270493514,2.77306638003,-7.99021027606,-3.53110965317,1.80232189184,3.41799736884,-0.641895068501,-1.25082437661,5.99211654264,-5.08615139523,-2.548646838,-4.57099094314,-1.67543634485,-10.3044661789,2.97848259608,-0.589525026182,-2.8693327719,-0.549144106517,-1.4549535259,0.258265585073,-3.2603771709,0.920940642894,-1.29313025489,3.61525327195,1.44458642518,-0.681301442218,-1.3565692604,-1.13201040818,-2.48609147797,-2.26341934705,-1.20153441879,-0.281742428192,-1.7504197396,0.827539601777,0.696355486236,-0.502420244259,-0.651656108818,-0.191771223955,-0.923174707088,-0.60721717754,1.00910103247,-0.427929289005,0.126758797929,-0.384648794383,-0.24467424052,-0.561151884154,0.0620040864716,-0.215856847854,0.00982065502589,-0.0669883148945,0.158035832757,0.0779159673205,0.119837003455,0.0415187848826,0.0687627255711,-0.0357000725808,-0.0675706128512,-0.14702373323,-0.04317079728,0.257134890405,0.0874815922661,-0.146290892826,0.0213352608543,-0.00420105908814,-0.119668970984,-0.122615124817,-0.166834618742,0.0642364956565,-0.151971035236,0.0626979370341,0.0308221222105,-0.0348864126258,0.00551253194701,-0.0143193058851,-0.028158567259],[-30150.1774337,961.119525612,1360.53430796,-3390.7252349,170.168909203,962.527817342,-450.813760485,2418.62503245,658.907136415,1009.11385477,-904.482543255,-208.522080275,366.410324999,170.029434997,483.536138285,-454.525900402,429.092073697,-370.43330603,-75.2675533877,269.321431991,20.1522994935,-112.754899404,129.095015756,-270.572200533,26.1471504045,223.143655696,37.6221425792,-36.3494788901,126.488755531,30.2472258694,18.6167737565,-75.3922518498,-52.2796317168,7.45302934446,-10.7133856997,-23.8805716997,39.2713128205,-19.432982378,19.6300761647,0.68803277685,22.8984413971,-9.5644951593,5.6641066678,-35.5865609511,5.71885149911,-1.29738336378,3.03924715887,-8.72532941429,-3.42167649123,1.5847458037,3.44421958898,-0.700938739946,-1.40210415121,5.70054648271,-5.22901995839,-2.24977718733,-4.64767601793,-1.47201303139,-10.2726335331,3.00022264865,-0.783228810618,-2.97292495403,-0.504639052143,-1.43455817197,0.224129560072,-3.32986731305,0.904693038118,-1.32432659805,3.55741163025,1.37284172127,-0.659348409391,-1.35704375665,-1.11299080849,-2.50603179212,-2.25324625169,-1.24984292103,-0.298252440442,-1.74544202044,0.81341901765,0.703779628373,-0.5020514408,-0.655925768019,-0.216500598543,-0.927012248456,-0.609449036767,0.994269125498,-0.443560044103,0.112558026781,-0.386999990232,-0.239441555846,-0.574189108583,0.0544819799819,-0.226439685315,0.00826839296302,-0.063836058464,0.158416570119,0.0904744013985,0.122724013491,0.0403436910755,0.0672844333535,-0.0342339516426,-0.0725763028969,-0.148162285583,-0.0421982955284,0.253334198513,0.0839835762655,-0.152130739152,0.0205815964975,-0.00537100210715,-0.122858826366,-0.124819319615,-0.1706635334,0.0660587110242,-0.150921542286,0.0636268851161,0.0344486793281,-0.0343974663042,0.00464644154965,-0.0132366572102,-0.0292439141403],[-30087.4793323,933.095543195,1358.84764042,-3354.06338207,152.559546251,981.306264209,-466.416510986,2402.32608006,652.404671336,996.244930671,-936.677483861,-202.359299607,371.05088823,164.422263198,481.013897086,-457.75780834,418.419111447,-370.950888902,-82.7406000064,274.796897976,19.4416164058,-110.71965539,123.491898632,-268.631720839,26.6481706549,218.417300893,39.8185927497,-37.7215385274,128.73743154,27.8335066472,18.600551264,-75.5118132001,-53.0511227095,8.73896154374,-9.03952438377,-23.6955281158,38.1083040788,-18.5821021199,18.9640297816,0.576356263586,21.9199197543,-10.059579593,6.60427842832,-35.5375507131,6.61582060966,-0.798839192248,3.30635267127,-9.4871872495,-3.31555710134,1.36593356371,3.4639840269,-0.76455695695,-1.55761213723,5.40639788491,-5.36818550695,-1.94106032392,-4.72226801061,-1.25924043783,-10.2282612478,3.02034751251,-0.987698514567,-3.07681220238,-0.456066618533,-1.41258220769,0.188700339648,-3.39899340109,0.886689068028,-1.35440519981,3.49610898576,1.2990795137,-0.635701381424,-1.35560987823,-1.09209182634,-2.52342646485,-2.24158028763,-1.2996750552,-0.315218280947,-1.73765591957,0.797710801445,0.711610400257,-0.500920713411,-0.659992604447,-0.24199396563,-0.930743505537,-0.611546327769,0.978825855941,-0.4590943752,0.0978137144847,-0.388105117683,-0.233973396073,-0.586778140225,0.0463001529472,-0.23723972031,0.0068585242304,-0.0605278001827,0.158629197051,0.103570543311,0.125763160674,0.0389922243833,0.065937653033,-0.0327493951632,-0.0775986431586,-0.149505433373,-0.0412193495274,0.249249287147,0.0802746107199,-0.158037676308,0.019949778151,-0.00645366916505,-0.125834106902,-0.127018167749,-0.174338542098,0.0679753236293,-0.149671174455,0.0644941221513,0.0382889862533,-0.0337826758066,0.00370465504675,-0.0121089934062,-0.0303202967671],[-30026.7612252,903.550153927,1355.93037204,-3316.60598723,136.242527192,998.686277313,-482.286180539,2385.0553208,645.475380304,982.754774891,-968.563275844,-195.841471379,375.446832339,158.400128918,477.422261693,-461.074031677,407.91588045,-371.797376635,-90.3513304612,279.952910235,18.7129334325,-108.99020887,117.560265055,-266.262363392,26.9961884943,213.636423001,41.9351413508,-39.1988929102,130.834993937,25.4131121373,18.4922637406,-75.5950812922,-53.7483077177,10.0910339133,-7.29225609785,-23.5258349416,36.9616530627,-17.7304634716,18.2596439023,0.472960867717,20.9128124131,-10.5439861934,7.54387846184,-35.4604612061,7.53582962621,-0.279084212949,3.56611467234,-10.2761469836,-3.21468161728,1.14633239104,3.47874098458,-0.83425560535,-1.71545009574,5.11003924909,-5.50252342973,-1.62455471566,-4.79733496699,-1.03704364352,-10.1725925232,3.03704799374,-1.20347482401,-3.17975495422,-0.402309748497,-1.38994078939,0.151835158694,-3.46789209156,0.867436127236,-1.38292372778,3.43176570082,1.22377019124,-0.611021350423,-1.35232320722,-1.06921088749,-2.53795345255,-2.22896209784,-1.35096692152,-0.332329231266,-1.72682170667,0.780299112516,0.719935203864,-0.499261522274,-0.663967775721,-0.268151552496,-0.934484653327,-0.613527635311,0.962841196592,-0.474390242748,0.0824797699234,-0.387852617942,-0.228433925356,-0.598926641696,0.0372981534603,-0.248272711656,0.00564746708653,-0.0570629106101,0.158633660964,0.11716764555,0.128893073426,0.0373953643203,0.0647686961654,-0.0313073173048,-0.0826094515802,-0.151071758767,-0.0401897577811,0.2448742478,0.0764270916254,-0.164075832381,0.0194775293853,-0.00752352236655,-0.128609413057,-0.129199816957,-0.177847844838,0.0700184617288,-0.148279866279,0.0653023701844,0.042350476592,-0.0330635908335,0.00268895283143,-0.0109308802755,-0.0313738530352],[-29967.8105116,873.135650901,1350.65446895,-3278.45708543,121.058286073,1013.99404216,-498.452551219,2366.83378801,638.330244631,968.7990987,-999.984866336,-188.918374566,379.624836435,151.913691938,472.827608313,-464.459628191,397.631462827,-372.968607765,-98.0598391788,284.713130563,17.9121303063,-107.584948381,111.317762973,-263.450196748,27.2093920815,208.838092375,43.9742760242,-40.7743276164,132.775040917,22.9877115564,18.2876473549,-75.6411835641,-54.357313619,11.5119898092,-5.48141954991,-23.3765325861,35.8418301075,-16.8844425524,17.5180542196,0.375569021246,19.8784277252,-11.0116865062,8.47817553738,-35.3570177392,8.4807886612,0.258931244908,3.81141334905,-11.0914042493,-3.12047431286,0.926594192779,3.48967508907,-0.911263311851,-1.87358220493,4.81194410803,-5.63089442628,-1.30202062208,-4.87517696078,-0.805294446981,-10.1066701848,3.04899852834,-1.43048281103,-3.28067867097,-0.342495262081,-1.36748017676,0.113468762175,-3.53670454382,0.847417463147,-1.40955233093,3.36480955756,1.14739192519,-0.58585649924,-1.34726903814,-1.04420328137,-2.54930790397,-2.21578233952,-1.40349262458,-0.349308309094,-1.71274957478,0.761090996614,0.728801455526,-0.497282547296,-0.6679286187,-0.294885912065,-0.938320809125,-0.615394919381,0.946366785543,-0.489327605489,0.066559643083,-0.386147133779,-0.222957451805,-0.610614246974,0.0273816643326,-0.25949047798,0.00469144416519,-0.0534392601656,0.158391816991,0.131214938911,0.132064604108,0.035491619085,0.0638128834987,-0.0299579878483,-0.0875896824703,-0.152871627169,-0.0390750861718,0.240213353187,0.0725065607725,-0.170295046821,0.0192077365562,-0.00864101110193,-0.131197210303,-0.131346599275,-0.181171333041,0.072214250409,-0.146804753028,0.066053810416,0.0466351507245,-0.032255602556,0.00160422842113,-0.00970036018327,-0.0323937875843],[-29910.5719489,841.705751731,1343.63998526,-3239.42899118,106.590863667,1027.47620214,-514.551121813,2347.60564057,631.224291352,954.5628325,-1030.66448994,-181.44155274,383.688515175,145.019254827,467.369580589,-467.832143515,387.565825807,-374.408785711,-105.763095907,289.056522915,17.0728694504,-106.467846029,104.793674866,-260.174004305,27.3226410568,204.044528391,45.9411897393,-42.4370245353,134.570853946,20.578491805,18.0040161417,-75.644424609,-54.8625330721,12.9998323605,-3.63361633276,-23.2454263589,34.7507541454,-16.048093539,16.7420769621,0.281535190624,18.8270327913,-11.4534803767,9.40704390679,-35.2298902813,9.45074483369,0.808502704979,4.039722616,-11.9274844025,-3.03233602194,0.708189627742,3.49690826774,-0.995699666651,-2.02942231139,4.51300612618,-5.75210043882,-0.974025469313,-4.95702217755,-0.563651523282,-10.0307355597,3.05680807219,-1.6661850921,-3.37916891069,-0.276725488285,-1.34577104269,0.0738459353658,-3.60558992834,0.827019734317,-1.43441108353,3.29569801731,1.07045401694,-0.560303773718,-1.34065151543,-1.01675575192,-2.55725373722,-2.20183172666,-1.45637828637,-0.366013476686,-1.69544941052,0.740085045078,0.738096629002,-0.495093347279,-0.671817187208,-0.322158899821,-0.942212859455,-0.617083640854,0.929380922062,-0.503874415337,0.0502549483617,-0.382958114219,-0.217558859351,-0.621708475472,0.0167209072512,-0.270589077148,0.00404589560111,-0.0496487187095,0.157873151141,0.145605567414,0.135277500822,0.033249611613,0.0630615725496,-0.0287090990497,-0.0925568355977,-0.154882536943,-0.0378799700955,0.235311600911,0.0685511431274,-0.176688004508,0.0192039371599,-0.00981053390399,-0.13360142412,-0.133417583927,-0.184255663794,0.0745648020746,-0.145291772898,0.0667484606705,0.0511232761281,-0.0313494680309,0.000467827830586,-0.00842938174516,-0.0333815720295],[-29855.029634,808.914530162,1335.94399711,-3199.26108883,92.3602024312,1039.60951513,-530.118820289,2327.29581876,624.423558931,940.23821148,-1060.29370314,-173.237990617,387.760717105,137.799530848,461.206139027,-471.092245246,377.706657897,-376.049205116,-113.342289223,292.975876786,16.2507589603,-105.589269806,98.0201918447,-256.410748173,27.3749629309,199.274237678,47.8417517975,-44.1752646347,136.240635307,18.2115192053,17.6640786025,-75.5979033088,-55.2479251807,14.5513796396,-1.77963876042,-23.1285127947,33.6882062577,-15.2248901229,15.934948493,0.188121850915,17.7711343997,-11.8593747252,10.3315091927,-35.0819849663,10.4452795144,1.36198715414,4.2496648197,-12.7777452298,-2.94916171837,0.492794042663,3.50029677303,-1.08740700082,-2.18024667879,4.21422400093,-5.8649287203,-0.640838475123,-5.04383083082,-0.311720266638,-9.94482959981,3.0615692111,-1.90742866977,-3.4749762556,-0.205346633344,-1.32531516341,0.0332889736142,-3.67471191841,0.806605452095,-1.45773254118,3.22489596117,0.993473550398,-0.534347310446,-1.33270449597,-0.986512906763,-2.56157206275,-2.18675098745,-1.50858803323,-0.382336432431,-1.67498102391,0.717302735641,0.747668212407,-0.492778700748,-0.675541714306,-0.34994469689,-0.946090633144,-0.618512635826,0.911843570711,-0.518020622499,0.0338168412607,-0.378271209853,-0.212223175882,-0.632048817962,0.00555223862176,-0.281200626833,0.00376606590428,-0.0456816559625,0.157049057141,0.160218653384,0.13854373561,0.0306454935239,0.0624951300271,-0.0275576987833,-0.0975375470959,-0.157073769693,-0.0366188123262,0.2302241698,0.0645921094508,-0.183233101684,0.0195348314775,-0.0110224765911,-0.135823844993,-0.135366024432,-0.187039185603,0.0770662259599,-0.143784064821,0.0673857979283,0.0557896870541,-0.0303297857858,-0.000699789801169,-0.00713337013951,-0.0343417447297],[-29801.167664,774.41605994,1328.62358062,-3157.69276276,77.8862448195,1050.87073901,-544.692574614,2305.82926284,618.19408583,926.017470826,-1088.5640624,-164.134672917,391.964290769,130.337233264,454.495244133,-474.140600982,368.041647603,-377.82116062,-120.678607705,296.46398167,15.5014069319,-104.899587709,91.0295050235,-252.137390459,27.4053852147,194.545726868,49.6818315003,-45.9773288818,137.802587285,15.9128600788,17.2905432386,-75.4947185455,-55.4974490487,16.1634497189,0.0497208531086,-23.0217884282,32.6539675257,-14.4183059953,15.0999051752,0.0925914771847,16.7232393384,-12.2193764717,11.2525970176,-34.916207928,11.4639740741,1.91174157925,4.43986230666,-13.6355445179,-2.86984637601,0.282082784274,3.4996968574,-1.18622764543,-2.32333157082,3.91659642965,-5.96816652365,-0.302728857285,-5.1365631341,-0.0491060712659,-9.84899325749,3.06437453089,-2.1510605466,-3.56785128791,-0.128704903494,-1.30661431516,-0.00787982773023,-3.74423418731,0.786537127826,-1.47974925948,3.15286827027,0.916967609492,-0.507971246013,-1.32366183666,-0.953119353501,-2.56204399101,-2.17018085009,-1.5590859915,-0.398168874723,-1.65140422497,0.692765546037,0.757363693857,-0.490423386232,-0.679010433057,-0.378217484396,-0.949883959021,-0.619600740395,0.893714696051,-0.531756177182,0.0174964772812,-0.37207207127,-0.206935429282,-0.641474765215,-0.00588798515002,-0.290957244711,0.0039071995847,-0.0415284416453,0.155890928721,0.174933319145,0.141875280512,0.0276554164375,0.0620939226401,-0.0265008349238,-0.102558453099,-0.159414607022,-0.0353060156383,0.225006238681,0.0606607305032,-0.189908734589,0.0202691197904,-0.0122672249817,-0.137866263408,-0.13714517431,-0.189460246971,0.0797146312991,-0.142324767729,0.0679652991696,0.0606092177541,-0.0291811543484,-0.00187816533509,-0.00582775054468,-0.0352788440441],[-29748.9701359,737.86441481,1322.73581191,-3114.46339732,62.6889332873,1061.73663163,-557.809312754,2283.1309131,612.801910514,912.092845726,-1115.16712421,-153.958584357,396.42208471,122.71507534,447.394856412,-476.87787832,358.558483433,-379.655946863,-127.65323993,299.513627063,14.8804214609,-104.349167731,83.8538055147,-247.330893274,27.4529354186,189.87750259,51.4672981492,-47.8314982441,139.274912165,13.7085807476,16.9061185515,-75.3279692009,-55.59506378,17.8328606709,1.8236701938,-22.9212497941,31.6478190305,-13.6318148475,14.2401833718,-0.00779345550376,15.6958543956,-12.5234925366,12.1713330042,-34.7354653002,12.5064098834,2.45012296719,4.60893742338,-14.4942400534,-2.79328496871,0.0777311993113,3.49496477328,-1.29200393155,-2.45595325115,3.62112210971,-6.06060110179,0.040034166431,-5.23617930091,0.224585668618,-9.74326748489,3.06631661741,-2.39392772517,-3.65754458983,-0.0471465049723,-1.29017027416,-0.0493381733183,-3.81432040833,0.767177272859,-1.50069379403,3.08007982572,0.841453278138,-0.481159717008,-1.3137573944,-0.916219699739,-2.55845063246,-2.15176204277,-1.60683628752,-0.413402501954,-1.6247788237,0.666494954,0.767030561468,-0.488112182254,-0.682131576524,-0.406951443465,-0.953522665912,-0.620266790657,0.874954262645,-0.545071029593,0.00154501192454,-0.36434634906,-0.20168064744,-0.649825808003,-0.0173634076584,-0.299491048457,0.00452454115237,-0.0371794454784,0.15437015961,0.189628687022,0.145284107569,0.0242555319734,0.0618383170977,-0.0255355553457,-0.10764618974,-0.161874330533,-0.033955982806,0.219712986379,0.056788277045,-0.196693299464,0.0214755023797,-0.0135351648941,-0.139730469849,-0.138708287081,-0.191457196403,0.0825061273264,-0.140957020552,0.0684864413749,0.0655567024794,-0.0278881722466,-0.00304683963213,-0.00452794813899,-0.0361974083316],[-29698.4740879,699.05077597,1319.00811323,-3069.38278723,46.475139749,1072.57433891,-569.142540167,2259.22047329,608.446383636,898.6242922,-1139.82431628,-142.566657046,401.212894234,115.02099628,440.047809592,-479.214910031,349.257282979,-381.482072534,-134.160554301,302.122739162,14.4305499385,-103.886163899,76.5311290088,-241.980105482,27.5554470592,185.285344518,53.2002714938,-49.721836751,140.672499065,11.6260161552,16.5303962217,-75.0886531845,-55.5290790945,19.5555872495,3.51209980433,-22.8220256061,30.6703754033,-12.8689027119,13.3597990405,-0.114476075662,14.7005698979,-12.7649887667,13.088756105,-34.5429355106,13.5725115681,2.96994240687,4.75558496251,-15.3471525218,-2.71811859132,-0.118754895566,3.48594797478,-1.40399120981,-2.5758066789,3.32874692649,-6.14159595729,0.387125114387,-5.34361317149,0.509638594467,-9.62813476565,3.0682326962,-2.63322745804,-3.74389466009,0.0388318040437,-1.27635454885,-0.0907245357612,-3.88509231072,0.748885852129,-1.52066438306,3.00691643002,0.767181871825,-0.453858068308,-1.30332614233,-0.875483784091,-2.55069796806,-2.13118042838,-1.65088624062,-0.427958678066,-1.59524043326,0.638581228164,0.776512394281,-0.485945787301,-0.684837319741,-0.436094605951,-0.956944453947,-0.620461075054,0.85553697659,-0.557976715447,-0.0138253068426,-0.355157277761,-0.19642316911,-0.657001476162,-0.0286432060993,-0.306511591623,0.00565117872049,-0.0326334708599,0.152471754283,0.20420273888,0.148775232298,0.0204315528212,0.0617012746045,-0.024661830428,-0.112817192551,-0.164427267722,-0.0325766453012,0.21439050753,0.0529945692105,-0.203555439887,0.0231928951792,-0.0148118397833,-0.14142568265,-0.1400104203,-0.192985429087,0.0854308344758,-0.13971820793,0.0689563053615,0.0706065145983,-0.0264399858463,-0.00418753382736,-0.00325063721306,-0.0371044904006],[-29649.9283236,658.31475443,1316.84929125,-3022.54236865,29.6994539552,1083.31255883,-578.912072271,2234.49670115,605.060104604,885.642649601,-1162.37655129,-129.935612646,406.239301684,107.363839054,432.536430294,-481.103189572,340.187880182,-383.216902502,-140.147638518,304.309790972,14.143096939,-103.449874367,69.1228895069,-236.12142297,27.7459776753,180.774124491,54.8678730777,-51.6155406799,141.996984445,9.69757573206,16.1705006462,-74.7593645151,-55.3052071763,21.324230935,5.08763165419,-22.7157732936,29.725585474,-12.133104985,12.4658865179,-0.22372192611,13.7453103258,-12.9501667163,14.0059585928,-34.3428861618,14.6635767737,3.46582739535,4.87878950137,-16.1874542026,-2.64197282264,-0.306547803999,3.4724587227,-1.51909690908,-2.68226159478,3.04020551726,-6.21281959128,0.737993449482,-5.45969309295,0.805892490415,-9.50584370917,3.0699385518,-2.86755799786,-3.82709166345,0.12813105761,-1.26501757654,-0.131520459511,-3.95650384758,0.732012644937,-1.53922199525,2.93344757117,0.693341632325,-0.425856477941,-1.29310751852,-0.830682369198,-2.5391914608,-2.10830240857,-1.69061594216,-0.441877429214,-1.56322787925,0.609389800766,0.785637135045,-0.484088579699,-0.687155605637,-0.465490406625,-0.960118508458,-0.6202596914,0.835496510121,-0.5705711125,-0.0285578611911,-0.344878427708,-0.191044576525,-0.663141455779,-0.0395186920755,-0.312038171263,0.00723157481522,-0.0279230558978,0.150235160206,0.218628894748,0.152325844123,0.0162074359488,0.0616261343486,-0.0238913205676,-0.118047094662,-0.167067929653,-0.0311500493863,0.209048559993,0.0492536246281,-0.210424788798,0.0253410767318,-0.0160634236509,-0.142990831535,-0.141013847661,-0.19406852695,0.0884549179813,-0.138622697335,0.0694123872952,0.0757311839466,-0.0248439328663,-0.0052906901523,-0.00201748850653,-0.0380172008567],[-29603.6345876,616.133068651,1315.33849876,-2974.10398806,13.0033951154,1093.77037743,-587.474301975,2209.45311792,602.508985015,873.146478116,-1182.69461318,-116.072120212,411.359836163,99.8576725736,424.927918359,-482.504375577,331.412538069,-384.775015682,-145.574760103,306.098392204,13.9965063322,-102.977383321,61.6963455881,-229.803128383,28.0563908115,176.34598739,56.4534748928,-53.4755893698,143.246691597,7.95693753032,15.8304394011,-74.3205962389,-54.9335108254,23.1305498894,6.52357056956,-22.5932824648,28.8182316223,-11.4279694046,11.5663597353,-0.330502153244,12.8370836984,-13.0885868661,14.9240460704,-34.1398571506,15.7812464008,3.93285953172,4.97760806339,-17.0082802745,-2.56221936245,-0.484989359703,3.45430047949,-1.63364147778,-2.77510643496,2.75617970729,-6.27651675449,1.09203237075,-5.58522103913,1.11307617626,-9.37908445631,3.07099460847,-3.09586784728,-3.90741368118,0.219501737842,-1.25587952676,-0.171168256981,-4.02846702798,0.716904884172,-1.5557932819,2.85966365856,0.618855032982,-0.396906332222,-1.2839420773,-0.781611448705,-2.52446144418,-2.08303951968,-1.72548867649,-0.455228447101,-1.52925579043,0.579354894942,0.794228817434,-0.482720857733,-0.689138319112,-0.494956130989,-0.963021886076,-0.619770189856,0.814881277009,-0.582973684013,-0.0426349408263,-0.333960953183,-0.185405762788,-0.668445472004,-0.0497867107916,-0.316167520312,0.00918803556591,-0.0230891723774,0.147713435593,0.232899434195,0.155906175944,0.0116166993941,0.0615488300138,-0.023238608666,-0.123301328601,-0.16979587328,-0.0296517700213,0.203687817436,0.0455280102998,-0.217221226475,0.0278100412329,-0.0172512481351,-0.144472274079,-0.141682646896,-0.194747118603,0.0915385542763,-0.137679101946,0.0698997871788,0.080902779477,-0.0231118988641,-0.00634893111257,-0.000851421871321,-0.0389551647548],[-29559.8946248,572.982437097,1313.55488853,-2924.22949198,-2.97151756057,1103.76688071,-595.185622189,2184.58324483,600.658936468,861.134337931,-1200.64928588,-100.982848794,416.433026773,92.6165657481,417.28947363,-483.380126677,322.993519664,-386.070990992,-150.40218658,307.512152567,13.9692219878,-102.405774946,54.3187558313,-223.073504364,28.5185500126,172.003078098,57.9404489307,-55.26496216,144.419943814,6.43777960218,15.5142200625,-73.7528414024,-54.4240528419,24.9663022744,7.79322137662,-22.445342728,27.9530962279,-10.7570437083,10.669132624,-0.429787903459,11.9828980345,-13.1898096971,15.8441241406,-33.9383883736,16.92716135,4.36612041509,5.05109767203,-17.8027659158,-2.47622991055,-0.653421396393,3.43127670761,-1.74394536436,-2.85412963559,2.47735132188,-6.33493219769,1.44863507721,-5.72099898389,1.43091847182,-9.25054714794,3.07096129049,-3.31710550896,-3.98513879454,0.311694326852,-1.24866056904,-0.209110240582,-4.100893861,0.703909802725,-1.56980489432,2.78555510158,0.542644547139,-0.366759017466,-1.276670373,-0.728067016261,-2.50703825171,-2.05530329806,-1.75496772797,-0.468081423433,-1.49383879555,0.54891073383,0.802111475124,-0.482022919687,-0.690837345067,-0.524309064542,-0.965631643434,-0.619100120582,0.793739691025,-0.59530389325,-0.0560388354535,-0.322856008471,-0.179367621,-0.673113249987,-0.059244107452,-0.318996371702,0.0114428671019,-0.0181727920843,0.144959638655,0.247006636787,0.159486460662,0.00669286119484,0.0614052952838,-0.0227182776245,-0.128545326895,-0.172610655561,-0.0280573821665,0.198308953529,0.0417802932278,-0.223864633193,0.030489782878,-0.0183366448739,-0.145916367854,-0.141980895735,-0.195061832654,0.0946419197947,-0.136896034945,0.070463605015,0.0860933701419,-0.0212557693966,-0.0073548792138,0.000224642840651,-0.03993800715],[-29519.0101798,529.339578228,1310.57761336,-2873.08072689,-17.5837648632,1113.12115471,-602.40242582,2160.38060312,599.375870559,849.604789232,-1216.11135331,-84.6744674475,421.317402617,85.7545874886,409.688295951,-483.692101504,314.993087995,-387.019407348,-154.590185474,308.574681768,14.0396877757,-101.672133428,47.0573788153,-215.980833557,29.164318823,167.747541496,59.3121671833,-56.9466383897,145.515064389,5.17377999982,15.2258502064,-73.0365930518,-53.7868960259,26.8232462519,8.86988890156,-22.2627436916,27.1349616706,-10.1238756339,9.78211911528,-0.516550323151,11.1897613533,-13.2633956901,16.7672984062,-33.7430197272,18.1029625218,4.76069164456,5.09831535075,-18.564046305,-2.38137616671,-0.811185747786,3.4031908695,-1.84632901723,-2.91911963281,2.20440218627,-6.39031067163,1.80719476792,-5.86782890107,1.75914819687,-9.12292192492,3.06939902212,-3.53021948556,-4.0605450848,0.403459306758,-1.2430808729,-0.244788722728,-4.17369635571,0.693374633485,-1.58068348382,2.71111230961,0.463632648138,-0.335165919988,-1.27213295993,-0.669845065512,-2.48745221688,-2.02500528006,-1.77851638095,-0.480506049913,-1.45749152335,0.518491540567,0.809109141789,-0.482175063847,-0.692304568403,-0.553366492786,-0.967924837165,-0.618357033736,0.772120165941,-0.607681203474,-0.068751834778,-0.312014747853,-0.172791044265,-0.677344514879,-0.0676877272611,-0.320621458364,0.0139183755526,-0.0132148868037,0.142026827607,0.260942782095,0.163036931178,0.00146943938877,0.0611314638426,-0.0223449103444,-0.133744522073,-0.175511833449,-0.0263424607819,0.192912641939,0.0379730404142,-0.230274889232,0.0332702958624,-0.0192809455056,-0.147369470433,-0.141872671908,-0.195053297716,0.0977251909701,-0.13628210951,0.0711489408068,0.0912750248941,-0.0192874300212,-0.00830115696162,0.00118778577747,-0.0409853530972],[-29481.1807189,485.440930331,1305.70490206,-2820.87424074,-30.3735256522,1121.71882357,-609.351284774,2137.26951678,598.540865455,838.520476598,-1228.9871232,-67.1993713739,425.920454808,79.34493019,402.190327264,-483.423775358,307.448875869,-387.551112531,-158.113884112,309.304733029,14.1923904992,-100.729550865,39.9773027236,-208.573773445,30.0168159621,163.582096587,60.5537510618,-58.4923582438,146.527789674,4.19135046114,14.9714187523,-72.1551882963,-53.0304392834,28.6925697463,9.73260367294,-22.0371418835,26.3681135544,-9.53240194652,8.91250590068,-0.586096663368,10.4641959969,-13.3167300753,17.6936692641,-33.5575538517,19.308033595,5.11207696922,5.11907595314,-19.2858715227,-2.27555594579,-0.957730509398,3.36987195547,-1.93771594266,-2.97017591269,1.93819493096,-6.44455785806,2.16680343754,-6.02608289277,2.09737308431,-8.9985901282,3.06617815683,-3.73419072477,-4.13386085726,0.493513201487,-1.23878371191,-0.277649641846,-4.24672787893,0.685586567133,-1.58793351834,2.63635363067,0.381088903583,-0.301966057624,-1.27102246519,-0.606856386785,-2.46628529892,-1.99211404589,-1.7957770353,-0.49257014489,-1.42069945215,0.488464626642,0.815113103915,-0.483300393915,-0.693581202397,-0.581957520123,-0.969902323902,-0.617629434477,0.75010116633,-0.620218829444,-0.0807548542737,-0.301825308874,-0.165546970534,-0.681319696145,-0.0749387116283,-0.321145175465,0.0165483441527,-0.0082743754975,0.138959392843,0.27469653273,0.166538669691,-0.00401549989907,0.0606713293408,-0.0221295808868,-0.138859168685,-0.178501442083,-0.0244951011101,0.187500583003,0.0340732808392,-0.236377779338,0.0360529897559,-0.0200373553004,-0.148871661928,-0.141330954186,-0.194763678269,0.100750309083,-0.135839483823,0.0719888295407,0.0964252735776,-0.0172143331239,-0.00918097071607,0.00201726044233,-0.0421121745714],[-29446.1965938,440.561810989,1299.11128754,-2768.04538714,-41.6077710642,1129.71166399,-615.739486938,2115.3975209,598.095665595,827.700382177,-1239.32499837,-48.7928603769,430.345522496,73.297280183,394.856477922,-482.645890218,300.299995219,-387.66202979,-161.007849033,309.701633614,14.4359886952,-99.5951510065,33.1349341582,-200.90248087,31.0641808472,159.511758857,61.6573196542,-59.9089052901,147.44350825,3.48783746692,14.765339993,-71.1033404971,-52.1564259438,30.5631797319,10.3832990289,-21.7636615104,25.6548503807,-8.98811552151,8.06457071247,-0.635078593762,9.8107816008,-13.3484970802,18.6193162875,-33.3828443612,20.5327293608,5.41746873815,5.11622565338,-19.9644512583,-2.15877152288,-1.09292882395,3.33125106716,-2.01744187823,-3.00864216091,1.68031540725,-6.49822316279,2.52534826339,-6.19441357418,2.44471651926,-8.87869789926,3.06240876491,-3.92812995446,-4.20511531329,0.580436702231,-1.2351047758,-0.307153440424,-4.31960722851,0.680592625506,-1.59137073247,2.56140916728,0.295671258112,-0.267348974287,-1.27343980686,-0.53947095713,-2.44432595995,-1.95682635129,-1.80710855294,-0.504334033286,-1.38383145857,0.458929656961,0.820283659232,-0.485293235263,-0.694665773829,-0.609958526558,-0.971660160287,-0.616929647958,0.72788135998,-0.633004991898,-0.092023312489,-0.292423762117,-0.15754651716,-0.685142040517,-0.0809153867821,-0.320692567097,0.0193124645581,-0.00348196583281,0.135767053491,0.288242083482,0.170016155602,-0.00970569819461,0.0600011252978,-0.0220693279507,-0.14382880938,-0.181591429332,-0.022553479524,0.182078583735,0.0300658913959,-0.242122706132,0.0387849356256,-0.0205265740572,-0.150437912606,-0.140364325508,-0.194241282275,0.103686274799,-0.135544496062,0.072968046139,0.101543489602,-0.0150261984067,-0.00998986225487,0.00270101375881,-0.0433148312275],[-29413.745878,393.737257608,1291.19037876,-2715.08422113,-51.7351703053,1137.31799077,-621.144499192,2094.8429533,597.997181985,816.927572509,-1247.20890545,-29.7359604097,434.744906837,67.4804472825,387.746400375,-481.451004729,293.460927761,-387.364351237,-163.321506581,309.759854296,14.7851838342,-98.3020655136,26.5845093258,-193.017487509,32.2858080707,155.542117914,62.6167414677,-61.2118239424,148.245021758,3.05332118366,14.6241095647,-69.8786070779,-51.1649354424,32.4234129452,10.82963401,-21.438293699,24.9969738751,-8.49689826175,7.24186404314,-0.660483888636,9.23361212369,-13.3552056816,19.539313844,-33.2190076133,21.7651473886,5.6744814504,5.09336845581,-20.5966101036,-2.03155128814,-1.21676009596,3.28728483403,-2.08544561934,-3.03617311308,1.43253027166,-6.5515169226,2.88041521844,-6.37104368875,2.80018079994,-8.76408257964,3.05951084582,-4.11118034752,-4.27428787828,0.662776541998,-1.23130285833,-0.332764186963,-4.39189456004,0.678379788235,-1.59088867742,2.48643696057,0.208384750625,-0.231591845409,-1.27933797577,-0.468173550276,-2.4224142878,-1.91939599585,-1.81304891129,-0.515856166664,-1.34722726879,0.429919384781,0.824848358285,-0.487990718679,-0.695546137856,-0.637257710996,-0.973318202962,-0.616250954332,0.705689465484,-0.646121663072,-0.102531253741,-0.283883161427,-0.148710846343,-0.688895499041,-0.085560375156,-0.319394339586,0.0222019055303,0.00101368734689,0.132450860859,0.301550012181,0.17350471761,-0.0155403489365,0.0591051451997,-0.0221576813948,-0.148587808827,-0.184796221246,-0.0205682926791,0.176653477821,0.0259402109557,-0.247464976709,0.0414246199131,-0.0206611752073,-0.152076915269,-0.138990269853,-0.193535953571,0.106503853632,-0.135367029407,0.0740593005078,0.106634507268,-0.0127083124006,-0.0107239572101,0.0032291660056,-0.0445850296404],[-29383.5166446,344.002307593,1282.33578465,-2662.48079778,-61.2043925816,1144.75611874,-625.14378842,2075.68415183,598.202325631,805.985114135,-1252.72277106,-10.3096974257,439.270908992,61.7632413035,380.919747076,-479.931677539,286.846155209,-386.670268987,-165.104283098,309.473865853,15.2546773867,-96.8834260477,20.3802644328,-184.969325045,33.6610922245,151.678763363,63.4258850096,-62.416658614,148.915131839,2.87788177784,14.5642231036,-68.4785454627,-50.0560472145,34.2616061229,11.0792676568,-21.0570295757,24.3962857633,-8.06463207012,6.44793638516,-0.659300322292,8.7367815243,-13.3333648565,20.4487363009,-33.0661599656,22.9933852479,5.88072960505,5.05410836476,-21.1791726501,-1.89442363174,-1.32920372994,3.23792988558,-2.14166596141,-3.05442350481,1.19660618069,-6.6046494743,3.22959027563,-6.55419597995,3.16276822455,-8.65558151091,3.05890439905,-4.28248507686,-4.34135797765,0.739079453793,-1.22663675329,-0.353945949965,-4.46315002913,0.678935034948,-1.58638090441,2.41159505169,0.12023442002,-0.194971846425,-1.28866996279,-0.393448939953,-2.4013903703,-1.88007677917,-1.8141360878,-0.527194996591,-1.31122660901,0.401466563361,0.829034751614,-0.491229974951,-0.696210149633,-0.663743272344,-0.974996308571,-0.615586633751,0.683754201435,-0.659650815199,-0.112252722345,-0.276276560649,-0.138961120285,-0.692664022765,-0.0888162991834,-0.317381199257,0.0252078358304,0.00506392919813,0.129011866257,0.314590896662,0.177039684414,-0.0214586455636,0.0579676825327,-0.0223881710779,-0.153070531698,-0.188130243876,-0.0185902372309,0.171232098944,0.0216855783899,-0.252359898159,0.0439305290599,-0.0203537321817,-0.153797362723,-0.137226271198,-0.192697535988,0.109173811095,-0.135276967035,0.0752353025531,0.111703160876,-0.0102459616365,-0.011379381214,0.00359183746139,-0.045914476385],[-29355.1969669,290.39199835,1272.94111417,-2610.72517212,-70.4641070992,1152.24436271,-627.314821503,2057.99945433,598.668007542,794.656073596,-1255.95052182,9.20490262184,444.075830117,56.0144720608,374.436170477,-478.180467295,280.370159279,-385.591975153,-166.405604929,308.838139057,15.8591708232,-95.3723642702,14.576435686,-176.808525157,35.1694279009,147.927284812,64.0786187874,-63.5389537186,149.436640132,2.95159941597,14.6021762457,-66.9007130755,-48.8298406955,36.0660960019,11.1398590097,-20.6158602669,23.854587771,-7.69719884948,5.68633823103,-0.628515669036,8.32438376132,-13.2794835816,21.3426580258,-32.9244177758,24.2055405081,6.03382770116,5.00204938455,-21.7089634896,-1.74791694383,-1.43023913043,3.18314285126,-2.18604169985,-3.06504807168,0.974309790868,-6.65783115469,3.57045940794,-6.74209319123,3.53148109131,-8.55403203463,3.06200942408,-4.44118731537,-4.40630503679,0.807892170624,-1.22036525443,-0.370162797934,-4.53293379136,0.682245345273,-1.57774096467,2.33704148178,0.0322253051962,-0.157766152767,-1.30138875873,-0.315781899889,-2.38209429531,-1.83912250087,-1.81090805988,-0.53840897463,-1.27616920539,0.373603945957,0.833070389763,-0.494848134867,-0.696645664316,-0.689303409508,-0.976814333755,-0.614929966367,0.662304286422,-0.673674420516,-0.12116176262,-0.269677013627,-0.128218501187,-0.696531562734,-0.0906257812977,-0.314783852435,0.0283214242199,0.00852010487742,0.125451120992,0.327335314755,0.180656384713,-0.0273997815144,0.0565730307829,-0.0227543268586,-0.157211342663,-0.191607923273,-0.0166700098346,0.165821280788,0.0172913325698,-0.256762777575,0.0462611495075,-0.0195168184115,-0.155607947771,-0.135089813524,-0.191775873362,0.111666912702,-0.135244192127,0.0764687621811,0.116754284728,-0.00762443264523,-0.0119522598986,0.00377914840487,-0.0472948780362],[-29328.4399922,232.411636366,1263.38322277,-2560.30149717,-79.9227050906,1159.91309029,-627.32652281,2041.75707732,599.338039239,782.761654148,-1257.00784266,28.5367305407,449.20824686,50.1235715987,368.31643476,-476.281664968,273.950078275,-384.153269298,-167.264281369,307.851276224,16.6040148912,-93.8065771911,9.22142331821,-168.596750292,36.7938583376,144.287887863,64.5741771758,-64.5938403183,149.797962938,3.25658955249,14.7424805394,-65.1475485446,-47.4893258153,37.8228695812,11.0210008102,-20.1133234081,23.3715564873,-7.39984034016,4.95907493559,-0.567567107365,7.99730153609,-13.1933981984,22.217652705,-32.7938148358,25.3914689908,6.13260305697,4.94114897433,-22.1839120108,-1.59264530845,-1.51999269111,3.12304056767,-2.21939333593,-3.06942246111,0.766666121914,-6.71152184607,3.90086823671,-6.93273149542,3.90519851237,-8.4599865816,3.07029755245,-4.58662916864,-4.46915575661,0.868053835396,-1.21190912261,-0.381019448515,-4.60093020854,0.688145182084,-1.56489489961,2.26295686831,-0.0547604926062,-0.120285308582,-1.3173826894,-0.235503490137,-2.36521501344,-1.79675185865,-1.80395980779,-0.549554863764,-1.24241479715,0.346367293923,0.837118573219,-0.498718832259,-0.696824759089,-0.713826169742,-0.978896631299,-0.614260302259,0.641551604552,-0.688257817852,-0.129216746398,-0.26414586328,-0.116386940784,-0.700554199521,-0.0909447396904,-0.311741423019,0.0315398258467,0.0112767629581,0.121771347848,0.339749749198,0.184377414403,-0.0333147240222,0.054922191779,-0.0232340037291,-0.160957658561,-0.195225131895,-0.0148374178019,0.16043210973,0.0127591382188,-0.260640004752,0.0483800414874,-0.0180811505201,-0.157513954904,-0.13260570972,-0.190825958152,0.113956525641,-0.135253313163,0.0777330846497,0.121786048711,-0.00483800427147,-0.0124392481262,0.00378638466311,-0.0487152829429],[-29302.7591641,171.447604443,1253.97195195,-2511.67031783,-89.8274658947,1167.54088029,-625.213646652,2026.48475199,600.103834311,770.275605915,-1256.13745165,47.4543441837,454.301837815,44.0624608797,362.425751022,-474.286490837,267.513676866,-382.424380785,-167.676653524,306.528405826,17.4571574468,-92.2420232153,4.34028366848,-160.440185973,38.5320213545,140.739242093,64.93325802,-65.5947960686,150.009975193,3.74310879364,14.9417111811,-63.2410153154,-46.0492344833,39.5085149106,10.7400206028,-19.5581426699,22.9383679551,-7.17523763231,4.26197130323,-0.485689432572,7.74357252046,-13.0882545073,23.0762913007,-32.6740546748,26.548059527,6.18073426738,4.87677841251,-22.6063667917,-1.42956558513,-1.59917876242,3.05838069973,-2.24606819442,-3.06780596776,0.571733646406,-6.76717961272,4.21970097675,-7.12320078291,4.28230685567,-8.37285793946,3.08544694405,-4.71894847304,-4.53012593999,0.919573230616,-1.20133698698,-0.386683215927,-4.66732046732,0.695858941228,-1.54789871144,2.18961213403,-0.140332622783,-0.0829733328716,-1.33628142035,-0.152329916042,-2.35083692658,-1.7530431427,-1.79411432303,-0.560682672641,-1.21040317547,0.319804400987,0.841085602254,-0.502861713124,-0.696656399243,-0.737198993691,-0.981385538545,-0.613501271211,0.621640701971,-0.703399812424,-0.136313355575,-0.259697608817,-0.103301548933,-0.7046765318,-0.0897822755851,-0.308426705194,0.0348841414059,0.0134012656805,0.117981955497,0.351784302343,0.188174438164,-0.0392015354983,0.0530830007184,-0.0237423572159,-0.1643091049,-0.198903527823,-0.0130387110677,0.155092682924,0.00813996346855,-0.264002300306,0.0502710603917,-0.0160500178998,-0.159507035353,-0.12982808832,-0.189923377319,0.11602642381,-0.135347839829,0.0790044566244,0.126769965059,-0.00191692461448,-0.0128391176794,0.00362949425673,-0.0501541065503],[-29277.6330001,109.356554462,1245.00038975,-2465.28627695,-100.385390877,1174.81836431,-621.102404827,2011.60008822,600.843706863,757.209815737,-1253.61382519,65.7362181645,458.886557064,37.8236830956,356.590442091,-472.237897506,260.99137631,-380.487146427,-167.628445453,304.888787875,18.3771956231,-90.7392260963,-0.0477628978604,-152.456148488,40.3852034174,137.254633076,65.1819250331,-66.5548852738,150.089166497,4.35344903357,15.1444592796,-61.2079580378,-44.5272291034,41.0972703023,10.3161796331,-18.9615882318,22.5440730809,-7.02543165355,3.58930700067,-0.394566844143,7.54802312892,-12.9805256733,23.9226440938,-32.5647582563,27.6739591998,6.18311274647,4.81466243232,-22.9797812074,-1.25972032728,-1.66865868395,2.99008111949,-2.27129530596,-3.0601787981,0.386829200132,-6.82651206442,4.52610149129,-7.31036437347,4.66106930309,-8.29177398509,3.10918739083,-4.83848199761,-4.58947866534,0.962751548691,-1.18887944379,-0.387462063535,-4.73240996056,0.704458501797,-1.52684089254,2.11730077805,-0.224223672387,-0.046307613349,-1.35764995205,-0.0658236692678,-2.33889329937,-1.70803954135,-1.78225159995,-0.571840721328,-1.18059414456,0.293966068973,0.844813527086,-0.507332926503,-0.696033772094,-0.759309170352,-0.984427888974,-0.612562572936,0.602699290343,-0.719082576044,-0.142331599565,-0.256335038523,-0.0887802250249,-0.70881528777,-0.0871607859637,-0.305020910719,0.0383814579791,0.0150041787018,0.114094024087,0.363384981448,0.192006387872,-0.0450700521487,0.0511400011411,-0.0241788679787,-0.167278359354,-0.202546215547,-0.0111992502233,0.149835350216,0.0034971023027,-0.266871467554,0.0519231354021,-0.0134448531349,-0.161575432039,-0.126818406772,-0.189148866453,0.117862982782,-0.135586007113,0.0802597601228,0.131670881593,0.00109956591278,-0.0131511695707,0.00332959075473,-0.0515871060777],[-29252.5400179,47.995138306,1236.76162416,-2421.60401739,-111.803481403,1181.43617396,-615.119009133,1996.52069588,601.435970998,743.576170454,-1249.71143967,83.1608270972,462.49235869,31.3997814382,350.636830797,-470.178837579,254.313597865,-378.423403034,-167.105381213,302.951682381,19.3227265534,-89.3587095875,-3.92349601543,-144.761954127,42.3546909918,133.807346383,65.3462419276,-67.4871722379,150.052026446,5.02990216648,15.2953159433,-59.0752213617,-42.9409720797,42.5633740684,9.76873914655,-18.3349302734,22.1777227709,-6.95246333148,2.93536169466,-0.305883541565,7.39547977594,-12.8866848615,24.7607813656,-32.4655465437,28.7678150923,6.14462990831,4.76052576698,-23.3076086332,-1.0841520883,-1.72929379532,2.91905969899,-2.30030370118,-3.0465211586,0.209269618879,-6.89122681094,4.81921364354,-7.49108558686,5.03974903651,-8.21586259537,3.14324868475,-4.9455665114,-4.64747701107,0.997889982024,-1.17476708927,-0.383663954702,-4.7965040811,0.713015742883,-1.5018099353,2.04631629945,-0.306166228474,-0.0107655377288,-1.38105328502,0.0244527585178,-2.32931739648,-1.66178424289,-1.76925163287,-0.583077329891,-1.15344750861,0.268903099703,0.848144397931,-0.512188621436,-0.69485006496,-0.780043988716,-0.98817051607,-0.611353907145,0.584855081327,-0.735288280524,-0.147151487782,-0.254060940682,-0.0726408684502,-0.71288719563,-0.0831026678079,-0.301705251353,0.0420588626482,0.0161960676793,0.110118633763,0.374497793768,0.195832195403,-0.0509301101791,0.049177736587,-0.0244430166774,-0.169878099601,-0.206056299557,-0.00924439585986,0.144692461454,-0.00110615129505,-0.269269309815,0.0533251957008,-0.0102870888099,-0.163707387879,-0.12363812252,-0.18858316114,0.119452578129,-0.136026050003,0.0814758771621,0.136453646134,0.00417222689734,-0.013374704813,0.00290778772612,-0.0529900387443],[-29226.958735,-10.7799921441,1229.54874322,-2381.07818202,-124.288738838,1187.08494082,-607.389671367,1980.66418484,601.758940822,729.386556905,-1244.70477148,99.5066455955,464.649196776,24.7832990994,344.391239965,-468.152263661,247.410762789,-376.314987421,-166.093184863,300.736349358,20.2523473708,-88.1609974423,-7.26769531887,-137.47491918,44.4417705433,130.370667589,65.4522724165,-68.404721265,149.915044638,5.71476008653,15.3388722809,-56.8696499369,-41.3081258162,43.8810645212,9.11696038851,-17.6894389742,21.8283679316,-6.95837359371,2.29441505194,-0.231323724326,7.27076887601,-12.8232052367,25.5947733971,-32.3760405005,29.8282742878,6.07017716697,4.72009314972,-23.593302444,-0.903903421593,-1.78194543612,2.84623431026,-2.33832241073,-3.02681325573,0.0363717384377,-6.96303146207,5.09818129669,-7.66222774287,5.41660923781,-8.14425164718,3.18936061777,-5.04053878345,-4.70438405556,1.02528972302,-1.15923051966,-0.375596852791,-4.8599082218,0.720602543577,-1.47289433213,1.97695219732,-0.385892878098,0.023175506275,-1.40605641974,0.118936875649,-2.32204248258,-1.61432043564,-1.75599441612,-0.594440818397,-1.12942307183,0.244666295001,0.850920265007,-0.517484946964,-0.692998465158,-0.79929073778,-0.992760253314,-0.60978497355,0.568235786585,-0.751999097676,-0.150653029637,-0.252878103579,-0.0547013785992,-0.71680898358,-0.0776303180996,-0.298660938855,0.0459434424949,0.0170874982702,0.106066864673,0.385068746562,0.199610792634,-0.0567915457954,0.0472807505959,-0.024434283972,-0.172121003313,-0.209336884343,-0.00709950856843,0.139696366483,-0.00560650334102,-0.271217630409,0.0544661704696,-0.00659815750933,-0.165891145793,-0.12034869301,-0.188306996969,0.120781585425,-0.136726203487,0.0826296897599,0.141083106503,0.00726181792626,-0.0135090244188,0.00238519873988,-0.0543386617694],[-29200.1475938,-65.4381151702,1223.60060745,-2343.95450558,-137.910479508,1191.56014975,-598.125927486,1963.61921301,601.704366876,714.678040085,-1238.80684202,114.62543565,465.012585245,18.0018747372,337.732777645,-466.186629496,240.242452307,-374.213644641,-164.573705298,298.28194221,21.1278772362,-87.1895135543,-10.0658960211,-130.707142834,46.645738077,126.922989568,65.5216681449,-69.3096815333,149.697034672,6.35576883335,15.2286384886,-54.6150445509,-39.6492614898,45.0282193289,8.37899723488,-17.0351072825,21.4859537611,-7.04435983107,1.66210337175,-0.179053827839,7.15935002194,-12.8047520584,26.4275204734,-32.2947205226,30.8536691512,5.9647396686,4.69839164287,-23.8397029334,-0.72029060466,-1.82779025467,2.77204828844,-2.38981241566,-3.0009647151,-0.134118650201,-7.04295842416,5.36227683637,-7.82070429689,5.79003317818,-8.07601021679,3.24861041832,-5.12363156289,-4.76020004261,1.04535719228,-1.14254673229,-0.3636529243,-4.92282479161,0.726274444363,-1.44016320369,1.90952297518,-0.463046188106,0.0551321978156,-1.43212044042,0.217929175465,-2.31682980234,-1.56574867131,-1.74321942276,-0.605874938992,-1.10886911014,0.221331164473,0.852920136846,-0.523254268558,-0.690389708894,-0.816946333209,-0.99831282802,-0.607783223074,0.552953667058,-0.769119090779,-0.152770433646,-0.252769802747,-0.034819544134,-0.720473997955,-0.0707979051892,-0.296062662533,0.0500618333657,0.0177708375926,0.101953997212,0.395026210851,0.203293868266,-0.0626464853202,0.0455240769787,-0.0240665585214,-0.174016820277,-0.21230522772,-0.00471264384829,0.134872328594,-0.00994798880599,-0.272736621752,0.0553345832247,-0.00240701257902,-0.168104837432,-0.117003122456,-0.188389221086,0.12184460626,-0.137730004623,0.0836987945973,0.145522792305,0.0103249451722,-0.0135527106405,0.00178496432686,-0.0556066677948],[-29170.4847358,-115.75222971,1218.93916737,-2309.6430904,-152.187279578,1195.07669855,-587.880610085,1945.65863039,601.217745464,699.588397599,-1231.98485279,128.662108756,463.740277396,11.2235288749,330.751692761,-464.252393394,232.884887502,-372.050752716,-162.513290765,295.707187924,21.9240234208,-86.4192823774,-12.3226556483,-124.549855874,48.9579277554,123.463134412,65.5584324867,-70.1605417163,149.426106153,6.92249102841,14.9538011128,-52.3230305422,-37.9965853692,45.9972735832,7.56857408311,-16.376819222,21.1440026255,-7.20824528724,1.03948948333,-0.143169231224,7.04921551996,-12.8387589624,27.2572428951,-32.2155047357,31.8410731749,5.83367748761,4.69765762519,-24.0471980681,-0.535724811326,-1.8692661341,2.69504682101,-2.4561624988,-2.96860283892,-0.30273993523,-7.12933928995,5.6112867378,-7.9636292468,6.15888448596,-8.00997217801,3.3195150608,-5.19466151911,-4.81387387759,1.05891972309,-1.12517832886,-0.348561148261,-4.98504426382,0.729021631296,-1.40360818384,1.84442715426,-0.536908644525,0.0850974835173,-1.45829076615,0.321182091331,-2.31275252053,-1.51639895522,-1.73110404073,-0.616905172149,-1.09168778637,0.199072048861,0.853670855237,-0.529433817405,-0.687004727928,-0.832946197353,-1.00481954281,-0.60534711149,0.539059180803,-0.786239888977,-0.153654704726,-0.253641262718,-0.0130127108047,-0.723682057637,-0.0627866829018,-0.294059021892,0.0544388661672,0.0182656586093,0.097812112773,0.404228012714,0.206804138304,-0.0684162155426,0.0439447106297,-0.0233113609811,-0.175563588706,-0.214935200811,-0.00212263683124,0.130217264846,-0.0141039584786,-0.273840032664,0.0559173348193,0.00222730958969,-0.170286149386,-0.113620602132,-0.188851126875,0.122669146287,-0.139022198749,0.0846636470103,0.149730960288,0.0133016011506,-0.0135014706887,0.00113833286528,-0.0567594911527],[-29136.1282274,-161.821264866,1215.532146,-2277.34513069,-166.500030177,1197.95433826,-577.291875919,1927.22633499,600.258009325,684.280585205,-1224.14455028,141.834863786,461.115586369,4.65137750195,323.591019458,-462.305514808,225.443449424,-369.727597913,-159.874414344,293.150706879,22.6187152238,-85.8082285055,-14.047287305,-119.089071983,51.3676832804,119.995031515,65.5621567484,-70.9048753618,149.132692687,7.38994343862,14.5124657875,-50.0021893869,-36.3852124959,46.7843017318,6.69830796105,-15.7181815853,20.7969311827,-7.44700966912,0.428992848415,-0.114247549526,6.92899085461,-12.9308516792,28.0809909673,-32.131170698,32.7872451332,5.68244443045,4.71942980451,-24.2155627329,-0.352890939505,-1.90912626626,2.61330055859,-2.5379933934,-2.92928434854,-0.469601549639,-7.21983044874,5.84512599862,-8.08816672612,6.52214687882,-7.94491260407,3.3999489561,-5.25334130156,-4.86409163125,1.06690987697,-1.10763431216,-0.331134706842,-5.04625412781,0.727817951821,-1.36320153471,1.7820842602,-0.606672713172,0.113158376872,-1.48350889975,0.428311041618,-2.30871178194,-1.46665865611,-1.7196851367,-0.62695243042,-1.07766973506,0.178087996691,0.852636220283,-0.535937041128,-0.682842002907,-0.847235379237,-1.01224059415,-0.602492845779,0.526587335162,-0.802875012883,-0.1535110469,-0.255378195276,0.0106618863669,-0.726209599644,-0.0538096764312,-0.292792093991,0.0590989205706,0.018573335744,0.0936774929996,0.412514341999,0.21005707558,-0.0740043133685,0.0425701367142,-0.0221546200056,-0.176756418925,-0.217214828068,0.000608982442805,0.125721005743,-0.0180550921019,-0.274540001064,0.0562009204404,0.00723825184404,-0.172362656974,-0.110211870084,-0.189702119276,0.12329093718,-0.140572833275,0.0855054169987,0.153664548983,0.0161276249625,-0.0133502930138,0.000478579695193,-0.057760501598],[-29095.236135,-203.744149739,1213.3472664,-2246.26182067,-180.229622429,1200.51281995,-566.997881741,1908.76622484,598.7840912,668.917558664,-1215.191681,154.361899612,457.421825303,-1.51146339211,316.393791881,-460.301953187,218.023519124,-367.145466495,-156.61954912,290.751119456,23.1898819441,-85.3142765324,-15.2491040955,-114.410804844,53.864348354,116.52261027,65.5324322363,-71.4902560173,148.847227881,7.73314283088,13.9027381468,-47.6611025612,-34.8502579115,47.3853782224,5.78081589654,-15.0628011649,20.4391560903,-7.75763268362,-0.166967071264,-0.0828663977911,6.78730151045,-13.0866559388,28.8958149946,-32.0344959675,33.6889438002,5.5164943036,4.76524688869,-24.3445718129,-0.17447388711,-1.95012384297,2.52488015174,-2.63592583271,-2.88256596533,-0.634812926417,-7.31208828984,6.06370961646,-8.19148086838,6.8788040744,-7.87960656818,3.48778651509,-5.29938355972,-4.90953937436,1.0702602154,-1.09042368498,-0.312186782209,-5.10614187296,0.721637253382,-1.31891551844,1.72291381868,-0.671530859869,0.13940189137,-1.50671634401,0.538931444698,-2.30360873134,-1.41691514272,-1.70899957734,-0.63543762636,-1.06660559076,0.158578056487,0.849280032089,-0.542677387344,-0.677900014479,-0.859758927882,-1.0205361785,-0.599236632927,0.515573137471,-0.818537983107,-0.152544664186,-0.257866312201,0.0361470123589,-0.727833060995,-0.044079910971,-0.292403955884,0.0640663762473,0.0186952434204,0.0895864195337,0.41972538855,0.212968152923,-0.0793143557037,0.0414278403975,-0.0205822642494,-0.177590421258,-0.21913213394,0.00342068393394,0.121373381788,-0.0217820694191,-0.27484866487,0.0561718352753,0.0125592570313,-0.174261935519,-0.106787664354,-0.190951603232,0.123745710607,-0.142351955607,0.0862052745623,0.157280496922,0.0187388557088,-0.013094166066,-0.000161019843342,-0.0585730688854],[-29045.9665248,-241.619813432,1212.35225158,-2215.59435454,-192.756947461,1203.07189465,-557.636784306,1890.72219797,596.75492383,653.662273734,-1205.03199146,166.461415108,452.942307339,-7.06187781781,309.303044175,-458.197667984,210.730477652,-364.205644729,-152.711168173,288.647046035,23.6154528806,-84.8953510521,-15.9374191244,-110.601068141,56.437266678,113.049800073,65.4688502566,-71.8642572305,148.60014534,7.92710597213,13.1227238245,-45.3083515411,-33.4268366576,47.7965775029,4.82871491743,-14.4142847532,20.0650940064,-8.13709403762,-0.745970813971,-0.0396033910641,6.61277297204,-13.3117974717,29.6987652819,-31.9182581025,34.5429279503,5.34128091354,4.83664758558,-24.434000193,-0.00315855205613,-1.99501205607,2.42785625107,-2.75058054998,-2.82800441063,-0.798483498553,-7.40376920256,6.26695258896,-8.2707358071,7.22783979036,-7.81282914355,3.58090214867,-5.33250094304,-4.94890317767,1.06990329987,-1.07405545011,-0.29253055653,-5.16439498867,0.709453383427,-1.27072239715,1.66733535533,-0.730675550434,0.163915040505,-1.52685460176,0.652658718942,-2.29634451352,-1.36755578377,-1.69908422931,-0.641781672521,-1.05828598803,0.140741276776,0.843066090759,-0.549568303674,-0.672177243293,-0.870461892312,-1.0296664923,-0.595594679915,0.50605159507,-0.832742320262,-0.150960760604,-0.260991325275,0.0633854321495,-0.728328878709,-0.0338104117151,-0.293036684627,0.0693656128686,0.0186327560622,0.085575174018,0.425701342213,0.215452843164,-0.0842499194541,0.040545306845,-0.0185802223673,-0.178060706028,-0.220675142878,0.00625093760226,0.117164223483,-0.0252655701732,-0.274778162,0.0558165745112,0.0181237679988,-0.175911560341,-0.103358722986,-0.192608983685,0.124069198242,-0.144329613155,0.0867443897007,0.160535742637,0.0210711324906,-0.0127280782957,-0.00074719041027,-0.0591605627698],[-28987.1159292,-275.797270057,1212.38691903,-2184.70334171,-203.643105906,1205.87506337,-549.692923277,1873.37255576,594.127756446,638.637220101,-1193.60522819,178.335339106,447.912278625,-11.8484641145,302.458979251,-455.954578594,203.653504208,-360.831450315,-148.129099887,286.945591412,23.879915569,-84.5009764007,-16.1293866709,-107.721723243,59.0775976007,109.580721929,65.3717453252,-71.9847729548,148.416505104,7.95109420641,12.1784928621,-42.9526226615,-32.1466735664,48.0166851185,3.85300882567,-13.7742851654,19.670701739,-8.58168895516,-1.30600670071,0.024377417232,6.3956196647,-13.6089084945,30.4867432195,-31.7770836557,35.3464638319,5.16077572693,4.93447922775,-24.4841815147,0.159027716028,-2.04577487831,2.32075354843,-2.88231916406,-2.76512074273,-0.960738869616,-7.49262855812,6.45484733704,-8.32418037182,7.56844983301,-7.74378037459,3.67719569096,-5.35244519749,-4.9810821605,1.06668879091,-1.05887014311,-0.272808054246,-5.22065785363,0.690467332982,-1.21857502031,1.61563084811,-0.78341681613,0.186741895261,-1.54310542451,0.769062159763,-2.28607381309,-1.31893938292,-1.68992216835,-0.645495245117,-1.05250106826,0.124679919774,0.833560535013,-0.556516998022,-0.665661087506,-0.879299335158,-1.03958050802,-0.591564518233,0.498031515723,-0.8450594096,-0.148958944983,-0.264644217025,0.092298283889,-0.727543280586,-0.0232168206425,-0.294785329653,0.0750163591727,0.0183689509325,0.0816737448523,0.43031597176,0.21744906809,-0.0887346790798,0.0399414051486,-0.016144305563,-0.178159119888,-0.221839400581,0.00904143291953,0.113082133263,-0.028480390325,-0.274341675908,0.0551251015446,0.0238711056671,-0.177255961141,-0.099936140457,-0.194673016875,0.124297740589,-0.146479115353,0.087108056537,0.163394847667,0.0230723283567,-0.0122508865574,-0.00125236295685,-0.0594943053732],[-28920.0347431,-307.625873767,1212.77946408,-2153.58705224,-213.170036423,1208.86082694,-543.035369947,1856.33321298,590.853104245,623.803023155,-1180.9871379,190.120520291,442.374717343,-15.9266779366,295.990475078,-453.558444192,196.816970596,-357.034326704,-142.922593852,285.627798053,23.9939904912,-84.0470758831,-15.8735257135,-105.73802226,61.7837630553,106.120263296,65.2444247967,-71.8509787673,148.299872946,7.80134718639,11.1079729297,-40.6030216919,-31.0279326326,48.0553310061,2.85824851965,-13.1366393071,19.2580966973,-9.08497472877,-1.84669418347,0.115566220166,6.13241177684,-13.9686471699,31.2560545402,-31.6129951586,36.0988475902,4.97302085117,5.05682364659,-24.4976844449,0.312687760651,-2.10131940602,2.20391290081,-3.03046683622,-2.69329336772,-1.12176932549,-7.57681765545,6.62769597479,-8.35440217627,7.90067836335,-7.67336019046,3.77466866913,-5.35912445505,-5.0058276364,1.06113474518,-1.04453443062,-0.252976668903,-5.27440240387,0.6647886674,-1.16234858665,1.56753208415,-0.829534949997,0.207754756596,-1.55561155868,0.887526570752,-2.27296547397,-1.27131048356,-1.68128130636,-0.646448075012,-1.04903900028,0.110109102461,0.820738858042,-0.563405719427,-0.658294615317,-0.886266373488,-1.0501823021,-0.587068977389,0.491416908891,-0.855292094943,-0.146716445373,-0.268737052947,0.122720198416,-0.725601657557,-0.0125252468733,-0.297556829895,0.081019740165,0.0178137166518,0.0778869474656,0.433577361669,0.218984545306,-0.0927726992589,0.039600540108,-0.0133098552381,-0.177864454804,-0.22265053775,0.0117467374043,0.109110801282,-0.0313777907059,-0.273556572187,0.0541012526089,0.0297641032507,-0.178306985127,-0.0965324369885,-0.197099864236,0.124470113496,-0.148786819745,0.0872980656873,0.16585286558,0.0247384521468,-0.0116769213228,-0.00167179359965,-0.059577428287],[-28846.7118278,-338.705063726,1212.73017651,-2122.40317142,-221.799887175,1211.89143614,-537.379378518,1839.05448777,586.879798916,609.079842214,-1167.2874673,201.937537309,436.324534684,-19.4036892674,290.023578393,-451.000983895,190.229046773,-352.847748783,-137.158254956,284.643192841,23.9749563656,-83.4411725465,-15.2261964051,-104.591064988,64.5560006214,102.673503242,65.0909392348,-71.4723706507,148.248441072,7.47834914187,9.95705610506,-38.2687592606,-30.0853876418,47.9248562001,1.84737167184,-12.4932301063,18.8309364407,-9.63982416812,-2.36806049696,0.239866772431,5.8213084376,-14.378678147,32.0028560622,-31.4298641374,36.7998828448,4.7745760539,5.20107129825,-24.4776364074,0.459081973602,-2.15978351643,2.07812920645,-3.19408961331,-2.6118650286,-1.28178132263,-7.65458677536,6.7858780396,-8.36507353019,8.22478163101,-7.60289349151,3.87134803358,-5.35248594418,-5.02310396745,1.05367631837,-1.03054651207,-0.232822636319,-5.32505746474,0.632754095616,-1.10189888222,1.52263330288,-0.868927810516,0.226782982961,-1.5647559994,1.00739063254,-2.25744187988,-1.22488506399,-1.67287576435,-0.644599656726,-1.04768745979,0.0966471555097,0.804678891654,-0.570110477216,-0.650009812433,-0.891368137977,-1.06136472697,-0.582012211396,0.486085584459,-0.863301084756,-0.144404894636,-0.273187169284,0.154464179743,-0.722699191335,-0.00196441631284,-0.30121109666,0.0873722299175,0.0168586446797,0.0742133040444,0.435527175345,0.220109441376,-0.0963881422237,0.0394985004493,-0.0101220953435,-0.177152239069,-0.223141706334,0.0143246380868,0.105232689625,-0.0339031483647,-0.272441261965,0.0527523321469,0.0357714720375,-0.179093333886,-0.0931604892358,-0.199835038501,0.124625701643,-0.151242345899,0.0873203318909,0.167912472952,0.0260775466485,-0.011024381468,-0.00200644474651,-0.0594210154696],[-28769.1360442,-370.634279099,1211.43934609,-2091.30938449,-229.994806328,1214.82914177,-532.440203192,1820.98669826,582.156672148,594.387836595,-1152.61596312,213.906968806,429.756641839,-22.3866680904,284.684335929,-448.273916823,183.897902694,-348.305191437,-130.902688089,283.941302659,23.8400919107,-82.5907894379,-14.243758899,-104.221951226,67.3945478786,99.2455208376,64.9153392036,-70.858444588,148.260401687,6.98258430266,8.7716344657,-35.9590459958,-29.3338123794,47.637601735,0.823315954753,-11.8359404913,18.3928785286,-10.2391100829,-2.87013287592,0.403182828717,5.46046877618,-14.8266660749,32.723304604,-31.2315621185,37.4493732151,4.56200110271,5.36461263883,-24.4271648257,0.599470746674,-2.21930508678,1.94419736358,-3.37225354221,-2.52017846839,-1.44098131751,-7.72418619869,6.92977306885,-8.35986674335,8.54101588565,-7.53370517808,3.96526073473,-5.33247689337,-5.03287551575,1.04474866615,-1.01640458686,-0.212132192316,-5.3720518616,0.594700326564,-1.03708169306,1.48052874372,-0.90149325617,0.243655932808,-1.5709217418,1.12799302576,-2.23992541458,-1.17987910251,-1.66441966328,-0.639909484784,-1.04823412245,0.0839124095919,0.785458467658,-0.576507280712,-0.640738664562,-0.894609759301,-1.07302063508,-0.576298374266,0.481915352312,-0.868947087502,-0.14219592563,-0.277911902276,0.18734323188,-0.719031063636,0.00823694513341,-0.305608041257,0.0940703025026,0.0153953264762,0.0706513367748,0.436207076193,0.220873922861,-0.0996051702065,0.0396110748989,-0.00662624983018,-0.175998000979,-0.223346058282,0.0167329219973,0.101430260378,-0.0360018403506,-0.27101415637,0.0510856446014,0.0418619233153,-0.179643709005,-0.0898331738544,-0.202824052404,0.124803889711,-0.153835313385,0.087180769887,0.169576346358,0.027097654649,-0.010311465869,-0.00225727880533,-0.0590361508796],[-28689.2962533,-405.01295905,1208.10726262,-2060.46337673,-238.216942045,1217.53619459,-527.93309817,1801.58016258,576.632555628,579.647165616,-1137.08237209,226.149393429,422.665949999,-24.9827843887,280.098794423,-445.368962093,177.831708314,-343.440129555,-124.222498141,283.471654388,23.6066758449,-81.4034496044,-12.9825733483,-104.571780768,70.2996424063,95.8413951506,64.7216752669,-70.018696562,148.333946998,6.31453689856,7.59760008922,-33.6830925258,-28.7879806308,47.2059086453,-0.210980959139,-11.1566533901,17.9475805206,-10.8757052827,-3.35293855507,0.611418143718,5.04805192172,-15.3002756027,33.4135569838,-31.0219606279,38.0471223207,4.33185576521,5.54483812446,-24.3493971233,0.735114471658,-2.2780219943,1.80291227048,-3.56402466977,-2.41757643011,-1.59957576658,-7.78386620627,7.0597605999,-8.3424541255,8.84963737693,-7.46712015053,4.05443372298,-5.29904453109,-5.0351066434,1.03478694423,-1.00160685442,-0.190691572712,-5.41481441979,0.550964069178,-0.967752805243,1.44081264611,-0.927129145442,0.258202964587,-1.57449178101,1.24867243104,-2.2208384618,-1.13650857743,-1.65562712414,-0.632337053709,-1.05046666396,0.0715231953796,0.763155417859,-0.582472139241,-0.630413157413,-0.895996368135,-1.08504287887,-0.569831620014,0.478784022338,-0.872090811645,-0.140261171214,-0.282828588164,0.221170358838,-0.714792456171,0.0178501115601,-0.310607574995,0.101110431992,0.013315353501,0.0671995678433,0.435658727618,0.221328156323,-0.10244794544,0.0399140521831,-0.00286754264896,-0.174377268826,-0.223296745544,0.0189293761659,0.0976859756255,-0.0376192437124,-0.269293666529,0.0491084944149,0.0480041683719,-0.17998681207,-0.0865633675,-0.206012418676,0.125044062384,-0.156555341773,0.0868852944151,0.170847162374,0.027806818936,-0.00955637340166,-0.00242525818396,-0.0584339184755],[-28608.9571126,-442.900689651,1202.16310334,-2029.88922511,-246.739298229,1219.86889335,-523.694739979,1780.37602885,570.273010923,564.787236809,-1120.83817491,238.740542771,415.058438807,-27.2662542252,276.327703364,-442.273280213,172.034572953,-338.291398823,-117.186275668,283.176545873,23.2944021613,-79.8124315093,-11.4923231766,-105.569903662,73.2689919734,92.4631094453,64.5074092027,-68.9626952254,148.463483167,5.47582066935,6.47408856174,-31.4458034015,-28.4564046416,46.6404057145,-1.25286081601,-10.4491056509,17.4968975458,-11.5423104609,-3.81735270875,0.869086703757,4.58286938557,-15.7889696202,34.0702637708,-30.8042282735,38.5924158555,4.08099020181,5.73930067656,-24.2471796729,0.86683864717,-2.33470873603,1.65513773447,-3.76819124003,-2.30383774012,-1.75782052065,-7.83225299204,7.17648182642,-8.3160799771,9.15072890466,-7.40423456642,4.13707174565,-5.25241748119,-5.02973210118,1.02429750556,-0.985766947669,-0.1683657181,-5.45279253976,0.501856405227,-0.893854178058,1.4031323045,-0.945913622425,0.27038325094,-1.57577950417,1.3687678089,-2.2006052206,-1.09492883345,-1.64624732227,-0.621846302048,-1.05410747281,0.0591319916153,0.737851154199,-0.587877274522,-0.61899429457,-0.895529713322,-1.09730895049,-0.562515232567,0.476579836344,-0.872649160732,-0.138749119197,-0.287870204696,0.255773590079,-0.710158632775,0.0266853410013,-0.31608988787,0.108491388572,0.0105350811086,0.0638449290922,0.433925829024,0.221513102076,-0.104929535876,0.0403864040739,0.00110858078871,-0.172271494952,-0.22301983101,0.0208842801521,0.0939896369267,-0.0387260748803,-0.267290335092,0.0468322985302,0.0541747358204,-0.180150060583,-0.0833608149288,-0.209350603725,0.125374147352,-0.159381220112,0.086438156195,0.171726215988,0.0282170121316,-0.00877513783767,-0.00251296728892,-0.0576274714273],[-28528.9864649,-483.197644616,1193.95159535,-1999.07657339,-255.078301732,1221.65972848,-520.047494441,1757.27876507,563.110519105,549.774450565,-1104.20178829,251.576760216,406.984361712,-29.1794779811,273.170623264,-438.955797249,166.494363385,-332.919278139,-109.870553897,282.969358803,22.9326259519,-77.85403528,-9.79598488969,-107.098670953,76.2901851053,89.1002637647,64.2436476443,-67.7002999107,148.628272178,4.47256739463,5.41320950347,-29.2348588653,-28.3225504976,45.9448727229,-2.30078303667,-9.71444980164,17.0354750124,-12.2309378459,-4.26764226979,1.17514342168,4.06634220772,-16.2894039795,34.6920505366,-30.5787219894,39.0824678117,3.80741614408,5.94620307771,-24.1222346441,0.993729199122,-2.39068628821,1.50201319928,-3.98243028575,-2.18048555822,-1.91616900791,-7.86947640242,7.28162456708,-8.28227656145,9.44367946941,-7.34522961221,4.21209073759,-5.19394994908,-5.01656819458,1.01407149228,-0.968960233585,-0.145334388157,-5.48550792226,0.447585907816,-0.815672463821,1.36734723339,-0.95864597366,0.280675221269,-1.57481986635,1.48761923933,-2.17965715131,-1.05505268081,-1.6361696505,-0.608418944451,-1.05861778873,0.0465278693234,0.709641409143,-0.592579757858,-0.606559151121,-0.893198016369,-1.1096349009,-0.55424901551,0.475232763838,-0.870763818639,-0.137715677179,-0.293032295643,0.291041056861,-0.705225185767,0.0347088272487,-0.322016284631,0.116221126873,0.00706992023269,0.060527990988,0.431060223817,0.221432895442,-0.107018632349,0.0410198345267,0.00525578922938,-0.169685827878,-0.222513021335,0.0226178836313,0.0903604037352,-0.0393944078087,-0.264983230787,0.0442849238889,0.0603814235738,-0.180155735709,-0.0802227332997,-0.212808888646,0.125776244355,-0.162248415385,0.085836949869,0.172209275845,0.028355926197,-0.00797513253093,-0.00252947852129,-0.056638239751],[-28450.0279498,-524.264144567,1184.04635323,-1967.38145708,-262.561235141,1222.7352384,-517.435149703,1732.28366925,555.194291123,534.584455493,-1087.53336292,264.509542098,398.505040618,-30.6319021171,270.361817386,-435.380880654,161.194885748,-327.3894072,-102.353851721,282.756245831,22.5531175831,-75.5903164602,-7.9098582638,-109.028683936,79.3482805171,85.7393623462,63.8949084387,-66.24144262,148.80378997,3.31203836399,4.42031604314,-27.0336330824,-28.3636227446,45.1213772001,-3.3534864606,-8.95569229029,16.5561558986,-12.9334275496,-4.70892211064,1.52715344197,3.50054381035,-16.8000327736,35.2780366038,-30.3450957916,39.5139742557,3.50943571635,6.16391057579,-23.9760031555,1.11443716025,-2.44791224689,1.34474701776,-4.20414103687,-2.04947912757,-2.0751240509,-7.8960421969,7.37713829685,-8.24214813258,9.72770462191,-7.29005773158,4.27858443055,-5.12527753555,-4.99540161777,1.00497124379,-0.951377512649,-0.121856047333,-5.51250084318,0.388335522881,-0.733580488096,1.33337000232,-0.966305771297,0.289687119169,-1.57157821465,1.60456708223,-2.15842752958,-1.01673229614,-1.62531855604,-0.592041139589,-1.06339356428,0.0335340475988,0.678625495286,-0.596432872946,-0.593213820032,-0.888986116948,-1.12182142079,-0.544931902341,0.474683206248,-0.866632664323,-0.137193607708,-0.298326046283,0.326875915892,-0.700067789584,0.0419257480334,-0.328368348714,0.124309897644,0.00296004570153,0.0571777336535,0.427115791402,0.221082465498,-0.108672831414,0.0418092305426,0.00952752995909,-0.166631340172,-0.221766934115,0.0241629288081,0.0868247749779,-0.0397216558332,-0.262343553867,0.0414983499328,0.0666398468703,-0.180024834527,-0.0771432078724,-0.216362508211,0.126220996145,-0.165081564052,0.08507760606,0.172290729003,0.0282551829281,-0.00716156573094,-0.00248548628078,-0.055489722674],[-28372.7252065,-564.460510125,1173.02099153,-1934.15991166,-268.515381047,1222.92196147,-516.301493913,1705.38603937,546.573537927,519.1929002,-1071.19304948,277.390384748,389.681797428,-31.5329730939,267.635548997,-431.512897882,156.11994618,-321.767425704,-94.7146880328,282.443359606,22.1876474215,-73.0833305935,-5.85024307515,-111.230543905,82.4283369234,82.3669094276,63.4257094333,-64.5960553556,148.965512483,2.00149486701,3.5007613095,-24.825500218,-28.5568259286,44.1719866753,-4.40970992728,-8.17583956476,16.0517831824,-13.6416196841,-5.14630710375,1.92268190909,2.88754761563,-17.3193100953,35.8273412949,-30.1030036957,39.8836312541,3.185351043,6.39078841867,-23.8099263256,1.2276135633,-2.50834420809,1.18454754272,-4.43072272331,-1.91277769132,-2.23518847215,-7.91245613502,7.46497249067,-8.19679894448,10.0020199129,-7.23867136819,4.33564655629,-5.04803584139,-4.96601906493,0.997859099483,-0.933209585345,-0.098189160077,-5.53331157836,0.324288196363,-0.647951076446,1.30111318084,-0.969872587489,0.298027188231,-1.56601989615,1.71895169748,-2.13734963105,-0.979819856084,-1.61361848608,-0.572699046137,-1.067830752,0.0199737455363,0.644902725228,-0.599289903481,-0.579064394269,-0.882878854732,-1.13366920084,-0.534462826559,0.474871565005,-0.860453576745,-0.137215673335,-0.303762641893,0.363181323881,-0.694762118665,0.0483412810865,-0.335127663556,0.132767951629,-0.00175436765652,0.0537231372112,0.422146411185,0.220456741317,-0.109849729623,0.0427494791227,0.0138772502639,-0.163119104403,-0.220772186947,0.0255521578871,0.0834092495821,-0.0398052322895,-0.259342504581,0.0385045561033,0.0729656209482,-0.179778354116,-0.0741163239065,-0.219986697188,0.126679045471,-0.167805302576,0.084156055391,0.171964962518,0.0279464041208,-0.0063396456872,-0.00239168496712,-0.0542054194236],[-28297.7218746,-602.147061912,1161.44912483,-1898.76797261,-272.268022037,1222.04643611,-517.090315217,1676.58117342,537.297470467,503.575433292,-1055.54099867,290.070784498,380.575954043,-31.7921373721,264.726081362,-427.316216388,151.25335082,-316.118973349,-87.0315817259,281.936852781,21.8679858337,-70.3951332233,-3.6334391,-113.574852157,85.5154130391,78.9694092462,62.8005684751,-62.7740701198,149.088915658,0.548198193275,2.65989843127,-22.5938344371,-28.8793645953,43.098768678,-5.46819227619,-7.37789807302,15.5151998418,-14.3473543614,-5.58491212155,2.35929396754,2.22942704573,-17.8456900375,36.3390839324,-29.8520997175,40.1881348735,2.83346424836,6.62520185423,-23.6254452731,1.33190944099,-2.57393976788,1.022623127,-4.65957457501,-1.77234049262,-2.39686509418,-7.91922397628,7.54707662349,-8.14733325119,10.2658408931,-7.19102296574,4.38237084655,-4.96386046738,-4.92820723022,0.993597398773,-0.914647252156,-0.0745921908385,-5.54748040367,0.255626874198,-0.559157054435,1.27048933848,-0.970325994388,0.306303672049,-1.55811025794,1.83011344495,-2.11685673137,-0.944167537265,-1.60099388781,-0.550378822768,-1.07132530444,0.00567018223094,0.608572411563,-0.601004133162,-0.564216966797,-0.874861069394,-1.14497893174,-0.522740721665,0.475738241538,-0.852424434862,-0.137814636607,-0.309353267751,0.399860437536,-0.689383847448,0.0539606041391,-0.342275812594,0.141605539575,-0.00703314501314,0.0500931817838,0.41620596257,0.219550651975,-0.110506923533,0.0438354672682,0.0182583974297,-0.159160193138,-0.219519397425,0.026818313073,0.080140326475,-0.039742550513,-0.255951283181,0.0353355218421,0.0793743610456,-0.179437291555,-0.0711361666616,-0.223656690349,0.127121035085,-0.170344267419,0.0830682284848,0.17122636345,0.027461211571,-0.00551458064921,-0.00225876898002,-0.0528088292273],[-28225.3692581,-636.193865759,1149.86356212,-1860.78511847,-273.292474707,1220.06485445,-520.117268635,1646.0067156,527.393509861,487.69233298,-1040.84252107,302.427522411,371.252738286,-31.3494001977,261.42838379,-422.766806842,146.569377788,-310.502718677,-79.3617764655,281.167572069,21.6184052601,-67.5688358744,-1.27001845926,-115.94531357,88.5943057086,75.5312967692,61.9932435599,-60.7869886951,149.152529415,-1.04089782899,1.90647515343,-20.3255064092,-29.3063895013,41.9076118455,-6.52682898446,-6.56496011242,14.939502014,-15.0433231787,-6.02866119798,2.83377799501,1.52854065797,-18.3764303376,36.8138265053,-29.5922566622,40.4267825135,2.45322100902,6.86474789891,-23.4249045191,1.4263136637,-2.64653889097,0.8600679066,-4.88834494538,-1.63008841322,-2.5602904229,-7.91704669935,7.62541555688,-8.09469856091,10.5188983204,-7.14674098718,4.41781037974,-4.8743483608,-4.88172364804,0.99301503182,-0.895768186115,-0.0513434705975,-5.55472663891,0.182680903175,-0.467605095265,1.24142506753,-0.9686832675,0.315105906548,-1.54791384521,1.9375905148,-2.09728310774,-0.909793749939,-1.58741931534,-0.525112730318,-1.07335714662,-0.00952428754666,0.569774014259,-0.60144594814,-0.548793050556,-0.864970372023,-1.15556306192,-0.509711274388,0.477223928853,-0.842823438911,-0.138987567698,-0.315110677177,0.436819550798,-0.684007216916,0.0587751493351,-0.349770276004,0.150816855791,-0.0128186856275,0.0462345335865,0.409370494601,0.218365251364,-0.110620814589,0.04506239355,0.0226268173654,-0.154773473194,-0.217999762354,0.0279910205337,0.0770308399482,-0.039634785594,-0.252151908377,0.0320153248582,0.0858757772421,-0.1790260788,-0.0682064185161,-0.227343649095,0.12751391436,-0.172637782444,0.0818138009147,0.170087327548,0.0268250774067,-0.00469081064608,-0.00209287714388,-0.0513237336179],[-28154.8493208,-667.509968325,1138.6338901,-1820.68459989,-271.646191669,1217.45202364,-525.185476678,1614.36969488,516.801917904,471.442395894,-1026.9835669,314.438518464,361.793001658,-30.2670019572,257.780249771,-417.887052778,142.004193138,-304.949445617,-71.6774150044,280.165140433,21.4331864371,-64.5717739954,1.25235734742,-118.278047361,91.6487642949,72.0287298815,61.0144532777,-58.6525919853,149.147099597,-2.76006921696,1.2628176859,-18.0213728201,-29.8048362452,40.6196892465,-7.58014207984,-5.74046137808,14.3187984725,-15.7256236745,-6.4767150128,3.33981530213,0.788387550302,-18.9040033116,37.2579016675,-29.324222492,40.6092769066,2.04864121046,7.10395064345,-23.2142621945,1.51116645225,-2.72751101679,0.697519150257,-5.11567868167,-1.48778888929,-2.7241356976,-7.90740615949,7.70201569872,-8.0392153987,10.7629837814,-7.10415797275,4.44085562078,-4.78094185494,-4.82620921362,0.996807091821,-0.876197550465,-0.0288007964565,-5.55548577963,0.106365233481,-0.37383726269,1.21390305135,-0.966112495761,0.324947596986,-1.53589199566,2.04171241823,-2.07856704358,-0.877381838844,-1.57306975048,-0.49711743828,-1.07374209353,-0.0256407663225,0.528807582756,-0.600554144377,-0.532975838386,-0.853455459371,-1.16528107088,-0.495507184389,0.479270486264,-0.832250074245,-0.140588767278,-0.32105389567,0.473977506539,-0.678700734228,0.0627213664687,-0.357472120922,0.160331868842,-0.0189836851088,0.0421646032052,0.401804734866,0.216926092649,-0.110243023812,0.0464267028182,0.0269479504705,-0.150008988392,-0.216206795372,0.0290874422903,0.0740389657513,-0.0395981596407,-0.247969672727,0.0285364359305,0.0924559589828,-0.178582887303,-0.0653691503241,-0.231002441359,0.12780985916,-0.174683921113,0.0804074280551,0.168632285338,0.0260388750851,-0.00386970282533,-0.00188192598185,-0.0497750433493],[-28085.0516911,-697.514161481,1128.08888989,-1779.16311058,-267.532659543,1214.81240458,-531.969928729,1582.51948646,505.441166557,454.709048263,-1013.7552463,326.106977363,352.281501577,-28.6377418224,253.880178841,-412.710940945,137.484434906,-299.48296694,-63.9293648677,278.983874898,21.299112175,-61.3523390159,3.95175447573,-120.522276332,94.6622762903,68.4357971976,59.8841563671,-56.3902306743,149.066426026,-4.60389944913,0.754646854841,-15.6857868597,-30.3395866363,39.2599950575,-8.6218102277,-4.90792341457,13.6474511499,-16.3912048721,-6.92704340726,3.87031043274,0.012751955815,-19.4196849198,37.6790847396,-29.0489639585,40.7479221182,1.6248882904,7.33656594715,-23.0003798326,1.58714586512,-2.81810795345,0.535499909881,-5.3404697546,-1.34717099558,-2.88670584094,-7.89197943113,7.77891884352,-7.98104754381,11.0004040697,-7.06128248196,4.45035638127,-4.68504462955,-4.76127566241,1.00563522273,-0.855447380995,-0.00734183204835,-5.55037236533,0.027741216151,-0.278429468102,1.18791999603,-0.963819471459,0.336323540951,-1.5226052451,2.14300649672,-2.06054782384,-0.847781382337,-1.55817028192,-0.466655718307,-1.07237993262,-0.042681220947,0.486013313863,-0.598284620293,-0.516963943105,-0.840617799605,-1.17400419587,-0.480307904561,0.481820064659,-0.821384147491,-0.142436843641,-0.32720351677,0.511256284863,-0.673531473089,0.0657219597468,-0.365218311222,0.170064490857,-0.0253834131539,0.0379184873183,0.393695580595,0.215264853809,-0.109443977115,0.0479251514926,0.0311896357673,-0.144924576798,-0.214134589326,0.0301216243273,0.0711092149985,-0.0397526565159,-0.243440687249,0.0248834241053,0.0990950905541,-0.178149323395,-0.0626760300585,-0.234583861706,0.127957351971,-0.176495444289,0.0788675102308,0.166963676039,0.0250973283955,-0.00305185611406,-0.00160927644176,-0.0481879514807],[-28014.8659977,-727.625237094,1118.5573426,-1736.91734423,-261.155364948,1212.75045817,-540.145614171,1551.30546551,493.229727784,437.37571632,-1000.94866938,337.436103816,342.802995465,-26.554418965,249.826670534,-407.272458093,132.936741129,-294.127095419,-56.06849358,277.678092491,21.2029652841,-57.8589223655,6.84623908133,-122.627223283,97.6183291875,64.7265873317,58.6223115665,-54.0192554462,148.904308526,-6.56697200404,0.407683486412,-13.323101718,-30.8755224838,37.8535234553,-9.64551209345,-4.07086776644,12.9198219789,-17.0370157953,-7.37761622259,4.4181679307,-0.79458189239,-19.9147511227,38.0851510422,-28.7674478132,40.8550222138,1.18712568656,7.55634966931,-22.7901189667,1.65492996075,-2.91958150908,0.374533237385,-5.56161213489,-1.20996380686,-3.04630577556,-7.87244358867,7.85816678579,-7.92035877549,11.2334659789,-7.01612307433,4.44516247279,-4.58806036441,-4.68653472986,1.02016106851,-0.833029713497,0.0126557589939,-5.54000093551,-0.0521297977775,-0.181957622893,1.16347260768,-0.963009986884,0.349728536033,-1.50861412933,2.24200009174,-2.0430647335,-0.821841958778,-1.54294599837,-0.433990342054,-1.06917045135,-0.0606476182702,0.441731404391,-0.594593274304,-0.500955977527,-0.826758860895,-1.18160367415,-0.464292887795,0.484814814929,-0.810905465282,-0.144350405081,-0.333580134018,0.548577865873,-0.6685665072,0.0676996333763,-0.372845810781,0.179928633965,-0.0318731394593,0.0335312826042,0.385229929014,0.213413212826,-0.108294100411,0.0495544959931,0.0353197122779,-0.139578076483,-0.211777237062,0.0311076126291,0.0681860988039,-0.0402182600824,-0.238601062961,0.0210408584289,0.105773356242,-0.177766993403,-0.0601787256919,-0.238038704702,0.12790487528,-0.178085112835,0.0772124477665,0.165183938867,0.0239951611272,-0.00223786943941,-0.00125828947143,-0.0465876510715],[-27943.1818691,-759.261987033,1110.36802937,-1694.64399456,-252.717794502,1211.87064531,-549.387522388,1521.57700722,480.086073548,419.325826297,-988.354946272,348.42910253,333.44224074,-24.1098325567,245.718224386,-401.605590973,128.287749842,-288.905643827,-48.0456686664,276.302110238,21.1315285747,-54.0399154741,9.9538773199,-124.542111017,100.500410479,60.8751888983,57.2488776147,-51.5590169851,148.654546921,-8.64387036019,0.247648406768,-10.937670585,-31.377525597,36.4252686162,-10.6449263425,-3.23281597824,12.1302728922,-17.6600054676,-7.82640330005,4.97629233985,-1.62982976122,-20.3804778809,38.4838758956,-28.4806408078,40.942881259,0.740516836627,7.75705766925,-22.5903411304,1.7151967976,-3.03318349178,0.215142184681,-5.77799979327,-1.07789639787,-3.20124042412,-7.85047570652,7.94180132001,-7.85731287299,11.4644763028,-6.96668830939,4.42412370692,-4.49139273928,-4.60159815142,1.04104627311,-0.808456583763,0.0308143130374,-5.52498602966,-0.132186457269,-0.0849976384544,1.1405575924,-0.964889834327,0.365657379821,-1.49447918417,2.33922054475,-2.02595705751,-0.800413146524,-1.52762198853,-0.399384081176,-1.06401343718,-0.0795419251425,0.396302051149,-0.589436004828,-0.485150554468,-0.812180111406,-1.18795074297,-0.447641586986,0.488196887962,-0.801493834246,-0.146148059891,-0.340204340956,0.585864229676,-0.663872910267,0.0685770915641,-0.380191583473,0.189838210294,-0.038308133722,0.0290380857414,0.376594677351,0.211402847681,-0.106863819612,0.0513114927395,0.0393060190248,-0.134027325513,-0.209128831426,0.0320594531804,0.0652141282818,-0.0411149542029,-0.233486910881,0.0169933079476,0.112470940334,-0.177477503656,-0.0579289051972,-0.241317764912,0.127600911572,-0.179465687615,0.0754606409871,0.163395513042,0.0227270970695,-0.00142834172848,-0.000812326018692,-0.0449993351809],[-27869.5152216,-793.48503935,1103.81255986,-1652.92603261,-242.399464823,1212.57473436,-559.337962413,1493.88939936,466.019583187,400.461363702,-975.799098083,359.114723925,324.277133681,-21.3853258379,241.612812171,-395.733341906,123.478491341,-283.847045385,-39.8239774292,274.905851548,21.064837483,-49.8694895432,13.2831482419,-126.217827886,103.295399183,56.8630080617,55.78561698,-49.0285194367,148.311769981,-10.8288076026,0.291267992119,-8.53471741839,-31.8152300663,35.000613793,-11.6165429724,-2.39693693153,11.2755553393,-18.2568440488,-8.27029044664,5.53743057576,-2.48997308283,-20.8096892734,38.8819111663,-28.189772386,41.0224038078,0.289863154565,7.93441307389,-22.4075718896,1.76850153212,-3.15987874018,0.0579245886115,-5.98846201398,-0.952811799999,-3.3501564973,-7.82779984801,8.03170360736,-7.79240279665,11.6953065649,-6.91138241756,4.38677389137,-4.39655250461,-4.50641095747,1.06886768781,-0.781447042219,0.0468038351372,-5.50592825355,-0.211378952367,0.0118052717911,1.11910375518,-0.970436336373,0.384541162103,-1.4807278333,2.43510191064,-2.00901205236,-0.784138875713,-1.5124282522,-0.363147323654,-1.05678261675,-0.0993143630594,0.350074084245,-0.582818151578,-0.469721673277,-0.797167216434,-1.19293831372,-0.430525487915,0.491893041768,-0.793704125053,-0.147663634911,-0.347068517303,0.623015021409,-0.659500710688,0.0682982543396,-0.387124330267,0.199701200226,-0.0445561818212,0.0244739191845,0.367951606985,0.209289748238,-0.10522701534,0.0531881286471,0.0431191877386,-0.128322813033,-0.206190795394,0.0329988938994,0.0621438553119,-0.0425364814475,-0.228141836147,0.0127331782817,0.119171041835,-0.177315938706,-0.055963479805,-0.244379184366,0.127013249309,-0.180653019759,0.0736311350637,0.161689579021,0.0213012435815,-0.000626013836198,-0.000257437727005,-0.0434429807262],[-27795.8871236,-829.922366835,1099.03385792,-1611.89153891,-230.284012516,1214.45372359,-569.508521874,1467.62158012,451.403265542,380.758551162,-963.241789829,369.623901286,315.358125998,-18.4164183223,237.406294628,-389.634775508,118.507564955,-278.998215116,-31.4153862815,273.521665373,20.9559379489,-45.4249348625,16.8041824771,-127.611924454,106.003740421,52.7007211863,54.2615070509,-46.4453807944,147.87392227,-13.1145152422,0.519290818874,-6.12294924619,-32.1772791073,33.6064985419,-12.5680973098,-1.56498885591,10.3619788386,-18.8230862445,-8.70182733239,6.09369904092,-3.37505595049,-21.2014018537,39.2814149048,-27.8971227606,41.0988963683,-0.161482040744,8.09200808065,-22.246992942,1.81490771265,-3.29948421494,-0.0962225742522,-6.19156933527,-0.837008871049,-3.49306785792,-7.80632803206,8.12911227569,-7.72743823122,11.9260872078,-6.85019231298,4.33538281833,-4.30547869355,-4.40225135805,1.10386299322,-0.752548197832,0.0604850051012,-5.48337247792,-0.288703637441,0.107528686303,1.09876829651,-0.979712936798,0.406556141452,-1.4677550519,2.52970509797,-1.99180886054,-0.772840483599,-1.49761443351,-0.325780922772,-1.04724747338,-0.119708172097,0.303430866976,-0.57494281944,-0.454744879427,-0.781942629778,-1.19654599437,-0.413084207932,0.495768462836,-0.787591464528,-0.148791831167,-0.3540521875,0.65984054635,-0.655431755637,0.0668919050216,-0.393639700506,0.209401857147,-0.0505351343671,0.0198735084932,0.359362035902,0.207227151895,-0.103471387044,0.0551573126117,0.0467410209844,-0.122485632483,-0.20299387245,0.0339784904409,0.0589499948372,-0.044471619215,-0.222639420373,0.00828422134766,0.125868918627,-0.177291295989,-0.0542603337763,-0.247210494949,0.126186900851,-0.18167532147,0.0717455545531,0.160112282218,0.0197792423013,0.000157805671293,0.000409560977645,-0.041917700056],[-27724.9449314,-867.843778459,1096.13767597,-1571.55487131,-216.431104183,1216.89591875,-579.378108051,1441.85840028,436.701036827,360.212170579,-950.677597508,380.113113609,306.728808259,-15.2271735923,232.954004736,-383.277971963,113.387962273,-274.410688491,-22.8440814141,272.177507049,20.7511285383,-40.809321494,20.47752355,-128.683616836,108.62927084,48.4063221861,52.7073289457,-43.8268725134,147.339777299,-15.4933543963,0.90347101349,-3.71194386414,-32.4570682164,32.2702514953,-13.5101360134,-0.73837731798,9.39824242513,-19.3540078961,-9.11247959312,6.63705650952,-4.28588812269,-21.5561802942,39.6834217074,-27.6052348367,41.1762659371,-0.610527454184,8.2354021546,-22.1134500177,1.8543559855,-3.45152990725,-0.246327542408,-6.38582760892,-0.732900425442,-3.63033015679,-7.78801926649,8.23510531951,-7.66455804251,12.1565134041,-6.78350058071,4.27290427615,-4.2202174099,-4.29073085815,1.14618507725,-0.722514174205,0.0717661714253,-5.45784963978,-0.36316840794,0.201180881512,1.07914051574,-0.99255460967,0.431814868641,-1.45592270305,2.62299772871,-1.97387459608,-0.766133659213,-1.48343508766,-0.28783334814,-1.03515142958,-0.140414846978,0.25676439594,-0.566062554597,-0.440271104928,-0.766713002364,-1.19877506702,-0.395449397274,0.499672944777,-0.783086043538,-0.149442568227,-0.361006662166,0.696128774809,-0.651630846984,0.0644080427513,-0.399765080626,0.218818502698,-0.0561753581522,0.0152715050033,0.350862166243,0.205392607931,-0.101688088882,0.0571871840246,0.0501561140357,-0.116529528379,-0.19957613621,0.0350585003933,0.0556133025661,-0.0468829036114,-0.217060739295,0.00367802563586,0.132562843313,-0.177406051167,-0.0527825946297,-0.249806576013,0.125186184533,-0.182563895219,0.0698261688583,0.158698509284,0.0182361184367,0.000909666300047,0.00118916497364,-0.0404173893769],[-27659.3360012,-906.519083195,1095.22976642,-1531.93038768,-200.900406426,1219.28962556,-588.42562822,1415.68471061,422.37681326,338.817003857,-938.101097119,390.738839893,298.432771031,-11.8416552302,228.111275474,-376.631011459,108.132674883,-270.136000982,-14.1342490177,270.901331913,20.3967078171,-36.1257194992,24.2637149851,-129.392121147,111.175827089,43.9978049754,51.1538637825,-41.190266049,146.708108578,-17.9576861824,1.41556270243,-1.31127906795,-32.6479928903,31.0192012856,-14.4532057421,0.0814921156588,8.39304513423,-19.8448848455,-9.49371286461,7.15946175577,-5.22327935797,-21.8745892671,40.0889661703,-27.3166515193,41.2584195108,-1.05428179064,8.37015476078,-22.011788847,1.88678699701,-3.6155458083,-0.391418554353,-6.5697426867,-0.642899277596,-3.76229904477,-7.77483255913,8.35076073333,-7.60590109636,12.3862803264,-6.71168980579,4.20229205316,-4.14281475748,-4.17346096276,1.19598682785,-0.692099094938,0.0805556826056,-5.42989067616,-0.433781159314,0.291770133847,1.05980971224,-1.00879632906,0.460429894443,-1.4455926498,2.71494742483,-1.954736373,-0.763634091589,-1.47014476987,-0.249853069368,-1.02023790785,-0.161125882423,0.210466667734,-0.55642990323,-0.426351281785,-0.751684985118,-1.1996268138,-0.377752706182,0.5034562812,-0.780118052948,-0.149525765664,-0.367783251921,0.731667677099,-0.6480627866,0.06089666667,-0.405527857062,0.227829458519,-0.0614072199694,0.0107025600507,0.342488200145,0.203963665627,-0.0999682750114,0.0592458822771,0.0533490621659,-0.110468245236,-0.195975660288,0.0362991813452,0.0521145342072,-0.0497328707428,-0.211486868646,-0.00105382036324,0.139251088495,-0.177662679898,-0.0514933898842,-0.252162306908,0.12407541869,-0.183350043475,0.0678952473827,0.157483146874,0.0167468971958,0.00161611755612,0.00208186913937,-0.0389359448956],[-27601.7076892,-945.218090016,1096.41588168,-1493.0324459,-183.751585849,1221.02314975,-596.129989662,1388.1853619,408.894511056,316.5678329,-925.506864659,401.657559135,290.513604884,-8.28392681842,222.733439821,-369.661974182,102.754694373,-266.22568806,-5.31007528297,269.7210953,19.8389743511,-31.47719894,28.1233003069,-129.696653502,113.647245815,39.4931634684,49.6318926797,-38.5528328563,145.977689619,-20.4998717179,2.02732001215,1.06946734666,-32.7434486257,29.8806765452,-15.4078531546,0.893213878404,7.3550860011,-20.2909929344,-9.83699278267,7.65287355387,-6.18803941482,-22.1571934444,40.4990828901,-27.0339157134,41.349264086,-1.48975375498,8.50182536424,-21.9468551603,1.91214139348,-3.79106190926,-0.530523848587,-6.74182042039,-0.569418241931,-3.88933017268,-7.76872691781,8.47715651167,-7.55360625857,12.6150831472,-6.63514257327,4.12649993767,-4.07531684011,-4.05205317685,1.25342113293,-0.662057083636,0.0867618871379,-5.40002652405,-0.499549787012,0.378304719738,1.04036518537,-1.02827306904,0.49251376963,-1.43712675523,2.8055218083,-1.93392130532,-0.764957469758,-1.45799803534,-0.212388556067,-1.00225033071,-0.181532773153,0.164929678952,-0.54629741152,-0.413036342005,-0.737065228966,-1.19910251679,-0.360125784895,0.506968265716,-0.778617683622,-0.148951343046,-0.374233267384,0.76624522353,-0.644692376354,0.0564077759189,-0.410955416252,0.23631304625,-0.0661610866114,0.00620132497124,0.334276339748,0.203117874263,-0.0984030995907,0.0613015467604,0.0563044606486,-0.104315527568,-0.192230518299,0.037760790885,0.0484344454691,-0.0529840567151,-0.205998884161,-0.0058797281592,0.145931926774,-0.178063657844,-0.0503558470582,-0.254272566986,0.122918921657,-0.184065068711,0.0659750595292,0.15650108164,0.0153866037864,0.00226370894556,0.00308816835321,-0.0374672628187],[-27554.0036317,-983.163503042,1099.60866756,-1454.85628725,-165.02159681,1221.63925768,-602.065595488,1358.71653835,396.623813135,293.512007221,-912.912966958,412.965532834,282.989361602,-4.57227410858,216.675767679,-362.344432524,97.292036056,-262.727861879,3.5875470763,268.663510902,19.0521627508,-26.9538289229,32.0181023694,-129.559617338,116.047616295,34.9113481745,48.171361318,-35.9372623036,145.146975993,-23.1104433995,2.71131622797,3.41719714079,-32.7377355096,28.8744382501,-16.3841962931,1.69529346109,6.293164313,-20.6873827306,-10.1366749502,8.10901676723,-7.18025112049,-22.4047464208,40.9148675051,-26.7592903014,41.451777865,-1.91528749864,8.63598533893,-21.9222363333,1.93052140601,-3.9772808477,-0.662643391315,-6.90096327435,-0.514610352287,-4.01194740888,-7.77084045928,8.61511172636,-7.50955451068,12.8423117524,-6.55419024573,4.04845039935,-4.01909369886,-3.92809689369,1.31855767341,-0.633016188516,0.0903028692712,-5.36864123721,-0.559672646734,0.459941766426,1.020285787,-1.05073099856,0.528134519176,-1.43094554505,2.89465806945,-1.91107197005,-0.769569606955,-1.44723503297,-0.175960607657,-0.981027947635,-0.20141614069,0.120459522271,-0.535886425938,-0.400381892808,-0.723041471283,-1.19719828165,-0.342700391995,0.510051729251,-0.778490616495,-0.147624879227,-0.380245122939,0.799683950908,-0.641478346827,0.0510374755947,-0.416061889507,0.244166575643,-0.0703562113228,0.00179141151249,0.326248807863,0.203011874398,-0.0970706062394,0.0633314561291,0.0590069917778,-0.0980957161316,-0.188374926364,0.039495048318,0.0445550315104,-0.0565952710683,-0.200665344509,-0.0107700695836,0.152599661151,-0.178609527769,-0.0493347725159,-0.256136353085,0.12176851661,-0.184734316557,0.0640786656689,0.155770879318,0.0142221293154,0.00284067008436,0.00420231894312,-0.0360056075366],[-27515.3525842,-1019.38960699,1103.94834358,-1417.32068669,-144.65654469,1221.29855808,-606.188832142,1327.71975791,385.557469236,269.90714678,-900.431434169,424.518152492,275.775937843,-0.701871529667,209.793276636,-354.673927698,91.8828101463,-259.676941323,12.4508992541,267.750325832,18.1222518053,-22.5936747329,35.9150613443,-128.956165376,118.38203832,30.2751359841,46.7988736274,-33.3879154116,144.213151513,-25.7726187414,3.44340127069,5.70473030279,-32.6287719905,27.9899767513,-17.3906387322,2.48588058433,5.21648036533,-21.0282037073,-10.3986748388,8.51868061614,-8.19708957701,-22.6187574801,41.3376598218,-26.4939180737,41.5652238726,-2.33456895916,8.77825369428,-21.9364863246,1.94267560478,-4.17209584675,-0.786664059584,-7.04766016336,-0.479589520175,-4.13134749184,-7.77902773595,8.76440975841,-7.47459529697,13.0661348809,-6.46895929591,3.97094063308,-3.97281112377,-3.80309305969,1.3911333022,-0.605100156262,0.0911356562665,-5.33553133624,-0.614109935191,0.536433804394,0.998608578987,-1.07556106609,0.567182064869,-1.42770419565,2.98217167202,-1.88629279627,-0.776336813219,-1.43803828636,-0.14097934279,-0.956793315984,-0.220913113746,0.0770186746793,-0.525293494105,-0.388462242259,-0.709725795243,-1.19388950811,-0.325608719443,0.512521652005,-0.779544492767,-0.145434590188,-0.385855648026,0.831944662021,-0.638355143445,0.0450662946163,-0.420808387641,0.251363308906,-0.0738673931568,-0.00254772693152,0.318371910002,0.203718671703,-0.0959963964259,0.0653494460908,0.0614416859299,-0.0918755366327,-0.184427670635,0.0415195198155,0.0404632452901,-0.0605104170772,-0.195504740093,-0.0157030577557,0.159232716222,-0.179293100857,-0.0484016880023,-0.257769131992,0.120626046098,-0.185359305297,0.0621822900435,0.155245821974,0.0132878284854,0.00334195102832,0.00539362303535,-0.0345467161746],[-27484.1795823,-1052.88358172,1108.38202268,-1380.32530261,-122.579822624,1220.3161203,-608.551581906,1295.90787192,375.593995802,246.063439149,-888.197787278,436.110592115,268.763691481,3.33788431999,201.940921204,-346.651493121,86.6901505817,-257.103921956,21.1555559212,267.002045557,17.1631563487,-18.4218006999,39.782396733,-127.864637659,120.655864314,25.6082603828,45.5401981003,-30.9545711141,143.173082053,-28.467786537,4.20024421994,7.90136637782,-32.4153811074,27.2092147434,-18.4351554302,3.26303602614,4.1343347055,-21.3073800639,-10.631797887,8.87242041008,-9.23500295516,-22.8009248286,41.768860689,-26.2386617982,41.6879363394,-2.75261952066,8.93426134862,-21.9869007382,1.94951414474,-4.37307277592,-0.901444458151,-7.18279661478,-0.465209876525,-4.24889537754,-7.79032240915,8.92457506618,-7.44932017742,13.284415985,-6.37952497405,3.89673651508,-3.93445884213,-3.67852050956,1.4708016652,-0.578306658175,0.0892270111376,-5.3003464585,-0.66301230934,0.607682214939,0.974260175684,-1.102065415,0.6095018027,-1.42811654607,3.06784764812,-1.85980367605,-0.783975522793,-1.43057591279,-0.10782720993,-0.929864820101,-0.240249947834,0.0344837092457,-0.514583963929,-0.377356373636,-0.69721137047,-1.18914641944,-0.308983067546,0.514186051495,-0.781562443708,-0.142264351192,-0.391138775853,0.86302272615,-0.635251140345,0.038820867858,-0.425142766345,0.257895496358,-0.0765583176184,-0.00684767655508,0.310597972348,0.205290363127,-0.0951929610808,0.0673784916166,0.0635936605016,-0.0857323110182,-0.180403679773,0.0438432332654,0.0361472792173,-0.0646696714503,-0.190523044251,-0.020658866117,0.165805546985,-0.1801052554,-0.0475297941074,-0.259190487982,0.11948085751,-0.185935596372,0.0602529478625,0.15486287076,0.0126099218982,0.00376418194313,0.00662514420571,-0.0330866940422],[-27458.9096617,-1082.6326071,1111.85681777,-1343.76979338,-98.7148237499,1219.00701369,-609.205727056,1263.99373175,366.631909274,222.291071898,-876.347547269,447.538025705,261.842980391,7.55759684207,192.973655897,-338.278162213,81.8771913003,-255.039799343,29.5770917486,266.439175546,16.2887912147,-14.4632711536,43.5883280365,-126.263374228,122.874446698,20.9344548562,44.421103229,-28.687008345,142.023633487,-31.1773355799,4.9585141554,9.97640491104,-32.0963858993,26.5140749211,-19.525721345,4.02482056456,3.05602788094,-21.5188359996,-10.8448495335,9.16079145853,-10.2904394257,-22.9529466723,42.2098709551,-25.9943842428,41.8182494957,-3.17446056721,9.10963922026,-22.0707751781,1.95194718085,-4.57777750473,-1.00584319177,-7.30725815599,-0.472325552269,-4.36595602196,-7.80175814021,9.09513210798,-7.43432071201,13.495018517,-6.28596253041,3.82860392156,-3.90202658125,-3.555858078,1.5572164083,-0.552633365554,0.0845436968984,-5.26273624134,-0.706530426142,0.673588379356,0.946167191451,-1.12954618863,0.654939128657,-1.43289643537,3.15147102984,-1.83182450145,-0.791202169918,-1.42501602952,-0.0768866575398,-0.900560844325,-0.259652898465,-0.00726880096201,-0.503823183321,-0.367143270215,-0.685591366588,-1.18293923891,-0.292955736608,0.514852945237,-0.784327600586,-0.137998037505,-0.396168439623,0.892913512576,-0.632094711663,0.0326278301941,-0.429012881308,0.263755388318,-0.0782926702128,-0.0111400235525,0.302879321084,0.207779045622,-0.0946727911347,0.0694415676775,0.0654480328898,-0.0797433612344,-0.176317882436,0.0464752165558,0.0315953257012,-0.0690132108963,-0.185726230322,-0.0256176681088,0.172292608433,-0.181036869685,-0.0466922914217,-0.260420005331,0.118322298235,-0.186458751226,0.0582576543354,0.154558986827,0.0122146301555,0.00410399299453,0.00785994603002,-0.0316216464485],[-27437.9678578,-1107.62386299,1113.31984179,-1307.55381738,-72.9849412035,1217.68630758,-608.203149872,1232.69018876,358.569726097,198.900232598,-865.016235129,458.595627267,254.904162448,11.9678694383,182.746435226,-329.55496839,77.6070662403,-253.515569049,37.5910814071,266.082221266,15.6130712373,-10.7431504238,47.3010747561,-124.130715127,125.043137893,16.27745289,43.467357506,-26.635006038,140.761671688,-33.8826546634,5.69488015669,11.8991454476,-31.6706094052,25.8864799792,-20.6703114348,4.76929497764,1.99086043905,-21.6564957138,-11.0466352169,9.37434907099,-11.3598471594,-23.0765212174,42.662091469,-25.7619481752,41.9544975721,-3.60511348293,9.31001822753,-22.1854052484,1.95088486804,-4.78377590268,-1.0987188652,-7.42193031435,-0.501790678338,-4.48389438109,-7.81036859047,9.27560534217,-7.43018846073,13.6958059291,-6.18834721526,3.76930872874,-3.87350406841,-3.43658459972,1.6500311774,-0.528077949702,0.077052476563,-5.22235032211,-0.744814942557,0.734053678938,0.913256240648,-1.15730553034,0.703339438731,-1.44275770257,3.2328268493,-1.80257516455,-0.796733188836,-1.42152675384,-0.0485401340817,-0.869199772995,-0.279348221151,-0.0483622828759,-0.493076500189,-0.357901915275,-0.674958953219,-1.1752381898,-0.277659026935,0.51433035075,-0.787623094671,-0.132519524389,-0.401018572543,0.92161239058,-0.628814231536,0.0268138164988,-0.43236658822,0.268935235108,-0.078934136445,-0.015456354118,0.295168282395,0.211236816137,-0.0944483775183,0.0715616492446,0.0669899204914,-0.0739860092276,-0.172185207284,0.0494244975746,0.0267955771509,-0.0734812121239,-0.181120271642,-0.0305596371725,0.178668355563,-0.182078822003,-0.0458623805353,-0.261477268312,0.117139715662,-0.186924331303,0.0561634246718,0.154271131324,0.0121281738588,0.00435801434824,0.0090610920841,-0.0301476787028],[-27420.0767801,-1127.47960926,1112.14563411,-1271.70952676,-45.432151951,1216.57212097,-605.620487664,1202.58890758,351.279109774,176.152564066,-854.262465037,469.115262247,247.854552197,16.5648413699,171.155788824,-320.505374519,74.0256466054,-252.536309432,45.0906315249,265.933764503,15.2240540517,-7.26193189254,50.8939560879,-121.462454461,127.162551085,11.6619122874,42.7024445183,-24.8353982064,139.381802706,-36.563662985,6.39450101547,13.645625594,-31.1434701114,25.3090578062,-21.8739336201,5.49447303943,0.948445414896,-21.715887751,-11.2434911816,9.50635188886,-12.4391699568,-23.172267786,43.1240258381,-25.5420091561,42.0945438294,-4.04824201174,9.54015214481,-22.327481245,1.94707331318,-4.98891292329,-1.17916056531,-7.52738597024,-0.55415742683,-4.60374793744,-7.81352524153,9.46496893143,-7.43735966454,13.8850415207,-6.08693507363,3.72104477092,-3.84710750597,-3.32187947282,1.74846523974,-0.504568072847,0.0666994801507,-5.1789851814,-0.777984547849,0.789120258946,0.874591423879,-1.1847895239,0.754509996201,-1.45812282399,3.31178705159,-1.77230278181,-0.799392284046,-1.4201171749,-0.0231066808587,-0.836211416403,-0.29949654821,-0.0888179590425,-0.482410106426,-0.349701376761,-0.665404164612,-1.16605044553,-0.263200927754,0.512457478033,-0.791246475348,-0.125734448091,-0.405710936446,0.949149362593,-0.625371082169,0.0216587821168,-0.435161650034,0.273400729253,-0.0784380086904,-0.0198194535361,0.287458824937,0.215686445474,-0.0945309926247,0.0737538598406,0.0682030662008,-0.0685232499396,-0.168023916852,0.0526921778907,0.0217366629798,-0.0780190165277,-0.17668968376,-0.0354644772175,0.184916507665,-0.183220289881,-0.0450047800703,-0.262378304904,0.115916050477,-0.187332808388,0.0539475436209,0.153945012179,0.0123684659474,0.00452091740229,0.0101973083272,-0.0286634073488],[-27405.1493336,-1144.36242574,1109.41843987,-1236.7990487,-16.5727682775,1215.49477134,-601.633397863,1173.79680593,344.52431206,154.115530107,-843.837223951,479.075561859,240.669290869,21.2867953365,158.264546817,-311.242561249,71.2097526605,-252.003430014,52.0389765594,265.924692314,15.106368499,-3.92182514978,54.3606900071,-118.324202586,129.214342508,7.1161881226,42.1407082319,-23.2732391809,137.869593303,-39.1944013573,7.07649437123,15.2188352017,-30.5467682932,24.767257067,-23.1297276713,6.19818050814,-0.0603542060061,-21.6989580357,-11.4318768952,9.56087188116,-13.5223341375,-23.2364901632,43.5825887066,-25.334393918,42.2343676504,-4.50207933689,9.80128617066,-22.4912722314,1.94060243072,-5.192149856,-1.24717930742,-7.62294741611,-0.62877013453,-4.72524427966,-7.80995085613,9.65999585596,-7.45564928833,14.0625879797,-5.98270532978,3.68371771478,-3.82195899649,-3.21172434913,1.850000348,-0.481751360944,0.0533483057036,-5.13302467281,-0.806030060501,0.839393320495,0.829786786742,-1.21202001471,0.808105533499,-1.478248825,3.38857123387,-1.74136336724,-0.798432241073,-1.42016026936,-0.00065171053319,-0.802471288657,-0.319996019181,-0.128248234468,-0.471893569858,-0.342571061288,-0.657004493511,-1.15553098013,-0.249592183983,0.509198307022,-0.795052964472,-0.117635488792,-0.410058607679,0.975692963637,-0.62185867803,0.0172559642732,-0.437395458755,0.277011332112,-0.0771260068048,-0.0242169034514,0.279911487262,0.22103339985,-0.0949270346979,0.0760019171945,0.0690657149037,-0.0633607702935,-0.163865609178,0.0562476537974,0.0164089606191,-0.0825926242469,-0.172333151066,-0.0403100140252,0.191057841213,-0.184443647797,-0.0440502807758,-0.263124917901,0.114608616545,-0.18770429564,0.0516283740911,0.153561324432,0.0129201887101,0.00457953848391,0.0112599702526,-0.0271774938679],[-27393.3959971,-1161.06997229,1106.64993066,-1203.51700416,12.9583137023,1214.18762586,-596.442292934,1146.29961483,338.042731771,132.808049772,-833.414592024,488.491848762,233.340476364,26.0575498976,144.177114452,-301.902138679,69.218941936,-251.79242311,58.416882925,265.967968074,15.2187862215,-0.600468837759,57.7000941837,-114.799023919,131.17542916,2.66955978746,41.7942077074,-21.9206383717,136.208350414,-41.7474409968,7.76846757549,16.6285021835,-29.9188996734,24.2472316202,-24.4278663215,6.87819613797,-1.0243629505,-21.6092568377,-11.6057826312,9.54468434882,-14.6027616512,-23.26441325,44.0217974772,-25.1387219862,42.3694774482,-4.96350100145,10.0937883597,-22.6704419628,1.931398087,-5.39272707427,-1.30301658897,-7.70762429741,-0.724671179389,-4.8477835229,-7.79870601726,9.85690880029,-7.48471697799,14.2287078413,-5.87681800274,3.65666118511,-3.79740711758,-3.10580144388,1.95168387619,-0.459205430876,0.0368419182696,-5.08499949321,-0.828910331302,0.885618828663,0.778593861079,-1.2391627886,0.863742650346,-1.50210136821,3.46348590631,-1.71014015924,-0.793213115701,-1.42086998576,0.0188227713925,-0.76896632982,-0.34067915041,-0.166163309772,-0.461597302297,-0.336530460142,-0.649834297286,-1.14387171781,-0.23681922946,0.504548010135,-0.798912202014,-0.108237087655,-0.413822491215,1.00144636188,-0.618403441658,0.0136519206634,-0.43907531365,0.279599947251,-0.0754114575144,-0.0286274845989,0.272728450393,0.227153819334,-0.0956416834444,0.0782816875874,0.0695547369833,-0.0584899302082,-0.159745216174,0.0600523952687,0.0108032845042,-0.0871732001069,-0.167927900158,-0.0450736038451,0.197122396975,-0.185729569466,-0.0429211914326,-0.263715353798,0.113168321026,-0.18806381656,0.0492345485308,0.153109509898,0.0137597167731,0.00451875515269,0.012246115737,-0.025701110976],[-27385.0272496,-1180.39990874,1105.35177807,-1172.55801409,42.5261978737,1212.38405164,-590.247585338,1120.08306525,331.571767722,112.249042113,-822.66864941,497.379445613,225.860206583,30.8009236124,128.997896974,-292.619716906,68.1127719623,-251.778781034,64.2051170366,265.976555156,15.5200788619,2.82449840134,60.9109862877,-110.96998288,133.022728039,-1.64869332617,41.6750020054,-20.749705189,134.381380978,-44.1953531201,8.49802797973,17.8843544524,-29.2982599747,23.7351353247,-25.7585223036,7.53229868316,-1.93240534543,-21.4503344266,-11.7591986627,9.46456459277,-15.6738744472,-23.2512619473,44.4256695531,-24.9546128859,42.4953816358,-5.4293825485,10.4180267666,-22.8586541944,1.91938614837,-5.58988495155,-1.3469139074,-7.7804262596,-0.84090293936,-4.97076578234,-7.77885130793,10.051930449,-7.5242223794,14.3836636406,-5.77043311155,3.63920880667,-3.77280044685,-3.0037929723,2.05056319834,-0.436507899525,0.0170232828961,-5.03544033944,-0.84658421104,0.928542748529,0.720764178733,-1.26638363138,0.921037946461,-1.52864611625,3.53683757907,-1.67901639621,-0.783094963712,-1.42146027263,0.0353147594161,-0.736683479953,-0.361378458241,-0.202073385576,-0.451591715551,-0.331599064606,-0.643967933305,-1.13126458275,-0.224868498027,0.498501759791,-0.802693827944,-0.0975536858434,-0.41676349203,1.0266127255,-0.615131795589,0.0108932089828,-0.440208513986,0.280999478236,-0.0737076875453,-0.0330299777134,0.266111895354,0.233923843994,-0.0966801185706,0.0805690372998,0.0696470028231,-0.0539020896022,-0.155697669753,0.0640678722788,0.00491044907061,-0.0917319089329,-0.163351157636,-0.0497326029266,0.203140215719,-0.187058728603,-0.0415398208217,-0.264147859092,0.111546071081,-0.188436394647,0.0467946993881,0.152579010391,0.0148634247626,0.00432344496817,0.0131527826569,-0.0242454313889],[-27380.2535699,-1205.14989493,1107.03565367,-1144.61669943,71.4959881218,1209.81741584,-583.249687539,1095.13288819,324.848818729,92.4574261807,-811.273476261,505.753675068,218.220579426,35.4407350402,112.831299632,-283.530906029,67.9508002698,-251.837996102,69.3844453086,265.863416936,15.9690180625,6.47543792532,63.9921839893,-106.920143887,134.733156142,-5.80929182646,41.7951501865,-19.732549043,132.37199193,-46.5107089437,9.29278293546,18.996119921,-28.7232449199,23.2171220391,-27.1118683506,8.15826689791,-2.77330591765,-21.2257410722,-11.8861152634,9.32728791396,-16.7290944749,-23.1922611561,44.7782223372,-24.7816861426,42.6075886263,-5.89659952113,10.7743694459,-23.0495726816,1.9044924812,-5.78286386128,-1.37911276014,-7.84036294813,-0.976507792394,-5.09359117313,-7.74944731113,10.2412834865,-7.57382513844,14.5277179126,-5.66471067526,3.63069420425,-3.74748756193,-2.90538114963,2.14368568846,-0.413236383776,-0.00626463536894,-4.98487790837,-0.859010550502,0.968911045174,0.656049271547,-1.29384832887,0.979608021567,-1.55684873175,3.6089327623,-1.64837531654,-0.76743784089,-1.42114507851,0.0488222480351,-0.706609679117,-0.381926459021,-0.235488662499,-0.44194722143,-0.327796365965,-0.639479758938,-1.11790149916,-0.213726423521,0.491054728407,-0.806267482233,-0.08559972452,-0.418642515098,1.05139522267,-0.61217016236,0.00902638692699,-0.44080235903,0.281042828632,-0.0724280236236,-0.0374031635296,0.26026400317,0.2412196139,-0.0980475197832,0.0828398326129,0.0693193828062,-0.0495886083941,-0.151757901827,0.0682555548018,-0.00127873124632,-0.0962399155503,-0.1584801501,-0.0542643675191,0.209141338214,-0.188411798924,-0.0398284777239,-0.26442068028,0.109692773871,-0.188847053403,0.0443374591112,0.151959267729,0.016207687305,0.00397848548991,0.013977008889,-0.0228216278224],[-27379.0725468,-1237.23480115,1112.67755312,-1120.22243148,99.3744127779,1206.30796417,-575.588752602,1071.51080415,317.685645307,73.4431411619,-799.011802085,513.653804507,210.42591123,39.909906745,95.7644435301,-274.751199654,68.7641701727,-251.859297193,73.9332558524,265.555764591,16.5279152013,10.4493881928,66.9576536381,-102.732988645,136.289279702,-9.7887488837,42.1601123806,-18.8404963466,130.168744748,-48.6696406992,10.177290047,19.9759748977,-28.2276999883,22.6801923475,-28.4787452141,8.75299226189,-3.5378402996,-20.9398876286,-11.9816948439,9.13893166452,-17.7610897186,-23.0839407078,45.0665791537,-24.6189894018,42.7015638322,-6.36158565548,11.163161111,-23.2377717039,1.88663165213,-5.97086972393,-1.39981504397,-7.88643985926,-1.13032639708,-5.21553707743,-7.70927336349,10.421559978,-7.63297152619,14.6609445636,-5.56056856941,3.63058862339,-3.7210006181,-2.81010249069,2.22847619712,-0.389011529738,-0.0330889357002,-4.93387737,-0.866175700795,1.00745454258,0.584448409563,-1.32156435847,1.03909151973,-1.58567048092,3.67997065279,-1.61851853399,-0.745725671058,-1.41928754554,0.0594178745891,-0.67960853847,-0.402129044125,-0.26597898704,-0.432714699481,-0.325155824979,-0.636401213976,-1.10395590851,-0.203362467408,0.482220630676,-0.809488137163,-0.072412653785,-0.419252986106,1.0759974751,-0.609625678853,0.0081043822132,-0.440866674655,0.279598931735,-0.0719108231454,-0.0417252325689,0.255364670125,0.248933839141,-0.099746724869,0.0850743432296,0.0685510336094,-0.0455430329194,-0.147949208514,0.0725781120485,-0.00776404653064,-0.100665168417,-0.153205882975,-0.0586332227035,0.215149860939,-0.189770190563,-0.0377245044014,-0.264532311386,0.107571183794,-0.189309664346,0.0418887801454,0.151243769672,0.017768953519,0.00346897554355,0.0147175658455,-0.0214376776477],[-27380.6302089,-1275.03833941,1121.11076825,-1099.24358297,126.234697956,1202.02345666,-567.163896002,1049.58249158,310.191454767,55.1802067861,-786.100953809,521.214880196,202.529392067,44.1777773091,77.8153132144,-266.315625424,70.4703681216,-251.78685945,77.8204235663,265.037800504,17.1732405981,14.7420960654,69.8819563019,-98.4936680078,137.696261893,-13.5867479169,42.7489529939,-18.0417415244,127.781219071,-50.6625246784,11.1639079298,20.8458892729,-27.8272696862,22.1147337349,-29.8526657208,9.30981715654,-4.22458854614,-20.6006272876,-12.0457883646,8.90278140145,-18.7595123006,-22.9280501556,45.2902870115,-24.4632827902,42.7726006635,-6.81900746,11.5846531096,-23.4214676389,1.86567302904,-6.15297064806,-1.40906425297,-7.91764589239,-1.30039253457,-5.33538994531,-7.65598381604,10.5908295104,-7.7002543146,14.7826629847,-5.45795609562,3.63891379263,-3.69360608134,-2.71691070873,2.30386948113,-0.363626100429,-0.0631569741614,-4.88314178696,-0.868176014292,1.04484350035,0.506951815612,-1.34890596385,1.09921526245,-1.61405504428,3.74972119376,-1.58942116375,-0.717937850203,-1.41584759032,0.0674728477851,-0.656050353557,-0.421685605048,-0.293352789203,-0.423866900193,-0.323766780311,-0.634592067901,-1.08952732152,-0.193678201647,0.472087350381,-0.812152094256,-0.0581219594857,-0.418518413591,1.10062491872,-0.60752833933,0.00820560264675,-0.440421393144,0.276680839766,-0.0721945661865,-0.0459720144974,0.251504653551,0.257025509877,-0.101771203937,0.0872704525428,0.0673302570829,-0.0417676551805,-0.144248342748,0.0770030101763,-0.0145077049447,-0.104962750518,-0.147474476991,-0.0627513688861,0.221166103222,-0.191118259331,-0.0352253770411,-0.264482236559,0.105191444203,-0.189793491063,0.0394638949249,0.150442187764,0.0195239704935,0.00278089901909,0.0153801590802,-0.0200887768567],[-27383.8596947,-1316.06143218,1130.63291496,-1081.38327697,152.291694218,1197.21853193,-557.813973814,1029.78961842,302.549816116,37.6336629181,-772.866907712,528.595893122,194.596430447,48.2227893197,58.9846090886,-258.23909449,72.9584663509,-251.578594583,81.0124450452,264.307974862,17.8850043082,19.3239855056,72.8548017284,-94.2877501171,138.964915122,-17.2087649071,43.5341375017,-17.3036960038,125.224249075,-52.483298188,12.2619454521,21.6302813326,-27.5330482765,21.5119804117,-31.2278107162,9.82119668871,-4.83408181773,-20.2166738256,-12.0794189234,8.62142473294,-19.7132603779,-22.7276439833,45.4519988407,-24.3107545548,42.8159495294,-7.26308963618,12.0390734482,-23.5997873883,1.8414746801,-6.32820028923,-1.40686428056,-7.93296579773,-1.48453826664,-5.45181349381,-7.58695177343,10.7475310511,-7.77405290081,14.8920039379,-5.356580412,3.6558290613,-3.66575399529,-2.6246138166,2.36917777382,-0.336915888091,-0.0960861710385,-4.83340869504,-0.865135343684,1.08173303701,0.424797450725,-1.37508908024,1.15972811553,-1.64094170593,3.81784701503,-1.56097669634,-0.684177642354,-1.41093432303,0.0734330191718,-0.636182091019,-0.440268908317,-0.317478144873,-0.415357041794,-0.323732540103,-0.633869172615,-1.07469676617,-0.184558225823,0.460761313578,-0.814040987346,-0.0428801364062,-0.416394826804,1.12548344301,-0.605888852397,0.00941482605489,-0.439488973389,0.272337634676,-0.0732427634924,-0.050118748768,0.248752426039,0.265470186291,-0.104112085178,0.0894304473676,0.0656476413704,-0.0382669535964,-0.140620421668,0.0814989145791,-0.0214625191703,-0.109084528474,-0.141245831705,-0.0665179753045,0.227184440105,-0.19244109746,-0.0323436053111,-0.264270187474,0.102575545689,-0.190256645159,0.0370753558805,0.149568239495,0.02144955981,0.00190046107259,0.0159722276823,-0.0187669260966],[-27387.6941426,-1357.80500192,1139.54160912,-1066.34463654,177.760252123,1192.14782859,-547.377842116,1012.57385262,294.944298365,20.7685494228,-759.635640075,535.955834273,186.692434878,52.0233853637,39.2730315568,-250.536518005,76.1175370948,-251.192414298,83.4758168841,263.364737853,18.6432163869,24.1654804759,75.965899665,-90.2008031135,140.1060518,-20.6602758356,44.4881313794,-16.5937712122,122.512668938,-54.1258985351,13.4807114824,22.3535693626,-27.3561300221,20.8631665881,-32.5983610457,10.2795859653,-5.36685127482,-19.796741019,-12.0836096181,8.29744926721,-20.6112321077,-22.4857766747,45.5543675714,-24.1575929426,42.8268608393,-7.68805688553,12.5266501335,-23.771857854,1.81389467349,-6.49559230302,-1.39321902016,-7.93138432549,-1.68059565508,-5.56347143998,-7.49955034032,10.8901035675,-7.85274668198,14.9880981856,-5.25614867667,3.68149377872,-3.6378944036,-2.53201982715,2.42371330855,-0.30871668497,-0.131493946617,-4.78541563003,-0.857177541662,1.11877827105,0.339223275931,-1.39932964289,1.22037894482,-1.66526975,3.88401074646,-1.53307862232,-0.64454831154,-1.40465685386,0.0777442402982,-0.620250717496,-0.457551720459,-0.338223129931,-0.407138342508,-0.325156412493,-0.634049380022,-1.05954527046,-0.17588713952,0.448348946322,-0.814936450265,-0.0268396793304,-0.412838254997,1.15077893744,-0.604717926659,0.0118168302649,-0.438091874279,0.266618398416,-0.075018925809,-0.0541406748331,0.247176460181,0.274243428563,-0.106760496781,0.0915566145192,0.0634937746153,-0.0350454065863,-0.13703056241,0.0860344906511,-0.0285813018894,-0.112982368903,-0.134479846674,-0.0698322111965,0.233199246625,-0.19372379718,-0.0290916988796,-0.263895895807,0.0997454788405,-0.19065723824,0.0347357154434,0.148635642354,0.0235225430498,0.000813866860123,0.0165012107412,-0.0174641260146],[-27391.0666912,-1397.76997107,1146.13446664,-1053.83078474,202.855222232,1187.06598526,-535.694356985,998.37686211,287.558470522,4.54990616516,-746.733127179,543.453694637,178.882813867,55.5580080283,18.6812810233,-243.222807119,79.8366525878,-250.586230305,85.1770356779,262.206539662,19.4278868897,29.2370049387,79.3049598591,-86.3183951379,141.130484334,-23.9467566835,45.5834001024,-15.8793785768,119.661312839,-55.5842630263,14.8295148888,23.0401716489,-27.307609186,20.1595264746,-33.9584975548,10.6774400931,-5.82342807788,-19.349542644,-12.0593835464,7.93344261245,-21.4423256469,-22.2055027134,45.6000461337,-23.9999862007,42.8005850025,-8.08813390957,13.0476111718,-23.9368059377,1.7827910774,-6.65418034501,-1.36813236519,-7.91188622587,-1.88639676167,-5.66902750086,-7.39115262134,11.0169860272,-7.93471505524,15.0700764898,-5.15636804776,3.71606729419,-3.61047734993,-2.43793675321,2.46678831868,-0.278864283308,-0.168997721184,-4.73990012771,-0.844426460918,1.156634321,0.251467252261,-1.42084358705,1.28091661616,-1.68597846058,3.94787501787,-1.5056204322,-0.599153121787,-1.397124293,0.0808523627129,-0.60850319963,-0.473206807999,-0.355455820259,-0.399164020563,-0.328141705623,-0.634949542025,-1.0441538624,-0.167549542324,0.434956674671,-0.814620116846,-0.0101530830424,-0.407804727419,1.17671729149,-0.604026270724,0.0154963931039,-0.436252554703,0.259572212937,-0.0774865638818,-0.0580130321455,0.24684522857,0.283320796876,-0.109707566935,0.0936512408127,0.0608592449614,-0.0321074925693,-0.133443882115,0.0905784037861,-0.0358168657839,-0.116608138423,-0.127136421455,-0.0725932457997,0.239204897825,-0.194951450722,-0.0254821674147,-0.263359093236,0.0967232342496,-0.19095338191,0.0324575260447,0.14765811383,0.0257197417944,-0.00049267846224,0.0169745473461,-0.0161723772579],[-27392.8957245,-1434.02884221,1149.14947269,-1043.53276976,227.708507566,1182.10258775,-522.690554428,987.470566839,280.574738173,-11.0547146193,-734.446837374,551.190469633,171.23949239,58.8110511011,-2.77248760378,-236.30529898,84.009965343,-249.723166963,86.0858353626,260.83129444,20.2113265005,34.5088463177,82.9418444012,-82.7165176362,142.050110555,-27.0718671928,46.792352916,-15.135837377,116.688960598,-56.858208693,16.3154779426,23.7153339445,-27.3931084976,19.3943097387,-35.3062429745,11.0087642638,-6.20504041402,-18.8823890876,-12.0094144976,7.53462885094,-22.1991503104,-21.8893907776,45.5922636075,-23.8337673018,42.7336126659,-8.45910699112,13.6017535775,-24.0937128917,1.74769086565,-6.80322548348,-1.33146478485,-7.87393522013,-2.09922432118,-5.76787292053,-7.25962760874,11.1273061156,-8.01836908278,15.1376639164,-5.05696975548,3.75954753929,-3.58385724798,-2.34116787794,2.49790772974,-0.247393273359,-0.208173935521,-4.69748727511,-0.827025819478,1.19598878356,0.162632749031,-1.43885588767,1.3411003486,-1.70214131467,4.00921361775,-1.47844178504,-0.548204183601,-1.38835071953,0.0832355843379,-0.6010330722,-0.487001349697,-0.369180959817,-0.391405027493,-0.332752042988,-0.636406640892,-1.02859074631,-0.159420093415,0.420682493933,-0.812889058958,0.00699113890683,-0.401270002981,1.20345771395,-0.603794955993,0.0204904385261,-0.434007523769,0.251285673825,-0.0805912888521,-0.0617384870856,0.247785782303,0.292684760286,-0.112944119599,0.0957163407776,0.0577425294298,-0.0294632413322,-0.129827566936,0.0950955389055,-0.0431261885538,-0.119922430979,-0.119203988431,-0.0747101077201,0.24519130536,-0.196104771118,-0.0215331614903,-0.26265974306,0.0935370494058,-0.191100321737,0.0302495400541,0.146650107056,0.0280219614576,-0.00202714827978,0.017402807973,-0.0148844122255],[-27392.040609,-1466.94043826,1149.08608964,-1035.09334011,252.120220987,1176.88701064,-508.646190182,979.447894713,274.170853205,-26.0677112129,-722.910207284,559.035172405,163.860461282,61.7907131721,-25.0003013989,-229.761034704,88.5519489886,-248.587199231,86.1848992382,259.234772185,20.9350484188,39.9507458817,86.8670247526,-79.4328552751,142.881169984,-30.0320021492,48.0871741449,-14.3700982991,113.630174606,-57.9710714646,17.9369765272,24.4076118718,-27.5963645527,18.5688278774,-36.6549875795,11.2737640077,-6.51570457697,-18.3969771785,-11.9429790258,7.11677796129,-22.8891600441,-21.5380663223,45.5365536714,-23.6533481224,42.6273954264,-8.80300873829,14.1871503967,-24.24147737,1.70679663477,-6.9428984375,-1.28250305148,-7.81891091363,-2.31416376035,-5.86230905108,-7.10482784504,11.2229463913,-8.10224648681,15.1929627458,-4.95778131836,3.81128677467,-3.55800599177,-2.24049756574,2.51734723613,-0.215133437417,-0.248435112401,-4.65835236426,-0.80519879671,1.2376591682,0.0732847687092,-1.45262767864,1.40073077418,-1.71336856081,4.06824496928,-1.45116701384,-0.492348993386,-1.37797008796,0.0855014885868,-0.597320142545,-0.499080173244,-0.379949964864,-0.383903248072,-0.338892309516,-0.638338180352,-1.01287283188,-0.151333690369,0.405590676425,-0.809602100613,0.0242603978986,-0.393288759235,1.2309726909,-0.603886505047,0.0266444749925,-0.431449491459,0.241995431208,-0.0842071134432,-0.0654294137451,0.249859486501,0.302345423356,-0.116459761804,0.0977528398009,0.0541736605524,-0.0271448881324,-0.12615707909,0.09953565904,-0.0504829079726,-0.122920749823,-0.110785111296,-0.0761312630368,0.251130527353,-0.197146954604,-0.017285395304,-0.261798735071,0.0902401493964,-0.191041839135,0.0281053095964,0.145629017741,0.0304259427839,-0.00377423014318,0.0178090886447,-0.013595890323],[-27387.3459568,-1497.43516225,1146.88414913,-1028.14316945,275.807527819,1170.92357572,-493.929199917,973.732025634,268.523404086,-40.508969527,-712.218165606,566.798820529,156.850227849,64.511144032,-47.8967329325,-223.559481406,93.3821574314,-247.167514721,85.4601479456,257.412206859,21.5328664729,45.5323083607,91.0511247173,-76.4955160264,143.640987563,-32.8217400991,49.4399918836,-13.5970198812,110.523462898,-58.9520669948,19.6901999288,25.1463885201,-27.8956424135,17.6864078448,-38.02196353,11.4741949398,-6.76013388714,-17.8936003563,-11.8710043769,6.69829639619,-23.5235199517,-21.1516689972,45.4390261539,-23.4527852647,42.4846251185,-9.12343334048,14.8014436834,-24.3789523772,1.65797988692,-7.07359733889,-1.22039051319,-7.74867188282,-2.52575117891,-5.95536477163,-6.92710176037,11.3064781305,-8.18491665461,15.238669562,-4.85865432705,3.87047584323,-3.53279984536,-2.13470545127,2.52557522442,-0.183113355785,-0.289152795092,-4.62255823841,-0.779188437319,1.2824954626,-0.0161462779489,-1.46142913354,1.45961887817,-1.71940464041,4.12529865426,-1.42336662012,-0.43234389402,-1.36552132173,0.0882900052463,-0.596690786143,-0.509682518564,-0.388450919736,-0.376718300382,-0.346427705492,-0.640681794497,-0.997004205125,-0.143115290359,0.389737063718,-0.804633503859,0.0412860865471,-0.383935403391,1.25918802773,-0.604133803263,0.0337561570913,-0.428685217971,0.231975648847,-0.0881901507738,-0.0692256131433,0.252886284791,0.312319799527,-0.120243796352,0.0997613909842,0.050190559739,-0.0251902195951,-0.122409949808,0.103844746747,-0.0578648268317,-0.125607325533,-0.102010886574,-0.076815037197,0.256990158545,-0.198036818217,-0.0127852239588,-0.260777190683,0.0868920062083,-0.190718849485,0.0260145867348,0.144612977236,0.0329324103499,-0.00571279014446,0.0182196167704,-0.0123032027077],[-27377.6563798,-1526.44341724,1143.48348281,-1022.31293139,298.487593384,1163.71660476,-478.9075193,969.746139503,263.80897928,-54.3983754733,-702.465641034,574.292431581,150.313299392,66.9864934715,-71.3563547749,-217.670106197,98.4201445783,-245.453301044,83.8975021257,255.358832425,21.9385944911,51.2231384846,95.4647680996,-73.9326078617,144.346888236,-35.4356595893,50.8229342268,-12.8314606617,107.40733351,-59.8304109374,21.5713374336,25.9610469789,-28.2692071423,16.7503765951,-39.4244029863,11.6118126751,-6.94304166491,-17.3725520602,-11.8044177965,6.29759060831,-24.113395137,-20.7303384518,45.3057908834,-23.2261353308,42.3079935765,-9.42397498713,15.4422754916,-24.5049909176,1.59911212429,-7.19572031943,-1.14427051811,-7.6650767041,-2.72852267659,-6.0500689613,-6.72679778484,11.38047261,-8.26494897342,15.2774809488,-4.75944037218,3.93630558785,-3.50811507284,-2.02257116925,2.52306008121,-0.152361608766,-0.329698526864,-4.59016774082,-0.749237786008,1.33134765442,-0.105229980189,-1.46453042596,1.51757564582,-1.71999399489,4.1807042545,-1.3946111054,-0.368945228385,-1.35054334423,0.092241064103,-0.59847137847,-0.519047625581,-0.395371908767,-0.369909802503,-0.355223431197,-0.643375117421,-0.980988952068,-0.134589850557,0.373177497382,-0.797857530744,0.0576995974667,-0.373284342661,1.28802952984,-0.604369736018,0.0416231394102,-0.425821463507,0.221500490505,-0.0923965139628,-0.0732668862998,0.2566861208,0.322624902239,-0.124285526042,0.101742647429,0.045831148399,-0.0236370223455,-0.118563710323,0.107968784585,-0.0652497479228,-0.127986388686,-0.0930124107856,-0.0767197556482,0.262737793675,-0.198733178994,-0.00807900255804,-0.259596231313,0.0835520918286,-0.190072268162,0.0239671235326,0.143620116894,0.0355420887324,-0.00782169437567,0.0186606197598,-0.0110027405371],[-27361.8164903,-1554.89560624,1139.82392233,-1017.23329958,319.877583005,1154.77041954,-463.949084001,966.913416223,260.204167253,-67.7558149633,-693.747562263,581.327023136,144.354183214,69.2309112812,-95.2737394966,-212.06237619,103.585464336,-243.43374581,81.4828824197,253.069882845,22.0860463014,56.9928409836,100.078578703,-71.7722387528,145.016196944,-37.8683391662,52.208129269,-12.0882791786,104.320294475,-60.6353189462,23.5765783279,26.8809703375,-28.6953238013,15.7640610826,-40.8795381086,11.6883728287,-7.06914123069,-16.8341257296,-11.7541465302,5.93306705033,-24.6699507035,-20.2742143355,45.1429576884,-22.9674549231,42.100192635,-9.70822786766,16.1072878751,-24.6184459959,1.52806484903,-7.30966551092,-1.05328641434,-7.5699839539,-2.91701435312,-6.14945049921,-6.50426434856,11.447501106,-8.34091283049,15.3120934903,-4.65999104438,4.00796685145,-3.48382793828,-1.90287435436,2.51027019308,-0.123906776664,-0.369443850985,-4.56124371476,-0.715589887481,1.38506573135,-0.193535927254,-1.46120172951,1.57441206241,-1.71488106568,4.23479135184,-1.36447097118,-0.30290933936,-1.33257507889,0.0979945949436,-0.601988295005,-0.527414734219,-0.401401016293,-0.363537372518,-0.365144686917,-0.646355783215,-0.964831158727,-0.125582328134,0.355967818988,-0.789148443316,0.0731323232716,-0.361409984255,1.31742300261,-0.604427188688,0.0500430765373,-0.422964988264,0.210844119944,-0.0966823161289,-0.077693034234,0.261078938153,0.33327774493,-0.128574253675,0.103697262236,0.041133347942,-0.0225230830086,-0.114595891867,0.111853755112,-0.0726154740374,-0.13006216986,-0.083920780453,-0.0758037438376,0.268341027484,-0.199194853973,-0.00321308620494,-0.258256978374,0.0802798782439,-0.189043010546,0.0219526720533,0.142668568066,0.0382557025083,-0.0100798089288,0.0191583250223,-0.00969089496835],[-27339.3094692,-1583.33186833,1136.67671768,-1012.61779921,339.851979475,1143.75807042,-449.351898693,964.723914398,257.851806825,-80.6027292512,-686.11381886,587.737969148,139.00002297,71.2654647514,-119.521053332,-206.704303447,108.825499509,-241.117023965,78.2382975787,250.550518283,21.9505344223,62.8156148434,104.85406257,-70.05286252,145.65744144,-40.1115668294,53.5695028401,-11.3782248132,101.299858482,-61.3876480972,25.6975908968,27.9276614008,-29.1570318004,14.7356353843,-42.3992186719,11.7047396378,-7.14071967736,-16.2792185141,-11.7285037141,5.62376579725,-25.202347343,-19.7846845334,44.957599667,-22.6723609618,41.8661273398,-9.97897298735,16.7937216736,-24.7190122138,1.4425349748,-7.41547534846,-0.947225410641,-7.46502611046,-3.08567892313,-6.25571509589,-6.26004411104,11.5100983165,-8.4111525575,15.3454530593,-4.55953300496,4.08491066386,-3.45953273007,-1.77475844962,2.48779124478,-0.0987548609361,-0.408013258739,-4.53569878645,-0.678564695723,1.44444750213,-0.280752553109,-1.45075427732,1.63000017755,-1.70389530747,4.28800220817,-1.33255368526,-0.234783768847,-1.3112063673,0.106034264502,-0.606548417359,-0.534937173228,-0.407229360168,-0.35766422008,-0.37611768419,-0.649600942081,-0.948543136009,-0.115970378065,0.338196008476,-0.778359822146,0.0872854058237,-0.348357008056,1.34729466943,-0.604139126253,0.058884943401,-0.420153669609,0.200278604264,-0.100881961333,-0.0825752099691,0.265885412423,0.344270501251,-0.133095900189,0.105627810205,0.0361242230145,-0.021881642496,-0.110504574856,0.115441958486,-0.0799364446271,-0.131836038403,-0.0748576213328,-0.0740396504845,0.273774524461,-0.199378781222,0.00177789117505,-0.256751892428,0.0771342890164,-0.187582489524,0.0199609691109,0.141779124807,0.0410625165326,-0.0124594019759,0.0197373317756,-0.00836515215986],[-27312.1727745,-1610.73128675,1134.13879225,-1008.5113617,358.914535458,1131.02752202,-435.134244068,962.935207438,256.759738235,-92.9667809614,-679.434143884,593.458069082,133.968507712,73.138891171,-143.880837175,-201.558079829,114.198948487,-238.58725979,74.3301087952,247.84560371,21.673366132,68.6840360737,109.716254684,-68.854316378,146.243960712,-42.1459683908,54.8881717111,-10.6956103184,98.3795568407,-62.0748211548,27.9079594211,29.091101834,-29.6564679389,13.692662069,-43.97376491,11.6582118285,-7.15035918775,-15.7111424038,-11.7253460468,5.39126141325,-25.7117280986,-19.2681298714,44.7606429963,-22.3427116399,41.619555583,-10.235738615,17.4972128688,-24.8097505631,1.33952106104,-7.51176948035,-0.828450158285,-7.35093125931,-3.22863556091,-6.36777578761,-5.9954566493,11.5706526241,-8.47311226384,15.3815026837,-4.45479319794,4.16762880273,-3.43369583382,-1.63882213143,2.45667811378,-0.0778215476573,-0.446043033473,-4.51284471393,-0.638789801842,1.51008205987,-0.367043670587,-1.4326635407,1.68445629826,-1.68720622811,4.34122980585,-1.29861458057,-0.164280854835,-1.28623072389,0.116218687303,-0.611380651687,-0.541424626656,-0.413560192317,-0.352367921121,-0.388312679572,-0.653245808653,-0.932170094371,-0.10584244652,0.320078599261,-0.765262521902,0.100138983975,-0.334051184631,1.37757242567,-0.603338832099,0.0683029962916,-0.417149853569,0.19006762392,-0.104743017401,-0.0877099745428,0.27092914696,0.355495985689,-0.137822859071,0.107544552923,0.0307874112106,-0.0217277588651,-0.106370036442,0.118660965264,-0.0871736457835,-0.133297918735,-0.0659066761189,-0.0714574173949,0.279041228094,-0.199234382937,0.00690618036758,-0.255038790614,0.074172054008,-0.185684108019,0.0179816905229,0.140983231983,0.0439059567742,-0.0149063500089,0.0204157264718,-0.00702737827333],[-27283.082433,-1635.68268079,1132.13848774,-1005.04177006,377.726321093,1117.09546754,-421.244469824,961.371747459,256.902052075,-104.877188061,-673.533231264,598.444478779,128.899962844,74.9068453285,-168.113225582,-196.584442146,119.79233856,-235.947564901,69.960765372,245.009930301,21.4373473988,74.5952749399,114.581072271,-68.2667833905,146.740296559,-43.9493791153,56.1470503883,-10.0306392904,95.5919255124,-62.6759023054,30.1767471804,30.3533930181,-30.2005433641,12.6675508281,-45.5881146713,11.5451967489,-7.08821571719,-15.1338130989,-11.739916117,5.25776208482,-26.1972316015,-18.732179411,44.5639771229,-21.9819254685,41.3764484677,-10.4772398352,18.2129962281,-24.8945636331,1.21584707866,-7.59681185817,-0.699967169176,-7.22820138779,-3.33992005564,-6.48372244204,-5.71201576975,11.6315158328,-8.52401100329,15.4244346804,-4.34187363798,4.25687323264,-3.40450165948,-1.4960278845,2.4181029757,-0.0619999440569,-0.484422406549,-4.49184303824,-0.596969706228,1.58250631876,-0.45269193724,-1.40644605051,1.73795779594,-1.66506834873,4.39547980728,-1.26244595629,-0.0909041343358,-1.25749258126,0.128250214817,-0.615694410275,-0.546600867379,-0.421099798182,-0.347729643146,-0.401960940876,-0.657465113672,-0.915765469158,-0.0953396774709,0.301864263133,-0.749606715772,0.111742945825,-0.318388557217,1.40818458468,-0.601859669218,0.0785228118399,-0.413647003336,0.180472762705,-0.107991343102,-0.0928252409967,0.27603447706,0.366822172941,-0.142724141945,0.109459673674,0.0250956933613,-0.0220719444597,-0.102293102961,0.121434663605,-0.0942847002579,-0.13443487405,-0.0571422167398,-0.0681013096471,0.284151151619,-0.198709202344,0.0121957533361,-0.253066829216,0.071449354656,-0.183351766465,0.0160044968575,0.140314997162,0.0467179894803,-0.0173599315997,0.021209967371,-0.00568053447143],[-27254.7144717,-1656.77486972,1130.60414589,-1002.33680727,396.948406513,1102.47860019,-407.630925657,959.857986573,258.25283894,-116.363168517,-668.235774929,602.65435408,123.434713768,76.6249820126,-191.97835311,-191.744127209,125.692197016,-233.301050915,65.3327166119,242.098289229,21.4252841912,80.5465017073,119.364432551,-68.3804466206,147.110990779,-45.4996342677,57.329053378,-9.37351532514,92.9695004602,-63.1699557357,32.4730174542,31.6966363336,-30.7961692227,11.6927113534,-47.2272058042,11.3621017475,-6.94444522101,-14.5511462996,-11.7674565137,5.24547599846,-26.6579964827,-18.1844622136,44.3794914937,-21.5934209585,41.1527770975,-10.7021917326,18.9363065189,-24.9773540129,1.06833699859,-7.66886643354,-0.564782955221,-7.09733848324,-3.41356819653,-6.60164492687,-5.4112352788,11.6950397466,-8.56106782966,15.4784413661,-4.21687633976,4.35339591816,-3.37013461699,-1.34733819355,2.37323800616,-0.052183157364,-0.524040609329,-4.47185530038,-0.55380890927,1.66225719297,-0.53798001062,-1.3716183376,1.79068204196,-1.63773619044,4.4517578749,-1.22384011164,-0.0141571443614,-1.22483637203,0.141831198515,-0.618699105411,-0.55018966827,-0.430554463206,-0.343830553659,-0.417293735913,-0.662433587881,-0.899382695715,-0.0846032148903,0.283801671877,-0.731142576948,0.122147179474,-0.301265169052,1.43905945981,-0.599535000601,0.0897699666765,-0.409338582103,0.171755604411,-0.110352797206,-0.0976489223723,0.281025738016,0.378117037706,-0.147768760436,0.111385355743,0.0190218502975,-0.0229247116235,-0.0983746007487,0.123686941669,-0.101227230802,-0.135233967538,-0.048638515124,-0.0640155923191,0.289114308273,-0.197750782671,0.017670582044,-0.25078516452,0.0690223723977,-0.180589365295,0.0140190486829,0.139808527912,0.0494305808978,-0.0197594253202,0.0221365127335,-0.00432758191678],[-27229.7449175,-1672.59667283,1129.46410841,-1000.52425633,417.241861855,1087.69361315,-394.241961264,958.218376896,260.786189422,-127.453940297,-663.36646881,606.044850828,117.21308589,78.3489560117,-215.236354317,-186.997871828,131.985051143,-230.750829447,60.6484118177,239.165471669,21.8199824775,86.5348866415,123.982252749,-69.285489132,147.32058517,-46.7745691131,58.4170951866,-8.71444201862,90.5448176468,-63.5360456322,34.7658335222,33.1029331613,-31.450256662,10.8005533363,-48.8759761573,11.1053341723,-6.70920365452,-13.9670577061,-11.8032098258,5.37661134067,-27.0931613735,-17.6326073408,44.2190755553,-21.1806166211,40.9645125757,-10.9093093919,19.6623785086,-25.0620242916,0.893814791719,-7.72619715803,-0.425904028324,-6.95884453302,-3.44361577275,-6.71963310978,-5.09462898288,11.7635761694,-8.58150179675,15.5477150576,-4.07590331798,4.45794882389,-3.32877911629,-1.19371554331,2.32325538081,-0.0492642948079,-0.565786873174,-4.45204304136,-0.510011911357,1.74987159669,-0.623190548279,-1.32769693282,1.84280640769,-1.60546427438,4.51106967115,-1.18258934581,0.0664565780767,-1.18810652881,0.15666398987,-0.619604149385,-0.551914802205,-0.442630472832,-0.340751820164,-0.434542332495,-0.668325962022,-0.883075209385,-0.0737742027494,0.266139497279,-0.709620278618,0.131401573022,-0.282577063373,1.47012536442,-0.596198189237,0.102270037432,-0.403918053063,0.164177732831,-0.111553238479,-0.101908931711,0.285727265125,0.38924855468,-0.15292572617,0.113333782413,0.0125386628502,-0.0242965727003,-0.094715356141,0.125341687612,-0.107958860167,-0.135682262392,-0.0404698432,-0.0592445304888,0.293940711295,-0.196306667145,0.0233546384547,-0.248142952811,0.06694728867,-0.177400804941,0.0120150065674,0.139497931801,0.0519756972741,-0.0220441097422,0.0232118208196,-0.00297148177204],[-27210.5118078,-1682.24451633,1128.68791509,-999.743417707,438.975131014,1073.11908726,-381.04352858,956.35156651,264.506418057,-138.225389759,-658.775127029,608.590857003,109.900440133,80.1219637555,-237.702928431,-182.31136476,138.734557308,-228.383418238,56.0840165638,236.243461272,22.7716114164,92.5427488067,128.359233233,-71.0484941226,147.338545236,-47.7550384229,59.4003459577,-8.04617114659,88.3412484075,-63.7555140167,37.0263126017,34.5561425785,-32.1666846286,10.0212047368,-50.5239051824,10.7706416764,-6.37480707935,-13.3845562013,-11.8423966237,5.6687001703,-27.5016107206,-17.0830764532,44.0938142834,-20.7468705359,40.8263312778,-11.0975113818,20.3866428386,-25.1522522729,0.689204855434,-7.76756656343,-0.285900408199,-6.81290761114,-3.42488879536,-6.83606720698,-4.76349851165,11.8392440508,-8.5830729473,15.6360463707,-3.91591721018,4.57116871267,-3.27912540157,-1.0361068694,2.26921446123,-0.0541511039374,-0.610541564518,-4.43178635859,-0.466058246633,1.84575217556,-0.708565462925,-1.27421438152,1.89447298074,-1.56850705551,4.57430815235,-1.13856334572,0.151350560787,-1.14724390693,0.172502941895,-0.617717936717,-0.551545038408,-0.457940746111,-0.338564123652,-0.453952334544,-0.675305800136,-0.866873351833,-0.0629717111055,0.249059079534,-0.684823587834,0.139541457382,-0.262225016432,1.50129467922,-0.591736933505,0.116241211383,-0.397145273909,0.157951207555,-0.111346124303,-0.105389881145,0.289980849111,0.400109880644,-0.158166400433,0.115324675459,0.00560761836588,-0.0262000453855,-0.0914014196619,0.126330353537,-0.114449843143,-0.135766505152,-0.0327140442032,-0.0538171233196,0.298629662334,-0.19434468982,0.0292699202645,-0.245106153015,0.0652687837007,-0.173793245551,0.00998390637936,0.139414906672,0.0543002939046,-0.0241614159183,0.0244485693653,-0.00161982805997],[-27198.001222,-1686.84525426,1128.40989794,-1000.17966183,461.346152929,1058.58115388,-368.071988482,954.45298738,269.538735144,-148.940076834,-654.41204448,610.338189135,101.262279511,81.9373682386,-259.416033361,-177.670102541,145.912888191,-226.218959531,51.710561512,233.273011596,24.2997929281,98.4930024629,132.455206958,-73.6416453283,147.154031307,-48.4339749959,60.2929983844,-7.37164720362,86.345505568,-63.8188142522,39.2337876608,36.0471544494,-32.9372032682,9.37566658826,-52.1786387449,10.3511331319,-5.94221198227,-12.8030233988,-11.8801494034,6.12057003576,-27.8812122341,-16.5376616086,44.0115747698,-20.295299057,40.7477306686,-11.2665302074,21.1053136468,-25.250816618,0.451833292934,-7.79373150217,-0.145596145792,-6.65846013832,-3.35537416279,-6.95048882876,-4.41829678784,11.9232309214,-8.56570527983,15.7456191177,-3.73732314553,4.69323154042,-3.22188705406,-0.875396911093,2.2117233529,-0.0678098935794,-0.659149590091,-4.411339575,-0.421527584254,1.949764501,-0.794183687897,-1.21076728705,1.94568271347,-1.52711872417,4.64191545043,-1.0919413492,0.240606590859,-1.10257505252,0.189310413774,-0.612744790865,-0.549029131508,-0.476724736518,-0.337296199063,-0.475826690428,-0.683491999468,-0.850715089998,-0.0522265143574,0.232472432451,-0.656670647084,0.146543934731,-0.240128736529,1.53241605435,-0.586256273336,0.131872118383,-0.389045680337,0.153089991361,-0.109595306499,-0.108103179165,0.293698102414,0.410694900716,-0.163471543162,0.117407910607,-0.00185496974733,-0.0286556687804,-0.0884597385872,0.126614647322,-0.120720962668,-0.135472175758,-0.0254632465977,-0.0477013063155,0.3031376167,-0.191913848057,0.0354305281012,-0.241707934635,0.0639855328786,-0.169786886132,0.00792478518827,0.139581511462,0.056411282278,-0.0260913848236,0.025844314009,-0.000298746243819],[-27192.8612496,-1688.03334756,1128.80558704,-1002.0298766,483.260240298,1043.767832,-355.381304085,952.792267441,276.038574924,-159.907229842,-650.252636251,611.350395896,91.089142558,83.7760740967,-280.469191688,-173.064533654,153.469345551,-224.261001693,47.5727935954,230.172068679,26.3915121233,104.293710669,136.238790026,-77.0135266197,146.761127421,-48.8073311372,61.1155007969,-6.69636286401,84.5351373269,-63.718677537,41.3696456056,37.5686163346,-33.7505305263,8.88265819216,-53.8523643137,9.83925771576,-5.41453495634,-12.2209340947,-11.9115786425,6.7263723578,-28.2295794398,-15.9969874642,43.9794196349,-19.8289581074,40.7369134848,-11.416301858,21.814800945,-25.3602712025,0.179126633882,-7.80594740687,-0.00537879985627,-6.49412062196,-3.23384899533,-7.06272993394,-4.05926455746,12.0164914576,-8.5298637818,15.8782154097,-3.54138687602,4.82419806133,-3.15828348924,-0.712454858558,2.15127734726,-0.0912216128808,-0.71244699169,-4.39117556988,-0.37577462713,2.06163987588,-0.88008341169,-1.13696826726,1.99640127447,-1.48155340456,4.71422099124,-1.04297998177,0.334223520203,-1.05452293445,0.207100766235,-0.604488017519,-0.544360832485,-0.499128531137,-0.336966294825,-0.500482684625,-0.692992290562,-0.834515297137,-0.0415473129892,0.216224238249,-0.625113192719,0.152371550059,-0.216212664979,1.56332220728,-0.579915584048,0.149343998935,-0.379711102541,0.149558522825,-0.1061922355,-0.110116933352,0.296808092902,0.421022682094,-0.168824263957,0.119640902073,-0.00994408156574,-0.0316859873379,-0.0859024843809,0.126163840788,-0.12680563372,-0.134784437499,-0.0188131501547,-0.0408497490656,0.307410318114,-0.189083430046,0.0418485883255,-0.237998269814,0.063084710383,-0.165405185405,0.00583855536374,0.140017395383,0.0583305629312,-0.0278222099138,0.0273928298647,0.000961005353049],[-27195.7399805,-1687.44325721,1130.05051247,-1005.49094992,503.62270582,1028.36714063,-343.025438502,951.639034626,284.161371639,-171.436077106,-646.272317426,611.691025953,79.17156781,85.6189859653,-300.955925993,-168.485106582,161.353231148,-222.513093089,43.7154597476,226.858578557,29.0337541127,109.852936483,139.678598537,-81.1127218675,146.153917614,-48.8710591523,61.8883015257,-6.02581080204,82.8876918823,-63.4478350691,43.4152733418,39.113175795,-34.5953843483,8.56089885013,-55.5572693574,9.22746460478,-4.7948925946,-11.6367630854,-11.9317948185,7.48025855717,-28.5443258634,-15.4616786771,44.0044114994,-19.3509036099,40.8020824635,-11.5467623228,22.5115147453,-25.4831699019,-0.131488592059,-7.80546971013,0.134364070853,-6.31850756944,-3.05909041326,-7.17262248135,-3.6866425665,12.1199803355,-8.47601344068,16.0356173581,-3.32937415371,4.96412902957,-3.08953412261,-0.548149901967,2.08837173576,-0.125367210988,-0.771269811116,-4.37176722256,-0.328154078172,2.18110960307,-0.966302822799,-1.05242993997,2.04659433234,-1.43206522085,4.79155420061,-0.991935868985,0.432200200729,-1.00351052158,0.225888360004,-0.59275092237,-0.537533892316,-0.525298217053,-0.337592659367,-0.528237601613,-0.703914403963,-0.81818884651,-0.0309428074851,0.200159179146,-0.590102961087,0.156986848356,-0.190401243097,1.59384585553,-0.572874240961,0.168838093538,-0.369233370716,0.147321240523,-0.101028361741,-0.111499251289,0.299239888445,0.431112291979,-0.174207672418,0.122081064073,-0.0187546971657,-0.0353135455111,-0.083741828507,0.124947205756,-0.132737271275,-0.133688453667,-0.0128594546451,-0.0332151211591,0.311393510298,-0.185922723975,0.0485362272981,-0.234027130695,0.0625534903932,-0.160671602092,0.00372612927539,0.140742207646,0.0600800364013,-0.0293420846446,0.0290878920465,0.00212866840727],[-27207.2855043,-1686.70944417,1132.3202043,-1010.7597697,521.338862193,1012.06709876,-331.058354849,951.262916871,294.062559529,-183.835846947,-642.446503095,611.423627978,65.3000938012,87.4470084802,-320.969758855,-163.922269808,169.513846741,-220.978782089,40.1833069017,223.250487269,32.2135040069,115.078742965,142.743248593,-85.887814942,145.326485922,-48.6211113464,62.6318489012,-5.36548369199,81.3807174326,-62.999018047,45.3520577754,40.6734803912,-35.4604826796,8.42910786379,-57.3055413451,8.50820297585,-4.08640149014,-11.048985167,-11.935908409,8.37638005465,-28.8230650308,-14.9323599044,44.0936129838,-18.8641914872,40.9514403414,-11.657847591,23.1918650596,-25.6220665919,-0.482585855229,-7.79355384457,0.273244907583,-6.13023948817,-2.82987553688,-7.2799984298,-3.30067156096,12.2346522313,-8.40461924392,16.2196070739,-3.1025507306,5.11308519933,-3.01685836965,-0.383351231492,2.02350180983,-0.171227637048,-0.836454090169,-4.35358741233,-0.278020640288,2.30790498544,-1.05288010972,-0.956764923031,2.09622755564,-1.37890829724,4.87424450438,-0.939065636371,0.534535484345,-0.949960782756,0.245687555809,-0.577336811109,-0.528542061983,-0.555379881347,-0.339193541115,-0.55940872587,-0.716366070215,-0.801650611374,-0.0204216983293,0.184121937357,-0.551591688539,0.160352374613,-0.162618912196,1.62381971656,-0.565291619392,0.190535642692,-0.357704315059,0.14634258303,-0.0939951356528,-0.112318240555,0.300922556911,0.440982797571,-0.179604878144,0.124785810821,-0.0283817966235,-0.0395608877526,-0.0819899424294,0.122934014047,-0.138549290311,-0.132169387549,-0.00769785984023,-0.0247500921852,0.315032936975,-0.182501018033,0.0555055713795,-0.229844489423,0.0623790470884,-0.155609594913,0.00158841929287,0.141775597463,0.0616816032253,-0.0306392024717,0.0309232756684,0.00317348459548],[-27227.8525274,-1687.01590248,1135.8158425,-1017.89976693,535.58464547,994.692796703,-319.589032115,951.890319893,305.879831979,-197.349119854,-638.754817149,610.587961083,49.327460375,89.2411257726,-340.546240584,-159.371058641,177.901064464,-219.632015697,37.0041405585,219.271641666,35.9047756993,119.901916573,145.418399825,-91.2914946952,144.274411603,-48.0527307076,63.3656746204,-4.71673244927,79.991753361,-62.371076188,47.1683839146,42.2489744147,-36.333301484,8.50481890412,-59.1081964554,7.67442573622,-3.29069213151,-10.4557417637,-11.9197722919,9.4090017858,-29.0638531655,-14.4094980294,44.2534258088,-18.3703470827,41.1916754068,-11.7494098192,23.8523303111,-25.7785691912,-0.876542565477,-7.7711455459,0.411215396734,-5.92774444479,-2.54512552541,-7.38479008039,-2.90156904056,12.3613219733,-8.31593417674,16.4319733027,-2.86208049244,5.27082307778,-2.94155112655,-0.218678338659,1.95725182148,-0.229702672654,-0.908605204035,-4.33708911047,-0.224669015313,2.44192717802,-1.13970761012,-0.849647765519,2.14533881393,-1.3221411708,4.96267797556,-0.88458918956,0.641035995118,-0.894312860175,0.26649670203,-0.558023687105,-0.517366291518,-0.589425606894,-0.341795433643,-0.594274605508,-0.730434493306,-0.784779261634,-0.00995649180704,0.168014861034,-0.509522403692,0.162438123916,-0.132792968577,1.65315138212,-0.557305404087,0.21455014847,-0.345237107962,0.146568943091,-0.0850178547858,-0.112636434031,0.301798272734,0.450636169203,-0.18500170701,0.127803348673,-0.0389130776992,-0.0444480802682,-0.0806395709098,0.120109422406,-0.144263591666,-0.1302099886,-0.00340402369776,-0.0154062557894,0.318284656924,-0.178878775115,0.0627646035741,-0.225505371093,0.0625405950973,-0.150240686022,-0.000568599122465,0.143139213096,0.063153831969,-0.0317076233528,0.0328932909536,0.00407402260642],[-27256.622222,-1687.74475847,1140.84120665,-1026.44054497,546.618485129,976.617610036,-308.946512784,953.574760555,319.679918939,-211.951884984,-635.193718709,609.128626161,31.3552126074,90.9826399562,-359.489032403,-154.844855701,186.46703796,-218.328335471,34.1380004873,214.86949187,40.0296982143,124.344137369,147.757885989,-97.292869904,142.999254787,-47.1583229548,64.1056438471,-4.06434095371,78.6983037891,-61.5873332866,48.8806291764,43.8662890799,-37.1963487979,8.80082311958,-60.9715657068,6.72110071457,-2.40345058935,-9.85384081159,-11.882208946,10.5728427454,-29.2665172825,-13.8929288405,44.487608095,-17.8647734218,41.5234181542,-11.8209658326,24.4896625689,-25.9505017909,-1.3149518907,-7.73795176224,0.549584205333,-5.70868874297,-2.20433769384,-7.48733110334,-2.48945951999,12.5002449968,-8.20936321533,16.6745313264,-2.60871985981,5.43588218407,-2.86520921234,-0.0537519204008,1.89056186497,-0.301367429188,-0.987405861442,-4.32264565605,-0.167153900775,2.58375674452,-1.22609425835,-0.731000741423,2.19425478051,-1.26104003019,5.05746727593,-0.828579554533,0.750739445734,-0.837070589369,0.288250097664,-0.53448834444,-0.503936327177,-0.627111459721,-0.345457811105,-0.632958843164,-0.746124770996,-0.767308653783,0.00062508259158,0.151970962052,-0.463803304238,0.16324389173,-0.100862128478,1.68204794089,-0.548966517493,0.240724159232,-0.332030290616,0.147874530125,-0.074157205152,-0.112494065782,0.301861636601,0.460005989733,-0.190394849996,0.131145052533,-0.0504071088873,-0.0499852762736,-0.0796057519001,0.116522127277,-0.149856019621,-0.127783350929,2.65630777916e-05,-0.00513090184321,0.321145989159,-0.175081156941,0.0703047334608,-0.221085012609,0.062985510846,-0.144578651302,-0.00271869814236,0.144862699009,0.0645019633131,-0.0325648732536,0.0349943885612,0.00484615917729],[-27292.482377,-1687.82767156,1147.72572622,-1035.77825026,554.969434002,958.351985661,-299.514855216,956.326533503,335.511809504,-227.55348366,-631.763875702,606.966434545,11.5470968829,92.6529326405,-377.543823264,-150.361630431,195.164491245,-216.893681608,31.5279850249,209.997388819,44.4974293591,128.449808815,149.832584369,-103.865154326,141.504070827,-45.9295844898,64.8667051118,-3.38895132626,77.4778640235,-60.6772316564,50.5121690802,45.5588523319,-38.0308906761,9.32872602805,-62.900808828,5.64369946992,-1.41887682979,-9.23975687471,-11.8227832506,11.8627354431,-29.4313270948,-13.3823303524,44.7992570631,-17.3413429506,41.9457846291,-11.8719486241,25.1006823133,-26.1347425252,-1.79921093831,-7.69336974478,0.689999245561,-5.47054824563,-1.80715339609,-7.58805551114,-2.06444426765,12.6515368891,-8.08409933363,16.9491030611,-2.34312338701,5.60649779032,-2.78950492677,0.112057024996,1.82446099511,-0.38671585048,-1.07230810451,-4.31061048013,-0.104469993124,2.73414410079,-1.31120313795,-0.600808055964,2.24337432967,-1.19468547691,5.15928171442,-0.771073037359,0.862491321033,-0.778753979207,0.310866029361,-0.506382274876,-0.488169114269,-0.668019501647,-0.350248392802,-0.675546305112,-0.763421474486,-0.748936440964,0.0115314895754,0.136180918221,-0.414333880137,0.162776923617,-0.0667679631248,1.71079135579,-0.540304191484,0.268832484909,-0.318303746409,0.150115507722,-0.0615077198794,-0.111925795172,0.301120355764,0.469008745156,-0.195783714357,0.134813089447,-0.0629151763663,-0.0561801507372,-0.0787840966502,0.112236710025,-0.155290904322,-0.124860154812,0.00261845159527,0.00612975572572,0.323624567747,-0.171124499938,0.0781132272622,-0.216663703828,0.0636532112101,-0.138635330066,-0.00483058684685,0.14697769872,0.0657279059672,-0.0332343446418,0.0372235542594,0.00551509805741],[-27334.3207811,-1686.19630115,1156.79883068,-1045.30902923,561.16654492,940.406370476,-291.678117772,960.155933383,353.424492766,-244.063257207,-628.465956054,604.022197571,-9.93314041409,94.2333854346,-394.456302118,-145.939352276,203.946148338,-215.153994306,29.1171925079,204.608683452,49.2171269408,132.263334372,151.71337225,-110.98156172,139.791915074,-44.3582117142,65.6638069449,-2.67120568786,76.3079293704,-59.670213611,52.0863791452,47.3600921157,-38.8181931736,10.1001331474,-64.9010855474,4.43769356131,-0.331170818981,-8.60996451709,-11.7410600849,13.2735123884,-29.558552315,-12.8773805797,45.1914699337,-16.7939281149,42.4578908773,-11.9017911863,25.6822100246,-26.3281695284,-2.33071681572,-7.63679674473,0.8341084296,-5.21079881569,-1.35321398608,-7.68739731629,-1.62662455194,12.8153132377,-7.93933550559,17.257510423,-2.06594562832,5.78090516866,-2.71611056956,0.279377499245,1.75997826671,-0.486241880359,-1.16276397534,-4.30133701375,-0.0356119888119,2.89383966269,-1.39419733244,-0.459053914364,2.29309633566,-1.12215811253,5.2687906,-0.71210594411,0.975137105858,-0.719883038559,0.334262783773,-0.473356970173,-0.469981598104,-0.711731794489,-0.356234898033,-0.722121857621,-0.78230917498,-0.729360276315,0.0229711938533,0.120835407349,-0.361013621348,0.161044465139,-0.0304520437409,1.73966358977,-0.531347657932,0.298649935433,-0.304277358728,0.153148039471,-0.0471639320961,-0.110966281566,0.299582137476,0.477560921463,-0.201167707347,0.138809626459,-0.0764885663143,-0.0630403786276,-0.0780702164099,0.107317752019,-0.16053257591,-0.121411080523,0.00439619296351,0.0184295029896,0.325728026759,-0.167025140531,0.0861773512008,-0.212321734605,0.0644831130651,-0.132422561629,-0.00687297431593,0.149515855742,0.066833568641,-0.0337394299848,0.0395777738164,0.0061060429961],[-27381.0252232,-1681.78230665,1168.38994949,-1054.42902833,565.738870717,923.291211378,-285.820358811,965.073254842,373.46695782,-261.390546948,-625.300627694,600.216726575,-32.921752899,95.705379948,-409.972157918,-141.595990682,212.764733255,-212.93521376,26.8487212731,198.656726705,54.0979487665,135.829117503,153.471126919,-118.615305844,137.86584288,-42.4359010298,66.5118978769,-1.89174615946,75.1659951364,-58.5957214641,53.6266348909,49.3034363766,-39.539522345,11.1266499954,-66.9775555935,3.09855454777,0.865467476949,-7.96093830278,-11.6366043281,14.800006091,-29.648462656,-12.377757537,45.6673439276,-16.2164013606,43.0588529446,-11.9099265119,26.2310661834,-26.5276609347,-2.91086663034,-7.56763001331,0.983559669631,-4.92691631607,-0.842160817732,-7.78579053129,-1.17610164127,12.9916896299,-7.77426470515,17.6015753282,-1.77784113804,5.95733959121,-2.64669844046,0.44883850406,1.6981427346,-0.600439462655,-1.25822551606,-4.29517868794,0.0404254157097,3.06359384609,-1.47423992536,-0.305722521846,2.34381967275,-1.04253853855,5.38666324161,-0.651714580855,1.08752228505,-0.660977776293,0.358358647548,-0.435063922093,-0.449290723992,-0.757830400064,-0.363485046099,-0.772770366965,-0.80277244368,-0.708277812978,0.035152660134,0.106125107246,-0.303742017831,0.158053761855,0.00814405844891,1.76894660573,-0.522126148712,0.329951320736,-0.290171010963,0.156828288959,-0.0312203749301,-0.109650184327,0.297254688987,0.485579004647,-0.206546236223,0.143136830612,-0.0911785649096,-0.0705736349131,-0.0773597224288,0.101829834624,-0.165545364531,-0.117406808336,0.00538433829134,0.0318221260205,0.327464000265,-0.162799415148,0.0944843714992,-0.208139394796,0.0654146332866,-0.125952185306,-0.00881456962965,0.152508813592,0.0678208600439,-0.0341035217504,0.0420540330004,0.00664419774266],[-27431.5363064,-1673.5673054,1182.66930711,-1062.73111555,569.120558821,907.295928051,-282.188254995,971.074672307,395.626966462,-279.449291695,-622.2841198,595.499483672,-57.2909092357,97.0400224682,-423.900812802,-137.35933337,221.573157793,-210.105998937,24.6739118665,192.111724859,59.0687120272,139.194783025,155.163390385,-126.739100844,135.728465114,-40.1635039384,67.4258622536,-1.03691385652,74.0322129887,-57.4728128341,55.1519588171,51.4155465226,-40.180993248,12.4154425135,-69.1339196053,1.62495439462,2.17408194365,-7.290210868,-11.5083300017,16.4369610176,-29.7001591277,-11.8833496639,46.2294985478,-15.6031871611,43.7469141229,-11.8959988068,26.7447162532,-26.7299894308,-3.54000456894,-7.48555023789,1.13969955161,-4.61699318815,-0.27431152055,-7.88327033878,-0.713375979074,13.1809004988,-7.58841334063,17.9822405197,-1.47968514826,6.13406342967,-2.58236609082,0.620567034802,1.63948424962,-0.729433425064,-1.3582294391,-4.29237345028,0.124503523784,3.24398357868,-1.55071012678,-0.140992263389,2.39591537302,-0.955252223736,5.51327972502,-0.589994509711,1.19859962275,-0.602403205195,0.382942165099,-0.391350665069,-0.426035519063,-0.805945341105,-0.372060535493,-0.827520923559,-0.824798351975,-0.685455961416,0.0482407246949,0.0922213040062,-0.242506617405,0.153837675327,0.0490145731422,1.79885359908,-0.51268802143,0.362486630693,-0.276163230733,0.160983287724,-0.0137783650887,-0.107999077829,0.294145698913,0.493000975899,-0.211919779161,0.147785407421,-0.107015447403,-0.0787787724092,-0.0765689988698,0.0958325859494,-0.170298885734,-0.112824725629,0.00561599161509,0.0463258483912,0.328845354628,-0.15846448193,0.103007575535,-0.204184842694,0.0663899327254,-0.119233230417,-0.0106278851144,0.155970161319,0.0686925866073,-0.0343496081617,0.0446441623753,0.00714603449522],[-27485.0058916,-1660.73274636,1199.17030786,-1070.59504505,571.366135056,891.82583131,-280.478956192,978.099879332,419.647371297,-298.171820217,-619.494906564,589.934534104,-83.0564382815,98.1673179958,-436.306621653,-133.29644117,230.325084858,-206.705883871,22.5770736717,185.011305565,64.1368714483,142.420841176,156.794363561,-135.32366242,133.380614722,-37.5784923422,68.4203276816,-0.115845872586,72.8973600376,-56.2790065584,56.663961346,53.6960178144,-40.748116952,13.9559183369,-71.3680418638,0.0283666922897,3.58669187392,-6.5995471377,-11.3525476963,18.1787694632,-29.7080679281,-11.3948870997,46.8786424278,-14.9509180986,44.5168266891,-11.8604971309,27.2232056304,-26.9315059136,-4.21426313582,-7.39137185051,1.30266935662,-4.28158818713,0.34731117365,-7.97827660204,-0.240544708853,13.3836556601,-7.38264155797,18.3969320478,-1.17323560229,6.30944745402,-2.52191207846,0.792682061424,1.58253584674,-0.871872130753,-1.46265113825,-4.29269731443,0.216907637929,3.43489183543,-1.623851653,0.0341817569903,2.44964309973,-0.861104105644,5.64786324327,-0.527278316972,1.30775100031,-0.543904353715,0.407282911874,-0.34284890423,-0.400243337725,-0.855898483993,-0.381998981478,-0.886179514407,-0.848383972007,-0.660938661385,0.0622257100876,0.0792177168695,-0.177647199325,0.148531531113,0.0918969337246,1.82932269503,-0.503158136626,0.395906574958,-0.262267122587,0.165323539088,0.00503364640471,-0.105982196487,0.29026278132,0.499850797201,-0.217293098032,0.152700216279,-0.123945445338,-0.0876193553192,-0.075697521548,0.0893658210654,-0.174783896697,-0.10766904819,0.00515846868107,0.0618166436753,0.32990588539,-0.154040785882,0.111664335309,-0.200477710348,0.0673621481333,-0.112263486319,-0.0123006460818,0.15984127011,0.0694551456499,-0.0344990604638,0.0473193716884,0.00759309924721],[-27540.6386541,-1642.51003644,1217.26715105,-1078.59729254,572.435219843,876.065204755,-280.252230571,986.074449252,445.209797631,-317.495058769,-617.027023429,583.614593893,-110.270083942,99.0069962095,-447.317672543,-129.484193189,238.974365136,-202.817121369,20.5507582815,177.409951814,69.3295411391,145.571023551,158.354912083,-144.339206659,130.822680169,-34.7274932435,69.5098575831,0.856621704302,71.7548697543,-54.981436779,58.1598998807,56.1376789756,-41.251253529,15.7330455247,-73.6763275606,-1.67653456248,5.09256041238,-5.891770109,-11.1649171447,20.01973568,-29.665446552,-10.9133104084,47.6150064835,-14.2567787828,45.362470166,-11.8041217571,27.6672246949,-27.1284558324,-4.92872191464,-7.28619271936,1.47230903949,-3.92187664668,1.01900825747,-8.0688503545,0.239895850864,13.6007837754,-7.15814293746,18.8421967896,-0.860471121228,6.48188953379,-2.46356021282,0.962800547525,1.52533135697,-1.02603482676,-1.5714506776,-4.2958108106,0.317779060459,3.63602810315,-1.69412434685,0.218650255519,2.50523467395,-0.761243989053,5.78934776626,-0.463957844978,1.41446557837,-0.48507125422,0.430520721084,-0.290386387378,-0.371963616206,-0.907559656027,-0.393331978513,-0.948496350657,-0.873528876102,-0.634839109964,0.0770543104321,0.067188673361,-0.109591600704,0.142296270767,0.136464374503,1.86022325126,-0.493680480574,0.429837043131,-0.248454435307,0.169530414321,0.0250804249472,-0.103555689723,0.285613531636,0.506173925736,-0.222672025627,0.157814655052,-0.141893779328,-0.0970501256934,-0.0747655391915,0.0824644017846,-0.178996440006,-0.10195069891,0.00408763816305,0.078134922947,0.330684620387,-0.149549593722,0.120358043976,-0.197025498242,0.0682871602377,-0.105037932374,-0.0138243810901,0.164045456686,0.0701158322119,-0.0345728456574,0.0500457154827,0.00795820644087],[-27597.6392691,-1618.13058254,1236.33403599,-1087.31433373,572.287433603,859.198331988,-281.067846303,994.923955402,471.995870773,-337.355933607,-614.974505841,576.632379061,-138.983590122,99.4787867881,-457.062053541,-125.999468534,247.474849312,-198.521964235,18.5875172889,169.362146598,74.6738352089,148.709061742,159.83590159,-153.755949649,128.055049919,-31.6571336447,70.7090153802,1.86565278609,70.5981756101,-53.547237638,59.6370318238,58.73335873,-41.7007630512,17.7317921355,-76.055181887,-3.47507537297,6.68095070361,-5.16970277903,-10.9410980798,21.9541639202,-29.5655524945,-10.4395601541,48.4388216308,-13.5179538234,46.2777240768,-11.7275729584,28.0774638263,-27.3170846367,-5.67846048904,-7.17111071265,1.64845855508,-3.53903390044,1.73708072352,-8.1530326296,0.72544938155,13.8331135062,-6.91611105942,19.3145816223,-0.543370326174,6.64978753853,-2.40553430335,1.1285394567,1.4659046113,-1.19020076011,-1.68458812124,-4.30137446897,0.427259093684,3.84710186866,-1.76198805118,0.411263948423,2.56292191675,-0.656821678742,5.93666726383,-0.400424936069,1.5182325176,-0.425493939077,0.451795425938,-0.234790862314,-0.341245790735,-0.960798684501,-0.406091121054,-1.01422164346,-0.900232636589,-0.607270504232,0.0926732198486,0.0562085010064,-0.0387676586563,0.135292835848,0.182390129786,1.89142462547,-0.484399039549,0.463903924809,-0.234696917674,0.173285284693,0.046226735936,-0.10067570696,0.28020554529,0.512015818684,-0.228062394739,0.163062121602,-0.160785669988,-0.107025825582,-0.0737933005283,0.0751631899196,-0.182932558245,-0.0956806006816,0.00247936873483,0.0951210972803,0.331220587454,-0.145012172173,0.128992094691,-0.193835706861,0.0691208497657,-0.0975515479453,-0.0151906186974,0.168506037767,0.0706819413337,-0.0345919307432,0.0527892483013,0.00821417051843],[-27655.2124118,-1586.82579155,1255.74516199,-1097.32264433,570.882396756,840.409496607,-282.485571559,1004.57397112,499.68721603,-357.691370987,-613.431389242,569.080605629,-169.248700728,99.5024194103,-465.66785272,-122.919146312,255.780388071,-193.902665272,16.6799022866,160.92237291,80.196867767,151.898687345,161.228197718,-163.544107477,125.078112436,-28.414040548,72.0323644948,2.89641128472,69.420711076,-51.9435432776,61.0926145784,61.4758858013,-42.1070055908,19.9371262283,-78.5010100345,-5.35258174244,8.34112589223,-4.43616814491,-10.6767502346,23.9763584359,-29.4016432506,-9.97457690101,49.3503187856,-12.7316278298,47.2564679444,-11.6315510079,28.4546134044,-27.4936377757,-6.45855844269,-7.04722369857,1.83095785823,-3.13423528209,2.49782956439,-8.22886446077,1.21361956468,14.081473514,-6.65773950414,19.810633423,-0.223911838229,6.81153933778,-2.34605815948,1.28751575256,1.40228944073,-1.36264917785,-1.80202353328,-4.30904881975,0.545489039919,4.06782261875,-1.82790260883,0.610873551927,2.62293664919,-0.548986979486,6.08875570587,-0.337071432585,1.61854097863,-0.364762440652,0.470246859646,-0.176890076839,-0.30813929754,-1.01548539671,-0.420308003559,-1.08310560395,-0.928494825794,-0.578346041267,0.109029132457,0.0463515273308,0.034396789704,0.127682167912,0.229347433881,1.92279617533,-0.475457799822,0.497733109592,-0.220966318468,0.176269521474,0.0683373447684,-0.0972983976237,0.274046417711,0.517421933227,-0.23347003816,0.168376013795,-0.180546337934,-0.117501197036,-0.0728010542866,0.0674970472826,-0.186588294,-0.088869676396,0.000409529070204,0.112615577749,0.331552814427,-0.140449787952,0.13746988061,-0.190915836691,0.0698190974444,-0.0897993123955,-0.0163908874617,0.173146330074,0.0711607680557,-0.0345772827218,0.0555160246871,0.00833380592214],[-27712.7721847,-1548.32296085,1274.95857644,-1109.14871934,568.168817217,819.14876522,-284.083104106,1014.96713411,528.056618885,-378.385506365,-612.46468427,561.013558829,-201.074271182,98.9981097276,-473.292977141,-120.288868939,263.854688539,-189.035433118,14.7980623595,152.140596346,85.9133546857,155.200933268,162.520366489,-173.664673511,121.900193231,-25.0430577395,73.4917492932,3.93455458808,68.2155359284,-50.1474378058,62.5245549708,64.3541011052,-42.4796660012,22.3335371083,-81.006334361,-7.29447814589,10.0626336719,-3.69517114849,-10.3679802212,26.0792383151,-29.1691224905,-9.5184708038,50.3462490713,-11.8943766757,48.2903704289,-11.5154234547,28.7995903979,-27.654467115,-7.26388444207,-6.91564672398,2.01968715573,-2.70914273948,3.29694032529,-8.29496988595,1.70193280872,14.3458191574,-6.38435489926,20.3261006521,0.096478187978,6.96569953381,-2.28361018035,1.43787309039,1.33258044127,-1.54156775625,-1.9235927742,-4.31847575459,0.672373597632,4.29766146221,-1.89238151818,0.816187507549,2.68532115582,-0.438728178734,6.24434844614,-0.274095751277,1.7149605387,-0.302519887724,0.48507251587,-0.11747557238,-0.272740430107,-1.07143117206,-0.435982442295,-1.15484048159,-0.95826729315,-0.548236201962,0.126017339551,0.0376562133227,0.109448445161,0.119591119685,0.277026007128,1.95419490097,-0.466967924253,0.530953743623,-0.207246171975,0.178156976964,0.0912521105125,-0.09340692736,0.267143424538,0.522451918084,-0.23889747743,0.173696146887,-0.20108996874,-0.128418065911,-0.0718114621442,0.0595033915859,-0.189967577336,-0.0815343760867,-0.00204941549608,0.130449514748,0.331717715134,-0.135886250486,0.145704720543,-0.188267835715,0.0703339680006,-0.0817788167556,-0.0174325533998,0.177888901144,0.0715599816743,-0.034546215394,0.0582006042869,0.00829599121474],[-27770.5703982,-1504.33294982,1293.76771905,-1123.11913089,564.051752866,795.929336463,-285.509860107,1026.11433961,557.241505532,-399.111312,-612.033302332,552.331800719,-234.297602976,97.8880172812,-480.214609835,-118.029332065,271.700883598,-183.972299739,12.8225365602,143.048712912,91.7884188895,158.666037682,163.691775456,-184.04175024,118.561366,-21.5818961391,75.0881379172,4.9677139878,66.9742151641,-48.1758051944,63.9333575223,67.3408943263,-42.8257282615,24.9035990663,-83.5481458898,-9.28658294512,11.8361599329,-2.95544451052,-10.0126821691,28.2501819893,-28.8719785857,-9.06803037938,51.4094444406,-11.0003412904,49.3622567378,-11.373226952,29.1142181316,-27.7963501839,-8.08846348503,-6.77756355031,2.21468766205,-2.26736467731,4.12763676174,-8.35230496107,2.18800643014,14.6226125829,-6.09781606156,20.8535381031,0.418583463719,7.11144965972,-2.2176871238,1.57986189222,1.25511526889,-1.72477788857,-2.04863489004,-4.32922261098,0.806871049926,4.53513599572,-1.95615289981,1.02534515796,2.74935957504,-0.326387494617,6.40138637403,-0.210922606535,1.80738244145,-0.238621794716,0.495700530081,-0.0571940648573,-0.235332910944,-1.12821359833,-0.452987140771,-1.22888667896,-0.989310996511,-0.517340602457,0.14332752112,0.0300175538209,0.185832160087,0.111010188571,0.325181514004,1.98542837221,-0.458909282039,0.563207999222,-0.193567154488,0.178591427583,0.114711266919,-0.0890925267113,0.259502562252,0.527222188131,-0.244333989084,0.178988005716,-0.222286607823,-0.139666593287,-0.070856837577,0.0512298641422,-0.193105888238,-0.0737132583552,-0.00483861298536,0.148417015946,0.331741247367,-0.131355540019,0.153649635921,-0.185871441919,0.0706022621582,-0.0734980987286,-0.0183863323629,0.182653321777,0.0718887485104,-0.0345014297609,0.0608515671625,0.00810386144098],[-27829.06829,-1457.06250828,1312.04987763,-1139.5104704,558.425349077,771.530191981,-286.433185325,1038.04354721,587.470462337,-419.488969349,-612.069130025,542.897462569,-268.71310912,96.0947875853,-486.739752826,-116.029994651,279.331962573,-178.759252932,10.6114614328,133.674101219,97.7747850659,162.341540073,164.719492557,-194.590217435,115.109641485,-18.0664834507,76.8197794529,5.98401425144,65.6879400849,-46.0554793813,65.3201761775,70.4051673409,-43.1515011321,27.6294076396,-86.0995528106,-11.3148129737,13.6526751144,-2.22690289648,-9.60919708722,30.4751827258,-28.5163460832,-8.61921373521,52.5192570535,-10.0430538668,50.4527412157,-11.1976654291,29.4005465193,-27.9161709281,-8.92610965224,-6.63417511764,2.41604084363,-1.81299611447,4.98252718187,-8.4024087466,2.66948047239,14.9074426343,-5.80011485516,21.3847021527,0.743740166738,7.24812798137,-2.14804033741,1.7142592718,1.1682923446,-1.91000939734,-2.17636472319,-4.34083808789,0.947703076057,4.77852543792,-2.01999852984,1.23634357113,2.81414650875,-0.212145627938,6.5576117628,-0.146783287163,1.89577834707,-0.172976772463,0.501616698203,0.00334393618165,-0.196247319819,-1.18535181543,-0.471163024308,-1.30464663696,-1.02133917084,-0.486116142708,0.160597954324,0.0232946771276,0.262967324754,0.101895783147,0.373586105019,2.01629180134,-0.45122891896,0.594141305254,-0.179971727807,0.177209130781,0.138430141411,-0.0844734424435,0.251129507542,0.531863349782,-0.249765538403,0.184223492513,-0.243995265561,-0.151124024051,-0.0699719070107,0.0427266621642,-0.19604659417,-0.0654504089451,-0.007902614758,0.166302928334,0.33164675491,-0.126894179502,0.161267573831,-0.183700840785,0.0705569646408,-0.0649678076856,-0.0193387776611,0.187358413591,0.0721566091408,-0.0344419736236,0.0634859984792,0.00776661576611],[-27888.7270978,-1408.71838609,1329.68233997,-1158.5993293,551.183751225,746.730313415,-286.520425521,1050.78271653,618.97207567,-439.138659871,-612.504053949,532.572675646,-304.115202623,93.5410661537,-493.175408137,-114.180315656,286.760914788,-173.442280496,8.02297352183,124.044139878,103.825177903,166.274979926,165.58058573,-205.224954864,111.593030429,-14.5327473779,78.6849229863,6.97158014658,64.3479019928,-43.8132943041,66.6861648811,73.5158220258,-43.4632933732,30.4930583654,-88.6336633131,-13.365085065,15.5031496558,-1.51946097184,-9.15586598433,32.7402337918,-28.1083595296,-8.16797897878,53.6550390702,-9.01604659828,51.5424382072,-10.9814428153,29.6606254749,-28.0108132932,-9.77063702438,-6.48668236605,2.6238281669,-1.35013206988,5.85421989381,-8.44682030297,3.14399497892,15.1958981552,-5.49324314418,21.9113491777,1.07328447478,7.37507276459,-2.07442116872,1.84184234286,1.07051008936,-2.09499210504,-2.30599711608,-4.35287088428,1.09359135528,5.02610900748,-2.0847001844,1.44717981502,2.87877655885,-0.0961832794976,6.71076688575,-0.0809090819625,1.98011991578,-0.105493431801,0.502306816159,0.0635279211909,-0.155814236497,-1.24236496325,-0.490351018223,-1.38152279649,-1.05406505108,-0.455019722668,0.177466916325,0.0173467115444,0.340273329432,0.092204311988,0.422011930682,2.04658040063,-0.443873880798,0.623399090586,-0.166502353728,0.173646344009,0.162124061408,-0.0796679213223,0.2420299371,0.536506009451,-0.255178090669,0.189374509508,-0.26607495233,-0.162667603088,-0.0691913968708,0.0340439828643,-0.198833062598,-0.0567899135999,-0.0111859721744,0.183892098901,0.331457581549,-0.122538691886,0.168521481361,-0.181730217798,0.0701310601717,-0.0561985929975,-0.0203764426041,0.191922998202,0.0723731041426,-0.0343668947836,0.0661209834026,0.00729345335539],[-27950.0080593,-1361.50733309,1346.54239388,-1180.66229901,542.221104682,722.308682411,-285.438926457,1064.35980717,651.9749319,-457.680565024,-613.269960702,521.219571218,-340.298296494,90.1494985004,-499.828577792,-112.36975404,294.000729568,-168.067370228,4.91520937163,114.186207499,109.892322087,170.513896728,166.252122913,-215.860842298,108.059543573,-11.0166156246,80.6818176034,7.91853644079,62.9452921897,-41.4760839007,68.032477578,76.6417602574,-43.7674137452,33.4766467809,-91.1235855871,-15.4233160527,17.3785539963,-0.843033402092,-8.6510298693,35.0313284546,-27.6541534718,-7.71028421756,54.7961426507,-7.91285167785,52.6119620567,-10.7172630401,29.8965049121,-28.0771612247,-10.6158596821,-6.33628623562,2.83813109826,-0.882867562417,6.73532320569,-8.48707869063,3.60918999321,15.4835679891,-5.17919279272,22.4252355546,1.40855256559,7.49162227523,-1.9965809653,1.96338821913,0.960166924163,-2.2774558342,-2.43674691112,-4.36486969912,1.24325756686,5.27616592303,-2.1510396396,1.6558509576,2.9423443272,0.0213188499004,6.85859401613,-0.0125312797345,2.06037880778,-0.0360803835634,0.497256679873,0.122747380624,-0.114364240746,-1.29877218167,-0.510392047838,-1.45891759843,-1.08720187221,-0.424508242291,0.193572684286,0.0120327853734,0.417169564392,0.0818921836681,0.470231141503,2.07608938235,-0.436791213335,0.650626784081,-0.15320149405,0.167539324715,0.185508354334,-0.0747942101138,0.232209527615,0.541280773552,-0.260557611163,0.194412958934,-0.288384678506,-0.174174575284,-0.0685500335831,0.0252320234553,-0.201508660987,-0.0477758580629,-0.0146332365949,0.200969374638,0.331197071067,-0.11832560012,0.175374305595,-0.179933758441,0.0692575334745,-0.0472011040354,-0.0215858805019,0.196265897228,0.0725477740925,-0.0342752410418,0.068773607098,0.00669357337406],[-28013.0045823,-1317.1685259,1362.56121341,-1205.84107036,531.552894034,698.917711234,-282.960984902,1078.75965861,686.596338789,-474.75875833,-614.305149564,508.804465931,-377.03457997,85.8808341018,-506.965096939,-110.528940243,301.067102482,-162.67011718,1.19424405849,104.132180201,115.92908432,175.119066068,166.737343475,-226.404258363,104.546084902,-7.54820246841,82.8023029685,8.82036467115,61.4720972397,-39.0624789487,69.3655007311,79.76321948,-44.0680428667,36.5581918283,-93.546351982,-17.4773559893,19.2697689675,-0.206962321771,-8.09417470176,37.3337749315,-27.1572992151,-7.24105938999,55.9234095015,-6.7270323742,53.6422286621,-10.3976867401,30.1102132282,-28.1108007358,-11.4560286285,-6.1842365113,3.05858935192,-0.415219413591,7.61854965808,-8.52435395581,4.06299431236,15.7661598504,-4.85954777999,22.9185964883,1.75057379188,7.59676618047,-1.9141986598,2.07952176948,0.835948162806,-2.4554183557,-2.5678210583,-4.37649293343,1.3953234977,5.5268635418,-2.21965080091,1.86042685395,3.00400974417,0.140233456263,6.99906980837,0.0590810066348,2.13637306566,0.0355741221923,0.486103117475,0.180489724664,-0.0721679706198,-1.35399884787,-0.53111712125,-1.53623804373,-1.12046040547,-0.395006465966,0.208577205294,0.00717954740023,0.493084313407,0.0709339039431,0.518016869661,2.10461020811,-0.429904941907,0.675464974273,-0.140048553776,0.158555831909,0.208324473565,-0.0699902001152,0.221719390798,0.546271206381,-0.265891089574,0.199311175139,-0.310777714713,-0.185524808105,-0.0680766951268,0.0163349670584,-0.204113410594,-0.0384754956331,-0.0181855482447,0.217342680296,0.330878513435,-0.11428301676,0.181782906169,-0.178265515539,0.0678638063034,-0.0379768573119,-0.0230427922595,0.200320869376,0.0726895233628,-0.0341763266125,0.0714518736117,0.0059768595027],[-28076.3387557,-1275.57084824,1377.88551772,-1233.7377319,519.679960706,676.703534645,-279.278701653,1093.79462984,722.508489685,-490.112881569,-615.573570533,495.710417941,-414.007347203,80.8482382837,-514.68613323,-108.753190624,307.986554089,-157.244545421,-3.04209321354,93.9319241435,121.888899354,180.204207949,167.144172512,-236.727577113,101.045131365,-4.134368484,85.0125810587,9.70197345292,59.9234847559,-36.5582975844,70.7125508767,82.9057794085,-44.3608487886,39.6994060697,-95.8946914871,-19.522787803,21.1673169704,0.381700258303,-7.48936624456,39.6301412395,-26.6111150983,-6.75112175838,57.0236395148,-5.45227625807,54.6153601342,-10.0147013824,30.3036927536,-28.102126111,-12.2871425559,-6.03197835744,3.28307563318,0.0491083446993,8.49702872147,-8.5583400878,4.50449174812,16.039856936,-4.53426054561,23.385582496,2.09915020619,7.68809975285,-1.82666352536,2.1902588833,0.697686690308,-2.62804923391,-2.69839493796,-4.38783779656,1.54801136527,5.77592177523,-2.29057609116,2.0592685077,3.06319405386,0.260646822834,7.13110844136,0.134507367925,2.20730626149,0.110663278525,0.469087085923,0.236634042406,-0.0292562973218,-1.40709528808,-0.552317577672,-1.61290937356,-1.15354156737,-0.366810615807,0.222237106148,0.00248372834636,0.567481434264,0.059376367289,0.565146174016,2.13191933687,-0.423047010073,0.697534888371,-0.126770710724,0.146489630837,0.230418376294,-0.0654723607497,0.210792378432,0.551372703767,-0.271169613216,0.204043220949,-0.33308437256,-0.196608659327,-0.067776865697,0.0073729404301,-0.206673947844,-0.0290487498298,-0.0217704028087,0.232912251671,0.330474983374,-0.110405412773,0.187679792907,-0.176599011289,0.0658550485355,-0.0284908379065,-0.0247794691614,0.204081421714,0.0728047115062,-0.0341205313604,0.0741274625132,0.0051559334831],[-28138.2648388,-1236.11561058,1392.71591221,-1263.81947157,507.224485335,655.685718026,-274.689128512,1109.23395973,759.272299327,-503.506468582,-617.045586289,482.424670782,-450.877668569,75.2029803343,-523.051687446,-107.178993023,314.788311193,-151.774286274,-7.6480347085,83.6398029915,127.725343954,185.896278479,167.606706553,-246.69467146,97.5380531538,-0.776160819984,87.2724444294,10.5956281708,58.2954176138,-33.9411547841,72.1061770692,86.1063553256,-44.6393714201,42.8579254721,-98.1652572514,-21.5571276411,23.0616307984,0.916474858244,-6.84181521137,41.9023103459,-26.0063562187,-6.23026041602,58.0851221291,-4.08230197569,55.513780137,-9.56015114148,30.4788643024,-28.0402337022,-13.1056370791,-5.88100578328,3.50902089513,0.506489877951,9.36399409876,-8.58836206168,4.93305486591,16.3009613136,-4.20287564431,23.8208229229,2.45377703604,7.76286966623,-1.73329242023,2.29546320512,0.5455022845,-2.79480598158,-2.82763603804,-4.39911119992,1.69944349471,6.02094867335,-2.36371006254,2.25080970957,3.11938382888,0.382698629666,7.25385847515,0.214289570832,2.27222834972,0.19060063927,0.446600574382,0.291157342672,0.0143998496555,-1.45701806582,-0.573774839097,-1.68836138914,-1.1861438107,-0.340184778366,0.23433268357,-0.0023904205829,0.63983367825,0.0472845653623,0.611397095093,2.15778947691,-0.416026340947,0.716452913251,-0.113032085918,0.131165988302,0.251662145672,-0.061476805972,0.199706777319,0.55643361942,-0.276385293808,0.208583591309,-0.355129223899,-0.207319109308,-0.0676501810421,-0.00163994376448,-0.209213562956,-0.019678711728,-0.0253118848365,0.24760140232,0.329949501792,-0.106678848733,0.192991388182,-0.174787635228,0.0631308670789,-0.0186988980402,-0.0268173500875,0.207555998401,0.0728990618709,-0.0341685015635,0.0767629722528,0.00424410157238],[-28197.0370906,-1198.20412342,1407.2530023,-1295.55347732,494.808648557,635.883826762,-269.489317285,1124.84688717,796.448682457,-514.703053214,-618.69155951,469.434467989,-487.306614447,69.0963295418,-532.121760363,-105.94283528,321.5016006,-146.242971061,-12.4778126904,73.3101804119,133.391994887,192.322233764,168.259042126,-256.169414315,94.0062204587,2.52537337499,89.5416856361,11.5335942097,56.5838586888,-31.1886655239,73.5789283632,89.4018625139,-44.8971506703,45.9913860025,-100.354702424,-23.5778916508,24.9431432448,1.39088199817,-6.15673231583,44.1321652176,-25.3337776734,-5.66826445618,59.0961467829,-2.61082817331,56.3199123347,-9.02588019172,30.6376486884,-27.9142198615,-13.9079478129,-5.73281279804,3.73385609085,0.953299351663,10.2126794929,-8.61374485252,5.34805623112,16.5457750507,-3.8649376308,24.218947114,2.81394950894,7.81832259449,-1.63340220265,2.39499837947,0.379514723214,-2.95514611146,-2.95471184644,-4.41052005493,1.84774221113,6.25955228618,-2.43894726721,2.4334842503,3.17206564178,0.506528556811,7.36646846977,0.298969382053,2.33018928479,0.276799758265,0.419035572016,0.344036634288,0.0588295408202,-1.5027237446,-0.595270327515,-1.76202389169,-1.21796558824,-0.315393040189,0.244644234284,-0.00777864818227,0.709613796654,0.0347234898192,0.656547673422,2.18199333652,-0.408651857644,0.731835435789,-0.0984968003819,0.11241017111,0.271927864846,-0.0582396497367,0.188740874261,0.561302307052,-0.281530243072,0.212906781163,-0.376736840586,-0.217549138402,-0.067696276911,-0.0106895728602,-0.211755546148,-0.0105484724022,-0.0287340788779,0.261333445801,0.329265089596,-0.103089385212,0.197644114364,-0.172684776894,0.0595908688414,-0.00855688993421,-0.0291778739174,0.210753043597,0.0729782978048,-0.0343808834993,0.0793210012808,0.00325467002766],[-28250.9097704,-1161.23769725,1421.69739341,-1328.40693712,483.054631008,617.317426234,-263.976319775,1140.40265101,833.598553817,-523.466169307,-620.481852876,457.227053096,-522.955255214,62.6795551944,-541.956352762,-105.181205234,328.155649113,-140.634231105,-17.3856594233,62.9974200714,138.842428918,199.609029911,169.235275758,-265.015678589,90.4310034713,5.76918695226,91.7800972341,12.5481369542,54.7847708561,-28.2784447802,75.163353813,92.8292162561,-45.1277264485,49.057423628,-102.459680154,-25.5825959795,26.8022871029,1.79844219818,-5.4393282716,46.3015888218,-24.5841345599,-5.05492297215,60.0450029148,-1.03157349716,57.0161803914,-8.40373270763,30.7819667257,-27.7131809408,-14.6905103721,-5.58889341097,3.95501217342,1.38591093133,11.0363186068,-8.63381343539,5.74886840917,16.7706002149,-3.5199910598,24.5745844147,3.1791628524,7.85170521152,-1.52630973089,2.48872805086,0.19984378428,-3.10852713631,-3.07878985111,-4.42227127302,1.99102983967,6.48934066372,-2.51618225736,2.60572592063,3.22072606516,0.632276284322,7.46808698527,0.389088568282,2.38023902114,0.370674189347,0.38678406799,0.395248926077,0.10406184668,-1.54316888793,-0.616585464919,-1.83332668243,-1.24870535279,-0.292699487827,0.252952055015,-0.0140167032464,0.776294540765,0.0217581323162,0.700375949529,2.20430362398,-0.400732483278,0.743298842862,-0.0828289751387,0.0900474460629,0.291087616966,-0.0559970059985,0.17817295606,0.565827120372,-0.286596572727,0.216987285456,-0.397731794474,-0.227191726967,-0.0679147890522,-0.019761834192,-0.214323187638,-0.0018411229274,-0.0319610694824,0.274031695671,0.328384767693,-0.0996230827833,0.201564393826,-0.170143825825,0.0551346607309,0.00197933419041,-0.0318824795307,0.21368100146,0.0730481426561,-0.0348183234457,0.0817641480474,0.00220094510605],[-28298.3768631,-1124.78169337,1436.18850235,-1361.92159744,472.525533339,600.032163993,-258.313903208,1155.73944528,870.312128983,-529.642366686,-622.404043838,446.22443074,-557.488950915,56.0855384754,-552.629352508,-105.023090081,334.762925649,-134.948915239,-22.2290352016,52.7653209715,144.039175565,207.855005775,170.645149069,-273.099592149,86.79778853,8.94621123902,93.9481064736,13.6626860472,52.8987225562,-25.1983583731,76.8860941163,96.4133059721,-45.3185809667,52.0169621174,-104.475655612,-27.5681691934,28.626235035,2.13183746999,-4.69737504039,48.3948258965,-23.7506505793,-4.38059829519,60.920168257,0.661991408827,57.5872532682,-7.68711137513,30.9137384895,-27.4278137097,-15.4498731355,-5.45167653201,4.16984134629,1.79996233578,11.8287538045,-8.64805655698,6.13527861233,16.9718978349,-3.16715461107,24.8829320951,3.54922498243,7.86055093135,-1.41147433232,2.57654429085,0.00689045766863,-3.25431099381,-3.19919109734,-4.43459307493,2.12731189966,6.70814668277,-2.59532932804,2.76625160711,3.26486163038,0.760086789828,7.55794901211,0.485212592895,2.42144573111,0.47335996181,0.350179983234,0.444784872023,0.150041996933,-1.57748545141,-0.637457049199,-1.90172229203,-1.27808501602,-0.27238497779,0.259047434777,-0.021396435802,0.839395933797,0.00842750260577,0.742667723939,2.22448631923,-0.392041523083,0.750479385226,-0.0657511628701,0.0639285142855,0.30901635423,-0.0549804383163,0.168217038544,0.569877339509,-0.291561512182,0.22082484696,-0.41793396374,-0.236148169818,-0.068301200183,-0.0288438541679,-0.216949662077,0.00626944004458,-0.0349420885811,0.285619403596,0.327265597347,-0.0962577030154,0.204679379127,-0.167038942135,0.0496631472292,0.0129429367077,-0.0349599642069,0.216340871664,0.0731161931283,-0.0355276655667,0.0840599963683,0.00109744037772],[-28338.891257,-1089.05767636,1450.62099162,-1395.93743882,463.548136262,584.17801625,-252.132696503,1170.97128452,906.296826876,-533.410259105,-624.514568942,436.587649975,-590.590220251,49.3736081479,-564.270195828,-105.567474439,341.26886756,-129.256742336,-26.8783124416,42.7154234541,148.980575354,217.044031204,172.500984038,-280.296302682,83.1080265626,12.0152914658,96.0086793834,14.8653281632,50.9447044882,-21.9772754995,78.7501565427,100.13091763,-45.4329656488,54.8440764463,-106.393342061,-29.5291895354,30.3891191792,2.38039579161,-3.94888957616,50.4055682632,-22.8364238485,-3.63794570857,61.7108737172,2.47738790999,58.0267811157,-6.87565292583,31.0348811012,-27.055216607,-16.183035538,-5.32733067405,4.37538081438,2.18814549707,12.5862620941,-8.65661805046,6.50873264033,17.1467647833,-2.80384346451,25.1414591259,3.92519456907,7.84354012876,-1.28892521085,2.65845287901,-0.197819418085,-3.39147732141,-3.31585086003,-4.44779891884,2.25412668734,6.91470252717,-2.67638174581,2.91491057951,3.30400870393,0.890126241275,7.63563526249,0.588001705979,2.45295045849,0.584883006773,0.309324965748,0.492689706757,0.196379858033,-1.60550695906,-0.657443381836,-1.96675416891,-1.30592032514,-0.25479744643,0.262765631762,-0.0300341008036,0.89862708667,-0.00533331717487,0.783239837156,2.24228048878,-0.382209810773,0.75309276915,-0.0472196428889,0.0340058141769,0.325600505033,-0.0554033086661,0.158830053635,0.573405950258,-0.296342761595,0.224520199761,-0.437144451845,-0.244353019612,-0.0688343808946,-0.0379277154889,-0.21970768185,0.0136460975531,-0.03772695763,0.296019573681,0.325840801243,-0.0929378114656,0.206919143564,-0.163327368247,0.0430824231126,0.0243231383727,-0.038468558824,0.218703875943,0.073197539347,-0.0365005455715,0.0861960715202,-3.65013349984e-05],[-28372.1455661,-1054.45126163,1464.82833513,-1430.36900033,456.390140503,569.931041386,-244.930044003,1186.28113844,941.289367253,-535.031476298,-626.887079506,428.412520957,-621.945871589,42.5847048701,-577.022206033,-106.905842283,347.602154308,-123.644648781,-31.2070915901,32.9587031961,153.673921563,227.131358793,174.790747737,-286.483212828,79.3671846442,14.9272513389,97.925416687,16.1353142347,48.9463129163,-18.6543162006,80.752640005,103.946811335,-45.4280742217,57.5161293923,-108.202264785,-31.4596476675,32.0618115425,2.53260663265,-3.21445008089,52.3298695141,-21.8470210882,-2.82019373356,62.406538497,4.42238537398,58.3306593815,-5.97055260281,31.1473109435,-26.5940884887,-16.8871097789,-5.2229592507,4.56858903301,2.54241590062,13.305729145,-8.65980552061,6.87109093977,17.2924568938,-2.42704692508,25.3482024028,4.30844297086,7.79963991868,-1.15883403954,2.73448802192,-0.412478792307,-3.51891018148,-3.42885797144,-4.46222357224,2.36889569316,7.10796520751,-2.75935252012,3.05183520343,3.3377136111,1.02256610418,7.70081287904,0.698139854302,2.47391246501,0.704991730815,0.264262595295,0.53902231007,0.242601455624,-1.62724232696,-0.676058140212,-2.02798849095,-1.33205048625,-0.24030160006,0.263952896449,-0.0400020544377,0.95374438223,-0.0196152267923,0.821916889678,2.25741847079,-0.370832562181,0.750874564785,-0.0272491261658,0.000257218455406,0.340729366819,-0.0574744286282,0.149904662283,0.576386864829,-0.300843138815,0.228199325771,-0.455159668575,-0.251749143465,-0.069489048747,-0.0470067399293,-0.222679843778,0.0201609250603,-0.0403906454664,0.305155148138,0.324037642424,-0.0895996746876,0.208214490622,-0.158987117162,0.035299880731,0.0360981745352,-0.0424738526597,0.220733791547,0.0733091447934,-0.0377147970553,0.0881648841451,-0.00118032989672],[-28397.8324044,-1021.3480646,1478.64400677,-1465.13082106,451.319246786,557.467297778,-236.203290049,1201.85197674,975.02646987,-534.767648,-629.595226848,421.794853843,-651.242713297,35.7597693001,-591.028706438,-109.129677586,353.691465359,-118.199570958,-35.0889730937,23.6061358741,158.126507471,238.072241138,177.502407236,-291.53772523,75.58072985,17.6329145647,99.6619191079,17.4518951942,46.9271441047,-15.2686005173,82.8906434158,107.825747192,-45.2611004122,60.0104837328,-109.891949067,-33.3535342515,33.6151841318,2.5769594627,-2.51463475658,54.1637832417,-20.7880090195,-1.92057089141,62.9965817977,6.50475316845,58.4947835132,-4.97300564911,31.2529443993,-26.0431282111,-17.5592080572,-5.14566567559,4.74642445746,2.85472903182,13.9840406263,-8.65792657223,7.22421395725,17.40623,-2.03375429771,25.5011988214,4.70034154633,7.72781741606,-1.02137249144,2.80468392619,-0.635280614323,-3.6354936364,-3.53830126386,-4.47820180264,2.46904040755,7.28689173439,-2.8442546604,3.17715784445,3.36552267716,1.15757784407,7.75314900437,0.81631098463,2.48349101234,0.833434540513,0.21503645164,0.583841561755,0.28823281535,-1.64270047121,-0.692815001705,-2.08499143603,-1.35631470542,-0.229262144994,0.26245547932,-0.0513726528907,1.00450420332,-0.0345091260133,0.858523482007,2.26963260342,-0.35750499314,0.74356034228,-0.00585432367171,-0.0373394001607,0.354292237031,-0.0614026097828,0.141333525435,0.578793995436,-0.304965461689,0.231988206905,-0.471776023713,-0.258279408495,-0.0702399213,-0.0560742492634,-0.225948744678,0.0256859980284,-0.0430081209275,0.312949069179,0.321783383933,-0.0861795592352,0.208496223785,-0.153996201877,0.0262229124346,0.0482462805453,-0.0470414349918,0.222394395723,0.0734679729487,-0.0391482536136,0.0899589448852,-0.00231349517205],[-28415.6443859,-990.133700658,1491.90148047,-1500.13744007,448.603155839,546.962843805,-225.449778982,1217.86676911,1007.24485448,-532.880403948,-632.712662287,416.830458791,-678.167553741,28.9397420962,-606.433020355,-112.330464323,359.465480174,-113.00844525,-38.3975573992,14.7686971652,162.345626357,249.821930832,180.623929606,-295.337242528,71.7541292551,20.0831048495,101.18178737,18.7943219743,44.9107943175,-11.8592484907,85.1612656878,111.732485308,-44.8892379473,62.3045022454,-111.451920191,-35.2048399493,35.0201089542,2.50194375138,-1.87002180525,55.9033630383,-19.664954363,-0.932305703386,63.4704228208,8.73226066107,58.5150489585,-3.8842073078,31.3536978513,-25.4010346303,-18.1964425719,-5.10255336232,4.90584554303,3.11704037607,14.6180822074,-8.6512888101,7.56996213937,17.4853399356,-1.62095488735,25.5984852773,5.10226165403,7.62703973582,-0.876712239606,2.86907479839,-0.864417833458,-3.74011174857,-3.64426956955,-4.49606837754,2.55198232097,7.45043911843,-2.93110117609,3.29101086815,3.38698222741,1.29533292646,7.79231078112,0.94319904373,2.48084536219,0.969959842445,0.161690114548,0.627206341602,0.332799962854,-1.65189030791,-0.707227643698,-2.13732918202,-1.37855218874,-0.222043787546,0.258119630858,-0.0642182523492,1.0506629328,-0.0501059146043,0.892884214642,2.27865522482,-0.341822319485,0.730885671786,0.0169500536228,-0.0788061689531,0.366178413113,-0.0673966637102,0.13300930404,0.58060125429,-0.308612548065,0.236012825075,-0.486789927044,-0.263886681818,-0.0710617161133,-0.0651235652654,-0.229596981371,0.0300933919197,-0.0456543528508,0.319324279018,0.319005288809,-0.0826137316619,0.207695146539,-0.148332635394,0.0157589105734,0.0607456917531,-0.0522368950981,0.223649465722,0.0736909872941,-0.0407787488417,0.0915707643824,-0.0034154470256],[-28425.5230721,-961.288547898,1504.22775049,-1535.29164008,448.327781719,538.534779075,-212.392293345,1234.41162003,1037.72855443,-529.623871859,-636.333606935,413.532653474,-702.548161064,22.1886699897,-623.310878741,-116.559176472,364.862042055,-108.136118119,-41.0317755891,6.51927563834,166.339716763,262.339576451,184.122290413,-297.784960426,67.8914506372,22.2423250846,102.460088817,20.1460450129,42.9116994069,-8.46667611519,87.5588289044,115.629423193,-44.280875065,64.3804327477,-112.869500229,-37.0087038604,36.2538494941,2.3010179852,-1.29677444293,57.5444279197,-18.485637844,0.150974900753,63.819382065,11.1093209339,58.3892575539,-2.70522701316,31.4505117666,-24.6682667102,-18.796534334,-5.09906710274,5.04449724811,3.32301616011,15.205360787,-8.64065240258,7.9104476686,17.5276116534,-1.18637107297,25.6385945136,5.51507681097,7.49651183204,-0.725366611041,2.92767019175,-1.09791798137,-3.83178384381,-3.74686109883,-4.515969924,2.61561482253,7.59770608368,-3.01998172791,3.39369479631,3.40169432293,1.435967591,7.81806049119,1.0792738685,2.46534529322,1.11425510782,0.104296618073,0.669252384505,0.375861238988,-1.65492008964,-0.718855071645,-2.18465899956,-1.39863465117,-0.218906346988,0.250810722624,-0.0786255447381,1.09203549302,-0.0664880991423,0.924887304138,2.28426063404,-0.323468146338,0.712646734621,0.041163932892,-0.124141326794,0.376288536335,-0.0756246501393,0.124796818478,0.58176736709,-0.311699572055,0.24037695428,-0.500027723292,-0.268527689089,-0.0719283700779,-0.0741644735028,-0.233696159618,0.0332798396262,-0.0484000871215,0.324223804745,0.315641903188,-0.0788516931877,0.20575082771,-0.141967306023,0.00383738335117,0.0735591193686,-0.0581145775795,0.224456247196,0.0739826473014,-0.0425842465771,0.0930021701186,-0.00446811874998],[-28428.4058147,-935.672035111,1514.42389256,-1570.4491784,449.851891819,532.064368112,-197.655368477,1251.18517304,1066.45085732,-525.222171385,-640.634561085,411.58478564,-724.776142495,15.6630240053,-641.467643127,-121.704748025,369.85564966,-103.559076336,-42.9918812899,-1.22158856891,170.121798289,275.599910475,187.880499197,-298.887246871,63.9911645846,24.129794901,103.517757277,21.5073127703,40.9076535773,-5.13648319944,90.0665478311,119.469507988,-43.4491780491,66.240063218,-114.123198403,-38.7648588334,37.3192351451,1.98751671843,-0.793395941788,59.0818585952,-17.266696206,1.33405035725,64.0423852181,13.6269219271,58.1228366922,-1.43663096431,31.5404229501,-23.8523238443,-19.359639601,-5.13401720162,5.16277054341,3.47316557609,15.7458681815,-8.62858777233,8.2487896709,17.5331465826,-0.730657529692,25.6220426629,5.93766916806,7.33639001518,-0.569215548605,2.98038104601,-1.33314691905,-3.91007030182,-3.84621157412,-4.5373005073,2.65971889597,7.72835820807,-3.11129258172,3.48618277538,3.40948396799,1.57947717383,7.83054097359,1.22414885639,2.43720265192,1.26576406638,0.0430468134365,0.710422845768,0.417104245427,-1.65229541493,-0.727437603314,-2.22700253035,-1.41656384305,-0.219690094431,0.240470610497,-0.0947385649364,1.12867096441,-0.0837046134458,0.954675431267,2.28639097359,-0.302479635979,0.688882156783,0.0668457938905,-0.173247558922,0.384568623258,-0.0860916213946,0.116449526851,0.582190313488,-0.314191132835,0.245095536865,-0.511435496947,-0.27221459012,-0.0728106974083,-0.0832726147156,-0.238273920961,0.0352407037602,-0.0512991778166,0.327671012969,0.311676905569,-0.0748958836965,0.202637897492,-0.134842603323,-0.00952369761359,0.0865871780417,-0.0646838483303,0.224745859411,0.0742973964056,-0.0445432316246,0.0942922569351,-0.00546337734964],[-28425.4789124,-914.238353771,1521.08450278,-1605.45405598,452.352466864,527.373916667,-182.088977917,1267.78920648,1093.43236438,-519.891920162,-645.812594823,410.587710552,-745.38406504,9.54238124081,-660.641082685,-127.615602979,374.429965485,-99.2317167482,-44.3034587638,-8.5714424267,173.7060358,289.581561366,191.760573995,-298.676262871,60.0503423881,25.7784131143,104.387193199,22.882573212,38.8672906212,-1.91556550546,92.664860404,123.20332424,-42.4185076945,67.8900666748,-115.189320722,-40.4741861549,38.2254867782,1.57974352223,-0.353974588055,60.5103011975,-16.0269801967,2.62130169385,64.1402592647,16.2726952949,57.7231201547,-0.0788595516167,31.619492291,-22.9624655341,-19.8865234423,-5.20455534194,5.26174290275,3.56970855748,16.2402174367,-8.61811790557,8.58835900811,17.5026152717,-0.255202006681,25.549841705,6.36842303468,7.14706843488,-0.410480649116,3.02709364756,-1.56730508982,-3.97466676576,-3.94246609588,-4.55926605225,2.68454742369,7.84220278297,-3.20550665466,3.56961610799,3.41023190268,1.72582178519,7.82999020664,1.37722329496,2.39683980178,1.42386951249,-0.0218389938495,0.751237735796,0.456248899057,-1.64462121876,-0.732760884547,-2.26447250882,-1.43237402361,-0.224130413945,0.227060271436,-0.112715683561,1.16067696695,-0.101795998144,0.982454892859,2.28503034685,-0.278982339979,0.65969117544,0.0940687545179,-0.226003662163,0.390976034273,-0.0987618779489,0.107693046692,0.581752886626,-0.316064185847,0.250161307259,-0.520989267434,-0.274973403259,-0.0736787316498,-0.0925400934369,-0.243346915883,0.0359960043636,-0.0544012560614,0.329709355177,0.307105257541,-0.0707619777385,0.198339751422,-0.126893792162,-0.0242842448486,0.0997149582821,-0.0719428285683,0.224442890037,0.0745771740321,-0.0466343190311,0.0954894365128,-0.00639557325705],[-28417.9286644,-897.94169535,1522.80417725,-1640.15027377,455.006487577,524.285730493,-166.543095204,1283.82549867,1118.6936768,-513.849735825,-652.064778237,410.142283476,-764.904495705,4.006318794,-680.56896659,-134.140165329,378.568652025,-95.1084362031,-44.9920922731,-15.6478329052,177.106594159,304.263157584,195.624532842,-297.184169436,56.0660553387,27.2210785405,105.100797033,24.2762743037,36.7592443309,1.14918120467,95.3342045593,126.781456495,-41.213224796,69.3371161364,-116.044173194,-42.1375671109,38.9818252644,1.09600196777,0.0274013320555,61.8244018593,-14.7853405639,4.0171099383,64.1138311898,19.0342726919,57.197441723,1.36764683457,31.6837806784,-22.0079512809,-20.3779509274,-5.30783320671,5.34249179993,3.61486503778,16.6890215986,-8.61226578855,8.93252654206,17.4366882689,0.238607746909,25.4230036197,6.80572272021,6.92894124072,-0.251383509391,3.06769428277,-1.79759293701,-4.02526887877,-4.03576976458,-4.5810724837,2.6903532881,7.93904709978,-3.30309686386,3.64513609679,3.40381886709,1.87496153534,7.81664616862,1.5378964718,2.34467910624,1.58795424053,-0.0901404982733,0.792217064994,0.493015116761,-1.63250243616,-0.734610561186,-2.29718166945,-1.44609945205,-0.231962689599,0.210540682402,-0.13271527123,1.18816112057,-0.120802793864,1.00843198574,2.28016285722,-0.253101809909,0.625173027759,0.122905932674,-0.282288433346,0.395468129767,-0.113599720275,0.0982529955374,0.580337879643,-0.317295686533,0.255566999892,-0.528665054184,-0.276830146858,-0.0745025063481,-0.1020590142,-0.24893179487,0.0355657614787,-0.0577559529808,0.330382282854,0.301921920697,-0.0664656498639,0.192839785036,-0.11805613741,-0.0404041708815,0.1128275506,-0.079889639511,0.223471926744,0.0747639196065,-0.0488361238437,0.0966421205327,-0.00725905690466],[-28406.9413697,-887.736251319,1518.17751206,-1674.38183272,456.990934684,522.622115341,-151.867693877,1298.89582793,1142.25539579,-507.312236008,-659.588181415,409.849359676,-783.870001494,-0.765586237248,-700.989064014,-141.126859071,382.255371777,-91.1436315485,-45.08336608,-22.5683069747,180.337638231,319.62332759,199.334393774,-294.443127573,52.0353747272,28.4906899953,105.690969228,25.6928640108,34.552148499,4.0108611689,98.0550182331,130.154489301,-39.8576901487,70.5878846214,-116.664061828,-43.7558829877,39.5974714748,0.554595626223,0.356643532326,63.0188067135,-13.5606280554,5.52585611835,63.9639279782,21.8992857725,56.5531351786,2.9024478039,31.7293490016,-20.998040586,-20.8346871256,-5.44100247892,5.40609470875,3.61085495048,17.0928937131,-8.61405440748,9.28466313458,17.3360361228,0.74938398192,25.242540387,7.24795253405,6.68240258232,-0.0941457262474,3.10206923803,-2.02121090393,-4.06157228402,-4.12626768067,-4.60192572647,2.67738937159,8.01869844989,-3.40453612647,3.71388404442,3.3901256013,2.02685653456,7.79074683784,1.70556767446,2.28114292879,1.75740104486,-0.161637394323,0.833880843768,0.527122815423,-1.61654400213,-0.732772279074,-2.32524274668,-1.45777438758,-0.242922305464,0.190872820354,-0.154895698561,1.21123104523,-0.140765541237,1.03281300674,2.27177260809,-0.224963597338,0.585426950909,0.153430446258,-0.341980669299,0.398002270129,-0.130569448847,0.0878549909195,0.57782808568,-0.317862590333,0.261305349193,-0.534438876624,-0.277810839264,-0.0752520550486,-0.111921481538,-0.255045208405,0.0339699951475,-0.0614128996999,0.329733247487,0.296121856627,-0.0620225746227,0.186121393873,-0.108264903937,-0.0578433882402,0.125810045505,-0.0885224023761,0.221757557201,0.0747995725545,-0.0511272611092,0.0977987206759,-0.00804817872492],[-28393.3935585,-884.161122747,1506.23467313,-1707.8513274,457.746598387,522.22705757,-138.711805069,1312.59784598,1164.1497127,-500.444842923,-668.478834678,409.372793023,-802.637556417,-4.63062786672,-721.624606491,-148.44483343,385.48172987,-87.2783739066,-44.6003237516,-29.4248006347,183.404298115,335.629386764,202.76804364,-290.50156192,47.958575316,29.6185418683,106.187254706,27.1377901525,32.2216023103,6.62890959408,100.809306483,133.284361925,-38.3740061623,71.6487687624,-117.033569283,-45.3285602002,40.082179444,-0.0280957790206,0.63889287849,64.0896285402,-12.369424909,7.15010606894,63.6925317882,24.8546756923,55.7971323804,4.5208282751,31.7525610089,-19.9419798389,-21.25746469,-5.60149489728,5.45383635858,3.56003019918,17.4521037196,-8.62578135425,9.6473591198,17.2021293144,1.27512158234,25.0099113132,7.6928311894,6.40801189273,0.0590080646317,3.13026453976,-2.235790402,-4.08345151523,-4.21396555345,-4.62113024021,2.64618234484,8.08108366549,-3.51007887821,3.77686329497,3.36927374303,2.1813021095,7.75255935069,1.87939551876,2.20661829844,1.93143812774,-0.236088238355,0.876649429883,0.558335539336,-1.59737331207,-0.727116240037,-2.34873843502,-1.4674408925,-0.256742099877,0.168053713148,-0.179334979618,1.22999767126,-0.161670718667,1.05574129641,2.2598665834,-0.194756700403,0.540546854792,0.18560585935,-0.404893572664,0.39853017325,-0.149601559581,0.0762445038438,0.574147429361,-0.317762812802,0.267363376439,-0.538299337089,-0.277938154794,-0.0758990506369,-0.12218876669,-0.261700870769,0.0312289332694,-0.0654032720447,0.327800135931,0.289712314784,-0.0574627318514,0.178181571433,-0.0974990592272,-0.0765412442936,0.138553766124,-0.0978275133429,0.219234123626,0.0746441102677,-0.0534879979458,0.0990010648079,-0.00875551102399],[-28376.9226871,-886.09504909,1487.7481056,-1739.69572682,457.769506798,523.031265955,-126.920690296,1324.51269813,1184.4551795,-493.208197085,-678.428609291,408.628431819,-820.861762506,-7.59358455467,-742.140674994,-156.046138543,388.271101968,-83.4004314982,-43.5558460735,-36.2068060017,186.275564844,352.203398169,205.86684455,-285.472951631,43.8487457539,30.6295108441,106.607776292,28.6204999611,29.7710665197,8.9880855626,103.585342853,136.17843252,-36.7752417052,72.5250596493,-117.170384813,-46.8492056777,40.4478358608,-0.643387915724,0.876206844096,65.0388467104,-11.219239323,8.88516485387,63.306245472,27.8846216106,54.9347574974,6.20097440319,31.7509918858,-18.8489629825,-21.6468866083,-5.78786242333,5.48783050095,3.46527056797,17.7655491331,-8.6468426433,10.020082721,17.0396380557,1.81134596477,24.7283650097,8.13541501471,6.10698973883,0.2058410721,3.15296517463,-2.44068671504,-4.09149666848,-4.29831152752,-4.6383846239,2.59835403155,8.1266077421,-3.61910562916,3.83452535842,3.34234852059,2.33743445251,7.70246747596,2.05757593339,2.12135090643,2.10867532291,-0.313167034198,0.920544570547,0.586591342433,-1.57570760308,-0.717850869832,-2.36763126922,-1.47517224141,-0.27314472825,0.142224592224,-0.205789702254,1.24458517044,-0.183288555667,1.07710837021,2.24454328938,-0.162923903505,0.490605340259,0.218957520741,-0.470577969335,0.396980987041,-0.170491330171,0.0632464192008,0.569384361251,-0.317078109945,0.273705250296,-0.540285369546,-0.277221391618,-0.0764217233596,-0.132798807717,-0.268900751434,0.0273636351727,-0.0696844246453,0.324598576511,0.282749696073,-0.0528733225307,0.169071703084,-0.0859123812271,-0.0963548257766,0.150974966054,-0.107744468437,0.215874986423,0.0743296620028,-0.0559052097576,0.100264645532,-0.00936651360283],[-28356.856443,-892.001679397,1463.92582445,-1768.91059361,457.819497508,524.987129879,-116.138668664,1334.21740308,1203.26193832,-485.511743581,-689.028336755,407.595122969,-838.021628798,-9.69610587295,-762.187812855,-163.903549778,390.65480637,-79.3842468186,-41.9602731362,-42.8782042217,188.911394688,369.256111789,208.588027425,-279.487039487,39.7221781612,31.5468691811,106.967801284,30.1514405223,27.2109672744,11.0794791258,106.372968009,138.85541396,-35.0722072607,73.2217719858,-117.100474322,-48.3099714779,40.7068605777,-1.28452029943,1.06987205464,65.8699072427,-10.1153109856,10.7245223441,62.8128270551,30.972612188,53.9709327757,7.91679765226,31.722519677,-17.7281708479,-22.0035234521,-5.99893707433,5.51039814295,3.32958781108,18.031784362,-8.67590889473,10.4015216336,16.8540324916,2.35296517893,24.4015974145,8.57009474229,5.78072197093,0.344113466145,3.17101586934,-2.63568609494,-4.08647673039,-4.3786143563,-4.65348601134,2.53580004371,8.15579521607,-3.73077840798,3.88718378621,3.31067605991,2.49422497235,7.64088414053,2.23806417524,2.02555110954,2.28756787198,-0.392526647549,0.965488360329,0.611871906055,-1.55228657265,-0.705269150201,-2.38185374405,-1.48104951199,-0.291850300261,0.113562739918,-0.23393609777,1.25512102492,-0.205335219526,1.09674278731,2.22592411279,-0.129971437611,0.435669680896,0.252901225405,-0.538519091024,0.393278216914,-0.193000233756,0.0487054753522,0.563668463401,-0.315911197883,0.280289426276,-0.540448490868,-0.275666503872,-0.0767999428031,-0.143658709384,-0.276643883665,0.0223953680428,-0.0741952568323,0.320138632918,0.275302689262,-0.0483558529277,0.158856772158,-0.073702350498,-0.117120654265,0.162996131509,-0.118201038647,0.211663260547,0.0739063949823,-0.0583674240196,0.101598371636,-0.00986486813614],[-28332.5225136,-900.34466272,1435.97584464,-1794.49149038,458.656408107,528.047038721,-106.010059283,1341.28897952,1220.66013127,-477.264927504,-699.868848568,406.251713382,-853.596164329,-10.9798413934,-781.416563408,-171.9898425,392.664161372,-75.104262363,-39.8239450301,-49.4028764406,191.271743917,386.698277607,210.888823189,-272.673568271,35.5951646582,32.3938891378,107.282596979,31.7410589219,24.5517307217,12.8941803349,109.162022616,141.334019117,-33.2757133121,73.7439204761,-116.849803715,-49.7030096588,40.871673447,-1.9447324457,1.22117513563,66.5862561554,-9.06287958504,12.6616684108,62.2200345632,34.1021360849,52.9105804616,9.64220948642,31.6650224272,-16.5887842662,-22.3279457927,-6.23355086756,5.52386029166,3.15599368272,18.2493638147,-8.71165072862,10.7903635533,16.6507827669,2.89488727456,24.0333044655,8.9912611044,5.43059443936,0.471585416756,3.18526135063,-2.8205747936,-4.06916068761,-4.45418279321,-4.66623153635,2.46041599331,8.16917062374,-3.84425924335,3.93515212978,3.27558248694,2.65064507778,7.56822227128,2.41881550123,1.91942926457,2.46657101657,-0.473819944103,1.01140289379,0.634158911545,-1.52784991828,-0.689664062884,-2.39133835432,-1.48515378191,-0.31257892559,0.0822454385691,-0.263450397468,1.26173271687,-0.227526877535,1.1144731069,2.2041304404,-0.0964055336891,0.375807150288,0.286852768313,-0.608202169438,0.387345368284,-0.216889743473,0.0324664106599,0.557129317858,-0.314364792733,0.287074359892,-0.538840217929,-0.273279445694,-0.0770135785542,-0.154675576459,-0.284929300729,0.0163453990653,-0.0788746679366,0.314430368845,0.267439983119,-0.0440118293095,0.147601761986,-0.0610664476014,-0.138675251335,0.174539748703,-0.12912499496,0.206582060951,0.0734244764292,-0.0608631682073,0.103011151908,-0.0102342562986],[-28303.2485865,-909.58764811,1405.10618114,-1815.43397976,461.040076184,532.163381865,-96.1791812603,1345.30444617,1236.73990048,-468.377193941,-710.540976231,404.577049964,-867.064378136,-11.4864406879,-799.477469984,-180.277792075,394.330485274,-70.4349206267,-37.1572018456,-55.7447038045,193.316568799,404.440645607,212.726462765,-265.162280764,31.4839973651,33.1938429724,107.567430675,33.3998022457,21.8037830087,14.4232792413,111.94234734,143.632960867,-31.3965703426,74.096519824,-116.444338894,-51.020472278,40.9546943212,-2.61726387006,1.33140271255,67.1913394671,-8.06718480954,14.6900929247,61.5356260217,37.2566819619,51.7586228013,11.3511213698,31.5763781809,-15.4399840685,-22.6207242017,-6.49053582026,5.53053795417,2.94749993711,18.4168418999,-8.75273876506,11.1852961756,16.4353590265,3.43202030139,23.6271821008,9.39330483334,5.05799299444,0.586017093919,3.1965463452,-2.99513906292,-4.04031752677,-4.52432559169,-4.67641833272,2.37409749231,8.16725850145,-3.95871016394,3.97874394057,3.23839392762,2.80566617755,7.4848947951,2.59778516828,1.80319572831,2.64413999831,-0.556699789559,1.05821026551,0.653434040243,-1.50313733745,-0.671328589623,-2.39601759481,-1.48756612886,-0.335050713915,0.0484499705128,-0.294008832648,1.26454772844,-0.249579696981,1.13012788814,2.179283659,-0.0627324227056,0.311085022022,0.320227944438,-0.679112436287,0.379105946563,-0.24192133246,0.0143739634855,0.549896506674,-0.312541610615,0.294018506656,-0.5355120676,-0.270066171219,-0.0770425001995,-0.165756513706,-0.293756035895,0.00923499542574,-0.0836615572892,0.307483847984,0.259230266412,-0.0399427579431,0.135371655902,-0.0482021530986,-0.160855138563,0.185528303849,-0.140444108364,0.200614502586,0.072934073566,-0.0633809697958,0.104511895136,-0.0104583597649],[-28268.8756708,-918.426307056,1372.31901148,-1830.9818038,465.540485329,537.321893021,-86.3437075567,1345.99638512,1251.50812421,-458.812776728,-720.722873413,402.605457135,-877.9870426,-11.2152977327,-816.063590441,-188.746997741,395.682775485,-65.2881426222,-33.9874234144,-61.8699752336,195.013726786,422.377032765,214.061644021,-257.073341834,27.4049093733,33.966893093,107.826770373,35.1376511811,18.9771127247,15.6666947711,114.698143669,145.764630621,-29.4516151713,74.2845067098,-115.910506882,-52.2558309701,40.9677247403,-3.29825068441,1.40299009354,67.6871287633,-7.13088682983,16.7993935536,60.7672328192,40.4179007488,50.5208689872,13.0194059555,31.4550179178,-14.2905885395,-22.8825349012,-6.76844475962,5.53195165205,2.70749174007,18.5328381112,-8.79710512234,11.5844356491,16.212670412,3.95900505312,23.1869014374,9.77042498179,4.6647724326,0.685227571549,3.20553293807,-3.15919268955,-4.0008288536,-4.58848152572,-4.68396828334,2.2787082467,8.15056447573,-4.07298707822,4.01809041604,3.20042837742,2.95826374796,7.39134217173,2.77303181785,1.67733918608,2.8186738136,-0.640662411752,1.1057107186,0.669718664001,-1.47878367733,-0.650599685261,-2.39589534416,-1.48838240539,-0.359003960504,0.0123622493978,-0.325215935333,1.26369066307,-0.271169402319,1.1435870667,2.15155127667,-0.0294291895407,0.241699233983,0.352460737673,-0.750707909119,0.36849427249,-0.267846601456,-0.0056654246241,0.542096732491,-0.310522696856,0.301073038727,-0.530535672784,-0.266044141956,-0.0768817559421,-0.176809620563,-0.303091864366,0.00110263738881,-0.088477634761,0.299336579564,0.250749937858,-0.0362291294818,0.122250008312,-0.035300195476,-0.183471717673,0.195880338389,-0.152069664272,0.193759805391,0.0724833428837,-0.0659060649946,0.106103534188,-0.0105244936337],[-28231.2980629,-926.484400796,1337.79316346,-1841.37142229,471.968203127,543.641683216,-76.4147265386,1343.71963218,1264.63862519,-448.755064669,-730.441982465,400.593169349,-886.251983483,-9.99678412124,-831.038040734,-197.404354215,396.740745863,-59.7257634308,-30.4101485325,-67.7546107462,196.362680066,440.333524022,214.868932619,-248.488604691,23.3738976578,34.7207625059,108.021886879,36.9627208224,16.0799582256,16.6596613492,117.391056388,147.716133953,-27.4817899606,74.3125057184,-115.276579166,-53.4078356754,40.9200929947,-3.99541538598,1.44296731718,68.0696978979,-6.24632774649,18.9635991507,59.9219797958,43.5600924526,49.2066759955,14.6307806534,31.3015843565,-13.1479657781,-23.1144767166,-7.06471375251,5.5264199648,2.44084790389,18.5962322825,-8.83972791149,11.9836119347,15.9853820531,4.46941329928,22.7160343105,10.1160538841,4.2546633347,0.767271539266,3.21215264751,-3.31265959906,-3.9520267501,-4.64660945154,-4.68930226744,2.17598433845,8.11951853386,-4.18472141388,4.05259333769,3.16297130985,3.10742953539,7.28811499238,2.94302762962,1.54346163737,2.98834647805,-0.724577487083,1.15321709035,0.683192916698,-1.45500438372,-0.627990197048,-2.39126101638,-1.48775756356,-0.384249702973,-0.0257972858813,-0.356389440434,1.25927460933,-0.291809946652,1.15493608414,2.1212852867,0.00314366527466,0.168360381262,0.38305788759,-0.82233774883,0.355487928101,-0.294377661598,-0.0274984993822,0.533845180328,-0.308302413619,0.308159994851,-0.524063130489,-0.261276848911,-0.0765871084512,-0.187746975146,-0.3127795291,-0.00794434246403,-0.0931758523841,0.290135854957,0.242106235979,-0.0328673721238,0.108394657928,-0.0225242949191,-0.206235910986,0.20549861467,-0.163847005804,0.186081609234,0.072112397946,-0.0684105249499,0.107765098254,-0.0104345067001],[-28192.9233803,-933.617713005,1301.50162743,-1847.08747446,479.943943164,551.275207808,-66.3566804242,1338.98458656,1275.72196231,-438.442235316,-739.813067906,398.851898575,-891.828789891,-7.61901585145,-844.306451343,-206.263580084,397.521789378,-53.8470966507,-26.5379557374,-73.376938135,197.370792009,458.119271314,215.126361163,-239.480344632,19.4069001648,35.4600643671,108.103251702,38.8826598659,13.1201203095,17.4462422755,119.977091105,149.468254973,-25.5340632087,74.1850634111,-114.571288355,-54.476555911,40.8205090623,-4.71937706835,1.45951310471,68.3336462915,-5.40327014258,21.1528463661,59.0068651546,46.6557193495,47.8262877485,16.1709240623,31.1172731504,-12.0191213368,-23.3177541238,-7.37649967574,5.51146098641,2.15282065246,18.605969333,-8.87484674173,12.3780834462,15.7555980767,4.95654955337,22.2181277341,10.4234321949,3.83186522773,0.830262590615,3.21615435007,-3.45549125176,-3.89535591733,-4.69879824595,-4.69296591331,2.06762994352,8.07453175334,-4.29123847845,4.08147213305,3.12730006795,3.25215935376,7.1757913811,3.10634816784,1.40344341022,3.15127576203,-0.80715805409,1.19992036661,0.694076622724,-1.43191005208,-0.604056945339,-2.38247540934,-1.48586133032,-0.410617164529,-0.0657995651188,-0.386775383586,1.25140977708,-0.31097484025,1.16431175849,2.08888380372,0.0346547872968,0.0919077232471,0.411544322684,-0.893323902155,0.340075310757,-0.321216751624,-0.0509103033168,0.5252541558,-0.305853452275,0.315194130418,-0.516266653752,-0.255839290461,-0.0762294990127,-0.19848165024,-0.322630514994,-0.0177813984721,-0.0975919727309,0.280056411071,0.233414109245,-0.0298328984535,0.0939820145375,-0.0100314195382,-0.228833520971,0.214281950264,-0.175604990504,0.17765965897,0.0718593415849,-0.0708631295423,0.109469640603,-0.0101938811832],[-28156.1592411,-939.68202736,1263.41739376,-1848.61459951,489.088419023,560.374922155,-56.1340114316,1332.30164745,1284.34869445,-428.112466218,-748.950894254,397.693356779,-894.68705093,-3.87010892118,-855.774452748,-215.338393939,398.043299,-47.7514558805,-22.4834235664,-78.7152851927,198.045425987,475.543426575,214.811962261,-230.120836953,15.5198548403,36.1894118324,108.021336348,40.9051170075,10.1053997742,18.0705008498,122.412253427,151.001777794,-23.6554034136,73.906726349,-113.823367054,-55.4620611939,40.6776829213,-5.48075482509,1.46080617734,68.4735733651,-4.59147660112,23.3372718497,58.0288870986,49.6772437161,46.3899481685,17.625514781,30.9032799531,-10.9110607682,-23.4935715988,-7.70095940609,5.48459281085,1.84866220967,18.560994182,-8.89670122228,12.7631085977,15.5254226093,5.41371832889,21.6967287226,10.685800569,3.40057763866,0.872314319143,3.21728692232,-3.58763910798,-3.83226105639,-4.74513678573,-4.69550484926,1.95534923788,8.01601521164,-4.38986357943,4.10394622963,3.09469199477,3.391449017,7.05494946197,3.26156899675,1.25916483264,3.30557943594,-0.887117151314,1.24501153321,0.702589606468,-1.40961127786,-0.579356750488,-2.3698993209,-1.48286343259,-0.437935568376,-0.107415518109,-0.415619800422,1.24020637619,-0.328137593379,1.17185090778,2.05474494233,0.0647728220822,0.013180519328,0.437444971449,-0.96298831583,0.322244817819,-0.34806611027,-0.0756858789563,0.51643596452,-0.303148504194,0.322090200819,-0.507318455609,-0.249806464984,-0.0758798689124,-0.208926718631,-0.332456306943,-0.0282839849748,-0.101561758374,0.269272984815,0.224788506128,-0.0271011210555,0.0791884879263,0.00202146255613,-0.250950350097,0.222129162744,-0.187172475918,0.168573699453,0.0717622766321,-0.073232658652,0.111190214507,-0.00980809930213],[-28123.4132631,-944.533127536,1223.5134528,-1846.43743669,499.022344291,571.093281613,-45.7111617793,1324.18121408,1290.10938049,-418.003934926,-757.97022603,397.429255929,-894.796355706,1.46182067168,-865.347675429,-224.642514366,398.322667699,-41.5381547183,-18.3591305567,-83.7479797119,198.393945369,492.415141739,213.903768519,-220.48235695,11.7286996304,36.9134180579,107.726612327,43.0377409435,7.04359741768,18.5765003719,124.652548962,152.297486526,-21.8927790736,73.4820410934,-113.06154787,-56.3644210412,40.5003245495,-6.29016774978,1.4550252563,68.4840785395,-3.80070970519,25.4870122514,56.995043831,52.5971278285,44.9079011778,18.9802314083,30.6608004181,-9.83078962474,-23.6431336178,-8.03524982037,5.44333353212,1.53362479943,18.4602517487,-8.89953096237,13.133945803,15.2969597777,5.83422413932,21.1553842902,10.896399661,2.96500009448,0.891540318393,3.21529924082,-3.70905462802,-3.76418686833,-4.78571394769,-4.69746470361,1.8408463975,7.94437998623,-4.47792202433,4.11923505496,3.06642443334,3.52429433903,6.92616735905,3.40726568058,1.11250623267,3.44937527016,-0.963167817293,1.28768157601,0.708951692319,-1.38821865652,-0.554446432848,-2.35389354892,-1.47893359733,-0.466034137719,-0.150416074645,-0.442168726576,1.22577461652,-0.342771716309,1.17769035005,2.01926681716,0.093166415187,-0.066981971106,0.460284762377,-1.03065293659,0.301984846647,-0.374627976275,-0.101610268829,0.507502912102,-0.300160260748,0.328762961447,-0.497390749099,-0.243253370859,-0.0756091594359,-0.218995253105,-0.342068389843,-0.0393275563114,-0.104920971885,0.257960313097,0.216344375099,-0.0246474525141,0.0641904878816,0.0134773832537,-0.272272200832,0.228939069685,-0.198378319591,0.158903475536,0.0718593059197,-0.0754878921596,0.112899873235,-0.00928264327588],[-28096.2223597,-948.180469797,1181.7298854,-1840.96731939,509.380438363,583.550307185,-35.0863763215,1315.00480403,1292.64676321,-408.354892532,-766.969425174,398.272751464,-892.150474116,8.51149479648,-872.964595576,-234.181985183,398.36708356,-35.3038601553,-14.2723162375,-88.4514280396,198.399308406,508.556400466,212.388618516,-210.631199117,8.05316856137,37.6347611184,107.16991692,45.2875219099,3.9425976749,18.9976628599,126.659579043,153.338422197,-20.2852218583,72.9117921378,-112.317011572,-57.1821507663,40.2966107742,-7.1581649694,1.44938382981,68.3597800938,-3.02302613162,27.5759406886,55.9103806773,55.3882740526,43.3895269013,20.2185813197,30.3904480494,-8.78587969009,-23.7666876046,-8.37654354562,5.38572751662,1.21290897545,18.3028922404,-8.87840824063,13.486678171,15.0713872542,6.21150937182,20.5975001683,11.0482686015,2.52934896277,0.885718208417,3.21024693089,-3.81974176773,-3.69236106597,-4.8204861144,-4.69925802175,1.72578703747,7.86006082748,-4.55293620304,4.12664638022,3.0435103704,3.64965412193,6.79013921014,3.54181426872,0.965344461556,3.58080188213,-1.03402360704,1.32724607406,0.713399999623,-1.36786160647,-0.529836598233,-2.33477780477,-1.4741518484,-0.49473789537,-0.194547593919,-0.465728241356,1.20824919288,-0.354394543689,1.18193286323,1.98285522073,0.119486134219,-0.14772853927,0.479584331106,-1.09559592965,0.279323155742,-0.400594341029,-0.128473372911,0.498573213425,-0.296897694977,0.335132405793,-0.486651888496,-0.236240941299,-0.0754776909123,-0.228591348551,-0.351296189563,-0.0507879030229,-0.107505885227,0.2462942675,0.208197956842,-0.022448075027,0.0491708298109,0.0241849554089,-0.292494033196,0.234620767304,-0.209045857186,0.148732078169,0.0721937005754,-0.0775973554308,0.1145749398,-0.00862133788957],[-28072.6406275,-951.248200755,1137.87513435,-1832.32235785,519.853443878,597.736282454,-24.3931104578,1304.63840845,1291.81232097,-399.403884298,-775.98124331,400.042772722,-886.839899217,17.1049867915,-878.695072226,-243.932151123,398.142915125,-29.1346527526,-10.3088641044,-92.7943507394,197.946852865,523.840513309,210.28857472,-200.609734743,4.52817997958,38.3483787648,106.303550501,47.6588163041,0.810619529087,19.3248452052,128.417327912,154.116653495,-18.8400161233,72.1817157052,-111.630731583,-57.9075488698,40.0725858199,-8.0950157446,1.44723445405,68.0953717412,-2.25965893256,29.5928761478,54.7721314542,58.0253451123,41.840750274,21.3153869962,30.0905077525,-7.78616767249,-23.8606527747,-8.72207620989,5.31192422054,0.891508610792,18.0888870181,-8.83173601348,13.8206875899,14.8461768939,6.5395679082,20.0259169574,11.1336404241,2.0979079737,0.851281715275,3.20341261285,-3.91991446503,-3.61714340904,-4.84887969154,-4.70076501755,1.61168252945,7.76358717723,-4.61321683501,4.1258413512,3.0259053675,3.76633912055,6.64802320796,3.66279275103,0.819542463435,3.69808127742,-1.09840014148,1.36351897936,0.716240827545,-1.34874483789,-0.5058529943,-2.31270745392,-1.46823939743,-0.523855062564,-0.239458152709,-0.485844598768,1.18786273993,-0.3626987077,1.18454506484,1.94594665725,0.14331023499,-0.228160178797,0.494847141842,-1.15692033422,0.254444948166,-0.425616206544,-0.156084520976,0.489788720433,-0.293514906595,0.341139479759,-0.475254793034,-0.228773848862,-0.0755032998423,-0.237583188262,-0.360040895869,-0.0625421604565,-0.109154807929,0.234455258298,0.200470660884,-0.0204822492435,0.0343379516045,0.034015115736,-0.311347437405,0.2391244664,-0.218976336846,0.138155982691,0.0728294049103,-0.0795285557723,0.116204816177,-0.00782137819221],[-28049.8514587,-954.514139611,1091.7247329,-1820.54735646,530.146109289,613.609056648,-13.798622224,1292.81913687,1287.50971604,-391.38952903,-785.022029482,402.459692511,-878.979304856,26.9912078621,-882.641810126,-253.86068215,397.60632605,-23.1139664641,-6.54931864459,-96.7435469291,196.897511391,538.153622548,207.634505572,-190.454354314,1.19244831161,39.0472736667,105.080179219,50.1553220634,-2.34403439947,19.5382630176,129.915375533,154.626506025,-17.5565093956,71.2737859508,-111.046129488,-58.5313596485,39.8337607602,-9.11091936943,1.45096445224,67.685566053,-1.51413525392,31.5303740828,53.5755771009,60.4834438207,40.2666324333,22.2432996955,29.7586822837,-6.84205651133,-23.9204912914,-9.06909919149,5.2225993725,0.574365908325,17.818412731,-8.75874990675,14.1361806427,14.6178740979,6.81253150393,19.443333975,11.1445466381,1.67497769802,0.784328591533,3.19638565578,-4.00983915341,-3.538676669,-4.87018859054,-4.70173282197,1.50000568419,7.6555121502,-4.65727172205,4.11656945738,3.01330062988,3.87312307788,6.50109355896,3.76757960254,0.676959705668,3.79945630863,-1.15501355801,1.3964388371,0.717797770207,-1.3310918839,-0.482775154163,-2.28779677534,-1.46082775297,-0.553189660143,-0.284771257192,-0.50212409649,1.16487237728,-0.367420664902,1.18545953229,1.90898530883,0.164198895364,-0.307365933926,0.505572365933,-1.21368540797,0.227574788121,-0.449334327484,-0.184257900247,0.481297194337,-0.290202276985,0.346730367348,-0.463348523189,-0.220842700945,-0.0756932017701,-0.245829977636,-0.3682216395,-0.0744678001613,-0.109706558907,0.222624830443,0.193285188966,-0.0187300054262,0.0199066967734,0.0428443819139,-0.328573161227,0.242410656416,-0.227965484833,0.127275010538,0.0738355315314,-0.0812487459762,0.117782174086,-0.00687830179881],[-28025.0382456,-958.756105566,1043.05421431,-1805.68711965,539.963183045,631.126478996,-3.47016965577,1279.28409882,1279.6426107,-384.550445532,-794.108132737,405.243883642,-868.683364881,37.9190692139,-884.907514026,-263.935248225,396.713479994,-17.3252352436,-3.07422434545,-100.265815727,195.112216631,551.381870462,204.457279513,-180.201448316,-1.91531201596,39.7244484939,103.45246922,52.780737125,-5.5130614905,19.6181319066,131.143301874,154.862305388,-16.4340492022,70.1699770299,-110.606626872,-59.0443273993,39.5856466689,-10.2160751379,1.46296114756,67.1250756006,-0.789982241642,33.3809899475,52.3159985565,62.7376729912,38.6722345169,22.9749706752,29.3926743991,-5.963949146,-23.9416653181,-9.41486386872,5.11842870112,0.266423070931,17.4916460284,-8.65868554626,14.4333639126,14.3830242668,7.02453191446,18.8524505386,11.0730187529,1.2648587065,0.680956589756,3.19075542876,-4.0897822663,-3.4571036173,-4.88370672287,-4.70190856597,1.39222931249,7.53638886111,-4.683608666,4.0985801882,3.00538736278,3.96877973694,6.3506244696,3.85355329825,0.539455655615,3.88316982838,-1.20257999401,1.42594419248,0.718394421732,-1.31512627762,-0.46088261094,-2.260160048,-1.45154842359,-0.582545708948,-0.330110413542,-0.514173032201,1.13953522454,-0.368296871858,1.184608843,1.87241535761,0.181712293204,-0.384434848894,0.51125917473,-1.26495040858,0.198937239807,-0.471389458513,-0.212807697944,0.473246396346,-0.287150187529,0.351851252562,-0.451082139434,-0.21243810494,-0.0760546122396,-0.253190922067,-0.375757551195,-0.0864422936861,-0.108999957082,0.210984528883,0.186764242829,-0.0171713738377,0.00609190882857,0.0505492716217,-0.343911952427,0.244439826794,-0.235809027408,0.116188983143,0.0752811930459,-0.0827251788343,0.119299685244,-0.00578764632439],[-27995.3843803,-964.751917822,991.639111848,-1787.78645183,549.009413598,650.246398726,6.42498921103,1263.77040383,1268.11466721,-379.12525261,-803.255902119,408.115718925,-856.066753138,49.6374820522,-885.594888671,-274.123519313,395.420540611,-11.8518930451,0.0358743057428,-103.32795625,192.45190123,563.411399328,200.787764984,-169.887407235,-4.75638657658,40.3729059162,101.373086653,55.5387594264,-8.6881591237,19.5446674821,132.090686901,154.818377191,-15.4719830701,68.8522630977,-110.35564532,-59.4371964193,39.3337546197,-11.4206823442,1.48561186322,66.4086129556,-0.0907270416617,35.1372791957,50.9886767602,64.763135437,37.0626176622,23.4830511929,28.9901868549,-5.16224851588,-23.9196370182,-9.75662161988,5.00008793502,-0.0273776985119,17.1087635594,-8.53077855784,14.7124439825,14.1381728015,7.16970089528,18.2559659659,10.9110882778,0.871851569913,0.53726346251,3.18811130086,-4.16001023719,-3.37256702541,-4.88872799998,-4.70103938051,1.2898262251,7.40677042469,-4.69073546867,4.07162303313,3.00185677147,4.05208284074,6.19789014632,3.91809231319,0.408889780636,3.94746468928,-1.23981558689,1.45197359072,0.718354376242,-1.30107155217,-0.440454897747,-2.22991155088,-1.44003291783,-0.611727229822,-0.375099127936,-0.521597703582,1.11210840132,-0.36506378513,1.18192557437,1.83668098571,0.195410606373,-0.45845596794,0.511406739581,-1.30977459373,0.168756867428,-0.491422354297,-0.241548101291,0.465784087671,-0.284549019611,0.356448319404,-0.438604702242,-0.203550668242,-0.0765947467948,-0.259525226953,-0.382567761693,-0.0983431125799,-0.10687382137,0.199715898568,0.181030524214,-0.0157863847404,-0.00689156871901,0.0570063025385,-0.357104558772,0.245172466978,-0.242302690831,0.104997721942,0.0772355020605,-0.0839251071389,0.12075002137,-0.00454494938394],[-27958.5359496,-972.875979113,937.367270904,-1766.98692295,557.108080519,670.891696259,15.8136343805,1246.00588601,1252.89459814,-375.318268922,-812.426586421,410.811050894,-841.236680262,61.9100960117,-884.792820021,-284.389619316,393.694165852,-6.78324283128,2.71670109868,-105.909446718,188.802984532,574.140214001,196.651889649,-159.548466039,-7.29764900224,40.9913345867,98.7993962088,58.4259171652,-11.8629538123,19.3014830957,132.750651288,154.485931051,-14.6697039433,67.3104185934,-110.326356457,-59.7014676892,39.0848582628,-12.7333104911,1.52080506511,65.5320919894,0.581124673191,36.7920450432,49.5885564989,66.5361578126,35.4443566393,23.7443579916,28.5487701611,-4.44604850942,-23.850575213,-10.0908851448,4.86820566152,-0.302614189285,16.6702725811,-8.37397276521,14.973139268,13.8800604028,7.24327039061,17.6567706095,10.6522711714,0.49966123998,0.350016228341,3.18958753907,-4.22074358967,-3.28530125189,-4.88448532403,-4.69873691297,1.19404908997,7.2671885498,-4.67727235815,4.03555011519,3.00242440001,4.12188262572,6.04419526467,3.95874313821,0.286986524485,3.99070775545,-1.26567095028,1.47442363764,0.718054104114,-1.28906259578,-0.421758003865,-2.19716299962,-1.42593109426,-0.640542016477,-0.419362761879,-0.524004814003,1.08285862674,-0.357439966379,1.17735665977,1.8021959939,0.204908810392,-0.528551891502,0.505595240926,-1.34734166249,0.137246754979,-0.509066099502,-0.270274857029,0.459005844437,-0.282533314695,0.360460044643,-0.426056979447,-0.194179069935,-0.0773186948771,-0.264706284419,-0.388557454295,-0.110040980186,-0.103176722056,0.188986315169,0.176205435063,-0.0145513092994,-0.0188395552025,0.0621095763995,-0.367928946233,0.244573232041,-0.247250913072,0.093799068759,0.0797496881795,-0.0848132261186,0.122120943145,-0.00315363862629],[-27913.9898186,-981.889026322,880.575785363,-1743.81716517,564.556587856,692.845376785,24.9986980157,1225.68127774,1234.21131732,-373.196612537,-821.361033427,413.127650981,-824.270504032,74.5595144441,-882.534918879,-294.6834879,391.542990836,-2.2320636015,4.96905293104,-108.040481754,184.153832678,583.513769628,192.055818069,-149.220237612,-9.52832515913,41.6011670923,95.7075567533,61.4100595808,-15.0387886039,18.8857830679,133.13047854,153.843712644,-14.0267864339,65.5654190902,-110.51093206,-59.8316689256,38.8507815546,-14.1560099177,1.56843378998,64.4962317737,1.22715312249,38.339081753,48.1092379504,68.037962137,33.8300807482,23.7523697563,28.0653658443,-3.81920681133,-23.7334753568,-10.4112124296,4.72322190284,-0.556944159312,16.1780027811,-8.18604478354,15.2132155138,13.6062089705,7.24487309978,17.0585189621,10.2960211885,0.149610192219,0.118658969718,3.19449800206,-4.27201920792,-3.19590700377,-4.86996756012,-4.69407087638,1.10527000365,7.11808932194,-4.64228926751,3.99062409164,3.00690314782,4.17733530211,5.89096637642,3.97372432768,0.174930236489,4.01176193705,-1.28003460274,1.49302318151,0.718081580743,-1.27887971696,-0.405003743237,-2.16201585647,-1.4089662114,-0.668812954106,-0.462534098191,-0.521002689599,1.05209101801,-0.345072397673,1.17090645635,1.76925265762,0.210041071406,-0.593979444827,0.493728895569,-1.37733307945,0.104574065634,-0.523923098811,-0.298709949983,0.45279850243,-0.281014254571,0.363794076117,-0.413546568321,-0.184354275856,-0.0782230415169,-0.268664233503,-0.393576022544,-0.121379627029,-0.0977962348788,0.178906477237,0.172405178131,-0.0134273822894,-0.0295905213318,0.065823531165,-0.37631195359,0.242623439578,-0.250492978918,0.0826829469735,0.0828034489955,-0.0853440007492,0.123380567107,-0.00164870183555],[-27861.7055473,-990.148379865,821.714061239,-1718.90257616,571.770870778,715.85547669,34.3771503197,1202.47803598,1212.35878888,-372.79310138,-829.744990671,414.878770344,-805.238119011,87.4230791299,-878.840977256,-304.951518672,388.986144972,1.68299663601,6.80999497752,-109.763935083,178.518298503,591.489383935,187.000774027,-138.938179319,-11.443228972,42.2295220033,92.0784256961,64.4518661732,-18.2189356793,18.2981694608,133.240992869,152.867351663,-13.5428505707,63.6460404456,-110.891293945,-59.8230845289,38.6446110281,-15.6892011715,1.6278922173,63.3029526803,1.84995999891,39.7724313502,46.5439851399,69.2509942703,32.2339329216,23.5047306572,27.5367631849,-3.28427205536,-23.5680395617,-10.7104227817,4.56552953987,-0.788545358676,15.634114455,-7.9644794259,15.4299502972,13.3143357046,7.17524191087,16.4650565517,9.84327653341,-0.1775747169,-0.156694964907,3.20170144638,-4.31382806629,-3.10507657516,-4.84410256404,-4.68597550017,1.02364091986,6.95989742074,-4.58496855608,3.9372102533,3.01513025316,4.21767357358,5.73966050244,3.96142245182,0.0737702423664,4.00961415575,-1.28302953909,1.50745913125,0.719077657781,-1.27021457935,-0.390390385973,-2.12456902033,-1.3888798778,-0.696366700775,-0.504247775021,-0.512200062198,1.02012029184,-0.327590166181,1.1625936772,1.73811287096,0.210696353216,-0.654029009361,0.475792929407,-1.39955475057,0.0708944823632,-0.535588086907,-0.326556924499,0.446996712349,-0.27984718111,0.36635035443,-0.401172773493,-0.174115323534,-0.079302245642,-0.271343399975,-0.397458912545,-0.132196035427,-0.0906296869453,0.169572914043,0.169744656377,-0.0123720793875,-0.038993600661,0.0681301888518,-0.38221763783,0.239308572816,-0.251876884866,0.0717373003537,0.0863585990982,-0.0854693384434,0.124492098754,-7.30168296472e-05],[-27801.6426952,-996.01136016,761.231504546,-1692.86855362,579.166864454,739.670032356,44.3459614955,1176.07761769,1187.63097695,-374.140553373,-837.264205686,415.87766014,-784.209419765,100.33813185,-873.730787165,-315.14010524,386.042757673,4.84328987298,8.25659241279,-111.12268043,171.910234846,598.024374644,181.487981308,-128.737748527,-13.0371743656,42.9035178899,87.8928604467,67.512016442,-21.4066672197,17.5392443368,133.093018488,151.532477798,-13.2175163828,61.5810585165,-111.449363931,-59.6709988995,38.4794332164,-17.3333048005,1.69857452652,61.9541750812,2.45214699512,41.0861358596,44.886062093,70.1577000727,30.6700560921,22.9990848647,26.9597514632,-2.84379287528,-23.3539699399,-10.9813355087,4.39552145352,-0.995595537461,15.0407678984,-7.70676150534,15.6206211953,13.0021578048,7.03510971199,15.8802289059,9.29497541011,-0.481166630905,-0.475932227085,3.21005662861,-4.3461611391,-3.01350226019,-4.8058181916,-4.67338501379,0.949313792311,6.79303752584,-4.50449258319,3.87567389101,3.02694295428,4.24213014378,5.59173466361,3.92022408085,-0.0154441321618,3.98325133323,-1.27477875414,1.51741839576,0.721683186879,-1.26275884657,-0.378116202183,-2.08492139013,-1.36541370199,-0.72302991455,-0.54413843052,-0.497205663628,0.987261164921,-0.304622359069,1.15243703543,1.709038528,0.206763619626,-0.707990966551,0.451772568334,-1.41381258185,0.0363636881355,-0.543655798475,-0.353519324924,0.441435124894,-0.278887436183,0.368028820186,-0.389034899597,-0.163501250495,-0.08055076618,-0.272688109602,-0.400041570404,-0.142327187699,-0.0815744053603,0.16108215486,0.168338772758,-0.011342876271,-0.0468979267439,0.0690115714763,-0.385610055937,0.234614114978,-0.251250627412,0.0610500726678,0.0903769530772,-0.0851411466136,0.125418743588,0.00153053857348],[-27733.7608222,-997.835287624,699.577521298,-1666.34049525,587.160504052,764.037080168,55.302101746,1146.16147983,1160.32184567,-377.271786439,-843.604426003,415.937571526,-761.254300858,113.142014385,-867.224140621,-325.195641209,382.731958349,7.13016810115,9.32591041155,-112.15959152,164.343494544,603.076059478,175.518663696,-118.654402601,-14.3049752646,43.6502733225,83.1317184147,70.5511898871,-24.6052554059,16.6096097583,132.697379608,149.814720742,-13.0504038993,59.3992491602,-112.167063833,-59.3706964379,38.3683346523,-19.0887413524,1.77987489709,60.451819348,3.03631580381,42.2742373062,43.128732835,70.7405254042,29.1525931922,22.2330765492,26.3311199599,-2.50031790485,-23.0909686037,-11.2167699182,4.21359052472,-1.17627244575,14.4001234067,-7.41037583493,15.7825057853,12.667392471,6.82520939122,15.3078815528,8.65205602273,-0.760438693328,-0.838939468365,3.21842230531,-4.36900940068,-2.92187635299,-4.75404229861,-4.65523364668,0.882440574716,6.61793431687,-4.40004370816,3.80638029559,3.04217848944,4.2499377164,5.44864588078,3.84851578498,-0.0916635613759,3.93166039116,-1.25540524269,1.52258788394,0.726539019688,-1.25620418225,-0.368379461974,-2.04317186477,-1.3383092925,-0.748629253495,-0.581840702836,-0.475628225717,0.953828353981,-0.275798063508,1.14045524414,1.68229152283,0.198131834436,-0.755155697843,0.421653038247,-1.41991247924,0.00113736592012,-0.547720968199,-0.379300695601,0.435948390767,-0.27799036166,0.368729413988,-0.377232251261,-0.152551094267,-0.0819630620589,-0.272642688153,-0.401159442226,-0.151610066162,-0.0705277172294,0.15353072896,0.168302430234,-0.010297248617,-0.0531526331347,0.0684497010553,-0.386453264897,0.228525549291,-0.248462203051,0.0507092076841,0.0948203255223,-0.0843113326725,0.126123707106,0.0031190865559],[-27658.3333685,-994.56991917,637.134270909,-1639.86284377,596.081851315,788.68616551,67.5468574163,1112.5422592,1130.70314238,-382.206725929,-848.477773526,414.923890479,-736.439336149,125.678840447,-859.379228166,-335.060862202,379.070984343,8.46388744941,10.026309976,-112.902163355,155.830435976,606.621094954,169.105319167,-108.720905052,-15.2423534275,44.4884497543,77.7893101654,73.5325810917,-27.8142112738,15.5113970755,132.068096369,147.698347577,-13.0378014903,57.1266434597,-113.023728796,-58.91899289,38.3236670927,-20.9516862459,1.87058368,58.7997813848,3.60360205915,43.330102706,41.267737525,70.9872102561,27.6940031601,21.2096099061,25.6499006125,-2.25451188243,-22.7792271492,-11.4095826448,4.02042946231,-1.32879661233,13.7148389532,-7.07414130316,15.9130716188,12.3081175349,6.54726007041,14.7513337804,7.91738404836,-1.01479146289,-1.24478427315,3.22554357354,-4.38247574564,-2.83089698987,-4.68771153328,-4.63069299839,0.823116085233,6.43522572365,-4.2713351643,3.72966955681,3.06048443835,4.24056126248,5.31171220494,3.74533321185,-0.154024578558,3.85423268118,-1.2252202232,1.52266641248,0.734159699508,-1.25019617923,-0.361362875828,-1.9994140774,-1.30740911144,-0.772990302477,-0.617021994561,-0.447239864791,0.920158242098,-0.240948780837,1.12667080101,1.65811433575,0.184774347904,-0.794935387827,0.385502467983,-1.41779413187,-0.0345912066017,-0.547485799429,-0.403585396441,0.430387188288,-0.277012442113,0.368360738598,-0.365850848516,-0.141315023217,-0.0835279400339,-0.271169157914,-0.400688349625,-0.159891268977,-0.0574387096051,0.146999915596,0.169715960923,-0.00919570233198,-0.057640688055,0.0664422911138,-0.384746876907,0.221058246169,-0.243403322917,0.0407975982182,0.09964700356,-0.0829498583041,0.126566990017,0.00465253895603],[-27576.889296,-987.5347577,574.014926404,-1613.65622216,605.917474278,813.272869766,80.9987794204,1075.55731192,1098.95774727,-388.913726893,-851.701867638,412.910542258,-709.817816667,137.819811477,-850.407834467,-344.6638719,375.069504727,8.92032059539,10.3313354183,-113.316376046,146.377439698,608.713492753,162.30554247,-98.9592439747,-15.8486619474,45.4028801704,71.9137588868,76.4294449724,-31.0180012788,14.2528547892,131.231972612,145.202174949,-13.1626708912,54.778293402,-113.988347276,-58.3188293849,38.3548431891,-22.9013343841,1.96707591232,57.0098592243,4.14927716137,44.2443990384,39.3087208564,70.9066711436,26.300008956,19.9526292322,24.9240959873,-2.09950396477,-22.4208951088,-11.5527796313,3.81793028695,-1.45155968075,12.9895632221,-6.70221310031,16.0105461447,11.923853356,6.20692580637,14.2117999182,7.10153505611,-1.24413515909,-1.68925795727,3.22971089232,-4.38711074967,-2.7412856759,-4.60579771343,-4.59988414898,0.771206599785,6.24640267666,-4.12020368084,3.64578096028,3.08074974662,4.21439482257,5.18169580744,3.61230831873,-0.202407152997,3.75197727489,-1.18528780859,1.51740042922,0.74455453623,-1.24419614721,-0.357186915713,-1.95372059813,-1.27295903513,-0.795934353567,-0.64948076605,-0.412466235177,0.886673877852,-0.200715669094,1.11112134207,1.63667179192,0.167002056112,-0.827229433655,0.343720598148,-1.4079323615,-0.0704783728999,-0.543082370178,-0.425981049607,0.424666306259,-0.275814732906,0.366866045402,-0.35492357298,-0.129887729072,-0.0852115981709,-0.268300327251,-0.398665616252,-0.167055857664,-0.0424635093284,0.141509993956,0.172521413595,-0.00801086423975,-0.0603803983968,0.0630498212113,-0.380632725006,0.21234712478,-0.236140556693,0.0313779332744,0.104801164464,-0.0810989022779,0.126695773858,0.00610196623771],[-27491.2714474,-978.641742615,510.265414209,-1587.86029844,616.568067551,837.434283321,95.4807348143,1035.67517396,1065.24632378,-397.348251812,-853.120702091,410.023586941,-681.439712736,149.442900847,-840.560142725,-353.929116,370.735296502,8.61424435387,10.2058268783,-113.352830984,135.989391806,609.426603348,155.188202544,-89.3887136113,-16.1241617511,46.3699404388,65.566640923,79.2175515293,-34.1973307309,12.8437606884,130.219008104,142.353656899,-13.4046421788,52.3665061998,-115.027321059,-57.5746783972,38.470540817,-24.912635541,2.06512280268,55.0958264314,4.6671464522,45.0071182741,37.2598036566,70.5131187131,24.9746495457,18.4913388495,24.1639513079,-2.02653941321,-22.0186114987,-11.6394041475,3.60828484722,-1.54299607327,12.229442575,-6.30008049209,16.0733467862,11.5144809259,5.81085688968,13.6899680559,6.21701208808,-1.44850741661,-2.1673327694,3.22910106115,-4.38357690874,-2.65376975833,-4.50728144929,-4.56316554858,0.726521258735,6.05316935657,-3.94901686099,3.55492859055,3.10167370133,4.17206470464,5.05921988979,3.45172214032,-0.236877112985,3.62630767386,-1.13686033544,1.50654828976,0.757606531394,-1.23761932514,-0.35595649397,-1.90615873129,-1.23530579348,-0.817281625638,-0.679048242098,-0.371896375704,0.853819976196,-0.155942300489,1.09384828796,1.61810930267,0.145210241594,-0.852059035622,0.29679007229,-1.39093577303,-0.106142881732,-0.534750227123,-0.446076092828,0.418716561105,-0.274259432103,0.364197247944,-0.34447002167,-0.118375034399,-0.0869745823632,-0.264086701046,-0.395168941267,-0.172998509583,-0.0258100031874,0.137065993208,0.176626266182,-0.00671839139335,-0.0614239057199,0.0583484624158,-0.374288197449,0.202556991483,-0.226784188702,0.0225078509044,0.110223458046,-0.0788186976352,0.12645403537,0.00744122852113],[-27403.3226651,-969.802813311,445.931660748,-1562.61474061,627.934325742,860.807496559,110.815590654,993.364381294,1029.7295353,-407.465763163,-852.578270638,406.389084605,-651.35499468,160.426081928,-830.086336136,-362.781040196,366.076136672,7.66043553967,9.61462449575,-112.962129557,124.671178397,608.833777214,147.82216833,-80.0286082028,-16.0691137654,47.3660064278,58.8095326177,81.8726707625,-37.3329049404,11.2938925619,129.059202613,139.180247463,-13.7433454296,49.9035890658,-116.107051928,-56.6910124014,38.6794378518,-26.9605394906,2.16049555967,53.0714565711,5.15101527336,45.6082523836,35.1291067527,69.8207636107,23.721963895,16.8549430797,23.3797117979,-2.02686348911,-21.5750153351,-11.6624994634,3.39368499172,-1.60154021216,11.4396233738,-5.87323274421,16.0998909666,11.0798812361,5.3657036109,13.1865262835,5.27631818635,-1.62794587015,-2.67398095822,3.22189087955,-4.37253671881,-2.56907658442,-4.39114335108,-4.52089564737,0.688869202448,5.85722994403,-3.76014230796,3.45732653216,3.12195558953,4.11419721662,4.94490765346,3.2658557113,-0.257500286813,3.47863737965,-1.08119014033,1.48986834975,0.773198686541,-1.22988095194,-0.357776522938,-1.85679578122,-1.1947961164,-0.836852337561,-0.705555647502,-0.326119325198,0.822041252084,-0.107472247232,1.07489305929,1.60257227937,0.119794186888,-0.869445394023,0.245193533958,-1.36741297136,-0.141203481856,-0.522728916943,-0.463458963832,0.412468769247,-0.272208737767,0.360306259767,-0.334509791605,-0.106882761765,-0.0887774385044,-0.258578784183,-0.390276023829,-0.177613902097,-0.00768607797026,0.13367294252,0.181937996615,-0.00529394084583,-0.060823351584,0.0524143857954,-0.365890682487,0.191852652634,-0.215444503265,0.0142449891596,0.115854534117,-0.0761694774169,0.125785751299,0.00864418592645],[-27314.8857915,-962.929909188,381.059592448,-1538.0592167,639.916943462,883.029599865,126.826213996,949.093469875,992.568045265,-419.221723425,-849.918567033,402.133095329,-619.613632823,170.647328093,-819.2365979,-371.144090187,361.09980224,6.17367096756,8.52256841031,-112.094873155,112.427685567,607.008364824,140.276308768,-70.8982219903,-15.683778917,48.3674540052,51.704010315,84.3705726721,-40.4054292173,9.61302819837,127.782555908,135.709400682,-14.1584107205,47.4018492129,-117.193941668,-55.6723038722,38.9902121689,-29.0199960068,2.2489653919,50.9505232082,5.59468896658,46.0377933373,32.924750972,68.8438164829,22.5459909697,15.0726462449,22.5816226807,-2.0917214538,-21.0927456342,-11.6151088488,3.17632256904,-1.62562651967,10.6252519803,-5.4271591224,16.0885961093,10.6199352779,4.87811626061,12.7021626906,4.29195639303,-1.78248815439,-3.20417477241,3.20625714702,-4.35465267585,-2.48793350142,-4.25636402904,-4.47343289551,0.658059571288,5.66028861972,-3.55594762497,3.35318886969,3.1402946983,4.04141866647,4.83938229994,3.05699006637,-0.264342502771,3.31037989383,-1.01952955983,1.46711896479,0.791214003211,-1.22039626655,-0.362751914958,-1.80569905226,-1.15177673377,-0.85446670821,-0.728834207058,-0.275724122486,0.791782420469,-0.0561490815332,1.05429707669,1.59020613337,0.0911491745288,-0.879409709153,0.1894136267,-1.33797256138,-0.17527892203,-0.507257986316,-0.477718100347,0.405853747111,-0.269524847962,0.355144994414,-0.3250624798,-0.0955167337393,-0.0905807124877,-0.251827081545,-0.384064563098,-0.180796712566,0.0117003795348,0.131335871062,0.188364082824,-0.00371316965025,-0.0586308775487,0.0453237624179,-0.355617568373,0.180398914592,-0.202231784705,0.00664698609177,0.121635042486,-0.0732114746641,0.124634898388,0.00968469857387],[-27227.4391198,-959.171481278,315.71159019,-1514.24204651,652.399402269,903.836930282,143.354093114,903.234179358,953.942625075,-432.523383561,-845.027871581,397.430858526,-586.349512935,180.060462059,-808.18353569,-378.962239542,355.823982381,4.26278317285,6.90260332442,-110.725365723,99.3079392579,604.046575225,132.610998968,-62.0102907823,-14.9785077923,49.3542475208,44.3154561139,86.6905604061,-43.3936625231,7.82328672229,126.424002539,131.97171961,-14.6272486903,44.8765306432,-118.254781872,-54.5269205894,39.4100770773,-31.0676043958,2.32719070498,48.7489359652,5.99568977923,46.2892740652,30.6574624705,67.6011004853,21.4507414351,13.1748831988,21.7795624057,-2.21199309448,-20.5752817348,-11.4917499838,2.95837433234,-1.61460202395,9.79194972293,-4.96688313476,16.0389245335,10.1357165166,4.35557763777,12.2380923743,3.27679821337,-1.91219432425,-3.75235948491,3.18026323454,-4.33040548617,-2.41099348249,-4.10246078046,-4.42126210929,0.633856576286,5.46396280322,-3.3388439637,3.24302071391,3.15569319504,3.95471411916,4.74314753492,2.82776228357,-0.257631016552,3.12331350309,-0.953295218268,1.43828817626,0.811510543976,-1.20869626513,-0.370942463263,-1.75301249306,-1.10666570505,-0.869991405909,-0.748792159502,-0.221343703793,0.763463547872,-0.0027786443003,1.03216481791,1.58112211237,0.0597379181242,-0.882048271817,0.130058201845,-1.30330500217,-0.207969281633,-0.488598087568,-0.488519289689,0.398808120376,-0.266091744085,0.348690140697,-0.316158914689,-0.0843898989044,-0.0923490137361,-0.243914477599,-0.376630143303,-0.182461643852,0.0321345356102,0.130050104964,0.195799210626,-0.00194440562828,-0.0549222675551,0.0371853997693,-0.343671551382,0.168380713021,-0.187285316024,-0.000232934862954,0.127497442144,-0.070006137168,0.122954983644,0.0105418301943],[-27141.0027454,-956.622027147,250.015852678,-1490.84615701,665.19633152,923.362811495,160.315201159,855.771064129,914.114478118,-447.085148475,-837.9616108,392.654330938,-552.032182588,188.922703926,-796.789455083,-386.257573335,350.306014968,2.01282757277,4.76009219108,-108.92272143,85.5375247786,600.136051758,124.852638707,-53.3513166569,-14.004009616,50.3207052503,36.7244751347,88.826069704,-46.268578425,5.99615260058,125.038216191,128.010403373,-15.1183922264,42.3546245175,-119.25792336,-53.2788115541,39.9403876201,-33.0865620919,2.3953786925,46.4911486938,6.36640758128,46.3703913339,28.3483887194,66.1298888119,20.4401127548,11.1970109227,20.9819423257,-2.37709630172,-20.0294642648,-11.2928381895,2.74195665302,-1.57146417672,8.94723779623,-4.49556525904,15.9545181428,9.63306831185,3.80890057487,11.7976384612,2.24518900523,-2.01721411563,-4.31087246572,3.14151879894,-4.2995486975,-2.33861200441,-3.93109765094,-4.3653735696,0.61584471114,5.26952286988,-3.11141666986,3.12849128061,3.16836476848,3.85650366785,4.65622908099,2.58223361436,-0.238238793449,2.92067563464,-0.884560890995,1.40428276862,0.833846615539,-1.19477497278,-0.38222748466,-1.69918662954,-1.06016640782,-0.883478896792,-0.765645799326,-0.163786594936,0.737406107095,0.0519841487684,1.00885298919,1.57529480951,0.026292855563,-0.877757734869,0.0682359418543,-1.26442816941,-0.238799962531,-0.467094295623,-0.495837717536,0.391291751758,-0.261880540865,0.3410174885,-0.307874850369,-0.0736437099132,-0.0940632057908,-0.235053375139,-0.36813988894,-0.182603500812,0.05337376882,0.129772158203,0.204086897369,7.33403240661e-05,-0.0498678750693,0.0282386510062,-0.330356559886,0.156063500808,-0.170860374949,-0.00635920873005,0.133341428788,-0.0666197717196,0.120737635132,0.0112154589611],[-27055.2322141,-952.612555993,184.11703307,-1467.46312697,678.105147524,941.839813848,177.6441325,806.591882259,873.364915776,-462.573211557,-828.817497761,388.224648645,-517.215104798,197.567123141,-784.839086129,-393.071704511,344.613150047,-0.497084694937,2.10850252595,-106.779757002,71.3861672826,595.487296334,117.019133933,-44.9012432591,-12.8210832724,51.2647339507,29.0154782526,90.7740694537,-48.9992041414,4.21545163576,123.684805334,123.871800113,-15.5981547785,39.8660587856,-120.172106765,-51.9558210724,40.581034274,-35.0617160617,2.45462374505,44.2037513034,6.72294914831,46.2923828696,26.0212825187,64.4720671658,19.517974092,9.17561692981,20.1968070189,-2.57608349192,-19.4629741744,-11.0202631974,2.52917080706,-1.50012303558,8.09911236135,-4.01590021537,15.8400637369,9.11902649683,3.24973041283,11.384651085,1.21184258963,-2.09771968466,-4.87152410908,3.0875200685,-4.26165406791,-2.27107016989,-3.74447537312,-4.30688392345,0.603563540216,5.07815243398,-2.87629463761,3.01156081178,3.17882598764,3.7495661627,4.57853316495,2.32482135354,-0.207200226156,2.7060685008,-0.815564641114,1.36623921207,0.857955585633,-1.17874217185,-0.396441176849,-1.64474863192,-1.0130535492,-0.895028096446,-0.779688434963,-0.103905219129,0.713906922505,0.107522113277,0.984781353917,1.57266465423,-0.00838614419525,-0.867009841673,0.00518073696784,-1.22244179297,-0.267277697212,-0.443112791051,-0.499725919152,0.383270313229,-0.256884136362,0.332227602977,-0.300297272354,-0.0634267454355,-0.0957082157223,-0.225488556542,-0.358778809577,-0.181237113805,0.0751685107991,0.130448841719,0.213057868287,0.00240838654216,-0.0436616959387,0.018755505703,-0.316001830276,0.143732860149,-0.153241237889,-0.0117006851504,0.139058507295,-0.0631198998602,0.117984011181,0.0117106666587],[-26969.7830718,-944.474077014,118.159784527,-1443.68453516,690.923266588,959.500507684,195.275481505,755.584391819,831.97524943,-478.653766196,-817.693245533,384.562947724,-482.451742584,206.326789149,-772.117158881,-399.446246017,338.812637661,-3.18784249254,-1.03869815529,-104.389289164,57.1235919232,590.310810868,109.128390594,-36.6400142344,-11.4905276455,52.1842403794,21.2728763431,92.5315285425,-51.5545668908,2.56500963038,122.423378436,119.602257973,-16.0328497964,37.4407613978,-120.966072714,-50.5857934505,41.3319075157,-36.9779132717,2.50602025322,41.9133337033,7.08142125592,46.0664863982,23.6998966685,62.6695212504,18.6881946099,7.14728873322,19.4322010638,-2.7980070815,-18.8834924141,-10.6759147388,2.32211807043,-1.40448865814,7.25556957943,-3.53058272391,15.7002481155,8.60062690488,2.68971249253,11.0029803796,0.191472787579,-2.15388318746,-5.42612480924,3.01576327152,-4.21629335547,-2.2086490816,-3.54479467967,-4.24690981788,0.59655262788,4.89103510981,-2.63610676114,2.89418954944,3.1875934216,3.63668045392,4.50996601361,2.05994279594,-0.165549707365,2.4830943139,-0.748544531731,1.3252939768,0.883570821995,-1.16070764467,-0.413417737531,-1.59022567044,-0.966101836335,-0.904737920457,-0.791213374846,-0.0425519995844,0.693262818473,0.16321806483,0.960369675452,1.57317207603,-0.0434992121908,-0.850276335595,-0.0578735225724,-1.17844560268,-0.292909218164,-0.417019754424,-0.500236429803,0.374709476763,-0.251095428639,0.322421049282,-0.293513166156,-0.0538875841407,-0.0972689706011,-0.215464804187,-0.348731914779,-0.17837731319,0.0972691931819,0.132026966449,0.222542848614,0.00512905136138,-0.0364977260108,0.00900795343442,-0.300936598946,0.13167437324,-0.134712181252,-0.016226213765,0.144540182541,-0.0595740431308,0.114695270119,0.0120325350712],[-26884.3108646,-929.537599409,52.2887602065,-1419.10196034,703.448105019,976.577463347,213.143842544,702.636350881,790.22679046,-494.993005781,-804.686567189,382.090364253,-448.295558964,215.534771396,-758.40840339,-405.422810799,332.971727857,-5.98033468231,-4.66804233701,-101.84413464,43.0195238536,584.817097273,101.198314636,-28.5475732279,-10.0731416197,53.0771312935,13.5810802815,94.0954158582,-53.9036938916,1.12865238696,121.313543967,115.248125096,-16.3887907297,35.108660304,-121.608561838,-49.1965729946,42.192897822,-38.8200006884,2.55066260761,39.6464858026,7.4579306797,45.7039396459,21.4079839689,60.7641367689,17.9546434714,5.1486138461,18.696169039,-3.03191948688,-18.2986999341,-10.2616825451,2.12289971909,-1.288471102,6.42460561162,-3.04230750479,15.5397580783,8.08490536926,2.14049215486,10.6564764787,-0.801206579906,-2.18587678016,-5.96648496047,2.9237446363,-4.16303831825,-2.15162984224,-3.33425630324,-4.18656789989,0.594351538497,4.70935451165,-2.39348193462,2.77833773559,3.19518363939,3.52062539167,4.45043385375,1.79201523635,-0.11432162977,2.25535528627,-0.685738625951,1.28258353304,0.910425692357,-1.14078117358,-0.432991364407,-1.53614491531,-0.920085976341,-0.912707284411,-0.800513927405,0.0194206404823,0.675770619367,0.218454819031,0.936037717171,1.57675750436,-0.0782464794639,-0.828028959998,-0.119692946525,-1.13353932842,-0.315201257874,-0.389181366312,-0.497421784755,0.365574914333,-0.244507315757,0.311698392566,-0.287609517289,-0.0451748046983,-0.098730397498,-0.205226900451,-0.338184214113,-0.174038929325,0.119426247603,0.134453343334,0.232372563581,0.0083036531171,-0.0285699611329,-0.000732016225225,-0.285490102289,0.120173622275,-0.115557481446,-0.0199046442146,0.149677959403,-0.0560497230727,0.110872570274,0.0121861459829],[-26798.7475944,-906.061813109,-13.2649349888,-1393.47479754,715.448584248,993.138076848,231.228944282,647.770651445,748.38318431,-511.323406593,-789.945859594,381.132400212,-415.209591799,225.463407761,-743.557811032,-411.050281728,327.148527977,-8.79051984058,-8.75905255584,-99.2541302729,29.3344158851,579.167523853,93.2552799453,-20.6102103651,-8.62505024102,53.9467103997,6.02082275299,95.4678215035,-56.0226189084,-0.016548834246,120.412939024,110.857626727,-16.6274565507,32.8981266979,-122.071412279,-47.8145629071,43.1615700255,-40.5730253629,2.59060796144,37.428715449,7.86843946463,45.2182872094,19.1696877575,58.7951247684,17.3207400581,3.21148891176,17.9952178522,-3.26889801461,-17.7159910913,-9.78054258315,1.93356948253,-1.15514014954,5.61429368206,-2.55365399813,15.3636118045,7.57877187535,1.61287870036,10.3489942584,-1.75272594366,-2.19377065376,-6.48491503125,2.80990720199,-4.10169506772,-2.10030968453,-3.11515267024,-4.12697608692,0.596560890152,4.5342799661,-2.1508310026,2.66589000391,3.20214797133,3.40403919183,4.39993680177,1.52509692996,-0.0545602118947,2.02626759125,-0.629083838377,1.23918890348,0.938192174857,-1.11912389182,-0.454965669592,-1.48304700046,-0.875714494046,-0.91903642927,-0.807858559804,0.0812113996628,0.661647283464,0.272643080815,0.912159139429,1.58335298745,-0.111892439734,-0.800737240602,-0.179111920421,-1.08870972958,-0.333672002375,-0.359964956226,-0.491366412557,0.355872909992,-0.237123239239,0.300166465658,-0.282667886528,-0.0374289673855,-0.100084431055,-0.19501950225,-0.32730167297,-0.168266691934,0.141398566999,0.137680319909,0.242392914821,0.0119892910422,-0.0200644992926,-0.0102104453623,-0.269974779236,0.10950114992,-0.0960537070216,-0.0227099068423,0.154378920104,-0.0525964794467,0.106529687717,0.01217298839],[-26714.1310884,-876.016130969,-77.9243891886,-1367.23370692,726.579646202,1008.58904687,249.691052575,591.550721229,706.63741268,-527.642576481,-773.822254802,381.632021183,-383.295178318,236.142109858,-727.651418479,-416.406621356,321.364574552,-11.5146354,-13.2632115577,-96.7971933671,16.2916314621,573.326924484,85.3595321662,-12.8396016914,-7.18368320316,54.8178692021,-1.34187631879,96.671320442,-57.9154018897,-0.820540942164,119.771315217,106.486496532,-16.6909883223,30.8313047471,-122.338852226,-46.4604019742,44.2261863835,-42.2228346842,2.63176451845,35.2812022437,8.32833073312,44.6323011686,17.0107135228,56.7909976704,16.7881046239,1.34904709409,17.329703729,-3.50811953181,-17.1416138691,-9.23981576142,1.75599090432,-1.00420448213,4.83301526681,-2.06674052393,15.1781529921,7.08863301682,1.11433726813,10.0844075644,-2.65459274195,-2.17722713873,-6.97572578702,2.67648125122,-4.03300712899,-2.05505036129,-2.89014298202,-4.06925737799,0.603025515795,4.36692364907,-1.90969261105,2.55842855477,3.2091767928,3.28899753299,4.35885053238,1.26180997334,0.0126510244265,1.7985032463,-0.579312489605,1.19596932089,0.966296689233,-1.09610233628,-0.479021922871,-1.43152641465,-0.833431185067,-0.923830897497,-0.81341637412,0.142223463769,0.650790304663,0.325305112434,0.888923190507,1.59285704843,-0.143959037435,-0.76886183254,-0.23523793288,-1.04449168381,-0.347885451882,-0.329742449428,-0.482282314899,0.345772196121,-0.228988814458,0.28795717208,-0.278748135693,-0.0307585589095,-0.101351036199,-0.185086764663,-0.316174080053,-0.161224928207,0.162978889509,0.141682390095,0.252510509555,0.0161981879595,-0.0111358470373,-0.019245502707,-0.254635878861,0.0998673407299,-0.0764465950945,-0.0246362547989,0.158612456253,-0.0491919248926,0.101730869481,0.0119801801377],[-26631.7756296,-842.297646579,-141.02623878,-1340.97716491,736.467737929,1022.17189776,268.735567576,534.675121877,665.164791334,-544.014406184,-756.717568662,383.43655865,-352.563230592,247.539557733,-710.835523729,-421.577062163,315.63226141,-14.0439885073,-18.1249921408,-94.6682613446,4.10526168712,567.21099943,77.5797848813,-5.25376973274,-5.78179636163,55.7208961545,-8.44467520044,97.7336088522,-59.5931093301,-1.24002538801,119.436452786,102.192345276,-16.51669263,28.9287818628,-122.398207384,-45.1532878784,45.3726835092,-43.7554761263,2.68100324501,33.2240437261,8.85284287698,43.971060474,14.957157291,54.7775932402,16.3579076409,-0.430269312866,16.6984452243,-3.75078579576,-16.5815296572,-8.64790922379,1.59197998155,-0.834532505929,4.08922890491,-1.58357012216,14.9900567188,6.62076953943,0.651496956869,9.86659498428,-3.49955866487,-2.1358066004,-7.43372806747,2.52664387751,-3.95795238058,-2.01622975534,-2.66197813367,-4.01453604254,0.613651302097,4.20838344879,-1.67138735628,2.45745998021,3.21699524043,3.17743545947,4.32764460988,1.00441742344,0.0862187315287,1.5745482299,-0.536855751733,1.15372857052,0.994104265627,-1.07213439473,-0.504810808443,-1.38219111029,-0.793613662718,-0.92719755693,-0.817331631159,0.201911140419,0.643017310774,0.375991065471,0.866473015668,1.60515982919,-0.174032579682,-0.732861173299,-0.287246748294,-1.00130709829,-0.357417060155,-0.29888692012,-0.470413386755,0.335482117183,-0.22016020025,0.275208683032,-0.275904701864,-0.0252640475852,-0.10255718543,-0.175672717307,-0.304872179888,-0.153107864703,0.183968414574,0.146439584412,0.262647131404,0.0209313475894,-0.00193061305483,-0.0276733886502,-0.239701852778,0.0914675397293,-0.0569741749234,-0.0256830219376,0.162363536808,-0.0457956902698,0.0965529803408,0.0115912462831],[-26552.9955013,-807.803453528,-201.907120149,-1315.30364793,744.739306481,1033.12815387,288.567889436,477.842415038,624.140636032,-560.502786443,-739.033617021,386.393344097,-323.024660696,259.624431432,-693.25642478,-426.646836624,309.963982379,-16.2698863093,-23.2888671033,-93.0622716269,-7.0106023374,560.735448958,69.9847516734,2.12926298527,-4.45214557197,56.6860797104,-15.2252321586,98.6823829128,-61.0668077243,-1.23170362299,119.45613197,98.0327837282,-16.0418760592,27.2111454561,-122.236803453,-43.9124183022,46.5869980158,-45.1569971628,2.74519510752,31.2773374357,9.45721428799,43.2596440764,13.0351150884,52.7807492431,16.0313195813,-2.11801801507,16.1002608931,-3.99809856373,-16.0416998456,-8.01323011416,1.44335271129,-0.644992627078,3.39139313542,-1.1061458328,14.805998062,6.18146218894,0.23098686532,9.699435106,-4.28037540253,-2.06906940412,-7.8537327123,2.36357217434,-3.87750870099,-1.98422574954,-2.43340902029,-3.96393634999,0.628344135729,4.05975725348,-1.43723583463,2.36449087227,3.22632845087,3.07128801554,4.30678859856,0.755182337193,0.165049561747,1.35688852054,-0.502144796857,1.11327043762,1.02097993418,-1.04763795496,-0.531983010509,-1.33564903984,-0.756639540312,-0.929243275406,-0.819748591729,0.259728737229,0.638145929602,0.424251091508,0.844951760176,1.62015147163,-0.201699373588,-0.693193700367,-0.334314131054,-0.959577880229,-0.361842280954,-0.267771442504,-0.456003523099,0.325212017639,-0.210693555448,0.262059169711,-0.274192022125,-0.0210459017274,-0.103729851246,-0.167021389797,-0.293466717004,-0.144109727977,0.204168341637,0.151931933378,0.272724563987,0.0261897736522,0.00740459396737,-0.035330303583,-0.225401152599,0.0844970919434,-0.0378744757665,-0.0258495421113,0.165617130725,-0.0423674064377,0.091072885071,0.0109897118833],[-26479.1049867,-775.430645404,-259.903669683,-1290.8116324,751.020798905,1040.69933954,309.393418308,421.751162357,583.74026254,-577.171607998,-721.172215729,390.349709007,-294.690380699,272.365411002,-675.060419627,-431.701177217,304.372131287,-18.0836359526,-28.6993092436,-92.1741616357,-16.8418695089,553.815973334,62.6431461253,9.29147393687,-3.22748668972,57.7437083235,-21.6212054598,99.5453388024,-62.3475635669,-0.75227709832,119.878133007,94.0654226561,-15.2038451955,25.6989829382,-121.841966136,-42.7569909279,47.8550665166,-46.4134452676,2.83121107233,29.4611809118,10.1566833579,42.5231309263,11.270682941,50.8263034445,15.8095109174,-3.70575671847,15.5339692903,-4.25125959297,-15.528085824,-7.34418557641,1.31192509063,-0.434453251725,2.74796649739,-0.636470695806,14.6326520993,5.7769917111,-0.140563907796,9.58680651735,-4.98979464504,-1.97657591523,-8.23055056117,2.19044323524,-3.79265396874,-1.95941622673,-2.20718653696,-3.91858256977,0.647009903359,3.92214295138,-1.20855864242,2.28102782299,3.23790156076,2.9724902455,4.29675206273,0.516367771541,0.248050167418,1.14801009669,-0.475610797071,1.07539870747,1.04628872503,-1.02303090475,-0.560189213269,-1.29250815572,-0.722886431163,-0.930074920765,-0.820811516636,0.315130561816,0.635993788956,0.469635342127,0.824502569294,1.63772211762,-0.226545726266,-0.65031785123,-0.375615845553,-0.919725936805,-0.360736568039,-0.236769090782,-0.439296618905,0.315171241951,-0.200645038887,0.248646803316,-0.273664533557,-0.0182045896508,-0.104896006147,-0.159376811753,-0.282028435929,-0.134424744588,0.223379870138,0.158139467512,0.282664590924,0.0319744698682,0.0167231653417,-0.0420524478964,-0.211962229936,0.0791513423976,-0.0193855268822,-0.025135149173,0.168358206961,-0.0388667042558,0.0853674484465,0.0101591019955],[-26411.1094304,-747.28077244,-314.510736408,-1267.94141185,754.958532687,1044.33912092,331.284471813,367.074591112,544.158286065,-594.033475458,-703.506769428,395.152461637,-267.601136061,285.680492831,-656.400520178,-436.786440073,298.883104065,-19.3882638786,-34.3039078215,-92.1595690907,-25.2346433568,546.392932572,55.61436669,16.2098964083,-2.13472233187,58.9199480617,-27.577326373,100.348827181,-63.4495802357,0.224567789067,120.733976481,90.3395426511,-13.9562216113,24.4067233112,-121.209591575,-41.7034992977,49.1643773787,-47.513647576,2.9455085451,27.791377323,10.9622187494,41.7835916023,9.68576127445,48.9379631274,15.6918172811,-5.18661513374,14.9983027128,-4.51145579749,-15.0459914092,-6.64898071855,1.19906933668,-0.202160913456,2.1659071958,-0.176311859664,14.4758376496,5.41249818397,-0.457569693805,9.53110724424,-5.6220253817,-1.85858349611,-8.56019770613,2.01033735715,-3.70468654927,-1.94211819782,-1.98585760251,-3.87933180079,0.669578233891,3.7964687507,-0.98655510367,2.20833874442,3.25226462302,2.88275296252,4.29774945872,0.28999363295,0.334120626636,0.950065175039,-0.457456395199,1.04073486639,1.06954791623,-0.998737844346,-0.589108495366,-1.25328898941,-0.692656922968,-0.929786276513,-0.820666547022,0.367657470564,0.63639919795,0.51177809389,0.80528120691,1.6577165783,-0.24821293372,-0.604712988972,-0.41049686736,-0.882101562584,-0.35381867384,-0.206225788872,-0.420549437307,0.305550484555,-0.190096004274,0.235107809093,-0.274355748753,-0.0168032817662,-0.10607913343,-0.152935651101,-0.270628398798,-0.124225399601,0.241432029736,0.165034579408,0.292388691414,0.0382824316376,0.0258918369779,-0.0477110289119,-0.199578345532,0.0755751298348,-0.00172250345157,-0.0235512505349,0.170579834483,-0.0352661383145,0.0795179908718,0.00908694676546],[-26348.7784233,-722.273211441,-365.856019906,-1246.50054814,756.278307045,1044.34973128,353.781037439,314.384591098,505.666519596,-610.895848913,-686.297037931,400.646317336,-241.91700579,299.284938677,-637.456593984,-441.793475939,293.579305062,-20.1336737063,-40.0627179438,-93.0169329041,-32.2758059384,538.505325678,48.9205513004,22.8417869337,-1.17734216137,60.2244754502,-33.0666181762,101.113816629,-64.3996086407,1.65720485937,121.990144344,86.8711036004,-12.3178868271,23.3241619417,-120.369857674,-40.7576203932,50.5086259854,-48.45754987,3.09289068848,26.2665523531,11.867710208,41.0510631955,8.2854681113,47.130913646,15.6702349439,-6.56001099038,14.4916484248,-4.77981471816,-14.598090126,-5.93501250503,1.10438254667,0.0511253443707,1.6461720993,0.273507093164,14.3379484957,5.08855901468,-0.718618544239,9.52881306509,-6.17710579859,-1.71813749727,-8.84351124863,1.8259476509,-3.61618675581,-1.93240518604,-1.77115323068,-3.84597245978,0.696073725155,3.6829841397,-0.771939453128,2.14673682864,3.26926735568,2.80289005521,4.3089748111,0.0771072259919,0.422134720532,0.763870925058,-0.446970116964,1.00917120508,1.09088377741,-0.975210223871,-0.618533513217,-1.21816238847,-0.665953500949,-0.928418788836,-0.819467345369,0.41719651491,0.639283190926,0.550650123259,0.787493911418,1.67979834178,-0.266562247515,-0.556942179051,-0.438979016764,-0.846768601598,-0.341380545477,-0.176378859566,-0.400070214081,0.296465839786,-0.179228584795,0.221570628488,-0.276215482351,-0.0167559568684,-0.107288759591,-0.147705129022,-0.259338938186,-0.113597212121,0.258265170956,0.172559109967,0.301817126978,0.0450946210802,0.0348307231763,-0.0523172816725,-0.18830199665,0.073711267869,0.014990835652,-0.0211575478458,0.172307482304,-0.0315899581286,0.0736236552699,0.00777679669334],[-26291.5726179,-698.531795859,-414.225432397,-1226.13842022,754.725791631,1041.24554569,376.290020144,264.227717742,468.55607557,-627.51490232,-669.774369845,406.675468225,-217.827902283,312.843326639,-618.415222502,-446.574259215,288.55714073,-20.2814883495,-45.9389111793,-94.7053922863,-38.1124339427,530.216811407,42.5745227595,29.139457859,-0.352982602623,61.6628446284,-38.0691771494,101.859930211,-65.227536575,3.48702298708,123.596858896,83.6677352153,-10.3240373505,22.4349357869,-119.361512775,-39.9223270554,51.883059474,-49.2478775935,3.27774710438,24.881037315,12.86277775,40.3325744249,7.07072587352,45.4182098725,15.734925337,-7.82693402262,14.0123074327,-5.05744905258,-14.1863979257,-5.2094758644,1.02701803785,0.324268350957,1.18821774247,0.71239847171,14.2205221619,4.80461094266,-0.923341940679,9.57491919639,-6.65653138098,-1.55898026627,-9.08253354247,1.63987043075,-3.53005538853,-1.9302898427,-1.56460045892,-3.81802579299,0.726544717212,3.58176892663,-0.565304653242,2.09629658773,3.28858439302,2.73349118107,4.32936703647,-0.121487295239,0.510959655997,0.589910754427,-0.443211958817,0.980417715302,1.11057482612,-0.952906205914,-0.648285317684,-1.18721177948,-0.642703624711,-0.926000819588,-0.817369454493,0.463721295058,0.644587483533,0.586306331677,0.771359539836,1.7035855654,-0.281509908105,-0.507589412525,-0.461253325227,-0.813719285246,-0.323857428736,-0.14743847537,-0.378180053161,0.288014751953,-0.16825010851,0.208161756994,-0.279172624502,-0.0179392958479,-0.108530921925,-0.143645105004,-0.248232704276,-0.102603959762,0.273847474542,0.180647262164,0.310869854716,0.0523879919957,0.0434732828342,-0.0559174481517,-0.17815048968,0.073452063832,0.0306535856322,-0.0180258163134,0.173574719446,-0.0278753369438,0.0677880401934,0.00623620736787],[-26238.9526665,-674.180359143,-459.904886102,-1206.50440705,750.046656099,1035.54093923,398.218324885,217.150526472,433.118066421,-643.646809636,-654.170113777,413.084106428,-195.523737933,326.020234817,-599.462987193,-450.980764301,283.913017522,-19.793330722,-51.8956590963,-97.1840864474,-42.891604059,521.591048514,36.5891038705,35.0552215304,0.34071991997,63.2406097358,-42.5650995731,102.606790989,-65.9632518319,5.65541104668,125.504342433,80.7370672069,-8.0098696888,21.7226818043,-118.223305221,-39.2005921256,53.2829249818,-49.88735619,3.50446739474,23.6291635215,13.9370413918,39.6351540095,6.04245698309,43.8129066789,15.8760498917,-8.98837396466,13.5585807426,-5.34547149835,-13.8129307602,-4.47956572522,0.966129127475,0.616130935503,0.79150065991,1.13977458501,14.1250961724,4.56009070735,-1.07137136471,9.66442085465,-7.06179761416,-1.38485415068,-9.27930694144,1.45470201099,-3.44919324759,-1.93578481911,-1.3677263247,-3.79501304663,0.761039550125,3.49290291973,-0.367243666455,2.05709253378,3.30989036936,2.67514599758,4.35786505143,-0.304985776646,0.59946263992,0.428668070823,-0.445241917208,0.954184388818,1.1288995799,-0.932283953065,-0.678184959629,-1.16052058902,-0.622834753859,-0.922560730625,-0.814528417212,0.507205411214,0.65225379142,0.618801620586,0.757096949182,1.72869640651,-0.292972155945,-0.457238680448,-0.477510824215,-0.782945844928,-0.301684569407,-0.119614808793,-0.355200058483,0.280294665365,-0.157367903475,0.195007690107,-0.283156065356,-0.0202299795955,-0.109811657727,-0.140715438539,-0.237382347251,-0.0913094201382,0.288147121235,0.189233238974,0.319466831725,0.0601394981835,0.0517529748493,-0.0585577703232,-0.169141131016,0.0746898250554,0.045164841693,-0.0142278311457,0.174415114933,-0.0241594480058,0.062114744195,0.00447273437781],[-26190.3792214,-647.342734743,-503.180293243,-1187.24788759,741.986570101,1027.75028695,418.972856619,173.699572713,399.643604584,-659.047744821,-639.715618332,419.716424064,-175.194425137,338.48024131,-580.786469515,-454.8649656,279.743341888,-18.6308237374,-57.8961332636,-100.412154598,-46.7603929764,512.691695752,30.9771174362,40.5413902938,0.906128981998,64.9633249118,-46.5344817273,103.374022026,-66.6366422044,8.10375791265,127.662817253,78.0867292863,-5.41058034964,21.1710369514,-116.993983354,-38.595388445,54.7034696461,-50.3787111032,3.77744116148,22.5052622856,15.0801211498,38.9658306684,5.20158386193,42.3280589373,16.0837700394,-10.0453205507,13.1287693608,-5.64499475307,-13.4797045808,-3.75247701604,0.920869132788,0.92557592721,0.455477386192,1.55504774209,14.0532080514,4.35443504816,-1.16233829791,9.79231325638,-7.39439998339,-1.19950149805,-9.43587379935,1.27303870589,-3.37650113315,-1.94890276656,-1.18205786549,-3.77645546692,0.799606563957,3.41646592725,-0.178349455211,2.02919917887,3.33285991899,2.62844416223,4.3934077726,-0.472584064133,0.686510879193,0.280626281922,-0.452119988588,0.9301812174,1.1461365563,-0.91380162791,-0.708053489911,-1.13817224369,-0.606274347997,-0.918126883801,-0.811099776341,0.54762246358,0.662223830237,0.648190891427,0.744924996475,1.75474902248,-0.300865231488,-0.406473973877,-0.487942545193,-0.754440512043,-0.275297213279,-0.0931180323419,-0.331451333983,0.273403024332,-0.14678929775,0.18223492332,-0.288094695064,-0.0235046890016,-0.111137004293,-0.138875989116,-0.226860517293,-0.0797773708628,0.30113229178,0.198251243374,0.327528015107,0.0683260934433,0.0596032581192,-0.0602844901603,-0.161291227048,0.0773168588711,0.0584236990379,-0.00983536755062,0.174862237789,-0.0204794645605,0.0567073658274,0.00249393331191],[-26145.5380849,-616.798943751,-544.228808769,-1168.19303048,730.452209595,1018.33242815,438.063653252,134.281020858,368.381840468,-673.516203704,-626.592597162,426.464324331,-156.982677957,349.992067203,-562.557212575,-458.092567361,276.123477319,-16.7789151868,-63.8930365078,-104.320637419,-49.8577029594,503.586591119,25.7412942285,45.5578806764,1.35065628714,66.8276932219,-49.9659714322,104.178492007,-67.2737577725,10.7776812561,130.026927212,75.7174499087,-2.56169055551,20.7681561691,-115.710778062,-38.10668335,56.1387662901,-50.72517561,4.09951204705,21.5027369458,16.2809754482,38.3298773205,4.54621162133,40.9732596536,16.3486605705,-10.9992134614,12.7219239681,-5.95701797997,-13.1880693467,-3.03469805402,0.890471220806,1.25090599501,0.178410060609,1.95809527265,14.005457654,4.18712908892,-1.1967576964,9.95346963653,-7.65650737563,-1.006423085,-9.55474124546,1.09724519299,-3.31384821481,-1.96953675413,-1.00872905541,-3.76191717196,0.842137610567,3.35234829341,0.00107377139947,2.01254748131,3.357353559,2.59370394277,4.43489866128,-0.623659296133,0.770933674184,0.146070522932,-0.462997209373,0.908230740061,1.16255382235,-0.897822613561,-0.737706473296,-1.12016280913,-0.592934163107,-0.912742911785,-0.807218934093,0.585002125507,0.674430682609,0.674565893594,0.735029882362,1.78138720874,-0.305168367396,-0.355833609983,-0.492800602389,-0.728190395557,-0.24515277493,-0.0681204382674,-0.307260921224,0.267410650389,-0.136673544668,0.169957001037,-0.293901528312,-0.0276413904359,-0.112504799544,-0.138067710448,-0.216733149705,-0.0680634266936,0.312789788231,0.207642575995,0.334992473603,0.0769153449586,0.0669660268501,-0.0611430576352,-0.154601452015,0.0812146934019,0.0703568345357,-0.00492897100121,0.174946894648,-0.0168695507764,0.051650489417,0.000316774334129],[-26105.0156579,-583.953757823,-582.792558553,-1149.86316314,715.994275761,1007.52405898,455.413284492,98.7394711547,339.414076365,-687.019969607,-614.784224095,433.410554722,-140.842417127,360.741005517,-544.886606061,-460.584193237,273.044615453,-14.3158523703,-69.797196688,-108.728181478,-52.2897385742,494.360289584,20.8439968934,50.0950259291,1.70190605146,68.7950134364,-52.8824226668,105.02605211,-67.8852977627,13.6397139349,132.569002405,73.6023525049,0.499979610878,20.5202663328,-114.404850412,-37.7224221574,57.5781904812,-50.9320143192,4.46733985611,20.6112789445,17.5259163423,37.7255436846,4.06317612975,39.7442543692,16.6629497127,-11.8532921628,12.3400939432,-6.28208620486,-12.936711047,-2.32989071068,0.874487957587,1.58818316673,-0.0462167587237,2.35065458898,13.9786941595,4.05785149099,-1.17867841442,10.1422753038,-7.85298228454,-0.808153404308,-9.64027551094,0.928759602863,-3.25897713993,-1.99710152189,-0.847301615281,-3.75113376735,0.887898589005,3.29968250628,0.1718768177,2.0064941843,3.38397533765,2.57015804797,4.48109935765,-0.758313781185,0.851408699175,0.0244928391859,-0.477388775846,0.888605684813,1.178377643,-0.884331175214,-0.766937530165,-1.10613890719,-0.582663140677,-0.90651353051,-0.80294073026,0.619598362933,0.688772899069,0.698165768288,0.727467182007,1.80835731318,-0.306112765153,-0.305673210408,-0.492581441087,-0.704162114688,-0.211797344097,-0.0446427977865,-0.28297961228,0.262281873985,-0.126987598665,0.158235663301,-0.30042607794,-0.0325231921838,-0.113880083905,-0.13815593314,-0.207039320269,-0.0561905509615,0.323180897894,0.217376928095,0.34187572253,0.0858372734484,0.0738169164834,-0.0611757547148,-0.149005951538,0.0862217399356,0.0810012517149,0.000375731968104,0.174688842594,-0.0133518345143,0.0469526423846,-0.00200411409064],[-26069.6234914,-550.868136256,-618.504911197,-1132.95640269,699.324476083,995.506339833,471.047452995,66.7791328193,312.779652542,-699.569147725,-604.224038,440.685573804,-126.680365044,371.01649226,-527.871001307,-462.274196732,270.476904965,-11.3432074657,-75.5089729216,-113.425334812,-54.1545299622,485.101525356,16.2374960458,54.150763484,1.99253061909,70.8177332514,-55.3152409501,105.919799135,-68.4781236882,16.6566176035,135.265794484,71.7076592498,3.73728535175,20.4381123016,-113.105844014,-37.4275446793,59.0099434728,-51.0049996728,4.87603843381,19.8196517498,18.8005942955,37.1493236793,3.73649594498,38.6333267596,17.0192790525,-12.6112460673,11.9860783396,-6.62063091918,-12.7236496779,-1.64101024615,0.872551758948,1.93290930995,-0.226112908982,2.73492812405,13.9688290783,3.9663293001,-1.11303278077,10.3529935855,-7.98936060544,-0.606985377827,-9.6973076024,0.768788429356,-3.20859892531,-2.0308922277,-0.696944202579,-3.74388373056,0.935998910118,3.2574115899,0.335199241366,2.01025247725,3.41351518596,2.55676779689,4.5307360466,-0.876831120358,0.926575721927,-0.0848129964556,-0.494900924257,0.871691326913,1.19382383272,-0.873216798588,-0.795534794805,-1.09565979879,-0.575294518575,-0.899558726722,-0.798299864031,0.651721214944,0.70514039713,0.719266504661,0.722259814202,1.83543132178,-0.303992618448,-0.256302722913,-0.487842589333,-0.682317166222,-0.175799179307,-0.0226680018589,-0.258964136853,0.257954402795,-0.117650339451,0.147119699064,-0.307501981322,-0.0380344880094,-0.115219698429,-0.138987082016,-0.197811389885,-0.0441735441411,0.332385529385,0.227431088588,0.348212388846,0.0950125130153,0.0801399977693,-0.0604240713642,-0.144422239081,0.092165630551,0.090421535769,0.00595434455767,0.174105076325,-0.00994543455765,0.0426033379247,-0.00440468892229],[-26040.1731361,-519.603038348,-650.999235301,-1118.17086621,681.154518044,982.460431082,484.991861419,38.1042150657,288.517909263,-711.173843252,-594.84557775,448.419840144,-114.403244111,381.107963437,-511.606749649,-463.096931347,268.390494532,-7.96255265056,-80.9287243256,-118.202645458,-55.550107265,475.899032646,11.8740623006,57.7230307732,2.25518233418,72.8483003634,-57.2958318011,106.862829881,-69.0590970622,19.7951539162,138.094055103,69.9995923182,7.11308186935,20.5324389345,-111.843402481,-37.2069907278,60.4222265182,-50.949904113,5.32072162536,19.1166188298,20.0906597711,36.5977112233,3.55018962481,37.6327605,17.4102901769,-13.2767645874,11.6626762105,-6.97308361439,-12.5469052362,-0.971011920559,0.884295040707,2.28058629221,-0.368988227345,3.11311831082,13.9717739207,3.912289562,-1.00475312422,10.5798878086,-8.07117823367,-0.405211927396,-9.73066852647,0.618538166312,-3.15942458775,-2.0702040294,-0.556825474789,-3.73994553904,0.985547984754,3.22447856833,0.492180600073,2.02303554959,3.44676303499,2.55249450855,4.58253491302,-0.979494914719,0.9950745102,-0.18255321113,-0.515139890853,0.85787294162,1.20910820594,-0.864368969402,-0.823286401501,-1.08828474486,-0.570661534664,-0.891998487167,-0.793331034594,0.681680720623,0.723423094302,0.738144091868,0.719430697742,1.86238122052,-0.299102120972,-0.208032095257,-0.479141575176,-0.662617046941,-0.137726539088,-0.00217894144398,-0.235571224647,0.254365944493,-0.108580646739,0.136657897277,-0.314962875835,-0.044059671677,-0.11648048417,-0.140407581902,-0.189081719456,-0.0320272067068,0.340483591323,0.237781846387,0.354037099511,0.104361697762,0.085919341458,-0.0589294975489,-0.140767828111,0.0988739973272,0.0986822718914,0.0116824699678,0.173212590537,-0.00666946969019,0.0385920892319,-0.00682090712073],[-26017.4761428,-492.219423396,-679.908899469,-1106.20467083,662.19610913,968.567493109,497.272212421,12.4189271084,266.668186795,-721.844161384,-586.582382216,456.74381231,-103.917776726,391.304855056,-496.190202421,-462.986750587,266.75553283,-4.27546010237,-85.9568100173,-122.850661454,-56.574500624,466.841545666,7.70596627258,60.8097652288,2.52251354086,74.8391624685,-58.8556007389,107.858241147,-69.6350793981,23.0220845276,141.030535913,68.4443738849,10.5902243659,20.8139910905,-110.647169423,-37.0457001149,61.8032408709,-50.7725000817,5.79650327593,18.4909436527,21.3817632322,36.0672002354,3.48827572702,36.7348392657,17.8286246727,-13.8535371355,11.3726866095,-7.33987578193,-12.4044977181,-0.322850994021,0.909350218684,2.6267159811,-0.482552550988,3.48742758224,13.983440197,3.89545932245,-0.85877177356,10.8172213004,-8.10397106456,-0.20512597486,-9.74518928977,0.479215307574,-3.10816514403,-2.11433208484,-0.426114089391,-3.73909767028,1.03565522376,3.19982646561,0.643960451497,2.04405659072,3.48450881577,2.55629950199,4.63522214177,-1.06658876534,1.05554483175,-0.269434031976,-0.537711911886,0.847535804192,1.22444657711,-0.857677173374,-0.849980484538,-1.0835730063,-0.568597426812,-0.883952798591,-0.788068941138,0.709786919055,0.743510908094,0.755074519059,0.719002751417,1.88897899537,-0.291735466415,-0.161171275197,-0.467035926662,-0.645023253631,-0.0981476819661,0.0168414924988,-0.213157605363,0.251454206756,-0.0996974002386,0.126899046894,-0.322642398853,-0.0504831369509,-0.117619282178,-0.142263857625,-0.180882669882,-0.0197663391331,0.347554992324,0.248405990407,0.359384481484,0.113805461792,0.0911390182995,-0.0567335232342,-0.137960232094,0.106174472343,0.105848045276,0.0174357113988,0.172028379925,-0.00354305869546,0.0349084095006,-0.00918872564584],[-26002.0616379,-470.167407868,-705.006725087,-1097.66319705,643.166423386,953.999879237,507.950966991,-10.5324721775,247.210582774,-731.604095059,-579.383726521,465.722200697,-95.0785998305,401.758259279,-481.701638743,-461.918435708,265.545373783,-0.384661559635,-90.5135135946,-127.199689691,-57.330719261,458.005527689,3.6803824267,63.4290930424,2.82288504781,76.7503479968,-60.0295679975,108.905630366,-70.213184229,26.2987481282,144.048981389,67.007854637,14.1327696244,21.2885566297,-109.548412689,-36.9295473723,63.1405327216,-50.4807572409,6.29868521978,17.9307831015,22.6613629843,35.5538149286,3.53452592942,35.9310508485,18.267527842,-14.3492864559,11.1168628217,-7.72189244446,-12.2941531051,0.300411694108,0.947127852282,2.96763591877,-0.574508215826,3.85977128033,13.9998366453,3.91513834253,-0.680466258432,11.059608807,-8.09406793193,-0.00945619729077,-9.74564240448,0.35169636219,-3.05216701329,-2.16249865356,-0.304006205413,-3.74105648161,1.0855816669,3.18223486318,0.791594710054,2.07235741177,3.52745265956,2.56708177255,4.68747288981,-1.13881255958,1.10686676285,-0.346333338883,-0.562171785608,0.840951048529,1.24007858179,-0.85313505467,-0.875427239445,-1.08106082809,-0.568879248618,-0.875526071609,-0.78255146145,0.73635143806,0.765224821763,0.770364379185,0.720923619932,1.91496188862,-0.282227306743,-0.11601502576,-0.4521260705,-0.629449769078,-0.0576264582699,0.0344586238704,-0.19204886211,0.249176015615,-0.0909502567223,0.11787634491,-0.330380133134,-0.0571863250679,-0.118598044637,-0.144410905809,-0.173234214377,-0.0074204204412,0.353694438468,0.259264885343,0.364289704013,0.123257782817,0.0957963949192,-0.0539054910367,-0.135907290686,0.113899664116,0.112001762141,0.0230965877474,0.17057991349,-0.00058540231161,0.0315412452049,-0.0114576116039],[-25993.3290493,-452.453736907,-726.623344692,-1092.780879,624.804501108,938.894714552,517.237619461,-30.8455252741,229.888224312,-740.533188195,-573.261830795,475.156723016,-87.5320085335,412.065892894,-468.157048875,-460.028478987,264.746192323,3.60247299574,-94.5988165775,-131.239072475,-57.9416887196,449.41835825,-0.27589937147,65.6798954445,3.16749152183,78.572208313,-60.8672126725,109.990597486,-70.8015331688,29.564791553,147.111107277,65.654399311,17.7095807509,21.9420954169,-108.584897077,-36.8481459104,64.4190280106,-50.0914341323,6.82332124749,17.4218677197,23.9241487016,35.0517006942,3.67172438992,35.209699505,18.7226598487,-14.7878686206,10.8877750602,-8.12183274951,-12.2124213171,0.895292987576,0.996151075247,3.30302634583,-0.65252755272,4.23091638333,14.0173609149,3.96891724483,-0.476994911933,11.3030707507,-8.05096942347,0.177325707311,-9.7365664049,0.235537900033,-2.99131822395,-2.213634402,-0.189807988064,-3.74528984992,1.13519486965,3.16982957209,0.935804717113,2.1062943106,3.57593549856,2.58349102079,4.73775820228,-1.19853133003,1.14888161376,-0.414815622751,-0.587868558299,0.837933243097,1.25633913988,-0.851152891246,-0.899525106716,-1.08019239138,-0.571059316619,-0.866760412304,-0.776829187723,0.761692260396,0.788110081539,0.784442680378,0.724839851629,1.93992816774,-0.271074127017,-0.0727973710249,-0.435184028047,-0.615620520081,-0.0167090855344,0.0509306360129,-0.172445991629,0.247564670525,-0.0824119812054,0.109560620504,-0.33803944296,-0.0640388671552,-0.119399168249,-0.146738010277,-0.166106775411,0.00492235616058,0.359055825686,0.270258199013,0.368790105509,0.13260601299,0.0999420214428,-0.0506261541783,-0.134478148311,0.121902086921,0.117299612811,0.0285752806949,0.168936557441,0.00218397090514,0.0284772759363,-0.013631072687],[-25990.3953805,-437.474312828,-745.228843605,-1091.69941421,607.854849156,923.380317084,525.378422493,-48.5757250031,214.384995894,-748.724872454,-568.24465142,484.783348803,-80.8722124842,421.687128848,-455.556350864,-457.493800456,264.347368629,7.57741402097,-98.2326249665,-134.997910964,-58.5353136233,441.095145943,-4.24118540621,67.6812424252,3.56323609423,80.3026755154,-61.4216285744,111.095243091,-71.4084998512,32.7544386731,150.175622147,64.3480011555,21.2907224322,22.7556103181,-107.796011621,-36.792043859,65.6229976154,-49.6234865176,7.36665313872,16.9493214655,25.1666179003,34.5545332176,3.88240838644,34.5582936082,19.1902845725,-15.1971730335,10.6759477698,-8.54284937583,-12.155558259,1.4582041509,1.05472116491,3.63340317745,-0.724275391265,4.60134277853,14.032507883,4.05395936725,-0.255961268019,11.5439789725,-7.98496906537,0.350312285714,-9.72244133088,0.129966506185,-2.92614220679,-2.26659709825,-0.0828531041006,-3.75120353197,1.18451401637,3.1605729608,1.07722817078,2.14405220679,3.6302084652,2.60411462355,4.78449809638,-1.24852639555,1.18167100327,-0.476617027231,-0.614099838243,0.838182815004,1.27358699242,-0.852245119504,-0.922194588088,-1.08038886134,-0.574633763088,-0.857682350625,-0.770955890745,0.786128957557,0.811642999395,0.797769034565,0.730322720763,1.96344135651,-0.258812870578,-0.0317371503401,-0.417024719319,-0.603211919441,0.0240626269036,0.066563927129,-0.154518844067,0.2466725893,-0.0741861157642,0.101907110899,-0.345489637992,-0.0709074418128,-0.120010160844,-0.14914302665,-0.159458387763,0.0171591189171,0.36380784737,0.281270175017,0.372923566673,0.141730848075,0.103639743871,-0.0471041185319,-0.133532275583,0.130039231469,0.121916108636,0.0337888876193,0.16717815229,0.00474545044402,0.0257026145661,-0.0157261267334],[-25992.3776352,-423.625037945,-761.293307149,-1094.56050022,593.061974388,907.585004862,532.619628753,-63.7785641858,200.384782004,-756.272579499,-564.360144779,494.338047597,-74.6934213325,430.081340086,-443.899462756,-454.491320147,264.338282881,11.4316319733,-101.434844762,-138.505306317,-59.2394985959,433.050999366,-8.29378196183,69.5522039746,4.01702189634,81.9396817025,-61.745909514,112.201667762,-72.0424579099,35.8019133595,153.201234565,63.0526534192,24.8462593552,23.710104199,-107.221145355,-36.7517893481,66.7367124138,-49.0958701584,7.92492267312,16.4982682973,26.3852680966,34.0559881846,4.14911519693,33.9643415311,19.6666658926,-15.6050890984,10.4719053954,-8.98809500217,-12.1198198357,1.9855564486,1.12113939861,3.95928232885,-0.79741656106,4.97153035321,14.0417724266,4.16742804771,-0.0249688606494,11.7787053137,-7.90636038381,0.504596084688,-9.70774722227,0.034208765723,-2.85716239257,-2.32024451046,0.0175247797232,-3.75820328453,1.23355829145,3.15242739775,1.21650276918,2.1838160199,3.69052269188,2.62753995768,4.82611258931,-1.29157907503,1.20531655014,-0.533473695978,-0.640163233725,0.841400191359,1.29218088042,-0.856926175848,-0.943356185298,-1.08107140319,-0.579098720296,-0.848318416522,-0.764985341309,0.809981101035,0.835299887307,0.810803053675,0.736943501586,1.9850649787,-0.245980480763,0.00694679694863,-0.398463064336,-0.591900379959,0.0641468697077,0.0816648954214,-0.13843726957,0.246552189753,-0.0663762024748,0.0948710533176,-0.352600027895,-0.0776587276406,-0.120418530254,-0.15152381055,-0.153247086216,0.0291869960734,0.368119196911,0.292185056957,0.376727968204,0.150512983834,0.106953408206,-0.0435479899707,-0.132929143115,0.138168588473,0.126025760966,0.0386545058983,0.165384538551,0.00707942579427,0.0232033739651,-0.0177597915816],[-25998.3928166,-409.301814573,-775.286820646,-1101.50583457,581.170383662,891.637095915,539.207490904,-76.5095356439,187.571467125,-763.269740992,-561.636267254,503.556788934,-68.589844728,436.707899553,-433.186302597,-451.19795809,264.70831526,15.0565973099,-104.225381965,-141.790359692,-60.1821482612,425.301027115,-12.5119953226,71.4118500828,4.53575205949,83.4811589726,-61.893149302,113.291972079,-72.7117809788,38.6414394835,156.1466531,61.7323493507,28.3462562066,24.7865799257,-106.899687314,-36.7179305077,67.7444432833,-48.5275408164,8.49437163036,16.0538321735,27.5765968068,33.5497412808,4.45438209931,33.4153516468,20.1480676885,-16.0395062191,10.266172382,-9.46072230727,-12.1014619521,2.4737611452,1.19370705367,4.28117971521,-0.879615891701,5.34195899468,14.0416494228,4.30648662414,0.20837877622,12.0036216154,-7.82543690496,0.635269651002,-9.69696411893,-0.0525087362719,-2.78490221205,-2.37343440673,0.111991996652,-3.76569486435,1.28234687926,3.14335525139,1.3542662104,2.2237706695,3.75712931102,2.65235440002,4.86102169826,-1.33047068735,1.21989987314,-0.587121772641,-0.665356353028,0.84728579927,1.31247954491,-0.865710496681,-0.962930400083,-1.08166118212,-0.583950320515,-0.838695139946,-0.758971310205,0.833568262323,0.858557057249,0.824004349635,0.744273468351,2.00436255808,-0.233113900909,0.0430356314947,-0.380313983116,-0.581362314436,0.103001833541,0.0965399390926,-0.124371118285,0.247255889695,-0.0590857834136,0.0884076849827,-0.35923992233,-0.0841594032383,-0.120611784311,-0.153778217599,-0.147430905551,0.0409031158742,0.372158567703,0.302887088431,0.380241190802,0.15883311603,0.109946860447,-0.0401663743678,-0.132528221521,0.146147648646,0.12980308115,0.0430892329097,0.163635556737,0.00916628644512,0.0209656670047,-0.0197490850699],[-26007.6011873,-393.270031344,-787.600630999,-1112.47070347,572.713849691,875.651336643,545.322921471,-86.9002810375,175.64097203,-769.850964913,-560.072570674,512.218962734,-62.2678071816,441.139551197,-423.401058796,-447.775578384,265.44271374,18.3616365957,-106.623942196,-144.882042693,-61.4712490506,417.860591471,-16.9530892318,73.3540023434,5.11754539425,84.9260232865,-61.9095026719,114.354481987,-73.4258220152,41.2196344918,158.974067288,60.3548768312,31.7607163607,25.9661944845,-106.861189262,-36.6830968335,68.633739906,-47.9344726085,9.07361110255,15.6018733128,28.7374292556,33.0299849828,4.78249756101,32.9006363293,20.6307567188,-16.5237540962,10.0519597047,-9.96310252876,-12.0970030354,2.9199396736,1.27064674476,4.59997086607,-0.977609193742,5.71339595394,14.0290900138,4.46825992997,0.437739849753,12.2153083205,-7.75165912715,0.73856268033,-9.6940229603,-0.131060014317,-2.70977712238,-2.42512336254,0.200988004533,-3.77310259503,1.33097321692,3.13154411011,1.49114112646,2.26223564065,3.83016630206,2.67737262598,4.88795118092,-1.36771586752,1.22557337549,-0.639161926438,-0.689114611927,0.855496241515,1.33478977942,-0.878917914412,-0.980857119311,-1.08169532924,-0.588762414337,-0.828815938239,-0.75297750444,0.857190747852,0.880926198035,0.837798874504,0.751955979865,2.02098848209,-0.220709497142,0.0763240650176,-0.363290359751,-0.571342910191,0.140159720941,0.111461529425,-0.11244418733,0.248819274059,-0.0523963662359,0.0824715648075,-0.365303689693,-0.0902928897706,-0.120585982208,-0.155819387654,-0.14195827108,0.0522083893687,0.376080755796,0.313270680821,0.383498051455,0.166595065825,0.112667376603,-0.0371363495461,-0.132203483471,0.153846013601,0.133405338569,0.0470163691974,0.161999685425,0.0109876360902,0.0189757453903,-0.0217021950212],[-26019.3360448,-375.773022169,-798.310631445,-1126.56474798,567.383208603,859.688186938,550.885472423,-95.3870373805,164.337362653,-776.315564519,-559.554988654,520.277640438,-55.8820926477,443.40252298,-414.465001213,-444.325821389,266.510197476,21.3275008265,-108.649429554,-147.808808698,-63.1351146264,410.746069448,-21.5901572683,75.371488763,5.7253834282,86.2771260536,-61.8133680498,115.402424875,-74.1978512708,43.5326901335,161.659590543,58.9032022709,35.0593979411,27.2307213436,-107.095853876,-36.6482432838,69.4052671814,-47.3207130722,9.67072943167,15.1311969757,29.8659015013,32.492978932,5.12475480747,32.4167239562,21.1110112587,-17.0629236168,9.83322445982,-10.4944811398,-12.1040116033,3.32405414022,1.34986643581,4.91796976838,-1.09441620157,6.08775793689,14.0028704022,4.6497187807,0.661819531612,12.4111802791,-7.69115543727,0.815253463976,-9.70065828429,-0.202721481312,-2.63177068625,-2.4746631827,0.284044759635,-3.77992506745,1.37982775236,3.11608244197,1.62768988493,2.29806868039,3.90931903241,2.70231850515,4.90684975695,-1.40476251506,1.22277259815,-0.690652928847,-0.711424656162,0.865512823549,1.35921058763,-0.896089845481,-0.99715377038,-1.08117483938,-0.593419725628,-0.818591778312,-0.747107375891,0.881071803794,0.902060505839,0.852477940858,0.759922733134,2.03496059277,-0.209101326724,0.1066610135,-0.347696934645,-0.561862452612,0.175448781935,0.126566430023,-0.102596061704,0.251210596258,-0.0463013209148,0.0770145384665,-0.370785933302,-0.0960095786613,-0.120371388576,-0.157621597516,-0.136739170239,0.0630188588225,0.379984967872,0.323270916622,0.3865211123,0.17379515597,0.115095952716,-0.0345088811285,-0.13188690986,0.161181728557,0.136920834729,0.0503840279701,0.160499955456,0.0125299352409,0.0172204161656,-0.0235919891964],[-26032.9739457,-357.423607273,-807.413876799,-1142.6911978,564.658562381,843.794535062,555.749355587,-102.482190526,153.416741218,-783.004029384,-559.941050258,527.72931387,-49.6995999421,443.636413865,-406.283670072,-440.935271532,267.875353415,23.9527971054,-110.320547757,-150.598981532,-65.1821404584,403.974091745,-26.37525047,77.4318889518,6.31346336817,87.5383025459,-61.6162047844,116.455253495,-75.0421183208,45.5891917337,164.182817246,57.3640867127,38.211997759,28.5620880919,-107.584046563,-36.6164061832,70.0629688136,-46.6873281,10.2961842721,14.6313446829,30.9604773106,31.9354995605,5.47419825364,31.9619469065,21.5851124624,-17.6575459647,9.61661027391,-11.0533221723,-12.1203186958,3.68677681985,1.42919542811,5.2378500234,-1.23212763052,6.46724901317,13.9622230556,4.84779548734,0.880584734579,12.588860943,-7.64922119434,0.867257442146,-9.71805552839,-0.268870149754,-2.55075849273,-2.5215044794,0.360467342827,-3.78567943931,1.42937518628,3.09628393498,1.76445978728,2.33026210127,3.99415971652,2.72714320567,4.91797188647,-1.44279184565,1.21200386651,-0.742518076908,-0.73241093896,0.876773026499,1.38578902571,-0.916573102334,-1.01185716582,-1.08021667327,-0.597884696578,-0.807910514467,-0.74147431265,0.905415411258,0.921648553677,0.868299201405,0.76817750972,2.04638759582,-0.198582869704,0.13390894399,-0.333736412272,-0.553010001606,0.208771278425,0.141957477568,-0.0947202733756,0.254381276823,-0.0407719830025,0.0719877733242,-0.375706315207,-0.101276603899,-0.120006819411,-0.159174408223,-0.131673980997,0.0732543493057,0.383956513272,0.332833046114,0.389329871762,0.180452834617,0.117197014835,-0.0323034066878,-0.131524983637,0.168084949635,0.140420629168,0.0531465256027,0.159148035734,0.0137808586127,0.0156866252088,-0.0253825053405],[-26047.8914464,-338.834606887,-814.907421878,-1159.75328268,564.020013007,828.017269276,559.768782792,-108.698126325,142.635209946,-790.256849082,-561.088284549,534.570474853,-43.9872278803,441.980822816,-398.762605596,-437.690513241,269.502768506,26.236132536,-111.656000525,-153.280885019,-67.6207220168,397.561289059,-31.2604198749,79.5027825198,6.83598242099,88.7133880352,-61.3294722247,117.532420597,-75.9728727406,47.3977246171,166.52334178,55.7242911993,41.1882126254,29.9422223182,-108.306132728,-36.5906218557,70.6107885063,-46.0353835847,10.9604332784,14.0918579555,32.0196204503,31.3543233007,5.82387231446,31.5346375588,22.0493414844,-18.3081523237,9.40876077358,-11.6380896584,-12.1437553528,4.0087799873,1.50646302293,5.56228523241,-1.39283419593,6.8540732524,13.9063804416,5.05942236089,1.09400237144,12.745973764,-7.63115175741,0.896490055051,-9.74740013011,-0.330883032139,-2.46661613088,-2.5650978648,0.42956083498,-3.78988286834,1.48008021933,3.07146227715,1.90199813497,2.35780821582,4.0842605688,2.7517978957,4.92157202963,-1.48298507495,1.19377350596,-0.795680667665,-0.752197913552,0.888714331489,1.41457214984,-0.939714497419,-1.02500411816,-1.07893779166,-0.602119769373,-0.796660001009,-0.736191702809,0.930425551355,0.939378914563,0.885520308851,0.776724091181,2.05537819695,-0.189447606132,0.157930323535,-0.321611497112,-0.544874617078,0.240029472313,0.157737508744,-0.0887103543141,0.258282736286,-0.0357796880514,0.0673424367454,-0.38008449746,-0.106061099472,-0.119531090706,-0.160467380811,-0.126663081321,0.082834685888,0.388080701337,0.341902319574,0.391943828264,0.186587549916,0.118934989008,-0.0305393637968,-0.131064187753,0.174485832955,0.143975781422,0.0552581784699,0.157955595165,0.0147280809215,0.014361318398,-0.027037781199],[-26063.4651034,-320.618841238,-820.788321499,-1176.65423235,564.947662463,812.403277844,562.797965866,-114.547230632,131.748871062,-798.414513187,-562.854220588,540.797615209,-39.0118752779,438.575348797,-391.807348009,-434.678130943,271.357029698,28.1761142214,-112.674491576,-155.882842982,-70.4592547713,391.52429209,-36.1977165207,81.5517490774,7.2471377935,89.8062177932,-60.9646297194,118.653378932,-77.0043641054,48.9668741086,168.660758526,53.9705767735,43.9577393515,31.3530516111,-109.242477779,-36.5739266256,71.0526699637,-45.3659454189,11.6739341049,13.5022783143,33.041794687,30.746226585,6.16682140487,31.133128292,22.499979479,-19.0152738776,9.21631958541,-12.24724763,-12.1721526144,4.29073591736,1.57949852153,5.89394899668,-1.57862661316,7.25043472421,13.834575028,5.28153171238,1.30203935497,12.880142194,-7.64224248549,0.904866742898,-9.78987752696,-0.390137140966,-2.37921918979,-2.60489395107,0.490630316964,-3.79205251225,1.53240755221,3.04093115647,2.04085222947,2.37969933658,4.17919380369,2.77623374338,4.91790464655,-1.52652341864,1.16858784189,-0.851063998159,-0.770910033166,0.900774219646,1.44560701622,-0.964860843182,-1.03663143992,-1.07745515529,-0.606087386202,-0.78472809224,-0.731372934462,0.956306205193,0.954940161513,0.904398915902,0.785566259079,2.06204110185,-0.181989016057,0.178587619185,-0.311524893641,-0.537545358936,0.2691256255,0.174009360235,-0.0844598364887,0.262866395179,-0.0312957716137,0.0630296960946,-0.38394014211,-0.110330199368,-0.118983018454,-0.161490076317,-0.121606849178,0.0916796936394,0.392442841409,0.350423987279,0.39438248023,0.192218750016,0.120274301285,-0.0292361900284,-0.130451005158,0.180314534636,0.147657351028,0.0566733029465,0.156934302654,0.015359276883,0.0132314416114,-0.028521854517],[-26079.0797332,-303.30311315,-825.000484499,-1192.55521498,567.032975839,797.079851524,564.739085704,-120.463475641,120.551052809,-807.706743024,-565.113334735,546.374015134,-34.9509040806,433.56728361,-385.350187521,-431.960998725,273.414151353,29.7872697957,-113.399803825,-158.430708419,-73.6928746399,385.876275523,-41.1350754725,83.5513466658,7.50927558312,90.8234856434,-60.5371568485,119.837455986,-78.1485841241,50.3082279047,170.57647403,52.1010550482,46.4945668318,32.7738888293,-110.37247848,-36.5685714537,71.3923522547,-44.6805945708,12.4454560225,12.8547135085,34.0273568043,30.1093854983,6.49666473955,30.755780406,22.9316135468,-19.7788959291,9.04499283712,-12.8778110007,-12.2035522817,4.53295723505,1.64609635696,6.23546579437,-1.79124900995,7.6583344163,13.7463311433,5.5115605981,1.50476678057,12.9890587806,-7.68669786447,0.894136959279,-9.84637014663,-0.447589833178,-2.28898728544,-2.64045008357,0.543117009412,-3.79189731655,1.58661988281,3.00404227878,2.18158133625,2.39504897938,4.27858965396,2.80050521969,4.9071571065,-1.57444219764,1.13695144892,-0.909372895109,-0.788606544502,0.912401003615,1.4788863665,-0.991376471324,-1.04674929816,-1.0758752972,-0.60975157881,-0.772055312497,-0.727129843161,0.983228168968,0.968059819643,0.925144762827,0.794693379453,2.06647887433,-0.176430393806,0.195770333084,-0.303671250959,-0.531068879572,0.295954699735,0.190837148911,-0.0818418220438,0.268082154309,-0.0272919686511,0.0590041923033,-0.387289114888,-0.114063999657,-0.118403286185,-0.162239916989,-0.116415496473,0.0997059682381,0.39712484293,0.358356582199,0.39666777048,0.197368189443,0.121184494507,-0.0284075554129,-0.129649040468,0.185528465703,0.151521986446,0.0573614143732,0.1560962821,0.0156660829964,0.0122868212337,-0.0298071231423],[-26094.1531917,-287.070155838,-827.275235785,-1207.64915254,570.312870658,782.495891063,565.686199463,-126.567178916,108.983987515,-817.920186907,-567.807892531,551.130108311,-31.6235287538,427.134690401,-379.430414281,-429.507149321,275.695857493,31.147809014,-113.876036965,-160.940451025,-77.2636793322,380.616589997,-46.0039679031,85.4940470524,7.61733744965,91.7833196158,-60.0786141149,121.103478178,-79.4084930406,51.4453831876,172.259143495,50.1592399178,48.7898522945,34.1735879107,-111.671657031,-36.5736658461,71.6327559096,-43.9829723108,13.277014768,12.1515362007,34.9842356524,29.4475747364,6.80932073214,30.4010708862,23.3320545741,-20.596820256,8.89673666103,-13.5209982104,-12.2368392002,4.73431796624,1.70391148931,6.58926361106,-2.03105916376,8.07896098877,13.6423405597,5.74896505557,1.7026724741,13.0706924553,-7.76435888758,0.865386211319,-9.91654837763,-0.502519843518,-2.19851614154,-2.67175054035,0.587006692006,-3.78989337803,1.64217189798,2.96029942124,2.32479257674,2.40345547321,4.38231042568,2.82508000692,4.88924841517,-1.62719315395,1.09936189861,-0.970438303944,-0.805085868135,0.923086322123,1.51418568429,-1.01869579056,-1.05526127798,-1.07426303963,-0.613082737181,-0.758792866253,-0.723568054305,1.01122949921,0.978621222488,0.947775940138,0.804037156256,2.06876951063,-0.17271429082,0.209476107762,-0.29821299666,-0.525322201329,0.320382456149,0.208130112394,-0.0806476938238,0.273873835584,-0.0237416117624,0.0552344605708,-0.390132096248,-0.117294444723,-0.117840047564,-0.162745769915,-0.11103857085,0.106817187795,0.402195015763,0.365711768075,0.398831419419,0.202066848211,0.121655578687,-0.0280440598109,-0.128690384966,0.190194056802,0.155568691819,0.0573528239533,0.155455477376,0.0156559828957,0.0115288056753,-0.0308994253321],[-26108.1115948,-272.01668511,-827.290754284,-1222.38690547,574.935627546,769.180699701,565.781333363,-132.900244362,97.0271335278,-828.730724903,-570.897106814,554.863116792,-28.7594268931,419.463325155,-374.114068429,-427.260905122,278.235299553,32.3518621621,-114.152369886,-163.425569665,-81.1005070058,375.741130139,-50.7317490126,87.3773004358,7.57441394346,92.706706292,-59.6245822529,122.470146659,-80.7847932321,52.404939511,173.699234286,48.1999958466,50.8390450514,35.518388063,-113.114566994,-36.5875339454,71.7765968235,-43.2772349847,14.1689376949,11.3976852821,35.9222530985,28.7659686476,7.10128259598,30.067505639,23.6874193934,-21.4663027554,8.77256969057,-14.1665785802,-12.2711089765,4.89333248699,1.75056401046,6.95772130923,-2.29806826446,8.51330001978,13.5235869102,5.9937058676,1.89634844402,13.1230812452,-7.8739756749,0.819534019525,-9.99977959867,-0.553786251178,-2.11094550871,-2.69888633265,0.622421284188,-3.7867085813,1.69831628182,2.9092443788,2.47110503634,2.40463835036,4.49027644329,2.8505290902,4.86403048738,-1.68508213483,1.05631501174,-1.03387269977,-0.820081218112,0.932332645419,1.55122613866,-1.04627072887,-1.062044319,-1.0726727771,-0.616052840857,-0.745144628012,-0.720791640751,1.04031506755,0.986546655683,0.972262625909,0.813514877924,2.06898486509,-0.170713072822,0.219729620843,-0.295304502958,-0.520139939037,0.342267355721,0.225758768496,-0.0806484048485,0.280183741185,-0.0206184329556,0.0516925096629,-0.392465970324,-0.120066441034,-0.117343323794,-0.163044363397,-0.105435453891,0.112913801031,0.407718269871,0.372514491343,0.400907591843,0.206348012708,0.121682680631,-0.0281305355406,-0.1276242516,0.194404993479,0.159782060215,0.0566930418559,0.155026287346,0.0153404219983,0.0109616238536,-0.0318129594462],[-26120.3810583,-258.239416777,-824.725218923,-1237.21933418,581.049527134,757.663580683,565.166513626,-139.504575886,84.6599491955,-839.814237077,-574.34019042,557.370262632,-26.088276094,410.738943857,-369.467190099,-425.166588524,281.065628966,33.493559526,-114.277981477,-165.899563208,-85.1321958181,371.245790575,-55.2457740008,89.1985570144,7.38359561494,93.6146322534,-59.2106419964,123.956162581,-82.278187076,53.2134964287,174.887213769,46.2781872991,52.6375944141,36.7745284941,-114.675761926,-36.6084998942,71.8265908917,-42.5675389385,15.1215521562,10.5980996436,36.8512310096,28.0697415805,7.36904354446,29.753590571,23.9838248373,-22.384599324,8.6735105592,-14.8043214315,-12.305457217,5.0085151734,1.78367401226,7.34321775134,-2.59228750192,8.9623370875,13.3910538279,6.24574381701,2.08638669881,13.1442631777,-8.01429834652,0.757499904405,-10.0954311885,-0.600248135348,-2.02941513758,-2.72194847174,0.649482705403,-3.78301081094,1.75430571839,2.85041894644,2.62113780048,2.39831714314,4.6024080312,2.87742345467,4.83135523797,-1.74841498754,1.00830660908,-1.09928855769,-0.833325808479,0.939642443748,1.58972889869,-1.07355321422,-1.06697536085,-1.07115890416,-0.61863386938,-0.73131447228,-0.718904675357,1.0704897456,0.991758404865,0.998574998214,0.823043832889,2.06719679206,-0.170299105531,0.226555549956,-0.29510014207,-0.515356707526,0.361467859429,0.243593635025,-0.0816149081375,0.286954173294,-0.0178961642391,0.0483503483457,-0.394287621251,-0.122424895055,-0.116963136076,-0.163172425733,-0.0995655271754,0.117896256664,0.413759515218,0.378789698437,0.402930452553,0.210244969324,0.121260927144,-0.0286518149202,-0.12649985332,0.198254961284,0.164146684699,0.0554275782502,0.154823110878,0.0147308457217,0.0105895046854,-0.0325619238444],[-26130.3876983,-245.835066648,-819.25680863,-1252.59729909,588.80285005,748.47383725,563.983766475,-146.422077392,71.8618928665,-850.846603494,-578.096356188,558.448767886,-23.3397539519,401.14730249,-365.555819431,-423.168521918,284.21999717,34.6670313913,-114.302050627,-168.37593052,-89.2875839266,367.126465931,-59.4733980678,90.9552669869,7.04797301447,94.5280840818,-58.8723740795,125.580227098,-83.8893769497,53.8976534944,175.813549311,44.44867874,54.1809496944,37.9082484115,-116.329795388,-36.6348878352,71.7854540094,-41.8580405181,16.1351855055,9.75771817629,37.7809912528,27.3640678833,7.60909679094,29.4578315886,24.2073877383,-23.3489658586,8.60057790038,-15.4239960856,-12.3389795285,5.07838040153,1.80086158658,7.74813179986,-2.91372806601,9.42705777011,13.2457249459,6.5050396866,2.27337924691,13.13227628,-8.18407702251,0.680203386466,-10.2028705257,-0.64076457522,-1.95706477879,-2.74102796884,0.668312875092,-3.77946795155,1.80939289178,2.78336491915,2.77550995459,2.38421138382,4.71862551384,2.90633408545,4.79107458174,-1.81749755933,0.955832511411,-1.16629835282,-0.844552853281,0.94451818736,1.62941513345,-1.09999517458,-1.06993134315,-1.06977581533,-0.620797802291,-0.717506273564,-0.718011230982,1.10175840498,0.99417875567,1.02668323513,0.832541309588,2.06347714588,-0.171344754667,0.229978572724,-0.29775428621,-0.510807121626,0.377842428252,0.261505229791,-0.0833181567103,0.294127434096,-0.0155485376208,0.0451799853852,-0.395593933162,-0.124414713252,-0.116749505612,-0.163166685223,-0.0933881722852,0.121665003415,0.420383661768,0.38456233579,0.404934166348,0.213791004447,0.120385445032,-0.0295927302678,-0.125366403074,0.201837645765,0.168647158338,0.0536019433054,0.154860346837,0.0138386994835,0.0104166770879,-0.0331605168865],[-26137.7304648,-234.887140905,-810.756811097,-1268.76923694,598.317345788,741.961152146,562.368215218,-153.657765601,58.6340025601,-861.548618918,-582.117411088,557.965460761,-20.2784138864,390.860887747,-362.399217926,-421.211570092,287.706792491,35.961255669,-114.270321748,-170.864897654,-93.5030935291,363.400004147,-63.3616479929,92.6427973698,6.56948793333,95.4564399735,-58.6399637407,127.353974754,-85.6169208593,54.4873704965,176.478632134,42.7600553491,55.4663712063,38.8901699453,-118.050812737,-36.6652598476,71.6546524258,-41.1516654155,17.2076567017,8.88143062325,38.7200874824,26.6555062629,7.81936725054,29.1790931466,24.3464028732,-24.354420342,8.55468786488,-16.0160329767,-12.3705771698,5.10193376421,1.79987625552,8.17376680128,-3.26196970446,9.9077691182,13.0888134069,6.77165124444,2.4580564893,13.0853615077,-8.3812447729,0.588721317801,-10.3210458598,-0.674674626542,-1.89661949727,-2.75617268155,0.679114623526,-3.77675157122,1.86274075189,2.70773650551,2.93454021754,2.36207772047,4.83866954573,2.9377882089,4.74304008291,-1.8922941228,0.89942166925,-1.23430850115,-0.853632544742,0.946506800023,1.66994444609,-1.1251496352,-1.07079516823,-1.06855038972,-0.622545597054,-0.703922226567,-0.718206188148,1.13403799231,0.993740279755,1.05646858117,0.841939536615,2.05785874731,-0.173688774758,0.230033824276,-0.303306607134,-0.506368830741,0.391295335737,0.279333176995,-0.0855572577231,0.301652194246,-0.0135410328625,0.0421587517776,-0.396377004083,-0.126081986831,-0.116746932816,-0.163061220494,-0.0868819111388,0.124133521572,0.427620967801,0.389854675205,0.406936569741,0.217017499842,0.119047935243,-0.0309141577733,-0.124270593807,0.205231796199,0.173251582654,0.0512550134673,0.155151414048,0.0126789927002,0.0104412662513,-0.0336262160194],[-26142.6996456,-225.426307209,-799.868949077,-1285.17388974,609.608639309,737.756726124,560.427371512,-161.069108485,45.0636349804,-871.820736911,-586.325538632,556.065594085,-16.8083126131,379.999109149,-359.829532556,-419.242767405,291.435350828,37.4446007704,-114.214801344,-173.363599401,-97.7454829833,360.167066415,-66.9362368735,94.2481824508,5.9454871264,96.3626445846,-58.5220142358,129.260773672,-87.4507993261,55.0260481624,176.922548889,41.235785169,56.4983632736,39.7084469144,-119.81132652,-36.6991297574,71.4306538054,-40.4464167071,18.3267511273,7.97393013597,39.6720005015,25.9561528592,8.0035066455,28.9176738923,24.3978767959,-25.3870291001,8.53634667285,-16.5735069897,-12.3983740098,5.08014572118,1.77898526207,8.61712403825,-3.63486639645,10.4020640721,12.9224503919,7.04602419961,2.64170239687,13.0025715301,-8.60046646747,0.484759876847,-10.4472289228,-0.703237251292,-1.84914561523,-2.76725785284,0.68241442428,-3.77554797206,1.91315331178,2.62363756862,3.09734584209,2.33182126427,4.96156210187,2.9721380163,4.6871019032,-1.97140265182,0.839735552032,-1.30190118236,-0.860982987794,0.945333019604,1.71073017598,-1.14897401033,-1.06947358921,-1.06739944474,-0.623994122809,-0.690757806784,-0.719547658035,1.16689375419,0.990416692865,1.08745654665,0.851230503222,2.05021828283,-0.17703547556,0.226798269746,-0.311337974741,-0.502091622578,0.40191410571,0.296793526387,-0.0882439348774,0.309502598309,-0.01180612074,0.0392852674407,-0.396609787606,-0.127477545962,-0.116977834952,-0.162879511474,-0.0801018270061,0.125267417698,0.435363084856,0.394678289959,0.408890186113,0.219948218785,0.117226395295,-0.032481149113,-0.123249038452,0.208456416771,0.177862092989,0.0483991302893,0.15570581117,0.0112809907846,0.0106369824583,-0.0339896150382],[-26145.7583626,-217.470023594,-787.430054089,-1301.04757581,622.665824436,735.312139438,558.261844103,-168.476686829,31.2597265024,-881.608325734,-590.635516464,552.964026836,-12.8683826716,368.668106926,-357.632131656,-417.209690609,295.290244972,39.1802827316,-114.164061442,-175.865897738,-101.989094687,357.549267238,-70.2425493864,95.7563733357,5.17216858944,97.1980341864,-58.5217333251,131.276925367,-89.3788484998,55.5604474541,177.195310085,39.8930569574,57.2832412222,40.3556160598,-121.583441078,-36.7362493273,71.1086761665,-39.7390668158,19.4777457704,7.039860718,40.6389429005,25.2794881705,8.16659839979,28.6742310213,24.3609940045,-26.4306205444,8.54595806177,-17.0901541226,-12.4202995698,5.01447794893,1.73658527946,9.07412927745,-4.029840679,10.9068570447,12.7489965919,7.32870124646,2.82573933299,12.8831619446,-8.83558992594,0.370182573625,-10.5782723176,-0.728191388004,-1.8152947692,-2.77411557203,0.678819661758,-3.77654713964,1.95934485037,2.53128438519,3.26274371447,2.29338424216,5.08614548736,3.00969194015,4.62310985371,-2.05307954561,0.777468758926,-1.36745251698,-0.867159265543,0.940766037488,1.75112409656,-1.17152681152,-1.06587932191,-1.06621228233,-0.625289226617,-0.678206809908,-0.722084559487,1.19980301222,0.984191996761,1.11908370833,0.86042113882,2.0403934053,-0.181055555634,0.220359331768,-0.321314558472,-0.498068319417,0.409832074567,0.313571434111,-0.0913180660109,0.317659159323,-0.0102680197828,0.0365634745222,-0.396260451215,-0.128653405554,-0.1174591085,-0.162642388421,-0.0731221434946,0.125045329926,0.443467012786,0.399042078696,0.410731210561,0.222605019928,0.114895396848,-0.0341347998351,-0.122335829936,0.211515575394,0.182364333141,0.0450400016013,0.15653205682,0.00967752314842,0.0109714322649,-0.0342845868253],[-26147.3697377,-211.035748093,-774.276957653,-1315.62661346,637.477994994,734.078972342,555.972241734,-175.701081422,17.3312135015,-890.856753648,-594.96212223,548.875617996,-8.39755660137,356.974021306,-355.592383562,-415.059916456,299.156047714,41.2315175893,-114.14667407,-178.365654641,-106.208271038,355.668221122,-73.3259702083,97.15232113,4.24573031822,97.9139450497,-58.6423287689,133.378731356,-91.3889045304,56.1373293335,177.34692623,38.7490594723,57.8273203782,40.8242141225,-123.339260756,-36.77637032,70.6839375275,-39.026388164,20.6459176193,6.0838663729,41.6231272699,24.6389926953,8.31372593739,28.4494217291,24.2349389971,-27.4690230869,8.58392576912,-17.5597103732,-12.434283371,4.90639212397,1.67107298092,9.54070828554,-4.44431508914,11.4190624486,12.5708126976,7.62022507932,3.01158966106,12.726388349,-9.08046296803,0.246852918155,-10.7110286469,-0.751275975214,-1.7957185957,-2.77657792845,0.66893772036,-3.78043905957,2.00002964654,2.43089323193,3.42955072089,2.24670888108,5.21126200729,3.05075841294,4.55091374557,-2.13558120338,0.713315889103,-1.42933862559,-0.872716461099,0.932575045065,1.79047798127,-1.19286655029,-1.05992508216,-1.06487820448,-0.626576755541,-0.666463031633,-0.725865811349,1.232243088,0.975050193209,1.15078664296,0.869518372821,2.02822176761,-0.185419713542,0.210804432978,-0.332702527766,-0.49439174354,0.415182578704,0.329352056308,-0.0947195289615,0.326102390326,-0.00885094852012,0.0339973151703,-0.395297162393,-0.129661580516,-0.118207649936,-0.16237068159,-0.066017084212,0.123445896386,0.451789751445,0.402954940062,0.412395838179,0.225009761924,0.112029511563,-0.0357162054876,-0.12156506119,0.214413339981,0.186643946906,0.0411833352336,0.157638669617,0.00790141920346,0.0114122222267,-0.0345450042631],[-26147.996893,-206.140938739,-761.246491286,-1328.14732103,654.034244807,733.508805092,553.659173149,-182.562873048,3.38703235288,-899.511388912,-599.220133574,544.015226544,-3.33476694214,345.02299252,-353.49565661,-412.741021699,302.917331845,43.6615213796,-114.191211254,-180.856732085,-110.377354435,354.64554257,-76.2318840159,98.4209769396,3.16237030852,98.4617134457,-58.8870083274,135.542493152,-93.4688035678,56.8034547626,177.427407832,37.8209814716,58.1369160677,41.1067778437,-125.050889898,-36.8192444981,70.1516559068,-38.3051531746,21.8165436621,5.11059110422,42.6267662,24.0481469317,8.4499726823,28.2439032114,24.018896272,-28.4860651391,8.65065353237,-17.9759117394,-12.4382549347,4.75734992277,1.58084503966,10.0127868292,-4.87571216392,11.9355946968,12.3902593997,7.92113839252,3.20067574444,12.5315063408,-9.32893341346,0.116634420461,-10.8423505135,-0.774229951456,-1.79106873125,-2.77447701142,0.653375984489,-3.78791371743,2.03392197918,2.32268038555,3.59658374757,2.19173740799,5.33575396678,3.09564586719,4.47036338987,-2.21716402434,0.64797154173,-1.48593562872,-0.87820965757,0.920529233722,1.82814360355,-1.21305173819,-1.05152358579,-1.06328651315,-0.628002556642,-0.655720267652,-0.730940332465,1.26369130313,0.962975283972,1.18200192732,0.878529134639,2.01354102265,-0.189798647846,0.198220996011,-0.344968052063,-0.491154717227,0.418098954516,0.34382054912,-0.0983882015671,0.334812804358,-0.00747912548142,0.0315907315327,-0.393688088624,-0.130554085758,-0.119240355739,-0.162085221237,-0.0588608727658,0.120447755211,0.460188300688,0.406425772699,0.413820264065,0.227184303424,0.108603311101,-0.0370664616187,-0.12097082514,0.217153778445,0.190586578083,0.0368348390162,0.159034168179,0.00598550836151,0.0119269588997,-0.0348047402339],[-26148.1942082,-202.707433699,-749.053430618,-1338.05467365,672.22116788,733.15279399,551.296491783,-189.005532409,-10.480980224,-907.540575654,-603.377920704,538.56263754,2.31609765034,332.906167663,-351.138507101,-410.199341685,306.477807463,46.497263632,-114.328265626,-183.328214793,-114.47977449,354.575573807,-78.9911233444,99.5547176646,1.92426257292,98.8044256376,-59.2577960127,137.74551447,-95.6053072781,57.5933958832,177.479579385,37.1158985775,58.2198622389,41.1971522263,-126.693059166,-36.8636971866,69.511083456,-37.5718263556,22.9772129355,4.12453393793,43.6493058533,23.5170856479,8.57820568001,28.0578694913,23.7122358429,-29.4671627436,8.74649958147,-18.3339130822,-12.4306694298,4.56997926973,1.46530962189,10.4865561894,-5.32159510852,12.4533862262,12.2092877346,8.23117892557,3.39387202145,12.2980994853,-9.57552597799,-0.0186952457431,-10.9693450356,-0.798492775644,-1.80141927917,-2.76770720633,0.632926880095,-3.79930580255,2.0600470474,2.20700653791,3.76269066259,2.1286283135,5.45850781675,3.14442096995,4.38141742395,-2.29618659784,0.582084564256,-1.53594465317,-0.884105419851,0.904422300225,1.86355604723,-1.23208392142,-1.04064464554,-1.06130829456,-0.629660578994,-0.646097320304,-0.737324292757,1.29368364384,0.947996161751,1.2122499374,0.887440313514,1.99627772183,-0.193882975794,0.182762661472,-0.357625355759,-0.48845660426,0.418693118851,0.356723969872,-0.102266554554,0.343758159136,-0.00608116715826,0.0293351712754,-0.391403716933,-0.131371031991,-0.120553997635,-0.16180586022,-0.0517226558152,0.116062100566,0.468540720259,0.4094600684,0.414960045402,0.229154332521,0.104613089354,-0.0380432160752,-0.120578738737,0.219728747492,0.194094381959,0.0320014905827,0.160713506866,0.00395579820975,0.0124808522266,-0.0350864725473],[-26148.8810934,-200.274591679,-737.924327721,-1345.62827368,691.515358924,732.960399532,548.351029822,-195.464089876,-24.2493861321,-915.004561456,-607.618224073,532.557340357,8.29132405543,320.654721302,-348.362243185,-407.376246136,309.81773389,49.620727848,-114.596512238,-185.750078467,-118.535309676,355.443567939,-81.5763121622,100.575623383,0.557485191321,98.9521678579,-59.7519808433,139.96910781,-97.7808793922,58.4929695554,177.517521336,36.6004338695,58.0900673286,41.0944153211,-128.251004492,-36.9048479591,68.7776088602,-36.8216405565,24.1247626701,3.1296139896,44.6791266804,23.0425606911,8.69242646202,27.8896619024,23.3150697868,-30.404082467,8.87164011618,-18.6345447151,-12.4120846149,4.3515730808,1.32792086566,10.959269704,-5.78008980072,12.9694415713,12.0282101207,8.54686459855,3.58986123011,12.0270632191,-9.81747296149,-0.157701751964,-11.0901373927,-0.824305988205,-1.82453420996,-2.7564120829,0.609122999314,-3.81352881921,2.07867373117,2.08481004135,3.92684326142,2.05840514296,5.5785865915,3.19618332656,4.28446979,-2.37141627378,0.516120797228,-1.57936685054,-0.890516239985,0.884145962861,1.89648363774,-1.24973678498,-1.02748646192,-1.05874177202,-0.631437179725,-0.63741301851,-0.744902866458,1.32199075487,0.930321282996,1.24138624628,0.896158638004,1.97671401077,-0.197442989377,0.164847941852,-0.370380883072,-0.486422934424,0.416991310368,0.368056980623,-0.1063074302,0.352855191091,-0.00460328189089,0.027172104136,-0.388423812522,-0.132104913127,-0.122064848341,-0.161548541805,-0.0446512722262,0.110430350752,0.476809309465,0.412049691538,0.415848187729,0.230960855073,0.100142029142,-0.0385703258985,-0.120380515006,0.222081258998,0.197135559793,0.0266953467818,0.162617383002,0.00181100903691,0.0130295256978,-0.0353680987225],[-26151.068217,-198.286151521,-727.963678775,-1351.35638031,711.290912834,732.980658262,544.162864145,-202.496465732,-37.91184693,-921.986569768,-612.177376696,526.003750444,14.2622430363,308.284834868,-345.01936098,-404.211863371,312.936507757,52.8776510222,-115.036646745,-188.087521554,-122.572825682,357.20750579,-83.945522296,101.513199969,-0.905907739581,98.9267763311,-60.3656680896,142.195587872,-99.9769091573,59.4758038188,177.548128115,36.2310972911,57.7629583958,40.7989534406,-129.712588131,-36.9368899516,67.9706549378,-36.0495207123,25.258342145,2.12960539725,45.7018427037,22.6179781783,8.78442018135,27.7371586059,22.8276956963,-31.2901785064,9.02620582875,-18.880055815,-12.3835838965,4.11059051982,1.17314440198,11.4284462254,-6.24946278649,13.4807832907,11.8469293221,8.86390837672,3.78677818338,11.7196209467,-10.0526835599,-0.299036606013,-11.2031072797,-0.851611649944,-1.85759996091,-2.74079750691,0.583681975832,-3.82914097542,2.09038183066,1.95717366339,4.08804432137,1.98230770539,5.69509747113,3.24979077693,4.18002325643,-2.44172259222,0.450500329472,-1.61652837867,-0.897466091804,0.859616445296,1.92677801091,-1.26572704853,-1.01230433235,-1.05536695308,-0.633166817973,-0.629411197836,-0.753528478878,1.34844194562,0.910203995093,1.26935022624,0.904570796493,1.95522093362,-0.200268899271,0.144961567607,-0.382989133181,-0.485185779001,0.412998348178,0.377876144618,-0.110466263673,0.362007881334,-0.00299607598177,0.0250305053701,-0.384730460132,-0.13273631888,-0.123669055824,-0.161328231862,-0.037690483916,0.103726480102,0.484977427502,0.414183099635,0.416537058676,0.232648706375,0.0952950355184,-0.0385882004289,-0.120359390995,0.224142113631,0.199694824329,0.0209297342654,0.164672929656,-0.000456960692879,0.0135262061906,-0.0356163212057],[-26155.7662468,-196.185852063,-719.275979963,-1355.72725272,730.921924501,733.262606724,538.072071628,-210.660580261,-51.4620241763,-928.569824036,-617.291711587,518.906283252,19.9001853561,295.812689795,-340.962356599,-400.646321709,315.833525692,56.1137701492,-115.689364803,-190.305742502,-126.621188197,359.825368186,-86.0568255726,102.396953295,-2.43386212307,98.7500872819,-61.0949630218,144.407269354,-102.17478582,60.5155267134,177.578294155,35.9643987862,57.2539624996,40.3111528976,-131.065672334,-36.9540162999,67.1096445072,-35.2503917579,26.3771006394,1.12828229886,46.703067946,22.2367442263,8.84597199102,27.5982377631,22.250411164,-32.1188050591,9.21032741141,-19.0726955584,-12.3462506809,3.85549075064,1.00544586188,11.8916046058,-6.72798061178,13.984433943,11.6653481028,9.17802322532,3.98275769422,11.3769960724,-10.279066969,-0.441351315704,-11.3066343916,-0.880351821665,-1.89780296931,-2.72106934417,0.558321443333,-3.84470047919,2.09575114607,1.82518017153,4.24529661978,1.90157580982,5.80714763577,3.30410116096,4.06858059163,-2.50597509318,0.385643249815,-1.6477553954,-0.904978949137,0.830749971195,1.95429080254,-1.27977143174,-0.99535355427,-1.05096384529,-0.63468395288,-0.621835693851,-0.763053555329,1.37286652546,0.887897645429,1.29608124961,0.912563477366,1.93216953452,-0.202150916153,0.123588269199,-0.395204605261,-0.484877209278,0.406719051393,0.386238025098,-0.114698490141,0.371120210974,-0.00121015573333,0.0228393502331,-0.380305744507,-0.133245838965,-0.125262768048,-0.161159896258,-0.0308840528021,0.0961244629499,0.493028433569,0.41584875021,0.417079025869,0.234262721725,0.0901770135344,-0.0380372490069,-0.12049860375,0.225842112062,0.201756888316,0.0147179796858,0.166807279893,-0.00285621251551,0.0139241205824,-0.0357978424434],[-26163.9858509,-193.417432148,-711.965727466,-1359.2291501,749.782488817,733.855281464,529.418729149,-220.51435375,-64.8935794296,-934.83754771,-623.197561763,511.269354233,24.876481778,283.254467516,-336.043726159,-396.619749466,318.508184326,59.1748222236,-116.595362068,-192.36993976,-130.709262909,363.255135952,-87.8682938187,103.256389234,-3.99432386245,98.443936935,-61.9359709103,146.586466956,-104.355898629,61.5857662789,177.614913888,35.7568482982,56.5785066988,39.6314000045,-132.298119355,-36.9504201401,66.2140003868,-34.4191786284,27.4801874324,0.129418832426,47.6684164297,21.8922649522,8.86886704405,27.4707775352,21.5835137828,-32.8833163224,9.4241355564,-19.2147131223,-12.3011683744,3.59473293711,0.829290876384,12.3462636973,-7.21390982254,14.4774160869,11.4833692267,9.4849221096,4.17593457557,11.0004120007,-10.4945323848,-0.58329738885,-11.3990984233,-0.910468564174,-1.94232967245,-2.69743346047,0.534759035501,-3.85876553854,2.09536147758,1.68991233325,4.39760293397,1.81744926527,5.91384426554,3.35797231855,3.95064456403,-2.56304331673,0.321969647083,-1.67337405858,-0.913078785816,0.797462764223,1.97887364847,-1.29158665428,-0.976889425098,-1.04531245622,-0.635823043585,-0.61443034212,-0.773330521121,1.39509380379,0.86365558139,1.3215186887,0.92002336901,1.90793085762,-0.2028792507,0.101212777086,-0.406781798489,-0.485629296539,0.398158239123,0.393199185307,-0.118959544769,0.380096161122,0.000803872551972,0.0205276139807,-0.375131750389,-0.133614063096,-0.126742132981,-0.161058500862,-0.0242757408019,0.0877982736291,0.500945686861,0.417035100785,0.417526456936,0.235847736419,0.084892868243,-0.0368578809725,-0.120781390319,0.227112054958,0.203306464502,0.00807340969503,0.168947566781,-0.00539484796686,0.0141764957504,-0.035879364882],[-26176.2507609,-189.543470243,-705.973355673,-1362.31916278,767.401736689,734.829396148,517.878994929,-232.472139889,-78.1921855104,-940.875630547,-630.012777509,503.134976246,28.9380767078,270.656937721,-330.193101384,-392.099364435,320.947147962,61.9242090023,-117.769542459,-194.237320509,-134.84976026,367.441563028,-89.3463637083,104.12120102,-5.56041157299,98.0220358652,-62.8810240735,148.712844262,-106.505612864,62.6654009385,177.66347096,35.5692355501,55.7569629843,38.7649478512,-133.398847162,-36.921413173,65.3005222903,-33.5523982795,28.565654562,-0.864574279879,48.5862280957,21.5779259508,8.84663061929,27.3532842563,20.8287990259,-33.5770008061,9.66761893589,-19.3085297566,-12.2495877629,3.33620250341,0.649077021877,12.7897972908,-7.70584553388,14.9575526018,11.3004866756,9.7810083143,4.36480138953,10.5913910904,-10.6965692979,-0.723688375646,-11.4792065273,-0.941755241857,-1.98832966111,-2.67013457511,0.514620141195,-3.87001517264,2.0898324852,1.55240691191,4.54415554873,1.73101470283,6.01450320351,3.41027100819,3.82678445864,-2.61190713944,0.259763337253,-1.6937390072,-0.921784737447,0.75986853202,2.00037894524,-1.30091199636,-0.957167863314,-1.03820977136,-0.636431170315,-0.60695513704,-0.784216683264,1.41503090504,0.837718172734,1.34563125174,0.926833048342,1.88285026105,-0.202282350279,0.0782775217652,-0.417504242433,-0.487546768249,0.38738050304,0.398797819608,-0.123204534817,0.388837250836,0.00309627926656,0.0180411579042,-0.369204480647,-0.133822347961,-0.128006018054,-0.161033712284,-0.0179038719276,0.0789137396028,0.508712955915,0.41772775733,0.417925595066,0.237433576615,0.0795374992537,-0.0350062624951,-0.121198473838,0.22790544132,0.204327902597,0.00102151161734,0.171025684696,-0.00807710308961,0.014242452202,-0.0358309484909],[-26191.1369623,-184.601903334,-700.583051815,-1365.32970571,783.928943076,736.342372947,504.473352567,-246.374025993,-91.3115602863,-946.780627537,-637.381278192,494.695551793,32.1343691218,258.189223134,-323.648656432,-387.160742304,323.086151604,64.2959912919,-119.123642953,-195.833126873,-138.990769705,372.276495816,-90.4909313044,105.021831332,-7.12593471793,97.4655920487,-63.9073630222,150.7554604,-108.625197944,63.7543106487,177.723805873,35.3794693808,54.8294830739,37.7365166365,-134.360996595,-36.8667813596,64.3755175119,-32.6529357506,29.6271651019,-1.85673997922,49.455746557,21.2870307289,8.77974849893,27.2467769527,19.9940538904,-34.1928842702,9.94019814188,-19.3572550046,-12.193429151,3.085489915,0.468929656252,13.2189989305,-8.20369713762,15.42586765,11.1145593023,10.0654464021,4.54928169469,10.152651518,-10.8809883782,-0.861985995821,-11.5469756873,-0.973410433423,-2.03280514007,-2.63957282149,0.499161169967,-3.87761164527,2.07994326836,1.41351665415,4.68490477879,1.64274604189,6.10927494465,3.45989966277,3.69783562687,-2.6519877841,0.198763044916,-1.70931880503,-0.931096586744,0.718870918125,2.01866213232,-1.30757698039,-0.93644727158,-1.02952068805,-0.63640589765,-0.599234708322,-0.795588875564,1.43289621398,0.8102738787,1.36850499078,0.932858646414,1.85717035877,-0.200341609026,0.0550557338886,-0.427271588234,-0.490624976602,0.37468952506,0.402998646847,-0.127387255916,0.397235150966,0.00572084158225,0.0153933874379,-0.36257561065,-0.133855118152,-0.128964168565,-0.161074000103,-0.0117850185701,0.0696041008515,0.516315646621,0.41790091962,0.418298185691,0.238990031907,0.0741657844048,-0.0325015870601,-0.121770521797,0.228266563475,0.204804100175,-0.00636358453452,0.172992573249,-0.0108917519536,0.0141046849651,-0.035636083332],[-26206.7335041,-178.749508032,-694.914941326,-1368.56202501,799.668418953,738.573311153,490.55836701,-261.916532784,-104.197432887,-952.651759979,-644.828500451,486.181080783,34.5903716388,246.051034737,-316.725701073,-381.906548234,324.84819793,66.2418946611,-120.543608788,-197.074609711,-143.064225454,377.638553832,-91.310257517,105.98891021,-8.6898754725,96.7476878118,-64.9884553153,152.680723383,-110.719899322,64.8576257494,177.794348345,35.1697384083,53.8411636173,36.5756933362,-135.178764208,-36.7874292258,63.4426702414,-31.725268102,30.6572848847,-2.8514846226,50.2789413452,21.0128622711,8.67044659102,27.1529028234,19.0885632539,-34.7239267873,10.2411517463,-19.3641704829,-12.1347802225,2.84761189768,0.292906082775,13.6305170994,-8.70770259473,15.8841857147,10.9230371772,10.3380912552,4.72965679881,9.68721041463,-11.0431805901,-0.997814011488,-11.6027503443,-1.00448402116,-2.07272146758,-2.60618718653,0.489546286544,-3.88083803139,2.0665127863,1.2740483025,4.81999044634,1.55296402388,6.19851864688,3.50576963374,3.56469993677,-2.68281681003,0.138571221815,-1.72061049699,-0.941009278196,0.675571050048,2.03357940991,-1.31143368936,-0.914986673605,-1.01912708157,-0.635657411257,-0.591109844509,-0.807328813525,1.44898593043,0.781498180896,1.39025529378,0.937962182811,1.83110807874,-0.197076657767,0.0317783441459,-0.436012517424,-0.494831929972,0.360448759659,0.405748016987,-0.13146117579,0.40517907031,0.00873221336572,0.012614594052,-0.355310733893,-0.133697565233,-0.12952904928,-0.161162534639,-0.00593031521523,0.0599944504855,0.523739574207,0.417525935879,0.418659849805,0.24047188275,0.0688225960918,-0.0293788049819,-0.122525687777,0.228262412078,0.204717591773,-0.0139955880757,0.17480393336,-0.0138237031355,0.0137517826973,-0.0352816169902],[-26221.1294353,-172.143060951,-688.089149644,-1372.31736678,814.924475294,741.701310058,477.4906032,-278.796180984,-116.795532442,-958.588249172,-651.879880925,477.821563128,36.4310968778,234.442083511,-309.739545073,-376.439447387,326.156289617,67.7136446789,-121.915385203,-197.879019882,-147.002061715,383.406356592,-91.8126032564,107.053067693,-10.2512160119,95.8414054809,-66.0977685117,154.455041225,-112.79496245,65.9804765807,177.873528094,34.9222312506,52.8371012642,35.3120649261,-135.846346557,-36.6842612978,62.5056646681,-30.7738723937,31.648579743,-3.85321456702,51.0577819915,20.7487035622,8.52095080359,27.0733090676,18.1216119941,-35.1630884297,10.569758321,-19.3325578082,-12.0757286618,2.62758517726,0.125063604709,14.0210002802,-9.21809986619,16.334331279,10.7233703708,10.5987977558,4.90620800962,9.1980849114,-11.1785368984,-1.13079618476,-11.6468749394,-1.03402588736,-2.10504400191,-2.57041665713,0.486939655654,-3.87897740594,2.05035999828,1.13480859944,4.9495523736,1.46198939025,6.28259346813,3.54679227257,3.42827925636,-2.70392577654,0.0787903196928,-1.72811112803,-0.951517756294,0.631070055304,2.0449869782,-1.31233420621,-0.893045093099,-1.0069108272,-0.6340958968,-0.582421334141,-0.819318212653,1.46359625421,0.751566560932,1.41099754871,0.942005677118,1.80488034892,-0.192507127329,0.00867628322656,-0.443655711535,-0.500135636732,0.345021661313,0.406992279993,-0.135379762161,0.412558217668,0.0121850484837,0.00973506921675,-0.347475443869,-0.13333488077,-0.129613124964,-0.161282486213,-0.00035089634859,0.0502098816149,0.530970553902,0.416574154332,0.4190262084,0.241833909597,0.0635528067101,-0.025672866575,-0.123492125357,0.227959977787,0.204050911927,-0.0217882083213,0.17641546595,-0.016857865212,0.0131723340565,-0.0347543970507],[-26232.4138049,-164.939338704,-679.225802206,-1376.89697713,830.001423073,745.905468955,466.626626083,-296.709491314,-129.051588081,-964.689316414,-658.060856251,469.846998736,37.7815574577,223.562080438,-303.005498201,-370.862104925,326.933429344,68.6629669142,-123.124917438,-198.163608244,-150.736212699,389.458523611,-92.0062294328,108.244933822,-11.8089385115,94.7198273824,-67.2087701702,156.04482194,-114.855632781,67.1279934824,177.959774836,34.6191365259,51.862392664,33.9752183823,-136.357940198,-36.5581821014,61.5681849819,-29.8032256862,32.5936155095,-4.86633616946,51.7942380275,20.4878375867,8.33348704468,27.0096428843,17.1024849886,-35.5033292701,10.925296438,-19.265698597,-12.0183621527,2.43042647951,-0.0305404746819,14.3870969559,-9.73512691296,16.7781288259,10.5130089536,10.8474207859,5.07921663486,8.68829213932,-11.2824482676,-1.26055627775,-11.6796939138,-1.06108591432,-2.12673810133,-2.53270022022,0.492505442021,-3.87131284387,2.03230386354,0.99660428749,5.07373038276,1.37014288245,6.36185856631,3.58187893073,3.28947545369,-2.71484624295,0.0190227902923,-1.73231774306,-0.962616965526,0.586469061404,2.05274103739,-1.31013061392,-0.87088155377,-0.992753800221,-0.631631539948,-0.57300996576,-0.831438788452,1.47702338515,0.720654500417,1.43084714355,0.944851148919,1.77870409723,-0.186652648539,-0.0140195181795,-0.450129852099,-0.506504105256,0.328771684498,0.406677785829,-0.139096482753,0.419261801836,0.0161340008027,0.00678510440216,-0.339135334074,-0.13275225633,-0.129128860382,-0.161417025146,0.00494210354407,0.0403754873496,0.537994400935,0.415016923204,0.419412882469,0.243030892905,0.0584012886552,-0.0214187221537,-0.124697988119,0.227426251259,0.202786595175,-0.0296551545866,0.177782871938,-0.0199791467598,0.0123549277006,-0.0340412710983],[-26239.1163818,-157.326443728,-667.795909871,-1382.50899287,845.16426837,751.290983214,458.975633142,-315.349365273,-140.919675859,-971.054538784,-663.00752153,462.424213368,38.7640120823,213.565143228,-296.805364829,-365.269401934,327.127361792,69.0489229384,-124.083173005,-197.863790163,-154.211588255,395.669023804,-91.9112089409,109.587221106,-13.3568019521,93.3683218819,-68.295181365,157.423061107,-116.902541094,68.3009208945,178.050474249,34.2408679377,50.9529711305,32.5898326042,-136.712009252,-36.4097154954,60.6345821402,-28.8161380937,33.4861909496,-5.89366097869,52.4896434182,20.2230665057,8.11063724239,26.9607887801,16.0405812794,-35.7395924126,11.3067957165,-19.1683125038,-11.9644699071,2.26034600903,-0.169817845928,14.7263823555,-10.258609257,17.2169331433,10.2899364472,11.0839933194,5.24808094683,8.16144995953,-11.3510800694,-1.38651011457,-11.7018288796,-1.08487956627,-2.13534182222,-2.49351509935,0.507114178446,-3.85726145979,2.01323921226,0.860182487142,5.19274512546,1.27783017478,6.43675698628,3.60999210502,3.14925340027,-2.71523158724,-0.0409907780547,-1.73376925808,-0.974242936795,0.542713043275,2.05674271434,-1.30481645191,-0.848737773311,-0.976615745691,-0.628209469111,-0.56271976798,-0.843555267986,1.48955711341,0.688987492945,1.44993264449,0.946359802574,1.75280286828,-0.179552153269,-0.0360667353735,-0.455392483978,-0.513863379145,0.312022668044,0.404773567954,-0.142565478144,0.425215422054,0.0205937500371,0.00379746929945,-0.330375525699,-0.131949242779,-0.128005862421,-0.161544837689,0.00994104216822,0.0306165691679,0.544803727762,0.412840753864,0.419837266826,0.244022299767,0.0534179256273,-0.0166646756639,-0.126153980249,0.22671226288,0.20091456833,-0.0375019112589,0.178868612556,-0.0231759001611,0.0112991149752,-0.0331347838668],[-26241.5298148,-149.617781765,-654.674025188,-1388.98911359,860.520797681,757.667432511,454.157352016,-334.394227463,-152.387259536,-977.784916484,-666.798605709,455.467336183,39.4897037955,204.423016497,-291.286927747,-359.725083201,326.784799665,68.8599183338,-124.801208512,-196.987639029,-157.425000793,401.893223678,-91.5948626137,111.070971929,-14.8676725379,91.8214015021,-69.3317372301,158.589104571,-118.917859472,69.4824596568,178.138835858,33.7607395324,50.1081166323,31.1609541863,-136.924088103,-36.2378626696,59.7118741732,-27.8087519471,34.3250365599,-6.93162131049,53.1427898645,19.9452691848,7.85640740509,26.9145804913,14.945756565,-35.8747530875,11.7122899648,-19.0508713354,-11.9146472482,2.1183278855,-0.28855617474,15.0401386933,-10.786722664,17.6502202373,10.0542701777,11.3092606959,5.40866707611,7.6235791534,-11.3836953047,-1.50724176734,-11.7150101319,-1.10528463528,-2.13068401354,-2.45349146471,0.530461870014,-3.83677652688,1.99436435821,0.72605183091,5.30714057111,1.18579667302,6.50806732062,3.63029887354,3.00882998155,-2.70522246194,-0.100957250661,-1.73317207327,-0.986096046647,0.500122365505,2.05707284266,-1.29695108542,-0.82678624535,-0.958767887793,-0.623914583674,-0.551407729706,-0.855464424557,1.5014615906,0.656991080054,1.46843533072,0.946389581543,1.7274266732,-0.17132177757,-0.0571774676206,-0.459516605351,-0.521971642894,0.294939988194,0.401339393802,-0.145743580332,0.430490239322,0.0254190792909,0.000814846483763,-0.321359250735,-0.130982828191,-0.126242306456,-0.161626673818,0.0146522459941,0.0210592620191,0.551418335754,0.410092810253,0.42032385157,0.244786343842,0.0486726465453,-0.0115124455776,-0.127801008369,0.225805201949,0.19845432731,-0.0452010630156,0.179662190274,-0.0264502530213,0.0100482979773,-0.0320502686849],[-26240.3874725,-142.158084381,-641.085586129,-1396.0799296,876.139492612,764.7704926,451.444142881,-353.518883265,-163.450149796,-984.981805494,-669.623496196,448.827322189,40.0671217261,196.061851591,-286.56446435,-354.28510944,325.977197667,68.0916946854,-125.31510284,-195.561392742,-160.386238365,407.981839139,-91.1363232689,112.679311146,-16.3091932787,90.1258648049,-70.293426415,159.548885741,-120.879145327,70.6514247091,178.217025144,33.150290442,49.3179458023,29.6887216468,-137.0139787,-36.0412441462,58.807745879,-26.7755426317,35.1101157698,-7.97505467242,53.751833501,19.6448436659,7.57515956124,26.8560890617,13.827980708,-35.9136695568,12.1395640386,-18.9252849362,-11.8691910267,2.0045497074,-0.382512120625,15.3305749295,-11.3172304606,18.0769964189,9.80666092244,11.5241463464,5.55595811783,7.08130123236,-11.3803313816,-1.6211273702,-11.721245137,-1.12234449537,-2.11316622238,-2.41329772315,0.561950889885,-3.809945358,1.97695348609,0.594661329306,5.41754151857,1.09487271579,6.57665204882,3.64201745973,2.8694850865,-2.68508133823,-0.160445356249,-1.73127445988,-0.997817758039,0.458861240096,2.05385718259,-1.28723533614,-0.805182157495,-0.939559320488,-0.618866725767,-0.538934079917,-0.866946043025,1.51299455864,0.625140815265,1.48654965964,0.944797614058,1.70283213978,-0.16209695854,-0.0770524201766,-0.462604077724,-0.530545116228,0.277649405545,0.3964577143,-0.148588294168,0.43519380508,0.0304247975158,-0.00211760324876,-0.312269268869,-0.129924359942,-0.123853509984,-0.161618799441,0.0190855336832,0.0118299092209,0.55786482351,0.406835419455,0.420898900618,0.24530592543,0.0442403916327,-0.00607710399819,-0.129562529706,0.224676297493,0.19543276031,-0.052616969606,0.180159867878,-0.0298077767513,0.00865684149164,-0.0308087560302],[-26236.4227235,-135.292083141,-628.256030665,-1403.52403119,892.088834763,772.335839232,450.108365915,-372.398138059,-174.104157326,-992.746561794,-671.671580399,442.355126395,40.6047550029,188.407799856,-282.752252031,-349.005441361,324.776010505,66.739993578,-125.66093487,-193.611289199,-163.105089021,413.785586091,-90.6147237241,114.395363612,-17.6490071845,88.3285103522,-71.1552375688,160.308338029,-122.763956067,71.7866309911,178.277207592,32.3810597983,48.5725752731,28.1732735037,-137.001482993,-35.8184804478,57.9298820556,-25.7109855325,35.8413920089,-9.01879857201,54.3149304623,19.312187991,7.27125573928,26.770385535,12.6972235712,-35.8612000827,12.5864027933,-18.8034631509,-11.8283980934,1.91918907321,-0.447442343088,15.5999000247,-11.8478959735,18.4962679988,9.54775945863,11.7295737022,5.68493716711,6.54123770785,-11.341025708,-1.72654305725,-11.7225413609,-1.13610252055,-2.08318999581,-2.3736022815,0.600983611217,-3.77685526601,1.96228078061,0.466459992841,5.52457276668,1.00588864172,6.64337365039,3.64436608703,2.73249860406,-2.6550706873,-0.219023823544,-1.72882468916,-1.00904953393,0.419093879049,2.0472214944,-1.27637002577,-0.784080697358,-0.919339137737,-0.613185737522,-0.525159047588,-0.877779908253,1.5244137595,0.593912252101,1.50447008866,0.941441028355,1.67927589581,-0.152013133275,-0.0953922982976,-0.464756762604,-0.539300018867,0.260276680694,0.390210980376,-0.151057124506,0.439433670769,0.0354257136633,-0.00495471910199,-0.303288339788,-0.128845185408,-0.120854790501,-0.161477480465,0.023250723897,0.00305485409053,0.564169789629,0.403130908557,0.42158867789,0.24556394483,0.0401961011133,-0.000473723029079,-0.13136200149,0.223296778538,0.191876755523,-0.0596139907799,0.180357908149,-0.0332540427622,0.00717911030317,-0.0294312763803],[-26230.3689365,-129.364509613,-617.410796766,-1411.06400865,908.43730574,780.099148162,449.422381295,-390.706797223,-184.345092809,-1001.18054137,-673.132245727,435.901703808,41.2110927546,181.387012637,-279.964568184,-343.942039678,323.252692886,64.8005565966,-125.874783483,-191.163566299,-165.591340813,419.155180441,-90.1091967969,116.20225418,-18.8547572651,86.4761367061,-71.8921593411,160.873394845,-124.549849104,72.8668934428,178.311548687,31.4245867335,47.8621216773,26.6147482752,-136.906402931,-35.5681920967,57.0859675012,-24.6095560346,36.5188287064,-10.0576905168,54.8302368829,18.9377002019,6.94905796766,26.6425409549,11.5634550172,-35.7222029271,13.0505910847,-18.6973158239,-11.7925652992,1.86242358139,-0.479103501637,15.8503229392,-12.3764825295,18.907041288,9.27821656358,11.9264661942,5.79058731909,6.01001009131,-11.2658156919,-1.82186496264,-11.7209062699,-1.14660208485,-2.04115688093,-2.3350735466,0.64696240717,-3.73759356374,1.95162042645,0.341896832028,5.6288591143,0.919674789447,6.70909460484,3.63656297887,2.59915042319,-2.61545298034,-0.276261381269,-1.72657103234,-1.01943283728,0.380984494369,2.03729153835,-1.26505597601,-0.763637052547,-0.8984564335,-0.606991461068,-0.5099428617,-0.887745805101,1.5359769351,0.563780944084,1.52239107519,0.936176952667,1.65701456906,-0.141205738873,-0.11189780724,-0.4660765215,-0.547952570535,0.242947574239,0.382681642958,-0.153107576199,0.443317387828,0.0402366366851,-0.00765134027975,-0.294599223179,-0.127816651963,-0.117261465504,-0.161158982798,0.0271576352969,-0.00513956005445,0.570359832711,0.399041604644,0.422419447303,0.245543302339,0.0366147152105,0.00518262522631,-0.133122880949,0.221637874113,0.187813201145,-0.0660564862867,0.18025257387,-0.0367946224649,0.00566946919668,-0.0279388602126],[-26222.9683442,-124.586022898,-609.445993187,-1418.41393623,925.215002662,787.84040936,448.753058538,-408.140844048,-194.229859368,-1010.29189753,-674.182800104,429.329519174,42.0131187553,174.976505947,-278.28804706,-339.126988724,321.474455913,62.2997617734,-125.991980112,-188.251694792,-167.849320045,423.959825933,-89.6890648339,118.087198168,-19.8968236423,84.615885897,-72.4864291333,161.253755652,-126.222107782,73.8773301234,178.31118337,30.2602878173,47.182572559,25.0153712311,-136.750027151,-35.2880562569,56.2832881002,-23.4663482445,37.143423612,-11.0890516977,55.2971132586,18.5149150256,6.61268030036,26.4614953574,10.4358250729,-35.5027578378,13.5298818586,-18.6161751245,-11.7615807159,1.83431045796,-0.474195873381,16.084436815,-12.9005620321,19.3081076098,8.99920365504,12.1158386152,5.86891385303,5.49354563002,-11.1554370771,-1.90538664283,-11.7181059173,-1.15380525719,-1.98768578095,-2.29841204539,0.699291438512,-3.69219604329,1.94617935378,0.221390887548,5.7309296188,0.837119327936,6.77466376656,3.6181331515,2.47072890562,-2.56655390351,-0.331580772243,-1.72513903326,-1.02866511443,0.344659032372,2.02421711062,-1.25389053053,-0.744014594049,-0.877230318392,-0.600374364476,-0.493132525702,-0.896612439887,1.54786066487,0.53521708131,1.54053091052,0.928923721833,1.63630210094,-0.129792267976,-0.126257901606,-0.466679283073,-0.556267915034,0.225779456304,0.373948325599,-0.154718433975,0.44694203289,0.0447010142832,-0.0101826467711,-0.286366122315,-0.126900275901,-0.113089572763,-0.160620655553,0.0308207807322,-0.0126298823582,0.576462824234,0.394639965505,0.423420253304,0.245231169933,0.0335797190249,0.010788775398,-0.134781764869,0.219681691069,0.183276179676,-0.0718301314176,0.179852407906,-0.0404242114247,0.00417408116968,-0.0263515082513],[-26214.9986361,-120.630992249,-603.940411807,-1425.1738239,942.298484728,795.516869673,447.845304523,-424.48097346,-204.059729869,-1019.71597298,-674.952233512,422.547076179,43.2117953596,169.356754469,-277.698750334,-334.496867319,319.49153628,59.3865329302,-126.044866403,-184.938076848,-169.861506038,428.142677674,-89.3844082969,120.053772748,-20.7565348859,82.7962738301,-72.9492793569,161.474184127,-127.796919184,74.828271571,178.263124422,28.8990893719,46.5533991069,23.3857146477,-136.559591035,-34.9719766587,55.5275340819,-22.2789311541,37.7203117552,-12.1201380386,55.7197375284,18.0499139282,6.26524489361,26.2316647468,9.32020442203,-35.2138305052,14.021900422,-18.5590625201,-11.7336972993,1.83442543903,-0.433194205844,16.3063715203,-13.4169406939,19.697398338,8.71397471271,12.2990712033,5.92001078471,4.99499451461,-11.0134189494,-1.97507134364,-11.7149407059,-1.15734888614,-1.92426502371,-2.26444678515,0.757382016456,-3.64049241362,1.94689547461,0.105241320762,5.8309303716,0.759341747492,6.84087548961,3.58982879237,2.34855630433,-2.50895200299,-0.383820795668,-1.72466332611,-1.03666774525,0.310090376641,2.00824415103,-1.24305712088,-0.725409426352,-0.855859969632,-0.593307419591,-0.474522140942,-0.904104204757,1.55991687809,0.508669400171,1.55920322153,0.919844497107,1.61738168738,-0.117818435413,-0.138114533387,-0.466737244613,-0.564206892488,0.208856135118,0.364074342352,-0.155953602069,0.450362783355,0.0487768491608,-0.0126051817056,-0.278679014807,-0.126118249191,-0.108358031134,-0.159824180677,0.0342734498038,-0.0193042318113,0.582511727197,0.390038971742,0.424631262439,0.244631806278,0.0312087771634,0.0162891890496,-0.136327808276,0.217453847556,0.17832855085,-0.0769058636305,0.179215073447,-0.0440940018242,0.00270630207046,-0.0246851022073],[-26207.2463654,-117.039714454,-600.143515288,-1430.91516557,959.525926654,803.130090164,446.538535466,-439.529058295,-214.197069613,-1028.99490773,-675.55745645,415.474388245,45.0265795671,164.759097555,-278.145096535,-329.964377905,317.349927078,56.2404303361,-126.065036552,-181.292347486,-171.604916367,431.665378612,-89.2154971769,122.109645553,-21.4179566776,81.0661598792,-73.2991911756,161.56321,-129.298196329,75.7363514432,178.153354081,27.3597951571,45.9999434207,21.7384375528,-136.363816649,-34.6129136739,54.8239967619,-21.0454924764,38.2556624857,-13.1606891469,56.1034919926,17.5519150609,5.90962592916,25.9613341199,8.22164391236,-34.8676081056,14.5242401722,-18.5224218028,-11.7067592261,1.86222388824,-0.357516864157,16.5206411048,-13.9222333043,20.0726298589,8.42630435679,12.4776355582,5.94499431406,4.51681267155,-10.8439887306,-2.02879973326,-11.711969626,-1.15678851517,-1.85260029316,-2.23403889323,0.820647239824,-3.58226086295,1.95463944641,-0.00628267679621,5.92891172267,0.687519368759,6.90851050294,3.55270888173,2.23396334509,-2.44328903996,-0.43167426484,-1.72515581763,-1.04341809301,0.277213145077,1.98964263533,-1.2326357006,-0.708025837318,-0.834514581095,-0.585734224196,-0.45389258324,-0.909934413314,1.57191634153,0.484581273634,1.57874546897,0.909163646351,1.60049383792,-0.105312011559,-0.147097903924,-0.466436670562,-0.571779267101,0.192253028437,0.353119179898,-0.156898264592,0.453624341818,0.0524507827719,-0.0149958289983,-0.27160932185,-0.125482932717,-0.103086479744,-0.158732323321,0.0375536263005,-0.0250536198659,0.58854077748,0.385361734662,0.426095421783,0.24375374172,0.02962809911,0.0216402344782,-0.137763305749,0.214990839547,0.173040368706,-0.0812759359247,0.178410513764,-0.0477443100003,0.00127128595999,-0.022954494038],[-26200.4980857,-113.3524863,-597.30476629,-1435.20945517,976.735503155,810.681631897,444.672167586,-453.08697139,-225.004243902,-1037.67084183,-676.115379415,408.031468797,47.6769283775,161.414874556,-279.575504193,-325.442222924,315.095621398,53.0410142602,-126.084084757,-177.384141729,-173.056568604,434.489571694,-89.2026014647,124.262484218,-21.8651546993,79.4744034181,-73.5546457531,161.549363001,-130.749852235,76.6182033976,177.967854585,25.661208933,45.5475476006,20.0861989746,-136.191426063,-34.2038276742,54.1779674558,-19.7642199248,38.7556451533,-14.2204446298,56.4537589514,17.0301365748,5.54869758876,25.6587884733,7.1451943918,-34.4762778153,15.0344945066,-18.5026967646,-11.6786106729,1.91716116926,-0.248582213448,16.7317596184,-14.4130546528,20.4315185585,8.13996720745,12.6530032796,5.94498064097,4.06145602732,-10.6513738422,-2.06445247985,-11.7097516677,-1.15167968776,-1.77439727327,-2.20804949703,0.888500207442,-3.51727957948,1.97028192667,-0.112911913597,6.02492402195,0.622829512379,6.97834953549,3.50783239985,2.12828075365,-2.37020677559,-0.473833993057,-1.72662841459,-1.04889352096,0.245961955578,1.96868253926,-1.2227062232,-0.692068114811,-0.813363346653,-0.577598376076,-0.431024728416,-0.913816379161,1.58362982194,0.463396074663,1.59949511357,0.897105537424,1.58587906213,-0.0923007667885,-0.152838214555,-0.465963825366,-0.578994803077,0.176045554018,0.341142324916,-0.157637605656,0.45677141087,0.05570945657,-0.0174314725637,-0.265228464639,-0.125006687366,-0.097294557723,-0.157307848639,0.0406992940108,-0.0297690579742,0.594584210961,0.380731365572,0.427855678411,0.2426055066,0.0289638943485,0.026798279981,-0.139090551871,0.212329163016,0.167481687283,-0.0849326012999,0.177508672129,-0.0513154522898,-0.000125813100765,-0.0211745357008],[-26195.5403504,-109.109604577,-594.673627476,-1437.62818661,993.765388947,818.173055937,442.085617101,-464.956585581,-236.843618039,-1045.28591529,-676.742912907,400.138331256,51.3822987907,159.555424823,-281.938391838,-320.843104816,312.774612331,49.9678449717,-126.133605213,-173.283094596,-174.193480324,436.576899867,-89.3659911511,126.519956378,-22.0821946328,78.0698638204,-73.7341242531,161.461172861,-132.175799919,77.4904610918,177.692608173,23.8221344595,45.2215537463,18.4416579409,-136.071141343,-33.7376790313,53.594737479,-18.4333012125,39.2264291076,-15.3091440947,56.775920705,16.4937966212,5.18533405418,25.3323128035,6.09590670819,-34.0520268105,15.5502568222,-18.4963311975,-11.6470958165,1.99869264573,-0.107808618846,16.9442411108,-14.8860195289,20.7717808232,7.85873788489,12.8266459671,5.92108596538,3.6313805084,-10.4398017058,-2.07991025158,-11.7088458212,-1.1415779474,-1.69136164799,-2.18733972389,0.96035401813,-3.44532675141,1.99469357286,-0.214377198108,6.11901761939,0.566449498995,7.05117331622,3.45625832699,2.0328392558,-2.29034697104,-0.508992793615,-1.72909302376,-1.05307139236,0.216271426043,1.94563383855,-1.21334864223,-0.677740546695,-0.79257546018,-0.568843473016,-0.405699452291,-0.915463415902,1.59482808609,0.445557176225,1.62178961611,0.883894538187,1.57377786954,-0.078812471477,-0.154965666618,-0.465504973467,-0.585863264619,0.160309129618,0.328203264085,-0.15825680937,0.459848693103,0.0585395120091,-0.0199889963169,-0.25960786437,-0.124701874022,-0.0910019041979,-0.155513521782,0.0437484367237,-0.0333415575884,0.60067626352,0.376270975779,0.429954979395,0.241195631262,0.0293423723628,0.0317196938549,-0.140311841225,0.209505313936,0.161722560621,-0.0878681127553,0.176579491812,-0.0547477450296,-0.00147984105083,-0.0193600791531],[-26193.0038686,-103.964511235,-591.621760382,-1437.92723131,1010.36987221,825.536821758,438.782382898,-475.087262158,-249.988335178,-1051.50038468,-677.531889486,391.743318344,56.2881400823,159.321148321,-285.171223442,-316.105778702,310.423131756,47.1573740019,-126.238420118,-169.068582151,-174.990394338,437.903392878,-89.7191856884,128.88834454,-22.0570919228,76.8941282482,-73.8529046133,161.321253445,-133.599476868,78.3713352228,177.314369777,21.8615170525,45.0406036107,16.8179229336,-136.027197885,-33.2082460321,53.0789837476,-17.0521219323,39.6737753787,-16.4340082626,57.0756335142,15.9494999577,4.82206550912,24.9886266574,5.07927186481,-33.6064964274,16.0693908088,-18.5002595558,-11.6104321901,2.10615309736,0.0635337835652,17.1619675689,-15.3383567735,21.0915883347,7.58533071031,12.9999982609,5.87441645723,3.22908915466,-10.213097009,-2.07346851204,-11.7094610743,-1.1263652974,-1.60499225069,-2.17258212737,1.03562197733,-3.36627781284,2.02859820052,-0.310352946636,6.21110170744,0.519303808497,7.12760056532,3.3989662328,1.94877756773,-2.20436984824,-0.535954436248,-1.73246258945,-1.05599209576,0.188108743474,1.92078384167,-1.20461935363,-0.665227986752,-0.772332061922,-0.559416508906,-0.377764470476,-0.914602516534,1.60530168593,0.431420593828,1.64588055199,0.86975300211,1.56439987932,-0.0648692100334,-0.153151186154,-0.465205080866,-0.592372042653,0.145121694736,0.314399388922,-0.158801676559,0.462905140518,0.0609255228486,-0.0227403823209,-0.254817092138,-0.124577720099,-0.0842310751557,-0.153313465729,0.0467304444615,-0.0356827751496,0.606846005847,0.372088731287,0.432439579169,0.239540871248,0.0308736034106,0.0363713398223,-0.141419874516,0.20656683427,0.155831106211,-0.0900726831268,0.175683852198,-0.0579916901608,-0.00279407023817,-0.0175240643908],[-26192.8959729,-98.0232288717,-588.009622044,-1436.59997071,1025.96769498,832.428982473,435.422294544,-484.018316225,-264.354649885,-1056.4469727,-678.47382997,382.908089977,62.2438706319,160.488687469,-289.167644738,-311.273210404,308.038366706,44.5736179315,-126.396263665,-164.858944619,-175.412954401,438.502627679,-90.2487023733,131.368390702,-21.7936610673,75.9596950155,-73.9134518675,161.128555159,-135.042418439,79.2853446446,176.82298511,19.7988682522,44.9965375575,15.2299002499,-136.065884397,-32.6125786227,52.6329255787,-15.624859196,40.1018117179,-17.5921823092,57.3596494821,15.3933977695,4.46004614508,24.6281877821,4.10254148662,-33.1491446416,16.5908413249,-18.5133789422,-11.5683307518,2.23839496814,0.264767773876,17.3862927276,-15.7697514343,21.390933957,7.31821880896,13.1743469622,5.80603816667,2.85727345962,-9.97347350261,-2.04508190641,-11.7104064061,-1.10722958056,-1.51596051235,-2.16369496575,1.11371821697,-3.28039718134,2.07213225739,-0.400288006839,6.30052084848,0.481305557763,7.20760196797,3.33661804457,1.87646636742,-2.11300947211,-0.553966516434,-1.73625420616,-1.05794812086,0.161571371283,1.894489188,-1.19648052305,-0.654637552448,-0.752862077619,-0.549278062053,-0.347334857748,-0.911015391632,1.61492031421,0.420992913149,1.67167595531,0.854895225107,1.5578311491,-0.0504703230043,-0.147228598007,-0.465043919785,-0.598419034997,0.130571275844,0.299979710291,-0.1591604749,0.466006702732,0.0628437920714,-0.0257380052329,-0.250918318632,-0.124630919125,-0.0770162940157,-0.150677234759,0.0496403321817,-0.036786947055,0.61310184787,0.368233016892,0.435368961591,0.237690882905,0.033603100845,0.0407620633063,-0.142368976955,0.203605449928,0.149867695342,-0.0915283645947,0.174846377115,-0.0610385320415,-0.00410547864655,-0.015671783563],[-26195.0681516,-91.5049252467,-583.819868375,-1434.32416373,1039.89371277,838.436489607,432.829264279,-492.436551341,-279.769594577,-1060.37651858,-679.535177238,373.722635369,69.0249010952,162.743745302,-293.810346899,-306.414418426,305.607743002,42.1374846034,-126.598098047,-160.782263265,-175.424529505,438.422568023,-90.9343079641,133.959451736,-21.2996663272,75.2717902245,-73.9150278235,160.876112548,-136.525684459,80.2585852507,176.209072576,17.6538411544,45.0744956032,13.6929456411,-136.189002911,-31.9485446641,52.2581678898,-14.1568879952,40.514257557,-18.7782925242,57.6349946725,14.8190278481,4.10008615552,24.249888475,3.17340735401,-32.688883589,17.1138235211,-18.5350771213,-11.5208758166,2.39415011813,0.495364361221,17.617938259,-16.1805026102,21.6702658492,7.05481500711,13.3509419129,5.71700711389,2.51867203018,-9.72274220374,-1.99511987529,-11.7101407932,-1.08568509951,-1.42473101336,-2.16040792349,1.1940570756,-3.18804652038,2.1252853493,-0.483574834215,6.38647844738,0.452115022919,7.29098620059,3.26979627899,1.81608432329,-2.01701836836,-0.562387586088,-1.73988600594,-1.05929498264,0.136789341985,1.86712384963,-1.18887075855,-0.646056927167,-0.734406379384,-0.538392106871,-0.314592528675,-0.904497431165,1.62357344886,0.414193362409,1.69899797481,0.839533488703,1.55412684612,-0.0356094649709,-0.137072451722,-0.464959964,-0.603879766186,0.116748421159,0.285231143894,-0.159182088782,0.469223578772,0.0642685549663,-0.0290293378583,-0.247971864443,-0.124855031154,-0.0693947010554,-0.147575740979,0.0524645210754,-0.0366689546908,0.619447034331,0.364737272087,0.438805917877,0.235703547776,0.0375602387929,0.0449112051551,-0.143103879875,0.200723932807,0.143890762756,-0.0922151691757,0.174082626507,-0.0638897006339,-0.00545947066866,-0.0138066168571],[-26199.3718928,-84.6287681201,-579.035155285,-1431.77756931,1051.48278107,843.146294683,431.82720434,-501.028771065,-296.060201673,-1063.53986156,-680.68237417,364.276943734,76.4066421279,165.772024851,-298.982021099,-301.598421269,303.118686462,39.7698818607,-126.834885458,-156.966619356,-174.988488642,437.711177661,-91.7557692188,136.660884514,-20.5828719634,74.8356399776,-73.8568942889,160.556960153,-138.070334754,81.3171529345,175.463250582,15.4460888551,45.2596177645,12.2224148582,-136.398355463,-31.2140120177,51.9563155984,-12.6535833212,40.9148323279,-19.9869651971,57.9086951491,14.2199279851,3.74299573387,23.8526210335,2.29956124736,-32.2346254052,17.6375525484,-18.564741858,-11.4681516992,2.57215040739,0.754794554735,17.8576258352,-16.5709094002,21.9300321708,6.79253213104,13.5310329546,5.60837931909,2.21602347328,-9.46271412925,-1.92395185929,-11.7071232123,-1.06324615687,-1.33176833411,-2.16245068504,1.27605289175,-3.08958749341,2.18804708206,-0.559605884261,6.46817790901,0.43139248009,7.37756193958,3.19908345274,1.76781010377,-1.91714906264,-0.560576197125,-1.74277612083,-1.06038819611,0.113892688096,1.83906179867,-1.18172866818,-0.639573794294,-0.717205839331,-0.526722617771,-0.279719397827,-0.894844025103,1.63115056784,0.410941169828,1.72766875925,0.823880074424,1.55334213763,-0.020280290514,-0.122557296845,-0.464891687288,-0.608629760761,0.103743678896,0.270440605432,-0.158715402593,0.472625967663,0.0651740468219,-0.0326618530024,-0.246038050161,-0.125243616242,-0.0614034365526,-0.143979896493,0.0551894323337,-0.0353436794431,0.62588480997,0.361634936364,0.442813239245,0.233636747407,0.0427743913814,0.048838106217,-0.14356931461,0.198025054805,0.137958743194,-0.0921131088863,0.173408160313,-0.0665466259002,-0.00690145069718,-0.0119319444606],[-26205.6586848,-77.6139252519,-573.638138686,-1429.63794638,1060.06975539,846.145349226,433.240026963,-510.481778956,-313.053503591,-1066.18784087,-681.881863647,354.661004287,84.1645043856,169.25922915,-304.565358513,-296.894237434,300.558622909,37.3917175463,-127.09758809,-153.540094159,-174.068200804,436.416420346,-92.6928528957,139.472045907,-19.6510422369,74.6564703768,-73.7383130716,160.164132518,-139.697429149,82.4871435894,174.576137533,13.1952644504,45.5370440578,10.8336636526,-136.695744086,-30.4068485444,51.728973622,-11.1203201657,41.3072554621,-21.2128266175,58.1877769757,13.5896359724,3.38958507358,23.4352777548,1.48869494703,-31.7952822258,18.1612435575,-18.6017609171,-11.4102427142,2.77112769596,1.04252936356,18.1060771283,-16.9412709035,22.1706810812,6.528783007,13.7158699292,5.48121080245,1.95206639582,-9.19520029608,-1.83194729899,-11.6998126403,-1.04142705528,-1.23753705498,-2.16955293485,1.35912000397,-2.98538176391,2.26040706147,-0.627773612472,6.54482263826,0.418798205403,7.46713786137,3.12506208252,1.73182237728,-1.81415408067,-0.54789090146,-1.74434268288,-1.06158327624,0.09301144213,1.8106770072,-1.17499286003,-0.635275837214,-0.701501329573,-0.514233569167,-0.24289737977,-0.881850563415,1.63754114907,0.411155563625,1.75751045739,0.808147263792,1.55553219087,-0.00447645421466,-0.103557682921,-0.464777563428,-0.612544543258,0.0916475972706,0.255895010606,-0.157609300724,0.476284068429,0.0655345029269,-0.0366830234706,-0.245177196375,-0.125790234443,-0.0530796407848,-0.139860613407,0.0578014871477,-0.0328260026981,0.632418419527,0.358959449218,0.44745371691,0.231548363343,0.0492749327374,0.0525621073403,-0.143710012494,0.19561158782,0.132130071396,-0.0912021957433,0.172838538477,-0.0690107378027,-0.00847682312482,-0.0100511465611],[-26213.8834592,-70.706483233,-567.750317666,-1428.44626141,1065.24447765,847.1747978,437.527564709,-521.257457309,-330.590257582,-1068.55955636,-683.086693061,344.962455413,92.0879389434,172.929389809,-310.429248353,-292.349672576,297.922098514,34.9498261892,-127.382933515,-150.59804199,-172.648769155,434.586107582,-93.7171951136,142.398645245,-18.5125366282,74.7373974394,-73.5575890045,159.698928588,-141.421830867,83.7887240982,173.542793257,10.9206419829,45.8913566307,9.54160509329,-137.079006448,-29.5255725644,51.5774943638,-9.5617257586,41.6970109507,-22.4489166414,58.4775465291,12.9218772711,3.04150966782,22.9974188359,0.747718593014,-31.3766674875,18.6835573032,-18.6453399011,-11.347345042,2.9899633055,1.35740513482,18.3646099215,-17.2914289979,22.3927353614,6.26156470077,13.9062121837,5.33694270955,1.72911321333,-8.92204062058,-1.71977175637,-11.6870678374,-1.02165335665,-1.14234903893,-2.18147851635,1.44263998395,-2.87589101947,2.34231962163,-0.687493937433,6.61576534977,0.413973711643,7.55952044481,3.04842927811,1.7082218845,-1.70873124031,-0.52385394755,-1.74416330965,-1.06311011729,0.0742526644108,1.78237624679,-1.16851910852,-0.633245006848,-0.68752606724,-0.500952956385,-0.204293371172,-0.865349297871,1.64267261831,0.414763544525,1.78833355033,0.792577061057,1.56074557329,0.0117885873317,-0.0799717034241,-0.464554771342,-0.615519527463,0.0805373922771,0.241867438198,-0.15571043932,0.480227897206,0.0653465642293,-0.041143082206,-0.245443193594,-0.126497414925,-0.044471035054,-0.135204245674,0.0602992813399,-0.0291377895722,0.639048660424,0.356752585101,0.452777162365,0.229499037441,0.0570769714072,0.0561043368008,-0.143469845526,0.193571185151,0.126469575379,-0.0894644030618,0.172379122107,-0.0712856063037,-0.0102249633846,-0.00816876267477],[-26224.4149197,-64.2602039774,-562.048564028,-1428.19631091,1067.61673543,846.59255714,443.693331417,-532.918003374,-348.566120229,-1070.84715044,-684.196327856,335.259532187,100.022558554,176.659852739,-316.387371995,-287.927680955,295.232140864,32.4947490624,-127.710710816,-148.104909369,-170.802233552,432.267441883,-94.7679094339,145.471801693,-17.1780954963,75.0730968428,-73.3091990212,159.195704923,-143.233616717,85.2183453007,172.376043266,8.63997928236,46.3049061537,8.35938152108,-137.530122744,-28.5713042333,51.5022201699,-7.97943628402,42.0966410209,-23.6819293915,58.7764314378,12.2111280212,2.70380620867,22.541276072,0.0804157636471,-30.972199831,19.2009369563,-18.6939557639,-11.2801023255,3.22813640398,1.69571956767,18.6369264424,-17.6193966764,22.5970162787,5.99121123613,14.1008570864,5.17855668756,1.54777157575,-8.6451906168,-1.58927527891,-11.6693466983,-1.00499566,-1.04590527922,-2.19812790878,1.525863336,-2.76197704423,2.43359800969,-0.738276630065,6.68095599733,0.416485458243,7.65450737848,2.97034052167,1.69679765523,-1.6013595283,-0.488642370025,-1.74245356074,-1.06469613059,0.0576315264965,1.75469748689,-1.16183185366,-0.633540324266,-0.675482649524,-0.487164858406,-0.164014197092,-0.845319927433,1.64662419247,0.421723203272,1.81990184863,0.777530361353,1.56900445313,0.0284221694725,-0.0517916275454,-0.464155310529,-0.617529684142,0.070436951021,0.228575619303,-0.152856561556,0.484326738566,0.0646964943136,-0.0461033027019,-0.246864212003,-0.1274035633,-0.0356676647595,-0.13005891464,0.0627301092575,-0.0243288401027,0.645766540802,0.355089458304,0.458781468198,0.227560452811,0.0661385536148,0.0594930725845,-0.142789248364,0.191931025691,0.121067656271,-0.0868895493506,0.171994476976,-0.0733833613664,-0.0121611310708,-0.00629396963354],[-26237.7252135,-58.6557682304,-557.348592747,-1428.74509893,1068.05130274,844.910737022,450.376761249,-544.800693138,-366.89047295,-1073.23102611,-685.096837985,325.628118856,107.828016391,180.366292432,-322.239608853,-283.570003986,292.518897895,30.1029541248,-128.106474455,-145.992415869,-168.622368023,429.507473518,-95.7759787791,148.728986873,-15.6590544198,75.6561341794,-72.9866630805,158.697082485,-145.116666905,86.7665290259,171.093154497,6.37065512524,46.7594854283,7.29969259476,-138.027108805,-27.5458141657,51.5032408722,-6.3743401646,42.5204524595,-24.8969725568,59.0811396437,11.4520520322,2.38235668793,22.0697491577,-0.510211603127,-30.5721991982,19.7092712918,-18.7459032971,-11.209270073,3.48527562096,2.05313569926,18.9273250299,-17.9227297108,22.7844197224,5.71864087636,14.298111511,5.00941950901,1.40822294163,-8.36663469823,-1.44260403547,-11.6475069015,-0.992435823621,-0.947754051701,-2.21943575034,1.60800779757,-2.64460164647,2.53402020109,-0.779654924378,6.74049384451,0.425881141297,7.7518941534,2.89206588846,1.69726079153,-1.49246322357,-0.442596900059,-1.73958848124,-1.06594310671,0.0431402277543,1.72821149641,-1.1543727018,-0.636215078074,-0.665566018634,-0.473217375127,-0.12215166469,-0.821779012867,1.64951303629,0.432000403117,1.8519674952,0.763397782539,1.58032439883,0.0453118255406,-0.0190332684046,-0.463509885636,-0.618569873309,0.0613568283858,0.216223448097,-0.148883182363,0.488409694192,0.0636929624234,-0.051627718589,-0.249461991707,-0.128556054296,-0.0267701563251,-0.124488183497,0.0651534398791,-0.0184559380569,0.652560621484,0.354053518075,0.465451547274,0.225807052874,0.0764034600033,0.062758380105,-0.141607796334,0.190703169736,0.116021108473,-0.0834694144173,0.171638970027,-0.0753182729541,-0.0142945568182,-0.00443710359812],[-26254.2864877,-54.273856737,-554.466118803,-1429.9496295,1067.41295359,842.641447222,456.217288365,-556.242802587,-385.472697163,-1075.89158638,-685.674293406,316.144099666,115.363965625,183.964383375,-327.78583834,-279.21838308,289.812517546,27.8509093355,-128.595778893,-144.192281059,-166.202946595,426.353252751,-96.6723860711,152.207672409,-13.9667489773,76.4790750415,-72.5835011413,158.245682236,-147.054861638,88.4237971029,169.711393884,4.13004828797,47.236887256,6.37523797308,-138.547980459,-26.4508729763,51.5806463027,-4.74732582297,42.982752053,-26.0791538266,59.3883790884,10.6393131137,2.08304309739,21.5857377878,-1.02116156937,-30.1669855308,20.2044490844,-18.7994772923,-11.1356037929,3.76100958603,2.42531656674,19.2401040228,-18.1989838731,22.9558415815,5.44477188473,14.4962823311,4.83289794647,1.31064876952,-8.08835727834,-1.2819041949,-11.6224061253,-0.984955705802,-0.847443632205,-2.24533667925,1.6882911061,-2.52472663447,2.64336417127,-0.811162054381,6.79447815489,0.441708456897,7.85147626058,2.81487545376,1.70932239547,-1.38246660504,-0.386058268824,-1.73594311626,-1.06645283624,0.030770967551,1.70348904425,-1.14558325931,-0.641322556877,-0.65797111678,-0.459458606444,-0.0787975811234,-0.794743114934,1.65145631448,0.445561007308,1.88428263294,0.750569942474,1.59472097886,0.0623450888691,0.0182875608782,-0.462549201309,-0.618634954978,0.0533075792552,0.205014818754,-0.143625816672,0.492305865767,0.0624446378024,-0.0577803634984,-0.25325827281,-0.130002262638,-0.0178791361746,-0.118555615439,0.0676287421831,-0.0115758672025,0.659419463293,0.353728213667,0.472772312456,0.224313281052,0.087815471216,0.0659303247759,-0.139865064759,0.189899677581,0.111426726388,-0.0791957780692,0.1712669682,-0.0771046110301,-0.0166344712613,-0.00260850072922],[-26274.5708895,-51.4951502425,-554.216857173,-1431.66690669,1066.56646197,840.296797515,459.854346927,-566.581607709,-404.222174284,-1079.00923428,-685.814764073,306.883358865,122.49005943,187.369800059,-332.825939872,-274.814559653,287.143147755,25.8150826534,-129.204178591,-142.636224512,-163.637743299,422.851829851,-97.3881142324,155.945329924,-12.1125147473,77.5344850215,-72.0932331624,157.88412514,-149.032081121,90.1806713609,168.248028361,1.93553754698,47.7189044382,5.5987173148,-139.070753537,-25.2882512797,51.7345262932,-3.09928168176,43.4978465878,-27.2135808898,59.6948577136,9.76757507525,1.81174742886,21.0921416571,-1.44943219714,-29.7468787705,20.6823591092,-18.8529725411,-11.0598589937,4.05496692874,2.80792520725,19.5795617597,-18.445714935,23.1121777451,5.17052252452,14.6936764203,4.65235877247,1.25523051798,-7.81234277063,-1.10932192606,-11.5949020482,-0.983537164836,-0.744522296575,-2.27576533371,1.76593099905,-2.4033138165,2.76140789565,-0.832331254082,6.84300819204,0.463515101136,7.95304919105,2.74003929282,1.73269356911,-1.27179395165,-0.319367207493,-1.73189251089,-1.06582710978,0.0205159452536,1.68110089932,-1.13490513256,-0.648916049283,-0.652892886171,-0.446236652251,-0.0340437535511,-0.764228794399,1.65257119177,0.462370879096,1.91659940476,0.739437459016,1.61220976164,0.0794094927909,0.0601550471833,-0.461203962192,-0.617719789162,0.0462997585125,0.195153625452,-0.136919979413,0.495844354972,0.0610601896944,-0.0646252710608,-0.258274795415,-0.13178956305,-0.00909523073152,-0.112324773659,0.0702154851482,-0.00374541130682,0.666331627051,0.354196994328,0.480728676607,0.223153580767,0.100318367896,0.0690389720107,-0.137500628962,0.18953260952,0.107381304418,-0.0740604201138,0.170832838436,-0.0787566455579,-0.0191901050349,-0.000818497187568],[-26298.667102,-50.5915635435,-557.019880905,-1433.69262712,1066.27129232,838.302552901,460.269856545,-575.325750169,-423.026713399,-1082.71232671,-685.397592146,297.904437852,129.117219709,190.513786683,-337.240140312,-270.320282765,284.538904158,24.054266234,-129.943273707,-141.262000618,-161.001490571,419.049363121,-97.8785179345,159.967952336,-10.1126161027,78.8120529119,-71.5090955801,157.645194022,-151.031211853,92.025911381,166.716518232,-0.198753530265,48.1876788988,4.98186462931,-139.571124908,-24.0617862549,51.9642012085,-1.43172360612,44.0771167504,-28.2875468382,59.9980073964,8.83288613592,1.57186583326,20.5918641195,-1.7927617779,-29.3025690896,21.1404006201,-18.9051488143,-10.9828885114,4.36670477836,3.19686756796,19.9489483167,-18.6612293876,23.2543398579,4.8967156616,14.8887758638,4.47123138999,1.24174447079,-7.53957695751,-0.926727736764,-11.5661690839,-0.989066715438,-0.638797073853,-2.31055179523,1.84021252138,-2.28135743932,2.8877883069,-0.842916596016,6.88613957845,0.490889855357,8.05632617753,2.66877953959,1.76700117384,-1.16083134539,-0.242800625981,-1.72786334779,-1.06380462336,0.0123211072779,1.66154253805,-1.12182446883,-0.658991190136,-0.650482902059,-0.433883894527,0.0119841447943,-0.730325698182,1.65295468827,0.482389823492,1.94868409252,0.730369340189,1.63275752317,0.0964510889009,0.106522249793,-0.459433908572,-0.61582589354,0.0403032068378,0.186818941023,-0.128619593979,0.49887274019,0.0596474172802,-0.072198512997,-0.264513649114,-0.133958621437,-0.000509046390623,-0.105864743507,0.072953735129,0.00497970924084,0.673282662999,0.355529959039,0.489291702496,0.222402267666,0.113859604897,0.0721112268849,-0.134476046034,0.189610640464,0.103965600421,-0.0680650217653,0.170305986413,-0.0802877333662,-0.0219659358091,0.000922741462025],[-26325.1299532,-51.3999476431,-561.707695325,-1435.57725781,1066.86567065,836.739099267,457.815678622,-582.669334351,-441.687834266,-1086.92103611,-684.275208599,289.196506643,135.36144329,193.389866293,-341.230056326,-265.777332073,282.01977319,22.5565490177,-130.768847183,-140.031503049,-158.292754492,414.988443016,-98.1964388466,164.255617745,-8.00303259409,80.2899603065,-70.8231907416,157.522319168,-153.031165509,93.9412277531,165.115097268,-2.27172221218,48.6267490513,4.53255132847,-140.015515609,-22.7835813386,52.2659135448,0.251322768827,44.7202388262,-29.2970863725,60.2981557552,7.83683215275,1.35685109808,20.0878231666,-2.05184952071,-28.8262275825,21.582014788,-18.9566258,-10.9059344929,4.69549426291,3.58902123607,20.3473207186,-18.8468365982,23.3833025873,4.62379257217,15.0807635931,4.29319572373,1.26834621268,-7.26705109726,-0.734889490631,-11.5386485886,-1.00204949802,-0.531110005889,-2.34910791856,1.91068994806,-2.15998150366,3.02157816667,-0.843555506814,6.92375337238,0.523585841893,8.16069141957,2.6021265628,1.81153510841,-1.04981208056,-0.156380149168,-1.72448885983,-1.06067169488,0.00594738823561,1.64500826685,-1.10600557898,-0.671312999232,-0.650719271872,-0.42266984358,0.059024976383,-0.693415817837,1.65262324555,0.505553412558,1.98035953384,0.723648154684,1.65613586954,0.113650001842,0.157217717595,-0.457314923294,-0.612981416451,0.0351249080959,0.180090552939,-0.118652217602,0.501312506593,0.0583106394898,-0.0804243133871,-0.271898321441,-0.136523268408,0.00782889057007,-0.0992666989598,0.0758059479854,0.0145480275641,0.680246079055,0.357743805698,0.498377052498,0.222133146292,0.128401333913,0.0751613531218,-0.130840800123,0.190128903779,0.101196226069,-0.0612508698654,0.169715972747,-0.0817075787464,-0.0249474293957,0.00260573203834],[-26352.1308071,-53.6483875961,-566.716163828,-1436.80995838,1068.58251342,835.600477722,453.186160013,-588.977830315,-459.985484315,-1091.50348881,-682.293316612,280.731392409,141.38999573,196.007131647,-345.077652028,-261.247494884,279.603708985,21.2923441416,-131.622727657,-138.912660296,-155.49105955,410.710768028,-98.4190903874,168.776925545,-5.82467256615,81.9435119988,-70.0273374713,157.499092727,-155.009860053,95.9065688196,163.438192607,-4.28552097618,49.0200024314,4.25768317478,-140.368027719,-21.4678065322,52.6351363315,1.94520436544,45.4239630004,-30.2404195961,60.5963543439,6.78238339226,1.1576701699,19.582940449,-2.22813486405,-28.3103955738,22.0121532631,-19.0084881654,-10.8303364125,5.04053501014,3.9815067088,20.772687727,-19.0045966535,23.5000563561,4.35209913502,15.2689977511,4.12199432882,1.33278615359,-6.99075781706,-0.534299390239,-11.5150986538,-1.02289530942,-0.422561887736,-2.39074100173,1.9769848616,-2.04034244869,3.16170919381,-0.835106251633,6.95568699101,0.561397268326,8.26544685844,2.54106278986,1.86550103087,-0.938931254522,-0.0600635806765,-1.72245391741,-1.0568515477,0.00110946978756,1.63161709967,-1.08715731479,-0.685588842607,-0.653536736081,-0.412848291799,0.106783737611,-0.653954231077,1.65157316058,0.531791160118,2.01146270529,0.719534861355,1.68206761438,0.131244874518,0.212038871881,-0.454951924843,-0.609221163897,0.0305311319479,0.17502342733,-0.106963815979,0.503103616054,0.0571533051903,-0.0891989344009,-0.28033264942,-0.139490625752,0.0158780739016,-0.0926273361526,0.0787151769533,0.0249091401647,0.687192372554,0.360841881933,0.507886538893,0.222419893414,0.143909380849,0.0782004541068,-0.126666357145,0.191079147451,0.0990737564901,-0.0536691526626,0.169107396791,-0.0830249728554,-0.0281152986422,0.00422116195605],[-26377.8410277,-57.0649684572,-570.48114981,-1436.87988842,1071.65473706,834.880729377,447.075647572,-594.616708125,-477.699610971,-1096.32781114,-679.297619363,272.480922318,147.370142589,198.3746755,-349.064891534,-256.792558503,277.308665677,20.2320647427,-132.446743765,-137.873400851,-152.575930233,406.258036647,-98.6236859756,173.50047513,-3.61844436369,83.7480127828,-69.1133545939,157.559106848,-156.945213454,97.9018829223,161.68023139,-6.24230229966,49.351326575,4.16416593074,-140.592763313,-20.1286318367,53.0673425976,3.64526810607,46.1850394582,-31.1157666123,60.8936547163,5.67251012099,0.965289995337,19.0801376174,-2.32305724637,-27.7476143884,22.4357676953,-19.0618205779,-10.757433745,5.40102664777,4.37144448337,21.223058104,-19.1365696401,23.6055915873,4.08198122894,15.4528364809,3.96136976038,1.43281470349,-6.70668974412,-0.325449638164,-11.4982773713,-1.05201394647,-0.314253514449,-2.43475834279,2.03871884449,-1.92359671363,3.30711310721,-0.818427095629,6.9817778515,0.604118342238,8.36989443541,2.48657064818,1.92810459931,-0.828383964647,0.046191275872,-1.72244339094,-1.05276740518,-0.00247796640556,1.62148805044,-1.06498852804,-0.701526086297,-0.65887003516,-0.404673031575,0.154965424874,-0.612396015611,1.64980073033,0.561032579997,2.04183058345,0.718290419057,1.71027557132,0.149474349835,0.270783133942,-0.452449831703,-0.604579941881,0.0262881480551,0.171672530325,-0.0935003548026,0.504186030445,0.0562788632488,-0.0984186382086,-0.28972047007,-0.142867815255,0.0235979973551,-0.0860433512193,0.0816244752688,0.0360126435445,0.694092040833,0.364827535375,0.517721973961,0.223336185801,0.160349571607,0.0812396332252,-0.122024183016,0.192453119462,0.0975987668105,-0.0453710584056,0.168524857898,-0.0842487068501,-0.0314502563961,0.00575971862985],[-26400.4319792,-61.3777752811,-571.438516667,-1435.27620757,1076.31525802,834.573895342,440.178488151,-599.951437843,-494.610161663,-1101.26212944,-675.13382003,264.41692354,153.469149424,200.50159061,-353.473738958,-252.474310235,275.152597397,19.3461239578,-133.182724146,-136.881653204,-149.52689103,401.671947365,-98.8874390297,178.394865896,-1.4252563315,85.6787674523,-68.073060934,157.685953681,-158.815143676,99.9071184035,159.835640754,-8.14421866002,49.604609018,4.25890535883,-140.65382447,-18.7802272534,53.5580053724,5.34686091308,47.000218385,-31.9213475245,61.1911084263,4.51018260547,0.770677520993,18.5823363227,-2.33805610613,-27.1304253511,22.8578097348,-19.1177077045,-10.6885659646,5.77616880353,4.75595505699,21.6964406113,-19.2448156445,23.7008987038,3.81378473273,15.6316379256,3.81506457353,1.56618227233,-6.41083950565,-0.108832436983,-11.4909428325,-1.08981520601,-0.207285681081,-2.48046723978,2.0955134792,-1.81090073766,3.45672162572,-0.794376303959,7.00186337104,0.651543271212,8.47333609173,2.43963256517,1.99855147177,-0.718365308299,0.162426616855,-1.72514215084,-1.04884249067,-0.00510023868305,1.61474013309,-1.03920807049,-0.718832096336,-0.666653909578,-0.398397855296,0.203275034569,-0.569196249153,1.64730225175,0.593207186018,2.07130014488,0.720175786647,1.740482554,0.168577070696,0.333247925069,-0.449913562361,-0.599092556408,0.0221622260784,0.170092828055,-0.0782077997676,0.504499711638,0.0557907625323,-0.10797968698,-0.299965620414,-0.146661958707,0.0309481546815,-0.0796114402938,0.0844768961677,0.0478081342052,0.700915581227,0.369704113652,0.527785169982,0.224955700221,0.177687732093,0.0842899938623,-0.116985743649,0.194242567795,0.0967718321576,-0.0364077753428,0.168012955422,-0.0853875718875,-0.0349330155046,0.00721208947441],[-26418.9662324,-66.2897275274,-568.455623015,-1431.67635587,1082.71434967,834.643562354,433.138594492,-605.273813624,-510.542370079,-1106.2225564,-669.749154579,256.522066775,159.790838713,202.386230923,-358.537501513,-248.334331385,273.135328994,18.6001501924,-133.788471279,-135.911847536,-146.333024457,396.999423424,-99.2688389191,183.424915672,0.71929328342,87.7057071129,-66.9061248365,157.864286258,-160.600021459,101.904767595,157.902617467,-9.98955393863,49.7616886664,4.54272154018,-140.523122045,-17.4363630515,54.1014094531,7.04578168838,47.8637952963,-32.6564127242,61.4899460017,3.29912758038,0.567470549733,18.0896652668,-2.27508566225,-26.4538032985,23.2813109993,-19.1777625242,-10.6249077598,6.16493782977,5.13247923019,22.1904399509,-19.3315370163,23.7872426502,3.54796067123,15.8051530537,3.68545956295,1.7304968799,-6.10019251955,0.11465681859,-11.4954425443,-1.13620603459,-0.102558283694,-2.52725138915,2.14717096036,-1.70322104817,3.60939963467,-0.763876889899,7.0160798945,0.703334019594,8.57522721506,2.40092659532,2.07605326799,-0.609103507536,0.288454984138,-1.73104249529,-1.04528823439,-0.00700274158297,1.61141573241,-1.00966951553,-0.737197305413,-0.676796824213,-0.394199653383,0.251448566961,-0.524809324081,1.64410502004,0.628217307544,2.09975619804,0.725364924758,1.77240802289,0.188713724133,0.399174427037,-0.447422317977,-0.592746302748,0.0179661439623,0.170319729467,-0.061064338488,0.503999361787,0.0557436386038,-0.117774563282,-0.310967637936,-0.150877046558,0.037896963681,-0.0734174133926,0.0872237904673,0.060238647043,0.707647738664,0.375472865544,0.537980337586,0.22732557473,0.195873859171,0.0873689536121,-0.111604954682,0.19643084255,0.0965949043172,-0.0268349420258,0.167601610625,-0.0864560275255,-0.0385397564468,0.00857087673034],[-26436.0711869,-71.4030822752,-562.125808359,-1426.51089515,1090.67171306,834.931499666,426.398142884,-610.580926008,-525.50261495,-1111.31715011,-663.496990122,248.822396842,166.185260604,203.983995148,-364.294858806,-244.333379257,271.184168163,17.9406329255,-134.285683007,-134.964420782,-143.021645128,392.308287063,-99.7514788154,188.540316034,2.80084662533,89.7772681186,-65.6436127271,158.083001147,-162.29002863,103.887498788,155.894436817,-11.7611176327,49.7962099079,4.99209183036,-140.203802005,-16.1092105723,54.6870867091,8.73963725207,48.76024703,-33.3243337556,61.7921138662,2.04609765299,0.359990309458,17.5910813569,-2.13815925533,-25.7224571138,23.7016229769,-19.2457112617,-10.5669746741,6.56541697733,5.49973901674,22.7010445848,-19.3995051575,23.8669864582,3.28538065351,15.9747041367,3.56948848148,1.92279698522,-5.77570536653,0.3425099653,-11.5124816743,-1.18908197759,-0.000167622384413,-2.57480008097,2.194215931,-1.60076452535,3.7637446851,-0.728110859193,7.02575947746,0.758623578793,8.67563697859,2.36991330136,2.15984545428,-0.500959283181,0.423170301532,-1.73986643355,-1.04146889394,-0.00827117443855,1.61125071656,-0.976805322924,-0.756244412827,-0.689102141565,-0.391947708372,0.299346037801,-0.479686891442,1.64036032335,0.665856536094,2.12727487891,0.733683801147,1.80575802588,0.209733173687,0.468078863565,-0.444952430424,-0.585338433243,0.0136987127843,0.172310414782,-0.0421770462556,0.502698644174,0.0559968738089,-0.12768063127,-0.322608861961,-0.15550454392,0.0444485383498,-0.06750353606,0.0898496993099,0.0732209705307,0.714330248435,0.382126644449,0.548221280808,0.230386792532,0.214794633545,0.0905191869031,-0.10586553064,0.198967702294,0.09707544171,-0.0167259982186,0.167262032417,-0.0874912069266,-0.0422285302281,0.00983634194192],[-26455.2654489,-76.2949310085,-553.473907423,-1420.39866769,1099.92440618,835.249022158,420.348875507,-615.796189628,-539.542561268,-1116.70195502,-656.832226561,241.354802089,172.439022162,205.239543182,-370.735833538,-240.412005154,269.208293312,17.3092769046,-134.712031016,-134.046311564,-139.629625686,387.671585271,-100.300227841,193.686976992,4.8103559363,91.8365131351,-64.3244405517,158.332055801,-163.877799788,105.850524263,153.828143717,-13.4378506436,49.6797685003,5.57740790358,-139.706819097,-14.8105414251,55.303380778,10.4264864038,49.6715957544,-33.9295124515,62.0997374174,0.7586018987,0.155228884334,17.0727485517,-1.93180500642,-24.9435291922,24.1121771233,-19.3258084534,-10.5151174651,6.97546622169,5.85677673371,23.2238389151,-19.4516337332,23.9427676811,3.02702143472,16.1420062715,3.46272332149,2.13997865717,-5.439327418,0.571815647755,-11.5423548054,-1.24583573013,0.0999909017401,-2.62287900372,2.23735364628,-1.50354813756,3.9182874945,-0.688324965707,7.03253310324,0.816412696983,8.77478800189,2.3457488731,2.24916945858,-0.39432648075,0.565236838339,-1.75114340263,-1.03653693381,-0.00895131278184,1.61390432456,-0.941192674023,-0.775579184531,-0.703346948539,-0.391434400826,0.346858466711,-0.434279916953,1.63625044806,0.705891278725,2.15398015537,0.744871385348,1.8402352577,0.231406327024,0.539421218855,-0.442454514248,-0.576618689501,0.00940525190518,0.176002507038,-0.021685220282,0.500625962362,0.0563610371889,-0.137571475497,-0.334767332279,-0.160532784566,0.0506159167332,-0.0619011877226,0.092347461419,0.0866653315355,0.721019093422,0.389656204914,0.558424202035,0.234053798116,0.234320906877,0.0937896823726,-0.0997336357667,0.201794507712,0.0982222794154,-0.00615883398812,0.166950751615,-0.088535911654,-0.0459528554856,0.0110106614794],[-26480.0676248,-80.5423652113,-543.524754932,-1413.95851577,1110.20948701,835.40744471,415.382534537,-620.843019115,-552.713874026,-1122.5330156,-650.209763794,234.156170865,178.338730453,206.097534924,-377.850448414,-236.510760377,267.116882852,16.647786877,-135.10518699,-133.164458507,-136.193838772,383.162365038,-100.879955118,198.810808555,6.73877345837,93.8265048283,-62.9875242564,158.601407669,-165.355969533,107.789056301,151.720783083,-14.9986938724,49.3839602013,6.26906143405,-139.043128065,-13.5521272192,55.9386352971,12.1043879432,50.5798636377,-34.4763506443,62.414942053,-0.555850607092,-0.0398216414747,16.5208308097,-1.66055103658,-24.1241619288,24.5064048944,-19.4223086357,-10.4696868902,7.39294553831,6.20263469819,23.7544073438,-19.4908364081,24.0172238724,2.77385976999,16.3087745552,3.36073607539,2.3789379646,-5.09300804536,0.799662510561,-11.5853565204,-1.30385998732,0.198021887574,-2.67125384585,2.27728936135,-1.41158885317,4.07155878038,-0.645765963305,7.03803175512,0.875702122337,8.87290290453,2.32758950034,2.34326670888,-0.289598945757,0.713318863856,-1.76440283956,-1.02964481845,-0.00908893214486,1.61903579541,-0.903408750192,-0.794807386476,-0.71930833204,-0.392452111312,0.393876873309,-0.389039366327,1.63195768054,0.748087942493,2.17999599527,0.758666646895,1.87554241308,0.253504091812,0.61266147711,-0.439879183999,-0.566336813131,0.00513108068555,0.181333629274,0.000271842221344,0.497809719916,0.0566466977852,-0.147320680514,-0.347321088677,-0.165950102271,0.0564121368765,-0.056641747807,0.0947099155181,0.100481956924,0.727770256506,0.398052301489,0.568505303653,0.238241035975,0.254323530832,0.0972294286579,-0.0931754343092,0.204852619485,0.100044252513,0.00478866059871,0.166624299038,-0.0896329432714,-0.0496662508564,0.0120960117129],[-26513.9963208,-83.7224763675,-533.303185611,-1407.80928166,1121.26401353,835.218082203,411.890862153,-625.644829104,-565.068218216,-1128.96637631,-644.084501722,227.26339152,183.670992544,206.502630273,-385.628726138,-232.570196231,264.81911519,15.8978675903,-135.502822615,-132.325800234,-132.751157026,378.853673354,-101.455529769,203.857720736,8.57705143362,95.6903058639,-61.6717797871,158.881014204,-166.717172463,109.698307183,149.58939983,-16.4225882204,48.8803807689,7.03744409596,-138.223683655,-12.345739564,56.581193904,13.7714006699,51.4670728481,-34.9692501665,62.7398531706,-1.88975078898,-0.218169183805,15.9214920893,-1.32892546686,-23.2714977186,24.8777377457,-19.5394663448,-10.4310337069,7.81571490267,6.53635522725,24.2883342731,-19.5200268475,24.0929925854,2.52687241444,16.4767240848,3.25909873554,2.63657097638,-4.73869662003,1.02313919833,-11.6417814023,-1.36054744426,0.29402993401,-2.71969029585,2.31472833137,-1.32490364057,4.22208926021,-0.601680605851,7.0438864164,0.935492603028,8.9702043061,2.31459137288,2.44137863312,-0.187170523718,0.866080647384,-1.77917418137,-1.01994501234,-0.00872980805963,1.62630436813,-0.864030732794,-0.813534784614,-0.736763378973,-0.394793220395,0.440292277218,-0.34441620528,1.62766430717,0.792212934455,2.20544636649,0.774808555323,1.91138218675,0.275797375717,0.687259622534,-0.437177054224,-0.554242545742,0.000921518486176,0.188241404526,0.0235548440431,0.494278320397,0.0566644246392,-0.156801830875,-0.360148170944,-0.17174483081,0.061850236825,-0.0517565957398,0.0969299003307,0.114581073565,0.734639720571,0.407305688721,0.578380788048,0.242862950597,0.274673357073,0.100887414396,-0.0861570905129,0.208083398299,0.102550196081,0.0160385954749,0.166239205507,-0.0908251033422,-0.0533222349774,0.0130945690127],[-26559.3641212,-85.5259499994,-523.669475566,-1402.45331575,1132.80293246,834.570667124,410.084238439,-630.176303371,-576.625433018,-1136.04569872,-638.823899261,220.662498329,188.236360752,206.455552851,-394.037772038,-228.544803419,262.254029829,15.0017906599,-135.9516568,-131.537978789,-129.329705208,374.820774581,-102.000367421,208.776885544,10.3117043724,97.3780009903,-60.4072703493,159.161096127,-167.953364482,111.568139873,147.451822536,-17.6949809411,48.1432928215,7.85321359917,-137.25819949,-11.2038060764,57.2190757369,15.4241917716,52.3199502556,-35.4125387029,63.0740179687,-3.23358545626,-0.374378502845,15.2648909269,-0.943929674969,-22.3923459055,25.2216890784,-19.680097551,-10.3997066537,8.24103655688,6.85694304997,24.8213491902,-19.5421086465,24.1721271835,2.28731595673,16.6471430002,3.15445972631,2.90887000839,-4.3785980307,1.23971742208,-11.7116278377,-1.4135552627,0.388132016568,-2.76781506892,2.35010858196,-1.24345282097,4.36857572596,-0.55735623457,7.05146221931,0.994918360113,9.06675454782,2.3061222682,2.54248684108,-0.0874208032058,1.02215675173,-1.79515264043,-1.00673109571,-0.00797236064308,1.63530050277,-0.823585340442,-0.831384030788,-0.755477826561,-0.398254966856,0.485971143298,-0.300882400884,1.62355124167,0.837948274024,2.23043705818,0.793075828394,1.94742382524,0.29807001661,0.762597775288,-0.434340714071,-0.540189521994,-0.00321563918499,0.196617089004,0.0479900856412,0.490071547089,0.0562752363509,-0.165896309638,-0.373118450207,-0.177888188352,0.0669424101204,-0.0472804477245,0.0990089350687,0.128861361954,0.741666698031,0.417375871224,0.587966916661,0.247833479083,0.295216016391,0.104793721142,-0.0786651472201,0.211420201978,0.105725974625,0.0274950596381,0.165758233599,-0.0921481182151,-0.0568748934718,0.0140138814944],[-26613.6595211,-86.0978477822,-514.825666427,-1397.92700082,1144.45274543,833.668602393,409.447595109,-634.617202268,-587.278054367,-1143.36511293,-634.445651403,214.136109285,191.8911684,206.181281186,-402.953021957,-224.444830247,259.48011065,13.9040951734,-136.534597352,-130.811449898,-125.922616542,371.147802584,-102.522069718,213.530522996,11.9114958586,98.867763286,-59.1886481865,159.432927239,-169.053786714,113.36702007,145.329014429,-18.8273446974,47.1576264196,8.68809179606,-136.151424703,-10.1413784048,57.8390019366,17.053861988,53.1440415358,-35.8102473465,63.4066708484,-4.56982495706,-0.509241736192,14.5571641696,-0.522458065337,-21.4921836287,25.5421000741,-19.8412639597,-10.3770463932,8.66378180972,7.16325254344,25.349761924,-19.5599451223,24.2543442698,2.05756631948,16.8196116134,3.0477732,3.18821236458,-4.01593923523,1.4484011585,-11.7937094293,-1.46159847098,0.480494617262,-2.81469898725,2.38279922067,-1.16697012699,4.51037926749,-0.514242540131,7.06106089185,1.05364750618,9.1619748575,2.3023963145,2.64453366974,0.00932765497345,1.18006291371,-1.81269653052,-0.989861111795,-0.00712558835161,1.64533954357,-0.78239744076,-0.848045320396,-0.77517201329,-0.402654022346,0.530681717371,-0.258993925646,1.61979390711,0.884638430034,2.25500114467,0.813406176778,1.98320278222,0.320157573182,0.837746599369,-0.43153065108,-0.524446948751,-0.0074226922311,0.206166471597,0.0732662581511,0.485274702146,0.0555419497543,-0.174516693894,-0.38606912294,-0.18428293065,0.0716974722907,-0.0432613670739,0.100983260899,0.143175317111,0.748823319424,0.428097353865,0.597180187155,0.25306452897,0.315696256081,0.108902802117,-0.0707676616589,0.214764376913,0.109465570352,0.0389900583446,0.165169072938,-0.09360941338,-0.0602805799072,0.0148829842557],[-26673.1649932,-85.6968254295,-506.809241204,-1394.15022774,1155.81784281,832.793708537,409.284501784,-639.198555291,-596.886792386,-1150.40636618,-630.880012154,207.415988308,194.505694065,205.960857529,-412.226994361,-220.294464421,256.585702625,12.5498870864,-137.343599304,-130.157372706,-122.514276367,367.921108599,-103.036784808,218.084115108,13.3407517443,100.144787912,-58.0017128019,159.688044614,-170.007001586,115.058064156,143.242722402,-19.8376585045,45.9109784844,9.51406657465,-134.906867304,-9.17416420529,58.4273691447,18.6501204471,53.9495970661,-36.1663330426,63.724468012,-5.87893552421,-0.625107865795,13.8084432421,-0.0838782990533,-20.5761549762,25.8448938598,-20.0185887102,-10.3645915694,9.0782242366,7.45410049675,25.8700273883,-19.5763895222,24.3387762573,1.84027925885,16.993283279,2.94106974087,3.46607159592,-3.65420270877,1.64857745072,-11.8865435834,-1.50365656408,0.571296594732,-2.85927389975,2.41190212548,-1.0951326441,4.64702704913,-0.47382980056,7.072718311,1.1114816267,9.25512618462,2.30383922763,2.74520163789,0.102766546956,1.33828516366,-1.83232994077,-0.969334219604,-0.00655113422653,1.65566805583,-0.740741438626,-0.863225734727,-0.795554927964,-0.407811916729,0.574167690498,-0.219327753428,1.61656635388,0.931543483672,2.27915352156,0.835777059374,2.01822106314,0.341908534327,0.911698894732,-0.428949327392,-0.507387925927,-0.0118794644081,0.216548974366,0.099037650378,0.479984467441,0.0545778312422,-0.182583359241,-0.398829216957,-0.190814697852,0.0761233943602,-0.0397507538775,0.102897799475,0.157363887686,0.756064944825,0.439273391576,0.605937156247,0.258467500401,0.335833602567,0.113150203463,-0.0625530696542,0.218009266633,0.113639994891,0.0503375759152,0.164465644909,-0.0952093391121,-0.0634962148372,0.0157362841394],[-26734.1630106,-84.5815386548,-499.657682906,-1391.04288741,1166.502615,832.227806082,408.898528085,-644.151391937,-605.312357199,-1156.65120568,-628.057235521,200.233899318,195.950216322,206.075324132,-421.712207718,-216.117893648,253.659150728,10.8842723545,-138.470617688,-129.586906361,-119.089070024,365.227043865,-103.560660842,222.403143897,14.5637978816,101.194270029,-56.8322636986,159.917985322,-170.801571524,116.604388513,141.214693344,-20.7439013775,44.3909459372,10.303125823,-133.528035304,-8.31787113381,58.9705740029,20.2026762767,54.7468672238,-36.4847527365,64.0140656612,-7.14138339054,-0.724325873603,13.0288595693,0.352441962792,-19.6494040359,26.1359935624,-20.2076949417,-10.363880826,9.47863741293,7.72830369898,26.378600497,-19.5942950935,24.4245555594,1.63811053099,17.167311352,2.83637993319,3.7339212534,-3.29687092645,1.83963334184,-11.9886477065,-1.53870903699,0.660716807619,-2.90047165534,2.43651917441,-1.02761745779,4.77804623519,-0.437608293887,7.08647035368,1.16822230714,9.34546947865,2.31087672347,2.84217326432,0.192587568878,1.49530953191,-1.85457696033,-0.945149578136,-0.00661064130914,1.66553260483,-0.698891738917,-0.876632355069,-0.816335559387,-0.413550179871,0.616172753741,-0.182460858095,1.61404263239,0.97792351613,2.30290908447,0.860165935079,2.05198067345,0.363171388939,0.983447461331,-0.426799205148,-0.489385553438,-0.0167657794718,0.227424019369,0.124958551127,0.474297524848,0.0534961472072,-0.190016681277,-0.41122776007,-0.197369130106,0.0802281473534,-0.0368000082251,0.104797472452,0.171268022327,0.763346934304,0.45070723929,0.614154380653,0.263953793524,0.355347582272,0.117471471318,-0.0541098070304,0.221048214672,0.118120259875,0.0613515966707,0.163641870896,-0.0969482456867,-0.0664787188156,0.0166081879886],[-26792.9360462,-83.0106431715,-493.408474545,-1388.52487071,1176.11145234,832.252715556,407.593243632,-649.706741702,-612.415458928,-1161.58137868,-625.907575513,192.321606235,196.095013747,206.805723248,-431.261180496,-211.939305635,250.788799931,8.85235693328,-140.007607535,-129.111210008,-115.631382854,363.151959618,-104.109845966,226.453091379,15.5449601226,102.001404798,-55.6661003795,160.114286436,-171.426058958,117.969109523,139.266674148,-21.5640523317,42.5851256991,11.0272574291,-132.018436713,-7.58820684645,59.4550131527,21.7012386045,55.5461023862,-36.7694633734,64.2621199983,-8.33763478888,-0.809244741566,12.228544576,0.767135059106,-18.7170748959,26.4213223089,-20.4042057937,-10.3764528068,9.85929491415,7.98467893921,26.8719361643,-19.6165150837,24.5108145889,1.45371589204,17.340849187,2.73573436122,3.98323488799,-2.94742636343,2.02095587497,-12.0985392051,-1.5657353847,0.748934114562,-2.93722410293,2.45575224544,-0.964101653519,4.90296399002,-0.40706829814,7.10235289688,1.22367113297,9.43226568906,2.32393451787,2.93313106784,0.278482416877,1.64962204878,-1.87996167832,-0.917306346393,-0.00766575264074,1.67417975586,-0.657122746508,-0.887972262709,-0.837222896363,-0.41969034164,0.65644059816,-0.148970213508,1.61239679304,1.02303860859,2.32628272902,0.886550262791,2.08398361861,0.383794625912,1.05198509912,-0.425282746489,-0.470812931198,-0.0222614611782,0.238451028666,0.150683249203,0.46831055624,0.052410164042,-0.196737035599,-0.423093780094,-0.203831867559,0.0840197022948,-0.0344605302064,0.106727201486,0.184728669685,0.770624647933,0.462202151939,0.62174841709,0.269434808482,0.373957721618,0.121802151822,-0.0455263096125,0.223774564559,0.122777376934,0.0718461049321,0.162691672281,-0.0988264833789,-0.069185012396,0.0175331026462],[-26846.7611109,-81.0492008967,-487.948033,-1386.40553414,1184.42903266,833.203312227,404.864439959,-656.001754622,-618.035917366,-1164.7853882,-624.343096521,183.438981414,194.858225212,208.369962559,-440.707755052,-207.782279567,248.032906286,6.41085356057,-142.029209413,-128.753476907,-112.126464211,361.780700826,-104.703166499,230.203043768,16.2508190894,102.548781411,-54.4937173849,160.267566534,-171.873236193,119.11792204,137.425315039,-22.3149522505,40.4881970602,11.6577078359,-130.378461764,-6.99830809256,59.8668344418,23.1363394798,56.3541389973,-37.0236888954,64.4564456806,-9.44885431545,-0.882982514735,11.417788396,1.1409218758,-17.7832784359,26.7061257085,-20.6041639078,-10.4033352757,10.2146177701,8.22213971081,27.3461711836,-19.6459350126,24.5963700556,1.28929083922,17.5128803038,2.64155257816,4.20615209063,-2.60837768886,2.19194258929,-12.2146148972,-1.5840115718,0.835855374692,-2.9684519508,2.46894207062,-0.904261179178,5.02112842625,-0.383660851858,7.12020543416,1.27754700836,9.51476326283,2.34349042164,3.01585569837,0.360235249131,1.79966712434,-1.90884035114,-0.885989097053,-0.0100725028261,1.68088324816,-0.615759504989,-0.896943826916,-0.857889438271,-0.426053019715,0.694719342246,-0.119364934773,1.61172823985,1.06618087989,2.34923931407,0.914855173014,2.1137376554,0.403656387126,1.11634638539,-0.424554390953,-0.452042823934,-0.0285494298346,0.249301249561,0.175870716015,0.46212633861,0.0514118221584,-0.202678977516,-0.434261846463,-0.21009052563,0.0875144777128,-0.0327708370551,0.108712458986,0.197584954258,0.777849648034,0.473557712312,0.628645107783,0.274828136183,0.391397738406,0.126085066734,-0.036905496869,0.226091871347,0.127478856485,0.0816497528996,0.161609730948,-0.10084365837,-0.071572438671,0.018538690803],[-26896.8933686,-77.9878985606,-482.558510626,-1384.0520966,1191.96118344,835.626690328,400.97679625,-662.798062899,-621.929990976,-1166.27876057,-623.20310447,173.458330945,192.349430779,210.733411469,-449.811069307,-203.667960539,245.329370143,3.56290210262,-144.540806034,-128.585036773,-108.563019502,361.192087373,-105.370161424,233.636504072,16.6569744831,102.808565188,-53.3243894023,160.364770229,-172.152715051,120.026834794,135.736879583,-23.0088894905,38.123168786,12.1627577067,-128.596029575,-6.55102799482,60.1911905416,24.5018026369,57.1641577682,-37.2477212326,64.5894911871,-10.4590000201,-0.951733490572,10.6075159992,1.45487748679,-16.8479927025,26.9929392999,-20.8052899359,-10.4435124766,10.5396168284,8.43998632423,27.7961698672,-19.6855694904,24.6787758547,1.14518983408,17.681708881,2.55781001287,4.39747661212,-2.27833834796,2.35203300831,-12.3347892474,-1.5939994414,0.920299449099,-2.99303134459,2.47638479802,-0.847767432312,5.13117144982,-0.368680035627,7.13908192564,1.32923811221,9.59216063702,2.37023062532,3.08852033052,0.438000071997,1.9437226876,-1.94089790419,-0.852124057498,-0.0141644927241,1.68502551675,-0.5753296128,-0.903210568867,-0.877861726792,-0.432455183043,0.730774814199,-0.0938827019557,1.61183779138,1.10677059936,2.37154355155,0.944796482673,2.14077354587,0.4227534264,1.17573300678,-0.424576487672,-0.43344665562,-0.0358249919542,0.259693230323,0.200198653397,0.455872029434,0.0505077580439,-0.207833781182,-0.444588695091,-0.216040620814,0.090762682153,-0.031717914581,0.110700920387,0.209668703945,0.784958305926,0.484558814641,0.634807436983,0.280076130571,0.407458115944,0.130292140283,-0.0284082228442,0.227944536172,0.132078204085,0.0906498642903,0.160393770769,-0.102996400466,-0.0736000308886,0.0196256385398],[-26945.5825215,-72.923829097,-476.370993648,-1380.72124263,1199.39401965,840.122998834,396.387213602,-669.763419275,-623.833047891,-1166.18377792,-622.308715673,162.280069353,188.726070807,213.798304814,-458.311585071,-199.616885126,242.586002932,0.323249207844,-147.530465643,-128.689253433,-104.930618148,361.463432874,-106.143047895,236.740579496,16.7412807748,102.750315476,-52.1720861565,160.39192364,-172.278317232,120.674434989,134.25253468,-23.6570142762,35.5201320108,12.5099462596,-126.655941487,-6.24664876922,60.4129853299,25.7922747318,57.9659254768,-37.4411193119,64.6548634521,-11.3527283161,-1.02246102964,9.80881106443,1.69016551299,-15.9101625343,27.2836211041,-21.0057240323,-10.495457774,10.829450391,8.63761579417,28.2164784068,-19.7384653997,24.7552701781,1.02130707925,17.8454692624,2.48887106317,4.55267824326,-1.95494797996,2.50067715157,-12.4568561322,-1.59645730621,1.00081319937,-3.0098272893,2.47861542979,-0.794290672876,5.23154591497,-0.363380690543,7.15783994806,1.37804994213,9.66364374617,2.4048934144,3.14939627002,0.512023353874,2.08002504729,-1.97565143015,-0.816822868788,-0.0202697147569,1.68601617064,-0.536411307092,-0.90642729772,-0.896629814182,-0.438712888384,0.764377269647,-0.0726933363637,1.61245161978,1.14426007401,2.39291011665,0.976037680298,2.16462780339,0.441112150539,1.22938842726,-0.425263363179,-0.41539551504,-0.0442865506014,0.269357344469,0.223349445783,0.44968088131,0.0496832822051,-0.212206900463,-0.453936603517,-0.221579644876,0.0938229716651,-0.0312758657383,0.112620811877,0.220809922491,0.791883195174,0.494986681014,0.64020767445,0.285127336353,0.421943528914,0.134402572316,-0.0202098252262,0.22928717169,0.136425424073,0.098748430701,0.159042276114,-0.10528059538,-0.0752272448361,0.0207878877855],[-26995.0782714,-64.9540854397,-468.51656829,-1375.66965675,1207.41365619,847.292386722,391.55259311,-676.565576492,-623.480456244,-1164.6227224,-621.481046439,149.804611163,184.145585656,217.466877428,-465.949764157,-195.649589901,239.71061608,-3.29335847532,-150.986256487,-129.149490716,-101.218829571,362.672050942,-107.054043065,239.502377244,16.4815924355,102.343591626,-51.0507773721,160.335052885,-172.263864438,121.039309826,133.023447231,-24.2704768326,32.709177869,12.6668127127,-124.542998839,-6.08545263175,60.517122684,27.0024024201,58.7492089009,-37.6034420601,64.6461694102,-12.1146956167,-1.1021284925,9.03275727057,1.82794957533,-14.9687327696,27.5800291422,-21.2036063515,-10.5576445317,11.0792767599,8.81442513535,28.6016429943,-19.8076696232,24.8230912178,0.917536777339,18.0022957915,2.43910012683,4.66722677482,-1.63584622408,2.63732503866,-12.5786094277,-1.59214347895,1.07594348707,-3.01770478991,2.47616896803,-0.743501160831,5.32070467597,-0.369017657702,7.17533707817,1.42328799571,9.72839852484,2.44821707435,3.19675482261,0.582551563164,2.20681051214,-2.01261802166,-0.781197171983,-0.0287161613468,1.68326481881,-0.499582825018,-0.906248822632,-0.913683752698,-0.444642192497,0.795296964221,-0.0559666593044,1.61329589725,1.1781016108,2.41305368456,1.00824225442,2.18483694134,0.458758966348,1.27655611079,-0.426529344003,-0.39826049098,-0.0541325088409,0.278023965512,0.24500547761,0.443686146835,0.0489237051487,-0.215803789224,-0.462167849278,-0.226605089584,0.0967540022985,-0.0314187934808,0.114400359648,0.230838613645,0.798556889349,0.504622533518,0.644818089944,0.289930298235,0.434658652003,0.138395562682,-0.0124856417033,0.230074390558,0.140370520791,0.105847443728,0.157553731354,-0.107692128823,-0.0764135363003,0.0220193804688],[-27047.6303205,-53.1757605226,-458.126320778,-1368.15402349,1216.70620803,857.735002967,386.929835873,-682.872287293,-620.607584169,-1161.71787612,-620.54121308,135.932370901,178.765415684,221.641364146,-472.466068374,-191.786611439,236.611021016,-7.27217429845,-154.896246813,-130.049112448,-97.4172231918,364.895255191,-108.135364085,241.909004523,15.8557639362,101.557952988,-49.974432774,160.180184085,-172.12317837,121.10004651,132.100784134,-24.8604273843,29.7203974949,12.6008962841,-122.242002973,-6.06772179839,60.4885064817,28.1268323576,59.5037748182,-37.7342484041,64.5570159955,-12.7295583352,-1.19769923971,8.29043829647,1.84939329471,-14.022648247,27.884021435,-21.3970770478,-10.6285461142,11.2842542373,8.96981136249,28.9462098215,-19.8962290435,24.8794771654,0.833773130984,18.150322812,2.41286160166,4.73659199758,-1.31867271956,2.76142668913,-12.6978430103,-1.58181627233,1.1442371738,-3.01552885142,2.46958041488,-0.695069156132,5.39710058706,-0.386845778203,7.19043089272,1.46425777057,9.78561090758,2.50093989066,3.22886729402,0.649831168265,2.32231539089,-2.05131477141,-0.746358608142,-0.0398318249161,1.67618107025,-0.465422403729,-0.902329952761,-0.928513594596,-0.450059152143,0.823304153547,-0.0438724920851,1.61409679595,1.20774751673,2.43168893047,1.04107369357,2.20093747309,0.475720280632,1.31647952134,-0.428288756676,-0.382412672225,-0.0655612697373,0.285423466966,0.264849133315,0.438021078605,0.0482143373813,-0.218629901331,-0.46914470991,-0.231014446701,0.0996144301031,-0.0321208007625,0.115967789887,0.239584781154,0.804911962015,0.513247594244,0.648610953225,0.294433560925,0.445408159895,0.142250311228,-0.00541100996361,0.230260805433,0.143763498579,0.111848894968,0.155926620858,-0.110226886508,-0.0771183610683,0.0233140585184],[-27104.9922382,-37.125716274,-444.658348862,-1357.61159633,1227.78006335,871.797748428,382.887539015,-688.477038052,-615.053204254,-1157.60125984,-619.313277202,120.636989194,172.687616904,226.24633764,-477.621530638,-188.047821219,233.207799667,-11.6041857262,-159.224093765,-131.44670194,-93.521523726,368.200719393,-109.402185951,243.961914513,14.8486677799,100.365101244,-48.9569327499,159.915543448,-171.870477847,120.844429295,131.524634968,-25.4352969232,26.5885849671,12.2858002894,-119.744390989,-6.19184097173,60.3141878009,29.1601913463,60.2196263568,-37.8345831423,64.3831662053,-13.185902846,-1.31495558872,7.59250003252,1.73869147165,-13.0717595304,28.1962498953,-21.5829062706,-10.7064808803,11.4404777016,9.10301245369,29.2450565664,-20.00669473,24.9225207039,0.769328829573,18.2877367476,2.4135913334,4.75643556964,-1.00165325195,2.87179232258,-12.812211347,-1.56620279663,1.20504257595,-3.00235362307,2.45937341496,-0.64872491213,5.45934973049,-0.417860659411,7.20217386509,1.50011679302,9.83451429397,2.56332751093,3.24419292115,0.714129771464,2.42473383798,-2.09117215898,-0.713303579858,-0.0537662826786,1.66423134845,-0.434380198403,-0.894393977586,-0.940645711182,-0.454794890299,0.848194512071,-0.0365542065298,1.61461353265,1.23265826412,2.44855504845,1.07414905416,2.2124879844,0.492011652369,1.34845593274,-0.430437362299,-0.368202420536,-0.0787061613016,0.29128633628,0.282587215909,0.432770660035,0.0475516760304,-0.220685632864,-0.474734265857,-0.234712869288,0.102452150392,-0.0333543357623,0.117259822342,0.246885260332,0.810884759202,0.520653649079,0.651546963997,0.298581297547,0.454011841617,0.145954047917,0.00085135111068,0.229803942199,0.146465107486,0.116654983566,0.154154646045,-0.112885951075,-0.0773211976687,0.0246713316238],[-27166.9330631,-18.0998906014,-428.878796398,-1344.20190455,1240.43270347,888.814531508,379.441083777,-693.676249667,-607.069706922,-1152.44384872,-617.633081603,104.185011087,165.792707949,231.295721934,-481.259468277,-184.450430354,229.472615954,-16.3033166759,-163.835810074,-133.301720429,-89.5520770658,372.617557943,-110.801515023,245.719944292,13.4732485971,98.7453074116,-48.0118003409,159.538157547,-171.521570168,120.297030659,131.290780015,-25.9926395096,23.3673461411,11.7193844335,-117.068143034,-6.44860480065,59.9898065213,30.097026773,60.8877120448,-37.9114345581,64.1290072878,-13.4880353688,-1.45495568442,6.94783721516,1.49216362499,-12.119540086,28.5125420024,-21.75238415,-10.7891471691,11.5477883382,9.21263024067,29.4943868517,-20.1396344993,24.9537324807,0.721190509578,18.4129323427,2.44101095954,4.7231866184,-0.6853581921,2.96467295872,-12.9188112674,-1.54590535225,1.26091382915,-2.9779898311,2.446026183,-0.604438655736,5.50672110056,-0.462020973783,7.21039805527,1.52943070435,9.8745319436,2.63375503129,3.24194266544,0.775799510595,2.51209139059,-2.13127421175,-0.682567535859,-0.0699554510142,1.64710933496,-0.406394036319,-0.882438107877,-0.949751749957,-0.458740794803,0.869865389501,-0.0340493765298,1.61473750253,1.25232698657,2.46348930821,1.10689966416,2.21913535056,0.507605249227,1.37199785821,-0.432796660252,-0.355897189573,-0.0934402113317,0.295343516636,0.298024202704,0.427826797809,0.0469769647076,-0.22195114877,-0.478822809195,-0.237636155576,0.105272015535,-0.03508522756,0.118247150977,0.252604212767,0.816426716773,0.526674739105,0.653540541759,0.302300194911,0.460349943577,0.149526123167,0.00618919786172,0.228672979654,0.148379080386,0.120168738858,0.152212376524,-0.115691192879,-0.0770816155967,0.0261124805188],[-27232.7257014,2.16600959323,-411.880818767,-1328.26504639,1254.28388296,907.866012496,376.517547429,-698.89207667,-597.01288705,-1146.42635654,-615.339414376,86.9162077266,157.905823104,236.825778889,-483.243769723,-181.010984863,225.389904298,-21.3892251776,-168.572997371,-135.548848633,-85.5353843978,378.165245395,-112.263315505,247.256276915,11.7494690502,96.6809848402,-47.1524692513,159.047253045,-171.09265975,119.49162013,131.383922237,-26.5272899712,20.1149898165,10.9055725186,-114.237875014,-6.82691042066,59.5131497229,30.9318661706,61.4992167606,-37.9732768064,63.8010825539,-13.6441920846,-1.6175766286,6.36490679233,1.10916045315,-11.1703691054,28.8275191275,-21.8954308114,-10.8740883142,11.6069639089,9.29710751852,29.6907357861,-20.2951203545,24.9754776341,0.685763294239,18.5243564222,2.49391356552,4.63346613855,-0.370944057176,3.03567981728,-13.0146001921,-1.52149503716,1.31520652387,-2.94243734599,2.43000557626,-0.562240607254,5.53864691954,-0.519026160043,7.21513041989,1.55061717455,9.90513458107,2.71012491,3.22151541949,0.835213657379,2.5823714316,-2.17061834399,-0.654570686408,-0.0876568310942,1.62456552584,-0.381273662784,-0.866528034724,-0.955539677474,-0.46180331971,0.888239554362,-0.0363691264927,1.61439314534,1.26625498305,2.47635349835,1.13871041943,2.22054851926,0.522462391048,1.38667162082,-0.435169584486,-0.345743705973,-0.109571372572,0.297326065152,0.310988989587,0.423033129432,0.0465426336456,-0.222401556209,-0.481301434903,-0.239727765088,0.108068117165,-0.0372776504602,0.118908963316,0.256612631613,0.821493043051,0.531155469204,0.654494535952,0.305512568246,0.464317826525,0.152993917513,0.0105029054377,0.226840009821,0.14941989586,0.122293397726,0.150069598951,-0.118669679201,-0.0764792070889,0.0276642536977],[-27301.643059,21.9362774077,-394.757571352,-1310.1411201,1268.9533564,928.032851679,374.04400724,-704.546673591,-585.238539517,-1139.72949708,-612.271063615,69.1703502598,148.852096655,242.872770363,-483.438323409,-177.746030764,220.944099119,-26.8815692618,-173.277257284,-138.122767271,-81.4979469085,384.863256304,-113.717551598,248.644095437,9.69729180154,94.1545468803,-46.3923731852,158.442056605,-170.59995101,118.461967237,131.788764593,-27.0340831352,16.8898247929,9.84828834713,-111.278202835,-7.31565496724,58.8820044859,31.6592370721,62.0453253825,-38.0285840422,63.4059353147,-13.6626091742,-1.80269552303,5.85216571199,0.589032654571,-10.2286257805,29.1358026415,-22.00196638,-10.9588476496,11.6187821756,9.35488708234,29.8306384785,-20.4732242992,24.9901213024,0.659452306794,18.6204558106,2.5710922368,4.48389512482,-0.0595673643533,3.08042411798,-13.0965355415,-1.49354294932,1.37127625055,-2.89569603824,2.41177845197,-0.522160986987,5.55455940975,-0.588575656917,7.21639791558,1.56209387362,9.92579293099,2.7903396053,3.18231007588,0.892745483535,2.63355734391,-2.20820197,-0.629733241767,-0.10612792409,1.59635041714,-0.358828823101,-0.84672944922,-0.957717460284,-0.463888919075,0.903239775178,-0.0435245808262,1.61350490086,1.2739435525,2.48700940745,1.16896621581,2.21639643819,0.536544397675,1.39204354367,-0.437359068951,-0.337988696371,-0.126907597767,0.296965038945,0.321310472445,0.418233292404,0.0463011130769,-0.222011962345,-0.482061237964,-0.24093115735,0.110834546913,-0.0398957787675,0.119224446879,0.258781510026,0.82603894636,0.533940444259,0.65431179602,0.308140732781,0.465810851211,0.156384811489,0.0136928489868,0.224277124726,0.14950203249,0.122932197054,0.147696099982,-0.121848477324,-0.0755935643821,0.0293533996551],[-27372.9580421,39.4752059399,-378.602209533,-1290.17022391,1284.06087835,948.395709344,371.94754048,-711.062194962,-572.102459202,-1132.5339841,-608.266817413,51.2872098339,138.456662888,249.472958219,-481.707017767,-174.672114076,216.119634836,-32.8000069587,-177.790191443,-140.958157063,-77.4662657847,392.731065222,-115.094187505,249.956582913,7.33667951362,91.1484068819,-45.7449458469,157.721794891,-170.059648367,117.241841511,132.490010044,-27.5078538293,13.7501598701,8.5514557213,-108.213742404,-7.90373557588,58.0941578903,32.2736670105,62.5172227888,-38.0858304203,62.950108881,-13.5515228186,-2.0101894695,5.4180709221,-0.0688690723202,-9.29868930282,29.4320139157,-22.061910981,-11.0409685088,11.5840209002,9.38441172724,29.9106300377,-20.6740183364,25.0000286241,0.638662670484,18.6996773326,2.67134005881,4.27109457191,0.247615369195,3.09451708057,-13.161574736,-1.46262018668,1.43247859967,-2.83776577834,2.39181166738,-0.48423001524,5.55389079345,-0.67036890313,7.21422749897,1.56227847155,9.93597771796,2.87230157546,3.1237255272,0.948768260785,2.66363251039,-2.24302250409,-0.608475412198,-0.124626231173,1.56221450493,-0.338869262576,-0.823108042456,-0.955993064938,-0.464904046951,0.914788820474,-0.0555268639383,1.61199720885,1.27489399388,2.49531882411,1.19705194917,2.20634805505,0.549812588949,1.38767994981,-0.439168047599,-0.332878887404,-0.145256839661,0.293991495132,0.328817547163,0.41327092423,0.0463048332341,-0.220757474337,-0.480993313357,-0.241189791885,0.113565396414,-0.0429037867867,0.11917278919,0.25898184116,0.830019635024,0.534874269151,0.652895171407,0.310107003743,0.464724378385,0.159726185628,0.0156594036572,0.220956416393,0.148539968856,0.121988373727,0.145061666275,-0.125254654531,-0.0745042797129,0.0312066668856],[-27445.8557523,53.4694605501,-364.147059809,-1268.62134738,1299.38936407,968.193057842,370.114070401,-718.734176449,-557.931914776,-1124.95730272,-603.207154217,33.5737977066,126.630937776,256.616879504,-477.962075221,-171.81314183,210.908808858,-39.1613579807,-181.966180202,-143.964301672,-73.4591968285,401.763231343,-116.334594714,251.245755339,4.68560577853,87.6509043285,-45.2212299282,156.889083768,-169.481714852,115.868372086,133.467894715,-27.9455747684,10.7472787728,7.02342175694,-105.06604787,-8.58051451815,57.1491422134,32.7709702257,62.9073627144,-38.1529355346,62.4425519086,-13.3196938832,-2.23906820489,5.07039551074,-0.863560403998,-8.38424455016,29.710732552,-22.0678658425,-11.1178391189,11.5037861944,9.38482334505,29.9279489665,-20.8976908131,25.0077476346,0.620509638516,18.7609999089,2.79366521426,3.99229689379,0.549835034862,3.07417623625,-13.207625455,-1.42929515034,1.50172601757,-2.76859270448,2.37050037263,-0.448398954029,5.53621350494,-0.76416636926,7.20864141202,1.54995358936,9.93541543709,2.95418802277,3.04523991444,1.0037345857,2.67096286346,-2.27435852798,-0.591198530494,-0.142518130644,1.52208272458,-0.321164101327,-0.795747203347,-0.950130384745,-0.464745164541,0.922818747298,-0.0723880281627,1.60976544209,1.26874879516,2.50119465404,1.22242671886,2.19012489454,0.562283623477,1.3732734489,-0.440435750177,-0.330619603391,-0.164436266424,0.288235099713,0.333389124089,0.40799800587,0.0465894874729,-0.218622925325,-0.478006125801,-0.240456848883,0.11625376674,-0.0462708678554,0.118724234712,0.257120091784,0.833401205497,0.533826478531,0.650159066699,0.311360772557,0.460982781934,0.163044127777,0.0163207952568,0.21686411884,0.146472511131,0.119390754182,0.142141487638,-0.128913040786,-0.073284134111,0.0332464023071],[-27519.1700739,64.295195648,-350.681133137,-1245.47904527,1315.37437151,987.294617774,368.264904191,-727.351678264,-542.940070081,-1116.86402334,-597.139313883,16.2060855769,113.631464045,264.112172017,-472.309054161,-169.222465108,205.33537054,-45.9710887689,-185.710718821,-146.948896549,-69.4650143058,411.854652419,-117.425773846,252.478960479,1.75408790722,83.6740832362,-44.8227040705,155.960095923,-168.851147958,114.392126516,134.684787387,-28.3527702175,7.9043649272,5.2902268239,-101.844426347,-9.33721460992,56.0534705207,33.1521077862,63.2132743199,-38.2356007342,61.9018344325,-12.9779819723,-2.48487200651,4.81417712664,-1.78752251655,-7.48619914424,29.9663710772,-22.0231566035,-11.1862272786,11.3804975704,9.35806021458,29.882647343,-21.1448954508,25.0165579581,0.60494898396,18.8055308447,2.93793627488,3.64718018135,0.847872158305,3.01804436205,-13.2363964133,-1.39412545387,1.58015837431,-2.68790802575,2.34795288949,-0.414303232229,5.50166082644,-0.869972653284,7.199643038,1.52536165211,9.92485566547,3.03527512573,2.94664837214,1.05841435428,2.6554445337,-2.30261329316,-0.578228419572,-0.159605509322,1.47657776883,-0.305319958726,-0.764801112104,-0.94011702004,-0.463268761631,0.927298766798,-0.0941238375371,1.60658870542,1.2557152005,2.50475427132,1.24484643826,2.1676587896,0.574195514928,1.34902179679,-0.441146589629,-0.331250559389,-0.184299907923,0.279919954219,0.335104171414,0.40229989212,0.0471238216418,-0.21563205235,-0.473077618957,-0.238724391189,0.118888796719,-0.049986291444,0.11781325568,0.253244623119,0.83619330676,0.530766326134,0.646064107054,0.311959735431,0.454626488285,0.166359555028,0.0156666522321,0.212043034058,0.143335775846,0.115170523071,0.138932366495,-0.132839516783,-0.0719786637776,0.0354773465321],[-27591.6470867,72.7509379058,-337.13261159,-1220.65676366,1332.61461929,1005.7279218,366.080195018,-736.577141753,-527.311562755,-1108.0554877,-590.152226617,-0.672714745829,99.8010661054,271.720748747,-464.901846969,-166.960796004,199.430932226,-53.2318274462,-188.942081281,-149.69424009,-65.4643470979,422.875310841,-118.366132808,253.602379041,-1.44984585962,79.2359137545,-44.5484559029,154.954393244,-168.146703792,112.867031961,136.098590008,-28.7371023292,5.23757668441,3.38233460555,-98.5551231912,-10.1655238032,54.8154010747,33.4193274672,63.4337556226,-38.3389728072,61.3489318322,-12.5377713747,-2.74227378674,4.65376955863,-2.83160296095,-6.60476639281,30.1933002491,-21.9337900058,-11.2427456798,11.21690289,9.30675971136,29.7754806394,-21.4164023144,25.0299221156,0.592646609851,18.8349095412,3.10423690967,3.23603394474,1.14289467375,2.92537054649,-13.2505465848,-1.35766601397,1.66847239581,-2.59538921897,2.32420583259,-0.38149932043,5.45050625217,-0.987853385032,7.18723104553,1.48911003588,9.90530375068,3.11511380687,2.82782528322,1.11365678738,2.61735620124,-2.32847121857,-0.569872024882,-0.175799131156,1.42649676972,-0.290902828957,-0.730441646761,-0.925996497918,-0.460321335157,0.928207378645,-0.120750984026,1.60221703669,1.23614164309,2.50616616714,1.26414122425,2.13893415016,0.585841615737,1.31524903591,-0.441321274696,-0.334770068139,-0.204711009449,0.26936876906,0.334091671786,0.396070281236,0.0478598447125,-0.21181831843,-0.466203106226,-0.235994202312,0.121458634619,-0.0540443460558,0.116365381268,0.247439270003,0.838416475926,0.525687995462,0.640582472774,0.311988664768,0.445724937005,0.169692091786,0.0137044536893,0.20655010603,0.139190207122,0.1093844546,0.135436508422,-0.137047725899,-0.0706265937071,0.0378998385963],[-27662.0328705,79.6352139954,-322.429677243,-1194.06794863,1351.70882605,1023.52050259,363.240096051,-746.073008264,-511.231030433,-1098.33303753,-582.334822628,-16.919391452,85.4825683701,279.204522681,-455.894346028,-165.088846613,193.22710626,-60.9462021358,-191.578541569,-151.98263069,-61.4378240862,434.695189,-119.154079507,254.562191732,-4.91816728133,74.3543660327,-44.3975730543,153.891537621,-167.347138462,111.34701558,137.667204524,-29.106233256,2.76307239571,1.33020878525,-95.2043837589,-11.0571300498,53.4431921381,33.5748770442,63.5676046398,-38.4681985416,60.8048194875,-12.0104463792,-3.00594645801,4.59352659557,-3.98664928821,-5.7401596036,30.3858908252,-21.8057727913,-11.2840070146,11.0157500153,9.23355921095,29.6072043277,-21.712981469,25.0513026285,0.584268419228,18.8507753995,3.29265078764,2.75914769413,1.43607051541,2.79540387808,-13.2527349432,-1.32047174733,1.76736480802,-2.49071376094,2.29929581659,-0.349543689219,5.38302327635,-1.11787419433,7.17140410318,1.44180611674,9.87776504031,3.19325498873,2.6886450306,1.17031110583,2.55697654619,-2.35261672314,-0.566436291873,-0.191009760095,1.3726368593,-0.277478706204,-0.692840685353,-0.907812345471,-0.455749382053,0.925523082512,-0.152286159592,1.59640047377,1.21037655612,2.50559883269,1.28014119372,2.10393538618,0.597515278338,1.27227920869,-0.440980514117,-0.341176442383,-0.225532816297,0.256904254651,0.330480607857,0.389202871472,0.0487495656567,-0.207215186585,-0.457377901006,-0.232268065762,0.123951428709,-0.0584393201941,0.114306140654,0.239787867269,0.840091250107,0.518585670019,0.633686344163,0.311532332968,0.434347567657,0.173061362455,0.0104416787347,0.200442278738,0.134096249082,0.102089322977,0.131656118996,-0.141551311509,-0.0692666488936,0.0405142175356],[-27729.073505,85.746550589,-305.500512168,-1165.62604625,1373.25571039,1040.6998928,359.424760462,-755.501719144,-494.883110752,-1087.49801459,-573.776032124,-32.3907327323,71.0187952511,286.325406805,-445.440443717,-163.667329027,186.755504984,-69.1168409606,-193.538373666,-153.596366746,-57.3660741522,447.184269289,-119.788021849,255.304579258,-8.64284811723,69.0474102202,-44.3691431537,152.791090942,-166.431208074,109.886004533,139.348532881,-29.4678251505,0.497010412328,-0.835686953648,-91.7984534063,-12.0037213018,51.9451019735,33.6210042924,63.6136193885,-38.6284247256,60.2904727781,-11.4073912745,-3.27056293272,4.63780202632,-5.24350904929,-4.89259208436,30.5385135633,-21.6451117018,-11.3066239748,10.7797868082,9.14109608888,29.3785738801,-22.0354029795,25.0841620178,0.580480315127,18.8547678208,3.50326157778,2.21681093965,1.72856761751,2.62739344533,-13.2456204624,-1.28309757067,1.8775323369,-2.37355912846,2.27325945615,-0.317992809186,5.29948539319,-1.26010071102,7.15216087958,1.38405727077,9.84324488195,3.26924959384,2.52898199722,1.22922653049,2.47458424867,-2.3757342258,-0.568228165993,-0.205148160087,1.31579516962,-0.264613584651,-0.652170105913,-0.885608089793,-0.449399399254,0.919224378069,-0.188746056199,1.5888890545,1.17876837278,2.50322075917,1.29267646355,2.0626469076,0.609509855165,1.22043635755,-0.440145016635,-0.35046799486,-0.246628573757,0.242849121403,0.324399962276,0.381591361084,0.0497449934459,-0.201856119832,-0.446597316696,-0.227547765049,0.126355327257,-0.0631655023621,0.111561063013,0.230374249754,0.841238166416,0.509453533308,0.625347901521,0.310675512436,0.420563819805,0.176486991439,0.00588580647456,0.193776496165,0.128114345847,0.0933419024064,0.127593403791,-0.146363916991,-0.0679375543315,0.0433208223859],[-27792.0055439,91.7336660554,-285.670773986,-1135.38653312,1397.55079782,1057.29971145,354.414713514,-764.588909466,-478.442336862,-1075.41905591,-564.589512055,-46.9687993486,56.6983998323,292.866371809,-433.734644091,-162.724875507,180.057237245,-77.7488365226,-194.761823322,-154.357236593,-53.2339714605,460.199557271,-120.27297358,255.796506002,-12.6063361098,63.3442731584,-44.4670921132,151.669654128,-165.377839134,108.527620874,141.098167982,-29.8342928444,-1.54600853101,-3.08671362615,-88.3466094395,-12.9961201434,50.3316640983,33.5609453176,63.5707015724,-38.82224105,59.8225743346,-10.7401211539,-3.53411279524,4.78835604802,-6.59115364347,-4.06406255299,30.6461964474,-21.4584003666,-11.3077598855,10.5123221493,9.0318089179,29.0910893132,-22.3833692395,25.1311043287,0.582069403539,18.8478793197,3.73528813358,1.61072433591,2.02113594872,2.42114211227,-13.2317145235,-1.24588887437,1.99958201933,-2.24388786651,2.24625905413,-0.286406123751,5.20031024123,-1.41427819731,7.12959013403,1.31664669419,9.80255440463,3.34260825721,2.34914681679,1.29112737903,2.37083463137,-2.39845736518,-0.575451429492,-0.218129294495,1.25668650064,-0.252043896955,-0.608623745193,-0.859472626311,-0.441121767343,0.909360787237,-0.230022095326,1.57946888252,1.14176252913,2.49918687218,1.30162927118,2.01517713379,0.622094457031,1.16018001965,-0.43888073942,-0.362611566762,-0.267880542544,0.227516677566,0.315980657749,0.37317532183,0.0507861193458,-0.195787184626,-0.433892168204,-0.221850710607,0.128662091639,-0.0682075514559,0.108076786064,0.219312553529,0.841890445205,0.49832828021,0.615573708624,0.309502524351,0.404489501202,0.179978588467,5.1243837987e-05,0.186599700716,0.121311019079,0.0832090294352,0.12325399544,-0.151492963476,-0.0666703474152,0.0463162269554],[-27852.0274353,97.646045551,-263.856022501,-1103.973008,1423.67684125,1073.377923,348.391968862,-773.312989204,-462.042823979,-1062.23397978,-554.987826341,-60.6367423485,42.5933498848,298.694619191,-421.133897888,-162.161798975,173.211397903,-86.857139338,-195.277023338,-154.244988336,-49.0433713076,473.546151196,-120.640371811,256.088071058,-16.7529829341,57.3192084553,-44.7146989774,150.53198422,-164.166639731,107.274266249,142.862466543,-30.2370618863,-3.35761416573,-5.40153104082,-84.8702569631,-14.0216876879,48.6225130494,33.4018895461,63.4381676411,-39.042008817,59.4006357924,-10.0206743276,-3.80785231782,5.03657449093,-8.01104986312,-3.26371136798,30.7065963658,-21.254579965,-11.2867806046,10.2189089925,8.90734105956,28.749228822,-22.7523119573,25.1912997019,0.590307602277,18.8285148642,3.98449004643,0.948233115344,2.31285361547,2.17866784495,-13.2129381379,-1.20835294367,2.13376213608,-2.10280279269,2.21895966621,-0.254354967657,5.0864920362,-1.578870445,7.10414098863,1.24106086386,9.75572786315,3.41268046371,2.15119512621,1.35623835638,2.24788958727,-2.42121665869,-0.587897211822,-0.229884924333,1.19569632395,-0.240187829658,-0.562483274803,-0.829676323791,-0.430782401508,0.896265920923,-0.2755046165,1.56807032462,1.10019247275,2.49359783499,1.30709033631,1.96213052167,0.635441228264,1.09251171105,-0.437434633365,-0.377448113086,-0.28924704506,0.211182622741,0.305361377206,0.364077819485,0.0517648637969,-0.189104861172,-0.419435276483,-0.215256820575,0.130877935662,-0.0735116079415,0.103884381692,0.206838119603,0.842132039794,0.485416651115,0.604507863137,0.308095884995,0.386425892349,0.183505704555,-0.00701989095394,0.178918828473,0.113777100598,0.0717977899672,0.118657234791,-0.156920983116,-0.065465315141,0.0494819441422],[-27910.828101,103.383365929,-241.369293064,-1072.15110013,1450.41340046,1088.99857825,341.638912254,-781.715562058,-445.808582831,-1048.14789979,-545.208265645,-73.4029853508,28.7214418515,303.698408149,-408.035767516,-161.846332516,166.306578321,-96.4591644019,-195.134078281,-153.278860019,-44.8003742733,487.016172488,-120.928259489,256.250157193,-21.0176162483,51.057726411,-45.140081074,149.379877289,-162.777388355,106.118037197,144.585476238,-30.7123105038,-4.93099383979,-7.76062370459,-81.3938330317,-15.0669196806,46.8395586184,33.1520147345,63.2154377302,-39.2775322316,59.0198760376,-9.26121991055,-4.10635444469,5.37124959363,-9.48278834886,-2.50246429798,30.718027433,-21.0431785636,-11.2436026233,9.90566131048,8.76913707263,28.3582151458,-23.1365951696,25.2630598019,0.606588032108,18.7944325359,4.24576209225,0.238093654817,2.60238075862,1.90254238494,-13.1910647239,-1.1697875375,2.28023127884,-1.95169179274,2.19215203629,-0.221413648477,4.95916913815,-1.75202087829,7.07635265623,1.15896207675,9.70260529375,3.47877541067,1.93761881319,1.42465926428,2.10828765191,-2.44439184343,-0.605253479238,-0.240351010032,1.13312777902,-0.229634007776,-0.51405232507,-0.796534919334,-0.418251100585,0.880344412284,-0.324458688765,1.55465981336,1.05498865408,2.48654074528,1.30920249916,1.90423553759,0.64969807157,1.01856844255,-0.436098897794,-0.394787117279,-0.310705419127,0.194113254365,0.292682743635,0.354467793329,0.052561129534,-0.181918233108,-0.403434963992,-0.207861640017,0.133012686242,-0.0790141826779,0.0990360303263,0.193216590223,0.842059586745,0.470967897791,0.5923288462,0.306537659429,0.366720641933,0.187027876043,-0.0152785518572,0.170730813938,0.105609499764,0.0592253322457,0.113825889745,-0.16262428582,-0.064315056905,0.0527957216166],[-27970.0964628,108.845304043,-219.523621025,-1040.68643881,1476.54003524,1104.22572801,334.437929439,-789.838231729,-429.863624148,-1033.36592954,-535.48812063,-85.2759519744,15.1004721755,307.765997882,-394.837815385,-161.646709217,159.431369863,-106.572326709,-194.383092718,-151.478089685,-40.5110809374,500.401742568,-121.174679563,256.353647178,-25.3350637106,44.6453373257,-45.7713557305,148.215129406,-161.189863495,105.051030259,146.211244739,-31.2962169246,-6.25933490113,-10.1444761244,-77.9417746998,-16.1183118673,45.004710597,32.8194986394,62.9019319757,-39.5186154988,58.6755139567,-8.47392701736,-4.44419212006,5.78117359466,-10.9859597413,-1.79124711166,30.6788037637,-20.8337242293,-11.1781424325,9.57869307586,8.61864151585,27.9232710242,-23.5305829131,25.3446962932,0.6323038138,18.7433904161,4.51399904691,-0.510937668789,2.88837751904,1.59533747382,-13.1678677003,-1.12949041476,2.43914803934,-1.79194275242,2.16662690827,-0.187156473785,4.81947990716,-1.93187292136,7.04676434964,1.07201262987,9.64302673266,3.54020229542,1.71090976543,1.49648990448,1.95456736085,-2.46836265649,-0.627208197992,-0.24946351202,1.06928400534,-0.220971056323,-0.463634526322,-0.76036415004,-0.403397663408,0.862000894476,-0.376149381164,1.53920378131,1.00708152358,2.47810270073,1.3081086,1.84222064789,0.665012889656,0.939487224957,-0.435165732029,-0.414438062786,-0.332233002567,0.176574869876,0.278085380021,0.34451418264,0.0530548192916,-0.174336384076,-0.386099553194,-0.199760713996,0.135076170295,-0.0846517865239,0.0935839123946,0.178713607633,0.841769722617,0.455231272006,0.579215138951,0.304909912714,0.345721398641,0.190504639271,-0.0246756928278,0.162032591613,0.0969051259376,0.0456088045142,0.108782728207,-0.168579181495,-0.0632121721039,0.0562353070491],[-28031.5214427,113.931536745,-199.632041735,-1010.34465328,1500.83630536,1119.1234231,327.071406166,-797.722601915,-414.331958661,-1018.09318261,-526.064681957,-96.2640658382,1.74823729959,310.78564759,-381.937603904,-161.431162166,152.67436389,-117.214041255,-193.074171217,-148.861915379,-36.1815918795,513.494982861,-121.417674984,256.469423779,-29.6401529792,38.1675514993,-46.6366402748,147.039536643,-159.383843637,104.065341974,147.68381972,-32.0249593766,-7.33582469772,-12.5335728073,-74.5385190219,-17.1623599932,43.1398787768,32.4125190174,62.4970705135,-39.7550628236,58.3627684359,-7.6709647628,-4.83593828818,6.25513873259,-12.5001546812,-1.14098557764,30.5872394723,-20.6357450288,-11.0903165234,9.2441182612,8.45729894798,27.4496191966,-23.9286392246,25.4345208406,0.668848068121,18.6731465863,4.78409568631,-1.29010447859,3.16950403762,1.25962485314,-13.1451204855,-1.08675933441,2.61067100927,-1.6249435575,2.14317502605,-0.151157751155,4.66856270325,-2.11656999842,7.01591528169,0.981874820207,9.57683221613,3.59627031529,1.4735598706,1.57183007873,1.78926724964,-2.49350883499,-0.653449334337,-0.257158390725,1.00446814241,-0.214787600314,-0.411533508885,-0.721479753008,-0.386091888815,0.841640000655,-0.429841762738,1.52166866102,0.957401531678,2.46837079903,1.30395147906,1.7768143189,0.681533585227,0.856405069062,-0.434927335394,-0.436210433054,-0.353807133205,0.158833766711,0.261709909351,0.3343859267,0.0531258358043,-0.166468397716,-0.367637366548,-0.191049587577,0.137078214736,-0.0903609303381,0.0875802083253,0.16359481408,0.841359083973,0.438456025526,0.565345222529,0.303294709908,0.323775811163,0.193895530579,-0.0351622678216,0.152821096003,0.0877608884783,0.031065355016,0.10355051808,-0.17476198005,-0.0621492601339,0.0597784481101],[-28095.9471617,118.536485644,-182.604263192,-981.696912796,1522.3244391,1133.75057439,319.781628932,-805.435599512,-399.350642938,-1002.52496989,-517.100744743,-106.376638181,-11.2837984515,312.673891468,-369.657678881,-161.102391628,146.098537247,-128.376396716,-191.256986378,-145.453754788,-31.8042108073,526.107919532,-121.678853618,256.660687316,-33.8781830908,31.7050964363,-47.7516228954,145.849120757,-157.344962234,103.160403028,148.959712358,-32.9231676024,-8.15416067364,-14.9057491002,-71.202160948,-18.1845867303,41.2662887207,31.942378786,62.0007060787,-39.9769135609,58.077691976,-6.8628076378,-5.29225119421,6.78268027972,-14.00670461,-0.558892599859,30.4420592325,-20.4568410672,-10.9800144652,8.90823563724,8.28687486969,26.9424732253,-24.3249522285,25.5305358044,0.716809830018,18.5820651263,5.05155981048,-2.09070271331,3.44493071826,0.898148192122,-13.1241018848,-1.04114157629,2.79466098369,-1.45213282475,2.12253665097,-0.113023896996,4.50766957145,-2.30432305933,6.98405305618,0.890105984452,9.50391206234,3.64634644363,1.22805088196,1.65077533104,1.61473522797,-2.52005216167,-0.683651189455,-0.263399531127,0.938988967315,-0.211409057875,-0.358058931451,-0.680206044021,-0.366319221338,0.819685513712,-0.484799689807,1.50197681729,0.90681937187,2.45739398973,1.29689323242,1.70869947524,0.699372580598,0.770413358754,-0.43558849487,-0.459896201644,-0.375406893263,0.141150719713,0.243732791373,0.32421000791,0.052687502865,-0.158430358946,-0.348257272077,-0.181841539454,0.139023848833,-0.0960914014062,0.0810788974481,0.148110799208,0.840890196375,0.420880508432,0.550888124407,0.301764343089,0.301212469536,0.197173425184,-0.0466725847058,0.14311098665,0.0782774273029,0.0157311092909,0.0981504237749,-0.181144708354,-0.0611274076303,0.0634010476942],[-28160.8385385,122.533551363,-167.73668398,-954.536546426,1540.99733862,1148.14553307,312.650487223,-813.145444199,-385.108916906,-986.817391339,-508.461121918,-115.626530723,-23.8094992265,313.460363709,-358.020519717,-160.700966589,139.664408696,-139.950176491,-188.979482948,-141.29374417,-27.3160539389,538.132197728,-121.914083009,256.959908301,-38.0363385955,25.3195684595,-49.0822752252,144.616806246,-155.082272588,102.364980687,150.045287849,-33.9692774047,-8.71008065762,-17.2282437112,-67.9254270102,-19.1666224553,39.4024290764,31.432881506,61.4144218041,-40.1751476648,57.8196715369,-6.05315163813,-5.80813028722,7.35630564328,-15.4939041733,-0.0373296232945,30.2436299541,-20.2969006038,-10.8470181391,8.57808316737,8.11041854923,26.4070099637,-24.7130063999,25.6295063293,0.77356179117,18.4709341088,5.31435131593,-2.90423757399,3.71586901709,0.514338870595,-13.104112249,-0.993182504047,2.98978757108,-1.27515209501,2.10525011419,-0.0724897630624,4.33850729663,-2.49361315665,6.95025884086,0.797843618071,9.42435771727,3.69002875778,0.976824014812,1.73340417454,1.43255670213,-2.54758260196,-0.717433404249,-0.2682625164,0.873177807556,-0.210108019572,-0.303544566159,-0.636901653591,-0.344527688291,0.79663781548,-0.540282167786,1.4798743437,0.855966709754,2.44506862983,1.28717297948,1.63837687471,0.718500376518,0.682420970285,-0.437004348075,-0.485217302563,-0.397018342561,0.123764413349,0.224473832883,0.313945581179,0.0517868284999,-0.150366357803,-0.328170320044,-0.172320782846,0.140898911263,-0.10184609272,0.0741411546984,0.132451942264,0.840289141399,0.402699464046,0.53597505739,0.300352012396,0.278283729199,0.200364553813,-0.0590743669919,0.132987823261,0.0685703045541,-0.000181897935971,0.0925971957428,-0.18768226113,-0.0601816501836,0.0670716295929],[-28222.815691,125.790879283,-153.92237533,-928.462423215,1557.09057458,1162.34151037,305.719771272,-821.045678847,-371.809066329,-971.116744214,-499.936130866,-124.027492803,-35.6090612923,313.202973499,-346.973589209,-160.301923212,133.306882482,-151.800837662,-186.289173708,-136.426199428,-22.6404406206,549.479367338,-122.062795616,257.391874796,-42.1122754221,19.0677810961,-50.5821397581,143.309743294,-152.610682964,101.715176362,150.959374892,-35.1301761011,-8.9998325745,-19.4656461883,-64.6947016363,-20.0891244715,37.5661042626,30.910955899,60.740233422,-40.3409802395,57.5889276926,-5.24399813572,-6.37466031721,7.96926526426,-16.9517888174,0.435054771798,29.9927291062,-20.153883936,-10.6910825047,8.26088361313,7.93130019679,25.8483970879,-25.0861103012,25.7278882559,0.835672557434,18.341147605,5.57104312335,-3.72226657729,3.9840406533,0.111800196022,-13.0839573155,-0.943677002238,3.19442258326,-1.09569364018,2.09180326432,-0.0293223099427,4.1628963486,-2.68298886863,6.91332219443,0.706120256224,9.33831090882,3.72697311113,0.722310350035,1.8197908646,1.24412645258,-2.57553216689,-0.754401954547,-0.271850854268,0.807371628241,-0.209893869085,-0.248330213516,-0.59193379091,-0.321280962685,0.773016437527,-0.595546989369,1.45506326608,0.805415453965,2.43125292823,1.27504909549,1.56630173334,0.738851993346,0.593291152995,-0.438942620281,-0.511878159932,-0.418629285322,0.106908009491,0.204288677438,0.303509844538,0.0505042417936,-0.142427485604,-0.307588106272,-0.162689264604,0.142684443057,-0.107641173698,0.0668299539134,0.116793569893,0.839447889619,0.384096734005,0.520727780621,0.299081144984,0.255222886941,0.203508486068,-0.0722186921022,0.122554890585,0.058758812931,-0.0164426546434,0.0869039809434,-0.194325250061,-0.059355510623,0.0707568728221],[-28278.4987373,128.176614782,-140.054408475,-903.073412205,1570.83971762,1176.37171754,299.031271312,-829.329846332,-359.653376973,-955.569325765,-491.316088969,-131.593273761,-46.4626809159,311.959630027,-336.464350156,-159.980297663,126.960862848,-163.793837308,-183.233571438,-130.895436461,-17.7006901985,560.060978253,-122.064423902,257.981374864,-46.1036494992,13.0065478734,-52.204758988,141.895082084,-149.945101628,101.247091463,151.72080219,-36.3727510093,-9.01966434916,-21.5825460795,-61.4963692537,-20.9327500818,35.7751186983,30.4035306868,59.9801566645,-40.465626389,57.3856810174,-4.43734850254,-6.9829260342,8.61480958362,-18.3703939889,0.869612005164,29.6901341577,-20.0257513614,-10.5119625213,7.96385973608,7.75289002253,25.2718022743,-25.4375724953,25.8221374248,0.899710734668,18.194099686,5.82020815339,-4.53634723985,4.25116734607,-0.305864524127,-13.0624428217,-0.893419955432,3.40693783204,-0.91544973211,2.08268394996,0.0167115017741,3.98265719718,-2.87099877352,6.87203267563,0.615968434074,9.24591336491,3.75683535703,0.466940968483,1.91000965661,1.05083925975,-2.60333286754,-0.794162816179,-0.274268052455,0.741907394474,-0.209775990093,-0.192755674027,-0.545669665171,-0.29714271753,0.74934091142,-0.649851947247,1.42724561023,0.755737513137,2.41580509378,1.26077995569,1.49292926722,0.760362451438,0.503887156227,-0.441171036765,-0.539583197872,-0.440227525764,0.0908146700094,0.183532968596,0.292819996017,0.0489201718306,-0.134764833664,-0.286722226585,-0.153148931577,0.144361485243,-0.113492813759,0.0592082689299,0.101311008742,0.838258411615,0.365256159945,0.505268053238,0.297975168009,0.232263239554,0.206644791554,-0.0859566374594,0.111915473369,0.0489622451327,-0.03282014881,0.0810839263364,-0.201024286831,-0.0586925117778,0.0744234563975],[-28324.5077952,129.558903239,-125.025854645,-877.968382438,1582.48033841,1190.26936583,292.626777576,-838.191489525,-348.844134605,-940.321433243,-482.391313611,-138.337622936,-56.1505543642,309.788242481,-326.440265359,-159.811126105,120.561254036,-175.794632513,-179.860188921,-124.745771172,-12.4201220186,569.788580362,-121.858400327,258.753196566,-50.0081167556,7.19268231864,-53.9036754088,140.3399728,-147.100436845,100.996827401,152.348398441,-37.6638894468,-8.76582390645,-23.5435329331,-58.3168142903,-21.6781565894,34.0472768022,29.9375345911,59.1362072637,-40.5403012174,57.2101520856,-3.63520411054,-7.62401218821,9.28618904234,-19.739755134,1.27769349655,29.3366225776,-19.9104631777,-10.3094131484,7.69423429776,7.57855823661,24.6823931991,-25.7607015447,25.9087096764,0.962244928731,18.031184423,6.06041932672,-5.33803707831,4.51897081457,-0.735051982383,-13.038374505,-0.843206248198,3.62570512925,-0.736112642681,2.07838001973,0.0658447114988,3.79961031221,-3.05619144954,6.82517984316,0.528420686783,9.14730681347,3.77927134884,0.213146951018,2.00413480595,0.854089904096,-2.63041671497,-0.836321964976,-0.275617618683,0.677122071362,-0.208763766274,-0.137160748195,-0.498476485567,-0.272676625839,0.726130768728,-0.702454834113,1.39612340199,0.707504795904,2.39858333538,1.24462393531,1.41871469239,0.782966771151,0.415072229322,-0.4434573228,-0.568036840503,-0.46180086811,0.0757175567775,0.162562349916,0.28179323365,0.0471150476954,-0.127529493297,-0.265784276807,-0.143901730616,0.145911078853,-0.119417182322,0.051339073585,0.0861795854553,0.836612677962,0.346361583501,0.489717634383,0.297057508625,0.209638083825,0.209813039874,-0.100139280486,0.101172856362,0.0392998938583,-0.0490833684145,0.0751501788814,-0.207729983124,-0.0582361764773,0.0780380593349],[-28358.6728302,129.942955917,-107.969991896,-852.820442271,1592.21333044,1203.91405219,286.52475485,-847.709855983,-339.535491171,-925.495391573,-473.031891273,-144.292776832,-64.5023217256,306.75600314,-316.847639127,-159.840824118,114.048716948,-187.683553789,-176.221610472,-118.03124151,-6.75332720737,578.586656465,-121.394799633,259.721640912,-53.8183448659,1.67713264388,-55.6390466646,138.615497273,-144.0937843,100.989356551,152.857172813,-38.9730862436,-8.24007996118,-25.3188211621,-55.1499294112,-22.3098555042,32.3987910659,29.5361386584,58.2117702643,-40.5575570615,57.061316221,-2.84036417618,-8.28841738463,9.97550305187,-21.0504747312,1.66824724368,28.9344283927,-19.8049997192,-10.0842399312,7.4583364224,7.41142887204,24.0855833032,-26.0490104439,25.9843317791,1.02049992479,17.8541574899,6.29019816289,-6.11944942273,4.78817873453,-1.1717450797,-13.0107211286,-0.793804988093,3.84913602926,-0.559485464423,2.07925158314,0.118190710315,3.61565366526,-3.23696690906,6.7719015618,0.444662457297,9.0428106245,3.79402959401,-0.0366522963705,2.10196440758,0.655430439092,-2.65635032751,-0.880397712243,-0.276046840009,0.613348638101,-0.206039230289,-0.0819181915129,-0.450774064048,-0.248401030091,0.703866914127,-0.752653485903,1.36153314555,0.661300350049,2.37950885657,1.2268556905,1.34417291867,0.806548731063,0.327733644818,-0.445641213604,-0.596904693222,-0.48332952581,0.0618132368186,0.141687001341,0.270370618162,0.0451933057561,-0.120847272031,-0.244991316945,-0.13513426563,0.14732070448,-0.125421589789,0.0432939528483,0.0715765566609,0.834420743817,0.32760754041,0.474206987777,0.296344377342,0.18757789552,0.213034050573,-0.114600312262,0.0904199233843,0.0298919663352,-0.0650230661969,0.0691278357986,-0.214382747031,-0.0580276115102,0.0815723178778],[-28383.663197,129.882247614,-88.9809255816,-827.599657319,1600.1008786,1216.57091646,280.650366122,-857.507011987,-331.689063348,-911.117636374,-463.426984823,-149.564920611,-71.545398374,302.967236641,-307.628141823,-160.001324935,107.386939109,-199.400425387,-172.390706539,-110.844773615,-0.779984011864,586.431420999,-120.666265691,260.8590607,-57.507048489,-3.5126141991,-57.3974910011,136.70846393,-140.950989358,101.205135136,153.246856334,-40.2802662778,-7.46628438797,-26.9011246403,-52.0196402325,-22.8277751631,30.839506271,29.2074832351,57.2157079603,-40.5152951889,56.9331677459,-2.05881929392,-8.9642956504,10.6702469055,-22.2954233868,2.04060755616,28.4916118615,-19.7024214679,-9.84145075879,7.25892068495,7.25364125317,23.4877690867,-26.2968299154,26.046814212,1.07432522524,17.6662209732,6.50786057704,-6.87492085678,5.05554260781,-1.61027155075,-12.9791035592,-0.745882174638,4.07580105672,-0.387814572492,2.0851477933,0.173384295998,3.43299523496,-3.4111309009,6.71272892045,0.366490819712,8.93345473641,3.80122921623,-0.280084067169,2.20219191474,0.45704201041,-2.68123875259,-0.925557711187,-0.27587812081,0.55090413025,-0.201475010728,-0.0275325794197,-0.40319262359,-0.224652950649,0.682875744732,-0.799905911526,1.32384925875,0.61775177994,2.35875483961,1.20781500097,1.27005763079,0.830787142625,0.242854768043,-0.447850484167,-0.625697086518,-0.504763349227,0.0491518977641,0.121035248365,0.25858866107,0.0433554115146,-0.11474284223,-0.224582263745,-0.12697176876,0.148603600969,-0.131477910496,0.0351789362205,0.0576868989091,0.83166500265,0.309231342817,0.458901395463,0.295823118076,0.166301866297,0.216253642965,-0.129103878499,0.0797079545513,0.0208623279044,-0.0805170539431,0.0630897953495,-0.220882172271,-0.0580982595042,0.0850176971808],[-28403.3580978,130.067319012,-68.392967878,-802.350332512,1606.17049062,1227.35148416,274.905448932,-867.0907285,-325.218333998,-897.190630941,-453.845526224,-154.278726599,-77.3566435045,298.535550713,-298.722285322,-160.195941206,100.545364703,-210.899944991,-168.445419108,-103.289015672,5.3889575405,593.312021308,-119.676084649,262.127321677,-61.0419540295,-8.35493657366,-59.1722418144,134.609612845,-137.700084802,101.613490344,153.513360495,-41.5679619398,-6.4738098514,-28.2887821066,-48.9573806077,-23.2356981095,29.3776752718,28.9559509924,56.158251958,-40.4127541003,56.8184557321,-1.29735790274,-9.63921486784,11.3567648671,-23.4680387389,2.39170532159,28.0176898006,-19.5948089426,-9.5871041058,7.09784802305,7.10708852716,22.8955928145,-26.4986951134,26.0942383818,1.12422651178,17.470938562,6.71167108319,-7.59934377755,5.31681989281,-2.0445453386,-12.9433056896,-0.700078030342,4.30431047884,-0.2234571627,2.09579006423,0.230940617996,3.25392050169,-3.57634060797,6.64854131408,0.295855755908,8.8204467297,3.80108199327,-0.514787329733,2.30323462024,0.26126303676,-2.70532164492,-0.970881950493,-0.275477644793,0.490101597457,-0.195116385164,0.0254585576587,-0.356414989927,-0.201724077348,0.663445030766,-0.843710163136,1.28358063781,0.577497829094,2.3365574614,1.18785792736,1.19718220726,0.855309575505,0.16144298752,-0.450284919421,-0.653885532155,-0.526044597956,0.0377471323974,0.100689952867,0.246507736582,0.0418258377562,-0.109215592467,-0.204801498136,-0.119524129207,0.149779446731,-0.137549159765,0.0271086643347,0.0446975187314,0.828345932513,0.291480996969,0.443974844064,0.295473858098,0.14602636679,0.219398886308,-0.143396738564,0.0690778290502,0.0123357584353,-0.0954649082005,0.0571209060561,-0.22711764897,-0.0584771470463,0.0883706196262],[-28421.6367347,131.188710793,-46.5404309626,-777.116772777,1610.44967423,1235.36728083,269.191840821,-875.968776485,-320.036785979,-883.716838567,-444.556447442,-158.558867121,-82.0129163126,293.574553084,-290.0705815,-160.327985578,93.4934379111,-222.136810286,-164.463690163,-95.4666158712,11.6425474224,599.217604739,-118.427542659,263.48828959,-64.3907878925,-12.8282128432,-60.9565325006,132.309684091,-134.369103418,102.183749361,153.652596791,-42.81870562,-5.29202901604,-29.4801322997,-45.9945843903,-23.5374068872,28.0215509226,28.7859246016,55.0496338639,-40.2491722959,56.7099292514,-0.562768441579,-10.3007429193,12.0214012004,-24.5617584259,2.71847142755,27.5221790263,-19.4742426619,-9.32725844702,6.97697937434,6.97366384118,22.3156967513,-26.6491411922,26.1246856953,1.17070946611,17.2718739454,6.89989419537,-8.28761058213,5.56776804794,-2.46848038635,-12.9031114124,-0.657032777718,4.5332745628,-0.068770430861,2.11089980997,0.290374825755,3.08071494583,-3.7302532132,6.58021813765,0.234707247767,8.70499418487,3.79379970289,-0.738401052421,2.4035098169,0.0704319368543,-2.72883865921,-1.01545041884,-0.275211595667,0.431254089372,-0.187008631168,0.0765176892963,-0.31112398879,-0.179906100021,0.645862542455,-0.883564292887,1.24123617896,0.541177241026,2.31315289888,1.1673405303,1.12636002655,0.879743599375,0.0845056917739,-0.4531443043,-0.680941541899,-0.54711553159,0.0276125335017,0.0807339767273,0.234188218911,0.0408290572663,-0.10426491132,-0.185893401047,-0.112901236174,0.150867920176,-0.143598352914,0.0191977778244,0.0327953226593,0.824464011456,0.274604509111,0.429601320203,0.295276724678,0.126967767633,0.222396849859,-0.157225651827,0.0585704260688,0.00443703779704,-0.109766205516,0.0513060164402,-0.232978567253,-0.0591933007235,0.0916275075965],[-28442.37831,133.936963638,-23.7576270125,-751.943283045,1612.96593715,1239.729832,263.411379329,-883.648926906,-316.057902152,-870.698722546,-435.828680441,-162.530014505,-85.5910759934,288.197851482,-281.613542231,-160.300770701,86.200602917,-233.065718955,-160.523461687,-87.4802223984,17.8698356063,604.137318638,-116.92392587,264.903830183,-67.5212764827,-16.910821371,-62.7435964555,129.799417743,-130.986077989,102.885239374,153.660476716,-44.0150297088,-3.95031454645,-30.4735139587,-43.162685434,-23.7366840398,26.7793860778,28.7017867339,53.9000852843,-40.0237882762,56.6003373758,0.13816065058,-10.936447687,12.6505001693,-25.570020086,3.01783676163,27.0145963552,-19.3328031448,-9.06797225726,6.89817567644,6.85526034242,21.754723162,-26.742703306,26.1362375593,1.21427976994,17.0725908129,7.07079442761,-8.9346136676,5.80414453161,-2.87599063708,-12.8583046201,-0.617386639274,4.76130357582,0.0738884272115,2.13019844452,0.351202068725,2.91566404778,-3.87052589953,6.5086387861,0.184995277169,8.58830468244,3.77959412286,-0.948564203589,2.50143479752,-0.113112870598,-2.75202945017,-1.05834310492,-0.275446157141,0.374674655643,-0.177197026314,0.125107285067,-0.268002445913,-0.159490708501,0.630416050021,-0.918966352931,1.19732477843,0.509428759254,2.28877732895,1.1466188704,1.05840446716,0.903716783905,0.0130502693284,-0.456628423737,-0.706336627513,-0.567918409724,0.0187616938603,0.0612501818258,0.221690482267,0.0405895428302,-0.0998901873609,-0.168102353408,-0.10721297886,0.151888699714,-0.149588505266,0.0115609173227,0.0221672172244,0.820019717529,0.258849885489,0.415954810503,0.295211845086,0.109342439459,0.225174602873,-0.170337377656,0.0482266247947,-0.00270905414101,-0.123320522438,0.0457299750238,-0.238354317248,-0.060275747123,0.0947847834738],[-28468.6167323,138.772845321,-0.421008541215,-726.889711611,1613.65919146,1239.90996628,257.529075203,-889.705959047,-313.205797365,-858.10814576,-427.847960696,-166.275818674,-88.2224276242,282.539828322,-273.316210827,-160.021299963,78.6690819623,-243.640655879,-156.688189557,-79.4272909965,23.9879320379,608.06510042,-115.164245381,266.350661083,-70.4022450777,-20.5855877636,-64.5247013273,127.072272623,-127.575971387,103.686386043,153.531898701,-45.1432166494,-2.47505008597,-31.2701749387,-40.4877189792,-23.8377937929,25.6572333333,28.7058562517,52.7191159045,-39.7356576513,56.4819189479,0.798669852127,-11.5348253388,13.2321213465,-26.4866957594,3.28680866503,26.5033191686,-19.1629897094,-8.81503160423,6.86248168919,6.75305690539,21.2185012063,-26.7745786676,26.1272308396,1.25540513856,16.8762317306,7.22269639896,-9.53578523825,6.02222258698,-3.26194682665,-12.8080716431,-0.581664593446,4.98729452359,0.202385789197,2.15327971285,0.412975417992,2.76078518644,-3.99498034791,6.43463192079,0.148315045329,8.47140866696,3.75858094141,-1.14320004989,2.59552505734,-0.287283517725,-2.77501807802,-1.09873285654,-0.276485846042,0.320466696346,-0.165788045015,0.170730714641,-0.227677889661,-0.140721637894,0.617368048265,-0.94949526478,1.15236593604,0.482788782345,2.26363913077,1.12601159767,0.994034628539,0.926882313143,-0.0520401448012,-0.460888872887,-0.729608687788,-0.588378816876,0.0111398806022,0.0423068218518,0.209061834803,0.041301895137,-0.0960868115373,-0.151647816513,-0.102547420186,0.152859110304,-0.155489438496,0.00430748483316,0.0129818561139,0.815016508324,0.244435508874,0.403176220061,0.295257797075,0.093341424823,0.227660814724,-0.182512357891,0.0380857964544,-0.00901905644464,-0.136047133751,0.0404565509384,-0.243150597117,-0.0617471587604,0.0978348756585],[-28500.0047369,145.238031987,22.9244105933,-702.078080236,1612.11896656,1236.81572455,251.762632015,-893.982685476,-311.447114425,-845.794569441,-420.467237724,-169.715839944,-90.2560598095,276.817964774,-265.241756352,-159.411339715,71.0322095242,-253.812754733,-152.963385225,-71.3845076288,30.0261865543,611.014047787,-113.130412076,267.864907425,-73.0069144468,-23.8531265995,-66.283251772,124.132582541,-124.151466831,104.552008912,153.257708943,-46.2045490973,-0.880663192983,-31.8829995613,-37.9741258137,-23.8469271009,24.6523442516,28.7921967817,51.513347726,-39.3831044693,56.3448718941,1.41211531084,-12.0880851841,13.7611855414,-27.307395095,3.52270029344,25.9921671085,-18.9589768717,-8.57313292752,6.86767746116,6.66537531405,20.7096076228,-26.7426127228,26.0970242375,1.29440142168,16.6842547735,7.3541651486,-10.0887167273,6.22033859624,-3.62504686198,-12.7492085626,-0.549930642363,5.21129136579,0.315482326743,2.17922668365,0.475399631196,2.61702333483,-4.10209623142,6.35882326866,0.124842630793,8.35462803926,3.73049148855,-1.32136905116,2.68468890133,-0.450994340021,-2.79746622518,-1.13616395804,-0.278388511684,0.267895013252,-0.153132949057,0.213054948073,-0.190556658922,-0.1236508044,0.606879930289,-0.975053427376,1.1069215661,0.461384329075,2.23783549235,1.10568771956,0.933592493966,0.948995828659,-0.110379429635,-0.4658844878,-0.750561169613,-0.608355637265,0.00441905823894,0.0239137177332,0.196297320443,0.0430412264903,-0.092834184281,-0.136649573125,-0.0989053179429,0.153787063107,-0.161298199704,-0.00247407215986,0.00533488163778,0.809469759597,0.231461268123,0.391274127856,0.295386960322,0.0790544539563,0.229790555252,-0.193665764259,0.0281812804303,-0.0145747839199,-0.147944107192,0.0354651957541,-0.247338337182,-0.0636047918653,0.100754236623],[-28535.3497656,152.644426872,45.6914761967,-677.645954049,1607.8471962,1231.71445079,246.392926544,-896.388927085,-310.75912813,-833.57685441,-413.45626455,-172.728616231,-92.0955070359,271.270516695,-257.477879307,-158.396347046,63.456098139,-263.532436387,-149.340074033,-63.423365814,36.0420089654,613.002048509,-110.800061788,269.497546225,-75.309604232,-26.7184997007,-68.0006866975,120.987400056,-120.722177628,105.446025995,152.827740576,-47.2040597606,0.821407595362,-32.3277812644,-35.6209481121,-23.7707566003,23.7597701368,28.9528081417,50.288680829,-38.9642698879,56.1788839117,1.97188209186,-12.589364818,14.234328872,-28.0281621436,3.72290125614,25.4838203818,-18.7153579473,-8.34670025969,6.91072686314,6.58982307967,20.2298060453,-26.6453129761,26.0452319136,1.33154650258,16.4976968933,7.46382582074,-10.591539375,6.39734472634,-3.96494544277,-12.6779138975,-0.52213354408,5.43362480062,0.41216228499,2.20699475656,0.538217387618,2.4850553645,-4.19051772117,6.28178782305,0.114399331444,8.23810756423,3.69496100475,-1.48241596555,2.76793283685,-0.603410223818,-2.81891997958,-1.17027355291,-0.281150336498,0.216014758562,-0.139644197068,0.251787855514,-0.156989795217,-0.108282169491,0.599087813772,-0.995624109017,1.06156418649,0.445240073272,2.21143580394,1.08577883292,0.877325767692,0.969838586403,-0.161705717703,-0.471525914749,-0.769063906905,-0.627691080033,-0.00179713437238,0.00606608220736,0.183378917053,0.0458527770974,-0.0901077083955,-0.12320248637,-0.0962656036436,0.154678115831,-0.167018642349,-0.00870054480186,-0.000696316738354,0.803397826647,0.219997428619,0.380224031344,0.29557016499,0.0665459290111,0.231500494413,-0.203746450957,0.0185449081439,-0.019499370308,-0.159029208736,0.0307142816508,-0.2509047758,-0.0658395485958,0.103515324857],[-28573.45926,160.303933211,67.2930340746,-653.730898177,1600.34581412,1225.87348896,241.700835568,-896.834504762,-311.119113277,-821.273861488,-406.584794202,-175.192685448,-94.14430379,266.13573994,-250.112280191,-156.901779047,56.1068603431,-272.750121711,-145.809281326,-55.6153590704,42.0928090813,614.046990356,-108.15083035,271.299554498,-77.2846340754,-29.1867688887,-69.6584450118,117.643777728,-117.297717082,106.33235531,152.231826734,-48.1467813476,2.61972374192,-32.6203134858,-33.4272280491,-23.6159549277,22.9745622932,29.1796901495,49.0510152937,-38.4772950648,55.9736426981,2.47135526032,-13.0318018352,14.6481874568,-28.645040956,3.88480116243,24.9809591954,-18.4267262516,-8.14015763327,6.9885937659,6.52400771356,19.7808601072,-26.4811869318,25.9714680282,1.36711826455,16.317595042,7.55030355958,-11.0423844219,6.55209314423,-4.28129726872,-12.5903861667,-0.49822205665,5.65462552625,0.491409909079,2.23553933122,0.601171366537,2.36555814698,-4.25888898828,6.20410057729,0.116806445161,8.12199200674,3.65162473048,-1.62568555119,2.84426337131,-0.743696055448,-2.83892542915,-1.20069878461,-0.284767502917,0.163881084473,-0.125734247677,0.286637307113,-0.127328340068,-0.0946196946391,0.594127816394,-1.011190578,1.01686631511,0.434380688763,2.1845094558,1.06641653457,0.825482153962,0.989191842324,-0.205757141533,-0.477723800009,-0.784986733578,-0.646227354325,-0.00790505837455,-0.0112408719883,0.170288602501,0.0497817871656,-0.0878827866842,-0.111401419378,-0.0946072087988,0.155537826186,-0.172654619885,-0.0142887242383,-0.00503434954885,0.79681906477,0.210114255745,0.370001427976,0.295778241239,0.0558802521395,0.232727302162,-0.212703272184,0.00920851101635,-0.0239159493501,-0.169320204358,0.0261621808083,-0.253837151328,-0.0684423311101,0.10609059885],[-28613.1406621,167.528454241,87.1419300329,-630.470477747,1589.11675407,1220.560183,237.967235867,-895.229239398,-312.50434466,-808.704451495,-399.622579705,-176.986585511,-96.8059845583,261.651890367,-243.232659506,-154.853092808,49.1506086727,-281.416231578,-142.362032447,-48.0319809167,48.235996712,614.1667611,-105.160353593,273.32190926,-78.906323619,-31.2629959853,-71.2379656228,114.108768115,-113.887698501,107.174914872,151.459800553,-49.0377465665,4.50284670955,-32.7763896636,-31.3920077993,-23.3891947195,22.291772025,29.464842623,47.8062512004,-37.9203211576,55.7188359504,2.90391988135,-13.4085338308,14.9993974139,-29.1540755829,4.0057896216,24.4862637562,-18.0876751002,-7.95792908081,7.09824204022,6.465536727,19.3645334422,-26.2487420943,25.8753467419,1.4013945909,16.1449861715,7.61222350933,-11.4393831083,6.68343601685,-4.57375703951,-12.4828238891,-0.478144938126,5.87462424087,0.552209444151,2.26381580726,0.664004247234,2.25920855383,-4.30585420386,6.12633652472,0.131885269825,8.0064261317,3.60011790621,-1.75052256622,2.91268701208,-0.871016721245,-2.85702866183,-1.22707679663,-0.289236193373,0.110549143184,-0.11181555951,0.317311173021,-0.101923334994,-0.0826673413162,0.592136055834,-1.02173610263,0.973400469863,0.428830849376,2.15712583817,1.04773242135,0.778309357025,1.00683685237,-0.242271833654,-0.484388789851,-0.79819948355,-0.663806669283,-0.0143010749104,-0.0280119321165,0.157008354652,0.0548734969023,-0.0861348219508,-0.101341235276,-0.0939090649197,0.156371751882,-0.178209985772,-0.0191554016146,-0.00760182732805,0.789751829265,0.201882014881,0.360581815207,0.29598201923,0.0471218254935,0.233407648456,-0.220485082139,0.000203920469055,-0.0279476547874,-0.178834860034,0.0217672654062,-0.256122702126,-0.0714040415664,0.108452517094],[-28653.2254039,173.85191524,104.826543309,-607.95430626,1573.81681425,1216.73217718,235.416839429,-891.561444784,-314.871089708,-795.710661452,-392.406035082,-178.013196219,-100.372370851,257.999922719,-236.909524665,-152.213646218,42.7117696014,-289.499645532,-139.003801005,-40.7262894996,54.4978334225,613.382954349,-101.817463975,275.60057055,-80.1612461411,-32.9589549646,-72.724313096,110.385659294,-110.501010601,107.937174041,150.506240417,-49.8797913307,6.45640264513,-32.8097079316,-29.5147130866,-23.0983633379,21.7048029852,29.7995739038,46.5585372442,-37.294142919,55.4046750772,3.26480641769,-13.7139429984,15.2842913797,-29.5531690316,4.08371211757,24.0017750728,-17.6949898857,-7.80368303915,7.23649195703,6.41224708918,18.9818342707,-25.9480338411,25.7564033282,1.43430529361,15.9806662153,7.64798975257,-11.7815072422,6.78996816052,-4.84222172848,-12.3525728496,-0.461846856264,6.09360479272,0.593850265737,2.29093249766,0.726416316782,2.16656248214,-4.33068959986,6.04904042132,0.159222256351,7.89152811278,3.54009788037,-1.85664928832,2.97217046854,-0.984799632874,-2.87290287902,-1.24906276304,-0.294560365149,0.0552895461305,-0.0982570224925,0.343596666665,-0.0810086111466,-0.0723989139096,0.59320991242,-1.02732183414,0.931683556675,0.428514196764,2.12935175843,1.02981499427,0.735924919434,1.02250869813,-0.271113287743,-0.491471025967,-0.808576133646,-0.680321493825,-0.0213103537157,-0.0442617255884,0.14353984688,0.0611293512191,-0.0848326720667,-0.0930807216113,-0.094134242334,0.157185789268,-0.18369020367,-0.0232240104931,-0.00836028773209,0.782219480835,0.195344656396,0.351927170092,0.296137191252,0.0403057979821,0.233473676628,-0.227033519948,-0.00845635036241,-0.0316911691963,-0.187594418089,0.017500784538,-0.257759819396,-0.0747033897178,0.110574547963],[-28692.6408787,179.696329659,120.637386868,-586.080190695,1554.72225076,1214.10831693,234.049699087,-886.133406319,-318.09158637,-782.227233189,-385.03821834,-178.272764915,-104.68843227,255.131587284,-231.144610743,-149.098400352,36.7480253518,-297.043077827,-135.797853677,-33.6776014792,60.7799877979,611.731987065,-98.155780447,278.111430506,-81.0849894652,-34.3132684097,-74.1170546253,106.46268141,-107.143643737,108.580807558,149.384705718,-50.6669643739,8.45427643166,-32.725585208,-27.7963038311,-22.7562070479,21.2004682236,30.1724264291,45.3050165788,-36.6101694814,55.0234663314,3.55662692259,-13.9473899263,15.4979880627,-29.8476601342,4.11823763281,23.52697736,-17.2542243102,-7.67806556229,7.39958938784,6.36289360082,18.6307491613,-25.585309042,25.613857514,1.46438789956,15.8244670336,7.6551221254,-12.0710909024,6.86925498895,-5.08755740346,-12.2015678971,-0.449256117622,6.31016363025,0.616842270937,2.3166093688,0.787938293436,2.08769193117,-4.33519965156,5.97263607369,0.197464467782,7.77730975884,3.47131043319,-1.94529807333,3.02152125799,-1.08552230333,-2.88672973608,-1.26638398027,-0.300775074926,-0.00176525830897,-0.0852532517364,0.36559837457,-0.0643491581942,-0.0636675884679,0.597291817087,-1.02832045547,0.892010033591,0.432950243883,2.10124369252,1.01258037109,0.697925736971,1.03575776372,-0.292646442059,-0.499078631725,-0.816007232345,-0.695865335962,-0.0289732988978,-0.0600442404106,0.129963534585,0.0683756138448,-0.0839190151746,-0.0865343636075,-0.0951823666345,0.157987189261,-0.189107178066,-0.0264445541035,-0.00742697690413,0.774265401808,0.190440870591,0.343945388092,0.296138898097,0.0353503055422,0.232839423528,-0.232261364454,-0.0168370614855,-0.0351373704955,-0.195634026252,0.013385494951,-0.25879150572,-0.0782703156973,0.112434199374],[-28730.3384701,185.705732991,135.040507107,-564.697986404,1532.26418416,1212.09774795,233.809702881,-879.325902302,-322.017065224,-768.212084733,-377.688848484,-177.789880823,-109.487425444,252.941333237,-225.922459725,-145.660217085,31.1753720837,-304.10770139,-132.821905403,-26.8467981437,66.9529801783,609.253982045,-94.2201185866,280.815364292,-81.725395051,-35.371271056,-75.4193830623,102.324300125,-103.820863675,109.067041506,148.113501095,-51.3911176348,10.4674176362,-32.527243107,-26.2381235025,-22.3766868401,20.7639331389,30.5712511599,44.0410809726,-35.8824635721,54.5680396772,3.78383884689,-14.1094798016,15.6353026898,-30.044746679,4.10949102443,23.0607156344,-16.7731241527,-7.58096710853,7.58363660435,6.31646052055,18.3085092691,-25.1683624401,25.4468501392,1.4898318643,15.6759794683,7.6309194023,-12.3113087351,6.91860456525,-5.31087240593,-12.0328911465,-0.440296938462,6.522550352,0.62200048724,2.34071930039,0.848058503243,2.02254792576,-4.32182089508,5.89751705106,0.245024120196,7.66375628753,3.39352345287,-2.01807879663,3.05950709974,-1.17392477093,-2.8988180018,-1.27878577536,-0.307923154236,-0.060267362518,-0.0729552936502,0.383500226538,-0.0515927554348,-0.0562963839547,0.604285463417,-1.02518253253,0.854618746687,0.441557471514,2.0728555335,0.995901573733,0.663778543728,1.04608825891,-0.307361596007,-0.507359225908,-0.820387471036,-0.71058196348,-0.0372591231572,-0.0754233047384,0.116379568674,0.0763947532127,-0.0833299844855,-0.0815805709083,-0.0969372022305,0.158783541416,-0.194474423652,-0.0287736780925,-0.00495806810914,0.765937979918,0.187083032756,0.336530844271,0.295867142684,0.0321442308678,0.23141439938,-0.236074179431,-0.0250222911934,-0.0382506854387,-0.2029923086,0.00945703030628,-0.259271916524,-0.0820225672329,0.114009989129],[-28765.2695618,192.524160728,148.501950423,-543.657548739,1506.87373502,1210.10961596,234.640738854,-871.519711032,-326.498756851,-753.623134116,-370.527644516,-176.589133172,-114.502606999,251.323609751,-221.227613599,-142.05195829,25.909805957,-310.754689148,-130.153671126,-20.1947607814,72.8873309038,605.98906209,-90.0552939699,283.673247071,-82.1303043584,-36.1782976389,-76.6344912583,97.954981103,-100.537936182,109.357101969,146.710931191,-52.0441030523,12.4667758256,-32.2179032425,-24.84151557,-21.9737637053,20.3803631295,30.9838990573,42.7621221942,-35.1250879183,54.0312250785,3.95089964145,-14.2008178112,15.6910504877,-30.1516264543,4.05759714953,22.6018349125,-16.2594351925,-7.51227813617,7.78473587823,6.27193210699,18.0123457495,-24.7049887782,25.2545220439,1.5088266434,15.5347943613,7.57268035772,-12.5053353866,6.93532495248,-5.51327507735,-11.8496247127,-0.434893535043,6.72901455648,0.610139942136,2.36313517214,0.906265272252,1.9710814907,-4.29298986652,5.82407692267,0.300313429672,7.55085291653,3.3065048276,-2.0766013336,3.0848957131,-1.25074707402,-2.909476445,-1.28601347535,-0.316047434611,-0.119868858881,-0.0615141946424,0.397486152372,-0.0423871821668,-0.0501083193335,0.614094544993,-1.01835863119,0.819748542038,0.453754360438,2.04424117444,0.979651624143,0.632950073795,1.05300439346,-0.315749048994,-0.516460427303,-0.821611541107,-0.724615144164,-0.0461370391942,-0.090462746727,0.102888100054,0.084969237756,-0.0830017132101,-0.0780977531571,-0.0992825135314,0.159582435289,-0.19980545512,-0.0301680281066,-0.00110973461205,0.757285602899,0.185183518177,0.329577913693,0.295201927935,0.0305764566527,0.229108114411,-0.23837752865,-0.0330961177794,-0.0409955407798,-0.209707889214,0.00575102426469,-0.259255207236,-0.0858778920525,0.115280435032],[-28796.3855373,200.795648364,161.487763214,-522.808733052,1478.98202388,1207.55306669,236.486695047,-863.09561081,-331.387891828,-738.418299365,-363.724325439,-174.695111188,-119.467233562,250.172866002,-217.044614351,-138.426485842,20.8673231315,-317.045214029,-127.870865785,-13.6823706804,78.4535603144,601.977349997,-85.7061221737,286.645954006,-82.347558847,-36.7796828938,-77.7655720649,93.3391900054,-97.3001270226,109.412215033,145.195300646,-52.6177725651,14.4233005671,-31.8007872289,-23.6078235032,-21.561398634,20.0349235944,31.3982210822,41.4635320119,-34.3521052474,53.4058524996,4.06226675711,-14.2220091423,15.660046683,-30.1754972487,3.96268086522,22.1491802109,-15.7209032086,-7.4718891035,7.99898948116,6.22829261875,17.7394897578,-24.2029827994,25.0360140681,1.51956169243,15.4005025544,7.47770376614,-12.6563455033,6.91672421374,-5.69587375919,-11.6548507107,-0.432970123627,6.92780584221,0.582075663116,2.38372986378,0.962046926512,1.93324365083,-4.25114310202,5.75270925777,0.361744612286,7.43858486347,3.21002244556,-2.12247555964,3.09645481736,-1.3167292509,-2.91901383449,-1.28781240728,-0.325190747582,-0.180221839781,-0.0510810011217,0.407740081872,-0.0363802176884,-0.0449264135681,0.6266227554,-1.00829931736,0.78763826572,0.468959391436,2.01545450842,0.963703544253,0.604907061261,1.05601037713,-0.318299100427,-0.526529854692,-0.819574133947,-0.738108645801,-0.0555762597092,-0.105226394532,0.0895892796331,0.0938815359079,-0.0828703345592,-0.0759643199974,-0.102102064946,0.160391460437,-0.205113787162,-0.0305842497925,0.00396185032218,0.748356658484,0.184654702142,0.322980971422,0.294023256769,0.0305358655908,0.225830078848,-0.239076975884,-0.0411426195365,-0.0433363632728,-0.215819392171,0.00230311048723,-0.258795533281,-0.0897540378841,0.116224054883],[-28823.039369,211.029656605,174.464559553,-502.112706568,1448.99623542,1203.93227629,239.24609915,-854.319746515,-336.528318202,-722.579707601,-357.398427401,-172.203778016,-124.196340529,249.351089461,-213.340422808,-134.907479327,15.9927415225,-323.026952372,-126.033360794,-7.28939963696,83.5400851298,597.266366515,-81.1989659661,289.679468989,-82.4184893766,-37.2108312449,-78.8120134848,88.4706631571,-94.1147379542,109.198594534,143.583423727,-53.1030645245,16.3093561267,-31.279326938,-22.5372840947,-21.1524707019,19.7154509783,31.8030335034,40.1431206451,-33.5754918315,52.6867242519,4.12345203486,-14.1731714092,15.5379231826,-30.1223577563,3.82243622174,21.702616227,-15.1651719798,-7.45938420567,8.22235886516,6.18431124964,17.4874411984,-23.6692511048,24.791090645,1.52127911903,15.2731315942,7.34454830875,-12.7672745612,6.86012985152,-5.85940947055,-11.4514700192,-0.434069412695,7.1175582945,0.538782039879,2.40222955099,1.01482417569,1.90874338912,-4.19842049081,5.68370806937,0.428039047873,7.32707178974,3.10420606917,-2.1570825742,3.0930307902,-1.37259802665,-2.92778484681,-1.2839878907,-0.335408418066,-0.240925866615,-0.0417244183711,0.414492053371,-0.0332546115402,-0.0405973780836,0.641698708635,-0.995462748442,0.75845417634,0.486645220241,1.98656594385,0.947992576801,0.579187731156,1.05470407289,-0.315521752822,-0.537683306773,-0.814185101185,-0.751183683044,-0.065480741998,-0.119763297539,0.076587873491,0.102941729327,-0.0828630235715,-0.0750474552755,-0.10528380487,0.161208545505,-0.210420277906,-0.0300061816446,0.0100901937967,0.739190940746,0.185404092684,0.316642172364,0.292238701549,0.0318916227914,0.221522786229,-0.238111951289,-0.0492286134707,-0.0452337003217,-0.221374123284,-0.000852554075871,-0.257939368796,-0.0935772828536,0.116836089408],[-28846.1903833,223.197347013,187.901224232,-481.975884012,1417.22781066,1199.1315427,242.636037447,-844.999729349,-341.73435388,-706.186322309,-351.46875512,-169.49659247,-128.83207838,248.590420791,-210.011675153,-131.501889187,11.3461660672,-328.693594165,-124.629653451,-1.07118147854,88.1069075877,591.933224184,-76.4863768812,292.66021083,-82.3583844078,-37.4674258702,-79.7579841257,83.3802195307,-90.9972146977,108.702405317,141.886153205,-53.4872629315,18.1029655666,-30.6577952738,-21.6257074299,-20.7555313245,19.4204659111,32.1910138202,38.8083721162,-32.7988781218,51.8765320366,4.14418487619,-14.0524719359,15.3235786136,-29.9934102944,3.62483404189,21.2660863815,-14.5994772828,-7.47312258519,8.45024220366,6.13789693418,17.2547749718,-23.1071477284,24.5220105816,1.51743163916,15.1544558458,7.17681229357,-12.8401013554,6.76294712596,-6.00315394103,-11.2416585724,-0.436208079617,7.29844394589,0.481870910959,2.41777359327,1.06374726393,1.89632152115,-4.13577533477,5.61696914556,0.49915477129,7.21697113157,2.9906329577,-2.18088837309,3.07378464278,-1.41902687326,-2.9363277894,-1.27458521529,-0.346805744512,-0.301370376831,-0.0331837871722,0.418156539319,-0.0328329942325,-0.0370626941515,0.658850700363,-0.980337447994,0.732072182637,0.506501202398,1.95771195058,0.932702847743,0.555616272271,1.04905795651,-0.308005821144,-0.549909301877,-0.8054149354,-0.763871258016,-0.0754934217382,-0.134063390059,0.0640071084052,0.112070352574,-0.0828711225975,-0.0751694396497,-0.10873241764,0.161992975491,-0.215775159226,-0.0285264335486,0.0170675243869,0.729793869112,0.18731972882,0.310494790798,0.289866112409,0.0344340230259,0.216260663349,-0.235557350561,-0.0573518714382,-0.046632581931,-0.2264541153,-0.00368771931734,-0.256702462754,-0.0973080266788,0.117178671014],[-28867.1994954,237.135306365,202.267209717,-462.915991982,1383.96425474,1193.13019428,246.328235868,-834.828537094,-346.812934233,-689.341316063,-345.803930459,-167.026387284,-133.598376365,247.590538952,-206.937426409,-128.187483575,7.01652345806,-334.025332804,-123.630397522,4.89805945954,92.1319263056,586.062433497,-71.5024536448,295.459707064,-82.176021801,-37.5352196369,-80.5838477466,78.1079487606,-87.965038965,107.914799978,140.112851475,-53.7567381995,19.7835666479,-29.9406753979,-20.8677969173,-20.3780500024,19.1511600692,32.5558048396,37.4691888987,-32.0238081148,50.9799399025,4.13524907272,-13.8575904738,15.0167282834,-29.788658086,3.35541434161,20.8445537758,-14.0309528942,-7.51115712144,8.67789685043,6.08674354208,17.0403347276,-22.5191385624,24.231656278,1.51252462084,15.0466863792,6.97935393534,-12.8765655105,6.62260073658,-6.12601157787,-11.0274110683,-0.437021293987,7.47101931569,0.413113477098,2.42935464609,1.10789881898,1.89447682068,-4.06386428889,5.55228871823,0.575358981151,7.10907476893,2.87124224464,-2.19413017619,3.03795604462,-1.45667594948,-2.94522687743,-1.25970966323,-0.359500518754,-0.360892276885,-0.0251161071812,0.419194120697,-0.0349729665179,-0.0342875355047,0.677531946662,-0.963419531093,0.708295605883,0.528270868405,1.9290455138,0.918080703835,0.534088364335,1.039138157,-0.296359823469,-0.563164538251,-0.793249289412,-0.776179819709,-0.0851919792029,-0.148101827633,0.0519748263268,0.121215553434,-0.0827770158157,-0.0761413279809,-0.112356771579,0.162694374481,-0.221236006432,-0.0262648082383,0.0246757510364,0.720162269347,0.190284782309,0.304479880844,0.286950908928,0.0379336434811,0.210151120315,-0.231521935778,-0.0654929040078,-0.0474741587556,-0.2311500827,-0.00617561184061,-0.255092882837,-0.100915199475,0.117330655034],[-28887.4276205,252.680121436,218.031968475,-445.450757075,1349.4930728,1185.90755942,249.994420344,-823.499147532,-351.570994635,-672.147861439,-340.272575279,-165.24599519,-138.719163733,246.051122905,-203.9967316,-124.942030645,3.09274038773,-339.002361689,-123.006246777,10.5440988419,95.5930399009,579.738504943,-66.1812949828,297.949485231,-81.8801794168,-37.3999654117,-81.2699681065,72.6939404812,-85.0356924681,106.826931115,138.272880935,-53.8978607421,21.3305971321,-29.1324504721,-20.2582559656,-20.0274962359,18.9087251286,32.8910493687,36.1354734657,-31.2518258065,50.001611898,4.10742841608,-13.5862067741,14.6170874994,-29.5081043542,2.99971713685,20.4429815116,-13.4667325901,-7.57154069378,8.90058015925,6.02854494303,16.8429641154,-21.9076894988,23.9229101343,1.5110634321,14.9520342641,6.7570314488,-12.8784066514,6.43651538293,-6.22688678831,-10.8107222049,-0.434144225397,7.63584092321,0.334280939038,2.43596536494,1.14636146862,1.90170806143,-3.98334400816,5.48946301925,0.65691887607,7.00417458176,2.74797306351,-2.19704520339,2.98478466527,-1.48620541402,-2.95506632607,-1.2394665167,-0.373610532624,-0.418828473237,-0.0171783780543,0.418065378486,-0.0395321291492,-0.0322370758762,0.697195663611,-0.945205112818,0.686927767347,0.551697748759,1.90071961873,0.904372491837,0.514499687077,1.02501080332,-0.281192277872,-0.577405714138,-0.777673816039,-0.788117817114,-0.094154094665,-0.161853765802,0.0406188692071,0.130325479693,-0.0824630874046,-0.0777741751303,-0.116065735009,0.163262366563,-0.226860394835,-0.0233411084473,0.0326967826886,0.710292967215,0.194182424913,0.298538496623,0.283538510682,0.0421610613439,0.203301567235,-0.226114469019,-0.0736322217483,-0.0476995814503,-0.235552739966,-0.00828945824914,-0.253118696728,-0.104367731359,0.117370896798],[-28908.2356737,269.668379003,235.664952976,-430.09790589,1314.10176997,1177.44296649,253.306316806,-810.704538444,-355.815470459,-654.709131013,-334.743311442,-164.608248922,-144.418369733,243.671851609,-201.068645748,-121.74329855,-0.336256451206,-343.604874217,-122.727854984,15.7927123332,98.4681469908,573.045949013,-60.4569996209,300.001072866,-81.4796351156,-37.0474160615,-81.7967089646,67.1782843269,-82.226656919,105.429951324,136.375603979,-53.8970009726,22.7234947802,-28.2376036581,-19.7917879832,-19.7113395257,18.6943527655,33.1903902143,34.8171282906,-30.4844751932,48.946212072,4.0715066979,-13.2360005883,14.1243715687,-29.1517523221,2.54328244355,20.0663326905,-12.913950147,-7.65232618157,9.11354948388,5.96099500675,16.6615067848,-21.27526643,23.5986545506,1.51755344097,14.8727105704,6.51470304869,-12.8473644028,6.20211576454,-6.30468397957,-10.5935866803,-0.425212043438,7.79346528778,0.247144497522,2.43659840527,1.17821784059,1.91651401716,-3.89487114759,5.42828828049,0.74410165466,6.90306245004,2.62276454779,-2.18987067458,2.91351017425,-1.50827542564,-2.96643035049,-1.2139610579,-0.389253577957,-0.474515872347,-0.00902759944746,0.415230893666,-0.0463680828791,-0.030876488999,0.717295067289,-0.92619030825,0.667771988303,0.576525373956,1.87288725056,0.891824558506,0.496745920227,1.00674202447,-0.263111702428,-0.592589527782,-0.7586741681,-0.799693699224,-0.101957448398,-0.175294360108,0.0300670789971,0.139348279136,-0.0818117215426,-0.079879035959,-0.119768176254,0.163646575823,-0.232705899745,-0.0198751369092,0.040912528287,0.700182788482,0.198895828392,0.292611692256,0.279674337251,0.046886853801,0.195819414217,-0.219443712364,-0.0817503352286,-0.0472500006698,-0.239752801576,-0.0100024851464,-0.250787972108,-0.107634552445,0.117378251638],[-28930.6223384,287.778180723,255.434769587,-417.271975911,1278.09128276,1167.83925261,256.033248167,-796.263569354,-359.381671606,-637.079543115,-329.107226908,-165.405734192,-150.831576959,240.257602708,-198.038281218,-118.578409955,-3.19449058569,-347.818274926,-122.752259735,20.5875211108,100.756461634,566.06012847,-54.286537992,301.502654714,-80.9861815628,-36.4682933893,-82.1519602913,61.604733208,-79.5521297232,103.719090841,134.432767933,-53.7464428806,23.943341875,-27.2587805437,-19.4590524173,-19.4356504496,18.5076150001,33.447167616,33.5233075134,-29.7234785362,47.8184510604,4.03860057011,-12.8074847202,13.5408308197,-28.7212109857,1.97586117427,19.7194592306,-12.3786726469,-7.75123548138,9.31209893954,5.88166397268,16.4943402718,-20.624425559,23.2615039144,1.53608489072,14.8100873869,6.25703207907,-12.7851236081,5.91769536996,-6.35847325626,-10.3779110108,-0.408294181932,7.94432221207,0.153451087735,2.43025823407,1.2027023201,1.93725499023,-3.7992306726,5.3686033509,0.837000379239,6.80640038779,2.4974892101,-2.17282542569,2.8236608059,-1.52353409055,-2.97985799618,-1.18340943364,-0.406468990828,-0.527410570719,-0.000304484069329,0.411152649996,-0.0553196728748,-0.0301752015472,0.737304869469,-0.906811422535,0.650632301295,0.602479958553,1.84570496278,0.880666190777,0.480756433832,0.984421735393,-0.242738337986,-0.608665196527,-0.736339610414,-0.810935157845,-0.108266381129,-0.188408588759,0.0204162674016,0.148250490343,-0.0807243691034,-0.0822745564629,-0.123380222274,0.16379584847,-0.238815085359,-0.0159734708137,0.0491142058245,0.689839544904,0.20430965493,0.286657981795,0.275399604305,0.0518960731629,0.187805079715,-0.211631838608,-0.0898313940818,-0.0460895554079,-0.243831844565,-0.0112940927072,-0.248108910779,-0.110685253566,0.117423299435],[-28954.1373713,306.053687775,276.806640277,-406.974748167,1241.81627314,1157.69328994,258.334925272,-780.498626753,-362.218406089,-619.118499101,-323.345274025,-167.290048628,-157.74098138,236.03404858,-194.814979731,-115.471905564,-5.45778642069,-351.64881291,-122.982033917,24.9435284025,102.542459651,558.819815173,-47.7183673583,302.409044331,-80.4236706433,-35.6731949426,-82.3537169035,56.0316931383,-77.0131710605,101.705890449,132.465659828,-53.4621247592,24.9777987843,-26.1912764208,-19.2345328684,-19.2009038951,18.3416052282,33.653511542,32.2601719404,-28.9712711576,46.6232258496,4.02115812593,-12.3125041846,12.8788556647,-28.2245124323,1.30404782807,19.4067683179,-11.8627003937,-7.8646665585,9.49166968711,5.78762755923,16.3379776588,-19.9580843331,22.9130005621,1.56908752563,14.7621808786,5.98790240136,-12.6931499858,5.58502284371,-6.38798751243,-10.1652489863,-0.383197131618,8.0883346322,0.0548505826311,2.41599656435,1.2196563221,1.96173739754,-3.69772079034,5.31041754777,0.935011566934,6.71433094531,2.37375307956,-2.14605475685,2.71591905376,-1.53258130498,-2.99570763,-1.14847124929,-0.424982284284,-0.577445425055,0.00941540316203,0.40629824235,-0.0661507219623,-0.0301196519601,0.756785764703,-0.88726552109,0.63531558397,0.62921845334,1.819343582,0.871058436296,0.46659535921,0.958234994814,-0.220739316477,-0.625552014123,-0.711173855796,-0.821946856045,-0.113091875407,-0.201220720631,0.0116391251404,0.157072215058,-0.0791787477408,-0.0848097471766,-0.126847034584,0.163655919206,-0.245170471421,-0.0116897851746,0.0571302694914,0.679314992207,0.210314528397,0.280705719017,0.270738711895,0.0570316722341,0.179331015579,-0.202854663412,-0.0978741041986,-0.044274338014,-0.247834896172,-0.0121683753923,-0.245090251016,-0.113492068423,0.117543518283],[-28977.9682972,323.38057622,299.044940917,-399.104814572,1205.64483446,1147.72545939,260.468655946,-763.857978876,-364.302856448,-600.636646082,-317.460871239,-169.75254284,-164.840432307,231.332060285,-191.314140354,-112.457680593,-7.11491858066,-355.107948402,-123.306134241,28.893582949,103.931932305,551.354633251,-40.8238166889,302.691712482,-79.8189690468,-34.6776872047,-82.4274998294,50.5212334076,-74.6075568041,99.405968571,130.497951625,-53.0658984776,25.8161703976,-25.0285490072,-19.0886689758,-19.0061758271,18.1877971897,33.8012493932,31.0331340447,-28.2304666446,45.3654800132,4.03196031888,-11.7657370485,12.153371537,-27.6712945221,0.538647800604,19.1325559548,-11.3667669973,-7.98868639543,9.64773964892,5.67583785452,16.1884659146,-19.2792505107,22.5544188175,1.61857596524,14.7261682292,5.71100300627,-12.5728544728,5.20673561933,-6.3931253395,-9.95706621481,-0.350161647463,8.22529876766,-0.0470314103942,2.39287692061,1.22907301896,1.98762918462,-3.59176801837,5.25378280546,1.03735759858,6.62686680699,2.25309556441,-2.10968558428,2.59125597619,-1.53600491264,-3.01429244911,-1.10991697485,-0.444440515613,-0.6246724821,0.0205727842761,0.401136668379,-0.0786062973819,-0.0307005316179,0.775319943238,-0.867689859397,0.621629425249,0.656380493165,1.79397750312,0.863145282883,0.454360517997,0.928390647421,-0.197793492605,-0.643161793416,-0.683784229062,-0.832852699709,-0.116531574234,-0.21376484727,0.00367731268671,0.165871945823,-0.0771716418039,-0.0873412097693,-0.130121033338,0.163171744855,-0.251739566562,-0.0070645294614,0.064798482527,0.668671872108,0.216802563086,0.27480071763,0.265711856162,0.062151078943,0.170462682003,-0.193301413155,-0.105880810534,-0.0418834291765,-0.251797846189,-0.0126356012336,-0.241740865213,-0.116027891433,0.117768110823],[-29001.302641,338.644522119,321.414047378,-393.560767042,1169.94506006,1138.65614184,262.691748017,-746.789893955,-365.612205226,-581.444631171,-311.457436996,-172.284567436,-171.823779053,226.482508884,-187.451162149,-109.569630257,-8.15466169008,-358.207141637,-123.613517418,32.4705334907,105.030670858,543.694206836,-33.674214953,302.32212993,-79.198943463,-33.4973366593,-82.3988300973,45.1354233055,-72.3330628274,96.8349436289,128.553315285,-52.5796159051,26.4477616042,-23.7640560209,-18.9919003785,-18.8505422104,18.0376646243,33.8822085702,29.8476062993,-27.5036785845,44.0501571249,4.08378810247,-11.1818613792,11.3793038698,-27.0711951152,-0.309533512438,18.9011181438,-10.8916060674,-8.11936197466,9.77578674729,5.54324694671,16.0418520081,-18.59093185,22.1870330044,1.68656482905,14.6992266227,5.43002288455,-12.4256480062,4.78547113036,-6.37378532889,-9.7548283046,-0.309428484433,8.35501083793,-0.150569283944,2.35996282738,1.23094558308,2.01259829699,-3.48279887427,5.19875105833,1.143260855,6.54402065722,2.13705607289,-2.06384482415,2.45064263154,-1.53439275724,-3.03592565071,-1.0685170803,-0.464490742105,-0.669143788602,0.0336083813025,0.396136925736,-0.092431466374,-0.0319085319011,0.79248959532,-0.848221692939,0.609381414055,0.683605712877,1.76978112104,0.857070718359,0.444149731829,0.8950975379,-0.174579721077,-0.661406347255,-0.654778055028,-0.843776594721,-0.118683120614,-0.226075060218,-0.00352750948602,0.174708175175,-0.0746998356417,-0.0897255459104,-0.13315463869,0.162288282242,-0.258489879413,-0.00213815314398,0.0719566081711,0.657972926324,0.223665873289,0.268988791342,0.26033923325,0.0671117212178,0.161265539186,-0.183161314215,-0.113853858043,-0.038995909584,-0.255756584406,-0.0127060382633,-0.238069625766,-0.118265617012,0.1181262797],[-29023.3279276,350.731201533,343.178335529,-390.241197492,1135.0850433,1131.20571821,265.26150931,-729.742640224,-366.123634962,-561.353101478,-305.338389743,-174.377473025,-178.384870929,221.816265438,-183.14144418,-106.841649771,-8.56579037341,-360.957852847,-123.79314016,35.7072287684,105.944466573,535.868160056,-26.3408911198,301.271767438,-78.5904605815,-32.1477097898,-82.2932287356,39.9363321218,-70.1874650036,94.0084340448,126.655422768,-52.0251289108,26.8618772933,-22.3912551798,-18.9146667158,-18.7330790101,17.8826812719,33.8882164738,28.7090011772,-26.7935205644,42.6822007585,4.18942243025,-10.5755552439,10.5715780963,-26.4338520719,-1.22969071539,18.7167508875,-10.4379512136,-8.25276027868,9.87128890454,5.38680692394,15.894182908,-17.8961361092,21.8121174464,1.77506873661,14.6785332428,5.14865102693,-12.2529415232,4.32386681033,-6.32986607202,-9.56000086381,-0.261238397496,8.47726706248,-0.254137430623,2.31631780915,1.22526718683,2.03431268018,-3.37223987562,5.14537424073,1.25194371703,6.46580518036,2.02717401325,-2.00865939265,2.29505007816,-1.52833268249,-3.06092043196,-1.02504203565,-0.484780021047,-0.710911391308,0.0489629162707,0.391768012073,-0.107371296179,-0.0337343441899,0.807876911195,-0.828998277201,0.598379139307,0.710533747323,1.74692883066,0.852978730547,0.436060822342,0.858564510936,-0.151776856594,-0.680197488489,-0.624762658509,-0.854842446965,-0.119644157549,-0.23818545102,-0.0100336809045,0.183639395653,-0.0717601136032,-0.0918193572691,-0.135900270793,0.16095048819,-0.265388918606,0.003048894308,0.078442409663,0.647280896574,0.230796573298,0.26331575386,0.254641039301,0.0717710269867,0.151805047323,-0.17262359297,-0.12179559168,-0.0356908599247,-0.259747000617,-0.0123899545133,-0.234085405068,-0.120178139577,0.118647227557],[-29043.5000942,358.779590928,363.811441242,-388.944960423,1101.32500381,1125.92279023,268.305426326,-713.003263644,-365.825508924,-540.228219819,-299.080121067,-175.653678046,-184.311416585,217.576606224,-178.34625786,-104.292917374,-8.32925363365,-363.371434414,-123.760335581,38.6282794357,106.747668452,527.904978406,-18.8888903384,299.519356932,-78.0177682046,-30.6379919403,-82.1358607102,34.9745958432,-68.170282934,90.9456435841,124.819368898,-51.4244205064,27.0503547001,-20.9103082331,-18.8313019422,-18.6532671821,17.7171067314,33.8133841365,27.6217674037,-26.1032911969,41.2668108144,4.35840881581,-9.96112722562,9.74297254839,-25.7686187411,-2.21138512075,18.5812655275,-10.0065485157,-8.38550967504,9.93100862983,5.20412719094,15.742296212,-17.1979388158,21.4311404894,1.8855848103,14.6613204391,4.87024536282,-12.057098083,3.8245624191,-6.26223323172,-9.37403249566,-0.206108931033,8.59179837262,-0.356354290408,2.2612705688,1.21215556393,2.05078815083,-3.26139212648,5.09377113921,1.36267264837,6.39213226421,1.92466044786,-1.9445472581,2.12548276652,-1.51854120306,-3.08957728329,-0.980232109831,-0.505153099854,-0.749989799223,0.0668844208669,0.388414619785,-0.123226464969,-0.0361450530208,0.821133792474,-0.810139752454,0.58845741871,0.736854473636,1.72557993508,0.850940546384,0.430122557865,0.818989749043,-0.130001591552,-0.699520361852,-0.594279033514,-0.866188108359,-0.119492732688,-0.25014122501,-0.0158968388675,0.192693465092,-0.0683537111493,-0.0935126498693,-0.138324732768,0.159110969431,-0.272404202576,0.00846738621842,0.084124671287,0.636667177683,0.238093441428,0.257828608591,0.248632324516,0.0760009621627,0.142132230499,-0.161856427243,-0.129725621779,-0.0320328013802,-0.263815006609,-0.0117048365778,-0.22981030293,-0.121747626438,0.119350304147],[-29062.3487282,362.941868396,383.624040382,-389.071960681,1068.49366636,1122.66884294,271.431700258,-696.213921087,-364.750913275,-518.158211819,-292.55091512,-176.25987227,-189.766562018,213.656428385,-173.210363998,-101.883743405,-7.39469798778,-365.458807312,-123.535942412,41.2253437991,107.388856462,519.828592826,-11.3581224768,297.07267499,-77.4946385848,-28.9518438974,-81.9504667375,30.2551172442,-66.2880111319,87.6801173851,123.025939956,-50.7999982729,27.0151604423,-19.3481930548,-18.7317172744,-18.6122076465,17.5463440381,33.6609571179,26.5864987132,-25.4390291962,39.8102125002,4.58735101308,-9.35140797141,8.89767715161,-25.083710427,-3.24564487375,18.4865347622,-9.59819393431,-8.51648407147,9.95684677958,4.99544641878,15.5861920333,-16.4996865726,21.0463465683,2.01754018393,14.6450412233,4.59683957634,-11.8442892345,3.2902070219,-6.1756207565,-9.19830378352,-0.145664787084,8.69807454691,-0.456814492772,2.19521052256,1.19222669336,2.06143201009,-3.15105507695,5.04432794898,1.47489044413,6.32251061022,1.82941305565,-1.87309059723,1.94307871548,-1.50624951744,-3.12214586809,-0.934706767521,-0.526245486437,-0.786243370383,0.0868501654039,0.38612422024,-0.140020094642,-0.0390133155549,0.832190986223,-0.791697798122,0.579559985096,0.762458738082,1.70583337019,0.850736349275,0.426087493504,0.776528786058,-0.109621969102,-0.719653439622,-0.563602850828,-0.878007214957,-0.118228512261,-0.262032042682,-0.0211618117629,0.201775702502,-0.0644996681885,-0.0948290471522,-0.1404523596,0.156752932324,-0.279503288978,0.0141329870856,0.0889962615059,0.626237776919,0.245481912072,0.252579117737,0.242307555318,0.0797316445981,0.132240368355,-0.150943800639,-0.137732620187,-0.0280280171042,-0.268046602157,-0.0106970452989,-0.225319328835,-0.122993336469,0.120215447661],[-29080.6718291,363.623512435,403.136068818,-389.922365697,1036.311882,1121.13358224,274.118710974,-678.855547153,-362.944114902,-495.286818805,-285.592029195,-176.473813301,-195.007312564,209.861034281,-167.924395747,-99.5597212249,-5.70394433134,-367.230784663,-123.167175788,43.4818420782,107.785168311,511.661795621,-3.78221358301,293.946759355,-77.0322250869,-27.0665453083,-81.7604314718,25.7713657965,-64.5488878386,84.2489859297,121.247345087,-50.1745009341,26.7607934834,-17.7385915503,-18.6097182445,-18.6114063149,17.3785820867,33.4364646092,25.6028250922,-24.8074583018,38.3188873504,4.86961733608,-8.75885864406,8.03773473012,-24.3870579223,-4.32386482778,18.421946629,-9.2136959,-8.64511876075,9.95198879706,4.76166059515,15.4266611138,-15.8047937517,20.6601741397,2.16984449419,14.6272037729,4.3301362903,-11.6216386488,2.72345201029,-6.07572966628,-9.03417830583,-0.0818074571015,8.79550007574,-0.555356714561,2.11879226502,1.16622111542,2.06599943026,-3.04190276362,4.99749771743,1.58808398231,6.25634812324,1.74100116969,-1.79616263888,1.74900933603,-1.49281749506,-3.15886314298,-0.889055272342,-0.548890378831,-0.81949892508,0.108144729851,0.384859979549,-0.157830918027,-0.0421881821096,0.841048950873,-0.773706978418,0.57165780008,0.787287629208,1.68777298005,0.852073561744,0.423639131058,0.731326493646,-0.0909438700865,-0.74094852596,-0.532943450428,-0.890507348847,-0.115831567147,-0.273958678319,-0.0258707257508,0.210760792189,-0.060221475741,-0.0958255769137,-0.142321869244,0.153867233133,-0.286653745271,0.0200725842014,0.0930810698271,0.616107354658,0.252894083648,0.247620233198,0.235656052188,0.0829077301301,0.122108304424,-0.139948648207,-0.14592252413,-0.0236682307434,-0.272537809035,-0.00942016008077,-0.22070071968,-0.123943801437,0.121212743397],[-29099.2673967,361.230001542,422.867462416,-390.796342903,1004.5005018,1121.006714,275.844838341,-660.409076441,-360.449380695,-471.757782108,-278.044720585,-176.57325874,-200.290673555,205.99572627,-162.678986266,-97.2664441968,-3.19881355984,-368.698179588,-122.701250843,45.3811944926,107.853741706,503.427379096,3.80521029512,290.156647768,-76.6416810759,-24.9593758201,-81.5891395671,21.5168109716,-62.9611512952,80.6893796997,119.455793437,-49.5705672134,26.2917527867,-16.1151856247,-18.4591103848,-18.6523690985,17.2220097714,33.1454358019,24.6703765275,-24.2153022534,36.7993168994,5.1985760988,-8.1959404064,7.16518810802,-23.6865920199,-5.43743983625,18.3768891654,-8.85386284343,-8.77084903566,9.91962012553,4.50366570773,15.2644941955,-15.1166747249,20.2750616605,2.34140737774,14.6053162652,4.07183812752,-11.3962699973,2.12694877583,-5.96826098096,-8.88301964103,-0.0164384325387,8.88347944948,-0.651819632622,2.03267039078,1.13487937042,2.06424558361,-2.9346092231,4.95373349196,1.70174014089,6.19305270812,1.65899412304,-1.7156366119,1.54444603914,-1.47960500537,-3.19996606459,-0.843866887915,-0.573920975072,-0.84958328361,0.130052694178,0.384585063822,-0.176737667955,-0.0455187030019,0.847708144854,-0.756201857556,0.564721825275,0.811282235564,1.67148260875,0.854659606311,0.422460972326,0.683527743472,-0.0742731753457,-0.763757425031,-0.502510172291,-0.903896092118,-0.11228196822,-0.286021906207,-0.0300657069911,0.21952341846,-0.0555426248271,-0.0965592669495,-0.143971979652,0.150444728126,-0.293823138916,0.0263130648578,0.096402985758,0.606390571276,0.26026205457,0.243004906875,0.228667135607,0.0854738745955,0.111714882234,-0.128933904995,-0.154401270833,-0.0189451659445,-0.277384649013,-0.00792776032744,-0.216042712365,-0.124627553108,0.122312276656],[-29118.9334306,356.166814215,443.338157044,-390.99405973,972.780376798,1121.9779441,276.088462226,-640.355443551,-357.310977542,-447.714843054,-269.750246585,-176.835966189,-205.873650326,201.865806712,-157.66476871,-94.9495056826,0.178873431206,-369.871805209,-122.185382712,46.9068212621,107.511714356,495.148135553,11.3705231097,285.71737797,-76.3341599167,-22.6076150799,-81.4599756776,17.4849222412,-61.5330397431,77.0384291766,117.623494152,-49.0108358344,25.6125373157,-14.5116571835,-18.2736992272,-18.7366019087,17.0848159869,32.7933998871,23.7887830056,-23.6692847903,35.2579826815,5.56759561528,-7.67511442127,6.28208010944,-22.9902435127,-6.57776475254,18.3407504088,-8.51950319522,-8.89311018898,9.86292620825,4.22235774418,15.1004820204,-14.4387438643,19.8934475876,2.53113847126,14.5768868777,3.82364771079,-11.175306951,1.50334871007,-5.85891572046,-8.74619136755,0.048540795151,8.96141715852,-0.7460419238,1.93749949441,1.09894199866,2.05592564241,-2.82984849197,4.91348831994,1.81534579787,6.13203226973,1.58296124877,-1.63338574514,1.33056023579,-1.46797191781,-3.24569158956,-0.79973087786,-0.602170473197,-0.876323266264,0.151858638354,0.385262639172,-0.196819077253,-0.0488539285493,0.852169026596,-0.739216999748,0.558723022296,0.834383645698,1.65704610037,0.858201905499,0.422236519107,0.633277407201,-0.0599157657215,-0.788431940998,-0.472512356397,-0.918381026857,-0.107559786357,-0.298322500629,-0.033788881644,0.22793826562,-0.050486606467,-0.0970871450554,-0.145441408779,0.146476273566,-0.300979037373,0.0328813163467,0.098985898806,0.59720208715,0.267517923255,0.238786090668,0.221330126056,0.0873747338316,0.101038945318,-0.117962506055,-0.163274797522,-0.0138505463544,-0.282683143864,-0.0062734254431,-0.211433543787,-0.125073123249,0.123484132737],[-29140.0833456,348.926880395,464.9195818,-389.978329996,940.966460402,1123.75285661,274.525250459,-618.343492963,-353.62666785,-423.30781467,-260.595489804,-177.474672917,-211.956624184,197.323785072,-153.042138419,-92.583778629,4.45640568081,-370.767137933,-121.656811825,48.0694854505,106.707257476,486.84916664,18.8739936273,280.652938748,-76.1158914367,-20.0009405227,-81.3956300549,13.6674619434,-60.2643205918,73.338671479,115.72799067,-48.5154870174,24.7333556069,-12.9550381567,-18.053204183,-18.8632354049,16.9733459749,32.3849269828,22.955759843,-23.1741509454,33.7035906754,5.9697369906,-7.20687921694,5.39107392784,-22.3038477212,-7.73687314612,18.3034045959,-8.21122496502,-9.01059869046,9.78509495783,3.91946618293,14.9350942307,-13.7741676351,19.5174898088,2.73773925876,14.5395947663,3.58694083913,-10.9648319115,0.855952778066,-5.75269610159,-8.62476869288,0.1113194131,9.02889350276,-0.837726128764,1.8341465943,1.05922463822,2.04092548188,-2.72822499101,4.87705302073,1.92841144709,6.07271411563,1.5123709349,-1.55112837322,1.10869583545,-1.45899236851,-3.29610827331,-0.757196571415,-0.634222747581,-0.899521855079,0.172839404798,0.386842695118,-0.218102512334,-0.0520151803529,0.854447793245,-0.722808917016,0.55361920335,0.856571111437,1.6445036902,0.862372337393,0.422665980587,0.580783849336,-0.0480541739454,-0.815226966229,-0.443134398464,-0.934077776485,-0.101653374889,-0.310948680002,-0.037079253946,0.235881743842,-0.0450778783557,-0.0974613035714,-0.146765295581,0.141968900027,-0.308087451892,0.0397862304351,0.100873616858,0.588638416111,0.274595033295,0.235001889507,0.213644394311,0.0885838631233,0.0900657777747,-0.107098399735,-0.172618462513,-0.00838333644689,-0.288500109117,-0.0045038899767,-0.206951301638,-0.125309760108,0.124696859572],[-29161.592217,340.352935789,487.389138705,-387.862553054,909.250115377,1126.10054836,271.62002272,-594.693708682,-349.708196099,-398.710796774,-250.649834128,-178.442034842,-218.513480318,192.410999232,-148.850539473,-90.2612543201,9.53751196613,-371.418307314,-121.112879785,48.9893214994,105.512676323,478.56481137,26.2514698731,275.023123071,-75.973411312,-17.1786207346,-81.4160153405,10.0493638829,-59.1208779249,69.6542702718,113.768163612,-48.0948669688,23.6872544887,-11.4457605744,-17.8210001783,-19.0218992386,16.8865703661,31.9207509136,22.1613636751,-22.7267309244,32.153744636,6.39683249424,-6.79388278329,4.49731423413,-21.6248580764,-8.90935345063,18.256670759,-7.92883447859,-9.11905571764,9.68932416429,3.60005446535,14.7675160698,-13.1251208762,19.148223936,2.95907861355,14.4918030002,3.36178601635,-10.7667622017,0.190660238907,-5.65180912868,-8.51867334071,0.17044932278,9.08619202006,-0.926030243464,1.72432840395,1.01684331822,2.01965378889,-2.6300646777,4.84406950149,2.04054204588,6.01460316431,1.44628778928,-1.4699632539,0.880886741488,-1.45259756035,-3.35061106639,-0.716653560279,-0.669664377968,-0.918886679059,0.192240885723,0.389222514818,-0.240409873934,-0.0547128651501,0.854623596798,-0.707121912623,0.549315583021,0.877976537716,1.63372117842,0.86670060232,0.423516395497,0.52650940572,-0.0383775403083,-0.844009745913,-0.414460917179,-0.950734129757,-0.0945842169579,-0.32393843927,-0.0399633404398,0.24323716676,-0.0393447648867,-0.0977140930137,-0.147964463037,0.136994335306,-0.315108168894,0.0469647167911,0.10218962132,0.58072348582,0.281431709,0.231631020443,0.205649512335,0.0891904155482,0.0788064259858,-0.0964095875892,-0.182385308477,-0.00257146400486,-0.294785535323,-0.00263850905654,-0.202633476768,-0.125369577865,0.125912855629],[-29181.9505352,331.375167551,510.375723012,-384.922774645,877.916806832,1128.80599435,268.034886653,-569.894484597,-345.920802288,-374.103960879,-240.028288757,-179.62568755,-225.461479889,187.215994182,-145.099178136,-88.1032036247,15.2950309988,-371.86410619,-120.540953492,49.8138066944,104.031309663,470.331718101,33.4326946867,268.896674951,-75.8883316815,-14.1923220894,-81.5403497736,6.61385473065,-58.060124994,66.0547958565,111.748227892,-47.7568633917,22.5129903624,-9.97760649133,-17.6063760185,-19.1998478095,16.8216161385,31.4006464304,21.3937364673,-22.3218762262,30.6282727627,6.84040718678,-6.43681047564,3.60656606856,-20.9486325372,-10.0904328158,18.19285413,-7.67193764067,-9.21348362505,9.578814087,3.27001952357,14.5966116815,-12.4935305198,18.7864050122,3.19281725626,14.4320456275,3.14792492249,-10.5819738749,-0.485980074829,-5.55776300291,-8.42753866379,0.224573104249,9.13377205783,-1.00997612767,1.60997406065,0.972989165564,1.99264995326,-2.53562389369,4.81401744137,2.15136616745,5.95722373695,1.3836754747,-1.39083425072,0.649339355773,-1.4484329629,-3.40842651818,-0.678451501769,-0.70783262044,-0.934101528951,0.209301235794,0.392286204841,-0.26351169637,-0.0566296609621,0.85279132797,-0.692322237637,0.545704226482,0.898769992747,1.62452075644,0.870680856171,0.424571509955,0.470979905033,-0.030451656991,-0.874550613446,-0.386551586969,-0.968005916758,-0.086382078159,-0.337317217509,-0.0424645357446,0.249889573876,-0.0333165571279,-0.0978729284427,-0.149056155128,0.131640481509,-0.32199941859,0.0543356895577,0.103077311976,0.573463077392,0.287967519852,0.228637353558,0.197395102387,0.0893124436317,0.067278376902,-0.0859650844696,-0.19249779918,0.00354990236177,-0.301460206789,-0.000689792955732,-0.198507410824,-0.125285407181,0.127092982005],[-29199.6487906,322.923762831,533.508229974,-381.435040509,847.251999876,1131.65416958,264.431949901,-544.434214592,-342.629726416,-349.667478502,-228.845862893,-180.913266625,-232.717884058,181.827314911,-141.797260672,-86.2308974113,21.6018014906,-372.143327399,-119.928399845,50.6904183214,102.366496262,462.186535187,40.3474109077,262.342338403,-75.8422646836,-11.0937109608,-81.787851593,3.34416115791,-57.0394750511,62.6098185348,109.672398424,-47.5093639894,21.2493196293,-8.54435796228,-17.4386205088,-19.3843355173,16.7756102701,30.8243882844,20.6410201849,-21.9544383498,29.1470032544,7.29198612878,-6.13634764929,2.72459447136,-20.2705290623,-11.2753383913,18.1042599403,-7.44014035601,-9.2888847672,9.45676498531,2.93525828971,14.4212452095,-11.8813234979,18.4327880801,3.43661590755,14.358856696,2.94509923756,-10.4113429845,-1.16741933056,-5.47206592552,-8.35099801485,0.272333337566,9.17209296344,-1.08858564116,1.49301270171,0.928853307131,1.9604533648,-2.44515898064,4.78637651947,2.26051238498,5.90010015474,1.32349765395,-1.31468522723,0.416260080165,-1.44614404573,-3.46878117802,-0.642940053201,-0.74806473108,-0.944850195499,0.223258609675,0.395917871755,-0.287178513962,-0.0574482458103,0.849045877474,-0.678576143131,0.542677198909,0.919121544744,1.61672461564,0.873807254835,0.42561507008,0.414721175957,-0.0238423161746,-0.906619902223,-0.359466082264,-0.985548967575,-0.0770767240881,-0.351110453797,-0.0446062344797,0.255724004693,-0.0270225461475,-0.0979652249188,-0.150057615837,0.125995240738,-0.328719431191,0.0618180628782,0.103680088612,0.566862971943,0.294142035339,0.225984758931,0.188930786726,0.0890679998993,0.055499117474,-0.0758339052299,-0.202878398383,0.009945594043,-0.308444907823,0.00132974805261,-0.194600445448,-0.125090078717,0.128198099798],[-29213.1774736,315.928908782,556.415554844,-377.675396385,817.541159617,1134.43004908,261.473320106,-518.801292554,-340.200208483,-325.581521156,-217.217565738,-182.192407652,-240.199953986,176.333506407,-138.953993343,-84.7656065486,28.3306621532,-372.294763779,-119.262585743,51.7666336661,100.621574884,454.165910986,46.9253613757,255.428857439,-75.8168224571,-7.93445372267,-82.1777390379,0.22350983581,-56.0163413478,59.3889086082,107.544890122,-47.3602564649,19.9349986909,-7.13979704209,-17.3470224544,-19.5626167616,16.7456797387,30.1917512267,19.8913567931,-21.6192687942,27.7297643105,7.74309438081,-5.89317965955,1.85716448281,-19.5859056104,-12.4592973269,17.9831934215,-7.23304852939,-9.34026149859,9.32637711861,2.6016676959,14.2402807975,-11.2904267428,18.0881281829,3.68813528806,14.2707702536,2.75305064158,-10.2557455838,-1.84710869571,-5.3962260977,-8.28868474664,0.312372602788,9.20161408429,-1.16088064369,1.37537346441,0.88562686982,1.92360341331,-2.3589262802,4.76062641494,2.36760927167,5.84275673889,1.26471798983,-1.24246004696,0.183855316525,-1.44537627841,-3.53090159527,-0.610468871892,-0.789697965971,-0.950816469451,0.233351162027,0.400001622127,-0.311180861026,-0.056851297716,0.843482136022,-0.666049880174,0.540126565476,0.939201261919,1.61015494742,0.875573954205,0.42643082199,0.35825904717,-0.0181153100398,-0.939987945638,-0.333264077489,-1.00301911229,-0.066697920341,-0.36534358721,-0.0464118312642,0.260625498712,-0.0204920230136,-0.0980183975023,-0.150986089146,0.120146515101,-0.33522643691,0.0693307508958,0.104141351012,0.560928950588,0.299894824944,0.223637106645,0.180306187611,0.0885751368765,0.0434861346526,-0.0660850647235,-0.213449569849,0.0165804424289,-0.315660422732,0.00340760369536,-0.190939922285,-0.124816423134,0.129189070109],[-29221.5570639,311.000281811,578.824236374,-373.921677075,788.916704511,1136.90869632,259.686220725,-493.440590943,-338.911655237,-302.066147339,-205.244488324,-183.368903976,-247.827818058,170.800959552,-136.55266805,-83.8039785751,35.3648379355,-372.34344077,-118.551717036,53.1650822657,98.881372232,446.284783857,53.1138039705,248.233587524,-75.7955137852,-4.75577112441,-82.7177359566,-2.76511763271,-54.9553293878,56.452144781,105.369243607,-47.3118118894,18.6043269,-5.75825915862,-17.3549775759,-19.7224808996,16.7312021573,29.5051296449,19.1363673289,-21.3102280129,26.3933979895,8.18627798994,-5.70651085279,1.00862682074,-18.8915156615,-13.6372733473,17.8231800419,-7.04973536383,-9.36355227011,9.19091538209,2.27458480314,14.0535084566,-10.7222441699,17.7531907901,3.94524956093,14.1665606023,2.57097550414,-10.1155678161,-2.51945578927,-5.33130566475,-8.23998712896,0.34347264309,9.22285388365,-1.22604669194,1.25879868324,0.844366929999,1.88287233463,-2.27703114678,4.73623409839,2.47241084738,5.78470921603,1.20634668788,-1.17496788291,-0.0458846820273,-1.44575548266,-3.59403984046,-0.581270360008,-0.832053325249,-0.951837576581,0.239057031147,0.404418708282,-0.33531546451,-0.0546100062349,0.836246906345,-0.654833520479,0.537942961742,0.959168180703,1.6046007398,0.875574555347,0.426819122628,0.302061440234,-0.0128645411139,-0.974407565899,-0.307989570385,-1.02009738123,-0.0553072425831,-0.380004576481,-0.0479083889483,0.264502910225,-0.0137684776346,-0.0980692851556,-0.151854190999,0.114170004574,-0.341476534891,0.0767988771952,0.10459564713,0.555649585391,0.30517952515,0.221561560931,0.171570522624,0.087946256716,0.0312655384456,-0.056766291086,-0.224129580782,0.0234152984755,-0.323020624841,0.00553170087589,-0.187548027793,-0.124497398231,0.130032396619],[-29225.9279981,307.465515358,600.851387312,-370.458873634,760.898866397,1138.82552861,259.05833846,-468.622896511,-338.700140422,-279.500963482,-192.972049006,-184.421179983,-255.533073564,165.207448809,-134.47291923,-83.3441677088,42.6290987361,-372.259314216,-117.887355381,54.9090026627,97.1566667495,438.471252168,58.9300567318,240.868329928,-75.7694340297,-1.55710141771,-83.3695886345,-5.6397199175,-53.8498136812,53.8216393677,103.146302329,-47.3438348067,17.2737754152,-4.39629323197,-17.4623092555,-19.8538571198,16.7405576779,28.7773964723,18.3815891152,-21.0172122779,25.1428017867,8.61816694922,-5.56962153958,0.177674913444,-18.1896947792,-14.8031764768,17.6226262154,-6.88714325553,-9.35843991809,9.05390321435,1.95710718801,13.8644216675,-10.176087627,17.4287830789,4.20668665942,14.0459630607,2.39588895306,-9.98923618545,-3.18269403655,-5.27658254829,-8.20331309982,0.364971854113,9.23656728828,-1.28392413007,1.14428348143,0.805594361949,1.83996374868,-2.19897498588,4.71261570644,2.57517291868,5.72543893464,1.14758012459,-1.11247914591,-0.271834257341,-1.44682888883,-3.65755006887,-0.555107899123,-0.874386785263,-0.948364482769,0.240814289857,0.409038965575,-0.359483821871,-0.0508496070604,0.827694639233,-0.644712418327,0.536011304801,0.979137210407,1.59971816721,0.873800440049,0.426646772229,0.246364648225,-0.00779635330922,-1.00956154046,-0.283623851932,-1.03656560563,-0.0430935067597,-0.39493145897,-0.0491376433056,0.267360352697,-0.00695219528008,-0.0981924224486,-0.152656025183,0.108092600633,-0.347417300014,0.0841724031284,0.105142117599,0.550944612201,0.310006040426,0.219738462631,0.162771390641,0.0872711600796,0.0188979310876,-0.0478401655834,-0.234819912149,0.0303950914036,-0.330411743541,0.00769171520345,-0.184426327693,-0.124166470352,0.130717153339],[-29227.960702,304.331732119,622.711763908,-367.57376618,732.854830459,1139.90605174,259.442475826,-444.575474582,-339.415904531,-258.305462998,-180.431747967,-185.345817822,-263.250185013,159.508594533,-132.568466956,-83.3597048377,50.0586006909,-371.998572564,-117.381901386,56.9967856509,95.4397248165,430.631704289,64.4089527395,233.453497371,-75.7315751968,1.67256277017,-84.0835489663,-8.41854075658,-52.7003609899,51.5100130854,100.876235447,-47.4305131289,15.9553583465,-3.05100155528,-17.6629477907,-19.9472095678,16.7843770871,28.0240442791,17.6360385467,-20.7291268161,23.9798870571,9.0364122382,-5.47431102157,-0.6384121332,-17.4841740487,-15.9506533149,17.381158593,-6.74168189896,-9.32554337521,8.91892868982,1.65177255595,13.6774397783,-9.65074594526,17.1157226531,4.47138795928,13.9089532017,2.22426080571,-9.87468728588,-3.83601331445,-5.23088861405,-8.17682551432,0.376347794615,9.24356834086,-1.33451699914,1.03263617941,0.769695989424,1.79681412142,-2.12410821572,4.6891746672,2.67627673876,5.66441864867,1.08766121921,-1.05512955625,-0.493083900008,-1.4481240794,-3.72081195693,-0.53162761566,-0.91593806641,-0.941001588926,0.239300994611,0.413729375117,-0.383613623195,-0.0457838474203,0.818231697492,-0.635395748641,0.534215082126,0.999212228557,1.59513020073,0.870342435275,0.425797181854,0.191347057101,-0.00264520088456,-1.04511513559,-0.26013253642,-1.05223081695,-0.0302773388856,-0.409924791694,-0.0501449983405,0.269225754378,-0.000157660059862,-0.0984717678529,-0.153381067446,0.101928992629,-0.352994176094,0.091407499489,0.105871051218,0.546716557815,0.314398342239,0.218151446737,0.153955985861,0.0866339972561,0.00645253787016,-0.0392479827641,-0.245417848359,0.0374607699998,-0.337713097241,0.00987775946378,-0.181571232518,-0.123857232981,0.131238056865],[-29229.3256015,300.606054788,644.62012241,-365.553134828,704.151781884,1139.8757715,260.691435341,-421.525590481,-340.909188057,-238.899139299,-167.655085392,-186.13939964,-270.91361692,153.660017078,-130.693031302,-83.8241208497,57.5884999356,-371.517404257,-117.147755661,59.4268220242,93.722812813,422.672528592,69.5853250733,226.109502575,-75.6749292931,4.94422881195,-84.8098688468,-11.119823888,-51.507538076,49.5298866512,98.5592121169,-47.5460347677,14.661089804,-1.71948642172,-17.9508234793,-19.9930023896,16.8732911718,27.2605656352,16.908732018,-20.4348768541,22.9065651554,9.43866483641,-5.41237860037,-1.44235521331,-16.7786845546,-17.073350461,17.0984038251,-6.6097609886,-9.26548157416,8.78957988294,1.36111861243,13.496982137,-9.14500795587,16.8148271167,4.73829483627,13.755506598,2.05256087949,-9.76985771145,-4.47860349985,-5.19305572772,-8.15868722751,0.377078023354,9.24467108404,-1.37782934023,0.924665097578,0.737058636182,1.7553599188,-2.05178125456,4.66531440878,2.77610356086,5.60112111204,1.02583289099,-1.00305483422,-0.708724100621,-1.44916863689,-3.78320518108,-0.510475636043,-0.955946889092,-0.93035329596,0.235195201863,0.41835691802,-0.40763255857,-0.0396264745424,0.808264443929,-0.626592686342,0.532437781195,1.01949711268,1.59045981142,0.86529136799,0.424153762565,0.13718705282,0.00285446190138,-1.08073361755,-0.237481238141,-1.06690004666,-0.0170793649758,-0.424785131668,-0.0509758580576,0.270127043525,0.00650064391615,-0.0989912798404,-0.154018793538,0.0956938699095,-0.358152606942,0.0984603370707,0.10687273679,0.542867949029,0.318380402055,0.216784148241,0.145171502482,0.0861189185345,-0.00600141591502,-0.0309310371765,-0.25582067382,0.0445532830509,-0.344804004349,0.0120799464426,-0.178979152804,-0.123603279599,0.131589823792],[-29231.6931224,295.295606063,666.791219066,-364.683759697,674.156905857,1138.46019367,262.658019518,-399.700509532,-343.030231493,-221.7014858,-154.673561467,-186.798507584,-278.457833796,147.617336801,-128.700332341,-84.7109466327,65.1539526062,-370.771997741,-117.297318812,62.1975025763,91.9981971188,414.500113448,74.4940068132,218.95675826,-75.5924883248,8.26890408038,-85.4988001707,-13.7618130498,-50.2719117012,47.8938807823,96.1954014964,-47.6645876351,13.4029838978,-0.398850124421,-18.3198666187,-19.9816997311,17.0179307188,26.5024531105,16.2086859236,-20.1233676187,21.9247474364,9.82257572342,-5.37562357763,-2.23687522099,-16.076957382,-18.1649145145,16.7739885626,-6.48779021892,-9.17887344764,8.66944486815,1.08768306291,13.3274680918,-8.65766248993,16.5269140734,5.00634866615,13.5855988224,1.87725899175,-9.67268405622,-5.10965446965,-5.16191575503,-8.14706109449,0.366640099088,9.24068956047,-1.4138651944,0.821178556373,0.70806912598,1.71753760676,-1.98134452064,4.6404383593,2.8750346382,5.5350190787,0.961338059169,-0.95639070012,-0.91784534977,-1.44949014377,-3.84410941776,-0.491298086695,-0.993652973709,-0.917024004781,0.229174968067,0.422788575396,-0.43146831808,-0.0325912356545,0.79819924135,-0.618012406354,0.530562889484,1.04009574031,1.58532997033,0.858738065158,0.42159992542,0.0840630213391,0.00896818078988,-1.11608225262,-0.215635571384,-1.08038032623,-0.00372021104522,-0.43931303591,-0.0516756264614,0.270092148389,0.0129082325381,-0.0998349168829,-0.154558679207,0.0894019218254,-0.362838036373,0.105287086667,0.108237463115,0.539301312641,0.321976191341,0.215620202135,0.136465134705,0.0858100742037,-0.0183947049764,-0.022830623369,-0.265925672939,0.0516135793437,-0.351563783273,0.0142883889257,-0.176646499084,-0.123438203688,0.131767170716],[-29236.3419631,287.781545227,689.254361551,-365.128614591,642.473447425,1135.48865591,265.27008538,-379.25794392,-345.669601636,-207.000656118,-141.57382739,-187.320478544,-285.824340851,141.34389339,-126.458216884,-85.9954801459,72.7019323382,-369.730980697,-117.929330189,65.3093238555,90.2665584038,406.04611615,79.1630814578,212.10544333,-75.4790314703,11.654450223,-86.1088049348,-16.3609682928,-48.9926734423,46.6092669383,93.7884287755,-47.7659927259,12.1974573137,0.913071300143,-18.7653616193,-19.9066176717,17.2270677732,25.7635456612,15.5431580293,-19.7853634516,21.0363250758,10.1858180262,-5.35547798216,-3.022502277,-15.3825243693,-19.2205496625,16.408369596,-6.37237661711,-9.06675314349,8.56182386679,0.833761873246,13.1728640334,-8.18706375177,16.2526293905,5.27447935767,13.3998629033,1.69562607475,-9.58146221328,-5.72837002064,-5.13625350326,-8.14006164784,0.344666687084,9.23236452953,-1.44283015184,0.722890228124,0.683049088472,1.68502137609,-1.91209630103,4.61405816358,2.97333459253,5.46587487688,0.89354745643,-0.915147866289,-1.11971398728,-1.44864045048,-3.90296393909,-0.473864434171,-1.02838628422,-0.901579243994,0.221820241909,0.426878034212,-0.455053444465,-0.0248935192938,0.788392099657,-0.609388211725,0.528490119538,1.06110144684,1.57944944696,0.850756080925,0.418100095075,0.0321355516566,0.0159504225189,-1.15083160923,-0.194587609362,-1.09246674008,0.00958872182587,-0.453358709983,-0.0522757650672,0.269161288796,0.0189672247078,-0.101070201565,-0.155005408504,0.0830651197713,-0.367011303061,0.111853991945,0.110043157597,0.535923375756,0.325213911495,0.214652330689,0.127879386868,0.0857858568582,-0.0306611426548,-0.0149034171779,-0.275629370452,0.0585777953424,-0.357898641323,0.0164977262134,-0.174565623571,-0.123391144023,0.131766223706],[-29242.9839121,278.941177923,711.297063243,-366.55544807,609.64889109,1131.20582325,268.755707967,-360.077393274,-348.8791705,-194.559444693,-128.663138423,-187.705668381,-292.982806086,134.833903863,-123.891038692,-87.6600876332,80.2266827662,-368.412737741,-119.087884108,68.7712054268,88.5622344977,397.343269691,83.5936341822,205.624801422,-75.3364865956,15.0961459867,-86.6311855446,-18.9266149192,-47.6635141347,45.6619195484,91.3557432736,-47.8526033655,11.0785370403,2.21550684224,-19.2880093427,-19.7724800249,17.5020394134,25.0510677886,14.912371586,-19.4190651546,20.2431085335,10.5261534616,-5.34190475148,-3.79100340861,-14.6981203691,-20.241690443,16.0053242765,-6.26091654128,-8.9318156701,8.46886568788,0.600684051009,13.0353245237,-7.72982743847,15.9919319877,5.54157095158,13.2015616909,1.50813752012,-9.49592527188,-6.33400962924,-5.11466554602,-8.13561013022,0.311410878635,9.22014361743,-1.46573599923,0.630135192835,0.662059376908,1.65843631687,-1.8431263582,4.5861183334,3.07080151979,5.3946091321,0.822343069246,-0.878837013325,-1.31429974986,-1.44626847911,-3.95944639993,-0.458437505555,-1.05983775879,-0.88442905299,0.213318541004,0.430425804856,-0.478339891075,-0.0167552792349,0.778997617131,-0.600549917999,0.52618408419,1.08256539914,1.5728702045,0.841349878168,0.413942750557,-0.0185059550657,0.0240113378128,-1.18467346457,-0.174435260966,-1.10290658444,0.0226729322965,-0.466970953651,-0.0527519654339,0.267423850852,0.0246461513739,-0.102698912921,-0.155424498688,0.0766845633239,-0.370694825119,0.11816758807,0.112318302051,0.532657666722,0.328138683642,0.213909605281,0.119438003868,0.0861016283135,-0.0427466968203,-0.00716761959002,-0.284825252404,0.0653628182213,-0.36382234142,0.0187207036644,-0.172712645184,-0.123473420551,0.131588746724],[-29250.9390307,270.025846382,732.021388948,-368.50820238,576.466781216,1125.96019261,273.418016828,-341.968804082,-352.751136402,-184.009306173,-116.303900841,-187.955187696,-299.909938198,128.089304573,-120.937278264,-89.68890241,87.7342650244,-366.848092724,-120.803413625,72.5941726097,86.9279775199,388.449575983,87.7800005801,199.573842358,-75.168568739,18.5861243933,-87.0654545079,-21.4662945441,-46.2767494284,45.0323637842,88.9182503426,-47.9324059626,10.084652642,3.50695174883,-19.8898647632,-19.5868625376,17.8423239758,24.3705903799,14.3147912156,-19.0245326448,19.5468880901,10.8413658937,-5.32449955029,-4.5319548697,-14.0262809879,-21.2313289816,15.5694600948,-6.15100368225,-8.77717125106,8.39243128736,0.389536864171,12.9165511673,-7.28213462034,15.7446090481,5.80649602162,12.9946154911,1.31606983438,-9.41616562031,-6.92584669178,-5.09570139848,-8.13157946178,0.267280871545,9.20440116708,-1.48379607239,0.543153882425,0.645095650437,1.63814524403,-1.77347232346,4.55667159726,3.16711688446,5.32243204416,0.74773469753,-0.846843813884,-1.50174822349,-1.4420474197,-4.0132940508,-0.445403468059,-1.08778857915,-0.865944598857,0.203759275196,0.433219103571,-0.501284463912,-0.00840011056157,0.770120039147,-0.591351468847,0.52362562134,1.10452822193,1.56573000456,0.830506646941,0.409497384489,-0.0677898946251,0.0333499983928,-1.21730489797,-0.155302894009,-1.1114352085,0.0353671439605,-0.480248215222,-0.0530659766314,0.264981512233,0.0299301464969,-0.104706394099,-0.155896675322,0.0702586341054,-0.37392641552,0.124244483077,0.115079016898,0.529431914196,0.330799858841,0.213430184568,0.111160040742,0.0868069926909,-0.0546003739753,0.000343187119682,-0.293406045166,0.0718807228322,-0.369375535385,0.0209745931522,-0.171059624518,-0.123691898507,0.131237913209],[-29259.5273799,262.286892835,750.529403471,-370.53081977,543.710662169,1120.10026091,279.560141508,-324.742122835,-357.377697659,-174.981695201,-104.85852092,-188.070147092,-306.582445884,121.11203187,-117.535416099,-92.0660577913,95.2307402469,-365.067869499,-123.106351796,76.7892507234,85.40653959,379.423036942,91.7165162455,194.011575958,-74.9789929385,22.1165184645,-87.4111243321,-23.9875487825,-44.8246949735,44.7011248175,86.4968553343,-48.0133869255,9.25423368312,4.78590126686,-20.572982855,-19.3573409568,18.2473997972,23.7276843228,13.7488815401,-18.601825839,18.9494540262,11.1292391867,-5.2928580433,-5.23493291419,-13.3695418319,-22.192457404,15.1053845419,-6.04023173085,-8.60593010992,8.33438162116,0.201407580707,12.8182455689,-6.84016636766,15.5104477548,6.06812714154,12.7829446097,1.12069952401,-9.34227564685,-7.50315460457,-5.07791057581,-8.1258425627,0.212684863616,9.18551152141,-1.49822370714,0.462186728812,0.632153568207,1.62451097247,-1.7021718281,4.52577068365,3.26196215102,5.25055381288,0.669732141198,-0.818553940623,-1.68220499411,-1.43565046227,-4.06424414224,-0.435148488897,-1.11201992705,-0.846497048682,0.193231854332,0.435045146602,-0.523843968978,-5.160835783e-05,0.76186361108,-0.581646807941,0.52079556889,1.12703053996,1.55816660875,0.818213577302,0.405133489491,-0.115644662819,0.0441654759799,-1.2484229888,-0.137314876304,-1.11778796144,0.0475060804117,-0.493288943006,-0.0531795477295,0.261935950617,0.0348043440372,-0.107077988248,-0.156502663967,0.0637857137381,-0.376743887239,0.130101285006,0.118341422556,0.526173846833,0.333246788149,0.213252227203,0.103064552529,0.0879515541115,-0.0661711806224,0.00759542067647,-0.30126447511,0.078043584027,-0.374598875038,0.0232766665501,-0.16957862217,-0.124053443131,0.130716896599],[-29268.0690208,256.975659514,765.923171617,-372.167242487,512.164078312,1113.97452504,287.485211556,-308.207296021,-362.85105259,-167.108066425,-94.6894049354,-188.051657171,-312.977037844,113.904022107,-113.623932696,-94.7756870926,102.722169568,-363.102891916,-126.027131676,81.3674650875,84.0406728276,370.321654481,95.3975167721,188.997012042,-74.7714742322,25.679461222,-87.6677075251,-26.4979192495,-43.2996664203,44.6487278198,84.1124636008,-48.1035326626,8.62570972799,6.05085064328,-21.3394185925,-19.0914910294,18.7167452141,23.1279205045,13.2131071815,-18.1510046542,18.4525966226,11.387557205,-5.23657589519,-5.88951379597,-12.7304385073,-23.128067836,14.6177051089,-5.9261943779,-8.42120247025,8.29657764523,0.0373834685957,12.742109333,-6.40010375073,15.2892352908,6.32533688508,12.5704693524,0.923303095524,-9.27434773979,-8.06520676395,-5.0598425932,-8.11627235314,0.148031052651,9.16384902334,-1.51023223928,0.387474163914,0.623228789367,1.61789631712,-1.62826250344,4.49346832108,3.35501878395,5.18018463807,0.588345200163,-0.793353066197,-1.85581564767,-1.42675079686,-4.11203392477,-0.428058735283,-1.1323129842,-0.826457569553,0.181825688257,0.435691150191,-0.545975212275,0.00806663229244,0.754332578306,-0.57128987895,0.517674764742,1.15011297796,1.55031777869,0.804457859307,0.401220558187,-0.161998655444,0.0566568422952,-1.27772481641,-0.120595575662,-1.12170019245,0.0589244652438,-0.506191585314,-0.053054427798,0.258388843681,0.0392538779551,-0.109799038513,-0.157323190186,0.0572641838441,-0.379185053249,0.135754601892,0.122121639444,0.52281119329,0.335528822623,0.213413891844,0.095170594265,0.0895849166963,-0.077408123264,0.0145554988056,-0.308293268607,0.0837634766575,-0.379533012201,0.0256441957316,-0.168241698736,-0.12456491966,0.13002887033],[-29275.8773571,254.954560391,777.678859678,-372.997477871,482.418430962,1107.8761863,297.325468455,-292.217136894,-369.170352916,-160.059520096,-86.0630015422,-187.915367242,-319.05825993,106.496461524,-109.193386912,-97.8064626075,110.217219544,-360.981355897,-129.589213251,86.3139858074,82.8675625789,361.187104714,98.8099636031,184.573262213,-74.5522850843,29.2694646415,-87.8339330529,-29.0035731148,-41.6973533872,44.8562958155,81.7845513542,-48.208550602,8.22559977591,7.29799930677,-22.1872707976,-18.7972947394,19.2494026766,22.5752326866,12.706383494,-17.6711207526,18.05681686,11.6159657426,-5.14773471572,-6.48714846181,-12.112072829,-24.039263287,14.1111787331,-5.80714138701,-8.22616504248,8.28010419763,-0.101708210574,12.6890462756,-5.95880291825,15.0807265606,6.57703985275,12.3606837448,0.725139924104,-9.2121695978,-8.61117469659,-5.0400756344,-8.10126524402,0.0738788007915,9.13931791393,-1.52085959464,0.319190831583,0.618246270731,1.61849195453,-1.55101090897,4.45983793011,3.44597264301,5.1123747576,0.50376149089,-0.770671172306,-2.02267625722,-1.41504792158,-4.15641747598,-0.424350183114,-1.14859664615,-0.806192753452,0.169610624754,0.435011589095,-0.5676262816,0.0157610325811,0.747577304257,-0.560188303469,0.514258042532,1.17375652901,1.54230627954,0.789261137154,0.398060627146,-0.206786874848,0.0709491584259,-1.30495467217,-0.105239198135,-1.12301124487,0.0694644437195,-0.51903333124,-0.0526578541504,0.254439028672,0.0432755608165,-0.112849190297,-0.158421139847,0.0506918847393,-0.381289171869,0.141211654057,0.126411765142,0.519282278078,0.337675546852,0.213946861944,0.0874958571214,0.0917409602932,-0.0882621011702,0.0211973243218,-0.314407513038,0.0889672421886,-0.384207815056,0.0280928881184,-0.167020643147,-0.125219993217,0.129172739441],[-29282.2391626,255.530296403,786.769039901,-372.745793636,454.296549236,1101.87726349,308.529601439,-276.795925768,-375.962563984,-153.665738897,-78.8619289111,-187.735081439,-324.742006623,99.0375359186,-104.442651027,-101.165212544,117.734978418,-358.720945642,-133.788164222,91.5105621331,81.9021270973,351.995760546,101.911321579,180.7198452,-74.3379276639,32.8905565145,-87.9053957165,-31.5051797676,-40.026941367,45.3073432386,79.5268782472,-48.3250322505,8.03278056576,8.51436341283,-23.0988136832,-18.4843590188,19.8426710888,22.067006127,12.2294287617,-17.1571927781,17.7574585193,11.8215583132,-5.02835989475,-7.02678662991,-11.5198114453,-24.919590302,13.5911601385,-5.6839468129,-8.02426048454,8.28294164489,-0.216080220752,12.6567690579,-5.51582033248,14.8845473546,6.82231875205,12.1553766916,0.527400859645,-9.15431016109,-9.13982245067,-5.0173025574,-8.08131160925,-0.00860787246748,9.10994202683,-1.53044205903,0.257248223392,0.616848159765,1.62580000781,-1.470599317,4.42503569962,3.53452716914,5.04753456151,0.41687989604,-0.750115476822,-2.18268484409,-1.40034656694,-4.19721618161,-0.423558043016,-1.16139066369,-0.786050891947,0.156578263358,0.433129972115,-0.588710391922,0.0229580788034,0.741432624583,-0.548464414786,0.510596218827,1.19770365965,1.5341948907,0.772782871611,0.395685908736,-0.249970749573,0.086871442924,-1.33004569561,-0.0912193027248,-1.12197643876,0.0789978477774,-0.531806333017,-0.0519790170748,0.250173981117,0.0469129196087,-0.116185298009,-0.159788040057,0.044064491514,-0.383101282793,0.146442110944,0.13110780587,0.515567809123,0.33963747954,0.214856920149,0.0800525768066,0.094390667657,-0.098691584681,0.0275247403982,-0.319611739816,0.093640788538,-0.388610017226,0.0306321933265,-0.165886157672,-0.125959528468,0.128130335365],[-29286.4345537,257.620640227,794.540386021,-371.172522587,427.429119205,1095.99447979,320.375411679,-262.010809722,-382.761604544,-147.796051117,-72.8728475916,-187.599142603,-329.932009559,91.704680978,-99.6226756791,-104.863304089,125.297139854,-356.33671742,-138.612579219,96.8130881007,81.1537178627,342.70766908,104.651681388,177.400381514,-74.147461566,36.5491435863,-87.8769067755,-34.0020341519,-38.3009898207,45.9859823762,77.3517747929,-48.4472901345,8.01421827133,9.6846632987,-24.0523653094,-18.1626970367,20.4934134682,21.598988958,11.783412001,-16.60323112,17.5485760814,12.0132903605,-4.88296276721,-7.50925271136,-10.9595872132,-25.7607063098,13.0631534951,-5.55814078308,-7.81899794124,8.3022942357,-0.306205332273,12.6421925523,-5.07138753412,14.7002911847,7.06029831726,11.9559108172,0.331259620723,-9.09903368024,-9.64981220472,-4.9902448888,-8.05742531352,-0.0981137832918,9.07327509383,-1.53914050824,0.20149204285,0.618605901602,1.63915046169,-1.38743892801,4.38923851054,3.62039019855,4.9859144779,0.328777114827,-0.731337506662,-2.33568991673,-1.38247777155,-4.23426825448,-0.425047334299,-1.17136250144,-0.766375701498,0.142700641539,0.430237066566,-0.609132040006,0.0296142735301,0.73567949299,-0.536294224114,0.506754105932,1.22163720474,1.52603139508,0.755216977587,0.394061159275,-0.291518314709,0.104178703707,-1.35297823828,-0.078479286674,-1.11895508831,0.0874039310248,-0.544481483661,-0.0510125951028,0.245678336112,0.0502211599246,-0.119758518312,-0.161397578228,0.0373771379523,-0.384667871062,0.151406254281,0.136081745008,0.511659090206,0.341345372919,0.216143373905,0.0728516251628,0.097489297269,-0.108656936904,0.0335490752978,-0.323932841362,0.0977847902362,-0.392715568695,0.0332699965199,-0.164808672913,-0.126711189961,0.126879221137],[-29287.7436468,260.14336454,802.339571771,-368.037997531,401.44682694,1090.24455838,332.140700346,-247.928935836,-389.101393348,-142.319785045,-67.8824181337,-187.595893574,-334.532000373,84.6753323889,-94.9844115065,-108.912104429,132.925397516,-353.8437275,-144.051052871,102.077457746,80.631686355,333.282877419,106.981133721,174.578491665,-73.9999463857,40.2516326024,-87.7432774893,-36.4934312117,-36.5320582095,46.8763255148,75.2715715044,-48.5696367802,8.13687906643,10.7936193016,-25.0262437368,-17.8423219622,21.1984928323,21.1669293116,11.3695022281,-16.0032461674,17.4242240271,12.200117328,-4.71605466801,-7.93537111724,-10.4373329897,-26.5542687392,12.5326629735,-5.43125342504,-7.6138865574,8.33536621872,-0.372556315473,12.6422316314,-4.62573606384,14.5275515626,7.29010328266,11.7636487459,0.137889925915,-9.04460440586,-10.1398061373,-4.95762415516,-8.03062022147,-0.193323747847,9.02687084671,-1.5471158181,0.151767993463,0.623090941376,1.65787330093,-1.30194094252,4.35262324382,3.70326956745,4.92776493487,0.240529846461,-0.713988788743,-2.48153998357,-1.36127257401,-4.26741190739,-0.428183076273,-1.17917962401,-0.747510898568,0.127949796769,0.426523639761,-0.628795722617,0.0356861193322,0.730098863186,-0.523853742666,0.502796516147,1.24523999917,1.51786357564,0.736757369991,0.393151135077,-0.33139760535,0.122625948694,-1.37373265173,-0.066962547224,-1.11430650773,0.0945619470689,-0.55702967619,-0.0497532667661,0.241036728754,0.0532554873569,-0.123520007869,-0.163223441774,0.0306249578382,-0.386035421716,0.156064365797,0.141205565937,0.507547425106,0.342729979225,0.217805530656,0.0659038740322,0.100992107611,-0.118118520947,0.0392816572832,-0.327397710099,0.101399921814,-0.396500419445,0.0360141828631,-0.163758619476,-0.127402642248,0.125396959792],[-29285.4465584,262.01624202,811.513270885,-363.102551274,375.980358509,1084.64422243,343.103268609,-234.617451188,-394.515849148,-137.106268971,-63.6773010869,-187.813677193,-338.445710702,78.1269258383,-90.7788091471,-113.322980751,140.641445071,-351.257032151,-150.092179808,107.159565106,80.3453840543,323.681432668,108.849769266,172.217796163,-73.9144417181,44.0044303081,-87.4993191175,-38.9786658909,-34.7327059946,47.9624849413,73.2985988945,-48.686384714,8.36772912485,11.8259517588,-25.9987670257,-17.5332469643,21.9547721987,20.7665753199,10.9888684595,-15.3512483095,17.3784568373,12.3909946594,-4.53214693206,-8.30596625861,-9.95898163158,-27.291935019,12.0051927438,-5.3048148663,-7.41243547781,8.37936184263,-0.415605940689,12.6538011676,-4.17909746233,14.3659220003,7.51085838251,11.5799531022,-0.0515345062037,-8.98928658852,-10.6084664268,-4.91816188307,-8.00191019778,-0.2929225823,8.96828301726,-1.5545288644,0.107921778737,0.629874724218,1.68129851027,-1.21451656102,4.3153667804,3.78287311208,4.8733363605,0.153214790157,-0.697720849982,-2.62008355304,-1.33656201291,-4.29648535314,-0.432330288247,-1.185509496,-0.729800199619,0.112297766519,0.422180459014,-0.647605936517,0.0411301187806,0.724471688876,-0.511318981654,0.498788261776,1.2681948778,1.50973921529,0.717597963733,0.392920592461,-0.369576656587,0.141968185801,-1.39228928751,-0.0566124816161,-1.10839001124,0.100351149517,-0.56942180362,-0.0481957105965,0.236333794142,0.0560711074985,-0.127420923343,-0.165239318108,0.0238030849558,-0.387250419795,0.160376727217,0.146351252036,0.503224117605,0.343722050691,0.219842697847,0.0592201952571,0.104854357164,-0.127036699918,0.0447338146172,-0.330033238449,0.104486857802,-0.399940519462,0.0388726375202,-0.162706427964,-0.127961549878,0.123661114363],[-29279.2367863,262.48872251,823.020686248,-356.312896859,350.688034877,1079.2063774,352.781316267,-222.03483135,-398.671409407,-132.037120267,-60.0652205978,-188.28855118,-341.642821671,72.2193358651,-87.1836184283,-118.093873925,148.445889278,-348.597908289,-156.696754674,111.933657534,80.2987186402,313.891293237,110.218969103,170.273139138,-73.9075741457,47.8035267355,-87.1451173467,-41.4549059432,-32.9142486566,49.2247098575,71.4395262577,-48.7976946698,8.6768407704,12.7648849242,-26.950111395,-17.2452301599,22.7556953961,20.3937410048,10.6411854957,-14.644735048,17.40335444,12.5922470316,-4.33654652297,-8.62193428085,-9.52875352599,-27.966547652,11.4860355611,-5.17917113118,-7.2177397595,8.43125446365,-0.436266655377,12.6734613401,-3.73210111892,14.2146890236,7.72143077438,11.4055278944,-0.23567535721,-8.93172034712,-11.0543895956,-4.87076766972,-7.97152786209,-0.395750328896,8.89559434713,-1.56151139375,0.0696428561476,0.638596499118,1.70858253836,-1.12572019172,4.27767960978,3.85876570544,4.82264645072,0.0677456706521,-0.682178906858,-2.75109984587,-1.30827525122,-4.3212601675,-0.437017210161,-1.19102114296,-0.713560375736,0.0956566726806,0.417405797611,-0.665494355402,0.0459386451631,0.718598383425,-0.498869953704,0.494783053652,1.29015499804,1.50169770059,0.697881054659,0.393319674473,-0.406021320263,0.161942589649,-1.40864974549,-0.0474038511466,-1.10152405715,0.104685521399,-0.581634380754,-0.0463343747742,0.231652855866,0.0587271442367,-0.131408917529,-0.167418532666,0.0169142899443,-0.388352991358,0.164315705105,0.151388197406,0.498688269896,0.344250533855,0.22223639171,0.0528020651898,0.109015365808,-0.135381181845,0.0499019321132,-0.331880594441,0.107049790188,-0.403021751324,0.0418418699818,-0.161618280527,-0.128329301767,0.12166304163],[-29270.4613545,262.136964513,836.271137346,-348.361268274,325.338716576,1073.9286578,361.654637632,-209.704865857,-401.764586445,-127.043112648,-56.9381552005,-188.847432781,-344.35681236,67.042192417,-84.0837859353,-123.169019554,156.25498928,-345.912515407,-163.714372172,116.347395655,80.4738225918,304.012062769,111.095275864,168.664259196,-73.9862382006,51.6032450628,-86.7018555724,-43.9108103619,-31.0830257544,50.6277971253,69.6783780132,-48.927120211,9.04671092698,13.5876587184,-27.8678856988,-16.9870094568,23.5810294979,20.0445039471,10.3201512742,-13.8951523331,17.4830985506,12.7996760541,-4.13774291905,-8.88445826638,-9.14401918035,-28.5756894373,10.9796385195,-5.04993183126,-7.03123810835,8.48709386826,-0.437209615491,12.6963535541,-3.28696781753,14.0719112143,7.91965730896,11.2384426667,-0.412535909294,-8.87204927374,-11.4759095407,-4.81510339477,-7.93658085389,-0.501267934195,8.8090036174,-1.56807863587,0.0359956990375,0.649166730492,1.73818768945,-1.03667907372,4.23990665573,3.92994036775,4.77478197275,-0.0156156852049,-0.666982934112,-2.874090932,-1.27673394934,-4.34124137818,-0.442424964473,-1.1963898342,-0.6990004165,0.0776989748236,0.412427952727,-0.68250136068,0.0502475546343,0.712357198825,-0.486702677099,0.490790196729,1.31065480735,1.49374483255,0.677542462366,0.39424007109,-0.440688715227,0.18221500166,-1.4229006188,-0.0394368733309,-1.09386368022,0.107617963427,-0.593666409524,-0.0441627860732,0.227071991498,0.0612983946379,-0.135417627746,-0.169732962975,0.00999189086534,-0.389357826546,0.167902005364,0.156175439023,0.493970177827,0.34423715247,0.224896963625,0.0466133782232,0.113350699013,-0.143159054448,0.0547226207872,-0.333038048543,0.109106980783,-0.405769727996,0.0448728870441,-0.160443365502,-0.128502184294,0.119449273342],[-29260.8806684,261.8688037,850.286472814,-340.126279742,299.728899033,1068.80488041,370.443425643,-197.042672739,-404.124411295,-122.067308913,-54.2091470257,-189.264954122,-346.887111339,62.6675642936,-81.291057443,-128.479226925,163.963917316,-343.253233643,-170.966827018,120.366793413,80.8473845879,294.171256216,111.496522573,167.30211856,-74.1548954019,55.3474917548,-86.195991617,-46.3329109499,-29.2441328664,52.1326805216,67.9935173616,-49.1040631084,9.46294266851,14.2700169787,-28.7415569495,-16.7670677108,24.4071223888,19.7150076177,10.0179695168,-13.1174332275,17.5998963318,13.0064525698,-3.94502122731,-9.09479303195,-8.80043663224,-29.1181282479,10.4902372978,-4.91152247494,-6.85395514246,8.54269895044,-0.421545654104,12.7172645216,-2.84631619073,13.9353401682,8.10311726023,11.0761083468,-0.579954844801,-8.81079282875,-11.8712945029,-4.75101900851,-7.89339556763,-0.609091570839,8.70923861904,-1.57421669128,0.00588853471791,0.661563686612,1.76840273171,-0.948663653829,4.20242645055,3.99524715603,4.72859696163,-0.0967704250393,-0.651746596045,-2.98848959368,-1.24235789202,-4.35586737583,-0.448897894273,-1.20229239994,-0.686302366114,0.0580372169381,0.407482727506,-0.698694510693,0.0542285740661,0.70564584673,-0.475017171536,0.486807894494,1.32919907572,1.4858780158,0.656466387391,0.395558859019,-0.473533777079,0.202433429961,-1.43514974891,-0.0328431297389,-1.08552305933,0.109236105738,-0.605522513651,-0.0416742409162,0.222667967105,0.0638635740627,-0.139377187442,-0.172154124581,0.00307684263561,-0.390273256519,0.171168418733,0.160569424583,0.489107935663,0.343601824592,0.227716973758,0.0406086332599,0.11771998365,-0.150386750365,0.0591175482057,-0.33361814683,0.110680208857,-0.408219995042,0.0479053198293,-0.159126622774,-0.128490208202,0.117080134997],[-29252.2551336,262.59207574,864.088541286,-332.486545487,273.655077674,1063.82886202,379.867873238,-183.463370022,-406.07991499,-117.05277186,-51.7912382043,-189.315747328,-349.533147178,59.1675202947,-78.6171787262,-133.955305325,171.467845626,-340.672443134,-178.275913928,123.95786475,81.3960933073,284.496388529,111.440542253,166.097679455,-74.4180072691,58.9801732764,-85.6539833031,-48.7077395101,-27.4026655711,53.7002938232,66.3633075035,-49.3579251329,9.91113906892,14.7877035424,-29.5605921596,-16.5938877776,25.2103219534,19.4013954872,9.72684394538,-12.326510794,17.7359549461,13.2057474216,-3.76766655473,-9.25419339426,-8.49366391923,-29.5926319569,10.0220675747,-4.75836857062,-6.68691547994,8.59388860423,-0.392385604291,12.7309809546,-2.41276487109,13.8027274811,8.26938990216,10.915935863,-0.735770846075,-8.74847047254,-12.2388127229,-4.67836446122,-7.83829839776,-0.718837411468,8.597027143,-1.57991166049,-0.0217704095001,0.675765635754,1.79751643332,-0.86294437885,4.16561752658,4.05353612731,4.68294545241,-0.175619696476,-0.636083556961,-3.09372861317,-1.20556686401,-4.36457655114,-0.45678034265,-1.20940567043,-0.675648268781,0.036283943014,0.402805925097,-0.714141363779,0.0580534303299,0.698362038789,-0.464013456713,0.482834350432,1.34529257313,1.47809465497,0.634537030267,0.397153114965,-0.504511441419,0.222245882675,-1.44550497726,-0.0277542019406,-1.07661637336,0.109627578466,-0.617207316851,-0.0388620357258,0.218517548752,0.0665013978721,-0.14321773007,-0.174653533035,-0.003789899828,-0.391107612436,0.174147735952,0.164426601779,0.484139637664,0.342264468277,0.230588982275,0.0347423292027,0.121982846587,-0.157080702236,0.0630083819353,-0.333733435378,0.111791253678,-0.410408098022,0.0508787994598,-0.157612992227,-0.128303384237,0.114615952089],[-29246.3451554,265.214616302,876.6991914,-326.320679734,246.913747926,1058.99441941,390.648173356,-168.382075736,-407.960128563,-111.942564289,-49.597470867,-188.774444524,-352.594348446,56.6141292201,-75.8738955596,-139.528064041,178.661946448,-338.22252402,-185.463427619,127.086623609,82.0966374287,275.114974657,110.945167927,164.961904105,-74.7800353216,62.4451960924,-85.1022884532,-51.0218278455,-25.5637194467,55.2915708071,64.7661116396,-49.7181080554,10.3769032021,15.1164622468,-30.3144583418,-16.4759525129,25.9669760763,19.0998110262,9.43897828165,-11.5373180951,17.8734815561,13.3907314524,-3.61496400833,-9.36391417005,-8.21935907889,-29.9979684373,9.57936502908,-4.58489562671,-6.53114373888,8.63648172364,-0.352840299127,12.7322895648,-1.98893249118,13.6718247489,8.41605450873,10.7553361431,-0.877822595459,-8.68560166547,-12.5767324413,-4.59698970318,-7.76761573874,-0.830121628724,8.47309698021,-1.58514964402,-0.0480729063056,0.691750846189,1.82381756242,-0.780791695595,4.12985841612,4.1036573386,4.63668148014,-0.25206464714,-0.619607481164,-3.18924077269,-1.16678065006,-4.36680729475,-0.466416652693,-1.2184064759,-0.667220168704,0.0120516970412,0.398633348644,-0.728909478277,0.0618938502974,0.690403486655,-0.453891552327,0.478867768029,1.35844006956,1.47039215467,0.61163859153,0.398899915637,-0.533576643848,0.241300367928,-1.45407414532,-0.0243016715062,-1.06725780117,0.108880011747,-0.628725442843,-0.0357194669244,0.214697502507,0.0692905814268,-0.146869389077,-0.177202703884,-0.0105673816087,-0.391869225456,0.176872747758,0.16760341831,0.479103378093,0.340145001583,0.233405549343,0.0289689649545,0.125998914693,-0.163257342701,0.0663167895426,-0.333496460261,0.112461894515,-0.412369582498,0.0537329570581,-0.155847413744,-0.127951723142,0.112117050113],[-29244.3280211,270.347692661,887.313212753,-322.33734852,219.338665561,1054.3144702,403.197495967,-151.429649952,-410.028453916,-106.658962657,-47.5214283976,-187.521248044,-356.362692098,55.0795521078,-72.8975749256,-145.121191188,185.460138672,-335.930542311,-192.381509747,129.738606491,82.9278890156,266.12656637,110.046534783,163.816661596,-75.2429414991,65.6984726024,-84.5591240037,-53.2615268991,-23.7290736678,56.8740383759,63.1801139648,-50.202773524,10.8503809462,15.2373863691,-30.9976710654,-16.4202270296,26.6583262878,18.8077614644,9.14866197484,-10.7625736854,17.9967805042,13.5561112783,-3.49271545884,-9.4251733637,-7.97342639242,-30.334585281,9.16549923413,-4.38699516926,-6.38741805993,8.66751422614,-0.305677677497,12.716970177,-1.57674577423,13.5405849886,8.54162121781,10.5921950537,-1.00436596384,-8.62272116342,-12.8840878029,-4.5065369508,-7.67855367429,-0.942471886712,8.3385185626,-1.58993477845,-0.0738866292619,0.709473423015,1.84591337399,-0.70323014975,4.09546888213,4.14481632434,4.5887635008,-0.326048518934,-0.601945144399,-3.27458450019,-1.12630483337,-4.36219134106,-0.478054692549,-1.22970656376,-0.661126360623,-0.0149472869768,0.39514633875,-0.743047060843,0.0659013052159,0.68170642534,-0.444804326493,0.47490272999,1.36825966298,1.46275205437,0.587696819864,0.4007026728,-0.560709677168,0.259315014456,-1.46097856021,-0.0225739694486,-1.05749023906,0.107086932379,-0.640079774895,-0.0322445305997,0.211254216206,0.0722918102449,-0.150269564035,-0.179774667338,-0.0172151496867,-0.392563490537,0.179379391114,0.169989853511,0.474030958173,0.337189611301,0.236072614871,0.0232482289805,0.129643977729,-0.168933931502,0.0689857035657,-0.333001835049,0.112715413928,-0.414132590339,0.0564169113494,-0.153786426738,-0.127449980317,0.109640556649],[-29245.0485446,277.416298516,895.8171588,-320.565425143,190.912627736,1049.8783353,416.70091916,-133.099920908,-412.285776432,-101.041098059,-45.3788591904,-185.858641045,-361.100348632,54.6363189496,-69.6230686368,-150.629890198,191.851327788,-333.72230751,-199.003689732,131.977440122,83.8774536707,257.518862711,108.853986672,162.62744846,-75.798689423,68.7439389445,-84.0097433459,-55.4124641738,-21.8872417931,58.4415959344,61.5827826527,-50.7851226958,11.3398893964,15.152966945,-31.624940127,-16.4276054699,27.2851887012,18.5282090674,8.8585273838,-10.0061380862,18.0985448526,13.7027366094,-3.39278983194,-9.43904173024,-7.75275511554,-30.6096489549,8.78037534095,-4.16642279502,-6.25553067389,8.68889012306,-0.252294101535,12.6847750667,-1.17536380608,13.4077669024,8.64832362281,10.4262982154,-1.11532557627,-8.56042490429,-13.1629765674,-4.40581748504,-7.57183704509,-1.05506181541,8.19573288585,-1.59434334458,-0.0991828554298,0.728790818626,1.86368507017,-0.630300682522,4.06253361004,4.17764052868,4.53856765412,-0.397682930871,-0.582775768197,-3.34982080633,-1.08398819079,-4.35113379928,-0.491556430591,-1.24265735004,-0.657180141424,-0.0446020149832,0.392308385844,-0.756524911382,0.0701462438355,0.672361183306,-0.436716041005,0.470919335897,1.37482276327,1.45509243285,0.562803656543,0.402570138464,-0.585992262992,0.276288433445,-1.46639339182,-0.0224869245536,-1.04707145294,0.10436545381,-0.651266234465,-0.0284540214991,0.208112564768,0.075493650473,-0.153384718985,-0.182348512255,-0.0236947586308,-0.39318405782,0.181716187872,0.171610013289,0.468929006958,0.333449559172,0.238549637739,0.017560567995,0.132858477021,-0.174131036784,0.0710431164288,-0.332272443291,0.112581107644,-0.41569564864,0.0589177314707,-0.151432968741,-0.126831889782,0.107230807607],[-29246.7684215,285.548859169,902.270523959,-320.863834714,161.655691951,1045.79443649,430.036498055,-114.102458888,-414.667352363,-94.9073152517,-42.9660528928,-184.194676893,-367.062036935,55.3570519757,-66.0098497135,-155.942243331,197.843165937,-331.49831499,-205.333843932,133.886273785,84.9351203812,249.25159954,107.495169611,161.37066809,-76.4367431352,71.5975371916,-83.4311589852,-57.4600863129,-20.0234209772,59.9947360135,59.951406871,-51.4271166052,11.8582884518,14.8710444504,-32.2160238798,-16.4974642333,27.8532730755,18.2654798598,8.57329259485,-9.26965731059,18.1735648433,13.8329929288,-3.30357281709,-9.40655321236,-7.55448074759,-30.8320056445,8.42303239505,-3.92640011837,-6.13502733411,8.70373044918,-0.193743039182,12.6364496223,-0.783253763255,13.2723306136,8.73932618105,10.257906187,-1.21104324634,-8.49932412144,-13.4162623985,-4.29343485295,-7.44907038112,-1.16697653625,8.04752358664,-1.59846965929,-0.123708762744,0.74953632224,1.8773323399,-0.561798333993,4.03107851592,4.2031128732,4.48557450077,-0.467121596241,-0.561791685528,-3.41513634748,-1.03956529765,-4.33423312234,-0.506687360252,-1.25634516794,-0.655121058526,-0.0767018029076,0.390028517811,-0.769294478118,0.074678859282,0.662496612375,-0.429543806076,0.466894064549,1.3783141083,1.44731550375,0.537092590992,0.404537399694,-0.609531480134,0.292289356692,-1.47050727568,-0.0239132150498,-1.03568792614,0.100838586149,-0.662279002562,-0.0243694340348,0.205167044882,0.0788666384148,-0.156188584088,-0.184904842152,-0.0299682649067,-0.393721641242,0.183934806107,0.172521535195,0.463797860466,0.32900237567,0.240809456571,0.0118916182751,0.135599016787,-0.178870053795,0.0725382855275,-0.331313236029,0.112089774681,-0.417049880802,0.061231974162,-0.148801576813,-0.126135930212,0.104928940981],[-29247.7493477,293.873799923,906.732802648,-323.091502343,131.587915709,1042.17119553,442.082287774,-95.1468341732,-417.108437963,-88.0759589892,-40.0792991519,-182.937408954,-374.502475889,57.3143734162,-62.0173911758,-160.946332847,203.44330526,-329.159060126,-211.375848707,135.548256763,86.0906781343,241.284512717,106.097729616,160.022723879,-77.1465666775,74.2752094166,-82.8003834268,-59.3898399592,-18.1228083748,61.5339511437,58.2632757878,-52.0907162868,12.4184380119,14.3994593609,-32.7906806774,-16.629179719,28.3682891695,18.0238998661,8.29767569428,-8.55477737183,18.2166307183,13.94926572,-3.21345010371,-9.32874175275,-7.37573878792,-31.0105015356,8.09250944197,-3.6701487537,-6.02545379396,8.7151562393,-0.131077958382,12.5727392321,-0.398882822248,13.1332362457,8.81779334982,10.0872795278,-1.29186078764,-8.44003004827,-13.6468089597,-4.16799260163,-7.31185821232,-1.27730117069,7.89667430161,-1.60240803943,-0.14721152914,0.771543223076,1.88705487213,-0.497518144249,4.00112951582,4.22221627945,4.42926460141,-0.534518228333,-0.538685229366,-3.47071777998,-0.992770729243,-4.31208776318,-0.523212974964,-1.26985635067,-0.654688659351,-0.11103596668,0.388215762537,-0.781307209272,0.0795493446814,0.65224156437,-0.423204731917,0.462803394749,1.37891843594,1.43932348068,0.510697112634,0.406639543558,-0.631434407408,0.307386515994,-1.47350884735,-0.0267255191659,-1.023026142,0.096629339506,-0.673112260195,-0.0200122626192,0.202312153239,0.0823813103741,-0.158654889508,-0.187424260549,-0.0359977249803,-0.394166954741,0.186086913893,0.172782056776,0.458637854711,0.323925591271,0.242824909989,0.0062270160975,0.137822201245,-0.183172377784,0.0735204682577,-0.330129164304,0.111272214058,-0.418186410228,0.0633561961632,-0.145906788013,-0.125400580284,0.102776094765],[-29246.2530187,301.519546082,909.263489284,-327.107353143,100.729356512,1039.11703417,451.716343435,-76.942617046,-419.544289484,-80.3653740267,-36.514887615,-182.494890592,-383.67638438,60.5809055012,-57.6051660439,-165.530241007,208.659397897,-326.605038293,-217.133580415,137.046538341,87.3339159174,233.577338102,104.789312704,158.560019221,-77.9176240919,76.7928976924,-82.0944291759,-61.1871717559,-16.1706011405,63.0597338556,56.495678571,-52.7378827748,13.033197976,13.7460521523,-33.3686688731,-16.8221283265,28.8359467422,17.8077951109,8.03639476838,-7.86314428303,18.2225327197,14.0539404663,-3.11080738123,-9.2066412941,-7.21366473587,-31.1539828139,7.78784552723,-3.4008903154,-5.92635580677,8.7262885282,-0.0653523270798,12.4943892844,-0.0207181595686,12.989443922,8.88688958644,9.91467879674,-1.35812001378,-8.38315391816,-13.8574799148,-4.02809427814,-7.16180506865,-1.38512084015,7.74596866743,-1.60625280187,-0.169438332553,0.79464481035,1.8930523558,-0.437255153373,3.9727125258,4.23593366901,4.36911851674,-0.600026540439,-0.513148732682,-3.51675176019,-0.943339060872,-4.28529617473,-0.540898768158,-1.28227723142,-0.65562249132,-0.147393822229,0.386779147905,-0.792514553066,0.0848078931595,0.641724891113,-0.417615928742,0.458623805295,1.37682048406,1.43101857727,0.483750710893,0.408911657124,-0.651808123629,0.321648643148,-1.47558674238,-0.0307965151305,-1.00877258383,0.0918607239911,-0.683760188371,-0.0154040016645,0.199442386528,0.0860082026548,-0.160757365405,-0.189887370964,-0.0417451953173,-0.394510712255,0.188224179305,0.172449215582,0.453449325708,0.31829673645,0.244568836618,0.000552397739143,0.139484634613,-0.187059403998,0.074038922015,-0.32872517916,0.110159224794,-0.419096360318,0.0652869542142,-0.142763139402,-0.124664318673,0.100813406954],[-29240.949687,307.814063803,909.975017618,-332.62917611,69.2003508977,1036.67447334,458.262400255,-60.0737845469,-421.869365081,-71.6564719719,-32.1255276001,-183.161398865,-394.70600729,65.1796544428,-52.7450679673,-169.609204958,213.488046848,-323.758309942,-222.595137157,138.458141538,88.6564015463,226.094356193,103.669897097,156.971639218,-78.7415787189,79.1624365811,-81.2952362492,-62.841151552,-14.1532725362,64.5702762833,54.6359483853,-53.3389162533,13.7154591825,12.921435171,-33.9607103352,-17.0744839117,29.2595327573,17.6211192417,7.79186746052,-7.19575341639,18.1876866616,14.1503783662,-2.98745426579,-9.04239840402,-7.06583473174,-31.2691388862,7.50780208364,-3.121469693,-5.83701338857,8.73918556382,0.00255502637636,12.4016653129,0.351973482069,12.8402850955,8.94922178447,9.74045063383,-1.41033445279,-8.32902429796,-14.050185605,-3.87295911673,-7.00030909929,-1.48981862477,7.5979090944,-1.60994338705,-0.190109968486,0.818633421205,1.89533296024,-0.380960644697,3.94583486642,4.24508018072,4.30481189,-0.663760995117,-0.485012141561,-3.55339863031,-0.891265697288,-4.25434790649,-0.559656383988,-1.29286390074,-0.657734742128,-0.185504967403,0.385692602908,-0.802818137648,0.0904932988675,0.631029016624,-0.412696380671,0.454313468446,1.37215466986,1.42232413385,0.456363421989,0.411361520981,-0.670721760073,0.33510370954,-1.47687513074,-0.0360140931577,-0.992736026673,0.0866383204881,-0.694213875749,-0.0105747429646,0.196477869371,0.0897216249133,-0.162455780766,-0.192269663536,-0.0471732910374,-0.39473641462,0.190376102176,0.171559051706,0.448235104913,0.312181188875,0.2460239188,-0.00514298638762,0.140552637403,-0.190541023899,0.0741308592324,-0.327113689769,0.108772851395,-0.41977357336,0.0670178773479,-0.13938647101,-0.123964790303,0.099072731808],[-29232.1438331,312.883482658,909.191578725,-338.810215789,37.5223515517,1034.62243063,462.826913837,-44.6219407492,-423.814930519,-62.0804318423,-26.9896071076,-184.776105607,-407.1836935,70.9351623806,-47.4586731116,-173.207081395,217.881658551,-320.627195828,-227.685503999,139.83558433,90.0568181519,218.818026038,102.728789848,155.2973958,-79.6188910949,81.3792306023,-80.4044547091,-64.3553420202,-12.0624002522,66.0545689741,52.7115943828,-53.8974735042,14.4782362269,11.9473082469,-34.5413809915,-17.3796101563,29.6326429976,17.4663363969,7.55730964237,-6.55099758037,18.1150106466,14.2458434799,-2.84889608029,-8.84261014979,-6.93158747966,-31.3540320452,7.25003009315,-2.83322487648,-5.75564360601,8.75165444669,0.0724638320108,12.292913432,0.716727095124,12.6865765381,9.00516658249,9.56528600303,-1.44970449055,-8.27683908849,-14.2230230828,-3.70426910036,-6.82794293036,-1.59196943943,7.45387308749,-1.61279972965,-0.208841702716,0.843137584465,1.89313877639,-0.329210874549,3.92042947611,4.24979982244,4.23680069488,-0.725679052002,-0.454655854533,-3.58071347588,-0.837589361018,-4.21929689424,-0.579982069495,-1.30155147856,-0.661128160567,-0.224860127715,0.385189660963,-0.811920310866,0.0965987600589,0.620050653705,-0.408372567452,0.449757330283,1.36485412794,1.41324799757,0.428551469333,0.413887689808,-0.688092657871,0.347616644909,-1.47729032008,-0.0423269914022,-0.975214412403,0.0809979929762,-0.704452041581,-0.00558896783917,0.19344123812,0.0935109802169,-0.163654059876,-0.194526174894,-0.0522468618752,-0.394798710255,0.192483509367,0.170061215411,0.443008005538,0.305595714992,0.247212213763,-0.0108554293284,0.141031395305,-0.193581113802,0.0737853124916,-0.325336937825,0.107100120319,-0.420222767177,0.0685308837684,-0.135797834753,-0.123336305094,0.0975487886583],[-29220.5484939,317.053473074,907.290303011,-344.662580612,6.31709019605,1032.67392279,466.962019877,-30.5430964846,-425.071453464,-51.830999508,-21.2419338089,-187.064406341,-420.569317889,77.6223554363,-41.7799782721,-176.3748819,221.781590302,-317.241581784,-232.313887746,141.225258427,91.5356276935,211.73535132,101.927630215,153.589782608,-80.552221055,83.4345767648,-79.4286621296,-65.7369290394,-9.89083808588,67.4993020785,50.7601697123,-54.4255504591,15.334574644,10.8481430806,-35.0762202847,-17.7296681985,29.9464504506,17.345538338,7.32363674264,-5.92661894248,18.0090483493,14.3485755826,-2.70406207436,-8.6149862236,-6.81070232469,-31.4045678047,7.01190292498,-2.53711713096,-5.68019778842,8.76043949047,0.144368459442,12.1659999013,1.07027810585,12.5295063511,9.05454305535,9.38996194929,-1.47760222738,-8.22551352403,-14.3731360784,-3.52432189914,-6.64507280716,-1.69244615767,7.31495692532,-1.61398688792,-0.225222418586,0.867744876882,1.88552037558,-0.282738342502,3.89641069778,4.25006881929,4.16573598764,-0.785698919997,-0.422597883237,-3.59872506827,-0.783609604034,-4.18008817034,-0.602518222443,-1.30844484215,-0.665978135702,-0.264890310595,0.38556875659,-0.819473600496,0.103106076012,0.608640087353,-0.404572842742,0.444822030345,1.35480167225,1.40381914229,0.400307623131,0.416361411805,-0.703800210614,0.359011618581,-1.47669415249,-0.049699160004,-0.956627974591,0.0749581762084,-0.714450312773,-0.000519754989396,0.190380757061,0.0973694449857,-0.164242165845,-0.196606828289,-0.0569313162189,-0.394645034478,0.1944650595,0.167883759504,0.437783336235,0.298544928439,0.248165622456,-0.0165776099935,0.140935810302,-0.196132046235,0.0729792694118,-0.323444623153,0.105119303513,-0.420451378479,0.0698049639726,-0.132019585516,-0.122812339213,0.0962270131033],[-29206.8767066,320.649705476,904.648320884,-349.198379008,-23.7937014471,1030.54196658,472.219854074,-17.7932625847,-425.329401583,-41.101920839,-15.017315375,-189.751696593,-434.322755335,85.0161597315,-35.7429802436,-179.163618054,225.129199398,-313.631353641,-236.389495206,142.673555541,93.0932921306,204.833335726,101.228057456,151.90129328,-81.5442284344,85.3197720773,-78.3744360844,-66.9930984883,-7.6314398346,68.8911657472,48.8192275227,-54.9351430495,16.2975199683,9.64841137282,-35.5307676577,-18.1168191764,30.1921281038,17.2608168265,7.08176419007,-5.32035967022,17.8743434445,14.4668144498,-2.56188149759,-8.36723631764,-6.70295861191,-31.4166516785,6.79079394833,-2.23410772156,-5.60862726512,8.76228500884,0.218263278289,12.0187909806,1.4093619405,12.3702626359,9.09717027788,9.21525551755,-1.4953997636,-8.17396283886,-14.4976683218,-3.33541518319,-6.45206497504,-1.79212165308,7.18225688651,-1.61266992012,-0.238840999442,0.892042875205,1.87152832912,-0.242275548132,3.87369287436,4.24586339642,4.09226882457,-0.843738808006,-0.389356239314,-3.60746217884,-0.730625978307,-4.13666676714,-0.627907240595,-1.31364886879,-0.672460056599,-0.305026523475,0.387128324313,-0.825130534313,0.109997046007,0.596647602565,-0.401225560196,0.439374208169,1.34188011672,1.39406654186,0.371624653592,0.418653935174,-0.717723811894,0.369112799884,-1.47494847004,-0.0580945491031,-0.937396946813,0.0685373049378,-0.724184316227,0.00455981688357,0.187344690478,0.10129019564,-0.164110061783,-0.19846154697,-0.0611920624571,-0.394222822608,0.196239411193,0.164954736792,0.432576405657,0.291033442852,0.248916045827,-0.0223022072928,0.140280784379,-0.198146193728,0.0716897176118,-0.321486445578,0.102808672922,-0.420466843974,0.0708191084577,-0.128074078185,-0.122426368829,0.095092840741],[-29191.8415084,323.997850292,901.642762751,-351.429719409,-52.1882916558,1027.93957874,480.152552126,-6.32844988105,-424.279242545,-30.0869417056,-8.45055947726,-192.563371888,-447.903880717,92.8915013877,-29.3816758213,-181.624301439,227.865843134,-309.826397231,-239.821533185,144.226867384,94.7302734225,198.098982938,100.591710828,150.284421456,-82.5975730681,87.0261135486,-77.2483541475,-68.1310362457,-5.27705929577,70.2168501309,46.926320963,-55.4382472069,17.3801177347,8.37258482418,-35.8705625532,-18.5332242283,30.3608489447,17.2142636237,6.82260741339,-4.72996193111,17.7154396069,14.6087998569,-2.43128359959,-8.10707012411,-6.6081356864,-31.3861891806,6.58407653245,-1.92515791341,-5.53888336545,8.75393531548,0.294142658169,11.8491529296,1.73071402532,12.210033494,9.13286732493,9.04194375274,-1.50446919955,-8.12110226726,-14.5937635432,-3.13984662263,-6.24928567932,-1.89186879921,7.05686924967,-1.60801388449,-0.249286328628,0.915619156182,1.85021320835,-0.208554991014,3.85219034877,4.23715977894,4.01705026194,-0.899716924932,-0.355448934405,-3.60695357899,-0.679938035808,-4.08897771699,-0.656791521714,-1.31726843576,-0.680749312323,-0.344699773785,0.390166798655,-0.828543640093,0.117253469321,0.583923484341,-0.398259073473,0.433280503294,1.3259722753,1.38401917014,0.342495330923,0.420636508115,-0.729742855304,0.377744358147,-1.4719151148,-0.0674771088396,-0.917941562644,0.0617538139176,-0.733629678848,0.00957666907854,0.184381302655,0.105266408599,-0.1631477108,-0.200040254188,-0.064994508978,-0.393479509961,0.197725223068,0.161202200083,0.427402522456,0.28306587187,0.249495384825,-0.0280219001367,0.139081219519,-0.199575928809,0.0698936447107,-0.319512104924,0.100146500493,-0.420276600371,0.0715523077207,-0.123983667646,-0.12221187011,0.0941317071695],[-29176.1396016,327.394434835,898.565417488,-350.637985124,-78.3846824058,1024.63413429,491.843017311,3.93318617283,-421.711952886,-18.9662285661,-1.6437312165,-195.280529973,-460.844241143,101.035330612,-22.7505624389,-183.813875053,229.952172215,-305.857085133,-242.538118702,145.930964679,96.4309514054,191.535306299,99.9796955546,148.783182545,-83.7149401009,88.5449764954,-76.052386852,-69.1549147631,-2.82584276354,71.4623004764,45.1178853173,-55.949323018,18.5884065314,7.04182514272,-36.0703871264,-18.9721298059,30.4458948217,17.2074853787,6.5401883498,-4.15534702498,17.5371354862,14.7817455434,-2.32039893803,-7.84152387296,-6.52695442335,-31.3107633518,6.38934391913,-1.61194847587,-5.46912657741,8.73284837851,0.372122230779,11.6556336273,2.03109594065,12.0506432606,9.16149472773,8.87061321347,-1.50630132973,-8.06661910495,-14.6595456836,-2.94029221513,-6.03759438787,-1.99234815907,6.93963494164,-1.5992581557,-0.256270441072,0.938158644758,1.8208604173,-0.182253214258,3.83199808215,4.2238089261,3.94076294861,-0.953615329953,-0.321436842813,-3.59736008386,-0.632857450885,-4.03715380351,-0.689655411675,-1.31947579839,-0.690928198485,-0.383430691143,0.394924759338,-0.829414830649,0.124842830903,0.570334258095,-0.395641965465,0.426487770452,1.30698160504,1.37374600415,0.312943017974,0.422188220251,-0.739774820985,0.38468183069,-1.46748865045,-0.0778323510705,-0.8986549112,0.0546358057768,-0.742784557684,0.0144706420688,0.181534724279,0.109294670731,-0.161269282437,-0.201299596743,-0.0683200604974,-0.392374073884,0.198854928101,0.156573436555,0.422283664049,0.274649181656,0.249926172387,-0.0337247464632,0.137339167175,-0.200385515698,0.067571724633,-0.317575749262,0.0971219016277,-0.419901466753,0.0719920793289,-0.119777242633,-0.122192589171,0.0933293601755],[-29160.4023489,331.019413971,895.366707848,-347.181658965,-102.459810464,1020.6104413,506.497223233,13.2249116363,-417.820544636,-7.86563023272,5.43207458796,-197.907077484,-472.96207263,109.282693957,-15.9861400857,-185.813007557,231.426010975,-301.755736907,-244.543009619,147.829134202,98.1153774216,185.209357772,99.3509807128,147.407679029,-84.8991159159,89.8680494657,-74.7700765691,-70.0568527832,-0.297106519046,72.610482416,43.4258844111,-56.49268719,19.900397162,5.66405406603,-36.1419943828,-19.431123615,30.448983026,17.2401482906,6.2409549704,-3.60515278105,17.3452496332,14.9887611064,-2.23416330276,-7.57493994523,-6.46390181842,-31.1946673404,6.20506884056,-1.29903819532,-5.39835402372,8.69933678388,0.452802676122,11.4395074297,2.30737388318,11.8964612056,9.1830788431,8.701088513,-1.50286172549,-8.01328889328,-14.6970595264,-2.7409412685,-5.81982345874,-2.09337105349,6.83037348211,-1.5859393741,-0.259997978037,0.959735658658,1.78369469082,-0.163822935118,3.81393350859,4.20516073364,3.8642159038,-1.00567148335,-0.288052289485,-3.57937068381,-0.590744387385,-3.98207881535,-0.7263510488,-1.32071272427,-0.702706636877,-0.421098393915,0.401411366889,-0.827643558956,0.132675358382,0.55581141091,-0.393503736013,0.419263725154,1.28489413541,1.36347603352,0.283113448169,0.423219526884,-0.747889535277,0.389506226815,-1.46169452695,-0.0892320345212,-0.879821503758,0.047250054648,-0.751737230367,0.0192332530255,0.178832551635,0.113385210698,-0.15848577197,-0.202223115648,-0.071214107041,-0.390911659836,0.199616056701,0.151092670873,0.417268482912,0.265799748477,0.250193469417,-0.0393803203226,0.135005276669,-0.200586785377,0.0647193765245,-0.315749319646,0.0937673655516,-0.419415791694,0.072160049132,-0.11550982727,-0.122353351904,0.0926727962984],[-29145.2447785,335.023599453,891.911715052,-341.688498626,-124.630346296,1015.90766609,522.851911074,21.8178479467,-412.898538694,3.10258389395,12.8385056871,-200.502623279,-484.147283428,117.480662058,-9.24540938987,-187.708299026,232.344477152,-297.555158862,-245.858874013,149.96404174,99.6875206902,179.204198978,98.6640013444,146.159535159,-86.1529122059,90.9870993152,-73.380358629,-70.8259556213,2.28454065984,73.6436166782,41.8811642051,-57.0951205853,21.2870934836,4.24388333911,-36.1063800401,-19.9088786752,30.37393971,17.3114334461,5.93446175475,-3.09019616087,17.1458555736,15.2319301073,-2.17671379168,-7.31098725972,-6.42440639741,-31.043871822,6.02994390154,-0.991705362412,-5.32577198579,8.65442677198,0.536905936279,11.2027303121,2.55644020366,11.7524928329,9.19768748425,8.53300377825,-1.49623465234,-7.96465923506,-14.7093300662,-2.5463614181,-5.59929847249,-2.19453649273,6.728649039,-1.56766849643,-0.260796732371,0.980521863804,1.73917559648,-0.153660914382,3.7989946804,4.1804398314,3.78824973934,-1.05618669567,-0.256070462034,-3.55380641294,-0.554971131529,-3.92482429241,-0.766572519523,-1.32148835904,-0.715701455835,-0.457671622651,0.409577927036,-0.823178663028,0.140646965055,0.540302670289,-0.392014114198,0.411956298108,1.25971653897,1.35347825104,0.253182947578,0.423648724738,-0.754194911071,0.391749923817,-1.45459091587,-0.101769479634,-0.861698707132,0.0396730025399,-0.760598504674,0.0238689382941,0.176298247411,0.117551667607,-0.154832381102,-0.202801075463,-0.073738034962,-0.389108955303,0.200009913634,0.144803362072,0.412412300285,0.256536301124,0.250272968806,-0.0449535747931,0.132017346791,-0.200203460519,0.0613357058368,-0.314109205375,0.0901262249458,-0.418907306142,0.0720863700498,-0.111242979531,-0.122669254152,0.0921493242663],[-29131.2819182,339.557803034,888.065520323,-334.786261798,-145.112960366,1010.56497498,539.643822019,29.9831165416,-407.23945596,13.8261444134,20.6372098321,-203.126776216,-494.289781783,125.476305552,-2.68537097946,-189.586349536,232.76468849,-293.288157305,-246.508379957,152.37835308,101.05135043,173.602891537,97.877192491,145.040375188,-87.4791406637,91.8938928998,-71.8621683622,-71.4513285929,4.89448999524,74.5439239914,40.5145706602,-57.783404066,22.7194993533,2.78592470693,-35.9845398163,-20.4040680059,30.2245910256,17.420521932,5.63026318241,-2.62129412598,16.9450268335,15.5133361074,-2.1521875027,-7.05333473524,-6.41389668611,-30.8643474719,5.86266170683,-0.69522826778,-5.25058674504,8.5991445832,0.625153953332,10.9472582501,2.77518725288,11.6237436463,9.2053884644,8.36599313615,-1.48850437582,-7.92427773306,-14.6993822971,-2.36112029931,-5.37934500972,-2.29544348708,6.63402578021,-1.54405647947,-0.258994496921,1.00068892612,1.68776270184,-0.15216391284,3.78817964989,4.14887084923,3.71370506703,-1.10546227748,-0.22626654807,-3.52148830539,-0.526909969541,-3.8664617746,-0.810013910278,-1.32231184835,-0.729529483694,-0.493119117905,0.419375745507,-0.815968980879,0.14865356422,0.523755763731,-0.391342829098,0.404913420017,1.23145548832,1.34402164951,0.223327842267,0.423394110539,-0.758798861255,0.390945298993,-1.44623598877,-0.115538006851,-0.84454388814,0.0319810914613,-0.769479188383,0.0283821342202,0.173955274294,0.121807680568,-0.150344311541,-0.20302374075,-0.0759532306133,-0.386982647774,0.200037803665,0.137748969188,0.407770437409,0.246877568389,0.250140363449,-0.0504094629529,0.128313176331,-0.199259263799,0.0574198180211,-0.312731795747,0.0862418124912,-0.418463741046,0.0718011950023,-0.107038257388,-0.123115391753,0.0917462528071],[-29119.1287961,344.772836468,883.693204882,-327.102706172,-164.124323139,1004.62153431,555.609697251,37.9918388585,-401.136817333,24.192781925,28.8898347738,-205.839145153,-503.279475943,133.116695077,3.53697451741,-191.533759163,232.743762727,-288.987538543,-246.514195528,155.11473401,102.110835861,168.488497071,96.9489891941,144.051823368,-88.880612982,92.5801970752,-70.1944410991,-71.9220770134,7.50813270929,75.2936250843,39.3569497371,-58.5843184945,24.1686186283,1.29478991449,-35.7974694292,-20.9153646265,30.004763125,17.5665948351,5.33791373296,-2.20926363793,16.7488369385,15.8350626681,-2.16472153372,-6.80565129058,-6.43780121029,-30.6620649655,5.70191486121,-0.414885202063,-5.17200458287,8.53451645794,0.718268669362,10.6750472188,2.96050738159,11.5152191496,9.20624959677,8.19969071363,-1.48175516144,-7.89569199009,-14.6702412137,-2.18978554747,-5.16328865099,-2.39569104679,6.54606787367,-1.51471427997,-0.254919064532,1.02040851151,1.62991557447,-0.15972869128,3.78248646937,4.10967841696,3.6414224987,-1.15379953931,-0.199415735204,-3.48323739528,-0.507933187642,-3.80806280184,-0.856369307498,-1.32369233784,-0.743807548791,-0.527409620227,0.430756128029,-0.805963350524,0.156591069175,0.506118418739,-0.391659609792,0.398483021589,1.20011765601,1.33537522172,0.193724458305,0.422373981011,-0.76180929872,0.386624729639,-1.43668791723,-0.130630936616,-0.828614413596,0.0242507634207,-0.778490089271,0.0327772771495,0.17182709497,0.126166888689,-0.145056764991,-0.202881376071,-0.0779210803481,-0.384549424735,0.199701031561,0.129972951259,0.403398215524,0.236842279062,0.249771346236,-0.0557129378802,0.123830564079,-0.197777917888,0.0529708185289,-0.311693480063,0.0821574608691,-0.418172827354,0.0713346769093,-0.102957218814,-0.123666860547,0.0914508906487],[-29109.2538572,350.805514628,878.621310551,-319.182199486,-181.865698979,998.126415116,569.750169973,46.0188045972,-394.859183633,34.1143359551,37.5796048839,-208.663493586,-511.041637848,140.32638199,9.31092072509,-193.62309886,232.338558628,-284.689149358,-245.898527394,158.192752101,102.800910469,163.939604572,95.8250368916,143.195501842,-90.3547062095,93.0419102275,-68.3662248173,-72.2270211401,10.1028406733,75.8801899868,38.4360000387,-59.5226097895,25.610767896,-0.22632561133,-35.5648773835,-21.4406162348,29.7186555942,17.7483210996,5.0654502593,-1.86262703776,16.5628869482,16.1980085026,-2.21789177953,-6.5699627716,-6.50067495613,-30.4420951459,5.54709870518,-0.155045780385,-5.08929459061,8.46149666205,0.817059444932,10.3882296253,3.11006617649,11.4306982151,9.20027179706,8.03413551766,-1.47738694517,-7.88167180209,-14.6243842076,-2.03598871858,-4.9540012555,-2.4950384508,6.46412091488,-1.47941712725,-0.248792670356,1.03985883808,1.56612026499,-0.176472988239,3.78267891814,4.06224392732,3.57226282818,-1.20134794857,-0.17613820017,-3.43976289813,-0.499087458788,-3.75047814158,-0.905385175023,-1.3260703603,-0.758190295925,-0.560621810052,0.443618017593,-0.793166104805,0.164392061515,0.487366379905,-0.393064541201,0.392942699993,1.16575265766,1.32778697956,0.164516054374,0.42056103615,-0.763299555431,0.37842760798,-1.42599249874,-0.147131266343,-0.814121336804,0.0165331130215,-0.787736431472,0.0370729876312,0.169927693792,0.130626778162,-0.139016077432,-0.202371408372,-0.0796901028389,-0.381815521195,0.198995355037,0.121528824743,0.399347035406,0.226456210676,0.24915637352,-0.0608280265144,0.118522949176,-0.195781109476,0.0479837033764,-0.311050309739,0.0779102620226,-0.418106469227,0.0707207695826,-0.0990522368504,-0.124292747291,0.0912484718604],[-29101.5392138,357.736664869,872.522221554,-311.235549668,-198.476727849,991.168307313,582.121441465,53.8534765076,-388.575275356,43.5990817373,46.3760510158,-211.480203561,-517.642994208,147.33984053,14.7109382778,-195.870823083,231.604899044,-280.440998425,-244.681736605,161.539582066,103.180364812,160.016912521,94.3998226057,142.473024333,-91.8770588195,93.2914568628,-66.4070180831,-72.3538409982,12.6639083558,76.3120859355,37.766830736,-60.614884095,27.0435146651,-1.779891716,-35.3013233303,-21.9743692414,29.3719617537,17.9623211003,4.81483910763,-1.58072818452,16.3908880566,16.5983329325,-2.31302932241,-6.34172273231,-6.60357875133,-30.205909527,5.40041952208,0.0835550841991,-5.00197709925,8.38075156323,0.922685314531,10.0896436032,3.22462216802,11.3690531902,9.1871883909,7.87098607543,-1.47406234479,-7.88187573772,-14.5620982606,-1.89961705117,-4.75253979681,-2.59388605259,6.38665620973,-1.43859734093,-0.240415318756,1.05924433251,1.49696875632,-0.20139845325,3.78858368344,4.00657582449,3.50716757746,-1.2476495999,-0.156434076194,-3.39132675503,-0.500117002859,-3.69367547149,-0.957017486311,-1.32961199708,-0.772483635746,-0.593274127346,0.457650906241,-0.777803555881,0.172135796031,0.46758746019,-0.395379131616,0.388288718255,1.128581881,1.32142101126,0.135713619615,0.418145589049,-0.763204639655,0.366421385965,-1.41414603452,-0.165080701348,-0.801090457011,0.00877784524525,-0.797301104547,0.0413446230306,0.168233141766,0.135120223514,-0.132313121927,-0.201519914136,-0.0812573460351,-0.378745362247,0.197894343616,0.112510335799,0.395652615973,0.215773335725,0.248344955488,-0.0657150512387,0.112406332159,-0.193282381308,0.0424370308394,-0.310776984659,0.0735123449444,-0.418273263675,0.0700086304003,-0.0953389448096,-0.1249381024,0.0911159318768],[-29095.7203955,365.633117666,865.029782714,-303.390174689,-214.08164361,983.845805533,593.043605027,61.1889856019,-382.428852919,52.679403432,54.8702806436,-214.133811766,-523.185635426,154.469025658,19.8577920623,-198.279357164,230.59834785,-276.294134895,-242.883722807,165.0593004,103.338953715,156.776646774,92.555043755,141.886002453,-93.4178746409,93.3453930176,-64.3564321102,-72.2899315547,15.1786108744,76.6030294683,37.3614036422,-61.8757126113,28.4697391748,-3.36979456308,-35.0200797077,-22.510344735,28.970748358,18.2047030695,4.58652899752,-1.36061631674,16.2360789915,17.0310104311,-2.45090404155,-6.11474165374,-6.74669988397,-29.9540797904,5.26478633095,0.301091154149,-4.90963524972,8.29287555462,1.03639273113,9.78230371764,3.30570712255,11.3279297907,9.16666580644,7.71230579415,-1.46975964848,-7.8951845588,-14.4831227518,-1.77962170437,-4.55950752712,-2.69279447431,6.31192649173,-1.39285151317,-0.2294814564,1.07877597368,1.42307951443,-0.233227713592,3.79979317946,3.94283931551,3.44709845051,-1.2920947448,-0.140148485627,-3.33807908846,-0.510440426472,-3.6374016968,-1.01127459222,-1.33441471668,-0.786531295366,-0.625994951958,0.472491923276,-0.760157510738,0.179938195809,0.446897489646,-0.398355245169,0.384447005864,1.08886965679,1.31642042418,0.107295075783,0.415372356071,-0.761424978734,0.350780530473,-1.40113245174,-0.184510623919,-0.789501259949,0.000909317668219,-0.807261414413,0.0456817249165,0.166710031564,0.139563946356,-0.125049905813,-0.200360132229,-0.0826069902056,-0.375292920505,0.196366019767,0.103021288011,0.392346755676,0.204854675445,0.247401365786,-0.0703334082977,0.105512353914,-0.190293240144,0.0363052497586,-0.310827866825,0.068969597889,-0.418665980921,0.069251217632,-0.0918237910733,-0.125541967204,0.0910281314736],[-29091.5329316,374.561703495,855.777838854,-295.773492522,-228.804680124,976.257504408,602.836753958,67.7184628924,-376.563676736,61.3876851995,62.6534012411,-216.468854885,-527.771651903,162.025892332,24.8722469653,-200.851126436,229.37446892,-272.299607917,-240.524385644,168.6559836,103.366432003,154.275033183,90.1723977579,141.436047817,-94.9473575029,93.2202747283,-62.2540781122,-72.0226877767,17.6342233468,76.7667371234,37.2316805702,-63.3196665388,29.8923216639,-4.99992031615,-34.7344189537,-23.0422638046,28.5210821616,18.4715752395,4.38096864852,-1.19934067297,16.1016984804,17.4910154718,-2.6322858161,-5.88283001695,-6.93022564212,-29.6871776175,5.14310815085,0.497736191924,-4.81185218294,8.1984630294,1.15942814771,9.46922453389,3.35485280645,11.3049737326,9.13837047179,7.56015808105,-1.46245714445,-7.92047902716,-14.3871970602,-1.67495383733,-4.37550769858,-2.79232433809,6.23818449436,-1.34277623614,-0.215685529954,1.09866474046,1.34507100529,-0.270683396544,3.81589982044,3.87119960743,3.39301715134,-1.33407363476,-0.127126550819,-3.28017002091,-0.529476336239,-3.58140372273,-1.06816484363,-1.3405759876,-0.800177001897,-0.659412663734,0.487778198005,-0.740509776364,0.187915183936,0.425412298325,-0.401744745991,0.381343492309,1.04688031581,1.31292832564,0.079238344635,0.412486053581,-0.757861000009,0.331679508384,-1.38693567758,-0.205452416342,-0.779333231352,-0.00714811213335,-0.817694666989,0.050173834858,0.165324955859,0.143874668298,-0.117328436429,-0.198925301518,-0.0837232156194,-0.371412168585,0.194378405965,0.0931654849613,0.389461252968,0.193761251068,0.246389878061,-0.0746424939358,0.0978726553279,-0.186825192743,0.0295628089746,-0.31115731824,0.0642879091112,-0.41927739119,0.0685014895476,-0.0885132240227,-0.126043383037,0.0909599314268],[-29088.7123516,384.589252831,844.400234798,-288.51292114,-242.770071251,968.50199857,611.820981558,73.1350393913,-371.123507225,69.7563112004,69.3165202825,-218.329869603,-531.503134044,170.322395515,29.8750678734,-203.58855623,227.98882613,-268.508466641,-237.62362476,172.233708162,103.352554501,152.568297603,87.1335820329,141.124772039,-96.4357112348,92.9326580312,-60.1395673027,-71.5395046314,20.0180208906,76.8169254388,37.3896233332,-64.9613170776,31.3141423716,-6.67415513877,-34.4576135061,-23.563847539,28.0290299189,18.7590458428,4.19860678018,-1.09395049175,15.9909852511,17.9733225282,-2.85794452524,-5.63979830299,-7.15434331387,-29.4057746899,5.03829400083,0.673663959985,-4.70821103981,8.0981083807,1.29303801723,9.15342061712,3.37359098608,11.2978307316,9.10196881509,7.41660634337,-1.4501331209,-7.9566399046,-14.2740605652,-1.58456460921,-4.20114356339,-2.89303626609,6.16368295113,-1.28896810202,-0.198721986087,1.11912161169,1.26356169488,-0.312488129388,3.83649602059,3.79182190728,3.34588538395,-1.37297652126,-0.11721339412,-3.21774967486,-0.556643338774,-3.5254284545,-1.12769659138,-1.34819327833,-0.813264482453,-0.694155642525,0.503146859731,-0.719142159746,0.196182683499,0.403247716281,-0.405299498216,0.378904107081,1.00287818881,1.31108782299,0.0515213479253,0.409731397943,-0.752413130823,0.309292786576,-1.37153963918,-0.227937460906,-0.770565856953,-0.0154700865832,-0.828678168192,0.0549104944241,0.164044507321,0.147969110949,-0.10925072111,-0.19724866087,-0.0845902025454,-0.3670570791,0.191899524679,0.0830467302322,0.387027906301,0.182554083831,0.245374765958,-0.0786017043975,0.0895188772883,-0.182889745866,0.022184157328,-0.311719700906,0.0594731668658,-0.420100264705,0.0678124044168,-0.0854136920393,-0.126381391228,0.090886192512],[-29086.9759907,395.709945294,830.721343967,-281.670667728,-256.120455977,960.708399318,620.278220849,77.2190694517,-366.209794598,77.8036897901,74.5514551191,-219.602880904,-534.500795154,179.616760347,34.9458614697,-206.496552272,226.500857851,-264.961224342,-234.21529555,175.701931846,103.378622812,151.691904266,83.3562058678,140.951758712,-97.8568667197,92.5024514138,-58.0488731233,-70.8334855635,22.319240129,76.7708966331,37.8421369956,-66.8047192657,32.7393487541,-8.39371970364,-34.1995701462,-24.0697881763,27.5018172372,19.063001056,4.03980245195,-1.04028477121,15.9072316072,18.4735840958,-3.12622294042,-5.3790815226,-7.41742700465,-29.1096175178,4.95297898325,0.829802516642,-4.59839765819,7.99274812238,1.43832276716,8.83802650037,3.36409535677,11.3042965929,9.05777455212,7.28374394989,-1.43055021968,-8.00219879071,-14.1434673342,-1.50719507655,-4.0365911437,-2.99536489274,6.08695994813,-1.23203243784,-0.178331052904,1.14037560354,1.1792799743,-0.357327323707,3.86116595588,3.70513652917,3.30653545289,-1.40816630015,-0.11012765803,-3.15092776974,-0.591199160995,-3.46915433552,-1.18979635454,-1.35728161097,-0.825674596281,-0.73070524805,0.518266133497,-0.696335800055,0.204871829972,0.38053279572,-0.408779752528,0.377056000996,0.957183003564,1.31101592621,0.0241500445904,0.407352722102,-0.744993409716,0.28387067919,-1.35492452516,-0.251955695887,-0.763116885754,-0.0241304705948,-0.840236804577,0.0599570305223,0.162848433574,0.151773647515,-0.100916503728,-0.195362614354,-0.0851989245729,-0.362195050552,0.188913544261,0.0727678044459,0.385076788296,0.171296570115,0.244422499979,-0.0821661248765,0.0805006189603,-0.178495017273,0.0141580436257,-0.312453147205,0.0545262724346,-0.421115216077,0.0672247139369,-0.0825245492455,-0.126509395999,0.0907830564455],[-29085.9684069,407.627357094,815.32765417,-275.048096321,-269.072093785,953.127884627,628.337763741,80.0998007901,-361.754748257,85.4923261046,78.4528626125,-220.339866962,-536.959840163,189.952292702,39.999601622,-209.58994186,224.98550045,-261.656250793,-230.389076402,178.991637468,103.49212565,151.598270922,78.9015260274,140.908479349,-99.1996630578,91.9629731669,-56.0034179276,-69.9205679289,24.5349637064,76.6602956476,38.5758996265,-68.8118634905,34.177157137,-10.14917272,-33.956733028,-24.5586625521,26.9513051358,19.3784388341,3.90455608288,-1.02934154785,15.8539441561,18.9901647591,-3.42575540216,-5.09261280533,-7.71059808938,-28.7951519249,4.88870253368,0.970097103596,-4.48250866371,7.88468725114,1.59579872296,8.52665658788,3.33110732961,11.3227674786,9.00869054921,7.16378411574,-1.40060849718,-8.05429063609,-13.9952301886,-1.4407458855,-3.88031754158,-3.09924090176,6.00769498184,-1.17260951005,-0.154436084269,1.16272788128,1.09339393516,-0.403737528312,3.88946084934,3.61263421535,3.275282065,-1.43889644462,-0.105082065659,-3.0796524128,-0.631758011024,-3.41198596185,-1.25406332494,-1.36752622198,-0.837436731178,-0.768954759522,0.532928627293,-0.672369165205,0.214174608363,0.35744947746,-0.41197930583,0.375731210177,0.910336075785,1.31272525587,-0.00275745771055,0.405592825321,-0.735560320023,0.255966889415,-1.33705556983,-0.277331283517,-0.756657119837,-0.0331960190404,-0.852185785244,0.0652819114153,0.161769102042,0.15525325758,-0.0924164742835,-0.193296226856,-0.0855675285734,-0.356847184981,0.185469216576,0.0624273963812,0.383631068256,0.160061606895,0.243608338046,-0.0852735963637,0.0709393126253,-0.173635568726,0.00553041653962,-0.313230871045,0.0494281792085,-0.422254237466,0.0667303435155,-0.0798167727286,-0.126438253125,0.0906317887041],[-29085.3159639,419.972413582,798.996181815,-268.381360167,-281.859649278,946.042149138,636.090741866,81.9937044634,-357.6482674,92.7707494751,81.2161095014,-220.634294249,-539.094096903,201.318568635,44.9101039945,-212.886032683,223.521564794,-258.581379893,-226.248601456,182.039189108,103.732098508,152.219053698,73.8667111458,140.984377445,-100.456666403,91.3508940327,-54.0209862974,-68.8223975614,26.664235773,76.5203531042,39.5725325464,-70.9342239768,35.6380510631,-11.9284074064,-33.722180649,-25.0300186511,26.3905134869,19.7001350764,3.79277843193,-1.05090861779,15.8346830809,19.5221071248,-3.74274914328,-4.77194981039,-8.0231647603,-28.4579985639,4.84673017099,1.0992472584,-4.36074337892,7.77657288436,1.76583618457,8.2230452517,3.28001024467,11.3517896401,8.95826696038,7.05897001761,-1.35699236346,-8.10970122908,-13.8291766384,-1.38290757959,-3.73036262906,-3.20446898916,5.92585290133,-1.11134831997,-0.127006215486,1.18649764747,1.00718159421,-0.450218076314,3.92092368578,3.51607081511,3.25231052766,-1.4643930722,-0.101162860264,-3.00383130823,-0.676773217288,-3.35325946776,-1.32001486259,-1.37852990141,-0.848617407076,-0.808650436027,0.546958044848,-0.647520055293,0.224298216068,0.334192924477,-0.414700341575,0.374862992075,0.862934118198,1.31620233519,-0.0290550141378,0.404694123448,-0.724083956278,0.226210967702,-1.31789426895,-0.303846942017,-0.750795624553,-0.0427317092817,-0.864287899934,0.0708293907044,0.160852035101,0.158382572322,-0.0838390593137,-0.191077728465,-0.0857209547387,-0.351048010314,0.181631439371,0.0521231718559,0.382712189651,0.148924466293,0.243009734938,-0.0878576487993,0.0609743488431,-0.168302572988,-0.00363847529205,-0.313909856714,0.0441548536054,-0.42343716542,0.0663090119876,-0.0772542453171,-0.126193181274,0.0904149357047],[-29084.6450255,432.376040115,782.503943307,-261.406612513,-294.717787063,939.732887494,643.628286858,83.1172515291,-353.780251225,99.5874892326,83.0365625249,-220.579629234,-541.117393208,213.705164202,49.5511842514,-216.402132431,222.187861748,-255.724445541,-221.897504851,184.780950846,104.137576877,153.485908722,68.3489298572,141.16889649,-101.620442911,90.7028847529,-52.1193628142,-67.5606202944,28.7061004787,76.386299625,40.8136570758,-73.1232749497,37.1325140752,-13.7193169812,-33.4889915063,-25.483404458,25.8324621626,20.0228656823,3.70438025806,-1.09477377712,15.8530085651,20.0684537996,-4.06341139657,-4.40865019701,-8.34443520968,-28.0937780872,4.82832741409,1.2219525186,-4.23330112638,7.67105213941,1.94880545195,7.93092686389,3.216187442,11.3899093286,8.9100539396,6.97154483218,-1.29638622855,-8.16521635804,-13.6451341934,-1.33137070236,-3.58476627818,-3.31085385097,5.84139855569,-1.04889786891,-0.0960105818582,1.21200410468,0.921920968195,-0.495268300829,3.95509744999,3.41720217775,3.23780614826,-1.48388230044,-0.0974562851049,-2.92337216021,-0.724698108212,-3.29231098749,-1.38716832753,-1.38989543934,-0.859283143906,-0.849538536651,0.560178089888,-0.622066270419,0.235449850482,0.310958299742,-0.416745043217,0.37438460414,0.815573843522,1.32143368738,-0.0545964798516,0.404899032325,-0.710534413013,0.195232464502,-1.29740211828,-0.331285389606,-0.745141465253,-0.0528025186808,-0.876305938383,0.0765437219908,0.160142755124,0.161136222919,-0.0752726853537,-0.188735349271,-0.0856841432608,-0.344832054478,0.177465110389,0.0419527966879,0.382341595952,0.13796042043,0.242704145433,-0.0898518121235,0.0507451181738,-0.16248720282,-0.0132883832312,-0.314347088499,0.0386822620432,-0.424583836486,0.0659404381883,-0.0748008498397,-0.125799399112,0.0901150438645],[-29083.5819555,444.469162044,766.627955054,-253.860006606,-307.881171744,934.481794338,651.04153035,83.6869130442,-350.040598931,105.891074708,84.1095884218,-220.269338392,-543.243556911,227.101655459,53.7966580568,-220.155548795,221.063202176,-253.073281635,-217.439420726,187.153286762,104.74759625,155.330492122,62.4453507958,141.45147998,-102.683558735,90.0556160696,-50.3163320598,-66.1568819618,30.6596019736,76.2933658317,42.2808945351,-75.3304906339,38.671029716,-15.5097946627,-33.2502440975,-25.9183679577,25.2901710352,20.341406551,3.63927232021,-1.15072482194,15.9124807919,20.6282473903,-4.37394939485,-3.99427162444,-8.66371762978,-27.6981111473,4.83475978184,1.34291242175,-4.10038122865,7.5707721337,2.14507682504,7.6540357965,3.14502226164,11.4356727955,8.86760164086,6.90375173617,-1.21547450249,-8.21762181132,-13.4429303635,-1.28382579736,-3.441568361,-3.4182001832,5.75429679399,-0.98590715819,-0.0614183186879,1.23956645547,0.838890073853,-0.53738753497,3.99152512677,3.31778415257,3.23195423421,-1.49659024687,-0.093048583441,-2.83818267295,-0.773986012223,-3.2284766553,-1.45504107977,-1.40122562581,-0.869500461601,-0.891365320477,0.572412466143,-0.596285610679,0.247836708999,0.287940766229,-0.417915594212,0.374229303824,0.768851964476,1.32840583565,-0.0792357100121,0.406449967798,-0.694881784762,0.163660930264,-1.27554061356,-0.359429344505,-0.739303707287,-0.0634734245996,-0.888002690331,0.0823691588758,0.159686784489,0.163488840551,-0.0668057789392,-0.186297319363,-0.0854820343315,-0.338233845402,0.173035127375,0.032013936695,0.382540730629,0.127244741429,0.242769024308,-0.0911896162764,0.0403910111773,-0.156180630985,-0.0233590586396,-0.31439955069,0.0329863709401,-0.425614087214,0.0656043409527,-0.0724204691248,-0.125282125304,0.0897146596006],[-29082.0612529,456.001241784,751.944983648,-245.580267995,-321.479775638,930.425307416,658.38682423,83.943939923,-346.301937489,111.640018179,84.6021787662,-219.799060516,-545.633579656,241.445867356,57.5376466149,-224.149521329,220.211643493,-250.624227429,-212.960647116,189.109135137,105.594176459,157.678464835,56.2454804111,141.818583189,-103.640447696,89.4371185872,-48.6253735722,-64.6315990069,32.5224617271,76.2742089075,43.9544805559,-77.5113345825,40.2627568844,-17.2882920477,-32.9996141169,-26.3336421031,24.7739106155,20.6513800213,3.59774448716,-1.20886531854,16.0168336868,21.2006040849,-4.66131454262,-3.52123485458,-8.97189490314,-27.2676124426,4.86688776809,1.46616663925,-3.96235720406,7.47771443128,2.35458752601,7.39539629373,3.07135673323,11.4882609502,8.83392429179,6.85773410144,-1.11113305848,-8.2638810554,-13.2223717946,-1.23807441683,-3.29893245724,-3.52633608975,5.66437433915,-0.922937109189,-0.0232869166411,1.26940489044,0.759134530345,-0.575189633488,4.02978048713,3.21942387816,3.23489879719,-1.5018248201,-0.0870585919603,-2.74816062,-0.823190339627,-3.16119261984,-1.52322122563,-1.41218699138,-0.879331510529,-0.933895521378,0.583521932851,-0.570421111996,0.261576456696,0.265299256267,-0.418019588847,0.374349614517,0.723285683436,1.33708536238,-0.102811763991,0.409566688262,-0.677085227773,0.132088084081,-1.25226305852,-0.388079410315,-0.732936306029,-0.074783469147,-0.899187774014,0.0882570997719,0.159523022679,0.165421046258,-0.058512807721,-0.183793820911,-0.0851418711204,-0.331282036794,0.168397125157,0.02238637188,0.383315373667,0.116842169487,0.243277433301,-0.091807481528,0.0300436215218,-0.149369297173,-0.0337934857725,-0.313932605786,0.0270466325338,-0.426460803384,0.0652851244848,-0.0700795574314,-0.124666691429,0.0891975158256],[-29081.2499579,467.195889985,738.230796425,-236.816411433,-335.2248019,927.118836904,665.581401423,84.2287025083,-342.367804967,116.832763708,84.567824473,-219.273123698,-548.237108337,256.468620426,60.7344932892,-228.331017042,219.638229305,-248.407643599,-208.478137652,190.667731068,106.681274703,160.431507034,49.8081764153,142.244708526,-104.493014281,88.8408623602,-47.0427467149,-63.0002703126,34.2871104866,76.35119228,45.8091080138,-79.6372276598,41.9115559026,-19.0454942453,-32.7331660483,-26.7246997203,24.2829539694,20.9517941884,3.58160306696,-1.26056191393,16.1704961449,21.7849343971,-4.91543493122,-2.98541306016,-9.26614867334,-26.8028728549,4.92395176655,1.59311537787,-3.82029935409,7.39119838287,2.57554246588,7.15519208831,2.99786764473,11.5493933346,8.80989241443,6.83523608071,-0.981003622249,-8.30166826927,-12.9831816767,-1.19236214781,-3.1555169774,-3.63518330605,5.57090540938,-0.860196323551,0.0179727121666,1.30134355239,0.682770366496,-0.607746537683,4.06956044697,3.12313365036,3.24661866614,-1.49922109298,-0.0787355210668,-2.65316405241,-0.871264828252,-3.09029508736,-1.59157985655,-1.42270102849,-0.888820962808,-0.976967772359,0.59351547129,-0.544576753587,0.276428629366,0.243047779611,-0.416886264743,0.374775123375,0.679074161399,1.34735908657,-0.125104518004,0.414378322309,-0.657060145151,0.100954319605,-1.22748998871,-0.417107732168,-0.725872776936,-0.086667953421,-0.909858121664,0.0941875223367,0.159663877614,0.166937420536,-0.0504124038105,-0.181262844418,-0.0847001087063,-0.323981785497,0.163569686885,0.0130783389852,0.384608651106,0.106775317104,0.244284861988,-0.0916533894666,0.0198033553087,-0.142020708784,-0.0445475804585,-0.312845129136,0.0208564423425,-0.427109067715,0.0649859344646,-0.0677548547401,-0.123978880711,0.0885520914352],[-29082.6232459,478.395254356,725.060910906,-227.920023976,-348.722761397,923.972536079,672.507715109,84.9063509997,-338.024467206,121.477738304,84.0316412924,-218.798028355,-550.950953657,271.848984098,63.3648469834,-232.632934808,219.333249768,-246.462396177,-203.991509858,191.864883853,108.00583252,163.485303702,43.1846343358,142.701370186,-105.245030646,88.2516773056,-45.5604058081,-61.2771653715,35.9446563191,76.5441059381,47.8180840957,-81.6835800583,43.619962449,-20.7726447431,-32.4475615725,-27.0861986034,23.8138248016,21.2425035867,3.59303347749,-1.2974970253,16.3780708033,22.380722422,-5.1269828237,-2.3835425166,-9.54523527424,-26.3054773122,5.0047871459,1.72449897824,-3.67545217597,7.30987778588,2.80571347788,6.93289678509,2.92669047365,11.6214241486,8.79584060447,6.83790202186,-0.822919382702,-8.32883531002,-12.7250623357,-1.14504558607,-3.01010403966,-3.7446869754,5.47302609675,-0.797805322987,0.061861300257,1.33510757213,0.609681213546,-0.634244710491,4.11059270842,3.02977705429,3.26705137431,-1.48849592944,-0.0673611745934,-2.55304109062,-0.917263297808,-3.0157202785,-1.66005881027,-1.43275297011,-0.898009120991,-1.02043918122,0.602439118251,-0.518821750493,0.292063230486,0.221164115369,-0.414350270354,0.375554683494,0.636337049018,1.35909388639,-0.145879052479,0.420991341081,-0.634711001715,0.0706621991278,-1.20113374762,-0.446404340575,-0.717991525488,-0.0990362432667,-0.920057494011,0.100147549039,0.160115134324,0.168048533741,-0.0425092404343,-0.178744332465,-0.0841955051458,-0.316332374139,0.158562132794,0.004080188938,0.386348025495,0.0970562648587,0.245842406904,-0.0906782120101,0.00976282174751,-0.134097640147,-0.0555804914196,-0.311044374299,0.014412681704,-0.427557012159,0.0647146019412,-0.0654256724619,-0.123244589286,0.0877680518208],[-29087.6562925,489.941482606,712.010844614,-219.242692678,-361.580164995,920.396558222,679.048218466,86.3420355971,-333.058190046,125.583368975,83.0187449745,-218.480274902,-553.671926321,287.2660278,65.4063566009,-236.9881735,219.286995037,-244.827351194,-199.500381261,192.736402789,109.564791449,166.735539822,36.4260497002,143.16008236,-105.900268943,87.6543933405,-44.1703051717,-59.4765536761,37.4862072914,76.8727398707,49.9547159884,-83.6258019705,45.3905122017,-22.4609870283,-32.1394623703,-27.4127965467,23.3630468166,21.5233627509,3.63422113663,-1.31135306986,16.6441602992,22.9874522547,-5.28663048308,-1.7123594993,-9.8079110397,-25.7770107424,5.10822927481,1.86105778096,-3.52906016696,7.23240643772,3.04287239526,6.72798398893,2.85996069751,11.7067075922,8.79210345757,6.86737627279,-0.634713528725,-8.34323403478,-12.4477160978,-1.09448132733,-2.8614757622,-3.85479224111,5.3698724933,-0.735884629206,0.107879580152,1.3704220805,0.539750702736,-0.653870614848,4.15260497358,2.94021767507,3.29613445494,-1.46936619341,-0.0522173563733,-2.44763985503,-0.960239568005,-2.93740441391,-1.72859992453,-1.44232804916,-0.906936287632,-1.06416685574,0.610338910523,-0.493225317755,0.308150263532,0.199626042652,-0.410246254134,0.37673714797,0.595193996945,1.37215664001,-0.164900447844,0.429512215722,-0.609942262284,0.0416142849428,-1.17310667876,-0.475859266048,-0.709170957166,-0.111797704529,-0.929829651786,0.106124302348,0.160882577839,0.168764956233,-0.034807990819,-0.176278227636,-0.0836668184953,-0.308333085346,0.153383783117,-0.00461772733448,0.388460959389,0.087697093326,0.248001164585,-0.0888328210764,1.46300477482e-05,-0.125562865589,-0.0668513673776,-0.308437594835,0.00771223195631,-0.427802768668,0.0644789579635,-0.0630713220078,-0.122489713292,0.0868350623737],[-29097.8242731,502.176722446,698.656115069,-211.136004594,-373.403523561,915.801056612,685.085364677,88.9009065001,-327.25523933,129.15808273,81.5542512694,-218.426363756,-556.296837034,302.398820962,66.8366710453,-241.329631993,219.489755268,-243.541374682,-195.004369386,193.318097174,111.355093029,170.077900375,29.5836180361,143.592359241,-106.462501327,87.0338403819,-42.8643991257,-57.6127047192,38.9028714704,77.3568840665,52.1923108786,-85.4393035887,47.2257408392,-24.1017645886,-31.8055301226,-27.6991513445,22.927143719,21.7942262155,3.70735146225,-1.29381246478,16.9733672697,23.6046079902,-5.38505017242,-0.968600283672,-10.0529323036,-25.2190580732,5.23311352194,2.00353212667,-3.3823678243,7.15743813577,3.28479105124,6.53992730469,2.79981379386,11.8075978654,8.79901556941,6.92530318139,-0.414219249208,-8.34271630065,-12.1508452887,-1.03902596737,-2.7084142632,-3.96544424649,5.26058069109,-0.674554763919,0.155528284373,1.40701220834,0.472862465306,-0.665810713691,4.19532494458,2.85531909783,3.33380544128,-1.44154874882,-0.0325858702393,-2.33680846609,-0.99924745855,-2.85528371424,-1.79714503707,-1.45141149859,-0.915642765284,-1.10800790372,0.617260884896,-0.467856670415,0.324359731979,0.17841134057,-0.404408864536,0.378371369898,0.555764655834,1.38641422558,-0.181933784526,0.440047417374,-0.582658391677,0.0142131393424,-1.14332112565,-0.5053625391,-0.699289477448,-0.124861703054,-0.939218355717,0.112104904732,0.161971993187,0.169097258367,-0.0273133281913,-0.173904472513,-0.0831528068113,-0.299983201744,0.148043958087,-0.0130250589049,0.390874915338,0.0787098830828,0.250812231565,-0.0860680885836,-0.00934861058101,-0.116379159439,-0.0783193570546,-0.304932044304,0.000751974437429,-0.427844469195,0.0642868335804,-0.0606711147888,-0.121740148863,0.0857427884852],[-29114.2874522,515.276652084,684.677809188,-203.878454169,-383.969447864,909.801596559,690.617090628,92.8315928729,-320.483575997,132.199019377,79.6900337093,-218.718428257,-558.759968267,317.009542331,67.6753243502,-245.604482148,219.913038775,-242.629427165,-190.526495149,193.641216022,113.373810649,173.430428659,22.6986044987,143.975273375,-106.940883554,86.3726727023,-41.6410395225,-55.7044958244,40.1874509833,78.0145129432,54.506533942,-87.1049933381,49.1283858581,-25.6865327792,-31.4436269368,-27.941739631,22.5023501006,22.0540282608,3.81246012269,-1.23852869227,17.3686982647,24.2316955364,-5.41523760758,-0.149223228553,-10.279719792,-24.6327827262,5.37828634867,2.15345886541,-3.23634602282,7.08382218695,3.52911351831,6.3679337048,2.74806586382,11.9258007064,8.81671066278,7.01276493056,-0.159830764863,-8.326046957,-11.8344723772,-0.977274462553,-2.54972646213,-4.07650491052,5.14481177836,-0.61387337254,0.204396682359,1.44467637506,0.408853551012,-0.669515518707,4.23850200395,2.77574889913,3.37987232559,-1.40485853564,-0.00801643247026,-2.22040998894,-1.03349015932,-2.7692622389,-1.86562371377,-1.45986783247,-0.924211985813,-1.15183113511,0.623272757444,-0.442753290665,0.340439755639,0.157506715519,-0.396744081964,0.380466695935,0.518132700184,1.40172663996,-0.19679236319,0.452629337468,-0.552810314089,-0.0112144551216,-1.11171319999,-0.534827769738,-0.688211928343,-0.138180797643,-0.948273918753,0.118068559139,0.16338220212,0.169057928248,-0.0200151424038,-0.171649241183,-0.0826839350598,-0.291291333811,0.142553626047,-0.0211548229767,0.393520675332,0.0701031714621,0.254299780024,-0.0823575535183,-0.0182502535983,-0.106513279362,-0.0899404485739,-0.300448623317,-0.00647638741135,-0.427684758522,0.0641404566819,-0.058212693095,-0.121019057556,0.0844887434314],[-29136.9464497,528.751071728,670.179291474,-197.456165402,-393.734948283,902.835391494,696.103268032,97.9166397365,-312.937941379,134.658169917,77.5849969547,-219.341133447,-561.14548956,331.192807929,68.1093910698,-249.816987787,220.453226515,-242.060847147,-186.18339301,193.718767207,115.618545103,176.80060122,15.7725527541,144.30813072,-107.366105786,85.6448419964,-40.5241683436,-53.7892356402,41.3395241988,78.856338634,56.8824823085,-88.625772574,51.1019920291,-27.2080944274,-31.0564166262,-28.1443134013,22.0837441013,22.2980221511,3.9409837882,-1.14703949448,17.826775483,24.8683080525,-5.37948231575,0.74792497356,-10.4903517999,-24.0176620974,5.54263858712,2.31556088497,-3.09087114762,7.01118993613,3.77297282594,6.21014363185,2.70525550299,12.060428006,8.84451896896,7.12859504322,0.127813576314,-8.29564282229,-11.4999004019,-0.908775211826,-2.3843184836,-4.18750325486,5.02432682802,-0.553646595294,0.254428191212,1.48350615448,0.34737468367,-0.665491736583,4.28197225586,2.70139062127,3.43362493628,-1.35950279815,0.0208695908722,-2.09836726763,-1.06276834083,-2.67911540233,-1.93391643313,-1.46707868937,-0.932899898326,-1.1955521685,0.628528961373,-0.417825729311,0.356450919676,0.136934583054,-0.387443214618,0.38287444697,0.482237899888,1.41792635481,-0.20948236545,0.466994048595,-0.520534791208,-0.0346448348613,-1.07831408637,-0.564262885953,-0.675748897965,-0.151880318932,-0.957072862706,0.123962790435,0.165084173271,0.168667124956,-0.0128441898144,-0.16948363375,-0.0822574958445,-0.282303403437,0.136930347773,-0.0290335092754,0.39634229911,0.0618713228225,0.258380284712,-0.0777654231415,-0.02667750314,-0.0959479163691,-0.101657987665,-0.29496282069,-0.0140018617353,-0.427344332756,0.0640196425208,-0.0557170227325,-0.120338662604,0.083101832027],[-29165.3869748,541.943312085,655.369495823,-191.782169685,-403.3271351,895.54506688,702.119252309,103.822071076,-304.894771909,136.476238152,75.4248034483,-220.254777294,-563.57504222,345.1263431,68.3678308881,-253.985685723,220.987917604,-241.791067626,-182.115100818,193.559198318,118.087029034,180.218252919,8.79707609589,144.595795587,-107.774241788,84.8221243146,-39.5441251029,-51.9088406461,42.3603635459,79.8912577006,59.3076110971,-90.0100408844,53.1503059413,-28.6595642281,-30.6477634308,-28.3124434907,21.6661147483,22.5205408962,4.08220937951,-1.02285367857,18.3426250364,25.5140605106,-5.28239727692,1.72477554675,-10.6875710145,-23.3727520767,5.72507216208,2.49535758254,-2.94554596141,6.93936823771,4.01337424283,6.06443089603,2.67160193056,12.2099431936,8.88156984632,7.27106487728,0.447514394508,-8.25483370722,-11.1487525442,-0.833314974759,-2.21112125347,-4.29788507684,4.90141190917,-0.49361769611,0.30565476495,1.52366640901,0.288030005611,-0.65451012276,4.32559348492,2.63193179797,3.49422356077,-1.30578685664,0.0531829212808,-1.97061809095,-1.08703204378,-2.5845864577,-2.00189140179,-1.47230498896,-0.942005581239,-1.2390983246,0.633205609172,-0.392952804306,0.372531925586,0.116726286014,-0.376768902645,0.385406437453,0.447984048684,1.43483896044,-0.220058193157,0.482803543633,-0.4860150441,-0.05613011603,-1.04317873757,-0.593699395234,-0.661697410956,-0.166128790513,-0.965698261606,0.129727203965,0.167041911995,0.16794692532,-0.00571644340723,-0.167364981822,-0.0818624886789,-0.273074660364,0.131193332148,-0.0366909756571,0.399287165847,0.0540051582788,0.262943296022,-0.072378571783,-0.034633526011,-0.0846697448113,-0.113412159457,-0.288463772291,-0.0218586345762,-0.426848400832,0.0638986031908,-0.0532134003866,-0.119708452656,0.0816188069716],[-29199.1947366,554.196703861,640.457356135,-186.769498406,-413.373118596,888.573248179,709.240398877,110.213910878,-296.630504018,137.593927882,73.3951156327,-221.419657766,-566.170267555,358.987873184,68.6796034894,-258.129112766,221.394711156,-241.775521599,-178.461656423,193.170956947,120.776995087,183.713218617,1.76378781784,144.843132289,-108.201365325,83.876295707,-38.7312493142,-50.1052273215,43.2512414534,81.128166705,61.7693754265,-91.2661978572,55.2770741836,-30.0340568764,-30.2215315903,-28.4517007344,21.2442510688,22.7159175063,4.22542381734,-0.869480051694,18.9112730363,26.1685678826,-5.12859547112,2.7832597151,-10.8741201231,-22.6971085536,5.92448899838,2.69836835533,-2.79997322687,6.86818394607,4.24732303769,5.9286693075,2.64732436575,12.3728096983,8.92699265326,7.43844579065,0.798072309901,-8.20694942251,-10.7826519852,-0.750680510924,-2.02906569764,-4.4070961738,4.7783530909,-0.433529938918,0.358108357594,1.56532200105,0.230423659165,-0.637341432674,4.36922347572,2.56705996299,3.56082848648,-1.24401603145,0.0880342802481,-1.83710024768,-1.10623130886,-2.48541865823,-2.06941682638,-1.47480765094,-0.951828112971,-1.28239692418,0.637478813334,-0.368013333608,0.38882147487,0.0969131672415,-0.364983786194,0.387874481834,0.415274940312,1.45229004721,-0.228574248162,0.499719815464,-0.449434293826,-0.0757224147805,-1.00636210638,-0.623168805066,-0.64585449196,-0.18109473598,-0.974233189484,0.135301405074,0.169219423646,0.166919406165,0.00145212383377,-0.165250617006,-0.081487913076,-0.263660354332,0.125361788057,-0.0441570799782,0.402302654719,0.046495498946,0.267878364347,-0.0662838737724,-0.0421214890164,-0.0726654390378,-0.125143149081,-0.280940613985,-0.0300808919761,-0.426222171688,0.0637515507857,-0.0507311227426,-0.119137916366,0.0800764209647],[-29237.9554439,564.854577764,625.651806306,-182.331182958,-424.500009054,882.562560853,718.042063158,116.758183126,-288.421574137,137.951942908,71.6815959503,-222.796072829,-569.05280687,372.955123524,69.2736685578,-262.265805728,221.551206289,-241.969642063,-175.363097675,192.562490682,123.686175905,187.315333175,-5.33569878634,145.055005137,-108.683550161,82.7791322238,-38.1158804913,-48.4203121461,44.0134303503,82.5759622091,64.2552304155,-92.4026430804,57.4860433453,-31.3246870675,-29.7815853446,-28.5676559675,20.8129420899,22.8784849913,4.3599140224,-0.690427421003,19.5277455942,26.8314451406,-4.92268987834,3.92530870269,-11.052741813,-21.989787418,6.13979102082,2.93011260055,-2.65375570671,6.7974639156,4.47182447922,5.80073267642,2.63264202775,12.5474909494,8.97991674815,7.62900914126,1.17828794268,-8.15531977886,-10.4032219063,-0.660658579894,-1.83708274198,-4.51458234306,4.65743644233,-0.373126587646,0.41182092316,1.60863779301,0.174159786663,-0.614756421765,4.41272001285,2.50646265005,3.63260000084,-1.17449564289,0.124534389267,-1.6977515266,-1.12031617674,-2.3813552571,-2.13636091355,-1.473847595,-0.962666571939,-1.32537528795,0.641524686347,-0.342886135171,0.405458269025,0.0775265695764,-0.352350505413,0.390090394563,0.38401436851,1.47010520544,-0.235084932316,0.517404856965,-0.410975761452,-0.0934738472662,-0.967919145592,-0.652702622936,-0.628017165619,-0.196946678925,-0.98276072037,0.140624999106,0.17158071358,0.16560664432,0.00874553892454,-0.16309787091,-0.0811227685494,-0.254115735083,0.119454924385,-0.0514616800946,0.405336144903,0.0393331659391,0.273075040081,-0.0595682034396,-0.0491445589611,-0.0599216733982,-0.136791141669,-0.272382481639,-0.0387028199768,-0.425490854261,0.0635526973991,-0.0482994864856,-0.118636542385,0.0785114267058],[-29281.0676825,573.49729639,611.078945336,-178.38480306,-437.112805591,877.958423735,728.925459326,123.171821728,-280.457811786,137.551347367,70.436284676,-224.343502419,-572.310938564,387.168952644,70.3221737725,-266.402011971,221.373153838,-242.340737068,-172.926585496,191.749184977,126.804190029,191.041428362,-12.5114300408,145.246817163,-109.24836268,81.5110363083,-37.7202377152,-46.885106043,44.6522103504,84.2390794827,66.7530288476,-93.4307639761,59.7804191971,-32.5280087506,-29.3313081856,-28.6654028655,20.3671623949,23.0039795531,4.47850127045,-0.488749357797,20.1870935868,27.5023165752,-4.67036006387,5.15187485618,-11.2267233932,-21.2500464693,6.37078359814,3.19483683913,-2.50682623707,6.72655895296,4.68419153997,5.67908364644,2.62722668237,12.7328465861,9.03972200983,7.84086227424,1.58711515906,-8.10322463855,-10.0118886695,-0.562970461457,-1.63462506049,-4.61993319491,4.54070301921,-0.312237528223,0.466652455511,1.65357704128,0.118897081802,-0.587692489296,4.45607798289,2.44996895626,3.70872563077,-1.09745076841,0.161733399609,-1.55248492562,-1.12926682467,-2.27235042964,-2.20259120366,-1.46887856316,-0.97478172187,-1.36794036647,0.645527231934,-0.317496475372,0.422517794444,0.0585658411003,-0.339154467228,0.391923081124,0.354131376779,1.48812301917,-0.239615991939,0.535508763173,-0.370776085235,-0.109438828059,-0.927947295675,-0.68232653909,-0.60807023051,-0.213822193377,-0.991346184156,0.145653493873,0.174103150968,0.164042895453,0.0162325226418,-0.1608750187,-0.0807674269235,-0.244502217143,0.113496213637,-0.0586352775266,0.408339536832,0.0325126226539,0.278428158648,-0.052301676796,-0.055712419264,-0.0464386383229,-0.14830674522,-0.262801670457,-0.047747826885,-0.424682122039,0.0632858590384,-0.0459449403653,-0.118213760899,0.0769577927684],[-29327.1815444,580.653349892,596.533532639,-174.866131765,-450.728062665,874.417429144,741.59523658,129.37540028,-272.582618829,136.634646737,69.6767334135,-226.018154333,-575.899489394,401.622751798,71.7700187933,-270.494821062,220.92891152,-242.903614878,-171.127773114,190.774176747,130.088199592,194.856323581,-19.7800907412,145.476126292,-109.889339747,80.0869159744,-37.5340583351,-45.4869977105,45.1888923061,86.1041086274,69.2522141645,-94.3738993032,62.161244237,-33.6543328919,-28.8721606131,-28.7481264649,19.9026287917,23.093750162,4.58814425735,-0.265678489947,20.8844669511,28.180843751,-4.381551934,6.45999501257,-11.4015306612,-20.4779511454,6.62088587484,3.49169608694,-2.36043794799,6.65291567401,4.8829680078,5.56454019511,2.62856028181,12.9293210884,9.10679039889,8.07145648363,2.02412080944,-8.05374407002,-9.60929135941,-0.457075516263,-1.42323231958,-4.72331359137,4.429213824,-0.251039134569,0.521775107879,1.69929657811,0.0645124437459,-0.557753609832,4.49984068037,2.39797423232,3.78850186122,-1.01278551407,0.198439181665,-1.40111427923,-1.13318397601,-2.15920203975,-2.26797257193,-1.46012558687,-0.988281067723,-1.40991762955,0.649702018748,-0.291955414264,0.439822677086,0.0399023508556,-0.325772145667,0.393469811146,0.325656007675,1.50623404716,-0.242078551228,0.553634037751,-0.328785572212,-0.12368096541,-0.886713947822,-0.712042974803,-0.586249580957,-0.231735055115,-0.999983934182,0.15040600705,0.176817560249,0.162311130605,0.0239205708051,-0.15859410978,-0.0804677492689,-0.234905874169,0.107526182806,-0.0657109484497,0.411282815975,0.0260429016096,0.283853695593,-0.0444873765797,-0.0618608198005,-0.0322705885653,-0.15968225922,-0.252303112984,-0.0571962100665,-0.423833506727,0.0629732673658,-0.043682541389,-0.11787876824,0.0754383512217],[-29374.7599986,587.08826031,581.727492728,-171.715490456,-464.640223573,871.398962769,755.581902875,135.340402296,-264.55279022,135.504706834,69.3868715984,-227.775418337,-579.739923209,416.273045423,73.5052912749,-274.489033122,220.324988772,-243.684958809,-169.909436827,189.68754077,133.487252625,198.711835144,-27.160025301,145.811029168,-110.591510848,78.5303056291,-37.5389592672,-44.2024702906,45.6487947547,88.1531784526,71.7426274723,-95.2583756547,64.6290201444,-34.7174097119,-28.4051223788,-28.8185346422,19.4152436442,23.1505489798,4.69933603399,-0.0219922094663,21.6150403893,28.866697551,-4.06727798034,7.84572713143,-11.5831740363,-19.6737687941,6.89442043936,3.81857248358,-2.21617404294,6.57350464686,5.06700537439,5.45850913345,2.6335773249,13.1377551461,9.18175439635,8.3180790507,2.48902499023,-8.00990819328,-9.19587224159,-0.342367625178,-1.20496593374,-4.82503220742,4.32378484583,-0.189794402607,0.57618907334,1.74475162975,0.0109373230222,-0.526710401761,4.5446885018,2.35101539226,3.87125241663,-0.920323743062,0.233399035605,-1.24342863104,-1.13219849068,-2.04291887346,-2.33236922734,-1.44800651989,-1.00323379977,-1.45111217682,0.654272506675,-0.266420460321,0.457132327807,0.0213754731247,-0.312602781535,0.394884945293,0.298643553511,1.52434184188,-0.242355078846,0.571371286518,-0.284907946616,-0.136266165987,-0.844528980911,-0.74184853411,-0.562878885218,-0.250668090354,-1.00865057965,0.15491755878,0.179768129679,0.160506499659,0.031801872995,-0.156278137113,-0.0802809689673,-0.225418944605,0.101589622506,-0.0727224127035,0.414140489059,0.0199366776065,0.289272911493,-0.0361116272109,-0.06763202706,-0.0174852949597,-0.170920406027,-0.241014901102,-0.0670174891519,-0.422985004579,0.0626467579571,-0.0415244986284,-0.117640702272,0.0739731500089],[-29422.2660136,593.567549686,566.372750118,-168.873200513,-478.143731611,868.362410299,770.415966164,141.038311295,-256.12512091,134.464393473,69.5506286666,-229.570684197,-583.753703857,431.076357953,75.416078872,-278.329448267,219.667895033,-244.711452177,-169.214352937,188.539351822,136.950397156,202.559779362,-34.6695781338,146.319622435,-111.339905465,76.8647396795,-37.7165574279,-43.0080069251,46.0572362336,90.3684177679,74.2141098774,-96.1105196235,67.1842485989,-35.730989431,-27.9311732347,-28.8793352742,18.9009093164,23.1771281686,4.82256965128,0.24153209163,22.3739886036,29.5595488584,-3.73855069446,9.30512917233,-11.7776639378,-18.8377667631,7.19570988013,4.17334816863,-2.07561772542,6.48529643964,5.23515513144,5.36239727248,2.63921231043,13.3589894493,9.26524648325,8.57801725671,2.98154779786,-7.97474712834,-8.77207358145,-0.218240669068,-0.981887317502,-4.92539771803,4.2252320738,-0.128766328255,0.62889454497,1.78889742242,-0.0418968298397,-0.496333483472,4.59130184369,2.30962935017,3.95630102146,-0.819889318564,0.265360261599,-1.07921702465,-1.12644122858,-1.9245097168,-2.39564537882,-1.43293921601,-1.01970910827,-1.4913291079,0.6594621556,-0.241049122014,0.474206157458,0.00282458219033,-0.300045615637,0.396322844228,0.273149306606,1.54234995579,-0.240328043458,0.588311115292,-0.239046932677,-0.14726033646,-0.801702273816,-0.771739821044,-0.538281811552,-0.270604125309,-1.01732272977,0.159223169203,0.182999047514,0.158724152497,0.0398686187918,-0.153950093662,-0.0802643194005,-0.216133666893,0.0957313233503,-0.0797033901274,0.416887062811,0.0142066254448,0.294607066923,-0.0271607531095,-0.0730683075317,-0.00215052834022,-0.182023907996,-0.229065126692,-0.0771811837719,-0.422176611851,0.0623381663882,-0.0394830211553,-0.117508700861,0.0725822370732],[-29468.1625582,600.856740062,550.181229323,-166.279583322,-490.533030072,864.767157424,785.627934402,146.440610793,-247.056405852,133.816572469,70.1519340538,-231.359341677,-587.862295186,445.989213826,77.3904692396,-281.960866618,219.064139739,-246.009778299,-168.985297744,187.379684683,140.426681217,206.351972548,-42.3270936529,147.070002739,-112.119553084,75.1137525323,-38.0484697334,-41.8800907561,46.4395352798,92.7319553828,76.656502486,-96.9566578026,69.8274312802,-36.7088222695,-27.4512929323,-28.9332362374,18.3555281723,23.1762398905,4.9683381601,0.524117021329,23.1564862961,30.2590685564,-3.40638256793,10.8342590948,-11.991010785,-17.9702123999,7.52907678558,4.5539052817,-1.94035219891,6.38526162049,5.38626877063,5.27761142321,2.64239973721,13.593864688,9.35789914062,8.84855838291,3.50140932876,-7.9512909952,-8.33833764445,-0.0840885287972,-0.756057885371,-5.02471879819,4.13437149705,-0.0682179074348,0.678891715842,1.83068918237,-0.0940585643112,-0.468393473353,4.64036110256,2.27435302009,4.04297140015,-0.711306103771,0.293070159818,-0.908268503673,-1.11604304964,-1.80498335581,-2.45766523535,-1.41534152901,-1.0377761835,-1.5303735224,0.665494425407,-0.215998907819,0.490803576893,-0.015910947665,-0.288499888778,0.397937868614,0.249228559275,1.56016194137,-0.23587991373,0.604044129892,-0.191106254628,-0.156729383497,-0.758543705415,-0.801713439641,-0.512782028217,-0.291525986196,-1.02597699373,0.163357858462,0.186554502009,0.157059239003,0.0481129977759,-0.151632972391,-0.0804750339503,-0.207142279476,0.0899960759537,-0.0866876005611,0.419497043959,0.00886541992455,0.29977742246,-0.0176210786955,-0.0782119277049,0.0136659404589,-0.192995487484,-0.216581881636,-0.0876568135569,-0.4214483248,0.0620793282349,-0.0375703180413,-0.117491901873,0.0712856603579],[-29511.3252527,609.524631822,533.008301079,-163.922511712,-501.261637793,860.270739305,800.787910439,151.516502671,-237.193582663,133.798867813,71.2001729001,-233.124274888,-592.02352881,460.937656012,79.3134182435,-285.358137017,218.596735082,-247.593438323,-169.168459024,186.248241607,143.867254783,210.045804555,-50.1477625927,148.111834992,-112.922373561,73.2961911005,-38.5159803313,-40.7979565506,46.8173332125,95.2226461216,79.0606586751,-97.8225206568,72.5567962461,-37.6639082547,-26.9652969698,-28.983071925,17.7759860519,23.1499997069,5.14516804875,0.824196524677,23.9563998999,30.9650279661,-3.08149418944,12.4276775884,-12.2279831398,-17.0727259114,7.89842089813,4.95725769213,-1.81125121799,6.27079208162,5.51912720337,5.2053513809,2.6403667066,13.8424197562,9.46005603069,9.1265894304,4.04764900508,-7.9421543145,-7.89562696048,0.0607490951573,-0.529566635101,-5.12321045597,4.05188604329,-0.00828135829204,0.725288729374,1.86908022726,-0.145596863116,-0.444538380671,4.69232347331,2.24544648569,4.13038008242,-0.594644611967,0.3154524768,-0.730777722545,-1.10116640874,-1.68539771781,-2.51831287648,-1.39564267736,-1.05748773754,-1.56804153218,0.672568695199,-0.191410945255,0.506706256161,-0.0349853811549,-0.278375814983,0.399867097526,0.226881076468,1.57763579004,-0.228975032161,0.618183890902,-0.141112340936,-0.164771424853,-0.715393927028,-0.831721512627,-0.486688165814,-0.313382182239,-1.03457515038,0.167354773626,0.190460861611,0.15559986873,0.0565300009553,-0.149339633169,-0.0809656563868,-0.198536905017,0.0844321681443,-0.0937176732194,0.421944910104,0.00391322813228,0.30469673352,-0.0075037715714,-0.0831131489363,0.0298730074987,-0.203828115463,-0.203703146436,-0.0984012490489,-0.420831139249,0.0618972018437,-0.0357930612823,-0.11759698041,0.0701013623402],[-29552.2803226,619.353138727,515.283120995,-161.980064315,-510.419375771,855.323288987,815.624376716,156.226062272,-226.744159623,134.387936207,72.8065531622,-234.958345319,-596.340707416,475.725801614,81.0573545946,-288.616303198,218.254704271,-249.423204723,-169.723670459,185.143234762,147.231675617,213.620959411,-58.1341609698,149.421057175,-113.767848243,71.4121523205,-39.0990422941,-39.7518455769,47.197562477,97.8062488679,81.4214809053,-98.7314541374,75.3614770674,-38.6062466404,-26.4683438298,-29.0321827956,17.1631027002,23.0979767767,5.35371955512,1.13704989496,24.7623627714,31.677600161,-2.77343853601,14.0739562619,-12.4883821345,-16.1523389402,8.30595057607,5.37694618823,-1.68635074163,6.14096501168,5.63222901991,5.14598887772,2.63151073006,14.1014863642,9.57090554045,9.40739627951,4.61658355194,-7.94828920932,-7.44698511717,0.21714922388,-0.304612897413,-5.22071303198,3.97792639457,0.0514342121255,0.767625530347,1.90301624047,-0.196482441989,-0.425925778195,4.74675334443,2.22206250906,4.2168148191,-0.470961956817,0.33213674457,-0.548561778965,-1.08210014065,-1.56700729535,-2.57755186423,-1.37431733824,-1.0788305697,-1.60409329788,0.680788020938,-0.167360838035,0.521784902084,-0.0545275389776,-0.270127501146,0.402178483675,0.205884513671,1.59444724911,-0.219905236599,0.630435777965,-0.0895824370243,-0.171613422615,-0.672716679754,-0.861538237508,-0.460248704308,-0.335983954699,-1.04301965707,0.171239569475,0.194673215522,0.154405989922,0.0651258250487,-0.147042403497,-0.0817699720322,-0.190409203068,0.0791018766072,-0.10087187482,0.424205022349,-0.000699813700617,0.309243734872,0.00308062793052,-0.087854212051,0.0462862364214,-0.214475757363,-0.190606456078,-0.109320764434,-0.420320049294,0.0617992366438,-0.0341357745705,-0.117820760527,0.0690388636341],[-29591.9666449,629.927452882,497.578290902,-160.677871207,-518.255140544,850.573088983,829.905410566,160.527083305,-216.005787676,135.49519253,75.1077385012,-236.981908803,-600.953501456,490.12728627,82.4915752152,-291.86045762,218.003573269,-251.446667804,-170.614177208,184.052503791,150.481603427,217.062694685,-66.2857111217,150.955175539,-114.682348849,69.4570456346,-39.7772759256,-38.7347507281,47.5834783004,100.44524852,83.7348839075,-99.7062080677,78.2283336932,-39.5450864873,-25.9544277413,-29.0840358242,16.518681338,23.0191036584,5.59268635451,1.45716776254,25.5616999982,32.3970586525,-2.49147668175,15.7601694542,-12.770767044,-15.2174359882,8.75345133169,5.80564328806,-1.56297727992,5.99527892339,5.72400223024,5.09968863007,2.61452192161,14.3670944265,9.68934723807,9.68586453042,5.20384902017,-7.97023220339,-6.99597596662,0.386043058845,-0.08342358627,-5.31697319994,3.91251017153,0.111450474545,0.805550013883,1.93144099682,-0.24666644992,-0.41359062957,4.8029919028,2.20307702189,4.3003561663,-0.34156190208,0.34292894152,-0.363843381449,-1.05916467513,-1.45111572224,-2.63536563121,-1.35185155354,-1.10177500111,-1.6382799924,0.690231377804,-0.143907808921,0.535932480679,-0.0746598808278,-0.264220027383,0.404922698183,0.185960999003,1.61022650486,-0.209044238726,0.640528125488,-0.0371564925496,-0.177514549954,-0.63100647714,-0.890893330483,-0.433697086006,-0.359108227847,-1.0511981408,0.175036027718,0.199128833134,0.15353051049,0.0739094682022,-0.144703477784,-0.0829170765973,-0.182850717402,0.0740709752419,-0.108237381454,0.42625171267,-0.00503607705652,0.313288656128,0.0139967362954,-0.0925253527412,0.0626978577648,-0.22488262723,-0.177479234168,-0.120308984811,-0.419901048597,0.0617880048352,-0.0325774445222,-0.118157603514,0.0681055793874],[-29631.3230969,640.832766393,480.466412631,-160.241562469,-525.017828651,846.668421811,843.399089326,164.377359478,-205.276117765,137.032051659,78.2403925781,-239.315321175,-606.001581381,503.91574562,83.4853770273,-295.215692741,217.80886804,-253.611417873,-171.803224427,182.963888338,153.578697922,220.356267949,-74.6018353859,152.671696335,-115.692247098,67.4262804851,-40.5303015295,-37.7396648977,47.9783359098,103.102129977,85.9967824131,-100.769532271,81.1442260724,-40.4896768561,-25.417542933,-29.1420979858,15.8445251863,22.9123129102,5.8607621222,1.77904075776,26.3417366677,33.1236769521,-2.2448697008,17.4733915041,-13.073697143,-14.2764015571,9.24270867727,6.23602150969,-1.43845734292,5.83323232949,5.79287484432,5.06661535436,2.58809039527,14.6352738576,9.81428069177,9.9568797833,5.80508146063,-8.00851982043,-6.54616336091,0.568361801526,0.131774384366,-5.41173763354,3.85565499483,0.172289099692,0.838710075102,1.95329827112,-0.296100035895,-0.408567898443,4.86038033531,2.18736595587,4.37908468011,-0.207748211515,0.347635046044,-0.178845238516,-1.0326804419,-1.33902663232,-2.69173761006,-1.32873136515,-1.1262913529,-1.6703527886,0.700977740976,-0.121111080674,0.549041957966,-0.0955048664,-0.261118473809,0.40815041217,0.166832660582,1.62460374355,-0.196765750225,0.648189267877,0.0155255428295,-0.182733980043,-0.590757832729,-0.919516507751,-0.407266753215,-0.382531925955,-1.05899822857,0.178767930061,0.20376498384,0.15302633835,0.0828899285621,-0.142285050437,-0.0844360657927,-0.175952991791,0.0694052379478,-0.115901369216,0.428059313043,-0.00915793341777,0.316701726897,0.0251091700084,-0.0972168066993,0.0789001020663,-0.234992939109,-0.164508904312,-0.131259535277,-0.419560130823,0.0618660786176,-0.0310970577538,-0.118601870661,0.0673089247481],[-29671.2885554,651.654271363,464.520088013,-160.896768177,-530.956336628,844.257569985,855.873490331,167.734684499,-194.852800836,138.909928474,82.3411790539,-242.078938269,-611.624617643,516.864815301,83.9080569531,-298.80710102,217.636114546,-255.865045235,-173.254057275,181.865228047,156.484618809,223.486936771,-83.0819560997,154.528125811,-116.823914708,65.3152663144,-41.3377394097,-36.7595809788,48.3853905324,105.739378136,88.2030911531,-101.94417657,84.0960141542,-41.4492668074,-24.851683634,-29.2098362555,15.1424374661,22.7765370905,6.15664053351,2.09715951097,27.0897978673,33.8577285714,-2.04287866726,19.2006967504,-13.3957317065,-13.3376201487,9.77550812509,6.66075337118,-1.31011744071,5.65432374271,5.83727487213,5.04693376699,2.55090626504,14.9020545718,9.9446054697,10.2153276383,6.41591692414,-8.06368858417,-6.10111115214,0.765036653398,0.338754100534,-5.50475300652,3.80737848511,0.234471758295,0.866753609127,1.96753183819,-0.344734348902,-0.411892548459,4.91825982883,2.17380524268,4.45108091664,-0.0708246488805,0.346061036533,0.00420994131575,-1.00296787074,-1.23204365942,-2.7466512334,-1.30544281495,-1.15234994619,-1.70006285937,0.713106085633,-0.0990298760539,0.561006299961,-0.117184955389,-0.261287920537,0.411912296757,0.148221626527,1.63720915147,-0.183443482778,0.653147539541,0.0678237194545,-0.187530886054,-0.552465260067,-0.94713748551,-0.381191148243,-0.406031973292,-1.06630754736,0.182459058213,0.208518937032,0.152946381413,0.0920762042747,-0.139749315865,-0.0863560353289,-0.16980757001,0.0651704386243,-0.123951014198,0.429602155446,-0.0131277542667,0.31935317679,0.0362825455546,-0.102018809618,0.0946851998634,-0.244750907045,-0.151882890118,-0.14206604093,-0.419283289634,0.0620360301912,-0.0296736008815,-0.119147923259,0.0666563148642],[-29712.5040328,662.016325163,450.150587425,-162.810936284,-536.258059712,843.762576012,867.124336995,170.607986483,-184.980206627,141.086319445,87.4753036959,-245.377527574,-617.854972631,528.80117534,83.6515942334,-302.721880083,217.460699751,-258.15087167,-174.93041728,180.759796576,159.156305743,226.433192189,-91.7297775016,156.490727139,-118.098319437,63.1249055148,-42.1808179791,-35.7860749098,48.8110585486,108.316635918,90.3473370858,-103.247287388,87.066274616,-42.4335248136,-24.2552031249,-29.2906539049,14.4140771225,22.6123346959,6.47949242116,2.40769092392,27.793415692,34.5992339536,-1.89407332723,20.9272164369,-13.7367924482,-12.4102526979,10.3533865856,7.07311171632,-1.17638352376,5.45795819122,5.85583768672,5.04102034163,2.50175478177,15.16380196,10.0795645317,10.4567835808,7.03148843046,-8.13618349783,-5.66448809399,0.976669885141,0.534939942652,-5.59563250471,3.76770469202,0.298333348504,0.889366580193,1.97322734157,-0.392491442665,-0.424485480475,4.97611781361,2.16161749822,4.5146852779,0.067944207532,0.33799239101,0.183184958815,-0.970364054933,-1.13152375646,-2.79992894474,-1.28240406116,-1.17991136048,-1.72723092905,0.726707209018,-0.0777296527068,0.571708393066,-0.139772312696,-0.26511276097,0.416273338877,0.129921917073,1.64770723167,-0.169383566587,0.655166544508,0.119145708108,-0.192140592275,-0.516635648223,-0.973458922027,-0.355739950636,-0.429407836082,-1.07304605338,0.186143711425,0.213338463689,0.153338980918,0.101468859572,-0.137063592603,-0.0886989811125,-0.164500367946,0.0614277958324,-0.132457360517,0.430855852676,-0.0169795128896,0.321132082558,0.0473876913131,-0.107010842409,0.109851444943,-0.254090492624,-0.139781449146,-0.152621955787,-0.419062619297,0.0623144587922,-0.0282942352213,-0.119784487594,0.0661574565111],[-29754.4190821,671.699946224,437.123855442,-165.918786238,-540.864387927,844.70052236,877.057937044,173.21073117,-175.689580065,143.703047415,93.4221406966,-249.2535032,-624.295776468,539.763683324,82.6986973836,-306.895648234,217.29745462,-260.395144849,-176.798031454,179.712603627,161.531818152,229.146459111,-100.566131433,158.560791177,-119.51481319,60.8780722793,-43.0471980874,-34.8050548091,49.2744009525,110.782178323,92.4134960774,-104.673597544,90.020451049,-43.4537969948,-23.6438908938,-29.3876993923,13.660525997,22.4267679761,6.8303972477,2.71350698398,28.4409502666,35.3472012699,-1.80425811466,22.6303094279,-14.102250837,-11.5065658719,10.9768865615,7.4687706918,-1.04007930415,5.24316676499,5.84802811347,5.05009858098,2.43980174362,15.418223319,10.2197744037,10.6795826371,7.64491687483,-8.22608348278,-5.24038254662,1.20254804427,0.716361468669,-5.68345536251,3.73668338124,0.363461678168,0.90638722899,1.9700378997,-0.439176989837,-0.446811344192,5.03402669326,2.15141207516,4.56927754944,0.207450521302,0.323132586005,0.3562846519,-0.935272742073,-1.03903715267,-2.85074923115,-1.25976172742,-1.20889720875,-1.75195592783,0.741919196628,-0.0573008078149,0.580990805218,-0.163137924053,-0.272654641655,0.421355788694,0.112015120907,1.65589975433,-0.154621805924,0.654150965295,0.169089661338,-0.19670302746,-0.483825388363,-0.998075243833,-0.331327788893,-0.452549148351,-1.07926301967,0.189898259124,0.218213341131,0.154234211389,0.111034723033,-0.134215695697,-0.0914584998339,-0.160094789946,0.0582203067795,-0.141426924392,0.431801140819,-0.0206335897875,0.32200290952,0.0583202832372,-0.112229366865,0.124221384085,-0.262904647585,-0.128356174772,-0.162820049541,-0.418914616488,0.0627740718032,-0.0269788208877,-0.120477749925,0.0658312229744],[-29796.1853916,680.525318242,425.044505188,-170.096855359,-544.655209995,846.362251488,885.608244285,175.807518707,-166.958884869,146.948016819,99.8896063551,-253.733690911,-630.442851214,549.844241225,81.0547572377,-311.226128944,217.171071122,-262.519843916,-178.823123176,178.804092921,163.54449541,231.571395914,-109.616131638,160.748365701,-121.067343915,58.6031337508,-43.9261486934,-33.8010118401,49.7976398915,113.081438375,94.3831562211,-106.212236459,92.919703773,-44.5218488828,-23.0378954804,-29.5040574725,12.8827216553,22.228525119,7.21091163312,3.0191559499,29.0209687236,36.1003856232,-1.77854613549,24.285391493,-14.4988407811,-10.6396027714,11.646301954,7.84400477006,-0.905127934362,5.00888706942,5.81351834085,5.07560374499,2.36430808558,15.6633614218,10.3661950035,10.8827497183,8.24882012143,-8.33337593986,-4.8329877718,1.4416287475,0.878699530919,-5.76716732645,3.7143707475,0.429257782557,0.917691865318,1.95775849978,-0.484567567808,-0.479220726519,5.09220511474,2.14414501038,4.61449736272,0.346625641475,0.301164597678,0.521799367774,-0.8981143433,-0.956207396372,-2.89812959062,-1.2375945537,-1.23921936234,-1.77440633738,0.758891956024,-0.0378399734447,0.588686024738,-0.187102480399,-0.283894522425,0.427296212186,0.0946547188327,1.66162280643,-0.139126423582,0.650040754042,0.217301352133,-0.201334271478,-0.454603247177,-1.02055381953,-0.308405528755,-0.475368086075,-1.08504004846,0.193809588278,0.223143848263,0.155657580677,0.120732189322,-0.131198564321,-0.0946210883792,-0.156648612475,0.0555864133344,-0.150850090068,0.432420036784,-0.0239819672655,0.321948970135,0.0689822091745,-0.117700089999,0.137623627321,-0.271076071205,-0.117751494326,-0.172552920805,-0.418861878487,0.0635016036432,-0.0257553926948,-0.121188261511,0.0656987791674],[-29836.9546495,688.312624914,413.517149783,-175.221680969,-547.510414639,848.038605854,892.709212523,178.66294924,-158.766084759,151.009132092,106.58561697,-258.844916475,-635.792018929,559.134751019,78.7251646297,-315.611045683,217.106241221,-264.446948015,-180.971915828,178.114708173,165.127676892,233.652660972,-118.904891858,163.063498491,-122.749859555,56.3284570724,-44.8069387562,-32.7584371662,50.4029975132,115.159849096,96.23790561,-107.852333552,95.7251931074,-45.6494460094,-22.4573654247,-29.6428129002,12.0816016632,22.0262943123,7.62259219741,3.32918608046,29.5220381954,36.8575421165,-1.82205049563,25.8678784013,-14.9332961882,-9.82240649675,12.361926664,8.19508842352,-0.775452566866,4.75405670993,5.75198055732,5.11897109364,2.27453474267,15.8972590417,10.5197862488,11.0653097361,8.83581603441,-8.45804826996,-4.44649703129,1.69286961155,1.01763498173,-5.84571414306,3.70082298547,0.495122696943,0.92315679898,1.93618412897,-0.528439753967,-0.522064214368,5.15087172503,2.14077234077,4.64998434922,0.484400917099,0.271771402189,0.678019453641,-0.859309269755,-0.884658035893,-2.9410875211,-1.21598127997,-1.27078969259,-1.79475063935,0.777775394765,-0.0194437816631,0.594626539947,-0.211486672673,-0.298813363116,0.434231175329,0.0779941916528,1.66471247493,-0.122865642351,0.642775862888,0.26342655348,-0.2061504042,-0.429537991354,-1.04046201771,-0.287424035961,-0.497776825234,-1.09045874201,0.197964585857,0.228130263992,0.15763459663,0.130519653102,-0.128005137649,-0.0981732436348,-0.154219611995,0.0535645573659,-0.160717241787,0.432694557477,-0.0269166276287,0.320953576865,0.0792753569722,-0.123448718823,0.149886784679,-0.278487462763,-0.10811183514,-0.181713168193,-0.418927002572,0.0645837887313,-0.0246519854567,-0.121876573605,0.0657812900032],[-29875.8785441,694.882049935,402.146402352,-181.169800388,-549.309890579,849.020427919,898.294795563,182.041622917,-151.089143457,156.074297668,113.218088841,-264.614005654,-639.839101672,567.727114681,75.7153103937,-319.948121925,217.127656885,-266.098436292,-183.210632792,177.724893101,166.214701972,235.334912661,-128.457525837,165.516237324,-124.556308057,54.0824093871,-45.6788372345,-31.6618219509,51.112695965,116.962843509,97.9593323373,-109.583018242,98.398079372,-46.8483539063,-21.9224492664,-29.8070504304,11.2581035863,21.828763744,8.06699556055,3.6481456344,29.9327258143,37.6174258528,-1.93988430101,27.3531859225,-15.4123509662,-9.0680201484,13.1240545925,8.51829612459,-0.654976354146,4.47761329192,5.66308695136,5.18163588689,2.16974264985,16.1179589516,10.6815080571,11.2262876016,9.39852247794,-8.60008787393,-4.08510358686,1.95522825313,1.12884867344,-5.91804155886,3.69609628987,0.560457456599,0.922658339778,1.90510977446,-0.570570125704,-0.575692394649,5.21024517109,2.14225010319,4.67537814039,0.61970769722,0.234635975698,0.823235256705,-0.819277932582,-0.826012619554,-2.97864052057,-1.1950006462,-1.30352007085,-1.8131573154,0.798719420412,-0.00220886453666,0.598644839167,-0.236111191814,-0.317392123561,0.442297244099,0.0621870201702,1.66500484681,-0.105807685024,0.632296243971,0.307111038369,-0.211267505497,-0.409198387585,-1.05736720699,-0.268834176249,-0.519687541805,-1.09560070256,0.202450138831,0.233172867225,0.160190767098,0.140355509038,-0.124628354854,-0.102101462487,-0.152865564969,0.0521931807431,-0.171018763794,0.432606719807,-0.0293295531819,0.319000042168,0.0891016144776,-0.12950096035,0.160839466191,-0.285021521538,-0.0995816245442,-0.190193390316,-0.419132586024,0.0661073614865,-0.0236966339875,-0.122503237463,0.066099920395],[-29912.3108135,700.170641671,390.498994381,-187.86968549,-550.023790177,848.724131132,902.464524948,186.127430654,-143.906482176,162.250771785,119.543623474,-271.058347253,-642.209356687,575.700361778,72.028623097,-324.150671258,217.238063659,-267.410793822,-185.513541165,177.695170644,166.758693963,236.567541985,-138.287329847,168.09585101,-126.477644065,51.8852447734,-46.5328627602,-30.4989806662,51.9469743351,118.447473602,99.5290129696,-111.394306969,100.901876528,-48.1280067812,-21.4497350681,-29.9985219621,10.4124061145,21.6429627077,8.5441420045,3.98026655354,30.243507484,38.378032944,-2.1354604218,28.719401807,-15.9403545844,-8.38888341772,13.9322046543,8.80999721696,-0.546500502017,4.1786124321,5.54695048121,5.26435763098,2.04961650522,16.3235918162,10.8521496568,11.3651714892,9.9304972492,-8.75927597299,-3.75282256904,2.22776422976,1.20883274803,-5.98326707372,3.70006975345,0.624853614734,0.916150118954,1.86444119548,-0.610802445827,-0.640224908229,5.27037561081,2.14938754039,4.6904244036,0.751630830196,0.189523969499,0.955902326778,-0.778364821081,-0.78163497844,-3.01001305824,-1.17484289483,-1.33728340263,-1.82983128995,0.821832302602,0.0138039572057,0.600639379983,-0.260828441282,-0.339559955753,0.451543040432,0.0473826216104,1.66237230026,-0.0879426014959,0.618584130899,0.348020509185,-0.216757579721,-0.394077102216,-1.07088784078,-0.253019295095,-0.540974658741,-1.10054557326,0.207354791114,0.238266618595,0.163341675934,0.150207565379,-0.121063542467,-0.106382688847,-0.152616939137,0.0514865597354,-0.181728687872,0.432142428756,-0.0311307680539,0.316085104849,0.098373799955,-0.135864826845,0.170336175688,-0.290570509099,-0.0922797811429,-0.197893708957,-0.419502738093,0.0681423458014,-0.0229084980245,-0.123036704377,0.0666711748747],[-29946.4133958,704.582907164,377.990130813,-195.45754636,-549.983320341,847.068412902,905.980243171,190.781426444,-137.198352098,169.323227879,125.513563209,-278.157582217,-643.045781957,583.082032253,67.66068224,-328.194367753,217.352421406,-268.3785294,-187.887082915,178.006380625,166.791911943,237.318870465,-148.360330287,170.708492482,-128.492849027,49.7247650526,-47.3670326575,-29.2710210191,52.9181394753,119.617267234,100.928477967,-113.279764245,103.209513102,-49.4885135444,-21.0415689835,-30.2136479716,9.54165243385,21.4692849208,9.0479064591,4.3285155118,30.4524941934,39.1343235378,-2.40539078512,29.9553017307,-16.5121187563,-7.7950223597,14.7827958192,9.06694052937,-0.448338429642,3.8565817924,5.4054471843,5.36519281732,1.91553605909,16.5126398652,11.0318175187,11.4833026238,10.4290578776,-8.93456906973,-3.45295658346,2.50994486205,1.25732450614,-6.04119520093,3.71191406123,0.688664796314,0.903895053508,1.81452723946,-0.64924921883,-0.714857611798,5.33063924575,2.16240671855,4.69529294986,0.87986916163,0.136531735434,1.0751370241,-0.73661073718,-0.751850074689,-3.0352574884,-1.15614427801,-1.37179673012,-1.84512325834,0.847055759281,0.0286771081861,0.600772497049,-0.285617674622,-0.365038780321,0.461665410113,0.0337141588898,1.65683237836,-0.0693477500842,0.601790883153,0.385900385906,-0.222516329156,-0.384362400209,-1.08084671185,-0.240092656924,-0.561361586898,-1.10536516089,0.212773714399,0.243385205654,0.167063211007,0.160081284717,-0.117315576453,-0.110955654729,-0.153394967341,0.0513623082148,-0.192755635968,0.431303141611,-0.0323024636676,0.312259209088,0.107048453336,-0.142477551584,0.17833499221,-0.295064936185,-0.0862231886383,-0.204744338571,-0.420067615917,0.0706919234631,-0.0222712369985,-0.123477025779,0.0674929164492],[-29978.550279,708.640218122,363.997134955,-204.121527639,-549.60995162,844.097541633,909.769370463,195.78395505,-130.945461899,176.995693191,131.127935594,-285.881914533,-642.62081065,589.886793643,62.6051050565,-332.070475597,217.363743566,-269.010657755,-190.345743724,178.61944209,166.366398928,237.561952246,-158.630736082,173.239535705,-130.577911091,47.5806589816,-48.1811139234,-27.9823740253,54.0365151778,120.487371229,102.139246262,-115.233841604,105.296271263,-50.927651782,-20.6967366889,-30.4475160794,8.64222685446,21.3064652064,9.57062751614,4.69554286613,30.5597057025,39.8804987907,-2.74458708234,31.0523333505,-17.1200707569,-7.29585962022,15.671472071,9.28596976181,-0.357681609522,3.51116704605,5.24089386783,5.4815221836,1.76930482489,16.68367322,11.2204474242,11.5824854932,10.8924618255,-9.12471748706,-3.18863010451,2.8013394114,1.27487253806,-6.09180220709,3.7306227963,0.752435144244,0.886233381878,1.75582752587,-0.686090134627,-0.798555416,5.39024378841,2.18138290974,4.69025962609,1.00427503644,0.0758383004812,1.18022091151,-0.693980560966,-0.736723153203,-3.05463313656,-1.13965255036,-1.40673812969,-1.85942035869,0.87428987047,0.0425288243646,0.599272494282,-0.3104898579,-0.393498710053,0.472273254883,0.0213107313473,1.64843891542,-0.05012231621,0.582110141679,0.420516017908,-0.228395380569,-0.380166446184,-1.08711769778,-0.230100005895,-0.580533984107,-1.11012931313,0.218803737323,0.248496997682,0.171321336193,0.169991543226,-0.113391720131,-0.115749539171,-0.155093573701,0.0517138744538,-0.20399187757,0.430094203736,-0.0328448732694,0.307586225407,0.11509304497,-0.149258673096,0.184819888598,-0.298444875824,-0.0814032220064,-0.210683016781,-0.420858888604,0.0737425657323,-0.0217596352634,-0.123832153134,0.0685583477439],[-30009.0854511,712.863946255,347.897330115,-214.049773963,-549.32515456,839.855785726,914.759327055,200.915361235,-125.128520257,184.972194959,136.386768177,-294.201548183,-641.206875933,596.129313485,56.8555087804,-335.770258977,217.165043581,-269.316193615,-192.904009276,179.495274083,165.534197936,237.269841478,-169.052756161,175.574354644,-132.708818405,45.432615317,-48.974873555,-26.6374707004,55.3124252351,121.072932411,103.142836788,-117.250990577,107.137433179,-52.4431990802,-20.4140238606,-30.6952139061,7.71051368652,21.1532383876,10.1046437674,5.08399897352,30.5651617716,40.6107598593,-3.14796100483,32.0019443234,-17.756637861,-6.90081784517,16.5938773935,9.46392861426,-0.271721514157,3.14201386629,5.05560733901,5.61072646749,1.61272631602,16.8352620018,11.4179751547,11.6645245854,11.3189665553,-9.32847154793,-2.9629676066,3.1015171392,1.2620254341,-6.13506435884,3.75518954172,0.816708801425,0.863505342504,1.6888016742,-0.721504883131,-0.890283231482,5.44839695126,2.20639138599,4.67560027919,1.12470079953,0.00762269161664,1.27043555186,-0.650439172523,-0.736319458882,-3.06839932823,-1.1261154665,-1.44178567772,-1.8731097291,0.903434716191,0.0554773417012,0.5963676756,-0.335455957182,-0.424609857738,0.482975476486,0.0103014383219,1.63724574575,-0.0303654852948,0.559735547427,0.451632754566,-0.234246360727,-0.381601404758,-1.08957467617,-0.223087086168,-0.598177508199,-1.11490787766,0.225541688523,0.253570363958,0.176082015365,0.179953217084,-0.109299236825,-0.12069352121,-0.157606682335,0.0524347067251,-0.215329682164,0.42852096049,-0.0327582301057,0.30213002433,0.122475045206,-0.156127729908,0.189774837695,-0.300650401046,-0.0778112562235,-0.215647481212,-0.421908225263,0.0772807438698,-0.021348477173,-0.124110037909,0.0698606713846],[-30038.3829001,717.775463274,329.068039599,-225.430429973,-549.550399709,834.387413581,921.877533175,205.955989761,-119.728235846,192.956760423,141.290088507,-303.086687154,-639.076410974,601.824259314,50.4055106453,-339.284982083,216.649334893,-269.304151706,-195.576365254,180.59479565,164.347351984,236.415592309,-179.580599451,177.598323264,-134.861559117,43.2603228157,-49.7480785494,-25.2407420601,56.7561934397,121.389097605,103.920768479,-119.325662697,108.708281019,-54.0329330249,-20.192216175,-30.9518290723,6.74289724021,21.0083392875,10.6422938048,5.49653419091,30.4688821606,41.3193079002,-3.61042424394,32.7955823066,-18.4142473435,-6.61931968042,17.5456557703,9.59766078673,-0.187649616047,2.74876792635,4.85190440505,5.75018640669,1.44760404588,16.9659763317,11.6243364916,11.7312243882,11.7068295295,-9.54458157526,-2.77909356411,3.41004730686,1.21933178453,-6.17095792279,3.78460788058,0.882029910764,0.836051173823,1.61390930393,-0.755673154255,-0.989005968888,5.50430644679,2.23750741937,4.65159075609,1.24099879583,-0.0679360641818,1.345062508,-0.605951451938,-0.750704236627,-3.07681538895,-1.11628078105,-1.47661745055,-1.88657850768,0.934390376466,0.0676408961558,0.592286344923,-0.360526938533,-0.458042336162,0.493380976666,0.000815379152534,1.62330670365,-0.01017644276,0.534860741344,0.479015945255,-0.239920896395,-0.388779440552,-1.0880915246,-0.219099641903,-0.613977817006,-1.11977070217,0.233084396637,0.258573673763,0.181311212397,0.189981182465,-0.105045389854,-0.125716779887,-0.160828217362,0.0534182533014,-0.226661319238,0.426588757238,-0.0320427674232,0.29595447638,0.129161924392,-0.163004260549,0.193183812343,-0.301621584882,-0.0754386662656,-0.219575469489,-0.423247295004,0.0812929291362,-0.0210125470814,-0.124318631572,0.0713930899968],[-30066.6575475,723.767675186,307.304505341,-238.273277935,-550.562145574,827.815579973,931.670552462,210.703002485,-114.716186631,200.713214131,145.815963295,-312.51631736,-636.445999482,607.011154864,43.264930597,-342.624694729,215.72799037,-268.994320387,-198.371106548,181.906192286,162.85148484,235.001560568,-190.167895088,179.21202722,-137.017863435,41.0449522873,-50.5021869235,-23.7941659876,58.3794653717,121.44983173,104.473814294,-121.453184449,109.990758249,-55.6935317281,-20.0276052752,-31.2136931089,5.73660222272,20.8696894888,11.1764978931,5.93457613169,30.271664695,42.0045908608,-4.12704232516,33.4278657959,-19.0864342488,-6.4567596181,18.5228348425,9.68481492517,-0.102860537157,2.33135913849,4.63199373686,5.89729497864,1.27528525941,17.0747249942,11.8399007091,11.7839268747,12.0550114114,-9.7720135291,-2.63909663087,3.72624852098,1.14780689713,-6.19972465464,3.81819244903,0.948924392175,0.804175797119,1.53153975106,-0.788748581048,-1.09384463583,5.55734280957,2.27466865831,4.61857555681,1.35315420253,-0.150672831632,1.40363742322,-0.56071948822,-0.779571163936,-3.0802723308,-1.1106801243,-1.51096080368,-1.90006924213,0.967069585774,0.0791300780161,0.587221499575,-0.385713961582,-0.49349551183,0.503175362277,-0.00710337015271,1.60672038325,0.0103844750064,0.507662519392,0.502482894127,-0.245354872509,-0.401620002364,-1.08265428589,-0.218122824566,-0.627703060523,-1.1247609162,0.241481260158,0.263480686816,0.186979525623,0.200092342061,-0.100631782607,-0.130756659466,-0.164651345365,0.0545713492281,-0.237911529625,0.424315007204,-0.0306988671577,0.289114836362,0.135135113485,-0.169837020597,0.195071203321,-0.301332464569,-0.0742646745043,-0.222431757421,-0.42489853008,0.0857519504774,-0.0207324724414,-0.124468952842,0.0731437394746],[-30093.5280494,730.719625197,284.073643777,-251.874650627,-552.056802502,820.578985155,943.161522174,215.02082963,-110.027427726,208.244569863,149.85461592,-322.50455245,-633.308827329,611.828948651,35.5083994292,-345.874589233,214.385820584,-268.449582536,-201.271764873,183.526715292,161.066543276,233.147308817,-200.765953049,180.376898939,-139.182429812,38.7736027518,-51.2454207741,-22.2899078363,60.1991737619,121.26437209,104.879763303,-123.632382122,110.993453536,-57.4172754048,-19.9065066713,-31.4821131886,4.69221492943,20.7319576116,11.7025029896,6.39466143496,29.9774194607,42.6820438526,-4.69349611038,33.906096644,-19.7711646995,-6.40241953528,19.5229768805,9.72625945936,-0.0155614973051,1.89085437108,4.39765146018,6.04949411978,1.09529212751,17.1617714257,12.0667710526,11.8221239588,12.3652856675,-10.0105959181,-2.54092217835,4.04843676891,1.05033294951,-6.22266826633,3.85654209551,1.01784527363,0.768042865042,1.44180121771,-0.820780569097,-1.20454462783,5.6075278625,2.31726225677,4.57717379375,1.46168352603,-0.24047804223,1.44671226265,-0.515894206077,-0.821127648692,-3.07968791217,-1.10898062935,-1.54474020902,-1.91324611852,1.00143569642,0.0900248948811,0.581224910522,-0.411028960203,-0.530785766112,0.512351060616,-0.0137508269095,1.58776441791,0.0314123277508,0.478250297589,0.522058724433,-0.250821206666,-0.419271675719,-1.07369766383,-0.219899414851,-0.6394513574,-1.12981477678,0.250591957014,0.26828672459,0.193076091219,0.210311704617,-0.0960373787329,-0.135783165119,-0.16896620278,0.0558543766431,-0.249134939551,0.421765395063,-0.0287275060031,0.281631896209,0.140431885867,-0.176691633828,0.195623073161,-0.299892934181,-0.0742198928929,-0.224289273565,-0.426847415321,0.0905760675799,-0.0205122531013,-0.124584289451,0.0750804887865],[-30118.4639956,738.38189081,261.260289971,-265.352518458,-553.585768802,813.195215757,954.992722976,218.790718514,-105.587883533,215.613638711,153.274308924,-333.074288003,-629.60223093,616.441445386,27.2267506476,-349.138643542,212.625995536,-267.743594659,-204.25568115,185.580882418,159.006054815,231.001701296,-211.325503517,181.069582536,-141.365698763,36.434855282,-51.9876932177,-20.7176798272,62.2335731293,120.840774081,105.235658602,-125.862956959,111.73161684,-59.1953447959,-19.8127418402,-31.7596403943,3.61116205274,20.5889990357,12.2161377248,6.87210399621,29.590834609,43.3713487777,-5.3056202956,34.2407475423,-20.4675125878,-6.44155315525,20.5440278123,9.72366776506,0.0758371342242,1.42860473155,4.15054556447,6.20423800632,0.906690552645,17.2277177262,12.3074842602,11.8448450401,12.6401289654,-10.2603728879,-2.48147975745,4.37467738324,0.930258836769,-6.24135795891,3.90057672155,1.08922736011,0.727780713085,1.3447316225,-0.851792467123,-1.32100743734,5.65504625056,2.3645377451,4.52807323244,1.56723610502,-0.337256019168,1.47509307189,-0.472863739139,-0.873209531375,-3.07611157798,-1.11063330499,-1.57792941762,-1.92562873248,1.03746471518,0.100397708677,0.574313042136,-0.436484061831,-0.569758734094,0.520977204091,-0.0195080317642,1.56676120082,0.0530410242531,0.446716646969,0.537820514205,-0.256677074633,-0.44069033032,-1.06176852743,-0.224111600756,-0.649403318447,-1.13484182279,0.260228734988,0.272992498999,0.199594679821,0.220666305394,-0.0912354819489,-0.140774467244,-0.173662168506,0.0572411044569,-0.260418646587,0.419017673352,-0.0261298093429,0.273517832135,0.145103475528,-0.183662941066,0.195065902332,-0.297446852002,-0.0752227807801,-0.225247984662,-0.429070198704,0.0956698978154,-0.0203617320087,-0.124690996385,0.0771661401693],[-30140.9349758,746.505049529,240.749278985,-277.824851835,-554.700442781,806.181858405,965.806435533,221.893916453,-101.323478456,222.883231764,155.94330485,-344.248419599,-625.263546698,621.012449782,18.5108177579,-352.5208356,210.451685224,-266.950013267,-207.3001963,188.193211416,156.683546978,228.713602248,-221.797276678,181.266722129,-143.578110801,34.0172909505,-52.7389173708,-19.0671941813,64.5009179923,120.187093101,105.638543287,-128.144610202,112.220498127,-61.0189206422,-19.7301322587,-32.0488258091,2.49487028506,20.4346691409,12.7132307291,7.36221771096,29.1165982912,44.0921875386,-5.95924957685,34.4422911824,-21.1745518058,-6.55941420131,21.5839335657,9.67871321803,0.172924988148,0.945961327287,3.89234403916,6.35898081445,0.708546437242,17.2731659953,12.5645770701,11.8511195177,12.8820179727,-10.5213885844,-2.45767891909,4.70303569654,0.790933453983,-6.2573629334,3.95121622865,1.16350545659,0.683517676743,1.24036888407,-0.881807623847,-1.44313455684,5.70008261872,2.41574465363,4.4719616384,1.67046127816,-0.440911085639,1.48958589652,-0.433016221037,-0.933652652466,-3.0705927732,-1.11508916,-1.61050218051,-1.93673667969,1.07513264881,0.110320881332,0.566502358787,-0.462091393903,-0.610260050864,0.52912292511,-0.0247560253635,1.54403312516,0.0754044732932,0.413154138563,0.549845341469,-0.263279652175,-0.464831835872,-1.04741374569,-0.23044157028,-0.65773955448,-1.13975159312,0.270203841863,0.277598721958,0.206529062063,0.231183179653,-0.0861993959711,-0.145708736239,-0.178628621444,0.0587053015803,-0.271849748307,0.416149594609,-0.0229069025602,0.264784820356,0.149201116458,-0.190845783136,0.193626171303,-0.294138076314,-0.0771917975146,-0.225407857454,-0.431543128203,0.100938058556,-0.0202907521106,-0.124815428629,0.0793634958599],[-30160.4105796,754.839678857,224.425445882,-288.409621164,-554.952222746,800.056499726,974.244940509,224.211670765,-97.1601368965,230.116160112,157.729866241,-356.049842817,-620.230111047,625.705766551,9.45143426561,-356.125143354,207.866059649,-266.142494866,-210.382651245,191.488220037,154.112547289,226.431875917,-232.132002715,180.944961833,-145.830106441,31.5094908302,-53.5090063499,-17.3281631196,67.0194628697,119.311384549,106.185460454,-130.477043093,112.475347358,-62.8791836846,-19.6424994037,-32.352220516,1.3447663188,20.2628233069,13.1896106328,7.8603164747,28.5593986585,44.8642420373,-6.65021865011,34.5212002558,-21.8913562457,-6.74125639677,22.6406400686,9.59306919401,0.277291695183,0.444275265715,3.62471487371,6.51117672037,0.49992568374,17.2987183326,12.8405862204,11.8399767911,13.0934293567,-10.7936871533,-2.46642921415,5.03157704136,0.635705696245,-6.27225239082,4.00938051833,1.24111436805,0.635382091508,1.12875092106,-0.910849387991,-1.57082747881,5.74282161197,2.47013251272,4.40952677716,1.77200838415,-0.551347564834,1.49099678212,-0.397739785404,-1.00029285244,-3.06418094276,-1.12179920316,-1.64243224873,-1.9460895558,1.11441550407,0.119866774771,0.55780932485,-0.487863083854,-0.652135351506,0.536857356081,-0.0298758483539,1.51990258411,0.0986365836511,0.377655343405,0.558210284256,-0.270986115058,-0.49065206208,-1.03118018763,-0.238571511423,-0.66464067631,-1.14445362665,0.280329525423,0.28210610538,0.213873008581,0.241889362656,-0.080902424516,-0.150564142503,-0.183754940492,0.0602207369239,-0.283515342281,0.413238911372,-0.0190599110386,0.255445037086,0.152776042647,-0.198335000862,0.191530360544,-0.2901104654,-0.0800454024452,-0.224868858685,-0.434242451794,0.106285167172,-0.0203091563546,-0.12498394117,0.0816353580954],[-30176.6708766,763.312635916,213.423551547,-296.494771758,-554.013714589,795.226009254,979.269743982,225.646505929,-93.060272891,237.341585312,158.556470442,-368.487136971,-614.483152032,630.665887057,0.179491199389,-360.032823876,204.885747537,-265.384056936,-213.479175701,195.544866262,151.316594974,224.273480394,-242.296151153,180.09455247,-148.126660706,28.9089092077,-54.3098300816,-15.4937374541,69.7984962806,118.223902045,106.94875716,-132.861470116,112.512626558,-64.7688368811,-19.5364522756,-32.6707341997,0.163483228589,20.0665619885,13.6420044369,8.3625000369,27.9239390914,45.7012169411,-7.37522765008,34.4876920684,-22.6163766889,-6.97423383492,23.7111183175,9.46863864263,0.390157533683,-0.0749083684057,3.34876169906,6.65853817968,0.280045002968,17.3049711463,13.1371658026,11.8105825201,13.2766707061,-11.0767233896,-2.50452768793,5.35859452089,0.467808302532,-6.28751897756,4.07577571074,1.32241457216,0.583514480822,1.0100598755,-0.938966505054,-1.70393113344,5.78337613747,2.52708582353,4.34137390759,1.87238355151,-0.668368520269,1.48030526297,-0.36805044247,-1.07119297156,-3.05781523738,-1.1302160192,-1.67372255137,-1.95341276592,1.15525436095,0.129098709354,0.548277963037,-0.513806200197,-0.695238833334,0.544250657281,-0.0351900528475,1.49465350304,0.122829774021,0.340316011659,0.563059269864,-0.280052469633,-0.517255575218,-1.01355085051,-0.248204333157,-0.670271425786,-1.1488891375,0.290452266136,0.286495253679,0.221605939946,0.252804642665,-0.0753187135579,-0.155328615312,-0.188951197975,0.0617664751048,-0.295482362225,0.410354261481,-0.0146052194176,0.245518392291,0.155880321053,-0.206198091993,0.18897357424,-0.285490337185,-0.0837043664463,-0.223729002229,-0.437138633709,0.111627487327,-0.0204253436337,-0.125217103695,0.0839503280572],[-30190.7378554,772.555896301,205.878060153,-302.548148545,-552.04235454,791.654388143,981.119253685,226.186055083,-89.1322590108,244.454070788,158.562454007,-381.511616313,-608.179464263,635.960049265,-9.01389032072,-364.234250752,201.581212515,-264.695160835,-216.561054568,200.259868982,148.359276081,222.227749175,-252.319148865,178.760171673,-150.450886651,26.2484932252,-55.1610857327,-13.5708223615,72.8114427459,116.943692102,107.90199631,-135.305158718,112.353646001,-66.6866720586,-19.4097499696,-32.9987109507,-1.04152038208,19.835965941,14.0707326246,8.86801156272,27.2149838875,46.5929079759,-8.13443846615,34.3509623839,-23.3455714732,-7.25310208896,24.7884395844,9.30824280894,0.511265372552,-0.609268580891,3.06333071215,6.7998107656,0.0487243393128,17.2924980775,13.4524393218,11.7626474061,13.4333732929,-11.3675946856,-2.56832136328,5.68329232078,0.290009387382,-6.30434912134,4.15025280045,1.40746923721,0.528104119913,0.885054783033,-0.966309307651,-1.84206420183,5.82157215117,2.58652897052,4.26777826206,1.97152006813,-0.791371976762,1.45918482808,-0.343475708865,-1.14532384912,-3.05199363081,-1.13979849653,-1.70449272977,-1.95925495304,1.19745059223,0.138043839171,0.538062529424,-0.539907575751,-0.739458942558,0.551377100462,-0.0407872368186,1.46841593606,0.147910502758,0.301244610017,0.564803622675,-0.290330044587,-0.544341727836,-0.994753244603,-0.259125828351,-0.674733068897,-1.15312604073,0.300555475213,0.290666341277,0.229649876466,0.263919819956,-0.0694257781035,-0.160029119449,-0.194210239923,0.0633427635658,-0.307737086424,0.407527823994,-0.00962024936191,0.235055730949,0.158569350508,-0.214393181961,0.186025411441,-0.280333848159,-0.088098706496,-0.222078490495,-0.440179003207,0.116927867844,-0.0206419366241,-0.125512344701,0.0863002027054],[-30203.9439848,783.377715225,199.173361693,-307.307571358,-549.316786411,789.194920456,980.351102764,225.839228527,-85.5209574608,251.314530432,157.941368291,-395.060278829,-601.519733991,641.636177795,-17.7975316518,-368.697076695,198.03637694,-264.085628895,-219.598361543,205.484387321,145.314188358,220.252109604,-262.246162065,177.00010378,-152.780431842,23.5700632388,-56.0844272798,-11.5697616094,76.022760787,115.491999457,108.994044769,-137.816889586,112.020928019,-68.6330032613,-19.2629391044,-33.3288534612,-2.26157952749,19.5603609947,14.4770140495,9.37688007131,26.4373125735,47.5231336327,-8.92887842638,34.1199515803,-24.0742758259,-7.5745171021,25.8647002098,9.11493251189,0.63998872833,-1.1562904002,2.76670375142,6.93399833071,-0.194065554451,17.2618670757,13.7836476362,11.6960184113,13.5649993104,-11.6628090831,-2.65404475742,6.00510239728,0.104960909224,-6.32385269525,4.23244900067,1.49626720419,0.469352471955,0.754638902698,-0.993053525174,-1.98478880277,5.85716387119,2.64852130897,4.18893256628,2.06920801177,-0.919654699452,1.42948245518,-0.323170977822,-1.22188332422,-3.0471038026,-1.15000709952,-1.73489160328,-1.96437056958,1.24077064393,0.146720276748,0.527344838431,-0.566148984408,-0.784692687616,0.558311985246,-0.0466975097073,1.44128146946,0.173763738128,0.260552784306,0.563921516341,-0.301568999194,-0.571758569053,-0.974951008435,-0.27114251085,-0.678111002669,-1.15726392665,0.310656796547,0.294499435096,0.237912488384,0.27521844781,-0.0632019754174,-0.164702378579,-0.199545605788,0.064955145456,-0.320245629304,0.404782663269,-0.00419768179236,0.224115631786,0.16089936281,-0.222851053122,0.182724094915,-0.274679614452,-0.0931607510981,-0.220005573025,-0.443305105804,0.122160803836,-0.0209601139479,-0.125861307388,0.0886825779446],[-30217.6217331,796.586347902,190.693846164,-311.510860029,-546.115654017,787.700890252,977.522924362,224.614936561,-82.3712304459,257.783878135,156.886764653,-409.070122504,-594.704647467,647.742197265,-25.8402541508,-373.388954419,194.335163165,-263.565283444,-222.56117032,211.069580399,142.254929557,218.303989029,-272.122356967,174.872633131,-155.092943843,20.9154396046,-57.1015086996,-9.5008989656,79.3969089252,113.890068846,110.173769402,-140.405443408,111.536994948,-70.6081445332,-19.0965662986,-33.6538644233,-3.48802922194,19.2290729798,14.8620675653,9.88913458179,25.5957046763,48.4757124023,-9.75957485884,33.8036000354,-24.7978249741,-7.93513481752,26.9319965344,8.89175857041,0.775701117559,-1.7134588548,2.45716265532,7.06010472762,-0.448353925548,17.2136460902,14.1280316043,11.6105424978,13.6730109516,-11.9588746238,-2.75793238759,6.32345670666,-0.0846851735148,-6.34713957237,4.32200152463,1.58879731408,0.407461000124,0.619715493538,-1.01937488702,-2.13166705509,5.88990551566,2.71312219416,4.105029546,2.16523746017,-1.05251345348,1.39304512196,-0.306291642569,-1.30006923594,-3.04353343227,-1.16030229255,-1.76506799129,-1.96951406799,1.28498096206,0.155146134608,0.516306704476,-0.592512200063,-0.830837076943,0.565130611253,-0.0529509809534,1.41334168956,0.200274448402,0.218352180351,0.560891124513,-0.313519492724,-0.599354147989,-0.954307780526,-0.284060894496,-0.680490624127,-1.16140238555,0.320773874035,0.29787460206,0.246301445945,0.286684079505,-0.0566256627645,-0.169385116361,-0.204970835025,0.0666091639244,-0.332974105293,0.402141843667,0.0015698023701,0.212756673532,0.162926589759,-0.231502487833,0.179107847429,-0.268566252195,-0.0988228287564,-0.217598499361,-0.446458487016,0.127300790419,-0.0213810542271,-0.126255634957,0.0910950496794],[-30233.1035689,812.990049545,177.823903559,-315.895834391,-542.71760117,787.025581595,973.192351626,222.522089484,-79.827940171,263.723027788,155.592194447,-423.478145323,-587.934890943,654.326032291,-32.8108791749,-378.277536637,190.561493547,-263.143946814,-225.419554597,216.866607338,139.255097428,216.340814794,-281.992899783,172.436044062,-157.36607022,18.3264426787,-58.233983969,-7.37457819773,82.8983456818,112.159145005,111.390037074,-143.079600872,110.924369119,-72.6124099185,-18.911178171,-33.9664465293,-4.7122044797,18.8314277268,15.2271120258,10.4048041133,24.6949397227,49.4344627756,-10.6275550916,33.4108481272,-25.511554145,-8.33161117842,27.9824248988,8.64177180342,0.917776056778,-2.27825897314,2.13298926227,7.17713380893,-0.714170021201,17.1484030706,14.4828320843,11.5060666275,13.7588704097,-12.2522993492,-2.87621877103,6.63778720517,-0.276276902405,-6.37531962579,4.41854758551,1.68504840786,0.342631167595,0.481187814594,-1.04544912257,-2.28226107757,5.91955130272,2.78039098138,4.01626192692,2.25939849106,-1.18924500399,1.35171980613,-0.291993096339,-1.37907942337,-3.04167019935,-1.17014453995,-1.79517071317,-1.97543990071,1.32984799263,0.163339525273,0.505129941975,-0.618978996611,-0.877789118976,0.571908278105,-0.059577759997,1.38468818264,0.227327601847,0.174754443978,0.556190620843,-0.325931684451,-0.626976513763,-0.932987199401,-0.297687493132,-0.681957330295,-1.16564100773,0.33092435157,0.30067190909,0.254724419391,0.298300268321,-0.0496751974094,-0.17411405646,-0.210499467088,0.0683103621202,-0.345888628818,0.399628429547,0.00758952220457,0.201037434915,0.164707263154,-0.240278268449,0.17521489175,-0.262032377521,-0.105017267975,-0.214945519045,-0.449580692358,0.132322322705,-0.0219059360837,-0.126686970606,0.0935352138145],[-30251.5565602,833.05257254,158.744859114,-321.04259409,-539.43119774,787.085702673,967.920500716,219.575051164,-77.9918325848,269.049895745,154.230726588,-438.175626499,-581.371039731,661.425841635,-38.4644160998,-383.33179983,186.793846805,-262.811724212,-228.146634057,222.741075201,136.371332329,214.317902647,-291.887261206,169.745245783,-159.580565409,15.8447336361,-59.4967773704,-5.19990563298,86.4967669605,110.31974482,112.599109052,-145.841032068,110.204863927,-74.6481743715,-18.7020823167,-34.2608467138,-5.92469122057,18.3596886328,15.5731801221,10.9256614437,23.7393475745,50.3854950551,-11.5335979528,32.9512315212,-26.2119596399,-8.75747750902,29.0090192684,8.36917966906,1.06516505586,-2.84792732703,1.79291544027,7.28453289681,-0.990535721069,17.0662995612,14.8456952142,11.3822998136,13.8243274163,-12.539754225,-3.00500737942,6.94751834431,-0.467163795938,-6.40933247611,4.52126578779,1.78478458002,0.275116240963,0.339791219399,-1.07133412263,-2.43586948865,5.94582606407,2.85049575196,3.92265070037,2.35154281356,-1.32911304758,1.30719427689,-0.279549025947,-1.45804806276,-3.04179910926,-1.17918240099,-1.82537009694,-1.98269385347,1.37511219018,0.171255781008,0.493968583833,-0.645517017972,-0.925413323318,0.578678001891,-0.0665484289972,1.35535329191,0.254796581009,0.129905030727,0.550239590832,-0.338564034424,-0.65448286799,-0.911153733547,-0.31185910366,-0.682634172428,-1.17001851898,0.34109176617,0.30280023525,0.263092511852,0.310029042609,-0.0423447804381,-0.178915730507,-0.216154458493,0.0700645487024,-0.35893561752,0.397257699805,0.0137860969793,0.189009672562,0.166288182269,-0.249113668797,0.171080221592,-0.255123943324,-0.111669806609,-0.212129061265,-0.452608188941,0.137194734597,-0.0225339594779,-0.127148991233,0.095993481815],[-30273.4861721,855.85965796,134.825779023,-326.900358027,-536.684717815,788.051658198,962.282419849,215.809999731,-76.7871886111,273.91040821,152.893500219,-452.87097014,-575.013225393,669.040720615,-42.9006263765,-388.526015553,183.088927128,-262.479852362,-230.727712338,228.616382811,133.592445049,212.182121946,-301.772129849,166.841646989,-161.729611333,13.511336927,-60.8778944102,-2.98103783631,90.182818194,108.389473782,113.786824205,-148.662964691,109.397457,-76.726056487,-18.4436302372,-34.537488882,-7.11307898638,17.817869362,15.9005598961,11.4604543857,22.7314594328,51.3240867898,-12.4774882712,32.4366670321,-26.9001820571,-9.19376665756,30.0085641069,8.08281618217,1.21513159802,-3.41870666169,1.43747317547,7.38352319169,-1.27244343454,16.9658714863,15.21588825,11.2383992729,13.8722818571,-12.8185619127,-3.13987750232,7.25204455663,-0.654701280283,-6.44943673405,4.62750030091,1.88687093911,0.2053767005,0.19558943945,-1.09661642361,-2.59073690519,5.96833708569,2.92403949154,3.82352992001,2.44176866214,-1.47124900667,1.26051946938,-0.268706292548,-1.53585467903,-3.04379447095,-1.18781681441,-1.85592250509,-1.99098704523,1.42041004338,0.178599113031,0.482865536891,-0.672037388171,-0.973444204243,0.585303664569,-0.0735954609895,1.32513238818,0.282508425542,0.0840846350088,0.543223267374,-0.351208205803,-0.681767022264,-0.88897517131,-0.326533655207,-0.682794818702,-1.17433018707,0.351123227349,0.304283708169,0.271330558003,0.321746331016,-0.0346919882217,-0.183775902022,-0.221996434003,0.0718785943698,-0.371982701892,0.39501379148,0.020153346719,0.176697854697,0.167678416272,-0.257961928588,0.166725914469,-0.247916249562,-0.118679819923,-0.209208273786,-0.455457130263,0.141866715154,-0.0232564097222,-0.127643508521,0.0984315273882],[-30299.2324695,880.152544053,108.232664723,-333.260624916,-534.936361538,790.157277007,956.856640256,211.268566883,-76.0941729175,278.507493851,151.651172043,-467.226861584,-568.821468554,677.159998693,-46.3054594743,-393.835779131,179.49799507,-262.039850865,-233.151139068,234.430376931,130.890288984,209.878230452,-311.598498802,163.763281246,-163.809496787,11.3671178206,-62.3586109003,-0.720893932131,93.9523821974,106.385209529,114.946415804,-151.511515839,108.520417024,-78.8587357702,-18.1049344105,-34.7983411817,-8.26420822446,17.2129211454,16.209353227,12.0196745111,21.6733568339,52.2478073405,-13.4587623757,31.879666762,-27.5785230689,-9.6183868533,30.9787815029,7.7926719968,1.36451715978,-3.9865912657,1.06764448357,7.47576936356,-1.55387820345,16.845248365,15.5930837272,11.0733842733,13.9059211564,-13.086207998,-3.27627738373,7.55075276989,-0.836246258527,-6.49572075784,4.73413668556,1.98994784717,0.133924829896,0.048478300735,-1.12076472333,-2.74484444364,5.98666226717,3.00173391178,3.71806190511,2.53023590266,-1.61475123516,1.21258711022,-0.259330050885,-1.61131513427,-3.04742791924,-1.19663681386,-1.88710580877,-1.99982192825,1.46535204945,0.1850109523,0.471835926478,-0.69843710126,-1.02158377719,0.591606864565,-0.0803918017286,1.29376159916,0.310278589379,0.0376077609472,0.535268295211,-0.363664162525,-0.708731940674,-0.866620131002,-0.341699359963,-0.682750591518,-1.17831041528,0.360831737743,0.305175267617,0.279366825407,0.333306537259,-0.0267902409524,-0.188670142493,-0.228095435444,0.0737596353313,-0.38487781564,0.39287305615,0.0267023916375,0.164119627442,0.168877601807,-0.266780779003,0.16217081884,-0.240491932955,-0.125940092531,-0.206236484018,-0.458038591415,0.146281792219,-0.024062593467,-0.128174367849,0.100803839802],[-30329.1355168,904.672469065,81.1315176491,-339.914893471,-534.644329054,793.636387942,952.221693171,205.992384317,-75.7929501715,283.044081334,150.574398761,-480.905986165,-562.75578984,685.773005332,-48.8648648631,-399.236685887,176.072311183,-261.383239323,-235.405263873,240.120904323,128.236717531,207.350985927,-321.317361156,160.548182121,-165.816510566,9.45294158588,-63.9202026529,1.57760695513,97.8013417857,104.323829703,116.071117119,-154.352802611,107.592012687,-81.0588917261,-17.6551073144,-35.0453717608,-9.36491938212,16.551795214,16.4996619941,12.6138133913,20.567121314,53.1542260678,-14.4769565949,31.2927428132,-28.2492843479,-10.0092463255,31.917393545,7.508737767,1.51016321768,-4.5475754276,0.684411380262,7.56293608242,-1.82882506963,16.7025597164,15.9769541815,10.8862740828,13.9284327382,-13.3401780662,-3.40965526767,7.84302991188,-1.00915563376,-6.54827290573,4.83806050244,2.09265566624,0.0612729128445,-0.101646370756,-1.14324771959,-2.89617322049,6.00037950806,3.08429072437,3.60540897492,2.61710440096,-1.75871808693,1.16428892604,-0.251285455699,-1.68324529058,-3.05247108897,-1.20623143296,-1.91919787911,-2.00870095478,1.50954870561,0.190132729773,0.460894877922,-0.724613151292,-1.0695340576,0.597409200305,-0.0866103969693,1.26097705259,0.337922526452,-0.00921108733262,0.526501319086,-0.375731868527,-0.735280587311,-0.844257230933,-0.357344430111,-0.682812813283,-1.18169360686,0.370030299987,0.305527853363,0.287129581623,0.344564065056,-0.0187129588227,-0.19357402341,-0.234521504641,0.0757148077956,-0.397468892471,0.390811845388,0.0334443519488,0.151292636919,0.169885375517,-0.275527951225,0.157433783166,-0.232933630225,-0.13334340905,-0.203267019373,-0.460263647489,0.15038349364,-0.0249418173629,-0.128745414597,0.103064908324],[-30363.5353788,928.160671243,55.688339237,-346.654662405,-536.266820506,798.72281984,948.956109824,200.023083729,-75.7636850406,287.723099325,149.733837074,-493.571029219,-556.776209873,694.869069993,-50.7647920123,-404.704331144,172.863136022,-260.401537337,-237.478436381,245.625811753,125.603584085,204.545146129,-330.879710004,157.23438318,-167.746941466,7.80967349198,-65.5439454801,3.91154570105,101.725579774,102.222211942,117.154161421,-157.152942103,106.630512676,-83.3392038599,-17.0632614271,-35.2805487669,-10.4020529067,15.841442799,16.7715880768,13.2533625978,19.4148344093,54.0409123323,-15.5316072578,30.6884072877,-28.9147675663,-10.3442533035,32.8221223217,7.24100414681,1.64891124827,-5.09765343596,0.288755881257,7.64668801826,-2.09126907489,16.5359350598,16.3671721485,10.6760879691,13.9430040268,-13.5779577029,-3.53545939815,8.12826291038,-1.17078630907,-6.60718153595,4.93615731224,2.19363475838,-0.0120667669647,-0.254888749035,-1.16353411021,-3.04270435219,6.00906670794,3.17242164098,3.4847334487,2.70253402289,-1.90224791586,1.11651664346,-0.24443766173,-1.75046101005,-3.05869561497,-1.21718970537,-1.95247658727,-2.01712657709,1.55261050906,0.193605876408,0.450057516549,-0.750462532316,-1.1169970609,0.602532270217,-0.0919241924662,1.22651487617,0.365255690691,-0.0560574057055,0.517048983742,-0.387211287746,-0.761315926263,-0.822055089415,-0.373457077841,-0.6832928064,-1.18421416509,0.378531916717,0.305394405178,0.294547094214,0.355373318127,-0.0105335620248,-0.198463116263,-0.24134468342,0.0777512479714,-0.409603866093,0.388806510773,0.0403903478668,0.138234529251,0.170701374045,-0.284161176435,0.152533655908,-0.225323978093,-0.140782554095,-0.200353207262,-0.462043373577,0.154115347262,-0.0258833880605,-0.129360494145,0.105169222222],[-30402.4434028,949.750968811,33.5624738094,-353.321203203,-540.02924872,805.487983495,947.420501191,193.406076137,-75.9338206774,292.721142789,149.180831714,-505.00397168,-550.848918812,704.375490249,-52.1549448627,-410.217564763,169.912217019,-259.002614854,-239.378407471,250.886089169,122.951505296,201.419047059,-340.235250167,153.85659463,-169.594977664,6.46886964337,-67.2072197752,6.27328970715,105.718467494,100.091030578,118.187493133,-159.876667611,105.649483725,-85.7081567624,-16.3074160207,-35.504891244,-11.3645266678,15.0896543517,17.0260718601,13.9469436301,18.2180273293,54.9047856419,-16.6189273011,30.0760054279,-29.5758485642,-10.6062874818,33.6909323915,6.99800272805,1.77821897134,-5.63319825443,-0.11799597094,7.72882882277,-2.33554959982,16.3436470729,16.7629041081,10.4427409655,13.9517353156,-13.7968536516,-3.65027152778,8.40618326219,-1.31888534288,-6.67239760256,5.02557349948,2.2916142012,-0.0856720296031,-0.41126276884,-1.18104089858,-3.18263554292,6.01229286262,3.26662241281,3.35548814774,2.78650202149,-2.04423734511,1.06990721058,-0.238527851281,-1.81198985274,-3.06585487122,-1.22996008841,-1.98715327671,-2.02465187462,1.59417075972,0.195128120046,0.439293243896,-0.775867153799,-1.16368911788,0.606809249388,-0.0960044359081,1.19015130496,0.392103503662,-0.102612746117,0.506986700898,-0.397900412414,-0.786757637577,-0.800129960745,-0.389973939327,-0.684437201188,-1.18563585976,0.386197437036,0.304816045098,0.301560376423,0.365594712368,-0.00233139188946,-0.203320030237,-0.248616899542,0.0798684521842,-0.421134658184,0.386809002704,0.0475457433297,0.124967662746,0.171316005475,-0.292625110204,0.147481832373,-0.217720826368,-0.14814989906,-0.197533340393,-0.463288785533,0.157438274699,-0.0268707607642,-0.130019718324,0.107079630573],[-30444.5560677,970.147499902,14.386637237,-359.954878425,-545.225877252,813.353617517,947.103797217,186.201889829,-76.4199141746,298.109471879,148.88947953,-515.463976867,-544.964784943,713.971436127,-53.0400452402,-415.768254749,167.223249125,-257.159743201,-241.190533027,255.855299262,120.196150822,197.985337662,-349.328533395,150.436233233,-171.34640487,5.42484948599,-68.8718242568,8.63635247871,109.763330343,97.9161467014,119.157901287,-162.483177221,104.643684752,-88.1574553689,-15.4012175456,-35.7156218198,-12.2495682243,14.3075772054,17.2674077519,14.6956976991,16.9760299764,55.7401660926,-17.7218360936,29.4522150361,-30.227699851,-10.7981144165,34.5227581934,6.78242885357,1.89800907967,-6.1520975469,-0.533142026577,7.81171807439,-2.55742338006,16.1245410676,17.1612923183,10.1897311659,13.9523783747,-13.9934572881,-3.75520744356,8.67790074018,-1.452760415,-6.74332244294,5.10449874394,2.38567793454,-0.159481110196,-0.570421407823,-1.19497831038,-3.31503084773,6.00959135292,3.36652494911,3.2182879015,2.86825519862,-2.18277607482,1.02407846126,-0.232801316899,-1.86770617063,-3.07362918826,-1.24442873424,-2.02317318028,-2.0310324356,1.63395396831,0.194622376064,0.428388566321,-0.800648586852,-1.2093838206,0.610119619556,-0.09851558272,1.15182300343,0.418331257455,-0.148542884796,0.496184950172,-0.407589347945,-0.811592265129,-0.77838864316,-0.406625346704,-0.686233859635,-1.18583992675,0.393079095914,0.303786624233,0.308161424217,0.375112712392,0.00579052569862,-0.208155525297,-0.256317624506,0.0820353572256,-0.43192914232,0.384673666891,0.0548928771737,0.111533244447,0.171682763656,-0.300812105662,0.142259895263,-0.210082877215,-0.155336162459,-0.194785572678,-0.463910662263,0.160382772634,-0.0278639848944,-0.130708264773,0.108792421689],[-30488.2411348,990.446982626,-2.71311172256,-366.645823399,-550.918182338,821.579042469,947.277007591,178.474832415,-77.3858011099,303.933013043,148.814565399,-525.3295037,-539.120846085,723.274045763,-53.3885694418,-421.351523642,164.79041417,-254.862544053,-243.019570191,260.490147912,117.241953571,194.270245126,-358.102823168,146.991392395,-172.98490818,4.66262330114,-70.495662225,10.9695340469,113.840982236,95.6772180942,120.050886066,-164.930285215,103.603172725,-90.6746097004,-14.3672192464,-35.9090140183,-13.0564825571,13.5071979138,17.5007286656,15.4988959433,15.6876219261,56.5407239272,-18.8199296119,28.8105470549,-30.8640681038,-10.9274711291,35.3167766361,6.595518804,2.00882050932,-6.65261765235,-0.953636109092,7.89785433322,-2.75300149001,15.8776055144,17.5589729817,9.9214524292,13.9415978438,-14.1641811459,-3.85251644109,8.94486968624,-1.57210936056,-6.81921999028,5.17138354918,2.4749986138,-0.233522347634,-0.73192740436,-1.20450487686,-3.43917090934,6.00048665592,3.47154519868,3.07403804145,2.94685774334,-2.31575207444,0.978393450868,-0.226379378688,-1.91769601366,-3.08168063579,-1.2603412187,-2.06041500313,-2.03607447545,1.67170744824,0.192067856723,0.417084266393,-0.824613318001,-1.25386907648,0.612354439123,-0.0991203902609,1.11150674337,0.443814211793,-0.19350965404,0.48446297816,-0.416066228047,-0.83582306875,-0.756685570887,-0.423090056095,-0.688605951641,-1.18473696844,0.399276974784,0.302288175962,0.314354979244,0.383817794992,0.0137232437164,-0.212987399105,-0.26440821575,0.084213260004,-0.441859180051,0.382230447866,0.0624083319595,0.0979771935847,0.171745913878,-0.308601440327,0.136841974126,-0.202344045883,-0.162231649585,-0.192073023326,-0.463819723433,0.162996731521,-0.028817258425,-0.131407577585,0.110312243689],[-30531.8663657,1011.74613509,-18.6107143117,-373.484173457,-556.167640217,829.423578916,947.211142001,170.289211503,-78.9953170609,310.23669273,148.910874202,-534.979011097,-533.314140058,731.900457296,-53.1689937644,-426.962493985,162.607893984,-252.100639081,-244.970276098,264.747340995,113.993346454,190.299996636,-366.501382968,143.540165518,-174.494172686,4.16720137011,-72.0366369797,13.2416344431,117.932237088,93.3539025381,120.851947656,-167.175805878,102.51800461,-93.2471297777,-13.2279743678,-36.0813413633,-13.7845746474,12.7005030306,17.7311675149,16.3558095016,14.3515827542,57.300129389,-19.892803833,28.1445124267,-31.4786999995,-11.002094641,36.0721646285,6.43850885997,2.11119219635,-7.13302490974,-1.37643204192,7.9897361594,-2.91839500405,15.601828884,17.9525823006,9.64229861467,13.9160583623,-14.3054377589,-3.94444781596,9.20854444229,-1.6766300147,-6.89935417777,5.22467841881,2.55874889438,-0.307824080804,-0.895343496831,-1.20877912926,-3.55433637051,5.9845032487,3.58109911028,2.92364389907,3.02137384469,-2.44105331337,0.93221523474,-0.218383356757,-1.96204543179,-3.08967128351,-1.27744311766,-2.09875745045,-2.0395842096,1.70717851293,0.187443774281,0.405121126679,-0.847567833773,-1.29693279293,0.613404766488,-0.0974816158899,1.06917929658,0.468427626401,-0.237174886148,0.471640031457,-0.423119186431,-0.859453308273,-0.734875178148,-0.439046823624,-0.691476647108,-1.18223758724,0.404891155082,0.300302733661,0.320145783156,0.39160043696,0.0213578151408,-0.217833449324,-0.272850030707,0.0863634574276,-0.450796632925,0.379309290162,0.0700686902476,0.0843454293874,0.171449721432,-0.315872391716,0.131202198512,-0.194438247625,-0.168726665731,-0.189358811545,-0.462926688712,0.165328041812,-0.0296847793303,-0.13209910085,0.111643744695],[-30573.7995219,1035.14167542,-34.1801117727,-380.560063927,-560.035727126,836.146547419,946.177210136,161.709334702,-81.4122976055,317.06543739,149.133190816,-544.790957975,-527.54170468,739.467808864,-52.3497945051,-432.596288318,160.669870397,-248.863649959,-247.147407889,268.583584391,110.354762381,186.100819376,-374.467476274,140.100646007,-175.857883482,3.92359397423,-73.4526518207,15.4214536983,122.017908812,90.925857815,121.546586241,-169.177553491,101.378237373,-95.862525622,-12.0060361544,-36.2288773787,-14.4331494763,11.8994791095,17.9638572133,17.2657095125,12.9666920363,58.012052721,-20.9200547333,27.4476220939,-32.0653422153,-11.0297219737,36.7880990795,6.31263530211,2.2056630768,-7.59158565805,-1.79848364851,8.08986211304,-3.04971499657,15.2961996467,18.3387564774,9.35666358137,13.8724245696,-14.4136396607,-4.03325086379,9.4703793502,-1.76602021257,-6.98298893861,5.26283385642,2.6361014317,-0.382414648596,-1.06023242361,-1.20695959885,-3.65980787397,5.96116560833,3.69460263268,2.76801080585,3.09086769173,-2.55656776103,0.884906868223,-0.207934571211,-2.00084047496,-3.09726320111,-1.29548000696,-2.13807922741,-2.04136785345,1.74011447579,0.180729341,0.392239929747,-0.869318620691,-1.33836287735,0.613161660051,-0.093262016966,1.02481743486,0.492046761002,-0.27920041342,0.457535356658,-0.428536356806,-0.882486243531,-0.712811899168,-0.454174405415,-0.694769115938,-1.17825238555,0.410021718244,0.297812330708,0.325538577599,0.398351115088,0.0285852929487,-0.222711473616,-0.281604426815,0.0884472464048,-0.458613362492,0.375740138314,0.0778505345987,0.0706838710846,0.170738451607,-0.322504237349,0.125314697968,-0.186299397693,-0.174711516189,-0.186606056546,-0.461142277767,0.167424593958,-0.0304207455845,-0.13276427866,0.112791572828],[-30612.9699413,1061.29069051,-50.0309340572,-387.938254769,-561.90411526,841.256701531,943.666075509,152.837601229,-84.7236986902,324.409596216,149.432729988,-555.038870225,-521.817752057,745.690573506,-50.9700089188,-438.216575695,158.965399291,-245.148504799,-249.634879969,271.956823028,106.273346644,181.68472858,-381.94437391,136.691912324,-177.051660927,3.91656161747,-74.705313325,17.4791199393,126.07203256,88.3820309129,122.112367887,-170.899320747,100.174545073,-98.5062473488,-10.715896343,-36.3480539135,-14.9986380803,11.1142545605,18.2026725322,18.2252161876,11.5353987319,58.6672000658,-21.8826024776,26.7149455945,-32.6185103962,-11.0145229059,37.4636429481,6.21990603705,2.2921512494,-8.02547455151,-2.21690124331,8.2000824897,-3.14348035916,14.9606155246,18.7137626916,9.06866191624,13.8073787867,-14.4862348891,-4.12021791058,9.73108947375,-1.8396749162,-7.06958920616,5.28466084724,2.70613682602,-0.457146266662,-1.22609129961,-1.19832164063,-3.75455470296,5.9301207678,3.81140461956,2.60815095564,3.15428159721,-2.66040202614,0.835990688113,-0.194260627433,-2.03408833362,-3.10424035896,-1.31425172423,-2.17828531903,-2.04119790585,1.77019542777,0.17187441858,0.378215407359,-0.889658522734,-1.37789722618,0.611567117008,-0.0861532451558,0.978479078067,0.51452194582,-0.319200232517,0.441986247613,-0.432115034317,-0.904864756571,-0.690430909293,-0.468195772995,-0.698444358912,-1.17271847052,0.414736540466,0.294827631637,0.330527538027,0.403958763751,0.0353063691842,-0.227624045193,-0.290619248713,0.0904310067033,-0.465167259656,0.371387795338,0.0857234690037,0.0570590664021,0.169551048677,-0.328368167437,0.119165560263,-0.177872695373,-0.180089172849,-0.183796847094,-0.458410574335,0.169324224243,-0.0309878493838,-0.133390447578,0.113758033894],[-30650.5532667,1089.0917425,-65.7155659531,-395.58200446,-562.435260644,845.260526743,940.048016936,143.928776739,-88.7089577374,332.041209368,149.746425938,-565.576541623,-516.225191435,750.672563864,-49.3509180922,-443.661211221,157.463032752,-240.981357472,-252.433235815,274.829958051,101.86709406,177.006891675,-388.875376064,133.336983163,-178.018866447,4.12986569461,-75.7710411773,19.3900736742,130.04152843,85.7485256454,122.495122186,-172.32881397,98.9000701438,-101.155505451,-9.33980063861,-36.4359361165,-15.4659757182,10.3475252182,18.4464556742,19.2203460298,10.0748293367,59.2444211649,-22.7666639818,25.9477868479,-33.1357960601,-10.9463982454,38.097403393,6.16541547548,2.36809146363,-8.42749950542,-2.62942110489,8.31965452661,-3.19784125215,14.5986112448,19.0723920295,8.78129111761,13.71767406,-14.5248134982,-4.20281340405,9.98843276424,-1.89577759522,-7.15942391442,5.29041230316,2.76756745701,-0.531166657709,-1.39215474584,-1.18260790469,-3.83630070265,5.8915059838,3.93058554411,2.44550399178,3.21007036872,-2.75153727455,0.785626157021,-0.1770142719,-2.06148076026,-3.11087433018,-1.33377515425,-2.21938582976,-2.03871199934,1.79683256993,0.160711466486,0.362958088066,-0.908325813681,-1.41507369197,0.608766889723,-0.0759625293562,0.93054673828,0.535603793087,-0.356596997563,0.424902187193,-0.433689159862,-0.9262902183,-0.667990348356,-0.481010759514,-0.702614700323,-1.16567896839,0.418974676988,0.291473825599,0.3350645751,0.408306147653,0.0414602921592,-0.232512839478,-0.299788289864,0.0923014495286,-0.47026033275,0.366256498185,0.0936291831748,0.0436200770518,0.167805172845,-0.33330302297,0.112788706041,-0.169148476095,-0.184813273993,-0.180989150189,-0.454809118433,0.171024552273,-0.0313827598136,-0.133988514052,0.114536064449],[-30688.2867175,1117.00376233,-80.5220809575,-403.42919611,-562.61181526,848.913941539,935.913167057,135.275718491,-93.0706325382,339.677739753,150.007642752,-576.152832918,-510.864106343,754.614927484,-47.8843640699,-448.736596513,156.126196919,-236.395668284,-255.52217617,277.167129653,97.2967118315,172.008264133,-395.20379027,130.059862278,-178.694796728,4.54701782307,-76.6299583393,21.1310835069,133.866537756,83.0607350321,122.632744612,-173.459717893,97.5485721107,-103.785450516,-7.85193323842,-36.4897474621,-15.8172237043,9.60012877375,18.6927907,20.2344646147,8.60577973029,59.7196016594,-23.5597803501,25.1490083689,-33.6155596928,-10.8116815574,38.6878736235,6.15502965408,2.43029763164,-8.78937675033,-3.03393600282,8.44718719646,-3.21135565305,14.2146307857,19.4090665548,8.49726941162,13.6000811177,-14.5320010463,-4.27754482232,10.2394278948,-1.93220884618,-7.25296299758,5.28070161774,2.81901364923,-0.603447421205,-1.55759175983,-1.15967786486,-3.90245835873,5.84558106894,4.05115878442,2.28161642001,3.25656693754,-2.82917331139,0.734132019009,-0.155954536365,-2.08263064788,-3.11755858854,-1.35412144357,-2.26141714394,-2.03351404985,1.81936988088,0.147043593623,0.346412449612,-0.925045124764,-1.44938011628,0.604957669354,-0.0625259927715,0.881484075626,0.555017985535,-0.390765527043,0.406210705523,-0.433101835777,-0.946403621842,-0.64582909731,-0.492563413525,-0.707430295343,-1.15720351015,0.422642977813,0.287904732904,0.33909103328,0.411274489081,0.0469959492529,-0.237304307445,-0.308991830933,0.0940503689455,-0.473680619461,0.360385342288,0.101502388255,0.0305365932419,0.165413163296,-0.337139557632,0.106230014166,-0.160128359324,-0.1888501245,-0.178259902385,-0.450448814147,0.172513143483,-0.0316106401811,-0.134575276999,0.115116258737],[-30727.9075129,1143.48568094,-93.7385525676,-411.417712827,-563.416431092,852.972864398,931.851658512,127.171283747,-97.5112808841,347.036650276,150.149744517,-586.516604859,-505.834580315,757.71881191,-46.9621888966,-453.249133188,154.918317931,-231.424897546,-258.881401779,278.932478031,92.7229071578,166.629801429,-400.872924058,126.884553421,-179.014748461,5.15152962032,-77.2621877726,22.6789180411,137.487201874,80.3540520926,122.463130638,-174.28571725,96.1138104997,-106.371233131,-6.22647833958,-36.5067114241,-16.0344433529,8.87290291811,18.93926167,21.2509375181,7.14904579226,60.0686271902,-24.2494926862,24.3214726723,-34.0561617803,-10.596706407,39.2335468485,6.19461460956,2.47558366559,-9.10282251679,-3.42833870669,8.58128947191,-3.18258153938,13.813118126,19.7182083308,8.21931502445,13.4513706877,-14.5104230916,-4.3409196435,10.4810935387,-1.94684926561,-7.35067638981,5.25614218452,2.85909572723,-0.67296015662,-1.72157133912,-1.12939099499,-3.95044015685,5.79260583582,4.17213771858,2.11803474603,3.29210423493,-2.8925099418,0.681827018141,-0.130840452582,-2.09715088944,-3.12468660784,-1.37536173875,-2.30441564585,-2.02520797335,1.83715133921,0.130673908897,0.328522969742,-0.939541087216,-1.4803043407,0.600336147062,-0.0456797586062,0.831754750236,0.572490205898,-0.421080639443,0.385839332729,-0.430196164395,-0.964845960318,-0.62428603711,-0.502797783581,-0.713041299143,-1.14736172678,0.42564829294,0.284274173861,0.342548257032,0.412745010322,0.0518622278443,-0.241924900069,-0.318110152589,0.0956695590189,-0.475216157479,0.35381342308,0.109277795385,0.0179783051809,0.162287359217,-0.339708525105,0.0995353634994,-0.150813964525,-0.192166029248,-0.175686040238,-0.445440565564,0.17377756331,-0.031676653794,-0.135167535339,0.115489211],[-30771.1528722,1166.99642925,-104.65305428,-419.485437718,-565.831760121,858.193213801,928.453623941,119.90832977,-101.733460566,353.835403842,150.106095321,-596.416718194,-501.236696881,760.185364685,-46.9762346169,-457.005222864,153.802821925,-226.102505565,-262.490613385,280.090143378,88.3063872396,160.812459037,-405.826084961,123.835060348,-178.914018336,5.92691270379,-77.6478524389,24.0103458804,140.843662119,77.6638698468,121.924175739,-174.800496772,94.5895448365,-108.888003883,-4.43762013926,-36.4840514768,-16.0996959784,8.16668534229,19.1834526448,22.2531303156,5.72542340221,60.2673833986,-24.8233420942,23.468042273,-34.4559628085,-10.2878063592,39.732916277,6.29003637859,2.50076347763,-9.35955303537,-3.81052198608,8.72057032564,-3.11007688865,13.3985172441,19.9942394208,7.95014618226,13.2683134979,-14.4627051922,-4.38944534573,10.710448369,-1.93757945005,-7.45303402527,5.21734739704,2.88643401555,-0.738676463423,-1.88326248126,-1.09160676892,-3.9776585827,5.73284009704,4.29253572469,1.95630547557,3.31501519219,-2.94074697092,0.629029898478,-0.101431052304,-2.10465437796,-3.13265186186,-1.39756718632,-2.34841771984,-2.01339768578,1.84952092351,0.111405521212,0.309234126202,-0.951538332268,-1.5073342068,0.595099014004,-0.0252599500645,0.78182242224,0.587746136907,-0.446917153249,0.363715598938,-0.424815248051,-0.981258226851,-0.603700048709,-0.511657918235,-0.719597866897,-1.13622324928,0.427897472373,0.280735968776,0.345377590819,0.412598933664,0.0560080153125,-0.246301068324,-0.327023535498,0.0971508138138,-0.474654984491,0.346579835996,0.11689011571,0.00611490307697,0.158340099793,-0.340840679073,0.0927506329052,-0.141206911163,-0.194727293117,-0.173344500304,-0.439895276771,0.174805377191,-0.0315859639595,-0.135782087989,0.115645515481],[-30818.9085507,1186.38132783,-112.792950403,-427.532417264,-570.504773904,865.071428071,926.132671019,113.683911224,-105.513623867,359.839930313,149.840561986,-605.673217283,-497.153386121,762.172078434,-48.2121941041,-459.86184885,152.753809518,-220.459975495,-266.326399326,280.612650555,84.1761416714,154.541202695,-410.016401896,120.936212333,-178.344123753,6.85949086262,-77.7708808145,25.1058153888,143.88495876,75.0247240294,120.975797803,-175.001192238,92.9752722653,-111.314996139,-2.46805081584,-36.4200778454,-15.9987221283,7.48351948109,19.4236992299,23.2277219087,4.35431673282,60.2976079461,-25.272368387,22.5926789016,-34.815046671,-9.87380375743,40.1843882436,6.4460447982,2.50307898303,-9.55290458562,-4.17823464031,8.86390892296,-2.99264863971,12.9752021564,20.2326048326,7.69217417346,13.0492561647,-14.3916591849,-4.41992358258,10.9245251666,-1.90282851042,-7.56045727269,5.1648338018,2.89996181835,-0.799768951605,-2.04186526867,-1.0462790838,-3.98191106169,5.6665901675,4.4115678476,1.79793491143,3.32416756142,-2.97334905449,0.576173979847,-0.0677623514734,-2.10478032654,-3.14186099796,-1.42087568865,-2.3933670567,-1.99780107229,1.85597853182,0.0890698399801,0.288502286627,-0.960829449411,-1.53002303551,0.589410763358,-0.00114027578797,0.732131359165,0.600621589974,-0.467765306515,0.339850894716,-0.416866629983,-0.99532084749,-0.584403069758,-0.519153886995,-0.727221193003,-1.12389169937,0.429322668608,0.277406336212,0.347538232049,0.41074380011,0.0593853578585,-0.250376511805,-0.33563001093,0.0984809267463,-0.471830239692,0.338727472301,0.124295030856,-0.00490300251699,0.153519177989,-0.34040927516,0.0859277804802,-0.131332263476,-0.196519980598,-0.171301113752,-0.433926932491,0.175591185766,-0.0313581580338,-0.136431712325,0.115578033621],[-30868.6544489,1202.03125569,-118.642768479,-435.307351433,-576.739722289,873.066024899,924.596307555,108.311872385,-108.923801034,365.010027385,149.439022273,-614.390880935,-493.598964315,763.661826096,-50.5311635462,-461.878321227,151.788079234,-214.520881872,-270.352898317,280.506063073,80.3342896243,147.977039213,-413.43628933,118.216140748,-177.32146496,7.94683657265,-77.6304234331,25.9604939712,146.595727811,72.4677212346,119.66600438,-174.898743603,91.2934404028,-113.647774383,-0.334494472554,-36.3174477604,-15.7319792827,6.83027174453,19.6613432107,24.1746445017,3.04956312925,60.1644465768,-25.6016062129,21.7037411522,-35.1403908915,-9.35347605769,40.5860215844,6.66292490658,2.48148410954,-9.68269364307,-4.52864958765,9.0112651997,-2.83009957673,12.5472670304,20.4328413504,7.44658253545,12.7988488572,-14.3008420199,-4.43033270939,11.1204131434,-1.84321961515,-7.67317323889,5.09873055705,2.89986435825,-0.856214273244,-2.19670412336,-0.99373953001,-3.96253477827,5.59434837126,4.52925579927,1.64426854469,3.32056837807,-2.99084025065,0.524150885116,-0.0309783027926,-2.09727322885,-3.15277335781,-1.44569217127,-2.43883657328,-1.97859189476,1.85664773988,0.063611476633,0.266331378214,-0.967478861179,-1.54818606514,0.583307096379,0.0266552138347,0.683048258127,0.611392891221,-0.483577015565,0.314592052398,-0.406515617046,-1.00687197999,-0.566699264687,-0.525559843189,-0.735916628776,-1.11060666176,0.429957244121,0.274251087738,0.349060789917,0.407192425541,0.0619589369707,-0.254163924598,-0.343898612565,0.0996266886377,-0.466755468303,0.330314406591,0.131532104389,-0.0150011196703,0.14791420189,-0.338457576754,0.0791430812565,-0.121308864797,-0.197609194632,-0.169577290202,-0.42766183999,0.176157730492,-0.0310705195684,-0.137113099544,0.115288695654],[-30917.0190033,1214.72348145,-122.926326863,-442.521103563,-583.505174698,881.376041818,923.375516393,103.510254934,-112.109916807,369.35395971,149.01785668,-622.745671573,-490.570594291,764.593825689,-53.6880899602,-463.164531769,150.933104077,-208.30682208,-274.531136665,279.784829111,76.7512326637,141.324985664,-416.087983113,115.703802486,-175.878662918,9.18933448141,-77.2294363432,26.5732287927,148.96950422,70.0231107719,118.064825435,-174.50754187,89.5722344839,-115.885985875,1.93781680612,-36.1799052036,-15.3036041551,6.21501428639,19.8984779177,25.0971436248,1.82360822975,59.8788970554,-25.8195889295,20.8106868348,-35.4406964016,-8.72808949417,40.9357882614,6.93984554226,2.43536078802,-9.75035673226,-4.8587957761,9.16286928434,-2.62248144521,12.1187360714,20.5955087024,7.2142478679,12.5233176333,-14.1939969257,-4.41894525699,11.2952156189,-1.75992444709,-7.79136046527,5.01906997399,2.88663983749,-0.908190090941,-2.34713455223,-0.934414121216,-3.91925185664,5.51665353467,4.64582295845,1.49661166351,3.30575949845,-2.99400946816,0.473966812918,0.00750015684582,-2.08190389867,-3.16586145664,-1.47248831553,-2.48430649294,-1.95605788429,1.85180804287,0.035003343109,0.242737218049,-0.971618948365,-1.56170401337,0.57679151634,0.0580648829778,0.634920423637,0.620446495449,-0.494419616291,0.28836976476,-0.393991956993,-1.01578921503,-0.550885854625,-0.531215961099,-0.745660564756,-1.09664171189,0.429859863885,0.271198433179,0.349993726563,0.401983944556,0.0636965929596,-0.257693249408,-0.351816124688,0.100549889661,-0.459489317049,0.321402509294,0.138661870362,-0.0241242361079,0.141650233357,-0.335071349181,0.0724788894997,-0.111279003233,-0.198079797772,-0.168183333888,-0.421229387172,0.176534788029,-0.0308147561634,-0.137818919299,0.114781699009],[-30960.6306502,1225.23527375,-126.36744391,-448.884536996,-589.769700555,889.200516363,922.001280377,98.9971005507,-115.217895925,372.879991939,148.693445704,-630.913551618,-488.065438877,764.907295231,-57.4379203627,-463.830372249,150.216357048,-201.839393498,-278.82214068,278.463396845,73.3973723548,134.790059123,-417.973719096,113.428154443,-174.048338586,10.5873692364,-76.5708755933,26.9428670186,150.999822936,67.7211419507,116.242290933,-173.841978037,87.8398397437,-118.029277878,4.32365093573,-36.0111941567,-14.717733459,5.6458192605,20.1371966815,25.998464808,0.688897672544,59.4519571464,-25.9348498942,19.9229737592,-35.7246641326,-7.99891030108,41.2316602363,7.27597554377,2.36409094935,-9.7573303777,-5.16570215367,9.31895130536,-2.36984599067,11.6936334848,20.7211666171,6.99604677047,12.2288885503,-14.0748671311,-4.38403375617,11.4460359127,-1.65411468904,-7.91519749319,4.92588436383,2.86078645828,-0.955874067296,-2.49251206219,-0.868728871101,-3.85178442097,5.43404448409,4.76149270386,1.35626955606,3.28128277884,-2.98364561575,0.426627961884,0.0462520905496,-2.05844314979,-3.1815978097,-1.50173580275,-2.52925703902,-1.93048677196,1.84173893597,0.00321835134614,0.217735623219,-0.973382091763,-1.57045759787,0.569867526516,0.0930270958156,0.588095160208,0.628168857458,-0.500360444584,0.261614724578,-0.379525397583,-1.02195014329,-0.537260060699,-0.536462415007,-0.756429391486,-1.0822704252,0.429089192871,0.268176582356,0.350385504127,0.395157491752,0.0645661661354,-0.260994428944,-0.35936933158,0.101212319988,-0.450090432659,0.312053650838,0.145744862825,-0.0322171395547,0.134852334255,-0.33033635777,0.0660175594756,-0.101384966891,-0.198016652572,-0.167129549044,-0.414758961941,0.176752135038,-0.030682575419,-0.138541841242,0.11406124112],[-30996.1178264,1234.34390122,-129.689937974,-454.10851507,-594.501869282,895.738486067,920.00458235,94.4904509147,-118.393663126,375.596388727,148.582169841,-639.070483492,-486.080660902,764.541452741,-61.5356017705,-463.985734441,149.66531115,-195.140193509,-283.186936668,276.556214452,70.2431102629,128.577276663,-419.095733131,111.418153512,-171.863112924,12.1413254853,-75.6576972317,27.0682558139,152.680218907,65.5920640802,114.26843084,-172.916443108,86.1244414171,-120.077297655,6.79777583181,-35.8150586015,-13.9785039077,5.13075882065,20.3795928326,26.8818535814,-0.342122904102,58.8946246146,-25.9559224643,19.0500597355,-36.000995016,-7.16720471263,41.471609471,7.67048374963,2.26705652437,-9.70505110395,-5.44639766837,9.47974139124,-2.07224495859,11.275983476,20.8103748229,6.79285584281,11.921787666,-13.9471958646,-4.32387073774,11.5699773443,-1.52696202383,-8.04486286403,4.81920603776,2.82280242288,-0.999443864909,-2.63219216014,-0.797109793343,-3.75985459546,5.34706004586,4.87648841426,1.22454751048,3.24868007553,-2.96053760218,0.383140530647,0.0838565614264,-2.026661796,-3.20045493221,-1.53390631429,-2.57316843487,-1.90216628885,1.82671991435,-0.0317705867176,0.191342410811,-0.972900672165,-1.57432753632,0.562538630179,0.131480216522,0.542919772351,0.634946432047,-0.501466836335,0.234757624626,-0.363345686572,-1.02523235545,-0.526119104036,-0.541639379196,-0.768199499507,-1.06776637712,0.42770389605,0.265113745093,0.350284584749,0.386752201727,0.0645354968085,-0.264097405911,-0.366545017527,0.101575769792,-0.438617461859,0.302329701652,0.152841615829,-0.0392246177355,0.127645566445,-0.324338367848,0.0598414454499,-0.0917690438764,-0.197504621585,-0.166426239903,-0.4083799522,0.176839548179,-0.0307656849352,-0.139274535027,0.113131519416],[-31021.2154132,1242.60474001,-133.36049766,-458.041447743,-596.908222601,900.397016343,917.002670592,89.7764071197,-121.794495664,377.500912519,148.791509487,-647.338621289,-484.575786728,763.431522842,-65.7897149604,-463.75453826,149.288428607,-188.227989314,-287.58483524,274.079648968,67.2609956582,122.861836501,-419.461489195,109.686500956,-169.357459029,13.8489259516,-74.4953911715,26.9541343311,154.010670614,63.6615755618,112.208678108,-171.746418315,84.4473860662,-122.02985343,9.33952004095,-35.5952933976,-13.0915922244,4.6770833717,20.6272278685,27.750137514,-1.2590817968,58.2176588991,-25.8915855179,18.1996218253,-36.2771929696,-6.23422815958,41.6544726296,8.12115155416,2.14419986734,-9.59526383692,-5.69824224258,9.64527568721,-1.73008021288,10.8691917066,20.8636536421,6.60533926988,11.6072628339,-13.8141446755,-4.23702297608,11.6645631162,-1.37975646411,-8.18029970817,4.69927430659,2.77324493269,-1.03903726553,-2.76565724331,-0.720051533111,-3.64350415638,5.25628612462,4.99091368071,1.1024746177,3.20937170466,-2.92548638544,0.344388114959,0.118957962985,-1.98636497325,-3.22282196954,-1.56937040288,-2.61562849796,-1.87134433141,1.80705722514,-0.0699318492095,0.163608128124,-0.970327738394,-1.57322586754,0.554789795071,0.173320589134,0.499660401018,0.641110930201,-0.497846306753,0.208167978173,-0.345718847257,-1.0255240236,-0.517717474271,-0.547039705131,-0.780948188449,-1.0533551672,0.425753384097,0.26193727527,0.349730269586,0.376823529732,0.0635853629297,-0.267033225791,-0.373330646634,0.101611720265,-0.425147718872,0.292284366797,0.16000499696,-0.0451127697806,0.120141565878,-0.317175893915,0.0540314628827,-0.0825575523297,-0.196617540703,-0.16608453362,-0.402202298281,0.176814328194,-0.0311509344606,-0.1400087504,0.111997031238],[-31038.0840723,1249.68559643,-136.817292581,-461.081931447,-597.147191439,903.415284133,912.95785512,84.913307914,-125.623080854,378.549316946,149.393344635,-655.624885795,-483.35979686,761.496756583,-70.2233757495,-463.316816196,149.018128529,-181.110227384,-291.968284215,271.05774286,64.4321686301,117.699661419,-419.099363772,108.180875513,-166.573258536,15.6972456637,-73.0995827849,26.6288096716,155.01693067,61.9371711639,110.110077647,-170.35174583,82.8026655617,-123.887397281,11.946454634,-35.3558969173,-12.0688351713,4.28875632276,20.8795359559,28.6044723306,-2.05990304155,57.4308661373,-25.751600016,17.3722140974,-36.5559738574,-5.20119285903,41.7825451855,8.62021057484,1.99770502601,-9.43094710813,-5.91991969628,9.81481440565,-1.34515409095,10.4741896641,20.8813657734,6.43331157785,11.2866490911,-13.6765483954,-4.12323421982,11.7289959623,-1.21426134172,-8.32050951196,4.56715647954,2.71290718592,-1.07463252747,-2.89289727028,-0.63832326154,-3.50405348824,5.16249693815,5.10439294369,0.989975179606,3.16429182188,-2.87934112052,0.310763899058,0.150462010338,-1.93749510613,-3.24875458744,-1.60809410686,-2.65665542221,-1.83810945749,1.7831641232,-0.110998974518,0.13472224331,-0.965899011389,-1.56718991501,0.546531846809,0.218276477134,0.458258532917,0.646775087632,-0.489767088312,0.181970580454,-0.327056005098,-1.02275564546,-0.512138735073,-0.552766953013,-0.794656394296,-1.03907049136,0.423250050491,0.258571102998,0.348725215863,0.365492213621,0.0617482930113,-0.269837345171,-0.3797164023,0.101330416679,-0.409833187906,0.281938689881,0.167257207931,-0.0499329404416,0.112398264852,-0.308998447164,0.0486627720103,-0.073812930523,-0.195385139177,-0.166118849031,-0.396258150238,0.176643872146,-0.0319057423368,-0.140732557481,0.110663473555],[-31049.9909106,1255.03238431,-139.241362603,-463.766109233,-595.615179023,905.240494258,907.918711389,80.0275514595,-130.093458524,378.686853432,150.450655174,-663.78238947,-482.204035335,758.652411618,-74.9133337146,-462.866628883,148.767819248,-173.791524012,-296.288015715,267.516457455,61.739916973,113.116855343,-418.042961471,106.83270029,-163.554245219,17.6706977262,-71.4884313087,26.1264809241,155.73119522,60.4217947469,108.015077355,-168.753358055,81.1774331015,-125.650542249,14.6207113128,-35.1009184106,-10.9236095205,3.968919334,21.1354194284,29.4455957946,-2.74458460921,56.5438141408,-25.5459724402,16.5666098724,-36.8388565297,-4.06930022464,41.8589873145,9.15850498496,1.83031647151,-9.21538785047,-6.11044482378,9.98742377567,-0.919619048602,10.0912902925,20.8638345094,6.27637487818,10.9603032707,-13.5346601767,-3.98254246114,11.7628984992,-1.03235831835,-8.46425835076,4.42412686544,2.64264137996,-1.10616802821,-3.01402908995,-0.552762781258,-3.34314262764,5.0665137825,5.21643085603,0.88669730086,3.11425304265,-2.82296301166,0.282538464301,0.177339748999,-1.88002894142,-3.27822508179,-1.64994233599,-2.69637499565,-1.80251039029,1.75548061534,-0.154646791099,0.104908954733,-0.959870880119,-1.55628832335,0.537657075476,0.266034123869,0.418574491194,0.651996896233,-0.477537592802,0.156229047195,-0.307804561099,-1.01686830019,-0.509423718615,-0.558877360226,-0.80930596212,-1.02489806961,0.420197034411,0.254938302447,0.347262919822,0.352895311903,0.059069753206,-0.272546323414,-0.385693147746,0.100751795328,-0.392844520666,0.271305549145,0.17461278399,-0.0537577858754,0.104460169753,-0.29996828796,0.0438090942636,-0.0655816467618,-0.193826119593,-0.166544427893,-0.390560210549,0.176283101183,-0.0330926690538,-0.141433106483,0.109136843248],[-31060.2030346,1258.09101749,-139.813747588,-466.630124151,-592.708588581,906.319851539,901.933814851,75.2455359183,-135.419668504,377.858773399,152.026420995,-671.664244774,-480.879846193,754.813745604,-79.9363384328,-462.598036953,148.450909097,-166.276495489,-300.494761862,263.48175408,59.1675284811,109.139522199,-416.325886901,105.573398393,-160.34415285,19.7536952435,-69.6800959798,25.4813471774,156.185660411,59.1183901715,105.966125129,-166.972187395,79.5588418834,-127.319901377,17.3644217793,-34.8344071275,-9.66929204393,3.72071406559,21.3937806197,30.2742456697,-3.31312447065,55.5660707215,-25.284709272,15.7815824706,-37.1273598369,-2.83975167007,41.8869591926,9.7268789578,1.64477867499,-8.95187299685,-6.26883241945,10.1621700264,-0.455627541646,9.72080653536,20.8113831428,6.13413128231,10.6285822059,-13.3887331717,-3.81498569225,11.7658933437,-0.835929055646,-8.61031229994,4.27145977312,2.56329971218,-1.13358214521,-3.12916955123,-0.464207894891,-3.16241161116,4.96915795374,5.32653207054,0.792289086111,3.06006798247,-2.7572132631,0.259982392046,0.198562224481,-1.81394322586,-3.31120574849,-1.69478000001,-2.73491300634,-1.76459585304,1.72444670835,-0.200550127404,0.0743924607576,-0.952499733553,-1.54058973716,0.528057771154,0.316279772683,0.380468598999,0.656834347901,-0.461466232014,0.131006994122,-0.288411916262,-1.0078030669,-0.509613257075,-0.565427164154,-0.824878736995,-1.010823622,0.416597475038,0.250961947786,0.345336877705,0.339169883083,0.0555952096665,-0.27519671988,-0.391251746193,0.0998957925016,-0.374352368855,0.260397822829,0.182086260383,-0.056659962239,0.0963717869657,-0.290247676669,0.0395441510732,-0.0579101693517,-0.191959184542,-0.167376511961,-0.385121181698,0.175686936448,-0.0347742751016,-0.14209754762,0.107423137194],[-31071.9875512,1258.30740981,-137.715487402,-470.21011925,-588.823823339,907.100560797,895.051740961,70.6936594522,-141.815750621,376.010328273,154.183621989,-679.123564166,-479.15857347,749.896016193,-85.369139481,-462.705101038,147.980806407,-158.569758106,-304.539254776,258.979594061,56.6982909489,105.79376591,-413.981744671,104.334392928,-156.986715201,21.9306513201,-67.692736035,24.7276075202,156.412522387,58.0299012978,104.005668868,-165.029166254,77.9340451053,-128.896087703,20.1797177354,-34.5604123183,-8.31925951356,3.54728217769,21.6535218636,31.0911597196,-3.76552059672,54.5072036912,-24.977816993,15.0159052127,-37.4230026292,-1.51374860898,41.8696209954,10.3161766667,1.44383610758,-8.64368948018,-6.39409727761,10.338119387,0.0446679741149,9.36305133669,20.7243349662,6.00618290171,10.2918427297,-13.2390205325,-3.62060190535,11.7376031127,-0.626855215291,-8.75743743484,4.11042951139,2.47573438,-1.15681325594,-3.23843550303,-0.373496405065,-2.9635004754,4.87125074792,5.43420124005,0.706398640012,3.00254925683,-2.68295307906,0.243366263652,0.213100482299,-1.73921470623,-3.3476688834,-1.74247200868,-2.7723952423,-1.72441456894,1.69050240905,-0.24838381189,0.0433969597478,-0.944041960659,-1.52016280108,0.517626223929,0.368699666923,0.343801179477,0.66134543453,-0.441861417738,0.106368036961,-0.269325471588,-0.995501024755,-0.512748182626,-0.572472602182,-0.841356563991,-0.996832868524,0.412454511553,0.246565113182,0.342940585755,0.32445298567,0.0513701285455,-0.277825093932,-0.396383060864,0.0987823444933,-0.354527384179,0.249228389175,0.189692172358,-0.0587121256895,0.0881776228755,-0.279998873657,0.0359416638699,-0.0508449665981,-0.18980303661,-0.168630342993,-0.379953766164,0.174810299088,-0.0370131209702,-0.142713031104,0.105528352272],[-31087.9579185,1255.2813054,-132.372381271,-474.883646088,-584.326032186,907.962871144,887.379877494,66.4139962777,-149.400274429,373.140187287,156.949235111,-686.041047676,-476.893221592,743.864606808,-91.2613259548,-463.334934861,147.284985777,-150.682073348,-308.370256355,254.01996813,54.3415375278,103.106569312,-411.038763154,103.058417376,-153.517230797,24.1870877722,-65.5480778443,23.898947749,156.438100656,57.1632922994,102.172813138,-162.9401213,76.2983305928,-130.378387884,23.0685906213,-34.2823566365,-6.88631329834,3.44878229892,21.9133457052,31.8964201302,-4.10034280034,53.3781406826,-24.6331780476,14.2704494347,-37.7266363968,-0.0938715767346,41.8091084735,10.9184582811,1.23028061409,-8.29423588992,-6.48566214139,10.5140640651,0.579158187689,9.01838858369,20.6036640881,5.8923823382,9.95086846178,-13.0857637862,-3.39945305048,11.67790354,-0.406735099184,-8.9042066921,3.94240633633,2.38082419228,-1.17587369443,-3.34192924481,-0.281499822721,-2.74805879382,4.77351183464,5.53897167366,0.628804405963,2.9425741383,-2.60094624261,0.232980445754,0.220171971298,-1.65580547671,-3.38754443576,-1.79273323708,-2.80895357115,-1.68200447097,1.65405573952,-0.297820114208,0.0121494765617,-0.934750726998,-1.49513040941,0.506265111547,0.422961437522,0.308489981668,0.665604342087,-0.41900060222,0.0824291025305,-0.250930546291,-0.979877572623,-0.518833933906,-0.580006318066,-0.858712675533,-0.98291451141,0.407754087947,0.241686056888,0.34007047655,0.308881566582,0.0464412493078,-0.280456893196,-0.401079151874,0.0974261426673,-0.333542412036,0.237823221262,0.197443711267,-0.0599783102482,0.0799374050841,-0.269369271923,0.0330831634894,-0.0444303926803,-0.187361977622,-0.170321515695,-0.375067754854,0.173610125019,-0.0398543511889,-0.143269886286,0.103458235538],[-31108.1130006,1249.22776969,-124.189265863,-480.393890244,-579.455346647,909.01920886,879.260861518,62.1113248291,-157.90992838,369.460690909,160.206225576,-692.407745616,-474.263436522,736.88540394,-97.5538450237,-464.4468645,146.347186875,-142.648783482,-311.928647594,248.548984639,52.2107827979,101.108430881,-407.503665776,101.733446703,-149.937257179,26.5129612623,-63.2821163098,23.0270004919,156.265208181,56.5416086018,100.493289188,-160.700456267,74.6795246825,-131.760783027,26.0324708304,-34.0011563492,-5.38095315501,3.41344093171,22.171155536,32.6874867776,-4.31044826265,52.1952486114,-24.2501787314,13.5544785347,-38.0364431883,1.41178240453,41.7034596755,11.530647956,1.00709353401,-7.90735744179,-6.54458154905,10.6877001829,1.14590636733,8.68738593727,20.4529478803,5.79358415499,9.60815016772,-12.9291579584,-3.15169690916,11.5876828289,-0.176033570165,-9.04842045346,3.76914429291,2.27955440393,-1.19107162096,-3.43969487831,-0.189224492046,-2.51777428738,4.67625437761,5.64049130559,0.55980618236,2.88127852784,-2.51156685196,0.2291944461,0.219979753655,-1.56361902124,-3.43059296824,-1.84467842173,-2.84474417875,-1.63736033123,1.61538678305,-0.348521068808,-0.0191116579666,-0.924866304497,-1.46583245523,0.49391866241,0.478658265772,0.274682458176,0.669750032832,-0.393037399525,0.0595203620118,-0.233364132434,-0.960745388386,-0.527734375402,-0.587766581053,-0.876885853445,-0.969069181615,0.402413367452,0.236323773493,0.336734728008,0.292592126387,0.0408604046663,-0.283073118352,-0.405336866918,0.095820898678,-0.311579072614,0.226260671522,0.205348692876,-0.0604880613948,0.0717717460577,-0.258446795009,0.0310814183884,-0.0387023452732,-0.184582706336,-0.172467036567,-0.370461292381,0.17205140924,-0.0432734464455,-0.143771159068,0.10121753476],[-31131.7980129,1240.51569837,-113.81573721,-486.325445805,-574.42064391,910.315044513,871.096142422,57.4060995952,-166.985930647,365.237597416,163.801555665,-698.242295867,-471.530524613,729.174419847,-104.160483376,-465.953269123,145.165215635,-134.511375967,-315.153339265,242.496781346,50.4455866967,99.8307280047,-403.377799724,100.35876625,-146.239916637,28.8993371643,-60.934413467,22.1428850848,155.890781287,56.1919159435,98.9894849344,-158.300469153,73.1135883389,-133.035927851,29.0726484943,-33.7171011273,-3.81310343723,3.42650154692,22.4246549588,33.4611639605,-4.38726600682,50.9762542144,-23.8260813029,12.8793539266,-38.3499376923,2.99373719097,41.5496882249,12.1508858424,0.777303580527,-7.48701100806,-6.5723179876,10.8564498409,1.74301892612,8.37066200172,20.2764145304,5.71089340568,9.26660539957,-12.7693864493,-2.87751522076,11.4680823,0.0650678686943,-9.18768596194,3.59249337336,2.17293688133,-1.20278915237,-3.53176195584,-0.0977104655394,-2.27434421391,4.57968991406,5.73843672638,0.499834106351,2.81986298349,-2.41509158417,0.232397557716,0.212973294879,-1.46254417119,-3.47653269684,-1.89727226448,-2.87992933053,-1.59046613158,1.57474363819,-0.400146151338,-0.0501452865092,-0.914625741676,-1.43266308131,0.480541492582,0.535364720553,0.242583487494,0.673937663097,-0.364094464172,0.0380252976773,-0.216701140289,-0.937891469669,-0.53927797806,-0.595428066765,-0.895806266903,-0.95530049229,0.396332318112,0.230492441668,0.332944454386,0.275721054064,0.0346807006461,-0.285643658342,-0.409154250587,0.0939550792524,-0.288821179794,0.214632187225,0.213413589057,-0.0602623024732,0.0638164794787,-0.247304499089,0.0300570064283,-0.0336946079256,-0.181397520749,-0.17508426506,-0.366129611779,0.170101161525,-0.0472284714668,-0.144223074488,0.0988107478839],[-31158.358171,1229.51398717,-101.90139134,-492.262906856,-569.430801163,911.895848672,863.287169595,51.9187750646,-176.269499405,360.736665088,167.582187656,-703.563336312,-468.955792215,720.947666788,-110.9950277,-467.766527899,143.736877991,-126.311338264,-317.983242138,235.79349601,49.1855091614,99.3048380678,-398.662512189,98.9336613566,-142.418331465,31.3372808524,-58.544531351,21.2777208637,155.311756298,56.1412800629,97.6837882956,-155.730457956,71.6364825262,-134.196477078,32.1904137449,-33.4304806414,-2.19268849869,3.47320761544,22.6715475766,34.2142559774,-4.32222505605,49.7388842283,-23.3581480205,12.256437024,-38.6646345971,4.64251663876,41.3448077449,12.7773120914,0.543939466816,-7.03715346099,-6.57033394409,11.0177351398,2.36860227712,8.06883538136,20.0782922261,5.64541514385,8.9291517094,-12.6066326591,-2.57708972463,11.3202432736,0.31638771432,-9.31961046056,3.41430356992,2.06198349086,-1.21140840549,-3.61816002968,-0.00799779570138,-2.01946583125,4.48402998123,5.83248452655,0.44931831508,2.75952806331,-2.31179711629,0.242979073627,0.19960206048,-1.35246975794,-3.5250818376,-1.94947946717,-2.91467129192,-1.54130585389,1.5323744035,-0.452354837444,-0.0807102517383,-0.904266087056,-1.39601643041,0.466088218128,0.592655370745,0.212397948118,0.678322389215,-0.33229445068,0.0183273917996,-0.20101648013,-0.911102814097,-0.553293212828,-0.60266545082,-0.915404085082,-0.941612056584,0.389410907972,0.224206240084,0.328710769939,0.258404738592,0.0279552432722,-0.288138402112,-0.412529347471,0.0918171511173,-0.265452547458,0.203029215643,0.221644871684,-0.0593219568277,0.0562074390294,-0.23601544034,0.030130505471,-0.029440964186,-0.177738718856,-0.178190560626,-0.362067946087,0.167726391643,-0.0516774909799,-0.144631857588,0.0962423728541],[-31187.1386905,1216.5915318,-89.0958242854,-497.790867484,-564.694695591,913.807091907,856.235392426,45.2698057261,-185.401852831,356.2236522,171.395083832,-708.389504832,-466.800545677,712.421157021,-117.971264683,-469.799019994,142.059979878,-118.090157831,-320.357266984,228.369266387,48.5701101294,99.5621384571,-393.359150359,97.4574173638,-138.465623953,33.8178577006,-56.1520319972,20.4626271645,154.525069539,56.4167666987,96.5985871888,-152.980720676,70.2841682088,-135.235085428,35.3870567138,-33.1415845623,-0.529632693062,3.53880260813,22.9095369921,34.9435671269,-4.10675443352,48.5008653896,-22.8436411426,11.6970892406,-38.9780485912,6.34864460405,41.085831859,13.4080668542,0.310029906052,-6.56174167288,-6.54009190555,11.1689781803,3.0207628334,7.78252468048,19.8628091549,5.59825442309,8.59870664929,-12.4410799882,-2.25060216015,11.1453070704,0.57774446364,-9.44180119234,3.23642487479,1.94770609891,-1.21731149718,-3.69891865214,0.078873464968,-1.75483639723,4.38948611637,5.9223112966,0.408688945693,2.70147432533,-2.20196012535,0.26132828686,0.180315515966,-1.23328461286,-3.57595860653,-2.00026473166,-2.94913232835,-1.48986348003,1.48852717754,-0.504806602776,-0.110565396326,-0.894024389155,-1.35628664529,0.450513455114,0.650104785228,0.184330718543,0.683059367517,-0.29776001357,0.000810126651458,-0.18638506223,-0.880166419294,-0.569608550653,-0.60915340884,-0.935609477157,-0.928007487649,0.381549105074,0.217479347412,0.324044788922,0.24077956895,0.0207371385697,-0.290527238604,-0.41546020216,0.0893955809995,-0.241656989489,0.191543204046,0.230049012626,-0.0576879478022,0.0490804583923,-0.224652674937,0.031422493378,-0.0259751976033,-0.173538598651,-0.181803282713,-0.358271528342,0.164894109365,-0.0565785697118,-0.145003733405,0.093516907616],[-31217.8332201,1202.2528175,-75.9539114174,-502.657926112,-560.3334092,915.995195672,850.195749589,37.2299057225,-194.065245877,351.910148945,175.075153659,-712.766207352,-465.265050039,703.77859335,-125.030808465,-471.963490044,140.134243904,-109.90328231,-322.231687044,220.176703058,48.7012203448,100.59870218,-387.480263668,95.9231856937,-134.375580668,36.3325625371,-53.7955873554,19.7264433675,153.522755647,57.0387343328,95.743697655,-150.047002265,69.0897092612,-136.142867507,38.6610433342,-32.8490413597,1.16819606146,3.60967948589,23.1383220417,35.6450863259,-3.73377797605,47.2759054488,-22.2802654833,11.2125815901,-39.2877514169,8.10319808327,40.7714001826,14.0408933688,0.0784463238344,-6.06439699418,-6.48276557652,11.3085637176,3.69721938232,7.51317451004,19.6337383597,5.57067530121,8.27850692288,-12.2729463477,-1.89840232804,10.9448504832,0.84837837564,-9.55215242547,3.06041218581,1.8310362532,-1.22081003087,-3.77388400518,0.162171828804,-1.48193260743,4.29641892011,6.00774705923,0.378525920547,2.64684412776,-2.08584544276,0.287816433234,0.155643411489,-1.10519994717,-3.62884477888,-2.04875112014,-2.98335374515,-1.43614077868,1.44340267829,-0.557184001458,-0.139479380781,-0.884109015063,-1.31381854332,0.43384073018,0.707376462231,0.158629751004,0.688301562569,-0.260573434341,-0.0141594333652,-0.172810054166,-0.844977005875,-0.588041059414,-0.614617151309,-0.956340695781,-0.914502185894,0.372677947758,0.210353645187,0.318952954038,0.222967216643,0.0130808635509,-0.292794661512,-0.417933578621,0.0866773220288,-0.217593159817,0.180268126235,0.238623870846,-0.0553599003787,0.042573989536,-0.213264442755,0.0340239804739,-0.0233168235334,-0.168739224012,-0.185934475014,-0.354733088019,0.161588509881,-0.0618810563524,-0.145341612221,0.0906433765434],[-31251.529142,1187.54468754,-62.6516454759,-507.268698505,-556.116843265,918.010384959,844.837136886,28.1708278122,-202.10608062,347.791073165,178.409095364,-716.845921962,-464.305405081,695.074440771,-132.226582984,-474.174144554,137.967059371,-101.862000057,-323.63222544,211.25830788,49.5297537794,102.269384732,-381.083210536,94.2995820982,-130.144645271,38.8746080063,-51.5103090325,19.0888890308,152.277242501,58.0007124216,95.0786482284,-146.9468355,68.0745811984,-136.904777464,41.9995427449,-32.5448346991,2.90115558866,3.67682916967,23.3655824949,36.3115409646,-3.20219877493,46.0616362104,-21.6674960789,10.8138234864,-39.5915430319,9.89946663389,40.4066562998,14.6719472212,-0.148569004539,-5.54739868813,-6.39837353173,11.4387271251,4.39414020835,7.26553350764,19.3930323048,5.56457785304,7.97306584007,-12.102587693,-1.52151227445,10.7221921944,1.12521675754,-9.64970652886,2.88664002318,1.71258422666,-1.22193355642,-3.84216878944,0.242400067479,-1.20134890848,4.20578524675,6.08923556577,0.360008302839,2.59654702946,-1.96367051741,0.322742519746,0.126436635767,-0.969716491475,-3.68327636692,-2.09469513609,-3.01689300731,-1.38021066579,1.39701210134,-0.609261901533,-0.167260136955,-0.874613606148,-1.26875964025,0.416369212279,0.764489617376,0.135715292704,0.694193171869,-0.220655502414,-0.0262798953304,-0.160007652728,-0.805860186413,-0.608362194713,-0.618984028171,-0.977468327513,-0.901158700775,0.362852755549,0.202981826396,0.313423021785,0.205030483279,0.0050463791772,-0.294983583534,-0.419891118326,0.083643272946,-0.193319072575,0.169308062144,0.247332853666,-0.0522522460912,0.036836957574,-0.201799718469,0.0379077069356,-0.0214282845612,-0.163321722351,-0.190574918187,-0.351435340354,0.157862530048,-0.067499435443,-0.145635145288,0.0876489097235],[-31289.6622718,1173.64957473,-49.2702985425,-512.191804767,-551.727103879,919.303835647,839.681939403,18.614584408,-209.411795914,343.807174616,181.17155436,-720.807894797,-463.816669273,686.330854821,-139.639339631,-476.345555494,135.567732257,-94.091559611,-324.601967761,201.679055537,50.9688952114,104.393737227,-374.236551629,92.5490884114,-125.769925694,41.4376362068,-49.33041855,18.5674037571,150.756056289,59.2895231649,94.5503955666,-143.70320011,67.2573624455,-137.504229331,45.3868998863,-32.2192870453,4.67166014781,3.73239207043,23.6009933544,36.9348430516,-2.51241473507,44.851670493,-21.0052505211,10.511633943,-39.8872804481,11.7312929536,39.9983697869,15.2969870841,-0.368931091348,-5.01269049618,-6.2866455634,11.5626664309,5.10730597025,7.0451763175,19.1421883095,5.58202115762,7.68721586235,-11.9303944903,-1.12112210691,10.4810863588,1.40460867861,-9.73379289659,2.71518781274,1.59287997359,-1.22064111028,-3.9027023352,0.320369517503,-0.913459184724,4.118691014,6.16737399974,0.354464940975,2.55143438944,-1.83564095252,0.366387496187,0.093626362162,-0.828657356256,-3.73875294213,-2.13801164333,-3.04918661971,-1.32216384413,1.34931926172,-0.66083824952,-0.19372541454,-0.865603122347,-1.22120812643,0.39846698094,0.821552395631,0.116050664585,0.700876201148,-0.177886634193,-0.0352662841946,-0.147622312007,-0.763249296472,-0.630332009082,-0.622231924237,-0.998851042387,-0.888051369007,0.352159918268,0.195544286887,0.307438077106,0.187017452993,-0.00330498260265,-0.297151522117,-0.421263182123,0.0802728188946,-0.168867581942,0.158769618237,0.256130755494,-0.0482581181115,0.0320209059059,-0.190182660453,0.0430168454026,-0.0202577550788,-0.157276986962,-0.19571007713,-0.348358497023,0.153786292139,-0.0733394754877,-0.145870669097,0.084565163672],[-31333.6684249,1161.74991186,-35.8911426989,-517.995864999,-546.846297137,919.326723613,834.252542225,9.08318792232,-215.869830614,339.899203054,183.137176062,-724.831371991,-463.693901083,677.569991043,-147.349829795,-478.392294835,132.945568539,-86.7172095085,-325.183999599,191.503920708,52.9318294194,106.791310781,-367.008847611,90.6341864672,-121.248529874,44.015289237,-47.2901374294,18.1794271488,148.926723204,60.8919887626,94.1058963273,-140.339075826,66.6566314274,-137.924637143,48.8074596988,-31.8627208628,6.48212399819,3.76850859913,23.8542296232,37.5069045956,-1.66482376137,43.6396211148,-20.293446402,10.3168319737,-40.1728206769,13.5925197402,39.5533102201,15.9117716305,-0.58055494887,-4.46221615975,-6.14731146377,11.6835796628,5.83249732678,6.85767758386,18.8827036934,5.62506429402,7.42578945121,-11.7567572058,-0.69842193291,10.2252871311,1.68290320812,-9.80374092276,2.54613498029,1.47245344826,-1.21689172891,-3.95441397275,0.396891515384,-0.618637320545,4.03624213953,6.24275954463,0.363224683362,2.5123575667,-1.70196235133,0.419032312347,0.0581437640336,-0.683845651976,-3.79477407601,-2.17861550568,-3.07967108722,-1.26209101647,1.30028797441,-0.711710991939,-0.218692963223,-0.8571425236,-1.17126219222,0.380502115693,0.878672941968,0.100099187589,0.708492656136,-0.13214724608,-0.0408336249086,-0.135298486097,-0.717577671613,-0.653710555053,-0.624338724316,-1.02034751044,-0.875254527306,0.340685825737,0.188221422509,0.300981204945,0.168976209918,-0.01191188984,-0.29935599471,-0.421980130861,0.0765453450184,-0.1442715421,0.148759400977,0.264972370742,-0.0432706496113,0.0282773779316,-0.178337427081,0.0492945685146,-0.0197534094785,-0.150595911138,-0.201325416742,-0.345482769702,0.149429918429,-0.0793069449905,-0.146034520143,0.0814237949047],[-31384.983417,1153.02813174,-22.5954500265,-525.249499305,-541.15652913,917.530224735,828.071330438,0.0986507677775,-221.367623575,336.007908235,184.080605883,-729.095599678,-463.832158982,668.814004975,-155.438804866,-480.228934548,130.109874193,-79.8641982873,-325.421406545,180.797878074,55.3317411819,109.28165651,-359.468659147,88.5173580999,-116.577565744,46.6012091955,-45.4236871921,17.9423988086,146.756769435,62.7949314144,93.692107168,-136.877442379,66.2909665693,-138.149414932,52.2455671227,-31.4654586162,8.33496139907,3.77731916673,24.134966304,38.019637605,-0.659823758759,42.4191008943,-19.5320013133,10.2402365923,-40.4460207302,15.4769896914,39.0782471756,16.5120595331,-0.781355589386,-3.89791942028,-5.98010102508,11.8046648491,6.56549493669,6.70861195097,18.6160757759,5.69576634127,7.19361906812,-11.5820663057,-0.254601859972,9.95854866616,1.95644941537,-9.85888000143,2.37956095166,1.35183460494,-1.21064444878,-3.99623303239,0.47277739763,-0.317257200304,3.95954454107,6.31598938395,0.387616378408,2.48016792025,-1.5628403171,0.480957918017,0.020920014743,-0.537104489103,-3.85083934006,-2.21642158695,-3.10778291473,-1.20008288558,1.24988205444,-0.76167807531,-0.241980532695,-0.849296769842,-1.11902002796,0.362842696066,0.935959401355,0.0883241826608,0.717184542565,-0.0833177544765,-0.0426969424227,-0.12268062909,-0.669278647401,-0.678257885159,-0.625282313217,-1.04181640171,-0.862842512387,0.328516867776,0.181193629113,0.294035490248,0.150954838188,-0.020713010586,-0.301654518759,-0.421972325386,0.072440236461,-0.119563807228,0.139384016829,0.27381249382,-0.0371829737625,0.0257579170507,-0.166188176728,0.0566840489114,-0.0198634221524,-0.143269388175,-0.207406401921,-0.342788370065,0.144863531193,-0.0853076124556,-0.146113034918,0.0782564599373],[-31444.3204874,1148.23492834,-9.43477048084,-534.288971454,-534.435721117,913.574221044,820.754068657,-7.88588769482,-225.843769446,332.118381365,183.843906998,-733.743625608,-464.171003048,660.055842902,-163.949291343,-481.776000392,127.08121651,-73.619673772,-325.340781722,169.632752986,58.0804736307,111.727340572,-351.684541512,86.1693834878,-111.761129964,49.1891195484,-43.7569943966,17.8736078339,144.224994239,64.9833708157,93.2650347316,-133.343831567,66.1720707184,-138.172032909,55.6808859382,-31.0214960726,10.2302229504,3.75382791108,24.4511181861,38.4650438816,0.500051176837,41.1856545409,-18.7224792196,10.2879992672,-40.7047900679,17.3767881433,38.5799945206,17.0938404597,-0.969871723069,-3.32190171354,-5.78561666108,11.9287292678,7.30181665417,6.60260168565,18.3438330162,5.79530626519,6.99442161655,-11.4067868224,0.208775168474,9.68454001128,2.22238882681,-9.89881925664,2.21557138403,1.23146331605,-1.20186696162,-4.02751206755,0.548631341671,-0.00993991945193,3.88968333169,6.38745491488,0.428414276622,2.45554831664,-1.41853737681,0.552299704293,-0.0171296027189,-0.389881570987,-3.90646964427,-2.25141176947,-3.13305035357,-1.13637237435,1.19811266168,-0.810570384406,-0.263464599527,-0.842114855208,-1.06460679299,0.345831263491,0.993442900585,0.0810607017393,0.7270953968,-0.031362872622,-0.0406356250984,-0.109460433574,-0.618730374856,-0.70371201346,-0.625031358378,-1.06310994146,-0.850874301846,0.315772554506,0.174590131341,0.286598718938,0.132998206332,-0.0296512962034,-0.304091018449,-0.421176818215,0.0679517449517,-0.0947867884899,0.130738257312,0.282633172301,-0.0299318997806,0.0245835780016,-0.153682609362,0.0651366152152,-0.0205301538347,-0.135301237958,-0.213920820585,-0.340257507146,0.140154918089,-0.0912592224095,-0.146097769542,0.0750959126242],[-31509.5025717,1146.39404034,3.65823448745,-544.52111988,-526.845055017,907.953419188,812.290039613,-14.6927803116,-229.441486053,328.393079454,182.53881362,-738.773703998,-464.827999802,651.171614086,-172.773416166,-482.977833273,123.925208035,-67.9183809362,-324.902748389,158.107773478,61.0845033117,114.162989292,-343.72502842,83.5942361865,-106.831274102,51.7730692321,-42.2828057492,17.9897413021,141.355289147,67.4351166431,92.8168856016,-129.773983466,66.28414441,-138.026185993,59.0743552856,-30.5395222092,12.1585046151,3.70449387748,24.8035592044,38.8354844005,1.80372218541,39.9425543287,-17.8730295763,10.4476012862,-40.9472479435,19.276970986,38.0655432865,17.6540280572,-1.14713685167,-2.73689525262,-5.56795127167,12.057017198,8.03592911511,6.54045954506,18.0676284327,5.92134257853,6.82745176792,-11.2316820521,0.68865486532,9.40658978397,2.48103279773,-9.92428673214,2.05437686007,1.11141912652,-1.19056158042,-4.04929652421,0.624228888618,0.301704582216,3.82766040606,6.45672438926,0.484174236923,2.43850765261,-1.2695437525,0.632610827486,-0.0551533668411,-0.242122972517,-3.96127125267,-2.28383600954,-3.15536864086,-1.0717612861,1.14518033547,-0.858350557012,-0.283256547826,-0.835581910607,-1.00825552253,0.329708207,1.05084649374,0.0781307207543,0.738374877757,0.0234154988976,-0.0346865149397,-0.0955185461196,-0.566090266826,-0.729722800131,-0.623517657748,-1.08405457592,-0.839347436794,0.302704877244,0.168335469019,0.278727480864,0.115138320466,-0.0386868312992,-0.306655044912,-0.419557428525,0.0631335885628,-0.0700211249727,0.122869654157,0.291525466408,-0.0216289410564,0.0247534608773,-0.140862591342,0.0746362199787,-0.0216727106276,-0.126746986749,-0.220765752728,-0.337880379405,0.135362528315,-0.0971274234679,-0.146001158636,0.071979296174],[-31577.6300294,1146.09746763,16.7806255539,-555.120426688,-518.641527913,901.37123197,802.761905563,-20.2132529806,-232.355147016,325.03880096,180.344477725,-744.147890682,-465.965217377,642.008218532,-181.765581383,-483.784727885,120.718722627,-62.6569640403,-324.051437336,146.329018251,64.248965124,116.666244039,-335.658648193,80.8041880957,-101.827038452,54.3471885504,-40.9855729931,18.3073357853,138.182818757,70.1261760687,92.348916347,-126.206190219,66.6045126017,-137.755625279,62.3822331448,-30.0318993053,14.1080386964,3.63863983814,25.1914030801,39.1234099298,3.23797421591,38.6950044231,-16.9934482113,10.7018563918,-41.1715660591,21.160836748,37.5419287955,18.1897669674,-1.31480817484,-2.14578994493,-5.33207037825,12.1903821691,8.76203615083,6.52204590899,17.7891461836,6.07065368081,6.69084863562,-11.0575898573,1.18161010753,9.1279414943,2.7334851406,-9.9362902016,1.89621419384,0.991691499441,-1.17673927344,-4.0630550715,0.699138420503,0.615819153821,3.77445685422,6.52316027262,0.552897520333,2.42888633242,-1.11640658997,0.721298885214,-0.0923154464821,-0.0933993614636,-4.01487176777,-2.31401128194,-3.17472476016,-1.00719364429,1.09133296001,-0.905014169169,-0.301526488578,-0.829667101146,-0.950226220759,0.31468837753,1.10781621671,0.0792279466328,0.751174174984,0.0806311626601,-0.0249508173617,-0.0807828517916,-0.511460551617,-0.755918066873,-0.620663791904,-1.10447030654,-0.828244099223,0.289598947606,0.162303010767,0.270493066856,0.0974039710992,-0.047783983792,-0.309322556015,-0.41708466716,0.0580543519524,-0.0453570127459,0.115813924151,0.300607689526,-0.0124292870245,0.0262361771096,-0.127793530618,0.0851749717374,-0.0232043849754,-0.117675087401,-0.227820601364,-0.335649182663,0.130542476454,-0.102889840269,-0.145840856449,0.0689448511344],[-31645.80322,1145.93721007,30.0294633941,-565.261373978,-510.082136889,894.531072192,792.252328767,-24.3385315996,-234.779125955,322.262344342,177.440051286,-749.828241496,-467.744723906,632.412556245,-190.780189041,-484.146978919,117.538634144,-57.7320673449,-322.730979355,134.40256601,67.4789939668,119.314746179,-327.553929154,77.8115111154,-96.7874633061,56.9056078076,-39.8497478717,18.842927856,134.742747665,73.0325562647,91.8623835363,-122.678743969,67.110500251,-137.404101863,65.5607774961,-29.5109896406,16.0670574981,3.56558856523,25.6137635343,39.3212712376,4.78959221732,37.4482089893,-16.0935309528,11.0335783266,-41.3759161166,23.0116839577,37.0161863698,18.6982018324,-1.47454289222,-1.55147569789,-5.08293950224,12.3296777102,9.47434159264,6.54722115719,17.510070427,6.24001797154,6.58275133305,-10.8853481001,1.68421377208,8.85183865232,2.9808496679,-9.93583743872,1.74132019937,0.872269897884,-1.16041100893,-4.07025637854,0.772928319359,0.930546644483,3.73105376622,6.58612503048,0.632585387874,2.42652476033,-0.959673035033,0.817771475093,-0.127780010501,0.0567185944011,-4.0668987921,-2.34225456147,-3.19110569502,-0.943613472361,1.03681841951,-0.950556796916,-0.318444532772,-0.824339591929,-0.890778891887,0.300986626014,1.16399810542,0.0840460863015,0.765644478032,0.139897921243,-0.011529737779,-0.0651812356561,-0.454943457534,-0.781925635388,-0.616392341424,-1.12417713479,-0.817546471123,0.276739877208,0.156366125203,0.261966767741,0.0798239487415,-0.0569071216001,-0.312069509625,-0.413729044967,0.0527826197784,-0.0208846478789,0.10960678408,0.309998155041,-0.00248812711929,0.0290003381302,-0.114540835143,0.0967449790264,-0.0250384693224,-0.108153992769,-0.234964769504,-0.333556112736,0.125750877089,-0.10852409745,-0.145634517229,0.0660308180527],[-31711.1225031,1144.50526752,43.5018086835,-574.118443854,-501.423879028,888.136352656,780.843971485,-26.9598420665,-236.907796492,320.27050806,174.004686278,-755.776812273,-470.328587519,622.23152723,-199.671641189,-484.014881071,114.461816445,-53.0403351106,-320.885505236,122.434495457,70.6797247394,122.186137082,-319.479399625,74.6284771453,-91.7515889592,59.4424573074,-38.8597821282,19.6130540864,131.070240471,76.1302644031,91.3585437386,-119.229936861,67.7794323155,-137.015366839,68.5662463194,-28.9891554946,18.0237933235,3.49466283096,26.0697542884,39.4215190922,6.4453611386,36.2073721925,-15.1830736287,11.4255808332,-41.5584698178,24.8128111438,36.4953513318,19.1764772937,-1.62799820345,-0.956842418932,-4.82552416505,12.4757573506,10.1670492719,6.61584566942,17.232085321,6.42621385023,6.5012989736,-10.7157946431,2.19303873594,8.5815247681,3.2242301921,-9.92393621718,1.58993169071,0.75314378493,-1.14158775517,-4.07236911447,0.845166967217,1.24402990332,3.69843223212,6.64498112835,0.721239100567,2.43126334062,-0.799890233477,0.921436194739,-0.160711227756,0.208660227305,-4.11697992819,-2.36888282294,-3.20449842902,-0.881964793769,0.981884598182,-0.994974016292,-0.334180791397,-0.819568548063,-0.830173540105,0.288817803388,1.21903819575,0.0922788466875,0.78193697645,0.200829577224,0.00547551839321,-0.0486415827786,-0.396641212884,-0.807373327377,-0.610625886883,-1.14299506211,-0.807236734485,0.264412777668,0.150398180948,0.25321987435,0.0624270439033,-0.0660206126422,-0.314871863611,-0.409461072789,0.0473869766988,0.00330577355884,0.104283950728,0.319815176336,0.00803934922456,0.0330145553707,-0.10116991287,0.109338350381,-0.0270882561128,-0.0982521557059,-0.242077660162,-0.331593365445,0.121043844801,-0.11400781965,-0.145399795225,0.0632754374763],[-31771.4941753,1140.66228528,57.3639040331,-581.193767052,-492.967582326,882.729148948,768.585841544,-28.1247260208,-238.908727065,319.190524123,170.176724273,-761.969628984,-473.827240085,611.374418825,-208.275054034,-483.360391988,111.538668684,-48.4879021371,-318.487467461,110.511869773,73.771510837,125.341291445,-311.496560811,71.2776622413,-86.7552691404,61.9534681472,-37.9992236902,20.6230695002,127.200033805,79.3925884916,90.8433814999,-115.891109599,68.5923154422,-136.623579226,71.3608918399,-28.4772761666,19.9662163618,3.4343594319,26.5561985256,39.4192238096,8.19076696305,34.9785470455,-14.2715117416,11.8628727242,-41.7178054466,26.5494427926,35.9847253513,19.6217403772,-1.77664609073,-0.364929711939,-4.56404907865,12.6287932789,10.8348163158,6.72646666286,16.9568593895,6.62610086341,6.44473278387,-10.5495805482,2.70460396473,8.31961520606,3.46421448955,-9.90145910447,1.44226661609,0.634447619531,-1.12030268716,-4.07074140709,0.915462027856,1.5543923318,3.67714903534,6.69923469043,0.817000985037,2.44290575392,-0.637840358233,1.03157163255,-0.19050535567,0.362642526248,-4.16471158445,-2.39412804203,-3.21481584174,-0.8230768495,0.926813368325,-1.03822686739,-0.348876760951,-0.815293258996,-0.768698058567,0.27831577461,1.27257672788,0.103605614627,0.800126999724,0.262987710025,0.0259066736412,-0.0311371134494,-0.336720867313,-0.831925782264,-0.603356219294,-1.16073938596,-0.797313095554,0.2528553251,0.144291285975,0.24432532357,0.0452585682687,-0.0750882411939,-0.317687759753,-0.404283229092,0.0419320661496,0.0271174642548,0.0998688628621,0.330143733916,0.0189982357226,0.0382250476438,-0.0877519827232,0.122913645585,-0.0292727665229,-0.0880500043412,-0.249041856206,-0.329754045745,0.116469846542,-0.119320846527,-0.145146195333,0.0607084742003],[-31828.0482824,1134.34349025,72.0587197951,-587.300068844,-485.189398419,878.206187794,755.392329048,-28.5059880677,-240.842265392,318.831358743,165.931265238,-768.438598148,-478.144568413,600.000067694,-216.348400413,-482.242121145,108.713691193,-44.0188653801,-315.622605275,98.6456900547,76.7355796395,128.77401729,-303.638805438,67.8228590832,-81.8216113231,64.4407745973,-37.2480052228,21.8336029271,123.165152424,82.7819398802,90.3417932764,-112.665797132,69.5448830368,-136.224529736,73.9309432631,-27.9802990353,21.881248345,3.38987126218,27.0607572782,39.3199338981,10.0060998112,33.7711819506,-13.3668394919,12.3392430937,-41.8541276137,28.2145072225,35.4826754896,20.0311476431,-1.92121766639,0.220624033263,-4.29977571731,12.786232321,11.4741130361,6.87237870428,16.685998619,6.83686314564,6.41170244331,-10.3866096763,3.21521277874,8.066212748,3.69932619204,-9.8687378432,1.2984674605,0.516895844137,-1.09667780695,-4.066239219,0.983578292044,1.85967954072,3.6660637328,6.74896647558,0.918577630315,2.46110878634,-0.47524569074,1.14694034008,-0.21748700592,0.518033107311,-4.20956539288,-2.41788219802,-3.22167439695,-0.7673197507,0.872022554636,-1.0801382465,-0.362559479984,-0.811333511547,-0.706751896261,0.269290460734,1.32423075905,0.117648496594,0.819986437085,0.325725006445,0.0493771620545,-0.012822388858,-0.27560875583,-0.855394910358,-0.594851971399,-1.17720658769,-0.787837857593,0.242115453618,0.138012505675,0.235362636523,0.0284299182192,-0.0840714569604,-0.320404075483,-0.398325862824,0.0364667666772,0.0504272719235,0.0963358471594,0.34093547676,0.0302347586906,0.0444884632858,-0.0743815075232,0.13729522941,-0.0315339366577,-0.0776758679056,-0.255752659922,-0.328034895133,0.112046758736,-0.124451877826,-0.14485062504,0.05832579001],[-31882.7208071,1125.75275476,88.0984082574,-593.577723139,-478.609309855,874.302858703,741.144169666,-28.9327485541,-242.741954013,318.922411685,161.202598736,-775.229596424,-483.132823047,588.329697834,-223.630367321,-480.740340969,105.904909598,-39.5868123347,-312.404979615,86.8279418751,79.5683770227,132.461355969,-295.932499115,64.3381645069,-76.9705364166,66.9081117211,-36.5851555751,23.1941016482,118.998193121,86.2580107545,89.8834035015,-109.55058297,70.6365501943,-135.804417004,76.2686240392,-27.5016884991,23.7555488908,3.36556524033,27.5688010406,39.1318174137,11.8703508381,32.5955741576,-12.4766907547,12.850676106,-41.9680475117,29.80285871,34.9858351554,20.4018580357,-2.0622588253,0.796030730379,-4.03322474584,12.944839962,12.0818630401,7.04556319784,16.4210933617,7.05576597853,6.40095974454,-10.226599088,3.72111458687,7.8207920301,3.92757289524,-9.82596896978,1.15865784311,0.401347897071,-1.07085732331,-4.0596079715,1.04931983229,2.15791769323,3.66361157483,6.79440090132,1.02481669104,2.48549250037,-0.314063539569,1.26617585965,-0.24221287875,0.673987243348,-4.25098179137,-2.43995227108,-3.22461645445,-0.714948826055,0.817963969908,-1.12049651397,-0.375227372554,-0.807479216882,-0.644762391135,0.261470796838,1.37361155077,0.134015278974,0.841211317698,0.388341930131,0.0754433456239,0.00610269458159,-0.213796034785,-0.877629439689,-0.585450986375,-1.19218844466,-0.778889348117,0.232193661834,0.131547644791,0.226412980389,0.0120690113102,-0.0929311260041,-0.322889872146,-0.391751290554,0.0310360156062,0.0731054530363,0.0936469522775,0.352108720962,0.0415954275943,0.0516390580138,-0.0611587610627,0.152273917876,-0.0338194313542,-0.0672700509053,-0.262108553449,-0.326433564247,0.107784810175,-0.129391828312,-0.144481842484,0.056114770938],[-31937.4477323,1115.09395114,105.995121707,-601.167103843,-473.747299183,870.754551183,725.722099071,-30.2341278268,-244.641335464,319.193082711,155.925014331,-782.388500466,-488.644254533,576.584533241,-229.859641753,-478.935323889,103.030349525,-35.1453304957,-308.948651417,75.0506108085,82.2663488625,136.380348832,-288.404007451,60.8976753482,-72.2219653301,69.3592145822,-35.9897035966,24.6540129445,114.731752687,89.7804933,89.4978366089,-106.542050624,71.8667320101,-135.349439665,78.3661576186,-27.0449089565,25.5757776168,3.36580828488,28.065700307,38.8630424126,13.7625111984,31.4620209163,-11.608699405,13.3931559252,-42.0601763332,31.3093515315,34.4908377577,20.7310304993,-2.20031546233,1.35750229311,-3.76491682907,13.1013816872,12.6549899355,7.23800154773,16.1637339696,7.28007464366,6.4112564802,-10.0692658439,4.21855879807,7.58282768854,4.14696219481,-9.77334902063,1.02296138308,0.288663216657,-1.04298544502,-4.05159308586,1.11249072112,2.44713295246,3.66822781171,6.83576238518,1.13456582184,2.51567695847,-0.156251213286,1.38791173359,-0.2652396744,0.82966020721,-4.28840121783,-2.46014524138,-3.22318437403,-0.66621940425,0.765089426937,-1.15909003015,-0.386878862722,-0.803520286161,-0.583156881136,0.254585717999,1.42033036455,0.152313748149,0.863497670731,0.450138944725,0.10366158634,0.0254382404551,-0.151773860527,-0.898478098286,-0.5754911074,-1.20547673422,-0.770545894643,0.22309044836,0.12488250807,0.217557522348,-0.00369623490301,-0.101628114388,-0.325014211085,-0.384721828852,0.025684750261,0.0950222640644,0.0917642268733,0.36358178262,0.0529267518995,0.0595110875449,-0.0481840171348,0.167640527005,-0.0360769154491,-0.0569728578463,-0.268008018929,-0.324947703721,0.10369422965,-0.13413161275,-0.144008605799,0.0540628030173],[-31994.1650409,1102.57095172,126.261012433,-611.208584863,-471.123348951,867.296654743,709.006852935,-33.2392462325,-246.573952284,319.372771584,150.032801587,-789.961186933,-494.531113413,564.985797911,-234.774910706,-476.907342334,100.008036603,-30.648007358,-305.367681615,63.3056824286,84.8259410347,140.508037232,-281.079696052,57.5754884429,-67.5958189731,71.7978182442,-35.4406781365,26.1627840971,110.398427913,93.3090797023,89.2147170319,-103.636783603,73.2348435793,-134.845796354,80.2157674519,-26.6134248059,27.3285941405,3.39496731433,28.5368255718,38.5217769509,15.6615720472,30.3808194764,-10.7704993177,13.9626667155,-42.1311252709,32.7288399633,33.9943167051,21.0158239779,-2.33593347236,1.90125063516,-3.49537263181,13.2526229817,13.1904173298,7.44167515812,15.9155107951,7.50705442262,6.44134444294,-9.91432700476,4.70379482127,7.35179435948,4.35550168641,-9.71107453215,0.891501699593,0.179701241219,-1.01320638086,-4.04293998338,1.17289503103,2.72535148157,3.67834769375,6.8732753447,1.24667267735,2.55128222313,-0.00376602046085,1.51078150423,-0.287124093113,0.984207271751,-4.32126411015,-2.47826808908,-3.21692051549,-0.621386813971,0.713850738517,-1.19570715539,-0.397512374548,-0.799246630549,-0.522362704211,0.248364159295,1.4639984619,0.172151690503,0.88654152535,0.510416513873,0.133588246193,0.0449843523485,-0.0900333894079,-0.91778961418,-0.565310177648,-1.21686323373,-0.762885824687,0.214806311809,0.118002900255,0.20887742958,-0.0187379028649,-0.110123288173,-0.326646153645,-0.377399794288,0.020457907966,0.116047961479,0.0906497196041,0.37527297783,0.0640752410719,0.0679388075964,-0.0355575495323,0.183185872816,-0.0382540537796,-0.0469245932349,-0.273349538503,-0.323574964191,0.0997852459547,-0.138662145906,-0.143399673123,0.0521572722806],[-32054.2668691,1088.4955072,149.077502195,-624.566421143,-471.076377756,863.62117605,690.95227135,-38.4726491382,-248.573411676,319.243310787,143.505906632,-797.945066214,-500.660212919,553.695087517,-238.239055994,-474.728799091,96.7681592577,-26.0527529519,-301.758659449,51.5924506149,87.2279788887,144.812521071,-273.969204087,54.4389027133,-63.1092442347,74.225193416,-34.9194602044,27.6745996921,106.02638394,96.8100472289,89.0581838703,-100.830089821,74.7387202864,-134.282023867,81.8155019814,-26.2100575009,29.0034501979,3.45564245436,28.9692777668,38.1155162603,17.5493503874,29.3606728785,-9.96878712318,14.5550818488,-42.1815168085,34.05933906,33.4919323309,21.2539406092,-2.46942880155,2.42443469602,-3.22502585864,13.3956712469,13.6861596455,7.64942310822,15.6777312703,7.73362641921,6.48983956175,-9.76201194834,5.17367109153,7.12667480367,4.55102880386,-9.6393549448,0.764058041574,0.0751574611448,-0.981631423034,-4.03426664562,1.23044008469,2.99100910932,3.6924273857,6.90710605173,1.3599494097,2.59184250199,0.141665346101,1.63352521806,-0.308418809015,1.13666661648,-4.34902871997,-2.49437280282,-3.20546100742,-0.580567744751,0.664607887895,-1.23018119597,-0.407142314024,-0.794487913802,-0.462761688709,0.242550042049,1.50431858438,0.193150766853,0.910051689442,0.568570161026,0.164763983618,0.0645879877252,-0.0290648977705,-0.935426590502,-0.555254782911,-1.22619369289,-0.755953935444,0.207315999014,0.110894809642,0.200446949765,-0.0329616808015,-0.118386002132,-0.327682394302,-0.369936842498,0.0153991715258,0.136084107889,0.0902531454265,0.387100282342,0.0749120838318,0.0767577627857,-0.0233544629441,0.198704823713,-0.040298045975,-0.0372686568173,-0.278045887186,-0.322315976587,0.0960660179932,-0.142985046118,-0.142630497932,0.0503766617361],[-32116.9799676,1073.61088176,173.303090648,-641.000391774,-473.221048386,859.246590391,671.804612098,-45.2405819919,-250.673579504,318.796263674,136.506901847,-806.143683638,-506.956617021,542.635484441,-240.611738708,-472.440618369,93.2895571193,-21.334767449,-298.148287368,39.9394424687,89.3908056674,149.226134453,-267.015264954,51.5280254268,-58.7682919238,76.6327533885,-34.4168394509,29.1625935354,101.626059299,100.276013475,89.0304348887,-98.1121748003,76.3698786739,-133.656011639,83.1867096184,-25.8350567153,30.6009659968,3.54336665915,29.3570795733,37.649064275,19.4189666144,28.4039073257,-9.20651047296,15.1658315271,-42.2120185942,35.311506989,32.9754526646,21.4452553048,-2.60019760125,2.92800151838,-2.95396237317,13.5290015495,14.1445945655,7.85751517733,15.4505711479,7.95533502611,6.55481431118,-9.61459932176,5.62743214843,6.90448428013,4.73070033362,-9.55845131521,0.639032177026,-0.0249284249248,-0.948240197387,-4.02568129526,1.28544620529,3.24418032699,3.70900671001,6.93718819543,1.47306616103,2.63654858331,0.279238656645,1.75530893821,-0.329660391777,1.28560804751,-4.37122455402,-2.50949140502,-3.18881705361,-0.543324329517,0.617353540132,-1.26252524196,-0.415847014872,-0.789232810057,-0.404553624583,0.236947232567,1.54135939379,0.214988135738,0.933788085775,0.624375648873,0.196666642824,0.0842835195585,0.0306448580631,-0.951307130785,-0.545706479425,-1.23352975089,-0.74966090283,0.200491249695,0.103544958737,0.192312652574,-0.0464076800651,-0.126419565868,-0.328130160057,-0.362441985398,0.0105472056653,0.15515749045,0.0904748844949,0.398980310512,0.085407185917,0.0858086533314,-0.0115491856416,0.214008457626,-0.0421542308345,-0.0281608293003,-0.282067011496,-0.321183293019,0.0925364251214,-0.147144746027,-0.141703315073,0.0486638422929],[-32180.9892403,1058.76821797,197.46554692,-659.994156887,-476.99095968,853.647990212,651.883237384,-52.5447152615,-252.908386299,318.075626318,129.244016178,-814.312118267,-513.359952374,531.670442741,-242.37681476,-470.07585474,89.5632326183,-16.4735735559,-294.545796124,28.382493397,91.2171440872,153.672270035,-260.143885611,48.8761659376,-54.5762388293,79.0094470979,-33.9259576867,30.6046367376,97.2034608713,103.706181117,89.1281825176,-95.4719684656,78.1182555735,-132.967987271,84.3565637661,-25.4880291782,32.1245538634,3.65190609003,29.6959841098,37.1265521049,21.2663669714,27.5112548118,-8.48567977384,15.79023516,-42.2233095674,36.4991626959,32.4356726603,21.5901861695,-2.72740607412,3.4138451707,-2.68218107875,13.651430872,14.5691905878,8.06307881979,15.2339232608,8.16738045817,6.63420530211,-9.4748800894,6.06492155768,6.68174617246,4.89150290029,-9.46863760404,0.514481503715,-0.120680666284,-0.912979413185,-4.01716471526,1.33833696618,3.48534929148,3.72664640358,6.96339731928,1.58465757094,2.68450540052,0.408380297178,1.87540523197,-0.351381384951,1.42948427764,-4.38739893275,-2.52490092657,-3.16709362663,-0.509080062042,0.571988530742,-1.2927973294,-0.423720792746,-0.783509746044,-0.347892792189,0.231374583399,1.57528103194,0.237354830133,0.957523415838,0.677703799906,0.228758364463,0.1041521747,0.0886100017768,-0.965363213667,-0.537055566042,-1.2389870193,-0.743883872439,0.194178051792,0.0959402535953,0.184514188177,-0.0591496177894,-0.134235777692,-0.328024311041,-0.355013573971,0.00593942058963,0.173326202454,0.0912029832634,0.410829336352,0.0955551323198,0.0949334683527,-9.09767921122e-05,0.228911904869,-0.0437674819498,-0.0197599866309,-0.285397150828,-0.320192445894,0.0891942768078,-0.151196381847,-0.140627054732,0.0469527818355],[-32244.9795913,1044.81865838,220.092640138,-681.031376609,-481.819710473,846.300467957,631.507509412,-59.386719415,-255.311762591,317.125394793,121.925478569,-822.205449162,-519.809845635,520.663416477,-244.01814006,-467.66756277,85.5801881854,-11.4486939796,-290.960416468,16.9574388063,92.6097168643,158.074320471,-253.281073015,46.5166335996,-50.53636174,81.3442234804,-33.4399567226,31.9786004097,92.7645955377,107.099752833,89.3481391879,-92.898400742,79.9737878171,-132.218178358,85.3522378278,-25.1685816185,33.5776261238,3.77502690833,29.9817444951,36.5521108597,23.0874977019,26.6834473306,-7.80830543264,16.4236121571,-42.2160686677,37.6361251261,31.8633872719,21.6891513082,-2.8502204228,3.88385972147,-2.40968087875,13.7617761974,14.9634162103,8.26324148994,15.0276804417,8.36496293029,6.72594914544,-9.34564521564,6.48598288501,6.45498386425,5.03042312848,-9.37018777198,0.388463419407,-0.212223512228,-0.875795779697,-4.0086976886,1.38953594072,3.71500015969,3.7439072033,6.98560896676,1.69335827906,2.73481788705,0.528516653707,1.99308666664,-0.374114332094,1.56674801964,-4.39709917664,-2.54187839834,-3.14039569907,-0.477258436102,0.528413695239,-1.3210554943,-0.430857963301,-0.777347148492,-0.29293347188,0.225650947098,1.60624364068,0.259941883009,0.98103038112,0.72842543662,0.260501289187,0.12427518,0.144344657055,-0.97752681778,-0.529692341612,-1.24268110965,-0.738499989866,0.188222393247,0.0880676002739,0.177091206742,-0.0712612111083,-0.141846435918,-0.327399707385,-0.3477499592,0.00161322650385,0.190648337195,0.0923254881858,0.42256363387,0.105350508032,0.103974196968,0.0110709044371,0.243230295756,-0.0450826729126,-0.012225004756,-0.288020544575,-0.319358967616,0.0860373825209,-0.155195089791,-0.139410647095,0.0451774482483],[-32307.6359247,1032.61334557,239.71213943,-703.595711069,-487.140899603,836.67911607,610.996790385,-64.7682649206,-257.91763891,315.989565171,114.759517967,-829.578755385,-526.245923458,509.477859708,-246.019570519,-465.248797029,81.3314262509,-6.23965142677,-287.401379153,5.7001141037,93.4712467153,162.355678417,-246.352834125,44.4827377667,-46.6519374446,83.6260314722,-32.9519783695,33.2623556623,88.3154701789,110.455931299,89.6870173303,-90.3804015547,81.9264122365,-131.4068125,86.2009052068,-24.8763207651,34.9635951041,3.90649527536,30.2101138479,35.9298716492,24.8783050492,25.921216876,-7.1763978562,17.0612819279,-42.1909748344,38.7362132252,31.2493914533,21.742568826,-2.96780684994,4.33993923914,-2.13646067654,13.8588545083,15.3307399308,8.45513064213,14.8317355234,8.54328265734,6.82798245209,-9.22968566485,6.89045969613,6.22072073911,5.1444476428,-9.26337577969,0.259035321866,-0.29968121205,-0.836636006186,-4.00026099823,1.43946670224,3.93361708852,3.75934984607,7.00369868137,1.79780292501,2.78659097633,0.639074112242,2.10762580949,-0.398391776758,1.69585198629,-4.39987260615,-2.56170085123,-3.1088282435,-0.447282945469,0.486529869136,-1.34735777267,-0.437352842191,-0.770773444131,-0.239829944013,0.219595176213,1.63440736185,0.28244032734,1.00408168311,0.776411381511,0.291357557651,0.144733762309,0.19736294758,-0.987729921761,-0.524007104985,-1.24472763351,-0.733386400705,0.182470262,0.0799139048293,0.170083358441,-0.0828161771554,-0.149263338857,-0.326291209223,-0.340749492069,-0.00239396638694,0.207181987965,0.0937304457161,0.434099477079,0.114787898047,0.112772828297,0.0219871988788,0.256778760601,-0.0460446773146,-0.00571475962271,-0.289921432131,-0.318698390591,0.0830635517292,-0.159196006074,-0.138063022351,0.0432718094158],[-32367.7623618,1022.7197483,255.151513561,-727.195038537,-492.50126154,824.537794628,590.677895111,-67.9784788464,-260.761187943,314.746337884,107.9368429,-836.242155433,-532.608189831,498.041977503,-248.804820228,-462.840786918,76.824592845,-0.827812057988,-283.863355285,-5.35430262577,93.7433703899,166.455709583,-239.305757095,42.800181543,-42.9235584813,85.8477367844,-32.4599112954,34.4413542417,83.869203965,113.76991385,90.1398398468,-87.9101796077,83.9662481345,-130.534534247,86.9297674243,-24.6100176549,36.2854535261,4.04054285217,30.3780855111,35.2658869794,26.634188977,25.2248960145,-6.59280861799,17.6990431519,-42.148160195,39.8100485011,30.5871505943,21.7512857214,-3.07945744515,4.78348135592,-1.86304544929,13.9416611436,15.6743628383,8.63613922082,14.6457919053,8.6983695653,6.93858532926,-9.12904932578,7.27822650762,5.97623992463,5.23124314428,-9.14860714225,0.124844636967,-0.383213384434,-0.795443264569,-3.99191557923,1.48828541889,4.14165326859,3.77182003508,7.01754340705,1.89674742921,2.83904991075,0.739623787665,2.21824427476,-0.424650420372,1.81545484488,-4.39549326059,-2.58536043601,-3.07257839285,-0.418709943962,0.44624350784,-1.37175484299,-0.443289957523,-0.763853733611,-0.188715641073,0.213084829639,1.6599056948,0.304554101568,1.02645199663,0.821560603535,0.320869542868,0.165553752118,0.247217619211,-0.995929453145,-0.520325422873,-1.24523033304,-0.728442563668,0.176797058448,0.0714851011812,0.163514917572,-0.0938712505344,-0.156492532057,-0.324736458705,-0.334097854073,-0.00604592344815,0.222971606386,0.0953197824057,0.445355610065,0.123862849006,0.121194167699,0.0326912615541,0.26939321472,-0.0466206104862,-0.000354972581093,-0.291093472896,-0.318224398713,0.0802709987656,-0.163238173901,-0.136593855329,0.0411839796067],[-32424.6398931,1014.57064012,266.437029849,-751.434109841,-497.900073278,810.745434225,570.907448807,-69.4563146612,-263.882551004,313.610730789,101.578080226,-842.225925545,-538.838158056,486.54297898,-252.557035994,-460.417461162,72.1339083949,4.79808415178,-280.282777393,-16.1732625835,93.5233807722,170.377671894,-232.168754869,41.464243032,-39.3410803851,88.0178722264,-31.9806315974,35.5313704353,79.4673652229,117.020876452,90.6948715248,-85.4930587214,86.0841446974,-129.603655961,87.5661384731,-24.3651005555,37.5445156943,4.17326329864,30.487613725,34.57389494,28.3483643299,24.593219604,-6.0637539582,18.3346115872,-42.0855696289,40.8554627114,29.880811828,21.7178645673,-3.18496784587,5.21389795878,-1.59206446956,14.0099048665,15.9964163858,8.80472213107,14.468795253,8.82957242455,7.05741186952,-9.04281178461,7.64928163956,5.72186352444,5.29119663971,-9.02681359238,-0.0131010969836,-0.463121125617,-0.752146577366,-3.9840429752,1.53507863798,4.33943802534,3.78130333875,7.02702568958,1.98943283525,2.89190116851,0.830315710366,2.32395986441,-0.452943595855,1.92503908081,-4.38464205462,-2.6127097831,-3.0321619214,-0.391627225568,0.407483546322,-1.39426795345,-0.448714687211,-0.756799813266,-0.139640604074,0.206232291632,1.68276556898,0.326038766018,1.04792388985,0.863884657507,0.348900547304,0.186539394466,0.293615906493,-1.00218213507,-0.518713933427,-1.24424547282,-0.723657189926,0.171195832816,0.0628632347021,0.157348654948,-0.104415235728,-0.163517050012,-0.322784226064,-0.327830048747,-0.00931111232708,0.238007077395,0.097050945196,0.456260657235,0.132574754146,0.129194285488,0.043146904238,0.280992713432,-0.0468665547133,0.00386125340574,-0.291568006298,-0.317943281826,0.0776595574203,-0.167296264448,-0.135015799435,0.0389186586259],[-32477.6687264,1007.31512081,273.894655249,-775.941893953,-503.449747444,796.449733088,552.049529294,-69.9281824341,-267.323111566,312.831966101,95.7863363876,-847.615381394,-544.877718769,475.232824268,-257.399222804,-457.940923319,67.3502369277,10.6474537739,-276.58151836,-26.7248742925,92.9474847799,174.140796329,-224.991321588,40.4625940871,-35.8916744402,90.1488873825,-31.5357622296,36.5557591658,75.1586345689,120.18398973,91.338687623,-83.1376414953,88.2711335826,-128.616906957,88.1373604643,-24.1361620425,38.7416763086,4.30121577438,30.541892954,33.869555017,30.0134996731,24.0245230753,-5.59629128369,18.966182262,-42.0006012035,41.867090176,29.1371927234,21.6452968302,-3.28425957652,5.63010449844,-1.3266730837,14.0634727965,16.2987646173,8.95959976807,14.2995017987,8.93706971661,7.18445966172,-8.96930555189,8.00365436289,5.45867338618,5.32537521227,-8.89905841721,-0.15320431357,-0.539740901224,-0.706671429746,-3.97710488183,1.57866550161,4.52726971792,3.78807029179,7.03202947522,2.07522146752,2.94497153678,0.911444639612,2.42373942735,-0.483228793999,2.02429313395,-4.3682266217,-2.6433166428,-2.98817676376,-0.36625544432,0.370184539446,-1.41491099471,-0.453662621624,-0.749860153347,-0.0926340261623,0.19920865279,1.70298727138,0.346662786484,1.06828190427,0.903423244702,0.375394105786,0.207439538033,0.336303666148,-1.00656963956,-0.519174542659,-1.24181744808,-0.719041303765,0.165689047783,0.0541493786277,0.151531965511,-0.114419954688,-0.170314174452,-0.320486063552,-0.321968410139,-0.0121591762415,0.252264644256,0.0988952611255,0.466745713071,0.140923968356,0.136752068223,0.0533005528936,0.291517097061,-0.0468608340205,0.00697396997148,-0.291385791771,-0.317859481264,0.075229466348,-0.171328855878,-0.133342252717,0.0364946926627],[-32526.2490696,1000.10229012,277.850356716,-800.347359841,-509.262696666,782.798389442,534.46821439,-70.120492234,-271.1242531,312.659266034,90.6647178273,-852.495838653,-550.668762602,464.363473497,-263.454385646,-455.373276947,62.56444247,16.7297133796,-272.681451069,-36.9772462759,92.1518893303,177.764313867,-217.822951395,39.7829065619,-32.5625119307,92.253231837,-31.1469261464,37.5378753562,70.9916926193,123.234424309,92.0578634001,-80.8525305286,90.5182464477,-127.577016553,88.6707755085,-23.9177946915,39.8778300694,4.42095943899,30.5441176628,33.1685266965,31.6222635716,23.5171418591,-5.1974780013,19.5919502043,-41.8906529865,42.8395652149,28.3631108495,21.5365739768,-3.37725416151,6.0310164256,-1.07002663809,14.1022520528,16.5832715769,9.09949252699,14.1366677746,9.02103992297,7.31972629473,-8.90686313819,8.34137394855,5.18775135748,5.33484594518,-8.76640490386,-0.293867446377,-0.613409176879,-0.658943306879,-3.97156299482,1.6178651519,4.70544670548,3.79239142892,7.03243871022,2.15347565042,2.99808780273,0.98330533467,2.51654981245,-0.515463505596,2.11290544422,-4.34715459535,-2.67674876542,-2.94122085456,-0.342815254249,0.334281042075,-1.43369785743,-0.458169351127,-0.743283224108,-0.0477251004833,0.192185003713,1.72057108898,0.36619462876,1.08731058138,0.940216066399,0.400293753143,0.228003031496,0.375026754896,-1.00917363865,-0.521709156581,-1.23799065401,-0.714605929473,0.16029916603,0.0454446061938,0.146012244203,-0.123857229368,-0.176861187107,-0.317893523423,-0.316535272297,-0.0145597584093,0.265720550236,0.100824057233,0.476741872057,0.148910846523,0.14384640246,0.0630986334844,0.300906205929,-0.0466817724323,0.00902322874985,-0.290587588749,-0.317977438361,0.0729809642035,-0.175294526357,-0.131586613222,0.0339309279065],[-32569.7811304,992.08124782,278.630101204,-824.279476476,-515.451333571,770.939101513,518.527581917,-70.75965413,-275.327359077,313.341852803,86.316330987,-856.952612996,-556.153180191,454.186886795,-270.845529506,-452.676625604,57.8673890489,23.0542795404,-268.504448404,-46.8984870567,91.2728013412,181.267455488,-210.71313843,39.4128523099,-29.340764141,94.343355174,-30.8357463021,38.5010739292,67.0152199904,126.147350811,92.838974115,-78.6463284208,92.8165149499,-126.486714061,89.1937257167,-23.704591078,40.9538716765,4.52905345208,30.4974823157,32.4864694642,33.1673245902,23.0694113861,-4.8743715179,20.2101104421,-41.7531230452,43.7675221479,27.5653837751,21.3946874735,-3.46387312524,6.41554919096,-0.825280479096,14.1261297549,16.8518013084,9.22312080304,13.9790494129,9.08166152511,7.46320935742,-8.85381705404,8.66246966747,4.91017928598,5.32067592162,-8.62991633945,-0.43349292899,-0.684462418209,-0.608887693934,-3.96787900989,1.65149673095,4.87426734719,3.79453728485,7.02813734082,2.22355770834,3.05107675354,1.0461925548,2.60135786863,-0.549605221438,2.19056445151,-4.32233360903,-2.71257390128,-2.89189212842,-0.321527309387,0.299707609073,-1.45064243225,-0.462270466088,-0.737317495801,-0.00494302018273,0.185332434999,1.73551730874,0.384402758642,1.10479446269,0.974302823873,0.4235430242,0.247978723536,0.409531029457,-1.01007580438,-0.526319681206,-1.23280948582,-0.710362091337,0.155048650238,0.0368499906361,0.140736885967,-0.132698881719,-0.183135369706,-0.315058157929,-0.31155296927,-0.0164825020482,0.278351038599,0.102808660557,0.486180228676,0.156535743533,0.150456174754,0.0724875719734,0.309099880358,-0.0464076939735,0.0100490813745,-0.289214156665,-0.318301594449,0.0709142896414,-0.179151854052,-0.129762279001,0.0312462105463],[-32608.0508105,982.537464788,276.650187646,-847.481750749,-522.098597491,761.716393755,504.333549094,-72.4555750883,-279.961045662,315.089537657,82.7608042763,-861.066899164,-561.24542407,444.926706596,-279.607018425,-449.815808716,53.3356397882,29.6048724575,-263.982326775,-56.4506928099,90.414457494,184.680324865,-203.705474397,39.3320591463,-26.2162271967,96.4283599194,-30.6258229438,39.4686241698,63.2722803518,128.897480372,93.6714488162,-76.5253953706,95.1529682653,-125.350751769,89.7302692469,-23.4912660133,41.9697893641,4.62235890857,30.4062894497,31.8372767878,34.6408384737,22.6803158776,-4.63309623489,20.8196173939,-41.5874487754,44.6467893068,26.749849836,21.2231159741,-3.54383002916,6.78248957547,-0.595048243959,14.135081602,17.1058434912,9.32912419047,13.825788801,9.1191152601,7.6151445527,-8.8089874868,8.96657424408,4.62674193955,5.28387662432,-8.49066971117,-0.570660202441,-0.753099628518,-0.556552784751,-3.96625105853,1.67849176547,5.03390497896,3.79465573183,7.0191295043,2.28496005998,3.10377924874,1.10035404125,2.67723912395,-0.585683280053,2.25704642952,-4.29454872721,-2.7503563872,-2.8406593623,-0.302542055718,0.266425691885,-1.4657682861,-0.465945889685,-0.732172494067,0.0356683991986,0.178750797405,1.74783461,0.401099876215,1.12052260538,1.00571765692,0.445087532788,0.267109318255,0.439612372037,-1.0093817007,-0.532989465655,-1.22631021511,-0.706320672353,0.149933112425,0.0284611440886,0.135657276176,-0.140915235032,-0.189109775832,-0.312026083475,-0.307047861041,-0.0179159847435,0.290132101603,0.104824264434,0.494986093802,0.163802320245,0.156565696265,0.0814099392175,0.31606017499,-0.0461120257282,0.0100986169175,-0.287300896933,-0.318836007474,0.0690219834639,-0.182866359904,-0.127881260251,0.0284601123462],[-32642.3867869,971.301896347,272.688242879,-870.15584123,-529.169534586,754.762095524,490.959390738,-75.3521496637,-285.002859796,317.954487986,79.6838539748,-864.903408173,-565.750194376,436.69330455,-289.418652649,-446.766609183,48.9885542,36.2624268521,-259.086676701,-65.5719103176,89.5532135264,188.076516453,-196.819941248,39.4879787335,-23.1891965895,98.5039603645,-30.5486654905,40.4634528114,59.7834695867,131.457686165,94.5561317118,-74.4871219735,97.4986256444,-124.181973834,90.291328446,-23.273023252,42.9219455018,4.69894464472,30.2792738909,31.2277780619,36.0329096848,22.3514347173,-4.47604453195,21.4224630393,-41.4012248858,45.4779710695,25.9184304341,21.0272868807,-3.61600658288,7.130109681,-0.379776733429,14.1294376131,17.3453903447,9.4158190799,13.6775714471,9.13359088716,7.77672003967,-8.773145331,9.25173421665,4.33703576703,5.22523713404,-8.34979680644,-0.704656737556,-0.81896996183,-0.50247760785,-3.96582301538,1.69823132064,5.18403284378,3.79240399226,7.00590010201,2.33769550124,3.15609243735,1.14584946313,2.74370382312,-0.624014410911,2.3124789872,-4.26409473831,-2.78964690603,-2.78747470259,-0.285729107032,0.234504328285,-1.47913769091,-0.46895287633,-0.727901966099,0.0740068525388,0.172254982319,1.7575652415,0.416275618739,1.13430212945,1.03447245945,0.46488120874,0.285112941455,0.465266766784,-1.0072924592,-0.541627631495,-1.21849661908,-0.702491990356,0.144840761968,0.0203518342788,0.130740761934,-0.148470617946,-0.194740546473,-0.30882167307,-0.303062411349,-0.0189245215512,0.301038727479,0.106861527386,0.503061643877,0.17072746139,0.162180976564,0.0897928856468,0.321838001747,-0.0458486070186,0.00924707420407,-0.284861778883,-0.31958320183,0.0672657950626,-0.186431335959,-0.12595001577,0.0255951073695],[-32674.5034304,958.341868932,267.612225716,-892.617944414,-536.599717721,749.404862404,477.220221064,-79.4767693085,-290.417581111,321.949460211,76.6877183296,-868.522730105,-569.444753146,429.568734614,-299.87159148,-443.507545773,44.8311908934,42.8821810753,-253.799032228,-74.1941740142,88.6334549402,191.5404974,-190.070618495,39.8200186958,-20.2625926525,100.562523742,-30.637760654,41.5084009498,56.5637666318,133.800381871,95.4967208002,-72.5266564245,99.8205038563,-122.995247389,90.8845417082,-23.0451887843,43.805795993,4.75718143212,30.1262785377,30.6630366628,37.333129866,22.0849960796,-4.40467578329,22.0213987486,-41.2040854132,46.2628658259,25.0720677381,20.8131147826,-3.67907653306,7.45655293967,-0.179371039132,14.1096163871,17.5700597237,9.481441061,13.5354687147,9.12528042108,7.94936209146,-8.74754915797,9.51559957693,4.0403601375,5.14549093104,-8.20844311273,-0.83494701261,-0.881585109848,-0.44732390042,-3.96547519089,1.71020884623,5.32419916142,3.78731662607,6.98905422633,2.38190692232,3.20792754076,1.18269147152,2.80037089004,-0.664987191215,2.35707756732,-4.23114386171,-2.82999272714,-2.73216113799,-0.270887869074,0.204039452627,-1.49082259489,-0.470993013249,-0.724520714476,0.109955412321,0.165588641288,1.76475984434,0.429963857764,1.14594467056,1.06057356388,0.48288006089,0.301701574365,0.486540223334,-1.0040331034,-0.552124743401,-1.20936435131,-0.698886221889,0.139632957585,0.0125903678321,0.125958680775,-0.155327860436,-0.199979594471,-0.305463863879,-0.299643109869,-0.0195913618944,0.31104565345,0.108914974233,0.510303271729,0.17733135767,0.167313449824,0.0975597065848,0.32650648687,-0.0456663802266,0.00757672949761,-0.281905413824,-0.320545318523,0.0655997759766,-0.189847017042,-0.123973616508,0.0226743952539],[-32706.1151116,943.624708981,262.290094973,-915.184256791,-544.324719759,744.973349979,461.93115429,-84.8568254748,-296.16998924,327.087210757,73.3746355877,-871.985455044,-572.106362419,423.635050743,-310.556994217,-440.017137256,40.8686084776,49.3193734781,-248.100927402,-82.2495183336,87.5995672371,195.156734854,-183.471585653,40.2675866573,-17.4393357186,102.596417285,-30.9265951461,42.6263096807,53.6281504237,135.897981174,96.4969140792,-70.6391469184,102.08561967,-121.80543956,91.5175474276,-22.8030886005,44.6167967413,4.79544004235,29.9571462886,30.1481159668,38.5310906598,21.8832281389,-4.42044936316,22.6191758919,-41.0056643947,47.0032719659,24.2117039168,20.5865142689,-3.73171362635,7.75996278361,0.0062637473086,14.076036523,17.779469483,9.52422572347,13.4005519672,9.09437587664,8.1344969812,-8.73345753903,9.75582031668,3.73601442004,5.0453714956,-8.06775411752,-0.960995505878,-0.940456764275,-0.391753399653,-3.96408789549,1.71391779201,5.45395215164,3.77892819318,6.96919696964,2.41773721343,3.25919578036,1.21089271751,2.84685924859,-0.708990198172,2.39105761263,-4.19586831678,-2.87094111989,-2.67454165722,-0.257817747585,0.175126999266,-1.50089494627,-0.471767887663,-0.722043541779,0.143397151028,0.158495425857,1.76946905962,0.442198464842,1.15526186439,1.08402730263,0.499040098074,0.316587198212,0.50347875132,-0.999828656818,-0.564371366049,-1.1989090654,-0.695513543496,0.134171057991,0.00524505137439,0.121282370232,-0.161449792479,-0.204778832666,-0.301971593063,-0.296836446276,-0.0199997551965,0.320127616738,0.110979129795,0.51660737019,0.183634199786,0.171974550218,0.104633697355,0.3301387566,-0.0456142877341,0.00516985906166,-0.278440413065,-0.321724498558,0.0639779777451,-0.193113637975,-0.121957133413,0.0197211756376],[-32738.9362014,927.117742929,257.589809463,-938.170974854,-552.280113568,740.796213834,443.907304631,-91.5197096147,-302.224863817,333.380496045,69.3468439962,-875.352173074,-573.512284232,418.974306891,-321.066020162,-436.273902399,37.1058655617,55.4292424118,-241.973896271,-89.6699777102,86.3959359186,199.009695966,-177.036922236,40.7700902423,-14.7223461211,104.598008226,-31.4486556787,43.8400200995,50.991599899,137.722897758,97.5604095471,-68.8197416502,104.260989855,-120.627417479,92.1979839983,-22.5420486909,45.3504036503,4.812091247,29.7817200421,29.6880793501,39.6163837086,21.7483590694,-4.52482464578,23.2185458393,-40.8155958671,47.7009878792,23.3382811387,20.353399929,-3.7725916094,8.03848264494,0.177222534267,14.0291166197,17.9732374773,9.542408657,13.2738925681,9.04106926864,8.33355098204,-8.7321290455,9.97004642764,3.42329798373,4.92561230798,-7.92887530828,-1.08226669563,-0.995096616815,-0.336427842737,-3.96054143963,1.70885160775,5.5728400342,3.76677325354,6.94693342431,2.44532926477,3.30980837753,1.23046585218,2.88278782266,-0.756412008985,2.41463456588,-4.15844032292,-2.91203935365,-2.61443924899,-0.246318148308,0.147862902558,-1.50942669323,-0.470979086798,-0.720485250588,0.174215141143,0.150718987573,1.77174352843,0.453013311523,1.16206534661,1.10484000813,0.513317329127,0.329481794223,0.516128360376,-0.994904142967,-0.578258064116,-1.18712641495,-0.692384131721,0.128316421904,-0.00161580846878,0.116683167841,-0.166799244052,-0.2090901739,-0.298363797785,-0.294688910247,-0.0202329508808,0.328259354567,0.113048518892,0.521870332091,0.18965617844,0.176175711921,0.110938153281,0.332807937179,-0.0457412719227,0.00210873915971,-0.274475387915,-0.323122882942,0.0623544519072,-0.196231433581,-0.119905637434,0.0167586481583],[-32774.2512169,908.84292288,254.085588631,-961.745605428,-560.24205041,736.304529943,422.315731331,-99.3779928121,-308.519290125,340.840969441,64.3385319949,-878.687467665,-573.511313123,415.584850746,-331.051876785,-432.260501873,33.5452920836,61.0990463182,-235.406550884,-96.4026698258,84.9621060431,203.165385986,-170.757973143,41.2670468291,-12.1153661678,106.556212409,-32.2296570848,45.1652800825,48.6633323449,139.253415729,98.6847944616,-67.0577698653,106.318808206,-119.474530162,92.9340708103,-22.2587956115,46.0024493159,4.80487515719,29.6076115453,29.2864653475,40.5812691344,21.6813442323,-4.71689623942,23.8213643578,-40.6410324652,48.3585250923,22.4523824245,20.1205012708,-3.8001163749,8.29053621827,0.333735468379,13.969057566,18.1512712133,9.53467393577,13.1565252173,8.96553022939,8.54802159821,-8.74439887028,10.1570474988,3.1019469287,4.78756599688,-7.79266124913,-1.1984807176,-1.04494814458,-0.281888844032,-3.95381121776,1.69454597815,5.68046273347,3.75035593439,6.92282599072,2.46476543862,3.35980138571,1.24164646014,2.90808939357,-0.807432805691,2.42818585124,-4.11903123683,-2.95291311288,-2.55175523035,-0.236134212863,0.122368791948,-1.51643624051,-0.46834177322,-0.719881297013,0.202288733142,0.141991431101,1.77168280447,0.462426506882,1.16621793783,1.12302796676,0.525738177128,0.340200196237,0.524583497143,-0.989437186524,-0.593632609595,-1.17403075587,-0.689479659215,0.121933005811,-0.00793907852485,0.112151959821,-0.171334766132,-0.212872404247,-0.294656009501,-0.293226999657,-0.020380597665,0.335424277129,0.115107890472,0.525998905588,0.195407559067,0.179936530359,0.116424947056,0.334588551587,-0.0460917346344,-0.00152150751928,-0.27002904213,-0.324731443863,0.0606817772276,-0.199196330891,-0.117830043476,0.0138106705974],[-32811.6252602,889.040703599,251.176694445,-985.480896669,-567.348995151,731.33905585,397.731273734,-107.884964678,-314.87957604,349.475872073,58.6116887942,-882.071895843,-572.238373629,413.130204928,-340.415964233,-427.976163951,30.1783032961,66.344124003,-228.415815315,-102.455045354,83.2182608946,207.61596258,-164.53514482,41.6984128138,-9.62542606534,108.446140119,-33.2642266819,46.5894646268,46.6295184503,140.4913009,99.8432131188,-65.3192850117,108.251976628,-118.354054172,93.7363512373,-21.95565818,46.5702731037,4.76900924222,29.4335079398,28.940713128,41.428680978,21.6780477348,-4.98629968846,24.4259048019,-40.4792012156,48.9812476785,21.5531542019,19.8978074776,-3.81162239976,8.51566824819,0.47657364933,13.8951894105,18.3146368049,9.50149957201,13.0493379612,8.86783886137,8.77969125841,-8.76940869247,10.3200715078,2.77344427936,4.6350617847,-7.65880281075,-1.31038033728,-1.08918196634,-0.228197526573,-3.94325296047,1.67070552757,5.77662699228,3.72905863227,6.89726630123,2.47588598545,3.40971018646,1.24556186002,2.92395217237,-0.86139918965,2.43273681842,-4.07780896443,-2.99350174238,-2.48670423168,-0.22679402637,0.0988690772449,-1.52172781888,-0.463625410874,-0.720349751276,0.227482389478,0.131998673578,1.76958209189,0.470393110084,1.16778719829,1.13864728078,0.536610722138,0.348968648541,0.529132356278,-0.983415816813,-0.61017160375,-1.15971125343,-0.686667783053,0.114895157293,-0.0137323194338,0.10775782713,-0.174997793702,-0.216111802715,-0.290850136838,-0.292397245189,-0.0205579414436,0.341640486495,0.117102890001,0.528941260135,0.200858906036,0.18330924598,0.121160260851,0.335560709767,-0.0466919155513,-0.00562437258448,-0.265160449255,-0.326496478244,0.0589066413739,-0.201987025767,-0.115764642274,0.0109037333094],[-32850.19358,868.006165518,247.968649506,-1008.80090706,-572.579991052,725.842969491,371.080716216,-116.379094456,-321.104335091,359.291342008,52.5602537974,-885.590008018,-569.899922787,411.190185785,-349.121730826,-423.424258808,26.9935857808,71.2118343627,-221.025691641,-107.849638214,81.0797433137,212.335121515,-158.2461091,42.0042543466,-7.26037799538,110.239450255,-34.5392199085,48.0928555102,44.8705672547,141.444189507,101.002699074,-63.564521588,110.058574051,-117.271747962,94.6159496486,-21.63636578,47.0515910718,4.69908031092,29.255865216,28.6467370193,42.1642217597,21.7330608713,-5.32030577134,25.0295449228,-40.3248477424,49.5752328477,20.6393837508,19.6961226513,-3.80417630691,8.71370374177,0.606643415063,13.8066244916,18.4646900181,9.44381206244,12.9531821827,8.7480528846,9.03041362246,-8.80587681272,10.4634860298,2.43970979117,4.47254804224,-7.52669994047,-1.41896397765,-1.12690048626,-0.175294890565,-3.92831748236,1.63707711527,5.86119125804,3.70223331105,6.8706032962,2.47847062781,3.46019499335,1.24356230398,2.93187822752,-0.917449367051,2.42947479856,-4.03494054898,-3.03382300204,-2.41957921167,-0.217771409823,0.0776138633493,-1.52505211562,-0.456613039047,-0.722029337129,0.249656850597,0.120415085259,1.76578550743,0.476852417818,1.16689187318,1.15176400643,0.546313458461,0.356116248032,0.530111569443,-0.97678066432,-0.627508855161,-1.14427577525,-0.68378765642,0.107079821699,-0.0190182652889,0.103589399411,-0.177725482746,-0.218801521547,-0.286944682713,-0.292126185724,-0.0208866274055,0.346934757709,0.118969387072,0.530655920515,0.205970858449,0.186354260485,0.125238854204,0.3358059184,-0.0475635138156,-0.0101005012196,-0.259938775282,-0.328353114191,0.0569742592393,-0.20457790628,-0.113749568518,0.00806498479176],[-32889.0914248,846.034389069,243.566976412,-1031.1296951,-574.914081376,719.759448799,343.290843149,-124.198851389,-326.992180804,370.293517316,46.5781664076,-889.326354603,-566.702417633,409.34460967,-357.132624882,-418.60815662,23.9798261192,75.7495362938,-213.260181941,-112.608982329,78.4618961411,217.29655856,-151.768537816,42.1246375775,-5.02807413941,111.907801712,-36.0414922032,49.6557345103,43.3668877977,142.119717788,102.130285884,-61.753714093,111.736679406,-116.233369982,95.5839904137,-21.3046477949,47.4441192784,4.58967517214,29.0711393644,28.4004513488,42.793494,21.8409749357,-5.70618526648,25.6296624719,-40.17271767,50.14655781,19.7098583509,19.526250894,-3.77484471929,8.88446770609,0.724851103525,13.7024751477,18.6027866189,9.36253790378,12.8689092646,8.60623001909,9.30204235014,-8.85252153169,10.5916586397,2.1026632196,4.30447314032,-7.39575258563,-1.52523006164,-1.15720610851,-0.123121936213,-3.90845559803,1.59340760052,5.93401397818,3.66923193459,6.84318591599,2.47229908825,3.51191602,1.23699804417,2.93336962752,-0.974721544085,2.41958712278,-3.99059303371,-3.07389465174,-2.35067312902,-0.208540184219,0.0588532551609,-1.52615981801,-0.447087697028,-0.725058778324,0.268672856943,0.106915036399,1.76063716785,0.481743726775,1.16365070767,1.16244419993,0.555224880403,0.36197209161,0.527857768301,-0.969472359534,-0.645278172411,-1.1278321889,-0.680678432499,0.0983639443822,-0.0238196501832,0.0997353063067,-0.179454989248,-0.220934712983,-0.282938150048,-0.292340360146,-0.0214883007395,0.351333865809,0.120643251278,0.531101411506,0.210704055409,0.189131975573,0.128755486657,0.335405684167,-0.0487282285695,-0.0148505386084,-0.254433186202,-0.33023647981,0.0548298457169,-0.206943360498,-0.111824956898,0.00532157354239],[-32927.4540432,823.420454684,237.077197763,-1051.89131927,-573.330309388,713.03167171,315.288438906,-130.68270472,-332.341726707,382.488536065,41.059366028,-893.36548601,-562.852315204,407.173292932,-364.41209472,-413.531227561,21.1257108931,80.0045886928,-205.143288291,-116.755611619,75.2800622173,222.473969483,-144.980102798,41.9996286569,-2.93636667896,113.422853388,-37.7578990046,51.2583834048,42.0988891187,142.525521978,103.193007104,-59.8470970252,113.284371623,-115.244678683,96.6515979022,-20.9642336083,47.7455737815,4.4353806347,28.8757863752,28.1977704441,43.3221002191,21.9963812221,-6.13120895232,26.2236352004,-40.0175566227,50.7012997753,18.7633652818,19.3989963076,-3.72069425984,9.02778514822,0.832103052659,13.5818537174,18.7302823732,9.25860359276,12.7973705898,8.44242798486,9.59643110127,-8.90806115005,10.7089569125,1.76422432011,4.13528544976,-7.26536069354,-1.63017701223,-1.17920123728,-0.0716196637199,-3.88311812208,1.5394438426,5.99495360013,3.62940646676,6.81536310095,2.45715108931,3.56553347998,1.22721933275,2.92992844084,-1.03235392694,2.40426112219,-3.94493346188,-3.1137344514,-2.28027894242,-0.198574170553,0.0428373575797,-1.52480161335,-0.434832424105,-0.729576798612,0.284391148964,0.0911728972536,1.75448118989,0.485006333643,1.15818244694,1.1707539175,0.563723482269,0.366865276171,0.522707584515,-0.96143153294,-0.663113364079,-1.11048836201,-0.677179264474,0.0886244706934,-0.0281592082098,0.0962841774601,-0.180123469193,-0.222504529266,-0.27882904176,-0.292966307337,-0.0224846066346,0.354864585838,0.122060352214,0.530236257892,0.215019136019,0.191702792947,0.131804917748,0.334441513751,-0.0502077589551,-0.0197751299345,-0.248712848008,-0.332081703207,0.0524186157,-0.209057776493,-0.110030942104,0.00270064805896],[-32964.5780626,800.404010062,227.856912613,-1070.68158057,-567.146291673,705.729941494,287.839652267,-135.424109562,-336.996131098,395.876079168,36.3066278139,-897.750551069,-558.576131276,404.393271204,-370.974432915,-408.191832087,18.4204292181,84.024653281,-196.707244995,-120.317416498,71.4857100533,227.835405495,-137.775917276,41.5841858847,-0.98840000318,114.758344695,-39.6723936869,52.8859589718,41.0501293369,142.668809184,104.159701131,-57.8120368781,114.695362115,-114.312852002,97.8250648941,-20.6192548613,47.953854075,4.23196171817,28.6670683553,28.0350504981,43.7554763628,22.1922818571,-6.58441377402,26.8089192885,-39.8555914807,51.2445262864,17.8007321679,19.3235266374,-3.63997667224,9.14354093463,0.929238073528,13.4438918771,18.8480888863,9.13300319839,12.7389071119,8.25667671547,9.91451285568,-8.97120861242,10.8190918069,1.4263335396,3.96892751804,-7.13474971605,-1.73462044384,-1.19218703192,-0.0207594138873,-3.85196315949,1.47500758249,6.04393612451,3.58236000369,6.78736661246,2.43290699888,3.62164509751,1.21542201571,2.9228849555,-1.08943238101,2.38455280479,-3.8979777302,-3.15336287916,-2.20866996606,-0.187440362353,0.0297672886012,-1.52077204025,-0.41972528336,-0.735698276593,0.296704393499,0.0729867078428,1.7475954032,0.486601755996,1.15065802835,1.17680164278,0.572142061516,0.37110136642,0.514982528024,-0.952616370606,-0.680719788387,-1.09235007579,-0.673150059462,0.0777714043967,-0.0320535245899,0.0933116793869,-0.179680627588,-0.223509785941,-0.274615092683,-0.29393913824,-0.0239712457986,0.357555103422,0.123177752426,0.528050338385,0.218880191424,0.194124084361,0.134475927422,0.332980153895,-0.0520116538051,-0.0247918021621,-0.242836305761,-0.333839327896,0.0496959699333,-0.2109063658,-0.108396201598,0.000226048362173],[-33000.4056259,777.00297197,216.272025838,-1087.78325013,-557.033938108,698.433062757,261.068089639,-139.036464501,-340.976731362,410.429998913,32.2580699288,-902.359092277,-554.180616579,401.270457251,-377.037309077,-402.568291775,15.8551803462,87.8586030792,-188.017215256,-123.343713351,67.174810841,233.326339578,-130.120860059,40.8928361602,0.831512668309,115.89633711,-41.7573213668,54.5431179911,40.2167628894,142.555069981,105.006425737,-55.644428124,115.945892228,-113.450745808,99.0913578121,-20.2754522261,48.0675933954,3.97989628495,28.4454718779,27.9104151644,44.0983920782,22.4153222976,-7.06190134379,27.3832846311,-39.6889741476,51.777266217,16.8309480111,19.3024642018,-3.53568418311,9.23185936927,1.01682486966,13.2877986567,18.9553411212,8.98700107884,12.6918180664,8.04889499869,10.2535378733,-9.0406554393,10.9231478175,1.09101409075,3.80731859944,-7.00244712307,-1.83864473674,-1.19625967261,0.0293661101009,-3.81547797672,1.40022008805,6.08115776473,3.52870017057,6.75895949605,2.39984976623,3.68059863932,1.20218431445,2.91288233774,-1.14483340845,2.36099288597,-3.84913714933,-3.19281128633,-2.13604093596,-0.175078443279,0.0196482186033,-1.51404104264,-0.402024433054,-0.743442710254,0.305632962971,0.0526491872432,1.73999248907,0.486580394942,1.14145715793,1.18086556896,0.580630628208,0.374891798281,0.504943621868,-0.943055280927,-0.698089002113,-1.07351476601,-0.668533740326,0.0658469829069,-0.0354945890567,0.0908416260938,-0.178126365539,-0.22397195177,-0.270290965304,-0.295228252038,-0.0259401410153,0.35943924652,0.12403728628,0.524658947437,0.222265120945,0.196441101786,0.136833377242,0.331029311592,-0.0541008607138,-0.029885609377,-0.236819620799,-0.335521559019,0.0466580525672,-0.212517633824,-0.106903583923,-0.00209161943538],[-33035.040255,753.179824441,202.940518767,-1103.65084157,-544.003731894,691.84696544,234.936721834,-142.388153995,-344.349409654,426.117690429,28.7606462883,-907.027250546,-549.992580579,398.207983117,-382.869237071,-396.633918483,13.4216660638,91.5556139331,-179.146594501,-125.889175056,62.4794614426,238.886600155,-121.997251354,39.9549985323,2.54376590826,116.820972623,-43.9821250967,56.239392243,39.5980932933,142.189365814,105.711043532,-53.3472972304,117.00783579,-112.672635457,100.43261149,-19.9389686329,48.0856084149,3.6808404082,28.2122896327,27.8224299622,44.3554504374,22.6505588326,-7.56153944056,27.9445795524,-39.521337783,52.2995387736,15.865042158,19.3367949624,-3.41199413984,9.29292461549,1.0953646177,13.112802424,19.05072988,8.82192916456,12.6538922598,7.81897383585,10.609835734,-9.11508779516,11.0215528223,0.760309877656,3.65187212488,-6.86680588905,-1.94215146269,-1.1917140947,0.0786338644649,-3.77435713059,1.31527750886,6.1068822874,3.46928572488,6.72978761823,2.35836298598,3.74267938273,1.18793004423,2.90039197331,-1.19738117063,2.33398075798,-3.79767188341,-3.23211374247,-2.06256694364,-0.161521269521,0.0124363310595,-1.50462241579,-0.382083055241,-0.752805752431,0.311229156197,0.0305767242962,1.73161884168,0.485014872473,1.13101173392,1.18326631662,0.589293495564,0.378424475482,0.492836767367,-0.932794227879,-0.715284111675,-1.05407778203,-0.66329398386,0.0529265020516,-0.0384682424714,0.0888848684599,-0.175473133179,-0.223918158822,-0.265850554025,-0.296811619971,-0.0283572705877,0.360552253678,0.124701981095,0.520208733434,0.225155275945,0.198696067245,0.138936149177,0.328581933898,-0.0564241769657,-0.0350584874455,-0.230668233529,-0.337156017125,0.0433111936039,-0.213930909438,-0.105524480391,-0.00424505769812],[-33068.5854719,728.89705151,188.480372731,-1118.73886852,-529.066156229,686.677579485,209.408519668,-146.347562502,-347.180048129,442.906548849,25.6613108082,-911.591166793,-546.338832744,395.608980848,-388.738730763,-390.362024069,11.1115881572,95.1648616883,-170.168778159,-128.008474493,57.5317587203,244.456015652,-113.387411365,38.8000920499,4.16875428943,117.516393227,-46.316247929,57.9843135078,39.1934240652,141.576758127,106.251417129,-50.9236706643,117.853066629,-111.992796304,101.83096076,-19.6159470114,48.0067158058,3.33645016104,27.9688143092,27.7696604104,44.531254513,22.8830477515,-8.08119584329,28.490652376,-39.3563155464,52.8113631627,14.914043955,19.4275048811,-3.27308388978,9.32692083662,1.16535849429,12.918131547,19.1329459652,8.639119386,12.6229184983,7.56680422827,10.9797360178,-9.19319184448,11.1147346995,0.436264804439,3.50400152533,-6.7261789884,-2.04504219345,-1.17884523356,0.126920805425,-3.72929517794,1.22037599449,6.12137345914,3.40497542407,6.69949684556,2.30883025275,3.80817260508,1.17308302028,2.88588524799,-1.24589982889,2.30391581308,-3.74284209656,-3.27130431713,-1.9884230806,-0.146801697271,0.0080878094432,-1.49252995498,-0.360254331977,-0.76378305596,0.313545271995,0.00718570784289,1.72242085522,0.481977810584,1.11975365454,1.18432450637,0.5982349768,0.381887301754,0.478907865838,-0.921879175438,-0.73236822349,-1.03413447323,-0.657394466862,0.0390852576585,-0.0409603256953,0.0874522573646,-0.171733380635,-0.223375539164,-0.261287753245,-0.298667213282,-0.0311886128187,0.360929363439,0.12523486419,0.51484634476,0.227532007789,0.200931202764,0.140843125193,0.325630967867,-0.0589303998455,-0.0403123722339,-0.224387584358,-0.338770322766,0.0396617230454,-0.215185521511,-0.104230282316,-0.00622696879047],[-33101.1447982,704.117137211,173.50956906,-1133.50184462,-513.231694315,683.630834831,184.446453952,-151.783074478,-349.534528944,460.763969303,22.8070174041,-915.88698193,-543.546182543,393.876582491,-394.914304019,-383.725920389,8.91664841251,98.7355221904,-161.157161658,-129.756284539,52.4637995363,249.974414493,-104.273660299,37.4575357622,5.72687238458,117.966740914,-48.7291329158,59.7874135657,39.0020587222,140.722308366,106.605409141,-48.3765748932,118.453458574,-111.425503704,103.268540457,-19.3125302918,47.8297322403,2.94838161661,27.7163385971,27.750672028,44.6304073771,23.0978453435,-8.61873833093,29.0193514261,-39.1975405972,53.3127585909,13.9889827488,19.5755799194,-3.12313078031,9.334032196,1.22730767609,12.7030143934,19.2006801789,8.43990367361,12.5966855881,7.29227717726,11.3595683047,-9.27365375172,11.2031213275,0.120922775205,3.36512023171,-6.57891939557,-2.14721850075,-1.15794802455,0.1741038892,-3.68098667559,1.11571169452,6.12489504653,3.33662802562,6.66773304457,2.25163516116,3.8773635837,1.15806705785,2.86983354756,-1.28921354461,2.27119744351,-3.68390795292,-3.3104170799,-1.91378443836,-0.130952582721,0.00655883722793,-1.47777745546,-0.336891445316,-0.776370273675,0.312633609181,-0.0171074732754,1.71234492387,0.477541831265,1.10811481802,1.1843607588,0.607559385132,0.385468180825,0.463402818598,-0.910356087581,-0.749404443977,-1.013780189,-0.650798866128,0.0243985455549,-0.0429566795895,0.0865546436873,-0.16691955804,-0.222371224862,-0.256596457367,-0.300773003214,-0.0344001460113,0.360605814349,0.125698962883,0.508718429802,0.229376667841,0.203188730367,0.142613187258,0.322169360556,-0.061568326638,-0.0456491996085,-0.217983113695,-0.340392096491,0.0357159708936,-0.216320798917,-0.102992381011,-0.00803005507686],[-33132.7919901,678.922984554,158.541142268,-1148.29429835,-497.256664105,683.217629123,159.992717422,-159.354722675,-351.478511084,479.61151083,20.0805929977,-919.79047151,-541.826588182,393.329855019,-401.553894695,-376.726608612,6.80994763593,102.313766484,-152.177495054,-131.176881831,47.3914389348,255.416235129,-94.6508688075,35.9517450532,7.23503627437,118.157300684,-51.1969861925,61.6565579794,39.023942016,139.635808698,106.76610494,-45.7114018909,118.786435565,-110.982634205,104.727298909,-19.0328682317,47.5539896535,2.51740034514,27.4557328056,27.7643722273,44.6582401962,23.2821071993,-9.1737022131,29.5282438109,-39.0488109893,53.803483238,13.0984969787,19.7813374768,-2.96552357947,9.31468773673,1.28168934833,12.4671638983,19.2523866615,8.22554113598,12.572493221,6.99512369194,11.7459110626,-9.35531466666,11.2870674791,-0.184146622148,3.23636981438,-6.423875153,-2.24847641174,-1.12926664926,0.220182779351,-3.63011608267,1.00168825494,6.11760511499,3.26504151315,6.63401085188,2.18715801991,3.95044208103,1.1431166905,2.85260670443,-1.32645436789,2.23624801773,-3.62039255098,-3.34940783762,-1.8387761466,-0.11403329587,0.00779086389198,-1.46040202762,-0.312319850868,-0.790516806873,0.308568455659,-0.0419079235359,1.70129903224,0.471785635269,1.09644429629,1.18362686615,0.617309358079,0.389322298993,0.446556795059,-0.898304409797,-0.766445412554,-0.993087377779,-0.643484961387,0.00892747021769,-0.044467288413,0.0861815017949,-0.161060658847,-0.220932677941,-0.251765728679,-0.303097116784,-0.0379464496833,0.359603987866,0.126159318168,0.501953881993,0.230680640713,0.20549221798,0.144292957962,0.318194036413,-0.0643020632782,-0.0510675478721,-0.211456892726,-0.342038440809,0.0314781346924,-0.217379598983,-0.101790713902,-0.0096511433033],[-33163.4817403,653.879172456,143.668339603,-1163.07081761,-480.880722566,685.168730812,135.906390494,-168.889133023,-353.076760857,499.187388107,17.5083565358,-923.335949639,-540.932602818,393.951605116,-408.373136603,-369.475847142,4.69018271314,105.933746408,-143.264946921,-132.27295804,42.3655646877,260.894356119,-84.5641093296,34.2871206469,8.69624807118,118.077929578,-53.7230662254,63.5929474409,39.2615836384,138.345974194,106.787480951,-42.9430056584,118.851621994,-110.666469123,106.188438431,-18.7731378991,47.1808810311,2.04070990517,27.1861777218,27.8110359939,44.6229965122,23.4313861152,-9.75229292225,30.0137717775,-38.9145843532,54.2822511782,12.2416614556,20.0424207045,-2.80049673807,9.270296021,1.32888473071,12.2122312647,19.2855729048,7.99699959424,12.5456846308,6.67443481249,12.1363383122,-9.43763568034,11.3666355065,-0.479271064576,3.11780440132,-6.26187457514,-2.34818977507,-1.09284227419,0.265647968798,-3.57732746741,0.879539307441,6.09923892506,3.19077077501,6.59731998447,2.11576599409,4.02721579986,1.12770932498,2.83416833759,-1.35798590381,2.19958180897,-3.55287072663,-3.38791934632,-1.76332348773,-0.0962092619462,0.011666402933,-1.44053404226,-0.286754098458,-0.805987050693,0.301512055669,-0.0669067206893,1.6890375267,0.464812238382,1.08475985618,1.18209930732,0.627280830356,0.393473972824,0.428562036998,-0.885937513626,-0.78350190064,-0.972036884307,-0.635486944112,-0.00732362928041,-0.0455987100151,0.0862368000056,-0.154251849802,-0.219088680253,-0.246765301024,-0.305568304118,-0.041736508213,0.357894837105,0.126689025734,0.494610574965,0.231475444015,0.207790617128,0.145880022383,0.313717829459,-0.0671569503023,-0.0565525650741,-0.204797515764,-0.34368438607,0.0269438821518,-0.218418892871,-0.100639402872,-0.0111035577422],[-33193.1389756,629.670698809,128.879461498,-1177.68600513,-463.589361417,689.019876053,112.025775509,-180.004579746,-354.393821399,519.183979716,15.1524999711,-926.597365061,-540.501928349,395.640574395,-414.977087545,-362.113083697,2.43744954968,109.626609002,-134.447040463,-133.036808594,37.4208227489,266.556266047,-74.0710047504,32.4630596026,10.1100313953,117.719627648,-56.3173945639,65.5961164246,39.7181345161,136.886250648,106.73873636,-40.0886057035,118.654192362,-110.476890967,107.632974832,-18.5275231896,46.7123146215,1.51462335235,26.9064317522,27.8912802067,44.533647961,23.5433341891,-10.3623834215,30.4720963573,-38.7994832139,54.7475154592,11.4151600836,20.3558041911,-2.62749612757,9.20251049073,1.3692510515,11.9403522628,19.2975097387,7.75517404766,12.5111139364,6.3291415869,12.5286729624,-9.52023286908,11.4418146563,-0.765252545248,3.0092062599,-6.09424104446,-2.44562689479,-1.04866531208,0.311112657802,-3.52325480034,0.75070598013,6.06942603607,3.11430992573,6.55651892941,2.03782296288,4.10739692809,1.11113308635,2.81438051267,-1.38447964619,2.16173606668,-3.48218025013,-3.42551609934,-1.68730178234,-0.0776724199849,0.0180532338535,-1.4183271853,-0.260381011468,-0.822499148733,0.29164864254,-0.0918164358047,1.67527634403,0.456730735148,1.07299643822,1.17968573287,0.637208060982,0.397914801455,0.409600054287,-0.87350225212,-0.800574212656,-0.950586652387,-0.626853108707,-0.0243646052174,-0.046481645643,0.0866031301252,-0.146604840975,-0.216868343609,-0.241560076134,-0.308105471119,-0.0456679071937,0.355436458097,0.127363194942,0.486728627397,0.231802628606,0.210014225241,0.14735970622,0.308757551112,-0.0701736368973,-0.0620860417002,-0.1979902079,-0.345294444582,0.0221067485235,-0.219499180196,-0.0995611159166,-0.0124047470476],[-33221.6886228,606.982561507,114.162808386,-1191.99446366,-444.868072381,694.306800999,88.1891748054,-192.319337067,-355.494235848,539.293664241,13.0752152563,-929.648666522,-540.172266673,398.295504469,-420.970805323,-354.77776599,-0.0681559488648,113.423501304,-125.751298883,-133.460728923,32.5918590722,272.549453499,-63.2291779552,30.4789589794,11.4759098669,117.073394945,-58.9899927573,67.6655994051,40.3967455757,135.290083852,106.689070352,-37.1654215338,118.199321173,-110.413782246,109.041923922,-18.2902079991,46.1501986733,0.935453742313,26.6152533034,28.0057217444,44.3991661786,23.6156035189,-11.011846674,30.8993785819,-38.7081300962,55.1977291286,10.6156767663,20.7184625257,-2.44596761947,9.11298458786,1.403145539,11.6536626626,19.285467993,7.50095949553,12.4636352571,5.95817506314,12.9207379218,-9.60272230922,11.5125941756,-1.04289305733,2.91035765749,-5.92229794343,-2.54005607492,-0.996726175665,0.357190046623,-3.46853205199,0.616629401116,6.02779600737,3.03615307981,6.51046617376,1.95369280545,4.19069765359,1.09267609968,2.79310529532,-1.40660708887,2.12324804029,-3.40915889173,-3.46176258998,-1.61058635102,-0.0586147090221,0.026819136156,-1.39393514264,-0.233387413277,-0.839771244592,0.279162449597,-0.116349639951,1.65973142102,0.447650220114,1.06108898296,1.17629379336,0.646825308973,0.402636384018,0.389852356799,-0.861245478334,-0.817662653022,-0.928694625824,-0.617631749578,-0.0422053098712,-0.0472467965439,0.0871630839595,-0.138231342435,-0.214300779819,-0.23611495574,-0.310627523687,-0.0496382322184,0.35218694687,0.128256935156,0.478348157968,0.231703745344,0.212093339746,0.148717335173,0.303330012787,-0.0733927722499,-0.0676497682364,-0.191020194225,-0.346833128654,0.0169602690594,-0.220680960578,-0.098578521033,-0.0135721598734],[-33249.0556089,586.499758442,99.5066806987,-1205.85079595,-424.202347177,700.565241804,64.2348907212,-205.451679211,-356.442547342,559.208820268,11.3386943442,-932.563802764,-539.581319685,401.81513695,-425.959347737,-347.609341737,-2.94653787695,117.355570352,-117.205245383,-133.537014454,27.9133196116,279.02140706,-52.0962518291,28.3342158366,12.7934071064,116.130231518,-61.7508823548,69.8009308568,41.3005677441,133.590919602,106.707682114,-34.1906726569,117.492182929,-110.477025468,110.396301511,-18.0553762232,45.496441435,0.299514130705,26.3114007819,28.154977486,44.228522801,23.6458462024,-11.7085556429,31.2917794827,-38.6451475249,55.6313452339,9.83989540776,21.127370297,-2.25535708525,9.00337175433,1.4309254215,11.3542982343,19.2467184977,7.23525093709,12.3981027119,5.56046628918,13.3103560992,-9.68472007709,11.578963311,-1.312994594,2.82104086148,-5.74736865452,-2.63074561952,-0.937015277681,0.404493335522,-3.41379319289,0.478750698505,5.97397839829,2.95679435178,6.45802020458,1.863739401,4.27683016426,1.07162649003,2.77020475117,-1.42503972567,2.08465497924,-3.33464442169,-3.49622331157,-1.53305251435,-0.0392280680935,0.0378318893429,-1.36751160019,-0.205960127266,-0.857521481869,0.264237710169,-0.140218904198,1.64211869446,0.437679787822,1.04897243093,1.17183113934,0.655866833346,0.40763031965,0.369500454403,-0.849414045319,-0.834767526158,-0.906318748422,-0.60787116113,-0.06085559552,-0.0480248639648,0.0877992533143,-0.129243064252,-0.211415100692,-0.230394841573,-0.313053367726,-0.0535450688806,0.348104399454,0.129445355738,0.469509285359,0.231220345088,0.213958258071,0.149938234942,0.2974520259,-0.0768550055467,-0.0732255351685,-0.183872699832,-0.348264950594,0.0114979790111,-0.222024733633,-0.0977142862169,-0.0146232448738],[-33275.3094267,568.661235781,85.0068704209,-1219.16065886,-401.36586788,707.299487335,40.054140755,-219.073093864,-357.268440885,578.661293812,9.99305317902,-935.393047204,-538.450960508,406.098331535,-429.658097293,-340.715614575,-6.26246994238,121.450483081,-108.822274371,-133.260648861,23.4243585721,286.075904026,-40.726967069,26.0399651069,14.0647929976,114.894997218,-64.5975655404,72.0012913577,42.4342805215,131.821347441,106.846128048,-31.1838794754,116.543348875,-110.666916566,111.680043989,-17.8190510575,44.7548048165,-0.394282794842,25.9953443779,28.3398659051,44.0302605376,23.632090313,-12.4591915404,31.647467153,-38.6136235027,56.0464266661,9.08511446917,21.5787230479,-2.05569291924,8.87508170464,1.45279948274,11.0444385803,19.1794195166,6.95916642135,12.3107118141,5.13547958476,13.6960594521,-9.76594727985,11.6409594691,-1.57614103234,2.74075682735,-5.57071634539,-2.71716949019,-0.869707728575,0.453317158162,-3.35971088403,0.338393831162,5.90784705588,2.87665687684,6.39843141428,1.76832316972,4.3655361602,1.04741441902,2.74565108216,-1.44025607815,2.04624217192,-3.25938484854,-3.52865321211,-1.45458059747,-0.0196815837629,0.0509242265577,-1.33926702533,-0.178295252392,-0.875510464666,0.247045636258,-0.163191484315,1.62224519684,0.426944267813,1.03661272802,1.16623611757,0.664155675907,0.412923664898,0.348648675968,-0.838212223967,-0.851907443752,-0.883404199082,-0.597600978052,-0.080289467513,-0.0489228754082,0.0884144616451,-0.119749448981,-0.208245317676,-0.22437862146,-0.315317337048,-0.0573003763336,0.343172246595,0.130990180187,0.460257264456,0.230391531819,0.215559125647,0.151018633198,0.291134266783,-0.080596907539,-0.0788040140411,-0.176535523893,-0.349558400191,0.00572620069171,-0.223575631009,-0.0969891129117,-0.0155727985959],[-33301.0978334,552.921732777,71.1891357407,-1232.03392569,-377.285077979,713.888037315,15.7498030417,-233.06792255,-357.862168946,597.540800624,9.0401036699,-938.09197194,-536.839747167,411.044420265,-432.22373531,-334.077811826,-9.86020430638,125.721986005,-100.559265071,-132.637368794,19.1821631639,293.641876534,-29.1645356177,23.6542932178,15.3033224784,113.427991086,-67.4774670371,74.2644459004,43.8086777025,130.010531917,107.085393427,-28.17376597,115.38497721,-110.985405168,112.888770063,-17.584612897,43.9364653733,-1.13662581871,25.6744014154,28.5620118553,43.8112063916,23.5738678259,-13.2656685751,31.9726379333,-38.6105079432,56.4394756888,8.35109064161,22.065600137,-1.8493336073,8.72854924365,1.46838272837,10.7264386332,19.0852790499,6.67471619608,12.2030236538,4.68481235656,14.0792161327,-9.84654514788,11.6988126954,-1.83204378511,2.66788126298,-5.39336332456,-2.79962427876,-0.795717429649,0.502681881825,-3.30711254828,0.196414080975,5.83025297801,2.79587987295,6.33251781653,1.66779069602,4.45667539032,1.0200381945,2.71985703545,-1.45196277879,2.00728706251,-3.18376913388,-3.55956905835,-1.37507094368,-5.29327063842e-05,0.065788695507,-1.30963901126,-0.15062598991,-0.893668639098,0.227705354573,-0.185253374883,1.60028234358,0.415631429602,1.02409984158,1.15956985956,0.671870009618,0.418685305965,0.327092626342,-0.827673956517,-0.869174246568,-0.859845097082,-0.586776196166,-0.100337543485,-0.0499531633975,0.0889924590059,-0.109850869122,-0.204845040773,-0.218101127604,-0.317415477111,-0.0608736079721,0.3374752579,0.132899588546,0.450657894971,0.229246622005,0.216925479914,0.151998365501,0.284362871438,-0.084638735235,-0.0844114006328,-0.169006761903,-0.350697877155,-0.000297595340899,-0.225317312472,-0.0964158363496,-0.0164250091599],[-33327.213152,538.489936958,58.6867263974,-1244.63152389,-353.17461132,719.677944177,-8.5223291242,-247.373720256,-358.079125862,615.776523889,8.46958171747,-940.592473741,-534.89040891,416.552853261,-433.923267808,-327.645516732,-13.5288627436,130.180345535,-92.358967912,-131.675599145,15.2484288482,301.604545434,-17.4492872296,21.2470244704,16.5249967505,111.803371964,-70.3254922025,76.5878055811,45.4360816552,128.186781325,107.38882074,-25.1913570164,114.054622878,-111.434854326,114.021019021,-17.3572814368,43.0544533222,-1.91560409328,25.3576010022,28.8232417848,43.5777584399,23.4710866921,-14.128709205,32.2754952257,-38.6312162376,56.8066044088,7.63819517354,22.5803018767,-1.63922015812,8.56396544876,1.47714171951,10.4026971578,18.9668925316,6.3841335588,12.0779407152,4.21059528302,14.4619033416,-9.9267599424,11.7528011948,-2.08019614899,2.60050856436,-5.21627168573,-2.87861223466,-0.716142979915,0.551289307195,-3.25686429898,0.0535495605894,5.74229145027,2.71453157879,6.26148933034,1.56248510532,4.55013711573,0.989638160859,2.69334549452,-1.45967348779,1.96681513417,-3.10809647763,-3.58967807169,-1.29442890079,0.0196030608719,0.0820827975387,-1.27912193265,-0.123194816655,-0.911968911784,0.206322970498,-0.206445255179,1.57649264578,0.403944777698,1.01155474429,1.15192419302,0.679276790228,0.425119586466,0.304550729367,-0.817790603046,-0.886678082635,-0.835522796799,-0.575333151575,-0.120794594141,-0.0511043867113,0.0895372271002,-0.0996454296573,-0.201272779625,-0.211611178305,-0.319359261284,-0.064248590751,0.331123537695,0.135168374998,0.440782112821,0.227812485239,0.218106706316,0.152928169383,0.277117840782,-0.0889966672074,-0.0900827717812,-0.161287083436,-0.351671758677,-0.0065031514675,-0.227218069819,-0.0960053252097,-0.0171814125793],[-33354.4477059,524.574535851,48.1328921306,-1257.11438088,-330.249101745,724.016260357,-32.6064624485,-261.928041969,-357.77470597,633.297646789,8.27122322228,-942.826449376,-532.745674987,422.523080647,-435.023700812,-321.368312536,-17.0575670285,134.835828082,-84.1641333225,-130.383764809,11.6848510863,309.849131574,-5.62155165891,18.8879831656,17.7458170153,110.095298694,-73.0765463941,78.968781496,47.3288147477,126.378403964,107.719752477,-22.2676774902,112.589840819,-112.017627092,115.075330151,-17.1422763719,42.1217988802,-2.71930677094,25.0539722458,29.1253821421,43.3363147591,23.3236548621,-15.0490358878,32.5642424324,-38.6711637774,57.1439249331,6.94679931344,23.1151285796,-1.42829358043,8.38152139739,1.47854301725,10.0756129191,18.8268553959,6.089651807,11.9383654826,3.71495904258,14.8461982798,-10.0068379246,11.8032031724,-2.32009142065,2.53673312748,-5.04040352262,-2.95463560727,-0.632082978389,0.597841234955,-3.20983224949,-0.0894616173518,5.64505775825,2.63268023299,6.18655587473,1.45274952303,4.64581059755,0.956354662502,2.66663934284,-1.46290186538,1.92385187003,-3.03266607966,-3.61968747357,-1.21255981665,0.039231572768,0.0994640340004,-1.24821016416,-0.0962442094569,-0.930384189341,0.183004589419,-0.226807804485,1.55113861457,0.39208781661,0.999098408835,1.14339094567,0.686642973489,0.432430850017,0.280741408887,-0.80855352363,-0.904529099984,-0.810318652604,-0.563208180385,-0.141455390187,-0.0523652041284,0.0900527476317,-0.089231235573,-0.19758704387,-0.204957591862,-0.321160162937,-0.0674091516251,0.324227190305,0.137791333721,0.430700853927,0.226115991112,0.219152190298,0.153858782375,0.269379175731,-0.093686882029,-0.0958532043235,-0.15337715807,-0.352468421949,-0.0128202100689,-0.229246194847,-0.0957684481713,-0.0178435448675],[-33383.593818,510.384216984,40.1608826799,-1269.6434241,-309.723183098,726.25003829,-56.3468036368,-276.668442676,-356.804303606,650.03335251,8.43476408493,-944.725795615,-530.548274647,428.854552548,-435.792040342,-315.195782481,-20.2354389359,139.698700056,-75.9175117313,-128.77029068,8.55312533944,318.260855803,6.27834133989,16.6469936046,18.9817844745,108.377930115,-75.6655349696,81.4047847412,49.4991993482,124.613708129,108.041531127,-19.4337522669,111.028185975,-112.736086518,116.050242741,-16.9448173972,41.1515322641,-3.53582300408,24.7725442539,29.4702593754,43.0932734261,23.131480287,-16.0273710813,32.8470829556,-38.7257659539,57.4475493686,6.27727430979,23.6623805582,-1.21949488293,8.18140816697,1.4720531827,9.74758468183,18.667763077,5.7935042382,11.7872004401,3.20003431368,15.234178148,-10.0870253557,11.8502968334,-2.55122289677,2.47464934833,-4.86672092894,-3.02819664601,-0.544636024083,0.641039465791,-3.16688251314,-0.231881340204,5.53964718753,2.55039407423,6.10892736871,1.33892707459,4.7435850969,0.92032804383,2.64026146388,-1.46116157176,1.87742275323,-2.95777713987,-3.65030448541,-1.12936903908,0.0587777787776,0.11758990624,-1.21739808045,-0.0700166451501,-0.948887378387,0.157856316719,-0.246381702081,1.52448276107,0.380264050848,0.98685180792,1.13406194523,0.69423551515,0.440823440234,0.255383088746,-0.799954078347,-0.922837446647,-0.784114018875,-0.550337618699,-0.162114702328,-0.0537242744273,0.0905430023041,-0.0787063918531,-0.19384634315,-0.198189186573,-0.322829655437,-0.0703391175493,0.316896320053,0.140763258897,0.420485054206,0.224184009215,0.220111317302,0.15484094201,0.261126877204,-0.0987255582724,-0.101757775097,-0.14527765538,-0.353076244159,-0.019178513526,-0.231369979351,-0.0957160739139,-0.0184129420379],[-33415.2452196,495.333205666,35.1690186257,-1282.37063217,-292.471110548,725.829544962,-79.6092698135,-291.466098364,-355.011888778,665.910149821,8.93752756232,-946.215582054,-528.412206627,435.394072033,-436.412814215,-309.083436343,-22.8823346042,144.776550092,-67.5899429123,-126.854270208,5.88480412156,326.733821468,18.2045341088,14.5894928467,20.2471337927,106.714165843,-78.0355556708,83.8871433809,51.946276788,122.914542055,108.329620551,-16.7169816189,109.404701682,-113.592104226,116.944548603,-16.7689037613,40.1557507593,-4.35556376715,24.5192155886,29.8581121666,42.8536972509,22.8963614836,-17.0625358151,33.131304584,-38.7919148144,57.7150507544,5.62731389965,24.2153758247,-1.01556553364,7.96406199905,1.45728698548,9.4204396985,18.4917360476,5.49772585355,11.6272158619,2.66781347902,15.6274169734,-10.1674597125,11.8943740177,-2.77371108324,2.41304181711,-4.69614242929,-3.10013945945,-0.454866353623,0.679871854093,-3.1287124973,-0.372977625696,5.42717225578,2.4677411401,6.02958716416,1.22142899071,4.84330801035,0.881579216096,2.61471915088,-1.45429448585,1.82684560493,-2.88367137506,-3.68215814763,-1.04484281917,0.0780854496457,0.136116018183,-1.18711327339,-0.0447170011229,-0.967429808361,0.131017621931,-0.265176946717,1.49674548806,0.368670556874,0.974913880644,1.12398546405,0.702253855969,0.450415493005,0.228282230194,-0.791992060518,-0.94169237609,-0.756840990782,-0.536715344288,-0.18258532763,-0.055194370224,0.0910108869923,-0.0681711654316,-0.190100354451,-0.191346211608,-0.324371684667,-0.0730286830112,0.30923487791,0.144091300081,0.410195666935,0.22204054904,0.221020323316,0.155908135956,0.252344897871,-0.104125187275,-0.107829271262,-0.13699846288,-0.353484711385,-0.0255178850098,-0.233557924899,-0.0958522037976,-0.0188992831004],[-33449.2012731,479.657878346,32.6159039128,-1295.41218858,-278.005624557,722.617905567,-102.346619777,-305.926669029,-352.195734175,680.843849843,9.70718633672,-947.1935696,-526.336547618,441.777853958,-436.740637426,-303.010490043,-24.941047628,150.066255716,-59.2646240213,-124.697471081,3.59086815652,335.197661913,30.089057375,12.7633689848,21.549033487,105.121868587,-80.1624757758,86.38285335,54.61596425,121.276913714,108.607970087,-14.1302674056,107.744384853,-114.585586124,117.758049647,-16.6136529268,39.1428199255,-5.17822732293,24.2873626297,30.2828281307,42.6173079762,22.6276592342,-18.1457454052,33.4205326529,-38.8724090298,57.9498458589,4.98390177446,24.7715031897,-0.818448837864,7.73089979186,1.43445202916,9.09371917152,18.2989949357,5.20355846886,11.4606531812,2.11973573828,16.0254760887,-10.2478433339,11.9357811053,-2.99018532279,2.35345590088,-4.5294122718,-3.17267559279,-0.363700754081,0.71447046908,-3.09534478549,-0.512043013051,5.308814409,2.38478866402,5.94861234444,1.10093892326,4.94465927624,0.839651357967,2.59045733619,-1.44345536143,1.77260759827,-2.81036056972,-3.71556477671,-0.959291021071,0.0965927359126,0.15469038407,-1.1575162037,-0.0203997569904,-0.985876499989,0.102761431178,-0.283080815024,1.46797876499,0.357478698965,0.963295431774,1.11303555314,0.710627376738,0.460980313312,0.199597444109,-0.784700996442,-0.961099563523,-0.728634626694,-0.522565401589,-0.202752168594,-0.0568847194824,0.0914549542571,-0.0577344710402,-0.186363424138,-0.184434639617,-0.32576008656,-0.0754935126295,0.301322201435,0.147832028329,0.399853714827,0.219698179671,0.221862846503,0.157024852434,0.243032997415,-0.109883511433,-0.114091321271,-0.128586339848,-0.35368774524,-0.0318184708529,-0.235779372137,-0.0961533699071,-0.0193448190512],[-33485.0627492,463.800149255,31.7252133271,-1308.875328,-265.499086911,716.581459852,-124.533322746,-319.589435671,-348.142688158,694.747589287,10.6590004468,-947.550691988,-524.291643797,447.589466125,-436.547646768,-296.962086033,-26.3851059657,155.562016675,-51.0528415594,-122.372329544,1.55215522075,343.59089298,41.8584139619,11.2121228701,22.8928855375,103.607641831,-82.030354947,88.8528275516,57.4408978808,119.690371019,108.912650447,-11.6828868831,106.069720794,-115.715946688,118.490800309,-16.4769619099,38.1201723906,-6.00583375624,24.0672312114,30.7367071162,42.3824920781,22.3366248867,-19.2663137396,33.7174768839,-38.971523927,58.1568123828,4.33134411424,25.3291691638,-0.629888560199,7.48358360775,1.40390412583,8.76639279085,18.0892854081,4.91204560359,11.2896216207,1.55710199542,16.4274136529,-10.3277697745,11.9748781107,-3.20390216739,2.2981271609,-4.36723113549,-3.24835845039,-0.272031650138,0.745253433679,-3.06663325524,-0.648376171863,5.18577232524,2.30160367835,5.86585342578,0.978208629406,5.04727696835,0.79396821496,2.56790536191,-1.43012717102,1.71548824439,-2.73779902523,-3.75076250814,-0.873104412161,0.113636383068,0.172959120719,-1.1287005493,0.00291820707594,-1.00407089682,0.0733940347288,-0.299949903103,1.43819245298,0.346853413353,0.951985232488,1.10104270815,0.719217943256,0.472204998409,0.169575378775,-0.778122845665,-0.981043789591,-0.699680725776,-0.508169376704,-0.22251815408,-0.0589286640039,0.0918726708308,-0.0475073853602,-0.182641065924,-0.17745187412,-0.326961169561,-0.0777556385555,0.29323147483,0.15205437007,0.389470237949,0.217166610093,0.22260937557,0.158138329804,0.233194887275,-0.115994585906,-0.1205652639,-0.1200972635,-0.353680376224,-0.0380704981783,-0.238003871478,-0.0965892370079,-0.0197999438828],[-33522.4304184,448.201932624,31.7206216542,-1322.86728511,-254.123859396,707.686547561,-146.143847936,-331.993679286,-342.639599088,707.534504859,11.708229931,-947.177882952,-522.24784134,452.412476337,-435.605979029,-290.923366766,-27.1880375758,161.258032721,-43.0658820277,-119.951281842,-0.35049690932,351.85203051,53.4391066929,9.97925535357,24.2840919245,102.178089059,-83.6232528465,91.2579788885,60.3537138264,118.144461878,109.279732339,-9.38411730779,104.403194811,-116.982600395,119.142855023,-16.3567277266,37.0952407827,-6.84040315193,23.8490671681,31.2120489715,42.1476360327,22.0345097897,-20.4135547061,34.0248469989,-39.0935348331,58.3408280267,3.653947099,25.8867802573,-0.451628465255,7.22377550909,1.36599908756,8.43743024644,17.8623531315,4.62423077722,11.1162304037,0.981213154394,16.8322878251,-10.4068325889,12.0120250487,-3.41811816897,2.24929115844,-4.21029969938,-3.32974143662,-0.180751466477,0.772638870816,-3.04243178409,-0.781275771727,5.05924468259,2.21825321546,5.7811609244,0.853989866299,5.15079916048,0.743953532595,2.54749257017,-1.41579288711,1.65626705443,-2.66594104297,-3.78798947739,-0.786673759836,0.1285531366,0.19056834495,-1.1007599881,0.0252200109047,-1.02185644239,0.0432217228545,-0.315640807054,1.40739641317,0.336959636268,0.940972053966,1.08783742472,0.727887421321,0.48377664555,0.138462682477,-0.77229956773,-1.00150983494,-0.670165087193,-0.493808855735,-0.241786212949,-0.0614595455895,0.0922615034456,-0.0376009850727,-0.178938793522,-0.170395318636,-0.327941242115,-0.0798370929407,0.285035882299,0.156827251734,0.379056276374,0.214455549291,0.223230399223,0.159195806425,0.222834278888,-0.122452465856,-0.127272437922,-0.111587211051,-0.353457634836,-0.0442641941089,-0.240200973338,-0.0971294698655,-0.0203150515878],[-33560.9050511,433.305142686,31.82580368,-1337.49529459,-243.052303797,695.899508442,-167.152664565,-342.678680874,-335.473315325,719.117733269,12.7701348282,-945.966076226,-520.175486426,455.830452396,-433.687771,-284.879474696,-27.3233704166,167.148503601,-35.4150319274,-117.506764221,-2.23625045726,359.919590345,64.7576383916,9.1082672865,25.7280546282,100.839813754,-84.9252291368,93.5592202637,63.2870482331,116.628734204,109.745286474,-7.24323593571,102.767292212,-118.384961722,119.714268223,-16.2508473933,36.0754577299,-7.68395559483,23.623116334,31.7011535453,41.9111263159,21.7325652912,-21.5767821927,34.3453527197,-39.2427170748,58.5067704913,2.93601690877,26.4427429804,-0.28541231764,6.95313755824,1.32109272644,8.10580122824,17.6179437725,4.34115750919,10.9425887529,0.393370119151,17.2391567642,-10.4846253316,12.0475819341,-3.63608987948,2.20918345477,-4.05931864251,-3.41937795584,-0.0907526277806,0.797044903418,-3.02259424958,-0.91004048224,4.93043015911,2.1348043077,5.69438535654,0.729034391104,5.25486392642,0.68903105639,2.52964830307,-1.40193548219,1.59572353956,-2.59474092433,-3.82748381996,-0.70038983149,0.140679742,0.20716417358,-1.07378819804,0.0464887743245,-1.03907658025,0.0125507858247,-0.330010122978,1.37560050666,0.327962303942,0.930244667386,1.07325019852,0.736497676733,0.495382351989,0.106506003498,-0.767273122182,-1.02248248021,-0.640273510112,-0.479765424785,-0.26045927406,-0.0646107060406,0.0926189188336,-0.0281263468591,-0.175262120642,-0.163262376684,-0.328666612669,-0.0817599079365,0.276808608046,0.162219599753,0.368622870169,0.211574706248,0.223696406168,0.160144520654,0.211954883691,-0.129251206442,-0.134234182114,-0.103112159718,-0.353014551576,-0.0503897857675,-0.242340228133,-0.0977437332457,-0.0209405361588],[-33600.0988657,419.553099944,31.4667493358,-1352.78349738,-231.586540397,681.287721162,-187.571938574,-351.358343874,-326.565688131,729.454591247,13.7900247844,-943.839853688,-518.034164038,457.561273041,-430.644318956,-278.808756625,-26.7702752585,173.238513398,-28.1867006719,-115.092200263,-4.2023449195,367.734383574,75.7443141748,8.63584698508,27.2300048839,99.5988573996,-85.9273956483,95.7241506067,66.1830987422,115.130751617,110.334409208,-5.26881211797,101.18057548,-119.919848316,120.201381989,-16.1569303127,35.066982931,-8.53791853953,23.3804862804,32.1951935923,41.6711435689,21.4404265426,-22.7468047114,34.6794911617,-39.4226914146,58.6569285759,2.16433045504,26.9956106104,-0.132288533469,6.6733311425,1.26922348537,7.77063130072,17.3562348796,4.06369640192,10.7703959469,-0.20513353426,17.6464436734,-10.5612471864,12.0813352166,-3.86074817223,2.17940151456,-3.9145213606,-3.519219187,-0.00292578902935,0.818868913357,-3.00688732609,-1.03420074006,4.80030052593,2.05145040953,5.60526896935,0.604060088626,5.35895268667,0.62880249617,2.51456960868,-1.38991773418,1.53450955135,-2.52402914681,-3.86937688644,-0.6145701879,0.149434722352,0.222433290215,-1.04779967042,0.0667393041054,-1.05559082285,-0.0183329621303,-0.342930723635,1.34284741422,0.320031107371,0.91976356531,1.05713949013,0.744934013542,0.506718893073,0.0739373927315,-0.76302946416,-1.04394574544,-0.610182148434,-0.466320585213,-0.27846426517,-0.06848923396,0.0929463548021,-0.0191654663323,-0.171607085354,-0.156051048404,-0.329102158873,-0.0835370729272,0.268625474636,0.168278397376,0.358183329019,0.208526976414,0.223984575344,0.160944837173,0.200567556948,-0.136378743568,-0.141481189984,-0.09471889351,-0.352362643452,-0.0564361581806,-0.244393707701,-0.0983965797945,-0.0217194310616],[-33639.6698709,407.394749994,30.8787091354,-1368.42365946,-219.547723451,664.322720083,-207.564622795,-358.445061495,-316.378580373,738.679115609,14.8334078761,-940.858389783,-515.740414387,457.860060764,-426.643557109,-272.66237674,-25.5304941178,179.576683528,-21.3677893238,-112.684962904,-6.25832888389,375.246402264,86.3446483328,8.57143262588,28.7944909478,98.4590134839,-86.6490728845,97.7471129534,69.0223089747,113.630140585,111.02829948,-3.46658358521,99.6459158143,-121.573690501,120.585688969,-16.0714354348,34.0708843676,-9.40134891959,23.1157315274,32.6808334937,41.4250450931,21.1612639068,-23.9204092708,35.0189090149,-39.6344603561,58.7832354742,1.33554757527,27.5445234907,0.00947586511479,6.38601494892,1.20916033051,7.4316695265,17.0791315275,3.7920263895,10.5997114859,-0.813033541399,18.0500319316,-10.6388198547,12.1107770862,-4.09372120584,2.15899041611,-3.77427211633,-3.6288074074,0.0818454736071,0.838425318293,-2.99472887537,-1.15421405007,4.66891992637,1.96889066382,5.51312093364,0.479649354246,5.46192024859,0.563581418981,2.50152435882,-1.38062164255,1.47276630314,-2.45314089229,-3.91337288786,-0.529239563384,0.154563711125,0.236224645608,-1.02249215005,0.0861131547836,-1.07132295824,-0.0492256109389,-0.354340588417,1.30931109518,0.313354756624,0.909376125821,1.03947561992,0.753175488809,0.517521756517,0.0409305114976,-0.759330531172,-1.06588060815,-0.580028575007,-0.453755499408,-0.295824109617,-0.073097205158,0.0932611334592,-0.0106840148317,-0.167931823149,-0.148761720404,-0.329207035211,-0.0851454062295,0.260572858073,0.174962855137,0.347760041057,0.205288001088,0.224098846613,0.161609625945,0.188711729219,-0.1437985361,-0.14908157398,-0.0864174236046,-0.351579373504,-0.0623868279882,-0.246343569571,-0.0990321136808,-0.022665327654],[-33679.287523,397.280444706,30.4992487383,-1384.02445307,-206.886765712,645.577078488,-227.331366783,-364.525849386,-305.50885782,746.969523195,15.9958417873,-937.114507099,-513.200016491,457.116248994,-421.932579154,-266.384703578,-23.6114118231,186.22251974,-14.9203218577,-110.24341242,-8.39182821117,382.407933729,96.5079574492,8.91764985055,30.4258903313,97.4235134947,-87.1166335167,99.6291363662,71.7946840468,112.104543284,111.797181874,-1.84158016292,98.1622615893,-123.33032177,120.844969456,-15.9905340961,33.0869570921,-10.2727110383,22.8242683321,33.1436105369,41.169982355,20.8966315498,-25.0958775037,35.3530403628,-39.8783718388,58.8750354786,0.448798838372,28.0887687319,0.142309204459,6.09284698951,1.13935485888,7.08882084272,16.7889706728,3.52615348896,10.4301849256,-1.42907296573,18.4451699616,-10.7199706672,12.1328261677,-4.33631146032,2.14635714111,-3.63646788906,-3.74708266892,0.162679353661,0.856007794832,-2.98544955602,-1.27076968422,4.53612559684,1.8879506355,5.41714215116,0.356350710994,5.56246476628,0.493859356176,2.48954813126,-1.37480901221,1.41050734874,-2.38128751878,-3.95906925039,-0.444349485646,0.155894119384,0.248427757301,-0.997484195164,0.104783567837,-1.08621284337,-0.0799437265691,-0.364193973374,1.27519832852,0.308126716534,0.898901448385,1.02025687319,0.761224597844,0.527536108128,0.00764442372541,-0.755882256324,-1.08826728526,-0.549940717417,-0.442351245017,-0.312585729632,-0.0784104422465,0.0935845479877,-0.00261858262862,-0.164184993874,-0.141395375911,-0.328938965369,-0.086552683393,0.252739772724,0.182210240392,0.337377664029,0.201826608036,0.224049850069,0.162164883256,0.176433974892,-0.151467923646,-0.157112801281,-0.0782085679727,-0.350758691282,-0.0682239697337,-0.248174492698,-0.0995893269541,-0.0237844567674],[-33718.6212787,389.660535948,30.7659338038,-1399.19455046,-193.554579931,625.623369662,-247.072820092,-370.187723197,-294.553386238,754.504030842,17.3728842021,-932.701028225,-510.318749366,455.71927116,-416.758478787,-259.920105674,-21.0204132024,193.235527783,-8.80632224852,-107.725909083,-10.5904687621,389.171265284,106.183558108,9.67712430072,32.1285805456,96.49558892,-87.3564502166,101.371249907,74.4902290746,110.531601894,112.611280976,-0.398831676629,96.728561181,-125.173575616,120.957003744,-15.9103976332,32.1149961571,-11.1504691991,22.5015129517,33.5690620095,40.9031068211,20.6480836375,-26.2714910428,35.6713192893,-40.1547738018,58.9216728815,-0.496785186739,28.6276334442,0.268639810913,5.79548527624,1.05825866747,6.74199018652,16.4880892717,3.26608371733,10.2614658218,-2.05199487071,18.8271061866,-10.8073269545,12.144401086,-4.58982141564,2.13990867127,-3.49900565819,-3.87298502343,0.238694044666,0.87191001958,-2.97838002662,-1.38455691447,4.40175477371,1.80945588953,5.31653352366,0.234712681896,5.6592843938,0.420127839107,2.47767650378,-1.37324164803,1.34774624191,-2.30768038426,-4.00606340018,-0.359851482388,0.153253358194,0.258932142835,-0.97239436396,0.122923784744,-1.10020033519,-0.110303874989,-0.372445134559,1.2407158932,0.304540451937,0.888158632468,0.999481535228,0.769083835958,0.536507113715,-0.0257618066565,-0.752390572717,-1.11108599369,-0.520046503248,-0.432388899686,-0.328796047448,-0.0844047678374,0.0939378915708,0.00509424000569,-0.160315257379,-0.133952998152,-0.328255673037,-0.0877266799672,0.245215232956,0.189957820494,0.327060855682,0.198111625023,0.223848215806,0.162636605392,0.163780868356,-0.159344245816,-0.16565233907,-0.0700931445847,-0.349994546334,-0.0739297579606,-0.249871156035,-0.100007211664,-0.0250830492328],[-33757.3405942,384.98537559,32.1163299914,-1413.54262387,-179.50207886,605.034166888,-266.989632279,-376.017698579,-284.109031396,761.460855389,19.0600928045,-927.710775748,-507.002392029,454.05856069,-411.368349704,-253.212951566,-17.7648830841,200.675213406,-2.98781447108,-105.090813168,-12.8418763973,395.488684242,115.320766892,10.852481618,33.906939102,95.678471248,-87.3948956557,102.97448264,77.0989491741,108.888958593,113.44082137,0.856632048156,95.3437629649,-127.087285532,120.899572125,-15.8271973827,31.1547966149,-12.0330877052,22.1428816433,33.9427251989,40.621569958,20.4171743359,-27.4455315209,35.9631798779,-40.4640141844,58.9124919752,-1.50207393114,29.160404738,0.390896010824,5.49558782111,0.964323353281,6.39108249505,16.1788242808,3.01182309164,10.0932037303,-2.68054231981,19.1910890293,-10.9035160473,12.1424204661,-4.8555535518,2.13805198828,-3.35978240308,-4.00545452283,0.309007740154,0.886425669144,-2.97285094578,-1.49626501276,4.26564469338,1.73423199085,5.21049595287,0.11528378998,5.75107728525,0.342878399125,2.46494505414,-1.37668135492,1.28449653646,-2.23153084674,-4.05395276338,-0.275697081315,0.146468838619,0.267627319749,-0.946841214652,0.140707046982,-1.11322529065,-0.140122622167,-0.37904832802,1.20607056821,0.302789427666,0.876966777535,0.977147891343,0.776755698462,0.544179939084,-0.0591291157196,-0.748561413457,-1.13431695035,-0.490473860084,-0.424149541062,-0.344501985299,-0.0910560045426,0.0943424573914,0.0125178628,-0.156271273509,-0.126435570353,-0.327114881902,-0.0886351715018,0.238088253135,0.198142862797,0.316834273762,0.194111879813,0.223504573918,0.163050788637,0.150798983996,-0.167384842218,-0.174777654526,-0.0620719714114,-0.349380888211,-0.0794863672124,-0.251418238535,-0.100224759859,-0.0265673358814],[-33794.9338862,383.242677597,34.7604342998,-1426.82067527,-164.746863117,584.207006539,-287.149704392,-382.425475379,-274.689628969,767.965485631,21.1369515869,-922.22675361,-503.141046897,452.449046375,-405.971116606,-246.219245783,-13.8723877585,208.570823944,2.57630215411,-102.306126727,-15.1440069141,401.320825033,123.889724725,12.4513014181,35.7681876687,94.9696363826,-87.2594986968,104.439720871,79.6094879998,107.156489503,114.256368213,1.92456537401,94.0075462541,-129.058969518,120.654975715,-15.7362822125,30.2057266474,-12.9192674724,21.7450959942,34.2519707226,40.3226032507,20.2037879732,-28.6166813146,36.2177615099,-40.8065140586,58.8378022209,-2.56723909396,29.6866315333,0.511199655763,5.19481620939,0.856592383359,6.03635142631,15.863122684,2.76358302808,9.92448464778,-3.3132870005,19.5323860888,-11.0107335736,12.1240665963,-5.13458436576,2.13938013898,-3.21711500818,-4.14339203744,0.372844877132,0.899965150088,-2.96826323899,-1.6063581816,4.12777095778,1.66307604464,5.09833386914,-0.00141958670121,5.83654428112,0.262641632952,2.45041425836,-1.38577045942,1.22077467979,-2.15222324952,-4.10242602849,-0.192008203506,0.135483334856,0.274413301182,-0.920497067845,0.158300785399,-1.12522779836,-0.169212812416,-0.383953702307,1.17144093405,0.303033406185,0.865145810304,0.953299626434,0.784202682685,0.550353437654,-0.0923449826894,-0.744121757314,-1.15795892407,-0.461367050198,-0.417856518255,-0.359743966503,-0.0983305891134,0.0948122337162,0.0197024425201,-0.152009434923,-0.118842370761,-0.325480541689,-0.0892542719232,0.231435907501,0.2067107824,0.306721076475,0.189817540281,0.2230191588,0.163438302074,0.137533160085,-0.175541392623,-0.184547309209,-0.0541474820277,-0.349005439713,-0.0848775111976,-0.252805732927,-0.10019628162,-0.0282384155274],[-33830.165411,382.569604321,37.9979690858,-1439.35402549,-149.573284783,562.839277348,-307.089943454,-389.111490233,-266.476894259,773.932498191,23.6186497746,-916.292691161,-498.562109984,450.907638443,-400.623028209,-238.941536837,-9.45121936469,216.830573083,7.93962692355,-99.3784189233,-17.5361358561,406.661710551,131.943869891,14.5009792122,37.7309245402,94.3435378918,-86.9824129671,105.767279892,82.0050433594,105.323006531,115.029848942,2.82385941583,92.7225141123,-131.090883602,120.223598916,-15.6297111157,29.2654469545,-13.808655867,21.3100989126,34.4915025175,40.0037582585,20.0011295258,-29.7852257766,36.4230247571,-41.1829870269,58.6917737542,-3.68966144654,30.2069099886,0.630446698184,4.89484631945,0.736476704953,5.67944552178,15.5413715748,2.52239653944,9.75214033537,-3.94811509626,19.8463416679,-11.1294483502,12.0875764183,-5.42708642237,2.14323043069,-3.07099997817,-4.28554171148,0.429854866511,0.913405788814,-2.96429889937,-1.71440034574,3.9886626311,1.59667131694,4.97976581722,-0.115009649995,5.91439696764,0.180104398778,2.43324418548,-1.40067337468,1.1566086939,-2.06983387712,-4.15153693332,-0.109588343557,0.120701073627,0.279232082659,-0.893249293716,0.175849188329,-1.13614887355,-0.197372403431,-0.387094975959,1.13689277741,0.305297340474,0.852518966504,0.928162023806,0.79122729402,0.555041213279,-0.125483059409,-0.738882765736,-1.18208489127,-0.432935674611,-0.413502266231,-0.374536418731,-0.106157414858,0.0953319891463,0.0266451240796,-0.14751706551,-0.111165857699,-0.323341506261,-0.0895934486657,0.225287509797,0.215639585372,0.296738423859,0.185304134738,0.222350622052,0.163849505971,0.12402129043,-0.18374293745,-0.194944242193,-0.0463285724265,-0.348931016646,-0.090093060284,-0.254044887039,-0.0999373591508,-0.0300768589169],[-33861.6183856,380.640680211,40.9010880456,-1451.61132511,-134.332383807,540.453331135,-326.214507981,-395.598863974,-259.569512477,779.223741648,26.5043029015,-909.942499104,-493.077300704,449.376742484,-395.342164238,-231.394009233,-4.62985150366,225.33241609,13.158883788,-96.3239006989,-20.0678687036,411.513710802,139.557465013,17.0338644857,39.8165921681,93.7688737596,-86.5969482854,106.957332242,84.2674515991,103.37955553,115.733531569,3.57818947663,91.4920005406,-133.188968317,119.610346957,-15.4987206168,28.3311913654,-14.7011368677,20.8411386368,34.6578578507,39.6626665593,19.8007341325,-30.9518510032,36.5666354889,-41.5942198249,58.4695418796,-4.86602402825,30.7220980723,0.749226615765,4.59735760291,0.605979135357,5.32236204383,15.2135680741,2.28950203767,9.57243899519,-4.58274141459,20.1283192456,-11.2596974915,12.0314505372,-5.73300630348,2.14912623587,-2.92185372275,-4.4306085076,0.479793362672,0.92774164168,-2.96071018693,-1.81973036049,3.84898714308,1.535672614,4.85461387049,-0.225130746726,5.98334961747,0.0959926201614,2.41261980278,-1.42143503554,1.09202949439,-1.98461199939,-4.20143047806,-0.029411389442,0.102641644783,0.282036155303,-0.86503902484,0.193490633475,-1.14592976312,-0.224395631255,-0.388401760012,1.10246368651,0.309572481143,0.838910309116,0.902005766365,0.797592039878,0.558310557425,-0.158663540875,-0.732676645838,-1.20678638027,-0.405405669033,-0.41102149142,-0.388887270737,-0.114455989226,0.0958791873662,0.0333297994293,-0.14278922197,-0.103396784509,-0.320692855516,-0.0896705075401,0.219660433639,0.224915425526,0.286901976412,0.180668531604,0.221447219578,0.16433963339,0.110299532722,-0.191912857279,-0.205932486931,-0.0386257542048,-0.349214208068,-0.0951244240048,-0.255152262477,-0.0994788926848,-0.0320581047793],[-33887.8760263,375.130429715,42.5419448752,-1464.06122467,-119.375200137,516.571519723,-343.92755649,-401.410717436,-254.066168833,783.701064581,29.7930265012,-903.210088143,-486.498338469,447.798764087,-390.146604413,-223.590847476,0.463242223491,233.954308236,18.2907966983,-93.1587829952,-22.7888109365,415.879195794,146.804772712,20.0823067239,42.0466330037,93.2143419701,-86.1364144702,108.010050455,86.3785490651,101.317182352,116.339684102,4.2112308594,90.3193395401,-135.3591642,118.820125062,-15.3345472404,27.4001937096,-15.5965944532,20.3414634052,34.7475739891,39.296959731,19.5941369319,-32.1172430908,36.6362595747,-42.0409991879,58.1662419017,-6.0930098785,31.2330537524,0.868128886182,4.30402951142,0.467102491869,4.9670982548,14.8797093028,2.06613793471,9.38164882939,-5.214880763,20.3736823008,-11.4015181116,11.9541895582,-6.05229059092,2.15659092697,-2.77009265168,-4.57729738846,0.522416020002,0.943966765047,-2.95724936171,-1.92168708116,3.70941192346,1.4807347421,4.72270010229,-0.331427223716,6.04211650326,0.0110322206623,2.38772607753,-1.44810037681,1.02706799688,-1.89680688614,-4.25225166286,0.0475487708661,0.0818246381793,0.282778010236,-0.83580739379,0.211363498539,-1.15451171394,-0.250076731927,-0.387803665503,1.06819124958,0.3158500788,0.82414390112,0.875101537017,0.803059427671,0.560228761556,-0.192006622084,-0.725335604735,-1.23215491942,-0.379002969172,-0.410348900252,-0.402804451279,-0.123145819663,0.0964312920608,0.0397403605196,-0.137820961001,-0.0955259045339,-0.317529669355,-0.0895032543576,0.214572052643,0.234524456674,0.27722739463,0.176007599301,0.220257207278,0.164963917398,0.0964040446533,-0.199974532694,-0.217476076875,-0.0310495389601,-0.349911603038,-0.0999630118927,-0.256144420844,-0.0988517824563,-0.0341575918438],[-33907.52155,363.713377282,41.9926932708,-1477.17237475,-105.052773721,490.716194933,-359.633247497,-406.070171452,-250.065548536,787.22631557,33.4839361076,-896.12936898,-478.636942694,446.116108842,-385.054428459,-215.546236073,5.69958821569,242.574204792,23.3920896051,-89.8992767537,-25.7485680352,419.760535538,153.760055613,23.6786554119,44.4424894984,92.6486405073,-85.6341213401,108.925607071,88.3201721033,99.1269328474,116.820574552,4.74665886714,89.2078651119,-137.607411784,117.857838458,-15.1284275108,26.4696878163,-16.4949126021,19.8143214562,34.7571881996,38.9042693514,19.3728730627,-33.2820881359,36.619562884,-42.5241118512,57.7770091249,-7.36730203666,31.7406349972,0.987742987112,4.01654149663,0.321849591785,4.61565141704,14.539792382,1.85354264251,9.17603804011,-5.84224794897,20.5777943124,-11.5549473247,11.8542940865,-6.38488586652,2.16514787644,-2.61613317467,-4.72431331673,0.557478492882,0.963075215272,-2.9536686837,-2.01960936304,3.57060440197,1.43251250747,4.58384658599,-0.433543427788,6.08941189767,-0.0740508761606,2.35774797702,-1.4807143333,0.961755116978,-1.80666780723,-4.3041454879,0.120318249394,0.0587696436672,0.281410138582,-0.805495533137,0.229606161227,-1.16183597291,-0.274209941489,-0.38523030347,1.03411305485,0.324121384055,0.808043805499,0.847720018667,0.80739196481,0.560863117139,-0.225632498034,-0.716691849542,-1.25828203703,-0.353953510737,-0.411419199158,-0.416295889112,-0.132146413618,0.0969657669147,0.0458606993014,-0.132607339303,-0.0875439711148,-0.313847027676,-0.089109494929,0.210039740426,0.24445283263,0.267730339011,0.171418206249,0.218728841056,0.165777591057,0.0823709839143,-0.207851344274,-0.229539045478,-0.0236104382893,-0.351079790614,-0.104600233481,-0.257037923745,-0.0980869286995,-0.0363507588398],[-33919.7416069,344.913711423,38.6225924531,-1491.23809515,-91.5828454025,462.655221886,-372.949102097,-409.291771994,-247.647593388,789.676309382,37.5497124777,-888.7393602,-469.337740319,444.285613182,-380.051312987,-207.301043488,10.9602738814,251.078646075,28.4892264074,-86.5515311635,-28.9867317524,423.169812571,160.494865458,27.8448836305,47.0145450876,92.0435577444,-85.1216589931,109.702450145,90.083946286,96.8056711226,117.155439787,5.21024808849,88.1576629219,-139.934690384,116.72919987,-14.8735680131,25.5375235635,-17.396129366,19.2625942511,34.6852905565,38.4845117465,19.1299639161,-34.4456283863,36.5073044694,-43.043426777,57.2986255414,-8.68340347189,32.2445856229,1.10913237083,3.73629274431,0.171935180672,4.26993700734,14.193718486,1.65284106842,8.95281906745,-6.46255218562,20.7371632636,-11.7200573159,11.7304030708,-6.73013255259,2.1738098167,-2.4609741286,-4.8706981933,0.585054850929,0.98590259379,-2.94982246519,-2.11293947652,3.43307109386,1.39149442576,4.43800458412,-0.531162862257,6.12430545395,-0.158799136739,2.32191750452,-1.51919977099,0.89604847809,-1.71455331269,-4.35721935368,0.188148347901,0.0340879207102,0.277935454238,-0.774062980016,0.248307622266,-1.16787274333,-0.29664427298,-0.380655901719,1.0002465495,0.334335921883,0.790468688884,0.820074107303,0.81037299307,0.560243521446,-0.259630755291,-0.706610531692,-1.28523170339,-0.330421908791,-0.414093198291,-0.429349964042,-0.141367226964,0.0974511893635,0.0516852687701,-0.127151755092,-0.0794557396938,-0.309643116115,-0.0885066781777,0.206063443499,0.254671946135,0.25842012156,0.166981118344,0.216822719878,0.16680879411,0.0682359009113,-0.215458329135,-0.242073917503,-0.0163077920785,-0.352749806519,-0.109017682531,-0.257845769306,-0.0972114968732,-0.0386134467803],[-33926.1365828,320.654276896,32.9893237405,-1505.85038263,-78.64995961,433.138518905,-384.346091692,-411.555765591,-246.817271561,790.987725537,41.8572972623,-881.099511905,-458.5769884,442.321836919,-374.993322169,-199.002874023,16.164630667,259.388512599,33.4876307967,-83.0814484032,-32.5028389314,426.157959561,167.069910476,32.5614588415,49.728947143,91.3832436125,-84.6237386452,110.332129811,91.7006540889,94.3735342946,117.351392108,5.63617025476,87.1558252944,-142.322134443,115.443152014,-14.5710555739,24.6040150232,-18.3008990867,18.6876961437,34.5386823635,38.0467422347,18.8643758929,-35.6013306959,36.3026161162,-43.5951418334,56.7344598936,-10.0270968724,32.7401928376,1.23525638797,3.46356137688,0.0179217171826,3.93154336016,13.8410050035,1.4647041014,8.7129813034,-7.07348030845,20.852875154,-11.8970605532,11.581708835,-7.08494643331,2.17954692003,-2.307944059,-5.01684167202,0.606492824681,1.01265068232,-2.94597322735,-2.20153335221,3.29667485637,1.35750385005,4.28564211593,-0.624125656401,6.14728834769,-0.243828587467,2.27965480728,-1.56299128041,0.82961253475,-1.62125907339,-4.41143026205,0.251191127079,0.00875740721215,0.2725585622,-0.741542889798,0.267359374494,-1.1727080542,-0.317447847431,-0.374233155141,0.966528616556,0.346276314725,0.771415632514,0.79214555124,0.811869191694,0.558250294977,-0.2939685467,-0.695088579887,-1.3129576566,-0.308327495812,-0.417936122708,-0.441876860071,-0.15067750928,0.0978205918462,0.0572507661004,-0.121490972652,-0.07132197411,-0.304928543257,-0.0877108254752,0.202573399953,0.265094145656,0.249280660315,0.162712691386,0.214548814975,0.167977293014,0.054031916908,-0.222677150528,-0.254987182955,-0.00909625336872,-0.354850473141,-0.11315768972,-0.258566701748,-0.0962377133349,-0.0409231058134],[-33928.9102971,293.707582519,25.947673976,-1520.42590321,-65.8053616681,403.161517612,-394.508550264,-413.533823909,-247.560807818,791.112209745,46.2471973354,-873.274382081,-446.363851517,440.253770708,-369.704117067,-190.826015938,21.2415510285,267.433269925,38.2624664128,-79.4448688992,-36.286412688,428.785621706,173.543188013,37.7984721021,52.54078402,90.6549384319,-84.1633517919,110.804471723,93.2108672141,91.8564777333,117.422512674,6.06069638289,86.1861962185,-144.745917182,114.009445105,-14.2239470804,23.670092316,-19.210030179,18.0906747108,34.3262177317,37.6023008822,18.5765616463,-36.7412180698,36.0117227929,-44.1745371155,56.0895276119,-11.3819848561,33.2216296971,1.36954836378,3.19834525086,-0.139916411759,3.60197702441,13.4810733764,1.2896891258,8.45845837793,-7.67271355859,20.9271604875,-12.0862045756,11.4075420463,-7.44563713336,2.17881871867,-2.1609539385,-5.163470345,0.623458559907,1.04336280767,-2.94248554364,-2.28535033581,3.16111763224,1.33019784277,4.12735638986,-0.712311095991,6.1592071351,-0.330023644728,2.23042706852,-1.61140138323,0.762038449278,-1.5276900404,-4.46669761519,0.309823837353,-0.016152289313,0.265534490243,-0.707986822416,0.286603533772,-1.17645689091,-0.336743562872,-0.3661593754,0.932875998015,0.35968345939,0.750916321277,0.763858311873,0.811768074286,0.554726364043,-0.328582416673,-0.682155867147,-1.3413860767,-0.287528283632,-0.422439301187,-0.453767212249,-0.159936458567,0.0979981205526,0.062604449512,-0.115670097782,-0.063217440302,-0.299717023424,-0.0867376013052,0.199482420773,0.275617018586,0.240289524821,0.158613178651,0.211929440642,0.169175760904,0.0397915458823,-0.229381128238,-0.268173823151,-0.00191930348958,-0.35728505953,-0.116952769953,-0.259195901811,-0.0951740696669,-0.0432575883712],[-33930.2665692,266.846137115,18.3524300026,-1534.38132289,-52.6002969013,373.71964963,-404.120811792,-415.897618617,-249.864426922,790.001407714,50.5599195712,-865.328528712,-432.707494254,438.110405206,-364.007358745,-182.944757496,26.119927422,275.142383616,42.6888968955,-75.5976330777,-40.3269761382,431.113444203,179.972695417,43.5260144696,55.4051440742,89.8458825228,-83.7634899284,111.109301535,94.6551573633,89.2804568089,117.382882646,6.52009748984,85.2326196832,-147.182211824,112.437829358,-13.8352994196,22.7366855626,-20.1243310576,17.4725775291,34.0567507722,37.1625277557,18.2669738298,-37.8573135132,35.640849468,-44.7768927182,55.3688441266,-12.731670041,33.6830692575,1.51544162349,2.9406422228,-0.301304819228,3.28274454897,13.1133450469,1.12835352596,8.191183921,-8.25793317713,20.9622497679,-12.2877369218,11.2072333723,-7.80851427739,2.16808474486,-2.02391473978,-5.31131080433,0.637618202375,1.07808229662,-2.93972398749,-2.364349773,3.02610136421,1.30923346639,3.96374461433,-0.795598466796,6.16090837238,-0.418268724907,2.17370147151,-1.66374260114,0.692917383994,-1.43475116479,-4.52294081531,0.364423729149,-0.0395715613513,0.257118266137,-0.673446337802,0.305882215962,-1.17923423887,-0.354654317332,-0.356631874158,0.899205435863,0.374298252685,0.729002440065,0.735136350598,0.809957154454,0.549514654952,-0.363408909624,-0.667842266492,-1.37044314374,-0.26788228408,-0.42709406251,-0.464911655628,-0.169003272828,0.0979079216728,0.0677935772246,-0.109734236285,-0.0552169042083,-0.294022270939,-0.0856026701515,0.196703316945,0.286138152319,0.231424284622,0.154682833415,0.208986911175,0.170296870915,0.0255473018124,-0.235443582051,-0.281528819408,0.00527957622915,-0.359956834741,-0.120335438137,-0.259728550238,-0.0940290574512,-0.0455947468856],[-33932.4092185,242.842449502,11.0583786631,-1547.13330768,-38.5860106339,345.808346581,-413.867210259,-419.31882138,-253.714353638,787.606965154,54.6359708437,-857.326509782,-417.617081193,435.920731067,-357.726708263,-175.533386957,30.7286523033,282.445319232,46.6420858844,-71.4955813648,-44.6140523978,433.202072252,186.416430036,49.7141770012,58.2771156613,88.9433162056,-83.4471445504,111.2364449,96.0740962384,86.6714268917,117.246583182,7.05064459255,84.2789396775,-149.607191592,110.738054989,-13.4081694788,21.8047248836,-21.0446101371,16.8344521753,33.739135596,36.7387629214,17.9360650966,-38.9416400314,35.19622111,-45.3974887365,54.5774248678,-14.059755045,34.1186845747,1.67636949235,2.69045014925,-0.465969118302,2.97535248274,12.737241457,0.98125468626,7.91309156257,-8.82682040521,20.9603734992,-12.5019051308,10.9801134803,-8.16988749007,2.14380453084,-1.90073743549,-5.46108964209,0.650637897856,1.11685247599,-2.93805313234,-2.43849100947,2.89132799503,1.29426778334,3.79540399778,-0.873867054587,6.15323861573,-0.509448244389,2.10894519946,-1.71932745582,0.621840501218,-1.34334739764,-4.58007926458,0.415368052891,-0.0604308013888,0.247564917655,-0.637972995888,0.325037536926,-1.18115508349,-0.371303008841,-0.345847963076,0.86543367209,0.389861591417,0.705705673766,0.705903628812,0.806323945804,0.542458094014,-0.398384569967,-0.652177650941,-1.40005503775,-0.24924750899,-0.431391735456,-0.475200825259,-0.177737150067,0.0974741413966,0.0728654074577,-0.103728493961,-0.0473951317675,-0.287858000123,-0.084321696498,0.194148899455,0.296555134252,0.222662509265,0.150921908953,0.205743540869,0.171233296181,0.0113316986763,-0.240737831751,-0.294947153041,0.0125569044577,-0.362769067824,-0.123238209177,-0.26015982777,-0.0928111682703,-0.0479124337884],[-33936.944737,223.532235288,4.82342348409,-1558.14689925,-23.4388481635,320.270664139,-424.178848233,-424.379667798,-259.079889516,783.892573975,58.3244032419,-849.284114536,-401.171521474,433.69100016,-350.759007563,-168.741775025,35.0154767489,289.273518163,50.0109775722,-67.1216795295,-49.1439306872,435.074817009,192.911213403,56.3337179602,61.1176299561,87.9386623442,-83.2335579082,111.178336345,97.4960524864,84.053753285,117.022807281,7.67847099787,83.311311234,-151.997052287,108.920711395,-12.9449392147,20.8749104114,-21.9719647407,16.1784375075,33.3805697112,36.34151543,17.5843873549,-39.9868965471,34.6832854699,-46.0311893293,53.7199274855,-15.3517537926,34.523339644,1.85536377303,2.44735881092,-0.633617359685,2.68121365783,12.3523703858,0.849076307489,7.62616869366,-9.37737563491,20.9233177631,-12.7284531665,10.7252981588,-8.52615561592,2.10280902218,-1.79455851392,-5.61363955512,0.664058112426,1.15950496854,-2.93778345662,-2.50770020384,2.75653614736,1.28492951413,3.62288692074,-0.946971170663,6.13695801445,-0.604211909995,2.03571116095,-1.77743728009,0.548341080827,-1.25418051046,-4.6381321585,0.462966641708,-0.077735403336,0.237118916746,-0.601625811951,0.343891450949,-1.18234730639,-0.386823262664,-0.333988226456,0.831449942071,0.406144468609,0.68110738808,0.67612385352,0.800769571248,0.533475933659,-0.433448989545,-0.635174692094,-1.43016417406,-0.231503083706,-0.434875437945,-0.484539259743,-0.186008048661,0.0966379546638,0.0778664834297,-0.0976985127799,-0.0398294488247,-0.281245981746,-0.0829060032832,0.191730772509,0.306770869575,0.213994459886,0.147334004282,0.202227364246,0.171901236448,-0.00282435919331,-0.245144248372,-0.308338362658,0.0199603271319,-0.365627643331,-0.125600458332,-0.260480083761,-0.0915308524662,-0.0501955591891],[-33943.0903065,207.004037232,0.0179347255333,-1567.08064195,-7.33555467926,297.340154182,-434.473902644,-431.304649195,-265.862643256,778.870110895,61.508449714,-841.022057266,-383.728702473,431.336509198,-343.293822108,-162.62212218,39.0035863167,295.566325104,52.7396383629,-62.5673947118,-53.9399646447,436.605653468,199.409163783,63.3580644346,63.9109894106,86.8400739766,-83.1269752728,110.937845881,98.9005825342,81.4454410245,116.701195294,8.38915917218,82.3251335601,-154.328080024,106.999744703,-12.4452908636,19.9470223258,-22.9086478251,15.5110375091,32.9816242136,35.977970269,17.2128895334,-40.9884856534,34.1043814288,-46.6711949116,52.7995785076,-16.6008254346,34.8946622174,2.05385017796,2.20932568516,-0.803887344603,2.4013660392,11.9590849603,0.733007356269,7.33261774952,-9.90887586223,20.8510909537,-12.9651106929,10.4410436798,-8.87407437894,2.0434148177,-1.7054165258,-5.77021765919,0.678916593398,1.20502458104,-2.93900905877,-2.57177076644,2.62161116358,1.28073401153,3.44656645228,-1.01466522845,6.11248109033,-0.702270590298,1.95389516595,-1.83722865135,0.471720872926,-1.16713955653,-4.69751786578,0.50725965955,-0.0907907668019,0.225982512061,-0.564493622635,0.362185265999,-1.18299037412,-0.401391613012,-0.321166339156,0.797033454735,0.423038262144,0.65548767195,0.64591971418,0.793249590928,0.522792730816,-0.468553949927,-0.616777255871,-1.46077790896,-0.214612587627,-0.437295444456,-0.49288711188,-0.193728968497,0.0954086514138,0.0828404883546,-0.09169207939,-0.0326074208502,-0.274240212361,-0.0813495472654,0.189355713198,0.316709534673,0.205461163992,0.143936101389,0.198489296737,0.172310997901,-0.0168964060461,-0.24857140794,-0.321670216035,0.0275019992493,-0.368448907801,-0.12738900227,-0.260660342007,-0.0902063954211,-0.0524572639055],[-33949.4657817,190.409604882,-3.08460066905,-1573.64145576,9.42202465638,277.09799264,-443.91731901,-440.228820826,-273.947300348,772.563498834,64.0798884229,-832.312283525,-365.716256125,428.749816109,-335.593898236,-157.202211342,42.7350251848,301.265060578,54.7859152135,-57.9513193945,-59.0322740133,437.631222581,205.841223628,70.7613107185,66.647339296,85.6598866847,-83.1278926701,110.520452395,100.255039754,78.8629050793,116.26649941,9.15815387178,81.3181169064,-156.576583495,104.989940223,-11.9082317311,19.0206108184,-23.8572012557,14.8398474448,32.541213596,35.6544814102,16.8226198155,-41.9424858612,33.4610706502,-47.3102899627,51.8192466819,-17.8020404279,35.2309709864,2.272852897,1.97390017348,-0.976399311912,2.13675387501,11.5579246443,0.634363115667,7.03469492645,-10.4209172342,20.7432570427,-13.2091037994,10.1253914365,-9.21048872299,1.96430992957,-1.63257553749,-5.93218717482,0.696125408393,1.25218441622,-2.94176994224,-2.63046292051,2.48647506597,1.28116828634,3.26677083357,-1.07667866689,6.08013595826,-0.803100444305,1.86347874973,-1.89782695814,0.391223745177,-1.08191040959,-4.75875454845,0.548219853067,-0.0989772928201,0.214347396429,-0.526672719931,0.37964012847,-1.18327664941,-0.41519532133,-0.307479248674,0.761935912395,0.44046444612,0.629176295128,0.615453645856,0.783733174293,0.510709368532,-0.50365428011,-0.596912006771,-1.49191983404,-0.198560713667,-0.438453818608,-0.50021843802,-0.200823669834,0.0938125503359,0.087830390445,-0.085757516609,-0.0258191732211,-0.266902744968,-0.0796419436579,0.186929291833,0.326300623728,0.197116340682,0.140748527999,0.194585973996,0.172496413332,-0.0308615857771,-0.250934937729,-0.334925038238,0.0351852030728,-0.371151823273,-0.128577518013,-0.260666794914,-0.0888580412771,-0.0547177464329],[-33954.6910169,170.900687785,-4.21069575615,-1577.53626071,26.5320446811,259.625355442,-451.674042847,-451.287237947,-283.218546278,764.996660713,65.9304975318,-822.926738866,-347.561814364,425.823478819,-327.921982291,-152.509825434,46.2518375315,306.311045109,56.1076550809,-53.3920460604,-64.4509785358,437.9881653,212.138335391,78.5175511061,69.3168248834,84.4104360501,-83.2368061262,109.931634771,101.526777518,76.3225604184,115.70347182,9.96089985295,80.2879715239,-158.718871396,102.906083266,-11.3327691231,18.0952260806,-24.8201668978,14.1724625791,32.0582523511,35.3774028253,16.4146263847,-42.8449756812,32.7549147976,-47.9412589616,50.781800756,-18.9504692299,35.5305846422,2.51339612002,1.73863167741,-1.15077350047,1.88832141342,11.1494289019,0.554458868752,6.73465642077,-10.9130958977,20.5993800021,-13.4576585749,9.77638282179,-9.53224359193,1.86418236994,-1.57529961534,-6.10091132252,0.716596625031,1.29975757681,-2.94610611046,-2.68353688933,2.35104987683,1.2857193494,3.08382830578,-1.13274092494,6.04025073311,-0.906177631027,1.76444344759,-1.95835758899,0.306093565243,-0.998178943347,-4.8223603685,0.585819968913,-0.101675382424,0.202405262679,-0.488259395826,0.395977184754,-1.18339849505,-0.428421649065,-0.293023902507,0.725909017367,0.458344494635,0.602503027368,0.584888083615,0.772189490791,0.497526729857,-0.538704809093,-0.575505609295,-1.52361354087,-0.183332154737,-0.438152624019,-0.506507294513,-0.207215912934,0.0918759701192,0.0928791579133,-0.0799431472543,-0.0195548313144,-0.259295632569,-0.0777728076738,0.184357078725,0.335473630921,0.189013709052,0.137791611841,0.190574031679,0.172491315538,-0.0446970422815,-0.252150465016,-0.348085154334,0.0430132208654,-0.373655351786,-0.129139682583,-0.260465634891,-0.0875060341765,-0.0569972052667],[-33957.3858667,145.629035487,-3.08686359228,-1578.47197678,43.6926602326,245.003418517,-456.909019676,-464.614955812,-293.561066536,756.19351945,66.9520552036,-812.637368841,-329.693009124,422.450055254,-320.540820611,-148.572747378,49.5960675351,310.64559922,56.6627049222,-49.0081671921,-70.226197955,437.513122579,218.23144152,86.6008798914,71.9095914443,83.1040576547,-83.4542116671,109.176871894,102.683149197,73.8408220108,114.996864713,10.772841872,79.2324076631,-160.731252418,100.76295914,-10.7179103455,17.1704183042,-25.8000866166,13.5164781767,31.5316549717,35.153088486,15.9899574247,-43.692033624,31.9874755346,-48.5568863875,49.6901094776,-20.0411822977,35.7918218763,2.77650403687,1.50106959845,-1.32663014912,1.65701290261,10.734137197,0.494609898592,6.43475842878,-11.3850079998,20.4190238038,-13.7080011087,9.39205922885,-9.83618392963,1.74172015097,-1.53285282572,-6.2777533228,0.741242310932,1.34651716556,-2.95205756686,-2.73075289614,2.21525761845,1.29387421152,2.89806711008,-1.18258144156,5.99315352979,-1.01097830947,1.65677079481,-2.01794593244,0.215574200785,-0.915631031538,-4.88885348798,0.62003275374,-0.0982654366474,0.190347803638,-0.449349942312,0.410917581243,-1.18354827378,-0.441257857661,-0.277897248151,0.688704471965,0.476599881786,0.575797638422,0.554385462524,0.758587709869,0.48354569784,-0.573660365873,-0.552484727941,-1.55588262101,-0.168911603752,-0.436193924307,-0.511727737709,-0.212829458056,0.0896252294532,0.0980297589724,-0.0742972941435,-0.0139045205069,-0.251480928162,-0.0757317545264,0.181544644185,0.344158050435,0.181206988202,0.135085680641,0.186510105443,0.172329537312,-0.0583799194542,-0.252133617074,-0.36113288939,0.0509893348903,-0.375878455378,-0.129049173002,-0.260023054344,-0.0861706182613,-0.0593158389022],[-33956.5674504,112.622550351,0.331650755377,-1576.18649355,60.7013596787,233.212342493,-458.979049938,-480.210631134,-304.86747797,746.203652379,67.1312912121,-801.273495366,-312.412688755,418.561406071,-313.673330336,-145.408812391,52.8059267407,314.248584547,56.4343905974,-44.88226744,-76.3739436711,436.085047378,224.058283408,94.9793785898,74.4183076979,81.7527899728,-83.774444735,108.266013165,103.703158986,71.4327755492,114.135533671,11.5732876389,78.1484384575,-162.590350402,98.5762043645,-10.0628526055,16.2457133663,-26.7973717589,12.8782462461,30.9613884206,34.9854390634,15.5502067988,-44.4807515618,31.1600932957,-49.1492355522,48.5471178112,-21.0695032888,36.0123997196,3.06281365931,1.25898968533,-1.50357029137,1.44327395756,10.312262274,0.455412546845,6.13717202001,-11.8358708864,20.2018281671,-13.9574535926,8.97111260608,-10.1194800821,1.59582937028,-1.50441796541,-6.46318241268,0.770815806879,1.39139292455,-2.95973539642,-2.77202220198,2.07894466837,1.30507987043,2.70994606858,-1.22599592863,5.93913693487,-1.11701178441,1.54055602015,-2.07572225241,0.119162603164,-0.834060219967,-4.95845966733,0.650848820622,-0.0883189529414,0.178350590059,-0.410026966435,0.424222051704,-1.18390891262,-0.453896772756,-0.262221705924,0.650149644361,0.495123963061,0.549339537546,0.524075713298,0.742925468607,0.469056887691,-0.608468466021,-0.527802976887,-1.58868632873,-0.155284486233,-0.432423763485,-0.51587285757,-0.217602729323,0.087087739611,0.103328399758,-0.0688580188591,-0.00893881529722,-0.243520392866,-0.0735189645682,0.178410125731,0.352290568653,0.173741506716,0.13263898516,0.182444628064,0.172047680138,-0.0718766451849,-0.250820046289,-0.374035834897,0.059104647441,-0.37775036727,-0.128295328883,-0.259311053866,-0.0848721636241,-0.0616844375249],[-33952.8419476,73.4137460075,5.17467417692,-1570.54157881,77.7529655081,223.828226781,-458.008353781,-497.527326448,-317.062122867,735.17925449,66.8347417735,-788.893945792,-295.524567275,414.24660285,-307.383111798,-142.996064879,55.9042961607,317.254027181,55.5079535799,-40.9529001241,-82.853793713,433.752140699,229.583798198,103.597077602,76.8457361564,80.3674830493,-84.1671984381,107.226390041,104.612414355,69.1081896211,113.124747846,12.3569966788,77.0302885696,-164.274049773,96.3648602927,-9.36755271629,15.3205398871,-27.8039115975,12.2591457703,30.3516295413,34.8685420254,15.0991510902,-45.2122748114,30.2732235999,-49.7074850982,47.356075588,-22.0317686618,36.1876285615,3.37141328663,1.01107307549,-1.6811181393,1.24555566051,9.88270999885,0.434587389518,5.84372775694,-12.2633866998,19.9477358016,-14.2037226289,8.51483712335,-10.380604004,1.42628846738,-1.488852753,-6.65409189519,0.805435546299,1.43394115318,-2.96953501018,-2.80786021907,1.94165482506,1.31862327155,2.52044632707,-1.2630451898,5.87835142174,-1.22391994364,1.41634912629,-2.13083631423,0.0173680585393,-0.75369074277,-5.03023506086,0.678330248318,-0.0721718144282,0.166524704386,-0.37031833548,0.43580967941,-1.18462559569,-0.466553476746,-0.246221587413,0.610374566154,0.513697619501,0.523206691999,0.493958749247,0.725314274597,0.454309843263,-0.643047371395,-0.501521769017,-1.62172656905,-0.142439158134,-0.426864107137,-0.519011878504,-0.221532806294,0.0842952822016,0.108834238098,-0.0636223380421,-0.0046500866696,-0.235474620258,-0.0711768787097,0.1749219297,0.35983664077,0.166629031122,0.130411468301,0.178403220805,0.171693420261,-0.0851107833418,-0.248225505497,-0.386702648044,0.067301540934,-0.379241405409,-0.126930140208,-0.258324866797,-0.083631544159,-0.0640761580815],[-33947.2128029,30.4112889003,10.3433015517,-1561.42996991,95.1416337393,216.326155494,-454.313006276,-515.881705746,-330.077274876,723.298175187,66.5238947148,-775.614923835,-278.707575113,409.634019905,-301.693936127,-141.302601547,58.9102241746,319.834494329,53.9941142463,-37.1226107318,-89.611217767,430.604915551,234.779721973,112.391994551,79.1971627803,78.9586898218,-84.5960053007,106.089704493,105.448173601,66.8755035379,111.973879781,13.1225914707,75.8714855446,-165.760550104,94.1488194858,-8.63215739249,14.3943021723,-28.8094648867,11.6593124765,29.7076076472,34.7940315394,14.6411125622,-45.8887620512,29.3271007374,-50.2200925009,46.1203088562,-22.9245680757,36.312217131,3.70100403998,0.756227253579,-1.8587786996,1.06181046052,9.44405951803,0.429136061208,5.55617107524,-12.6648787811,19.6567651644,-14.4446109224,8.02517750589,-10.6183530523,1.23309396724,-1.48493363748,-6.84648108986,0.845061235781,1.4738747902,-2.98192290074,-2.83893339742,1.80285624223,1.33375134723,2.33067961228,-1.29385630167,5.81091193545,-1.33137782072,1.28481380936,-2.18244275864,-0.0890470632325,-0.674854506166,-5.1029434213,0.702556982008,-0.0503510006478,0.154965106987,-0.33023823179,0.44563913501,-1.18583407132,-0.479448616217,-0.230146677026,0.569584934802,0.532073613539,0.497426708545,0.464001979331,0.705894103063,0.439543840568,-0.677308030422,-0.473729466891,-1.65464090966,-0.130364708021,-0.419580901241,-0.521233058532,-0.224631432391,0.0812807314179,0.114609669744,-0.0585770070985,-0.00101115472995,-0.227403912037,-0.0687585030009,0.17106102964,0.366768914184,0.159872937436,0.128350995999,0.174405302046,0.171317202616,-0.0979951817874,-0.244385772643,-0.399027252445,0.0755102178164,-0.380332158926,-0.125021259553,-0.257065534662,-0.0824697597105,-0.066454749209],[-33940.6834607,-13.9761545254,14.7386277593,-1548.74440422,113.161520391,210.181212742,-448.209082496,-534.59043302,-343.845207644,710.738263873,66.6602378631,-761.552633209,-261.640642703,404.852031545,-296.629574451,-140.296519096,61.8427591616,322.162553194,52.0035929732,-33.2939447507,-96.5916855193,426.733884945,239.617790818,121.302147058,81.4778735298,77.5369632278,-85.0243978473,104.887658493,106.247695016,64.7431566109,110.69230202,13.8686944933,74.6655569277,-167.028050967,91.9479745053,-7.85681334871,13.4664045277,-29.8037903808,11.0788820914,29.0345520519,34.7535417726,14.1804134779,-46.5123719594,28.3219589981,-50.6755152356,44.8431436639,-23.7444911894,36.3808741572,4.05028704054,0.493359704255,-2.03605697901,0.889990806647,8.99488997795,0.436060196511,5.27624741061,-13.0376704714,19.3289347124,-14.6779211783,7.50407847894,-10.8315245836,1.01624239484,-1.49143706786,-7.03634931623,0.889652581913,1.51090677436,-2.99736556066,-2.86590818702,1.66201707359,1.34971102979,2.14175765092,-1.31855634082,5.73693342109,-1.43906044921,1.14661376548,-2.22969622634,-0.199320392294,-0.597883416372,-5.17534850138,0.723608966872,-0.0233834911401,0.143766758232,-0.289800837709,0.45366908915,-1.1876700879,-0.492802837757,-0.214246759169,0.52798644776,0.550004707607,0.472027193946,0.43417281251,0.68480492923,0.42499815562,-0.711161391532,-0.44451443307,-1.68706691827,-0.119050224457,-0.410640091776,-0.522624655676,-0.226910351036,0.0780769614527,0.120717090447,-0.0537087814341,0.00200516041587,-0.219368569897,-0.0663168434914,0.166808399093,0.373060036293,0.153476601672,0.12640543419,0.170470290172,0.170969472135,-0.110442688384,-0.239336625671,-0.410903571714,0.0836608805355,-0.381003216951,-0.122636339491,-0.255534098987,-0.0814078101231,-0.0687839595445],[-33934.2573656,-57.3399178246,17.2617476789,-1532.37761908,132.106781483,204.868482635,-440.012657513,-552.970172262,-358.29819482,697.677369952,67.7052590452,-746.823277629,-244.002700475,400.029012083,-292.213797901,-139.945914228,64.7209495012,324.410770982,49.6471101371,-29.3694476682,-103.740666656,422.22956189,244.069740816,130.265552745,83.6931543654,76.1128562048,-85.4159086022,103.651954013,107.048236894,62.7195881512,109.289387108,14.5939282257,73.4060302639,-168.054751933,89.7822179128,-7.04166729957,12.5362512591,-30.7766468339,10.5179903422,28.3376920686,34.7387068922,13.7213761005,-47.0852632144,27.2580326722,-51.0622107774,43.5279060592,-24.488127662,36.3883083691,4.41796340947,0.221377912162,-2.21245798422,0.728049147964,8.53378052502,0.452361430024,5.00570219874,-13.3790851119,18.9642629029,-14.9014561013,6.95348476775,-11.018915955,0.775730275169,-1.50713949315,-7.21969589383,0.939169291286,1.54475004441,-3.01632948253,-2.88945103787,1.51860547287,1.36574925157,1.95479216972,-1.33727238384,5.65653082371,-1.54664286267,1.00241269081,-2.27175135806,-0.312689558787,-0.523109379607,-5.24621405385,0.741566148092,0.00820373455499,0.133024618488,-0.24902033558,0.45985821248,-1.19026939376,-0.506836787952,-0.19877161825,0.485784802486,0.567243664135,0.447035754965,0.404438657744,0.662186728319,0.410912064431,-0.744518403154,-0.413965030115,-1.71864216259,-0.108484796006,-0.400107624719,-0.523274927956,-0.228381305648,0.0747168464992,0.127218895957,-0.0490044164551,0.00442603866199,-0.211428895536,-0.0639049062313,0.162145011606,0.378682654493,0.147443399845,0.12452264881,0.166617603563,0.170700673754,-0.122366150995,-0.233113842529,-0.422225529463,0.0916837315383,-0.381235168613,-0.119843032597,-0.253731601297,-0.0804666952414,-0.0710275377248],[-33928.5062352,-97.7438769819,17.138698562,-1512.42425694,152.093661244,199.83210074,-430.085855769,-570.489346635,-373.339574119,684.228176404,70.0017253694,-731.548002865,-225.561730157,395.325209576,-288.457380691,-140.214549196,67.5593795007,326.718675271,47.0180411018,-25.2754777753,-110.996630456,417.166394499,248.113943319,139.229723322,85.8494616084,74.696809647,-85.7341066838,102.414197784,107.883980197,60.8117225772,107.772024069,15.3018519718,72.0826104191,-168.818075289,87.6666896986,-6.1883170703,11.6038925992,-31.7193936598,9.97938528724,27.6244544811,34.7427865764,13.2667162028,-47.606670154,26.1346841206,-51.3680665453,42.1777333959,-25.1523660939,36.3309351582,4.80217516036,-0.0607746332017,-2.38736293073,0.57457640323,8.06028463446,0.475767077895,4.74611401215,-13.6864025469,18.5628652995,-15.1119779854,6.37523774026,-11.1792325075,0.51201185455,-1.5307701119,-7.39280306325,0.993484235461,1.57505602689,-3.03924193698,-2.91005041902,1.37233473343,1.38131070737,1.77088760487,-1.34998576356,5.56993409603,-1.65349748433,0.852872741177,-2.30773783653,-0.428400508371,-0.450709347637,-5.3142498078,0.756589714086,0.0439216605302,0.122805701207,-0.207938445254,0.464160582873,-1.19375058856,-0.52173826666,-0.183886835151,0.443195415338,0.583593544606,0.422530963691,0.37483777268,0.63820422406,0.397551415609,-0.777254423735,-0.382172507,-1.74898918884,-0.0986478355207,-0.388041725171,-0.523270731129,-0.229051564618,0.0712341727277,0.134160054598,-0.0444525963539,0.0062776639427,-0.203643113036,-0.0615704229385,0.157064459608,0.383610699461,0.141784006256,0.122654983792,0.162876932741,0.170560565266,-0.133690644253,-0.225760582127,-0.432888515308,0.099516779725,-0.380997905808,-0.116707022138,-0.25165808415,-0.0796610749457,-0.0731549459334],[-33922.2748803,-135.142077701,14.8952871485,-1489.78658052,172.526756752,194.392408453,-418.974999185,-587.223415988,-388.756939529,670.242700521,73.4175210682,-715.867722908,-206.44191865,391.028367065,-285.319109372,-141.048848445,70.3547771793,329.093635129,44.1403811802,-21.0336445767,-118.270044566,411.554571284,251.755310761,148.180146849,87.9579330242,73.298816274,-85.9427075862,101.205615567,108.77679656,59.0204247357,106.137167862,16.0157723373,70.6697115422,-169.292334176,85.5975195689,-5.30416492857,10.6719624882,-32.6297929092,9.47626431131,26.9110559527,34.7655425457,12.8127235965,-48.0641297547,24.9477879881,-51.5786897322,40.7950082502,-25.7352908518,36.2119965659,5.19882787644,-0.354010422943,-2.55965786915,0.430717370027,7.57785309677,0.506907182481,4.49839397062,-13.9567286333,18.1252458934,-15.3020874803,5.77076533527,-11.31081152,0.227372264759,-1.56086912088,-7.55308474922,1.0521229459,1.60123009946,-3.06637330677,-2.92748287568,1.22389870736,1.39663114183,1.59111923047,-1.35609483784,5.47783322133,-1.75778629603,0.698649911201,-2.33668551248,-0.545732448767,-0.380240454425,-5.37794939773,0.769165826231,0.083433125409,0.113065232177,-0.166707036619,0.466511907108,-1.19816367696,-0.537563686817,-0.169421176654,0.400472578281,0.599058606708,0.398795253523,0.34569180972,0.613121134201,0.385288348138,-0.809102451801,-0.349239658353,-1.77767045733,-0.0894800530111,-0.374469734727,-0.522693311898,-0.228910496203,0.067666374219,0.141515824974,-0.0400497204703,0.00758223635287,-0.196061136021,-0.0593400280036,0.151610811072,0.387823234987,0.136538288353,0.12077269505,0.159319056771,0.170596155899,-0.144390149872,-0.217349527235,-0.442793782864,0.107129259808,-0.38021853149,-0.113286114149,-0.249309594222,-0.0789802492605,-0.0751585005388],[-33913.9763845,-169.961108115,11.3822625499,-1465.56875763,192.632753295,187.838798626,-407.272459053,-603.399599341,-404.308949105,655.507793172,77.7018096554,-699.928293809,-186.856504153,387.458101337,-282.744773579,-142.390901968,73.0994064844,331.509979995,41.0207806722,-16.6893703804,-125.464376224,405.388215859,255.005390844,157.111805472,90.0308767395,71.928756762,-86.0054633976,100.057337883,109.745480285,57.3450445804,104.379289926,16.7639327528,69.1379251028,-169.451064449,83.5660846586,-4.39806425267,9.74374079314,-33.5072072922,9.02443713071,26.2159106169,34.8083620317,12.3540816026,-48.4422546526,23.6923469902,-51.6791174749,39.3819245042,-26.2352852438,36.0364412962,5.60326803336,-0.65920594332,-2.72810505886,0.298255315642,7.09091103121,0.547137467689,4.26328633075,-14.1871257312,17.6520057824,-15.4633448246,5.14139213429,-11.4118982556,-0.0754456410722,-1.59592946639,-7.69823779754,1.11452411904,1.62261612758,-3.09795475275,-2.94134697211,1.07423638639,1.41214406206,1.41655503008,-1.35485222078,5.38103319051,-1.85736866931,0.540398655206,-2.35759927869,-0.663972903212,-0.31110487948,-5.43575243449,0.779861889142,0.126438931448,0.103730490268,-0.125505517069,0.466843299192,-1.20354151493,-0.554336614632,-0.155119206017,0.357880302183,0.613693407178,0.376162023185,0.317393269954,0.587225924995,0.374521573598,-0.839759895893,-0.315272165215,-1.80423340692,-0.0809124827755,-0.359411274103,-0.521622514704,-0.227942993629,0.0640517970316,0.14924403826,-0.0357941169309,0.0083609600275,-0.188730800501,-0.0572350814854,0.145840752857,0.39130060814,0.131753411869,0.118850516497,0.156025026858,0.170853767744,-0.154450876335,-0.207960741589,-0.451844051748,0.114498212951,-0.378813451376,-0.109636145359,-0.246681179225,-0.0784071782458,-0.0770362314558],[-33902.0238315,-202.627556358,7.45037387802,-1440.87495608,211.638336162,179.46066411,-395.570606666,-619.245115716,-419.754260903,639.810305226,82.6037546447,-683.875571615,-167.018724862,384.93402918,-280.680162947,-144.182799759,75.7855313632,333.942039311,37.665889878,-12.2880774946,-132.483092671,398.661451839,257.87573127,166.019681338,92.0806008807,70.5965117874,-85.886126206,99.0004952538,110.808825674,55.7849320651,102.492861699,17.5745766491,67.4578425706,-169.267801963,81.5637621028,-3.47886842088,8.82250738111,-34.350999519,8.63971346175,25.5574326073,34.8726322658,11.8854735425,-48.7256574837,22.3633638428,-51.6543869098,37.9406760399,-26.6507325783,35.8092180529,6.01084210676,-0.977237680589,-2.89146675925,0.17897350736,6.60388355708,0.597813657428,4.04153534916,-14.3746562005,17.1437460645,-15.5873102569,4.48844271885,-11.4807379776,-0.393699009814,-1.63444409474,-7.82595905399,1.18012645132,1.6385579767,-3.13421743574,-2.95124127254,0.924286762271,1.42828297516,1.24826298728,-1.34551052648,5.28033899449,-1.95010397568,0.378773427514,-2.36948402791,-0.782409394944,-0.242704802313,-5.48609852893,0.789245307432,0.172639880902,0.0947287543501,-0.0845132940006,0.46508587313,-1.20991695843,-0.572080616313,-0.140725486496,0.315682597912,0.627552502756,0.354964671402,0.29033465447,0.560807062696,0.365649803566,-0.868924164557,-0.280375708626,-1.82822547645,-0.0728761591124,-0.342885964016,-0.520138183984,-0.226133950122,0.0604287872238,0.157302525631,-0.0316841138621,0.0086350391016,-0.18169994249,-0.0552769434426,0.13981097182,0.394023165988,0.12747654254,0.116863182045,0.153075894205,0.171379722887,-0.163859032126,-0.197674288922,-0.459942041577,0.12160068032,-0.376699071185,-0.105812952496,-0.243767886867,-0.0779248219619,-0.0787861685994],[-33884.8303051,-233.568010563,3.95037024467,-1416.80934367,228.77019064,168.547397758,-384.461813313,-634.987184133,-434.851532978,622.937087553,87.8725195498,-667.855412374,-147.141818974,383.775767381,-279.071067112,-146.366631811,78.405415763,336.364142517,34.0823590975,-7.87518822728,-139.229661145,391.368402839,260.377879742,174.898756594,94.1194135743,69.3119620264,-85.5484480995,98.0662181991,111.985627031,54.3394371435,100.472354621,18.4759474567,65.6000554153,-168.716082574,79.5819290365,-2.5554308115,7.91154211918,-35.1605322995,8.33790302071,24.9540360573,34.9597404794,11.4015827375,-48.8989508842,20.9558412614,-51.4895351735,36.4734567393,-26.9800161633,35.5352755401,6.4168965723,-1.30898212101,-3.04850522968,0.0746552124678,6.12119579366,0.660291475605,3.83388528245,-14.5163824014,16.6010678374,-15.665544016,3.81324167045,-11.5155759491,-0.724644988333,-1.67490595224,-7.93394536436,1.24836863918,1.64839951229,-3.17539251656,-2.95676434122,0.774988826735,1.44548138822,1.08731108563,-1.32732236903,5.17655562417,-2.03385158667,0.214428682444,-2.37134465289,-0.9003294472,-0.174442402434,-5.52742729189,0.797883485718,0.22173677603,0.0859873032951,-0.0439097748078,0.461170742928,-1.21732286341,-0.590819258067,-0.125984581348,0.274143476334,0.640690450178,0.335536596898,0.26490846436,0.534153013556,0.359071749622,-0.896292666333,-0.244655969627,-1.84919410477,-0.0653021163201,-0.324913425182,-0.518320164181,-0.223468258908,0.0568356908541,0.165649118265,-0.0277180393904,0.00842567771019,-0.175016397995,-0.053486973934,0.13357815482,0.395971255599,0.123754846099,0.114785425604,0.150552710017,0.172220343419,-0.17260082573,-0.186570232971,-0.466990471968,0.12841370308,-0.373791796636,-0.101872372288,-0.240564764858,-0.077516140469,-0.0804063418844],[-33861.6319349,-263.263654246,1.63970435628,-1394.24438573,243.4689803,154.661144229,-374.368809837,-650.740702565,-449.384049782,604.754131177,93.2498784078,-652.008205673,-127.442736392,384.17262155,-277.833462701,-148.873999677,80.9394094809,338.735269441,30.2799230662,-3.51218431875,-145.622711529,383.539231124,262.515307617,183.750475042,96.1543148257,68.0779812186,-84.9712816976,97.2821535774,113.294605136,53.0064657929,98.3187915567,19.4895631879,63.5338005293,-167.777633077,77.6156138333,-1.63669622259,7.01277177677,-35.9343268794,8.1324232687,24.4225949428,35.070890233,10.8979425106,-48.9504429233,19.4634937208,-51.1721700113,34.9839928376,-27.2227901246,35.219617021,6.81752695364,-1.65457546179,-3.19801294286,-0.0130078338224,5.64715483,0.735299643904,3.64038350504,-14.6102324974,16.0246096825,-15.6906903976,3.11800306313,-11.5151001592,-1.0653078015,-1.71634919821,-8.02065443515,1.31879830545,1.65176162975,-3.22146533014,-2.95774946502,0.627138817479,1.4640021117,0.934387673467,-1.29985390208,5.07049510549,-2.10668841943,0.0480108654217,-2.36232550171,-1.01694506634,-0.106003434253,-5.5585424404,0.806191875863,0.273421389738,0.0774602458923,-0.00384747653841,0.455075844889,-1.22578627088,-0.61054658504,-0.110728611087,0.233486357975,0.653133579315,0.318166671592,0.241472768753,0.5075167076,0.355106971788,-0.92157188843,-0.208278336016,-1.86677587141,-0.0581323700271,-0.305505373446,-0.516234958781,-0.219961523696,0.053290412051,0.174237358277,-0.0238979565071,0.0077541113,-0.168717383241,-0.0518813007276,0.127203279709,0.397128137743,0.120625098323,0.112600251569,0.148514359476,0.173406070217,-0.180658349554,-0.174750401352,-0.472911855608,0.134920806196,-0.370023262957,-0.0978709397717,-0.237078080855,-0.0771662498372,-0.0819013158498],[-33834.9570339,-292.414052455,0.902643298216,-1373.12573758,256.031281831,138.45505542,-365.035765275,-666.171284803,-463.233601359,585.443987746,98.4480473482,-636.452475244,-108.153273839,385.792652597,-276.764074305,-151.594551138,83.3202057128,340.953001464,26.2806542614,0.67521476243,-151.641524276,375.348253573,264.259180871,192.602127101,98.1710721559,66.8694153579,-84.1938817456,96.6620135973,114.754186684,51.7781480845,96.059401071,20.6100401799,61.2228964959,-166.466944032,75.6744498217,-0.731975131403,6.12271073272,-36.6675386458,8.02712264594,23.9738226086,35.2065504032,10.3734861924,-48.8832234035,17.8748827328,-50.7001816027,33.4821399828,-27.383791858,34.8674639967,7.2118249666,-2.01119274395,-3.33890322468,-0.0826900245943,5.18559563414,0.821058875105,3.45828986255,-14.6575978673,15.4151601144,-15.6597299266,2.40849894102,-11.4797695012,-1.4117799862,-1.75997284403,-8.08758741577,1.39139877858,1.64937334441,-3.27143790777,-2.95496882116,0.480961956005,1.4834251694,0.78866255818,-1.26392543745,4.96299760436,-2.16756157372,-0.119865613715,-2.34212874363,-1.13116619119,-0.0382079517784,-5.57970411604,0.813978118729,0.327349377549,0.069209010607,0.0356286451515,0.446966404514,-1.23531096212,-0.631138558128,-0.0951399252367,0.193772301999,0.664795312558,0.30296566018,0.220247908944,0.481008929937,0.35375842386,-0.944504632706,-0.171647022611,-1.88096391869,-0.0513528611811,-0.284641905161,-0.513895707475,-0.215752190123,0.0497290872243,0.183003631556,-0.0202408676625,0.00664170056472,-0.162797635288,-0.0504551224275,0.120764488323,0.397488727991,0.118082515162,0.11032374626,0.14693106368,0.174903819323,-0.187997231695,-0.162403677216,-0.477707877471,0.141131449835,-0.365386023413,-0.0938679832167,-0.233358982306,-0.076868890176,-0.0833017935308],[-33808.1569608,-321.773365621,2.03015775054,-1353.16735208,266.967650204,120.855035031,-356.037208213,-680.83222359,-476.306604146,565.268349063,103.171853024,-621.301278358,-89.5089397403,388.173610254,-275.629813509,-154.407445535,85.4685835047,342.899570358,22.1097095956,4.54523011555,-157.280542484,367.005825715,265.572589135,201.487464846,100.150144965,65.6541035018,-83.2706035202,96.2160268047,116.382724846,50.6451701127,93.7279631537,21.8252693513,58.6298073213,-164.806696941,73.7717215687,0.14933056504,5.23652026821,-37.3544815212,8.02345733745,23.6168922421,35.3670061957,9.8279971151,-48.7040775606,16.1772815681,-50.0740307356,31.9792861759,-27.4690295766,34.4840925277,7.599631375,-2.37526871947,-3.47011961433,-0.133157285005,4.74023514386,0.915162879762,3.28416731845,-14.660735693,14.7735451315,-15.570727185,1.69139084076,-11.4104855942,-1.75992115731,-1.80751711411,-8.13700631632,1.46626231342,1.64224070152,-3.32406645486,-2.94942930946,0.336540709767,1.50315988848,0.64892591193,-1.2206708265,4.85491032172,-2.21563569491,-0.288594354027,-2.31059600325,-1.24182724371,0.0278404160812,-5.59153656657,0.820897902426,0.383167365636,0.0613218558238,0.0745005249537,0.437054469601,-1.24589490344,-0.652441617166,-0.0794884305797,0.155021777227,0.675560845431,0.289999800554,0.201419794269,0.454704929446,0.354949908075,-0.964842779683,-0.135225950991,-1.89184052964,-0.0449605120596,-0.262295211807,-0.511302209002,-0.21100941431,0.0460674108543,0.191880034929,-0.0167675101717,0.00510983750972,-0.157241271411,-0.0491984053473,0.11434421349,0.397050855614,0.11611192261,0.107980266478,0.145750877707,0.176664625569,-0.194578984175,-0.149740707594,-0.481400015603,0.147061577965,-0.35988786078,-0.0899235292017,-0.229469836606,-0.0766199576047,-0.0846450125867],[-33784.5830746,-352.095754174,5.31321839335,-1334.08318207,276.788640392,102.786986766,-346.94766724,-694.276811668,-488.509474585,544.488906931,107.126122088,-606.667672284,-71.7452425241,390.853244255,-274.197591894,-157.191842208,87.3053219022,344.45720789,17.7922459816,7.95608283989,-162.53420925,358.72230308,266.418622039,210.44024035,102.071992652,64.3998847075,-82.255802298,95.9544217456,118.198572797,49.5982179722,91.3582577947,23.1231416208,55.7169970117,-162.819573304,71.9207136415,0.997818969709,4.34936166441,-37.9894694281,8.12288352825,23.3609770306,35.5525428164,9.2612586111,-48.4197906304,14.3579634975,-49.2941781982,30.4868194183,-27.4845114939,34.0747786745,7.98078694268,-2.74323814032,-3.59060565102,-0.163175540213,4.31479029696,1.01520536843,3.11457883617,-14.6219031568,14.1005907319,-15.4217467548,0.973340299009,-11.3081500573,-2.1055909297,-1.86072223286,-8.17117314693,1.54348116483,1.63136974638,-3.37810717681,-2.94213782978,0.19395754622,1.52261559607,0.513967906877,-1.1712239206,4.74708045849,-2.25007542839,-0.457568954572,-2.26756890515,-1.34776264586,0.0910380404175,-5.59466403976,0.826606915064,0.440521980172,0.0538870399272,0.11275009756,0.425552087949,-1.25753606117,-0.674302201988,-0.0640440338963,0.117255252479,0.685315373457,0.279335330603,0.185174334063,0.428679955008,0.358605226674,-0.982338209884,-0.0994790427315,-1.89948798727,-0.0389522449403,-0.238437484865,-0.5084542621,-0.205902352378,0.0422210774208,0.200798665227,-0.0134986213499,0.00317991414043,-0.152032408884,-0.0481011158003,0.108024888042,0.395812349882,0.114698146658,0.105594169025,0.144921856634,0.178639523787,-0.200365119015,-0.136972139517,-0.484009748047,0.152727134554,-0.353536557833,-0.086097604305,-0.225473011149,-0.0764153482427,-0.0859682106768],[-33767.5867339,-384.135378546,11.0427959067,-1315.5871804,286.004807364,85.1768143288,-337.341670941,-706.05834178,-499.748629114,523.367353154,110.015681192,-592.664714294,-55.0976906174,393.369304332,-272.234321044,-159.826900497,88.7511999513,345.508145832,13.3534203319,10.7659940348,-167.39696767,350.708041197,266.760369214,219.494205688,103.917074618,63.0745980324,-81.2038333557,95.8874269661,120.220083709,48.6279777576,88.984064984,24.4915479071,52.4469295733,-160.528254621,70.1347106072,1.80408818558,3.45639620251,-38.5668162891,8.32685740336,23.2152501613,35.7634454708,8.67305401273,-48.0371478484,12.4042017919,-48.3610847785,29.016127711,-27.4362458229,33.6447984975,8.35513243348,-3.11153575847,-3.69930487395,-0.171510715374,3.91297803125,1.11878005166,2.94608737915,-14.5433574409,13.3971229138,-15.2108532181,0.261008852403,-11.1736645097,-2.44464891826,-1.92132842465,-8.19234991772,1.62314758766,1.61776652424,-3.43231627902,-2.93410128192,0.053294932817,1.54120161934,0.382578715181,-1.11671857112,4.64035521561,-2.27004541954,-0.62618301441,-2.21288907391,-1.44780681958,0.150281292322,-5.58971078335,0.830760844755,0.499059847332,0.0469928213014,0.150359297662,0.412671307356,-1.27023240165,-0.696566752428,-0.0490766419672,0.0804931965766,0.693944092159,0.271038488219,0.171697437662,0.403009255501,0.364648181894,-0.996742803831,-0.0648702194091,-1.90398857459,-0.0333249821006,-0.213040915815,-0.505351665507,-0.200600160447,0.0381057814041,0.209691619278,-0.0104549385123,0.00087332246223,-0.14715516498,-0.0471532201001,0.101888944806,0.393771040067,0.1138260133,0.103189810704,0.144392055538,0.18077954881,-0.205317148236,-0.124308620017,-0.48555855285,0.158144063568,-0.346339897347,-0.082450235105,-0.221430873332,-0.0762509582093,-0.0873086254604],[-33759.7318735,-418.3342213,19.3576662105,-1297.40654335,295.055111787,68.7958639592,-326.8845804,-715.7968433,-509.904086798,502.177607166,111.640630015,-579.404036903,-39.7660601076,395.348786848,-269.556364719,-162.203624138,89.7234589449,345.962182146,8.8225994087,12.840286821,-171.859051042,343.163923521,266.56129629,228.652803918,105.664848726,61.6433238985,-80.1590552065,96.0267348084,122.459355285,47.7281812566,86.6276491327,25.9228839999,48.7734910888,-157.959294923,68.4261011241,2.55896759392,2.5547655192,-39.0815941234,8.6379023166,23.1867390145,36.000248117,8.0613490897,-47.5641065737,10.3037106716,-47.2774985139,27.5780171605,-27.3288427035,33.1996416338,8.722653775,-3.47612960775,-3.79526851551,-0.157172886597,3.53795683883,1.22376338183,2.77487204154,-14.4276075988,12.6637674266,-14.937022288,-0.439640214627,-11.0077121165,-2.77378842205,-1.99081459697,-8.20302216208,1.70539404233,1.60253120472,-3.48555528781,-2.92620386462,-0.0852878024061,1.55832329746,0.253579081314,-1.05834790247,4.53547085379,-2.27481706027,-0.794009174024,-2.14620070943,-1.54102811908,0.204629274854,-5.57734407441,0.83311029368,0.558424738932,0.0407027139311,0.187317822663,0.398605355832,-1.28395214351,-0.719079586803,-0.0348555255515,0.0447842584385,0.70135065828,0.265167759257,0.161153615264,0.377720221024,0.3730135503,-1.0079081364,-0.0318050833695,-1.90547613137,-0.028053775779,-0.18609833838,-0.502001514305,-0.195265517432,0.0336403039298,0.218489440412,-0.00766313326318,-0.00177891844067,-0.142583792058,-0.0463593359068,0.0960252932708,0.390933427646,0.113474257503,0.100790989833,0.14410118128,0.183050545319,-0.209411204853,-0.111925553211,-0.486084116182,0.163345209606,-0.338325936498,-0.0790230426354,-0.217407336265,-0.0761147526151,-0.0886959120643],[-33760.4327318,-453.885553528,29.787826184,-1279.32144105,304.092137103,53.7972520511,-315.605086679,-723.379292118,-518.750277205,481.242498927,112.182160334,-566.991573616,-25.8071977227,396.775674677,-266.177895377,-164.260394447,90.1251891651,345.839379571,4.24598937239,14.0726924055,-175.893853458,336.252945204,265.786372898,237.798242032,107.290766695,60.0601081856,-79.1258393099,96.3898927994,124.903463349,46.9047430293,84.2652123365,27.4275651738,44.6162559473,-155.154738348,66.803690215,3.25421168923,1.64953267332,-39.5319073371,9.06281029702,23.2738877425,36.264479723,7.41683936117,-47.0133126577,8.04596815593,-46.0553164383,26.1809662937,-27.1613199805,32.7456520267,9.08391754997,-3.83112084933,-3.8779785809,-0.120148733783,3.19065142919,1.3291627786,2.59557644028,-14.2781701687,11.9003490248,-14.6028742026,-1.12543662654,-10.8101022272,-3.09303747681,-2.06961438947,-8.20656950648,1.79051381159,1.58714045478,-3.53710701314,-2.91883897215,-0.221323889092,1.57337001775,0.125912038995,-0.997542131304,4.43271987286,-2.26408872857,-0.96133623959,-2.06635831281,-1.62743062753,0.253792018937,-5.55840330716,0.833785520309,0.618249009364,0.0349812542007,0.223646420814,0.383472182234,-1.29854451476,-0.741676537361,-0.0216474113211,0.0102898073689,0.707512573437,0.261750621442,0.153621780514,0.352648806553,0.38368000575,-1.01608455985,-0.000455960035614,-1.90429072433,-0.0230261980575,-0.15768515525,-0.498440088937,-0.19003519343,0.0287557727056,0.227116457963,-0.00517361436457,-0.00470728116892,-0.138253082824,-0.0457826862674,0.0905487495497,0.387340702916,0.113597250128,0.0984192707951,0.143955547849,0.185477597398,-0.212681905856,-0.0998573715469,-0.485688956711,0.168431019783,-0.329603830063,-0.0757840257525,-0.213472495928,-0.0759629725344,-0.0901293954858],[-33768.316123,-489.670468455,41.7110779463,-1261.12528704,313.196872451,40.1795375361,-303.622713338,-728.759400755,-526.035232529,460.897086031,111.91673695,-555.531833185,-13.2422178509,397.723197326,-262.162537655,-165.947437138,89.8559431413,345.187367038,-0.325993767148,14.3640440168,-179.470559209,330.128629324,264.400944667,246.782418006,108.769278709,58.2762381383,-78.0985603619,96.9959122623,127.533228255,46.1666233287,81.8614411122,29.0205115743,39.8862206146,-152.160501566,65.2753869942,3.88180624432,0.747741079206,-39.9166184332,9.60944054248,23.4729946905,36.5579180087,6.72840278367,-46.398584075,5.62089321355,-44.7087228351,24.8328717431,-26.9312974257,32.2893871959,9.43963550491,-4.17014392624,-3.94702476851,-0.0606690877873,2.87142806613,1.43426840345,2.40246032304,-14.0988135605,11.1064922143,-14.2119403312,-1.79390836002,-10.5804257374,-3.40325780245,-2.15790012489,-8.2065951007,1.87884038375,1.5731650657,-3.58635958589,-2.91227729767,-0.354269696302,1.58572717959,-0.00144880574437,-0.935790747332,4.33228383246,-2.23766554896,-1.12863205871,-1.97201896047,-1.70725236036,0.297642287464,-5.53377090515,0.833011697185,0.678162158662,0.0297682340946,0.25937360308,0.36737091563,-1.31382899572,-0.764191314834,-0.00971838992606,-0.0228006072311,0.712425800467,0.260806800462,0.149159447917,0.327583108282,0.396637196431,-1.02162212081,0.0290631444008,-1.90082397695,-0.0181079509792,-0.12789741136,-0.494710966189,-0.185039481334,0.023386402085,0.235495447767,-0.00304272486768,-0.00783261124435,-0.134087965071,-0.0455011455757,0.0855806064144,0.383042728382,0.114143271012,0.0960956594929,0.14385312102,0.188100598983,-0.215178489232,-0.0881032645597,-0.484491801233,0.173518841847,-0.320303007219,-0.0726827777678,-0.209697994016,-0.0757439280328,-0.0916008181895],[-33782.0088616,-524.570059304,54.5052236163,-1242.61149489,322.450306967,27.9412793459,-291.056983935,-731.890881732,-531.506984962,441.476426068,111.120824665,-545.129324361,-2.09223488047,398.264584297,-257.573916187,-167.214977922,88.8152734028,344.053773481,-4.84293400003,13.6151748834,-182.558352588,324.944498958,262.370357227,255.457229815,110.074834949,56.2430010011,-77.0715930583,97.8638045201,130.32947036,45.5227824081,79.3810219767,30.7166433472,34.4943815563,-149.022501247,63.8491005757,4.43373703199,-0.143565848797,-40.2345899145,10.2856522508,23.7803582037,36.8823406944,5.98491731372,-45.7337388005,3.01840481328,-43.2519019875,23.5416301408,-26.6363948103,31.8374046612,9.79051938631,-4.48683328151,-4.00199677671,0.0210352205387,2.58065301346,1.53837041787,2.18978343747,-13.8933061838,10.2818215007,-13.767752043,-2.44258339175,-10.3182735425,-3.70531111889,-2.25584412597,-8.20670209448,1.97070724713,1.56217582879,-3.63270113695,-2.90678953435,-0.483581593098,1.59478018233,-0.129529846871,-0.874583240259,4.2343442922,-2.19535264595,-1.29636447898,-1.86183972883,-1.78073133296,0.336052843326,-5.5043292919,0.83101399685,0.73779368686,0.0250034455973,0.294527880422,0.350400685088,-1.3296250667,-0.786457629953,0.000665447983599,-0.0542974359601,0.716086302209,0.262356022008,0.147824131981,0.302311222405,0.411874770526,-1.0248708659,0.0566382237477,-1.89546751271,-0.0131647365868,-0.0968311516417,-0.490857722847,-0.180408674034,0.0174664064211,0.243549185659,-0.00132680782376,-0.0110757541888,-0.13001336659,-0.0455925882252,0.0812421566363,0.378089366546,0.115060599989,0.0938411618268,0.143691866566,0.190959444007,-0.216950192965,-0.0766624217829,-0.482611376543,0.178726023543,-0.310552897145,-0.069668891993,-0.206155472224,-0.0754059291758,-0.0931019226402],[-33800.1377617,-557.465419302,67.5480653132,-1223.57347815,331.933429789,17.0810364121,-278.02742203,-732.72744757,-534.913566698,423.31557663,110.070888282,-535.888555895,7.62163680036,398.473065097,-252.475655609,-168.013242513,86.9027324788,342.486227831,-9.25441531637,11.7269182338,-185.126417885,320.854077183,259.659956209,263.674575435,111.1818856,53.9116840185,-76.0393120953,99.0125808961,133.273010016,44.9821805206,76.7886414467,32.530880638,28.3517352383,-145.786654058,62.5327400738,4.90198982503,-1.01734469634,-40.4846842838,11.0993046199,24.1922766274,37.2395255002,5.17526090787,-45.0325948086,0.228421923905,-41.6990381788,22.3151381192,-26.2742319061,31.3962619425,10.1372809407,-4.77482335815,-4.04248430391,0.124733360341,2.31869253497,1.64075898333,1.9518055312,-13.6654164482,9.42596139,-13.2738407074,-3.06898969841,-10.0232365381,-4.00005914605,-2.36361871544,-8.21049363758,2.06644789005,1.55574353534,-3.6755197972,-2.90264637534,-0.608715948542,1.59991442533,-0.259357478354,-0.815409099793,4.13908281172,-2.13695514405,-1.465001348,-1.7344776943,-1.84810556078,0.368896449415,-5.47096089096,0.828017591846,0.796773093993,0.0206266806934,0.329137763805,0.332660619676,-1.34575220804,-0.808309193448,0.00923801175777,-0.0840111294171,0.718490041498,0.266418011769,0.149673347212,0.276621245115,0.429382376221,-1.02618084173,0.0821552718131,-1.88861295508,-0.00806225692336,-0.0645824210291,-0.486923935696,-0.176273064423,0.0109300000675,0.251200447475,-8.22062840637e-05,-0.0143575555241,-0.125954215173,-0.0461348886099,0.0776546929868,0.372530479913,0.116297516896,0.0916767836981,0.143369750262,0.194094026405,-0.21804625504,-0.0655340327502,-0.480166409435,0.184169912617,-0.300482929018,-0.0666919617398,-0.202916572249,-0.0748972860289,-0.0946244513027],[-33821.4039192,-587.515811964,80.2942340733,-1203.89614981,341.81005998,7.56715376389,-264.697173186,-731.251236672,-536.046798921,406.687254348,108.987068716,-527.88739169,15.8496185743,398.492054585,-246.9382131,-168.311019893,84.0357502668,340.514064068,-13.5232946207,8.62092480524,-187.13684219,318.004782186,256.260782965,271.310255614,112.070040683,51.2405783128,-74.9984948857,100.459844996,136.349671263,44.5567359541,74.0657376445,34.4741396628,21.3881239272,-142.498316496,61.3322969424,5.27948618137,-1.86808880137,-40.6665500589,12.0575153262,24.7070660701,37.6303922248,4.29090714136,-44.30840032,-2.75510390178,-40.0653488155,21.161215209,-25.8426941526,30.9716644604,10.4801823777,-5.02903390324,-4.06816468288,0.25020485532,2.08596909216,1.74068329643,1.6836201247,-13.4188084969,8.53934441484,-12.7343129382,-3.67105861539,-9.69553652363,-4.28831296712,-2.48124609634,-8.22114879191,2.1663175641,1.55514758975,-3.71447952244,-2.90008743313,-0.729124676353,1.60062009919,-0.391817410753,-0.759544068711,4.04676862847,-2.06252892035,-1.63487344591,-1.58909951185,-1.90964882425,0.396047256164,-5.43462713685,0.824265593177,0.854740371151,0.0165915204339,0.363176376032,0.314210866335,-1.36208607925,-0.829617943214,0.0157899327331,-0.111792357823,0.719628430991,0.272997032058,0.154763047092,0.250311903491,0.44909711307,-1.02589745101,0.105456159086,-1.88066026659,-0.00268361629846,-0.0312701125467,-0.482931257086,-0.172742866035,0.00373205858591,0.258371152478,0.000640738845621,-0.0176094346174,-0.121854175961,-0.0471906504076,0.0749170946299,0.366419226076,0.117808538189,0.0896297467493,0.142798522738,0.197526241515,-0.218518021154,-0.0547309846228,-0.477274293186,0.189953900166,-0.290224750104,-0.0637102694236,-0.2000556615,-0.074171925866,-0.0961621487033],[-33844.8055568,-614.993181969,92.5056766023,-1183.8304206,352.575336295,-0.752879180508,-251.403870994,-727.558090974,-534.873658783,391.614811998,107.864211343,-521.097116261,22.4272749077,398.745709043,-241.059376021,-168.151352129,80.2032661361,338.093436366,-17.6655204749,4.30211536974,-188.523323781,316.519612594,252.266661749,278.335682182,112.739549579,48.2159905175,-73.9555297109,102.217569559,139.565292869,44.2701991349,71.2607551134,36.5413209186,13.6087730938,-139.20060437,60.2460919954,5.56289079948,-2.69643851097,-40.7829798165,13.1644359603,25.3311136933,38.0524289805,3.33371206438,-43.572124539,-5.92209077495,-38.3701837973,20.087372534,-25.3407296629,30.5659092391,10.8176877598,-5.24952588009,-4.07906578402,0.397270647377,1.88312993716,1.83722869426,1.3836558296,-13.1567294075,7.62563521612,-12.1555763282,-4.24833491296,-9.33791891471,-4.57068111835,-2.60814799294,-8.24015026792,2.2702585739,1.56050184891,-3.75034756819,-2.89922799745,-0.844241868876,1.59680655944,-0.527232620994,-0.707408902067,3.95802169131,-1.97313286215,-1.80576328296,-1.42691015066,-1.96577796397,0.417384964167,-5.39660550806,0.820072865692,0.911377473648,0.0129067021361,0.396395287265,0.294955643495,-1.3787270566,-0.850408725796,0.020338730193,-0.137652669891,0.719474682619,0.282035491676,0.163142941005,0.223224448138,0.470745886118,-1.02434752072,0.126206262779,-1.87204276612,0.00301847191133,0.00289548841514,-0.478813641624,-0.169847974969,-0.00408989762788,0.264979793652,0.000815695241292,-0.0208051062167,-0.117731863489,-0.0487613944326,0.0730385863005,0.359821942988,0.119573126811,0.0877521355897,0.14194507406,0.201205990286,-0.218425267851,-0.0443209550716,-0.474047086996,0.196125550682,-0.27991888002,-0.0607168538759,-0.197658010246,-0.0732062447944,-0.097716767615],[-33869.4151786,-640.44764429,104.021168523,-1163.71870067,364.807227416,-8.06178690531,-238.528771049,-721.772278291,-531.404912426,378.059261394,106.640837651,-515.462369272,27.1615060379,399.72837011,-234.943764276,-167.59584456,75.412096824,335.162203945,-21.7103143557,-1.20377179191,-189.212463732,316.515462142,247.797112535,284.746169744,113.195821508,44.8312311443,-72.919207569,104.296319606,142.930717287,44.149278524,68.4388900021,38.7233209731,5.03775400963,-135.936073315,59.2705283866,5.74980416293,-3.50457092453,-40.8375521484,14.4234765914,26.0728244214,38.5022659581,2.30812734583,-42.8341669155,-9.25842422278,-36.633926147,19.1010441167,-24.7675522184,30.1804412034,11.1478116124,-5.43764555605,-4.07530311211,0.565762032969,1.71087851982,1.92943954904,1.05117503034,-12.8823219909,6.6893064617,-11.5446137149,-4.80076672007,-8.95376003094,-4.8477214993,-2.74359600986,-8.26855668822,2.37813498736,1.5716287828,-3.78416701487,-2.90015227733,-0.953497163117,1.58848795286,-0.665785402596,-0.659210607986,3.87354962691,-1.8700766093,-1.97731630194,-1.24962415844,-2.01694558558,0.432790661562,-5.35825249406,0.815772212704,0.966376847854,0.00959475218428,0.428490679511,0.274760187457,-1.39583169558,-0.870744614904,0.0229586454078,-0.161643833953,0.717997458132,0.293460336051,0.17486117731,0.195210760547,0.494003051779,-1.02185323391,0.144026836784,-1.86320211157,0.0090738920627,0.037681248375,-0.47448311948,-0.167598207967,-0.0124776869696,0.270944007408,0.0004223327244,-0.0239288589154,-0.113624629641,-0.0508333707837,0.0720059791259,0.352808263692,0.121576982324,0.0861022505705,0.140790079151,0.205065175072,-0.217829879387,-0.0343853193948,-0.47059551655,0.202718472008,-0.269708056472,-0.0577134430319,-0.195811614473,-0.0719822561298,-0.0992920628727],[-33894.3052888,-664.429313898,114.679485459,-1143.90340016,379.083702023,-14.5422938948,-226.453128946,-714.018066442,-525.651325994,365.981614351,105.255469132,-510.92779039,29.8592122021,401.934379424,-228.695997767,-166.706102522,69.6690590679,331.658226028,-25.6868977393,-7.87099839893,-189.130863118,318.109224567,242.971655299,290.537032902,113.44426569,41.0796107044,-71.8983194582,106.706660159,146.456786971,44.2206825826,65.6653384591,41.0110363936,-4.30086205349,-132.747278967,58.4020092696,5.83782675531,-4.29466314143,-40.833845646,15.8380472887,26.9406031793,38.9765333484,1.21860465463,-42.1049268999,-12.7499897725,-34.8769588875,18.2096639795,-24.1223756004,29.8167052784,11.4685684612,-5.59473919847,-4.05699217194,0.755510308551,1.56991828996,2.01636023295,0.685440111341,-12.5987290581,5.73483081945,-10.9084079358,-5.3283021657,-8.54643619191,-5.11999200948,-2.88686175167,-8.30742667541,2.48981087238,1.58835086142,-3.81698094291,-2.90294448184,-1.05632019608,1.5756784262,-0.807658049077,-0.615156194592,3.79406006196,-1.75466980167,-2.14917794564,-1.05895608292,-2.0636042947,0.442145436485,-5.32092458434,0.811696437524,1.01943094014,0.00667819696228,0.459158734772,0.253489734523,-1.41355655165,-0.890688684246,0.0237239196476,-0.183817618344,0.715165419282,0.307198510608,0.189965904366,0.166122722208,0.518542966467,-1.01873677365,0.158539134995,-1.85457996086,0.0155125285124,0.0728540338513,-0.469851720824,-0.166003381771,-0.0213731278349,0.276181430158,-0.000559678883604,-0.0269649813069,-0.109569826302,-0.0533928295593,0.0718060842336,0.345447821231,0.123805804292,0.0847383920425,0.139314212934,0.209035698227,-0.216793740018,-0.0250054528908,-0.46703030753,0.209766271987,-0.259735017165,-0.0547017648269,-0.194604470165,-0.0704819731877,-0.100891789311],[-33918.5483915,-687.488305765,124.319403032,-1124.72692923,395.982728799,-20.3771246332,-215.558200281,-704.419723243,-517.623665628,355.342882684,103.646627273,-507.438019279,30.3272936378,405.858078622,-222.4206964,-165.543731353,62.9809696051,327.519361833,-29.6244921022,-15.6738261706,-188.205123014,321.417793605,237.909810017,295.70358626,113.490291345,36.9544397094,-70.9016563769,109.459156238,150.154344373,44.5111197717,63.0052966333,43.3953637478,-14.3830038239,-129.676776963,57.6369377982,5.8245590602,-5.06889226104,-40.7754389012,17.4115581215,27.9428548915,39.4718613423,0.0695956596852,-41.3948039423,-16.3826729511,-33.1196650417,17.4206661447,-23.4044135901,29.4761463891,11.7779728317,-5.72215307472,-4.02424846827,0.966346770578,1.4609526974,2.09703511822,0.28571345705,-12.3090934202,4.76668095724,-10.2539418282,-5.83088937881,-8.11932371722,-5.38805054844,-3.03721682298,-8.35781885209,2.60515029686,1.61049055476,-3.84983243275,-2.90768882,-1.15214060477,1.55839212624,-0.953032853955,-0.575452670008,3.72026062315,-1.62822207912,-2.32099365685,-0.856620471825,-2.10620669697,0.445330377072,-5.28597826837,0.808178343464,1.07023219687,0.00417956285416,0.488095635052,0.231009520996,-1.4320581803,-0.91030400753,0.0227087941827,-0.204225791399,0.710947227818,0.323176960771,0.208505270533,0.135812214611,0.544039986597,-1.015320323,0.169364411304,-1.84661797193,0.022364265617,0.108180711362,-0.464831475828,-0.165073313122,-0.0307180386197,0.280609698314,-0.00215066976127,-0.0298977619843,-0.105604805355,-0.0564260208582,0.0724257127511,0.337810248648,0.126245292278,0.0837188603569,0.137498150332,0.213049462102,-0.215378733998,-0.0162627308577,-0.463462185618,0.217302558462,-0.250142499805,-0.0516835471963,-0.194124573305,-0.0686874092838,-0.102519701765],[-33941.6092215,-710.339402285,132.817548872,-1106.38035061,415.932769064,-25.6747525148,-206.113353441,-693.107031137,-507.296633979,346.100661131,101.775515963,-505.004064598,28.4596569095,411.871120594,-216.194971587,-164.153246315,55.3565907035,322.697156994,-33.5766297585,-24.5627282932,-186.39716277,326.524708596,232.716618745,300.232679411,113.336194121,32.4539479462,-69.9404218338,112.553315542,154.031792778,45.0299046761,60.5157459728,45.8616980946,-25.1765025303,-126.752887938,56.9738899821,5.70713455691,-5.8288513374,-40.666866571,19.1452571902,29.0856436778,39.9822183234,-1.13348909565,-40.7145746976,-20.1407423418,-31.3805442745,16.7392231795,-22.6142880082,29.1602946139,12.0737831652,-5.82134400654,-3.97749401146,1.19853742299,1.38463795428,2.17047831048,-0.148328739401,-12.0166020409,3.7892910547,-9.58852709109,-6.30860166605,-7.6759703614,-5.65227429294,-3.19384272835,-8.42032665158,2.7237960881,1.637678374,-3.88351027278,-2.91421335411,-1.240565539,1.536787623,-1.10206198447,-0.54027576728,3.65276685706,-1.492327971,-2.49246091445,-0.644539599146,-2.14531594582,0.442137048101,-5.25456904227,0.805483725266,1.11860435159,0.00210567199746,0.515018845921,0.207248307365,-1.45140556266,-0.929661269601,0.0200512080109,-0.222918841125,0.70533382962,0.341301920981,0.230394011465,0.104136458615,0.570083643382,-1.01194083312,0.176163723737,-1.83971773064,0.0296604018138,0.143417915508,-0.459351775168,-0.164772271877,-0.0404502172583,0.284156627533,-0.00435233808347,-0.0327135531793,-0.101766222972,-0.0598905708007,0.073840017157,0.329963083178,0.12886946966,0.0830767100285,0.135316295735,0.217024052355,-0.213656957213,-0.00823155381222,-0.459993835361,0.225343208503,-0.241063405668,-0.0486614520805,-0.194427619055,-0.0665878910714,-0.10417148943],[-33964.5214366,-734.356055541,140.201958635,-1088.44933738,438.764254702,-30.2466465738,-197.94040798,-680.231831065,-494.500679731,338.198876128,99.6940686738,-503.902410972,24.4982338912,419.854403229,-209.985900778,-162.510802361,46.8124667517,317.197902777,-37.6940863727,-34.3930238216,-183.810174838,333.380091292,227.439211855,304.077301915,112.971815373,27.5960423039,-69.0354693807,115.944416468,158.087778793,45.7167763756,58.2208091243,48.3734284598,-36.616799403,-123.946992538,56.4201332541,5.48081870766,-6.57379724305,-40.5164875746,21.0317447203,30.3656704389,40.4909254463,-2.38140357021,-40.0765246402,-24.0019987509,-29.6705628185,16.1614618305,-21.7582528332,28.8710206455,12.3527335667,-5.89421103328,-3.91837683401,1.45408709968,1.34144132189,2.23558284917,-0.615355050076,-11.7246184951,2.80694133857,-8.92079086957,-6.76201304487,-7.22060961877,-5.91231752867,-3.3555605723,-8.49368275005,2.84450611105,1.66877699512,-3.91778608333,-2.92132155935,-1.32191219986,1.51160117948,-1.25477710271,-0.509676119136,3.59182598991,-1.34972156456,-2.66348534167,-0.425466643978,-2.18193738586,0.431998920911,-5.22704842879,0.803610343389,1.16489628645,0.000400529543792,0.539730967202,0.182388950877,-1.47131738247,-0.94886159984,0.016143891041,-0.239942134222,0.698405307082,0.361396781723,0.255013212004,0.0709740325526,0.595924167227,-1.00899432753,0.178757346845,-1.83412053473,0.0374378918614,0.178281353215,-0.453411451558,-0.164882340342,-0.05049137984,0.286790750456,-0.00709185401039,-0.0354069616756,-0.0980879524781,-0.0636296095943,0.075977515335,0.321965478822,0.13160565508,0.0827440122279,0.132717971404,0.220819787855,-0.211741352064,-0.000958423143794,-0.456695776751,0.233833176097,-0.232591290308,-0.0456418774411,-0.195440099284,-0.0642019985541,-0.105810578945],[-33988.7109251,-761.07638504,146.538519985,-1070.36821518,464.158110239,-33.8300247544,-190.749296245,-665.951478592,-479.030188075,331.578037034,97.4769012788,-504.475912017,18.7719627842,429.566135669,-203.733052928,-160.575464368,37.3670876691,311.041576863,-42.1519484468,-44.996243278,-180.582669946,341.90070905,222.110241797,307.181978322,112.383882885,22.4035489471,-68.2100650797,119.576680091,162.318509859,46.4940800738,56.1363940341,50.8884423606,-48.6312381726,-121.216236406,55.9851079032,5.1404099704,-7.30240280519,-40.3336168966,23.0614589684,31.7772952703,40.9786420585,-3.66394284838,-39.4933164495,-27.9426260406,-27.9988035483,15.6812473892,-20.8439700826,28.6102803299,12.6113020567,-5.94276374867,-3.84885147401,1.73543534202,1.33178282385,2.29121150715,-1.11362023834,-11.4365505103,1.82387354734,-8.25968917014,-7.19182271039,-6.75764641856,-6.16765381855,-3.52110135931,-8.5761546344,2.96581699005,1.70245713525,-3.95217719272,-2.92756076413,-1.39667530124,1.48371348194,-1.41117974451,-0.483673083226,3.53759316781,-1.20342183656,-2.83402459781,-0.202362511688,-2.21718690951,0.414259943483,-5.2035669573,0.802488949723,1.20958817079,-0.00100756360172,0.562055882285,0.156677832966,-1.49142474916,-0.968013738765,0.0114432709094,-0.255339757067,0.690264026729,0.383264222499,0.281610544287,0.0362088541262,0.620726963332,-1.00689159786,0.17700535931,-1.83002760985,0.045735104599,0.212476499491,-0.447026698214,-0.16514005394,-0.0607592219931,0.288490778967,-0.0102777556985,-0.0379746578951,-0.094603171485,-0.0674576434686,0.07875506652,0.313874493776,0.134369490991,0.0826275922894,0.129646229063,0.224282670773,-0.209755072581,0.00551713453971,-0.453630488646,0.242699684456,-0.22480987285,-0.0426321552448,-0.197056205037,-0.0615556250731,-0.10739233131],[-34015.6035754,-792.03851029,151.893120582,-1051.57130968,491.7952602,-36.1621050006,-184.249950582,-650.423329284,-460.679544202,326.178653212,95.198629649,-507.067421349,11.6097817897,440.764527056,-197.375996997,-158.306297214,27.0389433749,304.248156928,-47.1253024832,-56.2039171844,-176.853158822,352.003329227,216.762361025,309.491233183,111.55912444,16.8992940403,-67.4874749932,123.394327486,166.720193415,47.2841609742,54.2784086485,53.3646273142,-61.1471625697,-118.517765186,55.678254218,4.6807068031,-8.01334085104,-40.1275695216,25.2248381914,33.3148782678,41.4260275075,-4.97090201455,-38.9776128046,-31.938808073,-26.3743493385,15.2924451471,-19.8791017743,28.3800295132,12.8459666559,-5.96901174646,-3.77087246952,2.04502169137,1.35608248377,2.33622705728,-1.64137906755,-11.1558058143,0.844329419541,-7.61417799934,-7.59872985773,-6.29148569004,-6.4177567255,-3.68919609386,-8.6660097915,3.08626534945,1.73738951155,-3.98620092925,-2.9314782969,-1.46534955704,1.45400521663,-1.57127144567,-0.462286017199,3.49022353686,-1.05644776374,-3.00403634221,0.021811892359,-2.2521804092,0.388264063795,-5.18427515719,0.802050296157,1.25316017395,-0.00219030653394,0.58181747456,0.130361335067,-1.51135877213,-0.987226426894,0.00640577525255,-0.269155796032,0.681012355084,0.406706922808,0.30943368045,-0.000275158962255,0.643657436903,-1.00604343573,0.170767839818,-1.8276401817,0.0545904088657,0.245708829344,-0.440213708356,-0.165281948091,-0.0711714393455,0.289235424954,-0.0138185813043,-0.0404133122597,-0.0913450576051,-0.0711891786528,0.0820895299468,0.305747186231,0.137076619851,0.0826342755477,0.126044120441,0.227258703284,-0.207821272793,0.0111555926305,-0.450860449902,0.251869956794,-0.217802872418,-0.0396396174582,-0.19917012736,-0.0586746639697,-0.108872107526],[-34046.6252758,-828.780550796,156.33164809,-1031.49294651,521.356629108,-36.9801052568,-178.152303336,-633.804738706,-439.243133304,321.941234019,92.933869656,-512.019792586,3.34062910903,453.20778653,-190.854301941,-155.662365775,15.8465237881,296.837620651,-52.7892349837,-67.8475760628,-172.760152192,363.604719178,211.428221989,310.949591048,110.484267822,11.1061037481,-66.8909651835,127.341579727,171.289036902,48.0093642805,52.6627609137,55.7598708378,-74.0919163252,-115.808724525,55.5090124875,4.09650766368,-8.70528420777,-39.9076604343,27.512320646,34.9727795271,41.8137411408,-6.29207615311,-38.5420763849,-35.9667287103,-24.8062830638,14.9889203956,-18.8713099259,28.1822240417,13.053205385,-5.97496462038,-3.68639435861,2.38528568913,1.41476032525,2.36949227243,-2.19688630107,-10.8857921345,-0.127449306337,-6.99321336368,-7.98343368201,-5.82653236245,-6.66209981244,-3.85857578045,-8.76151570825,3.20438781361,1.77224484119,-4.01937462122,-2.93162148605,-1.52842968115,1.42335706982,-1.73505374202,-0.445534278704,3.44987224319,-0.911818322858,-3.17347823416,0.244095662795,-2.28803377733,0.35335522983,-5.16932355785,0.802225134582,1.29609246526,-0.00321939834775,0.598839627414,0.103685838614,-1.53075056079,-1.00660840474,0.00148783170682,-0.281434337493,0.67075265867,0.431527562151,0.337730292631,-0.0385940890108,0.663880993139,-1.00686063276,0.159904867049,-1.82715947593,0.0640421735007,0.27768381778,-0.432988675204,-0.165044558219,-0.0816457275252,0.2890034003,-0.0176228689844,-0.0427195951913,-0.0883467884506,-0.0746387213764,0.0858977648503,0.297640614382,0.139642684115,0.0826708873371,0.121854697263,0.229593887558,-0.20606310673,0.0159174245207,-0.448448139374,0.261271216324,-0.211654008138,-0.0366715960483,-0.201676057297,-0.055585008585,-0.110205268591],[-34083.1108627,-872.194461287,160.070155489,-1009.83931636,552.545102018,-36.1883362868,-172.145309411,-616.210579606,-414.64353109,318.802444854,90.7288927743,-519.527278134,-5.75244413718,466.623396461,-184.120182652,-152.612961505,3.83755659804,288.837033079,-59.2525986022,-79.7631782969,-168.434107522,376.607862807,206.150872723,311.525673374,109.157096268,5.04944426559,-66.4309553086,131.367346684,176.017359461,48.6016821572,51.3004867689,58.039306858,-87.3880887785,-113.051148333,55.480862255,3.38637709841,-9.37815298609,-39.6803127454,29.9123762059,36.7431344663,42.1259011459,-7.61855307755,-38.194611628,-40.0036243707,-23.2997644942,14.7634190231,-17.8272404324,28.0187119241,13.2300571021,-5.96276187802,-3.59723757775,2.75741245518,1.50764070696,2.39044300533,-2.77795182325,-10.6289270776,-1.08757189948,-6.40354507623,-8.34648308668,-5.3667075762,-6.89964108401,-4.02795208715,-8.86076440729,3.31883395704,1.80579693718,-4.05137121362,-2.9268471894,-1.5863225502,1.3924965705,-1.90236325344,-0.433328586355,3.41644673845,-0.771925894602,-3.342114689,0.461893079656,-2.32553726864,0.309188427363,-5.15876857571,0.802944657762,1.33886315174,-0.00416668788786,0.613003858122,0.0768213706842,-1.5492746449,-1.02623141064,-0.00293195412454,-0.29224725057,0.659581004059,0.45754303852,0.365864765269,-0.0787536266293,0.680747568839,-1.0096014717,0.14439074874,-1.82870813698,0.0741228233552,0.308195375589,-0.42537066687,-0.164194404146,-0.092106050558,0.287798182022,-0.0216158558681,-0.0448906431933,-0.0856365861893,-0.0776532804133,0.0900955109874,0.289594494113,0.142005884088,0.0826490756415,0.117047407799,0.23116619874,-0.204568519358,0.0197817489241,-0.446437632508,0.270837971348,-0.206414919287,-0.0337333861898,-0.204475699439,-0.0523227671825,-0.111351894841],[-34126.0309653,-920.587537383,163.925357026,-987.40407,585.151406095,-34.3594801342,-165.834013933,-597.58579345,-387.316075346,316.683575262,88.5165928909,-529.189725566,-15.5699351511,480.615932124,-177.176437756,-149.16828216,-8.82327942682,280.301808732,-66.3593105984,-91.8043937167,-163.973269228,390.860610198,201.014943579,311.284489247,107.619614835,-1.23465809077,-66.06647941,135.439293403,180.881927045,49.0316946128,50.1831341242,60.1970549381,-100.939251706,-110.226623599,55.5734400831,2.56394400673,-10.0368564306,-39.4403820698,32.4056012136,38.6091797931,42.3604610697,-8.94659151784,-37.9240900058,-44.0309416959,-21.8442609816,14.6042093055,-16.7494746978,27.8909098205,13.3758040162,-5.9350626823,-3.50468615692,3.15756942354,1.63216532783,2.40080742818,-3.38060600233,-10.3836677667,-2.03355165988,-5.84309817611,-8.6878258084,-4.91399731636,-7.12727631176,-4.19595933638,-8.96114605439,3.428705155,1.83723199603,-4.08248611812,-2.91725038221,-1.63908369172,1.36153861874,-2.07237693613,-0.42514510262,3.38886369653,-0.636656475476,-3.50893714602,0.674069164585,-2.36417858714,0.256662793357,-5.15229017533,0.804141821966,1.38194209126,-0.00510462299831,0.624422219491,0.0496325409273,-1.56677923558,-1.04601917415,-0.00678626477109,-0.301777535365,0.647568258013,0.484627123881,0.393668332006,-0.120317895674,0.694345227171,-1.01391419982,0.124656708824,-1.83209448432,0.0848410073288,0.337391156682,-0.417390251048,-0.162617943302,-0.102501446059,0.285722307645,-0.0257895749768,-0.046925457095,-0.0832228512115,-0.0802098747147,0.0945940302032,0.281579172065,0.144194651476,0.0824997790431,0.111697286485,0.231981503864,-0.203284619378,0.0228022658409,-0.444799391101,0.280533870516,-0.202008925753,-0.0308221358907,-0.207500812551,-0.0489649077141,-0.112290943948],[-34176.2651607,-971.620909923,168.864132266,-965.252723211,618.988229031,-32.2333116622,-158.802484586,-577.832838888,-357.824294377,315.502070828,86.201519496,-540.458381243,-26.0582282155,494.759242025,-170.038511816,-145.348752071,-21.942067748,271.294449499,-73.8870543836,-103.829320014,-159.467828467,406.197027983,196.115460493,310.315144655,105.924884031,-7.70753697401,-65.7437251248,139.529773726,185.855617309,49.2796286166,49.2973788828,62.2344810507,-114.644222492,-107.321625575,55.7604217886,1.6466033764,-10.6875510694,-39.1798321484,34.9706236285,40.5519275375,42.5188332994,-10.2737429331,-37.7146247488,-48.0311798837,-20.4253167736,14.4984401157,-15.6395780035,27.8001265536,13.4902891735,-5.89465611001,-3.40989002454,3.58066960677,1.78518022183,2.40288679303,-4.00043432757,-10.1474812039,-2.96325289521,-5.30759150898,-9.00725929216,-4.46990377914,-7.34138570895,-4.36121251414,-9.05987535105,3.53321573292,1.86583931012,-4.11317036306,-2.90323556913,-1.68668079598,1.33044495734,-2.24410683033,-0.420351350932,3.36579209684,-0.505269465932,-3.6727438005,0.879854124624,-2.40311979915,0.196988502572,-5.14947420833,0.80575002434,1.42579707935,-0.006105801273,0.633264398213,0.0219076046353,-1.58315596431,-1.06585842266,-0.0100856047956,-0.310235974729,0.634778987338,0.51266780869,0.421088938786,-0.162740628315,0.704946562897,-1.01929455548,0.101248200288,-1.83704825615,0.0961994303331,0.36550725075,-0.409080870326,-0.16023161752,-0.112787220041,0.282903079829,-0.0301527583048,-0.0488235038074,-0.0811090284631,-0.0823180257765,0.0993034648649,0.273547652571,0.146259975835,0.0821587587734,0.1059057643,0.232077642935,-0.202123306427,0.025051320593,-0.443485473538,0.290329847564,-0.198327267577,-0.027932956367,-0.210690668942,-0.0455986130539,-0.113006092919],[-34234.6930261,-1022.95570975,175.853360774,-944.450791787,653.868258519,-30.549605734,-150.634789053,-556.854174568,-326.731716487,315.175377135,83.6882220797,-552.784491528,-37.1637076132,508.627174666,-162.721849391,-141.174795573,-35.3248918269,261.877457266,-81.6135133691,-115.69605488,-155.007976392,422.451182794,191.547449398,308.706745592,104.125964367,-14.3305260372,-65.4088800903,143.611141496,190.911307905,49.325711138,48.6298969476,64.1529511682,-128.401818523,-104.322629517,56.0154831887,0.651750195167,-11.3363934306,-38.8906267223,37.58607141,42.5523897295,42.6024302219,-11.5975587823,-37.5503290873,-51.9868381319,-19.0284761175,14.4332603263,-14.4991156306,27.7476709462,13.5733556205,-5.84433123792,-3.31399910897,4.02162601741,1.96353142297,2.39898235195,-4.63302228819,-9.9178343911,-3.87453991315,-4.79274392048,-9.30458098294,-4.03592916076,-7.53834948885,-4.52232660644,-9.15416699878,3.63158001622,1.89090817181,-4.1438749768,-2.8852072548,-1.72908155325,1.29917732909,-2.41656497631,-0.418314854724,3.34590091882,-0.37702426642,-3.83233284776,1.07847816682,-2.44152297098,0.131375729767,-5.14990652634,0.807702662027,1.47089591158,-0.00724282030581,0.63970008098,-0.00656518289976,-1.59829646256,-1.08563588354,-0.0128404787607,-0.317833351508,0.621277758845,0.541553083404,0.448074531555,-0.205475556719,0.712824170783,-1.02523827706,0.0747106761167,-1.8432991907,0.10820079728,0.392779747485,-0.400475967293,-0.156951868633,-0.122918678517,0.279467801228,-0.0347141378464,-0.0505842502413,-0.0792985628899,-0.0839872550946,0.10413395734,0.265452939962,0.148252846721,0.081561776064,0.0997742722239,0.231492455958,-0.200996480142,0.0266012585022,-0.442447938203,0.300196836229,-0.1952611848,-0.0250609588347,-0.213984540922,-0.042311066076,-0.113481018761],[-34302.1941386,-1072.2530677,185.859922114,-926.063791517,689.604182252,-30.048137213,-140.914995017,-534.552259139,-294.60186998,315.620939766,80.8812501321,-565.619302783,-48.8327576271,521.793578552,-155.241895043,-136.666836996,-48.7778351251,252.113333924,-89.3163709664,-127.262696007,-150.683904158,439.457141263,187.40593623,306.548398049,102.275916353,-21.0649589333,-65.0081319437,147.655750554,196.021876489,49.1501691465,48.1673642219,65.9538312633,-142.110857182,-101.216110679,56.3123001003,-0.403220549221,-11.9895400423,-38.5647295323,40.2305725177,44.5915783993,42.6126642244,-12.9155905246,-37.4153162516,-55.8804156381,-17.6392832608,14.3958188102,-13.3296528606,27.7348518211,13.6248464035,-5.7868771428,-3.21816333862,4.47535166801,2.16406496522,2.39139535699,-5.27395537344,-9.69219433048,-4.7652770214,-4.29427425626,-9.57958832573,-3.61357565744,-7.71454786474,-4.67791659928,-9.24123569911,3.72301233032,1.91172787349,-4.17505098767,-2.86356994387,-1.76625365377,1.26769747681,-2.58876341433,-0.418403137428,3.32785914189,-0.251180277392,-3.98650248309,1.26917149821,-2.47855016896,0.0610346497022,-5.15317298098,0.809933132175,1.51770638348,-0.00858827769063,0.643898954485,-0.0359975663857,-1.61209236181,-1.10523828417,-0.0150613912293,-0.324780448553,0.607129139341,0.571170938482,0.474573056255,-0.247976413055,0.718250645589,-1.03124110295,0.0455895892969,-1.85057702617,0.120847813081,0.419444736579,-0.391608984536,-0.152695138473,-0.1328511275,0.275543774501,-0.0394824455959,-0.0522071633075,-0.0777948994378,-0.0852270841647,0.108995649995,0.257248038569,0.15022425369,0.0806445921464,0.093404241235,0.230263782938,-0.199816040159,0.0275244248902,-0.441638843483,0.310105770249,-0.192701917464,-0.0222012545098,-0.217321700799,-0.0391894496545,-0.11369939848],[-34378.8240575,-1117.67477828,199.399464769,-910.813387488,725.784773923,-31.3411280016,-129.393448832,-510.851898558,-261.995212662,316.741575605,77.6696900459,-578.458285248,-60.9632496685,533.914102093,-147.655999266,-131.876446411,-62.0946977682,242.088915793,-96.7864101461,-138.408754059,-146.557792243,456.998081583,183.770144283,303.911978638,100.427212071,-27.8595584959,-64.4938152877,151.64082249,201.155614124,48.7360969072,47.8922477977,67.6384731769,-155.666387911,-97.9893317891,56.6281244245,-1.50043718489,-12.6521244774,-38.1977232277,42.8812864825,46.6494487163,42.5519748,-14.2236526926,-37.293776021,-59.6927086186,-16.2435181724,14.3723314124,-12.134593408,27.761727668,13.6452417298,-5.7261701052,-3.1235992147,4.93673650741,2.38355993446,2.38195430054,-5.91767922619,-9.46805448152,-5.63329202418,-3.8075112026,-9.83264415398,-3.20429470359,-7.86628372203,-4.82632524251,-9.31841342309,3.8068091858,1.92740497079,-4.2072154597,-2.83861001074,-1.79810343482,1.23601607575,-2.75952325124,-0.419880289493,3.31048377467,-0.127086047122,-4.13421947166,1.45117270558,-2.51315310414,-0.0127462104238,-5.15870365198,0.812328020035,1.56651754838,-0.0102211790989,0.64600782747,-0.0665158003634,-1.62445871973,-1.12454457178,-0.0167607059704,-0.331272786148,0.592417589287,0.60135447851,0.500517236789,-0.289708826905,0.721525246631,-1.03674249332,0.0144819514414,-1.85855692796,0.134107528497,0.445668603755,-0.382526842928,-0.147395878005,-0.14252811068,0.271256302694,-0.0444440275829,-0.0536950693908,-0.076600111402,-0.0860595988298,0.113793480194,0.248900433507,0.152224278425,0.0793449414441,0.0869089304546,0.228455708021,-0.198494366049,0.0278955776851,-0.44099161142,0.320005180468,-0.190545928196,-0.019357874092,-0.220624759375,-0.036304418499,-0.113654921618],[-34461.3422706,-1159.38529063,215.182712879,-898.045841969,761.103151221,-34.5305881597,-116.485611541,-485.767288019,-229.459920344,318.381586735,73.8807758252,-590.973804679,-73.2590036631,544.971593322,-140.189136289,-126.979776839,-75.0201465384,231.988376936,-103.866812117,-149.099391588,-142.579778416,474.653628201,180.656086286,300.800446464,98.629969895,-34.6126042805,-63.8428525868,155.563049891,206.262465509,48.0780578687,47.7701795236,69.2081722234,-168.948388376,-94.6327054657,56.9545123981,-2.62012130346,-13.325188488,-37.7996660915,45.5094991216,48.7017284084,42.4269098661,-15.5106121132,-37.1702043693,-63.3977013637,-14.8279037072,14.345281867,-10.9246947213,27.8233556445,13.6375704505,-5.6704352207,-3.03178952974,5.4005782296,2.61852762407,2.37059663622,-6.5540801039,-9.2430141335,-6.47626671197,-3.32622280826,-10.066372855,-2.80933468629,-7.98955063481,-4.96480634134,-9.38350121993,3.88259583381,1.93631507245,-4.24114959958,-2.81014130883,-1.8242918216,1.20433953105,-2.92690186034,-0.42159666944,3.29318394248,-0.00444671516918,-4.27512485824,1.62375389462,-2.54344206649,-0.0883649136564,-5.16530553158,0.814586663304,1.61690349059,-0.0122461625124,0.64608199689,-0.0979041787056,-1.63540429877,-1.14340257293,-0.0179582235785,-0.337444834325,0.577307143747,0.631717264599,0.525778908887,-0.330186017507,0.72305389143,-1.04095679556,-0.0178089913277,-1.8666957701,0.14780437769,0.471338918857,-0.37333037648,-0.141060574721,-0.151846122462,0.266722690422,-0.0494956859777,-0.055064232772,-0.0757107854751,-0.0865571423218,0.118411565287,0.240435533018,0.154299371125,0.0776084511484,0.0804489115729,0.226237291911,-0.196945757115,0.0277991252396,-0.440365118697,0.329753986154,-0.188710569979,-0.0165705262142,-0.223749681409,-0.0336605146609,-0.113381327851],[-34545.6842475,-1198.04971754,231.469159505,-886.763566528,794.028517836,-39.5909747861,-102.773222859,-459.334970022,-197.541098338,320.37064654,69.3262783766,-602.882450708,-85.3753266654,555.030700174,-133.108186273,-122.18412704,-87.2865648817,222.020225847,-110.413857646,-159.321184118,-138.671989766,491.952517126,178.063972327,297.199531254,96.9337197714,-41.2097650232,-63.038313271,159.42399309,211.287788751,47.1734827752,47.7625824374,70.6642095856,-181.833068298,-91.1374318014,57.286596342,-3.74201781244,-14.0087508711,-37.3842353149,48.0850278235,50.7230883431,42.2450444463,-16.7635986871,-37.0291738194,-66.9676751822,-13.3793984415,14.2962208802,-9.71255268237,27.9135425751,13.6054985776,-5.62898478864,-2.94428364911,5.8616514649,2.86541237934,2.356787058,-7.17190441769,-9.01469903312,-7.2918463718,-2.84378696263,-10.2839642047,-2.42989323083,-8.0802648493,-5.09034146478,-9.43441740838,3.95007971067,1.93665105045,-4.27770064965,-2.7778595613,-1.84441838633,1.17292318031,-3.08876568154,-0.422299202806,3.27551679986,0.116943431081,-4.40902825747,1.78619555076,-2.56731699073,-0.164141170602,-5.17162984015,0.816361587784,1.66825955218,-0.0147742739904,0.644153881748,-0.129861505118,-1.64496128761,-1.16165233405,-0.0186756038542,-0.343415800553,0.56198173144,0.661817971989,0.550214686234,-0.368933101512,0.723269162057,-1.04304207884,-0.0504284342608,-1.87439585381,0.161727140671,0.496273547765,-0.364133897483,-0.133713725247,-0.160689894924,0.26205824269,-0.0545118369859,-0.0563342772053,-0.0751221366989,-0.0868046222194,0.122728817621,0.231893226125,0.156495074117,0.0753827216427,0.0741965844226,0.22380383945,-0.195084992592,0.0273218885126,-0.439599605651,0.339188703683,-0.187118418381,-0.0138878389933,-0.226535770152,-0.031245752027,-0.112922369388],[-34627.7854581,-1234.33317182,246.518297704,-875.96897273,823.030077455,-46.49674498,-88.8380224973,-431.591487071,-166.783851955,322.538428405,63.8179686066,-613.900812968,-96.9675257297,564.15607059,-126.680029378,-117.696795772,-98.6263362445,212.392971021,-116.283827502,-169.060707176,-134.756553385,508.423484367,175.994012497,293.094962734,95.3879916466,-47.5367094598,-62.0632667703,163.225212422,216.176941958,46.0198023711,47.8308795768,72.0078664462,-194.196637397,-87.4947108884,57.619508577,-4.84587161932,-14.7028304237,-36.965108089,50.5776899769,52.6881993877,42.0139535641,-17.9697423145,-36.8552568939,-70.374911383,-11.8849609518,14.2066991582,-8.51076317309,28.0260952844,13.5526921231,-5.61113110837,-2.86263093818,6.31473084359,3.12065854553,2.33999025984,-7.75989857866,-8.78073492711,-8.07767629069,-2.35358155509,-10.4886079789,-2.06716796248,-8.13434261172,-5.1999121819,-9.46908030719,4.00896825267,1.92660577678,-4.31771585228,-2.74146049133,-1.85808270122,1.1420223611,-3.24298115472,-0.420734815126,3.25703950132,0.237290104245,-4.53573928399,1.93777815944,-2.58267781155,-0.238394691866,-5.17632779806,0.817305319278,1.71998107525,-0.0179165595922,0.640255901049,-0.162086583307,-1.65316187492,-1.17913390155,-0.0189345065983,-0.349304892298,0.546625281082,0.691215275921,0.573681182518,-0.405475195569,0.722603640584,-1.04215641235,-0.0825215726084,-1.88105948029,0.175664597451,0.520290356354,-0.355051718233,-0.125379826208,-0.16894416015,0.257378264502,-0.0593668968132,-0.0575248264455,-0.0748293801155,-0.0868869461015,0.126624149542,0.223313401851,0.158856929729,0.0726153533102,0.0683243488359,0.221350655483,-0.192826851719,0.0265506884631,-0.438535312622,0.348145849431,-0.18569204897,-0.0113584405457,-0.228822328855,-0.0290481444842,-0.112321798439],[-34703.5813722,-1268.90076627,258.589620535,-864.664472144,846.577033767,-55.2223558402,-75.2617501712,-402.573381666,-137.733286509,324.714605713,57.167617422,-623.745481094,-107.69090791,572.412352506,-121.171545767,-113.725081796,-108.771844073,203.315120953,-121.333002453,-178.304536286,-130.755596365,523.595265933,174.446416884,288.472470632,94.0423154671,-53.4791063265,-60.9007825146,166.968268221,220.875283237,44.6144474007,47.9364939796,73.2404239881,-205.915305396,-83.695742819,57.948381424,-5.91142763161,-15.4074459426,-36.5559616051,52.9573029705,54.5717324096,41.7412122432,-19.1161728961,-36.6330261155,-73.5916912748,-10.3315498143,14.0582674072,-7.33192207531,28.1548205969,13.4828170989,-5.62618647924,-2.78838076229,6.75459099598,3.38071046792,2.3196709357,-8.30680899791,-8.53874756216,-8.83140175567,-1.84898447502,-10.6834939533,-1.7223565065,-8.14770016832,-5.29050006172,-9.48540823511,4.05896889613,1.90437212343,-4.36204244983,-2.7006398221,-1.86488433846,1.11189241104,-3.38741471979,-0.415650431937,3.23730920138,0.356799016939,-4.65506755244,2.07778220608,-2.58742446366,-0.309445188055,-5.17805062566,0.817070383592,1.77146340186,-0.0217840653771,0.634420473799,-0.194278216977,-1.66003824935,-1.19568732186,-0.0187565916115,-0.355231317031,0.53142172139,0.719467851635,0.596035011426,-0.43933741633,0.721489909083,-1.03745786527,-0.113233601621,-1.88608895075,0.189405528041,0.543207210502,-0.346198151023,-0.11608337423,-0.176493650219,0.252798060864,-0.063935281665,-0.058655504247,-0.0748277307668,-0.0868890215472,0.129976473396,0.214735949221,0.161430480288,0.0692539465341,0.0630046046455,0.219073044854,-0.190086113729,0.0255723460499,-0.43701247995,0.356461939772,-0.184354037314,-0.00903095898824,-0.230448660769,-0.0270557059193,-0.111623367215],[-34770.0998555,-1302.28250881,266.446645607,-852.000136239,863.336765936,-65.7942375973,-62.5440327011,-372.484469731,-110.876077821,326.708343155,49.2112475909,-632.180730086,-117.225846988,579.872577123,-116.764532762,-110.450496488,-117.498049311,194.984060678,-125.452436375,-187.031324575,-126.620719376,537.040958445,173.415648701,283.329796396,92.9398449896,-58.9317843192,-59.5394107244,170.649671173,225.335979246,42.9550359582,48.0440792891,74.3638346142,-216.874736582,-79.7319266701,58.2687028591,-6.91874128127,-16.1227191433,-36.1686879512,55.1964760698,56.351655422,41.4324883325,-20.1915745944,-36.3499137489,-76.593450053,-8.7088234731,13.8352904242,-6.18711901386,28.2945426963,13.3997659462,-5.68247491268,-2.72322501585,7.17674991509,3.64210874633,2.29498609048,-8.80293633579,-8.28686283526,-9.55076194249,-1.32461127306,-10.8717076028,-1.39624581707,-8.11715535425,-5.35964810801,-9.48143845247,4.09994258308,1.86846777527,-4.41146583997,-2.65516500913,-1.86465197554,1.08275200557,-3.52016479468,-0.405991386379,3.21592721539,0.47549521826,-4.76681230037,2.20555551373,-2.57975128816,-0.37580006241,-5.175533071,0.815394926275,1.82220766854,-0.0264507285134,0.626703244765,-0.226156776436,-1.66562187005,-1.21116964048,-0.0181899476894,-0.361308982829,0.516501230505,0.746140487432,0.617107937177,-0.470092491744,0.720318183837,-1.0282557034,-0.141799833812,-1.8889650355,0.202746333616,0.564856123411,-0.337679383946,-0.105850728194,-0.183248918699,0.248426572595,-0.0681053346268,-0.0597450170066,-0.0751107029914,-0.0868845097558,0.132674872244,0.206189911955,0.164244106314,0.065257771841,0.0583881244058,0.217140626435,-0.186792834965,0.0244702339087,-0.43489132321,0.363991343733,-0.183034248948,-0.00694530366622,-0.231278287318,-0.0252602754501,-0.110862538965],[-34828.7383579,-1334.46798788,270.868988724,-837.716676109,872.76935502,-78.4467130074,-50.8560453363,-342.197660869,-86.4651837553,328.246770653,39.8818893274,-639.161576425,-125.352983651,586.643308693,-113.300456329,-107.951401693,-124.750222892,187.552681387,-128.672275584,-195.188035573,-122.421417417,548.51110097,172.873183658,277.71272837,92.0982292112,-63.8262119735,-57.9896247821,174.24573338,229.543430844,41.0399355383,48.1312115724,75.382735609,-226.998413515,-75.5954574575,58.5773834796,-7.8491100981,-16.8491834152,-35.8080388029,57.278986048,58.0191250215,41.0858209825,-21.1908486203,-36.0047910256,-79.3682384599,-7.01723984323,13.5333893692,-5.08141858547,28.4441552033,13.3083368228,-5.78436726851,-2.66942570932,7.57969904492,3.90177899874,2.26386197292,-9.24479824961,-8.02520724446,-10.2338715818,-0.78002814476,-11.0559171986,-1.08798016397,-8.04313236044,-5.40714506346,-9.45568398598,4.13236427859,1.81870966865,-4.4665240416,-2.60509043743,-1.85813071092,1.05467317162,-3.64025770939,-0.391496642,3.19267150193,0.592681103221,-4.87073125685,2.32071525589,-2.55903025167,-0.436717488711,-5.16784399287,0.812359571868,1.87213818952,-0.0318420506054,0.617252761766,-0.257528898389,-1.66994127811,-1.22550589925,-0.0173883796067,-0.367630600216,0.50177898426,0.770822423852,0.636632326125,-0.497503594956,0.719309217967,-1.01446397906,-0.167816050745,-1.88948238121,0.215513900002,0.585125697587,-0.329569108289,-0.0947156960101,-0.189223805097,0.244347283769,-0.0718211063028,-0.0608084016902,-0.0756650083149,-0.0869020864086,0.134649112002,0.197660952557,0.167257541108,0.06063278033,0.0545391715589,0.215620275219,-0.18293818018,0.0233139313824,-0.432111958924,0.370659840938,-0.181691709262,-0.00510650884022,-0.231271602623,-0.0236689931177,-0.110041621106],[-34881.9867252,-1365.31168706,273.14029024,-821.702462753,874.533057555,-93.4660779579,-40.2868504327,-312.753138106,-64.6951326865,329.036509434,29.136824707,-644.69072196,-131.878025313,592.83949473,-110.535699595,-106.280371875,-130.516213249,181.162750811,-131.057439503,-202.713710416,-118.256659066,557.800593185,172.784750589,271.67906662,91.5287409388,-68.1030177851,-56.2673788606,177.727717293,233.489847439,38.8677009856,48.1786975019,76.3024354769,-236.219273319,-71.2787291817,58.8716895381,-8.68414213634,-17.5874750663,-35.4769807325,59.1914015554,59.5685949503,40.6973421691,-22.1104504469,-35.5993889192,-81.9072611239,-5.25995670735,13.1509994929,-4.01837912984,28.6035690978,13.2135543158,-5.93524611862,-2.62938738221,7.9626731922,4.15674309768,2.2239171427,-9.63046664594,-7.75440743804,-10.8789392929,-0.216038946923,-11.2386867107,-0.796293145857,-7.92695696673,-5.43334110548,-9.4067768039,4.15686245344,1.75523955279,-4.52769322895,-2.55054222437,-1.84629474836,1.02769127399,-3.74695177198,-0.372103569952,3.16736418038,0.707478403317,-4.96657177388,2.42294594367,-2.52492772722,-0.491643333373,-5.1541357777,0.808130564662,1.9212850735,-0.0378464243663,0.606240798381,-0.288222786145,-1.6730242851,-1.23863813911,-0.016532121133,-0.374283580327,0.487116407909,0.793109014496,0.654315695155,-0.521381510407,0.718641398805,-0.99614794119,-0.190968151247,-1.88751410366,0.227542734191,0.603918682863,-0.321932891138,-0.082713947846,-0.194457970407,0.240637314278,-0.0750405741768,-0.0618597779062,-0.0764756575597,-0.0869591808077,0.135839129297,0.189123888227,0.170413356161,0.0553965932435,0.0515003822691,0.214553180227,-0.178528591233,0.0221695694906,-0.428634478854,0.376411063664,-0.180292733614,-0.00351088999955,-0.230413218979,-0.0222928241941,-0.109154632091],[-34932.3348032,-1394.66808991,274.544190508,-803.845867167,868.286130072,-111.138628337,-30.9255103464,-285.191084467,-45.7604529891,328.784180727,16.9333358053,-648.770868538,-136.60667939,598.576082749,-108.226645686,-105.489981497,-134.783868812,175.956036682,-132.672847555,-209.547390237,-114.2254129,564.704334769,173.116078328,265.28661121,91.2426529797,-71.7028302497,-54.3886271326,181.066885367,237.167438439,36.4368871445,48.1673437504,77.1282427226,-244.470253122,-66.7741358432,59.1488872872,-9.40544545027,-18.3382304043,-35.1784803124,60.920291242,60.9945189507,40.2631838682,-22.9468355472,-35.1354384031,-84.201722674,-3.44013184813,12.6865560459,-3.00155898667,28.7726953595,13.1204430121,-6.13849403492,-2.60551457401,8.32490716367,4.40402291569,2.17277015952,-9.95801343131,-7.47509006431,-11.4841736953,0.366552463652,-11.4225801094,-0.519918361407,-7.769954953,-5.43858641148,-9.33334887453,4.17406557842,1.67819917691,-4.59544957623,-2.49164648732,-1.83011829158,1.00184167746,-3.83950529048,-0.347749541385,3.13982737016,0.819008850041,-5.05408120344,2.51193208819,-2.47711008783,-0.540023462812,-5.13356081197,0.802874148943,1.96967842915,-0.0443522425094,0.593839128193,-0.318066643009,-1.67489870256,-1.250508401,-0.0158014060377,-0.381355334296,0.472374926708,0.812595612966,0.669865561154,-0.54153702254,0.718493113682,-0.97337283872,-0.210942034145,-1.88293331861,0.238667343173,0.621137829068,-0.31483629958,-0.0698811538683,-0.198991075621,0.237373784012,-0.0777217157327,-0.0629132652627,-0.0775276615482,-0.087073222255,0.136184860759,0.180553536165,0.173654122968,0.0495668318237,0.0493143927004,0.213980530483,-0.173570509982,0.0211032792531,-0.424418974757,0.381188644186,-0.178803637359,-0.00215476263356,-0.22868774868,-0.0211427339514,-0.108195590379],[-34982.2724379,-1422.39168,276.364329883,-784.035260351,853.686829107,-131.750660031,-22.8610874337,-260.551682976,-29.8556730376,327.196405761,3.22870469785,-651.404718009,-139.344653294,603.968020262,-106.129677731,-105.632805023,-137.541038014,172.07430673,-133.583419166,-215.628116169,-110.426647499,569.0172254,173.832895709,258.593162207,91.251238141,-74.5662778628,-52.369323771,184.234500055,240.568413254,33.7460488597,48.0779569904,77.8654658506,-251.684290048,-62.0740714425,59.4062429794,-9.99462809412,-19.1020857373,-34.9155041149,62.4522237581,62.2913507651,39.7794780558,-23.6964593942,-34.6146704508,-86.2428277388,-1.56092304824,12.138494279,-2.03451649568,28.9514449685,13.0340274988,-6.3974935893,-2.60021182421,8.66563576606,4.64064032528,2.10803958307,-10.2255105123,-7.18788177159,-12.0477834081,0.966942230166,-11.6101613647,-0.257589409286,-7.57345209908,-5.42323115888,-9.23403216615,4.18460212433,1.58773029024,-4.67026925766,-2.42852934365,-1.81057554433,0.977159746822,-3.91717657294,-0.318371927451,3.10988319064,0.926394174888,-5.13300689752,2.58735820056,-2.41524370651,-0.581303743442,-5.10527148212,0.796756569,2.01734836517,-0.0512478977481,0.580219524783,-0.346888672291,-1.67559234207,-1.26105872584,-0.0153764680905,-0.388933273259,0.457415965914,0.828877572863,0.682989441008,-0.557780915799,0.719042749929,-0.946203920592,-0.227423598264,-1.87561314184,0.248722233939,0.636685886036,-0.308344900701,-0.0562529842438,-0.202862781733,0.234633812858,-0.0798225084546,-0.0639829833681,-0.0788060311027,-0.0872616400523,0.135626243018,0.171924713572,0.176922413021,0.0431611173132,0.0480238390171,0.213943515007,-0.168070378285,0.0201811916893,-0.419425538393,0.384936214778,-0.177190735854,-0.00103444223155,-0.226079804021,-0.0202296876615,-0.107158514423],[-35033.7626399,-1448.22398201,279.572684516,-762.202875803,830.565390318,-155.452736108,-16.0693172955,-239.610738107,-17.1380454589,324.037998221,-11.9724796224,-652.604496448,-139.916884354,609.09865638,-104.021264121,-106.75226831,-138.787793,169.631196075,-133.865859855,-220.903192667,-106.953087363,570.579105042,174.907505402,251.656845021,91.5617024104,-76.6486383858,-50.2240241014,187.203850898,243.6856486,30.7945079661,47.8978196348,78.5175860139,-257.806335571,-57.1734830542,59.6420529568,-10.4361119536,-19.8794201473,-34.692033638,63.7774993626,63.4538728043,39.243001899,-24.3553926255,-34.0394787894,-88.0237803429,0.373042806435,11.5055475743,-1.11975546901,29.1392798768,12.9590599656,-6.71452911508,-2.61571097622,8.98432236645,4.86382932644,2.02797260817,-10.4315294633,-6.89372415128,-12.5685503485,1.58354067837,-11.8039259628,-0.00801121967973,-7.33910651842,-5.38745001263,-9.10793776419,4.18923620435,1.48420555199,-4.75242180634,-2.36123907396,-1.78860092604,0.953685019354,-3.97948122539,-0.284016839821,3.0773676666,1.02874141162,-5.20320781061,2.64903461769,-2.33931833354,-0.615005831812,-5.06868258692,0.78987591208,2.06438096327,-0.0584200233269,0.565617081129,-0.374511240277,-1.67511211413,-1.270272303,-0.0154017415698,-0.397114898614,0.442129924738,0.841616913336,0.693433541692,-0.569999364018,0.720417660882,-0.91477298046,-0.240162280028,-1.86550078342,0.257565082721,0.650479913938,-0.302491770216,-0.0418529234751,-0.20611795155,0.23249047531,-0.0812971483919,-0.0650756006084,-0.0802927014107,-0.0875374956535,0.134120159407,0.163215771661,0.180149836521,0.0361992988331,0.0476541214394,0.2144712452,-0.162047109743,0.019466629357,-0.413638280488,0.387608689608,-0.175433543515,-0.000139439610543,-0.222576672222,-0.0195584046676,-0.106033710794],[-35086.6610792,-1471.45468502,283.894573744,-738.456397021,799.439965869,-181.85248836,-10.0726285128,-222.086540137,-7.61571989,319.306541625,-28.4764004929,-652.420526842,-138.225229554,613.924946583,-101.758214311,-108.855202802,-138.573100774,168.627809388,-133.644019531,-225.352977469,-103.87248068,569.409574798,176.338505414,244.537086439,92.1649844971,-77.963786643,-47.9616880599,189.956335791,246.514690434,27.5846542596,47.6401170572,79.0807749591,-262.829398558,-52.0775300486,59.8587339187,-10.7255742405,-20.6695838133,-34.516110082,64.9013447497,64.4781821528,38.6531133308,-24.9181665365,-33.4149081605,-89.545782095,2.35126241717,10.7876418401,-0.255561608619,29.3338659264,12.8992030137,-7.08749199125,-2.653553089,9.28134457329,5.07167242898,1.93333097023,-10.5766405307,-6.59481856724,-13.0475496236,2.21161486419,-12.006095454,0.230225951177,-7.06990565879,-5.3307155879,-8.95609322275,4.18927450118,1.36892126138,-4.84135019085,-2.2895126119,-1.76496971888,0.931473722232,-4.0269640458,-0.245165352251,3.0421724443,1.1250988031,-5.26498930735,2.69727497963,-2.25061722819,-0.640954545008,-5.02425857432,0.782057637257,2.11108619728,-0.0657482146164,0.550520167802,-0.400733365183,-1.67338132497,-1.27829691546,-0.01587846279,-0.406038072821,0.426523098221,0.850742315736,0.701098830535,-0.578380098599,0.722541063893,-0.879477990843,-0.249161666234,-1.8528398306,0.265146242715,0.662494214312,-0.297180018361,-0.0266557134067,-0.208822255129,0.231000664264,-0.0820847058574,-0.066167980481,-0.0819573051205,-0.0878963791189,0.131691280086,0.154419197688,0.183224158496,0.0287101370206,0.0481616964127,0.215544521974,-0.155569504925,0.0190116809655,-0.40713738764,0.389206110402,-0.173564370992,0.000567953101779,-0.218176340216,-0.0191086205978,-0.104796638519],[-35140.2965906,-1491.26051923,288.743652704,-712.947370003,761.00068705,-210.421815755,-4.28012291133,-207.433000787,-1.25957022015,313.057811946,-46.0419343334,-650.912656402,-134.19077579,618.372247948,-99.217423023,-111.939291336,-136.958152053,169.037118731,-133.053534203,-228.966091631,-101.246331558,565.57317606,178.131067591,237.293638591,93.0479562911,-78.5402467243,-45.5898767352,192.475379715,249.05175202,24.1196445267,47.3245103714,79.5493770812,-266.758502222,-46.7939248701,60.0597326538,-10.8615059979,-21.4716696887,-34.396789573,65.8327182222,65.3607045637,38.0098154751,-25.3789275871,-32.7466660593,-90.8120339995,4.36176338205,9.98500111594,0.560833911079,29.5324199317,12.857846847,-7.51317535821,-2.71510652543,9.55730855539,5.26246427017,1.82550503982,-10.6619136285,-6.29368132644,-13.4864296383,2.84564602613,-12.2188229046,0.458560515535,-6.76916930154,-5.25232498739,-8.78000521306,4.18615933993,1.24340462758,-4.93629073864,-2.21300905433,-1.74041742072,0.910586255112,-4.06042713015,-0.202407279017,3.00420307537,1.21449989444,-5.31876835487,2.73251875226,-2.15074702699,-0.659050490248,-4.97272630461,0.773059046563,2.1578300141,-0.0731103075186,0.535480474771,-0.425348228204,-1.67030237975,-1.28532149464,-0.0167720685743,-0.415850748605,0.410630755358,0.856249126965,0.705924964956,-0.583186240336,0.725285142318,-0.840783468973,-0.254488881276,-1.83794796493,0.27143923636,0.672717399036,-0.292280264,-0.0106239102187,-0.211046564342,0.230217227219,-0.0821204697294,-0.0672295352613,-0.0837663992454,-0.0883295126611,0.128381221918,0.145531012923,0.186022182682,0.0207246203918,0.0494857844382,0.217132068618,-0.148718836144,0.0188656267621,-0.40002706541,0.389739800777,-0.171628727997,0.00113224845005,-0.212879469858,-0.0188538251511,-0.103419044739],[-35193.9980089,-1506.81821482,293.533576531,-685.827340748,715.937685151,-240.632617265,1.89909768305,-195.104031783,1.95952966122,305.347585159,-64.4279575639,-648.140732341,-127.734609958,622.36591755,-96.2757849759,-116.002216751,-134.004137554,170.832096164,-132.230039875,-231.731156213,-99.1361441082,559.134450217,180.290363776,229.98625361,94.1974896822,-78.4065427198,-43.1161512162,194.744407655,251.293046624,20.4026355537,46.9706606911,79.9177367752,-269.598669778,-41.330379963,60.2484959508,-10.8423982688,-22.2847707266,-34.343128237,66.5805780833,66.0978657901,37.3131114563,-25.7318222374,-32.040459981,-91.825737061,6.39257329915,9.09784944159,1.33219991568,29.7321587069,12.8383816696,-7.98837235634,-2.80173964838,9.81282048156,5.43449948726,1.70588518748,-10.6884186708,-5.99282873586,-13.8868387973,3.48011540265,-12.4442613809,0.678430885643,-6.44021722801,-5.15157531381,-8.58118040637,4.18133304569,1.10918285982,-5.03647977717,-2.13138749813,-1.71567952943,0.89108301765,-4.08067257441,-0.156332434394,2.96336511142,1.29597823077,-5.36496192033,2.75520540142,-2.04131436648,-0.669194274752,-4.91481263805,0.762637442029,2.20497836059,-0.0803841379354,0.521049692004,-0.448149010538,-1.66577768364,-1.29153497194,-0.018047995746,-0.42670087869,0.394488165147,0.858132693921,0.707851602372,-0.584680910024,0.728522079512,-0.799153932084,-0.256211049547,-1.82114286798,0.276417586093,0.681138079989,-0.287663125998,0.0062799299087,-0.212861751058,0.230193011673,-0.0813397288861,-0.0682296772244,-0.0856865407989,-0.0888281184923,0.124231601769,0.136547238636,0.188420712815,0.0122737374629,0.0515656060174,0.219202608422,-0.141576375712,0.019077746994,-0.392411519363,0.38922108435,-0.169672124239,0.00159795897889,-0.206686723009,-0.0187675080267,-0.101872676594],[-35247.0941689,-1517.30450199,297.67800036,-657.247855254,664.94109146,-271.95679186,9.05593144451,-184.553544848,2.07070586476,296.231637238,-83.3933466043,-644.164601873,-118.777818955,625.831312466,-92.8101948907,-121.041661884,-129.772247994,173.985713746,-131.309172556,-233.636792273,-97.6034224395,550.15793866,182.821565813,222.674683626,95.6004565603,-77.5911987194,-40.5480725915,196.746844593,253.234787511,16.4367841268,46.5982291303,80.1801984361,-271.354924438,-35.6946077717,60.4284705985,-10.6667420966,-23.1079798803,-34.3641821999,67.1538826356,66.6860915852,36.5630043984,-25.9709969474,-31.301997421,-92.590092284,8.43171976655,8.12641085671,2.06130523076,29.9302990664,12.8441976853,-8.50987612607,-2.91482082072,10.0484865206,5.58607271752,1.57586178377,-10.6572255719,-5.69477710246,-14.2504255055,4.10950423225,-12.6845639493,0.891275473753,-6.08636921955,-5.02776366986,-8.36112547393,4.17623794355,0.967783167284,-5.1411536339,-2.04430704019,-1.69149154289,0.873024409505,-4.08850247456,-0.107530632658,2.9195641041,1.36856735722,-5.40398697086,2.76577439298,-1.92392588319,-0.671286505737,-4.8512444349,0.750550125689,2.25289718363,-0.0874475417689,0.507779509471,-0.468928893379,-1.65970964182,-1.29712627878,-0.0196716811284,-0.438736415802,0.378130596584,0.856388363505,0.706818400202,-0.583127228458,0.732124058831,-0.755053897412,-0.254395295442,-1.80274222128,0.280054814353,0.687744869047,-0.283199223219,0.0240932507954,-0.21433868715,0.230980865124,-0.079677772206,-0.0691378186457,-0.0876842867944,-0.0893834188248,0.119284036501,0.127463896096,0.190296552629,0.00338847674984,0.0543403816517,0.221724864677,-0.134223395939,0.0196973219086,-0.384394955062,0.387661284738,-0.16774006943,0.00200959723295,-0.199598761524,-0.0188231589238,-0.100129281227],[-35298.7868869,-1522.22609316,300.723752637,-627.35206613,608.653399773,-303.944916714,17.6458762358,-175.328275081,-0.850445147705,285.787186077,-102.750471675,-639.054875415,-107.306077252,628.685630309,-88.6966133291,-127.037425222,-124.329107707,178.452088666,-130.40518913,-234.677690117,-96.6924218866,538.733781957,185.727877045,215.408028885,97.2396225175,-76.1268967118,-37.8924976705,198.468459998,254.876451742,12.2299872658,46.2285478401,80.3353890229,-272.042934618,-29.8982894704,60.6024140799,-10.3355418508,-23.9404778124,-34.4666481935,67.5606983928,67.1242477159,35.7607528696,-26.0909514259,-30.5353606516,-93.1096929072,10.4674581782,7.07270625384,2.74983900232,30.1234654201,12.8776579525,-9.0741691286,-3.0552590229,10.2643059714,5.71588663279,1.43687620188,-10.5694464942,-5.4017924843,-14.5784747968,4.72879364437,-12.9409838649,1.09801837561,-5.71097448455,-4.88036210193,-8.12155128693,4.17215271365,0.820639924388,-5.24954873034,-1.95168297682,-1.66850505846,0.856370010458,-4.08469163246,-0.0565924483301,2.8728560852,1.43139267783,-5.43622122413,2.7646083549,-1.80012615013,-0.665202167052,-4.78271816011,0.736668466134,2.30187365659,-0.094180149726,0.496158704653,-0.48754678424,-1.65202586052,-1.30226295951,-0.0216180140601,-0.45210525885,0.361593687067,0.851089962237,0.702753899147,-0.578788899838,0.73593313696,-0.708912472268,-0.249099638046,-1.78304052909,0.282365906754,0.692568179069,-0.278787876596,0.0428126105314,-0.215540055792,0.232626458857,-0.0770916920482,-0.0699207159477,-0.0897328758085,-0.0899918244005,0.113571759184,0.11828687251,0.191550677351,-0.00590962287094,0.0577472604089,0.224645368253,-0.126738549487,0.0207692057792,-0.376081823531,0.385086545795,-0.165858687295,0.00239769101205,-0.191629946568,-0.0189938262186,-0.0981673508384],[-35347.7699054,-1522.40962966,302.750355054,-596.249552426,547.526553904,-336.46228181,27.5828286738,-167.346251079,-6.54244550959,274.177217242,-122.5256782,-632.925216201,-93.5634096132,630.813430838,-83.8072642179,-133.897767842,-117.763075488,184.10991862,-129.54683,-234.872817041,-96.3784026854,525.054517394,189.004626798,208.192782092,99.0813279545,-74.0629502799,-35.1534661439,199.904401291,256.230571561,7.8091029235,45.8896331224,80.3990657515,-271.720949526,-23.9689811525,60.770326655,-9.85985520687,-24.7817960233,-34.6477853727,67.80552471,67.4209600057,34.9126372136,-26.0875983771,-29.7381310541,-93.3947011066,12.4889551117,5.94594393697,3.39517165789,30.3059125602,12.9370169465,-9.67649110846,-3.22212570572,10.4578506528,5.82427604326,1.29057382551,-10.4263625939,-5.11513994382,-14.8708182223,5.33496433232,-13.2111751388,1.2975264209,-5.31749993951,-4.70954243115,-7.86498551633,4.16970145626,0.668816166394,-5.36090186425,-1.85445540218,-1.64703607159,0.840676120793,-4.06990567367,-0.00411149690692,2.82389900726,1.48394703243,-5.46188539984,2.75186256357,-1.67121148629,-0.650713749055,-4.70980869722,0.721320098209,2.35187985877,-0.100468771734,0.486424405087,-0.504124495895,-1.64275475031,-1.30702701019,-0.0238996939407,-0.466955091493,0.3449145476,0.842625235116,0.695542173038,-0.571931961997,0.739670863899,-0.661017124289,-0.240345675222,-1.76223958636,0.283531701619,0.695805626824,-0.274443215335,0.0622710242877,-0.216495785372,0.235146759301,-0.0736257946962,-0.0705345021415,-0.0918322726706,-0.090670500079,0.107094467696,0.109061518839,0.192180748168,-0.0156368210821,0.0617151056232,0.227821880342,-0.119190010407,0.022320548983,-0.367577557643,0.381582292316,-0.163976557617,0.00273682913675,-0.18284943653,-0.0192507929966,-0.095992357871],[-35392.6099481,-1519.01173506,303.970502612,-564.0414998,481.964860173,-369.452855337,38.645285064,-160.618324815,-14.6973470031,261.58615822,-142.798805404,-625.900050668,-77.8584283784,632.091114352,-78.0134373251,-141.513066467,-110.167943747,190.819046432,-128.741456449,-234.247209592,-96.6193762969,509.338281438,192.645175899,201.024784065,101.087806974,-71.4528309056,-32.334313423,201.052160378,257.312943009,3.20572928618,45.6111723162,80.3912684017,-270.457863573,-17.9382076413,60.9315192781,-9.25325316685,-25.6315537227,-34.9024934982,67.891969153,67.5872942919,34.0261932183,-25.9572037544,-28.9062647873,-93.4566712923,14.4856049404,4.75712906295,3.99359394543,30.4713028747,13.0195019972,-10.311771131,-3.41403293757,10.6260855138,5.91198379369,1.13865104098,-10.2292972755,-4.83583429453,-15.126923962,5.92549688038,-13.4918919711,1.48815212284,-4.90944192798,-4.51565142232,-7.59416003305,4.16934462668,0.513282093778,-5.47444992747,-1.75382060986,-1.62731667722,0.825398220918,-4.04478292965,0.0493178458696,2.77350130299,1.52581511973,-5.48116096822,2.72763545752,-1.53841614712,-0.627568118734,-4.63306053447,0.704946723316,2.40280909599,-0.106202012526,0.478750825823,-0.518849567437,-1.63194992284,-1.31147903985,-0.0265388726853,-0.483433543576,0.328130657587,0.83146040676,0.685056178991,-0.562823036173,0.74302866298,-0.611619911188,-0.228145899525,-1.74051801078,0.283774500448,0.697696630062,-0.270208070711,0.0822606215057,-0.217227615581,0.238551556674,-0.0693461899142,-0.0709326543857,-0.0939891237734,-0.0914417992497,0.0998434761224,0.0998430519823,0.192208597759,-0.0258188272059,0.066170709195,0.231089969716,-0.111643333098,0.0243740759233,-0.358987835728,0.377248769335,-0.162022874193,0.00298761568284,-0.173340089104,-0.0195649010199,-0.0936165198282],[-35431.8737391,-1513.18903291,304.596890313,-530.829093913,412.372624901,-402.860605482,50.611741712,-155.15534826,-25.0072014105,248.198436496,-163.64969251,-618.103805256,-60.4997458863,632.395081146,-71.1864224187,-149.773697823,-101.637504894,198.439314925,-127.99642976,-232.825904314,-97.3733541819,491.803210552,196.642885172,193.899875625,103.22129368,-68.3500100705,-29.4383749191,201.909229167,258.139362126,-1.54853545999,45.4228527608,80.3320367533,-268.32257117,-11.83749376,61.0853029037,-8.5293067327,-26.4893701202,-35.2256723305,67.8236392876,67.6343164117,33.1089566715,-25.6960335108,-28.0357180096,-93.3071578747,16.4468020377,3.51726678863,4.54139661287,30.6132987515,13.1223404344,-10.9749382616,-3.62959278682,10.7659755035,5.97975272884,0.982804234621,-9.97957394352,-4.56489034995,-15.3462601958,6.49787187283,-13.7798885615,1.66824799461,-4.49029679349,-4.29903584025,-7.311806708,4.17154268021,0.355007907013,-5.58942981182,-1.65097489347,-1.60957897029,0.809991791242,-4.00996173185,0.103101204258,2.7224714051,1.55658163848,-5.49422939948,2.69202547523,-1.40297438811,-0.595512143076,-4.55301816009,0.687990042861,2.45455467405,-0.111268476834,0.473312181911,-0.531909537955,-1.61966498976,-1.31567965749,-0.029557702209,-0.501688244943,0.311279496433,0.818061701789,0.67116887412,-0.551728743606,0.745697957531,-0.56097289068,-0.212512803511,-1.71805441998,0.28331660474,0.698480606532,-0.266125273999,0.102573531627,-0.217757286112,0.242850641191,-0.0643189874665,-0.0710686498386,-0.0962100755094,-0.0923280753016,0.0918100985456,0.0906866888392,0.191656058801,-0.0364813505648,0.0710408630249,0.234285205148,-0.10416407196,0.0269525110033,-0.350418336121,0.372186221884,-0.159926830822,0.00311065472607,-0.163184761987,-0.0199069920513,-0.0910520542133],[-35464.1280021,-1506.09814679,304.842213159,-496.713520425,339.154154407,-436.629500432,63.2606949231,-150.968173387,-37.164060514,234.198479556,-185.158178743,-609.660906403,-41.795974476,631.601731519,-63.1975092666,-158.570038634,-92.2655513394,206.830566924,-127.319111213,-230.633937752,-98.5983478016,472.667441203,200.991115444,186.81389759,105.444022174,-64.8079592564,-26.4689860434,202.473099565,258.725624954,-6.42209312879,45.3543617953,80.2414105863,-265.383966725,-5.69836433199,61.230988486,-7.7015869064,-27.3548644256,-35.6122216304,67.6041426794,67.5730922025,32.1684633611,-25.3003535996,-27.1224468797,-92.9577152637,18.3619407772,2.23736227085,5.03487040816,30.7255625785,13.2427595878,-11.6609215656,-3.86741732186,10.8744855708,6.02832569347,0.824729792768,-9.67851600252,-4.30332292361,-15.528295104,7.04956989393,-14.0719191103,1.8361665494,-4.0635608796,-4.06004244975,-7.02065741209,4.17675607217,0.194963806575,-5.70507840912,-1.54711454659,-1.59405504575,0.793912312173,-3.96608041173,0.156644202516,2.6716177463,1.57583128742,-5.50127216386,2.64513105523,-1.26612046471,-0.554292689069,-4.47022606229,0.670891758247,2.50700989874,-0.11555676939,0.470282688401,-0.54349194654,-1.6059535627,-1.31968947212,-0.0329783344266,-0.521866825439,0.294398543543,0.80289534482,0.65375321554,-0.538915705533,0.747370170883,-0.50932812048,-0.193458879734,-1.69502743165,0.282380315994,0.698396973982,-0.262237656474,0.123001884091,-0.218106536656,0.248053803067,-0.0586102971175,-0.0708959656588,-0.0985017742712,-0.0933516816241,0.0829856490493,0.0816476463084,0.190544963972,-0.0476501004812,0.0762523590133,0.237243155409,-0.0968177813911,0.0300785786263,-0.341974737154,0.366494894997,-0.157617621301,0.00306655034221,-0.152466312873,-0.020247907853,-0.0883111785296],[-35488.5503705,-1498.61802458,304.804429136,-461.797353742,262.691657441,-470.679666268,76.3638629577,-148.030329498,-50.8557498097,219.783034188,-207.384388466,-600.690807443,-22.0850388957,629.639916723,-53.9407529885,-167.790642112,-82.1529390623,215.866103653,-126.713255165,-227.735876382,-100.22771505,452.163382602,205.676938773,179.768039232,107.717408467,-60.8786689849,-23.4297215468,202.749972955,259.085713204,-11.3742004065,45.4317327656,80.1396018342,-261.717962159,0.44736255637,61.3694731681,-6.78543062631,-28.2260817579,-36.0553386745,67.2401877437,67.4159694161,31.2143988306,-24.7687107969,-26.1639050542,-92.421476405,20.2205313426,0.929245843374,5.47031742147,30.8028388468,13.3777327493,-12.3644623999,-4.12562683749,10.9494738636,6.05921836366,0.666065602093,-9.32823766513,-4.05195636424,-15.6728658521,7.57820008847,-14.3648051383,1.99039411038,-3.63278385052,-3.79942683085,-6.72343711914,4.18532133677,0.0340445252215,-5.82064688304,-1.44348366119,-1.58087939329,0.77660044241,-3.91383620037,0.209382223409,2.62182066213,1.58334576011,-5.50253528725,2.58732768187,-1.12903976022,-0.50381631978,-4.38525101428,0.654094717379,2.56004828289,-0.118959674172,0.469749884662,-0.553779908203,-1.59094013286,-1.32357911145,-0.0368761100254,-0.54403567302,0.277517447013,0.786434359154,0.632766353994,-0.524640004644,0.747823299852,-0.456937735198,-0.171053442372,-1.67161599005,0.281192587846,0.697668798277,-0.25859923966,0.143359532001,-0.218293695643,0.254150842097,-0.0522937387188,-0.0703844514739,-0.100877088439,-0.0945430233215,0.0733826557353,0.0727722447941,0.188905177529,-0.0593327919547,0.0817399240656,0.23983211687,-0.0896524274775,0.0337660156669,-0.333747325948,0.360286207627,-0.155038276167,0.00281831902122,-0.141269925188,-0.0205625878856,-0.085410179543],[-35506.7621154,-1490.51691159,304.122548167,-426.188723268,183.278952469,-504.835860641,89.6658518951,-146.166055214,-65.7531896498,205.198124389,-230.309586602,-591.293069298,-1.82211353111,626.648291836,-43.4012701105,-177.316767416,-71.4287783115,225.473059943,-126.168188264,-224.354406402,-102.096199553,430.58053495,210.662272148,172.784883639,109.999596194,-56.6082059376,-20.325113538,202.780888627,259.226351279,-16.3275334694,45.6663830444,80.047511045,-257.428539428,6.56669576568,61.5079988486,-5.80323857639,-29.0947708737,-36.5414108035,66.7508862923,67.1804234613,30.2650476475,-24.1087751708,-25.1635361819,-91.7178883843,22.0125471598,-0.391951452439,5.84408511193,30.8442004605,13.5232170598,-13.0795512869,-4.4003745342,10.9923713252,6.0770377407,0.508215550652,-8.93401637637,-3.81085316144,-15.7812855476,8.08188584311,-14.6556374505,2.1299522406,-3.20172865322,-3.5195798244,-6.42284321454,4.19707932391,-0.127157075158,-5.93544348456,-1.34151752274,-1.56979608152,0.757437553807,-3.85416192734,0.260869683721,2.57424809935,1.57969472951,-5.49852301836,2.52009902292,-0.992722169129,-0.444628382587,-4.29874892913,0.638046354169,2.61346416735,-0.121386692128,0.471454607343,-0.562938841628,-1.57503270956,-1.32745927795,-0.041539124781,-0.56793620809,0.260634529704,0.769178962823,0.608502214732,-0.509115569433,0.747181635192,-0.404054177027,-0.14559309209,-1.64800034598,0.279998982466,0.696453737737,-0.25530880609,0.163547223093,-0.218323446452,0.261051596385,-0.0454729724717,-0.0695694467879,-0.103373774346,-0.0959647123592,0.0630985027785,0.0640712187194,0.186798690039,-0.0714651626949,0.0874700251055,0.242051296288,-0.0826456230471,0.037992608885,-0.325764824782,0.353716274415,-0.152187172915,0.00233862690981,-0.129690085288,-0.0208423624025,-0.0823816210707],[-35520.9954175,-1481.28537743,302.320843157,-389.997147154,101.187760387,-538.898999097,102.90448977,-145.162266487,-81.5230741003,190.702093457,-253.895323213,-581.562279786,18.508314823,622.817962889,-31.5869425103,-187.027850194,-60.2292429042,235.592029022,-125.669630231,-220.751743943,-104.013891369,408.222671192,215.902743795,165.892362348,112.247910896,-52.0411558361,-17.1599334653,202.615595348,259.152449253,-21.1956233662,46.0660760107,79.9862109201,-252.626697997,12.6263508933,61.6553936145,-4.77917737697,-29.9511064389,-37.0551228742,66.1584509868,66.8852116615,29.3408441352,-23.3304976123,-24.1262814097,-90.8679768231,23.7280774648,-1.71027339832,6.15253228092,30.849802427,13.6749156224,-13.7999910409,-4.68732183891,11.005502098,6.0871636572,0.352525026848,-8.50192038935,-3.57988534001,-15.8552362834,8.55887910506,-14.9415741728,2.25399631309,-2.77421155536,-3.22330108648,-6.1215661866,4.21174696241,-0.288123600393,-6.04879073654,-1.24269921508,-1.5604515738,0.735790196508,-3.78804932184,0.310690758745,2.53013990756,1.56564486338,-5.48980416154,2.445205792,-0.858108713777,-0.37743392095,-4.21139800488,0.623195249029,2.6670321,-0.122751503455,0.47505101741,-0.571129741419,-1.55871018166,-1.3314506928,-0.0473086632411,-0.593228609164,0.24374028317,0.751636172537,0.581338916633,-0.492545789843,0.745656041145,-0.350929965056,-0.117431251176,-1.62436107685,0.27904971416,0.694893098799,-0.252476328546,0.183487428765,-0.218197061202,0.268645913613,-0.0382591686646,-0.0685026635742,-0.10603581031,-0.097687412418,0.0522517883721,0.0555464060124,0.184295523647,-0.0839649560887,0.0934170640618,0.243932628014,-0.0757573926136,0.0427271575121,-0.318040564723,0.346952383925,-0.149076525778,0.00160255256889,-0.117823605259,-0.0210826593552,-0.0792621361925],[-35533.4824574,-1470.41399173,298.923587012,-353.332143552,16.6898020928,-572.669997181,115.817604615,-144.80587927,-97.8320972273,176.553284691,-278.103148359,-571.593026723,38.4217593717,618.340035915,-18.5056520656,-196.803326093,-48.6905066572,246.163604122,-125.203300787,-217.190105133,-105.790880559,385.393564277,221.353981936,159.118406901,114.419678115,-47.222104402,-13.9389527772,202.303841882,258.868917199,-25.8920011455,46.638575044,79.9767741613,-247.42343733,18.5930435368,61.8204855532,-3.73741364839,-30.7852631195,-37.5811597432,65.4850944883,66.5490913401,28.4622226171,-22.4438290125,-23.0570818843,-89.8927673425,25.357211494,-3.00976377601,6.39201772981,30.8197997534,13.8285315399,-14.5195844759,-4.98213017852,10.9911903243,6.09497594574,0.200339419082,-8.0380179572,-3.35892492477,-15.8964001525,9.00743182148,-15.2197734312,2.36168170086,-2.35404882458,-2.91339027316,-5.82229652361,4.22904118109,-0.44833765631,-6.1600111618,-1.14851182203,-1.55249233349,0.711024920657,-3.71649011306,0.358429623772,2.49073593636,1.54196282952,-5.4769475212,2.36440870274,-0.726140416483,-0.302937978328,-4.12387643959,0.609989982372,2.7205266287,-0.122967788345,0.48019327583,-0.578513602178,-1.54245143802,-1.33567407716,-0.0545260099534,-0.619573054758,0.226825198962,0.73431300501,0.551654578576,-0.475134055816,0.743457381951,-0.297817618373,-0.0869213419168,-1.60087876007,0.278594997232,0.693128187898,-0.250211779809,0.203102620415,-0.21791581201,0.276823641464,-0.0307634975862,-0.067235813806,-0.108907174652,-0.0997817871783,0.0409611107092,0.0471996446014,0.181465700499,-0.0967499155229,0.099555442863,0.245508046404,-0.068947760691,0.0479384607795,-0.31058787684,0.340161824719,-0.145718548989,0.000585174559378,-0.105767297187,-0.021278906695,-0.0760883579881],[-35546.4554155,-1457.39332412,293.455052638,-316.303230613,-69.943201519,-605.949770437,128.143024467,-144.883809514,-114.346953097,163.01004139,-302.894612104,-561.479897929,57.43373332,613.405616947,-4.16528065414,-206.52263076,-36.9487433877,257.128378473,-124.754919653,-213.931706101,-107.23725718,362.396987149,226.971614796,152.490948835,116.472223393,-42.1956373566,-10.666942922,201.895376997,258.380665193,-30.3301978563,47.3916435233,80.0402734702,-241.929756895,24.4334892934,62.0121027519,-2.70211401099,-31.5874155813,-38.1042062673,64.7530294583,66.1908198204,27.6496174164,-21.4587202624,-21.9608787527,-88.8132855638,26.8900384834,-4.27446636723,6.55890025995,30.7543474471,13.9797679154,-15.2321344059,-5.28046097996,10.9517601463,6.10585443893,0.0530041157554,-7.54837733304,-3.14784394052,-15.9064592478,9.42579593955,-15.4873933516,2.45216377694,-1.94505672853,-2.59264704053,-5.52772471388,4.24867890876,-0.607281848739,-6.26842728319,-1.06043842744,-1.54556482395,0.682508276398,-3.6404760302,0.403670454093,2.45727603533,1.50941529569,-5.46052190169,2.27946846877,-0.597758299571,-0.221845598178,-4.0368624313,0.598879134609,2.77372230134,-0.121949226994,0.486535543571,-0.58525141851,-1.5267353675,-1.3402501522,-0.0635324494657,-0.646629723386,0.209879768633,0.717716476954,0.51982731944,-0.457083757296,0.74079652185,-0.244969656067,-0.0544167865994,-1.57773397306,0.278885045989,0.691300311471,-0.248625132664,0.22231526944,-0.217480970994,0.28547462762,-0.023097129525,-0.0658206094566,-0.112031845692,-0.102318500321,0.0293450679831,0.0390327724144,0.178379242741,-0.109737784384,0.105859563438,0.24680948581,-0.0621767517932,0.0535953179184,-0.303420092199,0.33351188536,-0.142125456782,-0.000738428557831,-0.0936179731595,-0.0214265323735,-0.0728969195375],[-35561.7796852,-1441.96743837,285.625682391,-279.069212447,-158.371841413,-638.418668893,139.765134883,-145.17133168,-130.81256028,150.322232084,-328.191185505,-551.35991431,75.1320597188,608.19871225,11.4121453462,-216.082602005,-25.153027824,268.435570325,-124.32503737,-211.222229417,-108.188807304,339.525672205,232.713992363,146.052477467,118.370782734,-37.006043076,-7.35371917534,201.433131121,257.692576385,-34.4349670641,48.3326154746,80.1985488194,-236.241387643,30.1141208442,62.2373420059,-1.69448420598,-32.3483016574,-38.6103183669,63.9833948334,65.8268378477,26.9203423357,-20.3859382196,-20.8430720436,-87.6496655277,28.3170653138,-5.48897526624,6.64982057321,30.6552362284,14.1248215975,-15.931296201,-5.5780340613,10.890530123,6.12490151004,-0.0889101225952,-7.03942969058,-2.94664969435,-15.8874144698,9.81231532711,-15.7412516713,2.52461213785,-1.55051141969,-2.2640416343,-5.24034704057,4.27025661549,-0.764299872495,-6.37346422112,-0.979501416338,-1.53929788494,0.649766436974,-3.56103280291,0.445959496608,2.43072189754,1.46880902659,-5.44108953337,2.19195637826,-0.473760782776,-0.135075372819,-3.95094638587,0.590127840146,2.8263328406,-0.11964142577,0.493719787757,-0.591482928801,-1.51195048495,-1.34525754303,-0.0745839136232,-0.674065817546,0.192884759712,0.702249509831,0.486244616364,-0.438632071687,0.737874331634,-0.192670376917,-0.0203112501522,-1.55508665179,0.280067968368,0.689514460656,-0.247805300657,0.241028234908,-0.216893080058,0.294474102874,-0.0153696569134,-0.0643011100863,-0.115444873036,-0.1053371781,0.0175192284347,0.0310548765329,0.17511050433,-0.122842258443,0.112279270064,0.247871410024,-0.0554274343809,0.0596439593187,-0.296548279268,0.327134910789,-0.138312836796,-0.00238472818648,-0.0814798313647,-0.0215265369103,-0.069727303471],[-35579.8535097,-1424.89437476,275.890596427,-241.986036997,-247.985955995,-669.27478051,151.154551523,-145.397154268,-147.286735365,138.705826235,-353.7540236,-541.539829136,91.3938010013,602.874929024,28.1480215568,-225.449686286,-13.5040383398,280.06889801,-123.973527756,-209.241223411,-108.584101054,317.028189631,238.550351686,139.903713212,120.112233991,-31.696420553,-4.029272123,200.932761341,256.809426236,-38.1759524027,49.4671075098,80.4765092666,-230.392986484,35.6002392048,62.4963749431,-0.723886457991,-33.0609118488,-39.0910362173,63.1930346512,65.4643198558,26.2792290942,-19.2395136081,-19.7108973138,-86.4184749539,29.6304694446,-6.64008581728,6.66254697332,30.5307996695,14.2618644166,-16.610135455,-5.87080280539,10.8147964807,6.15610969503,-0.2279310469,-6.51905788586,-2.7558906225,-15.8425419489,10.1657015346,-15.9768045725,2.57825327401,-1.17152858982,-1.93122665872,-4.9618829663,4.29288893636,-0.91817977834,-6.47495748635,-0.90488037862,-1.53324986182,0.612964068028,-3.4793221627,0.484691284645,2.41092258997,1.42111117447,-5.41918635049,2.10268601768,-0.354375875469,-0.0444000900042,-3.86636754042,0.583267449358,2.8778286685,-0.116117695738,0.501339200137,-0.597262846564,-1.4981238091,-1.35060649048,-0.0875949234616,-0.701576635662,0.175782043631,0.687898644101,0.451331379528,-0.420151326234,0.734851708299,-0.141331198471,0.0148406319326,-1.53301416651,0.281883446828,0.687730365404,-0.247756960398,0.259065926574,-0.216149760253,0.30363883047,-0.00768436075843,-0.0626907656034,-0.119145591445,-0.108753297064,0.00558704049577,0.0233040406521,0.171751166473,-0.135960842998,0.11866617642,0.248738400585,-0.0487750527025,0.0659403400039,-0.289974456108,0.321023471466,-0.134309770299,-0.00433639558891,-0.0694866144004,-0.0216022110984,-0.0666303906208],[-35600.7083452,-1407.18566775,264.891084349,-205.458938164,-338.107695534,-697.595627731,162.928447573,-145.278344289,-163.905519448,128.368318536,-379.304202425,-532.368828766,106.168329446,597.582774698,45.9495990986,-234.607732224,-2.21535422007,292.020704881,-123.775095447,-208.151702852,-108.387404563,295.142069064,244.45265158,134.159934264,121.701365477,-26.3095714347,-0.728636178045,200.403106406,255.735963283,-41.5340200225,50.8003068875,80.8998311404,-224.403941812,40.8568624745,62.7876418994,0.203277887461,-33.7187998234,-39.5392710574,62.3977192248,65.1081237003,25.7279888902,-18.0342931183,-18.5720490019,-85.1353899816,30.8228459793,-7.71514367713,6.59512966452,30.3910070553,14.3895619487,-17.2615703176,-6.15477898621,10.7328498623,6.20319407052,-0.367361035954,-5.99550769549,-2.57625044349,-15.7754366228,10.4847580332,-16.1891678491,2.61232789938,-0.808683815507,-1.59802530768,-4.69385774855,4.31557004767,-1.06757070603,-6.57284518722,-0.835294205381,-1.52696147637,0.572425458302,-3.39653984154,0.519222423142,2.39744902303,1.36732898852,-5.39534171325,2.01228154803,-0.239688984433,0.0481939136534,-3.7832773399,0.577645866612,2.92761938186,-0.111483274139,0.508974778619,-0.602624629097,-1.48519198467,-1.35616513933,-0.102394647314,-0.728864500141,0.158503767794,0.674546324975,0.415521877375,-0.402047635641,0.73187955539,-0.0913953179674,0.050443981522,-1.51157324602,0.283969057461,0.685871440367,-0.248463729263,0.276233141861,-0.215247902417,0.312770956759,-0.000142944211192,-0.0609953735031,-0.123124406967,-0.112451296335,-0.00635107735433,0.0158255976203,0.168397242188,-0.148986995734,0.124847338532,0.249457568471,-0.0423178949533,0.0723178461562,-0.28369837818,0.315135194228,-0.130148711962,-0.00656765199213,-0.0577794509661,-0.0216824182989,-0.0636599113697],[-35624.3756477,-1389.85285178,253.268435761,-169.893149851,-428.059210298,-722.458733002,175.703996216,-144.53196875,-180.804953622,119.517203681,-404.562798014,-524.196099559,119.405017333,592.470756706,64.7241290928,-243.54058844,8.49944525021,304.283334288,-123.804445081,-208.116682511,-107.562983966,274.104840139,250.392850857,128.936418813,123.142965508,-20.8882973684,2.51315424641,199.853005064,254.476936063,-44.4900360744,52.3374008661,81.4941907695,-218.293642024,45.8490087523,63.1095832108,1.08060748487,-34.3155192493,-39.9479341262,61.6132188671,64.763107237,25.268332922,-16.7851234407,-17.4342215464,-83.8160867498,31.8867900219,-8.70149450255,6.44561885104,30.2458276711,14.5065797698,-17.8785189387,-6.42597437779,10.6529809105,6.26986971315,-0.510502468555,-5.47702489611,-2.40841287581,-15.6896934294,10.7682882938,-16.3734572948,2.62607672787,-0.462552673342,-1.2682607751,-4.43779664479,4.33729412576,-1.21112179531,-6.66706543208,-0.769461787719,-1.51997345036,0.52847489654,-3.31388157139,0.548909517036,2.38987210719,1.3084697179,-5.37008498187,1.92136713033,-0.129785516451,0.140720301541,-3.70182722925,0.572610996275,2.97511457753,-0.105843398214,0.516207521109,-0.607601733696,-1.47309165636,-1.36180163435,-0.118812253513,-0.755631733388,0.14098207961,0.662074997662,0.379250378346,-0.384727114615,0.729108776453,-0.0433059326436,0.0859039204828,-1.49082061913,0.28596237636,0.683861100199,-0.249909224628,0.292334678194,-0.214184397385,0.321672628096,0.00715288957742,-0.0592207312809,-0.127371725647,-0.116315615035,-0.0181947066361,0.00866488028606,0.165144744497,-0.161814174332,0.130649812428,0.250076024659,-0.0361542493286,0.0786098639574,-0.277719800946,0.309427705914,-0.125862116459,-0.00905271862314,-0.0464994697616,-0.0217960218729,-0.0608695961005],[-35650.8868731,-1373.90746128,241.663940269,-135.693905959,-517.162650555,-742.941618765,190.098370638,-142.875094663,-198.121078981,112.359976364,-429.250886404,-517.370827875,131.05323694,587.687382479,84.3788626604,-252.232103554,18.426780786,316.849129585,-124.136281294,-209.299177157,-106.075105397,254.154032491,256.342908333,124.348445052,124.441822397,-15.4754000012,5.66106473726,199.291296064,253.037093116,-47.0248667089,54.0835767044,82.2852644826,-212.081475514,50.5416961375,63.4606392133,1.90170098873,-34.8446237945,-40.3099366626,60.8553038911,64.4341283217,24.9019723878,-15.5068512658,-16.305109386,-82.4762413978,32.8148966761,-9.58648395031,6.21206473709,30.105230802,14.611583456,-18.4538994678,-6.68040075412,10.5834802684,6.35985169954,-0.660657723497,-4.97185526434,-2.253061638,-15.5889073067,11.0150957878,-16.5247887032,2.61874047342,-0.133710739912,-0.945756254856,-4.1952249125,4.35705534694,-1.34748218593,-6.75755632926,-0.706102016731,-1.51182650555,0.481436671482,-3.23254308422,0.573109171263,2.38776275286,1.24554061178,-5.34394551655,1.83056692561,-0.0247508783043,0.231192737046,-3.62216865341,0.567510742716,3.01972385232,-0.0993033052018,0.522618425513,-0.61222761766,-1.4617594689,-1.36738412032,-0.136676910393,-0.781580657809,0.123149126485,0.650367107372,0.342951150883,-0.36859587786,0.726690275037,0.00249376026147,0.120625570682,-1.47081301465,0.287500979615,0.681622759552,-0.252077063868,0.307175332998,-0.212956135996,0.330145990834,0.0141014374565,-0.057372636432,-0.131877953535,-0.120230692286,-0.0298434288701,0.00186722149784,0.162089686416,-0.174335836476,0.135900654134,0.250640880125,-0.0303824040237,0.0846497795898,-0.272038479867,0.303858633362,-0.121482438462,-0.0117658167089,-0.0357877994866,-0.0219718851816,-0.0583131751958],[-35680.1131653,-1360.12233727,230.316464276,-103.130976898,-604.843111674,-758.317671958,206.551597562,-140.166552319,-215.887739956,107.081882709,-453.156715446,-512.144545601,141.07766882,583.35120358,104.782423749,-260.660179176,27.3898782671,329.688443481,-124.845256637,-211.826402974,-103.90982147,235.481171284,262.282071795,120.500774007,125.598881698,-10.1101251115,8.68502670379,198.724241175,251.42728801,-49.1280743831,56.0381128509,83.2946971749,-205.792812797,54.9076076096,63.8392536806,2.65870775452,-35.3003713461,-40.6194593968,60.1388259543,64.1276177736,24.6284894101,-14.2135645484,-15.1915039961,-81.129176035,33.6022249088,-10.357651145,5.89399263391,29.9787164743,14.7026316145,-18.9816873942,-6.91463695585,10.5315401813,6.47642602545,-0.820781817946,-4.48712095677,-2.11100944311,-15.4760969088,11.2247737728,-16.6389131849,2.5899086343,0.177721496977,-0.634248890048,-3.96751351654,4.37391301187,-1.47557246471,-6.8442328761,-0.644010696475,-1.50203824719,0.431517168815,-3.15348927883,0.591177936852,2.39084748381,1.17943574244,-5.31721067479,1.74052819771,0.075379548996,0.317863071222,-3.54442022789,0.561798936934,3.06094329478,-0.0919691771482,0.527811141915,-0.616545380593,-1.45111379306,-1.37278656819,-0.155829738394,-0.806457862816,0.104932238468,0.639385110502,0.307000096665,-0.35397006764,0.724748483498,0.0456320431824,0.154042151596,-1.45158776828,0.288270339708,0.679106292571,-0.254943725625,0.320594375101,-0.211559778575,0.338012771023,0.0206169866253,-0.0554556327343,-0.136632069075,-0.124093750841,-0.0412079488514,-0.00453447885263,0.159316783989,-0.186459787208,0.140458777753,0.251184827113,-0.025090606591,0.0902992373734,-0.266651863137,0.298394534018,-0.117034199935,-0.0146833611263,-0.0257685103759,-0.0222368063402,-0.0560382742742],[-35711.2844189,-1348.31554703,217.855181384,-71.9322791145,-690.937469432,-768.643737496,224.795117871,-136.832225145,-233.729994328,103.779174567,-476.337220256,-508.378166747,149.504226617,579.460948106,125.64892761,-268.778928873,35.3591842322,342.683666123,-126.005815306,-215.682381807,-101.14033072,218.093763793,268.218744926,117.456098037,126.599717928,-4.81749500241,11.5748348449,198.147794242,249.682794452,-50.8240067795,58.1766525151,84.5280080075,-199.47695285,58.9500856692,64.2438841378,3.33797994161,-35.6798366668,-40.875761024,59.4749620928,63.8562982668,24.4389498066,-12.9163163008,-14.0965849991,-79.7787966512,34.2536891394,-11.0033090825,5.4968282807,29.8739076792,14.7753549774,-19.4600875653,-7.12753009025,10.4999593044,6.62116236316,-0.992440322538,-4.02544964988,-1.98358498236,-15.3519757561,11.4000746535,-16.7141231183,2.54056584606,0.473443904657,-0.337131620574,-3.75541625115,4.38718691855,-1.59539900678,-6.92691762586,-0.582291282859,-1.4900338144,0.378451161997,-3.07676172133,0.602472149199,2.39947527707,1.11059647463,-5.28919980315,1.65199062186,0.17077048753,0.399935905784,-3.46856925054,0.555353116453,3.09861496032,-0.083950975317,0.531479929104,-0.620636691337,-1.44099990387,-1.37790625375,-0.176159666386,-0.830187005838,0.0862394761695,0.629411508205,0.271539650321,-0.340805936456,0.723301949442,0.0860231172449,0.185699273139,-1.43310464319,0.288147514668,0.67636741136,-0.25845713361,0.33256895895,-0.209991063395,0.345173013503,0.0266777856843,-0.0534692490961,-0.141617340301,-0.127853147968,-0.0522434644736,-0.0105570527006,0.156865565359,-0.198151221006,0.144310529688,0.251682882919,-0.0203269420121,0.0955329141812,-0.261548169885,0.293037687756,-0.112510192,-0.0177905413511,-0.0164974388049,-0.0226093224799,-0.0540680998969],[-35743.4702165,-1338.06646443,202.506841993,-41.6902655624,-775.385544709,-774.172524786,244.383225985,-133.439759852,-251.170703214,102.525855218,-498.916507767,-505.834950853,156.374132248,575.985388286,146.653862323,-276.536519197,42.3419503848,355.695197016,-127.692349412,-220.815336913,-97.861618164,201.953312821,274.168620384,115.266592335,127.426062841,0.381023891684,14.3252496819,197.555332129,247.84499118,-52.1457078873,60.4689300965,85.9866847078,-193.189176768,62.6801376973,64.6729915479,3.92442041039,-35.9807987385,-41.0793697305,58.8739706873,63.6344654387,24.3222903191,-11.6254007994,-13.0226290543,-78.4266552064,34.7766676502,-11.5119642264,5.02747252367,29.7979581494,14.8247773084,-19.8883621677,-7.31849433119,10.4904378954,6.79520130407,-1.17685144628,-3.58834540014,-1.87224594156,-15.2166810856,11.5445406214,-16.7493461986,2.47204552863,0.755611439246,-0.0577113355297,-3.55953261797,4.3962619893,-1.7072396343,-7.00541002078,-0.520124144749,-1.47521522979,0.321855521429,-3.00217114466,0.606348089792,2.414150723,1.03935099618,-5.25899024547,1.56571697614,0.26163668515,0.476854030114,-3.39457018977,0.54815674543,3.13266739602,-0.0753596057767,0.533341698043,-0.624592861044,-1.43124480244,-1.38264627895,-0.197567575347,-0.852736011307,0.0669740828452,0.62080881282,0.23665387972,-0.328969764365,0.722342749287,0.123652663248,0.215170642835,-1.41530400945,0.287057458915,0.673488287514,-0.2625580728,0.343110710393,-0.208245498219,0.351546342811,0.0322780735844,-0.0514117607083,-0.146815607647,-0.131470024569,-0.0629162969047,-0.0162297649379,0.15476426169,-0.209389679708,0.147474114416,0.252095646109,-0.0161294546257,0.100353745024,-0.256713311972,0.28779930506,-0.107895273072,-0.021074740509,-0.00801336268407,-0.0231059054863,-0.0524197538608],[-35775.7401407,-1328.95446333,182.498196505,-11.9973891962,-858.127158385,-775.156743235,264.870216326,-130.55680315,-267.732727731,103.395927946,-521.018684913,-504.278157456,161.728607633,572.893296346,167.472715965,-283.881116705,48.3454284282,368.583435666,-129.979251065,-227.173491551,-94.1686688159,187.021321171,280.147390828,113.984432096,128.059648193,5.46396513649,16.9310317359,196.9402317,245.955256933,-53.1262216956,62.8846799948,87.6722150035,-186.984765647,66.1087710749,65.1250368738,4.40293202123,-36.2010365429,-41.2308137025,58.3461101185,63.4764149271,24.2674476895,-10.3511123207,-11.971912821,-77.0743036607,35.1785387239,-11.8721230405,4.492826209,29.7580216173,14.8459223709,-20.2657733882,-7.48694385258,10.504676212,6.9996834396,-1.37523339817,-3.177312264,-1.77845000647,-15.0703501339,11.6617138678,-16.7435101211,2.38568110191,1.02637905686,0.200705075987,-3.38046211863,4.40052314648,-1.81137216948,-7.07950950312,-0.456689651015,-1.45698451596,0.261347117511,-2.92952828178,0.602162040119,2.43537841193,0.966027494934,-5.2256593456,1.48247003859,0.348192889708,0.548060233594,-3.32237751399,0.540193288023,3.16302914899,-0.066305974596,0.533113359698,-0.628505200864,-1.42167548986,-1.38690974574,-0.219954346255,-0.874072803658,0.0470393017486,0.613939536687,0.202426852727,-0.318327831426,0.721862959451,0.15850636199,0.242029968207,-1.39812623714,0.284925126868,0.670551092627,-0.267187328173,0.352231255281,-0.206318590809,0.357052383482,0.0374120892762,-0.0492814427617,-0.152208711544,-0.134905521541,-0.0731927673127,-0.0215818804566,0.153041104148,-0.220154705151,0.149967736414,0.252383715244,-0.0125361887703,0.104764664913,-0.252133201259,0.28269059641,-0.103174301563,-0.0245233417256,-0.00035505992378,-0.0237430272448,-0.0511103379627],[-35807.1637738,-1320.55891759,156.05599532,17.5538970299,-939.102131338,-771.849102252,285.810383314,-128.75100175,-282.938928995,106.463396031,-542.767858626,-503.471046096,165.608874689,570.153444517,187.780976615,-290.760887949,53.3768700659,381.208781577,-132.940912375,-234.705068978,-90.1564676914,173.259291645,286.170748914,113.661792511,128.48220574,10.4098622977,19.3869415285,196.295869818,244.054970449,-53.7985921933,65.3936366094,89.586086622,-180.919000582,69.2469931827,65.5984810784,4.75841763449,-36.3383290618,-41.3306211264,57.9016387669,63.3964423694,24.2633586596,-9.10374514134,-10.9467129583,-75.7232939742,35.4666806427,-12.0722919884,3.89979018291,29.7612518154,14.8338139284,-20.5915834136,-7.63229282832,10.5443745118,7.23574936114,-1.58880438723,-2.79385429791,-1.70365486287,-14.9131201379,11.7551365842,-16.6955425811,2.28280598581,1.28790171361,0.43481072488,-3.21880425474,4.39935531241,-1.90807443448,-7.14901551513,-0.391168170525,-1.43474369551,0.196542820647,-2.85864386563,0.589270281667,2.46366293423,0.890954158743,-5.18828444738,1.4030125873,0.430653849056,0.612997305607,-3.25194569163,0.531446208388,3.18962876634,-0.0569009878434,0.530511825033,-0.632465021949,-1.41211896723,-1.39059975609,-0.243220860089,-0.894165307324,0.0263383761338,0.609166192144,0.168942637211,-0.308746417697,0.721854656351,0.190569894269,0.26585095678,-1.38151169633,0.281675472948,0.667637998295,-0.272285684706,0.359942219463,-0.204205848926,0.361610760054,0.0420740717105,-0.0470765704471,-0.157778492425,-0.138120779786,-0.0830391968658,-0.0266426641485,0.1517243239,-0.230425839174,0.151809600159,0.252507688888,-0.00958518878488,0.10876860886,-0.247793749609,0.277722772291,-0.0983321358885,-0.0281237281266,0.0064386915655,-0.0245371596407,-0.0501569539996],[-35837.1084337,-1312.48876973,121.892344419,47.2426432411,-1018.20854562,-764.494340595,306.854382501,-128.477012746,-296.445123252,111.751048139,-564.287620495,-503.203504691,168.123196981,567.762074126,207.286285706,-297.128302462,57.4404979063,393.441732721,-136.639320672,-243.323815841,-85.9191281449,160.638104204,292.245126906,114.340061482,128.687139374,15.1992176824,21.6880995663,195.614130154,242.181095626,-54.197553584,67.9680645811,91.7238593454,-175.033737968,72.1062517288,66.0938611959,4.98167772886,-36.3900019623,-41.3784797996,57.5483459216,63.4041290519,24.298472731,-7.89337091346,-9.94931851138,-74.3746718655,35.6483759413,-12.1032993224,3.25516111778,29.8131309061,14.7849604695,-20.864887059,-7.75391936684,10.6113091714,7.50372306839,-1.81848018611,-2.4395625178,-1.64867907811,-14.7457036531,11.8276949783,-16.6048454104,2.1645101952,1.54213361182,0.641710861541,-3.07471376148,4.39215449894,-1.9975304568,-7.21377415151,-0.322649316541,-1.40791691815,0.127275511888,-2.78948003887,0.56731294642,2.4990693336,0.814472938623,-5.14614641594,1.327850645,0.509347670912,0.671067084204,-3.18314420794,0.521851287652,3.21245283334,-0.0473265445855,0.52529561879,-0.636563356292,-1.40238318448,-1.39359555738,-0.26722695273,-0.912957255749,0.00481384676284,0.606720907804,0.136305499874,-0.300122556041,0.722287250589,0.219885667526,0.286249458147,-1.36535399516,0.27720905841,0.664817689235,-0.27779113408,0.366259492756,-0.201914701164,0.365144360886,0.0462556419609,-0.0448013907339,-0.163495895995,-0.141075693044,-0.0924066459981,-0.0314417568191,0.150840969102,-0.240179972269,0.153020204617,0.252444469649,-0.0072926747979,0.112363017967,-0.243665571085,0.272885322798,-0.0933638000609,-0.0318625482093,0.0123394802053,-0.0255010915355,-0.0495721342084],[-35866.13238,-1304.47123695,80.6607721086,76.8339118821,-1095.17752801,-753.305314415,328.038313964,-129.737534772,-308.438947254,119.076814475,-585.699500725,-503.371934674,169.648004662,565.825302892,225.824898082,-302.953041679,60.5284181778,405.19318094,-141.086844167,-252.805572333,-81.5472768858,149.166147446,298.339915492,116.017477741,128.714541539,19.8204085639,23.831066299,194.880923601,240.352937002,-54.3646009292,70.5903495154,94.057381174,-169.317135398,74.6997557284,66.6200185451,5.08710325623,-36.3515676524,-41.3707159641,57.2841445034,63.490198855,24.3592904442,-6.72917079193,-8.98206806846,-73.027458088,35.7305241636,-11.9652604495,2.56531899066,29.9124547713,14.7018093832,-21.0841096534,-7.85105731476,10.707561042,7.80066219409,-2.06396682219,-2.11637577744,-1.61178474573,-14.5711145101,11.8796513233,-16.4727169874,2.03091012494,1.7902259386,0.820159294324,-2.94656630821,4.37836107597,-2.07954908509,-7.27381811681,-0.249859679901,-1.37601684211,0.0542421148988,-2.72260458309,0.537065568343,2.53990446724,0.73698083829,-5.09934020153,1.25646321307,0.585055902458,0.721507602118,-3.11550261556,0.511153574821,3.23172008792,-0.0380485158806,0.517389720823,-0.640890119265,-1.39219988684,-1.3956809786,-0.291668279678,-0.930295618421,-0.0174345555691,0.606314277362,0.104700502768,-0.29247629053,0.723039489505,0.246722995764,0.303009890185,-1.34935969409,0.271328871867,0.662104902649,-0.283630494783,0.371216020844,-0.199500259439,0.367589129632,0.0499379495916,-0.0424840377049,-0.169288289053,-0.143725166424,-0.101185132208,-0.0360103029274,0.150413355886,-0.249383389548,0.153629226696,0.252236176319,-0.0055875700978,0.115523357711,-0.239658088557,0.268080856486,-0.0883049804938,-0.0357235119578,0.0173603597448,-0.0266328796956,-0.0493501325864],[-35895.0916074,-1296.26310509,33.500162275,105.964268477,-1169.69846643,-738.486909218,349.494638906,-132.422276847,-319.240992882,128.207410626,-607.124514177,-503.899365856,170.626769534,564.476717637,243.265221945,-308.209090014,62.6297080135,416.384116541,-146.283446291,-262.891702036,-77.1306689624,138.861187124,304.415244965,118.681492727,128.616176819,24.2637809569,25.8127621616,194.080667859,238.585384272,-54.3429195046,73.245407259,96.5525721624,-163.743925763,77.0411545241,67.1878705159,5.09498278681,-36.2180852255,-41.3028154729,57.1044783418,63.6406613081,24.4318250998,-5.62010330726,-8.0473126037,-71.6801671537,35.7199291053,-11.6606125652,1.83653960481,30.0563477228,14.5882927836,-21.2475091542,-7.92290445323,10.8352870937,8.12280777925,-2.32466788649,-1.82631989006,-1.59059484087,-14.3929418578,11.9106119087,-16.3009298271,1.88187876482,2.03312912728,0.969321971074,-2.83229279781,4.35742650288,-2.15384537333,-7.32922676807,-0.171435095838,-1.33857825272,-0.0216444360041,-2.65873668955,0.499587531894,2.58403564571,0.658888624635,-5.04816427567,1.18807253758,0.658673450742,0.763515940753,-3.04846548396,0.499050435872,3.24770730617,-0.0296037657847,0.50676072476,-0.64553494708,-1.38128176835,-1.39661599417,-0.316199451336,-0.946003173835,-0.0402678025586,0.607526510786,0.07433290678,-0.285858418042,0.723967454621,0.271407919627,0.315958812842,-1.33318859167,0.263813508768,0.65950088886,-0.289727792006,0.374849013378,-0.197029556499,0.368884273765,0.0530995262898,-0.0401586172215,-0.17507214367,-0.146022857875,-0.109249412261,-0.0403798228458,0.15046261737,-0.25799972478,0.153668637792,0.251941231734,-0.00437697376293,0.11821959966,-0.235665427099,0.263190261524,-0.0832015292009,-0.0396895947278,0.0215247502652,-0.0279268978632,-0.0494806335709],[-35924.8421107,-1287.62116002,-18.4506011954,134.270278551,-1241.46074884,-720.244010505,371.355818536,-136.420947989,-329.171852017,138.909552182,-628.683675711,-504.708828051,171.502963397,563.849905181,259.475665494,-312.87043188,63.7334445467,426.935529831,-152.229090473,-273.32356853,-72.759059423,129.740988993,310.43124562,122.31955788,128.443809794,28.5196808762,27.6301075892,193.197780628,236.893327133,-54.1756945863,75.9181536586,99.1753523654,-158.288841955,79.144097458,67.8083344983,5.02560489081,-35.9846137749,-41.1702641789,57.004791266,63.8415259402,24.502089998,-4.57512698998,-7.14740309124,-70.3313135746,35.6233945624,-11.1917928652,1.07509876347,30.2419340723,14.4483427851,-21.3533435187,-7.96865856341,10.9966442966,8.4664008649,-2.59998697004,-1.57142066889,-1.58273233862,-14.2147748455,11.9201830242,-16.0912564448,1.71728910468,2.27179361116,1.08836483963,-2.7298241332,4.3288022391,-2.22013437547,-7.3800794623,-0.0860113995857,-1.29513593531,-0.0994712065043,-2.59859554957,0.455938221535,2.62933017955,0.580607064546,-4.99291710992,1.1219008646,0.731095222812,0.796289181511,-2.98147738263,0.48523923678,3.2606912642,-0.022529158354,0.493375224232,-0.650587475952,-1.36934152308,-1.39616057851,-0.340475078109,-0.959902700489,-0.0635468659025,0.609937818045,0.0454079727963,-0.280319735453,0.724927227459,0.294266479762,0.324922786064,-1.31650048644,0.254441564562,0.657006898193,-0.296007050941,0.377195680008,-0.194569625093,0.368969000763,0.0557189037424,-0.0378592351451,-0.180763931919,-0.147922425349,-0.116474242922,-0.0445818369468,0.151009886678,-0.265992611731,0.1531704093,0.251618058732,-0.00356798487164,0.120421715383,-0.231581711783,0.258094426081,-0.0780992981955,-0.0437437718751,0.0248560718479,-0.0293775197807,-0.0499533215992],[-35956.2398847,-1278.30218759,-74.0526344163,161.388507628,-1310.15376317,-698.78150378,393.754314058,-141.623257216,-338.552116538,150.949954731,-650.498000188,-505.723351071,172.720058054,564.078452342,274.324636929,-316.911051688,63.8287049107,436.768411118,-158.923740145,-283.842535396,-68.5222033161,121.823318808,316.348047749,126.91912464,128.249205048,32.5784543364,29.280023017,192.216679606,235.291655282,-53.9061114501,78.593504561,101.891641838,-152.926616866,81.0222338726,68.4923278823,4.89925813844,-35.6462123939,-40.9685479354,56.9805271051,64.0788022804,24.5560984392,-3.60320037059,-6.28469050522,-68.9794118627,35.4477243308,-10.561238545,0.287272269889,30.4663381317,14.2858915017,-21.3998707045,-7.98751742644,11.1937896208,8.82768249204,-2.88932766385,-1.35370392716,-1.58582021412,-14.0402026222,11.9079709591,-15.8454693553,1.53701413432,2.50716982357,1.17645384785,-2.63709121727,4.29193974401,-2.27813114549,-7.42645555651,0.00777557362413,-1.24522467522,-0.178325262286,-2.54290035442,0.407177021725,2.67365537933,0.502546924914,-4.9338971758,1.05717044019,0.803216125716,0.819024405795,-2.91398288104,0.469417343521,3.2709487381,-0.0173615576448,0.477199812869,-0.656137342093,-1.35609184508,-1.39407470603,-0.364149770401,-0.971816976881,-0.0871327172974,0.613128409105,0.0181309617045,-0.275911039641,0.725774889544,0.315624716811,0.3297283698,-1.29895517696,0.2429916347,0.654624180972,-0.302392296779,0.378293230385,-0.192187497969,0.367782518101,0.0577746136365,-0.0356199973368,-0.186280125872,-0.149377526795,-0.122734380955,-0.048647865603,0.152076296931,-0.27332568417,0.152166512616,0.251325080148,-0.00306770250227,0.122099676447,-0.227301067682,0.252674238324,-0.0730441394911,-0.0478690187555,0.0273777445739,-0.0309791191903,-0.0507578811088],[-35989.8638549,-1268.37330799,-132.384764377,186.937769905,-1375.50931493,-674.354167516,416.82896116,-147.880065716,-347.67138109,164.129180556,-672.667430828,-506.865756819,174.652766464,565.259245387,287.672027083,-320.304026004,62.9331190987,445.804710516,-166.354823976,-294.229014838,-64.5128639881,115.118722848,322.1282509,132.458875237,128.081965482,36.4407793904,30.7570907842,191.124802051,233.786549857,-53.5735915352,81.2582367105,104.666743537,-147.635609217,82.6885021786,69.2466927922,4.73527699301,-35.1984937671,-40.6938011394,57.0273660744,64.3378521496,24.5819787273,-2.71146287561,-5.46228964844,-67.6251608987,35.1996247841,-9.7738048623,-0.521819183694,30.7267888302,14.1045091242,-21.3859989815,-7.97864981478,11.4284240017,9.20286311964,-3.19164502971,-1.17480509911,-1.59721872677,-13.87292946,11.8734680416,-15.565605565,1.34015372689,2.73996376046,1.23325736401,-2.55221667574,4.24635352765,-2.32763678132,-7.46828782043,0.1110216902,-1.18851042407,-0.257291692222,-2.49225774855,0.354566932735,2.71497808792,0.425089400348,-4.87138653995,0.992870946067,0.875830785396,0.831054167874,-2.8456501876,0.451349412469,3.2786906543,-0.0145386608326,0.458222345651,-0.662229953881,-1.34128730693,-1.39012989741,-0.38694798263,-0.981595972266,-0.110821216008,0.616684194651,-0.00729292236115,-0.272663209474,0.726315910646,0.335784997403,0.330223030405,-1.28033418228,0.229296669036,0.652321918726,-0.308802565311,0.378193449515,-0.189937748382,0.365271972778,0.0592444689969,-0.033472239885,-0.191547669423,-0.150360876665,-0.127926245945,-0.0525961495279,0.15367359612,-0.279951376966,0.150683226819,0.251112063384,-0.00277514907112,0.123213832635,-0.222742596927,0.246829390451,-0.0680961835362,-0.0520460447618,0.0291067682626,-0.0327250562648,-0.0518832246773],[-36025.184669,-1259.14297881,-193.39666157,210.465874268,-1437.42887995,-647.416352073,440.744093456,-154.886843353,-356.695251374,178.383178716,-695.207624295,-508.05803556,177.400766233,567.342368364,299.343657326,-323.018799996,61.1785285438,453.97021737,-174.459631585,-304.419613546,-60.835837978,109.608869489,327.744331634,138.882415071,127.983047273,40.1486622435,32.0465408464,189.921663444,232.349357773,-53.2025009344,83.9065704431,107.463492033,-142.408681039,84.1529970604,70.0619702895,4.54917949025,-34.6392849438,-40.3447523657,57.1419339318,64.6014465349,24.57631918,-1.89977751546,-4.68637063834,-66.2779970384,34.8854126066,-8.84401932387,-1.35167534906,31.0209335665,13.9063181502,-21.3132378702,-7.941108466,11.7004242365,9.58803087848,-3.50410001234,-1.03479810291,-1.61323727327,-13.7171201227,11.8157107525,-15.2547600448,1.12271528883,2.96990366838,1.26045343825,-2.47409002562,4.19181030263,-2.36879655684,-7.50492267454,0.223749623118,-1.12518379868,-0.335447677951,-2.446824189,0.300185418076,2.75166327739,0.348497396326,-4.80560164946,0.927061806662,0.949332703381,0.832252913474,-2.77704206637,0.431069261582,3.28386454058,-0.0141014975718,0.436515722961,-0.668733808351,-1.32484999534,-1.38414385837,-0.408873545274,-0.989198418938,-0.134147771575,0.620213888235,-0.0306587022777,-0.270527451784,0.726153313528,0.354954992096,0.326337859869,-1.26090590359,0.213407035041,0.649941017806,-0.31513693473,0.377006423815,-0.18782511162,0.361416269889,0.0601034081982,-0.0314362197859,-0.196535393763,-0.150921415408,-0.13203290875,-0.0563918108005,0.15577599172,-0.285777329399,0.148724061715,0.250994154103,-0.00255704034623,0.123686046584,-0.217925309883,0.240534790771,-0.0633726745196,-0.0562464954362,0.0300344616862,-0.0346046368978,-0.053315177445],[-36061.3959054,-1252.22999198,-257.255707363,231.502878274,-1495.8563516,-618.472300778,465.670419043,-162.300212163,-365.758335853,193.681744968,-718.11316561,-509.221969652,180.994976124,570.241204767,309.156831657,-325.023910984,58.7253275389,461.191680832,-183.162917833,-314.389986829,-57.5989301232,105.268207632,333.171235764,146.124580334,127.991244918,43.7544411393,33.1312650633,188.609798825,230.942717388,-52.8134419035,86.5345869926,110.244104799,-137.242320192,85.4251022711,70.9246261701,4.35552955898,-33.9669665647,-39.9207787329,57.3210928212,64.8517087149,24.5378231182,-1.16618819655,-3.96386742106,-64.949541006,34.5113070599,-7.78882749853,-2.20295108899,31.3465243567,13.6930791536,-21.1837472037,-7.87391710897,12.0092110876,9.97924331729,-3.82340502722,-0.933366477754,-1.62992253461,-13.5770544968,11.7336216115,-14.9162922567,0.879933109909,3.19647335651,1.26022254112,-2.40179250677,4.12813983218,-2.40184178991,-7.53555995206,0.345713746996,-1.05556658215,-0.411868424299,-2.40664358594,0.24631355707,2.78217545217,0.273004246047,-4.73674254653,0.857569882063,1.02401510009,0.822630561187,-2.70894492035,0.408677999216,3.28635207503,-0.015991930636,0.412174106531,-0.675473174699,-1.30674387552,-1.37594584087,-0.430000132827,-0.994610239949,-0.156582681104,0.623331904124,-0.0517614576753,-0.269435055395,0.724839509201,0.373318697433,0.318024856593,-1.24106046259,0.195427454592,0.647290315768,-0.321289493832,0.374856815058,-0.18584186348,0.356202254051,0.060325650953,-0.0295294242623,-0.201222601905,-0.151127139978,-0.135059103049,-0.0599866918409,0.158348306073,-0.290699981853,0.146286834793,0.250977842533,-0.0022720154336,0.123428559146,-0.212893193974,0.23378415162,-0.0590051350652,-0.0604397503578,0.0301457233547,-0.0366061534131,-0.0550387926924],[-36097.6911423,-1249.25313943,-324.129283125,249.578839483,-1550.73562327,-588.026256959,491.778646016,-169.776794179,-374.995242992,209.994675064,-741.378639797,-510.27934145,185.466314901,573.869138092,316.928854081,-326.287896286,55.733910377,467.395850052,-192.389437577,-324.115789999,-54.909945261,102.071186177,338.383909103,154.120207217,128.145352914,47.3104543211,33.9941552946,187.191743233,229.529267058,-52.4270166987,89.1383675927,112.970799309,-132.133014535,86.5142015635,71.8211262299,4.16889112803,-33.1799192704,-39.42125736,57.5617048865,65.0707619685,24.465193863,-0.508738825278,-3.3017139427,-63.6514135262,34.0835274059,-6.62517495514,-3.07630126627,31.7013132171,13.4665527087,-20.9996868153,-7.77609947255,12.3542053175,10.3725579848,-4.14627248981,-0.870193762821,-1.64332119177,-13.4570124691,11.626123138,-14.5535616629,0.607041479906,3.41915663401,1.23474514319,-2.334405359,4.05517187954,-2.42700379839,-7.55939948617,0.476668436451,-0.979980557579,-0.485629136093,-2.37175984957,0.19523242904,2.80497911664,0.19884328271,-4.66500927334,0.782222032357,1.10017119595,0.802197029603,-2.64214515253,0.384276733727,3.28603493575,-0.0201518227989,0.385291658096,-0.682272322124,-1.28693291271,-1.3653650969,-0.45040141978,-0.997817358353,-0.177596241703,0.625652656585,-0.0703962681838,-0.269317309133,0.721926908675,0.391060109955,0.305236018976,-1.22118798101,0.175462649565,0.644178650168,-0.327154331409,0.371869285017,-0.183980279756,0.349616769884,0.0598854169735,-0.0277693405375,-0.205588596863,-0.151046047325,-0.13700956252,-0.0633326350691,0.161355361525,-0.294615774708,0.143369363544,0.251069618899,-0.00177871343925,0.122353611171,-0.207690236624,0.226571185335,-0.0551250877968,-0.0645951891057,0.0294254517783,-0.0387178981347,-0.0570391237],[-36133.2639581,-1251.83121309,-394.184770224,264.223815452,-1602.01058835,-556.582463947,519.239482472,-176.973211435,-384.540581255,227.29176476,-764.998631879,-511.151933311,190.845701328,578.139551831,322.477028597,-326.779293223,52.3646713513,472.509474181,-202.063945677,-333.572678368,-52.8766882285,99.9922540262,343.357297466,162.804131911,128.484165757,50.8690400325,34.6181034001,185.670031706,228.071645143,-52.0638275758,91.713993477,115.605793034,-127.07725193,87.4296786906,72.7379362647,4.00382812623,-32.2765237014,-38.8455653657,57.8606322716,65.2407295742,24.3571347355,0.0745266919456,-2.70684414938,-62.3952353232,33.6082929066,-5.37000726255,-3.97238074369,32.0830521639,13.2284993895,-20.7632165379,-7.64667928562,12.7348276887,10.7640324297,-4.46941481559,-0.844963497293,-1.64947992574,-13.3612739262,11.4921378515,-14.1699277255,0.299274688586,3.63743731009,1.18620171504,-2.27100982217,3.97273620793,-2.44451390014,-7.57564111006,0.616368066101,-0.898747508074,-0.555805018162,-2.34221689008,0.149223113308,2.8185387752,0.126247839512,-4.5906018721,0.698845117636,1.17809421138,0.770962237315,-2.57742916593,0.35796657347,3.28279480086,-0.0265230368344,0.355962539387,-0.688955519822,-1.26538107212,-1.35223087844,-0.470151080627,-0.998805697202,-0.196658750481,0.626790559887,-0.0863582134332,-0.27010550182,0.71696792296,0.408363226203,0.287923345416,-1.20167858053,0.153617341836,0.640414858562,-0.332625536256,0.368168495463,-0.182232636245,0.341646662006,0.0587569259721,-0.0261734558344,-0.209612681652,-0.150746134401,-0.137889020842,-0.0663814829052,0.164761980418,-0.297421148348,0.139969465457,0.251275973429,-0.000935773469149,0.120373443512,-0.202360425256,0.218889604254,-0.0518640553384,-0.0686821912593,0.0278585454672,-0.0409281633864,-0.0593012237487],[-36167.4769467,-1261.07945951,-467.46319575,275.058665861,-1649.73372347,-524.490387066,548.127928923,-183.656104635,-394.555093225,245.476988515,-788.979058447,-511.790041493,197.131829869,582.942913626,325.68412297,-326.482860802,48.7345165431,476.488486057,-212.103732874,-342.740002177,-51.5822758103,98.9869927152,348.07275978,172.08276008,129.035804936,54.4730488162,34.9881175244,184.05077749,226.535498383,-51.7413751301,94.2505675535,118.115931772,-122.076801592,88.177402842,73.6626423243,3.87277714193,-31.2574664414,-38.1933640278,58.2123367329,65.3436858202,24.2132281999,0.584312340646,-2.18415185843,-61.1919901655,33.0915780369,-4.0405287194,-4.89065200049,32.4874302772,12.9808452863,-20.4769190078,-7.48522807474,13.149621105,11.1494352854,-4.78988195906,-0.857048644203,-1.64496215928,-13.2935180815,11.3313565085,-13.7687358682,-0.0464525571719,3.85065303393,1.11692425096,-2.21080755238,3.88086149006,-2.45469416379,-7.58363452159,0.764415115184,-0.81241297705,-0.621525418188,-2.31792307549,0.110240259059,2.82160776118,0.0555042793876,-4.51373581093,0.605796170172,1.25797989769,0.729123454447,-2.51546177882,0.329906121573,3.27649252742,-0.0349938216272,0.324287197802,-0.695373079193,-1.24204899609,-1.33640873707,-0.489328074573,-0.997587496977,-0.213307357298,0.626415635536,-0.0994847885174,-0.271724861354,0.709629651879,0.425396604726,0.266168117626,-1.18284122704,0.130049250515,0.635847509407,-0.337602565174,0.363841208937,-0.180590667158,0.33229880588,0.0569230392878,-0.0247531824142,-0.213278849557,-0.150292814033,-0.137720516044,-0.0690867632338,0.168542981621,-0.299039292906,0.13609625649,0.251605488575,0.000377575163936,0.117441634285,-0.196940510772,0.210743689589,-0.049319003987,-0.0726746141633,0.025445985696,-0.0432210427542,-0.0618011310224],[-36200.3687633,-1276.0989438,-543.500169687,282.067458874,-1694.39183834,-491.480379629,578.13615555,-190.032189162,-405.304057962,264.191035611,-813.371162367,-512.258017862,204.194497788,588.078027705,326.694760001,-325.448244773,44.7863991873,479.405553253,-222.396233441,-351.611891386,-51.0110725793,98.9355143277,352.537307422,181.74877528,129.785699897,58.1273804127,35.097670952,182.354406661,224.898507059,-51.4647533135,96.7092794263,120.48657461,-117.154558161,88.749184955,74.5873114733,3.77966540152,-30.1326578459,-37.4654512598,58.6016784775,65.3615090312,24.0365732931,1.01631367408,-1.73037037196,-60.0501139976,32.5383781257,-2.65497854348,-5.82580798176,32.901884894,12.7261785542,-20.1450680729,-7.29350855727,13.5936170351,11.5233795237,-5.10607403083,-0.90457986198,-1.62839828223,-13.2550214553,11.1465428139,-13.3532753603,-0.426503882057,4.05755681485,1.02985084012,-2.15348187086,3.78037203645,-2.45822966106,-7.58332887712,0.919804481425,-0.72241754916,-0.682136255289,-2.29824460526,0.0789327949314,2.81409472352,-0.0128889157845,-4.4346882617,0.503552910979,1.33963412968,0.677627357252,-2.4564214707,0.300483960247,3.26690568843,-0.0452379705064,0.290391223394,-0.701479480432,-1.21688403526,-1.31790942287,-0.50803249967,-0.99428026788,-0.227346623031,0.624420334001,-0.109783150385,-0.274076371921,0.700037950494,0.442267052089,0.240568750562,-1.16466026307,0.105128083646,0.630484094763,-0.342006347001,0.358822591043,-0.179043940369,0.321660200357,0.0544011847655,-0.0234956326904,-0.216589854959,-0.149741162542,-0.136600303554,-0.0714087457972,0.17271317009,-0.299500397525,0.131804046481,0.252075115684,0.00219974232026,0.113677110673,-0.191438297991,0.202179998052,-0.047448674733,-0.0765642262248,0.0222530847968,-0.0455638348715,-0.0644788233196],[-36232.1470789,-1295.48718568,-621.70494774,285.325064776,-1736.5803259,-457.128016945,608.860624952,-196.418199068,-417.078888646,283.008774032,-838.237518074,-512.648728185,211.871278045,593.320782444,325.719026256,-323.741312578,40.4197843074,481.362527027,-232.821417534,-360.186170887,-51.1227550556,99.6990635834,356.764364883,191.566430539,130.708607078,61.8274468615,34.9423532525,180.604923501,223.141359839,-51.235954417,99.0443403736,122.70770896,-112.338697635,89.1333214036,75.5051310305,3.72629279095,-28.9143142136,-36.6629091341,59.0111173248,65.2760285411,23.8311481953,1.36497413743,-1.34019286328,-58.9774058079,31.953443715,-1.23185468238,-6.77134924907,33.3117904151,12.4672528642,-19.7723603845,-7.07383124828,14.0609690892,11.8801892014,-5.41672868056,-0.985377232905,-1.59893542616,-13.2464598947,10.9412287098,-12.9268214331,-0.83556249365,4.25675550218,0.928071095431,-2.09883651511,3.67229106708,-2.45589621444,-7.5748231977,1.08137916717,-0.63042556937,-0.737037591435,-2.28241213668,0.055623219425,2.79619714009,-0.0783802343903,-4.35375182223,0.393123233251,1.42276531304,0.617607973517,-2.40036513638,0.270146166475,3.25379103586,-0.0568756629122,0.254406491879,-0.707255245938,-1.18983021741,-1.29677998554,-0.526369738681,-0.989027837537,-0.238647961311,0.620752712989,-0.11730287145,-0.277054956783,0.688433362679,0.459065936869,0.211852942495,-1.14703887534,0.0792765465047,0.624371837593,-0.345763178579,0.353009908152,-0.177581482164,0.309837875132,0.0512174318766,-0.0223818441147,-0.219553142511,-0.149143672126,-0.134642943155,-0.0733093858022,0.177297347307,-0.298861401099,0.127158443736,0.252703898327,0.00454854765333,0.109240137126,-0.185854355209,0.193255655233,-0.04617725224,-0.0803472736165,0.0183612378662,-0.0479196396339,-0.0672652633425],[-36263.0195642,-1317.84170488,-701.486785612,284.906353853,-1776.89457911,-421.008874324,639.897799727,-203.130868406,-430.170998456,301.505071764,-863.640700002,-513.055038229,219.999743603,598.447066217,322.967008298,-321.427931653,35.5341369267,482.461258639,-243.259255309,-368.460665572,-51.8769997595,101.138885202,360.767356654,201.299978887,131.779282918,65.5686602023,34.5177539952,178.826332292,221.244745386,-51.0569707317,101.209961674,124.769322234,-107.65739601,89.3181085618,76.4092883145,3.71445919612,-27.614651843,-35.7868197232,59.4231130943,65.0690736842,23.6009310865,1.62473717588,-1.00831250571,-57.9816645849,31.3415253469,0.210344916344,-7.72077636396,33.7025212417,12.2068218876,-19.3634925936,-6.8285066628,14.5458308772,12.214188375,-5.72058355789,-1.09726083926,-1.55572072267,-13.2685092467,10.7189461382,-12.4926493174,-1.26831159953,4.44685594525,0.814674629786,-2.04667522262,3.55764180195,-2.44846964643,-7.55821650435,1.24798217475,-0.538101382645,-0.785629488599,-2.26965632704,0.0406340310403,2.76811248874,-0.140418164815,-4.27121909032,0.275515030186,1.50708185347,0.550199331029,-2.34734967065,0.23933881724,3.23690532169,-0.0695270782845,0.216464878974,-0.712680898108,-1.16083157027,-1.27306747476,-0.544445174372,-0.98197403358,-0.247082785769,0.615360830207,-0.122093524125,-0.280555539199,0.675056432307,0.475884627637,0.180748391695,-1.12988025054,0.0529173443692,0.617557960856,-0.348799356754,0.346300426636,-0.176192318834,0.2969388599,0.0473978500926,-0.0213928541386,-0.222176156865,-0.148552834981,-0.131962994627,-0.0747506384557,0.182320314754,-0.297179242521,0.122225056561,0.253510880076,0.00744181081663,0.104290978092,-0.180189250724,0.184027786721,-0.0454289211717,-0.0840200025112,0.0138518400005,-0.0502515569367,-0.070091413793],[-36293.1938901,-1341.76002114,-782.254939009,280.886196391,-1815.9299909,-382.698527075,670.844142473,-210.486931228,-444.871800571,319.254796794,-889.643282586,-513.569813763,228.417467425,603.2327674,318.648792691,-318.57396944,30.0289220687,482.803599347,-253.589716921,-376.433200331,-53.2334832111,103.116223904,364.559707227,210.71367335,132.972483854,69.3464324749,33.8194627498,177.042637316,219.189352368,-50.9297945486,103.160354605,126.661401842,-103.138829282,89.2918428037,77.2929706439,3.74596450297,-26.2458870327,-34.8382650994,59.8201256057,64.7224737943,23.3499001468,1.79004623463,-0.729422472547,-57.0706893171,30.7073735634,1.65312230511,-8.66758988798,34.0594517745,11.9476392956,-18.9231613513,-6.55984531592,15.0423560092,12.519701101,-6.01637631247,-1.23805076332,-1.49790130336,-13.3218453585,10.4832270411,-12.0540342445,-1.71943440728,4.62646499339,0.692751056089,-1.9968017309,3.43744746102,-2.43672577952,-7.53360781811,1.41845650653,-0.447109333951,-0.827312008754,-2.25920783363,0.0342877282781,2.73003824734,-0.198451195445,-4.18738266378,0.15173619498,1.59229215665,0.476535457575,-2.2974319683,0.208507989525,3.21600529787,-0.0828123960636,0.176698260396,-0.717736959338,-1.12983212161,-1.24681894025,-0.562364189506,-0.973262683636,-0.252522510034,0.608192743363,-0.124204680822,-0.28447304243,0.660147703253,0.492814492968,0.147982796429,-1.11308757538,0.0264731825161,0.610089687514,-0.351041178371,0.338591412866,-0.174865476667,0.283070184359,0.0429685088849,-0.0205097002138,-0.224466342675,-0.148021143303,-0.12867501775,-0.0756944589643,0.18780687391,-0.294510860685,0.117069493263,0.2545151045,0.0108973514637,0.0989898980214,-0.174443552832,0.174553518103,-0.0451278661915,-0.0875786590816,0.00880628629632,-0.0525226866755,-0.0728882373732],[-36322.8958377,-1365.96368213,-863.507891463,273.478282567,-1854.15906051,-341.931377038,701.347806725,-218.720648401,-461.329598812,335.868162009,-916.270916953,-514.265026797,236.975520529,607.490654332,313.027858338,-315.228132951,23.8239234485,482.495034724,-263.701485088,-384.089468639,-55.1655166298,105.525668969,368.136344766,219.603906802,134.259660522,73.1556465628,32.8457275598,175.276479462,216.966524901,-50.8583651777,104.864296967,128.368666634,-98.8081850802,89.0465474558,78.1475298862,3.81986530591,-24.820248853,-33.8196472789,60.1866662039,64.2238326781,23.0814453694,1.85883205622,-0.50141492733,-56.2509042336,30.0552837778,3.07969934398,-9.60464169142,34.369961357,11.6921922484,-18.4560892891,-6.27055883319,15.5449894232,12.7920304951,-6.30266609811,-1.40508982965,-1.42580142992,-13.4062880429,10.237285636,-11.614382469,-2.18343954301,4.79399668477,0.564930816713,-1.94888140444,3.312873412,-2.42136767599,-7.50124851446,1.59154409155,-0.359038031639,-0.861422390618,-2.25041077127,0.0366204775975,2.68233276107,-0.252037703595,-4.10262497079,0.0227913864653,1.67797702721,0.397661812839,-2.25058992313,0.178111078722,3.19093916722,-0.0963345807302,0.135279493241,-0.722392610833,-1.09683624143,-1.21813539073,-0.580161859402,-0.963094228383,-0.254895321185,0.599205974658,-0.123724661919,-0.288723492413,0.643920148453,0.509887898862,0.11419811215,-1.09658012192,0.000328951690171,0.602022859688,-0.352432942304,0.329818957922,-0.173591769281,0.268354339524,0.0379660540798,-0.0197118800785,-0.226426150805,-0.14758071373,-0.124906189148,-0.076102462336,0.193756612219,-0.290919176153,0.111752618399,0.255712307254,0.0149186731388,0.0934735964162,-0.168632955548,0.164901660503,-0.0451978335361,-0.0910172935052,0.00330802614846,-0.0547003830012,-0.0755888374501],[-36352.423629,-1389.67034731,-945.101037815,263.451582128,-1891.56271225,-299.077132172,731.263709771,-227.736388058,-479.120259567,351.096759909,-943.401561004,-515.129074323,245.578966166,611.181015207,306.581253494,-311.370487501,16.9201995485,481.655587596,-273.518092772,-391.366638307,-57.7009500327,108.395187918,371.418212139,227.895631481,135.599040349,76.9890687251,31.6054303664,173.545046054,214.610228915,-50.8544100049,106.348832652,129.854761205,-94.6786975583,88.5891536547,78.9569761043,3.92424503331,-23.350017461,-32.7386480521,60.5154523356,63.5838520329,22.7966039998,1.8429745727,-0.334977994424,-55.5232345254,29.3877308885,4.48017712359,-10.5221888794,34.6294491024,11.4419018628,-17.9671029609,-5.96496328219,16.0493413688,13.0303959094,-6.57729808527,-1.59381183196,-1.34445388453,-13.5182329754,9.98306524218,-11.1776243411,-2.6541373069,4.94709381279,0.432007671927,-1.90202611572,3.18565361336,-2.40280735732,-7.46199938683,1.76558256569,-0.275173137609,-0.887046579885,-2.24306308478,0.0465231172933,2.62599784431,-0.301175622298,-4.01768776097,-0.110327673981,1.76320686546,0.314269584097,-2.20648542488,0.148650753863,3.16192093592,-0.109627736928,0.0925453601253,-0.726571669019,-1.0620896687,-1.18733367116,-0.597592029587,-0.951895560695,-0.254356500083,0.58839590427,-0.120896779649,-0.293307325798,0.626476457103,0.526901201029,0.0796933230317,-1.08034150356,-0.0252817154916,0.593447796133,-0.352990955557,0.320074451715,-0.172369159624,0.252975661703,0.0324694369223,-0.0189727326167,-0.228038056965,-0.147182160653,-0.120834152813,-0.0759349027828,0.200068260975,-0.286491036155,0.106316321538,0.257004992317,0.0194520149498,0.0877845129961,-0.162833655753,0.155187767173,-0.0455608157336,-0.0943211719791,-0.00255127385494,-0.0567690170862,-0.0781348800512],[-36382.0935963,-1412.22170408,-1026.97900073,251.713884713,-1927.9989767,-254.664326966,760.498459837,-237.356045143,-497.676539866,364.727527895,-970.876249332,-516.129459578,254.146365644,614.301018182,299.839418756,-306.963937977,9.33912754281,480.408915105,-282.971785496,-398.189745726,-60.881268136,111.786092834,374.307755885,235.545939471,136.945544961,80.8389360648,30.110111585,171.86416102,212.165085791,-50.9316034349,107.655572072,131.078061588,-90.7606125021,87.9303194896,79.7034839096,4.04444382201,-21.8474857857,-31.604269153,60.801252973,62.8190080282,22.4958250968,1.75784101348,-0.243998788413,-54.8872306244,28.7067346648,5.84637654221,-11.4098398656,34.8353190662,11.1979227445,-17.4610549009,-5.64777584103,16.5513134234,13.2349957548,-6.83793894858,-1.79917330624,-1.26006857944,-13.6532197976,9.72219145443,-10.7478212346,-3.12516341768,5.08320635973,0.294316211474,-1.85520936421,3.0576641713,-2.38138408475,-7.41687358309,1.93880849152,-0.196724577148,-0.903207698997,-2.23707617649,0.0626001536189,2.56219617878,-0.345972773516,-3.93340261432,-0.246632499348,1.84692447066,0.226961390523,-2.16470136229,0.120641002387,3.12925606095,-0.122208754339,0.0488736250473,-0.730186609127,-1.02589848466,-1.15478458554,-0.614338238147,-0.940150186497,-0.251118101038,0.575767376872,-0.116003094212,-0.298246081915,0.607891747464,0.543591752607,0.0446816704319,-1.06437141906,-0.0501630009444,0.584463434764,-0.352749527164,0.309488108866,-0.171197397972,0.237133948522,0.0265681850126,-0.0182640569989,-0.229279543079,-0.146755722905,-0.116649169581,-0.0751516943179,0.206615337434,-0.281319269588,0.100797748498,0.258272355751,0.0244292998951,0.0819415225344,-0.157136976045,0.145539076901,-0.0461383668849,-0.0974733647051,-0.00867789282745,-0.0587172143582,-0.0804701718692],[-36412.222072,-1432.95943985,-1109.08640288,239.17297996,-1963.32588445,-209.221495911,788.958665147,-247.401514604,-516.431196738,376.547403368,-998.53601653,-517.233685797,262.596280269,616.847831415,293.332794717,-301.971389268,1.10208460567,478.87867439,-291.994808784,-404.483827289,-64.747955656,115.759695799,376.707422546,242.511922855,138.254095983,84.6974856851,28.3713116308,170.249648289,209.675716908,-51.1036198726,108.82612564,131.996943816,-87.0641756973,87.0807030495,80.369227914,4.16580180888,-20.324946756,-30.4255123156,61.0388370883,61.9457768339,22.1795577189,1.61879860798,-0.242364423879,-54.3424429624,28.0143148763,7.17011849811,-12.257203064,34.9849753039,10.9614094993,-16.9427976435,-5.32371368779,17.0468071647,13.4060284426,-7.08225536266,-2.01613078848,-1.17885542695,-13.8067881508,9.4562898675,-10.3290345233,-3.59015359405,5.19978430782,0.152191025095,-1.80740464938,2.930781192,-2.35743711956,-7.36688425111,2.10945843163,-0.124902275543,-0.908928870395,-2.23236144874,0.0834560928278,2.49209044617,-0.386536979212,-3.85060111084,-0.385134602621,1.92807264206,0.136339851289,-2.1248206241,0.0945958117364,3.09324999935,-0.13359452265,0.00464205200363,-0.733149906392,-0.98856877054,-1.12085893787,-0.630084023164,-0.928341611709,-0.24539217836,0.561325237135,-0.109325665805,-0.303561300091,0.588241137796,0.559696906733,0.00937639570695,-1.04866956718,-0.0741190865833,0.575168713498,-0.351742966159,0.298190143993,-0.170076234603,0.221028997609,0.0203518259505,-0.0175576523957,-0.230128091067,-0.146231639319,-0.112541500287,-0.0737127509545,0.213271358852,-0.275496705352,0.0952340450989,0.259393593617,0.0297824509733,0.0759634998045,-0.151634239023,0.136082828474,-0.046852041091,-0.100456941885,-0.0149781098826,-0.0605336002452,-0.0825385195964],[-36443.1253883,-1451.22524203,-1191.36786693,226.736657508,-1997.40146609,-163.277173495,816.550933927,-257.694691388,-534.816987214,386.34332373,-1026.22189719,-518.409256215,270.847271348,618.818623064,287.591821972,-296.355746263,-7.7695520888,477.188522593,-300.51940816,-410.173919389,-69.3424973091,120.377308894,378.519658662,248.750673716,139.47961504,88.5569546888,26.4005709191,168.717331793,207.186743647,-51.3841337227,109.90210377,132.569783922,-83.5996329295,86.0509624236,80.936382729,4.27365913076,-18.7946933008,-29.211379274,61.2229736537,60.9806346197,21.8482509248,1.44121458561,-0.343962015403,-53.888421971,27.3124912925,8.44322388957,-13.0538868883,35.0758218712,10.7335167331,-16.4171837229,-4.99749400058,17.5317241701,13.5436923838,-7.30791400214,-2.23964081468,-1.10702433933,-13.9744776765,9.18698607612,-9.92532558109,-4.04274355473,5.29427763932,0.00596670253344,-1.75758547072,2.80688078165,-2.33130572298,-7.31304453878,2.27576894859,-0.0609161580806,-0.90323321652,-2.22883030388,0.107695441173,2.41684332819,-0.422976061348,-3.77011483053,-0.52484549679,2.00559417891,0.0430075855691,-2.08642609904,0.0710291693508,3.05420820811,-0.143301931542,-0.0397715950085,-0.735374036045,-0.950406607558,-1.08592753214,-0.64451292272,-0.916953342257,-0.237390786356,0.545074329732,-0.101146554626,-0.309274519654,0.567599746358,0.574954016545,-0.0260092597867,-1.03323564667,-0.0969541543234,0.565662570248,-0.350005581578,0.286310771717,-0.169005419792,0.204860606593,0.013909887336,-0.0168253179777,-0.230561182851,-0.145540148727,-0.108701405768,-0.0715779867057,0.219909842485,-0.269116172343,0.0896623571604,0.260247901976,0.0354433911831,0.0698693195796,-0.146416767287,0.126946260679,-0.047623392453,-0.10325497372,-0.021358204134,-0.0622068001748,-0.0842837299254],[-36474.7752321,-1466.57899715,-1273.7714218,215.021130584,-2030.06180176,-117.260850517,843.190054219,-268.02951329,-552.360113191,393.97362657,-1053.77283305,-519.59592711,278.793307854,620.238274204,283.000723612,-290.107324226,-17.244216874,475.425913505,-308.472272782,-415.209133561,-74.6706485566,125.682657519,379.660892421,254.240725103,140.573711778,92.4037538734,24.208965218,167.282377179,204.735242034,-51.7780384956,110.920878347,132.760826233,-80.3762688972,84.8467655609,81.3891712597,4.35298979758,-17.2691226863,-27.9704295124,61.3506212882,59.9394152373,21.5031835804,1.23837408919,-0.561312235257,-53.5239918373,26.6006571942,9.65992766194,-13.7903381681,35.105227823,10.5144958614,-15.8886577571,-4.67336405363,18.0022618633,13.6482144587,-7.51298368537,-2.46580567903,-1.05043398112,-14.1520598147,8.91508564713,-9.53954037368,-4.47754303185,5.3642699371,-0.143903552194,-1.70520737131,2.68760599474,-2.3033211037,-7.25618453655,2.43607010349,-0.00580225570197,-0.885547339457,-2.22655796978,0.133900802543,2.33753500921,-0.455571005801,-3.69262805499,-0.664885078328,2.07839748708,-0.0524341530426,-2.04925256079,0.0503261891403,3.01243247797,-0.150879643153,-0.0840273446372,-0.736789338101,-0.911711097328,-1.05033868029,-0.657379483449,-0.906449829797,-0.227338585187,0.527064628145,-0.0917609389922,-0.315420209024,0.546013380343,0.589086451609,-0.0613098739856,-1.01810993898,-0.118515419523,0.556059135186,-0.347570950466,0.273965198293,-0.167978628732,0.188808961901,0.00732869655248,-0.0160448361844,-0.230563144787,-0.144630350453,-0.105302766386,-0.0687142675238,0.226412365104,-0.262268062853,0.0841038707448,0.260716703812,0.0413309301758,0.0636656355926,-0.141574120128,0.11823797264,-0.048376311462,-0.105856648808,-0.0277470563552,-0.0637256509528,-0.0856632673723],[-36505.7647075,-1479.45338833,-1356.25872146,203.476306755,-2061.05516988,-71.2058430054,868.823533331,-278.088089511,-568.960556044,399.582250229,-1081.0193944,-520.62246691,286.229989421,621.242517581,279.358852716,-283.326079929,-27.2495901135,473.533487527,-315.757866345,-419.634881907,-80.5952478405,131.64912034,380.103478596,259.046373927,141.474747929,96.2009888135,21.8057117058,165.957316976,202.328106665,-52.2551041245,111.902867152,132.557788252,-77.3995239503,83.4538198503,81.7200095846,4.38730331153,-15.7610495285,-26.7094535155,61.4274971992,58.8353832664,21.1489537803,1.01523391525,-0.901469986472,-53.2450717694,25.8676999078,10.824120949,-14.4603573961,35.0704222119,10.3009855388,-15.360032699,-4.35369150578,18.4558010531,13.719935425,-7.69714180562,-2.69531070851,-1.01353802593,-14.336233201,8.63811403559,-9.16966323443,-4.89305781117,5.40787918653,-0.296492077965,-1.65165406869,2.57366767893,-2.27378226005,-7.19640210521,2.58906595134,0.0400989780336,-0.85691175987,-2.22627497659,0.160567171359,2.25491568429,-0.485295454114,-3.61823587227,-0.804806777662,2.14525339892,-0.149389573271,-2.01364232268,0.0323564908914,2.96820993456,-0.15600340943,-0.127936396111,-0.737397611701,-0.872753422986,-1.01435072587,-0.668722286182,-0.897219308925,-0.215510658409,0.507526621099,-0.081516469691,-0.322084552991,0.523410602676,0.601761647213,-0.0965513019997,-1.00349505626,-0.138822231314,0.54653330751,-0.344469721924,0.261208596516,-0.16696523627,0.172975805164,0.000681780116114,-0.0152179225314,-0.230145680957,-0.143526785793,-0.102453940619,-0.0651162671177,0.232692741536,-0.255033022746,0.0785159328867,0.260690329798,0.0473114242142,0.0573102174142,-0.137188803622,0.109992004834,-0.0490440341699,-0.108275629322,-0.0341639539599,-0.065079834896,-0.0866892277474],[-36534.3422734,-1490.4992978,-1438.79482613,191.260517178,-2090.10789843,-25.0464232987,893.40705839,-287.524572098,-584.611742016,403.384533237,-1107.79005867,-521.289897088,292.928323348,621.994798858,276.319344858,-276.139380519,-37.7031636784,471.417681711,-322.275096181,-423.520651671,-86.9434043479,138.23248934,379.833753607,263.253358063,142.117773245,99.9059387782,19.1995629134,164.754025432,199.964686784,-52.7763196481,112.864249439,131.954255777,-74.6738773516,81.8528425405,81.9233620758,4.3597430479,-14.2833927808,-25.4347995182,61.4615082405,57.6811609687,20.7909894266,0.774668773699,-1.37012372977,-53.0468547305,25.0998802708,11.9421089316,-15.0585834808,34.9685990899,10.0887212298,-14.8337135853,-4.04037411204,18.8900183943,13.7592245094,-7.86046789987,-2.92998698832,-1.00043889966,-14.5239282695,8.35277666864,-8.81246308858,-5.28876769187,5.42335697359,-0.450752599385,-1.59879132402,2.46554363017,-2.24298013777,-7.13361204812,2.73355404565,0.0766209839122,-0.818770478069,-2.22887568,0.186167639678,2.16965305117,-0.513296211742,-3.54688607205,-0.944272408704,2.20489835341,-0.247264249422,-1.980089583,0.0168608208596,2.92182403725,-0.158380754772,-0.171347741302,-0.737218520769,-0.833797788046,-0.978199520392,-0.678650920301,-0.889630959972,-0.20219469543,0.486735926128,-0.0707739156283,-0.329366665436,0.499690665216,0.612633055073,-0.131807218232,-0.989634193348,-0.15793697227,0.537275178673,-0.340731813063,0.248081130819,-0.165928542167,0.157443266814,-0.00596053567349,-0.0143522758031,-0.229327339877,-0.142272856534,-0.100246906473,-0.0607856111355,0.238672846123,-0.247489261281,0.0728399308639,0.260061337527,0.0532381162141,0.0507486135745,-0.133341560539,0.102223758072,-0.0495621330188,-0.110531695831,-0.0406507860218,-0.066259245699,-0.0873873646842],[-36558.7563884,-1500.3676078,-1521.34479601,177.532093009,-2116.94631539,21.2831362658,916.896316523,-295.993113102,-599.30709735,405.595814121,-1133.91330331,-521.399239114,298.659316934,622.658563698,273.535335611,-268.674593143,-48.5224294398,468.984933108,-327.922869621,-426.935930097,-93.5422272659,145.388556504,378.838053872,266.947415389,142.437837481,103.475883036,16.3992713719,163.684376794,197.644331631,-53.3026741052,113.821204461,130.943814606,-72.2038083637,80.0245508801,81.9936931053,4.25345238194,-12.8490713962,-24.1528157553,61.4605612665,56.4893706057,20.434718421,0.519553374472,-1.97296192586,-52.9245336839,24.2834591209,13.0201967905,-15.5796553305,34.7969525091,9.8734383988,-14.3121054526,-3.73530962739,19.3025905419,13.766450939,-8.00304150512,-3.17166560364,-1.01523902819,-14.7120754545,8.05577897342,-8.46470886137,-5.6641524731,5.40895488428,-0.605638841057,-1.54848489845,2.36371164442,-2.21120568262,-7.06772916863,2.86833193993,0.10359720272,-0.77256749436,-2.2352544357,0.209175299556,2.08241480757,-0.540720084143,-3.47852644398,-1.08294378537,2.25606878953,-0.345463755798,-1.94908854001,0.00357992530058,2.8735582454,-0.157719203581,-0.214110372085,-0.736271729229,-0.795108396025,-0.942120915342,-0.687274975186,-0.884053963268,-0.187678385656,0.464968160769,-0.0598940457102,-0.337365660239,0.474752819819,0.621354126906,-0.167151297086,-0.976770545093,-0.175922024967,0.528474840127,-0.336387140996,0.234622965631,-0.164831846185,0.142293477284,-0.0125279245168,-0.0134555947841,-0.228126670064,-0.140911964463,-0.098773641952,-0.0557239252252,0.244274553206,-0.239714987717,0.0670172519539,0.258722284596,0.0589642490911,0.0439263726037,-0.130113133648,0.0949486331678,-0.0498661804507,-0.112644628904,-0.0472494416149,-0.0672537770565,-0.0877834318165],[-36577.2555113,-1509.70920058,-1603.87369134,161.449365402,-2141.29674874,67.8485633504,939.246994854,-303.147864572,-613.040048291,406.431431412,-1159.21760574,-520.751514458,303.193977478,623.397257766,270.65996055,-261.059084949,-59.624879269,466.141678771,-332.600093994,-429.950204428,-100.218825782,153.073113813,377.102715811,270.214283781,142.369990387,106.868100857,13.4135896122,162.76024531,195.36639045,-53.7951565344,114.789911472,129.520050535,-69.9937962493,77.9496621178,81.925467045,4.05157468893,-11.4710043282,-22.8698504618,61.4325631311,55.2726344392,20.0855686656,0.252762427497,-2.71567303547,-52.8733015929,23.4046972956,14.0646897067,-16.0182118539,34.5526765214,9.65087251021,-13.7976133376,-3.44039580682,19.6911941507,13.7419839404,-8.12494215835,-3.42217763968,-1.0620408374,-14.8976051901,7.74382637707,-8.12316947804,-6.01869195406,5.36292450458,-0.760104527585,-1.50260055313,2.26864951764,-2.17874984034,-6.99866827011,2.99219718771,0.120861075244,-0.719746809054,-2.2463055994,0.22806324305,1.99386865123,-0.568713876772,-3.41310477774,-1.22048272156,2.29750114626,-0.443393666705,-1.92113339199,-0.00774544953015,2.82369601836,-0.153726280254,-0.256073280333,-0.734576901004,-0.756949450438,-0.906350762214,-0.694704040219,-0.880857499142,-0.172249418494,0.442498942554,-0.0492376288425,-0.346180651282,0.448496318345,0.627578314429,-0.202657212964,-0.965147306332,-0.192839771978,0.520322383326,-0.331465622834,0.220874265386,-0.163638448084,0.127608567005,-0.0189500601141,-0.0125355782588,-0.226562220033,-0.13948751137,-0.0981261250619,-0.0499328350348,0.249419737128,-0.231788411311,0.0609892834345,0.256565728598,0.0643430657608,0.0367890430321,-0.12758426572,0.0881820309345,-0.0498917489078,-0.11463420911,-0.0540018098127,-0.0680533226631,-0.0879031827781],[-36588.7226938,-1519.11523201,-1686.20918865,142.355779443,-2162.94221623,114.700594817,960.446579883,-308.792898348,-625.770286152,406.123704876,-1183.54360106,-519.227631549,306.33550714,624.348425078,267.405141154,-253.407633791,-70.9420020739,462.825764148,-336.256014148,-432.635841648,-106.811849052,161.2613697,374.629989912,273.128838466,141.857664028,110.043914798,10.2572547895,161.991478625,193.139472953,-54.2157245899,115.788226367,127.688114025,-68.0505631109,75.6170942499,81.7151786161,3.73718793237,-10.1600632481,-21.590916793,61.3862827525,54.0451424443,19.7493575368,-0.022890469744,-3.60148022465,-52.8881746895,22.4523842499,15.0820998368,-16.369813414,34.2347876174,9.41693893714,-13.2924052679,-3.15710238128,20.0543866653,13.6868968855,-8.22664200229,-3.68313969728,-1.1440761845,-15.0777511481,7.41397396659,-7.78469407893,-6.35195329573,5.28414859658,-0.913293819511,-1.46270589617,2.18075618795,-2.14595382795,-6.9266068435,3.1042971047,0.128309581705,-0.661692318784,-2.26281847997,0.241380482472,1.90494425853,-0.59849087431,-3.35049488812,-1.35653388476,2.32820215485,-0.540685648925,-1.8965738363,-0.0173314738929,2.77259306035,-0.146160717145,-0.297134593429,-0.732216069267,-0.719562209397,-0.87115094314,-0.701063007536,-0.88034499535,-0.15622991634,0.419659646935,-0.0391785441125,-0.355903349186,0.420801637491,0.630993127188,-0.238441014923,-0.954954293518,-0.208738393086,0.513019575968,-0.32599633468,0.206872655014,-0.162309683387,0.113451376099,-0.0251749742122,-0.0115942925668,-0.224656570702,-0.138037111002,-0.0983781098768,-0.043430696265,0.254051909939,-0.223803470127,0.0547012402858,0.25349323776,0.0692365889341,0.0292924638001,-0.125808087859,0.0819363720465,-0.0495753918755,-0.116521771739,-0.0609442425992,-0.0686581863745,-0.0877675423289],[-36594.5793605,-1528.93795247,-1767.62942982,120.335235922,-2181.89249469,161.830004326,980.609755596,-313.331965438,-637.322562539,404.972879241,-1206.78055493,-517.028046651,308.015887528,625.546003071,263.717942523,-245.784660344,-82.4612749108,459.100668278,-339.041225004,-435.0767277,-113.206106115,170.006198388,371.48578293,275.72250407,140.877819709,112.980820573,6.96894255591,161.379817975,191.009230747,-54.5302103864,116.840711603,125.499414194,-66.3898024098,73.048568262,81.3674439354,3.29310842863,-8.91893069882,-20.3156875871,61.3339373042,52.82735545,19.4334603087,-0.304836169547,-4.62374548077,-52.9634622802,21.4254239084,16.0797672413,-16.6337061935,33.8495920423,9.16827268734,-12.7977012365,-2.88518698553,20.3942486883,13.6050797259,-8.31018360258,-3.95531043994,-1.26109465196,-15.2509599511,7.06467546843,-7.44645266465,-6.66385310644,5.17403462666,-1.06511262114,-1.42917592342,2.10011516211,-2.11335994759,-6.85277313011,3.20517805539,0.126093860076,-0.599547505484,-2.28516219909,0.247979711162,1.8176192205,-0.631530278321,-3.2902746905,-1.49067335663,2.34825971576,-0.637875739155,-1.8751815666,-0.0252219841116,2.7208940549,-0.134986078417,-0.337388980804,-0.729520744185,-0.68309614939,-0.836887462804,-0.706537980289,-0.88255686934,-0.140079733541,0.397004681017,-0.0301431113325,-0.366595851538,0.391474153325,0.631422306052,-0.27478825063,-0.946167809546,-0.2236092569,0.506814890727,-0.320004988595,0.192645601449,-0.160799030648,0.0998075834476,-0.0312241307422,-0.0106112742666,-0.222448432598,-0.136575224959,-0.0995304547466,-0.0363027848257,0.258201134531,-0.21591701745,0.0481136482975,0.249442422842,0.0735419605021,0.0214336354904,-0.124727284519,0.0762121566253,-0.0488575870129,-0.118334870971,-0.0680909435981,-0.0691103126903,-0.0873781197348],[-36596.8815291,-1539.46988597,-1847.27517303,95.6567495622,-2198.21405072,209.212574736,999.883005354,-317.318736644,-647.487894127,403.296180473,-1228.8298907,-514.433102984,308.19929511,626.998027537,259.604215661,-238.24199599,-94.1841718725,455.061278593,-341.156658996,-437.359628262,-119.297945976,179.379890548,367.751915691,278.01584257,139.415801048,115.660357182,3.59331318766,160.924977994,189.030575907,-54.7054146539,117.973606279,123.016924819,-65.0294504472,70.2740058871,80.8889094692,2.70208708231,-7.7482419415,-19.0425006024,61.288606024,51.6413019989,19.1456417299,-0.590566636652,-5.77336549651,-53.0932969401,20.325248813,17.0652389563,-16.8100578296,33.4052184797,8.90168867726,-12.3144842273,-2.62397923026,20.7137416118,13.5011265584,-8.37800213061,-4.23923404681,-1.41197525356,-15.415981459,6.69473426892,-7.10569545091,-6.95439535635,5.03462123733,-1.2156572727,-1.40208747767,2.02673108904,-2.08156077266,-6.77865805883,3.29573616652,0.114428587763,-0.534395747414,-2.31360083165,0.246789542717,1.7341331068,-0.669377769595,-3.23194812537,-1.62246007241,2.35803202171,-0.735726066567,-1.85658377564,-0.0314177330264,2.66931593042,-0.120217136185,-0.376980247396,-0.726884805176,-0.647677801502,-0.803952356528,-0.711330364386,-0.887467785984,-0.124293157433,0.37514420982,-0.0225707604965,-0.378312852665,0.360300466753,0.628723649715,-0.312026842405,-0.938710778926,-0.237429529237,0.501968476522,-0.313516455632,0.178218032127,-0.159058004185,0.0866435776244,-0.0371373516816,-0.00956042747184,-0.219980548651,-0.135110526802,-0.10156579409,-0.0286511066796,0.261919111505,-0.20830163537,0.0411908609619,0.244359905234,0.077165102151,0.0132198490955,-0.124256928486,0.0710069046543,-0.0476797930223,-0.120102615705,-0.0754505793435,-0.0694620562714,-0.0867316953874],[-36597.6852173,-1551.00355654,-1924.28717647,68.5893350832,-2211.97335092,256.824088907,1018.41281252,-321.306882763,-656.057297591,401.410834536,-1249.59303169,-511.723143769,306.849906356,628.712534266,255.069811572,-230.83147211,-106.112167052,450.802482529,-342.803248563,-439.571309018,-124.983717645,189.454736852,363.510209019,280.029415941,137.45695166,118.064063629,0.175026961028,160.626673314,187.258420513,-54.7081381224,119.213149492,120.303619681,-63.9874435242,67.3233288583,80.2862216835,1.94687479803,-6.64863223719,-17.7696935975,61.2633681493,50.5090106335,18.893666549,-0.877573835801,-7.04123696458,-53.2718112445,19.1532915055,18.046062018,-16.8990359597,32.9097956133,8.61400182333,-11.8437372242,-2.37280872619,21.0158268281,13.3796314794,-8.43253275775,-4.53545469707,-1.59559700308,-15.5715655318,6.30295375436,-6.7596726534,-7.22358401561,4.86794707107,-1.36502411444,-1.3815174017,1.96060861765,-2.05114887656,-6.70575255856,3.3768675648,0.0935284421725,-0.467320422834,-2.34839845251,0.236738590733,1.65672548712,-0.71357902892,-3.17501913325,-1.75145296732,2.35787726544,-0.834998760335,-1.84040765617,-0.0359194734771,2.6185756153,-0.101868662563,-0.416052198146,-0.724702131655,-0.613433696817,-0.772737659636,-0.715641565735,-0.895052410155,-0.10936447535,0.354688398364,-0.016900921598,-0.391109046893,0.327067178682,0.622754956875,-0.350484712568,-0.932506126163,-0.250176375914,0.498740482271,-0.306555606842,0.163614874483,-0.157038118312,0.0739257472014,-0.0429544590078,-0.00841565629612,-0.217295661788,-0.133651690091,-0.104466762325,-0.0205776677894,0.265257541462,-0.201129905976,0.0338972317711,0.238192306327,0.080011935567,0.00465839560852,-0.124312092549,0.0663181361169,-0.0459834686061,-0.121854114842,-0.0830318163692,-0.0697657717783,-0.085825049679],[-36599.0464426,-1563.83148819,-1997.80619834,39.4020072061,-2223.23686189,304.640329699,1036.34566044,-325.850074596,-662.821789609,399.634067398,-1268.97140124,-509.178512228,303.931897734,630.69755905,250.120581261,-223.604920086,-118.246734543,446.419167521,-344.18192614,-441.798535646,-130.159770127,200.30302797,358.842483738,281.783786159,134.986615163,120.173478914,-3.24125584771,160.48461857,185.747676641,-54.5051815221,120.585580342,117.422472558,-63.2817179418,64.2264589088,79.5660270443,1.01022248039,-5.62073684694,-16.4956043311,61.2713029178,49.4525098964,18.6852995148,-1.16334973173,-8.41825657766,-53.4931377683,17.9109845277,19.0297834629,-16.900808221,32.3714521268,8.30202704198,-11.3864432112,-2.13100508402,21.3034657294,13.2451885855,-8.47621065537,-4.84451656986,-1.81083891433,-15.7164620297,5.88813731109,-6.40563448784,-7.47142305438,4.67605077036,-1.5133094866,-1.36754253832,1.90175239688,-2.0227168327,-6.63554755819,3.44946837693,0.0636081007121,-0.399404910001,-2.38981913655,0.216755468806,1.58763593113,-0.765679737083,-3.11899165464,-1.87721097659,2.34815363969,-0.936455949634,-1.82628040093,-0.0387279583037,2.56939003794,-0.0799554296679,-0.454748637992,-0.723366603041,-0.58049036642,-0.743635407451,-0.719672990242,-0.905285406725,-0.0957879746282,0.336247411669,-0.0135730246309,-0.405039128549,0.291560890022,0.613374026229,-0.390489783438,-0.927476775765,-0.261826962749,0.497391056893,-0.299147313277,0.14886105595,-0.154690887345,0.0616204807512,-0.0487152746984,-0.007150864853,-0.214436514939,-0.132207388389,-0.108215993872,-0.0121844741176,0.268268125003,-0.194574411358,0.0261971142174,0.230886247514,0.0819883824364,-0.00424343397785,-0.124807849496,0.0621433709964,-0.0437100724669,-0.123618477283,-0.0908433212091,-0.070073813872,-0.0846549630013],[-36603.0027738,-1578.25970927,-2067.14801288,8.33233146282,-2232.07713861,352.558685357,1053.80343043,-331.303696023,-667.584300441,398.207358696,-1286.85901912,-507.044613985,299.381317942,632.963681338,244.768967133,-216.581706002,-130.579203779,442.00218307,-345.467781214,-444.130324586,-134.731812435,211.990895385,353.814111194,283.301800517,131.996060044,121.973900814,-6.61430268217,160.499880615,184.542007015,-54.0639970994,122.11349601,114.42706425,-62.9288405354,61.0123892551,78.7320943669,-0.122550307951,-4.66384861744,-15.2186244685,61.3249773442,48.4922474144,18.5277816135,-1.4455974749,-9.89609717026,-53.7533917494,16.6005646735,20.0223427887,-16.8164281541,31.7975289086,7.96304771038,-10.9433216257,-1.89820452494,21.5797382533,13.1026223934,-8.51106241143,-5.16667224862,-2.05659655866,-15.8497167578,5.44939559076,-6.04131533981,-7.6979311479,4.46070179969,-1.66037251358,-1.36017678858,1.85010512207,-1.99682569664,-6.56933314945,3.51436109379,0.025039783759,-0.33169884183,-2.43808016815,0.186010347391,1.52882725187,-0.826868087884,-3.06344605362,-1.99923080001,2.32919835723,-1.04067718782,-1.8138728583,-0.0398116785889,2.52238089512,-0.0545148463219,-0.493199713951,-0.7232172606,-0.548947087786,-0.716979421509,-0.723622358097,-0.918067130879,-0.0839781098896,0.32038748248,-0.0129452372859,-0.420148794776,0.253656031917,0.600482855407,-0.432309491931,-0.923557903528,-0.272355037965,0.498137516361,-0.291321694375,0.133983699827,-0.15197503054,0.04969068289,-0.0544490209988,-0.00574284181583,-0.21143742831,-0.130787269462,-0.112780007962,-0.00356290054485,0.271001754084,-0.188781127967,0.0180593800083,0.222413859627,0.0830192915843,-0.013481549084,-0.12567958619,0.0584837908795,-0.0408125588043,-0.125423333717,-0.0988869751531,-0.0704298608765,-0.0832223105355],[-36611.5179841,-1594.64826551,-2132.32845846,-24.5079233694,-2238.59108955,400.162965669,1070.80959555,-337.229983245,-670.195414694,397.069202756,-1303.12029094,-505.427104275,293.021704598,635.531655223,239.053777197,-209.651334753,-143.060325565,437.626226954,-346.732531478,-446.664695299,-138.642993601,224.559833815,348.424664822,284.615447559,128.500254279,123.4656622,-9.91659186557,160.678935184,183.64007695,-53.3546431669,123.804926017,111.33340363,-62.9399002768,57.7063990485,77.7766818626,-1.45584937207,-3.77189073802,-13.9373613028,61.4349095516,47.6423471515,18.4262587832,-1.72286495859,-11.4695361441,-54.0566190751,15.2274857435,21.0232493409,-16.6504929118,31.192215666,7.59622104863,-10.5140377187,-1.67526971203,21.8481985202,12.9576790993,-8.53748028008,-5.50100793389,-2.33183173775,-15.9715593022,4.9870683065,-5.66638627454,-7.90318579173,4.22259291152,-1.80512345643,-1.35918228655,1.80536167433,-1.97391045263,-6.5075960754,3.57207366284,-0.0211741164282,-0.265116869841,-2.49321166976,0.144639624366,1.48115523582,-0.896902327157,-3.00826838849,-2.11676019559,2.30126471107,-1.14751172497,-1.80303049922,-0.0390100783858,2.4777889573,-0.0256748681792,-0.531480941334,-0.724373793008,-0.518794123961,-0.692870668201,-0.727672646609,-0.933000699047,-0.0740300049027,0.307499114443,-0.0150506780425,-0.436447753981,0.213578356472,0.584160237776,-0.475969333334,-0.920733690391,-0.281720679419,0.50102584487,-0.283129863111,0.119018712862,-0.148878086914,0.0380853224101,-0.0601425212271,-0.00417991409705,-0.208299031218,-0.129404877907,-0.11806086308,0.00523820237609,0.273506086081,-0.183789609696,0.00947097371224,0.212849311268,0.0831052203913,-0.0230646607832,-0.126943945794,0.0553552237667,-0.0372898638076,-0.127290401992,-0.107137518514,-0.0708428857705,-0.0815443466183],[-36626.5373977,-1613.37070698,-2193.53838955,-59.038437702,-2242.88171156,446.958585808,1087.36302679,-342.992885546,-670.51763056,396.082347579,-1317.61221872,-504.396700735,284.648467545,638.424778455,233.020410864,-202.670845938,-155.630706043,433.361959017,-348.02205167,-449.501918003,-141.845822663,238.04517879,342.657268581,285.759001148,124.520090712,124.652854716,-13.124029441,161.029610231,183.029302406,-52.3478295538,125.664257966,108.148106594,-63.324616672,54.3328389236,76.6891700921,-2.99151185898,-2.93744398365,-12.6504760339,61.6111054404,46.9153521563,18.3853531995,-1.9939112618,-13.1341270427,-54.4088482956,13.7980057903,22.0304049264,-16.4084855499,30.5589143112,7.20117273754,-10.0979931945,-1.46336991885,22.1125191955,12.8163353194,-8.55544793206,-5.84631823048,-2.63552281088,-16.0825151941,4.50180243677,-5.28100252715,-8.08727918651,3.96214768031,-1.94623536034,-1.36425822458,1.7671549812,-1.95437456705,-6.45062224194,3.6230603957,-0.0738736646207,-0.200539900209,-2.5551969733,0.093021254469,1.44519891282,-0.97518321375,-2.95342114114,-2.22898468588,2.26458501424,-1.25662623536,-1.79364245023,-0.0361303399903,2.4357597633,0.00641391239845,-0.569654177532,-0.726901050789,-0.489994484383,-0.67135190013,-0.732003147372,-0.949614917971,-0.0659589507224,0.297928878927,-0.0198412030769,-0.45393671739,0.171641446029,0.564529165636,-0.521434317527,-0.91900056858,-0.289880547375,0.506059193669,-0.27462818085,0.104004197669,-0.145394800423,0.0267498841477,-0.0657719989693,-0.00245329316888,-0.205013530253,-0.128074732526,-0.123944502528,0.0141806151744,0.275827969724,-0.179612804801,0.00042335811298,0.202292280483,0.082265653377,-0.0330046805622,-0.128637885546,0.0527771592618,-0.0331524191637,-0.129239921741,-0.115562906361,-0.071313185196,-0.0796424203759],[-36650.0063387,-1634.80058374,-2250.96866056,-95.1788919465,-2245.05200147,492.450960948,1103.46259516,-347.956352207,-668.413446231,395.109541162,-1330.1918045,-504.024121004,274.057016631,641.666348785,226.714267542,-195.497279153,-168.23095136,429.280039103,-349.382216535,-452.742262916,-144.292808659,252.482265841,336.495046426,286.766735145,120.076462189,125.539570008,-16.2125214516,161.559733712,182.697099343,-51.0142660891,127.695879464,104.877789033,-64.092709227,50.9160595152,75.4589396159,-4.7313749157,-2.1530891293,-11.3566298617,61.8635709109,46.3238054771,18.4096870382,-2.25749546353,-14.8854234095,-54.8161079609,12.3183828664,23.0417113522,-16.0958891244,29.9010267561,6.77752845796,-9.69458975759,-1.26367441897,22.3763729451,12.68456767,-8.5649490381,-6.20139774319,-2.9666481373,-16.1831099647,3.99424496005,-4.88531933274,-8.25030353291,3.67978968051,-2.08238127053,-1.375103795,1.7351179702,-1.9386215063,-6.39869755498,3.66777560399,-0.13189892559,-0.138848839111,-2.62401941072,0.0315331924352,1.42153731271,-1.06111150651,-2.89886679345,-2.33508979345,2.21939157979,-1.36768739325,-1.7855978379,-0.0309796456982,2.39643885196,0.0416009030492,-0.607781279931,-0.730863884469,-0.462511178489,-0.652465869902,-0.736793151975,-0.967438594393,-0.0597802384037,0.292023347302,-0.0272686685656,-0.472616396227,0.128158882931,0.541712631288,-0.568669454394,-0.918354970323,-0.296791302097,0.513240714006,-0.265873008952,0.08897825686,-0.141519915023,0.0156298529389,-0.0713136778117,-0.000554190503564,-0.201573132011,-0.126811352121,-0.130316869605,0.0232261183792,0.278014253742,-0.176263661536,-0.0090920040057,0.190842445316,0.0805200750609,-0.0433135199076,-0.130798362685,0.0507690869687,-0.0284106565591,-0.131292132602,-0.124131093763,-0.0718410557952,-0.0775378809342],[-36683.8701313,-1659.31144586,-2304.81012593,-132.848966514,-2245.20495615,536.145506263,1119.10717167,-351.48433251,-663.745359898,394.013531506,-1340.71605034,-504.38008272,261.042761701,645.279663963,220.180746642,-187.987673997,-180.80166766,425.451127056,-350.858900811,-456.486000258,-145.936460625,267.906430497,329.921122314,287.672923412,115.190261557,126.129899722,-19.1579739404,162.27713358,182.630883724,-49.324662602,129.904178112,101.529066843,-65.2538974479,47.4804114579,74.0753709946,-6.67727568925,-1.41140694995,-10.0544839861,62.2023118634,45.8802501624,18.503882475,-2.51237664278,-16.7189787881,-55.2844266209,10.7948750246,24.0550704254,-15.7181866913,29.221954913,6.32491389069,-9.30322911235,-1.07735248595,22.6434324347,12.5683527672,-8.56596726892,-6.56504107684,-3.32418607628,-16.2738691453,3.4650428548,-4.47949192643,-8.39235103156,3.37594248658,-2.2122342322,-1.39141819015,1.70888356888,-1.92705473678,-6.35210792041,3.70667359933,-0.194089964107,-0.080924592719,-2.69966231397,-0.0394466069986,1.41074946535,-1.15408796427,-2.8445678273,-2.43426104086,2.16591672077,-1.4803618729,-1.77878578878,-0.0233651778055,2.35997176214,0.0797355114111,-0.64592410592,-0.736327144574,-0.436307215717,-0.63625533012,-0.742221952011,-0.986000535055,-0.0555091590016,0.290129090939,-0.0372849306849,-0.492487501716,0.0834442495205,0.515833627032,-0.617639753815,-0.918793327846,-0.302409603849,0.522573557131,-0.25692070878,0.0739789930464,-0.137248174671,0.00467071361987,-0.0767437813402,0.00152618242669,-0.197970043083,-0.125629255495,-0.137063907609,0.0323364925198,0.280111786866,-0.173755128155,-0.01908364986,0.178599483812,0.0778879699627,-0.0540030903059,-0.133462334448,0.0493504964912,-0.0230750076805,-0.133467274209,-0.132810035789,-0.07242679421,-0.0752520774191],[-36729.5537462,-1687.17224604,-2355.2942068,-171.948881573,-2243.47812633,577.653247165,1134.35935573,-353.067479203,-656.417808985,392.643574402,-1349.10182224,-505.489430776,245.449937764,649.305614419,213.469620527,-180.011793838,-193.294602463,421.931682876,-352.499935863,-460.821336716,-146.726371474,284.324258052,322.929216985,288.516963581,109.887683942,126.431250924,-21.939577047,163.182053032,182.811464139,-47.2533259282,132.286736802,98.1099956903,-66.8071982232,44.0476730347,72.5359564232,-8.82628347964,-0.704768024971,-8.74209693584,62.6343675124,45.5938343613,18.6715623214,-2.75946276145,-18.6292950657,-55.8157549898,9.2328055588,25.0708938835,-15.2806675567,28.5254170592,5.84351444631,-8.92284918901,-0.905395292522,22.9168370196,12.4729018541,-8.5587073293,-6.93644718577,-3.70662938673,-16.3546941586,2.91522076133,-4.06309101815,-8.5137313203,3.05141288561,-2.33494827339,-1.41302784207,1.6880207418,-1.91992595225,-6.31103951847,3.74019562521,-0.259165120711,-0.0276024758259,-2.78200848738,-0.119351102313,1.41317948264,-1.25339976798,-2.79037129582,-2.52586422845,2.10443212529,-1.5944410606,-1.7731082326,-0.0131642413284,2.32650423876,0.120609004349,-0.684152910312,-0.743358419159,-0.411312046081,-0.622637962219,-0.748454626894,-1.00483943712,-0.0531242286186,0.292462219475,-0.0497435676211,-0.513520265142,0.0377975938335,0.487022465496,-0.668352892717,-0.92029766507,-0.306726774528,0.534050135788,-0.247820086068,0.0590335050476,-0.132598284128,-0.00619102206287,-0.0820538859526,0.00379232497306,-0.194191101429,-0.124533286457,-0.144063497149,0.041481699387,0.282153247459,-0.172063681588,-0.0295558100572,0.16566442999,0.0743926260953,-0.0650993152529,-0.136641393842,0.0485218512512,-0.0171585217785,-0.135782219671,-0.141578409699,-0.0730704117,-0.0728110295214],[-36786.4007399,-1718.23354747,-2402.81459104,-212.301016315,-2240.14727834,617.007650023,1149.53666047,-352.703258904,-646.502987849,390.794956812,-1355.50544211,-507.193519088,227.318080488,653.855461298,206.648153372,-171.490297126,-205.706068795,418.721367179,-354.360979538,-465.788224858,-146.600469614,301.627332861,315.555438302,289.358748373,104.216133593,126.464292378,-24.5496572968,164.244396224,183.193219698,-44.7889509301,134.813919568,94.6343903436,-68.7088179719,40.629333121,70.8706346346,-11.1563961988,-0.0247021513429,-7.41511655494,63.1549103303,45.460126626,18.9123519319,-3.00825731304,-20.6066675042,-56.3957324384,7.63375872991,26.0996331871,-14.7878460271,27.8163969343,5.3357544543,-8.55053282121,-0.748081608114,23.1975928142,12.4003646808,-8.54425806016,-7.31643242241,-4.11052842615,-16.4229899936,2.34731396724,-3.6333492171,-8.61562378574,2.70854051517,-2.45160135345,-1.44026814154,1.67184260169,-1.91687975593,-6.27527962674,3.76873065266,-0.32535583902,0.0204645623124,-2.87053862488,-0.206856904857,1.42823180482,-1.3578797869,-2.73566253715,-2.60998626771,2.03536698181,-1.71021519075,-1.7685183117,-0.00053463216483,2.29618285116,0.163780085633,-0.722571537612,-0.752036246404,-0.387320881901,-0.611031162951,-0.755599407322,-1.02353355943,-0.0524568635465,0.298716995617,-0.0641050456003,-0.535562998032,-0.00853517332126,0.45543874061,-0.720987216203,-0.922792372695,-0.309872782571,0.547619908702,-0.238589724037,0.0441248765094,-0.127684791369,-0.0170547347211,-0.0872969792932,0.00623157978036,-0.190201670478,-0.123489588841,-0.151161268057,0.050664425819,0.28411463241,-0.171019913467,-0.0404954887681,0.152143741771,0.0700725454455,-0.0766841662805,-0.140245676947,0.0482075099431,-0.0106847183594,-0.138240375989,-0.150457781524,-0.0737707779945,-0.0702594391911],[-36853.2343152,-1752.24131597,-2447.80553322,-253.708289686,-2235.52273241,654.347791445,1165.02032744,-350.515841693,-634.115030074,388.249473491,-1360.14309583,-509.287828828,206.735550703,659.058058421,199.787982304,-162.356566083,-218.04352106,415.805640735,-356.499646305,-471.414553722,-145.493767325,319.678489043,307.846490911,290.263294283,98.2283170405,126.253008268,-26.9838253116,165.426482552,183.723922144,-41.9238294769,137.449285728,91.1175053442,-70.9042604955,37.2343082404,69.1174559961,-13.6408439116,0.637471069549,-6.06858801612,63.7561461035,45.4713006095,19.2248772969,-3.27041267396,-22.6403397093,-57.0059205014,5.99838404023,27.1542497269,-14.2440426595,27.1001946433,4.80461797391,-8.18289906842,-0.605512101326,23.4861726224,12.3521256243,-8.52392933647,-7.70621748872,-4.53194795166,-16.475537531,1.76423542196,-3.18691460729,-8.69942525165,2.35004822548,-2.56375241454,-1.47360171906,1.6595982983,-1.9174089784,-6.24451579715,3.79265458455,-0.390771838417,0.0626691638232,-2.96463289279,-0.300451539198,1.45507595419,-1.46624731237,-2.67971146065,-2.68689434789,1.95918985385,-1.82809920975,-1.76498197158,0.0142957310666,2.2691543748,0.208749318259,-0.761292229749,-0.762441902017,-0.364095376073,-0.600727257898,-0.763750311817,-1.04167105126,-0.0533017051247,0.308457220341,-0.0797315528583,-0.558433531977,-0.055321675442,0.421249366636,-0.775763736422,-0.926187433113,-0.312012258047,0.563221596089,-0.229240650282,0.0292251872844,-0.122646205176,-0.0280287780563,-0.0925414018176,0.00882700031681,-0.185961745026,-0.122454631486,-0.158194787474,0.0598955399155,0.285957768243,-0.170417944102,-0.0518853835547,0.138145233048,0.0649700334936,-0.0888536269299,-0.144159955614,0.0483128050793,-0.00367973449304,-0.140841783635,-0.159480439484,-0.0745264774399,-0.0676466789429],[-36928.8776752,-1788.94151736,-2490.70128792,-295.973620635,-2229.91480876,689.81274804,1181.1915982,-346.629397653,-619.368069248,384.788919195,-1363.23096927,-511.567841165,183.790709241,665.042259612,192.960744451,-152.543982928,-230.314413658,413.169964315,-358.973550632,-477.728212344,-143.341276889,338.340560716,299.849079456,291.295617802,91.9769408141,125.82138278,-29.2376917132,166.690631415,184.351343216,-38.6502534377,140.156394602,87.574595234,-73.3390295954,33.8715149165,67.3144708749,-16.2528566829,1.29043203632,-4.69755649216,64.4302806188,45.6195299647,19.6077644068,-3.5575812206,-24.7195552868,-57.6278807138,4.32733099215,28.247704894,-13.6535780105,26.3821102909,4.25308906435,-7.81656699013,-0.477787440759,23.7830492481,12.3295690613,-8.4990310332,-8.10702308667,-4.96695272042,-16.5091176513,1.1688980749,-2.72043527275,-8.76653254182,1.97865886674,-2.67296039886,-1.5134912051,1.6505369814,-1.92100645024,-6.21843558159,3.81234332379,-0.453522838287,0.0984039708337,-3.06367145744,-0.398622529902,1.49288145304,-1.57722163577,-2.6217879757,-2.75685565825,1.87636930492,-1.94850806401,-1.76246515777,0.0310989297477,2.24556558511,0.255017265224,-0.800427228652,-0.774656661708,-0.341397181495,-0.591018572643,-0.7730013589,-1.05884006187,-0.0554533946923,0.321246694623,-0.0959852776311,-0.581949698564,-0.102329536027,0.384621257832,-0.832903465523,-0.930392828718,-0.313309831024,0.580793918171,-0.219783892394,0.0143065172249,-0.11762103433,-0.0392215057699,-0.0978554939815,0.0115616400506,-0.181431319866,-0.121384883231,-0.165001622541,0.0691859097765,0.287644481481,-0.170051893799,-0.0637081919789,0.123776717716,0.0591273957198,-0.101703680742,-0.148269001689,0.0487430691722,0.00383029275045,-0.143586483083,-0.168678671801,-0.075336094383,-0.0650221212914],[-37012.1540228,-1828.08011748,-2531.93610971,-338.899928109,-2223.63382762,723.541596416,1198.43171428,-341.168096867,-602.376238959,380.195088678,-1364.98524832,-513.829037273,158.571916933,671.936918693,186.23807694,-141.985929884,-242.526200993,410.799798689,-361.84030699,-484.757089762,-140.07801059,357.476381998,291.609908583,292.520735426,85.5147114441,125.193400098,-31.3068671236,167.999162208,185.023254656,-34.9605146815,142.89880551,84.020914555,-75.9586290733,30.549869673,65.4997296385,-18.9656645777,1.94286114759,-3.29706715582,65.1695196626,45.8969883446,20.0596392517,-3.88141532939,-26.8335578422,-58.2431746104,2.621249088,29.3929600793,-13.0207726371,25.6674439823,3.68415178486,-7.44815564579,-0.365008295012,24.0886954953,12.3340793689,-8.47087302532,-8.52006991822,-5.41160748956,-16.5205112351,0.564214875517,-2.23055929747,-8.81834248004,1.59709528916,-2.78078424857,-1.56039923016,1.64390780073,-1.92716500203,-6.196726532,3.82817277328,-0.511718558016,0.127061625471,-3.16703448513,-0.499857401534,1.54081782368,-1.68952204842,-2.56116199169,-2.82013738805,1.78737389857,-2.07185669996,-1.76093381576,0.0496470452598,2.22556325753,0.302084489524,-0.840088776252,-0.788761801186,-0.318987951063,-0.581197432768,-0.783446567091,-1.07462874052,-0.0587065735886,0.336649219438,-0.112228408154,-0.605929329382,-0.149326378574,0.345721328457,-0.892627415653,-0.935318541901,-0.313930131572,0.600275595164,-0.210230477968,-0.000659053816433,-0.112747787611,-0.0507412715632,-0.103307596241,0.0144185524501,-0.176570389795,-0.120236812917,-0.171419340399,0.0785464035017,0.289136598646,-0.169715882866,-0.0759466116025,0.109146009669,0.0525869376043,-0.115330311258,-0.152457587024,0.0494036347343,0.011819226301,-0.146474514807,-0.178084766696,-0.0761982131703,-0.0624351387515],[-37101.6940311,-1869.40196105,-2571.88857912,-382.195576406,-2216.81869888,755.631766839,1216.97392867,-334.25448289,-583.292722661,374.308803187,-1365.57106236,-515.909625723,131.222260025,679.824260627,179.673662117,-130.646122775,-254.693578577,408.673914986,-365.134097341,-492.50462491,-135.666351237,376.952938865,283.162202406,293.968326359,78.8892832388,124.389055173,-33.1905519659,169.3148494,185.69334848,-30.8541485287,145.642026888,80.4667722716,-78.7161709557,27.2767795659,63.7099321008,-21.7535133333,2.60033264155,-1.86324022854,65.9654210049,46.2935341535,20.5770852151,-4.25234753217,-28.9717657949,-58.8369491883,0.88037699791,30.6005944696,-12.3499807852,24.9606629149,3.10083109906,-7.07474845652,-0.267046304981,24.4030306487,12.3663408603,-8.4411301975,-8.94686324901,-5.86170151957,-16.507159502,-0.0477872313622,-1.71488698304,-8.85609325385,1.20787123193,-2.88853791003,-1.61477571103,1.63886867508,-1.93532618482,-6.17895199275,3.84046658629,-0.563804506356,0.148102255531,-3.2742081002,-0.602665945745,1.59786910008,-1.80215023497,-2.49735461136,-2.87707853079,1.69263356101,-2.19838174551,-1.76047671066,0.0697201586768,2.20917214591,0.349441781491,-0.88031904681,-0.80475841603,-0.296635136564,-0.570599604249,-0.795173765363,-1.08869718589,-0.0628398181284,0.354183944023,-0.12791768935,-0.630238787334,-0.196098977619,0.304691735451,-0.955029485942,-0.940910378494,-0.314020648457,0.62154541615,-0.200592610333,-0.0156743131384,-0.108157283563,-0.0626689097527,-0.108954637629,0.0173985743876,-0.171336779703,-0.118962224492,-0.177300875794,0.0879829685458,0.290391116971,-0.169212934219,-0.0885945048211,0.0943505726863,0.0453905106612,-0.129792258006,-0.156636095219,0.0502053745188,0.0202450374713,-0.149503681301,-0.187713444861,-0.0771104728303,-0.0599318603991],[-37195.3582544,-1912.64740849,-2610.71458051,-425.190711223,-2208.9226911,786.014104208,1236.45954002,-326.00459318,-562.426903284,367.206989933,-1364.9493147,-517.818724692,102.103726424,688.599994937,173.249363209,-118.609611842,-266.86020636,406.744325767,-368.795373633,-500.876456302,-130.178163754,396.653824712,274.485262909,295.526720655,72.128101621,123.412386015,-34.9023058688,170.602287749,186.338997802,-26.3596641049,148.35936364,76.9026950386,-81.5952001692,24.0536137809,61.9763758638,-24.5947113769,3.25599611473,-0.396496126501,66.8069503493,46.7897648012,21.1485152519,-4.67593098258,-31.124296819,-59.4086932945,-0.896689937036,31.8716584347,-11.6456914573,24.2629026576,2.50631558809,-6.69528628997,-0.182857000741,24.723759916,12.4242375943,-8.41293747318,-9.39004659935,-6.31192208438,-16.4691450273,-0.66862531923,-1.17482750129,-8.88038850585,0.812663990104,-2.99655534625,-1.67701970979,1.63421259927,-1.94472643142,-6.16417847811,3.84933941775,-0.609569349533,0.161255931476,-3.385102259,-0.705647022508,1.66227736292,-1.9152374531,-2.43089171091,-2.92830529693,1.59242366931,-2.32760655469,-1.76167388603,0.0911303498415,2.19592891767,0.396540840798,-0.92087994392,-0.8223268813,-0.274129385343,-0.558734614636,-0.80824602448,-1.1009932943,-0.067567444528,0.37319141066,-0.142888092885,-0.654938560573,-0.242510711851,0.261575606481,-1.01969512343,-0.947257438066,-0.31366030523,0.644242445658,-0.190887195756,-0.0306415166448,-0.10394957978,-0.0749751771147,-0.11480790149,0.0205736763533,-0.165679634864,-0.117494262339,-0.182560633892,0.097481869783,0.291345716522,-0.1683816812,-0.101690393365,0.0794464700807,0.03757815054,-0.144999284459,-0.160817356894,0.0510813222424,0.0290021311045,-0.152662833144,-0.197509156863,-0.0780667311193,-0.0575454415547],[-37290.8147172,-1957.55569912,-2648.51432422,-467.12092361,-2199.2276625,814.577807082,1256.3818584,-316.532838665,-540.127213625,359.025602619,-1363.02985218,-519.608179761,71.6330294541,698.113202289,166.929088659,-105.991780934,-279.076985404,404.956353951,-372.741155305,-509.753772348,-123.712683597,416.466784792,265.544911548,297.048911081,65.2535597916,122.263441401,-36.4592782625,171.826527084,186.943496009,-21.5128139869,151.026069788,73.3142639335,-84.5868698658,20.8802320362,60.3290079758,-27.4685828084,3.89989500323,1.10166968547,67.682425383,47.3639624488,21.7602997104,-5.15649898972,-33.2814434024,-59.9614812382,-2.711767208,33.2048201402,-10.9124273453,23.5744658716,1.90383473751,-6.30917437542,-0.111166884662,25.0480349856,12.5049535658,-8.38979478552,-9.85254805321,-6.75668096126,-16.4072107253,-1.30070246617,-0.612742241644,-8.89167324241,0.412941747737,-3.10492552442,-1.74751757485,1.62864133713,-1.95455089511,-6.15134829481,3.85485367294,-0.649137543141,0.166320209439,-3.49973287587,-0.807421758883,1.73209920455,-2.02919735378,-2.3625503599,-2.97451570117,1.48698096321,-2.45887616302,-1.76522820499,0.113697698289,2.18524821865,0.442823594451,-0.961463303511,-0.841067391925,-0.251267143637,-0.545155431871,-0.822720225659,-1.11153691147,-0.0725877039792,0.392967509894,-0.157069147112,-0.680137668566,-0.288444110997,0.216391311894,-1.08608266214,-0.954484643626,-0.312910884139,0.667945817079,-0.181132316243,-0.0454377873904,-0.100217043621,-0.0876033110405,-0.120867259745,0.0240336122413,-0.159545930647,-0.115761405951,-0.187128387463,0.107024451442,0.291933248077,-0.167069659759,-0.115283963798,0.0644794150502,0.0291894389239,-0.160823910078,-0.165039814421,0.0519700518626,0.0379690204265,-0.155938582939,-0.20739878574,-0.0790599004755,-0.0553057941003],[-37385.7314442,-2003.86607226,-2685.38802057,-507.221804613,-2187.01547131,841.212074019,1276.2341939,-305.953630277,-516.742086484,349.900594949,-1359.72252162,-521.329836508,40.2268824371,708.212963347,160.676746913,-92.9080138941,-291.394816769,403.255322457,-376.8884618,-519.017761461,-116.369146217,436.279564356,256.306969776,298.387890403,58.2880509519,120.942270107,-37.878618577,172.952617232,187.49013649,-16.3493507515,153.617399352,69.6870600338,-87.6823331972,17.7564940499,58.7977754855,-30.3544517273,4.52207274314,2.62976174252,68.5801637929,47.9944092576,22.3988089384,-5.69838486269,-35.4334980327,-60.4983873286,-4.56667030613,34.5987477516,-10.154711141,22.8956552184,1.29661803286,-5.91581794214,-0.0507024591136,25.373007546,12.60567277,-8.37520206768,-10.3372956946,-7.1903899275,-16.3220995104,-1.94642175026,-0.0309925934919,-8.89039246989,0.0101726888704,-3.21373741173,-1.82665565459,1.62085665252,-1.96398472918,-6.13940374957,3.85707175718,-0.682633542772,0.163092645552,-3.61811586517,-0.906611281926,1.80539121731,-2.14444358798,-2.2931076279,-3.01640775824,1.37654218247,-2.59153560603,-1.77184253072,0.137242283554,2.17654469467,0.487731969459,-1.00176096151,-0.860580142834,-0.227844857681,-0.529415023897,-0.838653250115,-1.12034788314,-0.0775988476739,0.412808132268,-0.170390380382,-0.705945130782,-0.333781704784,0.169157222038,-1.15365043609,-0.962716918182,-0.31183416743,0.692234663805,-0.171346053795,-0.0599402484304,-0.0970520424425,-0.100496548922,-0.127132584317,0.0278681359458,-0.15288264242,-0.113692134818,-0.19093390928,0.116592057753,0.292086562412,-0.165124405845,-0.129424902685,0.0494951207923,0.0202639574962,-0.177138654324,-0.169341910171,0.0528101373368,0.0470242186632,-0.159317543285,-0.217309214529,-0.0800828933368,-0.0532428299177],[-37477.7764597,-2051.31776724,-2721.43587989,-544.72894528,-2171.56797576,865.806103577,1295.5098566,-294.381378945,-492.619954656,339.967920625,-1354.93716984,-523.035540511,8.30199869604,718.748358773,154.456246414,-79.4736945706,-303.864601517,401.586554204,-381.154312558,-528.549612049,-108.24678707,455.979908655,246.737259047,299.396651387,51.2539683028,119.448920907,-39.1774762425,173.945608023,187.962212634,-10.9050269754,156.108606355,66.006664417,-90.8727433152,14.6822595402,57.4126254413,-33.2316422334,5.11257277058,4.18628457982,69.488483266,48.6593873885,23.0504132842,-6.30592191057,-37.5707531979,-61.0224858749,-6.4632147226,36.0521094347,-9.37706553616,22.2267733593,0.687894959679,-5.51462221942,-0.000190226466286,25.6958292856,12.723579202,-8.37265925281,-10.8472176074,-7.60746076037,-16.2145542968,-2.60818624958,0.568060053758,-8.87699119465,-0.394175002454,-3.32307997536,-1.91482029741,1.60956030926,-1.9722130869,-6.12728714911,3.85605607578,-0.71018180402,0.151370795945,-3.74026714123,-1.0018367187,1.88020999356,-2.26138980666,-2.22334058449,-3.05467948282,1.26134406686,-2.72492991925,-1.78221972634,0.161584185173,2.16923299157,0.530707892829,-1.04146475384,-0.880465328957,-0.203658973712,-0.511066358658,-0.856101979066,-1.12744605501,-0.0822991268039,0.432009168326,-0.182781321049,-0.732469966687,-0.378406022937,0.11989170726,-1.22185677931,-0.972079184741,-0.310491937352,0.716688119226,-0.161546490419,-0.0740260228195,-0.094546943603,-0.113598128149,-0.133603747126,0.0321670013612,-0.145636745552,-0.111214928433,-0.193906972113,0.126166032944,0.291738510303,-0.162393455408,-0.144162896589,0.0345393005047,0.01084128794,-0.193816036657,-0.173762086518,0.0535401526226,0.0560462390404,-0.162786326785,-0.227167326267,-0.0811286221416,-0.0513864608887],[-37564.9671735,-2099.61393545,-2756.68372349,-579.145663947,-2152.43780527,888.35478113,1313.63902991,-281.99978124,-468.143546912,329.311217041,-1348.59218753,-524.741191856,-23.7374789464,729.563115524,148.248568433,-65.7990066457,-316.52740077,399.900555963,-385.438192118,-538.246086235,-99.4508467395,475.443041158,236.816396161,299.930146051,44.1856272098,117.789083629,-40.3747707629,174.78491263,188.338208057,-5.21948579928,158.47061286,62.2595706243,-94.1476773882,11.6540951897,56.1972920346,-36.0773763262,5.66381203017,5.76768826717,70.3973963256,49.3370908994,23.7032728049,-6.98426534197,-39.6849833814,-61.5359376404,-8.40363845084,37.5602289874,-8.58525438532,21.5673357571,0.0810078486335,-5.10520777253,0.0418313097215,26.0137383019,12.8557461296,-8.38439896429,-11.384672248,-8.00302125886,-16.0862766732,-3.28795819919,1.18136028379,-8.85261826483,-0.798571331536,-3.43247134174,-2.01207659994,1.59351797284,-1.97849758731,-6.11398429935,3.85199732904,-0.731655600609,0.1312846169,-3.86606157023,-1.09178852132,1.95448839252,-2.38044929965,-2.15390569311,-3.09019235661,1.14172772348,-2.85825372287,-1.79702364345,0.186527813429,2.16265863475,0.571168334018,-1.08031423194,-0.9003321385,-0.178540942979,-0.489656392874,-0.875067793876,-1.13284062731,-0.0863932003455,0.44986984228,-0.194157134803,-0.7597647752,-0.422223135105,0.0686856655695,-1.29014069892,-0.982733003197,-0.308943469231,0.74085291185,-0.151741326026,-0.0876027794453,-0.092789682872,-0.126872407418,-0.140272628505,0.0369988282098,-0.137764805565,-0.108282592444,-0.195969492597,0.135732703419,0.290831713992,-0.158737178362,-0.15952323624,0.019675533292,0.000979105032077,-0.210719872526,-0.178354482097,0.0540970634757,0.0648950077542,-0.166329968905,-0.236907378091,-0.0821798555312,-0.0497565729548],[-37646.7185358,-2148.31337666,-2790.85981661,-611.046188093,-2130.26067406,909.275739314,1329.79939067,-269.269676295,-443.832775899,317.804856356,-1340.6401409,-526.31890865,-55.5376896681,740.479545711,142.102985547,-51.9733331485,-329.384915905,398.168569911,-389.569445408,-548.066240978,-90.1105863394,494.494098192,226.584179304,299.851163413,37.1650316951,115.991012303,-41.4965019377,175.507397607,188.577367295,0.652067381544,160.657013101,58.4359220526,-97.4904086506,8.65539553907,55.1506580266,-38.860467604,6.17770150062,7.36220501308,71.3036948392,50.005361434,24.3527063948,-7.74185796359,-41.7738910499,-62.0372492034,-10.3918694933,39.1050527374,-7.79000619444,20.9137090805,-0.520249589115,-4.68805651076,0.0775756411382,26.3243183295,12.9988039127,-8.40758458641,-11.9497395618,-8.37506330879,-15.9428029258,-3.98593646208,1.80307657265,-8.82123789569,-1.20123906106,-3.53914627424,-2.11720465172,1.57175091524,-1.98240571251,-6.09865500284,3.84559939735,-0.745923478775,0.104293665283,-3.99480982557,-1.17543444224,2.02566434102,-2.50203391218,-2.08497699283,-3.12446172928,1.01845172885,-2.99009997572,-1.81676208746,0.21181490161,2.15589066794,0.608430432276,-1.11823980922,-0.919825732782,-0.152462236786,-0.46470803837,-0.895330076512,-1.1364982181,-0.0896113584135,0.465702713008,-0.204375536687,-0.787656473041,-0.465233270609,0.0159201056272,-1.35786389443,-0.994986480987,-0.307238010709,0.764146150652,-0.141896732171,-0.100700370524,-0.0918504696678,-0.140368230636,-0.147099142422,0.0423476995261,-0.12926174859,-0.104945237124,-0.197011962811,0.145298324281,0.289347881588,-0.154067280477,-0.175433629031,0.00503886188811,-0.00919254407801,-0.227679161327,-0.183236020598,0.0544114028449,0.0733561028814,-0.169927196579,-0.246493123538,-0.0831787869603,-0.0483329482966],[-37722.7948822,-2196.93880272,-2823.61803547,-641.272472483,-2105.94306757,929.092297584,1343.10548903,-256.721188882,-420.241850237,305.270894415,-1331.04213999,-527.604863508,-86.7573431471,751.314607737,136.085843159,-38.0808569445,-342.42900836,396.367022078,-393.359882454,-557.984706948,-80.3612721141,512.9456943,216.095202004,299.024451742,30.2861079453,114.08860201,-42.5704396405,176.16429285,188.634125111,6.65053660789,162.617069356,54.5267745625,-100.882634353,5.66626209343,54.2653933214,-41.5476275649,6.65852566918,8.95601256069,72.2058655109,50.6419525328,24.9958226572,-8.58796448163,-43.8366606656,-62.5240135965,-12.4322583548,40.6651826449,-7.0032906323,20.2614727992,-1.11197079728,-4.26386567938,0.109444258284,26.625239512,13.1492721836,-8.4381121937,-12.5419298666,-8.72229481768,-15.790628015,-4.70187905823,2.42668336947,-8.78751814425,-1.60033914304,-3.63976869545,-2.22866329049,1.54334431009,-1.98358141036,-6.08050256133,3.83769445608,-0.751602802888,0.0721898981108,-4.12568153246,-1.25181155894,2.09105203274,-2.62655512838,-2.01660791657,-3.15916641744,0.89237902683,-3.11891122127,-1.8419038522,0.237171513752,2.14792901445,0.641786369305,-1.15521961461,-0.9386002664,-0.125429331448,-0.435738195753,-0.916612709093,-1.13837479997,-0.0916902989069,0.478823673056,-0.213279879083,-0.81591555638,-0.507460198693,-0.0379514362448,-1.42436873849,-1.00918436244,-0.305422302509,0.785952539722,-0.131968498317,-0.113379194106,-0.0917950818208,-0.154155563017,-0.154035211255,0.0481765641729,-0.120132090913,-0.1012772989,-0.1969170187,0.154874132808,0.287278492664,-0.148308301487,-0.191797386518,-0.00921780506596,-0.0195255191472,-0.244514198445,-0.188539321976,0.0544120954773,0.081196515469,-0.173555159607,-0.255895690241,-0.0840574660871,-0.0470853431539],[-37792.9605481,-2245.01292547,-2854.6122563,-670.666471883,-2080.39147122,948.327775392,1352.67187515,-244.884443774,-397.924978544,291.531387069,-1319.75929488,-528.435229043,-117.055149062,761.885260006,130.263486672,-24.2057608994,-355.651539573,394.472338492,-396.621313279,-567.976114815,-70.3381703083,530.610444027,205.404057794,297.314759308,23.6427821468,112.115747833,-43.6243537444,176.806828257,188.462916267,12.7168259206,164.300043902,50.5231840144,-104.306051748,2.66679635786,53.5341678231,-44.1055677071,7.11056902309,10.5352886532,73.1023950445,51.2246177362,25.6297301954,-9.53184960229,-45.8724766909,-62.993823852,-14.52915554,42.2192206699,-6.23707736763,19.6062063833,-1.69024921958,-3.83333252368,0.139838651658,26.9141719931,13.303670575,-8.47187786069,-13.1607534801,-9.04342369306,-15.6362469014,-5.43554400758,3.04565512339,-8.75612706753,-1.99403252952,-3.73100252797,-2.34491135404,1.50738333102,-1.98166862874,-6.05873027654,3.82911468063,-0.747310937313,0.0367652724001,-4.25784631614,-1.31995694893,2.14796566138,-2.75442443234,-1.94885189729,-3.19598523775,0.76437256129,-3.24313000301,-1.87291773153,0.262323713893,2.13777359758,0.670528326803,-1.19123177704,-0.956309893948,-0.0974487032831,-0.402263765626,-0.938639573737,-1.13842634547,-0.092366719725,0.48854861497,-0.220713514373,-0.84431252139,-0.5489276886,-0.0924754237243,-1.48899760371,-1.02567139187,-0.303543085353,0.805656783152,-0.121912413925,-0.125699648239,-0.0926892971612,-0.168304369771,-0.161032757385,0.054448371013,-0.110380348817,-0.0973532142011,-0.195567296205,0.164471366277,0.284615026794,-0.141384781124,-0.20851782026,-0.0229415589292,-0.0298716799327,-0.261045279264,-0.194397006184,0.05402806612,0.088183236564,-0.177191007789,-0.265086205835,-0.0847479425695,-0.045983513767],[-37856.979869,-2292.05845675,-2883.49635533,-700.070141061,-2054.51237045,967.505492191,1357.6130992,-234.289565745,-377.436369439,276.408390165,-1306.75271563,-528.646177868,-146.089817089,772.008460921,124.702261488,-10.4322278788,-369.044370983,392.460945184,-399.16554791,-578.01509525,-60.1765471664,547.300961916,194.565340204,294.58683438,17.3289804863,110.106344853,-44.6860141231,177.486233726,188.018175526,18.7918393605,165.655199016,46.4162062692,-107.742358085,-0.362900162514,52.9496514356,-46.5009995287,7.53811604959,12.0862110336,73.9917701438,51.7311105845,26.251537613,-10.5827780318,-47.8805235882,-63.4442730023,-16.6869115536,43.7457687726,-5.5033360692,18.9434893027,-2.25117829973,-3.39715428895,0.171160311762,27.1887859163,13.4585187193,-8.50477766191,-13.80572072,-9.33715784246,-15.4861545456,-6.18668933011,3.65346628353,-8.73173272257,-2.38048017251,-3.8095116944,-2.46440768011,1.46295315164,-1.9763113155,-6.03254145023,3.82069224638,-0.731665246418,-0.000188254833419,-4.39047380181,-1.37890768971,2.19371942064,-2.88605330818,-1.88176236791,-3.23659700685,0.635295276097,-3.36119886444,-1.91027251929,0.286997566069,2.12442434065,0.693948486471,-1.22625442543,-0.972608770024,-0.0685268286076,-0.363801648593,-0.961134552559,-1.13660882717,-0.0913773187671,0.494193431295,-0.226519794938,-0.872617864242,-0.589659509572,-0.147198320489,-1.55109286272,-1.04479231361,-0.301647099961,0.822643585034,-0.11168426846,-0.137722130973,-0.0945988935194,-0.182884616112,-0.168043703189,0.061126068909,-0.100011038589,-0.0932474194555,-0.192845431271,0.174101261966,0.281348963553,-0.133221259124,-0.225498241814,-0.0359794910607,-0.0400828861912,-0.27709269917,-0.200941693178,0.05318823952,0.0940832572133,-0.180811890925,-0.274035797956,-0.0851822660656,-0.044997216376],[-37914.6971824,-2337.82344399,-2909.90381808,-730.113319829,-2029.15948578,987.018816433,1357.27028418,-225.360277156,-359.316906077,259.756882773,-1292.06960929,-528.073960121,-173.536407565,781.539040985,119.460475383,3.16166341954,-382.575161254,390.312274311,-400.822732086,-588.063232952,-50.0001886445,562.844089376,183.62872373,290.7291964,11.4302295362,108.098025738,-45.7805966177,178.248356745,187.259595879,24.8189966483,166.638597576,42.1982702074,-111.165191026,-3.4374725908,52.499986306,-48.7036899514,7.94678804597,13.5975297185,74.8721305753,52.141645896,26.8588202395,-11.7471723307,-49.85853456,-63.8713495382,-18.9078380286,45.2230535421,-4.81321112515,18.269739765,-2.79104908309,-2.95616829931,0.206146759033,27.4475862732,13.611087567,-8.53296470332,-14.4754749875,-9.6020113485,-15.3462175282,-6.95463782546,4.24363197359,-8.71865273517,-2.75790778702,-3.87220696538,-2.58561112458,1.40924050401,-1.96727878142,-6.00110989093,3.81338430432,-0.703383688283,-0.0369913985049,-4.52268027008,-1.42764213709,2.22584396457,-3.02164983604,-1.81548857657,-3.28262427109,0.505970523572,-3.47173453894,-1.9542924918,0.310993337632,2.10696789409,0.711429652501,-1.26027268881,-0.987197112943,-0.0386577872553,-0.319980159206,-0.983828413569,-1.13286443151,-0.0884715366887,0.495139672418,-0.230550774824,-0.900611723794,-0.629685117887,-0.201687259485,-1.61004851969,-1.06681681182,-0.29976302028,0.836332006052,-0.101233026182,-0.149498747466,-0.0975650327379,-0.19794958698,-0.175026141489,0.0681606012963,-0.0890417681543,-0.0890334445235,-0.188658208456,0.183760618444,0.277482108665,-0.123760243985,-0.242637930184,-0.0481896538989,-0.0500267498917,-0.292493745597,-0.208285039213,0.0518374448969,0.0986838828408,-0.18438408436,-0.282711855471,-0.0852999408759,-0.0440961614108],[-37966.2768337,-2382.95727691,-2933.38656727,-760.577388197,-2004.97547823,1006.74131257,1351.89084443,-218.094690727,-344.054169752,241.563536853,-1276.10157084,-526.555136029,-199.135383446,790.483319105,114.564285626,16.5222509687,-396.114757959,388.017782548,-401.4963544,-598.029928741,-39.8869595431,577.123575277,172.624206731,285.725449491,5.99845741322,106.143373506,-46.9229009413,179.117515168,186.167903213,30.7517802238,167.233504859,37.8672967901,-114.515949878,-6.55055256295,52.1552035539,-50.6956275918,8.34755354979,15.068283817,75.7402283569,52.4462836001,27.4510203104,-13.0200864769,-51.798437769,-64.2646237833,-21.1860911104,46.6278000837,-4.17454580118,17.5847309276,-3.3069430216,-2.51177219441,0.248879633666,27.6924174454,13.7616533398,-8.55362021667,-15.1651920164,-9.83572299423,-15.2197889119,-7.73697141195,4.80983001545,-8.71980300629,-3.12480014001,-3.91698650366,-2.70698061582,1.34583835389,-1.95484178895,-5.96349143437,3.80864790786,-0.66158659583,-0.0724155612544,-4.65336862309,-1.46490376013,2.24273578869,-3.16060848027,-1.75056303212,-3.3354644958,0.377063289848,-3.57405051965,-2.00472385526,0.334408109194,2.08483781693,0.722717119054,-1.29329969666,-0.999959395902,-0.00778607312716,-0.270873267799,-1.00647946833,-1.1270802004,-0.0834497851717,0.491031520087,-0.232693314736,-0.928112809658,-0.669056717962,-0.255592050735,-1.66546510494,-1.09171433005,-0.297847253156,0.846278533279,-0.090480350545,-0.161048431305,-0.101530412707,-0.213485846236,-0.18196284688,0.0754548899006,-0.0775425120159,-0.0847811929934,-0.183009006781,0.19338847944,0.273057572461,-0.113016119273,-0.259820034161,-0.0594739441998,-0.0596338918494,-0.307153674183,-0.216454845759,0.0499841293596,0.101853676377,-0.187830365619,-0.29106681218,-0.0850702898705,-0.0432498760609],[-38011.9631705,-2428.33468084,-2953.47613492,-791.031611224,-1982.55024392,1026.41659406,1341.94876712,-212.384516767,-332.122416291,221.847947588,-1259.32629223,-523.926343342,-222.643558347,798.885486288,110.031811858,29.6019769095,-409.509805897,385.571932699,-401.108239158,-607.811537466,-29.9032443741,590.037395354,161.576868531,279.582968949,1.07719262018,104.298708762,-48.1251327751,180.112644436,184.729081643,36.5461882068,167.429986743,33.4225799985,-117.727974356,-9.69051834312,51.8808065417,-52.4618564901,8.75271790866,16.5000847117,76.5924685687,52.6375449039,28.0280467873,-14.3937323029,-53.6907101182,-64.6120615197,-23.5137880725,47.936358132,-3.59435808238,16.8890746858,-3.79613916884,-2.06550369272,0.30377660579,27.9259586628,13.9112435774,-8.56418246515,-15.8691806242,-10.0358377378,-15.1095933792,-8.53083678758,5.34577890557,-8.73774900564,-3.4797067614,-3.94199532004,-2.8269751003,1.27244122547,-1.93939646342,-5.91871242308,3.808065086,-0.605494895697,-0.105344817653,-4.78138841837,-1.48937730617,2.2430078489,-3.30212030128,-1.68761405861,-3.396458876,0.249198969513,-3.66763448958,-2.06116829838,0.357413164683,2.05755439531,0.727646802782,-1.32535557855,-1.01082615582,0.0241562163588,-0.216666358657,-1.02885291429,-1.11912938963,-0.0761252186545,0.481578813895,-0.232842977042,-0.954949474135,-0.707832201248,-0.30858317353,-1.71699478035,-1.11937925167,-0.295838138657,0.852074010379,-0.0793410798007,-0.172381823189,-0.10641311533,-0.229463277467,-0.188842764399,0.0828998510203,-0.0655963363179,-0.0805596618851,-0.175925353881,0.202909449976,0.268128791422,-0.101021237317,-0.276923669979,-0.069745219799,-0.0688506850915,-0.320994732617,-0.225457950587,0.0476526444898,0.103481515131,-0.191062637772,-0.299049363115,-0.0844700905621,-0.0424278417057],[-38052.0005405,-2474.83038109,-2969.70405305,-821.045253965,-1962.47367896,1045.78827434,1327.91803941,-208.121465587,-323.995901524,200.629710159,-1242.22146543,-520.024219809,-243.817745883,806.789733541,105.88117372,42.3532833828,-422.606949868,382.969187568,-399.580210669,-617.304413977,-20.1154276493,601.483525342,150.511788455,272.309130072,-3.29003634022,102.620352111,-49.3994978,181.252679993,182.929115286,42.1582187167,167.218109107,28.8634138136,-120.734604178,-12.8457481955,51.6422986322,-53.9874206865,9.17458647018,17.8945437852,77.4252562911,52.7079510146,28.589808632,-15.8603216409,-55.5258285108,-64.9016285295,-25.8830461885,49.1250774212,-3.07966595382,16.1833829346,-4.25591657839,-1.61890051272,0.37525534554,28.1508891549,14.0608858193,-8.56208971195,-16.5817496282,-10.1999005373,-15.0183556131,-9.33338065034,5.84519714039,-8.77505620295,-3.82117718112,-3.94537842531,-2.9440535245,1.18874364294,-1.9213389302,-5.86579919958,3.81321786777,-0.534329514518,-0.134663242273,-4.90558921345,-1.49974752258,2.22527310107,-3.44537635945,-1.62726998007,-3.46694860674,0.123002957155,-3.75197413179,-2.12322750984,0.380179788026,2.02463791538,0.726054620337,-1.35646046406,-1.01972792961,0.0572369837846,-0.157544816062,-1.05071394891,-1.10888525499,-0.0663109915752,0.466491393429,-0.230895324111,-0.980950069523,-0.746069459199,-0.36033110716,-1.76428970778,-1.14970596007,-0.293674016854,0.853309281017,-0.0677300522009,-0.183509563815,-0.112131222508,-0.245851764262,-0.195654839084,0.0903864009536,-0.0532863072048,-0.076437848219,-0.167434777394,0.212248135072,0.262749202031,-0.0878079504469,-0.293827953874,-0.0789163385323,-0.0776235026448,-0.333939168588,-0.235301191468,0.044867341869,0.103456276409,-0.193992803889,-0.306608203309,-0.0834761204631,-0.0415995397247],[-38086.6332911,-2523.31910296,-2981.60185369,-850.18758148,-1945.33567947,1064.59996686,1310.27264848,-205.197247494,-320.148881279,177.928419749,-1225.2647824,-514.685403181,-262.414759668,814.240251873,102.130490852,54.7286125294,-435.252834672,380.204009958,-396.834093239,-626.404913122,-10.5898938806,611.359940976,139.454045827,263.911308154,-7.05970096522,101.164624158,-50.7582016969,182.556557282,180.753988255,47.5438698733,166.587937827,24.1890922167,-123.469179058,-16.0046203842,51.4051831878,-55.2573642211,9.62546458195,19.2532724199,78.2349966045,52.6500231395,29.136214806,-17.4120663233,-57.2942698495,-65.1212905945,-28.2859827319,50.1703076858,-2.6374874006,15.4682675694,-4.68355430384,-1.17350037292,0.467733523045,28.3698881512,14.2116076052,-8.54478022027,-17.2972078456,-10.325456351,-14.9488002961,-10.1417496982,6.30180321635,-8.83429006796,-4.14776092912,-3.92528083026,-3.05667483488,1.09444013049,-1.90106531463,-5.80377810642,3.82568828217,-0.447311378928,-0.159254909684,-5.02482056586,-1.49469915672,2.18814450109,-3.58956771519,-1.57015912053,-3.54827488305,-0.000899352636885,-3.82655712929,-2.19050317831,0.402879263152,1.98560866331,0.717776488373,-1.38663448276,-1.02659525419,0.0915241317322,-0.093694024297,-1.07182776964,-1.09622105228,-0.0538202583722,0.445479098282,-0.226745918312,-1.00594294812,-0.783826383265,-0.410506330917,-1.8070020491,-1.18258883864,-0.291293227816,0.84957518886,-0.0555621059974,-0.19444229388,-0.118602816146,-0.262621190211,-0.202388015972,0.097805455999,-0.0406954908213,-0.0724847490151,-0.157564804955,0.221329139749,0.256972240768,-0.073408610994,-0.310412002082,-0.0869001582351,-0.0858987175366,-0.345909229784,-0.245991406174,0.0416525730786,0.101666837519,-0.196532767041,-0.313692027795,-0.0820651570862,-0.0407344514973],[-38115.9944871,-2574.17105614,-2988.78972933,-878.079600949,-1931.44797849,1082.6578831,1289.400222,-203.482713718,-320.869564854,153.749740974,-1208.79467787,-507.815962031,-278.279459938,821.265869031,98.8354150227,66.6994250426,-447.317393495,377.28712686,-392.830217112,-635.019548141,-1.40188249062,619.602933301,128.431662533,254.412200923,-10.2008085111,99.9739813344,-52.2061140015,184.034537398,178.193555994,52.6633898469,165.54146808,19.4045898261,-125.876303365,-19.157290224,51.1432108712,-56.2626127421,10.1151642222,20.5775052164,79.0180721554,52.4593702478,29.6660228097,-19.0394873999,-58.9863088669,-65.2624864109,-30.7152526263,51.0534313556,-2.27322771468,14.7462350097,-5.07735673323,-0.730932621368,0.584921011688,28.5850304503,14.3641820427,-8.51011134886,-18.0102423356,-10.4105387611,-14.9030252485,-10.9533175917,6.71027258637,-8.91723901318,-4.45779441922,-3.88021496439,-3.16355450632,0.989440354203,-1.87889343169,-5.73182527308,3.84673335992,-0.343975674336,-0.17818799232,-5.13815734715,-1.47321295482,2.13071228023,-3.73392822969,-1.51688341855,-3.64144826042,-0.121870791057,-3.89095996014,-2.26261108045,0.425595333945,1.9400983363,0.702800512552,-1.41586274259,-1.03136246608,0.12706715656,-0.0253627419992,-1.09198074782,-1.081073535,-0.0385336689538,0.41838663575,-0.220347165595,-1.02981888402,-0.82114663658,-0.458816904171,-1.84485249037,-1.21790945221,-0.288658582132,0.840554919921,-0.042791108771,-0.205173148118,-0.125730225924,-0.279727459301,-0.209028707081,0.105069800156,-0.0278984910233,-0.0687666353407,-0.146367015891,0.230086186498,0.250842619313,-0.0578742689737,-0.326575291214,-0.0936361672971,-0.0936335289035,-0.356841093506,-0.257526072573,0.0380367788488,0.0980369998223,-0.198611900783,-0.32025207188,-0.0802250431683,-0.0398043191252],[-38139.7720621,-2625.73838774,-2991.24251445,-904.549288042,-1920.00965684,1100.01862653,1265.34294961,-202.765279159,-325.70197542,128.043616186,-1192.59255761,-499.599688227,-291.608893416,827.83395973,96.201726508,78.3132558257,-458.763713083,374.294322008,-387.68293628,-643.095465834,7.33794745528,626.302054589,117.484430708,243.895795823,-12.73250927,99.0354233726,-53.7187596663,185.662184045,175.253159263,57.49402701,164.128412236,14.5376038086,-127.945640062,-22.301021232,50.8631215454,-57.0176183286,10.6435238919,21.8669696474,79.770775855,52.1439523573,30.1733842976,-20.7263427897,-60.5914116135,-65.3305463314,-33.1656613963,51.7759616416,-1.98584141556,14.0273697736,-5.43972959251,-0.293193124498,0.727696497845,28.7959731259,14.5183645112,-8.45761683886,-18.7170531248,-10.4551358463,-14.8806208398,-11.7663658412,7.06910852926,-9.02258322231,-4.74876160092,-3.81016293197,-3.26443412724,0.874514547793,-1.85482785489,-5.64971597688,3.87631013862,-0.225114621234,-0.191267054057,-5.24557568501,-1.43545365871,2.05397577134,-3.8778629674,-1.46793927062,-3.74615673608,-0.239227092423,-3.94511428235,-2.33922334464,0.448061584117,1.88818427591,0.68172355458,-1.4439902649,-1.03397910024,0.163841929728,0.0469467747733,-1.11104395033,-1.06363344753,-0.020601855108,0.385598183966,-0.211878846231,-1.05271833841,-0.858016968998,-0.505121206612,-1.87783581438,-1.25549809155,-0.285830772473,0.826301029603,-0.0295270454187,-0.215625237419,-0.133352772648,-0.297070557118,-0.215553192356,0.112179688226,-0.0149360625129,-0.0653388744514,-0.133989196288,0.23848946769,0.244370150135,-0.0413307651452,-0.342298739381,-0.0991703763244,-0.10082844032,-0.366726655505,-0.269865228926,0.0340647565041,0.0926302608886,-0.20022946062,-0.326249731979,-0.0779878823436,-0.0387899276001],[-38157.542667,-2675.86872926,-2989.02370397,-929.476360554,-1909.94163223,1116.80139864,1238.05666143,-202.811499639,-334.004089615,100.74605717,-1176.30057016,-490.289804459,-302.688153448,833.896535425,94.4727377102,89.6366583343,-469.578168567,371.317643323,-381.545110671,-650.589971393,15.5100819809,631.585172422,106.655085049,232.46140273,-14.6864892932,98.3220858319,-55.2643274989,187.406386577,171.94201015,62.0172797859,162.410411962,9.62151196831,-129.678116765,-25.4348539759,50.5799023736,-57.5427146678,11.2078887224,23.1210164038,80.4893781806,51.714817248,30.6512994627,-22.4546996293,-62.0988419693,-65.3342736225,-35.6325522165,52.3444444503,-1.77267032965,13.3236509038,-5.77410394206,0.137630621688,0.896230871143,29.0017688204,14.6736559581,-8.38724952694,-19.4142184816,-10.4597243096,-14.8805505769,-12.5794029196,7.37777128029,-9.14822582182,-5.0179333076,-3.71547425599,-3.35931181445,0.750648086866,-1.82879484738,-5.55737528213,3.91405065757,-0.0918346988875,-0.198480756632,-5.34727702116,-1.38188200907,1.95941158266,-4.02081979359,-1.42379668774,-3.86175766773,-0.352272216834,-3.98904054896,-2.42002618727,0.469924057339,1.83005523474,0.655294665172,-1.47082704941,-1.03439849124,0.201805916475,0.122668895608,-1.12890961793,-1.04415503196,-0.000242944093016,0.34763278877,-0.201577584075,-1.0748441943,-0.894409902055,-0.549315198008,-1.90601532814,-1.29517222885,-0.28289496203,0.806958415657,-0.0159189301667,-0.225704166706,-0.141294024901,-0.314536489649,-0.221935218723,0.119157242712,-0.00184049770334,-0.0622541076501,-0.120603183923,0.246518293166,0.237555920902,-0.0239226379534,-0.357583625068,-0.103575426477,-0.107494781472,-0.375571741144,-0.28295955359,0.029785392518,0.0855450423413,-0.20140217254,-0.33164894478,-0.0753968434708,-0.0376743226358],[-38168.8829527,-2722.40971219,-2982.19679285,-952.740536279,-1900.1648224,1133.12540093,1207.49718761,-203.387930978,-345.133884081,71.7930757132,-1159.56086406,-480.139533418,-311.802333379,839.405607572,93.8917610319,100.736186024,-479.747135079,368.449138724,-374.569600215,-657.460370007,22.9950071099,635.580154382,95.9863602522,220.208331521,-16.0944346319,97.807104271,-56.8110063062,189.234034349,168.269320743,66.2146465979,160.449108926,4.68969210928,-131.074661088,-28.5578290235,50.3085405188,-57.8582354469,11.8056038453,24.3389961764,81.1701496095,51.1830126999,31.0927684981,-24.2066250553,-63.4978638143,-65.2824715509,-38.1112682613,52.7654256883,-1.63105628333,12.6470574431,-6.08391084228,0.559451121187,1.09069502121,29.2014701765,14.8295573308,-8.29896224981,-20.0983166743,-10.424780854,-14.9017779666,-13.3909372997,7.63572107475,-9.29206993819,-5.26258037266,-3.59649845942,-3.44818568476,0.618826347031,-1.8007206723,-5.45472825312,3.95958695608,0.0547576134392,-0.199817761783,-5.44346279733,-1.31295874662,1.84849632241,-4.16224657352,-1.38492568093,-3.98760841306,-0.460310124387,-4.022759213,-2.50470582467,0.490828797282,1.76589996541,0.624262895044,-1.49618309583,-1.03257397364,0.240916582038,0.201237990092,-1.14546999139,-1.02289253041,0.0223249368331,0.305009496,-0.189680002978,-1.09639933467,-0.930297957288,-0.591294838127,-1.92945433861,-1.33674933632,-0.279936313994,0.782671975835,-0.00211577724109,-0.235315540905,-0.149377551268,-0.332011262879,-0.228148533105,0.126024586118,0.011355910992,-0.0595649762396,-0.106380816574,0.254151972769,0.230401019281,-0.00579442584304,-0.37243122676,-0.106923958916,-0.113643882044,-0.383382175786,-0.296759724925,0.0252475733637,0.0768797658036,-0.202146762532,-0.336413646973,-0.0724950954085,-0.0364405499462],[-38173.36957,-2763.20896801,-2970.82527603,-974.221533012,-1889.60014508,1149.1098349,1173.62035828,-204.261128998,-358.449335457,41.1206836012,-1142.01558785,-469.402097795,-319.236526554,844.313187626,94.7021088756,111.67839235,-489.256987754,365.780856132,-366.909264839,-663.663966868,29.6732088663,638.414868051,85.5209910152,207.235892071,-16.9880313372,97.4636142489,-58.3269848957,191.112016716,164.24430313,70.0676258692,158.306144796,-0.224477964417,-132.136200646,-31.6689869425,50.0640231442,-57.9845143528,12.434014392,25.5202596559,81.8093606189,50.5595864929,31.4907915969,-25.9641862042,-64.7777410285,-65.1839433833,-40.5971527054,53.045451262,-1.558341103,12.0095684339,-6.37258135358,0.970180877992,1.31125983767,29.3941298366,14.9855695768,-8.19270784416,-20.7659259713,-10.3507821822,-14.943266516,-14.1994774544,7.8424181479,-9.45201869791,-5.47997362949,-3.45358506524,-3.53105385499,0.480034703896,-1.77053159278,-5.34169995413,4.01255107345,0.213555836481,-0.195266731247,-5.53433445523,-1.22914461204,1.72270659884,-4.30159117242,-1.35179626117,-4.12306632975,-0.562644775183,-4.0462907275,-2.5929484732,0.510421847614,1.69590722052,0.589377294913,-1.51986840386,-1.028458882,0.281131391654,0.282088427814,-1.16061731147,-1.00010018497,0.0468836604123,0.258247351499,-0.176422726795,-1.1175866425,-0.96565365623,-0.630956086738,-1.9482161528,-1.38004688619,-0.277039991554,0.753586607888,0.0117333991319,-0.244364964941,-0.157426920332,-0.349380882794,-0.234166882429,0.132803840947,0.0246208711596,-0.0573241215227,-0.0914939320172,0.261369816339,0.222906532938,0.012909332741,-0.386842822943,-0.1092886148,-0.119287071719,-0.390163784794,-0.311216421287,0.0205001855144,0.0667328528986,-0.202479956586,-0.340507775246,-0.0693258070152,-0.0350716552454],[-38171.2686197,-2796.72302411,-2955.18739748,-993.857173185,-1877.43121892,1164.81421961,1136.48188829,-205.286524656,-373.322561645,8.70822351955,-1123.37126919,-458.291577859,-325.29100362,848.577936705,97.0904541548,122.525206919,-498.086093132,363.381666073,-358.692263986,-669.156094051,35.4609401899,640.19370236,75.2840487148,193.658114313,-17.4000832637,97.2692486371,-59.7841628951,193.014453366,159.884430462,73.5682573817,156.034459107,-5.09592482359,-132.855241068,-34.7637194435,49.8630147556,-57.9414578613,13.0890227548,26.6639901874,82.4056154736,49.8561435446,31.8415079326,-27.7107685755,-65.9295168409,-65.0426544229,-43.0845003484,53.1928072247,-1.55193786381,11.4217392994,-6.64350497935,1.36726327103,1.55784317467,29.5789857397,15.1412450691,-8.06816750584,-21.4135429927,-10.2383967301,-15.0025988782,-15.0035641777,7.99853729344,-9.6260416273,-5.66755064599,-3.28764701822,-3.60783611334,0.335208985245,-1.73850684521,-5.21832674981,4.07244654033,0.383267443423,-0.184766050123,-5.61989327765,-1.130996711,1.58379449567,-4.43851862272,-1.32446239232,-4.2674778531,-0.658632545381,-4.05993622116,-2.68436331263,0.528354397555,1.62026638914,0.551366584964,-1.54177400171,-1.02205076491,0.322314476902,0.364629797796,-1.17424216829,-0.976020951362,0.0732084971911,0.207889260252,-0.162087514503,-1.1384835828,-1.00046165409,-0.668196762477,-1.96246061031,-1.424830362,-0.274286354828,0.719855580706,0.0254827824407,-0.252765223894,-0.165272239792,-0.366540125066,-0.239972449433,0.139484250812,0.0379024297628,-0.0555678517984,-0.0761185759809,0.268153327777,0.215070897349,0.0320428245144,-0.400795134221,-0.110756022427,-0.124434030512,-0.395953950869,-0.326256307028,0.0155755431255,0.055202526249,-0.202425032674,-0.343899649737,-0.0659363671875,-0.033556469942],[-38165.6040029,-2823.84399137,-2936.42039729,-1011.81769779,-1863.89246623,1180.05934446,1096.53703145,-206.67504946,-389.182245593,-25.2916382466,-1103.59195226,-446.865484186,-330.32674443,852.185114571,101.016911826,133.320063934,-506.1807834,361.227729498,-349.947955143,-673.884191171,40.4175216853,640.927131636,65.2299514488,179.647908412,-17.3678654797,97.2196295567,-61.1692832145,194.944385319,155.24022014,76.7507463523,153.652182863,-9.93279253845,-133.190600033,-37.8228228092,49.7288892301,-57.7472636023,13.7607603689,27.7687017329,82.9668535867,49.0865173227,32.1536126,-29.4350311212,-66.9513518773,-64.8432181184,-45.5634124897,53.2227402169,-1.60954463598,10.8884309844,-6.89990499498,1.74626517897,1.82935074443,29.7560170101,15.2963418834,-7.92393586733,-22.0373377654,-10.0890598644,-15.0718342927,-15.8018675483,8.10961153863,-9.81237385214,-5.82341592808,-3.10185095026,-3.67813893357,0.185086827564,-1.70633755887,-5.08509020625,4.13826285275,0.561855717252,-0.168052996952,-5.69933991164,-1.01945760899,1.43461399859,-4.57356262537,-1.30131384966,-4.42014572882,-0.747839475384,-4.06511952542,-2.77825137632,0.544298218522,1.53916940612,0.510878163272,-1.56211503153,-1.01352402706,0.363956634732,0.448172566811,-1.18622854937,-0.950852639862,0.101048308934,0.154573563841,-0.147136665583,-1.15866594852,-1.03475514073,-0.702922119445,-1.97273368117,-1.47065729274,-0.27173655164,0.681665647736,0.0389993470307,-0.260457823464,-0.172769773811,-0.383418844107,-0.245581160103,0.145923543761,0.051069991271,-0.0542671433499,-0.060447625999,0.274492787223,0.206881939224,0.0514551368354,-0.414166649673,-0.11146875864,-0.12908783975,-0.40091628606,-0.341709990471,0.010439671081,0.0423862124755,-0.202031476696,-0.346575124375,-0.0623910449738,-0.0319069682242],[-38160.0890703,-2846.0728766,-2915.87626459,-1028.33145246,-1849.48101026,1194.60631641,1054.34092625,-208.726510054,-405.471211514,-60.6829045127,-1082.70606035,-435.142184934,-334.719906138,855.12663065,106.384957358,144.101773748,-513.47938215,359.272029961,-340.680995311,-677.793724727,44.6380408733,640.602151555,55.2954539952,165.392904589,-16.9297708566,97.3148764417,-62.4727995846,196.91208393,150.370450626,79.6598393565,151.168744935,-14.7515295541,-133.092673237,-40.8234444656,49.6866977877,-57.4197019941,14.4379159302,28.8327409088,83.5033481588,48.2650984328,32.4389396743,-31.1269511562,-67.8431861124,-64.5654099553,-48.0229420537,53.1522370259,-1.72893073846,10.413080814,-7.14496311886,2.10228435539,2.1244352237,29.9253880684,15.4506695212,-7.75833592028,-22.6333986681,-9.90439868491,-15.1416511452,-16.593089966,8.18238846916,-10.009316898,-5.94584071623,-2.89992691503,-3.74149046083,0.0303563195161,-1.6760678363,-4.94258318989,4.20886099809,0.747097893402,-0.144814573636,-5.77167484534,-0.895566236479,1.27829456879,-4.70747404847,-1.28032436132,-4.58036178023,-0.829884021654,-4.06354514738,-2.87383666104,0.557930227479,1.45280884277,0.46853909738,-1.58118766396,-1.00309728717,0.405455328436,0.532002421064,-1.19645879158,-0.924781774364,0.130145355212,0.0989624629916,-0.132077614643,-1.17758411462,-1.06857943971,-0.73503927061,-1.97967786804,-1.5170332187,-0.269446926737,0.639211933563,0.052153264962,-0.267391449504,-0.179782325666,-0.399955664019,-0.251017376242,0.151946568954,0.0639732995299,-0.0533766394566,-0.044678167557,0.280380668878,0.198324833081,0.0709940822224,-0.426811300496,-0.11158338742,-0.133249931088,-0.405245959753,-0.357384065935,0.00504202194702,0.0283811391985,-0.201355326535,-0.348524436536,-0.0587583294606,-0.0301409099749],[-38158.4371729,-2864.91068659,-2894.90698851,-1043.62678281,-1834.69397424,1208.21624241,1010.44871123,-211.740713084,-421.632283618,-97.2695780939,-1060.74201676,-423.140048257,-338.846645898,857.394394366,113.098066219,154.909146716,-519.920212979,357.467551019,-330.896041492,-680.83016122,48.2175852746,639.205757794,45.4173111319,151.080733068,-16.124192266,97.5551087258,-63.6851657362,198.927820552,145.333900385,82.3402829699,148.593574194,-19.5685843156,-132.511856373,-43.7427318382,49.7614916483,-56.9765434554,15.1091781346,29.8544543313,84.0253723906,47.4062774802,32.7093232307,-32.7765059956,-68.6049595212,-64.189005419,-50.452141965,52.998284439,-1.90786549023,9.99912611344,-7.3818610694,2.43041855389,2.4417492892,30.0872633352,15.6040374838,-7.56969065632,-23.1978140792,-9.68604029111,-15.2027278214,-17.3759338306,8.22361567072,-10.2151722906,-6.03309625085,-2.68560496621,-3.79741884026,-0.128294450238,-1.64974178003,-4.79139856718,4.28310196374,0.936771207311,-0.114737782077,-5.83589856687,-0.760361523929,1.11796566745,-4.84100376014,-1.25946765542,-4.74741783064,-0.904384640656,-4.05691759415,-2.97034316356,0.568927341392,1.3613772704,0.424976454832,-1.59928806965,-0.990989163961,0.446208021306,0.615405046763,-1.20481523181,-0.897994878766,0.160241895593,0.0417181584332,-0.117417796287,-1.19468845607,-1.10197987456,-0.764455328941,-1.98393567358,-1.56346368021,-0.26747382487,0.592689562774,0.0648147082945,-0.273514787869,-0.186172698632,-0.416089208899,-0.256305459647,0.157378175551,0.0764620983856,-0.0528509833979,-0.0290072861402,0.285809446942,0.189384753439,0.0905074731942,-0.438583017885,-0.111256472748,-0.136921736182,-0.409138141337,-0.373085127736,-0.000667951710488,0.0132845340381,-0.200452620074,-0.349737823599,-0.0551067097342,-0.028276055077],[-38164.3616617,-2881.85842813,-2874.86455816,-1057.93203449,-1820.02848142,1220.65022945,965.4155249,-216.017465193,-437.108286117,-134.855661805,-1037.72824479,-410.877442312,-343.083120865,858.980315144,121.059713875,165.780993191,-525.441599481,355.767276227,-320.597750687,-682.93896715,51.25124241,636.724946028,35.5322776369,136.89902407,-14.9895225794,97.9404458428,-64.7968354,201.001866539,140.189347878,84.836823768,145.936099513,-24.400405268,-131.398545134,-46.5578323528,49.9783220316,-56.4355584045,15.763235678,30.8321886167,84.5431994825,46.5244450704,32.9765973444,-34.3736729542,-69.2366120783,-63.6937799948,-52.8400651479,52.7778692435,-2.14411821025,9.65000420781,-7.61378056498,2.72576552806,2.77994561769,30.2418072313,15.7562552727,-7.35632306709,-23.7266723776,-9.4356117827,-15.245742707,-18.1491015419,8.24004072898,-10.4282415554,-6.0834537724,-2.46261515749,-3.84545221701,-0.290177393035,-1.6294034926,-4.63212920455,4.35984673705,1.12865289441,-0.0775096241775,-5.89101156436,-0.614882401798,0.956756755749,-4.97490262847,-1.23671746008,-4.92060570338,-0.970959788853,-4.04694137283,-3.06699488065,0.576966477226,1.26506726031,0.380817303172,-1.61671241922,-0.977418276138,0.485612176632,0.697666130116,-1.21118020692,-0.870678476966,0.191080189648,-0.0164971491069,-0.103664645123,-1.20942934782,-1.13500176883,-0.791077407406,-1.98614960043,-1.60945421759,-0.265873590789,0.542293659954,0.0768538490884,-0.278776524413,-0.191803695987,-0.431758102849,-0.261469772121,0.16204321271,0.088386131684,-0.0526448184532,-0.0136320672339,0.290771595614,0.180046874815,0.109843122269,-0.44933573304,-0.110644578602,-0.140104686687,-0.412788000198,-0.388619770192,-0.00674079732541,-0.00280637538524,-0.199379395196,-0.350205522939,-0.051504674881,-0.0263301634134],[-38180.5162437,-2898.08581301,-2856.63660912,-1071.41265451,-1806.0252715,1231.60572974,919.755027143,-221.648224293,-451.45688277,-173.243786075,-1013.7413845,-398.319798537,-347.709700138,859.899925837,130.171594533,176.729498047,-529.985019809,354.120529612,-309.769504421,-684.059570336,53.841500571,633.173570995,25.5820803744,123.032007402,-13.567095491,98.47010082,-65.8012140115,203.144907709,134.993921038,87.1929502167,143.210798033,-29.2630549614,-129.702650052,-49.2447549011,50.3578607987,-55.813329183,16.3891678666,31.7642221196,85.0644201722,45.632546361,33.2516281404,-35.9075439942,-69.7394569738,-63.058612616,-55.1744848727,52.5062911285,-2.43515565357,9.36715364379,-7.84337826396,2.98380215237,3.13715724139,30.3887401801,15.9070645194,-7.11695428642,-24.2162402121,-9.15476325702,-15.2617806478,-18.9109277646,8.23805108174,-10.6472508375,-6.09572357336,-2.23419403885,-3.88507458089,-0.454588094659,-1.61686268116,-4.46548378583,4.43796517281,1.32070413448,-0.0330041024982,-5.93630536212,-0.460186598954,0.797530836888,-5.10975315541,-1.21018160492,-5.09925624755,-1.02917573276,-4.03508226396,-3.16302637631,0.581830407802,1.16413583928,0.336634024682,-1.63368229661,-0.962598170645,0.523143888907,0.778114793937,-1.2154998083,-0.843105515396,0.22240504796,-0.0750915760534,-0.0912915790669,-1.22128812194,-1.16770702478,-0.814783440345,-1.98688777634,-1.65453752944,-0.26467167688,0.488264637674,0.0881558104222,-0.283116971505,-0.196561101863,-0.446883332908,-0.26652594756,0.165798729937,0.099603254942,-0.0527222633399,0.00123454443896,0.29525800456,0.170293151331,0.128843408001,-0.458934396996,-0.10989495549,-0.142788699058,-0.416371322986,-0.403807265237,-0.0132096077036,-0.0197900739603,-0.198185767844,-0.349912591343,-0.0480101146383,-0.0243203272459],[-38205.3160502,-2913.43737297,-2839.25336269,-1083.98249548,-1793.3995501,1240.52557651,873.814963325,-227.891053363,-464.69509552,-212.23109178,-989.050942976,-385.220801507,-352.623600598,860.263253007,140.328277346,187.660344233,-533.504570352,352.461997091,-298.309582317,-684.107243877,56.1204511332,628.672923675,15.5283345531,109.65031121,-11.9100079854,99.1396610585,-66.7035138251,205.369287742,129.79814567,89.4471183431,140.45233998,-34.1710523651,-127.372141,-51.7749542376,50.9032623752,-55.1216858257,16.9776164471,32.6485601484,85.5858953449,44.7377447187,33.5414099433,-37.3636696661,-70.1203002586,-62.2587960072,-57.4380557931,52.1921013902,-2.77723431947,9.14401785396,-8.07121058456,3.20152178479,3.50943861447,30.5260066175,16.0559353761,-6.85189801692,-24.6634973139,-8.8452368022,-15.2435523287,-19.6582762224,8.22259357524,-10.8726247592,-6.0708721544,-2.00160414551,-3.91559330034,-0.620756838676,-1.61299147144,-4.29263426433,4.51636259532,1.51162188461,0.0181567777619,-5.97223562925,-0.297407037881,0.642085082083,-5.24546437826,-1.17850432541,-5.28285641545,-1.0783899791,-4.02185114175,-3.25771448337,0.583725329362,1.0590978559,0.292780260586,-1.65012093885,-0.946722107305,0.558593777419,0.856253907471,-1.21797514534,-0.815894630627,0.253971485173,-0.133754507441,-0.0806359492765,-1.22986993883,-1.20022385961,-0.83533464759,-1.98642082934,-1.69835494752,-0.263769966087,0.431024060436,0.0986655194496,-0.286442947569,-0.200422623809,-0.461315337886,-0.271454708248,0.168630578124,0.110003770361,-0.0530853385278,0.0153161672049,0.299253225308,0.160092655517,0.147328973083,-0.467288040154,-0.109117600015,-0.144917628937,-0.419986365407,-0.41851759527,-0.0200376571386,-0.0375478966116,-0.196898166211,-0.348823363236,-0.0446385213461,-0.0222609683517],[-38236.1165687,-2927.42634476,-2821.28068665,-1095.4925114,-1782.9101393,1246.78894828,827.901600178,-233.795666646,-476.95478586,-251.61334741,-963.974644056,-371.281199083,-357.626251068,860.203946643,151.422550205,198.452589222,-535.95750206,350.722705049,-286.094988523,-682.991222192,58.2275862427,623.371154109,5.33762746772,96.9211632249,-10.0742978698,99.9438075529,-67.5118988003,207.68776478,124.650897047,91.6365260647,137.700443853,-39.1385305535,-124.354502687,-54.1187465831,51.6133018276,-54.3712702902,17.5196137765,33.4831397494,86.1018034232,43.8457580623,33.8519691274,-38.7267151676,-70.3873211988,-61.2687263411,-59.6121529086,51.8421642266,-3.16630814329,8.97204149234,-8.29730888499,3.37629690414,3.89232454663,30.6511069822,16.202270125,-6.5618661034,-25.0656016844,-8.50879750409,-15.1841748949,-20.387642904,8.19825490782,-11.1052125621,-6.01040506825,-1.76561450903,-3.93627158848,-0.787897583094,-1.61842759381,-4.11486841077,4.59395319629,1.70028704626,0.0751640107451,-5.99954907105,-0.127695439473,0.491950204559,-5.38177696814,-1.14046395852,-5.47093218519,-1.11790784465,-4.00752015382,-3.35034660192,0.582963294,0.95053261423,0.249554966847,-1.66587699626,-0.929978274166,0.591831092657,0.931629776569,-1.21887108198,-0.789750881765,0.285537066942,-0.192245645459,-0.0720010902195,-1.23481091601,-1.23269706922,-0.852463070341,-1.98494501253,-1.7405749619,-0.263039448989,0.37103878073,0.108342854343,-0.288652897546,-0.203388950227,-0.474886919535,-0.276228048566,0.170556808508,0.119486091813,-0.0537455399244,0.028320560153,0.302740224849,0.149411239505,0.165115026242,-0.474316712754,-0.108413195307,-0.146423816767,-0.423712000429,-0.432633420308,-0.0271707652958,-0.0559568907724,-0.195537096546,-0.346896992448,-0.0413947879955,-0.0201658408868],[-38270.2732868,-2939.56596514,-2801.28444873,-1105.79365626,-1775.3158612,1249.77502353,782.321204435,-238.411778387,-488.36781528,-291.186321455,-938.83021159,-356.201739123,-362.519080374,859.855656737,163.347201003,208.985290484,-537.301065879,348.833679873,-273.002727185,-680.620739697,60.302398046,617.416412338,-5.02345358684,85.0117911777,-8.11600295168,100.877221298,-68.2345328963,210.113096967,119.601050444,93.7983712987,134.994828148,-44.1796226011,-120.597219822,-56.246448158,52.4867542227,-53.5727245344,18.0061922116,34.2658979692,86.6063228294,42.9623043105,34.189332067,-39.9813456962,-70.5486990604,-60.0627997903,-61.6781512186,51.4633438357,-3.5983310604,8.84266921298,-8.52170452344,3.50549998927,4.28134984751,30.7615417128,16.3454710485,-6.24757039064,-25.419711325,-8.14721044854,-15.0767654913,-21.095523798,8.16962177784,-11.3458634879,-5.91582786761,-1.52699416092,-3.94637265839,-0.955224285925,-1.63380877864,-3.93347399583,4.66965116741,1.88558052085,0.137208590593,-6.01899239278,0.0477964753794,0.348656917545,-5.51843159618,-1.09483884121,-5.66300953486,-1.14703464618,-3.99236144781,-3.44021013203,0.579856353815,0.839019418342,0.207257099426,-1.68079911916,-0.912554859275,0.622725085109,1.00378870708,-1.2184524821,-0.765379327914,0.316859358926,-0.250324692292,-0.0656903363635,-1.23574717099,-1.26527144952,-0.865900749801,-1.98265657902,-1.78086606263,-0.262351116168,0.308775651044,0.117147693275,-0.289645266376,-0.205460769522,-0.487430879604,-0.280817962894,0.171595472327,0.127948633171,-0.0547143634376,0.0399554823721,0.305701970177,0.13821475543,0.182016776206,-0.479940465039,-0.107882424496,-0.147239602987,-0.427627101021,-0.446037400367,-0.0345547518406,-0.0748941038761,-0.194123065101,-0.344092632813,-0.0382838075775,-0.0180486990072],[-38305.1416918,-2949.36947084,-2777.8305167,-1114.73688407,-1771.37553788,1248.86298075,737.380042829,-240.789102832,-499.066045273,-330.745782405,-913.935369423,-339.683169486,-367.10351734,859.352033277,175.995017631,219.13750549,-537.492512758,346.725947952,-258.909802452,-676.905030813,62.4843786892,610.956848403,-15.5883213158,74.0894227993,-6.09116103814,101.934583288,-68.8795800725,212.658042447,114.697481133,95.9698519628,132.375211365,-49.3084615822,-116.047777116,-58.128375183,53.5223946271,-52.736690516,18.4283841095,34.9947718543,87.093631986,42.0931013822,34.5595251363,-41.1122264497,-70.6126131096,-58.6154125273,-63.6174257227,51.0625044155,-4.06925700615,8.74734566991,-8.74442885809,3.58650351901,4.67204932681,30.854811248,16.4849404288,-5.90972272347,-25.7229842373,-7.76224072139,-14.9144412629,-21.7784148929,8.14128088364,-11.5954267782,-5.78864610521,-1.28651213273,-3.94515972319,-1.12195090518,-1.65977275628,-3.74973879023,4.74237070039,2.06638320983,0.203481511449,-6.03131229976,0.227916985785,0.213735934265,-5.65516893352,-1.04040731042,-5.85861444256,-1.16507570047,-3.97664717135,-3.52659247377,0.574716560901,0.725137572292,0.166185614285,-1.69473595786,-0.894640050679,0.651145005262,1.07227700487,-1.21698420964,-0.743485028182,0.347695926782,-0.30775135013,-0.0620070221762,-1.23231482126,-1.29809179642,-0.875379727172,-1.97975178193,-1.81889673977,-0.261575958204,0.244701523866,0.125039914417,-0.289318498999,-0.206638770098,-0.498780019845,-0.285196445613,0.171764620819,0.135289808307,-0.0560033049752,0.0499286929512,0.308121428285,0.126469055422,0.197849431703,-0.484079347248,-0.107625970712,-0.14729732804,-0.431810540151,-0.458612195463,-0.0421354364385,-0.0942365833561,-0.192676578129,-0.340369438162,-0.035310473083,-0.0159232968689],[-38338.4915007,-2956.54401514,-2749.6602319,-1122.26262999,-1771.59389341,1243.66827898,693.3713837,-240.138182875,-509.105119043,-370.085341779,-889.513464493,-321.51695928,-371.227775049,858.811359267,189.238774392,228.801334817,-536.515084431,344.347110344,-243.739903875,-671.782949455,64.8824848264,604.126179901,-26.3981644011,64.2901707319,-4.05541021826,103.103867549,-69.4551231692,215.331650816,109.984389336,98.1736128806,129.879112141,-54.5392393096,-110.679825179,-59.7279248624,54.7154247794,-51.8731890623,18.7781344947,35.6665792045,87.5604729855,41.2453955683,34.9645665903,-42.1056283739,-70.5889000319,-56.9099513074,-65.4112843819,50.6452862399,-4.57524366911,8.67765307874,-8.96509846997,3.61731616432,5.06023499591,30.929141425,16.6198474116,-5.5497432255,-25.9732215918,-7.35648919868,-14.6922621183,-22.4326086692,8.1168383722,-11.8543109265,-5.63114384201,-1.04499371842,-3.931749591,-1.28702149661,-1.69668950603,-3.56476891358,4.81118444651,2.24144643168,0.273075847195,-6.03720490115,0.411335896205,0.0885853959926,-5.79172957985,-0.976361957061,-6.05709355701,-1.17169222393,-3.9606259138,-3.60868556252,0.567921646324,0.609492705847,0.126673164363,-1.70752131601,-0.876388632283,0.676981310669,1.13661089727,-1.21468443644,-0.724685069969,0.377762873885,-0.364243956549,-0.0612293321289,-1.22430222442,-1.33125587054,-0.880729094891,-1.97642129167,-1.85439111,-0.260558580733,0.179259502963,0.131981418516,-0.287567468028,-0.206934973687,-0.508785974865,-0.289326089283,0.171091349455,0.141414548716,-0.057610174473,0.0579876551029,0.309976555566,0.114148512922,0.212443286478,-0.486692978079,-0.107734685616,-0.146557705457,-0.436322164312,-0.470266418258,-0.0498410713499,-0.113865218321,-0.191214903729,-0.335695853888,-0.0324741608385,-0.0138029964241],[-38369.7493485,-2961.57241736,-2716.21682995,-1128.66925389,-1775.45925974,1234.75149931,650.536501811,-236.31287602,-518.235806648,-408.989983213,-865.410336117,-301.857462609,-374.92720361,858.290449762,202.871191249,237.921051468,-534.455985773,341.711066802,-227.60346262,-665.311827534,67.4835311419,597.000394656,-37.5252754327,55.6256872642,-2.06278970815,104.346220236,-69.9689205516,218.128137479,105.487275056,100.374086502,127.535249687,-59.8863825501,-104.571678227,-60.9808183362,56.046753106,-50.9897564777,19.0510390628,36.2736608324,88.0138426012,40.4325466477,35.3904422055,-42.9542454077,-70.4940261905,-54.9657652161,-67.0407670043,50.212433887,-5.11326375077,8.62572390125,-9.18167083145,3.59849136452,5.44282767316,30.9856596745,16.7484285964,-5.17188513572,-26.1707972362,-6.93589991721,-14.4130590195,-23.0535835736,8.09597818502,-12.1211614335,-5.44871917194,-0.803489261674,-3.90467345004,-1.448300507,-1.74385800293,-3.37894388125,4.87579889532,2.40900317305,0.344692990679,-6.03716392178,0.596009112512,-0.0259268438246,-5.92785384905,-0.90355238771,-6.25707620939,-1.16796903158,-3.94445203141,-3.68529947484,0.560112057015,0.492795751591,0.0891871905004,-1.71892961046,-0.857821771431,0.700209287132,1.19618629767,-1.21158456612,-0.709244653865,0.406610454489,-0.419355390684,-0.0635348507072,-1.21210669826,-1.36467329127,-0.882166150342,-1.97283344786,-1.88729579647,-0.259038049616,0.112797697215,0.137942196615,-0.284272756761,-0.206406735343,-0.517375710693,-0.293131879184,0.169638930639,0.146253856387,-0.05947803798,0.0640386485338,0.311225266023,0.101261586586,0.225688974346,-0.487899250054,-0.108260094999,-0.145094941134,-0.441145714099,-0.481012491998,-0.0575296392159,-0.133676264577,-0.189742357399,-0.330077491611,-0.0297521805124,-0.0116995908102],[-38398.7560995,-2965.13141332,-2677.11902006,-1134.34459681,-1782.20587081,1222.90950339,609.103673534,-229.327868419,-526.13265986,-447.242533377,-841.377446702,-280.949754824,-378.283937389,857.830752831,216.664974574,246.453971554,-531.428412445,338.848291747,-210.657595255,-657.578616456,70.2437968278,589.641048048,-49.0497229771,48.0765095966,-0.166939005676,105.616080534,-70.4286494657,221.038009296,101.226963244,102.521152183,125.370143355,-65.3643768086,-97.8278163781,-61.8158577282,57.4937147053,-50.0933079364,19.2436061771,36.8072383036,88.4633012768,39.6694427714,35.8191296389,-43.6523772383,-70.3461153683,-52.8111939215,-68.4868463597,49.7634680106,-5.68049370584,8.58382816076,-9.39168863771,3.53121875105,5.81702537862,31.0262188258,16.8686874458,-4.78110997195,-26.3167281875,-6.50725270397,-14.0816056926,-23.636614545,8.07740371221,-12.3941830514,-5.24754869717,-0.563105368604,-3.86231608355,-1.60338248084,-1.80030947094,-3.1924615575,4.93607899597,2.56715683762,0.416936414493,-6.03163249033,0.779714065931,-0.129065503693,-6.06328198359,-0.823242462891,-6.4570124015,-1.15534683808,-3.92825632214,-3.75514882263,0.551993918873,0.375783967814,0.0542288305166,-1.72872041138,-0.838927231325,0.720825427515,1.25036904093,-1.20766931021,-0.697341008756,0.433747460566,-0.472597167059,-0.0690760124001,-1.1962778007,-1.39820664268,-0.880005242142,-1.96915100744,-1.91761304897,-0.25672704577,0.045640466782,0.14289426233,-0.279311376171,-0.20512274345,-0.524495026216,-0.296529398773,0.167479681007,0.149745250933,-0.0615362755735,0.0680276570738,0.311820463059,0.0878252563782,0.237492214142,-0.487855624153,-0.109243893182,-0.143011614059,-0.446245903633,-0.490888792572,-0.0650415552723,-0.153569819607,-0.188260016486,-0.323529254512,-0.0271163251086,-0.00962448096071],[-38425.3526181,-2967.89773888,-2631.98551144,-1139.6764998,-1791.06796056,1208.93915284,569.301175238,-219.197846227,-532.470230448,-484.625818936,-817.166258659,-259.038911276,-381.380110753,857.473716543,230.392830741,254.357411186,-527.545560107,335.789259606,-193.059418352,-648.670267631,73.1195610761,582.109695458,-61.051575601,41.6231749292,1.57850239128,106.86788763,-70.8419871577,224.051773125,97.2242788513,104.564689279,123.410312495,-70.9877075904,-90.5527197499,-62.1618451624,59.0336446757,-49.1907586124,19.3523442008,37.2585331838,88.9184094555,38.9709720904,36.2326065476,-44.1943235527,-70.163291348,-50.4745770917,-69.7304952177,49.2979092646,-6.27410998903,8.54423588061,-9.59269458394,3.41668795538,6.18002613236,31.0526717081,16.9786274227,-4.38237925201,-26.4120314626,-6.07732738594,-13.702675863,-24.1769765219,8.0598183439,-12.6715805328,-5.0338090199,-0.324948645321,-3.80306227477,-1.74986196265,-1.86507513402,-3.00551980663,4.99188969759,2.71401082909,0.488409591225,-6.02105373553,0.960228187688,-0.220095302119,-6.19775422592,-0.736696043123,-6.65535213514,-1.13526635806,-3.91216958399,-3.81694821776,0.544273357797,0.259194612807,0.0222992222297,-1.73665328896,-0.819692775168,0.738826224683,1.29852496191,-1.20292338026,-0.689151363527,0.458682684086,-0.523480800197,-0.078005251697,-1.17736508959,-1.43171850886,-0.874560718909,-1.96553672732,-1.94534511729,-0.253338250111,-0.0218878281773,0.146809629277,-0.272560337228,-0.203151686392,-0.530089720319,-0.29943423151,0.164685917195,0.151826251965,-0.0637142673306,0.0699006645532,0.311715050078,0.0738565022623,0.247758724697,-0.486719561354,-0.110727774486,-0.140410303218,-0.451587447031,-0.499933695872,-0.0722172347553,-0.173445980894,-0.186768958336,-0.316066045771,-0.024538387631,-0.00758906780909],[-38449.3797686,-2970.54812987,-2580.43501329,-1145.05280388,-1801.27976291,1193.63730931,531.357283294,-205.937495597,-536.923070186,-520.922666557,-792.528234395,-236.370007318,-384.29785807,857.260788964,243.827466124,261.588686472,-522.920624421,332.5644448,-174.966048478,-638.673732466,76.0671030788,574.467892267,-73.6109018711,36.2462204623,3.11989498486,108.05608071,-71.2166108738,227.159935824,93.5000468281,106.454577147,121.682276461,-76.7708604006,-82.8508684602,-61.9475827624,60.6438781156,-48.2890236796,19.3737614972,37.6187670388,89.388727581,38.3520227557,36.6128505887,-44.5743840382,-69.9636779123,-47.9842543949,-70.752686348,48.815278303,-6.89128905505,8.49921708414,-9.78223136533,3.25608860892,6.52902795443,31.0668711505,17.0762519898,-3.98065449371,-26.4577240782,-5.65290379013,-13.2810432567,-24.6699444431,8.04192547022,-12.9515586299,-4.81367674228,-0.0901256979365,-3.72529680695,-1.88533349695,-1.93718621614,-2.81831649292,5.04309594933,2.84766855114,0.557715993465,-6.00587078607,1.13532890901,-0.29828095761,-6.3310108185,-0.645176988925,-6.85054541211,-1.1091683062,-3.89632261492,-3.86941227211,0.537656499687,0.14376494486,-0.00610049654189,-1.74248781337,-0.800106166162,0.754208171501,1.3400198955,-1.19733148783,-0.684852947065,0.480924917023,-0.571517804623,-0.0904750030869,-1.15591812285,-1.46507147391,-0.866146929261,-1.96215336444,-1.97049425119,-0.248584343557,-0.0894628275037,0.149660311074,-0.263896650906,-0.200562252552,-0.534105591887,-0.301761960853,0.161329955839,0.152434379095,-0.0659413933285,0.069603654802,0.310861930482,0.0593723042014,0.256394224847,-0.484648522637,-0.112753433234,-0.137393587597,-0.457135058415,-0.508185577787,-0.0788970929007,-0.193204845919,-0.185270260296,-0.307702768568,-0.0219901610835,-0.00560475228889],[-38471.268308,-2973.41852952,-2522.46860925,-1150.76893396,-1812.06029274,1177.69070253,495.375822444,-189.637153354,-539.189960173,-555.944453278,-767.23360826,-213.235473143,-387.181440765,857.193162999,256.752273973,268.111359133,-517.679047287,329.214058861,-156.551309505,-627.691517072,79.0253111927,566.765660203,-86.7920805042,31.9007098686,4.40449472215,109.135849671,-71.5598814995,230.348685379,90.0757997668,108.140949646,120.202208584,-82.7228569337,-74.8393674352,-61.1123351835,62.3004412672,-47.3974526086,19.3052097662,37.8794616736,89.8827671924,37.8254005571,36.9429904985,-44.7914082971,-69.7628604628,-45.3746145354,-71.536042162,48.3139846964,-7.52875989842,8.44117726208,-9.95814707811,3.05122475364,6.86132192797,31.0707921185,17.1598802681,-3.58088049083,-26.4553272641,-5.24037932326,-12.8228048526,-25.1110993845,8.02166278752,-13.2316875459,-4.59346538893,0.139976773484,-3.62771290384,-2.00758529163,-2.01568518792,-2.63110030578,5.08966413888,2.96642258141,0.623614095734,-5.98649803566,1.30291983254,-0.363160356794,-6.4626637954,-0.550255167302,-7.0408192467,-1.07860314782,-3.88080237403,-3.91140343595,0.532825142517,0.0302205941242,-0.0305352509217,-1.74605233829,-0.780171096069,0.766985281789,1.37432802968,-1.1908714295,-0.684551260141,0.500057315981,-0.616259893301,-0.10654564966,-1.1325418247,-1.49803771276,-0.855072273957,-1.959098568,-1.99302244532,-0.242193852614,-0.156728172597,0.15141213606,-0.253230660986,-0.19742818623,-0.536520230923,-0.303444659565,0.157479554371,0.151539912205,-0.0681498243033,0.0671210571998,0.30922291576,0.0444109482981,0.263323598322,-0.48180705332,-0.115341661568,-0.134059248668,-0.462830132893,-0.515678655698,-0.084921840861,-0.212742444988,-0.183767251882,-0.298466556438,-0.0194492371811,-0.00368207166493],[-38493.8085631,-2975.48171058,-2459.61688068,-1156.75065039,-1822.56768871,1161.34553476,460.962810916,-170.68975901,-539.066598826,-589.616757622,-741.127702363,-190.117158308,-390.423628501,857.111010886,268.993395038,273.913973326,-511.995255566,325.817261741,-138.055854498,-615.888346375,81.8635104331,559.006886397,-100.596730818,28.4398127107,5.38313933004,110.06538726,-71.8778944776,233.586934287,86.9759008261,109.574958644,118.944898125,-88.8308636412,-66.6858208359,-59.6372172055,63.9741249479,-46.5351320568,19.1474140548,38.0333398497,90.4048442112,37.3955818391,37.2107593303,-44.8624455937,-69.5662708764,-42.7042423628,-72.0697836376,47.7879936821,-8.18146167289,8.3630637747,-10.1195114226,2.80635807351,7.17457138831,31.0668981224,17.2290940113,-3.18793514099,-26.4083791006,-4.84462171112,-12.3393506428,-25.4972469724,7.99390521706,-13.506999286,-4.38003617415,0.362851693067,-3.51023755137,-2.11518020812,-2.09965950669,-2.44432323522,5.13196640819,3.0693221933,0.685482380275,-5.96323493801,1.46140924661,-0.415364058793,-6.59181235718,-0.454724471203,-7.22350870318,-1.04556035095,-3.8655204649,-3.9423755131,0.53036377256,-0.0807593217974,-0.0508342178003,-1.74745035149,-0.759954970891,0.77724165318,1.40135696493,-1.18349334196,-0.688064891073,0.515960496098,-0.65741957296,-0.125909368911,-1.10806258487,-1.53002776382,-0.841621362326,-1.95620955631,-2.01273067373,-0.233958686155,-0.22319951109,0.152006191475,-0.240606042496,-0.193843455397,-0.537438391888,-0.304480357622,0.153184233397,0.149244172257,-0.0702828936269,0.0625910833232,0.306795449744,0.0290959452113,0.268548388453,-0.478388036076,-0.11842964291,-0.130485877834,-0.468520789539,-0.52243051294,-0.0901333734541,-0.2319385397,-0.182272271292,-0.288433464329,-0.0169164024836,-0.00182810852724],[-38520.3807532,-2975.36965321,-2393.79278335,-1162.83129737,-1831.94487042,1144.73787638,427.59981531,-149.563902749,-536.372913893,-621.893708479,-714.074610752,-167.544267214,-394.479317999,856.814249699,280.387656948,278.991318818,-506.055922358,322.4629505,-119.737043825,-603.444500002,84.4336349802,551.183924328,-115.010782282,25.6912250234,6.00756198042,110.803636935,-72.1764288904,236.839276171,84.2254208064,110.708010515,117.874788323,-95.0765831643,-58.5704576322,-57.5138061398,65.6344111189,-45.723582978,18.9019427467,38.0734245679,90.9582256545,37.0649605852,37.405041217,-44.8090951075,-69.3768026486,-40.0377717629,-72.3447813941,47.2301594141,-8.84388607202,8.2579594497,-10.2656995002,2.526364663,7.46653273385,31.057774809,17.2837906313,-2.80667961779,-26.3209218809,-4.47011625919,-11.8433938727,-25.8254989701,7.95276198637,-13.7718913062,-4.18038723468,0.575711890987,-3.37310617598,-2.20687477124,-2.1882078764,-2.2584880964,5.17047633778,3.15560583413,0.742854331262,-5.93635221183,1.60933161098,-0.455795790849,-6.71742749603,-0.361684800063,-7.3957258583,-1.01213913431,-3.85034465222,-3.96193014577,0.530832548163,-0.18850731344,-0.06689263701,-1.74685412424,-0.73954112519,0.78507890426,1.42112265484,-1.17514044698,-0.695140700068,0.528589437146,-0.694749548768,-0.148166286934,-1.08336215943,-1.56036175635,-0.826072855836,-1.95325843994,-2.02937965531,-0.223686598644,-0.288360492177,0.151377379282,-0.226099803274,-0.189907083937,-0.536996620358,-0.304883574304,0.148488954317,0.145681240484,-0.0722867253299,0.0561903902983,0.303585884349,0.0135721117392,0.272089303468,-0.474591437916,-0.121933658506,-0.126747268984,-0.474031828414,-0.52845457434,-0.0943738814143,-0.250668824477,-0.180799908896,-0.277691777543,-0.0143982422619,-4.9081797152e-05],[-38554.3650979,-2971.71433757,-2326.90927306,-1168.84421909,-1839.33475746,1128.00379773,394.768402223,-126.728174755,-530.928833118,-652.729434741,-685.938427476,-146.046004261,-399.803405982,856.102796511,290.771887328,283.338185375,-500.047720764,319.240022197,-101.852237853,-590.540257583,86.5876190139,543.289127473,-130.020164362,23.4826428418,6.22949584514,111.309542155,-72.4612638201,240.070304657,81.849430508,111.49151163,116.95632242,-101.441718144,-50.6735067938,-54.7336792977,67.2507817415,-44.9843263262,18.5703642258,37.992738829,91.5461785396,36.8359307787,37.5147202911,-44.6529560179,-69.1973492753,-37.4398366214,-72.3519060512,46.6333360464,-9.51052478936,8.11894711477,-10.3960864123,2.2161206166,7.734962363,31.0460078248,17.3238675401,-2.44197509479,-26.196997898,-4.12134827301,-11.3476477875,-26.0929671414,7.89234232294,-14.0207610626,-4.00151670725,0.775770197416,-3.21655420409,-2.2814255058,-2.28042900102,-2.07409770445,5.20566750814,3.22451195126,0.795263432872,-5.90612057581,1.7452213854,-0.485359280206,-6.83848020413,-0.274236053318,-7.55458278883,-0.980438716595,-3.83514270071,-3.96966897618,0.534791627675,-0.292355891339,-0.078605748383,-1.74443592781,-0.719012893529,0.790598653618,1.43364105302,-1.16575596628,-0.705525547329,0.537899118898,-0.728002525894,-0.172916529825,-1.05932230445,-1.58835981961,-0.808705415959,-1.95001732947,-2.04273010896,-0.211185344544,-0.35169476505,0.149460601441,-0.209788951159,-0.185718095738,-0.535331461913,-0.304668828892,0.143438678532,0.140985198117,-0.0741074434431,0.0480956352513,0.299600571491,-0.00201573532005,0.273967051595,-0.470617225853,-0.125769989598,-0.122917216006,-0.479188049581,-0.533764264723,-0.0974855554758,-0.26880899374,-0.179364755062,-0.266329781383,-0.0119013417868,0.001648789604],[-38599.1418163,-2963.14774379,-2260.87930557,-1174.62275976,-1843.88026944,1111.2793692,361.950138256,-102.651165212,-522.554284249,-682.078065302,-656.583246584,-126.151573848,-406.850789171,854.776568396,299.982913808,286.949362765,-494.157323885,316.237373891,-84.6587969491,-577.355898745,88.1773967143,535.314849313,-145.610806529,21.6417622008,6.00067409608,111.542046377,-72.738178349,243.244613367,79.873000731,111.876868361,116.153943654,-107.90797122,-43.1751972903,-51.2884139903,68.7927187769,-44.3388830552,18.1542468756,37.7843056338,92.1719698836,36.7108864029,37.5286806853,-44.4156275045,-69.030804252,-34.9750708243,-72.0820282281,45.9903777329,-10.1758695185,7.93910959758,-10.5100472602,1.88050202878,7.97761667414,31.0341828164,17.3492221496,-2.0986827456,-26.040649445,-3.80280305808,-10.8648256327,-26.2967632498,7.80675545428,-14.2480060109,-3.85042272859,0.960239442529,-3.04081706217,-2.33758893662,-2.37542158454,-1.89165487453,5.2380134998,3.27527899202,0.842243169277,-5.87281074866,1.86761302963,-0.504958254106,-6.95394147368,-0.195478130403,-7.69719157152,-0.952558316526,-3.81978237505,-3.96519364654,0.542801169443,-0.391637566029,-0.0858687917517,-1.74036803348,-0.698453610468,0.793902519842,1.43892811306,-1.15528312161,-0.718966293062,0.543844521123,-0.756931209506,-0.19976022368,-1.03682477602,-1.61334208288,-0.789797704162,-1.94625833548,-2.05254275359,-0.196262678319,-0.412685978902,0.146190759917,-0.191750493991,-0.181375514686,-0.532579462128,-0.303850640666,0.138078367442,0.135290126389,-0.0756911719972,0.0384834753084,0.294845863088,-0.0175227791683,0.274202341062,-0.466665366898,-0.129854917432,-0.119069512788,-0.483814253103,-0.538373008915,-0.099310586373,-0.286234741912,-0.177981400159,-0.254435761151,-0.00943228632916,0.0032592867549],[-38656.8626354,-2948.73009867,-2197.07737494,-1180.05760712,-1844.98479483,1094.75651903,328.850846489,-77.7617999407,-511.176207778,-709.912513849,-625.948691595,-108.311470482,-415.979546332,852.6105706,307.859101364,289.805791026,-488.553798781,313.513524559,-68.4005743426,-564.054997517,89.0554031182,527.259820068,-161.753136564,20.0462140765,5.28582100832,111.465838188,-73.0128001414,246.31747071,78.3141495019,111.809951952,115.439296206,-114.459853107,-36.2278762405,-47.1772465429,70.2272855469,-43.8030751364,17.6546702766,37.4431445907,92.8366397163,36.6888628917,37.4343645755,-44.1158333473,-68.8811967508,-32.701520133,-71.5291743993,45.292228692,-10.8351497588,7.71219427937,-10.6066065295,1.5242486237,8.19285326961,31.0250293785,17.3592086969,-1.78170373266,-25.8557602169,-3.51867574906,-10.4072671001,-26.4345996016,7.69006331145,-14.4489893604,-3.73333571396,1.12669478397,-2.84617183054,-2.37439589529,-2.47222796195,-1.71156701775,5.26820120382,3.30725557009,0.883348732953,-5.83667554433,1.97518415231,-0.515861633898,-7.06289811692,-0.128406126736,-7.82113116443,-0.930477286211,-3.80404658401,-3.94824757474,0.555253747443,-0.485701448323,-0.0886504261584,-1.73480978054,-0.677909486154,0.795142961174,1.43705946387,-1.14367431591,-0.735227205202,0.546409432082,-0.781385221455,-0.228324355193,-1.01669332168,-1.63470789405,-0.769654230885,-1.94174613141,-2.05864376065,-0.178784253528,-0.470853817612,0.141543531402,-0.172082872342,-0.176975435352,-0.528876472867,-0.30244338844,0.132454079767,0.128721247624,-0.0769854023327,0.0275282988879,0.289334251485,-0.0327982320637,0.272822726781,-0.462929411408,-0.134105149221,-0.115283508725,-0.487753158781,-0.542298851434,-0.0997140441563,-0.302833131205,-0.17665300078,-0.242102715567,-0.0070005950098,0.00477238360166],[-38724.765311,-2929.23461551,-2134.72412817,-1185.268823,-1843.09359772,1078.85060699,296.073375923,-52.3303473113,-497.149595178,-736.280833249,-594.27650392,-92.6613490938,-427.160484405,849.280161063,314.244964382,291.833011282,-483.335788355,311.005480848,-53.2673947136,-550.734305529,89.0760766887,519.148276926,-178.355575513,18.7733692102,4.10162526986,111.068586692,-73.2901511894,249.206844231,77.1626837509,111.214493126,114.812828007,-121.0931068,-29.8723633595,-42.4300493354,71.5118708156,-43.3699286104,17.0707587958,36.9722617382,93.5323201182,36.7554614797,37.21344631,-43.7607957291,-68.7570986494,-30.6508778119,-70.6999944578,44.5221933991,-11.4865462336,7.43460675556,-10.6833862429,1.15155464423,8.3814345674,31.0218528972,17.3510087204,-1.49609917398,-25.6455795159,-3.27200079724,-9.98581766745,-26.5065906751,7.53613863964,-14.6229373326,-3.65341519265,1.27416068925,-2.63306220517,-2.39197444054,-2.56966499233,-1.5338599291,5.29777075351,3.32023096455,0.918222149582,-5.7978961577,2.06718495762,-0.520799117346,-7.16490022633,-0.0755959216615,-7.92584805077,-0.915695511364,-3.7873788126,-3.91914128144,0.571871598168,-0.573963050145,-0.087212987485,-1.72786878036,-0.657278233063,0.794675794488,1.4283494356,-1.13091867692,-0.754142182603,0.545692873982,-0.801601850319,-0.258343353452,-0.999519654927,-1.65217347557,-0.748682902438,-1.93621564218,-2.06112111188,-0.158847320116,-0.525862103805,0.135657691512,-0.150970257728,-0.172602235049,-0.52435557113,-0.300460889166,0.126616263502,0.121368348518,-0.0779430950285,0.0153954195781,0.283102790747,-0.0476674224891,0.2698831504,-0.459577243123,-0.138439096067,-0.111660775237,-0.490919165368,-0.545578315579,-0.0986525161406,-0.318536694984,-0.175336978422,-0.229442497024,-0.00462752234875,0.00616282556029],[-38798.8591067,-2905.86275424,-2072.50175055,-1190.43381279,-1838.91241108,1064.03285072,264.444832041,-26.5874113309,-480.936450667,-761.249861166,-561.883954439,-79.2581547227,-440.267592373,844.435785895,318.986554598,292.942714932,-478.58432947,308.619871325,-39.4355756043,-537.473868812,88.0943567456,511.010833817,-195.311042734,17.9505332844,2.47776667192,110.343706119,-73.5751020673,251.821376261,76.4013576343,110.00868748,114.282187929,-127.806283369,-24.1215965116,-37.084353762,72.6014447077,-43.0267705354,16.4011479967,36.3766597221,94.2489161825,36.8929248521,36.8461582805,-43.3548614331,-68.6682175018,-28.8482490011,-69.6042941517,43.661666394,-12.1289774719,7.10341717513,-10.7376578071,0.766477962909,8.54472418947,31.028102707,17.3212605836,-1.24697017643,-25.4131980462,-3.06552248304,-9.61094925905,-26.5134514913,7.33880688761,-14.7700419021,-3.61305297245,1.40202395337,-2.40197353592,-2.3907269379,-2.6664931658,-1.35846399954,5.32847559274,3.31410462079,0.946527153147,-5.75663587889,2.14300879865,-0.522865596319,-7.25961371446,-0.0395185905103,-8.01125559506,-0.909593011104,-3.76913768989,-3.87832706296,0.592209373736,-0.655854483696,-0.0818922308239,-1.71963971231,-0.636420439255,0.792907676313,1.41317203369,-1.1170145136,-0.775562531851,0.541822677518,-0.817915301356,-0.289578508144,-0.985837480704,-1.66553426854,-0.727317474098,-1.92939435555,-2.06012824154,-0.136607027125,-0.577410694791,0.128712790593,-0.1286182544,-0.168337361775,-0.519149140205,-0.297916819332,0.12061646396,0.113312356857,-0.0785185779734,0.0022478822598,0.276194675369,-0.0619497079836,0.265445400247,-0.456770329128,-0.14277559504,-0.108308439252,-0.493244591355,-0.548252544341,-0.0961054689567,-0.333289334406,-0.173979320807,-0.216571671331,-0.00233725671592,0.00740155091423],[-38875.1532859,-2879.81597481,-2009.09242735,-1195.72998186,-1833.14696788,1050.77446787,234.792320326,-0.763596007057,-462.998778465,-784.886435263,-529.088314032,-68.1588324063,-455.174859221,837.72789121,321.929923748,293.046593372,-474.380458988,306.263324553,-27.0814345571,-524.353733396,85.9651826086,502.878104672,-212.512457587,17.7050119816,0.443925005694,109.2846107,-73.8725233492,254.069709128,76.0129253086,108.110730608,113.855024842,-134.597933882,-18.9885135608,-31.1776912166,73.450977348,-42.7609279695,15.6444734429,35.6613411886,94.9763330024,37.083495694,36.3127328786,-42.9023772426,-68.624260862,-27.3187388408,-68.2518792288,42.6920422165,-12.7613620029,6.71569568704,-10.7666926291,0.373076452283,8.68408575775,31.0472281419,17.2666026503,-1.03941784688,-25.1617065117,-2.90198508689,-9.29313379916,-26.4558970713,7.09189350411,-14.8904950437,-3.61464086117,1.50967137131,-2.15339117266,-2.37105575288,-2.76147297247,-1.18530962004,5.36206916538,3.28877598424,0.967927477629,-5.71305799802,2.20204902848,-0.525155962687,-7.34670449386,-0.0226452086108,-8.07726716183,-0.913549804547,-3.74868184494,-3.82625721564,0.615821726268,-0.730807861177,-0.0730239112669,-1.71021725578,-0.615196692791,0.790245263178,1.39190126361,-1.10196013489,-0.799339559531,0.534926673384,-0.830659779826,-0.321791108959,-0.976180503971,-1.67458571405,-0.705991701145,-1.9210097593,-2.05581858393,-0.112218523594,-0.625199447882,0.120888378991,-0.105232466608,-0.164262263527,-0.513389563378,-0.294824855423,0.114506226457,0.10463420043,-0.0786661790562,-0.0117512681865,0.268653099848,-0.0754644460865,0.259571264654,-0.454670136506,-0.147033483212,-0.105333627698,-0.494661755236,-0.550362680712,-0.0920523692356,-0.347034950628,-0.172526015657,-0.203606804299,-0.000153986481223,0.00845949794693],[-38949.657112,-2852.29573714,-1943.17834384,-1201.33473559,-1826.50300109,1039.5466761,207.942946261,24.9104946531,-443.79858279,-807.257393203,-496.20685358,-59.4203271828,-471.75627393,828.806923119,322.921123568,292.056338,-470.805213771,303.842469099,-16.3812891146,-511.453945312,82.5434935977,494.780703421,-229.852739431,18.1641109841,-1.97021993758,107.884714667,-74.1872856094,255.860485163,75.98014093,105.438818106,113.538987618,-141.466609407,-14.4860523715,-24.7475930932,74.0154388611,-42.5597279708,14.7993706982,34.8313087837,95.704475671,37.3094166904,35.5934024957,-42.4076899408,-68.6349362842,-26.0874524709,-66.6525554373,41.5947154065,-13.3826183557,6.26851244026,-10.7677621155,-0.0245920151035,8.80088289417,31.0826785362,17.1836732838,-0.87854329221,-24.8941956167,-2.78413288922,-9.04284321205,-26.334642436,6.78922393789,-14.984488732,-3.66057066662,1.59648973806,-1.88780046524,-2.33336325099,-2.85336490245,-1.01432718154,5.40030491529,3.2441445003,0.982086857012,-5.66732580522,2.24369900017,-0.530765108318,-7.42583847707,-0.0274468512921,-8.12379611558,-0.928945910812,-3.72536990683,-3.7633840358,0.642263307882,-0.798255294788,-0.0609437839062,-1.69969609016,-0.59346758173,0.787095211611,1.36491113081,-1.08575384972,-0.825324572229,0.525132692276,-0.840169490988,-0.354742445582,-0.971082429688,-1.67912325318,-0.685139338857,-1.91078934121,-2.04834557332,-0.0858369585652,-0.668928220389,0.112364007052,-0.0810184986034,-0.160458388303,-0.507209223935,-0.291198673927,0.108337096305,0.0954148070241,-0.0783402261656,-0.0264389868802,0.260521258677,-0.0880309943369,0.25232253195,-0.453438132342,-0.151131597655,-0.102843467503,-0.495102975501,-0.551949867683,-0.0864726836084,-0.359717444804,-0.170923050692,-0.190664461737,0.00189809998544,0.00930760494184],[-39019.0185355,-2824.14552824,-1873.67075466,-1207.31976405,-1819.44549251,1030.73764493,184.491276505,50.1179054963,-423.731139203,-828.390126498,-463.465827129,-53.046911534,-489.886386766,817.436412318,321.856976493,289.902963841,-467.909628854,301.297805665,-7.47091962467,-498.857842512,77.7315356829,486.742984373,-247.230699943,19.4479395839,-4.73379239216,106.14414885,-74.521903243,257.116654556,76.2828246299,101.935652403,113.341581554,-148.400376255,-10.614394728,-17.8286797326,74.2612248364,-42.4100185099,13.865842428,33.8925145067,96.4238586146,37.5563900803,34.6727400876,-41.8740498561,-68.7057505928,-25.1721875085,-64.8163271364,40.3565733686,-13.9934206625,5.75990396287,-10.7385708103,-0.423019394649,8.89642456203,31.1371071666,17.0699863754,-0.768715504023,-24.6133213585,-2.71299176722,-8.86839686792,-26.1500893731,6.42656621695,-15.0526461771,-3.75228984993,1.66197318477,-1.60557425753,-2.27827739871,-2.94111666376,-0.845486905573,5.44455881658,3.18035029767,0.988630939912,-5.61942996749,2.26773120031,-0.542371868051,-7.49664907747,-0.0556389715869,-8.15093947647,-0.95660654802,-3.69871328957,-3.68998926201,0.671130164587,-0.857815204806,-0.0460105375688,-1.68819484411,-0.571140223611,0.783799777408,1.33260652906,-1.06847310954,-0.853309636525,0.5125486618,-0.846763622603,-0.38822768358,-0.970914839495,-1.67897291256,-0.665052716183,-1.89852417579,-2.03781736585,-0.0576190867286,-0.708377723147,0.103272435705,-0.0561742783382,-0.157003145479,-0.500735476445,-0.287076238736,0.102151495835,0.085730802188,-0.077519158904,-0.0416644551513,0.251830913752,-0.0994926613531,0.243768363931,-0.453198696691,-0.154984752984,-0.100895676722,-0.494520686175,-0.553033893541,-0.0793721574489,-0.371284307625,-0.169141141859,-0.177849111193,0.00379878454088,0.00991394235404],[-39082.4402554,-2794.77694332,-1800.39719191,-1213.33389604,-1811.47641926,1024.40335148,164.101722419,74.1962767854,-402.924808628,-848.154242049,-430.727421381,-48.8321677166,-509.441993111,803.832227836,318.837387751,286.594780437,-465.624731954,298.705323509,-0.323957657718,-486.661930638,71.6207814356,478.764263356,-264.568720068,21.6478215111,-7.81113269409,104.089910482,-74.8694659297,257.818398945,76.88906044,97.6419632599,113.269737667,-155.345361695,-7.32269809614,-10.4439272635,74.2004327221,-42.2967312075,12.8493597061,32.8547077711,97.127433592,37.8239563169,33.5526808655,-41.300321497,-68.8254076944,-24.5615114778,-62.7539931318,38.9864749681,-14.6014654683,5.19177229939,-10.6785558051,-0.820896953513,8.97180109014,31.2099830789,16.9265579258,-0.711375012884,-24.3200009084,-2.68271398516,-8.76950392057,-25.9013867364,6.00745868633,-15.0973155308,-3.88746848556,1.70604518725,-1.30663536938,-2.20732856625,-3.02442483598,-0.678918335863,5.49469696427,3.09849623827,0.987033033485,-5.56867065941,2.27543464941,-0.560990848597,-7.55863971172,-0.105914533343,-8.15952888713,-0.995137730306,-3.66883454699,-3.60567240171,0.702183917938,-0.909851243803,-0.0286745960207,-1.67592794348,-0.548307853872,0.780443613425,1.29551590543,-1.05051193574,-0.88284985899,0.497202897214,-0.850701292443,-0.422177492025,-0.975400821771,-1.67408306085,-0.64545845675,-1.88425968449,-2.02416100492,-0.0277280853701,-0.743652081095,0.0935592682129,-0.0308670285701,-0.153957789945,-0.494075560592,-0.282592663379,0.0959553554363,0.0756416025169,-0.0762778637293,-0.057325759173,0.242568096569,-0.10978856007,0.234007416259,-0.453927861482,-0.15849167399,-0.0993503379174,-0.492947783407,-0.55354912775,-0.0708616511027,-0.381697387906,-0.167249918001,-0.165216827174,0.00554372994874,0.0102351093251],[-39139.7636578,-2763.24360464,-1723.41425705,-1218.92024507,-1801.8570073,1020.51672475,146.20615654,96.3968976374,-381.441223332,-866.379900604,-397.762806202,-46.5170054309,-530.30044963,788.323323286,314.013033268,282.159420962,-463.851548959,296.174884025,5.12650241028,-474.966007252,64.3500100776,470.837596577,-281.795073069,24.8478841048,-11.1653852049,101.755713394,-75.2207071701,257.960207829,77.7639983667,92.622987271,113.330243399,-162.23720824,-4.54736386213,-2.61340076124,73.8565854312,-42.2043185967,11.756760708,31.7285873436,97.8087616949,38.1151154074,32.2395006048,-40.684272917,-68.9784107658,-24.23668438,-60.4765508407,37.4987719349,-15.2162049211,4.56698587344,-10.5875873284,-1.2174657868,9.02804814863,31.2999792615,16.7552794635,-0.707230234093,-24.0147167308,-2.68573340411,-8.74372096972,-25.5873701459,5.53738227034,-15.1212761802,-4.06283230132,1.72873655747,-0.990794114622,-2.1222727248,-3.10317321664,-0.514790846705,5.55020798363,2.99992586729,0.976728359519,-5.51417543241,2.26847750147,-0.587220599636,-7.6112812973,-0.176210878114,-8.15057964585,-1.04259067081,-3.63600901787,-3.50986240458,0.735227583379,-0.954913372426,-0.00940931676324,-1.66313376341,-0.525110237434,0.777046971782,1.25419859531,-1.03234349223,-0.913441106189,0.479103810689,-0.85222660078,-0.456556415867,-0.984101341579,-1.66443265225,-0.625941757855,-1.86810487547,-2.00725825582,0.00367126257529,-0.774936272696,0.0831233184209,-0.00525629575845,-0.151379537965,-0.487331687343,-0.277907348789,0.0897454825137,0.0652023223674,-0.0747153388127,-0.0733332113295,0.232707406025,-0.118881754502,0.223145718058,-0.455564571615,-0.161547063007,-0.0980181247813,-0.490437278879,-0.553408585071,-0.0610783036585,-0.390922123997,-0.165343736187,-0.152811585923,0.00713256919942,0.0102248371682],[-39190.8301287,-2728.59913446,-1642.77855153,-1223.62192464,-1789.84848258,1019.05069374,130.236451407,115.971057169,-359.342015581,-882.897262914,-364.343151458,-45.8423343772,-552.339112986,771.238652283,307.534588971,276.624518587,-462.49110576,293.816348607,8.94736620334,-463.869869917,56.0580008304,462.956040243,-298.838032211,29.1322547046,-14.7596942861,99.1752714161,-75.5663604646,257.536570706,78.8727884169,86.943961031,113.529886195,-169.011558401,-2.22479341208,5.64283469863,73.2532058765,-42.1172332109,10.5948836094,30.524851991,98.4614040153,38.4328673586,30.7394750809,-40.0236721697,-69.149262984,-24.1789662163,-57.9949976801,35.9078159992,-15.847091169,3.88841310865,-10.4655356088,-1.6119669896,9.06620140767,31.4057687026,16.5580425167,-0.75698958295,-23.6979512904,-2.71448388509,-8.78860461512,-25.206875222,5.02181789328,-15.1273075126,-4.27510702502,1.73007810741,-0.657860807113,-2.02486584554,-3.17724560321,-0.353273812392,5.61058049992,2.88598272991,0.957152139804,-5.45507183795,2.2485279105,-0.621659670851,-7.65404475169,-0.26446534745,-8.1251070509,-1.09701658268,-3.600512041,-3.4019882203,0.770064176352,-0.993551551321,0.0113119427027,-1.65005067902,-0.501687139213,0.773630104603,1.20921393409,-1.01444094289,-0.944579244688,0.458259814395,-0.851583647888,-0.491329000058,-0.996577363983,-1.65000064094,-0.606087816796,-1.85016875694,-1.98699088381,0.0364141741724,-0.802415276413,0.0718634001746,0.0204983736375,-0.149325605808,-0.480606067666,-0.273179695902,0.0835186844724,0.054468076096,-0.0729305823258,-0.0895971240047,0.222223441017,-0.126735308662,0.211289298456,-0.458047771988,-0.164045622372,-0.0967097110044,-0.487042184272,-0.552525280263,-0.0501592542049,-0.398923954247,-0.163516953482,-0.140677363685,0.00856493528328,0.00983685719655],[-39235.4810543,-2689.89715506,-1558.54667683,-1226.98204823,-1774.71207106,1019.97818745,115.624479557,132.170044497,-336.688817641,-897.536489727,-330.239627016,-46.549064256,-575.435339842,752.907168438,299.552730788,270.017706482,-461.444428244,291.739578651,11.2055393455,-453.473316197,46.8835329158,455.112650562,-315.625870754,34.5850606499,-18.5572042991,96.3822983808,-75.897159314,256.541977075,80.1805805971,80.6701211344,113.875453496,-175.604054691,-0.291388132137,14.3047140407,72.4138169709,-42.0199275831,9.37056658596,29.2542004801,99.078921645,38.7802121777,29.058880069,-39.3162873086,-69.322467526,-24.3696169877,-55.320331067,34.227958891,-16.5035763601,3.15892242863,-10.3122708749,-2.00364165703,9.08729653741,31.5260243905,16.3367386139,-0.861361474755,-23.3701870517,-2.76139928915,-8.90171145649,-24.758737585,4.46624647944,-15.118188915,-4.52101838445,1.71010064905,-0.307645760695,-1.91686389964,-3.24652579321,-0.194536607217,5.6753031384,2.75801037135,0.927739596129,-5.39048742748,2.2172540305,-0.664906611921,-7.68640099239,-0.368615282904,-8.08412640056,-1.15646667905,-3.56261895515,-3.28147879854,0.806496712301,-1.02631574114,0.033015824876,-1.63691706546,-0.478178324128,0.770213264007,1.16112125715,-0.997277451608,-0.975760141051,0.434679320502,-0.849016534039,-0.526459789548,-1.01238985405,-1.63076598112,-0.58548183087,-1.83056033706,-1.96324065414,0.0703358664861,-0.826274070709,0.0596783273193,0.0462374331586,-0.147853209739,-0.474000912525,-0.268569105651,0.0772717687175,0.0434939780593,-0.0710225924401,-0.106027809583,0.211090800441,-0.133312286565,0.198544186579,-0.461316407502,-0.165882054419,-0.0952357702775,-0.482815511269,-0.550812228086,-0.0382416418305,-0.405668317005,-0.161863926956,-0.128858136702,0.00984046119071,0.00902490072332],[-39273.7702119,-2646.65553277,-1471.04799328,-1228.63865479,-1756.00402794,1023.27761678,101.983617689,144.53845987,-313.601275105,-910.166106808,-295.241487078,-48.3065076978,-599.52274092,733.605462838,290.168061464,262.402914651,-460.598641,290.052692026,11.9880124829,-443.875135534,36.9530187201,447.291837614,-332.063495601,41.294244284,-22.5120732536,93.409139369,-76.206058007,254.974460526,81.6442770687,73.8737734687,114.369488638,-181.948363237,1.32368050195,23.3489595487,71.3569797502,-41.897056815,8.09010416366,27.9256168425,99.6543836109,39.1568447725,27.2081411457,-38.5595777887,-69.48091554,-24.787931713,-52.4633812264,32.4718978278,-17.1953423993,2.38360013061,-10.1278161916,-2.39179771345,9.09187666995,31.6586657774,16.0938472328,-1.01989739452,-23.031348436,-2.81901455019,-9.08017151633,-24.2420908349,3.87592650328,-15.0968384665,-4.79632634797,1.66923590395,0.0597024618773,-1.80013005913,-3.31096104431,-0.0386397547207,5.7436175887,2.61760930064,0.888175123304,-5.31959884641,2.17643866141,-0.717479462346,-7.70767249996,-0.486404137024,-8.02875156536,-1.21879015976,-3.52255546659,-3.14795399993,0.844223537177,-1.05373072715,0.0552241472225,-1.6239248519,-0.454680515257,0.766773861064,1.11052108076,-0.981307033291,-1.00649394979,0.40845267561,-0.844743779873,-0.561826836546,-1.03102925942,-1.60670044002,-0.56364597195,-1.80938570124,-1.93587034856,0.105222271996,-0.846707584164,0.0465104364665,0.0718136391988,-0.147005676315,-0.467607155268,-0.264218659069,0.0709853017973,0.0323403484904,-0.0690942381391,-0.122526540992,0.199295408087,-0.138575903719,0.185033013177,-0.465292261357,-0.166953934154,-0.0933928367022,-0.477824509363,-0.548176213463,-0.0254792333785,-0.411131242903,-0.160466205653,-0.117385929417,0.0109505793657,0.0077436809478],[-39306.6009439,-2600.24911024,-1381.70289676,-1228.60948499,-1734.46072547,1028.94932013,89.6532591557,153.79414806,-290.431086863,-920.808099981,-259.210323188,-50.4975890537,-624.759943171,713.400676458,279.280891026,253.989260413,-459.785263416,288.856832499,11.4621163499,-435.170084894,26.3434032879,439.443426974,-347.962348199,49.3630079666,-26.5425137507,90.2826644614,-76.4948939851,252.846231015,83.1877886115,66.6555010933,114.997558516,-187.970244636,2.72016065594,32.7394429438,70.0814077416,-41.7340862819,6.75761627023,26.5412261687,100.17889068,39.5492396537,25.2142830914,-37.7497686699,-69.6010500598,-25.4053454807,-49.4343096135,30.6457119758,-17.9329902195,1.57640400622,-9.91280596821,-2.77601040037,9.07851478515,31.7985981701,15.8341996485,-1.22752110613,-22.6791276921,-2.8802688935,-9.31940850826,-23.6572604916,3.2552266399,-15.0667290136,-5.09292784619,1.60951923212,0.442682302208,-1.67695629946,-3.37075245488,0.114791624553,5.81377779796,2.46740788223,0.839139808212,-5.24177911599,2.12832318693,-0.779574220896,-7.71658800726,-0.61479980634,-7.96049070486,-1.28102817146,-3.48034875149,-3.00179732891,0.882524318962,-1.07622059317,0.0774394270752,-1.61108018365,-0.431118268331,0.763117942627,1.05817864458,-0.966907106858,-1.03634797716,0.379997964043,-0.838881587485,-0.596962222292,-1.0517039581,-1.57774703712,-0.539850310212,-1.7867392438,-1.9046668147,0.140662184841,-0.863950545835,0.032476155291,0.0971289595651,-0.146770773244,-0.461470618759,-0.260206157569,0.0645748868323,0.0210883311294,-0.0672638716552,-0.138958433339,0.186868487323,-0.142489981605,0.170944815499,-0.469828469966,-0.167170327266,-0.0909208860216,-0.472193379301,-0.544499101965,-0.0120923067108,-0.415331131698,-0.159354106529,-0.106244959062,0.0118539200665,0.00595183861364],[-39335.0889839,-2552.51697419,-1292.20454202,-1227.00720491,-1711.11356515,1036.9991178,79.15430147,160.948264971,-267.58796513,-929.522820089,-222.025811223,-52.4336356053,-651.361827605,692.307587745,266.74145632,245.022157921,-458.82191358,288.251400312,9.81526670326,-427.451913119,15.1192648284,431.508598089,-363.110503634,58.8983690613,-30.5577520398,87.028374988,-76.767725478,250.173042588,84.7267781603,59.1229563604,115.740985915,-193.593483103,4.00503040598,42.4368233065,68.5808525948,-41.5166839276,5.37667918378,25.101438814,100.643051555,39.9405662331,23.1084804881,-36.8827764137,-69.6577020904,-26.1913283969,-46.2431104914,28.7538259887,-18.72735051,0.753509720663,-9.66802745064,-3.15592178854,9.04529132482,31.9399733397,15.5632150857,-1.47799944316,-22.3106590254,-2.93820261725,-9.6144195687,-23.0048700548,2.60829311457,-15.0314720949,-5.40175405029,1.53338690314,0.83945395299,-1.54974179692,-3.42616458347,0.266241260812,5.88379077768,2.3102914444,0.78156391076,-5.15645035142,2.0752636367,-0.85130637616,-7.71172781024,-0.75057629838,-7.88095055091,-1.34001984749,-3.43597635352,-2.84358320088,0.920574056144,-1.09418424763,0.099159356734,-1.59834276008,-0.407373097238,0.759008714494,1.00490036918,-0.954435942234,-1.06490381739,0.349815204556,-0.831520579338,-0.631311535285,-1.07355181067,-1.5438416049,-0.513301890408,-1.76271243625,-1.86939791669,0.176195114572,-0.878247634894,0.0177354342334,0.122097664918,-0.147122378526,-0.455625848243,-0.256593082662,0.0579398860863,0.00982427559315,-0.0656537160329,-0.155179562275,0.173852586412,-0.145018493198,0.156485232416,-0.474761008041,-0.166443172115,-0.0875457543896,-0.466060559642,-0.539656529326,0.00168223255609,-0.418296975429,-0.158545138516,-0.0954074910651,0.0125009130051,0.00360899635059],[-39360.3500655,-2505.29821133,-1204.24608381,-1223.94448068,-1686.99394848,1047.4328301,71.0076421458,167.011966506,-245.481622123,-936.370617972,-183.567627064,-53.4259746339,-679.543275231,670.340975148,252.399994192,235.747021324,-457.526209577,288.335795705,7.23487929944,-420.814369056,3.34518155091,423.428530408,-377.296036991,70.0073449318,-34.4670143702,83.6717722794,-77.0286107153,246.970649293,86.1769086495,51.3837916223,116.581093623,-198.74186285,5.28526782822,52.4017597173,66.8490659601,-41.2305176958,3.95086918244,23.6066651337,101.037474939,40.3139939221,20.9219079175,-35.9545174816,-69.6257026368,-27.1153505677,-42.8997781231,26.8006645199,-19.5892539605,-0.0689070608288,-9.39426788457,-3.53117394873,8.99028673078,32.0769430568,15.2863127689,-1.76509923922,-21.9230766413,-2.98585601958,-9.96020183404,-22.2855430242,1.93927215254,-14.9946792487,-5.71373613141,1.44327518661,1.24817760692,-1.4208857278,-3.47746198863,0.416192884264,5.95166353937,2.14914531546,0.716377690852,-5.06303466789,2.01961604035,-0.932791416729,-7.69167220486,-0.890507620669,-7.79173783532,-1.3926043212,-3.38941581636,-2.67388603123,0.957547747213,-1.10802059897,0.119881628499,-1.58567228055,-0.38332651587,0.754209382467,0.951492675105,-0.944251809345,-1.09174306468,0.318404415903,-0.822751377893,-0.664320364026,-1.09571067773,-1.50491997588,-0.483207757292,-1.73739675012,-1.82983151863,0.211360570744,-0.889843530514,0.00244822373446,0.146634025918,-0.148034370159,-0.450107388966,-0.253440915859,0.050979661823,-0.0013654685016,-0.0643859943165,-0.17104600345,0.160290253615,-0.146125411475,0.1418599028,-0.479925850297,-0.16468440706,-0.0829932779599,-0.459564488944,-0.533524131281,0.0156074788056,-0.420057766135,-0.158056810548,-0.0848457908567,0.0128419878935,0.000674776788395],[-39383.4999224,-2460.43190838,-1119.52067689,-1219.53397838,-1663.13327696,1060.25627731,65.7341786969,172.996408569,-224.521770056,-941.411844471,-143.715446588,-52.7859334211,-709.519167058,647.515617114,236.106741487,226.409264773,-455.715769497,289.209418922,3.90836989505,-415.351201548,-8.91426833542,415.144403377,-390.307023357,82.7969529415,-38.1795269912,80.2383576657,-77.2816079269,243.254805176,87.4538430137,43.5456592315,117.499204425,-203.339168091,6.66785099881,62.5949112565,64.8797994872,-40.8612555303,2.48376254433,22.057315483,101.352769533,40.6526921325,18.6857399613,-34.960908335,-69.4798827041,-28.1468820991,-39.4143067718,24.7906522232,-20.5295312606,-0.874670673038,-9.09231451575,-3.90140895172,8.91158144482,32.2036590923,15.0089119226,-2.08258732788,-21.5135147454,-3.01626939865,-10.3517524407,-21.4999028995,1.25230997908,-14.9599620134,-6.01980526074,1.34162035214,1.66701345669,-1.29278726841,-3.5249092289,0.565130225114,6.01540309452,1.98685482368,0.644511408393,-4.96095418062,1.96373642752,-1.02414483119,-7.65500148705,-1.03136778074,-7.69445928993,-1.43562072593,-3.34064468365,-2.49328023535,0.992620390658,-1.11812855564,0.13910393467,-1.57302844442,-0.358860038116,0.748483152344,0.898761982895,-0.936712978119,-1.11644731324,0.286265616837,-0.81266460561,-0.695434297012,-1.11731841984,-1.46091798256,-0.448774955615,-1.71088365695,-1.78573548464,0.245698062909,-0.898982911869,-0.0132255257651,0.170652313225,-0.149480626142,-0.444949786172,-0.25081113867,0.0435935763061,-0.0123945515381,-0.0635829295506,-0.186413832517,0.146224037195,-0.14577470941,0.127274465523,-0.485158971448,-0.161805970463,-0.0769892928862,-0.452843605766,-0.525977543563,0.0294465264211,-0.420642495855,-0.157906631558,-0.0745321238659,0.0128275744436,-0.00289119744321],[-39405.4144666,-2419.23652893,-1039.0599577,-1213.91913836,-1640.24330631,1075.41453458,63.6878054292,179.638073415,-205.050274468,-944.68645727,-102.418438901,-49.9630412325,-741.416726884,623.829613798,217.798605681,217.217557167,-453.230837592,290.940103736,-0.00853006167603,-411.116680202,-21.6055159215,406.615425096,-401.941279553,97.3258804737,-41.6150019968,76.7522209677,-77.5286714522,239.040348959,88.4889023455,35.7041836592,118.480374571,-207.318517225,8.24497359285,72.9638229671,62.669101422,-40.397699945,0.979011042233,20.4544380593,101.580744287,40.9410917082,16.4278415216,-33.9001049912,-69.2011319421,-29.2570962962,-35.8036480163,22.7285509641,-21.5528375547,-1.64769072303,-8.76323431428,-4.26641282421,8.80794901984,32.3145967021,14.7351962696,-2.42511816323,-21.0797355653,-3.02423233619,-10.7836225635,-20.6500530208,0.551555538388,-14.9288149789,-6.31171613533,1.23074596007,2.09346996435,-1.1675554883,-3.56889099537,0.713387006658,6.07318377762,1.82585403891,0.566845384032,-4.84954196727,1.90964834806,-1.12513327149,-7.60060411042,-1.17019513119,-7.59035525828,-1.4665030073,-3.28972007119,-2.30263599751,1.02503659746,-1.12475294152,0.156404521945,-1.56040505657,-0.333884589994,0.741587438799,0.847420395031,-0.932096124008,-1.13856952799,0.253859091302,-0.801307885833,-0.724102597874,-1.13757619394,-1.41178908916,-0.40942692807,-1.68325335349,-1.73702017022,0.278787592102,-0.905868015725,-0.0290980795524,0.194030825817,-0.15142624801,-0.440186350323,-0.248754001688,0.035685304084,-0.0231844302168,-0.0633456079223,-0.201143957584,0.131705490236,-0.143939835176,0.112926724628,-0.490297360789,-0.157741067605,-0.0693260334586,-0.446016335602,-0.516925870271,0.0429774299416,-0.420078153713,-0.158091997969,-0.0644573585382,0.0124106398595,-0.00710373222935],[-39426.0103235,-2380.94804409,-961.249489477,-1207.36649795,-1617.75720925,1092.60969636,64.5544038171,186.574748703,-187.137614177,-946.152841433,-59.9037460117,-44.9596352708,-775.012549665,599.214352183,197.759176765,208.233586387,-450.002162784,293.469418061,-4.48682635583,-408.007157676,-34.7190294988,397.872918259,-412.035589351,113.459494989,-44.7350948599,73.2318059678,-77.7633400715,234.338458069,89.2760403685,27.9068778539,119.524594169,-210.650365383,10.0496916814,83.4035837418,60.2222063937,-39.8411917345,-0.559431572385,18.8016324273,101.718009147,41.1686692237,14.1628387822,-32.7792216913,-68.7945745805,-30.4239792605,-32.1125826988,20.6204714565,-22.6391258064,-2.37221790702,-8.40921314784,-4.62654741679,8.68093545307,32.4055250827,14.4644075246,-2.79089668128,-20.6220134175,-3.01153154828,-11.2485795314,-19.74401609,-0.158831349551,-14.8942649403,-6.58451755573,1.1125247338,2.52244866944,-1.04613903016,-3.61027250915,0.860696924529,6.12384921514,1.66677199722,0.4840601814,-4.72777495534,1.85804543278,-1.23412804296,-7.5286011592,-1.30508540498,-7.47920053081,-1.48506436006,-3.23701738319,-2.10400657739,1.05431942855,-1.12752224234,0.171683854618,-1.54793234408,-0.30842874602,0.733256492007,0.797802741722,-0.930351544573,-1.15754815664,0.221486183993,-0.788556845419,-0.74978923076,-1.15593834221,-1.35755728669,-0.365452709119,-1.65454093743,-1.68416589635,0.310371125288,-0.91053130923,-0.044870565825,0.216503975935,-0.15380123145,-0.435845452751,-0.247274831833,0.0271757688431,-0.0336877865071,-0.0636905681889,-0.215116616591,0.116822185117,-0.140632137729,0.0989831448364,-0.495182065949,-0.152507971463,-0.0600613265114,-0.439121051679,-0.506412088959,0.0560380845276,-0.418383717163,-0.158529856171,-0.0546867753841,0.0115543013145,-0.0118753475146],[-39444.9642966,-2344.28180182,-883.813317134,-1200.17336871,-1594.78851271,1111.48311197,67.8528521274,193.169548444,-170.786421326,-945.748988863,-16.468003154,-37.9162547229,-809.995573146,573.584540958,176.358715358,199.482295065,-445.98312016,296.707363342,-9.52920908083,-405.879507391,-48.256286659,388.966234212,-420.436478258,131.014833967,-47.5119468981,69.6941449388,-77.9770486746,229.159394609,89.8248689644,20.1892268829,120.635586789,-213.314501883,12.1002769344,93.7961684359,57.5466456276,-39.1962062635,-2.12753605338,17.1031359941,101.762374303,41.3261626859,11.9020482474,-31.6076122325,-68.2713934937,-31.6272202922,-28.3928489774,18.4728616265,-23.7621734343,-3.03258819352,-8.03271660847,-4.98231853597,8.53277985285,32.4725369154,14.1945519005,-3.17901543852,-20.1412506408,-2.98170303455,-11.7389447117,-18.7912946494,-0.874688145804,-14.847221744,-6.83408184841,0.988716687484,2.94819938083,-0.929196429909,-3.65003912391,1.00664366745,6.16641035649,1.5097864762,0.396786424872,-4.59454103479,1.80928883267,-1.3491516143,-7.4394218753,-1.43439868014,-7.36040350966,-1.49171279125,-3.182991596,-1.89974100358,1.08006155737,-1.12591085929,0.184922951379,-1.53577463953,-0.28255049284,0.723218771016,0.750149535106,-0.931347942904,-1.17279301761,0.189408504794,-0.774244112107,-0.77196183495,-1.17192250321,-1.2982641979,-0.317357731162,-1.62477023166,-1.62779547537,0.340231120913,-0.912962817124,-0.0602163285084,0.237770204137,-0.156526795688,-0.431954230003,-0.246367725107,0.0179902065547,-0.0438651086959,-0.0646132122504,-0.228216879937,0.101670699039,-0.135872441224,0.085602356042,-0.499655149141,-0.146146221935,-0.0493193970154,-0.43217611416,-0.494512645544,0.0684813454948,-0.415576160745,-0.159117040043,-0.0453042579304,0.010224213474,-0.0170929917585],[-39461.9531898,-2307.95315008,-804.475485598,-1192.63706221,-1570.45074363,1131.6761307,73.1020286267,198.785586649,-155.999328056,-943.412891467,27.5921544375,-28.9734387759,-846.05473507,546.854888813,153.967482083,190.98862583,-441.127084807,300.563941025,-15.1383683301,-404.590602767,-62.2187649937,379.944724299,-426.990471782,149.808934889,-49.917699429,66.1562701536,-78.1612321516,223.51342068,90.1450000148,12.5867158137,121.817076002,-215.290716044,14.4150010218,104.023551905,54.6499503487,-38.4672188966,-3.72127315462,15.3631861665,101.711649947,41.4043101014,9.65678642129,-30.3946304117,-67.6427715562,-32.8465086917,-24.6961850102,16.2921694,-24.8957578568,-3.61313755101,-7.63621028821,-5.33423198828,8.36572132747,32.5117248819,13.9236356104,-3.58856699147,-19.6383495738,-2.93828279468,-12.2470394716,-17.8013912414,-1.59185231144,-14.7785952364,-7.05628133983,0.861081835283,3.3649719074,-0.817386223503,-3.68917619331,1.15081092414,6.19987815111,1.35507525348,0.305654738822,-4.44872809557,1.76373969876,-1.4682264542,-7.33349550059,-1.55649503472,-7.23337259698,-1.48685630788,-3.12809768594,-1.69218830463,1.10185565734,-1.11939319355,0.196102830919,-1.52409627552,-0.256307817097,0.711202734873,0.704701287319,-0.934954022088,-1.18371392933,0.15788766359,-0.758202313636,-0.790088049724,-1.18504631546,-1.23395144552,-0.265647426601,-1.59396505911,-1.56853171966,0.368150037424,-0.913152564147,-0.074808711528,0.257527950983,-0.159524159949,-0.428539818629,-0.246026777512,0.00805385318986,-0.05367688507,-0.0661089420069,-0.240329818019,0.0863476092045,-0.129681569814,0.0729429881371,-0.503558672575,-0.138695358921,-0.0372244699413,-0.425199883208,-0.481303985945,0.0801600681592,-0.411672458999,-0.159750383465,-0.0363936897039,0.00838603100348,-0.0226436134205],[-39476.6538068,-2270.67743686,-720.96003979,-1185.05489002,-1543.85742893,1152.83010185,79.8208115817,202.785977328,-142.778966507,-939.082541152,71.9800915281,-18.2717266168,-882.878973183,518.940104436,130.955737557,182.777521311,-435.387431814,304.949152556,-21.3169941971,-403.997317224,-76.6079420946,370.857739866,-431.54409543,169.658835234,-51.9244937702,62.6352138849,-78.3073253926,217.410798385,90.2460454012,5.13482971359,123.07278538,-216.558797181,17.0121356138,113.967709003,51.5396517822,-37.6587049986,-5.33661362997,13.5860203514,101.563646272,41.3938494772,7.43836980804,-29.1496300261,-66.9198916425,-34.0615337595,-21.0743289552,14.0848427029,-26.0136564925,-4.09820194802,-7.22215977913,-5.68279358025,8.18199898528,32.5191816636,13.6496648672,-4.01864389661,-19.1142125553,-2.88480682832,-12.7651851786,-16.7838084083,-2.30616130754,-14.6792952639,-7.24698835643,0.731380191353,3.76701605804,-0.711366946881,-3.72866907099,1.29278238332,6.22326354845,1.20281610666,0.211295747626,-4.28922402764,1.72175918206,-1.58937503136,-7.21125127697,-1.66973454673,-7.09751619492,-1.470902917,-3.07279062937,-1.48369750912,1.1192944019,-1.1074436463,0.205204511931,-1.51306158463,-0.229758705434,0.696936842627,0.661698510501,-0.941038485214,-1.18972071021,0.127185270264,-0.740264077746,-0.80363551436,-1.19482741749,-1.16466065227,-0.210827227838,-1.56214924268,-1.50699744157,0.393910333267,-0.91109057504,-0.088321058809,0.275475657031,-0.162714543456,-0.425629355176,-0.246246085051,-0.00270805528029,-0.0630836039159,-0.0681731593584,-0.251340501237,0.0709494928137,-0.122080347655,0.0611636710147,-0.506734698464,-0.130194922319,-0.0239007702598,-0.418210718985,-0.466862556078,0.0909271078367,-0.406689586465,-0.160326720317,-0.0280389542314,0.00600540856832,-0.02841416096],[-39488.7619905,-2231.68441957,-631.635791176,-1177.72691362,-1514.43266147,1174.48670804,87.6432335445,204.745695215,-131.168181212,-932.757889702,116.388633164,-5.93965428022,-920.162193919,489.805178786,107.635159339,174.876776289,-428.744015985,309.787905882,-28.0494048634,-403.994673287,-91.3915505678,361.747200023,-433.953821122,190.359437788,-53.5025732049,59.1442963766,-78.4057370831,210.870342809,90.1293937435,-2.12616949832,124.404138086,-217.09986675,19.8985925863,123.519137496,48.2300172166,-36.7742917475,-6.96896837743,11.7770470059,101.315817481,41.2858780397,5.25944590932,-27.8833867159,-66.1142430244,-35.2540847658,-17.5753762635,11.8589512807,-27.0925246563,-4.47295395042,-6.7933421289,-6.02806764574,7.98382121606,32.4911849251,13.3711075665,-4.46812524089,-18.5706400736,-2.8252794169,-13.2861703587,-15.7482613864,-3.01301928555,-14.541804306,-7.40216266785,0.601553814209,4.14880811889,-0.611903611165,-3.76930598324,1.4321039281,6.23568232922,1.05332493612,0.114196081944,-4.1154099726,1.68347286316,-1.71083705045,-7.07347692877,-1.77266298402,-6.95238082363,-1.44434807941,-3.01733254526,-1.27665633099,1.13200499941,-1.08956568839,0.212193035685,-1.50282330572,-0.20297341273,0.680242889556,0.621357077051,-0.949482944561,-1.19033379553,0.0975330319995,-0.720358596572,-0.812205761166,-1.20086510284,-1.09046095977,-0.153430647265,-1.52929335889,-1.44384804281,0.417324181825,-0.906736764077,-0.10048444296,0.291378652907,-0.16602240519,-0.423252029724,-0.247012497066,-0.0143299882019,-0.0720539734691,-0.0707926266721,-0.261143253413,0.0555794074716,-0.113112944647,0.0503986669192,-0.509054627183,-0.120677503417,-0.00949385990701,-0.411207413384,-0.451291557027,0.100653590836,-0.400646143394,-0.160756471586,-0.0203067128508,0.00305258910207,-0.0343040088956],[-39498.0497416,-2192.26149344,-537.450617383,-1170.96419412,-1482.84279767,1195.78896514,96.6639442092,205.087157937,-121.370666271,-924.686728428,160.468445514,7.94225480739,-957.618178479,459.616231892,84.083092729,167.325594146,-421.282610993,315.064734946,-35.246430863,-404.630289891,-106.402343077,352.625294934,-434.11590643,211.617106565,-54.6145888788,55.6819897574,-78.4427710906,203.945080976,89.7635406142,-9.13691249687,125.803355655,-216.900374753,23.0358446401,132.602426782,44.7622581939,-35.8142135749,-8.61150887166,9.94635878739,100.964193826,41.0729298937,3.13798621657,-26.6123634942,-65.2385405634,-36.4143508609,-14.2328515582,9.62905215735,-28.120529249,-4.72591251366,-6.3537802078,-6.36835262803,7.7732735355,32.4247522636,13.0882783349,-4.93503623297,-18.0130252148,-2.76557796901,-13.8046521733,-14.7053161887,-3.70609715843,-14.3648953732,-7.5181138165,0.474272939807,4.50573028515,-0.520187128217,-3.81108664682,1.5681702191,6.23666959942,0.907470133256,0.0142663975833,-3.92864007856,1.64806404099,-1.83172116014,-6.9223941101,-1.86456887371,-6.79806547525,-1.40803707111,-2.96121412326,-1.07360722564,1.13975279807,-1.06537906926,0.21696953378,-1.49348780269,-0.176071266789,0.661316015852,0.583794300416,-0.960220649169,-1.18551608802,0.0690430451675,-0.698801319841,-0.815935894566,-1.20308528502,-1.01153158508,-0.0941035172434,-1.49515499877,-1.37986928248,0.438322616224,-0.899930603671,-0.111260851319,0.305269829513,-0.169385163157,-0.421445246478,-0.248283876272,-0.02668523619,-0.0805895817588,-0.0739195481855,-0.269669412075,0.0403663323956,-0.102916913678,0.0406847675022,-0.510507211764,-0.110147899053,0.00576535131972,-0.404110485228,-0.434801210526,0.109283727441,-0.393567232892,-0.161004406682,-0.0131947381446,-0.000483831389347,-0.0402622359816],[-39504.3080997,-2154.21046315,-439.997162583,-1165.08054253,-1450.06475988,1215.78022234,107.092747555,204.444643846,-113.630328174,-915.178808517,203.859655026,23.3054803719,-994.965676754,428.589666049,60.3182999646,160.166030414,-413.11547023,320.779080195,-42.8005308183,-405.989935075,-121.439327302,343.49678253,-431.936555336,233.116070881,-55.2212939031,52.2430541268,-78.4037050784,196.696592891,89.108758324,-15.8332531053,127.260359215,-215.948103333,26.3740046822,141.15068917,41.1843223199,-34.7778567254,-10.2568467314,8.10521940367,100.504449571,40.7478983634,1.09329321871,-25.3544452174,-64.3058055183,-37.534621165,-11.0766367554,7.41132417614,-29.0887150676,-4.84643319056,-5.90780834177,-6.70150549774,7.55241074076,32.3170862593,12.8019534818,-5.41718861195,-17.4476592149,-2.71204817502,-14.3157549426,-13.6657515221,-4.37863252955,-14.1489141092,-7.59123878795,0.352389848466,4.83339122926,-0.437514885078,-3.85381365111,1.70033811133,6.22586529633,0.76625821223,-0.0887266433659,-3.73076174528,1.61448044405,-1.95135324507,-6.7605829575,-1.94492643269,-6.63480725994,-1.36290262188,-2.90373319564,-0.877131333865,1.142337681,-1.03453260802,0.219419160393,-1.48514984569,-0.149183863652,0.640444697938,0.549102854302,-0.973197757271,-1.17534110724,0.0417975034384,-0.676004261676,-0.815096912007,-1.20149553255,-0.928079264171,-0.0335197501238,-1.45943850692,-1.31587950905,0.456866384524,-0.890481455768,-0.120669999908,0.317248967819,-0.172743475114,-0.420248463172,-0.250010838722,-0.0396067951772,-0.088700236763,-0.0774974886031,-0.276859568173,0.0254457272064,-0.0916531533841,0.0320343967669,-0.511110543406,-0.0986039574552,0.0216246166575,-0.396820885068,-0.417628493475,0.116779998925,-0.385479583777,-0.161048882123,-0.00668358050658,-0.00461066863195,-0.0462503470313],[-39507.3281048,-2119.33313337,-340.868070945,-1160.38976989,-1417.07547042,1233.50382882,119.139447562,203.452431292,-108.191073411,-904.543881161,246.202388149,40.0815021391,-1031.92343864,396.941883554,36.3595432832,153.440140626,-404.354847085,326.930382072,-50.6041633515,-408.159376878,-136.30151092,334.366420741,-427.321971823,254.540560056,-55.2834413891,48.8222495846,-78.2738167096,189.186458562,88.1253191837,-22.1510451468,128.765069894,-214.23083463,29.8631856194,149.097036969,37.5441572,-33.664607444,-11.8975935755,6.2648925624,99.9322589801,40.3036767731,-0.855330595338,-24.1275167418,-63.329059148,-38.6071847981,-8.13661377114,5.22194618046,-29.9881269092,-4.82387153394,-5.45976085673,-7.02538322548,7.323287629,32.1653894925,12.5129093166,-5.91239411693,-16.8808333095,-2.67103572531,-14.8146029868,-12.6403460938,-5.02386300225,-13.8942061576,-7.61793456777,0.238756820502,5.12739962368,-0.365184268792,-3.89728958549,1.82796445979,6.20290935722,0.630695687205,-0.195016378812,-3.5236223725,1.58166980082,-2.06905918987,-6.59062360752,-2.01320987787,-6.46284328784,-1.30987746149,-2.8441875947,-0.689809796459,1.13955953133,-0.996675123802,0.219427069702,-1.47790420489,-0.122442799356,0.617917412235,0.517375412419,-0.988360427095,-1.15988237277,0.0158786004823,-0.6523794362,-0.809959810943,-1.19610341395,-0.840310732978,0.0276467417418,-1.42184822798,-1.25269707096,0.472916234786,-0.878198682311,-0.128731604749,0.327415848794,-0.176037998822,-0.419701137544,-0.252144000473,-0.0529276610958,-0.0963957464595,-0.0814700126297,-0.282654312659,0.0109530515247,-0.0794825624008,0.0244599787167,-0.510882713303,-0.08604352685,0.0378316893437,-0.389239563457,-0.400010382775,0.123104886565,-0.376409924869,-0.160868254426,-0.000753790330303,-0.00933473835172,-0.0522298468582],[-39506.9007966,-2089.43130878,-241.65598664,-1157.20568721,-1384.85185163,1248.00313377,133.013848208,202.744798625,-105.296808473,-893.091697548,287.136771333,58.2017998349,-1068.21021402,364.889286704,12.2255849221,147.189980314,-395.112994951,333.518081023,-58.5497870848,-411.224383339,-150.78790161,325.238967496,-420.178359874,275.574803408,-54.7617844481,45.4143362303,-78.0383836474,181.476257994,86.7734955041,-28.0261424446,130.307408818,-211.736350784,33.4535003586,156.374582488,33.8897104397,-32.4738519754,-13.5263610228,4.43664197129,99.2432963177,39.7331584471,-2.68858273666,-22.9494629237,-62.3213227113,-39.6243308805,-5.44266452145,3.07709701368,-30.809809571,-4.64758309664,-5.01397207859,-7.33784278188,7.08795899738,31.9668645435,12.2219221485,-6.41846448702,-16.3188387345,-2.64888631024,-15.2963206261,-11.6398786105,-5.63502617989,-13.6011171618,-7.59459814155,0.136226136232,5.38336414086,-0.3044926664,-3.94131703935,1.95040611951,6.16744171938,0.501789072345,-0.304836146662,-3.30906935998,1.54857983982,-2.1841648792,-6.4150961967,-2.06889342617,-6.28241066909,-1.24989431972,-2.78187515272,-0.514223754209,1.1312182322,-0.951455435698,0.216878415885,-1.47184565045,-0.0959796699412,0.594022635166,0.488704648474,-1.00565481687,-1.13921340419,-0.00863147003078,-0.628338857539,-0.800795588821,-1.18691649774,-0.748432727457,0.0887220460018,-1.38208850658,-1.19114031669,0.486432915071,-0.862891645248,-0.135465381864,0.335870253408,-0.179209392041,-0.419842727327,-0.254633977578,-0.0664808298783,-0.103685918826,-0.0857806849698,-0.286994236485,-0.00297623502889,-0.0665660393636,0.0179739373549,-0.509841812653,-0.0724644554646,0.0541343226153,-0.381267470948,-0.382183855325,0.128220871636,-0.366384984986,-0.160440880109,0.00461408199054,-0.0146628562747,-0.0581622402756],[-39502.690576,-2065.70338863,-143.804518944,-1155.78426822,-1354.21428635,1258.63548457,148.714476075,202.890301123,-105.127905203,-881.089486738,326.29664946,77.5450430329,-1103.55350374,332.63067389,-12.0470458679,141.461402413,-385.506723874,340.532137165,-66.5384841782,-415.24101762,-164.722424797,316.122875053,-410.469228128,295.92087446,-53.6282530847,42.014004811,-77.6817810265,173.630162552,85.0238639019,-33.4059616507,131.875855305,-208.464812855,37.089232411,162.932098337,30.2697998931,-31.2072080345,-15.1351830163,2.63277939878,98.4350488033,39.0319911776,-4.38895335713,-21.835003144,-61.2948705525,-40.5807303413,-3.0180601401,0.993188546408,-31.5470854054,-4.3107946218,-4.57433970307,-7.63685568756,6.84856029693,31.7192965746,11.9298216009,-6.93274338446,-15.7672815528,-2.65119054475,-15.7570503125,-10.6735101814,-6.20616075158,-13.2705376724,-7.51906350249,0.0473002667964,5.59751883468,-0.256393930623,-3.985709177,2.06700768426,6.11920875558,0.380209759269,-0.418212898353,-3.08904059731,1.51432009698,-2.29611392434,-6.23627014975,-2.11167204096,-6.09373311401,-1.18397986368,-2.71615768517,-0.352559448954,1.11730481163,-0.898630090319,0.21176627175,-1.46702998713,-0.069938819127,0.5690758898,0.463082218804,-1.02499374347,-1.1134539977,-0.0316234737276,-0.604260355992,-0.78788826833,-1.17398663181,-0.652669116442,0.149077864074,-1.33990044889,-1.13194838399,0.497455168194,-0.844410044155,-0.14092888472,0.34271426356,-0.182183804806,-0.42068906637,-0.25743311805,-0.0800913772688,-0.110583274869,-0.0903755303086,-0.289833190822,-0.0162085996267,-0.0530497101972,0.0125751219625,-0.508003399097,-0.0578640088136,0.0703121955428,-0.372807833634,-0.364375162392,0.132120190574,-0.355420298582,-0.159756716148,0.0094459517054,-0.0205851104079,-0.0640106149959],[-39493.8552874,-2046.93415047,-48.1611375555,-1156.15013742,-1325.35699947,1266.01422135,165.394748139,204.194601767,-107.610596849,-868.63438927,363.290741155,97.7786606981,-1137.71581242,300.294427884,-36.3507517823,136.315449466,-375.671070521,347.924589305,-74.5058309431,-420.146523372,-178.028676884,307.041372984,-398.387303848,315.352223559,-51.8994848775,38.615668663,-77.1847738686,165.722709028,82.8882182177,-38.2841707314,133.45312142,-204.46589757,40.6913477044,168.78099834,26.7367244079,-29.8752192162,-16.7137827966,0.869808856428,97.512255479,38.2068406278,-5.94610317172,-20.7861948811,-60.2589893573,-41.4805813452,-0.859628631409,-1.01243524185,-32.2023869856,-3.82221761383,-4.14301490509,-7.92085166316,6.60754959413,31.4228010759,11.6376505523,-7.45070216412,-15.2290271358,-2.680518742,-16.197007025,-9.74393152351,-6.73450974947,-12.9055378678,-7.39491267429,-0.026917553377,5.76859928476,-0.220467776883,-4.03032146251,2.17706470301,6.05838258053,0.265288649432,-0.534348039424,-2.8658359335,1.47864733805,-2.4048208432,-6.05517204406,-2.14212367151,-5.8969807335,-1.11353650977,-2.64665294026,-0.205423526749,1.09857487728,-0.838386544245,0.20451538462,-1.46335715818,-0.0445155813565,0.543500885789,0.44009571026,-1.04615665824,-1.08290905603,-0.0528800134216,-0.58038502657,-0.771573973101,-1.1575427816,-0.553312300304,0.208268352454,-1.29517220726,-1.07554356787,0.506333715979,-0.822764929132,-0.145331016575,0.348059164868,-0.184829356261,-0.422161492967,-0.260500697723,-0.0935526982582,-0.117111187704,-0.0952104132529,-0.291178067719,-0.0286182166131,-0.0390206099839,0.00820808293115,-0.505372896046,-0.0422371215611,0.0862726905293,-0.363772979779,-0.346767652717,0.134914100449,-0.343486622663,-0.158852121348,0.0137935966362,-0.0270246778829,-0.0697443903279],[-39479.4261363,-2031.30496639,44.5757227218,-1158.27008199,-1298.31767635,1271.06668242,181.99680398,206.897640465,-112.607582015,-855.781023551,397.721483474,118.517271643,-1170.46839565,267.991327553,-60.5601685035,131.816961421,-365.745628219,355.637995924,-82.3960272285,-425.848439368,-190.655172021,298.021385184,-384.182618949,333.660145254,-49.6032942987,35.2136717697,-76.527224667,157.831025572,80.388656598,-42.6660004817,135.020477417,-199.801660573,44.1749827712,173.948356623,23.3436530805,-28.4906605854,-18.2513059285,-0.834717583454,96.481468343,37.2671269289,-7.35148553622,-19.8019301383,-59.2222188971,-42.3304638662,1.04241278261,-2.92219734437,-32.7804244399,-3.19443476749,-3.72171222932,-8.18837497936,6.3674656093,31.0780761196,11.3465051953,-7.96734410402,-14.7062556823,-2.73868613974,-16.6174238746,-8.85221575573,-7.21811729145,-12.509732833,-7.22716468825,-0.0856738990368,5.89596645216,-0.195950386282,-4.07501993488,2.27986046349,5.98524174443,0.156021521748,-0.652236588943,-2.6418457074,1.44148013623,-2.51031788033,-5.87251774516,-2.16104701355,-5.69231023864,-1.04006061169,-2.57304264938,-0.0730277347015,1.07597518169,-0.771019981554,0.195658420452,-1.46068814146,-0.0199180387539,0.517748379433,0.419231692323,-1.06888967118,-1.04792975853,-0.0721566512232,-0.55691978046,-0.752201852001,-1.1378581919,-0.450671812301,0.265893281406,-1.24782869559,-1.02226895267,0.513497275007,-0.798007687909,-0.148918518133,0.35201854388,-0.186999657824,-0.424157721524,-0.263797724386,-0.106650267649,-0.123295743476,-0.10024365839,-0.291049019445,-0.0400811871255,-0.0245510010951,0.00480379593032,-0.501953193359,-0.0255781456586,0.101955115811,-0.354077513189,-0.329533949409,0.136743613494,-0.330543519869,-0.157775054973,0.017715260248,-0.0338880081122,-0.0753345684794],[-39458.434328,-2016.99720852,133.707627084,-1162.11088915,-1273.1340024,1274.7202061,197.462783176,211.239357124,-119.981559301,-842.584007991,429.191313477,139.375494681,-1201.58250901,235.832151764,-84.5499317136,128.030778222,-355.869990292,363.614915502,-90.1532728834,-432.254304381,-202.550424357,289.089835554,-368.105205351,350.635934098,-46.7674958202,31.8023581147,-75.6889959149,150.032240333,77.5472771894,-46.5566816967,136.55919355,-194.534157511,47.4552741436,178.461247314,20.1437550069,-27.066307207,-19.7368979771,-2.46324784855,95.3492393931,36.222270212,-8.5965538064,-18.8811009185,-58.1930989431,-43.1369578779,2.69784687996,-4.71852075441,-33.285907897,-2.44002877752,-3.31214622048,-8.43796990679,6.13084706279,30.6858197779,11.0574817224,-8.47767248218,-14.2011473906,-2.8275079757,-17.0195339723,-7.99943599712,-7.65502749543,-12.0867376534,-7.02083857569,-0.128215344932,5.97898129795,-0.182077939917,-4.1196706331,2.37467825345,5.90006479747,0.0514041551313,-0.770873565976,-2.41946025787,1.40273706469,-2.61263728028,-5.68902311861,-2.16924076283,-5.47987834047,-0.965048523172,-2.49500854393,0.0444161800806,1.05045247744,-0.696825586322,0.185728045199,-1.45888391482,0.00364572655672,0.492269127033,0.399976734474,-1.09293889228,-1.00886728455,-0.0892089492425,-0.534071528851,-0.7301210539,-1.11520610754,-0.345057185688,0.321552421195,-1.19779482778,-0.972467622704,0.519374561857,-0.770189708218,-0.151938130096,0.354705987144,-0.188548320914,-0.426575466448,-0.267285205832,-0.119169560245,-0.12916302833,-0.105433590307,-0.289466198267,-0.050473612301,-0.00971314590206,0.0022932366294,-0.497747180891,-0.00788143305755,0.117298779624,-0.343636037669,-0.312846675574,0.137749741939,-0.316550552843,-0.156573476289,0.0212691860057,-0.0410815505084,-0.0807521516581],[-39429.9110681,-2002.19224897,218.536140726,-1167.63934608,-1249.84366298,1277.90213071,210.734825306,217.459691654,-129.59522731,-829.097960999,457.302668221,159.967948625,-1230.82940806,203.927679384,-108.194677095,125.021739817,-346.183750063,371.79790652,-97.7217677569,-439.271657184,-213.662948044,280.27364799,-350.405094971,366.07088464,-43.419903914,28.3760716817,-74.6499501057,142.403481462,74.3861781384,-49.9614451714,138.050540073,-188.725444027,50.4473583538,182.346744537,17.1901992835,-25.614934146,-21.1597045071,-3.99822986655,94.1221206273,35.0816906083,-9.67276133801,-18.0225992247,-57.1801692667,-43.9066433542,4.11645643866,-6.38382846525,-33.7235474851,-1.57158233865,-2.91603142325,-8.66818071612,5.90023267494,30.2467301229,10.771676326,-8.9766905766,-13.7158824594,-2.94879948761,-17.404570429,-7.18666536667,-8.04328447932,-11.6401674141,-6.78095336793,-0.153788465812,6.01700478316,-0.17808661889,-4.16413959618,2.46080136063,5.80313028987,-0.0495676715056,-0.889253989592,-2.20106992376,1.36233669664,-2.71181128759,-5.50540402995,-2.16750361506,-5.25984175008,-0.889996597932,-2.4122323553,0.14669647049,1.02295351706,-0.616098542623,0.175256924816,-1.45780545612,0.0259676324513,0.467513884887,0.381817406192,-1.11805043153,-0.966072813452,-0.10379246959,-0.512047182929,-0.705680727665,-1.08985977333,-0.236777953722,0.374845542087,-1.14499551774,-0.92648266229,0.524394293106,-0.739362377789,-0.15463659317,0.356235081208,-0.189328956949,-0.429312442144,-0.27092414985,-0.130896050847,-0.13473912841,-0.110738533592,-0.286449756454,-0.0596715932772,0.0054206932237,0.000607380697793,-0.492757748499,0.0108586642905,0.132242990206,-0.332363157023,-0.296878454322,0.138073498016,-0.301467284224,-0.155295344557,0.0245136173746,-0.048511754484,-0.0859681420719],[-39393.3725834,-1985.2512364,298.486177818,-1174.7181243,-1228.26498326,1281.43052851,220.876467871,225.683968009,-141.262244421,-815.332297424,481.778632091,179.874759078,-1257.9797789,172.487094404,-131.39368396,122.845945596,-336.833213787,380.133824132,-105.057299773,-446.803560269,-223.933664864,271.603109739,-331.34840936,379.802813251,-39.5962410116,24.9243559322,-73.4014665036,135.013067889,70.9367475453,-52.8850317252,139.482351658,-182.437931799,53.0877251911,185.632636929,14.5305092692,-24.1496833204,-22.5130116738,-5.42381233326,92.8067805784,33.8573291771,-10.5747945511,-17.2236386128,-56.1909796707,-44.6437240558,5.30821642757,-7.90190249407,-34.0980551094,-0.603310578478,-2.53485629162,-8.87841895182,5.67825847597,29.7620847996,10.489947892,-9.46039029774,-13.2522688669,-3.10302058592,-17.7733214474,-6.41469785581,-8.38088145275,-11.1734893337,-6.51312794536,-0.161813965751,6.01029852019,-0.182971908848,-4.20832716464,2.53769615895,5.69479478763,-0.148072369525,-1.00652122588,-1.98875562502,1.32033591309,-2.80785622534,-5.32236216964,-2.15651260448,-5.03251509233,-0.816288757585,-2.32466777349,0.233990670994,0.994280048549,-0.529300414626,0.164831303945,-1.45731879709,0.046850018967,0.443846885553,0.364202069506,-1.14400986658,-0.919944461855,-0.115738719765,-0.491052627409,-0.679214979302,-1.06207449705,-0.126181530927,0.425432934484,-1.08949049956,-0.88451616724,0.528900184512,-0.705637091796,-0.157255551,0.356706635498,-0.189209174162,-0.432259033151,-0.274686197684,-0.141651212819,-0.140068873379,-0.116123934139,-0.282055490134,-0.0675866804346,0.0207677911954,-0.000315126333193,-0.486996846893,0.0306180679731,0.146746626468,-0.320228080548,-0.281757024097,0.137834815527,-0.285276575117,-0.153987807588,0.0274939995934,-0.0560839193864,-0.0909600167347],[-39350.2751864,-1965.25442569,373.476048417,-1182.79343253,-1207.33884754,1285.68640758,227.436840062,235.579046338,-154.600108136,-801.115617889,502.824878783,198.538078807,-1282.80202961,142.11320132,-154.144806141,121.524532729,-327.99153943,388.586710198,-112.162009153,-454.735171001,-233.273127141,263.121961436,-311.265628601,391.855623584,-35.3638613809,21.4175522404,-71.9809914566,127.894081675,67.2675333254,-55.3302222748,140.868720637,-175.735456624,55.3982774726,188.349571167,12.1896253741,-22.6851640614,-23.8066679941,-6.73094701704,91.4103539191,32.5712106905,-11.310272123,-16.4747188491,-55.2291200853,-45.3428988918,6.28387057908,-9.26196095369,-34.4141497813,0.444041644001,-2.16920491669,-9.07156525367,5.46794973569,29.2354797444,10.2122060797,-9.9287180857,-12.8106257088,-3.28520987196,-18.1247955978,-5.68321094557,-8.66560799228,-10.6895791632,-6.22538058473,-0.152409066126,5.9627267267,-0.194766513626,-4.25227088508,2.60556136707,5.57572692006,-0.245985111396,-1.12241202905,-1.78336060598,1.27734482643,-2.90072473071,-5.14054252787,-2.1364581192,-4.79884464741,-0.744859195329,-2.233356323,0.308033442359,0.964653801577,-0.437558286856,0.155251741972,-1.45731018491,0.0661369147851,0.421286266614,0.346426256635,-1.17076064563,-0.871068095477,-0.125182988821,-0.471289641108,-0.650997743373,-1.03203383848,-0.0137668569023,0.473216969345,-1.0318787881,-0.846206279306,0.532895948547,-0.669365275182,-0.160016259006,0.356170350963,-0.18811256804,-0.435276304538,-0.278585524385,-0.151400513759,-0.145272066971,-0.121583723074,-0.276481770864,-0.0742722211266,0.0362035720647,-0.000504959484588,-0.480512670193,0.051253793734,0.160846850032,-0.307418439502,-0.267430584698,0.137069314566,-0.268054480471,-0.152694767371,0.0302045849972,-0.0636987443028,-0.095731151885],[-39302.5602109,-1941.46184827,443.547411554,-1191.20736382,-1185.7867799,1290.94150992,230.086468993,246.697170838,-169.177275733,-786.231319454,520.767729319,215.365567373,-1305.06399879,113.507209752,-176.470541103,121.06989783,-319.838597888,397.124903253,-119.049624193,-462.947170463,-241.584294834,254.877307066,-290.503322411,402.299741108,-30.7980272493,17.8212014583,-70.4374880837,121.070795663,63.4563733476,-57.299307761,142.230303762,-168.682210329,57.4222712726,190.528908437,10.1868422709,-21.2363525532,-25.0546625752,-7.91228645439,89.9400918569,31.2478808486,-11.8900457952,-15.7646612525,-54.2971904723,-45.9964905581,7.05435481645,-10.4545809809,-34.6765522888,1.54809703695,-1.81943529885,-9.25136753525,5.27242903378,28.6710904664,9.93812324164,-10.382609013,-12.3908998607,-3.48905061977,-18.4575565424,-4.99160298939,-8.89520276619,-10.191164787,-5.92632941184,-0.125865117641,5.87905427165,-0.211262441606,-4.29604260563,2.66477878987,5.44667333227,-0.345355259861,-1.23681150031,-1.58541869208,1.23411185686,-2.99035351942,-4.96057591975,-2.10740888584,-4.55993460929,-0.676529672255,-2.13961148693,0.370948726926,0.934151501254,-0.342165623931,0.147372376972,-1.45767092066,0.0836827707484,0.39976364191,0.327747292344,-1.19828568456,-0.820076517305,-0.132336511202,-0.452958976371,-0.621287911575,-0.999903420368,0.0999292474856,0.518160537767,-0.972894218406,-0.811050151723,0.536300296857,-0.630958360334,-0.163134875551,0.354663151428,-0.185976730882,-0.438217991505,-0.282646938457,-0.160145419828,-0.150487256438,-0.127118952833,-0.269962614063,-0.07981701195,0.0515929971678,1.48760844846e-05,-0.473362473374,0.0725931308562,0.174600393194,-0.294176470637,-0.253802451259,0.135791536797,-0.2499003537,-0.151459314437,0.0326268276946,-0.0712557782551,-0.100291398568],[-39252.168991,-1913.13353558,508.741926259,-1199.30201121,-1162.33030441,1297.46757755,228.495881777,258.590585705,-184.562204491,-770.462799183,535.933504721,229.764884331,-1324.53352504,87.3703293195,-198.393386307,121.494437515,-312.554260058,405.716741831,-125.733873191,-471.320239739,-248.7701279,246.91625061,-269.408060506,411.205591295,-25.9740008441,14.1008444383,-68.8199195037,114.567482695,59.5811054808,-58.794579125,143.587757783,-161.342384745,59.2029626651,192.202009925,8.54145463242,-19.81822498,-26.2709845244,-8.96048318178,88.4032455994,29.9118853519,-12.3249673093,-15.0822871419,-53.3977907933,-46.5968217509,7.63060506295,-11.4703397124,-34.88998342,2.68647830852,-1.4859054385,-9.42157371016,5.09481894993,28.0730924747,9.66737173046,-10.8229981523,-11.9930381978,-3.70822610338,-18.7701679433,-4.33927234071,-9.06740444276,-9.68097408945,-5.62459255252,-0.082473470998,5.76404602403,-0.230251701172,-4.33971417443,2.71573023218,5.30838066937,-0.448232177666,-1.34960474089,-1.39546370874,1.19138542461,-3.07667930716,-4.78309316038,-2.069433631,-4.31688917195,-0.612121949457,-2.04474674838,0.424860467036,0.902849872687,-0.24441589047,0.142047347019,-1.45829230539,0.0993420376993,0.379210625283,0.3074225014,-1.22656789921,-0.767602530329,-0.137410521352,-0.436261385543,-0.590344375607,-0.965848865462,0.21436996137,0.560226530848,-0.913270625546,-0.778544937729,0.539031941093,-0.590827779639,-0.166827558997,0.35222196072,-0.18273925499,-0.440937829255,-0.286895248404,-0.167887397184,-0.155852989035,-0.13273067585,-0.262732035148,-0.0843098495015,0.0668010278411,0.0012213752149,-0.46560351141,0.0944633686224,0.188063988253,-0.280744410703,-0.240775938916,0.134016023882,-0.230913548214,-0.150324539322,0.0347421817946,-0.0786545702651,-0.104650607827],[-39201.0428605,-1879.52951905,569.101251563,-1206.41946773,-1135.69094515,1305.53635249,222.335605529,270.811535136,-200.323351689,-753.593454138,548.648526012,241.143689243,-1340.97844696,64.4037696437,-219.935839218,122.810548398,-306.318396834,414.330564467,-132.228484443,-479.735059913,-254.733586297,239.285896054,-248.326412605,418.643599617,-20.9670443927,10.2220220324,-67.1772488357,108.408415613,55.719567594,-59.8183273076,144.961739451,-153.780171698,60.7836077244,193.400236818,7.27275713134,-18.4457575262,-27.4696229489,-9.86818973571,86.8070663541,28.5877699004,-12.6258884068,-14.4164178364,-52.5335210102,-47.1362151661,8.02355724183,-12.2998142849,-35.0591639629,3.83680816688,-1.16897333603,-9.58593169198,4.93824206383,27.4456612785,9.39962389875,-11.2508205759,-11.6169875958,-3.93641959685,-19.0611934627,-3.72561735299,-9.17995169029,-9.16173495495,-5.32878813259,-0.0225254769008,5.62246685283,-0.249526300706,-4.38335743959,2.75879749886,5.16159557649,-0.556665227556,-1.46067685202,-1.21402948139,1.14991394988,-3.15963880966,-4.60872506487,-2.0226010813,-4.07081252938,-0.552457788029,-1.95007559046,0.471892605031,0.870825640981,-0.145602551089,0.140130790188,-1.45906564017,0.112969166481,0.359558830573,0.284709208569,-1.25559020546,-0.714278937536,-0.140616253713,-0.421397620969,-0.55842602717,-0.930035796514,0.329018463884,0.599377839685,-0.85374184457,-0.74818779056,0.541009592902,-0.549384965484,-0.171310467707,0.348883702667,-0.178337732663,-0.443289552987,-0.29135526273,-0.174627911986,-0.161507812013,-0.138419944558,-0.255024049536,-0.0878395303779,0.0816926254209,0.00309153274754,-0.457293039274,0.116691796316,0.201294367507,-0.267364496448,-0.228254362804,0.131757317488,-0.211193417426,-0.149333532557,0.0365321014058,-0.0857946693549,-0.108818630709],[-39150.8701782,-1840.19186768,624.513449465,-1212.05504912,-1104.81926046,1315.3420815,211.547557769,282.984248869,-216.10287669,-735.4453039,559.195284722,249.054511287,-1354.26476277,45.192313021,-241.092964711,125.020858046,-301.292925138,422.901166579,-138.548828163,-488.071542605,-259.420731662,232.036917143,-227.581919479,424.68300908,-15.8468962865,6.15570680847,-65.5563955744,102.606568701,51.941670781,-60.374348107,146.362380359,-146.060664587,62.2009477115,194.149348438,6.38976487914,-17.1315372895,-28.6627521459,-10.6274464005,85.1565937309,27.2953030682,-12.8027774349,-13.7573956871,-51.7035369524,-47.6091712552,8.247135518,-12.936437037,-35.1873814241,4.97871015897,-0.868246926323,-9.74744791819,4.80634383062,26.792732313,9.13455004952,-11.6662725213,-11.2622797112,-4.16637163304,-19.3299942365,-3.1494324519,-9.23182967566,-8.63608364111,-5.04644912533,0.0532042238542,5.45840167957,-0.266934102008,-4.42687861268,2.79450515921,5.00716610501,-0.672309071869,-1.56980196131,-1.04158823595,1.11071834446,-3.23931000395,-4.43761343537,-1.96707251416,-3.82272284779,-0.49808405565,-1.85690650661,0.513722399155,0.838114207835,-0.0470799886922,0.142349720264,-1.45984042693,0.124420977408,0.340723073448,0.259005597551,-1.28532272866,-0.660711101511,-0.142094633762,-0.408552206633,-0.525665946057,-0.892658619452,0.443306885757,0.635619285798,-0.7950477718,-0.719502319634,0.54211430779,-0.507060651849,-0.176736292054,0.344679933474,-0.172736293164,-0.445130886128,-0.296058281158,-0.180387975523,-0.167560138705,-0.144195316225,-0.247044559441,-0.0905094456295,0.0961399766247,0.00561303998161,-0.44848495452,0.139105813052,0.214348203946,-0.254257930691,-0.216136840313,0.129027926724,-0.190866770486,-0.148510397198,0.0379752222283,-0.0925840913215,-0.112802645135],[-39102.327403,-1795.79080083,674.252193828,-1216.31696182,-1069.58194565,1326.76903034,197.159217642,295.020898808,-231.837747186,-715.994858122,567.680954417,253.629358134,-1364.65110916,29.855032454,-261.750097317,128.088917831,-297.567945991,431.229171124,-144.716842233,-496.206521591,-262.950032335,225.234266677,-207.40600612,429.388332833,-10.6611995742,1.89459819629,-63.9961047181,97.1297220073,48.2856190344,-60.4724567501,147.757711467,-138.252563085,63.4656646341,194.452696654,5.86037474205,-15.8785950222,-29.8552871722,-11.2278444516,83.4480209487,26.0351449238,-12.8620691636,-13.1016471733,-50.8932179196,-48.0189014909,8.32721702299,-13.3850611146,-35.2721901852,6.09981118693,-0.580333882224,-9.90616292177,4.70486120733,26.1172807175,8.87181228746,-12.0665948848,-10.9267853266,-4.38705178021,-19.5791212965,-2.60709635211,-9.22700956014,-8.10628989863,-4.78076789395,0.142007830095,5.273215636,-0.280546380551,-4.46952135895,2.82394884033,4.84634593144,-0.795239571333,-1.67631030193,-0.878365800298,1.07590948644,-3.3163359124,-4.26794402224,-1.90337941028,-3.57329418226,-0.448448046348,-1.76652803164,0.550240371274,0.804585681313,0.0495537406761,0.148922653884,-1.46029897114,0.133563768693,0.322550976882,0.230273287791,-1.31568443218,-0.607394623231,-0.141705351099,-0.397844753082,-0.49169396445,-0.854026872901,0.556543164107,0.6691234124,-0.737952548627,-0.692117959089,0.542076516687,-0.46436277909,-0.183003850463,0.339620738868,-0.166005213602,-0.446335505001,-0.301061568282,-0.185266779595,-0.17399784676,-0.15009536745,-0.238887014265,-0.0924813641218,0.110044169696,0.0088163740496,-0.43921972502,0.161533257286,0.227281933349,-0.241561780522,-0.204305697857,0.125832230487,-0.170170239497,-0.147803286384,0.0390389063261,-0.0989647190623,-0.116599136537],[-39055.8380185,-1747.27857542,717.437561486,-1219.46663498,-1030.07473033,1339.6239695,180.469454701,306.905642397,-247.538632952,-695.257248973,574.168879173,255.145107078,-1372.49428245,18.3945736221,-281.76513898,131.968510079,-295.215606438,439.08165794,-150.756106452,-504.016061182,-265.483058336,218.946467215,-188.007068578,432.822901557,-5.45207346876,-2.56317265863,-62.5330776407,91.9343570239,44.7816895716,-60.123973321,149.10523858,-130.425468434,64.5819256869,194.308031474,5.64220402497,-14.6875723901,-31.0503282743,-11.6583629123,81.6753296286,24.8031784094,-12.8093149685,-12.4471198066,-50.0844990788,-48.3707951012,8.29266712997,-13.6533948651,-35.3097113463,7.18973899167,-0.301091811071,-10.0613757596,4.6400540264,25.4220415578,8.61107066766,-12.4482897276,-10.6079600058,-4.58648686543,-19.8119231481,-2.09438384051,-9.17070900363,-7.57453185149,-4.53385164911,0.240694250555,5.06759390639,-0.288490265222,-4.51036370711,2.84836693373,4.68049013857,-0.925137886268,-1.77942113345,-0.724526402781,1.04787074549,-3.39150081873,-4.09741356287,-1.83214580118,-3.32311456011,-0.402722160739,-1.6802237107,0.580890359155,0.770068846071,0.142639662685,0.159940983397,-1.46008177915,0.140266208019,0.304873365678,0.198614757667,-1.34658148886,-0.554797663272,-0.139237786359,-0.389378642505,-0.456014102627,-0.814478878661,0.668004187649,0.700104693125,-0.683226377708,-0.665690599241,0.540588994381,-0.421818589161,-0.189948493368,0.333710836955,-0.158241308049,-0.446781074152,-0.306428879919,-0.189383061131,-0.180778679906,-0.156166179668,-0.230616750209,-0.0939316491738,0.123313518261,0.0127427085423,-0.429534461224,0.183802077304,0.240151932186,-0.229392079095,-0.192639064105,0.122172575118,-0.149367912299,-0.147141365776,0.0396876973543,-0.10488690225,-0.120201917227],[-39011.8255085,-1695.60744838,753.18962927,-1221.76549772,-986.393344061,1353.7136695,162.777138497,318.622637082,-263.216203765,-673.247608627,578.722403064,253.878635409,-1378.15107896,10.8135822043,-300.995991644,136.613417116,-294.308053528,446.225706868,-156.690200621,-511.376225691,-267.181379685,213.24204132,-169.593502902,435.050045937,-0.261637182906,-7.21947461087,-61.2040157163,86.9769552411,41.46015961,-59.3402179037,150.3624675,-122.648981876,65.5538980646,193.713102902,5.6928700328,-13.559111059,-32.2509756991,-11.9079808061,79.8325013917,23.595286467,-12.6500662252,-11.7917610985,-49.2593155975,-48.6702413143,8.17235121211,-13.7491466362,-35.2960660074,8.23812131412,-0.0263783202029,-10.2123854885,4.61818212032,24.7097498993,8.35198524522,-12.8078591107,-10.3032593127,-4.75270371578,-20.031748297,-1.60706970403,-9.068145666,-7.04298762368,-4.30780760147,0.346072393968,4.84222167505,-0.288892884912,-4.54848368583,2.86899783095,4.51095380918,-1.061685177,-1.87835371542,-0.580234271758,1.02898549129,-3.46558900663,-3.92371879467,-1.75399571838,-3.07277200867,-0.360078799437,-1.59927708893,0.605116200568,0.734392486765,0.230518803003,0.175496101151,-1.4588293573,0.144396963071,0.287521064639,0.164132485557,-1.37792007157,-0.503388382207,-0.134481320174,-0.383257257089,-0.418130380867,-0.774352958533,0.776966845096,0.728777601608,-0.631639461699,-0.639876130408,0.537344515658,-0.379955324011,-0.197405571204,0.326954945843,-0.149541390576,-0.446345258132,-0.312223971883,-0.19285555706,-0.187860381871,-0.16245383431,-0.22229910347,-0.0950366641045,0.135856335943,0.0174332170507,-0.419466273584,0.205740221394,0.253014576928,-0.217864859567,-0.181015067726,0.11805130696,-0.128723876733,-0.146453801034,0.0398861389681,-0.110300990557,-0.123604799515],[-38970.7133567,-1641.72967662,780.628474014,-1223.47497919,-938.633516444,1368.84490084,145.381138582,330.156040308,-278.881129399,-649.981069252,581.404870164,250.10682042,-1381.978295,7.11470387995,-319.300557251,141.977421268,-294.917434304,452.428397749,-162.542704539,-518.16307943,-268.2065664,208.189511553,-152.373705139,436.133096656,4.86799007046,-12.076176515,-60.0456203189,82.2139981494,38.3513063672,-58.1325105823,151.48690403,-114.992704654,66.3857489616,192.665660944,5.96999007046,-12.4938526947,-33.4603296932,-11.9656771561,77.9135178591,22.407352039,-12.3898743092,-11.1335185606,-48.3996026428,-48.9226293582,7.99513464259,-13.6800247755,-35.2273752687,9.2345858952,0.247948983044,-10.3584911653,4.64550532155,23.9831408076,8.09421607524,-13.1418050953,-10.010138811,-4.87372915834,-20.2419452486,-1.14092872956,-8.92453720714,-6.51383533916,-4.10474296169,0.454951169069,4.59778412625,-0.27988136851,-4.58295932381,2.88707992353,4.33909202606,-1.20456260384,-1.97232730741,-0.445653635586,1.02163709349,-3.53938475982,-3.74455645503,-1.66955319339,-2.82285455525,-0.319690363059,-1.52497171149,0.622361733281,0.697385388051,0.311532187299,0.195679399493,-1.45618221195,0.145824701532,0.270324898566,0.12692894984,-1.40960635316,-0.453634940611,-0.127225333179,-0.379583979021,-0.377546819445,-0.733987434318,0.882708025163,0.755356611484,-0.58396200326,-0.614330442907,0.532035855307,-0.339300225592,-0.205210434405,0.319357783637,-0.140002275254,-0.444905721486,-0.318510599989,-0.195803004311,-0.195200696383,-0.16900441281,-0.21399941025,-0.0959727722329,0.147580936368,0.0229290731654,-0.40905227255,0.227175637842,0.265926244048,-0.207096155094,-0.169311837389,0.113470772355,-0.108502220639,-0.14566975782,0.0395987748226,-0.115157333656,-0.126801595711],[-38932.897121,-1586.54541144,799.284246326,-1224.68719074,-886.910957795,1384.97620657,129.296272715,341.499291537,-294.515259567,-625.515998527,582.256352752,244.053104825,-1384.25585044,7.23688684539,-336.606372231,148.002847558,-297.098303118,457.477589513,-168.33113785,-524.247619402,-268.735870398,203.801184494,-136.540048682,436.118784523,9.8944517511,-17.1218319078,-59.08732897,77.6102012644,35.4801743413,-56.5219311997,152.431221368,-107.52396497,67.0770938449,191.173860255,6.44142667548,-11.4921654575,-34.6782094485,-11.8203937602,75.9159335802,21.2353327597,-12.0350154317,-10.4715094719,-47.4885763334,-49.1357937823,7.79013973557,-13.452044471,-35.101670028,10.1668348006,0.525455618627,-10.4989934884,4.72749657221,23.2457135095,7.83773960227,-13.4463237699,-9.72600415188,-4.93841497297,-20.4457867719,-0.690990424236,-8.74508122632,-5.98957576587,-3.92730667414,0.564235912838,4.33525299262,-0.259938239593,-4.61316101245,2.9034984708,4.16618969488,-1.35324787785,-2.06026473832,-0.320669215749,1.02805252383,-3.6134452127,-3.55752305563,-1.57964699588,-2.57418232046,-0.280878690123,-1.45851880023,0.632140996368,0.658964869396,0.384266019949,0.220513553047,-1.45190986103,0.144395327212,0.253064921107,0.0871667458916,-1.44147256527,-0.405896346964,-0.117312359199,-0.378343289254,-0.333756700358,-0.693731964097,0.984575330164,0.780051502172,-0.5408685455,-0.588763249115,0.524413410752,-0.300355791693,-0.213228931395,0.310930410292,-0.129713039005,-0.442363435842,-0.325345924302,-0.198357262426,-0.20276038378,-0.175851119722,-0.205768047413,-0.0969073496432,0.15845037535,0.0292686545193,-0.398313800021,0.247965224668,0.278938998881,-0.197181213953,-0.157417704913,0.108442539391,-0.0889438430475,-0.144737651745,0.0387954605809,-0.119398315399,-0.129791731595],[-38898.6606562,-1530.74638154,810.327391927,-1224.81697264,-831.421301387,1402.67321997,114.40115147,352.682958305,-309.985163722,-600.083706156,581.223835923,235.727193014,-1384.95615933,10.8642893656,-353.119510951,154.586191813,-300.834843527,461.244257464,-174.048779576,-529.480573369,-269.009271189,199.864502796,-122.220816297,434.987440853,14.7744420094,-22.2917330556,-58.3295237802,73.1632162006,32.8508771528,-54.5685986347,153.128762286,-100.300998865,67.6093412706,189.28747408,7.11602331598,-10.5533234862,-35.8913099381,-11.4609235141,73.8515948169,20.075485032,-11.5946651456,-9.80953018226,-46.5145765935,-49.3273504207,7.58751656918,-13.0644482721,-34.924620374,11.0148673955,0.807399615692,-10.6331997215,4.86648125298,22.5040238771,7.5837978288,-13.7163873325,-9.44806133521,-4.93891275072,-20.6462426897,-0.249303176091,-8.5348950804,-5.47400024751,-3.78031461792,0.671217675235,4.05674620008,-0.228967600497,-4.63962859397,2.91772620331,3.99325101282,-1.50640491299,-2.1399031144,-0.204047706236,1.04983316227,-3.68741890246,-3.35981420531,-1.48592484818,-2.32850379812,-0.243563370774,-1.40084028375,0.634248834122,0.619402389511,0.448287220146,0.249746365522,-1.44629786889,0.139863688412,0.235318101296,0.0452489370758,-1.47305517459,-0.360095001362,-0.104797544823,-0.379044063795,-0.286210352464,-0.653981551076,1.08219921681,0.803053276228,-0.50265099335,-0.563099549648,0.514458069975,-0.263525543455,-0.221448902542,0.301709253156,-0.118731810149,-0.438712601138,-0.332760721892,-0.2007026814,-0.210512270826,-0.182975652086,-0.1975955545,-0.0979718234797,0.168646677451,0.0364791549132,-0.387209123679,0.268081678827,0.292087662225,-0.188132144896,-0.145261814716,0.103015063133,-0.0701968877539,-0.143682898233,0.0374672999371,-0.122934456355,-0.132597086829],[-38868.2598914,-1474.97220999,815.338430314,-1223.10984738,-772.380161229,1422.65334684,100.29033363,363.746890166,-325.128591253,-573.958737352,578.231032975,225.0853548,-1383.97475928,17.6173722228,-369.115682265,161.612492555,-306.093646395,463.620155994,-179.682848585,-533.707601785,-269.282430179,196.110693131,-109.528268096,432.702797087,19.4644176682,-27.507856907,-57.7653230079,68.8789285974,30.4622957031,-52.3423915248,153.508036949,-93.3797693407,67.9593480668,187.066680312,8.01286869268,-9.67632741389,-37.0830450801,-10.8760220878,71.7359207593,18.9241399513,-11.0787238393,-9.15254680878,-45.4672242984,-49.517360429,7.41767216254,-12.5147855686,-34.7038061932,11.7567573697,1.09446213068,-10.7604187699,5.06399785419,21.7653919435,7.33394914675,-13.9466620084,-9.17346644819,-4.86819903542,-20.846207088,0.192829906609,-8.29907606563,-4.97122277175,-3.66912440582,0.773283934468,3.76466822287,-0.187228948243,-4.6631942733,2.92888271944,3.82120999997,-1.66249417398,-2.20868311123,-0.0942762941618,1.08842399083,-3.76072721701,-3.14852528718,-1.39023921076,-2.08779957534,-0.207813433059,-1.35278576738,0.628550292142,0.579057941919,0.503407885789,0.283056922902,-1.4397608115,0.13196186956,0.216610637009,0.00163870375412,-1.50381670662,-0.316044151808,-0.0897891898346,-0.381076277414,-0.234347366339,-0.615142534739,1.17528085541,0.824548241995,-0.469505592192,-0.53731816718,0.502208343594,-0.229188257859,-0.229888686204,0.291737081424,-0.107108979855,-0.433970724392,-0.34077917408,-0.203036733841,-0.218432200898,-0.190346830065,-0.189457511716,-0.0992886336519,0.178406609426,0.0445849721895,-0.375680742657,0.287526647003,0.305402743742,-0.179940271795,-0.132783514364,0.0972460203942,-0.0523863097428,-0.142550162659,0.0356107085935,-0.125668311273,-0.135245154543],[-38841.9507557,-1419.86251986,815.897880985,-1218.81133744,-710.00315133,1445.63399301,86.5583779768,374.730936671,-339.783291549,-547.415637327,573.201657206,212.083859994,-1381.20718789,27.1165961991,-384.870595023,168.966788309,-312.841302584,464.4970395,-185.220563741,-536.7743651,-269.811008776,192.270982171,-98.5746641865,429.228584665,23.9208355506,-32.6921804106,-57.387844911,64.7632240939,28.3133108936,-49.9131885076,153.497555525,-86.8162393977,68.1039710619,184.571656845,9.15105150634,-8.86017787388,-38.2368287928,-10.0544451515,69.5843305974,17.7776286126,-10.4970919012,-8.50552546878,-44.3361403239,-49.7258849626,7.31101353476,-11.8006057506,-34.446807372,12.3705784131,1.38732432002,-10.8799595387,5.32158486616,21.0371377421,7.08975194808,-14.131814023,-8.899375578,-4.7192503709,-21.0485740532,0.644105715603,-8.04272147827,-4.48535732623,-3.59909365065,0.867822168743,3.46142353523,-0.134981779855,-4.68469025539,2.93608761754,3.6510006764,-1.81997612551,-2.26404540439,0.0101578333584,1.14526999153,-3.83279154423,-2.92075168435,-1.29444254407,-1.85405023922,-0.173697905026,-1.31520485644,0.614910416027,0.538291520145,0.549440114778,0.320124311173,-1.4327132648,0.120421955083,0.196468726124,-0.0432007737121,-1.53321968684,-0.273557046304,-0.0723955940143,-0.383829904883,-0.177607332558,-0.577621254574,1.26352141628,0.844722707811,-0.441628587409,-0.511397924386,0.487702742229,-0.197722711882,-0.23856662074,0.281056664291,-0.0948949392937,-0.428155312622,-0.349425462186,-0.205556892357,-0.226496017368,-0.197933473819,-0.181329499267,-0.100980220069,0.187966938025,0.053610504191,-0.363671156086,0.306301775884,0.318914753094,-0.172596918523,-0.119922151427,0.0911930879858,-0.0356370639995,-0.141384110398,0.0332221022521,-0.127502434901,-0.137763427869],[-38819.9891779,-1366.05693421,813.586263437,-1211.16696531,-644.5058857,1472.3325643,72.7998432915,385.674947374,-353.787014,-520.728951291,566.059421915,196.678978408,-1376.54898277,38.9824220767,-400.65995808,176.5341176,-321.044402956,463.766662376,-190.649143912,-538.526523769,-270.850668385,188.076596587,-89.4722646806,424.528535029,28.1001524796,-37.766680515,-57.1902077479,60.8219883296,26.4028036255,-47.3508682207,153.025828179,-80.6663720375,68.020067084,181.862581572,10.5496604577,-8.10387549939,-39.3360749944,-8.98494837535,67.4122435214,16.6322821112,-9.85966971963,-7.87343227952,-43.1109455453,-49.972985177,7.29794770498,-10.9194582076,-34.1612037968,12.8344042155,1.68666734017,-10.9911309333,5.64078077922,20.3265813062,6.85276462472,-14.2665096016,-8.62294481181,-4.48504330098,-21.2562376713,1.11322114263,-7.77092861456,-4.02051789862,-3.5755799652,0.952219856268,3.14941661143,-0.0724855923561,-4.70494874515,2.93846049598,3.48355706217,-1.97731123229,-2.30343066946,0.110767489209,1.22181614641,-3.90303327203,-2.67358877993,-1.20038730861,-1.62923637688,-0.141285814723,-1.28894715623,0.593194251375,0.49746311771,0.586196005012,0.360627616317,-1.42556980473,0.104976029407,0.174418566521,-0.0888063149613,-1.56072664072,-0.23244693285,-0.0527250571442,-0.386694920972,-0.115429841699,-0.541824050066,1.34662206973,0.863762982018,-0.419216224385,-0.485317643942,0.470979776499,-0.169507682505,-0.247501044505,0.269710770953,-0.0821400796343,-0.421283872847,-0.358723767533,-0.208460629556,-0.234679563612,-0.205704403511,-0.173187097359,-0.103169022641,0.197564430002,0.0635801487604,-0.351122863096,0.324408712156,0.332654199943,-0.166093408952,-0.106617073472,0.0849139427198,-0.0200741055091,-0.140229406826,0.030297896615,-0.128339381987,-0.140179399938],[-38802.3441632,-1313.82565154,809.532715587,-1199.61013163,-576.15014833,1503.26681259,58.6713171047,396.562791351,-367.052460307,-494.16557035,556.743466669,178.918118736,-1369.87933931,52.8781497009,-416.674886244,184.209878423,-330.654960444,461.3495574,-195.948181789,-538.849372416,-272.587955877,183.312602991,-82.29863756,418.596040523,31.9714307443,-42.6641609243,-57.1563005876,57.0597686098,24.7184434787,-44.7071262056,152.038056976,-74.9707220366,67.6959707515,178.989171692,12.2237651037,-7.40312390019,-40.3642649691,-7.65715976251,65.2356038886,15.4858656556,-9.17385211825,-7.26048017707,-41.7813867708,-50.273436515,7.39918180173,-9.87185800651,-33.8553783813,13.1306063949,1.99288305427,-11.0929028369,6.02226434345,19.6408307565,6.62565224732,-14.3461863333,-8.34206025174,-4.1588614301,-21.4713592706,1.6066103581,-7.4885919067,-3.581059237,-3.6026417832,1.02438413338,2.83053195282,-0.000472816125336,-4.72482039938,2.93514620416,3.31975710559,-2.13250186185,-2.32484743679,0.20892644174,1.31935741285,-3.9709961766,-2.40471921539,-1.10983666548,-1.41535926901,-0.110663105422,-1.27461383908,0.563143889274,0.456772348121,0.61352352131,0.404131966715,-1.41877231364,0.0853692226601,0.150054054798,-0.134667400276,-1.58594445079,-0.192425658578,-0.0309258581703,-0.389110914354,-0.0473446384041,-0.508089324692,1.42430127312,0.881809473189,-0.402348239636,-0.459151646808,0.452085740095,-0.144945126676,-0.256711663589,0.257727430794,-0.0688966935099,-0.413408146029,-0.368704371625,-0.211931122815,-0.242967898587,-0.213645766891,-0.164990238277,-0.105966311331,0.207423942086,0.074516862648,-0.337980864643,0.341865830376,0.346652111202,-0.160408027759,-0.0928262352986,0.0784607418405,-0.00582925284371,-0.139128021843,0.0268310799669,-0.128101424572,-0.142520014449],[-38787.8370211,-1261.961172,803.06084904,-1184.32574957,-505.382403141,1538.15587403,44.0775019422,407.154415766,-379.792141414,-467.961769176,545.254636113,159.213245208,-1361.01208404,68.6384351704,-432.768118146,191.93090666,-341.566676261,457.281370893,-201.06676536,-537.78674235,-274.932959971,177.979427751,-76.9925822955,411.543137111,35.5541544994,-47.3607323656,-57.2330957441,53.4757589049,23.203054747,-41.9609256202,150.546211571,-69.7082112734,67.1659278424,175.959301624,14.1723584259,-6.74043859225,-41.3051494643,-6.06419664832,63.0724567258,14.3418809078,-8.4370116612,-6.66786937264,-40.3377145392,-50.6208715686,7.5966233913,-8.67018292081,-33.5409261482,13.2587482817,2.30520615232,-11.1828890446,6.46327534789,18.9861465635,6.4155066013,-14.3693672612,-8.05752805969,-3.73521660515,-21.6931691478,2.12165664719,-7.19979433062,-3.17229913118,-3.67914082207,1.08430076891,2.50457416931,0.0784323850294,-4.74522968224,2.92539059564,3.16025446783,-2.281717993,-2.32857565567,0.305452281156,1.43858864972,-4.03671358739,-2.11417466561,-1.02419657847,-1.21450297073,-0.0819833812936,-1.27181234529,0.524009602768,0.415777304815,0.631414096171,0.449746660329,-1.41287189936,0.0613988477677,0.123239882447,-0.18008415251,-1.60905742776,-0.152799467124,-0.00730619269587,-0.390715929311,0.0267579164049,-0.476483737887,1.49634663201,0.898818990823,-0.39063833421,-0.433356247095,0.431098058999,-0.124529721224,-0.266223655006,0.245075713947,-0.0552246794058,-0.404716808921,-0.37942195671,-0.216094368589,-0.251382943578,-0.221813022064,-0.156636262627,-0.109438676321,0.217722690917,0.0864378382355,-0.324200168978,0.35875841659,0.360941582784,-0.155466902834,-0.0785820206413,0.0718635643225,0.00693822107635,-0.13811114345,0.0228009309221,-0.126789703865,-0.144810017383],[-38775.0021372,-1208.88657117,793.04289382,-1165.68661047,-432.69528404,1576.51923081,28.9851290789,417.153787306,-392.29352058,-442.346168335,531.609201158,138.067460935,-1349.74470128,86.1407736469,-448.707798375,199.644397663,-353.658673693,451.626527563,-205.946356441,-535.422099053,-277.726654851,172.131337175,-73.4582062299,403.51152166,38.8804133658,-51.8433323215,-57.3583363422,50.0678148512,21.7882504025,-39.0730465259,148.578953519,-64.8423534013,66.4756619244,172.770385094,16.3904142624,-6.09503806805,-42.1425465935,-4.20004870119,60.9413722272,13.2052636433,-7.64401534784,-6.09604689626,-38.7703053216,-51.0036372168,7.86248014939,-7.32977640093,-33.2302451471,13.2226911341,2.62258203101,-11.2583643299,6.96019384135,18.3685772851,6.23052615082,-14.3353467926,-7.77088441249,-3.2089277336,-21.9201648418,2.65348057375,-6.9084159982,-2.79979613139,-3.80263962015,1.13247518984,2.17082789793,0.161132913943,-4.76711950973,2.90846477499,3.00564673829,-2.4206715074,-2.31546313018,0.401023553126,1.58005469123,-4.10034122216,-1.80257406381,-0.944783711985,-1.02877223071,-0.0554171617305,-1.27990168217,0.474918710388,0.373875701214,0.639895029015,0.496467037515,-1.4084469761,0.0328752633561,0.0939084396833,-0.224309355161,-1.63039423934,-0.112773201255,0.0177857645118,-0.391197624027,0.106897307739,-0.447006013078,1.56256303903,0.914702444652,-0.383583700289,-0.408483257198,0.408101942262,-0.108779322947,-0.2760635635,0.231709950735,-0.0411858372703,-0.395432772221,-0.390937305222,-0.221062068101,-0.259955835455,-0.23027895472,-0.14800686309,-0.113641537844,0.228625983111,0.0993588268124,-0.309738286176,0.375188484715,0.375556227854,-0.151183122872,-0.0639354204665,0.0651469695729,0.0180621797438,-0.137207264174,0.0181833006775,-0.124425078364,-0.147073605289],[-38762.3738968,-1153.02492461,778.351079952,-1144.06550567,-358.581424931,1617.87636514,13.3609297894,426.264872657,-404.844061062,-417.547388391,515.823432718,115.983869028,-1335.87467535,105.262660292,-464.262071518,207.297546787,-366.810076022,444.449452113,-210.528416845,-531.838908009,-280.8100147,165.822597572,-71.5996167062,394.642891039,41.9822969643,-56.0988982747,-57.4697655067,46.8337920851,20.4056434175,-36.0042689845,146.164944374,-60.3366620742,65.6708965656,169.419835825,18.8729064509,-5.4461408201,-42.8602744698,-2.05870558952,58.8609205868,12.0809496372,-6.78973017753,-5.54545977794,-37.0695355894,-51.4100803388,8.16895975172,-5.86598189728,-32.935733428,13.0262962104,2.94395608705,-11.316603466,7.5093998726,17.7941714793,6.07890936002,-14.2434193342,-7.48366548697,-2.57481372296,-22.1508438912,3.19720270162,-6.61833702131,-2.46910878786,-3.9707007158,1.16941282313,1.82857777569,0.244531673452,-4.79143279786,2.88363984682,2.85653150636,-2.54507428669,-2.28635766437,0.496318803322,1.74430037161,-4.16203479865,-1.47053634321,-0.87291473045,-0.860271797656,-0.0311349661267,-1.29824085702,0.414998530667,0.330465250739,0.63899361926,0.543288438631,-1.40607595808,-0.000391171948668,0.0619921167192,-0.266595791729,-1.65028355329,-0.0715517037347,0.0440018386854,-0.390243656685,0.193093020611,-0.419654873692,1.6227553868,0.929370744408,-0.380681530054,-0.385084489514,0.383182598936,-0.098211788643,-0.286257933818,0.217584471479,-0.0268419670519,-0.385778946627,-0.403311199594,-0.226945922574,-0.268717711087,-0.239116350554,-0.138983732351,-0.118630316136,0.240299125287,0.113295579668,-0.294552726312,0.39125804867,0.390529659575,-0.147469776568,-0.0489374257409,0.0583355169989,0.0273764866513,-0.136444876542,0.0129540404298,-0.121028406572,-0.149334974716],[-38748.4866857,-1092.79930791,757.857637459,-1119.83522648,-283.533459718,1661.74675923,-2.8283646514,434.191638505,-417.731226118,-393.794049911,497.913601706,93.4655725985,-1319.19949058,125.881590268,-479.199082163,214.837549383,-380.900006534,435.814569252,-214.754408385,-527.120634698,-284.0240137,159.107475248,-71.3209210672,385.078942114,44.8918949157,-60.1143677077,-57.5051263625,43.7715462429,18.9868467643,-32.7153730577,143.332845691,-56.1546509454,64.7973553339,165.905067543,21.6148088292,-4.7729653409,-43.4421512067,0.365843018285,56.8496719988,10.9738746651,-5.8690231496,-5.01655504769,-35.2257818139,-51.8285478139,8.48826987399,-4.29414286026,-32.6697890407,12.6734247692,3.26827371714,-11.3548812261,8.10727349046,17.268977704,5.96885469303,-14.0928792932,-7.19740745998,-1.8276934807,-22.3837038349,3.74794359465,-6.33343751182,-2.18579565083,-4.18088664735,1.19561909576,1.47710843964,0.325531566392,-4.81911246264,2.85018691572,2.71350636146,-2.65063821251,-2.24210706231,0.592016577413,1.9318705251,-4.22195003462,-1.11868043705,-0.809906298287,-0.71110642025,-0.00930731387607,-1.32618887714,0.343376382138,0.284943666811,0.628737166325,0.589206204034,-1.40633725951,-0.0385900995205,0.0274233037689,-0.306196245711,-1.66905403734,-0.0283398173292,0.0709938550575,-0.387541685471,0.285364540029,-0.394429043155,1.67672856792,0.942734799822,-0.381429015688,-0.36371175644,0.356425238075,-0.0933449751094,-0.296833310705,0.202653606502,-0.0122548686991,-0.375978242838,-0.416604422258,-0.233857633232,-0.277699707343,-0.248397995257,-0.129448563093,-0.124460431431,0.25290742406,0.128263848092,-0.278600999462,0.407069122371,0.405895491111,-0.144239952616,-0.0336390274311,0.0514537660078,0.0347150052915,-0.135852473079,0.00708900137593,-0.116620546987,-0.151618322213],[-38732.2769359,-1027.39095754,730.801062219,-1093.46682318,-208.057046641,1707.63780121,-19.6789678344,440.656830189,-431.23191879,-371.259991842,477.898003415,70.9424129616,-1299.5941695,147.759972295,-493.332073748,222.223072142,-395.795770917,425.803256817,-218.610315767,-521.365825067,-287.247751414,152.033239927,-72.4971718704,374.985045828,47.6474020893,-63.8794001627,-57.4044683401,40.8686295939,17.4685511521,-29.1745338028,140.111878842,-52.2587058285,63.9002563243,162.217912821,24.589448875,-4.05613157024,-43.8765048087,3.07620925812,54.9231319216,9.88974898972,-4.87745182471,-4.51220081674,-33.2306491324,-52.2491820196,8.79229947616,-2.63554733402,-32.4416923781,12.1694605785,3.59396848756,-11.3710854338,8.74962278254,16.7981618317,5.9084760093,-13.8835566291,-6.91353927677,-0.96372120803,-22.6178707627,4.30092588428,-6.05878865447,-1.95396810581,-4.43067034449,1.2115223126,1.1156286187,0.401270365541,-4.85099258649,2.80742831119,2.57704573832,-2.73325284872,-2.18365958902,0.689127952706,2.14314702752,-4.28030292205,-0.747719294764,-0.757015438345,-0.582767162971,0.00960807785092,-1.3629154926,0.259177887844,0.236727437565,0.609246138855,0.633372410057,-1.40973936113,-0.0818383579653,-0.00986458665232,-0.342367296799,-1.68705924317,0.0176899344978,0.098447672875,-0.382772541502,0.383738071727,-0.371331565293,1.72450564211,0.954584969185,-0.385274357016,-0.344892587739,0.327921096304,-0.0945958216567,-0.307717520279,0.186861027276,0.00253462668906,-0.366228704518,-0.430860725706,-0.241898668234,-0.286934599516,-0.258194654188,-0.119281741852,-0.131175679577,0.266623208499,0.144278416906,-0.261857009873,0.422741635966,0.421642276,-0.14137759285,-0.0180967799357,0.0445385198476,0.0399420771036,-0.135419866267,0.000553315939223,-0.111248279015,-0.153945760715],[-38714.2892666,-959.013753536,697.884913521,-1065.82438183,-132.709941281,1755.00850297,-37.5388728126,445.458307647,-445.580801264,-349.899926666,455.803030665,48.5511842423,-1277.24388755,170.199869329,-506.654685105,229.458667101,-411.317404479,414.564705189,-222.260215252,-514.73334692,-290.512828919,144.619174994,-74.8872025321,364.621269418,50.3114343468,-67.3945434192,-57.1170660922,38.0713809388,15.8077582381,-25.37950626,136.533504478,-48.6067011756,63.0227957407,158.327879636,27.683568624,-3.28186523702,-44.1697028447,6.061412483,53.0845468717,8.8373808234,-3.81333600875,-4.04494952114,-31.0806573473,-52.6693073264,9.0516626552,-0.935261737846,-32.2482532056,11.5258774466,3.91742664289,-11.3655561133,9.42996799171,16.3833589933,5.90554874957,-13.6174235116,-6.63306095624,0.0156077189484,-22.854984968,4.8517804723,-5.8042259255,-1.77194887949,-4.71716630224,1.21724229013,0.743043409469,0.469825323454,-4.88747191747,2.75489126251,2.44713145312,-2.78951848793,-2.11236535343,0.789994133064,2.37785992114,-4.33755054992,-0.358741930618,-0.715260607188,-0.474290353424,0.024004700776,-1.40683342452,0.161521888876,0.185308150002,0.581013682396,0.675566076929,-1.4165110097,-0.129961574817,-0.0499340528236,-0.37438070946,-1.70475225827,0.0674943054882,0.126185287442,-0.375589747638,0.488266704318,-0.350382765532,1.76698233741,0.964229405025,-0.391469784451,-0.329057382638,0.297785520538,-0.101977597642,-0.318443514148,0.170107769874,0.0175695634106,-0.356628907202,-0.446055742661,-0.251129563474,-0.296461716594,-0.268569011377,-0.108358430577,-0.138773358869,0.281646897471,0.161350205062,-0.244360238485,0.438467184527,0.437578329265,-0.13865005166,-0.00238949138208,0.0376755571299,0.0430439553118,-0.134982148412,-0.006730758551,-0.105062065671,-0.1563310687],[-38695.4703432,-890.639736863,660.179016507,-1037.87024741,-58.0629235552,1803.30578231,-56.8190175045,448.41270947,-461.001975511,-329.613785246,431.657100655,26.3554187687,-1252.41135838,192.388257884,-519.205653916,236.560357631,-427.273124935,402.265057878,-225.912705994,-507.397148527,-293.888972673,136.877567249,-78.2207916832,354.271354197,52.9527127985,-70.6630673162,-56.5945005772,35.3158357113,13.9665474165,-21.3354404651,132.629743065,-45.1553835989,62.207664314,154.198894813,30.7622637521,-2.43779351742,-44.3326227748,9.30707385024,51.3340986297,7.82635286599,-2.67568606891,-3.62977467815,-28.7735549271,-53.0880436033,9.23665479232,0.75570291524,-32.0831636316,10.7556716914,4.23452259731,-11.3392463391,10.1412573997,16.025321634,5.96776374987,-13.2969876629,-6.35686528573,1.10746263043,-23.0973152954,5.39624032807,-5.58077587401,-1.63661353382,-5.03739940697,1.21282172277,0.358182000432,0.529508562631,-4.92884037005,2.69215422385,2.32362216738,-2.81621310495,-2.02967492543,0.897288853985,2.63557628982,-4.39421028142,0.047068624903,-0.68560061981,-0.384098634999,0.0319888488442,-1.4561661368,0.0495255308334,0.130196165834,0.544626111721,0.715722960856,-1.4268110185,-0.182712574842,-0.0928465707226,-0.401512044355,-1.72261105408,0.122062368686,0.154062728078,-0.365639999673,0.599010247137,-0.3316072897,1.80527254896,0.97085570843,-0.399218536049,-0.316612257731,0.266139885265,-0.115402654935,-0.328445525294,0.152284211518,0.0329139546128,-0.347252559393,-0.462148075901,-0.261600621784,-0.306322025989,-0.279581730518,-0.0965524850685,-0.147239143214,0.298185932295,0.179489165047,-0.226166560409,0.454455279356,0.453466906304,-0.135795536573,0.0133984666707,0.0309629003076,0.0440373710871,-0.134335731772,-0.0148516835389,-0.0982382908764,-0.15878594103],[-38676.7668316,-825.240948465,618.753196318,-1010.56676492,15.3132266209,1851.97655704,-77.9303398285,449.336674248,-477.719543503,-310.301498448,405.488630586,4.41864886887,-1225.35929564,213.512114474,-531.023717864,243.544167105,-443.471149998,389.070458397,-229.776387144,-499.531178156,-297.445909132,128.820703492,-82.2277179546,344.219041477,55.6399585545,-73.6882416928,-55.7883527533,32.5380293448,11.9069980815,-17.047486454,128.432615072,-41.8614997102,61.4975527752,149.794885178,33.6906299346,-1.51154358762,-44.3761420589,12.7988145172,49.6719689764,6.86624781729,-1.46351237237,-3.28164980503,-26.3070903401,-53.5045107192,9.31757126874,2.3863356122,-31.9401157647,9.87183963095,4.54113076497,-11.2931091857,10.8764392882,15.7248021993,6.10281184624,-12.9247568055,-6.08584505256,2.3090128566,-23.3471305892,5.93003842098,-5.39946504909,-1.54483763076,-5.38839454504,1.1983033049,-0.0401264199137,0.57863220557,-4.9753878587,2.6187956494,2.20637654261,-2.81011467461,-1.93703887491,1.01368585097,2.91586321743,-4.45079947977,0.468529341316,-0.668994291203,-0.310614651087,0.0316668160004,-1.50913709331,-0.077694040681,0.0709018467774,0.5006697416,0.753778818042,-1.44079820081,-0.239844182807,-0.138663616327,-0.423036862147,-1.74111360201,0.182383197133,0.181936024102,-0.3525699934,0.716028509518,-0.315029783622,1.84049017187,0.973651480486,-0.407723849867,-0.307963329613,0.233105564973,-0.134783345404,-0.337157786699,0.133280729433,0.0486318134431,-0.338173369593,-0.479096328209,-0.273362145994,-0.316556495115,-0.291293475306,-0.0837377611277,-0.156558706519,0.316447754291,0.198705249346,-0.207331850757,0.470915431757,0.469071262515,-0.132552255117,0.0291827226633,0.0244985718331,0.0429390556001,-0.133277028608,-0.0238979204686,-0.0909533385524,-0.161322072569],[-38659.1253972,-765.789429292,574.677278098,-984.876279361,86.8477293309,1900.46774498,-101.283777703,448.046840572,-495.957607212,-291.862997135,377.326037658,-17.195593129,-1196.350413,232.758415614,-542.14761463,250.426118896,-459.719697382,375.147050258,-234.059857856,-491.309384076,-301.253364753,120.460870521,-86.6377599772,334.748072569,58.4418927249,-76.4733363879,-54.6502035789,29.6739972729,9.59118962743,-12.5207942625,123.974140967,-38.6817961215,60.9351518554,145.079777556,36.3337628473,-0.490742623814,-44.3111381572,16.522255641,48.0983396925,5.9666483771,-0.175825286315,-3.01554841904,-23.6790120548,-53.917828543,9.26470746567,3.90562534001,-31.8128017133,8.88737758332,4.83312556004,-11.2280977276,11.6284619389,15.4825531345,6.31838387471,-12.5032386615,-5.82089304405,3.61742772764,-23.606699694,6.4489077204,-5.27131999985,-1.49349673227,-5.76717660279,1.17372973092,-0.453052663071,0.61550837477,-5.02740429789,2.53439399335,2.09525324034,-2.76800117173,-1.83590777176,1.14185885952,3.21828778783,-4.50783550818,0.904457188138,-0.666400436359,-0.252261045077,0.0211448961896,-1.56396975795,-0.221019680066,0.0069355545451,0.449730886807,0.789669404693,-1.45863136992,-0.301109223476,-0.187446665615,-0.438230723496,-1.76073787352,0.249445863875,0.209661204831,-0.336026424614,0.839381300797,-0.300674893125,1.87374910129,0.971804322282,-0.416188963962,-0.303516714878,0.198803934152,-0.160032020919,-0.344014531344,0.11298770084,0.0647871530488,-0.329465046303,-0.496859102363,-0.286464438936,-0.327206091383,-0.303764909438,-0.069788114556,-0.16671772269,0.336639804777,0.219008410443,-0.18791198464,0.48805715303,0.484154653295,-0.128658414821,0.0448789050365,0.018380594159,0.0397657400216,-0.13160245118,-0.0339579307844,-0.0833835926195,-0.16395115818],[-38643.1175075,-714.523387039,528.937838762,-961.576437589,156.067772085,1948.22038833,-126.9554452,444.556659735,-515.918363541,-274.173536922,347.154832532,-38.3559773399,-1165.55551797,249.448139291,-552.653820736,257.205673944,-475.847141559,360.649337241,-238.918183056,-482.876331556,-305.343664772,111.805723247,-91.2009314214,326.092595412,61.4152705478,-79.0254881604,-53.1290299399,26.669201488,6.98524460305,-7.762415013,119.279008544,-35.5784629805,60.5453512304,140.031643495,38.5757385694,0.634512675024,-44.14856932,20.4645000815,46.6129060269,5.13370995352,1.18773506663,-2.84452918123,-20.8900387569,-54.3303058244,9.05503070333,5.26938454618,-31.6956472212,7.81399339023,5.10700327891,-11.1451043349,12.3907621422,15.2982457798,6.6205095643,-12.0349613125,-5.56319343407,5.02894577279,-23.8785910586,6.94978890875,-5.2055807284,-1.47911255458,-6.1710664227,1.13927026308,-0.881326602604,0.638641055517,-5.08509708134,2.43851714424,1.98991742072,-2.68738879316,-1.72767620125,1.28407147285,3.54219153669,-4.56582006457,1.35380295101,-0.678660051614,-0.207236964659,-0.00132813603104,-1.61903161355,-0.381170842251,-0.061941165058,0.392543467044,0.823365579996,-1.48040316741,-0.366268162766,-0.239208521109,-0.446490024121,-1.78196628867,0.324114487578,0.23712745227,-0.315693975492,0.969024934439,-0.288602627345,1.90617279348,0.964552533532,-0.423835351749,-0.303710867397,0.163458348588,-0.190984960357,-0.348519722325,0.0913331412536,0.081448113384,-0.321185754369,-0.515391385619,-0.300918903379,-0.338300774658,-0.317058261395,-0.0545959068618,-0.177691897658,0.358944356339,0.240380050852,-0.1679827614,0.506099603579,0.498495374063,-0.123855839485,0.0603738959157,0.0127251734917,0.0345679564916,-0.129126333204,-0.0450870300562,-0.075688544492,-0.166682765121],[-38627.8138357,-670.745696386,482.18846233,-940.706093937,222.892412099,1994.65202688,-153.682161002,439.666833846,-537.716389123,-257.009672434,314.788899709,-58.6599836504,-1132.77779365,263.43826938,-562.769768073,263.816043454,-491.762484039,345.685264194,-244.292290767,-474.259053865,-309.599529538,102.844389017,-95.748186115,318.28838444,64.568983773,-81.367301448,-51.1633924333,23.5068102172,4.07145817594,-2.7870041742,114.3425749,-32.5354645765,60.2818363563,134.685133426,40.3765547954,1.86424751874,-43.899716959,24.6185775071,45.2134171005,4.35987878774,2.62500954216,-2.77399132784,-17.9527700004,-54.757006836,8.69219605795,6.4607195205,-31.5860125741,6.65824098829,5.3617477469,-11.0447785601,13.1587307231,15.1672270548,7.00857421596,-11.5225342766,-5.31509594256,6.53608231749,-24.16657155,7.4344535206,-5.20434104886,-1.49679143103,-6.59856867157,1.09560043499,-1.32391436031,0.647301684248,-5.14834351975,2.33069072809,1.8892602384,-2.56874662386,-1.61351481016,1.44094671504,3.88601380676,-4.62519218584,1.81605268007,-0.706142858671,-0.172847574727,-0.0369335836548,-1.67326621885,-0.558213384278,-0.134962029866,0.330431821741,0.854978615068,-1.50594154813,-0.435112031186,-0.293767291511,-0.447694499964,-1.80529906207,0.406753369401,0.26435655916,-0.29140927374,1.10450174044,-0.279014448659,1.93892294918,0.951337208472,-0.429957428083,-0.309113590155,0.12770008927,-0.227174150625,-0.350456243204,0.0683956193399,0.0986993416307,-0.313331484013,-0.534633703133,-0.316581341857,-0.349826474612,-0.331242018817,-0.0381275223841,-0.189417065436,0.383443006627,0.262687373206,-0.147699677303,0.525300540205,0.511931880329,-0.117900818001,0.0754395921645,0.00772125105168,0.0275314410261,-0.125734694224,-0.057207950358,-0.0679601155597,-0.169517950231],[-38611.909857,-633.02539876,434.999484598,-922.119404608,287.338674017,2039.17432482,-179.865919945,434.374877718,-561.444355526,-240.123283044,279.999217151,-77.6372943904,-1097.728517,274.719791233,-572.760627369,270.173876199,-507.394883088,330.351136234,-250.069574785,-465.455201274,-313.866278179,93.5613632865,-100.130712926,311.321620716,67.8999582781,-83.5252476084,-48.6892475835,20.1794182464,0.836168668331,2.38888169862,109.15286446,-29.5422087347,60.0804916343,129.089042505,41.7151896234,3.19601759438,-43.5759432761,28.9789992886,43.8971355025,3.63417382922,4.1332092405,-2.80741923888,-14.8827755568,-55.2161847311,8.18653054476,7.46956001331,-31.4819916932,5.42538583782,5.59696467155,-10.9277092511,13.9282470155,15.0837627739,7.48030202361,-10.9685874314,-5.07924167599,8.13042188622,-24.4747076396,7.90588080358,-5.26790822838,-1.54128584922,-7.04848397233,1.04352234811,-1.77934112004,0.640953560188,-5.21693840307,2.21042980527,1.79197934665,-2.41328197085,-1.49453826061,1.61269746789,4.24796839261,-4.68637524361,2.29082624157,-0.749100760573,-0.146174544476,-0.0867102690627,-1.72576115151,-0.752049763721,-0.211109573623,0.26486789526,0.88465488401,-1.53500829525,-0.507439500395,-0.350892412069,-0.441844722026,-1.83124085698,0.497601856131,0.291403470929,-0.263046933447,1.24525055292,-0.272147182753,1.97317083028,0.931650139965,-0.433867843178,-0.320325023411,0.0922624184877,-0.268055505638,-0.349676707657,0.044291342056,0.116629611778,-0.305882681798,-0.554522964536,-0.33326865684,-0.36175811337,-0.346386234129,-0.0203678511691,-0.201819092059,0.410192184559,0.285769030162,-0.127238152844,0.545927368812,0.524317667625,-0.110553255536,0.0898191443314,0.00357595181298,0.0188757306103,-0.121331475242,-0.0702102778897,-0.0602733347059,-0.172455642742],[-38594.1010462,-599.931535587,387.941241358,-905.6705258,349.42358248,2081.19894635,-203.908716865,429.678306165,-587.194934315,-223.266248126,242.55676282,-94.8175918896,-1060.11896497,283.283690197,-582.891569355,276.195820953,-522.673496973,314.743258476,-256.137428908,-456.46242405,-317.989229823,83.9411415128,-104.19970072,305.178485299,71.4051199406,-85.5257979989,-45.6425519151,16.6796203615,-2.73428559757,7.74868605021,103.697901647,-26.58810328,59.8772014654,123.292165883,42.5706211515,4.62737858899,-43.1886104733,33.5402767969,42.6613238219,2.94561402743,5.70954526193,-2.94829729438,-11.6956251973,-55.7260926632,7.54836117899,8.28583577495,-31.3816784993,4.12069339915,5.81225976041,-10.7944852561,14.695190353,15.0421187517,8.03341718117,-10.3757506543,-4.85827174084,9.80354900345,-24.8070657987,8.36705000531,-5.39658953409,-1.60734829674,-7.51961294789,0.983838103881,-2.24613206565,0.619059982561,-5.29067652127,2.07724943617,1.69677239877,-2.22220214112,-1.37186121476,1.79953661321,4.62626908879,-4.74979260948,2.77774350178,-0.807785660366,-0.1242995431,-0.151697014636,-1.77560398921,-0.962582438154,-0.289366330073,0.197323631961,0.912540760922,-1.56736519192,-0.583049242051,-0.41035331803,-0.428941261306,-1.86029633667,0.596899294551,0.318323133002,-0.230481568703,1.39071020601,-0.268237655315,2.01008769868,0.904983120875,-0.434879247249,-0.337945307428,0.0578785985291,-0.313084939311,-0.34603372936,0.0191365163585,0.135327697814,-0.298819794289,-0.574996079457,-0.350797750802,-0.374070613055,-0.362560959757,-0.00130178326303,-0.214823843564,0.439248319053,0.309463674381,-0.106773608518,0.568247495302,0.535506231482,-0.101573057253,0.103255702965,0.000496400749759,0.00882036222944,-0.115820617257,-0.083983598851,-0.0527032308139,-0.175494771886],[-38573.0828785,-570.033148295,341.584068406,-891.213613716,409.164162131,2120.13755564,-224.212546597,426.574633999,-615.060797057,-206.190447055,202.23251468,-109.730558478,-1019.66041453,289.120951623,-593.427764759,281.798526486,-537.527483963,298.957936038,-262.38324693,-447.278372464,-321.813703597,73.9682191521,-107.806338366,299.84515925,75.0813946384,-87.3954239773,-41.9592619525,13.0000113483,-6.65356629955,13.2758523253,97.965710886,-23.6625560375,59.6078502507,117.343298716,42.9218274779,6.15588618964,-42.7490807526,38.2969214029,41.5032446479,2.28321833185,7.35122870668,-3.20010987436,-8.40688869333,-56.3049837856,6.78801497587,8.89947655576,-31.2831669137,2.74942913261,6.00723872101,-10.6456954231,15.4554400694,15.0365608025,8.66564388256,-9.74665382269,-4.65482724358,11.5470481937,-25.1677124986,8.82094037341,-5.59069223312,-1.6897312612,-8.01075622116,0.917349803772,-2.722812381,0.581084250593,-5.36935266429,1.93066468114,1.60233704802,-1.99671444169,-1.24659833474,2.00167703279,5.01912968986,-4.81586765508,3.27642432695,-0.882449461094,-0.104304239794,-0.232932642755,-1.82188230963,-1.18971386515,-0.368714832961,0.129270976205,0.938782619905,-1.60277402131,-0.661739927813,-0.471919444641,-0.408984688806,-1.89297016438,0.704885031444,0.345170490807,-0.193587793596,1.54031953383,-0.267522692031,2.05084481625,0.870827944065,-0.432304290507,-0.362574582466,0.0252818916832,-0.361718365559,-0.339379921989,-0.00695265079587,0.154882373727,-0.292123268051,-0.595989957527,-0.368985526214,-0.386738895791,-0.379836248126,0.0190857912878,-0.228357185987,0.470667839027,0.333609958523,-0.086481464822,0.592528325576,0.545351067433,-0.0907201283199,0.115492418612,-0.00131027716387,-0.00241512713124,-0.109106061273,-0.0984174994418,-0.0453248327672,-0.178634266897],[-38547.9372889,-542.120847818,296.418035215,-878.63389594,466.518621242,2155.60303129,-239.646704796,425.849882053,-645.044371908,-188.689502226,158.879201094,-122.037541841,-976.160557182,292.250813175,-604.547527522,286.928638376,-551.899785885,283.075489123,-268.716292095,-437.882294949,-325.204410695,63.6647325878,-110.818462074,295.297708763,78.927329728,-89.1705136034,-37.5850883471,9.13386176916,-10.9204390516,18.9419605291,91.9548345016,-20.7580191547,59.204682799,111.291217674,42.7478504202,7.77898231041,-42.2702186568,43.2400620382,40.4202103166,1.63884688616,9.04985965777,-3.56490316719,-5.032397721,-56.9701108406,5.91863411037,9.30201963944,-31.1854921639,1.31627506186,6.18200171857,-10.4818486757,16.2048320507,15.0611980995,9.37339832994,-9.08469731978,-4.47159228987,13.3515365833,-25.560119796,9.27083997653,-5.84984524628,-1.78376000557,-8.51991905055,0.844624758982,-3.20737979036,0.526907894862,-5.45255517754,1.77042149129,1.50757088451,-1.73851093847,-1.11981422529,2.21888924716,5.42438295581,-4.8850641571,3.78620480796,-0.973174560738,-0.0835591321947,-0.331026461933,-1.86387623085,-1.43294120745,-0.448038472947,0.0619094041826,0.963539604134,-1.6409323087,-0.743247478602,-0.535280748402,-0.382091994716,-1.9296001978,0.821608543379,0.371948841628,-0.15232620068,1.69340173783,-0.270256051426,2.09639172602,0.828830536818,-0.4256272701,-0.394628130212,-0.00478556979194,-0.413422361656,-0.329594458111,-0.0338861093999,0.175358521601,-0.285767165451,-0.617423556201,-0.387628382475,-0.399723079037,-0.39824306585,0.0407920714174,-0.242334150533,0.504454139086,0.358024997743,-0.0665499468774,0.618951686692,0.553721679504,-0.0778190666193,0.126295008212,-0.0016554290779,-0.0146182895358,-0.101122309245,-0.113408845773,-0.0382056728627,-0.181871569229],[-38519.292053,-515.871523134,252.61214597,-867.940885603,521.209902593,2188.01310951,-250.949690384,427.444095241,-676.78711339,-170.724008117,112.676552041,-131.926551088,-929.812742569,292.805521781,-616.08174442,291.652789402,-565.788478814,267.112298285,-275.133305416,-428.179832596,-328.10363057,53.2033819102,-113.170497422,291.471740557,82.9479584816,-90.9271217471,-32.5047582566,5.07714529196,-15.4740852123,24.6711369086,85.7058864272,-17.8791220695,58.5853855493,105.184625499,42.027986674,9.49365377357,-41.7708980914,48.3472978777,39.4097321532,1.01572461096,10.7745941293,-4.03897059451,-1.58903157611,-57.7347249268,4.96462139635,9.49143244319,-31.0914547042,-0.176420536027,6.33862674891,-10.3031342398,16.9390283915,15.1095132505,10.1478647584,-8.39636355193,-4.31142298212,15.2037617066,-25.9853820887,9.72127216752,-6.17096410901,-1.88705089426,-9.04192523649,0.7652911197,-3.69572217972,0.458085371366,-5.53904662822,1.59718938059,1.41217124567,-1.45122273308,-0.992373261481,2.44917433174,5.83833750848,-4.9580075125,4.30528593416,-1.07936533703,-0.0605900317086,-0.444869725212,-1.90163603253,-1.69014044847,-0.52582406837,-0.00465148059847,0.987021933093,-1.68128054791,-0.827056812394,-0.599809270819,-0.348845846002,-1.96985707227,0.946359826053,0.398454890179,-0.107001296368,1.84881748868,-0.27675922338,2.14679109568,0.779253364086,-0.415019070898,-0.433781798064,-0.03154617376,-0.467706158321,-0.316662745848,-0.0616784372448,0.196725455891,-0.27970001206,-0.63914402422,-0.406440706681,-0.412924061584,-0.417656036283,0.0637426119807,-0.256626429093,0.540398476586,0.382439757184,-0.0472184983144,0.647357090325,0.560551605706,-0.0629532409107,0.135519454253,-0.000424290638778,-0.0276050332455,-0.0919261069604,-0.128883623596,-0.0313832970525,-0.185198169224],[-38488.1614064,-491.183632726,210.255138532,-859.175167219,572.902132596,2217.98674093,-259.327303101,431.085824495,-709.840232614,-152.296302228,63.8860479003,-139.717260685,-880.906734887,290.945576684,-627.774445443,296.06760915,-579.205422383,251.068759169,-281.652897355,-418.05822466,-330.47303474,42.7945081365,-114.813517333,288.292746483,87.1499356506,-92.7512199805,-26.7127529656,0.826511361044,-20.2387900766,30.3756442714,79.2699984973,-15.0335385424,57.6640053485,99.0722064521,40.7415966546,11.2967736285,-41.2714953031,53.5928456571,38.4693712298,0.419917621041,12.488977118,-4.61716738634,1.90606854067,-58.6110767316,3.95319480741,9.46728991754,-31.0047962954,-1.72689282065,6.47968626551,-10.109661417,17.6536477389,15.1748322219,10.9789194114,-7.68890543127,-4.17721842191,17.0895036996,-26.4439993597,10.1770691202,-6.55028601041,-1.99779306706,-9.57080321488,0.678742245861,-4.18319997545,0.376589367457,-5.62738313899,1.41186875373,1.31603540575,-1.13896568605,-0.86508976099,2.69009100067,6.25692093513,-5.03536352335,4.83158491951,-1.20025666264,-0.0342115781839,-0.572924171765,-1.93540453474,-1.95878227677,-0.600459294485,-0.0705745428014,1.00945259534,-1.72319497489,-0.912590096426,-0.664797574653,-0.309945328818,-2.01324461757,1.07823900495,0.424433693033,-0.0580035655347,2.00531182439,-0.287370630612,2.20188387402,0.722513025241,-0.400822224706,-0.479526574842,-0.0542134381153,-0.52408964963,-0.300596752214,-0.0903703690709,0.218928599147,-0.273863949256,-0.660980558149,-0.425116382855,-0.426227937557,-0.437910696968,0.0878450568128,-0.271094878727,0.578239074571,0.406563664485,-0.0287393673902,0.677498469305,0.565790392543,-0.0462707126718,0.143044305615,0.00247943038294,-0.0411983555708,-0.0816047611607,-0.144775098577,-0.0248877547022,-0.188604069445],[-38455.5595848,-467.95563508,169.435750766,-852.377325306,621.259437661,2246.14287616,-265.985342689,436.50362075,-743.754940691,-133.408722056,12.7691690526,-145.729345097,-829.732298326,286.831477125,-639.369660577,300.269727204,-592.162476228,234.945267415,-288.293678373,-407.404710397,-332.274294725,32.6484522841,-115.698594728,285.686218393,91.5399159862,-94.7287798759,-20.2035537587,-3.62139057926,-25.1388389393,35.9677454248,72.6983025467,-12.2289423338,56.3545890434,93.0026447919,38.8680407768,13.1852149244,-40.7923865382,58.9509221121,37.5966886185,-0.142507968776,14.1565536208,-5.29434877268,5.43576142867,-59.6114169424,2.91157231713,9.22916701306,-30.9292586983,-3.33337695161,6.60775272185,-9.90153950875,18.3443087396,15.2504809803,11.8564385322,-6.96957586994,-4.07187771084,18.9945426985,-26.936471592,10.6430630086,-6.98404813957,-2.11417566376,-10.1005814216,0.584371497402,-4.66517360397,0.284392570489,-5.7161208325,1.21536001538,1.21906063899,-0.805855657904,-0.738778041483,2.9391979681,6.67606082304,-5.11779799168,5.363018978,-1.33508341023,-0.00323841146914,-0.713651540765,-1.96542455754,-2.23633738094,-0.670331826546,-0.136022647089,1.03105457944,-1.76605182558,-0.999269497936,-0.729538222661,-0.26608952932,-2.05926666348,1.21634620555,0.449630306761,-0.00572349305758,2.16162978295,-0.302428695839,2.26151100988,0.659026119657,-0.383379263325,-0.531353449372,-0.0720008807521,-0.582092729661,-0.281408444222,-0.120002639619,0.24191337392,-0.268201118413,-0.682762354555,-0.443349295022,-0.439520801079,-0.458842585447,0.113007049749,-0.285600356495,0.617714156086,0.430106147285,-0.0113648023616,0.70912975646,0.569387586521,-0.0279195433805,0.148748111176,0.00715202621669,-0.0552212538221,-0.0702455785884,-0.161016536379,-0.0187490951774,-0.192079272457],[-38422.5008238,-446.085988681,130.242720533,-847.587944378,665.945944196,2273.10046581,-272.129608887,443.42603494,-778.082448734,-114.063605101,-40.4126041219,-150.282478791,-776.579197075,280.623722349,-650.61141981,304.355773148,-604.671499982,218.742218668,-295.074258928,-396.106529062,-333.469082042,22.97555537,-115.77680253,283.577648139,96.1245542396,-96.9457730054,-12.9716419204,-8.26991108462,-30.0985170953,41.3597031763,66.0419304101,-9.47300720423,54.5711834808,87.0246247786,36.386679456,15.1558507107,-40.3539480432,64.3957439784,36.7892453915,-0.665486043685,15.7408686344,-6.06536998351,8.98290588722,-60.7479962468,1.86697189912,8.77663868029,-30.8685836736,-4.99410808849,6.72539857143,-9.67887781656,19.0066300407,15.3297854922,12.7702983642,-6.24562778006,-3.99829995048,20.9046588394,-27.4632987685,11.1240860063,-7.46848768562,-2.23438782415,-10.6252882927,0.481572234258,-5.13700349166,0.183467667813,-5.80381583142,1.00856357025,1.12114421964,-0.456008509173,-0.614252420629,3.19405394818,7.09168475949,-5.20597671953,5.89750532358,-1.48308045246,0.0335148285873,-0.865513571386,-1.99193892099,-2.52027644956,-0.733829339809,-0.201158658126,1.05205087394,-1.80922733594,-1.08651718416,-0.793323777605,-0.217977533664,-2.10742703975,1.35978155333,0.473789787937,0.0494484361871,2.31651640236,-0.322271841781,2.32551345206,0.589209246704,-0.363032718561,-0.588753410474,-0.0841220195646,-0.641235292491,-0.259109788885,-0.150615983629,0.26562520276,-0.262653660906,-0.704318610002,-0.460833327203,-0.452688746276,-0.480287239263,0.139136234624,-0.300003719457,0.658561944174,0.452776633222,0.00465294851431,0.742004884619,0.571292734145,-0.00804779451447,0.152509419817,0.0136897890919,-0.06949672531,-0.057935865986,-0.177541202666,-0.0129973678438,-0.195613780823],[-38390.1759437,-425.622666986,92.7050027243,-844.858309567,706.888750182,2299.20733056,-278.70097437,451.612392155,-812.38977808,-94.2133994543,-95.4592597816,-153.666379028,-721.713734472,272.525530671,-661.301462348,308.418172035,-616.720130887,202.463438717,-301.996950103,-384.037749254,-334.012393467,13.9491236635,-115.013941056,281.91968131,100.899387851,-99.4764445371,-5.02752947735,-13.1195325601,-35.0381776364,46.4693179202,59.3478078123,-6.76862567137,52.2493083276,81.1867575762,33.2897152522,17.2032087486,-39.9773903566,69.8994461661,36.0416853567,-1.14342788945,17.2068321321,-6.92234903031,12.5326265453,-62.0276902912,0.847902288179,8.11395918123,-30.8270418742,-6.70581162246,6.83522372616,-9.44272966942,19.6360479626,15.4063803096,13.7089417734,-5.52434809168,-3.9584905062,22.8063536283,-28.023717776,11.624748659,-7.99826727864,-2.35687140033,-11.1385947618,0.369877323586,-5.59399715172,0.0759248411124,-5.88885111844,0.792525282779,1.02221515638,-0.0939672766814,-0.492311384942,3.45193375703,7.49986364186,-5.30032755434,6.43273873044,-1.64291842554,0.076926533029,-1.02651532157,-2.01524651718,-2.80777712534,-0.789497216435,-0.266149607227,1.07262792246,-1.85199065568,-1.17369714048,-0.855444708806,-0.166342480231,-2.15718925525,1.50745297958,0.496648149535,0.107037380438,2.4686560358,-0.347072726064,2.3935504095,0.513624673004,-0.340207477129,-0.651062793523,-0.0899399679918,-0.70099706494,-0.233749384557,-0.1822196127,0.289967859706,-0.257147246196,-0.725464038193,-0.477266251806,-0.465592589817,-0.502071471714,0.166093327518,-0.314165643809,0.70047841634,0.474287525752,0.0190847512722,0.775833826791,0.571493654083,0.0131385622375,0.154262572486,0.0221399515326,-0.0838308567535,-0.0447781543819,-0.19426249764,-0.00765866722645,-0.199194999181],[-38360.4821032,-407.211703342,56.6124203379,-844.282508476,745.066839876,2323.72677121,-285.580603552,460.945114128,-846.307190968,-73.6109955701,-152.41666024,-156.050934259,-665.308370434,262.910996699,-671.47236427,312.532530791,-628.199116615,186.126473938,-308.998865465,-371.019756957,-333.832526797,5.59432444106,-113.434720202,280.77357845,105.815485012,-102.348134022,3.55414857489,-18.159264808,-39.8624448425,51.2365403984,52.646036039,-4.09956528238,49.4103745316,75.537361966,29.6207193052,19.312435647,-39.6872611843,75.4258362828,35.3369832645,-1.57265439415,18.5248139927,-7.84645505044,16.07911135,-63.435874558,-0.111964736042,7.2641000236,-30.8110195203,-8.45917387101,6.93993793175,-9.19792450624,20.2272695201,15.4751343265,14.655078116,-4.81315980652,-3.95087979837,24.6890140501,-28.6119131155,12.1487749982,-8.56175131275,-2.48107909369,-11.6327417548,0.24937766142,-6.03125044456,-0.0355757506092,-5.96891711643,0.568872856531,0.92232939559,0.274016297575,-0.373690096318,3.70897661867,7.89724160809,-5.40032652497,6.96552421366,-1.81101101968,0.126647216468,-1.19283512429,-2.03587052623,-3.09484486751,-0.836511666202,-0.331179192328,1.09282598876,-1.89318258964,-1.25994062478,-0.915183111844,-0.112053716294,-2.20785553508,1.65749963881,0.51790523014,0.166231070395,2.61649029716,-0.376340945952,2.46455413159,0.433417334177,-0.315657845403,-0.716999320096,-0.0894162216526,-0.760697104802,-0.205522354947,-0.214696645858,0.314678524764,-0.251541656093,-0.745955421373,-0.492361394766,-0.477992038544,-0.523987199136,0.193551333488,-0.327946082279,0.742990567934,0.494363131594,0.0317939291128,0.810150716689,0.570131253646,0.0352019143433,0.154165078416,0.0323535072406,-0.097962092507,-0.0309358719495,-0.211014359656,-0.00274326848793,-0.202799940463],[-38335.4930456,-391.648646067,21.6950134,-845.965329324,781.722169106,2345.65095865,-292.384733781,471.337396746,-879.480759865,-51.9593944957,-211.392136349,-157.57607573,-607.512104028,252.196934113,-681.214410873,316.77025181,-638.974982443,169.752300854,-316.000819199,-356.860767498,-332.851105083,-2.10070976878,-111.078577262,280.227753841,110.812796607,-105.576454608,12.6827264988,-23.3752494801,-44.4720107905,55.6068589395,45.9625102659,-1.44481234171,46.0972658605,70.1246836337,25.4361049001,21.4663327267,-39.5089425244,80.9366401107,34.6551966011,-1.94996384642,19.6665490711,-8.8161199627,19.6188140784,-64.9525494888,-0.977666632681,6.2547120266,-30.8274317242,-10.2433713832,7.04227839233,-8.95023579339,20.7748194019,15.5312250226,15.589983371,-4.11951994424,-3.97300451116,26.5427484596,-29.2208061915,12.6996674272,-9.14572962306,-2.60671631793,-12.0996126951,0.12030365102,-6.44380631736,-0.148236454017,-6.0415311083,0.339379454824,0.821574618057,0.641263295307,-0.259107885498,3.96103785912,8.28060610622,-5.50521170567,7.49244434854,-1.98320768866,0.182020424407,-1.36019463132,-2.05439020031,-3.37719208944,-0.874206605796,-0.396435278017,1.11264879167,-1.93153685641,-1.34432071312,-0.971818988861,-0.0560146413528,-2.25868778345,1.80786849131,0.537251824739,0.226132879874,2.75840011552,-0.409420333615,2.53727512786,0.349877833091,-0.290220484668,-0.785126058321,-0.0826618717105,-0.819614302613,-0.174660455105,-0.247898678987,0.339452729427,-0.245680200491,-0.765535058925,-0.505835970405,-0.489621521845,-0.54581761362,0.221136329835,-0.341204806732,0.785583148767,0.512730733287,0.0426669195286,0.844445728208,0.567384712307,0.0576467390599,0.152430238913,0.0441323902127,-0.111611966333,-0.0165876711485,-0.22761086161,0.00174250804979,-0.206403019676],[-38317.2825141,-379.72904348,-12.3171780635,-850.01156033,818.096693699,2363.97206373,-298.729602403,482.702435899,-911.556557236,-28.9615972778,-272.49301896,-158.381734689,-548.473934317,240.800156594,-690.617887453,321.202737488,-648.91425365,153.361895989,-322.923625495,-341.368996205,-330.98975138,-9.14784643757,-107.984949527,280.370621764,115.831273516,-109.177019441,22.2675385566,-28.7536282283,-48.767567557,59.5257618719,39.323125669,1.21664684617,42.3528660822,64.9969682648,20.7922853216,23.6477013085,-39.4678163747,86.3935834318,33.9763828526,-2.2721545349,20.6037722226,-9.80977568594,23.1481885072,-66.5577155251,-1.71424086088,5.11344600939,-30.883193598,-12.0475807081,7.14498231205,-8.70543699725,21.2732222963,15.5698298773,16.4949335172,-3.45088552447,-4.0224013287,28.3576652116,-29.8433184088,13.280928349,-9.73699204469,-2.73348848675,-12.5310910064,-0.01711430436,-6.82670771733,-0.259259615778,-6.10421037695,0.105818240979,0.720038504583,1.00109479823,-0.149284083222,4.20397280438,8.64674458428,-5.6142211707,8.01008171038,-2.15535788622,0.242389702351,-1.5243154944,-2.07138479157,-3.65053120451,-0.901915951901,-0.462105728881,1.13210005,-1.9657871746,-1.42591048152,-1.024632342,0.000871345093418,-2.30894790454,1.95650649739,0.55437872832,0.285846182688,2.89276641996,-0.445654721224,2.6104639078,0.264296772615,-0.26473205621,-0.854006076326,-0.0697880093291,-0.877027548909,-0.141395440082,-0.281677307972,0.36398600519,-0.239406189284,-0.783945250232,-0.517407193043,-0.500215469105,-0.567345907259,0.248474393862,-0.353801589031,0.82774090865,0.529117613367,0.0515901600121,0.878209035241,0.56343320954,0.0799775136443,0.149271355278,0.0572785344451,-0.124502011995,-0.00191220443838,-0.243866076395,0.00579234206472,-0.209978651826],[-38307.9242522,-372.248443899,-45.6941140268,-856.525989714,855.432369481,2377.68225732,-304.231446767,494.953427475,-942.180655546,-4.32060496321,-335.826638927,-158.607842381,-488.342860367,229.137477822,-699.773079307,325.901390219,-657.883455514,136.976235866,-329.68809854,-324.352658405,-328.17008874,-15.5589530368,-104.193274292,281.290596501,120.81086662,-113.16544167,32.2179190109,-34.2805427041,-52.649807219,62.9387375245,32.753777424,3.9058259768,38.2200589645,60.202461545,15.7456738548,25.8393427132,-39.5892647333,91.758392028,33.2805995051,-2.53602474825,21.3082183022,-10.805854139,26.6636884134,-68.2313731082,-2.28672487976,3.86795279117,-30.985220254,-13.8609783949,7.25078689505,-8.46930158421,21.7170028918,15.5861263704,17.3512045335,-2.81471356686,-4.09660693514,30.1238726608,-30.4723711719,13.8960601669,-10.3223284128,-2.86110101385,-12.9190601123,-0.162645801462,-7.17499759167,-0.365847582557,-6.15447220531,-0.13003762168,0.617808735968,1.34683188804,-0.0449380202297,4.43363678046,8.99244449034,-5.72659299429,8.51501887447,-2.32331106613,0.307098595804,-1.68091936528,-2.08743355216,-3.91057462609,-0.918973621203,-0.528378409508,1.15118348258,-1.9946672628,-1.50378300604,-1.07290317341,0.0577008435459,-2.35789780255,2.10136061736,0.56897673587,0.344474352654,3.01797013954,-0.484387940952,2.68287098094,0.177964755618,-0.240029221316,-0.922202442239,-0.0509057256718,-0.932215734226,-0.105959064928,-0.315884128696,0.387973883548,-0.232562932366,-0.800928294676,-0.526792277,-0.509508309713,-0.588355272144,0.275191602868,-0.365596201041,0.868948597394,0.543251054371,0.0584500880555,0.910930811679,0.558455924817,0.101698715353,0.144901728818,0.0715938739345,-0.136353763255,0.0129118757213,-0.259594076905,0.0093999132349,-0.21350125192],[-38308.9878223,-369.617837756,-78.6737533795,-865.461968157,894.678398936,2386.06820097,-308.60607664,507.946424219,-971.01970716,22.1461892207,-401.388212122,-158.356986846,-427.261118563,217.586147919,-708.768158977,330.91587599,-665.768903164,120.621259225,-336.210233103,-305.642561492,-324.331384035,-21.3732913876,-99.7689277449,283.040588337,125.688738746,-117.54836316,42.4330675885,-39.940505691,-56.019610119,65.8014263149,26.2788465792,6.63367766827,33.7371496025,55.792719763,10.3560929941,28.0230281393,-39.8944340357,96.9927244886,32.5466642665,-2.73667028872,21.7550844832,-11.780345325,30.1565028666,-69.9531556575,-2.66195248468,2.54443045343,-31.1395740263,-15.6744808208,7.3630051748,-8.247210048,22.1016118116,15.5749729191,18.1416724581,-2.21857975338,-4.19184231001,31.8308266438,-31.0998188137,14.5476514215,-10.8900454243,-2.98883406193,-13.2570266581,-0.315853409897,-7.48444399624,-0.465233270901,-6.18993536706,-0.366481527844,0.514890497838,1.67215961232,0.0530963866361,4.64616310287,9.3145023665,-5.84109757206,9.00360044937,-2.48337300835,0.3754418037,-1.82629699947,-2.10301770227,-4.15352362714,-0.924783399443,-0.595513134016,1.16987497557,-2.01695155493,-1.57702737439,-1.1159915397,0.113589760076,-2.40491721991,2.24041313059,0.580718233284,0.401194371242,3.13238375408,-0.524983141152,2.75326307113,0.0920191625258,-0.216850316278,-0.988447906301,-0.0261173155891,-0.984574101661,-0.0686227523561,-0.350350060206,0.411114478601,-0.224985307171,-0.816242292336,-0.533723610778,-0.51724703192,-0.60863672777,0.300912808738,-0.376456105116,0.908711220594,0.554870520658,0.0631684157729,0.94210804303,0.552612088946,0.122344603814,0.139497794871,0.0868987319926,-0.146938417947,0.02770917608,-0.27461263082,0.0125679048572,-0.216943729737],[-38320.026063,-370.709983925,-111.366050674,-876.167096196,935.612971173,2389.59451895,-311.967591468,521.308906291,-997.82268403,50.1638233251,-468.724494511,-157.582383289,-365.343894576,206.365162778,-717.68284798,336.208915157,-672.536071134,104.342753683,-342.386746285,-285.159881131,-319.483479408,-26.7397007086,-94.881041664,285.531491573,130.390900492,-122.296540664,52.7716458755,-45.7115144984,-58.7786096628,68.1100770179,19.9166576728,9.37091022878,28.9241283995,51.8325416201,4.69700207232,30.1764082967,-40.3875284678,102.057970631,31.7484357317,-2.8623770131,21.9334172122,-12.6994715853,33.5967621079,-71.7012285035,-2.81394281572,1.16326612704,-31.3489061367,-17.4859636764,7.48725350215,-8.0429709918,22.4262034183,15.5299516925,18.8556135659,-1.67053441531,-4.29906561433,33.4653729251,-31.7132473795,15.2346352032,-11.4345172241,-3.11426678971,-13.5449901753,-0.47547159075,-7.75371542157,-0.554771876876,-6.20862459906,-0.60207310425,0.410958995143,1.97221888201,0.143526876129,4.83879704509,9.60975113117,-5.95463458501,9.47121917663,-2.63367479779,0.446518638701,-1.95901556743,-2.11822633426,-4.37753491906,-0.919028548592,-0.664057514637,1.1880390846,-2.03157734617,-1.64479672113,-1.15357771542,0.16773122304,-2.44985725202,2.37178759272,0.589201970084,0.455477650549,3.23434594638,-0.566880734912,2.82047175956,0.00698448398991,-0.195540377413,-1.05215394721,0.00451011132164,-1.03396330456,-0.0298165957413,-0.384823314202,0.433116234867,-0.216474461273,-0.829708546073,-0.537994279601,-0.523228859438,-0.628012603242,0.325257961679,-0.386279525584,0.946614806986,0.563764203882,0.065807953764,0.971264961255,0.545981138062,0.14156856813,0.133088524925,0.103086989192,-0.15622583019,0.042317340224,-0.288754284955,0.0153350147038,-0.220272974155],[-38340.0876322,-374.013083394,-143.84895938,-887.837536833,977.721521955,2389.02032621,-314.529663118,534.611210706,-1022.35913801,79.3429432203,-537.270127077,-156.199903709,-302.699611397,195.653954731,-726.594755078,341.721491667,-678.170223811,88.1914690743,-348.109535767,-262.848385052,-313.653860819,-31.8344145682,-89.7246867244,288.638696517,134.840574399,-127.371759652,63.0821809222,-51.5699375673,-60.8286275219,69.8710904973,13.6840211156,12.0781708891,23.796407086,48.3900364208,-1.15473036798,32.276103773,-41.0685166531,106.915453081,30.8585327173,-2.89972829177,21.8357252537,-13.5270133453,36.9493316715,-73.4533899545,-2.7185113492,-0.256605794801,-31.6150150289,-19.2950424808,7.62972405725,-7.86000004616,22.690858009,15.4443257971,19.4839041912,-1.17874654624,-4.40791930448,35.0137047507,-32.2991758428,15.9550307401,-11.9516348189,-3.23455310489,-13.7845734175,-0.640027777972,-7.98220546685,-0.631849166429,-6.20866612896,-0.835438535646,0.305606937661,2.24251457395,0.224946600902,5.00906187012,9.87503279683,-6.06363603552,9.91302983108,-2.77280384553,0.5193795669,-2.07821134336,-2.1330505085,-4.58125407284,-0.901462199677,-0.73463111313,1.20551253262,-2.03752264698,-1.70626019249,-1.18542202961,0.219337666362,-2.4926868325,2.49364287846,0.594008286702,0.506869210328,3.32218694997,-0.609540451504,2.88334484177,-0.0767680117813,-0.176346116045,-1.11290172577,0.0409182417764,-1.08036034881,0.00998964387804,-0.419031425543,0.45369017947,-0.206823109788,-0.841164159445,-0.539412542874,-0.527263574845,-0.646313055064,0.347845786477,-0.394972377265,0.982265641093,0.569732477519,0.06646678725,0.997932609928,0.538622559635,0.159053779775,0.125666024503,0.120070915419,-0.164235518173,0.0565772709484,-0.301855280913,0.0177489441657,-0.223454368822],[-38368.2211879,-378.01533715,-176.200432964,-899.669453067,1020.48948705,2385.10473771,-316.505963454,547.423674478,-1044.39862095,109.294194777,-606.459750807,-154.125420103,-239.436692016,185.631956111,-735.581489034,347.394589468,-682.656625579,72.2181552314,-353.270499233,-238.651840986,-306.87001423,-36.8336665347,-84.4949336011,292.237593474,138.96098301,-132.735805596,73.2131997792,-57.4921433386,-62.0714853676,71.090867617,7.59774731819,14.7161068799,18.3693973925,45.5333134696,-7.12223578436,34.2987351558,-41.9373672151,111.526494463,29.8495740399,-2.83530749513,21.4545173724,-14.2267510306,40.1790770912,-75.1874383189,-2.35147356141,-1.6962509189,-31.9396991468,-21.1013327527,7.79660902028,-7.70171284159,22.8956558812,15.3113583397,20.0174206683,-0.751385139788,-4.50804583686,36.4620153671,-32.8441231771,16.7068572599,-12.4372892154,-3.34684691518,-13.977399138,-0.808049405513,-8.16930773129,-0.693850905508,-6.18818618441,-1.06520400678,0.19842703517,2.47855156494,0.295948713607,5.15448084094,10.107189376,-6.16453392597,10.3241871875,-2.89934756267,0.593075054389,-2.1830206015,-2.14748128539,-4.76332665945,-0.871837483727,-0.807853491258,1.22213204262,-2.03376546786,-1.7605869347,-1.21128481127,0.267621523968,-2.533374895,2.60413786251,0.594717523567,0.55491407033,3.39423699838,-0.652422020198,2.94073011331,-0.15886705658,-0.159514243497,-1.1702724028,0.0830487624909,-1.12374224033,0.0503262054633,-0.452701929092,0.472547339532,-0.195823967829,-0.850446236009,-0.537786660002,-0.529160960718,-0.663368239743,0.368295007923,-0.402440574977,1.01527000743,0.572575715045,0.0652430014522,1.02164203262,0.530595841134,0.174483410223,0.117222399129,0.137762780562,-0.170987000084,0.0703298710485,-0.313751860295,0.019857394634,-0.22645329739],[-38403.4753877,-381.204946181,-208.498424895,-910.859007898,1063.40230221,2378.60686841,-318.110164345,559.316634625,-1063.7106847,139.628223866,-675.728006687,-151.274804468,-175.663559426,176.478599251,-744.720658609,353.169192508,-685.980540825,56.4735619886,-357.761534363,-212.514016663,-299.159425603,-41.9136901764,-79.386852969,296.20357275,142.675348866,-138.350463966,83.013229497,-63.4545002534,-62.4090048715,71.7758092409,1.67464669137,17.245365432,12.6585110496,43.3304820708,-13.1286456343,36.2209230326,-42.9940487772,115.852417402,28.694178516,-2.65569799358,20.7823023331,-14.7624650668,43.2508639012,-76.8811719049,-1.68864492865,-3.13673485207,-32.3247569339,-22.9044500111,7.99410057141,-7.57152500864,23.0406773319,15.1243124272,20.4470393314,-0.396619189553,-4.58908766784,37.7964980203,-33.3346083559,17.4881339906,-12.8873714203,-3.44830212829,-14.1250900901,-0.978063907327,-8.31441581408,-0.73816286006,-6.14531099305,-1.28999570241,0.0890119974488,2.67583473179,0.355126366896,5.27257722055,10.303062881,-6.25376025872,10.6998460208,-3.01189336034,0.666655567261,-2.27257961603,-2.16150972531,-4.92239824989,-0.829907531769,-0.88434421078,1.23773433755,-2.01928381929,-1.80694609401,-1.23092638944,0.311795229783,-2.57189037315,2.70143141959,0.59091002111,0.599157250309,3.44882632516,-0.694985170265,2.99147536972,-0.238941382197,-0.145291471092,-1.2238471391,0.130843360181,-1.16408598501,0.0907233279759,-0.485562359709,0.489398742178,-0.183269750509,-0.857391879323,-0.532924890389,-0.528730799634,-0.679008313785,0.386224350802,-0.408590033541,1.04523419053,0.572094289937,0.0622346815918,1.04192427292,0.521960470029,0.187540630949,0.107749754325,0.156074854508,-0.176499794114,0.0834160433195,-0.324280264701,0.0217080674997,-0.229235143508],[-38444.7759042,-382.349879418,-240.958933703,-920.784927293,1105.80586211,2370.15013765,-319.49500712,569.844300955,-1080.19082845,169.949752332,-744.540692086,-147.5769486,-111.553101122,168.281162954,-754.038303392,358.977773107,-688.131457472,41.0045550962,-361.508717792,-184.416528388,-290.572225505,-47.2207466321,-74.5551971405,300.430239423,145.911553925,-144.17412922,92.3423539918,-69.4444220416,-61.7606527622,71.9406977172,-4.06054686544,19.6364699454,6.68444530636,41.8390338922,-19.1078951879,38.022458997,-44.2370456735,119.861320212,27.3670090196,-2.34838380469,19.8148578666,-15.0979242564,46.1342411558,-78.512187913,-0.711768572253,-4.56106926829,-32.7713459442,-24.7033248983,8.22797058887,-7.47223491675,23.126482251,14.8777520938,20.7658248253,-0.121453773754,-4.64082747328,39.0052712222,-33.7577229106,18.2962240412,-13.2987723185,-3.53661772507,-14.2295306573,-1.14855948911,-8.41747249428,-0.762555824368,-6.07850946262,-1.50858712655,-0.0229962966961,2.83055695266,0.401191404236,5.36133821023,10.4599436284,-6.32808548685,11.035772104,-3.10912663909,0.739027529478,-2.34630806438,-2.17494801641,-5.05748396409,-0.77564137616,-0.964519793585,1.25215516071,-1.99325167637,-1.844617296,-1.24418456147,0.351144728882,-2.60828200884,2.78392213795,0.582204804487,0.639186153068,3.48452424425,-0.736664228206,3.0345210269,-0.31672345434,-0.133887251212,-1.27326500133,0.184141111533,-1.20138903763,0.130755027419,-0.517389756697,0.503993078746,-0.168991192354,-0.861874556167,-0.524674210054,-0.525830699387,-0.693085989007,0.401295496454,-0.413345956102,1.07181601247,0.568125759861,0.0575655940487,1.05835735072,0.512782782096,0.197943033007,0.0972507654921,0.174916162919,-0.180805224181,0.0956971027579,-0.333325903086,0.0233387522904,-0.231770693089],[-38490.5564672,-381.337177567,-274.350138162,-929.556189088,1146.487897,2359.81518237,-320.569510974,578.496374461,-1094.23834073,199.83980592,-812.48822991,-143.012823484,-47.5360626253,160.758311904,-763.354186282,364.71875708,-689.115757591,25.8424639695,-364.574841946,-154.492386752,-281.249122934,-52.7812073226,-69.9934449769,304.884057665,148.616117808,-150.151631752,101.106884643,-75.4935035886,-60.116475997,71.6338413314,-9.55140549782,21.8994484973,0.489039486232,41.0739900554,-25.037134965,39.6958186662,-45.6589050805,123.548403966,25.8509046536,-1.90445153471,18.5610375693,-15.1968509096,48.8174919911,-80.0572791122,0.573701806389,-5.96005011029,-33.2780601714,-26.4941485497,8.5023097431,-7.40417189096,23.1555488971,14.5714450852,20.9755950367,0.07176169093,-4.65360880682,40.0841545463,-34.1028486035,19.1258660451,-13.6723823078,-3.61167297899,-14.2936517433,-1.31786744357,-8.48061727044,-0.766340706055,-5.98762122119,-1.72034106037,-0.137759292343,2.94166311103,0.433330432347,5.42060676446,10.5769151499,-6.38563386616,11.3301752033,-3.1901247574,0.808521196478,-2.40475923671,-2.18689285781,-5.16907711766,-0.709871654575,-1.04798460207,1.26522633677,-1.95562687264,-1.87332208373,-1.25120699806,0.38525001093,-2.64291777699,2.85096746004,0.568375637753,0.674757713614,3.50085639137,-0.776791909438,3.06917798229,-0.392360674381,-0.12536200047,-1.3183966795,0.242370653115,-1.23573064837,0.170170427965,-0.548159177127,0.516229697431,-0.152971105531,-0.863913186211,-0.513036461456,-0.520509568636,-0.70554419847,0.413341952408,-0.41671069912,1.09487944565,0.560656419247,0.0514622298372,1.07070719128,0.50315650635,0.205545885773,0.0857703875352,0.194182754552,-0.18398183712,0.107116013165,-0.340970853809,0.0247475910789,-0.234052341096],[-38539.1278214,-378.33364928,-309.578262108,-937.464334081,1184.09659603,2347.54694389,-321.181764567,584.746428932,-1106.3784574,228.873486351,-879.192199447,-137.576419905,15.8923460382,153.536557255,-772.436501003,370.282058613,-688.944046795,11.0147339402,-367.056878207,-122.912450921,-271.353471492,-58.5914712394,-65.6547569771,309.549706422,150.740219555,-156.224410946,109.224689697,-81.6443850688,-57.4841665905,70.9119298533,-14.7335778626,24.054205334,-5.88058156873,41.0397540451,-30.904319298,41.2366486632,-47.2506898853,126.915645427,24.1307485782,-1.3158884371,17.0329640039,-15.0229557135,51.2935830635,-81.4930371635,2.15638486085,-7.32641938797,-33.8428527196,-28.2724272243,8.8207884026,-7.36704799524,23.1308351215,14.2064600746,21.0803561628,0.181841703205,-4.61791544156,41.0308928317,-34.3599397549,19.9711425167,-14.010091664,-3.67389223667,-14.320645882,-1.48427983514,-8.50653882096,-0.749213441081,-5.87282857695,-1.92476760431,-0.255389265544,3.00878609173,0.450848748766,5.45068977602,10.6535092811,-6.42486810318,11.581876083,-3.25406306319,0.87332278157,-2.44876982642,-2.19626207639,-5.2580405752,-0.633646906021,-1.13413995878,1.27677871068,-1.90656320628,-1.89289247959,-1.25221883823,0.413764576741,-2.6762454608,2.90216454186,0.549234969692,0.705671250007,3.49758748265,-0.814675526609,3.09484975366,-0.466104177605,-0.119738876538,-1.35917076944,0.304858011463,-1.2672105163,0.208762430825,-0.577895182513,0.526045610644,-0.13523032162,-0.863563052348,-0.498052203669,-0.512864141255,-0.716348430548,0.422240182744,-0.418705907379,1.11434,0.549709746715,0.0441767611303,1.0787866962,0.493182220111,0.210238878207,0.0733641452363,0.213767433939,-0.186119985495,0.117636150542,-0.347346362583,0.0259228140748,-0.236077884756],[-38588.8007113,-373.506103206,-347.549529375,-944.800903075,1217.28014834,2333.29036353,-321.179856558,588.068038156,-1117.13641433,256.625895344,-944.274179988,-131.261728646,78.2369148424,146.24241016,-781.053441279,375.557591896,-687.626930692,-3.45118965987,-369.051797952,-89.847580061,-261.048624783,-64.6479373738,-61.4922936398,314.411864639,152.235038201,-162.333906183,116.613637398,-87.9397066566,-53.8714165572,69.8316530529,-19.5427126166,26.1206447019,-12.3772930165,41.7407293461,-36.6974025192,42.6405956112,-49.003462975,129.965021355,22.1914239537,-0.57468176528,15.2427597331,-14.5399493553,53.5554810294,-82.7960537279,4.02489924469,-8.65291911124,-34.4636766927,-30.0336671808,9.18707693588,-7.36057529352,23.0552987753,13.7838657352,21.0841144008,0.207600761778,-4.5242311506,41.8432309176,-34.5189506851,20.8261359705,-14.3137906631,-3.72369984471,-14.3137056072,-1.64608872827,-8.49792582426,-0.710869965404,-5.73431383806,-2.12137685881,-0.375998492348,3.03155877959,0.453051651027,5.4518941377,10.6892578577,-6.44425090441,11.7896955077,-3.30011690441,0.93161849806,-2.47917652686,-2.20197349905,-5.32523720126,-0.548015669502,-1.22238718622,1.28664312743,-1.84621447545,-1.90316050598,-1.24744522102,0.43634192713,-2.70871284343,2.9371105394,0.524595249086,0.731726080305,3.47448223421,-0.849622392366,3.11093985882,-0.538205099301,-0.117041037088,-1.39551586703,0.370929213116,-1.29592834048,0.246323937215,-0.606622334368,0.533377830795,-0.115789672198,-0.860879437471,-0.479761995766,-0.50299115112,-0.725464173614,0.427866651541,-0.419353225667,1.13011318549,0.535309220885,0.035961360101,1.08240876705,0.482960500701,0.211911699266,0.0600875633773,0.233563005612,-0.18731002187,0.127220890893,-0.352583675119,0.0268526514876,-0.237845121295],[-38637.8858813,-367.021347997,-389.1701638,-951.85743687,1244.6867431,2316.99038263,-320.411875607,587.93477592,-1127.03744738,282.672134619,-1007.35575082,-124.062740489,139.002433761,138.502381772,-788.973200835,380.435271113,-685.175014892,-17.5278614991,-370.656572562,-55.4686333377,-250.497936411,-70.9470047173,-57.4592154639,319.45521126,153.051752785,-168.421556844,123.191595991,-94.4221085263,-49.2859179115,68.4497007001,-23.9144584167,28.1186708475,-18.9539700149,43.1813194432,-42.4043389612,43.9033061332,-50.9082872366,132.698508514,20.0178139402,0.32718122731,13.2025473194,-13.7115425219,55.5961525452,-83.9429204666,6.1678636115,-9.93229129002,-35.1384851945,-31.7733746782,9.60484571144,-7.38446584977,22.9318977097,13.3047307402,20.9908759481,0.147853365354,-4.36303970703,42.5189136429,-34.5698357142,21.6849289209,-14.5853695811,-3.76152014973,-14.2760234525,-1.8015861874,-8.45746695873,-0.651006214984,-5.5722593127,-2.30967892431,-0.499699248806,3.00961405941,0.439244436666,5.42452674228,10.6836927155,-6.44224497636,11.9524542418,-3.32746162899,0.981594559257,-2.49681603142,-2.20294495265,-5.37152986042,-0.454026484022,-1.31212760693,1.294650432,-1.77473447831,-1.9039581853,-1.23711128543,0.45263556291,-2.74076770809,2.95540260866,0.494268924716,0.752721522566,3.43130536219,-0.880939819356,3.11685181555,-0.608914574753,-0.117291639791,-1.42736056809,0.43991028461,-1.32198381998,0.282647848347,-0.634365194205,0.538163370296,-0.094669988846,-0.855917624472,-0.458206396819,-0.490987332105,-0.732856916039,0.430097822881,-0.418674298769,1.14211451206,0.517478320377,0.0270681989222,1.08138630544,0.472591925442,0.210454037908,0.0459961667402,0.253462274102,-0.187642298811,0.135833610218,-0.35681403713,0.0275253335267,-0.239351847938],[-38685.1746697,-359.146054041,-435.035383763,-959.006715619,1265.27363601,2298.70860621,-318.74441712,583.997700165,-1136.51296141,306.720871959,-1068.1042132,-115.961453168,197.743250777,129.928518511,-795.959910707,384.82718931,-681.570329862,-31.2018185886,-371.93778974,-19.9658687756,-239.843590264,-77.4867473903,-53.4994645257,324.663057412,153.149124468,-174.420739233,128.886908499,-101.119500823,-43.7453770747,66.8284137718,-27.7941302788,30.0635021639,-25.5672927348,45.3582067177,-48.0125920766,45.0200211348,-52.9537724694,135.120428319,17.6015303297,1.39799507973,10.9311311661,-12.5079054489,57.4084168287,-84.9132373155,8.56883424892,-11.1562476616,-35.8636450514,-33.4860644867,10.0762811327,-7.4386743326,22.7642198848,12.7710372418,20.8060938603,0.00379916425032,-4.12606303405,43.056793441,-34.5038432688,22.5413847209,-14.8258073272,-3.7872076363,-14.2107107164,-1.94926021434,-8.38798400549,-0.569536271821,-5.38734605332,-2.48918078104,-0.626681385827,2.94319568054,0.409179810015,5.36946698131,10.6370326333,-6.41745661049,12.0695237701,-3.33523218427,1.0218679723,-2.50270248272,-2.1981895243,-5.39794160615,-0.352723175921,-1.40249814165,1.30071485047,-1.69247741705,-1.89525514691,-1.2215673426,0.462379749665,-2.77278721225,2.95692750729,0.458261178357,0.768566356254,3.36810574533,-0.907902324748,3.11221900711,-0.678481775398,-0.120483513744,-1.45472001187,0.511118181315,-1.34543503922,0.317565132738,-0.661120075088,0.540384976387,-0.0719278761447,-0.848768211078,-0.433480940261,-0.476971361899,-0.73852283146,0.428872494953,-0.416685606262,1.15030967559,0.496296959017,0.0177670722944,1.07561339123,0.462174867005,0.205794283447,0.0311488920216,0.273351713051,-0.187192202814,0.143453116322,-0.360158923561,0.0279257957763,-0.24059234855],[-38731.3807888,-350.546338684,-484.49638582,-966.946476877,1279.23434914,2278.97329417,-316.118103497,576.617805427,-1145.61903731,329.015039399,-1126.36975623,-106.891892215,254.211945908,120.075007859,-801.761451166,388.734154958,-676.680605487,-44.5155273113,-372.840502498,16.3928601636,-229.143091372,-84.2719400291,-49.5201092126,330.013242954,152.516242896,-180.232577339,133.669817047,-108.000873576,-37.3075580948,65.0527380744,-31.1657086558,31.951613632,-32.1891613973,48.2371891361,-53.5076618002,45.9843586507,-55.1187161203,137.244480797,14.9610994419,2.64718150101,8.47404303809,-10.9250465639,58.9845033431,-85.6986373104,11.1911179808,-12.3123788733,-36.6291779794,-35.1622854218,10.5976337432,-7.52412582934,22.5583736962,12.1884213077,20.5410086272,-0.213821584772,-3.80997565525,43.4601531212,-34.3173981998,23.3884900769,-15.032437345,-3.79833734076,-14.1205537546,-2.08838256028,-8.29283115632,-0.467246802083,-5.18225008946,-2.65937692843,-0.757445053755,2.83499085039,0.364400102597,5.2898842415,10.5522441635,-6.36906643812,12.1424784591,-3.32240191527,1.05277891964,-2.49855982036,-2.18710134188,-5.40613624758,-0.24513072087,-1.491578104,1.30508413335,-1.60059910988,-1.877571448,-1.20166439201,0.465631812055,-2.80486601063,2.94273039956,0.417348123755,0.77960720645,3.28606891285,-0.929653243797,3.09759427857,-0.747148017259,-0.126488173751,-1.47795551108,0.583833573916,-1.36617362407,0.35105902812,-0.686770296287,0.540208335632,-0.0477630306864,-0.839663054341,-0.405901056959,-0.461149693443,-0.742580834562,0.4243788024,-0.413382966886,1.15486511566,0.472070791456,0.00839826502827,1.06530881735,0.451798879464,0.198015626623,0.015618323577,0.293092472538,-0.185975256103,0.150119944207,-0.362700726289,0.0280257953196,-0.24154685354],[-38777.6985447,-341.98818101,-536.593361076,-976.455697554,1287.07147109,2258.42937013,-312.492063883,566.333570399,-1154.31792495,349.931135038,-1182.04829096,-96.7760901086,308.210657177,108.481572563,-806.121639796,392.179155383,-670.344996508,-57.5254363932,-373.279380173,53.3203011588,-218.43277505,-91.3090323991,-45.4189994898,335.482239924,151.149779841,-185.750132074,137.521038537,-115.020486783,-30.0402394262,63.2132706212,-34.0228403595,33.7747943792,-38.7952812366,51.7763435616,-58.8745571871,46.7895309982,-57.3794625487,139.086710629,12.1217762281,4.08444399268,5.88349654099,-8.96543384323,60.3164941129,-86.2937617619,13.9929592652,-13.3872452995,-37.423519417,-36.7915948104,11.163670121,-7.64198803198,22.3210976487,11.5634324846,20.2083075972,-0.49188347334,-3.4126902443,43.733383087,-34.0082194645,24.2190125336,-15.2016817112,-3.79191443741,-14.0082576876,-2.21842091378,-8.17549570572,-0.345142617981,-4.96014619494,-2.81975874568,-0.892567977792,2.68829764086,0.306895052734,5.1895204083,10.4329808016,-6.29639867551,12.1734433958,-3.2879037664,1.07509837756,-2.48628943319,-2.16916979348,-5.39793778274,-0.132269381874,-1.57718240581,1.30808941224,-1.50045577903,-1.85156475268,-1.17837860522,0.462529839508,-2.83702813228,2.91414605136,0.37249860765,0.786300159637,3.18666455657,-0.945303116281,3.07376034045,-0.815152652508,-0.135146806039,-1.49751492184,0.657328061932,-1.38404958579,0.383150839528,-0.711170928624,0.537844869427,-0.0224109220659,-0.82886932615,-0.375837152139,-0.443750723493,-0.74518052529,0.416867213972,-0.408757034172,1.15599745778,0.445161907548,-0.000680315537876,1.05077255504,0.441551312241,0.187239958534,-0.000519542323292,0.312539371752,-0.183992014836,0.155890060678,-0.364512066423,0.0277937946146,-0.242192079955],[-38825.3222435,-334.237560103,-590.366500631,-988.313354557,1289.28759049,2237.72175768,-307.825427424,553.683473769,-1162.57187421,369.845656973,-1235.03572847,-85.5360793303,359.541522611,94.6879353701,-808.78429418,395.185177912,-662.402657668,-70.2879945601,-373.169092102,90.529201889,-207.748976615,-98.6044742658,-41.0939853221,341.046520362,149.046407075,-190.86646435,140.421289872,-122.132600444,-22.0111995236,61.4006084256,-36.3591722018,35.524833533,-45.3613574867,55.9337468573,-64.0982872924,47.4287504945,-59.7123561137,140.663162495,9.10881563968,5.71948605627,3.2117052803,-6.63153526282,61.3964711624,-86.6932519807,16.9326025599,-14.3674073149,-38.2351048027,-38.3635499793,11.7691568447,-7.79342863251,22.0591302468,10.9026203188,19.8206781186,-0.817261093082,-2.93211947488,43.8808737419,-33.5740260202,25.0257196359,-15.3299625027,-3.76494410054,-13.8765276355,-2.3388429634,-8.03946494817,-0.204228531723,-4.72420914361,-2.969817612,-1.03262788314,2.50641412388,0.238654398746,5.0721173672,10.2828960432,-6.19877753892,12.1645436671,-3.23067068208,1.08959732236,-2.46779271006,-2.14388426718,-5.37517020966,-0.0151594219368,-1.65712595889,1.31006181877,-1.39340364674,-1.81789272512,-1.1526861538,0.453211921453,-2.86929760622,2.87250922863,0.32468147678,0.789101302301,3.0713623683,-0.953962481978,3.04149990327,-0.882735033317,-0.146300596838,-1.51384610025,0.730873244878,-1.39891293561,0.413861871995,-0.734177042921,0.533505999166,0.00389298012189,-0.816654198389,-0.343659631029,-0.425002848803,-0.746471503593,0.406588198423,-0.402798461652,1.15392332745,0.41593239715,-0.00911076206585,1.03230457552,0.431519514759,0.173589170274,-0.0171887094092,0.331547229881,-0.18124303517,0.16081943254,-0.365665565073,0.0271982561193,-0.242504744844],[-38875.4461912,-328.060455048,-644.855995589,-1003.2984248,1286.38529597,2217.49538043,-302.077323266,539.205994227,-1170.34313499,389.135103304,-1285.22797982,-73.0938923602,408.006680235,78.2338190285,-809.4932319,397.775209874,-652.692743707,-82.8596505379,-372.424307622,127.732310033,-197.128031382,-106.164715394,-36.4429166748,346.682556307,146.202796366,-195.474635076,142.351287954,-129.291474559,-13.2882168416,59.705348501,-38.1683509947,37.1935202209,-51.8630953816,60.6674758861,-69.1638611712,47.895229457,-62.0937411745,141.989881077,5.94747262796,7.56201119331,0.510882861533,-3.92581879877,62.2165165162,-86.8917492774,19.9682923231,-15.2394252941,-39.0523695747,-39.8677082554,12.4088604924,-7.97961532293,21.7792099952,10.2125343572,19.3908075396,-1.17682903563,-2.36617602066,43.9070154895,-33.0125368239,25.8013789286,-15.4137017963,-3.71443150445,-13.7280687188,-2.4491163977,-7.88822617816,-0.0455093555182,-4.47761370927,-3.10904490661,-1.178202495,2.29263837135,0.161667878953,4.94141700366,10.1056433839,-6.07552724461,12.1179043599,-3.14963560673,1.09704673031,-2.44497103982,-2.11073415109,-5.33965752636,0.105178895936,-1.72922367509,1.31133248454,-1.28079893523,-1.77721302943,-1.12556320934,0.437816147318,-2.90169846148,2.81915469728,0.274865577884,0.788466720928,2.94163203988,-0.954741880663,3.00159567756,-0.950134511857,-0.159790732375,-1.52739690243,0.803740722272,-1.41061368477,0.443213430559,-0.75564371,0.527403146243,0.0309132062822,-0.803284842945,-0.309738898854,-0.405134466128,-0.746603369418,0.393792224505,-0.395497902856,1.14885935017,0.384744350117,-0.0165351672174,1.01020485,0.421790836443,0.157185152941,-0.0343131814104,0.349970866115,-0.177728873262,0.164964026596,-0.366233843349,0.0262076422917,-0.242461565253],[-38928.4694847,-324.18570695,-699.161943085,-1022.00505026,1278.70269093,2198.29047632,-295.237664512,523.219830467,-1177.57639234,408.055510821,-1332.53221876,-59.3834081817,453.345900029,58.7747016576,-808.026107536,399.94993055,-641.11300377,-95.2956675078,-370.980898983,164.636581538,-186.603062652,-113.971249048,-31.3963370408,352.360652027,142.617646983,-199.481531765,143.301860183,-136.453109611,-3.9452200277,58.2162926349,-39.4509448767,38.7704911923,-58.2812455125,65.9403912866,-74.0522008873,48.181634019,-64.4979964546,143.08263828,2.66295857615,9.61799492779,-2.16694992632,-0.857604374346,62.7709195468,-86.8869668632,23.0635115869,-15.989127164,-39.8629538327,-41.2958535982,13.0769922837,-8.2006041238,21.4883002964,9.49950601743,18.931161196,-1.55729254123,-1.71447748437,43.8172827059,-32.3235534529,26.5402067865,-15.4496648868,-3.63768110138,-13.5661657206,-2.54959010318,-7.72476581003,0.129871426371,-4.22349222046,-3.23699179916,-1.32958617574,2.05059852728,0.0781253696619,4.80101869501,9.90513402213,-5.92634220565,12.0360873022,-3.04413424369,1.09842477961,-2.41951813718,-2.06961274759,-5.29296449079,0.227786293962,-1.79139330083,1.31221811376,-1.16404505129,-1.73024894589,-1.09791460504,0.41657084541,-2.9341727939,2.75547826433,0.224032888852,0.78485068432,2.79907920194,-0.946954297316,2.95489297933,-1.01748633032,-0.175502813817,-1.53854758897,0.875253988621,-1.41896527717,0.471228230201,-0.77542675857,0.51975495652,0.0583938790828,-0.789035796034,-0.274456930312,-0.384370284008,-0.74572749151,0.378751403979,-0.386857714601,1.14103680426,0.35196548019,-0.0226373280954,0.984812119052,0.412449232792,0.138177980545,-0.051800262565,0.36768311527,-0.173442160838,0.168387288756,-0.366283000839,0.0248013554929,-0.242053515354],[-38981.6103842,-323.193605004,-752.624064389,-1044.28803331,1265.91993796,2180.22854061,-287.419500097,505.164561194,-1184.14607212,426.381071097,-1376.90066982,-44.3858917896,495.049479789,36.4290828663,-804.295923649,401.620787045,-627.795564616,-107.646566472,-368.859550095,200.925805422,-176.194345668,-121.905742483,-26.0155640253,358.026440699,138.297768172,-202.849348321,143.304275956,-143.580468016,5.91926149891,57.0150617103,-40.2352072932,40.236773683,-64.6167398996,71.7344887986,-78.7278805394,48.2784455785,-66.891638135,143.956114912,-0.71968940543,11.8785008735,-4.77054356038,2.53638029836,63.0627990179,-86.6889055513,26.2026976816,-16.5994110611,-40.6513163199,-42.6486764973,13.7655420017,-8.45200437006,21.1942641448,8.76899420244,18.4533163723,-1.94467944469,-0.983461184861,43.6214856579,-31.515207964,27.2422149046,-15.4359899406,-3.53319445539,-13.3964220758,-2.64413775813,-7.55006673759,0.320215641478,-3.96480722455,-3.35344862116,-1.48593983631,1.785243024,-0.00898270087834,4.65395178602,9.68630996788,-5.75239762233,11.9234012858,-2.91511333201,1.09553845612,-2.39229702032,-2.02202901621,-5.23561890046,0.351947435256,-1.84196392098,1.31297770107,-1.04473413995,-1.67798621924,-1.07035982077,0.390065299553,-2.96633496659,2.68311990132,0.173217912176,0.778700190556,2.64585324035,-0.930722497725,2.9024875466,-1.084509291,-0.193500102071,-1.54740803848,0.944944118394,-1.42363488724,0.497934625699,-0.793385048903,0.510808973713,0.0859974902414,-0.774211051181,-0.238241977977,-0.362920258118,-0.744002313806,0.361824420636,-0.376927066838,1.13074557922,0.31798599666,-0.0272678595665,0.956620200611,0.403565083623,0.116830458758,-0.0694904591436,0.384628874673,-0.168343831897,0.171182581337,-0.365853051041,0.0230025576972,-0.241328597811],[-39031.2919408,-325.627300427,-804.641986805,-1069.81734137,1247.55271445,2163.32638286,-278.766662913,484.259985121,-1189.90903537,443.765514395,-1418.29682021,-28.0944546815,532.545349266,11.4312176358,-798.249519796,402.676918419,-612.931147406,-119.961682889,-366.102147778,236.277978969,-165.91894366,-129.824906453,-20.3946087613,363.619387729,133.251996679,-205.55410525,142.39991517,-150.638252677,16.2005481262,56.1814813843,-40.5563130164,41.5712425508,-70.8755559202,78.0365479376,-83.1513872347,48.1755993498,-69.239216761,144.624719006,-4.17547777466,14.3308646666,-7.24884133432,6.21255556005,63.0974810415,-86.3106380552,29.3755265115,-17.0524426741,-41.4011204409,-43.9290940753,14.4659440709,-8.72831372519,20.9051894327,8.02623968631,17.9686283406,-2.32484822941,-0.181269370035,43.3305185849,-30.5977150342,27.9088638076,-15.371158342,-3.39977240849,-13.2250208819,-2.73751423881,-7.36461097447,0.523686445284,-3.7044788236,-3.45826549458,-1.64614102487,1.50185036592,-0.0964657664333,4.5031031133,9.454370934,-5.55523889172,11.7845918434,-2.7639223697,1.09040194761,-2.36396303326,-1.96989583079,-5.1678893128,0.477007968155,-1.87936745502,1.3138558137,-0.924505530753,-1.62147621037,-1.04344699803,0.358979032445,-2.99771740946,2.60378062089,0.123468281499,0.770460420036,2.48423947981,-0.906371692879,2.84553772287,-1.15081808619,-0.213890272986,-1.55402053404,1.01239408105,-1.42425312205,0.52336238178,-0.809378199156,0.500819966008,0.113366123739,-0.759121966242,-0.201533863893,-0.340990655917,-0.741588049043,0.343391601276,-0.365766832804,1.11829021736,0.2832017327,-0.0303190809387,0.926161681959,0.395205374827,0.0934335761655,-0.0872075779252,0.400771057278,-0.162386896009,0.173450745765,-0.364977485929,0.0208453507822,-0.240349072411],[-39073.9372056,-332.029944437,-854.615337636,-1098.26294189,1223.11669777,2147.60081266,-269.422985851,459.725900956,-1194.72214313,459.862570979,-1456.68415714,-10.5022083553,565.261438211,-15.9846390526,-789.833735534,403.007463731,-596.7104733,-132.290352216,-362.750578855,270.371099464,-155.793919859,-137.58545171,-14.6274823822,369.078958521,127.489169246,-207.571823057,140.630157719,-157.591166493,26.793960242,55.7953773141,-40.4494368182,42.7527726532,-77.0636709517,84.8333482189,-87.2832080806,47.8630305471,-71.5052828781,145.102858595,-7.67941298941,16.9624219433,-9.55078654178,10.1273417515,62.8802917294,-85.7652370886,32.5716739811,-17.3303876918,-42.0960295999,-45.1400234543,15.1696329156,-9.0240298527,20.6291640525,7.27648324313,17.4884523728,-2.6836573788,0.683955712207,42.9552757263,-29.5812893403,28.5416140205,-15.2536514752,-3.23621580267,-13.0581452368,-2.83447442146,-7.16888053433,0.73844699327,-3.44542711968,-3.55129254136,-1.80906728954,1.20569905746,-0.181133260768,4.35135951348,9.21451663336,-5.33641141092,11.624404508,-2.59191085472,1.08502944185,-2.33517152004,-1.91512606515,-5.09004428524,0.602313540995,-1.90203582241,1.31509701889,-0.804998553285,-1.56177028014,-1.01772427832,0.323991566788,-3.02785255242,2.51916143568,0.0758316304659,0.760576553155,2.316523245,-0.874227093765,2.78520185164,-1.21602740819,-0.236781002405,-1.55842735877,1.07718684604,-1.4204505887,0.547541263168,-0.823265827488,0.490042701588,0.140141863555,-0.744079899071,-0.164772410104,-0.318787744866,-0.738644909954,0.323833272699,-0.353437885737,1.103975261,0.248008521486,-0.0316833115197,0.893969150376,0.387437092297,0.0682783213529,-0.104775425689,0.41607257604,-0.155524362742,0.175292623462,-0.36368979748,0.0183638366252,-0.239177198944],[-39105.9692297,-342.944688249,-901.943744186,-1129.29480229,1192.12756532,2133.0686396,-259.532301803,430.78210741,-1198.44225643,474.325971115,-1492.02616783,8.39773569157,592.625676376,-45.5842322178,-778.995410421,402.50156204,-579.324263462,-144.681909911,-358.846730147,302.883164194,-145.836337494,-145.044089009,-8.80819602085,374.344618481,121.018122617,-208.878522247,138.036383499,-164.403912367,37.5948182344,55.9365751566,-39.9497534708,43.760238848,-83.1870623714,92.1116691579,-91.0838301844,47.3306743846,-73.6543870316,145.404941711,-11.2065015076,19.7605083399,-11.6253224764,14.2371592133,62.4165571934,-85.065775365,35.780815995,-17.4154118029,-42.7197072015,-46.2843817567,15.8680429602,-9.3336504161,20.3742758965,6.52496564701,17.0241437409,-3.0069653763,1.60407181396,42.5066513215,-28.4761455591,29.1419260683,-15.0819507245,-3.04132547995,-12.9019782379,-2.93977318232,-6.96335743084,0.962660440916,-3.19057221487,-3.63237988348,-1.97359617844,0.902067603038,-0.259794617649,4.20160782317,8.97194677882,-5.09746057701,11.4475848122,-2.40042828506,1.08143512661,-2.3065778247,-1.85963259314,-5.0023523752,0.727209802112,-1.90840094264,1.31694588387,-0.687852537113,-1.49991978944,-0.993739803147,0.285782425282,-3.05627282538,2.43096335834,0.031355592719,0.749493770312,2.14498986062,-0.834613911375,2.7226382764,-1.27975194932,-0.262279966177,-1.56067079574,1.13890538284,-1.41185789427,0.570501034589,-0.834907552058,0.478731948637,0.16596679367,-0.729396207523,-0.128397438655,-0.296517792424,-0.735333109276,0.303529761706,-0.340001098873,1.08810525245,0.212802196192,-0.0312528706175,0.860575193144,0.380327221926,0.0416556829062,-0.122017809213,0.430496343913,-0.147709241665,0.176809055851,-0.36202347767,0.0155921171038,-0.237875237197],[-39124.7817444,-358.662820886,-946.289842262,-1162.53824801,1154.22629844,2119.71778785,-249.267505444,397.081725675,-1200.92724471,486.867920556,-1524.31314771,28.6057411446,614.271599892,-77.1090752293,-765.753421165,401.085672112,-560.973006414,-157.15397335,-354.44741303,333.538416219,-136.082589139,-152.068992557,-3.01249195087,379.349218951,113.863145843,-209.465641888,134.680103695,-171.046924458,48.5014439433,56.6573998549,-39.0969663262,44.5793355877,-89.2584802516,99.8522970975,-94.5143750955,46.5698839209,-75.6530177329,145.546651699,-14.7324935347,22.7078267604,-13.4308829744,18.4951243525,61.7134536129,-84.2300216397,38.9930439414,-17.2914464239,-43.2559692697,-47.3651356035,16.5514480148,-9.65082290056,20.1472815068,5.77634719148,16.5857513482,-3.28262603534,2.57019889154,41.9951285122,-27.2943915878,29.7117848618,-14.8542403854,-2.81398105703,-12.7617125021,-3.05761917111,-6.74828795621,1.19400245777,-2.94250018591,-3.70165364341,-2.1384612839,0.596265742632,-0.329380150464,4.05668145858,8.73125630321,-4.8403114829,11.2587958529,-2.19097720409,1.08165196435,-2.27867321813,-1.80520438541,-4.90513504502,0.850934198601,-1.89708091411,1.31954194238,-0.574609838486,-1.43701824021,-0.97189236669,0.245091274851,-3.08243009143,2.34089104733,-0.00909897754586,0.7376721232,1.97189406963,-0.787984839008,2.65900587013,-1.34156549813,-0.290390677562,-1.56082842701,1.19715959427,-1.39812460328,0.592304457648,-0.844178827974,0.467136475038,0.190481292881,-0.715362067578,-0.0928169451019,-0.274378190258,-0.731782403884,0.282873881072,-0.325546729258,1.0710009026,0.177945038769,-0.0289838328422,0.826505759574,0.37392706751,0.0138804748878,-0.138771476894,0.443994010946,-0.138899761479,0.178099098686,-0.360005107521,0.012566235731,-0.236502785888],[-39131.6512021,-378.468182589,-988.36830169,-1197.44003647,1109.55509445,2107.42063996,-238.917738585,360.011166867,-1202.03901088,497.434527016,-1553.64262513,50.0960724224,630.655170417,-110.20375486,-750.414793072,398.83553153,-541.896260132,-169.597287579,-349.669137089,362.246081707,-126.64638475,-158.574190381,2.75696299312,383.999155021,106.1103372,-209.38629531,130.703354644,-177.513561963,59.4241650168,57.9001734951,-37.9488930567,45.2230357052,-95.3177654444,108.012045692,-97.5385021325,45.5776835914,-77.4754153586,145.548773155,-18.2361142668,25.76854918,-14.9638640416,22.8411378415,60.7855574373,-83.2945288338,42.2001111434,-16.9494858815,-43.689242307,-48.3854496102,17.2054794322,-9.96579407797,19.9496120249,5.03296624776,16.178098623,-3.50647448956,3.57050571805,41.42954605,-26.0557082044,30.2552728569,-14.5675163984,-2.55337724945,-12.6385787222,-3.19003613132,-6.52297551699,1.42819876968,-2.70246100838,-3.76034394572,-2.30182037501,0.293728158492,-0.387303691099,3.91920015423,8.4946210193,-4.56840800485,11.0623709833,-1.96567233665,1.08778801634,-2.25129267867,-1.75313479986,-4.7989253766,0.972291372576,-1.86743855103,1.32260459413,-0.466424920372,-1.37432769869,-0.951983373796,0.202898359321,-3.1054539464,2.25066374442,-0.045418343924,0.725631148688,1.79936828816,-0.735302499218,2.59546562368,-1.40087822818,-0.320699999486,-1.55911903033,1.25166711667,-1.37897611014,0.61314628146,-0.851018458143,0.455481047477,0.213318919243,-0.702187927718,-0.0583116190522,-0.252530826872,-0.728000727211,0.262308387479,-0.310282569177,1.05304759662,0.143665126267,-0.0250872940135,0.792260247103,0.36822520445,-0.0146371867339,-0.154924943597,0.456472175562,-0.129075027418,0.179254665034,-0.357633624247,0.00933000256235,-0.23510879946],[-39128.8247351,-401.392751406,-1029.1568008,-1233.40228306,1058.38145462,2096.02069308,-228.80120482,321.390164584,-1201.64046625,506.030373697,-1580.13893664,72.8364691272,642.437955993,-144.488626232,-733.358588599,395.864197583,-522.343349956,-181.870879564,-344.643336459,388.961632602,-117.660763628,-164.485173964,8.51577083613,388.194207719,97.8612472688,-208.709014403,126.26830397,-183.802915337,70.2763105554,59.5797174494,-36.5678799145,45.711131628,-101.411531497,116.541735421,-100.120505056,44.3525156762,-79.0977582511,145.433365982,-21.6968326477,28.9022148416,-16.2301522264,27.2117964188,59.6492951834,-82.3005459101,45.394186408,-16.3822902304,-44.0041054357,-49.3485378907,17.8146079507,-10.2679605419,19.7813672418,4.29658070653,15.8047026251,-3.67634120262,4.5924232708,40.8183315885,-24.7816694074,30.7769968955,-14.2184776149,-2.25878754743,-12.5328171102,-3.3385015799,-6.28648779828,1.66048761653,-2.47137063249,-3.80995691554,-2.46168726502,-7.92315676952e-05,-0.43109995106,3.79173022425,8.26361195982,-4.28557371493,10.8625611201,-1.72678145295,1.10197011856,-2.22410711156,-1.70459329124,-4.68430935673,1.08997776491,-1.81902284652,1.32574820531,-0.364355272419,-1.31315237218,-0.933664881987,0.160244066737,-3.1243934193,2.16200433719,-0.0776755494585,0.713905254944,1.62951435062,-0.67765699687,2.53317905734,-1.4570594093,-0.352690632293,-1.55579668242,1.30217251978,-1.35415676669,0.633254252021,-0.855381082421,0.443984432337,0.234111525631,-0.690064054551,-0.0251303236254,-0.231128714977,-0.723965556827,0.242288523585,-0.294445794722,1.03464688826,0.110156984513,-0.0198381052534,0.758331415199,0.363194526051,-0.0434633605138,-0.170379665802,0.467826173276,-0.118219363846,0.180365882294,-0.354901054107,0.00592916928879,-0.233739571287],[-39118.549476,-426.468505382,-1069.63301792,-1269.82710321,1000.97288023,2085.36144435,-219.236107743,283.038452426,-1199.59452212,512.660043803,-1603.9264188,96.794670861,650.281524658,-179.584044469,-714.963870205,392.284727561,-502.563601222,-193.833776269,-339.50144528,413.640540847,-109.258765073,-169.727434787,14.2795336032,391.834158073,89.217426632,-207.502331059,121.537119301,-189.914075036,80.9712096591,61.6108530896,-35.0162731518,46.0634157838,-107.586391956,125.392186769,-102.224677626,42.8928224551,-80.4962247529,145.222490088,-25.0941176212,32.0683629882,-17.2356340772,31.5436968229,58.3210933683,-81.2893218313,48.5674385422,-15.5826195249,-44.1851377779,-50.2576145593,18.363304309,-10.5467188859,19.642646949,3.56894845843,15.4690804141,-3.79005663817,5.62338252712,40.1699127814,-23.4938491952,31.2815638194,-13.8038228865,-1.92948544121,-12.4446678781,-3.50449303383,-6.0378924852,1.88610723823,-2.2501450085,-3.85199867795,-2.61607576722,-0.279690509731,-0.458303641855,3.67683798275,8.03980015752,-3.99563218523,10.6636171807,-1.47657232321,1.12632510697,-2.19678742199,-1.66074931429,-4.56187297224,1.20268981648,-1.75138279372,1.32858714214,-0.269458384275,-1.25479646798,-0.916588948782,0.11816878515,-3.13829753911,2.07663571322,-0.105943637192,0.703028850133,1.4644340914,-0.616138436827,2.47330769142,-1.50947831132,-0.385845276325,-1.55111545998,1.34842037331,-1.32341092478,0.652856115324,-0.857221340664,0.432865396005,0.252490964915,-0.679180714683,0.00647807805904,-0.210324867282,-0.719654370305,0.223269532049,-0.278273581988,1.01620033126,0.0776151393329,-0.0135111176838,0.725212023327,0.358807925617,-0.0721641050069,-0.185037099991,0.477951339606,-0.106317095129,0.181522877864,-0.351799423362,0.00240948760136,-0.232441394741],[-39103.0725574,-452.727422565,-1110.77463138,-1306.11661233,937.596872563,2075.28639093,-210.540650948,246.77576399,-1195.76408979,517.328120536,-1625.12940819,121.938417226,654.847444453,-215.110364694,-695.609700347,388.210178751,-482.806339271,-205.345004658,-334.374897688,436.238278387,-101.573428387,-174.226464332,20.0638533193,394.81878711,80.2804258715,-205.83477717,116.67196826,-195.846131515,91.4221914283,63.908401788,-33.3564190211,46.2996806004,-113.888960369,134.514220215,-103.815313603,41.197046208,-81.6469932067,144.938205379,-28.4074381311,35.2265328628,-17.9861961423,35.7734357926,56.8173785088,-80.3021055603,51.712036353,-14.5432338196,-44.2169184558,-51.1158937299,18.8360392454,-10.7914657037,19.5335509375,2.85182739413,15.1747490499,-3.84545125987,6.65081446431,39.4927172826,-22.2138215663,31.7735804705,-13.320251065,-1.56474442102,-12.3743712377,-3.68948801004,-5.77625726286,2.10029587468,-2.03970008666,-3.88797535805,-2.76299969488,-0.539639758183,-0.466449474993,3.57708974384,7.82475664513,-3.70240698783,10.4697900819,-1.21731271766,1.16297981754,-2.16900451518,-1.62277232374,-4.43220220991,1.30912396815,-1.66406738577,1.33073577082,-0.182791745588,-1.20056419342,-0.9004076317,0.0777129026059,-3.14621533485,1.99628076009,-0.130295650169,0.693536342421,1.30622934492,-0.551836923955,2.41701304624,-1.55750420405,-0.419646631923,-1.54532943972,1.39015524698,-1.28648293625,0.672179617364,-0.85649387273,0.422342704865,0.268089089968,-0.669728174722,0.0362647228815,-0.1902722965,-0.715044645216,0.205706655529,-0.262003107068,0.998109479368,0.0462341165523,-0.00638118242676,0.693394830957,0.355038296454,-0.100305478768,-0.198798702647,0.486743010068,-0.0933525456322,0.182815779142,-0.348320758273,-0.00118329080891,-0.231260563196],[-39084.1648871,-479.652063868,-1153.20069238,-1341.67067335,868.767593238,2065.53999638,-202.799387327,213.978592924,-1189.99684478,520.037788668,-1643.87791841,148.228614765,656.724245959,-250.714140143,-675.608660217,383.768957279,-463.338905467,-216.257532348,-329.367236599,456.731771817,-94.7414447577,-177.900299186,25.886063741,397.062810183,71.1516730328,-203.775632248,111.821287755,-201.591745851,101.55639863,66.392599726,-31.6426105579,46.4429657784,-120.360140705,143.859489215,-104.865620055,39.2640899492,-82.5281595127,144.601197861,-31.6191748259,38.3394282473,-18.4868028092,39.842837178,55.1525733079,-79.3802088196,54.8219058159,-13.2581915514,-44.0868928461,-51.926302344,19.2183499403,-10.9919534699,19.4547514748,2.14643350516,14.924075676,-3.84120598875,7.66325983202,38.7933496736,-20.9624883694,32.2574482387,-12.7644860005,-1.16388843019,-12.3223720108,-3.89471442516,-5.50063136449,2.29874989501,-1.84066231413,-3.91927113436,-2.90054881528,-0.775102086823,-0.453536199417,3.49482501517,7.61958442915,-3.40939665586,10.2847515138,-0.951027299181,1.21384943755,-2.14023293456,-1.59181849072,-4.29585865422,1.40829816932,-1.55672622209,1.33185776088,-0.105316008555,-1.1516983516,-0.884726815033,0.0398504936886,-3.14732155678,1.92245479269,-0.150875067973,0.685955105385,1.1567538385,-0.485789597728,2.36535884352,-1.60045552702,-0.453598559145,-1.53871055565,1.42720930386,-1.2431203791,0.691424486531,-0.853231013654,0.412602500165,0.280556765654,-0.661889442298,0.0640247367194,-0.171104232936,-0.710116319585,0.190003285828,-0.245855573877,0.980750025457,0.0161800696462,0.00127843412751,0.663319305214,0.351876754003,-0.127480637314,-0.211590579638,0.49413045986,-0.0793037055575,0.184331621463,-0.344467218926,-0.00481769940916,-0.230235423082],[-39061.692474,-508.527321674,-1196.09574363,-1375.8801394,795.985845269,2055.47058995,-195.16226697,184.250473085,-1182.07951944,520.786639246,-1660.32467133,175.598837789,656.208309925,-286.1467165,-655.007405952,379.150864605,-444.500705287,-226.400089553,-324.470440045,475.183766345,-88.9141129332,-180.637156365,31.770425551,398.540679937,61.9321060152,-201.397166281,107.078591814,-207.117861606,111.3562287,69.0053423227,-29.8969279321,46.5293001109,-127.017998625,153.382979124,-105.384457281,37.0946996309,-83.1254898017,144.226657948,-34.7233551732,41.3824110792,-18.7387298212,43.7146332764,53.3330852124,-78.5651943707,57.8980015817,-11.7267446875,-43.7939713427,-52.6906186519,19.5000393407,-11.139358185,19.4092107325,1.45181518654,14.7148277726,-3.77940357523,8.65369846921,38.0711222465,-19.7580628548,32.7367467059,-12.133351539,-0.726443224454,-12.2899334582,-4.12040179436,-5.20999021576,2.47899818532,-1.65250012585,-3.94678239896,-3.02711671183,-0.983816716416,-0.41941871381,3.43147607852,7.42351441119,-3.11879956663,10.1098562583,-0.678768301416,1.28000255956,-2.10916177638,-1.56899085189,-4.1533062803,1.50051640343,-1.42941132734,1.33181399518,-0.0376044755721,-1.10919612896,-0.868967690153,0.0052903791182,-3.14129384018,1.85584283505,-0.16810711636,0.680784374246,1.01686887123,-0.418821736059,2.31901761074,-1.63744739858,-0.4872895569,-1.531602171,1.45976508046,-1.1930837359,0.71067838079,-0.847775879193,0.403700422607,0.289620904801,-0.655818489127,0.0897292014382,-0.152874777268,-0.704859173242,0.176355411329,-0.229988297611,0.964394218913,-0.012494337316,0.00920080451613,0.635211743861,0.349387302265,-0.153391124006,-0.22343743439,0.500178722904,-0.0641232284473,0.186145071915,-0.340281500716,-0.00851941229913,-0.229372533055],[-39035.0451026,-541.088671233,-1238.28570069,-1408.1336111,720.999092012,2044.32746731,-186.545589262,156.751698375,-1171.78361032,519.570864885,-1674.62806585,203.97582755,653.522979643,-321.185637564,-633.786112425,374.561051026,-426.649160234,-235.595347139,-319.648594837,491.67846183,-84.2463835491,-182.317797988,37.7429311635,399.241783344,52.7225401815,-198.772396878,102.523663748,-212.384992962,120.817892739,71.6939398066,-28.1333980973,46.597959664,-133.874890209,163.040508268,-105.389598886,34.6900819395,-83.4266677622,143.828402155,-37.7169183457,44.334007835,-18.7423307605,47.356783497,51.3633178552,-77.8986877353,60.9430354697,-9.9494435775,-43.3399305942,-53.4103337312,19.6719768355,-11.2252117304,19.4004633587,0.766478934175,14.5436229037,-3.6629772271,9.61621998715,37.3235242217,-18.6180861232,33.2148500021,-11.4236965246,-0.25198501266,-12.2785234503,-4.36653003251,-4.90329079048,2.63902776091,-1.4743924537,-3.97128359736,-3.14117292195,-1.16416389544,-0.364415954293,3.3882484092,7.23530946658,-2.83248905852,9.94587987011,-0.401344850673,1.3622961274,-2.07428377508,-1.55537916032,-4.00498466096,1.58640416245,-1.28227533248,1.33051465991,0.0198663884155,-1.07399330774,-0.852505275204,-0.0253249338502,-3.12793554159,1.7969223385,-0.182487457627,0.678516349638,0.887187635101,-0.351705651467,2.27856407678,-1.66754410676,-0.520329283812,-1.52436550627,1.48809270661,-1.13613671538,0.730000940503,-0.840549280284,0.395659487756,0.295027432226,-0.651662027951,0.1133931879,-0.135618247773,-0.699265446472,0.164907169564,-0.21454262129,0.949288448247,-0.0397648126162,0.017120586008,0.609245152319,0.347652167377,-0.177765579167,-0.234388619716,0.504986772803,-0.0477574336801,0.18832770552,-0.335816432866,-0.0123283887368,-0.228670504831],[-39003.6125573,-579.071587795,-1278.59647915,-1437.81968911,645.55479682,2031.35992411,-175.86565359,130.642562701,-1158.880614,516.386658203,-1686.94650088,233.286325299,648.891598404,-355.608447132,-611.924954507,370.204666837,-410.141691813,-243.665975971,-314.865787786,506.300058132,-80.8932072413,-182.822986177,43.8295729926,399.155507375,43.6237908945,-195.974341649,98.2362868676,-217.353654102,129.93760185,74.4057024063,-26.3660480066,46.6882205038,-140.943171539,172.787894976,-104.898818475,32.0514435616,-83.4193770826,143.420246997,-40.5968035159,47.1727449912,-18.4979592093,50.7372472486,49.2476748692,-77.4223144347,63.9597192994,-7.92683857106,-42.726547249,-54.0869386595,19.7250318137,-11.2410459878,19.4320440012,0.088931243945,14.4070786331,-3.49486015216,10.5449139971,36.5480448191,-17.5600992753,33.6951322571,-10.632369802,0.259909996357,-12.2896098576,-4.63307905443,-4.57949006244,2.7768256371,-1.30551822953,-3.99354917506,-3.24118698305,-1.31452387237,-0.288846856985,3.36634748252,7.0537324707,-2.55233846988,9.79359790406,-0.119566073263,1.46158708495,-2.03409166512,-1.55207316906,-3.85133336898,1.66658693834,-1.11547086844,1.32786994126,0.0666201184625,-1.04702567019,-0.83471458833,-0.0513529379615,-3.10705001755,1.7461707544,-0.194511754071,0.679643232194,0.768323322122,-0.285213656476,2.24457297054,-1.68980993964,-0.552327398506,-1.51736178198,1.51246231217,-1.07204302626,0.749451806033,-0.831972027864,0.388502711175,0.296522272748,-0.649566771509,0.135031766968,-0.119368962723,-0.693327379557,0.15580269806,-0.199659887933,0.935679101972,-0.0656070645362,0.024772435872,0.58559253601,0.346753575476,-0.200332643121,-0.244493488428,0.508653583162,-0.0301526406343,0.190951097305,-0.331124844597,-0.01628458798,-0.228127950122],[-38966.7846223,-624.211546608,-1315.85399456,-1464.32697407,571.400423052,2015.81725602,-162.038759341,105.083359968,-1143.14202701,511.230211814,-1697.43837535,263.457072289,642.537509499,-389.192689001,-589.40410707,366.286862335,-395.335721527,-250.434646915,-310.086105703,519.132755112,-79.0095346456,-182.033483053,50.0563434526,398.271238999,34.736673517,-193.076018202,94.2962444817,-221.984359209,138.711567135,77.0879403504,-24.6089046135,46.8393586962,-148.235198698,182.580957576,-103.929889654,29.1799911838,-83.0913014514,143.016008988,-43.3599498562,49.8771490242,-18.00596875,53.8239839403,46.9905598873,-77.1776999904,66.9507648901,-5.65948001784,-41.9555979555,-54.7219245144,19.6500736641,-11.1783928386,19.5074873081,-0.582321388254,14.3018125251,-3.2779855582,11.4338701104,35.7421732589,-16.6016434119,34.1809676009,-9.75622021564,0.80966559376,-12.3246605507,-4.92002877496,-4.23754500543,2.8903788292,-1.14505638523,-4.01435357754,-3.32562843256,-1.43327689569,-0.193030358007,3.3669787738,6.87754629888,-2.2802211391,9.65378591498,0.165758904502,1.57873237605,-1.98707818096,-1.56016263118,-3.69279197716,1.74169022307,-0.929150566176,1.32379002542,0.102180249624,-1.02922899854,-0.814970647674,-0.0721511259608,-3.0784406246,1.70406553406,-0.204675667988,0.684657222547,0.660889124295,-0.220118063605,2.21761902092,-1.70330918525,-0.582893559604,-1.51095221866,1.53314402698,-1.00056637725,0.769090617741,-0.822464932871,0.382253108431,0.293851351185,-0.649679432541,0.154660009503,-0.104161240393,-0.687037212782,0.149186134347,-0.185481440558,0.9238125686,-0.0899968013579,0.031891011377,0.564426900355,0.346773752702,-0.220820956191,-0.253801393339,0.511278127583,-0.0112551686884,0.194086822292,-0.326259565131,-0.0204279692866,-0.227743480643],[-38924.2128206,-677.721578058,-1349.44347535,-1487.26175511,500.114368124,1997.13826885,-144.355997161,79.5805334003,-1124.41002791,504.137109311,-1706.26204654,294.292809818,634.69406171,-421.723963932,-566.326411012,363.012230464,-382.542906666,-255.756501118,-305.331558939,530.237268578,-78.7191030402,-179.874003592,56.4425281873,396.617815696,26.1621825681,-190.149150988,90.77018515,-226.248000568,147.133932587,79.6844266023,-22.8837440042,47.0794248979,-155.758560258,192.362953443,-102.507450183,26.0794732574,-82.4334301803,142.62746977,-46.002529714,52.4260715703,-17.2712375474,56.5865945055,44.5959043675,-77.2001197797,69.9134555072,-3.15028392648,-41.0300090476,-55.3173653366,19.440161083,-11.0292767548,19.6294539254,-1.24708876908,14.2238210083,-3.01606047401,12.2773416559,34.9032800797,-15.7582553079,34.6732467423,-8.79319870526,1.39718713171,-12.3851053909,-5.22695674255,-3.87657707227,2.97805270794,-0.991902163942,-4.0344389838,-3.3928804421,-1.51935023404,-0.0775228804599,3.39067556653,6.70530976756,-2.01789868981,9.52653022314,0.453706123324,1.71451572947,-1.93227038067,-1.58042237378,-3.52985887521,1.81220824753,-0.72375278374,1.31813621409,0.126248940845,-1.02135895639,-0.792666091555,-0.0872031299305,-3.04193927488,1.67092512601,-0.213486813301,0.693950140107,0.56528556669,-0.157173482587,2.19814858088,-1.70734698303,-0.611722921439,-1.50538549367,1.55031739298,-0.921535957694,0.788988371556,-0.812420610993,0.376896108119,0.286810834191,-0.652108334127,0.172315943607,-0.0900062045981,-0.68034905605,0.145176919528,-0.172127425029,0.913889943334,-0.112927976278,0.0382164695946,0.545872347038,0.347757602468,-0.239011257783,-0.26234596659,0.512929685537,0.0089700477899,0.19779509097,-0.321277558124,-0.0247958350309,-0.227512223274],[-38876.5956292,-738.724933065,-1380.98740134,-1507.10107534,432.598765705,1975.51980892,-123.607622727,55.0251235076,-1102.80952309,495.300498185,-1713.57570532,325.110279375,625.634625789,-453.020100544,-543.285371336,360.583134762,-371.891847666,-259.616560842,-300.855852013,539.58037814,-80.0207962724,-176.445074194,62.9805857591,394.381876973,18.0020291919,-187.260291825,87.6722184285,-230.156982877,155.190573771,82.1247850644,-21.2433387954,47.3915681264,-163.501774749,202.026896145,-100.68359444,22.7638052933,-81.4499750734,142.258271489,-48.517648135,54.7996649056,-16.3167420966,59.0012459747,42.0657510683,-77.4994486034,72.8233602005,-0.411628941748,-39.9573056008,-55.8776670196,19.0971099969,-10.7876925701,19.7971084931,-1.89844591541,14.1666159704,-2.71588721249,13.0702368331,34.0282610945,-15.0374544359,35.1629267046,-7.74566459216,2.02030620639,-12.4722222031,-5.55183103997,-3.49636563177,3.03972606566,-0.843816054016,-4.05441850667,-3.44098072011,-1.57385923679,0.0561692046172,3.43528237706,6.5347654574,-1.76668588685,9.40916021078,0.742892291962,1.86942801361,-1.87083261682,-1.61236752018,-3.36326772049,1.87811019832,-0.500858787538,1.31057427113,0.139242846637,-1.02345073274,-0.767264038998,-0.0964971393027,-2.9974921029,1.64643196747,-0.221500610422,0.707512279396,0.481062506651,-0.0970637119975,2.18609449981,-1.70219187799,-0.638852621175,-1.50046011182,1.56379960048,-0.835042879346,0.809261485676,-0.802118896937,0.372266790954,0.275397855756,-0.65680824071,0.188129426338,-0.0768222013136,-0.673064497746,0.143795708996,-0.159633198588,0.90593114814,-0.134467522152,0.0435109668068,0.529857362787,0.349600737296,-0.25489268364,-0.270097957631,0.51355875996,0.0304836144758,0.202090655678,-0.316252324967,-0.0294148600515,-0.22741536556],[-38824.8932638,-805.822417684,-1412.66756518,-1524.53966634,369.586683527,1951.3482327,-100.958682979,32.6543201179,-1078.53610094,484.952916905,-1719.53750093,355.104222495,615.642577979,-482.906984416,-520.99715907,359.201381417,-363.465380748,-262.032318633,-296.970612988,547.105379359,-82.8822848319,-171.891174115,69.6562679599,391.789512845,10.3581036891,-184.474699372,85.0033191226,-233.734088934,162.865299141,84.3351023741,-19.7482107369,47.74771199,-171.448593191,211.453238298,-98.5172809608,19.2494445673,-80.1484535579,141.910021417,-50.8976433398,56.9784064659,-15.1699834753,61.045746903,39.4016705735,-78.079211118,75.6506194656,2.5417406326,-38.7461623763,-56.40781842,18.6249256394,-10.4481277085,20.008741649,-2.52778414667,14.1230881637,-2.38504190753,13.807627559,33.113893435,-14.4447559427,35.6384810901,-6.61707929298,2.67633597498,-12.5872508029,-5.89221738359,-3.0968545318,3.07565605013,-0.698274855079,-4.07487299251,-3.46788060924,-1.59846627347,0.206302039204,3.49797152991,6.36345189012,-1.5277857803,9.29831602563,1.03181928619,2.04388688178,-1.80446356559,-1.65519826775,-3.19381098727,1.93923400097,-0.262335571076,1.30072107588,0.141757245399,-1.03535939791,-0.738245229204,-0.100147482847,-2.94507379874,1.63010949286,-0.229284431389,0.725233553712,0.407557134587,-0.0404548476204,2.18126125117,-1.68835326651,-0.664405291684,-1.49586203475,1.57331725187,-0.741243734583,0.83003773387,-0.791811430161,0.368162650684,0.259659791704,-0.663695527075,0.20225327199,-0.0645043820564,-0.664946995876,0.145038461717,-0.148012921322,0.899910811675,-0.154700616751,0.047542159098,0.516261530594,0.352161446987,-0.268506468587,-0.277012395237,0.513086159655,0.0532275220552,0.206976904218,-0.311261501487,-0.0343090623034,-0.227430610211],[-38770.0659399,-877.61483797,-1446.66575951,-1540.27225972,311.811189321,1925.00989665,-77.5742248545,13.70531306,-1051.78534983,473.326903941,-1724.3055826,383.469380716,605.001294522,-511.210501129,-500.177945242,359.068776615,-357.346342134,-263.021267034,-293.987469923,552.755567794,-87.2712392081,-166.356782611,76.455326582,389.066813328,3.33229635992,-181.85763229,82.7644620376,-237.00210154,170.141917152,86.2414651688,-18.4588815782,48.1197800968,-179.582766607,220.522432516,-96.0674682777,15.5528483551,-78.5363830612,141.584326826,-53.1348535491,58.9427736871,-13.8584627612,62.6979058454,36.6052334668,-78.9429319799,78.3653737982,5.6950804928,-37.4052541349,-56.9128083943,18.0276132442,-10.005069594,20.2626440313,-3.1264947823,14.0861283404,-2.03110069302,14.4845857506,32.1569542327,-13.9856749752,36.0883835011,-5.41090422434,3.36258959465,-12.7314310063,-6.24568148981,-2.67798762019,3.08609980911,-0.552755366759,-4.09638328765,-3.47153145214,-1.5948337136,0.371131765278,3.57591534961,6.18890758746,-1.30240142027,9.19063781542,1.31898898177,2.2383099873,-1.73486190316,-1.70811481386,-3.0222811498,1.99541758101,-0.010050127856,1.2881935077,0.134387415533,-1.05694002225,-0.705090401373,-0.0982684893324,-2.88465905252,1.62148113658,-0.237405648239,0.747003876355,0.344106640907,0.0119870147585,2.18345330841,-1.666340545,-0.688503565836,-1.49127722411,1.57859694955,-0.640295115777,0.851444889903,-0.781749850123,0.364381181056,0.239644017862,-0.672686568005,0.214840294858,-0.052947898343,-0.655760008446,0.148901136658,-0.137280753319,0.895803562594,-0.173712437845,0.050077702553,0.504964433451,0.355298021338,-0.279893847448,-0.283044308185,0.511432693424,0.0771437612139,0.212457224393,-0.306382723508,-0.0395024597415,-0.227535659941],[-38713.0738731,-952.702999978,-1485.16377701,-1554.99358705,260.005350819,1896.89115724,-54.619295291,-0.584707837266,-1022.75285815,460.65499776,-1728.03809958,409.400495571,593.994151662,-537.756536264,-481.54390088,360.387126542,-353.617568047,-262.600898589,-292.218050879,556.474239006,-93.1553298906,-159.98637894,83.3635134173,386.439868437,-2.97350249503,-179.47434924,80.9566219787,-239.983803493,177.004236261,87.7699600858,-17.4358730692,48.479696055,-187.888046015,229.114931415,-93.3931149248,11.6904739323,-76.6212810106,141.282794989,-55.2216169834,60.673244005,-12.409681032,63.9355313567,33.6780103318,-80.0941358459,80.9377636942,9.03364633508,-35.9432556377,-57.397625799,17.3091780452,-9.4530056506,20.557106278,-3.6859691417,14.048627253,-1.66163970286,15.0961833251,31.1542206193,-13.6657266803,36.5011075398,-4.13060080288,4.07638022259,-12.9060026288,-6.60978907498,-2.23970874478,3.07131449035,-0.404734388688,-4.11953023842,-3.44988459146,-1.56462392672,0.54891452482,3.66628616069,6.00867107115,-1.09173585688,9.08276572787,1.60290325448,2.45311498348,-1.66372630572,-1.77031735587,-2.84947068236,2.04649886397,0.254130548617,1.27260844597,0.11772863544,-1.08804767609,-0.667280294705,-0.0909744875291,-2.81622255432,1.62007033304,-0.246431633011,0.772713160623,0.29004821602,0.0595957793541,2.19247514499,-1.63666310984,-0.711270076503,-1.48639164156,1.57936529591,-0.532353615301,0.873610727543,-0.772185796281,0.360719875817,0.215397910052,-0.683697738283,0.22604330924,-0.04204790169,-0.64526699346,0.155379692785,-0.127450854664,0.893584029555,-0.191588163205,0.0508852532564,0.495845654348,0.35886875015,-0.28909605505,-0.288148725253,0.508519170072,0.102174322638,0.218535004007,-0.301693626857,-0.0450190703206,-0.227708217459],[-38654.8536252,-1029.65175788,-1529.87291437,-1569.23094814,214.736926085,1867.36938795,-33.0924308472,-9.37753878207,-991.606090498,447.176792132,-1730.9077584,432.22668864,582.873857142,-562.423642656,-465.687427967,363.308541102,-352.323300995,-260.818732287,-291.91620216,558.213399117,-100.485246275,-152.916752735,90.3289164755,384.111138112,-8.47576747515,-177.379383405,79.5757025051,-242.700170412,183.436729319,88.8511778244,-16.7281824514,48.7893448206,-196.345229842,237.117358556,-90.5549252628,7.68009349689,-74.4134468941,141.00459022,-57.1505933924,62.1533837861,-10.8514626949,64.7434232141,30.6212225873,-81.5308419961,83.3364343968,12.5377988291,-34.3672506459,-57.867751688,16.475010388,-8.7883502903,20.8896873561,-4.19839703815,14.0040424865,-1.28386405382,15.6385002184,30.1030141582,-13.4880317212,36.8650463525,-2.78178833803,4.81541013748,-13.1122549412,-6.98223064912,-1.78247590585,3.03187409256,-0.252105892425,-4.14488689433,-3.40124654496,-1.5095749345,0.737850102403,3.76633327856,5.82054874348,-0.896807531258,8.97132357056,1.88170146911,2.68835779319,-1.59301041803,-1.84083738077,-2.67620650623,2.09230296534,0.528210432215,1.25362680195,0.0924118033587,-1.12841239218,-0.624431708653,-0.0783707150897,-2.73980822203,1.62533469822,-0.256874422636,0.80220181533,0.244650488968,0.101731489006,2.20798384213,-1.59996223242,-0.732729274782,-1.4809622231,1.57540231719,-0.417722947456,0.896658086747,-0.763334751656,0.356987692789,0.187015912832,-0.696603975235,0.235998526208,-0.0316945066508,-0.633255663107,0.164441744075,-0.118535050414,0.89320063915,-0.208392848288,0.049773473733,0.48874069631,0.362712253339,-0.296133876753,-0.292314696605,0.504284345945,0.128223183039,0.225223007977,-0.297262303407,-0.0508711345337,-0.227917583851],[-38596.2471427,-1106.8821583,-1580.62248447,-1582.84191559,175.912434515,1836.78603042,-13.3261265634,-13.4309201295,-958.400016357,433.160102035,-1733.14549476,451.814601669,571.77044471,-585.301042154,-452.705852311,367.786345065,-353.353408635,-257.842392887,-293.104643033,557.959896494,-109.143753378,-145.253935148,97.1489686373,382.188561995,-13.1644327791,-175.584366074,78.5973221908,-245.164949189,189.426526765,89.433725331,-16.3387089353,48.9704567424,-204.923306127,244.441021282,-87.6205869604,3.5447389354,-71.9343084434,140.739105004,-58.9157286418,63.3791151192,-9.21292547559,65.1343460826,27.4346949916,-83.2290482058,85.5240501398,16.1683185379,-32.6779589215,-58.3306359036,15.5360410659,-8.01522587676,21.2550195486,-4.65916226016,13.9480989577,-0.903494794147,16.1116484423,29.0028341404,-13.4461328266,37.1682712612,-1.37871771038,5.57893810402,-13.3516750348,-7.36119589673,-1.30880371338,2.96962001816,-0.0944325372517,-4.17299511768,-3.32534453084,-1.43172736722,0.935912852982,3.87361398216,5.62341852904,-0.717896448752,8.85286979043,2.15207294649,2.94264741753,-1.52568775909,-1.91803153394,-2.50345333078,2.13260376053,0.809677366315,1.23108561454,0.059210296884,-1.17726405281,-0.576705683679,-0.0605260452011,-2.65573688462,1.63646857436,-0.269024713633,0.83511223135,0.206907843314,0.137858741054,2.22904691211,-1.55740668409,-0.752512884662,-1.4750298022,1.566701735,-0.29729531425,0.920690072241,-0.755267573521,0.353039446088,0.154780745677,-0.711114466353,0.244775743952,-0.021757679927,-0.619610746294,0.175941524548,-0.110535825507,0.894497009721,-0.2241110593,0.046715052269,0.483308742493,0.366588471293,-0.300946300055,-0.29566735796,0.498738767565,0.15504226323,0.232571509689,-0.293118669223,-0.0570237830245,-0.2280994537],[-38538.0727181,-1182.77929601,-1636.77130423,-1595.51663019,143.273085837,1805.47354329,4.51363289945,-13.9015782713,-923.16148144,418.879797747,-1734.99680167,468.16525645,560.783279612,-606.530623861,-442.572730673,373.72416692,-356.559164909,-253.869531595,-295.748311011,555.709290071,-118.996635125,-137.096267712,103.583439001,380.756449653,-17.0477975055,-174.090203058,77.9920283639,-247.390079533,194.961423436,89.4707136138,-16.2588272236,48.9347235169,-213.588310314,251.003397882,-84.6595335135,-0.691242943496,-69.2080754509,140.473288864,-60.5112901268,64.3494490239,-7.52351042912,65.1280558493,24.1179031382,-85.1592468738,87.4617799048,19.8810909982,-30.8745092269,-58.7942204854,14.504585984,-7.13968176155,21.6470034674,-5.06444709008,13.8770884159,-0.525881954967,16.5167480278,27.8537242884,-13.5311782417,37.3987731321,0.0622023066738,6.36661200841,-13.6257994555,-7.74499929595,-0.821720929799,2.88671052051,0.0683058456195,-4.2043889739,-3.22226094238,-1.33319750733,1.14102077411,3.98576254129,5.41642623299,-0.555098005743,8.72394649429,2.4103444965,3.21423112719,-1.4649868165,-2.00008775038,-2.33221031239,2.1671623149,1.09589016167,1.20486595458,0.0189331134481,-1.23370750271,-0.524399320501,-0.0375002599333,-2.56439859883,1.65260048524,-0.283117867414,0.871037295072,0.175746101253,0.167468271461,2.25458447495,-1.51029711121,-0.770154448359,-1.46870618668,1.55331069476,-0.172110039621,0.945804854938,-0.748018962708,0.348741413907,0.119022196796,-0.72689696167,0.252428157438,-0.0121023512573,-0.604241226114,0.189704923235,-0.103453329846,0.897290557545,-0.238707240135,0.0417236835911,0.479164896088,0.37023767452,-0.303451862992,-0.298365866426,0.491910928998,0.182345470052,0.240640159644,-0.289283096419,-0.0634303689749,-0.228181119959],[-38481.1486441,-1255.72826573,-1697.67819056,-1606.94523277,116.56008978,1773.76438523,20.2608628804,-11.9462395994,-885.917331456,404.610749546,-1736.7071721,481.279674772,550.011727097,-626.25427688,-435.261619815,381.025635154,-361.791843763,-249.097799613,-299.812143605,551.457138778,-129.909675437,-128.542091956,109.392096665,379.899110651,-20.1341607528,-172.897800169,77.7303683522,-249.387501153,200.02921417,88.9152536812,-16.4799120188,48.593836841,-222.306277848,256.721966644,-81.7411984179,-5.00350533112,-66.2589577093,140.194091326,-61.9315452422,65.0633965195,-5.81265861069,64.7443084013,20.6703226203,-87.2919303992,89.1107926732,23.6320017465,-28.9560303241,-59.2664474729,13.3929610476,-6.16776729626,22.0595397245,-5.41043381026,13.7873026105,-0.156375567399,16.8549190055,26.6557283249,-13.7343162116,37.5445428311,1.52456293974,7.17807973685,-13.9361647495,-8.13195532491,-0.324256317513,2.78530385296,0.236129424977,-4.23960252847,-3.09207817289,-1.21610163724,1.35109186332,4.10041322579,5.19871766049,-0.408507598614,8.58109578893,2.65284292898,3.50135619283,-1.41413607785,-2.08519396508,-2.16347660744,2.19573969383,1.38420762903,1.17484889287,-0.0276107495166,-1.29684758657,-0.467809719833,-0.00935314135668,-2.46618342142,1.67285895467,-0.299389245391,0.909569892883,0.15009108498,0.190050816192,2.28351665069,-1.45993416014,-0.785187508087,-1.46210318434,1.53527634193,-0.0432064475041,0.972100605755,-0.741623620053,0.343959874438,0.0800700543973,-0.74361921122,0.259008961633,-0.00259345038006,-0.587056085657,0.205557829165,-0.0972877133376,0.9013986989,-0.252145834685,0.0348130624257,0.475924260283,0.373400133524,-0.303569103596,-0.30056937911,0.48382932431,0.209846710343,0.249488608345,-0.28577595711,-0.0700442455666,-0.228089875585],[-38426.2932134,-1324.11416223,-1762.7019604,-1616.81786411,95.5146560725,1741.99101488,33.7495787186,-8.72163050565,-846.694412115,390.627827712,-1738.52209906,491.158878425,539.555152414,-644.613890314,-430.746076499,389.594378253,-368.902719138,-243.724848147,-305.261078326,545.199001546,-141.74865824,-119.689749412,114.334710728,379.700854558,-22.4318216195,-172.008063222,77.7828894837,-251.16915376,204.617693801,87.7204565414,-16.9933380235,47.8594884113,-231.043244173,261.514205858,-78.9350151694,-9.3677014188,-63.1111650109,139.888461916,-63.1707613828,65.5199686254,-4.10981107546,64.0028596259,17.0914290316,-89.5975911807,90.4322574265,27.3769363194,-26.9216509756,-59.7552589058,12.2134821618,-5.10553183247,22.4865289317,-5.69330470305,13.675033291,0.199674337436,17.1272814063,25.4088899728,-14.0466949813,37.5935712246,2.99195541543,8.01298917553,-14.2843074629,-8.52037846176,0.180561361059,2.66755826888,0.409058369608,-4.27916984684,-2.93487861568,-1.08255603938,1.56404411819,4.21520030546,4.9694386167,-0.27822062375,8.42085978117,2.8758950538,3.80226988512,-1.37636403071,-2.17153811305,-1.99825137232,2.21809696268,1.67198857916,1.14091550023,-0.0796122945774,-1.3657891491,-0.40723398239,0.0238555284587,-2.36148140913,1.69637250645,-0.318074208979,0.950302911174,0.128868616689,0.205097111212,2.31476355935,-1.40761847721,-0.79714560606,-1.45533260303,1.51264582194,0.0883761381634,0.999675495606,-0.73611624639,0.338561105872,0.0382541066873,-0.760948965035,0.264571351504,0.00690409296606,-0.567964308013,0.22332613137,-0.0920391258873,0.906638850063,-0.264391286843,0.0259968834995,0.47320193827,0.375816118813,-0.301216559901,-0.30243705312,0.474522447568,0.237259890944,0.259176506292,-0.28261762341,-0.0768187659812,-0.227753013534],[-38373.9789587,-1386.80489642,-1831.05759284,-1624.93790798,79.7919383359,1710.50540134,45.0164828623,-5.2625683479,-805.619193281,377.169431338,-1740.58617003,497.859383184,529.515286403,-661.7390256,-428.879423874,399.296196086,-377.745964088,-237.906541797,-312.029943865,536.936054371,-154.374702818,-110.615305131,118.218025474,380.183495626,-23.954012604,-171.419317864,78.1166458294,-252.74128989,208.722273087,85.8525237929,-17.7777842611,46.6668335549,-239.772768387,265.302368663,-76.3088277125,-13.7588611003,-59.7918485475,139.541829505,-64.2259104652,65.7237328347,-2.44157999518,62.927627511,13.3857233531,-92.0474433658,91.3908940581,31.0730411901,-24.7752052716,-60.2640462831,10.9790277422,-3.96066976619,22.9219577285,-5.91049638624,13.538418329,0.536828065164,17.3356861016,24.1142401164,-14.4585475404,37.5361367032,4.44874016496,8.87011017886,-14.6698793985,-8.90709105346,0.689379885457,2.5356880064,0.586910228778,-4.32368499204,-2.75119526216,-0.934523215464,1.77779511045,4.32794588456,4.72795181942,-0.163888235307,8.24052853715,3.07640142257,4.11499637165,-1.35418961223,-2.25680363006,-1.83756451923,2.23407232719,1.95645631582,1.10299227148,-0.136248938998,-1.4396046877,-0.343089528077,0.0620024762121,-2.25078196405,1.722319521,-0.339390444796,0.992858705598,0.111126765475,0.21229485298,2.34733595785,-1.35452839539,-0.805461959232,-1.44851883749,1.48549186636,0.221492342412,1.02851208111,-0.73155342203,0.332434454695,-0.00607513060527,-0.778561636705,0.26916894693,0.0165029259308,-0.546919163379,0.242825868918,-0.0877035936957,0.91284121094,-0.27540922453,0.0153300337334,0.470661973243,0.37726437052,-0.296325148126,-0.304120266262,0.464024194351,0.264299978077,0.269709461503,-0.279826696252,-0.0837016094046,-0.227097010587],[-38323.2953739,-1444.59964389,-1901.38471576,-1631.56171991,68.7028657585,1679.73755547,54.9090261962,-2.11623434814,-763.216641447,364.328074787,-1742.64035051,501.65968076,520.003322282,-677.709933515,-429.034050645,409.845574041,-388.187348103,-231.631598756,-319.933133633,526.691941509,-167.630269899,-101.305718245,121.036685928,381.118866851,-24.7336998037,-171.119569102,78.6847184325,-254.087413383,212.368826467,83.3300193954,-18.7611470381,45.0448821215,-248.498504202,268.027807606,-73.9241217869,-18.1495210796,-56.3399251075,139.133540351,-65.1047824911,65.7014825349,-0.823262008118,61.5591784489,9.57780811819,-94.6155880958,91.9656261093,34.6825065781,-22.5393486154,-60.7779989423,9.70472624633,-2.74745567101,23.3601568646,-6.06446281939,13.3829800847,0.849287268399,17.4849073253,22.776758288,-14.9564458549,37.3716677568,5.88235443803,9.74470047398,-15.0849933855,-9.28294692223,1.19755320305,2.39213124272,0.768692073668,-4.37398201744,-2.54336349612,-0.773350544243,1.99026070874,4.43722340508,4.47448763716,-0.0633846185429,8.04038396053,3.25355755399,4.43666740759,-1.34729355779,-2.33665595506,-1.68256898371,2.24381255449,2.23429211487,1.06118739738,-0.196643758828,-1.51723731057,-0.276275053546,0.104710463681,-2.13497186967,1.7500778053,-0.363484940297,1.03697750888,0.096402588026,0.212119579934,2.38060715062,-1.30135299401,-0.809168483503,-1.44183663026,1.45398955125,0.354572586141,1.05813046167,-0.728079245193,0.325561540564,-0.0524842316697,-0.796163294043,0.272857067438,0.0262260032173,-0.52405107037,0.263833681025,-0.0842606481434,0.919887115946,-0.285170011773,0.00303216882544,0.468164168421,0.377677507289,-0.28887529722,-0.305739279143,0.452390066295,0.290686175504,0.280876912054,-0.277414691856,-0.090617759038,-0.226045078833],[-38272.9861928,-1498.78039642,-1972.17911921,-1637.05889838,61.4723114207,1650.13699857,64.4773467144,0.292099305605,-720.11134726,352.159801234,-1744.32470047,502.89375685,511.132818861,-692.594537166,-430.462111901,420.919168884,-400.095539782,-224.846950612,-328.754932221,514.49592428,-181.353155575,-91.725671405,122.832312302,382.216305919,-24.8087827159,-171.094241777,79.4366950793,-255.185340904,215.590844299,80.1845978986,-19.8586269822,43.046107591,-257.231628988,269.636650088,-71.8407935811,-22.511594763,-52.7972528789,138.64142006,-65.8178719837,65.4855675871,0.732675130885,59.9422409329,5.69731124787,-97.2768482605,92.1389280335,38.1687836397,-20.2414417383,-61.2777556805,8.40626864208,-1.48180916495,23.7955431172,-6.15891229749,13.2160870404,1.1311639365,17.5804501516,21.4024111814,-15.5260466355,37.1018804002,7.28100468892,10.6311397562,-15.5198775098,-9.63730775915,1.70011180316,2.23938213983,0.953208355934,-4.43095497398,-2.31416929951,-0.600231623747,2.19935635589,4.54179414342,4.20949335107,0.0258602835116,7.82145591432,3.40713270852,4.76419164505,-1.35464705234,-2.40625602776,-1.53444845709,2.24754155207,2.50204174519,1.01565449271,-0.259906244811,-1.59759777857,-0.207809574641,0.151538761412,-2.01503725482,1.77907502294,-0.390487008141,1.08242902302,0.0843553879296,0.205243791008,2.41404107895,-1.24865903903,-0.807196769513,-1.43547331082,1.41833953879,0.485941239216,1.08793512241,-0.725859693577,0.31794705143,-0.100519043175,-0.813467668417,0.275691457468,0.0360738564166,-0.499534734707,0.286116356946,-0.0816856969063,0.927670683124,-0.293645196625,-0.0106358633317,0.465617267032,0.37702661739,-0.278859814318,-0.307406573068,0.439680966548,0.316138746372,0.292414253537,-0.27539135526,-0.0974865240866,-0.224519614188],[-38221.7951495,-1550.62914577,-2041.93659325,-1641.79904186,57.325148403,1622.15325192,74.7715824107,1.53716042532,-676.927901369,340.720653857,-1745.27927991,501.89559715,503.017334952,-706.460759664,-432.415762735,432.193637383,-413.339207724,-217.499528955,-338.279624221,500.377264003,-195.381155937,-81.8398472641,123.646524807,383.185150511,-24.2171608377,-171.328760732,80.3221635562,-256.01288912,218.421816943,76.4479138521,-20.9854247207,40.7229834434,-265.983320109,270.075023507,-70.1187392834,-26.8169955569,-49.2056900492,138.043294236,-66.3756734664,65.1083378521,2.21376366697,58.1215434562,1.77386066326,-100.00604675,91.8932742839,41.4953235311,-17.9088453717,-61.7439552947,7.09934589738,-0.179649866003,24.2225332636,-6.19755311555,13.0451076786,1.37657005884,17.6278196552,19.9971654907,-16.1530065928,36.728490648,8.63289737196,11.523807721,-15.9647598572,-9.95953525527,2.19208617513,2.07993485971,1.13926352723,-4.49549791258,-2.06639865424,-0.416360052005,2.40299749471,4.64041937602,3.93341624229,0.106416527825,7.58477426154,3.5368961466,5.09447773613,-1.3752212808,-2.46076478791,-1.39438663072,2.24548322743,2.75625097566,0.966547172228,-0.325145887692,-1.67959685261,-0.138712107203,0.202046639952,-1.8919642483,1.8087388375,-0.420525960989,1.12898294999,0.0746444687733,0.192339985137,2.44710168418,-1.19701329638,-0.7984784079,-1.42961620864,1.37874249119,0.613922671503,1.11733054844,-0.725060744877,0.309595675245,-0.149725411789,-0.830188491198,0.27772786146,0.0460470171203,-0.47354486211,0.309440685937,-0.0799541476603,0.936086030518,-0.300806327141,-0.0254132148454,0.462930012301,0.375282789094,-0.266271506554,-0.309234629343,0.42595779826,0.340377953825,0.304056881544,-0.273766431505,-0.104227213756,-0.222443012566],[-38168.4659778,-1601.42788371,-2109.15292792,-1646.15174886,55.4862497859,1596.23583683,86.8418712792,1.19367682297,-634.290894421,330.066675833,-1745.1441488,498.999187356,495.770429365,-719.376524118,-434.147158237,443.345636306,-427.78702053,-209.536265373,-348.291494222,484.365222,-209.552067074,-71.6129284736,123.520943653,383.734738312,-22.9967336665,-171.808550809,81.2907116494,-256.547874698,220.895234757,72.1516218059,-22.0567408812,38.1279831587,-274.764754935,269.289055263,-68.8178550824,-31.0376368677,-45.6070948064,137.316988484,-66.7886814623,64.6021431911,3.60753584528,56.1418145121,-2.16291571454,-102.778006453,91.2111393139,44.6255774085,-15.5689202469,-62.1572365819,5.79964898016,1.14310260781,24.6355440808,-6.18409356857,12.8774104815,1.57961762477,17.6325209103,18.5669879097,-16.8229824371,36.2532145147,9.92623894144,12.4170840636,-16.4098685135,-10.2389911017,2.66850680826,1.91628356434,1.32566203922,-4.56850488419,-1.80283754223,-0.222929427047,2.59909956804,4.73186037929,3.64670359197,0.180854171367,7.33136886518,3.64261712869,5.42443433292,-1.40798742813,-2.49534317522,-1.26356719594,2.23786148807,2.99346557516,0.914019050707,-0.391472178217,-1.76214529356,-0.0700016670733,0.255793369849,-1.76673897896,1.83849691259,-0.453731111502,1.1764089918,0.0669291341449,0.174080661254,2.47925290759,-1.14698253201,-0.781944989304,-1.42445265319,1.33539907061,0.736841252868,1.14572122487,-0.725848376792,0.30051209996,-0.199649184182,-0.846039493753,0.279022023853,0.0561460169194,-0.4462561583,0.333573457251,-0.0790414080813,0.94502727617,-0.306624951376,-0.0410390378233,0.460011147452,0.372417110672,-0.251103181061,-0.311335929272,0.411281464579,0.36312406101,0.315540191667,-0.27254966563,-0.11075913725,-0.219737669884],[-38112.0352934,-1652.07791152,-2172.89535515,-1650.43092183,55.1229609653,1572.8565808,101.290858264,-1.17096484652,-592.813155925,320.244158009,-1743.59355397,494.498293257,489.478672346,-731.385296568,-435.021726495,454.068513237,-443.275109294,-200.907791529,-358.582852676,466.500614112,-223.71249132,-61.0799810001,122.501186645,383.616516983,-21.188639978,-172.506184044,82.2893909062,-256.762169076,223.047423485,67.331871517,-23.0143529588,35.3100030585,-283.582726201,267.247209731,-67.9943132355,-35.148792492,-42.0418638121,136.441625911,-67.0659277951,63.9990293183,4.90448858628,54.0420609536,-6.08395404484,-105.569225239,90.0829918868,47.5249588548,-13.2496820572,-62.5014620619,4.52132137843,2.46999530293,25.0290417432,-6.12213926008,12.720268521,1.73584973585,17.6001274536,17.1184114944,-17.5227657508,35.6789739715,11.1494726847,13.3047781132,-16.8465341234,-10.466199721,3.12552347142,1.75070587587,1.51096028628,-4.65072283932,-1.52643845213,-0.0211192367641,2.7859549899,4.81523342182,3.35008864363,0.251503197427,7.06241669692,3.72427116214,5.7511863312,-1.4520127864,-2.50553323136,-1.14281990789,2.22502476395,3.2104757603,0.858260469804,-0.458080724563,-1.8441681862,-0.00272907020877,0.312270601718,-1.64033496936,1.86789161354,-0.490151338546,1.22444772817,0.0609078544526,0.151196960536,2.51013267966,-1.09913145784,-0.756663851015,-1.4201132342,1.28855440472,0.853090679312,1.17255078686,-0.728338852638,0.290727668322,-0.249844957474,-0.860746064454,0.279611007152,0.0663450968354,-0.417870493261,0.358301749222,-0.0789181114236,0.954400094325,-0.31108498754,-0.0572418769315,0.456840695357,0.36840618278,-0.233360375404,-0.313810942197,0.395728238307,0.384107377325,0.326609863796,-0.271752394835,-0.116998949332,-0.216342987769],[-38052.7112383,-1701.95776856,-2234.51687431,-1654.72767923,55.1725165975,1552.57653623,116.931216113,-6.01874255658,-553.060470828,311.26038191,-1740.43848958,488.525801011,484.120679883,-742.432714777,-434.85798758,464.122379028,-459.5094551,-191.579539369,-368.97811347,446.870474266,-237.744255978,-50.5576040683,120.648861948,382.750374096,-18.8469756619,-173.34282125,83.2551079163,-256.603862791,224.926050404,62.0427935724,-23.9063459199,32.3036308295,-292.426488123,264.007299196,-67.689390277,-39.1391777884,-38.5445476242,135.401519637,-67.2105934898,63.3298253605,6.10697751172,51.8384030732,-9.96244680867,-108.362900892,88.5312780052,50.1667311597,-10.981766343,-62.7733891455,3.27231666056,3.78244192359,25.3976900128,-6.01488502781,12.5805732265,1.8465339424,17.5364866699,15.6602347485,-18.2436876023,35.0135148152,12.2919892211,14.1784177343,-17.2704975658,-10.6363364627,3.56376305156,1.58461325714,1.69272243365,-4.74231032683,-1.24081989946,0.187947471492,2.96336405907,4.89107474083,3.04544849014,0.319733294579,6.77968316301,3.78265874191,6.07272360143,-1.50674907626,-2.48840140575,-1.03155877682,2.20781957495,3.40504953864,0.799608678758,-0.524511604639,-1.92464791091,0.0619276669796,0.370699506456,-1.51367531713,1.89692411261,-0.529513785815,1.27272324975,0.0564357673884,0.124654593133,2.54007488746,-1.05401656964,-0.72224531693,-1.41650158232,1.23863148299,0.961341951379,1.1974194697,-0.732449578215,0.280380342277,-0.299902330602,-0.87408021968,0.279457146125,0.0765133356095,-0.388698394029,0.383493796499,-0.0795357932558,0.964156384023,-0.31421983447,-0.0737078470715,0.45368379747,0.363248655616,-0.213099548867,-0.316712089596,0.379435870856,0.403098397179,0.337052715009,-0.27139232497,-0.122852686988,-0.212266390699],[-37990.994836,-1750.06530373,-2295.94192664,-1659.0774435,54.5146236541,1535.97906169,132.128124523,-13.8189754377,-515.586862939,303.112876733,-1735.52413665,481.174376866,479.648079395,-752.439959439,-433.587734561,473.284035345,-476.163501526,-181.520640913,-379.309716349,425.57339091,-251.537994593,-40.4327802176,118.029575323,381.098307201,-16.0290758866,-174.226770434,84.1222330306,-256.015101152,226.581618177,56.3430137661,-24.8073815985,29.1398770004,-301.280910289,259.64947292,-67.9406388103,-43.0008685056,-35.1482352747,134.182280286,-67.2243968717,62.6250562975,7.22032291865,49.5412395229,-13.7721505675,-111.143906173,86.5864379819,52.5261200395,-8.79646360645,-62.9729989663,2.05904091504,5.06132283846,25.736202049,-5.86542301802,12.4651206172,1.91436890693,17.4475144061,14.2018225377,-18.978213932,34.2657887991,13.3434160033,15.0289604251,-17.6786022787,-10.7457394078,3.98497171517,1.41920063115,1.8682645893,-4.84327879514,-0.949766906494,0.403161760508,3.13150404553,4.96027556574,2.73494618676,0.386674077721,6.48508077836,3.81878660984,6.38725225774,-1.5717441255,-2.44139524976,-0.928843876786,2.18721696343,3.57519936546,0.738437653701,-0.59039101379,-2.00258117195,0.122758727966,0.43023363503,-1.38767051365,1.9257102838,-0.571465163209,1.32083052494,0.0534071774649,0.0954779114392,2.5695874072,-1.01219230916,-0.678435457599,-1.41346458846,1.18609776036,1.06033539575,1.21996665873,-0.738048244939,0.269634738563,-0.349419652951,-0.885825632812,0.278504093606,0.0864935214129,-0.3590775519,0.40903812281,-0.0808412147249,0.974259600506,-0.31607526116,-0.0901124557038,0.450876874886,0.356948691763,-0.190389891163,-0.320079780986,0.362557483292,0.419877661233,0.346665846684,-0.271488754045,-0.128223732762,-0.207532308864],[-37927.3871104,-1795.39836589,-2359.09495337,-1663.5156371,52.0289891068,1523.64751578,145.246763191,-25.0409826204,-480.946356066,295.799171672,-1728.69567618,472.536687072,476.012498305,-761.328211247,-431.142760505,481.330283857,-492.910692151,-170.70022818,-389.410101061,402.707952492,-264.984340708,-31.0924919874,114.708932527,378.622313847,-12.7922758202,-175.066339604,84.8251365999,-254.938029468,228.064629465,50.2911578925,-25.7921218289,25.8497520993,-310.130862283,254.253880164,-68.7856114387,-46.7259403923,-31.8860157954,132.769518481,-67.1090562663,61.9152471092,8.24984510415,47.160968955,-17.4868218827,-113.897113846,84.2789121297,54.5783512105,-6.72506434986,-63.1002726578,0.887900230336,6.28751841622,26.0392910107,-5.67684537697,12.3807067119,1.94205329194,17.3391265092,12.7525397276,-19.7188106802,33.4447476764,14.2933804835,15.8473636841,-18.0676916998,-10.7907466372,4.39089562872,1.25566292092,2.0349028612,-4.95363969268,-0.657064495472,0.623414693069,3.29055221923,5.02372712593,2.42074478872,0.453455161749,6.18052205787,3.83366150779,6.69297841428,-1.6465457619,-2.36196231473,-0.833735281827,2.16418797176,3.71893769605,0.675121370765,-0.655345147356,-2.07696467359,0.178554296227,0.490026538404,-1.26323105028,1.95436600111,-0.615652180628,1.36836452214,0.0517163891947,0.0646912678465,2.59917811513,-0.974213118146,-0.624980343571,-1.41084914353,1.13142069177,1.14881133909,1.23983173931,-0.745002544231,0.258655473923,-0.397995273912,-0.895765977231,0.276695502428,0.0961284424169,-0.329345658172,0.434823251883,-0.0827811369781,0.984673199017,-0.316697036603,-0.106131210289,0.448756348705,0.349510453804,-0.165300592006,-0.32395442588,0.345246196679,0.434225710149,0.355246360197,-0.272060980071,-0.133015469197,-0.202165172454],[-37862.3890851,-1836.95480395,-2425.90039574,-1668.07768247,46.5953199271,1516.16525711,154.652311815,-40.1540832352,-449.692974017,289.316795923,-1719.79828919,462.70539788,473.165564035,-769.018650894,-427.454858481,488.037926232,-509.424470555,-159.087433191,-399.111707353,378.372747462,-277.97392787,-22.9237219171,110.75253932,375.284391584,-9.19391063107,-175.769836766,85.2981889747,-253.314793049,229.425586931,43.9458517458,-26.935228445,22.4642666548,-318.961213691,247.90067019,-70.2618607656,-50.3064691974,-28.7909782183,131.148844844,-66.8662899989,61.2309227755,9.20086436528,44.7079900217,-21.0802173157,-116.607396672,81.6391407611,56.2986503891,-4.79885907547,-63.1551913535,-0.234699305089,7.44190902555,26.3016700572,-5.45224425093,12.3341275297,1.93228575996,17.2172388261,11.3217511839,-20.457943787,32.5593432003,15.1315101143,16.6245850095,-18.4346092669,-10.767696232,4.7832809587,1.09519504945,2.18995335733,-5.0734044679,-0.366497688652,0.847597331961,3.44068585015,5.08232065081,2.10500735127,0.52120616156,5.86791951645,3.82829017761,6.98810818519,-1.73070181326,-2.24755015204,-0.745293065992,2.13970364228,3.8342769857,0.610033806083,-0.719000200681,-2.14679512012,0.228104555234,0.549231767545,-1.1412674184,1.98300713854,-0.661721547971,1.41492020972,0.0512577070907,0.0333190147482,2.62935488746,-0.940633438356,-0.561626045396,-1.40850213843,1.07506773217,1.22551010809,1.25665409677,-0.753180167508,0.247607165097,-0.44522754287,-0.903684926318,0.273975025425,0.105260886793,-0.299840404145,0.460737707446,-0.0853023211623,0.995360634797,-0.316130929795,-0.121439618287,0.447658640024,0.340938104324,-0.137900841109,-0.328376433794,0.327655132083,0.445923084588,0.362591356924,-0.273128301059,-0.137131278836,-0.196189411661],[-37796.5147612,-1874.00817206,-2497.71575433,-1672.754782,37.2898491235,1513.86992008,159.198557539,-59.52590489,-422.277153903,283.676899281,-1708.78123517,451.819329701,471.054223187,-775.38987108,-422.39467413,493.22175445,-525.404727384,-146.668042651,-408.235603541,352.693085583,-290.39608599,-16.2544153471,106.217021961,371.035745832,-5.28709688638,-176.252043445,85.4887664078,-251.098085878,230.713662279,37.3571790095,-28.3056162105,19.0137291312,-327.749606777,240.668778371,-72.3829935365,-53.7356223562,-25.8924286112,129.310092838,-66.5034811182,60.5993161602,10.0760927326,42.1922783902,-24.5256534886,-119.25892031,78.7018105353,57.670530616,-3.04363974442,-63.1371663345,-1.30367795702,8.50716126454,26.5191185759,-5.19641794129,12.3310779204,1.88744358747,17.0877651752,9.91899004379,-21.1880225597,31.6198016406,15.8508127549,17.3528958294,-18.7756827818,-10.6739318896,5.16391236107,0.938850652334,2.3310513342,-5.2024280221,-0.081708392591,1.07471762602,3.58204085365,5.13710322751,1.78993540914,0.59098978798,5.54964274481,3.80406467252,7.27104128771,-1.8233444271,-2.09637886579,-0.662554982947,2.11454145998,3.91958784449,0.543564510793,-0.780982751606,-2.21119553884,0.270407759507,0.607072681825,-1.02259109498,2.01173847369,-0.709313580711,1.46007773518,0.0519944497,0.00234593282441,2.66052133583,-0.911797305929,-0.488281377711,-1.40620094763,1.01745503995,1.28943633588,1.27009538331,-0.762438025847,0.236658253766,-0.490735687831,-0.90940040229,0.270334526973,0.113745948291,-0.270891301563,0.486659204837,-0.0883660920612,1.0062577232,-0.314457171625,-0.135755095593,0.447873599327,0.331269436785,-0.10829829318,-0.333347995652,0.309915036568,0.454829651597,0.368511369109,-0.274686272882,-0.14047958442,-0.18961687029],[-37730.3300502,-1906.93484555,-2573.63076712,-1677.36125789,23.9749138513,1516.11624248,159.69371729,-83.1173091028,-398.734986047,278.94511394,-1696.01008758,440.201919602,469.606699096,-780.150112522,-415.588263389,496.848521748,-540.657141561,-133.494462013,-416.557372226,325.901161877,-302.134930455,-11.1763688229,101.123088715,365.784413484,-1.10807674894,-176.453635247,85.3962687594,-248.282796636,231.972703387,30.541054925,-29.9492116075,15.525639737,-336.444774507,232.632284524,-75.0668330663,-57.010934051,-23.2045411859,127.259987272,-66.0506715661,60.0344916623,10.867809171,39.6221177881,-27.7946872655,-121.833022003,75.5185934971,58.7106542285,-1.46320415347,-63.043329471,-2.31926140826,9.47308664894,26.6916808681,-4.92098936999,12.3728480583,1.80861850689,16.9566112601,8.55446253022,-21.9012297737,30.6414473327,16.4578178906,18.0298232905,-19.0851775032,-10.5108197723,5.53472844977,0.787118215485,2.45710864262,-5.33993906817,0.194233948954,1.30425106826,3.71458772664,5.18974537412,1.47788441498,0.663601135566,5.22988963693,3.76391829124,7.54095185161,-1.92194302995,-1.90975877108,-0.584469504845,2.08870468024,3.97467350163,0.476165336051,-0.840920907964,-2.26979424928,0.305294447727,0.663051874238,-0.907617499358,2.04062039861,-0.758043016613,1.50335796237,0.0541659917085,-0.027401484097,2.69266401354,-0.887207134586,-0.405506131515,-1.40344487984,0.958793587384,1.34065188135,1.27990631857,-0.772589908955,0.225992481365,-0.534222451264,-0.912867322703,0.265958717618,0.121487942981,-0.242795143967,0.512422225838,-0.0919920290043,1.01718972004,-0.311893840579,-0.148962691846,0.449504794649,0.320676768162,-0.0767544628992,-0.338718428021,0.292067161206,0.461122583761,0.372870652463,-0.276635482865,-0.142988969488,-0.182409046615],[-37664.413841,-1936.38690502,-2652.16823146,-1681.66721232,6.7093773024,1522.01323791,157.434615441,-110.787465869,-378.998974075,275.200692694,-1681.95449839,428.222758812,468.746534277,-782.965027944,-406.600534771,498.922971672,-555.013839076,-119.635751415,-423.841224581,298.255892683,-313.073273019,-7.72234169083,95.4824683446,359.427639305,3.31112621953,-176.321761294,85.0331017917,-244.874362676,233.245227176,23.5048526227,-31.9061940476,12.0267966168,-344.988222528,223.864054579,-78.2072568116,-60.1310301504,-20.7377071901,125.009475797,-65.5435680076,59.5472215645,11.5656843787,37.0053689577,-30.8584355714,-124.310331889,72.1454080378,59.4439708884,-0.0558515582561,-62.870242781,-3.28300169589,10.3312829239,26.8204674632,-4.63928761409,12.4596269482,1.69658086463,16.8296807557,7.23854313765,-22.589691571,29.6408791286,16.9624354139,18.6542084696,-19.3568430535,-10.280731659,5.8977063282,0.640344937402,2.56735628194,-5.48500977188,0.458403007925,1.53579003776,3.83825561142,5.24207346649,1.17124830094,0.739768394802,4.91331516258,3.71116964389,7.79720760975,-2.02355136806,-1.68977273576,-0.509962783457,2.06200300107,3.99969534112,0.408303708023,-0.89844316009,-2.32234589403,0.33280322962,0.716741746183,-0.796663036479,2.06970220892,-0.807518199012,1.54426693424,0.0580807218366,-0.0551363139013,2.72566520929,-0.866154932447,-0.314022841897,-1.39966372732,0.899243050191,1.37948290989,1.28585988905,-0.783438826195,0.215797414269,-0.575411454256,-0.914074853952,0.261080519448,0.128403492509,-0.215840545342,0.53785044384,-0.0962142749576,1.02795424124,-0.308693477039,-0.160989365116,0.452609223409,0.309366046313,-0.0435693299401,-0.344298828876,0.274130383064,0.46505838005,0.375546893563,-0.278852776198,-0.144593057773,-0.174514852522],[-37599.3450225,-1963.01643109,-2731.85094467,-1685.44274744,-14.4478973311,1530.66991996,153.718076366,-142.395545185,-363.001621612,272.522888336,-1667.08411955,416.25143856,468.397271246,-783.500270069,-394.996396785,499.449847772,-568.30694592,-105.160970996,-429.851371776,270.016194339,-323.093925435,-5.92509329734,89.3068896155,351.862668058,7.9384884573,-175.803570709,84.4116712668,-240.878221354,234.573750567,16.2559452333,-34.2167429423,8.54399791507,-353.321456482,214.436954463,-81.6981422296,-63.0945365233,-18.5023178716,122.569506062,-65.0178771077,59.1482781499,12.159389054,34.3498926416,-33.6880153311,-126.671480107,68.6381725487,59.8954302576,1.18011878556,-62.614468282,-4.19645085698,11.0733478346,26.9065888906,-4.36464175066,12.5916035953,1.55210100711,16.712877337,5.98160636054,-23.245534094,28.6346958804,17.3745752169,19.2248924431,-19.5844290555,-9.98603932846,6.25482309977,0.498878016586,2.66102525151,-5.63671229899,0.707872456262,1.76892691359,3.95297365029,5.29591388044,0.872420999156,0.820219756174,4.60457429154,3.64913734056,8.03917629501,-2.12522318769,-1.43850362768,-0.437960970558,2.03424612049,3.99481474695,0.340447052871,-0.953177998317,-2.36860511567,0.352972714912,0.767714699059,-0.69004411128,2.09903320027,-0.857347471245,1.58231069372,0.0640470288045,-0.0800716344736,2.75940721179,-0.847932707627,-0.214554043945,-1.39428728234,0.838963104099,1.40625558684,1.28772908126,-0.794787786932,0.206260618852,-0.614026317894,-0.913012162427,0.25593285455,0.134409218526,-0.190316119677,0.562767532234,-0.101066972887,1.03834890272,-0.305108621386,-0.171762073478,0.457243883028,0.297543219094,-0.0090428739768,-0.349900296194,0.256123579213,0.466893539435,0.376417778988,-0.281214998067,-0.14522547301,-0.165883199902],[-37535.7024836,-1987.47550435,-2811.2017041,-1688.4579654,-39.4380468571,1541.19530225,149.840924438,-177.800717045,-350.675432284,270.990953659,-1651.86860302,404.657550074,468.482452519,-781.421491621,-380.340757943,498.433893596,-580.368588083,-90.1391808961,-434.352024983,241.440983183,-332.079699457,-5.8173829889,82.608081292,342.986744507,12.7419864027,-174.846212616,83.5443829469,-236.299810023,236.000790481,8.80170588744,-36.9210377033,5.10404177639,-361.385982017,204.423850105,-85.433366777,-65.9000790383,-16.5087644781,119.951025715,-64.5093055318,58.8484337011,12.6385938952,31.6635495823,-36.2545434694,-128.897096797,65.0528054209,60.0899819978,2.24640762234,-62.272567992,-5.06116092859,11.6908791261,26.9511556799,-4.11038085677,12.7689670047,1.37594928071,16.6121046789,4.79402669334,-23.8608834849,27.6394964399,17.7041471918,19.7407162877,-19.7616851315,-9.62911455952,6.60805586789,0.363064651535,2.73734655071,-5.79411881528,0.939715965908,2.00325407481,4.05867098555,5.35309299182,0.583796441777,0.90568341017,4.3083219936,3.58113999136,8.26622564026,-2.2240122351,-1.1580343147,-0.367390217919,2.0052437365,3.96019310313,0.273062796759,-1.00475391298,-2.40832655678,0.365841513327,0.815543134267,-0.588077128698,2.1286626683,-0.907139176649,1.61699528376,0.0723733013328,-0.101420523699,2.79377230975,-0.831832468243,-0.107822272747,-1.38674533716,0.778113424833,1.42129607757,1.28528688169,-0.806439800532,0.19756966149,-0.649790663264,-0.909668414522,0.250748645014,0.139421742677,-0.166510480957,0.586997164412,-0.106584265759,1.04817132041,-0.301391814004,-0.181207775004,0.463465770926,0.28541423436,0.026524925317,-0.355333927951,0.238065626723,0.466884560885,0.375360995315,-0.283598993662,-0.144819838936,-0.156463000642],[-37474.0807819,-2010.22431043,-2889.09882949,-1690.45443524,-68.1529059381,1552.93134847,146.768140457,-216.816036921,-341.979790733,270.672594776,-1636.71546221,393.758877352,468.972794497,-776.509616276,-362.324048775,495.870992725,-591.054585725,-74.6354814884,-437.159900292,212.789905171,-339.928127089,-7.42431003926,75.4160713186,332.749736162,17.6897951488,-173.409960224,82.4524586394,-231.146199918,237.562329298,1.15773192502,-40.0535511981,1.74020721992,-369.120164841,193.899537506,-89.3085504118,-68.5442518967,-14.7644246574,117.165950051,-64.047120312,58.6550638857,12.9942598591,28.9523734877,-38.5309419122,-130.968349303,61.4417102528,60.0523845754,3.14735783608,-61.8435039881,-5.87866860709,12.1774748024,26.9545436241,-3.88848391018,12.9913533773,1.1686557825,16.5318685053,3.68478843665,-24.4295517634,26.6704570272,17.9608689712,20.2010518335,-19.8834011906,-9.21300502813,6.95892661014,0.233024698963,2.79569202967,-5.95623601761,1.15113672084,2.23846696713,4.15500918591,5.4151556985,0.307207497385,0.996404192846,4.02894827656,3.51040379981,8.47821805656,-2.31723338221,-0.850636176847,-0.297037188729,1.97467153996,3.89637800449,0.206547706847,-1.05287242825,-2.44133379997,0.371452165648,0.85987476354,-0.491079128027,2.15868020527,-0.956576627305,1.64785576423,0.0834531204573,-0.118474485417,2.82873552989,-0.817173322942,0.00541875776117,-1.37644376979,0.716875865818,1.42506665319,1.27839307869,-0.818190088125,0.189886910112,-0.682472585542,-0.904058721621,0.245722796614,0.143377952685,-0.144664856499,0.610394245768,-0.112790359845,1.0572316936,-0.297731035591,-0.189264975248,0.471348572195,0.273176615734,0.062864659606,-0.360398625472,0.219977128828,0.46529217016,0.372301920835,-0.28589628075,-0.143327172356,-0.14621982432],[-37415.1371494,-2030.95545498,-2965.84273031,-1691.05959348,-100.287100654,1566.15182271,144.137330928,-259.070102187,-336.981605659,271.589331066,-1621.78365642,383.665975466,470.02770913,-769.006651528,-341.138787881,491.721588873,-600.315535681,-58.6991340874,-438.301733466,184.325524733,-346.595621338,-10.7403334315,67.8340843593,321.31200152,22.750884409,-171.507583099,81.1923843326,-225.430997787,239.268211236,-6.62748247658,-43.6259301182,-1.48830323672,-376.449810934,182.946532948,-93.2262830954,-71.0155226285,-13.2646216574,114.230064947,-63.6348299497,58.5619579103,13.222508936,26.2150899269,-40.4973525889,-132.868553799,57.8432314702,59.8066316751,3.89788086942,-61.3358385845,-6.650449226,12.534733902,26.9141895712,-3.70552949148,13.2561876971,0.929789612077,16.4710827362,2.65731511557,-24.952094459,25.7370633352,18.1536891488,20.6073939241,-19.9485282864,-8.74346199895,7.30713680077,0.107968648439,2.83599694171,-6.12180872716,1.33985595319,2.47467330277,4.24057952566,5.48252098654,0.0422427803242,1.09069352254,3.76978330034,3.43978534311,8.67699466775,-2.40324600368,-0.519334642908,-0.225130591841,1.94166919318,3.80546188927,0.141015914282,-1.0975272037,-2.46772618807,0.369862936886,0.900658539948,-0.399369685984,2.18933659003,-1.00564301027,1.67454326267,0.0980208364761,-0.130838727283,2.86464285101,-0.803382782482,0.124290618252,-1.36269280111,0.655520991275,1.41857400784,1.267254668,-0.829802717919,0.183273938871,-0.712018076258,-0.896301975077,0.240898149872,0.146295800556,-0.12483092693,0.632938609702,-0.119669714645,1.06539055498,-0.294056028119,-0.195918369693,0.481032722619,0.260994189907,0.0998292059098,-0.364844503482,0.20188559342,0.462394000178,0.367356700692,-0.288057067407,-0.140768062365,-0.135185871261],[-37359.5444864,-2049.16964864,-3042.08933842,-1689.87234354,-135.485954941,1581.36343918,141.254258781,-304.145395695,-335.774666781,273.751135228,-1607.1700064,374.437592254,471.853782252,-759.269875825,-317.103015879,485.937265788,-608.125728956,-42.3754402427,-437.856765184,156.311135915,-352.05331546,-15.7522520759,59.9836442584,308.886521821,27.8944225511,-169.164974893,79.82946206,-219.169444261,241.121745971,-14.4972189307,-47.6441146112,-4.51580620126,-383.29758634,171.649282788,-97.0908972905,-73.3003270963,-12.0016651262,111.160123927,-63.2695033137,58.5595083659,13.3207533744,23.4485974345,-42.1357224304,-134.581563667,54.2921987062,59.3765257867,4.51553030465,-60.7605341552,-7.37796277814,12.766255722,26.8267956326,-3.56674608194,13.5603421441,0.658679619695,16.4272633403,1.71364006134,-25.4307529788,24.847378425,18.2913640587,20.961768157,-19.9570577588,-8.22691263381,7.65193278821,-0.0131203522545,2.85833739095,-6.28951629622,1.50372440714,2.71208386055,4.31370570553,5.55532636406,-0.212070158619,1.18637946318,3.5338922629,3.37204879191,8.86489127585,-2.48067059981,-0.167343653858,-0.149759647522,1.90524235131,3.68992340651,0.0765108912098,-1.13878493273,-2.48767200393,0.361136023108,0.937918726893,-0.313269013641,2.22092289801,-1.05439648135,1.69673792357,0.116895992003,-0.138196882905,2.90193298993,-0.789915458149,0.247883700552,-1.34477873776,0.594341543126,1.4029609414,1.2521654472,-0.841033969887,0.177767123474,-0.73841760103,-0.886543011232,0.236279529,0.148213504371,-0.107012986204,0.654641321618,-0.127196852962,1.07252102065,-0.290231973875,-0.201164201305,0.492675345655,0.249022359336,0.137302012586,-0.368409480052,0.183820254555,0.458471910646,0.360689171745,-0.29004623429,-0.137180491128,-0.123409999482],[-37307.9756936,-2064.36760209,-3118.49458569,-1686.4915888,-173.394792733,1599.07291206,137.424686948,-351.624400296,-338.452763814,277.167979961,-1592.9713329,366.132475557,474.657599697,-747.656567612,-290.534773388,478.469607216,-614.459456554,-25.7097015038,-435.904236127,129.010032764,-356.272342713,-22.4468648828,51.9862748597,295.686278309,33.0895779433,-166.408029257,78.4289938551,-212.376779968,243.12624318,-22.3947590506,-52.1140448244,-7.27661828144,-389.586157102,160.092233379,-100.806725459,-75.3851011624,-10.9678647118,107.972880511,-62.9482092726,58.6381078438,13.2864054232,20.6497945451,-43.4279983671,-136.091232287,50.8234415938,58.7858693994,5.01785972405,-60.1285530737,-8.06266925633,12.8756395598,26.68906392,-3.47736216285,13.9006888982,0.354654655607,16.3979262866,0.855796605184,-25.8677687299,24.0094653573,18.3826500349,21.2662001292,-19.9089809477,-7.66978409458,7.99256092087,-0.131259155333,2.8627894815,-6.45803807707,1.64059282685,2.95090941933,4.3727114262,5.63370933916,-0.456703768659,1.28129007867,3.32434036218,3.30995831681,9.04424368289,-2.54812767091,0.202122849332,-0.0690135760412,1.86439666951,3.55224120529,0.013076109773,-1.17671230877,-2.50133953041,0.345333620381,0.971679587779,-0.233097322069,2.25373020468,-1.10289519635,1.71411989138,0.140898129651,-0.140232585893,2.94104466345,-0.77622596123,0.375288396485,-1.32198788635,0.533630263291,1.37937025377,1.23341921388,-0.851640124003,0.173402839631,-0.761661625477,-0.874926666431,0.231871758208,0.14916928221,-0.0912153282791,0.675513446918,-0.135346297603,1.07849620667,-0.286124055147,-0.204998713047,0.506433564757,0.237416526481,0.175166527994,-0.370831473256,0.165810346291,0.45380776127,0.35246317085,-0.291828662056,-0.132602440812,-0.110941066997],[-37261.1036715,-2076.05002598,-3195.714404,-1680.51623268,-213.658937965,1619.78695555,131.954378359,-401.089598839,-345.109686477,281.849837962,-1579.28445668,358.809373214,478.645747301,-734.524005338,-261.752101025,469.270196903,-619.291009479,-8.74721942011,-432.523386976,102.685509328,-359.223836354,-30.8109707627,43.9635000075,281.924252226,38.3055189537,-163.262639845,77.0562817515,-205.068245537,245.28501254,-30.2633844495,-57.0416609054,-9.70505608499,-395.238189267,148.359831078,-104.278100065,-77.2562806895,-10.1555300623,104.685088224,-62.6680166949,58.7881489351,13.1168773309,17.8155797933,-44.3561273298,-137.38141304,47.471789766,58.0584650029,5.42242270992,-59.4508577138,-8.70602865338,12.8664847126,26.4976965449,-3.44260621547,14.2741001395,0.0170435700617,16.3805875438,0.0858180783519,-26.2653831191,23.2313871933,18.4363034114,21.5227154382,-19.8042891932,-7.07850354308,8.32826754716,-0.247464613014,2.84942931747,-6.62605342199,1.74831195649,3.19136075795,4.41592038839,5.71780741994,-0.692630499012,1.37325343293,3.14419279613,3.25627808847,9.21738769089,-2.60423771729,0.585850925688,0.0190184023336,1.81813780294,3.39489393467,-0.049244957884,-1.21137602522,-2.50889705037,0.322517924774,1.00196538601,-0.159174822341,2.28804958549,-1.15119731107,1.72636931059,0.170846792034,-0.136629469856,2.98241658839,-0.761768903013,0.505595097878,-1.29360655351,0.473679893693,1.34894474483,1.21130976562,-0.861377460241,0.170217463048,-0.78174061522,-0.861597777018,0.227679661704,0.149201352152,-0.0774422471089,0.695566051004,-0.144092571373,1.08318922912,-0.281597454223,-0.207418147887,0.522464503384,0.226332093797,0.21330620049,-0.371848401167,0.147885102684,0.448683411758,0.342842534866,-0.29336923136,-0.127071893582,-0.0978279318202],[-37219.4770754,-2083.96439729,-3274.25815721,-1671.72603456,-255.8615753,1643.70145674,124.44809668,-452.237095248,-355.760596251,287.730600375,-1566.25039618,352.574406454,483.965367244,-720.1761396,-231.058940143,458.317851055,-622.639129915,8.45696349264,-427.785972237,77.5575868344,-360.891170967,-40.8304017537,35.9855888788,267.836341288,43.5118298051,-159.761079677,75.7698703363,-197.26561158,247.591720656,-38.0495348217,-62.430377752,-11.7520591675,-400.173715106,136.548451464,-107.415567625,-78.9025944802,-9.55707842124,101.314874873,-62.4279177429,59.0003841481,12.8102553034,14.9417374797,-44.907784283,-138.438160958,44.2738659259,57.2186429399,5.74359471861,-58.7410470535,-9.30997708403,12.7429512111,26.2507095688,-3.46722230149,14.6767930665,-0.354404299729,16.3718778883,-0.594678690839,-26.626138098,22.5216614735,18.4609408032,21.7328901845,-19.6446813211,-6.4602432747,8.6584853096,-0.362659018612,2.81854918037,-6.79222573046,1.82514233468,3.43339379645,4.44194945242,5.8074699311,-0.920490604787,1.46001376324,2.99620612877,3.21347155471,9.38631627576,-2.64798785642,0.980272556288,0.116087082838,1.76576673705,3.22032255682,-0.110362407972,-1.24285611967,-2.51054374818,0.292865035817,1.0288126833,-0.0917510862943,2.32404250901,-1.19930667712,1.73316292894,0.207431387509,-0.127191854415,3.02644494242,-0.746086918204,0.637804172209,-1.25907172359,0.414821014921,1.31280379077,1.18615987495,-0.870017910975,0.168244480528,-0.798662513756,-0.846722823651,0.223728966427,0.148348383402,-0.0656831916089,0.714794027601,-0.15339722143,1.08649033486,-0.276524977654,-0.208449436881,0.540890577936,0.215899006166,0.251577410764,-0.371252997307,0.130098024736,0.443379907009,0.332003706046,-0.29462951497,-0.120627338505,-0.0841467639475],[-37183.1475796,-2088.84525834,-3354.04893712,-1660.62417781,-299.337332315,1669.76899433,115.706608518,-505.217477736,-370.106141674,294.439832125,-1554.18696062,347.723190066,490.525827093,-704.703609601,-198.702835026,445.7003157,-624.700364767,25.8088408537,-421.733801722,53.6731952425,-361.306686453,-52.4871224059,27.9177919836,253.75010911,48.6797581391,-155.961139248,74.6012744118,-189.016768634,250.001461852,-45.7122821848,-68.2735092643,-13.4350588761,-404.302231812,124.802187016,-110.15453088,-80.3219430979,-9.16535741445,97.8858654083,-62.2345977534,59.2670056599,12.3673213755,12.0195949701,-45.0935563275,-139.256337688,41.2734650582,56.2928449667,5.9830387028,-58.023266487,-9.87835515056,12.5114420201,25.9513748532,-3.55401680416,15.1023649535,-0.758257668719,16.3648873264,-1.18574288571,-26.953777796,21.8906236565,18.4646199483,21.8965024831,-19.4386861018,-5.82515611893,8.98339202698,-0.477386429839,2.77130606135,-6.95515459076,1.8709836778,3.67594501972,4.45058811703,5.90139346365,-1.13959556468,1.53898000042,2.88190238838,3.18279927221,9.55165110895,-2.67983167431,1.38040341041,0.223303322721,1.7077657786,3.03081728634,-0.170000610123,-1.27128600645,-2.50660241436,0.257006666894,1.05230723461,-0.0307931288365,2.3613520162,-1.24700992935,1.73416390729,0.2508207874,-0.112206803243,3.07335574658,-0.729074735192,0.770555889582,-1.21842309184,0.357535562243,1.27197307297,1.15840821412,-0.877396018167,0.16750582325,-0.81250517611,-0.830554864246,0.220129010222,0.14665084965,-0.0558682305316,0.733127583716,-0.163169892352,1.08835829394,-0.270809929042,-0.208242263466,0.561695376606,0.206145378161,0.289728268818,-0.369057257,0.112599681233,0.438175032699,0.320173548222,-0.2955578541,-0.113309292249,-0.0700829812932],[-37152.0426135,-2091.67391777,-3434.86326754,-1647.89470182,-343.358697313,1696.6313199,106.829681215,-560.294955586,-387.76834305,301.531016582,-1543.4561569,344.598712229,498.177050759,-688.143726696,-164.917230692,431.532569328,-625.715712119,43.204665316,-414.401199068,31.0359916921,-360.514964043,-65.7621303974,19.5741051647,240.016035778,53.7809674522,-151.926988425,73.5752513338,-180.37613722,252.45968738,-53.2138566372,-74.5618440924,-14.7881095056,-407.530602805,113.277059437,-112.436606627,-81.5145200465,-8.97332226337,94.4230590672,-62.0966653565,59.5805655644,11.789531539,9.03936539606,-44.929758598,-139.833006528,38.5161752175,55.3080406929,6.13923948925,-57.324298013,-10.4154795772,12.178920838,25.6042782098,-3.70531168711,15.5437580932,-1.1926647649,16.3518206719,-1.68784019251,-27.252346887,21.3490636805,18.4552588656,22.0128809521,-19.1965397918,-5.1841400388,9.30335181218,-0.592096345506,2.70907312895,-7.11342363835,1.88614549671,3.91769605385,4.4419190406,5.99798642519,-1.34892466329,1.60747724864,2.80249496932,3.16522107484,9.71367103577,-2.70058937415,1.78090507938,0.341617994735,1.64491256463,2.82863065094,-0.227837502323,-1.29681244407,-2.49742674094,0.215688434852,1.07254709323,0.0238026743593,2.39949154113,-1.2940393984,1.72903200977,0.301053728777,-0.092082066023,3.12333248277,-0.710715105786,0.902400495753,-1.17185103122,0.302343309594,1.2274548491,1.1285224303,-0.88336197618,0.168020533491,-0.823363935187,-0.813368601032,0.217010033659,0.144149675711,-0.0479125875888,0.750480754676,-0.173307253072,1.0887690072,-0.264363236251,-0.206976999167,0.58482778053,0.197073866778,0.327479816989,-0.365327991022,0.0955649079039,0.433345759697,0.307591530622,-0.296099282076,-0.105158778381,-0.0558493137518],[-37126.0896063,-2093.43168423,-3516.47767225,-1634.22164593,-387.198158598,1722.93018503,98.9170821121,-617.733738084,-408.369220682,308.557637115,-1534.41999194,343.543961121,506.768962154,-670.533802236,-129.935572157,415.929590423,-625.926170056,60.5406895327,-405.822487912,9.64963332329,-358.560584966,-80.6364234061,10.7685242652,226.984601383,58.7871212407,-147.72279707,72.7165584582,-171.398137857,254.911848491,-60.5164882773,-81.2861708868,-15.845265351,-409.765691506,102.129090431,-114.203411662,-82.4805188294,-8.97392818939,90.9514550861,-62.0227291827,59.9336159559,11.0783417859,5.99126188948,-44.4327062292,-140.165230774,36.0475844588,54.2911997282,6.21068190469,-56.6709236299,-10.9256670882,11.752351363,25.2140054502,-3.92342891399,15.9939147785,-1.65577381627,16.3248827385,-2.10143629747,-27.525890045,20.9077714837,18.440775574,22.0813542099,-18.9284786475,-4.54809299734,9.6187287781,-0.707238264421,2.63322355174,-7.26561650872,1.87093730224,4.15732852493,4.41602488149,6.09565722332,-1.54745718519,1.66283061207,2.75919726594,3.16169679649,9.87265490157,-2.71108115909,2.17643915453,0.471981971634,1.5779847322,2.61601517833,-0.283551022559,-1.31958219103,-2.48337041996,0.169655956537,1.08963031241,0.0721399476197,2.43797451786,-1.34012741492,1.7174270005,0.358168948706,-0.0672253924408,3.17655863289,-0.690990781794,1.03188823648,-1.11954591469,0.249764030913,1.18025137682,1.09697017069,-0.887765979376,0.169807653524,-0.831334123892,-0.79543873624,0.214502277312,0.140885786401,-0.0417314864924,0.766767575811,-0.183705972521,1.08769837545,-0.257095827146,-0.204834015515,0.610236670845,0.188687129011,0.364553097611,-0.360132010145,0.0791685404798,0.429169058871,0.294497122474,-0.296198832223,-0.09621682047,-0.0416584912176],[-37105.2159871,-2095.09986634,-3598.66867505,-1620.28904952,-430.128204475,1747.30734132,93.0685785512,-677.798034513,-431.530794873,315.073177095,-1527.44047263,344.901924922,516.151485191,-651.911147576,-93.9913044396,399.006357475,-625.572736662,77.7131661565,-396.031991891,-10.4822227237,-355.488130451,-97.09099911,1.31504512796,215.006286011,63.669883001,-143.412735049,72.049953141,-162.137191066,257.303396439,-67.5824072038,-88.4372782978,-16.6405807072,-410.914361334,91.514301702,-115.396562781,-83.2201329506,-9.16013041392,87.4960527012,-62.021397862,60.3187089285,10.2352081081,2.86549758209,-43.618714356,-140.250073725,33.9132808368,53.2692916821,6.19585077588,-56.0899253364,-11.4132344076,11.2386972934,24.7851423858,-4.21069044844,16.4457773023,-2.14573305081,16.2762783401,-2.42699688684,-27.7784519436,20.5775370043,18.4290880925,22.1012508748,-18.6447389252,-3.92791295759,9.92988703762,-0.823261685396,2.54513049825,-7.41031683735,1.82566860521,4.39352405904,4.37298829807,6.19281426564,-1.73417241499,1.70236519489,2.75322267259,3.17318627104,10.0288815517,-2.71212723233,2.56166722718,0.61534612617,1.50775991834,2.3952233962,-0.336819108818,-1.33974200585,-2.46478714343,0.119654848797,1.10365494546,0.114322315271,2.47631438046,-1.38500630956,1.69900864364,0.422205184256,-0.0380445321803,3.23321767884,-0.669884515026,1.15756935752,-1.06169811525,0.200317500134,1.13136491382,1.06421908248,-0.890458222118,0.172886225624,-0.836511075128,-0.777039972099,0.212735981753,0.136900106533,-0.0372401509544,0.781902082447,-0.194262719632,1.08512229954,-0.248918629591,-0.201993684035,0.63787092869,0.180987821858,0.400669153017,-0.353536125145,0.0635854146913,0.425921901089,0.281129793007,-0.295801537866,-0.0865244420839,-0.0277232435853],[-37089.3970209,-2097.31647647,-3681.28434531,-1606.51495309,-471.455257207,1768.82803949,89.9919111971,-740.585177074,-456.838114802,320.679090371,-1522.71518373,348.928651956,526.138919066,-632.349543825,-57.3332759231,380.90787758,-624.870696524,94.6174766386,-385.07824511,-29.3632802657,-351.363130602,-115.076195652,-8.91499532272,204.381853028,68.3969641082,-139.05336342,71.5921462755,-152.650785993,259.582308416,-74.3757123587,-96.0051224834,-17.2110920221,-410.909378069,81.5742072712,-115.966861339,-83.737595398,-9.51918490431,84.08215065,-62.097575213,60.7259458127,9.26465133971,-0.346225827041,-42.5103861639,-140.087220698,32.1518881551,52.270176603,6.0960940175,-55.6063224271,-11.8819039326,10.6467119151,24.3228979612,-4.567336958,16.8922221147,-2.65968274394,16.1990856663,-2.66627506319,-28.0134035104,20.3670319721,18.4283040125,22.0733356591,-18.3559232256,-3.33409328585,10.2372659866,-0.94032029836,2.44615821896,-7.54618607291,1.75138803194,4.62502080294,4.31316071383,6.28802445412,-1.90802376065,1.72402997962,2.7853639193,3.20048822514,10.182953303,-2.70497804498,2.93132241471,0.772103279309,1.43525649442,2.16882664086,-0.387345243689,-1.35752029879,-2.44214243354,0.0665161844438,1.11478661983,0.150486660205,2.51404966054,-1.42830660071,1.67366523965,0.493137590214,-0.00502437519834,3.29348020353,-0.647467179534,1.27797060254,-0.998731063951,0.154543702622,1.08187990234,1.03073698917,-0.891372731306,0.177238011863,-0.839034616669,-0.758450382039,0.211810488981,0.132266283884,-0.0343386720758,0.795804286749,-0.204859951308,1.08105010301,-0.239754622456,-0.19865065171,0.667644134896,0.173974009482,0.435544599424,-0.345657166876,0.0489717580248,0.423872581962,0.267739243199,-0.294886016629,-0.0761596450678,-0.0142361686752],[-37078.7993158,-2099.34634179,-3764.45893471,-1592.25340172,-510.621474892,1788.25152686,88.8267140057,-805.524989631,-483.72834515,325.168712714,-1519.78402144,355.532431131,536.403064113,-612.068651112,-20.2719484555,361.899272278,-623.932480238,111.145517621,-373.066623535,-47.0266869475,-346.334911018,-134.419713032,-19.8208958376,195.213198911,72.9202674521,-134.670808012,71.3276629057,-143.008686288,261.706665381,-80.8679780596,-103.976329632,-17.6057643559,-409.787116923,72.3922904325,-115.901846916,-84.0532970973,-10.0155506117,80.736245673,-62.2413458059,61.1356248856,8.18345168423,-3.6462523697,-41.1554770421,-139.686845088,30.7741732116,51.3252762945,5.92421189601,-55.2380833814,-12.3330207511,9.99230686352,23.8349736521,-4.98528392568,17.3258622955,-3.19073136073,16.0898764106,-2.8261735945,-28.2314206862,20.2764552839,18.447289216,22.0041176507,-18.0740995253,-2.77550896157,10.5416061527,-1.05738455772,2.33763529207,-7.6721969169,1.65210067059,4.85078298607,4.23796861284,6.38048866824,-2.0678611236,1.72826946202,2.85473107872,3.24375695664,10.3367663594,-2.69260504001,3.2804239387,0.940414044869,1.36245576896,1.94067148299,-0.434935088171,-1.37347208711,-2.41634913295,0.0114128601462,1.1234612598,0.180902899567,2.55081927985,-1.46925155774,1.64219923445,0.570686992235,0.0310416274595,3.35746519395,-0.624162138341,1.39152470687,-0.93200042435,0.113063469456,1.03320952286,0.996992419586,-0.890778863999,0.182695653506,-0.839222555761,-0.739961524279,0.211701546713,0.127188858073,-0.0328666105143,0.808418108219,-0.215323276338,1.07562480024,-0.229574988631,-0.195056667328,0.699328669078,0.167625384726,0.468878348565,-0.336812046518,0.0354093649923,0.423254696066,0.254616101034,-0.293565223322,-0.0653483443746,-0.00130933601194],[-37073.6373157,-2100.11099317,-3848.39824051,-1576.59244161,-547.102949587,1806.76054986,88.320594256,-871.880418964,-511.601679475,328.383350377,-1518.02245977,364.534611503,546.58009595,-591.32459932,16.8668127491,342.275691718,-622.844804901,127.188314545,-360.116713599,-63.5129513712,-340.573746172,-154.918591715,-31.2446140862,187.55250341,77.1877438008,-130.283585846,71.2329816132,-133.283724226,263.637074236,-87.0326474677,-112.336693441,-17.8765449216,-407.609855467,64.0375267976,-115.198243651,-84.1916684587,-10.6079872332,77.4851340117,-62.4390893991,61.5255936605,7.0114541874,-7.03543751039,-39.6080304305,-139.061742308,29.7839385535,50.4669029988,5.6958677658,-55.0014139747,-12.7673356239,9.29318336172,23.329694067,-5.45436553841,17.7392450816,-3.73097941365,15.9460956422,-2.91488266508,-28.4325056655,20.303887628,18.4950991577,21.901542032,-17.8117021455,-2.26063036745,10.8437233467,-1.17312910901,2.22088137768,-7.78739988403,1.53255072479,5.06983135852,4.14910724429,6.46956628183,-2.21250852867,1.71615201623,2.96001355917,3.30298565615,10.4925403961,-2.67840990833,3.60406254677,1.11788098488,1.29157978479,1.71492330188,-0.479419847865,-1.38823403986,-2.38843191447,-0.0443967714617,1.13018236387,0.205874209069,2.58628725768,-1.50696263776,1.6056416103,0.654510633693,0.0692828844755,3.42527873809,-0.600480876711,1.49664090375,-0.863094918094,0.0765178431401,0.986849140437,0.963454078871,-0.889029809792,0.189054511617,-0.837437194516,-0.721868328237,0.212354004091,0.12190509168,-0.032648394317,0.819693443193,-0.225464091484,1.06902282832,-0.218362962011,-0.191477755131,0.732661610545,0.161917047603,0.500364886055,-0.327367695334,0.0229614218616,0.424293162717,0.242061226248,-0.291985697055,-0.0543534332344,0.010965316954],[-37074.1254643,-2098.53196148,-3933.30805994,-1558.62011898,-580.37577335,1825.53785495,87.2211592268,-938.91441185,-539.858311333,330.16430961,-1516.80597277,375.756542126,556.306190197,-570.373518333,53.7571424764,322.33228605,-621.694387612,142.63689285,-346.348101733,-78.8625821384,-334.249910536,-176.369872168,-43.0281077379,181.451946279,81.1473439229,-125.910213945,71.2845809795,-123.548732085,265.33414188,-92.843163744,-121.072007605,-18.0753809325,-404.439871272,56.5788919783,-113.852775685,-84.1771398921,-11.2552544658,74.3556119075,-62.6771857512,61.8736996508,5.76850389499,-10.5146367136,-37.9220897691,-138.224707772,29.1849867274,49.7273689585,5.42672498126,-54.9125199826,-13.185599312,8.56704263268,22.8153838146,-5.9644159831,18.1249177098,-4.2725274152,15.7651884305,-2.94059245925,-28.6166606426,20.4474096926,18.580789292,21.773553985,-17.581165407,-1.79792788622,11.1444333791,-1.28622859774,2.09721613593,-7.89084548899,1.39748239817,5.28118667041,4.04827185738,6.55461666875,-2.34079000066,1.68874601634,3.09990076898,3.37816751428,10.6524950885,-2.66579434087,3.89732898655,1.30210666137,1.22485058475,1.4957474768,-0.520630728373,-1.40244282607,-2.35941545092,-0.0996543577457,1.13545343052,0.225703764423,2.62011761333,-1.54056129787,1.56502334947,0.744265757963,0.108828804532,3.49702692396,-0.576934879911,1.59172842643,-0.793603266837,0.0455478661815,0.944294120129,0.93059067217,-0.886478758281,0.196109947256,-0.834040835048,-0.704465723333,0.213712710261,0.116652247285,-0.0335084515306,0.829580188009,-0.235093793505,1.06142062434,-0.206101776493,-0.18817993936,0.767380038606,0.156824098124,0.529698697508,-0.317691044583,0.0116911149007,0.427212901231,0.230375478576,-0.290293976935,-0.0434378048771,0.0224958527721],[-37080.4782055,-2093.53077761,-4019.39419027,-1537.42448004,-609.916038238,1845.76618857,84.2760161971,-1005.88991507,-567.898434282,330.352896665,-1515.51003447,389.019572054,565.217522472,-549.471538037,90.0731755123,302.364205423,-620.56794547,157.382277976,-331.880374372,-93.1160878511,-327.533678582,-198.570594855,-55.0133344624,176.96370727,84.7470185866,-121.569209332,71.4589395861,-113.876542141,266.758475214,-98.2729700499,-130.168065822,-18.2542196017,-400.339441909,50.0853615864,-111.862167155,-84.0341418078,-11.9161120067,71.3744756017,-62.9420146204,62.1577903699,4.47444585273,-14.0847054438,-36.1516984979,-137.188536893,28.9811202802,49.1389864157,5.13244689678,-54.9876071805,-13.588562576,7.83158589939,22.3003675033,-6.50526944667,18.4754274172,-4.80747587786,15.5445998449,-2.91149316133,-28.7838878119,20.7051021663,18.7134150738,21.6280986919,-17.3949236308,-1.39587190059,11.4445520607,-1.39535766946,1.96795922691,-7.98158424649,1.25163989436,5.48386967181,3.93715770131,6.63499920283,-2.45152956439,1.64711983647,3.27308211647,3.46929572166,10.818850112,-2.65816002855,4.15531400565,1.49069363638,1.16449021166,1.28730938703,-0.558398935296,-1.41673511475,-2.33032441509,-0.153101546072,1.13977795821,0.24069474134,2.65197436607,-1.56916899518,1.52137543421,0.83960960842,0.14880879631,3.57281583955,-0.554035633206,1.67519650814,-0.725114192231,0.0207945810856,0.907039826991,0.89887090463,-0.883478899064,0.203657321488,-0.82939577947,-0.688048638985,0.215722514366,0.111667587468,-0.0352712102022,0.838028239003,-0.244023779162,1.05299462541,-0.192774665971,-0.185429244256,0.803221032571,0.152321636301,0.55657426854,-0.308149025528,0.00166163037774,0.432238830927,0.219859717753,-0.288636602072,-0.0328643525325,0.0331903339919],[-37092.7383989,-2084.35765833,-4106.53092008,-1512.35910693,-635.235890814,1868.30515875,78.5703090885,-1072.05601246,-595.228186202,328.852699114,-1513.67577681,404.136967773,572.948527945,-528.802730603,125.532358581,282.651197207,-619.523208382,171.314289312,-316.841524695,-106.326696042,-320.541245962,-221.30607128,-67.0640915436,174.095808667,87.9364879069,-117.274884675,71.7324572821,-104.327353851,267.876227073,-103.283709877,-139.606522945,-18.4592187875,-395.386900052,44.602501199,-109.227853556,-83.7860560274,-12.5505695715,68.567526556,-63.2159078179,62.3579856515,3.151688903,-17.7460926631,-34.3456193601,-135.970072717,29.1688596586,48.7294294721,4.82907036141,-55.2409610783,-13.9761977981,7.1032208901,21.7923603472,-7.06567476736,18.7835333622,-5.32819827761,15.2820099934,-2.83479564428,-28.9339481704,21.0732466274,18.9010266132,21.4737038078,-17.2644847076,-1.06153450643,11.7437944266,-1.49920418298,1.83420728691,-8.05883173015,1.09956296589,5.67672218799,3.81739412963,6.71000631381,-2.54349250161,1.59287798319,3.4780106019,3.57621247626,10.9939162138,-2.65877624142,4.37380603346,1.68096879775,1.11245995885,1.09340152292,-0.592619933174,-1.43172627739,-2.30216920292,-0.203643348539,1.14359807535,0.2511945326,2.68158699253,-1.59192353847,1.47586262327,0.940227092331,0.188469422376,3.65272919633,-0.532266860985,1.74572971493,-0.659146590558,0.00278234856818,0.876469440519,0.868735260699,-0.880396294501,0.211471723792,-0.823847391382,-0.672888883652,0.218283878098,0.107185308174,-0.037743576999,0.845012179897,-0.252062693945,1.04393987778,-0.178336078429,-0.183439022693,0.839924461442,0.148369088374,0.580742801207,-0.299096983231,-0.00708864200826,0.439554331008,0.210785209683,-0.28715838745,-0.0228675328279,0.0429708668743],[-37110.2625678,-2071.57756402,-4193.26650325,-1483.83972562,-655.991695669,1892.72181981,70.5393283928,-1136.60633607,-621.777482267,325.816429808,-1511.5069634,420.889665485,579.126679992,-508.26293736,160.02538616,263.411397655,-618.501957508,184.317922036,-301.393172883,-118.598509964,-313.172493034,-244.314697105,-79.1315347247,172.679642874,90.6725493846,-113.024735236,72.0812189859,-94.9108354034,268.675734022,-107.789828037,-149.35247846,-18.713378929,-389.72479879,40.0822362543,-105.970115806,-83.4520700199,-13.1236369501,65.9565871113,-63.4650053648,62.4634946102,1.83289707455,-21.4976213234,-32.5314923108,-134.60234882,29.7155969086,48.5078196663,4.5341262028,-55.6791861226,-14.3453638462,6.39318135405,21.2966399818,-7.63003938876,19.042842389,-5.82815994439,14.976039139,-2.71379353569,-29.0656379251,21.5409282157,19.1476526436,21.3212268799,-17.197650807,-0.796394652296,12.0374724096,-1.59650885028,1.69616485675,-8.12246374927,0.944973560887,5.85787034474,3.69034691336,6.77866265497,-2.61520912181,1.52976949291,3.71219359335,3.69815600559,11.1803684286,-2.67038256604,4.55138422639,1.8691563366,1.06967812157,0.916324819062,-0.623446222302,-1.44794649521,-2.27590310282,-0.250838236173,1.14711042997,0.257727399265,2.70894679858,-1.60802814325,1.43018478135,1.04591377255,0.227525860826,3.73676119962,-0.512001244135,1.80311394401,-0.596940056627,-0.00843119781581,0.853517397976,0.840511342037,-0.877648498006,0.219247157318,-0.817673280321,-0.659165781962,0.221119713346,0.103427338805,-0.0406623730699,0.850605343945,-0.259008178254,1.03452586448,-0.162625318203,-0.182211942068,0.877241352993,0.144863185498,0.602182363341,-0.290843917964,-0.0146204988334,0.449176620234,0.203304844942,-0.285997251569,-0.0135680559799,0.0518157325271],[-37132.235651,-2056.08414094,-4277.81768501,-1452.547598,-671.875871898,1918.26008768,60.955901245,-1198.72065501,-647.582181973,321.459082917,-1509.37301577,439.050518823,583.377711541,-487.675941923,193.486264666,244.847540242,-617.416986813,196.276965274,-285.705345863,-130.048351803,-305.273221337,-267.323139032,-91.1886593633,172.502444827,92.9137698673,-108.812051924,72.4812308835,-85.6240221677,269.150878562,-111.693969673,-159.366893009,-19.0339111105,-383.511746317,36.4530821561,-102.113946176,-83.0503226658,-13.6015739508,63.5624848289,-63.6513993352,62.4657986806,0.553298192766,-25.3377078744,-30.7316766085,-133.122446411,30.581441976,48.4786403963,4.26551874326,-56.3069664942,-14.6921412093,5.71140754571,20.8178746482,-8.18168540578,19.2471732636,-6.30109917167,14.6255425836,-2.55080115178,-29.1775120857,22.0954329611,19.4563165541,21.1821079286,-17.2012976686,-0.600532999869,12.319797167,-1.68602559664,1.55381345345,-8.17252117207,0.791389176379,6.02526134299,3.55731592789,6.83992593548,-2.6651509914,1.4620795345,3.97290205082,3.83421354449,11.380972863,-2.69558616813,4.68732542261,2.05120476989,1.03680224561,0.758007321129,-0.65109456191,-1.46590465189,-2.25246512631,-0.294408044733,1.15045030001,0.260861819467,2.73411054742,-1.61670237668,1.38617554966,1.15649287582,0.265810443639,3.82488367822,-0.493583702664,1.84741042543,-0.539664359873,-0.0129051063015,0.839005951068,0.814498529605,-0.875665935759,0.226657353631,-0.811134117311,-0.64703553758,0.223908544545,0.100612542126,-0.0437468981842,0.854905751786,-0.264655121219,1.02504067771,-0.145452903718,-0.18169799841,0.914925524689,0.141684985052,0.620927739214,-0.283687243802,-0.0210195332428,0.461081377252,0.197541920274,-0.285289388801,-0.00505819560234,0.0597172557692],[-37157.8425877,-2038.77103538,-4358.40121059,-1419.16398594,-682.580838597,1944.16387827,50.5928547795,-1257.57873837,-672.678144817,315.995652613,-1507.64335543,458.39238142,585.327355518,-466.86552791,225.849000513,227.162358442,-616.181090268,207.075208152,-269.948070562,-140.793043744,-296.689232406,-290.058063761,-103.208460817,173.351449463,94.6187162022,-104.630125646,72.9084991608,-76.4639495138,269.295543194,-114.898779928,-169.610727235,-19.4380264164,-376.906350827,33.6435543081,-97.6843369415,-82.5989528456,-13.9506403822,61.4060472699,-63.7371818029,62.3563792976,-0.651879916974,-29.2647687655,-28.9685315117,-131.567446697,31.7265048068,48.6463750602,4.04115230511,-57.1289863742,-15.0126103764,5.06783971956,20.3607325873,-8.70393491334,19.3903447515,-6.74075425287,14.2293756289,-2.34813280879,-29.2681256618,22.7240468932,19.8300417336,21.067786974,-17.2823010318,-0.474030210853,12.5849798561,-1.76650834735,1.407134594,-8.20904486678,0.642327309394,6.1768423837,3.4196010486,6.89275386451,-2.69178967681,1.39409327681,4.25740693432,3.98347232783,11.5984956236,-2.73699421338,4.78090646027,2.22306261456,1.0144898767,0.620377074785,-0.675781711231,-1.48610963108,-2.23279428491,-0.33407460998,1.15375296342,0.261166271338,2.75713500224,-1.61716580593,1.34566856938,1.2717876289,0.303155502795,3.91706846091,-0.477359156581,1.87868038919,-0.488489269735,-0.0106984251242,0.8337573515,0.790996204367,-0.87487903394,0.2333760443,-0.804490573376,-0.636654354176,0.226328896131,0.0989597809028,-0.0467164521111,0.858011424058,-0.26879841197,1.01577240966,-0.126629353398,-0.181847187747,0.952730793998,0.138715544418,0.637013713098,-0.277924374819,-0.0263713383812,0.475244280709,0.193619732424,-0.285170993523,0.00256977469083,0.0666677614198],[-37186.2683167,-2020.53189359,-4433.23382521,-1384.37015137,-687.799014863,1969.67710748,40.2230161312,-1312.36035528,-697.101230296,309.641133066,-1506.68740391,478.68810691,584.601344852,-445.655478937,257.047600119,210.558585727,-614.70706184,216.596439795,-254.291373908,-150.94940797,-287.26632778,-312.246137993,-115.163934443,175.013891716,95.7459552369,-100.472247312,73.3390300039,-67.4276528111,269.103610417,-117.306903945,-180.044941781,-19.9429359308,-370.067220512,31.5821681138,-92.7062803734,-82.11609944,-14.1370960527,59.5081019955,-63.6844448418,62.1267178959,-1.7474094293,-33.2772204464,-27.2644162787,-129.974430886,33.1108953466,49.0155070557,3.87893121064,-58.1499299433,-15.3028518366,4.47241813008,19.9298820402,-9.18011000636,19.4661756187,-7.14086348145,13.7863935768,-2.10810282295,-29.3360336632,23.4140560421,20.2718515713,20.9897040366,-17.4475366361,-0.416966946945,12.827231634,-1.83671102767,1.25610979538,-8.23207570161,0.501305456961,6.31056066779,3.27850215087,6.93610415125,-2.69359674446,1.33009588872,4.56297920385,4.14501959047,11.835702817,-2.79721386751,4.83140417756,2.38067838756,1.00339856062,0.505362125696,-0.697724429497,-1.50907031648,-2.21782959017,-0.369559767671,1.15715369814,0.259209233008,2.77807692623,-1.60863799819,1.31049748169,1.39162125853,0.339393370273,4.01328737649,-0.463672525895,1.89698506533,-0.444584555649,-0.00187020251901,0.838593850976,0.770303747284,-0.875718218727,0.239076960889,-0.798003319539,-0.628178435417,0.228059292541,0.0986879179022,-0.04929033462,0.860020381398,-0.271232939636,1.00700915255,-0.105965185667,-0.182609506107,0.990410978384,0.135835920978,0.650475069268,-0.27385272509,-0.0307615073938,0.491641009251,0.191661578136,-0.285778260107,0.00922358128573,0.072659574298],[-37216.85516,-2002.2272266,-4500.71702869,-1348.87915806,-687.069444452,1994.18701529,30.5763462959,-1362.414363,-720.857489572,302.607879722,-1506.73051868,499.646240837,580.848212067,-423.988237315,287.031540275,195.233887554,-612.930056133,224.788064245,-238.913262993,-160.626113771,-276.915346667,-333.636014455,-127.023810961,177.27304796,96.2581529669,-96.3337209792,73.7447916511,-58.5147131482,268.575783322,-118.842166847,-190.618094839,-20.553208792,-363.146776007,30.19862213,-87.2228476702,-81.6185336291,-14.1323457547,57.8847997009,-63.4590989893,61.773967976,-2.70416449052,-37.3674814873,-25.6361177856,-128.380656435,34.6939330853,49.5816887698,3.79164839496,-59.3732297891,-15.5589306579,3.93434359901,19.5283700331,-9.59421965129,19.4704259571,-7.49620278082,13.296322953,-1.83263793257,-29.379975276,24.1529375752,20.7814588546,20.9576659336,-17.7032335474,-0.42753407988,13.0412945674,-1.89562904787,1.10114663953,-8.24201951027,0.371463257006,6.42451142529,3.13548782548,6.96901045028,-2.66957596943,1.27424683057,4.88680250458,4.31766310854,12.0944321128,-2.87871164847,4.8391502043,2.52057958076,1.00386179776,0.414265933867,-0.717150639025,-1.53514036184,-2.20833351068,-0.400674971186,1.16076497239,0.255518101912,2.79703994651,-1.59062807212,1.28237566805,1.51570565678,0.374432190322,4.113361537,-0.452974305457,1.90268416631,-0.408866067993,0.0134313230368,0.853998997726,0.752664486649,-0.878537204038,0.243457221073,-0.791912843286,-0.6217142382,0.22880824379,0.0999757483192,-0.0512107780665,0.861042243509,-0.271793611364,0.999043772484,-0.0833030745341,-0.183893858588,1.02771346392,0.132924768043,0.661392364979,-0.27170515787,-0.034253559652,0.510193869203,0.191747073423,-0.287215778647,0.0148442496905,0.0776981462276],[-37249.5749705,-1984.58500445,-4559.99133925,-1313.53127746,-679.317669765,2017.65413795,22.2113417144,-1407.76597147,-743.833740478,295.09769313,-1507.42180101,520.718096399,573.807688083,-402.280880131,315.812179284,181.365657301,-610.874670291,231.851945199,-224.023665568,-169.899218846,-265.807278968,-354.06428998,-138.739762536,179.896360314,96.1343719797,-92.2179033056,74.0816005509,-49.734894488,267.740047351,-119.513113681,-201.229134801,-21.2228463531,-356.272687713,29.4273475249,-81.34942573,-81.1175557918,-13.9283742172,56.5335836179,-63.042328637,61.3179713013,-3.51742713379,-41.5039789415,-24.0781333794,-126.824085792,36.4317756886,50.3052485453,3.77165124434,-60.7973121248,-15.7768502229,3.45985921706,19.1527587335,-9.93302030076,19.4066211635,-7.80569859428,12.7623751798,-1.5221145643,-29.3994263934,24.9289332105,21.3453339641,20.9749466709,-18.0530341386,-0.496363321551,13.2240343591,-1.94322375818,0.944356968114,-8.24074198842,0.254428911055,6.51738200245,2.99270152475,6.99081019798,-2.62085996134,1.23020272864,5.2257112224,4.4990928232,12.3728074324,-2.98339148327,4.80869533702,2.64160958578,1.01491690703,0.345893616674,-0.734332914469,-1.56405250132,-2.20436234343,-0.427590144385,1.16460801546,0.250455952698,2.81431514576,-1.56380335238,1.26253547085,1.64330737705,0.408483356272,4.2165091875,-0.446137289476,1.89733133436,-0.381233980899,0.0347011520979,0.879101526075,0.738097540063,-0.883382854742,0.246307486945,-0.786378897954,-0.617169232341,0.228404202215,0.102841797067,-0.0523117451531,0.861233026338,-0.270475406371,0.992188231331,-0.0586143163465,-0.185444786557,1.0643599111,0.129851122652,0.670029249418,-0.271456333148,-0.0368227194331,0.530611677597,0.193781111376,-0.289461722099,0.0195060019013,0.0818414370508],[-37284.5569841,-1968.30006192,-4610.38202974,-1279.19858292,-663.315857864,2040.18233577,15.6436326886,-1448.60947878,-765.886992513,287.309735111,-1508.26628811,541.290678707,563.24230342,-381.069143164,343.416345824,169.126220327,-608.587862094,238.05356127,-209.840489545,-178.836627998,-254.178152254,-373.389547427,-150.259196692,182.647312334,95.3577740111,-88.1301640989,74.3012352041,-41.1005065123,266.631208539,-119.349469478,-211.764607609,-21.8932080211,-349.566438471,29.2039586198,-75.2194803763,-80.6230986063,-13.5223111532,55.4472201123,-62.4191366397,60.7842417009,-4.18858136393,-45.6491419829,-22.5793880245,-125.342857653,38.2797903661,51.1376837139,3.80617575783,-62.4193515703,-15.952598493,3.0544686422,18.7979890941,-10.1839552789,19.2802279609,-8.06931499507,12.1886329036,-1.17652156685,-29.3940470851,25.7304758035,21.946636679,21.0431870514,-18.4999341089,-0.612196593886,13.3728476213,-1.97969799381,0.788278687718,-8.23047379718,0.151452761529,6.58800777464,2.8524554164,7.00091677614,-2.54911353847,1.20149450067,5.57645242832,4.6867192169,12.6680242606,-3.11301665116,4.74564516394,2.74319076917,1.03527716198,0.298425705829,-0.749554993568,-1.59538423917,-2.20579584249,-0.450564828748,1.1686812469,0.244344779316,2.83024047062,-1.52912071516,1.25208897274,1.77358163806,0.441834073719,4.32179785633,-0.444139847002,1.88277869418,-0.361334549437,0.0613450949765,0.912691466872,0.726565972458,-0.890225323448,0.247441806707,-0.781541053341,-0.614401140887,0.226705605732,0.10726452149,-0.0524501311684,0.860760344896,-0.26731332189,0.986759264868,-0.0319023630364,-0.186965740449,1.10006554901,0.12648161777,0.676695144755,-0.273016360096,-0.0384221372406,0.552549879141,0.197624904353,-0.292462659138,0.0233163590365,0.0851605336141],[-37321.9304367,-1954.06723379,-4651.21437298,-1246.75314779,-637.83617581,2061.87546906,11.3888495206,-1485.13918303,-786.874255175,279.443167488,-1508.7690172,560.750992871,548.914588593,-360.888762196,369.870868572,158.687901992,-606.116589321,243.658391071,-196.581642839,-187.506246031,-242.263994098,-391.470369654,-161.529520957,185.289387576,93.9115207968,-84.0758731664,74.3554741117,-32.6238589026,265.284072917,-118.380959266,-222.111059202,-22.5056532031,-343.149511124,29.4640697361,-68.9664774325,-80.1450947512,-12.9112862757,54.6184755501,-61.5745258525,60.1982930037,-4.71901118577,-49.7653997856,-21.1288066856,-123.975110715,40.1933443274,52.0304916074,3.88245793451,-64.2365227453,-16.0821634299,2.72367553239,18.4590020676,-10.3344679099,19.0967130725,-8.28701605646,11.5791787706,-0.79584778897,-29.3634974207,26.54599821,22.5685267784,21.1640278782,-19.0469291575,-0.763775818816,13.4851309661,-2.00525458996,0.635449704939,-8.2134455977,0.0637851508514,6.6352241172,2.71706166815,6.99874356656,-2.45600151911,1.19165306441,5.93577319337,4.87795277207,12.9772780819,-3.26935043141,4.65560527325,2.82474549748,1.06365583616,0.270042733046,-0.763100614061,-1.62871307965,-2.21251376193,-0.469858565752,1.17298308626,0.237506575716,2.84515386768,-1.4875370366,1.25214825637,1.90568365855,0.474771548264,4.42829507182,-0.447960347086,1.86087837044,-0.348814028679,0.0927689619853,0.953558850967,0.718032848765,-0.899034762763,0.24667422856,-0.777538879247,-0.613267686885,0.223570892256,0.11322237893,-0.0514828314012,0.859791814193,-0.262342355156,0.983073608876,-0.00317066653549,-0.1881601707,1.13454560676,0.122682886366,0.681699473159,-0.276295347885,-0.0390049635784,0.575663918545,0.203139664714,-0.296165158438,0.0263828422144,0.0877265227646],[-37361.8245639,-1942.58135484,-4681.81364179,-1217.06704542,-601.650790665,2082.83739813,9.96262251223,-1517.54938233,-806.652537964,271.697152083,-1508.43502549,578.486044,530.587074122,-342.275473007,395.202576209,150.223027657,-603.507809751,248.931913214,-184.465033365,-195.975977747,-230.30083207,-408.165339519,-172.498142856,187.586069596,91.7787740725,-80.0604003156,74.1960957745,-24.3172613407,263.733446518,-116.637308074,-232.155035523,-23.0015413061,-337.143388513,30.143295195,-62.7238827219,-79.6934769049,-12.0924292976,54.0401162972,-60.4934991305,59.5856390389,-5.11010060415,-53.8151815235,-19.7153143272,-122.758983673,42.1278047821,52.9351695574,3.98773377342,-66.2460002697,-16.1615329949,2.4729835456,18.1307386068,-10.3720015179,18.8615432212,-8.4587658517,10.9380954271,-0.380082079368,-29.3074374701,27.3639332854,23.1941640412,21.3391099541,-19.6970149839,-0.939842918269,13.5582810057,-2.02009638184,0.488407926374,-8.19188805112,-0.00732357855539,6.65786640546,2.58883244772,6.98370395103,-2.34318872154,1.20420933763,6.3004205886,5.07020397117,13.2977643808,-3.45415610327,4.54418125317,2.88569613726,1.0987662031,0.25892523004,-0.775253513687,-1.66361652701,-2.22439585582,-0.485730896879,1.17751195311,0.230263335848,2.85939328358,-1.44000919289,1.26382540439,2.03876865722,0.507582985503,4.53506836228,-0.458577158778,1.83348248781,-0.343318673696,0.128378563437,1.00049370921,0.712461233915,-0.909781325294,0.243818800704,-0.77451194547,-0.613626593381,0.218858499705,0.12069382673,-0.0492667411404,0.858495049241,-0.255597503403,0.981447999135,0.0275773212242,-0.188731527745,1.16751531343,0.118321561407,0.685351656802,-0.281203405685,-0.03852434895,0.599609240518,0.210186604816,-0.300515788675,0.0288129725531,0.0896104913488],[-37404.3296383,-1934.12934825,-4701.69149961,-1190.79588407,-553.866400379,2103.24795614,11.7066091125,-1545.96897178,-825.011354173,264.128588124,-1506.91014992,594.025719393,508.029256236,-325.585158851,419.488420172,143.892793972,-600.848513064,254.071058501,-173.649757035,-204.308092019,-218.477273518,-423.320148714,-183.116905513,189.312509601,88.9477057107,-76.0895593607,73.75604208,-16.1986426302,262.018854499,-114.149271237,-241.77648462,-23.3321965681,-331.652938619,31.1893384797,-56.6211754874,-79.2781701934,-11.0651893342,53.7013715679,-59.1706341939,58.9730442458,-5.36212665828,-57.7592028028,-18.3265007193,-121.729965013,44.0464970669,53.8024917239,4.10264006547,-68.4449723775,-16.1876411182,2.30724420291,17.8094942044,-10.2865175178,18.5816329037,-8.58344248231,10.2700545329,0.0716438858662,-29.2265024472,28.1739294737,23.8064065084,21.5659583592,-20.452433587,-1.12829198446,13.59178036,-2.02456008607,0.349707349922,-8.16713539052,-0.0607641296899,6.65507536408,2.47044205707,6.95537594149,-2.21205132244,1.2418269896,6.667341547,5.26077419026,13.6257217562,-3.66864307228,4.41737146294,2.92625711854,1.13945158832,0.262843719278,-0.786240377689,-1.6997063945,-2.24110579917,-0.498334270609,1.18213543507,0.222949164114,2.87324020357,-1.3874145333,1.28788136951,2.17191811933,0.54054726933,4.64104996649,-0.476702746467,1.80245239563,-0.344301873828,0.167648000924,1.05214209436,0.709631000974,-0.922384621073,0.238734822066,-0.772601755251,-0.615352723564,0.212478379877,0.129595703131,-0.0457237178561,0.857008402458,-0.247138415085,0.982148280124,0.0602503870624,-0.18838698171,1.19870888503,0.113341682078,0.687934783546,-0.287617122003,-0.0369169876404,0.624018430915,0.218546059697,-0.305468040003,0.0307391577987,0.0908771400075],[-37449.3800783,-1927.3664908,-4711.10517229,-1167.72941177,-494.927826449,2123.59086764,16.2665753586,-1570.26523447,-841.470232278,256.225324457,-1504.4034263,607.471435097,481.038494016,-310.454292879,443.005842939,139.813882759,-598.385816539,258.998566489,-164.059661765,-212.54231399,-206.79224488,-436.728924258,-193.355394448,190.290529403,85.426528131,-72.1709401415,72.8929084624,-8.30840806338,260.198698505,-110.951725318,-250.828962973,-23.4888025515,-326.716569973,32.5982597216,-50.7718886497,-78.9090695332,-9.83829311006,53.5773219714,-57.638808225,58.3922755047,-5.4709385249,-61.5513249594,-16.9446148531,-120.91294238,45.9445790264,54.5803395793,4.18141676889,-70.8306817601,-16.161205605,2.22870047783,17.4969825131,-10.078049687,18.2696877112,-8.6555801629,9.58208380091,0.563627121205,-29.1252281441,28.970497571,24.3869052675,21.8256352813,-21.3124121647,-1.31362579072,13.5934556804,-2.01951794487,0.221966338714,-8.13693613686,-0.0959913872366,6.6272131149,2.36601333514,6.91399607044,-2.06281093211,1.30370069574,7.03428244946,5.44652837998,13.9535612635,-3.91180524908,4.28274534612,2.94981112526,1.18507552509,0.277928686233,-0.796059681323,-1.73673173137,-2.26144295079,-0.507392763436,1.18619779209,0.215946606723,2.88675026759,-1.33031229963,1.32367258468,2.30391859619,0.573909996821,4.74463096498,-0.501985955901,1.76968634177,-0.350445555491,0.210324541161,1.10657414685,0.708589255542,-0.93656208983,0.231462594475,-0.771957545605,-0.618389501203,0.204546540112,0.139598369958,-0.0410354677434,0.855353175902,-0.23712334354,0.985236731105,0.0944062728057,-0.186848581484,1.22793648519,0.107996912427,0.689626604031,-0.295279002684,-0.0340537490584,0.648432640183,0.227674855098,-0.311003088502,0.032393352208,0.0915656245576],[-37496.8713388,-1920.54014767,-4710.49827627,-1147.44091145,-425.614421262,2144.42583003,23.1143144345,-1590.24005054,-855.481204548,247.332947333,-1501.26469013,619.067489347,449.419112253,-296.339495712,466.082409748,138.091847129,-596.406869358,263.568628926,-155.559783467,-220.712732871,-195.197252368,-448.172902003,-203.187630781,190.353618465,81.2284638898,-68.3125765045,71.4454537423,-0.692582054308,258.336099304,-107.080577185,-259.15942917,-23.4725076494,-322.356076244,34.3782082139,-45.2855685493,-78.5960622885,-8.42278675219,53.6395109654,-55.9404732712,57.876350306,-5.43127841512,-65.143695761,-15.5505705253,-120.330153207,47.825166632,55.215871424,4.17170463376,-73.4003847228,-16.0838902289,2.23894320699,17.1962717257,-9.74914989395,17.9398610085,-8.66862713632,8.88179995762,1.10102181376,-29.0091254969,29.7493639619,24.9170096678,22.0950871853,-22.2754242146,-1.47949928068,13.573219626,-2.00597608188,0.107819347187,-8.09814238305,-0.112601281301,6.5749471291,2.28003125515,6.85996550052,-1.89540051926,1.388157883,7.39918953883,5.62422238459,14.2727370724,-4.18208267059,4.14826511728,2.96053290483,1.23513159865,0.299900607133,-0.804652847353,-1.77447589589,-2.28399059043,-0.512523358852,1.18891245217,0.209650320337,2.89992265422,-1.26918220678,1.37020435291,2.43348290564,0.607908443345,4.84406714873,-0.533809728165,1.73709179877,-0.360238779371,0.256223742145,1.161716029,0.708199911354,-0.951980628716,0.222087670482,-0.772730486984,-0.622697490207,0.195230501631,0.150310569933,-0.035448659179,0.853521409038,-0.225735193326,0.990724740034,0.129514959032,-0.183842095647,1.25502726445,0.102618322721,0.690578534591,-0.303898032911,-0.0297890463942,0.672370159911,0.23694893944,-0.317109031734,0.0340323966657,0.0917087146099],[-37546.6988749,-1911.89768403,-4700.314428,-1129.50366604,-346.705537205,2166.3125407,31.7216195243,-1605.69530007,-866.496303254,236.797043001,-1497.84377693,629.058180378,412.97543574,-282.697387975,489.045685836,138.832240194,-595.198820699,267.635437559,-148.015158056,-228.853437875,-183.643802197,-457.433317801,-212.587635629,189.335266252,76.3667355435,-64.5225022961,69.2524367406,6.60281098281,256.494177665,-102.571733706,-266.614841799,-23.2844602552,-318.593251104,36.5373332499,-40.2717615265,-78.3490358233,-6.82971638743,53.8594820076,-54.1180813801,57.4582861402,-5.23788854005,-68.4884629757,-14.1252815325,-120.00383493,49.6913758555,55.6562455587,4.02114441014,-76.1513375712,-15.9573587639,2.33956322701,16.9104300347,-9.3023700068,17.6063061602,-8.61603164543,8.17681972943,1.68898215065,-28.883705442,30.5062550307,25.3780690588,22.3512605363,-23.3399432342,-1.60956739795,13.5409848558,-1.98494062072,0.00990082977846,-8.047606222,-0.110189741989,6.49894487781,2.21698079027,6.79368539437,-1.70975305261,1.49352597834,7.76000905798,5.79061204838,14.5747033527,-4.47791537374,4.02189299103,2.96259720468,1.28911339425,0.324479958206,-0.811961298538,-1.81272224631,-2.30733199784,-0.513343040353,1.18949284333,0.204454961617,2.91275654204,-1.20450396966,1.42648197719,2.55932386552,0.642779884273,4.93761430873,-0.571557004344,1.70657623913,-0.372170606151,0.305161161871,1.21549390316,0.707326882142,-0.968307134885,0.210695602644,-0.775071749846,-0.628237254486,0.184697785657,0.161341045779,-0.0292099605394,0.851505141331,-0.213156869,0.99862369487,0.16504642632,-0.179093292777,1.27981037333,0.0975369832235,0.69094199156,-0.313183197863,-0.0239772928378,0.695349281693,0.245744261144,-0.32377396726,0.0359131320564,0.091339179775],[-37598.7581414,-1899.68646505,-4680.99724392,-1113.4909585,-258.980526663,2189.81069705,41.5602838122,-1616.4328632,-873.967560666,223.963197713,-1494.49052222,637.687806425,371.511789269,-268.984590291,512.223236442,142.140615068,-595.048819743,271.053184135,-141.290821444,-236.998518211,-172.083400577,-464.291407503,-221.529430111,187.068962224,70.8545656486,-60.8087513627,66.1526162778,13.5317466338,254.736054357,-97.4611017492,-273.042159447,-22.9258087622,-315.449888223,39.0837841228,-35.8400139214,-78.1778775018,-5.0701281427,54.2087785556,-52.2140845991,57.1711004978,-4.88551111082,-71.5377743713,-12.6496616712,-119.956224981,51.5463226684,55.848620284,3.67737684812,-79.0807966108,-15.7832749837,2.53215137452,16.6425256331,-8.74026189384,17.2831765312,-8.49124193311,7.47475984274,2.33266231899,-28.7544789158,31.2368971619,25.7514327896,22.5711017991,-24.5044427212,-1.68748508617,13.506664029,-1.95741768503,-0.0691547590743,-7.98217974663,-0.0883526994063,6.3998738322,2.18134691371,6.71555691463,-1.50580150086,1.61813240871,8.11468724975,5.94245321561,14.8509142739,-4.79774339544,3.91159118196,2.96017877222,1.34651449713,0.347387215677,-0.81792645764,-1.85125414087,-2.33005045277,-0.509468791432,1.18715239358,0.200755187224,2.92525110965,-1.13675730318,1.49151076055,2.68015429366,0.678761594974,5.02352823595,-0.614610725525,1.6800471354,-0.384730096518,0.356952358335,1.26583393166,0.704834081643,-0.985208505488,0.197371943511,-0.779132504645,-0.634969357952,0.173115913413,0.172298540218,-0.0225660402012,0.849296412247,-0.199571275122,1.00894498357,0.200470655248,-0.172327941455,1.30211496239,0.0930839642016,0.690868391272,-0.322843482724,-0.0164729015794,0.71688829712,0.253436768628,-0.330985992641,0.0382923992646,0.0904897896639],[-37652.549974,-1882.11964776,-4652.88383864,-1098.95050022,-163.266218819,2215.26332243,52.1791201159,-1622.72456863,-877.362898065,208.314820972,-1491.53401965,645.193599024,324.796511385,-254.944853718,535.716163644,148.131053555,-596.194506033,273.70479885,-135.248335863,-245.176943391,-160.571354725,-468.603273118,-229.925562052,183.502875625,64.7186695531,-57.1891244471,62.0057644884,20.0387046523,253.119534983,-91.8211019865,-278.293400241,-22.3789121882,-312.900569455,42.0284215568,-32.1181577538,-78.092962949,-3.16475905664,54.6580742426,-50.2749641671,57.0461272215,-4.37512384453,-74.2393572509,-11.0986504244,-120.200862781,53.3966442162,55.7315242899,3.08673194116,-82.181542442,-15.5650621839,2.81574647668,16.3942720819,-8.06664416426,16.9851244941,-8.287636899,6.78502923257,3.03739426379,-28.6270918378,31.9376813494,26.0173703427,22.7296716854,-25.7644144317,-1.69637367635,13.4811106407,-1.92474801451,-0.126821722441,-7.89921879621,-0.0468814402153,6.27876443385,2.177650306,6.62595524405,-1.28391536321,1.75963559986,8.46125045726,6.07659633414,15.0921721633,-5.13929376038,3.82555126703,2.95785663219,1.40645244875,0.364216005247,-0.822420246953,-1.88966948109,-2.35072281635,-0.500597822507,1.18110532958,0.198959122181,2.93724620213,-1.06661015253,1.56416439417,2.79464929148,0.716193605534,5.09994767155,-0.662217303059,1.65944804452,-0.396191607765,0.411244580662,1.31055880349,0.699671291492,-1.00230906366,0.182284339818,-0.784997861702,-0.642816566023,0.160656763344,0.182769588088,-0.0157807027741,0.846848393974,-0.185209157581,1.0216918712,0.235227274758,-0.163259951173,1.32176051494,0.0895969386321,0.690484676211,-0.332535662423,-0.00717026218866,0.7364479354,0.259421748031,-0.338708627185,0.0414026476987,0.0891900858195],[-37705.9967302,-1857.27355655,-4615.88531939,-1085.32771649,-60.5793500416,2242.14674394,63.4350197876,-1626.72203955,-876.213792769,189.886615286,-1489.2203954,651.784522928,272.453995653,-241.470451053,558.719716883,156.951752225,-598.675480571,275.588165701,-129.735368806,-253.397204116,-149.578175867,-470.524481277,-237.442686103,179.043894807,58.0397337714,-53.7204898772,56.7557067614,26.0301814633,251.681164495,-85.8702102988,-282.24082046,-21.5509720494,-310.731029402,45.3929519995,-29.3071677605,-78.1066208339,-1.17310981484,55.1745634039,-48.3633180883,57.1079655622,-3.7326464824,-76.5232570567,-9.42329001887,-120.7164957,55.2630623396,55.2089678246,2.19029665641,-85.4284528445,-15.3131817477,3.17917932288,16.1619644161,-7.29040239108,16.7287984526,-7.99831806997,6.1242056683,3.80922096173,-28.5077300612,32.6076570243,26.1518317324,22.7944878941,-27.1034231559,-1.61722004916,13.4789415302,-1.88961081313,-0.161009393416,-7.79809419551,0.0136513226948,6.13809900608,2.21055447699,6.5251516458,-1.04621026078,1.9130179727,8.79804542452,6.19027026616,15.2866719774,-5.4974414443,3.77288227262,2.96182691868,1.4665406155,0.370052550504,-0.825036586905,-1.92682434141,-2.36790027511,-0.486748251691,1.17056907261,0.19952876496,2.94794433064,-0.995483384015,1.64279012193,2.9013330946,0.755826964906,5.16454315745,-0.713077029368,1.64686686112,-0.403970683621,0.467011842501,1.34707731429,0.691131764939,-1.01906283647,0.165928815012,-0.792488690798,-0.651550450151,0.14750964279,0.192251892686,-0.00918629780139,0.843958789587,-0.170492627597,1.03683513127,0.268634507254,-0.151555795088,1.33852784554,0.0874399903394,0.689819893461,-0.341707670901,0.00387633024676,0.753258676208,0.263171836366,-0.346807077183,0.0453787608629,0.0874566975139],[-37756.6261482,-1823.19030768,-4569.80629158,-1072.04246102,48.0158665036,2269.72061464,75.2618938133,-1631.04684775,-870.067611108,168.851106415,-1487.77503379,657.662476188,214.072649389,-229.740785529,580.202682443,168.759436344,-602.481834723,276.729907133,-124.596114083,-261.662671388,-139.678176232,-470.285464769,-243.68598362,174.213587901,50.9119376094,-50.4694828772,50.3672817994,31.4031776597,250.452172679,-79.8634163699,-284.761735921,-20.3304004865,-308.679790849,49.2017933294,-27.6263043575,-78.2316680863,0.835627985356,55.7245705502,-46.5457735584,57.3795311231,-2.9902342716,-78.3150987662,-7.56864836794,-121.473173093,57.1698200533,54.1763315258,0.927847204375,-88.7919298931,-15.0398545801,3.60872869303,15.940543039,-6.42168888826,16.5313458183,-7.61631762966,5.5106591279,4.65436314737,-28.4027144225,33.2465382272,26.129687106,22.7311823706,-28.5020519428,-1.43047747267,13.5157143727,-1.85501990096,-0.1697358626,-7.67868051569,0.092477519878,5.98072284262,2.28475864389,6.41339140318,-0.795238345204,2.07259294696,9.12349899584,6.28079847745,15.4219568305,-5.86634841068,3.76292258751,2.97869004305,1.52401632,0.35985622451,-0.825299897455,-1.96138933954,-2.38012759697,-0.468018424018,1.15476184258,0.202939582394,2.95638867281,-0.924986094204,1.72560357591,2.99869222224,0.798515476757,5.21486818573,-0.765753667137,1.64442756427,-0.405268164422,0.523059848632,1.37269478632,0.678594623133,-1.03488127697,0.148883486719,-0.80135980158,-0.660904783298,0.133868216313,0.200220949429,-0.00313231105933,0.840386434886,-0.155891637723,1.05433741438,0.299980223502,-0.136870087269,1.35218810152,0.0869838058597,0.68887861626,-0.349755231844,0.0165726042595,0.766493436835,0.264179008361,-0.355121970673,0.0503312307848,0.0853030259515],[-37801.9659663,-1777.91201739,-4514.4513606,-1058.51458757,161.455217652,2297.24458758,87.5936531789,-1638.32056503,-858.471719412,145.380820121,-1487.42331914,663.029356858,149.240879909,-220.935260378,599.133846607,183.710831174,-607.603659855,277.156645593,-119.674765506,-269.976716205,-131.445668049,-468.116656383,-248.260635961,169.533523037,43.4294603732,-47.5027386712,42.805328305,36.0546938343,249.463789323,-74.0557098836,-285.733462441,-18.6056096404,-306.485376583,53.479363425,-27.294827961,-78.480921636,2.79226274661,56.2744201923,-44.8889577729,57.8837395074,-2.18004245935,-79.5405073567,-5.47979338473,-122.440944316,59.141160372,52.5289960314,-0.760840204396,-92.2423756625,-14.7573015859,4.09067336707,15.7249483539,-5.47065596977,16.4099140028,-7.13466776173,4.96275958935,5.57904155528,-28.3183657583,33.8540389988,25.9258066111,22.5053870605,-29.9408838412,-1.11659921494,13.6069868434,-1.82398909804,-0.151019220595,-7.54085232788,0.188829081888,5.80948123721,2.40496202388,6.29091979946,-0.533551768088,2.23267394235,9.43603801548,6.3455044338,15.4855698366,-6.24017662302,3.80501060045,3.01504641672,1.57611688489,0.328586400327,-0.822734598562,-1.99203509317,-2.38594954985,-0.444506684524,1.13290185943,0.209667041315,2.96162240632,-0.856727379684,1.81082038817,3.08521319359,0.845112944755,5.24847624846,-0.818810979056,1.65425413304,-0.397284890507,0.578194303832,1.38471654187,0.661438987225,-1.0491758382,0.131726472565,-0.811366003693,-0.670613338425,0.119926148475,0.206152253729,0.00203177167565,0.835890165668,-0.141876140511,1.07416137114,0.328552294271,-0.118857441786,1.36251243023,0.088599071729,0.687665417842,-0.356074068942,0.0308242883822,0.775325134573,0.261935238748,-0.363493935695,0.0563705494924,0.0827424723367],[-37839.5439226,-1719.48080194,-4449.62513186,-1044.16394987,278.674490237,2323.97831583,100.36420887,-1651.16476318,-840.97348401,119.648282163,-1488.39063577,668.08706299,77.5470945308,-216.233278833,614.481995656,201.96266198,-614.031047332,276.895003527,-114.815516883,-278.34270957,-125.454963546,-464.248488907,-250.771824483,165.525268347,35.6864813689,-44.8868924835,34.0346849809,39.8817305799,248.747244214,-68.7020805235,-285.033315838,-16.2650116518,-303.886309389,58.2500801648,-28.531998987,-78.867198413,4.62760287159,56.790436841,-43.4594979273,58.6435063182,-1.33422629284,-80.1251078056,-3.10179298242,-123.589858724,61.2013263103,50.1623419791,-2.93598935937,-95.7501922273,-14.4777436702,4.61129212492,15.5101207643,-4.44745594957,16.3816504176,-6.54640064981,4.49887703063,6.58947692004,-28.261004905,34.4298733797,25.5150603948,22.0827339092,-31.4005018999,-0.656038544033,13.7683166175,-1.79953222442,-0.102877558002,-7.38448420322,0.30193793928,5.6272194836,2.57586383418,6.15798211793,-0.263702681053,2.38757437858,9.73408932772,6.38171160097,15.4650541098,-6.61308804483,3.9084847002,3.07749645106,1.62007963277,0.271202451015,-0.816865110187,-2.01743222,-2.38391090166,-0.416311378243,1.10420734307,0.220186608558,2.9626887088,-0.792316337034,1.8966561908,3.15938252786,0.896473172569,5.26292083775,-0.87081272781,1.67847054648,-0.377221702212,0.631220912882,1.38044790323,0.639043978367,-1.06135797321,0.115035890178,-0.822262106784,-0.680409888493,0.105877103839,0.209521301001,0.00595646462718,0.830228817731,-0.128916088513,1.09626965217,0.353638590328,-0.0971724727085,1.36927197899,0.0926564744835,0.686184871444,-0.360059905883,0.0465371111476,0.778926686713,0.255932502254,-0.371763600285,0.0636072090135,0.0797884378738],[-37867.3634184,-1646.53584472,-4375.24660053,-1028.75267008,398.638407615,2349.3769716,113.351422426,-1671.47459545,-817.247364284,91.8980770379,-1490.79588743,673.074045611,-0.991033253719,-216.551385304,625.348323522,223.578606155,-621.73488113,276.042560127,-109.833950145,-286.705578855,-122.139676579,-458.935969892,-250.873079371,162.663810219,27.7663674087,-42.6858345846,24.0592276124,42.8142890974,248.316786278,-64.0242864213,-282.560823267,-13.2274274519,-300.647618204,63.5011314871,-31.5194555936,-79.3996144561,6.27417018986,57.2390713726,-42.3119826919,59.6679925681,-0.483482902682,-80.0055179192,-0.395982389579,-124.890818402,63.3570407068,46.9904523342,-5.64020764457,-99.2819924924,-14.211667302,5.15586726007,15.2887529978,-3.36259387682,16.4581237945,-5.84738613554,4.13490783758,7.68702289405,-28.235499323,34.9709903163,24.8779238381,21.4369733149,-32.8595296314,-0.0333061127038,14.0121313891,-1.78400591407,-0.0239361651608,-7.21042950877,0.430465955518,5.43629996935,2.80083526581,6.01473260499,0.01116203924,2.53240475069,10.0157983513,6.38755786973,15.3503719112,-6.97872075468,4.0808552291,3.17130416308,1.65309376021,0.183597076746,-0.807205970374,-2.03633002731,-2.37271387604,-0.383747955833,1.06814246185,0.234835108167,2.95858711702,-0.733254511494,1.981508642,3.21988866766,0.953366729466,5.256134293,-0.92017800716,1.71867646461,-0.342812655025,0.680864845267,1.35759338214,0.610945886839,-1.0709024466,0.0993446232567,-0.833760807375,-0.689969060146,0.0918901212064,0.209931684483,0.00833168535261,0.823146351934,-0.117399347035,1.1205852271,0.374624996463,-0.0715522383302,1.37222605961,0.099499916111,0.684360267112,-0.36122119042,0.063530278239,0.776565148747,0.245754881137,-0.379757799115,0.0721200803861,0.0764523061147],[-37885.3305075,-1560.10459772,-4291.69232092,-1013.41194406,520.427439215,2373.6778038,125.708957592,-1698.23954102,-787.476191821,62.6630241828,-1494.33205563,678.374967632,-84.6387652526,-221.754688926,631.363654737,248.250149616,-630.609215664,274.980721582,-104.431199689,-294.776476929,-121.370627516,-452.532405936,-248.411326126,161.237808073,19.7092353303,-40.9524754311,13.0389803156,44.9143730195,248.118741003,-60.1111594997,-278.304357237,-9.53331313355,-296.640356571,69.070785569,-36.2883469063,-80.0724822402,7.67134023869,57.5872801257,-41.4528466356,60.9113409078,0.347323046948,-79.1623268212,2.61123390348,-126.318136348,65.5449456955,43.002219373,-8.8456368222,-102.789232683,-13.9626212064,5.70569512028,15.0445470804,-2.22798574137,16.6285881461,-5.04484469239,3.87685402761,8.85356480099,-28.2409029678,35.4632783791,24.0172932553,20.5743294855,-34.2887524032,0.750857887589,14.338338927,-1.7771380566,0.0847508686355,-7.02345679521,0.570794725711,5.23715345741,3.07793540519,5.86096135941,0.285516615958,2.66546385492,10.2781848027,6.36443883077,15.1411620892,-7.3286172915,4.32232034385,3.29638799212,1.67215595951,0.0653962861255,-0.793232189512,-2.04779258061,-2.35169051959,-0.348000290436,1.02515517786,0.253394793023,2.94814260421,-0.680613242941,2.06450350456,3.26622774923,1.01623124711,5.2275643429,-0.964747235167,1.77437427122,-0.293924665039,0.725529129304,1.31545424828,0.577309679447,-1.07753726915,0.085004619792,-0.845406349489,-0.698728894766,0.0780357363392,0.207499388716,0.00900496474434,0.814327229378,-0.107385432386,1.14687234172,0.391289453554,-0.0420635738347,1.37108664172,0.109366160407,0.681789762137,-0.359517266568,0.0812769039429,0.767884128963,0.231354887749,-0.387248193389,0.0818615506895,0.0727373900017],[-37893.8269068,-1461.81158007,-4199.45323715,-999.615236077,643.150990987,2397.3135805,136.43442867,-1729.72266052,-751.96989126,32.5480017706,-1498.58564132,684.411044939,-171.232097099,-231.445440011,632.29122148,275.575730409,-640.528897961,274.161850825,-98.2797880333,-302.208113034,-122.87793835,-445.415678402,-243.281839075,161.489339585,11.5443894777,-39.7369805258,1.17300428947,46.2769865868,248.082453015,-57.018300129,-272.274501593,-5.25353357988,-291.762084179,74.7600806473,-42.8321997924,-80.8764133494,8.76020198224,57.8021458048,-40.8764858016,62.3139393975,1.13478500846,-77.5871164638,5.87718409104,-127.846978287,67.6841632343,38.205237699,-12.506802249,-106.219579856,-13.7324196728,6.24107556687,14.7589573621,-1.0559002683,16.8767188052,-4.14883445182,3.72824402595,10.0661208824,-28.2748164188,35.8898610445,22.9416701942,19.5091450813,-35.656996046,1.6916558807,14.7437170191,-1.77799935554,0.221522254355,-6.82931340912,0.718735777876,5.02972780456,3.40389531256,5.69636744309,0.553240547226,2.78584756284,10.5179869729,6.31456449977,14.8394826394,-7.65379630929,4.63125015471,3.45132998313,1.67421479691,-0.0828405851308,-0.774408896073,-2.05096263502,-2.32033033464,-0.310469360818,0.975939401604,0.275509273222,2.93013650272,-0.635356319915,2.1449485674,3.29809783221,1.08542112277,5.17703756349,-1.00221616096,1.84454203108,-0.230957863493,0.763536258015,1.25373096079,0.538457492126,-1.08105376316,0.0723225938476,-0.856700864024,-0.706068287419,0.0643598592372,0.202468496061,0.00786323702848,0.803441036223,-0.0988517736322,1.17485556082,0.403507916503,-0.00885575862911,1.36555385942,0.122465186618,0.677990230622,-0.355020202404,0.0991635796962,0.752621373852,0.21277714197,-0.393992650944,0.0927523860131,0.0686449848245],[-37893.2343332,-1353.2813109,-4099.02029332,-988.836010409,765.918468882,2420.71706977,144.525449958,-1764.18701456,-711.03838724,2.15788797403,-1503.14314544,691.603493415,-258.607024425,-245.22588887,627.89425593,305.15378658,-651.368775044,274.038310791,-91.0522376956,-308.65319641,-126.391731075,-437.963668648,-235.379892548,163.660482433,3.30113419477,-39.0895153715,-11.3396392672,46.99713404,248.137266941,-54.8013086796,-264.481840181,-0.458953674143,-285.910360722,80.3700549588,-51.1445411194,-81.8020193675,9.48184438469,57.8507511142,-40.5772962336,63.8161760972,1.85549643426,-75.2714687999,9.35919636736,-129.452509946,69.6938152812,32.6071019162,-16.5782292817,-109.520701065,-13.5228769904,6.74230846119,14.4134381934,0.141393817358,17.1861911045,-3.16941354527,3.69260625789,11.3017093797,-28.3348402553,36.2338617888,21.6595562027,18.2557627629,-36.9330863911,2.7842902905,15.2250434528,-1.78566051439,0.384716702965,-6.6337466971,0.870100640034,4.81397086756,3.77544604819,5.52064991791,0.808213331167,2.89265174602,10.7319431529,6.24014489239,14.447391557,-7.94527646205,5.00601477197,3.63471218107,1.65621883867,-0.260554201307,-0.750201218529,-2.04498294563,-2.27812282353,-0.272556145742,0.921189043582,0.300822158856,2.90335014488,-0.598447530953,2.22215161947,3.31519697623,1.1612907537,5.10438053079,-1.03028053368,1.92815780893,-0.154312381631,0.793208724424,1.17212397881,0.49471146081,-1.08124325096,0.0616052594876,-0.867146481879,-0.711366133169,0.0509083999012,0.195083088883,0.00479343643119,0.790157358631,-0.0917757998362,1.20425944924,0.41115634021,0.0279219278795,1.3553278468,0.139006973991,0.672478546669,-0.347802066006,0.116576896936,0.730514629902,0.190066263679,-0.399749039619,0.104713352446,0.0641763858728],[-37883.9345035,-1236.13830935,-3990.88443351,-982.547731332,887.839278849,2444.32103969,148.979635757,-1799.8956638,-664.9916044,-27.902439034,-1507.59106894,700.373528946,-344.599542865,-262.698285817,617.935990268,336.582756177,-663.003693939,275.062464415,-82.4210711931,-313.764436301,-131.642127685,-430.554258036,-224.600760872,167.993314292,-4.9912261745,-39.0602454712,-24.2998891555,47.1698196199,248.212527408,-53.5157855221,-254.936956848,4.77956170043,-278.982745892,85.7017467405,-61.2188977546,-82.8399118786,9.77735641021,57.7001787581,-40.549673975,65.3584390671,2.48605077677,-72.2069657818,13.0145989267,-131.109897052,71.4930237941,26.2154066282,-21.0144432771,-112.640263368,-13.3358074484,7.18969366456,13.9894439243,1.35162779053,17.5406803768,-2.1166401042,3.77346914867,12.5373485346,-28.4185750567,36.4784040883,20.1794528287,16.8285251906,-38.0858492692,4.02396354083,15.779096016,-1.7991922367,0.572672925435,-6.44250400574,1.0207008402,4.58983050321,4.18931867232,5.33350784577,1.0443144659,2.98497227601,10.9167916335,6.14339002432,13.9669468376,-8.19407640379,5.4449843059,3.84511663089,1.61511665101,-0.467185226689,-0.720074285355,-2.02899626755,-2.22455748858,-0.235661623974,0.861598014305,0.328977060019,2.86656486304,-0.570850664593,2.29542044969,3.31722324095,1.24419453717,5.00941982082,-1.04663610246,2.02419966953,-0.0643883506934,0.812869021554,1.0703337615,0.446393721435,-1.07789705487,0.0531593307756,-0.876245333951,-0.714001327083,0.0377272683315,0.185587249545,-0.000317502821401,0.774145782762,-0.0861349400618,1.23480857176,0.414110679577,0.0681202062843,1.34010873796,0.159201501774,0.66477158438,-0.337934925453,0.132903447099,0.701301643605,0.163266872756,-0.40427522725,0.117665216079,0.0593328884365],[-37866.3526458,-1111.74836902,-3875.73089794,-982.100626437,1007.97689312,2468.14188397,148.961400848,-1834.99339746,-614.320538788,-57.1926804554,-1511.5552798,711.043261277,-427.124889417,-283.20664775,602.20856986,369.40589498,-675.316654003,277.669549876,-72.0469307827,-317.219599488,-138.251539956,-423.563688013,-210.907945182,174.629674326,-13.3146018573,-39.6807015582,-37.4937006344,46.9146378037,248.224734587,-53.1746116346,-243.695999488,10.3686742438,-270.911355432,90.5539723717,-72.9927161052,-83.9773852269,9.60174454668,57.326170496,-40.7783309116,66.8752394832,3.00781141201,-68.4046877278,16.7905937121,-132.797198621,73.0025260145,19.0612906631,-25.7557276395,-115.53058058,-13.1712522119,7.56527762352,13.4698634086,2.56298025951,17.9222208451,-1.00234968715,3.97019465638,13.7489895749,-28.5225588919,36.607642495,18.515587215,15.2481291734,-39.0874997134,5.40167189244,16.400647611,-1.81737230948,0.782832303296,-6.26148808515,1.16617180328,4.3575408289,4.64102248393,5.13457146329,1.25594932122,3.06241265499,11.0700778997,6.02688519513,13.4024471158,-8.39213095872,5.94434229228,4.08004505164,1.54849253935,-0.701088456695,-0.683595415118,-2.00250167717,-2.15947024568,-0.201214804603,0.798160706645,0.359447821859,2.81880088884,-0.553231210886,2.36416884244,3.30428137546,1.33422830022,4.89246023108,-1.0492189474,2.13122220629,0.037951515232,0.821098073027,0.948692683536,0.393950339763,-1.07091472631,0.0472166017133,-0.883536334819,-0.713405376403,0.024828389346,0.174322753519,-0.00754467442415,0.755142292742,-0.0818623794583,1.26618095067,0.412384939727,0.11149290802,1.31967756893,0.183180543959,0.654397510005,-0.325600500826,0.147563376612,0.664917029247,0.132539121277,-0.40734577593,0.131494929877,0.0541283420639],[-37841.0880324,-980.442381412,-3755.02211123,-988.351976581,1125.21104907,2490.53049894,144.302361937,-1867.15191919,-560.240472081,-85.930854991,-1514.81911422,723.538375596,-504.415266551,-305.062057918,580.619792828,402.945729708,-688.223263919,282.22630633,-59.5429376801,-318.796682928,-145.41153879,-417.361640366,-194.537853835,183.310447635,-21.6957613657,-40.9078752883,-50.6470947947,46.4495440157,248.039010825,-53.6197904265,-230.997372185,16.1251519887,-261.766529296,94.7166608024,-86.1791207364,-85.1884647985,8.96568537686,56.7391043077,-41.2092422991,68.2775809847,3.42122141044,-63.953708419,20.593877661,-134.504046836,74.1495203186,11.2700697461,-30.6853979634,-118.162553568,-13.0221599483,7.85809312555,12.8433235142,3.76541916592,18.3062822926,0.154512438984,4.26547887042,14.9083156744,-28.6390797882,36.6098558636,16.7050888857,13.5606881148,-39.9238095644,6.89158695357,17.0764515986,-1.83780685372,1.00904690034,-6.09722329953,1.30144454165,4.11848100459,5.12117973697,4.92319570596,1.43962675354,3.12660690746,11.1925762112,5.89471684,12.767153583,-8.53503963182,6.49152596898,4.3326778588,1.45647376572,-0.956275211288,-0.640740686773,-1.96642353612,-2.08408266495,-0.17075681802,0.73307344294,0.391029229742,2.76003405121,-0.54506146594,2.42823456386,3.2781028867,1.43045358897,4.75571944504,-1.0369264725,2.24608612725,0.149994170677,0.817510524854,0.810060781852,0.33832310086,-1.0606287331,0.0437091860541,-0.88870553378,-0.709220237083,0.0120877470322,0.162022148708,-0.0168112837559,0.733148464557,-0.0787143275164,1.29786843805,0.406545326678,0.15740630789,1.29413898358,0.210763053528,0.640929658391,-0.31141912022,0.160111051858,0.622082872315,0.09850529011,-0.408802024777,0.145954194321,0.0486268133379],[-37808.7834469,-842.292512501,-3630.41479409,-1002.03582594,1238.37555033,2509.42140656,135.000936213,-1893.92466127,-504.147757365,-114.499560716,-1517.20527542,737.685450953,-574.7821181,-326.317366155,553.10637048,436.469604813,-701.647284698,289.082348179,-44.5103328407,-318.298741117,-152.205984873,-412.316156971,-175.795121991,193.676280806,-30.1726877827,-42.6801235478,-63.4711091847,46.0170839167,247.507634011,-54.6506059152,-217.125043072,21.8432895511,-251.65316349,97.977519125,-100.435155753,-86.4438587396,7.89377300722,55.9580172281,-41.7786992355,69.4705903265,3.73149376615,-58.962600002,24.3210214599,-136.222967171,74.8628203661,2.99060382663,-35.6725278909,-120.511729959,-12.8797062012,8.05891954332,12.0998856126,4.94935978473,18.6666933929,1.33322358021,4.63785141302,15.9859429935,-28.7593632623,36.4743541242,14.7908129597,11.8186695665,-40.5839398646,8.46367416935,17.7912564544,-1.8578090739,1.24427145094,-5.95638941658,1.42127396459,3.87431645086,5.61919092409,4.69866668401,1.59238149094,3.17969668854,11.2858680219,5.75134667802,12.0765680696,-8.61931809827,7.07178599937,4.59511514195,1.33982333132,-1.22567094157,-0.591588369367,-1.92204252733,-1.99996273008,-0.145856824943,0.668833027894,0.422346304089,2.69047907838,-0.545515427374,2.48756137557,3.24082597105,1.53167337934,4.60189336762,-1.00889641275,2.36522866914,0.268563987327,0.801979453646,0.657930008923,0.280577719621,-1.04747977216,0.0424942774891,-0.891475763809,-0.701140477256,-0.000652659705014,0.149515676124,-0.0280025641163,0.708232272156,-0.0764027498125,1.32931634346,0.397296096671,0.205129791538,1.2636785277,0.241689778208,0.623952656533,-0.296120763733,0.170134394208,0.573718126091,0.0619031923211,-0.408502007165,0.160760896767,0.0429049230997],[-37770.0816727,-697.370928263,-3503.56566723,-1023.88621868,1346.30420057,2522.74912881,121.055540866,-1912.86505594,-447.438747724,-143.281395707,-1518.53646664,753.311066397,-636.536887901,-345.025422296,519.605014125,469.24486475,-715.512477356,298.587289825,-26.5503572198,-315.528828552,-157.71873889,-408.795279701,-154.984384813,205.367820426,-38.7833641915,-44.9358032227,-75.6767813532,45.8598031677,246.482882036,-56.0663421178,-202.362980282,27.3173815468,-240.67615402,100.124254432,-115.417865261,-87.7142751965,6.41060154423,55.0019462922,-42.4229928188,70.3593942637,3.94384147321,-53.5399346235,27.8685957948,-137.9464851,75.0712398167,-5.62824714598,-40.5861910642,-122.553657379,-12.7350665138,8.1585362495,11.229611075,6.1052173909,18.9772828194,2.51306104255,5.0658419064,16.9524876923,-28.8746348311,36.1904472073,12.8156145561,10.0745410806,-41.0570516568,10.0878989849,18.5298106539,-1.87469217452,1.48146068943,-5.84566620403,1.52041498138,3.62671258827,6.12445653795,4.46027050767,1.7112482615,3.22382365336,11.3515347856,5.60123642827,11.3461924064,-8.64148203325,7.67037304682,4.85945699067,1.19930423733,-1.50220109862,-0.53621673195,-1.87063933374,-1.90867842474,-0.128083986088,0.60793626621,0.452024065321,2.61035069857,-0.553767092811,2.54209303916,3.19458882491,1.63669064721,4.43367790378,-0.964266503114,2.48508706867,0.390485336868,0.774377936012,0.495792317223,0.221779910938,-1.03190854042,0.0434290697095,-0.891569857884,-0.688860665051,-0.0135508319608,0.137633576778,-0.0410037488053,0.68046168949,-0.0746396119228,1.35996997645,0.385341505945,0.25393274461,1.22848174711,0.275701465725,0.603051131424,-0.280435411466,0.177221325035,0.520741743859,0.0234706409759,-0.406303756469,0.175632924572,0.0370392921908],[-37725.6254932,-545.74979467,-3376.13145139,-1054.63719897,1447.83080343,2528.44818765,102.464593082,-1921.52653546,-391.509796244,-172.658958039,-1518.63539111,770.241800976,-687.991019789,-359.239076175,480.05243507,500.538853971,-729.742602904,311.090745669,-5.26425177271,-310.289999729,-161.033661525,-407.167050431,-132.410277462,218.025713081,-47.5657736753,-47.6132711995,-86.9751488485,46.2202474295,244.817032791,-57.6662830517,-186.995151948,32.3417225919,-228.94039689,100.944573816,-130.784293364,-88.9704223155,4.54076509438,53.8899285348,-43.0784141472,70.8491195514,4.06347752569,-47.7942844302,31.1331713522,-139.667126097,74.7035923302,-14.4376232222,-45.2954611253,-124.263883457,-12.5794164295,8.14772261679,10.222561273,7.22340725939,19.2118792457,3.67330213201,5.52797997278,17.7785659311,-28.9761200114,35.7474450429,10.8223487939,8.38077020889,-41.3323059835,11.7342268453,19.2768626727,-1.88576936006,1.71356935019,-5.77173342959,1.59362250127,3.37733483743,6.62637707121,4.20729328716,1.7932617933,3.26112945701,11.391157956,5.44884780984,10.5915284239,-8.59804711195,8.2725377747,5.11780349454,1.03567948495,-1.77879113356,-0.474704043571,-1.81349463826,-1.81179773262,-0.119007462172,0.552879962592,0.478687533857,2.51986364002,-0.568990459869,2.59177331623,3.14152964467,1.7443083685,4.25376895845,-0.902174478572,2.60209856255,0.512582590986,0.734579048562,0.327139659229,0.162995389705,-1.01435573479,0.0463707564063,-0.888710648981,-0.672075368601,-0.0267647708304,0.127206091681,-0.0557000711226,0.649904690508,-0.0731368794236,1.38927464657,0.371385810741,0.30308455275,1.18873418761,0.312538863808,0.57780971006,-0.265093043516,0.18095976571,0.464072678904,-0.0160545508599,-0.40206530606,0.190288165093,0.0311065414527],[-37676.2750209,-387.9358085,-3249.27359725,-1094.45572141,1541.95747834,2524.66044305,79.1807084879,-1918.18584573,-337.456574777,-202.913361051,-1517.40196074,788.260094419,-727.936571878,-367.440810706,434.56868923,529.726904981,-744.231207201,326.794642204,19.6069938166,-302.469806842,-161.421708099,-407.702147389,-108.378902834,231.364347914,-56.5563643876,-50.6512329924,-97.1152948485,47.2933911037,242.399017478,-59.272761696,-171.29723844,36.7385054657,-216.54782469,100.283395156,-146.202273729,-90.190896794,2.31510971206,52.6462843831,-43.6849358001,70.8673690977,4.09743764194,-41.8372511913,34.0256232441,-141.376234321,73.7099816187,-23.2882219031,-49.689792248,-125.621914999,-12.4056849714,8.02063560643,9.07476312199,8.29565578208,19.3500156497,4.79555780742,6.00139788315,18.4397520017,-29.0573680176,35.1403604092,8.85292616771,6.78165267215,-41.4017667215,13.3735743559,20.0190803197,-1.88864483316,1.93405242193,-5.73936582929,1.63662237275,3.12788058898,7.11506626476,3.93896641705,1.83613274929,3.29254336957,11.4067311085,5.29849781065,9.82650804556,-8.4868347022,8.86418824493,5.36360923597,0.850211485032,-2.04871114392,-0.407131584383,-1.75195730022,-1.71086844517,-0.119835873091,0.505782082646,0.500941587751,2.41944026088,-0.590408783013,2.6362988238,3.08357521515,1.85324401366,4.06481341122,-0.82214025347,2.71279268933,0.63209134172,0.682776214774,0.15544655995,0.105127724455,-0.995298913695,0.0511859153689,-0.882716485765,-0.6506653149,-0.0404155325511,0.118950093775,-0.0720073447465,0.616704656762,-0.0716837266707,1.41667895558,0.356053024517,0.351808445642,1.14472646857,0.351890815267,0.547881116716,-0.250735404965,0.181049333079,0.4047025734,-0.0560213434679,-0.395729151229,0.204463353865,0.0251742208931],[-37623.7596831,-226.173789739,-3122.17247548,-1141.24038222,1628.35960789,2510.35710688,50.9732964529,-1904.01298714,-285.172030241,-233.919779137,-1515.0449222,806.971829166,-757.088059405,-369.831641108,384.00721094,556.616302493,-758.750975475,345.310154295,47.7633949504,-292.293792861,-158.902212475,-410.281794226,-83.2022347469,245.393084289,-65.7854447636,-53.9897886282,-105.998485048,49.0839235551,239.264380545,-60.8003068777,-155.51176908,40.4415156022,-203.588516331,98.2144794751,-161.38279827,-91.3858495345,-0.210510756551,51.3164678332,-44.1972562831,70.4316504236,4.06004843734,-35.7925551652,36.5140442861,-143.060428676,72.1256716036,-32.028970491,-53.7401607332,-126.623095543,-12.2138150814,7.78494253398,7.80610571464,9.31893381845,19.3940422284,5.87077363886,6.4576385035,18.9314527223,-29.1212228546,34.3870174753,6.9454786735,5.28879686654,-41.2691090836,14.980662762,20.7508087371,-1.88208678902,2.13836591081,-5.7457180125,1.64902420116,2.88017511398,7.5834908524,3.65430242929,1.84027553192,3.3141451209,11.4018963048,5.15392449398,9.05878356669,-8.3108889425,9.43386211358,5.5957467687,0.646160286992,-2.306609813,-0.333592678959,-1.68764888442,-1.60735758497,-0.130335675454,0.467245235596,0.517310535585,2.31033343898,-0.617442344074,2.6743776006,3.0218066748,1.96187303134,3.86926204032,-0.72521245964,2.81406819483,0.747892062522,0.620444245592,-0.0158821654846,0.0484318982805,-0.975363081569,0.0577786607797,-0.873787779653,-0.625255866391,-0.0544763939293,0.113128983718,-0.0899637048691,0.581306600202,-0.0703781631385,1.44164467412,0.339646189611,0.399143029116,1.09716950367,0.393238543242,0.513190464785,-0.23765130082,0.177636425883,0.34391382509,-0.0961257905185,-0.387575634922,0.217970619141,0.0192735971864],[-37570.0262365,-63.143089175,-2993.51318671,-1192.32268806,1706.88089042,2484.71672902,17.5659647836,-1880.9012737,-234.248428318,-265.451901954,-1511.85023084,825.938748336,-776.640611885,-367.042215681,329.404779141,581.122319276,-773.044377801,366.100768898,78.7652183023,-280.071998456,-153.681603148,-414.689850944,-57.1937147555,260.195024127,-75.2817883089,-57.5693867617,-113.564030769,51.5489628891,235.485319749,-62.1864963857,-139.87298543,43.4124365989,-190.149587309,94.8687985833,-176.047648461,-92.5733199902,-2.97399051737,49.9512162732,-44.5737555833,69.5819472035,3.96745925154,-29.7869462329,38.5808317195,-144.705146751,70.0072162586,-40.5083537387,-57.4379234134,-127.266727806,-12.0055031811,7.45168830355,6.44244368764,10.2915233449,19.3520134831,6.89222884923,6.86684734858,19.2540330422,-29.1728522251,33.5109432581,5.13719368279,3.90563935708,-40.9409111172,16.5311644692,21.4683124009,-1.86515442101,2.32246607737,-5.78603955687,1.63140853102,2.63607565353,8.02533081615,3.35225914016,1.80678047848,3.3208020558,11.3807077285,5.01872119191,8.29443737547,-8.07455966401,9.97075443527,5.81444313928,0.427285349911,-2.54748047056,-0.254183662975,-1.62225913206,-1.50271198238,-0.149912785051,0.437493191567,0.526298543572,2.19400368207,-0.649560681725,2.70447054077,2.95709375051,2.06848536476,3.66951659862,-0.612821908284,2.90291612673,0.859276447195,0.549378298825,-0.183459129411,-0.00699925208787,-0.95521010434,0.0660624909189,-0.862220457753,-0.596658544381,-0.0688836869139,0.1098927941,-0.109637867061,0.544230940379,-0.0693954070808,1.46363686502,0.322388105575,0.444080753045,1.04687928016,0.43601136596,0.473730964942,-0.226041301075,0.170979138336,0.283061520606,-0.136150719029,-0.377969562001,0.230640937355,0.0134268661729],[-37517.0214372,98.4769424036,-2861.98083157,-1245.03414555,1777.3650243,2446.91785934,-21.3176787136,-1850.74401944,-184.278034692,-297.283419158,-1508.10384202,844.722595048,-787.789358836,-359.703182722,271.798172771,603.160228093,-786.85388425,388.62997297,112.172730546,-266.114464293,-145.966308616,-420.710177549,-30.6667844118,275.853269349,-85.074168529,-61.3304760477,-119.751243338,54.6456272113,231.134032852,-63.368908009,-124.615129049,45.6129520532,-176.318153118,90.3773242906,-189.918605777,-93.7713476149,-5.91322377628,48.6012670915,-44.7728136876,68.3582431115,3.83581942418,-23.9471742754,40.2083827857,-146.295826133,67.4111695575,-48.5748563989,-60.774437121,-127.552114505,-11.7824456922,7.03191781925,5.00963167774,11.2117063377,19.2319839151,7.85320266143,7.19916993315,19.4078579114,-29.2174238316,32.5356647745,3.46525856707,2.63561670878,-40.4237508693,18.0007518831,22.1678557867,-1.83690692249,2.48230918212,-5.85558004009,1.58435590689,2.39743944878,8.43426613802,3.03179436593,1.73673792629,3.30738151909,11.347219563,4.89648123657,7.53955186011,-7.78219669787,10.4640602646,6.01992539426,0.197346132866,-2.76631644634,-0.169000872108,-1.55747778433,-1.39837846774,-0.177973117671,0.416749720685,0.526409777926,2.07191149791,-0.686233334641,2.72503853845,2.89030616918,2.17137095712,3.467978839,-0.486399410605,2.9763275327,0.965536189545,0.471373532285,-0.343896944166,-0.0610728899184,-0.935501847939,0.0759509040671,-0.848310447172,-0.565684870176,-0.0835737434535,0.109391557509,-0.131098546893,0.505998096842,-0.0689106767517,1.48212059112,0.304501571965,0.485614067297,0.994671785276,0.479638601644,0.429495827861,-0.216105975719,0.161335564652,0.223500746581,-0.175878956018,-0.367275737328,0.242305284938,0.00765622369338],[-37466.6920418,256.006954208,-2726.26051071,-1296.70626136,1839.65570789,2396.13904771,-65.9540262323,-1815.43453838,-134.853115047,-329.188020408,-1504.09171108,862.885112421,-791.729429774,-348.445190531,212.224170773,622.645301712,-799.921964898,412.361253465,147.546198355,-250.73123104,-135.962757376,-428.126634045,-3.93488526873,292.450921875,-95.1913589296,-65.2135051412,-124.499434076,58.331034627,226.282717611,-64.2851195364,-109.972441498,47.0047455628,-162.181329254,84.8710284068,-202.717451693,-94.9979718619,-8.9661047392,47.3173576763,-44.7528105831,66.8005218219,3.68127829491,-18.3999891737,41.3790947261,-147.817904413,64.3940854742,-56.0769632245,-63.7410586887,-127.478558358,-11.5463390364,6.53667598522,3.53352432166,12.0777647734,19.0420080259,8.74697429837,7.42475177196,19.3932922792,-29.2601053766,31.4847090414,1.96686069783,1.48216548664,-39.7242063871,19.3650974093,22.8457033702,-1.79640348681,2.61385148559,-5.94958903982,1.50844687331,2.16612374083,8.80397680003,2.6918659229,1.63123821266,3.26875085559,11.3054859917,4.79079796006,6.8002094088,-7.43814987523,10.9029746562,6.21242058022,-0.0398979050675,-2.95811107009,-0.0781406420329,-1.49499458241,-1.2958038714,-0.213922589103,0.405238593077,0.51614840486,1.94551739424,-0.726929841495,2.7345424878,2.82231365769,2.26881975162,3.26705051434,-0.347375777805,3.03129346039,1.06596298338,0.388225103782,-0.493808222086,-0.11369617848,-0.916900178297,0.0873573985046,-0.832353675015,-0.533146365082,-0.0984828954967,0.111775306534,-0.154414459935,0.467128489144,-0.0690991904049,1.49656091526,0.286209388334,0.522735421743,0.941363006271,0.52354956852,0.380478264216,-0.208045894743,0.148963799046,0.16658658965,-0.215093328503,-0.355858965765,0.252794638322,0.00198386558843],[-37420.2779801,406.505439826,-2585.49265558,-1345.25577362,1893.79820537,2332.15829788,-116.30693087,-1776.72184378,-85.6850135533,-360.835940402,-1499.99219818,880.096779768,-789.638668243,-333.772937853,151.821116581,639.537279639,-811.994569458,436.689640036,184.411128668,-234.23054083,-123.82692874,-436.671229331,22.6889930958,310.020973,-105.632141288,-69.1755411431,-127.793585386,62.5429093442,221.026083249,-64.8732608185,-96.1710558361,47.5685308795,-147.845142016,78.4828376942,-214.194871234,-96.2617981972,-12.0729956442,46.1416712792,-44.4731022694,64.9596023964,3.51568781574,-13.2681420703,42.0851445812,-149.25683952,61.0110785581,-62.8780063856,-66.3345130061,-127.046191179,-11.2969264335,5.97891327122,2.04124910415,12.8903461198,18.7917687051,9.56663699036,7.5155503032,19.2140659862,-29.3054683797,30.3807430971,0.674700732358,0.446957143593,-38.8503157735,20.6032143628,23.4972020084,-1.74287085733,2.71415565475,-6.06199942903,1.40519783605,1.94354029634,9.12883135492,2.33179673623,1.49173903148,3.19989297245,11.259258616,4.70457377893,6.08208433471,-7.04776351852,11.2784507907,6.39211334587,-0.280846314713,-3.11879293726,0.0179986003377,-1.43625958418,-1.19608519355,-0.256961711223,0.402820107347,0.494337295013,1.81637232366,-0.771182156047,2.73144746493,2.75385121266,2.35918786435,3.06899561217,-0.1976002831,3.06534650451,1.16000304769,0.301706736469,-0.630235437096,-0.164809229375,-0.900009733115,0.100119988501,-0.814665890684,-0.499874079317,-0.113518157328,0.117118630285,-0.179580187599,0.42814869608,-0.0701333327536,1.50645723003,0.267700256506,0.554528755642,0.887752290397,0.567138798873,0.326774322632,-0.201996777478,0.134146757243,0.11354705367,-0.253622497896,-0.344109237716,0.261998191741,-0.00355779155269],[-37376.1918761,545.982270346,-2440.63902096,-1390.94034641,1940.64404424,2257.15142911,-171.090089338,-1735.77774582,-36.9613883257,-391.483594012,-1495.55328267,896.46302117,-782.625773904,-315.68732522,92.1336116144,653.973768346,-822.831566213,460.736333109,222.153989482,-216.913441661,-109.513005278,-445.868567892,48.8936690035,328.395971513,-116.275330469,-73.2401249389,-129.801363978,67.1413999803,215.548884834,-65.0736699519,-83.4046711111,47.3611423726,-133.491260917,71.3534987254,-224.217163626,-97.5336961369,-15.1841308578,45.0821746059,-43.896948796,62.9296454467,3.33371038815,-8.65838915317,42.3578285885,-150.598170749,57.3115056622,-68.9007077219,-68.5729971913,-126.258461172,-11.0261382958,5.37920240975,0.565024901854,13.6595598101,18.4974623963,10.3045399975,7.45077065882,18.8873684364,-29.3556996281,29.2429940651,-0.396467528871,-0.475397315863,-37.8159573544,21.7074796973,24.1140280832,-1.67620597736,2.78470998237,-6.18147726181,1.27986864576,1.729318984,9.40595263822,1.95237016661,1.32116750295,3.09625302633,11.2110787087,4.63794744759,5.38921865095,-6.62035991517,11.5884743526,6.55901874864,-0.522534686492,-3.24803170604,0.117810063152,-1.38176411414,-1.09892011358,-0.305469380255,0.407900676015,0.461074136718,1.68638901803,-0.818771892395,2.71423527394,2.6851149096,2.44109610289,2.87552705863,-0.0405960477613,3.07818544797,1.24772070226,0.21350641486,-0.751940509464,-0.214483947547,-0.885206237178,0.11377475228,-0.795642132751,-0.466777178743,-0.128469272574,0.125194343959,-0.206293774659,0.38960993343,-0.072174154347,1.51144624716,0.249026487368,0.580443965814,0.834572424934,0.609661681225,0.268891403532,-0.197834940606,0.117266641011,0.0651018114003,-0.291478463187,-0.332517285764,0.270038010631,-0.00889544814601],[-37332.1395274,670.185161234,-2293.11669245,-1434.60287533,1981.24631783,2173.89371455,-228.704659254,-1693.62975393,11.0110240339,-420.28394115,-1490.41534871,912.197996904,-771.782160447,-294.063303612,34.8078217895,666.136841045,-832.196303086,483.554075807,260.126489059,-199.079182993,-92.9247203735,-455.191403108,74.3684127507,347.358355576,-126.969749608,-77.4474158603,-130.736107642,71.9672612551,210.058388896,-64.8272370949,-71.8588778704,46.4584445657,-119.320266275,63.6257130256,-232.679531648,-98.7751012093,-18.2522127789,44.1382802254,-42.9885862249,60.8156469721,3.12571102599,-4.67348787219,42.2382227847,-151.827457735,53.3432842154,-74.0826364907,-70.4800764195,-125.11964564,-10.7239518339,4.76002169891,-0.861656560566,14.3978807694,18.1769139311,10.9528465872,7.21142989422,18.4337539243,-29.4123897257,28.08982909,-1.23637699959,-1.29205199931,-36.6364695118,22.6736112757,24.6869403574,-1.59647334021,2.82810916767,-6.29537188756,1.13865501436,1.52264419801,9.63315205618,1.55473468362,1.12281810384,2.95339173622,11.1631849608,4.59036680489,4.7252462956,-6.1662558439,11.8327891523,6.71310944813,-0.762157620724,-3.34643230034,0.219384863324,-1.3317598135,-1.00365648074,-0.357619088511,0.418523240078,0.41677532273,1.55757065407,-0.869543079722,2.68139190087,2.6161660938,2.51323144767,2.68822001453,0.119695344927,3.07005062067,1.32933479206,0.125290688811,-0.858115221042,-0.262825186272,-0.872808187042,0.127782284056,-0.775697262086,-0.434784358136,-0.143096667196,0.135699819273,-0.23417913173,0.352069576221,-0.0753798721935,1.51119900809,0.230206294079,0.600022438464,0.782539557172,0.650338818163,0.207439745291,-0.195371850146,0.0987304736294,0.0218434528263,-0.328719057763,-0.321599028033,0.27709437823,-0.0139455838589],[-37285.8267317,774.861827953,-2144.34275564,-1477.08625596,2016.65811946,2085.16042733,-287.551798233,-1651.30537753,57.9254869238,-446.389941731,-1484.21878047,927.515867244,-758.19924156,-268.775824009,-18.5100869793,676.208570948,-839.852128001,504.195611249,297.680335661,-181.02701429,-73.9658074106,-464.112488359,98.8024946338,366.690563351,-137.564221842,-81.8375732389,-130.811154167,76.8612478883,204.761861967,-64.0748524057,-61.7192666608,44.9363019826,-105.532738409,55.4421821198,-239.477178075,-99.9474489429,-21.2299438061,43.3094007065,-41.7122506182,58.7226029716,2.88205474311,-1.41619567699,41.7674032067,-152.930260114,49.1543316464,-78.3613619489,-72.079315866,-123.634021883,-10.3803442583,4.14384943687,-2.20530355846,15.1177839224,17.8479481413,11.5037200269,6.77854506478,17.8737767448,-29.4771292768,26.9396153168,-1.83476059354,-2.01016101435,-35.3271906274,23.4973269611,25.2066975942,-1.50373743919,2.84694790986,-6.39103265566,0.987752653716,1.3227003326,9.80824101505,1.14003875686,0.899985310954,2.76686982113,11.1178160631,4.5612796897,4.09380120674,-5.69576808341,12.0111390005,6.85435810391,-0.996909717731,-3.41459964406,0.320814117765,-1.28649832345,-0.909642144263,-0.411584328301,0.432730740536,0.361857245808,1.43192040848,-0.923339747213,2.63140333179,2.5470661105,2.57428087915,2.50864964068,0.279332311679,3.04118235255,1.40506416208,0.0387261081792,-0.947951353686,-0.309937798829,-0.863134079262,0.141603178041,-0.755246139555,-0.404824312269,-0.157160767157,0.148332427945,-0.262860169426,0.316084999478,-0.0799087033013,1.50538655431,0.211257889794,0.6128055598,0.732369834397,0.688390812268,0.143029586282,-0.194418972121,0.0789452783786,-0.0156354320676,-0.365402115007,-0.311870382646,0.283347577776,-0.0186246783588],[-37234.9592864,855.759985968,-1995.73429614,-1519.23338387,2047.93254245,1993.7268406,-346.032663892,-1609.83212605,103.475263742,-468.954555667,-1476.6039621,942.630792466,-742.968430934,-239.69983739,-66.1739487769,684.371031268,-845.562388882,521.713682559,334.167237551,-163.056185013,-52.5399997735,-472.104577025,121.885184949,386.175033002,-147.907570307,-86.4507564063,-130.239841343,81.6641145999,199.866570577,-62.7574060427,-53.1714280292,42.8705791469,-92.3292576372,46.9456075331,-244.505305685,-101.012174866,-24.0700263384,42.5949486184,-40.0321780381,56.7555094446,2.59310655334,1.01072998277,40.986445891,-153.892137522,44.792565384,-81.6744533538,-73.3942807062,-121.805867202,-9.98529277964,3.55316392174,-3.43242436718,15.8317441939,17.5283898587,11.9493235843,6.1331332259,17.2279911925,-29.5515088853,25.8107198901,-2.18135122445,-2.63687846855,-33.903459083,24.1743446167,25.6640585564,-1.39806276759,2.84382090816,-6.45580891551,0.833357275739,1.12867178196,9.92903092108,0.709430855886,0.655963601056,2.53224800005,11.0772107065,4.55013394085,3.49851732244,-5.21921341242,12.1232677075,6.98273737559,-1.22398557783,-3.45313866109,0.42018894339,-1.24623128517,-0.816224953373,-0.465538591936,0.448566118384,0.296736298707,1.31144145797,-0.98000592405,2.56275555277,2.47787630497,2.62293137777,2.33839109788,0.434373269212,2.99182097355,1.47512765728,-0.0445207771793,-1.02064068925,-0.355926638494,-0.856502410394,0.15469802845,-0.734703626026,-0.377825735917,-0.170421998418,0.162789541694,-0.291960798363,0.282213578227,-0.085918864679,1.49367992728,0.192199487672,0.61833471603,0.684779403898,0.723038266127,0.076271164878,-0.194787772551,0.0583180785377,-0.0467422532969,-0.401585468306,-0.303847267729,0.288977892505,-0.0228492113129],[-37177.8502681,910.015725065,-1848.36392748,-1561.79099804,2076.15972134,1902.22454747,-402.650146415,-1570.2536104,147.349792039,-487.218960898,-1467.16565358,957.645439255,-727.080003885,-206.855448746,-106.871306746,690.776751728,-849.168039219,535.316478098,368.904395425,-145.43977377,-28.6263169887,-478.687568262,143.318027402,405.502645131,-157.861333371,-91.3413330084,-129.214692114,86.2082808457,195.574001813,-60.8307410614,-46.3511210873,40.3364588979,-79.9216057766,38.2657766187,-247.709924035,-101.933053549,-26.7334144979,41.9917168875,-37.9189828031,55.0152417143,2.2496930269,2.53005358576,39.9331955223,-154.701041286,40.2981839612,-83.9868990445,-74.4426017917,-119.640960128,-9.52954546912,3.00864017522,-4.51359919024,16.5518444164,17.2353062727,12.282565824,5.263097859,16.5165829536,-29.6346083153,24.7188477991,-2.27394223141,-3.17658471802,-32.3828070792,24.7018227744,26.0484221401,-1.27939060847,2.82158347539,-6.47841833504,0.681450114195,0.939848239982,9.99420089893,0.265180181248,0.39434924323,2.24730449358,11.0431618983,4.55530375658,2.94298602962,-4.74730779784,12.1693730717,7.09728019273,-1.44080374998,-3.463188023,0.515793531016,-1.211046456,-0.722794993338,-0.517824472341,0.464137882939,0.222059964617,1.1980437549,-1.03931620998,2.47464321395,2.40875369083,2.65809792749,2.17878836067,0.580854370242,2.92238359623,1.53946223071,-0.122889033913,-1.07584648188,-0.400785021789,-0.853172240588,0.166579062989,-0.714425102648,-0.354609080915,-0.182691443864,0.178731742092,-0.321089060945,0.25091408057,-0.0935157901981,1.47590146509,0.17308899112,0.616344878,0.640348936056,0.75355601405,0.00775784627318,-0.196300367905,0.0372653653793,-0.0711025944418,-0.437256325735,-0.29800602872,0.294123827924,-0.0265387360405],[-37115.2418699,940.318632314,-1701.92637497,-1605.12121091,2102.57795544,1812.71042102,-456.314066266,-1533.67784741,189.223205967,-500.777207474,-1455.31611823,972.216499933,-711.11968224,-170.843379113,-140.624540263,695.460088098,-850.820454768,544.83396719,401.070979727,-128.346175745,-2.50492315208,-483.569944338,162.851659333,423.998050097,-167.337910329,-96.6205039474,-127.844970053,90.2928250266,192.062524986,-58.310512107,-41.1947792057,37.4063973379,-68.5663706441,29.4808200409,-249.2402698,-102.683215728,-29.2140693012,41.48601987,-35.3687922581,53.5861924013,1.84448695945,3.16662732417,38.6325713763,-155.3544895,35.6805103277,-85.3733636879,-75.2181726802,-117.151084113,-9.00693384108,2.52374011324,-5.43569594393,17.2885990524,16.982734004,12.4993365003,4.18388814966,15.7582632794,-29.7154639705,23.6690554096,-2.14256865501,-3.62256511287,-30.7915420919,25.0826826421,26.3437477728,-1.1471694038,2.78413337879,-6.45305185643,0.537154490373,0.755940599218,10.0059009468,-0.185961142701,0.119945675755,1.91868752871,11.0156799119,4.57086877255,2.43062851054,-4.29236395949,12.1514688422,7.19326056481,-1.64567857765,-3.44802139204,0.606684367081,-1.18037605783,-0.628911293541,-0.567460964895,0.47781681678,0.139400088449,1.09326435428,-1.10076748698,2.36909562185,2.34023795522,2.67960752629,2.03026065855,0.714722711496,2.83399446369,1.59687726774,-0.195240194689,-1.11511787495,-0.44406011821,-0.853164884368,0.176965043342,-0.694528031693,-0.335561827345,-0.193982814063,0.195672450138,-0.349789526746,0.222250846919,-0.102593781184,1.45247869224,0.154143064559,0.60734535511,0.599117193623,0.77943581727,-0.0619844970639,-0.19882147645,0.016241502149,-0.0892147333425,-0.472119394133,-0.294664720316,0.298756778601,-0.0296251004675],[-37048.4835636,950.746669103,-1555.77189187,-1649.4899783,2128.4625853,1727.09765427,-506.035976475,-1501.22895542,228.765813834,-509.311563469,-1440.42199518,985.889173234,-695.572049453,-132.409503535,-167.789737762,698.425852659,-850.748616851,550.251564403,429.811653334,-111.917615267,25.4687314983,-486.507333293,180.24899149,440.894340701,-176.262415709,-102.41367844,-126.219123891,93.7084902796,189.504729963,-55.227326722,-37.5890043198,34.1521688843,-58.5313415564,20.6559542924,-249.296386437,-103.238131182,-31.5142034881,41.0615522794,-32.3841120047,52.54863345,1.37062270302,2.97082531856,37.1062613766,-155.85239195,30.9411485374,-85.9359310327,-75.7089526062,-114.349523838,-8.41206027055,2.11012237527,-6.18965447267,18.0521304722,16.7839520309,12.5962706649,2.9178397095,14.9713748126,-29.7806014146,22.6637369319,-1.82532596117,-3.96533125174,-29.1581654155,25.3212860968,26.5326350153,-1.00072438531,2.73562899923,-6.37526874039,0.405379247438,0.576765051894,9.96714878139,-0.636120260647,-0.162141870791,1.55526283402,10.9943293372,4.58983498377,1.96482339629,-3.86709380539,12.0720227561,7.26501277126,-1.83714835292,-3.41144617813,0.69211101193,-1.15348842872,-0.534175119397,-0.613636165589,0.488039270801,0.0505596055484,0.998547086769,-1.16378720761,2.24885074708,2.27296445364,2.68751517567,1.89299603474,0.831903125705,2.72795460171,1.64590026182,-0.260541408678,-1.14047548409,-0.485187560497,-0.856442219851,0.185626364685,-0.675070395713,-0.320963212352,-0.204360476506,0.213088296686,-0.377590897129,0.196189610759,-0.112994355824,1.42399042985,0.135618062657,0.5920390414,0.560987462443,0.800223668746,-0.132446865845,-0.2022264669,-0.00428967991437,-0.101795121404,-0.505808755028,-0.29410182453,0.302806361374,-0.0320432261714],[-36978.9248211,945.377796823,-1409.25073143,-1695.16325603,2155.08895144,1647.29944029,-550.827430074,-1474.03105274,265.647923943,-512.50429696,-1421.84992357,998.20865789,-680.921688978,-92.2996970607,-188.722987676,699.678857692,-849.18150679,551.5546843,454.271079125,-96.2963166659,54.9391967243,-487.255363171,195.272934623,455.424609742,-184.559964038,-108.846265702,-124.425602358,96.2460197418,188.07320661,-51.611792449,-35.4203983652,30.645547955,-50.0843078299,11.8563958656,-248.078317401,-103.573269689,-33.6360297987,40.7020088294,-28.9674476443,51.9828368051,0.821234609632,1.99302168947,35.3759534468,-156.194658422,26.0817026443,-85.7766848279,-75.9029008039,-111.249563983,-7.7395271326,1.77944560078,-6.76641462093,18.8525610459,16.6522393317,12.5700033692,1.48728815013,14.1742601961,-29.8165462113,21.7052865763,-1.36030961583,-4.19539473326,-27.5111783448,25.4219950151,26.597683428,-0.839380784722,2.68022871755,-6.24062824763,0.291033228555,0.402137790232,9.88096211929,-1.07742431728,-0.446808165831,1.16589613807,10.9786747639,4.60520838527,1.54894931797,-3.48420924355,11.9335025505,7.30687109154,-2.0137513679,-3.35726979118,0.771323025906,-1.1296519067,-0.438187736321,-0.655538170414,0.493241595898,-0.0426585487412,0.915335783033,-1.22780282442,2.11664656022,2.20756854157,2.68187587713,1.76718253248,0.928320445598,2.60556503603,1.68505870639,-0.317759825053,-1.15393992496,-0.523602981393,-0.862966125157,0.192333422198,-0.656110177262,-0.311092473077,-0.213888798684,0.230455912592,-0.404021873457,0.172696105579,-0.124559032307,1.39101549905,0.117770340087,0.571128830909,0.525863028364,0.815465561436,-0.203120260782,-0.206390707969,-0.0238643495721,-0.109560210031,-0.537958489949,-0.296595823373,0.306202193079,-0.0337280347301],[-36907.9151145,928.289976864,-1261.71314689,-1742.40699994,2183.73239439,1575.2289721,-589.699980094,-1453.2082577,299.539844602,-510.037676022,-1398.96654254,1008.72015263,-667.653184271,-51.2598347349,-203.78037844,699.223915478,-846.348105908,548.728741448,473.593919979,-81.6245042706,85.5510222876,-485.569662014,207.686399479,466.82195002,-192.155669843,-116.04367495,-122.552854182,97.6961565502,187.940544795,-47.4945168305,-34.5755632774,26.9583089677,-43.493058781,3.14736125284,-245.786106149,-103.664101027,-35.5817609728,40.3910842336,-25.1213047784,51.969074411,0.189457031309,0.283590557463,33.4633355105,-156.3811987,21.1037767023,-84.9977088222,-75.7879765075,-107.864489229,-6.98393680228,1.54336842925,-7.15691623314,19.7000131438,16.600874885,12.4171696649,-0.0854309168325,13.3852620724,-29.8098239242,20.7960985529,-0.785615084924,-4.30326715604,-25.8790821743,25.389171274,26.5214925717,-0.662463833747,2.62209091461,-6.04468963887,0.199025276891,0.231875006457,9.75035867714,-1.50200045728,-0.728947978785,0.759453169453,10.9682807821,4.60999497208,1.18638490667,-3.15642218199,11.7383759622,7.31316980509,-2.17402591468,-3.28929964113,0.843569969352,-1.10813482982,-0.340550409728,-0.692355075363,0.491860142966,-0.138451439076,0.845074273735,-1.29224178994,1.9752210319,2.14468557452,2.66274463216,1.65300819499,0.999899503903,2.4681267924,1.71288009488,-0.365862592984,-1.15753181322,-0.558742013636,-0.872698478402,0.196856611055,-0.637705358892,-0.306228846664,-0.222632148087,0.247251928708,-0.428611157093,0.151736064866,-0.137129328822,1.35413272096,0.10085625152,0.545317617677,0.493647177228,0.824707488302,-0.273495682587,-0.211189568371,-0.0420186755853,-0.113226450629,-0.568202680426,-0.302425198858,0.308873890555,-0.0346144477211],[-36837.2264427,903.231112837,-1112.72596267,-1791.34710243,2215.38171339,1512.3271002,-621.875288968,-1439.45759587,330.270522798,-501.732012511,-1371.2762607,1017.0592118,-656.110473699,-10.0549407453,-213.486043483,697.079650238,-842.471247903,541.859679803,487.088673526,-67.9728143062,116.95137385,-481.261297507,217.2971199,474.415211951,-198.998821748,-124.109260021,-120.644460012,97.8785680151,189.253377806,-42.9112080784,-34.9187296693,23.1509813024,-38.9908721107,-5.41653642408,-242.617911238,-103.493927069,-37.3584962787,40.1201296809,-20.8589517568,52.5741810179,-0.531352778636,-2.08793240677,31.3871933725,-156.414017992,16.0102954925,-83.7000265601,-75.355782813,-104.215098851,-6.14252437214,1.40961194325,-7.35632966309,20.6005477385,16.640135345,12.1356407815,-1.77404178918,12.6205756083,-29.7477853138,19.9373756977,-0.138238682554,-4.28047432757,-24.2900394606,25.2276569247,26.2890240303,-0.469466141587,2.56465002662,-5.78519906938,0.132870730312,0.0656380870282,9.57832138219,-1.90234363505,-1.00374723132,0.345235734891,10.9627696043,4.59801534062,0.880184632585,-2.89469552435,11.4895178885,7.27866164998,-2.31662743437,-3.21099790256,0.908362947971,-1.08823812742,-0.24114220923,-0.723553798108,0.482575009372,-0.235112382711,0.788875668062,-1.35647746107,1.82760099913,2.08498249818,2.6304521622,1.55055210967,1.04331587337,2.3170653962,1.72793352175,-0.404010733781,-1.15318516208,-0.590061188987,-0.885566246424,0.199061601501,-0.619866381493,-0.306523104022,-0.230664466833,0.263006402225,-0.450936950339,0.133211839165,-0.150517268397,1.31399103572,0.0851450977,0.515380205503,0.464182468938,0.827671829164,-0.343088963113,-0.216537022954,-0.0583393242616,-0.113507593145,-0.596183237962,-0.311768285442,0.310742743274,-0.034669368024],[-36770.3209124,872.628877239,-962.722287791,-1841.5492023,2249.87954249,1458.14530475,-647.415456727,-1431.76772178,358.303460264,-487.959793401,-1338.83456457,1023.22281213,-646.07491528,30.4733641562,-219.036296223,693.319933949,-837.749175973,531.43556088,494.719176411,-55.1255305813,148.797880674,-474.363095902,224.092122088,477.916276421,-205.135404763,-133.058153226,-118.564528167,96.7286181402,192.05451262,-37.9179770828,-36.2246428646,19.2391141885,-36.6729790569,-13.8230975266,-238.764351627,-103.077378064,-38.9928810979,39.9111222612,-16.2367079224,53.8112425974,-1.34694596176,-4.97536533195,29.1547043626,-156.303503189,10.8094667057,-81.9804207687,-74.612498263,-100.352250498,-5.22305580472,1.37014699765,-7.37674730197,21.5439802137,16.7682880705,11.7282326598,-3.53650840235,11.8878060663,-29.6210819273,19.125555349,0.549219884537,-4.12259889068,-22.7708578079,24.9442147165,25.8946874811,-0.26054982736,2.50844471127,-5.4686502726,0.0905109054797,-0.0975308046569,9.36769400406,-2.27242004376,-1.26755645404,-0.0657100462961,10.9619939342,4.56634849289,0.632106322271,-2.70299615665,11.1914318673,7.19977319881,-2.44067996404,-3.12444580873,0.966259248901,-1.06939309407,-0.14095342123,-0.749716543047,0.465041278362,-0.331319707307,0.746530189284,-1.419666812,1.67796876465,2.02925261901,2.58643206844,1.4594575405,1.05824808679,2.15430437126,1.72895448547,-0.432140757295,-1.14248757506,-0.617100635289,-0.901356750927,0.199195164038,-0.602413519305,-0.311612151118,-0.238097995548,0.277463095667,-0.470775459256,0.116772247262,-0.164416893425,1.2715198596,0.0709579636745,0.482379037227,0.437068559613,0.82478651129,-0.411515258773,-0.222501471087,-0.0726149520941,-0.11110658169,-0.621573393959,-0.324402827376,0.31169673126,-0.0339876237257],[-36711.0831574,838.58088479,-812.351802452,-1892.4388749,2286.78197445,1411.76272338,-666.592692802,-1428.70019721,384.260797413,-469.23154945,-1301.83471016,1027.29828598,-637.187221949,69.4643100764,-221.795495071,688.032450528,-832.373985696,518.044975586,496.613100029,-42.7953488002,180.750787921,-464.963323093,228.10325534,477.132781931,-210.635577992,-142.883431499,-116.132298884,94.2105951025,196.360799638,-32.576035403,-38.2456768645,15.2270118177,-36.6000992423,-22.070725787,-234.414161379,-102.436916356,-40.51644734,39.79369554,-11.3216553665,55.6799079264,-2.26285075832,-8.21336479664,26.7701436919,-156.062136606,5.51081875946,-79.9346139707,-73.5679452614,-96.3343164138,-4.23592978009,1.41300689042,-7.2344920503,22.5160645554,16.9805980961,11.198997419,-5.32685460119,11.1924112328,-29.4211905084,18.3558834709,1.24526006144,-3.82623769705,-21.3480060824,24.5460875729,25.335254625,-0.0360443876597,2.45328968156,-5.1037238765,0.068493613759,-0.258744310966,9.12128552298,-2.60656368631,-1.51701732982,-0.461901976641,10.9658640985,4.51288803229,0.443583641394,-2.58354196052,10.8490285969,7.07334948279,-2.54542468979,-3.03137935758,1.01807770464,-1.05106361566,-0.0412521363273,-0.771704336258,0.439157779652,-0.425847993122,0.717497339195,-1.48091272128,1.53079549762,1.97832083364,2.53239367201,1.37925879566,1.04512541701,1.98189174105,1.71472008553,-0.450383045517,-1.12694005323,-0.639421379405,-0.919822402333,0.197599344236,-0.585119504904,-0.321004427683,-0.245054549486,0.290419197894,-0.487952390842,0.102002724998,-0.17849275114,1.22771872788,0.058628880564,0.447448465446,0.411844379429,0.816655848808,-0.478414557122,-0.229189918271,-0.0846847131221,-0.106723658918,-0.644054209793,-0.340006421358,0.311615507174,-0.0326960242154],[-36663.3978113,803.184750208,-662.264186839,-1943.44169561,2325.64510204,1372.25849371,-679.679206626,-1428.81658393,408.764674659,-446.057811411,-1260.46995345,1029.37296568,-629.088106638,106.057127122,-223.12799844,681.304883892,-826.537772645,502.276514829,492.898115778,-30.6949646675,212.470340752,-453.150244974,229.362368949,471.872366983,-215.569500543,-153.578171773,-113.1670124,90.2887870788,202.189089258,-26.9465945984,-40.7342056702,11.1189783817,-38.8329522893,-30.1578249375,-229.756074556,-101.595004289,-41.9607269149,39.7974830825,-6.18087618029,58.1798257822,-3.28459540859,-11.6365873794,24.2377865714,-155.702400554,0.123880071769,-77.6583286886,-72.2319462126,-92.2196688413,-3.19154497828,1.52622491951,-6.9458868086,23.5025547497,17.2723304565,10.5519871778,-7.09910423055,10.5398488944,-29.1395878013,17.6236060273,1.91838129326,-3.38798759836,-20.0479531502,24.0405184175,24.6074971627,0.203720680918,2.39899965055,-4.69910050906,0.0633666665129,-0.419115074267,8.84190491917,-2.89910856559,-1.74877154151,-0.831857858675,10.9742904237,4.43552756222,0.316050255616,-2.53855081758,10.4672187755,6.89623553313,-2.63010279771,-2.93353454705,1.06463714767,-1.03271357804,0.0566935548771,-0.790378203819,0.404823342959,-0.517471820417,0.701236619586,-1.53931806744,1.39055236722,1.93301203873,2.47004629406,1.30949018329,1.00437713684,1.80187552903,1.68400742141,-0.458867980434,-1.10804359767,-0.656584448195,-0.940715611066,0.194616187662,-0.567757070864,-0.334208373451,-0.251655943901,0.301671897765,-0.502293452094,0.0884887082167,-0.192409388776,1.18358717585,0.0484918794893,0.411722842761,0.388048858561,0.803884155849,-0.543426845714,-0.23670937001,-0.0943877613851,-0.101059067483,-0.66330674684,-0.358256664085,0.310378723677,-0.0309213788817],[-36631.1495078,768.538088214,-513.109121139,-1993.98323981,2366.02501801,1338.71175334,-686.947207631,-1430.67844374,432.437232419,-418.94911004,-1214.93355046,1029.5341836,-621.41828228,139.391045401,-224.398164743,673.224917958,-820.432632395,484.718769514,483.701895054,-18.5370738875,243.616784331,-439.01212744,227.901312211,461.942670077,-220.00733152,-165.135450979,-109.487908953,84.9274822462,209.55623188,-21.0908662285,-43.442603283,6.91931807218,-43.4322578204,-38.0827987103,-224.978825218,-100.574104207,-43.3572517323,39.9521184541,-0.881452454971,61.3106449418,-4.41770815284,-15.0796896589,21.5619082122,-155.236777348,-5.34182093958,-75.2472874452,-70.6143235206,-88.0666800238,-2.10030007936,1.6978343829,-6.5272544774,24.4892047829,17.6387501864,9.79125405509,-8.80728113527,9.93557683746,-28.7677505497,16.9239689823,2.53708302508,-2.8044454463,-18.8971678776,23.4347501741,23.7081867948,0.458415881778,2.34538933126,-4.26346079828,0.0716778751049,-0.579755736928,8.53236117286,-3.14438868448,-1.95946077197,-1.16409549493,10.9871832362,4.33216068608,0.250939830598,-2.57024060948,10.0509131012,6.66527638105,-2.69395547389,-2.83264737508,1.10675641051,-1.01380686711,0.151615561783,-0.80659917181,0.361936798,-0.604965769452,0.697207532253,-1.59398572902,1.2617105426,1.89415113092,2.4010992557,1.24968601156,0.936432519106,1.61630375865,1.63559359258,-0.457725944037,-1.08729920946,-0.668150868523,-0.963788787548,0.190587739886,-0.550098949762,-0.350732428153,-0.258023994047,0.311018384141,-0.513624350012,0.0758156327609,-0.205831353565,1.14012473879,0.0408809915714,0.37633652177,0.365220927186,0.787075746541,-0.606192112103,-0.245166831803,-0.101563250922,-0.0948130500375,-0.679012066478,-0.378831152254,0.30786603343,-0.0287904971137],[-36616.6542175,735.998755644,-365.728032322,-2043.39408922,2407.42044172,1310.19988714,-688.723460052,-1433.02688166,455.833536797,-388.416359469,-1165.50989731,1027.9535883,-613.926423963,168.805553215,-226.635060927,663.917106438,-814.176220773,465.888851765,469.311692992,-6.11305551815,273.870517216,-422.696956117,223.79494538,447.244820773,-223.999028875,-177.498526629,-104.947161412,78.1328097668,218.424069395,-15.0679361453,-46.1771885525,2.62702304456,-50.4022275882,-45.8467340153,-220.256097303,-99.3936309606,-44.7296773924,40.2851908218,4.50329712772,65.0557311581,-5.66441201445,-18.398494545,18.7424162843,-154.671065173,-10.8677598109,-72.7863962233,-68.7329292611,-83.9259828079,-0.974817366678,1.91557378215,-5.99445167132,25.4587055997,18.0732888822,8.92287855042,-10.4115069207,9.38195928981,-28.2990325504,16.2537385744,3.07425258833,-2.07579227016,-17.9152630681,22.7361954915,22.6376655554,0.726556100805,2.29208048578,-3.80527823999,0.0895638081971,-0.741553591547,8.19569617427,-3.3384695099,-2.14611851881,-1.44931829798,11.0043808343,4.20160464725,0.248898043909,-2.67824174804,9.60491746412,6.37859514321,-2.73592529733,-2.73006693573,1.14505703969,-0.993880276742,0.242349884819,-0.821066901136,0.310613849833,-0.687142586867,0.704622630095,-1.64381414192,1.14779279128,1.8623699751,2.32725470743,1.19944232943,0.842260088153,1.42714310751,1.5687261247,-0.447126497063,-1.06593709985,-0.673790479381,-0.988656865261,0.185847658369,-0.531958668911,-0.370032488425,-0.264203749831,0.318311119636,-0.521781965437,0.0636431612855,-0.218344707981,1.09813071941,0.0360696933984,0.342331221036,0.342983489659,0.766840606324,-0.666375916776,-0.254598899892,-0.106073351506,-0.0885452268257,-0.690911527218,-0.40127590019,0.303971871821,-0.0264169607549],[-36615.9532581,703.965577808,-221.72933447,-2090.62485101,2449.10059895,1285.79326887,-685.552947348,-1435.32117584,479.24035667,-354.97200734,-1112.84795067,1025.14009334,-606.793055387,194.44117165,-229.526588075,653.653482228,-807.588434602,446.017958572,450.653099685,6.47097796884,302.992551561,-404.591595566,217.290172544,428.053912846,-227.513745937,-190.411378543,-99.5286731752,70.0782627433,228.534409658,-8.92838737121,-48.9600597227,-1.78016269128,-59.5210418663,-53.4614504737,-215.701374249,-98.0608094335,-46.0701542571,40.8161117596,9.87510752411,69.333318087,-7.01370914918,-21.5334902732,15.7617482934,-153.984325707,-16.3994278953,-70.3172948468,-66.6377341957,-79.8172524532,0.163386463105,2.16600243319,-5.36146986147,26.3814959791,18.5620443866,7.96105468531,-11.8962942343,8.86898624477,-27.734295812,15.6157621402,3.52032885973,-1.21654580968,-17.0944272743,21.95294592,21.4105568108,1.0020337538,2.23792307239,-3.33219780147,0.111516063648,-0.904494531649,7.83588345355,-3.48434236482,-2.30734553863,-1.68697212056,11.0254334023,4.04637124899,0.307418620739,-2.85183476596,9.13361852199,6.03942727809,-2.75376041861,-2.62559470767,1.17937143796,-0.97276223293,0.328148888517,-0.833835592014,0.251837704885,-0.762967684829,0.721706670452,-1.68688397136,1.04852827412,1.83752830911,2.25018611709,1.15860214909,0.724985374426,1.23603486971,1.48453424798,-0.427395915246,-1.04410432086,-0.673608368288,-1.01438486992,0.180696048144,-0.513312934574,-0.391354278513,-0.269933199781,0.32362366188,-0.526647874585,0.0519278636935,-0.229221575446,1.05760349005,0.0340892434275,0.310378122984,0.321295347059,0.743811405873,-0.723746111941,-0.264760533464,-0.10787229584,-0.0822527284487,-0.698987676119,-0.42461059272,0.298649805154,-0.0238614414671],[-36623.5192843,670.097622137,-82.9131884454,-2134.53113868,2490.27734205,1264.56051956,-678.035207781,-1437.20014767,502.877386603,-319.128884672,-1057.68780734,1021.68692848,-600.306662411,216.638679989,-232.425355805,642.742948018,-800.414730956,425.265808142,428.811288962,19.0302307483,330.764052916,-385.142630081,208.67690875,404.738531131,-230.500434882,-203.568167123,-93.249280274,60.9791752635,239.574052016,-2.72067722116,-51.867259886,-6.32980716181,-70.5103730585,-60.9414508842,-211.413089368,-96.5798170164,-47.3629563792,41.5622484435,15.1294771,74.0453563605,-8.45129649593,-24.4463314106,12.5979742043,-153.148936501,-21.8733205,-67.8708065994,-64.3867387574,-75.7524248227,1.29057111002,2.4353848556,-4.64183423303,27.2249516591,19.0892811041,6.92200486185,-13.2522534839,8.383554137,-27.0762793958,15.0144072908,3.87013860237,-0.244807982236,-16.4199929864,21.0932627351,20.0450542609,1.27758563905,2.18157409843,-2.85165731787,0.131614996614,-1.06833910099,7.45712945085,-3.58673003624,-2.4421344028,-1.87868842544,11.0498190961,3.86989593452,0.423207298188,-3.07771272613,8.64129812444,5.65228632961,-2.74491038127,-2.51864526565,1.20933472214,-0.95035406967,0.40836902844,-0.844798079487,0.186808444921,-0.831444641885,0.746437461769,-1.72107143997,0.962697750344,1.81929283905,2.1715597819,1.12707022355,0.588273159891,1.04453899351,1.38461761882,-0.398899653067,-1.02167713468,-0.667818434893,-1.0399003503,0.175424626138,-0.494179247751,-0.413890979565,-0.274873567078,0.327084842256,-0.528114827516,0.0407005366997,-0.237655594623,1.01834119046,0.0349103455832,0.281055776004,0.300199274643,0.718626487175,-0.778096122737,-0.275336282446,-0.106937332358,-0.0757920630978,-0.703283357375,-0.447723332302,0.291868182462,-0.0211713833667],[-36633.8249507,632.053956059,48.9202448903,-2173.96856577,2530.16252341,1245.57026022,-666.769779612,-1438.30261856,526.964321164,-281.399822483,-1000.76956412,1018.1873235,-594.755730891,235.738857513,-234.683973735,631.494406499,-792.400566908,403.792118681,404.871434656,31.3799069949,356.966186831,-364.796643954,198.245069048,377.667260462,-232.908047886,-216.663052768,-86.1258187391,51.0508814153,251.229795817,3.50673698985,-54.9748321347,-11.0494783935,-83.0918935684,-68.3012380456,-207.489675975,-94.9548310998,-48.592357811,42.5409680492,20.1619042214,79.0937966103,-9.96287099359,-27.098672524,9.22916398184,-152.137275105,-27.2259329322,-65.4777547653,-62.0379433793,-71.7434357793,2.38299627411,2.7099855689,-3.8490699712,27.9564483774,19.639263439,5.82195148216,-14.4699950775,7.91255940116,-26.327722363,14.4540416372,4.1185085793,0.821319294824,-15.8772926942,20.1654072124,18.5593516051,1.54594855483,2.12169057123,-2.37109462433,0.143940962253,-1.23284784332,7.06364060631,-3.65035531115,-2.54947768268,-2.02609867539,11.0770160718,3.67561414708,0.592969813353,-3.34256869144,8.13223812113,5.2216858417,-2.7068247288,-2.40863318447,1.23458200901,-0.926557120963,0.48236676015,-0.853847198601,0.11672615171,-0.891577036583,0.776792812495,-1.74425277033,0.889081979181,1.80733027101,2.09304199907,1.10475130581,0.435788226515,0.854215427142,1.2705758936,-0.362003165009,-0.998531803497,-0.656634578844,-1.06413085519,0.170325109278,-0.474575109442,-0.436835772731,-0.278686074905,0.328823492151,-0.526075574287,0.0299919770192,-0.242840404173,0.980141960385,0.0385037037898,0.254942728484,0.27973804767,0.691924192216,-0.829219374305,-0.286010696765,-0.103245709498,-0.0690197389642,-0.703841415181,-0.46950222139,0.283595352776,-0.0183942305701],[-36641.3429118,587.493647002,171.970804675,-2207.79274579,2567.96799539,1227.89111187,-652.356201103,-1438.26740991,551.720854919,-242.297651791,-942.833317795,1015.23450817,-590.428746684,252.082483504,-235.655051483,620.21676036,-783.291399532,381.756608395,379.918710597,43.3352108836,381.380118857,-344.000221479,186.284568484,347.208685672,-234.685537123,-229.390195878,-78.1751246011,40.5087152865,263.188440406,9.70539794684,-58.3588195612,-15.9667444128,-96.9872757999,-75.5553147567,-204.029567381,-93.1900290745,-49.7426326051,43.7696377527,24.8678872539,84.3805894683,-11.534129581,-29.4521681803,5.63338759069,-150.921719071,-32.3937604991,-63.1689626283,-59.6493484946,-67.802221186,3.4169216554,2.97606909267,-2.99670226119,28.5433618717,20.1962557957,4.67711694833,-15.5401294231,7.4428984719,-25.4913637752,13.9390327906,4.26026555358,1.96373410413,-15.451658888,19.1776406273,16.9716425432,1.79985929943,2.05692949815,-1.89794755599,0.142574315721,-1.39778130241,6.65962336008,-3.67994097654,-2.62836794963,-2.1308343332,11.1065024854,3.46696132989,0.813411903334,-3.63309572479,7.61072036168,4.75213935828,-2.63695300473,-2.2949730389,1.25474841538,-0.901272720809,0.549498539206,-0.860875784397,0.0427909070192,-0.942368447471,0.810750531075,-1.75430418503,0.826461719847,1.80130731107,2.01629906579,1.09155014889,0.271195356265,0.666624118862,1.14400872871,-0.317071905552,-0.974544589516,-0.640270699791,-1.08600393334,0.165689214489,-0.454518020648,-0.45938183916,-0.281031946443,0.328968442949,-0.520422864958,0.0198329813669,-0.24396964276,0.942803939588,0.0448400219719,0.232617528813,0.259954441399,0.664342862983,-0.876909291784,-0.296468326347,-0.0967746756935,-0.0617922642389,-0.700704693731,-0.488835362441,0.27379966513,-0.0155774271939],[-36641.5774866,534.559078309,284.92674354,-2235.32420205,2602.98799593,1210.78063658,-635.59000819,-1436.81468513,577.155706263,-202.230006612,-884.517616204,1013.32658467,-587.565892054,266.055255532,-234.737876844,609.136988904,-772.806411697,359.270566527,355.00288292,54.6642084159,403.776385695,-323.243867361,173.071057422,313.774759461,-235.793944703,-241.450773627,-69.448468921,29.5710764625,275.124654048,15.8187696036,-62.113580996,-21.1089041185,-111.890534938,-82.7097963144,-201.1141942,-91.2879591895,-50.8010973094,45.2559472401,29.1530221758,89.8060590002,-13.1485964142,-31.4843103113,1.79245981711,-149.475493705,-37.3120247072,-60.9749525473,-57.2786239316,-63.9362628388,4.37130423031,3.21929047062,-2.09813704571,28.9568451488,20.7460116535,3.50590955012,-16.4574353394,6.96254333955,-24.5721516745,13.4743789563,4.29102057527,3.16235239317,-15.1259696994,18.1389754474,15.3023062575,2.03264746624,1.98567924741,-1.43872156948,0.122070008995,-1.56237548616,6.24972945891,-3.68052369083,-2.67790797939,-2.19628550992,11.1377850439,3.24673200044,1.08040199494,-3.93611056256,7.0810628033,4.24917610871,-2.53323413251,-2.17705949478,1.26951153295,-0.874488940761,0.609394289813,-0.865933463765,-0.0337789739208,-0.982989465538,0.846384626718,-1.74928593205,0.773136628096,1.80076782623,1.94269223269,1.08736830507,0.0981316826987,0.483296666572,1.00688603751,-0.264519428634,-0.949503178383,-0.618986964817,-1.10445766064,0.161777064809,-0.434019843831,-0.480767793064,-0.281673791959,0.327624112626,-0.51113663355,0.0102910836283,-0.240329198095,0.90608309491,0.0538432012578,0.214541217991,0.240969410193,0.636446753947,-0.920971603164,-0.306361370309,-0.087530040265,-0.0539647042193,-0.693951005763,-0.504679339924,0.262483670306,-0.0127778943531],[-36634.1596509,473.325896968,388.42996809,-2257.74309702,2634.8463053,1194.2521607,-618.050727493,-1433.98997577,602.4336889,-161.183732941,-826.054811285,1012.58114475,-586.214134897,278.222544313,-231.518450317,598.154377872,-760.559689452,336.251566458,331.032086982,64.9464128999,423.883008649,-303.193767951,158.823127496,277.950906006,-236.242672469,-252.574030285,-60.1348628797,18.4686265185,286.664580665,21.7580009892,-66.4067382213,-26.5021798989,-127.385057291,-89.7372480084,-198.756976247,-89.2446531266,-51.7672384531,46.9688762396,32.9632954145,95.2640230072,-14.7811045174,-33.2359403074,-2.29682526686,-147.775215348,-41.91085186,-58.9250431812,-54.9821171006,-60.1352262666,5.23589008077,3.42286684325,-1.16630329763,29.1831602906,21.2802407913,2.33548112797,-17.2333652889,6.463768217,-23.583870027,13.0676007168,4.20952184232,4.38916156879,-14.8732858278,17.0614289081,13.5804638605,2.24001382911,1.90525363083,-0.996192607329,0.0788813813294,-1.72376825917,5.840391876,-3.65839559811,-2.69764136534,-2.23287690975,11.1704846583,3.01515697316,1.38645927386,-4.23892463512,6.54772783346,3.72238806416,-2.3955645555,-2.05420758213,1.27871885295,-0.846540802589,0.662777810734,-0.86969703096,-0.111692242021,-1.01327873154,0.882153911682,-1.7279943608,0.725481945823,1.80476432709,1.87236256397,1.09209452386,-0.0798762542692,0.305651266821,0.862658761223,-0.204951686008,-0.922840949586,-0.593228610748,-1.11847222134,0.158722407716,-0.413069887318,-0.500413980908,-0.280779770056,0.324797265533,-0.498545549936,0.00158076637119,-0.231573954092,0.869566701557,0.0652499315924,0.200704807455,0.223216624835,0.608503769521,-0.961261247838,-0.315212624524,-0.0756318560639,-0.0453863526264,-0.683798038194,-0.516264666367,0.249786726087,-0.0100904611575],[-36619.7520452,404.353065881,483.610798425,-2276.69450296,2663.24908933,1178.50795162,-601.513883308,-1429.92015537,626.508640362,-119.040479774,-767.575706007,1013.02065254,-586.372139519,289.194638854,-225.629450582,587.086289618,-746.139044643,312.568752605,308.879050443,73.7141994704,441.417380174,-284.560030012,143.745105653,240.365917346,-236.053212201,-262.496226897,-50.4577526883,7.43509252759,297.422233096,27.4261624013,-71.4242287573,-32.1725250146,-143.026571948,-96.6018476265,-196.954330637,-87.0545134259,-52.6435850609,48.8677269898,36.2547910098,100.646672724,-16.4043141321,-34.7637369237,-6.63392876768,-145.798348098,-46.1190944604,-57.0482522636,-52.8158448072,-56.3843229311,6.00312256511,3.5694058752,-0.214010747325,29.212346648,21.7921420629,1.19516940998,-17.8835401452,5.9399228728,-22.5425117798,12.726849249,4.01530183968,5.61416690265,-14.6642136142,15.9577694368,11.8374219477,2.41825195697,1.81269782113,-0.572204233584,0.009936368797,-1.87857295019,5.43848889117,-3.62016271391,-2.68722190522,-2.25279188517,11.2042507908,2.77182613674,1.72326561546,-4.52897304634,6.01521394717,3.18238288123,-2.22433009698,-1.92571242204,1.28226034152,-0.817850065616,0.710646369376,-0.873000072084,-0.18963941473,-1.03324189866,0.916613398985,-1.68940984607,0.679391811457,1.81222648517,1.80514607727,1.10561435407,-0.259329563133,0.135077765818,0.71514809807,-0.139022728881,-0.893902706068,-0.563487141844,-1.12703832679,0.156627396799,-0.391651820897,-0.517786182219,-0.278619426422,0.320470252612,-0.483065467947,-0.00604675066612,-0.217451043714,0.832799861829,0.0787501001242,0.190981801251,0.207207935212,0.580707726603,-0.997645468051,-0.322512534057,-0.0612287368251,-0.0359050602876,-0.670498446484,-0.52289033631,0.235882392009,-0.00761943371559],[-36599.0173095,328.199547951,571.599554644,-2293.82349213,2687.90251386,1163.75027676,-587.75499993,-1424.73209749,648.33439818,-75.6818961031,-709.21110334,1014.6675722,-588.038570225,299.581828159,-216.703556314,575.750086496,-729.132289113,288.091269384,289.416500966,80.4999432625,456.096892723,-268.052760306,128.041318844,201.648585525,-235.247055677,-270.953624508,-40.6405845578,-3.29579843752,307.011624179,32.7263241378,-77.3519901243,-38.1458927263,-158.370808,-103.267772956,-195.702674485,-84.7119426276,-53.4326661573,50.9118017292,38.9835930015,105.846199387,-17.9908854995,-36.1243789156,-11.2183117918,-143.522356052,-49.8656050111,-55.3735975283,-50.8358238571,-52.6687642942,6.66544504164,3.64151523114,0.74593087482,29.0344435718,22.274914322,0.114312124255,-18.4235807816,5.38435707552,-21.4640698799,12.4602757299,3.70789305229,6.80737366645,-14.4693593996,14.840765461,10.1044871143,2.56365541879,1.70505699103,-0.168600012269,-0.0878370925287,-2.02340288795,5.05089878423,-3.57243105373,-2.64630339679,-2.26821378869,11.2387329035,2.51632937988,2.08250289515,-4.79369090006,5.48801963947,2.63976821651,-2.01991658026,-1.79086913558,1.28002596479,-0.788838489164,0.753997233144,-0.876676173238,-0.266311009495,-1.0428846201,0.948318101646,-1.63251276266,0.630760363428,1.82208397196,1.74087879022,1.12781334448,-0.436729352386,-0.0270339902276,0.568175246251,-0.0673866084609,-0.862033250774,-0.530254062366,-1.12914668835,0.155594185647,-0.369749314356,-0.532350176524,-0.275462306745,0.314625424805,-0.46511224142,-0.0123402477453,-0.197707599925,0.795327678022,0.0940335940021,0.185245703428,0.193455191212,0.55325244209,-1.02999150604,-0.327751543972,-0.0444692962837,-0.0253686780301,-0.654304886094,-0.523855344296,0.220944227605,-0.00546911813588],[-36572.6180843,245.424306078,653.526556844,-2310.7751368,2708.51274472,1150.18140352,-578.549601652,-1418.55267569,666.864799886,-30.9896309218,-651.091806252,1017.54436786,-591.212091319,309.994401234,-204.373446193,563.963130858,-709.127234707,262.688261211,273.51716621,84.8360194109,467.638938752,-254.382065598,111.916094017,162.427702584,-233.845694674,-277.682484163,-30.9068046993,-13.4903193039,315.046766755,37.5615564965,-84.3759598425,-44.4482362946,-172.973494536,-109.699201786,-194.998424905,-82.2113432716,-54.137010767,53.0604026965,41.1057854292,110.754794229,-19.513478861,-37.3745450383,-16.0494354458,-140.924703308,-53.079236015,-53.9300967089,-49.0980710558,-48.9737618178,7.21530086868,3.62180257574,1.70071183842,28.6394904128,22.7217564223,-0.877753001115,-18.8691080714,4.79042059369,-20.3645372742,12.2760313361,3.2868279651,7.93878713187,-14.2593295251,13.723185408,8.41296595564,2.67251778351,1.57937631325,0.212776492587,-0.217511066574,-2.15487140121,4.68449983498,-3.5218066331,-2.57453963779,-2.29132597279,11.2735804585,2.24825659127,2.45585298831,-5.02051330016,4.97064340538,2.10515172661,-1.78270982864,-1.64897284382,1.27190568888,-0.759927832557,0.793827669444,-0.881558920521,-0.340397543763,-1.04221254905,0.975823032682,-1.55628348533,0.575481740165,1.83326645897,1.67939672043,1.15857704389,-0.608576730524,-0.179294155105,0.425561403973,0.00930262404387,-0.826577386647,-0.494020876574,-1.12378801736,0.155724927849,-0.347346037484,-0.543571743352,-0.271577956712,0.307245133054,-0.445101724187,-0.017048505128,-0.172090755688,0.756695252437,0.110790300375,0.183370018031,0.182470242723,0.526331732881,-1.05816660406,-0.330420099331,-0.0255021481747,-0.0136250566811,-0.635470012484,-0.518458684866,0.205145792411,-0.00374382052686],[-36541.4440486,156.372358845,730.493854522,-2328.46070597,2724.88543354,1137.94419197,-575.565754658,-1411.33826056,681.264246309,15.1137089759,-593.392765996,1021.58561754,-595.905920332,320.844910767,-188.28085278,551.516524364,-685.801135485,236.260044966,261.931517042,86.3140256072,475.776988467,-244.124052258,95.580472574,123.30648752,-231.902435666,-282.467150045,-21.4706594192,-22.9150829649,321.188010571,41.84731978,-92.6495760137,-51.0820738081,-186.444844853,-115.863446126,-194.814993099,-79.5601512049,-54.7611238696,55.270649686,42.596092359,115.271953179,-20.938614016,-38.5711781111,-21.1107114598,-137.995370658,-55.6947798579,-52.7349562682,-47.6410889693,-45.2836711357,7.64727931077,3.49447472337,2.63980019945,28.0227308201,23.1269596628,-1.75181083683,-19.2342259964,4.15566502358,-19.2615487552,12.1848411116,2.75484815216,8.98535211343,-14.0061266219,12.6177253541,6.79360756348,2.7426696957,1.43281019508,0.570677462165,-0.381300583276,-2.26939789581,4.34612464304,-3.47324069961,-2.47146888689,-2.33294403246,11.3098105023,1.96773075953,2.83670767587,-5.19798922574,4.46769185198,1.58950687259,-1.51391790717,-1.4993214407,1.25803322721,-0.731675451446,0.831011341874,-0.888618295352,-0.410567911464,-1.03140067298,0.99815002505,-1.46007931708,0.510226948252,1.84511772923,1.62040598048,1.19798956106,-0.771424931216,-0.320354952518,0.291136269327,0.0902756556805,-0.786768498777,-0.455274094495,-1.1102783495,0.157113268765,-0.324469018477,-0.551057759572,-0.267318430379,0.298346190064,-0.423540571761,-0.0199399327368,-0.140541190494,0.716638257707,0.128715113462,0.185132307533,0.174754768412,0.500168023805,-1.08199909526,-0.329998742577,-0.00453919657001,-0.000476597005733,-0.61423365959,-0.50621685853,0.188690818565,-0.00250934912645],[-36507.2930384,60.5329475519,803.490414751,-2344.85625562,2737.22417511,1126.94387281,-580.041692679,-1402.36321086,691.539391461,62.5416855938,-536.465526962,1026.37435469,-602.191487705,331.75496418,-168.103724169,538.096325895,-659.189014375,208.831627373,254.920997144,84.7624497694,480.308823083,-237.318825104,79.2723537285,84.785867144,-229.597843905,-285.284298893,-12.5095954055,-31.3380621782,325.28105302,45.5486343101,-102.196279066,-57.9561826674,-198.613009076,-121.740354884,-195.033766625,-76.8179355012,-55.3174142647,57.4909327152,43.5037979624,119.326390929,-22.2082489959,-39.7722772108,-26.3213540591,-134.774405678,-57.6707884585,-51.7581375844,-46.4333232055,-41.5794245692,7.96455325725,3.25013508733,3.56177515934,27.2002256353,23.4891851228,-2.47913664884,-19.526970971,3.49444927224,-18.1793064963,12.2077255674,2.12753154402,9.95177159695,-13.6873384823,11.536791971,5.27493101573,2.77809010244,1.2629499821,0.906238058496,-0.577992536605,-2.36262608597,4.04242308715,-3.42506542918,-2.33616724633,-2.39841253276,11.3539104183,1.67700727301,3.22529836092,-5.31912315693,3.98420403455,1.10527033339,-1.21803784784,-1.34122391151,1.23951728228,-0.705181086799,0.865927498798,-0.899369860415,-0.475404512449,-1.01130131645,1.01618819145,-1.34476527358,0.434774466879,1.85863801178,1.56309306275,1.2469292445,-0.922035688828,-0.449036885816,0.168763539941,0.174302126514,-0.741394300836,-0.414480249222,-1.08923501776,0.159818820844,-0.301318719161,-0.554979491424,-0.26336581527,0.288083255588,-0.401298646371,-0.0208614591387,-0.103773769938,0.675654647813,0.147522955769,0.189926368099,0.170769762059,0.475098171425,-1.10116167641,-0.325928405659,0.0179544931106,0.0144561004797,-0.590784375246,-0.48751638968,0.17190372863,-0.00167752069035],[-36472.1899281,-42.8186308197,873.476934005,-2357.20403847,2745.83205003,1117.0262694,-593.108191336,-1390.73138239,697.90745265,111.166903135,-480.705781821,1031.40572665,-610.154777105,342.148432578,-143.529062342,523.36233364,-629.415336517,180.459187618,252.624793405,80.0690023719,481.04830157,-233.872488559,63.2363511466,47.341195223,-227.144299339,-286.158690588,-4.19185944179,-38.5275696678,327.217928403,48.6429104136,-113.007010009,-64.9559051009,-209.360621539,-127.312911188,-195.513127123,-74.0572985408,-55.8202667072,59.6674593575,43.896826437,122.854126867,-23.25820139,-41.0361054781,-31.5845280929,-131.314372637,-58.9717536185,-50.9577907648,-45.4257051322,-37.8410986114,8.17244150368,2.88098623061,4.46749370586,26.1932399982,23.8081863266,-3.03112830187,-19.7538625179,2.82533407443,-17.1436545163,12.3682790818,1.42366516034,10.8496881111,-13.2819491884,10.4927195794,3.88489788679,2.7842950264,1.06749625447,1.22118918882,-0.805516786546,-2.430005763,3.77999936585,-3.3739582298,-2.16759527928,-2.49170828126,11.4137351746,1.37887462002,3.62356635209,-5.37803344913,3.5253271204,0.665244592406,-0.900388924415,-1.1739920144,1.21771030387,-0.681680075914,0.898831784773,-0.915465573709,-0.533468123055,-0.982936138299,1.03129346451,-1.2115832987,0.349679643395,1.87524164717,1.50651455456,1.30647300268,-1.0572228629,-0.564202528264,0.0623154133272,0.260036414864,-0.689131088641,-0.372100879616,-1.06160067946,0.163892688304,-0.278138959768,-0.55564930249,-0.260484707274,0.276645451141,-0.379336611922,-0.0196796425612,-0.0626969061437,0.634432947073,0.166933756872,0.19705005432,0.170966046222,0.451487640235,-1.1152881352,-0.317640117902,0.0414505651104,0.031597885321,-0.565297885761,-0.462961308675,0.155139117773,-0.00112165410371],[-36438.1595927,-154.407079289,941.414108753,-2362.74630725,2751.01213889,1108.03720511,-615.896026251,-1375.54663094,700.585647185,160.861965804,-426.509223244,1036.17488073,-619.881772199,351.449187066,-114.243869278,506.974345787,-596.604567053,151.198904888,255.182092711,72.1213938894,477.809282896,-233.69114705,47.7170784946,11.447825523,-224.754181916,-285.115085007,3.31430168863,-44.2519181575,326.890671022,51.1075584172,-125.072709853,-71.9665833372,-218.570316575,-132.564098168,-196.111456237,-71.3508427042,-56.2840659518,61.7464371861,43.8431019804,125.791180377,-24.0242887877,-42.4209260539,-36.8033984102,-127.667835807,-59.5621671396,-50.2920659167,-44.5691661177,-34.0487697556,8.27626284564,2.37923071622,5.35781282681,25.0230390485,24.0837167988,-3.37918366067,-19.9214201596,2.16688016492,-16.1804368341,12.6900960327,0.662036020764,11.6907441846,-12.7689428227,9.49784249963,2.65146975107,2.76680049028,0.844149592365,1.51726176038,-1.06180319308,-2.4669867182,3.56545767771,-3.31659650946,-1.96471354888,-2.61680808551,11.4971397388,1.07612128883,4.03345295801,-5.36883845772,3.09620827685,0.282232133026,-0.566290410639,-0.996937507515,1.19396474174,-0.662407756087,0.929979844355,-0.938557393236,-0.583319519614,-0.947326797352,1.04482177688,-1.06177533632,0.255497825143,1.89634297597,1.44972704324,1.37769774407,-1.17380031299,-0.664714453122,-0.0243359130006,0.346132899051,-0.628655158008,-0.328597524536,-1.02831799192,0.169385975365,-0.255173560529,-0.553379556353,-0.259439702282,0.264221898239,-0.358615132323,-0.0162610412323,-0.0182190112325,0.593661679804,0.186667446347,0.205801220786,0.175794443463,0.429701894728,-1.12401225932,-0.304564908633,0.0654206636729,0.051373607064,-0.537949917444,-0.433155645875,0.138751581162,-0.000715068251674],[-36407.2269067,-274.957100874,1008.26263547,-2358.72531467,2753.06752227,1099.82250331,-649.535973044,-1355.91281231,699.791192376,211.499477802,-374.271543904,1040.17696428,-631.458456652,359.081098748,-79.9351469559,488.592160523,-560.881171127,121.106958368,262.73208195,60.8073347965,470.40562603,-236.680905002,32.9591494388,-22.4188881895,-222.639871581,-282.178242029,9.84064120229,-48.2794203713,324.191315178,52.9199886474,-138.384319607,-78.8735596048,-226.124728516,-137.476898953,-196.687135611,-68.7711703717,-56.7231967533,63.6740737745,43.4105487905,128.073570846,-24.4423287783,-43.9850020791,-41.88112986,-123.887359457,-59.4065208237,-49.7191131472,-43.81463753,-30.182514495,8.28133607869,1.73707110716,6.23358950995,23.7108879261,24.3155300637,-3.49470058999,-20.0361634189,1.53764827847,-15.3154974685,13.1967707984,-0.138568855042,12.486582346,-12.1273034675,8.56449505238,1.60260818296,2.73112251675,0.590610575934,1.79618668042,-1.34478161619,-2.46901874289,3.40540222124,-3.24965767617,-1.72648261829,-2.77768875308,11.611979079,0.771535767748,4.4568994873,-5.28565653809,2.70199467122,-0.030964561349,-0.221061580263,-0.809372149,1.16963304567,-0.648599464616,0.959627322101,-0.970297276996,-0.623519478461,-0.905494952447,1.05812906118,-0.896583330313,0.15278435947,1.92335633873,1.3917871161,1.46168037714,-1.26858189862,-0.749435233655,-0.0873182415301,0.431245957394,-0.558642804755,-0.284431722842,-0.990329612441,0.176349786245,-0.232666341678,-0.548482616594,-0.260995396184,0.251001718396,-0.340094871478,-0.0104722133796,0.028751502673,0.554029370323,0.206443953769,0.215477722088,0.18570577634,0.4101063994,-1.12696783644,-0.286133807178,0.0893364330412,0.0742081152544,-0.508916196605,-0.398703431641,0.123095713965,-0.000331082019385],[-36381.1547771,-405.075741115,1074.83963097,-2342.77439927,2752.52501485,1091.92978077,-694.681044428,-1331.09582246,695.749811129,262.834720853,-324.280088816,1042.9310779,-644.878228949,364.723119723,-40.6602779561,468.006725516,-522.509098949,90.3262502091,275.28533878,46.1370560777,458.762089596,-242.669294039,19.212707223,-53.9005111172,-220.961768292,-277.418618111,15.2475161678,-50.4283419083,319.081160748,54.0676445896,-152.88132011,-85.5416771619,-231.967544692,-142.018832579,-197.087991721,-66.3815651006,-57.1428678339,65.402303284,42.6628520803,129.652345121,-24.4652761095,-45.7741202883,-46.723898167,-120.033846385,-58.4754227821,-49.1923344573,-43.1085831507,-26.2219936119,8.1939529253,0.95562787919,7.0969689058,22.2786211985,24.5035590954,-3.35929023822,-20.1028583096,0.953626886844,-14.5730529803,13.9099464218,-0.958533338883,13.2516920385,-11.3391218008,7.70507797226,0.76228055542,2.68236777301,0.306909212477,2.05977321908,-1.65091275473,-2.43252460432,3.30445442399,-3.1694647368,-1.45320216743,-2.97667439915,11.7656881529,0.468101011758,4.89651787936,-5.12378915343,2.34753315724,-0.263014911564,0.130174848646,-0.610790135565,1.14574609386,-0.641176916361,0.987838471867,-1.01154414089,-0.652880220033,-0.858366486082,1.0726497428,-0.717774370323,0.0426277189925,1.95770693765,1.33181032648,1.55951728549,-1.33865939473,-0.81730134816,-0.123236945157,0.514256240536,-0.477885730582,-0.240156609837,-0.948556658804,0.184723316239,-0.210934104501,-0.541322254509,-0.265685708696,0.237171322412,-0.324517233546,-0.00217891820857,0.0772352486392,0.516270534651,0.225977738156,0.225400078282,0.201063675266,0.393065603264,-1.1238252921,-0.261851441738,0.112754951956,0.100488181073,-0.478405076496,-0.360240523605,0.108485354025,0.000164906284778],[-36360.6582384,-544.89941563,1141.38789343,-2314.09124285,2750.80636765,1082.71382784,-750.073201478,-1301.009718,688.721248756,314.153686753,-276.38881237,1044.05213541,-659.764146832,369.074526059,2.04183274319,445.533586341,-482.310241014,59.3465744208,292.338003946,28.6108707578,443.247030845,-251.169554581,6.75001340234,-83.1062843377,-219.672352038,-271.089456022,19.5096990619,-50.7167598687,311.798569898,54.5781023628,-168.297351517,-91.7537833852,-236.286664427,-146.095561698,-197.119630379,-64.2080351545,-57.5115837871,66.9059662281,41.646741125,130.538659891,-24.1146341628,-47.7841617913,-51.249922558,-116.201553498,-56.7639463649,-48.646139422,-42.3795964164,-22.1452050446,8.02429681561,0.0716931590198,7.9552488157,20.7503511434,24.6484546663,-2.9954168884,-20.1192568098,0.420515409873,-13.9708100987,14.8434606047,-1.77492486841,14.0119503623,-10.3989148844,6.93225765021,0.138477435593,2.62400550423,0.00239321783798,2.31014409804,-1.97078066314,-2.35781897354,3.25930462933,-3.07092309373,-1.15052834328,-3.20947836941,11.964021878,0.169577842649,5.35760259667,-4.88327019815,2.0364693342,-0.408475955428,0.48308238076,-0.401415418171,1.12204847816,-0.639807336431,1.01391198471,-1.05998473242,-0.671219741183,-0.806484175408,1.09013221807,-0.529216129118,-0.07175112259,2.00086342147,1.26914809182,1.67238275324,-1.38223623784,-0.867544895076,-0.130607678413,0.594949488418,-0.385637260727,-0.196691706591,-0.903834090581,0.193998124937,-0.190585574501,-0.532467872247,-0.273121854826,0.222906278227,-0.311746583685,0.00875628116552,0.125968940488,0.481303655615,0.24496137628,0.234979471285,0.221883002075,0.378939893415,-1.11440160316,-0.231516836008,0.135575037144,0.130448262238,-0.446755418148,-0.318530088499,0.0950713098934,0.000939180659493],[-36346.1903578,-694.446882557,1208.00664139,-2272.264613,2749.55706578,1070.23122831,-813.976642366,-1265.73059572,678.973756166,364.625044816,-230.343321299,1043.17900389,-675.646682859,373.089674815,46.2618995634,421.619438057,-441.245972886,28.744447976,313.257608962,8.85161237142,424.339706686,-261.616354247,-4.15114089058,-110.262367897,-218.67212282,-263.489695111,22.6305662136,-49.2127042277,302.65117037,54.4889712443,-184.314593812,-97.2722266814,-239.33104004,-149.597284869,-196.577102231,-62.2672699737,-57.7886731736,68.1656297084,40.4047062155,130.75869931,-23.4290434777,-49.9985312916,-55.3804331355,-112.493076229,-54.2732812318,-48.0101895099,-41.5518031769,-17.9297310206,7.78352410667,-0.869023013885,8.81701520373,19.1507594666,24.7510469985,-2.43575810722,-20.0813573889,-0.058558995611,-13.524848095,16.009199714,-2.56398177275,14.7960813323,-9.30430637536,6.25876689127,-0.264804810827,2.55909560009,-0.311260265004,2.54950040193,-2.29350023469,-2.24618949756,3.26466040963,-2.94858374824,-0.825456409609,-3.47016131717,12.212315162,-0.120078451094,5.84611873245,-4.56531667449,1.77214848781,-0.463376634987,0.833521076431,-0.181654386344,1.09796321884,-0.643844327501,1.03695516098,-1.11251275698,-0.678607482866,-0.750295021237,1.11240337606,-0.335301425244,-0.186598066307,2.05430530059,1.20321079555,1.80147053966,-1.39779377983,-0.899471877876,-0.108423666238,0.673337713304,-0.281266126313,-0.155048130616,-0.8569753278,0.203553863003,-0.172302458238,-0.522540279669,-0.282684373408,0.208379443065,-0.301428027304,0.0224716206497,0.173618317231,0.450093207748,0.263081974354,0.243649748483,0.248091426455,0.368088641468,-1.09855038434,-0.195002612558,0.157780939832,0.164284738103,-0.414338709536,-0.274367120325,0.0829636327965,0.00216594568021],[-36338.2042019,-853.736900037,1274.79509337,-2216.88327735,2750.42259433,1052.53856593,-884.655565261,-1225.33455238,666.775584267,413.417464358,-185.889222336,1039.95055043,-692.05630959,377.722923053,90.0906369263,396.710975717,-400.27767013,-0.903612151976,337.411685343,-12.5178855467,402.519374025,-273.444360656,-13.212964523,-135.594921842,-217.861580636,-254.918274723,24.6134939516,-45.9842049609,291.946589907,53.8378605119,-200.61522698,-101.859355457,-241.34962385,-152.41420065,-195.255457924,-60.5759589986,-57.9334645544,69.1618608265,38.9792376424,130.338647528,-22.4471445939,-52.4006334929,-59.0366600018,-109.011010011,-51.0046170428,-47.2141461896,-40.5493292823,-13.5531537674,7.48279115552,-1.82081060006,9.69085403395,17.5045278734,24.812166314,-1.71299146136,-19.9851585163,-0.480469172771,-13.2512462403,17.4190501164,-3.301942381,15.6328089632,-8.05291993119,5.69733850046,-0.443569818142,2.49069795027,-0.62237409307,2.78004321532,-2.6081863627,-2.09892382337,3.31522933727,-2.79699770161,-0.484981630159,-3.75278389571,12.5159029123,-0.396912580984,6.36803137994,-4.17114558466,1.55791590377,-0.42374589229,1.17735099601,0.0480865703902,1.07291333615,-0.652641492242,1.05607530104,-1.16602191998,-0.675112886037,-0.690246024384,1.14129010586,-0.140423077247,-0.298159013189,2.11951208539,1.13340882112,1.94797440399,-1.38381337262,-0.912388300033,-0.0556781335709,0.749432927459,-0.164141058461,-0.116236999427,-0.808793790487,0.212770181102,-0.15676646227,-0.512160286638,-0.293753803275,0.193763674151,-0.293206669812,0.039105336151,0.21884911788,0.423603665579,0.280026638593,0.25084475726,0.279616618091,0.360871219038,-1.07612525034,-0.152181393958,0.179356911242,0.202193988022,-0.381526438632,-0.228546613088,0.0722723739615,0.00401940592236],[-36337.1528376,-1022.78822621,1341.8524679,-2147.5360035,2755.04843843,1027.6924245,-960.374168331,-1179.89768476,652.394983969,459.699614695,-142.772122213,1034.00564214,-708.523499584,383.928627834,131.618759253,371.254894378,-360.366708309,-29.0210889899,364.167764603,-34.8747894617,378.265289771,-286.088241427,-20.1576663623,-159.330106219,-217.141225487,-245.674134207,25.4618586048,-41.0992920436,279.99245625,52.6623794428,-216.881431004,-105.277518118,-242.591368177,-154.4365076,-192.949748102,-59.1507916697,-57.9052864904,69.8752266841,37.4128256965,129.304688699,-21.2075780512,-54.9738730986,-62.1398332593,-105.857950278,-46.9591434574,-46.1876709298,-39.2963005825,-8.99305551237,7.13325431922,-2.73795956005,10.5853512704,15.8363380696,24.8326428349,-0.859794517509,-19.8266586613,-0.842087964771,-13.1660838059,19.0848981788,-3.9650450223,16.5508572697,-6.64237920917,5.26070528281,-0.393821220659,2.42187244443,-0.91927112338,3.00397362281,-2.90395394045,-1.91730959797,3.40571898461,-2.6107159551,-0.136099268685,-4.05140675835,12.8801200365,-0.656969258536,6.92930563238,-3.70197393088,1.39711686777,-0.285612669387,1.51043219986,0.287401062507,1.04632185038,-0.665552433329,1.07037970524,-1.21740592682,-0.660805391652,-0.626784185663,1.17861929653,0.0510260963282,-0.402679864265,2.19796328626,1.05915255196,2.11308810551,-1.3387763681,-0.905600165022,0.0286356946475,0.823247143147,-0.0336307882925,-0.0812694305355,-0.76010289867,0.2210267299,-0.144659293155,-0.501948703015,-0.30571068326,0.179231828707,-0.286727616619,0.0587956635765,0.260327081444,0.402799503641,0.295482475209,0.255998344998,0.316386246673,0.357646997739,-1.04697981589,-0.102925802779,0.200287202602,0.244372391349,-0.348690093412,-0.181863560792,0.0631075846155,0.0066737659614],[-36343.1397695,-1201.185636,1409.32282021,-2064.42527479,2764.91212055,994.175674121,-1039.17578351,-1129.72814499,636.137454243,502.616879245,-100.715991515,1025.06728546,-724.650516519,392.479087264,169.258360337,345.74456822,-322.409780442,-55.0749850602,392.83091745,-57.6079007187,352.076919376,-298.979306585,-24.8160726888,-181.678209808,-216.387369679,-236.039809932,25.2069314826,-34.6799817595,267.101703069,50.9966455935,-232.808308078,-107.342317925,-243.286236828,-155.576634508,-189.491085558,-57.9942785671,-57.6639282832,70.2924195755,35.7381146401,127.696368415,-19.7624611572,-57.6986899519,-64.6291430284,-103.117158721,-42.1568119381,-44.8735017366,-37.7343202166,-4.23319062856,6.74582504341,-3.57598332734,11.5060213714,14.1686642706,24.8145863401,0.0871228007436,-19.6037687158,-1.14362647734,-13.2778854154,21.0093963768,-4.53272725892,17.5708064008,-5.07280312996,4.95669374275,-0.117487201344,2.3545933251,-1.19049448552,3.22296509911,-3.17076523289,-1.70347522462,3.52955946884,-2.3859247239,0.213656144875,-4.35989726789,13.3077171079,-0.896623883613,7.53319534915,-3.16028043923,1.29112198506,-0.0476906832594,1.82899766802,0.535194521055,1.01741219533,-0.681710809948,1.07913196052,-1.26352628629,-0.636054857317,-0.560387560799,1.22580672558,0.234731867444,-0.497008811512,2.29051908952,0.980032382132,2.29721259553,-1.26202438068,-0.879019774722,0.14474271534,0.894800945486,0.110330629053,-0.0510188190206,-0.71155928658,0.22771644029,-0.136553161647,-0.492437670647,-0.317834279862,0.164920170699,-0.281528408371,0.0816291177472,0.296853737627,0.388354850503,0.309144582537,0.25862906027,0.358156817787,0.358587196875,-1.01116825481,-0.0472953060905,0.220566983161,0.290831818539,-0.316205746163,-0.135035940143,0.0555367071849,0.0102811598317],[-36354.8702521,-1386.77797155,1477.52955226,-1970.20843754,2780.81931281,952.176330385,-1118.2202778,-1076.06230652,618.457486304,541.22149785,-59.3582562225,1013.19504426,-740.326788556,403.418363638,202.707051454,320.86008792,-287.044849358,-78.7063808683,422.456371356,-80.1525601809,324.534562473,-311.535435782,-27.4534794354,-202.786036319,-215.379574759,-226.23222635,23.9915638156,-27.0642356254,253.608487755,48.8608096351,-248.142649227,-108.082377553,-243.588239558,-155.835931094,-184.854831665,-57.0522148309,-57.1710221978,70.4246325664,33.9483646228,125.606678045,-18.2178182914,-60.5436644533,-66.515619501,-100.79456207,-36.6926211572,-43.2666827673,-35.8749004791,0.717997928958,6.33043512802,-4.29528922729,12.4460927718,12.5151507318,24.7652248354,1.07492114225,-19.322049261,-1.39864886644,-13.5649571013,23.1582616218,-4.99722358588,18.6806610419,-3.35429166743,4.77350518237,0.359805862185,2.28649224612,-1.42546839935,3.43658067932,-3.4019719915,-1.46291213158,3.67507108654,-2.12535107883,0.554593015845,-4.67134962512,13.7911073637,-1.11357460949,8.17210945423,-2.55359073115,1.23340313896,0.280567249366,2.13077205933,0.787619659381,0.984609458963,-0.699370507349,1.08222080012,-1.30111572077,-0.60243280724,-0.491658425167,1.28262372413,0.406694370094,-0.580403210696,2.39556238524,0.896358748142,2.49757759375,-1.15634007485,-0.834984624644,0.289740312876,0.964149211012,0.265547842374,-0.0258076702249,-0.663192445269,0.232285364076,-0.132582295278,-0.483804659319,-0.328998770235,0.15081859105,-0.276716326657,0.107485329141,0.327773778899,0.379782450887,0.320740027402,0.258594256398,0.404000180621,0.363110426505,-0.969546977485,0.0139032510365,0.240235094285,0.34084610446,-0.284467806428,-0.0884736586536,0.0494567488941,0.0149054394037],[-36370.699978,-1576.98009177,1546.84090273,-1868.15655381,2803.40772467,902.308695222,-1194.44665195,-1020.36859818,599.846819426,574.542424454,-18.3147061694,998.532621737,-755.513534976,416.6084603,231.983823249,297.328223279,-254.845195339,-99.5998764156,452.036892986,-101.955743591,296.23872724,-323.171151075,-28.4437999479,-222.784518198,-213.873214579,-216.451904934,21.9865018151,-18.6440014662,239.852273626,46.2715305173,-262.644167685,-107.57957453,-243.63239761,-155.237977308,-179.052409941,-56.2562167408,-56.3886612396,70.2891839151,32.0269897657,123.141970398,-16.6931506016,-63.4744121429,-67.8282528872,-98.8767533089,-30.6803315899,-41.3753347162,-33.7470309539,5.84589505953,5.89677146162,-4.85750805822,13.3957224007,10.8872342186,24.6930658836,2.04672879895,-18.9889733006,-1.62405755061,-13.9980502486,25.4879769341,-5.35396773138,19.8602820124,-1.49944005876,4.69443460315,1.00650704365,2.21411521417,-1.61383735729,3.64385578864,-3.59177333942,-1.20195250336,3.82929667907,-1.83335730461,0.876480483362,-4.97866474031,14.3201197068,-1.30585027778,8.83574563772,-1.89069215191,1.21545753235,0.68702353683,2.4138529523,1.0401410114,0.946139142767,-0.716565467292,1.07969124388,-1.32687475601,-0.561811182279,-0.421230109052,1.34843051177,0.562992328783,-0.65272270853,2.51085673941,0.808622097105,2.71062001191,-1.02536637761,-0.776438508705,0.459943993489,1.03135538912,0.429260176448,-0.0058207670569,-0.614875079993,0.234192833294,-0.132771425777,-0.476138470802,-0.337977059203,0.136880387424,-0.271291088307,0.136192207148,0.352567688421,0.376304703554,0.33000386875,0.255835987892,0.452817020263,0.370447144376,-0.923172953429,0.0796761790307,0.259341295364,0.39350457508,-0.253875268063,-0.0425096065407,0.0447221081665,0.0205883860066],[-36388.9846393,-1769.20685558,1617.62511028,-1761.54068566,2833.31506563,845.187070567,-1264.79390673,-964.115448771,580.797192887,601.608613001,22.7988688121,981.22372112,-770.17197506,431.911380592,257.107666371,275.875744097,-226.38409867,-117.440071703,480.565249007,-122.464426692,267.789921856,-333.300974525,-28.1609475724,-241.804587889,-211.623662993,-206.89936716,19.3624916923,-9.81122710712,226.172524,43.2454671902,-276.072576688,-105.915786385,-243.553732225,-153.8063531,-172.095243904,-55.5379005768,-55.2789384142,69.9033918802,29.9574041899,120.408598284,-15.3079592352,-66.4565485609,-68.5960333968,-97.3503254257,-24.2337037112,-39.2075782782,-31.3797012246,11.1358856625,5.45452093272,-5.22427061842,14.3450671871,9.29635149638,24.6066170476,2.94567406282,-18.6120138383,-1.83675494838,-14.5479162423,27.955025334,-5.59839342361,21.0895301322,0.479156458867,4.7027770066,1.79106541676,2.13400823593,-1.74524585177,3.84382585227,-3.73436839977,-0.926928524471,3.97927908784,-1.51430568597,1.16908768657,-5.27474352376,14.8845830401,-1.47147973012,9.51380158976,-1.18037204681,1.22878236807,1.15954058747,2.67633792546,1.28822311105,0.900226748246,-0.731329631541,1.07158831161,-1.33750391779,-0.516061923294,-0.349735942739,1.42258730806,0.699704468013,-0.713826951726,2.63416571805,0.717312876137,2.93277676176,-0.872746215948,-0.706325220824,0.65166926341,1.09648292919,0.598706956058,0.00875710757496,-0.566479896006,0.232898179977,-0.137145284871,-0.469527906865,-0.343542051585,0.123058857485,-0.264252410149,0.16757766116,0.370715949355,0.377144007264,0.336671165527,0.250296309261,0.503508021803,0.379827808235,-0.87310315215,0.149029788321,0.277935345787,0.44789655637,-0.224827124925,0.00252332597987,0.0411871834259,0.0273717809697],[-36408.0799285,-1960.87312191,1690.25041359,-1653.63189515,2871.17904516,781.425758353,-1326.2010429,-908.771287112,561.800345962,621.449017437,64.3666788895,961.412045621,-784.263328089,449.189127855,278.097571465,257.229420175,-202.234839632,-131.911566732,507.034206083,-141.125585227,239.788654498,-341.339428188,-26.9788356547,-259.977177837,-208.386293855,-197.775134502,16.2902796584,-0.957860373186,212.908702197,39.7992786037,-288.187589468,-103.172890647,-243.487264647,-151.564638421,-163.994757072,-54.8288826187,-53.8039467274,69.28457472,27.7230220166,117.512914513,-14.1817453398,-69.4556892474,-68.8479512397,-96.2018714067,-17.466497996,-36.7715341478,-28.8019008749,16.5733546373,5.01337042988,-5.35720770623,15.2842840601,7.7539393305,24.51438589,3.71488522579,-18.1986438778,-2.05364347828,-15.1853064672,30.5158898419,-5.72593439075,22.3482662205,2.56890264827,4.78182739419,2.68193005524,2.04271731808,-1.80933837521,4.03552629543,-3.82395629569,-0.644172379438,4.11206115422,-1.17255850764,1.42218376459,-5.55248688575,15.4743262665,-1.60849180812,10.1959750005,-0.431417761125,1.264874849,1.68598080963,2.91632455733,1.52733049223,0.845097776897,-0.741696941858,1.05795702315,-1.32970373188,-0.467056971143,-0.277809256515,1.50445433254,0.812909512288,-0.763575586999,2.76325288716,0.622921532354,3.16048475505,-0.702122516862,-0.627588554917,0.861231628874,1.15959528062,0.771127505982,0.0177411707622,-0.517879598565,0.22786073616,-0.145728604289,-0.464061769279,-0.344466652203,0.109307298897,-0.254600009009,0.201469600569,0.381699044863,0.38152276078,0.34047697668,0.241917275016,0.554973870327,0.390482875829,-0.820394543157,0.220970389336,0.296067004947,0.503111374299,-0.197722370869,0.0462922486924,0.038706373096,0.0352974056224],[-36426.277259,-2149.55228514,1764.97686887,-1547.13459818,2917.43942626,711.843854053,-1376.33657661,-855.650754097,543.370475302,633.497620728,106.561742133,939.245443935,-797.733003942,468.176215568,295.117560072,241.949427337,-182.766781271,-142.794307181,530.543685907,-157.502412045,212.821611219,-346.786959783,-25.3335754484,-277.388713552,-203.97063889,-189.234987889,12.9413053146,7.56315407993,200.355380374,35.9652976043,-298.794225753,-99.4698071275,-243.538284062,-148.563919228,-154.788868456,-54.0685596712,-51.9367959405,68.4498203527,25.318512486,114.552727892,-13.4137627303,-72.4388301001,-68.6210107281,-95.4047230709,-10.5044387309,-34.0851207337,-26.0500599606,22.1330013903,4.58138104388,-5.22867867932,16.2017633247,6.27177553154,24.4236201872,4.30538297833,-17.757491625,-2.28849590347,-15.8799604352,33.1209994413,-5.7351652972,23.6121510318,4.75316568684,4.91255198332,3.64557348252,1.93712870293,-1.79898917468,4.21770991745,-3.85638269353,-0.359737023432,4.21578122711,-0.813303063765,1.62738067303,-5.80557340557,16.0774572251,-1.71579392727,10.8707946195,0.346531780563,1.31457134834,2.25291386816,3.13177539609,1.75275264503,0.779413234279,-0.746143783768,1.03893456372,-1.30099340633,-0.416590360462,-0.206198878417,1.59308110575,0.899479711788,-0.802280611548,2.89566011384,0.525975074297,3.38976221958,-0.517479623828,-0.543368498002,1.08444955346,1.2204218242,0.943470722389,0.0210463915999,-0.468974959176,0.218699111871,-0.158448136996,-0.459794879809,-0.339770972536,0.0955619746775,-0.241509941376,0.237619951149,0.385173641675,0.388523947963,0.341273181067,0.23067496359,0.606116374657,0.401602343453,-0.766136637192,0.294415020922,0.313661804075,0.558115577873,-0.172938515368,0.0884760269321,0.0371314971514,0.0443432401925],[-36441.6109286,-2333.45188154,1841.63180263,-1442.4866261,2971.74418588,638.07962729,-1415.78708555,-805.453338958,526.111607063,638.808521938,148.712308226,914.888346681,-810.463174893,488.097197758,308.911777301,229.929565497,-167.533617678,-150.24962143,550.622230279,-171.622968422,187.420189559,-349.487719666,-23.9100698374,-293.94759281,-198.402861311,-181.255746081,9.48978182203,15.5548842741,188.627566034,31.8385526256,-307.878731237,-95.073624779,-243.693151436,-144.965305513,-144.621479024,-53.2274506383,-49.6946628395,67.4152953351,22.7835653143,111.591671221,-13.0222758904,-75.3784884467,-67.9842725822,-94.8791675681,-3.52110544842,-31.2054473005,-23.1903704261,27.7467833564,4.16011067452,-4.85395713291,17.0788287887,4.86300209081,24.3365285702,4.69975760487,-17.3018060937,-2.54256636563,-16.597570166,35.6965669692,-5.63722455211,24.8400450592,6.99916241022,5.06660185485,4.64056202082,1.81548957524,-1.71999151579,4.38799901423,-3.83407943262,-0.0785584942618,4.28295968542,-0.445026686157,1.78366163326,-6.03079233854,16.6751994994,-1.79580779847,11.5221134348,1.14043133653,1.36606492063,2.84173845396,3.32011286849,1.95907888414,0.703576142199,-0.744916317843,1.01502678012,-1.25216687843,-0.366144501001,-0.13611562749,1.68627435203,0.959461419404,-0.832063424525,3.02804246967,0.427146756196,3.61495264721,-0.324167546241,-0.4575898095,1.31515333017,1.27735566631,1.111523787,0.0189867471978,-0.419779014349,0.205669029118,-0.17483872091,-0.456646140199,-0.329463950691,0.0816910092586,-0.224863622371,0.275476704211,0.381501140803,0.396672893082,0.339378937194,0.216681549113,0.655841838541,0.412214361586,-0.711549109914,0.367923635597,0.330148361774,0.611384608248,-0.150767130359,0.128800548239,0.0363040617717,0.0542320605025],[-36452.0509563,-2510.93798283,1919.93435892,-1339.5591641,3033.5433545,561.976141225,-1445.86866283,-758.724743011,510.650224777,638.84084915,189.935434754,888.509329961,-822.320203815,508.049138588,320.369399159,220.897040593,-155.885125708,-154.53418354,566.905536027,-183.631532742,164.101964934,-349.371783855,-23.4554196133,-309.517706449,-191.763282204,-173.76948729,6.11061573172,22.8594014006,177.79537552,27.529745998,-315.472658104,-90.2884748369,-243.908495683,-140.957413273,-133.662985237,-52.283854949,-47.105740966,66.1969358837,20.1691253369,108.684833296,-13.0053019711,-78.2485619729,-67.0148116245,-94.5322308807,3.29795850728,-28.199420827,-20.2964646881,33.3359724776,3.74949142387,-4.25904522159,17.895037636,3.54110204485,24.2540598837,4.88849178838,-16.8459915,-2.81397935105,-17.3028158059,38.1627512258,-5.44639150085,25.9866087302,9.27007206862,5.21329930558,5.62348544206,1.67638735543,-1.58136841883,4.54373325579,-3.76112489551,0.194706399604,4.30721241558,-0.0770417160425,1.89185268309,-6.22571060901,17.2470556091,-1.85183370651,12.1326154937,1.93638408577,1.40688779076,3.43256051447,3.47862437093,2.14072348043,0.618425026523,-0.738703148419,0.986831684561,-1.18483676775,-0.317123896288,-0.0688858205326,1.78153009668,0.993694513704,-0.855497775569,3.15683332732,0.327146393707,3.82998084586,-0.12787770997,-0.374373441927,1.54667620934,1.32845584473,1.27078345292,0.0119759666693,-0.370332866847,0.189185487904,-0.194337215188,-0.454500472191,-0.313801731436,0.0675454924255,-0.204718806777,0.31441186745,0.371219126831,0.404355505507,0.335230223476,0.200083229638,0.703057689461,0.421306619256,-0.657884178215,0.439966914297,0.344831068488,0.661271129616,-0.131478303394,0.167003455706,0.0360629946874,0.0646228412734],[-36455.5673609,-2680.37666075,1999.6036818,-1238.22339737,3102.28696259,485.376459017,-1467.89740153,-716.010667571,497.612811975,635.053730449,229.348179302,860.276969875,-833.170453578,527.129102221,330.379601647,214.579058561,-147.171082215,-155.904667568,579.029299979,-193.672383386,143.38451276,-346.369228365,-24.7167255676,-323.962945312,-184.132222654,-166.708289733,2.97871359476,29.3187766507,167.928925175,23.1495800519,-321.607558541,-85.418488537,-244.140945712,-136.728858506,-122.083783555,-51.216072032,-44.1982238619,64.8106782149,17.5261373891,105.887302912,-13.3608581234,-81.022948364,-65.7897026776,-94.2709389911,9.76720979217,-25.1339482917,-17.4419751631,38.8218406957,3.34945539399,-3.46994509995,18.6299470504,2.31955843015,24.1771629721,4.86206821179,-16.4044520601,-3.10085934606,-17.9603775014,40.4397110114,-5.17694548876,27.0065024727,11.5290739123,5.32196663227,6.55093351818,1.51840946387,-1.39214290406,4.68225231218,-3.64159746477,0.455400849696,4.28215530402,0.28133950535,1.95277986035,-6.3878951413,17.7725280738,-1.88717193615,12.6849848437,2.72049320726,1.42457218362,4.0054859971,3.60459729982,2.29210070475,0.524798413118,-0.72819287983,0.954947289239,-1.10061569389,-0.270933049849,-0.00583577434142,1.87634436499,1.00301887326,-0.87515741432,3.27846605948,0.226683802482,4.02877162345,0.0656984591119,-0.297840347804,1.77235144131,1.37178139725,1.41674647325,0.000427779127657,-0.320677619431,0.169663488229,-0.216380478984,-0.453242797525,-0.293040459537,0.0529765139636,-0.181133249377,0.353797448558,0.35486518434,0.409957694609,0.329263018331,0.181026203217,0.746671354895,0.427866805491,-0.606394058987,0.509015537957,0.35701431466,0.706127806169,-0.115342122024,0.202822392423,0.0362472236291,0.0751745572265],[-36450.1301616,-2840.13398702,2080.35891533,-1138.35051112,3177.4250406,410.123643827,-1483.18939473,-677.856813955,487.625852187,628.906293921,266.067599456,830.359842522,-842.880287056,544.43415282,339.831560771,210.702825338,-140.741264053,-154.617747573,586.629218963,-201.889798737,125.785408451,-340.410129214,-28.4410884917,-337.147200238,-175.590003745,-160.004231624,0.26898196223,34.7750812157,159.098331342,18.8087571174,-326.314984733,-80.767797115,-244.347130437,-132.468257211,-110.05427044,-50.0024013163,-41.0003050688,63.2724585453,14.9055463061,103.254168868,-14.0869614981,-83.6755453055,-64.3860205639,-94.0023178817,15.7011050622,-22.0759366733,-14.7005342677,44.1256599529,2.95993468691,-2.51265892256,19.2631142155,1.21185428326,24.1067866801,4.61096955807,-15.9915919898,-3.40133083695,-18.5349353989,42.4476051261,-4.84316586122,27.8543867144,13.7393471914,5.3619261317,7.37949602111,1.34014332097,-1.16133799174,4.80089585341,-3.47957552295,0.698868047546,4.20140423715,0.620804636794,1.96726920286,-6.51491285976,18.2311194132,-1.90512277216,13.1619055323,3.47886188,1.40665032409,4.54062084927,3.69531905154,2.40762482796,0.423534827852,-0.71407411641,0.919971606355,-1.00111627642,-0.228976465214,0.0517081942862,1.96821318227,0.988274376634,-0.893616090417,3.38937403883,0.126468798177,4.20524978788,0.250869535133,-0.23211147965,1.98551227642,1.40539136165,1.54490960112,-0.0152440863137,-0.270854374862,0.147518030097,-0.240405371456,-0.452758037941,-0.267436279761,0.0378351636584,-0.154164704951,0.393005455231,0.332976897913,0.411865369758,0.321913300177,0.159656667906,0.785590262327,0.430882609317,-0.558330969121,0.573540187513,0.366002490734,0.744307302099,-0.102628673804,0.235995001482,0.0366956763274,0.0855461830826],[-36434.6985308,-2989.16641181,2162.07096856,-1039.85621072,3258.14726628,337.763000908,-1492.84331908,-644.761283777,480.998410221,621.67573987,299.312844511,798.895488565,-851.29441731,559.190580815,349.558844629,208.900818737,-136.00250962,-150.929664348,589.424774769,-208.430845727,111.712909217,-331.479344373,-35.2130955332,-348.939064617,-166.236963325,-153.591563631,-1.87770909123,39.1052864137,151.337642854,14.6142770335,-329.63901534,-76.5940531329,-244.470853863,-128.318414537,-97.7458176102,-48.6255861563,-37.5460113963,61.5950393054,12.3597895314,100.820201528,-15.1657000036,-86.1870440331,-62.8683988343,-93.642980464,20.9424880077,-19.0908098946,-12.134431867,49.1687416895,2.58203263964,-1.41641054237,19.7763395193,0.231517154842,24.0408239995,4.13291423011,-15.6222470485,-3.71040723068,-18.9976417935,44.116787885,-4.4606717778,28.4911906665,15.8640393053,5.30562661392,8.07154208853,1.14124164523,-0.898759200411,4.89700269594,-3.27929262399,0.920997196405,4.06073667958,0.932501149384,1.93745575524,-6.60528130039,18.6045701869,-1.90919549833,13.5480131429,4.1982288001,1.34215174506,5.02019922265,3.7484022878,2.48295935916,0.315652914429,-0.697208171404,0.882435281046,-0.888446727933,-0.192463044824,0.102640521639,2.05466126153,0.9507075016,-0.913175086628,3.48649143119,0.0272768775996,4.35403677415,0.422622716236,-0.180797907587,2.18014610669,1.42744137648,1.65137547828,-0.034586311011,-0.221064963133,0.123188000851,-0.26582893705,-0.4528830134,-0.237479531099,0.0220113255621,-0.124004270042,0.431394567815,0.306126814773,0.408695464523,0.313658690264,0.136186324895,0.818913713746,0.429555134808,-0.514748444183,0.632213473737,0.371120567518,0.774372202259,-0.0935205003856,0.266194492904,0.03723833655,0.0953911592184],[-36412.1882557,-3128.79189899,2245.21781065,-942.834282407,3342.60190636,268.64880389,-1497.08818537,-617.031779848,476.769875985,613.911557487,328.711430591,765.897306916,-858.170958164,571.141581701,360.172589701,208.42660406,-132.58990349,-145.09492562,587.470589035,-213.45374548,101.137999436,-319.780859643,-44.9672792629,-359.22594204,-156.253506292,-147.413226241,-3.45663539675,42.325964071,144.536638519,10.6583296725,-331.673834908,-72.9689944575,-244.404620373,-124.238892244,-85.333697829,-47.0861456086,-33.892702725,59.7784877822,9.94727494084,98.5388975435,-16.5154445773,-88.5653099833,-61.2517059538,-93.1478873657,25.4477504571,-16.2380596542,-9.76058761985,53.8725553402,2.22153752882,-0.223310605652,20.160396166,-0.607747347741,23.9649445106,3.45456351067,-15.3129791681,-4.01065761674,-19.345537574,45.4183956617,-4.05044165506,28.9029186734,17.8661702505,5.13802294213,8.61255832117,0.92561834764,-0.617342041624,4.96790824192,-3.04560300738,1.1198615464,3.86457640873,1.2094157635,1.87071058925,-6.661320446,18.8835731141,-1.90373539447,13.8357494034,4.86787473222,1.22609521141,5.43496808585,3.76276073138,2.51876476045,0.202891787904,-0.679147193689,0.842599490187,-0.766697633053,-0.161819286778,0.146738656353,2.13332806668,0.893191122722,-0.935045818238,3.56875557503,-0.069853737826,4.47254052561,0.578659696621,-0.145471172152,2.3528568908,1.43647348333,1.73467030123,-0.0569872181983,-0.172154123157,0.0972078371981,-0.291988961382,-0.453262136743,-0.204597329451,0.00555006079506,-0.0913764082291,0.46827015727,0.275027332717,0.399989009268,0.305143381182,0.111088887933,0.846508509187,0.423939146217,-0.475905294442,0.684515726736,0.371775837283,0.795724774133,-0.0878499598293,0.292836344427,0.0376694122137,0.104340788632],[-36386.5042771,-3260.91879088,2330.42917573,-847.423032577,3428.67687486,202.837568492,-1495.93558797,-594.928405278,473.662220662,605.981308181,353.992965532,731.347661047,-863.246373634,580.159577242,372.228324561,208.439018486,-130.195591783,-137.367605849,580.905068364,-217.119507667,93.9223452811,-305.573442779,-57.4756586074,-367.899938644,-145.840054306,-141.414332395,-4.49710926193,44.4885861405,138.549029635,7.02940241519,-332.526154459,-69.9178802818,-244.028109447,-120.143441241,-72.9941591177,-45.3890426553,-30.103572203,57.8196974767,7.72790301856,96.3434351322,-18.0386369137,-90.8250021427,-59.5383691159,-92.4815861435,29.2016712733,-13.5756945949,-7.58457863361,58.1586098383,1.88540886607,1.02130854298,20.408300564,-1.29218910297,23.8617619412,2.60981440248,-15.0807818234,-4.28154000531,-19.5821357778,46.3337603446,-3.63479372378,29.0818438632,19.7087281722,4.84719649281,8.99381068552,0.698252637275,-0.330804525203,5.0109470399,-2.783516084,1.29408035938,3.61950878019,1.44499501184,1.77571378345,-6.68630089107,19.0610589542,-1.89329673942,14.0195075778,5.47771595813,1.05499679603,5.77780261172,3.73763337034,2.51695073219,0.0871706811701,-0.66161604105,0.800658043587,-0.640455169421,-0.13727608809,0.184000800147,2.20188174936,0.819004713767,-0.960167233662,3.63560460194,-0.163819145522,4.55886561267,0.717360794504,-0.127192931486,2.50090272908,1.43112632458,1.79392615509,-0.081795541579,-0.125127321078,0.0701358631887,-0.318203415358,-0.453491719034,-0.170450984944,-0.0114647752557,-0.0571389248502,0.502924267207,0.240425812182,0.385518058553,0.297053208352,0.0849035739069,0.868433323192,0.414302822846,-0.441861648844,0.730129206456,0.367396172663,0.807977205871,-0.0853618642956,0.315271600721,0.0377741672724,0.112020839978],[-36361.5515357,-3387.45542979,2418.33479794,-753.760767647,3514.26008577,140.385810437,-1489.39712122,-578.711263176,470.397415435,598.252553363,374.887057167,695.228914431,-866.257127733,586.1169892,386.281577785,208.096899194,-128.511720617,-128.001779497,569.866619356,-219.589141961,89.9276129253,-289.115861536,-72.5102524936,-374.853160571,-135.197029025,-135.539995034,-5.02844299435,45.6446245755,133.228527501,3.81598264237,-332.302685014,-67.465969799,-243.221000561,-115.945812439,-60.9034494984,-43.5392402786,-26.2418129787,55.7155618898,5.76157424855,94.1669925138,-19.6377187077,-92.9807794979,-57.730815514,-91.6086243541,32.1890293193,-11.1617233595,-5.61198201561,61.948414117,1.58060616297,2.27211455891,20.5130691216,-1.80805798933,23.7138900188,1.63256390824,-14.9426484895,-4.50251240654,-19.7109494421,46.8442138223,-3.23604621474,29.0202393636,21.3547012162,4.42122864243,9.20656514807,0.464123723228,-0.0528646609675,5.02345363845,-2.49804126472,1.44227289719,3.33211914954,1.63268542712,1.66114541639,-6.68349323009,19.1299584665,-1.882433812,14.0936809298,6.01766875964,0.825372571811,6.04157797311,3.67225919277,2.47942697471,-0.0295911728811,-0.646339571273,0.756804751056,-0.514305514673,-0.119064345776,0.214425154744,2.25799046117,0.7314277485,-0.989478281313,3.68647664352,-0.253515442909,4.61111660579,0.837106328098,-0.12702484373,2.62154172188,1.41003854259,1.82827512502,-0.108360014857,-0.080990023041,0.0425304028716,-0.343790269883,-0.453168071333,-0.136701807704,-0.0289493272029,-0.0221496252441,0.534648941238,0.203069613606,0.365054666941,0.290074007199,0.0581695997039,0.884746830307,0.400914343994,-0.412677636332,0.76873617284,0.357409446291,0.810741685616,-0.0858010259451,0.332851306451,0.03733786568,0.118057081909],[-36341.2349723,-3510.31015803,2509.56441144,-661.98579403,3597.23945312,81.3500454452,-1477.48437947,-568.640456652,465.697431488,591.092854444,391.123313329,657.523430541,-866.939684476,588.886239337,402.887877946,206.559083361,-127.23043611,-117.251521025,554.493648613,-221.023658035,89.0154685409,-270.666883668,-89.8430798481,-379.977713958,-124.524852112,-129.735327097,-5.07994890158,45.8455513289,128.428843416,1.10655773485,-331.110137594,-65.6385222019,-241.862973194,-111.559756749,-49.2378169928,-41.5417014605,-22.3706182002,53.4629745228,4.10818911487,91.9427479076,-21.2151316539,-95.0473010356,-55.8314723416,-90.4935495544,34.3946034578,-9.05415459084,-3.84837487321,65.1634771094,1.3140889311,3.48377509752,20.4677182472,-2.14160388529,23.5039424711,0.556709030674,-14.9155726415,-4.65303283058,-19.7354916043,46.9310879831,-2.87651735872,28.7103783026,22.7670775277,3.84820076749,9.24208767531,0.228210814588,0.202759541263,5.00276258612,-2.19418796041,1.56305842167,3.0089928724,1.76593354203,1.53568556665,-6.65616805753,19.0832024102,-1.87570089103,14.0526627234,6.47764941852,0.533738611636,6.21916934287,3.56587718674,2.40810318838,-0.145474541357,-0.635042642145,0.711233422404,-0.392834846449,-0.107414956849,0.238009921864,2.29932235375,0.633739700687,-1.02391790961,3.72080983138,-0.337838727411,4.62739807537,0.936276615619,-0.146028567024,2.71203196955,1.37184877972,1.83684929615,-0.136029371735,-0.0407476951894,0.0149497802961,-0.368067495865,-0.451887504703,-0.105011107857,-0.0468197396594,0.0127336852504,0.562736222976,0.163706097426,0.338370888992,0.284891613145,0.031426182211,0.895507705075,0.384041888962,-0.388413385853,0.800018885833,0.341243530804,0.803630401516,-0.0889122569387,0.344926506288,0.0361457713904,0.12207528308],[-36328.2291752,-3631.13774226,2604.8430128,-571.844273857,3676.14415303,25.5677661442,-1459.93524448,-564.358166937,458.443024888,584.861404042,402.451708871,618.343845754,-864.88916948,588.442373406,422.412340741,203.107847526,-126.078785512,-105.388503737,535.022777245,-221.532899318,90.9512047282,-250.524492526,-109.137027378,-383.121982032,-114.007548846,-123.962523979,-4.6902331291,45.1569447502,123.980253425,-1.04480377052,-329.052377954,-64.4221492492,-239.824903753,-106.879421127,-38.148100906,-39.4052717589,-18.5552060805,51.0659057142,2.81688659489,89.5931941663,-22.6838558944,-97.0410569249,-53.8338001787,-89.1159231259,35.8276137427,-7.29984781582,-2.29437891163,67.7328693277,1.09141574195,4.6138004936,20.268539084,-2.28284136042,23.2132840795,-0.583795447931,-15.0156921914,-4.71379602243,-19.666218806,46.5872615429,-2.57709066649,28.1499038187,23.9133918148,3.12117510068,9.09789018964,-0.00482108829412,0.423871526412,4.94642084457,-1.87703879918,1.65521043446,2.65776541688,1.83868988841,1.40768945848,-6.60922753836,18.9171428295,-1.8779635467,13.8932754774,6.84935994589,0.178664631131,6.30631514931,3.41848673008,2.30591721709,-0.258651907409,-0.629126774474,0.664077906753,-0.280325072934,-0.102398615112,0.255095026143,2.32375363363,0.529133880722,-1.06436016661,3.73860950974,-0.416141063239,4.60678954054,1.01386711889,-0.184623062072,2.77062416768,1.31561153615,1.81946994709,-0.164150211204,-0.00534738333659,-0.0120565396276,-0.390369804137,-0.449239868211,-0.0769024521575,-0.064933960643,0.0467288819629,0.586557686346,0.12307846014,0.305451432129,0.282159538615,0.00510465312443,0.900963928052,0.364036566741,-0.368969312132,0.823863630924,0.318479402106,0.786520648408,-0.0944075270402,0.350924559129,0.0340018574419,0.123739121159],[-36320.287322,-3750.57864655,2705.27664834,-481.513792146,3752.06841022,-27.9996272187,-1435.39274761,-563.034887749,448.150091247,579.883919618,408.703686712,578.323888063,-859.13535478,585.170933118,444.458430347,197.519225668,-124.923420585,-92.7547963053,512.083484397,-221.022044268,95.1146197974,-229.143533825,-129.618452914,-383.959456361,-103.763558997,-118.25211088,-3.93507717383,43.7008087742,119.619292561,-2.72170871267,-326.221890779,-63.6488729611,-236.942456362,-101.720536711,-27.6835056748,-37.1543270339,-14.8688950911,48.5566331538,1.89375963939,86.9980826754,-23.9990253611,-98.9858620642,-51.6953931519,-87.5153617505,36.5950449918,-5.90106609826,-0.930794227638,69.6159075997,0.912541406464,5.63107179959,19.9249217151,-2.23684374852,22.8182838411,-1.754763627,-15.2557228003,-4.67044366651,-19.5413616057,45.8518005281,-2.35291076877,27.3579390923,24.7793650348,2.25313729967,8.7964684371,-0.231563820015,0.604360558382,4.85282502774,-1.55196927805,1.71811939629,2.29027270128,1.84692099463,1.28421289908,-6.55410011945,18.6418169089,-1.89533251462,13.6220587297,7.13164527021,-0.233065083113,6.31020684253,3.23312875964,2.17991947897,-0.367662618369,-0.628700141166,0.615232210471,-0.179841024521,-0.103445201522,0.267387283879,2.32999272689,0.420458945507,-1.11141949898,3.74214987332,-0.489598381771,4.55227031508,1.07133387415,-0.240656499832,2.79953939286,1.24204474323,1.77871513024,-0.192060593404,0.0244975480284,-0.0379745285445,-0.410098865251,-0.444789162946,-0.0533484338764,-0.0829171517903,0.0793565628948,0.605803026529,0.0819132424818,0.267131615215,0.28240200404,-0.0207951966233,0.902120703844,0.341581205079,-0.353606973031,0.840972795783,0.28931044919,0.760350147898,-0.101867436426,0.350578080806,0.0307849332108,0.122863909874],[-36313.9322379,-3869.01975933,2812.06662681,-388.77978963,3826.74771153,-80.6097574906,-1402.2262076,-561.223190929,434.493311061,576.477749839,409.731056787,538.227558363,-848.56667401,579.560084172,468.439198065,189.692691124,-123.665894223,-79.7100662471,486.403463722,-219.345105101,100.789138486,-207.018068879,-150.404582067,-382.119905601,-93.8949259548,-112.651695455,-2.89955637059,41.6132537317,115.059060604,-4.04218277452,-322.708315492,-63.1120679235,-233.042492075,-95.8792306875,-17.8678270191,-34.8171257212,-11.387028768,45.9745113692,1.33413969244,84.0264794538,-25.1263124333,-100.907362534,-49.3648787746,-85.7464959347,36.8283232136,-4.84892338621,0.266534484141,70.7794703322,0.776019795489,6.50731274735,19.4495309586,-2.0124490745,22.2940618066,-2.92195182638,-15.6475245664,-4.50985418205,-19.4060940661,44.7753177925,-2.21768757626,26.3589773143,25.3552647077,1.26205387832,8.36656411966,-0.448923423908,0.739637355819,4.72058416267,-1.22442811128,1.75133000767,1.91940075643,1.78709738817,1.17198684133,-6.50384581816,18.2706831177,-1.93422982175,13.2479812731,7.32513604926,-0.692612601766,6.24089912808,3.01360460206,2.03818853572,-0.471137737611,-0.633547578148,0.564530379238,-0.0941432621471,-0.109824393826,0.276935234282,2.31695611453,0.310477388572,-1.16564545303,3.73427232943,-0.559842581174,4.46779466148,1.11074806126,-0.311334353825,2.80199131691,1.15228219013,1.71785209146,-0.219096443761,0.0481321547475,-0.0622990172385,-0.426673089684,-0.438092928004,-0.035183902913,-0.100336278143,0.110213006716,0.62024146902,0.0409328212452,0.224459409975,0.286110906852,-0.0463814612904,0.900172543068,0.317441561416,-0.341428212194,0.852252793625,0.254083164321,0.72632172828,-0.110839742876,0.343696001377,0.0263925171578,0.119302871964],[-36305.686748,-3986.84796901,2926.41425696,-291.427707047,3901.91754379,-133.520247518,-1358.80494322,-555.475648316,417.147364826,574.960243374,405.385629034,498.818857552,-832.071560809,572.097992269,493.767695194,179.527717232,-122.207759319,-66.6139810784,458.710408872,-216.356094032,107.258185532,-184.642158997,-170.612640447,-377.233098409,-84.5036931094,-107.208885358,-1.6687460542,39.0303899539,110.012657333,-5.12425163895,-318.601291513,-62.605108722,-227.951871945,-89.1516302396,-8.724860659,-32.4219262568,-8.1849506472,43.3588948876,1.13335819816,80.5474505202,-26.0313894905,-102.831204416,-46.79088456,-83.8639561854,36.6588744168,-4.13453362767,1.32176252906,71.190435932,0.68040477986,7.21424706872,18.8550316323,-1.61849536325,21.615738027,-4.05111636594,-16.2029575877,-4.21890598833,-19.3055902501,43.4084261899,-2.18513099966,25.1775116757,25.6313583534,0.165891350521,7.83691893927,-0.653805943306,0.82511263737,4.54830727639,-0.899864013131,1.75438696912,1.55803561315,1.65568959653,1.07774223812,-6.47152465184,17.8171999253,-2.00107749506,12.7800119005,7.43046294082,-1.1911399955,6.10844671153,2.76371558396,1.88880294903,-0.56770832851,-0.643453921348,0.511806458736,-0.025992346754,-0.120805869771,0.285787416564,2.28356027755,0.201951703447,-1.22758757508,3.71781828543,-0.628505559617,4.35731684221,1.13418086008,-0.393862097571,2.78119361167,1.04745766601,1.64014807659,-0.2445936877,0.0649014926627,-0.0845248364936,-0.439510887917,-0.428708702478,-0.023243709167,-0.116758304742,0.138894492095,0.629642239314,0.000859573223571,0.178482788131,0.293778144485,-0.0717622351354,0.896313956342,0.292383393192,-0.331534873264,0.858610037664,0.213144039764,0.685638217851,-0.120872204169,0.330087250904,0.0207221277435,0.112909230174],[-36292.0736774,-4104.45016403,3049.52084753,-187.242985132,3979.31339384,-187.988720149,-1303.49827322,-542.34483175,395.786933039,575.648748892,395.519213389,460.861786526,-808.538448812,563.27282311,519.856973035,166.923777331,-120.450568765,-53.8262083154,429.732013501,-211.909023278,113.805185673,-162.509865491,-189.359853664,-368.928803439,-75.6919038511,-101.971288241,-0.32772155947,36.0883277719,104.193182527,-6.08594098887,-313.990458263,-61.9213699425,-221.497457026,-81.3338625523,-0.278402314274,-29.9969870763,-5.33800426486,40.7491382367,1.28674660063,76.4300618935,-26.679928912,-104.783033791,-43.9220380214,-81.9223730091,36.21812461,-3.74901077066,2.2590452125,70.8156828057,0.624250230414,7.72359849557,18.1540885544,-1.06382063966,20.7584325531,-5.10801356551,-16.9338819624,-3.78447750458,-19.2850242203,41.801738574,-2.26895094969,23.8380353675,25.5979134916,-1.01738376985,7.2362745979,-0.843117421544,0.856197121679,4.33460339594,-0.583725697855,1.72683498114,1.21906330227,1.44916814721,1.00821004236,-6.47019663785,17.294825801,-2.1022975615,12.2271194048,7.4482566027,-1.71980933498,5.92290429841,2.48726303196,1.73984128058,-0.656005454443,-0.658204006693,0.456894494644,0.0218511607189,-0.135659307103,0.295992369936,2.22872169695,0.0976443836623,-1.29779541145,3.69562914864,-0.697219215266,4.22479111974,1.14370345045,-0.485445204593,2.74035994897,0.928704960042,1.5488703315,-0.267888250649,0.0741506176159,-0.104146817094,-0.448030670428,-0.416194025462,-0.0183627025378,-0.13175019663,0.164997297701,0.633774562905,-0.0375841247895,0.130249721409,0.305895614372,-0.0970456124166,0.891739454284,0.267172457846,-0.323028799886,0.860950941115,0.166839567783,0.639502444907,-0.131512578086,0.309560759448,0.0136712834287,0.103536207244],[-36270.4686102,-4221.88389084,3183.14854601,-74.1328847029,4059.39187299,-245.019486621,-1235.06944915,-519.315952337,370.542425053,578.429302028,379.880266517,425.055207261,-777.08389891,553.293551285,546.099148571,151.984862064,-118.319639345,-41.7864814313,400.174511374,-205.906379541,119.69766755,-140.986305073,-206.076870485,-356.937007501,-67.5046857208,-96.9582038062,1.03447178111,32.9230537215,97.3512175227,-7.05347556304,-308.881410877,-60.9662006168,-213.524122392,-72.2892457698,7.46402080774,-27.5608297005,-2.90109540669,38.1899959489,1.78768114395,71.5661642149,-27.0419768452,-106.756136411,-40.7404486255,-79.9582037783,35.6166895852,-3.67530813084,3.09362326084,69.6349728473,0.606093611723,8.01472639454,17.3651310503,-0.35981181121,19.7014057584,-6.05867152496,-17.8426001761,-3.20069607255,-19.3773627448,40.0015404695,-2.47719880114,22.3629923296,25.2519946274,-2.27039819524,6.59450415751,-1.01429613803,0.82971645363,4.08098488705,-0.281792471141,1.66864989386,0.914912862257,1.16581598861,0.969283964992,-6.50943360692,16.7157518195,-2.24253593525,11.598225338,7.38121097639,-2.27039537171,5.69536579369,2.18828597813,1.59931062689,-0.734928161948,-0.67740073337,0.400126952626,0.0469407456661,-0.153394766701,0.309524662787,2.15158276492,0.000325369551038,-1.37610789396,3.66989875319,-0.767275126319,4.0739978247,1.14169065999,-0.583509312409,2.68305742873,0.79738368745,1.44767209242,-0.288529333139,0.075578316189,-0.12080448258,-0.451683225221,-0.400195205174,-0.0212423806247,-0.144810406435,0.188182216282,0.632421184797,-0.0736473443552,0.080872354247,0.322710901302,-0.122259118678,0.887434121091,0.242527564697,-0.31511097524,0.86015840293,0.115630967047,0.589286336998,-0.142408801817,0.282189275285,0.00514877277777,0.0911385194045],[-36241.6581657,-4337.88932815,3331.30285477,49.5080530993,4137.49409044,-304.603611736,-1153.85745374,-487.604778241,343.367165657,581.462686292,357.803831991,391.837426052,-737.736981016,541.252386948,571.802601532,135.633031291,-115.835343397,-31.254797727,370.658296695,-198.444547481,124.139575417,-119.920816066,-221.448032293,-341.388570026,-59.7595028622,-92.0756999336,2.31290864433,29.670059159,89.387269881,-8.18587632377,-302.943567356,-60.0928475616,-203.948799203,-62.1498618747,14.5599555503,-25.09302799,-0.847378857063,35.7478225771,2.62171727217,65.9387466146,-27.1050745099,-108.614356722,-37.3621536541,-77.9352133288,34.8819442682,-3.86373649437,3.80507908464,67.6796018987,0.624406763291,8.09753267155,16.5296464758,0.471948684292,18.4404793074,-6.87020546417,-18.8931842647,-2.49068472392,-19.5667434129,38.036808084,-2.7952917852,20.7666294973,24.6178542064,-3.57815154333,5.94600612006,-1.16690931646,0.748155983042,3.80057747025,-0.00116600439394,1.58153215575,0.656185362091,0.8111657528,0.963508749231,-6.58485464335,16.0870994773,-2.4193340793,10.9020622895,7.24027313835,-2.83712358051,5.44108189989,1.87177427633,1.4749322238,-0.804447430225,-0.699919253599,0.343829978286,0.0480860788216,-0.171983841984,0.328062980208,2.05218951855,-0.0872056113362,-1.45952149647,3.6402306404,-0.838603591085,3.90802156023,1.13173190742,-0.686360714542,2.61426686313,0.655756767702,1.34175055711,-0.306919236118,0.0702982979222,-0.134716127526,-0.450048850406,-0.380713626313,-0.0320508318258,-0.155163337131,0.208368096891,0.625418928033,-0.106464950453,0.0317195219437,0.3434943395,-0.147108004611,0.883545335273,0.218979730588,-0.307378940659,0.857021265009,0.0604383618425,0.537038218693,-0.153609530198,0.249100819551,-0.00489153523028,0.0760768568423],[-36207.281722,-4450.87731268,3498.55011488,185.163467051,4207.68227985,-366.478848685,-1060.59520249,-449.35971689,316.670208496,582.47837216,328.521600115,361.581610278,-690.754892295,525.962349144,596.254777329,118.994862179,-113.04181715,-23.0712204604,341.782303781,-189.668386244,126.318957433,-99.0337921911,-236.471103625,-322.514568598,-52.2169035701,-87.201536551,3.39869370928,26.4647116455,80.2393287194,-9.65036328919,-295.762301411,-59.7665320397,-192.70643264,-51.1149838093,21.0832172693,-22.5634188904,0.870428349969,33.494372679,3.77245522937,59.5535828453,-26.8611368939,-110.189178839,-33.9366723423,-75.7989933621,34.020453368,-4.25644601503,4.36408051551,64.9937492891,0.677645118354,7.98955486732,15.6948866944,1.40732952646,16.9756151871,-7.510002383,-20.0401486513,-1.68481541283,-19.8250965193,35.9321902958,-3.20298859718,19.061144555,23.7265416593,-4.92623665813,5.32631034755,-1.3010564166,0.615415985974,3.50941020477,0.25072143955,1.46761336489,0.453024878398,0.392562492738,0.992591896343,-6.68859064482,15.4147228758,-2.62845734383,10.1473156082,7.03845344873,-3.41483211701,5.17634251893,1.54295548587,1.37435584198,-0.864802221638,-0.724452782857,0.290828137208,0.024410877254,-0.189138509501,0.353212036469,1.93081390612,-0.162141384645,-1.54432207836,3.60558077839,-0.910794587899,3.72977299766,1.1177202592,-0.792525868509,2.53932249247,0.50631294633,1.23668891367,-0.323673535643,0.059778003096,-0.14624473926,-0.442740221619,-0.357839442702,-0.0508227922393,-0.161964879281,0.225538302659,0.612618135161,-0.135143256419,-0.0157757674873,0.367271950546,-0.171216952189,0.880011048923,0.19701302424,-0.299529377014,0.85230485499,0.00229660286203,0.484975513813,-0.165263597477,0.211687231597,-0.0164845015127,0.0588134032325],[-36168.9786573,-4559.25868118,3689.45666747,334.316995928,4264.01867488,-430.382950661,-956.015610909,-406.729175716,292.860607218,579.205830107,291.265261192,334.660927313,-636.394829913,506.236456919,618.743121377,103.196931894,-109.983196831,-18.0758128894,314.145466948,-179.722754978,125.423861756,-78.0456271729,-252.14384902,-300.546080801,-44.6374361389,-82.2134735856,4.18293165508,23.4423787422,69.8453831554,-11.6141564775,-286.922986756,-60.452475314,-179.731967884,-39.3838845159,27.1076213206,-19.9418393474,2.29960918036,31.5014008127,5.22349525959,52.4164466596,-26.302078985,-111.312086879,-30.6135239253,-73.4951355797,33.0387815938,-4.79558684663,4.74129538504,61.6215943477,0.764264110151,7.70833052256,14.9081035694,2.42219939489,15.3067753847,-7.94544928133,-21.2380077592,-0.813460093449,-20.1243523587,33.7123359833,-3.68004793236,17.2587351868,22.6091064168,-6.30024638364,4.77094670193,-1.41683689824,0.435396738481,3.22351214983,0.466437597857,1.32902511938,0.315575487802,-0.0826487386004,1.0582409076,-6.812772509,14.7044761168,-2.86567107904,9.34267064277,6.78876226769,-3.99835913687,4.91743755275,1.20705716607,1.30523125211,-0.916231498551,-0.749694536621,0.243945994979,-0.024961141968,-0.202570745803,0.38657654584,1.78772787592,-0.221674776022,-1.62679549899,3.56490513527,-0.9834380951,3.54216280827,1.1035487818,-0.900531231831,2.46355855702,0.351540968865,1.13807035025,-0.339407807768,0.0454848719903,-0.155753305113,-0.429370014495,-0.331662808163,-0.0775929979631,-0.164370923446,0.239676196715,0.593869148733,-0.158788575586,-0.0601805060322,0.393069756021,-0.19421064339,0.87676921413,0.177111514378,-0.291258965174,0.84677450051,-0.057759459203,0.435315646182,-0.177519837902,0.171340350774,-0.0296649869866,0.0398103422501],[-36128.3883498,-4661.44427038,3908.5888536,498.452278509,4300.56550921,-496.053670856,-840.851594521,-361.861562146,274.347415467,569.37453061,245.266505525,311.448544533,-574.913991037,480.887729316,638.555079088,89.3658176015,-106.70361867,-17.1086382719,288.346720512,-168.752512828,120.642336544,-56.6767147343,-269.464033016,-275.714184219,-36.7816488634,-76.9892709648,4.55672716084,20.73842801,58.1434223067,-14.2444759067,-276.010997107,-62.6158986472,-164.960350117,-27.1558369366,32.7069830601,-17.1981263064,3.48744660007,29.8406615359,6.9584376069,44.53311181,-25.4198157711,-111.814564958,-27.5422276383,-70.9692316831,31.9434936545,-5.42330914295,4.90739152483,57.6073164036,0.882719171919,7.27139717798,14.2165489642,3.4924269692,13.4339218872,-8.14393315904,-22.4412760116,0.0930092800607,-20.4364412256,31.4018940249,-4.20622848605,15.3715990772,21.2965979098,-7.68577356386,4.3154450452,-1.51435022114,0.211998516621,2.95891236468,0.638550207689,1.16789901729,0.253981266925,-0.607122888246,1.16216328426,-6.94953113357,13.962213302,-3.12674063511,8.49681274192,6.50420995542,-4.58254279572,4.68065690325,0.869306876232,1.27520822485,-0.958974223327,-0.774337730369,0.206008117184,-0.100906261776,-0.209992527441,0.429761222587,1.62320337623,-0.262998611111,-1.70322761775,3.51715967917,-1.05612409102,3.34810166338,1.09311054169,-1.00890326203,2.39230929705,0.193929580839,1.05147805497,-0.354737628548,0.0288863448854,-0.163604812415,-0.40955090467,-0.302273876519,-0.112396185095,-0.161537360188,0.250765142192,0.569022311299,-0.17650722129,-0.100061685677,0.419913777507,-0.21571376019,0.873757782986,0.159759269722,-0.28226438601,0.841195529205,-0.118694973661,0.390276039621,-0.19052708572,0.129452016433,-0.0444678525695,0.0195298575703],[-36085.5132791,-4755.03481571,4157.16774512,677.210023951,4312.67232956,-562.911277405,-716.279320867,-316.38071203,262.854022016,551.231510772,190.603791315,292.478279261,-506.594071975,449.86914182,655.200299435,78.5048112315,-103.180793295,-20.7522204572,264.970800414,-156.887328042,111.540461797,-34.9294351194,-288.853738689,-248.569036618,-28.4328740834,-71.4126809215,4.39280996025,18.4382563128,45.1503583589,-17.693743159,-262.800831832,-66.5049362361,-148.467641542,-14.62327164,37.9079670161,-14.31633603,4.48607085077,28.5474697199,8.93890446452,35.9471619408,-24.2415139057,-111.572093671,-24.8404443534,-68.1940205978,30.7557081482,-6.10547678999,4.85393393678,53.0202648041,1.02483740709,6.69994776959,13.6547272482,4.59238727917,11.3649583016,-8.08979467915,-23.6043927479,1.00133417125,-20.7353563925,29.0326659662,-4.76420968258,13.4217450215,19.8247133757,-9.06064418952,3.98712331005,-1.59589010858,-0.0503601575832,2.72883812398,0.762802849888,0.985817118493,0.274597388317,-1.17047330744,1.3026809101,-7.09142215649,13.1952426892,-3.40628746124,7.62098252055,6.19705104032,-5.15893134338,4.47876731633,0.534703341117,1.28860027411,-0.993546827827,-0.797551018771,0.179181156561,-0.202556738195,-0.210198704371,0.484201872344,1.43847736489,-0.284450071784,-1.77044896978,3.46121824794,-1.12776529923,3.15060680501,1.08975437413,-1.11556890425,2.32991029309,0.0360570051401,0.980922606491,-0.370443510279,0.0113342834667,-0.17003067729,-0.383258105234,-0.269937454183,-0.154837876224,-0.153078511102,0.259057668399,0.538037057331,-0.187629260161,-0.134206144834,0.446686911322,-0.235243636605,0.870769378858,0.145458339715,-0.272367032056,0.83621050281,-0.179460074698,0.35155747866,-0.204423421654,0.0873240068198,-0.0608554990762,-0.00151546062145],[-36033.8083303,-4834.39064738,4423.0333368,862.859222947,4300.83793502,-629.106098211,-585.247965627,-269.812174886,257.361156136,525.094074207,130.742648365,278.926548595,-431.814765612,417.693495674,669.077245635,71.1240637728,-99.1267289407,-28.5589256605,244.545649083,-144.196105262,99.1964448854,-13.9341146551,-308.432323266,-220.937116476,-19.4655803207,-65.3914249104,3.49041000536,16.4273777247,31.1987957715,-22.055186071,-247.823492934,-71.4993740135,-130.89437246,-1.95124969906,42.5486344062,-11.3374020486,5.36700127706,27.511381489,11.0386058224,26.8534202622,-22.9353467051,-110.636139529,-22.4984014904,-65.2508301457,29.5547592278,-6.90280860262,4.65607630405,48.0304689697,1.15593259988,6.02979681459,13.2061528157,5.69048075519,9.13955471346,-7.83518915728,-24.6814969721,1.8667097145,-21.0033430427,26.665064022,-5.34835386255,11.4704262595,18.2477412799,-10.3716168381,3.78045171205,-1.6725273379,-0.34518777824,2.53530956427,0.847642480004,0.782163330027,0.368623408235,-1.75014696424,1.46457319885,-7.23270017681,12.4166891613,-3.69435740266,6.73664165811,5.87651672386,-5.70591340635,4.31044291379,0.207329947288,1.33637588674,-1.02157562189,-0.820404813259,0.163000114451,-0.322068719631,-0.206315620172,0.550658666192,1.23864683789,-0.288943764808,-1.82746879333,3.39562615852,-1.19456542413,2.95312175818,1.09465218945,-1.21605705419,2.2767024866,-0.119140625901,0.92412414561,-0.387965710228,-0.00628176495961,-0.174736031038,-0.351916979102,-0.235616957925,-0.202806739896,-0.140442421906,0.26588296936,0.501309188991,-0.19237977201,-0.16228010761,0.471699552732,-0.251888214823,0.867015310222,0.13478269668,-0.261887142502,0.831970919444,-0.238944836006,0.318794190652,-0.219303912335,0.045897855749,-0.0785004869132,-0.0226113960979],[-35965.0914899,-4893.06199428,4690.68035413,1045.82593657,4266.84843771,-692.47097612,-451.149956517,-221.156928653,256.163882227,491.797091155,69.9953743752,272.130419581,-350.980263976,390.013548558,680.806584461,67.6104409782,-94.1870082443,-39.8235806881,227.585010575,-130.732558232,85.0665250222,4.89693381088,-325.743462512,-194.963982456,-9.77702014266,-58.8392166918,1.63038230281,14.5413356223,16.7002620721,-27.4072340434,-231.799108069,-76.7619108462,-113.022190194,10.702010187,46.4198956204,-8.31647720964,6.20660449925,26.5855132808,13.1092736198,17.4845198758,-21.7047391517,-109.102165518,-20.4744681059,-62.2481353727,28.4345349353,-7.8997371279,4.40986948008,42.8331283391,1.23469020471,5.30041422543,12.841592567,6.75361417784,6.80532282836,-7.44922557222,-25.6266526043,2.64144446189,-21.2247093373,24.3666530742,-5.95594409559,9.58870714241,16.6246178946,-11.5576832339,3.68168853749,-1.75752694993,-0.66547459349,2.37754503752,0.90469189726,0.555772020709,0.523469978862,-2.32054923095,1.62923394674,-7.36804453389,11.6411317576,-3.97985240359,5.86780710017,5.55108237573,-6.19858770531,4.17083466137,-0.108958753245,1.40616729282,-1.04496438484,-0.844444964459,0.156342079348,-0.449854327584,-0.202552491829,0.629722866576,1.02977380077,-0.280538653175,-1.87384100243,3.31884659756,-1.25205091538,2.75919661861,1.1084316668,-1.30529709515,2.23202815931,-0.268637702597,0.877230203664,-0.408909421902,-0.0231878316823,-0.177294433757,-0.317315426644,-0.200450457109,-0.253762231151,-0.125535569354,0.272839405282,0.459343600363,-0.191207589947,-0.184169644538,0.49311897174,-0.264628089072,0.861561556831,0.128324293659,-0.251269668204,0.828505511321,-0.296024316155,0.291103763659,-0.235252870865,0.00602503593015,-0.0970029163849,-0.0429933261215],[-35871.1807445,-4924.59908531,4944.60352261,1216.53622589,4212.4899498,-750.838753978,-317.377721251,-169.415951269,257.557264686,452.175431859,12.6742670472,273.426959265,-264.494759093,372.482058155,691.008982689,68.3508086008,-88.0072138416,-53.8410123467,214.602628942,-116.550400693,70.6069414199,20.1513974307,-338.330832194,-172.795193216,0.735553883697,-51.6697700261,-1.40641814075,12.6156733824,2.06628478821,-33.8283164769,-215.447804896,-81.4552456009,-95.6327420684,23.178289319,49.3126610486,-5.30871436039,7.08124713767,25.6229815331,15.0026397957,8.07309388348,-20.7531162275,-107.065634629,-18.7270132567,-59.2944113246,27.4889233125,-9.18069491291,4.21136431835,37.623442351,1.21979567599,4.55126991459,12.5318134023,7.74869432768,4.40987435172,-7.00101290272,-26.3939235647,3.27784696552,-21.3837634374,22.2049980049,-6.58426345134,7.84765202108,15.014279492,-12.557835101,3.67709207268,-1.86415398552,-1.00421085148,2.25476289569,0.945573900884,0.305477559363,0.726547752383,-2.85608547982,1.77805695,-7.49213456706,10.8831495172,-4.25167440827,5.03849579232,5.22922336566,-6.61205296092,4.05509352482,-0.410308208471,1.48560672243,-1.06561689603,-0.871217322995,0.158084139742,-0.576325683552,-0.203118536326,0.721985735941,0.817920259068,-0.263293699876,-1.90911951112,3.22934275173,-1.29574822262,2.57238148203,1.13172048529,-1.37821841045,2.19522959293,-0.409408615259,0.836388311989,-0.43487983881,-0.0386099479899,-0.177279445541,-0.28124134823,-0.165576021095,-0.305163805025,-0.110264430197,0.281525336369,0.412645185529,-0.184561547078,-0.199760826152,0.509112438352,-0.272443853581,0.853474098438,0.126675083695,-0.240959560016,0.825843010656,-0.349573573716,0.267603785742,-0.252354610351,-0.0314429799277,-0.115962887796,-0.0618966279548],[-35743.8940805,-4922.55214936,5169.29756775,1365.41615198,4139.54858343,-802.042274629,-187.323687543,-113.590220671,259.836367911,407.063966557,-36.9083759179,284.15323469,-172.762442992,370.751782147,700.305107094,73.7320323935,-80.2329283686,-69.9060474427,206.112248239,-101.703346389,57.2739332912,30.4169633567,-343.738108076,-156.576307417,12.1748891911,-43.7967986734,-5.83913631868,10.4859343815,-12.2916085524,-41.396862772,-199.489711072,-84.7420771445,-79.5076754059,35.3193689978,51.0178410809,-2.36926634823,8.06729581262,24.4769026836,16.5704362893,-1.14822461304,-20.2839029148,-104.622009848,-17.2144059994,-56.4981330474,26.8118124013,-10.8301145047,4.1566116723,32.596610444,1.06993446813,3.82183379455,12.2475822221,8.64262798528,2.000820989,-6.55966012756,-26.9373737734,3.72822577747,-21.4648135041,20.2476636959,-7.23059499945,6.31832524655,13.4756623441,-13.3110641637,3.75292060389,-2.0056734855,-1.35438680034,2.16618149075,0.981911290099,0.0301143148077,0.96526738098,-3.33116108315,1.89243600487,-7.59964961567,10.1573214791,-4.49872536091,4.27272468014,4.91941506335,-6.92140789385,3.95837046991,-0.692863866379,1.56232640566,-1.08543693477,-0.902267739493,0.167103384128,-0.691894909035,-0.212222970648,0.828038536731,0.609148218312,-0.241267867903,-1.93285823341,3.12557780772,-1.32118379549,2.3962264442,1.16514632406,-1.42975038341,2.16564906917,-0.5384277542,0.797746001919,-0.467482154459,-0.0517741451711,-0.174264626487,-0.245482644232,-0.132131719247,-0.354470916557,-0.0965354811891,0.293539122826,0.361718838574,-0.172890476512,-0.208939722983,0.51784722257,-0.274316102577,0.841818914797,0.13042701983,-0.231401768793,0.824012149665,-0.398467667259,0.24741184496,-0.270693443897,-0.0656547191153,-0.134980501449,-0.0785566788602],[-35578.8314872,-4881.87344139,5351.91774923,1484.48810907,4049.54090129,-844.919620905,-63.6322892253,-53.1798624274,261.612647994,357.658337939,-75.1007004369,305.392999902,-76.3374484698,388.771415522,709.375830239,83.9464570672,-70.3284041005,-87.2587768086,202.458057696,-86.2347946958,46.1892591971,34.570491854,-340.106428024,-147.834798883,24.5317417611,-35.0857405748,-11.7883319219,8.03509972816,-25.9439302022,-50.1250771079,-184.533441964,-85.9620381102,-65.25081444,46.9348721137,51.3733848203,0.420399946101,9.24004093554,23.0305297095,17.7105462182,-9.94659441136,-20.4427196702,-101.849661092,-15.9095723023,-53.9379517536,26.4567181288,-12.9145214862,4.31245162047,27.921138896,0.745369006186,3.14413818837,11.9604402878,9.41519534718,-0.371941762039,-6.18039978196,-27.2158622901,3.95251055802,-21.4526250426,18.5418253268,-7.89192772792,5.0548518914,12.0557450669,-13.7716562342,3.89292112101,-2.19349341598,-1.71189184385,2.10820172616,1.0249169658,-0.269539232703,1.22770764402,-3.72311171438,1.95651755513,-7.68518794255,9.47260509087,-4.71109610878,3.58879688872,4.62673421211,-7.10760130723,3.8743707268,-0.953801608091,1.62555910892,-1.10600091759,-0.939765415901,0.18148985944,-0.788573237704,-0.233300311666,0.947406434007,0.409228865929,-0.218258813619,-1.94449385885,3.00567336145,-1.32454153429,2.23304328978,1.20831008674,-1.45600006842,2.14184154103,-0.653088017984,0.757873099552,-0.507720828446,-0.0620703028714,-0.167826305865,-0.21186687722,-0.101261977164,-0.399649405581,-0.0860969488518,0.309966058628,0.307290183145,-0.156784392578,-0.211622505033,0.517786057314,-0.269444094467,0.825699730632,0.139812332691,-0.222979785691,0.822746961803,-0.441671924598,0.229589045374,-0.290137237257,-0.0959064614178,-0.15374302058,-0.0923621900006],[-35386.7209648,-4803.1233205,5490.26146345,1572.15982395,3942.90526826,-882.329835573,54.0440154105,10.3184073728,262.763127799,306.597278475,-100.892626898,337.216756947,23.6263285911,423.673402502,719.142847833,98.4083431649,-57.0325718691,-104.92034738,203.306027251,-70.1468875228,37.1367550922,32.6455356391,-327.9667783,-145.625802096,37.34890177,-25.2089303939,-18.9802234316,5.33590145808,-38.389351533,-59.7602627768,-170.741563781,-85.1624961972,-52.7546910431,57.7057879157,50.4053962229,2.87356150837,10.6704680822,21.2876617469,18.5054574141,-18.0883419064,-21.1439688487,-98.7585859909,-14.84366578,-51.5732233225,26.3156679635,-15.4288135831,4.62888114167,23.6587613409,0.212669597762,2.5204650614,11.645026306,10.0976702737,-2.64938323449,-5.86295862686,-27.2074287331,3.94111540021,-21.3337929345,17.0530992665,-8.5640742982,4.04359991446,10.7536756507,-13.955073477,4.07079542829,-2.43159344413,-2.08421200834,2.06595471122,1.08416423558,-0.584928157194,1.50461982963,-4.02099425157,1.96545863481,-7.74302350456,8.81547143238,-4.88363311117,2.98216026125,4.34266304964,-7.17498233393,3.79101658334,-1.19441904726,1.67093974397,-1.12757580964,-0.988372959458,0.196185446382,-0.864768351916,-0.266686275798,1.07535020329,0.22277011689,-0.197018966867,-1.942994179,2.86638464596,-1.30463514188,2.08019055926,1.25670557499,-1.45778520416,2.1192126466,-0.752456338196,0.715028610035,-0.554197384721,-0.0695436941635,-0.157551889654,-0.182380258577,-0.0741366453958,-0.44069065112,-0.0800640587913,0.329839172838,0.250967761144,-0.137398034495,-0.207845740166,0.508573527162,-0.257901744357,0.804371250557,0.153624363235,-0.215831263074,0.82060268549,-0.478512750519,0.212970555036,-0.309688066789,-0.122085496597,-0.172286360142,-0.10331520814],[-35182.072516,-4688.26417185,5584.78664098,1628.43535658,3819.81049979,-918.137201386,166.800761955,74.9087250116,263.481221885,256.880293083,-113.934519307,379.441694868,125.825051539,470.886124616,730.588061372,116.337430188,-38.9030321451,-121.857170119,208.152572016,-53.4314524137,29.5657762793,24.9648205415,-308.447607266,-148.3863667,50.0571679426,-13.7904269748,-27.0424440265,2.50850933868,-49.1085836968,-69.9834978495,-158.165130439,-82.5677528714,-41.7340139971,67.2809472421,48.1870179577,4.77718129096,12.4284866196,19.2822344716,19.0838088871,-25.3395853924,-22.2442482798,-95.341689102,-14.0623969586,-49.3334797999,26.240317259,-18.3499815572,5.02668643979,19.8445182519,-0.560016478896,1.94565878961,11.2767533443,10.7342000412,-4.77018896914,-5.59318697965,-26.8949078604,3.69207550529,-21.0953694057,15.7267121813,-9.2425532901,3.25399799614,9.55664442944,-13.8920721442,4.25773403356,-2.72209616238,-2.48173247575,2.02175410671,1.16881650867,-0.905553421258,1.78742335309,-4.21679587398,1.91716892548,-7.76734918204,8.16676999186,-5.01237173042,2.44254882043,4.05528518725,-7.13375018927,3.69478459179,-1.41704423067,1.6957037589,-1.1501012133,-1.05337632873,0.205344984101,-0.920487046196,-0.311941879349,1.20606452272,0.0540890680506,-0.180039450858,-1.92720976093,2.70412530355,-1.26093577179,1.93378848204,1.30479981499,-1.43710120039,2.09238069528,-0.836018154671,0.66789383328,-0.604912613321,-0.0744034404772,-0.143031553008,-0.159048661888,-0.0519319307313,-0.478092416995,-0.079393786384,0.351678428288,0.194580844039,-0.116027322703,-0.197676095716,0.49014967961,-0.239981631535,0.777125924156,0.170296730007,-0.210032393606,0.815839860383,-0.508406819056,0.196335057998,-0.328131561497,-0.144226866909,-0.190733598019,-0.111571113944],[-34979.3961437,-4539.25838061,5635.95121241,1653.3187669,3680.4254113,-956.206001097,275.733486,138.595226771,263.960344812,211.506886682,-113.876741671,431.885002712,228.954883722,525.837963393,744.693372355,136.953457637,-14.4973853991,-137.035655988,216.494107107,-36.0803169118,22.9256780615,11.8510723907,-282.677363284,-154.55354234,62.0873390041,-0.454289161857,-35.6026268854,-0.326906862575,-57.5823378454,-80.4758603968,-146.855195855,-78.4021095986,-31.9034920841,75.3091809317,44.7913926938,5.91822224625,14.5840059147,17.0481835594,19.5742396473,-31.4664431637,-23.600155793,-91.5918749827,-13.6114763643,-47.1482532317,26.0823213691,-21.65501617,5.42665371872,16.5134501018,-1.60454194554,1.41456374896,10.8310344705,11.3689319259,-6.6730445068,-5.35693515774,-26.26113443,3.20342607449,-20.7244066818,14.5078907376,-9.92288328344,2.65547481684,8.45184173722,-13.6134084884,4.42492744463,-3.06712416315,-2.91483842804,1.95791357342,1.28803719434,-1.22091598749,2.06753762971,-4.30250376085,1.80955810873,-7.75235785535,7.50735025752,-5.09334732886,1.95969658895,3.75268423623,-6.99410408859,3.5721513044,-1.62400520512,1.6970866018,-1.17351673091,-1.14006148227,0.203123311744,-0.955736115073,-0.368628138623,1.33374407044,-0.0924971837313,-0.169811388808,-1.89599117171,2.51530897652,-1.19291457754,1.78995728756,1.34705983291,-1.39594346688,2.05596399645,-0.903258907247,0.615150069195,-0.657867304285,-0.0768586632421,-0.12385547108,-0.143897960735,-0.0358240399585,-0.512352467025,-0.0850431070065,0.374003787811,0.139958703295,-0.0939681776422,-0.181180239016,0.46245456215,-0.215976335285,0.743256201015,0.188263051546,-0.205659369953,0.806719026144,-0.530770804239,0.178461238312,-0.344253350389,-0.162365614609,-0.209207812093,-0.117285288076],[-34793.2018507,-4358.06833192,5644.21310831,1646.81411487,3524.91881824,-1000.40051746,381.937723137,199.382048931,264.393911138,173.47656419,-100.369657995,494.363869523,331.711988487,583.957300362,762.440682277,159.476165012,17.626767898,-149.422215947,227.827047635,-18.0853085605,16.6658157417,-6.37298298389,-251.784494717,-162.564378663,72.8702136792,15.1754242007,-44.2884051869,-3.05017737824,-63.2913251308,-90.9184284896,-136.862813947,-72.8898678444,-22.9778340861,81.4393198228,40.2916631002,6.08364732664,17.2069353342,14.6194446858,20.1053887047,-36.2350335145,-25.0682892178,-87.5020481906,-13.5366145233,-44.9470756638,25.6933356474,-25.3209081832,5.74956918234,13.7005973639,-2.95275952393,0.922024315384,10.2832827522,12.0460132042,-8.29663538824,-5.1400534785,-25.2889431998,2.47320230905,-20.2079569886,13.3418616017,-10.600582858,2.21745905697,7.426457908,-13.1498387618,4.54356616934,-3.46880003888,-3.39391504716,1.85674677212,1.45098970182,-1.52051681848,2.33638207478,-4.27010509141,1.64053586614,-7.69224240483,6.81806171754,-5.12259526881,1.52333758952,3.4229438079,-6.7662432472,3.40959327342,-1.81763001738,1.67232372076,-1.19776196481,-1.25371437866,0.183675268457,-0.970522353073,-0.436306069925,1.45258352459,-0.212671541599,-0.168825903928,-1.84818897843,2.29634930716,-1.10004271266,1.64481720524,1.37795265493,-1.33630741337,2.00458085948,-0.95366403576,0.555478617692,-0.711062247651,-0.0771184838877,-0.0996138190248,-0.138954028704,-0.0269891798656,-0.543968565031,-0.0979689960351,0.39533521424,0.0889306103785,-0.0725165197537,-0.158424837398,0.425428222278,-0.186178434891,0.70205453072,0.205956946397,-0.202788384778,0.791500722432,-0.5450213801,0.15812778003,-0.356839062469,-0.176536781954,-0.227832080249,-0.120613111202],[-34633.651312,-4146.47733803,5612.25615639,1609.28633544,3353.97920145,-1053.41353895,486.779506995,255.285880042,265.050735259,145.203752448,-73.5916908159,565.941978281,432.484857259,641.047349362,783.981491229,183.177958902,58.3936081254,-158.346885,241.390073544,0.47530929896,10.3235680558,-29.3055766671,-216.918972768,-171.130763777,81.9092814689,33.3474952019,-52.8407390244,-5.58317955729,-65.840993181,-101.032470659,-128.199730368,-66.2619870597,-14.7875010711,85.4036215178,34.7828029922,5.1116047752,20.3543599862,12.0172638462,20.7933894434,-39.468597462,-26.5236559509,-83.0677048329,-13.8602582042,-42.6770009797,24.9672708904,-29.3044920562,5.930032061,11.4349315636,-4.61893038053,0.468260427283,9.61634571572,12.8076153823,-9.59443092405,-4.92705572574,-23.9723938085,1.51120657717,-19.5353741005,12.1899757249,-11.2683772574,1.91539339831,6.46912281062,-12.5346199091,4.58938725203,-3.92473118183,-3.92440048354,1.705820848,1.66606599514,-1.79566355899,2.58760447,-4.11641156188,1.41183826887,-7.58099899629,6.08689265202,-5.09632463206,1.12663040794,3.05698148405,-6.46111748795,3.19603554793,-2.0003814894,1.6197444085,-1.22219919048,-1.39765289434,0.143094307644,-0.965017383861,-0.513782908927,1.55786684982,-0.30329847529,-0.178284804829,-1.78295196839,2.04593860414,-0.982417424175,1.49570131377,1.39295889948,-1.2603774801,1.93379853909,-0.986973718723,0.487994873496,-0.762800143764,-0.0754331205439,-0.0701510453779,-0.145632306663,-0.0261422876379,-0.573270208749,-0.118519909791,0.41440415901,0.043125081257,-0.052668184129,-0.129765553404,0.379463354828,-0.151064255667,0.653183356691,0.222096596275,-0.201384764046,0.768879369156,-0.550613475417,0.134405906338,-0.364857807012,-0.186869961732,-0.246717503195,-0.121774353433],[-34493.512891,-3905.55241954,5551.66777291,1542.54386362,3170.37370348,-1113.25187693,592.706863365,304.373617718,266.501230922,126.762565991,-35.8334967952,642.668987713,528.431293767,694.410653467,806.145693669,207.541914236,106.654439061,-164.594194304,255.390924088,19.1775301336,3.78840747252,-56.2287674013,-179.316860009,-180.063939657,88.9987949769,53.8020696632,-61.4538961487,-8.0159792144,-65.3357355285,-110.700017279,-120.720457716,-58.7760586354,-7.62596325041,87.2680506747,28.4471107687,3.04498399772,24.0320679422,9.21212831341,21.7043527424,-41.2188669147,-27.9149016576,-78.2947072151,-14.5117991444,-40.355170413,23.9670596646,-33.4819770393,5.9578936908,9.72114843597,-6.54694946057,0.0749942727589,8.84280872105,13.6880068862,-10.5790355039,-4.69710954887,-22.3504454182,0.374309914976,-18.7052179866,11.0780811978,-11.9078183796,1.74877652822,5.57422445324,-11.8110116439,4.55631388303,-4.41446418365,-4.49194476153,1.5137168839,1.93857225733,-2.04489058241,2.82376606265,-3.85753293638,1.14050694647,-7.41183693732,5.33038650859,-5.01143937829,0.776431882446,2.65705072856,-6.09267906366,2.93019716417,-2.17526154376,1.54205333621,-1.24388137576,-1.56732257737,0.0852283397359,-0.94005214765,-0.596850768769,1.64923515689,-0.365968720915,-0.194232641701,-1.70062180991,1.77188384145,-0.842640333183,1.344794089,1.39161355418,-1.17109422916,1.84298007139,-1.00394708935,0.413550610601,-0.812591334196,-0.0722171781406,-0.0363286922061,-0.162906504611,-0.0321532220496,-0.599913831574,-0.144610228377,0.430788027957,0.00336760989676,-0.0342186644665,-0.0967140304163,0.326763243994,-0.111845107033,0.597785097699,0.236538435588,-0.20097036691,0.739284907234,-0.547155037956,0.107536996967,-0.36801261437,-0.193872948857,-0.265927272947,-0.121246342664],[-34361.2066232,-3636.18152415,5476.26127125,1448.7560094,2977.38913229,-1176.7508485,702.438316075,344.724711841,269.391211713,117.642041275,10.0862088757,719.841050481,616.401429817,741.724588063,824.932782649,232.103773031,160.742345334,-169.312299061,267.779603348,37.5109116126,-2.96217010661,-86.3455708428,-140.235741855,-189.449986742,94.0056975829,76.1521343395,-70.4354712255,-10.4806892807,-62.0046821822,-119.843289183,-114.240200323,-50.6963319475,-1.90244312147,87.1819987153,21.488715975,-0.0221403092779,28.2330230151,6.16183567969,22.8918838545,-41.594696504,-29.2090815704,-73.1915091925,-15.3973653242,-38.0162470347,22.7978899795,-37.7094160807,5.83681843432,8.5578747685,-8.66312015404,-0.230676397651,7.98269158681,14.7194803717,-11.2778372874,-4.42804606373,-20.4732820716,-0.868849474453,-17.7183501644,10.048150396,-12.4976647865,1.72312113541,4.73759037884,-11.0247743722,4.44281578917,-4.9130304358,-5.07725087396,1.29426944704,2.27304322617,-2.26853894431,3.04965646639,-3.51440349598,0.847409918045,-7.17776882094,4.57222552676,-4.8650171866,0.483023414369,2.22823897577,-5.67563083471,2.61324565521,-2.34540687817,1.44304901973,-1.25928416165,-1.75620089372,0.0158638894203,-0.896622413789,-0.680547981955,1.72741884307,-0.403454581181,-0.211424650131,-1.60183839152,1.48427065948,-0.683939154286,1.19549285607,1.3744651989,-1.0715872531,1.73243743778,-1.00559801953,0.333431697813,-0.860248070825,-0.0679263583079,0.000737425041278,-0.189139899833,-0.0434305722722,-0.623387600817,-0.173545812839,0.444275715521,-0.0297170652351,-0.016663369116,-0.061070907025,0.269983821314,-0.069916044439,0.53737216635,0.24942346192,-0.200956185822,0.703581157831,-0.534292270228,0.0780549707832,-0.366189995163,-0.198148088775,-0.285512604345,-0.119570796237],[-34225.1525442,-3339.25259952,5399.84996479,1330.09208279,2778.31229586,-1240.74577076,818.692388953,374.418612293,274.366491215,117.331214758,61.3487110052,792.754319245,693.245397213,780.666528534,836.34225122,256.399277302,218.990411572,-173.64935447,276.506115408,54.9650114051,-9.9506687799,-118.859002648,-100.933203718,-199.37498547,96.7969326665,100.010675986,-80.09305892,-13.1094226872,-56.0769631507,-128.384507206,-108.574162524,-42.2870563719,1.97383681837,85.2948570614,14.1117481561,-3.99569344931,32.9501890174,2.82418353741,24.4095880328,-40.7049408614,-30.3732509219,-67.7665646204,-16.4230847235,-35.6948939162,21.5649498444,-41.8428621285,5.57047065411,7.94373734869,-10.8937458509,-0.42165383341,7.05601413161,15.9343284947,-11.7182244338,-4.09769638614,-18.3910878117,-2.14963338803,-16.5756321515,9.14215569497,-13.0166750398,1.84393990861,3.95504813039,-10.2216684998,4.24736269731,-5.39546132977,-5.66102181366,1.06131310467,2.67401363946,-2.46694970025,3.2700652949,-3.10795752177,0.553415202721,-6.8718072402,3.83609194605,-4.65413573613,0.256686405047,1.77563366004,-5.22467566145,2.24634855409,-2.51395419038,1.32652997488,-1.2648831891,-1.95776530932,-0.059212518615,-0.835723951629,-0.759912880992,1.79314830563,-0.418528358793,-0.224616065706,-1.48724160178,1.19318469858,-0.50954160209,1.05119494012,1.34206241351,-0.964986144471,1.6024826197,-0.992940381161,0.248924003943,-0.90558260553,-0.0630163626761,0.0399314909152,-0.222695769614,-0.0583829274771,-0.643179683789,-0.202632524222,0.45465611614,-0.0555042056716,0.000502293572889,-0.0246368218209,0.211781018321,-0.0266721233324,0.47345697525,0.260892672852,-0.200753213233,0.662631942115,-0.511671374746,0.0464937466519,-0.35927646001,-0.200297726933,-0.305524712229,-0.117289431495],[-34073.7706896,-3015.65359335,5336.24716691,1188.7213938,2576.43000214,-1302.0719608,944.187605828,391.534768955,282.072883013,125.319122899,115.135294401,856.704946668,755.813327761,808.913850265,836.373592436,279.964169066,279.731722403,-178.75351573,279.52046435,71.0293871803,-17.1995926457,-152.972078474,-62.6668310118,-209.925016282,97.2394436075,124.990681356,-90.7342538978,-16.0342923652,-47.7817084428,-136.245892183,-103.537548651,-33.8124812845,3.59365407176,81.7560171348,6.52033685725,-8.78160072589,38.1765297617,-0.843030521146,26.3110705301,-38.6584546184,-31.3744649446,-62.0283273539,-17.4950853222,-33.4257741285,20.3734272686,-45.7383681308,5.16251471274,7.87736296403,-13.165129941,-0.47084028398,6.08279617402,17.3648439111,-11.9275851028,-3.68389163192,-16.1540466811,-3.39940362267,-15.2779254655,8.40206947027,-13.4436077014,2.11674553655,3.22242525089,-9.44745443267,3.96842433427,-5.83678825702,-6.22396057346,0.828682424016,3.14601823498,-2.64046390579,3.48978216184,-2.65912929484,0.279390819616,-6.48696478813,3.14566800598,-4.37587270599,0.107702255818,1.30432221575,-4.75451640423,1.83067339389,-2.68404017809,1.19629471748,-1.2571540991,-2.16549329013,-0.134214359682,-0.758352530519,-0.829983798385,1.84715394184,-0.413962356456,-0.228562124015,-1.35747132924,0.908711599127,-0.322675391198,0.915297666261,1.2949537779,-0.85442049584,1.45342759858,-0.966988046124,0.161313397798,-0.948407190191,-0.0579428928753,0.0801376899666,-0.261937391239,-0.0754188768358,-0.658778247803,-0.229176223575,0.461718124253,-0.0733690729458,0.0177829152502,0.0107875866054,0.15481076655,0.016491600838,0.407551937006,0.271087065968,-0.199772441595,0.617301081252,-0.478938554022,0.0133872434392,-0.347158519531,-0.200924208778,-0.326014811439,-0.11494396578],[-33898.6494023,-2669.25990189,5294.45456313,1027.3832053,2375.34618196,-1358.26801943,1080.77125834,394.497751952,293.127752426,140.719236811,168.950891334,907.852117333,801.566874717,824.790960057,823.026446317,302.327275109,341.004319347,-185.493515335,275.345493491,85.4110413783,-24.5524017491,-187.467619949,-26.5606064057,-221.134656676,95.2466084221,150.581274388,-102.545796988,-19.318466946,-37.3354869282,-143.347352571,-98.9223194969,-25.5612114598,2.65599848566,76.6098471518,-0.974812319881,-14.2597913356,43.8701105969,-4.84942384171,28.6106481475,-35.5748252488,-32.1912600946,-56.0077391293,-18.5526466384,-31.2191189749,19.267770556,-49.2111712425,4.60911442617,8.36327608315,-15.4005264287,-0.356363820719,5.08646998412,19.0196134239,-11.9392190033,-3.1716889206,-13.8181291938,-4.5657763251,-13.825307044,7.85030826588,-13.7467448826,2.53716701666,2.54212578686,-8.74702972781,3.6122799548,-6.21351500979,-6.74678826265,0.609189073543,3.68723986512,-2.79140946169,3.71101017063,-2.18900574291,0.0414749205596,-6.01909158361,2.5198317784,-4.02718636979,0.0412321702022,0.821635385661,-4.28134831994,1.37075437215,-2.85839251328,1.05828286441,-1.23342805216,-2.37264326566,-0.203926188651,-0.666247001,-0.88639891221,1.88976970275,-0.392742200697,-0.218967778877,-1.2140711732,0.639749506699,-0.12690728869,0.789958626574,1.23434861647,-0.743871691757,1.28644367291,-0.929394371586,0.0728175092841,-0.989049840382,-0.0530528060261,0.12006357617,-0.305147465433,-0.0930322171438,-0.669655883374,-0.250590241098,0.465309149941,-0.0829293481413,0.0356591861411,0.0433894441733,0.101426713884,0.0580869414591,0.340936478749,0.280199935735,-0.197802845717,0.568494791518,-0.436309905855,-0.0204741353416,-0.330108434224,-0.200527472799,-0.346955565369,-0.112861556021],[-33704.0502555,-2315.89671569,5264.22732742,851.096591611,2179.93325758,-1409.68568237,1226.80570938,383.112612372,308.034671704,161.142766242,221.595023919,945.80714351,830.413777136,829.21039038,802.301040768,322.989761292,399.666071493,-193.620394955,264.795403081,98.6867555241,-31.1363799217,-219.447672587,6.79589841393,-232.832472397,90.9175436731,175.776127744,-115.231013674,-22.7493378621,-24.9046229197,-149.599547325,-94.4274616878,-17.9192732665,-0.707290715804,69.4806225066,-7.63668954723,-20.2062100473,49.849403016,-9.07427352229,31.1654838787,-31.6165715967,-32.8480977225,-49.8256932063,-19.6676543422,-28.9874326873,18.0494691891,-51.9132454451,3.8764314239,9.42959189925,-17.5109917753,-0.0772558025646,4.10411763797,20.8124004247,-11.8100720424,-2.57504938655,-11.4624517474,-5.66138504129,-12.2147155035,7.43106529968,-13.8524628934,3.0612985812,1.94285979911,-8.16184054708,3.21644692523,-6.50803498334,-7.21029845641,0.41155312658,4.2704538406,-2.93006164956,3.92560638362,-1.71928438019,-0.163113811793,-5.47538784886,1.95824466452,-3.60455737903,0.0419565604622,0.343877146164,-3.82733625153,0.884592344392,-3.03810276479,0.926998436675,-1.19445828704,-2.57159751961,-0.265416878625,-0.564118538369,-0.927195782809,1.91974375449,-0.358706813317,-0.195336857052,-1.06219957596,0.390446587767,0.0728397284593,0.672376480851,1.16409923173,-0.640728284765,1.10613940955,-0.884370655802,-0.0106189872996,-1.02990162647,-0.0482575812122,0.157710181193,-0.350286386695,-0.110057575694,-0.675222873845,-0.264717783605,0.465510665851,-0.0847723905446,0.0545161907706,0.0713069348424,0.0527733735807,0.0962531872605,0.273958085716,0.288633764163,-0.196145329837,0.517288869623,-0.386281109196,-0.0532740475871,-0.309941464103,-0.199197829662,-0.368005431614,-0.110511117498],[-33497.40313,-1974.37667384,5230.50900588,665.450579942,1995.3807741,-1457.37996907,1379.78208965,357.529521549,327.268764831,183.825355598,272.190861732,971.04436939,842.873295523,823.73170512,782.197750662,341.445878248,452.279804821,-202.605773554,249.257232606,111.650755914,-35.8997669418,-245.594087874,36.9467145054,-244.79552625,84.39780056,199.445051269,-128.372375603,-26.0453522464,-10.6428795913,-154.910823024,-89.7287183086,-11.2970484717,-6.25616196416,59.8875953879,-12.6217089401,-26.370805523,55.8979800481,-13.364271599,33.7934522655,-26.9569453486,-33.3809204028,-43.6255707259,-20.945145642,-26.6187877293,16.4592729449,-53.4557489269,2.92312678881,11.1103232867,-19.4045330562,0.362226589651,3.17623366308,22.6332624523,-11.6030016767,-1.91516016782,-9.17191721085,-6.71511766702,-10.4423048808,7.06897795799,-13.676661593,3.63535077111,1.45991385199,-7.73247020345,2.82625213979,-6.70421397369,-7.59530284638,0.243471757681,4.86208358676,-3.06868259617,4.12284135289,-1.27181536756,-0.341886562076,-4.86589133192,1.45576389787,-3.1043469797,0.089435641045,-0.11040521794,-3.41613743852,0.393554830644,-3.22385347571,0.819086556345,-1.14185356204,-2.75451929924,-0.316326382265,-0.457421399116,-0.951011816096,1.93542781697,-0.315908439939,-0.158122903531,-0.907918690589,0.163763514019,0.271303630801,0.558510155818,1.08871867072,-0.553230619402,0.917982692389,-0.836767682297,-0.0821196565573,-1.07386938252,-0.0433598530077,0.190901906127,-0.395233972965,-0.125414787402,-0.674873925763,-0.269509527067,0.462462660275,-0.0797279789925,0.0747151122386,0.0926660070828,0.00969297524739,0.129036495807,0.206731257671,0.296843330148,-0.196478780549,0.464801507383,-0.331917738284,-0.0829396665464,-0.288858619056,-0.196923183075,-0.388744316323,-0.107147005077],[-33286.1379063,-1663.51241546,5178.24314462,476.034197487,1826.87827665,-1502.40589896,1537.19152984,317.898650814,351.305155791,206.002649283,319.86157435,984.038139166,839.464690384,809.914468162,770.716950875,357.189876608,495.40834531,-211.921270097,230.11802155,125.097268843,-37.7908025879,-262.588717296,63.4358729271,-256.80088104,75.8329302822,220.457854809,-141.552354422,-28.9249572317,5.29597988319,-159.189526248,-84.5018324444,-6.1049188425,-13.750563691,47.3500179843,-15.086284614,-32.5035264246,61.7994147224,-17.5661101078,36.3124278499,-21.7691981912,-33.8256707097,-37.5507528288,-22.4901577458,-24.0012565651,14.2379316004,-53.449839876,1.70786160381,13.4394831197,-20.9891573469,0.957826175095,2.34331258699,24.3722570452,-11.380865363,-1.21320840249,-7.03142845285,-7.75586209809,-8.50422921224,6.68868362714,-13.1352408411,4.20553412735,1.12857450984,-7.49950200991,2.48702249271,-6.78591777685,-7.88261312418,0.112642141397,5.42855252891,-3.21953442833,4.29198563055,-0.86844886588,-0.502354514927,-4.20063978086,1.007246712,-2.52291641776,0.163229626397,-0.522664421849,-3.07140912041,-0.080990649077,-3.41632718911,0.75119234548,-1.07722263546,-2.91357185181,-0.354294652231,-0.351609839729,-0.956484417984,1.93517361007,-0.268399326186,-0.107779463308,-0.757290670139,-0.0373390428545,0.463222388884,0.444318578204,1.0127199805,-0.489619040209,0.727441405352,-0.7914362346,-0.134808063093,-1.1238599426,-0.0381622559867,0.217463152065,-0.437870042182,-0.138023687186,-0.668003745678,-0.262916147452,0.456305121502,-0.0686258923221,0.0966171336451,0.105592609364,-0.0269722515107,0.154483024664,0.139370494374,0.305283412586,-0.200482084449,0.412150896618,-0.276285367357,-0.107398165468,-0.269060908976,-0.193691436748,-0.408752125646,-0.102023573624],[-33077.6844651,-1402.11657966,5092.37328973,288.436471443,1679.61531034,-1545.81849148,1696.52516066,264.370171499,380.618968569,224.910291702,363.730331351,985.26279703,820.707222223,789.318243391,775.85901628,369.716007004,525.614518941,-221.038503548,208.764809399,139.820520607,-35.7577266383,-267.11341234,85.8074047374,-268.625599573,65.3684840391,237.684348206,-154.353421779,-31.1065999508,22.7581923298,-162.344003575,-78.4225471799,-2.75326614618,-22.9504443278,31.3871424844,-14.1868306841,-38.3543214141,67.337280068,-21.5264810848,38.5402851736,-16.2265818109,-34.2182912174,-31.7446206558,-24.4077278619,-21.0229116583,11.1261949325,-51.5066764807,0.189296951778,16.4510842727,-22.1728717232,1.70528577293,1.64584893724,25.9194417424,-11.2065205577,-0.490381228611,-5.1258883422,-8.81250623026,-6.3966425345,6.21481969346,-12.1441004969,4.71805919088,0.984128337021,-7.50351927946,2.24408487821,-6.73701218884,-8.05304098147,0.0267614522806,5.93628409237,-3.39487927282,4.42230976868,-0.531035036007,-0.652028854981,-3.48967094372,0.607550340454,-1.85662693922,0.242898730966,-0.874353180762,-2.81680853667,-0.51767657475,-3.61620644808,0.739960926141,-1.0021742656,-3.04091842457,-0.376961641185,-0.252138116698,-0.942250994384,1.91733285371,-0.22023171768,-0.0447600813734,-0.616377667671,-0.209900411166,0.643333973262,0.325760674737,0.940616208099,-0.458133891726,0.539983432351,-0.753227096238,-0.16180777151,-1.18278014076,-0.0324674247234,0.235218320098,-0.476074412287,-0.146804109962,-0.654007040135,-0.242888320729,0.447178037822,-0.0522959093704,0.12058343809,0.108212690156,-0.0563800770878,0.170638931396,0.0719902955894,0.31440879037,-0.209834128131,0.360455229145,-0.222449570652,-0.124576717602,-0.252749343751,-0.189490494389,-0.42760876573,-0.0943951780074]])
    return models,coeffs

def get_cals10k():
    models= ['-9950', '-9900', '-9850', '-9800', '-9750', '-9700', '-9650', '-9600', '-9550', '-9500', '-9450', '-9400', '-9350', '-9300', '-9250', '-9200', '-9150', '-9100', '-9050', '-9000', '-8950', '-8900', '-8850', '-8800', '-8750', '-8700', '-8650', '-8600', '-8550', '-8500', '-8450', '-8400', '-8350', '-8300', '-8250', '-8200', '-8150', '-8100', '-8050', '-8000', '-7950', '-7900', '-7850', '-7800', '-7750', '-7700', '-7650', '-7600', '-7550', '-7500', '-7450', '-7400', '-7350', '-7300', '-7250', '-7200', '-7150', '-7100', '-7050', '-7000', '-6950', '-6900', '-6850', '-6800', '-6750', '-6700', '-6650', '-6600', '-6550', '-6500', '-6450', '-6400', '-6350', '-6300', '-6250', '-6200', '-6150', '-6100', '-6050', '-6000', '-5950', '-5900', '-5850', '-5800', '-5750', '-5700', '-5650', '-5600', '-5550', '-5500', '-5450', '-5400', '-5350', '-5300', '-5250', '-5200', '-5150', '-5100', '-5050', '-5000', '-4950', '-4900', '-4850', '-4800', '-4750', '-4700', '-4650', '-4600', '-4550', '-4500', '-4450', '-4400', '-4350', '-4300', '-4250', '-4200', '-4150', '-4100', '-4050', '-4000', '-3950', '-3900', '-3850', '-3800', '-3750', '-3700', '-3650', '-3600', '-3550', '-3500', '-3450', '-3400', '-3350', '-3300', '-3250', '-3200', '-3150', '-3100', '-3050', '-3000', '-2950', '-2900', '-2850', '-2800', '-2750', '-2700', '-2650', '-2600', '-2550', '-2500', '-2450', '-2400', '-2350', '-2300', '-2250', '-2200', '-2150', '-2100', '-2050', '-2000', '-1950', '-1900', '-1850', '-1800', '-1750', '-1700', '-1650', '-1600', '-1550', '-1500', '-1450', '-1400', '-1350', '-1300', '-1250', '-1200', '-1150', '-1100', '-1050', '-1000', '-950', '-900', '-850', '-800', '-750', '-700', '-650', '-600', '-550', '-500', '-450', '-400', '-350', '-300', '-250', '-200', '-150', '-100', '-50', '0', '50', '100', '150', '200', '250', '300', '350', '400', '450', '500', '550', '600', '650', '700', '750', '800', '850', '900', '950', '1000', '1050', '1100', '1150', '1200', '1250', '1300', '1350', '1400', '1450', '1500', '1550', '1600', '1650', '1700', '1750', '1800', '1850', '1900', '1950']
    coeffs=numpy.array( [[-11879.5124795009,-1051.85242165007,-1764.27926483403,15.8172783704635,897.994334841120,420.100581694191,1399.03772956815,101.979103095417,-20.0170661838267,-15.7552634534317,31.6537958989222,-68.0182921123384,-63.0259088574744,-252.973632944288,15.9377292070309,-44.2626302575369,-51.1942635044333,-49.8940871945832,-34.5664641996341,-32.7464600211636,33.8406771791881,-52.8478435832710,37.7072039713272,-54.0547399412226,-12.4496673590095,-7.85281553469197,-13.2984093962937,-5.31515872789975,-2.68905331713219,2.21640099326486,-7.52279717592054,-9.70984447484000,11.5374617760522,-0.503736926153977,20.6482703708749,-2.16616986305257,-0.900689899043482,-1.37626219654872,-5.44663619918808,-0.525009207574971,-4.96279222831167,-1.42446186174534,-1.91114348112935,1.55826416375387,0.344127388566689,-1.87493322388042,-1.83177723605350,-4.63988801834656,-0.537844117904056,-0.165839620583098,-0.224128043236587,-1.76020470735499,-0.585617179517441,-0.672032856327500,-0.589311012703488,0.119347588592072,-0.212718797646939,0.306711180251015,0.194808833729420,0.791334202927492,0.606792073161052,0.937604108111202,0.558948960581751,-9.316262773823115E-002,4.297665167622611E-002,-2.753877979896062E-002,-0.166812829178604,-0.133799866018003,-0.131773612137995,-3.856028442360664E-002,-0.159240749131889,0.181997741909833,-6.667734040264195E-003,0.331230794950652,3.057216438972110E-002,-4.757998663520626E-002,-0.279669884776308,-0.111715159228943,-0.269970946513413,1.631336516441652E-002,-1.027029784569346E-002,2.162805720780643E-002,3.537148882415227E-003,-9.061571511997168E-004,-1.521561798535054E-002,-7.932339975780560E-002,7.232082348947844E-003,-5.421260009582072E-002,2.144646200626040E-002,-1.578062577907372E-002,-2.141961534532906E-002,-2.588678419610645E-002,-6.276296742655714E-002,-1.852190971472399E-004,-4.214509406883998E-003,8.974807188371879E-002,-2.318753970378513E-002,4.893441383581788E-002,-5.239354890181511E-002,-3.926180179920313E-003,7.542522488173247E-004,-1.444237824198606E-003,7.741040848807613E-003,-2.523700334261826E-003,-1.031304477714604E-002,-7.144499438173558E-003,-3.650729922858986E-003,-1.275653897712469E-002,-7.378057010244619E-003,2.383288953805646E-003,2.177495603637741E-003,9.776036336715378E-003,1.496508303528435E-002,4.023071352786550E-003,-1.905384258837344E-003,1.020599352574908E-003,-2.064315446339099E-002,1.416271541192838E-002,-3.027593226222059E-003,1.936707403089839E-00],[-12153.9888416636,-1163.89139623372,-1757.71986414325,30.4816784690459,1103.59078010704,407.144024823364,1544.59414146826,165.867651473345,-18.1443196073668,3.64929086606526,36.6744766444332,-133.040079667783,-34.9580913933874,-370.376130437538,4.35152252547118,-65.8575368122241,-57.5715641551129,-92.2309173295204,-62.5835374677636,-62.4703341408083,40.9245806315513,-60.6577869472870,46.6725314585272,-53.9440686969746,-16.1446109481420,-11.9897684537185,-23.7448293378501,-10.1926355176967,-5.84388193299909,3.05758239449162,-6.22913351842133,-12.6807816316900,17.0464001153874,-1.85394896611776,28.1184215202564,-2.70685845040632,-2.33321137854545,-3.09035039876005,-7.50346949573736,-1.37214395859485,-7.57442482748964,-1.09434177755355,-3.69881610213523,3.45616094284248,-7.691416401819348E-002,-2.08722592402230,-2.18568954125863,-6.21089077252302,-0.860163996788107,-0.465578166591479,-0.633249016975410,-2.61734758512135,-1.32168067894843,-1.12865926815996,-0.852866865268058,0.301208565336713,-0.165816649470227,0.425629215452197,0.565865104901077,1.05435329762493,0.917401279420018,1.33831790119420,0.747811228137813,-0.117059799385426,4.262531408004088E-002,-6.336047214577271E-002,-0.307087110386732,-0.304962320319854,-0.283977356178381,-0.101965473335323,-0.259068377656161,0.303698891696903,-6.170439944235605E-002,0.596220825150331,0.139255480593505,-2.335011421432490E-003,-0.342453233267992,-0.147492357525846,-0.412901402370863,8.963841978281312E-003,-5.573116697800613E-003,4.071780910798781E-002,-1.165597741327196E-004,-2.819716067327532E-002,-5.676163990727481E-002,-0.141078670996905,-1.644057479351508E-002,-9.320304201586135E-002,4.841156879951926E-002,-2.559622226747384E-002,1.292560713797889E-003,-2.097976646669184E-002,-8.284527530517778E-002,1.064942546384411E-003,-1.584838503322730E-002,0.114094964906712,-2.477963492448396E-002,7.543365223573942E-002,-6.681658499480032E-002,-6.291463515953783E-003,4.593385166516131E-003,-1.841066374476000E-003,3.126399021018123E-003,-1.351080139094062E-002,-2.143165035025260E-002,-1.870445528521833E-002,-1.082161126716039E-002,-1.920026872384771E-002,-8.687730332799775E-003,8.076202774696482E-003,1.022819221204225E-002,2.183473781962723E-002,2.410403836255487E-002,1.171031668987037E-002,-4.663847198103033E-003,3.732492699672382E-003,-2.559983048436641E-002,2.011693156467047E-002,-5.349552011025539E-003,2.601577727122742E-00],[-12457.4499179563,-1247.00409644853,-1753.49131065783,34.5134654088036,1235.84459798163,380.226956791183,1629.68460753902,219.527448656964,-17.1635353048792,25.7650865906931,34.7365106769821,-192.483439404427,-4.53634884480989,-478.922734164277,-8.01926182161859,-84.2338685603913,-59.6992010686939,-135.605746232690,-90.6299624641993,-88.9918048477839,46.3603808906046,-63.9486157173983,54.8626608951545,-51.8162981475669,-18.9209095860083,-15.7970651568306,-33.9226328871542,-15.0232898666954,-8.04934165692409,3.81993561443550,-5.04674629608604,-15.0495929577490,21.0075993336363,-3.48596686734983,34.4748594235602,-3.18131693423279,-3.66504134547221,-4.87778975236230,-9.25579783032275,-2.21532900971659,-10.0221108249040,-0.715415265535110,-5.43317933538064,5.31310397124194,-0.529931811225982,-2.29353120622044,-2.33050517385655,-7.52483215453846,-1.15100460826731,-0.726198515649620,-1.10888916872441,-3.42767992180096,-2.05391404940390,-1.56370331674468,-1.04813221829489,0.507527327784711,-0.157711636079542,0.488180968421995,0.878009674583436,1.24876490611598,1.21926412889503,1.69021751417075,0.902414009916558,-0.126474818022914,3.560461692834831E-002,-0.104699755672027,-0.455515850096160,-0.466364717309805,-0.447040522121669,-0.167375076550912,-0.363373554664868,0.399224099318511,-0.123040736278592,0.842494243675077,0.265115644382807,5.627164151082735E-002,-0.379216070686967,-0.184167332371832,-0.539555370799733,6.547190272878379E-004,-1.797911435708405E-003,5.928147132030309E-002,-4.443637635371666E-003,-5.843265045269638E-002,-0.102526117387920,-0.207380644149100,-4.498820287699926E-002,-0.130373411368117,7.394105010587693E-002,-3.158189337654226E-002,2.696470481865954E-002,-1.626193182762350E-002,-9.831498898612426E-002,2.851262834591530E-003,-2.784451388911247E-002,0.134575584850756,-2.225612599643226E-002,0.100333528016235,-7.845683171045813E-002,-9.134713742920252E-003,1.001809917320263E-002,-2.707718455145656E-003,-2.740138465388878E-003,-2.593254118523081E-002,-3.426573781761205E-002,-3.038198350495444E-002,-1.788880470419408E-002,-2.551196288953466E-002,-9.794216241241693E-003,1.414093571809832E-002,1.847952725679682E-002,3.545868651830492E-002,3.422665273895430E-002,2.028138394079385E-002,-6.723855025636192E-003,4.912388992751963E-003,-2.900299450618805E-002,2.407164306108102E-002,-7.781543541415099E-003,3.187460670378862E-00],[-12802.9955284430,-1278.56145298385,-1772.84658669726,26.3927448695934,1306.10815681431,344.721511665913,1659.42077750177,258.151883735102,-17.9999049740087,54.5793862573153,18.9894010888841,-240.388440335773,21.9208275027297,-575.828053805182,-15.8960218000261,-99.0654140723396,-56.9141766250677,-179.828528679636,-116.719231944962,-110.078931744872,49.8627324658555,-63.6557168786823,61.9564675606951,-49.3817565626367,-21.1744016361695,-18.9350150119717,-43.6672758019712,-19.0664041424082,-9.39263290452291,4.18102339342956,-4.20685765764224,-17.4839185827593,23.6863367780453,-5.09000793486395,39.9656973998894,-3.72282910267021,-4.79983180987768,-6.76934032037789,-10.6268738776995,-3.14851536554954,-12.3390303396056,-0.325453667318773,-7.03545523260754,7.16921820542563,-0.931089020242251,-2.44997135857356,-2.33525111928883,-8.65682266834903,-1.42148451768822,-0.961504121975320,-1.64418919374940,-4.18835594107553,-2.76588829267126,-1.96838812692602,-1.15518671054889,0.687209170136749,-0.158058872234790,0.501986601773366,1.12146971038040,1.39941300564539,1.51313119873386,1.99507643321676,1.03726224647612,-0.131019972741895,6.400323307669223E-003,-0.147979408726610,-0.610052874262062,-0.618582148300975,-0.612465260611805,-0.232154384938310,-0.471732769368953,0.470341028418071,-0.182437031628748,1.07067781781708,0.394225673389826,0.121435329444200,-0.398330744687112,-0.219283135714486,-0.645919400804093,-5.417310228559065E-003,-2.301186138167332E-003,7.320333771112549E-002,-7.662727800351571E-003,-9.049667539618286E-002,-0.151612221965505,-0.275377335964699,-7.860954526347741E-002,-0.164384469625784,9.645278134715500E-002,-3.366571164427946E-002,5.543601023118892E-002,-1.242902778531796E-002,-0.105583934939116,4.572370406081985E-003,-3.664767246990918E-002,0.153613293992689,-1.823772636466797E-002,0.122743631069003,-8.839645299141760E-002,-1.254417285082747E-002,1.641807434911792E-002,-3.331059249303098E-003,-9.510897788843481E-003,-3.895795728166253E-002,-4.813331492657454E-002,-4.224515212944396E-002,-2.489539569448723E-002,-3.200839329565859E-002,-1.126069602963707E-002,2.113346518960806E-002,2.604625071181216E-002,5.071387856647532E-002,4.498148430345245E-002,2.896715883639733E-002,-8.229626907914511E-003,4.744063299872836E-003,-3.162435667055807E-002,2.684749079335419E-002,-9.752276578346247E-003,3.737924954272127E-00],[-13276.6292243959,-1264.21686912017,-1807.48393004817,5.15640205211442,1329.08009145629,304.483329876855,1650.52126911717,283.962046027659,-18.8954544657913,87.8994091624504,-16.2315556372356,-271.122913626314,38.4321106282562,-660.442954815561,-17.5605669052200,-108.727763739555,-51.5698351505765,-224.423072846529,-140.030149283368,-124.245802091796,49.9359352965986,-61.0549696570414,67.6695878762310,-47.2878430625079,-22.5728389066206,-21.6741222305442,-52.9923489962919,-22.1426780664281,-9.76804980984606,3.68497296686666,-3.41544374716940,-20.5365335193678,25.7079070144204,-6.42439589102999,44.7770129461838,-4.20654891010946,-5.73515685184119,-8.71419987015158,-11.7424401541285,-4.04984600078912,-14.6732209765191,0.185127614711304,-8.44450918380507,9.08880803314185,-1.15687441152668,-2.42960222282961,-2.26342042971937,-9.67652101770426,-1.62417783453802,-1.16275466239380,-2.17975647591562,-4.91570521640130,-3.38342555291517,-2.38531000531899,-1.11506156226287,0.782884875243446,-0.111182013182222,0.509498643953661,1.31343585152539,1.55146400822721,1.78199693674731,2.24827990694577,1.15749424819431,-0.127347747059888,-3.661098538385499E-002,-0.183046637388800,-0.766088779717906,-0.751920956238946,-0.776952299080126,-0.270112353268967,-0.582349774439820,0.534676732016799,-0.222077964988258,1.28754925946926,0.519203047884077,0.180154813517475,-0.409676239607654,-0.255514320107436,-0.732356287267182,-7.628557644369557E-003,-5.960994077497500E-003,8.393498280138005E-002,-7.208620664271798E-003,-0.122475183212752,-0.199627171556890,-0.341360098922400,-0.108264971585600,-0.194619028432106,0.118087774049326,-2.949319556648490E-002,8.541415241045958E-002,-6.841404494036642E-003,-0.105758343770738,4.200891372490059E-003,-4.111699172523291E-002,0.171343720846928,-1.429823016259228E-002,0.142112978406521,-9.744991208314663E-002,-1.603860074910725E-002,2.384355614959637E-002,-3.103834587609656E-003,-1.607948081414422E-002,-5.141991155895906E-002,-6.159128575521119E-002,-5.234681986222704E-002,-3.154369272009611E-002,-3.757079583348260E-002,-1.240163789062297E-002,2.911686293247554E-002,3.255467114456251E-002,6.612495631797446E-002,5.527433527349589E-002,3.620482927841465E-002,-9.407632700972937E-003,4.126673086535064E-003,-3.409747742519582E-002,2.918464924306708E-002,-1.104630951255642E-002,4.254774822390822E-00],[-13947.5443435392,-1214.35890919233,-1832.24426093216,-18.1945672208918,1299.14066802102,245.805183825876,1600.45493174799,304.304892860399,-14.7635532012453,122.408951081871,-74.5207131436640,-281.798383950751,44.1775432266950,-731.374672284438,-18.9999247383007,-110.448217576912,-45.2567022541621,-269.910600031857,-162.861216070654,-132.137546919040,43.8196709446422,-56.5794457980654,71.4550556569625,-44.0036526587483,-22.0948690280056,-24.3378090555948,-62.2661003027542,-24.9904254668837,-9.05218335829246,2.02707280726473,-2.41519192075459,-24.1893264237546,27.0695935515310,-7.54662872891509,48.6347462351967,-4.40732508406364,-6.45703340918704,-10.6797082053175,-12.8218783034227,-4.80168912120473,-17.2603016954605,0.906662693491187,-9.72843751872300,11.1337637741258,-1.14549142415063,-2.05180380920227,-2.09105093634051,-10.5370190592610,-1.71174698796005,-1.27628520924498,-2.67719043868538,-5.64219546764732,-3.86284343182172,-2.90138271601065,-0.881861973870939,0.776259473756223,-4.888520168067116E-003,0.529941454913345,1.46002195527427,1.70186979647896,1.99581874058954,2.43276965973077,1.25222808685855,-0.106978415953544,-6.869256194741249E-002,-0.203483897881609,-0.922327561361702,-0.855667079013604,-0.952937160281613,-0.262162154655161,-0.698358786583115,0.604229945745946,-0.235184488798708,1.50337469272235,0.647212640603701,0.228696513673024,-0.409331599657102,-0.298148372162978,-0.800196830798741,-8.484649282706981E-003,-1.129946642972728E-002,9.628462076299214E-002,-1.576295208237559E-003,-0.153622290832496,-0.244295280434816,-0.407140453575095,-0.126775007009410,-0.221789451105587,0.142629076073972,-1.586904572272413E-002,0.115450748743668,1.987548993817210E-003,-0.104289622292982,-2.587704699764487E-003,-4.344183617921386E-002,0.183885163714250,-8.752962036250320E-003,0.158464160812271,-0.104546430664181,-1.960761076804183E-002,3.287526313860730E-002,-2.225819277266296E-003,-2.173974066150263E-002,-6.315217729513727E-002,-7.423224121529591E-002,-5.890206253557755E-002,-3.727548309139983E-002,-4.089020941640497E-002,-1.202902895305429E-002,3.758217045882929E-002,3.802642470027083E-002,8.035907349729812E-002,6.435330643316015E-002,4.114810440511737E-002,-1.010821975801775E-002,3.340920270693558E-003,-3.625358540516931E-002,3.061675496151407E-002,-1.202620020549497E-002,4.676340180183133E-00],[-14821.6765041465,-1121.35546291158,-1842.21668295652,-31.4659770908896,1231.14151933796,152.871930625495,1518.74068251947,325.175908036183,-2.77676585671464,162.556096213111,-155.942065186016,-272.045856164474,43.6313744380093,-788.504342083233,-25.2506918123573,-103.761699122173,-38.1919242815642,-316.363279848354,-187.132119120077,-136.005608676416,31.1755260272978,-51.0423705120951,73.1466426810299,-38.8680320586624,-19.4548300891622,-27.1060669814475,-71.8188023742193,-27.9857029322314,-7.71418142243187,-0.486529503910868,-1.30199825717514,-27.9580821457308,27.6684492643485,-8.57846116173392,51.4730562161976,-4.28978845562347,-6.95984781304196,-12.6787815366659,-13.9612011899780,-5.49540829478704,-20.1459060103274,1.83466964009969,-10.9438723171143,13.3158057323086,-0.997670260942462,-1.26581144925333,-1.85699156242904,-11.1876213664112,-1.68570548502206,-1.28886596291531,-3.11820100250782,-6.37699620764545,-4.22814785775351,-3.55327826978621,-0.487161411470277,0.693984825211899,0.110398508728606,0.541401259633657,1.57244387822358,1.83518703552803,2.15154077627050,2.56194792570852,1.30388474459204,-7.181364964942374E-002,-8.218960208481008E-002,-0.205103977350965,-1.07153550915823,-0.931651871003283,-1.14716306776486,-0.219412627663622,-0.819328938070701,0.681036921563390,-0.229357751674422,1.72669089160615,0.784924498028630,0.272338388250685,-0.395578995386986,-0.347989087970383,-0.856820244000072,-7.777895182907764E-003,-1.859952103106067E-002,0.111391806113475,9.965688740875580E-003,-0.183473981935228,-0.285862496038456,-0.474570642705428,-0.133440792877015,-0.245842704029960,0.171735971311035,6.517444549174183E-003,0.142466033650443,1.102190953076430E-002,-0.106171387710567,-1.806768406318867E-002,-4.600475380946137E-002,0.188681203428031,-4.775590440849852E-004,0.172609230250427,-0.110190118081922,-2.306271438506792E-002,4.265868687050203E-002,-6.825373811570869E-004,-2.679489640654473E-002,-7.370525224005582E-002,-8.598697480684699E-002,-6.160293893487120E-002,-4.160241768702431E-002,-4.216260566305131E-002,-9.913684389757474E-003,4.504576870978942E-002,4.269524220299763E-002,9.258823483191436E-002,7.242525329543575E-002,4.399188118081171E-002,-1.045078113904956E-002,2.448090661153369E-003,-3.785987957763014E-002,3.095288928647011E-002,-1.302099547409126E-002,4.984519727605509E-00],[-15869.2324065406,-983.056711813681,-1833.50200204162,-28.0028800261452,1154.29835757881,34.4260979698565,1425.58012860001,354.319982710432,16.9858298630460,212.483160945853,-255.809581920670,-249.325261996749,42.1466564345050,-834.320308847081,-38.4604448923247,-90.7581529722584,-30.6750154978462,-361.820909256543,-213.327496826326,-137.595967111787,13.8602442641289,-46.7357730962448,72.8502609611138,-32.7869317848377,-15.3572673876508,-29.8286473995265,-81.6271473955193,-31.4008186259126,-6.54232819709966,-3.86953506596474,-0.427823830086807,-31.4975832445979,27.8075495780862,-9.46612222145256,53.6017291978844,-3.99813762449813,-7.24583098714044,-14.7803459013490,-15.2768912930393,-6.27060141784256,-23.2153103195498,2.87952126940164,-12.0774957893565,15.5302231515401,-0.838138413895319,-0.143874435665944,-1.62440572794859,-11.6269688787364,-1.59148530779099,-1.23621013831278,-3.50659596560830,-7.11254237194461,-4.51885083232714,-4.34325166273604,-7.638271004314059E-003,0.545903983273976,0.213677502595198,0.529101557481906,1.70917246960767,1.96480972141809,2.25746258474211,2.66380897730751,1.29934391911089,-3.448663496169403E-002,-8.055026097905653E-002,-0.196649380802595,-1.20702605642700,-0.990699491019237,-1.36398649395746,-0.161744739835256,-0.939189684792700,0.769385651507466,-0.214379274376815,1.95527988131766,0.928714099122452,0.309327595347600,-0.372427497573647,-0.402355072019066,-0.907187469525204,-3.194728300257400E-003,-2.799323485946072E-002,0.128396581535669,2.431321342547054E-002,-0.211001582662551,-0.323889180682683,-0.543356830104557,-0.131532462011418,-0.267219663753744,0.204443812589013,3.254038560354381E-002,0.166755520028658,1.892216875401178E-002,-0.111269562733700,-3.834487905609731E-002,-5.078408719222223E-002,0.186049354524586,9.542014294540208E-003,0.184723592128503,-0.115134791569470,-2.585415832869402E-002,5.172963557736280E-002,1.455077271287384E-003,-3.096423329327123E-002,-8.227937863289608E-002,-9.736040593222356E-002,-6.200278757361477E-002,-4.520589376649104E-002,-4.209499088338307E-002,-7.082864452091046E-003,5.081821891246284E-002,4.677162165205346E-002,0.102029164507695,7.929182068560087E-002,4.483960852257031E-002,-1.116469109195839E-002,1.999903943129131E-003,-3.868188363122909E-002,3.082084145946885E-002,-1.391293367979758E-002,5.187906013300654E-00],[-17036.6402329030,-866.989024183672,-1795.69789983879,-10.6626011891341,1070.75736474768,-73.2809245422289,1346.52499050886,410.329288901106,47.1834200136116,266.417729074221,-362.225150523984,-222.956716655690,47.0006438317287,-871.600334691943,-52.6249793253420,-71.9999100816713,-24.6224152047569,-402.170065010385,-240.032321320463,-135.313125565912,-4.32926261970730,-44.5297856738552,71.9579233093758,-27.6237255320214,-10.1734768773493,-32.5303768385034,-90.8823004800168,-35.0580953145707,-5.77178243681713,-8.04764955555487,0.211105420035832,-34.4333287213130,28.0420718085504,-9.89356602647545,55.5585880787974,-3.49911973676294,-7.34659431633391,-17.0040539123806,-16.7139740257494,-7.15921585270430,-26.1322494382774,4.07190762623143,-12.9194047205826,17.6579166790381,-0.716236428684937,1.12781604239483,-1.48291798748035,-11.9008452198183,-1.41462006935039,-1.15476088186130,-3.88451197908127,-7.81626951541807,-4.75625830339407,-5.16645579675973,0.528448798731906,0.367802188540264,0.336317408211709,0.496882248531199,1.91272563233872,2.09914231341687,2.32697551027541,2.76839408475300,1.24616489023104,1.004863736520290E-002,-6.719660150262514E-002,-0.199145103882757,-1.32906407083885,-1.04570050271457,-1.58454023260326,-9.590426593920458E-002,-1.04024614369159,0.877224968717429,-0.190962221370639,2.17384351931178,1.06068640453692,0.326454463805412,-0.349266079807545,-0.455815557516514,-0.951925393574501,1.199518020895671E-002,-3.653354213483957E-002,0.148897792331078,3.436020838559151E-002,-0.236475418187447,-0.360154541895782,-0.607712193051209,-0.124137080839547,-0.282984702185623,0.241043679587284,5.915588882301138E-002,0.189628866460442,2.396656724210260E-002,-0.117386818689151,-5.804228080091592E-002,-5.738051050800683E-002,0.179758249313241,1.976569131788204E-002,0.194410731240208,-0.120011531038954,-2.759639806529043E-002,6.050652591679306E-002,3.216832758512000E-003,-3.449665872083014E-002,-8.944731778940225E-002,-0.108164997602798,-6.148656244145781E-002,-4.836760582041930E-002,-4.084120482648028E-002,-4.129022696383310E-003,5.479061492097942E-002,4.989106744806383E-002,0.108069991860789,8.419422664329440E-002,4.392535289429745E-002,-1.291087625744531E-002,2.647003228639386E-003,-3.883543590284414E-002,3.102963204627677E-002,-1.433372716307647E-002,5.338286958052710E-00],[-18263.6914909223,-819.577754671299,-1730.43801356841,10.3277056221610,970.868085256134,-150.297000328428,1287.13363728722,503.075668711602,88.5045852038735,312.559910442685,-458.644007383123,-196.979628927316,60.6200425114111,-898.812843793445,-61.1379548275232,-48.0795603000019,-22.1311547016308,-432.776808257407,-264.860883180712,-127.196591007925,-19.8013035438402,-44.5839653708461,73.0156715223973,-25.2822557514320,-3.80794443614332,-35.1598593676990,-98.4062036873811,-38.4548675390292,-5.13603086870414,-12.1769292668528,0.435984049397008,-36.0366249807463,28.4827688694252,-9.62535300952108,57.5848926664293,-2.52312819528141,-7.27387506188110,-19.1419732803773,-18.0767842375673,-8.04421263568931,-28.5618980487682,5.27637561701385,-13.1786167071300,19.5187541997044,-0.559658040713092,2.37095818750490,-1.45166397656871,-12.0930936517430,-1.08865890222728,-1.02686154897258,-4.28609980844256,-8.43787284542968,-4.93329027209378,-5.87460917324412,1.07188063895907,0.258294967602648,0.474793699055553,0.488337010795497,2.12238899713620,2.22675290203089,2.35337007477898,2.88233551163461,1.17726167973637,8.101461161529330E-002,-2.819772719773453E-002,-0.234475181333734,-1.43301544323361,-1.09028606775676,-1.77365349520050,-2.420446801770499E-002,-1.09879412987450,0.988181284023337,-0.149612439004994,2.35685461721859,1.16395201549677,0.314925578761226,-0.329631768643751,-0.503080656944145,-0.986969380606202,4.073802623514334E-002,-4.024814900911155E-002,0.178048629216781,3.399363175851243E-002,-0.256797195781923,-0.391319590535252,-0.661039891687797,-0.114296803858289,-0.289535046341082,0.275848179266877,8.769427510864018E-002,0.206145425915979,2.618009331831045E-002,-0.127232559916385,-7.341248467269521E-002,-6.393424031719785E-002,0.174287828192876,2.996566532811398E-002,0.201463584334442,-0.124993242149916,-2.899974500515679E-002,7.132695648726786E-002,2.994040840737123E-003,-3.663880264212836E-002,-9.569206544184326E-002,-0.117019326673055,-6.044326772127660E-002,-5.009694212306921E-002,-3.940508392295057E-002,-2.620814048858178E-004,5.581667357780298E-002,5.208615207402454E-002,0.109979695663085,8.775428302697544E-002,4.185345282325276E-002,-1.493605434849881E-002,4.765160274673160E-003,-3.873465947116386E-002,3.167266153192427E-002,-1.417137041187921E-002,5.486341045021681E-00],[-19502.4192473963,-779.691950443569,-1647.97177327758,26.5074476544995,854.322618686769,-212.709942350570,1225.56635439593,633.429895465540,133.345273984491,345.540041410961,-538.280631475708,-166.276435755244,76.4048297196550,-910.575858980490,-64.1014311319037,-22.1919440161803,-22.4600697360820,-452.755911976334,-285.435838453112,-113.613207700899,-30.7602979197198,-46.0417042129060,77.7835407028564,-26.0846350677955,3.32388256647082,-37.5341441530624,-103.833934751700,-41.0511807177030,-4.43852213891579,-15.2144024140048,-8.541464549230079E-002,-35.8620757755028,28.6135174679744,-8.98187157602016,59.3109984719059,-1.08922847127875,-7.11480520052362,-20.9507577301224,-19.1250981153770,-8.94071628659060,-30.3334642934426,6.17742152864150,-12.7391591787769,20.9401779136629,-0.324806692951264,3.57772181803298,-1.42887996527438,-12.2119143418957,-0.638333610877348,-0.854347808146662,-4.70025451652351,-8.92830802727831,-5.07181032102639,-6.37857458590604,1.56680001331596,0.290288217097945,0.589097022073465,0.511005971901568,2.23168684563109,2.29640566852201,2.32552225648617,2.96861840504085,1.12953594241056,0.178067979612923,2.954586424406565E-002,-0.305310024622630,-1.51527139138555,-1.11374545161256,-1.90640623276015,4.904274769454616E-002,-1.10608328910419,1.07092755768420,-9.390853905701672E-002,2.48577353634817,1.23115825581796,0.282874855662838,-0.305046323936071,-0.543740632765535,-1.00505881884015,7.656413001728339E-002,-3.960077328218914E-002,0.210484336576849,2.460443504893601E-002,-0.270949611481799,-0.413932160224713,-0.700287837387585,-0.106229754013164,-0.286161914859008,0.300286979381157,0.119268724830965,0.210986414173504,2.554096260391804E-002,-0.142820727031431,-8.465518048416611E-002,-6.728413119823197E-002,0.169983053470181,4.186922471159080E-002,0.205259372836500,-0.128983099432136,-3.086513956110964E-002,8.404631261767188E-002,4.667441783930249E-004,-3.751010895586547E-002,-0.101207736774539,-0.122629690602400,-5.899569963429965E-002,-4.918048954599775E-002,-3.867601187241718E-002,5.047965820016262E-003,5.305785764473176E-002,5.255302212604947E-002,0.108091245353829,9.104016285046096E-002,3.954477593927200E-002,-1.593893684803734E-002,7.929174389644453E-003,-3.868690085866162E-002,3.149460008132667E-002,-1.385001549730662E-002,5.599869524726205E-00],[-20721.5046897282,-749.248059363670,-1585.37084396220,35.3321738234277,727.337105664631,-279.551942505878,1148.67809084120,803.861036168917,174.676856187760,366.085628471007,-602.869566131759,-133.140559149771,86.2852100963012,-909.352925985308,-62.3354742351235,1.28443240982680,-23.3175858873543,-463.724607781165,-301.868873318175,-96.2935273751126,-35.9359487310072,-48.7897569009869,86.7615163864647,-30.4087589427331,9.96168440701497,-39.2268058011187,-107.576973025000,-43.0223186205248,-4.03712392291505,-17.2464364720077,-1.38797438323548,-34.4314756427977,28.4978727781308,-8.28307239955085,60.5195649921917,0.425505960141748,-6.96107208582786,-22.4190076209179,-19.8389957003912,-10.0047925994969,-31.4732441827475,6.59091233292103,-11.7455920767168,21.7529953682771,-0.169339507181654,4.65011823520315,-1.38889390300810,-12.2205666235394,-0.191270113839052,-0.700351182595117,-5.10179879817597,-9.28893710625735,-5.21458893157932,-6.67387911758486,1.96686025218389,0.425150747169428,0.654117119773010,0.506543688642212,2.20033243439635,2.26922944550918,2.28027388350949,3.02046346190649,1.13218735192977,0.275213605227919,7.742032480776655E-002,-0.401353464215731,-1.58484692108318,-1.12244351691094,-1.99223397616890,0.113401767724484,-1.07253419061518,1.11573727125346,-4.938832099689092E-002,2.55800228186535,1.25061236212108,0.241079060617441,-0.274136163780510,-0.580865123762173,-1.00821507828516,0.115345612605111,-3.695461806676141E-002,0.236429183334958,1.103157889743325E-002,-0.282436300254773,-0.428693741201732,-0.729971604103309,-0.105023840087214,-0.277003005041881,0.312023413234999,0.147089653167440,0.207590387738122,2.079630490660256E-002,-0.158593490231315,-9.051510789778852E-002,-6.478122903051312E-002,0.167112601938043,5.366808976774511E-002,0.206012647667514,-0.131510157007097,-3.289194720952555E-002,9.648809630820852E-002,-2.687029173407998E-003,-3.817961444925232E-002,-0.105798619900693,-0.126375114617189,-5.819490219218666E-002,-4.682044338782199E-002,-3.825095143681473E-002,1.034814186258045E-002,4.814635805288137E-002,5.008098499612990E-002,0.104164190830579,9.403198865938962E-002,3.772177335040056E-002,-1.606469679079093E-002,1.144346468871607E-002,-3.867292573374981E-002,3.006075585122450E-002,-1.377463030143744E-002,5.656342805841256E-00],[-21953.3236477841,-742.634325788839,-1531.47917004969,40.9756430367609,613.522239817027,-354.767942135708,1065.29243744837,1007.64225337810,212.393367554396,379.232531625624,-652.630515157413,-101.124134962837,84.0852091155453,-904.408437542424,-55.8196078451405,19.2837393058844,-22.8586826336907,-467.258382647583,-315.102218840896,-77.5225611914854,-34.8152091881274,-52.8149847006194,99.2295755256978,-39.0506822876934,14.8977491181481,-39.9137243402452,-110.049442259704,-44.6389082190188,-4.21646673498672,-19.1398351071167,-2.99367396286046,-32.8078857121101,28.7048561123332,-7.49931364888692,61.4900623423828,1.63284310203137,-6.83128268652562,-23.5192491252054,-20.2730135794242,-11.2499674310869,-32.2120973024315,6.62045484661036,-10.5431235294640,21.9057501887250,-0.285716910458818,5.50835628800622,-1.33970396089549,-12.1148845952599,0.119882944368280,-0.626923726020410,-5.41031029837481,-9.54315654676520,-5.35161736070449,-6.80530291000262,2.28190796918594,0.573641780057191,0.669252738560674,0.437816007245474,2.05370847272682,2.16038615856148,2.26921112528393,3.06323897724797,1.20399303333151,0.341450097072905,8.914209405409335E-002,-0.493930616378101,-1.64641850970885,-1.11840010222701,-2.05229901170968,0.173691544004929,-1.01570580548189,1.14119756340400,-3.295227447668903E-002,2.58759099799066,1.22607025365821,0.198047324631994,-0.245683745281883,-0.621168533241945,-1.00745192298233,0.157188583562703,-3.460392437200509E-002,0.248969981017542,4.849898053381490E-004,-0.292579159215395,-0.435101983482307,-0.754431882825339,-0.108164475499818,-0.266824691391335,0.316379928219838,0.165016807608011,0.202088549548612,1.269542015793695E-002,-0.167798815810954,-8.980194257989704E-002,-5.707207307430349E-002,0.167623244336611,6.121670663440142E-002,0.204618757456269,-0.133165261612183,-3.455769738061099E-002,0.106010861170199,-3.879828967541396E-003,-3.900477660159869E-002,-0.108087261928046,-0.129077616959745,-5.787471013751624E-002,-4.460590036920824E-002,-3.687998852803901E-002,1.460589950042769E-002,4.310053562014195E-002,4.486658520853941E-002,0.100149374175840,9.648440564464736E-002,3.615690568970027E-002,-1.635040896164885E-002,1.495083133199017E-002,-3.862041488800096E-002,2.826189775434681E-002,-1.402420751880697E-002,5.684300180692260E-00],[-23250.3095649240,-778.792390930978,-1411.45767683506,49.1159183083491,527.221244343265,-424.524151418918,1006.87793056899,1233.84389465901,252.004362050903,387.918867803228,-682.011417652559,-70.4809853539801,68.7232737939341,-906.814683083717,-43.0284286690033,32.6426830117564,-21.3149471317121,-464.030833349045,-326.424139952592,-58.5465213837447,-27.4343962491369,-56.6277835972265,114.685795960326,-52.4036938293029,18.1551835912506,-39.8363331086272,-111.241840410178,-46.1120734319979,-4.67349888782380,-21.5618021322548,-4.22033850986964,-31.6581446434387,30.0961857329598,-6.26806229004420,62.9609676072060,2.49699653904494,-6.61986336051462,-24.1289906847132,-20.4736237257531,-12.5025160203729,-32.8295034623397,6.61633126058177,-9.37684672850370,21.5855431939771,-0.691385757237910,6.12249107192121,-1.32368589209390,-11.9232784729212,0.283116592043824,-0.605281200979190,-5.54783490802387,-9.71206869895851,-5.40228731063854,-6.79794570613798,2.58651476666456,0.713914007360249,0.642579880129197,0.326601688803220,1.84156737883379,2.01278646881450,2.34773569222757,3.14635411846240,1.35684848427193,0.370656844394557,7.033400039570883E-002,-0.555847569839366,-1.68878221955254,-1.08823419947696,-2.09350442299608,0.243033157863770,-0.944695868349153,1.17557118877319,-3.177472951698595E-002,2.60176114996812,1.18163277221892,0.163144241810707,-0.232575164160633,-0.673790488444380,-1.02226998357415,0.206497522051164,-3.263941615359768E-002,0.253453675739250,-3.806854981245716E-003,-0.295558200545934,-0.432626695227269,-0.773314665153098,-0.108021276438671,-0.255347049803810,0.322502531927453,0.175333190811916,0.198085767577610,2.626176871059533E-003,-0.168417435060631,-8.288116361988893E-002,-4.601575281869165E-002,0.174424782363762,6.200165147730947E-002,0.202764209546629,-0.135834775885465,-3.553808815997344E-002,0.113012146911068,-2.735592869566077E-003,-3.860187584363182E-002,-0.106988604068746,-0.129253594443201,-5.658945127091078E-002,-4.233100993817539E-002,-3.376599029026924E-002,1.859555983384042E-002,3.868146773027369E-002,3.876559314526332E-002,9.758580741243267E-002,9.884893166100915E-002,3.426604092237671E-002,-1.799118598248994E-002,1.828479525144348E-002,-3.883307361530170E-002,2.788009188191180E-002,-1.462527455980456E-002,5.773591024744830E-00],[-24620.1141913837,-878.686887491935,-1205.18758159838,67.5726796759222,464.215458149342,-492.131945763189,980.478558101241,1458.93897615318,296.598839661693,389.791661857402,-686.895163913286,-41.7028158239900,44.7313530184460,-919.225401686077,-24.9098704280659,42.7077720624941,-20.4006917775461,-453.516223341780,-336.052460103177,-40.4912437705551,-15.1369897656455,-58.7661958036335,131.636429270212,-69.5103344455242,20.2133859622355,-39.4802098167104,-110.989028020725,-47.5386952824417,-5.09432440623226,-24.6056822433499,-4.61554005005359,-30.8042851077952,33.0542787928541,-4.13027326079169,64.9930580371764,3.16385434244296,-6.28254606119940,-24.2022104628371,-20.4916100629482,-13.5444137412238,-33.3499355047734,6.85352757495894,-8.30509656742624,20.9855327522025,-1.27930660468097,6.44991212395283,-1.38394019185799,-11.6293956593746,0.351339299524263,-0.605272917166496,-5.49510280906702,-9.80538204386441,-5.29113872415083,-6.64956553345847,2.92616477768827,0.867219192861784,0.576016163303061,0.227562455761249,1.58475268402757,1.84040711032370,2.50283081987615,3.28598285408194,1.57497138404119,0.369087296652507,3.601547105249919E-002,-0.582407149311324,-1.70536119349353,-1.02309065134635,-2.11127680405399,0.325954811975678,-0.860404610961141,1.23083269601166,-2.556060809402867E-002,2.60831225132482,1.13551851313461,0.143355931542094,-0.233871672573994,-0.736694856205166,-1.05823964663083,0.261639777440358,-3.006432229092242E-002,0.257480605508050,-4.022850316364163E-003,-0.289602093221036,-0.422265969744630,-0.784506825921784,-9.832371396268298E-002,-0.241736769023842,0.334708404068761,0.180712536695633,0.196752462076032,-7.957571809763555E-003,-0.160965451675018,-6.932047949908098E-002,-3.365378727049946E-002,0.187311722981747,5.443629542543071E-002,0.200094885065249,-0.139993656117075,-3.543878882928707E-002,0.118413192102455,-3.490591049771374E-005,-3.698168811269661E-002,-0.102515772235009,-0.126524907972371,-5.289254563372042E-002,-3.997078260551909E-002,-2.850444904104102E-002,2.302634334513458E-002,3.522581942073556E-002,3.409654814866075E-002,9.648612479316279E-002,0.101603913846705,3.146745469500419E-002,-2.121796476139221E-002,2.109242090438072E-002,-3.887110261939085E-002,3.001176717498769E-002,-1.522174787378686E-002,5.913531434754615E-00],[-25933.6255570122,-992.649017297773,-952.393227892728,105.851830025263,418.136890654597,-551.844837658618,973.210530467954,1658.42943745866,340.832271028600,382.237683650170,-664.543586746516,-15.1865248278396,15.8157655106681,-935.378272963753,-5.66662028206272,48.8262275206841,-21.2058590180698,-435.025300914324,-342.650813217917,-25.1830105628280,0.799802781677881,-58.6405440997647,147.975699576875,-88.3339124317231,21.0519296186638,-39.2311237948212,-108.930337440494,-48.7618202120292,-5.52880648062168,-27.6463941205540,-4.45070620823107,-30.0024027561457,37.2402187600381,-1.04030639312149,67.2628871038315,3.61514745603832,-5.88963604820323,-23.7193508765271,-20.3370830866054,-14.3368053932131,-33.5717444170063,7.24425987924889,-7.27901496224048,20.2752719212019,-1.86620147901130,6.48889751714748,-1.53095284178954,-11.2635715603495,0.351382805021307,-0.617438637451839,-5.28221160285312,-9.80724043593963,-5.02679775788236,-6.33229542629911,3.26002116153563,1.06604822144296,0.480000711723759,0.168384107246943,1.29540865106575,1.62474351013900,2.68748156971330,3.45814637978872,1.84026312760355,0.345413131737806,-5.743765535366718E-003,-0.581642773940548,-1.69070790954177,-0.924424633151600,-2.08872787140734,0.405238961609535,-0.766321029832987,1.29402542749225,-1.257629367178686E-002,2.59926531446697,1.09207759492243,0.141957388834858,-0.238896053329080,-0.799772717091190,-1.10801838424122,0.311349473857689,-2.621847521898300E-002,0.262005447456530,-2.798557441687251E-003,-0.274495997966746,-0.405313484835102,-0.784129937111868,-8.249784723830877E-002,-0.226769050748931,0.349287214830817,0.180049838464180,0.196745228837866,-1.815180075997764E-002,-0.147142534832049,-4.920465926613141E-002,-1.988635749062536E-002,0.203999214272795,3.952971691451137E-002,0.195411525988283,-0.144354353827897,-3.390403284030275E-002,0.122123314807298,3.169954921829153E-003,-3.450411423328432E-002,-9.554521290961052E-002,-0.121270427876375,-4.715887873369992E-002,-3.771776868515150E-002,-2.191611223990107E-002,2.683196006336781E-002,3.260449923357456E-002,3.169215184706663E-002,9.612733187398151E-002,0.105017738466178,2.805412391523837E-002,-2.568057101919134E-002,2.277380622818357E-002,-3.876167605237663E-002,3.454655949292396E-002,-1.546609081984959E-002,6.033149099961685E-00],[-27010.8578233820,-1072.28495614769,-712.665627958413,165.702245387542,395.161156024791,-594.679768599121,973.818258477728,1812.70729324236,377.933929918092,363.426095342458,-617.347286354077,6.37335395252916,-9.42266013444292,-940.221740219005,12.9074469945712,49.6947845869688,-23.8534960493379,-408.838600375776,-343.517524392039,-14.8644091563417,19.5430023455810,-58.1807105033968,160.636879360536,-107.136044191974,20.1920493296896,-38.7100880622848,-104.837243828001,-49.0971691684346,-6.55268681560937,-29.5377120710311,-4.41358948827162,-29.0816674929625,41.6535243910163,2.74857362462445,69.4921040791926,3.72027614366086,-5.49924467591179,-22.7234758278099,-19.9452693721542,-14.9177664998629,-33.2262038003660,7.55850153807048,-6.26734642637290,19.4741160417257,-2.35423782579289,6.26943196368695,-1.79951624824803,-10.8988983870127,0.276380279257412,-0.677139991603245,-4.95285789501785,-9.67866267174073,-4.69370018928777,-5.83473016917582,3.49667421464206,1.32325221076986,0.354659015178371,0.146748444332677,0.991143392941545,1.37053387366904,2.83372109862996,3.62609909490569,2.12794346716092,0.300736279356616,-5.762522508865740E-002,-0.559478814836226,-1.63869778530026,-0.811688569776048,-2.00529835771382,0.459635041258066,-0.659005920017615,1.34182514178456,-3.184507926825535E-003,2.55668877299976,1.03731989410080,0.156700966652959,-0.239816023628346,-0.839961987660572,-1.15459102154864,0.345611028343849,-2.174681469781952E-002,0.262969676802237,-6.650746696679205E-004,-0.251143921476147,-0.381620794055258,-0.766789809028219,-6.731637857448464E-002,-0.209694773960727,0.359077327349162,0.170077644523539,0.193877322695148,-2.863701718302621E-002,-0.129568206647647,-2.393125735578613E-002,-5.714948021233552E-003,0.221112599466112,1.844101191991930E-002,0.186982362849546,-0.146828293733405,-3.069787784951046E-002,0.122940637923298,6.403638667287989E-003,-3.129552990245869E-002,-8.683017211948782E-002,-0.113713823475682,-4.149127905764938E-002,-3.551715065275166E-002,-1.581717202643637E-002,2.884412041896625E-002,3.020670910445365E-002,3.111035766611574E-002,9.551070409154901E-002,0.108763691682497,2.474249732512232E-002,-3.047516192331262E-002,2.304819688997766E-002,-3.876689544541582E-002,4.081891297004507E-002,-1.485253663165111E-002,6.082126089550131E-00],[-27736.7891450589,-1110.13783012223,-530.746949440166,245.069809114964,389.118802357407,-596.097859890512,979.379246277918,1924.40746705446,406.004113495710,328.926444563147,-548.598714050226,19.2958289975894,-17.2203730629760,-915.756346516724,34.6158939206519,46.9291216799305,-28.1581013034713,-375.630861087987,-335.550641331539,-8.94937981489588,40.9650299870354,-58.6926418909934,166.650870271657,-125.036673363917,18.0074887449507,-37.1456682097928,-98.4523971276712,-47.3875005930784,-7.92235986521165,-29.1125174220391,-4.69837080906596,-28.0910529451947,44.7263129857321,6.76302440310625,71.6161636109188,3.55390321133136,-5.05036941035882,-21.2776233727136,-19.1735050898714,-15.1499815712212,-32.1105381767308,7.75858117876574,-5.24844480210660,18.4894916084468,-2.60977621618471,5.84267834085319,-2.20130210340680,-10.6816800641890,0.175778578968180,-0.793168144843940,-4.56339485555827,-9.38368488764017,-4.35203486239345,-5.17112119337265,3.62144386149335,1.64731076156326,0.204882934462211,0.161591928313199,0.685102480069086,1.12108321902401,2.87981817976684,3.75400750190697,2.41338275904987,0.246666459689876,-0.115235342505448,-0.526059487753922,-1.54953798123250,-0.703352293412907,-1.84404900782642,0.493954264475673,-0.524782545818542,1.35824577119491,1.224222315267179E-003,2.45899599879368,0.958289711285585,0.177846252215270,-0.237126662607330,-0.834397066031547,-1.17597098430780,0.356084757830578,-1.757820929060707E-002,0.259124096831677,4.245830096750316E-004,-0.222564060465348,-0.351185976217875,-0.727242905049569,-5.340284707835048E-002,-0.185332175004402,0.360119440844260,0.154192570515978,0.182586521546597,-3.858634382716424E-002,-0.110874073461734,3.565426401255627E-003,5.475026719108264E-003,0.236090509311272,-7.974592686459404E-003,0.173624930652226,-0.144788774924409,-2.633524296634987E-002,0.121007674494746,8.643104207923556E-003,-2.740028240060993E-002,-7.749823642456516E-002,-0.103776657368697,-3.714394590886428E-002,-3.206656943883444E-002,-1.109647586746176E-002,3.004058866070291E-002,2.738332420687935E-002,3.213086242625169E-002,9.402341039676443E-002,0.112108934991411,2.129122374529087E-002,-3.432935803492747E-002,2.138070910515716E-002,-3.961479579336064E-002,4.794322885576460E-002,-1.279615032184209E-002,6.067858060941553E-00],[-28057.9937169829,-1129.84431634353,-454.467754621655,334.141910982294,374.494569451248,-535.384863088977,983.442232594942,2005.20160205347,424.132790964892,275.038969903618,-462.348155107096,19.2051810488993,-2.18645604675098,-851.141763798896,65.7626333401782,43.3737566031309,-33.6395643174477,-336.875248265993,-318.774150102980,-5.66170612213271,65.4152340622835,-59.5745901392705,164.802912046336,-142.180127072564,15.2339073807914,-34.1795099665058,-89.4607765980652,-42.9635079907619,-8.94491138762650,-25.5721807732464,-5.36083277602018,-27.2509514838172,44.8615728581882,10.3379081202304,73.7224684452740,3.24253157957651,-4.39656680529606,-19.3866374070542,-17.8890715746008,-14.9801598967698,-30.2700104717279,7.83702062578269,-4.23732611220397,17.2572339567795,-2.54109982512591,5.32445767800283,-2.68691187578089,-10.7791048887784,0.121479583398014,-0.908859025381541,-4.16153190548698,-8.91578382581794,-4.04385260208292,-4.38756869995802,3.65833295141103,2.02421551220761,3.231724015163125E-002,0.179081303350710,0.374004546107952,0.922806809966839,2.80442778760239,3.82014438837747,2.68242556276054,0.199999446037046,-0.171442034079541,-0.488335284887811,-1.42653920298078,-0.607527435933647,-1.60609565159308,0.517844550008294,-0.364274201151140,1.33826049100490,-1.007151533040939E-003,2.29788685822026,0.856790592186662,0.193784842364853,-0.239863744219503,-0.774367030444184,-1.15692266729898,0.341396563085722,-1.589404846071342E-002,0.250146842775319,-1.591428345341153E-003,-0.189780044209916,-0.315368973100192,-0.665783799774834,-3.881294632022451E-002,-0.150711985189690,0.353917797654308,0.137417389933593,0.158473808581497,-4.820382264070114E-002,-9.395115898069292E-002,2.848910962691299E-002,1.227681326451489E-002,0.249043953834463,-3.774210940511537E-002,0.155436794400750,-0.137287754246219,-2.197596510043281E-002,0.117319326427675,8.768279332648409E-003,-2.242353537873931E-002,-6.823804020549627E-002,-9.129679613176414E-002,-3.385354842518626E-002,-2.651464942571375E-002,-7.650205967082474E-003,3.093720567171047E-002,2.379015937152625E-002,3.394582200414733E-002,9.209553742358627E-002,0.114992825950386,1.731447638726620E-002,-3.590231793036643E-002,1.732290582238301E-002,-4.232977084075504E-002,5.472949305068691E-002,-9.085086341699349E-003,6.056649129505595E-00],[-28005.4050347628,-1159.43102566709,-484.995310879920,413.069280529210,338.259737774791,-389.694923912677,993.244584346919,2055.98433601671,431.349457749201,208.588568744929,-358.104871786742,9.37791694251799,31.1539308699478,-750.787323578891,110.028225745515,41.5127358317850,-38.4578565493750,-294.559568144747,-295.250129570453,-3.76560245930952,92.3239588424675,-59.0001839446756,156.913083886430,-158.164902317132,12.7050949959390,-30.0137407558104,-77.6146550126426,-35.4542451069688,-8.64911888814516,-18.2338305099411,-6.19717731950491,-26.4834496681845,40.9592375122087,12.5876469295970,75.5757215853880,2.92031600014707,-3.43012086662838,-16.9726631743423,-15.8857251524875,-14.2895891587924,-27.8460020649420,7.80726317785697,-3.24952618004010,15.8205306661930,-2.16812349136898,4.74574374268237,-3.17425804778068,-11.2861874094482,0.165092833881948,-0.936709426257686,-3.76401254981315,-8.26863105008279,-3.76056364137026,-3.51957889345065,3.62656438098272,2.44423079797679,-0.191667333515688,0.166592514739010,2.741084718074072E-002,0.818608349040916,2.63988653809966,3.82219899511177,2.90100737619799,0.177048483725942,-0.216695136359579,-0.443443745967426,-1.26547106664749,-0.516365459988457,-1.30151519150062,0.536650736100510,-0.190423220617325,1.28085218511419,-7.551550367101970E-003,2.08634409951882,0.752713451662825,0.195238501756459,-0.259290208305137,-0.672492729825681,-1.10019468277660,0.307705037179690,-1.798025935959198E-002,0.236037075207532,-7.521379204655917E-003,-0.152058656445834,-0.275055714212642,-0.585742712083314,-2.032364772561318E-002,-0.104799535853146,0.344905163370620,0.126198422147567,0.117430673733030,-5.868428182309501E-002,-8.544343684388302E-002,4.344106102940900E-002,1.421317776302561E-002,0.260859646709672,-6.611353173958998E-002,0.136246055324246,-0.126852085872650,-1.880291231286936E-002,0.112477706087165,5.912776490603531E-003,-1.652916658100004E-002,-5.927512669406541E-002,-7.559358989587436E-002,-2.994250175076448E-002,-1.768790261730406E-002,-5.590431009972088E-003,3.210390397401983E-002,1.865134534763634E-002,3.575629045521191E-002,9.011676161990184E-002,0.118007976968103,1.320334187780136E-002,-3.403526250622182E-002,1.102974015039969E-002,-4.739934446305316E-002,5.953616462281688E-002,-4.481232824297393E-003,6.135419143470270E-00],[-27688.9607597585,-1194.26713156730,-581.024178040783,461.045547654988,302.053057712084,-151.613063362918,1041.44065059200,2040.97753229749,422.315307820937,152.915189516565,-239.653262730065,3.98151057241739,57.5588307532919,-638.236494727543,157.474251240216,42.2970660225136,-38.0919450387572,-254.049814216948,-268.606414221937,-6.97748801048728,116.809058086674,-54.6705507058753,148.655302364379,-169.160068100025,11.0457467807450,-25.4538627412938,-63.8996825962937,-25.4411266428508,-7.01228567033361,-7.34240321598013,-6.87680098992169,-25.4103076539561,32.8200149556340,12.0883402837292,75.9276915378951,2.45712168545426,-2.34587195670561,-14.0666249033102,-13.0438099838894,-13.1168593934484,-24.9986371401405,7.55362901276253,-2.39666829558461,14.2249839607655,-1.72313317812094,3.98169648164614,-3.44515621123364,-11.9109391129276,0.240657936026014,-0.848869893906630,-3.35882070088104,-7.43145064580640,-3.48883935440681,-2.63772404483666,3.50341069188462,2.84339195590717,-0.503731072619394,6.961758377515392E-002,-0.361749733255125,0.849153231280595,2.48835617148679,3.75235458109093,2.97161782342784,0.176699613209164,-0.251686459709856,-0.375847556872329,-1.06801379631028,-0.425291414162970,-0.967181592639413,0.538322363766044,-3.939998702867763E-002,1.18596682200069,-1.835387370752075E-002,1.86211265845197,0.685763929590681,0.182384645927475,-0.289885541682471,-0.579025657097513,-1.02945975247142,0.268714206648019,-2.398650056762659E-002,0.212629267391423,-1.211413109321416E-002,-0.113458970555772,-0.233846286486532,-0.495501484713508,1.082098119715726E-003,-5.138815263784409E-002,0.337590262951581,0.126811195727199,6.071912367088415E-002,-6.773720797590374E-002,-9.358566511909781E-002,4.047418740239777E-002,8.420077448854474E-003,0.266541873407060,-8.065217825168944E-002,0.125327322438978,-0.117970679838365,-1.731488447273477E-002,0.104782001688409,8.414533596547976E-004,-1.144830990512315E-002,-5.056727162316812E-002,-5.655616847342633E-002,-2.372559848388361E-002,-4.709915604361389E-003,-4.728106564770022E-003,3.390526200311332E-002,1.082122903632524E-002,3.664707313521005E-002,8.720894022997214E-002,0.120445896925348,9.744909973576334E-003,-2.898649603912667E-002,3.511218530430789E-003,-5.301216378857478E-002,5.979531317262544E-002,-1.515243555881687E-003,6.300980814173433E-00],[-27271.4035232630,-1250.55258776876,-682.560798738051,465.364162204560,305.653424577062,156.789525917852,1173.55945536187,1920.19137829649,393.588027164962,131.269192849051,-116.712445741010,17.7290623413524,52.1134813927633,-542.330903631649,194.103723086191,44.9712220585998,-28.9563604932020,-221.012238896788,-243.220792358074,-21.1674859892500,133.504212565123,-46.2645219897811,146.885768630594,-171.178444121520,10.5978001214702,-21.1690245332119,-50.2728172648577,-14.2912617308409,-5.16763098401283,5.82546193750391,-6.96827638461956,-23.4712754246766,21.6185892569134,7.98031110307643,73.6015466840869,1.67863327862848,-1.46864591381490,-10.9085476802809,-9.51612846339348,-11.6906137643719,-21.8827468018339,6.97488028206239,-1.84267815039159,12.4522343449164,-1.60181920811899,2.81395247852254,-3.30124596113887,-12.1269919746586,0.222897791563104,-0.711677428286770,-2.92701793852265,-6.42898530207693,-3.24641134386056,-1.83269151181222,3.24784845508314,3.13386603007086,-0.939201705666055,-0.146945405815467,-0.768913826080960,1.04750023405429,2.47641732693708,3.62689156585559,2.80596779463406,0.180843994950460,-0.283296421756241,-0.277940437629673,-0.845726421323231,-0.346650192304206,-0.655652510258838,0.505476689179489,5.633500189535317E-002,1.06454382105973,-3.745690467526575E-002,1.67000799551069,0.684433779965091,0.165594716896836,-0.317186976971345,-0.549110337688715,-0.978432793967170,0.245940332700861,-3.307295401889028E-002,0.177995108729693,-9.620300244844733E-003,-8.164373286594503E-002,-0.197559365335299,-0.406781852587098,2.094517059183716E-002,2.048491449635855E-003,0.334893659437252,0.140562377293355,-4.242897313846504E-003,-7.197260631306694E-002,-0.121592378412080,1.760435130369212E-002,-9.622500524225978E-003,0.259772931225670,-7.019463531790207E-002,0.131862423425608,-0.114725765072481,-1.737168707565729E-002,9.213251764102930E-002,-4.380493441697549E-003,-9.246337035167253E-003,-4.206631879925612E-002,-3.538836460725153E-002,-1.515884704083805E-002,1.178477530711705E-002,-4.409847982582833E-003,3.645535875649392E-002,-2.798177264554249E-004,3.641024064134605E-002,8.198396153008006E-002,0.120850035393412,7.655228461431805E-003,-2.258065351927604E-002,-3.357972680218223E-003,-5.599399151977405E-002,5.431676680714236E-002,-2.883109340340939E-003,6.513605572495577E-00],[-26812.7767888632,-1341.31478360187,-730.921852035847,459.386065746369,349.496333676639,491.002632496761,1357.45452941617,1717.20225493655,357.410276407166,140.356656349521,6.44803998176906,50.4070513129531,23.4656197658718,-465.271696034595,217.945319165737,49.0078992531384,-11.8702885758771,-194.695359599817,-220.992073967108,-44.5790984620029,144.898772759070,-36.3086912934178,151.740250154808,-166.787032839740,11.6898550078019,-16.5341517115554,-37.6719123428163,-2.75774335022801,-3.85909758334246,20.0038627164110,-6.48911668437809,-20.8693952802121,9.13130050105402,1.61584416766868,69.3378508864567,0.890379576154603,-0.618764981153194,-7.78584032915056,-5.57612727683898,-10.2437371282346,-18.6522645801079,6.18949357804741,-1.60839626762096,10.5928930299576,-1.94420472506276,1.30477990750900,-2.79887274737639,-11.9011845908132,0.124611732189384,-0.565152568912933,-2.49809467979687,-5.33682965581736,-3.04574337616832,-1.10764828944228,2.90507280277918,3.34431109784987,-1.47946280215841,-0.437430416060865,-1.20459977615580,1.36996900726250,2.57265513573018,3.47818554400672,2.48446540456626,0.177121032957960,-0.313363420408961,-0.174585079862254,-0.604488570527460,-0.291300895161980,-0.380800879387380,0.450517087694560,0.117698736525155,0.936985080165970,-6.838966479451883E-002,1.51502361683490,0.734843333204628,0.150164689043871,-0.334286504018568,-0.573917971385552,-0.953970086710389,0.241983731439473,-4.519293478706702E-002,0.140589715079754,-4.500334629365342E-003,-5.459685890171739E-002,-0.169112861158420,-0.322203047463466,3.865875666920020E-002,5.380320679530000E-002,0.335495661617240,0.159461868239677,-7.184739598542245E-002,-7.309995764651457E-002,-0.161564468306636,-1.658086775050704E-002,-3.832819360376374E-002,0.244268176738803,-4.319931265762761E-002,0.150877646190114,-0.116258891971914,-1.899870352429364E-002,7.665327905517870E-002,-8.666143352817254E-003,-9.170150927726727E-003,-3.410100504483385E-002,-1.283296254865833E-002,-6.129693776986575E-003,3.021793225780112E-002,-4.480172129749105E-003,3.953021173557098E-002,-1.378299451108549E-002,3.626212632909293E-002,7.456019199566460E-002,0.119940908154587,6.040963415688999E-003,-1.660358215834989E-002,-9.028252993534203E-003,-5.602275763246986E-002,4.584430210931029E-002,-7.302227591781586E-003,6.733205060987807E-00],[-26308.6254542099,-1433.76254859846,-731.111646296086,478.025352130392,415.009244276118,792.253098689588,1526.62523498068,1498.41418392148,326.767466083137,164.911459310667,122.581413612442,94.8443929922961,-7.31099814004571,-397.650633701986,233.173428590025,53.9438435471594,10.4353408533156,-172.573776494124,-201.385343498154,-70.9713623233322,157.259703027327,-28.6071953014796,159.476639567163,-162.465721422886,14.2457159125616,-10.7429753238869,-26.1689997719060,9.20875131207689,-3.19342405063020,34.3120037302189,-6.08123924496439,-18.4278695323815,-3.03211997762651,-4.82001091463794,64.8228819889661,0.483330179719154,0.549907472092909,-4.88842321037395,-1.44012877866472,-8.99544581148471,-15.5460386650204,5.38180242538181,-1.54964935221234,8.82176764837004,-2.61442965182129,-0.315097528775590,-2.14909728684423,-11.6059915268214,4.432264712515026E-002,-0.425648856625311,-2.09468650207065,-4.24377428668452,-2.88027538417039,-0.433307540585060,2.56828718785040,3.55171037723761,-2.10015549139081,-0.737684258085135,-1.69356861875596,1.73336137861787,2.67348644709364,3.35785079599057,2.17089182332504,0.161543927253639,-0.350759560406239,-8.396433902242421E-002,-0.347372504182245,-0.260887615703890,-0.135557987287553,0.394626826342789,0.179568198306187,0.813295682045685,-0.107811816684186,1.38401955300186,0.805063464840626,0.132216518641696,-0.342868444217270,-0.614165053605151,-0.948346763472193,0.248716574810482,-6.137105851163586E-002,0.109229837798804,-1.938619404469510E-003,-2.609152660291051E-002,-0.149225596302981,-0.241223038398518,5.635656805427620E-002,0.104371455733403,0.334687299812745,0.174474247472932,-0.140087091458405,-7.612683295803298E-002,-0.202633253004792,-5.051530620282536E-002,-6.995339123527557E-002,0.229751350849800,-1.629721843149959E-002,0.171278304664883,-0.120173198134298,-2.197842786172732E-002,6.184422922816232E-002,-1.139435544609327E-002,-9.752069005800976E-003,-2.671612349846222E-002,1.065359246837834E-002,1.454792956776515E-003,4.811296940772008E-002,-6.039178594255410E-003,4.259078233959017E-002,-2.843628120477826E-002,3.738147448724813E-002,6.648425267520922E-002,0.120106486310413,3.531905077733919E-003,-1.186831600527253E-002,-1.396426893192159E-002,-5.510223492272911E-002,3.828743350116259E-002,-1.177843035820372E-002,6.947325339076771E-00],[-25718.9378054456,-1460.93305428448,-686.104401572570,529.420624112900,496.532099035135,1022.84503108689,1646.56129271456,1304.21992406428,304.779257551841,196.703980636095,220.816904446342,144.739486697002,-35.3289379871110,-339.265447957958,242.373904757287,58.5056233282542,35.6332923292523,-154.062233030298,-184.582522165526,-96.9746072473959,173.689223424866,-26.1634417362854,168.038931322026,-162.335433534864,17.4784728348595,-3.89075675875531,-15.8814972747782,21.2705706387734,-3.33259589430425,48.1906824204786,-6.53736305021792,-16.4986935693058,-13.6339008448179,-10.0992911338197,60.8664804743110,0.462252735635095,2.07419536223050,-2.34532481670181,2.64491137972463,-8.11950543116746,-12.7000692351200,4.56568703003668,-1.43182285662962,7.28647967451389,-3.49245476049671,-1.93063756274571,-1.49254553108586,-11.4750278962492,1.888409192789700E-002,-0.320897977166761,-1.71922018045606,-3.22139509188272,-2.73309211000228,0.208238983761306,2.26308069146741,3.79171264318619,-2.78532375165135,-1.03662667488649,-2.23881513581772,2.08747072757924,2.74125672333799,3.31560929409074,1.95353259526586,0.132677805282505,-0.405914184742759,-6.315107387364760E-003,-8.194264071357228E-002,-0.251369464575530,8.113495925980312E-002,0.335026579319303,0.255325852028966,0.689611616370818,-0.154756605836089,1.27206881869064,0.874815956290326,0.107266435136574,-0.342552502816969,-0.650920018149704,-0.958903583537211,0.265886913356891,-8.059594845656234E-002,8.674902937581974E-002,-2.169119885959938E-003,6.616912246776421E-003,-0.138194577306241,-0.166483086548044,7.197885355173612E-002,0.152061034742883,0.327076860911414,0.180107903932494,-0.206864886350999,-8.345351533415227E-002,-0.239018655496748,-7.646097324313017E-002,-9.803527527165501E-002,0.220538817442969,2.464296149460345E-003,0.187272461739293,-0.125381425987381,-2.519921876185778E-002,4.946178468590244E-002,-1.200702216829693E-002,-1.027275202909968E-002,-1.967086434359720E-002,3.392060398921407E-002,6.481903277713916E-003,6.304778876355398E-002,-1.055755182392930E-002,4.441813817189208E-002,-4.355229120399001E-002,3.984275437518389E-002,5.858128439175682E-002,0.122912938869549,-3.830923448676478E-004,-8.789383388940994E-003,-1.815910980908458E-002,-5.433314877859061E-002,3.355500625406513E-002,-1.498168800070655E-002,7.141269579518177E-00],[-25000.1715659926,-1381.56629324474,-589.202642898678,611.518675124655,580.363773074753,1172.67909198202,1702.08792592515,1130.98444247318,292.674867198137,228.718776948753,289.174464083298,190.729587750796,-69.0631541546548,-297.855320632132,249.886446939229,62.3280391775897,60.3479477459274,-141.087435257141,-173.537254808985,-122.330571100622,192.867150379914,-28.9917077305574,177.136628934028,-167.474460029306,20.6081794579507,3.05788077554088,-7.29461725966494,32.0626357797622,-4.41730658192132,60.9097871977672,-8.08852524004314,-14.9535749208231,-22.0629650535778,-14.0638811166727,57.4987178541602,0.628418112613489,3.76956327151582,-0.306814219884597,6.23489284437950,-7.66809257962670,-10.2482694279161,3.72545993535686,-1.05666443265135,6.14114676698910,-4.57246692323112,-3.53638299245342,-0.861210714796004,-11.5286703828298,3.938498531351559E-002,-0.257953730806984,-1.38770734654371,-2.36947463434176,-2.59194928084949,0.785810703176351,1.98515067136433,4.05671135840671,-3.49340240995672,-1.37109592484719,-2.82495201574443,2.41978429109435,2.80827988680550,3.37448976849432,1.83953655696848,9.824781655934149E-002,-0.476024502029387,6.301619964793777E-002,0.172995902294682,-0.257349278759926,0.254915050622722,0.261799050714334,0.334993923259376,0.563946487949859,-0.217659000904887,1.18064428636565,0.937081734562871,8.248619147618698E-002,-0.328692875928014,-0.683710634918362,-0.985589581710645,0.297010925313262,-9.912162411290296E-002,7.446453548800792E-002,-3.294350831108285E-003,4.288909568969961E-002,-0.136817576369870,-0.104890608952175,8.127346591403628E-002,0.191970215081492,0.311237875562241,0.173360066677316,-0.268838576643797,-9.559272817116317E-002,-0.266063320892392,-9.074883848055744E-002,-0.120166794206211,0.215666372657282,1.282083932948514E-002,0.197596686525132,-0.131601175465118,-2.723634769379148E-002,4.070441868899766E-002,-1.049166738346219E-002,-1.022938496203195E-002,-1.342717335728360E-002,5.445953718417740E-002,8.566688826724584E-003,7.287053420318837E-002,-1.830881416645688E-002,4.333673560379050E-002,-5.811133424261022E-002,4.281972959117050E-002,5.177047552360589E-002,0.129217647882346,-5.484068831388735E-003,-7.821605669117812E-003,-2.170499711908274E-002,-5.401643292787255E-002,3.181188403885719E-002,-1.694472422598226E-002,7.305626138370906E-00],[-24188.9631478089,-1233.37036469061,-457.468124635531,724.938858562154,648.655157447549,1259.47002193853,1703.97689779287,967.245326857524,297.408656402251,249.451525356577,325.132625894460,221.273862292720,-114.199200404778,-287.651962921905,260.362119087815,66.5990002346497,79.5160228582179,-135.880428260919,-171.671057930042,-147.672121153299,210.817027437642,-35.7310967516865,187.944275398469,-176.953176818000,23.6308086275865,8.99888857807438,-1.11804410159277,40.0734606755588,-6.06435176675865,71.3512083578790,-10.0784480746915,-13.7736218157528,-27.6725227629442,-17.0829513244122,55.0194485856723,0.967044879413872,5.39449216771168,1.12622430665422,8.80977113312574,-7.42693667829094,-8.50997897179256,2.94353538966057,-0.466690130109001,5.61071248499005,-5.80997762776900,-5.16253230637060,-0.273287867458457,-11.8526003565228,9.920065322250336E-002,-0.213697779646893,-1.12581540278498,-1.80666169526293,-2.46369619787511,1.22401220225785,1.74288214062587,4.31957652937153,-4.11913184217248,-1.71601959722476,-3.39964802491984,2.74818163426256,2.91942277389167,3.53968873184471,1.82320758165102,7.620052686754854E-002,-0.535244876568864,0.121182953450288,0.391540567798860,-0.275058074486686,0.368883539138081,0.191647564724356,0.396457340031874,0.460089979057327,-0.297314750036152,1.12327921713114,0.985443631457736,5.957334594900754E-002,-0.310777470747573,-0.718226867006809,-1.03365742710303,0.342320635894774,-0.110446065164788,7.554391088215212E-002,-4.375313023284449E-003,7.899727262955190E-002,-0.143565411102711,-6.382103800519237E-002,8.614751220768163E-002,0.216442068114827,0.292747144716051,0.156852012483457,-0.322472837132708,-0.111850917649985,-0.285740409881700,-9.424908639797891E-002,-0.136617300258427,0.216701557946618,1.821164232049031E-002,0.205329100747691,-0.140303818968642,-2.749881756196386E-002,3.665032893691597E-002,-7.358517192210739E-003,-9.396416207979189E-003,-9.386823652619966E-003,6.960320356315812E-002,8.424771340389162E-003,7.661918587925803E-002,-2.783735906045135E-002,3.965239318875967E-002,-7.044937889351284E-002,4.563601078043661E-002,4.654418719778265E-002,0.138799916062771,-1.017800091925721E-002,-8.884055628878439E-003,-2.397167428444948E-002,-5.503405763324753E-002,3.246876384360689E-002,-1.852526996928103E-002,7.514656871689401E-00],[-23392.2564867330,-1027.90419622015,-292.548692498126,856.736819472150,707.751473594818,1312.02769292352,1685.17169915657,812.086895571784,321.288556103939,260.657476297205,339.975770136001,237.939376074171,-163.701723025839,-311.013524692759,271.656527120721,72.2062900483477,91.8349599902770,-136.267602208489,-177.295452759794,-172.194275058216,223.726756179479,-45.6179999430275,199.948125356115,-188.786305111686,26.7433230423810,13.7535288043551,2.71691049939814,45.7138679520827,-7.48440832384178,78.8547573894290,-12.1422519859975,-13.0558084165227,-30.5404066928499,-19.3129069693843,53.8471248194589,1.47656343508187,6.84435060021043,2.05636301347484,10.4105225024587,-7.10900299085205,-7.65792425985380,2.28595195950914,2.672120992388116E-002,5.73834119555564,-7.03221632538042,-6.69925479211385,0.237832911621974,-12.5044962474312,0.184427755283348,-0.174203739051929,-0.928268523942447,-1.52161658486810,-2.34621055435170,1.49400723715599,1.55171599804777,4.54666917956507,-4.60922001447402,-1.99813727414759,-3.90345491341986,3.07988929578477,3.04616308379993,3.78422312288351,1.88514299085447,7.560453355942873E-002,-0.569484922400636,0.164901910734687,0.565026080279106,-0.292770852004828,0.433746100085979,0.147002819442848,0.426782816232026,0.398360677406936,-0.378438545613811,1.10967958710179,1.02272677457068,3.005595828827598E-002,-0.304096389021402,-0.755905744942773,-1.10134100791259,0.396827886092061,-0.112524326744937,8.746394519995850E-002,-4.179186952476217E-003,0.110725980950416,-0.153025232916822,-4.151599517652603E-002,9.236077385577587E-002,0.224135381700346,0.276715967492486,0.138708373811401,-0.366809351182605,-0.130695015211324,-0.306364174724102,-9.265705554330433E-002,-0.150848471129205,0.224761248205971,2.193666924763041E-002,0.213477233668796,-0.152331736148239,-2.645149621842709E-002,3.641890452947012E-002,-3.017737412132468E-003,-8.143792386989344E-003,-7.516352167878550E-003,7.950097726337202E-002,7.554762797961619E-003,7.627897137068493E-002,-3.802872593827558E-002,3.547775930415247E-002,-8.019799107992598E-002,4.849611534143804E-002,4.242256478019988E-002,0.150095614631276,-1.354382560857462E-002,-1.105621661353824E-002,-2.452492205256643E-002,-5.763580334739348E-002,3.455850698757061E-002,-2.020190717765892E-002,7.835895485973249E-00],[-22670.8684092473,-808.105793678954,-128.778188990449,966.746682474300,744.005014578222,1343.18358051180,1665.11097944458,680.388467062144,350.650891632919,277.155323174620,349.425770052074,253.052170795452,-205.749937913241,-348.443269825365,271.896540362876,79.1138666164392,101.468030286904,-136.542316295139,-185.830608795206,-192.926058225395,229.466043677947,-57.3590456966324,209.917097066717,-199.400799658731,30.1222856455320,17.8832533773501,5.06855684666502,50.4812581159817,-7.95978729457547,83.5367149972770,-14.7234374933691,-13.1297181316551,-31.8510219072504,-20.6353892607523,53.7521447836924,2.05385170996576,8.13210151505018,2.72181509594711,11.5797997185435,-6.69132086615183,-7.63338824282831,1.72312480917872,-5.700807583055207E-003,6.27555780662702,-7.91308691252846,-7.89979500715120,0.640724122149809,-13.3293129047298,0.285703977601138,-0.118672654932057,-0.783031000206182,-1.36853085297871,-2.23671869589443,1.59697172816155,1.43650296976455,4.68513207568947,-5.01191192675859,-2.19149910797722,-4.32303354113985,3.35642545737150,3.10841598751694,4.04147466004971,1.99337970956199,9.502277199632242E-002,-0.584335747558011,0.192219119384942,0.698361697612258,-0.290230073699840,0.468149778229863,0.126235313985475,0.415964862687113,0.366364878787555,-0.448079397682930,1.13440503930520,1.06723028633204,-8.810830609298550E-003,-0.307743611827307,-0.792618546566718,-1.17318730273271,0.445797850940543,-0.110737354784022,0.100745052997876,-5.947145974411601E-004,0.134208855172912,-0.160489709304281,-3.405175733925788E-002,9.915869714289034E-002,0.218649378760679,0.264091085241287,0.126453169997382,-0.401195375322068,-0.148244670141116,-0.334509827105726,-9.421133039708869E-002,-0.164051949596617,0.235605519344342,2.633945605305748E-002,0.223246891890858,-0.164778910320821,-2.558993275214913E-002,3.790359677202443E-002,1.520894119633710E-003,-7.292095899974661E-003,-6.899751534527438E-003,8.565641043625818E-002,7.133020839109717E-003,7.495685692958813E-002,-4.779505857541744E-002,3.202113819853943E-002,-8.789020763177786E-002,5.149100753890109E-002,3.942273385430334E-002,0.160535588205193,-1.549214037696773E-002,-1.272941092539737E-002,-2.457718444475942E-002,-6.042107790594164E-002,3.655931186034202E-002,-2.193529631183152E-002,8.215632817915063E-00],[-22009.5227094150,-655.183305468049,-41.5052865002086,1019.73798278100,742.471245500745,1356.51083993142,1653.29015143491,585.508884788199,368.452646937914,309.804956525412,367.122138553001,276.558639502321,-232.881315756407,-374.015058735324,251.247291792651,86.2618690419542,112.602396210901,-130.664964682133,-192.782335802847,-207.371481016366,227.408936403822,-69.6600345187907,214.301221409791,-203.984552150513,33.9636003800164,22.1374800113902,6.69517277704117,55.2646057142571,-7.41059716147455,85.5127485989651,-17.9485409202631,-14.4365976118321,-32.1679061732636,-20.7286200123237,54.1069605020604,2.72770089309371,9.26553903795516,3.27894059611487,12.7391669548425,-6.28040207513748,-8.26446041565617,1.17044901905698,-0.892840362371674,6.90144549326628,-8.11412037088182,-8.55070441962995,0.865752933087009,-14.0627989221869,0.418358613818471,-1.925351639828973E-002,-0.682017669265677,-1.18868034576850,-2.14286334602031,1.53033039755051,1.37877673303060,4.65474358574698,-5.35445828417473,-2.26781671572351,-4.65258910349466,3.50331926986577,3.04011416782714,4.22784860074199,2.12357087999203,0.130062731495557,-0.574598583450226,0.196837154994608,0.798965740988464,-0.255113134178048,0.480533968081299,0.112388965456660,0.359807375755936,0.342803147280331,-0.499202060274598,1.17793684051553,1.12522275627283,-5.564771445936175E-002,-0.316207648376407,-0.816004256293309,-1.22810772571030,0.471092899928663,-0.110702474379170,0.109161293911967,6.539214836417186E-003,0.147124678820698,-0.161501137715314,-3.898393147809198E-002,0.100073859499139,0.202313930223040,0.251917969900742,0.121926130068235,-0.423099321789215,-0.156400539864371,-0.370635866801443,-0.104765454572813,-0.173726337327179,0.242491006302874,3.112668832273641E-002,0.234467641728436,-0.172432260151068,-2.662339752785021E-002,3.931111783813482E-002,5.136421469052187E-003,-7.004340902028144E-003,-6.835758099256545E-003,8.864898400839594E-002,7.121956110678715E-003,7.401909111647126E-002,-5.584842151152572E-002,2.932105232962382E-002,-9.355806739897284E-002,5.462686326284325E-002,3.696800975227642E-002,0.166323433122177,-1.587259449767759E-002,-1.298028529135375E-002,-2.495323434352354E-002,-6.131060646187732E-002,3.746050890379207E-002,-2.351669822686283E-002,8.523094866246296E-00],[-21354.7255197017,-582.108747204065,-36.1533243322697,1020.16781919037,717.060265545948,1368.47429251718,1661.19844224253,513.848302211924,371.797998623558,364.793274663360,398.161353995253,316.476700686354,-248.349901931089,-373.860529487550,211.511086880576,93.1377018116187,127.382876441093,-116.260115427460,-194.208497107384,-214.450697912403,217.555743606437,-81.3130142671508,211.043313049323,-200.697406859582,38.0573956374908,27.1003095945899,7.89576653947087,60.5097988327849,-6.07142473952197,84.9014058633020,-21.5252819901931,-17.3754481859941,-31.7384740660993,-19.5447060286020,54.4171770034269,3.45418986682490,10.2938755051877,3.82356961987504,14.0665117199428,-5.93434214091545,-9.31931975004152,0.549827866774025,-2.69410014172168,7.36113616236932,-7.53363003816609,-8.58230463712505,0.843915013562560,-14.5442328013664,0.560593980646567,0.153246979195736,-0.584095939711927,-0.885258950738423,-2.06830251214477,1.33836835659698,1.35170945425113,4.40738377031183,-5.63807185956682,-2.21291353847110,-4.90239745861495,3.49616986746384,2.83891332930447,4.28666253143056,2.25245766358271,0.171179620587264,-0.534158705298026,0.187882909294562,0.882916395913842,-0.182461584545694,0.489032736227622,9.917140893914847E-002,0.265909309832417,0.311025775713306,-0.532237268624110,1.21842738292796,1.19252639215061,-9.921361184115687E-002,-0.326299662809667,-0.821355836822583,-1.25032599906440,0.460557182860878,-0.115234340272369,0.108636894305583,1.971610022029736E-002,0.153934993083545,-0.151954008063375,-4.967437903798999E-002,9.075348100210182E-002,0.178861260195815,0.236406121081416,0.123387901775806,-0.432951672174920,-0.148055309413121,-0.408417760470430,-0.124847809520804,-0.179055242533020,0.242200496761424,3.323887891811204E-002,0.245503453018632,-0.172628901679921,-3.018488086613184E-002,3.940299679616331E-002,7.742379465762039E-003,-5.797258214656914E-003,-6.786078238287118E-003,8.976162160465288E-002,7.046085330606764E-003,7.460399274433696E-002,-6.150663043023011E-002,2.707932267958386E-002,-9.746260561256812E-002,5.783266763389594E-002,3.479679737169104E-002,0.165771799332465,-1.552373252730661E-002,-1.192796782041750E-002,-2.624178935934516E-002,-5.970244786521356E-002,3.724495284031171E-002,-2.465860426230466E-002,8.679271436643470E-00],[-20695.1587390432,-478.073839568465,-71.9847230213435,1006.94315539107,701.232587968815,1382.14929830386,1684.45735050680,433.530044221971,369.097065315011,437.862031554479,436.025140989471,374.962680582880,-263.649398722626,-350.448189231666,161.304171346456,98.9124798937821,144.741831268318,-96.6657236273393,-188.369267463075,-215.600189946673,199.688970546762,-91.5002473826093,201.406825533553,-191.380334994608,41.6179888056960,32.7294754549120,8.22668719213690,66.1897761933084,-4.20928370989637,82.1436697303109,-25.1494720387721,-21.5966690249098,-31.0561207985219,-17.4835072812045,54.3702577456027,4.01254078508579,11.1828354482539,4.38889008583819,15.4761851785489,-5.64617029944478,-10.5828781439984,-0.276039231569130,-5.13150547437569,7.50450476248492,-6.29300162179020,-8.10760103685363,0.571390137511086,-14.8099892397050,0.640261005521908,0.387967988221794,-0.444795836980818,-0.471684252198182,-2.03869868525309,1.11182838433995,1.31385280460318,3.99188475950644,-5.86640176623836,-2.03939073488842,-5.12997152733069,3.33722192931498,2.53988291612986,4.20688871297614,2.38270421649702,0.207070546879692,-0.468162408350096,0.183407361893558,0.960262690863435,-8.465511241657102E-002,0.520306196683730,8.904220042370943E-002,0.148470530560411,0.258999124614985,-0.558723504608929,1.24004216746732,1.25120684471607,-0.122771695507619,-0.332199872786134,-0.810275791973315,-1.23207783980720,0.410427364832739,-0.122623167914456,9.681299017995262E-002,4.320597490239893E-002,0.160639991615180,-0.132476147887398,-5.955410136410076E-002,7.052243834192139E-002,0.149690659873390,0.213040054873918,0.125604528330207,-0.435011027599300,-0.124420810452712,-0.440721980832094,-0.149614492987255,-0.181023768690677,0.237423179413015,3.011628737729732E-002,0.254055432813696,-0.165918873863678,-3.530870226519205E-002,3.761041485097717E-002,1.042617287439348E-002,-2.152870267572180E-003,-7.101349415591506E-003,8.981972405264375E-002,5.946549755555532E-003,7.660304805984071E-002,-6.557718917367739E-002,2.442066241753999E-002,-9.975555337086310E-002,6.052089206751388E-002,3.365013820612002E-002,0.160911024716352,-1.534474883821961E-002,-9.458024925923268E-003,-2.880840190166504E-002,-5.697052181006570E-002,3.621065124346466E-002,-2.516663295391424E-002,8.691959942402538E-00],[-20130.2004506761,-356.911478960351,-142.247070000670,997.690312573036,691.873447922359,1377.38597914391,1701.72144912356,349.683887040836,369.324738467785,508.907376294190,466.102212495246,437.440306687242,-277.448020336924,-316.530680043867,113.657271072940,103.813300473697,159.445594865103,-77.0875097051536,-178.358143209656,-211.386819308970,174.994156614425,-99.8931760385351,188.716875268503,-180.051278627558,44.5753118426052,38.3654077009735,7.23361440724543,71.4017083048707,-2.01491211640476,77.7435380141223,-28.1878765475869,-26.1133133176243,-30.2306761491661,-14.9597601556124,54.0861218632461,4.48668492848242,11.8968252125970,4.92602490299701,16.6129879861924,-5.38811981238080,-11.9675314739754,-1.25185794504020,-7.71295456487189,7.32459539600885,-4.70818986152451,-7.33943623534395,4.467299564912514E-002,-14.9966593798680,0.673043333469397,0.668018047147570,-0.264445275145508,-5.150168735231314E-002,-2.09634769823602,0.878366168432190,1.24804783069789,3.50930274408291,-6.03464501987041,-1.78739732321621,-5.35296553504241,3.06005826321242,2.19348962471124,4.03906558411848,2.53765263192803,0.243787396570451,-0.371705441782342,0.182970048404317,1.02737342422853,5.827508600835552E-003,0.570788136761161,8.835081743298910E-002,2.175622497992085E-002,0.192105241276770,-0.593820886616743,1.24659869376894,1.27134267070433,-0.118096573243942,-0.332328157451533,-0.777806623457623,-1.17912739128151,0.333769060394960,-0.127973694461088,8.157656566651462E-002,7.434597760222995E-002,0.169485340932160,-0.110417498974188,-7.016526153727075E-002,4.206611541621043E-002,0.111878234130512,0.181613364411351,0.122514222154073,-0.431378811861383,-9.470997074959542E-002,-0.462085630326417,-0.171471820429127,-0.179198495474079,0.233856107148667,2.121692493310463E-002,0.258093510690177,-0.155710922109299,-4.090299181684289E-002,3.597821258696648E-002,1.353158234624836E-002,4.342874418370471E-003,-9.148009075014151E-003,8.788032759634165E-002,2.813116527918549E-003,7.744455424287558E-002,-6.862993331333014E-002,2.061265123735118E-002,-9.983435092721298E-002,6.190016452224264E-002,3.482464077862674E-002,0.155077144451744,-1.494683548082261E-002,-5.373815412563013E-003,-3.167468404394265E-002,-5.503377943355214E-002,3.501227908052916E-002,-2.491166620786521E-002,8.629931032580958E-00],[-19782.1221487026,-277.275327781079,-252.814913535759,965.248105037525,662.971937155080,1343.43966691353,1714.93323848907,308.618117601934,365.599882410048,565.406030836769,473.611882479010,493.165598373358,-282.616952944346,-289.058546556702,74.2644488173358,107.109876633925,168.561457562534,-62.2568320837204,-166.840444530957,-200.580626101845,146.977322411590,-105.690003816831,176.273140182392,-170.469196970675,46.8549058714271,42.8827543341905,5.16659532855406,75.3065319164403,0.422148199262692,72.5032319689613,-30.3819537094190,-30.2182660676796,-29.4342277805878,-12.7239665047019,53.6776563080701,4.89235863370446,12.2991551286853,5.43216045371540,17.2315731825924,-5.29000337973494,-13.3091341383798,-2.23640671633159,-9.88982769892159,6.85521934437467,-3.10563600675053,-6.51398375536936,-0.672650750296786,-15.1742526649130,0.683441558703389,0.952774726122801,-6.121025194008310E-002,0.294174538730738,-2.25796518732948,0.646757676633888,1.17543397397443,3.06648518309813,-6.16485527711962,-1.54186648875382,-5.52815446405931,2.70087098318677,1.88757784144613,3.85206277446665,2.70645937329980,0.282885454902650,-0.258946533925407,0.188074331097531,1.07739184155744,6.939352549922240E-002,0.620906994839716,9.199526279584233E-002,-0.102183590339635,0.104867228365863,-0.643868846542463,1.24771329005917,1.23820286495836,-8.460428814989156E-002,-0.325144268409374,-0.732079882422164,-1.11136974928000,0.250064850340318,-0.130421444420076,6.695171463892124E-002,0.109911952749148,0.179654686246342,-9.290206681369635E-002,-8.353092081812385E-002,7.196992545338926E-003,6.761541914560117E-002,0.142617283887529,0.113231137016603,-0.423731688826528,-6.994884778240397E-002,-0.469024848988971,-0.184165742897044,-0.170625600280410,0.233973422485988,1.073662914887723E-002,0.257723755571560,-0.146383701086068,-4.606102993073201E-002,3.574169542739564E-002,1.699422335634771E-002,1.233157175830977E-002,-1.314691634922927E-002,8.388729544369419E-002,-2.366337957236353E-003,7.600724275320153E-002,-7.107211989522548E-002,1.561066940874071E-002,-9.842600583345947E-002,6.061345780116795E-002,3.898815427311053E-002,0.150348758320292,-1.320852996554740E-002,-3.119624687066150E-004,-3.380884133397152E-002,-5.505065963991139E-002,3.383263091767678E-002,-2.430203413164839E-002,8.524617174897851E-00],[-19756.6103878773,-211.207691827032,-353.594889408993,870.174198798187,603.474251453931,1293.88105709326,1756.00607404315,325.942667618370,341.764801425792,609.500696838030,452.680636911669,548.280550932698,-288.095522307975,-289.015710071954,34.6760255399431,105.563825321908,174.525778983531,-56.4726515757663,-153.891420564486,-185.430922152319,117.167413788080,-109.025268448993,166.635447789416,-163.040089933487,47.6554514902386,45.3821912472551,2.55435616043971,77.3007802342890,2.84063983234149,66.8619744768130,-32.1107212370800,-33.9997127994295,-29.0493542701616,-11.9922630419861,52.7600223650029,4.94556335575381,12.1048418617005,5.96729496185751,17.3406565863098,-5.45107125788714,-14.4901468238731,-3.29125108043071,-11.4698864998606,6.16811967505120,-1.71837421542776,-5.79714358177409,-1.27185196804480,-15.2502267458255,0.605977674040274,1.16364544141120,0.155593198827809,0.550755189252176,-2.49771655226835,0.430413248193545,1.08240905655042,2.68607657617415,-6.27186527004900,-1.35304536897106,-5.60229522696075,2.31932933631774,1.72598657456408,3.66512401151327,2.80841260972321,0.311706765519535,-0.165238480208746,0.215300710739547,1.10664173653951,0.111700520291747,0.653419956819657,8.490408692690209E-002,-0.225580441147909,-1.903191330799577E-002,-0.697074060897723,1.25000106475464,1.17045903195309,-3.142924555257827E-002,-0.308914292639331,-0.713079627725482,-1.05476293913807,0.175557859116472,-0.130472718519603,4.766532940207531E-002,0.150834505381705,0.188695654799813,-8.071469828372942E-002,-9.764044601038649E-002,-3.498964017952361E-002,2.335028407307483E-002,9.484912144004007E-002,0.103722380595690,-0.413621355351899,-5.387475283210894E-002,-0.464931409666084,-0.188912041466614,-0.157679297067656,0.233484351468739,7.854633670810926E-003,0.257381542541314,-0.139938737496919,-4.973367328662030E-002,3.540589405996808E-002,2.141732282977987E-002,1.940092137515365E-002,-1.818482652259515E-002,7.935288859366885E-002,-9.338232464391154E-003,7.384754208378892E-002,-7.447306016971178E-002,1.042457009227386E-002,-9.714769449605211E-002,5.554554970714182E-002,4.455677055169496E-002,0.145956460784214,-9.566090749765830E-003,4.095311615410767E-003,-3.445091757401272E-002,-5.616725989706670E-002,3.179969416976599E-002,-2.460874203547935E-002,8.350471481429550E-00],[-20115.9553266745,-121.076395199843,-390.292093290364,689.856602010060,505.561632560821,1229.19438569636,1839.00922650906,372.226965716562,288.611995588473,640.255358718456,402.978336610968,609.304453236396,-309.157490057850,-327.591178370872,-13.0259014705701,95.8027469298219,179.000169987662,-62.0316597815866,-140.117090993334,-171.603717504858,84.1493826818951,-110.813125889704,160.011488793678,-156.245041403271,46.2104160208795,45.5810955095460,-0.513722522848596,76.7794500366586,4.46259365410365,60.6061836040682,-33.7857072095172,-37.9069391615911,-29.4681087393917,-13.5719247104517,50.8415847013089,4.44024282427373,11.0724123367792,6.54461103187512,16.9605590533467,-5.90258551447608,-15.5809182040142,-4.64442240512695,-12.7288514604382,5.30964611662595,-0.713554755714780,-5.19977773478202,-1.39786882002022,-15.0569951285365,0.361929374951249,1.22065058987025,0.370354231538411,0.716151249242208,-2.82384553939630,0.208368891366962,0.892852526441582,2.30504786395767,-6.33913466258892,-1.21299408028393,-5.57218640206863,1.97688693120622,1.74071363976334,3.44414360654911,2.76817993331249,0.322039197673974,-0.115221224435768,0.266781192072767,1.10590671663997,0.136772098056096,0.657945346738616,5.491630185198502E-002,-0.359961589122590,-0.183705665219547,-0.744098671396038,1.24757101339316,1.09059973059996,3.012286218762858E-002,-0.285012021680875,-0.754078072004043,-1.02137868664971,0.117924377523604,-0.125954943796028,1.637554674326866E-002,0.197319742458895,0.191376881489633,-7.158803290137432E-002,-0.111225238548450,-8.744524193603791E-002,-1.933619013738942E-002,3.639513749189742E-002,9.878946582941979E-002,-0.403060228189366,-4.432275687033054E-002,-0.458160935628903,-0.192349507346506,-0.148408266218229,0.225435609715785,1.891706902060678E-002,0.260462554923928,-0.134632034712036,-5.133083666823671E-002,3.281888880091095E-002,2.741613528498564E-002,2.343961054543426E-002,-2.419595882505450E-002,7.486186253644643E-002,-1.860292128129580E-002,7.247896648473175E-002,-8.027731326518843E-002,6.191999247710770E-003,-9.718291855632309E-002,4.623283041318289E-002,4.859739385196295E-002,0.139464265017059,-4.309101056446871E-003,6.701112291716281E-003,-3.321694465109514E-002,-5.666327025768134E-002,2.785185105421074E-002,-2.680387519367800E-002,8.062329277597838E-00],[-20791.6449466549,8.65890950582076,-376.407084331457,440.147418890498,366.061860909662,1155.86374223303,1944.93896001723,421.676767313502,211.505496447238,652.798076436547,336.429938626122,673.021070954079,-351.174692283484,-396.224964444895,-63.2020026595689,77.8516515347744,180.685327367807,-76.1901888725272,-126.464312656549,-161.768515750958,50.0075823509292,-111.019192727215,153.925561598061,-150.996892570994,42.2088911559596,43.5901261987127,-3.44406797292595,74.1262508329317,4.76673710970615,54.0835633611887,-35.6867345408380,-42.7234249425130,-30.7418492847675,-16.8066190344832,48.5279608244390,3.35740048288591,9.35770468429435,7.19038659839431,16.1912915335778,-6.63601365726139,-16.6627491636575,-6.34839001206022,-13.9165948763459,4.44134671484992,7.690369471231012E-003,-4.63440236100847,-1.08396270895967,-14.7501260358269,-4.603921279577708E-002,1.13392871947768,0.551806016216844,0.774819162425546,-3.21490063449975,1.046574241860822E-002,0.571153217998057,1.91174421505855,-6.33992669509253,-1.09326655966671,-5.48391217487197,1.69298326503328,1.87117476788831,3.18010759184820,2.62291653126201,0.313969750939620,-0.115564973650196,0.330640394656812,1.07512464590307,0.153699105827486,0.653893738095201,-1.380191565374591E-003,-0.501594802641010,-0.371313203407036,-0.781400807283439,1.23071949495481,1.00955551986965,8.806214785274674E-002,-0.267381040350640,-0.842837426850398,-1.00882337727821,7.039299484941006E-002,-0.116832430540618,-2.887911711277715E-002,0.245337214645904,0.188278958849300,-6.191149572026988E-002,-0.119837872059323,-0.147706140985055,-5.840423538726337E-002,-2.862620099038546E-002,9.750674243811218E-002,-0.397453165763946,-3.985129297339287E-002,-0.453805359889545,-0.200407294674879,-0.144415623974755,0.211507124712516,3.884670737145425E-002,0.265424710256907,-0.128689756628462,-5.088120061025282E-002,2.725797737662222E-002,3.440429572181871E-002,2.429959997498850E-002,-3.050985422907935E-002,7.116787409190135E-002,-2.918071587736083E-002,7.274139103263727E-002,-8.858307352274272E-002,2.792950384065666E-003,-9.901486154168888E-002,3.398396128563201E-002,5.003981820254274E-002,0.130423635494234,1.388646857002758E-003,7.572938823511520E-003,-3.099566803780657E-002,-5.709718860454967E-002,2.314589985015077E-002,-2.993800168189566E-002,7.686620349746914E-00],[-21647.2853269906,182.796502383842,-337.748069704559,162.003515228548,209.351830885607,1089.73129184512,2054.85744249201,463.085178987609,126.105489863936,651.399558376275,273.639320233832,735.434307306594,-408.221040679712,-476.024278818887,-102.564047119415,55.7970863462718,179.637277804033,-92.5337619864037,-111.105524478546,-153.882585921623,19.7269551206216,-108.179025340321,146.471821739712,-149.896451747097,36.1220513979085,40.3347622124161,-5.11294364822141,71.3133233690958,4.33239705650934,48.5205603673923,-37.7245786053609,-48.5619397379134,-32.7460926348823,-20.3791583229580,46.6966327103593,1.86753517151819,7.49915162201766,8.04792121620758,15.4763050378157,-7.40072054468572,-17.6119581472488,-8.16011368784898,-15.0255788168358,3.65700316293954,0.678779864079322,-4.11408432088131,-0.608052045710974,-14.6160720177916,-0.542710340238234,0.998908040401310,0.701991128781159,0.791658334095070,-3.56515751555004,-7.000826229410538E-002,0.162784841495962,1.55921206670616,-6.28729487608373,-0.962986652459943,-5.40902729720222,1.46912110333907,2.02390741552438,2.89642477619390,2.45829527225090,0.287326267900820,-0.156922040398972,0.397737186203976,1.03660574370532,0.178115812089412,0.680521497977800,-7.342577394888987E-002,-0.631806694143164,-0.560562061227235,-0.796250859169163,1.19027467542761,0.933591326186559,0.133441992254581,-0.274588454145626,-0.943565902231540,-1.00720224104381,2.503175374554736E-002,-0.107214077059442,-8.480956293416371E-002,0.289116846289831,0.185652735288059,-4.845871696446245E-002,-0.115654881691073,-0.205470921061254,-8.898365034274933E-002,-9.312800764027113E-002,9.874584418040575E-002,-0.402690672023443,-4.011243324902599E-002,-0.453268043928021,-0.215340342357421,-0.141435716553428,0.199655607537466,5.859425017152577E-002,0.269232589438694,-0.123223833982862,-4.949150952497337E-002,1.882441278392205E-002,4.075395163372841E-002,2.313505415646559E-002,-3.574330676538639E-002,7.029854047211961E-002,-3.852146155358187E-002,7.538059240983450E-002,-9.843909463494016E-002,2.366279618061201E-004,-0.102681531969064,2.115976700812530E-002,4.972199762037084E-002,0.120038570235407,6.325825873930238E-003,8.056961618333164E-003,-2.900309549100042E-002,-5.873734521661619E-002,1.932529146428804E-002,-3.254092109295141E-002,7.308232659807090E-00],[-22581.9160637175,375.983941672888,-272.468634303106,-115.551110966273,53.7715024325222,1039.83311240739,2156.62767480471,503.471630771716,42.2064518183478,644.275035126425,229.611944338944,795.046618324683,-469.001414011776,-547.685950387027,-121.861394451637,34.5600573142979,177.856479377198,-105.920525699433,-92.1655914375924,-143.826734191851,-2.50944878630541,-100.233541795467,138.223648964592,-154.325744113934,28.9639897777909,36.8953772260582,-4.87106745502148,70.1242538178030,4.20388895528096,45.2453029266954,-39.8177326194743,-54.6442902615694,-35.6271368339656,-23.5990243689299,45.5212410709877,0.204826158629281,5.99486055009949,9.19320508900202,15.2540919543660,-8.00419193102973,-18.2048270128271,-9.80204304715838,-15.9089032836738,2.84912294410970,1.39173285555183,-3.72703762061556,-0.179006521976367,-14.7043600372184,-1.02374092800821,0.908057473552106,0.828136689718705,0.855129478587564,-3.78601602070325,2.107624401000630E-002,-0.253242878706825,1.28834363384636,-6.24974047889244,-0.858109405985820,-5.40469503937578,1.29263892177654,2.15375749332370,2.61771371705337,2.32551811500115,0.243678451338757,-0.226185508105008,0.462685441616393,1.00999014842759,0.213533707967832,0.752115713527216,-0.153740600088698,-0.737515291444281,-0.745419265708321,-0.781440619213029,1.12501748780565,0.870199218351153,0.170700132620872,-0.310229579145362,-1.03215435560236,-1.00493684983689,-1.744355054594110E-002,-0.102325910029808,-0.145160710195230,0.324407780502791,0.187670556195714,-3.253261989034307E-002,-9.795978385255880E-002,-0.252152126888679,-0.106897003812404,-0.151833660693444,0.101725921777374,-0.419435795339391,-4.507596541568679E-002,-0.453969951913590,-0.235535744616927,-0.134945300121635,0.194675683081056,7.451388366503826E-002,0.270539744800378,-0.120432096619288,-4.844183587732321E-002,8.564697889586536E-003,4.491458792815114E-002,2.109963617444984E-002,-3.875415741756989E-002,7.328016496339945E-002,-4.489858291489793E-002,8.041649881289178E-002,-0.108373945671497,-1.633635962876316E-003,-0.107801045965656,9.345045855971016E-003,4.944788496313043E-002,0.109863108591039,9.709045938901798E-003,9.524959964783955E-003,-2.818568814561450E-002,-6.153196232125373E-002,1.647171422970869E-002,-3.423300187240613E-002,6.994017654708444E-00],[-23555.2891717887,559.144430335351,-203.519904436374,-384.457958223931,-89.9333881153511,995.982082504657,2248.78595408033,546.766552276989,-38.1163458003984,637.579958886501,202.724315798639,852.900773011146,-523.474687425084,-599.918723844278,-117.731533905065,16.3801575605824,176.583812368128,-116.511836794989,-70.3130257451773,-129.475483606596,-14.6576799260454,-87.3172669949119,130.713579250122,-164.088850767224,21.4623851241716,33.6617177470329,-3.21400141350130,71.0760269016967,4.73678646547047,44.7035652492184,-42.1241137348707,-60.2183608953897,-39.3585869619187,-26.2187273179043,44.9641586895234,-1.46165899917747,5.03307211618276,10.4461484264316,15.5786096375543,-8.50091453130259,-18.4280546873961,-11.1060114151066,-16.4759173004385,1.98560037622091,2.07795648400364,-3.55566781833932,8.324238237656292E-002,-14.9420282958605,-1.41395927773986,0.871129312651561,0.923471139396541,0.946869111002398,-3.87225909645041,0.239251352960210,-0.620447512784311,1.09171453100403,-6.31328191987118,-0.830605406301111,-5.49754842724888,1.15610714825490,2.27381058512590,2.37490795533115,2.24089788137047,0.184930643944841,-0.322071958901944,0.529176939627184,0.992421261207503,0.247383200780141,0.844169159909089,-0.244364486259866,-0.820565404775809,-0.929171980171734,-0.739683707772749,1.04699340036073,0.826986006213841,0.209108332391636,-0.367892211442301,-1.09730076845600,-0.998768456211667,-5.027090902889359E-002,-0.105921442685016,-0.203305988888161,0.350616249338435,0.192736749690165,-1.911037966838859E-002,-7.546796865587484E-002,-0.285203975848363,-0.112310955024808,-0.202698282772766,0.105176372985884,-0.444763263007985,-5.582575873556862E-002,-0.451575464072719,-0.258463227125125,-0.122292397698250,0.197712091763210,8.573198737741350E-002,0.269868081498879,-0.122392970721158,-4.823131365875412E-002,-2.050423680906926E-003,4.679646362441327E-002,1.818149848438604E-002,-3.914779708773087E-002,7.872390474138652E-002,-4.829526548848929E-002,8.636132923230952E-002,-0.118195363897774,-3.446801408246241E-003,-0.113842020657500,-4.275510254978644E-004,5.077867195710775E-002,0.101629092025458,1.138743222655686E-002,1.214684641348194E-002,-2.902385398483188E-002,-6.488635361148472E-002,1.433541162431915E-002,-3.516617166548813E-002,6.809179329865958E-00],[-24546.9382812631,706.624545476111,-166.429427486496,-634.146707587347,-208.265717330440,940.342231247102,2336.62456102895,591.998142013272,-108.685088580801,630.635549900795,185.272995437274,910.938637994310,-560.642123011771,-630.945589847764,-92.3639664442058,1.03503803974408,175.450364006879,-127.511261092426,-47.3575617197279,-111.310888903811,-16.9447856984784,-72.4382384691653,125.074863821233,-177.274057100136,13.9748429934219,30.7138797898202,-1.27608226313339,73.4676768082502,5.70623607465713,46.4832922715028,-44.4043937229126,-64.7845561065916,-43.3497738709327,-28.0685890014420,44.9933566782440,-2.94415230515574,4.53440244632540,11.5367636697214,16.1722059274134,-8.87906472658720,-18.4234053292705,-11.9060187743060,-16.7512183235392,1.20552366388825,2.61104771510666,-3.61769903172486,0.131397551876261,-15.2577334155218,-1.69863252737900,0.841370511775017,0.985063244874300,0.981038426156893,-3.86148142857658,0.507038581379440,-0.896351312889679,0.949113082490086,-6.48500795444789,-0.863377561886285,-5.67134060942476,1.05487165833153,2.41487732049972,2.19301274691525,2.20358110480498,0.114752641555529,-0.440367860895445,0.606825112106026,0.972049730782551,0.267611850675409,0.921379901507502,-0.329405524323554,-0.885242363841781,-1.10318432268711,-0.679691917991082,0.974842792759311,0.800415248377654,0.256188086021804,-0.434480768586958,-1.13130508532904,-0.991441683118491,-6.971262969822770E-002,-0.115724220371261,-0.253052859259624,0.369895997668523,0.198173003232711,-9.525728089710150E-003,-5.823650353173455E-002,-0.302982676186896,-0.109689907630692,-0.242499799827805,0.106564748157282,-0.472682829031194,-7.219323820781433E-002,-0.442577330369554,-0.280494965366179,-0.103773577452327,0.207845927643441,9.115426300796942E-002,0.268289887159749,-0.129135611439299,-4.850473988975981E-002,-1.186137562601527E-002,4.766847343417783E-002,1.398599229772447E-002,-3.750938144076368E-002,8.405691466013436E-002,-4.939573916300022E-002,9.105002163771686E-002,-0.127433863862880,-5.196085356420156E-003,-0.119436759987689,-7.340084391527234E-003,5.438341647437857E-002,9.664260657798608E-002,1.240763360022905E-002,1.544113946435401E-002,-3.104180371412983E-002,-6.827313228453052E-002,1.295446468563175E-002,-3.552494896662063E-002,6.775617885024378E-00],[-25557.1455447382,826.981823185431,-119.526877347966,-847.093651316347,-294.632589537844,864.111736770833,2403.05984762844,636.791261562554,-159.257810424116,615.403848966749,172.239302515999,965.956465704885,-570.282342229474,-640.487350828244,-53.4884692832019,-13.0763777919056,172.252139343044,-141.627821179970,-26.1139348138233,-91.4512075517178,-11.6032620757928,-59.7144611526020,121.276131993150,-191.619801263840,6.54324547663214,28.0721620002105,-0.413007637449036,75.8928320861988,6.67021014848658,49.9549659704417,-46.4851526585211,-67.8256839560510,-47.2930130814660,-29.2632010464808,45.4727393758746,-4.12557448306085,4.30240113891594,12.2230681377251,16.5852239262973,-9.07944120964323,-18.3275869328836,-12.2526613323991,-16.8401338839901,0.613989769323351,2.82067437044641,-3.75609235470159,2.192576962089370E-002,-15.6002836518893,-1.92073062367719,0.773384327100605,1.00486346473144,0.864678861146982,-3.84258387883384,0.753528370510684,-1.09646549710714,0.864589036733449,-6.71262582113915,-0.922081569597921,-5.89035250358828,0.965778830723363,2.55988564609332,2.06096955644822,2.20754245190562,3.905753364756191E-002,-0.564542242424096,0.692262430887809,0.935082059187132,0.263071298366591,0.962874875943532,-0.386973924727296,-0.930232746895109,-1.25383737650757,-0.624771681734946,0.920072561078728,0.776291470697949,0.318974609671391,-0.490259053583909,-1.12757500171621,-0.979047029049222,-8.100190333088578E-002,-0.125553446379878,-0.291322026132705,0.384940603359499,0.202027117401036,-1.858138273566496E-003,-5.278071068420228E-002,-0.306864089448097,-0.105763668085640,-0.270928015592253,0.100889010525744,-0.497961925746856,-9.376428358033854E-002,-0.426448182577156,-0.297276688345966,-8.258150204680070E-002,0.222311669534833,9.032466992212690E-002,0.264960386873028,-0.138327516265748,-4.876463544120350E-002,-2.015291144599146E-002,4.894531615871729E-002,9.089698688240389E-003,-3.521989480390779E-002,8.673121834224971E-002,-4.976140761611768E-002,9.319200072130714E-002,-0.135573810179220,-6.850397531932294E-003,-0.123374271242323,-1.174937993992544E-002,6.012933488931525E-002,9.600275788068113E-002,1.433041315041882E-002,1.941028359632367E-002,-3.346084413009480E-002,-7.153210612957531E-002,1.179618496648230E-002,-3.529456689363307E-002,6.838916501892013E-00],[-26595.7458629040,952.378067031373,-47.5095898528816,-1026.84052057293,-329.732343024384,769.589861528035,2443.32195961678,689.441135346182,-189.108286578546,587.799247518910,162.384181100292,1006.97217615291,-550.520568692576,-631.715348757920,-8.21299603680629,-28.6140580327411,165.275241074832,-158.998961191565,-8.46253740495024,-72.3930987535085,0.288054881009966,-51.9504274335114,119.851712168904,-206.392822563324,-1.15148030473662,25.7242989014204,-1.21780597469012,77.6551109853558,7.16161402012892,54.5940519627670,-48.4167423164274,-69.0582143133871,-50.7677342454297,-30.0447208093924,46.6131685176929,-5.08997873143398,4.13982526462465,12.4179280580747,16.6134362152130,-9.13364300944687,-18.1405760858387,-12.3512921700238,-16.7416727765227,0.145221679050125,2.61310572302693,-3.91473839880313,-0.230737694481334,-15.9998886259299,-2.13174554809671,0.617554903245277,0.987249386731840,0.594260865962075,-3.89283266222575,0.968949261937350,-1.28518059514189,0.870236635791308,-6.95526923613278,-1.00752571749055,-6.10633302286516,0.875275636376790,2.68982738273859,1.98397855718850,2.26279014779906,-3.805749756547720E-002,-0.687522939684715,0.773002369382503,0.877997730851828,0.225508617084998,0.973695091103686,-0.419917289825167,-0.946977716844818,-1.37381299513367,-0.597011093379989,0.882459778687547,0.735455784778639,0.393241899444246,-0.530566239328545,-1.08637283422049,-0.962756304064498,-8.865791479136270E-002,-0.131174386898992,-0.319983243662193,0.397189367591957,0.201941974527800,4.750823775618784E-003,-5.872383624886877E-002,-0.302843824861222,-0.103771012084528,-0.291815122306741,8.449452044245542E-002,-0.518411391494424,-0.121206429227948,-0.405015621876115,-0.304338802310744,-6.065310199113476E-002,0.240436509742594,8.339367473355369E-002,0.259617059187641,-0.148404572145710,-4.843929746712920E-002,-2.721232093097289E-002,5.136653139989545E-002,3.859539906061769E-003,-3.285068730548239E-002,8.566598277084275E-002,-5.126293364286205E-002,9.271074286438410E-002,-0.143071589360311,-8.614701358075396E-003,-0.125329357927192,-1.477483334633730E-002,6.757208878695115E-002,9.964716841897424E-002,1.803763151250521E-002,2.368382192009471E-002,-3.567894358994513E-002,-7.516598295322777E-002,1.095081863569691E-002,-3.440806408716546E-002,6.984238208842590E-00],[-27675.4124995633,1044.99028841482,16.5063061001693,-1201.66896672018,-290.355552076286,670.953323420139,2483.53020772029,761.565280212294,-202.901005995352,548.058717500958,159.764329810017,1019.29040156090,-508.148304707951,-615.322687791436,39.7182025982392,-46.9497171871647,153.678350739919,-177.220307520328,5.05777734297638,-56.2986159292234,18.0191832727150,-50.1201955656992,122.121823254503,-221.496769195433,-9.05128707783494,23.5182190700838,-3.27787013663209,78.5886568973854,6.86228456030073,59.6206477023891,-50.0159560653270,-68.5144204801221,-52.8143766534468,-30.5169957454741,48.7114168807847,-5.92168022379479,3.89613370830576,12.1650303835107,16.2793599230650,-9.03386458897828,-17.8052045945448,-12.3659389805753,-16.3888257896797,-0.389522479421358,2.01562294296334,-4.22958823242002,-0.680988726962907,-16.4817377213300,-2.35028510519696,0.349000279199838,0.953566019986141,0.239779100550195,-4.01980994820933,1.17523523064006,-1.53251021796958,0.970217735122277,-7.17734476789923,-1.11723599580972,-6.24425291437958,0.809202777010458,2.81614876291531,1.99325992349989,2.37072912403945,-0.111880986358534,-0.801631707576954,0.834109112548572,0.804971988126289,0.156901417202920,0.966687613448019,-0.445919418966357,-0.931248563224882,-1.45777690632177,-0.599037769646878,0.857079343136353,0.664152368735408,0.461914928149102,-0.568845736743003,-1.01757625586840,-0.953096444924630,-8.963413906171426E-002,-0.130814564626283,-0.340821853963976,0.405571237283984,0.194622845983739,9.832051515245155E-003,-7.105143922296965E-002,-0.296433876871487,-0.104004977526572,-0.308259365597364,5.876149728799721E-002,-0.532185715178356,-0.151800990141421,-0.381749672019200,-0.298350240049890,-3.914577389475118E-002,0.262722519498499,7.132699152275759E-002,0.253962378705743,-0.159454944924445,-4.695200144810032E-002,-3.356464226762348E-002,5.463278351687564E-002,-1.850183067779297E-003,-3.014213475050506E-002,8.106415314682848E-002,-5.439368800616181E-002,9.015482196301942E-002,-0.150098484242704,-1.007644255256969E-002,-0.125320299565854,-1.695055537721563E-002,7.545095663434569E-002,0.105480707726475,2.331082077803729E-002,2.713528710068029E-002,-3.671603800213858E-002,-7.945916457864716E-002,1.138560873842285E-002,-3.304658453734470E-002,7.238026268498052E-00],[-28746.2674125078,1095.96945292077,66.9949114385269,-1378.21156401199,-183.670241189411,583.299808526199,2535.48000457648,849.029135416024,-199.646447827985,497.925231101061,171.068191418238,1002.09429068190,-460.313339581295,-602.827742936958,84.3068673747482,-66.6035916614894,139.728730298874,-194.322633885504,14.4707767305542,-45.8722948400415,37.6859191136584,-51.9133580873106,129.362738200051,-234.781264722595,-16.2150168534872,21.4791900474318,-5.59255442872315,78.5802501028947,5.86499052983633,64.2245317930707,-50.9006224713366,-66.3864543470556,-53.3858057646639,-31.0370426282969,51.1114451057647,-6.68529594425839,3.59042466319990,11.5842188101946,15.8087086855352,-8.73067603975821,-17.2734611763751,-12.4519873835023,-15.7927289582321,-1.11594366384644,1.19850371752035,-4.78414793073075,-1.20417863930485,-16.9121949560931,-2.59248773545059,1.876187808627594E-002,0.935905047254630,-0.100064082222584,-4.19139584978722,1.41559308744131,-1.86256127680015,1.13483402510807,-7.35978109744249,-1.22724138774529,-6.30163489474336,0.771170583731633,2.96005516150372,2.06581351449264,2.50124240329048,-0.177370482467072,-0.892045748714515,0.865430339677273,0.734409711381367,7.655349607637467E-002,0.960447071844920,-0.477913493676196,-0.888554966170980,-1.51045658054554,-0.616962226194979,0.833212499674385,0.568906529783983,0.513620815734273,-0.609470359676607,-0.946483834168395,-0.953573139481491,-8.205394272395207E-002,-0.126112625300882,-0.355131959280834,0.408432847651088,0.180158889708144,1.243730192209584E-002,-8.089060909642391E-002,-0.291643986614318,-0.103531998055633,-0.321581710125347,3.165517792287621E-002,-0.540258526300066,-0.180979557526323,-0.361178269495379,-0.283449487951777,-2.113738379140694E-002,0.286009553477003,5.930388344344571E-002,0.250335676112156,-0.170012985816425,-4.413593462273658E-002,-3.977050777828189E-002,5.780068007365113E-002,-7.591452649951453E-003,-2.690696084010918E-002,7.460795396211266E-002,-5.836139987522486E-002,8.737756437803951E-002,-0.156588583078992,-1.024042604974217E-002,-0.124089663500767,-1.859749083589069E-002,8.190492445803702E-002,0.110852261273681,2.905650430303026E-002,2.931863163652403E-002,-3.632702943069093E-002,-8.375650222463242E-002,1.261359064955909E-002,-3.210235773509227E-002,7.560587115007407E-00],[-29639.8788295515,1129.45076527405,140.643007955914,-1545.84708546348,-45.2838390858692,523.001223905899,2580.23274137958,938.633256235985,-174.048256099909,442.255739809149,203.021521850621,966.126108165246,-425.753576927554,-594.814106846709,118.901708912262,-85.2609293919394,127.685873749086,-209.042691596271,20.1802732323402,-42.9370983473301,55.9705171540822,-53.5241273427523,141.436907925191,-243.649432753765,-21.4874047413530,19.8659383788148,-6.90538216730975,77.7373436967745,4.38090228180290,68.4239361012251,-50.8632509774636,-62.9680649474692,-53.4651235034597,-31.9867467120341,52.6464401025978,-7.42957090836006,3.41769939699467,10.7933848742760,15.5690868258800,-8.22818116386131,-16.4221916842844,-12.7601998649476,-14.9533828581718,-2.04193401346647,0.378733645029253,-5.50065997071832,-1.58906439818967,-17.1341327890335,-2.86548325523317,-0.268692380147187,0.971882642922828,-0.332798948670857,-4.38954258022408,1.74507795770009,-2.26713873915095,1.35047471880436,-7.49674888082781,-1.32366198376369,-6.34400533358597,0.730980143259764,3.11474437331931,2.13610260085434,2.62362746643252,-0.223484508845002,-0.940057844181069,0.861376997341908,0.696678168301972,1.105304171677650E-002,0.974318696379837,-0.521752671142423,-0.823558417409101,-1.54343882170768,-0.640932854485497,0.797597387843164,0.468919047764312,0.545852885343486,-0.642666154907392,-0.894173641929384,-0.956476555991361,-7.125041532103052E-002,-0.120441755048051,-0.364849233668606,0.405752016050642,0.163232734519066,1.116694954143447E-002,-7.903378931824073E-002,-0.293352540492268,-9.818508465797135E-002,-0.331706356697845,1.088165258478215E-002,-0.546349770476935,-0.204711365755059,-0.346247337442998,-0.267856417991297,-7.748539915009252E-003,0.305569510582317,5.295056392457400E-002,0.249483603463294,-0.177315239138724,-4.035472895911524E-002,-4.592013154028323E-002,5.998139406401109E-002,-1.154672869532983E-002,-2.338167671671041E-002,6.838021977639742E-002,-6.215276206188020E-002,8.658773846526201E-002,-0.162315438549241,-8.782691040845272E-003,-0.122764497165449,-2.047851432850876E-002,8.571602242995875E-002,0.114352021622324,3.456312382349930E-002,3.095677237358642E-002,-3.510724345816285E-002,-8.727084260480934E-002,1.298014539946850E-002,-3.231580571191232E-002,7.846107223509478E-00],[-30228.7183512939,1128.84375171610,280.185697426190,-1700.29855908771,100.980221545183,489.223969390832,2595.44975311283,1027.40067554051,-118.665577520892,387.496788489560,261.964961241562,921.614976134154,-403.826320165050,-582.357711479259,142.514003971528,-101.602957627533,120.740751128045,-219.109873714068,24.4196672236545,-46.2933617563835,72.4230640104763,-52.6960225498748,156.711464726201,-247.307247698397,-23.9429598481604,19.3981096544031,-6.09592653127140,76.8438823763659,2.85533896689611,72.9134417617495,-49.3968939722132,-58.1036473133409,-53.8648133944656,-33.2396174521356,52.4021098621243,-8.00350204745751,3.66237979691407,9.86908732522092,15.9687650446069,-7.35162536574623,-15.0290612418058,-13.1684648985235,-13.8159885973423,-3.22313444686283,-0.350071191624897,-6.34053670569525,-1.78865086493642,-17.0564531378202,-3.13765586237901,-0.447421931801832,1.11955451796753,-0.373470712117943,-4.58013783415709,2.21187083459473,-2.72484636133083,1.63932059335922,-7.61652404175469,-1.37922563154633,-6.44646397631994,0.658411675266264,3.24067629197763,2.16248209730337,2.72067451907568,-0.242329528323125,-0.927081164637841,0.816243282783757,0.725820598110039,-2.443997859831730E-002,1.02382558923708,-0.571099601394297,-0.725655358468360,-1.56626785692400,-0.664228692889642,0.733455636404463,0.366942711340903,0.564207091923316,-0.658738787498329,-0.855824596087619,-0.950542127359941,-6.368031597733177E-002,-0.116160315951542,-0.368765817149415,0.396517368875362,0.147817708307271,4.932028534473692E-003,-5.778143017692097E-002,-0.302382009033882,-8.496307951501482E-002,-0.339285782022203,-1.895211033499649E-003,-0.554322886605455,-0.222668920782137,-0.335884727121308,-0.255363558179909,1.766255424106980E-003,0.318618034020063,5.163578860416483E-002,0.249813054934658,-0.179573118938408,-3.583776516571241E-002,-5.191614601979649E-002,6.063108233639555E-002,-1.226458384406173E-002,-1.978977161183166E-002,6.364393752890243E-002,-6.535400708047456E-002,8.842874485239388E-002,-0.167199749679290,-5.285322817412536E-003,-0.121974391811383,-2.282176014969554E-002,8.661751973984842E-002,0.115651446614608,3.991208826496000E-002,3.335664912783264E-002,-3.341579230337030E-002,-8.915207475653233E-002,1.177539884039595E-002,-3.350464834911020E-002,7.985478965148557E-00],[-30489.4348565849,1083.76987215702,497.502582818385,-1846.88730429703,254.178016471411,486.449277960891,2589.05687587386,1125.45325486614,-31.5773010829815,344.191844173456,352.879663825311,878.434124723768,-383.755590487594,-557.262126721785,159.176592241919,-114.586439701615,121.101646739001,-221.980085821633,31.2629019425993,-52.8783264695441,89.8222130068556,-49.1911503051955,174.102762665035,-247.705168909977,-23.1092306277720,21.0045214806143,-2.37393535941768,77.5067915132186,1.92226996036932,78.6605460759278,-46.4638233617970,-51.6860874311263,-54.9888191034623,-34.4006230513570,50.3886713614633,-8.23655021843679,4.62904121626907,8.89424438748865,17.4495944050752,-5.96421561533954,-12.8774407143569,-13.5029710707462,-12.2816091655701,-4.76419284735544,-0.958470268552074,-7.38062947156796,-1.92242844328922,-16.7347945536653,-3.35952212655128,-0.478940066263153,1.41518076295937,-0.143468522366161,-4.70212869187374,2.87202805348113,-3.22415705140716,2.04565232574072,-7.79854160429571,-1.37771082951313,-6.66276200161183,0.548945674283012,3.32482640765874,2.15983698395353,2.79999325295802,-0.237817515229710,-0.848973989545821,0.732441666622974,0.850919286265141,-2.327002262841480E-002,1.12894131425724,-0.623391011911836,-0.581275519664255,-1.59337673609339,-0.677791129164383,0.630146789629516,0.258088296167045,0.573691458679044,-0.659586802976190,-0.819084529462915,-0.934459713247003,-6.036646231040205E-002,-0.116968341384161,-0.365332248963681,0.380633246306527,0.138086172244304,-5.852072403107376E-003,-1.123375311515788E-002,-0.317070636429363,-5.934374153383025E-002,-0.347292441836937,-6.793291439080813E-003,-0.568530114778240,-0.237763505020317,-0.327951906125549,-0.245595172279069,9.521336027770133E-003,0.327022765322965,5.134205218642018E-002,0.250290341227125,-0.177812130561354,-3.114510017677425E-002,-5.784584715206753E-002,5.961896561165188E-002,-9.192898878176523E-003,-1.561233662647480E-002,6.213012362924287E-002,-6.754295158272849E-002,9.321424215473013E-002,-0.172279691527601,8.093389476076720E-004,-0.122579544681552,-2.514011768294042E-002,8.516364997824477E-002,0.115484136273963,4.505059294828679E-002,3.721771061012443E-002,-3.153480969875655E-002,-8.944763755425537E-002,9.729241407869330E-003,-3.507881768444415E-002,7.979849557956938E-00],[-30498.1541622912,1009.54903823792,745.142229391168,-1996.28646035307,400.999291193288,522.643677405384,2580.46078564820,1249.09563670293,75.2071028854887,321.279555051158,469.920015572337,845.834487867771,-356.398332390646,-516.612411731947,172.869952939628,-123.014428774265,128.818301987368,-216.761178012789,43.2283345212757,-59.1358904924636,111.002546509982,-43.4405291057188,193.051390003382,-247.590649220087,-19.0938572894270,25.0543945408100,4.11851805558552,80.9344857679773,2.31488001164756,86.0372706703120,-42.6584870506754,-44.2124535409243,-57.1484176404198,-35.1804847837974,47.3140974917502,-8.03137198521971,6.36498834565384,8.00912506232698,20.1603919373954,-4.17405684860626,-10.0301667040746,-13.6800697234091,-10.3475575028037,-6.66211208566745,-1.37904517963784,-8.63438343535977,-2.10653910903286,-16.3264381716922,-3.48356377839870,-0.342172967039708,1.81706780220340,0.364898469216547,-4.70553314062347,3.70711683904100,-3.72138132800581,2.58780516895997,-8.11354853600933,-1.32393360969986,-7.01006540495633,0.401999106329479,3.38471505647688,2.16208921150219,2.88809425227160,-0.216022240416364,-0.720195289018320,0.622844747713463,1.06677820028183,1.486057794811100E-002,1.29493250678840,-0.671857932928254,-0.396834602505418,-1.64029111203093,-0.676429788605530,0.492441367157963,0.144954227884902,0.576754184740172,-0.648600140167539,-0.780148310603145,-0.914124858095133,-6.113088739818263E-002,-0.125312666670883,-0.355652743762166,0.360417755294018,0.136612949594649,-1.854096777807318E-002,5.681478755987619E-002,-0.335636075016112,-1.997733622040857E-002,-0.358834616893878,-1.930646850330543E-003,-0.590964509020147,-0.252359674667212,-0.321301019648187,-0.237677745242378,1.761184340411632E-002,0.334350875223096,4.975435862966360E-002,0.251101587391244,-0.173748034839320,-2.787940920270946E-002,-6.312075848651569E-002,5.695892969224861E-002,-3.054451238808109E-003,-1.134225236683028E-002,6.519899865284441E-002,-6.807370449437275E-002,0.100973513269391,-0.178083594967287,9.776463909253992E-003,-0.125311085067053,-2.707095872111243E-002,8.267575164734436E-002,0.115177261288315,4.968799287828583E-002,4.244121514048574E-002,-3.009862058018550E-002,-8.913456523450719E-002,7.670335547566737E-003,-3.663984469557530E-002,7.899794294658065E-00],[-30391.3614936557,902.802304644264,976.954936114071,-2163.45700079055,517.529613466224,585.140205723021,2578.40253197265,1392.42157894161,181.483009990065,316.690121717312,600.071459795054,822.796214528206,-322.066004163869,-463.534433404723,183.397323986526,-127.464822671953,140.118465650370,-205.246705396621,58.4192842919239,-64.4397895571670,135.500196239087,-37.7508014504088,212.042003852065,-248.747677734249,-13.1786846057292,30.7863203396978,12.1604398703499,86.4443462582487,3.79123503379536,94.4936815814213,-39.1200679887278,-36.6063204562293,-60.2793104956070,-35.4088442860164,44.0331898285873,-7.44781559682679,8.50850348462744,7.29561512995947,23.6647517057177,-2.25881957298514,-6.92295851737889,-13.7825708508289,-8.27135170570149,-8.78073328261316,-1.59878201488921,-10.0007526359535,-2.38075887326497,-15.9835640435616,-3.52599202789403,-8.646352405366979E-002,2.22763748998096,1.01975397314197,-4.60755209088536,4.60795963987298,-4.20193737565986,3.21914389305004,-8.56127198039371,-1.23458521843587,-7.46348312932880,0.233508417223391,3.42336314288587,2.19321605961293,3.00148027931729,-0.181695265111059,-0.571010168302579,0.505394020900530,1.32739474907445,7.899844545195139E-002,1.49497404162782,-0.709370313691137,-0.198082272991810,-1.71066676327041,-0.665982408434124,0.337789567094659,3.846248059440170E-002,0.572725593236636,-0.627743055550533,-0.740097105726446,-0.895615618205614,-6.628488073537650E-002,-0.138506642577139,-0.342720890625833,0.338126951084080,0.140802063048047,-2.902588270646670E-002,0.132862910900197,-0.356847308770145,2.730661858470351E-002,-0.373319503476674,1.063889950897978E-002,-0.620284510540632,-0.265633638725105,-0.318095461566231,-0.230904669469991,2.480984639899453E-002,0.342548555756693,4.559902797022134E-002,0.252393412906381,-0.168384131783768,-2.679377256997865E-002,-6.724228981179609E-002,5.347032499196498E-002,4.239116005914114E-003,-8.138416865813380E-003,7.154565674349903E-002,-6.679978220659433E-002,0.110511383754961,-0.184469868275234,2.086584061650375E-002,-0.130069972873797,-2.808051980969767E-002,7.990719404397877E-002,0.115899907645669,5.334365534836672E-002,4.843716407067457E-002,-2.967869687550006E-002,-8.903927289824859E-002,6.158785267311757E-003,-3.790478509611520E-002,7.811914908188496E-00],[-30250.3087597959,797.494140870736,1149.91285993091,-2360.25731741607,602.318878540592,646.334411428971,2588.50793669778,1533.43729103558,267.488763274270,326.689973986050,729.075141330186,802.280858509150,-290.868340454758,-406.754937319945,186.766876988697,-131.028088248487,150.989780809726,-191.230460095893,72.7742559024343,-70.9028124830371,160.309032611777,-35.0420326269840,229.564994018142,-251.740867503737,-7.39313719626977,36.7839405577967,20.3167673456552,92.4144937592545,5.43235809479809,103.081526261594,-37.0931247543414,-29.8475658033541,-63.8586581678495,-35.1337439209479,41.2531803599699,-6.84268843855842,10.5210317174023,6.75598277425771,27.3207966354003,-0.566185185752129,-4.08285533349700,-13.9857105925746,-6.38721783954204,-10.9143960953162,-1.64231411456002,-11.3575952809610,-2.74169499412341,-15.8130829159468,-3.56179158584259,0.179294369613012,2.57517956179401,1.64880278457325,-4.46286097923133,5.45501242634693,-4.67939450646426,3.86254176572000,-9.09513806012460,-1.14963199227615,-7.97662035917785,7.105578348773685E-002,3.43751023796544,2.27051195050202,3.14205017731036,-0.142657280444867,-0.441748770234320,0.397892633214854,1.58157128932148,0.155390730673893,1.69257419199994,-0.739311340056792,-1.774129431780405E-002,-1.79931399621874,-0.658177633400805,0.188938250877571,-4.858905654928285E-002,0.558354302465572,-0.600287536519459,-0.705834793846706,-0.885550385672687,-7.500741952788276E-002,-0.152541866709925,-0.332718429208071,0.317111969619274,0.145200110146684,-3.542491340736210E-002,0.202216719573419,-0.380808307794868,7.404030614113503E-002,-0.388033519818485,2.513781873420057E-002,-0.653788767474459,-0.276023796992363,-0.322622342290719,-0.224713663912900,2.917670334744773E-002,0.352076991495101,3.882589221388359E-002,0.254713833050599,-0.162758691224411,-2.689758989655532E-002,-7.081902010428943E-002,5.024780044720293E-002,1.058279553095307E-002,-6.188002043645783E-003,7.844412466311508E-002,-6.399403141532137E-002,0.119778713572046,-0.191302299736555,3.197759412194739E-002,-0.136434966747804,-2.794000326250911E-002,7.695735098973890E-002,0.118374944608565,5.538520302595185E-002,5.448580677885766E-002,-3.068268401941002E-002,-8.967369368982775E-002,5.552787352349807E-003,-3.881578480704338E-002,7.771728215085781E-00],[-30145.3413085206,698.307277424317,1225.02720982992,-2575.50340468938,675.652538142511,686.885606088792,2604.62521464953,1651.15649552083,320.135432357259,346.623945514545,838.783903058524,774.487594270203,-271.255491902462,-358.374519765473,183.386287140304,-136.617920263405,158.049759299363,-176.834802764704,80.9068104191030,-79.9915715589432,180.764265213300,-37.0152168835903,244.818979083993,-256.426383773723,-3.46418086754501,41.8152420687720,27.0725411525934,97.6875688060264,6.62862200173241,110.521002831648,-36.7260122102356,-24.5216880462623,-66.8732035429979,-34.5423585865029,39.4803570804880,-6.61812136178082,11.9453039425737,6.43393395012482,30.4678243341122,0.674052651184409,-1.90135656720415,-14.3556375005826,-4.91023751589580,-12.7843330808779,-1.60914294429344,-12.5792912589438,-3.18513458312045,-15.8571929139066,-3.64036012301180,0.335695811011497,2.82292739539311,2.16445716234995,-4.31526553393576,6.14363391048073,-5.10958831852150,4.43493189428318,-9.62329179231018,-1.10573519771483,-8.48623785635771,-4.945043962041052E-002,3.41459932153266,2.39983516647109,3.29673546516606,-0.108159439750004,-0.365998361054917,0.307181085563524,1.78676081621374,0.223221860452557,1.86822166839449,-0.766699621984960,0.126586332839595,-1.87690869160761,-0.663791594666534,6.949684032855744E-002,-0.116048101170255,0.528784215287377,-0.575372866928844,-0.683569025460180,-0.887534099408695,-8.180710924104566E-002,-0.161706716113729,-0.331209603656147,0.299077218214557,0.145520675684894,-3.889817144359070E-002,0.254266001185350,-0.403525860566802,0.111998539799441,-0.399393421880739,3.691547789152259E-002,-0.686779687001660,-0.284271774199086,-0.337436738828344,-0.218771158282731,2.947436371348507E-002,0.362488056876000,3.018164927767921E-002,0.258295707083199,-0.158650385405913,-2.657143863670171E-002,-7.452644000510623E-002,4.742085201654790E-002,1.387728808470134E-002,-5.624648514431156E-003,8.397123817402116E-002,-6.089095988311287E-002,0.127176604560446,-0.197049585330713,4.066517811938057E-002,-0.142834340259433,-2.724470525695142E-002,7.362577214610251E-002,0.122448184774893,5.559352325557536E-002,5.990628538156584E-002,-3.275028984594355E-002,-9.107083633239026E-002,6.004677341282741E-003,-3.935273353410707E-002,7.827388701239424E-00],[-30092.1551663902,600.235586546253,1224.14057567635,-2802.67258843582,748.788462587371,706.879564210415,2609.71248042539,1738.23964645491,339.488580343420,371.068462887473,921.122746373072,730.338745684475,-263.664086378306,-329.532559427900,175.903413312012,-146.999218951609,159.164648887915,-163.010572322920,79.0663292924976,-91.9482964663636,192.495427848195,-43.1652284210231,257.459455647087,-261.454167789416,-1.85321065602585,45.0750639169184,31.8644708868008,101.503669421041,7.30550758269764,115.650719605090,-37.3297211165773,-20.8036287237383,-68.1629099363135,-33.9182335369103,38.8792375127337,-7.00057249952564,12.5747941381052,6.24319531700585,32.7165017099009,1.42779353549541,-0.552666471880684,-14.8310511402939,-3.95180292428032,-14.0819770110665,-1.59054880116644,-13.5463820250441,-3.69979988245474,-16.1084591677611,-3.78258451038763,0.300936852865234,2.99881977264188,2.53307875060442,-4.21561580320629,6.62043395830765,-5.45477423331775,4.88286991299916,-10.0379010038502,-1.11536689658159,-8.91987022049671,-0.113591353806739,3.34052286921476,2.56661758051373,3.45460984643918,-8.266980413015966E-002,-0.348856751953193,0.220433260778481,1.93349175824809,0.268900382717971,2.01904022279587,-0.791809822878049,0.230399269719503,-1.91086108444800,-0.691488304900182,-2.707839476311597E-003,-0.173148683737491,0.482625067431723,-0.563451648717277,-0.673694703378946,-0.901936127729739,-8.343320374576994E-002,-0.164390501581020,-0.339963669787616,0.283589103970012,0.138546888968242,-4.362856430253712E-002,0.289338780856201,-0.422836994189141,0.136573184386573,-0.405192838726564,4.268614227095828E-002,-0.713628815862875,-0.292012240352972,-0.362266905655699,-0.214050481601654,2.625757124760246E-002,0.371987425415527,2.117161006473271E-002,0.263005278757580,-0.157055850324888,-2.433539336422098E-002,-7.877528666461353E-002,4.462638582423167E-002,1.385090676475794E-002,-6.166931706675488E-003,8.743655884021004E-002,-5.872273128187389E-002,0.132065330792520,-0.200735972202461,4.546506607417635E-002,-0.147656757257668,-2.678275034743356E-002,6.961985971395619E-002,0.126802009669463,5.463023414422265E-002,6.390357380895002E-002,-3.482501510163244E-002,-9.296536741082750E-002,7.458573446024248E-003,-3.963231786613169E-002,7.980594923711690E-00],[-30007.4010425847,491.799388064804,1169.36503690469,-3054.61006661274,807.635959702319,719.280347909504,2593.28924674690,1805.98375658544,338.314595624220,399.405693264509,976.898789443843,666.458753053225,-261.695422290604,-329.630882028688,167.389729340934,-163.527655464736,154.141799427330,-151.545939842363,65.9676642620665,-105.091652548396,193.180051242514,-51.1352113278413,268.336073850271,-265.421697190291,-1.55853392462648,46.2780050496969,35.0941451027190,103.403127889408,8.18855930252584,117.788854143569,-38.0178253700736,-18.7327921060474,-67.0271306169784,-33.6184733700902,39.3876826704502,-8.01753795109969,12.4561520885238,5.95179467901183,34.0236488204053,1.83468122300889,-9.263502345600028E-002,-15.2437254011983,-3.52328550790847,-14.6110800221168,-1.60300744049652,-14.2182978743283,-4.27714148621109,-16.5542876180654,-3.98552199542217,6.134427116089403E-002,3.17071011921345,2.72544794316620,-4.19327720040272,6.86350628678997,-5.69217239321101,5.19859655644255,-10.2787565515786,-1.17767800641937,-9.23228574441666,-0.125385438438645,3.24191572105698,2.76024772399284,3.61857176759158,-6.430107491621941E-002,-0.367983741969619,0.112679203740532,2.03498887344746,0.297677639058584,2.14605138196817,-0.800620984653933,0.288966636014724,-1.88545724733173,-0.745088080533351,-1.342178694808996E-002,-0.227863520008293,0.425860929634624,-0.571158696555405,-0.680156641030753,-0.932062495502235,-7.990241166367471E-002,-0.163725626832422,-0.358763155685310,0.271946573658532,0.120269718246816,-5.430499712866094E-002,0.311109739002783,-0.439459525151888,0.147044974832712,-0.404623026607275,4.303127172714959E-002,-0.729482910432728,-0.299362932979884,-0.395288801059206,-0.212411835431497,2.178925359983163E-002,0.379754844777236,1.403511145992075E-002,0.270278153755656,-0.158520325393226,-1.956417282844499E-002,-8.320455421709178E-002,4.107108759916948E-002,1.171172441844800E-002,-7.443718023132859E-003,8.839976768713377E-002,-5.719539212868840E-002,0.134689323134343,-0.201958827593001,4.675938786054163E-002,-0.150031776091047,-2.711683703792525E-002,6.555341738763794E-002,0.130233731750406,5.364698202322252E-002,6.598694303187411E-002,-3.603098182801445E-002,-9.550969870857183E-002,9.764522471149190E-003,-4.018123299170732E-002,8.231231297797868E-00],[-29778.4079285481,380.574992762406,1051.72653006196,-3332.35278646350,809.493770771457,724.414772583815,2535.05748688609,1867.69511880662,329.560405316251,434.199896242576,1007.19112698522,589.009040962304,-257.142748991338,-358.315808279621,156.770068431576,-186.011980038044,143.878914581000,-144.194880747671,41.8569878525151,-117.864537823028,182.241840814585,-57.9116519497091,278.364082358051,-266.486664910060,-1.19070422502519,45.4994912342436,37.2818519681288,102.949951256846,10.2350804590234,117.140733746940,-38.1104366870558,-17.8976697970632,-63.9164289383458,-33.9989945305726,40.1984049954601,-9.56499642181438,11.6839356121585,5.36101645600831,34.4858878951057,2.00746807928385,-0.382190474827920,-15.4108486434665,-3.50301277807816,-14.3522829173709,-1.61378171964224,-14.5651730632345,-4.85290321676851,-17.0826218382441,-4.22105072843153,-0.344623369338506,3.38953165093723,2.71084681653182,-4.23425299842560,6.85918253359431,-5.80905082264017,5.41595618327014,-10.3544285626501,-1.28624962642665,-9.44611122111165,-0.123279288643563,3.14737005409302,2.95205081750896,3.77938633564234,-4.775251435851176E-002,-0.394993716297367,-3.308069265633082E-002,2.10574744143010,0.320928568305776,2.24586741875411,-0.774313510270570,0.299759848901103,-1.80496928268100,-0.823745186334366,3.798847956256243E-002,-0.280651489057333,0.372861805569020,-0.584835006593865,-0.707411126305837,-0.973957176313079,-7.654333150679736E-002,-0.162118357213003,-0.386010433745100,0.266113292019567,8.776189854074554E-002,-7.239384320592183E-002,0.319286748984488,-0.455040170462608,0.145433030717303,-0.397436539212626,4.016230428652372E-002,-0.732295164185487,-0.305199780750127,-0.433128304547276,-0.215247206382083,1.857108925430075E-002,0.383433776396728,1.123151015475659E-002,0.281027988337056,-0.161874327940411,-1.225269284061462E-002,-8.703494417277331E-002,3.608005846339322E-002,8.670092899395755E-003,-9.341590801049343E-003,8.621571172427595E-002,-5.494840367021604E-002,0.134872559527181,-0.199860299737375,4.557548425959939E-002,-0.150037539705636,-2.853143393852209E-002,6.213471335023969E-002,0.132809663178753,5.365632735728636E-002,6.693638660538098E-002,-3.619415438710935E-002,-9.834226432884338E-002,1.184708555056440E-002,-4.161901057053758E-002,8.497321530251853E-00],[-29338.7168589475,343.462678495919,895.612278595550,-3624.49169209174,707.240327299675,710.745681385153,2420.79173948032,1932.27489812050,319.276496083141,479.642878494514,1012.17465248052,513.623434432427,-241.272037443581,-404.087926635366,142.835993469990,-213.216769778410,128.914604082910,-142.570551036498,9.21375730227363,-129.009715289544,160.842015845522,-59.4760704731380,287.350742037855,-263.138562041555,0.345558759642261,42.7518596293099,38.7339534793204,100.054639368584,14.2660276903030,114.665626894659,-37.2893562091729,-17.6255999618978,-60.0062425472612,-35.1907439397158,40.3627130914625,-11.4615766638177,10.3463143208428,4.33049611071424,34.2856129132320,1.91605894084355,-1.16599349530213,-15.1204825135022,-3.73515609246253,-13.3197689351966,-1.52522039209308,-14.4809392394916,-5.32894192515815,-17.5190507423004,-4.41479377780337,-0.856862888092639,3.68329007590006,2.44428414891793,-4.30432884831763,6.60476350536657,-5.79571296198650,5.59085638386238,-10.3151496437057,-1.43175615088615,-9.62074557958658,-0.161171057981515,3.06610210688544,3.09890216576130,3.92105947478054,-1.807572037108301E-002,-0.411771483840220,-0.216125784041715,2.15684480162731,0.345885781671523,2.31210292671889,-0.703034198540357,0.262273665010322,-1.68645819469745,-0.915724645216374,0.142445855896181,-0.321973441059408,0.345891581046330,-0.582830599034445,-0.753240137890833,-1.01570061742274,-7.954176249750347E-002,-0.160693824844649,-0.418231787754560,0.268711275208036,4.012513079023698E-002,-9.845342388380929E-002,0.311198300126944,-0.472813035656071,0.136460949947866,-0.384471757971860,3.743416077359576E-002,-0.723335094435865,-0.310354148096530,-0.470281048912207,-0.224729907239434,1.979809171250009E-002,0.380136089735562,1.488573988578172E-002,0.294075843946996,-0.165101086046576,-2.498980551316613E-003,-8.904220858056307E-002,2.992310502606548E-002,5.853568473776024E-003,-1.149861039792512E-002,8.035023485635269E-002,-5.057603876273424E-002,0.131950312565264,-0.194685669435528,4.279704065468730E-002,-0.148787118926487,-3.094543553041488E-002,6.050338151874664E-002,0.135581431513042,5.535490705470381E-002,6.844025722472501E-002,-3.588627051747622E-002,-0.100823682962382,1.231139275108287E-002,-4.415401448173097E-002,8.667508132349290E-00],[-28718.9669031218,363.241566918027,755.675603128782,-3912.31667845239,494.663271967865,676.262130260484,2267.64546979203,1992.83155254471,307.847272062648,539.301750259131,991.146592113519,449.298119107037,-207.592452113223,-456.061935560261,130.729656046770,-241.473899077199,108.957108089527,-145.719834270476,-28.6955303172074,-136.578974759700,131.742699138750,-55.1766032246313,293.306117504028,-256.592771338568,3.23455364693124,38.1962898003575,39.3027584331744,95.2958826419015,20.1382623060764,111.039261819155,-35.7587600483071,-17.6131559589811,-55.6037459621413,-36.5402765598792,39.8409338529160,-13.3995171035277,8.62968516116882,2.83697404465402,33.5088730059263,1.50709333891990,-2.28064246183462,-14.1711749702411,-4.10362033178770,-11.5477077273125,-1.28602324571388,-13.9637290404781,-5.77997084590727,-17.7948015098274,-4.46060500326710,-1.41213871894342,4.01644418540693,1.91943373302888,-4.33193439795443,6.10935295993827,-5.63936163683373,5.72871623868015,-10.2074844766816,-1.59215554022008,-9.76723215374811,-0.227367833202298,2.98419372654340,3.20646191931481,4.01559425801683,3.372897697197601E-002,-0.417138114161118,-0.416907263604529,2.18720330353800,0.370129198013872,2.33597414918588,-0.597461843717709,0.183995185285989,-1.54374390422185,-0.995202355762860,0.289723061795570,-0.342163259333056,0.351597520397307,-0.563120772708455,-0.805390871361377,-1.05127692657095,-8.509429272482961E-002,-0.159147025716028,-0.448314443694315,0.279137037051412,-1.837637933170677E-002,-0.131361997986951,0.285080720290860,-0.491363163945264,0.124872044320263,-0.366561432839125,3.666558118086968E-002,-0.704991273791384,-0.315754870602863,-0.501907137404618,-0.239719219457483,2.656739264092966E-002,0.369801009595438,2.179326593875557E-002,0.306528530953378,-0.168915659424326,9.335268119705168E-003,-8.784029565333200E-002,2.335969561111249E-002,3.493392808110775E-003,-1.340534535067269E-002,7.112839324215821E-002,-4.370444291406471E-002,0.125565183655556,-0.187542836115275,3.877763243219262E-002,-0.147168999260274,-3.320081797661473E-002,6.087859480470863E-002,0.139175284215805,5.773174842189970E-002,7.094714838309905E-002,-3.547417336616446E-002,-0.102382887910228,1.175947957580564E-002,-4.682622112590969E-002,8.713414200355749E-00],[-28052.2726922669,363.843514973709,620.565606990928,-4164.46332998053,209.309156061968,635.207628822857,2114.35576042788,2035.47285366986,289.338084365294,614.992103121959,944.203444854383,396.939307457197,-157.865000861284,-513.441401957137,128.256476863299,-265.467955460083,84.2069950969930,-150.939175959145,-69.8889413148932,-139.867116094071,98.6832244260667,-47.6358867968974,295.120661626163,-249.641853702568,6.85078642690541,32.1738070137469,38.4189025015266,89.8877996578082,26.9494989060688,106.514351066066,-34.1372071229281,-18.1447946215281,-50.2155798486927,-37.0587916651899,39.6245709992927,-15.0495343219942,6.73512055684678,1.03635535358823,32.1944031285377,0.730213253454964,-3.75939628359800,-12.5623850736280,-4.55446796428590,-9.00622259263975,-0.850320992367862,-13.1842674833284,-6.38864786293385,-18.0617111021162,-4.29488642748052,-1.94822195016067,4.26336272191306,1.18025967390504,-4.25407200450691,5.42093132464681,-5.33945903467652,5.81446619584660,-10.0751336711585,-1.72494148195947,-9.86608625105841,-0.265563262195161,2.90658183262173,3.33709585434643,4.05808250737545,0.105023065947350,-0.427014791778163,-0.605540870259579,2.18307253229436,0.384091725421286,2.31748379478600,-0.487412604171944,7.674531789430636E-002,-1.38206435400731,-1.03675238509330,0.481908258064012,-0.329056977997653,0.375354328941934,-0.543791953397781,-0.855529657216624,-1.09133927152344,-8.346217553511621E-002,-0.156221656207648,-0.467926594692783,0.291527461719560,-7.980025509640921E-002,-0.167914101557955,0.240735037426346,-0.506407453212568,0.113395468935222,-0.342698962374618,4.035501937272566E-002,-0.680354716944946,-0.322069900544083,-0.528339952255373,-0.258475311328228,3.676740903079208E-002,0.357661279440105,2.684136255986023E-002,0.317947027754880,-0.176331431354087,2.176043894905362E-002,-8.264224841702712E-002,1.719174630890449E-002,-1.037266167883385E-004,-1.554279034119413E-002,5.997520785332211E-002,-3.515911091313643E-002,0.116702742138683,-0.180233342880882,3.389700279088306E-002,-0.145186198664629,-3.312884749886339E-002,6.288063847734263E-002,0.144289784775929,5.909873152335183E-002,7.344407131507558E-002,-3.516824208386251E-002,-0.103405648213831,1.232390969583069E-002,-4.855349318033125E-002,8.748171388244966E-00],[-27426.8752054805,314.594912325891,428.891682187136,-4333.53757993996,-115.620979789182,613.470759993219,1975.26039996280,2052.96996221297,264.805343709692,701.122338979295,875.231220138446,351.338038607800,-97.7366227153524,-579.679235832488,138.225528623637,-280.809592726316,55.7372098197611,-155.645368306837,-114.338558856577,-140.647757125277,64.5318711935363,-39.3726430979545,293.371452703103,-243.246651373654,11.0547375481171,25.4570155230104,35.5337292921408,84.5760871416558,34.0025612729640,100.911913325225,-32.8646136913482,-19.6114777225861,-43.3971792823447,-36.2423347872042,40.7061159807877,-16.1983554211165,4.84137189511038,-0.902595801812921,30.3339367465641,-0.445119407194894,-5.67386075440062,-10.5186015045931,-5.13730011095117,-5.65294409665532,-0.140522857176157,-12.2667471065794,-7.18445556636440,-18.5058221478850,-3.91836792530643,-2.40259375143431,4.28877488203652,0.297144121782509,-4.07384886147103,4.59188042689626,-4.91326471214477,5.85522879943325,-9.90221494291884,-1.78234117765591,-9.88480501665650,-0.244106199389414,2.84084269466581,3.52859511556441,4.08179649904797,0.186094567059164,-0.442819397624120,-0.778465006331266,2.12934137066372,0.376266516604294,2.27135586197187,-0.390169094594675,-4.832787858714016E-002,-1.19124935587725,-1.03431743789609,0.723669889623435,-0.275571688418853,0.397953438825772,-0.539265743549697,-0.903326493937685,-1.14598158937669,-7.155466879109210E-002,-0.150553001383811,-0.471874307541357,0.299486811581104,-0.137710149926049,-0.204985082716094,0.179323072523697,-0.515191455145496,0.102845786268746,-0.311007296651450,5.144819296615988E-002,-0.648818745873055,-0.327364190553961,-0.553679659078640,-0.280155534257135,4.645718916537490E-002,0.348784355539980,2.889525103145495E-002,0.329729946297439,-0.187434656430548,3.241716583116752E-002,-7.284368935629817E-002,1.100579357170975E-002,-5.822067342810197E-003,-1.944801186605519E-002,4.862723015920866E-002,-2.622658404188736E-002,0.107204275636207,-0.172784862073999,2.894100388391080E-002,-0.141816245226045,-2.910731512510719E-002,6.616176702520390E-002,0.150913990931994,5.872772348596422E-002,7.479260253147636E-002,-3.507287802124797E-002,-0.104752812389813,1.521436062273396E-002,-4.917781606749577E-002,8.887714375213275E-00],[-26857.0054790503,255.715818075515,170.142855522370,-4388.86648940574,-442.585602140004,610.879233067915,1832.95748185878,2036.09775331653,242.551832707257,787.551818638862,789.544716108133,301.587055298329,-30.2554004856750,-652.808819946048,159.310531435820,-286.558712995129,24.5529122898126,-158.979090619779,-162.034025476784,-141.282668599216,29.9036988109075,-32.1060533648625,288.184668841814,-236.185714539041,15.6659643630325,18.7030289365391,30.4564053085828,79.0462074758227,40.5749395212504,93.7327112566903,-32.0125023313434,-21.7795152799691,-34.8974315296467,-33.9793842089280,43.2690280652445,-16.8368978542634,3.01792173008288,-2.94723241815166,27.8888923877142,-2.01770188509975,-8.03018289235447,-8.25495830588243,-5.90889965842376,-1.57988136815865,0.775850810940870,-11.1584544877071,-8.06860971236655,-19.1018560210193,-3.38011614261361,-2.76760058658574,4.03139397508360,-0.679036443293745,-3.84163866142542,3.63846411456380,-4.40681809813575,5.83789070080388,-9.60238295911171,-1.75639998128265,-9.76126464065628,-0.154626358568395,2.74996747942040,3.76003265156195,4.10223874866431,0.261208334249286,-0.461472763168781,-0.946810353171200,2.01202674055120,0.326876751089132,2.19943551095829,-0.308783651170831,-0.184526277816498,-0.953996790127795,-0.994856488447988,1.00957703800638,-0.189050377944225,0.405801406985213,-0.550814316117231,-0.939963684328909,-1.20795069018351,-4.818199354549307E-002,-0.141537984740183,-0.459170066300738,0.297872031349247,-0.191241284573323,-0.242273557476169,0.102776029910973,-0.515934478368315,9.175835233110657E-002,-0.268600182076430,6.721153682182285E-002,-0.604909204444646,-0.329480077941905,-0.579055816581659,-0.302863388662972,5.288654391926104E-002,0.342643499379028,2.854498498076036E-002,0.340398559726488,-0.199389890209247,4.004695081713824E-002,-5.879608272281020E-002,3.962916590607369E-003,-1.358192278518696E-002,-2.573917311516597E-002,3.762978861049598E-002,-1.804967252754195E-002,9.675866023823783E-002,-0.163862526795373,2.406743707018463E-002,-0.135223657092955,-2.127398377713911E-002,7.020447503078975E-002,0.157588441966304,5.657612703911712E-002,7.439392630665675E-002,-3.468357579608674E-002,-0.106039903587566,2.021041773027714E-002,-4.861439208502943E-002,9.125505857797901E-00],[-26339.9549660789,213.219937130561,-132.104022389544,-4334.99001136931,-714.350613784007,611.826252362553,1670.80774274072,1984.64157357905,241.026875170779,864.300706097133,695.880262861146,237.599740780635,45.2943918093207,-730.710050498775,189.023150095187,-285.550047585196,-7.39450225505752,-161.715222327332,-211.258765801828,-143.061061244450,-5.39296499163029,-27.8527221214026,279.959679481258,-227.682456689838,20.8981845235784,12.2978433093263,23.8483877359660,73.0548587166683,46.0894143335603,84.6039284186226,-31.0283676182606,-24.0896198297844,-24.4956797089693,-30.5368354076421,46.9494982437818,-17.0730822088089,1.37075705985772,-5.29484962099738,24.9321248003701,-3.77321074893332,-10.7165526000965,-5.91218663404856,-6.81850252169077,2.93876543642263,1.67886223700289,-9.84416773085311,-8.97506082461701,-19.7461908032441,-2.75087672984311,-3.10472668528999,3.57232061963583,-1.71365249909230,-3.62945369534891,2.57888021134633,-3.87604208695518,5.73363093361940,-9.10311712113504,-1.65539504493954,-9.43787405343485,1.867594158496530E-002,2.59812368631654,3.99810268905506,4.11375738117535,0.317264429639795,-0.473182563266559,-1.13211181049592,1.84142896082779,0.227638348285619,2.09384692008602,-0.237462980571517,-0.320797217605329,-0.653714819540415,-0.931667885391655,1.32664798439456,-9.364133708290034E-002,0.391475116590015,-0.579595184433587,-0.954747036234051,-1.26665888939518,-1.308676574036757E-002,-0.131670813712358,-0.431121242175648,0.284036717729692,-0.245498009493116,-0.283625561329788,1.899136803237427E-002,-0.505647788665794,7.705965204890336E-002,-0.213960440225037,8.160838322727558E-002,-0.544491114117979,-0.327562372686709,-0.601556757567492,-0.322968470363799,5.542328587980854E-002,0.336954575672161,2.488305885618949E-002,0.347991805083587,-0.210365687458752,4.592838974229668E-002,-4.223412719138556E-002,-3.987210368273524E-003,-2.253982648159884E-002,-3.289894699147711E-002,2.587639075380834E-002,-1.114796828898120E-002,8.382286018872842E-002,-0.152719498861229,1.911127923234861E-002,-0.123648445098937,-1.078607484011242E-002,7.399612502920169E-002,0.162438321337077,5.316575075956832E-002,7.198766169923661E-002,-3.274984011947821E-002,-0.106345602892910,2.693527001966351E-002,-4.681251664777483E-002,9.398951636617214E-00],[-25875.5990720731,217.282567291301,-435.306001921719,-4207.07220212613,-913.052778160239,621.482150827761,1487.45929352909,1905.83371623754,280.506209145836,928.660700077957,602.704434947376,163.460348334771,129.386136318458,-810.752735084974,222.501978172794,-280.720860289268,-37.2870872670533,-165.674702111087,-258.093518679897,-145.782623118558,-40.0991338890578,-27.0302581737334,269.335070702847,-218.380924486961,27.9681672212423,6.18827214438203,17.1741058770181,67.0629591851843,50.7331093058138,73.7491754218004,-29.8493294387898,-26.1294139299677,-12.8695573646545,-26.5372551792257,51.0940758943241,-17.1095763241267,0.145196405883353,-8.23583190299305,21.7623726526889,-5.61383164205406,-13.3994214241766,-3.62619283636756,-7.68894198977803,7.57236501778713,2.40050108535697,-8.36954410845770,-9.87214510893634,-20.3317726852769,-2.04482534176090,-3.44121218574909,3.08056205192237,-2.77520498691219,-3.47323425736925,1.45477402668249,-3.35440312369399,5.53892685982434,-8.43948982414553,-1.52596433021873,-8.90690387813806,0.268613501547033,2.38606417522992,4.21152717311488,4.09791558019067,0.349992713949819,-0.463098344288050,-1.35211903113782,1.65329700461750,9.231311565890493E-002,1.95819905250398,-0.173467607988590,-0.453132663901590,-0.298037585064899,-0.854571369995349,1.65243715970738,-2.812372083333665E-003,0.357322409685448,-0.623676735060085,-0.945803813453139,-1.31401201651617,3.128558041770256E-002,-0.127701016994687,-0.391264491214953,0.262393630271306,-0.304598593832025,-0.335448871778088,-6.111051455672653E-002,-0.482864509015419,6.072200591738568E-002,-0.150313759854371,9.217929514291442E-002,-0.469261737080076,-0.323382046250077,-0.615838719330547,-0.337948673669447,5.747194554520538E-002,0.329909666395812,1.789926150694445E-002,0.351077371379825,-0.220661720586386,5.261329781213396E-002,-2.448206829096118E-002,-1.273153370592116E-002,-3.067582471948959E-002,-3.765110199937502E-002,1.294969008774651E-002,-4.219438434257945E-003,6.754483939752039E-002,-0.139692232940348,1.351916862788406E-002,-0.107792025066649,1.202339549921831E-003,7.685644000170504E-002,0.164822717181274,4.901117926935207E-002,6.776025727837995E-002,-2.894070998634491E-002,-0.105161386240468,3.466819464280060E-002,-4.386421674815186E-002,9.636061325842252E-00],[-25427.8686287132,256.235174461144,-672.340962299972,-4064.93599924732,-1056.53589633659,648.752561241831,1296.05503343224,1819.76443794502,361.903350897152,981.577085708832,514.247141590441,98.7795528349207,211.225974090599,-884.641558301010,253.505115434570,-273.092759694374,-61.5756191324987,-173.125338462498,-297.651397719205,-146.444791824130,-72.2110115709916,-28.4402863967721,257.190698978427,-210.060831782476,37.5600099462796,-0.420152480276747,11.7248105243691,62.0100254541366,54.4467802011424,62.6631868989411,-29.3438609879577,-27.8059347620549,-1.60172838669245,-22.7643894406609,54.8320808500119,-17.1445652658324,-0.525347704462072,-11.8447465946044,18.7407520062047,-7.66864457675949,-15.7069493610666,-1.72732914983910,-8.20506210125126,11.9804167645614,2.96135216536896,-6.76299468498870,-10.7452780580247,-20.7718419574978,-1.27060739773905,-3.75655993609169,2.66665160785139,-3.82473580355277,-3.44133003415694,0.372720284556323,-2.84458225167789,5.27876090375787,-7.72749973577054,-1.45764684163338,-8.24876399755008,0.534988469587377,2.13869988968421,4.37051037376516,4.04356229354783,0.374343260792398,-0.433353537286647,-1.60116851148188,1.47507767068082,-5.167150058862266E-002,1.80122222417819,-0.136029230271439,-0.578626773574330,6.327396437535321E-002,-0.774900298379982,1.96536925096694,8.312061432584796E-002,0.316311384594758,-0.670326049665315,-0.920612695607367,-1.34239927601664,7.831036894833918E-002,-0.135954437048090,-0.347257373633507,0.240862976003816,-0.368504008834267,-0.403027104119047,-0.129234897416513,-0.453457732977475,4.481974116378299E-002,-8.549083328553984E-002,0.100263847596921,-0.388311562448276,-0.319457487775401,-0.617558680556668,-0.348211183623737,6.666388986220897E-002,0.320390929955799,1.071879601996724E-002,0.349137972168482,-0.231479516801071,6.165988884852839E-002,-6.420879799585709E-003,-2.121446533034459E-002,-3.682482028377087E-002,-3.804420845170375E-002,-1.356634114003365E-003,3.477448210247219E-003,4.970452678628538E-002,-0.126344371928216,6.299026415215778E-003,-9.003455275736619E-002,1.254168986301923E-002,7.924507722878392E-002,0.165744679958462,4.502348630514588E-002,6.291651714246473E-002,-2.434011558308934E-002,-0.102638662382429,4.172838811707191E-002,-4.019492134877208E-002,9.763224215088484E-00],[-25011.9077885524,293.584365200663,-801.670372989439,-3954.68934222535,-1176.60527505753,694.370072865120,1124.51986860851,1744.89687497429,471.395774164650,1028.13982349317,434.406320151984,60.8904919217058,283.211397032358,-945.529206494620,277.100716225765,-264.169991723569,-79.1400731827284,-183.842215190982,-326.307860253474,-143.450233025468,-99.4409033300186,-31.7447190282166,245.215359640316,-205.509525429054,49.3429149275751,-7.51957552842332,8.13847903994886,58.6823630888519,57.4008831542110,53.4095651675118,-30.6014244560241,-28.8860683066500,7.91582133309716,-19.8185567888438,57.5710933103552,-17.3313511973945,-0.644788894086213,-15.8654404399705,16.1311701998310,-10.0813320624038,-17.2838169410173,-0.503248233942315,-8.15003383848065,15.7867523661552,3.45126855521752,-5.17939948152627,-11.6521071211307,-21.0870094661650,-0.458300387748995,-4.02575027695256,2.39596786673535,-4.81397647778515,-3.56631110248507,-0.554259146626980,-2.40189320071963,5.04531082473122,-7.14718664937678,-1.50379652269923,-7.61123280663725,0.754738657910790,1.89156659871924,4.47991651206871,3.96630736039981,0.402730719443783,-0.390336577111249,-1.87049511880772,1.33577637618122,-0.185737454140429,1.65182957670086,-0.144184330660833,-0.688006149413858,0.368176085966145,-0.708860938224673,2.24477489205320,0.155912863052668,0.288610515830288,-0.708768047592126,-0.888178602696186,-1.35228493896031,0.121105449408038,-0.156935938792210,-0.307686735700158,0.225214193243946,-0.433717795245707,-0.483787836620880,-0.184017250901019,-0.430517589527320,3.258081842707701E-002,-3.239649387828682E-002,0.104922708679278,-0.314989354857037,-0.319888080873086,-0.607938006892677,-0.353971219212899,8.829661973635877E-002,0.310140603558824,5.607585259588298E-003,0.344210331827069,-0.245091687218455,7.329450154783632E-002,1.102884462606261E-002,-2.886298302887944E-002,-4.057019406328696E-002,-3.393549727014278E-002,-1.680860583302024E-002,1.086715791262229E-002,3.259339144369187E-002,-0.115035975406951,-3.175948321003009E-003,-7.417257377664696E-002,2.124189504813177E-002,8.230736164621626E-002,0.167419209402033,4.269896957406986E-002,5.935981688631570E-002,-2.011554111796145E-002,-9.952144399528351E-002,4.686917001063688E-002,-3.662358394940031E-002,9.781784554014064E-00],[-24673.4580973508,316.511663621354,-850.418634498572,-3886.65135225491,-1318.85238575728,758.992675546938,993.577734520186,1687.91931529646,590.658895921477,1070.93654021802,368.778720897634,54.4515537608802,342.032097428966,-992.952779573375,288.425964396117,-254.273379323951,-91.8646109917593,-196.051001355101,-342.165004702415,-136.697705734997,-119.874506444397,-36.1915901308562,234.902360614938,-206.391835084331,62.9930142202726,-14.7418695750174,6.67381436775704,56.8713290291477,60.5700959619058,47.0988923345616,-34.2544662673179,-29.2146319006668,15.1528992868456,-17.8821576340550,59.1261347492959,-17.5563630040942,-0.304073180167392,-19.9122887795624,13.9789292724063,-12.8366287385948,-17.9468933319020,9.732757321569316E-002,-7.41797335202335,18.8036518737327,4.11041518292947,-3.80871124313869,-12.6103866266240,-21.3833398027389,0.448927706832361,-4.18228399095569,2.27157295396723,-5.72617206880008,-3.75046845134705,-1.28284053940639,-2.04598081697709,4.94889563270733,-6.79796252960044,-1.63092342547590,-7.08683869839263,0.906352057701697,1.66394353028205,4.55657257809912,3.87973453314465,0.454027722978977,-0.325886989644310,-2.15626335128467,1.25237265640619,-0.296437842325041,1.53225398518006,-0.189728133823861,-0.775432645850073,0.576723872159604,-0.646751999717750,2.47084077003258,0.217643156220201,0.279962960115229,-0.733457510995978,-0.861184392053907,-1.34814138603595,0.152645857456639,-0.184642722882786,-0.272190355519533,0.214116316206109,-0.495102778689903,-0.570965834735756,-0.230775323979470,-0.422717014715443,3.063769708845205E-002,3.035810056741205E-004,0.107982082610071,-0.257521813912446,-0.324058920318815,-0.591571831283520,-0.353293182426336,0.122808282927973,0.301711917186634,3.570213952286717E-003,0.338570605894582,-0.263005036535763,8.693311671413155E-002,2.941782285369901E-002,-3.742864933299579E-002,-4.161244323275195E-002,-2.675928392157446E-002,-3.296623773079859E-002,1.741906335809094E-002,1.685544327147907E-002,-0.106654409643028,-1.426428129609558E-002,-6.323656177342500E-002,2.719818261538589E-002,8.649070934345285E-002,0.171416942953357,4.192003279240424E-002,5.820179571447734E-002,-1.710627223890107E-002,-9.650619501826575E-002,4.965944360353742E-002,-3.373072198526333E-002,9.708242111906273E-00],[-24436.5854784805,302.923454841052,-875.829268227083,-3840.43826975265,-1475.65289095515,828.794770392396,913.371670980817,1643.57964986644,703.304800298319,1104.28001608925,322.101212605982,76.0653039753928,383.179155588619,-1029.77024264912,286.564964909313,-243.023091284347,-101.572021790762,-208.830303695477,-344.874020537726,-127.251402221364,-132.542896953084,-41.2553033030580,226.160259650732,-212.321990184724,77.5808806864361,-22.0783157632696,6.81799488328338,56.1118660316673,63.9534184724881,43.9375812675063,-39.5603344928485,-28.9799426455624,20.5125247605863,-16.5683606265260,59.7654440438334,-17.4282901879082,0.341597111726736,-23.6505977223426,12.1588972280089,-15.6096159596989,-17.8547776958968,0.329728973004197,-6.10804718049712,21.0783274958781,5.14939066608031,-2.74701000366419,-13.5972292283934,-21.7846165499175,1.49342733628397,-4.18304360922104,2.23277716015012,-6.55118996031566,-3.91961956579039,-1.80515619027657,-1.73684196542111,5.02070444243041,-6.64903646175584,-1.71803076463720,-6.67016903945966,1.00879287966177,1.45932400679467,4.61394727224847,3.78679974614106,0.551744022015002,-0.234688070835936,-2.43970876129512,1.21840925891964,-0.375515586128224,1.43337922416827,-0.255819204716517,-0.831859794007078,0.684281284361336,-0.565584128078082,2.63905893990111,0.277765253812050,0.285883379347282,-0.747421241556125,-0.844434905570183,-1.33576368862568,0.166926160183673,-0.210103376266278,-0.234935677486140,0.200657701050245,-0.547383717917968,-0.658061489303990,-0.272467082163452,-0.428751107891445,3.936700186251172E-002,1.437073505754057E-002,0.113459685580567,-0.218230957632035,-0.326832189277732,-0.571315318158251,-0.345083248905390,0.164414718263972,0.297679288700904,3.619568340906256E-003,0.333139954448897,-0.284590259861623,0.101141810369655,4.966582153184233E-002,-4.780066936661045E-002,-4.088885446875890E-002,-1.934530463243794E-002,-4.977065736286731E-002,2.216891344373369E-002,3.201553868982814E-003,-0.101028769843602,-2.494368088244348E-002,-5.719484413576226E-002,3.161260708875259E-002,9.165009755674833E-002,0.177633762685127,4.172252555962234E-002,5.946314492022440E-002,-1.507493688221603E-002,-9.398927755344405E-002,5.063200070898544E-002,-3.154632529716351E-002,9.543982672260119E-00],[-24331.9986111903,237.675654592232,-901.676025422249,-3750.77063251517,-1606.88224517362,897.563465294254,884.223645623829,1587.02148770566,795.882964903805,1124.72859546808,292.825443613890,114.528844103575,408.394014506155,-1060.50775881973,279.026217738153,-228.632311695826,-110.044663708088,-220.003867374731,-337.548155772779,-117.667256332840,-136.805211728135,-45.3569402006727,217.568022148660,-221.495551185885,91.1669504601999,-29.2985289640394,7.13775113380623,56.1435504972424,66.8790467761102,43.3580574345421,-44.8661008816789,-28.1719962870018,24.9140349631802,-14.9566255600236,60.1587772301364,-16.6645159922987,1.17072260664964,-26.7217494484572,10.4911120939829,-18.1197213919283,-17.2620248678259,0.664461863127326,-4.49157714191298,22.9172746773417,6.54690448217163,-2.07508275509081,-14.6194159630471,-22.3466412927779,2.67135571862336,-4.01047849045007,2.15176203981369,-7.23650776223980,-3.99678460778273,-2.13493169027311,-1.41538221723930,5.23502575018052,-6.60476095126907,-1.65199411062440,-6.29992601869943,1.09738009508653,1.27100440638543,4.67486845525570,3.67471578337201,0.693121740475157,-0.132596273571450,-2.67913985163476,1.20939679186016,-0.440644843498250,1.34751165686044,-0.338460024084848,-0.847403530345587,0.728780957253847,-0.441806796531648,2.75529126813746,0.347823386302195,0.296627862993007,-0.765983647141664,-0.826796630805470,-1.32199001660502,0.169750529139751,-0.222614785419160,-0.189164411454858,0.177517364509690,-0.581315440170158,-0.736931500184198,-0.310541351666238,-0.439613754521144,5.887795349750853E-002,2.061866500858657E-002,0.124235247357684,-0.194115018159344,-0.327934835418400,-0.549030567461961,-0.331534731762695,0.203744098086195,0.300766820157123,3.065756824953453E-003,0.327289775748405,-0.308801704210298,0.113988460097477,7.119396126676093E-002,-5.980412478995902E-002,-4.040160303898363E-002,-1.420805799750124E-002,-6.494163149529356E-002,2.350195566317257E-002,-7.408066857067166E-003,-9.724087957425881E-002,-3.315208989950894E-002,-5.434124448343648E-002,3.656520724837560E-002,9.730745346003966E-002,0.184561311032906,4.109963628469244E-002,6.203657199640698E-002,-1.312111812107442E-002,-9.176081664184556E-002,5.128415739074691E-002,-2.941539019356103E-002,9.342188882926188E-00],[-24372.1582737735,81.1344031579019,-886.586826493982,-3566.97702792253,-1684.72779156931,970.470091583653,899.952180354794,1499.19862426560,855.060043236732,1130.41788364227,275.515700264201,159.356967258350,417.691576187278,-1084.72541339923,274.652619945953,-207.943770555582,-118.279547504416,-227.400659130798,-325.659563418839,-109.075278930139,-132.577613934792,-46.1320444661255,207.717788566892,-232.228674139198,101.939447725044,-36.5822170801924,6.23849362085982,56.8279548923846,68.4640093361345,44.7412290547548,-49.0568467528642,-26.7541777752868,28.7067906680847,-12.2950137527965,60.8661470598840,-15.2191619625538,2.07120758948999,-28.9281448332924,8.84693647687411,-20.3231389759258,-16.4506839909368,1.36756339507156,-2.75456057484440,24.5836288722188,8.13192137601479,-1.81344382478065,-15.6760380222587,-23.0035417964869,3.93328800902199,-3.65532110847871,1.86147637856269,-7.75332220164812,-3.93028955581220,-2.29154541835153,-1.04611119161170,5.53042152245281,-6.59795540252513,-1.42743592005297,-5.95136256793857,1.19324712225511,1.10185394348654,4.76233955443568,3.52441778127489,0.855004148525499,-4.864602832799804E-002,-2.83167418587966,1.18364028939803,-0.514487945867323,1.26899092589535,-0.453645956534311,-0.821359476866135,0.746335123949607,-0.263201494198086,2.82786621270872,0.439455588965515,0.301909936183714,-0.798744699275398,-0.797996276611065,-1.31251273680096,0.173206984602440,-0.218294708205710,-0.130891593068162,0.141604607984994,-0.590928456453429,-0.802618348014208,-0.345898213900770,-0.445842886705747,8.956286965513868E-002,3.053266454533060E-002,0.142940859143705,-0.182278000976910,-0.330488805797729,-0.527016145282748,-0.316892145079350,0.234620015975574,0.311383521540112,-3.742201988812878E-004,0.319825138822315,-0.334039450669862,0.123622129677811,9.299285980634758E-002,-7.221590457286252E-002,-4.222405737942377E-002,-1.290351233430712E-002,-7.567915365753437E-002,2.118708725885908E-002,-1.366021840029756E-002,-9.468466302722278E-002,-3.792409559078652E-002,-5.301001879396427E-002,4.332281991955511E-002,0.102534238863062,0.190994909091220,3.887862079638415E-002,6.472478036165816E-002,-1.123526724973207E-002,-8.955878808229949E-002,5.298579290206968E-002,-2.646763172289324E-002,9.174613543870493E-00],[-24476.1813602034,-165.374649304581,-830.970869804843,-3295.35452146513,-1689.79402353396,1059.83526636143,938.625993481619,1388.28630148739,880.825534094921,1118.44759365799,270.584085474584,207.898607574403,408.328528037041,-1099.52178510221,275.119980859908,-180.821274733410,-123.878079286648,-229.184341306905,-313.971343910609,-101.207130919946,-120.928671488577,-41.3030455290124,196.696203721290,-243.016310140389,110.122219997556,-44.3252306704993,4.33053519103192,58.7803110931826,68.4889133499014,47.5508369665323,-51.4363827031886,-24.9241161909720,31.3624649112075,-8.70626986743740,62.0481907095549,-13.2509440452504,3.08861974599862,-30.4224581626785,7.34477304828036,-22.0637747554976,-15.6672852640463,2.28991060026997,-1.01404543496893,26.1307438893867,9.73110825204653,-1.87576960461884,-16.6700481436111,-23.6365295199363,5.20399255179219,-3.15447479404584,1.30747255087754,-8.08930601643575,-3.71805265767652,-2.30363946328449,-0.613207972787751,5.82267582454804,-6.60435915428296,-1.11343412577003,-5.63654384835822,1.28881348738634,0.981358685722067,4.88383439646061,3.34680051471527,1.00998106171572,9.637907902637452E-003,-2.90523707692239,1.11308967463483,-0.581337366605564,1.19722008693099,-0.610035192612290,-0.766524097757236,0.767092998894435,-4.113377089763479E-002,2.87364153072747,0.557664834435544,0.303898809725344,-0.837963913837453,-0.760833778857865,-1.30980618303005,0.179465806830273,-0.205182751215635,-6.251617767504922E-002,9.726763270237936E-002,-0.582412112295910,-0.855884638451556,-0.374246183258576,-0.436894555239272,0.126344676850865,5.115831019134055E-002,0.173196045132192,-0.177881814832581,-0.334431583952885,-0.505919899246018,-0.303102152601135,0.255027042405899,0.327859440544863,-7.366584713973899E-003,0.310788890778969,-0.357224501211264,0.129395397716231,0.113723108679503,-8.376154335348981E-002,-4.657951843428256E-002,-1.470586454765418E-002,-8.102762303878686E-002,1.760278879636628E-002,-1.407324863512707E-002,-9.235984164032306E-002,-3.920715325271266E-002,-5.088136571174046E-002,5.255389931286149E-002,0.106818655853610,0.196924854505630,3.428117295950037E-002,6.714686940975102E-002,-1.055155648783150E-002,-8.795799807138935E-002,5.604730508731439E-002,-2.263034552332864E-002,9.085391776052967E-00],[-24567.7871376850,-442.610103107127,-765.823906245692,-3006.91443268846,-1618.47265922831,1140.26088055354,967.272510049112,1264.67301896135,878.353978050209,1091.77639030775,275.609257383703,258.300384415039,379.801260373304,-1101.73654915250,274.088968382066,-151.673230166720,-124.191357420803,-225.517803496958,-304.743770758288,-93.6593120360859,-105.858417887682,-29.7809428468346,183.749373720301,-253.138087564474,116.823640333348,-53.2692201135669,2.85398767789305,62.3904003626302,67.1159319789047,50.6447899207219,-52.3408221889664,-22.7640224943847,32.0620729067851,-4.84701518697796,63.4019326481225,-11.1458643494948,4.19499890048806,-31.5461771901019,6.21173368491421,-23.3040369976252,-15.1507488134970,3.11981922163818,0.621879573760891,27.4632681556029,11.1840120131391,-2.04010974885509,-17.4810028413932,-24.0508897154823,6.42378815328926,-2.62995801269527,0.609582131523178,-8.27420685669540,-3.38888719169142,-2.25732343118389,-0.154140047461282,6.02565230116640,-6.62149483771599,-0.816866626642624,-5.34297447159672,1.36748790299039,0.905787027726586,5.02379885470788,3.13654348446478,1.14013866118302,3.946475842145943E-002,-2.93342986581466,0.997525564350666,-0.610509767429892,1.12839169343032,-0.808205931272084,-0.708598714773353,0.805847168748868,0.208029142092132,2.90720880700930,0.702107925684093,0.312049964282636,-0.865337761733338,-0.721751606904656,-1.30761674980350,0.184234360220036,-0.195272916975641,8.254310158643932E-003,5.396917310942111E-002,-0.570637311468462,-0.901695744558176,-0.388080260531009,-0.408763416098262,0.163152884791238,8.170813814082462E-002,0.216239741041788,-0.173679567656001,-0.338256456544859,-0.485064887089506,-0.288302087455104,0.265883754764057,0.344678439782501,-1.844209926393131E-002,0.298653806389305,-0.375637668768235,0.133513901809563,0.132331338893033,-9.345638599228481E-002,-5.227863423524631E-002,-1.626347137757229E-002,-8.165600421105564E-002,1.583019322233990E-002,-9.475595243293689E-003,-9.064960695772838E-002,-3.771223690578382E-002,-4.650815057066594E-002,6.442917580730492E-002,0.109462577394042,0.202487102673866,2.643827100326855E-002,6.937277439524636E-002,-1.247500972043757E-002,-8.711894491562869E-002,6.007560576179347E-002,-1.788725425082155E-002,9.033950910601148E-00],[-24608.6390554666,-723.925617206285,-671.573236447309,-2793.75448489289,-1490.27456939543,1197.41828969028,978.703487117787,1137.62503986914,853.987973208926,1053.43366181415,285.414611237398,316.245902598300,329.758784018362,-1091.73411402492,261.795571983708,-124.238795925073,-117.336885886598,-219.347510934027,-297.615327932756,-84.9720786421620,-91.1234651922778,-12.4744838226018,167.806714589935,-263.079550060537,123.163765897556,-64.5692046765982,2.81817433395962,67.6088376327594,64.2993622862155,53.1653836345618,-53.3493709639761,-20.5735216487543,30.2514606062299,-1.60223407589912,64.6612174607581,-9.34765970326677,5.35902216881806,-32.6527199258804,5.39735177530790,-24.2294473904747,-15.0422843131218,3.43250956281193,2.03917071157970,28.5078605181886,12.4000101907731,-2.10799632038829,-18.0492710081835,-24.1013342902213,7.54796687049080,-2.18537511288298,-6.991452543324225E-002,-8.38438121718450,-3.03162546681542,-2.22390723328830,0.309719996184943,6.07020552887182,-6.68280353887685,-0.658588176004986,-5.02795934099140,1.40689000126599,0.872615295208341,5.16492759182062,2.87773996631242,1.24056719891473,3.791380597129398E-002,-2.93945164699849,0.844376553120639,-0.573445865895485,1.05022928299833,-1.05408059067900,-0.672130437192013,0.848849469824146,0.464173138437444,2.93903771034002,0.876383795799600,0.340101642796316,-0.871781930786574,-0.688650726806241,-1.30068980877678,0.183107769215696,-0.199001361681243,7.279075466000112E-002,2.295969618286210E-002,-0.566466116178771,-0.946829729575778,-0.383500836402820,-0.362721687490755,0.194876779641541,0.115721269032898,0.270003659282827,-0.166301974733131,-0.342007214852843,-0.462625838683123,-0.270244541263367,0.271325168424198,0.357073355187725,-3.178159130413487E-002,0.282072967875531,-0.390038061059535,0.139106709492581,0.148512682880242,-0.100509093155715,-5.765689315076432E-002,-1.377129122882411E-002,-7.952685440429637E-002,1.755351289988935E-002,-5.206467117577157E-004,-9.046760142043409E-002,-3.547160617105664E-002,-4.021364218209201E-002,7.820109271818518E-002,0.110499720862810,0.207846808387295,1.536568023612676E-002,7.117048636049540E-002,-1.810732037855491E-002,-8.697770063360716E-002,6.428121422343459E-002,-1.245878254057632E-002,8.973264436111697E-00],[-24612.4986887308,-1024.16717857129,-547.271517491344,-2697.67724826034,-1361.50241910048,1252.62989880835,970.582654344590,1022.18692955572,817.840342837773,999.695720733991,296.598839955903,393.396822059510,257.260375793631,-1074.94809393207,228.878497264170,-97.6141816505212,-101.545467484335,-213.054431127142,-292.432919439198,-73.6987225727405,-79.4071035238198,9.91254253240476,149.376174170756,-271.887521434035,130.483237300443,-78.5846571679972,4.33934462396259,73.8792013990185,60.4212549103531,54.5803695481246,-55.7190937659680,-18.6606614606242,25.5399960230121,0.200880201415542,65.5782512842900,-7.98116315988647,6.64954752392157,-33.7810653633574,4.56905974126410,-24.9138439394951,-15.3703371854617,2.88396723184291,3.10401917612640,29.3887948760918,13.4913141865747,-1.97702254391435,-18.2150249987870,-23.7545376290601,8.54342597428132,-1.80225331473338,-0.642796269203735,-8.46148180755459,-2.75831947317627,-2.22472122739653,0.837989234754628,5.96157333996324,-6.79947780028046,-0.662137522644581,-4.66279498537616,1.35951573110606,0.883706840002784,5.26896166691935,2.57270910354372,1.32356846254289,2.634338989987963E-002,-2.93607629386809,0.662438454533117,-0.446460602297882,0.953758916308078,-1.33838482955377,-0.663229547141399,0.878978997392701,0.705793600938447,2.97045988506534,1.09263292341115,0.394540861219928,-0.855216626531883,-0.674408947084102,-1.28666528682456,0.169396585552290,-0.219173115320631,0.129146340609545,8.871604793215958E-003,-0.568470291422261,-0.992236330213379,-0.362343993041957,-0.301867866115442,0.216106445032816,0.147585309007048,0.334564799463931,-0.156124369701928,-0.345118642591371,-0.439517463830954,-0.251351151466024,0.272671451371166,0.362498260949350,-3.998114427815178E-002,0.262553954128248,-0.400326014378455,0.146420142110216,0.163345529475621,-0.105122177009219,-6.082943930958765E-002,-6.386400976486135E-003,-7.658450586105774E-002,2.220137319132407E-002,1.360487820867105E-002,-9.109582714047072E-002,-3.396979513538682E-002,-3.287990570479145E-002,9.280104446723661E-002,0.110311070592275,0.212493397897509,2.906186415077628E-003,7.198955974257586E-002,-2.770495687231318E-002,-8.703398164181488E-002,6.704469859690117E-002,-7.362823381150147E-003,8.859490622270053E-00],[-24522.6625523074,-1350.20879167362,-392.288361405120,-2723.64728922830,-1260.56125847188,1309.76942089454,953.511889241012,935.097956752950,779.120273074869,930.334690463367,309.478502414204,493.276623908194,166.258062603487,-1058.20087363935,171.422123476029,-71.1287073650956,-75.1636699178100,-209.687703337339,-288.835436279327,-58.5002273170963,-72.1130344157634,36.1314887544227,129.721490233167,-278.463632209131,138.852440246444,-94.5647198834833,7.07575190623966,80.1323928846041,55.8050032636427,54.8832319568881,-59.8833357805453,-17.2199027379039,18.3084452331845,0.240722011691871,66.2088523779916,-6.99653648105248,8.13924023277610,-34.7658240100855,3.44511880633498,-25.1993643737006,-16.2216844582341,1.47629479223246,3.69610170158430,30.2564121367241,14.6152947858808,-1.65750407015026,-17.8910947461624,-23.1127150284638,9.34139670604284,-1.43760593885405,-1.05604227763550,-8.53410698772301,-2.65793776429264,-2.24616623755817,1.49012285026770,5.76484852419820,-6.94837986326866,-0.781559866162289,-4.24470680308844,1.19407484692608,0.932649049634798,5.31619448053135,2.24765021833864,1.40576372302882,2.380356998085283E-002,-2.91668002055488,0.469092108608030,-0.215336754354122,0.824000811937771,-1.63467820943620,-0.671620876506543,0.878811412834273,0.917697278863766,2.99992167141684,1.35242770646681,0.474561263360271,-0.820920949097000,-0.684426876545909,-1.26855268630020,0.138829208078116,-0.253594406632372,0.177211193665946,1.154024254965785E-002,-0.569642204945788,-1.03335411724462,-0.329605337205763,-0.232009173383443,0.223014667793252,0.174988438606305,0.407529746343579,-0.146480700138414,-0.347396415433424,-0.419106243717967,-0.234970621797012,0.269890412447284,0.361194268890182,-3.713557919800064E-002,0.242949046863055,-0.406351794220633,0.154166550468448,0.177089245972761,-0.107358805457850,-6.047348172111834E-002,5.012859863077456E-003,-7.507685252551118E-002,2.796621722877143E-002,3.346328349697131E-002,-9.233895700288500E-002,-3.330944976596406E-002,-2.552092696789810E-002,0.106735633286169,0.109749444352753,0.215732591544266,-8.399262462260089E-003,7.135979561634570E-002,-4.051740682244499E-002,-8.688161163820907E-002,6.739178568449215E-002,-3.515676073431725E-003,8.688631381014386E-00],[-24309.5763540818,-1683.20683663550,-234.612807531809,-2829.84203142416,-1166.53764395685,1347.39487970930,940.490811095833,893.858268234106,740.713394851603,849.496438394995,323.248875509160,607.512789095868,66.8738010392102,-1048.49844179835,88.8876994902457,-47.3192089511859,-38.3987990199303,-211.498357861918,-286.882270330037,-40.7933946226915,-69.5910374445615,62.6768142662262,110.741131785856,-282.062654612558,146.747615303818,-110.504843392903,9.81500807826091,85.2650604332383,50.7254023209614,54.5341214026076,-65.2143673331793,-16.4193162713765,9.58442701370147,-1.61725359942811,66.8346930736572,-6.33055478810746,9.69326766312124,-35.2462338276397,1.83274495585747,-24.8349670047005,-17.6848331188905,-0.597158657422748,3.64775575780793,31.0780047401589,15.7586517604701,-1.20357414449411,-17.0671082695667,-22.3822823359330,9.82651377597609,-1.09796780107051,-1.28149013719619,-8.59394947811297,-2.77388456449742,-2.28737652277320,2.24313788006521,5.55975101337373,-7.09534184002916,-0.940181972225525,-3.79071362211298,0.926461858496034,1.01391183648516,5.30678969186631,1.94821800547264,1.48549240212754,3.481366703441163E-002,-2.86286868132745,0.281239734369933,0.104319703393645,0.656370198397644,-1.90378906488298,-0.679597709648333,0.839933414572271,1.07864136672564,3.02906726260346,1.63492581854906,0.578135586776919,-0.775605648099480,-0.718989923101523,-1.25467475033557,8.755735670378567E-002,-0.293919948317993,0.213240387171310,2.897165244613839E-002,-0.563213532633091,-1.05902986330474,-0.293492948412784,-0.159503389185921,0.212896353188315,0.194762554712068,0.481104348767836,-0.141693753827091,-0.346790824839292,-0.405820460368602,-0.221667306021219,0.260676079388120,0.354859187559129,-2.216445749021428E-002,0.227053131501785,-0.407864264355054,0.160315975823641,0.187664103262415,-0.106918993319536,-5.691294992465183E-002,1.825955638777676E-002,-7.612921000361152E-002,3.218344089404617E-002,5.854037508687509E-002,-9.435935629284742E-002,-3.231916628571351E-002,-1.920734507598561E-002,0.118442243517333,0.109654160057623,0.217467469836724,-1.622130046724886E-002,6.914929560089245E-002,-5.477742268944229E-002,-8.670347760371878E-002,6.513401107886804E-002,-1.738020042915465E-003,8.482553700767344E-00],[-24122.4449335858,-1996.39663648091,-157.898963088189,-2922.47906566393,-1058.41452068809,1375.61276023690,944.857417032595,905.536365882877,701.412624502423,769.819534109831,332.991604019959,717.781028151231,-19.0366490766255,-1056.32633344492,-12.0510815317697,-29.0311569668776,4.35393602758609,-214.827417080995,-287.940354141295,-25.8635795255940,-70.4079551799414,85.7948728986469,94.9631632549507,-283.133232403196,152.797155702527,-123.179228853880,10.6174494979125,89.1449308152428,46.5367261789189,53.5792167191795,-70.3218022793575,-16.2008393792701,0.903909458624901,-5.33211695266362,68.0465642183377,-5.94696893591474,11.1075295654047,-34.7731250296590,-0.366676060410817,-23.8093076602199,-19.5988500535967,-2.99606776694383,2.76514897089501,31.7866456312020,16.7429795168761,-0.786256989357628,-15.8284481666354,-21.8127912443812,9.97663808412822,-0.785813338298614,-1.34574627782645,-8.55631859174471,-3.00301030222472,-2.41786352481177,2.99268206388915,5.42616423767138,-7.22005659389679,-1.03919998922959,-3.30889665654039,0.633752734290861,1.13339101948555,5.26984140102855,1.71199365327968,1.53175249521848,6.601762157719232E-002,-2.77448444084262,0.110340982373978,0.456929552391860,0.490577073256662,-2.10782947472248,-0.677803582089467,0.789991209483718,1.17788864531381,3.06049690042778,1.90737437734940,0.696650891571953,-0.737491536025399,-0.779712671899472,-1.26045411361495,1.852046877083353E-002,-0.327246892152891,0.233704832773695,5.854737298092984E-002,-0.543541923941682,-1.05471867944088,-0.266712769924056,-8.794244330065226E-002,0.189880472856457,0.201306211093633,0.549735408258020,-0.141372134120901,-0.341542711818886,-0.405974886040922,-0.210490793884652,0.240070021661205,0.346773453189492,1.685749709081331E-003,0.219188651508902,-0.406106451240165,0.162179839107667,0.193377415408858,-0.105390394240474,-5.147853214086581E-002,3.057980762744604E-002,-7.703945751683502E-002,3.308798042833260E-002,8.700400465507405E-002,-9.558686349947197E-002,-2.914943833414781E-002,-1.505167225671930E-002,0.127943566239653,0.109742245559709,0.217345770118618,-1.963882996604517E-002,6.506566536957403E-002,-6.795228318085693E-002,-8.713684195913728E-002,6.140423778535076E-002,-2.490451213345808E-003,8.326269667889521E-00],[-24090.6553033675,-2253.12118120938,-157.610167081964,-2952.55242241658,-928.875267067486,1407.01446693514,979.992626691024,949.577003567473,664.096774255784,704.260244044814,339.283974210578,802.288168375971,-74.3466697462235,-1087.76826917017,-119.785054128641,-19.5789243833077,47.3754079174422,-215.541991785825,-293.050706142148,-20.1617745355018,-73.2760370622553,103.597356812448,83.4579421906165,-282.796337624512,156.389756537247,-130.368494429545,8.57452572741590,91.9761471436124,43.8468385141732,51.7847422915048,-74.3770214302121,-16.0670167018265,-6.10543808810040,-10.4021109185354,70.2378163853568,-5.91903738606644,12.3374607067729,-33.3832458520475,-3.00114630242898,-22.3987133694685,-21.6818092982253,-5.34102888735044,0.944795552035757,32.4063841132345,17.3876861045595,-0.650490418382049,-14.3770539745560,-21.5383886401230,9.85095060492184,-0.536803962625527,-1.25722052069924,-8.37880567872361,-3.24148892508315,-2.69409869811128,3.58457278659295,5.40840893765253,-7.30356859963534,-1.02017883620695,-2.81988719173439,0.393099218017467,1.26009397214432,5.24572207608159,1.54519061618576,1.51959240613749,0.119119629855408,-2.67403386617620,-2.435554470285100E-002,0.786548701226802,0.368026194754899,-2.23865960029694,-0.665906183800124,0.770512694658471,1.22808935479909,3.08733406421573,2.14061196220085,0.814136679245305,-0.730090093458923,-0.858653136831646,-1.29429569907261,-5.634650020207600E-002,-0.347050666275734,0.237575915843590,9.875963543656445E-002,-0.512599606641126,-1.01651792104320,-0.255188291426562,-2.260840604763881E-002,0.163388378278340,0.193803832210747,0.610806565864304,-0.142899307512137,-0.334078353464488,-0.426089704780350,-0.201270516605613,0.205494469514692,0.339642825239045,2.897668536028420E-002,0.220800970591194,-0.403685003202948,0.159758950209806,0.193687921377140,-0.103966666679193,-4.478270643078695E-002,4.194108113926933E-002,-7.537383325887280E-002,3.053548224890205E-002,0.116255094315722,-9.515339445043074E-002,-2.223170563920730E-002,-1.389460499270437E-002,0.136640397470591,0.108391292759810,0.214357096594726,-1.918528787964756E-002,5.919373789014003E-002,-7.798272273952361E-002,-8.805508280517155E-002,5.797993300159525E-002,-5.281711284228557E-003,8.304343846413348E-00],[-24200.4336486807,-2431.69247215952,-126.507343328525,-2948.70673024089,-747.911877355281,1409.20366993383,1039.44412421124,1020.30481840545,632.251438412100,646.152495152082,350.302903237575,853.483470113690,-109.302251976209,-1135.25160914532,-226.629741094060,-19.1365825204464,90.8232454387874,-215.407870930269,-302.038190162909,-24.7161275511555,-79.8879613409495,116.157583012447,76.2189817328363,-280.974440044316,157.396753314849,-132.674710086670,4.22697334218659,94.0234937575814,40.9655938670910,49.4423029605929,-77.5564356535833,-15.5889675781334,-10.9529031913208,-16.1421118681078,73.0703906756995,-6.28632836432400,13.5493372917201,-31.6012758293463,-5.71592358713081,-20.7771895222978,-23.9632614254840,-7.67157207387740,-1.60183401159107,32.9193326536448,17.7209822946622,-0.851013006622532,-12.8708573049537,-21.4830390124355,9.45813895298684,-0.404716289562342,-1.04288361163839,-8.09904256962180,-3.54943928683538,-3.03671532075804,3.94875013396012,5.45670238776153,-7.33942508646306,-0.908573130203553,-2.39789790539041,0.198588298994104,1.33418174986502,5.24171359678863,1.44210317706255,1.45372402699559,0.170512369554660,-2.56555720314790,-0.116188885089727,1.07962481699578,0.275586944315166,-2.33929670875527,-0.636389436512832,0.782076972763664,1.25311826211655,3.10370121799617,2.32018908411809,0.913349718082700,-0.756477272414150,-0.941323655980133,-1.34621434386477,-0.125739651445857,-0.360797557995887,0.228020801317406,0.146126046236195,-0.478141675456019,-0.957281903962099,-0.249813120703202,3.393388509606342E-002,0.136033766497218,0.178690815919466,0.664068623030915,-0.148431203109030,-0.329528125166638,-0.466822153490518,-0.196689152218905,0.160374098522207,0.332920838000555,5.696406363614823E-002,0.229226666864698,-0.400435335704031,0.155619292027952,0.187444236174209,-9.998612147365622E-002,-3.784110711012192E-002,5.458059457581494E-002,-7.271374132331625E-002,2.473151931601312E-002,0.145262133976510,-9.569250006962880E-002,-1.169013752822100E-002,-1.439681561112199E-002,0.144902382289597,0.103968759742355,0.208087538096001,-1.660559191993945E-002,5.239353786191963E-002,-8.458947632117361E-002,-8.860256165008053E-002,5.563310542356405E-002,-9.031210710673598E-003,8.409956585422126E-00],[-24343.2592163216,-2559.79272992178,-69.9108430232821,-2959.21037718109,-506.934241951070,1379.80719544684,1116.67710284976,1122.77940246290,613.347789733373,589.052927674701,367.135704862497,877.181823495406,-144.240445902343,-1192.61241279113,-323.651600379945,-23.5839325381302,138.327914298843,-215.663160842509,-315.181060406839,-35.4591968978571,-90.5118551907862,125.997403933589,74.2389244516909,-278.431329147932,156.889237586192,-131.705749428149,-1.09898419827431,96.5550350306032,37.0276949044302,46.8767541371503,-80.1970768157839,-14.5517459636986,-13.9769445340097,-21.8493343615009,76.2926994902856,-7.20996797500919,15.0911079884355,-29.9188771032900,-8.17196126158427,-18.9612088197814,-26.4143262002624,-10.1289947874810,-4.34407529444802,33.3294641264376,18.0014857762032,-1.50506579900516,-11.4933415186844,-21.5931783245777,8.81817717313294,-0.388869233820226,-0.743328110214117,-7.72233184011360,-3.95780597863352,-3.32331296683307,4.18317860137353,5.54084212620681,-7.38052778721449,-0.759793743518171,-2.13541644203481,-5.490864314578285E-004,1.34738806820865,5.27940037613081,1.41637518658842,1.34175984458968,0.200936281008502,-2.45957644640896,-0.171510839836119,1.35854483123083,0.204088262817972,-2.45657815304890,-0.581683853260153,0.811281534372357,1.27197600210519,3.10279485194429,2.44584553284362,0.981693274420545,-0.815158635935860,-1.01923979614576,-1.40843010793610,-0.181417962498712,-0.382085339094488,0.206622913948555,0.200034901477184,-0.446330249734560,-0.895583211494319,-0.240760688467910,8.525116819857943E-002,0.106317883449639,0.161448930046573,0.714132960998819,-0.162069318800029,-0.334422759925532,-0.524077543784137,-0.198663182120340,0.113457716033752,0.329167314141476,8.552048327805900E-002,0.242457548458114,-0.396928560701073,0.151714643778726,0.174667998730719,-9.207764569934994E-002,-3.140123194949872E-002,6.996393435032496E-002,-7.115311945480667E-002,1.693743481263197E-002,0.174373043572345,-9.839775433661345E-002,-7.239055733653215E-005,-1.498579820880804E-002,0.151896192883681,9.664256708635671E-002,0.199197046864310,-1.292659920828524E-002,4.571082816498800E-002,-8.897568063020173E-002,-8.884613576788346E-002,5.489304945340771E-002,-1.298756722993360E-002,8.673851482013789E-00],[-24415.8842080302,-2635.14883949453,-13.2194818249360,-3025.44964686539,-266.418808312318,1350.46640370816,1189.63712819390,1231.56377542564,613.363048244573,534.038762505406,385.387294582479,885.314254652942,-198.191061079708,-1253.82352251353,-408.122720603673,-27.7383956307567,190.885259473500,-214.354663676687,-332.065799907975,-49.0825056513799,-104.044030369673,136.518698478895,77.6239424102157,-274.950264216128,156.573288458079,-128.872625107757,-5.87872395176761,100.584720593824,32.7738492650379,44.3813415177516,-82.8749925705848,-12.4829541520876,-16.0277487120547,-27.0420875780033,79.4237363191604,-8.80093118236455,17.0997366998917,-28.5349921375371,-10.1231930931353,-16.9288022944993,-28.7291070739492,-12.7368884315118,-6.73893835273786,33.7732129845530,18.5831305301143,-2.58315752263476,-10.2783245980541,-21.7774094276241,7.98749463283847,-0.436422581041195,-0.413819600479137,-7.24102224203366,-4.40936055045782,-3.48124952906365,4.43173956307204,5.70133821660175,-7.45108521342660,-0.593447603004105,-2.07382546956529,-0.261427664180004,1.30813435335919,5.34945383074208,1.46911290374471,1.19545275417177,0.212820927960832,-2.38827419057442,-0.202603916366658,1.64860341395641,0.167551321746507,-2.59336444999010,-0.509072965005359,0.849305817382076,1.29314457137693,3.07784433855324,2.53711933884065,1.02531389061351,-0.888257331152834,-1.08712656612436,-1.46997744974768,-0.225171835983625,-0.419081661495702,0.172496191800101,0.258719793705765,-0.421631044800973,-0.845900628569515,-0.224232443480178,0.132776420030672,7.205959796277678E-002,0.144519620310564,0.765733282406718,-0.181664514480874,-0.350052994229417,-0.590534186282734,-0.206461764096905,7.390025549652415E-002,0.328887839467934,0.117419306219174,0.258165280791582,-0.392527610614525,0.147905972287767,0.157886920541343,-8.225397289404117E-002,-2.537900373545472E-002,8.558846308818654E-002,-7.121377114744892E-002,9.320128466915987E-003,0.203084637550634,-0.101299895648689,9.197655011546941E-003,-1.471895379773902E-002,0.156359284883253,8.834404536215673E-002,0.189046702419444,-7.310098577325893E-003,4.046809553217941E-002,-9.256295932701701E-002,-8.891885103590731E-002,5.510637908829764E-002,-1.685878208229512E-002,9.050500174840827E-00],[-24367.6869234312,-2619.48767690407,72.3499889758947,-3150.33397656193,-87.3634571421456,1349.60407329264,1231.81171023390,1319.52120213162,637.355860969146,483.867747694388,401.988715914344,893.148846473108,-282.923370035351,-1311.35310717884,-487.180171018228,-27.5557800876066,248.894363585025,-208.036762530353,-349.880342862679,-64.2052460517737,-118.578799720355,148.789356609668,85.6925199297886,-268.706486886691,157.632614165806,-124.348015231443,-8.90959828639417,106.550990305418,29.5208884942066,42.7090179334967,-85.7613250726671,-8.75831666759600,-17.9638533838979,-31.6657854644540,81.7912264735928,-10.9615410269613,19.5346653318859,-27.2336879929769,-11.4447891752981,-14.3346469498559,-30.5004448179150,-15.4425171472085,-8.40860709120046,34.3551324274611,19.7523285941370,-3.80387244434576,-9.05683374881264,-21.8909792598204,6.96712922359803,-0.485772509584763,-9.144032487578221E-002,-6.61645106046591,-4.79519097962131,-3.48089418828976,4.82544037515578,6.00565182198467,-7.49890383072788,-0.349909399555470,-2.15381244807817,-0.612890902871752,1.24818081406084,5.40038614761265,1.58966084925809,1.02199907860433,0.220917522547532,-2.38107532214506,-0.217439233940972,1.97609320772949,0.177693243561320,-2.70169856679598,-0.424167153002635,0.898479661440296,1.31640681364643,3.03967874005079,2.62042311123155,1.07611290340805,-0.944690235345878,-1.14010450022568,-1.51803436424993,-0.270374349164017,-0.470788447408686,0.123248407320623,0.315738896943759,-0.404433432597513,-0.810108253909556,-0.199833489226492,0.181359681417432,2.786898268578340E-002,0.130768618634166,0.820393848349468,-0.197278905376010,-0.368125397087163,-0.653985232318135,-0.216134629973123,4.685304925683084E-002,0.328480437538337,0.156651113489717,0.274095765403922,-0.384173384554342,0.142833013551138,0.139017445559054,-7.339800570112591E-002,-1.936012359166288E-002,9.654623761921291E-002,-7.252880362387343E-002,3.647356738048220E-003,0.230611060508086,-0.100395180015181,1.434868061719900E-002,-1.162590688030334E-002,0.157872033669528,8.208755928469204E-002,0.178887906713202,2.508661469934918E-003,3.748738228578971E-002,-9.572740673314493E-002,-8.870981460388883E-002,5.461581034835612E-002,-2.100590583723233E-002,9.387647867021727E-00],[-24213.4560000131,-2508.12065561001,185.218624138022,-3346.14103831683,13.7948710071992,1355.83339488410,1242.58500369741,1374.98102208854,687.095799918381,440.898197524683,412.654891963981,904.974002441327,-405.713785803127,-1364.83132384460,-566.870909389996,-23.3365648995136,311.017826935844,-197.763097516944,-366.117001259770,-82.8101312725181,-130.567799095927,160.173330342347,98.2347281527698,-259.930801594643,159.956705476728,-117.934229301273,-9.22869504446285,114.063617060930,27.3471681087604,43.1230431729380,-88.9446495963440,-3.25538028055165,-19.7611496984292,-35.7671788203216,83.5203752338863,-13.5441563890037,22.2957849604447,-25.6701362190684,-12.0747834419462,-10.8739799451602,-31.6173273035472,-18.1419666679841,-9.09698976781076,35.1088709958260,21.5846366164532,-4.90054949783045,-7.83640593394317,-21.9948487506135,5.71105184550703,-0.523500086786237,0.262781098560389,-5.86922831064798,-5.02651338401140,-3.33760770961243,5.37531836564253,6.52861948904391,-7.48342538499547,4.241895555668151E-002,-2.26220368072629,-1.02745017485488,1.25575976771305,5.43140911138248,1.78665101838806,0.827178128895871,0.223849514609212,-2.44224875800214,-0.204494699343978,2.36245125084242,0.217516357089630,-2.73247695725057,-0.335308717944468,0.958910020048725,1.34076282339594,3.02806393808912,2.70925597297516,1.17460447518769,-0.972445700167304,-1.17235315878059,-1.55919679141970,-0.330135682609725,-0.530516288679309,5.359124458641291E-002,0.363970491014699,-0.393559611222448,-0.783518165393763,-0.172414383822637,0.233990704478187,-3.315757478021807E-002,0.124720080244888,0.874550307704651,-0.201352483791824,-0.379541879584695,-0.702014143904924,-0.223563690763331,3.721629415515310E-002,0.327676310953343,0.201580182347438,0.290728484813556,-0.373144685660977,0.137159839085515,0.117703517799471,-6.744469630414249E-002,-1.377389648891683E-002,9.949397295457592E-002,-7.567093705012834E-002,8.526291231319053E-004,0.254694002488985,-9.424820115597547E-002,1.551232012019174E-002,-4.522651751630801E-003,0.157344635145311,8.168435213685495E-002,0.170784830228811,1.882401041475579E-002,3.647313650746118E-002,-9.815894894376691E-002,-8.946942153072993E-002,5.286913493200684E-002,-2.584451463900528E-002,9.621717908102798E-00],[-24013.2166831334,-2343.72495166610,328.592816658986,-3591.44510558120,48.1557066797496,1359.72882766246,1228.20140620458,1407.54955259830,771.701865778430,401.167014027349,407.227585634428,914.791320266153,-562.201856849288,-1417.04214073509,-642.597003686291,-16.0770708018073,373.942414242375,-186.271682485192,-381.669399163216,-107.986805300907,-135.834733181897,167.654995633732,115.641738345525,-249.011096565954,163.542951004739,-108.844229801089,-6.58059146497466,122.043541703775,25.9255724396040,46.3268730592569,-91.2750053469668,3.79027301177163,-20.3300783639285,-39.2165888621750,85.1148883792612,-16.4225750632503,25.4973363854879,-23.5924371085595,-12.1949465709873,-6.41235751961989,-31.9660547596328,-20.5959461790417,-8.52338881145226,36.1123791742883,23.9075154444869,-5.62385512711077,-6.73856501273426,-22.1653715098306,4.21189806521162,-0.507504905815903,0.743285213464706,-5.02187488948735,-4.99561956655880,-3.11013980484331,6.06749923930768,7.32414012718248,-7.33696130848510,0.638762718027455,-2.25936611739604,-1.44689763941926,1.43302081683695,5.45169383668231,2.07457871972341,0.603620868595830,0.232887065482364,-2.56984800275683,-0.141958029513754,2.81160820613943,0.263933158238635,-2.64589375731635,-0.231581363461347,1.04934197271220,1.36722208316012,3.08024639005504,2.78352368040627,1.34688999668672,-0.984334831745985,-1.17437021411230,-1.60413012523676,-0.405719982450476,-0.590230090131301,-3.850151100370674E-002,0.396922754933886,-0.383161775038953,-0.761049945138124,-0.150262275914283,0.295751783016337,-0.111936465685504,0.129483677329753,0.924738973923719,-0.189380168976619,-0.379952447007669,-0.720201668894734,-0.229883896587569,5.014544921099246E-002,0.325888782500922,0.246166086951649,0.308484841599385,-0.362155252775074,0.132571267385897,9.320479238721399E-002,-6.710990282106731E-002,-7.600870141825452E-003,9.333499324204407E-002,-8.100959131223673E-002,1.095994596428196E-003,0.272000146799125,-8.173204134666594E-002,1.341123793322515E-002,6.458336486619018E-003,0.155012330524850,8.958914136892461E-002,0.164489303374472,4.318209140032296E-002,3.553551843608180E-002,-9.885342403330590E-002,-9.266399135191838E-002,4.976309410365173E-002,-3.146630387539678E-002,9.739528433215840E-00],[-23902.7921183625,-2123.26187044268,482.049290440995,-3800.56260132514,33.4359541848383,1359.82258224313,1202.01042098921,1437.54951098188,891.632638208716,364.836843672346,376.768836310898,912.658015401254,-737.148445644172,-1467.83241861805,-707.415341099968,-5.26117923026534,434.344774432820,-173.433872221039,-397.458492113536,-142.676531025674,-130.571554139041,171.390039432041,139.202673425537,-235.344314066621,168.042324629140,-95.4527774510830,-1.62786003879083,129.660403921945,25.7728678583117,52.4662264420441,-90.8667980356005,12.3222121392836,-18.1578874470088,-41.6729657518073,87.2169618840126,-19.5722812963298,29.1943645863126,-20.5676290425488,-12.0208159411928,-1.03030843274498,-31.3713369564908,-22.3690327685925,-6.53093767464418,37.5634471800030,26.5963818699548,-5.77420877774504,-5.79793976321275,-22.4094749219442,2.48409972390529,-0.381057684791998,1.39748067693219,-4.04482478188063,-4.54002147763185,-2.87285916570837,6.91814963257460,8.47169790080809,-6.93681193845665,1.48707577771477,-2.00532666615293,-1.83460593631615,1.85147909068305,5.46267758969386,2.49303940208153,0.327330638285704,0.249117185566282,-2.75064643618729,-2.225703726052898E-002,3.30687722137253,0.312638849447116,-2.40707119263032,-8.901625905930109E-002,1.20961613846331,1.40991240988894,3.21970503600658,2.80642468235149,1.60348111050406,-1.01093588237886,-1.13594839100657,-1.66115088466963,-0.488384728335347,-0.639833368357157,-0.154072841728425,0.408734552515532,-0.364656093846546,-0.733783957426303,-0.145504539610948,0.372519909827168,-0.201896819589887,0.146779918098692,0.973086481342345,-0.157437358883120,-0.372076961054272,-0.699156376687826,-0.244166930981387,8.896010088589681E-002,0.320870950712801,0.286728784123499,0.327226957188685,-0.351125820756166,0.129944648064293,6.479439553934950E-002,-7.516944753759343E-002,1.290571732876227E-004,7.736542473079072E-002,-8.699663881547580E-002,3.615627855608127E-003,0.279283509774821,-6.164337285773763E-002,9.451486792173747E-003,1.982719910172895E-002,0.149877926108947,0.106950778606129,0.155567201301204,7.702439467323456E-002,3.149299914328559E-002,-9.678976603829262E-002,-9.956594154137376E-002,4.524151002861795E-002,-3.824317326045992E-002,9.783824202321367E-00],[-23985.9899702654,-1915.97498078830,593.260809543346,-3917.51888851498,-0.328226838914747,1304.32234413266,1189.77500562284,1464.47591443885,1029.98927371567,337.321216994290,327.799390057451,888.396561892140,-910.905801563929,-1506.12529936588,-755.677441700165,7.45304579329348,489.258196843102,-158.878527920782,-411.143624561474,-186.602483787583,-111.881976348730,173.024175572773,168.849111091069,-220.168553888109,171.850983773755,-77.5872291401698,4.98755916744920,136.519925355113,26.4615109357089,61.9343776655653,-86.7178500432695,22.6362761044500,-12.3259504632746,-42.4185931544676,90.3157786629414,-22.8838828541135,33.1496592006306,-16.4942505932159,-11.5053201666672,4.85348495988916,-29.8444327922154,-23.0022354386507,-3.23373864940446,39.5681922249165,29.4506505326294,-5.31858833209482,-5.06559234820915,-22.6283489865832,0.573684284012825,-0.192743442229131,2.18576074194633,-2.97874248252994,-3.64568718294840,-2.64922430336832,7.86361590565571,9.98727085339998,-6.20932242339000,2.54488088702055,-1.43225414204274,-2.16749145751530,2.51845706751592,5.49222398881160,3.06398068200005,-6.446997373621351E-003,0.234778060731365,-2.95649013748498,0.144504968097663,3.80824299284146,0.345118696298319,-2.02896973322244,0.105166941473756,1.46143049778372,1.48558872485030,3.45432589769569,2.74884304705006,1.94408315621272,-1.08209021279880,-1.03873166785112,-1.73472858262628,-0.557232238821739,-0.673284667634452,-0.290943105282047,0.393594988928164,-0.338865898011061,-0.699254468677820,-0.165001408722103,0.462662401898995,-0.294862889745298,0.182095937944117,1.01906345819098,-0.105511177694290,-0.366253114262712,-0.636865377273919,-0.275553103896750,0.154383773340647,0.310963477972467,0.320138210963975,0.344588078475191,-0.339408895921061,0.130851104328027,3.190589968996724E-002,-9.052479038405789E-002,7.578154859089676E-003,5.287682041403100E-002,-9.321638995692712E-002,7.041389352816406E-003,0.274061811902521,-3.611263889006316E-002,5.147218344961847E-003,3.414272743025916E-002,0.141259360086351,0.133897132304089,0.139738273762082,0.120747256012477,2.196439859679445E-002,-9.155389895859542E-002,-0.110321311640500,4.031888585120987E-002,-4.612239380728307E-002,9.849316595723488E-00],[-24261.1903027065,-1744.08026984334,600.516108305018,-3924.88573918589,-19.4889775817399,1167.45968564200,1213.77616133361,1473.09631304983,1149.89719495638,329.236142316891,286.703542031740,842.695182060293,-1059.23563576046,-1515.40063674541,-782.300425419021,18.4406838603336,533.443416307524,-141.047667130522,-417.603427023182,-233.630793946753,-82.0607665135454,176.404958400615,201.362443910451,-205.173329409811,173.072913733207,-57.7846461603899,11.8495870226828,142.581138712188,27.5007277200462,73.8318547378196,-79.0923552332821,33.9402092034497,-3.49101404618769,-41.1884999920456,94.0110632543174,-25.9030907598299,36.4682721744836,-12.0520084061216,-10.4615916978697,10.2361970555615,-27.7561573467781,-22.3079169827115,0.604843076363003,41.9401951278364,32.1061597350276,-4.46178540845625,-4.57290638536193,-22.7104276403219,-1.28158526526209,-7.998705749420816E-002,2.87513385125656,-1.98165781613463,-2.57252616396119,-2.45528467592712,8.70727439199911,11.6417538198792,-5.19540075588696,3.62303496459169,-0.661070438104142,-2.43390054921961,3.30289466477053,5.54680763383955,3.73833873641123,-0.344368739732976,0.156727801769442,-3.15807576700733,0.307964447154169,4.20972676515743,0.353538333647229,-1.59667819542719,0.314701187624927,1.78586732239985,1.58194087771774,3.74583956190398,2.61240251683226,2.31891998183939,-1.19627392091219,-0.885730955611696,-1.81223006915696,-0.595982700471268,-0.686435883140301,-0.430261201334849,0.353454708840935,-0.319626007992576,-0.665539023361495,-0.205263504032005,0.544445033560067,-0.378736728648910,0.236103750866885,1.05557184332136,-3.975473096023812E-002,-0.370691900422154,-0.549342446589724,-0.323581013941098,0.236925004968911,0.298607392562226,0.344702720848456,0.358183993295945,-0.326578274250869,0.134390576202311,-1.159413313932451E-003,-0.107373408385638,1.074697594870418E-002,2.358521648701269E-002,-9.905368062918968E-002,9.169933714720264E-003,0.257792783582642,-1.016962693175737E-002,2.153666476035293E-003,4.864187351984312E-002,0.129695925827884,0.166322708746648,0.117439046202550,0.169131272928480,9.100909775247782E-003,-8.372426089853352E-002,-0.122670990201052,3.621844353282716E-002,-5.414496983581015E-002,9.983455084504017E-00],[-24489.7325125248,-1563.20134888628,540.033087944603,-3845.30086137085,31.4079876685931,1017.78892381442,1272.93332647906,1457.34444468471,1224.84038224838,346.954334547540,289.079792491172,788.952534049072,-1154.87057698776,-1492.39773144536,-782.911609714042,22.5324939259099,563.896990674143,-120.083240392346,-414.167421767670,-273.263960821972,-52.0538363174787,184.538558592751,228.275872308365,-191.455258589377,171.126246266191,-40.4746294567626,16.8188684385487,148.099392058167,28.0216009513308,84.2750235443118,-69.1568735185547,42.9614565851517,6.16031632116134,-38.7572566741906,97.1145281475598,-28.0908438062700,38.2571756086622,-8.78896003469470,-8.86592010477580,13.9923664518599,-26.0393806607690,-20.6328818290357,3.32270978158608,44.2257500479934,33.9106544520970,-3.71351509214339,-4.36423575060723,-22.6947704042408,-2.75134073243952,-0.214004780427815,3.19650552906708,-1.23129653381003,-1.84769679907207,-2.33240966613294,9.24905793845647,12.8851634235825,-4.07350405166746,4.41409273594419,9.452652090380195E-003,-2.65298651036994,3.92824173914787,5.60728622059575,4.37526368846440,-0.600489444459994,2.628078585744424E-002,-3.33888595527879,0.411426951136001,4.39883027296277,0.348644559422786,-1.24282552615442,0.461161443337215,2.13826415469857,1.63430871363072,4.00592550654647,2.42849333596498,2.61574988385601,-1.31869284493467,-0.719357039132291,-1.86744575185487,-0.609798570553280,-0.683582136698285,-0.542145999184715,0.306529791515127,-0.323301995918094,-0.648210892348984,-0.243657993729778,0.591915274655546,-0.443401562110182,0.304054019270124,1.07087535440264,2.653111947521537E-002,-0.387454854115137,-0.473948923772869,-0.374479415280555,0.308833010138715,0.291680000649381,0.356641437450258,0.367861072793963,-0.313676155712778,0.137535754684942,-2.737425474187084E-002,-0.117597099605735,7.586284930357738E-003,-2.376489035660317E-003,-0.103167833573891,7.971744902971716E-003,0.239533319982920,1.191532230760588E-002,1.905624235477142E-003,6.413564560992566E-002,0.117621995683503,0.193893609069367,9.447746607843079E-002,0.209568739461963,-7.322494393652648E-004,-7.636167471428017E-002,-0.132252027576562,3.367036706963095E-002,-6.034579797914198E-002,0.10161716300920],[-24684.8041975971,-1456.70410578757,417.498655986039,-3775.34749890294,84.2879769424844,883.710056995658,1341.06686847955,1393.20058020113,1249.37034744165,362.514235267234,332.526746814362,737.959318513420,-1202.25256458376,-1442.38981898790,-763.704486273806,22.2834056381841,577.484313896150,-101.775455458145,-403.521013813890,-304.139249995231,-31.6059082901252,194.266335870602,241.388300842031,-179.637520218886,168.495107710027,-28.7283477730699,18.8190597203349,152.393042247332,25.5236342844771,89.8173455992584,-60.5538721419267,47.0764560729948,13.8220951935620,-36.0530652747530,98.4663225419312,-28.9448202870170,38.6799842795336,-7.76008172134546,-6.93522712158651,15.3395486714604,-25.2642663118575,-19.0607469191467,3.92905583689052,45.7920082995501,34.5078383483042,-3.44071370614292,-4.41690914523874,-22.5683103822699,-3.65783494761149,-0.546035797241311,3.09163805576301,-0.813296778127303,-1.77360508443530,-2.29261555733097,9.34988282515848,13.3585725100847,-3.12963836746004,4.75046846539274,0.370405486247852,-2.86482424444019,4.21271919586849,5.63361675696039,4.83517224598957,-0.745266240064611,-0.116243278726979,-3.48830625703279,0.441277141477935,4.37281642546798,0.330145436096448,-1.04974032121318,0.503301059416458,2.44311974926179,1.61454498609733,4.15818637924509,2.24282136411728,2.76484930542114,-1.41482763473279,-0.577677335286576,-1.87938780863946,-0.611991992593519,-0.681803320635340,-0.610583771123416,0.267543470869989,-0.353019345351988,-0.654374603089837,-0.259922807268962,0.602214308015513,-0.483854776034708,0.375769147739803,1.06526983931034,8.258352159939998E-002,-0.411453309634728,-0.430302029196599,-0.416441142916941,0.350584131240448,0.291303472585680,0.353706553836935,0.372555926669078,-0.301625182894203,0.138266965687417,-4.400726174075638E-002,-0.117581390632629,-2.719935513513395E-004,-1.891483173426522E-002,-0.105246024500735,6.146925537802545E-003,0.226365621824500,2.878836615039237E-002,4.872529200557731E-003,8.049908508356360E-002,0.108680961672208,0.209571410331452,7.534414346535472E-002,0.233199177491139,-4.885982189622350E-003,-7.310922835036203E-002,-0.136169155895849,3.195015910018283E-002,-6.311924522759706E-002,0.10280791773781],[-24711.6553493698,-1416.69037892852,287.776594363381,-3724.19480966431,109.907181142248,806.498552398931,1396.62193973578,1295.69770104698,1206.79095626742,363.091221045228,406.994479195977,692.492460324287,-1193.92128632272,-1375.84451639484,-725.127817162809,19.2280758088107,569.861676310802,-90.2722938961074,-389.584108455955,-318.262223371731,-28.9799614968895,208.799600802048,236.752022080085,-169.530837775703,166.117154914501,-24.8905524446789,16.0189453789280,154.009133617191,19.9821415583811,87.8268981651072,-53.3365047331094,44.1587384359309,18.5337876327244,-33.6307437030770,97.2448801625921,-27.7799667969516,37.6014239647830,-9.22055781962851,-5.07640605242679,13.8461850418875,-25.8350673088434,-17.8415269660231,1.80294249577599,46.4754481946669,33.6723854878192,-3.91897441073020,-4.60497281572541,-22.3992464376672,-3.81951608852361,-0.896676005494770,2.51336500702511,-0.720046955631040,-2.50692158849957,-2.29767936225261,8.99278441573913,12.8915427845812,-2.49383117268270,4.48052376185577,0.244258744902318,-3.13416973354583,4.02987605306658,5.61111979248103,5.05752545093953,-0.737957265491149,-0.206584357282744,-3.56323953450484,0.405327662516893,4.13310300507515,0.329119179477715,-1.05239125568890,0.440946785380621,2.62713217236312,1.48681659971884,4.13022624408997,2.05776669553170,2.70319334360005,-1.45997031267181,-0.499287355830499,-1.83585102922259,-0.606148465423936,-0.685197728836034,-0.616549723550179,0.244871224245407,-0.395318408961985,-0.677723681909362,-0.239058431163727,0.568786056197890,-0.489162100102558,0.437072254549614,1.04048207213603,0.112781780291975,-0.441350417789222,-0.437188051239398,-0.442983739991917,0.345911512365694,0.298734303770264,0.335784538917279,0.372121753412810,-0.287313233160444,0.131786549751216,-4.746433824295184E-002,-0.106074181641896,-1.047748118983104E-002,-2.493260883225285E-002,-0.102915548716808,4.680068862804686E-003,0.225091227952439,3.957608648902816E-002,1.249405994458056E-002,9.563757924133588E-002,0.103044326652100,0.208286904587595,6.312061547666142E-002,0.234373970878613,-1.345059894427746E-003,-7.700673607975266E-002,-0.132874591806850,3.034178889821638E-002,-6.253568652352526E-002,0.10319666042761],[-24314.8456011275,-1334.44246392858,198.794540063649,-3608.90049610720,178.744160993693,864.584235587633,1428.71602990852,1195.44744351136,1088.97532042755,367.863417919412,499.313180269839,657.775034241800,-1106.14010085900,-1300.97641758459,-657.019837592002,8.78193415179853,539.603932884675,-82.7242526466925,-377.110813347097,-305.869138343475,-46.3974044693406,233.088110200115,215.214726229503,-161.322807027916,162.643669519735,-29.3271337044058,6.70923784577826,152.837254595921,14.0588490524393,77.7345331617634,-44.0043033254328,33.7250474807575,21.0874105713374,-31.4359001742444,93.3745429787055,-24.5695367113926,34.7290172576255,-12.7533968461002,-3.78458584089374,9.67472210835182,-27.7059836156458,-16.3890044488801,-3.09498200560496,46.6277326626712,31.2697148174415,-5.18020474385808,-4.88797320640159,-22.3250853647824,-3.13968454684043,-1.16777137524794,1.50055599820728,-0.850278275008419,-4.00857852388194,-2.35632277365184,8.30882041887332,11.5176475425408,-2.15107784337328,3.57766918037063,-0.466811099346144,-3.46705104591054,3.33475362573034,5.55174634750789,5.05168543078560,-0.561654831901168,-0.196195873724512,-3.53475035515248,0.320682000324661,3.67190110594715,0.402915725731081,-1.23944005932088,0.307919215751390,2.68916843393951,1.22030752532470,3.89553217319667,1.84749004257983,2.40275463110590,-1.44944192653359,-0.498168018422004,-1.73828799756837,-0.585224203515216,-0.683392842847388,-0.552830535743078,0.244645405541519,-0.432186416391365,-0.705360950554233,-0.181127880927091,0.488928542381010,-0.450409435935349,0.477618036454273,0.998028296290669,0.104275931832833,-0.479518629115400,-0.506527410662046,-0.453742968099377,0.288902438806926,0.316977143811350,0.303271793367863,0.367473440208011,-0.269211741256994,0.114083468906827,-3.555261785167003E-002,-8.558842817321440E-002,-2.122617788965076E-002,-2.130906180510470E-002,-9.279989717601336E-002,1.887256671823727E-003,0.239849902815337,4.620074980614518E-002,2.538090064947618E-002,0.107041745043258,9.866435425905806E-002,0.187921377825891,6.025383219168549E-002,0.212756988433035,1.242414288652613E-002,-8.748941754740291E-002,-0.122284304506491,2.915031330138424E-002,-5.949192834027518E-002,0.10330131931971],[-23726.4469218147,-1247.12809863298,66.6625133516298,-3425.72080878763,252.642725516978,993.377074148550,1445.47812613928,1069.25592839493,936.903757394706,366.018270861189,579.728408835353,632.651598996156,-978.419284856801,-1214.38493541520,-573.326751584150,-6.24409147493460,493.683878379911,-77.8287092842736,-366.854584681515,-278.280785469492,-71.7482892299744,258.760451832967,184.980446721883,-155.869939064909,158.572302817754,-37.4138678490484,-5.78565497212576,149.716011207230,8.99380741330252,64.1742596735979,-33.5738470859657,19.6371260881976,22.1860354010835,-29.0425965631949,88.1478892332160,-20.4517685406821,31.2376934700398,-16.9963814349553,-2.99105204854106,4.33383606577148,-29.7690622945760,-14.8272857344446,-8.94864528018748,46.2754199428001,28.1831578483981,-6.63388388218209,-5.14689393457406,-22.3065895731992,-2.03179215743358,-1.28452825466729,0.404382876724738,-1.04740940218518,-5.72294262460325,-2.41458519678500,7.52467921156712,9.77369599440513,-2.02826314672228,2.45251994512725,-1.48951047920432,-3.75013451722662,2.36410361295578,5.43308104837682,4.92330144716280,-0.317128417531536,-0.116418304047055,-3.44402103333421,0.240718389854768,3.12228850979776,0.538348990766298,-1.47219756841392,0.177751525405130,2.67496865408434,0.906878520880960,3.53744310792463,1.62866504602414,1.97592561007119,-1.41161611047410,-0.529511089724231,-1.60872780023008,-0.547021530938124,-0.678518066310702,-0.458765821329703,0.252958926685286,-0.456761213870378,-0.727119879669806,-0.106398377038488,0.397443617482088,-0.380755136003336,0.502440523763394,0.950857379353696,6.893437005562118E-002,-0.514866517423829,-0.602588153894439,-0.456313377234467,0.211557191186483,0.339027758612408,0.266378092100036,0.358523311975736,-0.249177532040966,9.048386528217199E-002,-1.747740383365821E-002,-6.409029011873557E-002,-3.047958578285093E-002,-1.312798380353075E-002,-7.830499085435395E-002,1.278258585627729E-003,0.261678300169338,5.344340016794465E-002,4.021976193435768E-002,0.114294970629468,9.469029878643936E-002,0.157985321364700,6.318350503516794E-002,0.181262184896173,3.183951873162112E-002,-9.816464991720954E-002,-0.108350929849647,2.835367279956761E-002,-5.539278216815715E-002,0.10280064769274],[-23346.4288738200,-1180.08917666011,-164.178477777948,-3226.64024537602,267.898658299994,1076.15035518435,1480.28135966031,890.395804278440,811.215483438907,336.454942373983,631.642224133504,618.169450296924,-875.164964046912,-1114.20912994238,-501.481399141909,-19.8049909405273,445.591556953797,-76.6612927533792,-351.758019619257,-253.902951722043,-88.6295626597276,273.953011471913,156.128978366780,-154.525170433024,155.633998017337,-43.1132897040795,-15.9094060670438,146.800288072923,5.14306008015733,53.5225704256063,-25.7789901360290,6.68565673428364,22.5121003827579,-26.3320040462340,83.6857057867379,-16.8394121230488,28.8567765706335,-20.5801073576452,-2.11763075417417,-0.190504071384244,-30.7837261157352,-13.7757988486581,-13.6797761477879,45.4513043277268,25.7441249618860,-7.48201586730772,-5.16892474536974,-22.3313877842819,-1.09651638636710,-1.22076204185628,-0.368914697167518,-1.19901517181557,-7.01625149456838,-2.37405388143430,6.84269889124451,8.29971295179559,-1.96715945415059,1.64803362882311,-2.33852640267792,-3.85681282222010,1.44812125166123,5.21979893364501,4.81499179176364,-0.135601778633306,-3.884488930193872E-002,-3.36734437413201,0.214358133895737,2.67756237907551,0.672869408390589,-1.58500766213878,0.104391882832009,2.64684807392393,0.688222570131430,3.20344215275666,1.44556334497035,1.58751863779473,-1.39758902687252,-0.538489349734713,-1.47838202353780,-0.498055863204722,-0.683721657241854,-0.389951986436350,0.251244864522941,-0.476310454803014,-0.739223885903349,-3.872057222751262E-002,0.340505156601386,-0.307535140165135,0.524658433612390,0.917424000769344,3.630389626682830E-002,-0.532938706763471,-0.675342840446946,-0.463466674548468,0.156048659359352,0.355963360903616,0.241194266578351,0.346121443305169,-0.230867503971894,7.020730288737370E-002,-6.515840122804789E-003,-4.827698865650403E-002,-3.702125915822338E-002,-5.907275100397825E-003,-6.715706035011221E-002,8.419393789440396E-003,0.277847850000166,6.416569411833292E-002,5.294442053117676E-002,0.120098391543089,9.160725908891387E-002,0.132682793092573,6.412701883082568E-002,0.156603928549902,4.885129204626730E-002,-0.101728556448747,-9.662920783485801E-002,2.746393051417180E-002,-5.202063978051137E-002,0.10142812981154],[-23224.6527594035,-1108.39039758404,-394.014470015718,-3072.87098443663,253.157851561789,1088.87767836511,1535.15394800693,683.516304982429,737.106617315759,271.300433164463,658.113244702356,608.290351982543,-816.921574677006,-1010.68116510868,-440.879913045413,-34.3944940702191,402.415384057427,-80.8684765497071,-328.455613008639,-237.259270178081,-91.3952728495198,276.412114888876,132.273889721089,-160.144264541797,153.745668983346,-44.6765307820350,-21.0276514569008,145.611279492742,1.96977402386338,48.3395562607286,-21.5909655278006,-4.04423809035806,23.0132315187017,-23.5170802705061,81.4178355013666,-14.3709383524703,28.3552735132830,-23.0210160324512,-0.908592921010831,-3.18572381290964,-30.5080169095389,-13.5855611979332,-16.7181698495273,44.4272205808607,24.3157441738696,-7.46290814034031,-4.93213420734301,-22.6199493433753,-0.560074063734423,-0.997012553177181,-0.617479980633343,-1.28089866351644,-7.75691082473254,-2.17734549489822,6.26810429373759,7.29801307007192,-1.84827745907522,1.31518594855291,-2.81822082435555,-3.74278133434693,0.683603918149374,4.91939369591553,4.78518162925413,-6.254243341416391E-002,6.237395879090534E-003,-3.33574721102281,0.263015151710887,2.42391823891717,0.775066755857285,-1.55291374399815,0.102386212844966,2.62816570206161,0.612656867897036,2.96028117277005,1.29955631271016,1.28868338519269,-1.44872155213629,-0.515094207762569,-1.36274652622290,-0.438694289171623,-0.707929148403800,-0.371063460362734,0.237338441632230,-0.493969563248632,-0.739768150871489,1.491963541442508E-002,0.331660573685102,-0.244910288101794,0.545799405503891,0.903822841867279,1.365788777961722E-002,-0.534119224862337,-0.713232792326960,-0.484350014007214,0.134405272767232,0.368576349648624,0.231728455873528,0.331627066281753,-0.218268381278697,5.703692663916166E-002,-8.620919062379126E-003,-3.991539081385674E-002,-4.013266664271722E-002,1.407664968437453E-003,-6.333235582188150E-002,2.395702971098794E-002,0.284776461823013,7.629052228673479E-002,6.202542309383720E-002,0.125065652255355,8.905415065916186E-002,0.116392405609153,5.931135890402440E-002,0.143687648636140,6.048930518765232E-002,-9.623777071907863E-002,-8.961565839882557E-002,2.656312971765015E-002,-4.994399612616591E-002,0.10010972554643],[-23282.0919316053,-1002.81893555746,-597.429647470531,-2947.91228384949,254.386668040404,1063.91692362323,1576.26127488389,499.224736234890,699.394488113258,174.113313890509,650.719110451485,583.743677367063,-789.240538565981,-919.092203373214,-371.542116309045,-52.5456414160568,363.062314069574,-89.2298365581135,-300.261518490036,-223.942753413174,-81.1676725019500,271.898476423567,113.034002186873,-176.534601436934,151.092692219644,-42.5850830540726,-22.2852117130756,146.545974671850,-0.997324572666814,47.5594678753243,-19.5289089899421,-13.5759662619086,24.0457096369769,-20.7265788814763,81.9372194661105,-13.0364011786528,29.5656396365523,-23.9323622214589,0.351870050841805,-5.19343977870175,-29.1876770138117,-14.1607436398236,-18.3036465213270,43.3491750424011,23.5985229492702,-6.94303224214382,-4.49229107741473,-23.4665828451568,-0.336981688638777,-0.593496953357095,-0.382157558748093,-1.22509104403281,-8.07171028635968,-1.82166768080641,5.75262901857963,6.75858625941925,-1.63825479930947,1.32405419389097,-3.00643221914990,-3.44225309279911,3.962349198338995E-003,4.58060721257890,4.84027173789375,-9.706311597904861E-002,1.715723724054157E-002,-3.31567449755743,0.367136795209662,2.32885231521718,0.868216970707951,-1.43704355478381,0.190641460894090,2.61308403567004,0.660110321729378,2.76716198295606,1.15549056024467,1.04011358281831,-1.58369438527152,-0.476518240130641,-1.25930327749251,-0.364342730412252,-0.746469042020740,-0.399096249948285,0.217100401662335,-0.497887606122428,-0.719654279847760,5.326602253346761E-002,0.362267121495335,-0.187332069303280,0.556028525820235,0.909975774892420,-1.180693790940831E-002,-0.530446078523852,-0.728422446469079,-0.518799019787917,0.136661023395421,0.385374663222769,0.232780392395905,0.315835613726635,-0.211696667107576,4.815164736873331E-002,-2.274874126719883E-002,-3.912848571669406E-002,-3.967252568124218E-002,1.121052838142420E-002,-6.422282707002336E-002,4.343259976119999E-002,0.285322031663822,8.792033272626505E-002,6.847740389352036E-002,0.126601981597386,8.517662268646996E-002,0.106767206453276,4.821743916894162E-002,0.139369564394858,6.735602788253583E-002,-8.432077000124943E-002,-8.726971648851940E-002,2.652507067088314E-002,-4.867170203842405E-002,0.10056044078803],[-23466.3505271989,-840.681398514839,-776.914053786296,-2812.94456918984,297.190536603858,1038.15184604102,1568.53669227940,355.162955936815,673.043959320961,58.6950231775332,608.041639319177,532.583920663873,-773.368748555420,-849.662737441824,-280.324662002891,-73.4340198500760,325.114562108487,-98.3208511292430,-268.186571603584,-208.760377679760,-62.6325228161856,265.259703499877,95.4797319291272,-207.151381713340,145.720295285692,-37.8234478260744,-21.7328264685491,150.405174156351,-3.93776119341869,48.8323218938422,-18.9736358100192,-23.5075960211688,24.7285725111057,-17.7399327121733,85.1837756417420,-12.5802429897359,31.8320516226317,-23.2490429615898,1.62147514871671,-7.00588733663103,-27.2493274331010,-15.3556329170243,-19.1599355766299,42.2146733474392,23.2574781931902,-6.41166235297223,-3.81560283074262,-25.1018595148555,-0.286335933866150,-6.070933339691430E-002,0.111625049709895,-1.01169614223649,-8.17032444532122,-1.30097535619217,5.23930188756147,6.54748686089169,-1.32035721503930,1.51087698534071,-3.05541309153697,-2.98373345411166,-0.737088955967655,4.26082589496526,4.95790868871127,-0.210298772119330,-2.539268250703790E-002,-3.27184875707492,0.471687161181596,2.31163346774665,0.990452761781974,-1.29862169967955,0.361398322705704,2.60404129243786,0.797261188089316,2.57183221827321,1.00256137688881,0.777508165228767,-1.79267801141528,-0.445735481813886,-1.15119494175995,-0.273193486715519,-0.789886330463293,-0.462272821456927,0.194670662178694,-0.484901242609731,-0.675483845969864,8.015900434809950E-002,0.416403942130810,-0.125768080171240,0.552723077423210,0.934355549934804,-4.657024992835823E-002,-0.530878367426302,-0.739032562100586,-0.561146937943113,0.143461175470785,0.417252319693811,0.237219029366058,0.298949111172374,-0.208574266426201,3.947241680206913E-002,-4.438664859145873E-002,-4.330933860880568E-002,-3.768170879305788E-002,2.368170947245670E-002,-6.574014675099926E-002,6.218406815459050E-002,0.283952707573066,9.748554359367095E-002,7.428676458396760E-002,0.124482281507234,7.940588994691558E-002,0.100520117944744,3.228444349765387E-002,0.137389858686554,7.192882946437311E-002,-7.025910771102217E-002,-8.813206109211423E-002,2.840352997706568E-002,-4.693875751150758E-002,0.10441992365616],[-23745.6136910977,-627.147054802015,-909.824010204038,-2665.64293346547,388.505021874845,1022.92539648826,1499.39268153167,233.303477215563,639.547794131482,-60.8222496897800,539.734292130068,456.592683615387,-757.141088523912,-805.788520827923,-164.830355889811,-94.7910626724500,285.895825774021,-105.169361283728,-232.539884285863,-188.635264780351,-42.3865844832449,257.175328249870,77.0472002551925,-251.772909327624,136.524249233585,-31.6982968860202,-20.7766899961497,157.606379197503,-6.71570005684888,50.3420639442264,-20.1924723581717,-34.7770576951087,24.2011696639184,-14.1203329081782,90.6376694244097,-12.5937372789527,34.3136656532934,-21.2763957764150,3.12609193433113,-8.96893479377409,-25.1367899988811,-16.9623417149362,-20.0270447276066,41.0715060892536,23.0233116302415,-6.12415299456252,-2.88881122863641,-27.5269660336334,-0.280146540328220,0.479897740670251,0.588563592677485,-0.703462018971480,-8.22718644840430,-0.582228277048673,4.68069256392204,6.48867376904429,-0.884143318676955,1.75160311389339,-3.09904878450959,-2.37103323176996,-1.63105338052526,4.01642941834640,5.10507208661566,-0.345275770327157,-0.136788516293073,-3.19641552635747,0.526716396805520,2.28993096435026,1.17248117003346,-1.17169816889566,0.579455292209885,2.61228687046989,0.981779648210895,2.37025646690552,0.853058149059585,0.466966817483428,-2.04167788872641,-0.435989024900857,-1.02617533130803,-0.165631371353349,-0.824940701842202,-0.541417416074351,0.168139458442194,-0.461740553103242,-0.614546119514821,0.101748451853835,0.475351967554984,-5.744927306947144E-002,0.541781172672347,0.967826757033266,-8.504381215353450E-002,-0.538227262635089,-0.756860697606962,-0.604388030788725,0.138723795146142,0.469727760565473,0.237806357139956,0.281831523383619,-0.206626876915015,2.889459737373007E-002,-6.678235530512476E-002,-4.917782406236531E-002,-3.712922314841366E-002,3.602602867883443E-002,-6.536622978663259E-002,7.667021499701381E-002,0.283506875488881,0.102698879284361,8.021492260754784E-002,0.121668594101759,7.255782396665506E-002,9.676579317043776E-002,1.536885255164959E-002,0.132692279369933,7.667954038898024E-002,-5.792097303747441E-002,-9.066744393359331E-002,3.289290973187263E-002,-4.353360422853816E-002,0.11262826870985],[-24035.4511581561,-369.055037585917,-985.751603375881,-2543.89521760621,529.556833272291,1010.69414321169,1391.58263136411,132.314631828563,601.061750296147,-178.979371171014,455.676207033773,373.724204173131,-735.349033904528,-784.238407537930,-36.9282904578070,-115.181745550746,245.525110909292,-110.794129072348,-196.372868808151,-164.346558186106,-26.5103572985126,244.813978698302,57.7392412626870,-302.296592839965,124.365307410572,-25.6046393526627,-20.0520654064558,166.819823941355,-9.09086573147242,51.0784331812881,-22.9180963089244,-47.0503909199621,22.6573178496921,-9.64073183478102,97.1627591013519,-12.8551452988027,36.2664980864997,-18.7513109591731,4.88739853299531,-10.7889420356989,-23.1017960668304,-18.6814535153910,-21.1343644523897,39.9489341657816,22.8294556197332,-6.00275314540074,-1.80271615012128,-30.3537541037432,-0.280626583807131,0.861939469567694,0.917625086172268,-0.404889072939297,-8.33925783243094,0.344753717412133,4.12214111210629,6.46581336732558,-0.351712478169273,2.01800808638428,-3.19999684697791,-1.64772197020441,-2.63266564881074,3.85983077546969,5.25507851299109,-0.444766975643769,-0.292170909248757,-3.10731292185150,0.519395544103064,2.21978800401844,1.42002328630467,-1.05702317844248,0.821047471621103,2.64155881069835,1.16819267999232,2.18501171171492,0.716967497078647,0.117083000735986,-2.27980859878843,-0.446673811137784,-0.888818781442338,-5.261667883227199E-002,-0.839354350883191,-0.613789757767510,0.139197666088346,-0.438017727572221,-0.553249694866723,0.127242330529588,0.522389909186748,1.676146012457010E-002,0.527873947803662,0.998577108236727,-0.119069996135973,-0.547096087695703,-0.783734442399339,-0.642495337272626,0.117441758123170,0.533669551463055,0.230588626714454,0.266244229098552,-0.202347927921355,1.820578147356850E-002,-8.362496942654488E-002,-5.435799367267369E-002,-3.796720221361709E-002,4.525445420277277E-002,-6.281459925185762E-002,8.428534944361704E-002,0.285777529328437,0.101937839618942,8.643496717090543E-002,0.120267856054906,6.532984770455581E-002,9.431679304387329E-002,4.892767724570382E-004,0.123331526882125,8.182604705957545E-002,-4.887242784026019E-002,-9.370806438025658E-002,3.983108306806542E-002,-3.824976452765385E-002,0.12369155613521],[-24225.1010063646,-144.405708354078,-1032.87108594469,-2465.71006498625,684.023503403862,1012.21805373159,1268.74168760564,81.5030181298518,568.624976090911,-288.143997150302,358.047512378640,308.757931062078,-704.890059557941,-782.329248361337,74.8846955270599,-133.240824121422,209.952991232783,-116.929280513488,-165.937634279668,-140.301003999261,-19.3114924776724,224.998303254059,38.7924338611922,-347.032980010844,111.342151172606,-20.0805460868627,-20.3024362846475,176.348732309694,-10.5263514932988,50.6656318560283,-26.4390113140778,-59.4173131536084,19.9316909222262,-4.61219616699043,102.682515596524,-13.6484795605678,37.2262985647846,-16.4061448640241,6.76147539886615,-12.0706236965368,-21.0035307151010,-20.2263766062712,-22.4361344080713,38.6891203881525,22.7648241176927,-6.10498723455304,-0.633019969168892,-33.0180157789119,-0.374008357784440,0.938625345961327,1.08840431792921,-0.107669425427405,-8.51403999415209,1.45629246183153,3.73194862544350,6.44656248617914,0.148071784046186,2.29864442590278,-3.43492337292802,-0.928206100107452,-3.64632762558310,3.79097827096340,5.37906054788663,-0.494668675025275,-0.460438106402957,-3.02706780387760,0.463596119745202,2.09846342440245,1.73402912334945,-0.942034880528498,1.07561382428520,2.68787267457207,1.30495823493663,2.02223425500519,0.610576571598781,-0.251307688261653,-2.44132501151038,-0.482252595875092,-0.753056199757598,4.519812587078399E-002,-0.826298640700107,-0.669752203386297,0.117830868717898,-0.420327330155907,-0.508767337587414,0.161531690449911,0.549524016667047,9.440076943341438E-002,0.513765408834916,1.01862192292240,-0.144214728765522,-0.549448710462058,-0.820816512929190,-0.668611226726517,7.992631576070904E-002,0.593965091522034,0.217373421547019,0.256367486994261,-0.190265092035182,1.124711556650938E-002,-9.284185030258364E-002,-5.809161617715146E-002,-3.911485736627348E-002,4.877330809275095E-002,-5.822850218795745E-002,8.375910058010562E-002,0.292470374496322,9.787290079586486E-002,9.165475170366057E-002,0.120077988003674,5.793370156113922E-002,9.089966677220900E-002,-1.066781125697891E-002,0.110024932963109,8.757946709193647E-002,-4.396258303219481E-002,-9.510444484670129E-002,4.805821081049183E-002,-3.215844414947716E-002,0.13453284053378],[-24298.9837852198,-55.6386882345582,-1056.65102836990,-2401.79459716760,795.835201876904,1040.41467579074,1120.61479557084,103.043053957075,539.486971573908,-370.633929705947,246.248732745308,262.526703837704,-662.182695735257,-805.745701376162,148.253378563129,-147.214787054040,184.060766964044,-122.268422120206,-148.466344679957,-121.312845357436,-24.4563192399674,200.051658296075,22.8207141271413,-379.548061752459,98.8911737984517,-14.7107933538897,-22.6002678078728,185.129329737392,-9.91751003699724,49.1258411921906,-29.4565949159157,-70.4601166518646,15.2528750204674,0.132185461551990,104.992532548261,-15.2712507227973,36.8975948212103,-14.4452450644827,8.75678253103639,-12.7492298243931,-18.5025015686370,-21.1586274584704,-23.7803884622141,36.9905692672767,22.7734554490082,-6.87510316322241,0.618941417310902,-35.1358191817715,-0.617893485900345,0.666896623120099,1.10303865052226,0.306660750601173,-8.66179455303388,2.71652469379626,3.64117091737691,6.50811344651597,0.450462496639148,2.50924259716547,-3.94164210848486,-0.304864355638859,-4.61502465716294,3.84586466200742,5.44423444431421,-0.505309468161601,-0.629890395588692,-2.96715950216778,0.382311449488517,1.92725415520312,2.12865515601861,-0.816932131431981,1.33991441314499,2.74889274242561,1.35218349142156,1.86311424674095,0.545882897193572,-0.623266189908476,-2.47503305530646,-0.561193612027842,-0.630109177811462,0.119276194262907,-0.781387678887902,-0.710718430210832,0.109142558285873,-0.412110500361858,-0.488151293583472,0.198898954330667,0.552198557476664,0.175918583261857,0.502319720624828,1.02522879152269,-0.160207040871098,-0.543594278609358,-0.871480621308163,-0.674092352018368,2.562764886817399E-002,0.643781402043987,0.203511746145569,0.257611797285075,-0.167369134793539,1.011786717561439E-002,-9.506158451200540E-002,-6.143083031791434E-002,-4.162198288506221E-002,4.365838219989966E-002,-5.142462532232024E-002,7.521563147082136E-002,0.303146966324828,9.518793563513232E-002,9.461413256299447E-002,0.120063797991455,4.994228303781840E-002,8.621833900905847E-002,-1.592281989578116E-002,9.443171538500902E-002,9.587741696892478E-002,-4.370638991350909E-002,-9.235234968400367E-002,5.647898706310572E-002,-2.691210802264778E-002,0.14355957518747],[-24214.2954722024,-102.685439648479,-1029.64903376550,-2372.04735753475,862.642074168080,1065.17905102777,952.298875179653,171.850833861492,512.428206830251,-424.133350884231,132.922021131151,225.498868991954,-619.413039844403,-854.550859120280,183.669984562614,-157.606248844257,169.162319673892,-128.422656177000,-145.606194623690,-109.476242204234,-40.4680097516628,177.322711497611,14.2887230988930,-399.164992606730,88.3826240066289,-10.2662460678106,-26.4273367568949,192.595952950555,-7.80671080514192,47.8423351548726,-30.8920610511862,-78.1318638009449,9.01971788310311,3.62449259179618,103.854552144310,-17.3761414282482,35.6058256182417,-13.0236306789023,10.9532603778741,-12.8001477077868,-15.5285460051054,-21.3381145906231,-24.7907533330179,34.9781766025625,22.7130641153316,-8.39022846994104,2.02213387399680,-36.5426348182134,-0.953927478116395,0.149329577601404,1.05055779761417,0.845374801846422,-8.80094189702080,4.11418858037151,3.80851305286999,6.75420320771091,0.528575733274323,2.58115500770438,-4.69142296895069,0.221265956217119,-5.45539591999092,4.02270568048779,5.43810355355129,-0.470364687416916,-0.774648461397220,-2.93613975021504,0.314356267745010,1.74606861011666,2.57074076691889,-0.698901131272427,1.61894553491690,2.81051084129135,1.32228455387357,1.71195178476098,0.532874277296610,-0.962702144514150,-2.39843356114465,-0.688828740554967,-0.533069059170257,0.180552160656948,-0.717492654491294,-0.736716506915795,0.110388535929609,-0.414373355197338,-0.491905246949659,0.238960909489872,0.532610259860138,0.259445057340983,0.494427501028422,1.02477647345867,-0.171019384305593,-0.532604816810432,-0.931351018171767,-0.660828587224186,-4.044441300977111E-002,0.680754097966922,0.197446096610987,0.270203260517514,-0.138149931535769,1.433142396791635E-002,-9.222624121038771E-002,-6.462122783759064E-002,-4.485787652532519E-002,3.206548837045101E-002,-4.484654167679267E-002,6.119004661631219E-002,0.317351689359669,9.321617142487924E-002,9.638478942056204E-002,0.119418967462074,4.185944245149657E-002,8.204665917892355E-002,-1.505532414949354E-002,7.909374349151957E-002,0.105623709429850,-4.647639753316143E-002,-8.587970117549987E-002,6.401749140382394E-002,-2.393746962192474E-002,0.15114329055914],[-24031.5906550530,-188.616973561865,-1001.56591000904,-2395.56127566575,940.555096433978,1052.74057362996,802.666331416831,240.663723884204,489.854777879683,-462.786266449637,31.2112097307219,201.315041174535,-592.362976081977,-913.062725128532,200.026329234594,-163.258624808382,163.739715255055,-133.787702869364,-153.499565917567,-105.471140233081,-58.8157578494424,163.264413222581,16.5681746412614,-406.269991365923,81.0737430946874,-7.62356986342172,-30.8502698138352,199.551992178239,-5.77339195892440,49.0196244741161,-30.1694194186916,-80.1391428702836,3.11903376155559,5.50781748016697,101.098352184685,-19.1803178287869,34.1290375785765,-12.0249584751567,13.0944539614651,-12.0450811680974,-12.1884084701159,-21.0634682818958,-24.9363565069885,33.2224912857701,22.5791221717369,-10.1403496487526,3.51001749036586,-37.1924943674860,-1.24702894503456,-0.416736571832560,1.00881197598977,1.47463600938857,-8.96507324642347,5.57275611267363,4.12116869715679,7.24810940009547,0.472931609529826,2.59278309671093,-5.44468749350501,0.673127188071447,-6.05160574075822,4.25054932888835,5.38631894804807,-0.397539262632884,-0.851752687878024,-2.93360056920581,0.273215305403482,1.60228067054936,2.99895532774479,-0.630270693751499,1.92018689595510,2.86820526239390,1.27012252389973,1.60120075570594,0.573876774684202,-1.20635173258972,-2.28274699149988,-0.826618402644185,-0.476556632519608,0.236889928688649,-0.654716382116386,-0.741804094476715,0.116169286191988,-0.419153579551844,-0.511189709308138,0.282179785217347,0.506333420229225,0.332886738861032,0.484049426731368,1.02768305242159,-0.179619643201463,-0.520611899855978,-0.984691141950575,-0.639595212621599,-0.103987945235170,0.701559355313270,0.203967040975142,0.287424015258853,-0.111422472117556,1.988502180610484E-002,-8.671428992977429E-002,-6.745576862673405E-002,-4.643964694272447E-002,1.924798424508640E-002,-4.013716015639938E-002,4.433394293836999E-002,0.334498613318620,8.892896713604763E-002,9.852119145337822E-002,0.118377839715843,3.590288601074500E-002,8.060735560638033E-002,-1.076466124539704E-002,6.805874739477306E-002,0.112193663770460,-4.902964033167466E-002,-7.921552427594092E-002,7.014761453802164E-002,-2.325944285314694E-002,0.15769904904708],[-23854.7700852253,-263.987344876108,-954.332277747113,-2474.03553311517,1051.53824086160,995.299731305068,695.068793421247,291.652426129507,467.130587275075,-498.806756127332,-46.5083920864544,196.793354916320,-581.523931654506,-973.446860281709,206.329344812784,-162.292619285534,166.097087604282,-135.114565610123,-167.710376262315,-110.719518410721,-75.6289460217629,159.223732208503,28.3158742574831,-399.672881192698,77.6224247479293,-6.75300885487119,-35.3563660271029,206.470838350486,-5.41075004120159,53.4174934270633,-27.7331463660088,-75.8072070193534,-1.10876873393878,5.84378309333965,97.4861749328910,-19.9601377663285,32.9737303355324,-11.1217890829414,15.0025301441081,-10.4844408723573,-8.61462607697080,-20.7237197675833,-24.1948666267419,32.0796006267814,22.3896873779153,-11.8495208474652,5.00432027842911,-37.1252868854808,-1.40266805392539,-0.869666811377351,1.00566027032146,2.20771754357501,-9.14247054057721,7.02719820943066,4.42803703307589,7.96823221273449,0.337858886490472,2.65611382799656,-6.04878318780278,1.03576976442191,-6.40355107991190,4.47778344300490,5.27553782968087,-0.307704299821657,-0.830384822818973,-2.93857529517312,0.260737455816143,1.51994783500566,3.37638043954461,-0.644907189309639,2.24008427476801,2.91004559426268,1.24550067352024,1.54573556550750,0.668916837342852,-1.33520029397657,-2.16259807485900,-0.947803743897046,-0.460019426594406,0.286268768912203,-0.604135725064426,-0.719036407436847,0.122755824186881,-0.416981712092518,-0.531802164927241,0.327898648287988,0.484931598506740,0.388074112221377,0.465222958619500,1.04126889216869,-0.184708823542660,-0.507032569201408,-1.02687706100607,-0.615670598301707,-0.160064423210005,0.704805485361331,0.222689786953995,0.305349511603188,-9.085036230495797E-002,2.278952484496343E-002,-8.030299056291090E-002,-6.977659822786082E-002,-4.521033631016484E-002,8.809846043225491E-003,-3.680826601724872E-002,2.648221759931376E-002,0.353483526057532,8.044899164775592E-002,0.103219594620782,0.117581180297745,3.518747415398533E-002,8.148816416491153E-002,-5.332781179015977E-003,6.297562758684076E-002,0.113625856392140,-4.970042636946623E-002,-7.326201615450453E-002,7.445102245250423E-002,-2.429073783881347E-002,0.16298504620105],[-23759.1633634767,-323.586450843442,-843.781275014668,-2595.19194245567,1160.49578279783,921.775570333427,623.820987693219,335.917040570330,424.494370001034,-524.545915908201,-97.8552738066871,212.954097647618,-573.441966793890,-1048.23105050624,199.766994588815,-152.769417740235,176.043434326280,-128.633844153516,-186.496323544161,-127.915498129614,-94.6606560742976,163.369761411860,43.7603366567089,-377.726538251118,77.9950023606934,-6.45228812337482,-39.8003988348316,213.316332272767,-7.88372660077156,59.2304548073767,-24.7761158643957,-67.0603422560596,-3.50509497375170,4.91995832949639,92.3581897966562,-19.2936002563075,32.2238722133458,-9.77141892041414,16.8778016638445,-8.63649794592994,-4.94182586431822,-20.5546203711698,-23.2554513535110,31.6502726110511,22.0573819309140,-13.7236330074203,6.52951498166006,-36.4716879268225,-1.37598724227458,-1.10679696476406,1.00120651071209,3.16939247153784,-9.25307622136953,8.44249118537486,4.60231059232598,8.79958439038272,0.118842945209745,2.81021578740865,-6.49829531861228,1.28478741729352,-6.62414519068018,4.71539381346401,5.03587853710439,-0.226770006410671,-0.716918755307282,-2.91770469872940,0.282263083168374,1.50310305601114,3.71156168493754,-0.749598922125416,2.55986715479606,2.92983058540152,1.27279202938893,1.53820629750087,0.830297169654181,-1.40003872835847,-2.02751451336897,-1.07178620174204,-0.471210844409301,0.329318012219212,-0.565001435415985,-0.668771687710151,0.125856671200730,-0.399268000845232,-0.535210989986084,0.372995589858789,0.471758896647456,0.430176202281142,0.440735796006121,1.07266154227496,-0.178407292926425,-0.485420572376559,-1.07051810451617,-0.589594996413152,-0.221597406780135,0.694123060820033,0.251049223876150,0.326967922484194,-7.366173748554480E-002,1.977452775575607E-002,-7.398865586954677E-002,-7.290785132701869E-002,-4.305795074903554E-002,1.118295719929997E-003,-3.145765941135538E-002,9.817022034085094E-003,0.373855956149068,6.982606019717731E-002,0.113324019303698,0.117961993603693,4.324245579969203E-002,8.167467488827473E-002,-2.521416882159934E-004,6.106989427583101E-002,0.111382302188550,-4.944321114356429E-002,-6.491094494124725E-002,7.657199765954249E-002,-2.671942622035734E-002,0.16709988819708],[-23714.8580046041,-445.197910845039,-741.639280229800,-2723.42971609714,1246.14586981197,863.184830294750,574.232176631661,404.551551667762,346.839828228018,-520.926607498214,-131.754616145083,249.312332754699,-552.336299545985,-1146.64725347518,176.071858868846,-134.054989720646,195.095874355303,-111.989997142968,-211.951518272679,-155.098649511110,-119.945451562253,172.434626597239,57.4168675091276,-340.601248102421,81.2358365678975,-5.71947910165801,-44.1473585560973,219.535897816378,-13.4864860696873,63.9722664045422,-21.3360935608390,-57.0276563427258,-4.17951004465627,3.63757953814965,85.2869095944010,-17.2365673146181,31.7520342639232,-7.52744889880994,18.7857756845890,-7.00844765323150,-1.50422970701112,-20.4412522570137,-22.7803184065096,31.9361587895915,21.4748754622098,-15.8635126165198,8.00511469667675,-35.3348012595364,-1.19065749552663,-1.09203930138927,0.959857911399486,4.45715704782729,-9.19095593118291,9.74807165124301,4.66275803189998,9.58104009444937,-0.224064615516458,3.00265842151667,-6.82990874917441,1.38196839284280,-6.77724274191171,5.01293069638726,4.64698573936626,-0.173315228167529,-0.540583755175974,-2.83735171438694,0.342870114747015,1.55404295291527,4.01377737842905,-0.928695295938913,2.86314743008852,2.92519172691683,1.33796365253542,1.57316679414385,1.04837029326512,-1.45660190842297,-1.85903190102805,-1.22232470567574,-0.505314938815775,0.370888434629392,-0.529499320744821,-0.596660618198591,0.122326331500358,-0.358305285516250,-0.509512887912191,0.412073961388351,0.468468109877301,0.465272915082164,0.418971570635655,1.12328512411712,-0.157722726800109,-0.450269966379793,-1.12465922025694,-0.563594452054982,-0.301778116293157,0.671641012934805,0.281423042273710,0.354758712090125,-5.413692651682726E-002,1.031412339998406E-002,-6.783841775168795E-002,-7.863561132198185E-002,-4.241067875267695E-002,-5.351346596021547E-003,-2.107810465655965E-002,-4.333670737442849E-003,0.394873253560382,6.164195760688840E-002,0.129338308056523,0.119791668115667,6.160306813389148E-002,7.868752373851698E-002,4.228478228617631E-003,5.776215702851763E-002,0.106820808640919,-5.094809662284698E-002,-5.195170159959911E-002,7.691208400579326E-002,-3.049580857512804E-002,0.17008391244572],[-23712.8593759615,-633.322062734335,-694.350933838342,-2826.69202206902,1308.28831682743,803.540957377846,570.164378891172,502.195509077657,236.015414460086,-477.627069748007,-153.517038011054,311.842919492768,-511.925583354937,-1254.95996914405,129.730751267602,-107.468560483850,222.196008779917,-87.1273665646190,-243.625333268716,-187.055976816604,-150.406293589542,182.861557353202,67.5050093117610,-290.172617469783,85.7574695091349,-4.47550607793658,-48.3508677257778,223.907449658726,-21.3750012377941,67.0483279493717,-17.2503543531222,-47.2285599812487,-2.83477497958653,3.19615634441882,76.9776076341911,-14.1607155738368,31.3439996660712,-4.32572024805195,20.4974069406248,-5.66226662829809,1.29016284528532,-20.0927510932226,-22.9293239947579,33.0343926602148,20.7697582050666,-17.8624924818130,9.29028619736223,-33.6981568490805,-0.957062611623981,-0.844319390998461,0.894231934617976,5.95374323135606,-8.89113922729438,10.8549313010924,4.66860292230971,10.2522572462437,-0.678567200875294,3.20542458861421,-7.01535017393401,1.28617791536669,-6.82377227359840,5.38224576751826,4.18335563531043,-0.155070323463340,-0.328469909440874,-2.67342847845111,0.441602975106985,1.67336436700775,4.26921045323824,-1.14365783897878,3.13660146266820,2.88957928357120,1.42265920955974,1.66624842352276,1.29279013860458,-1.49793761697973,-1.65738996215143,-1.38297933859477,-0.566755468344228,0.413927258314682,-0.492451524429487,-0.507975209602754,0.113037391661720,-0.292364577473144,-0.453025256651796,0.440468052090969,0.474257403742100,0.493105091551048,0.405159158640239,1.18725817069864,-0.124758271869160,-0.402678011763424,-1.18405595417415,-0.544262952646354,-0.396773402740650,0.633434403602679,0.307507731305072,0.385420098493951,-2.806183960508787E-002,-3.804547837958150E-003,-6.169458435091324E-002,-8.630815173279556E-002,-4.339322583851706E-002,-1.216891648314771E-002,-5.624917584109522E-003,-1.520099931657452E-002,0.414322129831953,5.731886746687168E-002,0.149864523080305,0.122258443796603,8.913877821336205E-002,7.345492040236927E-002,8.183144633905170E-003,5.279962877437912E-002,9.937308580658898E-002,-5.539503145670147E-002,-3.574921483994240E-002,7.616899135077115E-002,-3.576626753465405E-002,0.17140985708968],[-23818.8462553611,-802.343506775490,-707.484827583636,-2894.20761245827,1338.77216202623,730.630683169816,641.579448289641,600.716586248708,112.589656952272,-401.754220566858,-168.310227454213,404.486566493099,-461.045331155133,-1352.28643800232,62.9675607165423,-75.5727436710108,253.247356358069,-59.7704845860388,-278.468228870343,-218.247286139058,-180.254858267215,192.052788407252,74.3245517287486,-233.919217672624,90.5797104566647,-2.92804641146122,-52.1587394204811,226.181879572605,-29.7713830851879,69.2205269143941,-13.3499024266683,-38.6095240031267,9.827354684550801E-002,3.95205308566464,69.1425671950589,-10.7475524756963,31.1951217520235,-0.486784512042038,21.7726834333689,-4.51837775075495,3.16148050723216,-19.5629731719524,-23.5825253050399,35.0132261176323,20.1386646712918,-19.2108696804764,10.2984823422718,-31.8134355437430,-0.804691035520198,-0.369880157425501,0.889327093401989,7.42594978653128,-8.36824776872377,11.6872532725883,4.65907604189516,10.8119063228076,-1.18963331303753,3.40010164937953,-7.01704183868279,1.03166139547931,-6.71959600723751,5.79274500506416,3.75574444816124,-0.184742700883407,-0.108560757475195,-2.43102799575663,0.576775473155462,1.86445968167960,4.46976808147066,-1.34831734944129,3.36256512011443,2.83340019624788,1.51342685235843,1.83626265734602,1.53967338510921,-1.49098563203472,-1.45189966750495,-1.52513143155393,-0.653502506774053,0.454859991897797,-0.460779164398755,-0.418858805904119,0.105582869315206,-0.207236499311004,-0.371843764890389,0.456981087728681,0.491587531355276,0.512048910164211,0.399891429938762,1.25839054968914,-8.388629921959398E-002,-0.350573151971922,-1.23528045280223,-0.538524570777052,-0.489325236044841,0.583818712789693,0.327002014340293,0.414154342981057,1.864541536145492E-003,-2.001540104722219E-002,-5.747654642456046E-002,-9.399825827597968E-002,-4.445224115056141E-002,-1.824477270031887E-002,1.265332822592045E-002,-2.079268520021930E-002,0.430904431198572,5.589264794463229E-002,0.171902298529560,0.125053495919589,0.122138515625441,6.999989845928353E-002,1.233887399175512E-002,4.950542357346649E-002,8.915574960586713E-002,-6.196665822280903E-002,-2.029969630820490E-002,7.518516583029061E-002,-4.207666315118331E-002,0.17165231249637],[-24002.3028894334,-920.896015521176,-705.589738331855,-2942.03479735781,1304.42631484356,643.828183545803,764.013558355256,687.149202764499,14.5557651041270,-314.820329906372,-171.316425123462,504.476043222925,-414.622978810499,-1428.03356779019,-15.6144729609615,-40.3245868297774,286.208195656532,-38.7053583551161,-313.463175852711,-241.083256606931,-204.169319252206,199.396243620122,77.6174724187376,-183.478259041550,95.2007777425878,-0.902385464451104,-54.1651975665924,226.335221137766,-36.4842263242726,71.1701005475813,-11.1562032932830,-32.2961755849278,2.72498323744683,5.04034926286677,63.2793811524872,-7.87137899132758,31.9315169558334,3.27093592051458,22.8545305645073,-3.25309906572521,3.94435583586805,-18.9454183468403,-24.4737883089912,37.4126670981213,19.6220620084858,-19.7881748288312,10.9357999291383,-30.1801509917221,-0.886161271542645,0.319966995328849,1.02831003160547,8.68244202031029,-7.69972125368233,12.2766680271030,4.71075634381404,11.2531763978832,-1.70009330814144,3.48831192150851,-6.87120371234990,0.690188004849459,-6.48278469390003,6.19328687976224,3.43509136026221,-0.266465044255373,7.619776112384487E-002,-2.14584432411553,0.766766216459595,2.12842568849914,4.61357657881053,-1.48372176400569,3.51789955547188,2.76799408978493,1.58344935764668,2.06123052094719,1.77238991297070,-1.42326667872249,-1.27164760098237,-1.62936621395188,-0.750728994896589,0.480133690901052,-0.448473661106929,-0.354400970311844,0.105499805405407,-0.115340034062836,-0.283653069438362,0.473392041043965,0.523463426346079,0.524817975819753,0.408920676080851,1.32194567915661,-4.234170570548213E-002,-0.306351798173975,-1.26473664756850,-0.543109472883916,-0.558289134608260,0.536313989295224,0.340288709551210,0.436771411268400,2.798709541169634E-002,-3.396320766578616E-002,-5.910409913412221E-002,-9.943675474950869E-002,-4.439819899685061E-002,-2.128173216938175E-002,3.021133150925501E-002,-1.858747462121116E-002,0.444992200696052,5.619681726747063E-002,0.191030627256216,0.128950705056980,0.153606321650847,7.263478009782173E-002,1.833857765949357E-002,5.067816778895411E-002,7.811728844102241E-002,-6.889266407834729E-002,-9.771612076616313E-003,7.469315507135611E-002,-4.799105750122106E-002,0.17165398911489],[-24219.4089938681,-1029.88902098333,-664.243196141259,-3016.14093026892,1197.93109877051,527.468464939198,917.112842755404,763.875472188718,-25.7433594015155,-247.030575312154,-157.138403060257,589.317127762836,-387.364976302290,-1476.22609922169,-91.3847447480519,-3.61810603409253,319.554351893915,-31.1674905404118,-345.630694075333,-250.318390663587,-216.590683074877,204.762681488888,78.5299120638785,-145.855828097665,99.5328424512799,0.952933156605545,-52.8424551961417,224.255347200762,-40.2916276614537,74.1126938564436,-11.4394239649604,-27.9262967159344,3.80673710501674,5.29109069324480,60.3879672804667,-6.03969208356847,33.7997722552162,6.12552517557792,23.9227518095809,-1.32089457223971,3.76915606353377,-18.2387663871361,-24.9465062509065,39.5601048856743,19.2033018397003,-19.6545996391169,10.9818740628411,-29.0511823463309,-1.25178879730734,1.10894793147694,1.30864516961712,9.55529544719727,-7.00812408120706,12.7102436520180,4.92290280705214,11.6128034701197,-2.18150344645020,3.43936195117269,-6.61114650622841,0.312771844716899,-6.08959130695314,6.50893695232039,3.23321258801138,-0.367631410937989,0.199852488867688,-1.87180681073503,1.00554509789463,2.44502194678950,4.67917533362357,-1.51737761577339,3.59666843459746,2.69232276763879,1.61511751418199,2.30364203110239,1.97613975608448,-1.28112272526918,-1.13953178687673,-1.67594651254810,-0.852908055231406,0.473561048023592,-0.461042184510570,-0.323671055220478,0.112168336721061,-3.306044125435945E-002,-0.213412126728024,0.501219221131963,0.567216401994290,0.531570881294051,0.435047873890844,1.36197555546959,-8.729324709402044E-003,-0.278607503380170,-1.26015023804311,-0.549761014404652,-0.585160654628771,0.498246686472730,0.348895754113429,0.450358915758782,4.091435863489949E-002,-4.125777648999897E-002,-6.734132331302110E-002,-0.100754861098378,-4.274441129551669E-002,-2.041613123321856E-002,4.270174994539340E-002,-8.892082453130631E-003,0.457262517773674,5.623064737014477E-002,0.203645591404078,0.133838811023632,0.177097880023797,8.304460448505969E-002,2.702792086612053E-002,5.838851667493258E-002,6.716423387133157E-002,-7.347778617698324E-002,-6.926582518802536E-003,7.467334805921363E-002,-5.210613448137680E-002,0.17090076305164],[-24471.2490873345,-1097.87091883497,-631.837287517875,-3106.20963819187,1072.17382863962,397.709790677475,1088.85154463451,825.373057690756,-15.9629432167468,-205.515820893189,-135.367567539103,652.192885870613,-382.755151478199,-1501.35972619034,-148.749170770793,31.2945363950833,350.564783181228,-35.5769551560987,-373.745597165788,-245.850193153060,-215.256883060115,210.252451876878,78.3716686549087,-121.646438611945,102.556608615016,1.16823700622981,-48.9417753032190,220.930187938028,-40.7130908130266,78.6315447820931,-13.4734353134034,-24.3911741304876,3.55512827721288,3.91038411609707,60.6461869652065,-5.39246086536368,36.1114445613065,7.92398543471402,24.7089031601561,1.33878274262484,3.04062865509531,-17.3709271080560,-24.5552598251066,41.2172646005537,18.7378058609678,-19.1158161159152,10.2458048350877,-28.4506048092868,-1.76530366827999,1.79447374310618,1.60091325736014,10.0040952520386,-6.37153742018315,13.0255623546003,5.36109029373146,11.9574489884660,-2.64046009856470,3.24201629154138,-6.29240082305344,-0.125291361591777,-5.54923422954733,6.70341143370179,3.11141486527547,-0.442792842605050,0.250123441141653,-1.64227922169479,1.22929727144352,2.75790836927996,4.66828066485131,-1.48383586944364,3.61055667772976,2.60900762728370,1.59604097843007,2.52385061600749,2.13301851144980,-1.07336717554826,-1.07070123566377,-1.66887225832512,-0.963864302259234,0.424496377477987,-0.484470229875654,-0.316505548450657,0.123150155459283,2.984070483675316E-002,-0.175340718796436,0.534338216642433,0.613990001228792,0.528916488046543,0.468994392928778,1.37233991683271,1.025530528001691E-002,-0.274949785372647,-1.22523371081776,-0.553269783692477,-0.571237430164776,0.470612907223265,0.350290763134260,0.455722204121411,3.441503276634797E-002,-4.084126918397553E-002,-7.760965144449923E-002,-9.851857967448710E-002,-4.092623276950908E-002,-1.775212734066714E-002,4.885139336668396E-002,3.188800578006673E-003,0.467875729620590,5.460850931052503E-002,0.207740113315608,0.138209971769696,0.190014006404769,9.914966905254788E-002,3.800037488747316E-002,7.143721393107005E-002,5.646741654860900E-002,-7.695882852520837E-002,-1.139783980289295E-002,7.378148055560972E-002,-5.372422239535028E-002,0.16880690577387],[-24706.1971385814,-1107.56068825234,-577.316042849911,-3150.85797711046,997.477315134691,316.701967984903,1226.21960174693,866.648403779947,18.6449156597483,-179.273071839726,-114.216702511784,682.174667605861,-389.336601334593,-1523.31450379315,-178.756911521544,60.9478214786379,377.319302243346,-45.1193177883587,-400.710863464984,-228.920127551818,-207.595733135509,218.327445072262,75.9828258075742,-108.301512067077,102.733385906699,-1.21135557186274,-44.5156268975948,217.122980048776,-37.9035390220243,82.4536476048749,-15.3702219727331,-22.0681269536079,2.77897153156344,0.950732837788715,63.0418113210690,-5.80153755651179,37.9045859138114,8.89757003314872,24.8858125181718,4.43723801937740,1.85080822653359,-16.1540791726417,-23.7541814501403,42.4643185861182,17.8557885825118,-18.7175081285750,8.77208131161584,-28.3338768370607,-2.24613800855612,2.18985341937140,1.74238601706088,10.1248573949622,-5.81806747548302,13.2144917780545,6.03096869959904,12.2008741345265,-3.04709455086164,2.80707147658011,-6.03623290075550,-0.686824350507399,-5.01179095166462,6.80284728666944,3.00570463993117,-0.456479325913798,0.223342204867395,-1.46818695423061,1.36951034459304,3.00682921867267,4.60792328303125,-1.43644186926180,3.56983448545371,2.53583928727122,1.49972473422269,2.67527056536909,2.20787331636824,-0.873481846948130,-1.06152719739825,-1.64783288558367,-1.07585363125622,0.337390646515379,-0.495193020519885,-0.315266136260012,0.133421331455521,7.033085639084746E-002,-0.170944128598327,0.563238882609636,0.654704452728006,0.514768880341944,0.503108321459636,1.35197509633749,1.356482788030077E-002,-0.301459565565606,-1.18435732709912,-0.552627646641426,-0.545318393904344,0.453433615982115,0.335509224301283,0.455835881655138,1.133349651419757E-002,-3.348261221049104E-002,-8.317984919053333E-002,-9.460466723233345E-002,-4.119057542700862E-002,-1.673145060915484E-002,5.011533985789685E-002,1.101418280597020E-002,0.476723442520589,5.190250915222510E-002,0.203587796226270,0.142090533673822,0.192796780199849,0.114624598905234,4.937608204403453E-002,8.194006577292801E-002,4.692580918181114E-002,-8.522899558092745E-002,-1.939580430214430E-002,7.022099284041632E-002,-5.267548204897886E-002,0.16565052085265],[-24940.3966155242,-1102.85411347832,-482.113213799236,-3101.03525986143,1004.71090103451,330.393804155928,1282.47415086619,874.834745040472,59.2604652087178,-164.853360265722,-101.643890642792,677.979730471017,-393.665751436356,-1551.74243355880,-181.417833655467,84.1326021992546,396.806943426323,-54.3053813337285,-430.808186835706,-202.517966516316,-200.201565966843,228.359757747236,71.1222834912638,-102.201355767700,99.8233065824359,-6.39333020628283,-41.5501412861961,212.647659965359,-32.7078533438351,83.6699183257569,-15.5088129211057,-21.2085081368940,2.23887261269914,-2.59113724526914,66.4822100281122,-6.79909209342014,38.7172953253562,9.37333091190542,24.0521222881062,7.61494564753400,0.199327572419348,-14.5504738268357,-23.0867204047428,43.5307569460606,16.3581797768055,-18.6069797305688,6.87951494501086,-28.5105947998788,-2.53221998138248,2.28285786578912,1.65353118100289,10.0085801277334,-5.33683298975042,13.2250444905734,6.87461555202657,12.2365503143490,-3.36443185519027,2.12871521797143,-5.88035041850318,-1.34919544325747,-4.59433893134012,6.84941747233595,2.88721984729930,-0.401877142341861,0.148375933262988,-1.34336230811296,1.38759595132134,3.15831938070575,4.51073743228128,-1.41084960339319,3.48989636608830,2.49041810440423,1.32384330456630,2.74928001714704,2.18813456003017,-0.737813457368505,-1.09601306570392,-1.63524676279451,-1.17555548001335,0.237365267911170,-0.478887852943327,-0.302223407184924,0.137856467759024,9.360064458710746E-002,-0.192061987847875,0.576802792985434,0.689068111109053,0.489131852414601,0.533418302282732,1.30621523264869,5.290253726140537E-003,-0.355148138343437,-1.15535933755165,-0.551240018352579,-0.532177727410610,0.443850601438906,0.301914896848751,0.452028044881709,-1.971351386741501E-002,-2.197461961488704E-002,-7.935930317844896E-002,-9.149609600080198E-002,-4.393494303347458E-002,-1.883328206778510E-002,4.826461179131170E-002,1.098108696336694E-002,0.483183207878489,4.953498828055351E-002,0.193079441655289,0.146052847622081,0.188230632791797,0.124651206788144,5.924571961662990E-002,8.397857403595591E-002,3.874557849532320E-002,-0.100773781997384,-2.733354129652742E-002,6.358476407438041E-002,-4.951835560782273E-002,0.16227519344430],[-25237.7400732942,-1034.53778948748,-413.070744395846,-2945.00505973385,1078.83097668230,430.552481844891,1288.75161300356,836.698071292648,86.7839420535493,-156.214482487457,-112.083641194588,662.236068052520,-390.284535816411,-1575.35596253703,-163.670394546317,101.457199659751,403.998012667561,-62.2006468456137,-462.893774674480,-172.360671845787,-190.191253223556,238.543495316870,65.8391120794596,-99.8467105027808,94.4039312713884,-14.1936509202666,-41.4140593566049,206.863587021228,-26.2661030374865,83.4874503400374,-13.9706603608633,-21.0207850510692,2.57374073933403,-5.76211546001948,70.5799960211770,-7.88814418737047,38.4119630785173,9.80701153314743,21.8729261497031,10.1886018733977,-1.55061004569147,-12.8083154011651,-22.5425059343012,44.7396066898112,14.3847581110384,-18.3366122900330,4.91998012934466,-28.6976096494938,-2.53078387117893,2.23853610999294,1.35398842023243,9.63525483874423,-4.90454725820037,12.9918251802256,7.71582159515276,12.1110305586438,-3.56850602797286,1.30680230600962,-5.68242960276382,-2.02690296411082,-4.24181592628409,6.85970419467121,2.76825591172141,-0.300957815845224,7.023794369981104E-002,-1.23375843260703,1.27051935035545,3.19905731620592,4.36600654076778,-1.42782751501301,3.38039781060339,2.46731386179765,1.10176524574227,2.80012271905662,2.09998378968163,-0.643404698847078,-1.16033857744693,-1.62091224773070,-1.25812693848883,0.150637217068559,-0.436536455096537,-0.268509229353478,0.136611521045939,0.109969608559898,-0.221661954512987,0.556608911435208,0.714259580314870,0.455591606649838,0.553929969354928,1.24645307404833,-3.219860514495057E-003,-0.424626851393530,-1.13201561232462,-0.556275332882385,-0.530315922069522,0.436595774664018,0.257328841118974,0.444582158761134,-5.231952781744324E-002,-1.157750234925616E-002,-6.545330646803675E-002,-9.130204750194992E-002,-4.748180206702922E-002,-2.310163332544690E-002,4.441411810695655E-002,4.258620956481450E-003,0.485201670617692,4.754794792795079E-002,0.178870239416448,0.149494677460872,0.179508611849676,0.131109831434752,6.619341557816677E-002,7.996397986985757E-002,3.078855561954732E-002,-0.120549638500511,-3.438307306355907E-002,5.438499339760011E-002,-4.544345456033001E-002,0.15928626880677],[-25546.5692196921,-862.613717424636,-382.870227385219,-2728.46947150217,1183.43126044218,581.376394472642,1297.76693102776,767.189644424330,94.9051471638086,-141.904043645435,-145.717341168324,655.194080331766,-378.959357030356,-1584.21331237493,-137.075290294220,113.434658760912,397.194761711061,-72.6108127790950,-491.293401836553,-142.460049462243,-174.699467045677,247.036046574583,61.0933844642631,-100.596949364750,87.6519015555427,-23.8544455470816,-43.7496746001446,199.316577227338,-19.9312213819492,83.8370367452596,-11.9979912369765,-21.6940979201754,3.89387540473403,-8.30216740587456,74.9099950053603,-8.79662321709753,37.2457389717991,10.4057035980469,18.6867621001145,11.4599698397921,-3.04550098096226,-11.2343043736114,-22.0924555669309,46.1499772958712,12.0888135657441,-17.4867700581270,3.09841917360655,-28.7589422891141,-2.28347536480744,2.25843792659991,0.982939068791150,8.98915058158491,-4.51940021989508,12.5492936828494,8.32666601681068,11.8809213979815,-3.65979235674357,0.380019578197216,-5.30841162708503,-2.63180090913535,-3.86754715333268,6.85464392427159,2.66206814166545,-0.194389894595087,1.668782697216449E-002,-1.10307396833951,1.06379894618257,3.15128402850454,4.17262263161115,-1.48378901383220,3.23897625683344,2.43949748681575,0.866876140750811,2.89443784600532,1.97415776015896,-0.549559159323727,-1.23897346619827,-1.60065440077817,-1.32271151666116,9.298486406863955E-002,-0.384292390517641,-0.222335905017379,0.134066429246332,0.126636213136611,-0.244125205588346,0.498036178057265,0.726150135094142,0.422915729933858,0.564012210752870,1.18146405441178,-8.291263455090296E-005,-0.495784141729759,-1.10048897754202,-0.571946243970608,-0.527909432763249,0.429206702362369,0.210234646297000,0.434693864074803,-8.314748615907849E-002,-5.670245509560377E-003,-4.590782146888232E-002,-9.477463697072376E-002,-4.998145263499253E-002,-2.651261177691344E-002,3.940199366165186E-002,-3.477954000655218E-003,0.481075301236155,4.548515242507323E-002,0.163830225225977,0.152051853028352,0.169035693245571,0.139010442084029,7.006855794553155E-002,7.422492542909076E-002,2.264971823028878E-002,-0.140275822208871,-4.094324378489628E-002,4.399219833721746E-002,-4.164984674142699E-002,0.15712029270098],[-25877.3398453686,-653.707492258992,-402.232340614995,-2509.69350525221,1263.99841118134,756.192416777491,1325.38024275081,695.640790632509,93.1306223523475,-120.520013772438,-190.268366087298,653.842801788894,-364.256961582914,-1579.54969392673,-115.031486461668,121.239450714764,378.280886492807,-87.5399562403781,-513.203722561881,-115.327059697410,-155.576587262763,252.607787378399,57.5134952105065,-105.525772861954,81.4871770818462,-33.9087432333035,-47.2767618850228,189.969063718632,-14.2352177697507,84.7815184415306,-10.4266514511155,-23.9651620794372,5.90768314868787,-10.5526522664738,78.8581988885216,-9.54684746781147,35.7961909380925,11.0870612813184,15.1243526502467,11.2304674617601,-4.25544492442492,-10.0215145816577,-21.8394337927041,47.4414163996454,9.60641976695229,-16.0752416398018,1.48669424277356,-28.7007096805711,-1.91439036775520,2.46166615245673,0.701239744794254,8.19451777036581,-4.14716156428046,11.9480867351895,8.59798130053558,11.5272600251683,-3.68522386730939,-0.660264358191797,-4.74729143203489,-3.11267302952108,-3.43491466188961,6.85659135023579,2.58624941588092,-0.132949842080111,-8.758141924080641E-003,-0.953597406201098,0.850977337452653,3.05238068852915,3.95850676911395,-1.55446093034654,3.05573923679682,2.38945309589318,0.633143876140910,3.04491361419687,1.82376359972435,-0.439647540778480,-1.32009605767376,-1.58056235327120,-1.37038861282474,6.490841034514847E-002,-0.339690950804123,-0.183124017362908,0.132793984313162,0.146033545205050,-0.255589326452649,0.416666785923677,0.729193986280138,0.396169615083857,0.566462690230833,1.11381734693968,1.710133169462527E-002,-0.557996735906669,-1.05354129792402,-0.594411861152970,-0.515887928162321,0.422182411670428,0.165441756367775,0.423851202151569,-0.110573703147218,-3.108963683479809E-003,-2.795109324308363E-002,-0.101904254467709,-5.117202195367749E-002,-2.735344431938622E-002,3.546181654360816E-002,-7.033104092616519E-003,0.470498018906076,4.499311342315890E-002,0.148848862885451,0.153790212184674,0.158343515260639,0.150603483073778,7.153744916056778E-002,6.908403835421591E-002,1.481171362603567E-002,-0.156993061967888,-4.749552158021009E-002,3.409983457111735E-002,-3.897795783769360E-002,0.15583316126697],[-26130.5457575749,-499.938747879738,-421.447685183751,-2342.59217609780,1302.16547186272,916.057610080707,1352.68059154687,650.671337724854,103.963012115835,-98.4916759676071,-219.434392507940,645.094321997413,-356.042821419194,-1562.09035861227,-112.104491719876,124.315694867905,353.982305653262,-107.255356691094,-527.959201095201,-90.7136210370123,-137.657373869510,254.489056369340,56.6872666436209,-114.647945110025,77.4624575023769,-43.4558611825418,-49.8147362949827,178.680676756307,-9.07805483641596,85.7449722549274,-9.65681728472956,-27.3449340403819,7.92528854968240,-12.8416526336679,81.6949914824871,-10.3438142418026,34.5554322365510,11.4215202808504,11.7043166731840,10.1525232431650,-5.48964154643551,-9.24025614984943,-21.6540241262200,48.0686278622247,7.31343365133484,-14.3064650931839,0.183826994664539,-28.4680363021259,-1.57568370191989,2.79571310892637,0.613563021673906,7.33844778304093,-3.76975891063230,11.2249300516146,8.58361463858745,11.0474480859659,-3.70343308284661,-1.73980072990299,-4.10985505062503,-3.43627778792682,-2.96683326269525,6.85803125013019,2.55990884877101,-0.129182727795288,-1.415019001377171E-002,-0.832905340392379,0.697139445953837,2.95628054982780,3.72238912290422,-1.60318841219869,2.83104598639575,2.30447760189031,0.425727229726339,3.20964021528645,1.67113893734267,-0.315837609246717,-1.38548400455257,-1.56410832461041,-1.39862419783603,5.717627043544601E-002,-0.313958070240953,-0.163676164330145,0.129603992957457,0.161062730596090,-0.266726238424349,0.334870515621666,0.733727749954604,0.369410984625411,0.567415803445559,1.04491566824205,3.722289304572248E-002,-0.599097987151144,-0.995989939355825,-0.612565829383461,-0.490669857070665,0.414866536547105,0.127538057002633,0.412081403297566,-0.132340774087195,9.052479589539872E-004,-1.647484833146991E-002,-0.111282278745423,-5.086800423841571E-002,-2.551089093513087E-002,3.173872692273916E-002,-4.216283735817428E-003,0.453477817863500,4.728894252718937E-002,0.133254261748737,0.154405936073762,0.149295838781369,0.163292075909038,7.327053652873644E-002,6.460390246738519E-002,9.149682886124446E-003,-0.169061885587369,-5.378874282700842E-002,2.573757258742980E-002,-3.786324234517205E-002,0.15463723238576],[-26290.1341887227,-418.276655120102,-432.931840771273,-2260.44312409556,1276.30333686362,1031.80683435618,1372.47818267615,617.089026924435,143.726716550785,-70.3287843947536,-223.432091670612,618.428019348281,-362.257367277523,-1533.08366811722,-137.747071841286,122.440203011083,329.149187886959,-128.308181039819,-535.429225440360,-71.1003929238627,-123.449279486457,250.417761359908,60.2600483243185,-128.336563478015,76.5593763205493,-51.3461662612714,-49.9352209225468,165.942014676208,-3.66481624241736,86.0990571827253,-10.7911941632805,-29.8819841509014,9.19448078191674,-15.1958690436082,83.0252101018503,-11.4934779612537,33.6952591282237,11.0656262451704,8.69814853225999,8.86197054860337,-6.81203941715470,-8.84039066304579,-21.0714229795374,47.5349788137519,5.68058237071491,-12.5457312299849,-0.801367869052299,-28.0099317759077,-1.33971859908626,3.12899647261214,0.739767941774371,6.47282542958570,-3.29213296242914,10.3557288469680,8.39020416981713,10.5659604443355,-3.80492924182951,-2.69102441030862,-3.53811405423236,-3.55264384798110,-2.49783266224129,6.85799114633806,2.57421475433951,-0.183960353015584,-8.968530961505159E-003,-0.798465147361401,0.628222736516812,2.89959807505363,3.47480045979688,-1.59057296180039,2.57793056070375,2.18511988610697,0.284158840003884,3.32153643612824,1.55033443541492,-0.179758851440804,-1.41562018596063,-1.54542000206407,-1.40757106352672,6.003477709177001E-002,-0.310074918424018,-0.169221883063131,0.124163848329208,0.163013334404917,-0.284447446282156,0.265059851716786,0.745907712314334,0.340102124725098,0.566891729990707,0.978986230380729,4.734947481783898E-002,-0.610054108772822,-0.936139457366884,-0.609767910357067,-0.449626077166658,0.406731771194270,0.100695159386451,0.398963825063287,-0.149117739050369,9.809819421935364E-003,-1.222407947233289E-002,-0.122088195027179,-4.869212685837258E-002,-2.147668287267776E-002,2.771419292631324E-002,5.585956822812436E-003,0.430139577909290,5.352668298568999E-002,0.116469429261930,0.151800354924608,0.143617458300559,0.173410582942710,7.900331262965012E-002,6.114132645497686E-002,7.424185972679649E-003,-0.174887755763313,-5.937816842290271E-002,2.007524738188928E-002,-3.797850249767416E-002,0.15261678302140],[-26387.7685085816,-357.345033053762,-473.289020664417,-2298.84073126667,1155.84957713317,1108.43858101946,1391.96560123519,587.727729914970,216.414012291980,-26.7583381930485,-209.098581317722,571.835040734264,-383.243576688951,-1502.23474573834,-186.816717162175,116.208260216414,305.428826471442,-148.305396424243,-536.593124584533,-59.7798338731508,-114.795504032146,239.963009019096,68.3417784803447,-146.332735993337,79.5529410860097,-56.8127002616426,-47.3884348013908,152.729882317519,2.52280243818422,84.9546785082778,-14.6667492945876,-30.6921250651461,9.53391850416614,-18.0554528442470,83.0261716730886,-13.2176758428652,33.0852020889690,9.79282872688405,6.26509470710261,7.50927860062331,-8.22814394413335,-8.73043111953171,-19.7849551465654,45.7567562876192,4.85912496163566,-11.1711213825207,-1.67984011246879,-27.4719091583499,-1.21843301616562,3.32333025678130,1.03065809430969,5.60663036799580,-2.67928034031026,9.32762610158966,8.11529524315639,10.2324589997477,-4.03350027813703,-3.43132154215640,-3.16002757341418,-3.49714602158764,-2.05300008428295,6.86256671749413,2.60115780576134,-0.287836776996850,-5.599443488743750E-003,-0.888854356506988,0.634905411219326,2.89617583477037,3.24548514257779,-1.49567572523565,2.31181090084940,2.04390470532609,0.216979308684947,3.33931053294927,1.46250943540712,-3.932299544584292E-002,-1.40458378060659,-1.53602666313268,-1.40618320291401,5.716546549537731E-002,-0.326008281756989,-0.202431711905681,0.122865686117738,0.142967211503656,-0.311253262154074,0.210310650205349,0.759475503875101,0.311977170673466,0.561741427586708,0.920542354410648,4.121183456988566E-002,-0.595616557674426,-0.881500063453297,-0.577498107322805,-0.394384854535272,0.399402357390929,8.409512212929383E-002,0.387039458114409,-0.164932394861228,2.485286886860875E-002,-1.287281862308835E-002,-0.133700495124604,-4.495426576125424E-002,-1.642714681943767E-002,2.316632825420193E-002,2.117312846785131E-002,0.402034694525667,6.363014247277758E-002,9.904111717203574E-002,0.144251161656171,0.139579527402562,0.179982109069672,9.037432378821822E-002,5.893349570372146E-002,1.001853964199853E-002,-0.175124059160317,-6.450150816574297E-002,1.741242838900768E-002,-3.853127468890240E-002,0.14941514907690],[-26361.7268143711,-208.811487087766,-526.962430208244,-2412.52831049153,970.656518459626,1184.53417366126,1417.22794673276,575.277957557386,309.486831475145,50.2716773778601,-188.100248583049,526.329929494134,-399.340458112913,-1472.88593549897,-240.500148126037,105.506093494357,283.589865715745,-163.878131205795,-532.204656119521,-55.1731431641853,-113.186309811304,226.069259209517,78.6529655899995,-164.815312668506,85.3357105294614,-59.9098810681212,-43.7665965442950,140.773678203986,9.99817819851863,82.2891938356246,-20.2405125800452,-30.2001033238113,9.80204145322111,-21.8333260573230,82.3112783643299,-15.4907509174476,32.1462319368020,7.69362308178315,4.34078360886563,5.94171381378091,-9.70309708151350,-8.65242008518216,-17.9974477039952,43.4082005466250,4.49556306149554,-10.0798207205341,-2.75314902661472,-26.9860966196706,-1.14646151150981,3.24271374999348,1.31360120959836,4.71242051326576,-2.00811091623797,8.16667859295868,7.85676625225056,10.0988521954490,-4.33052017649325,-4.01017844278617,-3.02565273955000,-3.42101458429811,-1.68063926344058,6.84000792361424,2.60112356410419,-0.406565022878324,-2.552604343411619E-002,-1.10151029166226,0.659984579899789,2.90724192356437,3.06511129002941,-1.33226966984577,2.05055467307339,1.91017003376144,0.191422810140818,3.28353124513705,1.37091216397274,9.085932495866852E-002,-1.36552148793994,-1.55733794120517,-1.40505388170211,3.205713237602992E-002,-0.346112182965334,-0.255107021655716,0.128830229341013,9.754509759302622E-002,-0.348202004286435,0.161868699421275,0.762826794803430,0.288867224224762,0.551075633772496,0.871020381208881,2.158789886784745E-002,-0.572608669572222,-0.841321532682180,-0.526805975184764,-0.338809503604697,0.390685466754588,6.804336516550825E-002,0.378228055523209,-0.184077903415657,4.506510812849115E-002,-1.271727291418265E-002,-0.145428415074291,-4.176861696821984E-002,-1.385289110259794E-002,1.839439909530403E-002,3.767671538795914E-002,0.371959182283752,7.650077508477206E-002,8.217594194404057E-002,0.132460188530488,0.134422290424583,0.183091064271949,0.106376211803456,5.569964076275612E-002,1.604433718855080E-002,-0.174427871088486,-6.897803824359852E-002,1.530247056995247E-002,-3.845975710456494E-002,0.14466619372609],[-26186.5971991239,-79.2998525892565,-635.051981326924,-2543.29235911856,747.638097869779,1290.61667366940,1438.15701248752,591.467975363011,406.601183443003,149.071068894022,-170.911386168107,503.735796270351,-391.496188880289,-1439.86278375437,-275.628283543592,91.0352281143583,262.181187186609,-171.350107903507,-528.559751566171,-52.1613162534263,-120.159808884512,211.062753339438,88.8653812893049,-177.762027319812,92.7847969474603,-61.2912624166255,-40.9325004463320,130.764795786664,18.2319518301505,78.1196500765327,-25.2469803334255,-29.9235774169898,11.8802419403478,-26.2825897602238,81.8844740335635,-17.7522404590408,30.7095375222625,5.15053831305564,2.46320319355398,4.13097736928727,-11.5456729071649,-8.59019046306354,-16.3963471169914,41.5038728594882,4.05563340673907,-8.74478527473486,-4.22416982458642,-26.5332966715659,-0.995996933578352,2.91073198845539,1.43853317379360,3.82726814629982,-1.42365357667094,6.88193136882352,7.67464936407378,9.99039488218584,-4.59890194189524,-4.52068711572203,-3.09270120253123,-3.47995889819681,-1.40624608145685,6.73110441786020,2.56867514732870,-0.502805771930956,-5.869020469217387E-002,-1.40697565371184,0.660568110059808,2.89526008476035,2.93797635350106,-1.14822189683066,1.80352072648026,1.80543589445792,0.159706487936614,3.21194414982169,1.22229272800189,0.190820587100191,-1.33609466118925,-1.61896541665421,-1.41603488342282,-1.678184831160354E-002,-0.355296997322620,-0.311369502927013,0.137917421334323,3.771617598111544E-002,-0.393167335880329,0.112707831140722,0.755460888570963,0.266082400640241,0.534008098266438,0.830594310130361,-7.945823335436827E-003,-0.556160215836865,-0.826003677903945,-0.484096832988863,-0.300646623868779,0.373146730377298,4.098855702450899E-002,0.371784020561124,-0.208097521914779,6.751105900373844E-002,-7.589964661977564E-003,-0.157796085946394,-4.093237865867044E-002,-1.642700831116148E-002,1.448827444763932E-002,5.005009203378054E-002,0.344467605457600,9.127550958793722E-002,6.740235159155794E-002,0.119098011073176,0.127435084743284,0.180668212550980,0.122913753679943,4.764527962500394E-002,2.263438375034601E-002,-0.177810918918153,-7.281737209309831E-002,1.046811923557916E-002,-3.734745002041273E-002,0.13832583266564],[-26023.5918864084,-43.9215174114433,-864.392713755371,-2638.68089401785,445.217522048861,1447.20590414744,1450.60937364460,608.248610148705,486.567341816654,258.607170583398,-165.385015165959,510.170470802076,-348.341504141427,-1400.47405874002,-286.487751152344,73.8305966501123,235.775020009148,-167.079356965520,-531.509944224885,-50.3879381946816,-134.932872733634,195.804481967643,97.9581353749293,-182.610885198345,101.120448974634,-60.9267700377648,-40.3013487272401,122.390411193999,27.2262154347377,72.2741398242437,-28.9960795599698,-30.9823651563414,16.7391691362916,-30.3796834457114,82.5253277015864,-19.5115488465438,28.8980911792284,2.83662177639620,0.295256740406650,1.74978371400938,-13.8952352963381,-8.65799946397673,-15.7769798430757,40.7868759383679,3.40182764722841,-6.81492544649549,-5.97874560951848,-26.0847593350749,-0.647101859125297,2.52275263526946,1.38118126522776,3.03245375249341,-0.944063616323529,5.43577249301474,7.47171526647790,9.75959151441974,-4.81284063439936,-4.99459142247391,-3.26566928526021,-3.71154492903735,-1.22967966907606,6.53601516995348,2.55647663848263,-0.576470833606649,-7.344669712141011E-002,-1.75175729933247,0.637351557533604,2.83742178277510,2.88019281086030,-0.985436902880885,1.55018691913890,1.73169610982797,0.100686965693290,3.17204624304067,1.00754230496432,0.251216937284788,-1.34454804411726,-1.70615972834497,-1.44608884840330,-7.069546078446641E-002,-0.348143534689065,-0.361687389640434,0.150388421749418,-1.706823706986543E-002,-0.431806856017158,5.402632490460138E-002,0.737889399019072,0.242316418922432,0.503493126342087,0.801301073166453,-4.121732623091399E-002,-0.552353832202567,-0.843389808750244,-0.470425293430358,-0.286394012830462,0.343653651769509,3.230827408316702E-003,0.366020050235954,-0.233310255266995,8.692185101924541E-002,3.009806053511893E-003,-0.172318642212356,-4.199630247865400E-002,-2.387992262090551E-002,1.496551260706542E-002,5.775705824612857E-002,0.321474652065463,0.106683040522573,5.587381344618741E-002,0.104466892771732,0.120747946589583,0.171711185566354,0.135771730116471,3.453356923872712E-002,2.731517366882722E-002,-0.186117190712161,-7.680058285877230E-002,2.516250838002078E-003,-3.614812505093032E-002,0.13169616692979],[-26016.6846920484,11.6045650674511,-1193.48703526152,-2659.25455017529,47.7789881206259,1661.55365618438,1485.53569479183,582.099710573835,533.682653167213,391.198487183222,-172.272012169009,541.314820275119,-275.367886227030,-1354.35067327804,-278.183266853039,54.1163339783044,199.419149025687,-151.929398436366,-540.116802653772,-52.5214010135976,-152.391343137850,181.584689441885,107.444632613677,-182.319057603594,109.009606678252,-58.9020996914379,-42.4538786509950,114.934428553275,37.6368660530763,65.6671900198519,-31.8971218581300,-33.1830472677030,23.8889259163924,-33.2178185868703,84.4631161095050,-20.7716328187694,26.6261378457290,1.17959320653582,-2.15816590423343,-1.57794024608988,-16.4614429913066,-8.72633768179517,-16.1977832941471,41.3220292791898,2.74700437266781,-4.30873835042987,-7.78428971879367,-25.6319402401035,-7.211910567415510E-002,2.24702348688077,1.21952254090562,2.28875420901802,-0.477753829302680,3.82128355903038,7.09588850480340,9.44670577871236,-5.00867963748104,-5.41242176111857,-3.45560375809005,-4.00129685489698,-1.06436962831408,6.31752933788341,2.62482523631740,-0.639500922510238,-4.835970720353749E-002,-2.06673499657822,0.605506065605796,2.72107741586388,2.89758589334216,-0.857180456397345,1.26834294206320,1.67263706489615,2.426481879393034E-002,3.18844708912015,0.768480553119696,0.296496055974574,-1.39096408538317,-1.79383809863041,-1.49989791857080,-0.107365413348136,-0.326918313706924,-0.401553575346721,0.173669251549011,-5.467006265745885E-002,-0.448982018753233,-2.405043125265533E-002,0.702299915762668,0.223932019818407,0.452590811361329,0.783551295261234,-7.246696823109995E-002,-0.555267278521404,-0.884628251222603,-0.488036397931071,-0.285770478602315,0.305204314911993,-3.658866093618602E-002,0.360144192333811,-0.256070697384503,9.905950834435968E-002,1.829645657219737E-002,-0.188416514374547,-4.244235379513449E-002,-3.353905090499283E-002,2.198527802405258E-002,6.349622634249014E-002,0.300908031967414,0.119663970918221,4.789137655905235E-002,8.645670426171460E-002,0.116778019932518,0.159478705025355,0.144481739427981,1.956355556890885E-002,2.876668856183328E-002,-0.196059016440517,-8.258633804125123E-002,-5.823076634438312E-003,-3.608957770152388E-002,0.12642722592999],[-26011.0800057667,119.158406744294,-1486.17370955875,-2636.44811536766,-386.309298868689,1859.99507077020,1582.74709363972,507.577013679110,560.093121849676,542.977159711641,-165.428647767384,581.877838937866,-197.916625460711,-1295.22935470761,-258.111792339085,30.1846991261348,155.933556898290,-134.638451665895,-547.749402335390,-56.1317131471878,-166.960108116178,170.820989813880,120.154275611377,-181.373306462709,115.046572682139,-56.3455651266459,-45.1714617660414,106.495165966453,48.8427791200366,60.6717469105746,-33.7631202305948,-35.3595316756003,32.2555438990660,-34.8348025101543,87.2031803981772,-21.6527733152655,24.0118642498142,-5.190018969827635E-002,-4.57588337782881,-5.29906578869970,-19.0704715864972,-8.46880898586980,-16.9944131846583,42.4083488021724,2.29280151413069,-1.39661151582003,-9.50435989559974,-25.0504485476634,0.588584780528467,2.12024871248877,1.13226166627802,1.43765499857162,-3.637476874608695E-002,2.17346140039092,6.47851582489915,9.13669444288624,-5.19165180908584,-5.78438298755057,-3.61845110523563,-4.24046265106397,-0.778523633927625,6.09691547733586,2.78834034272444,-0.676823572608351,2.468739466197755E-002,-2.30537402152079,0.603977509448135,2.58114817256668,2.92363961261191,-0.754074018957369,0.963607849931326,1.57784445787864,-5.397132632415799E-002,3.24815865227652,0.530020455517359,0.374531301760917,-1.46727755619580,-1.86152655992105,-1.57578993903918,-0.122861694363013,-0.303927648556049,-0.428090096517996,0.209676978766458,-7.640779830404967E-002,-0.446254252456388,-0.112483997322019,0.642281049855466,0.212281226074450,0.384366101586766,0.767430315424575,-0.107605779569105,-0.557284090878960,-0.928599323007301,-0.528084851374309,-0.282094370913308,0.259086447530061,-7.238928103968160E-002,0.352831890965457,-0.276034637448755,0.105150943697582,3.510594850707457E-002,-0.201887382138843,-3.865752769366779E-002,-4.082617820105652E-002,3.136385601699609E-002,6.969892024994601E-002,0.280449297830191,0.124828462670372,4.326421082145571E-002,6.331132917704863E-002,0.114315775966334,0.147746835204989,0.149635661541795,5.709436772528359E-003,2.638122085037901E-002,-0.204389098706215,-9.134585357782092E-002,-1.281647900644300E-002,-3.770121691998583E-002,0.12229332648744],[-25884.7072982776,249.986947458352,-1705.26026172193,-2613.14080243586,-798.726593117561,1970.80634441869,1744.78732975867,409.149352600367,586.632787907951,695.698359624268,-124.541444199382,611.356287082991,-143.442915614580,-1224.09301201681,-237.262892499056,-0.451737425415148,112.604518903319,-121.211742526884,-549.885792948974,-59.9790253869323,-175.225659121713,163.245867403897,137.817731578827,-183.618011365789,118.569479931447,-53.6333018725015,-45.2366471813951,96.2541206410315,60.1058912341346,58.7789534260859,-34.6593787991989,-36.5994561603399,40.0677025018039,-36.0537118349940,89.7732436493103,-22.5928604670679,21.4326080682747,-1.07347131320958,-6.52129403916044,-8.57473953557333,-21.4150275427651,-7.82541873408109,-17.3837275771466,42.9580686836135,2.17430281504681,1.47383786593834,-11.0798757391543,-24.3086644347770,1.16545345568814,2.06170174280173,1.32937903260359,0.475206220245098,0.394954070385765,0.656934670545729,5.66627681718760,8.90545014736200,-5.42538759334526,-6.10166423309564,-3.80066723912677,-4.36628132913755,-0.320566756895425,5.86296166389292,3.01933127300988,-0.686078525504483,0.129220321821358,-2.46612962220559,0.675883323959580,2.46449498590447,2.91247741216212,-0.659762699864883,0.664034492304193,1.41397227548514,-0.116718131338415,3.29488253571487,0.303167969226417,0.500617488901942,-1.56147709174936,-1.90612567655133,-1.66483403192288,-0.129649550705337,-0.289151892161027,-0.448024425440355,0.256991881072561,-8.925772115353674E-002,-0.432698700517992,-0.194292741018771,0.563551140238218,0.207005681510719,0.303694284673564,0.744427322180067,-0.158149316481498,-0.552965986626977,-0.960844169081653,-0.574837830408599,-0.263216051300737,0.208950137114845,-0.101441740317536,0.344265794542111,-0.295207080812805,0.109850372772127,4.878384625675516E-002,-0.210170411933283,-2.890693044762224E-002,-4.117319378469276E-002,3.894926387460114E-002,7.730374226547465E-002,0.258777562510091,0.120413920808515,4.049890282918582E-002,3.393677843903987E-002,0.111285455163029,0.137102005958960,0.152524569183130,-5.470303245160498E-003,2.144989500504649E-002,-0.209148937519526,-0.103004780063415,-1.823878734626707E-002,-4.085556064729598E-002,0.11817900837472],[-25761.1375895986,392.236832762270,-1824.75192913641,-2572.76488028033,-1162.26101729779,1970.09489789738,1943.55065742944,332.392653067995,614.694889838673,828.084761150506,-54.3831528543363,612.996089201787,-124.184765135446,-1151.08909076666,-222.907031435240,-35.7081775853541,73.6062890480968,-111.764265546882,-546.412089698659,-64.4999923784217,-177.585881396746,158.112055440668,158.891163036079,-191.345250279929,119.034036038623,-50.4527170157116,-41.4364509482774,84.6535854166036,71.1492293172915,59.9561774366116,-34.5032179552203,-36.9669397115975,45.3675699085386,-37.5626378067513,91.0411760364250,-23.9289547312063,19.0895096079354,-1.61875685205572,-7.78405268121289,-10.9520020922832,-23.0500179429521,-6.79928364067931,-16.9121629010810,42.1089894719831,2.45608446277251,3.71439820864448,-12.4394999269981,-23.5182296420451,1.57346096557949,2.00855590468415,1.86500028447246,-0.464542751026812,0.912700531809003,-0.571556438978547,4.80364002804049,8.81605383049660,-5.78048753565312,-6.32973339838988,-4.10579062781670,-4.34414528883705,0.245224197405895,5.61920937760877,3.26299541786868,-0.678066881835941,0.230805221965791,-2.54638577544844,0.824785160142508,2.38253124058771,2.87678835515036,-0.561338859788522,0.415792813439566,1.18937622137939,-0.144869376981404,3.26870418480573,0.102648020662183,0.649924428475182,-1.65007048738526,-1.93919420180224,-1.74832391668863,-0.140731983556297,-0.279684936519473,-0.465569409804926,0.306715998415564,-9.507872720828622E-002,-0.411991830058173,-0.258779159173513,0.479767005829224,0.213729086381611,0.218281200836613,0.713937774583741,-0.230097713023704,-0.539808340463129,-0.975996269378508,-0.611651115458119,-0.228213585634490,0.163722499061804,-0.123459404623819,0.336174879088481,-0.313335385772566,0.116614192337587,5.657782235402344E-002,-0.213555294422472,-1.478533457326132E-002,-3.395848921675736E-002,4.405437088813428E-002,8.577861456042271E-002,0.236123109415693,0.108939014954933,3.826136182032001E-002,-8.144485891786622E-004,0.106841696146527,0.127078551207781,0.155177303509657,-1.431872718440997E-002,1.737762265259734E-002,-0.209921255143818,-0.115775852481380,-2.152839691887589E-002,-4.484129432207525E-002,0.11363414540295],[-25621.2830829004,486.976043458296,-1813.20977212025,-2506.37389340899,-1440.86524995763,1846.03444123692,2142.22982905614,301.525434304939,646.356144045906,918.865023885490,33.4560266136007,574.458206901885,-136.414975694910,-1086.94498317387,-211.049428535768,-73.5416984445739,42.0336028623931,-106.027644201350,-539.494329440220,-67.1238440958849,-176.812811064371,155.197243547741,179.221627679188,-204.489714493629,115.922633079318,-46.9293701324522,-33.3190707254833,72.1044075906527,81.1190464391485,63.0256389264955,-32.2256379652610,-36.8471285805285,47.4201578034491,-39.2587022924981,90.1634785766537,-25.6137948085714,17.1453348829608,-1.59660784100017,-8.31916982362180,-11.9225792929106,-23.7873630695271,-5.18538709547901,-15.5386009690117,39.6381921959461,3.00443102623286,4.86140384381801,-13.5267679411666,-22.7779645893228,1.76958525549948,1.87909921677996,2.70124645904476,-1.26644055013270,1.49888113534068,-1.36422675295130,4.08046981175797,8.84703022385327,-6.18946018239281,-6.42785778637199,-4.57973645904816,-4.17063049542238,0.793597623432333,5.37588204376094,3.44519039344788,-0.639727720724094,0.304455415553585,-2.55590284908587,1.03407453823655,2.33733071724347,2.82234719250199,-0.448529869129168,0.266026457748958,0.945196531545813,-0.136041593170307,3.13655472921798,-7.221514124209155E-002,0.783271988014102,-1.71426587468028,-1.96412272174556,-1.80261996252026,-0.160875707741394,-0.268246940224406,-0.478099860654072,0.344825602933673,-9.704900948621834E-002,-0.391022304512170,-0.293957872750282,0.402331798558083,0.234249118759895,0.142804324993118,0.675419531151266,-0.318377293369405,-0.521274793914066,-0.972137524529201,-0.628330494855557,-0.185332901126716,0.131619041785555,-0.141463836723908,0.329238349990265,-0.328309134975493,0.127864549082069,5.838052921988050E-002,-0.212808310109435,1.149350712263824E-003,-2.108320034798695E-002,4.473879739217774E-002,9.245896476676305E-002,0.214649942216363,9.326889510621574E-002,3.633823966361509E-002,-3.629120673032478E-002,9.966488814756637E-002,0.117185986749999,0.157172538856647,-2.153519275647760E-002,1.672701351097898E-002,-0.207182271577206,-0.126543064845697,-2.212716356307156E-002,-4.836345768420669E-002,0.10862169169927],[-25549.5810340252,568.444022081935,-1732.96936216480,-2380.60890605681,-1640.16466758105,1651.92313720604,2312.07358694221,295.625155613622,670.251379253394,972.475271743835,111.064887094288,501.727587698570,-158.828337358213,-1037.65200428947,-190.837847212518,-111.201212763470,16.1721938228896,-99.5734747054441,-532.138127823222,-67.4252136737381,-173.078831660599,153.589518993287,194.794678822718,-220.746530911298,108.869533321397,-42.6288286734655,-22.5609920837615,59.7659627912407,90.3007400675385,66.4022032018461,-27.3218029134042,-36.4525372361169,46.4262977651315,-40.5761831209539,87.1353716177734,-27.5145120085078,15.4111517308060,-0.868939277864486,-8.27505112410620,-11.6706473475561,-23.3676364355954,-2.83314342219751,-13.5057551612954,36.0278582451777,3.48579682057176,4.87340532258294,-14.3700491307749,-22.1042160434601,1.82395618853046,1.63705836349289,3.65056773709265,-1.83917992688229,2.16990787755716,-1.74266872956187,3.59590355372210,8.95696740887396,-6.57437865563617,-6.38426402162248,-5.16359595563094,-3.88108019273843,1.24874169804651,5.13731174384767,3.51121747943482,-0.570080312334358,0.331504481841497,-2.50652625725510,1.25352637486081,2.28389741595675,2.77860183882942,-0.317339517780689,0.217772265183784,0.734724657978090,-0.112066317694135,2.91036388833386,-0.228268304420652,0.878222477908154,-1.74516591336078,-1.97124979724766,-1.81679779349469,-0.184573157440866,-0.241069870070646,-0.483311155938997,0.364852033978870,-9.602686905997565E-002,-0.370483799720823,-0.307348683988120,0.332348482224436,0.269194501729040,8.307804511137314E-002,0.628889381118664,-0.406211849364010,-0.504891432633168,-0.947519293829176,-0.625217795411238,-0.142534136238827,0.114258248536034,-0.158924071888202,0.322303737883712,-0.339200786551083,0.142047245125587,5.763356602228443E-002,-0.210031520565970,1.526721509753593E-002,-7.298067195242479E-003,4.245929689152250E-002,9.458275474873648E-002,0.194824445522202,7.731489843249202E-002,3.404581976786599E-002,-6.841250415315590E-002,8.906447328410481E-002,0.108165099864847,0.157417974634600,-2.662532873378122E-002,1.927132726019710E-002,-0.201429635986793,-0.133494043686498,-2.043761134438396E-002,-5.030453239062693E-002,0.10325549964335],[-25535.9325760903,670.851735352603,-1623.80972834618,-2206.77022952437,-1785.11787136705,1464.45070552742,2444.32579577078,287.793169245665,676.361778642790,1001.71624438693,162.603702548051,418.404680447586,-176.011014690869,-1001.07370820510,-152.155309929916,-145.150955882762,-4.69918999867165,-90.3410676650834,-524.481955156963,-64.1729294380875,-164.836909279959,152.336194473909,203.510341726767,-236.862276963276,98.4833421914253,-37.4815425118781,-10.6454218652340,49.0586705250400,98.6205367392795,69.4554937952820,-20.4153371736094,-36.3785774272625,42.9405570409648,-40.9499553530695,82.5560937470604,-29.3210330606481,13.7564174971061,0.479007377716564,-7.56566479049461,-10.6430019419878,-21.7206622462814,7.526921630586830E-002,-11.1591266683424,32.0365889177100,3.58983918816838,4.08784901803047,-14.9999093119119,-21.4478810468638,1.81012229741529,1.32323404522707,4.49823256261390,-2.16389076162914,2.88737456772888,-1.73088507646430,3.34530661038999,9.08307621771137,-6.86999454283359,-6.25095574869449,-5.77122232083464,-3.54182466509150,1.60671138685575,4.90388479377147,3.45299160813832,-0.467149827484430,0.306679782420354,-2.40965913162552,1.43843130200004,2.19962514517979,2.76473390880440,-0.170750278065455,0.245890216099731,0.576628518864675,-0.101008111812861,2.63806809610460,-0.368832848310482,0.927919538709092,-1.73675361729773,-1.95688256298198,-1.79185725735425,-0.201737914795745,-0.194454196934971,-0.481318718781663,0.366973139253541,-9.303014888666446E-002,-0.350101529347422,-0.308697227299023,0.264749643511140,0.316847924524213,4.188962087382681E-002,0.577632861912854,-0.476267989018965,-0.494219307572534,-0.901852321637932,-0.610478779528062,-0.105788307808891,0.108578457369044,-0.178038671817272,0.314065421173625,-0.344965506529721,0.155378277776290,5.824421460044416E-002,-0.206610963514161,2.514263657185021E-002,2.896191902223020E-003,3.916279539146155E-002,9.211827538334411E-002,0.177240055957203,6.352938270793729E-002,3.144573800995747E-002,-9.379222629745804E-002,7.524904813983228E-002,0.101963780761734,0.155832755975353,-2.955453582560408E-002,2.346142390755134E-002,-0.194272249815379,-0.136404945464490,-1.790825664610441E-002,-5.027531221054237E-002,9.784980407285661E-00],[-25537.4873537524,802.667560493839,-1502.68995155778,-1996.89526111932,-1881.86472053723,1319.51460550557,2549.31738380415,277.749604241558,656.231240822219,1009.23105071437,184.146279842719,344.500374447415,-187.265148776986,-972.658559202621,-91.6754896703084,-171.719446747391,-19.4734840031010,-79.6501637511818,-518.910181711809,-56.9378272965628,-150.929625279129,151.819792769581,206.120060351769,-249.485742003295,85.9039385039451,-31.8501947031936,1.14378722110835,40.5148950309280,105.237592913247,72.4738467934238,-12.2546593660488,-37.3579125790220,38.1587512871118,-40.5102174538562,77.8178603310506,-30.6292925929656,12.3019992576615,2.46866759715036,-6.30878959980997,-9.24421022995454,-19.3325682110698,3.12601442316971,-8.86443647758019,28.4434033270754,3.13375789274664,2.98381392424754,-15.4841370770071,-20.8244260417302,1.76001855324465,1.05552284195577,5.11915031689372,-2.24856697183059,3.54980082980238,-1.39141652571531,3.29295217789126,9.18808255540288,-7.06450519954031,-6.13163017508035,-6.33836609371536,-3.24632738932524,1.93530349482406,4.68369053640661,3.32263307587601,-0.336908570060360,0.243583203059641,-2.25987717045499,1.57897746831246,2.09693792791961,2.77473485036617,-3.320527003137491E-002,0.323904710212068,0.458983910380236,-0.133640918722509,2.37850213077087,-0.497666806584583,0.948629313520919,-1.70248563788101,-1.92718841098942,-1.74911333542944,-0.211933761530477,-0.135837527967900,-0.471163900975339,0.354168611248406,-8.090307223405362E-002,-0.326639124888833,-0.304689013443810,0.198403016638310,0.369444895855287,1.800796171389152E-002,0.524963309893348,-0.525605493792248,-0.493121832617236,-0.840257354876983,-0.595983618026900,-7.763186893245091E-002,0.110302175479469,-0.200170822813684,0.305944736997530,-0.347053165207702,0.163915052875583,6.112320543297964E-002,-0.203105427855894,3.049481562506201E-002,7.842346928861450E-003,3.669820149867027E-002,8.594947583094981E-002,0.163596679561040,5.194607628716453E-002,2.874909065039967E-002,-0.111517919949638,5.920081652556627E-002,0.100429212770986,0.153593766476684,-2.997935348519304E-002,2.714210849808949E-002,-0.188492337836600,-0.136837927237225,-1.618393901730085E-002,-4.876964082246563E-002,9.309540461809157E-00],[-25573.1656507998,913.745789020359,-1380.53331195881,-1748.46751758766,-1922.67152784884,1204.55364604950,2644.92000033828,267.577350061919,602.712250392832,989.516841384129,177.155011095777,283.643013076311,-204.334849413727,-949.344419684982,-18.8731388993847,-188.453128432682,-26.0992436900882,-70.1764419487093,-519.893430151950,-45.7363900141891,-130.730028576157,152.008818609488,205.646011122634,-257.529388906725,71.7681511243806,-26.5274054065322,11.6640273220809,33.7189096212967,109.430633442956,75.8208106724910,-3.58220492181032,-39.4439978933852,33.2517427527042,-39.4101344799589,74.5465031020854,-31.2322367764162,11.2266035427160,5.16391694244537,-4.92648968381792,-7.66003549202243,-16.9742655743474,6.02263719131251,-6.81379860581355,25.7543160640455,2.24466556261934,1.89106574856852,-15.8113758365062,-20.2510277745126,1.69137250106956,0.925593685335561,5.46083547019248,-2.12088426436956,4.06876983736380,-0.829387194676893,3.46099838184206,9.26405734624801,-7.17956650890850,-6.10192002440217,-6.80349879807580,-3.02666468852976,2.34042824098653,4.52040972706757,3.20795518751569,-0.185579216694635,0.154339587958367,-2.04179218342707,1.67818470109944,1.99451719673138,2.78208347122578,5.924258389573863E-002,0.433597120698461,0.368597467934979,-0.222447108958438,2.17580959971423,-0.602453739728946,0.970770825524552,-1.66349759599898,-1.87983804363216,-1.71716922411158,-0.212703269511815,-7.398100500421843E-002,-0.447786742473901,0.329232726883205,-4.965212729505183E-002,-0.299542466773229,-0.299058082554964,0.137826518533560,0.417706709328838,1.031381870493721E-002,0.472239788459201,-0.559973656206477,-0.505222324467228,-0.768452001725038,-0.587741520839644,-5.449067945267915E-002,0.116500561656580,-0.222618601546410,0.299621858111479,-0.347269460308990,0.165784270168782,6.591331504199043E-002,-0.199470155728548,3.213518589292114E-002,8.581967047181985E-003,3.616289412746547E-002,7.585431367360344E-002,0.156058699967024,4.135745909585645E-002,2.517751474888698E-002,-0.121980856764177,4.226891838177862E-002,0.104574102442199,0.152375095967426,-2.706435021227991E-002,2.796231148525499E-002,-0.185837909973367,-0.137291779945797,-1.520176366416070E-002,-4.682489052736463E-002,9.024167655498465E-00],[-25612.1443082013,911.520324521460,-1254.99379903960,-1479.66771012522,-1895.06743468417,1081.82077284063,2726.70241701329,252.723784486675,521.928656828213,940.299128800021,154.116869400456,227.782269979166,-239.023961976731,-931.439613569096,44.4041333207432,-198.287928818998,-20.8953241217032,-65.4113127111865,-527.090828159251,-29.2823819388329,-105.114270270943,151.606636136588,204.729628275839,-262.911694824193,56.1520409714035,-22.4991101613305,20.9490838422784,28.2837881680605,111.077721757119,79.6526285047267,5.16411771471764,-42.1244997676581,28.3821221911591,-37.6221227119199,73.1989450865229,-31.2683873510575,10.5696216239485,8.26744189575508,-3.60056692812491,-5.76357786086452,-15.0620603678004,8.73231358162689,-5.01063066267160,23.9551712401118,1.27368876544189,0.869891828412825,-15.8094787630187,-19.7050951889507,1.58955098082507,0.886244940648784,5.58130775865778,-1.83124786083019,4.34935440907471,-8.096619722316432E-002,3.88296252877101,9.30717812597651,-7.19899785386087,-6.16527332011606,-7.10924635839262,-2.84273807869952,2.87340411395109,4.45540319996966,3.17329568110678,-7.022229535813338E-003,4.366894689571794E-002,-1.76147481596806,1.74679135953999,1.90998596721502,2.76239410969519,8.766193872073536E-002,0.569051500938667,0.301107748412127,-0.360806986756422,2.04185123762061,-0.667097873823241,1.01707249818731,-1.62253217239917,-1.80524722702569,-1.70580612682083,-0.199074842423747,-1.577489997573725E-002,-0.409759184082371,0.297256758659083,-1.594909993593912E-003,-0.275169498716693,-0.285662195072746,8.438007778802402E-002,0.457114792759861,1.879265362141542E-002,0.417725103653026,-0.582271522832310,-0.530218882437407,-0.687778253229706,-0.581653939849527,-2.987125350169512E-002,0.125948568183799,-0.238082528447447,0.294395317577483,-0.344183530263842,0.162561936856409,7.173383595090345E-002,-0.194287451446247,3.142616820900775E-002,8.380059287100658E-003,3.612460048131150E-002,6.073432734087592E-002,0.156570135621667,3.000289420018072E-002,1.990013016598557E-002,-0.125034810351276,2.438449542055965E-002,0.114337133055597,0.152436582911154,-2.019243430968753E-002,2.511339202386589E-002,-0.185277561462857,-0.139403863289804,-1.354239618377341E-002,-4.566187737911313E-002,8.983502777378126E-00],[-25727.7572294094,858.704794081334,-1108.30156666827,-1219.13064577933,-1808.34242703306,931.797582650646,2792.52491603988,219.977753449874,422.560679208212,873.914668762689,127.696328497152,170.920575862249,-282.143171799552,-919.969604158108,78.5562037280272,-207.536193222792,-6.69119950758855,-66.6309851665752,-534.216410098647,-8.83516584822001,-75.6838252663488,150.352503862315,203.215883192665,-267.387751770814,39.3813498034232,-20.3106943549368,28.7964146078265,23.9025601422390,111.108130002175,83.5233733626097,13.7789938882919,-44.8310645462445,23.4907579990740,-35.3460587747412,73.3269903592030,-30.9241764741791,9.98830761742247,11.3298701843546,-2.36480681649420,-3.74048696865739,-13.4537938902809,11.4230614484757,-3.63611198643680,22.7982188596676,0.356092118290107,-2.224254694015119E-002,-15.3457712316439,-19.1066473880522,1.49740786504688,0.835311050356807,5.59704502174588,-1.47087161210526,4.37045918999495,0.768293393900594,4.43198114519867,9.31184285221361,-7.09775969747279,-6.30996527012442,-7.16143042881188,-2.66065898481074,3.50624183905325,4.47907920713280,3.22078769577794,0.191728665858040,-7.419274365894282E-002,-1.44451739509099,1.78944673081866,1.82324148911425,2.72006312431229,6.003676168383881E-002,0.711235877749092,0.257376085525515,-0.537936876604427,1.96720966262573,-0.696965889303236,1.10283783142212,-1.57632409886611,-1.69812387094331,-1.70731080173628,-0.171700828127484,3.788000868453067E-002,-0.361079073194675,0.267263316971866,5.041865834691695E-002,-0.255245288906254,-0.263898112261270,3.217684958494354E-002,0.490749650718998,3.510175347261145E-002,0.357167347459800,-0.587578242412840,-0.566076835230317,-0.596077762771334,-0.571798658496283,-1.519231332461063E-003,0.136328284796990,-0.242761354944315,0.287606386771268,-0.335909621350068,0.156216993374013,7.793503897176539E-002,-0.186627072169203,2.944455679859002E-002,1.013138679356499E-002,3.549671983302808E-002,4.091845348275152E-002,0.163121415507007,1.694758551397960E-002,1.332502194510760E-002,-0.122057029896502,5.570261660653011E-003,0.129681923625432,0.151997058630322,-9.260474924865770E-003,1.919407892285250E-002,-0.184771810774416,-0.143061443457396,-1.058161277944138E-002,-4.597147394364416E-002,9.107946997694889E-00],[-25909.2222590377,832.363705043791,-920.396074392356,-1021.36199293942,-1671.53899965467,739.496354964316,2869.45705337902,186.647821746879,323.606243047250,793.076508949037,114.945852290705,114.996296910121,-327.617811018666,-910.445495142385,79.2867947726981,-215.965857830942,12.7219262262021,-76.4555947088732,-533.040346494226,15.6503532800353,-43.3945963715319,148.714576085969,199.020787242377,-269.952366933802,22.8438048403565,-20.3365567936590,36.0123900538794,19.5657754932689,109.279312832216,86.9968429937421,21.3001901895664,-47.8967191113987,18.8825287615295,-33.3849003609314,74.5369675297906,-30.0599377891315,9.50430176990875,13.7980157472049,-1.09786540722376,-1.65552189733153,-12.0471588825268,13.9396146925812,-2.76002300187912,21.8654095997277,-0.678074298161363,-0.561093481000321,-14.5840581214061,-18.3553028716259,1.39955530901952,0.784314399106735,5.57170068116053,-1.16529367833487,4.16381590250234,1.67876584250225,4.90763919727292,9.19292840394880,-6.86333660953615,-6.56871996635934,-6.84943919606914,-2.52319017456349,4.19702857236239,4.50306492703042,3.27783077341445,0.391297424985604,-0.182943948917485,-1.11530312274298,1.81344524892011,1.73644029776563,2.62858844364764,-1.478150507869267E-003,0.838986642896093,0.208891150174356,-0.731531735187883,1.93495233609363,-0.715470362002914,1.21924571911998,-1.53626081284813,-1.57409855927613,-1.71054303700902,-0.147459386061179,7.932484248557782E-002,-0.306347188337263,0.235869244222050,9.443482060528074E-002,-0.239532290539606,-0.229385709516949,-1.554592409603477E-002,0.521443500145444,5.630682076686534E-002,0.288553696403590,-0.572706711391795,-0.606211278512498,-0.488184439038705,-0.557553615951714,2.797735761602303E-002,0.143880701159677,-0.242929192177549,0.276717435732990,-0.325239859350489,0.148718345467345,8.176770269445213E-002,-0.175959173615643,2.650579854922966E-002,1.516945945800116E-002,3.202808380952447E-002,2.125237249934129E-002,0.171931917479251,2.031002705067689E-003,7.613315787414100E-003,-0.113969360313414,-1.284543540252876E-002,0.149163415298712,0.148470246748974,3.055518144835731E-003,1.032693011645318E-002,-0.184601674706064,-0.146984968473448,-8.361884036834882E-003,-4.682480846167633E-002,9.171125894593281E-00],[-26078.9908773467,813.804447005589,-683.153374730908,-908.224468328619,-1481.06282173677,483.796654090631,2945.71737602024,177.383679684225,243.232356825245,695.611818595779,119.625172773442,57.5686222052746,-371.279184907850,-896.901838068726,54.0747740082283,-219.210133394546,34.8081275240236,-94.8236817831544,-523.171599038752,43.8925734616632,-11.7612694155378,145.894151387481,189.707376461431,-269.686860158963,7.87399712385338,-22.1453479098736,43.1461847105650,14.5377984026381,104.792834671438,89.7532919351030,26.7791778725531,-51.4349115491385,14.3944595375079,-32.4211906130841,76.2407899288961,-28.5143139715652,9.45295419079059,15.5502542181464,0.244144978324511,0.656060482483244,-10.9627169692232,15.9338175422605,-2.31066373616654,20.6855492708384,-2.11457104756575,-0.632516934703414,-13.7709647275970,-17.4271918982848,1.23922294396498,0.799445519173401,5.52002107823483,-0.926982923680403,3.82664027361965,2.60102561459196,5.21023681711036,8.89403492335188,-6.57077678059163,-6.95669092965817,-6.22365456209630,-2.46455674224368,4.83992204289998,4.46373184872312,3.25913460984835,0.565306396100215,-0.279160669796634,-0.795758048287236,1.82911091953724,1.67172096741311,2.46106934267151,-7.157714515769879E-002,0.950018574560418,0.131574933615468,-0.918444800707150,1.91897809880176,-0.734177501671847,1.33928487246166,-1.50094937651310,-1.45048565696157,-1.70131797470426,-0.140302700422412,0.103319227217642,-0.252286695477099,0.191121629372400,0.127543604638543,-0.226002885284683,-0.181684235794723,-4.357200608623905E-002,0.544158211034200,8.533753825738274E-002,0.214036054042978,-0.544323165273124,-0.642160528122277,-0.368185619745608,-0.536781876010175,5.239657329490673E-002,0.147681353701304,-0.247263804574296,0.261065635653391,-0.315528358067456,0.141715367359076,7.952966867109088E-002,-0.163772211527309,2.151218210867548E-002,2.204119874200504E-002,2.433854702602509E-002,6.490237123285772E-003,0.179385547320393,-1.242951482144532E-002,4.083537606298685E-003,-0.101457440425535,-2.850913358403757E-002,0.169851448388566,0.143151056769732,1.393208946817767E-002,5.670810880535830E-004,-0.185709799521268,-0.149007000409579,-8.861025346205658E-003,-4.656604355358750E-002,9.025370856910941E-00],[-26254.6749238480,785.692644745788,-462.707102036612,-848.312545740445,-1259.57856822113,207.296624354033,2970.48271738562,198.717649465187,185.903826366118,597.218329455244,126.389530835818,-7.67713538853761,-403.710267071441,-890.504513457700,10.8573464661090,-214.915876226452,57.0447890779420,-116.495220699885,-513.392646480101,72.8692068126429,12.8097143454761,141.010616821211,174.739014938129,-269.381335116940,-4.68349653537413,-24.7504994158738,49.1543215135361,9.56756230080679,98.9548852935656,90.5059555842470,29.9050956165195,-55.8320508598093,8.91188117957749,-32.5962322601962,77.9671115017076,-26.6698815860230,9.83507004374913,16.8844196774424,1.47981358629847,3.11927325579354,-10.5054816308563,17.3016143765530,-2.47323784220345,19.0750242085782,-3.96520668343979,-0.558323038351531,-12.9806783057758,-16.6025942210136,1.02198299403767,0.857997871075697,5.40350179124080,-0.682330144763053,3.51029435762528,3.37477391866553,5.43330468429825,8.43543089123753,-6.37992248739556,-7.44521568719977,-5.51682824960378,-2.43329851788755,5.31622478841284,4.42349170621022,3.15103333499649,0.696440026992106,-0.382874235911255,-0.519330552856027,1.82421879373614,1.63042499958253,2.24643188457859,-0.122246723848741,1.02595092404453,5.080859533782420E-002,-1.09590974207563,1.90046758977002,-0.724690960454741,1.42689133756351,-1.45119501608310,-1.35313319731571,-1.67855269434708,-0.149103664924729,0.119783951209495,-0.210145812324300,0.133175409885658,0.149523683605431,-0.215644293426535,-0.136533308271939,-4.097384935925161E-002,0.549615168625810,0.125107301682485,0.139875576639934,-0.512892139288419,-0.667707143572002,-0.256381016068399,-0.504016363740092,6.346139127189399E-002,0.155776067940183,-0.256761280519243,0.245900473959142,-0.307852364204885,0.136768831489055,7.204383657908399E-002,-0.153248594603035,1.242847950721194E-002,2.653438438495972E-002,1.413884917879964E-002,-3.032818023669649E-003,0.183397252321453,-2.167100403545236E-002,5.674067071901868E-004,-8.630416329705881E-002,-3.906962048506362E-002,0.189389509733325,0.141747179057533,2.176446195526122E-002,-6.112348619981346E-003,-0.188459492671049,-0.148302889588458,-1.106410193335487E-002,-4.484173557914697E-002,8.819576695240515E-00],[-26428.0149970803,735.153565288632,-279.801016917046,-825.528643409467,-1061.21325372453,-16.8417969419170,2927.91157770327,234.200795491388,155.412318749252,517.834186279411,123.464000016617,-74.5615025775043,-416.316853434493,-899.131455112454,-43.0408133979853,-202.767989524666,75.5805294087424,-137.093507021047,-509.723275595580,100.908999466705,24.9784764395976,136.045576620472,154.415575560422,-271.215143013562,-13.3761652189308,-28.0846808078141,52.5952529677212,5.26375781986973,93.9115007710056,87.9672938723068,30.9643711630450,-61.4857852205090,2.16339109424420,-33.5596226919637,79.3422580153409,-24.9536321881000,10.4047518002400,17.6969837311863,2.24566091462776,5.41308342344977,-10.9113049914080,18.1955284774817,-3.54547857074168,17.2574574086468,-5.94850635758829,-0.531760945123890,-12.1879620894852,-16.0505622079158,0.836878632576546,0.923373654248079,5.18365381183000,-0.461977544009659,3.29405648925276,3.81987974053039,5.69910413130104,7.82430446780741,-6.35694109305827,-7.99318514671407,-4.90478336139151,-2.38049365708348,5.55389250224565,4.43541826978024,2.97231405408101,0.791273021840046,-0.488077939368805,-0.329866978593810,1.77927462261088,1.60525950984618,2.02520691112439,-0.132096137777657,1.03370254010639,-3.240111071460390E-003,-1.26135925359835,1.87209385345585,-0.661010951296185,1.46416361420839,-1.37896027100557,-1.30262967733679,-1.64415040964707,-0.166124694028694,0.137313942825428,-0.185215132172297,7.539090100271061E-002,0.157726091300567,-0.216239982990421,-0.107575487943257,-1.006866730526925E-002,0.533912981255424,0.173409423438866,7.361101100184976E-002,-0.484180887446279,-0.678526593028586,-0.171823650327583,-0.461137078609281,5.673562463258336E-002,0.171056066756331,-0.267844316971466,0.235010930456801,-0.301268652544470,0.135166571169006,6.429633982573404E-002,-0.145998501769030,6.614136343016928E-004,2.542779135243699E-002,3.631831915375768E-003,-7.943505429997390E-003,0.184114351088432,-2.221405853117894E-002,-5.707771326339039E-003,-7.094672700906982E-002,-4.369593217198409E-002,0.205644284559222,0.146616922289422,2.502170356236041E-002,-7.391797131243489E-003,-0.192973858201897,-0.144809576405208,-1.360950356695331E-002,-4.211732900800095E-002,8.682332363412965E-00],[-26554.2239486838,675.543648404227,-184.389167763126,-859.830957216720,-917.294915912010,-153.398054561986,2849.67898479800,273.656026247778,152.488197283564,469.433611495009,111.737710940974,-128.944738939175,-403.494735629413,-921.632781200508,-96.9629939389663,-185.282412676830,86.2991745098973,-155.516254833405,-511.677628013146,128.922607329217,22.7472480790801,136.159254865914,130.588061648439,-274.055191701442,-16.6695155767683,-33.2540898166036,52.7936841749908,1.73667238722668,91.0819501737042,81.7678267509789,31.2154513249609,-68.5541044220861,-3.92790234064655,-35.0678383282308,80.5860824637044,-23.4591784705292,10.7670898367121,17.5717245067069,2.23058321914660,7.09137406284446,-12.2952370009581,18.9297200633166,-5.66835993475566,15.9343462350981,-7.80199664678880,-0.387008138547602,-11.4725400008349,-15.7928891412494,0.821829234983359,0.964378173067665,4.86249693060312,-0.393200152787318,3.11288476016864,3.85355452774556,6.04890242450106,7.06836963057039,-6.37676066322348,-8.60127313836817,-4.38609728830204,-2.33950508475953,5.55281159570069,4.49101379734398,2.75918670243797,0.878171743397189,-0.558749775354073,-0.260231550154960,1.68615288382385,1.58436020123130,1.82597058696627,-0.105280810676129,0.953717951703560,-7.030941454287370E-003,-1.41382256119979,1.85749447750566,-0.565217681206461,1.45179230454516,-1.31001283019937,-1.31089631698602,-1.60826583695944,-0.186537242113457,0.156758930648695,-0.170818552256330,3.326828038177131E-002,0.148613254284227,-0.236543224482398,-9.658608971983744E-002,3.439385650026370E-002,0.500636533993025,0.225032686657082,2.051066451392954E-002,-0.455513120205876,-0.678529382643522,-0.124247317079306,-0.421839793025593,3.261512166415052E-002,0.187717045213383,-0.279025495172511,0.229130440002250,-0.296151406491754,0.137100058073112,6.247494524195699E-002,-0.141403428360054,-9.921075422681485E-003,1.910480594922686E-002,-5.923908184766822E-003,-9.211911095428540E-003,0.183036294987562,-1.458266724109962E-002,-1.528161694950532E-002,-5.655103767247862E-002,-4.402992697412797E-002,0.217301492825597,0.153996356076835,2.247428487061766E-002,-4.902315982081191E-003,-0.199830027033618,-0.139430351501265,-1.656223272867230E-002,-3.910209460189082E-002,8.624454554381250E-00],[-26779.4559682940,642.155635248510,-235.852917121869,-941.286883083383,-823.715413209766,-194.218851093100,2780.11997663166,306.721127454082,167.119667561913,459.454383502565,100.146109792241,-155.341934596666,-358.596896700743,-948.432884894360,-141.851976698378,-165.623234966158,86.1703862159422,-167.890213376098,-516.169045864133,157.643641352486,6.32362560962758,144.487368977997,106.306644892911,-274.529488726270,-14.3928555152523,-40.5523403214614,49.0666686390869,-0.671835678180124,91.7135339330037,72.1437659942192,32.0295620458698,-76.6376482732215,-6.63478836772382,-37.0506316132604,82.3900966675191,-22.1699431114532,10.4433723255483,16.3353216155762,1.18104752109926,7.79163651184840,-14.7302008211907,19.7884921754563,-8.93946997637457,15.8367623235697,-9.46258477234943,0.274696279980270,-11.0201898140903,-15.6920031464909,1.08465768289120,0.922349064569560,4.41088064911708,-0.564328039608562,2.91394262260137,3.41281913294075,6.44352657767629,6.13859438679073,-6.30037559992765,-9.29255980696550,-3.88258536641560,-2.38641468109856,5.37102506110059,4.53325041684055,2.55787470381463,0.965474478657688,-0.574849293235894,-0.313672086189194,1.53870065872861,1.52725373322880,1.67752631496822,-6.822564310448116E-002,0.772129566312399,5.253098976631981E-002,-1.56391203313827,1.89215209262699,-0.491970834854674,1.40814876016839,-1.28814762886769,-1.37094872876726,-1.59011252407123,-0.207843416699871,0.179938189799582,-0.155954221989428,1.792159201888327E-002,0.123001818994631,-0.276950833966783,-0.102539440391691,7.630098955960329E-002,0.455244951935237,0.268478468470692,-2.274573347730929E-002,-0.423556184913353,-0.679447983352844,-0.117344712565500,-0.404901303313935,-6.402606674325332E-003,0.192939239495147,-0.292543047207780,0.225878862723955,-0.294973688420621,0.141645278786681,7.056316624541759E-002,-0.137320306973435,-1.714051043220785E-002,9.904610926777422E-003,-1.171795880357355E-002,-9.275037194807908E-003,0.181238777855624,-2.244128357037987E-003,-2.802679929045541E-002,-4.442720968091843E-002,-4.242606263711148E-002,0.222501461313268,0.157977566972013,1.294961165785201E-002,-2.954699449826103E-003,-0.209469607504439,-0.133827653038162,-2.094425090286470E-002,-3.636126180744478E-002,8.562182961450643E-00],[-27047.8277465704,611.632803155053,-403.587528799254,-1060.17936843595,-750.647356072452,-185.707212233543,2758.16850588295,337.190424298436,195.202757547405,479.971126300376,109.281533882636,-147.281146778816,-287.291370052079,-966.185089347867,-174.231771381073,-146.525309112805,78.4998124820154,-172.862702647485,-520.312926295532,189.693033350860,-21.7471671520447,161.636722782555,85.0634511892933,-270.249890914448,-7.42852760148660,-49.5644224981122,42.8387538703050,-2.18495967578940,96.1866173831739,60.7068421914290,34.0576642941088,-84.8351835906960,-4.57884926010338,-39.5706320231752,85.4188298769709,-21.0290055988864,9.45490701792916,14.0872817170981,-0.838233400071303,7.93700874146109,-18.3722540229973,20.9763559403725,-13.1611106858091,17.1310486305683,-10.7815898625884,1.67947063930002,-10.9422287348485,-15.5700594760905,1.58227169251800,0.758635171686343,3.85979028180745,-1.02743860744122,2.65961863678426,2.55714012132472,6.89975625095904,5.04482753756495,-6.09798047203561,-10.0414714319050,-3.38769128993465,-2.56048382739657,5.12757704492020,4.51676565094249,2.42173635460094,1.06357538913277,-0.537688741070498,-0.473759916060032,1.35989941692077,1.44109719976611,1.56437292665972,-3.450111678145395E-002,0.494441766090263,0.148862156827994,-1.71407136496961,1.98972854542241,-0.469088040856179,1.37462747618463,-1.33801564220314,-1.45887725020857,-1.60784330884045,-0.232731168145383,0.202182410184876,-0.133712355451500,2.828901351740729E-002,8.551676726732528E-002,-0.336250874701379,-0.117921833150292,0.107983280981939,0.397725569329529,0.298345459364045,-6.385650569938661E-002,-0.394989565162414,-0.689746455494453,-0.146030895656790,-0.419609579613958,-5.103382683677152E-002,0.177585961336357,-0.308439434374576,0.223527683783862,-0.300153413876137,0.148678283057787,8.751280859249939E-002,-0.131773316140501,-1.980382029694054E-002,4.717977028736499E-004,-1.431543956416297E-002,-9.643438127896291E-003,0.179993079262239,9.957572965464710E-003,-4.400276456698929E-002,-3.587210095763642E-002,-4.119225524341427E-002,0.221231922053561,0.156033711831656,-2.056928136885322E-003,-4.667628267748857E-003,-0.221622610148048,-0.129798064749246,-2.717445140100904E-002,-3.422778991969022E-002,8.431149825390222E-00],[-27331.6634328438,608.948211524178,-680.031050445215,-1170.43210496669,-683.098663751357,-170.881996885282,2792.25096669997,374.399785891472,220.481075736403,520.146553297492,140.870522478668,-114.184238838479,-204.886512124006,-975.062612919176,-199.509989008811,-130.051816772367,66.5871843877623,-169.229641444688,-525.658862257078,222.520305056062,-56.7640131902081,185.265950959800,70.0818122648823,-262.855323969906,2.69125946005279,-59.1261273027079,35.5729398519990,-2.66383185250155,104.535004530550,49.3641458764218,36.7999095210300,-92.4782315193805,1.45050270710537,-42.9414830074854,90.0382668290970,-20.1405013210208,8.00483455587462,11.5786386085466,-3.68106265741288,7.87836620045033,-23.0438150901976,22.4334086880119,-17.8978615272217,19.4240021226444,-11.5306856945313,3.52374324418442,-11.1544645810384,-15.5121770349647,2.23747273331872,0.484436203262235,3.29764414518715,-1.71475406561740,2.42520385542322,1.39319950879193,7.45667181889124,3.93449775097891,-5.91661671812844,-10.7762582062830,-2.99278203208431,-2.79880752418158,4.94653999476871,4.49037746811185,2.41075401145230,1.16189223113323,-0.469735335892560,-0.703910907296542,1.17569055623082,1.35008088599064,1.48429384934892,-1.032868397112400E-002,0.152906480078101,0.251208882211507,-1.85520563033504,2.13921933287360,-0.471424442577535,1.39030134277254,-1.44920679286043,-1.55590973495827,-1.67352901272968,-0.264124760813158,0.220736798277812,-0.105596665230158,5.612719222642346E-002,4.515855677419492E-002,-0.404196800939758,-0.144755491264676,0.132268841029192,0.330189588462269,0.311174540260049,-0.104482239771468,-0.380144623207496,-0.709913134480378,-0.199177174526667,-0.457210083442311,-8.814362303728909E-002,0.147147251974490,-0.322253766382609,0.225584171787434,-0.312607958257208,0.157411206630727,0.109084223764726,-0.126395894917273,-1.899184585772102E-002,-7.529187761150289E-003,-1.490435165038706E-002,-1.044595944615423E-002,0.179200142953018,2.005448942781217E-002,-6.362811934863216E-002,-3.240982666353157E-002,-4.019927431402203E-002,0.217172367509736,0.151812636291835,-1.782311525802456E-002,-9.672401581852333E-003,-0.235048279706425,-0.128871174310312,-3.348406167741323E-002,-3.323927503099033E-002,8.359862673073802E-00],[-27696.7594932911,587.732294334069,-972.363852266547,-1253.28582520915,-634.685136547520,-168.987723387030,2827.37888191387,397.370979341553,238.065099146370,567.393944193842,188.823088551069,-81.2799097989497,-132.417006570162,-988.352564620516,-229.102012217925,-115.631914965154,54.0914750513624,-156.674594018378,-533.654575997762,248.383872496186,-97.1314385303732,207.400486658108,60.3772578306290,-256.917390807024,15.1584425642417,-67.0193023823901,29.1069884700492,-1.25072364003537,115.054097603074,38.7135148823364,38.1580132429813,-99.4987369168998,8.78495230915781,-47.1943617566824,95.3888669955155,-19.4919770780813,6.71572942513944,9.55543688794770,-6.66157295629669,7.91223277689144,-28.1920640823132,23.6310114164014,-22.8027978613428,21.8287913943595,-11.7053764440986,5.17148601198642,-11.3628765702194,-15.7025177568339,2.90283477756801,0.160588025207583,2.87140153740257,-2.42472404970883,2.34553776353287,0.114576473028968,8.04868293099087,2.93817224615326,-5.94756212689100,-11.3800720242393,-2.80455459134809,-2.94163978379911,4.81502457888467,4.54429178879744,2.51390343504203,1.22101532153388,-0.400852172788133,-0.973374693015574,1.02437220501709,1.30454085703462,1.45010610583046,2.085602763383239E-002,-0.199350388582699,0.340678650782338,-1.95707033183887,2.31109944016351,-0.439430204201459,1.45337029142163,-1.56910753181816,-1.65086664213944,-1.76978319161594,-0.296014669762204,0.227313680810884,-8.333475305896519E-002,8.568134991962487E-002,5.461304213640009E-003,-0.464508274752981,-0.178604977259196,0.163532505988300,0.258517788406887,0.312091045313261,-0.137051442076910,-0.377620970659480,-0.725660576802980,-0.262051921446998,-0.493369391317614,-0.113575763785087,0.115442443436244,-0.329681101419409,0.234988409726636,-0.328598020673551,0.166540046223060,0.127903664879850,-0.124302412813481,-1.762804732649555E-002,-1.298766742773056E-002,-1.520725385601654E-002,-8.317226673456826E-003,0.177485174227989,2.964902453594540E-002,-8.489331069282634E-002,-3.171908654323947E-002,-3.542229724278307E-002,0.214725289028629,0.152005310479263,-3.049742387897647E-002,-1.451413444148662E-002,-0.247244956747139,-0.129771566165485,-3.709687015223104E-002,-3.331963087987323E-002,8.523009702139236E-00],[-28141.5506695189,486.759454176808,-1199.16546216888,-1337.48072857529,-618.907935218757,-170.155223432065,2843.99944158394,387.744264007877,256.949708541940,611.597249656669,252.342894636377,-64.8496216323531,-89.6164895731957,-1014.08064342495,-266.430806198842,-100.425356510678,44.3460807890394,-138.426022475429,-539.848730538784,261.570238697334,-137.702857921168,220.733731400469,53.8865263463051,-255.546858615700,29.7266810661320,-71.6118939599055,25.3732673300119,2.94431504356734,124.916087082835,29.2442267622004,35.7987965573084,-106.251975754485,15.5367712201784,-52.3746014166627,101.028935268327,-18.8598664837978,6.25997347343530,8.20749960608690,-8.81239053645768,8.18183513204229,-33.0963975499366,23.9160799783721,-27.5223664958923,23.6576027792171,-11.6245059195281,6.30043514583602,-11.4402488590504,-16.2497156221965,3.41626300379652,-0.121559632657265,2.67402802396982,-3.00402855054841,2.46170683866152,-1.04086763698252,8.52540040036035,2.09710530180036,-6.23389022815429,-11.8141167003638,-2.74876984708145,-2.90219664719909,4.71045490070686,4.70653867012706,2.67054839495901,1.21238173499322,-0.353206370962122,-1.25506525311736,0.932932656726939,1.34904419218039,1.45200763709366,8.389633532983043E-002,-0.525151067713876,0.404088998025247,-1.99852221889137,2.49357808473845,-0.344758916875024,1.53592699889856,-1.66828609234402,-1.74610495701774,-1.87826905614330,-0.324551171525757,0.210534511926150,-7.843729574189666E-002,0.102376102711023,-3.619535105247706E-002,-0.506442364297653,-0.208073404308322,0.213333187563855,0.188624844548643,0.311869521066769,-0.152557203183002,-0.374962827275201,-0.723165305440151,-0.318174237317514,-0.511545040494959,-0.131069875531853,9.262108531118310E-002,-0.332270398826685,0.251534191694640,-0.346721892702738,0.174605047895304,0.137963725810079,-0.126512306524130,-1.790156363885127E-002,-1.561696438758758E-002,-1.712050337184127E-002,1.592261108599552E-003,0.173426816109833,4.021368272301924E-002,-0.103592862201064,-2.975025170173260E-002,-2.348397190713909E-002,0.216719174349758,0.159072222083629,-3.953766472343200E-002,-1.829346492719096E-002,-0.257251432774211,-0.131104102261521,-3.761988651958798E-002,-3.369794413754364E-002,8.966328349255635E-00],[-28622.4276025597,385.784005380481,-1315.16086394450,-1423.03864271633,-604.112081815509,-144.230373946227,2847.58915045502,357.867601690861,277.025555702703,651.061659321516,327.533428346413,-62.6884598117701,-67.1275811280832,-1042.71628594152,-294.402703786513,-85.1238377471287,34.5465407975631,-115.543620178573,-538.905422659474,262.156006022638,-171.549758881734,226.888796490337,47.7426535984959,-256.084734247410,45.2832264624502,-72.9606963902117,24.2159391014302,9.80449788467499,132.391868156780,21.8252892908552,30.7566882393676,-112.325026107306,22.1969323922344,-58.6622228193137,106.941247099957,-17.8364409549359,6.63367043394791,7.44685547678566,-9.83018602576355,8.55320565409629,-36.9816068005728,23.1607989979863,-31.7251746570145,25.0788509432769,-11.9757219577022,7.38030021921380,-11.5807668062912,-16.9715007756035,3.78103727072305,-0.267705406025832,2.68751012755076,-3.38754279598867,2.71479320127501,-1.98930468066389,8.73082812607509,1.39597464365367,-6.58002681267712,-12.1463176277584,-2.57737030532953,-2.79757045030460,4.60632156811847,4.85299352377438,2.77475057351101,1.14339877211719,-0.308258697084376,-1.52221696710168,0.896577022116931,1.46512196717957,1.46850712317664,0.180589190967051,-0.805192995546260,0.452317645710622,-2.00466088410991,2.69269190909203,-0.245438674701570,1.62077669746843,-1.76664522447278,-1.84230695930279,-1.98132807528231,-0.359123728488124,0.171627262509249,-8.993397453901078E-002,0.100017308621495,-7.808604017295702E-002,-0.522673023572451,-0.229245514230619,0.279639809140772,0.123063934398404,0.309858242679985,-0.151375952239087,-0.360293228349470,-0.707340617664270,-0.354979182667297,-0.520292232555087,-0.149851350772902,7.404979022180770E-002,-0.339441146926440,0.269042595903411,-0.368724190512984,0.178697757084717,0.138021319945518,-0.132594620626807,-1.989290373176316E-002,-1.668893226549474E-002,-2.002147517747777E-002,2.037572622838445E-002,0.165754978315651,5.147253423897877E-002,-0.116061541732644,-2.547608088319458E-002,-6.292116999943228E-003,0.222109819952504,0.167487137809177,-4.642095021125982E-002,-2.322980337147256E-002,-0.266089949733686,-0.131877292461207,-3.881111049408358E-002,-3.296560369165469E-002,9.433709381012607E-00],[-29099.0782194180,388.937638457360,-1363.65871018408,-1489.53259042801,-586.475453801037,-82.3236375154479,2832.48913578487,344.198712851011,294.717230674335,682.656017099492,406.813893340425,-68.6961008969894,-54.5456295610485,-1068.97638139586,-298.687631733677,-71.1759326549050,20.9139441434093,-88.7477487264112,-529.872990166725,252.761249923462,-195.938028849979,232.321140207629,40.8326919700635,-255.978584308009,60.5757136811737,-72.0502504653665,24.8934738831189,18.1978523681794,136.906110871303,17.4217667416999,25.1431366475789,-117.052457652844,29.2180754897079,-65.7521598331752,112.847604021524,-16.2638569545699,7.63324661062728,7.23524357040985,-9.83509208202618,8.77851788031023,-39.2427934109019,21.4808950082870,-34.9693812561840,26.6008025928581,-12.9071038524527,8.96564579527164,-11.9347645917926,-17.7038788704030,4.05118954809359,-0.152942054260806,2.84985766557284,-3.53505916683373,3.05643805808258,-2.67011088542221,8.61999131683199,0.908882650387647,-6.73001750546344,-12.4077660342154,-2.12536365853387,-2.81096523224915,4.47754862084156,4.84753056789109,2.76311365989023,1.04292362701322,-0.236968874760129,-1.75739706234786,0.911217575604280,1.64079343011733,1.49744639620940,0.308618951612259,-1.01685262394387,0.508804252595082,-1.99611485108493,2.91434805307969,-0.204311076752634,1.69857126937239,-1.89040762897910,-1.94828744441542,-2.05996564050136,-0.409250505684745,0.118296046315187,-0.115812330845310,8.126115103046889E-002,-0.114727139349515,-0.509759728994953,-0.243400339557137,0.354946855431026,6.596581772140969E-002,0.305022189590418,-0.132900959803840,-0.329270823209056,-0.687803438285063,-0.370294151939583,-0.537731256833924,-0.174038395984314,5.476515824950287E-002,-0.353933958134206,0.281988514538849,-0.393276362080417,0.176629723371157,0.129948628171702,-0.141651208723401,-2.299486033377205E-002,-1.840365408063887E-002,-2.286470767686745E-002,4.669742344965919E-002,0.155258595478339,6.314558240625948E-002,-0.120823449227618,-1.921853496334757E-002,1.178778719335145E-002,0.228926696253364,0.170766627595249,-5.129190434540805E-002,-3.038838788668083E-002,-0.274485353889124,-0.132289376379719,-4.407106144675789E-002,-3.114221049422502E-002,9.658246965039934E-00],[-29393.9674653426,482.828099538183,-1371.62398256348,-1576.54066830619,-572.994822502576,-72.0487226502530,2798.20742240368,370.906594341019,319.441287775211,690.157917534880,480.660660521991,-83.9052764427377,-65.8793800207569,-1094.14126905358,-281.336405788865,-60.7571240838120,3.68421239884689,-67.5761790103495,-515.363565850332,235.231080851630,-212.058690783927,239.906214950452,35.0598133306440,-257.742091956652,74.8628543002473,-70.6358344391744,27.8091807640241,26.1591254856410,136.487406528712,17.9199976473867,19.4580450902716,-119.335848211919,35.6198903304988,-72.3488502472965,118.096006198530,-14.2054428494817,9.44483436113341,7.46235806025646,-8.88637571805607,8.80762963810412,-39.6240437324623,18.8951047648457,-36.5034699479831,28.2481190636903,-13.7688910896456,11.1047636947510,-12.3459282471250,-18.4047979801510,4.20706009479998,0.315990680912338,3.26876289051977,-3.47460336629701,3.38418272275109,-2.87516765293502,8.22052497518615,0.888925185796913,-6.58551780826387,-12.4892325585792,-1.46229533596163,-2.95057837545682,4.32247368741976,4.69520672184927,2.66581814353893,0.951321513533096,-0.116875130009670,-1.93492320045139,1.01033136586730,1.92792015498842,1.53308491718622,0.463770985802870,-1.08875378746677,0.568525764782550,-1.92824940337714,3.15544221832944,-0.210559791639154,1.77764388313198,-2.02859549219687,-2.06240485260729,-2.09583141768583,-0.460415959104318,4.817034672211411E-002,-0.155532440282258,5.613548107073786E-002,-0.141753965628815,-0.470122028657076,-0.244792512616529,0.435434534559693,2.802944739432454E-002,0.305787460691269,-8.621431936507719E-002,-0.288791030783587,-0.660360016286890,-0.365469721538788,-0.566729411538761,-0.194231133218500,4.008141843169151E-002,-0.365573835776877,0.289097680924116,-0.413678932638942,0.169170892919535,0.114636315827453,-0.151747469220925,-2.495520370669072E-002,-1.885621843096858E-002,-2.874399481729963E-002,7.962756815833187E-002,0.145638389033522,7.341602926441881E-002,-0.115996231164165,-1.050201295750940E-002,2.934627792146221E-002,0.238628709065184,0.169555761724106,-5.025814555777935E-002,-3.689419084873147E-002,-0.279987170772206,-0.133073562316123,-5.179995580727073E-002,-2.989834160339374E-002,9.666292492766468E-00],[-29647.9900194323,611.957612003763,-1406.08542531290,-1683.60058265161,-591.466761929539,-136.190971480987,2751.79743255631,411.517724278614,345.656982004073,674.048369128409,527.259511282584,-110.756021546728,-111.180266541433,-1117.83899719134,-252.629645187601,-52.5124226810221,-17.3424669288606,-53.8825082215531,-499.361589807745,207.808291677884,-218.999373227849,246.186468784638,33.6659855913866,-264.484077538699,87.5807258898707,-68.4873137457900,31.5827337087956,33.6273032809592,131.222939700336,23.4720457959810,12.9350207531425,-118.183299197256,40.4383768639648,-77.1007864353310,122.443806353175,-11.8776380664994,11.9983980868110,8.34165863135412,-7.19860258467276,8.45278664390789,-38.1597505410518,15.4433937765923,-35.9954625358728,29.7780813938551,-13.9558512105826,13.4197131904829,-12.5689520106506,-19.0900605154230,4.27864116714424,1.13052602030836,3.93326147137937,-3.15908292092329,3.73094425515673,-2.61442047659097,7.58746090917012,1.46840034424903,-6.24680176903410,-12.2530914489305,-0.729365514969850,-3.08053676535535,4.16500595324232,4.49831701693900,2.57302366996672,0.863048422975640,4.657066475750191E-002,-2.03343704258298,1.18605496236609,2.30743498999919,1.60349516967348,0.631741182233717,-0.995209245008307,0.629443338749072,-1.75943532165461,3.39643100749592,-0.218032090316656,1.86061615788931,-2.15432340030195,-2.15795652129284,-2.09014595198816,-0.487356245068944,-3.295620464851140E-002,-0.206525882554384,3.521816238980277E-002,-0.152865681137867,-0.403207434170794,-0.238092855439616,0.517704793140381,1.541989517753912E-002,0.310028015579707,-3.907867169376457E-003,-0.245076361166786,-0.618052133558245,-0.345470867571357,-0.596928170247462,-0.198085658668727,3.622980425598443E-002,-0.362919667167047,0.291204735374005,-0.424933621529185,0.155485704579276,9.414808266253477E-002,-0.162394869266573,-2.536585033199396E-002,-1.710343110653950E-002,-3.552945401233661E-002,0.116020262401751,0.138888430646300,8.263608047219075E-002,-0.101771872997424,-2.471901390038896E-004,4.731879304962157E-002,0.251918238142815,0.167589781528196,-3.965076295739514E-002,-4.045077523184478E-002,-0.278692307998410,-0.135182270139399,-5.832883622631457E-002,-3.050525642542047E-002,9.650358888667741E-00],[-30058.3342669205,725.236192642115,-1411.70396025525,-1786.38437631811,-639.512341624978,-202.655106166970,2686.69362289775,438.888997113394,362.906920738744,645.853238105495,547.098365425438,-157.102167589797,-181.135371051755,-1140.67210972180,-222.612483488539,-45.2565760081835,-40.8429723613039,-42.6042582164612,-483.654910382252,172.225904487136,-217.350127883374,246.032229407767,37.4324991033123,-276.615931036712,98.0251064480142,-64.4694101442435,34.3896252259738,41.5567286058625,123.516574023364,31.6154995034841,5.07012278967513,-114.342730778011,43.5685105000573,-79.7825463591123,125.961860470820,-9.49325644931490,14.8199755691607,9.80658431705220,-5.00772864863192,7.80575939943662,-35.5908611947449,11.4051232242194,-34.1577976107592,30.8196579093950,-13.4781621236916,15.3707919809619,-12.4793711354251,-19.8729850454877,4.32130065157664,2.09502278059071,4.64876115800530,-2.58591091446723,4.10466016734227,-2.14215975000517,6.78289561012835,2.39570414589670,-5.85601264340531,-11.7363874911651,-4.605325987152746E-002,-3.06254861982329,3.98257578433620,4.35588544575476,2.56232765351041,0.764532686781273,0.220511643295296,-2.07431020236287,1.38248145168422,2.67702439525739,1.71145767873520,0.789603503794177,-0.813467322550730,0.693006010863366,-1.51985679673720,3.60711229543923,-0.198948879375392,1.92156987166148,-2.24376386602649,-2.21237839119387,-2.05464715975854,-0.480882350105836,-0.111050938640518,-0.260850690923172,2.019877356126654E-002,-0.151708910222867,-0.320381538641813,-0.230647159918812,0.592523134014584,1.514324194152000E-002,0.309635090717096,9.765305899270567E-002,-0.201038175055860,-0.560543640816304,-0.321983059588151,-0.612139502442453,-0.186039238958809,4.693133293623005E-002,-0.344424919893082,0.290416243182631,-0.427397080705212,0.136044232969574,7.236946737114247E-002,-0.172427747634398,-2.547916822306035E-002,-1.474429294022113E-002,-3.894098359063677E-002,0.149404852567205,0.133514522190995,9.075482635246666E-002,-8.219588931815919E-002,1.026190330949727E-002,6.578335602220861E-002,0.265751874623787,0.167902027203193,-2.248398769492980E-002,-4.030818990241786E-002,-0.269672821313524,-0.138700024990519,-6.147892096629589E-002,-3.269676581964190E-002,9.770109066505461E-00],[-30573.0540521639,783.315902079665,-1398.07001367549,-1882.26308704309,-678.221595065458,-244.858190075441,2594.73668759144,436.014618991999,374.182075486086,615.332908052116,555.335525792937,-228.094329008062,-258.043846670465,-1165.12751990830,-194.163220079179,-42.1261175832835,-63.4181251980474,-30.1186283685877,-469.812244671295,133.767963332136,-210.469940973933,238.178220137588,44.5792298584747,-293.800171762988,105.436550856029,-58.6698146064720,35.9948925239513,50.4278055959314,115.978056010109,39.8965948312916,-3.52499275874727,-109.384300282407,45.0478661941822,-81.1977976590821,128.857779387466,-7.40719736291156,17.3900649779087,11.4059184345157,-2.57889264633594,7.31209110602913,-32.9624581306338,7.35826424830388,-32.1469543793311,31.1251581430198,-12.7550182315470,16.5090744748862,-12.1876980706771,-20.8694839642788,4.38413971699968,2.89242352250442,5.25017418059611,-1.88622075464757,4.40007039312626,-1.71623443419753,5.91530828696937,3.29662269315617,-5.52768189671425,-11.1309542656103,0.461474811058595,-2.84966114594873,3.75222569299872,4.32952164661446,2.64936472479797,0.678896141873174,0.366198105927863,-2.11811514057332,1.54720872466613,2.94497025915553,1.82532235317959,0.907235712398880,-0.650977217439876,0.770258326209801,-1.29224877746878,3.77306622616275,-0.150162458727148,1.94954524053844,-2.28754187197601,-2.22592596356085,-2.00508932755533,-0.454449981759538,-0.170844560647142,-0.310372501428240,8.605763657676528E-003,-0.152244655807412,-0.247342119321402,-0.228715246860135,0.647810754126231,5.509566498686988E-003,0.302788736988801,0.186405178470422,-0.160144309829106,-0.499471718224350,-0.307506514204627,-0.600989143253573,-0.167696997386562,7.495462108729678E-002,-0.318605378160921,0.290359535207684,-0.427319229554436,0.115879932401829,5.377537770922085E-002,-0.180842122870559,-2.675860494491214E-002,-1.354909306672323E-002,-3.942844861029678E-002,0.172474021327784,0.127598590009892,9.604782345369654E-002,-6.405828157064876E-002,2.085778147796884E-002,8.277599552840614E-002,0.277728573197380,0.173564955022549,-4.737940532469879E-003,-3.539339660028439E-002,-0.256617515588529,-0.143227286777416,-6.094020968433941E-002,-3.537714455228503E-002,0.10112927033489],[-31018.9910302130,855.894901519676,-1394.22247813878,-1974.81310590693,-684.178743060986,-273.956402958824,2467.29184270655,409.836169665487,385.950521802065,589.119114835070,561.601450575664,-313.047465525166,-321.245067608632,-1191.64645515986,-168.202790916153,-46.3823515738983,-83.3621898555403,-17.7672512372788,-456.399024614293,97.4940408085151,-202.325593849714,226.535880218081,50.7486120996526,-313.844687241078,109.962779696219,-52.5453714658534,36.5686906753172,59.7651310735300,110.186841144992,47.0925753450990,-11.6465656232533,-104.979423462393,44.4812940356048,-82.7700479517498,130.564243078010,-5.80470834590720,19.2077449996233,12.5844369419984,-0.225055104076988,7.09023167637086,-30.7382352009989,3.85382313405439,-30.8627506209627,30.6872441987933,-12.2988007928835,16.6693096796842,-11.8589309754067,-22.0893818737134,4.52823152397311,3.32871243783974,5.67598244224237,-1.27564754482064,4.47795423903086,-1.44026928465770,5.06868605972438,3.93974580415962,-5.29004848070838,-10.6649228631010,0.716149024907667,-2.52748959133262,3.44008887990162,4.40305715131657,2.76985533542579,0.642647209563649,0.477789134881124,-2.20337750810886,1.64290765713365,3.07144946461382,1.91780452274625,0.963752515389368,-0.566365953346011,0.868192311876490,-1.15760089830553,3.89253402358169,-8.427456111459464E-002,1.94994767452719,-2.27013098582638,-2.22218169607166,-1.94142241124002,-0.440004326484180,-0.204549593747248,-0.347444507871278,4.915411078966335E-004,-0.167621852610018,-0.201297551493578,-0.237405996830799,0.672806027828410,-1.921947355218017E-002,0.291876568367423,0.238571401724070,-0.120025391725742,-0.448744146805946,-0.305275573312657,-0.559746536484509,-0.155072664598370,0.120176460430710,-0.296730885986266,0.294174868047708,-0.429554717071725,9.994828609818041E-002,4.156567903809829E-002,-0.187642281290431,-2.936733013059989E-002,-1.397604111114107E-002,-4.102971203692698E-002,0.182605962165226,0.120952531616195,9.770310985776127E-002,-5.138278085735794E-002,3.257766211113542E-002,9.560343920292455E-002,0.288174677287417,0.186132812305834,8.504541097196571E-003,-2.376705587452125E-002,-0.245516047300699,-0.146943452907898,-5.848262290064352E-002,-3.722268992604283E-002,0.10587680740358],[-31294.0743742724,960.303636147083,-1349.03942908129,-2070.56146945565,-660.823127944383,-303.558836573852,2309.44699462330,390.360331644380,404.068602440000,565.135404129414,570.780332699138,-396.880512170745,-356.903429553433,-1219.86521639422,-146.098448040692,-56.4804974556501,-101.507996155630,-11.0114923411340,-438.606708995942,67.4490277669508,-195.494806154585,214.876584701118,51.8196238692516,-334.500945527508,112.670436935473,-47.9286728449674,36.0082573024288,68.1849611267145,105.816565268580,52.7221922303271,-18.5135713225140,-102.617424095281,41.7062477312292,-85.5057544340224,130.224667811337,-4.36797391244039,19.9913554317070,12.8474085833361,1.74865737406037,6.91503291744478,-28.9347869716015,1.09428325680053,-30.6849252773859,29.5430977916533,-12.4805373471145,15.9057663978838,-11.5923273745539,-23.4258500675386,4.78680402426738,3.43075710101191,5.92058701641958,-0.975561959833965,4.23488202075088,-1.27142842218687,4.22975267953464,4.22872236889284,-5.10326666848865,-10.4729043521559,0.753308584074388,-2.19382480987476,3.04823543737953,4.53505799381103,2.84394740436782,0.677717797364715,0.583261483481578,-2.31393280906310,1.65236421397953,3.06436749253869,1.96062722687143,0.957114533575035,-0.561104874221892,0.968294041188623,-1.14629401434813,3.97128204409529,-1.584526398142116E-002,1.92764590466519,-2.17925166208198,-2.22497016482839,-1.85654915485755,-0.460523906331801,-0.215230067428864,-0.361194225103197,-3.754342289554267E-003,-0.201388806826709,-0.182837112018941,-0.255816423937271,0.664892297678062,-4.999087552891526E-002,0.280646337932646,0.248366709776463,-7.514864088104974E-002,-0.410574994760259,-0.308174547570511,-0.489779153675622,-0.155940249742213,0.178884251626202,-0.287350811714683,0.302524893571108,-0.434389419586112,8.986813932900800E-002,3.679235583309530E-002,-0.191609165310048,-3.182362749375866E-002,-1.511887906305566E-002,-4.790184755308292E-002,0.182798444589356,0.114368281995396,9.532598556890813E-002,-4.337595259229102E-002,4.652713229276971E-002,0.103813893205077,0.298124009297867,0.204758536171375,1.447065422182491E-002,-5.521302790201695E-003,-0.240250249398557,-0.147894531204343,-5.578187687368553E-002,-3.744813419045920E-002,0.11045600424069],[-31506.7907873766,1070.15095140237,-1267.96189614058,-2146.85017674644,-623.068401255443,-303.432603657272,2138.11996921765,392.248820053865,426.713638578652,546.279281368729,568.407128088060,-467.878951539487,-363.144652717528,-1249.02307464123,-121.591953402798,-66.2754089282843,-120.003703322639,-9.38330084671091,-414.176818777144,43.9453774115537,-189.298361339759,204.314189784322,46.6102764223534,-354.979368185114,114.568189794105,-45.0797584631183,33.7458496272124,75.4000703094082,102.054521792339,56.1168999625132,-24.0195154813701,-102.792222882676,37.2710244892413,-89.5055338021056,127.854533370635,-2.90198065344106,19.8087990911787,12.3379723530803,3.02547583501109,6.33841629152663,-27.2491258895281,-1.14704616810813,-31.3774657143117,27.8467168598462,-13.4287758717961,14.4754322060452,-11.4883850364395,-24.6842685092798,5.15998515479056,3.35474444933010,5.98956219034369,-0.991090598987600,3.76362376128732,-1.18904595015713,3.37889791695966,4.17805351758371,-4.92244039848540,-10.5348496333857,0.719731788952325,-1.89135664771485,2.64915866800505,4.68844958430939,2.82482883668400,0.757714878806866,0.701535740201925,-2.41426391228864,1.56738320462431,2.95176565223070,1.96078930279144,0.895875104257008,-0.606377885027417,1.06728935331399,-1.23119314016605,4.02324048620031,4.301731092085438E-002,1.89059532471255,-2.03257012663409,-2.24191988664935,-1.75132130138081,-0.515282263414992,-0.207495019058862,-0.350367872620365,-3.213776455422428E-003,-0.244410937164157,-0.177842221792453,-0.285452629158898,0.634360050991727,-7.605910690265234E-002,0.268851824472109,0.229716546318172,-1.847845956738405E-002,-0.378417360072626,-0.303177979224922,-0.399082441990466,-0.169885804413398,0.244716820202148,-0.294211846380783,0.312962859490747,-0.441422966294608,8.357021417225186E-002,3.885532764257549E-002,-0.193130505455962,-3.293118490145848E-002,-1.615644640991905E-002,-5.926344986026078E-002,0.177763216494827,0.108317782619322,9.164424298958110E-002,-3.783169749353221E-002,6.302483689221836E-002,0.109359119954549,0.308148732106205,0.226185625741037,1.343095205121328E-002,1.603523119011190E-002,-0.241117900492913,-0.145907929139919,-5.354277783622153E-002,-3.591509468220471E-002,0.11413291838406],[-31669.9036977425,1165.45793004266,-1145.95676326847,-2213.45838615984,-581.446441464523,-292.691355192308,1956.96808569258,393.223955471818,461.307278318356,530.970361939418,551.935016079037,-522.197972700680,-355.162650759730,-1263.06642213467,-90.3365236903610,-71.8647718652545,-136.270931134955,-10.8643200687352,-380.815394323276,26.2961185433438,-182.602121230706,194.044861936873,37.0452291701159,-373.168335476791,115.986990857977,-42.7551979259256,31.1692337143792,80.9409908166355,97.8068425216940,57.1643720979680,-28.8511710759829,-103.963361523003,31.9606285506609,-94.2562120645707,123.719372986179,-1.51411244754665,19.1309607795943,11.3063074210382,3.74314751706287,5.52706346825079,-25.5311503349934,-3.23977274391515,-32.2640850440739,25.6658504372506,-14.9234016603147,12.9280107642332,-11.4940301657788,-25.4246388090073,5.48422726736282,3.20022420507108,5.95068824801899,-1.21485169126221,3.20467243695376,-1.16264046302136,2.51472919562306,3.87248850119758,-4.66084194765145,-10.6865108359968,0.748484365506771,-1.64470669697678,2.31930922735921,4.76451170823912,2.70164377717851,0.842191864211181,0.821803328268158,-2.49811235692507,1.42139972744023,2.79753480281186,1.91492668721107,0.822821680565978,-0.668732030580607,1.15101653626857,-1.34225909398622,4.04015068357303,8.040240748690738E-002,1.86106545746526,-1.85554172420906,-2.25423024503828,-1.62291146963811,-0.593124534545518,-0.192157935357099,-0.328296221382792,-1.055287068407724E-003,-0.288880585644390,-0.175595233508870,-0.315152924901459,0.594557413644945,-9.546273599052188E-002,0.257799207574918,0.201009870259659,5.061664287634984E-002,-0.340906517162306,-0.279868920616458,-0.299970346286661,-0.189363626492082,0.302724129462267,-0.314290517675352,0.318022499523191,-0.447677022241747,7.994893739982022E-002,4.402920851517249E-002,-0.191960828937499,-3.115995586529875E-002,-1.649814465008960E-002,-7.329858602580616E-002,0.171705359424367,0.102428174049179,8.912721441065641E-002,-3.234045330878947E-002,8.172683802471303E-002,0.113898316085128,0.316496423425296,0.245330527905080,7.972030974203745E-003,3.634989455807758E-002,-0.245448784987725,-0.141546440655461,-5.309834157957076E-002,-3.281443358569153E-002,0.11538627216202],[-31726.6621340356,1269.61386486661,-1014.69041513300,-2253.20844758023,-530.447166985508,-282.984467438465,1781.62807970553,360.626888094318,502.470140847138,525.540791046324,528.693002608676,-559.351180486914,-341.718618502371,-1240.88358101215,-44.4970935706861,-73.5035224550441,-148.908180991180,-10.8652575327419,-338.212028702869,16.4701984977928,-171.873095764555,186.261877794073,28.2585735965937,-386.386280744851,116.003694405884,-39.8364257401171,29.3194101507781,84.3666454888032,93.6848492624800,56.3749634239585,-32.7752471079392,-103.898269490959,27.6220226491549,-99.0382924665238,119.030258288818,-0.378867374181942,18.1461245738118,10.1080479590422,3.96946033641036,4.74094543294442,-23.8793071334579,-5.16452911228691,-32.6968826848719,23.4597475329030,-16.6999119940327,11.8872636754172,-11.5855873284622,-25.2761192845112,5.66213442919405,3.00539408723224,5.80771157933814,-1.56394262704613,2.69981489667509,-1.23924450502274,1.66634202419061,3.43346675934756,-4.21946994572293,-10.8033581522819,0.936946900693066,-1.50092793944278,2.15707153873882,4.67010700907485,2.52430688514162,0.904833623435327,0.918851769157188,-2.56422763635562,1.24351567413654,2.63475427401408,1.82050066701065,0.772480496558570,-0.732929455977775,1.20248270339410,-1.42463215636541,4.01242880699044,6.463903038183100E-002,1.86451558178280,-1.69866466082606,-2.23490149727947,-1.48335278683889,-0.676035415630116,-0.174734003058346,-0.306469322678906,-3.560429458679053E-004,-0.325400269121226,-0.168540995249552,-0.339858162437444,0.551606647153110,-0.109710260835871,0.241284541296784,0.175132781413212,0.122883487941253,-0.299636505748286,-0.237123258639900,-0.212937727516777,-0.204831150560911,0.337352691541645,-0.343530431812830,0.310780540512016,-0.452738002469487,7.742911495840889E-002,4.995295866020436E-002,-0.188049852074804,-2.575239272092789E-002,-1.686960808154302E-002,-8.635641118975348E-002,0.166312445893963,9.554266120610734E-002,8.736736080741869E-002,-2.561474319499765E-002,9.895742119204616E-002,0.117027949387706,0.320421691702777,0.256408562956683,1.168236926670179E-003,4.979813238019415E-002,-0.251001601100321,-0.136898661621249,-5.611527824971531E-002,-2.867266127927592E-002,0.11350094728575],[-31714.3192282839,1355.88385313980,-957.621029485435,-2233.08265836325,-509.933063581010,-270.324155033053,1615.28787313861,290.154382779160,535.347345104700,529.094016375694,502.457812111568,-587.372710574810,-331.458213015064,-1174.74056220843,15.9225787738890,-71.6498575569294,-158.886740679462,-5.89123118821116,-292.411852050082,15.0495735730351,-153.748536604877,184.372665553679,26.3189850850198,-393.759568130541,114.213898604285,-35.7236125418586,28.1603373473561,85.5893877275353,91.4421762518468,54.8757028019951,-35.3482225842672,-101.497415903324,25.6232508129368,-103.541119748891,115.352130244648,0.262061179000413,16.9537872184902,9.25209338344845,3.64976963768221,4.02844472315686,-22.5072914856306,-6.76052038218228,-32.3181576726681,21.7963056938454,-18.3981897770062,11.6930836416242,-11.6756929016410,-24.3005552612736,5.67464709487805,2.82155486089450,5.54559508851395,-1.95702118836286,2.36556991003084,-1.47940382164911,0.954477839472714,3.03222274085582,-3.59033226400749,-10.8528320391320,1.27908632344386,-1.48294870118791,2.22880352080201,4.40212727446139,2.40144369803980,0.930787790729576,0.965775537813535,-2.61225449479907,1.05477133081153,2.47374797343025,1.70102057096874,0.773885337744870,-0.793185676370711,1.22098677721273,-1.45696259509321,3.94728338119721,-1.412758936294854E-002,1.91116252328741,-1.60599385412368,-2.17889738409555,-1.35703849652367,-0.747791078767751,-0.154355103546765,-0.295201066269239,-5.170739367039417E-004,-0.344772605253282,-0.155940961508523,-0.363407213541406,0.511056781617167,-0.119303112027433,0.215059240677679,0.160875730108182,0.183170140804975,-0.262965870034329,-0.185023488433556,-0.155555855991863,-0.207420991264894,0.344673922950476,-0.373734533727064,0.291046231604772,-0.457193610862399,7.510385217184788E-002,5.634781847293890E-002,-0.182800028143050,-1.705618537978066E-002,-1.959292431692243E-002,-9.393497986736526E-002,0.161097004376925,8.808299388169920E-002,8.636285628574385E-002,-1.867445252888538E-002,0.109934658618312,0.117108501049699,0.319325003110046,0.257526036770114,-3.875631859320366E-003,5.360282875817866E-002,-0.256406270739323,-0.135277372596844,-6.288091098242836E-002,-2.505579845878338E-002,0.10986654035407],[-31719.1477627856,1373.74333830906,-999.403089545000,-2180.90412572493,-529.106264222724,-237.039030302758,1480.88192338094,221.509854710921,552.537306328555,534.863505442989,492.086715318442,-611.388493225988,-329.365344068865,-1073.60757373417,78.6994783867328,-68.6166399166511,-166.785204464250,2.56097208410856,-246.463959713248,19.9150135945433,-126.587229654254,188.672837352082,34.2761863508516,-396.806285189163,111.644675918243,-30.8954686704088,27.0718612167011,85.6184949941668,91.5120376072714,54.2486465773288,-36.5510186849687,-97.6888828560276,26.5671724087429,-108.058151856885,113.791936430082,0.419024239209285,15.6205382832707,8.62503878803482,2.94902047280773,3.29034669840944,-21.6126353064396,-8.03993313627305,-31.4234242820976,20.9364114405395,-19.8013227147660,12.2800284248618,-11.6119490018855,-22.9515071171398,5.53085293081850,2.63871530496308,5.19342135773589,-2.39731394410707,2.12938631747407,-1.85915154891976,0.405606652961124,2.74012327921609,-2.81125619499619,-10.8838508896022,1.75324355451768,-1.52354789059643,2.51579449723555,4.06029899745865,2.41468024775515,0.915982681755613,0.960329016289309,-2.64844388217999,0.866156523245188,2.31830751281812,1.57828689700590,0.830641565504314,-0.850317274961202,1.22542448966875,-1.45080217430333,3.88567397494981,-0.135081057930890,1.98354251253422,-1.59451927642373,-2.11497534342268,-1.26931918232290,-0.801705807832698,-0.135021890630406,-0.298900525841894,6.230533213520685E-003,-0.352243632385977,-0.141745644438624,-0.386226982606783,0.477408003797085,-0.122995624972461,0.182503375025460,0.160136497729816,0.224958840231708,-0.234202878416175,-0.140553286293019,-0.132256715134517,-0.199544889001212,0.333476928763086,-0.396927129841269,0.266343390598049,-0.460726131068398,7.325322900982111E-002,6.242344325923455E-002,-0.175474778125370,-6.032479181434303E-003,-2.369546521639243E-002,-9.520673858743858E-002,0.155876730841945,8.306351665309848E-002,8.505109262831657E-002,-1.135618018674422E-002,0.113209842817945,0.114065064951206,0.314236902367348,0.249651210302116,-7.274772218766754E-003,4.878912298336552E-002,-0.260385695284290,-0.138460321994760,-7.100825070937823E-002,-2.355634727479135E-002,0.10704656591987],[-31744.2534169444,1279.60365642372,-1080.85381350598,-2173.04234753504,-549.727386259858,-187.058603407758,1390.11809899296,172.768772348381,561.786267838265,538.084430639636,520.506911912560,-630.955237679249,-339.987255316433,-950.861408288110,127.415225197447,-68.3549584855436,-170.736642093753,10.7792472121367,-199.780344760429,26.6123730622627,-93.5204255812075,195.135312261181,49.8633808176467,-395.707956538563,109.761580034255,-26.3473374567681,26.0942089793966,85.9178441637940,92.6999503951614,55.4013261568751,-36.8006641166753,-93.6861328511868,30.1971729105416,-112.662139217394,113.742034917751,0.259231813555389,14.1751304945475,7.58640191196127,2.39821163159829,2.62415104514244,-21.1991632252608,-9.11648020130720,-30.5503579775068,20.7199517498218,-20.8570962263492,13.2986404449349,-11.3015477486390,-21.5706768951042,5.25558540322832,2.35422118140403,4.83706030721545,-2.89745508422645,1.81918361056458,-2.27798765379849,-5.245579463501646E-002,2.48651465768464,-1.94030766476046,-10.9236123079171,2.29417218296475,-1.51774086035716,2.89934246116222,3.73831028812970,2.55047403040367,0.878203471264514,0.922010683186163,-2.68775412303715,0.690370390818945,2.16939057961616,1.45942121894365,0.914773645611208,-0.911024248617449,1.23498428423512,-1.42829777766827,3.86154499433784,-0.259310995611577,2.05444663305036,-1.63814405836138,-2.06313358720507,-1.22266041755880,-0.840052765243040,-0.123727486351011,-0.313448138126053,2.764875675127930E-002,-0.364123566037642,-0.135367836658593,-0.399046110149173,0.448067636658374,-0.122592728347514,0.150328331698431,0.167412148027383,0.253739669300424,-0.208054558180161,-0.114699081591324,-0.133825327302699,-0.188845250611197,0.312660114411996,-0.410032089737822,0.243772201993095,-0.461393450264459,7.304165165347834E-002,6.713767476325373E-002,-0.163915765513185,6.145573881761605E-003,-2.579688565133595E-002,-9.286330743951091E-002,0.150841039237800,8.268592593990005E-002,8.123000547804969E-002,-2.788539094212799E-003,0.111568318464144,0.109568394897779,0.305929071353762,0.235315378207580,-1.105542680631662E-002,3.913706567731403E-002,-0.261731093560281,-0.144689185875356,-7.756067522026075E-002,-2.431659696211226E-002,0.10584013417437],[-31841.8987529794,1129.96462132995,-1171.50211759148,-2206.38784411052,-545.850267383537,-90.7304605981913,1319.86000496576,132.441919774321,566.000105027680,549.148012009302,589.552400861435,-641.604614545209,-357.818060564279,-825.731295514006,150.607729402788,-70.4623677006032,-170.450913561905,20.4423694374601,-154.530144547603,28.9927596162486,-62.1184656360798,199.849084622441,67.5858038011655,-387.134132315148,110.001259031859,-22.2452683402334,24.3846221504518,87.8034996100837,94.8168027010339,57.1642029517821,-36.3328876687325,-90.5787947799601,35.7852761860902,-117.177769130023,113.354460238329,-1.386979562574873E-002,12.4853708210850,5.78854376361086,2.36847455537536,1.91978578398689,-21.0542816312933,-10.0079029390010,-30.2686996765341,20.9636712345832,-21.6787080652245,14.2692677618893,-10.8260063876650,-20.2986038305994,4.97633296751928,1.95013427785237,4.47772089627381,-3.37842792065886,1.42711251174431,-2.72568419362226,-0.500958986235925,2.12324078591682,-1.09465031066804,-11.0078356445502,2.78771195272808,-1.43931221868687,3.23282093267037,3.48626879178107,2.73030574508935,0.824114678922087,0.891265810754825,-2.73368085569038,0.525585269537432,1.99800603417712,1.37273244930011,0.976241288255106,-1.00164818262397,1.26858338046278,-1.42780571931950,3.88585628535835,-0.356452459605237,2.09560001299613,-1.68351287567462,-2.03041101716274,-1.20420376896769,-0.874318030139321,-0.120979535310321,-0.325144375521010,6.593704132672558E-002,-0.388306910861533,-0.138194933247248,-0.402041487038552,0.416310291868538,-0.119407283051437,0.118880911562179,0.174529837227306,0.283153892831351,-0.181129236875269,-0.109709971421466,-0.146746479762405,-0.183184045446075,0.286988788960542,-0.416484404880978,0.228413357652066,-0.457493780310882,7.287282714689065E-002,7.104376693700094E-002,-0.149279321352063,1.744148004884256E-002,-2.442964078198040E-002,-8.736213823035124E-002,0.147210887207886,8.566549729507275E-002,7.541160270863549E-002,6.975333165247980E-003,0.108874821741054,0.106130533078679,0.295248178085373,0.218199101811082,-1.770206253709464E-002,2.900055484097471E-002,-0.261480834013332,-0.150343361385292,-8.121721816933428E-002,-2.628560892522083E-002,0.10524251748584],[-31981.1528516940,976.143347179112,-1239.77753945147,-2280.59644841457,-520.328692743340,37.4048237064905,1251.71809767858,91.1681431580383,575.147519308015,562.659209134740,697.820996247363,-644.246422027854,-383.039225432852,-714.132406852214,146.685436425382,-72.1921944229934,-165.706067462376,30.9294446143470,-113.102599660877,23.6463079902792,-38.4643777960537,199.372741773073,82.9981920689270,-368.676431301588,113.563286458100,-18.6015424442438,22.7590893069852,91.0420143703456,97.2468649360529,58.5786316340562,-36.3021486006441,-88.7665426203269,42.3374779768303,-121.606497581283,111.384996874054,-9.379336567424798E-002,10.7895255865532,2.99446790741640,3.13325171137838,1.28931657939017,-21.0713759525784,-10.8148222826049,-30.6757712723517,21.3246368280015,-22.3579800206712,14.8630648454211,-10.3578080512388,-19.2146695024102,4.78546591666957,1.47630654045902,4.11586715546007,-3.83256153289432,0.976836335482824,-3.16542902559482,-0.987747088022655,1.55373959624936,-0.403623304742251,-11.1447278507494,3.13804654583862,-1.28191106942839,3.43224117757845,3.30143039410676,2.86877347485031,0.768299698600518,0.899361902119621,-2.79306434122211,0.386900137425466,1.80083307869317,1.30586087089742,0.990981856338989,-1.14311817268860,1.31633475751561,-1.46588253859899,3.95145512956898,-0.399621762629534,2.09332100180640,-1.69119616237957,-2.01484384631352,-1.20062199881927,-0.913916817125628,-0.132190357354354,-0.319256266093582,0.112209439919066,-0.427835231724395,-0.153010087146602,-0.394002005027214,0.380360400331573,-0.116841714791960,9.272783094719589E-002,0.171727068956763,0.320055907945778,-0.150847569661961,-0.119396552486260,-0.157011957577528,-0.182998661193306,0.259973370723354,-0.418458338641422,0.222458140872918,-0.451419522395663,7.183588997825295E-002,7.468629194285979E-002,-0.132860193978582,2.689653068180888E-002,-1.839997899289180E-002,-8.126016496602914E-002,0.147305386461368,8.862648981736762E-002,6.764484192043270E-002,1.651834909966646E-002,0.108135815574968,0.105377405728365,0.283407758771300,0.203041405123650,-2.823541214552518E-002,2.107714640920855E-002,-0.259803465557872,-0.153128246419872,-8.179838875038106E-002,-2.816168090950790E-002,0.10400017872649],[-32054.3514785718,830.229240495329,-1237.16345704105,-2383.50928648209,-481.309684622100,147.543150727707,1197.36041470606,44.2756554138486,591.776303988254,560.160799099762,832.470889204547,-643.761782708234,-414.870153700258,-623.747723653658,128.865084859533,-74.3934952991731,-159.245484908539,40.0296717937794,-76.8016058419925,11.4566815195331,-24.1976829509857,191.816812735492,94.5501820557219,-342.057503865997,119.577463357493,-15.8131703492345,22.5030722383866,94.2191462449261,98.7787456267219,59.6876859446919,-37.8479380970687,-87.3910627632114,49.1988686129457,-125.888592146754,107.789060140412,0.149659466669692,9.29605738770242,-0.729429254111138,4.54088347151324,0.704536500871360,-20.9729860085271,-11.6472782085718,-31.2228583992844,21.3912342766646,-22.9692779047650,14.9416694099435,-10.0890223626146,-18.3391707033647,4.74924118982180,0.941876424965890,3.78640999676453,-4.30372003003790,0.452777282700234,-3.50505538906855,-1.51923976022622,0.833923147760940,5.112136014491965E-002,-11.2953999579823,3.28477124341816,-1.03370677040548,3.47620819742167,3.13633697487013,2.89358676857837,0.736295898667926,0.940540333523535,-2.86491045460455,0.292526239610840,1.57952158631926,1.23396029179917,0.955526162493287,-1.31438555887629,1.34849539660680,-1.52503272891980,4.01570180401465,-0.392209410605853,2.04759546953662,-1.66052019253660,-2.00574625885189,-1.19852212332058,-0.951656683030764,-0.158697427911340,-0.288927393885121,0.154933489745319,-0.479903283836434,-0.181858445487306,-0.373715563421224,0.339303209056449,-0.114238842471161,7.273527457294712E-002,0.153187883320634,0.357500337899428,-0.118557989246071,-0.133680515299897,-0.153658542141042,-0.181434305518577,0.234400548744300,-0.415164123025385,0.223576254211886,-0.449355827781899,7.091676478891493E-002,7.898713204353894E-002,-0.115292765763461,3.444397355695445E-002,-6.627276920929016E-003,-7.782731302742965E-002,0.150616652232440,8.829636744740023E-002,5.716309399714446E-002,2.371636665185064E-002,0.109180587693195,0.106719821533363,0.270506423187235,0.193268212549683,-4.104442735297329E-002,1.595017012499959E-002,-0.254648139511639,-0.152474867123646,-7.991266400288272E-002,-2.886490000054178E-002,0.10146736592220],[-32097.0966079773,684.562883318703,-1179.56564797205,-2454.80603431890,-454.085738799736,231.830106451128,1183.44006092818,-8.53768299275716,594.898223547974,533.374820444635,969.319085376763,-633.187325847129,-439.011407513535,-555.298496273644,113.258629456110,-79.7296444300059,-157.190867366645,51.1824075387885,-46.3092251687527,-5.64364357966948,-18.9872046258870,176.997523374784,101.935438023759,-309.717941344159,125.215830336213,-14.3056151106163,22.9513508321732,96.1484087010551,98.5017328017998,60.3596662904731,-41.1275635916112,-85.2572534929117,56.0320930611272,-129.113918389964,102.996161759366,0.621208797168544,7.63367590315872,-4.93725345277166,5.95311620664595,-0.352438188188155,-20.2138272004538,-12.5011775140025,-31.3885228296499,21.0489355977237,-23.5093158271179,14.6095802187721,-10.1898728179259,-17.5047324192013,4.93094960693289,0.300760842740423,3.40816418852729,-4.79241521378449,-0.115539137458808,-3.67864110454666,-2.08379262624497,7.124661111888003E-002,0.245506485890345,-11.3973953835603,3.22646725255524,-0.768155127136326,3.37500980728434,2.93814401176036,2.76080825265927,0.740614353959555,0.977310612981231,-2.92912474134346,0.221196684395174,1.30684710505783,1.16876734139437,0.859966572005501,-1.47452050893971,1.34465807444991,-1.58849374584874,4.02770266719569,-0.372942730189643,1.96080033986224,-1.60341857497057,-1.99015713755446,-1.18639441171143,-0.968939334942943,-0.186197225773985,-0.234010073782274,0.188020346817076,-0.535613527934314,-0.218979959582805,-0.350007524142116,0.286643955800609,-0.105621123103514,5.055891469835903E-002,0.117771167360203,0.386222334036128,-8.992262778230246E-002,-0.145998080704249,-0.135426133030764,-0.176259466328458,0.207147914479912,-0.406031888872486,0.225849066655262,-0.452292163796671,7.047322684336237E-002,8.619840671184237E-002,-9.681219927831340E-002,3.856006774102988E-002,8.175985075754172E-003,-7.698273848163328E-002,0.152566362624352,8.284212437736004E-002,4.401569039418820E-002,2.654889013358697E-002,0.108976448761980,0.109127399409986,0.254701012677469,0.188796276809996,-5.412601616430503E-002,1.218131354769246E-002,-0.244302981697928,-0.148256104208682,-7.647602235984509E-002,-2.789212985729357E-002,9.689838359603369E-00],[-32091.8092182924,515.393554500473,-1110.81367912372,-2455.77658708415,-439.030963459112,287.951551127844,1222.16670115471,-64.3272884339226,567.446340266733,479.848009990196,1097.59155339314,-601.152923906716,-443.227998833388,-505.499870008697,106.798390714899,-91.9034421890298,-162.112688302662,66.2919598355018,-20.2434644527729,-23.0310005828334,-23.1467882196589,156.903375945235,105.429039611126,-274.275139530238,127.551461320232,-15.2451812626322,23.0872319440770,96.0461775425752,95.6102966446990,60.2589318548347,-45.3981981947631,-81.8368957974388,62.1411675457000,-129.971860874327,97.6324129511867,1.25194388187738,5.25384999464920,-9.31955594749279,6.78214965375045,-2.12524750076971,-18.6438849376667,-13.3493691768310,-31.0872737247556,20.3468444877211,-23.8219139429503,14.1647480227240,-10.6173671575448,-16.5159815990113,5.33533429052120,-0.527041639873436,2.87419238328020,-5.33190807134431,-0.793151653516997,-3.62762883527106,-2.66031714736288,-0.661479040706967,0.239837054777308,-11.3986362654662,3.01244759912795,-0.604586778496907,3.13303363428767,2.67421398335887,2.48870090757590,0.814600413963228,0.977536428076668,-2.96972965859199,0.128256456475357,0.975740565566358,1.10667568704831,0.690723144894383,-1.58529614313740,1.28941436169327,-1.64913420664775,3.95765609198506,-0.381731539727432,1.83411280150804,-1.52810909016374,-1.96196525695006,-1.15291981011272,-0.950408498387038,-0.197477805133862,-0.155843621700558,0.210336418774621,-0.591372379508526,-0.260930175657212,-0.330672386377460,0.213812639379998,-9.055261431673961E-002,1.962412308242597E-002,6.973520480109416E-002,0.399806616449362,-6.873344841178053E-002,-0.156317803059206,-0.108531850992318,-0.173491077538671,0.173900891067970,-0.390123129516918,0.223117440779354,-0.454048761633551,7.069410256754560E-002,9.909832636527441E-002,-7.582632236748056E-002,3.828074413587416E-002,2.195101625901255E-002,-7.994055007891382E-002,0.147506786669420,7.331996874604867E-002,2.689532912178994E-002,2.524029775116048E-002,0.105561492822250,0.112027296576071,0.234619826256556,0.187253957326028,-6.649077129288578E-002,8.248988914215603E-003,-0.229203356907377,-0.140816069911289,-7.258012927128081E-002,-2.570337413731747E-002,8.986998722940785E-00],[-32055.2816278192,292.276976972957,-1104.61808331891,-2371.59318039022,-420.308229737234,331.934407306221,1292.03403906877,-133.284429176838,509.099303463013,407.205998344906,1209.40333810721,-545.705640644803,-428.973315701495,-469.560510340752,109.464943138651,-112.328917623105,-172.540273318454,83.8266917605236,2.66145685965373,-37.0376308034104,-34.0985554033848,135.236503524396,107.158616191611,-241.753574212266,125.890015679398,-19.3220074627053,21.7840986997051,95.2221919920960,90.9228222262802,59.2078420602323,-50.0722686369308,-77.3937697098346,65.9655280341853,-128.160088019487,92.9213660221392,1.92741285094795,2.04460749983052,-13.5891421927383,6.81390289739454,-4.49210044587713,-16.6423693718636,-14.3774179742743,-30.5474952714094,19.2731982511597,-23.7114041672368,13.8004579090496,-11.1025385752026,-15.4787287844046,5.95965722899382,-1.53584529876066,2.19723515446868,-5.94003478241303,-1.64459315419409,-3.41182203748138,-3.21857114023882,-1.28432372610749,5.004503017662704E-002,-11.2726409140564,2.68138557125889,-0.561597291760132,2.76694022924405,2.36853620611282,2.18358998015304,0.976558885124947,0.941101808851170,-2.98910449688262,-2.798797466813435E-002,0.611053706620880,1.04761986902477,0.445225967133032,-1.63156441999973,1.18665265674166,-1.69290061888617,3.80836991989065,-0.418569321276348,1.67573405883344,-1.45324632504204,-1.92411232775217,-1.09967252699832,-0.896116722186195,-0.188649215684652,-6.251335036467673E-002,0.228632866782102,-0.648536911943025,-0.305188017987452,-0.322607125474072,0.124599723642858,-7.397161038754660E-002,-2.528484908057525E-002,2.600908799391190E-002,0.394706306582466,-5.676597661189958E-002,-0.170363221061944,-8.153087494059461E-002,-0.178288279443999,0.138480968967928,-0.367103416660643,0.214078281660309,-0.450998682004847,7.019619944853280E-002,0.118294586800898,-5.254581675586934E-002,3.483376870114843E-002,3.327294713473468E-002,-8.742004188482436E-002,0.134292721303756,6.312834280778168E-002,5.632305778024498E-003,2.216835082149271E-002,9.888370335953353E-002,0.115427520464028,0.212107329491164,0.187071794298797,-7.772534181154572E-002,4.118261490104968E-003,-0.212229778091818,-0.132406619421875,-6.925455601680143E-002,-2.309602085817511E-002,8.220030909565293E-00],[-31994.0325700491,46.1292148948908,-1165.54624434625,-2239.39512022839,-386.053323897782,395.613182714526,1371.76341983566,-219.110539934919,430.302045117659,332.830776128645,1307.10213569850,-473.202341256822,-403.648403035669,-444.728272761157,114.229982242314,-140.940623410020,-184.574014014570,96.9102092842078,25.2308632399914,-44.7814481886347,-46.8579087814660,116.209194810775,109.080601455198,-218.108021869672,121.733321209822,-26.8494795572509,18.7571918150729,95.5081894086542,86.5431875657401,57.1915796933826,-55.2996080775333,-73.1877389941999,66.1117743674935,-124.391001212238,90.0341701486741,2.63278058085894,-1.74058324106553,-17.7304323841990,6.40444084421397,-7.12205641457680,-14.8582741011684,-15.6881577739902,-30.1615261424703,17.7432528074821,-23.0230559847173,13.4568095378627,-11.3661528394359,-14.7068114519899,6.80655328501630,-2.63913814044424,1.50639435491600,-6.65665944026097,-2.67111416695866,-3.14430929440737,-3.74481373214777,-1.72974140057625,-0.385651203069261,-11.0457634995098,2.24852517628481,-0.583729935286468,2.33001880188690,2.07393007242324,1.96896816540416,1.22567615447469,0.890925146003457,-2.99309890430974,-0.252056788154254,0.262830757220275,0.984369439760814,0.147083481566400,-1.63118034273287,1.02777276156401,-1.69862081819836,3.59815727557229,-0.448364244748077,1.49991124051915,-1.40273656124954,-1.88975699385246,-1.04264951591988,-0.822326203429133,-0.173755511363962,3.614076813328011E-002,0.252576882782382,-0.713830931021949,-0.351972245470699,-0.327232152690746,3.031612967783122E-002,-5.838603102582364E-002,-8.544883691718830E-002,5.977063781081745E-003,0.370843994797416,-5.284882518474466E-002,-0.191919877671646,-6.224980321415054E-002,-0.191371092447365,0.108553105920876,-0.340623918543979,0.202915607130078,-0.444614868065401,6.709449239175019E-002,0.141918283000577,-2.822828975509863E-002,3.035973893266759E-002,4.357754067456243E-002,-0.100025862757406,0.118574973946272,5.458098664627316E-002,-1.911006336697460E-002,2.065273841565116E-002,8.989322993422943E-002,0.120249146994267,0.191719629804950,0.187567500788297,-8.816469363445793E-002,-4.273106090673360E-006,-0.198499410012955,-0.125579519886492,-6.768225286911109E-002,-2.058512423862863E-002,7.614766443901771E-00],[-31910.3215148791,-192.322688420291,-1251.49785124823,-2100.94734779381,-313.057045563358,470.296081210693,1451.89713787030,-310.557646246281,350.385503143452,263.718333156067,1398.79584664765,-395.900486603283,-370.385597289953,-429.726049668273,114.929383113966,-176.976029748894,-194.528979950713,100.812429674455,47.3302794550757,-46.6835662857085,-57.6405444174580,100.637021720162,111.656246766895,-205.366655900368,116.683815426143,-37.2600843250311,14.8000466878909,97.7518237554931,83.8097231027745,54.8128141882859,-60.8202777953893,-69.8694469222034,62.4242675200884,-119.498775704569,89.6066012218987,3.44656256743110,-5.68139815710304,-21.7077221090854,5.96292779836180,-9.29590401860914,-13.7638203482347,-17.1028745325146,-30.1928716769070,15.7438116157486,-21.7595539664093,13.0193775432925,-11.3170137015058,-14.3505521693194,7.81387929708889,-3.78379710583194,0.941752928033676,-7.48671608871390,-3.79635356493635,-2.88843321764370,-4.19581125169143,-1.96012975740999,-1.11207676837382,-10.6872352794596,1.72593700638086,-0.595950718193742,1.91347084693854,1.83997622779608,1.90212479786223,1.54730247339908,0.850998687142792,-2.99379141463604,-0.513629530277164,-2.441649248696934E-002,0.905315331608407,-0.157706700172355,-1.60271354348396,0.824113462353640,-1.65146760981231,3.36139084660781,-0.437125042471698,1.34016916863056,-1.38992973162605,-1.86153054032421,-1.00252202961154,-0.751503971854688,-0.162887751549589,0.136679487595445,0.281639267301799,-0.790802350193067,-0.401951570096371,-0.340923419227578,-5.265950400654779E-002,-4.974511112590118E-002,-0.152192140133290,1.478743559810403E-002,0.331248818358996,-5.279024738684961E-002,-0.218979632040406,-5.410589360296004E-002,-0.211900636262239,8.857013435049645E-002,-0.318512929400704,0.194671106517373,-0.438357874515346,6.160011911855289E-002,0.167027286982663,-4.525550202223776E-003,2.582945626963900E-002,5.383587064747861E-002,-0.118150011682312,0.105500920046330,4.762576559959095E-002,-4.547652324653562E-002,2.218713199453902E-002,8.056942764134054E-002,0.128811066439911,0.177289271782754,0.189273945027044,-9.708119867870074E-002,-3.622140651061215E-003,-0.191486600048765,-0.121314605257719,-6.817235243865490E-002,-1.826447268839774E-002,7.271569416603782E-00],[-31827.2029006514,-402.293573221381,-1314.27849096203,-1972.28726406060,-215.694092936877,510.959631828708,1544.56758769442,-390.619955089789,290.935732740487,190.974751711441,1481.94488608607,-336.198122291810,-339.863354545528,-424.878415234696,113.270233088734,-214.593399872012,-200.141556932994,96.9793964053193,64.0630880807657,-46.7991727525727,-63.4065979088302,87.5417770962790,114.432645219946,-203.044508909378,111.356562340604,-48.3529768334933,11.8032782665975,101.303788397073,82.9342766939166,52.9255543728134,-66.4781862386036,-67.1139791503069,55.8879296940134,-114.048511016906,92.0813557221220,4.11048385651603,-9.10037096319760,-25.0250747236596,5.65093057485682,-10.2057787815444,-13.3729800244983,-18.2882753157628,-30.4673251674293,13.3842626126202,-19.9203773480955,12.3902221641498,-11.0514774312566,-14.3729636121849,8.77627588430414,-4.89740893546407,0.564668363145998,-8.33351653367936,-4.81300926253604,-2.61375641050310,-4.43777340305401,-1.92933100288081,-2.04642980371172,-10.1430093618516,1.16667464103909,-0.545673994205928,1.62505593429889,1.69906906078597,1.98379186330864,1.90054861806066,0.815566070815380,-3.01229951223006,-0.768953441435582,-0.215865749797607,0.815922344740933,-0.405451636693438,-1.55397922284846,0.625549152309984,-1.55427600716958,3.12951124620962,-0.370743390877805,1.23509175939011,-1.42219822799513,-1.82841874498096,-0.993365843433456,-0.699253965390286,-0.154334321436173,0.231567798768348,0.302104957741748,-0.871457062567319,-0.453325232756766,-0.358386535974720,-0.109422172972661,-5.420404548033813E-002,-0.205672566562197,4.011571177933081E-002,0.282524130267199,-5.442626638854830E-002,-0.243919640307209,-5.400108862531006E-002,-0.233751707598660,8.155136958278718E-002,-0.304917234254485,0.192066962792821,-0.435198335465542,5.631740032523938E-002,0.190544781487765,1.534123838408112E-002,2.157551743520219E-002,6.234473475544462E-002,-0.140382593508435,9.624448455232407E-002,4.133985471990088E-002,-6.883272586254405E-002,2.376574836258223E-002,7.320987541994478E-002,0.140858368519248,0.170839151043549,0.192846672016178,-0.102353798454870,-6.219620118276636E-003,-0.191368435565858,-0.119730899274793,-6.951043579745653E-002,-1.604339745484172E-002,7.213037881191679E-00],[-31927.1910216657,-586.234135042411,-1370.46423726942,-1867.33047087106,-164.507532624193,482.668761724112,1642.19865954985,-453.244558411488,264.406346551183,95.6251930406536,1538.12071206762,-320.188757246184,-332.065465681994,-430.991754918491,113.434677995706,-244.430291030740,-200.085105626947,90.8332702613724,66.8236808436335,-49.1940914733695,-62.4527252100627,74.4895154412323,117.218468195829,-209.912066513587,105.943295415307,-57.1396380333658,11.9323074308552,104.725236083086,84.0761400923695,51.5917562579435,-72.5615422210772,-64.3217416784055,47.2819478037135,-108.009485746454,97.2165797866391,4.03372786079928,-11.1821889169044,-26.9675469550295,5.46037604568275,-9.27071145745613,-13.4327253043358,-19.0378903925988,-30.4180848573789,10.6732559575369,-17.3915540090156,11.4418858411271,-10.6555705653264,-14.6255064772773,9.45096132071645,-5.86923572793022,0.359469500719440,-9.00360635618175,-5.40684397539995,-2.29351447828671,-4.27094950579359,-1.62753807565562,-3.07874406587825,-9.38613439632188,0.605700560290455,-0.386563189719323,1.55026746653274,1.66916075637285,2.19909689594617,2.22778206233887,0.746352598288914,-3.06681597389340,-0.980680209246703,-0.287897230751432,0.729100001437312,-0.539788069766586,-1.49188456059874,0.481975394980391,-1.42021218170970,2.90669059400632,-0.244826386947710,1.20547947355683,-1.48761162071072,-1.76770071023062,-1.01220314633801,-0.664788160279967,-0.139929162655439,0.306137068896741,0.298326604135275,-0.941886039573263,-0.506445753235418,-0.376455960105506,-0.130130132231973,-7.532729170513196E-002,-0.228160339284520,6.424274322168654E-002,0.231212361131326,-5.698837492214481E-002,-0.253613722476513,-5.300953051919023E-002,-0.242573607579960,9.020445079213593E-002,-0.296536361150071,0.193470381879554,-0.434384374826790,5.522820277064821E-002,0.210578449727286,2.773820719440656E-002,1.705943991488549E-002,6.590762502462472E-002,-0.163649032886908,8.876192211773894E-002,3.407124287582428E-002,-8.389311718673406E-002,1.890751480665787E-002,6.951265785635821E-002,0.152629831376344,0.172816171463801,0.198832342235280,-0.101331791449873,-7.161521472403646E-003,-0.195134615117716,-0.121152290571954,-6.926021262582914E-002,-1.402368548944068E-002,7.427272036752093E-00],[-32180.8531212221,-750.439529616966,-1423.19425849981,-1814.90357441956,-161.994088352756,350.732055464219,1721.23966238241,-494.878098230607,274.498675263889,-29.6167483610132,1555.24457353626,-357.782273612497,-346.126342715635,-445.007233072448,124.368821344941,-265.429424437032,-194.249159770773,84.6069274226182,50.5313154671690,-52.1713975640818,-55.7065694748784,60.9058629353379,118.857973172730,-224.225201411066,100.061911082816,-62.7651024422199,16.6996948330466,106.737679941386,86.6312669996313,50.9928413751732,-77.7706503181401,-61.0881177114768,37.3989916696096,-101.182342400389,103.987493802321,2.97949265173461,-11.5561928688083,-27.3471463873390,5.37012710036080,-6.34340333100068,-13.7131905128056,-19.0517962928392,-29.6311329465750,7.69878033341266,-14.4593311485824,10.1957529113080,-10.2939075635079,-14.9084048011986,9.73170089668810,-6.65325710979094,0.374113476764259,-9.41978880021166,-5.48574119631068,-1.89157945760051,-3.64281982462861,-1.10235479823674,-4.12689719450313,-8.49507477134974,5.289820701989167E-002,-0.119055260029555,1.71671360678105,1.76171656311531,2.50395172457561,2.49848954022396,0.633388867152382,-3.15146252720576,-1.11355148279849,-0.233981506572849,0.641597565024597,-0.561392282195158,-1.40523082706700,0.405655458269700,-1.27879138159283,2.70344748681786,-8.934631352558564E-002,1.26851810432489,-1.56068615157235,-1.65622481088726,-1.04624253662094,-0.639191711032319,-0.118947717285920,0.355347630463658,0.264831387259558,-0.991848632107328,-0.561502280213596,-0.389564636048474,-0.117022302430301,-0.111305804029423,-0.215857389820766,7.196624861939080E-002,0.179741456135656,-6.695779156227982E-002,-0.232290145923693,-4.476351747113349E-002,-0.227683690715563,0.113562588450539,-0.293316404797954,0.194922920229461,-0.434610994719507,6.096438778739640E-002,0.225544633442971,3.103823512789009E-002,1.301923421332550E-002,6.514592884994520E-002,-0.186763286854504,8.106720470940794E-002,2.437783056542495E-002,-9.106833283553524E-002,4.517529944204534E-003,6.934157449083744E-002,0.159674469536087,0.184391608745169,0.207882855481952,-9.214672803621782E-002,-5.790056587061927E-003,-0.199908392415544,-0.125498302626216,-6.552556119420097E-002,-1.186818036744816E-002,7.856319373478779E-00],[-32497.5372062653,-848.586436922224,-1513.50389002884,-1766.70063216154,-195.017793144901,147.862747045782,1763.41177784727,-526.343382477077,305.024537276096,-167.456333678567,1520.02083760507,-434.287028721365,-358.244552980975,-460.225343975597,150.135490088119,-281.684647356675,-186.830431302117,80.3221590817367,15.0181287205663,-51.5303679833246,-43.8318796377434,49.1485290177523,118.149587993573,-242.207861396309,92.6659079460183,-66.2247986285504,24.3373293756604,106.324746056275,90.9114263375125,50.7238212666510,-79.8094186596902,-57.3935793734759,27.0135518171222,-93.6771286591150,111.048016781090,1.01119574996154,-10.8520195378961,-26.4025276513070,4.87624251230090,-2.21058048636716,-13.9109388994053,-17.9875357056773,-28.0976260464405,4.80517287896252,-11.6672407873853,8.88551010041829,-10.0759276696080,-15.0045982805503,9.73018938175912,-7.25081830155371,0.569765417801954,-9.64307509438242,-5.16708495848529,-1.49903601837969,-2.63523465523219,-0.450378267596956,-5.13051565999464,-7.62816848638598,-0.441547451556739,0.179040748529349,2.10998036668697,1.93737899999941,2.84029813858976,2.70739933023617,0.501379979578493,-3.22734946551488,-1.18040547309943,-0.121448779935554,0.558001643363571,-0.516412851635854,-1.29176763902199,0.380221456370388,-1.18042931752711,2.52312040185811,4.576483613333471E-002,1.42842078816702,-1.61835034425005,-1.48683464832735,-1.08021454600333,-0.617533281894278,-8.779752660579764E-002,0.386929067276403,0.213919764585205,-1.01153062369631,-0.612772392955278,-0.402097887836654,-8.657352519448243E-002,-0.152159804311103,-0.186560203297109,5.514696586996618E-002,0.128359637063217,-9.472285523924760E-002,-0.169384439253313,-2.995589590087469E-002,-0.187415590338491,0.144963429069251,-0.296543995538412,0.192343832020869,-0.434427647330445,7.168839709937674E-002,0.236503876670687,2.609929653940561E-002,1.137128408796648E-002,6.208505334138573E-002,-0.206846398906914,7.125958910442907E-002,1.206208913273718E-002,-9.296457856313484E-002,-1.866314408582026E-002,6.877961326250340E-002,0.158531103653676,0.205308740280347,0.218968836275015,-7.485368342664743E-002,-2.713929747103762E-003,-0.204606548923463,-0.132074500296367,-5.885071760603726E-002,-9.161154504955367E-003,8.349023868687756E-00],[-32812.6669283376,-866.266554270074,-1633.37392881580,-1666.56607207114,-246.971530940712,-37.7752696918639,1789.80991005024,-562.988028791941,329.326177718841,-289.147743340452,1441.65594212349,-529.401359063787,-341.633121602049,-475.642057354587,190.206786356539,-298.892006670210,-182.058450498962,80.0000512737801,-35.6382738474487,-42.3243382352455,-29.9533324435960,42.1701364588026,115.590631102012,-260.071748551825,82.2520350388183,-69.2194452579452,31.3391092434030,102.843291705709,97.3285354879855,49.0610105864374,-77.0186625076047,-53.9708071752602,16.9994653669039,-85.8690463856178,117.156696054284,-1.62833490706834,-10.2771107922849,-24.9351961819074,3.53968269055251,1.97948521154422,-14.1182459105300,-15.6640572402914,-26.4843727201006,2.26038151068141,-9.58270393886233,7.47328171132483,-9.98112351480369,-14.7792055945204,9.61228165600505,-7.78408797116418,0.762851236677988,-9.79327866658589,-4.77119988819593,-1.23376663207881,-1.43058052314558,9.177673115886231E-002,-6.05239814177117,-6.97295118743458,-0.894224405077999,0.450651142599516,2.66245911547209,2.16953887480922,3.15996993885786,2.88089307368718,0.365755834391392,-3.25529805278142,-1.22385276642236,-6.818740639810258E-002,0.490917486939483,-0.469549248911793,-1.18382722156907,0.380156022726517,-1.17814470933648,2.34303609291408,0.126276128490478,1.64063396050142,-1.64729009887422,-1.28129531445736,-1.10565461315048,-0.588245271680513,-4.021877745004133E-002,0.415160678568505,0.167480976999858,-1.00334302385791,-0.659168963448026,-0.414407117287997,-6.604169964554571E-002,-0.187198347072048,-0.159123139688401,9.887534498988807E-003,7.507218943351564E-002,-0.143558056771267,-7.765213784608345E-002,-8.341334477544230E-003,-0.133751452037953,0.180183766981275,-0.304309486131561,0.185340485643712,-0.432203780108153,8.359669888703802E-002,0.247008631300516,1.902302224718308E-002,1.210039907348917E-002,5.925088767663475E-002,-0.220775571406141,5.597775554759089E-002,5.628472779361177E-004,-9.311178308317042E-002,-4.730816149141025E-002,6.462698234192371E-002,0.148752004121403,0.230606254192297,0.231137444931076,-5.322190059423197E-002,1.810052160617012E-003,-0.208576931571298,-0.139208257179580,-5.002395699095277E-002,-6.378540117937185E-003,8.863182088691367E-00],[-33067.1683589474,-893.646493445522,-1763.73583549220,-1528.40972618868,-328.670093597060,-178.072468607673,1825.42634756279,-614.632041690170,329.507960245872,-376.756039458007,1344.34701920573,-621.306180676605,-295.479407731173,-487.283480602135,232.907190361430,-319.833525988001,-176.968791985331,83.3303102994061,-95.6766663513183,-25.6144772442313,-17.9817240542661,41.0085943631426,114.592007293516,-270.515913703935,68.7477036386677,-72.6698225688615,36.5295913798205,95.6366305557909,104.499380055282,45.4109081021054,-69.1559347819778,-50.3266070446712,8.47823350012279,-78.3113651603496,120.595506928423,-4.57000839605946,-10.6623063271470,-23.6638567930586,1.52498405123026,5.64787761108682,-14.4725682479913,-12.2441357647291,-25.1818563585989,0.380657631690654,-8.49940462409076,5.89417026872434,-9.83484296951089,-13.9389067688674,9.38510245106226,-8.40997717776021,0.809895451816742,-9.93222735081382,-4.56726488036213,-1.11649663154386,-0.187144258348120,0.368100213590369,-6.80312243711663,-6.62606729667992,-1.33532132905784,0.604102703142149,3.31070879702903,2.41957936541298,3.40959998990436,3.05319459038987,0.220645151909561,-3.22888864406689,-1.26485081159467,-0.116191794132440,0.412051268900248,-0.458824658684222,-1.10931570893296,0.385585834571334,-1.28921547643904,2.15607304464299,0.139638455905039,1.85200750169640,-1.63008146720280,-1.07573235936559,-1.12124792599819,-0.539496790277616,2.471020932632547E-002,0.449349605178852,0.133739400272339,-0.981099677280240,-0.706147135240975,-0.421758940200573,-7.703142206189097E-002,-0.216671502247014,-0.136127172535337,-5.654130762708343E-002,2.373559151175771E-002,-0.207694852655887,1.935716240707296E-002,1.400536340232017E-002,-8.341741418985685E-002,0.208046092880841,-0.310073897236418,0.176916656790080,-0.423881296075268,9.527587235389524E-002,0.259655906924367,1.624172031835130E-002,1.344379236435398E-002,5.673326263087744E-002,-0.228811701862971,3.301968264090432E-002,-7.524733627770242E-003,-9.441529868183629E-002,-7.616457496136030E-002,5.714169117875088E-002,0.132160658203592,0.252618765916453,0.241105978310246,-3.100487983537838E-002,6.011332672044407E-003,-0.211871664306782,-0.143542598387960,-4.195701149796966E-002,-5.133858656094611E-003,9.306443433046672E-00],[-33279.1438317160,-1008.12065367561,-1955.64100493234,-1355.66983336757,-476.449820034822,-277.754159561043,1866.32656736411,-692.012142814265,297.201816282982,-419.772400372141,1241.00940281945,-690.230357689370,-233.064439882327,-490.476543327364,264.080904409684,-343.464694337175,-167.274047064072,90.9461064222274,-161.328063660888,-10.5084625859179,-9.82639294772163,43.9916970531288,117.881972672344,-265.359581647045,53.3604898945226,-75.7817446778436,40.0538261269253,84.6878722878505,110.623902893126,40.4110456811713,-57.1008698357207,-45.4672388303674,2.51206494863356,-71.7108528167953,119.989605180754,-7.47528827804641,-12.2428631883219,-22.6633866818244,-0.818858115785746,8.60828720195495,-14.8271003094513,-8.17707714485134,-24.2249505644766,-0.384060068521517,-8.53671388345511,4.22108719479748,-9.51037048887222,-12.3049687797121,8.98172790430263,-9.17917899150205,0.659527243401634,-10.0355866389846,-4.57440675670604,-1.15660751366719,0.976095837190883,0.382339013154090,-7.30355081113771,-6.56841280365708,-1.78743463577116,0.531276651538481,3.97494235988203,2.62972027588432,3.53282318615554,3.22929055326122,5.919629187384904E-002,-3.16265346296443,-1.30454166384267,-0.241231747218855,0.292488271272854,-0.486775365087515,-1.07767346154829,0.397498487459622,-1.50684268272852,1.97079097998236,8.808350818086885E-002,2.01221092632861,-1.55140836310668,-0.905998767042331,-1.13076783463494,-0.472879988579176,0.106588944237007,0.490360554486577,0.106221111703275,-0.954854085080559,-0.752415822137410,-0.427350059161656,-0.126587626607593,-0.245803193971856,-0.115272962890402,-0.130446357444508,-1.966614812797253E-002,-0.278302928765317,9.632288147377537E-002,2.739095158757173E-002,-5.321421243595863E-002,0.216440652729336,-0.309403054489919,0.171314035669777,-0.406143817058898,0.106208677467000,0.274768754279069,1.944251220315388E-002,1.333380884933152E-002,5.153330519933755E-002,-0.231861436728485,2.616033292913156E-003,-1.248739151136742E-002,-9.754524952619487E-002,-0.100620593205756,4.760874074231639E-002,0.112067141521189,0.263403016067793,0.246025663716953,-1.122971268512761E-002,8.158662048124410E-003,-0.214873808078290,-0.141810598659510,-3.827016695777513E-002,-6.761068858799025E-003,9.526772009440243E-00],[-33391.1588957696,-1169.54223626129,-2221.74920956425,-1166.26768939252,-683.584067105530,-313.858670519813,1915.73626361655,-794.497868706973,240.549806851758,-408.141168292115,1148.94353626208,-730.984402425350,-162.027338598032,-482.911698475886,286.082880365633,-366.876325152680,-154.309440242465,101.902861250607,-226.206182203127,-2.90120092449439,-2.26108903527756,49.9894630891300,123.856145883461,-245.617141990222,38.2695314405813,-77.8843875010103,42.9570645074182,71.5883536391974,114.899419292210,35.2622765231879,-43.2205573419611,-40.2745052148862,-0.104683141355111,-66.5182685915345,116.652365613870,-9.97953009286080,-14.5067550586464,-21.9391939357360,-2.98427726801102,10.7542387304034,-15.2027779131104,-4.04000020508003,-23.7425358947938,0.238537631293979,-9.70181569482035,2.68739790664329,-9.25504441535258,-10.3176557494919,8.43690378008092,-9.95668256770209,0.368729611906769,-10.1681878498605,-4.68245091958829,-1.36762000083381,1.88699595561965,0.202189391324541,-7.56248157075050,-6.80060153629236,-2.21023484404063,0.210075005540074,4.55470909689861,2.79589428581563,3.54237340499028,3.39812323554035,-0.103745030947975,-3.08353989794668,-1.32778476394237,-0.383737869892770,0.122793607009555,-0.540131513682959,-1.10356130696321,0.411425866984018,-1.81022770606893,1.80758459280492,-1.644122229221655E-002,2.08305316012603,-1.44023733009795,-0.790730301592530,-1.14578525214239,-0.404923022660105,0.191069797729503,0.532118487074105,7.707145755782628E-002,-0.930078999947715,-0.793634489103957,-0.435482179361845,-0.205787415034869,-0.276116523790871,-9.702471039114603E-002,-0.202104324998883,-5.638803193704326E-002,-0.350522038671557,0.136419146462414,2.609690150038024E-002,-5.110827032716975E-002,0.209458646132131,-0.309633997658579,0.170171895642755,-0.383871909649389,0.115564627412414,0.290454345497492,2.655382228561288E-002,1.231893376133686E-002,4.286342510821856E-002,-0.231403930547277,-2.868937922592163E-002,-1.635197630427792E-002,-0.103963294836750,-0.118469645205919,3.614489766784836E-002,9.267378728778708E-002,0.260720283082388,0.247131008481622,1.972710514220371E-003,8.027187821679927E-003,-0.219542877818464,-0.135473679441137,-3.914071206545094E-002,-1.016217422101268E-002,9.566697434058810E-00],[-33481.8265200524,-1256.81265833564,-2555.84453845429,-985.374703268224,-923.004573477339,-255.824777957868,1985.62672800578,-922.171531645035,174.571926188605,-337.961257647318,1082.23137097177,-747.229821189256,-82.8133984064045,-457.966490836910,306.718579718168,-383.003524933768,-143.421783845084,117.764204586917,-283.808678849645,-4.38577616992898,8.59871573578440,55.9737648533168,129.512668572247,-218.198437369382,26.4315503520323,-77.4700649844947,45.9756982227044,58.8111456012854,118.026466919453,30.6902078564454,-31.0223671121403,-35.6997506276597,3.041405257740992E-003,-62.4566780675646,113.026085120867,-11.6779624808403,-16.4140976387280,-21.3173011985186,-4.39173442813302,12.1339601199057,-15.8012413142611,-0.533690750013445,-23.8065361796962,1.74269597635813,-11.6212701750950,1.74475421703993,-9.35589642157589,-8.40420573922381,7.84771845426051,-10.4510291650508,2.443199086720401E-002,-10.2847586210632,-4.66568390970495,-1.81778888343032,2.38235621392439,-0.122933967511236,-7.76659018036496,-7.21731280033914,-2.52834449948188,-0.245227984477842,5.03202359500277,2.91875930508964,3.51091374473442,3.51276570582968,-0.232622630812907,-3.01723342281033,-1.29867108273197,-0.494245754075967,-6.855938527390470E-002,-0.580270470969414,-1.21637249637009,0.403715585404337,-2.14728875787783,1.68002210278462,-0.132999283769005,2.08696921120579,-1.33537282426244,-0.703295837215447,-1.17676118177504,-0.348100117564629,0.255781480392071,0.562738341697149,4.363324172716310E-002,-0.904768343325848,-0.820927438579919,-0.445984015347428,-0.289206539243273,-0.310432617277647,-8.458097603292337E-002,-0.267113822872909,-9.154260281563360E-002,-0.412588167181658,0.143570386723046,1.131951355327935E-002,-6.512636161766708E-002,0.192583848468872,-0.315663689073156,0.168973065245686,-0.363660609612326,0.120220925998936,0.302314601956842,3.409076837067719E-002,1.149316418620616E-002,3.170169097847355E-002,-0.225699729659742,-5.070517215020524E-002,-2.222957151144120E-002,-0.111444528890616,-0.130884209190315,2.229305239204296E-002,7.838794971580824E-002,0.248184314338509,0.247862663805601,8.112574857789127E-003,5.424941008483827E-003,-0.224645667628247,-0.129652103974147,-4.210819879019545E-002,-1.363705311161876E-002,9.485530962411434E-00],[-33676.9260315806,-1197.30633257196,-2970.70545012828,-832.231002276687,-1176.89860787274,-137.802674524040,2101.71498441523,-1054.34407353363,100.709315691829,-221.648607826522,1027.08145511284,-746.465532872119,-0.698574589958566,-419.245791126633,330.501400206114,-384.057233987730,-139.011432922701,137.942542920266,-333.426119933428,-16.1904859871371,21.7301814193673,59.6227481610261,133.156818598254,-188.298248557190,19.8441127523102,-72.8535942723823,48.7606288761572,47.4976334843981,120.211839882307,27.1458427370445,-23.1569887795314,-31.8793003632154,1.78009043902645,-59.4554044033800,110.504816917615,-12.3929152240517,-17.0048125734174,-20.1294008104010,-4.79297391880819,12.8288140059217,-16.6270168141872,1.79836754800229,-24.1804521825793,3.19004907914632,-13.7835836091454,1.61917674474901,-9.98999621017115,-6.64280180520106,7.24760362594225,-10.3790395585454,-0.252912370150106,-10.1557167660298,-4.26482619029393,-2.49002013076373,2.43275391823471,-0.468193557961267,-8.18881715115277,-7.65446706095772,-2.72481676657244,-0.730418146916725,5.47999134298164,2.98884952290064,3.46147307349921,3.51025065582769,-0.305544690660494,-2.95539132360447,-1.16963947317467,-0.529212777969898,-0.230595269395464,-0.572748837256810,-1.40213862039664,0.329558749484093,-2.44184267197120,1.58608171657930,-0.220146669989934,2.08530116001835,-1.25853383163157,-0.623832638827948,-1.23442635950395,-0.306547962953922,0.287407688084765,0.566814927220034,5.784953579158415E-003,-0.867813950336698,-0.823123120192737,-0.459571410791335,-0.348752955047284,-0.347071738062082,-8.209625416918512E-002,-0.317879696439611,-0.130908454619482,-0.450708879910502,0.133316319520171,-1.176489951082686E-002,-7.679865095103011E-002,0.165355614981254,-0.324856165745591,0.165375731004713,-0.351108954672892,0.118343345436542,0.304317987378756,3.742049867047179E-002,9.970033913418034E-003,1.758626719783073E-002,-0.212608427516532,-5.681546636213807E-002,-3.175348762326109E-002,-0.114631252622921,-0.139872517413441,5.683553091877533E-003,7.203193806502692E-002,0.232654787522290,0.251068093615067,1.163024862720707E-002,5.116604679159355E-004,-0.227289964859428,-0.127611206942172,-4.578937019109308E-002,-1.674582607183529E-002,9.247563556791136E-00],[-33951.5167272387,-1063.14997414421,-3382.19141945534,-759.065081469768,-1420.03503734294,-30.1806592713732,2265.25381477900,-1113.20547951910,14.1289330769451,-99.9527372068195,958.337535916887,-745.778993132346,79.8443848425261,-388.441051304170,363.480811160168,-368.569837228838,-143.121543729653,153.782949458820,-378.523210595696,-36.5636978316210,30.7736078434390,61.1836732890436,131.513276481892,-160.305275130244,18.8502508077844,-64.1391996781407,50.1480051649119,37.1858820924471,119.530137694900,24.6952683817913,-20.3476633403248,-30.1594950732384,4.45056657494912,-58.4625773391046,109.229468871767,-12.1181208948612,-15.6749006123531,-17.8945196458274,-4.45651427641483,12.8708561530773,-17.6628468214673,2.55972293318424,-24.8107755453333,3.66854405900132,-16.0786078292627,1.94858195633904,-11.2885052822706,-5.23618317750286,6.59149131886170,-9.64314458380391,-0.314608418879938,-9.60601880779404,-3.46643127227471,-3.20868801939674,2.09296484948576,-0.712285511568366,-9.01202313294835,-8.06667485967373,-2.89587381775318,-1.23640239283340,5.88098630816203,3.01386181658619,3.34000493335933,3.35532271095825,-0.325556580513252,-2.87104755052932,-0.922059100948774,-0.447722352960330,-0.334170710103557,-0.519706743247368,-1.58790109976697,0.140707017086037,-2.64095590367727,1.50036349785222,-0.274296878857199,2.10024676728088,-1.21743121708282,-0.581285007644512,-1.31780512324169,-0.293481919798388,0.283961378470436,0.530429492182407,-3.324690512409379E-002,-0.812212169503066,-0.796268637358913,-0.475752931628697,-0.364632459628873,-0.379207814759413,-9.242933832997038E-002,-0.345802817774420,-0.181894159057018,-0.456778728384274,0.114331632070958,-3.131807260391115E-002,-8.360911487990014E-002,0.134645358197321,-0.339206458324194,0.163718102546957,-0.351149457529644,0.112725268622401,0.291530699177776,3.345717073780297E-002,5.810617501765800E-003,1.302824205658051E-004,-0.195285586210702,-4.776448144147202E-002,-4.249490900083169E-002,-0.109933067675646,-0.145138306379491,-1.231542364794849E-002,7.494534331741810E-002,0.220309049840520,0.259698811278257,1.565094382431917E-002,-3.368718797583620E-003,-0.227691763307839,-0.128220972591452,-5.035572699311882E-002,-1.900832319790246E-002,8.836553120337019E-00],[-34239.1172141179,-957.971040857148,-3697.76745119414,-764.786686586591,-1633.20803414811,38.9711927504328,2404.35249725556,-1067.61492565377,-86.4725398661138,-7.71297547191226,864.009068292105,-767.963573373143,155.723608454199,-386.948300731877,401.835101227221,-343.489514632087,-155.077745635492,156.622287847750,-419.073246980039,-59.9776919383939,30.3988723294657,60.6512985413440,122.184528006852,-141.773360491785,21.2513579285558,-52.4989823904412,48.2553472324591,28.0314689647370,115.216347942530,22.6193631589709,-22.1084231904885,-32.2206301814875,6.58810567991548,-60.0098185797080,108.874325516838,-11.0974476558472,-12.6153304196465,-14.7681707537383,-3.78194471518402,12.1256080382181,-18.9019222809762,1.68944944073686,-25.9684872042786,2.85443854901777,-18.4196274900409,2.20866984149575,-12.9324262160058,-4.59790232642981,5.88968768537806,-8.38466297598578,-0.135520516409558,-8.66860315586884,-2.53989770901125,-3.78468172702076,1.42961284499382,-0.827803334205275,-10.1099519092393,-8.46277037589019,-3.10005295047540,-1.71446047731538,6.13516338613511,3.00628886349658,3.14953904969365,3.06585075541952,-0.313290700470111,-2.73686464571868,-0.601256126266824,-0.276193679355562,-0.357643730226601,-0.452237081354007,-1.71066862396114,-0.152504440478533,-2.74291236251685,1.41153056999843,-0.314734405476707,2.12618731575395,-1.21308084913585,-0.593549334042487,-1.40185170051112,-0.314814664404544,0.252770743325166,0.451671097899191,-6.133107853602354E-002,-0.740482692418674,-0.739980723403979,-0.492283356997014,-0.341458970084641,-0.396074822872277,-0.120944687680856,-0.351903758953844,-0.237900320634219,-0.439363984814440,9.519373177631589E-002,-3.994235189176328E-002,-8.883419764418753E-002,0.114184215219929,-0.357911839582545,0.166405542342695,-0.362216769004588,0.105043755535397,0.264210060302417,2.360732804947447E-002,-1.361026865080218E-003,-1.749876723051038E-002,-0.178422062663275,-3.077147337435239E-002,-4.942488937306568E-002,-0.100321280634835,-0.145272156320791,-2.782561037239026E-002,8.325011391112619E-002,0.216430554870516,0.271655175919814,2.116958948158165E-002,-4.041549680949939E-003,-0.226913700933409,-0.130377117718999,-5.516773859021113E-002,-1.992278883745272E-002,8.397519119707887E-00],[-34525.1077693303,-915.056124939898,-3948.66173193514,-788.724116067114,-1803.33612850135,102.169771378625,2458.17450641757,-976.233569814212,-209.020290879677,55.6481575320743,742.717112244334,-810.026525064179,227.488806840656,-413.789467722060,436.615770216843,-319.552661342195,-174.448805875566,147.409672709915,-451.485475495751,-80.8365463988284,22.9409998775580,58.5139989123201,105.862590300842,-137.259094897883,23.6326766364963,-40.3338692295110,41.6195545602269,21.1959190869987,108.681012114344,20.6938175332536,-27.1022396297911,-38.0757796859886,7.44031596038583,-63.4012998290225,109.222392994477,-9.78416617548308,-8.85633741461524,-11.2481099800519,-3.31085560047619,10.2084912840098,-19.9965662735951,-0.453647210075444,-27.8329576847956,1.38451753217281,-20.7252105551251,2.32510250176791,-14.4806149023861,-4.81807399391201,5.29128186380517,-6.87155602903513,0.174002607943342,-7.56881918640570,-1.77245912831088,-4.15989242141438,0.484680529732365,-0.874477648287294,-11.2182320924964,-8.90134723395007,-3.23697238531726,-2.12472118840719,6.21150355725473,2.97533860605876,2.92615928435681,2.69688876819456,-0.283644601314429,-2.53630068285955,-0.296640178282326,-9.894442178936923E-002,-0.289404064151362,-0.444010544954041,-1.75751831637935,-0.498886531771532,-2.79352718692806,1.35409066644707,-0.368499785391946,2.16980000648791,-1.24512230445858,-0.647001333224537,-1.46118084444474,-0.359271748154104,0.206305089190845,0.347052942885015,-6.563778949987394E-002,-0.658548443402932,-0.657753588896801,-0.513098877638222,-0.305224004847513,-0.388101847098202,-0.179059456544745,-0.345651271436158,-0.280487319096800,-0.423023468652021,8.962524184856691E-002,-4.420878811730303E-002,-9.542453917040489E-002,0.109596709049481,-0.379371850319903,0.171530079889957,-0.379270493529055,9.448593722935801E-002,0.228182098636468,1.064301222179798E-002,-1.009811571433377E-002,-3.048229889579646E-002,-0.163977333336321,-1.360496511166799E-002,-4.937718770507668E-002,-9.309440992106539E-002,-0.140854364599120,-3.869701472498101E-002,9.094639187956086E-002,0.224042571217982,0.281056567544397,2.706944986658089E-002,-2.809646616976429E-003,-0.227325554200407,-0.133279169633911,-5.936728300053681E-002,-1.889194387262987E-002,8.095471732811410E-00],[-34622.8860629141,-888.792735110803,-4104.43519414769,-799.091175970224,-1867.92705274855,204.063636731959,2451.06159543550,-870.141432319360,-355.502823462182,107.932460744431,614.053921246866,-851.111679144799,303.527781920021,-457.911329648745,468.119225507460,-307.549372290201,-199.531906495263,129.667532775707,-471.216466955012,-93.2338129141992,13.7270827658743,57.0934103577594,84.5638093038742,-146.145373175567,23.0964320125722,-30.8487958618388,30.6283805052361,17.0981245028115,101.014383721575,19.4327793327896,-33.1974927491510,-47.2346248610864,7.64417371693338,-68.0057482787322,110.265739696308,-8.51616733591680,-5.54276132794450,-8.10477763458326,-3.42180459249984,7.02750196029821,-20.6963735050816,-3.27855921593917,-30.5853819171835,-3.308967636265434E-002,-23.2279731781273,2.31966145118356,-15.8034312618339,-5.72311164308945,4.91098114914883,-5.40045105009780,0.519212035346488,-6.59971170595503,-1.43683582941134,-4.29827114988017,-0.740326057656904,-1.00314146807870,-12.1745744383066,-9.52722035533283,-3.22844432938395,-2.47085455910446,6.14061100239897,2.95796144592982,2.67990712459774,2.32739401073900,-0.232879911863095,-2.26887565847879,-5.996361577601019E-002,1.294804578087782E-002,-0.145960023656495,-0.567731728420693,-1.74912093979427,-0.866168498872639,-2.86989465439081,1.35282092801769,-0.461570942687782,2.22005730408079,-1.30760212005440,-0.735931432376661,-1.49328748403025,-0.412735790502521,0.155142194274027,0.243283472258662,-4.025863611010101E-002,-0.573201760649604,-0.561541213955255,-0.532293789381669,-0.285335070039172,-0.352023017830665,-0.270054279815942,-0.344818774508482,-0.303132082466845,-0.426967885202203,9.719399887967553E-002,-4.727966472429090E-002,-0.113849791125685,0.121239628020791,-0.406402566743195,0.178261934825282,-0.398962819147756,8.136762695066987E-002,0.189978355041370,-1.420752286592362E-003,-1.766234122463545E-002,-3.417535537902889E-002,-0.152714544839051,-1.208741026214224E-003,-3.968005148674671E-002,-9.523918165524217E-002,-0.133256862356104,-4.533483690238382E-002,9.460566568515935E-002,0.240006618350566,0.286270621766893,2.844820705105647E-002,-5.001300290969306E-004,-0.231998981967020,-0.135731554494621,-6.179296583031146E-002,-1.581388331934959E-002,8.034608588026582E-00],[-34777.5974526172,-916.963309467893,-4200.53695325883,-770.477256429360,-1883.48707099422,349.041403082811,2410.85167332445,-782.885913007465,-521.848054477408,155.741870085582,483.356251811494,-868.862822305280,365.813235508141,-499.881710152911,486.997468525145,-305.017787770511,-227.327235186551,111.800144801633,-477.194424825803,-102.366481676765,9.13412872664630,54.7390260536716,63.8009493985241,-164.161274148890,19.1287898324153,-24.2074878172048,16.5629710453301,15.6618468073871,93.2236996886487,20.1872907457006,-40.3988789803011,-56.9998562837623,6.52439177647108,-73.2077685030345,111.410979475551,-7.64786847576282,-3.33976953665188,-5.35267186151302,-4.26830912842234,2.88401760837055,-20.5822084651772,-6.64204896791181,-33.6498680621768,-1.31792981867139,-25.6444526762751,2.40371233215875,-16.6812570589815,-6.76848490839960,4.71875921771630,-4.12065155873751,0.743895907613160,-5.86085761805486,-1.45165710821504,-4.27498662549349,-2.16072660896290,-1.20385588566918,-12.9530495737412,-10.2618909982459,-3.03158452918361,-2.73829014901837,6.06346866999958,2.93958628295480,2.43871119797616,1.99232944913107,-0.170968432728220,-1.96849040800046,6.923131841019287E-002,2.935287541206676E-002,4.219851838807009E-002,-0.814856788228728,-1.72372555792244,-1.22544316596873,-2.98748393897090,1.41537843865090,-0.569652015394098,2.30322639592018,-1.37366577920405,-0.840617517958954,-1.50392717866099,-0.461306827328834,0.114236999447495,0.154296356589895,8.158031632817630E-003,-0.489434479535076,-0.460754087831691,-0.557717622803125,-0.292917452591589,-0.300305605773441,-0.387293866304651,-0.355804617793647,-0.302373446297327,-0.447793506595162,0.120454143882327,-5.086172499964801E-002,-0.141129181035853,0.137672120623506,-0.430380921269788,0.184273479473469,-0.414966575787629,6.602188462454855E-002,0.155184245683918,-1.072440679494114E-002,-2.276407496895153E-002,-3.121450317991768E-002,-0.143053617234462,4.434548175332061E-003,-2.331997678554917E-002,-0.106126933257987,-0.125682133760839,-4.946320917478929E-002,9.322960752401245E-002,0.260252624744888,0.286532120181974,2.499227323070920E-002,8.248565076077336E-004,-0.239753582485448,-0.137945874768958,-6.247609035775995E-002,-1.228901145003451E-002,8.122099053493416E-00],[-35060.1962885905,-1013.34074323065,-4180.73453024405,-721.154725603119,-1884.48072338783,524.769907938064,2361.19740498335,-702.791198710741,-693.047263675923,200.248554657437,370.366869773118,-849.075832021285,396.680281604459,-527.096822141798,490.171404708330,-305.516350141653,-251.293604248246,98.2525419007384,-467.995229175379,-111.504715309315,12.4832223571599,52.9966192141153,48.7972851325219,-186.042943844095,13.0824827097527,-19.8726721587442,2.02064021704671,16.4587860304761,85.3920132651640,24.3771450111016,-48.6550480831791,-65.0479067253716,3.57258963629764,-79.0530832123824,112.208033259712,-7.11554735075866,-2.26610697595623,-2.97430986545155,-5.52425394409604,-1.61336312665388,-19.5619643281521,-10.4881691072478,-36.3858596060739,-2.51402592984669,-27.7467461339540,2.87166166154261,-16.9805481775916,-7.46781419787261,4.61837105811781,-3.04135031859555,0.747038099702960,-5.38136106356569,-1.71246380440936,-4.11596028578280,-3.68486917449547,-1.40911527738374,-13.5032210451907,-11.0235712059057,-2.59333637362590,-2.96561240721923,6.13157205496216,2.87544980112856,2.21830451974869,1.71428239867992,-9.396878470137560E-002,-1.68516759091652,8.843486491357715E-002,-1.196116298616663E-002,0.216082416954924,-1.14151976293184,-1.70714137886539,-1.55905560455407,-3.12836186548701,1.55686713285661,-0.673390733275766,2.45166485619232,-1.43206187479177,-0.954570584057414,-1.50452856161531,-0.498694040525050,8.408350808551844E-002,8.707672874267436E-002,6.449889633762462E-002,-0.413931669448149,-0.361018946777993,-0.593471061714976,-0.325167238607719,-0.248814303421324,-0.512509050225196,-0.373610506895204,-0.275946091602392,-0.476907163668616,0.162696126367010,-6.268634679920743E-002,-0.171468678557631,0.144843704243075,-0.442094455411119,0.188774950994395,-0.423898245237995,4.837542210918678E-002,0.126428230780766,-1.645186121882540E-002,-2.421702186126578E-002,-2.439667253907332E-002,-0.135932036863943,5.891611630777087E-003,-4.230344474807544E-003,-0.122745622355039,-0.118333037736096,-5.149501808372935E-002,8.718058781378596E-002,0.282716254857744,0.279618852941595,1.879496898362502E-002,-2.392140413552268E-003,-0.248974481301433,-0.140788005748173,-6.362528510425096E-002,-1.016468262236535E-002,8.210300269191181E-00],[-35359.0281620240,-1171.03032234071,-4091.37927155135,-669.161684540242,-1884.98778464733,680.442116509195,2291.25748523458,-608.836944198095,-848.310931962790,234.047512571557,272.612343856747,-800.069104930273,393.086735599195,-534.959287886032,491.147207390810,-302.367495537424,-269.481156140956,89.0127044775140,-448.310939441068,-120.572582500249,24.6532727338645,55.6407551324952,39.3015516353664,-209.325016239075,6.83767276479155,-17.4172707912834,-10.8901419733693,18.9592025897860,77.1984051525095,32.3980491621268,-57.1394698003980,-70.8731294171912,-1.23906855135407,-85.6234163852223,113.149570303172,-6.67383922869132,-1.84238150118369,-0.676891498550082,-6.90266605525683,-6.09121098315134,-17.8160634187927,-14.5610877442008,-38.4572953132773,-3.58609102753736,-29.6111634032247,3.90957526018994,-16.8309264203104,-7.84827067220379,4.59297883738925,-2.05556246706445,0.588374783037926,-5.10010896919843,-2.17061221998833,-3.83547469635948,-5.16835550071464,-1.51938353568261,-13.8008826110701,-11.8144251666799,-1.94775062951362,-3.19687890754234,6.31032315775543,2.74903055099727,2.02462271231090,1.50960094491225,1.873578282434728E-002,-1.44636525537249,3.125324064637936E-002,-6.643233199666751E-002,0.356451296547785,-1.49980829957837,-1.68670371204691,-1.84798675169531,-3.28496221846411,1.75848268037996,-0.769502610275687,2.64487981600757,-1.48664986026095,-1.07391749092549,-1.49836899055875,-0.528862974908473,6.032025674671369E-002,4.287586779871103E-002,0.116938022791243,-0.342307777704367,-0.264014875821733,-0.635183295087758,-0.371924265464738,-0.202500028179660,-0.630937561498156,-0.391465449237005,-0.234593496061134,-0.511770742861209,0.214772671597450,-8.664574031155677E-002,-0.202354809809437,0.140538745799218,-0.441298036818487,0.190548876688405,-0.427058086815249,2.785234349385558E-002,0.104588439703044,-2.122550368823058E-002,-1.985135205753787E-002,-1.501074017939348E-002,-0.130728037725622,6.050804465084356E-003,1.644947291974438E-002,-0.141484590265136,-0.110324337870099,-5.329840332732960E-002,7.653023967330042E-002,0.305414808750570,0.265877045799676,1.124420480377973E-002,-1.070022175124164E-002,-0.258730680404519,-0.145369558341378,-6.644832219037661E-002,-9.481234394925837E-003,8.255038584545454E-00],[-35690.5139438048,-1356.68808699377,-4036.19042014185,-607.546736790152,-1884.86385432124,778.640934121769,2198.10927195512,-506.281374297989,-972.366793171953,245.423743792338,176.281870074279,-735.280370486954,363.472148356175,-527.633914292841,505.803434948575,-290.693230212400,-285.227181585029,83.8831566288566,-425.715830720574,-127.839351414083,45.5994452791402,63.0454700508585,33.9676949226499,-234.340558011301,1.61758381196610,-16.3906822594050,-22.2357607480822,23.1512441857589,69.6561874500543,44.3557692255231,-65.3973158268984,-74.7017670539063,-7.80543588653410,-92.9868641169870,115.336538261713,-6.27792556564155,-1.68193209714051,1.79741699072303,-8.49708710398905,-10.3078180999138,-15.5405635119235,-18.6591534417297,-39.8872146470632,-4.66746530187475,-31.5025305609033,5.45173440943731,-16.4547875009905,-8.24075619904841,4.65714112819260,-1.10593092866939,0.318590423352754,-4.96496196641811,-2.82118670070792,-3.47806551788736,-6.46914132149147,-1.47084687671166,-13.9907874112722,-12.6957292603321,-1.23334765252007,-3.40853390682302,6.50481673928950,2.59698009831597,1.87652643668123,1.37738345502073,0.173151294760105,-1.26550842738170,-7.809629684599557E-002,-0.149499529593559,0.486763032453359,-1.85120630989213,-1.65175195493416,-2.09570093026723,-3.48715651854512,1.98050418072523,-0.854759578203827,2.84909937665945,-1.54404104143825,-1.19491606732423,-1.48942659986332,-0.556318292311689,4.574730639394667E-002,1.918978966778930E-002,0.164449905539905,-0.265971066887172,-0.177498048924228,-0.681530584760331,-0.422284669669243,-0.162509606857114,-0.744994214293451,-0.415145527198641,-0.200227410084124,-0.554223718717979,0.261145584439017,-0.116600712256531,-0.233275212405786,0.133065203102207,-0.432453925166713,0.190307435250733,-0.430444844164802,5.431846150109284E-003,9.020222926777088E-002,-2.687959383595285E-002,-8.075796396569168E-003,-5.307694997899321E-003,-0.124793307628221,4.450925505995927E-003,3.996119673957270E-002,-0.160820078238919,-0.103883838158528,-5.943445798471796E-002,6.149946292098014E-002,0.327140502098480,0.250875840016732,3.303031777266714E-003,-2.169688254951415E-002,-0.268660614227707,-0.153037682726179,-7.063804089916058E-002,-9.937447256419431E-003,8.385842435718656E-00],[-36016.2208813011,-1544.38637946034,-3958.02464497005,-531.546494853209,-1848.04747846080,850.820978516602,2103.03509831640,-380.094626174826,-1060.03750727087,229.125149580213,95.3252784490486,-667.189612993974,326.909508684321,-516.416803491960,539.299620780005,-270.238753954203,-298.328282433136,81.3891322453195,-405.623059748375,-126.007950368628,72.3499797815083,73.4888360091010,32.3527853204593,-262.128806740765,-2.50123508266337,-16.5254520283463,-33.4785312696463,29.0303338907045,64.8506020509161,59.4941445095850,-73.1179570400546,-77.5541898153486,-16.1313732487002,-101.512537424067,119.463485439528,-5.98044621813101,-1.70414382148470,3.99407553649117,-10.3046353590990,-13.8534490688086,-13.3468968306788,-22.5357533305240,-41.2288152542006,-6.20130230359432,-33.7508521703475,7.03317633172172,-15.9758661379869,-8.90778888186324,4.78570005332752,-0.290522871453066,-0.141706893548624,-4.94766955961387,-3.78026843780829,-3.12258678440327,-7.46328384079431,-1.39592329309524,-14.3252979331928,-13.8040406578362,-0.680732123498857,-3.53253435418074,6.68067922574546,2.50513800935525,1.79598334107605,1.32475497697124,0.337772688695882,-1.14656127796183,-0.221667604985700,-0.322902100416828,0.612845683620752,-2.17344139411596,-1.64115878984223,-2.34120474138700,-3.79802332364894,2.16823228543161,-0.912660704306178,3.03561240376659,-1.59432140836951,-1.32444020823514,-1.48984336101162,-0.585725550327806,4.699526861825692E-002,1.195550890170101E-002,0.216709965440091,-0.184680582794001,-0.123792346052737,-0.727028852587738,-0.471892932330671,-0.136887881793468,-0.861644224603053,-0.463322755409727,-0.197493085832338,-0.603176214841267,0.282878876137378,-0.135981513420357,-0.267244799546351,0.133776941209777,-0.419371165310403,0.192274556514902,-0.439954736402109,-1.541381166254693E-002,8.340071637523312E-002,-2.916394452207728E-002,9.733417393241468E-003,1.401867205592331E-003,-0.115537057194945,-2.356831184099148E-003,6.947319172096109E-002,-0.181650601927634,-0.102867666954193,-7.369221694465530E-002,4.337320497697228E-002,0.345504306100915,0.243387183908654,-5.832045902818036E-003,-3.162275430432230E-002,-0.279278368969605,-0.164243472941437,-7.487107370633632E-002,-1.201030415262704E-002,8.797146291777309E-00],[-36298.6343559274,-1726.54991428172,-3805.16444243655,-456.086441051926,-1732.07793396294,916.583323721349,2009.23326800297,-232.869588560000,-1109.32120556675,183.833459908467,55.1259006099978,-608.310171756531,290.112172803612,-507.940506210773,579.829996011499,-243.385954894846,-302.455785845155,79.7287617597396,-388.600301409020,-111.011575277327,100.888987367811,81.0883301358283,33.8902813666012,-292.068909384706,-6.13688001637973,-16.7339650101927,-44.9882192167909,36.4818441761957,63.3480939287920,76.0049280126368,-80.5951493933614,-79.9125736912129,-26.1418641406305,-110.662222628367,125.420328298067,-5.71309025665626,-1.78313546054449,5.41852564583419,-11.8972462630753,-16.0776006854765,-11.9685447965799,-26.0537039206806,-42.8069166014734,-8.57466301618821,-36.2289302638090,8.21238910774767,-15.2431037547772,-9.86444020260840,4.88222167840548,0.227872803180735,-0.864315628529804,-4.94199210965445,-5.08828997392343,-2.84311523528839,-8.06913472385795,-1.44696835251723,-14.9040573914932,-15.0443046218875,-0.432265593224060,-3.45358835650207,6.83208900881621,2.52458410585023,1.79291745778950,1.34977171406718,0.450597820436859,-1.08202340162430,-0.376614169771185,-0.611814811990625,0.702992767787827,-2.43470015582728,-1.69079094527005,-2.60794160337544,-4.20886909074308,2.27358633686077,-0.907193189940753,3.17920083631109,-1.61598582969845,-1.45332568812797,-1.50600335866452,-0.617729443749083,6.831325581440352E-002,1.326850810473411E-002,0.276630651450454,-0.105953491121163,-0.117555342364582,-0.760592403169981,-0.514240668853885,-0.139328411840667,-0.976430788012531,-0.542887985559912,-0.234858460082943,-0.645504402262002,0.269903284583536,-0.130245597086872,-0.304588996064474,0.147229280946298,-0.401185047294299,0.197517893954714,-0.454015473493533,-3.160135853627944E-002,8.246048430166465E-002,-2.256774667573224E-002,2.841253142954982E-002,2.579811328478265E-003,-0.102026469315398,-1.771143967757252E-002,0.104952898393604,-0.204329222454848,-0.108034799294675,-9.461852430950117E-002,2.525268649992003E-002,0.356542207678573,0.247034889488978,-1.619673588867803E-002,-3.841530491502592E-002,-0.288333909840822,-0.177583251259720,-7.702696615002297E-002,-1.611860881430197E-002,9.536300777142756E-00],[-36563.7374889271,-1926.65988424214,-3627.03748001846,-414.081621933139,-1536.99146003633,963.441523547667,1895.87840677380,-81.4000998777685,-1128.25982980585,107.845919461071,65.3706649377984,-567.373157842986,245.212468561174,-499.518577064274,606.688336936375,-212.230658840209,-294.346670975987,76.3366952324761,-373.463971781925,-87.1038360279965,128.403556720466,80.2194104926017,37.0081639410196,-321.902737204718,-9.18251045839298,-16.7362367760643,-55.7823664981743,44.4278537652897,62.6696685164413,91.9036212162576,-88.8753229466026,-81.4002771092782,-37.3508065278416,-118.729937046217,132.335642528611,-5.22114686436972,-1.57284046704392,6.13106051388873,-12.9393384252098,-16.9595858478869,-11.6290712062161,-29.4659637036193,-44.1653699725784,-11.8328047799890,-38.3021049274606,8.82528736495659,-14.1533463920975,-10.9393247077021,4.86099939574792,0.488704539890644,-1.72798927857902,-4.83242233172979,-6.55918970764677,-2.62646100503059,-8.37173744288702,-1.54701590099961,-15.7072351953293,-16.1115546145836,-0.466971289736529,-3.15145017341368,6.95546993079010,2.64563333658696,1.85592104510821,1.40222233215473,0.481160684930990,-1.03020596803849,-0.507736173410748,-0.936969846663913,0.729574898897315,-2.62376163387760,-1.76242046453571,-2.90805898143679,-4.60002859246630,2.27511607875721,-0.814930723258464,3.26984368388235,-1.60126598192203,-1.56136137294567,-1.53523497827779,-0.655780229442457,9.830869303804630E-002,1.343344822847759E-002,0.334530160883051,-3.197170793862487E-002,-0.142521098945491,-0.774139798994390,-0.531276001469111,-0.169656589325768,-1.07672147367689,-0.628858661342635,-0.304241394774859,-0.662808730730845,0.232030529018850,-9.925255199509575E-002,-0.340182333637609,0.168903619899996,-0.380447023745824,0.202607526518556,-0.466400918923743,-4.210298338446761E-002,8.145424088847696E-002,-8.297425402544247E-003,4.253808666820374E-002,-3.381118895106540E-004,-8.624088330786220E-002,-3.716095287716863E-002,0.140693991397342,-0.225639032320852,-0.114569595989928,-0.117695834313278,1.369637989220193E-002,0.358988057391106,0.258675369543421,-2.633836420047154E-002,-4.277886350095030E-002,-0.294283271201246,-0.190331669193371,-7.609169897305558E-002,-2.137078725314328E-002,0.10424198375335],[-36824.6216124162,-2218.33259454039,-3405.65620474251,-438.095002347526,-1315.30097115771,1003.80055398762,1753.82201947362,70.7162883146550,-1128.35166928597,6.87623894799825,117.371567616467,-547.538932760410,187.780882122911,-488.484673582205,607.180229077627,-178.262372470711,-278.623944563408,67.4647319234719,-360.097401611897,-63.0238402877395,152.125901537812,69.3981712310377,39.0561446494618,-349.327278128337,-10.6267299505954,-17.5162413008830,-65.1084860234114,51.2835776969053,59.1349919955956,105.281893887927,-98.7372701472326,-81.9165081220808,-48.4870581474602,-123.651978129865,139.198642861843,-4.31802060687986,-0.822076679177340,6.35272675173472,-13.3698772756418,-17.3620118323201,-12.0630182008529,-33.0571921214334,-44.6172175894953,-15.5827955266378,-39.2769158590029,8.95119233822072,-12.9564900154205,-11.9354137688351,4.69419833576492,0.687056102956872,-2.47042267516335,-4.59945419624267,-7.93711435107668,-2.38320233094187,-8.58564330336295,-1.48364502165182,-16.6704293300888,-16.7253906201492,-0.655013587115676,-2.73259587890945,7.08806176052631,2.85061035993144,1.97869184059402,1.41399751393959,0.450320573922506,-0.931717986589894,-0.574826929355080,-1.18377451507141,0.712765261914715,-2.75866783253131,-1.78165640160122,-3.23676027489213,-4.83278937050688,2.20470410136518,-0.650675558824833,3.33146864441434,-1.56119268632627,-1.62999338166494,-1.57381089352389,-0.705196999635215,0.116988692575820,5.363417673140093E-003,0.383376691185289,3.955549075370721E-002,-0.168582068972527,-0.764546855664108,-0.511458145613994,-0.210987378128431,-1.15045245078017,-0.682838361525824,-0.385493054671683,-0.644991035872233,0.195816032862290,-5.511180206396064E-002,-0.364846629862248,0.192094239465076,-0.366146695064152,0.204839229163703,-0.472567541125219,-4.707194262380171E-002,7.430904309482772E-002,8.149803498400502E-003,4.994796218287616E-002,-3.969713326914467E-003,-7.099162030608810E-002,-5.130030677331831E-002,0.169394464878790,-0.241104089285383,-0.115805235940358,-0.138168715438795,1.499983485435318E-002,0.357582998437366,0.272995286709759,-3.364989535975599E-002,-4.626371631559342E-002,-0.298332424395941,-0.200210053214307,-7.179339086986029E-002,-2.590049814471063E-002,0.11233611913369],[-37056.3887820442,-2481.42233147514,-3108.25850817630,-508.564392326806,-1085.71582174837,1052.04084481259,1608.92951428015,221.893597175249,-1115.39968246511,-90.2176826788737,183.210155947787,-539.068294449630,133.432409815118,-472.596200520138,590.713601600617,-146.081185375789,-262.931370282186,51.4477439036096,-343.591860387683,-47.2032646090811,171.918040796607,54.2742267063755,36.1773183900646,-369.810854139288,-10.2529166430510,-19.2084005438960,-72.9764092532838,57.2505640140905,51.2723934112351,114.731086260086,-107.677665286807,-81.9575103923994,-56.0213139539257,-123.919394935545,145.908729625562,-3.07957142767250,0.234623022763173,6.33549333216541,-13.1126999376634,-18.2407925052042,-12.5594939279650,-36.1609793991450,-43.9856456405575,-18.4764592629162,-38.9915043134340,9.11652508426222,-12.0982343261886,-12.6746450796573,4.43537585460640,0.907123098463267,-2.81427003488273,-4.29484950769911,-9.04935239453084,-2.05950210145869,-8.85311309790971,-1.15232085345564,-17.4315585449725,-16.8005199263362,-0.683592594622877,-2.37584312905629,7.29218623700839,3.09305699296147,2.18758376608013,1.35343383659463,0.401610176705485,-0.747888730691739,-0.561489133622377,-1.32085349047166,0.707202632780417,-2.86405062599075,-1.71550800765661,-3.50663193988956,-4.87812084485975,2.15217584331353,-0.504375480464117,3.41031277727344,-1.53298721425184,-1.62628727061726,-1.61613510914922,-0.765281097981923,0.117168576240627,-8.169919078034781E-003,0.423600644764540,0.108389753415563,-0.174187504942985,-0.733776222021159,-0.475476407859411,-0.246047184388692,-1.19557091646073,-0.695328490787324,-0.444825741262439,-0.611759698607307,0.192336984781588,-2.094183053824097E-002,-0.369591376384489,0.209255655067097,-0.368094853198861,0.200372346407473,-0.469830588503451,-4.851647214903011E-002,6.032461980789747E-002,2.208551023683062E-002,5.307920744143387E-002,-5.410301792202429E-003,-5.656123879226342E-002,-5.844848974047147E-002,0.185506121250761,-0.252213138213986,-0.109844391903000,-0.152413421762623,2.545845038495591E-002,0.358504852479493,0.280263699758400,-3.503677894476673E-002,-5.194806013680019E-002,-0.301165842920320,-0.207095522020056,-6.390993777812490E-002,-2.821018651973516E-002,0.11808801004060],[-37347.6939703426,-2631.11106278061,-2794.27928360424,-620.321397323770,-903.110234389957,1091.66163976075,1472.11902036392,361.581365029370,-1089.18275276606,-170.612727174164,237.604499730117,-534.110463665835,86.9119693844380,-448.307245798776,565.112131356557,-117.911097130824,-252.894504825129,29.0605395991647,-319.977527671457,-46.4343460980694,187.749357662561,38.1049706540349,24.5451378618982,-381.956745842148,-7.66188883845846,-21.1545053309654,-78.9659642987724,63.1133064688606,39.1691371819608,119.489254927617,-114.383620877609,-82.9516011686956,-58.5034311274519,-119.176528305978,152.345817761180,-1.70525557604981,1.36298914780509,6.25870318357073,-12.0600970030458,-20.1813193823054,-12.6258248684180,-38.3412883800174,-42.6324182184395,-19.8561302586261,-37.5382623985572,9.56707576225743,-11.8437345593047,-13.2269842590776,4.15749007476035,1.14943482967980,-2.63687474945521,-3.99409051254370,-9.83995657808263,-1.64262903608750,-9.22129224913590,-0.594692822785034,-17.7534010695570,-16.4188282600256,-0.436642054311028,-2.19285414699864,7.51918866257977,3.33094019101073,2.50730164756352,1.22594560033852,0.362487978936077,-0.488426413555577,-0.480876814934731,-1.36276439789845,0.757774200830861,-2.95031531659425,-1.57283865066360,-3.64976945093807,-4.78219736837206,2.15728389899960,-0.444524343329163,3.50928398384523,-1.53355530274544,-1.54277826042497,-1.64705422000780,-0.839025914883248,9.967319277342061E-002,-2.331528823023601E-002,0.456638546246616,0.169146118906219,-0.154309159043992,-0.686889067797727,-0.447672624834802,-0.264238005584463,-1.21405367879801,-0.676830755132650,-0.463680043038771,-0.583628388349104,0.231037424658210,-7.317273554334829E-003,-0.355646132678513,0.220973603604407,-0.392739092700359,0.188089755543959,-0.456393029059279,-4.789284688494944E-002,4.226681229104558E-002,3.072521749677605E-002,5.513991314265776E-002,-3.427999971060264E-003,-4.332103922091696E-002,-6.038519382420907E-002,0.187475373013283,-0.260996096503849,-9.878168493215148E-002,-0.159161765091035,3.805564028562849E-002,0.363980962251479,0.275841586151170,-3.195264930829171E-002,-5.929987632773312E-002,-0.304722043876140,-0.211114406288860,-5.246503733792569E-002,-2.715506577544007E-002,0.12107263892042],[-37620.7145472712,-2663.35235568242,-2535.42122429716,-797.290719206839,-789.797912867425,1099.94934558853,1359.49728952272,490.916878403795,-1038.54059556157,-237.993260061160,296.465794918308,-517.668249701030,32.6336361262179,-408.793721635330,523.301219368824,-94.6216249307293,-244.617706017774,1.52869353988150,-284.841088062875,-59.8710902319035,199.406706658830,19.1499943224610,4.32012406331363,-387.387948804533,-2.73055306494326,-23.2248766239835,-81.8403890689993,69.4275935419263,24.2861159544112,120.314515869767,-119.850192885550,-86.7132019752755,-57.2354337746518,-110.343393104753,158.357529885356,-0.454719449984539,2.18717112634711,5.67984167695634,-10.1360316035344,-22.8337915583820,-12.6303843966013,-39.7806401530638,-41.2731020584936,-20.1234389724923,-34.9281725737480,10.2648552565463,-12.1244534399340,-13.8315092693105,3.86526340272512,1.24859048293960,-2.13159315840100,-3.89192166921330,-10.4753521968716,-1.16414854012635,-9.64487033031391,1.593572999892383E-002,-17.6452013525503,-15.7391561214929,-1.948360638555419E-002,-2.18257559635463,7.71910630711301,3.54206344796144,2.99066731834908,1.09230189191327,0.327657073428552,-0.227809352613638,-0.388127619102309,-1.34366119040005,0.837880086088592,-3.01423585275319,-1.41062741450894,-3.67916140108554,-4.62043616095011,2.22866820743602,-0.468710200938824,3.62407966783754,-1.55355766584021,-1.39878662965362,-1.66461689913938,-0.934335760685176,7.055619623180016E-002,-3.390271745130206E-002,0.485997089594173,0.205592270792196,-0.130110499456486,-0.630726450683065,-0.444846321004788,-0.274671644350719,-1.20829612037540,-0.646035466366661,-0.444454352792893,-0.562512221667707,0.304106487968046,-1.244912618159025E-002,-0.326708614511740,0.228049828411040,-0.436606752484854,0.171408648528535,-0.431131904429502,-4.443839015843477E-002,2.621553784947016E-002,3.706444535376720E-002,5.837372729316108E-002,4.649345249446547E-004,-3.471426877751480E-002,-6.011788111998786E-002,0.177768964723455,-0.270231880656623,-8.601386024780620E-002,-0.159061732737586,4.819637595362244E-002,0.374880424919625,0.261369392901011,-2.737917834424400E-002,-6.797197630165694E-002,-0.311129508406766,-0.214547654529185,-3.816866808829349E-002,-2.294962772079104E-002,0.12150672337785],[-37910.1538858541,-2605.82360920899,-2326.72124342388,-1025.53787204863,-758.900341380317,1117.38242269145,1264.35980792884,613.848680789147,-964.205678344041,-303.145198804814,385.223805620123,-485.741980643548,-34.2369357222252,-354.521229287958,457.241076460860,-75.6801442578862,-234.525652927479,-26.3199852316194,-241.661347103462,-81.8729634346033,203.360496228757,-5.92539501536666,-21.5969452804139,-389.899490118846,4.26947650783697,-24.9014637435880,-82.6625262967784,75.9156591773854,9.51723286283641,116.804118442417,-126.058372982164,-94.6101660147492,-55.5130336650224,-99.0458690884240,163.435870915682,0.516614215018086,2.42022719531536,3.99417573639990,-7.65210791725242,-25.7386363388347,-13.5634621305902,-41.1521337499360,-40.9424917560895,-20.5144147980621,-31.3355454686353,10.7360985868555,-12.5976012890168,-14.7188356255141,3.58507180484803,1.07507984776374,-1.70122783583218,-4.05542068688270,-11.1522567071557,-0.835276986779496,-10.0938476128855,0.399516339804868,-17.4536792182292,-14.9113291395151,0.224036927938429,-2.21888948487607,7.80397074256007,3.72510109950465,3.66848984166231,0.995394374601864,0.273443601136467,-5.024700064485869E-002,-0.337065975602413,-1.33475525991344,0.912935071744651,-3.04817256380718,-1.31611025931215,-3.67142761098515,-4.45294396106505,2.29258218390045,-0.507334067536066,3.72631617556187,-1.56150845041174,-1.21967503647535,-1.67041637233493,-1.04774464946184,3.954849165288074E-002,-4.098690353692899E-002,0.517605789923637,0.206828079286111,-0.126266998228478,-0.574910869718982,-0.464704347997067,-0.296123798773161,-1.18781802824110,-0.614581601984982,-0.413242468745563,-0.529311088413068,0.386435844865263,-1.849442959730392E-002,-0.287773949287480,0.233621391463473,-0.487823835417467,0.154609172254768,-0.395376852839555,-3.793199269783858E-002,1.641084755948992E-002,4.619889205691730E-002,6.091952622672243E-002,1.793130915860073E-003,-3.100143558607701E-002,-5.970975807844623E-002,0.159802028307540,-0.277707034278258,-7.477175908105867E-002,-0.155352147254166,5.904934939308339E-002,0.388278083492990,0.246506374346787,-2.294403121022391E-002,-7.563930522429474E-002,-0.319653808423480,-0.219372032855496,-2.211589140982784E-002,-1.667391689554239E-002,0.11996496360173],[-38079.5642096956,-2498.35708991451,-2046.34244570656,-1239.88317397811,-760.794565976435,1221.23032243916,1164.77427383011,725.964374649804,-881.134749737205,-361.096171656781,520.318696374815,-450.084885439675,-98.8224717957079,-297.429621756941,371.431948198593,-64.6379368102650,-219.971030710695,-48.4159163609336,-199.495975381442,-101.990319528384,196.103788419988,-37.9876840515665,-49.1469221190029,-393.852916921327,11.0736187158464,-25.9158316896507,-83.6249822440285,81.7655342072754,-1.91007634779136,108.387395651933,-133.309089000427,-106.425296885890,-56.0831787130219,-86.7083864295063,166.772058562380,1.06769270098752,1.81272138654945,0.800909574769509,-5.11179212220271,-28.3964324708609,-16.2048618930839,-42.6651871154372,-42.3075606025019,-22.1227409147159,-27.2221233747225,10.2834412821877,-12.8641414116328,-15.9803988369620,3.38948704635187,0.521927798737287,-1.68145618063644,-4.42686981613286,-12.0129116598508,-0.899160542700283,-10.4776313873801,0.299172417183814,-17.5547757081371,-14.0438326688092,-5.541179313748540E-002,-2.07109393847517,7.69143892799089,3.91763267771180,4.49742136735244,0.969282751717701,0.163514378488136,7.381421027129029E-003,-0.354553678801777,-1.42277624430220,0.940714397470952,-3.04582111200702,-1.35692986700859,-3.69752096657503,-4.31602872939417,2.24417313079907,-0.464255423956692,3.77739091232465,-1.51816523733106,-1.01197350416517,-1.66296125909722,-1.15116700438467,1.968610568899378E-002,-4.757032394995194E-002,0.555812496338526,0.172184160310614,-0.162537955831441,-0.528207647516311,-0.497692855203571,-0.344897928623696,-1.16099365405923,-0.592519470667001,-0.403400746863359,-0.460328289064522,0.453557845204992,2.802028400816517E-003,-0.238022165367143,0.244748575637285,-0.529487337397680,0.140317027877367,-0.353821890631968,-2.888759550112073E-002,1.483417309454014E-002,6.231265387175557E-002,5.882653759212062E-002,-3.320706616465085E-003,-3.023396129746505E-002,-6.258535052801575E-002,0.136534775080643,-0.279844484626182,-6.904245796457747E-002,-0.152229589795480,7.620310716780589E-002,0.399176853114581,0.244645493088395,-1.664554079640967E-002,-7.839187648048904E-002,-0.324777662679253,-0.225652948885531,-4.282653765660284E-003,-9.641322937050348E-003,0.11757652131445],[-38053.2101143584,-2396.17239902259,-1729.07562079781,-1370.19102386512,-742.307904056123,1392.49481772730,1069.85061177900,798.195852584614,-812.786245182261,-402.563718114350,678.510325516014,-416.565538575225,-162.524554303134,-255.113872011696,278.767062972103,-66.3168068413331,-200.574196450592,-61.2413440842550,-165.633946333037,-118.416950014546,181.677281172854,-72.8082098924256,-69.5341788392574,-396.619305457429,14.7081365463460,-26.2277736111290,-85.1267581764104,85.7781046773232,-8.51238824804830,97.5134545754821,-138.747059189279,-119.069715390817,-57.2587979293224,-74.6433888911327,168.055579456821,1.10460788761098,7.175116798272513E-003,-3.00408454998050,-3.20471202597967,-30.2563100432220,-20.1492389661885,-43.6207839688368,-44.7685334053138,-24.3044903782953,-23.1359714653407,8.86730565971570,-12.6844420876617,-17.4315040046313,3.33169729917088,-0.461090149552376,-2.07469178535513,-4.95508064952937,-12.9494736717827,-1.46085059506616,-10.6359087716468,-0.222195835483440,-17.8027302430951,-13.1847505209035,-0.768515227594696,-1.62516412765332,7.46910185304211,4.13508780857122,5.38711175534894,1.02783976068103,-1.576291354301480E-002,-3.652166881766800E-002,-0.461558984216481,-1.63638031614395,0.861464303308596,-3.00893642670609,-1.53052235014052,-3.73049459826543,-4.22991679993583,2.10593034357096,-0.325729349952428,3.78081497961366,-1.41963935447149,-0.781433572800037,-1.65257852092794,-1.20705373391035,2.683953623365105E-002,-5.063199629112160E-002,0.591586176417343,0.111501620382949,-0.235660258910644,-0.514068716007764,-0.544655169052295,-0.429411918243513,-1.13487813230847,-0.589904001785625,-0.417208059445353,-0.360635267646266,0.500227746364013,5.712128355685669E-002,-0.173429976519603,0.262763842113239,-0.545301806089862,0.133094204952073,-0.312249684309131,-1.877616511357244E-002,2.211321208738141E-002,8.227253584862718E-002,5.118568086105728E-002,-1.684781301934726E-002,-3.207737657267590E-002,-7.508702628055988E-002,0.107206161451254,-0.279006981532406,-7.140225409081195E-002,-0.151798980895285,9.671133899087866E-002,0.406084240362858,0.257538888537482,-4.040264274330969E-003,-7.622723729815412E-002,-0.320137327852058,-0.232313607745710,1.472681869471477E-002,-4.220789304759802E-003,0.11539937896228],[-37988.5519688886,-2339.01206274177,-1425.13945219022,-1399.62105625488,-665.219380380765,1548.07842694131,1050.15326688329,815.753466262506,-772.670809600119,-414.472231085368,820.431446496105,-360.038009066558,-235.819875533150,-249.497064974195,192.702382346198,-79.9108406940145,-175.223370814750,-66.4017646437693,-135.219315788182,-138.448537896141,168.742005479907,-102.489149845639,-72.9846688854662,-390.688270362550,14.9478474352334,-25.7146460681613,-85.7529990794300,88.7037355966436,-11.5401710267246,90.0045495409725,-138.933899466494,-128.348224840979,-54.1849691148690,-64.8062781169826,167.322189479201,0.755445580387544,-2.92692545009310,-5.94810911126870,-2.18603555394051,-31.1989851591663,-23.5616476548273,-43.2428950417642,-47.0949757592799,-24.9873420920491,-19.9280531411511,7.12469892052529,-12.1075805282176,-18.6807248939330,3.37714871184401,-1.76026601262007,-2.58871630993468,-5.68458900533294,-13.7111749760897,-2.29894475698122,-10.5372251687108,-0.828553676123660,-17.6336093009505,-12.4626785101261,-1.37978767998983,-1.00010367017001,7.33939017509574,4.37489180102378,6.16932468829607,1.12008194048934,-0.233193010898623,-0.139551918712607,-0.681067676050690,-1.90583527380526,0.637630766717549,-2.96511595095090,-1.75730531992197,-3.65733669286746,-4.20708724754151,2.07024955112270,-0.185207817017913,3.77871610726497,-1.30675121084797,-0.580570453775455,-1.66013974054586,-1.18487279555912,5.448414590278112E-002,-4.248425853833913E-002,0.606718943205793,3.122039671951148E-002,-0.315119729403868,-0.564319776784541,-0.606175414469187,-0.537729904819374,-1.10770039992447,-0.606680027143437,-0.411041082582051,-0.269417315046106,0.537628430411197,0.120954071924282,-0.104807067636073,0.283439801150080,-0.528481156706577,0.141670980307336,-0.278471642261724,-1.043837186737299E-002,3.501602544238092E-002,9.779603163810874E-002,3.995408564017729E-002,-3.417551579516867E-002,-4.173393821027734E-002,-9.749117376646591E-002,7.081404829953880E-002,-0.281928777956883,-7.831780369978036E-002,-0.149879814703989,0.111983412568306,0.413306552931853,0.274013900321968,1.577449209032985E-002,-7.290516163510516E-002,-0.304729604488588,-0.236527768322277,3.222678130255212E-002,-3.288082626383872E-003,0.11464735242563],[-38072.5346843394,-2350.32846364484,-1165.48524764804,-1366.81440917751,-573.798018633497,1625.26686806489,1114.45747739989,783.795722818241,-760.823472929219,-389.057590269085,914.178242262383,-269.451487095431,-332.589173941617,-301.584781749971,109.076851090896,-96.6755499407740,-141.045206703578,-67.0613019482582,-105.555778610180,-169.497898268686,156.588549489970,-124.950190911796,-57.0362169196956,-373.013293727947,14.3227513500067,-23.4514744493012,-83.5689068831588,91.3667961189276,-13.3395229146109,88.2850687492574,-134.904534496217,-132.169520649397,-46.1321594611576,-58.5818245844942,163.298274879947,-1.333222093382814E-003,-6.09740840460478,-7.00305477149902,-1.57412891984021,-31.5843480606640,-24.9746678900479,-41.8499694880490,-48.3622573024576,-23.4921833270471,-17.9540059239518,5.26421589030140,-11.1435104532453,-19.3915056530469,3.36311665100625,-3.07888095151995,-2.90979503776532,-6.45951693005236,-13.9958334129071,-3.08416925699656,-10.2370341164659,-1.25092475736974,-16.8745657839192,-11.9373693889687,-1.65691406296566,-0.335157344023056,7.33222436628167,4.64926941649207,6.66903829894583,1.15149824251463,-0.467927544826077,-0.263114932782691,-0.969250579227145,-2.09727415606841,0.312116200036122,-2.90643251326710,-1.95580395174545,-3.43268193606768,-4.20187798572958,2.22059922837213,-7.559171458769286E-002,3.75160827282436,-1.17056455402921,-0.476480400917073,-1.68140330756194,-1.07475996197540,8.053648817796841E-002,-3.467587104583847E-002,0.587643613794234,-6.195314119134529E-002,-0.367434302328160,-0.678192272532125,-0.661201497518147,-0.642513039247439,-1.06271336018780,-0.621556216049242,-0.356981477034553,-0.199472366970868,0.561131651498776,0.185191160518776,-4.804543664155241E-002,0.304977531712102,-0.475805364196211,0.169540594676351,-0.254415607877714,-4.592360242742089E-003,4.650899828049562E-002,0.101085628106656,2.452123211418454E-002,-4.897014866409230E-002,-6.082925765471039E-002,-0.120136187335654,2.992010789959676E-002,-0.284795062840238,-8.402104290623819E-002,-0.141799845345650,0.121007062712515,0.419710870952269,0.289274344211810,3.844229616662410E-002,-6.763659018177491E-002,-0.280091237398265,-0.234428432449019,4.573239371824674E-002,-8.655936466850844E-003,0.11543004817272],[-38320.6580651182,-2383.49699889512,-861.592450489149,-1356.28211983930,-521.551032994866,1620.89447243549,1226.36023619015,730.260653393406,-773.303077432964,-335.658594549278,954.350214758445,-172.808032940421,-446.310011758644,-411.548211017641,25.0253677541148,-108.154928706788,-103.178414459305,-67.0788057058847,-82.9799403776997,-210.506858946413,137.799764310149,-140.254120527640,-27.0291294063608,-344.645778693084,15.7793965174962,-19.7025805914105,-78.5144374126680,92.0018282132141,-15.8400376261699,89.6111676682411,-129.054440501220,-130.826936435923,-34.5164561008461,-55.4343926925513,154.959438640243,-0.833791686274704,-8.52315616123789,-6.18347757390853,-1.02055779636152,-31.7934272228995,-24.6773433293963,-40.0518080300041,-48.5468786842816,-20.4453364727563,-16.9877942807306,3.19037624405007,-9.86058282893137,-19.4046228635422,3.19045617686787,-4.05620939393571,-2.88182474140137,-7.02470029493852,-13.6782844025461,-3.71741747640749,-9.86362824918919,-1.51274481427530,-15.7100678768718,-11.5796081780733,-1.69558706410414,0.319789422857195,7.32407838493884,4.98193087276573,6.84956069955260,1.06290884588412,-0.675859456264137,-0.381713029157588,-1.22135247932759,-2.13098975696651,-3.854711555477923E-002,-2.81091718855103,-2.11291646524759,-3.10132559269372,-4.15999979989575,2.48162977405129,3.658537551328199E-002,3.64424278220945,-0.977318729825131,-0.471075181163303,-1.69816301969214,-0.884827683531810,8.823336589627925E-002,-3.888237799418989E-002,0.534332821286305,-0.152596552281740,-0.380720133629300,-0.815636475038860,-0.690484125810827,-0.724587542665267,-0.985932542169948,-0.619997821971533,-0.266541231613108,-0.133433618812081,0.549215194496693,0.258375718571494,-9.687797518795527E-003,0.326549554227969,-0.389936383692853,0.210355846515640,-0.235494546608332,-6.338462962488564E-004,5.198311380460006E-002,8.985015360010476E-002,5.194231256689935E-003,-5.852072692418037E-002,-8.203859888908492E-002,-0.134763383318856,-9.889754227348654E-003,-0.279035184024116,-8.545248850146345E-002,-0.127455205988423,0.128052972697977,0.417308108017844,0.305628024159515,5.799458582149797E-002,-5.681997627162883E-002,-0.246968418098311,-0.223615146132304,5.571039867182978E-002,-2.012799294469340E-002,0.11671432561352],[-38650.5661254986,-2290.26454836092,-549.566360371522,-1429.47994570846,-503.441474157823,1563.69977032059,1358.51765201883,691.706145654547,-817.958963724673,-272.685081664256,938.631590421545,-106.995204071609,-552.127584231138,-543.231268399146,-42.7906660849684,-111.071065930833,-78.3480438146386,-69.9046037480847,-76.3788460491710,-252.821137471284,114.726222041976,-144.244358381299,8.53595528985678,-311.219473718888,20.6092231874012,-17.6903773674186,-73.7223142624964,88.9273487998457,-19.6659440788124,91.7945503691236,-122.106224928814,-125.373631687744,-20.7535307094113,-53.5439089923908,143.834401163159,-1.12746845223219,-9.96259425399526,-4.20778395072377,-0.961048101440809,-32.4616866980954,-23.4959575668680,-38.2066966061800,-47.7089044935053,-16.6756888649447,-16.6007098630753,1.18266488011811,-8.63099476370767,-18.8641926652507,3.05326846187466,-4.41801881030179,-2.50739344192918,-7.33589703505152,-12.9378361094798,-4.28544886897017,-9.57879156760997,-1.60059810888092,-14.4399966370673,-11.3786615684123,-1.55243715000731,0.916581628637831,7.25293576614238,5.38689416676460,6.85729608769109,0.892057116638821,-0.775681415694877,-0.461015991172442,-1.38786023810790,-2.04407244602693,-0.353361936273108,-2.71694653317493,-2.21338197876742,-2.73438345062921,-4.06367178369594,2.77217059112543,0.162116049770691,3.48169885199963,-0.752659759502128,-0.492444425717807,-1.70041169770892,-0.650187420749751,7.838714373290576E-002,-4.354199340076845E-002,0.463693532092117,-0.222854996727503,-0.363538493974637,-0.945069858427927,-0.695385779206647,-0.774415787584544,-0.885858599103571,-0.597153418389794,-0.164945642050524,-6.541492966921120E-002,0.510531818035116,0.335407536828757,2.302934922938889E-002,0.347762540947476,-0.289690038392847,0.250934753465636,-0.220247402423228,-4.429875902516890E-005,5.458095736669658E-002,6.637356263789887E-002,-1.375305806141421E-002,-6.191920843406497E-002,-9.841295677874659E-002,-0.140072288125307,-4.407352352960267E-002,-0.262139123893013,-8.198048340572980E-002,-0.110447808607525,0.134556856423221,0.407644647621564,0.322390641777158,7.357148007534915E-002,-4.101094182392253E-002,-0.210070924141712,-0.207083192625859,6.327272720982928E-002,-3.484311352230191E-002,0.11805795512993],[-38810.4371300184,-2068.04915699718,-294.100202190958,-1524.11075294973,-466.338841585129,1538.90601336242,1434.87559872122,652.011192065076,-883.813495866497,-203.683017925163,891.347711380691,-111.836825773993,-628.199188798560,-659.025252456539,-89.1911249154792,-106.281521951496,-76.8014422579362,-71.6301600073004,-93.4728646563415,-284.684651914261,89.1056958922475,-142.716327257502,39.6471368059465,-284.081243391503,26.9549887852526,-19.6990967197027,-72.4495386637550,82.4389477651695,-23.1377892826209,92.3956292453218,-116.941807591925,-117.242980193157,-9.22137614745126,-50.3643179054436,132.492919521549,-0.961189408680227,-10.7572797533439,-2.22673255922500,-1.64534185253734,-33.6845139410117,-22.4845726061080,-37.1085174279049,-45.8833093134328,-14.0011135565223,-15.8673336861294,-0.322425675329236,-7.78312509833225,-18.0836282180480,3.13550867783292,-4.21954041153145,-1.99064798199556,-7.42329579889429,-12.0753053712650,-4.90547180219654,-9.50786085892801,-1.44042207795023,-13.5946646641995,-11.0517494006432,-1.27491190639950,1.52583132738773,7.15626064507384,5.81970377309912,6.90161039989130,0.738910553701600,-0.752250385456603,-0.493247726554262,-1.47582217947948,-1.94072101219129,-0.582539119885246,-2.64305586022108,-2.23996579106660,-2.41943913582096,-3.84574256997393,3.04116616386597,0.348697144375401,3.38350795803000,-0.559578451406013,-0.429185301553356,-1.68095344825133,-0.420033614914856,7.072270576608483E-002,-3.891028865531461E-002,0.399192965251255,-0.270949735725001,-0.339058271565258,-1.04768105468943,-0.674845891886372,-0.798045609924230,-0.776550504252592,-0.540535077662203,-7.390546979457981E-002,2.066357472914413E-002,0.494114048616208,0.398882931978895,8.202188520429009E-002,0.365200394392025,-0.197996810869585,0.276969489042902,-0.211355997215830,-2.201119225172835E-003,5.981333347348040E-002,3.780321122487538E-002,-3.089437955910148E-002,-6.047565967776992E-002,-0.108030525439488,-0.136598734630754,-7.355565666809168E-002,-0.233428036815130,-7.511872034447688E-002,-9.434156406590492E-002,0.145095082968643,0.404484509222404,0.336372273695257,9.386581959607437E-002,-2.571488282841359E-002,-0.173859225855338,-0.191572287392195,6.846890909940317E-002,-4.838017983880384E-002,0.11910025546801],[-38626.2674466140,-1690.15153320950,-157.745318567731,-1548.85516437408,-352.684370022884,1616.20331800510,1417.71555130364,624.920362801507,-947.971550332581,-125.175974714020,846.652915419805,-191.170774467224,-655.192565200361,-752.565192202904,-119.853848224144,-94.1060848269755,-93.8986184201601,-64.8575907089804,-132.878917736910,-293.721080780220,55.6609604823200,-144.558132925689,57.4127064784867,-270.238767004026,32.3910812086578,-25.2054980765616,-74.4380905396123,74.5837580210534,-23.4224867143538,87.9942657783707,-116.698158893438,-109.587886845405,-4.25185967400229,-44.7107229769813,123.269216173793,-0.947920990382524,-11.2361384133784,-0.941708751251433,-2.64860149556901,-34.9906006383007,-22.7654890647458,-37.4899426661064,-43.6761468752703,-14.0289617537400,-13.9272929874300,-1.01521113455179,-7.45679057471952,-17.4911014065998,3.37720212294243,-3.72341868438833,-1.65078889180504,-7.25494858303588,-11.3408518303498,-5.57892968320984,-9.61504965495361,-1.15022398736501,-13.5675004121711,-10.2741717309925,-0.930831077518958,2.17919988309772,7.06968628073888,6.17788514702460,7.06559362051217,0.671938928920307,-0.674169056885947,-0.524666010089601,-1.50284610425129,-1.89650571040448,-0.672322570359402,-2.56517910322993,-2.23073280622560,-2.20909876036042,-3.45179053612622,3.26163001762509,0.631500773187057,3.41849609635688,-0.451699467057614,-0.253438355862211,-1.63814683492856,-0.239817835216120,8.385296858904209E-002,-3.181855501206797E-002,0.350349845190198,-0.305939143252350,-0.328752944769004,-1.10139988727131,-0.625290955629763,-0.811392658801169,-0.657484683474496,-0.444187694420490,-3.927077366382760E-003,0.137558496925837,0.528551409743515,0.431756945090647,0.176694844254547,0.379419451271332,-0.127972708558692,0.284740361044186,-0.210804793434609,-3.223436387953104E-003,6.982461192845424E-002,1.234506427513616E-002,-4.909268500597747E-002,-5.696215193238124E-002,-0.109840378801863,-0.125321030963602,-9.817924296783717E-002,-0.190974823436471,-6.869410093492147E-002,-7.951291474523114E-002,0.163163196210557,0.415146448745395,0.343720847657554,0.122109783137644,-1.421147506842684E-002,-0.141441437188745,-0.181266973591491,7.110930045951523E-002,-5.763569889507274E-002,0.11934950250154],[-38395.2334843576,-1266.76575265923,-250.455983905761,-1492.16772022042,-219.719301327338,1740.26041505534,1356.36338225384,614.885473517107,-994.246581753776,-60.4708145228640,801.969031695528,-297.036034998671,-636.385099286123,-819.990080891142,-139.337413384652,-69.3340309071989,-120.588137813719,-48.2141461921851,-184.081471444774,-277.808017136394,17.6630103390613,-152.552945135686,58.9307843714248,-266.204549498464,37.6751883771920,-31.5387958444676,-76.4438015788711,67.5423310063962,-19.7394542773977,79.6993446047660,-121.441498409610,-104.754909251817,-5.39788153143276,-38.0136774932746,117.985084616194,-0.885021115249207,-10.9850305648610,0.298942836425861,-3.49649290638402,-35.6848897781377,-24.4354917116049,-39.3134168886445,-41.6022757272161,-16.2518517403006,-11.2429900234667,-0.604013032958832,-7.64485624951893,-17.4157366277172,3.62600259664215,-2.98546083262374,-1.61449443942578,-6.83742748476892,-10.6816608281314,-6.20110559713414,-9.76554585893588,-0.832534855311152,-14.2481297546163,-9.17910725885888,-0.564915917139295,2.69978119751267,6.97887454851750,6.36481420551046,7.24630666092189,0.651446271543439,-0.593726446488876,-0.594084779043988,-1.49126355838875,-1.86275682255004,-0.633535337069137,-2.45498299306766,-2.22462962970013,-2.11058169551676,-2.95489167740528,3.44315535713994,0.930651107374236,3.55422992130700,-0.447013627290021,-4.701505902325540E-002,-1.59327823485129,-0.137562104966128,0.104992737684354,-3.385898227666387E-002,0.305718896044383,-0.330103835356310,-0.324782994020309,-1.10950719324884,-0.539456985866948,-0.828895014587432,-0.533338482795795,-0.323979459094943,4.563802758430283E-002,0.258488688670070,0.596901526308083,0.424586084154412,0.278278549385666,0.388598736757188,-8.938524012331389E-002,0.279952844536213,-0.217677525027787,-3.425431743642547E-003,8.015048553301479E-002,-8.405372808994473E-003,-6.958742299698674E-002,-5.421390750905610E-002,-0.105188695833522,-0.104102376191180,-0.116264277009500,-0.138007430690374,-6.398539223103565E-002,-6.454245746063979E-002,0.184927442471671,0.435110285519282,0.342925890210179,0.150797615587363,-7.131017212004810E-003,-0.118859154394760,-0.176459363801239,7.019364039096443E-002,-6.128037631874853E-002,0.11857425813692],[-38255.8207695696,-1002.42913896044,-356.553421136750,-1379.41699386272,-145.433575400171,1896.00395916761,1319.77469256033,597.019188794204,-1041.18538424191,-29.1591735104622,736.492646127729,-378.896154596028,-599.002713887464,-853.796469224528,-164.777114012784,-37.6478695578141,-148.529712424186,-29.3712090170799,-240.309106326850,-246.500332619403,-11.3980214614343,-166.917986431714,46.8134052771310,-264.622926389026,43.8280481360181,-37.2052321066807,-76.1276427905802,62.0861898243229,-13.8669848518430,72.7133774515329,-128.194602247294,-102.701504245460,-8.98797668878856,-32.9370530381213,116.993343396214,0.235113580564843,-9.83012250761195,2.48477574023861,-3.77619308648412,-35.1714985171362,-26.5243517172570,-41.7695764459241,-39.0983089314085,-18.6053963800529,-9.11254521064354,0.693701225624594,-7.84516455861207,-17.9676206252253,3.93497278278586,-2.02689547298678,-1.77801490891592,-6.14374168166440,-9.79485600401182,-6.64088293146688,-9.79496704507929,-0.244532727406177,-15.1776777924469,-8.14540428101143,-0.338399785893224,2.98661946133805,6.85371880002262,6.39957229810234,7.22900058425188,0.629367926820490,-0.534700180449811,-0.689991833203201,-1.46512404587732,-1.69902206468345,-0.547274031440538,-2.30541096984985,-2.18166712668625,-2.09440233623701,-2.46341424628256,3.58912191525438,1.15428530486706,3.70182935504472,-0.497490530194922,7.319833180002160E-002,-1.60746391314653,-0.113958192037093,0.107026837021956,-4.892758382799629E-002,0.254382772025469,-0.354075940536698,-0.303981076685734,-1.10190270730994,-0.414012909829971,-0.857663959306632,-0.416553178315576,-0.188853552579109,8.476406187114144E-002,0.347439320554900,0.665031631987806,0.387102570134795,0.357589083580523,0.377648490605809,-8.684464253197358E-002,0.272517151924289,-0.224316186002988,-7.660481932596389E-003,8.723112605879457E-002,-2.607607812314507E-002,-9.565106891013625E-002,-5.601066286956236E-002,-9.936216999857078E-002,-7.027746551501270E-002,-0.129791151120125,-8.256748841224511E-002,-5.690569812500322E-002,-4.396368586933944E-002,0.204731273932448,0.457576592159446,0.337481986818889,0.176576822299184,-6.764782839867544E-003,-0.111333064120265,-0.174732075286546,6.527158849750844E-002,-5.843304787362295E-002,0.11642775317163],[-38007.0316314758,-903.864051615096,-371.979255137104,-1259.59015795614,-92.6382050491175,2058.20562162509,1323.98113384917,581.936077545773,-1117.20355215633,-20.1092964266661,641.910561981952,-402.043936713475,-556.391202190595,-860.712489499636,-192.648458373826,-12.7848677419775,-173.352124729670,-16.3652376829308,-287.341505209076,-209.405047987588,-17.9780205950754,-180.228640569725,29.4379682255701,-264.802379032818,50.4854405773695,-43.7372760327562,-71.8574308633828,59.6341803780610,-8.46114712504400,72.6515159669261,-132.310042361662,-101.614514553928,-12.0510678774286,-31.1863777020500,117.866775342900,2.97582069259264,-8.49166092509494,6.09802076438811,-3.56988114069489,-33.3480182862562,-27.4575814152292,-43.6169812425858,-35.3142813951491,-19.1851147976152,-8.48989269749226,1.87727720212888,-7.88448352212276,-19.3501641978201,4.35643989609746,-1.05149361358471,-1.89361453870749,-5.49036717352485,-8.48057767356139,-6.68490107572383,-9.54537161210617,0.929268065446478,-15.7790817012523,-7.39523914074662,-0.366478845960538,2.99337349504326,6.58906825315125,6.38013573874896,6.88990308495425,0.599155144731017,-0.513910396451851,-0.783630249031370,-1.50213250015129,-1.30161704941120,-0.500041819948243,-2.10332459914169,-2.00606351504797,-2.07138367549521,-2.01525529370475,3.71895717346958,1.25673692429773,3.75612832967910,-0.538943622513046,2.021805723234365E-002,-1.68627620579100,-0.155496879597742,8.439572309162070E-002,-6.868479547049958E-002,0.185295922559153,-0.396264453391467,-0.252971684964714,-1.11336099318308,-0.259449340857051,-0.882633561809790,-0.304404073746927,-3.685840175853961E-002,0.131131282564437,0.389886454375993,0.707470520583467,0.342332035044206,0.386388168897813,0.354889175928026,-0.123137151568004,0.272672059175563,-0.231393027781119,-1.425191753959225E-002,9.390342086533371E-002,-4.412152745333443E-002,-0.126332937119410,-6.390650627360134E-002,-0.102977647483242,-2.835773657943882E-002,-0.141741055385675,-3.172933647303066E-002,-4.329748199138771E-002,-1.271593793010194E-002,0.219419730246954,0.479043005810369,0.332729927731702,0.195157300399465,-9.687694971352552E-003,-0.120734105848995,-0.171094609040217,5.548626521691621E-002,-5.049201856344658E-002,0.11278333076007],[-37701.6788014281,-953.274739878009,-445.871663395505,-1161.63247904652,-27.5206308318869,2148.03765200412,1327.94165426937,570.136421445671,-1222.93288966199,-25.8742168100090,511.481760521703,-384.014067719849,-508.125141783006,-863.135026767863,-199.720657009301,-0.640919916215730,-199.669834515849,-9.99422961163704,-320.640810706033,-177.402510347802,-0.855117457394468,-188.607488202004,14.0297176362938,-273.782917375091,56.5028003196374,-51.4389844298411,-63.4780036461124,60.0200060689695,-5.95839094450336,80.5588946084474,-132.218512911179,-99.3995095835581,-14.6468998779401,-31.9930950232768,117.437625719738,7.00614927974564,-7.25064373827921,11.4246611751093,-3.39867261692244,-30.4602865603550,-26.4224968228971,-44.3398934859950,-30.0330656487191,-17.9472504182505,-9.49918090781843,1.63392993095962,-8.18658301361502,-21.8800726396298,4.79649913962173,-0.176307518461540,-1.70750697294963,-5.08984135227317,-6.57994163666020,-6.25342090676993,-9.00496933879122,2.80133416376293,-15.9217775794565,-6.83791898588606,-0.831401242369870,2.78041597932349,5.95242362936313,6.39475106170022,6.25303944682174,0.537474522171373,-0.551883344559847,-0.845028020350191,-1.61922160286505,-0.653916561954065,-0.495854498458243,-1.79516563415570,-1.62451634358703,-1.97557134587239,-1.57177444484575,3.77763172269246,1.26313661427895,3.60735270314437,-0.541902973474520,-0.213168831547985,-1.76922800182316,-0.237003127959280,5.465964249916141E-002,-9.734726493864899E-002,9.046681043892310E-002,-0.455964205773201,-0.163873837807087,-1.15817108489346,-6.970299056620120E-002,-0.879233222282462,-0.186019626393313,0.133685349776059,0.173598814547770,0.404690338448100,0.694672331121345,0.319092005736604,0.342869697572771,0.353551160324384,-0.201144401800086,0.285884823648332,-0.249724458638674,-1.603616429120683E-002,0.100212437102136,-6.715169748288709E-002,-0.159732539835552,-7.803873050199404E-002,-0.120706929184175,1.670390630266550E-002,-0.153595342158052,1.602019464731321E-002,-2.219088925653185E-002,2.594981944481645E-002,0.233530467818397,0.492764572791844,0.337719694212204,0.199612243095150,-5.276865634401778E-003,-0.144475994037048,-0.160048506079043,4.075825564084717E-002,-3.945985457616079E-002,0.10800712419248],[-37366.2450273875,-938.913154245658,-650.746557692931,-1111.87621279628,75.3369187476717,2141.47563122682,1382.70947015839,601.092113962301,-1338.50390979816,-45.6313520467108,365.356392287541,-355.206677957661,-438.288526430138,-890.334030073908,-177.070574716995,-3.07893786065810,-237.464333230064,-7.15470597414187,-349.993962522203,-151.140028072212,27.6842130453009,-190.066328319792,5.25886567824294,-298.364766848168,60.5466577794232,-62.2530649888731,-50.9815199884999,58.5362257000051,-6.80035558137663,92.2697521382725,-128.536457027769,-94.6329507457246,-18.6247761611426,-31.8292095687299,115.128304156228,11.5994921217686,-6.34022006109343,17.9859942758211,-4.18626312717942,-27.2315195978865,-24.2616191191549,-43.8583927484854,-23.3552086225114,-16.0335766588877,-10.6719828129298,-0.435145709476484,-9.03806255466768,-25.5028249773226,5.29901293449601,0.643742178429632,-1.21982496765460,-5.02691745602760,-4.23444615788725,-5.51983776857651,-8.28756056168922,5.31356507751776,-15.8222719215559,-6.07456834120078,-1.79950750569464,2.51312800889220,4.94412040084124,6.50393466854177,5.44175019746316,0.486932437074458,-0.601300243072271,-0.894969541515350,-1.74801088279097,0.188033555673080,-0.512871909821683,-1.37440006765483,-1.07037941029733,-1.79451172196286,-1.03676458362662,3.70649146354323,1.25688218060727,3.25918574388357,-0.515950613692548,-0.576827210587682,-1.81052567133820,-0.320838341786034,3.760972901483570E-002,-0.127180316309447,-2.225499003453061E-002,-0.514262251004430,-3.939793866063268E-002,-1.23004887225159,0.155062070866251,-0.846784984594221,-4.514104219072691E-002,0.326142281653492,0.187022373526179,0.426465032601088,0.618984810023858,0.330138925265164,0.238084053504118,0.399489351761576,-0.306800194691616,0.312865669483669,-0.282048018470066,-9.305705599311688E-003,0.108105355875653,-9.449165898260833E-002,-0.191586574947273,-9.416228415312995E-002,-0.150152758997651,6.532502038764380E-002,-0.168214104277260,6.641239315940926E-002,3.745222091652822E-003,6.381114093276836E-002,0.256150337611126,0.495012518206958,0.357861052055975,0.190700144403101,1.455260926325075E-002,-0.175290615307696,-0.141021667451963,2.518890587564462E-002,-2.726945898770462E-002,0.10261195679663],[-37042.9687492967,-856.492876171620,-836.952276285659,-1176.07431480052,146.874733455083,2088.73887347975,1474.05508101275,671.398217709137,-1444.64736637257,-78.3903502991596,242.951281070805,-348.140344481945,-342.895084869096,-948.003324234409,-151.880667810870,-15.8062089162692,-284.149266172783,-7.19494899880901,-384.728515563745,-119.888702651830,52.7791257378470,-184.648077282236,4.98029732935652,-331.916547666255,63.2651334059741,-76.3500287726770,-35.8202072500355,51.4609179789502,-6.90972649925325,102.113166848749,-122.320384654381,-87.4120126515076,-24.6162103518272,-28.0124008992402,110.658751152374,16.1854257663917,-6.01766385674144,24.6108724996732,-6.00818048189642,-23.8255443022351,-22.7443343774153,-41.9204139153673,-16.1960228611788,-14.4892140804114,-10.4549595006105,-3.97411304859379,-10.1599054373546,-29.7943952366028,5.93514614470101,1.41717851843086,-0.606511203452759,-5.21332256839397,-1.85980820765190,-4.88413456015022,-7.37394389311627,8.06248134752627,-15.7007875828964,-4.93903185986884,-3.17272877817192,2.32194774308494,3.67839626672461,6.70506959375022,4.69450652522745,0.504488478258736,-0.600385134030562,-0.962398303800289,-1.82824924999224,1.06464445090836,-0.553988148252029,-0.874730190807878,-0.493651491092156,-1.57021811105121,-0.416201497482311,3.50920309058349,1.31268841218698,2.79448760332927,-0.449344470612561,-0.958007385826248,-1.79078409262783,-0.380054093434715,3.855680579009587E-002,-0.141546140166934,-0.130471846184956,-0.559121360438287,8.951317560568969E-002,-1.30508186589372,0.385894274735166,-0.805665933902617,0.120353223260987,0.525040514950992,0.170378177225307,0.472385871053580,0.496292815579214,0.373171898483425,0.114442201827020,0.488496871157225,-0.407792469264048,0.351495796927262,-0.319150855311001,2.930299251541888E-003,0.121786672961575,-0.121681338356126,-0.217075918594325,-0.108718049980619,-0.180916884467294,0.114223783685877,-0.184549772806464,0.122292882673352,3.094252497566214E-002,9.639512287874484E-002,0.286419654702638,0.488028139320350,0.389127361541934,0.175860512597322,4.961274868095523E-002,-0.203847538180167,-0.115829982578772,1.241266037423601E-002,-1.648678078059298E-002,9.717554030920575E-00],[-36672.0289642083,-764.545580211626,-939.230434052289,-1359.55460349613,179.854276664274,2000.45381239010,1577.13303439722,724.589817644426,-1527.65190652991,-101.472069385197,161.656122012588,-350.006523694477,-244.842486107306,-1017.94830927674,-154.763953835927,-34.6366789467883,-324.011823705419,-13.8584111697574,-411.488817004892,-67.9685847085191,73.6864822147824,-166.492334403258,14.2566651623553,-360.216064134605,64.0423706776405,-92.7650634390392,-19.4805659217171,41.4362853183571,-0.163328868484840,110.017072757693,-110.872243619485,-79.1404966011801,-29.4487173850211,-20.3449760820560,105.041865079350,20.1691365701290,-7.04350597108982,30.5259222042220,-8.15073744772592,-19.9582545623398,-22.2091244238770,-37.3303275330970,-9.61893897327266,-12.4355742301002,-8.36397581844330,-7.58685426792263,-11.0070469163666,-34.2745669352067,6.77681726672052,1.97263182474366,-1.432919036517584E-002,-5.69421070924252,-2.148219527171538E-002,-4.49393244683855,-6.05615271600487,10.5075896252213,-15.0888553031082,-3.81240101827087,-4.39853795197835,2.16406391776389,2.35423991236412,6.89118925517612,4.24409018868624,0.661057611817691,-0.513638689304482,-1.03830914793555,-1.92834808308950,1.76624686368506,-0.654826100230454,-0.409066866371335,-4.676257706779000E-002,-1.27315545269714,8.914974513589861E-002,3.34353178118203,1.36194663393796,2.32602079518380,-0.365779652741336,-1.25383743720871,-1.70690454706708,-0.397649167883670,5.270531794692311E-002,-0.116145431466076,-0.213631958589290,-0.596207553849313,0.190255535276022,-1.37421667336264,0.551665801502089,-0.768422096042600,0.287270544016402,0.678144706956899,0.164328151602929,0.495973842569099,0.362492167807599,0.417072003462645,1.317295522384205E-002,0.598023928435391,-0.468996244113652,0.395835008871118,-0.348479989665943,1.116030966459174E-002,0.145820077509867,-0.145148769325176,-0.229674279710884,-0.115322577583676,-0.207294565744750,0.151781890825091,-0.194342672271393,0.169783369475600,5.669112214060593E-002,0.124678916691365,0.303091233341738,0.478793777456550,0.413142601776377,0.158984741754277,9.050085321470025E-002,-0.223898752492569,-9.051302128484053E-002,3.992554360193880E-003,-1.026050767886095E-002,9.319885697149381E-00],[-36241.3971729689,-887.260770294820,-1137.25635149779,-1533.06494040056,173.503356956855,1815.20599171367,1634.01348406973,676.919920392326,-1558.01557685713,-97.2435709878869,104.561026444050,-340.803974739282,-189.771978067133,-1090.16254792123,-195.111556456725,-51.8052220889379,-339.497113500381,-28.9619023437077,-415.691853210938,10.6126324297037,91.9089879953335,-128.610235754356,33.1687732855232,-376.933240087212,61.2352077760541,-108.551443020660,-2.17642422226060,33.3898054149700,16.4025585218832,117.822089756423,-90.5552758052262,-72.0954728620043,-30.8246404461568,-9.61683197546247,99.8722859908903,22.8159315665464,-9.43014388550667,35.8780703246848,-9.72246836096125,-15.5532461036609,-22.0893700582647,-29.1711162267130,-4.60845576614663,-8.46373858653818,-4.71397540043262,-9.91905270155156,-10.9699171588390,-38.5447618471996,7.76913919331923,2.26891332854009,0.493817699874611,-6.43425861681037,0.918427099167383,-4.23074596456399,-4.16976930225402,12.1257210705673,-13.3196582089912,-3.24211624901900,-4.99464481178772,2.00269861236713,1.15470727416136,6.95169318087696,4.20334665265840,0.972988907440644,-0.340620967691873,-1.09423027167532,-2.11017718701331,2.17298413207811,-0.815935379580267,-0.107145130904276,0.169192940580338,-0.821817459921151,0.227604985175019,3.35560670316190,1.28841399255681,1.91815140619736,-0.303094220124649,-1.42870397620341,-1.54991695819802,-0.348991803002261,6.613102779085432E-002,-4.291766409954543E-002,-0.266799619178802,-0.619863658299636,0.258919944696980,-1.43458487657763,0.593052682704874,-0.737763501459460,0.428826996388599,0.723816100072843,0.200621289731295,0.432466158426062,0.239818552398329,0.428748666368375,-5.353513782329421E-002,0.715807553347752,-0.465719970344231,0.439275957363448,-0.359298771945622,4.726403729396274E-003,0.177311234461556,-0.164175234314570,-0.223538455336820,-0.106120222555131,-0.226441006530052,0.168733545830346,-0.187273414474982,0.190316357903445,7.621700048033908E-002,0.149225895183109,0.282263979203798,0.468724651226197,0.413449805207365,0.135757309232584,0.129411271980128,-0.233008884565427,-7.155409067106329E-002,1.706510708407144E-003,-1.113503666614368E-002,9.294518983884757E-00],[-36026.3885257224,-1076.12628603129,-1289.17653007979,-1713.68441196498,96.5320256171718,1557.13252088947,1667.97148437559,596.814326476763,-1527.32788041642,-115.859759013588,41.7506576514900,-313.007967930795,-194.309950870832,-1171.60136262548,-229.289313485872,-55.1829103663440,-335.657148986424,-57.1814725357748,-404.359267979097,98.0180853359893,102.291430534802,-68.0639126204469,51.6529509080995,-375.037714312616,58.6541354752103,-119.745455652143,15.3968677813098,26.9849224636442,36.4359747182452,124.655229250438,-63.5332068993628,-71.0407186187477,-27.3171127098600,0.395602599262561,96.8363462051865,24.3546451827574,-10.9340616271095,41.2395017234068,-10.3669205355386,-11.2959113565305,-22.0636315767965,-19.6318160676338,-2.22202157522746,-2.79336865924853,-1.31236044204037,-10.3671187589209,-10.3288012546169,-42.2772555180270,8.51366608048341,2.79149652425108,1.08016542335361,-7.01930330697537,1.19505329390826,-3.94549692493422,-2.14765983589855,12.7024595706404,-10.6801764417533,-3.57024756049332,-4.98486039031391,1.65653376042006,0.159039048738703,6.67525136030056,4.40151072192531,1.25537415365431,-0.109182373251176,-1.12605274734894,-2.25284437413924,2.41806190470017,-0.985315576366706,3.593924496401693E-002,0.177130269857607,-0.295436090462546,-5.065185107474273E-002,3.49842730781905,1.03062074748837,1.56554371993900,-0.344750723296807,-1.56039526496312,-1.35564340868218,-0.257198160469696,4.386656765775417E-002,2.417419491262791E-002,-0.311398914204600,-0.609351070921229,0.320584021096429,-1.47146920629071,0.554017054150599,-0.714806223434552,0.536328557185966,0.665147876336823,0.262237501760431,0.287768319713881,0.131509800149645,0.388185369057224,-0.108549878066572,0.823702380401098,-0.420065818387666,0.481581562902333,-0.357926922911586,-1.560535019898033E-002,0.195713430171502,-0.182399370637160,-0.203130696236900,-8.649396393401579E-002,-0.234834542164126,0.175945563270884,-0.164235018614682,0.189816055950916,8.720537354967496E-002,0.169990259188010,0.229800045137122,0.454999570142026,0.391256739795601,0.103922121854275,0.161162511678208,-0.237624049122937,-5.851573118604196E-002,1.262913475172373E-004,-1.767102332471198E-002,9.419156674225364E-00],[-35887.5126748976,-1205.63961467367,-1326.61921930792,-1913.04265136003,-16.4398826491177,1344.91692308525,1717.21584100504,539.565319411421,-1439.10981413823,-175.015602945688,0.883099662873623,-281.909739093961,-242.151858587289,-1266.53865500484,-237.534373118366,-48.0083268741493,-321.440897723637,-92.6779677657388,-392.260354500685,177.805639987323,100.824710066744,-0.729385809859916,63.0179564900287,-361.489898311879,57.3242571593281,-124.910355588339,32.5803487277403,19.9057624245620,54.0667606212744,128.302413407258,-37.3033308926865,-77.3134673471680,-22.4359501707717,8.12150062299435,96.4618412498867,24.7728370008444,-10.2965536464016,45.9855029208947,-9.94446809611721,-7.57318646640242,-22.3282319872296,-11.6114924242469,-2.46699078072821,2.47590369110659,0.985545003117234,-9.42941807544079,-9.22939488629172,-45.2047553387176,8.69945218740479,3.67963172356294,1.69938452877767,-7.11414161304780,1.13594936743830,-3.57682340945942,-0.496265793473330,12.4147892323684,-8.05745596174974,-4.48983219238750,-4.70834436223573,1.31669114781980,-0.520035170557159,6.04180704103980,4.64340818236197,1.39400216391794,0.107878278266478,-1.17377274900984,-2.21392805213268,2.62144185327701,-1.10164290909487,0.126490558770301,4.938678519381583E-002,0.174022949666146,-0.563029686140201,3.64790699595980,0.712774802439229,1.28568211883601,-0.508840150309401,-1.69562672471106,-1.18234187593809,-0.129864590452493,-1.873508489402665E-002,3.744452747671104E-002,-0.360472105799129,-0.561496107114876,0.376840180862150,-1.46592229122261,0.508632271581565,-0.706012033696085,0.624259731033765,0.549696607171017,0.318412371508393,0.131200681259151,4.803618783880727E-002,0.310433682046480,-0.158242754268400,0.908000556516119,-0.357733177349782,0.526522978983132,-0.349931124041278,-3.994565914465496E-002,0.189150990453985,-0.198501503852921,-0.179240804617214,-6.754187034685499E-002,-0.231441092093892,0.186436427387539,-0.136191208935085,0.185590740421963,8.773729534495832E-002,0.188084046954460,0.169858274425463,0.439855243720620,0.360482344829057,7.289254487304295E-002,0.182724064999075,-0.240744981363729,-4.805548698876067E-002,-1.860925224185773E-003,-2.659358386654083E-002,9.431989686318269E-00],[-35512.1771577483,-1304.04214707306,-1338.89777539246,-2124.98516301846,-124.093124199527,1216.84181430186,1764.63609017788,506.721240042280,-1301.81171395369,-255.285259059208,9.36646410350992,-262.105991415321,-312.069653748381,-1353.66276577616,-241.338407528389,-41.3068363284496,-301.255195976640,-129.137094082339,-386.358561492356,240.707480069113,88.9918048007312,50.3685881018442,66.6396790956915,-348.173576740262,55.7856524919603,-125.633113009331,48.7735783793530,10.8694407980289,66.1993530368339,127.839778740201,-19.8041905069328,-87.2811059852414,-21.6881411558561,14.2501056248613,98.2054544304950,23.8458197321468,-7.91330995805436,49.1302882394921,-8.50944768679988,-4.53040906628277,-22.9692640382174,-6.92212087279065,-4.01937948091135,5.16366151108391,2.73414277006886,-7.46809978885077,-7.47554951722590,-46.8938188665086,8.30173421856333,4.70550857650590,2.30924372722601,-6.69439406678601,0.912254236147656,-3.11120871724354,0.529468829738420,11.7376938006907,-6.22187011884167,-5.31085907070096,-4.34940504691352,1.32069769100545,-0.755174750267940,5.17448254308786,4.83038243688173,1.40368032649194,0.263286536930105,-1.24487778345170,-1.95050374851259,2.82856787930936,-1.12614765575376,0.244888574807616,-0.109060347857689,0.457713258542871,-1.02427724161999,3.72165482343245,0.531278388855262,1.14708059942160,-0.719991390812307,-1.79766250380188,-1.06244841551989,3.697047972507544E-002,-0.105158834448131,-1.034805899788628E-002,-0.407702671760079,-0.488085566698229,0.417632044832553,-1.40449841355952,0.498135168856568,-0.706865251304686,0.694673640197632,0.441164228680040,0.348502738929307,3.488607211342118E-002,1.214764739088517E-002,0.228708681277908,-0.182468311152832,0.954990854452477,-0.282381140589890,0.570901492762724,-0.330082749349065,-5.954299266739567E-002,0.159647712215880,-0.211056169639144,-0.158319985954993,-5.359594781987864E-002,-0.218880807067770,0.206939488193866,-0.112597779350158,0.188024853946479,8.121444621079139E-002,0.201340586224174,0.124561530059233,0.428833290839258,0.334211100160147,5.593480634773695E-002,0.192316441736983,-0.237600143975617,-3.869441845435839E-002,-4.321979728255352E-004,-3.420184670647360E-002,9.118309159687181E-00],[-35127.6230171241,-1417.86886364525,-1339.90471535870,-2361.33534868942,-275.519371668051,1093.45457919091,1808.47283201042,466.632706564723,-1127.30617765997,-360.092731262365,46.8143493210593,-255.840991176385,-401.803091140968,-1404.62650330252,-277.593860585942,-39.3475643061549,-283.404108462704,-164.214741208492,-386.735734579499,278.215601881685,73.0541487143681,72.5376748454791,63.9296888877663,-341.430051592733,53.5278702597097,-124.097400931224,64.4626159282310,-0.894694397531990,71.9493158682037,124.498237938622,-13.1272740083800,-96.0128331464499,-27.3029345555269,19.8087885361635,101.238081331867,21.7349081654483,-4.37469810094887,50.8427884271616,-6.54031245781739,-1.92693416522167,-23.5794079627456,-5.07288035710122,-5.41025169612011,4.71427263694856,4.73091881396497,-4.69261414547386,-4.84103700299405,-47.1267408584312,7.52661794653196,5.74417276993370,2.98168789778054,-5.90311502516703,0.772692803792620,-2.60818938519475,1.07625751791793,11.0229269039329,-5.30217657391794,-5.60921481501451,-3.95921735995348,1.85142615536478,-0.603487232198086,4.28277026311874,4.92320449912556,1.32726365393756,0.371167837278419,-1.34681513834784,-1.50860045310427,3.05272483127161,-1.08097821595732,0.410053637323558,-0.269824972737213,0.544249821643770,-1.29191083756736,3.67876746360594,0.581191684249393,1.16504001439607,-0.851539243032621,-1.81158583011558,-0.989643291699600,0.230197290262131,-0.201077985564564,-0.102212124502453,-0.455074175185902,-0.401902105215415,0.435242616273119,-1.30017715371800,0.522414649609509,-0.723748092838064,0.746336215809902,0.354929180655004,0.353132242299118,1.880463623784622E-002,2.998952913109241E-002,0.186443131281252,-0.163152334116375,0.967333291899785,-0.188487049693694,0.604737145129458,-0.289484510395984,-7.072209926320068E-002,0.113430963542069,-0.222589094390776,-0.140006506438487,-4.594209753801841E-002,-0.202159803486769,0.234475273387511,-9.995929145564621E-002,0.198911862293144,6.632578932137100E-002,0.210454824969212,9.926678482050394E-002,0.424593719994400,0.322090365237268,5.734447969323900E-002,0.196668579282350,-0.221565399986567,-3.050996280418777E-002,9.247171498435937E-003,-3.746484995181770E-002,8.509407108227207E-00],[-34885.1138847132,-1606.10393071030,-1436.70441997610,-2562.18282434613,-453.028544168150,904.659624452601,1828.12037927742,365.190100116334,-910.458467923297,-474.956154785799,100.278148929355,-264.948930830375,-502.660894926755,-1432.50810388296,-361.350570986388,-40.5092664719666,-273.172783346146,-192.296678445847,-387.079692654625,292.190572923652,50.8928159247274,63.2198785494010,59.9857005426208,-344.235128583638,49.1847739235384,-122.742596949831,79.7571955388813,-13.9047333607165,72.5739642650310,118.652882840785,-15.1302819109120,-100.347458989612,-37.5969700429394,25.6679272609620,103.575841866634,18.2678972719958,-0.535698832316960,51.3950228682512,-4.68534803738133,0.579412675481206,-23.6181208109199,-4.19354435268459,-6.28015424339671,2.12075524819388,6.94623049943969,-1.81515869187898,-2.02782615607718,-46.3058572673779,6.56465950863302,6.61264214877753,3.74586161692086,-5.03365863581008,0.834907020501701,-1.99485977935709,1.56495253066153,10.2434381715487,-4.93956033228156,-5.51769958705292,-3.51622282144193,2.72980638252732,-0.378766704819914,3.60172369910821,5.02058935254716,1.22980854483153,0.446481526835728,-1.48410153490055,-0.994096462330108,3.25446795558177,-0.982543572147224,0.619656934031824,-0.458443676954317,0.540295161452864,-1.42504196283054,3.56417569917840,0.799340115844193,1.23881779531649,-0.834214833951370,-1.69048956635410,-0.923449429361924,0.429615842911062,-0.280516184108282,-0.209506132744790,-0.507236701559152,-0.318396534720100,0.421034226870749,-1.17786676769975,0.560306843906654,-0.758426964559978,0.788889908495527,0.260175688628840,0.352000045526292,5.290340820219273E-002,7.712084766853788E-002,0.204339596397115,-0.104643073299255,0.965749894937056,-8.553808009035734E-002,0.619143999722514,-0.239651236797862,-6.880571962168038E-002,6.012526208676860E-002,-0.235957047385224,-0.122737970925189,-4.292512806813364E-002,-0.188743176019866,0.257587043788516,-9.797305949812275E-002,0.214560941871299,3.943850970469014E-002,0.218641590293084,8.669157723880169E-002,0.426398851574011,0.325116738614821,6.887679046225262E-002,0.202289762619669,-0.193825727901562,-2.378105300316345E-002,2.487252566133689E-002,-3.788671387143278E-002,7.924046245810862E-00],[-34684.2213049524,-1646.73342188376,-1548.20235571754,-2705.36131873377,-558.442237389185,693.504170193838,1851.17483299182,281.889868039615,-667.486885558099,-590.245023120930,174.279501892136,-292.528643019309,-565.914020483087,-1466.95934857217,-466.398809530113,-44.3237453428964,-284.626848724200,-211.917772828887,-386.350359485157,289.660610504383,13.9386598952672,26.9655677368040,61.2379658141391,-354.292667971097,41.9015738722685,-126.595632658171,90.8806934875507,-29.0857748379483,66.5204639882936,107.614458668834,-24.2363245063555,-98.9831757020570,-48.1321174582618,31.3256186296980,104.218702281793,13.6849319161005,2.59130703254973,50.1692800562371,-4.40462776344301,2.00564321324505,-23.4085431949210,-3.53748935022973,-6.91564939227130,-1.34853035201371,8.54505679001011,0.802453970849317,-0.346483144539828,-44.6712175234690,5.66723469768656,7.30740265096054,4.60095551144680,-4.45908991041060,0.927996585012343,-1.27371549522198,2.05980522277777,9.26065340040368,-4.97621694852398,-5.25929098834936,-2.87678456848542,3.62222645679785,-0.266784190486798,3.32246841171473,5.28577011216523,1.18657122179745,0.568788413251726,-1.59008279397031,-0.467928676484913,3.39898930368952,-0.833068757935087,0.831539298354619,-0.670274522718034,0.446286015851497,-1.43686815345391,3.43767583089018,1.08348785805014,1.27474806461421,-0.680066790637168,-1.38970307578731,-0.847849587607723,0.606296526011253,-0.319493850165426,-0.293118011185733,-0.546225697507985,-0.232468998456619,0.388303555066138,-1.05259875073213,0.599334541935769,-0.796370958060811,0.808299176986767,0.162277415679940,0.345623748359892,0.119723614720624,0.129994366398178,0.271193725775830,-1.030915587885917E-002,0.955698638498526,-5.950143466467231E-004,0.605838790279096,-0.205591162820966,-5.156522205682067E-002,8.297765430680469E-003,-0.249478232156446,-0.102967733873885,-3.716439490546963E-002,-0.182913534143445,0.271370102755126,-0.102785310434963,0.229937858777056,7.525773235405465E-003,0.220520250535719,8.770419496020336E-002,0.433391239385909,0.336568832320683,8.471795930846732E-002,0.205581475673477,-0.160950366054663,-1.924185510020055E-002,3.837900483635619E-002,-3.880617851914404E-002,7.728495252911272E-00],[-34478.3770349880,-1467.96873413919,-1709.67173117680,-2805.21214797410,-580.031522431598,515.218729747411,1843.06342436399,241.353075812857,-437.338456107110,-701.883732968754,272.965552443050,-328.379290146632,-588.056180404848,-1495.13594571783,-557.621668822195,-49.0533346197827,-318.432825036780,-221.688871791286,-378.327345599012,267.374599845407,-34.0349902278332,-26.2506455025665,72.4961035463475,-368.208805776580,32.9292246261566,-136.413039293718,93.0260995820256,-44.7925858025434,52.6282426579807,90.6171694606082,-38.7847622796146,-92.7274188580657,-56.4798830042534,34.9681217488736,101.565421384911,8.55273234898051,4.29421572758704,46.5255452350905,-6.49479789638537,1.83630065284937,-23.5130946426345,-3.41479191519912,-8.23385109422512,-4.54695272187161,8.83169332895105,2.92206538109709,-0.362754540743901,-41.8855976710385,4.96716846277417,7.77648141271510,5.45877748128041,-4.41438554622228,0.960727029920269,-0.647184706807336,2.48163079511248,7.81703093311960,-5.15342487585344,-4.92970819938392,-1.99707789272058,4.31949863482871,-0.174685223749312,3.51481968516857,5.83209254433179,1.22894947320759,0.760253725392292,-1.58975009788339,-1.101843726246818E-002,3.47045027428117,-0.662472504422440,1.00936826745689,-0.907555001868068,0.271992387429133,-1.33015524944914,3.33418541170857,1.38177588010136,1.25205799604477,-0.392249460694200,-0.920167311817050,-0.740851455690954,0.714733629545971,-0.306266599218785,-0.335051577855524,-0.546163771334864,-0.143621395176239,0.350008350450635,-0.935590254671589,0.627251293988279,-0.819549695258531,0.785906713364280,8.053533962002214E-002,0.334061817213979,0.220908061954071,0.171224509918928,0.368862738846703,0.103328033145540,0.936441980891324,4.714354156267653E-002,0.555630140570759,-0.198072935466584,-2.170720016829441E-002,-3.500785971059393E-002,-0.259089562138212,-7.871259722242029E-002,-2.681224438937762E-002,-0.183157440967622,0.272392952159537,-0.106255265150899,0.239807881841567,-2.084387160878188E-002,0.212099680503029,0.103352872627411,0.440137176885279,0.348110427887203,9.727067624460137E-002,0.204044292718748,-0.128812233437941,-1.981799286556973E-002,4.462509805808436E-002,-4.338410125016866E-002,8.100870943634686E-00],[-34168.0845856963,-1272.91825132303,-1752.98722560738,-2888.73833450775,-568.476455286392,461.465098850133,1738.88529351648,181.325202756296,-272.907377055703,-782.654461867465,389.915563745292,-358.827983555308,-609.902037539313,-1475.49412122118,-604.645748262447,-52.4677862053554,-348.637139386818,-219.308272740684,-355.405864340283,223.661536575368,-76.5402744579191,-80.3116932391197,86.9452291735167,-384.446448888919,25.8751211412309,-146.220418658915,85.3142255731374,-55.9646284225104,34.5622701608951,69.3451542888041,-56.1059839164456,-86.1006692612269,-63.6356082686615,34.1080860866717,95.5467003238079,3.96070031215267,4.35786123010821,40.7919692983763,-9.99157686106703,0.902977381512297,-24.8258723454139,-4.60164763827523,-11.0016581788889,-6.79868791410992,7.70044505058776,4.52586756084015,-1.45155033791551,-37.5655594663259,4.49907096565761,7.75714566437030,6.07634648629126,-4.76848735640252,0.952391237870380,-0.536488743483110,2.72235653287745,5.84730440148917,-5.03548540801935,-4.56637108538689,-0.947132369426578,4.80610433545598,0.278318364144658,4.04464203731311,6.49219774543521,1.30505301705337,0.925525996380976,-1.50250399526932,0.274434632041262,3.45931298512407,-0.545760665555457,1.12446201433105,-1.17677787998535,0.125987658891803,-1.15150366977857,3.28826564244256,1.66998821398806,1.26646021783994,7.461383912967648E-003,-0.422448220445267,-0.606826547299078,0.709919057579717,-0.268640323319693,-0.344802908736931,-0.497871059224890,-7.409609560233325E-002,0.305990981265307,-0.829246067029122,0.640108630456824,-0.824846624785040,0.732511038753531,2.712362554436082E-002,0.340877857637660,0.348554553625882,0.206745069376683,0.477485644344336,0.206972165537105,0.902653861074215,5.757899246351456E-002,0.470187936471642,-0.204575551037135,1.044761957522689E-002,-6.293200634048496E-002,-0.259737860110188,-5.244176812086540E-002,-1.667581898382364E-002,-0.179976276781197,0.264348967995146,-0.101305546812236,0.242833163972929,-4.122605630226472E-002,0.200695435526470,0.127616840866915,0.441148769661502,0.351994586887593,0.101335929575848,0.196311404448204,-0.102003713303879,-3.047933531647396E-002,4.596265096649686E-002,-4.980654993454651E-002,8.907205505833869E-00],[-33865.2684775704,-1193.79694680193,-1748.19949960933,-2988.47124580867,-574.649879525316,519.703810617747,1548.66921661854,76.9908042641146,-204.279306369424,-823.045943664036,511.252474574088,-375.134292358363,-661.715760726623,-1385.80141784642,-595.684074251540,-52.8193259004250,-349.521924815478,-193.214383658377,-319.083491159479,158.864024508825,-99.9099392277828,-126.073817335423,94.1415572631466,-405.877159484434,24.3117574078870,-148.209966560052,74.1340060799912,-58.7818229905542,14.9426082264486,46.5281037349600,-74.7718761679662,-81.4539739709929,-73.9184002573512,28.1055708640888,90.1343193596990,1.12458247582071,3.45791747632886,34.3899200676735,-13.1252656323823,-0.156540112648437,-28.1331008484532,-8.18095795781477,-14.3157617513043,-8.93023291549708,5.66878193077152,6.52466736905348,-2.44721041938117,-31.9818443716329,4.22715982944490,7.08453362719946,6.01610097255834,-5.10971961509747,0.925736113434549,-1.37002135207723,2.54422570452307,3.72648263787826,-4.46976970894420,-4.08415398666733,0.242967100358413,5.23688953882259,1.40268739654527,4.64538912770242,6.88888285880521,1.30100901349698,0.949568743443592,-1.51242013788238,0.332777651681966,3.42642540366558,-0.582396124417627,1.15381085341387,-1.48378418067888,0.145860358066070,-0.918332721408409,3.30606554791279,1.93985895784593,1.46499578118964,0.483243338240022,-7.597973834386895E-002,-0.499455041165505,0.604053452012985,-0.259030388544027,-0.349569480544180,-0.424673036488383,-5.494001907914500E-002,0.277168106903051,-0.735353222609446,0.657352741844435,-0.845092211106755,0.691389320547139,2.280159752466631E-002,0.378594996190150,0.492326968642223,0.261794066333115,0.601214508360659,0.278875636210701,0.837619605524261,5.074885207803247E-002,0.369213738238354,-0.202246684164004,3.320000445209003E-002,-7.486108571210731E-002,-0.244209497865575,-3.015310888436197E-002,-9.395315009956244E-003,-0.162516318473992,0.260527304975917,-9.160880955537784E-002,0.245047618718619,-4.705004846005743E-002,0.193736893162268,0.156579147359267,0.433487504310668,0.352888339380101,9.993605655639839E-002,0.178872321813304,-8.019044761708330E-002,-5.156639422098881E-002,5.003172480036309E-002,-5.164039100759055E-002,9.703439475912080E-00],[-33745.5062504687,-1119.13346675366,-1975.41789806994,-3093.20335490757,-605.761275068756,591.403598443094,1350.02924746897,-38.8035239394800,-231.825167992779,-844.592285244056,602.310114515845,-360.217943511878,-729.471195737240,-1233.71672030271,-527.068311385409,-51.5560651218944,-320.285130343048,-138.776953423780,-272.685952635982,79.5682942587665,-98.1038429645778,-162.043425253780,88.1178760345463,-432.716156238906,28.2214801069408,-138.910373101446,64.5405912781486,-52.5230500573509,-4.85738493738489,26.0804283932419,-94.3004336332028,-78.6175984201237,-90.0016254631396,19.3580297728105,89.2257976038283,0.395908376014801,2.46594225076284,28.8392064526600,-15.3606698328122,-1.56365835704668,-32.9163468060530,-14.6422675924903,-17.0276091558350,-12.3532556119337,3.63965900836533,9.87078098576693,-2.86329230728500,-26.4434293987371,4.10910263845300,5.88358621416481,5.12710471375072,-5.24908971090000,0.775956664873605,-3.20684401069824,1.77646629481002,1.88986846185184,-3.76897021347017,-3.36905650987966,1.64652632691982,5.69020274965011,2.95082353075589,5.00552699632486,6.83552476534099,1.15654370056494,0.806548952106397,-1.73431389686861,0.166344657786650,3.38511285438848,-0.815635496559177,1.09215801313636,-1.79301726447981,0.349476257320515,-0.634841413493307,3.38285649993974,2.18822595888626,1.86874115782783,0.945824622329960,4.611850060608804E-002,-0.436663633472913,0.465290932253589,-0.295046840420682,-0.367669135454698,-0.355416254278613,-8.482204636944080E-002,0.286925002614192,-0.670195395964494,0.694885411233406,-0.899354741247049,0.683520897006348,7.705266151402025E-002,0.434215435576437,0.644802946034860,0.348742588153333,0.739715539102924,0.304378268976181,0.741605016537660,5.400282033486142E-002,0.279926878726638,-0.185644968991605,4.115715107578844E-002,-7.491035281751032E-002,-0.212491623374316,-1.280676182125466E-002,-2.837278432487920E-003,-0.128687927459894,0.267417364893946,-8.438490199420955E-002,0.252145384346391,-3.414585295310929E-002,0.188561403218508,0.189680329150903,0.418191675580189,0.358490202866451,9.417664794968456E-002,0.150714032753138,-5.796064516487980E-002,-7.565108513336644E-002,5.931042220565595E-002,-4.513108270526297E-002,0.10006770503387],[-33787.6616969364,-1017.75670006101,-2352.57428954051,-3154.99245519889,-643.331262229480,672.957708869055,1210.17628234448,-149.877873433561,-327.918508293240,-871.503340395987,634.463348398469,-297.425675512842,-786.924494880116,-1034.19862336967,-411.574791158090,-55.8499505476750,-275.381438361328,-70.7490537093517,-217.837569779582,-2.29746711887847,-70.8262735500994,-191.200652161454,65.9631368510919,-456.041689319789,34.0708273417445,-119.898348907786,55.4806372770264,-39.2494332968959,-22.5756145975878,11.6179482662976,-113.647728968487,-78.4779932191976,-108.274514078235,11.6272136630168,92.7274870063729,1.24476464013760,1.86182484052552,24.5083564671285,-17.1876812198987,-3.36873509849661,-37.7304399248084,-23.3234892430703,-19.3775249072100,-17.1371614388327,2.65815243662039,14.2117782801771,-2.91464646051750,-22.3636864988153,4.12336255448661,4.40011944021548,3.71089168161049,-5.26503593285171,0.330262556190426,-5.67123897265251,0.437973860855761,0.431161526275811,-3.27635829850694,-2.34120466576396,3.21194820885940,6.08722581652437,4.28394908594185,4.89345444773537,6.48977510807047,0.918290857341607,0.553290485259757,-2.09291526802991,-0.157286654431791,3.25592502987758,-1.20055365127772,0.942766788997688,-2.04471300113716,0.620891206342320,-0.320801674127507,3.49228438211812,2.41220250055530,2.33069471864569,1.25735762062685,1.775375194497270E-002,-0.372139575844053,0.352125144676714,-0.351788925312592,-0.402494685877799,-0.295917641634988,-0.132798918429088,0.319123888541131,-0.644815585406148,0.741480082715405,-0.967517392143682,0.681160939564437,0.169440426269535,0.489012489677037,0.798199001701968,0.445961262665972,0.856771148823225,0.282413120167198,0.647753819007841,8.430540103550482E-002,0.217579796022787,-0.164436436505516,3.685162464237400E-002,-6.877120255838609E-002,-0.172523692507264,4.210088940370270E-003,3.117529296372496E-003,-8.570978413192960E-002,0.278025837116716,-7.976921235477864E-002,0.260827784845265,-8.490272990637419E-003,0.180052856649574,0.225591753061377,0.396770714613222,0.363693972068362,8.179966949300628E-002,0.120047508816285,-2.883903563370945E-002,-9.359029436450460E-002,6.987737184637648E-002,-3.324887305222583E-002,9.624378979681576E-00],[-33899.5381908410,-936.226800195102,-2658.95635941818,-3092.00088776730,-656.401381214690,843.251401500663,1130.73475583041,-252.392062574577,-426.050023051261,-911.049536298744,612.775659886874,-175.927519873648,-831.022686496766,-821.735475820602,-283.766024343639,-65.1165515053320,-226.838495010257,-7.97859640277532,-151.744076963518,-79.4032056156484,-28.9405950723247,-220.118024828017,32.5618874776719,-457.354143828077,38.5023211642148,-94.7863501043488,43.8796443305140,-20.8830333763653,-36.9697075653364,4.57244847988546,-131.933811445996,-80.5249340376643,-120.152449412728,7.43104219998346,96.0734373341941,2.50177756404552,1.96365575708661,20.8243663368079,-18.7269721310577,-5.17486227953987,-40.6196006640932,-32.9049930853147,-21.7588705649643,-21.8402646547847,3.62079725234746,17.9052670911658,-3.38029125950926,-20.4346552496782,4.10511246362055,2.95678786838360,2.20652171195784,-5.16477482786188,-0.445670192418388,-7.93101859438630,-1.23340998946620,-0.731646823988969,-3.10262164012109,-0.916724733188088,4.71779540536621,6.11069136380836,4.83247718304495,4.24747959143774,6.23447631035381,0.668673985078645,0.298826987604910,-2.43027184107127,-0.524289592596176,2.98432563529821,-1.57422696041744,0.720539192759658,-2.18555112737678,0.783835970370907,2.342819432991198E-002,3.60109328998444,2.57676773940240,2.65563788670026,1.32653695702259,2.808571585327744E-002,-0.243449588360733,0.257164401363513,-0.388638158899295,-0.449060773867923,-0.236996428700833,-0.166257081862886,0.338659032582443,-0.644609390697169,0.769402332166000,-1.01231596961494,0.631642414050094,0.274871243946976,0.542522525672038,0.942882956891245,0.520486726174928,0.904229412589689,0.248829519115025,0.594303068585552,0.137052318946154,0.182898916116809,-0.151406245435624,2.849740112313539E-002,-6.436280259761466E-002,-0.135302064740915,2.397355094149090E-002,5.854072510795402E-003,-4.655841072084173E-002,0.279955055632096,-7.057972533449838E-002,0.263269262140543,2.125009782540161E-002,0.169606768730045,0.262345981582930,0.372364008840559,0.353246205379441,6.664165704753240E-002,9.880070495235140E-002,8.678918946293622E-003,-0.100242428985582,7.415895406034075E-002,-2.351816972537264E-002,8.620703932769753E-00],[-34223.8604144814,-857.875529957090,-2679.02240640294,-2842.91231544956,-602.618922232371,1138.40239609652,1090.88085063828,-355.860731871231,-460.064742531698,-954.930201405415,534.830033103529,-7.50606608246904,-885.502721738725,-656.781767535503,-191.798461241502,-66.6877267873000,-185.570699175114,34.2592882258492,-78.7417034291753,-151.614918959026,4.23302058289566,-257.730183223295,-2.99147335358073,-424.638735782297,40.3231271070491,-69.1155267670465,27.2982147089764,-0.223478442564099,-48.7018786864620,2.66328035094006,-149.685852455177,-82.0188050182879,-119.474588316675,7.24200689624024,92.8978493973558,2.99408913180372,2.64829446381141,17.5356969610407,-20.0026684842677,-6.75781229335231,-40.0975487044363,-42.1765224493279,-23.4512381607026,-25.2193043195945,6.84804940911817,18.5654376633650,-5.08222974842693,-20.6647224322911,3.87721584965691,1.91172279853792,1.05289966670693,-4.82822967226703,-1.37105177272180,-9.07012669879944,-2.91292024812661,-1.50007724646567,-3.32570698523985,0.869795696588109,5.61382841660278,5.43291479577751,4.21526823459634,3.29179129214981,6.33200182175507,0.463012044564477,0.174110746289661,-2.58525613729701,-0.826130191029718,2.58389564020556,-1.70849322593964,0.438815488166526,-2.15543519281975,0.682254983406397,0.412153973151730,3.60068274811489,2.62953866775118,2.63478304851471,1.20222750013945,0.225164599729446,-2.436102220322048E-002,0.119587070506862,-0.374488130156923,-0.487845337121860,-0.170102524835163,-0.162429501461960,0.324869849838626,-0.639790587668034,0.762460161912559,-1.00104828615851,0.494102258481090,0.378718747745651,0.587948251088198,1.06585808621552,0.522776873911559,0.875668789606203,0.251326942431646,0.603609316784366,0.183635164901751,0.166306713232123,-0.153446170089486,2.466275237220749E-002,-6.682953244785535E-002,-0.112119013780622,4.569475848769012E-002,4.558942393551756E-003,-2.276658977408930E-002,0.266845762905213,-5.044143026229540E-002,0.254890178359509,4.895785125998423E-002,0.161052687222111,0.298742201449367,0.343148748168017,0.321821607501355,5.565317494365524E-002,9.930189919506603E-002,4.625115672123054E-002,-9.569901315667939E-002,6.629515203402513E-002,-2.046690019619615E-002,7.338125988548606E-00],[-34778.7344884298,-670.389133453409,-2596.91963222165,-2484.45129655506,-419.262432116412,1438.71924708681,1001.99866863788,-536.109227376557,-438.773331039687,-976.684496122430,392.151209259151,144.497342442247,-978.471540282323,-585.180121050357,-111.426909935828,-56.4885544057973,-158.795900230017,56.5690014990698,-14.9392924424679,-220.642416532881,11.7815833901568,-285.023056211338,-25.8762529728267,-369.087308349138,40.7260576698648,-47.8759889616914,7.32156873226426,20.3028757035635,-58.1387913001166,3.09972152046882,-161.043668252558,-76.2010277747364,-109.366443623859,9.60855507423413,78.1874875176525,3.09011572726456,3.32320638990236,14.9221693213298,-20.5093899155290,-7.95661886277584,-35.8924655817241,-49.4562113822367,-22.2367121529633,-27.8031435646700,11.3678701682347,14.0179166918195,-8.81427384795340,-21.8425466333234,3.70566994761745,1.36949828846416,0.429731166581094,-4.02860580702012,-2.21166905431052,-8.80041829766521,-4.53591670484048,-1.50234748477269,-4.00550731887495,2.64626694483634,5.19731876388035,3.72853985210336,2.80444713017033,2.53759835683224,6.70155998220848,0.343282349017714,0.250733953492952,-2.54469823733079,-1.00240147310596,2.08158930139941,-1.51996551597569,1.543890123035355E-002,-1.92730866772124,0.359047682749471,0.783742409434797,3.34593361507608,2.41492688605810,2.31811058207712,1.09957623775140,0.596241026952548,0.248814133699202,-0.123951112608664,-0.318360684288542,-0.491341087873955,-0.106206849111731,-0.133624332923312,0.273808406577184,-0.615905476587795,0.704602737563601,-0.937039453917227,0.298221056093482,0.463039820281863,0.615577095502543,1.11616104460529,0.458495866734924,0.838220428713717,0.305357741467061,0.665755700574279,0.177620720750803,0.145467137841966,-0.168540052092654,2.214346702062496E-002,-7.334079262826938E-002,-0.106648822292949,6.194972444939895E-002,1.653621225415388E-003,-1.660172212718024E-002,0.242188398075117,-2.429718706803715E-002,0.241523037692472,7.300777846813147E-002,0.160615753090324,0.326134078594526,0.309808374430343,0.285580128771718,5.276078142395247E-002,0.124540824038721,6.495382182403718E-002,-9.134027315013038E-002,4.733994533314637E-002,-2.045732319050922E-002,6.233013341455815E-00],[-35427.1029093923,-273.511883196312,-2322.61152221302,-2117.86625737101,-63.2482165338306,1697.42510743042,882.710517599267,-801.868750931907,-388.214663260834,-958.925193796805,212.406974689394,254.801969435815,-1102.81684434818,-622.089130398910,-26.3991608169423,-38.1831975970305,-149.283268047471,68.5348387581096,31.7918259877256,-280.823863316541,-11.6706328710069,-288.733856559051,-25.5407090967889,-305.502124503531,40.2604581134033,-34.7459818546418,-13.1822158564007,39.7598426203111,-64.5520880897603,4.79297419315691,-160.926414404314,-58.7020461207581,-94.7195759538990,14.0743693326330,52.7389498143766,3.21231664218269,3.27098116785371,12.6863186333593,-19.9091275830389,-8.40651181010472,-28.4560128769326,-53.1835895599012,-16.8649377354447,-30.0015982478306,16.4443183204504,4.78131670454257,-14.5085807336086,-22.7707265936726,3.83646006584744,1.15687867300888,0.210389489723995,-2.83948078758102,-2.84107098944927,-7.26251949448596,-5.93310418136074,-0.651829103900278,-4.94944481969358,4.20440523808526,3.50979874571723,1.08142035644878,1.17719434504420,2.32312795107473,7.16730186762149,0.358740239508857,0.512583289277413,-2.38568029003081,-1.08478631998681,1.51699725777602,-1.07555283579146,-0.568578857160162,-1.56780512357007,-1.027040610594812E-002,1.09370670456817,2.88531838449267,1.87417805632264,1.87429902798144,1.16352584856151,1.06014157001187,0.496588698947567,-0.463218662375200,-0.234994117195733,-0.441093391057624,-5.599794344624366E-002,-0.115311980471682,0.182553808303442,-0.578906952532052,0.589262738450693,-0.854780321544539,0.108711300299544,0.517698038508056,0.643461100034634,1.06473506289591,0.370756617206529,0.838437677334013,0.403690582007837,0.739986368806574,0.104156184942564,0.109053483390800,-0.191223629397347,1.772349147711407E-002,-7.712144187488813E-002,-0.112508417763839,6.558138203722888E-002,-3.081383244146785E-003,-2.927011288020143E-002,0.209227674174460,-1.548397149263464E-003,0.228848116231227,9.188992509426708E-002,0.174933096927938,0.338335758327214,0.279247690971744,0.256398935964647,5.978815256354877E-002,0.163099607198172,5.622729421859823E-002,-9.503954425758791E-002,2.124525384763808E-002,-1.889691925757833E-002,5.484790727845243E-00],[-36061.7752271920,44.6205233259876,-1959.30012327702,-1807.18097723458,369.938165004995,1844.91229725926,771.309269003675,-1050.93557351673,-335.417512770307,-902.901435219673,23.5857492372922,340.148682661480,-1205.94251640720,-703.907326279934,9.11524990225293,-15.9073570115971,-152.062832678768,90.4929015985820,63.4596926408671,-325.237924505151,-47.9418290281245,-292.450931133689,-8.80114177323841,-243.735104822772,38.8170081804841,-28.8065881959380,-30.5296509683996,59.9852127026005,-69.1213620391688,10.4512270197691,-154.202696053769,-32.1395593318017,-80.5632311209095,20.8858943883203,21.7314105284599,3.31741844264786,2.30507048887957,10.4600235469432,-18.0099027689035,-8.61780821707333,-18.3548668603269,-53.6632174217356,-8.45159144105920,-32.1890529015509,21.5063965431270,-6.04679545395477,-20.6477387789472,-22.8932838568296,4.28153376402137,0.950203362630175,1.416054769250778E-002,-1.44383294595704,-3.28954428883534,-5.01823553392322,-6.82438585102564,0.603349698468083,-6.00964779268572,5.50258171183205,1.31674916870588,-1.65384049604591,-0.435618107350547,2.59822325105351,7.50862957652115,0.507982055523475,0.834410614648353,-2.23059159156109,-1.17533843927814,0.944267262670212,-0.566422876429406,-1.20277760861370,-1.19419786888363,-0.262973456495367,1.33735937547352,2.42363878818890,1.26444984459238,1.40146437045705,1.39400686320659,1.50465722022938,0.659749183257538,-0.831383669136252,-0.132916456003711,-0.348874979504437,-2.912234558820929E-002,-0.146989944933930,6.815424142616255E-002,-0.555572115899506,0.441373668806565,-0.785059137650938,-1.668335300380603E-002,0.555798724039977,0.703374325515307,0.974203121792392,0.290119915932328,0.866424000795677,0.503859975097804,0.767469171481638,-1.782216106054452E-002,6.434355479288968E-002,-0.207725788245190,1.205010758542453E-002,-7.346813057709665E-002,-0.119144140999173,4.976029570256164E-002,-9.776815110243121E-003,-5.836906939226050E-002,0.170852017100839,1.279677715952820E-002,0.222844999539432,0.108575245204402,0.203766627713211,0.344231885799581,0.252996767789095,0.232904528007822,6.664943441526464E-002,0.194631972188059,2.615552374085007E-002,-9.888168123760724E-002,-3.692665796026024E-003,-1.363965809004407E-002,4.717125885028716E-00],[-36809.5594273377,377.341489176373,-1505.74786593085,-1527.78904673984,868.660775843295,1961.25471119021,639.922107543712,-1224.30211601671,-307.027480690679,-796.139019867824,-140.284823654945,421.249561798360,-1237.07391131949,-763.030663206799,-40.4149133816724,8.54743598374464,-161.624742580875,148.776142645804,88.1591600679876,-350.265468109592,-73.7138084058539,-320.920441482217,13.4321987149557,-181.782853020542,36.6686387966226,-27.0083502248859,-42.8727492529013,85.9015498753561,-71.9968217352617,22.1736900766601,-147.750950898619,-2.24753260474730,-65.4808414474089,27.5450256491033,-9.48602065405466,3.34513999507781,0.279304281799373,7.92923997413230,-14.7768028849480,-9.52953533773489,-6.34461667327080,-52.3109969719711,0.773273334549566,-33.0399280584883,25.1942296954131,-15.8460546667540,-25.6129425212815,-22.2733897004948,5.02137162140222,0.451969077433646,-0.722634668259602,1.651222991048180E-002,-3.62177833213326,-2.79815609094604,-7.08963951003727,1.57940518982388,-6.85516734519923,6.32428122098645,-0.661262401231289,-3.61103211873829,-1.93219209399317,3.09387896347070,7.58783555916580,0.742417811961974,1.08201338016574,-2.20924497122623,-1.40570723423378,0.380303448543063,-0.161914190167231,-1.78223380586043,-0.954331641070425,-0.292638138556336,1.46836836517851,2.15091437775687,0.851407364370595,0.952607835107798,1.66110489038418,1.85823523337217,0.731054938903699,-1.17344146304742,-1.561066097990901E-002,-0.235227920294665,-2.861483140161647E-002,-0.255929748384551,-4.040224617017345E-002,-0.577360046558922,0.292320835261703,-0.749924440613490,-7.346747918461473E-002,0.594260276933191,0.823498014051471,0.909584278008770,0.236509316418436,0.876213501780640,0.571374281302283,0.721401164929409,-0.170439302915422,2.516936727269017E-002,-0.210572288463693,4.773103069318397E-003,-5.863272044975694E-002,-0.116360303129352,9.305671602463452E-003,-1.867936003770469E-002,-9.570028459232911E-002,0.129617148630496,1.887650670258135E-002,0.221586782072405,0.128246561931084,0.244882235705931,0.352912492596479,0.230550089427022,0.205398216334456,6.437694343027517E-002,0.204763428597149,-2.042990166388541E-002,-9.279822906773585E-002,-1.995442284532585E-002,-6.477188950602112E-003,3.735767477596443E-00],[-37443.3314916583,772.951706216771,-1064.29001586965,-1264.60434910443,1390.47935580093,2059.16095782032,461.889707202402,-1249.49416123207,-318.379840981271,-651.775284603734,-266.688759508180,502.285883574343,-1160.81650258140,-762.989470632399,-146.051945784785,26.8691062290690,-171.784940743828,247.500540603426,110.657183199289,-353.401914029573,-74.5033822109544,-371.198156384497,31.7657583022980,-120.193769871914,34.0153708023655,-26.4826523500453,-47.8707423100986,117.918209336051,-73.5036312864402,38.9563748975167,-143.660434842680,24.8754804469342,-48.3549652766167,30.1909745668400,-34.9496279881273,3.42313097227620,-2.47222889976572,5.39250668964226,-10.6735207234891,-11.7436229006516,6.05745744874027,-50.2754750244600,8.96493311781737,-31.2431175023728,26.5651173894002,-22.5178830621114,-28.2051178377067,-21.2504467028652,5.99255915298492,-0.489392937996321,-2.10082230470250,1.34681696421751,-4.06733665074369,-1.11464275880686,-6.81879361323648,1.99199509463441,-7.03456070868516,6.65192052256200,-1.85919045117096,-4.37417666679844,-3.17519516420897,3.49004005240407,7.28697229364399,1.03813801719205,1.16981253613444,-2.38606001223814,-1.79557926912267,-0.141836073539046,3.857751408223950E-002,-2.24720236501932,-0.870528170726947,-5.330974703768597E-002,1.51285587804666,2.15497569561862,0.737697212585856,0.558437631161131,1.80453093365110,2.05328731975688,0.740719741038834,-1.42967913849805,0.108897623446361,-0.122595845342389,-6.042081380467135E-002,-0.434337457651709,-0.118038749406525,-0.640472367470813,0.155346759125522,-0.740527069895749,-7.658865193004488E-002,0.656742723707880,0.998399050447611,0.887002247628456,0.217523282773033,0.820064736081139,0.583786746888509,0.613947786664096,-0.314655902214834,1.667387903002813E-003,-0.201078965144595,-3.378024691481684E-003,-3.152023822734372E-002,-0.102516212575638,-5.031447059518061E-002,-2.629630517282253E-002,-0.132465413186926,8.584939049056006E-002,2.113683390619762E-002,0.217791087043927,0.156026063608865,0.290398147413532,0.362475890124110,0.211473371737461,0.163781056126943,5.218491169393952E-002,0.189582167997510,-7.096498927586362E-002,-7.208193237769775E-002,-2.660260157540510E-002,-3.943226364700802E-004,2.645750462070978E-00],[-37827.7043087827,968.948863231950,-891.426557845900,-976.187565416198,1801.11511955941,2083.55187482798,255.421415714927,-1168.33653245443,-364.198079619118,-514.079628074646,-404.978534120518,582.442179183711,-1013.86759557658,-714.810885359969,-246.268303924728,35.3549018992325,-177.204322174445,363.485365840376,123.487099637850,-347.397944487434,-54.7328113166837,-426.631530773853,38.8225490516038,-68.0113097288434,31.7416745518326,-23.9538588795120,-46.4296360123972,150.110201440386,-74.0088074131204,54.6889742871520,-142.016716395411,44.1916819462527,-33.4314143240081,26.4910386521075,-50.7476177807465,3.48780973977565,-5.00193365476781,4.16802480658952,-7.29809079065177,-14.6122761156299,16.6907189376686,-48.9178503501083,15.2189435937646,-27.6242095248398,26.1256529719188,-25.5387904868645,-28.3135780136180,-20.2378921228230,7.00099125366338,-1.74170847418754,-3.60184583146885,2.49122997514062,-4.49758188830990,-0.254120519783698,-6.26648560849563,2.03334725721785,-6.58614819067389,6.93377652431350,-2.31109067880721,-4.14175447423306,-4.10688158927524,3.65960620939493,6.44971060423539,1.33198508475197,1.08505912575288,-2.68094703183249,-2.23864777919557,-0.557358405496893,5.809977735402121E-002,-2.57257155948975,-0.850492276206057,0.373879198434421,1.60337349354705,2.30914349924315,0.859102377510646,0.164208923803402,1.78340741119602,2.00250215622009,0.732163116722286,-1.57888994043040,0.232615418422319,-3.635619386365559E-002,-0.123506420550608,-0.625343590112444,-0.154908180442329,-0.720491662646137,5.352088946402225E-002,-0.740694056750713,-5.768015248895754E-002,0.761029805203387,1.17082326452875,0.894025991675628,0.197160079213738,0.698936194880025,0.518312192396082,0.486997733176581,-0.415229664198920,-8.037609511741728E-003,-0.183621151955807,-1.078381450152021E-002,2.336781385194959E-003,-8.914115047263610E-002,-0.114442040001305,-3.287265703663075E-002,-0.160665153309258,4.270802839170527E-002,2.034121167090263E-002,0.211208629930539,0.187260968934955,0.327333638804130,0.370646643641710,0.185791442826631,0.111168920163987,2.980021081020911E-002,0.158622930704308,-0.111118217518128,-4.137196668791251E-002,-2.785278962645223E-002,5.058079140944548E-003,1.651704127052784E-00],[-37940.5294205724,855.867352784972,-740.281061976657,-689.599893674277,2103.44997552470,2168.91519334437,73.3527146514752,-1103.38186086801,-439.924126032750,-394.693536721929,-553.290044007260,686.201865410461,-855.352627902011,-613.358470150351,-279.191785258833,33.8756830641073,-170.921249914065,470.289743029040,128.057489162311,-339.425271721209,-17.0637331890543,-467.386461334245,31.1183345881387,-33.4072002240295,31.4381623041753,-18.8402934904730,-42.2973330384168,176.160403376087,-70.0697315567954,64.5033751942248,-141.564185409291,52.2297185747833,-24.3995981039615,15.3537269456263,-57.0869383291531,3.71893407285727,-7.03574332484346,4.75641664183541,-6.36635413146505,-15.8436648761926,23.6020061412703,-49.0045984359312,18.7169842744832,-23.1433829665901,24.4870728423490,-25.8545173794512,-26.2693122001570,-19.0355999011658,7.86241365297592,-3.15029720085403,-4.67617947604025,3.29536201180304,-4.49734628689297,-0.441449403398663,-5.64402100838677,1.84572692026569,-5.51085999793785,7.47555380357413,-2.37149786829382,-3.22990311702984,-4.58001501473934,3.68413152848783,4.89542607074314,1.55008426179827,0.877389772213860,-2.95224059566972,-2.63784220025808,-0.845741595146021,-8.797805432081526E-002,-2.71898498729422,-0.841500806085031,0.905650390508603,1.81993630689793,2.46738873663519,1.12464246449691,-0.256803093401802,1.67349530776808,1.61399212674438,0.747437409607739,-1.65302314273343,0.344706815336187,1.933775723304750E-002,-0.204061062398478,-0.767700013638277,-0.179945691688713,-0.801700185120210,1.756767291908598E-002,-0.752313943054706,-3.776516893958980E-002,0.886519565464552,1.30349831339310,0.917840554364744,0.138009743155066,0.549082709256329,0.360065122131549,0.386774231589087,-0.470365284973871,-1.485943751269363E-002,-0.155021303255145,-1.746293936176959E-002,3.893646750569747E-002,-8.788517133704711E-002,-0.165890594447301,-4.531714659947140E-002,-0.175743829664275,5.432429541156427E-003,1.080856682543011E-002,0.205730679978985,0.205892396787155,0.355375868703914,0.376313242421785,0.144714117307537,5.674258304653411E-002,-3.224318078083964E-003,0.127349490262824,-0.136125731665511,-1.121662475874561E-002,-2.308500583840989E-002,1.228738685136048E-002,9.073918124587566E-00],[-37797.5725480272,627.166657904309,-458.186857069329,-516.782864677180,2321.99750392333,2345.71767133276,-92.2182487720982,-1140.16868426235,-525.992616115752,-316.629554439269,-655.055928541263,812.801514809747,-715.485744081290,-458.205141269218,-239.327736229930,23.3068439750980,-157.259078022027,553.504366361856,128.839757321476,-325.548478704713,28.9605429207500,-485.691394906517,12.4008458061567,-18.0435191014473,33.2871504594439,-14.8867584036172,-35.4051212974744,189.437556353975,-60.9751257823268,65.6608428022911,-142.138109424631,49.9915265273594,-23.3670246589535,-1.81824553383000,-56.9854713740166,4.40929104862646,-8.57348647440450,6.35935636372156,-8.34763081284479,-14.4306428104940,25.7176081736041,-49.9668751535346,18.7990197091242,-18.8320467819082,21.6628815058267,-24.5716019773754,-22.1581729733134,-17.7192809103814,8.45550712046096,-4.44557634206968,-5.18702581989532,3.51743639122530,-4.03660592270261,-1.68426505563931,-5.01119060822982,1.31622569143105,-3.79971066751436,7.98971017703311,-2.33688582227254,-1.73501023417414,-4.90674000885404,3.57471642649869,2.59079210402768,1.67163326552960,0.649943836054591,-3.14018381612356,-2.93297068152069,-0.983498226249840,-0.423257988212663,-2.63364201544023,-0.891617008794939,1.46638412568638,2.11983074271788,2.52489042547974,1.50948128532256,-0.754572759688065,1.58647782633546,0.883479608692439,0.836759431250530,-1.66789612319779,0.430889112470487,5.638416884400294E-002,-0.283662984165979,-0.831237151717989,-0.209929310171509,-0.865935316743375,5.054294431576432E-002,-0.777172946469610,-5.521646207536037E-003,0.998007525697519,1.37616070595137,0.944921686180474,1.672982806892912E-002,0.413774160868912,0.124899601777494,0.336323328703108,-0.485955033085156,-1.909642606383569E-002,-0.123426314167504,-2.158350770071881E-002,7.479836698802851E-002,-9.564549215675634E-002,-0.191009126949259,-6.153548743693767E-002,-0.176490276098707,-2.469359177628115E-002,-9.028222147153065E-003,0.202700164787391,0.206096775943808,0.376311709092399,0.373881953611285,8.717690841288138E-002,8.308408555070205E-003,-4.849762607032270E-002,0.105206401788315,-0.145611125552624,1.682296564957498E-002,-1.312051833116863E-002,1.908460757449376E-002,4.126177691619488E-00],[-37516.0678389441,329.504917159170,-85.2702531202936,-506.638304606022,2439.34351304395,2543.39005015144,-246.999187701171,-1211.54594639756,-585.779574631487,-292.718890521696,-668.879983400432,951.125874390704,-583.995831503796,-264.266172510673,-165.563248465045,8.21995249197813,-136.469786353028,613.822246647644,133.544783053351,-301.566790070745,72.2107161834277,-486.305456345546,-16.1494637239238,-20.3744803785898,36.0048753550663,-13.8818111687258,-22.7730177210746,189.406567210594,-50.2293937021143,57.3275317617883,-143.904062041830,39.5109157263881,-30.5300966739653,-20.9715808153029,-51.2297346077229,5.51061776353651,-9.45373684682286,7.86389127598169,-11.4454466933517,-11.6192878340162,23.5642641357586,-50.8484168483757,14.9965864110424,-15.6865796730476,17.5466211482553,-21.7891773346851,-15.7979351627742,-16.4366645661455,8.69222898952304,-5.43974685657294,-5.43861034461089,3.27050732594478,-3.48541364041386,-3.57006299446238,-4.55836899333358,0.351570282653080,-1.68559770399142,7.93787674973026,-2.06391394802734,0.461399740367632,-5.54184435041887,3.20363620364066,-0.345225637358752,1.65236132814897,0.452327349054266,-3.29059259497162,-3.14227692396669,-0.931454538766496,-0.849543814025586,-2.39259701409311,-1.02960331077471,1.96686156147938,2.40732430391209,2.46141892370615,2.01820727546286,-1.29947913485995,1.58178497934223,-0.118882540902088,0.979651584646155,-1.63345403405493,0.468370168861823,6.992568334123411E-002,-0.338869430571882,-0.832299030770046,-0.219658720657048,-0.885134126548811,0.122863681263376,-0.781406064156333,4.751204461725697E-002,1.08734691973698,1.37474795868188,0.951198288663788,-0.161119908287645,0.322046204935897,-0.127754746840330,0.322154295822026,-0.458439561231426,-9.174698739259184E-003,-0.107075829896023,-2.118884798195183E-002,0.102553688339455,-9.786914796498597E-002,-0.190177264077104,-6.691220357344284E-002,-0.161137805044921,-4.388975466928900E-002,-2.525903548723692E-002,0.197404640723675,0.202804969151065,0.386143715429713,0.360774780389376,1.734118546322039E-002,-3.311021678426566E-002,-0.107385823173555,9.004523428938220E-002,-0.132339478754547,4.266761843989033E-002,4.958572643992444E-003,2.144075163253014E-002,2.748814704539579E-00],[-37003.1021873349,-209.642611294675,187.673140550394,-596.279000494392,2495.27672357002,2691.93197078180,-444.666410347207,-1293.98585433685,-591.117171333178,-278.106644567068,-622.684490214598,1083.63707842060,-490.894498256841,-67.3541889412263,-85.6460562262339,-0.142659243508044,-93.9278327863418,645.910416203451,154.784370064486,-286.687638548113,105.309500814933,-479.582852656333,-55.3550107493407,-36.7028210372831,39.1079501198694,-12.6058808423421,-7.29476262625461,182.944752786677,-43.3639542147942,38.6742565984205,-149.043835735219,20.8641988632191,-43.4608699812848,-35.0907007458383,-41.7257468560426,6.48917403473636,-9.78836481155734,8.47985632295109,-12.6743619254181,-9.45301142054215,18.9676213490881,-52.5950374413539,6.66101016529785,-14.6491705581202,12.7089283482456,-18.7374471710453,-7.87243330442913,-14.9033258184372,8.39418207048482,-6.16727407597006,-5.48764647562339,3.01522923830319,-3.14350028560459,-5.26147875931303,-5.00912367539604,-0.854060142863569,-4.065995482427223E-002,7.13227735434540,-1.44306852344892,3.12627036663027,-6.71083017421799,2.22994123218825,-3.57477584319493,1.39434054310712,0.256114425923417,-3.34446561074153,-3.31665692912611,-0.676731599044729,-1.06697312996685,-2.22126763389736,-1.14044446940757,2.16886279247676,2.62393804883546,2.19474495965043,2.55597110282072,-1.77079560428497,1.59485427004019,-1.31726831383160,1.08102381365897,-1.63272083386458,0.450382921663383,3.238521059738406E-002,-0.330637462045828,-0.795323230574726,-0.178074859366489,-0.835130416275860,0.180434909971893,-0.682341746272106,7.242485334929842E-002,1.16703681489191,1.25380618422431,0.896641862613351,-0.390966745966606,0.268937277293189,-0.316785161228108,0.327775512516463,-0.402820916291132,3.272817068126006E-002,-0.141321756402966,-1.418469435984547E-002,0.114656115234916,-8.724416605873263E-002,-0.175406720794621,-4.875436333232295E-002,-0.126806531488496,-4.630997398975617E-002,-1.670518629657229E-002,0.176907741659113,0.214986788048559,0.368382368581085,0.342347963318816,-6.967160725798455E-002,-7.740862071333138E-002,-0.183300624256945,7.929531448323356E-002,-8.863604940942466E-002,5.531171299992590E-002,3.337683596929957E-002,1.702691880661188E-002,6.071590141056785E-00],[-36402.9291361788,-837.304256821012,476.227651566348,-721.614077522608,2564.77054600265,2826.62450025865,-737.980478727041,-1368.13527068448,-545.028861251644,-241.636630577423,-572.352041891070,1189.82538568415,-452.060545912202,68.2866239577460,-18.2520547630046,7.40363784707724,-30.1005775164964,638.794811536693,197.270967191883,-303.736313647376,115.510139225210,-469.610854401444,-94.2117463261759,-55.3456474810866,43.1577931765656,-9.88076432013683,3.13882795639143,175.372859138242,-44.2189020265226,6.14269262949890,-154.832336561674,-2.16576315024133,-55.3656546403140,-32.8454623569891,-30.6942045143326,7.54055494006194,-10.3577561062987,7.58962899409147,-9.89144761806649,-9.92918152133935,13.6881331347730,-55.8662687615333,-6.08407280977035,-14.9635532320676,8.23235337577898,-16.2763966055264,0.717153240794682,-11.6370863951905,7.61771972799669,-6.44118496525424,-5.16650539582927,3.09658124511689,-3.20947574289914,-5.88317012509715,-7.04599319104341,-1.99920283007493,0.199929195369054,5.82800570696543,7.915096802521455E-002,5.54025108364617,-8.23869093627864,6.156887122353993E-002,-6.31092170215018,0.847532457504667,0.150563931158316,-3.17714971846863,-3.50521366445503,-0.256830958199018,-0.771026199153642,-2.32668429487263,-1.13539627093444,1.85058187223634,2.74012861247254,1.71154772089459,2.88699761035875,-1.88079277042077,1.49508478076021,-2.51118092944171,0.942172559035466,-1.78832856782701,0.392909775953557,-5.515252821043887E-002,-0.223721530777893,-0.721591008767275,-6.637721807043734E-002,-0.730886037393798,0.158726020178797,-0.440021700862338,2.538544123412206E-002,1.23408070539376,0.986423403827362,0.716934484623798,-0.625950900088466,0.222747970396417,-0.321460953121375,0.309156155422827,-0.344245902949227,0.115736775875668,-0.273378028172671,-3.273369359537030E-003,0.111069764271564,-6.393636638669664E-002,-0.154502482951790,-3.288823050172902E-003,-7.263256311058182E-002,-3.044906055255370E-002,1.738216331403562E-002,0.133796400276801,0.247602636128677,0.307974534057099,0.322244952082691,-0.170882748168347,-0.143213351653152,-0.265472841852070,6.423033903871646E-002,-4.406802886393696E-003,3.547629693623617E-002,6.291064739815033E-002,6.057076451408969E-003,1.570733968127611E-00],[-35786.1256830957,-1446.53315015001,840.235255328315,-855.189048652298,2648.47075660992,2932.35496095513,-1107.66190741945,-1336.46127754050,-456.760032791674,-194.859958784510,-543.837097837336,1254.41581521587,-427.651659716479,130.182078473075,21.0772396634825,31.3528564098195,51.2210993578388,590.973820700373,262.964607146647,-356.095890159593,115.027387055324,-451.135499069257,-105.097691172584,-69.4063222424176,48.6163816136458,-3.95854598045453,5.69704524945830,170.623408644369,-51.7139681388194,-38.4168344183023,-152.456579482806,-18.7621494686394,-60.8088553358793,-1.88650255094464,-18.2328780936836,9.50351689514649,-11.6497353217185,4.89274089775393,-1.11346340652503,-13.4970436430387,8.96170775905720,-60.0390436750074,-21.1107251472494,-14.6885535952996,4.75201929642540,-13.5480436368208,10.5330915046467,-4.20818343945141,6.54820619569399,-6.06887143718042,-4.39957670932774,3.54242707848523,-3.87793906775215,-4.76077550468408,-10.7155277457978,-2.60609677589408,-1.59962772098540,4.71524509448303,3.81438637902335,7.16701930179620,-9.49631100672542,-3.94586564168682,-7.36930231793397,8.027280584874259E-002,0.216072353657714,-2.79427796221882,-3.73885819638031,0.277998060180698,0.116261494935817,-2.73374306116999,-0.938174794766378,1.00526286936231,2.79557248543910,1.16308084720020,2.90082672889228,-1.18658256992808,1.20570672171277,-3.40989350363523,0.275712597946820,-2.19300815215639,0.322364163342105,-0.179467092938776,-2.823546109821179E-002,-0.618636271413176,0.112283703385196,-0.623571327342374,1.628203291259051E-002,-8.194666271531345E-002,-5.453897444927852E-002,1.28857293024189,0.602129280876457,0.393489278202954,-0.755885998194886,0.190894760714725,-5.067422978502899E-002,0.197245590557206,-0.286849127696930,0.241539527713432,-0.541013402704515,8.805467397457006E-003,9.949138176233166E-002,-3.009076021413682E-002,-0.133603557325620,6.442103389105669E-002,-3.579137087849372E-003,3.540299489516999E-003,5.607445463123572E-002,7.613832810144294E-002,0.300002640342454,0.204138585101379,0.304585728701728,-0.261671524712176,-0.229973311244273,-0.330394526115635,3.213635438691083E-002,0.133702995165935,-3.002032464703464E-002,7.222374276790151E-002,-4.338110470715353E-003,3.422573018561578E-00],[-35137.4183275199,-1892.63885424036,975.687248655661,-978.273965181290,2693.14914653528,2901.31629017493,-1368.78323041061,-1309.02798157517,-316.224980898403,-198.085914899427,-547.050691268598,1266.75853578562,-410.126474169369,163.569384797967,8.73797257049452,75.9809074168316,136.296880478029,512.817309530709,333.578026978597,-442.517082174362,135.804237553587,-418.551976282481,-56.7297826701583,-79.5175726697967,59.4182227365605,8.53392047279699,2.56495043178553,165.391738129419,-59.0556330780521,-93.7568872044308,-130.655202951872,-16.8618274428923,-56.5750843649218,66.6020812378613,-7.82793159032408,14.2007058537185,-12.4488230519345,0.678143172142457,12.6361309313217,-17.6012670170240,1.86006723045043,-63.6196747676874,-35.7966751896970,-10.4412281057874,2.04725031289324,-10.8808667795899,22.8845562292130,8.51624231206173,5.40865178486655,-4.37219422811180,-3.22384509078495,3.93843982245627,-4.97145561492706,-2.28247405287298,-15.0333070608148,-2.89757581344054,-5.65984679925338,4.77818129254113,10.5911418532135,7.35997106641679,-10.1995026551051,-10.1550416047011,-5.28455616552705,-0.797809382362551,0.648850719246253,-2.27473190004831,-3.80592308698258,0.836236271396193,1.34729593341948,-3.26798173346190,-0.654037279617326,-0.138191939056945,2.73748598643281,0.623450913648289,2.57868387684754,0.407899798797252,0.717755141133294,-3.67824519145848,-1.17481523266968,-2.87892579224697,0.227354537480459,-0.294467054988148,0.209310763457216,-0.412984826805455,0.319678767875822,-0.529652699335919,-0.239730297199122,0.267750842650906,-9.164147684074969E-002,1.26628072518712,0.168344768056296,-5.629576458829989E-002,-0.722842470118594,0.219622540207830,0.425080422259301,-5.845675253682520E-002,-0.222516358914750,0.390493039027448,-0.939837571304762,9.528881972681244E-003,8.011179477933296E-002,7.823838531244229E-003,-9.587877600097526E-002,0.135249481506824,9.343944588570366E-002,5.429994934323931E-002,7.113922469799425E-002,1.838411063561844E-002,0.342257745127272,7.196192571008916E-002,0.272560943327713,-0.312753863112144,-0.308692063039371,-0.360390339149614,-1.379258245633265E-002,0.314511151303667,-0.134667912198067,1.993893666218045E-002,3.441216611809562E-003,5.948325890025187E-00],[-34624.5402797684,-1969.55381174640,1186.56379515871,-989.816873961853,2700.52855674107,2813.44442266339,-1462.15055021489,-1387.43893454305,-104.892712911491,-250.319820244486,-573.851110095521,1209.86656762848,-366.207761726255,171.873915956572,-57.9564279614012,139.359481617049,222.848532269162,414.193666716340,387.291729903698,-553.258474814178,188.317133806254,-365.430780571381,48.6158926596014,-86.2804718926985,75.2445538560027,32.9175270781380,-6.19400738040616,160.928528648713,-56.8979613990669,-160.481419918361,-79.3637138088507,4.31732940887455,-40.8425279881231,168.243980310685,-6.98337257135811,22.0814144729375,-12.1891340255165,-4.82236668923445,29.1268280444917,-17.9822534702704,-13.2485180375311,-64.4305999226575,-48.5546381681820,3.23231379045646,-2.73417151244849,-9.07201901406637,37.0743813592536,25.4526469931560,4.43597069465357,-1.33796272093246,-1.97751589354192,3.40499605124783,-6.02328369111606,0.849914047715205,-17.6631928353059,-4.09003894758979,-11.3034158285220,7.04438368439828,20.0853183720447,4.65282618544605,-10.0009980620425,-18.3308864948370,1.80894051447733,-1.47576713908207,1.44673587773654,-1.64662345952072,-3.46027339564002,1.15364277794713,2.56713201073687,-3.54648753737324,-0.463009945708726,-1.04019153527090,2.34346737803919,0.115125216893540,1.84642477161221,2.47971078545436,-6.905973107864424E-002,-2.69289745817012,-3.53253479145545,-3.67251132906037,0.100548739076808,-0.313598822427527,0.430940549342819,-6.659655831631020E-002,0.480223477531923,-0.399806139109606,-0.517902068252282,0.414533691940304,-1.366060382941101E-002,1.01569364775578,-0.170123379174715,-0.544491734298701,-0.536262368398513,0.308848452972822,0.805274099638792,-0.510353172456108,-0.123185511448660,0.484067357899823,-1.34462055358499,-1.241963950887607E-002,5.475493321787221E-002,3.776642928628421E-002,-2.961067342452684E-002,0.172961115377969,0.218142193203005,0.115145723685013,4.461796547843128E-002,-2.110039069335288E-002,0.306805942978549,-5.406816038433016E-002,0.187539778512288,-0.288269003020313,-0.323597439871644,-0.333301014090510,-6.809198619261805E-002,0.476087932642066,-0.243821273998287,-0.149728514729749,6.132077569812330E-002,7.860447443734962E-00],[-34377.2708485222,-1846.75531969467,1775.94462134452,-771.279281271401,2552.73460730825,2622.43460449218,-1527.09360730669,-1636.94778268326,199.826553005859,-336.932265859104,-626.304172932845,1041.81657610558,-284.586619077555,118.836611927632,-129.777720864572,208.745762915327,318.091783042787,292.540134871963,402.721193704273,-674.869086989810,261.324865218482,-300.688504609459,165.678394527580,-103.763842533233,90.7370329626111,77.2673287343202,-17.3806726523037,167.005434152829,-42.7583729278342,-227.166944016946,-5.20829224490565,32.7779826483308,-21.7230695615517,273.015614348514,-24.4662113140099,32.1208286925497,-9.22733562346330,-9.71834543434745,45.4146165110694,-9.81126738601084,-42.3125692392529,-63.0769577393394,-55.7660935309779,29.7118187369071,-15.0834297048847,-8.28920928470266,47.8721877082714,41.4886075566728,4.08188831773460,2.24313102840464,-1.07741673125788,0.554600631172714,-6.26878936783726,3.85267295107399,-15.3673243823678,-7.92630595522875,-17.1718911555521,12.8998945145472,29.4504205257329,-2.92687940725034,-7.66282690095179,-26.5062587421194,15.7615510005423,-1.32267397101784,2.25301933878957,-0.904461544414315,-2.41692318640412,0.893988898595111,3.17502948962039,-2.99205884058178,-0.548292023115144,-0.989138775933204,1.45404419183721,-0.372383342685593,0.745270611107966,3.93377461371457,-1.27351562454462,0.560878024826716,-6.49409439497648,-3.99605190858209,-0.117373195567441,-0.107116279556730,0.519528152092215,0.342614520533545,0.508229157148873,-0.110474851315651,-0.553235160673115,6.296006868209930E-002,0.198253091507905,0.357938893166867,-0.165330280172008,-0.746307396059310,-0.260173937179684,0.415035449193820,0.473816575860677,-1.15628958853874,4.991463175903731E-002,0.353455388299022,-1.41765215976434,-7.564846171789127E-002,1.808093286586140E-002,3.309034492488262E-002,5.491133126539268E-002,0.132235952200474,0.316813622707594,0.187777074413839,-2.232121426544667E-002,-1.763185776746184E-002,9.818590126297623E-002,-0.111978541506949,2.405210000538382E-002,-0.137485924607669,-0.158182503697806,-0.211962586935822,-0.124714060536827,0.470330672556005,-0.277524651136484,-0.484336815562222,0.218297186050444,6.735409131791870E-00],[-34283.2978785671,-2841.27059002292,2809.32194503388,-298.595491157409,2050.43075226236,2045.40958137311,-1892.42789802409,-1882.08764615107,582.621883857371,-425.492154211270,-683.520185181734,744.113572043954,-192.130287513187,-52.9895893261711,-82.7086731859044,275.015554711056,440.300764414794,166.595085270507,368.146834189835,-784.574499997539,288.616083725791,-262.854988335216,174.488450276985,-159.295833604378,100.802559825354,151.273207138909,-26.1676994899084,211.142103319173,-31.9474870351407,-261.923209856749,51.3352892058801,39.6163834574561,-21.8027012494083,312.281401252221,-70.0672139950157,40.5481444351807,0.544813323145050,-11.1017513829881,55.7539844430208,9.99008632212336,-88.3618794506031,-67.9104820132027,-49.2906590436978,65.1036273808921,-39.5870680752278,-6.85719856115737,42.8403280860935,47.0642043928343,4.74331252053450,4.45090831165961,-1.22989328092203,-6.07970163737728,-4.42996175487280,5.43450310663733,-4.49772750715352,-16.5755942035175,-21.2955925634939,24.8081934663159,31.4182545752255,-16.9868506618134,-0.537150239181488,-29.1840792559877,36.9735243551472,0.487395464282506,2.24075350263618,-6.820854360903450E-002,-0.329636121160623,-0.217683595118936,2.30230080047209,-0.936060069200150,-0.983308723408553,0.825315285114545,0.519956574652717,-0.812076716450993,-0.176947319215530,2.83924284807830,-2.73840549182183,7.44875125196744,-8.72549181498042,-2.67723155564923,-0.594902745156790,0.488951099000051,0.256455395500571,0.581733974179872,0.307621495733362,0.627485145723832,0.210635432839592,-1.15796501500769,0.452202366102399,-0.707859774444025,0.554401273520032,0.134503070330669,-3.102160359248617E-003,0.456021503415088,-1.49317993891063,-1.82543999061694,0.355992824483535,-0.281802531623866,-0.490249193163342,-0.211421167727172,-5.972075079389667E-002,-5.068660096630461E-002,0.109571212907039,-4.453902138578064E-002,0.279995972323468,0.293279365753424,-8.234284951886645E-002,7.477329478621039E-002,-0.376061459213327,5.905317228639399E-003,-0.167868447723824,0.181825535407386,0.373634720384629,6.583560677885666E-002,-0.151076304841877,4.527329965292969E-002,-7.065222246804631E-002,-0.958225327474987,0.532065921918226,-1.183463982401857E-00],[-34474.9466672487,-3574.34887434699,3610.95051912052,319.371638835838,2279.43730713933,1446.20893442610,-1946.03918382851,-932.557554415560,708.460216710044,-234.181983944275,-663.778347888649,869.458763596043,56.7479327060841,-260.230718353755,368.731834885058,311.025002595016,585.228489605451,153.562797131569,372.146731690785,-808.221216212498,207.531733709832,-275.524883638159,-77.7529397301003,-221.633006508107,94.0214288966416,242.123236819314,-41.9161093370673,351.570516567539,-48.4082187546632,-196.903098247313,32.2519272274124,-12.8605583630039,-48.7242518172589,191.119474486278,-132.572621440990,41.0318698363627,14.0391846911837,-3.84917069374720,45.7288628225381,36.0381447893052,-141.318213878047,-91.1032509980224,-17.8500995135098,98.0467344685227,-70.5571974901838,7.41032843988161,7.22018326980389,32.8181380887869,8.45368484600714,0.989889257895794,-4.72515185284772,-18.0705751392881,1.32442909338429,3.40846690344174,17.7666106765237,-31.6719919836153,-19.8283667361380,44.0914333078821,16.9382030900190,-35.4328787488604,15.4637677078159,-15.2477037183434,59.9442840352878,4.72676571629467,0.245186013210339,0.495809918627341,2.17002281959792,-2.65331824558270,-1.22407813297270,2.76292598060058,-1.50394935629036,5.11983174351787,0.630206275246511,0.114127286368607,4.109218927037933E-002,-2.36952358374723,-3.37842615754945,18.2215581277799,-7.15585395539036,0.936210709040439,-1.50449484584583,1.71373514477495,-0.670674044847272,0.186678111002261,-0.284322215096228,2.01845364919532,2.59048549729321,-3.60174617015853,0.341847968674209,-1.68546236145106,2.56748977398743,3.24123445146751,0.317632520685662,0.406328407038669,-5.78615715170067,-2.12618356346115,0.703339216376788,-1.67334810534184,2.29390898600496,-0.471365905728567,-0.199384293687867,-0.263375493839294,2.070766448761175E-002,-0.426526397174596,-8.489047187747785E-002,0.410611819899377,-2.962000172102615E-002,0.315802958830135,-1.15235614118937,0.436423430014970,-0.175886745857477,0.686016076547450,1.45557437231669,0.580060774679158,-6.399495205642414E-002,-1.02651428051260,0.582737467348609,-1.38256156874621,1.01811149920712,-0.20375751866368],[-34333.7414127882,-3171.89829988705,4670.84185297709,617.059818900313,2340.98476322861,939.369036532392,-1380.98597645716,215.465164987311,826.206450949840,-304.550905559142,-884.104358755589,1143.00767967951,165.016726579023,-314.086472747970,981.116899475500,378.792848655751,616.402277111623,-20.3311957498792,304.575781277852,-718.823121159433,58.8228205858500,-284.569301710955,-164.359869496062,-177.873946379341,26.4761744989203,340.872505754431,-114.632051357790,445.682426141185,-48.2189771856772,-91.8459504122837,-18.8645107883473,-59.1576089947024,-38.8960683056112,81.8888948477938,-101.446558204589,55.9532614351425,25.6834904889629,27.4012273089055,19.1772188922964,51.1921894715020,-182.010515493090,-85.5217584445339,-2.97355343200780,84.7959694952483,-46.6896655322006,50.5258629667784,6.52954254560681,27.3259283681614,27.8887223305736,-6.58976922349087,-8.63653076261780,-29.4709537530221,10.5763390275762,4.94515770099722,45.3277540208878,-49.6831610141421,-12.4890519997357,45.1083946269560,-6.55394560228437,-28.4244712478923,27.4812164463889,23.8626557758465,48.5167003515921,11.5066779675236,-3.15116681721980,-0.384251285503446,4.79202585975346,-7.97183798477692,-7.76074850297809,8.71249210845626,-0.478176564092096,7.76704272842566,-0.886681912726960,7.26712041298391,-2.12399115767230,-4.13814155553183,2.05289678831546,18.9148528526692,0.767765213349002,-4.82693270565343,-2.81556333740090,3.50241329955390,-2.45532742835989,-0.985245764050928,-2.22141670578778,3.76770654384338,6.75624557206662,-6.38100913520710,-1.04515948670742,-1.77366616197673,6.33414519946941,6.46646184022720,2.25946186525930,1.77524863151257,-9.11129190859874,-1.90607924870115,-0.956551229109321,-3.29600632006427,5.48203889774413,-0.976300796092166,-0.363570742386837,-0.417104401648176,-0.451966415529125,-0.987914734292934,-1.27675090030219,4.780987873766178E-002,0.469093674925497,0.504164747235737,-2.15451994486417,1.22804521345003,0.299227265191298,1.45684085005973,2.99151128423156,1.25154165487186,0.439287626027841,-1.88660418554744,1.26930106595268,-1.50675851516380,1.42943123731249,-0.33061699866544],[-33413.1418355241,-3203.84875852587,5567.39859479475,220.491560718937,2506.19971804215,637.129049328106,-679.754888317441,1012.18247257507,966.300495960936,-841.976981275583,-741.983307946217,1253.42642119890,265.601052034653,-68.8896455180985,983.958910264047,556.029890546555,594.675277728014,-18.4341435856273,261.564786554945,-499.090397061093,-20.3600863585035,-256.250226334980,-143.305553210508,-212.988269635287,-30.6157947060623,376.636835964409,-230.454567147409,477.052258202621,-23.7374107634280,-58.1918020425414,-21.8099853247709,-61.2765279912515,-75.7207871533484,77.4333918370458,2.68937575547107,71.7838240765367,44.7229504950757,37.4988819211118,-39.3023832545349,71.5229726473378,-155.697067565860,-44.3728215562979,-11.2429488183780,17.8162468633022,1.87847968206769,64.6565240902444,-1.45512450076015,34.2932863541827,56.8785768504164,-12.1546504822446,-7.87767913516718,-33.2850906933470,17.3944504305679,7.81031735465174,69.0817049477388,-56.1893849765744,-19.1851435875556,11.8775570734933,-19.2525860007886,-4.28741280392448,10.8234281734044,32.5506201734344,1.11297770926670,17.0550509462939,-4.39267350775580,-2.16744471752931,6.06013542694372,-14.9763229683374,-15.7178361545073,17.5034953839506,-2.23870409172792,3.76426879802257,-1.60235058859974,16.4857610326380,-5.90333955453369,-3.38208599320371,10.3898778306302,2.22110309521980,-7.30847517185618,-9.23847511766488,-4.07263767131729,4.99946855709084,-4.17885187521028,-2.32707635679207,-4.28251149915639,5.20301764845163,10.1638050157680,-6.81003615045472,-2.69593879840001,-0.949011082659509,11.6644959075239,7.12938653141505,6.46816679933794,3.74314626793235,-9.37611788001635,-1.40219663873746,-4.23587407952113,-6.55081320298259,8.75641750757991,-1.76862995030235,-0.607591228049256,-3.548673017286826E-002,-1.12797165375703,-1.12743801019077,-3.07681211111604,-0.753668580365237,1.92957857573667,-0.166152298366998,-2.10579137698087,2.78247545431722,1.22224326149483,2.33894808864450,4.37247721583150,1.42119900769497,0.703966471458044,-2.18380400808763,1.70476759407663,-0.100926631021946,1.52417571494142,1.1357323418719],[-32373.4742160292,-2727.52105422676,5868.30162778061,-24.2906051832169,2836.18832169532,-221.391979177043,100.748338570532,1454.32816881874,1041.26820542966,-1189.07403784586,-408.840783748186,1405.23831510928,122.637934620990,290.446099676751,837.871603285875,732.680019941689,601.157389202965,160.606208101755,409.787593881883,-294.379952963043,-197.716961752616,-217.544193736526,4.05007848666867,-139.104533898000,-83.4426219752141,374.149497205700,-283.792046492018,439.223301585363,-12.4735602288713,-28.3958417000281,-6.49118829746168,-49.1773645926682,-109.501419423746,118.707631164933,59.0374949715580,38.7978090430867,68.6670306215826,21.8464487813438,-81.4806390242578,86.6358315577520,-132.841092751400,-17.9164562290150,-41.4626617138569,-63.1914731952618,25.6119010831789,68.0627764594682,-18.0163303730571,-4.08099465563411,68.4732004455671,-27.5282735821682,-16.3893445348397,-27.5012593398106,8.91176950454478,22.3366938633920,61.6629854690359,-44.1675877244339,-38.5129473607560,-30.9892380776493,-10.2553158953317,-6.41010569731291,-4.95676272124079,23.7846973048484,-30.3580716960319,16.6815408838232,-0.154744826419023,0.483810887644550,-1.42030397949307,-20.2306964635041,-20.4971914904158,19.3083694065359,-1.52405321512225,-1.72452123154371,-0.286239312460235,18.7720153078099,-12.0879968894143,-1.69628367331084,4.92854944697702,-10.6863565332971,-13.5610420429618,2.44783661673735,-2.59362385559946,7.03556660264109,-4.36424876029550,-1.95177757031235,-1.40210757310847,2.14808582340440,7.75644652816221,-2.91577718351722,-2.40007253613798,2.19795390192706,15.1495208168157,3.88454872243063,8.26983705552522,0.205119954071517,-4.75445561600013,-4.02522416429871,-6.52937697481862,-5.44390576104802,12.9740339668122,-2.65266638126882,3.771998608847923E-002,0.876101638447704,-1.19273032100238,0.464427576175427,-3.18939668689707,-0.853085869422312,2.80833006595548,-1.45734815574160,0.486760151911113,3.63862069346922,2.36366960140597,2.07957464844151,3.60502622988239,-2.041522945561756E-002,0.100747384454651,-0.967807478689158,1.51662122344156,1.66819819107191,2.44076690491765,3.4066118633264],[-31468.8481048051,-2342.09513757676,5905.08852337573,-665.875329631986,2948.21664084033,-946.578730152525,1006.57901118176,1172.18208519428,1057.95336145803,-1458.50761024025,-390.301023804596,1271.98511855796,55.8189567168541,641.703453948178,508.763235953065,864.745902093785,637.624000649126,263.179690702013,626.248691508538,-111.406242072845,-374.878312044847,-189.808664688908,143.599656335553,-41.4185872309843,-178.835814166010,342.601662210499,-256.386031947768,273.462209398759,30.4207619960023,-4.75653982168312,2.67821686847760,-71.3924992384347,-125.928525921572,37.9592957270814,18.7951721385218,48.6415747755528,55.0179727986810,28.6029721357271,-30.2076457498749,81.6785941249286,-208.369913847264,-38.5962170973052,-75.0436501242413,-46.1738692050215,60.9663568060651,48.4966828498612,-49.0769138974640,-77.6432349761384,69.2504585353517,-47.9976573334387,-46.5569418069681,-4.40046031991558,-0.730110526695628,42.7999918383092,13.1365142579097,-37.1045497819415,-32.7904598758775,-40.3902071735732,13.1575673794521,12.6518510977495,-3.36124244548644,28.5537284078446,-38.2396535088151,11.0302276331729,4.88667069655710,1.31548217585371,-9.62452151268829,-21.2076412640141,-13.3528849934177,12.0519951353295,4.69697902213413,-0.613900386594287,3.96340012776815,8.43575404085007,-19.6227835043614,4.78069661885440,-1.77907664213905,-4.16206183700575,4.33149766367707,0.165476864356321,4.03830459545461,8.31548845419963,-7.79269896975572,0.477866865277217,6.20886982776883,-5.77549397676709,1.08490495646011,3.15202779910593,7.059997705736892E-002,5.66193414938472,12.5385827615700,-1.08402349215136,6.29070054563304,-7.52437370006363,3.19631438467200,-7.84949449066705,-5.19646129654952,2.19251433755636,10.9698021101449,-3.09779364431753,0.847531350417883,1.73694047654859,-0.835167574104782,2.70086072787079,-1.24901928096668,8.536743856295878E-002,0.963380008648994,-1.48438459154057,3.96213109686966,2.05370602665050,3.14594681493623,1.01226491202871,-0.569870722487924,-1.89138244671831,-0.543983221450708,1.72711145519152,1.06804878218439,1.65721327715106,3.98676834320476,2.4716862208762],[-30563.1490447679,-2233.70221447267,5812.32852325386,-1318.42149794166,2992.82946432648,-1795.23672230742,1575.68380152529,380.525313516860,1286.23921427702,-1893.53086764078,-496.814217559685,1269.62771107831,214.344695385701,891.624375057949,-51.7635173380212,959.408453312797,799.836742693283,165.195395637718,533.497696838277,-285.485303771767,-402.875413460884,-29.9339721383170,302.779807832157,-199.553692589859,-243.961365398607,351.865914494944,-14.9943170092160,204.195405378956,96.6033155549303,-21.6560584331662,-89.4549053668676,-154.544316824184,-120.418596257734,-71.9481452726193,75.3783817244453,54.1103491103710,51.8954282598575,-0.235187316369696,-2.31544280730500,106.678879365353,-256.384263825666,41.2916098827725,-8.80033687882412,-15.9095686224989,8.72610572479601,-13.8028776876841,-109.975726860442,-24.4948448634513,73.9796621282415,-52.1710362359246,-46.1347430677262,5.25171728333462,-21.6929564271309,20.1848215936393,-11.1603421086658,-30.1254169426726,1.20578655723523,-10.2983234048978,30.0239842258729,18.1740047218548,-19.2084815538664,17.3970051587954,-23.3567951997896,7.43418023823724,5.24315474242703,7.22511190520463,-6.25039779403281,-14.7156045381668,-12.3359127897018,6.03505033045467,3.41101128817494,-11.1650224659379,8.85661639769500,2.43961508045928,-8.77237659058828,18.3416188346559,10.8999315408377,-0.639668187795622,9.07905632856005,-16.3085578523611,9.97161396508953,7.27462647169519,-20.2429573910823,2.77605250980118,13.3401673899902,-10.8642416183503,2.43703148099747,8.49066103287015,-0.269694728183669,5.85478824686328,0.412398615919125,-0.814567150384708,8.36224788430024,-2.97341017571209,10.7705979530851,-1.25656626291621,-1.82880887478659,0.734091618960210,2.45142835593218,-2.01280401696136,-0.959121816754339,1.27105138594817,0.743025000550792,2.53115523902227,-2.11934524990497,0.719578994851234,-1.57489096385070,2.53271015690435,5.56739920219065,-1.49274560366273,3.94792101314126,0.633757890440319,-0.940696961401029,-2.05398043926704,-0.428807374915832,3.52577090203205,1.76183777779838,1.25182375192018,2.07267420976024,-2.2701518050416]])
    return models,coeffs


def unpack(gh):
    """
    unpacks gh list into l m g h type list
    """
    data=[]
    k,l=0,1
    while k+1<len(gh):
        for m in range(l+1):
            if m==0:
                data.append([l,m,gh[k],0])
                k+=1
            else:
                data.append([l,m,gh[k],gh[k+1]])
                k+=2
    return data


def magsyn(gh,sv,b,date,itype,alt,colat,elong):
    """
# Computes x, y, z, and f for a given date and position, from the
# spherical harmonic coeifficients of the International Geomagnetic
# Reference Field (IGRF).
# From Malin and Barraclough (1981), Computers and Geosciences, V.7, 401-405.
#
# Input:
#       date  = Required date in years and decimals of a year (A.D.)
#       itype = 1, if geodetic coordinates are used, 2 if geocentric
#       alt   = height above mean sea level in km (if itype = 1)
#       alt   = radial distance from the center of the earth (itype = 2)
#       colat = colatitude in degrees (0 to 180)
#       elong = east longitude in degrees (0 to 360)
#               gh        = main field values for date (calc. in igrf subroutine)
#               sv        = secular variation coefficients (calc. in igrf subroutine)
#               begin = date of dgrf (or igrf) field prior to required date
#
# Output:
#       x     - north component of the magnetic force in nT
#       y     - east component of the magnetic force in nT
#       z     - downward component of the magnetic force in nT
#       f     - total magnetic force in nT
#
#       NB: the coordinate system for x,y, and z is the same as that specified
#       by itype.
#
# Modified 4/9/97 to use DGRFs from 1945 to 1990 IGRF
# Modified 10/13/06 to use  1995 DGRF, 2005 IGRF and sv coefficient
# for extrapolation beyond 2005. Coefficients from Barton et al. PEPI, 97: 23-26
# (1996), via web site for NOAA, World Data Center A. Modified to use
#degree and
# order 10 as per notes in Malin and Barraclough (1981).
# coefficients for DGRF 1995 and IGRF 2005 are from http://nssdcftp.gsfc.nasa.gov/models/geomagnetic/igrf/fortran_code/
# igrf subroutine calculates
# the proper main field and secular variation coefficients (interpolated between
# dgrf values or extrapolated from 1995 sv values as appropriate).
    """
#
#       real gh(120),sv(120),p(66),q(66),cl(10),sl(10)
#               real begin,dateq
    p=numpy.zeros((66),'f')
    q=numpy.zeros((66),'f')
    cl=numpy.zeros((10),'f')
    sl=numpy.zeros((10),'f')
    begin=b
    t = date - begin
    r = alt
    one = colat*0.0174532925
    ct = numpy.cos(one)
    st = numpy.sin(one)
    one = elong*0.0174532925
    cl[0] = numpy.cos(one)
    sl[0] = numpy.sin(one)
    x,y,z = 0.0,0.0,0.0
    cd,sd = 1.0,0.0
    l,ll,m,n = 1,0,1,0
    if itype!=2:
#
# if required, convert from geodectic to geocentric
        a2 = 40680925.0
        b2 = 40408585.0
        one = a2 * st * st
        two = b2 * ct * ct
        three = one + two
        rho = numpy.sqrt(three)
        r = numpy.sqrt(alt*(alt+2.0*rho) + (a2*one+b2*two)/three)
        cd = (alt + rho) /r
        sd = (a2 - b2) /rho * ct * st /r
        one = ct
        ct = ct*cd - st*sd
        st  = st*cd + one*sd
    ratio = 6371.2 /r
    rr = ratio * ratio
#
# compute Schmidt quasi-normal coefficients p and x(=q)
    p[0] = 1.0
    p[2] = st
    q[0] = 0.0
    q[2] = ct
    for k in range(1,66):
        if n < m:   # else go to 2
            m = 0
            n = n + 1
            rr = rr * ratio
            fn = n
            gn = n - 1
# 2
        fm = m
        if k != 2: # else go to 4
            if m == n:   # else go to 3
                one = numpy.sqrt(1.0 - 0.5/fm)
                j = k - n - 1
                p[k] = one * st * p[j]
                q[k] = one * (st*q[j] + ct*p[j])
                cl[m-1] = cl[m-2]*cl[0] - sl[m-2]*sl[0]
                sl[m-1] = sl[m-2]*cl[0] + cl[m-2]*sl[0]
            else:
# 3
                gm = m * m
                one = numpy.sqrt(fn*fn - gm)
                two = numpy.sqrt(gn*gn - gm) /one
                three = (fn + gn) /one
                i = k - n
                j = i - n + 1
                p[k] = three*ct*p[i] - two*p[j]
                q[k] = three*(ct*q[i] - st*p[i]) - two*q[j]
#
# synthesize x, y, and z in geocentric coordinates.
# 4
        one = (gh[l-1] + sv[ll+l-1]*t)*rr
        if m != 0: # else go to 7
            two = (gh[l] + sv[ll+l]*t)*rr
            three = one*cl[m-1] + two*sl[m-1]
            x = x + three*q[k]
            z = z - (fn + 1.0)*three*p[k]
            if st != 0.0: # else go to 5
                y = y + (one*sl[m-1] - two*cl[m-1])*fm*p[k]/st
            else:
# 5
                y = y + (one*sl[m-1] - two*cl[m-1])*q[k]*ct
            l = l + 2
        else:
# 7
            x = x + one*q[k]
            z = z - (fn + 1.0)*one*p[k]
            l = l + 1
        m = m + 1
#
# convert to coordinate system specified by itype
    one = x
    x = x*cd + z*sd
    z = z*cd - one*sd
    f = numpy.sqrt(x*x + y*y + z*z)
#
    return x,y,z,f
#
#
def measurements_methods(meas_data,noave):
    """
    get list of unique specs
    """
#
    version_num=get_version()
    sids=get_specs(meas_data)
# list  of measurement records for this specimen
#
# step through spec by spec
#
    SpecTmps,SpecOuts=[],[]
    for spec in sids:
        TRM,IRM3D,ATRM,CR=0,0,0,0
        expcodes=""
# first collect all data for this specimen and do lab treatments
        SpecRecs=get_dictitem(meas_data,'er_specimen_name',spec,'T') # list  of measurement records for this specimen
        for rec in SpecRecs:
            if 'measurement_flag' not in rec.keys():rec['measurement_flag']='g'
            tmpmeths=rec['magic_method_codes'].split(":")
            meths=[]
            if "LP-TRM" in tmpmeths:TRM=1 # catch these suckers here!
            if "LP-IRM-3D" in tmpmeths:
                IRM3D=1 # catch these suckers here!
            elif "LP-AN-TRM" in tmpmeths:
                ATRM=1 # catch these suckers here!
            elif "LP-CR-TRM" in tmpmeths:
                CR=1 # catch these suckers here!
#
# otherwise write over existing method codes
#
# find NRM data (LT-NO)
#
            elif float(rec["measurement_temp"])>=273. and float(rec["measurement_temp"]) < 323.:
# between 0 and 50C is room T measurement
                if ("measurement_dc_field" not in rec.keys() or float(rec["measurement_dc_field"])==0 or rec["measurement_dc_field"]=="") and ("measurement_ac_field" not in rec.keys() or float(rec["measurement_ac_field"])==0 or rec["measurement_ac_field"]==""):
# measurement done in zero field!
                    if  "treatment_temp" not in rec.keys() or rec["treatment_temp"].strip()=="" or (float(rec["treatment_temp"])>=273. and float(rec["treatment_temp"]) < 298.):
# between 0 and 50C is room T treatment
                        if "treatment_ac_field" not in rec.keys() or rec["treatment_ac_field"] =="" or float(rec["treatment_ac_field"])==0:
# no AF
                            if "treatment_dc_field" not in rec.keys() or rec["treatment_dc_field"]=="" or float(rec["treatment_dc_field"])==0:# no IRM!
                                if "LT-NO" not in meths:meths.append("LT-NO")
                            elif "LT-IRM" not in meths:
                                meths.append("LT-IRM") # it's an IRM
#
# find AF/infield/zerofield
#
                        elif "treatment_dc_field" not in rec.keys() or rec["treatment_dc_field"]=="" or float(rec["treatment_dc_field"])==0: # no ARM
                            if "LT-AF-Z" not in meths:meths.append("LT-AF-Z")
                        else: # yes ARM
                            if "LT-AF-I" not in meths: meths.append("LT-AF-I")
#
# find Thermal/infield/zerofield
#
                    elif float(rec["treatment_temp"])>=323:  # treatment done at  high T
                        if TRM==1:
                            if "LT-T-I" not in meths: meths.append("LT-T-I") # TRM - even if zero applied field!
                        elif "treatment_dc_field" not in rec.keys() or rec["treatment_dc_field"]=="" or float(rec["treatment_dc_field"])==0.: # no TRM
                            if  "LT-T-Z" not in meths: meths.append("LT-T-Z") # don't overwrite if part of a TRM experiment!
                        else: # yes TRM
                            if "LT-T-I" not in meths: meths.append("LT-T-I")
#
# find low-T infield,zero field
#
                    else:  # treatment done at low T
                        if "treatment_dc_field" not in rec.keys() or rec["treatment_dc_field"]=="" or float(rec["treatment_dc_field"])==0: # no field
                            if "LT-LT-Z" not in meths:meths.append("LT-LT-Z")
                        else: # yes field
                            if "LT-LT-I" not in meths:meths.append("LT-LT-I")
                if "measurement_chi_volume" in rec.keys() or "measurement_chi_mass" in rec.keys():
                    if  "LP-X" not in meths:meths.append("LP-X")
                elif "measurement_lab_dc_field" in rec.keys() and rec["measurement_lab_dc_field"]!=0: # measurement in presence of dc field and not susceptibility; hysteresis!
                    if  "LP-HYS" not in meths:
                        hysq=raw_input("Is this a hysteresis experiment? [1]/0")
                        if hysq=="" or hysq=="1":
                            meths.append("LP-HYS")
                        else:
                            metha=raw_input("Enter the lab protocol code that best describes this experiment ")
                            meths.append(metha)
                methcode=""
                for meth in meths:
                    methcode=methcode+meth.strip()+":"
                rec["magic_method_codes"]=methcode[:-1] # assign them back
#
# done with first pass, collect and assign provisional method codes
            if "measurement_description" not in rec.keys():rec["measurement_description"]=""
            rec["er_citation_names"]="This study"
            SpecTmps.append(rec)
# ready for second pass through, step through specimens, check whether ptrm, ptrm tail checks, or AARM, etc.
#
    for spec in sids:
        MD,pTRM,IZ,ZI=0,0,0,0 # these are flags for the lab protocol codes
        expcodes=""
        NewSpecs,SpecMeths=[],[]
        experiment_name,measnum="",1
        if IRM3D==1:experiment_name="LP-IRM-3D"
        if ATRM==1: experiment_name="LP-AN-TRM"
        if CR==1: experiment_name="LP-CR"
        NewSpecs=get_dictitem(SpecTmps,'er_specimen_name',spec,'T')
#
# first look for replicate measurements
#
        Ninit=len(NewSpecs)
        if noave!=1:
            vdata,treatkeys=vspec_magic(NewSpecs) # averages replicate measurements, returns treatment keys that are being used
            if len(vdata)!=len(NewSpecs):
                #print spec,'started with ',Ninit,' ending with ',len(vdata)
                NewSpecs=vdata
                #print "Averaged replicate measurements"
#
# now look through this specimen's records - try to figure out what experiment it is
#
        if len(NewSpecs)>1: # more than one meas for this spec - part of an unknown experiment
            SpecMeths=get_list(NewSpecs,'magic_method_codes').split(":")
            if "LT-T-I" in  SpecMeths and experiment_name=="": # TRM steps, could be TRM acquisition, Shaw or a Thellier experiment or TDS experiment
    #
    # collect all the infield steps and look for changes in dc field vector
    #
                Steps,TI=[],1
                for rec in  NewSpecs:
                    methods=get_list(NewSpecs,'magic_method_codes').split(":")
                    if "LT-T-I" in methods:Steps.append(rec)  # get all infield steps together
                rec_bak=Steps[0]
                if "treatment_dc_field_phi" in rec_bak.keys() and "treatment_dc_field_theta" in rec_bak.keys():
                    if rec_bak["treatment_dc_field_phi"] !="" and rec_bak["treatment_dc_field_theta"]!="":   # at least there is field orientation info
                        phi0,theta0=rec_bak["treatment_dc_field_phi"],rec_bak["treatment_dc_field_theta"]
                        for k in range(1,len(Steps)):
                            rec=Steps[k]
                            phi,theta=rec["treatment_dc_field_phi"],rec["treatment_dc_field_theta"]
                            if phi!=phi0 or theta!=theta0: ANIS=1   # if direction changes, is some sort of anisotropy experiment
                if "LT-AF-I" in SpecMeths and "LT-AF-Z" in SpecMeths: # must be Shaw :(
                    experiment_name="LP-PI-TRM:LP-PI-ALT-AFARM"
                elif TRM==1:
                    experiment_name="LP-TRM"
            else: TI= 0 # no infield steps at all
            if "LT-T-Z" in  SpecMeths and experiment_name=="": # thermal demag steps
                if TI==0:
                    experiment_name="LP-DIR-T" # just ordinary thermal demag
                elif TRM!=1: # heart pounding - could be some  kind of TRM normalized paleointensity or LP-TRM-TD experiment
                    Temps=[]
                    for step in Steps: # check through the infield steps - if all at same temperature, then must be a demag of a total TRM with checks
                        if step['treatment_temp'] not in Temps:Temps.append(step['treatment_temp'])
                    if len(Temps)>1:
                        experiment_name="LP-PI-TRM" # paleointensity normalized by TRM
                    else:
                        experiment_name="LP-TRM-TD" # thermal demag of a lab TRM (could be part of a LP-PI-TDS experiment)
                TZ=1
            else: TZ= 0 # no zero field steps at all
            if "LT-AF-I" in  SpecMeths: # ARM steps
                Steps=[]
                for rec in  NewSpecs:
                    tmp=rec["magic_method_codes"].split(":")
                    methods=[]
                    for meth in tmp:
                        methods.append(meth.strip())
                    if "LT-AF-I" in methods:Steps.append(rec)  # get all infield steps together
                rec_bak=Steps[0]
                if "treatment_dc_field_phi" in rec_bak.keys() and "treatment_dc_field_theta" in rec_bak.keys():
                    if rec_bak["treatment_dc_field_phi"] !="" and rec_bak["treatment_dc_field_theta"]!="":   # at least there is field orientation info
                        phi0,theta0=rec_bak["treatment_dc_field_phi"],rec_bak["treatment_dc_field_theta"]
                        ANIS=0
                        for k in range(1,len(Steps)):
                            rec=Steps[k]
                            phi,theta=rec["treatment_dc_field_phi"],rec["treatment_dc_field_theta"]
                            if phi!=phi0 or theta!=theta0: ANIS=1   # if direction changes, is some sort of anisotropy experiment
                        if ANIS==1:
                            experiment_name="LP-AN-ARM"
                if experiment_name=="":  # not anisotropy of ARM - acquisition?
                        field0=rec_bak["treatment_dc_field"]
                        ARM=0
                        for k in range(1,len(Steps)):
                            rec=Steps[k]
                            field=rec["treatment_dc_field"]
                            if field!=field0: ARM=1
                        if ARM==1:
                            experiment_name="LP-ARM"
                AFI=1
            else: AFI= 0 # no ARM steps at all
            if "LT-AF-Z" in  SpecMeths and experiment_name=="": # AF demag steps
                if AFI==0:
                    experiment_name="LP-DIR-AF" # just ordinary AF demag
                else: # heart pounding - a pseudothellier?
                    experiment_name="LP-PI-ARM"
                AFZ=1
            else: AFZ= 0 # no AF demag at all
            if "LT-IRM" in SpecMeths: # IRM
                Steps=[]
                for rec in  NewSpecs:
                    tmp=rec["magic_method_codes"].split(":")
                    methods=[]
                    for meth in tmp:
                        methods.append(meth.strip())
                    if "LT-IRM" in methods:Steps.append(rec)  # get all infield steps together
                rec_bak=Steps[0]
                if "treatment_dc_field_phi" in rec_bak.keys() and "treatment_dc_field_theta" in rec_bak.keys():
                    if rec_bak["treatment_dc_field_phi"] !="" and rec_bak["treatment_dc_field_theta"]!="":   # at least there is field orientation info
                        phi0,theta0=rec_bak["treatment_dc_field_phi"],rec_bak["treatment_dc_field_theta"]
                        ANIS=0
                        for k in range(1,len(Steps)):
                            rec=Steps[k]
                            phi,theta=rec["treatment_dc_field_phi"],rec["treatment_dc_field_theta"]
                            if phi!=phi0 or theta!=theta0: ANIS=1   # if direction changes, is some sort of anisotropy experiment
                        if ANIS==1:experiment_name="LP-AN-IRM"
                if experiment_name=="":  # not anisotropy of IRM - acquisition?
                    field0=rec_bak["treatment_dc_field"]
                    IRM=0
                    for k in range(1,len(Steps)):
                        rec=Steps[k]
                        field=rec["treatment_dc_field"]
                        if field!=field0: IRM=1
                    if IRM==1:experiment_name="LP-IRM"
                IRM=1
            else: IRM=0 # no IRM at all
            if "LP-X" in SpecMeths: # susceptibility run
                Steps=get_dictitem(NewSpecs,'magic_method_codes','LT-X','has')
                if len(Steps)>0:
                    rec_bak=Steps[0]
                    if "treatment_dc_field_phi" in rec_bak.keys() and "treatment_dc_field_theta" in rec_bak.keys():
                        if rec_bak["treatment_dc_field_phi"] !="" and rec_bak["treatment_dc_field_theta"]!="":   # at least there is field orientation info
                            phi0,theta0=rec_bak["treatment_dc_field_phi"],rec_bak["treatment_dc_field_theta"]
                            ANIS=0
                            for k in range(1,len(Steps)):
                                rec=Steps[k]
                                phi,theta=rec["treatment_dc_field_phi"],rec["treatment_dc_field_theta"]
                                if phi!=phi0 or theta!=theta0: ANIS=1   # if direction changes, is some sort of anisotropy experiment
                            if ANIS==1:experiment_name="LP-AN-MS"
            else: CHI=0 # no susceptibility at all
    #
    # now need to deal with special thellier experiment problems - first clear up pTRM checks and  tail checks
    #
            if experiment_name=="LP-PI-TRM": # is some sort of thellier experiment
                rec_bak=NewSpecs[0]
                tmp=rec_bak["magic_method_codes"].split(":")
                methbak=[]
                for meth in tmp:
                    methbak.append(meth.strip()) # previous steps method codes
                for k in range(1,len(NewSpecs)):
                    rec=NewSpecs[k]
                    tmp=rec["magic_method_codes"].split(":")
                    meths=[]
                    for meth in tmp:
                        meths.append(meth.strip()) # get this guys method codes
    #
    # check if this is a pTRM check
    #
                    if float(rec["treatment_temp"])<float(rec_bak["treatment_temp"]): # went backward
                        if "LT-T-I" in meths and "LT-T-Z" in methbak:  #must be a pTRM check after first z
    #
    # replace LT-T-I method code with LT-PTRM-I
    #
                            methcodes=""
                            for meth in meths:
                                if meth!="LT-T-I":methcode=methcode+meth.strip()+":"
                            methcodes=methcodes+"LT-PTRM-I"
                            meths=methcodes.split(":")
                            pTRM=1
                        elif "LT-T-Z" in meths and "LT-T-I" in methbak:  # must be pTRM check after first I
    #
    # replace LT-T-Z method code with LT-PTRM-Z
    #
                            methcodes=""
                            for meth in meths:
                                if meth!="LT-T-Z":methcode=methcode+meth+":"
                            methcodes=methcodes+"LT-PTRM-Z"
                            meths=methcodes.split(":")
                            pTRM=1
                    methcodes=""
                    for meth in meths:
                        methcodes=methcodes+meth.strip()+":"
                    rec["magic_method_codes"]=methcodes[:-1]  #  attach new method code
                    rec_bak=rec # next previous record
                    tmp=rec_bak["magic_method_codes"].split(":")
                    methbak=[]
                    for meth in tmp:
                        methbak.append(meth.strip()) # previous steps method codes
    #
    # done with assigning pTRM checks.  data should be "fixed" in NewSpecs
    #
    # now let's find out which steps are infield zerofield (IZ) and which are zerofield infield (ZI)
    #
                rec_bak=NewSpecs[0]
                tmp=rec_bak["magic_method_codes"].split(":")
                methbak=[]
                for meth in tmp:
                    methbak.append(meth.strip()) # previous steps method codes
                if "LT-NO" not in methbak: # first measurement is not NRM
                    if "LT-T-I" in methbak: IZorZI="LP-PI-TRM-IZ" # first pair is IZ
                    if "LT-T-Z" in methbak: IZorZI="LP-PI-TRM-ZI" # first pair is ZI
                    if IZorZI not in methbak:methbak.append(IZorZI)
                    methcode=""
                    for meth in methbak:
                        methcode=methcode+meth+":"
                    NewSpecs[0]["magic_method_codes"]=methcode[:-1]  # fix first heating step when no NRM
                else: IZorZI="" # first measurement is NRM and not one of a pair
                for k in range(1,len(NewSpecs)): # hunt through measurements again
                    rec=NewSpecs[k]
                    tmp=rec["magic_method_codes"].split(":")
                    meths=[]
                    for meth in tmp:
                        meths.append(meth.strip()) # get this guys method codes
    #
    # check if this start a new temperature step of a infield/zerofield pair
    #
                    if float(rec["treatment_temp"])>float(rec_bak["treatment_temp"]) and "LT-PTRM-I" not in methbak: # new pair?
                        if "LT-T-I" in meths:  # infield of this pair
                                IZorZI="LP-PI-TRM-IZ"
                                IZ=1 # at least one IZ pair
                        elif "LT-T-Z" in meths: #zerofield
                                IZorZI="LP-PI-TRM-ZI"
                                ZI=1 # at least one ZI pair
                    elif float(rec["treatment_temp"])>float(rec_bak["treatment_temp"]) and "LT-PTRM-I" in methbak and IZorZI!="LP-PI-TRM-ZI": # new pair after out of sequence PTRM check?
                        if "LT-T-I" in meths:  # infield of this pair
                                IZorZI="LP-PI-TRM-IZ"
                                IZ=1 # at least one IZ pair
                        elif "LT-T-Z" in meths: #zerofield
                                IZorZI="LP-PI-TRM-ZI"
                                ZI=1 # at least one ZI pair
                    if float(rec["treatment_temp"])==float(rec_bak["treatment_temp"]): # stayed same temp
                        if "LT-T-Z" in meths and "LT-T-I" in methbak and IZorZI=="LP-PI-TRM-ZI":  #must be a tail check
    #
    # replace LT-T-Z method code with LT-PTRM-MD
    #
                            methcodes=""
                            for meth in meths:
                                if meth!="LT-T-Z":methcode=methcode+meth+":"
                            methcodes=methcodes+"LT-PTRM-MD"
                            meths=methcodes.split(":")
                            MD=1
    # fix method codes
                    if "LT-PTRM-I" not in meths and "LT-PTRM-MD" not in meths and IZorZI not in meths:meths.append(IZorZI)
                    newmeths=[]
                    for meth in meths:
                        if meth not in newmeths:newmeths.append(meth)  # try to get uniq set
                    methcode=""
                    for meth in newmeths:
                        methcode=methcode+meth+":"
                    rec["magic_method_codes"]=methcode[:-1]
                    rec_bak=rec # moving on to next record, making current one the backup
                    methbak=rec_bak["magic_method_codes"].split(":") # get last specimen's method codes in a list

    #
    # done with this specimen's records, now  check if any pTRM checks or MD checks
    #
                if pTRM==1:experiment_name=experiment_name+":LP-PI-ALT-PTRM"
                if MD==1:experiment_name=experiment_name+":LP-PI-BT-MD"
                if IZ==1 and ZI==1:experiment_name=experiment_name+":LP-PI-BT-IZZI"
                if IZ==1 and ZI==0:experiment_name=experiment_name+":LP-PI-IZ" # Aitken method
                if IZ==0 and ZI==1:experiment_name=experiment_name+":LP-PI-ZI" # Coe method
                IZ,ZI,pTRM,MD=0,0,0,0  # reset these for next specimen
                for rec in NewSpecs: # fix the experiment name for all recs for this specimen and save in SpecOuts
    # assign an experiment name to all specimen measurements from this specimen
                    if experiment_name!="":
                        rec["magic_method_codes"]=rec["magic_method_codes"]+":"+experiment_name
                    rec["magic_experiment_name"]=spec+":"+experiment_name
                    rec['measurement_number']='%i'%(measnum)  # assign measurement numbers
                    measnum+=1
                    SpecOuts.append(rec)
            elif experiment_name=="LP-PI-TRM:LP-PI-ALT-AFARM": # is a Shaw experiment!
                ARM,TRM=0,0
                for rec in NewSpecs: # fix the experiment name for all recs for this specimen and save in SpecOuts
    # assign an experiment name to all specimen measurements from this specimen
    # make the second ARM in Shaw experiments LT-AF-I-2, stick in the AF of ARM and TRM codes
                    meths=rec["magic_method_codes"].split(":")
                    if ARM==1:
                        if "LT-AF-I" in meths:
                            del meths[meths.index("LT-AF-I")]
                            meths.append("LT-AF-I-2")
                            ARM=2
                        if "LT-AF-Z" in meths and TRM==0 :
                            meths.append("LP-ARM-AFD")
                    if TRM==1 and ARM==1:
                        if "LT-AF-Z" in meths:
                            meths.append("LP-TRM-AFD")
                    if ARM==2:
                        if "LT-AF-Z" in meths:
                            meths.append("LP-ARM2-AFD")
                    newcode=""
                    for meth in meths:
                        newcode=newcode+meth+":"
                    rec["magic_method_codes"]=newcode[:-1]
                    if "LT-AF-I" in meths:ARM=1
                    if "LT-T-I" in meths:TRM=1
                    rec["magic_method_codes"]=rec["magic_method_codes"]+":"+experiment_name
                    rec["magic_experiment_name"]=spec+":"+experiment_name
                    rec['measurement_number']='%i'%(measnum)  # assign measurement numbers
                    measnum+=1
                    SpecOuts.append(rec)
            else:  # not a Thellier-Thellier  or a Shaw experiemnt
                for rec in  NewSpecs:
                    if experiment_name=="":
                        rec["magic_method_codes"]="LT-NO"
                        rec["magic_experiment_name"]=spec+":LT-NO"
                        rec['measurement_number']='%i'%(measnum)  # assign measurement numbers
                        measnum+=1
                    else:
                        if experiment_name not in rec['magic_method_codes']:
                            rec["magic_method_codes"]=rec["magic_method_codes"]+":"+experiment_name
                            rec["magic_method_codes"]=rec["magic_method_codes"].strip(':')
                        rec['measurement_number']='%i'%(measnum)  # assign measurement numbers
                        measnum+=1
                        rec["magic_experiment_name"]=spec+":"+experiment_name
                    rec["magic_software_packages"]=version_num
                    SpecOuts.append(rec)
        else:
            NewSpecs[0]["magic_experiment_name"]=spec+":"+NewSpecs[0]['magic_method_codes'].split(':')[0]
            NewSpecs[0]["magic_software_packages"]=version_num
            SpecOuts.append(NewSpecs[0]) # just copy over the single record as is
    return SpecOuts

def mw_measurements_methods(MagRecs):
# first collect all data for this specimen and do lab treatments
    MD,pMRM,IZ,ZI=0,0,0,0 # these are flags for the lab protocol codes
    expcodes=""
    NewSpecs,SpecMeths=[],[]
    experiment_name=""
    phi,theta="",""
    Dec,Inc="","" # NRM direction
    ZI,IZ,MD,pMRM="","","",""
    k=-1
    POWT_I,POWT_Z=[],[]
    ISteps,ZSteps=[],[]
    k=-1
    for rec in MagRecs:
        k+=1
# ready for pass through, step through specimens, check whether ptrm, ptrm tail checks, or AARM, etc.
#
#
# collect all the experimental data for this specimen
# and look through this specimen's records - try to figure out what experiment it is
#
        meths=rec["magic_method_codes"].split(":")
        powt=int(float(rec["treatment_mw_energy"]))
        for meth in meths:
            if meth not in SpecMeths:SpecMeths.append(meth)  # collect all the methods for this experiment
        if "LT-M-I" in meths: # infield step
            POWT_I.append(powt)
            ISteps.append(k)
            if phi=="": # first one
                phi=float(rec["treatment_dc_field_phi"])
                theta=float(rec["treatment_dc_field_theta"])
        if "LT-M-Z" in meths: # zero field  step
            POWT_Z.append(powt)
            ZSteps.append(k)
            if phi=="": # first one
                Dec=float(rec["measurement_dec"])
                Inc=float(rec["measurement_inc"])
    if "LT-M-I" not in  SpecMeths: # just microwave demag
        experiment_name="LP-DIR-M"
    else: # Microwave infield steps , some sort of LP-PI-M experiment
        experiment_name="LP-PI-M"
        if "LT-PMRM-Z"  in  SpecMeths or "LT-PMRM-I" in SpecMeths: # has pTRM checks
            experiment_name=experiment_name+":LP-PI-ALT-PMRM"
        if Dec!="" and phi!="":
            ang=angle([Dec,Inc],[phi,theta]) # angle between applied field and NRM
            if ang>= 0 and ang< 2: experiment_name=experiment_name+":LP-NRM-PAR"
            if ang> 88 and ang< 92: experiment_name=experiment_name+":LP-NRM-PERP"
            if ang> 178 and ang< 182: experiment_name=experiment_name+":LP-NRM-APAR"
#
# now check whether there are z pairs for all I steps or is this a single heating experiment
#
        noZ=0
        for powt in POWT_I:
            if powt not in POWT_Z:noZ=1 # some I's missing their Z's
        if noZ==1:
            meths = experiment_name.split(":")
            if  "LP-NRM-PERP" in meths: # this is a single  heating experiment
                experiment_name=experiment_name+":LP-PI-M-S"
            else:
                print "Trouble interpreting file - missing zerofield steps? "
                sys.exit()
        else: # this is a double heating experiment
            experiment_name=experiment_name+":LP-PI-M-D"
  # check for IZ or ZI pairs
            for  istep in ISteps: # look for first zerofield step with this power
                rec=MagRecs[istep]
                powt_i=int(float(rec["treatment_mw_energy"]))
                IZorZI,step="",-1
                while IZorZI =="" and step<len(ZSteps)-1:
                    step+=1
                    zstep=ZSteps[step]
                    zrec=MagRecs[zstep]
                    powt_z=int(float(zrec["treatment_mw_energy"]))
                    if powt_i==powt_z:  # found a match
                        if zstep < istep: # zero field first
                            IZorZI="LP-PI-M-ZI"
                            ZI=1 # there is at least one ZI step
                            break
                        else: # in field first
                            IZorZI="LP-PI-M-IZ"
                            IZ=1 # there is at least one ZI step
                            break
                if IZorZI!="":
                    MagRecs[istep]['magic_method_codes']= MagRecs[istep]['magic_method_codes']+':'+IZorZI
                    MagRecs[zstep]['magic_method_codes']= MagRecs[zstep]['magic_method_codes']+':'+IZorZI
            print POWT_Z
            print POWT_I
            for  istep in ISteps: # now look for MD checks (zero field)
              if istep+2<len(MagRecs):  # only if there is another step to consider
                irec=MagRecs[istep]
                powt_i=int(float(irec["treatment_mw_energy"]))
                print istep,powt_i,ZSteps[POWT_Z.index(powt_i)]
                if powt_i in POWT_Z and ZSteps[POWT_Z.index(powt_i)] < istep:  # if there is a previous zero field step at same  power
                    nrec=MagRecs[istep+1] # next step
                    nmeths=nrec['magic_method_codes'].split(":")
                    powt_n=int(float(nrec["treatment_mw_energy"]))
                    if 'LT-M-Z' in nmeths and powt_n==powt_i:  # the step after this infield was a zero field at same energy
                        MD=1  # found a second zero field  match
                        mdmeths=MagRecs[istep+1]['magic_method_codes'].split(":")
                        mdmeths[0]="LT-PMRM-MD" # replace method code with tail check code
                        methods=""
                        for meth in mdmeths:methods=methods+":"+meth
                        MagRecs[istep+1]['magic_method_codes']=methods[1:]
            if MD==1: experiment_name=experiment_name+":LP-PI-BT-MD"
            if IZ==1:
                if ZI==1:
                    experiment_name=experiment_name+":LP-PI-BT-IZZI"
                else:
                    experiment_name=experiment_name+":LP-PI-M-IZ"
            else:
                if ZI==1:
                    experiment_name=experiment_name+":LP-PI-M-ZI"
                else:
                    print "problem in measurements_methods - no ZI or IZ in double heating experiment"
                    sys.exit()
    for rec in MagRecs:
        if 'er_synthetic_name' in rec.keys() and rec['er_synthetic_name']!="":
            rec['magic_experiment_name']=rec['er_synthetic_name']+":"+experiment_name
        else:
            rec['magic_experiment_name']=rec['er_specimen_name']+":"+experiment_name
        rec['magic_method_codes']=rec['magic_method_codes']+":"+experiment_name
    return MagRecs

def parse_site(sample,convention,Z):
    """
    parse the site name from the sample name using the specified convention
    """
    site=sample # default is that site = sample
#
#
# Sample is final letter on site designation eg:  TG001a (used by SIO lab in San Diego)
    if convention=="1":
        return sample[:-1] # peel off terminal character
#
# Site-Sample format eg:  BG94-1  (used by PGL lab in Beijing)
#
    if convention=="2":
        parts=sample.strip('-').split('-')
        return parts[0]
#
# Sample is XXXX.YY where XXX is site and YY is sample
#
    if convention=="3":
        parts=sample.split('.')
        return parts[0]
#
# Sample is XXXXYYY where XXX is site desgnation and YYY is Z long integer
#
    if convention=="4":
       k=int(Z)-1
       return sample[0:-k]  # peel off Z characters from site

    if convention=="5": # sample == site
        return sample

    if convention=="7": # peel off Z characters for site
       k=int(Z)
       return sample[0:k]

    if convention=="8": # peel off Z characters for site
       return ""
    if convention=="9": # peel off Z characters for site
       return sample

    print "Error in site parsing routine"
    sys.exit()
def get_samp_con():
    """
     get sample naming  convention
    """
#
    samp_con,Z="",""
    while samp_con=="":
        samp_con=raw_input("""
        Sample naming convention:
            [1] XXXXY: where XXXX is an arbitrary length site designation and Y
                is the single character sample designation.  e.g., TG001a is the
                first sample from site TG001.  	 [default]
            [2] XXXX-YY: YY sample from site XXXX (XXX, YY of arbitary length)
            [3] XXXX.YY: YY sample from site XXXX (XXX, YY of arbitary length)
            [4-Z] XXXX[YYY]:  YYY is sample designation with Z characters from site XXX
            [5] site name same as sample
            [6] site is entered under a separate column
            [7-Z] [XXXX]YYY:  XXXX is site designation with Z characters with sample name XXXXYYYY
            NB: all others you will have to customize your self
                 or e-mail ltauxe@ucsd.edu for help.
            select one:
""")
    #
        if samp_con=="" or  samp_con =="1":
            samp_con,Z="1",1
        if "4" in samp_con:
            if "-" not in samp_con:
                print "option [4] must be in form 4-Z where Z is an integer"
                samp_con=""
            else:
                Z=samp_con.split("-")[1]
                samp_con="4"
        if "7" in samp_con:
            if "-" not in samp_con:
                print "option [7] must be in form 7-Z where Z is an integer"
                samp_con=""
            else:
                Z=samp_con.split("-")[1]
                samp_con="7"
        if samp_con.isdigit()==False or int(samp_con)>7:
            print "Try again\n "
            samp_con=""
    return samp_con,Z

def get_tilt(dec_geo,inc_geo,dec_tilt,inc_tilt):
#
    """
    Function to return dip and dip direction used to convert geo to tilt coordinates
    """
# strike is horizontal line equidistant from two input directions
    SCart=[0,0,0] # cartesian coordites of Strike
    SCart[2]=0.  # by definition
    GCart=dir2cart([dec_geo,inc_geo,1.]) # cartesian coordites of Geographic D
    TCart=dir2cart([dec_tilt,inc_tilt,1.]) # cartesian coordites of Tilt D
    X=(TCart[1]-GCart[1])/(GCart[0]-TCart[0])
    SCart[1]=numpy.sqrt(1/(X**2+1.))
    SCart[0]=SCart[1]*X
    SDir=cart2dir(SCart)
    DipDir=(SDir[0]-90.)%360.
    DipDir=(SDir[0]+90.)%360.
# D is creat circle distance between geo direction and strike
# theta is GCD between geo and tilt (on unit sphere).  use law of cosines
# to get small cirlce between geo and tilt (dip)
    cosd = GCart[0]*SCart[0]+GCart[1]*SCart[1]  # cosine of angle between two
    d=numpy.arccos(cosd)
    cosTheta=GCart[0]*TCart[0]+GCart[1]*TCart[1]+GCart[2]*TCart[2]
    Dip =(180./numpy.pi)*numpy.arccos(-((cosd**2-cosTheta)/numpy.sin(d)**2))
    if Dip>90:Dip=-Dip
    return DipDir,Dip
#
def get_azpl(cdec,cinc,gdec,ginc):
    """
     gets azimuth and pl from specimen dec inc (cdec,cinc) and gdec,ginc (geographic)  coordinates
    """
    TOL=1e-4
    rad=numpy.pi/180.
    Xp=dir2cart([gdec,ginc,1.])
    X=dir2cart([cdec,cinc,1.])
    # find plunge first
    az,pl,zdif,ang=0.,-90.,1.,360.
    while  zdif>TOL and pl<180.:
        znew=X[0]*numpy.sin(pl*rad)+X[2]*numpy.cos(pl*rad)
        zdif=abs(Xp[2]-znew)
        pl+=.01

    while ang>0.1 and az<360.:
        d,i=dogeo(cdec,cinc,az,pl)
        ang=angle([gdec,ginc],[d,i])
        az+=.01
    return az-.01,pl-.01

def set_priorities(SO_methods,ask):
    """
     figure out which sample_azimuth to use, if multiple orientation methods
    """
    # if ask set to 1, then can change priorities
    SO_defaults=['SO-SUN','SO-GPS-DIFF','SO-SIGHT','SO-SIGHT-BS','SO-CMD-NORTH','SO-MAG','SO-SM','SO-REC','SO-V','SO-CORE','SO-NO']
    SO_priorities,prior_list=[],[]
    if len(SO_methods) >= 1:
        for l in range(len(SO_defaults)):
            if SO_defaults[l] in SO_methods:
                SO_priorities.append(SO_defaults[l])
    pri,change=0,"1"
    if ask==1:
        print  """These methods of sample orientation were found:
      They have been assigned a provisional priority (top = zero, last = highest number) """
        for m in range(len(SO_defaults)):
            if SO_defaults[m] in SO_methods:
                SO_priorities[SO_methods.index(SO_defaults[m])]=pri
                pri+=1
        while change=="1":
            prior_list=SO_priorities
            for m in range(len(SO_methods)):
                print SO_methods[m],SO_priorities[m]
            change=raw_input("Change these?  1/[0] ")
            if change!="1":break
        SO_priorities=[]
        for l in range(len(SO_methods)):
             print SO_methods[l]
             print " Priority?   ",prior_list
             pri=int(raw_input())
             SO_priorities.append(pri)
             del prior_list[prior_list.index(pri)]
    return SO_priorities
#
#
def get_EOL(file):
    """
     find EOL of input file (whether mac,PC or unix format)
    """
    f=open(file,'r')
    firstline=f.read(350)
    EOL=""
    for k in range(350):
        if firstline[k:k+2] == "\r\n":
            print file, ' appears to be a dos file'
            EOL='\r\n'
            break
    if EOL=="":
        for k in range(350):
            if firstline[k] == "\r":
                print file, ' appears to be a mac file'
                EOL='\r'
    if EOL=="":
        print file, " appears to be a  unix file"
        EOL='\n'
    f.close()
    return EOL
#
def sortshaw(s,datablock):
    """
     sorts data block in to ARM1,ARM2 NRM,TRM,ARM1,ARM2=[],[],[],[]
     stick  first zero field stuff into first_Z
    """
    for rec in datablock:
        methcodes=rec["magic_method_codes"].split(":")
        step=float(rec["treatment_ac_field"])
        str=float(rec["measurement_magn_moment"])
        if "LT-NO" in methcodes:
            NRM.append([0,str])
        if "LT-T-I" in methcodes:
            TRM.append([0,str])
            field=float(rec["treatment_dc_field"])
        if "LT-AF-I" in methcodes:
            ARM1.append([0,str])
        if "LT-AF-I-2" in methcodes:
            ARM2.append([0,str])
        if "LT-AF-Z" in methcodes:
            if "LP-ARM-AFD" in methcodes:
                ARM1.append([step,str])
            elif "LP-TRM-AFD" in methcodes:
                TRM.append([step,str])
            elif "LP-ARM2-AFD" in methcodes:
                ARM2.append([step,str])
            else:
                NRM.append([step,str])
    cont=1
    while cont==1:
        if len(NRM)!=len(TRM):
            print "Uneven NRM/TRM steps: "
            NRM,TRM,cont=cleanup(TRM,NRM)
        else:cont=0
    cont=1
    while cont==1:
        if len(ARM1)!=len(ARM2):
            print "Uneven ARM1/ARM2 steps: "
            ARM1,ARM2,cont=cleanup(ARM2,ARM1)
        else:cont=0
#
# final check
#
    if len(NRM)!=len(TRM) or len(ARM1)!=len(ARM2):
               print len(NRM),len(TRM),len(ARM1),len(ARM2)
               print " Something wrong with this specimen! Better fix it or delete it "
               raw_input(" press return to acknowledge message")
# now do the ratio to "fix" NRM/TRM data
# a
    TRM_ADJ=[]
    for kk in range(len(TRM)):
        step=TRM[kk][0]
        for k in range(len(ARM1)):
            if  ARM1[k][0]==step:
                TRM_ADJ.append([step,TRM[kk][1]*ARM1[k][1]/ARM2[k][1]])
                break
    shawblock=(NRM,TRM,ARM1,ARM2,TRM_ADJ)
    return shawblock,field
#
#
def makelist(List):
    """
     makes a colon delimited list from List
    """
    clist=""
    for element in List:
        clist=clist+element+":"
    return clist[:-1]
#
def getvec(gh,lat,long):
#
    """
       evaluates the vector at a given latitude (long=0) for a specified set of coefficients
        Lisa Tauxe 2/26/2007
    """

#
#
    sv=[]
    pad=120-len(gh)
    for x in range(pad):gh.append(0.)
    for x in range(len(gh)):sv.append(0.)
#! convert to colatitude for MB routine
    itype = 1
    colat = 90.-lat
    date,alt=2000.,0. # use a dummy date and altitude
    x,y,z,f=magsyn(gh,sv,date,date,itype,alt,colat,long)
    vec=cart2dir([x,y,z])
    vec[2]=f
    return vec
#
def s_l(l,alpha):
    """
    get sigma as a function of degree l from Constable and Parker (1988)
    """
    a2=alpha**2
    c_a=0.547
    s_l=numpy.sqrt(((c_a**(2.*l))*a2)/((l+1.)*(2.*l+1.)))
    return s_l
#
def mktk03(terms,seed,G2,G3):
    """
    generates a list of gauss coefficients drawn from the TK03.gad distribution
    """
#random.seed(n)
    p=0
    n=seed
    gh=[]
    g10,sfact,afact=-18e3,3.8,2.4
    g20=G2*g10
    g30=G3*g10
    alpha=g10/afact
    s1=s_l(1,alpha)
    s10=sfact*s1
    gnew=random.normal(g10,s10)
    if p==1:print 1,0,gnew,0
    gh.append(gnew)
    gh.append(random.normal(0,s1))
    gnew=gh[-1]
    gh.append(random.normal(0,s1))
    hnew=gh[-1]
    if p==1:print 1,1,gnew,hnew
    for l in range(2,terms+1):
        for m in range(l+1):
            OFF=0.0
            if l==2 and m==0:OFF=g20
            if l==3 and m==0:OFF=g30
            s=s_l(l,alpha)
            j=(l-m)%2
            if j==1:
                s=s*sfact
            gh.append(random.normal(OFF,s))
            gnew=gh[-1]
            if m==0:
                hnew=0
            else:
                gh.append(random.normal(0,s))
                hnew=gh[-1]
            if p==1:print l,m,gnew,hnew
    return gh
#
#
def pinc(lat):
    """
    calculate paleoinclination from latitude
    """
    rad = numpy.pi/180.
    tanl=numpy.tan(lat*rad)
    inc=numpy.arctan(2.*tanl)
    return inc/rad
#
def plat(inc):
    """
    calculate paleolat from inclination
    """
    rad = numpy.pi/180.
    tani=numpy.tan(inc*rad)
    lat=numpy.arctan(tani/2.)
    return lat/rad
#
#
def pseudo(DIs):
    """
     draw a bootstrap sample of Directions
    """
#
    Inds=numpy.random.randint(len(DIs),size=len(DIs))
    D=numpy.array(DIs)
    return D[Inds]
#
def di_boot(DIs):
    """
     returns bootstrap parameters for Directional data
    """
# get average DI for whole dataset
    fpars=fisher_mean(DIs)
#
# now do bootstrap to collect BDIs  bootstrap means
#
    nb,BDIs=5000,[]  # number of bootstraps, list of bootstrap directions
#

    for k in range(nb): # repeat nb times
#        if k%50==0:print k,' out of ',nb
        pDIs= pseudo(DIs) # get a pseudosample
        bfpars=fisher_mean(pDIs) # get bootstrap mean bootstrap sample
        BDIs.append([bfpars['dec'],bfpars['inc']])
    return BDIs

def pseudosample(x):
    """
     draw a bootstrap sample of x
    """
#
    BXs=[]
    for k in range(len(x)):
        ind=random.randint(0,len(x)-1)
        BXs.append(x[ind])
    return BXs

def get_plate_data(plate):
    """
    returns the pole list for a given plate
    """
    if plate=='AF':
       apwp="""
0.0        90.00    0.00
1.0        88.38  182.20
2.0        86.76  182.20
3.0        86.24  177.38
4.0        86.08  176.09
5.0        85.95  175.25
6.0        85.81  174.47
7.0        85.67  173.73
8.0        85.54  173.04
9.0        85.40  172.39
10.0       85.26  171.77
11.0       85.12  171.19
12.0       84.97  170.71
13.0       84.70  170.78
14.0       84.42  170.85
15.0       84.10  170.60
16.0       83.58  169.22
17.0       83.06  168.05
18.0       82.54  167.05
19.0       82.02  166.17
20.0       81.83  166.63
21.0       82.13  169.10
22.0       82.43  171.75
23.0       82.70  174.61
24.0       82.96  177.69
25.0       83.19  180.98
26.0       83.40  184.50
27.0       82.49  192.38
28.0       81.47  198.49
29.0       80.38  203.25
30.0       79.23  207.04
31.0       78.99  206.32
32.0       78.96  204.60
33.0       78.93  202.89
34.0       78.82  201.05
35.0       78.54  198.97
36.0       78.25  196.99
37.0       77.95  195.10
38.0       77.63  193.30
39.0       77.30  191.60
40.0       77.56  192.66
41.0       77.81  193.77
42.0       78.06  194.92
43.0       78.31  196.13
44.0       78.55  197.38
45.0       78.78  198.68
46.0       79.01  200.04
47.0       79.03  201.22
48.0       78.92  202.23
49.0       78.81  203.22
50.0       78.67  204.34
51.0       78.30  206.68
52.0       77.93  208.88
53.0       77.53  210.94
54.0       77.12  212.88
55.0       76.70  214.70
56.0       76.24  216.60
57.0       75.76  218.37
58.0       75.27  220.03
59.0       74.77  221.58
60.0       74.26  223.03
61.0       73.71  225.04
62.0       73.06  228.34
63.0       72.35  231.38
64.0       71.60  234.20
65.0       71.49  234.96
66.0       71.37  235.71
67.0       71.26  236.45
68.0       71.14  237.18
69.0       71.24  236.94
70.0       71.45  236.27
71.0       71.65  235.59
72.0       71.85  234.89
73.0       72.04  234.17
74.0       72.23  233.45
75.0       72.42  232.70
76.0       71.97  236.12
77.0       70.94  241.83
78.0       69.76  246.94
79.0       68.44  251.48
80.0       68.01  252.16
81.0       67.68  252.45
82.0       67.36  252.72
83.0       67.03  252.99
84.0       66.91  252.32
85.0       66.91  251.01
86.0       66.91  249.71
87.0       66.89  248.40
88.0       66.87  247.10
89.0       66.83  245.80
90.0       66.78  244.50
91.0       66.73  243.21
92.0       66.66  243.44
93.0       66.59  244.66
94.0       66.51  245.88
95.0       66.86  247.10
96.0       67.26  248.35
97.0       67.64  249.65
98.0       68.02  250.99
99.0       68.38  252.38
100.0      68.73  253.81
101.0      67.73  253.53
102.0      66.39  252.89
103.0      65.05  252.31
104.0      63.71  251.79
105.0      62.61  252.26
106.0      61.86  254.08
107.0      61.10  255.82
108.0      60.31  257.47
109.0      59.50  259.05
110.0      58.67  260.55
111.0      57.94  261.67
112.0      57.64  261.52
113.0      57.33  261.38
114.0      57.03  261.23
115.0      56.73  261.09
116.0      56.42  260.95
117.0      55.57  260.90
118.0      54.35  260.90
119.0      53.14  260.90
120.0      51.92  260.90
121.0      51.40  260.83
122.0      50.96  260.76
123.0      50.58  260.83
124.0      50.45  261.47
125.0      50.32  262.11
126.0      50.19  262.74
127.0      50.06  263.37
128.0      49.92  264.00
129.0      49.78  264.62
130.0      49.63  265.25
131.0      49.50  265.76
132.0      49.50  265.41
133.0      49.50  265.06
134.0      49.50  264.71
135.0      48.67  264.80
136.0      47.50  265.07
137.0      46.32  265.34
138.0      45.14  265.59
139.0      43.95  265.83
140.0      42.75  265.17
141.0      41.53  264.17
142.0      40.30  263.20
143.0      41.89  262.76
144.0      43.49  262.29
145.0      45.08  261.80
146.0      46.67  261.29
147.0      48.25  260.74
148.0      49.84  260.15
149.0      51.42  259.53
150.0      52.99  258.86
151.0      54.57  258.14
152.0      56.14  257.37
153.0      57.70  256.52
154.0      59.05  255.88
155.0      58.56  257.68
156.0      57.79  258.80
157.0      56.41  258.47
158.0      55.04  258.16
159.0      53.78  257.93
160.0      53.60  258.23
161.0      53.41  258.52
162.0      53.23  258.81
163.0      53.04  259.10
164.0      52.85  259.38
165.0      52.67  259.67
166.0      52.48  259.95
167.0      52.29  260.22
168.0      52.10  260.50
169.0      54.10  259.90
170.0      56.10  259.24
171.0      57.63  259.26
172.0      59.05  259.48
173.0      60.47  259.71
174.0      61.88  259.97
175.0      63.30  260.25
176.0      64.71  260.56
177.0      65.90  261.33
178.0      66.55  263.15
179.0      67.21  263.56
180.0      67.88  262.97
181.0      68.56  262.34
182.0      69.23  261.68
183.0      69.06  261.18
184.0      68.32  260.84
185.0      67.58  260.53
186.0      66.84  260.23
187.0      66.09  259.95
188.0      65.35  259.68
189.0      64.61  259.43
190.0      63.87  259.19
191.0      63.12  258.97
192.0      62.63  258.67
193.0      62.24  258.34
194.0      61.86  258.02
195.0      62.06  256.25
196.0      62.62  253.40
197.0      63.13  250.46
198.0      63.56  247.41
"""
    if plate=='ANT':
       apwp="""
0.0        90.00    0.00
1.0        88.48  178.80
2.0        86.95  178.80
3.0        86.53  172.26
4.0        86.46  169.30
5.0        86.41  166.81
6.0        86.35  164.39
7.0        86.29  162.05
8.0        86.22  159.79
9.0        86.15  157.62
10.0       86.07  155.53
11.0       85.98  153.53
12.0       85.88  151.77
13.0       85.63  151.47
14.0       85.39  151.20
15.0       85.10  150.74
16.0       84.60  149.57
17.0       84.10  148.60
18.0       83.60  147.78
19.0       83.10  147.07
20.0       82.99  146.90
21.0       83.46  147.46
22.0       83.93  148.10
23.0       84.40  148.85
24.0       84.87  149.74
25.0       85.34  150.80
26.0       85.80  152.10
27.0       85.57  166.36
28.0       85.09  178.53
29.0       84.44  188.22
30.0       83.67  195.72
31.0       83.55  194.37
32.0       83.58  191.03
33.0       83.60  187.66
34.0       83.52  184.03
35.0       83.23  180.01
36.0       82.91  176.34
37.0       82.56  172.99
38.0       82.19  169.96
39.0       81.80  167.20
40.0       82.22  166.10
41.0       82.64  164.87
42.0       83.05  163.49
43.0       83.46  161.94
44.0       83.86  160.19
45.0       84.26  158.20
46.0       84.65  155.91
47.0       84.85  155.14
48.0       84.94  155.56
49.0       85.02  156.00
50.0       85.11  156.86
51.0       85.22  161.60
52.0       85.29  166.52
53.0       85.33  171.57
54.0       85.33  176.65
55.0       85.30  181.70
56.0       85.23  187.68
57.0       85.11  193.43
58.0       84.94  198.85
59.0       84.74  203.89
60.0       84.49  208.51
61.0       84.23  214.70
62.0       83.87  224.68
63.0       83.35  233.34
64.0       82.70  240.60
65.0       82.75  243.15
66.0       82.78  245.72
67.0       82.80  248.32
68.0       82.80  250.92
69.0       83.19  251.41
70.0       83.74  250.94
71.0       84.29  250.38
72.0       84.84  249.70
73.0       85.39  248.86
74.0       85.94  247.79
75.0       86.48  246.39
76.0       86.07  261.42
77.0       84.60  277.45
78.0       82.89  286.25
79.0       81.08  291.58
80.0       80.93  293.29
81.0       80.96  294.72
82.0       80.98  296.17
83.0       81.00  297.62
84.0       81.51  298.75
85.0       82.37  299.83
86.0       83.22  301.18
87.0       84.06  302.91
88.0       84.90  305.21
89.0       85.73  308.41
90.0       86.54  313.11
91.0       87.31  320.59
92.0       87.40  334.40
93.0       86.93  346.81
94.0       86.36  355.67
95.0       85.61    7.48
96.0       84.70   16.06
97.0       83.71   22.06
98.0       82.68   26.39
99.0       81.61   29.65
100.0      80.52   32.16
101.0      80.70   31.28
102.0      81.18   29.47
103.0      81.66   27.45
104.0      82.13   25.19
105.0      82.14   22.30
106.0      81.49   19.18
107.0      80.81   16.51
108.0      80.11   14.20
109.0      79.40   12.20
110.0      78.68   10.45
111.0      78.05    9.62
112.0      77.79   11.65
113.0      77.52   13.60
114.0      77.23   15.46
115.0      76.94   17.24
116.0      76.63   18.94
117.0      76.60   18.39
118.0      76.74   16.34
119.0      76.88   14.25
120.0      76.99   12.12
121.0      76.94   12.67
122.0      76.86   13.53
123.0      76.68   14.35
124.0      76.08   15.08
125.0      75.48   15.75
126.0      74.88   16.36
127.0      74.27   16.93
128.0      73.66   17.46
129.0      73.06   17.95
130.0      72.45   18.41
131.0      71.90   18.79
132.0      71.87   18.70
133.0      71.84   18.61
134.0      71.81   18.53
135.0      71.81   15.55
136.0      71.74   11.34
137.0      71.59    7.18
138.0      71.34    3.11
139.0      71.01  359.16
140.0      71.25  355.22
141.0      71.67  351.10
142.0      72.00  346.80
143.0      72.09  352.56
144.0      72.01  358.32
145.0      71.77    3.99
146.0      71.36    9.46
147.0      70.80   14.67
148.0      70.10   19.55
149.0      69.28   24.10
150.0      68.35   28.28
151.0      67.32   32.13
152.0      66.21   35.64
153.0      65.02   38.85
154.0      63.85   41.25
155.0      63.30   38.84
156.0      63.13   36.67
157.0      63.86   34.84
158.0      64.58   32.92
159.0      65.17   31.04
160.0      64.92   30.50
161.0      64.66   29.97
162.0      64.40   29.44
163.0      64.14   28.93
164.0      63.87   28.43
165.0      63.61   27.93
166.0      63.34   27.44
167.0      63.07   26.97
168.0      62.80   26.50
169.0      61.86   30.42
170.0      60.82   34.09
171.0      59.74   36.31
172.0      58.64   38.08
173.0      57.52   39.75
174.0      56.37   41.31
175.0      55.21   42.78
176.0      54.03   44.17
177.0      52.92   45.01
178.0      51.98   44.71
179.0      51.38   45.20
180.0      51.02   46.19
181.0      50.64   47.16
182.0      50.26   48.12
183.0      50.50   48.18
184.0      51.16   47.63
185.0      51.82   47.07
186.0      52.47   46.49
187.0      53.13   45.89
188.0      53.78   45.28
189.0      54.43   44.64
190.0      55.07   43.98
191.0      55.71   43.31
192.0      56.19   42.92
193.0      56.61   42.67
194.0      57.03   42.41
195.0      57.37   43.88
196.0      57.62   46.54
197.0      57.80   49.23
198.0      57.93   51.94
"""
    if plate=='AU':
       apwp="""
0.0        90.00    0.00
1.0        88.81  204.00
2.0        87.62  204.00
3.0        87.50  207.24
4.0        87.58  216.94
5.0        87.58  227.69
6.0        87.51  238.13
7.0        87.35  247.65
8.0        87.14  255.93
9.0        86.87  262.92
10.0       86.56  268.74
11.0       86.22  273.56
12.0       85.87  277.29
13.0       85.52  278.11
14.0       85.18  278.81
15.0       84.87  279.00
16.0       84.71  277.55
17.0       84.54  276.18
18.0       84.37  274.90
19.0       84.20  273.69
20.0       83.80  275.43
21.0       83.01  280.56
22.0       82.18  284.64
23.0       81.31  287.92
24.0       80.42  290.60
25.0       79.52  292.83
26.0       78.60  294.70
27.0       77.32  290.94
28.0       76.00  287.87
29.0       74.65  285.33
30.0       73.28  283.19
31.0       72.98  283.37
32.0       72.95  284.09
33.0       72.92  284.80
34.0       72.92  285.21
35.0       72.97  284.91
36.0       73.03  284.61
37.0       73.09  284.31
38.0       73.14  284.01
39.0       73.20  283.70
40.0       72.83  285.38
41.0       72.45  286.99
42.0       72.06  288.54
43.0       71.65  290.02
44.0       71.24  291.44
45.0       70.81  292.80
46.0       70.38  294.10
47.0       70.08  294.79
48.0       69.88  295.11
49.0       69.68  295.42
50.0       69.46  295.67
51.0       69.01  295.35
52.0       68.55  295.05
53.0       68.10  294.75
54.0       67.65  294.47
55.0       67.20  294.20
56.0       66.69  293.91
57.0       66.18  293.63
58.0       65.68  293.37
59.0       65.17  293.11
60.0       64.66  292.87
61.0       63.96  292.74
62.0       62.84  292.87
63.0       61.72  292.99
64.0       60.60  293.10
65.0       60.35  293.65
66.0       60.09  294.19
67.0       59.84  294.72
68.0       59.58  295.24
69.0       59.76  295.88
70.0       60.14  296.57
71.0       60.51  297.28
72.0       60.88  298.00
73.0       61.24  298.75
74.0       61.60  299.51
75.0       61.96  300.28
76.0       60.92  301.16
77.0       58.95  302.00
78.0       56.98  302.76
79.0       55.00  303.44
80.0       54.72  303.90
81.0       54.63  304.34
82.0       54.53  304.79
83.0       54.44  305.22
84.0       54.82  305.66
85.0       55.51  306.11
86.0       56.20  306.57
87.0       56.89  307.05
88.0       57.58  307.55
89.0       58.26  308.07
90.0       58.95  308.61
91.0       59.63  309.17
92.0       59.80  310.34
93.0       59.62  311.90
94.0       59.42  313.45
95.0       59.46  315.65
96.0       59.50  317.94
97.0       59.49  320.23
98.0       59.44  322.51
99.0       59.36  324.79
100.0      59.23  327.05
101.0      59.10  326.62
102.0      58.98  325.52
103.0      58.84  324.43
104.0      58.69  323.34
105.0      58.29  322.95
106.0      57.53  323.57
107.0      56.75  324.16
108.0      55.98  324.73
109.0      55.20  325.27
110.0      54.42  325.80
111.0      53.81  326.35
112.0      53.88  327.12
113.0      53.94  327.88
114.0      53.99  328.65
115.0      54.04  329.42
116.0      54.08  330.19
117.0      53.91  330.07
118.0      53.59  329.36
119.0      53.26  328.66
120.0      52.93  327.97
121.0      52.97  328.13
122.0      53.04  328.39
123.0      53.03  328.78
124.0      52.70  329.69
125.0      52.35  330.59
126.0      52.00  331.47
127.0      51.65  332.34
128.0      51.29  333.20
129.0      50.92  334.04
130.0      50.54  334.87
131.0      50.18  335.59
132.0      50.01  335.53
133.0      49.83  335.48
134.0      49.65  335.42
135.0      48.86  334.35
136.0      47.78  332.89
137.0      46.68  331.50
138.0      45.57  330.16
139.0      44.44  328.88
140.0      43.86  327.11
141.0      43.50  325.14
142.0      43.10  323.20
143.0      44.00  325.32
144.0      44.85  327.50
145.0      45.66  329.75
146.0      46.43  332.06
147.0      47.15  334.44
148.0      47.81  336.88
149.0      48.43  339.38
150.0      48.99  341.94
151.0      49.49  344.55
152.0      49.93  347.22
153.0      50.31  349.93
154.0      50.48  352.37
155.0      49.32  352.03
156.0      48.45  351.31
157.0      48.28  349.67
158.0      48.09  348.05
159.0      47.87  346.61
160.0      47.53  346.69
161.0      47.19  346.77
162.0      46.84  346.85
163.0      46.50  346.93
164.0      46.16  347.00
165.0      45.82  347.08
166.0      45.48  347.15
167.0      45.14  347.23
168.0      44.80  347.30
169.0      45.48  349.99
170.0      46.09  352.74
171.0      46.20  354.95
172.0      46.16  357.01
173.0      46.09  359.07
174.0      45.98    1.12
175.0      45.83    3.16
176.0      45.65    5.19
177.0      45.27    6.85
178.0      44.51    7.68
179.0      44.31    8.58
180.0      44.50    9.55
181.0      44.67   10.52
182.0      44.84   11.51
183.0      45.02   11.29
184.0      45.22   10.27
185.0      45.42    9.24
186.0      45.60    8.20
187.0      45.77    7.16
188.0      45.93    6.11
189.0      46.09    5.05
190.0      46.23    3.99
191.0      46.36    2.92
192.0      46.52    2.20
193.0      46.68    1.62
194.0      46.84    1.03
195.0      47.67    1.40
196.0      48.95    2.45
197.0      50.22    3.54
198.0      51.48    4.70
"""
    if plate=='EU':
       apwp="""
0.0        90.00    0.00
1.0        88.43  178.70
2.0        86.86  178.70
3.0        86.34  172.60
4.0        86.18  169.84
5.0        86.05  167.60
6.0        85.91  165.51
7.0        85.77  163.55
8.0        85.62  161.73
9.0        85.46  160.03
10.0       85.31  158.44
11.0       85.15  156.95
12.0       84.97  155.67
13.0       84.70  155.37
14.0       84.42  155.10
15.0       84.08  154.59
16.0       83.51  153.18
17.0       82.92  152.01
18.0       82.34  151.01
19.0       81.75  150.16
20.0       81.55  149.86
21.0       81.93  150.29
22.0       82.30  150.76
23.0       82.68  151.28
24.0       83.05  151.85
25.0       83.43  152.49
26.0       83.80  153.20
27.0       83.47  162.05
28.0       83.00  169.89
29.0       82.41  176.64
30.0       81.74  182.37
31.0       81.53  181.04
32.0       81.43  178.14
33.0       81.30  175.32
34.0       81.08  172.47
35.0       80.66  169.55
36.0       80.22  166.89
37.0       79.76  164.46
38.0       79.29  162.23
39.0       78.80  160.20
40.0       79.13  159.12
41.0       79.45  157.97
42.0       79.77  156.75
43.0       80.08  155.46
44.0       80.39  154.08
45.0       80.69  152.62
46.0       80.98  151.05
47.0       81.13  150.65
48.0       81.19  151.08
49.0       81.25  151.51
50.0       81.31  152.21
51.0       81.38  155.38
52.0       81.43  158.60
53.0       81.44  161.83
54.0       81.44  165.08
55.0       81.40  168.30
56.0       81.33  172.18
57.0       81.22  175.97
58.0       81.07  179.66
59.0       80.89  183.21
60.0       80.67  186.61
61.0       80.49  190.87
62.0       80.37  197.35
63.0       80.14  203.60
64.0       79.80  209.50
65.0       79.85  210.35
66.0       79.90  211.20
67.0       79.94  212.07
68.0       79.99  212.94
69.0       80.20  211.11
70.0       80.46  207.98
71.0       80.69  204.68
72.0       80.89  201.23
73.0       81.05  197.65
74.0       81.18  193.94
75.0       81.27  190.14
76.0       81.59  195.53
77.0       81.79  207.82
78.0       81.61  220.13
79.0       81.07  231.45
80.0       81.02  232.09
81.0       81.05  231.62
82.0       81.07  231.16
83.0       81.09  230.69
84.0       81.26  227.31
85.0       81.47  221.76
86.0       81.59  216.00
87.0       81.63  210.12
88.0       81.58  204.25
89.0       81.45  198.51
90.0       81.23  192.99
91.0       80.94  187.78
92.0       81.02  185.31
93.0       81.39  184.44
94.0       81.76  183.50
95.0       82.43  179.95
96.0       83.10  175.40
97.0       83.71  169.92
98.0       84.25  163.35
99.0       84.71  155.53
100.0      85.05  146.45
101.0      84.53  152.65
102.0      83.71  160.59
103.0      82.79  166.60
104.0      81.81  171.23
105.0      81.32  175.20
106.0      81.60  179.66
107.0      81.82  184.38
108.0      81.98  189.32
109.0      82.08  194.43
110.0      82.12  199.63
111.0      82.03  203.00
112.0      81.66  199.22
113.0      81.26  195.76
114.0      80.83  192.62
115.0      80.37  189.76
116.0      79.90  187.17
117.0      79.19  187.67
118.0      78.34  189.84
119.0      77.47  191.71
120.0      76.59  193.35
121.0      76.23  193.12
122.0      75.94  192.71
123.0      75.74  192.46
124.0      75.95  192.77
125.0      76.16  193.09
126.0      76.38  193.42
127.0      76.59  193.76
128.0      76.79  194.12
129.0      77.00  194.48
130.0      77.21  194.85
131.0      77.38  195.04
132.0      77.22  193.47
133.0      77.04  191.93
134.0      76.86  190.44
135.0      76.26  192.29
136.0      75.46  195.27
137.0      74.62  197.94
138.0      73.76  200.34
139.0      72.87  202.49
140.0      71.59  202.74
141.0      70.15  202.29
142.0      68.70  201.90
143.0      69.87  198.07
144.0      70.94  193.81
145.0      71.91  189.09
146.0      72.75  183.89
147.0      73.44  178.23
148.0      73.97  172.14
149.0      74.31  165.73
150.0      74.47  159.11
151.0      74.42  152.44
152.0      74.17  145.90
153.0      73.74  139.63
154.0      73.26  134.46
155.0      73.88  136.15
156.0      74.11  138.70
157.0      73.41  142.81
158.0      72.65  146.58
159.0      71.89  149.70
160.0      71.74  149.67
161.0      71.60  149.65
162.0      71.46  149.63
163.0      71.31  149.61
164.0      71.17  149.58
165.0      71.03  149.56
166.0      70.89  149.54
167.0      70.74  149.52
168.0      70.60  149.50
169.0      70.64  140.48
170.0      70.23  131.62
171.0      69.98  125.23
172.0      69.67  119.51
173.0      69.17  114.01
174.0      68.51  108.79
175.0      67.69  103.90
176.0      66.74   99.36
177.0      66.01   95.57
178.0      66.01   92.81
179.0      65.66   91.06
180.0      65.09   90.02
181.0      64.52   89.02
182.0      63.93   88.07
183.0      63.89   88.62
184.0      64.20   90.17
185.0      64.49   91.77
186.0      64.77   93.39
187.0      65.02   95.05
188.0      65.26   96.73
189.0      65.48   98.45
190.0      65.67  100.19
191.0      65.85  101.96
192.0      65.88  103.25
193.0      65.85  104.31
194.0      65.82  105.38
195.0      64.95  105.43
196.0      63.53  104.86
197.0      62.11  104.35
198.0      60.68  103.89
"""
    if plate=='GL':
       apwp="""
0.0        90.00    0.00
1.0        88.33  180.70
2.0        86.67  180.70
3.0        86.14  175.33
4.0        85.95  173.39
5.0        85.79  171.94
6.0        85.62  170.59
7.0        85.45  169.35
8.0        85.28  168.19
9.0        85.11  167.12
10.0       84.94  166.12
11.0       84.76  165.19
12.0       84.57  164.34
13.0       84.22  163.81
14.0       83.88  163.34
15.0       83.49  162.61
16.0       82.96  160.83
17.0       82.42  159.31
18.0       81.88  157.98
19.0       81.33  156.83
20.0       81.12  156.68
21.0       81.41  157.94
22.0       81.70  159.28
23.0       81.98  160.72
24.0       82.26  162.26
25.0       82.53  163.92
26.0       82.80  165.70
27.0       82.16  172.55
28.0       81.43  178.31
29.0       80.63  183.13
30.0       79.78  187.17
31.0       79.55  186.15
32.0       79.47  183.99
33.0       79.37  181.86
34.0       79.20  179.58
35.0       78.84  176.94
36.0       78.45  174.48
37.0       78.05  172.17
38.0       77.63  170.01
39.0       77.20  168.00
40.0       77.40  168.23
41.0       77.61  168.47
42.0       77.81  168.71
43.0       78.01  168.97
44.0       78.21  169.23
45.0       78.42  169.50
46.0       78.62  169.78
47.0       78.58  170.26
48.0       78.38  170.84
49.0       78.18  171.41
50.0       77.97  172.10
51.0       77.62  174.07
52.0       77.26  175.92
53.0       76.88  177.68
54.0       76.50  179.33
55.0       76.10  180.90
56.0       75.72  182.56
57.0       75.33  184.14
58.0       74.93  185.63
59.0       74.52  187.05
60.0       74.10  188.40
61.0       73.71  190.34
62.0       73.39  193.73
63.0       73.02  196.99
64.0       72.60  200.10
65.0       72.58  200.61
66.0       72.56  201.13
67.0       72.53  201.64
68.0       72.51  202.15
69.0       72.64  201.35
70.0       72.83  199.97
71.0       73.02  198.55
72.0       73.19  197.11
73.0       73.35  195.64
74.0       73.50  194.14
75.0       73.65  192.62
76.0       73.70  196.06
77.0       73.52  202.77
78.0       73.14  209.26
79.0       72.57  215.41
80.0       72.42  216.02
81.0       72.32  216.04
82.0       72.23  216.07
83.0       72.14  216.09
84.0       72.16  214.56
85.0       72.23  211.98
86.0       72.27  209.39
87.0       72.28  206.78
88.0       72.25  204.19
89.0       72.19  201.60
90.0       72.09  199.04
91.0       71.96  196.50
92.0       72.14  195.56
93.0       72.55  195.67
94.0       72.96  195.79
95.0       73.76  195.21
96.0       74.60  194.49
97.0       75.44  193.69
98.0       76.28  192.80
99.0       77.11  191.79
100.0      77.94  190.65
101.0      77.17  190.62
102.0      76.01  190.85
103.0      74.85  191.04
104.0      73.70  191.21
105.0      73.00  192.27
106.0      72.98  194.70
107.0      72.94  197.12
108.0      72.86  199.52
109.0      72.76  201.90
110.0      72.62  204.25
111.0      72.45  205.69
112.0      72.21  203.68
113.0      71.94  201.72
114.0      71.66  199.82
115.0      71.35  197.98
116.0      71.03  196.20
117.0      70.33  195.81
118.0      69.39  196.30
119.0      68.44  196.75
120.0      67.49  197.16
121.0      67.17  196.83
122.0      66.91  196.42
123.0      66.74  196.16
124.0      66.92  196.46
125.0      67.11  196.77
126.0      67.30  197.09
127.0      67.48  197.41
128.0      67.67  197.73
129.0      67.85  198.06
130.0      68.04  198.39
131.0      68.19  198.60
132.0      68.11  197.59
133.0      68.02  196.59
134.0      67.93  195.60
135.0      67.26  196.33
136.0      66.33  197.70
137.0      65.39  198.98
138.0      64.45  200.17
139.0      63.49  201.28
140.0      62.22  201.09
141.0      60.81  200.42
142.0      59.40  199.80
143.0      60.73  197.43
144.0      62.01  194.85
145.0      63.24  192.06
146.0      64.41  189.02
147.0      65.52  185.72
148.0      66.54  182.13
149.0      67.48  178.26
150.0      68.32  174.08
151.0      69.04  169.61
152.0      69.64  164.86
153.0      70.11  159.86
154.0      70.43  155.41
155.0      70.72  157.56
156.0      70.56  159.72
157.0      69.42  161.65
158.0      68.26  163.38
159.0      67.19  164.78
160.0      67.04  164.60
161.0      66.90  164.42
162.0      66.76  164.24
163.0      66.62  164.06
164.0      66.47  163.88
165.0      66.33  163.71
166.0      66.19  163.54
167.0      66.04  163.37
168.0      65.90  163.20
169.0      67.23  156.43
170.0      68.24  148.97
171.0      69.04  143.36
172.0      69.69  138.01
173.0      70.17  132.36
174.0      70.47  126.50
175.0      70.57  120.51
176.0      70.48  114.53
177.0      70.45  109.51
178.0      70.93  106.46
179.0      70.89  104.04
180.0      70.54  102.15
181.0      70.16  100.33
182.0      69.76   98.58
183.0      69.64   99.18
184.0      69.68  101.32
185.0      69.70  103.47
186.0      69.69  105.62
187.0      69.65  107.76
188.0      69.59  109.89
189.0      69.50  112.01
190.0      69.39  114.11
191.0      69.25  116.18
192.0      69.07  117.58
193.0      68.88  118.69
194.0      68.68  119.77
195.0      67.88  118.87
196.0      66.66  116.82
197.0      65.42  114.97
198.0      64.15  113.29
"""
    if plate=='IN':
       apwp="""
0.0        90.00    0.00
1.0        88.57  197.10
2.0        87.14  197.10
3.0        86.82  197.10
4.0        86.76  201.35
5.0        86.70  205.94
6.0        86.62  210.32
7.0        86.52  214.48
8.0        86.40  218.38
9.0        86.26  222.02
10.0       86.11  225.39
11.0       85.95  228.51
12.0       85.77  231.10
13.0       85.46  231.14
14.0       85.15  231.18
15.0       84.84  230.71
16.0       84.54  228.40
17.0       84.23  226.34
18.0       83.92  224.49
19.0       83.59  222.82
20.0       83.40  225.11
21.0       83.32  233.06
22.0       83.11  240.67
23.0       82.79  247.72
24.0       82.37  254.09
25.0       81.87  259.74
26.0       81.30  264.70
27.0       79.78  264.31
28.0       78.25  264.03
29.0       76.73  263.81
30.0       75.20  263.63
31.0       74.95  264.21
32.0       75.01  264.98
33.0       75.06  265.75
34.0       75.09  266.19
35.0       75.05  265.83
36.0       75.02  265.47
37.0       74.98  265.11
38.0       74.94  264.75
39.0       74.90  264.40
40.0       74.38  266.62
41.0       73.83  268.69
42.0       73.26  270.63
43.0       72.68  272.45
44.0       72.09  274.14
45.0       71.48  275.74
46.0       70.85  277.23
47.0       70.10  277.93
48.0       69.27  278.14
49.0       68.45  278.34
50.0       67.56  278.48
51.0       66.19  278.29
52.0       64.82  278.12
53.0       63.45  277.97
54.0       62.07  277.83
55.0       60.70  277.70
56.0       58.96  277.66
57.0       57.23  277.62
58.0       55.49  277.58
59.0       53.75  277.55
60.0       52.02  277.52
61.0       50.04  277.70
62.0       47.49  278.32
63.0       44.95  278.88
64.0       42.40  279.40
65.0       41.10  279.80
66.0       39.80  280.18
67.0       38.50  280.54
68.0       37.19  280.90
69.0       36.48  281.11
70.0       36.03  281.27
71.0       35.58  281.43
72.0       35.13  281.58
73.0       34.68  281.74
74.0       34.23  281.89
75.0       33.78  282.04
76.0       32.33  283.04
77.0       30.21  284.54
78.0       28.07  285.98
79.0       25.92  287.36
80.0       25.05  287.84
81.0       24.33  288.22
82.0       23.61  288.59
83.0       22.89  288.95
84.0       22.55  289.11
85.0       22.46  289.12
86.0       22.37  289.13
87.0       22.29  289.15
88.0       22.20  289.16
89.0       22.11  289.17
90.0       22.02  289.18
91.0       21.94  289.20
92.0       21.59  289.76
93.0       21.07  290.69
94.0       20.55  291.61
95.0       20.43  292.63
96.0       20.34  293.67
97.0       20.24  294.70
98.0       20.14  295.73
99.0       20.04  296.76
100.0      19.92  297.79
101.0      18.99  297.44
102.0      17.86  296.75
103.0      16.72  296.07
104.0      15.58  295.40
105.0      14.47  295.17
106.0      13.41  295.58
107.0      12.35  295.98
108.0      11.28  296.39
109.0      10.22  296.79
110.0       9.15  297.18
111.0       8.25  297.49
112.0       7.98  297.44
113.0       7.71  297.38
114.0       7.44  297.33
115.0       7.18  297.27
116.0       6.91  297.22
117.0       6.09  297.02
118.0       4.90  296.72
119.0       3.71  296.43
120.0       2.52  296.13
121.0       1.90  296.20
122.0       1.34  296.31
123.0       0.80  296.53
124.0       0.32  297.16
125.0      -0.16  297.78
126.0      -0.64  298.41
127.0      -1.12  299.04
128.0      -1.60  299.67
129.0      -2.09  300.30
130.0      -2.57  300.93
131.0      -3.01  301.50
132.0      -3.16  301.53
133.0      -3.31  301.56
134.0      -3.46  301.59
135.0      -4.41  301.48
136.0      -5.71  301.30
137.0      -7.01  301.12
138.0      -8.31  300.94
139.0      -9.61  300.75
140.0     -10.62  299.98
141.0     -11.51  298.94
142.0     -12.40  297.90
143.0     -10.89  298.80
144.0      -9.37  299.69
145.0      -7.85  300.58
146.0      -6.33  301.45
147.0      -4.81  302.32
148.0      -3.29  303.19
149.0      -1.76  304.06
150.0      -0.24  304.92
151.0       1.28  305.78
152.0       2.81  306.65
153.0       4.33  307.52
154.0       5.61  308.38
155.0       4.72  309.22
156.0       3.82  309.62
157.0       2.88  309.03
158.0       1.94  308.43
159.0       1.08  307.93
160.0       0.88  308.24
161.0       0.68  308.55
162.0       0.49  308.85
163.0       0.29  309.16
164.0       0.09  309.47
165.0      -0.11  309.78
166.0      -0.30  310.08
167.0      -0.50  310.39
168.0      -0.70  310.70
169.0       1.16  311.47
170.0       3.03  312.25
171.0       4.29  313.12
172.0       5.40  314.02
173.0       6.51  314.92
174.0       7.62  315.83
175.0       8.72  316.74
176.0       9.83  317.65
177.0      10.65  318.58
178.0      10.83  319.52
179.0      11.31  320.00
180.0      11.98  320.18
181.0      12.66  320.35
182.0      13.33  320.53
183.0      13.28  320.28
184.0      12.74  319.76
185.0      12.21  319.24
186.0      11.67  318.72
187.0      11.13  318.20
188.0      10.59  317.69
189.0      10.05  317.17
190.0       9.51  316.66
191.0       8.96  316.15
192.0       8.62  315.75
193.0       8.36  315.40
194.0       8.10  315.04
195.0       8.76  314.48
196.0      10.03  313.78
197.0      11.30  313.07
198.0      12.56  312.35
"""
    if plate=='NA':
       apwp="""
0.0        90.00    0.00
1.0        88.33  180.70
2.0        86.67  180.70
3.0        86.14  175.33
4.0        85.95  173.39
5.0        85.79  171.94
6.0        85.62  170.59
7.0        85.45  169.35
8.0        85.28  168.19
9.0        85.11  167.12
10.0       84.94  166.12
11.0       84.76  165.19
12.0       84.57  164.34
13.0       84.22  163.81
14.0       83.88  163.34
15.0       83.49  162.61
16.0       82.96  160.83
17.0       82.42  159.31
18.0       81.88  157.98
19.0       81.33  156.83
20.0       81.12  156.68
21.0       81.41  157.94
22.0       81.70  159.28
23.0       81.98  160.72
24.0       82.26  162.26
25.0       82.53  163.92
26.0       82.80  165.70
27.0       82.16  172.55
28.0       81.43  178.31
29.0       80.63  183.13
30.0       79.78  187.17
31.0       79.55  186.15
32.0       79.47  183.99
33.0       79.37  181.86
34.0       79.20  179.56
35.0       78.86  176.88
36.0       78.50  174.36
37.0       78.12  171.99
38.0       77.72  169.78
39.0       77.30  167.70
40.0       77.61  167.72
41.0       77.92  167.75
42.0       78.23  167.77
43.0       78.54  167.80
44.0       78.85  167.83
45.0       79.16  167.86
46.0       79.48  167.89
47.0       79.55  168.32
48.0       79.47  169.01
49.0       79.38  169.70
50.0       79.28  170.59
51.0       79.05  173.39
52.0       78.79  176.08
53.0       78.52  178.64
54.0       78.22  181.08
55.0       77.90  183.40
56.0       77.51  185.86
57.0       77.09  188.16
58.0       76.65  190.32
59.0       76.20  192.35
60.0       75.74  194.24
61.0       75.25  196.69
62.0       74.73  200.49
63.0       74.14  204.02
64.0       73.50  207.30
65.0       73.48  207.86
66.0       73.46  208.42
67.0       73.43  208.98
68.0       73.41  209.53
69.0       73.65  208.66
70.0       74.01  207.12
71.0       74.35  205.51
72.0       74.68  203.84
73.0       75.00  202.09
74.0       75.30  200.27
75.0       75.59  198.38
76.0       75.52  201.87
77.0       75.06  208.70
78.0       74.41  215.06
79.0       73.59  220.85
80.0       73.50  221.21
81.0       73.50  221.00
82.0       73.50  220.79
83.0       73.50  220.58
84.0       73.72  218.91
85.0       74.06  216.16
86.0       74.37  213.31
87.0       74.63  210.35
88.0       74.86  207.30
89.0       75.04  204.16
90.0       75.18  200.96
91.0       75.27  197.71
92.0       75.55  196.67
93.0       75.95  197.15
94.0       76.36  197.65
95.0       77.18  197.76
96.0       78.05  197.83
97.0       78.92  197.91
98.0       79.79  198.01
99.0       80.66  198.13
100.0      81.53  198.27
101.0      80.82  196.53
102.0      79.71  194.75
103.0      78.60  193.30
104.0      77.48  192.12
105.0      76.75  192.71
106.0      76.59  195.69
107.0      76.40  198.60
108.0      76.18  201.42
109.0      75.93  204.14
110.0      75.65  206.77
111.0      75.39  208.27
112.0      75.32  205.66
113.0      75.23  203.07
114.0      75.11  200.52
115.0      74.96  198.02
116.0      74.78  195.56
117.0      74.13  194.52
118.0      73.19  194.41
119.0      72.24  194.30
120.0      71.29  194.21
121.0      70.97  193.62
122.0      70.71  192.99
123.0      70.54  192.59
124.0      70.71  193.06
125.0      70.89  193.53
126.0      71.06  194.01
127.0      71.24  194.50
128.0      71.41  195.00
129.0      71.58  195.51
130.0      71.75  196.03
131.0      71.90  196.38
132.0      71.88  195.14
133.0      71.85  193.90
134.0      71.81  192.67
135.0      71.10  193.14
136.0      70.08  194.23
137.0      69.06  195.23
138.0      68.04  196.14
139.0      67.01  196.96
140.0      65.77  196.26
141.0      64.44  195.02
142.0      63.10  193.90
143.0      64.58  191.66
144.0      66.02  189.16
145.0      67.42  186.37
146.0      68.76  183.24
147.0      70.04  179.71
148.0      71.23  175.75
149.0      72.34  171.28
150.0      73.33  166.27
151.0      74.19  160.69
152.0      74.88  154.55
153.0      75.40  147.91
154.0      75.73  141.88
155.0      76.02  144.73
156.0      75.85  147.65
157.0      74.69  150.19
158.0      73.49  152.38
159.0      72.39  154.07
160.0      72.26  153.82
161.0      72.13  153.57
162.0      71.99  153.32
163.0      71.86  153.07
164.0      71.73  152.83
165.0      71.60  152.59
166.0      71.47  152.36
167.0      71.33  152.13
168.0      71.20  151.90
169.0      72.50  143.28
170.0      73.38  133.55
171.0      74.04  126.09
172.0      74.51  118.88
173.0      74.74  111.36
174.0      74.71  103.74
175.0      74.42   96.27
176.0      73.90   89.17
177.0      73.49   83.36
178.0      73.72   79.48
179.0      73.50   76.79
180.0      72.99   75.03
181.0      72.46   73.37
182.0      71.92   71.80
183.0      71.85   72.55
184.0      72.07   74.85
185.0      72.26   77.20
186.0      72.43   79.60
187.0      72.56   82.04
188.0      72.67   84.51
189.0      72.74   87.01
190.0      72.79   89.52
191.0      72.80   92.04
192.0      72.74   93.81
193.0      72.65   95.23
194.0      72.54   96.64
195.0      71.70   96.06
196.0      70.36   94.36
197.0      69.01   92.87
198.0      67.64   91.56
"""
    if plate=='SA':
       apwp="""
0.0        90.00    0.00
1.0        88.48  176.30
2.0        86.95  176.30
3.0        86.53  168.76
4.0        86.45  164.50
5.0        86.37  160.76
6.0        86.28  157.18
7.0        86.17  153.79
8.0        86.06  150.58
9.0        85.93  147.57
10.0       85.79  144.75
11.0       85.64  142.12
12.0       85.48  139.77
13.0       85.24  138.58
14.0       84.99  137.49
15.0       84.69  136.40
16.0       84.13  135.05
17.0       83.57  133.95
18.0       83.00  133.01
19.0       82.44  132.22
20.0       82.25  131.54
21.0       82.61  130.86
22.0       82.97  130.10
23.0       83.33  129.26
24.0       83.69  128.32
25.0       84.05  127.28
26.0       84.40  126.10
27.0       84.43  135.88
28.0       84.29  145.47
29.0       84.01  154.39
30.0       83.60  162.34
31.0       83.39  160.95
32.0       83.23  157.53
33.0       83.04  154.27
34.0       82.75  151.13
35.0       82.23  148.16
36.0       81.69  145.56
37.0       81.14  143.29
38.0       80.57  141.28
39.0       80.00  139.50
40.0       80.29  138.06
41.0       80.58  136.53
42.0       80.86  134.91
43.0       81.14  133.19
44.0       81.40  131.36
45.0       81.66  129.42
46.0       81.90  127.36
47.0       82.03  126.70
48.0       82.09  127.04
49.0       82.15  127.39
50.0       82.22  128.02
51.0       82.37  131.28
52.0       82.49  134.65
53.0       82.59  138.13
54.0       82.66  141.69
55.0       82.70  145.30
56.0       82.74  149.45
57.0       82.73  153.61
58.0       82.69  157.75
59.0       82.61  161.83
60.0       82.50  165.80
61.0       82.43  170.84
62.0       82.42  178.70
63.0       82.28  186.40
64.0       82.00  193.70
65.0       82.08  194.90
66.0       82.15  196.11
67.0       82.22  197.36
68.0       82.28  198.62
69.0       82.50  196.70
70.0       82.76  193.22
71.0       82.99  189.49
72.0       83.19  185.52
73.0       83.36  181.34
74.0       83.48  176.96
75.0       83.58  172.44
76.0       83.88  180.55
77.0       83.90  198.12
78.0       83.37  214.31
79.0       82.41  227.29
80.0       82.34  228.63
81.0       82.39  228.88
82.0       82.44  229.14
83.0       82.48  229.40
84.0       82.82  226.98
85.0       83.33  222.26
86.0       83.78  216.82
87.0       84.17  210.58
88.0       84.48  203.56
89.0       84.70  195.83
90.0       84.82  187.59
91.0       84.83  179.15
92.0       85.11  176.27
93.0       85.63  177.19
94.0       86.15  178.37
95.0       87.04  175.29
96.0       87.94  168.69
97.0       88.78  152.46
98.0       89.26  101.14
99.0       88.81   47.96
100.0      87.98   31.01
101.0      88.51   36.07
102.0      89.29   63.58
103.0      89.30  145.49
104.0      88.53  174.06
105.0      88.07  189.19
106.0      88.01  213.41
107.0      87.64  233.01
108.0      87.08  246.23
109.0      86.42  254.90
110.0      85.70  260.77
111.0      85.15  264.12
112.0      85.38  263.70
113.0      85.61  263.23
114.0      85.84  262.72
115.0      86.08  262.14
116.0      86.31  261.48
117.0      86.05  255.65
118.0      85.41  248.40
119.0      84.71  242.98
120.0      83.97  238.86
121.0      83.74  236.57
122.0      83.55  234.54
123.0      83.39  233.53
124.0      83.33  236.16
125.0      83.26  238.74
126.0      83.18  241.27
127.0      83.09  243.73
128.0      82.98  246.12
129.0      82.86  248.43
130.0      82.73  250.66
131.0      82.62  252.43
132.0      82.80  250.74
133.0      82.98  248.95
134.0      83.15  247.08
135.0      82.42  244.60
136.0      81.28  242.47
137.0      80.14  240.84
138.0      79.00  239.54
139.0      77.85  238.48
140.0      76.82  234.91
141.0      75.79  230.78
142.0      74.70  227.20
143.0      76.33  226.82
144.0      77.95  226.34
145.0      79.58  225.72
146.0      81.20  224.87
147.0      82.82  223.63
148.0      84.44  221.68
149.0      86.04  218.15
150.0      87.61  209.92
151.0      88.97  176.54
152.0      88.68   89.32
153.0      87.22   67.59
154.0      85.89   60.82
155.0      86.78   50.54
156.0      87.70   41.70
157.0      88.96   60.27
158.0      89.26  158.76
159.0      88.19  190.34
160.0      88.08  197.32
161.0      87.94  203.47
162.0      87.79  208.80
163.0      87.62  213.39
164.0      87.43  217.35
165.0      87.23  220.75
166.0      87.03  223.70
167.0      86.82  226.26
168.0      86.60  228.50
169.0      88.64  230.93
170.0      89.31   38.96
171.0      87.78   36.39
172.0      86.36   34.32
173.0      84.94   33.40
174.0      83.53   32.89
175.0      82.11   32.55
176.0      80.69   32.32
177.0      79.48   31.11
178.0      78.71   27.80
179.0      78.03   27.66
180.0      77.42   29.28
181.0      76.79   30.75
182.0      76.16   32.10
183.0      76.35   32.76
184.0      77.09   33.06
185.0      77.83   33.40
186.0      78.58   33.77
187.0      79.32   34.20
188.0      80.06   34.69
189.0      80.80   35.27
190.0      81.54   35.93
191.0      82.28   36.73
192.0      82.77   37.91
193.0      83.16   39.32
194.0      83.55   40.91
195.0      83.19   47.69
196.0      82.21   55.93
197.0      81.11   62.23
198.0      79.92   67.11
"""
    return apwp
#
def bc02(data):
    """
     get APWP from Besse and Courtillot 2002 paper
    """

    plate,site_lat,site_lon,age=data[0],data[1],data[2],data[3]
    apwp=get_plate_data(plate)
    recs=apwp.split()
    #
    # put it into  usable form in plate_data
    #
    k,plate_data=0,[]
    while k<len(recs)-3:
        rec=[float(recs[k]),float(recs[k+1]),float(recs[k+2])]
        plate_data.append(rec)
        k=k+3

    #
    # find the right pole for the age
    #
    for i in range(len(plate_data)):
        if age >= plate_data[i][0] and age <= plate_data[i+1][0]:
           if (age-plate_data[i][0]) < (plate_data[i][0]-age):
              rec=i
           else:
              rec=i+1
           break
    pole_lat=plate_data[rec][1]
    pole_lon=plate_data[rec][2]
    return pole_lat,pole_lon

def linreg(x,y):
    """
    does a linear regression
    """
    if len(x)!=len(y):
        print 'x and y must be same length'
        sys.exit()
    xx,yy,xsum,ysum,xy,n,sum=0,0,0,0,0,len(x),0
    linpars={}
    for i in range(n):
        xx+=x[i]*x[i]
        yy+=y[i]*y[i]
        xy+=x[i]*y[i]
        xsum+=x[i]
        ysum+=y[i]
        xsig=numpy.sqrt((xx-xsum**2/n)/(n-1.))
        ysig=numpy.sqrt((yy-ysum**2/n)/(n-1.))
    linpars['slope']=(xy-(xsum*ysum/n))/(xx-(xsum**2)/n)
    linpars['b']=(ysum-linpars['slope']*xsum)/n
    linpars['r']=(linpars['slope']*xsig)/ysig
    for i in range(n):
        a=y[i]-linpars['b']-linpars['slope']*x[i]
        sum+=a
    linpars['sigma']=sum/(n-2.)
    linpars['n']=n
    return linpars


def squish(incs,f):
    """
    returns 'flattened' inclination, assuming factor, f and King (1955) formula
    """
    incs=incs*numpy.pi/180. # convert to radians
    tincnew=f*numpy.tan(incs) # multiply tangent by flattening factor
    return numpy.arctan(tincnew)*180./numpy.pi


def get_TS(ts):
    if ts=='ck95':
        TS=[0,0.780,0.990,1.070,1.770,1.950,2.140,2.150,2.581,3.040,3.110,3.220,3.330,3.580,4.180,4.290,4.480,4.620,4.800,4.890,4.980,5.230,5.894,6.137,6.269,6.567,6.935,7.091,7.135,7.170,7.341,7.375,7.432,7.562,7.650,8.072,8.225,8.257,8.699,9.025,9.230,9.308,9.580,9.642,9.740,9.880,9.920,10.949,11.052,11.099,11.476,11.531,11.935,12.078,12.184,12.401,12.678,12.708,12.775,12.819,12.991,13.139,13.302,13.510,13.703,14.076,14.178,14.612,14.800,14.888,15.034,15.155,16.014,16.293,16.327,16.488,16.556,16.726,17.277,17.615,18.281,18.781,19.048,20.131,20.518,20.725,20.996,21.320,21.768,21.859,22.151,22.248,22.459,22.493,22.588,22.750,22.804,23.069,23.353,23.535,23.677,23.800,23.999,24.118,24.730,24.781,24.835,25.183,25.496,25.648,25.823,25.951,25.992,26.554,27.027,27.972,28.283,28.512,28.578,28.745,29.401,29.662,29.765,30.098,30.479,30.939,33.058,33.545,34.655,34.940,35.343,35.526,35.685,36.341,36.618,37.473,37.604,37.848,37.920,38.113,38.426,39.552,39.631,40.130,41.257,41.521,42.536,43.789,46.264,47.906,49.037,49.714,50.778,50.946,51.047,51.743,52.364,52.663,52.757,52.801,52.903,53.347,55.904,56.391,57.554,57.911,60.920,61.276,62.499,63.634,63.976,64.745,65.578,67.610,67.735,68.737,71.071,71.338,71.587,73.004,73.291,73.374,73.619,79.075,83.000]
        Labels=[['C1n',0],['C1r',0.78],['C2',1.77],['C2An',2.581],['C2Ar',3.58],['C3n',4.18],['C3r',5.23],['C3An',5.894],['C3Ar',6.567],['C3Bn',6.935],['C3Br',7.091],['C4n',7.432],['C4r',8.072],['C4An',8.699],['C4Ar',9.025],['C5n',9.74],['C5r',10.949],['C5An',11.935],['C5Ar',12.401],['C5AAn',12.991],['C5AAr',13.139],['C5ABn',13.302],['C5ABr',13.51],['C5ACn',13.703],['C5ACr',14.076],['C5ADn',14.178],['C5ADr',14.612],['C5Bn',14.8],['C5Br',15.155],['C5Cn',16.014],['C5Cr',16.726],['C5Dn',17.277],['C5Dr',17.615],['C5En',18.281],['C5Er',18.781],['C6n',19.048],['C6r',20.131],['C6An',20.518],['C6Ar',21.32],['C6AAn',21.768],['C6AAr',21.859],['C6Bn',22.588],['C6Br',23.069],['C6Cn',23.353],['C6Cr',24.118],['C7n',24.73],['C7r',25.183],['C7A',25.496],['C8n',25.823],['C8r',26.554],['C9n',27.027],['C9r',27.972],['C10n',28.283],['C10r',28.745],['C11n',29.401],['C11r',30.098],['C12n',30.479],['C12r',30.939],['C13n',33.058],['C13r',33.545],['C15n',34.655],['C15r',34.94],['C16n',35.343],['C16r',36.341],['C17n',36.618],['C17r',38.113],['C18n',38.426],['C18r',40.13],['C19n',41.257],['C19r',41.521],['C20n',42.536],['C20r',43.789],['C21n',46.264],['C21r',47.906],['C22n',49.037],['C22r',49.714],['C23n',50.778],['C23r',51.743],['C24n',52.364],['C24r',53.347],['C25n',55.904],['C25r',56.391],['C26n',57.554],['C26r',57.911],['C27n',60.92],['C27r',61.276],['C28n',62.499],['C28r',63.634],['C29n',63.976],['C29r',64.745],['C30n',65.578],['C30r',67.61],['C31n',67.735],['C31r',68.737],['C32n',71.071],['C32r',73.004],['C33n',73.619],['C33r',79.075],['C34n',83]]
        return TS,Labels
    if ts=='gts04':
        TS=[0,0.781,0.988,1.072,1.778,1.945,2.128,2.148,2.581,3.032,3.116,3.207,3.33,3.596,4.187,4.3,4.493,4.631,4.799,4.896,4.997,5.235,6.033,6.252,6.436,6.733,7.14,7.212,7.251,7.285,7.454,7.489,7.528,7.642,7.695,8.108,8.254,8.3,8.769,9.098,9.312,9.409,9.656,9.717,9.779,9.934,9.987,11.04,11.118,11.154,11.554,11.614,12.014,12.116,12.207,12.415,12.73,12.765,12.82,12.878,13.015,13.183,13.369,13.605,13.734,14.095,14.194,14.581,14.784,14.877,15.032,15.16,15.974,16.268,16.303,16.472,16.543,16.721,17.235,17.533,17.717,17.74,18.056,18.524,18.748,20,20.04,20.213,20.439,20.709,21.083,21.159,21.403,21.483,21.659,21.688,21.767,21.936,21.992,22.268,22.564,22.754,22.902,23.03,23.249,23.375,24.044,24.102,24.163,24.556,24.915,25.091,25.295,25.444,25.492,26.154,26.714,27.826,28.186,28.45,28.525,28.715,29.451,29.74,29.853,30.217,30.627,31.116,33.266,33.738,34.782,35.043,35.404,35.567,35.707,36.276,36.512,37.235,37.345,37.549,37.61,37.771,38.032,38.975,39.041,39.464,40.439,40.671,41.59,42.774,45.346,47.235,48.599,49.427,50.73,50.932,51.057,51.901,52.648,53.004,53.116,53.167,53.286,53.808,56.665,57.18,58.379,58.737,61.65,61.983,63.104,64.128,64.432,65.118,65.861,67.696,67.809,68.732,70.961,71.225,71.474,72.929,73.231,73.318,73.577,79.543,84]
        Labels=[['C1n',0.000],['C1r',0.781],['C2',1.778],['C2An',2.581],['C2Ar',3.596],['C3n',4.187],['C3r',5.235],['C3An',6.033],['C3Ar',6.733],['C3Bn',7.140],['C3Br',7.212],['C4n',7.528],['C4r',8.108],['C4An',8.769],['C4Ar',9.098],['C5n',9.779],['C5r',11.040],['C5An',12.014],['C5Ar',12.415],['C5AAn',13.015],['C5AAr',13.183],['C5ABn',13.369],['C5ABr',13.605],['C5ACn',13.734],['C5ACr',14.095],['C5ADn',14.194],['C5ADr',14.581],['C5Bn',14.784],['C5Br',15.160],['C5Cn',15.974],['C5Cr',16.721],['C5Dn',17.235],['C5Dr',17.533],['C5En',18.056],['C5Er',18.524],['C6n',18.748],['C6r',19.772],['C6An',20.040],['C6Ar',20.709],['C6AAn',21.083],['C6AAr',21.159],['C6Bn',21.767],['C6Br',22.268],['C6Cn',22.564],['C6Cr',23.375],['C7n',24.044],['C7r',24.556],['C7A',24.919],['C8n',25.295],['C8r',26.154],['C9n',26.714],['C9r',27.826],['C10n',28.186],['C11n',29.451],['C11r',30.217],['C12n',30.627],['C12r',31.116],['C13n',33.266],['C13r',33.738],['C15n',34.782],['C15r',35.043],['C16n',35.404],['C16r',36.276],['C17n',36.512],['C17r',37.771],['C18n',38.032],['C18r',39.464],['C19n',40.439],['C19r',40.671],['C20n',41.590],['C20r',42.774],['C21n',45.346],['C21r',47.235],['C22n',48.599],['C22r',49.427],['C23n',50.730],['C23r',51.901],['C24n',52.648],['C24r',53.808],['C25n',56.665],['C25r',57.180],['C26n',58.379],['C26r',58.737],['C27n',61.650],['C27r',61.938],['C28n',63.104],['C28r',64.128],['C29n',64.432],['C29r',65.118],['C30n',65.861],['C30r',67.696],['C31n',67.809],['C31r',68.732],['C32n',70.961],['C32r',72.929],['C33n',73.577],['C33r',79.543],['C34n',84.000]]
        return TS,Labels
    if ts=='gts12':
        TS=[0, 0.781, 0.988, 1.072, 1.173, 1.185, 1.778, 1.945, 2.128, 2.148, 2.581, 3.032, 3.116, 3.207, 3.330, 3.596, 4.187, 4.300, 4.493, 4.631, 4.799, 4.896, 4.997, 5.235, 6.033, 6.252, 6.436, 6.733, 7.140, 7.212, 7.251, 7.285, 7.454, 7.489, 7.528, 7.642, 7.695, 8.108, 8.254, 8.300, 8.771, 9.105, 9.311, 9.426, 9.647, 9.721, 9.786, 9.937, 9.984, 11.056, 11.146, 11.188, 11.592, 11.657, 12.049, 12.174, 12.272, 12.474, 12.735, 12.770, 12.829, 12.887, 13.032, 13.183, 13.363, 13.608, 13.739, 14.070, 14.163, 14.609, 14.775, 14.870, 15.032, 15.160, 15.974, 16.268, 16.303, 16.472, 16.543, 16.721, 17.235, 17.533, 17.717, 17.740, 18.056, 18.524, 18.748, 19.722, 20.040, 20.213, 20.439, 20.709, 21.083, 21.159, 21.403, 21.483, 21.659, 21.688, 21.767, 21.936, 21.992, 22.268, 22.564, 22.754, 22.902, 23.030, 23.233, 23.295, 23.962, 24.000, 24.109, 24.474, 24.761, 24.984, 25.099, 25.264, 25.304, 25.987, 26.420, 27.439, 27.859, 28.087, 28.141, 28.278, 29.183, 29.477, 29.527, 29.970, 30.591, 31.034, 33.157, 33.705, 34.999, 35.294, 35.706, 35.892, 36.051, 36.700, 36.969, 37.753, 37.872, 38.093, 38.159, 38.333, 38.615, 39.627, 39.698, 40.145, 41.154, 41.390, 42.301, 43.432, 45.724, 47.349, 48.566, 49.344, 50.628, 50.835, 50.961, 51.833, 52.620, 53.074, 53.199, 53.274, 53.416, 53.983, 57.101, 57.656, 58.959, 59.237, 62.221, 62.517, 63.494, 64.667, 64.958, 65.688, 66.398, 68.196, 68.369, 69.269, 71.449, 71.689, 71.939, 73.649, 73.949, 74.049, 74.309, 79.900, 83.64]
        Labels=[['C1n',0.000],['C1r',0.781],['C2',1.778],['C2An',2.581],['C2Ar',3.596],['C3n',4.187],['C3r',5.235],['C3An',6.033],['C3Ar',6.733],['C3Bn',7.140],['C3Br',7.212],['C4n',7.528],['C4r',8.108],['C4An',8.771],['C4Ar',9.105],['C5n',9.786],['C5r',11.056],['C5An',12.049],['C5Ar',12.474],['C5AAn',13.032],['C5AAr',13.183],['C5ABn',13.363],['C5ABr',13.608],['C5ACn',13.739],['C5ACr',14.070],['C5ADn',14.163],['C5ADr',14.609],['C5Bn',14.775],['C5Br',15.160],['C5Cn',15.974],['C5Cr',16.721],['C5Dn',17.235],['C5Dr',17.533],['C5En',18.056],['C5Er',18.524],['C6n',18.748],['C6r',19.722],['C6An',20.040],['C6Ar',20.709],['C6AAn',21.083],['C6AAr',21.159],['C6Bn',21.767],['C6Br',22.268],['C6Cn',22.564],['C6Cr',23.295],['C7n',23.962],['C7r',24.474],['C7An',24.761],['C7Ar',24.984],['C8n',25.099],['C8r',25.987],['C9n',26.420],['C9r',27.439],['C10n',27.859],['C10r',28.278],['C11n',29.183],['C11r',29.970],['C12n',30.591],['C12r',31.034],['C13n',33.157],['C13r',33.705],['C15n',34.999],['C15r',35.294],['C16n',35.706],['C16r',36.700],['C17n',36.969],['C17r',38.333],['C18n',38.615],['C18r',40.145],['C19n',41.154],['C19r',41.390],['C20n',42.301],['C20r',43.432],['C21n',45.724],['C21r',47.349],['C22n',48.566],['C22r',49.344],['C23n',50.628],['C23r',51.833],['C24n',52.620],['C24r',53.983],['C25n',57.101],['C25r',57.656],['C26n',58.959],['C26r',59.237],['C27n',62.221],['C27r',62.517],['C28n',63.494],['C28r',64.667],['C29n',64.958],['C29r',65.688],['C30n',66.398],['C30r',68.196],['C31n',68.369],['C31r',69.269],['C32n',71.449],['C32r',73.649],['C33n',74.309],['C33r',79.900],['C34n',83.64]]
        return TS,Labels
    print "Time Scale Option Not Available"
    sys.exit()

def initialize_acceptance_criteria ():
    '''
    initialize acceptance criteria with NULL values for thellier_gui and demag_gui

    acceptancec criteria format is doctionaries:

    acceptance_criteria={}
        acceptance_criteria[crit]={}
            acceptance_criteria[crit]['category']=
            acceptance_criteria[crit]['criterion_name']=
            acceptance_criteria[crit]['value']=
            acceptance_criteria[crit]['threshold_type']
            acceptance_criteria[crit]['decimal_points']

   'category':
       'DE-SPEC','DE-SAMP'..etc
   'criterion_name':
       MagIC name
   'value':
        a number (for 'regular criteria')
        a string (for 'flag')
        1 for True (if criteria is bullean)
        0 for False (if criteria is bullean)
        -999 means N/A
   'threshold_type':
       'low'for low threshold value
       'high'for high threshold value
        [flag1.flag2]: for flags
        'bool' for bollean flags (can be 'g','b' or True/Flase or 1/0)
   'decimal_points':
       number of decimal points in rounding
       (this is used in displaying criteria in the dialog box)
       -999 means Exponent with 3 descimal points for floats and string for string
    '''

    acceptance_criteria={}
    # --------------------------------
    # 'DE-SPEC'
    # --------------------------------

    # low cutoff value
    category='DE-SPEC'
    for crit in ['specimen_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    category='DE-SPEC'
    for crit in ['specimen_mad','specimen_dang','specimen_alpha95']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        acceptance_criteria[crit]['decimal_points']=1

    # flag
    for crit in ['specimen_direction_type']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        if crit=='specimen_direction_type':
            acceptance_criteria[crit]['threshold_type']=['l','p']
        if crit=='specimen_polarity':
            acceptance_criteria[crit]['threshold_type']=['n','r','t','e','i']
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'DE-SAMP'
    # --------------------------------

    # low cutoff value
    category='DE-SAMP'
    for crit in ['sample_n','sample_n_lines','sample_n_planes']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    category='DE-SAMP'
    for crit in ['sample_r','sample_alpha95','sample_sigma','sample_k','sample_tilt_correction']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['sample_tilt_correction']:
            acceptance_criteria[crit]['decimal_points']=0
        elif crit in ['sample_alpha95']:
            acceptance_criteria[crit]['decimal_points']=1
        else:
            acceptance_criteria[crit]['decimal_points']=-999

    # flag
    for crit in ['sample_direction_type','sample_polarity']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        if crit=='sample_direction_type':
            acceptance_criteria[crit]['threshold_type']=['l','p']
        if crit=='sample_polarity':
            acceptance_criteria[crit]['threshold_type']=['n','r','t','e','i']
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'DE-SITE'
    # --------------------------------

    # low cutoff value
    category='DE-SITE'
    for crit in ['site_n','site_n_lines','site_n_planes']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['site_k','site_r','site_alpha95','site_sigma','site_tilt_correction']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['site_tilt_correction']:
            acceptance_criteria[crit]['decimal_points']=0
        else:
            acceptance_criteria[crit]['decimal_points']=1

    # flag
    for crit in ['site_direction_type','site_polarity']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        if crit=='site_direction_type':
            acceptance_criteria[crit]['threshold_type']=['l','p']
        if crit=='site_polarity':
            acceptance_criteria[crit]['threshold_type']=['n','r','t','e','i']
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'DE-STUDY'
    # --------------------------------
    category='DE-STUDY'
    # low cutoff value
    for crit in ['average_k','average_n','average_nn','average_nnn','average_r']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        if crit in ['average_n','average_nn','average_nnn']:
            acceptance_criteria[crit]['decimal_points']=0
        elif crit in ['average_alpha95']:
            acceptance_criteria[crit]['decimal_points']=1
        else:
            acceptance_criteria[crit]['decimal_points']=-999

    # high cutoff value
    for crit in ['average_alpha95','average_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['average_alpha95']:
            acceptance_criteria[crit]['decimal_points']=1
        else :
            acceptance_criteria[crit]['decimal_points']=-999


    # --------------------------------
    # 'IE-SPEC' (a long list from SPD.v.1.0)
    # --------------------------------
    category='IE-SPEC'

    # low cutoff value
    for crit in ['specimen_int_n','specimen_f','specimen_fvds','specimen_frac','specimen_q','specimen_w','specimen_r_sq','specimen_int_ptrm_n',\
    'specimen_int_ptrm_tail_n','specimen_ac_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0
        if crit in ['specimen_int_n','specimen_int_ptrm_n','specimen_int_ptrm_tail_n','specimen_ac_n']:
            acceptance_criteria[crit]['decimal_points']=0
        elif crit in ['specimen_f','specimen_fvds','specimen_frac','specimen_q']:
            acceptance_criteria[crit]['decimal_points']=2
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # high cutoff value
    for crit in ['specimen_b_sigma','specimen_b_beta','specimen_g','specimen_gmax','specimen_k','specimen_k_sse','specimen_k_prime','specimen_k_prime_sse',\
    'specimen_coeff_det_sq','specimen_z','specimen_z_md','specimen_int_mad','specimen_int_mad_anc','specimen_int_alpha','specimen_alpha','specimen_alpha_prime',\
    'specimen_theta','specimen_int_dang','specimen_int_crm','specimen_ptrm','specimen_dck','specimen_drat','specimen_maxdev','specimen_cdrat',\
    'specimen_drats','specimen_mdrat','specimen_mdev','specimen_dpal','specimen_tail_drat','specimen_dtr','specimen_md','specimen_dt','specimen_dac','specimen_gamma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['specimen_int_mad','specimen_int_mad_anc','specimen_int_dang','specimen_drat','specimen_cdrat','specimen_drats','specimen_tail_drat','specimen_dtr','specimen_md','specimen_dac','specimen_gamma']:
            acceptance_criteria[crit]['decimal_points']=1
        elif crit in ['specimen_gmax']:
            acceptance_criteria[crit]['decimal_points']=2
        elif crit in ['specimen_b_sigma','specimen_b_beta','specimen_g','specimen_k', 'specimen_k_prime']:
            acceptance_criteria[crit]['decimal_points']=3
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # flags
    for crit in ['specimen_scat']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']='bool'
        acceptance_criteria[crit]['decimal_points']=-999


    # --------------------------------
    # 'IE-SAMP'
    # --------------------------------
    category='IE-SAMP'

    # low cutoff value
    for crit in ['sample_int_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['sample_int_rel_sigma','sample_int_rel_sigma_perc','sample_int_sigma','sample_int_sigma_perc']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['sample_int_rel_sigma_perc','sample_int_sigma_perc']:
            acceptance_criteria[crit]['decimal_points']=1
        else :
            acceptance_criteria[crit]['decimal_points']=-999


    # --------------------------------
    # 'IE-SITE'
    # --------------------------------
    category='IE-SITE'

    # low cutoff value
    for crit in ['site_int_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['site_int_rel_sigma','site_int_rel_sigma_perc','site_int_sigma','site_int_sigma_perc']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['site_int_rel_sigma_perc','site_int_sigma_perc']:
            acceptance_criteria[crit]['decimal_points']=1
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'IE-STUDY'
    # --------------------------------
    category='IE-STUDY'
    # low cutoff value
    for crit in ['average_int_n','average_int_n','average_int_nn','average_int_nnn',]:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['average_int_rel_sigma','average_int_rel_sigma_perc','average_int_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        if crit in ['average_int_rel_sigma_perc']:
            acceptance_criteria[crit]['decimal_points']=1
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'NPOLE'
    # --------------------------------
    category='NPOLE'
    # flags
    for crit in ['site_polarity']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']=['n','r']
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'NPOLE'
    # --------------------------------
    category='RPOLE'
    # flags
    for crit in ['site_polarity']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']=['n','r']
        acceptance_criteria[crit]['decimal_points']=-999


    # --------------------------------
    # 'VADM'
    # --------------------------------
    category='VADM'
    # low cutoff value
    for crit in ['vadm_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        if crit in ['vadm_n']:
            acceptance_criteria[crit]['decimal_points']=0
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'VADM'
    # --------------------------------
    category='VADM'
    # low cutoff value
    for crit in ['vadm_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['vadm_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'VADM'
    # --------------------------------
    category='VDM'
    # low cutoff value
    for crit in ['vdm_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['vdm_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'VGP'
    # --------------------------------
    category='VDM'
    # low cutoff value
    for crit in ['vgp_n']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=0

    # high cutoff value
    for crit in ['vgp_alpha95','vgp_dm','vgp_dp','vgp_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        if crit in ['vgp_alpha95']:
            acceptance_criteria[crit]['decimal_points','vgp_dm','vgp_dp']=1
        else :
            acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'AGE'
    # --------------------------------
    category='AGE'
    # low cutoff value
    for crit in ['average_age_min']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="low"
        acceptance_criteria[crit]['decimal_points']=-999

    # high cutoff value
    for crit in ['average_age_max','average_age_sigma']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        acceptance_criteria[crit]['decimal_points']=-999

    # flags
    for crit in ['average_age_unit']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']=['Ga','Ka','Ma','Years AD (+/-)','Years BP','Years Cal AD (+/-)','Years Cal BP']
        acceptance_criteria[crit]['decimal_points']=-999

    # --------------------------------
    # 'ANI'
    # --------------------------------
    category='ANI'
    # high cutoff value
    for crit in ['anisotropy_alt','sample_aniso_mean','site_aniso_mean']: # value is in precent
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']="high"
        acceptance_criteria[crit]['decimal_points']=3

    # flags
    for crit in ['anisotropy_ftest_flag']:
        acceptance_criteria[crit]={}
        acceptance_criteria[crit]['category']=category
        acceptance_criteria[crit]['criterion_name']=crit
        acceptance_criteria[crit]['value']=-999
        acceptance_criteria[crit]['threshold_type']='bool'
        acceptance_criteria[crit]['decimal_points']=-999


    return(acceptance_criteria)



def read_criteria_from_file(path,acceptance_criteria):
    '''
    Read accceptance criteria from magic pmag_criteria file
    # old format:
    multiple lines.  pmag_criteria_code defines the type of criteria

    to deal with old format this function reads all the lines and ignore empty cells.
    i.e., the program assumes that in each column there is only one value (in one of the lines)

    special case in the old format:
        specimen_dang has a value and pmag_criteria_code is IE-specimen.
        The program assumes that the user means specimen_int_dang
    # New format for thellier_gui and demag_gui:
    one long line. pmag_criteria_code=ACCEPT

    path is the full path to the criteria file

    the fucntion takes exiting acceptance_criteria
    and updtate it with criteria from file

    output:
    acceptance_criteria={}
    acceptance_criteria[MagIC Variable Names]={}
    acceptance_criteria[MagIC Variable Names]['value']:
        a number for acceptance criteria value
        -999 for N/A
        1/0 for True/False or Good/Bad
    acceptance_criteria[MagIC Variable Names]['threshold_type']:
        "low":  lower cutoff value i.e. crit>=value pass criteria
        "high": high cutoff value i.e. crit<=value pass criteria
        [string1,string2,....]: for flags
    acceptance_criteria[MagIC Variable Names]['decimal_points']:number of decimal points in rounding
            (this is used in displaying criteria in the dialog box)

    '''
    acceptance_criteria_list=acceptance_criteria.keys()
    meas_data,file_type=magic_read(path)
    for rec in meas_data:
        for crit in rec.keys():
            rec[crit]=rec[crit].strip('\n')
            if crit in ['pmag_criteria_code','criteria_definition','magic_experiment_names','er_citation_names']:
                continue
            elif rec[crit]=="":
                continue
            if crit=="specimen_dang" and "pmag_criteria_code" in rec.keys() and "IE-SPEC" in rec["pmag_criteria_code"]:
                crit="specimen_int_dang"
                print "-W- Found backward compatibility problem with selection criteria specimen_dang. Cannot be associated with IE-SPEC. Program assumes that the statistic is specimen_int_dang"
                acceptance_criteria["specimen_int_dang"]['value']=float(rec["specimen_dang"])
            elif crit not in acceptance_criteria_list:
                print "-W- WARNING: criteria code %s is not supported by PmagPy GUI. please check"%crit
                acceptance_criteria[crit]={}
                acceptance_criteria[crit]['value']=rec[crit]
                acceptance_criteria[crit]['threshold_type']="inherited"
                acceptance_criteria[crit]['decimal_points']=-999
                # LJ add:
                acceptance_criteria[crit]['category'] = None

            # bollean flag
            elif acceptance_criteria[crit]['threshold_type']=='bool':
                if str(rec[crit]) in ['1','g','True','TRUE']:
                    acceptance_criteria[crit]['value']=True
                else:
                    acceptance_criteria[crit]['value']=False

            # criteria as flags
            elif type(acceptance_criteria[crit]['threshold_type'])==list:
                if str(rec[crit]) in acceptance_criteria[crit]['threshold_type']:
                    acceptance_criteria[crit]['value']=str(rec[crit])
                else:
                    print "-W- WARNING: data %s from criteria code  %s and is not supported by PmagPy GUI. please check"%(crit,rec[crit])
            elif float(rec[crit]) == -999:
                continue
            else:
                acceptance_criteria[crit]['value']=float(rec[crit])
    return(acceptance_criteria)

def write_criteria_to_file(path,acceptance_criteria):
    crit_list=acceptance_criteria.keys()
    crit_list.sort()
    rec={}
    rec['pmag_criteria_code']="ACCEPT"
    rec['criteria_definition']="acceptance criteria for study"
    rec['er_citation_names']="This study"

    for crit in crit_list:
        # ignore criteria that are not in MagIc model 2.5
        if 'category' in acceptance_criteria[crit].keys():
            if acceptance_criteria[crit]['category']=='thellier_gui':
                continue

        # fix True/False typoes
        if type(acceptance_criteria[crit]['value'])==str:
            if acceptance_criteria[crit]['value']=="TRUE":
                 acceptance_criteria[crit]['value']="True"
            if acceptance_criteria[crit]['value']=="FALSE":
                 acceptance_criteria[crit]['value']="False"

        if type(acceptance_criteria[crit]['value'])==str:
            if acceptance_criteria[crit]['value'] != "-999" and acceptance_criteria[crit]['value'] != "":

                rec[crit]=acceptance_criteria[crit]['value']
        elif type(acceptance_criteria[crit]['value'])==int:
            if acceptance_criteria[crit]['value'] !=-999:
                rec[crit]="%.i"%(acceptance_criteria[crit]['value'])
        elif type(acceptance_criteria[crit]['value'])==float:
            if float(acceptance_criteria[crit]['value'])==-999:
                continue
            decimal_points=acceptance_criteria[crit]['decimal_points']
            if decimal_points != -999:
                command="rec[crit]='%%.%sf'%%(acceptance_criteria[crit]['value'])"%(decimal_points)
                exec command
            else:
                rec[crit]="%e"%(acceptance_criteria[crit]['value'])
        elif type(acceptance_criteria[crit]['value'])==bool:
                rec[crit]=str(acceptance_criteria[crit]['value'])
        else:
            print "-W- WARNING: statistic %s not written to file:",acceptance_criteria[crit]['value']
    magic_write(path,[rec],"pmag_criteria")



def add_flag(var, flag):
    """
    for use when calling command-line scripts from withing a program.
    if a variable is present, add its proper command_line flag.
    return a string.
    """
    if var:
        var = flag + " " + str(var)
    else:
        var = ""
    return var


def get_named_arg_from_sys(name, default_val=None, reqd=False):
    """
    Extract the value after a command-line flag such as '-f' and return it.
    If the command-line flag is missing, return default_val.
    If reqd == True and the command-line flag is missing, throw an error.
    """
    if name in sys.argv: # if the command line flag is found in sys.argv
        ind = sys.argv.index(name)
        return sys.argv[ind+1]
    if reqd: # if arg is required but not present
        raise MissingCommandLineArgException(name)
    return default_val # if arg is not provided but has a default value, return that value

def get_flag_arg_from_sys(name):
    if name in sys.argv:
        return True
    else:
        return False


def merge_recs_headers(recs):
    '''
    take a list of recs [rec1,rec2,rec3....], each rec is a dictionary.
    make sure that all recs have the same headers.
    '''
    headers=[]
    for rec in recs:
        keys=rec.keys()
        for key in keys:
            if key not in headers:
                    headers.append(key)
    for rec in recs:
        for header in headers:
            if header not in rec.keys():
                rec[header]=""
    return recs


def remove_files(file_list, WD='.'):
    for f in file_list:
        full_file = os.path.join(WD, f)
        if os.path.isfile(full_file):
            os.remove(full_file)

def get_attr(obj, attr='name'):
    try:
        name = obj.__getattribute__(attr)
    except AttributeError:
        name = str(obj)
    return name

def adjust_to_360(val, key):
    """
    Take in a value and a key.  If the key is of the type:
    declination/longitude/azimuth/direction, adjust it to be within
    the range 0-360 as required by the MagIC data model
    """
    CheckDec = ['_dec', '_lon', '_azimuth', 'dip_direction']
    adjust = False
    for dec_key in CheckDec:
        if dec_key in key:
            if key.endswith(dec_key) or key.endswith('_'):
                adjust = True
    if not val:
        return ''
    elif not adjust:
        return val
    elif adjust:
        new_val = float(val) % 360
        if new_val != float(val):
            print '-I- adjusted {} {} to 0=>360.: {}'.format(key, val, new_val)
        return new_val


def adjust_all_to_360(dictionary):
    """
    Take a dictionary and check each key/value pair.
    If this key is of type: declination/longitude/azimuth/direction,
    adjust it to be within 0-360 as required by the MagIC data model
    """
    for key in dictionary:
        dictionary[key] = adjust_to_360(dictionary[key], key)
    return dictionary

class MissingCommandLineArgException(Exception):

    def __init__(self, message):
        self.message = "{} is a required option! Please provide this information and try again".format(message)

    def __str__(self):
        return self.message
